"use strict";/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ie=["require","exports","vs/editor/common/core/range","vs/base/common/errors","vs/editor/common/core/offsetRange","vs/editor/common/core/position","vs/base/common/arrays","vs/base/common/strings","vs/editor/common/diff/defaultLinesDiffComputer/algorithms/diffAlgorithm","vs/base/common/arraysFind","vs/base/common/lifecycle","vs/base/common/event","vs/editor/common/core/lineRange","vs/base/common/assert","vs/base/common/platform","vs/base/common/objects","vs/base/common/uri","vs/editor/common/diff/defaultLinesDiffComputer/utils","vs/editor/common/diff/rangeMapping","vs/base/common/functional","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/map","vs/base/common/stopwatch","vs/base/common/cancellation","vs/base/common/diff/diff","vs/base/common/types","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/diff/defaultLinesDiffComputer/algorithms/myersDiffAlgorithm","vs/editor/common/diff/defaultLinesDiffComputer/linesSliceCharSequence","vs/editor/common/diff/linesDiffComputer","vs/editor/common/diff/legacyLinesDiffComputer","vs/base/common/collections","vs/base/common/color","vs/base/common/diff/diffChange","vs/base/common/keyCodes","vs/base/common/lazy","vs/base/common/process","vs/base/common/path","vs/base/common/cache","vs/base/common/hash","vs/base/common/codicons","vs/editor/common/core/editOperation","vs/editor/common/core/selection","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/diff/defaultLinesDiffComputer/heuristicSequenceOptimizations","vs/editor/common/diff/defaultLinesDiffComputer/lineSequence","vs/editor/common/diff/defaultLinesDiffComputer/algorithms/dynamicProgrammingDiffing","vs/editor/common/diff/defaultLinesDiffComputer/computeMovedLines","vs/editor/common/diff/defaultLinesDiffComputer/defaultLinesDiffComputer","vs/editor/common/diff/linesDiffComputers","vs/editor/common/languages/defaultDocumentColorsComputer","vs/editor/common/languages/linkComputer","vs/editor/common/languages/supports/inplaceReplaceSupport","vs/editor/common/model","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/services/unicodeTextModelHighlighter","vs/editor/common/standalone/standaloneEnums","vs/editor/common/tokenizationRegistry","vs/nls!vs/editor/common/languages","vs/editor/common/languages","vs/editor/common/services/editorBaseApi","vs/css","vs/base/common/worker/simpleWorker","vs/nls","vs/nls!vs/editor/common/services/editorSimpleWorker","vs/editor/common/services/editorSimpleWorker"],se=function(O){for(var t=[],k=0,D=O.length;k<D;k++)t[k]=ie[O[k]];return t};const We=this,Ce=typeof global=="object"?global:{};var he;(function(O){O.global=We;class t{get isWindows(){return this._detect(),this._isWindows}get isNode(){return this._detect(),this._isNode}get isElectronRenderer(){return this._detect(),this._isElectronRenderer}get isWebWorker(){return this._detect(),this._isWebWorker}get isElectronNodeIntegrationWebWorker(){return this._detect(),this._isElectronNodeIntegrationWebWorker}constructor(){this._detected=!1,this._isWindows=!1,this._isNode=!1,this._isElectronRenderer=!1,this._isWebWorker=!1,this._isElectronNodeIntegrationWebWorker=!1}_detect(){this._detected||(this._detected=!0,this._isWindows=t._isWindows(),this._isNode=typeof module<"u"&&!!module.exports,this._isElectronRenderer=typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="renderer",this._isWebWorker=typeof O.global.importScripts=="function",this._isElectronNodeIntegrationWebWorker=this._isWebWorker&&typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="worker")}static _isWindows(){return typeof navigator<"u"&&navigator.userAgent&&navigator.userAgent.indexOf("Windows")>=0?!0:typeof process<"u"?process.platform==="win32":!1}}O.Environment=t})(he||(he={}));var he;(function(O){class t{constructor(f,N,h){this.type=f,this.detail=N,this.timestamp=h}}O.LoaderEvent=t;class k{constructor(f){this._events=[new t(1,"",f)]}record(f,N){this._events.push(new t(f,N,O.Utilities.getHighPerformanceTimestamp()))}getEvents(){return this._events}}O.LoaderEventRecorder=k;class D{record(f,N){}getEvents(){return[]}}D.INSTANCE=new D,O.NullLoaderEventRecorder=D})(he||(he={}));var he;(function(O){class t{static fileUriToFilePath(D,r){if(r=decodeURI(r).replace(/%23/g,"#"),D){if(/^file:\/\/\//.test(r))return r.substr(8);if(/^file:\/\//.test(r))return r.substr(5)}else if(/^file:\/\//.test(r))return r.substr(7);return r}static startsWith(D,r){return D.length>=r.length&&D.substr(0,r.length)===r}static endsWith(D,r){return D.length>=r.length&&D.substr(D.length-r.length)===r}static containsQueryString(D){return/^[^\#]*\?/gi.test(D)}static isAbsolutePath(D){return/^((http:\/\/)|(https:\/\/)|(file:\/\/)|(\/))/.test(D)}static forEachProperty(D,r){if(D){let f;for(f in D)D.hasOwnProperty(f)&&r(f,D[f])}}static isEmpty(D){let r=!0;return t.forEachProperty(D,()=>{r=!1}),r}static recursiveClone(D){if(!D||typeof D!="object"||D instanceof RegExp||!Array.isArray(D)&&Object.getPrototypeOf(D)!==Object.prototype)return D;let r=Array.isArray(D)?[]:{};return t.forEachProperty(D,(f,N)=>{N&&typeof N=="object"?r[f]=t.recursiveClone(N):r[f]=N}),r}static generateAnonymousModule(){return"===anonymous"+t.NEXT_ANONYMOUS_ID+++"==="}static isAnonymousModule(D){return t.startsWith(D,"===anonymous")}static getHighPerformanceTimestamp(){return this.PERFORMANCE_NOW_PROBED||(this.PERFORMANCE_NOW_PROBED=!0,this.HAS_PERFORMANCE_NOW=O.global.performance&&typeof O.global.performance.now=="function"),this.HAS_PERFORMANCE_NOW?O.global.performance.now():Date.now()}}t.NEXT_ANONYMOUS_ID=1,t.PERFORMANCE_NOW_PROBED=!1,t.HAS_PERFORMANCE_NOW=!1,O.Utilities=t})(he||(he={}));var he;(function(O){function t(r){if(r instanceof Error)return r;const f=new Error(r.message||String(r)||"Unknown Error");return r.stack&&(f.stack=r.stack),f}O.ensureError=t;class k{static validateConfigurationOptions(f){function N(h){if(h.phase==="loading"){console.error('Loading "'+h.moduleId+'" failed'),console.error(h),console.error("Here are the modules that depend on it:"),console.error(h.neededBy);return}if(h.phase==="factory"){console.error('The factory function of "'+h.moduleId+'" has thrown an exception'),console.error(h),console.error("Here are the modules that depend on it:"),console.error(h.neededBy);return}}if(f=f||{},typeof f.baseUrl!="string"&&(f.baseUrl=""),typeof f.isBuild!="boolean"&&(f.isBuild=!1),typeof f.paths!="object"&&(f.paths={}),typeof f.config!="object"&&(f.config={}),typeof f.catchError>"u"&&(f.catchError=!1),typeof f.recordStats>"u"&&(f.recordStats=!1),typeof f.urlArgs!="string"&&(f.urlArgs=""),typeof f.onError!="function"&&(f.onError=N),Array.isArray(f.ignoreDuplicateModules)||(f.ignoreDuplicateModules=[]),f.baseUrl.length>0&&(O.Utilities.endsWith(f.baseUrl,"/")||(f.baseUrl+="/")),typeof f.cspNonce!="string"&&(f.cspNonce=""),typeof f.preferScriptTags>"u"&&(f.preferScriptTags=!1),f.nodeCachedData&&typeof f.nodeCachedData=="object"&&(typeof f.nodeCachedData.seed!="string"&&(f.nodeCachedData.seed="seed"),(typeof f.nodeCachedData.writeDelay!="number"||f.nodeCachedData.writeDelay<0)&&(f.nodeCachedData.writeDelay=1e3*7),!f.nodeCachedData.path||typeof f.nodeCachedData.path!="string")){const h=t(new Error("INVALID cached data configuration, 'path' MUST be set"));h.phase="configuration",f.onError(h),f.nodeCachedData=void 0}return f}static mergeConfigurationOptions(f=null,N=null){let h=O.Utilities.recursiveClone(N||{});return O.Utilities.forEachProperty(f,(a,l)=>{a==="ignoreDuplicateModules"&&typeof h.ignoreDuplicateModules<"u"?h.ignoreDuplicateModules=h.ignoreDuplicateModules.concat(l):a==="paths"&&typeof h.paths<"u"?O.Utilities.forEachProperty(l,(g,E)=>h.paths[g]=E):a==="config"&&typeof h.config<"u"?O.Utilities.forEachProperty(l,(g,E)=>h.config[g]=E):h[a]=O.Utilities.recursiveClone(l)}),k.validateConfigurationOptions(h)}}O.ConfigurationOptionsUtil=k;class D{constructor(f,N){if(this._env=f,this.options=k.mergeConfigurationOptions(N),this._createIgnoreDuplicateModulesMap(),this._createSortedPathsRules(),this.options.baseUrl===""&&this.options.nodeRequire&&this.options.nodeRequire.main&&this.options.nodeRequire.main.filename&&this._env.isNode){let h=this.options.nodeRequire.main.filename,a=Math.max(h.lastIndexOf("/"),h.lastIndexOf("\\"));this.options.baseUrl=h.substring(0,a+1)}}_createIgnoreDuplicateModulesMap(){this.ignoreDuplicateModulesMap={};for(let f=0;f<this.options.ignoreDuplicateModules.length;f++)this.ignoreDuplicateModulesMap[this.options.ignoreDuplicateModules[f]]=!0}_createSortedPathsRules(){this.sortedPathsRules=[],O.Utilities.forEachProperty(this.options.paths,(f,N)=>{Array.isArray(N)?this.sortedPathsRules.push({from:f,to:N}):this.sortedPathsRules.push({from:f,to:[N]})}),this.sortedPathsRules.sort((f,N)=>N.from.length-f.from.length)}cloneAndMerge(f){return new D(this._env,k.mergeConfigurationOptions(f,this.options))}getOptionsLiteral(){return this.options}_applyPaths(f){let N;for(let h=0,a=this.sortedPathsRules.length;h<a;h++)if(N=this.sortedPathsRules[h],O.Utilities.startsWith(f,N.from)){let l=[];for(let g=0,E=N.to.length;g<E;g++)l.push(N.to[g]+f.substr(N.from.length));return l}return[f]}_addUrlArgsToUrl(f){return O.Utilities.containsQueryString(f)?f+"&"+this.options.urlArgs:f+"?"+this.options.urlArgs}_addUrlArgsIfNecessaryToUrl(f){return this.options.urlArgs?this._addUrlArgsToUrl(f):f}_addUrlArgsIfNecessaryToUrls(f){if(this.options.urlArgs)for(let N=0,h=f.length;N<h;N++)f[N]=this._addUrlArgsToUrl(f[N]);return f}moduleIdToPaths(f){if(this._env.isNode&&this.options.amdModulesPattern instanceof RegExp&&!this.options.amdModulesPattern.test(f))return this.isBuild()?["empty:"]:["node|"+f];let N=f,h;if(!O.Utilities.endsWith(N,".js")&&!O.Utilities.isAbsolutePath(N)){h=this._applyPaths(N);for(let a=0,l=h.length;a<l;a++)this.isBuild()&&h[a]==="empty:"||(O.Utilities.isAbsolutePath(h[a])||(h[a]=this.options.baseUrl+h[a]),!O.Utilities.endsWith(h[a],".js")&&!O.Utilities.containsQueryString(h[a])&&(h[a]=h[a]+".js"))}else!O.Utilities.endsWith(N,".js")&&!O.Utilities.containsQueryString(N)&&(N=N+".js"),h=[N];return this._addUrlArgsIfNecessaryToUrls(h)}requireToUrl(f){let N=f;return O.Utilities.isAbsolutePath(N)||(N=this._applyPaths(N)[0],O.Utilities.isAbsolutePath(N)||(N=this.options.baseUrl+N)),this._addUrlArgsIfNecessaryToUrl(N)}isBuild(){return this.options.isBuild}shouldInvokeFactory(f){return!!(!this.options.isBuild||O.Utilities.isAnonymousModule(f)||this.options.buildForceInvokeFactory&&this.options.buildForceInvokeFactory[f])}isDuplicateMessageIgnoredFor(f){return this.ignoreDuplicateModulesMap.hasOwnProperty(f)}getConfigForModule(f){if(this.options.config)return this.options.config[f]}shouldCatchError(){return this.options.catchError}shouldRecordStats(){return this.options.recordStats}onError(f){this.options.onError(f)}}O.Configuration=D})(he||(he={}));var he;(function(O){class t{constructor(l){this._env=l,this._scriptLoader=null,this._callbackMap={}}load(l,g,E,m){if(!this._scriptLoader)if(this._env.isWebWorker)this._scriptLoader=new r;else if(this._env.isElectronRenderer){const{preferScriptTags:e}=l.getConfig().getOptionsLiteral();e?this._scriptLoader=new k:this._scriptLoader=new f(this._env)}else this._env.isNode?this._scriptLoader=new f(this._env):this._scriptLoader=new k;let b={callback:E,errorback:m};if(this._callbackMap.hasOwnProperty(g)){this._callbackMap[g].push(b);return}this._callbackMap[g]=[b],this._scriptLoader.load(l,g,()=>this.triggerCallback(g),e=>this.triggerErrorback(g,e))}triggerCallback(l){let g=this._callbackMap[l];delete this._callbackMap[l];for(let E=0;E<g.length;E++)g[E].callback()}triggerErrorback(l,g){let E=this._callbackMap[l];delete this._callbackMap[l];for(let m=0;m<E.length;m++)E[m].errorback(g)}}class k{attachListeners(l,g,E){let m=()=>{l.removeEventListener("load",b),l.removeEventListener("error",e)},b=L=>{m(),g()},e=L=>{m(),E(L)};l.addEventListener("load",b),l.addEventListener("error",e)}load(l,g,E,m){if(/^node\|/.test(g)){let b=l.getConfig().getOptionsLiteral(),e=N(l.getRecorder(),b.nodeRequire||O.global.nodeRequire),L=g.split("|"),A=null;try{A=e(L[1])}catch(p){m(p);return}l.enqueueDefineAnonymousModule([],()=>A),E()}else{let b=document.createElement("script");b.setAttribute("async","async"),b.setAttribute("type","text/javascript"),this.attachListeners(b,E,m);const{trustedTypesPolicy:e}=l.getConfig().getOptionsLiteral();e&&(g=e.createScriptURL(g)),b.setAttribute("src",g);const{cspNonce:L}=l.getConfig().getOptionsLiteral();L&&b.setAttribute("nonce",L),document.getElementsByTagName("head")[0].appendChild(b)}}}function D(a){const{trustedTypesPolicy:l}=a.getConfig().getOptionsLiteral();try{return(l?self.eval(l.createScript("","true")):new Function("true")).call(self),!0}catch{return!1}}class r{constructor(){this._cachedCanUseEval=null}_canUseEval(l){return this._cachedCanUseEval===null&&(this._cachedCanUseEval=D(l)),this._cachedCanUseEval}load(l,g,E,m){if(/^node\|/.test(g)){const b=l.getConfig().getOptionsLiteral(),e=N(l.getRecorder(),b.nodeRequire||O.global.nodeRequire),L=g.split("|");let A=null;try{A=e(L[1])}catch(p){m(p);return}l.enqueueDefineAnonymousModule([],function(){return A}),E()}else{const{trustedTypesPolicy:b}=l.getConfig().getOptionsLiteral();if(!(/^((http:)|(https:)|(file:))/.test(g)&&g.substring(0,self.origin.length)!==self.origin)&&this._canUseEval(l)){fetch(g).then(L=>{if(L.status!==200)throw new Error(L.statusText);return L.text()}).then(L=>{L=`${L}
//# sourceURL=${g}`,(b?self.eval(b.createScript("",L)):new Function(L)).call(self),E()}).then(void 0,m);return}try{b&&(g=b.createScriptURL(g)),importScripts(g),E()}catch(L){m(L)}}}}class f{constructor(l){this._env=l,this._didInitialize=!1,this._didPatchNodeRequire=!1}_init(l){this._didInitialize||(this._didInitialize=!0,this._fs=l("fs"),this._vm=l("vm"),this._path=l("path"),this._crypto=l("crypto"))}_initNodeRequire(l,g){const{nodeCachedData:E}=g.getConfig().getOptionsLiteral();if(!E||this._didPatchNodeRequire)return;this._didPatchNodeRequire=!0;const m=this,b=l("module");function e(L){const A=L.constructor;let p=function(o){try{return L.require(o)}finally{}};return p.resolve=function(o,c){return A._resolveFilename(o,L,!1,c)},p.resolve.paths=function(o){return A._resolveLookupPaths(o,L)},p.main=process.mainModule,p.extensions=A._extensions,p.cache=A._cache,p}b.prototype._compile=function(L,A){const p=b.wrap(L.replace(/^#!.*/,"")),$=g.getRecorder(),o=m._getCachedDataPath(E,A),c={filename:A};let s;try{const M=m._fs.readFileSync(o);s=M.slice(0,16),c.cachedData=M.slice(16),$.record(60,o)}catch{$.record(61,o)}const i=new m._vm.Script(p,c),u=i.runInThisContext(c),w=m._path.dirname(A),d=e(this),v=[this.exports,d,this,A,w,process,Ce,Buffer],R=u.apply(this.exports,v);return m._handleCachedData(i,p,o,!c.cachedData,g),m._verifyCachedData(i,p,o,s,g),R}}load(l,g,E,m){const b=l.getConfig().getOptionsLiteral(),e=N(l.getRecorder(),b.nodeRequire||O.global.nodeRequire),L=b.nodeInstrumenter||function(p){return p};this._init(e),this._initNodeRequire(e,l);let A=l.getRecorder();if(/^node\|/.test(g)){let p=g.split("|"),$=null;try{$=e(p[1])}catch(o){m(o);return}l.enqueueDefineAnonymousModule([],()=>$),E()}else{g=O.Utilities.fileUriToFilePath(this._env.isWindows,g);const p=this._path.normalize(g),$=this._getElectronRendererScriptPathOrUri(p),o=!!b.nodeCachedData,c=o?this._getCachedDataPath(b.nodeCachedData,g):void 0;this._readSourceAndCachedData(p,c,A,(s,i,u,w)=>{if(s){m(s);return}let d;i.charCodeAt(0)===f._BOM?d=f._PREFIX+i.substring(1)+f._SUFFIX:d=f._PREFIX+i+f._SUFFIX,d=L(d,p);const v={filename:$,cachedData:u},R=this._createAndEvalScript(l,d,v,E,m);this._handleCachedData(R,d,c,o&&!u,l),this._verifyCachedData(R,d,c,w,l)})}}_createAndEvalScript(l,g,E,m,b){const e=l.getRecorder();e.record(31,E.filename);const L=new this._vm.Script(g,E),A=L.runInThisContext(E),p=l.getGlobalAMDDefineFunc();let $=!1;const o=function(){return $=!0,p.apply(null,arguments)};return o.amd=p.amd,A.call(O.global,l.getGlobalAMDRequireFunc(),o,E.filename,this._path.dirname(E.filename)),e.record(32,E.filename),$?m():b(new Error(`Didn't receive define call in ${E.filename}!`)),L}_getElectronRendererScriptPathOrUri(l){if(!this._env.isElectronRenderer)return l;let g=l.match(/^([a-z])\:(.*)/i);return g?`file:///${(g[1].toUpperCase()+":"+g[2]).replace(/\\/g,"/")}`:`file://${l}`}_getCachedDataPath(l,g){const E=this._crypto.createHash("md5").update(g,"utf8").update(l.seed,"utf8").update(process.arch,"").digest("hex"),m=this._path.basename(g).replace(/\.js$/,"");return this._path.join(l.path,`${m}-${E}.code`)}_handleCachedData(l,g,E,m,b){l.cachedDataRejected?this._fs.unlink(E,e=>{b.getRecorder().record(62,E),this._createAndWriteCachedData(l,g,E,b),e&&b.getConfig().onError(e)}):m&&this._createAndWriteCachedData(l,g,E,b)}_createAndWriteCachedData(l,g,E,m){let b=Math.ceil(m.getConfig().getOptionsLiteral().nodeCachedData.writeDelay*(1+Math.random())),e=-1,L=0,A;const p=()=>{setTimeout(()=>{A||(A=this._crypto.createHash("md5").update(g,"utf8").digest());const $=l.createCachedData();if(!($.length===0||$.length===e||L>=5)){if($.length<e){p();return}e=$.length,this._fs.writeFile(E,Buffer.concat([A,$]),o=>{o&&m.getConfig().onError(o),m.getRecorder().record(63,E),p()})}},b*Math.pow(4,L++))};p()}_readSourceAndCachedData(l,g,E,m){if(!g)this._fs.readFile(l,{encoding:"utf8"},m);else{let b,e,L,A=2;const p=$=>{$?m($):--A===0&&m(void 0,b,e,L)};this._fs.readFile(l,{encoding:"utf8"},($,o)=>{b=o,p($)}),this._fs.readFile(g,($,o)=>{!$&&o&&o.length>0?(L=o.slice(0,16),e=o.slice(16),E.record(60,g)):E.record(61,g),p()})}}_verifyCachedData(l,g,E,m,b){m&&(l.cachedDataRejected||setTimeout(()=>{const e=this._crypto.createHash("md5").update(g,"utf8").digest();m.equals(e)||(b.getConfig().onError(new Error(`FAILED TO VERIFY CACHED DATA, deleting stale '${E}' now, but a RESTART IS REQUIRED`)),this._fs.unlink(E,L=>{L&&b.getConfig().onError(L)}))},Math.ceil(5e3*(1+Math.random()))))}}f._BOM=65279,f._PREFIX="(function (require, define, __filename, __dirname) { ",f._SUFFIX=`
});`;function N(a,l){if(l.__$__isRecorded)return l;const g=function(m){a.record(33,m);try{return l(m)}finally{a.record(34,m)}};return g.__$__isRecorded=!0,g}O.ensureRecordedNodeRequire=N;function h(a){return new t(a)}O.createScriptLoader=h})(he||(he={}));var he;(function(O){class t{constructor(a){let l=a.lastIndexOf("/");l!==-1?this.fromModulePath=a.substr(0,l+1):this.fromModulePath=""}static _normalizeModuleId(a){let l=a,g;for(g=/\/\.\//;g.test(l);)l=l.replace(g,"/");for(l=l.replace(/^\.\//g,""),g=/\/(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//;g.test(l);)l=l.replace(g,"/");return l=l.replace(/^(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//,""),l}resolveModule(a){let l=a;return O.Utilities.isAbsolutePath(l)||(O.Utilities.startsWith(l,"./")||O.Utilities.startsWith(l,"../"))&&(l=t._normalizeModuleId(this.fromModulePath+l)),l}}t.ROOT=new t(""),O.ModuleIdResolver=t;class k{constructor(a,l,g,E,m,b){this.id=a,this.strId=l,this.dependencies=g,this._callback=E,this._errorback=m,this.moduleIdResolver=b,this.exports={},this.error=null,this.exportsPassedIn=!1,this.unresolvedDependenciesCount=this.dependencies.length,this._isComplete=!1}static _safeInvokeFunction(a,l){try{return{returnedValue:a.apply(O.global,l),producedError:null}}catch(g){return{returnedValue:null,producedError:g}}}static _invokeFactory(a,l,g,E){return a.shouldInvokeFactory(l)?a.shouldCatchError()?this._safeInvokeFunction(g,E):{returnedValue:g.apply(O.global,E),producedError:null}:{returnedValue:null,producedError:null}}complete(a,l,g,E){this._isComplete=!0;let m=null;if(this._callback)if(typeof this._callback=="function"){a.record(21,this.strId);let b=k._invokeFactory(l,this.strId,this._callback,g);m=b.producedError,a.record(22,this.strId),!m&&typeof b.returnedValue<"u"&&(!this.exportsPassedIn||O.Utilities.isEmpty(this.exports))&&(this.exports=b.returnedValue)}else this.exports=this._callback;if(m){let b=O.ensureError(m);b.phase="factory",b.moduleId=this.strId,b.neededBy=E(this.id),this.error=b,l.onError(b)}this.dependencies=null,this._callback=null,this._errorback=null,this.moduleIdResolver=null}onDependencyError(a){return this._isComplete=!0,this.error=a,this._errorback?(this._errorback(a),!0):!1}isComplete(){return this._isComplete}}O.Module=k;class D{constructor(){this._nextId=0,this._strModuleIdToIntModuleId=new Map,this._intModuleIdToStrModuleId=[],this.getModuleId("exports"),this.getModuleId("module"),this.getModuleId("require")}getMaxModuleId(){return this._nextId}getModuleId(a){let l=this._strModuleIdToIntModuleId.get(a);return typeof l>"u"&&(l=this._nextId++,this._strModuleIdToIntModuleId.set(a,l),this._intModuleIdToStrModuleId[l]=a),l}getStrModuleId(a){return this._intModuleIdToStrModuleId[a]}}class r{constructor(a){this.id=a}}r.EXPORTS=new r(0),r.MODULE=new r(1),r.REQUIRE=new r(2),O.RegularDependency=r;class f{constructor(a,l,g){this.id=a,this.pluginId=l,this.pluginParam=g}}O.PluginDependency=f;class N{constructor(a,l,g,E,m=0){this._env=a,this._scriptLoader=l,this._loaderAvailableTimestamp=m,this._defineFunc=g,this._requireFunc=E,this._moduleIdProvider=new D,this._config=new O.Configuration(this._env),this._hasDependencyCycle=!1,this._modules2=[],this._knownModules2=[],this._inverseDependencies2=[],this._inversePluginDependencies2=new Map,this._currentAnonymousDefineCall=null,this._recorder=null,this._buildInfoPath=[],this._buildInfoDefineStack=[],this._buildInfoDependencies=[],this._requireFunc.moduleManager=this}reset(){return new N(this._env,this._scriptLoader,this._defineFunc,this._requireFunc,this._loaderAvailableTimestamp)}getGlobalAMDDefineFunc(){return this._defineFunc}getGlobalAMDRequireFunc(){return this._requireFunc}static _findRelevantLocationInStack(a,l){let g=b=>b.replace(/\\/g,"/"),E=g(a),m=l.split(/\n/);for(let b=0;b<m.length;b++){let e=m[b].match(/(.*):(\d+):(\d+)\)?$/);if(e){let L=e[1],A=e[2],p=e[3],$=Math.max(L.lastIndexOf(" ")+1,L.lastIndexOf("(")+1);if(L=L.substr($),L=g(L),L===E){let o={line:parseInt(A,10),col:parseInt(p,10)};return o.line===1&&(o.col-=53),o}}}throw new Error("Could not correlate define call site for needle "+a)}getBuildInfo(){if(!this._config.isBuild())return null;let a=[],l=0;for(let g=0,E=this._modules2.length;g<E;g++){let m=this._modules2[g];if(!m)continue;let b=this._buildInfoPath[m.id]||null,e=this._buildInfoDefineStack[m.id]||null,L=this._buildInfoDependencies[m.id];a[l++]={id:m.strId,path:b,defineLocation:b&&e?N._findRelevantLocationInStack(b,e):null,dependencies:L,shim:null,exports:m.exports}}return a}getRecorder(){return this._recorder||(this._config.shouldRecordStats()?this._recorder=new O.LoaderEventRecorder(this._loaderAvailableTimestamp):this._recorder=O.NullLoaderEventRecorder.INSTANCE),this._recorder}getLoaderEvents(){return this.getRecorder().getEvents()}enqueueDefineAnonymousModule(a,l){if(this._currentAnonymousDefineCall!==null)throw new Error("Can only have one anonymous define call per script file");let g=null;this._config.isBuild()&&(g=new Error("StackLocation").stack||null),this._currentAnonymousDefineCall={stack:g,dependencies:a,callback:l}}defineModule(a,l,g,E,m,b=new t(a)){let e=this._moduleIdProvider.getModuleId(a);if(this._modules2[e]){this._config.isDuplicateMessageIgnoredFor(a)||console.warn("Duplicate definition of module '"+a+"'");return}let L=new k(e,a,this._normalizeDependencies(l,b),g,E,b);this._modules2[e]=L,this._config.isBuild()&&(this._buildInfoDefineStack[e]=m,this._buildInfoDependencies[e]=(L.dependencies||[]).map(A=>this._moduleIdProvider.getStrModuleId(A.id))),this._resolve(L)}_normalizeDependency(a,l){if(a==="exports")return r.EXPORTS;if(a==="module")return r.MODULE;if(a==="require")return r.REQUIRE;let g=a.indexOf("!");if(g>=0){let E=l.resolveModule(a.substr(0,g)),m=l.resolveModule(a.substr(g+1)),b=this._moduleIdProvider.getModuleId(E+"!"+m),e=this._moduleIdProvider.getModuleId(E);return new f(b,e,m)}return new r(this._moduleIdProvider.getModuleId(l.resolveModule(a)))}_normalizeDependencies(a,l){let g=[],E=0;for(let m=0,b=a.length;m<b;m++)g[E++]=this._normalizeDependency(a[m],l);return g}_relativeRequire(a,l,g,E){if(typeof l=="string")return this.synchronousRequire(l,a);this.defineModule(O.Utilities.generateAnonymousModule(),l,g,E,null,a)}synchronousRequire(a,l=new t(a)){let g=this._normalizeDependency(a,l),E=this._modules2[g.id];if(!E)throw new Error("Check dependency list! Synchronous require cannot resolve module '"+a+"'. This is the first mention of this module!");if(!E.isComplete())throw new Error("Check dependency list! Synchronous require cannot resolve module '"+a+"'. This module has not been resolved completely yet.");if(E.error)throw E.error;return E.exports}configure(a,l){let g=this._config.shouldRecordStats();l?this._config=new O.Configuration(this._env,a):this._config=this._config.cloneAndMerge(a),this._config.shouldRecordStats()&&!g&&(this._recorder=null)}getConfig(){return this._config}_onLoad(a){if(this._currentAnonymousDefineCall!==null){let l=this._currentAnonymousDefineCall;this._currentAnonymousDefineCall=null,this.defineModule(this._moduleIdProvider.getStrModuleId(a),l.dependencies,l.callback,null,l.stack)}}_createLoadError(a,l){let g=this._moduleIdProvider.getStrModuleId(a),E=(this._inverseDependencies2[a]||[]).map(b=>this._moduleIdProvider.getStrModuleId(b));const m=O.ensureError(l);return m.phase="loading",m.moduleId=g,m.neededBy=E,m}_onLoadError(a,l){const g=this._createLoadError(a,l);this._modules2[a]||(this._modules2[a]=new k(a,this._moduleIdProvider.getStrModuleId(a),[],()=>{},null,null));let E=[];for(let e=0,L=this._moduleIdProvider.getMaxModuleId();e<L;e++)E[e]=!1;let m=!1,b=[];for(b.push(a),E[a]=!0;b.length>0;){let e=b.shift(),L=this._modules2[e];L&&(m=L.onDependencyError(g)||m);let A=this._inverseDependencies2[e];if(A)for(let p=0,$=A.length;p<$;p++){let o=A[p];E[o]||(b.push(o),E[o]=!0)}}m||this._config.onError(g)}_hasDependencyPath(a,l){let g=this._modules2[a];if(!g)return!1;let E=[];for(let b=0,e=this._moduleIdProvider.getMaxModuleId();b<e;b++)E[b]=!1;let m=[];for(m.push(g),E[a]=!0;m.length>0;){let e=m.shift().dependencies;if(e)for(let L=0,A=e.length;L<A;L++){let p=e[L];if(p.id===l)return!0;let $=this._modules2[p.id];$&&!E[p.id]&&(E[p.id]=!0,m.push($))}}return!1}_findCyclePath(a,l,g){if(a===l||g===50)return[a];let E=this._modules2[a];if(!E)return null;let m=E.dependencies;if(m)for(let b=0,e=m.length;b<e;b++){let L=this._findCyclePath(m[b].id,l,g+1);if(L!==null)return L.push(a),L}return null}_createRequire(a){let l=(g,E,m)=>this._relativeRequire(a,g,E,m);return l.toUrl=g=>this._config.requireToUrl(a.resolveModule(g)),l.getStats=()=>this.getLoaderEvents(),l.hasDependencyCycle=()=>this._hasDependencyCycle,l.config=(g,E=!1)=>{this.configure(g,E)},l.__$__nodeRequire=O.global.nodeRequire,l}_loadModule(a){if(this._modules2[a]||this._knownModules2[a])return;this._knownModules2[a]=!0;let l=this._moduleIdProvider.getStrModuleId(a),g=this._config.moduleIdToPaths(l),E=/^@[^\/]+\/[^\/]+$/;this._env.isNode&&(l.indexOf("/")===-1||E.test(l))&&g.push("node|"+l);let m=-1,b=e=>{if(m++,m>=g.length)this._onLoadError(a,e);else{let L=g[m],A=this.getRecorder();if(this._config.isBuild()&&L==="empty:"){this._buildInfoPath[a]=L,this.defineModule(this._moduleIdProvider.getStrModuleId(a),[],null,null,null),this._onLoad(a);return}A.record(10,L),this._scriptLoader.load(this,L,()=>{this._config.isBuild()&&(this._buildInfoPath[a]=L),A.record(11,L),this._onLoad(a)},p=>{A.record(12,L),b(p)})}};b(null)}_loadPluginDependency(a,l){if(this._modules2[l.id]||this._knownModules2[l.id])return;this._knownModules2[l.id]=!0;let g=E=>{this.defineModule(this._moduleIdProvider.getStrModuleId(l.id),[],E,null,null)};g.error=E=>{this._config.onError(this._createLoadError(l.id,E))},a.load(l.pluginParam,this._createRequire(t.ROOT),g,this._config.getOptionsLiteral())}_resolve(a){let l=a.dependencies;if(l)for(let g=0,E=l.length;g<E;g++){let m=l[g];if(m===r.EXPORTS){a.exportsPassedIn=!0,a.unresolvedDependenciesCount--;continue}if(m===r.MODULE){a.unresolvedDependenciesCount--;continue}if(m===r.REQUIRE){a.unresolvedDependenciesCount--;continue}let b=this._modules2[m.id];if(b&&b.isComplete()){if(b.error){a.onDependencyError(b.error);return}a.unresolvedDependenciesCount--;continue}if(this._hasDependencyPath(m.id,a.id)){this._hasDependencyCycle=!0,console.warn("There is a dependency cycle between '"+this._moduleIdProvider.getStrModuleId(m.id)+"' and '"+this._moduleIdProvider.getStrModuleId(a.id)+"'. The cyclic path follows:");let e=this._findCyclePath(m.id,a.id,0)||[];e.reverse(),e.push(m.id),console.warn(e.map(L=>this._moduleIdProvider.getStrModuleId(L)).join(` => 
`)),a.unresolvedDependenciesCount--;continue}if(this._inverseDependencies2[m.id]=this._inverseDependencies2[m.id]||[],this._inverseDependencies2[m.id].push(a.id),m instanceof f){let e=this._modules2[m.pluginId];if(e&&e.isComplete()){this._loadPluginDependency(e.exports,m);continue}let L=this._inversePluginDependencies2.get(m.pluginId);L||(L=[],this._inversePluginDependencies2.set(m.pluginId,L)),L.push(m),this._loadModule(m.pluginId);continue}this._loadModule(m.id)}a.unresolvedDependenciesCount===0&&this._onModuleComplete(a)}_onModuleComplete(a){let l=this.getRecorder();if(a.isComplete())return;let g=a.dependencies,E=[];if(g)for(let L=0,A=g.length;L<A;L++){let p=g[L];if(p===r.EXPORTS){E[L]=a.exports;continue}if(p===r.MODULE){E[L]={id:a.strId,config:()=>this._config.getConfigForModule(a.strId)};continue}if(p===r.REQUIRE){E[L]=this._createRequire(a.moduleIdResolver);continue}let $=this._modules2[p.id];if($){E[L]=$.exports;continue}E[L]=null}const m=L=>(this._inverseDependencies2[L]||[]).map(A=>this._moduleIdProvider.getStrModuleId(A));a.complete(l,this._config,E,m);let b=this._inverseDependencies2[a.id];if(this._inverseDependencies2[a.id]=null,b)for(let L=0,A=b.length;L<A;L++){let p=b[L],$=this._modules2[p];$.unresolvedDependenciesCount--,$.unresolvedDependenciesCount===0&&this._onModuleComplete($)}let e=this._inversePluginDependencies2.get(a.id);if(e){this._inversePluginDependencies2.delete(a.id);for(let L=0,A=e.length;L<A;L++)this._loadPluginDependency(a.exports,e[L])}}}O.ModuleManager=N})(he||(he={}));var ne,he;(function(O){const t=new O.Environment;let k=null;const D=function(h,a,l){typeof h!="string"&&(l=a,a=h,h=null),(typeof a!="object"||!Array.isArray(a))&&(l=a,a=null),a||(a=["require","exports","module"]),h?k.defineModule(h,a,l,null,null):k.enqueueDefineAnonymousModule(a,l)};D.amd={jQuery:!0};const r=function(h,a=!1){k.configure(h,a)},f=function(){if(arguments.length===1){if(arguments[0]instanceof Object&&!Array.isArray(arguments[0])){r(arguments[0]);return}if(typeof arguments[0]=="string")return k.synchronousRequire(arguments[0])}if((arguments.length===2||arguments.length===3)&&Array.isArray(arguments[0])){k.defineModule(O.Utilities.generateAnonymousModule(),arguments[0],arguments[1],arguments[2],null);return}throw new Error("Unrecognized require call")};f.config=r,f.getConfig=function(){return k.getConfig().getOptionsLiteral()},f.reset=function(){k=k.reset()},f.getBuildInfo=function(){return k.getBuildInfo()},f.getStats=function(){return k.getLoaderEvents()},f.define=D;function N(){if(typeof O.global.require<"u"||typeof require<"u"){const h=O.global.require||require;if(typeof h=="function"&&typeof h.resolve=="function"){const a=O.ensureRecordedNodeRequire(k.getRecorder(),h);O.global.nodeRequire=a,f.nodeRequire=a,f.__$__nodeRequire=a}}t.isNode&&!t.isElectronRenderer&&!t.isElectronNodeIntegrationWebWorker?module.exports=f:(t.isElectronRenderer||(O.global.define=D),O.global.require=f)}O.init=N,(typeof O.global.define!="function"||!O.global.define.amd)&&(k=new O.ModuleManager(t,O.createScriptLoader(t),D,f,O.Utilities.getHighPerformanceTimestamp()),typeof O.global.require<"u"&&typeof O.global.require!="function"&&f.config(O.global.require),ne=function(){return D.apply(null,arguments)},ne.amd=D.amd,typeof doNotInitLoader>"u"&&N())})(he||(he={})),ne(ie[66],se([0,1]),function(O,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.load=void 0;function k(h,a,l,g){if(g=g||{},(g["vs/css"]||{}).disabled){l({});return}const m=a.toUrl(h+".css");D(h,m,()=>{l({})},b=>{typeof l.error=="function"&&l.error("Could not find "+m+".")})}t.load=k;function D(h,a,l,g){if(r(h,a)){l();return}f(h,a,l,g)}function r(h,a){const l=document.getElementsByTagName("link");for(let g=0,E=l.length;g<E;g++){const m=l[g].getAttribute("data-name"),b=l[g].getAttribute("href");if(m===h||b===a)return!0}return!1}function f(h,a,l,g){const E=document.createElement("link");E.setAttribute("rel","stylesheet"),E.setAttribute("type","text/css"),E.setAttribute("data-name",h),N(h,E,l,g),E.setAttribute("href",a),(document.head||document.getElementsByTagName("head")[0]).appendChild(E)}function N(h,a,l,g){const E=()=>{a.removeEventListener("load",m),a.removeEventListener("error",b)},m=e=>{E(),l()},b=e=>{E(),g(e)};a.addEventListener("load",m),a.addEventListener("error",b)}}),ne("vs/nls",["require","exports"],function(O,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.load=t.create=t.setPseudoTranslation=t.getConfiguredDefaultLocale=t.localize2=t.localize=void 0;let k=typeof document<"u"&&document.location&&document.location.hash.indexOf("pseudo=true")>=0;const D="i-default";function r(A,p){let $;return p.length===0?$=A:$=A.replace(/\{(\d+)\}/g,(o,c)=>{const s=c[0],i=p[s];let u=o;return typeof i=="string"?u=i:(typeof i=="number"||typeof i=="boolean"||i===void 0||i===null)&&(u=String(i)),u}),k&&($="\uFF3B"+$.replace(/[aouei]/g,"$&$&")+"\uFF3D"),$}function f(A,p){let $=A[p];return $||($=A["*"],$)?$:null}function N(A){return A.charAt(A.length-1)==="/"?A:A+"/"}async function h(A,p,$){const o=N(A)+N(p)+"vscode/"+N($),c=await fetch(o);if(c.ok)return await c.json();throw new Error(`${c.status} - ${c.statusText}`)}function a(A){return function(p,$){const o=Array.prototype.slice.call(arguments,2);return r(A[p],o)}}function l(A){return(p,$,...o)=>({value:r(A[p],o),original:r($,o)})}function g(A,p,...$){return r(p,$)}t.localize=g;function E(A,p,...$){const o=r(p,$);return{value:o,original:o}}t.localize2=E;function m(A){}t.getConfiguredDefaultLocale=m;function b(A){k=A}t.setPseudoTranslation=b;function e(A,p){return{localize:a(p[A]),localize2:l(p[A]),getConfiguredDefaultLocale:p.getConfiguredDefaultLocale??($=>{})}}t.create=e;function L(A,p,$,o){const c=o["vs/nls"]??{};if(!A||A.length===0)return $({localize:g,localize2:E,getConfiguredDefaultLocale:()=>c.availableLanguages?.["*"]});const s=c.availableLanguages?f(c.availableLanguages,A):null,i=s===null||s===D;let u=".nls";i||(u=u+"."+s);const w=d=>{Array.isArray(d)?(d.localize=a(d),d.localize2=l(d)):(d.localize=a(d[A]),d.localize2=l(d[A])),d.getConfiguredDefaultLocale=()=>c.availableLanguages?.["*"],$(d)};typeof c.loadBundle=="function"?c.loadBundle(A,s,(d,v)=>{d?p([A+".nls"],w):w(v)}):c.translationServiceUrl&&!i?(async()=>{try{const d=await h(c.translationServiceUrl,s,A);return w(d)}catch(d){if(!s.includes("-"))return console.error(d),p([A+".nls"],w);try{const v=s.split("-")[0],R=await h(c.translationServiceUrl,v,A);return c.availableLanguages??(c.availableLanguages={}),c.availableLanguages["*"]=v,w(R)}catch(v){return console.error(v),p([A+".nls"],w)}}})():p([A+u],w,d=>{if(u===".nls"){console.error("Failed trying to load default language strings",d);return}console.error(`Failed to load message bundle for language ${s}. Falling back to the default language:`,d),p([A+".nls"],w)})}t.load=L}),function(){const O=globalThis.MonacoEnvironment,t=O&&O.baseUrl?O.baseUrl:"../../../";function k(g,E){if(O?.createTrustedTypesPolicy)try{return O.createTrustedTypesPolicy(g,E)}catch(m){console.warn(m);return}try{return self.trustedTypes?.createPolicy(g,E)}catch(m){console.warn(m);return}}const D=k("amdLoader",{createScriptURL:g=>g,createScript:(g,...E)=>{const m=E.slice(0,-1).join(","),b=E.pop().toString();return`(function anonymous(${m}) { ${b}
})`}});function r(){try{return(D?globalThis.eval(D.createScript("","true")):new Function("true")).call(globalThis),!0}catch{return!1}}function f(){return new Promise((g,E)=>{if(typeof globalThis.define=="function"&&globalThis.define.amd)return g();const m=t+"vs/loader.js";if(!(/^((http:)|(https:)|(file:))/.test(m)&&m.substring(0,globalThis.origin.length)!==globalThis.origin)&&r()){fetch(m).then(e=>{if(e.status!==200)throw new Error(e.statusText);return e.text()}).then(e=>{e=`${e}
//# sourceURL=${m}`,(D?globalThis.eval(D.createScript("",e)):new Function(e)).call(globalThis),g()}).then(void 0,E);return}D?importScripts(D.createScriptURL(m)):importScripts(m),g()})}function N(){require.config({baseUrl:t,catchError:!0,trustedTypesPolicy:D,amdModulesPattern:/^vs\//})}function h(g){f().then(()=>{N(),require([g],function(E){setTimeout(function(){const m=E.create((b,e)=>{globalThis.postMessage(b,e)},null);for(globalThis.onmessage=b=>m.onmessage(b.data,b.ports);l.length>0;){const b=l.shift();m.onmessage(b.data,b.ports)}},0)})})}typeof globalThis.define=="function"&&globalThis.define.amd&&N();let a=!0;const l=[];globalThis.onmessage=g=>{if(!a){l.push(g);return}a=!1,h(g.data)}}(),ne(ie[9],se([0,1]),function(O,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$rb=t.$qb=t.$pb=t.$ob=t.$nb=t.$mb=t.$lb=t.$kb=t.$jb=t.$ib=t.$hb=t.$gb=t.$fb=void 0;function k(L,A,p){const $=D(L,A);if($!==-1)return L[$]}t.$fb=k;function D(L,A,p=L.length-1){for(let $=p;$>=0;$--){const o=L[$];if(A(o))return $}return-1}t.$gb=D;function r(L,A){const p=f(L,A);return p===-1?void 0:L[p]}t.$hb=r;function f(L,A,p=0,$=L.length){let o=p,c=$;for(;o<c;){const s=Math.floor((o+c)/2);A(L[s])?o=s+1:c=s}return o-1}t.$ib=f;function N(L,A){const p=h(L,A);return p===L.length?void 0:L[p]}t.$jb=N;function h(L,A,p=0,$=L.length){let o=p,c=$;for(;o<c;){const s=Math.floor((o+c)/2);A(L[s])?c=s:o=s+1}return o}t.$kb=h;function a(L,A,p=0,$=L.length){const o=h(L,A,p,$);return o===L.length?-1:o}t.$lb=a;class l{constructor(A){this.e=A,this.c=0}findLastMonotonous(A){if(l.assertInvariants){if(this.d){for(const $ of this.e)if(this.d($)&&!A($))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=A}const p=f(this.e,A,this.c);return this.c=p+1,p===-1?void 0:this.e[p]}}t.$mb=l,l.assertInvariants=!1;function g(L,A){if(L.length===0)return;let p=L[0];for(let $=1;$<L.length;$++){const o=L[$];A(o,p)>0&&(p=o)}return p}t.$nb=g;function E(L,A){if(L.length===0)return;let p=L[0];for(let $=1;$<L.length;$++){const o=L[$];A(o,p)>=0&&(p=o)}return p}t.$ob=E;function m(L,A){return g(L,(p,$)=>-A(p,$))}t.$pb=m;function b(L,A){if(L.length===0)return-1;let p=0;for(let $=1;$<L.length;$++){const o=L[$];A(o,L[p])>0&&(p=$)}return p}t.$qb=b;function e(L,A){for(const p of L){const $=A(p);if($!==void 0)return $}}t.$rb=e}),ne(ie[34],se([0,1]),function(O,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$G=t.$F=t.$E=t.$D=void 0;function k(N,h){const a=Object.create(null);for(const l of N){const g=h(l);let E=a[g];E||(E=a[g]=[]),E.push(l)}return a}t.$D=k;function D(N,h){const a=[],l=[];for(const g of N)h.has(g)||a.push(g);for(const g of h)N.has(g)||l.push(g);return{removed:a,added:l}}t.$E=D;function r(N,h){const a=[],l=[];for(const[g,E]of N)h.has(g)||a.push(E);for(const[g,E]of h)N.has(g)||l.push(E);return{removed:a,added:l}}t.$F=r;function f(N,h){const a=new Set;for(const l of h)N.has(l)&&a.add(l);return a}t.$G=f}),ne(ie[35],se([0,1]),function(O,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$3s=t.$2s=t.$1s=t.$Zs=void 0;function k(h,a){const l=Math.pow(10,a);return Math.round(h*l)/l}class D{constructor(a,l,g,E=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,a))|0,this.g=Math.min(255,Math.max(0,l))|0,this.b=Math.min(255,Math.max(0,g))|0,this.a=k(Math.max(Math.min(1,E),0),3)}static equals(a,l){return a.r===l.r&&a.g===l.g&&a.b===l.b&&a.a===l.a}}t.$Zs=D;class r{constructor(a,l,g,E){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,a),0)|0,this.s=k(Math.max(Math.min(1,l),0),3),this.l=k(Math.max(Math.min(1,g),0),3),this.a=k(Math.max(Math.min(1,E),0),3)}static equals(a,l){return a.h===l.h&&a.s===l.s&&a.l===l.l&&a.a===l.a}static fromRGBA(a){const l=a.r/255,g=a.g/255,E=a.b/255,m=a.a,b=Math.max(l,g,E),e=Math.min(l,g,E);let L=0,A=0;const p=(e+b)/2,$=b-e;if($>0){switch(A=Math.min(p<=.5?$/(2*p):$/(2-2*p),1),b){case l:L=(g-E)/$+(g<E?6:0);break;case g:L=(E-l)/$+2;break;case E:L=(l-g)/$+4;break}L*=60,L=Math.round(L)}return new r(L,A,p,m)}static i(a,l,g){return g<0&&(g+=1),g>1&&(g-=1),g<1/6?a+(l-a)*6*g:g<1/2?l:g<2/3?a+(l-a)*(2/3-g)*6:a}static toRGBA(a){const l=a.h/360,{s:g,l:E,a:m}=a;let b,e,L;if(g===0)b=e=L=E;else{const A=E<.5?E*(1+g):E+g-E*g,p=2*E-A;b=r.i(p,A,l+1/3),e=r.i(p,A,l),L=r.i(p,A,l-1/3)}return new D(Math.round(b*255),Math.round(e*255),Math.round(L*255),m)}}t.$1s=r;class f{constructor(a,l,g,E){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,a),0)|0,this.s=k(Math.max(Math.min(1,l),0),3),this.v=k(Math.max(Math.min(1,g),0),3),this.a=k(Math.max(Math.min(1,E),0),3)}static equals(a,l){return a.h===l.h&&a.s===l.s&&a.v===l.v&&a.a===l.a}static fromRGBA(a){const l=a.r/255,g=a.g/255,E=a.b/255,m=Math.max(l,g,E),b=Math.min(l,g,E),e=m-b,L=m===0?0:e/m;let A;return e===0?A=0:m===l?A=((g-E)/e%6+6)%6:m===g?A=(E-l)/e+2:A=(l-g)/e+4,new f(Math.round(A*60),L,m,a.a)}static toRGBA(a){const{h:l,s:g,v:E,a:m}=a,b=E*g,e=b*(1-Math.abs(l/60%2-1)),L=E-b;let[A,p,$]=[0,0,0];return l<60?(A=b,p=e):l<120?(A=e,p=b):l<180?(p=b,$=e):l<240?(p=e,$=b):l<300?(A=e,$=b):l<=360&&(A=b,$=e),A=Math.round((A+L)*255),p=Math.round((p+L)*255),$=Math.round(($+L)*255),new D(A,p,$,m)}}t.$2s=f;class N{static fromHex(a){return N.Format.CSS.parseHex(a)||N.red}static equals(a,l){return!a&&!l?!0:!a||!l?!1:a.equals(l)}get hsla(){return this.i?this.i:r.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:f.fromRGBA(this.rgba)}constructor(a){if(a)if(a instanceof D)this.rgba=a;else if(a instanceof r)this.i=a,this.rgba=r.toRGBA(a);else if(a instanceof f)this.j=a,this.rgba=f.toRGBA(a);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(a){return!!a&&D.equals(this.rgba,a.rgba)&&r.equals(this.hsla,a.hsla)&&f.equals(this.hsva,a.hsva)}getRelativeLuminance(){const a=N.k(this.rgba.r),l=N.k(this.rgba.g),g=N.k(this.rgba.b),E=.2126*a+.7152*l+.0722*g;return k(E,4)}static k(a){const l=a/255;return l<=.03928?l/12.92:Math.pow((l+.055)/1.055,2.4)}getContrastRatio(a){const l=this.getRelativeLuminance(),g=a.getRelativeLuminance();return l>g?(l+.05)/(g+.05):(g+.05)/(l+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(a){const l=this.getRelativeLuminance(),g=a.getRelativeLuminance();return l>g}isDarkerThan(a){const l=this.getRelativeLuminance(),g=a.getRelativeLuminance();return l<g}lighten(a){return new N(new r(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*a,this.hsla.a))}darken(a){return new N(new r(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*a,this.hsla.a))}transparent(a){const{r:l,g,b:E,a:m}=this.rgba;return new N(new D(l,g,E,m*a))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new N(new D(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(a){const l=a.rgba,g=this.rgba.a,E=l.a,m=g+E*(1-g);if(m<1e-6)return N.transparent;const b=this.rgba.r*g/m+l.r*E*(1-g)/m,e=this.rgba.g*g/m+l.g*E*(1-g)/m,L=this.rgba.b*g/m+l.b*E*(1-g)/m;return new N(new D(b,e,L,m))}makeOpaque(a){if(this.isOpaque()||a.rgba.a!==1)return this;const{r:l,g,b:E,a:m}=this.rgba;return new N(new D(a.rgba.r-m*(a.rgba.r-l),a.rgba.g-m*(a.rgba.g-g),a.rgba.b-m*(a.rgba.b-E),1))}flatten(...a){const l=a.reduceRight((g,E)=>N.o(E,g));return N.o(this,l)}static o(a,l){const g=1-a.rgba.a;return new N(new D(g*l.rgba.r+a.rgba.a*a.rgba.r,g*l.rgba.g+a.rgba.a*a.rgba.g,g*l.rgba.b+a.rgba.a*a.rgba.b))}toString(){return this.u||(this.u=N.Format.CSS.format(this)),this.u}static getLighterColor(a,l,g){if(a.isLighterThan(l))return a;g=g||.5;const E=a.getRelativeLuminance(),m=l.getRelativeLuminance();return g=g*(m-E)/m,a.lighten(g)}static getDarkerColor(a,l,g){if(a.isDarkerThan(l))return a;g=g||.5;const E=a.getRelativeLuminance(),m=l.getRelativeLuminance();return g=g*(E-m)/E,a.darken(g)}}t.$3s=N,N.white=new N(new D(255,255,255,1)),N.black=new N(new D(0,0,0,1)),N.red=new N(new D(255,0,0,1)),N.blue=new N(new D(0,0,255,1)),N.green=new N(new D(0,255,0,1)),N.cyan=new N(new D(0,255,255,1)),N.lightgrey=new N(new D(211,211,211,1)),N.transparent=new N(new D(0,0,0,0)),function(h){let a;(function(l){let g;(function(E){function m(i){return i.rgba.a===1?`rgb(${i.rgba.r}, ${i.rgba.g}, ${i.rgba.b})`:h.Format.CSS.formatRGBA(i)}E.formatRGB=m;function b(i){return`rgba(${i.rgba.r}, ${i.rgba.g}, ${i.rgba.b}, ${+i.rgba.a.toFixed(2)})`}E.formatRGBA=b;function e(i){return i.hsla.a===1?`hsl(${i.hsla.h}, ${(i.hsla.s*100).toFixed(2)}%, ${(i.hsla.l*100).toFixed(2)}%)`:h.Format.CSS.formatHSLA(i)}E.formatHSL=e;function L(i){return`hsla(${i.hsla.h}, ${(i.hsla.s*100).toFixed(2)}%, ${(i.hsla.l*100).toFixed(2)}%, ${i.hsla.a.toFixed(2)})`}E.formatHSLA=L;function A(i){const u=i.toString(16);return u.length!==2?"0"+u:u}function p(i){return`#${A(i.rgba.r)}${A(i.rgba.g)}${A(i.rgba.b)}`}E.formatHex=p;function $(i,u=!1){return u&&i.rgba.a===1?h.Format.CSS.formatHex(i):`#${A(i.rgba.r)}${A(i.rgba.g)}${A(i.rgba.b)}${A(Math.round(i.rgba.a*255))}`}E.formatHexA=$;function o(i){return i.isOpaque()?h.Format.CSS.formatHex(i):h.Format.CSS.formatRGBA(i)}E.format=o;function c(i){const u=i.length;if(u===0||i.charCodeAt(0)!==35)return null;if(u===7){const w=16*s(i.charCodeAt(1))+s(i.charCodeAt(2)),d=16*s(i.charCodeAt(3))+s(i.charCodeAt(4)),v=16*s(i.charCodeAt(5))+s(i.charCodeAt(6));return new h(new D(w,d,v,1))}if(u===9){const w=16*s(i.charCodeAt(1))+s(i.charCodeAt(2)),d=16*s(i.charCodeAt(3))+s(i.charCodeAt(4)),v=16*s(i.charCodeAt(5))+s(i.charCodeAt(6)),R=16*s(i.charCodeAt(7))+s(i.charCodeAt(8));return new h(new D(w,d,v,R/255))}if(u===4){const w=s(i.charCodeAt(1)),d=s(i.charCodeAt(2)),v=s(i.charCodeAt(3));return new h(new D(16*w+w,16*d+d,16*v+v))}if(u===5){const w=s(i.charCodeAt(1)),d=s(i.charCodeAt(2)),v=s(i.charCodeAt(3)),R=s(i.charCodeAt(4));return new h(new D(16*w+w,16*d+d,16*v+v,(16*R+R)/255))}return null}E.parseHex=c;function s(i){switch(i){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(g=l.CSS||(l.CSS={}))})(a=h.Format||(h.Format={}))}(N||(t.$3s=N={}))}),ne(ie[36],se([0,1]),function(O,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Bs=void 0;class k{constructor(r,f,N,h){this.originalStart=r,this.originalLength=f,this.modifiedStart=N,this.modifiedLength=h}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}t.$Bs=k}),ne(ie[3],se([0,1]),function(O,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$cb=t.$bb=t.$ab=t.$_=t.$$=t.$0=t.$9=t.$8=t.$7=t.$6=t.$5=t.$4=t.$3=t.$2=t.$1=t.$Z=t.setUnexpectedErrorHandler=t.$X=t.$W=void 0;class k{constructor(){this.b=[],this.a=function(i){setTimeout(()=>{throw i.stack?o.isErrorNoTelemetry(i)?new o(i.message+`

`+i.stack):new Error(i.message+`

`+i.stack):i},0)}}addListener(i){return this.b.push(i),()=>{this.d(i)}}c(i){this.b.forEach(u=>{u(i)})}d(i){this.b.splice(this.b.indexOf(i),1)}setUnexpectedErrorHandler(i){this.a=i}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(i){this.a(i),this.c(i)}onUnexpectedExternalError(i){this.a(i)}}t.$W=k,t.$X=new k;function D(s){t.$X.setUnexpectedErrorHandler(s)}t.setUnexpectedErrorHandler=D;function r(s){if(!s||typeof s!="object")return!1;const i=s;return i.code==="EPIPE"&&i.syscall?.toUpperCase()==="WRITE"}t.$Z=r;function f(s){l(s)||t.$X.onUnexpectedError(s)}t.$1=f;function N(s){l(s)||t.$X.onUnexpectedExternalError(s)}t.$2=N;function h(s){if(s instanceof Error){const{name:i,message:u}=s,w=s.stacktrace||s.stack;return{$isError:!0,name:i,message:u,stack:w,noTelemetry:o.isErrorNoTelemetry(s)}}return s}t.$3=h;const a="Canceled";function l(s){return s instanceof g?!0:s instanceof Error&&s.name===a&&s.message===a}t.$4=l;class g extends Error{constructor(){super(a),this.name=this.message}}t.$5=g;function E(){const s=new Error(a);return s.name=s.message,s}t.$6=E;function m(s){return s?new Error(`Illegal argument: ${s}`):new Error("Illegal argument")}t.$7=m;function b(s){return s?new Error(`Illegal state: ${s}`):new Error("Illegal state")}t.$8=b;class e extends TypeError{constructor(i){super(i?`${i} is read-only and cannot be changed`:"Cannot change read-only property")}}t.$9=e;function L(s){return s?s.message?s.message:s.stack?s.stack.split(`
`)[0]:String(s):"Error"}t.$0=L;class A extends Error{constructor(i){super("NotImplemented"),i&&(this.message=i)}}t.$$=A;class p extends Error{constructor(i){super("NotSupported"),i&&(this.message=i)}}t.$_=p;class $ extends Error{constructor(){super(...arguments),this.isExpected=!0}}t.$ab=$;class o extends Error{constructor(i){super(i),this.name="CodeExpectedError"}static fromError(i){if(i instanceof o)return i;const u=new o;return u.message=i.message,u.stack=i.stack,u}static isErrorNoTelemetry(i){return i.name==="CodeExpectedError"}}t.$bb=o;class c extends Error{constructor(i){super(i||"An unexpected bug occurred."),Object.setPrototypeOf(this,c.prototype)}}t.$cb=c}),ne(ie[6],se([0,1,3,9]),function(O,t,k,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ac=t.$_b=t.$$b=t.$0b=t.$9b=t.$8b=t.$7b=t.CompareResult=t.$6b=t.$5b=t.$4b=t.$3b=t.$2b=t.$1b=t.$Zb=t.$Yb=t.$Xb=t.$Wb=t.$Vb=t.$Ub=t.$Tb=t.$Sb=t.$Rb=t.$Qb=t.$Pb=t.$Ob=t.$Nb=t.$Mb=t.$Lb=t.$Kb=t.$Jb=t.$Ib=t.$Hb=t.$Gb=t.top=t.$Eb=t.$Db=t.$Cb=t.$Bb=t.$Ab=t.$zb=t.$yb=t.$xb=t.$wb=t.$vb=t.$ub=t.$tb=t.$sb=void 0;function r(B,C=0){return B[B.length-(1+C)]}t.$sb=r;function f(B){if(B.length===0)throw new Error("Invalid tail call");return[B.slice(0,B.length-1),B[B.length-1]]}t.$tb=f;function N(B,C,j=(X,ee)=>X===ee){if(B===C)return!0;if(!B||!C||B.length!==C.length)return!1;for(let X=0,ee=B.length;X<ee;X++)if(!j(B[X],C[X]))return!1;return!0}t.$ub=N;function h(B,C){const j=B.length-1;C<j&&(B[C]=B[j]),B.pop()}t.$vb=h;function a(B,C,j){return l(B.length,X=>j(B[X],C))}t.$wb=a;function l(B,C){let j=0,X=B-1;for(;j<=X;){const ee=(j+X)/2|0,G=C(ee);if(G<0)j=ee+1;else if(G>0)X=ee-1;else return ee}return-(j+1)}t.$xb=l;function g(B,C,j){if(B=B|0,B>=C.length)throw new TypeError("invalid index");const X=C[Math.floor(C.length*Math.random())],ee=[],G=[],Z=[];for(const K of C){const Q=j(K,X);Q<0?ee.push(K):Q>0?G.push(K):Z.push(K)}return B<ee.length?g(B,ee,j):B<ee.length+Z.length?Z[0]:g(B-(ee.length+Z.length),G,j)}t.$yb=g;function E(B,C){const j=[];let X;for(const ee of B.slice(0).sort(C))!X||C(X[0],ee)!==0?(X=[ee],j.push(X)):X.push(ee);return j}t.$zb=E;function*m(B,C){let j,X;for(const ee of B)X!==void 0&&C(X,ee)?j.push(ee):(j&&(yield j),j=[ee]),X=ee;j&&(yield j)}t.$Ab=m;function b(B,C){for(let j=0;j<=B.length;j++)C(j===0?void 0:B[j-1],j===B.length?void 0:B[j])}t.$Bb=b;function e(B,C){for(let j=0;j<B.length;j++)C(j===0?void 0:B[j-1],B[j],j+1===B.length?void 0:B[j+1])}t.$Cb=e;function L(B,C,j){const X=[];function ee(K,Q,re){if(Q===0&&re.length===0)return;const le=X[X.length-1];le&&le.start+le.deleteCount===K?(le.deleteCount+=Q,le.toInsert.push(...re)):X.push({start:K,deleteCount:Q,toInsert:re})}let G=0,Z=0;for(;;){if(G===B.length){ee(G,0,C.slice(Z));break}if(Z===C.length){ee(G,B.length-G,[]);break}const K=B[G],Q=C[Z],re=j(K,Q);re===0?(G+=1,Z+=1):re<0?(ee(G,1,[]),G+=1):re>0&&(ee(G,0,[Q]),Z+=1)}return X}t.$Db=L;function A(B,C,j){const X=L(B,C,j),ee=[],G=[];for(const Z of X)ee.push(...B.slice(Z.start,Z.start+Z.deleteCount)),G.push(...Z.toInsert);return{removed:ee,added:G}}t.$Eb=A;function p(B,C,j){if(j===0)return[];const X=B.slice(0,j).sort(C);return o(B,C,X,j,B.length),X}t.top=p;function $(B,C,j,X,ee){return j===0?Promise.resolve([]):new Promise((G,Z)=>{(async()=>{const K=B.length,Q=B.slice(0,j).sort(C);for(let re=j,le=Math.min(j+X,K);re<K;re=le,le=Math.min(le+X,K)){if(re>j&&await new Promise(oe=>setTimeout(oe)),ee&&ee.isCancellationRequested)throw new k.$5;o(B,C,Q,re,le)}return Q})().then(G,Z)})}t.$Gb=$;function o(B,C,j,X,ee){for(const G=j.length;X<ee;X++){const Z=B[X];if(C(Z,j[G-1])<0){j.pop();const K=(0,D.$kb)(j,Q=>C(Z,Q)<0);j.splice(K,0,Z)}}}function c(B){return B.filter(C=>!!C)}t.$Hb=c;function s(B){let C=0;for(let j=0;j<B.length;j++)B[j]&&(B[C]=B[j],C+=1);B.length=C}t.$Ib=s;function i(B,C,j){B.splice(j,0,B.splice(C,1)[0])}t.$Jb=i;function u(B){return!Array.isArray(B)||B.length===0}t.$Kb=u;function w(B){return Array.isArray(B)&&B.length>0}t.$Lb=w;function d(B,C=j=>j){const j=new Set;return B.filter(X=>{const ee=C(X);return j.has(ee)?!1:(j.add(ee),!0)})}t.$Mb=d;function v(B){const C=new Set;return j=>{const X=B(j);return C.has(X)?!1:(C.add(X),!0)}}t.$Nb=v;function R(B,C){return B.length>0?B[0]:C}t.$Ob=R;function M(B,C){return B.length>0?B[B.length-1]:C}t.$Pb=M;function P(B,C,j=(X,ee)=>X===ee){let X=0;for(let ee=0,G=Math.min(B.length,C.length);ee<G&&j(B[ee],C[ee]);ee++)X++;return X}t.$Qb=P;function _(B){return[].concat(...B)}t.$Rb=_;function F(B,C){let j=typeof C=="number"?B:0;typeof C=="number"?j=B:(j=0,C=B);const X=[];if(j<=C)for(let ee=j;ee<C;ee++)X.push(ee);else for(let ee=j;ee>C;ee--)X.push(ee);return X}t.$Sb=F;function y(B,C,j){return B.reduce((X,ee)=>(X[C(ee)]=j?j(ee):ee,X),Object.create(null))}t.$Tb=y;function I(B,C){return B.push(C),()=>q(B,C)}t.$Ub=I;function q(B,C){const j=B.indexOf(C);if(j>-1)return B.splice(j,1),C}t.$Vb=q;function x(B,C,j){const X=B.slice(0,C),ee=B.slice(C);return X.concat(j,ee)}t.$Wb=x;function T(B,C){let j;if(typeof C=="number"){let X=C;j=()=>{const ee=Math.sin(X++)*179426549;return ee-Math.floor(ee)}}else j=Math.random;for(let X=B.length-1;X>0;X-=1){const ee=Math.floor(j()*(X+1)),G=B[X];B[X]=B[ee],B[ee]=G}}t.$Xb=T;function V(B,C){const j=B.indexOf(C);j>-1&&(B.splice(j,1),B.unshift(C))}t.$Yb=V;function H(B,C){const j=B.indexOf(C);j>-1&&(B.splice(j,1),B.push(C))}t.$Zb=H;function W(B,C){for(const j of C)B.push(j)}t.$1b=W;function J(B,C){return Array.isArray(B)?B.map(C):C(B)}t.$2b=J;function n(B){return Array.isArray(B)?B:[B]}t.$3b=n;function te(B){return B[Math.floor(Math.random()*B.length)]}t.$4b=te;function ce(B,C,j){const X=Ne(B,C),ee=B.length,G=j.length;B.length=ee+G;for(let Z=ee-1;Z>=X;Z--)B[Z+G]=B[Z];for(let Z=0;Z<G;Z++)B[Z+X]=j[Z]}t.$5b=ce;function me(B,C,j,X){const ee=Ne(B,C);let G=B.splice(ee,j);return G===void 0&&(G=[]),ce(B,ee,X),G}t.$6b=me;function Ne(B,C){return C<0?Math.max(C+B.length,0):Math.min(C,B.length)}var we;(function(B){function C(G){return G<0}B.isLessThan=C;function j(G){return G<=0}B.isLessThanOrEqual=j;function X(G){return G>0}B.isGreaterThan=X;function ee(G){return G===0}B.isNeitherLessOrGreaterThan=ee,B.greaterThan=1,B.lessThan=-1,B.neitherLessOrGreaterThan=0})(we||(t.CompareResult=we={}));function Ee(B,C){return(j,X)=>C(B(j),B(X))}t.$7b=Ee;function ve(...B){return(C,j)=>{for(const X of B){const ee=X(C,j);if(!we.isNeitherLessOrGreaterThan(ee))return ee}return we.neitherLessOrGreaterThan}}t.$8b=ve;const De=(B,C)=>B-C;t.$9b=De;const _e=(B,C)=>(0,t.$9b)(B?1:0,C?1:0);t.$0b=_e;function Te(B){return(C,j)=>-B(C,j)}t.$$b=Te;class Se{constructor(C){this.g=C,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(C){let j=this.c;for(;j<this.g.length&&C(this.g[j]);)j++;const X=j===this.c?null:this.g.slice(this.c,j);return this.c=j,X}takeFromEndWhile(C){let j=this.d;for(;j>=0&&C(this.g[j]);)j--;const X=j===this.d?null:this.g.slice(j+1,this.d+1);return this.d=j,X}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const C=this.g[this.c];return this.c++,C}removeLast(){const C=this.g[this.d];return this.d--,C}takeCount(C){const j=this.g.slice(this.c,this.c+C);return this.c+=C,j}}t.$_b=Se;class Ae{constructor(C){this.iterate=C}forEach(C){this.iterate(j=>(C(j),!0))}toArray(){const C=[];return this.iterate(j=>(C.push(j),!0)),C}filter(C){return new Ae(j=>this.iterate(X=>C(X)?j(X):!0))}map(C){return new Ae(j=>this.iterate(X=>j(C(X))))}some(C){let j=!1;return this.iterate(X=>(j=C(X),!j)),j}findFirst(C){let j;return this.iterate(X=>C(X)?(j=X,!1):!0),j}findLast(C){let j;return this.iterate(X=>(C(X)&&(j=X),!0)),j}findLastMaxBy(C){let j,X=!0;return this.iterate(ee=>((X||we.isGreaterThan(C(ee,j)))&&(X=!1,j=ee),!0)),j}}t.$ac=Ae,Ae.empty=new Ae(B=>{})}),ne(ie[13],se([0,1,3]),function(O,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$7c=t.$6c=t.$5c=t.$4c=t.ok=void 0;function D(a,l){if(!a)throw new Error(l?`Assertion failed (${l})`:"Assertion Failed")}t.ok=D;function r(a,l="Unreachable"){throw new Error(l)}t.$4c=r;function f(a){if(!a)throw new k.$cb("Assertion Failed")}t.$5c=f;function N(a){if(!a()){debugger;a(),(0,k.$1)(new k.$cb("Assertion Failed"))}}t.$6c=N;function h(a,l){let g=0;for(;g<a.length-1;){const E=a[g],m=a[g+1];if(!l(E,m))return!1;g++}return!0}t.$7c=h}),ne(ie[19],se([0,1]),function(O,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$db=void 0;function k(D){const r=this;let f=!1,N;return function(){return f||(f=!0,N=D.apply(r,arguments)),N}}t.$db=k}),ne(ie[20],se([0,1]),function(O,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Iterable=void 0;var k;(function(D){function r(s){return s&&typeof s=="object"&&typeof s[Symbol.iterator]=="function"}D.is=r;const f=Object.freeze([]);function N(){return f}D.empty=N;function*h(s){yield s}D.single=h;function a(s){return r(s)?s:h(s)}D.wrap=a;function l(s){return s||f}D.from=l;function*g(s){for(let i=s.length-1;i>=0;i--)yield s[i]}D.reverse=g;function E(s){return!s||s[Symbol.iterator]().next().done===!0}D.isEmpty=E;function m(s){return s[Symbol.iterator]().next().value}D.first=m;function b(s,i){for(const u of s)if(i(u))return!0;return!1}D.some=b;function e(s,i){for(const u of s)if(i(u))return u}D.find=e;function*L(s,i){for(const u of s)i(u)&&(yield u)}D.filter=L;function*A(s,i){let u=0;for(const w of s)yield i(w,u++)}D.map=A;function*p(...s){for(const i of s)for(const u of i)yield u}D.concat=p;function $(s,i,u){let w=u;for(const d of s)w=i(w,d);return w}D.reduce=$;function*o(s,i,u=s.length){for(i<0&&(i+=s.length),u<0?u+=s.length:u>s.length&&(u=s.length);i<u;i++)yield s[i]}D.slice=o;function c(s,i=Number.POSITIVE_INFINITY){const u=[];if(i===0)return[u,s];const w=s[Symbol.iterator]();for(let d=0;d<i;d++){const v=w.next();if(v.done)return[u,D.empty()];u.push(v.value)}return[u,{[Symbol.iterator](){return w}}]}D.consume=c})(k||(t.Iterable=k={}))}),ne(ie[37],se([0,1]),function(O,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Kq=t.KeyMod=t.KeyCodeUtils=t.$Jq=t.$Iq=t.$Hq=t.$Gq=t.$Fq=t.ScanCode=t.KeyCode=void 0;var k;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.Digit0=21]="Digit0",e[e.Digit1=22]="Digit1",e[e.Digit2=23]="Digit2",e[e.Digit3=24]="Digit3",e[e.Digit4=25]="Digit4",e[e.Digit5=26]="Digit5",e[e.Digit6=27]="Digit6",e[e.Digit7=28]="Digit7",e[e.Digit8=29]="Digit8",e[e.Digit9=30]="Digit9",e[e.KeyA=31]="KeyA",e[e.KeyB=32]="KeyB",e[e.KeyC=33]="KeyC",e[e.KeyD=34]="KeyD",e[e.KeyE=35]="KeyE",e[e.KeyF=36]="KeyF",e[e.KeyG=37]="KeyG",e[e.KeyH=38]="KeyH",e[e.KeyI=39]="KeyI",e[e.KeyJ=40]="KeyJ",e[e.KeyK=41]="KeyK",e[e.KeyL=42]="KeyL",e[e.KeyM=43]="KeyM",e[e.KeyN=44]="KeyN",e[e.KeyO=45]="KeyO",e[e.KeyP=46]="KeyP",e[e.KeyQ=47]="KeyQ",e[e.KeyR=48]="KeyR",e[e.KeyS=49]="KeyS",e[e.KeyT=50]="KeyT",e[e.KeyU=51]="KeyU",e[e.KeyV=52]="KeyV",e[e.KeyW=53]="KeyW",e[e.KeyX=54]="KeyX",e[e.KeyY=55]="KeyY",e[e.KeyZ=56]="KeyZ",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.F20=78]="F20",e[e.F21=79]="F21",e[e.F22=80]="F22",e[e.F23=81]="F23",e[e.F24=82]="F24",e[e.NumLock=83]="NumLock",e[e.ScrollLock=84]="ScrollLock",e[e.Semicolon=85]="Semicolon",e[e.Equal=86]="Equal",e[e.Comma=87]="Comma",e[e.Minus=88]="Minus",e[e.Period=89]="Period",e[e.Slash=90]="Slash",e[e.Backquote=91]="Backquote",e[e.BracketLeft=92]="BracketLeft",e[e.Backslash=93]="Backslash",e[e.BracketRight=94]="BracketRight",e[e.Quote=95]="Quote",e[e.OEM_8=96]="OEM_8",e[e.IntlBackslash=97]="IntlBackslash",e[e.Numpad0=98]="Numpad0",e[e.Numpad1=99]="Numpad1",e[e.Numpad2=100]="Numpad2",e[e.Numpad3=101]="Numpad3",e[e.Numpad4=102]="Numpad4",e[e.Numpad5=103]="Numpad5",e[e.Numpad6=104]="Numpad6",e[e.Numpad7=105]="Numpad7",e[e.Numpad8=106]="Numpad8",e[e.Numpad9=107]="Numpad9",e[e.NumpadMultiply=108]="NumpadMultiply",e[e.NumpadAdd=109]="NumpadAdd",e[e.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",e[e.NumpadSubtract=111]="NumpadSubtract",e[e.NumpadDecimal=112]="NumpadDecimal",e[e.NumpadDivide=113]="NumpadDivide",e[e.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",e[e.ABNT_C1=115]="ABNT_C1",e[e.ABNT_C2=116]="ABNT_C2",e[e.AudioVolumeMute=117]="AudioVolumeMute",e[e.AudioVolumeUp=118]="AudioVolumeUp",e[e.AudioVolumeDown=119]="AudioVolumeDown",e[e.BrowserSearch=120]="BrowserSearch",e[e.BrowserHome=121]="BrowserHome",e[e.BrowserBack=122]="BrowserBack",e[e.BrowserForward=123]="BrowserForward",e[e.MediaTrackNext=124]="MediaTrackNext",e[e.MediaTrackPrevious=125]="MediaTrackPrevious",e[e.MediaStop=126]="MediaStop",e[e.MediaPlayPause=127]="MediaPlayPause",e[e.LaunchMediaPlayer=128]="LaunchMediaPlayer",e[e.LaunchMail=129]="LaunchMail",e[e.LaunchApp2=130]="LaunchApp2",e[e.Clear=131]="Clear",e[e.MAX_VALUE=132]="MAX_VALUE"})(k||(t.KeyCode=k={}));var D;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.None=0]="None",e[e.Hyper=1]="Hyper",e[e.Super=2]="Super",e[e.Fn=3]="Fn",e[e.FnLock=4]="FnLock",e[e.Suspend=5]="Suspend",e[e.Resume=6]="Resume",e[e.Turbo=7]="Turbo",e[e.Sleep=8]="Sleep",e[e.WakeUp=9]="WakeUp",e[e.KeyA=10]="KeyA",e[e.KeyB=11]="KeyB",e[e.KeyC=12]="KeyC",e[e.KeyD=13]="KeyD",e[e.KeyE=14]="KeyE",e[e.KeyF=15]="KeyF",e[e.KeyG=16]="KeyG",e[e.KeyH=17]="KeyH",e[e.KeyI=18]="KeyI",e[e.KeyJ=19]="KeyJ",e[e.KeyK=20]="KeyK",e[e.KeyL=21]="KeyL",e[e.KeyM=22]="KeyM",e[e.KeyN=23]="KeyN",e[e.KeyO=24]="KeyO",e[e.KeyP=25]="KeyP",e[e.KeyQ=26]="KeyQ",e[e.KeyR=27]="KeyR",e[e.KeyS=28]="KeyS",e[e.KeyT=29]="KeyT",e[e.KeyU=30]="KeyU",e[e.KeyV=31]="KeyV",e[e.KeyW=32]="KeyW",e[e.KeyX=33]="KeyX",e[e.KeyY=34]="KeyY",e[e.KeyZ=35]="KeyZ",e[e.Digit1=36]="Digit1",e[e.Digit2=37]="Digit2",e[e.Digit3=38]="Digit3",e[e.Digit4=39]="Digit4",e[e.Digit5=40]="Digit5",e[e.Digit6=41]="Digit6",e[e.Digit7=42]="Digit7",e[e.Digit8=43]="Digit8",e[e.Digit9=44]="Digit9",e[e.Digit0=45]="Digit0",e[e.Enter=46]="Enter",e[e.Escape=47]="Escape",e[e.Backspace=48]="Backspace",e[e.Tab=49]="Tab",e[e.Space=50]="Space",e[e.Minus=51]="Minus",e[e.Equal=52]="Equal",e[e.BracketLeft=53]="BracketLeft",e[e.BracketRight=54]="BracketRight",e[e.Backslash=55]="Backslash",e[e.IntlHash=56]="IntlHash",e[e.Semicolon=57]="Semicolon",e[e.Quote=58]="Quote",e[e.Backquote=59]="Backquote",e[e.Comma=60]="Comma",e[e.Period=61]="Period",e[e.Slash=62]="Slash",e[e.CapsLock=63]="CapsLock",e[e.F1=64]="F1",e[e.F2=65]="F2",e[e.F3=66]="F3",e[e.F4=67]="F4",e[e.F5=68]="F5",e[e.F6=69]="F6",e[e.F7=70]="F7",e[e.F8=71]="F8",e[e.F9=72]="F9",e[e.F10=73]="F10",e[e.F11=74]="F11",e[e.F12=75]="F12",e[e.PrintScreen=76]="PrintScreen",e[e.ScrollLock=77]="ScrollLock",e[e.Pause=78]="Pause",e[e.Insert=79]="Insert",e[e.Home=80]="Home",e[e.PageUp=81]="PageUp",e[e.Delete=82]="Delete",e[e.End=83]="End",e[e.PageDown=84]="PageDown",e[e.ArrowRight=85]="ArrowRight",e[e.ArrowLeft=86]="ArrowLeft",e[e.ArrowDown=87]="ArrowDown",e[e.ArrowUp=88]="ArrowUp",e[e.NumLock=89]="NumLock",e[e.NumpadDivide=90]="NumpadDivide",e[e.NumpadMultiply=91]="NumpadMultiply",e[e.NumpadSubtract=92]="NumpadSubtract",e[e.NumpadAdd=93]="NumpadAdd",e[e.NumpadEnter=94]="NumpadEnter",e[e.Numpad1=95]="Numpad1",e[e.Numpad2=96]="Numpad2",e[e.Numpad3=97]="Numpad3",e[e.Numpad4=98]="Numpad4",e[e.Numpad5=99]="Numpad5",e[e.Numpad6=100]="Numpad6",e[e.Numpad7=101]="Numpad7",e[e.Numpad8=102]="Numpad8",e[e.Numpad9=103]="Numpad9",e[e.Numpad0=104]="Numpad0",e[e.NumpadDecimal=105]="NumpadDecimal",e[e.IntlBackslash=106]="IntlBackslash",e[e.ContextMenu=107]="ContextMenu",e[e.Power=108]="Power",e[e.NumpadEqual=109]="NumpadEqual",e[e.F13=110]="F13",e[e.F14=111]="F14",e[e.F15=112]="F15",e[e.F16=113]="F16",e[e.F17=114]="F17",e[e.F18=115]="F18",e[e.F19=116]="F19",e[e.F20=117]="F20",e[e.F21=118]="F21",e[e.F22=119]="F22",e[e.F23=120]="F23",e[e.F24=121]="F24",e[e.Open=122]="Open",e[e.Help=123]="Help",e[e.Select=124]="Select",e[e.Again=125]="Again",e[e.Undo=126]="Undo",e[e.Cut=127]="Cut",e[e.Copy=128]="Copy",e[e.Paste=129]="Paste",e[e.Find=130]="Find",e[e.AudioVolumeMute=131]="AudioVolumeMute",e[e.AudioVolumeUp=132]="AudioVolumeUp",e[e.AudioVolumeDown=133]="AudioVolumeDown",e[e.NumpadComma=134]="NumpadComma",e[e.IntlRo=135]="IntlRo",e[e.KanaMode=136]="KanaMode",e[e.IntlYen=137]="IntlYen",e[e.Convert=138]="Convert",e[e.NonConvert=139]="NonConvert",e[e.Lang1=140]="Lang1",e[e.Lang2=141]="Lang2",e[e.Lang3=142]="Lang3",e[e.Lang4=143]="Lang4",e[e.Lang5=144]="Lang5",e[e.Abort=145]="Abort",e[e.Props=146]="Props",e[e.NumpadParenLeft=147]="NumpadParenLeft",e[e.NumpadParenRight=148]="NumpadParenRight",e[e.NumpadBackspace=149]="NumpadBackspace",e[e.NumpadMemoryStore=150]="NumpadMemoryStore",e[e.NumpadMemoryRecall=151]="NumpadMemoryRecall",e[e.NumpadMemoryClear=152]="NumpadMemoryClear",e[e.NumpadMemoryAdd=153]="NumpadMemoryAdd",e[e.NumpadMemorySubtract=154]="NumpadMemorySubtract",e[e.NumpadClear=155]="NumpadClear",e[e.NumpadClearEntry=156]="NumpadClearEntry",e[e.ControlLeft=157]="ControlLeft",e[e.ShiftLeft=158]="ShiftLeft",e[e.AltLeft=159]="AltLeft",e[e.MetaLeft=160]="MetaLeft",e[e.ControlRight=161]="ControlRight",e[e.ShiftRight=162]="ShiftRight",e[e.AltRight=163]="AltRight",e[e.MetaRight=164]="MetaRight",e[e.BrightnessUp=165]="BrightnessUp",e[e.BrightnessDown=166]="BrightnessDown",e[e.MediaPlay=167]="MediaPlay",e[e.MediaRecord=168]="MediaRecord",e[e.MediaFastForward=169]="MediaFastForward",e[e.MediaRewind=170]="MediaRewind",e[e.MediaTrackNext=171]="MediaTrackNext",e[e.MediaTrackPrevious=172]="MediaTrackPrevious",e[e.MediaStop=173]="MediaStop",e[e.Eject=174]="Eject",e[e.MediaPlayPause=175]="MediaPlayPause",e[e.MediaSelect=176]="MediaSelect",e[e.LaunchMail=177]="LaunchMail",e[e.LaunchApp2=178]="LaunchApp2",e[e.LaunchApp1=179]="LaunchApp1",e[e.SelectTask=180]="SelectTask",e[e.LaunchScreenSaver=181]="LaunchScreenSaver",e[e.BrowserSearch=182]="BrowserSearch",e[e.BrowserHome=183]="BrowserHome",e[e.BrowserBack=184]="BrowserBack",e[e.BrowserForward=185]="BrowserForward",e[e.BrowserStop=186]="BrowserStop",e[e.BrowserRefresh=187]="BrowserRefresh",e[e.BrowserFavorites=188]="BrowserFavorites",e[e.ZoomToggle=189]="ZoomToggle",e[e.MailReply=190]="MailReply",e[e.MailForward=191]="MailForward",e[e.MailSend=192]="MailSend",e[e.MAX_VALUE=193]="MAX_VALUE"})(D||(t.ScanCode=D={}));class r{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(L,A){this._keyCodeToStr[L]=A,this._strToKeyCode[A.toLowerCase()]=L}keyCodeToStr(L){return this._keyCodeToStr[L]}strToKeyCode(L){return this._strToKeyCode[L.toLowerCase()]||0}}const f=new r,N=new r,h=new r;t.$Fq=new Array(230),t.$Gq={};const a=[],l=Object.create(null),g=Object.create(null);t.$Hq={lowerCaseToEnum:e=>g[e]||0,toEnum:e=>l[e]||0,toString:e=>a[e]||"None"},t.$Iq=[],t.$Jq=[];for(let e=0;e<=193;e++)t.$Iq[e]=-1;for(let e=0;e<=132;e++)t.$Jq[e]=-1;(function(){const e="",L=[[1,0,"None",0,"unknown",0,"VK_UNKNOWN",e,e],[1,1,"Hyper",0,e,0,e,e,e],[1,2,"Super",0,e,0,e,e,e],[1,3,"Fn",0,e,0,e,e,e],[1,4,"FnLock",0,e,0,e,e,e],[1,5,"Suspend",0,e,0,e,e,e],[1,6,"Resume",0,e,0,e,e,e],[1,7,"Turbo",0,e,0,e,e,e],[1,8,"Sleep",0,e,0,"VK_SLEEP",e,e],[1,9,"WakeUp",0,e,0,e,e,e],[0,10,"KeyA",31,"A",65,"VK_A",e,e],[0,11,"KeyB",32,"B",66,"VK_B",e,e],[0,12,"KeyC",33,"C",67,"VK_C",e,e],[0,13,"KeyD",34,"D",68,"VK_D",e,e],[0,14,"KeyE",35,"E",69,"VK_E",e,e],[0,15,"KeyF",36,"F",70,"VK_F",e,e],[0,16,"KeyG",37,"G",71,"VK_G",e,e],[0,17,"KeyH",38,"H",72,"VK_H",e,e],[0,18,"KeyI",39,"I",73,"VK_I",e,e],[0,19,"KeyJ",40,"J",74,"VK_J",e,e],[0,20,"KeyK",41,"K",75,"VK_K",e,e],[0,21,"KeyL",42,"L",76,"VK_L",e,e],[0,22,"KeyM",43,"M",77,"VK_M",e,e],[0,23,"KeyN",44,"N",78,"VK_N",e,e],[0,24,"KeyO",45,"O",79,"VK_O",e,e],[0,25,"KeyP",46,"P",80,"VK_P",e,e],[0,26,"KeyQ",47,"Q",81,"VK_Q",e,e],[0,27,"KeyR",48,"R",82,"VK_R",e,e],[0,28,"KeyS",49,"S",83,"VK_S",e,e],[0,29,"KeyT",50,"T",84,"VK_T",e,e],[0,30,"KeyU",51,"U",85,"VK_U",e,e],[0,31,"KeyV",52,"V",86,"VK_V",e,e],[0,32,"KeyW",53,"W",87,"VK_W",e,e],[0,33,"KeyX",54,"X",88,"VK_X",e,e],[0,34,"KeyY",55,"Y",89,"VK_Y",e,e],[0,35,"KeyZ",56,"Z",90,"VK_Z",e,e],[0,36,"Digit1",22,"1",49,"VK_1",e,e],[0,37,"Digit2",23,"2",50,"VK_2",e,e],[0,38,"Digit3",24,"3",51,"VK_3",e,e],[0,39,"Digit4",25,"4",52,"VK_4",e,e],[0,40,"Digit5",26,"5",53,"VK_5",e,e],[0,41,"Digit6",27,"6",54,"VK_6",e,e],[0,42,"Digit7",28,"7",55,"VK_7",e,e],[0,43,"Digit8",29,"8",56,"VK_8",e,e],[0,44,"Digit9",30,"9",57,"VK_9",e,e],[0,45,"Digit0",21,"0",48,"VK_0",e,e],[1,46,"Enter",3,"Enter",13,"VK_RETURN",e,e],[1,47,"Escape",9,"Escape",27,"VK_ESCAPE",e,e],[1,48,"Backspace",1,"Backspace",8,"VK_BACK",e,e],[1,49,"Tab",2,"Tab",9,"VK_TAB",e,e],[1,50,"Space",10,"Space",32,"VK_SPACE",e,e],[0,51,"Minus",88,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[0,52,"Equal",86,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[0,53,"BracketLeft",92,"[",219,"VK_OEM_4","[","OEM_4"],[0,54,"BracketRight",94,"]",221,"VK_OEM_6","]","OEM_6"],[0,55,"Backslash",93,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,56,"IntlHash",0,e,0,e,e,e],[0,57,"Semicolon",85,";",186,"VK_OEM_1",";","OEM_1"],[0,58,"Quote",95,"'",222,"VK_OEM_7","'","OEM_7"],[0,59,"Backquote",91,"`",192,"VK_OEM_3","`","OEM_3"],[0,60,"Comma",87,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[0,61,"Period",89,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[0,62,"Slash",90,"/",191,"VK_OEM_2","/","OEM_2"],[1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",e,e],[1,64,"F1",59,"F1",112,"VK_F1",e,e],[1,65,"F2",60,"F2",113,"VK_F2",e,e],[1,66,"F3",61,"F3",114,"VK_F3",e,e],[1,67,"F4",62,"F4",115,"VK_F4",e,e],[1,68,"F5",63,"F5",116,"VK_F5",e,e],[1,69,"F6",64,"F6",117,"VK_F6",e,e],[1,70,"F7",65,"F7",118,"VK_F7",e,e],[1,71,"F8",66,"F8",119,"VK_F8",e,e],[1,72,"F9",67,"F9",120,"VK_F9",e,e],[1,73,"F10",68,"F10",121,"VK_F10",e,e],[1,74,"F11",69,"F11",122,"VK_F11",e,e],[1,75,"F12",70,"F12",123,"VK_F12",e,e],[1,76,"PrintScreen",0,e,0,e,e,e],[1,77,"ScrollLock",84,"ScrollLock",145,"VK_SCROLL",e,e],[1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",e,e],[1,79,"Insert",19,"Insert",45,"VK_INSERT",e,e],[1,80,"Home",14,"Home",36,"VK_HOME",e,e],[1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",e,e],[1,82,"Delete",20,"Delete",46,"VK_DELETE",e,e],[1,83,"End",13,"End",35,"VK_END",e,e],[1,84,"PageDown",12,"PageDown",34,"VK_NEXT",e,e],[1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",e],[1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",e],[1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",e],[1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",e],[1,89,"NumLock",83,"NumLock",144,"VK_NUMLOCK",e,e],[1,90,"NumpadDivide",113,"NumPad_Divide",111,"VK_DIVIDE",e,e],[1,91,"NumpadMultiply",108,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[1,92,"NumpadSubtract",111,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[1,93,"NumpadAdd",109,"NumPad_Add",107,"VK_ADD",e,e],[1,94,"NumpadEnter",3,e,0,e,e,e],[1,95,"Numpad1",99,"NumPad1",97,"VK_NUMPAD1",e,e],[1,96,"Numpad2",100,"NumPad2",98,"VK_NUMPAD2",e,e],[1,97,"Numpad3",101,"NumPad3",99,"VK_NUMPAD3",e,e],[1,98,"Numpad4",102,"NumPad4",100,"VK_NUMPAD4",e,e],[1,99,"Numpad5",103,"NumPad5",101,"VK_NUMPAD5",e,e],[1,100,"Numpad6",104,"NumPad6",102,"VK_NUMPAD6",e,e],[1,101,"Numpad7",105,"NumPad7",103,"VK_NUMPAD7",e,e],[1,102,"Numpad8",106,"NumPad8",104,"VK_NUMPAD8",e,e],[1,103,"Numpad9",107,"NumPad9",105,"VK_NUMPAD9",e,e],[1,104,"Numpad0",98,"NumPad0",96,"VK_NUMPAD0",e,e],[1,105,"NumpadDecimal",112,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[0,106,"IntlBackslash",97,"OEM_102",226,"VK_OEM_102",e,e],[1,107,"ContextMenu",58,"ContextMenu",93,e,e,e],[1,108,"Power",0,e,0,e,e,e],[1,109,"NumpadEqual",0,e,0,e,e,e],[1,110,"F13",71,"F13",124,"VK_F13",e,e],[1,111,"F14",72,"F14",125,"VK_F14",e,e],[1,112,"F15",73,"F15",126,"VK_F15",e,e],[1,113,"F16",74,"F16",127,"VK_F16",e,e],[1,114,"F17",75,"F17",128,"VK_F17",e,e],[1,115,"F18",76,"F18",129,"VK_F18",e,e],[1,116,"F19",77,"F19",130,"VK_F19",e,e],[1,117,"F20",78,"F20",131,"VK_F20",e,e],[1,118,"F21",79,"F21",132,"VK_F21",e,e],[1,119,"F22",80,"F22",133,"VK_F22",e,e],[1,120,"F23",81,"F23",134,"VK_F23",e,e],[1,121,"F24",82,"F24",135,"VK_F24",e,e],[1,122,"Open",0,e,0,e,e,e],[1,123,"Help",0,e,0,e,e,e],[1,124,"Select",0,e,0,e,e,e],[1,125,"Again",0,e,0,e,e,e],[1,126,"Undo",0,e,0,e,e,e],[1,127,"Cut",0,e,0,e,e,e],[1,128,"Copy",0,e,0,e,e,e],[1,129,"Paste",0,e,0,e,e,e],[1,130,"Find",0,e,0,e,e,e],[1,131,"AudioVolumeMute",117,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[1,132,"AudioVolumeUp",118,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[1,133,"AudioVolumeDown",119,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[1,134,"NumpadComma",110,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[0,135,"IntlRo",115,"ABNT_C1",193,"VK_ABNT_C1",e,e],[1,136,"KanaMode",0,e,0,e,e,e],[0,137,"IntlYen",0,e,0,e,e,e],[1,138,"Convert",0,e,0,e,e,e],[1,139,"NonConvert",0,e,0,e,e,e],[1,140,"Lang1",0,e,0,e,e,e],[1,141,"Lang2",0,e,0,e,e,e],[1,142,"Lang3",0,e,0,e,e,e],[1,143,"Lang4",0,e,0,e,e,e],[1,144,"Lang5",0,e,0,e,e,e],[1,145,"Abort",0,e,0,e,e,e],[1,146,"Props",0,e,0,e,e,e],[1,147,"NumpadParenLeft",0,e,0,e,e,e],[1,148,"NumpadParenRight",0,e,0,e,e,e],[1,149,"NumpadBackspace",0,e,0,e,e,e],[1,150,"NumpadMemoryStore",0,e,0,e,e,e],[1,151,"NumpadMemoryRecall",0,e,0,e,e,e],[1,152,"NumpadMemoryClear",0,e,0,e,e,e],[1,153,"NumpadMemoryAdd",0,e,0,e,e,e],[1,154,"NumpadMemorySubtract",0,e,0,e,e,e],[1,155,"NumpadClear",131,"Clear",12,"VK_CLEAR",e,e],[1,156,"NumpadClearEntry",0,e,0,e,e,e],[1,0,e,5,"Ctrl",17,"VK_CONTROL",e,e],[1,0,e,4,"Shift",16,"VK_SHIFT",e,e],[1,0,e,6,"Alt",18,"VK_MENU",e,e],[1,0,e,57,"Meta",91,"VK_COMMAND",e,e],[1,157,"ControlLeft",5,e,0,"VK_LCONTROL",e,e],[1,158,"ShiftLeft",4,e,0,"VK_LSHIFT",e,e],[1,159,"AltLeft",6,e,0,"VK_LMENU",e,e],[1,160,"MetaLeft",57,e,0,"VK_LWIN",e,e],[1,161,"ControlRight",5,e,0,"VK_RCONTROL",e,e],[1,162,"ShiftRight",4,e,0,"VK_RSHIFT",e,e],[1,163,"AltRight",6,e,0,"VK_RMENU",e,e],[1,164,"MetaRight",57,e,0,"VK_RWIN",e,e],[1,165,"BrightnessUp",0,e,0,e,e,e],[1,166,"BrightnessDown",0,e,0,e,e,e],[1,167,"MediaPlay",0,e,0,e,e,e],[1,168,"MediaRecord",0,e,0,e,e,e],[1,169,"MediaFastForward",0,e,0,e,e,e],[1,170,"MediaRewind",0,e,0,e,e,e],[1,171,"MediaTrackNext",124,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[1,172,"MediaTrackPrevious",125,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[1,173,"MediaStop",126,"MediaStop",178,"VK_MEDIA_STOP",e,e],[1,174,"Eject",0,e,0,e,e,e],[1,175,"MediaPlayPause",127,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[1,176,"MediaSelect",128,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[1,177,"LaunchMail",129,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[1,178,"LaunchApp2",130,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[1,179,"LaunchApp1",0,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[1,180,"SelectTask",0,e,0,e,e,e],[1,181,"LaunchScreenSaver",0,e,0,e,e,e],[1,182,"BrowserSearch",120,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[1,183,"BrowserHome",121,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[1,184,"BrowserBack",122,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[1,185,"BrowserForward",123,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[1,186,"BrowserStop",0,e,0,"VK_BROWSER_STOP",e,e],[1,187,"BrowserRefresh",0,e,0,"VK_BROWSER_REFRESH",e,e],[1,188,"BrowserFavorites",0,e,0,"VK_BROWSER_FAVORITES",e,e],[1,189,"ZoomToggle",0,e,0,e,e,e],[1,190,"MailReply",0,e,0,e,e,e],[1,191,"MailForward",0,e,0,e,e,e],[1,192,"MailSend",0,e,0,e,e,e],[1,0,e,114,"KeyInComposition",229,e,e,e],[1,0,e,116,"ABNT_C2",194,"VK_ABNT_C2",e,e],[1,0,e,96,"OEM_8",223,"VK_OEM_8",e,e],[1,0,e,0,e,0,"VK_KANA",e,e],[1,0,e,0,e,0,"VK_HANGUL",e,e],[1,0,e,0,e,0,"VK_JUNJA",e,e],[1,0,e,0,e,0,"VK_FINAL",e,e],[1,0,e,0,e,0,"VK_HANJA",e,e],[1,0,e,0,e,0,"VK_KANJI",e,e],[1,0,e,0,e,0,"VK_CONVERT",e,e],[1,0,e,0,e,0,"VK_NONCONVERT",e,e],[1,0,e,0,e,0,"VK_ACCEPT",e,e],[1,0,e,0,e,0,"VK_MODECHANGE",e,e],[1,0,e,0,e,0,"VK_SELECT",e,e],[1,0,e,0,e,0,"VK_PRINT",e,e],[1,0,e,0,e,0,"VK_EXECUTE",e,e],[1,0,e,0,e,0,"VK_SNAPSHOT",e,e],[1,0,e,0,e,0,"VK_HELP",e,e],[1,0,e,0,e,0,"VK_APPS",e,e],[1,0,e,0,e,0,"VK_PROCESSKEY",e,e],[1,0,e,0,e,0,"VK_PACKET",e,e],[1,0,e,0,e,0,"VK_DBE_SBCSCHAR",e,e],[1,0,e,0,e,0,"VK_DBE_DBCSCHAR",e,e],[1,0,e,0,e,0,"VK_ATTN",e,e],[1,0,e,0,e,0,"VK_CRSEL",e,e],[1,0,e,0,e,0,"VK_EXSEL",e,e],[1,0,e,0,e,0,"VK_EREOF",e,e],[1,0,e,0,e,0,"VK_PLAY",e,e],[1,0,e,0,e,0,"VK_ZOOM",e,e],[1,0,e,0,e,0,"VK_NONAME",e,e],[1,0,e,0,e,0,"VK_PA1",e,e],[1,0,e,0,e,0,"VK_OEM_CLEAR",e,e]],A=[],p=[];for(const $ of L){const[o,c,s,i,u,w,d,v,R]=$;if(p[c]||(p[c]=!0,a[c]=s,l[s]=c,g[s.toLowerCase()]=c,o&&(t.$Iq[c]=i,i!==0&&i!==3&&i!==5&&i!==4&&i!==6&&i!==57&&(t.$Jq[i]=c))),!A[i]){if(A[i]=!0,!u)throw new Error(`String representation missing for key code ${i} around scan code ${s}`);f.define(i,u),N.define(i,v||u),h.define(i,R||v||u)}w&&(t.$Fq[w]=i),d&&(t.$Gq[d]=i)}t.$Jq[3]=46})();var E;(function(e){function L(s){return f.keyCodeToStr(s)}e.toString=L;function A(s){return f.strToKeyCode(s)}e.fromString=A;function p(s){return N.keyCodeToStr(s)}e.toUserSettingsUS=p;function $(s){return h.keyCodeToStr(s)}e.toUserSettingsGeneral=$;function o(s){return N.strToKeyCode(s)||h.strToKeyCode(s)}e.fromUserSettings=o;function c(s){if(s>=98&&s<=113)return null;switch(s){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return f.keyCodeToStr(s)}e.toElectronAccelerator=c})(E||(t.KeyCodeUtils=E={}));var m;(function(e){e[e.CtrlCmd=2048]="CtrlCmd",e[e.Shift=1024]="Shift",e[e.Alt=512]="Alt",e[e.WinCtrl=256]="WinCtrl"})(m||(t.KeyMod=m={}));function b(e,L){const A=(L&65535)<<16>>>0;return(e|A)>>>0}t.$Kq=b}),ne(ie[38],se([0,1]),function(O,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$V=void 0;class k{constructor(r){this.d=r,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(r){this.c=r}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}t.$V=k}),ne(ie[21],se([0,1]),function(O,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$2c=void 0;class k{constructor(f){this.element=f,this.next=k.Undefined,this.prev=k.Undefined}}k.Undefined=new k(void 0);class D{constructor(){this.a=k.Undefined,this.b=k.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===k.Undefined}clear(){let f=this.a;for(;f!==k.Undefined;){const N=f.next;f.prev=k.Undefined,f.next=k.Undefined,f=N}this.a=k.Undefined,this.b=k.Undefined,this.c=0}unshift(f){return this.d(f,!1)}push(f){return this.d(f,!0)}d(f,N){const h=new k(f);if(this.a===k.Undefined)this.a=h,this.b=h;else if(N){const l=this.b;this.b=h,h.prev=l,l.next=h}else{const l=this.a;this.a=h,h.next=l,l.prev=h}this.c+=1;let a=!1;return()=>{a||(a=!0,this.e(h))}}shift(){if(this.a!==k.Undefined){const f=this.a.element;return this.e(this.a),f}}pop(){if(this.b!==k.Undefined){const f=this.b.element;return this.e(this.b),f}}e(f){if(f.prev!==k.Undefined&&f.next!==k.Undefined){const N=f.prev;N.next=f.next,f.next.prev=N}else f.prev===k.Undefined&&f.next===k.Undefined?(this.a=k.Undefined,this.b=k.Undefined):f.next===k.Undefined?(this.b=this.b.prev,this.b.next=k.Undefined):f.prev===k.Undefined&&(this.a=this.a.next,this.a.prev=k.Undefined);this.c-=1}*[Symbol.iterator](){let f=this.a;for(;f!==k.Undefined;)yield f.element,f=f.next}}t.$2c=D}),ne(ie[22],se([0,1]),function(O,t){"use strict";var k,D,r;Object.defineProperty(t,"__esModule",{value:!0}),t.$Gc=t.$Fc=t.$Ec=t.$Dc=t.$Cc=t.Touch=t.$Bc=t.$Ac=t.$zc=t.$yc=t.$xc=void 0;function f($,o,c){let s=$.get(o);return s===void 0&&(s=c,$.set(o,s)),s}t.$xc=f;function N($){const o=[];return $.forEach((c,s)=>{o.push(`${s} => ${c}`)}),`Map(${$.size}) {${o.join(", ")}}`}t.$yc=N;function h($){const o=[];return $.forEach(c=>{o.push(c)}),`Set(${$.size}) {${o.join(", ")}}`}t.$zc=h;class a{constructor(o,c){this.uri=o,this.value=c}}function l($){return Array.isArray($)}class g{constructor(o,c){if(this[k]="ResourceMap",o instanceof g)this.b=new Map(o.b),this.c=c??g.a;else if(l(o)){this.b=new Map,this.c=c??g.a;for(const[s,i]of o)this.set(s,i)}else this.b=new Map,this.c=o??g.a}set(o,c){return this.b.set(this.c(o),new a(o,c)),this}get(o){return this.b.get(this.c(o))?.value}has(o){return this.b.has(this.c(o))}get size(){return this.b.size}clear(){this.b.clear()}delete(o){return this.b.delete(this.c(o))}forEach(o,c){typeof c<"u"&&(o=o.bind(c));for(const[s,i]of this.b)o(i.value,i.uri,this)}*values(){for(const o of this.b.values())yield o.value}*keys(){for(const o of this.b.values())yield o.uri}*entries(){for(const o of this.b.values())yield[o.uri,o.value]}*[(k=Symbol.toStringTag,Symbol.iterator)](){for(const[,o]of this.b)yield[o.uri,o.value]}}t.$Ac=g,g.a=$=>$.toString();class E{constructor(o,c){this[D]="ResourceSet",!o||typeof o=="function"?this.a=new g(o):(this.a=new g(c),o.forEach(this.add,this))}get size(){return this.a.size}add(o){return this.a.set(o,o),this}clear(){this.a.clear()}delete(o){return this.a.delete(o)}forEach(o,c){this.a.forEach((s,i)=>o.call(c,i,i,this))}has(o){return this.a.has(o)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(D=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}t.$Bc=E;var m;(function($){$[$.None=0]="None",$[$.AsOld=1]="AsOld",$[$.AsNew=2]="AsNew"})(m||(t.Touch=m={}));class b{constructor(){this[r]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(o){return this.a.has(o)}get(o,c=0){const s=this.a.get(o);if(s)return c!==0&&this.j(s,c),s.value}set(o,c,s=0){let i=this.a.get(o);if(i)i.value=c,s!==0&&this.j(i,s);else{switch(i={key:o,value:c,next:void 0,previous:void 0},s){case 0:this.h(i);break;case 1:this.g(i);break;case 2:this.h(i);break;default:this.h(i);break}this.a.set(o,i),this.d++}return this}delete(o){return!!this.remove(o)}remove(o){const c=this.a.get(o);if(c)return this.a.delete(o),this.i(c),this.d--,c.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const o=this.b;return this.a.delete(o.key),this.i(o),this.d--,o.value}forEach(o,c){const s=this.e;let i=this.b;for(;i;){if(c?o.bind(c)(i.value,i.key,this):o(i.value,i.key,this),this.e!==s)throw new Error("LinkedMap got modified during iteration.");i=i.next}}keys(){const o=this,c=this.e;let s=this.b;const i={[Symbol.iterator](){return i},next(){if(o.e!==c)throw new Error("LinkedMap got modified during iteration.");if(s){const u={value:s.key,done:!1};return s=s.next,u}else return{value:void 0,done:!0}}};return i}values(){const o=this,c=this.e;let s=this.b;const i={[Symbol.iterator](){return i},next(){if(o.e!==c)throw new Error("LinkedMap got modified during iteration.");if(s){const u={value:s.value,done:!1};return s=s.next,u}else return{value:void 0,done:!0}}};return i}entries(){const o=this,c=this.e;let s=this.b;const i={[Symbol.iterator](){return i},next(){if(o.e!==c)throw new Error("LinkedMap got modified during iteration.");if(s){const u={value:[s.key,s.value],done:!1};return s=s.next,u}else return{value:void 0,done:!0}}};return i}[(r=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(o){if(o>=this.size)return;if(o===0){this.clear();return}let c=this.b,s=this.size;for(;c&&s>o;)this.a.delete(c.key),c=c.next,s--;this.b=c,this.d=s,c&&(c.previous=void 0),this.e++}g(o){if(!this.b&&!this.c)this.c=o;else if(this.b)o.next=this.b,this.b.previous=o;else throw new Error("Invalid list");this.b=o,this.e++}h(o){if(!this.b&&!this.c)this.b=o;else if(this.c)o.previous=this.c,this.c.next=o;else throw new Error("Invalid list");this.c=o,this.e++}i(o){if(o===this.b&&o===this.c)this.b=void 0,this.c=void 0;else if(o===this.b){if(!o.next)throw new Error("Invalid list");o.next.previous=void 0,this.b=o.next}else if(o===this.c){if(!o.previous)throw new Error("Invalid list");o.previous.next=void 0,this.c=o.previous}else{const c=o.next,s=o.previous;if(!c||!s)throw new Error("Invalid list");c.previous=s,s.next=c}o.next=void 0,o.previous=void 0,this.e++}j(o,c){if(!this.b||!this.c)throw new Error("Invalid list");if(!(c!==1&&c!==2)){if(c===1){if(o===this.b)return;const s=o.next,i=o.previous;o===this.c?(i.next=void 0,this.c=i):(s.previous=i,i.next=s),o.previous=void 0,o.next=this.b,this.b.previous=o,this.b=o,this.e++}else if(c===2){if(o===this.c)return;const s=o.next,i=o.previous;o===this.b?(s.previous=void 0,this.b=s):(s.previous=i,i.next=s),o.next=void 0,o.previous=this.c,this.c.next=o,this.c=o,this.e++}}}toJSON(){const o=[];return this.forEach((c,s)=>{o.push([s,c])}),o}fromJSON(o){this.clear();for(const[c,s]of o)this.set(c,s)}}t.$Cc=b;class e extends b{constructor(o,c=1){super(),this.k=o,this.l=Math.min(Math.max(0,c),1)}get limit(){return this.k}set limit(o){this.k=o,this.m()}get ratio(){return this.l}set ratio(o){this.l=Math.min(Math.max(0,o),1),this.m()}get(o,c=2){return super.get(o,c)}peek(o){return super.get(o,0)}set(o,c){return super.set(o,c,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}t.$Dc=e;class L{constructor(){this.a=new Map}add(o){return this.a.set(o,(this.a.get(o)||0)+1),this}delete(o){let c=this.a.get(o)||0;return c===0?!1:(c--,c===0?this.a.delete(o):this.a.set(o,c),!0)}has(o){return this.a.has(o)}}t.$Ec=L;class A{constructor(o){if(this.a=new Map,this.b=new Map,o)for(const[c,s]of o)this.set(c,s)}clear(){this.a.clear(),this.b.clear()}set(o,c){this.a.set(o,c),this.b.set(c,o)}get(o){return this.a.get(o)}getKey(o){return this.b.get(o)}delete(o){const c=this.a.get(o);return c===void 0?!1:(this.a.delete(o),this.b.delete(c),!0)}forEach(o,c){this.a.forEach((s,i)=>{o.call(c,s,i,this)})}keys(){return this.a.keys()}values(){return this.a.values()}}t.$Fc=A;class p{constructor(){this.a=new Map}add(o,c){let s=this.a.get(o);s||(s=new Set,this.a.set(o,s)),s.add(c)}delete(o,c){const s=this.a.get(o);s&&(s.delete(c),s.size===0&&this.a.delete(o))}forEach(o,c){const s=this.a.get(o);s&&s.forEach(c)}get(o){const c=this.a.get(o);return c||new Set}}t.$Gc=p}),ne(ie[10],se([0,1,6,34,22,19,20]),function(O,t,k,D,r,f,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$1c=t.$Zc=t.$Yc=t.$Xc=t.$Wc=t.$Vc=t.$Uc=t.$Tc=t.$Sc=t.$Rc=t.$Qc=t.$Pc=t.$Oc=t.$Nc=t.$Mc=t.$Lc=t.$Kc=t.$Jc=t.$Ic=t.$Hc=void 0;const h=!1;let a=null;class l{constructor(){this.b=new Map}c(y){let I=this.b.get(y);return I||(I={parent:null,source:null,isSingleton:!1,value:y,idx:l.a++},this.b.set(y,I)),I}trackDisposable(y){const I=this.c(y);I.source||(I.source=new Error().stack)}setParent(y,I){const q=this.c(y);q.parent=I}markAsDisposed(y){this.b.delete(y)}markAsSingleton(y){this.c(y).isSingleton=!0}f(y,I){const q=I.get(y);if(q)return q;const x=y.parent?this.f(this.c(y.parent),I):y;return I.set(y,x),x}getTrackedDisposables(){const y=new Map;return[...this.b.entries()].filter(([,q])=>q.source!==null&&!this.f(q,y).isSingleton).flatMap(([q])=>q)}computeLeakingDisposables(y=10,I){let q;if(I)q=I;else{const W=new Map,J=[...this.b.values()].filter(te=>te.source!==null&&!this.f(te,W).isSingleton);if(J.length===0)return;const n=new Set(J.map(te=>te.value));if(q=J.filter(te=>!(te.parent&&n.has(te.parent))),q.length===0)throw new Error("There are cyclic diposable chains!")}if(!q)return;function x(W){function J(te,ce){for(;te.length>0&&ce.some(me=>typeof me=="string"?me===te[0]:te[0].match(me));)te.shift()}const n=W.source.split(`
`).map(te=>te.trim().replace("at ","")).filter(te=>te!=="");return J(n,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),n.reverse()}const T=new r.$Gc;for(const W of q){const J=x(W);for(let n=0;n<=J.length;n++)T.add(J.slice(0,n).join(`
`),W)}q.sort((0,k.$7b)(W=>W.idx,k.$9b));let V="",H=0;for(const W of q.slice(0,y)){H++;const J=x(W),n=[];for(let te=0;te<J.length;te++){let ce=J[te];ce=`(shared with ${T.get(J.slice(0,te+1).join(`
`)).size}/${q.length} leaks) at ${ce}`;const Ne=T.get(J.slice(0,te).join(`
`)),we=(0,D.$D)([...Ne].map(Ee=>x(Ee)[te]),Ee=>Ee);delete we[J[te]];for(const[Ee,ve]of Object.entries(we))n.unshift(`    - stacktraces of ${ve.length} other leaks continue with ${Ee}`);n.unshift(ce)}V+=`


==================== Leaking disposable ${H}/${q.length}: ${W.value.constructor.name} ====================
${n.join(`
`)}
============================================================

`}return q.length>y&&(V+=`


... and ${q.length-y} more leaking disposables

`),{leaks:q,details:V}}}t.$Hc=l,l.a=0;function g(F){a=F}if(t.$Ic=g,h){const F="__is_disposable_tracked__";g(new class{trackDisposable(y){const I=new Error("Potentially leaked disposable").stack;setTimeout(()=>{y[F]||console.log(I)},3e3)}setParent(y,I){if(y&&y!==i.None)try{y[F]=!0}catch{}}markAsDisposed(y){if(y&&y!==i.None)try{y[F]=!0}catch{}}markAsSingleton(y){}})}function E(F){return a?.trackDisposable(F),F}t.$Jc=E;function m(F){a?.markAsDisposed(F)}t.$Kc=m;function b(F,y){a?.setParent(F,y)}function e(F,y){if(a)for(const I of F)a.setParent(I,y)}function L(F){return a?.markAsSingleton(F),F}t.$Lc=L;function A(F){return typeof F.dispose=="function"&&F.dispose.length===0}t.$Mc=A;function p(F){if(N.Iterable.is(F)){const y=[];for(const I of F)if(I)try{I.dispose()}catch(q){y.push(q)}if(y.length===1)throw y[0];if(y.length>1)throw new AggregateError(y,"Encountered errors while disposing of store");return Array.isArray(F)?[]:F}else if(F)return F.dispose(),F}t.$Nc=p;function $(F){for(const y of F)A(y)&&y.dispose();return[]}t.$Oc=$;function o(...F){const y=c(()=>p(F));return e(F,y),y}t.$Pc=o;function c(F){const y=E({dispose:(0,f.$db)(()=>{m(y),F()})});return y}t.$Qc=c;class s{constructor(){this.f=new Set,this.g=!1,E(this)}dispose(){this.g||(m(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{p(this.f)}finally{this.f.clear()}}add(y){if(!y)return y;if(y===this)throw new Error("Cannot register a disposable on itself!");return b(y,this),this.g?s.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(y),y}delete(y){if(y){if(y===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(y),y.dispose()}}deleteAndLeak(y){y&&this.f.has(y)&&(this.f.delete(y),b(y,null))}}t.$Rc=s,s.DISABLE_DISPOSED_WARNING=!1;class i{constructor(){this.q=new s,E(this),b(this.q,this)}dispose(){m(this),this.q.dispose()}B(y){if(y===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(y)}}t.$Sc=i,i.None=Object.freeze({dispose(){}});class u{constructor(){this.b=!1,E(this)}get value(){return this.b?void 0:this.a}set value(y){this.b||y===this.a||(this.a?.dispose(),y&&b(y,this),this.a=y)}clear(){this.value=void 0}dispose(){this.b=!0,m(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const y=this.a;return this.a=void 0,y&&b(y,null),y}}t.$Tc=u;class w{constructor(y){this.b=y,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}t.$Uc=w;class d{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,E(this)}set(y){let I=y;return this.unset=()=>I=void 0,this.isset=()=>I!==void 0,this.dispose=()=>{I&&(I(),I=void 0,m(this))},this}}t.$Vc=d;class v{constructor(){this.a=new Map}acquire(y,...I){let q=this.a.get(y);q||(q={counter:0,object:this.b(y,...I)},this.a.set(y,q));const{object:x}=q,T=(0,f.$db)(()=>{--q.counter===0&&(this.c(y,q.object),this.a.delete(y))});return q.counter++,{object:x,dispose:T}}}t.$Wc=v;class R{constructor(y){this.a=y}async acquire(y,...I){const q=this.a.acquire(y,...I);try{return{object:await q.object,dispose:()=>q.dispose()}}catch(x){throw q.dispose(),x}}}t.$Xc=R;class M{constructor(y){this.object=y}dispose(){}}t.$Yc=M;function P(F){const y=new s;try{F(y)}finally{y.dispose()}}t.$Zc=P;class _{constructor(){this.a=new Map,this.b=!1,E(this)}dispose(){m(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{p(this.a.values())}finally{this.a.clear()}}has(y){return this.a.has(y)}get size(){return this.a.size}get(y){return this.a.get(y)}set(y,I,q=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),q||this.a.get(y)?.dispose(),this.a.set(y,I)}deleteAndDispose(y){this.a.get(y)?.dispose(),this.a.delete(y)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}t.$1c=_}),ne(ie[14],se([0,1]),function(O,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$C=t.$B=t.$A=t.$z=t.$y=t.$x=t.OS=t.OperatingSystem=t.$v=t.$u=t.$t=t.$s=t.$r=t.Language=t.$q=t.$p=t.$o=t.$n=t.$m=t.$l=t.$k=t.$j=t.$i=t.$h=t.$g=t.$f=t.$e=t.$d=t.$c=t.Platform=t.$b=t.$a=void 0,t.$a="en";let k=!1,D=!1,r=!1,f=!1,N=!1,h=!1,a=!1,l=!1,g=!1,E=!1,m,b=t.$a,e=t.$a,L,A;t.$b=typeof self=="object"?self:typeof global=="object"?global:{};let p;typeof t.$b.vscode<"u"&&typeof t.$b.vscode.process<"u"?p=t.$b.vscode.process:typeof process<"u"&&(p=process);const $=typeof p?.versions?.electron=="string",o=$&&p?.type==="renderer";if(typeof navigator=="object"&&!o){A=navigator.userAgent,k=A.indexOf("Windows")>=0,D=A.indexOf("Macintosh")>=0,l=(A.indexOf("Macintosh")>=0||A.indexOf("iPad")>=0||A.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,r=A.indexOf("Linux")>=0,E=A?.indexOf("Mobi")>=0,h=!0,m=t.$a,b=m,e=navigator.language;const M=typeof document<"u"&&document.getElementById("vscode-remote-nls-configuration"),P=M&&M.getAttribute("data-settings");if(P)try{const _=JSON.parse(P),F=_.availableLanguages["*"];m=_.locale,e=_.osLocale,b=F||t.$a,L=_._translationsConfigFile}catch{}}else if(typeof p=="object"){k=p.platform==="win32",D=p.platform==="darwin",r=p.platform==="linux",f=r&&!!p.env.SNAP&&!!p.env.SNAP_REVISION,a=$,g=!!p.env.CI||!!p.env.BUILD_ARTIFACTSTAGINGDIRECTORY,m=t.$a,b=t.$a;const M=p.env.VSCODE_NLS_CONFIG;if(M)try{const P=JSON.parse(M),_=P.availableLanguages["*"];m=P.locale,e=P.osLocale,b=_||t.$a,L=P._translationsConfigFile}catch{}N=!0}else console.error("Unable to resolve platform.");var c;(function(M){M[M.Web=0]="Web",M[M.Mac=1]="Mac",M[M.Linux=2]="Linux",M[M.Windows=3]="Windows"})(c||(t.Platform=c={}));function s(M){switch(M){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}t.$c=s;let i=0;D?i=1:k?i=3:r&&(i=2),t.$d=k,t.$e=D,t.$f=r,t.$g=f,t.$h=N,t.$i=a,t.$j=h,t.$k=h&&typeof t.$b.importScripts=="function",t.$l=l,t.$m=E,t.$n=g,t.$o=i,t.$p=A,t.$q=b;var u;(function(M){function P(){return t.$q}M.value=P;function _(){return t.$q.length===2?t.$q==="en":t.$q.length>=3?t.$q[0]==="e"&&t.$q[1]==="n"&&t.$q[2]==="-":!1}M.isDefaultVariant=_;function F(){return t.$q==="en"}M.isDefault=F})(u||(t.Language=u={})),t.$r=m,t.$s=e,t.$t=L,t.$u=typeof t.$b.postMessage=="function"&&!t.$b.importScripts,t.$v=(()=>{if(t.$u){const M=[];t.$b.addEventListener("message",_=>{if(_.data&&_.data.vscodeScheduleAsyncWork)for(let F=0,y=M.length;F<y;F++){const I=M[F];if(I.id===_.data.vscodeScheduleAsyncWork){M.splice(F,1),I.callback();return}}});let P=0;return _=>{const F=++P;M.push({id:F,callback:_}),t.$b.postMessage({vscodeScheduleAsyncWork:F},"*")}}return M=>setTimeout(M)})();var w;(function(M){M[M.Windows=1]="Windows",M[M.Macintosh=2]="Macintosh",M[M.Linux=3]="Linux"})(w||(t.OperatingSystem=w={})),t.OS=D||l?2:k?1:3;let d=!0,v=!1;function R(){if(!v){v=!0;const M=new Uint8Array(2);M[0]=1,M[1]=2,d=new Uint16Array(M.buffer)[0]===(2<<8)+1}return d}t.$x=R,t.$y=!!(t.$p&&t.$p.indexOf("Chrome")>=0),t.$z=!!(t.$p&&t.$p.indexOf("Firefox")>=0),t.$A=!!(!t.$y&&t.$p&&t.$p.indexOf("Safari")>=0),t.$B=!!(t.$p&&t.$p.indexOf("Edg/")>=0),t.$C=!!(t.$p&&t.$p.indexOf("Android")>=0)}),ne(ie[39],se([0,1,14]),function(O,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ec=t.$dc=t.env=t.cwd=void 0;let D;if(typeof k.$b.vscode<"u"&&typeof k.$b.vscode.process<"u"){const r=k.$b.vscode.process;D={get platform(){return r.platform},get arch(){return r.arch},get env(){return r.env},cwd(){return r.cwd()}}}else typeof process<"u"?D={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:D={get platform(){return k.$d?"win32":k.$e?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};t.cwd=D.cwd,t.env=D.env,t.$dc=D.platform,t.$ec=D.arch}),ne(ie[40],se([0,1,39]),function(O,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$tc=t.sep=t.$rc=t.$qc=t.$pc=t.$oc=t.$nc=t.$mc=t.$lc=t.$kc=t.$jc=t.$ic=t.$hc=t.$gc=t.$fc=void 0;const D=65,r=97,f=90,N=122,h=46,a=47,l=92,g=58,E=63;class m extends Error{constructor(u,w,d){let v;typeof w=="string"&&w.indexOf("not ")===0?(v="must not be",w=w.replace(/^not /,"")):v="must be";const R=u.indexOf(".")!==-1?"property":"argument";let M=`The "${u}" ${R} ${v} of type ${w}`;M+=`. Received type ${typeof d}`,super(M),this.code="ERR_INVALID_ARG_TYPE"}}function b(i,u){if(i===null||typeof i!="object")throw new m(u,"Object",i)}function e(i,u){if(typeof i!="string")throw new m(u,"string",i)}const L=k.$dc==="win32";function A(i){return i===a||i===l}function p(i){return i===a}function $(i){return i>=D&&i<=f||i>=r&&i<=N}function o(i,u,w,d){let v="",R=0,M=-1,P=0,_=0;for(let F=0;F<=i.length;++F){if(F<i.length)_=i.charCodeAt(F);else{if(d(_))break;_=a}if(d(_)){if(!(M===F-1||P===1))if(P===2){if(v.length<2||R!==2||v.charCodeAt(v.length-1)!==h||v.charCodeAt(v.length-2)!==h){if(v.length>2){const y=v.lastIndexOf(w);y===-1?(v="",R=0):(v=v.slice(0,y),R=v.length-1-v.lastIndexOf(w)),M=F,P=0;continue}else if(v.length!==0){v="",R=0,M=F,P=0;continue}}u&&(v+=v.length>0?`${w}..`:"..",R=2)}else v.length>0?v+=`${w}${i.slice(M+1,F)}`:v=i.slice(M+1,F),R=F-M-1;M=F,P=0}else _===h&&P!==-1?++P:P=-1}return v}function c(i,u){b(u,"pathObject");const w=u.dir||u.root,d=u.base||`${u.name||""}${u.ext||""}`;return w?w===u.root?`${w}${d}`:`${w}${i}${d}`:d}t.$fc={resolve(...i){let u="",w="",d=!1;for(let v=i.length-1;v>=-1;v--){let R;if(v>=0){if(R=i[v],e(R,"path"),R.length===0)continue}else u.length===0?R=k.cwd():(R=k.env[`=${u}`]||k.cwd(),(R===void 0||R.slice(0,2).toLowerCase()!==u.toLowerCase()&&R.charCodeAt(2)===l)&&(R=`${u}\\`));const M=R.length;let P=0,_="",F=!1;const y=R.charCodeAt(0);if(M===1)A(y)&&(P=1,F=!0);else if(A(y))if(F=!0,A(R.charCodeAt(1))){let I=2,q=I;for(;I<M&&!A(R.charCodeAt(I));)I++;if(I<M&&I!==q){const x=R.slice(q,I);for(q=I;I<M&&A(R.charCodeAt(I));)I++;if(I<M&&I!==q){for(q=I;I<M&&!A(R.charCodeAt(I));)I++;(I===M||I!==q)&&(_=`\\\\${x}\\${R.slice(q,I)}`,P=I)}}}else P=1;else $(y)&&R.charCodeAt(1)===g&&(_=R.slice(0,2),P=2,M>2&&A(R.charCodeAt(2))&&(F=!0,P=3));if(_.length>0)if(u.length>0){if(_.toLowerCase()!==u.toLowerCase())continue}else u=_;if(d){if(u.length>0)break}else if(w=`${R.slice(P)}\\${w}`,d=F,F&&u.length>0)break}return w=o(w,!d,"\\",A),d?`${u}\\${w}`:`${u}${w}`||"."},normalize(i){e(i,"path");const u=i.length;if(u===0)return".";let w=0,d,v=!1;const R=i.charCodeAt(0);if(u===1)return p(R)?"\\":i;if(A(R))if(v=!0,A(i.charCodeAt(1))){let P=2,_=P;for(;P<u&&!A(i.charCodeAt(P));)P++;if(P<u&&P!==_){const F=i.slice(_,P);for(_=P;P<u&&A(i.charCodeAt(P));)P++;if(P<u&&P!==_){for(_=P;P<u&&!A(i.charCodeAt(P));)P++;if(P===u)return`\\\\${F}\\${i.slice(_)}\\`;P!==_&&(d=`\\\\${F}\\${i.slice(_,P)}`,w=P)}}}else w=1;else $(R)&&i.charCodeAt(1)===g&&(d=i.slice(0,2),w=2,u>2&&A(i.charCodeAt(2))&&(v=!0,w=3));let M=w<u?o(i.slice(w),!v,"\\",A):"";return M.length===0&&!v&&(M="."),M.length>0&&A(i.charCodeAt(u-1))&&(M+="\\"),d===void 0?v?`\\${M}`:M:v?`${d}\\${M}`:`${d}${M}`},isAbsolute(i){e(i,"path");const u=i.length;if(u===0)return!1;const w=i.charCodeAt(0);return A(w)||u>2&&$(w)&&i.charCodeAt(1)===g&&A(i.charCodeAt(2))},join(...i){if(i.length===0)return".";let u,w;for(let R=0;R<i.length;++R){const M=i[R];e(M,"path"),M.length>0&&(u===void 0?u=w=M:u+=`\\${M}`)}if(u===void 0)return".";let d=!0,v=0;if(typeof w=="string"&&A(w.charCodeAt(0))){++v;const R=w.length;R>1&&A(w.charCodeAt(1))&&(++v,R>2&&(A(w.charCodeAt(2))?++v:d=!1))}if(d){for(;v<u.length&&A(u.charCodeAt(v));)v++;v>=2&&(u=`\\${u.slice(v)}`)}return t.$fc.normalize(u)},relative(i,u){if(e(i,"from"),e(u,"to"),i===u)return"";const w=t.$fc.resolve(i),d=t.$fc.resolve(u);if(w===d||(i=w.toLowerCase(),u=d.toLowerCase(),i===u))return"";let v=0;for(;v<i.length&&i.charCodeAt(v)===l;)v++;let R=i.length;for(;R-1>v&&i.charCodeAt(R-1)===l;)R--;const M=R-v;let P=0;for(;P<u.length&&u.charCodeAt(P)===l;)P++;let _=u.length;for(;_-1>P&&u.charCodeAt(_-1)===l;)_--;const F=_-P,y=M<F?M:F;let I=-1,q=0;for(;q<y;q++){const T=i.charCodeAt(v+q);if(T!==u.charCodeAt(P+q))break;T===l&&(I=q)}if(q!==y){if(I===-1)return d}else{if(F>y){if(u.charCodeAt(P+q)===l)return d.slice(P+q+1);if(q===2)return d.slice(P+q)}M>y&&(i.charCodeAt(v+q)===l?I=q:q===2&&(I=3)),I===-1&&(I=0)}let x="";for(q=v+I+1;q<=R;++q)(q===R||i.charCodeAt(q)===l)&&(x+=x.length===0?"..":"\\..");return P+=I,x.length>0?`${x}${d.slice(P,_)}`:(d.charCodeAt(P)===l&&++P,d.slice(P,_))},toNamespacedPath(i){if(typeof i!="string"||i.length===0)return i;const u=t.$fc.resolve(i);if(u.length<=2)return i;if(u.charCodeAt(0)===l){if(u.charCodeAt(1)===l){const w=u.charCodeAt(2);if(w!==E&&w!==h)return`\\\\?\\UNC\\${u.slice(2)}`}}else if($(u.charCodeAt(0))&&u.charCodeAt(1)===g&&u.charCodeAt(2)===l)return`\\\\?\\${u}`;return i},dirname(i){e(i,"path");const u=i.length;if(u===0)return".";let w=-1,d=0;const v=i.charCodeAt(0);if(u===1)return A(v)?i:".";if(A(v)){if(w=d=1,A(i.charCodeAt(1))){let P=2,_=P;for(;P<u&&!A(i.charCodeAt(P));)P++;if(P<u&&P!==_){for(_=P;P<u&&A(i.charCodeAt(P));)P++;if(P<u&&P!==_){for(_=P;P<u&&!A(i.charCodeAt(P));)P++;if(P===u)return i;P!==_&&(w=d=P+1)}}}}else $(v)&&i.charCodeAt(1)===g&&(w=u>2&&A(i.charCodeAt(2))?3:2,d=w);let R=-1,M=!0;for(let P=u-1;P>=d;--P)if(A(i.charCodeAt(P))){if(!M){R=P;break}}else M=!1;if(R===-1){if(w===-1)return".";R=w}return i.slice(0,R)},basename(i,u){u!==void 0&&e(u,"ext"),e(i,"path");let w=0,d=-1,v=!0,R;if(i.length>=2&&$(i.charCodeAt(0))&&i.charCodeAt(1)===g&&(w=2),u!==void 0&&u.length>0&&u.length<=i.length){if(u===i)return"";let M=u.length-1,P=-1;for(R=i.length-1;R>=w;--R){const _=i.charCodeAt(R);if(A(_)){if(!v){w=R+1;break}}else P===-1&&(v=!1,P=R+1),M>=0&&(_===u.charCodeAt(M)?--M===-1&&(d=R):(M=-1,d=P))}return w===d?d=P:d===-1&&(d=i.length),i.slice(w,d)}for(R=i.length-1;R>=w;--R)if(A(i.charCodeAt(R))){if(!v){w=R+1;break}}else d===-1&&(v=!1,d=R+1);return d===-1?"":i.slice(w,d)},extname(i){e(i,"path");let u=0,w=-1,d=0,v=-1,R=!0,M=0;i.length>=2&&i.charCodeAt(1)===g&&$(i.charCodeAt(0))&&(u=d=2);for(let P=i.length-1;P>=u;--P){const _=i.charCodeAt(P);if(A(_)){if(!R){d=P+1;break}continue}v===-1&&(R=!1,v=P+1),_===h?w===-1?w=P:M!==1&&(M=1):w!==-1&&(M=-1)}return w===-1||v===-1||M===0||M===1&&w===v-1&&w===d+1?"":i.slice(w,v)},format:c.bind(null,"\\"),parse(i){e(i,"path");const u={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return u;const w=i.length;let d=0,v=i.charCodeAt(0);if(w===1)return A(v)?(u.root=u.dir=i,u):(u.base=u.name=i,u);if(A(v)){if(d=1,A(i.charCodeAt(1))){let I=2,q=I;for(;I<w&&!A(i.charCodeAt(I));)I++;if(I<w&&I!==q){for(q=I;I<w&&A(i.charCodeAt(I));)I++;if(I<w&&I!==q){for(q=I;I<w&&!A(i.charCodeAt(I));)I++;I===w?d=I:I!==q&&(d=I+1)}}}}else if($(v)&&i.charCodeAt(1)===g){if(w<=2)return u.root=u.dir=i,u;if(d=2,A(i.charCodeAt(2))){if(w===3)return u.root=u.dir=i,u;d=3}}d>0&&(u.root=i.slice(0,d));let R=-1,M=d,P=-1,_=!0,F=i.length-1,y=0;for(;F>=d;--F){if(v=i.charCodeAt(F),A(v)){if(!_){M=F+1;break}continue}P===-1&&(_=!1,P=F+1),v===h?R===-1?R=F:y!==1&&(y=1):R!==-1&&(y=-1)}return P!==-1&&(R===-1||y===0||y===1&&R===P-1&&R===M+1?u.base=u.name=i.slice(M,P):(u.name=i.slice(M,R),u.base=i.slice(M,P),u.ext=i.slice(R,P))),M>0&&M!==d?u.dir=i.slice(0,M-1):u.dir=u.root,u},sep:"\\",delimiter:";",win32:null,posix:null};const s=(()=>{if(L){const i=/\\/g;return()=>{const u=k.cwd().replace(i,"/");return u.slice(u.indexOf("/"))}}return()=>k.cwd()})();t.$gc={resolve(...i){let u="",w=!1;for(let d=i.length-1;d>=-1&&!w;d--){const v=d>=0?i[d]:s();e(v,"path"),v.length!==0&&(u=`${v}/${u}`,w=v.charCodeAt(0)===a)}return u=o(u,!w,"/",p),w?`/${u}`:u.length>0?u:"."},normalize(i){if(e(i,"path"),i.length===0)return".";const u=i.charCodeAt(0)===a,w=i.charCodeAt(i.length-1)===a;return i=o(i,!u,"/",p),i.length===0?u?"/":w?"./":".":(w&&(i+="/"),u?`/${i}`:i)},isAbsolute(i){return e(i,"path"),i.length>0&&i.charCodeAt(0)===a},join(...i){if(i.length===0)return".";let u;for(let w=0;w<i.length;++w){const d=i[w];e(d,"path"),d.length>0&&(u===void 0?u=d:u+=`/${d}`)}return u===void 0?".":t.$gc.normalize(u)},relative(i,u){if(e(i,"from"),e(u,"to"),i===u||(i=t.$gc.resolve(i),u=t.$gc.resolve(u),i===u))return"";const w=1,d=i.length,v=d-w,R=1,M=u.length-R,P=v<M?v:M;let _=-1,F=0;for(;F<P;F++){const I=i.charCodeAt(w+F);if(I!==u.charCodeAt(R+F))break;I===a&&(_=F)}if(F===P)if(M>P){if(u.charCodeAt(R+F)===a)return u.slice(R+F+1);if(F===0)return u.slice(R+F)}else v>P&&(i.charCodeAt(w+F)===a?_=F:F===0&&(_=0));let y="";for(F=w+_+1;F<=d;++F)(F===d||i.charCodeAt(F)===a)&&(y+=y.length===0?"..":"/..");return`${y}${u.slice(R+_)}`},toNamespacedPath(i){return i},dirname(i){if(e(i,"path"),i.length===0)return".";const u=i.charCodeAt(0)===a;let w=-1,d=!0;for(let v=i.length-1;v>=1;--v)if(i.charCodeAt(v)===a){if(!d){w=v;break}}else d=!1;return w===-1?u?"/":".":u&&w===1?"//":i.slice(0,w)},basename(i,u){u!==void 0&&e(u,"ext"),e(i,"path");let w=0,d=-1,v=!0,R;if(u!==void 0&&u.length>0&&u.length<=i.length){if(u===i)return"";let M=u.length-1,P=-1;for(R=i.length-1;R>=0;--R){const _=i.charCodeAt(R);if(_===a){if(!v){w=R+1;break}}else P===-1&&(v=!1,P=R+1),M>=0&&(_===u.charCodeAt(M)?--M===-1&&(d=R):(M=-1,d=P))}return w===d?d=P:d===-1&&(d=i.length),i.slice(w,d)}for(R=i.length-1;R>=0;--R)if(i.charCodeAt(R)===a){if(!v){w=R+1;break}}else d===-1&&(v=!1,d=R+1);return d===-1?"":i.slice(w,d)},extname(i){e(i,"path");let u=-1,w=0,d=-1,v=!0,R=0;for(let M=i.length-1;M>=0;--M){const P=i.charCodeAt(M);if(P===a){if(!v){w=M+1;break}continue}d===-1&&(v=!1,d=M+1),P===h?u===-1?u=M:R!==1&&(R=1):u!==-1&&(R=-1)}return u===-1||d===-1||R===0||R===1&&u===d-1&&u===w+1?"":i.slice(u,d)},format:c.bind(null,"/"),parse(i){e(i,"path");const u={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return u;const w=i.charCodeAt(0)===a;let d;w?(u.root="/",d=1):d=0;let v=-1,R=0,M=-1,P=!0,_=i.length-1,F=0;for(;_>=d;--_){const y=i.charCodeAt(_);if(y===a){if(!P){R=_+1;break}continue}M===-1&&(P=!1,M=_+1),y===h?v===-1?v=_:F!==1&&(F=1):v!==-1&&(F=-1)}if(M!==-1){const y=R===0&&w?1:R;v===-1||F===0||F===1&&v===M-1&&v===R+1?u.base=u.name=i.slice(y,M):(u.name=i.slice(y,v),u.base=i.slice(y,M),u.ext=i.slice(v,M))}return R>0?u.dir=i.slice(0,R-1):w&&(u.dir="/"),u},sep:"/",delimiter:":",win32:null,posix:null},t.$gc.win32=t.$fc.win32=t.$fc,t.$gc.posix=t.$fc.posix=t.$gc,t.$hc=L?t.$fc.normalize:t.$gc.normalize,t.$ic=L?t.$fc.isAbsolute:t.$gc.isAbsolute,t.$jc=L?t.$fc.join:t.$gc.join,t.$kc=L?t.$fc.resolve:t.$gc.resolve,t.$lc=L?t.$fc.relative:t.$gc.relative,t.$mc=L?t.$fc.dirname:t.$gc.dirname,t.$nc=L?t.$fc.basename:t.$gc.basename,t.$oc=L?t.$fc.extname:t.$gc.extname,t.$pc=L?t.$fc.format:t.$gc.format,t.$qc=L?t.$fc.parse:t.$gc.parse,t.$rc=L?t.$fc.toNamespacedPath:t.$gc.toNamespacedPath,t.sep=L?t.$fc.sep:t.$gc.sep,t.$tc=L?t.$fc.delimiter:t.$gc.delimiter}),ne(ie[23],se([0,1]),function(O,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Kd=void 0;const k=globalThis.performance&&typeof globalThis.performance.now=="function";class D{static create(f){return new D(f)}constructor(f){this.c=k&&f===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}t.$Kd=D}),ne(ie[11],se([0,1,3,19,10,21,23]),function(O,t,k,D,r,f,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Xd=t.$Wd=t.$Vd=t.$Ud=t.$Td=t.$Sd=t.$Rd=t.$Qd=t.$Pd=t.$Od=t.$Nd=t.$Md=t.Event=void 0;const h=!1,a=!1;var l;(function(_){_.None=()=>r.$Sc.None;function F(G){if(a){const{onDidAddListener:Z}=G,K=e.create();let Q=0;G.onDidAddListener=()=>{++Q===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),K.print()),Z?.()}}}function y(G,Z){return te(G,()=>{},0,void 0,!0,void 0,Z)}_.defer=y;function I(G){return(Z,K=null,Q)=>{let re=!1,le;return le=G(oe=>{if(!re)return le?le.dispose():re=!0,Z.call(K,oe)},null,Q),re&&le.dispose(),le}}_.once=I;function q(G,Z,K){return J((Q,re=null,le)=>G(oe=>Q.call(re,Z(oe)),null,le),K)}_.map=q;function x(G,Z,K){return J((Q,re=null,le)=>G(oe=>{Z(oe),Q.call(re,oe)},null,le),K)}_.forEach=x;function T(G,Z,K){return J((Q,re=null,le)=>G(oe=>Z(oe)&&Q.call(re,oe),null,le),K)}_.filter=T;function V(G){return G}_.signal=V;function H(...G){return(Z,K=null,Q)=>{const re=(0,r.$Pc)(...G.map(le=>le(oe=>Z.call(K,oe))));return n(re,Q)}}_.any=H;function W(G,Z,K,Q){let re=K;return q(G,le=>(re=Z(re,le),re),Q)}_.reduce=W;function J(G,Z){let K;const Q={onWillAddFirstListener(){K=G(re.fire,re)},onDidRemoveLastListener(){K?.dispose()}};Z||F(Q);const re=new o(Q);return Z?.add(re),re.event}function n(G,Z){return Z instanceof Array?Z.push(G):Z&&Z.add(G),G}function te(G,Z,K=100,Q=!1,re=!1,le,oe){let be,de,pe,Fe=0,$e;const qe={leakWarningThreshold:le,onWillAddFirstListener(){be=G(Ue=>{Fe++,de=Z(de,Ue),Q&&!pe&&(Pe.fire(de),de=void 0),$e=()=>{const Ve=de;de=void 0,pe=void 0,(!Q||Fe>1)&&Pe.fire(Ve),Fe=0},typeof K=="number"?(clearTimeout(pe),pe=setTimeout($e,K)):pe===void 0&&(pe=0,queueMicrotask($e))})},onWillRemoveListener(){re&&Fe>0&&$e?.()},onDidRemoveLastListener(){$e=void 0,be.dispose()}};oe||F(qe);const Pe=new o(qe);return oe?.add(Pe),Pe.event}_.debounce=te;function ce(G,Z=0,K){return _.debounce(G,(Q,re)=>Q?(Q.push(re),Q):[re],Z,void 0,!0,void 0,K)}_.accumulate=ce;function me(G,Z=(Q,re)=>Q===re,K){let Q=!0,re;return T(G,le=>{const oe=Q||!Z(le,re);return Q=!1,re=le,oe},K)}_.latch=me;function Ne(G,Z,K){return[_.filter(G,Z,K),_.filter(G,Q=>!Z(Q),K)]}_.split=Ne;function we(G,Z=!1,K=[],Q){let re=K.slice(),le=G(de=>{re?re.push(de):be.fire(de)});Q&&Q.add(le);const oe=()=>{re?.forEach(de=>be.fire(de)),re=null},be=new o({onWillAddFirstListener(){le||(le=G(de=>be.fire(de)),Q&&Q.add(le))},onDidAddFirstListener(){re&&(Z?setTimeout(oe):oe())},onDidRemoveLastListener(){le&&le.dispose(),le=null}});return Q&&Q.add(be),be.event}_.buffer=we;function Ee(G,Z){return(Q,re,le)=>{const oe=Z(new De);return G(function(be){const de=oe.evaluate(be);de!==ve&&Q.call(re,de)},void 0,le)}}_.chain=Ee;const ve=Symbol("HaltChainable");class De{constructor(){this.f=[]}map(Z){return this.f.push(Z),this}forEach(Z){return this.f.push(K=>(Z(K),K)),this}filter(Z){return this.f.push(K=>Z(K)?K:ve),this}reduce(Z,K){let Q=K;return this.f.push(re=>(Q=Z(Q,re),Q)),this}latch(Z=(K,Q)=>K===Q){let K=!0,Q;return this.f.push(re=>{const le=K||!Z(re,Q);return K=!1,Q=re,le?re:ve}),this}evaluate(Z){for(const K of this.f)if(Z=K(Z),Z===ve)break;return Z}}function _e(G,Z,K=Q=>Q){const Q=(...be)=>oe.fire(K(...be)),re=()=>G.on(Z,Q),le=()=>G.removeListener(Z,Q),oe=new o({onWillAddFirstListener:re,onDidRemoveLastListener:le});return oe.event}_.fromNodeEventEmitter=_e;function Te(G,Z,K=Q=>Q){const Q=(...be)=>oe.fire(K(...be)),re=()=>G.addEventListener(Z,Q),le=()=>G.removeEventListener(Z,Q),oe=new o({onWillAddFirstListener:re,onDidRemoveLastListener:le});return oe.event}_.fromDOMEventEmitter=Te;function Se(G){return new Promise(Z=>I(G)(Z))}_.toPromise=Se;function Ae(G){const Z=new o;return G.then(K=>{Z.fire(K)},()=>{Z.fire(void 0)}).finally(()=>{Z.dispose()}),Z.event}_.fromPromise=Ae;function B(G,Z,K){return Z(K),G(Q=>Z(Q))}_.runAndSubscribe=B;function C(G,Z){let K=null;function Q(le){K?.dispose(),K=new r.$Rc,Z(le,K)}Q(void 0);const re=G(le=>Q(le));return(0,r.$Qc)(()=>{re.dispose(),K?.dispose()})}_.runAndSubscribeWithStore=C;class j{constructor(Z,K){this._observable=Z,this.f=0,this.g=!1;const Q={onWillAddFirstListener:()=>{Z.addObserver(this)},onDidRemoveLastListener:()=>{Z.removeObserver(this)}};K||F(Q),this.emitter=new o(Q),K&&K.add(this.emitter)}beginUpdate(Z){this.f++}handlePossibleChange(Z){}handleChange(Z,K){this.g=!0}endUpdate(Z){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function X(G,Z){return new j(G,Z).emitter.event}_.fromObservable=X;function ee(G){return Z=>{let K=0,Q=!1;const re={beginUpdate(){K++},endUpdate(){K--,K===0&&(G.reportChanges(),Q&&(Q=!1,Z()))},handlePossibleChange(){},handleChange(){Q=!0}};return G.addObserver(re),G.reportChanges(),{dispose(){G.removeObserver(re)}}}}_.fromObservableLight=ee})(l||(t.Event=l={}));class g{constructor(F){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${F}_${g.f++}`,g.all.add(this)}start(F){this.g=new N.$Kd,this.listenerCount=F}stop(){if(this.g){const F=this.g.elapsed();this.durations.push(F),this.elapsedOverall+=F,this.invocationCount+=1,this.g=void 0}}}t.$Md=g,g.all=new Set,g.f=0;let E=-1;function m(_){const F=E;return E=_,{dispose(){E=F}}}t.$Nd=m;class b{constructor(F,y=Math.random().toString(18).slice(2,5)){this.threshold=F,this.name=y,this.g=0}dispose(){this.f?.clear()}check(F,y){const I=this.threshold;if(I<=0||y<I)return;this.f||(this.f=new Map);const q=this.f.get(F.value)||0;if(this.f.set(F.value,q+1),this.g-=1,this.g<=0){this.g=I*.5;let x,T=0;for(const[V,H]of this.f)(!x||T<H)&&(x=V,T=H);console.warn(`[${this.name}] potential listener LEAK detected, having ${y} listeners already. MOST frequent listener (${T}):`),console.warn(x)}return()=>{const x=this.f.get(F.value)||0;this.f.set(F.value,x-1)}}}class e{static create(){return new e(new Error().stack??"")}constructor(F){this.value=F}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let L=0;class A{constructor(F){this.value=F,this.id=L++}}const p=2,$=(_,F)=>{if(_ instanceof A)F(_);else for(let y=0;y<_.length;y++){const I=_[y];I&&F(I)}};class o{constructor(F){this.w=0,this.f=F,this.g=E>0||this.f?.leakWarningThreshold?new b(this.f?.leakWarningThreshold??E):void 0,this.j=this.f?._profName?new g(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(h){const F=this.t;queueMicrotask(()=>{$(F,y=>y.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??(this.q=(F,y,I)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),r.$Sc.None;if(this.m)return r.$Sc.None;y&&(F=F.bind(y));const q=new A(F);let x,T;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(q.stack=e.create(),x=this.g.check(q.stack,this.w+1)),h&&(q.stack=T??e.create()),this.t?this.t instanceof A?(this.u??(this.u=new s),this.t=[this.t,q]):this.t.push(q):(this.f?.onWillAddFirstListener?.(this),this.t=q,this.f?.onDidAddFirstListener?.(this)),this.w++;const V=(0,r.$Qc)(()=>{x?.(),this.x(q)});return I instanceof r.$Rc?I.add(V):Array.isArray(I)&&I.push(V),V}),this.q}x(F){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const y=this.t,I=y.indexOf(F);if(I===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,y[I]=void 0;const q=this.u.current===this;if(this.w*p<=y.length){let x=0;for(let T=0;T<y.length;T++)y[T]?y[x++]=y[T]:q&&(this.u.end--,x<this.u.i&&this.u.i--);y.length=x}}y(F,y){if(!F)return;const I=this.f?.onListenerError||k.$1;if(!I){F.value(y);return}try{F.value(y)}catch(q){I(q)}}z(F){const y=F.current.t;for(;F.i<F.end;)this.y(y[F.i++],F.value);F.reset()}fire(F){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof A)this.y(this.t,F);else{const y=this.u;y.enqueue(this,F,this.t.length),this.z(y)}this.j?.stop()}hasListeners(){return this.w>0}}t.$Od=o;const c=()=>new s;t.$Pd=c;class s{constructor(){this.i=-1,this.end=0}enqueue(F,y,I){this.i=0,this.end=I,this.current=F,this.value=y}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class i extends o{async fireAsync(F,y,I){if(this.t)for(this.h||(this.h=new f.$2c),$(this.t,q=>this.h.push([q.value,F]));this.h.size>0&&!y.isCancellationRequested;){const[q,x]=this.h.shift(),T=[],V={...x,token:y,waitUntil:H=>{if(Object.isFrozen(T))throw new Error("waitUntil can NOT be called asynchronous");I&&(H=I(H,q)),T.push(H)}};try{q(V)}catch(H){(0,k.$1)(H);continue}Object.freeze(T),await Promise.allSettled(T).then(H=>{for(const W of H)W.status==="rejected"&&(0,k.$1)(W.reason)})}}}t.$Qd=i;class u extends o{get isPaused(){return this.h!==0}constructor(F){super(F),this.h=0,this.s=new f.$2c,this.A=F?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const F=Array.from(this.s);this.s.clear(),super.fire(this.A(F))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(F){this.w&&(this.h!==0?this.s.push(F):super.fire(F))}}t.$Rd=u;class w extends u{constructor(F){super(F),this.k=F.delay??100}fire(F){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(F)}}t.$Sd=w;class d extends o{constructor(F){super(F),this.h=[],this.k=F?.merge}fire(F){this.hasListeners()&&(this.h.push(F),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(y=>super.fire(y)),this.h=[]}))}}t.$Td=d;class v{constructor(){this.g=!1,this.h=[],this.f=new o({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(F){const y={event:F,listener:null};this.h.push(y),this.g&&this.m(y);const I=()=>{this.g&&this.o(y);const q=this.h.indexOf(y);this.h.splice(q,1)};return(0,r.$Qc)((0,D.$db)(I))}j(){this.g=!0,this.h.forEach(F=>this.m(F))}k(){this.g=!1,this.h.forEach(F=>this.o(F))}m(F){F.listener=F.event(y=>this.f.fire(y))}o(F){F.listener&&F.listener.dispose(),F.listener=null}dispose(){this.f.dispose()}}t.$Ud=v;class R{constructor(F,y,I,q){this.f=new r.$Rc;const x=this.f.add(new v),T=this.f.add(new r.$1c);function V(H){T.set(H,x.add(q(H)))}for(const H of F)V(H);this.f.add(y(H=>{V(H)})),this.f.add(I(H=>{T.deleteAndDispose(H)})),this.event=x.event}dispose(){this.f.dispose()}}t.$Vd=R;class M{constructor(){this.f=[]}wrapEvent(F){return(y,I,q)=>F(x=>{const T=this.f[this.f.length-1];T?T.push(()=>y.call(I,x)):y.call(I,x)},void 0,q)}bufferEvents(F){const y=[];this.f.push(y);const I=F();return this.f.pop(),y.forEach(q=>q()),I}}t.$Wd=M;class P{constructor(){this.f=!1,this.g=l.None,this.h=r.$Sc.None,this.j=new o({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(F){this.g=F,this.f&&(this.h.dispose(),this.h=F(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}t.$Xd=P}),ne(ie[24],se([0,1,11]),function(O,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Yd=t.CancellationToken=void 0;const D=Object.freeze(function(h,a){const l=setTimeout(h.bind(a),0);return{dispose(){clearTimeout(l)}}});var r;(function(h){function a(l){return l===h.None||l===h.Cancelled||l instanceof f?!0:!l||typeof l!="object"?!1:typeof l.isCancellationRequested=="boolean"&&typeof l.onCancellationRequested=="function"}h.isCancellationToken=a,h.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:k.Event.None}),h.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:D})})(r||(t.CancellationToken=r={}));class f{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?D:(this.b||(this.b=new k.$Od),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class N{constructor(a){this.f=void 0,this.g=void 0,this.g=a&&a.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new f),this.f}cancel(){this.f?this.f instanceof f&&this.f.cancel():this.f=r.Cancelled}dispose(a=!1){a&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof f&&this.f.dispose():this.f=r.None}}t.$Yd=N}),ne(ie[41],se([0,1,24]),function(O,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ze=t.$ye=t.$xe=void 0;class D{constructor(h){this.b=h,this.a=null}get(){if(this.a)return this.a;const h=new k.$Yd,a=this.b(h.token);return this.a={promise:a,dispose:()=>{this.a=null,h.cancel(),h.dispose()}},this.a}}t.$xe=D;class r{constructor(h){this.c=h,this.a=void 0,this.b=void 0}get(h){const a=JSON.stringify(h);return this.b!==a&&(this.b=a,this.a=this.c(h)),this.a}}t.$ye=r;class f{get cachedValues(){return this.a}constructor(h){this.b=h,this.a=new Map}get(h){if(this.a.has(h))return this.a.get(h);const a=this.b(h);return this.a.set(h,a),a}}t.$ze=f}),ne(ie[7],se([0,1,41,38]),function(O,t,k,D){"use strict";var r;Object.defineProperty(t,"__esModule",{value:!0}),t.$yf=t.$xf=t.$wf=t.$vf=t.GraphemeBreakType=t.$uf=t.$tf=t.$sf=t.$rf=t.$qf=t.$pf=t.$of=t.$nf=t.$mf=t.$lf=t.$kf=t.$jf=t.$if=t.$hf=t.$gf=t.$ff=t.$ef=t.$df=t.$cf=t.$bf=t.$af=t.$_e=t.$$e=t.$0e=t.$9e=t.$8e=t.$7e=t.$6e=t.$5e=t.$4e=t.$3e=t.$2e=t.$1e=t.$Ze=t.$Ye=t.$Xe=t.$We=t.$Ve=t.$Ue=t.$Te=t.$Se=t.$Re=t.$Qe=t.$Pe=t.$Oe=t.$Ne=t.$Me=t.$Le=t.$Ke=t.$Je=t.$Ie=t.$He=t.$Ge=t.$Fe=t.$Ee=t.$De=t.$Ce=void 0;function f(S){return!S||typeof S!="string"?!0:S.trim().length===0}t.$Ce=f;const N=/{(\d+)}/g;function h(S,...U){return U.length===0?S:S.replace(N,function(z,Y){const ue=parseInt(Y,10);return isNaN(ue)||ue<0||ue>=U.length?z:U[ue]})}t.$De=h;const a=/{([^}]+)}/g;function l(S,U){return Object.keys(U).length===0?S:S.replace(a,(z,Y)=>U[Y]??z)}t.$Ee=l;function g(S){return S.replace(/[<>&]/g,function(U){switch(U){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return U}})}t.$Fe=g;function E(S){return S.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}t.$Ge=E;function m(S,U){let z=0;const Y=U.charCodeAt(0);for(let ue=S.length-1;ue>=0;ue--)S.charCodeAt(ue)===Y&&z++;return z}t.$He=m;function b(S,U,z="\u2026"){return S.length<=U?S:`${S.substr(0,U)}${z}`}t.$Ie=b;function e(S,U=" "){const z=L(S,U);return A(z,U)}t.$Je=e;function L(S,U){if(!S||!U)return S;const z=U.length;if(z===0||S.length===0)return S;let Y=0;for(;S.indexOf(U,Y)===Y;)Y=Y+z;return S.substring(Y)}t.$Ke=L;function A(S,U){if(!S||!U)return S;const z=U.length,Y=S.length;if(z===0||Y===0)return S;let ue=Y,ae=-1;for(;ae=S.lastIndexOf(U,ue-1),!(ae===-1||ae+z!==ue);){if(ae===0)return"";ue=ae}return S.substring(0,ue)}t.$Le=A;function p(S){return S.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}t.$Me=p;function $(S){return S.replace(/\*/g,"")}t.$Ne=$;function o(S,U,z={}){if(!S)throw new Error("Cannot create regex from empty string");U||(S=E(S)),z.wholeWord&&(/\B/.test(S.charAt(0))||(S="\\b"+S),/\B/.test(S.charAt(S.length-1))||(S=S+"\\b"));let Y="";return z.global&&(Y+="g"),z.matchCase||(Y+="i"),z.multiline&&(Y+="m"),z.unicode&&(Y+="u"),new RegExp(S,Y)}t.$Oe=o;function c(S){return S.source==="^"||S.source==="^$"||S.source==="$"||S.source==="^\\s*$"?!1:!!(S.exec("")&&S.lastIndex===0)}t.$Pe=c;function s(S){return S.split(/\r\n|\r|\n/)}t.$Qe=s;function i(S){for(let U=0,z=S.length;U<z;U++){const Y=S.charCodeAt(U);if(Y!==32&&Y!==9)return U}return-1}t.$Re=i;function u(S,U=0,z=S.length){for(let Y=U;Y<z;Y++){const ue=S.charCodeAt(Y);if(ue!==32&&ue!==9)return S.substring(U,Y)}return S.substring(U,z)}t.$Se=u;function w(S,U=S.length-1){for(let z=U;z>=0;z--){const Y=S.charCodeAt(z);if(Y!==32&&Y!==9)return z}return-1}t.$Te=w;function d(S,U,z){const Y=[];let ue=0;for(const ae of S.matchAll(U)){if(Y.push(S.slice(ue,ae.index)),ae.index===void 0)throw new Error("match.index should be defined");ue=ae.index+ae[0].length,Y.push(z(ae[0],...ae.slice(1),ae.index,S,ae.groups))}return Y.push(S.slice(ue)),Promise.all(Y).then(ae=>ae.join(""))}t.$Ue=d;function v(S,U){return S<U?-1:S>U?1:0}t.$Ve=v;function R(S,U,z=0,Y=S.length,ue=0,ae=U.length){for(;z<Y&&ue<ae;z++,ue++){const Re=S.charCodeAt(z),fe=U.charCodeAt(ue);if(Re<fe)return-1;if(Re>fe)return 1}const ge=Y-z,ye=ae-ue;return ge<ye?-1:ge>ye?1:0}t.$We=R;function M(S,U){return P(S,U,0,S.length,0,U.length)}t.$Xe=M;function P(S,U,z=0,Y=S.length,ue=0,ae=U.length){for(;z<Y&&ue<ae;z++,ue++){let Re=S.charCodeAt(z),fe=U.charCodeAt(ue);if(Re===fe)continue;if(Re>=128||fe>=128)return R(S.toLowerCase(),U.toLowerCase(),z,Y,ue,ae);F(Re)&&(Re-=32),F(fe)&&(fe-=32);const Le=Re-fe;if(Le!==0)return Le}const ge=Y-z,ye=ae-ue;return ge<ye?-1:ge>ye?1:0}t.$Ye=P;function _(S){return S>=48&&S<=57}t.$Ze=_;function F(S){return S>=97&&S<=122}t.$1e=F;function y(S){return S>=65&&S<=90}t.$2e=y;function I(S,U){return S.length===U.length&&P(S,U)===0}t.$3e=I;function q(S,U){const z=U.length;return U.length>S.length?!1:P(S,U,0,z)===0}t.$4e=q;function x(S,U){const z=Math.min(S.length,U.length);let Y;for(Y=0;Y<z;Y++)if(S.charCodeAt(Y)!==U.charCodeAt(Y))return Y;return z}t.$5e=x;function T(S,U){const z=Math.min(S.length,U.length);let Y;const ue=S.length-1,ae=U.length-1;for(Y=0;Y<z;Y++)if(S.charCodeAt(ue-Y)!==U.charCodeAt(ae-Y))return Y;return z}t.$6e=T;function V(S){return 55296<=S&&S<=56319}t.$7e=V;function H(S){return 56320<=S&&S<=57343}t.$8e=H;function W(S,U){return(S-55296<<10)+(U-56320)+65536}t.$9e=W;function J(S,U,z){const Y=S.charCodeAt(z);if(V(Y)&&z+1<U){const ue=S.charCodeAt(z+1);if(H(ue))return W(Y,ue)}return Y}t.$0e=J;function n(S,U){const z=S.charCodeAt(U-1);if(H(z)&&U>1){const Y=S.charCodeAt(U-2);if(V(Y))return W(Y,z)}return z}class te{get offset(){return this.e}constructor(U,z=0){this.c=U,this.d=U.length,this.e=z}setOffset(U){this.e=U}prevCodePoint(){const U=n(this.c,this.e);return this.e-=U>=65536?2:1,U}nextCodePoint(){const U=J(this.c,this.d,this.e);return this.e+=U>=65536?2:1,U}eol(){return this.e>=this.d}}t.$$e=te;class ce{get offset(){return this.c.offset}constructor(U,z=0){this.c=new te(U,z)}nextGraphemeLength(){const U=$e.getInstance(),z=this.c,Y=z.offset;let ue=U.getGraphemeBreakType(z.nextCodePoint());for(;!z.eol();){const ae=z.offset,ge=U.getGraphemeBreakType(z.nextCodePoint());if(pe(ue,ge)){z.setOffset(ae);break}ue=ge}return z.offset-Y}prevGraphemeLength(){const U=$e.getInstance(),z=this.c,Y=z.offset;let ue=U.getGraphemeBreakType(z.prevCodePoint());for(;z.offset>0;){const ae=z.offset,ge=U.getGraphemeBreakType(z.prevCodePoint());if(pe(ge,ue)){z.setOffset(ae);break}ue=ge}return Y-z.offset}eol(){return this.c.eol()}}t.$_e=ce;function me(S,U){return new ce(S,U).nextGraphemeLength()}t.$af=me;function Ne(S,U){return new ce(S,U).prevGraphemeLength()}t.$bf=Ne;function we(S,U){U>0&&H(S.charCodeAt(U))&&U--;const z=U+me(S,U);return[z-Ne(S,z),z]}t.$cf=we;function Ee(S){const U=new ce(S);let z=0;for(;!U.eol();)z++,U.nextGraphemeLength();return z}t.$df=Ee;let ve;function De(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function _e(S){return ve||(ve=De()),ve.test(S)}t.$ef=_e;const Te=/^[\t\n\r\x20-\x7E]*$/;function Se(S){return Te.test(S)}t.$ff=Se,t.$gf=/[\u2028\u2029]/;function Ae(S){return t.$gf.test(S)}t.$hf=Ae;function B(S){return S>=11904&&S<=55215||S>=63744&&S<=64255||S>=65281&&S<=65374}t.$if=B;function C(S){return S>=127462&&S<=127487||S===8986||S===8987||S===9200||S===9203||S>=9728&&S<=10175||S===11088||S===11093||S>=127744&&S<=128591||S>=128640&&S<=128764||S>=128992&&S<=129008||S>=129280&&S<=129535||S>=129648&&S<=129782}t.$jf=C;function j(S,U){if(S.length<U)return S;const z=/\b/g;let Y=0;for(;z.test(S)&&!(S.length-z.lastIndex<U);)Y=z.lastIndex,z.lastIndex+=1;return S.substring(Y).replace(/^\s/,"")}t.$kf=j;const X=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,ee=/\x1b\].*?\x07/g;function G(S){return S&&(S=S.replace(X,"").replace(ee,"")),S}t.$lf=G,t.$mf=String.fromCharCode(65279);function Z(S){return!!(S&&S.length>0&&S.charCodeAt(0)===65279)}t.$nf=Z;function K(S){return Z(S)?S.substr(1):S}t.$of=K;function Q(S,U){if(!S||!U||S.length<U.length)return!1;const z=U.length,Y=S.toLowerCase();let ue=0,ae=-1;for(;ue<z;){const ge=Y.indexOf(U[ue],ae+1);if(ge<0)return!1;ae=ge,ue++}return!0}t.$pf=Q;function re(S,U=!1){return S?(U&&(S=S.replace(/\\./g,"")),S.toLowerCase()!==S):!1}t.$qf=re;function le(S){return S.charAt(0).toUpperCase()+S.slice(1)}t.$rf=le;function oe(S,U=1){if(U===0)return"";let z=-1;do z=S.indexOf(`
`,z+1),U--;while(U>0&&z>=0);return z===-1?S:(S[z-1]==="\r"&&z--,S.substr(0,z))}t.$sf=oe;function be(S){return S=S%(2*26),S<26?String.fromCharCode(97+S):String.fromCharCode(65+S-26)}t.$tf=be;function de(S){return $e.getInstance().getGraphemeBreakType(S)}t.$uf=de;function pe(S,U){return S===0?U!==5&&U!==7:S===2&&U===3?!1:S===4||S===2||S===3||U===4||U===2||U===3?!0:!(S===8&&(U===8||U===9||U===11||U===12)||(S===11||S===9)&&(U===9||U===10)||(S===12||S===10)&&U===10||U===5||U===13||U===7||S===1||S===13&&U===14||S===6&&U===6)}var Fe;(function(S){S[S.Other=0]="Other",S[S.Prepend=1]="Prepend",S[S.CR=2]="CR",S[S.LF=3]="LF",S[S.Control=4]="Control",S[S.Extend=5]="Extend",S[S.Regional_Indicator=6]="Regional_Indicator",S[S.SpacingMark=7]="SpacingMark",S[S.L=8]="L",S[S.V=9]="V",S[S.T=10]="T",S[S.LV=11]="LV",S[S.LVT=12]="LVT",S[S.ZWJ=13]="ZWJ",S[S.Extended_Pictographic=14]="Extended_Pictographic"})(Fe||(t.GraphemeBreakType=Fe={}));class $e{static getInstance(){return $e.c||($e.c=new $e),$e.c}constructor(){this.d=qe()}getGraphemeBreakType(U){if(U<32)return U===10?3:U===13?2:4;if(U<127)return 0;const z=this.d,Y=z.length/3;let ue=1;for(;ue<=Y;)if(U<z[3*ue])ue=2*ue;else if(U>z[3*ue+1])ue=2*ue+1;else return z[3*ue+2];return 0}}$e.c=null;function qe(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Pe(S,U){if(S===0)return 0;const z=Ue(S,U);if(z!==void 0)return z;const Y=new te(U,S);return Y.prevCodePoint(),Y.offset}t.$vf=Pe;function Ue(S,U){const z=new te(U,S);let Y=z.prevCodePoint();for(;Ve(Y)||Y===65039||Y===8419;){if(z.offset===0)return;Y=z.prevCodePoint()}if(!C(Y))return;let ue=z.offset;return ue>0&&z.prevCodePoint()===8205&&(ue=z.offset),ue}function Ve(S){return 127995<=S&&S<=127999}var je;(function(S){S[S.zwj=8205]="zwj",S[S.emojiVariantSelector=65039]="emojiVariantSelector",S[S.enclosingKeyCap=8419]="enclosingKeyCap"})(je||(je={})),t.$wf="\xA0";class Ie{static getInstance(U){return r.d.get(Array.from(U))}static getLocales(){return r.e.value}constructor(U){this.f=U}isAmbiguous(U){return this.f.has(U)}getPrimaryConfusable(U){return this.f.get(U)}getConfusableCodePoints(){return new Set(this.f.keys())}}t.$xf=Ie,r=Ie,Ie.c=new D.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),Ie.d=new k.$ye(S=>{function U(fe){const Le=new Map;for(let Me=0;Me<fe.length;Me+=2)Le.set(fe[Me],fe[Me+1]);return Le}function z(fe,Le){const Me=new Map(fe);for(const[Be,Oe]of Le)Me.set(Be,Oe);return Me}function Y(fe,Le){if(!fe)return Le;const Me=new Map;for(const[Be,Oe]of fe)Le.has(Be)&&Me.set(Be,Oe);return Me}const ue=r.c.value;let ae=S.filter(fe=>!fe.startsWith("_")&&fe in ue);ae.length===0&&(ae=["_default"]);let ge;for(const fe of ae){const Le=U(ue[fe]);ge=Y(ge,Le)}const ye=U(ue._common),Re=z(ye,ge);return new r(Re)}),Ie.e=new D.$V(()=>Object.keys(r.c.value).filter(S=>!S.startsWith("_")));class ke{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static e(){return this.d||(this.d=new Set(ke.c())),this.d}static isInvisibleCharacter(U){return ke.e().has(U)}static get codePoints(){return ke.e()}}t.$yf=ke,ke.d=void 0}),ne(ie[42],se([0,1,7]),function(O,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ki=t.$Ji=t.$Ii=t.$Hi=t.$Gi=t.$Fi=t.$Ei=void 0;function D(p){return r(p,0)}t.$Ei=D;function r(p,$){switch(typeof p){case"object":return p===null?f(349,$):Array.isArray(p)?a(p,$):l(p,$);case"string":return h(p,$);case"boolean":return N(p,$);case"number":return f(p,$);case"undefined":return f(937,$);default:return f(617,$)}}t.$Fi=r;function f(p,$){return($<<5)-$+p|0}t.$Gi=f;function N(p,$){return f(p?433:863,$)}function h(p,$){$=f(149417,$);for(let o=0,c=p.length;o<c;o++)$=f(p.charCodeAt(o),$);return $}t.$Hi=h;function a(p,$){return $=f(104579,$),p.reduce((o,c)=>r(c,o),$)}function l(p,$){return $=f(181387,$),Object.keys(p).sort().reduce((o,c)=>(o=h(c,o),r(p[c],o)),$)}class g{constructor(){this.g=0}get value(){return this.g}hash($){return this.g=r($,this.g),this.g}}t.$Ii=g;var E;(function(p){p[p.BLOCK_SIZE=64]="BLOCK_SIZE",p[p.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(E||(E={}));function m(p,$,o=32){const c=o-$,s=~((1<<c)-1);return(p<<$|(s&p)>>>c)>>>0}function b(p,$=0,o=p.byteLength,c=0){for(let s=0;s<o;s++)p[$+s]=c}function e(p,$,o="0"){for(;p.length<$;)p=o+p;return p}function L(p,$=32){return p instanceof ArrayBuffer?Array.from(new Uint8Array(p)).map(o=>o.toString(16).padStart(2,"0")).join(""):e((p>>>0).toString(16),$/4)}t.$Ji=L;class A{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update($){const o=$.length;if(o===0)return;const c=this.p;let s=this.r,i=this.u,u,w;for(i!==0?(u=i,w=-1,i=0):(u=$.charCodeAt(0),w=0);;){let d=u;if(k.$7e(u))if(w+1<o){const v=$.charCodeAt(w+1);k.$8e(v)?(w++,d=k.$9e(u,v)):d=65533}else{i=u;break}else k.$8e(u)&&(d=65533);if(s=this.w(c,s,d),w++,w<o)u=$.charCodeAt(w);else break}this.r=s,this.u=i}w($,o,c){return c<128?$[o++]=c:c<2048?($[o++]=192|(c&1984)>>>6,$[o++]=128|(c&63)>>>0):c<65536?($[o++]=224|(c&61440)>>>12,$[o++]=128|(c&4032)>>>6,$[o++]=128|(c&63)>>>0):($[o++]=240|(c&1835008)>>>18,$[o++]=128|(c&258048)>>>12,$[o++]=128|(c&4032)>>>6,$[o++]=128|(c&63)>>>0),o>=64&&(this.y(),o-=64,this.t+=64,$[0]=$[64+0],$[1]=$[64+1],$[2]=$[64+2]),o}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),L(this.h)+L(this.l)+L(this.m)+L(this.n)+L(this.o)}x(){this.p[this.r++]=128,b(this.p,this.r),this.r>56&&(this.y(),b(this.p));const $=8*this.t;this.q.setUint32(56,Math.floor($/4294967296),!1),this.q.setUint32(60,$%4294967296,!1),this.y()}y(){const $=A.g,o=this.q;for(let M=0;M<64;M+=4)$.setUint32(M,o.getUint32(M,!1),!1);for(let M=64;M<320;M+=4)$.setUint32(M,m($.getUint32(M-12,!1)^$.getUint32(M-32,!1)^$.getUint32(M-56,!1)^$.getUint32(M-64,!1),1),!1);let c=this.h,s=this.l,i=this.m,u=this.n,w=this.o,d,v,R;for(let M=0;M<80;M++)M<20?(d=s&i|~s&u,v=1518500249):M<40?(d=s^i^u,v=1859775393):M<60?(d=s&i|s&u|i&u,v=2400959708):(d=s^i^u,v=3395469782),R=m(c,5)+d+w+v+$.getUint32(M*4,!1)&4294967295,w=u,u=i,i=m(s,30),s=c,c=R;this.h=this.h+c&4294967295,this.l=this.l+s&4294967295,this.m=this.m+i&4294967295,this.n=this.n+u&4294967295,this.o=this.o+w&4294967295}}t.$Ki=A,A.g=new DataView(new ArrayBuffer(320))}),ne(ie[25],se([0,1,36,42]),function(O,t,k,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Es=t.$Ds=t.$Cs=void 0;class r{constructor(m){this.a=m}getElements(){const m=this.a,b=new Int32Array(m.length);for(let e=0,L=m.length;e<L;e++)b[e]=m.charCodeAt(e);return b}}t.$Cs=r;function f(E,m,b){return new g(new r(E),new r(m)).ComputeDiff(b).changes}t.$Ds=f;class N{static Assert(m,b){if(!m)throw new Error(b)}}class h{static Copy(m,b,e,L,A){for(let p=0;p<A;p++)e[L+p]=m[b+p]}static Copy2(m,b,e,L,A){for(let p=0;p<A;p++)e[L+p]=m[b+p]}}var a;(function(E){E[E.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})(a||(a={}));class l{constructor(){this.a=[],this.b=1073741824,this.c=1073741824,this.d=0,this.e=0}MarkNextChange(){(this.d>0||this.e>0)&&this.a.push(new k.$Bs(this.b,this.d,this.c,this.e)),this.d=0,this.e=0,this.b=1073741824,this.c=1073741824}AddOriginalElement(m,b){this.b=Math.min(this.b,m),this.c=Math.min(this.c,b),this.d++}AddModifiedElement(m,b){this.b=Math.min(this.b,m),this.c=Math.min(this.c,b),this.e++}getChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a}getReverseChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a.reverse(),this.a}}class g{constructor(m,b,e=null){this.a=e,this.b=m,this.c=b;const[L,A,p]=g.o(m),[$,o,c]=g.o(b);this.d=p&&c,this.e=L,this.f=A,this.g=$,this.h=o,this.k=[],this.m=[]}static n(m){return m.length>0&&typeof m[0]=="string"}static o(m){const b=m.getElements();if(g.n(b)){const e=new Int32Array(b.length);for(let L=0,A=b.length;L<A;L++)e[L]=(0,D.$Hi)(b[L],0);return[b,e,!0]}return b instanceof Int32Array?[[],b,!1]:[[],new Int32Array(b),!1]}p(m,b){return this.f[m]!==this.h[b]?!1:this.d?this.e[m]===this.g[b]:!0}q(m,b){if(!this.p(m,b))return!1;const e=g.r(this.b,m),L=g.r(this.c,b);return e===L}static r(m,b){return typeof m.getStrictElement=="function"?m.getStrictElement(b):null}s(m,b){return this.f[m]!==this.f[b]?!1:this.d?this.e[m]===this.e[b]:!0}u(m,b){return this.h[m]!==this.h[b]?!1:this.d?this.g[m]===this.g[b]:!0}ComputeDiff(m){return this.v(0,this.f.length-1,0,this.h.length-1,m)}v(m,b,e,L,A){const p=[!1];let $=this.w(m,b,e,L,p);return A&&($=this.z($)),{quitEarly:p[0],changes:$}}w(m,b,e,L,A){for(A[0]=!1;m<=b&&e<=L&&this.p(m,e);)m++,e++;for(;b>=m&&L>=e&&this.p(b,L);)b--,L--;if(m>b||e>L){let i;return e<=L?(N.Assert(m===b+1,"originalStart should only be one more than originalEnd"),i=[new k.$Bs(m,0,e,L-e+1)]):m<=b?(N.Assert(e===L+1,"modifiedStart should only be one more than modifiedEnd"),i=[new k.$Bs(m,b-m+1,e,0)]):(N.Assert(m===b+1,"originalStart should only be one more than originalEnd"),N.Assert(e===L+1,"modifiedStart should only be one more than modifiedEnd"),i=[]),i}const p=[0],$=[0],o=this.y(m,b,e,L,p,$,A),c=p[0],s=$[0];if(o!==null)return o;if(!A[0]){const i=this.w(m,c,e,s,A);let u=[];return A[0]?u=[new k.$Bs(c+1,b-(c+1)+1,s+1,L-(s+1)+1)]:u=this.w(c+1,b,s+1,L,A),this.H(i,u)}return[new k.$Bs(m,b-m+1,e,L-e+1)]}x(m,b,e,L,A,p,$,o,c,s,i,u,w,d,v,R,M,P){let _=null,F=null,y=new l,I=b,q=e,x=w[0]-R[0]-L,T=-1073741824,V=this.k.length-1;do{const H=x+m;H===I||H<q&&c[H-1]<c[H+1]?(i=c[H+1],d=i-x-L,i<T&&y.MarkNextChange(),T=i,y.AddModifiedElement(i+1,d),x=H+1-m):(i=c[H-1]+1,d=i-x-L,i<T&&y.MarkNextChange(),T=i-1,y.AddOriginalElement(i,d+1),x=H-1-m),V>=0&&(c=this.k[V],m=c[0],I=1,q=c.length-1)}while(--V>=-1);if(_=y.getReverseChanges(),P[0]){let H=w[0]+1,W=R[0]+1;if(_!==null&&_.length>0){const J=_[_.length-1];H=Math.max(H,J.getOriginalEnd()),W=Math.max(W,J.getModifiedEnd())}F=[new k.$Bs(H,u-H+1,W,v-W+1)]}else{y=new l,I=p,q=$,x=w[0]-R[0]-o,T=1073741824,V=M?this.m.length-1:this.m.length-2;do{const H=x+A;H===I||H<q&&s[H-1]>=s[H+1]?(i=s[H+1]-1,d=i-x-o,i>T&&y.MarkNextChange(),T=i+1,y.AddOriginalElement(i+1,d+1),x=H+1-A):(i=s[H-1],d=i-x-o,i>T&&y.MarkNextChange(),T=i,y.AddModifiedElement(i+1,d+1),x=H-1-A),V>=0&&(s=this.m[V],A=s[0],I=1,q=s.length-1)}while(--V>=-1);F=y.getChanges()}return this.H(_,F)}y(m,b,e,L,A,p,$){let o=0,c=0,s=0,i=0,u=0,w=0;m--,e--,A[0]=0,p[0]=0,this.k=[],this.m=[];const d=b-m+(L-e),v=d+1,R=new Int32Array(v),M=new Int32Array(v),P=L-e,_=b-m,F=m-e,y=b-L,q=(_-P)%2===0;R[P]=m,M[_]=b,$[0]=!1;for(let x=1;x<=d/2+1;x++){let T=0,V=0;s=this.J(P-x,x,P,v),i=this.J(P+x,x,P,v);for(let W=s;W<=i;W+=2){W===s||W<i&&R[W-1]<R[W+1]?o=R[W+1]:o=R[W-1]+1,c=o-(W-P)-F;const J=o;for(;o<b&&c<L&&this.p(o+1,c+1);)o++,c++;if(R[W]=o,o+c>T+V&&(T=o,V=c),!q&&Math.abs(W-_)<=x-1&&o>=M[W])return A[0]=o,p[0]=c,J<=M[W]&&1447>0&&x<=1447+1?this.x(P,s,i,F,_,u,w,y,R,M,o,b,A,c,L,p,q,$):null}const H=(T-m+(V-e)-x)/2;if(this.a!==null&&!this.a(T,H))return $[0]=!0,A[0]=T,p[0]=V,H>0&&1447>0&&x<=1447+1?this.x(P,s,i,F,_,u,w,y,R,M,o,b,A,c,L,p,q,$):(m++,e++,[new k.$Bs(m,b-m+1,e,L-e+1)]);u=this.J(_-x,x,_,v),w=this.J(_+x,x,_,v);for(let W=u;W<=w;W+=2){W===u||W<w&&M[W-1]>=M[W+1]?o=M[W+1]-1:o=M[W-1],c=o-(W-_)-y;const J=o;for(;o>m&&c>e&&this.p(o,c);)o--,c--;if(M[W]=o,q&&Math.abs(W-P)<=x&&o<=R[W])return A[0]=o,p[0]=c,J>=R[W]&&1447>0&&x<=1447+1?this.x(P,s,i,F,_,u,w,y,R,M,o,b,A,c,L,p,q,$):null}if(x<=1447){let W=new Int32Array(i-s+2);W[0]=P-s+1,h.Copy2(R,s,W,1,i-s+1),this.k.push(W),W=new Int32Array(w-u+2),W[0]=_-u+1,h.Copy2(M,u,W,1,w-u+1),this.m.push(W)}}return this.x(P,s,i,F,_,u,w,y,R,M,o,b,A,c,L,p,q,$)}z(m){for(let b=0;b<m.length;b++){const e=m[b],L=b<m.length-1?m[b+1].originalStart:this.f.length,A=b<m.length-1?m[b+1].modifiedStart:this.h.length,p=e.originalLength>0,$=e.modifiedLength>0;for(;e.originalStart+e.originalLength<L&&e.modifiedStart+e.modifiedLength<A&&(!p||this.s(e.originalStart,e.originalStart+e.originalLength))&&(!$||this.u(e.modifiedStart,e.modifiedStart+e.modifiedLength));){const c=this.q(e.originalStart,e.modifiedStart);if(this.q(e.originalStart+e.originalLength,e.modifiedStart+e.modifiedLength)&&!c)break;e.originalStart++,e.modifiedStart++}const o=[null];if(b<m.length-1&&this.I(m[b],m[b+1],o)){m[b]=o[0],m.splice(b+1,1),b--;continue}}for(let b=m.length-1;b>=0;b--){const e=m[b];let L=0,A=0;if(b>0){const i=m[b-1];L=i.originalStart+i.originalLength,A=i.modifiedStart+i.modifiedLength}const p=e.originalLength>0,$=e.modifiedLength>0;let o=0,c=this.G(e.originalStart,e.originalLength,e.modifiedStart,e.modifiedLength);for(let i=1;;i++){const u=e.originalStart-i,w=e.modifiedStart-i;if(u<L||w<A||p&&!this.s(u,u+e.originalLength)||$&&!this.u(w,w+e.modifiedLength))break;const v=(u===L&&w===A?5:0)+this.G(u,e.originalLength,w,e.modifiedLength);v>c&&(c=v,o=i)}e.originalStart-=o,e.modifiedStart-=o;const s=[null];if(b>0&&this.I(m[b-1],m[b],s)){m[b-1]=s[0],m.splice(b,1),b++;continue}}if(this.d)for(let b=1,e=m.length;b<e;b++){const L=m[b-1],A=m[b],p=A.originalStart-L.originalStart-L.originalLength,$=L.originalStart,o=A.originalStart+A.originalLength,c=o-$,s=L.modifiedStart,i=A.modifiedStart+A.modifiedLength,u=i-s;if(p<5&&c<20&&u<20){const w=this.A($,c,s,u,p);if(w){const[d,v]=w;(d!==L.originalStart+L.originalLength||v!==L.modifiedStart+L.modifiedLength)&&(L.originalLength=d-L.originalStart,L.modifiedLength=v-L.modifiedStart,A.originalStart=d+p,A.modifiedStart=v+p,A.originalLength=o-A.originalStart,A.modifiedLength=i-A.modifiedStart)}}}return m}A(m,b,e,L,A){if(b<A||L<A)return null;const p=m+b-A+1,$=e+L-A+1;let o=0,c=0,s=0;for(let i=m;i<p;i++)for(let u=e;u<$;u++){const w=this.B(i,u,A);w>0&&w>o&&(o=w,c=i,s=u)}return o>0?[c,s]:null}B(m,b,e){let L=0;for(let A=0;A<e;A++){if(!this.p(m+A,b+A))return 0;L+=this.e[m+A].length}return L}C(m){return m<=0||m>=this.f.length-1?!0:this.d&&/^\s*$/.test(this.e[m])}D(m,b){if(this.C(m)||this.C(m-1))return!0;if(b>0){const e=m+b;if(this.C(e-1)||this.C(e))return!0}return!1}E(m){return m<=0||m>=this.h.length-1?!0:this.d&&/^\s*$/.test(this.g[m])}F(m,b){if(this.E(m)||this.E(m-1))return!0;if(b>0){const e=m+b;if(this.E(e-1)||this.E(e))return!0}return!1}G(m,b,e,L){const A=this.D(m,b)?1:0,p=this.F(e,L)?1:0;return A+p}H(m,b){const e=[];if(m.length===0||b.length===0)return b.length>0?b:m;if(this.I(m[m.length-1],b[0],e)){const L=new Array(m.length+b.length-1);return h.Copy(m,0,L,0,m.length-1),L[m.length-1]=e[0],h.Copy(b,1,L,m.length,b.length-1),L}else{const L=new Array(m.length+b.length);return h.Copy(m,0,L,0,m.length),h.Copy(b,0,L,m.length,b.length),L}}I(m,b,e){if(N.Assert(m.originalStart<=b.originalStart,"Left change is not less than or equal to right change"),N.Assert(m.modifiedStart<=b.modifiedStart,"Left change is not less than or equal to right change"),m.originalStart+m.originalLength>=b.originalStart||m.modifiedStart+m.modifiedLength>=b.modifiedStart){const L=m.originalStart;let A=m.originalLength;const p=m.modifiedStart;let $=m.modifiedLength;return m.originalStart+m.originalLength>=b.originalStart&&(A=b.originalStart+b.originalLength-m.originalStart),m.modifiedStart+m.modifiedLength>=b.modifiedStart&&($=b.modifiedStart+b.modifiedLength-m.modifiedStart),e[0]=new k.$Bs(L,A,p,$),!0}else return e[0]=null,!1}J(m,b,e,L){if(m>=0&&m<L)return m;const A=e,p=L-e-1,$=b%2===0;if(m<0){const o=A%2===0;return $===o?0:1}else{const o=p%2===0;return $===o?L-1:L-2}}}t.$Es=g}),ne(ie[26],se([0,1]),function(O,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Qf=t.$Pf=t.$Of=t.$Nf=t.$Mf=t.$Lf=t.$Kf=t.$Jf=t.$If=t.$Hf=t.$Gf=t.$Ff=t.$Ef=t.$Df=t.$Cf=t.$Bf=t.$Af=t.$zf=void 0;function k(s){return typeof s=="string"}t.$zf=k;function D(s){return Array.isArray(s)&&s.every(i=>k(i))}t.$Af=D;function r(s){return typeof s=="object"&&s!==null&&!Array.isArray(s)&&!(s instanceof RegExp)&&!(s instanceof Date)}t.$Bf=r;function f(s){const i=Object.getPrototypeOf(Uint8Array);return typeof s=="object"&&s instanceof i}t.$Cf=f;function N(s){return typeof s=="number"&&!isNaN(s)}t.$Df=N;function h(s){return!!s&&typeof s[Symbol.iterator]=="function"}t.$Ef=h;function a(s){return s===!0||s===!1}t.$Ff=a;function l(s){return typeof s>"u"}t.$Gf=l;function g(s){return!E(s)}t.$Hf=g;function E(s){return l(s)||s===null}t.$If=E;function m(s,i){if(!s)throw new Error(i?`Unexpected type, expected '${i}'`:"Unexpected type")}t.$Jf=m;function b(s){if(E(s))throw new Error("Assertion Failed: argument is undefined or null");return s}t.$Kf=b;function e(...s){const i=[];for(let u=0;u<s.length;u++){const w=s[u];if(E(w))throw new Error(`Assertion Failed: argument at index ${u} is undefined or null`);i.push(w)}return i}t.$Lf=e;const L=Object.prototype.hasOwnProperty;function A(s){if(!r(s))return!1;for(const i in s)if(L.call(s,i))return!1;return!0}t.$Mf=A;function p(s){return typeof s=="function"}t.$Nf=p;function $(...s){return s.length>0&&s.every(p)}t.$Of=$;function o(s,i){const u=Math.min(s.length,i.length);for(let w=0;w<u;w++)c(s[w],i[w])}t.$Pf=o;function c(s,i){if(k(i)){if(typeof s!==i)throw new Error(`argument does not match constraint: typeof ${i}`)}else if(p(i)){try{if(s instanceof i)return}catch{}if(!E(s)&&s.constructor===i||i.length===1&&i.call(void 0,s)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}t.$Qf=c}),ne(ie[43],se([0,1,26]),function(O,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Vj=t.$Uj=t.$Tj=void 0;const D=Object.create(null);function r(h,a){if((0,k.$zf)(a)){const l=D[a];if(l===void 0)throw new Error(`${h} references an unknown codicon: ${a}`);a=l}return D[h]=a,{id:h}}function f(){return D}t.$Tj=f;function N(){return Object.values(t.$Vj)}t.$Uj=N,t.$Vj={add:r("add",6e4),plus:r("plus",6e4),gistNew:r("gist-new",6e4),repoCreate:r("repo-create",6e4),lightbulb:r("lightbulb",60001),lightBulb:r("light-bulb",60001),repo:r("repo",60002),repoDelete:r("repo-delete",60002),gistFork:r("gist-fork",60003),repoForked:r("repo-forked",60003),gitPullRequest:r("git-pull-request",60004),gitPullRequestAbandoned:r("git-pull-request-abandoned",60004),recordKeys:r("record-keys",60005),keyboard:r("keyboard",60005),tag:r("tag",60006),tagAdd:r("tag-add",60006),tagRemove:r("tag-remove",60006),gitPullRequestLabel:r("git-pull-request-label",60006),person:r("person",60007),personFollow:r("person-follow",60007),personOutline:r("person-outline",60007),personFilled:r("person-filled",60007),gitBranch:r("git-branch",60008),gitBranchCreate:r("git-branch-create",60008),gitBranchDelete:r("git-branch-delete",60008),sourceControl:r("source-control",60008),mirror:r("mirror",60009),mirrorPublic:r("mirror-public",60009),star:r("star",60010),starAdd:r("star-add",60010),starDelete:r("star-delete",60010),starEmpty:r("star-empty",60010),comment:r("comment",60011),commentAdd:r("comment-add",60011),alert:r("alert",60012),warning:r("warning",60012),search:r("search",60013),searchSave:r("search-save",60013),logOut:r("log-out",60014),signOut:r("sign-out",60014),logIn:r("log-in",60015),signIn:r("sign-in",60015),eye:r("eye",60016),eyeUnwatch:r("eye-unwatch",60016),eyeWatch:r("eye-watch",60016),circleFilled:r("circle-filled",60017),primitiveDot:r("primitive-dot",60017),closeDirty:r("close-dirty",60017),debugBreakpoint:r("debug-breakpoint",60017),debugBreakpointDisabled:r("debug-breakpoint-disabled",60017),debugHint:r("debug-hint",60017),primitiveSquare:r("primitive-square",60018),edit:r("edit",60019),pencil:r("pencil",60019),info:r("info",60020),issueOpened:r("issue-opened",60020),gistPrivate:r("gist-private",60021),gitForkPrivate:r("git-fork-private",60021),lock:r("lock",60021),mirrorPrivate:r("mirror-private",60021),close:r("close",60022),removeClose:r("remove-close",60022),x:r("x",60022),repoSync:r("repo-sync",60023),sync:r("sync",60023),clone:r("clone",60024),desktopDownload:r("desktop-download",60024),beaker:r("beaker",60025),microscope:r("microscope",60025),vm:r("vm",60026),deviceDesktop:r("device-desktop",60026),file:r("file",60027),fileText:r("file-text",60027),more:r("more",60028),ellipsis:r("ellipsis",60028),kebabHorizontal:r("kebab-horizontal",60028),mailReply:r("mail-reply",60029),reply:r("reply",60029),organization:r("organization",60030),organizationFilled:r("organization-filled",60030),organizationOutline:r("organization-outline",60030),newFile:r("new-file",60031),fileAdd:r("file-add",60031),newFolder:r("new-folder",60032),fileDirectoryCreate:r("file-directory-create",60032),trash:r("trash",60033),trashcan:r("trashcan",60033),history:r("history",60034),clock:r("clock",60034),folder:r("folder",60035),fileDirectory:r("file-directory",60035),symbolFolder:r("symbol-folder",60035),logoGithub:r("logo-github",60036),markGithub:r("mark-github",60036),github:r("github",60036),terminal:r("terminal",60037),console:r("console",60037),repl:r("repl",60037),zap:r("zap",60038),symbolEvent:r("symbol-event",60038),error:r("error",60039),stop:r("stop",60039),variable:r("variable",60040),symbolVariable:r("symbol-variable",60040),array:r("array",60042),symbolArray:r("symbol-array",60042),symbolModule:r("symbol-module",60043),symbolPackage:r("symbol-package",60043),symbolNamespace:r("symbol-namespace",60043),symbolObject:r("symbol-object",60043),symbolMethod:r("symbol-method",60044),symbolFunction:r("symbol-function",60044),symbolConstructor:r("symbol-constructor",60044),symbolBoolean:r("symbol-boolean",60047),symbolNull:r("symbol-null",60047),symbolNumeric:r("symbol-numeric",60048),symbolNumber:r("symbol-number",60048),symbolStructure:r("symbol-structure",60049),symbolStruct:r("symbol-struct",60049),symbolParameter:r("symbol-parameter",60050),symbolTypeParameter:r("symbol-type-parameter",60050),symbolKey:r("symbol-key",60051),symbolText:r("symbol-text",60051),symbolReference:r("symbol-reference",60052),goToFile:r("go-to-file",60052),symbolEnum:r("symbol-enum",60053),symbolValue:r("symbol-value",60053),symbolRuler:r("symbol-ruler",60054),symbolUnit:r("symbol-unit",60054),activateBreakpoints:r("activate-breakpoints",60055),archive:r("archive",60056),arrowBoth:r("arrow-both",60057),arrowDown:r("arrow-down",60058),arrowLeft:r("arrow-left",60059),arrowRight:r("arrow-right",60060),arrowSmallDown:r("arrow-small-down",60061),arrowSmallLeft:r("arrow-small-left",60062),arrowSmallRight:r("arrow-small-right",60063),arrowSmallUp:r("arrow-small-up",60064),arrowUp:r("arrow-up",60065),bell:r("bell",60066),bold:r("bold",60067),book:r("book",60068),bookmark:r("bookmark",60069),debugBreakpointConditionalUnverified:r("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:r("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:r("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:r("debug-breakpoint-data-unverified",60072),debugBreakpointData:r("debug-breakpoint-data",60073),debugBreakpointDataDisabled:r("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:r("debug-breakpoint-log-unverified",60074),debugBreakpointLog:r("debug-breakpoint-log",60075),debugBreakpointLogDisabled:r("debug-breakpoint-log-disabled",60075),briefcase:r("briefcase",60076),broadcast:r("broadcast",60077),browser:r("browser",60078),bug:r("bug",60079),calendar:r("calendar",60080),caseSensitive:r("case-sensitive",60081),check:r("check",60082),checklist:r("checklist",60083),chevronDown:r("chevron-down",60084),dropDownButton:r("drop-down-button",60084),chevronLeft:r("chevron-left",60085),chevronRight:r("chevron-right",60086),chevronUp:r("chevron-up",60087),chromeClose:r("chrome-close",60088),chromeMaximize:r("chrome-maximize",60089),chromeMinimize:r("chrome-minimize",60090),chromeRestore:r("chrome-restore",60091),circle:r("circle",60092),circleOutline:r("circle-outline",60092),debugBreakpointUnverified:r("debug-breakpoint-unverified",60092),circleSlash:r("circle-slash",60093),circuitBoard:r("circuit-board",60094),clearAll:r("clear-all",60095),clippy:r("clippy",60096),closeAll:r("close-all",60097),cloudDownload:r("cloud-download",60098),cloudUpload:r("cloud-upload",60099),code:r("code",60100),collapseAll:r("collapse-all",60101),colorMode:r("color-mode",60102),commentDiscussion:r("comment-discussion",60103),compareChanges:r("compare-changes",60157),creditCard:r("credit-card",60105),dash:r("dash",60108),dashboard:r("dashboard",60109),database:r("database",60110),debugContinue:r("debug-continue",60111),debugDisconnect:r("debug-disconnect",60112),debugPause:r("debug-pause",60113),debugRestart:r("debug-restart",60114),debugStart:r("debug-start",60115),debugStepInto:r("debug-step-into",60116),debugStepOut:r("debug-step-out",60117),debugStepOver:r("debug-step-over",60118),debugStop:r("debug-stop",60119),debug:r("debug",60120),deviceCameraVideo:r("device-camera-video",60121),deviceCamera:r("device-camera",60122),deviceMobile:r("device-mobile",60123),diffAdded:r("diff-added",60124),diffIgnored:r("diff-ignored",60125),diffModified:r("diff-modified",60126),diffRemoved:r("diff-removed",60127),diffRenamed:r("diff-renamed",60128),diff:r("diff",60129),discard:r("discard",60130),editorLayout:r("editor-layout",60131),emptyWindow:r("empty-window",60132),exclude:r("exclude",60133),extensions:r("extensions",60134),eyeClosed:r("eye-closed",60135),fileBinary:r("file-binary",60136),fileCode:r("file-code",60137),fileMedia:r("file-media",60138),filePdf:r("file-pdf",60139),fileSubmodule:r("file-submodule",60140),fileSymlinkDirectory:r("file-symlink-directory",60141),fileSymlinkFile:r("file-symlink-file",60142),fileZip:r("file-zip",60143),files:r("files",60144),filter:r("filter",60145),flame:r("flame",60146),foldDown:r("fold-down",60147),foldUp:r("fold-up",60148),fold:r("fold",60149),folderActive:r("folder-active",60150),folderOpened:r("folder-opened",60151),gear:r("gear",60152),gift:r("gift",60153),gistSecret:r("gist-secret",60154),gist:r("gist",60155),gitCommit:r("git-commit",60156),gitCompare:r("git-compare",60157),gitMerge:r("git-merge",60158),githubAction:r("github-action",60159),githubAlt:r("github-alt",60160),globe:r("globe",60161),grabber:r("grabber",60162),graph:r("graph",60163),gripper:r("gripper",60164),heart:r("heart",60165),home:r("home",60166),horizontalRule:r("horizontal-rule",60167),hubot:r("hubot",60168),inbox:r("inbox",60169),issueClosed:r("issue-closed",60324),issueReopened:r("issue-reopened",60171),issues:r("issues",60172),italic:r("italic",60173),jersey:r("jersey",60174),json:r("json",60175),bracket:r("bracket",60175),kebabVertical:r("kebab-vertical",60176),key:r("key",60177),law:r("law",60178),lightbulbAutofix:r("lightbulb-autofix",60179),linkExternal:r("link-external",60180),link:r("link",60181),listOrdered:r("list-ordered",60182),listUnordered:r("list-unordered",60183),liveShare:r("live-share",60184),loading:r("loading",60185),location:r("location",60186),mailRead:r("mail-read",60187),mail:r("mail",60188),markdown:r("markdown",60189),megaphone:r("megaphone",60190),mention:r("mention",60191),milestone:r("milestone",60192),gitPullRequestMilestone:r("git-pull-request-milestone",60192),mortarBoard:r("mortar-board",60193),move:r("move",60194),multipleWindows:r("multiple-windows",60195),mute:r("mute",60196),noNewline:r("no-newline",60197),note:r("note",60198),octoface:r("octoface",60199),openPreview:r("open-preview",60200),package:r("package",60201),paintcan:r("paintcan",60202),pin:r("pin",60203),play:r("play",60204),run:r("run",60204),plug:r("plug",60205),preserveCase:r("preserve-case",60206),preview:r("preview",60207),project:r("project",60208),pulse:r("pulse",60209),question:r("question",60210),quote:r("quote",60211),radioTower:r("radio-tower",60212),reactions:r("reactions",60213),references:r("references",60214),refresh:r("refresh",60215),regex:r("regex",60216),remoteExplorer:r("remote-explorer",60217),remote:r("remote",60218),remove:r("remove",60219),replaceAll:r("replace-all",60220),replace:r("replace",60221),repoClone:r("repo-clone",60222),repoForcePush:r("repo-force-push",60223),repoPull:r("repo-pull",60224),repoPush:r("repo-push",60225),report:r("report",60226),requestChanges:r("request-changes",60227),rocket:r("rocket",60228),rootFolderOpened:r("root-folder-opened",60229),rootFolder:r("root-folder",60230),rss:r("rss",60231),ruby:r("ruby",60232),saveAll:r("save-all",60233),saveAs:r("save-as",60234),save:r("save",60235),screenFull:r("screen-full",60236),screenNormal:r("screen-normal",60237),searchStop:r("search-stop",60238),server:r("server",60240),settingsGear:r("settings-gear",60241),settings:r("settings",60242),shield:r("shield",60243),smiley:r("smiley",60244),sortPrecedence:r("sort-precedence",60245),splitHorizontal:r("split-horizontal",60246),splitVertical:r("split-vertical",60247),squirrel:r("squirrel",60248),starFull:r("star-full",60249),starHalf:r("star-half",60250),symbolClass:r("symbol-class",60251),symbolColor:r("symbol-color",60252),symbolCustomColor:r("symbol-customcolor",60252),symbolConstant:r("symbol-constant",60253),symbolEnumMember:r("symbol-enum-member",60254),symbolField:r("symbol-field",60255),symbolFile:r("symbol-file",60256),symbolInterface:r("symbol-interface",60257),symbolKeyword:r("symbol-keyword",60258),symbolMisc:r("symbol-misc",60259),symbolOperator:r("symbol-operator",60260),symbolProperty:r("symbol-property",60261),wrench:r("wrench",60261),wrenchSubaction:r("wrench-subaction",60261),symbolSnippet:r("symbol-snippet",60262),tasklist:r("tasklist",60263),telescope:r("telescope",60264),textSize:r("text-size",60265),threeBars:r("three-bars",60266),thumbsdown:r("thumbsdown",60267),thumbsup:r("thumbsup",60268),tools:r("tools",60269),triangleDown:r("triangle-down",60270),triangleLeft:r("triangle-left",60271),triangleRight:r("triangle-right",60272),triangleUp:r("triangle-up",60273),twitter:r("twitter",60274),unfold:r("unfold",60275),unlock:r("unlock",60276),unmute:r("unmute",60277),unverified:r("unverified",60278),verified:r("verified",60279),versions:r("versions",60280),vmActive:r("vm-active",60281),vmOutline:r("vm-outline",60282),vmRunning:r("vm-running",60283),watch:r("watch",60284),whitespace:r("whitespace",60285),wholeWord:r("whole-word",60286),window:r("window",60287),wordWrap:r("word-wrap",60288),zoomIn:r("zoom-in",60289),zoomOut:r("zoom-out",60290),listFilter:r("list-filter",60291),listFlat:r("list-flat",60292),listSelection:r("list-selection",60293),selection:r("selection",60293),listTree:r("list-tree",60294),debugBreakpointFunctionUnverified:r("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:r("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:r("debug-breakpoint-function-disabled",60296),debugStackframeActive:r("debug-stackframe-active",60297),circleSmallFilled:r("circle-small-filled",60298),debugStackframeDot:r("debug-stackframe-dot",60298),debugStackframe:r("debug-stackframe",60299),debugStackframeFocused:r("debug-stackframe-focused",60299),debugBreakpointUnsupported:r("debug-breakpoint-unsupported",60300),symbolString:r("symbol-string",60301),debugReverseContinue:r("debug-reverse-continue",60302),debugStepBack:r("debug-step-back",60303),debugRestartFrame:r("debug-restart-frame",60304),callIncoming:r("call-incoming",60306),callOutgoing:r("call-outgoing",60307),menu:r("menu",60308),expandAll:r("expand-all",60309),feedback:r("feedback",60310),gitPullRequestReviewer:r("git-pull-request-reviewer",60310),groupByRefType:r("group-by-ref-type",60311),ungroupByRefType:r("ungroup-by-ref-type",60312),account:r("account",60313),gitPullRequestAssignee:r("git-pull-request-assignee",60313),bellDot:r("bell-dot",60314),debugConsole:r("debug-console",60315),library:r("library",60316),output:r("output",60317),runAll:r("run-all",60318),syncIgnored:r("sync-ignored",60319),pinned:r("pinned",60320),githubInverted:r("github-inverted",60321),debugAlt:r("debug-alt",60305),serverProcess:r("server-process",60322),serverEnvironment:r("server-environment",60323),pass:r("pass",60324),stopCircle:r("stop-circle",60325),playCircle:r("play-circle",60326),record:r("record",60327),debugAltSmall:r("debug-alt-small",60328),vmConnect:r("vm-connect",60329),cloud:r("cloud",60330),merge:r("merge",60331),exportIcon:r("export",60332),graphLeft:r("graph-left",60333),magnet:r("magnet",60334),notebook:r("notebook",60335),redo:r("redo",60336),checkAll:r("check-all",60337),pinnedDirty:r("pinned-dirty",60338),passFilled:r("pass-filled",60339),circleLargeFilled:r("circle-large-filled",60340),circleLarge:r("circle-large",60341),circleLargeOutline:r("circle-large-outline",60341),combine:r("combine",60342),gather:r("gather",60342),table:r("table",60343),variableGroup:r("variable-group",60344),typeHierarchy:r("type-hierarchy",60345),typeHierarchySub:r("type-hierarchy-sub",60346),typeHierarchySuper:r("type-hierarchy-super",60347),gitPullRequestCreate:r("git-pull-request-create",60348),runAbove:r("run-above",60349),runBelow:r("run-below",60350),notebookTemplate:r("notebook-template",60351),debugRerun:r("debug-rerun",60352),workspaceTrusted:r("workspace-trusted",60353),workspaceUntrusted:r("workspace-untrusted",60354),workspaceUnspecified:r("workspace-unspecified",60355),terminalCmd:r("terminal-cmd",60356),terminalDebian:r("terminal-debian",60357),terminalLinux:r("terminal-linux",60358),terminalPowershell:r("terminal-powershell",60359),terminalTmux:r("terminal-tmux",60360),terminalUbuntu:r("terminal-ubuntu",60361),terminalBash:r("terminal-bash",60362),arrowSwap:r("arrow-swap",60363),copy:r("copy",60364),personAdd:r("person-add",60365),filterFilled:r("filter-filled",60366),wand:r("wand",60367),debugLineByLine:r("debug-line-by-line",60368),inspect:r("inspect",60369),layers:r("layers",60370),layersDot:r("layers-dot",60371),layersActive:r("layers-active",60372),compass:r("compass",60373),compassDot:r("compass-dot",60374),compassActive:r("compass-active",60375),azure:r("azure",60376),issueDraft:r("issue-draft",60377),gitPullRequestClosed:r("git-pull-request-closed",60378),gitPullRequestDraft:r("git-pull-request-draft",60379),debugAll:r("debug-all",60380),debugCoverage:r("debug-coverage",60381),runErrors:r("run-errors",60382),folderLibrary:r("folder-library",60383),debugContinueSmall:r("debug-continue-small",60384),beakerStop:r("beaker-stop",60385),graphLine:r("graph-line",60386),graphScatter:r("graph-scatter",60387),pieChart:r("pie-chart",60388),bracketDot:r("bracket-dot",60389),bracketError:r("bracket-error",60390),lockSmall:r("lock-small",60391),azureDevops:r("azure-devops",60392),verifiedFilled:r("verified-filled",60393),newLine:r("newline",60394),layout:r("layout",60395),layoutActivitybarLeft:r("layout-activitybar-left",60396),layoutActivitybarRight:r("layout-activitybar-right",60397),layoutPanelLeft:r("layout-panel-left",60398),layoutPanelCenter:r("layout-panel-center",60399),layoutPanelJustify:r("layout-panel-justify",60400),layoutPanelRight:r("layout-panel-right",60401),layoutPanel:r("layout-panel",60402),layoutSidebarLeft:r("layout-sidebar-left",60403),layoutSidebarRight:r("layout-sidebar-right",60404),layoutStatusbar:r("layout-statusbar",60405),layoutMenubar:r("layout-menubar",60406),layoutCentered:r("layout-centered",60407),layoutSidebarRightOff:r("layout-sidebar-right-off",60416),layoutPanelOff:r("layout-panel-off",60417),layoutSidebarLeftOff:r("layout-sidebar-left-off",60418),target:r("target",60408),indent:r("indent",60409),recordSmall:r("record-small",60410),errorSmall:r("error-small",60411),arrowCircleDown:r("arrow-circle-down",60412),arrowCircleLeft:r("arrow-circle-left",60413),arrowCircleRight:r("arrow-circle-right",60414),arrowCircleUp:r("arrow-circle-up",60415),heartFilled:r("heart-filled",60420),map:r("map",60421),mapFilled:r("map-filled",60422),circleSmall:r("circle-small",60423),bellSlash:r("bell-slash",60424),bellSlashDot:r("bell-slash-dot",60425),commentUnresolved:r("comment-unresolved",60426),gitPullRequestGoToChanges:r("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:r("git-pull-request-new-changes",60428),searchFuzzy:r("search-fuzzy",60429),commentDraft:r("comment-draft",60430),send:r("send",60431),sparkle:r("sparkle",60432),insert:r("insert",60433),mic:r("mic",60434),thumbsDownFilled:r("thumbsdown-filled",60435),thumbsUpFilled:r("thumbsup-filled",60436),coffee:r("coffee",60437),snake:r("snake",60438),game:r("game",60439),vr:r("vr",60440),chip:r("chip",60441),piano:r("piano",60442),music:r("music",60443),micFilled:r("mic-filled",60444),gitFetch:r("git-fetch",60445),copilot:r("copilot",60446),dialogError:r("dialog-error","error"),dialogWarning:r("dialog-warning","warning"),dialogInfo:r("dialog-info","info"),dialogClose:r("dialog-close","close"),treeItemExpanded:r("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:r("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:r("tree-filter-on-type-off","list-selection"),treeFilterClear:r("tree-filter-clear","close"),treeItemLoading:r("tree-item-loading","loading"),menuSelection:r("menu-selection","check"),menuSubmenu:r("menu-submenu","chevron-right"),menuBarMore:r("menubar-more","more"),scrollbarButtonLeft:r("scrollbar-button-left","triangle-left"),scrollbarButtonRight:r("scrollbar-button-right","triangle-right"),scrollbarButtonUp:r("scrollbar-button-up","triangle-up"),scrollbarButtonDown:r("scrollbar-button-down","triangle-down"),toolBarMore:r("toolbar-more","more"),quickInputBack:r("quick-input-back","arrow-left")}}),ne(ie[15],se([0,1,26]),function(O,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$kn=t.$jn=t.$in=t.$hn=t.$gn=t.$fn=t.$en=t.$dn=t.$cn=t.$bn=t.$an=t.$_m=t.$$m=t.$0m=t.$9m=void 0;function D(c){if(!c||typeof c!="object"||c instanceof RegExp)return c;const s=Array.isArray(c)?[]:{};return Object.entries(c).forEach(([i,u])=>{s[i]=u&&typeof u=="object"?D(u):u}),s}t.$9m=D;function r(c){if(!c||typeof c!="object")return c;const s=[c];for(;s.length>0;){const i=s.shift();Object.freeze(i);for(const u in i)if(f.call(i,u)){const w=i[u];typeof w=="object"&&!Object.isFrozen(w)&&!(0,k.$Cf)(w)&&s.push(w)}}return c}t.$0m=r;const f=Object.prototype.hasOwnProperty;function N(c,s){return h(c,s,new Set)}t.$$m=N;function h(c,s,i){if((0,k.$If)(c))return c;const u=s(c);if(typeof u<"u")return u;if(Array.isArray(c)){const w=[];for(const d of c)w.push(h(d,s,i));return w}if((0,k.$Bf)(c)){if(i.has(c))throw new Error("Cannot clone recursive data-structure");i.add(c);const w={};for(const d in c)f.call(c,d)&&(w[d]=h(c[d],s,i));return i.delete(c),w}return c}function a(c,s,i=!0){return(0,k.$Bf)(c)?((0,k.$Bf)(s)&&Object.keys(s).forEach(u=>{u in c?i&&((0,k.$Bf)(c[u])&&(0,k.$Bf)(s[u])?a(c[u],s[u],i):c[u]=s[u]):c[u]=s[u]}),c):s}t.$_m=a;function l(c,s){if(c===s)return!0;if(c==null||s===null||s===void 0||typeof c!=typeof s||typeof c!="object"||Array.isArray(c)!==Array.isArray(s))return!1;let i,u;if(Array.isArray(c)){if(c.length!==s.length)return!1;for(i=0;i<c.length;i++)if(!l(c[i],s[i]))return!1}else{const w=[];for(u in c)w.push(u);w.sort();const d=[];for(u in s)d.push(u);if(d.sort(),!l(w,d))return!1;for(i=0;i<w.length;i++)if(!l(c[w[i]],s[w[i]]))return!1}return!0}t.$an=l;function g(c){const s=new Set;return JSON.stringify(c,(i,u)=>{if((0,k.$Bf)(u)||Array.isArray(u)){if(s.has(u))return"[Circular]";s.add(u)}return u})}t.$bn=g;function E(c,s){const i=Object.create(null);return!c||!s||Object.keys(s).forEach(w=>{const d=c[w],v=s[w];l(d,v)||(i[w]=v)}),i}t.$cn=E;function m(c,s){const i=s.toLowerCase(),u=Object.keys(c).find(w=>w.toLowerCase()===i);return u?c[u]:c[s]}t.$dn=m;function b(c,s){const i=Object.create(null);for(const[u,w]of Object.entries(c))s(u,w)&&(i[u]=w);return i}t.$en=b;function e(c){let s=[];for(;Object.prototype!==c;)s=s.concat(Object.getOwnPropertyNames(c)),c=Object.getPrototypeOf(c);return s}t.$fn=e;function L(c){const s=[];for(const i of e(c))typeof c[i]=="function"&&s.push(i);return s}t.$gn=L;function A(c,s){const i=w=>function(){const d=Array.prototype.slice.call(arguments,0);return s(w,d)},u={};for(const w of c)u[w]=i(w);return u}t.$hn=A;function p(c,s,i){typeof s=="string"&&c[s]!==void 0&&typeof c[s]!="boolean"&&(c[s]=i)}t.$in=p;function $(c,s,i){typeof s=="string"&&c[s]!==void 0&&typeof c[s]!="number"&&(c[s]=i)}t.$jn=$;function o(c,s,i,u){if(typeof s!="string")return;const w=c[s];w!==void 0&&(typeof w!="string"||!i.includes(w))&&(c[s]=u)}t.$kn=o}),ne(ie[27],se([0,1]),function(O,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Be=t.$Ae=t.Constants=void 0;var k;(function(f){f[f.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",f[f.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",f[f.MAX_UINT_8=255]="MAX_UINT_8",f[f.MAX_UINT_16=65535]="MAX_UINT_16",f[f.MAX_UINT_32=4294967295]="MAX_UINT_32",f[f.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(k||(t.Constants=k={}));function D(f){return f<0?0:f>255?255:f|0}t.$Ae=D;function r(f){return f<0?0:f>4294967295?4294967295:f|0}t.$Be=r}),ne(ie[16],se([0,1,40,14]),function(O,t,k,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$wc=t.$vc=t.URI=void 0;const r=/^\w[\w\d+.-]*$/,f=/^\//,N=/^\/\//;function h(d,v){if(!d.scheme&&v)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${d.authority}", path: "${d.path}", query: "${d.query}", fragment: "${d.fragment}"}`);if(d.scheme&&!r.test(d.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(d.path){if(d.authority){if(!f.test(d.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(N.test(d.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function a(d,v){return!d&&!v?"file":d}function l(d,v){switch(d){case"https":case"http":case"file":v?v[0]!==E&&(v=E+v):v=E;break}return v}const g="",E="/",m=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class b{static isUri(v){return v instanceof b?!0:v?typeof v.authority=="string"&&typeof v.fragment=="string"&&typeof v.path=="string"&&typeof v.query=="string"&&typeof v.scheme=="string"&&typeof v.fsPath=="string"&&typeof v.with=="function"&&typeof v.toString=="function":!1}constructor(v,R,M,P,_,F=!1){typeof v=="object"?(this.scheme=v.scheme||g,this.authority=v.authority||g,this.path=v.path||g,this.query=v.query||g,this.fragment=v.fragment||g):(this.scheme=a(v,F),this.authority=R||g,this.path=l(this.scheme,M||g),this.query=P||g,this.fragment=_||g,h(this,F))}get fsPath(){return c(this,!1)}with(v){if(!v)return this;let{scheme:R,authority:M,path:P,query:_,fragment:F}=v;return R===void 0?R=this.scheme:R===null&&(R=g),M===void 0?M=this.authority:M===null&&(M=g),P===void 0?P=this.path:P===null&&(P=g),_===void 0?_=this.query:_===null&&(_=g),F===void 0?F=this.fragment:F===null&&(F=g),R===this.scheme&&M===this.authority&&P===this.path&&_===this.query&&F===this.fragment?this:new A(R,M,P,_,F)}static parse(v,R=!1){const M=m.exec(v);return M?new A(M[2]||g,w(M[4]||g),w(M[5]||g),w(M[7]||g),w(M[9]||g),R):new A(g,g,g,g,g)}static file(v){let R=g;if(D.$d&&(v=v.replace(/\\/g,E)),v[0]===E&&v[1]===E){const M=v.indexOf(E,2);M===-1?(R=v.substring(2),v=E):(R=v.substring(2,M),v=v.substring(M)||E)}return new A("file",R,v,g,g)}static from(v,R){return new A(v.scheme,v.authority,v.path,v.query,v.fragment,R)}static joinPath(v,...R){if(!v.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let M;return D.$d&&v.scheme==="file"?M=b.file(k.$fc.join(c(v,!0),...R)).path:M=k.$gc.join(v.path,...R),v.with({path:M})}toString(v=!1){return s(this,v)}toJSON(){return this}static revive(v){if(v){if(v instanceof b)return v;{const R=new A(v);return R._formatted=v.external??null,R._fsPath=v._sep===L?v.fsPath??null:null,R}}else return v}}t.URI=b;function e(d){return!d||typeof d!="object"?!1:typeof d.scheme=="string"&&(typeof d.authority=="string"||typeof d.authority>"u")&&(typeof d.path=="string"||typeof d.path>"u")&&(typeof d.query=="string"||typeof d.query>"u")&&(typeof d.fragment=="string"||typeof d.fragment>"u")}t.$vc=e;const L=D.$d?1:void 0;class A extends b{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=c(this,!1)),this._fsPath}toString(v=!1){return v?s(this,!0):(this._formatted||(this._formatted=s(this,!1)),this._formatted)}toJSON(){const v={$mid:1};return this._fsPath&&(v.fsPath=this._fsPath,v._sep=L),this._formatted&&(v.external=this._formatted),this.path&&(v.path=this.path),this.scheme&&(v.scheme=this.scheme),this.authority&&(v.authority=this.authority),this.query&&(v.query=this.query),this.fragment&&(v.fragment=this.fragment),v}}const p={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function $(d,v,R){let M,P=-1;for(let _=0;_<d.length;_++){const F=d.charCodeAt(_);if(F>=97&&F<=122||F>=65&&F<=90||F>=48&&F<=57||F===45||F===46||F===95||F===126||v&&F===47||R&&F===91||R&&F===93||R&&F===58)P!==-1&&(M+=encodeURIComponent(d.substring(P,_)),P=-1),M!==void 0&&(M+=d.charAt(_));else{M===void 0&&(M=d.substr(0,_));const y=p[F];y!==void 0?(P!==-1&&(M+=encodeURIComponent(d.substring(P,_)),P=-1),M+=y):P===-1&&(P=_)}}return P!==-1&&(M+=encodeURIComponent(d.substring(P))),M!==void 0?M:d}function o(d){let v;for(let R=0;R<d.length;R++){const M=d.charCodeAt(R);M===35||M===63?(v===void 0&&(v=d.substr(0,R)),v+=p[M]):v!==void 0&&(v+=d[R])}return v!==void 0?v:d}function c(d,v){let R;return d.authority&&d.path.length>1&&d.scheme==="file"?R=`//${d.authority}${d.path}`:d.path.charCodeAt(0)===47&&(d.path.charCodeAt(1)>=65&&d.path.charCodeAt(1)<=90||d.path.charCodeAt(1)>=97&&d.path.charCodeAt(1)<=122)&&d.path.charCodeAt(2)===58?v?R=d.path.substr(1):R=d.path[1].toLowerCase()+d.path.substr(2):R=d.path,D.$d&&(R=R.replace(/\//g,"\\")),R}t.$wc=c;function s(d,v){const R=v?o:$;let M="",{scheme:P,authority:_,path:F,query:y,fragment:I}=d;if(P&&(M+=P,M+=":"),(_||P==="file")&&(M+=E,M+=E),_){let q=_.indexOf("@");if(q!==-1){const x=_.substr(0,q);_=_.substr(q+1),q=x.lastIndexOf(":"),q===-1?M+=R(x,!1,!1):(M+=R(x.substr(0,q),!1,!1),M+=":",M+=R(x.substr(q+1),!1,!0)),M+="@"}_=_.toLowerCase(),q=_.lastIndexOf(":"),q===-1?M+=R(_,!1,!0):(M+=R(_.substr(0,q),!1,!0),M+=_.substr(q))}if(F){if(F.length>=3&&F.charCodeAt(0)===47&&F.charCodeAt(2)===58){const q=F.charCodeAt(1);q>=65&&q<=90&&(F=`/${String.fromCharCode(q+32)}:${F.substr(3)}`)}else if(F.length>=2&&F.charCodeAt(1)===58){const q=F.charCodeAt(0);q>=65&&q<=90&&(F=`${String.fromCharCode(q+32)}:${F.substr(2)}`)}M+=R(F,!0,!1)}return y&&(M+="?",M+=R(y,!1,!1)),I&&(M+="#",M+=v?I:$(I,!1,!1)),M}function i(d){try{return decodeURIComponent(d)}catch{return d.length>3?d.substr(0,3)+i(d.substr(3)):d}}const u=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function w(d){return d.match(u)?d.replace(u,v=>i(v)):d}}),ne(ie[67],se([0,1,3,11,10,15,14,7]),function(O,t,k,D,r,f,N,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.create=t.SimpleWorkerServer=t.SimpleWorkerClient=t.logOnceWebWorkerWarning=void 0;const a="$initialize";let l=!1;function g(w){N.$j&&(l||(l=!0,console.warn("Could not create web worker(s). Falling back to loading web worker code in main thread, which might cause UI freezes. Please see https://github.com/microsoft/monaco-editor#faq")),console.warn(w.message))}t.logOnceWebWorkerWarning=g;var E;(function(w){w[w.Request=0]="Request",w[w.Reply=1]="Reply",w[w.SubscribeEvent=2]="SubscribeEvent",w[w.Event=3]="Event",w[w.UnsubscribeEvent=4]="UnsubscribeEvent"})(E||(E={}));class m{constructor(d,v,R,M){this.vsWorker=d,this.req=v,this.method=R,this.args=M,this.type=0}}class b{constructor(d,v,R,M){this.vsWorker=d,this.seq=v,this.res=R,this.err=M,this.type=1}}class e{constructor(d,v,R,M){this.vsWorker=d,this.req=v,this.eventName=R,this.arg=M,this.type=2}}class L{constructor(d,v,R){this.vsWorker=d,this.req=v,this.event=R,this.type=3}}class A{constructor(d,v){this.vsWorker=d,this.req=v,this.type=4}}class p{constructor(d){this.a=-1,this.g=d,this.b=0,this.c=Object.create(null),this.d=new Map,this.f=new Map}setWorkerId(d){this.a=d}sendMessage(d,v){const R=String(++this.b);return new Promise((M,P)=>{this.c[R]={resolve:M,reject:P},this.o(new m(this.a,R,d,v))})}listen(d,v){let R=null;const M=new D.$Od({onWillAddFirstListener:()=>{R=String(++this.b),this.d.set(R,M),this.o(new e(this.a,R,d,v))},onDidRemoveLastListener:()=>{this.d.delete(R),this.o(new A(this.a,R)),R=null}});return M.event}handleMessage(d){!d||!d.vsWorker||this.a!==-1&&d.vsWorker!==this.a||this.h(d)}h(d){switch(d.type){case 1:return this.j(d);case 0:return this.k(d);case 2:return this.l(d);case 3:return this.m(d);case 4:return this.n(d)}}j(d){if(!this.c[d.seq]){console.warn("Got reply to unknown seq");return}const v=this.c[d.seq];if(delete this.c[d.seq],d.err){let R=d.err;d.err.$isError&&(R=new Error,R.name=d.err.name,R.message=d.err.message,R.stack=d.err.stack),v.reject(R);return}v.resolve(d.res)}k(d){const v=d.req;this.g.handleMessage(d.method,d.args).then(M=>{this.o(new b(this.a,v,M,void 0))},M=>{M.detail instanceof Error&&(M.detail=(0,k.$3)(M.detail)),this.o(new b(this.a,v,void 0,(0,k.$3)(M)))})}l(d){const v=d.req,R=this.g.handleEvent(d.eventName,d.arg)(M=>{this.o(new L(this.a,v,M))});this.f.set(v,R)}m(d){if(!this.d.has(d.req)){console.warn("Got event for unknown req");return}this.d.get(d.req).fire(d.event)}n(d){if(!this.f.has(d.req)){console.warn("Got unsubscribe for unknown req");return}this.f.get(d.req).dispose(),this.f.delete(d.req)}o(d){const v=[];if(d.type===0)for(let R=0;R<d.args.length;R++)d.args[R]instanceof ArrayBuffer&&v.push(d.args[R]);else d.type===1&&d.res instanceof ArrayBuffer&&v.push(d.res);this.g.sendMessage(d,v)}}class $ extends r.$Sc{constructor(d,v,R){super();let M=null;this.a=this.B(d.create("vs/base/common/worker/simpleWorker",q=>{this.c.handleMessage(q)},q=>{M?.(q)})),this.c=new p({sendMessage:(q,x)=>{this.a.postMessage(q,x)},handleMessage:(q,x)=>{if(typeof R[q]!="function")return Promise.reject(new Error("Missing method "+q+" on main thread host."));try{return Promise.resolve(R[q].apply(R,x))}catch(T){return Promise.reject(T)}},handleEvent:(q,x)=>{if(c(q)){const T=R[q].call(R,x);if(typeof T!="function")throw new Error(`Missing dynamic event ${q} on main thread host.`);return T}if(o(q)){const T=R[q];if(typeof T!="function")throw new Error(`Missing event ${q} on main thread host.`);return T}throw new Error(`Malformed event name ${q}`)}}),this.c.setWorkerId(this.a.getId());let P=null;const _=globalThis.require;typeof _<"u"&&typeof _.getConfig=="function"?P=_.getConfig():typeof globalThis.requirejs<"u"&&(P=globalThis.requirejs.s.contexts._.config);const F=(0,f.$gn)(R);this.b=this.c.sendMessage(a,[this.a.getId(),JSON.parse(JSON.stringify(P)),v,F]);const y=(q,x)=>this.g(q,x),I=(q,x)=>this.c.listen(q,x);this.f=new Promise((q,x)=>{M=x,this.b.then(T=>{q(s(T,y,I))},T=>{x(T),this.h("Worker failed to load "+v,T)})})}getProxyObject(){return this.f}g(d,v){return new Promise((R,M)=>{this.b.then(()=>{this.c.sendMessage(d,v).then(R,M)},M)})}h(d,v){console.error(d),console.info(v)}}t.SimpleWorkerClient=$;function o(w){return w[0]==="o"&&w[1]==="n"&&h.$2e(w.charCodeAt(2))}function c(w){return/^onDynamic/.test(w)&&h.$2e(w.charCodeAt(9))}function s(w,d,v){const R=_=>function(){const F=Array.prototype.slice.call(arguments,0);return d(_,F)},M=_=>function(F){return v(_,F)},P={};for(const _ of w){if(c(_)){P[_]=M(_);continue}if(o(_)){P[_]=v(_,void 0);continue}P[_]=R(_)}return P}class i{constructor(d,v){this.a=v,this.b=null,this.c=new p({sendMessage:(R,M)=>{d(R,M)},handleMessage:(R,M)=>this.d(R,M),handleEvent:(R,M)=>this.f(R,M)})}onmessage(d){this.c.handleMessage(d)}d(d,v){if(d===a)return this.g(v[0],v[1],v[2],v[3]);if(!this.b||typeof this.b[d]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+d));try{return Promise.resolve(this.b[d].apply(this.b,v))}catch(R){return Promise.reject(R)}}f(d,v){if(!this.b)throw new Error("Missing requestHandler");if(c(d)){const R=this.b[d].call(this.b,v);if(typeof R!="function")throw new Error(`Missing dynamic event ${d} on request handler.`);return R}if(o(d)){const R=this.b[d];if(typeof R!="function")throw new Error(`Missing event ${d} on request handler.`);return R}throw new Error(`Malformed event name ${d}`)}g(d,v,R,M){this.c.setWorkerId(d);const F=s(M,(y,I)=>this.c.sendMessage(y,I),(y,I)=>this.c.listen(y,I));return this.a?(this.b=this.a(F),Promise.resolve((0,f.$gn)(this.b))):(v&&(typeof v.baseUrl<"u"&&delete v.baseUrl,typeof v.paths<"u"&&typeof v.paths.vs<"u"&&delete v.paths.vs,typeof v.trustedTypesPolicy!==void 0&&delete v.trustedTypesPolicy,v.catchError=!0,globalThis.require.config(v)),new Promise((y,I)=>{(globalThis.require||O)([R],x=>{if(this.b=x.create(F),!this.b){I(new Error("No RequestHandler!"));return}y((0,f.$gn)(this.b))},I)}))}}t.SimpleWorkerServer=i;function u(w){return new i(w,null)}t.create=u}),ne(ie[28],se([0,1,27]),function(O,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ws=t.$Vs=void 0;class D{constructor(h){const a=(0,k.$Ae)(h);this.c=a,this.a=D.d(a),this.b=new Map}static d(h){const a=new Uint8Array(256);return a.fill(h),a}set(h,a){const l=(0,k.$Ae)(a);h>=0&&h<256?this.a[h]=l:this.b.set(h,l)}get(h){return h>=0&&h<256?this.a[h]:this.b.get(h)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}t.$Vs=D;var r;(function(N){N[N.False=0]="False",N[N.True=1]="True"})(r||(r={}));class f{constructor(){this.a=new D(0)}add(h){this.a.set(h,1)}has(h){return this.a.get(h)===1}clear(){return this.a.clear()}}t.$Ws=f}),ne(ie[4],se([0,1,3]),function(O,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Gs=t.$Fs=void 0;class D{static addRange(N,h){let a=0;for(;a<h.length&&h[a].endExclusive<N.start;)a++;let l=a;for(;l<h.length&&h[l].start<=N.endExclusive;)l++;if(a===l)h.splice(a,0,N);else{const g=Math.min(N.start,h[a].start),E=Math.max(N.endExclusive,h[l-1].endExclusive);h.splice(a,l-a,new D(g,E))}}static tryCreate(N,h){if(!(N>h))return new D(N,h)}static ofLength(N){return new D(0,N)}constructor(N,h){if(this.start=N,this.endExclusive=h,N>h)throw new k.$cb(`Invalid range: ${this.toString()}`)}get isEmpty(){return this.start===this.endExclusive}delta(N){return new D(this.start+N,this.endExclusive+N)}deltaStart(N){return new D(this.start+N,this.endExclusive)}deltaEnd(N){return new D(this.start,this.endExclusive+N)}get length(){return this.endExclusive-this.start}toString(){return`[${this.start}, ${this.endExclusive})`}equals(N){return this.start===N.start&&this.endExclusive===N.endExclusive}containsRange(N){return this.start<=N.start&&N.endExclusive<=this.endExclusive}contains(N){return this.start<=N&&N<this.endExclusive}join(N){return new D(Math.min(this.start,N.start),Math.max(this.endExclusive,N.endExclusive))}intersect(N){const h=Math.max(this.start,N.start),a=Math.min(this.endExclusive,N.endExclusive);if(h<=a)return new D(h,a)}intersectsOrTouches(N){const h=Math.max(this.start,N.start),a=Math.min(this.endExclusive,N.endExclusive);return h<=a}slice(N){return N.slice(this.start,this.endExclusive)}clip(N){if(this.isEmpty)throw new k.$cb(`Invalid clipping range: ${this.toString()}`);return Math.max(this.start,Math.min(this.endExclusive-1,N))}clipCyclic(N){if(this.isEmpty)throw new k.$cb(`Invalid clipping range: ${this.toString()}`);return N<this.start?this.endExclusive-(this.start-N)%this.length:N>=this.endExclusive?this.start+(N-this.start)%this.length:N}map(N){const h=[];for(let a=this.start;a<this.endExclusive;a++)h.push(N(a));return h}forEach(N){for(let h=this.start;h<this.endExclusive;h++)N(h)}}t.$Fs=D;class r{constructor(){this.a=[]}addRange(N){let h=0;for(;h<this.a.length&&this.a[h].endExclusive<N.start;)h++;let a=h;for(;a<this.a.length&&this.a[a].start<=N.endExclusive;)a++;if(h===a)this.a.splice(h,0,N);else{const l=Math.min(N.start,this.a[h].start),g=Math.max(N.endExclusive,this.a[a-1].endExclusive);this.a.splice(h,a-h,new D(l,g))}}toString(){return this.a.map(N=>N.toString()).join(", ")}intersectsStrict(N){let h=0;for(;h<this.a.length&&this.a[h].endExclusive<=N.start;)h++;return h<this.a.length&&this.a[h].start<N.endExclusive}intersectWithRange(N){const h=new r;for(const a of this.a){const l=a.intersect(N);l&&h.addRange(l)}return h}intersectWithRangeLength(N){return this.intersectWithRange(N).length}get length(){return this.a.reduce((N,h)=>N+h.length,0)}}t.$Gs=r}),ne(ie[5],se([0,1]),function(O,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$xs=void 0;class k{constructor(r,f){this.lineNumber=r,this.column=f}with(r=this.lineNumber,f=this.column){return r===this.lineNumber&&f===this.column?this:new k(r,f)}delta(r=0,f=0){return this.with(this.lineNumber+r,this.column+f)}equals(r){return k.equals(this,r)}static equals(r,f){return!r&&!f?!0:!!r&&!!f&&r.lineNumber===f.lineNumber&&r.column===f.column}isBefore(r){return k.isBefore(this,r)}static isBefore(r,f){return r.lineNumber<f.lineNumber?!0:f.lineNumber<r.lineNumber?!1:r.column<f.column}isBeforeOrEqual(r){return k.isBeforeOrEqual(this,r)}static isBeforeOrEqual(r,f){return r.lineNumber<f.lineNumber?!0:f.lineNumber<r.lineNumber?!1:r.column<=f.column}static compare(r,f){const N=r.lineNumber|0,h=f.lineNumber|0;if(N===h){const a=r.column|0,l=f.column|0;return a-l}return N-h}clone(){return new k(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(r){return new k(r.lineNumber,r.column)}static isIPosition(r){return r&&typeof r.lineNumber=="number"&&typeof r.column=="number"}}t.$xs=k}),ne(ie[2],se([0,1,5]),function(O,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ys=void 0;class D{constructor(f,N,h,a){f>h||f===h&&N>a?(this.startLineNumber=h,this.startColumn=a,this.endLineNumber=f,this.endColumn=N):(this.startLineNumber=f,this.startColumn=N,this.endLineNumber=h,this.endColumn=a)}isEmpty(){return D.isEmpty(this)}static isEmpty(f){return f.startLineNumber===f.endLineNumber&&f.startColumn===f.endColumn}containsPosition(f){return D.containsPosition(this,f)}static containsPosition(f,N){return!(N.lineNumber<f.startLineNumber||N.lineNumber>f.endLineNumber||N.lineNumber===f.startLineNumber&&N.column<f.startColumn||N.lineNumber===f.endLineNumber&&N.column>f.endColumn)}static strictContainsPosition(f,N){return!(N.lineNumber<f.startLineNumber||N.lineNumber>f.endLineNumber||N.lineNumber===f.startLineNumber&&N.column<=f.startColumn||N.lineNumber===f.endLineNumber&&N.column>=f.endColumn)}containsRange(f){return D.containsRange(this,f)}static containsRange(f,N){return!(N.startLineNumber<f.startLineNumber||N.endLineNumber<f.startLineNumber||N.startLineNumber>f.endLineNumber||N.endLineNumber>f.endLineNumber||N.startLineNumber===f.startLineNumber&&N.startColumn<f.startColumn||N.endLineNumber===f.endLineNumber&&N.endColumn>f.endColumn)}strictContainsRange(f){return D.strictContainsRange(this,f)}static strictContainsRange(f,N){return!(N.startLineNumber<f.startLineNumber||N.endLineNumber<f.startLineNumber||N.startLineNumber>f.endLineNumber||N.endLineNumber>f.endLineNumber||N.startLineNumber===f.startLineNumber&&N.startColumn<=f.startColumn||N.endLineNumber===f.endLineNumber&&N.endColumn>=f.endColumn)}plusRange(f){return D.plusRange(this,f)}static plusRange(f,N){let h,a,l,g;return N.startLineNumber<f.startLineNumber?(h=N.startLineNumber,a=N.startColumn):N.startLineNumber===f.startLineNumber?(h=N.startLineNumber,a=Math.min(N.startColumn,f.startColumn)):(h=f.startLineNumber,a=f.startColumn),N.endLineNumber>f.endLineNumber?(l=N.endLineNumber,g=N.endColumn):N.endLineNumber===f.endLineNumber?(l=N.endLineNumber,g=Math.max(N.endColumn,f.endColumn)):(l=f.endLineNumber,g=f.endColumn),new D(h,a,l,g)}intersectRanges(f){return D.intersectRanges(this,f)}static intersectRanges(f,N){let h=f.startLineNumber,a=f.startColumn,l=f.endLineNumber,g=f.endColumn;const E=N.startLineNumber,m=N.startColumn,b=N.endLineNumber,e=N.endColumn;return h<E?(h=E,a=m):h===E&&(a=Math.max(a,m)),l>b?(l=b,g=e):l===b&&(g=Math.min(g,e)),h>l||h===l&&a>g?null:new D(h,a,l,g)}equalsRange(f){return D.equalsRange(this,f)}static equalsRange(f,N){return!f&&!N?!0:!!f&&!!N&&f.startLineNumber===N.startLineNumber&&f.startColumn===N.startColumn&&f.endLineNumber===N.endLineNumber&&f.endColumn===N.endColumn}getEndPosition(){return D.getEndPosition(this)}static getEndPosition(f){return new k.$xs(f.endLineNumber,f.endColumn)}getStartPosition(){return D.getStartPosition(this)}static getStartPosition(f){return new k.$xs(f.startLineNumber,f.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(f,N){return new D(this.startLineNumber,this.startColumn,f,N)}setStartPosition(f,N){return new D(f,N,this.endLineNumber,this.endColumn)}collapseToStart(){return D.collapseToStart(this)}static collapseToStart(f){return new D(f.startLineNumber,f.startColumn,f.startLineNumber,f.startColumn)}collapseToEnd(){return D.collapseToEnd(this)}static collapseToEnd(f){return new D(f.endLineNumber,f.endColumn,f.endLineNumber,f.endColumn)}delta(f){return new D(this.startLineNumber+f,this.startColumn,this.endLineNumber+f,this.endColumn)}static fromPositions(f,N=f){return new D(f.lineNumber,f.column,N.lineNumber,N.column)}static lift(f){return f?new D(f.startLineNumber,f.startColumn,f.endLineNumber,f.endColumn):null}static isIRange(f){return f&&typeof f.startLineNumber=="number"&&typeof f.startColumn=="number"&&typeof f.endLineNumber=="number"&&typeof f.endColumn=="number"}static areIntersectingOrTouching(f,N){return!(f.endLineNumber<N.startLineNumber||f.endLineNumber===N.startLineNumber&&f.endColumn<N.startColumn||N.endLineNumber<f.startLineNumber||N.endLineNumber===f.startLineNumber&&N.endColumn<f.startColumn)}static areIntersecting(f,N){return!(f.endLineNumber<N.startLineNumber||f.endLineNumber===N.startLineNumber&&f.endColumn<=N.startColumn||N.endLineNumber<f.startLineNumber||N.endLineNumber===f.startLineNumber&&N.endColumn<=f.startColumn)}static compareRangesUsingStarts(f,N){if(f&&N){const l=f.startLineNumber|0,g=N.startLineNumber|0;if(l===g){const E=f.startColumn|0,m=N.startColumn|0;if(E===m){const b=f.endLineNumber|0,e=N.endLineNumber|0;if(b===e){const L=f.endColumn|0,A=N.endColumn|0;return L-A}return b-e}return E-m}return l-g}return(f?1:0)-(N?1:0)}static compareRangesUsingEnds(f,N){return f.endLineNumber===N.endLineNumber?f.endColumn===N.endColumn?f.startLineNumber===N.startLineNumber?f.startColumn-N.startColumn:f.startLineNumber-N.startLineNumber:f.endColumn-N.endColumn:f.endLineNumber-N.endLineNumber}static spansMultipleLines(f){return f.endLineNumber>f.startLineNumber}toJSON(){return this}}t.$ys=D}),ne(ie[44],se([0,1,2]),function(O,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$zs=void 0;class D{static insert(f,N){return{range:new k.$ys(f.lineNumber,f.column,f.lineNumber,f.column),text:N,forceMoveMarkers:!0}}static delete(f){return{range:f,text:null}}static replace(f,N){return{range:f,text:N}}static replaceMove(f,N){return{range:f,text:N,forceMoveMarkers:!0}}}t.$zs=D}),ne(ie[12],se([0,1,3,4,2,9]),function(O,t,k,D,r,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Is=t.$Hs=void 0;class N{static fromRange(l){return new N(l.startLineNumber,l.endLineNumber)}static subtract(l,g){return g?l.startLineNumber<g.startLineNumber&&g.endLineNumberExclusive<l.endLineNumberExclusive?[new N(l.startLineNumber,g.startLineNumber),new N(g.endLineNumberExclusive,l.endLineNumberExclusive)]:g.startLineNumber<=l.startLineNumber&&l.endLineNumberExclusive<=g.endLineNumberExclusive?[]:g.endLineNumberExclusive<l.endLineNumberExclusive?[new N(Math.max(g.endLineNumberExclusive,l.startLineNumber),l.endLineNumberExclusive)]:[new N(l.startLineNumber,Math.min(g.startLineNumber,l.endLineNumberExclusive))]:[l]}static joinMany(l){if(l.length===0)return[];let g=new h(l[0].slice());for(let E=1;E<l.length;E++)g=g.getUnion(new h(l[E].slice()));return g.ranges}static ofLength(l,g){return new N(l,l+g)}static deserialize(l){return new N(l[0],l[1])}constructor(l,g){if(l>g)throw new k.$cb(`startLineNumber ${l} cannot be after endLineNumberExclusive ${g}`);this.startLineNumber=l,this.endLineNumberExclusive=g}contains(l){return this.startLineNumber<=l&&l<this.endLineNumberExclusive}get isEmpty(){return this.startLineNumber===this.endLineNumberExclusive}delta(l){return new N(this.startLineNumber+l,this.endLineNumberExclusive+l)}deltaLength(l){return new N(this.startLineNumber,this.endLineNumberExclusive+l)}get length(){return this.endLineNumberExclusive-this.startLineNumber}join(l){return new N(Math.min(this.startLineNumber,l.startLineNumber),Math.max(this.endLineNumberExclusive,l.endLineNumberExclusive))}toString(){return`[${this.startLineNumber},${this.endLineNumberExclusive})`}intersect(l){const g=Math.max(this.startLineNumber,l.startLineNumber),E=Math.min(this.endLineNumberExclusive,l.endLineNumberExclusive);if(g<=E)return new N(g,E)}intersectsStrict(l){return this.startLineNumber<l.endLineNumberExclusive&&l.startLineNumber<this.endLineNumberExclusive}overlapOrTouch(l){return this.startLineNumber<=l.endLineNumberExclusive&&l.startLineNumber<=this.endLineNumberExclusive}equals(l){return this.startLineNumber===l.startLineNumber&&this.endLineNumberExclusive===l.endLineNumberExclusive}toInclusiveRange(){return this.isEmpty?null:new r.$ys(this.startLineNumber,1,this.endLineNumberExclusive-1,Number.MAX_SAFE_INTEGER)}toExclusiveRange(){return new r.$ys(this.startLineNumber,1,this.endLineNumberExclusive,1)}mapToLineArray(l){const g=[];for(let E=this.startLineNumber;E<this.endLineNumberExclusive;E++)g.push(l(E));return g}forEach(l){for(let g=this.startLineNumber;g<this.endLineNumberExclusive;g++)l(g)}serialize(){return[this.startLineNumber,this.endLineNumberExclusive]}includes(l){return this.startLineNumber<=l&&l<this.endLineNumberExclusive}toOffsetRange(){return new D.$Fs(this.startLineNumber-1,this.endLineNumberExclusive-1)}}t.$Hs=N;class h{constructor(l=[]){this.c=l}get ranges(){return this.c}addRange(l){if(l.length===0)return;const g=(0,f.$kb)(this.c,m=>m.endLineNumberExclusive>=l.startLineNumber),E=(0,f.$ib)(this.c,m=>m.startLineNumber<=l.endLineNumberExclusive)+1;if(g===E)this.c.splice(g,0,l);else if(g===E-1){const m=this.c[g];this.c[g]=m.join(l)}else{const m=this.c[g].join(this.c[E-1]).join(l);this.c.splice(g,E-g,m)}}contains(l){const g=(0,f.$hb)(this.c,E=>E.startLineNumber<=l);return!!g&&g.endLineNumberExclusive>l}intersects(l){const g=(0,f.$hb)(this.c,E=>E.startLineNumber<l.endLineNumberExclusive);return!!g&&g.endLineNumberExclusive>l.startLineNumber}getUnion(l){if(this.c.length===0)return l;if(l.c.length===0)return this;const g=[];let E=0,m=0,b=null;for(;E<this.c.length||m<l.c.length;){let e=null;if(E<this.c.length&&m<l.c.length){const L=this.c[E],A=l.c[m];L.startLineNumber<A.startLineNumber?(e=L,E++):(e=A,m++)}else E<this.c.length?(e=this.c[E],E++):(e=l.c[m],m++);b===null?b=e:b.endLineNumberExclusive>=e.startLineNumber?b=new N(b.startLineNumber,Math.max(b.endLineNumberExclusive,e.endLineNumberExclusive)):(g.push(b),b=e)}return b!==null&&g.push(b),new h(g)}subtractFrom(l){const g=(0,f.$kb)(this.c,e=>e.endLineNumberExclusive>=l.startLineNumber),E=(0,f.$ib)(this.c,e=>e.startLineNumber<=l.endLineNumberExclusive)+1;if(g===E)return new h([l]);const m=[];let b=l.startLineNumber;for(let e=g;e<E;e++){const L=this.c[e];L.startLineNumber>b&&m.push(new N(b,L.startLineNumber)),b=L.endLineNumberExclusive}return b<l.endLineNumberExclusive&&m.push(new N(b,l.endLineNumberExclusive)),new h(m)}toString(){return this.c.map(l=>l.toString()).join(", ")}getIntersection(l){const g=[];let E=0,m=0;for(;E<this.c.length&&m<l.c.length;){const b=this.c[E],e=l.c[m],L=b.intersect(e);L&&!L.isEmpty&&g.push(L),b.endLineNumberExclusive<e.endLineNumberExclusive?E++:m++}return new h(g)}getWithDelta(l){return new h(this.c.map(g=>g.delta(l)))}}t.$Is=h}),ne(ie[45],se([0,1,5,2]),function(O,t,k,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$As=t.SelectionDirection=void 0;var r;(function(N){N[N.LTR=0]="LTR",N[N.RTL=1]="RTL"})(r||(t.SelectionDirection=r={}));class f extends D.$ys{constructor(h,a,l,g){super(h,a,l,g),this.selectionStartLineNumber=h,this.selectionStartColumn=a,this.positionLineNumber=l,this.positionColumn=g}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(h){return f.selectionsEqual(this,h)}static selectionsEqual(h,a){return h.selectionStartLineNumber===a.selectionStartLineNumber&&h.selectionStartColumn===a.selectionStartColumn&&h.positionLineNumber===a.positionLineNumber&&h.positionColumn===a.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(h,a){return this.getDirection()===0?new f(this.startLineNumber,this.startColumn,h,a):new f(h,a,this.startLineNumber,this.startColumn)}getPosition(){return new k.$xs(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new k.$xs(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(h,a){return this.getDirection()===0?new f(h,a,this.endLineNumber,this.endColumn):new f(this.endLineNumber,this.endColumn,h,a)}static fromPositions(h,a=h){return new f(h.lineNumber,h.column,a.lineNumber,a.column)}static fromRange(h,a){return a===0?new f(h.startLineNumber,h.startColumn,h.endLineNumber,h.endColumn):new f(h.endLineNumber,h.endColumn,h.startLineNumber,h.startColumn)}static liftSelection(h){return new f(h.selectionStartLineNumber,h.selectionStartColumn,h.positionLineNumber,h.positionColumn)}static selectionsArrEqual(h,a){if(h&&!a||!h&&a)return!1;if(!h&&!a)return!0;if(h.length!==a.length)return!1;for(let l=0,g=h.length;l<g;l++)if(!this.selectionsEqual(h[l],a[l]))return!1;return!0}static isISelection(h){return h&&typeof h.selectionStartLineNumber=="number"&&typeof h.selectionStartColumn=="number"&&typeof h.positionLineNumber=="number"&&typeof h.positionColumn=="number"}static createWithDirection(h,a,l,g,E){return E===0?new f(h,a,l,g):new f(l,g,h,a)}}t.$As=f}),ne(ie[46],se([0,1,28]),function(O,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ys=t.$Xs=t.WordCharacterClass=void 0;var D;(function(N){N[N.Regular=0]="Regular",N[N.Whitespace=1]="Whitespace",N[N.WordSeparator=2]="WordSeparator"})(D||(t.WordCharacterClass=D={}));class r extends k.$Vs{constructor(h){super(0);for(let a=0,l=h.length;a<l;a++)this.set(h.charCodeAt(a),2);this.set(32,1),this.set(9,1)}}t.$Xs=r;function f(N){const h={};return a=>(h.hasOwnProperty(a)||(h[a]=N(a)),h[a])}t.$Ys=f(N=>new r(N))}),ne(ie[29],se([0,1,20,10,21]),function(O,t,k,D,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$as=t.$_r=t.$$r=t.$0r=t.$9r=void 0,t.$9r="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function f(E=""){let m="(-?\\d*\\.\\d\\w*)|([^";for(const b of t.$9r)E.indexOf(b)>=0||(m+="\\"+b);return m+="\\s]+)",new RegExp(m,"g")}t.$0r=f();function N(E){let m=t.$0r;if(E&&E instanceof RegExp)if(E.global)m=E;else{let b="g";E.ignoreCase&&(b+="i"),E.multiline&&(b+="m"),E.unicode&&(b+="u"),m=new RegExp(E.source,b)}return m.lastIndex=0,m}t.$$r=N;const h=new r.$2c;h.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function a(E){const m=h.unshift(E);return(0,D.$Qc)(m)}t.$_r=a;function l(E,m,b,e,L){if(L||(L=k.Iterable.first(h)),b.length>L.maxLen){let c=E-L.maxLen/2;return c<0?c=0:e+=c,b=b.substring(c,E+L.maxLen/2),l(E,m,b,e,L)}const A=Date.now(),p=E-1-e;let $=-1,o=null;for(let c=1;!(Date.now()-A>=L.timeBudget);c++){const s=p-L.windowSize*c;m.lastIndex=Math.max(0,s);const i=g(m,b,p,$);if(!i&&o||(o=i,s<=0))break;$=s}if(o){const c={word:o[0],startColumn:e+1+o.index,endColumn:e+1+o.index+o[0].length};return m.lastIndex=0,c}return null}t.$as=l;function g(E,m,b,e){let L;for(;L=E.exec(m);){const A=L.index||0;if(A<=b&&E.lastIndex>=b)return L;if(e>0&&A>e)return null}return null}}),ne(ie[8],se([0,1,6,3,4]),function(O,t,k,D,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$pZ=t.$oZ=t.$nZ=t.$mZ=t.$lZ=void 0;class f{static trivial(E,m){return new f([new N(r.$Fs.ofLength(E.length),r.$Fs.ofLength(m.length))],!1)}static trivialTimedOut(E,m){return new f([new N(r.$Fs.ofLength(E.length),r.$Fs.ofLength(m.length))],!0)}constructor(E,m){this.diffs=E,this.hitTimeout=m}}t.$lZ=f;class N{static invert(E,m){const b=[];return(0,k.$Bb)(E,(e,L)=>{b.push(N.fromOffsetPairs(e?e.getEndExclusives():h.zero,L?L.getStarts():new h(m,(e?e.seq2Range.endExclusive-e.seq1Range.endExclusive:0)+m)))}),b}static fromOffsetPairs(E,m){return new N(new r.$Fs(E.offset1,m.offset1),new r.$Fs(E.offset2,m.offset2))}constructor(E,m){this.seq1Range=E,this.seq2Range=m}swap(){return new N(this.seq2Range,this.seq1Range)}toString(){return`${this.seq1Range} <-> ${this.seq2Range}`}join(E){return new N(this.seq1Range.join(E.seq1Range),this.seq2Range.join(E.seq2Range))}delta(E){return E===0?this:new N(this.seq1Range.delta(E),this.seq2Range.delta(E))}deltaStart(E){return E===0?this:new N(this.seq1Range.deltaStart(E),this.seq2Range.deltaStart(E))}deltaEnd(E){return E===0?this:new N(this.seq1Range.deltaEnd(E),this.seq2Range.deltaEnd(E))}intersectsOrTouches(E){return this.seq1Range.intersectsOrTouches(E.seq1Range)||this.seq2Range.intersectsOrTouches(E.seq2Range)}intersect(E){const m=this.seq1Range.intersect(E.seq1Range),b=this.seq2Range.intersect(E.seq2Range);if(!(!m||!b))return new N(m,b)}getStarts(){return new h(this.seq1Range.start,this.seq2Range.start)}getEndExclusives(){return new h(this.seq1Range.endExclusive,this.seq2Range.endExclusive)}}t.$mZ=N;class h{constructor(E,m){this.offset1=E,this.offset2=m}toString(){return`${this.offset1} <-> ${this.offset2}`}}t.$nZ=h,h.zero=new h(0,0),h.max=new h(Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER);class a{isValid(){return!0}}t.$oZ=a,a.instance=new a;class l{constructor(E){if(this.e=E,this.c=Date.now(),this.d=!0,E<=0)throw new D.$cb("timeout must be positive")}isValid(){if(!(Date.now()-this.c<this.e)&&this.d){this.d=!1;debugger}return this.d}disable(){this.e=Number.MAX_SAFE_INTEGER,this.isValid=()=>!0,this.d=!0}}t.$pZ=l}),ne(ie[30],se([0,1,4,8]),function(O,t,k,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$uZ=void 0;class r{compute(l,g,E=D.$oZ.instance){if(l.length===0||g.length===0)return D.$lZ.trivial(l,g);const m=l,b=g;function e(u,w){for(;u<m.length&&w<b.length&&m.getElement(u)===b.getElement(w);)u++,w++;return u}let L=0;const A=new N;A.set(0,e(0,0));const p=new h;p.set(0,A.get(0)===0?null:new f(null,0,0,A.get(0)));let $=0;e:for(;;){if(L++,!E.isValid())return D.$lZ.trivialTimedOut(m,b);const u=-Math.min(L,b.length+L%2),w=Math.min(L,m.length+L%2);for($=u;$<=w;$+=2){let d=0;const v=$===w?-1:A.get($+1),R=$===u?-1:A.get($-1)+1;d++;const M=Math.min(Math.max(v,R),m.length),P=M-$;if(d++,M>m.length||P>b.length)continue;const _=e(M,P);A.set($,_);const F=M===v?p.get($+1):p.get($-1);if(p.set($,_!==M?new f(F,M,P,_-M):F),A.get($)===m.length&&A.get($)-$===b.length)break e}}let o=p.get($);const c=[];let s=m.length,i=b.length;for(;;){const u=o?o.x+o.length:0,w=o?o.y+o.length:0;if((u!==s||w!==i)&&c.push(new D.$mZ(new k.$Fs(u,s),new k.$Fs(w,i))),!o)break;s=o.x,i=o.y,o=o.prev}return c.reverse(),new D.$lZ(c,!1)}}t.$uZ=r;class f{constructor(l,g,E,m){this.prev=l,this.x=g,this.y=E,this.length=m}}class N{constructor(){this.a=new Int32Array(10),this.b=new Int32Array(10)}get(l){return l<0?(l=-l-1,this.b[l]):this.a[l]}set(l,g){if(l<0){if(l=-l-1,l>=this.b.length){const E=this.b;this.b=new Int32Array(E.length*2),this.b.set(E)}this.b[l]=g}else{if(l>=this.a.length){const E=this.a;this.a=new Int32Array(E.length*2),this.a.set(E)}this.a[l]=g}}}class h{constructor(){this.a=[],this.b=[]}get(l){return l<0?(l=-l-1,this.b[l]):this.a[l]}set(l,g){l<0?(l=-l-1,this.b[l]=g):this.a[l]=g}}}),ne(ie[47],se([0,1,6,4,8]),function(O,t,k,D,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$CZ=t.$BZ=t.$AZ=t.$zZ=t.$yZ=void 0;function f(e,L,A){let p=A;return p=N(e,L,p),p=N(e,L,p),p=h(e,L,p),p}t.$yZ=f;function N(e,L,A){if(A.length===0)return A;const p=[];p.push(A[0]);for(let o=1;o<A.length;o++){const c=p[p.length-1];let s=A[o];if(s.seq1Range.isEmpty||s.seq2Range.isEmpty){const i=s.seq1Range.start-c.seq1Range.endExclusive;let u;for(u=1;u<=i&&!(e.getElement(s.seq1Range.start-u)!==e.getElement(s.seq1Range.endExclusive-u)||L.getElement(s.seq2Range.start-u)!==L.getElement(s.seq2Range.endExclusive-u));u++);if(u--,u===i){p[p.length-1]=new r.$mZ(new D.$Fs(c.seq1Range.start,s.seq1Range.endExclusive-i),new D.$Fs(c.seq2Range.start,s.seq2Range.endExclusive-i));continue}s=s.delta(-u)}p.push(s)}const $=[];for(let o=0;o<p.length-1;o++){const c=p[o+1];let s=p[o];if(s.seq1Range.isEmpty||s.seq2Range.isEmpty){const i=c.seq1Range.start-s.seq1Range.endExclusive;let u;for(u=0;u<i&&!(!e.isStronglyEqual(s.seq1Range.start+u,s.seq1Range.endExclusive+u)||!L.isStronglyEqual(s.seq2Range.start+u,s.seq2Range.endExclusive+u));u++);if(u===i){p[o+1]=new r.$mZ(new D.$Fs(s.seq1Range.start+i,c.seq1Range.endExclusive),new D.$Fs(s.seq2Range.start+i,c.seq2Range.endExclusive));continue}u>0&&(s=s.delta(u))}$.push(s)}return p.length>0&&$.push(p[p.length-1]),$}function h(e,L,A){if(!e.getBoundaryScore||!L.getBoundaryScore)return A;for(let p=0;p<A.length;p++){const $=p>0?A[p-1]:void 0,o=A[p],c=p+1<A.length?A[p+1]:void 0,s=new D.$Fs($?$.seq1Range.start+1:0,c?c.seq1Range.endExclusive-1:e.length),i=new D.$Fs($?$.seq2Range.start+1:0,c?c.seq2Range.endExclusive-1:L.length);o.seq1Range.isEmpty?A[p]=a(o,e,L,s,i):o.seq2Range.isEmpty&&(A[p]=a(o.swap(),L,e,i,s).swap())}return A}function a(e,L,A,p,$){let c=1;for(;e.seq1Range.start-c>=p.start&&e.seq2Range.start-c>=$.start&&A.isStronglyEqual(e.seq2Range.start-c,e.seq2Range.endExclusive-c)&&c<100;)c++;c--;let s=0;for(;e.seq1Range.start+s<p.endExclusive&&e.seq2Range.endExclusive+s<$.endExclusive&&A.isStronglyEqual(e.seq2Range.start+s,e.seq2Range.endExclusive+s)&&s<100;)s++;if(c===0&&s===0)return e;let i=0,u=-1;for(let w=-c;w<=s;w++){const d=e.seq2Range.start+w,v=e.seq2Range.endExclusive+w,R=e.seq1Range.start+w,M=L.getBoundaryScore(R)+A.getBoundaryScore(d)+A.getBoundaryScore(v);M>u&&(u=M,i=w)}return e.delta(i)}function l(e,L,A){const p=[];for(const $ of A){const o=p[p.length-1];if(!o){p.push($);continue}$.seq1Range.start-o.seq1Range.endExclusive<=2||$.seq2Range.start-o.seq2Range.endExclusive<=2?p[p.length-1]=new r.$mZ(o.seq1Range.join($.seq1Range),o.seq2Range.join($.seq2Range)):p.push($)}return p}t.$zZ=l;function g(e,L,A){const p=[];let $;function o(){if(!$)return;const s=$.s1Range.length-$.deleted,i=$.s2Range.length-$.added;Math.max($.deleted,$.added)+($.count-1)>s&&p.push(new r.$mZ($.s1Range,$.s2Range)),$=void 0}for(const s of A){let i=function(R,M){if(!$||!$.s1Range.containsRange(R)||!$.s2Range.containsRange(M))if($&&!($.s1Range.endExclusive<R.start&&$.s2Range.endExclusive<M.start)){const F=D.$Fs.tryCreate($.s1Range.endExclusive,R.start),y=D.$Fs.tryCreate($.s2Range.endExclusive,M.start);$.deleted+=F?.length??0,$.added+=y?.length??0,$.s1Range=$.s1Range.join(R),$.s2Range=$.s2Range.join(M)}else o(),$={added:0,deleted:0,count:0,s1Range:R,s2Range:M};const P=R.intersect(s.seq1Range),_=M.intersect(s.seq2Range);$.count++,$.deleted+=P?.length??0,$.added+=_?.length??0};const u=e.findWordContaining(s.seq1Range.start-1),w=L.findWordContaining(s.seq2Range.start-1),d=e.findWordContaining(s.seq1Range.endExclusive),v=L.findWordContaining(s.seq2Range.endExclusive);u&&d&&w&&v&&u.equals(d)&&w.equals(v)?i(u,w):(u&&w&&i(u,w),d&&v&&i(d,v))}return o(),E(A,p)}t.$AZ=g;function E(e,L){const A=[];for(;e.length>0||L.length>0;){const p=e[0],$=L[0];let o;p&&(!$||p.seq1Range.start<$.seq1Range.start)?o=e.shift():o=L.shift(),A.length>0&&A[A.length-1].seq1Range.endExclusive>=o.seq1Range.start?A[A.length-1]=A[A.length-1].join(o):A.push(o)}return A}function m(e,L,A){let p=A;if(p.length===0)return p;let $=0,o;do{o=!1;const c=[p[0]];for(let s=1;s<p.length;s++){let w=function(v,R){const M=new D.$Fs(u.seq1Range.endExclusive,i.seq1Range.start);return e.getText(M).replace(/\s/g,"").length<=4&&(v.seq1Range.length+v.seq2Range.length>5||R.seq1Range.length+R.seq2Range.length>5)};const i=p[s],u=c[c.length-1];w(u,i)?(o=!0,c[c.length-1]=c[c.length-1].join(i)):c.push(i)}p=c}while($++<10&&o);return p}t.$BZ=m;function b(e,L,A){let p=A;if(p.length===0)return p;let $=0,o;do{o=!1;const s=[p[0]];for(let i=1;i<p.length;i++){let d=function(R,M){const P=new D.$Fs(w.seq1Range.endExclusive,u.seq1Range.start);if(e.countLinesIn(P)>5||P.length>500)return!1;const F=e.getText(P).trim();if(F.length>20||F.split(/\r\n|\r|\n/).length>1)return!1;const y=e.countLinesIn(R.seq1Range),I=R.seq1Range.length,q=L.countLinesIn(R.seq2Range),x=R.seq2Range.length,T=e.countLinesIn(M.seq1Range),V=M.seq1Range.length,H=L.countLinesIn(M.seq2Range),W=M.seq2Range.length,J=2*40+50;function n(te){return Math.min(te,J)}return Math.pow(Math.pow(n(y*40+I),1.5)+Math.pow(n(q*40+x),1.5),1.5)+Math.pow(Math.pow(n(T*40+V),1.5)+Math.pow(n(H*40+W),1.5),1.5)>(J**1.5)**1.5*1.3};const u=p[i],w=s[s.length-1];d(w,u)?(o=!0,s[s.length-1]=s[s.length-1].join(u)):s.push(u)}p=s}while($++<10&&o);const c=[];return(0,k.$Cb)(p,(s,i,u)=>{let w=i;function d(F){return F.length>0&&F.trim().length<=3&&i.seq1Range.length+i.seq2Range.length>100}const v=e.extendToFullLines(i.seq1Range),R=e.getText(new D.$Fs(v.start,i.seq1Range.start));d(R)&&(w=w.deltaStart(-R.length));const M=e.getText(new D.$Fs(i.seq1Range.endExclusive,v.endExclusive));d(M)&&(w=w.deltaEnd(M.length));const P=r.$mZ.fromOffsetPairs(s?s.getEndExclusives():r.$nZ.zero,u?u.getStarts():r.$nZ.max),_=w.intersect(P);c.push(_)}),c}t.$CZ=b}),ne(ie[48],se([0,1]),function(O,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$xZ=void 0;class k{constructor(f,N){this.a=f,this.b=N}getElement(f){return this.a[f]}get length(){return this.a.length}getBoundaryScore(f){const N=f===0?0:D(this.b[f-1]),h=f===this.b.length?0:D(this.b[f]);return 1e3-(N+h)}getText(f){return this.b.slice(f.start,f.endExclusive).join(`
`)}isStronglyEqual(f,N){return this.b[f]===this.b[N]}}t.$xZ=k;function D(r){let f=0;for(;f<r.length&&(r.charCodeAt(f)===32||r.charCodeAt(f)===9);)f++;return f}}),ne(ie[17],se([0,1]),function(O,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$sZ=t.$rZ=t.$qZ=void 0;class k{constructor(N,h){this.width=N,this.height=h,this.a=[],this.a=new Array(N*h)}get(N,h){return this.a[N+h*this.width]}set(N,h,a){this.a[N+h*this.width]=a}}t.$qZ=k;function D(f){return f===32||f===9}t.$rZ=D;class r{static b(N){let h=this.a.get(N);return h===void 0&&(h=this.a.size,this.a.set(N,h)),h}constructor(N,h,a){this.range=N,this.lines=h,this.source=a,this.d=[];let l=0;for(let g=N.startLineNumber-1;g<N.endLineNumberExclusive-1;g++){const E=h[g];for(let b=0;b<E.length;b++){l++;const e=E[b],L=r.b(e);this.d[L]=(this.d[L]||0)+1}l++;const m=r.b(`
`);this.d[m]=(this.d[m]||0)+1}this.c=l}computeSimilarity(N){let h=0;const a=Math.max(this.d.length,N.d.length);for(let l=0;l<a;l++)h+=Math.abs((this.d[l]??0)-(N.d[l]??0));return 1-h/(this.c+N.c)}}t.$sZ=r,r.a=new Map}),ne(ie[49],se([0,1,4,8,17]),function(O,t,k,D,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$tZ=void 0;class f{compute(h,a,l=D.$oZ.instance,g){if(h.length===0||a.length===0)return D.$lZ.trivial(h,a);const E=new r.$qZ(h.length,a.length),m=new r.$qZ(h.length,a.length),b=new r.$qZ(h.length,a.length);for(let c=0;c<h.length;c++)for(let s=0;s<a.length;s++){if(!l.isValid())return D.$lZ.trivialTimedOut(h,a);const i=c===0?0:E.get(c-1,s),u=s===0?0:E.get(c,s-1);let w;h.getElement(c)===a.getElement(s)?(c===0||s===0?w=0:w=E.get(c-1,s-1),c>0&&s>0&&m.get(c-1,s-1)===3&&(w+=b.get(c-1,s-1)),w+=g?g(c,s):1):w=-1;const d=Math.max(i,u,w);if(d===w){const v=c>0&&s>0?b.get(c-1,s-1):0;b.set(c,s,v+1),m.set(c,s,3)}else d===i?(b.set(c,s,0),m.set(c,s,1)):d===u&&(b.set(c,s,0),m.set(c,s,2));E.set(c,s,d)}const e=[];let L=h.length,A=a.length;function p(c,s){(c+1!==L||s+1!==A)&&e.push(new D.$mZ(new k.$Fs(c+1,L),new k.$Fs(s+1,A))),L=c,A=s}let $=h.length-1,o=a.length-1;for(;$>=0&&o>=0;)m.get($,o)===3?(p($,o),$--,o--):m.get($,o)===1?$--:o--;return p(-1,-1),e.reverse(),new D.$lZ(e,!1)}}t.$tZ=f}),ne(ie[31],se([0,1,9,4,5,2,17]),function(O,t,k,D,r,f,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$vZ=void 0;class h{constructor(e,L,A){this.lines=e,this.considerWhitespaceChanges=A,this.b=[],this.c=[],this.d=[];let p=!1;L.start>0&&L.endExclusive>=e.length&&(L=new D.$Fs(L.start-1,L.endExclusive),p=!0),this.lineRange=L,this.c[0]=0;for(let $=this.lineRange.start;$<this.lineRange.endExclusive;$++){let o=e[$],c=0;if(p)c=o.length,o="",p=!1;else if(!A){const s=o.trimStart();c=o.length-s.length,o=s.trimEnd()}this.d.push(c);for(let s=0;s<o.length;s++)this.b.push(o.charCodeAt(s));$<e.length-1&&(this.b.push(`
`.charCodeAt(0)),this.c[$-this.lineRange.start+1]=this.b.length)}this.d.push(0)}toString(){return`Slice: "${this.text}"`}get text(){return this.getText(new D.$Fs(0,this.length))}getText(e){return this.b.slice(e.start,e.endExclusive).map(L=>String.fromCharCode(L)).join("")}getElement(e){return this.b[e]}get length(){return this.b.length}getBoundaryScore(e){const L=m(e>0?this.b[e-1]:-1),A=m(e<this.b.length?this.b[e]:-1);if(L===7&&A===8)return 0;let p=0;return L!==A&&(p+=10,L===0&&A===1&&(p+=1)),p+=E(L),p+=E(A),p}translateOffset(e){if(this.lineRange.isEmpty)return new r.$xs(this.lineRange.start+1,1);const L=(0,k.$ib)(this.c,A=>A<=e);return new r.$xs(this.lineRange.start+L+1,e-this.c[L]+this.d[L]+1)}translateRange(e){return f.$ys.fromPositions(this.translateOffset(e.start),this.translateOffset(e.endExclusive))}findWordContaining(e){if(e<0||e>=this.b.length||!a(this.b[e]))return;let L=e;for(;L>0&&a(this.b[L-1]);)L--;let A=e;for(;A<this.b.length&&a(this.b[A]);)A++;return new D.$Fs(L,A)}countLinesIn(e){return this.translateOffset(e.endExclusive).lineNumber-this.translateOffset(e.start).lineNumber}isStronglyEqual(e,L){return this.b[e]===this.b[L]}extendToFullLines(e){const L=(0,k.$hb)(this.c,p=>p<=e.start)??0,A=(0,k.$jb)(this.c,p=>e.endExclusive<=p)??this.b.length;return new D.$Fs(L,A)}}t.$vZ=h;function a(b){return b>=97&&b<=122||b>=65&&b<=90||b>=48&&b<=57}var l;(function(b){b[b.WordLower=0]="WordLower",b[b.WordUpper=1]="WordUpper",b[b.WordNumber=2]="WordNumber",b[b.End=3]="End",b[b.Other=4]="Other",b[b.Separator=5]="Separator",b[b.Space=6]="Space",b[b.LineBreakCR=7]="LineBreakCR",b[b.LineBreakLF=8]="LineBreakLF"})(l||(l={}));const g={[0]:0,[1]:0,[2]:0,[3]:10,[4]:2,[5]:3,[6]:3,[7]:10,[8]:10};function E(b){return g[b]}function m(b){return b===10?8:b===13?7:(0,N.$rZ)(b)?6:b>=97&&b<=122?0:b>=65&&b<=90?1:b>=48&&b<=57?2:b===-1?3:b===44||b===59?5:4}}),ne(ie[32],se([0,1]),function(O,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ns=t.$Ms=void 0;class k{constructor(f,N,h){this.changes=f,this.moves=N,this.hitTimeout=h}}t.$Ms=k;class D{constructor(f,N){this.lineRangeMapping=f,this.changes=N}flip(){return new D(this.lineRangeMapping.flip(),this.changes.map(f=>f.flip()))}}t.$Ns=D}),ne(ie[18],se([0,1,12]),function(O,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ls=t.$Ks=t.$Js=void 0;class D{static inverse(h,a,l){const g=[];let E=1,m=1;for(const e of h){const L=new r(new k.$Hs(E,e.original.startLineNumber),new k.$Hs(m,e.modified.startLineNumber),void 0);L.modified.isEmpty||g.push(L),E=e.original.endLineNumberExclusive,m=e.modified.endLineNumberExclusive}const b=new r(new k.$Hs(E,a+1),new k.$Hs(m,l+1),void 0);return b.modified.isEmpty||g.push(b),g}constructor(h,a){this.original=h,this.modified=a}toString(){return`{${this.original.toString()}->${this.modified.toString()}}`}flip(){return new D(this.modified,this.original)}join(h){return new D(this.original.join(h.original),this.modified.join(h.modified))}get changedLineCount(){return Math.max(this.original.length,this.modified.length)}}t.$Js=D;class r extends D{constructor(h,a,l){super(h,a),this.innerChanges=l}flip(){return new r(this.modified,this.original,this.innerChanges?.map(h=>h.flip()))}}t.$Ks=r;class f{constructor(h,a){this.originalRange=h,this.modifiedRange=a}toString(){return`{${this.originalRange.toString()}->${this.modifiedRange.toString()}}`}flip(){return new f(this.modifiedRange,this.originalRange)}}t.$Ls=f}),ne(ie[50],se([0,1,8,18,6,9,22,12,4,31,17,30]),function(O,t,k,D,r,f,N,h,a,l,g,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$wZ=void 0;function m(o,c,s,i,u,w){let{moves:d,excludedChanges:v}=e(o,c,s,w);if(!w.isValid())return[];const R=o.filter(P=>!v.has(P)),M=L(R,i,u,c,s,w);return(0,r.$1b)(d,M),d=p(d),d=d.filter(P=>{const _=P.original.toOffsetRange().slice(c).map(y=>y.trim());return _.join(`
`).length>=15&&b(_,y=>y.length>=2)>=2}),d=$(o,d),d}t.$wZ=m;function b(o,c){let s=0;for(const i of o)c(i)&&s++;return s}function e(o,c,s,i){const u=[],w=o.filter(R=>R.modified.isEmpty&&R.original.length>=3).map(R=>new g.$sZ(R.original,c,R)),d=new Set(o.filter(R=>R.original.isEmpty&&R.modified.length>=3).map(R=>new g.$sZ(R.modified,s,R))),v=new Set;for(const R of w){let M=-1,P;for(const _ of d){const F=R.computeSimilarity(_);F>M&&(M=F,P=_)}if(M>.9&&P&&(d.delete(P),u.push(new D.$Js(R.range,P.range)),v.add(R.source),v.add(P.source)),!i.isValid())return{moves:u,excludedChanges:v}}return{moves:u,excludedChanges:v}}function L(o,c,s,i,u,w){const d=[],v=new N.$Gc;for(const F of o)for(let y=F.original.startLineNumber;y<F.original.endLineNumberExclusive-2;y++){const I=`${c[y-1]}:${c[y+1-1]}:${c[y+2-1]}`;v.add(I,{range:new h.$Hs(y,y+3)})}const R=[];o.sort((0,r.$7b)(F=>F.modified.startLineNumber,r.$9b));for(const F of o){let y=[];for(let I=F.modified.startLineNumber;I<F.modified.endLineNumberExclusive-2;I++){const q=`${s[I-1]}:${s[I+1-1]}:${s[I+2-1]}`,x=new h.$Hs(I,I+3),T=[];v.forEach(q,({range:V})=>{for(const W of y)if(W.originalLineRange.endLineNumberExclusive+1===V.endLineNumberExclusive&&W.modifiedLineRange.endLineNumberExclusive+1===x.endLineNumberExclusive){W.originalLineRange=new h.$Hs(W.originalLineRange.startLineNumber,V.endLineNumberExclusive),W.modifiedLineRange=new h.$Hs(W.modifiedLineRange.startLineNumber,x.endLineNumberExclusive),T.push(W);return}const H={modifiedLineRange:x,originalLineRange:V};R.push(H),T.push(H)}),y=T}if(!w.isValid())return[]}R.sort((0,r.$$b)((0,r.$7b)(F=>F.modifiedLineRange.length,r.$9b)));const M=new h.$Is,P=new h.$Is;for(const F of R){const y=F.modifiedLineRange.startLineNumber-F.originalLineRange.startLineNumber,I=M.subtractFrom(F.modifiedLineRange),q=P.subtractFrom(F.originalLineRange).getWithDelta(y),x=I.getIntersection(q);for(const T of x.ranges){if(T.length<3)continue;const V=T,H=T.delta(-y);d.push(new D.$Js(H,V)),M.addRange(V),P.addRange(H)}}d.sort((0,r.$7b)(F=>F.original.startLineNumber,r.$9b));const _=new f.$mb(o);for(let F=0;F<d.length;F++){const y=d[F],I=_.findLastMonotonous(n=>n.original.startLineNumber<=y.original.startLineNumber),q=(0,f.$hb)(o,n=>n.modified.startLineNumber<=y.modified.startLineNumber),x=Math.max(y.original.startLineNumber-I.original.startLineNumber,y.modified.startLineNumber-q.modified.startLineNumber),T=_.findLastMonotonous(n=>n.original.startLineNumber<y.original.endLineNumberExclusive),V=(0,f.$hb)(o,n=>n.modified.startLineNumber<y.modified.endLineNumberExclusive),H=Math.max(T.original.endLineNumberExclusive-y.original.endLineNumberExclusive,V.modified.endLineNumberExclusive-y.modified.endLineNumberExclusive);let W;for(W=0;W<x;W++){const n=y.original.startLineNumber-W-1,te=y.modified.startLineNumber-W-1;if(n>i.length||te>u.length||M.contains(te)||P.contains(n)||!A(i[n-1],u[te-1],w))break}W>0&&(P.addRange(new h.$Hs(y.original.startLineNumber-W,y.original.startLineNumber)),M.addRange(new h.$Hs(y.modified.startLineNumber-W,y.modified.startLineNumber)));let J;for(J=0;J<H;J++){const n=y.original.endLineNumberExclusive+J,te=y.modified.endLineNumberExclusive+J;if(n>i.length||te>u.length||M.contains(te)||P.contains(n)||!A(i[n-1],u[te-1],w))break}J>0&&(P.addRange(new h.$Hs(y.original.endLineNumberExclusive,y.original.endLineNumberExclusive+J)),M.addRange(new h.$Hs(y.modified.endLineNumberExclusive,y.modified.endLineNumberExclusive+J))),(W>0||J>0)&&(d[F]=new D.$Js(new h.$Hs(y.original.startLineNumber-W,y.original.endLineNumberExclusive+J),new h.$Hs(y.modified.startLineNumber-W,y.modified.endLineNumberExclusive+J)))}return d}function A(o,c,s){if(o.trim()===c.trim())return!0;if(o.length>300&&c.length>300)return!1;const u=new E.$uZ().compute(new l.$vZ([o],new a.$Fs(0,1),!1),new l.$vZ([c],new a.$Fs(0,1),!1),s);let w=0;const d=k.$mZ.invert(u.diffs,o.length);for(const P of d)P.seq1Range.forEach(_=>{(0,g.$rZ)(o.charCodeAt(_))||w++});function v(P){let _=0;for(let F=0;F<o.length;F++)(0,g.$rZ)(P.charCodeAt(F))||_++;return _}const R=v(o.length>c.length?o:c);return w/R>.6&&R>10}function p(o){if(o.length===0)return o;o.sort((0,r.$7b)(s=>s.original.startLineNumber,r.$9b));const c=[o[0]];for(let s=1;s<o.length;s++){const i=c[c.length-1],u=o[s],w=u.original.startLineNumber-i.original.endLineNumberExclusive,d=u.modified.startLineNumber-i.modified.endLineNumberExclusive;if(w>=0&&d>=0&&w+d<=2){c[c.length-1]=i.join(u);continue}c.push(u)}return c}function $(o,c){const s=new f.$mb(o);return c=c.filter(i=>{const u=s.findLastMonotonous(v=>v.original.startLineNumber<i.original.endLineNumberExclusive)||new D.$Js(new h.$Hs(1,1),new h.$Hs(1,1)),w=(0,f.$hb)(o,v=>v.modified.startLineNumber<i.modified.endLineNumberExclusive);return u!==w}),c}}),ne(ie[51],se([0,1,6,13,12,4,2,8,49,30,50,47,32,18,31,48]),function(O,t,k,D,r,f,N,h,a,l,g,E,m,b,e,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$FZ=t.$EZ=t.$DZ=void 0;class A{constructor(){this.e=new a.$tZ,this.f=new l.$uZ}computeDiff(c,s,i){if(c.length<=1&&(0,k.$ub)(c,s,(J,n)=>J===n))return new m.$Ms([],[],!1);if(c.length===1&&c[0].length===0||s.length===1&&s[0].length===0)return new m.$Ms([new b.$Ks(new r.$Hs(1,c.length+1),new r.$Hs(1,s.length+1),[new b.$Ls(new N.$ys(1,1,c.length,c[0].length+1),new N.$ys(1,1,s.length,s[0].length+1))])],[],!1);const u=i.maxComputationTimeMs===0?h.$oZ.instance:new h.$pZ(i.maxComputationTimeMs),w=!i.ignoreTrimWhitespace,d=new Map;function v(J){let n=d.get(J);return n===void 0&&(n=d.size,d.set(J,n)),n}const R=c.map(J=>v(J.trim())),M=s.map(J=>v(J.trim())),P=new L.$xZ(R,c),_=new L.$xZ(M,s),F=(()=>P.length+_.length<1700?this.e.compute(P,_,u,(J,n)=>c[J]===s[n]?s[n].length===0?.1:1+Math.log(1+s[n].length):.99):this.f.compute(P,_))();let y=F.diffs,I=F.hitTimeout;y=(0,E.$yZ)(P,_,y),y=(0,E.$BZ)(P,_,y);const q=[],x=J=>{if(w)for(let n=0;n<J;n++){const te=T+n,ce=V+n;if(c[te]!==s[ce]){const me=this.j(c,s,new h.$mZ(new f.$Fs(te,te+1),new f.$Fs(ce,ce+1)),u,w);for(const Ne of me.mappings)q.push(Ne);me.hitTimeout&&(I=!0)}}};let T=0,V=0;for(const J of y){(0,D.$6c)(()=>J.seq1Range.start-T===J.seq2Range.start-V);const n=J.seq1Range.start-T;x(n),T=J.seq1Range.endExclusive,V=J.seq2Range.endExclusive;const te=this.j(c,s,J,u,w);te.hitTimeout&&(I=!0);for(const ce of te.mappings)q.push(ce)}x(c.length-T);const H=p(q,c,s);let W=[];return i.computeMoves&&(W=this.h(H,c,s,R,M,u,w)),(0,D.$6c)(()=>{function J(te,ce){if(te.lineNumber<1||te.lineNumber>ce.length)return!1;const me=ce[te.lineNumber-1];return!(te.column<1||te.column>me.length+1)}function n(te,ce){return!(te.startLineNumber<1||te.startLineNumber>ce.length+1||te.endLineNumberExclusive<1||te.endLineNumberExclusive>ce.length+1)}for(const te of H){if(!te.innerChanges)return!1;for(const ce of te.innerChanges)if(!(J(ce.modifiedRange.getStartPosition(),s)&&J(ce.modifiedRange.getEndPosition(),s)&&J(ce.originalRange.getStartPosition(),c)&&J(ce.originalRange.getEndPosition(),c)))return!1;if(!n(te.modified,s)||!n(te.original,c))return!1}return!0}),new m.$Ms(H,W,I)}h(c,s,i,u,w,d,v){return(0,g.$wZ)(c,s,i,u,w,d).map(P=>{const _=this.j(s,i,new h.$mZ(P.original.toOffsetRange(),P.modified.toOffsetRange()),d,v),F=p(_.mappings,s,i,!0);return new m.$Ns(P,F)})}j(c,s,i,u,w){const d=new e.$vZ(c,i.seq1Range,w),v=new e.$vZ(s,i.seq2Range,w),R=d.length+v.length<500?this.e.compute(d,v,u):this.f.compute(d,v,u);let M=R.diffs;return M=(0,E.$yZ)(d,v,M),M=(0,E.$AZ)(d,v,M),M=(0,E.$zZ)(d,v,M),M=(0,E.$CZ)(d,v,M),{mappings:M.map(_=>new b.$Ls(d.translateRange(_.seq1Range),v.translateRange(_.seq2Range))),hitTimeout:R.hitTimeout}}}t.$DZ=A;function p(o,c,s,i=!1){const u=[];for(const w of(0,k.$Ab)(o.map(d=>$(d,c,s)),(d,v)=>d.original.overlapOrTouch(v.original)||d.modified.overlapOrTouch(v.modified))){const d=w[0],v=w[w.length-1];u.push(new b.$Ks(d.original.join(v.original),d.modified.join(v.modified),w.map(R=>R.innerChanges[0])))}return(0,D.$6c)(()=>!i&&u.length>0&&u[0].original.startLineNumber!==u[0].modified.startLineNumber?!1:(0,D.$7c)(u,(w,d)=>d.original.startLineNumber-w.original.endLineNumberExclusive===d.modified.startLineNumber-w.modified.endLineNumberExclusive&&w.original.endLineNumberExclusive<d.original.startLineNumber&&w.modified.endLineNumberExclusive<d.modified.startLineNumber)),u}t.$EZ=p;function $(o,c,s){let i=0,u=0;o.modifiedRange.endColumn===1&&o.originalRange.endColumn===1&&o.originalRange.startLineNumber+i<=o.originalRange.endLineNumber&&o.modifiedRange.startLineNumber+i<=o.modifiedRange.endLineNumber&&(u=-1),o.modifiedRange.startColumn-1>=s[o.modifiedRange.startLineNumber-1].length&&o.originalRange.startColumn-1>=c[o.originalRange.startLineNumber-1].length&&o.originalRange.startLineNumber<=o.originalRange.endLineNumber+u&&o.modifiedRange.startLineNumber<=o.modifiedRange.endLineNumber+u&&(i=1);const w=new r.$Hs(o.originalRange.startLineNumber+i,o.originalRange.endLineNumber+1+u),d=new r.$Hs(o.modifiedRange.startLineNumber+i,o.modifiedRange.endLineNumber+1+u);return new b.$Ks(w,d,[o])}t.$FZ=$}),ne(ie[33],se([0,1,25,32,18,7,2,13,12]),function(O,t,k,D,r,f,N,h,a){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ps=t.$Os=void 0;const l=3;class g{computeDiff(i,u,w){const v=new p(i,u,{maxComputationTime:w.maxComputationTimeMs,shouldIgnoreTrimWhitespace:w.ignoreTrimWhitespace,shouldComputeCharChanges:!0,shouldMakePrettyDiff:!0,shouldPostProcessCharChanges:!0}).computeDiff(),R=[];let M=null;for(const P of v.changes){let _;P.originalEndLineNumber===0?_=new a.$Hs(P.originalStartLineNumber+1,P.originalStartLineNumber+1):_=new a.$Hs(P.originalStartLineNumber,P.originalEndLineNumber+1);let F;P.modifiedEndLineNumber===0?F=new a.$Hs(P.modifiedStartLineNumber+1,P.modifiedStartLineNumber+1):F=new a.$Hs(P.modifiedStartLineNumber,P.modifiedEndLineNumber+1);let y=new r.$Ks(_,F,P.charChanges?.map(I=>new r.$Ls(new N.$ys(I.originalStartLineNumber,I.originalStartColumn,I.originalEndLineNumber,I.originalEndColumn),new N.$ys(I.modifiedStartLineNumber,I.modifiedStartColumn,I.modifiedEndLineNumber,I.modifiedEndColumn))));M&&(M.modified.endLineNumberExclusive===y.modified.startLineNumber||M.original.endLineNumberExclusive===y.original.startLineNumber)&&(y=new r.$Ks(M.original.join(y.original),M.modified.join(y.modified),M.innerChanges&&y.innerChanges?M.innerChanges.concat(y.innerChanges):void 0),R.pop()),R.push(y),M=y}return(0,h.$6c)(()=>(0,h.$7c)(R,(P,_)=>_.original.startLineNumber-P.original.endLineNumberExclusive===_.modified.startLineNumber-P.modified.endLineNumberExclusive&&P.original.endLineNumberExclusive<_.original.startLineNumber&&P.modified.endLineNumberExclusive<_.modified.startLineNumber)),new D.$Ms(R,[],v.quitEarly)}}t.$Os=g;function E(s,i,u,w){return new k.$Es(s,i,u).ComputeDiff(w)}class m{constructor(i){const u=[],w=[];for(let d=0,v=i.length;d<v;d++)u[d]=$(i[d],1),w[d]=o(i[d],1);this.lines=i,this.a=u,this.b=w}getElements(){const i=[];for(let u=0,w=this.lines.length;u<w;u++)i[u]=this.lines[u].substring(this.a[u]-1,this.b[u]-1);return i}getStrictElement(i){return this.lines[i]}getStartLineNumber(i){return i+1}getEndLineNumber(i){return i+1}createCharSequence(i,u,w){const d=[],v=[],R=[];let M=0;for(let P=u;P<=w;P++){const _=this.lines[P],F=i?this.a[P]:1,y=i?this.b[P]:_.length+1;for(let I=F;I<y;I++)d[M]=_.charCodeAt(I-1),v[M]=P+1,R[M]=I,M++;!i&&P<w&&(d[M]=10,v[M]=P+1,R[M]=_.length+1,M++)}return new b(d,v,R)}}class b{constructor(i,u,w){this.a=i,this.b=u,this.d=w}toString(){return"["+this.a.map((i,u)=>(i===10?"\\n":String.fromCharCode(i))+`-(${this.b[u]},${this.d[u]})`).join(", ")+"]"}e(i,u){if(i<0||i>=u.length)throw new Error("Illegal index")}getElements(){return this.a}getStartLineNumber(i){return i>0&&i===this.b.length?this.getEndLineNumber(i-1):(this.e(i,this.b),this.b[i])}getEndLineNumber(i){return i===-1?this.getStartLineNumber(i+1):(this.e(i,this.b),this.a[i]===10?this.b[i]+1:this.b[i])}getStartColumn(i){return i>0&&i===this.d.length?this.getEndColumn(i-1):(this.e(i,this.d),this.d[i])}getEndColumn(i){return i===-1?this.getStartColumn(i+1):(this.e(i,this.d),this.a[i]===10?1:this.d[i]+1)}}class e{constructor(i,u,w,d,v,R,M,P){this.originalStartLineNumber=i,this.originalStartColumn=u,this.originalEndLineNumber=w,this.originalEndColumn=d,this.modifiedStartLineNumber=v,this.modifiedStartColumn=R,this.modifiedEndLineNumber=M,this.modifiedEndColumn=P}static createFromDiffChange(i,u,w){const d=u.getStartLineNumber(i.originalStart),v=u.getStartColumn(i.originalStart),R=u.getEndLineNumber(i.originalStart+i.originalLength-1),M=u.getEndColumn(i.originalStart+i.originalLength-1),P=w.getStartLineNumber(i.modifiedStart),_=w.getStartColumn(i.modifiedStart),F=w.getEndLineNumber(i.modifiedStart+i.modifiedLength-1),y=w.getEndColumn(i.modifiedStart+i.modifiedLength-1);return new e(d,v,R,M,P,_,F,y)}}function L(s){if(s.length<=1)return s;const i=[s[0]];let u=i[0];for(let w=1,d=s.length;w<d;w++){const v=s[w],R=v.originalStart-(u.originalStart+u.originalLength),M=v.modifiedStart-(u.modifiedStart+u.modifiedLength);Math.min(R,M)<l?(u.originalLength=v.originalStart+v.originalLength-u.originalStart,u.modifiedLength=v.modifiedStart+v.modifiedLength-u.modifiedStart):(i.push(v),u=v)}return i}class A{constructor(i,u,w,d,v){this.originalStartLineNumber=i,this.originalEndLineNumber=u,this.modifiedStartLineNumber=w,this.modifiedEndLineNumber=d,this.charChanges=v}static createFromDiffResult(i,u,w,d,v,R,M){let P,_,F,y,I;if(u.originalLength===0?(P=w.getStartLineNumber(u.originalStart)-1,_=0):(P=w.getStartLineNumber(u.originalStart),_=w.getEndLineNumber(u.originalStart+u.originalLength-1)),u.modifiedLength===0?(F=d.getStartLineNumber(u.modifiedStart)-1,y=0):(F=d.getStartLineNumber(u.modifiedStart),y=d.getEndLineNumber(u.modifiedStart+u.modifiedLength-1)),R&&u.originalLength>0&&u.originalLength<20&&u.modifiedLength>0&&u.modifiedLength<20&&v()){const q=w.createCharSequence(i,u.originalStart,u.originalStart+u.originalLength-1),x=d.createCharSequence(i,u.modifiedStart,u.modifiedStart+u.modifiedLength-1);if(q.getElements().length>0&&x.getElements().length>0){let T=E(q,x,v,!0).changes;M&&(T=L(T)),I=[];for(let V=0,H=T.length;V<H;V++)I.push(e.createFromDiffChange(T[V],q,x))}}return new A(P,_,F,y,I)}}class p{constructor(i,u,w){this.a=w.shouldComputeCharChanges,this.b=w.shouldPostProcessCharChanges,this.d=w.shouldIgnoreTrimWhitespace,this.e=w.shouldMakePrettyDiff,this.f=i,this.g=u,this.h=new m(i),this.j=new m(u),this.k=c(w.maxComputationTime),this.l=c(w.maxComputationTime===0?0:Math.min(w.maxComputationTime,5e3))}computeDiff(){if(this.h.lines.length===1&&this.h.lines[0].length===0)return this.j.lines.length===1&&this.j.lines[0].length===0?{quitEarly:!1,changes:[]}:{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:1,modifiedStartLineNumber:1,modifiedEndLineNumber:this.j.lines.length,charChanges:void 0}]};if(this.j.lines.length===1&&this.j.lines[0].length===0)return{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:this.h.lines.length,modifiedStartLineNumber:1,modifiedEndLineNumber:1,charChanges:void 0}]};const i=E(this.h,this.j,this.k,this.e),u=i.changes,w=i.quitEarly;if(this.d){const M=[];for(let P=0,_=u.length;P<_;P++)M.push(A.createFromDiffResult(this.d,u[P],this.h,this.j,this.l,this.a,this.b));return{quitEarly:w,changes:M}}const d=[];let v=0,R=0;for(let M=-1,P=u.length;M<P;M++){const _=M+1<P?u[M+1]:null,F=_?_.originalStart:this.f.length,y=_?_.modifiedStart:this.g.length;for(;v<F&&R<y;){const I=this.f[v],q=this.g[R];if(I!==q){{let x=$(I,1),T=$(q,1);for(;x>1&&T>1;){const V=I.charCodeAt(x-2),H=q.charCodeAt(T-2);if(V!==H)break;x--,T--}(x>1||T>1)&&this.m(d,v+1,1,x,R+1,1,T)}{let x=o(I,1),T=o(q,1);const V=I.length+1,H=q.length+1;for(;x<V&&T<H;){const W=I.charCodeAt(x-1),J=I.charCodeAt(T-1);if(W!==J)break;x++,T++}(x<V||T<H)&&this.m(d,v+1,x,V,R+1,T,H)}}v++,R++}_&&(d.push(A.createFromDiffResult(this.d,_,this.h,this.j,this.l,this.a,this.b)),v+=_.originalLength,R+=_.modifiedLength)}return{quitEarly:w,changes:d}}m(i,u,w,d,v,R,M){if(this.n(i,u,w,d,v,R,M))return;let P;this.a&&(P=[new e(u,w,u,d,v,R,v,M)]),i.push(new A(u,u,v,v,P))}n(i,u,w,d,v,R,M){const P=i.length;if(P===0)return!1;const _=i[P-1];return _.originalEndLineNumber===0||_.modifiedEndLineNumber===0?!1:_.originalEndLineNumber===u&&_.modifiedEndLineNumber===v?(this.a&&_.charChanges&&_.charChanges.push(new e(u,w,u,d,v,R,v,M)),!0):_.originalEndLineNumber+1===u&&_.modifiedEndLineNumber+1===v?(_.originalEndLineNumber=u,_.modifiedEndLineNumber=v,this.a&&_.charChanges&&_.charChanges.push(new e(u,w,u,d,v,R,v,M)),!0):!1}}t.$Ps=p;function $(s,i){const u=f.$Re(s);return u===-1?i:u+1}function o(s,i){const u=f.$Te(s);return u===-1?i:u+2}function c(s){if(s===0)return()=>!0;const i=Date.now();return()=>Date.now()-i<s}}),ne(ie[52],se([0,1,33,51]),function(O,t,k,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$GZ=void 0,t.$GZ={getLegacy:()=>new k.$Os,getDefault:()=>new D.$DZ}}),ne(ie[53],se([0,1,35]),function(O,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$HZ=void 0;function D(m){const b=[];for(const e of m){const L=Number(e);(L||L===0&&e.replace(/\s/g,"")!=="")&&b.push(L)}return b}function r(m,b,e,L){return{red:m/255,blue:e/255,green:b/255,alpha:L}}function f(m,b){const e=b.index,L=b[0].length;if(!e)return;const A=m.positionAt(e);return{startLineNumber:A.lineNumber,startColumn:A.column,endLineNumber:A.lineNumber,endColumn:A.column+L}}function N(m,b){if(!m)return;const e=k.$3s.Format.CSS.parseHex(b);if(e)return{range:m,color:r(e.rgba.r,e.rgba.g,e.rgba.b,e.rgba.a)}}function h(m,b,e){if(!m||b.length!==1)return;const A=b[0].values(),p=D(A);return{range:m,color:r(p[0],p[1],p[2],e?p[3]:1)}}function a(m,b,e){if(!m||b.length!==1)return;const A=b[0].values(),p=D(A),$=new k.$3s(new k.$1s(p[0],p[1]/100,p[2]/100,e?p[3]:1));return{range:m,color:r($.rgba.r,$.rgba.g,$.rgba.b,$.rgba.a)}}function l(m,b){return typeof m=="string"?[...m.matchAll(b)]:m.findMatches(b)}function g(m){const b=[],L=l(m,/\b(rgb|rgba|hsl|hsla)(\([0-9\s,.\%]*\))|(#)([A-Fa-f0-9]{3})\b|(#)([A-Fa-f0-9]{4})\b|(#)([A-Fa-f0-9]{6})\b|(#)([A-Fa-f0-9]{8})\b/gm);if(L.length>0)for(const A of L){const p=A.filter(s=>s!==void 0),$=p[1],o=p[2];if(!o)continue;let c;if($==="rgb"){const s=/^\(\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*\)$/gm;c=h(f(m,A),l(o,s),!1)}else if($==="rgba"){const s=/^\(\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(0[.][0-9]+|[.][0-9]+|[01][.]|[01])\s*\)$/gm;c=h(f(m,A),l(o,s),!0)}else if($==="hsl"){const s=/^\(\s*(36[0]|3[0-5][0-9]|[12][0-9][0-9]|[1-9]?[0-9])\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*\)$/gm;c=a(f(m,A),l(o,s),!1)}else if($==="hsla"){const s=/^\(\s*(36[0]|3[0-5][0-9]|[12][0-9][0-9]|[1-9]?[0-9])\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(0[.][0-9]+|[.][0-9]+|[01][.]|[01])\s*\)$/gm;c=a(f(m,A),l(o,s),!0)}else $==="#"&&(c=N(f(m,A),$+o));c&&b.push(c)}return b}function E(m){return!m||typeof m.getValue!="function"||typeof m.positionAt!="function"?[]:g(m)}t.$HZ=E}),ne(ie[54],se([0,1,28]),function(O,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$hZ=t.$gZ=t.$fZ=t.State=void 0;var D;(function(b){b[b.Invalid=0]="Invalid",b[b.Start=1]="Start",b[b.H=2]="H",b[b.HT=3]="HT",b[b.HTT=4]="HTT",b[b.HTTP=5]="HTTP",b[b.F=6]="F",b[b.FI=7]="FI",b[b.FIL=8]="FIL",b[b.BeforeColon=9]="BeforeColon",b[b.AfterColon=10]="AfterColon",b[b.AlmostThere=11]="AlmostThere",b[b.End=12]="End",b[b.Accept=13]="Accept",b[b.LastKnownState=14]="LastKnownState"})(D||(t.State=D={}));class r{constructor(e,L,A){const p=new Uint8Array(e*L);for(let $=0,o=e*L;$<o;$++)p[$]=A;this.a=p,this.rows=e,this.cols=L}get(e,L){return this.a[e*this.cols+L]}set(e,L,A){this.a[e*this.cols+L]=A}}class f{constructor(e){let L=0,A=0;for(let $=0,o=e.length;$<o;$++){const[c,s,i]=e[$];s>L&&(L=s),c>A&&(A=c),i>A&&(A=i)}L++,A++;const p=new r(A,L,0);for(let $=0,o=e.length;$<o;$++){const[c,s,i]=e[$];p.set(c,s,i)}this.a=p,this.b=L}nextState(e,L){return L<0||L>=this.b?0:this.a.get(e,L)}}t.$fZ=f;let N=null;function h(){return N===null&&(N=new f([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),N}var a;(function(b){b[b.None=0]="None",b[b.ForceTermination=1]="ForceTermination",b[b.CannotEndIn=2]="CannotEndIn"})(a||(a={}));let l=null;function g(){if(l===null){l=new k.$Vs(0);const b=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let L=0;L<b.length;L++)l.set(b.charCodeAt(L),1);const e=".,;:";for(let L=0;L<e.length;L++)l.set(e.charCodeAt(L),2)}return l}class E{static a(e,L,A,p,$){let o=$-1;do{const c=L.charCodeAt(o);if(e.get(c)!==2)break;o--}while(o>p);if(p>0){const c=L.charCodeAt(p-1),s=L.charCodeAt(o);(c===40&&s===41||c===91&&s===93||c===123&&s===125)&&o--}return{range:{startLineNumber:A,startColumn:p+1,endLineNumber:A,endColumn:o+2},url:L.substring(p,o+1)}}static computeLinks(e,L=h()){const A=g(),p=[];for(let $=1,o=e.getLineCount();$<=o;$++){const c=e.getLineContent($),s=c.length;let i=0,u=0,w=0,d=1,v=!1,R=!1,M=!1,P=!1;for(;i<s;){let _=!1;const F=c.charCodeAt(i);if(d===13){let y;switch(F){case 40:v=!0,y=0;break;case 41:y=v?0:1;break;case 91:M=!0,R=!0,y=0;break;case 93:M=!1,y=R?0:1;break;case 123:P=!0,y=0;break;case 125:y=P?0:1;break;case 39:case 34:case 96:w===F?y=1:w===39||w===34||w===96?y=0:y=1;break;case 42:y=w===42?1:0;break;case 124:y=w===124?1:0;break;case 32:y=M?0:1;break;default:y=A.get(F)}y===1&&(p.push(E.a(A,c,$,u,i)),_=!0)}else if(d===12){let y;F===91?(R=!0,y=0):y=A.get(F),y===1?_=!0:d=13}else d=L.nextState(d,F),d===0&&(_=!0);_&&(d=1,v=!1,R=!1,P=!1,u=i+1,w=F),i++}d===13&&p.push(E.a(A,c,$,u,s))}return p}}t.$gZ=E;function m(b){return!b||typeof b.getLineCount!="function"||typeof b.getLineContent!="function"?[]:E.computeLinks(b)}t.$hZ=m}),ne(ie[55],se([0,1]),function(O,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$iZ=void 0;class k{constructor(){this.c=[["true","false"],["True","False"],["Private","Public","Friend","ReadOnly","Partial","Protected","WriteOnly"],["public","protected","private"]]}navigateValueSet(r,f,N,h,a){if(r&&f){const l=this.a(f,a);if(l)return{range:r,value:l}}if(N&&h){const l=this.a(h,a);if(l)return{range:N,value:l}}return null}a(r,f){const N=this.b(r,f);return N!==null?N:this.d(r,f)}b(r,f){const N=Math.pow(10,r.length-(r.lastIndexOf(".")+1));let h=Number(r);const a=parseFloat(r);return!isNaN(h)&&!isNaN(a)&&h===a?h===0&&!f?null:(h=Math.floor(h*N),h+=f?N:-N,String(h/N)):null}d(r,f){return this.e(this.c,r,f)}e(r,f,N){let h=null;for(let a=0,l=r.length;h===null&&a<l;a++)h=this.f(r[a],f,N);return h}f(r,f,N){let h=r.indexOf(f);return h>=0?(h+=N?1:-1,h<0?h=r.length-1:h%=r.length,r[h]):null}}t.$iZ=k,k.INSTANCE=new k}),ne(ie[56],se([0,1,15]),function(O,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Uu=t.$Tu=t.$Su=t.$Ru=t.ModelConstants=t.PositionAffinity=t.$Qu=t.TrackedRangeStickiness=t.$Pu=t.$Ou=t.EndOfLineSequence=t.DefaultEndOfLine=t.EndOfLinePreference=t.InjectedTextCursorStops=t.MinimapPosition=t.GlyphMarginLane=t.OverviewRulerLane=void 0;var D;(function(c){c[c.Left=1]="Left",c[c.Center=2]="Center",c[c.Right=4]="Right",c[c.Full=7]="Full"})(D||(t.OverviewRulerLane=D={}));var r;(function(c){c[c.Left=1]="Left",c[c.Right=2]="Right"})(r||(t.GlyphMarginLane=r={}));var f;(function(c){c[c.Inline=1]="Inline",c[c.Gutter=2]="Gutter"})(f||(t.MinimapPosition=f={}));var N;(function(c){c[c.Both=0]="Both",c[c.Right=1]="Right",c[c.Left=2]="Left",c[c.None=3]="None"})(N||(t.InjectedTextCursorStops=N={}));var h;(function(c){c[c.TextDefined=0]="TextDefined",c[c.LF=1]="LF",c[c.CRLF=2]="CRLF"})(h||(t.EndOfLinePreference=h={}));var a;(function(c){c[c.LF=1]="LF",c[c.CRLF=2]="CRLF"})(a||(t.DefaultEndOfLine=a={}));var l;(function(c){c[c.LF=0]="LF",c[c.CRLF=1]="CRLF"})(l||(t.EndOfLineSequence=l={}));class g{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(s){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,s.tabSize|0),s.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,s.indentSize|0),this.a=!1),this.insertSpaces=!!s.insertSpaces,this.defaultEOL=s.defaultEOL|0,this.trimAutoWhitespace=!!s.trimAutoWhitespace,this.bracketPairColorizationOptions=s.bracketPairColorizationOptions}equals(s){return this.tabSize===s.tabSize&&this.a===s.a&&this.indentSize===s.indentSize&&this.insertSpaces===s.insertSpaces&&this.defaultEOL===s.defaultEOL&&this.trimAutoWhitespace===s.trimAutoWhitespace&&(0,k.$an)(this.bracketPairColorizationOptions,s.bracketPairColorizationOptions)}createChangeEvent(s){return{tabSize:this.tabSize!==s.tabSize,indentSize:this.indentSize!==s.indentSize,insertSpaces:this.insertSpaces!==s.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==s.trimAutoWhitespace}}}t.$Ou=g;class E{constructor(s,i){this._findMatchBrand=void 0,this.range=s,this.matches=i}}t.$Pu=E;var m;(function(c){c[c.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",c[c.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",c[c.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",c[c.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(m||(t.TrackedRangeStickiness=m={}));function b(c){return c&&typeof c.read=="function"}t.$Qu=b;var e;(function(c){c[c.Left=0]="Left",c[c.Right=1]="Right",c[c.None=2]="None",c[c.LeftOfInjectedText=3]="LeftOfInjectedText",c[c.RightOfInjectedText=4]="RightOfInjectedText"})(e||(t.PositionAffinity=e={}));var L;(function(c){c[c.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(L||(t.ModelConstants=L={}));class A{constructor(s,i,u,w,d,v){this.identifier=s,this.range=i,this.text=u,this.forceMoveMarkers=w,this.isAutoWhitespaceEdit=d,this._isTracked=v}}t.$Ru=A;class p{constructor(s,i,u){this.regex=s,this.wordSeparators=i,this.simpleSearch=u}}t.$Su=p;class ${constructor(s,i,u){this.reverseEdits=s,this.changes=i,this.trimAutoWhitespaceLineNumbers=u}}t.$Tu=$;function o(c){return!c.isTooLargeForSyncing()&&!c.isForSimpleWidget}t.$Uu=o}),ne(ie[57],se([0,1,6,27]),function(O,t,k,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Zu=t.$Yu=t.$Xu=void 0;class r{constructor(a){this.a=a,this.b=new Uint32Array(a.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues(a,l){a=(0,D.$Be)(a);const g=this.a,E=this.b,m=l.length;return m===0?!1:(this.a=new Uint32Array(g.length+m),this.a.set(g.subarray(0,a),0),this.a.set(g.subarray(a),a+m),this.a.set(l,a),a-1<this.c[0]&&(this.c[0]=a-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(E.subarray(0,this.c[0]+1)),!0)}setValue(a,l){return a=(0,D.$Be)(a),l=(0,D.$Be)(l),this.a[a]===l?!1:(this.a[a]=l,a-1<this.c[0]&&(this.c[0]=a-1),!0)}removeValues(a,l){a=(0,D.$Be)(a),l=(0,D.$Be)(l);const g=this.a,E=this.b;if(a>=g.length)return!1;const m=g.length-a;return l>=m&&(l=m),l===0?!1:(this.a=new Uint32Array(g.length-l),this.a.set(g.subarray(0,a),0),this.a.set(g.subarray(a+l),a),this.b=new Uint32Array(this.a.length),a-1<this.c[0]&&(this.c[0]=a-1),this.c[0]>=0&&this.b.set(E.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum(a){return a<0?0:(a=(0,D.$Be)(a),this.d(a))}d(a){if(a<=this.c[0])return this.b[a];let l=this.c[0]+1;l===0&&(this.b[0]=this.a[0],l++),a>=this.a.length&&(a=this.a.length-1);for(let g=l;g<=a;g++)this.b[g]=this.b[g-1]+this.a[g];return this.c[0]=Math.max(this.c[0],a),this.b[a]}getIndexOf(a){a=Math.floor(a),this.getTotalSum();let l=0,g=this.a.length-1,E=0,m=0,b=0;for(;l<=g;)if(E=l+(g-l)/2|0,m=this.b[E],b=m-this.a[E],a<b)g=E-1;else if(a>=m)l=E+1;else break;return new N(E,a-b)}}t.$Xu=r;class f{constructor(a){this.a=a,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum(a){return this.g(),a===0?0:this.d[a-1]}getIndexOf(a){this.g();const l=this.e[a],g=l>0?this.d[l-1]:0;return new N(l,a-g)}removeValues(a,l){this.a.splice(a,l),this.f(a)}insertValues(a,l){this.a=(0,k.$Wb)(this.a,a,l),this.f(a)}f(a){this.b=!1,this.c=Math.min(this.c,a-1)}g(){if(!this.b){for(let a=this.c+1,l=this.a.length;a<l;a++){const g=this.a[a],E=a>0?this.d[a-1]:0;this.d[a]=E+g;for(let m=0;m<g;m++)this.e[E+m]=a}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue(a,l){this.a[a]!==l&&(this.a[a]=l,this.f(a))}}t.$Yu=f;class N{constructor(a,l){this.index=a,this.remainder=l,this._prefixSumIndexOfResultBrand=void 0,this.index=a,this.remainder=l}}t.$Zu=N}),ne(ie[58],se([0,1,7,5,57]),function(O,t,k,D,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$1u=void 0;class f{constructor(h,a,l,g){this.d=h,this.f=a,this.g=l,this.h=g,this.j=null,this.k=null}dispose(){this.f.length=0}get version(){return this.h}getText(){return this.k===null&&(this.k=this.f.join(this.g)),this.k}onEvents(h){h.eol&&h.eol!==this.g&&(this.g=h.eol,this.j=null);const a=h.changes;for(const l of a)this.o(l.range),this.p(new D.$xs(l.range.startLineNumber,l.range.startColumn),l.text);this.h=h.versionId,this.k=null}l(){if(!this.j){const h=this.g.length,a=this.f.length,l=new Uint32Array(a);for(let g=0;g<a;g++)l[g]=this.f[g].length+h;this.j=new r.$Xu(l)}}n(h,a){this.f[h]=a,this.j&&this.j.setValue(h,this.f[h].length+this.g.length)}o(h){if(h.startLineNumber===h.endLineNumber){if(h.startColumn===h.endColumn)return;this.n(h.startLineNumber-1,this.f[h.startLineNumber-1].substring(0,h.startColumn-1)+this.f[h.startLineNumber-1].substring(h.endColumn-1));return}this.n(h.startLineNumber-1,this.f[h.startLineNumber-1].substring(0,h.startColumn-1)+this.f[h.endLineNumber-1].substring(h.endColumn-1)),this.f.splice(h.startLineNumber,h.endLineNumber-h.startLineNumber),this.j&&this.j.removeValues(h.startLineNumber,h.endLineNumber-h.startLineNumber)}p(h,a){if(a.length===0)return;const l=(0,k.$Qe)(a);if(l.length===1){this.n(h.lineNumber-1,this.f[h.lineNumber-1].substring(0,h.column-1)+l[0]+this.f[h.lineNumber-1].substring(h.column-1));return}l[l.length-1]+=this.f[h.lineNumber-1].substring(h.column-1),this.n(h.lineNumber-1,this.f[h.lineNumber-1].substring(0,h.column-1)+l[0]);const g=new Uint32Array(l.length-1);for(let E=1;E<l.length;E++)this.f.splice(h.lineNumber+E-1,0,l[E]),g[E-1]=l[E].length+this.g.length;this.j&&this.j.insertValues(h.lineNumber,g)}}t.$1u=f}),ne(ie[59],se([0,1,7,46,5,2,56]),function(O,t,k,D,r,f,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$EB=t.$DB=t.$CB=t.$BB=t.$AB=t.$zB=void 0;const h=999;class a{constructor($,o,c,s){this.searchString=$,this.isRegex=o,this.matchCase=c,this.wordSeparators=s}parseSearchRequest(){if(this.searchString==="")return null;let $;this.isRegex?$=l(this.searchString):$=this.searchString.indexOf(`
`)>=0;let o=null;try{o=k.$Oe(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:$,global:!0,unicode:!0})}catch{return null}if(!o)return null;let c=!this.isRegex&&!$;return c&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(c=this.matchCase),new N.$Su(o,this.wordSeparators?(0,D.$Ys)(this.wordSeparators):null,c?this.searchString:null)}}t.$zB=a;function l(p){if(!p||p.length===0)return!1;for(let $=0,o=p.length;$<o;$++){const c=p.charCodeAt($);if(c===10)return!0;if(c===92){if($++,$>=o)break;const s=p.charCodeAt($);if(s===110||s===114||s===87)return!0}}return!1}t.$AB=l;function g(p,$,o){if(!o)return new N.$Pu(p,null);const c=[];for(let s=0,i=$.length;s<i;s++)c[s]=$[s];return new N.$Pu(p,c)}t.$BB=g;class E{constructor($){const o=[];let c=0;for(let s=0,i=$.length;s<i;s++)$.charCodeAt(s)===10&&(o[c++]=s);this.a=o}findLineFeedCountBeforeOffset($){const o=this.a;let c=0,s=o.length-1;if(s===-1||$<=o[0])return 0;for(;c<s;){const i=c+((s-c)/2>>0);o[i]>=$?s=i-1:o[i+1]>=$?(c=i,s=i):c=i+1}return c+1}}class m{static findMatches($,o,c,s,i){const u=o.parseSearchRequest();return u?u.regex.multiline?this.b($,c,new A(u.wordSeparators,u.regex),s,i):this.c($,c,u,s,i):[]}static a($,o,c,s,i,u){let w,d=0;s?(d=s.findLineFeedCountBeforeOffset(i),w=o+i+d):w=o+i;let v;if(s){const _=s.findLineFeedCountBeforeOffset(i+u.length)-d;v=w+u.length+_}else v=w+u.length;const R=$.getPositionAt(w),M=$.getPositionAt(v);return new f.$ys(R.lineNumber,R.column,M.lineNumber,M.column)}static b($,o,c,s,i){const u=$.getOffsetAt(o.getStartPosition()),w=$.getValueInRange(o,1),d=$.getEOL()===`\r
`?new E(w):null,v=[];let R=0,M;for(c.reset(0);M=c.next(w);)if(v[R++]=g(this.a($,u,w,d,M.index,M[0]),M,s),R>=i)return v;return v}static c($,o,c,s,i){const u=[];let w=0;if(o.startLineNumber===o.endLineNumber){const v=$.getLineContent(o.startLineNumber).substring(o.startColumn-1,o.endColumn-1);return w=this.d(c,v,o.startLineNumber,o.startColumn-1,w,u,s,i),u}const d=$.getLineContent(o.startLineNumber).substring(o.startColumn-1);w=this.d(c,d,o.startLineNumber,o.startColumn-1,w,u,s,i);for(let v=o.startLineNumber+1;v<o.endLineNumber&&w<i;v++)w=this.d(c,$.getLineContent(v),v,0,w,u,s,i);if(w<i){const v=$.getLineContent(o.endLineNumber).substring(0,o.endColumn-1);w=this.d(c,v,o.endLineNumber,0,w,u,s,i)}return u}static d($,o,c,s,i,u,w,d){const v=$.wordSeparators;if(!w&&$.simpleSearch){const P=$.simpleSearch,_=P.length,F=o.length;let y=-_;for(;(y=o.indexOf(P,y+_))!==-1;)if((!v||L(v,o,F,y,_))&&(u[i++]=new N.$Pu(new f.$ys(c,y+1+s,c,y+1+_+s),null),i>=d))return i;return i}const R=new A($.wordSeparators,$.regex);let M;R.reset(0);do if(M=R.next(o),M&&(u[i++]=g(new f.$ys(c,M.index+1+s,c,M.index+1+M[0].length+s),M,w),i>=d))return i;while(M);return i}static findNextMatch($,o,c,s){const i=o.parseSearchRequest();if(!i)return null;const u=new A(i.wordSeparators,i.regex);return i.regex.multiline?this.e($,c,u,s):this.f($,c,u,s)}static e($,o,c,s){const i=new r.$xs(o.lineNumber,1),u=$.getOffsetAt(i),w=$.getLineCount(),d=$.getValueInRange(new f.$ys(i.lineNumber,i.column,w,$.getLineMaxColumn(w)),1),v=$.getEOL()===`\r
`?new E(d):null;c.reset(o.column-1);const R=c.next(d);return R?g(this.a($,u,d,v,R.index,R[0]),R,s):o.lineNumber!==1||o.column!==1?this.e($,new r.$xs(1,1),c,s):null}static f($,o,c,s){const i=$.getLineCount(),u=o.lineNumber,w=$.getLineContent(u),d=this.g(c,w,u,o.column,s);if(d)return d;for(let v=1;v<=i;v++){const R=(u+v-1)%i,M=$.getLineContent(R+1),P=this.g(c,M,R+1,1,s);if(P)return P}return null}static g($,o,c,s,i){$.reset(s-1);const u=$.next(o);return u?g(new f.$ys(c,u.index+1,c,u.index+1+u[0].length),u,i):null}static findPreviousMatch($,o,c,s){const i=o.parseSearchRequest();if(!i)return null;const u=new A(i.wordSeparators,i.regex);return i.regex.multiline?this.h($,c,u,s):this.j($,c,u,s)}static h($,o,c,s){const i=this.b($,new f.$ys(1,1,o.lineNumber,o.column),c,s,10*h);if(i.length>0)return i[i.length-1];const u=$.getLineCount();return o.lineNumber!==u||o.column!==$.getLineMaxColumn(u)?this.h($,new r.$xs(u,$.getLineMaxColumn(u)),c,s):null}static j($,o,c,s){const i=$.getLineCount(),u=o.lineNumber,w=$.getLineContent(u).substring(0,o.column-1),d=this.k(c,w,u,s);if(d)return d;for(let v=1;v<=i;v++){const R=(i+u-v-1)%i,M=$.getLineContent(R+1),P=this.k(c,M,R+1,s);if(P)return P}return null}static k($,o,c,s){let i=null,u;for($.reset(0);u=$.next(o);)i=g(new f.$ys(c,u.index+1,c,u.index+1+u[0].length),u,s);return i}}t.$CB=m;function b(p,$,o,c,s){if(c===0)return!0;const i=$.charCodeAt(c-1);if(p.get(i)!==0||i===13||i===10)return!0;if(s>0){const u=$.charCodeAt(c);if(p.get(u)!==0)return!0}return!1}function e(p,$,o,c,s){if(c+s===o)return!0;const i=$.charCodeAt(c+s);if(p.get(i)!==0||i===13||i===10)return!0;if(s>0){const u=$.charCodeAt(c+s-1);if(p.get(u)!==0)return!0}return!1}function L(p,$,o,c,s){return b(p,$,o,c,s)&&e(p,$,o,c,s)}t.$DB=L;class A{constructor($,o){this._wordSeparators=$,this.a=o,this.b=-1,this.c=0}reset($){this.a.lastIndex=$,this.b=-1,this.c=0}next($){const o=$.length;let c;do{if(this.b+this.c===o||(c=this.a.exec($),!c))return null;const s=c.index,i=c[0].length;if(s===this.b&&i===this.c){if(i===0){k.$0e($,o,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=s,this.c=i,!this._wordSeparators||L(this._wordSeparators,$,o,s,i))return c}while(c);return null}}t.$EB=A}),ne(ie[60],se([0,1,2,59,7,13,29]),function(O,t,k,D,r,f,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.UnicodeHighlighterReasonKind=t.$eZ=void 0;class h{static computeUnicodeHighlights(e,L,A){const p=A?A.startLineNumber:1,$=A?A.endLineNumber:e.getLineCount(),o=new g(L),c=o.getCandidateCodePoints();let s;c==="allNonBasicAscii"?s=new RegExp("[^\\t\\n\\r\\x20-\\x7E]","g"):s=new RegExp(`${a(Array.from(c))}`,"g");const i=new D.$EB(null,s),u=[];let w=!1,d,v=0,R=0,M=0;e:for(let P=p,_=$;P<=_;P++){const F=e.getLineContent(P),y=F.length;i.reset(0);do if(d=i.next(F),d){let I=d.index,q=d.index+d[0].length;if(I>0){const H=F.charCodeAt(I-1);r.$7e(H)&&I--}if(q+1<y){const H=F.charCodeAt(q-1);r.$7e(H)&&q++}const x=F.substring(I,q);let T=(0,N.$as)(I+1,N.$0r,F,0);T&&T.endColumn<=I+1&&(T=null);const V=o.shouldHighlightNonBasicASCII(x,T?T.word:null);if(V!==0){V===3?v++:V===2?R++:V===1?M++:(0,f.$4c)(V);const H=1e3;if(u.length>=H){w=!0;break e}u.push(new k.$ys(P,I+1,P,q+1))}}while(d)}return{ranges:u,hasMore:w,ambiguousCharacterCount:v,invisibleCharacterCount:R,nonBasicAsciiCharacterCount:M}}static computeUnicodeHighlightReason(e,L){const A=new g(L);switch(A.shouldHighlightNonBasicASCII(e,null)){case 0:return null;case 2:return{kind:1};case 3:{const $=e.codePointAt(0),o=A.ambiguousCharacters.getPrimaryConfusable($),c=r.$xf.getLocales().filter(s=>!r.$xf.getInstance(new Set([...L.allowedLocales,s])).isAmbiguous($));return{kind:0,confusableWith:String.fromCodePoint(o),notAmbiguousInLocales:c}}case 1:return{kind:2}}}}t.$eZ=h;function a(b,e){return`[${r.$Ge(b.map(A=>String.fromCodePoint(A)).join(""))}]`}var l;(function(b){b[b.Ambiguous=0]="Ambiguous",b[b.Invisible=1]="Invisible",b[b.NonBasicAscii=2]="NonBasicAscii"})(l||(t.UnicodeHighlighterReasonKind=l={}));class g{constructor(e){this.b=e,this.a=new Set(e.allowedCodePoints),this.ambiguousCharacters=r.$xf.getInstance(new Set(e.allowedLocales))}getCandidateCodePoints(){if(this.b.nonBasicASCII)return"allNonBasicAscii";const e=new Set;if(this.b.invisibleCharacters)for(const L of r.$yf.codePoints)E(String.fromCodePoint(L))||e.add(L);if(this.b.ambiguousCharacters)for(const L of this.ambiguousCharacters.getConfusableCodePoints())e.add(L);for(const L of this.a)e.delete(L);return e}shouldHighlightNonBasicASCII(e,L){const A=e.codePointAt(0);if(this.a.has(A))return 0;if(this.b.nonBasicASCII)return 1;let p=!1,$=!1;if(L)for(const o of L){const c=o.codePointAt(0),s=r.$ff(o);p=p||s,!s&&!this.ambiguousCharacters.isAmbiguous(c)&&!r.$yf.isInvisibleCharacter(c)&&($=!0)}return!p&&$?0:this.b.invisibleCharacters&&!E(e)&&r.$yf.isInvisibleCharacter(A)?2:this.b.ambiguousCharacters&&this.ambiguousCharacters.isAmbiguous(A)?3:0}}function E(b){return b===" "||b===`
`||b==="	"}var m;(function(b){b[b.None=0]="None",b[b.NonBasicASCII=1]="NonBasicASCII",b[b.Invisible=2]="Invisible",b[b.Ambiguous=3]="Ambiguous"})(m||(m={}))}),ne(ie[61],se([0,1]),function(O,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.WrappingIndent=t.TrackedRangeStickiness=t.TextEditorCursorStyle=t.TextEditorCursorBlinkingStyle=t.SymbolTag=t.SymbolKind=t.SignatureHelpTriggerKind=t.SelectionDirection=t.ScrollbarVisibility=t.ScrollType=t.RenderMinimap=t.RenderLineNumbersType=t.PositionAffinity=t.OverviewRulerLane=t.OverlayWidgetPositionPreference=t.MouseTargetType=t.MinimapPosition=t.MarkerTag=t.MarkerSeverity=t.KeyCode=t.InlineCompletionTriggerKind=t.InlayHintKind=t.InjectedTextCursorStops=t.IndentAction=t.GlyphMarginLane=t.EndOfLineSequence=t.EndOfLinePreference=t.EditorOption=t.EditorAutoIndentStrategy=t.DocumentHighlightKind=t.DefaultEndOfLine=t.CursorChangeReason=t.ContentWidgetPositionPreference=t.CompletionTriggerKind=t.CompletionItemTag=t.CompletionItemKind=t.CompletionItemInsertTextRule=t.CodeActionTriggerType=t.AccessibilitySupport=void 0;var k;(function(n){n[n.Unknown=0]="Unknown",n[n.Disabled=1]="Disabled",n[n.Enabled=2]="Enabled"})(k||(t.AccessibilitySupport=k={}));var D;(function(n){n[n.Invoke=1]="Invoke",n[n.Auto=2]="Auto"})(D||(t.CodeActionTriggerType=D={}));var r;(function(n){n[n.None=0]="None",n[n.KeepWhitespace=1]="KeepWhitespace",n[n.InsertAsSnippet=4]="InsertAsSnippet"})(r||(t.CompletionItemInsertTextRule=r={}));var f;(function(n){n[n.Method=0]="Method",n[n.Function=1]="Function",n[n.Constructor=2]="Constructor",n[n.Field=3]="Field",n[n.Variable=4]="Variable",n[n.Class=5]="Class",n[n.Struct=6]="Struct",n[n.Interface=7]="Interface",n[n.Module=8]="Module",n[n.Property=9]="Property",n[n.Event=10]="Event",n[n.Operator=11]="Operator",n[n.Unit=12]="Unit",n[n.Value=13]="Value",n[n.Constant=14]="Constant",n[n.Enum=15]="Enum",n[n.EnumMember=16]="EnumMember",n[n.Keyword=17]="Keyword",n[n.Text=18]="Text",n[n.Color=19]="Color",n[n.File=20]="File",n[n.Reference=21]="Reference",n[n.Customcolor=22]="Customcolor",n[n.Folder=23]="Folder",n[n.TypeParameter=24]="TypeParameter",n[n.User=25]="User",n[n.Issue=26]="Issue",n[n.Snippet=27]="Snippet"})(f||(t.CompletionItemKind=f={}));var N;(function(n){n[n.Deprecated=1]="Deprecated"})(N||(t.CompletionItemTag=N={}));var h;(function(n){n[n.Invoke=0]="Invoke",n[n.TriggerCharacter=1]="TriggerCharacter",n[n.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(h||(t.CompletionTriggerKind=h={}));var a;(function(n){n[n.EXACT=0]="EXACT",n[n.ABOVE=1]="ABOVE",n[n.BELOW=2]="BELOW"})(a||(t.ContentWidgetPositionPreference=a={}));var l;(function(n){n[n.NotSet=0]="NotSet",n[n.ContentFlush=1]="ContentFlush",n[n.RecoverFromMarkers=2]="RecoverFromMarkers",n[n.Explicit=3]="Explicit",n[n.Paste=4]="Paste",n[n.Undo=5]="Undo",n[n.Redo=6]="Redo"})(l||(t.CursorChangeReason=l={}));var g;(function(n){n[n.LF=1]="LF",n[n.CRLF=2]="CRLF"})(g||(t.DefaultEndOfLine=g={}));var E;(function(n){n[n.Text=0]="Text",n[n.Read=1]="Read",n[n.Write=2]="Write"})(E||(t.DocumentHighlightKind=E={}));var m;(function(n){n[n.None=0]="None",n[n.Keep=1]="Keep",n[n.Brackets=2]="Brackets",n[n.Advanced=3]="Advanced",n[n.Full=4]="Full"})(m||(t.EditorAutoIndentStrategy=m={}));var b;(function(n){n[n.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",n[n.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",n[n.accessibilitySupport=2]="accessibilitySupport",n[n.accessibilityPageSize=3]="accessibilityPageSize",n[n.ariaLabel=4]="ariaLabel",n[n.ariaRequired=5]="ariaRequired",n[n.autoClosingBrackets=6]="autoClosingBrackets",n[n.autoClosingComments=7]="autoClosingComments",n[n.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",n[n.autoClosingDelete=9]="autoClosingDelete",n[n.autoClosingOvertype=10]="autoClosingOvertype",n[n.autoClosingQuotes=11]="autoClosingQuotes",n[n.autoIndent=12]="autoIndent",n[n.automaticLayout=13]="automaticLayout",n[n.autoSurround=14]="autoSurround",n[n.bracketPairColorization=15]="bracketPairColorization",n[n.guides=16]="guides",n[n.codeLens=17]="codeLens",n[n.codeLensFontFamily=18]="codeLensFontFamily",n[n.codeLensFontSize=19]="codeLensFontSize",n[n.colorDecorators=20]="colorDecorators",n[n.colorDecoratorsLimit=21]="colorDecoratorsLimit",n[n.columnSelection=22]="columnSelection",n[n.comments=23]="comments",n[n.contextmenu=24]="contextmenu",n[n.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",n[n.cursorBlinking=26]="cursorBlinking",n[n.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",n[n.cursorStyle=28]="cursorStyle",n[n.cursorSurroundingLines=29]="cursorSurroundingLines",n[n.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",n[n.cursorWidth=31]="cursorWidth",n[n.disableLayerHinting=32]="disableLayerHinting",n[n.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",n[n.domReadOnly=34]="domReadOnly",n[n.dragAndDrop=35]="dragAndDrop",n[n.dropIntoEditor=36]="dropIntoEditor",n[n.emptySelectionClipboard=37]="emptySelectionClipboard",n[n.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",n[n.extraEditorClassName=39]="extraEditorClassName",n[n.fastScrollSensitivity=40]="fastScrollSensitivity",n[n.find=41]="find",n[n.fixedOverflowWidgets=42]="fixedOverflowWidgets",n[n.folding=43]="folding",n[n.foldingStrategy=44]="foldingStrategy",n[n.foldingHighlight=45]="foldingHighlight",n[n.foldingImportsByDefault=46]="foldingImportsByDefault",n[n.foldingMaximumRegions=47]="foldingMaximumRegions",n[n.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",n[n.fontFamily=49]="fontFamily",n[n.fontInfo=50]="fontInfo",n[n.fontLigatures=51]="fontLigatures",n[n.fontSize=52]="fontSize",n[n.fontWeight=53]="fontWeight",n[n.fontVariations=54]="fontVariations",n[n.formatOnPaste=55]="formatOnPaste",n[n.formatOnType=56]="formatOnType",n[n.glyphMargin=57]="glyphMargin",n[n.gotoLocation=58]="gotoLocation",n[n.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",n[n.hover=60]="hover",n[n.inDiffEditor=61]="inDiffEditor",n[n.inlineSuggest=62]="inlineSuggest",n[n.letterSpacing=63]="letterSpacing",n[n.lightbulb=64]="lightbulb",n[n.lineDecorationsWidth=65]="lineDecorationsWidth",n[n.lineHeight=66]="lineHeight",n[n.lineNumbers=67]="lineNumbers",n[n.lineNumbersMinChars=68]="lineNumbersMinChars",n[n.linkedEditing=69]="linkedEditing",n[n.links=70]="links",n[n.matchBrackets=71]="matchBrackets",n[n.minimap=72]="minimap",n[n.mouseStyle=73]="mouseStyle",n[n.mouseWheelScrollSensitivity=74]="mouseWheelScrollSensitivity",n[n.mouseWheelZoom=75]="mouseWheelZoom",n[n.multiCursorMergeOverlapping=76]="multiCursorMergeOverlapping",n[n.multiCursorModifier=77]="multiCursorModifier",n[n.multiCursorPaste=78]="multiCursorPaste",n[n.multiCursorLimit=79]="multiCursorLimit",n[n.multiDocumentOccurrencesHighlight=80]="multiDocumentOccurrencesHighlight",n[n.occurrencesHighlight=81]="occurrencesHighlight",n[n.overviewRulerBorder=82]="overviewRulerBorder",n[n.overviewRulerLanes=83]="overviewRulerLanes",n[n.padding=84]="padding",n[n.pasteAs=85]="pasteAs",n[n.parameterHints=86]="parameterHints",n[n.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",n[n.definitionLinkOpensInPeek=88]="definitionLinkOpensInPeek",n[n.quickSuggestions=89]="quickSuggestions",n[n.quickSuggestionsDelay=90]="quickSuggestionsDelay",n[n.readOnly=91]="readOnly",n[n.readOnlyMessage=92]="readOnlyMessage",n[n.renameOnType=93]="renameOnType",n[n.renderControlCharacters=94]="renderControlCharacters",n[n.renderFinalNewline=95]="renderFinalNewline",n[n.renderLineHighlight=96]="renderLineHighlight",n[n.renderLineHighlightOnlyWhenFocus=97]="renderLineHighlightOnlyWhenFocus",n[n.renderValidationDecorations=98]="renderValidationDecorations",n[n.renderWhitespace=99]="renderWhitespace",n[n.revealHorizontalRightPadding=100]="revealHorizontalRightPadding",n[n.roundedSelection=101]="roundedSelection",n[n.rulers=102]="rulers",n[n.scrollbar=103]="scrollbar",n[n.scrollBeyondLastColumn=104]="scrollBeyondLastColumn",n[n.scrollBeyondLastLine=105]="scrollBeyondLastLine",n[n.scrollPredominantAxis=106]="scrollPredominantAxis",n[n.selectionClipboard=107]="selectionClipboard",n[n.selectionHighlight=108]="selectionHighlight",n[n.selectOnLineNumbers=109]="selectOnLineNumbers",n[n.showFoldingControls=110]="showFoldingControls",n[n.showUnused=111]="showUnused",n[n.snippetSuggestions=112]="snippetSuggestions",n[n.smartSelect=113]="smartSelect",n[n.smoothScrolling=114]="smoothScrolling",n[n.stickyScroll=115]="stickyScroll",n[n.stickyTabStops=116]="stickyTabStops",n[n.stopRenderingLineAfter=117]="stopRenderingLineAfter",n[n.suggest=118]="suggest",n[n.suggestFontSize=119]="suggestFontSize",n[n.suggestLineHeight=120]="suggestLineHeight",n[n.suggestOnTriggerCharacters=121]="suggestOnTriggerCharacters",n[n.suggestSelection=122]="suggestSelection",n[n.tabCompletion=123]="tabCompletion",n[n.tabIndex=124]="tabIndex",n[n.unicodeHighlighting=125]="unicodeHighlighting",n[n.unusualLineTerminators=126]="unusualLineTerminators",n[n.useShadowDOM=127]="useShadowDOM",n[n.useTabStops=128]="useTabStops",n[n.wordBreak=129]="wordBreak",n[n.wordSeparators=130]="wordSeparators",n[n.wordWrap=131]="wordWrap",n[n.wordWrapBreakAfterCharacters=132]="wordWrapBreakAfterCharacters",n[n.wordWrapBreakBeforeCharacters=133]="wordWrapBreakBeforeCharacters",n[n.wordWrapColumn=134]="wordWrapColumn",n[n.wordWrapOverride1=135]="wordWrapOverride1",n[n.wordWrapOverride2=136]="wordWrapOverride2",n[n.wrappingIndent=137]="wrappingIndent",n[n.wrappingStrategy=138]="wrappingStrategy",n[n.showDeprecated=139]="showDeprecated",n[n.inlayHints=140]="inlayHints",n[n.editorClassName=141]="editorClassName",n[n.pixelRatio=142]="pixelRatio",n[n.tabFocusMode=143]="tabFocusMode",n[n.layoutInfo=144]="layoutInfo",n[n.wrappingInfo=145]="wrappingInfo",n[n.defaultColorDecorators=146]="defaultColorDecorators",n[n.colorDecoratorsActivatedOn=147]="colorDecoratorsActivatedOn",n[n.inlineCompletionsAccessibilityVerbose=148]="inlineCompletionsAccessibilityVerbose"})(b||(t.EditorOption=b={}));var e;(function(n){n[n.TextDefined=0]="TextDefined",n[n.LF=1]="LF",n[n.CRLF=2]="CRLF"})(e||(t.EndOfLinePreference=e={}));var L;(function(n){n[n.LF=0]="LF",n[n.CRLF=1]="CRLF"})(L||(t.EndOfLineSequence=L={}));var A;(function(n){n[n.Left=1]="Left",n[n.Right=2]="Right"})(A||(t.GlyphMarginLane=A={}));var p;(function(n){n[n.None=0]="None",n[n.Indent=1]="Indent",n[n.IndentOutdent=2]="IndentOutdent",n[n.Outdent=3]="Outdent"})(p||(t.IndentAction=p={}));var $;(function(n){n[n.Both=0]="Both",n[n.Right=1]="Right",n[n.Left=2]="Left",n[n.None=3]="None"})($||(t.InjectedTextCursorStops=$={}));var o;(function(n){n[n.Type=1]="Type",n[n.Parameter=2]="Parameter"})(o||(t.InlayHintKind=o={}));var c;(function(n){n[n.Automatic=0]="Automatic",n[n.Explicit=1]="Explicit"})(c||(t.InlineCompletionTriggerKind=c={}));var s;(function(n){n[n.DependsOnKbLayout=-1]="DependsOnKbLayout",n[n.Unknown=0]="Unknown",n[n.Backspace=1]="Backspace",n[n.Tab=2]="Tab",n[n.Enter=3]="Enter",n[n.Shift=4]="Shift",n[n.Ctrl=5]="Ctrl",n[n.Alt=6]="Alt",n[n.PauseBreak=7]="PauseBreak",n[n.CapsLock=8]="CapsLock",n[n.Escape=9]="Escape",n[n.Space=10]="Space",n[n.PageUp=11]="PageUp",n[n.PageDown=12]="PageDown",n[n.End=13]="End",n[n.Home=14]="Home",n[n.LeftArrow=15]="LeftArrow",n[n.UpArrow=16]="UpArrow",n[n.RightArrow=17]="RightArrow",n[n.DownArrow=18]="DownArrow",n[n.Insert=19]="Insert",n[n.Delete=20]="Delete",n[n.Digit0=21]="Digit0",n[n.Digit1=22]="Digit1",n[n.Digit2=23]="Digit2",n[n.Digit3=24]="Digit3",n[n.Digit4=25]="Digit4",n[n.Digit5=26]="Digit5",n[n.Digit6=27]="Digit6",n[n.Digit7=28]="Digit7",n[n.Digit8=29]="Digit8",n[n.Digit9=30]="Digit9",n[n.KeyA=31]="KeyA",n[n.KeyB=32]="KeyB",n[n.KeyC=33]="KeyC",n[n.KeyD=34]="KeyD",n[n.KeyE=35]="KeyE",n[n.KeyF=36]="KeyF",n[n.KeyG=37]="KeyG",n[n.KeyH=38]="KeyH",n[n.KeyI=39]="KeyI",n[n.KeyJ=40]="KeyJ",n[n.KeyK=41]="KeyK",n[n.KeyL=42]="KeyL",n[n.KeyM=43]="KeyM",n[n.KeyN=44]="KeyN",n[n.KeyO=45]="KeyO",n[n.KeyP=46]="KeyP",n[n.KeyQ=47]="KeyQ",n[n.KeyR=48]="KeyR",n[n.KeyS=49]="KeyS",n[n.KeyT=50]="KeyT",n[n.KeyU=51]="KeyU",n[n.KeyV=52]="KeyV",n[n.KeyW=53]="KeyW",n[n.KeyX=54]="KeyX",n[n.KeyY=55]="KeyY",n[n.KeyZ=56]="KeyZ",n[n.Meta=57]="Meta",n[n.ContextMenu=58]="ContextMenu",n[n.F1=59]="F1",n[n.F2=60]="F2",n[n.F3=61]="F3",n[n.F4=62]="F4",n[n.F5=63]="F5",n[n.F6=64]="F6",n[n.F7=65]="F7",n[n.F8=66]="F8",n[n.F9=67]="F9",n[n.F10=68]="F10",n[n.F11=69]="F11",n[n.F12=70]="F12",n[n.F13=71]="F13",n[n.F14=72]="F14",n[n.F15=73]="F15",n[n.F16=74]="F16",n[n.F17=75]="F17",n[n.F18=76]="F18",n[n.F19=77]="F19",n[n.F20=78]="F20",n[n.F21=79]="F21",n[n.F22=80]="F22",n[n.F23=81]="F23",n[n.F24=82]="F24",n[n.NumLock=83]="NumLock",n[n.ScrollLock=84]="ScrollLock",n[n.Semicolon=85]="Semicolon",n[n.Equal=86]="Equal",n[n.Comma=87]="Comma",n[n.Minus=88]="Minus",n[n.Period=89]="Period",n[n.Slash=90]="Slash",n[n.Backquote=91]="Backquote",n[n.BracketLeft=92]="BracketLeft",n[n.Backslash=93]="Backslash",n[n.BracketRight=94]="BracketRight",n[n.Quote=95]="Quote",n[n.OEM_8=96]="OEM_8",n[n.IntlBackslash=97]="IntlBackslash",n[n.Numpad0=98]="Numpad0",n[n.Numpad1=99]="Numpad1",n[n.Numpad2=100]="Numpad2",n[n.Numpad3=101]="Numpad3",n[n.Numpad4=102]="Numpad4",n[n.Numpad5=103]="Numpad5",n[n.Numpad6=104]="Numpad6",n[n.Numpad7=105]="Numpad7",n[n.Numpad8=106]="Numpad8",n[n.Numpad9=107]="Numpad9",n[n.NumpadMultiply=108]="NumpadMultiply",n[n.NumpadAdd=109]="NumpadAdd",n[n.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",n[n.NumpadSubtract=111]="NumpadSubtract",n[n.NumpadDecimal=112]="NumpadDecimal",n[n.NumpadDivide=113]="NumpadDivide",n[n.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",n[n.ABNT_C1=115]="ABNT_C1",n[n.ABNT_C2=116]="ABNT_C2",n[n.AudioVolumeMute=117]="AudioVolumeMute",n[n.AudioVolumeUp=118]="AudioVolumeUp",n[n.AudioVolumeDown=119]="AudioVolumeDown",n[n.BrowserSearch=120]="BrowserSearch",n[n.BrowserHome=121]="BrowserHome",n[n.BrowserBack=122]="BrowserBack",n[n.BrowserForward=123]="BrowserForward",n[n.MediaTrackNext=124]="MediaTrackNext",n[n.MediaTrackPrevious=125]="MediaTrackPrevious",n[n.MediaStop=126]="MediaStop",n[n.MediaPlayPause=127]="MediaPlayPause",n[n.LaunchMediaPlayer=128]="LaunchMediaPlayer",n[n.LaunchMail=129]="LaunchMail",n[n.LaunchApp2=130]="LaunchApp2",n[n.Clear=131]="Clear",n[n.MAX_VALUE=132]="MAX_VALUE"})(s||(t.KeyCode=s={}));var i;(function(n){n[n.Hint=1]="Hint",n[n.Info=2]="Info",n[n.Warning=4]="Warning",n[n.Error=8]="Error"})(i||(t.MarkerSeverity=i={}));var u;(function(n){n[n.Unnecessary=1]="Unnecessary",n[n.Deprecated=2]="Deprecated"})(u||(t.MarkerTag=u={}));var w;(function(n){n[n.Inline=1]="Inline",n[n.Gutter=2]="Gutter"})(w||(t.MinimapPosition=w={}));var d;(function(n){n[n.UNKNOWN=0]="UNKNOWN",n[n.TEXTAREA=1]="TEXTAREA",n[n.GUTTER_GLYPH_MARGIN=2]="GUTTER_GLYPH_MARGIN",n[n.GUTTER_LINE_NUMBERS=3]="GUTTER_LINE_NUMBERS",n[n.GUTTER_LINE_DECORATIONS=4]="GUTTER_LINE_DECORATIONS",n[n.GUTTER_VIEW_ZONE=5]="GUTTER_VIEW_ZONE",n[n.CONTENT_TEXT=6]="CONTENT_TEXT",n[n.CONTENT_EMPTY=7]="CONTENT_EMPTY",n[n.CONTENT_VIEW_ZONE=8]="CONTENT_VIEW_ZONE",n[n.CONTENT_WIDGET=9]="CONTENT_WIDGET",n[n.OVERVIEW_RULER=10]="OVERVIEW_RULER",n[n.SCROLLBAR=11]="SCROLLBAR",n[n.OVERLAY_WIDGET=12]="OVERLAY_WIDGET",n[n.OUTSIDE_EDITOR=13]="OUTSIDE_EDITOR"})(d||(t.MouseTargetType=d={}));var v;(function(n){n[n.TOP_RIGHT_CORNER=0]="TOP_RIGHT_CORNER",n[n.BOTTOM_RIGHT_CORNER=1]="BOTTOM_RIGHT_CORNER",n[n.TOP_CENTER=2]="TOP_CENTER"})(v||(t.OverlayWidgetPositionPreference=v={}));var R;(function(n){n[n.Left=1]="Left",n[n.Center=2]="Center",n[n.Right=4]="Right",n[n.Full=7]="Full"})(R||(t.OverviewRulerLane=R={}));var M;(function(n){n[n.Left=0]="Left",n[n.Right=1]="Right",n[n.None=2]="None",n[n.LeftOfInjectedText=3]="LeftOfInjectedText",n[n.RightOfInjectedText=4]="RightOfInjectedText"})(M||(t.PositionAffinity=M={}));var P;(function(n){n[n.Off=0]="Off",n[n.On=1]="On",n[n.Relative=2]="Relative",n[n.Interval=3]="Interval",n[n.Custom=4]="Custom"})(P||(t.RenderLineNumbersType=P={}));var _;(function(n){n[n.None=0]="None",n[n.Text=1]="Text",n[n.Blocks=2]="Blocks"})(_||(t.RenderMinimap=_={}));var F;(function(n){n[n.Smooth=0]="Smooth",n[n.Immediate=1]="Immediate"})(F||(t.ScrollType=F={}));var y;(function(n){n[n.Auto=1]="Auto",n[n.Hidden=2]="Hidden",n[n.Visible=3]="Visible"})(y||(t.ScrollbarVisibility=y={}));var I;(function(n){n[n.LTR=0]="LTR",n[n.RTL=1]="RTL"})(I||(t.SelectionDirection=I={}));var q;(function(n){n[n.Invoke=1]="Invoke",n[n.TriggerCharacter=2]="TriggerCharacter",n[n.ContentChange=3]="ContentChange"})(q||(t.SignatureHelpTriggerKind=q={}));var x;(function(n){n[n.File=0]="File",n[n.Module=1]="Module",n[n.Namespace=2]="Namespace",n[n.Package=3]="Package",n[n.Class=4]="Class",n[n.Method=5]="Method",n[n.Property=6]="Property",n[n.Field=7]="Field",n[n.Constructor=8]="Constructor",n[n.Enum=9]="Enum",n[n.Interface=10]="Interface",n[n.Function=11]="Function",n[n.Variable=12]="Variable",n[n.Constant=13]="Constant",n[n.String=14]="String",n[n.Number=15]="Number",n[n.Boolean=16]="Boolean",n[n.Array=17]="Array",n[n.Object=18]="Object",n[n.Key=19]="Key",n[n.Null=20]="Null",n[n.EnumMember=21]="EnumMember",n[n.Struct=22]="Struct",n[n.Event=23]="Event",n[n.Operator=24]="Operator",n[n.TypeParameter=25]="TypeParameter"})(x||(t.SymbolKind=x={}));var T;(function(n){n[n.Deprecated=1]="Deprecated"})(T||(t.SymbolTag=T={}));var V;(function(n){n[n.Hidden=0]="Hidden",n[n.Blink=1]="Blink",n[n.Smooth=2]="Smooth",n[n.Phase=3]="Phase",n[n.Expand=4]="Expand",n[n.Solid=5]="Solid"})(V||(t.TextEditorCursorBlinkingStyle=V={}));var H;(function(n){n[n.Line=1]="Line",n[n.Block=2]="Block",n[n.Underline=3]="Underline",n[n.LineThin=4]="LineThin",n[n.BlockOutline=5]="BlockOutline",n[n.UnderlineThin=6]="UnderlineThin"})(H||(t.TextEditorCursorStyle=H={}));var W;(function(n){n[n.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",n[n.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",n[n.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",n[n.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(W||(t.TrackedRangeStickiness=W={}));var J;(function(n){n[n.None=0]="None",n[n.Same=1]="Same",n[n.Indent=2]="Indent",n[n.DeepIndent=3]="DeepIndent"})(J||(t.WrappingIndent=J={}))}),ne(ie[62],se([0,1,11,10]),function(O,t,k,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$0s=void 0;class r{constructor(){this.a=new Map,this.b=new Map,this.c=new k.$Od,this.onDidChange=this.c.event,this.d=null}handleChange(h){this.c.fire({changedLanguages:h,changedColorMap:!1})}register(h,a){return this.a.set(h,a),this.handleChange([h]),(0,D.$Qc)(()=>{this.a.get(h)===a&&(this.a.delete(h),this.handleChange([h]))})}get(h){return this.a.get(h)||null}registerFactory(h,a){this.b.get(h)?.dispose();const l=new f(this,h,a);return this.b.set(h,l),(0,D.$Qc)(()=>{const g=this.b.get(h);!g||g!==l||(this.b.delete(h),g.dispose())})}async getOrCreate(h){const a=this.get(h);if(a)return a;const l=this.b.get(h);return!l||l.isResolved?null:(await l.resolve(),this.get(h))}isResolved(h){if(this.get(h))return!0;const l=this.b.get(h);return!!(!l||l.isResolved)}setColorMap(h){this.d=h,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}t.$0s=r;class f extends D.$Sc{get isResolved(){return this.c}constructor(h,a,l){super(),this.f=h,this.g=a,this.h=l,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.j()),this.b}async j(){const h=await this.h.tokenizationSupport;this.c=!0,h&&!this.a&&this.B(this.f.register(this.g,h))}}}),ne(ie[63],se([68,69]),function(O,t){return O.create("vs/editor/common/languages",t)}),ne(ie[64],se([0,1,43,16,44,2,62,63]),function(O,t,k,D,r,f,N,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExternalUriOpenerPriority=t.$pt=t.$ot=t.InlayHintKind=t.CommentState=t.CommentMode=t.CommentThreadState=t.CommentThreadCollapsibleState=t.Command=t.$nt=t.$mt=t.SymbolKinds=t.SymbolTag=t.$lt=t.$kt=t.SymbolKind=t.$jt=t.DocumentHighlightKind=t.SignatureHelpTriggerKind=t.CodeActionTriggerType=t.$it=t.InlineCompletionTriggerKind=t.CompletionTriggerKind=t.CompletionItemInsertTextRule=t.CompletionItemTag=t.CompletionItemKinds=t.CompletionItemKind=t.$ht=t.$gt=t.$ft=void 0;class a{constructor(V,H,W){this.offset=V,this.type=H,this.language=W,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}t.$ft=a;class l{constructor(V,H){this.tokens=V,this.endState=H,this._tokenizationResultBrand=void 0}}t.$gt=l;class g{constructor(V,H){this.tokens=V,this.endState=H,this._encodedTokenizationResultBrand=void 0}}t.$ht=g;var E;(function(T){T[T.Method=0]="Method",T[T.Function=1]="Function",T[T.Constructor=2]="Constructor",T[T.Field=3]="Field",T[T.Variable=4]="Variable",T[T.Class=5]="Class",T[T.Struct=6]="Struct",T[T.Interface=7]="Interface",T[T.Module=8]="Module",T[T.Property=9]="Property",T[T.Event=10]="Event",T[T.Operator=11]="Operator",T[T.Unit=12]="Unit",T[T.Value=13]="Value",T[T.Constant=14]="Constant",T[T.Enum=15]="Enum",T[T.EnumMember=16]="EnumMember",T[T.Keyword=17]="Keyword",T[T.Text=18]="Text",T[T.Color=19]="Color",T[T.File=20]="File",T[T.Reference=21]="Reference",T[T.Customcolor=22]="Customcolor",T[T.Folder=23]="Folder",T[T.TypeParameter=24]="TypeParameter",T[T.User=25]="User",T[T.Issue=26]="Issue",T[T.Snippet=27]="Snippet"})(E||(t.CompletionItemKind=E={}));var m;(function(T){const V=new Map;V.set(0,k.$Vj.symbolMethod),V.set(1,k.$Vj.symbolFunction),V.set(2,k.$Vj.symbolConstructor),V.set(3,k.$Vj.symbolField),V.set(4,k.$Vj.symbolVariable),V.set(5,k.$Vj.symbolClass),V.set(6,k.$Vj.symbolStruct),V.set(7,k.$Vj.symbolInterface),V.set(8,k.$Vj.symbolModule),V.set(9,k.$Vj.symbolProperty),V.set(10,k.$Vj.symbolEvent),V.set(11,k.$Vj.symbolOperator),V.set(12,k.$Vj.symbolUnit),V.set(13,k.$Vj.symbolValue),V.set(15,k.$Vj.symbolEnum),V.set(14,k.$Vj.symbolConstant),V.set(15,k.$Vj.symbolEnum),V.set(16,k.$Vj.symbolEnumMember),V.set(17,k.$Vj.symbolKeyword),V.set(27,k.$Vj.symbolSnippet),V.set(18,k.$Vj.symbolText),V.set(19,k.$Vj.symbolColor),V.set(20,k.$Vj.symbolFile),V.set(21,k.$Vj.symbolReference),V.set(22,k.$Vj.symbolCustomColor),V.set(23,k.$Vj.symbolFolder),V.set(24,k.$Vj.symbolTypeParameter),V.set(25,k.$Vj.account),V.set(26,k.$Vj.issues);function H(n){let te=V.get(n);return te||(console.info("No codicon found for CompletionItemKind "+n),te=k.$Vj.symbolProperty),te}T.toIcon=H;const W=new Map;W.set("method",0),W.set("function",1),W.set("constructor",2),W.set("field",3),W.set("variable",4),W.set("class",5),W.set("struct",6),W.set("interface",7),W.set("module",8),W.set("property",9),W.set("event",10),W.set("operator",11),W.set("unit",12),W.set("value",13),W.set("constant",14),W.set("enum",15),W.set("enum-member",16),W.set("enumMember",16),W.set("keyword",17),W.set("snippet",27),W.set("text",18),W.set("color",19),W.set("file",20),W.set("reference",21),W.set("customcolor",22),W.set("folder",23),W.set("type-parameter",24),W.set("typeParameter",24),W.set("account",25),W.set("issue",26);function J(n,te){let ce=W.get(n);return typeof ce>"u"&&!te&&(ce=9),ce}T.fromString=J})(m||(t.CompletionItemKinds=m={}));var b;(function(T){T[T.Deprecated=1]="Deprecated"})(b||(t.CompletionItemTag=b={}));var e;(function(T){T[T.None=0]="None",T[T.KeepWhitespace=1]="KeepWhitespace",T[T.InsertAsSnippet=4]="InsertAsSnippet"})(e||(t.CompletionItemInsertTextRule=e={}));var L;(function(T){T[T.Invoke=0]="Invoke",T[T.TriggerCharacter=1]="TriggerCharacter",T[T.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(L||(t.CompletionTriggerKind=L={}));var A;(function(T){T[T.Automatic=0]="Automatic",T[T.Explicit=1]="Explicit"})(A||(t.InlineCompletionTriggerKind=A={}));class p{constructor(V,H,W,J){this.range=V,this.text=H,this.completionKind=W,this.isSnippetText=J}equals(V){return f.$ys.lift(this.range).equalsRange(V.range)&&this.text===V.text&&this.completionKind===V.completionKind&&this.isSnippetText===V.isSnippetText}}t.$it=p;var $;(function(T){T[T.Invoke=1]="Invoke",T[T.Auto=2]="Auto"})($||(t.CodeActionTriggerType=$={}));var o;(function(T){T[T.Invoke=1]="Invoke",T[T.TriggerCharacter=2]="TriggerCharacter",T[T.ContentChange=3]="ContentChange"})(o||(t.SignatureHelpTriggerKind=o={}));var c;(function(T){T[T.Text=0]="Text",T[T.Read=1]="Read",T[T.Write=2]="Write"})(c||(t.DocumentHighlightKind=c={}));function s(T){return T&&D.URI.isUri(T.uri)&&f.$ys.isIRange(T.range)&&(f.$ys.isIRange(T.originSelectionRange)||f.$ys.isIRange(T.targetSelectionRange))}t.$jt=s;var i;(function(T){T[T.File=0]="File",T[T.Module=1]="Module",T[T.Namespace=2]="Namespace",T[T.Package=3]="Package",T[T.Class=4]="Class",T[T.Method=5]="Method",T[T.Property=6]="Property",T[T.Field=7]="Field",T[T.Constructor=8]="Constructor",T[T.Enum=9]="Enum",T[T.Interface=10]="Interface",T[T.Function=11]="Function",T[T.Variable=12]="Variable",T[T.Constant=13]="Constant",T[T.String=14]="String",T[T.Number=15]="Number",T[T.Boolean=16]="Boolean",T[T.Array=17]="Array",T[T.Object=18]="Object",T[T.Key=19]="Key",T[T.Null=20]="Null",T[T.EnumMember=21]="EnumMember",T[T.Struct=22]="Struct",T[T.Event=23]="Event",T[T.Operator=24]="Operator",T[T.TypeParameter=25]="TypeParameter"})(i||(t.SymbolKind=i={})),t.$kt={[17]:(0,h.localize)(0,null),[16]:(0,h.localize)(1,null),[4]:(0,h.localize)(2,null),[13]:(0,h.localize)(3,null),[8]:(0,h.localize)(4,null),[9]:(0,h.localize)(5,null),[21]:(0,h.localize)(6,null),[23]:(0,h.localize)(7,null),[7]:(0,h.localize)(8,null),[0]:(0,h.localize)(9,null),[11]:(0,h.localize)(10,null),[10]:(0,h.localize)(11,null),[19]:(0,h.localize)(12,null),[5]:(0,h.localize)(13,null),[1]:(0,h.localize)(14,null),[2]:(0,h.localize)(15,null),[20]:(0,h.localize)(16,null),[15]:(0,h.localize)(17,null),[18]:(0,h.localize)(18,null),[24]:(0,h.localize)(19,null),[3]:(0,h.localize)(20,null),[6]:(0,h.localize)(21,null),[14]:(0,h.localize)(22,null),[22]:(0,h.localize)(23,null),[25]:(0,h.localize)(24,null),[12]:(0,h.localize)(25,null)};function u(T,V){return(0,h.localize)(26,null,T,t.$kt[V])}t.$lt=u;var w;(function(T){T[T.Deprecated=1]="Deprecated"})(w||(t.SymbolTag=w={}));var d;(function(T){const V=new Map;V.set(0,k.$Vj.symbolFile),V.set(1,k.$Vj.symbolModule),V.set(2,k.$Vj.symbolNamespace),V.set(3,k.$Vj.symbolPackage),V.set(4,k.$Vj.symbolClass),V.set(5,k.$Vj.symbolMethod),V.set(6,k.$Vj.symbolProperty),V.set(7,k.$Vj.symbolField),V.set(8,k.$Vj.symbolConstructor),V.set(9,k.$Vj.symbolEnum),V.set(10,k.$Vj.symbolInterface),V.set(11,k.$Vj.symbolFunction),V.set(12,k.$Vj.symbolVariable),V.set(13,k.$Vj.symbolConstant),V.set(14,k.$Vj.symbolString),V.set(15,k.$Vj.symbolNumber),V.set(16,k.$Vj.symbolBoolean),V.set(17,k.$Vj.symbolArray),V.set(18,k.$Vj.symbolObject),V.set(19,k.$Vj.symbolKey),V.set(20,k.$Vj.symbolNull),V.set(21,k.$Vj.symbolEnumMember),V.set(22,k.$Vj.symbolStruct),V.set(23,k.$Vj.symbolEvent),V.set(24,k.$Vj.symbolOperator),V.set(25,k.$Vj.symbolTypeParameter);function H(W){let J=V.get(W);return J||(console.info("No codicon found for SymbolKind "+W),J=k.$Vj.symbolProperty),J}T.toIcon=H})(d||(t.SymbolKinds=d={}));class v{static asEditOperation(V){return r.$zs.replace(f.$ys.lift(V.range),V.text)}}t.$mt=v;class R{static fromValue(V){switch(V){case"comment":return R.Comment;case"imports":return R.Imports;case"region":return R.Region}return new R(V)}constructor(V){this.value=V}}t.$nt=R,R.Comment=new R("comment"),R.Imports=new R("imports"),R.Region=new R("region");var M;(function(T){function V(H){return!H||typeof H!="object"?!1:typeof H.id=="string"&&typeof H.title=="string"}T.is=V})(M||(t.Command=M={}));var P;(function(T){T[T.Collapsed=0]="Collapsed",T[T.Expanded=1]="Expanded"})(P||(t.CommentThreadCollapsibleState=P={}));var _;(function(T){T[T.Unresolved=0]="Unresolved",T[T.Resolved=1]="Resolved"})(_||(t.CommentThreadState=_={}));var F;(function(T){T[T.Editing=0]="Editing",T[T.Preview=1]="Preview"})(F||(t.CommentMode=F={}));var y;(function(T){T[T.Published=0]="Published",T[T.Draft=1]="Draft"})(y||(t.CommentState=y={}));var I;(function(T){T[T.Type=1]="Type",T[T.Parameter=2]="Parameter"})(I||(t.InlayHintKind=I={}));class q{constructor(V){this.b=V,this.a=null}dispose(){this.a&&this.a.then(V=>{V&&V.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}t.$ot=q,t.$pt=new N.$0s;var x;(function(T){T[T.None=0]="None",T[T.Option=1]="Option",T[T.Default=2]="Default",T[T.Preferred=3]="Preferred"})(x||(t.ExternalUriOpenerPriority=x={}))}),ne(ie[65],se([0,1,24,11,37,16,5,2,45,64,61]),function(O,t,k,D,r,f,N,h,a,l,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$kZ=t.$jZ=void 0;class E{static chord(e,L){return(0,r.$Kq)(e,L)}}t.$jZ=E,E.CtrlCmd=2048,E.Shift=1024,E.Alt=512,E.WinCtrl=256;function m(){return{editor:void 0,languages:void 0,CancellationTokenSource:k.$Yd,Emitter:D.$Od,KeyCode:g.KeyCode,KeyMod:E,Position:N.$xs,Range:h.$ys,Selection:a.$As,SelectionDirection:g.SelectionDirection,MarkerSeverity:g.MarkerSeverity,MarkerTag:g.MarkerTag,Uri:f.URI,Token:l.$ft}}t.$kZ=m}),ne(ie[70],se([0,1,25,16,5,2,58,29,54,55,65,23,60,33,52,15,3,53]),function(O,t,k,D,r,f,N,h,a,l,g,E,m,b,e,L,A,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.create=t.EditorSimpleWorker=void 0;class $ extends N.$1u{get uri(){return this.d}get eol(){return this.g}getValue(){return this.getText()}findMatches(i){const u=[];for(let w=0;w<this.f.length;w++){const d=this.f[w],v=this.offsetAt(new r.$xs(w+1,1)),R=d.matchAll(i);for(const M of R)(M.index||M.index===0)&&(M.index=M.index+v),u.push(M)}return u}getLinesContent(){return this.f.slice(0)}getLineCount(){return this.f.length}getLineContent(i){return this.f[i-1]}getWordAtPosition(i,u){const w=(0,h.$as)(i.column,(0,h.$$r)(u),this.f[i.lineNumber-1],0);return w?new f.$ys(i.lineNumber,w.startColumn,i.lineNumber,w.endColumn):null}getWordUntilPosition(i,u){const w=this.getWordAtPosition(i,u);return w?{word:this.f[i.lineNumber-1].substring(w.startColumn-1,i.column-1),startColumn:w.startColumn,endColumn:i.column}:{word:"",startColumn:i.column,endColumn:i.column}}words(i){const u=this.f,w=this.q.bind(this);let d=0,v="",R=0,M=[];return{*[Symbol.iterator](){for(;;)if(R<M.length){const P=v.substring(M[R].start,M[R].end);R+=1,yield P}else if(d<u.length)v=u[d],M=w(v,i),R=0,d+=1;else break}}}getLineWords(i,u){const w=this.f[i-1],d=this.q(w,u),v=[];for(const R of d)v.push({word:w.substring(R.start,R.end),startColumn:R.start+1,endColumn:R.end+1});return v}q(i,u){const w=[];let d;for(u.lastIndex=0;(d=u.exec(i))&&d[0].length!==0;)w.push({start:d.index,end:d.index+d[0].length});return w}getValueInRange(i){if(i=this.r(i),i.startLineNumber===i.endLineNumber)return this.f[i.startLineNumber-1].substring(i.startColumn-1,i.endColumn-1);const u=this.g,w=i.startLineNumber-1,d=i.endLineNumber-1,v=[];v.push(this.f[w].substring(i.startColumn-1));for(let R=w+1;R<d;R++)v.push(this.f[R]);return v.push(this.f[d].substring(0,i.endColumn-1)),v.join(u)}offsetAt(i){return i=this.s(i),this.l(),this.j.getPrefixSum(i.lineNumber-2)+(i.column-1)}positionAt(i){i=Math.floor(i),i=Math.max(0,i),this.l();const u=this.j.getIndexOf(i),w=this.f[u.index].length;return{lineNumber:1+u.index,column:1+Math.min(u.remainder,w)}}r(i){const u=this.s({lineNumber:i.startLineNumber,column:i.startColumn}),w=this.s({lineNumber:i.endLineNumber,column:i.endColumn});return u.lineNumber!==i.startLineNumber||u.column!==i.startColumn||w.lineNumber!==i.endLineNumber||w.column!==i.endColumn?{startLineNumber:u.lineNumber,startColumn:u.column,endLineNumber:w.lineNumber,endColumn:w.column}:i}s(i){if(!r.$xs.isIPosition(i))throw new Error("bad position");let{lineNumber:u,column:w}=i,d=!1;if(u<1)u=1,w=1,d=!0;else if(u>this.f.length)u=this.f.length,w=this.f[u-1].length+1,d=!0;else{const v=this.f[u-1].length+1;w<1?(w=1,d=!0):w>v&&(w=v,d=!0)}return d?{lineNumber:u,column:w}:i}}class o{constructor(i,u){this.d=i,this.f=Object.create(null),this.g=u,this.h=null}dispose(){this.f=Object.create(null)}j(i){return this.f[i]}k(){const i=[];return Object.keys(this.f).forEach(u=>i.push(this.f[u])),i}acceptNewModel(i){this.f[i.url]=new $(D.URI.parse(i.url),i.lines,i.EOL,i.versionId)}acceptModelChanged(i,u){if(!this.f[i])return;this.f[i].onEvents(u)}acceptRemovedModel(i){this.f[i]&&delete this.f[i]}async computeUnicodeHighlights(i,u,w){const d=this.j(i);return d?m.$eZ.computeUnicodeHighlights(d,u,w):{ranges:[],hasMore:!1,ambiguousCharacterCount:0,invisibleCharacterCount:0,nonBasicAsciiCharacterCount:0}}async computeDiff(i,u,w,d){const v=this.j(i),R=this.j(u);return!v||!R?null:o.l(v,R,w,d)}static l(i,u,w,d){const v=d==="advanced"?e.$GZ.getDefault():e.$GZ.getLegacy(),R=i.getLinesContent(),M=u.getLinesContent(),P=v.computeDiff(R,M,w),_=P.changes.length>0?!1:this.n(i,u);function F(y){return y.map(I=>[I.original.startLineNumber,I.original.endLineNumberExclusive,I.modified.startLineNumber,I.modified.endLineNumberExclusive,I.innerChanges?.map(q=>[q.originalRange.startLineNumber,q.originalRange.startColumn,q.originalRange.endLineNumber,q.originalRange.endColumn,q.modifiedRange.startLineNumber,q.modifiedRange.startColumn,q.modifiedRange.endLineNumber,q.modifiedRange.endColumn])])}return{identical:_,quitEarly:P.hitTimeout,changes:F(P.changes),moves:P.moves.map(y=>[y.lineRangeMapping.original.startLineNumber,y.lineRangeMapping.original.endLineNumberExclusive,y.lineRangeMapping.modified.startLineNumber,y.lineRangeMapping.modified.endLineNumberExclusive,F(y.changes)])}}static n(i,u){const w=i.getLineCount(),d=u.getLineCount();if(w!==d)return!1;for(let v=1;v<=w;v++){const R=i.getLineContent(v),M=u.getLineContent(v);if(R!==M)return!1}return!0}async computeDirtyDiff(i,u,w){const d=this.j(i),v=this.j(u);if(!d||!v)return null;const R=d.getLinesContent(),M=v.getLinesContent();return new b.$Ps(R,M,{shouldComputeCharChanges:!1,shouldPostProcessCharChanges:!1,shouldIgnoreTrimWhitespace:w,shouldMakePrettyDiff:!0,maxComputationTime:1e3}).computeDiff().changes}async computeMoreMinimalEdits(i,u,w){const d=this.j(i);if(!d)return u;const v=[];let R;u=u.slice(0).sort((P,_)=>{if(P.range&&_.range)return f.$ys.compareRangesUsingStarts(P.range,_.range);const F=P.range?0:1,y=_.range?0:1;return F-y});let M=0;for(let P=1;P<u.length;P++)f.$ys.getEndPosition(u[M].range).equals(f.$ys.getStartPosition(u[P].range))?(u[M].range=f.$ys.fromPositions(f.$ys.getStartPosition(u[M].range),f.$ys.getEndPosition(u[P].range)),u[M].text+=u[P].text):(M++,u[M]=u[P]);u.length=M+1;for(let{range:P,text:_,eol:F}of u){if(typeof F=="number"&&(R=F),f.$ys.isEmpty(P)&&!_)continue;const y=d.getValueInRange(P);if(_=_.replace(/\r\n|\n|\r/g,d.eol),y===_)continue;if(Math.max(_.length,y.length)>o.o){v.push({range:P,text:_});continue}const I=(0,k.$Ds)(y,_,w),q=d.offsetAt(f.$ys.lift(P).getStartPosition());for(const x of I){const T=d.positionAt(q+x.originalStart),V=d.positionAt(q+x.originalStart+x.originalLength),H={text:_.substr(x.modifiedStart,x.modifiedLength),range:{startLineNumber:T.lineNumber,startColumn:T.column,endLineNumber:V.lineNumber,endColumn:V.column}};d.getValueInRange(H.range)!==H.text&&v.push(H)}}return typeof R=="number"&&v.push({eol:R,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),v}computeHumanReadableDiff(i,u,w){const d=this.j(i);if(!d)return u;const v=[];let R;u=u.slice(0).sort((M,P)=>{if(M.range&&P.range)return f.$ys.compareRangesUsingStarts(M.range,P.range);const _=M.range?0:1,F=P.range?0:1;return _-F});for(let{range:M,text:P,eol:_}of u){let T=function(H,W){return new r.$xs(H.lineNumber+W.lineNumber-1,W.lineNumber===1?H.column+W.column-1:W.column)},V=function(H,W){const J=[];for(let n=W.startLineNumber;n<=W.endLineNumber;n++){const te=H[n-1];n===W.startLineNumber&&n===W.endLineNumber?J.push(te.substring(W.startColumn-1,W.endColumn-1)):n===W.startLineNumber?J.push(te.substring(W.startColumn-1)):n===W.endLineNumber?J.push(te.substring(0,W.endColumn-1)):J.push(te)}return J};if(typeof _=="number"&&(R=_),f.$ys.isEmpty(M)&&!P)continue;const F=d.getValueInRange(M);if(P=P.replace(/\r\n|\n|\r/g,d.eol),F===P)continue;if(Math.max(P.length,F.length)>o.o){v.push({range:M,text:P});continue}const y=F.split(/\r\n|\n|\r/),I=P.split(/\r\n|\n|\r/),q=e.$GZ.getDefault().computeDiff(y,I,w),x=f.$ys.lift(M).getStartPosition();for(const H of q.changes)if(H.innerChanges)for(const W of H.innerChanges)v.push({range:f.$ys.fromPositions(T(x,W.originalRange.getStartPosition()),T(x,W.originalRange.getEndPosition())),text:V(I,W.modifiedRange).join(d.eol)});else throw new A.$cb("The experimental diff algorithm always produces inner changes")}return typeof R=="number"&&v.push({eol:R,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),v}async computeLinks(i){const u=this.j(i);return u?(0,a.$hZ)(u):null}async computeDefaultDocumentColors(i){const u=this.j(i);return u?(0,p.$HZ)(u):null}async textualSuggest(i,u,w,d){const v=new E.$Kd,R=new RegExp(w,d),M=new Set;e:for(const P of i){const _=this.j(P);if(_){for(const F of _.words(R))if(!(F===u||!isNaN(Number(F)))&&(M.add(F),M.size>o.p))break e}}return{words:Array.from(M),duration:v.elapsed()}}async computeWordRanges(i,u,w,d){const v=this.j(i);if(!v)return Object.create(null);const R=new RegExp(w,d),M=Object.create(null);for(let P=u.startLineNumber;P<u.endLineNumber;P++){const _=v.getLineWords(P,R);for(const F of _){if(!isNaN(Number(F.word)))continue;let y=M[F.word];y||(y=[],M[F.word]=y),y.push({startLineNumber:P,startColumn:F.startColumn,endLineNumber:P,endColumn:F.endColumn})}}return M}async navigateValueSet(i,u,w,d,v){const R=this.j(i);if(!R)return null;const M=new RegExp(d,v);u.startColumn===u.endColumn&&(u={startLineNumber:u.startLineNumber,startColumn:u.startColumn,endLineNumber:u.endLineNumber,endColumn:u.endColumn+1});const P=R.getValueInRange(u),_=R.getWordAtPosition({lineNumber:u.startLineNumber,column:u.startColumn},M);if(!_)return null;const F=R.getValueInRange(_);return l.$iZ.INSTANCE.navigateValueSet(u,P,_,F,w)}loadForeignModule(i,u,w){const d=(M,P)=>this.d.fhr(M,P),R={host:(0,L.$hn)(w,d),getMirrorModels:()=>this.k()};return this.g?(this.h=this.g(R,u),Promise.resolve((0,L.$gn)(this.h))):new Promise((M,P)=>{O([i],_=>{this.h=_.create(R,u),M((0,L.$gn)(this.h))},P)})}fmr(i,u){if(!this.h||typeof this.h[i]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+i));try{return Promise.resolve(this.h[i].apply(this.h,u))}catch(w){return Promise.reject(w)}}}t.EditorSimpleWorker=o,o.o=1e5,o.p=1e4;function c(s){return new o(s,null)}t.create=c,typeof importScripts=="function"&&(globalThis.monaco=(0,g.$kZ)())})}).call(this);

//# sourceMappingURL=workerMain.js.map
