"use strict";/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var be=["exports","require","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/base/common/path","vs/base/common/types","vs/nls","vs/nls!vs/server/node/server.main","vs/base/common/errors","vs/base/common/network","vs/platform/log/common/log","vs/base/common/async","vs/base/common/buffer","vs/platform/files/common/files","vs/base/common/strings","vs/base/common/arrays","vs/base/common/resources","vs/base/common/cancellation","vs/base/node/pfs","vs/base/common/objects","vs/base/common/uuid","vs/platform/configuration/common/configuration","vs/platform/environment/common/environment","vs/base/common/map","os","vs/base/common/process","fs","vs/platform/extensionManagement/common/extensionManagement","vs/platform/product/common/productService","vs/platform/telemetry/common/telemetry","vs/platform/userDataProfile/common/userDataProfile","vs/platform/uriIdentity/common/uriIdentity","vs/platform/extensions/common/extensions","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/registry/common/platform","vs/platform/telemetry/common/telemetryUtils","vs/base/common/extpath","vs/base/common/errorMessage","vs/base/common/performance","vs/base/parts/ipc/common/ipc","vs/editor/common/core/range","vs/platform/request/common/request","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/server/node/serverEnvironmentService","vs/base/common/iterator","vs/base/common/stream","vs/base/common/codicons","vs/base/common/marshalling","vs/base/common/uriIpc","child_process","vs/base/common/semver/semver","vs/platform/files/common/watcher","vs/platform/product/common/product","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/platform/extensionManagement/common/extensionsScannerService","vs/base/common/mime","vs/base/common/processes","vs/base/common/stopwatch","vs/base/common/hash","vs/base/common/severity","vs/base/common/ternarySearchTree","vs/platform/environment/node/argv","vs/platform/instantiation/common/descriptors","vs/platform/contextkey/common/contextkey","vs/platform/files/node/diskFileSystemProvider","vs/platform/policy/common/policy","vs/workbench/api/node/uriTransformer","vs/workbench/contrib/testing/common/testId","vs/base/parts/ipc/node/ipc.net","vs/base/common/decorators","vs/base/common/functional","vs/base/common/json","vs/base/common/lazy","vs/base/common/glob","path","net","vs/platform/extensions/common/extensionValidator","vs/platform/download/common/download","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","url","vs/platform/shell/node/shellEnv","crypto","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminal","vs/platform/workspace/common/workspace","vs/server/node/remoteLanguagePacks","vs/workbench/common/editor","vs/workbench/contrib/testing/common/testTypes","vs/base/node/zip","vs/base/common/amd","vs/base/common/assert","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/themables","vs/base/common/htmlContent","vs/base/node/id","vs/base/node/powershell","vs/base/node/processes","vs/base/node/ps","vs/base/node/shell","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/node/ipc.cp","vs/editor/common/core/position","vs/platform/environment/node/environmentService","vs/platform/files/common/io","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/fileService","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/log/node/loggerService","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementCLI","vs/platform/languagePacks/node/languagePacks","vs/platform/terminal/common/environmentVariable","vs/platform/terminal/common/environmentVariableCollection","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/userDataProfile/node/userDataProfile","vs/server/node/extensionHostStatusService","vs/server/node/extensionsScannerService","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostTypes","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostTypeConverters","vs/workbench/services/extensions/common/proxyIdentifier","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","vs/server/node/extensionHostConnection","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/marked/marked","vs/base/common/numbers","vs/base/common/skipList","vs/base/common/cache","vs/base/common/filters","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/console","vs/amdX","vs/base/common/labels","vs/base/common/dataTransfer","vs/base/node/languagePacks","vs/base/node/macAddress","vs/base/node/osReleaseInfo","vs/base/node/extpath","vs/base/node/ports","vs/base/parts/storage/common/storage","vs/editor/common/core/editOperation","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/node/zip","vs/nls!vs/editor/common/languages","vs/editor/common/languages","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLI","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/common/terminalProfiles","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/server/node/remoteExtensionHostAgentCli","vs/nls!vs/server/node/serverEnvironmentService","vs/nls!vs/server/node/serverServices","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsUtil","vs/platform/contextkey/common/scanner","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/download/common/downloadIpc","vs/platform/environment/common/environmentService","vs/platform/environment/node/argvHelper","vs/platform/environment/node/userDataPath","vs/platform/extensionManagement/common/extensionNls","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/diagnostics/common/diagnostics","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/label/common/label","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/log/node/spdlogLog","vs/platform/markers/common/markers","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/remote/common/remoteExtensionsScanner","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/download/common/downloadService","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","vs/platform/state/node/state","vs/platform/state/node/stateService","vs/platform/telemetry/common/errorTelemetry","vs/platform/telemetry/common/remoteTelemetryChannel","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/common/serverTelemetryService","vs/platform/telemetry/node/1dsAppender","https","vs/platform/telemetry/node/errorTelemetry","vs/platform/terminal/common/requestStore","vs/platform/terminal/common/terminalEnvironment","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/nodePtyHostStarter","vs/platform/terminal/node/terminalEnvironment","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/storage/common/storage","vs/platform/userDataProfile/common/userDataProfileIpc","vs/server/node/remoteExtensionManagement","vs/server/node/serverConnectionToken","cookie","vs/server/node/telemetryClient","http","vs/server/node/webClientServer","vs/workbench/api/common/extHostInitDataService","vs/workbench/api/common/extHostRpcService","vs/server/node/remoteAgentEnvironmentImpl","vs/server/node/remoteFileSystemProviderServer","vs/workbench/contrib/terminal/common/environmentVariable","vs/workbench/contrib/terminal/common/terminalEnvironment","vs/workbench/services/configuration/common/configuration","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/contrib/terminal/common/remote/remoteTerminalChannel","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostTelemetry","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostTestItem","vs/workbench/services/extensions/common/extensionsUtil","vs/server/node/remoteExtensionsScanner","vs/workbench/api/common/extHost.protocol","vs/workbench/api/common/extHostCommands","vs/workbench/services/remote/common/remoteFileSystemProviderClient","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionManagementUtil","zlib","vs/server/node/remoteExtensionHostAgentCli","vs/base/node/unc","vs/workbench/api/node/extHostCLIServer","vs/server/node/remoteTerminalChannel","vs/server/node/serverServices","vs/server/node/remoteExtensionHostAgentServer","perf_hooks","fs/promises","readline","util","minimist","assert","graceful-fs","@microsoft/1ds-core-js","yauzl","yazl","vs/server/node/server.main"],we=function(ue){for(var e=[],y=0,R=ue.length;y<R;y++)e[y]=be[ue[y]];return e};define(be[95],we([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=e.$T=void 0,e.$T=!1;class y{static get(){const r=new Map,L=new Map,I=new Map,C=new Map;function p(u,b){u.has(b.detail)||u.set(b.detail,-b.timestamp)}function w(u,b){const m=u.get(b.detail);m&&(m>=0||u.set(b.detail,m+b.timestamp))}let A=[];typeof ue=="function"&&typeof ue.getStats=="function"&&(A=ue.getStats().slice(0).sort((u,b)=>u.timestamp-b.timestamp));for(const u of A)switch(u.type){case 10:p(r,u);break;case 11:case 12:w(r,u);break;case 21:p(L,u);break;case 22:w(L,u);break;case 33:p(I,u);break;case 34:w(I,u);break;case 31:p(C,u);break;case 32:w(C,u);break}let k=0;I.forEach(u=>k+=u);function v(u){const b=[];return u.forEach((m,d)=>b.push([d,m])),b}return{amdLoad:v(r),amdInvoke:v(L),nodeRequire:v(I),nodeEval:v(C),nodeRequireTotal:k}}static toMarkdownTable(r,L){let I="";const C=[];return r.forEach((p,w)=>{C[w]=p.length}),L.forEach(p=>{p.forEach((w,A)=>{typeof w>"u"&&(w=p[A]="-");const k=w.toString().length;C[A]=Math.max(k,C[A])})}),r.forEach((p,w)=>{I+=`| ${p+" ".repeat(C[w]-p.toString().length)} `}),I+=`|
`,r.forEach((p,w)=>{I+=`| ${"-".repeat(C[w])} `}),I+=`|
`,L.forEach(p=>{p.forEach((w,A)=>{typeof w<"u"&&(I+=`| ${w+" ".repeat(C[A]-w.toString().length)} `)}),I+=`|
`}),I}}e.$U=y}),define(be[141],we([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rb=e.$qb=e.$pb=e.$ob=e.$nb=e.$mb=e.$lb=e.$kb=e.$jb=e.$ib=e.$hb=e.$gb=e.$fb=void 0;function y(m,d,h){const g=R(m,d);if(g!==-1)return m[g]}e.$fb=y;function R(m,d,h=m.length-1){for(let g=h;g>=0;g--){const l=m[g];if(d(l))return g}return-1}e.$gb=R;function r(m,d){const h=L(m,d);return h===-1?void 0:m[h]}e.$hb=r;function L(m,d,h=0,g=m.length){let l=h,$=g;for(;l<$;){const c=Math.floor((l+$)/2);d(m[c])?l=c+1:$=c}return l-1}e.$ib=L;function I(m,d){const h=C(m,d);return h===m.length?void 0:m[h]}e.$jb=I;function C(m,d,h=0,g=m.length){let l=h,$=g;for(;l<$;){const c=Math.floor((l+$)/2);d(m[c])?$=c:l=c+1}return l}e.$kb=C;function p(m,d,h=0,g=m.length){const l=C(m,d,h,g);return l===m.length?-1:l}e.$lb=p;class w{constructor(d){this.e=d,this.c=0}findLastMonotonous(d){if(w.assertInvariants){if(this.d){for(const g of this.e)if(this.d(g)&&!d(g))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=d}const h=L(this.e,d,this.c);return this.c=h+1,h===-1?void 0:this.e[h]}}e.$mb=w,w.assertInvariants=!1;function A(m,d){if(m.length===0)return;let h=m[0];for(let g=1;g<m.length;g++){const l=m[g];d(l,h)>0&&(h=l)}return h}e.$nb=A;function k(m,d){if(m.length===0)return;let h=m[0];for(let g=1;g<m.length;g++){const l=m[g];d(l,h)>=0&&(h=l)}return h}e.$ob=k;function v(m,d){return A(m,(h,g)=>-d(h,g))}e.$pb=v;function u(m,d){if(m.length===0)return-1;let h=0;for(let g=1;g<m.length;g++){const l=m[g];d(l,m[h])>0&&(h=g)}return h}e.$qb=u;function b(m,d){for(const h of m){const g=d(h);if(g!==void 0)return g}}e.$rb=b}),define(be[142],we([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$G=e.$F=e.$E=e.$D=void 0;function y(I,C){const p=Object.create(null);for(const w of I){const A=C(w);let k=p[A];k||(k=p[A]=[]),k.push(w)}return p}e.$D=y;function R(I,C){const p=[],w=[];for(const A of I)C.has(A)||p.push(A);for(const A of C)I.has(A)||w.push(A);return{removed:p,added:w}}e.$E=R;function r(I,C){const p=[],w=[];for(const[A,k]of I)C.has(A)||p.push(k);for(const[A,k]of C)I.has(A)||w.push(k);return{removed:p,added:w}}e.$F=r;function L(I,C){const p=new Set;for(const w of C)I.has(w)&&p.add(w);return p}e.$G=L}),define(be[73],we([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kh=e.$jh=e.$ih=void 0;function y(I){return(C,p,w)=>{let A=null,k=null;if(typeof w.value=="function"?(A="value",k=w.value):typeof w.get=="function"&&(A="get",k=w.get),!k)throw new Error("not supported");w[A]=I(k,p)}}function R(I,C,p){let w=null,A=null;if(typeof p.value=="function"?(w="value",A=p.value,A.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof p.get=="function"&&(w="get",A=p.get),!A)throw new Error("not supported");const k=`$memoize$${C}`;p[w]=function(...v){return this.hasOwnProperty(k)||Object.defineProperty(this,k,{configurable:!1,enumerable:!1,writable:!1,value:A.apply(this,v)}),this[k]}}e.$ih=R;function r(I,C,p){return y((w,A)=>{const k=`$debounce$${A}`,v=`$debounce$result$${A}`;return function(...u){this[v]||(this[v]=p?p():void 0),clearTimeout(this[k]),C&&(this[v]=C(this[v],...u),u=[this[v]]),this[k]=setTimeout(()=>{w.apply(this,u),this[v]=p?p():void 0},I)}})}e.$jh=r;function L(I,C,p){return y((w,A)=>{const k=`$throttle$timer$${A}`,v=`$throttle$result$${A}`,u=`$throttle$lastRun$${A}`,b=`$throttle$pending$${A}`;return function(...m){if(this[v]||(this[v]=p?p():void 0),(this[u]===null||this[u]===void 0)&&(this[u]=-Number.MAX_VALUE),C&&(this[v]=C(this[v],...m)),this[b])return;const d=this[u]+I;d<=Date.now()?(this[u]=Date.now(),w.apply(this,[this[v]]),this[v]=p?p():void 0):(this[b]=!0,this[k]=setTimeout(()=>{this[b]=!1,this[u]=Date.now(),w.apply(this,[this[v]]),this[v]=p?p():void 0},d-Date.now()))}})}e.$kh=L}),define(be[11],we([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=e.$bb=e.$ab=e.$_=e.$$=e.$0=e.$9=e.$8=e.$7=e.$6=e.$5=e.$4=e.$3=e.$2=e.$1=e.$Z=e.setUnexpectedErrorHandler=e.$X=e.$W=void 0;class y{constructor(){this.b=[],this.a=function(n){setTimeout(()=>{throw n.stack?l.isErrorNoTelemetry(n)?new l(n.message+`

`+n.stack):new Error(n.message+`

`+n.stack):n},0)}}addListener(n){return this.b.push(n),()=>{this.d(n)}}c(n){this.b.forEach(i=>{i(n)})}d(n){this.b.splice(this.b.indexOf(n),1)}setUnexpectedErrorHandler(n){this.a=n}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(n){this.a(n),this.c(n)}onUnexpectedExternalError(n){this.a(n)}}e.$W=y,e.$X=new y;function R(c){e.$X.setUnexpectedErrorHandler(c)}e.setUnexpectedErrorHandler=R;function r(c){if(!c||typeof c!="object")return!1;const n=c;return n.code==="EPIPE"&&n.syscall?.toUpperCase()==="WRITE"}e.$Z=r;function L(c){w(c)||e.$X.onUnexpectedError(c)}e.$1=L;function I(c){w(c)||e.$X.onUnexpectedExternalError(c)}e.$2=I;function C(c){if(c instanceof Error){const{name:n,message:i}=c,o=c.stacktrace||c.stack;return{$isError:!0,name:n,message:i,stack:o,noTelemetry:l.isErrorNoTelemetry(c)}}return c}e.$3=C;const p="Canceled";function w(c){return c instanceof A?!0:c instanceof Error&&c.name===p&&c.message===p}e.$4=w;class A extends Error{constructor(){super(p),this.name=this.message}}e.$5=A;function k(){const c=new Error(p);return c.name=c.message,c}e.$6=k;function v(c){return c?new Error(`Illegal argument: ${c}`):new Error("Illegal argument")}e.$7=v;function u(c){return c?new Error(`Illegal state: ${c}`):new Error("Illegal state")}e.$8=u;class b extends TypeError{constructor(n){super(n?`${n} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$9=b;function m(c){return c?c.message?c.message:c.stack?c.stack.split(`
`)[0]:String(c):"Error"}e.$0=m;class d extends Error{constructor(n){super("NotImplemented"),n&&(this.message=n)}}e.$$=d;class h extends Error{constructor(n){super("NotSupported"),n&&(this.message=n)}}e.$_=h;class g extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$ab=g;class l extends Error{constructor(n){super(n),this.name="CodeExpectedError"}static fromError(n){if(n instanceof l)return n;const i=new l;return i.message=n.message,i.stack=n.stack,i}static isErrorNoTelemetry(n){return n.name==="CodeExpectedError"}}e.$bb=l;class $ extends Error{constructor(n){super(n||"An unexpected bug occurred."),Object.setPrototypeOf(this,$.prototype)}}e.$cb=$}),define(be[18],we([1,0,11,141]),function(ue,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ac=e.$_b=e.$$b=e.$0b=e.$9b=e.$8b=e.$7b=e.CompareResult=e.$6b=e.$5b=e.$4b=e.$3b=e.$2b=e.$1b=e.$Zb=e.$Yb=e.$Xb=e.$Wb=e.$Vb=e.$Ub=e.$Tb=e.$Sb=e.$Rb=e.$Qb=e.$Pb=e.$Ob=e.$Nb=e.$Mb=e.$Lb=e.$Kb=e.$Jb=e.$Ib=e.$Hb=e.$Gb=e.top=e.$Eb=e.$Db=e.$Cb=e.$Bb=e.$Ab=e.$zb=e.$yb=e.$xb=e.$wb=e.$vb=e.$ub=e.$tb=e.$sb=void 0;function r(T,z=0){return T[T.length-(1+z)]}e.$sb=r;function L(T){if(T.length===0)throw new Error("Invalid tail call");return[T.slice(0,T.length-1),T[T.length-1]]}e.$tb=L;function I(T,z,B=(te,H)=>te===H){if(T===z)return!0;if(!T||!z||T.length!==z.length)return!1;for(let te=0,H=T.length;te<H;te++)if(!B(T[te],z[te]))return!1;return!0}e.$ub=I;function C(T,z){const B=T.length-1;z<B&&(T[z]=T[B]),T.pop()}e.$vb=C;function p(T,z,B){return w(T.length,te=>B(T[te],z))}e.$wb=p;function w(T,z){let B=0,te=T-1;for(;B<=te;){const H=(B+te)/2|0,x=z(H);if(x<0)B=H+1;else if(x>0)te=H-1;else return H}return-(B+1)}e.$xb=w;function A(T,z,B){if(T=T|0,T>=z.length)throw new TypeError("invalid index");const te=z[Math.floor(z.length*Math.random())],H=[],x=[],W=[];for(const X of z){const ae=B(X,te);ae<0?H.push(X):ae>0?x.push(X):W.push(X)}return T<H.length?A(T,H,B):T<H.length+W.length?W[0]:A(T-(H.length+W.length),x,B)}e.$yb=A;function k(T,z){const B=[];let te;for(const H of T.slice(0).sort(z))!te||z(te[0],H)!==0?(te=[H],B.push(te)):te.push(H);return B}e.$zb=k;function*v(T,z){let B,te;for(const H of T)te!==void 0&&z(te,H)?B.push(H):(B&&(yield B),B=[H]),te=H;B&&(yield B)}e.$Ab=v;function u(T,z){for(let B=0;B<=T.length;B++)z(B===0?void 0:T[B-1],B===T.length?void 0:T[B])}e.$Bb=u;function b(T,z){for(let B=0;B<T.length;B++)z(B===0?void 0:T[B-1],T[B],B+1===T.length?void 0:T[B+1])}e.$Cb=b;function m(T,z,B){const te=[];function H(X,ae,ge){if(ae===0&&ge.length===0)return;const Ee=te[te.length-1];Ee&&Ee.start+Ee.deleteCount===X?(Ee.deleteCount+=ae,Ee.toInsert.push(...ge)):te.push({start:X,deleteCount:ae,toInsert:ge})}let x=0,W=0;for(;;){if(x===T.length){H(x,0,z.slice(W));break}if(W===z.length){H(x,T.length-x,[]);break}const X=T[x],ae=z[W],ge=B(X,ae);ge===0?(x+=1,W+=1):ge<0?(H(x,1,[]),x+=1):ge>0&&(H(x,0,[ae]),W+=1)}return te}e.$Db=m;function d(T,z,B){const te=m(T,z,B),H=[],x=[];for(const W of te)H.push(...T.slice(W.start,W.start+W.deleteCount)),x.push(...W.toInsert);return{removed:H,added:x}}e.$Eb=d;function h(T,z,B){if(B===0)return[];const te=T.slice(0,B).sort(z);return l(T,z,te,B,T.length),te}e.top=h;function g(T,z,B,te,H){return B===0?Promise.resolve([]):new Promise((x,W)=>{(async()=>{const X=T.length,ae=T.slice(0,B).sort(z);for(let ge=B,Ee=Math.min(B+te,X);ge<X;ge=Ee,Ee=Math.min(Ee+te,X)){if(ge>B&&await new Promise(Ce=>setTimeout(Ce)),H&&H.isCancellationRequested)throw new y.$5;l(T,z,ae,ge,Ee)}return ae})().then(x,W)})}e.$Gb=g;function l(T,z,B,te,H){for(const x=B.length;te<H;te++){const W=T[te];if(z(W,B[x-1])<0){B.pop();const X=(0,R.$kb)(B,ae=>z(W,ae)<0);B.splice(X,0,W)}}}function $(T){return T.filter(z=>!!z)}e.$Hb=$;function c(T){let z=0;for(let B=0;B<T.length;B++)T[B]&&(T[z]=T[B],z+=1);T.length=z}e.$Ib=c;function n(T,z,B){T.splice(B,0,T.splice(z,1)[0])}e.$Jb=n;function i(T){return!Array.isArray(T)||T.length===0}e.$Kb=i;function o(T){return Array.isArray(T)&&T.length>0}e.$Lb=o;function s(T,z=B=>B){const B=new Set;return T.filter(te=>{const H=z(te);return B.has(H)?!1:(B.add(H),!0)})}e.$Mb=s;function t(T){const z=new Set;return B=>{const te=T(B);return z.has(te)?!1:(z.add(te),!0)}}e.$Nb=t;function a(T,z){return T.length>0?T[0]:z}e.$Ob=a;function f(T,z){return T.length>0?T[T.length-1]:z}e.$Pb=f;function S(T,z,B=(te,H)=>te===H){let te=0;for(let H=0,x=Math.min(T.length,z.length);H<x&&B(T[H],z[H]);H++)te++;return te}e.$Qb=S;function D(T){return[].concat(...T)}e.$Rb=D;function E(T,z){let B=typeof z=="number"?T:0;typeof z=="number"?B=T:(B=0,z=T);const te=[];if(B<=z)for(let H=B;H<z;H++)te.push(H);else for(let H=B;H>z;H--)te.push(H);return te}e.$Sb=E;function P(T,z,B){return T.reduce((te,H)=>(te[z(H)]=B?B(H):H,te),Object.create(null))}e.$Tb=P;function M(T,z){return T.push(z),()=>ee(T,z)}e.$Ub=M;function ee(T,z){const B=T.indexOf(z);if(B>-1)return T.splice(B,1),z}e.$Vb=ee;function se(T,z,B){const te=T.slice(0,z),H=T.slice(z);return te.concat(B,H)}e.$Wb=se;function G(T,z){let B;if(typeof z=="number"){let te=z;B=()=>{const H=Math.sin(te++)*179426549;return H-Math.floor(H)}}else B=Math.random;for(let te=T.length-1;te>0;te-=1){const H=Math.floor(B()*(te+1)),x=T[te];T[te]=T[H],T[H]=x}}e.$Xb=G;function ne(T,z){const B=T.indexOf(z);B>-1&&(T.splice(B,1),T.unshift(z))}e.$Yb=ne;function he(T,z){const B=T.indexOf(z);B>-1&&(T.splice(B,1),T.push(z))}e.$Zb=he;function Z(T,z){for(const B of z)T.push(B)}e.$1b=Z;function fe(T,z){return Array.isArray(T)?T.map(z):z(T)}e.$2b=fe;function V(T){return Array.isArray(T)?T:[T]}e.$3b=V;function ie(T){return T[Math.floor(Math.random()*T.length)]}e.$4b=ie;function Y(T,z,B){const te=re(T,z),H=T.length,x=B.length;T.length=H+x;for(let W=H-1;W>=te;W--)T[W+x]=T[W];for(let W=0;W<x;W++)T[W+te]=B[W]}e.$5b=Y;function J(T,z,B,te){const H=re(T,z);let x=T.splice(H,B);return x===void 0&&(x=[]),Y(T,H,te),x}e.$6b=J;function re(T,z){return z<0?Math.max(z+T.length,0):Math.min(z,T.length)}var ce;(function(T){function z(x){return x<0}T.isLessThan=z;function B(x){return x<=0}T.isLessThanOrEqual=B;function te(x){return x>0}T.isGreaterThan=te;function H(x){return x===0}T.isNeitherLessOrGreaterThan=H,T.greaterThan=1,T.lessThan=-1,T.neitherLessOrGreaterThan=0})(ce||(e.CompareResult=ce={}));function oe(T,z){return(B,te)=>z(T(B),T(te))}e.$7b=oe;function _(...T){return(z,B)=>{for(const te of T){const H=te(z,B);if(!ce.isNeitherLessOrGreaterThan(H))return H}return ce.neitherLessOrGreaterThan}}e.$8b=_;const q=(T,z)=>T-z;e.$9b=q;const Q=(T,z)=>(0,e.$9b)(T?1:0,z?1:0);e.$0b=Q;function O(T){return(z,B)=>-T(z,B)}e.$$b=O;class N{constructor(z){this.g=z,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(z){let B=this.c;for(;B<this.g.length&&z(this.g[B]);)B++;const te=B===this.c?null:this.g.slice(this.c,B);return this.c=B,te}takeFromEndWhile(z){let B=this.d;for(;B>=0&&z(this.g[B]);)B--;const te=B===this.d?null:this.g.slice(B+1,this.d+1);return this.d=B,te}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const z=this.g[this.c];return this.c++,z}removeLast(){const z=this.g[this.d];return this.d--,z}takeCount(z){const B=this.g.slice(this.c,this.c+z);return this.c+=z,B}}e.$_b=N;class U{constructor(z){this.iterate=z}forEach(z){this.iterate(B=>(z(B),!0))}toArray(){const z=[];return this.iterate(B=>(z.push(B),!0)),z}filter(z){return new U(B=>this.iterate(te=>z(te)?B(te):!0))}map(z){return new U(B=>this.iterate(te=>B(z(te))))}some(z){let B=!1;return this.iterate(te=>(B=z(te),!B)),B}findFirst(z){let B;return this.iterate(te=>z(te)?(B=te,!1):!0),B}findLast(z){let B;return this.iterate(te=>(z(te)&&(B=te),!0)),B}findLastMaxBy(z){let B,te=!0;return this.iterate(H=>((te||ce.isGreaterThan(z(H,B)))&&(te=!1,B=H),!0)),B}}e.$ac=U,U.empty=new U(T=>{})}),define(be[96],we([1,0,11]),function(ue,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7c=e.$6c=e.$5c=e.$4c=e.ok=void 0;function R(p,w){if(!p)throw new Error(w?`Assertion failed (${w})`:"Assertion Failed")}e.ok=R;function r(p,w="Unreachable"){throw new Error(w)}e.$4c=r;function L(p){if(!p)throw new y.$cb("Assertion Failed")}e.$5c=L;function I(p){if(!p()){debugger;p(),(0,y.$1)(new y.$cb("Assertion Failed"))}}e.$6c=I;function C(p,w){let A=0;for(;A<p.length-1;){const k=p[A],v=p[A+1];if(!w(k,v))return!1;A++}return!0}e.$7c=C}),define(be[74],we([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$db=void 0;function y(R){const r=this;let L=!1,I;return function(){return L||(L=!0,I=R.apply(r,arguments)),I}}e.$db=y}),define(be[47],we([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var y;(function(R){function r(c){return c&&typeof c=="object"&&typeof c[Symbol.iterator]=="function"}R.is=r;const L=Object.freeze([]);function I(){return L}R.empty=I;function*C(c){yield c}R.single=C;function p(c){return r(c)?c:C(c)}R.wrap=p;function w(c){return c||L}R.from=w;function*A(c){for(let n=c.length-1;n>=0;n--)yield c[n]}R.reverse=A;function k(c){return!c||c[Symbol.iterator]().next().done===!0}R.isEmpty=k;function v(c){return c[Symbol.iterator]().next().value}R.first=v;function u(c,n){for(const i of c)if(n(i))return!0;return!1}R.some=u;function b(c,n){for(const i of c)if(n(i))return i}R.find=b;function*m(c,n){for(const i of c)n(i)&&(yield i)}R.filter=m;function*d(c,n){let i=0;for(const o of c)yield n(o,i++)}R.map=d;function*h(...c){for(const n of c)for(const i of n)yield i}R.concat=h;function g(c,n,i){let o=i;for(const s of c)o=n(o,s);return o}R.reduce=g;function*l(c,n,i=c.length){for(n<0&&(n+=c.length),i<0?i+=c.length:i>c.length&&(i=c.length);n<i;n++)yield c[n]}R.slice=l;function $(c,n=Number.POSITIVE_INFINITY){const i=[];if(n===0)return[i,c];const o=c[Symbol.iterator]();for(let s=0;s<n;s++){const t=o.next();if(t.done)return[i,R.empty()];i.push(t.value)}return[i,{[Symbol.iterator](){return o}}]}R.consume=$})(y||(e.Iterable=y={}))}),define(be[75],we([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8m=e.$7m=e.$6m=e.$5m=e.$4m=e.$3m=e.$2m=e.$1m=e.$Zm=e.$Ym=e.$Xm=e.$Wm=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var y;(function(n){n[n.None=0]="None",n[n.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=2]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",n[n.InvalidUnicode=4]="InvalidUnicode",n[n.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",n[n.InvalidCharacter=6]="InvalidCharacter"})(y||(e.ScanError=y={}));var R;(function(n){n[n.OpenBraceToken=1]="OpenBraceToken",n[n.CloseBraceToken=2]="CloseBraceToken",n[n.OpenBracketToken=3]="OpenBracketToken",n[n.CloseBracketToken=4]="CloseBracketToken",n[n.CommaToken=5]="CommaToken",n[n.ColonToken=6]="ColonToken",n[n.NullKeyword=7]="NullKeyword",n[n.TrueKeyword=8]="TrueKeyword",n[n.FalseKeyword=9]="FalseKeyword",n[n.StringLiteral=10]="StringLiteral",n[n.NumericLiteral=11]="NumericLiteral",n[n.LineCommentTrivia=12]="LineCommentTrivia",n[n.BlockCommentTrivia=13]="BlockCommentTrivia",n[n.LineBreakTrivia=14]="LineBreakTrivia",n[n.Trivia=15]="Trivia",n[n.Unknown=16]="Unknown",n[n.EOF=17]="EOF"})(R||(e.SyntaxKind=R={}));var r;(function(n){n[n.InvalidSymbol=1]="InvalidSymbol",n[n.InvalidNumberFormat=2]="InvalidNumberFormat",n[n.PropertyNameExpected=3]="PropertyNameExpected",n[n.ValueExpected=4]="ValueExpected",n[n.ColonExpected=5]="ColonExpected",n[n.CommaExpected=6]="CommaExpected",n[n.CloseBraceExpected=7]="CloseBraceExpected",n[n.CloseBracketExpected=8]="CloseBracketExpected",n[n.EndOfFileExpected=9]="EndOfFileExpected",n[n.InvalidCommentToken=10]="InvalidCommentToken",n[n.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=12]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",n[n.InvalidUnicode=14]="InvalidUnicode",n[n.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",n[n.InvalidCharacter=16]="InvalidCharacter"})(r||(e.ParseErrorCode=r={}));var L;(function(n){n.DEFAULT={allowTrailingComma:!0}})(L||(e.ParseOptions=L={}));function I(n,i=!1){let o=0;const s=n.length;let t="",a=0,f=16,S=0;function D(ne){let he=0,Z=0;for(;he<ne;){const fe=n.charCodeAt(o);if(fe>=48&&fe<=57)Z=Z*16+fe-48;else if(fe>=65&&fe<=70)Z=Z*16+fe-65+10;else if(fe>=97&&fe<=102)Z=Z*16+fe-97+10;else break;o++,he++}return he<ne&&(Z=-1),Z}function E(ne){o=ne,t="",a=0,f=16,S=0}function P(){const ne=o;if(n.charCodeAt(o)===48)o++;else for(o++;o<n.length&&w(n.charCodeAt(o));)o++;if(o<n.length&&n.charCodeAt(o)===46)if(o++,o<n.length&&w(n.charCodeAt(o)))for(o++;o<n.length&&w(n.charCodeAt(o));)o++;else return S=3,n.substring(ne,o);let he=o;if(o<n.length&&(n.charCodeAt(o)===69||n.charCodeAt(o)===101))if(o++,(o<n.length&&n.charCodeAt(o)===43||n.charCodeAt(o)===45)&&o++,o<n.length&&w(n.charCodeAt(o))){for(o++;o<n.length&&w(n.charCodeAt(o));)o++;he=o}else S=3;return n.substring(ne,he)}function M(){let ne="",he=o;for(;;){if(o>=s){ne+=n.substring(he,o),S=2;break}const Z=n.charCodeAt(o);if(Z===34){ne+=n.substring(he,o),o++;break}if(Z===92){if(ne+=n.substring(he,o),o++,o>=s){S=2;break}switch(n.charCodeAt(o++)){case 34:ne+='"';break;case 92:ne+="\\";break;case 47:ne+="/";break;case 98:ne+="\b";break;case 102:ne+="\f";break;case 110:ne+=`
`;break;case 114:ne+="\r";break;case 116:ne+="	";break;case 117:{const V=D(4);V>=0?ne+=String.fromCharCode(V):S=4;break}default:S=5}he=o;continue}if(Z>=0&&Z<=31)if(p(Z)){ne+=n.substring(he,o),S=2;break}else S=6;o++}return ne}function ee(){if(t="",S=0,a=o,o>=s)return a=s,f=17;let ne=n.charCodeAt(o);if(C(ne)){do o++,t+=String.fromCharCode(ne),ne=n.charCodeAt(o);while(C(ne));return f=15}if(p(ne))return o++,t+=String.fromCharCode(ne),ne===13&&n.charCodeAt(o)===10&&(o++,t+=`
`),f=14;switch(ne){case 123:return o++,f=1;case 125:return o++,f=2;case 91:return o++,f=3;case 93:return o++,f=4;case 58:return o++,f=6;case 44:return o++,f=5;case 34:return o++,t=M(),f=10;case 47:{const he=o-1;if(n.charCodeAt(o+1)===47){for(o+=2;o<s&&!p(n.charCodeAt(o));)o++;return t=n.substring(he,o),f=12}if(n.charCodeAt(o+1)===42){o+=2;const Z=s-1;let fe=!1;for(;o<Z;){if(n.charCodeAt(o)===42&&n.charCodeAt(o+1)===47){o+=2,fe=!0;break}o++}return fe||(o++,S=1),t=n.substring(he,o),f=13}return t+=String.fromCharCode(ne),o++,f=16}case 45:if(t+=String.fromCharCode(ne),o++,o===s||!w(n.charCodeAt(o)))return f=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return t+=P(),f=11;default:for(;o<s&&se(ne);)o++,ne=n.charCodeAt(o);if(a!==o){switch(t=n.substring(a,o),t){case"true":return f=8;case"false":return f=9;case"null":return f=7}return f=16}return t+=String.fromCharCode(ne),o++,f=16}}function se(ne){if(C(ne)||p(ne))return!1;switch(ne){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function G(){let ne;do ne=ee();while(ne>=12&&ne<=15);return ne}return{setPosition:E,getPosition:()=>o,scan:i?G:ee,getToken:()=>f,getTokenValue:()=>t,getTokenOffset:()=>a,getTokenLength:()=>o-a,getTokenError:()=>S}}e.$Wm=I;function C(n){return n===32||n===9||n===11||n===12||n===160||n===5760||n>=8192&&n<=8203||n===8239||n===8287||n===12288||n===65279}function p(n){return n===10||n===13||n===8232||n===8233}function w(n){return n>=48&&n<=57}var A;(function(n){n[n.nullCharacter=0]="nullCharacter",n[n.maxAsciiCharacter=127]="maxAsciiCharacter",n[n.lineFeed=10]="lineFeed",n[n.carriageReturn=13]="carriageReturn",n[n.lineSeparator=8232]="lineSeparator",n[n.paragraphSeparator=8233]="paragraphSeparator",n[n.nextLine=133]="nextLine",n[n.space=32]="space",n[n.nonBreakingSpace=160]="nonBreakingSpace",n[n.enQuad=8192]="enQuad",n[n.emQuad=8193]="emQuad",n[n.enSpace=8194]="enSpace",n[n.emSpace=8195]="emSpace",n[n.threePerEmSpace=8196]="threePerEmSpace",n[n.fourPerEmSpace=8197]="fourPerEmSpace",n[n.sixPerEmSpace=8198]="sixPerEmSpace",n[n.figureSpace=8199]="figureSpace",n[n.punctuationSpace=8200]="punctuationSpace",n[n.thinSpace=8201]="thinSpace",n[n.hairSpace=8202]="hairSpace",n[n.zeroWidthSpace=8203]="zeroWidthSpace",n[n.narrowNoBreakSpace=8239]="narrowNoBreakSpace",n[n.ideographicSpace=12288]="ideographicSpace",n[n.mathematicalSpace=8287]="mathematicalSpace",n[n.ogham=5760]="ogham",n[n._=95]="_",n[n.$=36]="$",n[n._0=48]="_0",n[n._1=49]="_1",n[n._2=50]="_2",n[n._3=51]="_3",n[n._4=52]="_4",n[n._5=53]="_5",n[n._6=54]="_6",n[n._7=55]="_7",n[n._8=56]="_8",n[n._9=57]="_9",n[n.a=97]="a",n[n.b=98]="b",n[n.c=99]="c",n[n.d=100]="d",n[n.e=101]="e",n[n.f=102]="f",n[n.g=103]="g",n[n.h=104]="h",n[n.i=105]="i",n[n.j=106]="j",n[n.k=107]="k",n[n.l=108]="l",n[n.m=109]="m",n[n.n=110]="n",n[n.o=111]="o",n[n.p=112]="p",n[n.q=113]="q",n[n.r=114]="r",n[n.s=115]="s",n[n.t=116]="t",n[n.u=117]="u",n[n.v=118]="v",n[n.w=119]="w",n[n.x=120]="x",n[n.y=121]="y",n[n.z=122]="z",n[n.A=65]="A",n[n.B=66]="B",n[n.C=67]="C",n[n.D=68]="D",n[n.E=69]="E",n[n.F=70]="F",n[n.G=71]="G",n[n.H=72]="H",n[n.I=73]="I",n[n.J=74]="J",n[n.K=75]="K",n[n.L=76]="L",n[n.M=77]="M",n[n.N=78]="N",n[n.O=79]="O",n[n.P=80]="P",n[n.Q=81]="Q",n[n.R=82]="R",n[n.S=83]="S",n[n.T=84]="T",n[n.U=85]="U",n[n.V=86]="V",n[n.W=87]="W",n[n.X=88]="X",n[n.Y=89]="Y",n[n.Z=90]="Z",n[n.ampersand=38]="ampersand",n[n.asterisk=42]="asterisk",n[n.at=64]="at",n[n.backslash=92]="backslash",n[n.bar=124]="bar",n[n.caret=94]="caret",n[n.closeBrace=125]="closeBrace",n[n.closeBracket=93]="closeBracket",n[n.closeParen=41]="closeParen",n[n.colon=58]="colon",n[n.comma=44]="comma",n[n.dot=46]="dot",n[n.doubleQuote=34]="doubleQuote",n[n.equals=61]="equals",n[n.exclamation=33]="exclamation",n[n.greaterThan=62]="greaterThan",n[n.lessThan=60]="lessThan",n[n.minus=45]="minus",n[n.openBrace=123]="openBrace",n[n.openBracket=91]="openBracket",n[n.openParen=40]="openParen",n[n.percent=37]="percent",n[n.plus=43]="plus",n[n.question=63]="question",n[n.semicolon=59]="semicolon",n[n.singleQuote=39]="singleQuote",n[n.slash=47]="slash",n[n.tilde=126]="tilde",n[n.backspace=8]="backspace",n[n.formFeed=12]="formFeed",n[n.byteOrderMark=65279]="byteOrderMark",n[n.tab=9]="tab",n[n.verticalTab=11]="verticalTab"})(A||(A={}));function k(n,i){const o=[],s=new Object;let t;const a={value:{},offset:0,length:0,type:"object",parent:void 0};let f=!1;function S(D,E,P,M){a.value=D,a.offset=E,a.length=P,a.type=M,a.colonOffset=void 0,t=a}try{l(n,{onObjectBegin:(D,E)=>{if(i<=D)throw s;t=void 0,f=i>D,o.push("")},onObjectProperty:(D,E,P)=>{if(i<E||(S(D,E,P,"property"),o[o.length-1]=D,i<=E+P))throw s},onObjectEnd:(D,E)=>{if(i<=D)throw s;t=void 0,o.pop()},onArrayBegin:(D,E)=>{if(i<=D)throw s;t=void 0,o.push(0)},onArrayEnd:(D,E)=>{if(i<=D)throw s;t=void 0,o.pop()},onLiteralValue:(D,E,P)=>{if(i<E||(S(D,E,P,c(D)),i<=E+P))throw s},onSeparator:(D,E,P)=>{if(i<=E)throw s;if(D===":"&&t&&t.type==="property")t.colonOffset=E,f=!1,t=void 0;else if(D===","){const M=o[o.length-1];typeof M=="number"?o[o.length-1]=M+1:(f=!0,o[o.length-1]=""),t=void 0}}})}catch(D){if(D!==s)throw D}return{path:o,previousNode:t,isAtPropertyKey:f,matches:D=>{let E=0;for(let P=0;E<D.length&&P<o.length;P++)if(D[E]===o[P]||D[E]==="*")E++;else if(D[E]!=="**")return!1;return E===D.length}}}e.$Xm=k;function v(n,i=[],o=L.DEFAULT){let s=null,t=[];const a=[];function f(D){Array.isArray(t)?t.push(D):s!==null&&(t[s]=D)}return l(n,{onObjectBegin:()=>{const D={};f(D),a.push(t),t=D,s=null},onObjectProperty:D=>{s=D},onObjectEnd:()=>{t=a.pop()},onArrayBegin:()=>{const D=[];f(D),a.push(t),t=D,s=null},onArrayEnd:()=>{t=a.pop()},onLiteralValue:f,onError:(D,E,P)=>{i.push({error:D,offset:E,length:P})}},o),t[0]}e.$Ym=v;function u(n,i=[],o=L.DEFAULT){let s={type:"array",offset:-1,length:-1,children:[],parent:void 0};function t(D){s.type==="property"&&(s.length=D-s.offset,s=s.parent)}function a(D){return s.children.push(D),D}l(n,{onObjectBegin:D=>{s=a({type:"object",offset:D,length:-1,parent:s,children:[]})},onObjectProperty:(D,E,P)=>{s=a({type:"property",offset:E,length:-1,parent:s,children:[]}),s.children.push({type:"string",value:D,offset:E,length:P,parent:s})},onObjectEnd:(D,E)=>{s.length=D+E-s.offset,s=s.parent,t(D+E)},onArrayBegin:(D,E)=>{s=a({type:"array",offset:D,length:-1,parent:s,children:[]})},onArrayEnd:(D,E)=>{s.length=D+E-s.offset,s=s.parent,t(D+E)},onLiteralValue:(D,E,P)=>{a({type:c(D),offset:E,length:P,parent:s,value:D}),t(E+P)},onSeparator:(D,E,P)=>{s.type==="property"&&(D===":"?s.colonOffset=E:D===","&&t(E))},onError:(D,E,P)=>{i.push({error:D,offset:E,length:P})}},o);const S=s.children[0];return S&&delete S.parent,S}e.$Zm=u;function b(n,i){if(!n)return;let o=n;for(const s of i)if(typeof s=="string"){if(o.type!=="object"||!Array.isArray(o.children))return;let t=!1;for(const a of o.children)if(Array.isArray(a.children)&&a.children[0].value===s){o=a.children[1],t=!0;break}if(!t)return}else{const t=s;if(o.type!=="array"||t<0||!Array.isArray(o.children)||t>=o.children.length)return;o=o.children[t]}return o}e.$1m=b;function m(n){if(!n.parent||!n.parent.children)return[];const i=m(n.parent);if(n.parent.type==="property"){const o=n.parent.children[0].value;i.push(o)}else if(n.parent.type==="array"){const o=n.parent.children.indexOf(n);o!==-1&&i.push(o)}return i}e.$2m=m;function d(n){switch(n.type){case"array":return n.children.map(d);case"object":{const i=Object.create(null);for(const o of n.children){const s=o.children[1];s&&(i[o.children[0].value]=d(s))}return i}case"null":case"string":case"number":case"boolean":return n.value;default:return}}e.$3m=d;function h(n,i,o=!1){return i>=n.offset&&i<n.offset+n.length||o&&i===n.offset+n.length}e.$4m=h;function g(n,i,o=!1){if(h(n,i,o)){const s=n.children;if(Array.isArray(s))for(let t=0;t<s.length&&s[t].offset<=i;t++){const a=g(s[t],i,o);if(a)return a}return n}}e.$5m=g;function l(n,i,o=L.DEFAULT){const s=I(n,!1);function t(oe){return oe?()=>oe(s.getTokenOffset(),s.getTokenLength()):()=>!0}function a(oe){return oe?_=>oe(_,s.getTokenOffset(),s.getTokenLength()):()=>!0}const f=t(i.onObjectBegin),S=a(i.onObjectProperty),D=t(i.onObjectEnd),E=t(i.onArrayBegin),P=t(i.onArrayEnd),M=a(i.onLiteralValue),ee=a(i.onSeparator),se=t(i.onComment),G=a(i.onError),ne=o&&o.disallowComments,he=o&&o.allowTrailingComma;function Z(){for(;;){const oe=s.scan();switch(s.getTokenError()){case 4:fe(14);break;case 5:fe(15);break;case 3:fe(13);break;case 1:ne||fe(11);break;case 2:fe(12);break;case 6:fe(16);break}switch(oe){case 12:case 13:ne?fe(10):se();break;case 16:fe(1);break;case 15:case 14:break;default:return oe}}}function fe(oe,_=[],q=[]){if(G(oe),_.length+q.length>0){let Q=s.getToken();for(;Q!==17;){if(_.indexOf(Q)!==-1){Z();break}else if(q.indexOf(Q)!==-1)break;Q=Z()}}}function V(oe){const _=s.getTokenValue();return oe?M(_):S(_),Z(),!0}function ie(){switch(s.getToken()){case 11:{let oe=0;try{oe=JSON.parse(s.getTokenValue()),typeof oe!="number"&&(fe(2),oe=0)}catch{fe(2)}M(oe);break}case 7:M(null);break;case 8:M(!0);break;case 9:M(!1);break;default:return!1}return Z(),!0}function Y(){return s.getToken()!==10?(fe(3,[],[2,5]),!1):(V(!1),s.getToken()===6?(ee(":"),Z(),ce()||fe(4,[],[2,5])):fe(5,[],[2,5]),!0)}function J(){f(),Z();let oe=!1;for(;s.getToken()!==2&&s.getToken()!==17;){if(s.getToken()===5){if(oe||fe(4,[],[]),ee(","),Z(),s.getToken()===2&&he)break}else oe&&fe(6,[],[]);Y()||fe(4,[],[2,5]),oe=!0}return D(),s.getToken()!==2?fe(7,[2],[]):Z(),!0}function re(){E(),Z();let oe=!1;for(;s.getToken()!==4&&s.getToken()!==17;){if(s.getToken()===5){if(oe||fe(4,[],[]),ee(","),Z(),s.getToken()===4&&he)break}else oe&&fe(6,[],[]);ce()||fe(4,[],[4,5]),oe=!0}return P(),s.getToken()!==4?fe(8,[4],[]):Z(),!0}function ce(){switch(s.getToken()){case 3:return re();case 1:return J();case 10:return V(!0);default:return ie()}}return Z(),s.getToken()===17?o.allowEmptyContent?!0:(fe(4,[],[]),!1):ce()?(s.getToken()!==17&&fe(9,[],[]),!0):(fe(4,[],[]),!1)}e.$6m=l;function $(n,i){const o=I(n),s=[];let t,a=0,f;do switch(f=o.getPosition(),t=o.scan(),t){case 12:case 13:case 17:a!==f&&s.push(n.substring(a,f)),i!==void 0&&s.push(o.getTokenValue().replace(/[^\r\n]/g,i)),a=o.getPosition();break}while(t!==17);return s.join("")}e.$7m=$;function c(n){switch(typeof n){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(n){if(Array.isArray(n))return"array"}else return"null";return"object"}default:return"null"}}e.$8m=c}),define(be[76],we([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V=void 0;class y{constructor(r){this.d=r,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(r){this.c=r}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$V=y}),define(be[97],we([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2c=void 0;class y{constructor(L){this.element=L,this.next=y.Undefined,this.prev=y.Undefined}}y.Undefined=new y(void 0);class R{constructor(){this.a=y.Undefined,this.b=y.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===y.Undefined}clear(){let L=this.a;for(;L!==y.Undefined;){const I=L.next;L.prev=y.Undefined,L.next=y.Undefined,L=I}this.a=y.Undefined,this.b=y.Undefined,this.c=0}unshift(L){return this.d(L,!1)}push(L){return this.d(L,!0)}d(L,I){const C=new y(L);if(this.a===y.Undefined)this.a=C,this.b=C;else if(I){const w=this.b;this.b=C,C.prev=w,w.next=C}else{const w=this.a;this.a=C,C.next=w,w.prev=C}this.c+=1;let p=!1;return()=>{p||(p=!0,this.e(C))}}shift(){if(this.a!==y.Undefined){const L=this.a.element;return this.e(this.a),L}}pop(){if(this.b!==y.Undefined){const L=this.b.element;return this.e(this.b),L}}e(L){if(L.prev!==y.Undefined&&L.next!==y.Undefined){const I=L.prev;I.next=L.next,L.next.prev=I}else L.prev===y.Undefined&&L.next===y.Undefined?(this.a=y.Undefined,this.b=y.Undefined):L.next===y.Undefined?(this.b=this.b.prev,this.b.next=y.Undefined):L.prev===y.Undefined&&(this.a=this.a.next,this.a.prev=y.Undefined);this.c-=1}*[Symbol.iterator](){let L=this.a;for(;L!==y.Undefined;)yield L.element,L=L.next}}e.$2c=R}),define(be[26],we([1,0]),function(ue,e){"use strict";var y,R,r;Object.defineProperty(e,"__esModule",{value:!0}),e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.$Cc=e.Touch=e.$Bc=e.$Ac=e.$zc=e.$yc=e.$xc=void 0;function L(g,l,$){let c=g.get(l);return c===void 0&&(c=$,g.set(l,c)),c}e.$xc=L;function I(g){const l=[];return g.forEach(($,c)=>{l.push(`${c} => ${$}`)}),`Map(${g.size}) {${l.join(", ")}}`}e.$yc=I;function C(g){const l=[];return g.forEach($=>{l.push($)}),`Set(${g.size}) {${l.join(", ")}}`}e.$zc=C;class p{constructor(l,$){this.uri=l,this.value=$}}function w(g){return Array.isArray(g)}class A{constructor(l,$){if(this[y]="ResourceMap",l instanceof A)this.b=new Map(l.b),this.c=$??A.a;else if(w(l)){this.b=new Map,this.c=$??A.a;for(const[c,n]of l)this.set(c,n)}else this.b=new Map,this.c=l??A.a}set(l,$){return this.b.set(this.c(l),new p(l,$)),this}get(l){return this.b.get(this.c(l))?.value}has(l){return this.b.has(this.c(l))}get size(){return this.b.size}clear(){this.b.clear()}delete(l){return this.b.delete(this.c(l))}forEach(l,$){typeof $<"u"&&(l=l.bind($));for(const[c,n]of this.b)l(n.value,n.uri,this)}*values(){for(const l of this.b.values())yield l.value}*keys(){for(const l of this.b.values())yield l.uri}*entries(){for(const l of this.b.values())yield[l.uri,l.value]}*[(y=Symbol.toStringTag,Symbol.iterator)](){for(const[,l]of this.b)yield[l.uri,l.value]}}e.$Ac=A,A.a=g=>g.toString();class k{constructor(l,$){this[R]="ResourceSet",!l||typeof l=="function"?this.a=new A(l):(this.a=new A($),l.forEach(this.add,this))}get size(){return this.a.size}add(l){return this.a.set(l,l),this}clear(){this.a.clear()}delete(l){return this.a.delete(l)}forEach(l,$){this.a.forEach((c,n)=>l.call($,n,n,this))}has(l){return this.a.has(l)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(R=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Bc=k;var v;(function(g){g[g.None=0]="None",g[g.AsOld=1]="AsOld",g[g.AsNew=2]="AsNew"})(v||(e.Touch=v={}));class u{constructor(){this[r]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(l){return this.a.has(l)}get(l,$=0){const c=this.a.get(l);if(c)return $!==0&&this.j(c,$),c.value}set(l,$,c=0){let n=this.a.get(l);if(n)n.value=$,c!==0&&this.j(n,c);else{switch(n={key:l,value:$,next:void 0,previous:void 0},c){case 0:this.h(n);break;case 1:this.g(n);break;case 2:this.h(n);break;default:this.h(n);break}this.a.set(l,n),this.d++}return this}delete(l){return!!this.remove(l)}remove(l){const $=this.a.get(l);if($)return this.a.delete(l),this.i($),this.d--,$.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const l=this.b;return this.a.delete(l.key),this.i(l),this.d--,l.value}forEach(l,$){const c=this.e;let n=this.b;for(;n;){if($?l.bind($)(n.value,n.key,this):l(n.value,n.key,this),this.e!==c)throw new Error("LinkedMap got modified during iteration.");n=n.next}}keys(){const l=this,$=this.e;let c=this.b;const n={[Symbol.iterator](){return n},next(){if(l.e!==$)throw new Error("LinkedMap got modified during iteration.");if(c){const i={value:c.key,done:!1};return c=c.next,i}else return{value:void 0,done:!0}}};return n}values(){const l=this,$=this.e;let c=this.b;const n={[Symbol.iterator](){return n},next(){if(l.e!==$)throw new Error("LinkedMap got modified during iteration.");if(c){const i={value:c.value,done:!1};return c=c.next,i}else return{value:void 0,done:!0}}};return n}entries(){const l=this,$=this.e;let c=this.b;const n={[Symbol.iterator](){return n},next(){if(l.e!==$)throw new Error("LinkedMap got modified during iteration.");if(c){const i={value:[c.key,c.value],done:!1};return c=c.next,i}else return{value:void 0,done:!0}}};return n}[(r=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(l){if(l>=this.size)return;if(l===0){this.clear();return}let $=this.b,c=this.size;for(;$&&c>l;)this.a.delete($.key),$=$.next,c--;this.b=$,this.d=c,$&&($.previous=void 0),this.e++}g(l){if(!this.b&&!this.c)this.c=l;else if(this.b)l.next=this.b,this.b.previous=l;else throw new Error("Invalid list");this.b=l,this.e++}h(l){if(!this.b&&!this.c)this.b=l;else if(this.c)l.previous=this.c,this.c.next=l;else throw new Error("Invalid list");this.c=l,this.e++}i(l){if(l===this.b&&l===this.c)this.b=void 0,this.c=void 0;else if(l===this.b){if(!l.next)throw new Error("Invalid list");l.next.previous=void 0,this.b=l.next}else if(l===this.c){if(!l.previous)throw new Error("Invalid list");l.previous.next=void 0,this.c=l.previous}else{const $=l.next,c=l.previous;if(!$||!c)throw new Error("Invalid list");$.previous=c,c.next=$}l.next=void 0,l.previous=void 0,this.e++}j(l,$){if(!this.b||!this.c)throw new Error("Invalid list");if(!($!==1&&$!==2)){if($===1){if(l===this.b)return;const c=l.next,n=l.previous;l===this.c?(n.next=void 0,this.c=n):(c.previous=n,n.next=c),l.previous=void 0,l.next=this.b,this.b.previous=l,this.b=l,this.e++}else if($===2){if(l===this.c)return;const c=l.next,n=l.previous;l===this.b?(c.previous=void 0,this.b=c):(c.previous=n,n.next=c),l.next=void 0,l.previous=this.c,this.c.next=l,this.c=l,this.e++}}}toJSON(){const l=[];return this.forEach(($,c)=>{l.push([c,$])}),l}fromJSON(l){this.clear();for(const[$,c]of l)this.set($,c)}}e.$Cc=u;class b extends u{constructor(l,$=1){super(),this.k=l,this.l=Math.min(Math.max(0,$),1)}get limit(){return this.k}set limit(l){this.k=l,this.m()}get ratio(){return this.l}set ratio(l){this.l=Math.min(Math.max(0,l),1),this.m()}get(l,$=2){return super.get(l,$)}peek(l){return super.get(l,0)}set(l,$){return super.set(l,$,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.$Dc=b;class m{constructor(){this.a=new Map}add(l){return this.a.set(l,(this.a.get(l)||0)+1),this}delete(l){let $=this.a.get(l)||0;return $===0?!1:($--,$===0?this.a.delete(l):this.a.set(l,$),!0)}has(l){return this.a.has(l)}}e.$Ec=m;class d{constructor(l){if(this.a=new Map,this.b=new Map,l)for(const[$,c]of l)this.set($,c)}clear(){this.a.clear(),this.b.clear()}set(l,$){this.a.set(l,$),this.b.set($,l)}get(l){return this.a.get(l)}getKey(l){return this.b.get(l)}delete(l){const $=this.a.get(l);return $===void 0?!1:(this.a.delete(l),this.b.delete($),!0)}forEach(l,$){this.a.forEach((c,n)=>{l.call($,c,n,this)})}keys(){return this.a.keys()}values(){return this.a.values()}}e.$Fc=d;class h{constructor(){this.a=new Map}add(l,$){let c=this.a.get(l);c||(c=new Set,this.a.set(l,c)),c.add($)}delete(l,$){const c=this.a.get(l);c&&(c.delete($),c.size===0&&this.a.delete(l))}forEach(l,$){const c=this.a.get(l);c&&c.forEach($)}get(l){const $=this.a.get(l);return $||new Set}}e.$Gc=h}),define(be[2],we([1,0,18,142,26,74,47]),function(ue,e,y,R,r,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Sc=e.$Rc=e.$Qc=e.$Pc=e.$Oc=e.$Nc=e.$Mc=e.$Lc=e.$Kc=e.$Jc=e.$Ic=e.$Hc=void 0;const C=!1;let p=null;class w{constructor(){this.b=new Map}c(P){let M=this.b.get(P);return M||(M={parent:null,source:null,isSingleton:!1,value:P,idx:w.a++},this.b.set(P,M)),M}trackDisposable(P){const M=this.c(P);M.source||(M.source=new Error().stack)}setParent(P,M){const ee=this.c(P);ee.parent=M}markAsDisposed(P){this.b.delete(P)}markAsSingleton(P){this.c(P).isSingleton=!0}f(P,M){const ee=M.get(P);if(ee)return ee;const se=P.parent?this.f(this.c(P.parent),M):P;return M.set(P,se),se}getTrackedDisposables(){const P=new Map;return[...this.b.entries()].filter(([,ee])=>ee.source!==null&&!this.f(ee,P).isSingleton).flatMap(([ee])=>ee)}computeLeakingDisposables(P=10,M){let ee;if(M)ee=M;else{const Z=new Map,fe=[...this.b.values()].filter(ie=>ie.source!==null&&!this.f(ie,Z).isSingleton);if(fe.length===0)return;const V=new Set(fe.map(ie=>ie.value));if(ee=fe.filter(ie=>!(ie.parent&&V.has(ie.parent))),ee.length===0)throw new Error("There are cyclic diposable chains!")}if(!ee)return;function se(Z){function fe(ie,Y){for(;ie.length>0&&Y.some(J=>typeof J=="string"?J===ie[0]:ie[0].match(J));)ie.shift()}const V=Z.source.split(`
`).map(ie=>ie.trim().replace("at ","")).filter(ie=>ie!=="");return fe(V,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),V.reverse()}const G=new r.$Gc;for(const Z of ee){const fe=se(Z);for(let V=0;V<=fe.length;V++)G.add(fe.slice(0,V).join(`
`),Z)}ee.sort((0,y.$7b)(Z=>Z.idx,y.$9b));let ne="",he=0;for(const Z of ee.slice(0,P)){he++;const fe=se(Z),V=[];for(let ie=0;ie<fe.length;ie++){let Y=fe[ie];Y=`(shared with ${G.get(fe.slice(0,ie+1).join(`
`)).size}/${ee.length} leaks) at ${Y}`;const re=G.get(fe.slice(0,ie).join(`
`)),ce=(0,R.$D)([...re].map(oe=>se(oe)[ie]),oe=>oe);delete ce[fe[ie]];for(const[oe,_]of Object.entries(ce))V.unshift(`    - stacktraces of ${_.length} other leaks continue with ${oe}`);V.unshift(Y)}ne+=`


==================== Leaking disposable ${he}/${ee.length}: ${Z.value.constructor.name} ====================
${V.join(`
`)}
============================================================

`}return ee.length>P&&(ne+=`


... and ${ee.length-P} more leaking disposables

`),{leaks:ee,details:ne}}}e.$Hc=w,w.a=0;function A(E){p=E}if(e.$Ic=A,C){const E="__is_disposable_tracked__";A(new class{trackDisposable(P){const M=new Error("Potentially leaked disposable").stack;setTimeout(()=>{P[E]||console.log(M)},3e3)}setParent(P,M){if(P&&P!==n.None)try{P[E]=!0}catch{}}markAsDisposed(P){if(P&&P!==n.None)try{P[E]=!0}catch{}}markAsSingleton(P){}})}function k(E){return p?.trackDisposable(E),E}e.$Jc=k;function v(E){p?.markAsDisposed(E)}e.$Kc=v;function u(E,P){p?.setParent(E,P)}function b(E,P){if(p)for(const M of E)p.setParent(M,P)}function m(E){return p?.markAsSingleton(E),E}e.$Lc=m;function d(E){return typeof E.dispose=="function"&&E.dispose.length===0}e.$Mc=d;function h(E){if(I.Iterable.is(E)){const P=[];for(const M of E)if(M)try{M.dispose()}catch(ee){P.push(ee)}if(P.length===1)throw P[0];if(P.length>1)throw new AggregateError(P,"Encountered errors while disposing of store");return Array.isArray(E)?[]:E}else if(E)return E.dispose(),E}e.$Nc=h;function g(E){for(const P of E)d(P)&&P.dispose();return[]}e.$Oc=g;function l(...E){const P=$(()=>h(E));return b(E,P),P}e.$Pc=l;function $(E){const P=k({dispose:(0,L.$db)(()=>{v(P),E()})});return P}e.$Qc=$;class c{constructor(){this.f=new Set,this.g=!1,k(this)}dispose(){this.g||(v(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{h(this.f)}finally{this.f.clear()}}add(P){if(!P)return P;if(P===this)throw new Error("Cannot register a disposable on itself!");return u(P,this),this.g?c.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(P),P}delete(P){if(P){if(P===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(P),P.dispose()}}deleteAndLeak(P){P&&this.f.has(P)&&(this.f.delete(P),u(P,null))}}e.$Rc=c,c.DISABLE_DISPOSED_WARNING=!1;class n{constructor(){this.q=new c,k(this),u(this.q,this)}dispose(){v(this),this.q.dispose()}B(P){if(P===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(P)}}e.$Sc=n,n.None=Object.freeze({dispose(){}});class i{constructor(){this.b=!1,k(this)}get value(){return this.b?void 0:this.a}set value(P){this.b||P===this.a||(this.a?.dispose(),P&&u(P,this),this.a=P)}clear(){this.value=void 0}dispose(){this.b=!0,v(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const P=this.a;return this.a=void 0,P&&u(P,null),P}}e.$Tc=i;class o{constructor(P){this.b=P,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Uc=o;class s{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,k(this)}set(P){let M=P;return this.unset=()=>M=void 0,this.isset=()=>M!==void 0,this.dispose=()=>{M&&(M(),M=void 0,v(this))},this}}e.$Vc=s;class t{constructor(){this.a=new Map}acquire(P,...M){let ee=this.a.get(P);ee||(ee={counter:0,object:this.b(P,...M)},this.a.set(P,ee));const{object:se}=ee,G=(0,L.$db)(()=>{--ee.counter===0&&(this.c(P,ee.object),this.a.delete(P))});return ee.counter++,{object:se,dispose:G}}}e.$Wc=t;class a{constructor(P){this.a=P}async acquire(P,...M){const ee=this.a.acquire(P,...M);try{return{object:await ee.object,dispose:()=>ee.dispose()}}catch(se){throw ee.dispose(),se}}}e.$Xc=a;class f{constructor(P){this.object=P}dispose(){}}e.$Yc=f;function S(E){const P=new c;try{E(P)}finally{P.dispose()}}e.$Zc=S;class D{constructor(){this.a=new Map,this.b=!1,k(this)}dispose(){v(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{h(this.a.values())}finally{this.a.clear()}}has(P){return this.a.has(P)}get size(){return this.a.size}get(P){return this.a.get(P)}set(P,M,ee=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),ee||this.a.get(P)?.dispose(),this.a.set(P,M)}deleteAndDispose(P){this.a.get(P)?.dispose(),this.a.delete(P)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$1c=D}),function(ue,e){typeof define=="function"&&define.amd?define(be[143],we([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(ue=typeof globalThis<"u"?globalThis:ue||self,e(ue.marked={}))}(this,function(ue){"use strict";function e(z,B){for(var te=0;te<B.length;te++){var H=B[te];H.enumerable=H.enumerable||!1,H.configurable=!0,"value"in H&&(H.writable=!0),Object.defineProperty(z,H.key,H)}}function y(z,B,te){return B&&e(z.prototype,B),te&&e(z,te),Object.defineProperty(z,"prototype",{writable:!1}),z}function R(z,B){if(z){if(typeof z=="string")return r(z,B);var te=Object.prototype.toString.call(z).slice(8,-1);if(te==="Object"&&z.constructor&&(te=z.constructor.name),te==="Map"||te==="Set")return Array.from(z);if(te==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(te))return r(z,B)}}function r(z,B){(B==null||B>z.length)&&(B=z.length);for(var te=0,H=new Array(B);te<B;te++)H[te]=z[te];return H}function L(z,B){var te=typeof Symbol<"u"&&z[Symbol.iterator]||z["@@iterator"];if(te)return(te=te.call(z)).next.bind(te);if(Array.isArray(z)||(te=R(z))||B&&z&&typeof z.length=="number"){te&&(z=te);var H=0;return function(){return H>=z.length?{done:!0}:{done:!1,value:z[H++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function I(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}ue.defaults=I();function C(z){ue.defaults=z}var p=/[&<>"']/,w=/[&<>"']/g,A=/[<>"']|&(?!#?\w+;)/,k=/[<>"']|&(?!#?\w+;)/g,v={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},u=function(B){return v[B]};function b(z,B){if(B){if(p.test(z))return z.replace(w,u)}else if(A.test(z))return z.replace(k,u);return z}var m=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function d(z){return z.replace(m,function(B,te){return te=te.toLowerCase(),te==="colon"?":":te.charAt(0)==="#"?te.charAt(1)==="x"?String.fromCharCode(parseInt(te.substring(2),16)):String.fromCharCode(+te.substring(1)):""})}var h=/(^|[^\[])\^/g;function g(z,B){z=typeof z=="string"?z:z.source,B=B||"";var te={replace:function(x,W){return W=W.source||W,W=W.replace(h,"$1"),z=z.replace(x,W),te},getRegex:function(){return new RegExp(z,B)}};return te}var l=/[^\w:]/g,$=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function c(z,B,te){if(z){var H;try{H=decodeURIComponent(d(te)).replace(l,"").toLowerCase()}catch{return null}if(H.indexOf("javascript:")===0||H.indexOf("vbscript:")===0||H.indexOf("data:")===0)return null}B&&!$.test(te)&&(te=t(B,te));try{te=encodeURI(te).replace(/%25/g,"%")}catch{return null}return te}var n={},i=/^[^:]+:\/*[^/]*$/,o=/^([^:]+:)[\s\S]*$/,s=/^([^:]+:\/*[^/]*)[\s\S]*$/;function t(z,B){n[" "+z]||(i.test(z)?n[" "+z]=z+"/":n[" "+z]=D(z,"/",!0)),z=n[" "+z];var te=z.indexOf(":")===-1;return B.substring(0,2)==="//"?te?B:z.replace(o,"$1")+B:B.charAt(0)==="/"?te?B:z.replace(s,"$1")+B:z+B}var a={exec:function(){}};function f(z){for(var B=1,te,H;B<arguments.length;B++){te=arguments[B];for(H in te)Object.prototype.hasOwnProperty.call(te,H)&&(z[H]=te[H])}return z}function S(z,B){var te=z.replace(/\|/g,function(W,X,ae){for(var ge=!1,Ee=X;--Ee>=0&&ae[Ee]==="\\";)ge=!ge;return ge?"|":" |"}),H=te.split(/ \|/),x=0;if(H[0].trim()||H.shift(),H.length>0&&!H[H.length-1].trim()&&H.pop(),H.length>B)H.splice(B);else for(;H.length<B;)H.push("");for(;x<H.length;x++)H[x]=H[x].trim().replace(/\\\|/g,"|");return H}function D(z,B,te){var H=z.length;if(H===0)return"";for(var x=0;x<H;){var W=z.charAt(H-x-1);if(W===B&&!te)x++;else if(W!==B&&te)x++;else break}return z.slice(0,H-x)}function E(z,B){if(z.indexOf(B[1])===-1)return-1;for(var te=z.length,H=0,x=0;x<te;x++)if(z[x]==="\\")x++;else if(z[x]===B[0])H++;else if(z[x]===B[1]&&(H--,H<0))return x;return-1}function P(z){z&&z.sanitize&&!z.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function M(z,B){if(B<1)return"";for(var te="";B>1;)B&1&&(te+=z),B>>=1,z+=z;return te+z}function ee(z,B,te,H){var x=B.href,W=B.title?b(B.title):null,X=z[1].replace(/\\([\[\]])/g,"$1");if(z[0].charAt(0)!=="!"){H.state.inLink=!0;var ae={type:"link",raw:te,href:x,title:W,text:X,tokens:H.inlineTokens(X)};return H.state.inLink=!1,ae}return{type:"image",raw:te,href:x,title:W,text:b(X)}}function se(z,B){var te=z.match(/^(\s+)(?:```)/);if(te===null)return B;var H=te[1];return B.split(`
`).map(function(x){var W=x.match(/^\s+/);if(W===null)return x;var X=W[0];return X.length>=H.length?x.slice(H.length):x}).join(`
`)}var G=function(){function z(te){this.options=te||ue.defaults}var B=z.prototype;return B.space=function(H){var x=this.rules.block.newline.exec(H);if(x&&x[0].length>0)return{type:"space",raw:x[0]}},B.code=function(H){var x=this.rules.block.code.exec(H);if(x){var W=x[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:x[0],codeBlockStyle:"indented",text:this.options.pedantic?W:D(W,`
`)}}},B.fences=function(H){var x=this.rules.block.fences.exec(H);if(x){var W=x[0],X=se(W,x[3]||"");return{type:"code",raw:W,lang:x[2]?x[2].trim():x[2],text:X}}},B.heading=function(H){var x=this.rules.block.heading.exec(H);if(x){var W=x[2].trim();if(/#$/.test(W)){var X=D(W,"#");(this.options.pedantic||!X||/ $/.test(X))&&(W=X.trim())}return{type:"heading",raw:x[0],depth:x[1].length,text:W,tokens:this.lexer.inline(W)}}},B.hr=function(H){var x=this.rules.block.hr.exec(H);if(x)return{type:"hr",raw:x[0]}},B.blockquote=function(H){var x=this.rules.block.blockquote.exec(H);if(x){var W=x[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:x[0],tokens:this.lexer.blockTokens(W,[]),text:W}}},B.list=function(H){var x=this.rules.block.list.exec(H);if(x){var W,X,ae,ge,Ee,Ce,Ne,Fe,$e,ke,ve,je,Be=x[1].trim(),Ze=Be.length>1,qe={type:"list",raw:"",ordered:Ze,start:Ze?+Be.slice(0,-1):"",loose:!1,items:[]};Be=Ze?"\\d{1,9}\\"+Be.slice(-1):"\\"+Be,this.options.pedantic&&(Be=Ze?Be:"[*+-]");for(var Qe=new RegExp("^( {0,3}"+Be+")((?:[	 ][^\\n]*)?(?:\\n|$))");H&&(je=!1,!(!(x=Qe.exec(H))||this.rules.block.hr.test(H)));){if(W=x[0],H=H.substring(W.length),Fe=x[2].split(`
`,1)[0],$e=H.split(`
`,1)[0],this.options.pedantic?(ge=2,ve=Fe.trimLeft()):(ge=x[2].search(/[^ ]/),ge=ge>4?1:ge,ve=Fe.slice(ge),ge+=x[1].length),Ce=!1,!Fe&&/^ *$/.test($e)&&(W+=$e+`
`,H=H.substring($e.length+1),je=!0),!je)for(var xe=new RegExp("^ {0,"+Math.min(3,ge-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),Xe=new RegExp("^ {0,"+Math.min(3,ge-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),me=new RegExp("^ {0,"+Math.min(3,ge-1)+"}(?:```|~~~)"),Pe=new RegExp("^ {0,"+Math.min(3,ge-1)+"}#");H&&(ke=H.split(`
`,1)[0],Fe=ke,this.options.pedantic&&(Fe=Fe.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(me.test(Fe)||Pe.test(Fe)||xe.test(Fe)||Xe.test(H)));){if(Fe.search(/[^ ]/)>=ge||!Fe.trim())ve+=`
`+Fe.slice(ge);else if(!Ce)ve+=`
`+Fe;else break;!Ce&&!Fe.trim()&&(Ce=!0),W+=ke+`
`,H=H.substring(ke.length+1)}qe.loose||(Ne?qe.loose=!0:/\n *\n *$/.test(W)&&(Ne=!0)),this.options.gfm&&(X=/^\[[ xX]\] /.exec(ve),X&&(ae=X[0]!=="[ ] ",ve=ve.replace(/^\[[ xX]\] +/,""))),qe.items.push({type:"list_item",raw:W,task:!!X,checked:ae,loose:!1,text:ve}),qe.raw+=W}qe.items[qe.items.length-1].raw=W.trimRight(),qe.items[qe.items.length-1].text=ve.trimRight(),qe.raw=qe.raw.trimRight();var Ie=qe.items.length;for(Ee=0;Ee<Ie;Ee++){this.lexer.state.top=!1,qe.items[Ee].tokens=this.lexer.blockTokens(qe.items[Ee].text,[]);var Oe=qe.items[Ee].tokens.filter(function(ze){return ze.type==="space"}),Te=Oe.every(function(ze){for(var He=ze.raw.split(""),Ke=0,Je=L(He),We;!(We=Je()).done;){var it=We.value;if(it===`
`&&(Ke+=1),Ke>1)return!0}return!1});!qe.loose&&Oe.length&&Te&&(qe.loose=!0,qe.items[Ee].loose=!0)}return qe}},B.html=function(H){var x=this.rules.block.html.exec(H);if(x){var W={type:"html",raw:x[0],pre:!this.options.sanitizer&&(x[1]==="pre"||x[1]==="script"||x[1]==="style"),text:x[0]};if(this.options.sanitize){var X=this.options.sanitizer?this.options.sanitizer(x[0]):b(x[0]);W.type="paragraph",W.text=X,W.tokens=this.lexer.inline(X)}return W}},B.def=function(H){var x=this.rules.block.def.exec(H);if(x){x[3]&&(x[3]=x[3].substring(1,x[3].length-1));var W=x[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:W,raw:x[0],href:x[2],title:x[3]}}},B.table=function(H){var x=this.rules.block.table.exec(H);if(x){var W={type:"table",header:S(x[1]).map(function(Ne){return{text:Ne}}),align:x[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:x[3]&&x[3].trim()?x[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(W.header.length===W.align.length){W.raw=x[0];var X=W.align.length,ae,ge,Ee,Ce;for(ae=0;ae<X;ae++)/^ *-+: *$/.test(W.align[ae])?W.align[ae]="right":/^ *:-+: *$/.test(W.align[ae])?W.align[ae]="center":/^ *:-+ *$/.test(W.align[ae])?W.align[ae]="left":W.align[ae]=null;for(X=W.rows.length,ae=0;ae<X;ae++)W.rows[ae]=S(W.rows[ae],W.header.length).map(function(Ne){return{text:Ne}});for(X=W.header.length,ge=0;ge<X;ge++)W.header[ge].tokens=this.lexer.inline(W.header[ge].text);for(X=W.rows.length,ge=0;ge<X;ge++)for(Ce=W.rows[ge],Ee=0;Ee<Ce.length;Ee++)Ce[Ee].tokens=this.lexer.inline(Ce[Ee].text);return W}}},B.lheading=function(H){var x=this.rules.block.lheading.exec(H);if(x)return{type:"heading",raw:x[0],depth:x[2].charAt(0)==="="?1:2,text:x[1],tokens:this.lexer.inline(x[1])}},B.paragraph=function(H){var x=this.rules.block.paragraph.exec(H);if(x){var W=x[1].charAt(x[1].length-1)===`
`?x[1].slice(0,-1):x[1];return{type:"paragraph",raw:x[0],text:W,tokens:this.lexer.inline(W)}}},B.text=function(H){var x=this.rules.block.text.exec(H);if(x)return{type:"text",raw:x[0],text:x[0],tokens:this.lexer.inline(x[0])}},B.escape=function(H){var x=this.rules.inline.escape.exec(H);if(x)return{type:"escape",raw:x[0],text:b(x[1])}},B.tag=function(H){var x=this.rules.inline.tag.exec(H);if(x)return!this.lexer.state.inLink&&/^<a /i.test(x[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(x[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(x[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(x[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:x[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(x[0]):b(x[0]):x[0]}},B.link=function(H){var x=this.rules.inline.link.exec(H);if(x){var W=x[2].trim();if(!this.options.pedantic&&/^</.test(W)){if(!/>$/.test(W))return;var X=D(W.slice(0,-1),"\\");if((W.length-X.length)%2===0)return}else{var ae=E(x[2],"()");if(ae>-1){var ge=x[0].indexOf("!")===0?5:4,Ee=ge+x[1].length+ae;x[2]=x[2].substring(0,ae),x[0]=x[0].substring(0,Ee).trim(),x[3]=""}}var Ce=x[2],Ne="";if(this.options.pedantic){var Fe=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ce);Fe&&(Ce=Fe[1],Ne=Fe[3])}else Ne=x[3]?x[3].slice(1,-1):"";return Ce=Ce.trim(),/^</.test(Ce)&&(this.options.pedantic&&!/>$/.test(W)?Ce=Ce.slice(1):Ce=Ce.slice(1,-1)),ee(x,{href:Ce&&Ce.replace(this.rules.inline._escapes,"$1"),title:Ne&&Ne.replace(this.rules.inline._escapes,"$1")},x[0],this.lexer)}},B.reflink=function(H,x){var W;if((W=this.rules.inline.reflink.exec(H))||(W=this.rules.inline.nolink.exec(H))){var X=(W[2]||W[1]).replace(/\s+/g," ");if(X=x[X.toLowerCase()],!X||!X.href){var ae=W[0].charAt(0);return{type:"text",raw:ae,text:ae}}return ee(W,X,W[0],this.lexer)}},B.emStrong=function(H,x,W){W===void 0&&(W="");var X=this.rules.inline.emStrong.lDelim.exec(H);if(X&&!(X[3]&&W.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var ae=X[1]||X[2]||"";if(!ae||ae&&(W===""||this.rules.inline.punctuation.exec(W))){var ge=X[0].length-1,Ee,Ce,Ne=ge,Fe=0,$e=X[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for($e.lastIndex=0,x=x.slice(-1*H.length+ge);(X=$e.exec(x))!=null;)if(Ee=X[1]||X[2]||X[3]||X[4]||X[5]||X[6],!!Ee){if(Ce=Ee.length,X[3]||X[4]){Ne+=Ce;continue}else if((X[5]||X[6])&&ge%3&&!((ge+Ce)%3)){Fe+=Ce;continue}if(Ne-=Ce,!(Ne>0)){if(Ce=Math.min(Ce,Ce+Ne+Fe),Math.min(ge,Ce)%2){var ke=H.slice(1,ge+X.index+Ce);return{type:"em",raw:H.slice(0,ge+X.index+Ce+1),text:ke,tokens:this.lexer.inlineTokens(ke)}}var ve=H.slice(2,ge+X.index+Ce-1);return{type:"strong",raw:H.slice(0,ge+X.index+Ce+1),text:ve,tokens:this.lexer.inlineTokens(ve)}}}}}},B.codespan=function(H){var x=this.rules.inline.code.exec(H);if(x){var W=x[2].replace(/\n/g," "),X=/[^ ]/.test(W),ae=/^ /.test(W)&&/ $/.test(W);return X&&ae&&(W=W.substring(1,W.length-1)),W=b(W,!0),{type:"codespan",raw:x[0],text:W}}},B.br=function(H){var x=this.rules.inline.br.exec(H);if(x)return{type:"br",raw:x[0]}},B.del=function(H){var x=this.rules.inline.del.exec(H);if(x)return{type:"del",raw:x[0],text:x[2],tokens:this.lexer.inlineTokens(x[2])}},B.autolink=function(H,x){var W=this.rules.inline.autolink.exec(H);if(W){var X,ae;return W[2]==="@"?(X=b(this.options.mangle?x(W[1]):W[1]),ae="mailto:"+X):(X=b(W[1]),ae=X),{type:"link",raw:W[0],text:X,href:ae,tokens:[{type:"text",raw:X,text:X}]}}},B.url=function(H,x){var W;if(W=this.rules.inline.url.exec(H)){var X,ae;if(W[2]==="@")X=b(this.options.mangle?x(W[0]):W[0]),ae="mailto:"+X;else{var ge;do ge=W[0],W[0]=this.rules.inline._backpedal.exec(W[0])[0];while(ge!==W[0]);X=b(W[0]),W[1]==="www."?ae="http://"+X:ae=X}return{type:"link",raw:W[0],text:X,href:ae,tokens:[{type:"text",raw:X,text:X}]}}},B.inlineText=function(H,x){var W=this.rules.inline.text.exec(H);if(W){var X;return this.lexer.state.inRawBlock?X=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(W[0]):b(W[0]):W[0]:X=b(this.options.smartypants?x(W[0]):W[0]),{type:"text",raw:W[0],text:X}}},z}(),ne={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:a,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};ne._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,ne._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,ne.def=g(ne.def).replace("label",ne._label).replace("title",ne._title).getRegex(),ne.bullet=/(?:[*+-]|\d{1,9}[.)])/,ne.listItemStart=g(/^( *)(bull) */).replace("bull",ne.bullet).getRegex(),ne.list=g(ne.list).replace(/bull/g,ne.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+ne.def.source+")").getRegex(),ne._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",ne._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,ne.html=g(ne.html,"i").replace("comment",ne._comment).replace("tag",ne._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),ne.paragraph=g(ne._paragraph).replace("hr",ne.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",ne._tag).getRegex(),ne.blockquote=g(ne.blockquote).replace("paragraph",ne.paragraph).getRegex(),ne.normal=f({},ne),ne.gfm=f({},ne.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),ne.gfm.table=g(ne.gfm.table).replace("hr",ne.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",ne._tag).getRegex(),ne.gfm.paragraph=g(ne._paragraph).replace("hr",ne.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",ne.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",ne._tag).getRegex(),ne.pedantic=f({},ne.normal,{html:g(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",ne._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:a,paragraph:g(ne.normal._paragraph).replace("hr",ne.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",ne.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var he={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:a,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:a,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};he._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",he.punctuation=g(he.punctuation).replace(/punctuation/g,he._punctuation).getRegex(),he.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,he.escapedEmSt=/\\\*|\\_/g,he._comment=g(ne._comment).replace("(?:-->|$)","-->").getRegex(),he.emStrong.lDelim=g(he.emStrong.lDelim).replace(/punct/g,he._punctuation).getRegex(),he.emStrong.rDelimAst=g(he.emStrong.rDelimAst,"g").replace(/punct/g,he._punctuation).getRegex(),he.emStrong.rDelimUnd=g(he.emStrong.rDelimUnd,"g").replace(/punct/g,he._punctuation).getRegex(),he._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,he._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,he._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,he.autolink=g(he.autolink).replace("scheme",he._scheme).replace("email",he._email).getRegex(),he._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,he.tag=g(he.tag).replace("comment",he._comment).replace("attribute",he._attribute).getRegex(),he._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,he._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,he._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,he.link=g(he.link).replace("label",he._label).replace("href",he._href).replace("title",he._title).getRegex(),he.reflink=g(he.reflink).replace("label",he._label).replace("ref",ne._label).getRegex(),he.nolink=g(he.nolink).replace("ref",ne._label).getRegex(),he.reflinkSearch=g(he.reflinkSearch,"g").replace("reflink",he.reflink).replace("nolink",he.nolink).getRegex(),he.normal=f({},he),he.pedantic=f({},he.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:g(/^!?\[(label)\]\((.*?)\)/).replace("label",he._label).getRegex(),reflink:g(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",he._label).getRegex()}),he.gfm=f({},he.normal,{escape:g(he.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),he.gfm.url=g(he.gfm.url,"i").replace("email",he.gfm._extended_email).getRegex(),he.breaks=f({},he.gfm,{br:g(he.br).replace("{2,}","*").getRegex(),text:g(he.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function Z(z){return z.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function fe(z){var B="",te,H,x=z.length;for(te=0;te<x;te++)H=z.charCodeAt(te),Math.random()>.5&&(H="x"+H.toString(16)),B+="&#"+H+";";return B}var V=function(){function z(te){this.tokens=[],this.tokens.links=Object.create(null),this.options=te||ue.defaults,this.options.tokenizer=this.options.tokenizer||new G,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var H={block:ne.normal,inline:he.normal};this.options.pedantic?(H.block=ne.pedantic,H.inline=he.pedantic):this.options.gfm&&(H.block=ne.gfm,this.options.breaks?H.inline=he.breaks:H.inline=he.gfm),this.tokenizer.rules=H}z.lex=function(H,x){var W=new z(x);return W.lex(H)},z.lexInline=function(H,x){var W=new z(x);return W.inlineTokens(H)};var B=z.prototype;return B.lex=function(H){H=H.replace(/\r\n|\r/g,`
`),this.blockTokens(H,this.tokens);for(var x;x=this.inlineQueue.shift();)this.inlineTokens(x.src,x.tokens);return this.tokens},B.blockTokens=function(H,x){var W=this;x===void 0&&(x=[]),this.options.pedantic?H=H.replace(/\t/g,"    ").replace(/^ +$/gm,""):H=H.replace(/^( *)(\t+)/gm,function(Ne,Fe,$e){return Fe+"    ".repeat($e.length)});for(var X,ae,ge,Ee;H;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Ne){return(X=Ne.call({lexer:W},H,x))?(H=H.substring(X.raw.length),x.push(X),!0):!1}))){if(X=this.tokenizer.space(H)){H=H.substring(X.raw.length),X.raw.length===1&&x.length>0?x[x.length-1].raw+=`
`:x.push(X);continue}if(X=this.tokenizer.code(H)){H=H.substring(X.raw.length),ae=x[x.length-1],ae&&(ae.type==="paragraph"||ae.type==="text")?(ae.raw+=`
`+X.raw,ae.text+=`
`+X.text,this.inlineQueue[this.inlineQueue.length-1].src=ae.text):x.push(X);continue}if(X=this.tokenizer.fences(H)){H=H.substring(X.raw.length),x.push(X);continue}if(X=this.tokenizer.heading(H)){H=H.substring(X.raw.length),x.push(X);continue}if(X=this.tokenizer.hr(H)){H=H.substring(X.raw.length),x.push(X);continue}if(X=this.tokenizer.blockquote(H)){H=H.substring(X.raw.length),x.push(X);continue}if(X=this.tokenizer.list(H)){H=H.substring(X.raw.length),x.push(X);continue}if(X=this.tokenizer.html(H)){H=H.substring(X.raw.length),x.push(X);continue}if(X=this.tokenizer.def(H)){H=H.substring(X.raw.length),ae=x[x.length-1],ae&&(ae.type==="paragraph"||ae.type==="text")?(ae.raw+=`
`+X.raw,ae.text+=`
`+X.raw,this.inlineQueue[this.inlineQueue.length-1].src=ae.text):this.tokens.links[X.tag]||(this.tokens.links[X.tag]={href:X.href,title:X.title});continue}if(X=this.tokenizer.table(H)){H=H.substring(X.raw.length),x.push(X);continue}if(X=this.tokenizer.lheading(H)){H=H.substring(X.raw.length),x.push(X);continue}if(ge=H,this.options.extensions&&this.options.extensions.startBlock&&function(){var Ne=1/0,Fe=H.slice(1),$e=void 0;W.options.extensions.startBlock.forEach(function(ke){$e=ke.call({lexer:this},Fe),typeof $e=="number"&&$e>=0&&(Ne=Math.min(Ne,$e))}),Ne<1/0&&Ne>=0&&(ge=H.substring(0,Ne+1))}(),this.state.top&&(X=this.tokenizer.paragraph(ge))){ae=x[x.length-1],Ee&&ae.type==="paragraph"?(ae.raw+=`
`+X.raw,ae.text+=`
`+X.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=ae.text):x.push(X),Ee=ge.length!==H.length,H=H.substring(X.raw.length);continue}if(X=this.tokenizer.text(H)){H=H.substring(X.raw.length),ae=x[x.length-1],ae&&ae.type==="text"?(ae.raw+=`
`+X.raw,ae.text+=`
`+X.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=ae.text):x.push(X);continue}if(H){var Ce="Infinite loop on byte: "+H.charCodeAt(0);if(this.options.silent){console.error(Ce);break}else throw new Error(Ce)}}return this.state.top=!0,x},B.inline=function(H,x){return x===void 0&&(x=[]),this.inlineQueue.push({src:H,tokens:x}),x},B.inlineTokens=function(H,x){var W=this;x===void 0&&(x=[]);var X,ae,ge,Ee=H,Ce,Ne,Fe;if(this.tokens.links){var $e=Object.keys(this.tokens.links);if($e.length>0)for(;(Ce=this.tokenizer.rules.inline.reflinkSearch.exec(Ee))!=null;)$e.includes(Ce[0].slice(Ce[0].lastIndexOf("[")+1,-1))&&(Ee=Ee.slice(0,Ce.index)+"["+M("a",Ce[0].length-2)+"]"+Ee.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Ce=this.tokenizer.rules.inline.blockSkip.exec(Ee))!=null;)Ee=Ee.slice(0,Ce.index)+"["+M("a",Ce[0].length-2)+"]"+Ee.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Ce=this.tokenizer.rules.inline.escapedEmSt.exec(Ee))!=null;)Ee=Ee.slice(0,Ce.index)+"++"+Ee.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;H;)if(Ne||(Fe=""),Ne=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ve){return(X=ve.call({lexer:W},H,x))?(H=H.substring(X.raw.length),x.push(X),!0):!1}))){if(X=this.tokenizer.escape(H)){H=H.substring(X.raw.length),x.push(X);continue}if(X=this.tokenizer.tag(H)){H=H.substring(X.raw.length),ae=x[x.length-1],ae&&X.type==="text"&&ae.type==="text"?(ae.raw+=X.raw,ae.text+=X.text):x.push(X);continue}if(X=this.tokenizer.link(H)){H=H.substring(X.raw.length),x.push(X);continue}if(X=this.tokenizer.reflink(H,this.tokens.links)){H=H.substring(X.raw.length),ae=x[x.length-1],ae&&X.type==="text"&&ae.type==="text"?(ae.raw+=X.raw,ae.text+=X.text):x.push(X);continue}if(X=this.tokenizer.emStrong(H,Ee,Fe)){H=H.substring(X.raw.length),x.push(X);continue}if(X=this.tokenizer.codespan(H)){H=H.substring(X.raw.length),x.push(X);continue}if(X=this.tokenizer.br(H)){H=H.substring(X.raw.length),x.push(X);continue}if(X=this.tokenizer.del(H)){H=H.substring(X.raw.length),x.push(X);continue}if(X=this.tokenizer.autolink(H,fe)){H=H.substring(X.raw.length),x.push(X);continue}if(!this.state.inLink&&(X=this.tokenizer.url(H,fe))){H=H.substring(X.raw.length),x.push(X);continue}if(ge=H,this.options.extensions&&this.options.extensions.startInline&&function(){var ve=1/0,je=H.slice(1),Be=void 0;W.options.extensions.startInline.forEach(function(Ze){Be=Ze.call({lexer:this},je),typeof Be=="number"&&Be>=0&&(ve=Math.min(ve,Be))}),ve<1/0&&ve>=0&&(ge=H.substring(0,ve+1))}(),X=this.tokenizer.inlineText(ge,Z)){H=H.substring(X.raw.length),X.raw.slice(-1)!=="_"&&(Fe=X.raw.slice(-1)),Ne=!0,ae=x[x.length-1],ae&&ae.type==="text"?(ae.raw+=X.raw,ae.text+=X.text):x.push(X);continue}if(H){var ke="Infinite loop on byte: "+H.charCodeAt(0);if(this.options.silent){console.error(ke);break}else throw new Error(ke)}}return x},y(z,null,[{key:"rules",get:function(){return{block:ne,inline:he}}}]),z}(),ie=function(){function z(te){this.options=te||ue.defaults}var B=z.prototype;return B.code=function(H,x,W){var X=(x||"").match(/\S*/)[0];if(this.options.highlight){var ae=this.options.highlight(H,X);ae!=null&&ae!==H&&(W=!0,H=ae)}return H=H.replace(/\n$/,"")+`
`,X?'<pre><code class="'+this.options.langPrefix+b(X,!0)+'">'+(W?H:b(H,!0))+`</code></pre>
`:"<pre><code>"+(W?H:b(H,!0))+`</code></pre>
`},B.blockquote=function(H){return`<blockquote>
`+H+`</blockquote>
`},B.html=function(H){return H},B.heading=function(H,x,W,X){if(this.options.headerIds){var ae=this.options.headerPrefix+X.slug(W);return"<h"+x+' id="'+ae+'">'+H+"</h"+x+`>
`}return"<h"+x+">"+H+"</h"+x+`>
`},B.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},B.list=function(H,x,W){var X=x?"ol":"ul",ae=x&&W!==1?' start="'+W+'"':"";return"<"+X+ae+`>
`+H+"</"+X+`>
`},B.listitem=function(H){return"<li>"+H+`</li>
`},B.checkbox=function(H){return"<input "+(H?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},B.paragraph=function(H){return"<p>"+H+`</p>
`},B.table=function(H,x){return x&&(x="<tbody>"+x+"</tbody>"),`<table>
<thead>
`+H+`</thead>
`+x+`</table>
`},B.tablerow=function(H){return`<tr>
`+H+`</tr>
`},B.tablecell=function(H,x){var W=x.header?"th":"td",X=x.align?"<"+W+' align="'+x.align+'">':"<"+W+">";return X+H+("</"+W+`>
`)},B.strong=function(H){return"<strong>"+H+"</strong>"},B.em=function(H){return"<em>"+H+"</em>"},B.codespan=function(H){return"<code>"+H+"</code>"},B.br=function(){return this.options.xhtml?"<br/>":"<br>"},B.del=function(H){return"<del>"+H+"</del>"},B.link=function(H,x,W){if(H=c(this.options.sanitize,this.options.baseUrl,H),H===null)return W;var X='<a href="'+b(H)+'"';return x&&(X+=' title="'+x+'"'),X+=">"+W+"</a>",X},B.image=function(H,x,W){if(H=c(this.options.sanitize,this.options.baseUrl,H),H===null)return W;var X='<img src="'+H+'" alt="'+W+'"';return x&&(X+=' title="'+x+'"'),X+=this.options.xhtml?"/>":">",X},B.text=function(H){return H},z}(),Y=function(){function z(){}var B=z.prototype;return B.strong=function(H){return H},B.em=function(H){return H},B.codespan=function(H){return H},B.del=function(H){return H},B.html=function(H){return H},B.text=function(H){return H},B.link=function(H,x,W){return""+W},B.image=function(H,x,W){return""+W},B.br=function(){return""},z}(),J=function(){function z(){this.seen={}}var B=z.prototype;return B.serialize=function(H){return H.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},B.getNextSafeSlug=function(H,x){var W=H,X=0;if(this.seen.hasOwnProperty(W)){X=this.seen[H];do X++,W=H+"-"+X;while(this.seen.hasOwnProperty(W))}return x||(this.seen[H]=X,this.seen[W]=0),W},B.slug=function(H,x){x===void 0&&(x={});var W=this.serialize(H);return this.getNextSafeSlug(W,x.dryrun)},z}(),re=function(){function z(te){this.options=te||ue.defaults,this.options.renderer=this.options.renderer||new ie,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new Y,this.slugger=new J}z.parse=function(H,x){var W=new z(x);return W.parse(H)},z.parseInline=function(H,x){var W=new z(x);return W.parseInline(H)};var B=z.prototype;return B.parse=function(H,x){x===void 0&&(x=!0);var W="",X,ae,ge,Ee,Ce,Ne,Fe,$e,ke,ve,je,Be,Ze,qe,Qe,xe,Xe,me,Pe,Ie=H.length;for(X=0;X<Ie;X++){if(ve=H[X],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ve.type]&&(Pe=this.options.extensions.renderers[ve.type].call({parser:this},ve),Pe!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ve.type))){W+=Pe||"";continue}switch(ve.type){case"space":continue;case"hr":{W+=this.renderer.hr();continue}case"heading":{W+=this.renderer.heading(this.parseInline(ve.tokens),ve.depth,d(this.parseInline(ve.tokens,this.textRenderer)),this.slugger);continue}case"code":{W+=this.renderer.code(ve.text,ve.lang,ve.escaped);continue}case"table":{for($e="",Fe="",Ee=ve.header.length,ae=0;ae<Ee;ae++)Fe+=this.renderer.tablecell(this.parseInline(ve.header[ae].tokens),{header:!0,align:ve.align[ae]});for($e+=this.renderer.tablerow(Fe),ke="",Ee=ve.rows.length,ae=0;ae<Ee;ae++){for(Ne=ve.rows[ae],Fe="",Ce=Ne.length,ge=0;ge<Ce;ge++)Fe+=this.renderer.tablecell(this.parseInline(Ne[ge].tokens),{header:!1,align:ve.align[ge]});ke+=this.renderer.tablerow(Fe)}W+=this.renderer.table($e,ke);continue}case"blockquote":{ke=this.parse(ve.tokens),W+=this.renderer.blockquote(ke);continue}case"list":{for(je=ve.ordered,Be=ve.start,Ze=ve.loose,Ee=ve.items.length,ke="",ae=0;ae<Ee;ae++)Qe=ve.items[ae],xe=Qe.checked,Xe=Qe.task,qe="",Qe.task&&(me=this.renderer.checkbox(xe),Ze?Qe.tokens.length>0&&Qe.tokens[0].type==="paragraph"?(Qe.tokens[0].text=me+" "+Qe.tokens[0].text,Qe.tokens[0].tokens&&Qe.tokens[0].tokens.length>0&&Qe.tokens[0].tokens[0].type==="text"&&(Qe.tokens[0].tokens[0].text=me+" "+Qe.tokens[0].tokens[0].text)):Qe.tokens.unshift({type:"text",text:me}):qe+=me),qe+=this.parse(Qe.tokens,Ze),ke+=this.renderer.listitem(qe,Xe,xe);W+=this.renderer.list(ke,je,Be);continue}case"html":{W+=this.renderer.html(ve.text);continue}case"paragraph":{W+=this.renderer.paragraph(this.parseInline(ve.tokens));continue}case"text":{for(ke=ve.tokens?this.parseInline(ve.tokens):ve.text;X+1<Ie&&H[X+1].type==="text";)ve=H[++X],ke+=`
`+(ve.tokens?this.parseInline(ve.tokens):ve.text);W+=x?this.renderer.paragraph(ke):ke;continue}default:{var Oe='Token with "'+ve.type+'" type was not found.';if(this.options.silent){console.error(Oe);return}else throw new Error(Oe)}}}return W},B.parseInline=function(H,x){x=x||this.renderer;var W="",X,ae,ge,Ee=H.length;for(X=0;X<Ee;X++){if(ae=H[X],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ae.type]&&(ge=this.options.extensions.renderers[ae.type].call({parser:this},ae),ge!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(ae.type))){W+=ge||"";continue}switch(ae.type){case"escape":{W+=x.text(ae.text);break}case"html":{W+=x.html(ae.text);break}case"link":{W+=x.link(ae.href,ae.title,this.parseInline(ae.tokens,x));break}case"image":{W+=x.image(ae.href,ae.title,ae.text);break}case"strong":{W+=x.strong(this.parseInline(ae.tokens,x));break}case"em":{W+=x.em(this.parseInline(ae.tokens,x));break}case"codespan":{W+=x.codespan(ae.text);break}case"br":{W+=x.br();break}case"del":{W+=x.del(this.parseInline(ae.tokens,x));break}case"text":{W+=x.text(ae.text);break}default:{var Ce='Token with "'+ae.type+'" type was not found.';if(this.options.silent){console.error(Ce);return}else throw new Error(Ce)}}}return W},z}();function ce(z,B,te){if(typeof z>"u"||z===null)throw new Error("marked(): input parameter is undefined or null");if(typeof z!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(z)+", string expected");if(typeof B=="function"&&(te=B,B=null),B=f({},ce.defaults,B||{}),P(B),te){var H=B.highlight,x;try{x=V.lex(z,B)}catch(Ee){return te(Ee)}var W=function(Ce){var Ne;if(!Ce)try{B.walkTokens&&ce.walkTokens(x,B.walkTokens),Ne=re.parse(x,B)}catch(Fe){Ce=Fe}return B.highlight=H,Ce?te(Ce):te(null,Ne)};if(!H||H.length<3||(delete B.highlight,!x.length))return W();var X=0;ce.walkTokens(x,function(Ee){Ee.type==="code"&&(X++,setTimeout(function(){H(Ee.text,Ee.lang,function(Ce,Ne){if(Ce)return W(Ce);Ne!=null&&Ne!==Ee.text&&(Ee.text=Ne,Ee.escaped=!0),X--,X===0&&W()})},0))}),X===0&&W();return}function ae(Ee){if(Ee.message+=`
Please report this to https://github.com/markedjs/marked.`,B.silent)return"<p>An error occurred:</p><pre>"+b(Ee.message+"",!0)+"</pre>";throw Ee}try{var ge=V.lex(z,B);if(B.walkTokens){if(B.async)return Promise.all(ce.walkTokens(ge,B.walkTokens)).then(function(){return re.parse(ge,B)}).catch(ae);ce.walkTokens(ge,B.walkTokens)}return re.parse(ge,B)}catch(Ee){ae(Ee)}}ce.options=ce.setOptions=function(z){return f(ce.defaults,z),C(ce.defaults),ce},ce.getDefaults=I,ce.defaults=ue.defaults,ce.use=function(){for(var z=arguments.length,B=new Array(z),te=0;te<z;te++)B[te]=arguments[te];var H=f.apply(void 0,[{}].concat(B)),x=ce.defaults.extensions||{renderers:{},childTokens:{}},W;B.forEach(function(X){if(X.extensions&&(W=!0,X.extensions.forEach(function(ge){if(!ge.name)throw new Error("extension name required");if(ge.renderer){var Ee=x.renderers?x.renderers[ge.name]:null;Ee?x.renderers[ge.name]=function(){for(var Ce=arguments.length,Ne=new Array(Ce),Fe=0;Fe<Ce;Fe++)Ne[Fe]=arguments[Fe];var $e=ge.renderer.apply(this,Ne);return $e===!1&&($e=Ee.apply(this,Ne)),$e}:x.renderers[ge.name]=ge.renderer}if(ge.tokenizer){if(!ge.level||ge.level!=="block"&&ge.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");x[ge.level]?x[ge.level].unshift(ge.tokenizer):x[ge.level]=[ge.tokenizer],ge.start&&(ge.level==="block"?x.startBlock?x.startBlock.push(ge.start):x.startBlock=[ge.start]:ge.level==="inline"&&(x.startInline?x.startInline.push(ge.start):x.startInline=[ge.start]))}ge.childTokens&&(x.childTokens[ge.name]=ge.childTokens)})),X.renderer&&function(){var ge=ce.defaults.renderer||new ie,Ee=function(Fe){var $e=ge[Fe];ge[Fe]=function(){for(var ke=arguments.length,ve=new Array(ke),je=0;je<ke;je++)ve[je]=arguments[je];var Be=X.renderer[Fe].apply(ge,ve);return Be===!1&&(Be=$e.apply(ge,ve)),Be}};for(var Ce in X.renderer)Ee(Ce);H.renderer=ge}(),X.tokenizer&&function(){var ge=ce.defaults.tokenizer||new G,Ee=function(Fe){var $e=ge[Fe];ge[Fe]=function(){for(var ke=arguments.length,ve=new Array(ke),je=0;je<ke;je++)ve[je]=arguments[je];var Be=X.tokenizer[Fe].apply(ge,ve);return Be===!1&&(Be=$e.apply(ge,ve)),Be}};for(var Ce in X.tokenizer)Ee(Ce);H.tokenizer=ge}(),X.walkTokens){var ae=ce.defaults.walkTokens;H.walkTokens=function(ge){var Ee=[];return Ee.push(X.walkTokens.call(this,ge)),ae&&(Ee=Ee.concat(ae.call(this,ge))),Ee}}W&&(H.extensions=x),ce.setOptions(H)})},ce.walkTokens=function(z,B){for(var te=[],H=function(){var ae=W.value;switch(te=te.concat(B.call(ce,ae)),ae.type){case"table":{for(var ge=L(ae.header),Ee;!(Ee=ge()).done;){var Ce=Ee.value;te=te.concat(ce.walkTokens(Ce.tokens,B))}for(var Ne=L(ae.rows),Fe;!(Fe=Ne()).done;)for(var $e=Fe.value,ke=L($e),ve;!(ve=ke()).done;){var je=ve.value;te=te.concat(ce.walkTokens(je.tokens,B))}break}case"list":{te=te.concat(ce.walkTokens(ae.items,B));break}default:ce.defaults.extensions&&ce.defaults.extensions.childTokens&&ce.defaults.extensions.childTokens[ae.type]?ce.defaults.extensions.childTokens[ae.type].forEach(function(Be){te=te.concat(ce.walkTokens(ae[Be],B))}):ae.tokens&&(te=te.concat(ce.walkTokens(ae.tokens,B)))}},x=L(z),W;!(W=x()).done;)H();return te},ce.parseInline=function(z,B){if(typeof z>"u"||z===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof z!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(z)+", string expected");B=f({},ce.defaults,B||{}),P(B);try{var te=V.lexInline(z,B);return B.walkTokens&&ce.walkTokens(te,B.walkTokens),re.parseInline(te,B)}catch(H){if(H.message+=`
Please report this to https://github.com/markedjs/marked.`,B.silent)return"<p>An error occurred:</p><pre>"+b(H.message+"",!0)+"</pre>";throw H}},ce.Parser=re,ce.parser=re.parse,ce.Renderer=ie,ce.TextRenderer=Y,ce.Lexer=V,ce.lexer=V.lex,ce.Tokenizer=G,ce.Slugger=J,ce.parse=ce;var oe=ce.options,_=ce.setOptions,q=ce.use,Q=ce.walkTokens,O=ce.parseInline,N=ce,U=re.parse,T=V.lex;ue.Lexer=V,ue.Parser=re,ue.Renderer=ie,ue.Slugger=J,ue.TextRenderer=Y,ue.Tokenizer=G,ue.getDefaults=I,ue.lexer=T,ue.marked=ce,ue.options=oe,ue.parse=N,ue.parseInline=O,ue.parser=U,ue.setOptions=_,ue.use=q,ue.walkTokens=Q,Object.defineProperty(ue,"__esModule",{value:!0})}),define(be[98],we([1,0,26]),function(ue,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sl=e.$rl=e.$ql=void 0;const R=new y.$Dc(1e4);function r(w){return p(w,"NFC",R)}e.$ql=r;const L=new y.$Dc(1e4);function I(w){return p(w,"NFD",L)}e.$rl=I;const C=/[^\u0000-\u0080]/;function p(w,A,k){if(!w)return w;const v=k.get(w);if(v)return v;let u;return C.test(w)?u=w.normalize(A):u=w,k.set(w,u),u}e.$sl=function(){const w=/[\u0300-\u036f]/g;return function(A){return I(A).replace(w,"")}}()}),define(be[144],we([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ul=e.$Tl=e.$Sl=e.rot=e.$Ql=void 0;function y(C,p,w){return Math.min(Math.max(C,p),w)}e.$Ql=y;function R(C,p){return(p+C%p)%p}e.rot=R;class r{constructor(){this.a=0}getNext(){return this.a++}}e.$Sl=r;class L{constructor(){this.a=1,this.b=0}update(p){return this.b=this.b+(p-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Tl=L;class I{constructor(p){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(p),this.c.fill(0,0,p)}update(p){const w=this.c[this.d];return this.c[this.d]=p,this.d=(this.d+1)%this.c.length,this.e-=w,this.e+=p,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Ul=I}),function(){function ue(r){const L=[];typeof r=="number"&&L.push("code/timeOrigin",r);function I(p){L.push(p,Date.now())}function C(){const p=[];for(let w=0;w<L.length;w+=2)p.push({name:L[w],startTime:L[w+1]});return p}return{mark:I,getMarks:C}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ue():{mark(r){performance.mark(r)},getMarks(){let r=performance.timeOrigin;typeof r!="number"&&(r=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const L=[{name:"code/timeOrigin",startTime:Math.round(r)}];for(const I of performance.getEntriesByType("mark"))L.push({name:I.name,startTime:Math.round(r+I.startTime)});return L}};if(typeof process=="object"){const r=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return ue(r)}else return console.trace("perf-util loaded in UNKNOWN environment"),ue()}function y(r){return r.MonacoPerformanceMarks||(r.MonacoPerformanceMarks=e()),r.MonacoPerformanceMarks}var R;typeof global=="object"?R=global:typeof self=="object"?R=self:R={},typeof define=="function"?define("vs/base/common/performance",[],function(){return y(R)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=y(R):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),R.perf=y(R))}(),define(be[3],we([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$C=e.$B=e.$A=e.$z=e.$y=e.$x=e.OS=e.OperatingSystem=e.$v=e.$u=e.$t=e.$s=e.$r=e.Language=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.$h=e.$g=e.$f=e.$e=e.$d=e.$c=e.Platform=e.$b=e.$a=void 0,e.$a="en";let y=!1,R=!1,r=!1,L=!1,I=!1,C=!1,p=!1,w=!1,A=!1,k=!1,v,u=e.$a,b=e.$a,m,d;e.$b=typeof self=="object"?self:typeof global=="object"?global:{};let h;typeof e.$b.vscode<"u"&&typeof e.$b.vscode.process<"u"?h=e.$b.vscode.process:typeof process<"u"&&(h=process);const g=typeof h?.versions?.electron=="string",l=g&&h?.type==="renderer";if(typeof navigator=="object"&&!l){d=navigator.userAgent,y=d.indexOf("Windows")>=0,R=d.indexOf("Macintosh")>=0,w=(d.indexOf("Macintosh")>=0||d.indexOf("iPad")>=0||d.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,r=d.indexOf("Linux")>=0,k=d?.indexOf("Mobi")>=0,C=!0,v=e.$a,u=v,b=navigator.language;const f=typeof document<"u"&&document.getElementById("vscode-remote-nls-configuration"),S=f&&f.getAttribute("data-settings");if(S)try{const D=JSON.parse(S),E=D.availableLanguages["*"];v=D.locale,b=D.osLocale,u=E||e.$a,m=D._translationsConfigFile}catch{}}else if(typeof h=="object"){y=h.platform==="win32",R=h.platform==="darwin",r=h.platform==="linux",L=r&&!!h.env.SNAP&&!!h.env.SNAP_REVISION,p=g,A=!!h.env.CI||!!h.env.BUILD_ARTIFACTSTAGINGDIRECTORY,v=e.$a,u=e.$a;const f=h.env.VSCODE_NLS_CONFIG;if(f)try{const S=JSON.parse(f),D=S.availableLanguages["*"];v=S.locale,b=S.osLocale,u=D||e.$a,m=S._translationsConfigFile}catch{}I=!0}else console.error("Unable to resolve platform.");var $;(function(f){f[f.Web=0]="Web",f[f.Mac=1]="Mac",f[f.Linux=2]="Linux",f[f.Windows=3]="Windows"})($||(e.Platform=$={}));function c(f){switch(f){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.$c=c;let n=0;R?n=1:y?n=3:r&&(n=2),e.$d=y,e.$e=R,e.$f=r,e.$g=L,e.$h=I,e.$i=p,e.$j=C,e.$k=C&&typeof e.$b.importScripts=="function",e.$l=w,e.$m=k,e.$n=A,e.$o=n,e.$p=d,e.$q=u;var i;(function(f){function S(){return e.$q}f.value=S;function D(){return e.$q.length===2?e.$q==="en":e.$q.length>=3?e.$q[0]==="e"&&e.$q[1]==="n"&&e.$q[2]==="-":!1}f.isDefaultVariant=D;function E(){return e.$q==="en"}f.isDefault=E})(i||(e.Language=i={})),e.$r=v,e.$s=b,e.$t=m,e.$u=typeof e.$b.postMessage=="function"&&!e.$b.importScripts,e.$v=(()=>{if(e.$u){const f=[];e.$b.addEventListener("message",D=>{if(D.data&&D.data.vscodeScheduleAsyncWork)for(let E=0,P=f.length;E<P;E++){const M=f[E];if(M.id===D.data.vscodeScheduleAsyncWork){f.splice(E,1),M.callback();return}}});let S=0;return D=>{const E=++S;f.push({id:E,callback:D}),e.$b.postMessage({vscodeScheduleAsyncWork:E},"*")}}return f=>setTimeout(f)})();var o;(function(f){f[f.Windows=1]="Windows",f[f.Macintosh=2]="Macintosh",f[f.Linux=3]="Linux"})(o||(e.OperatingSystem=o={})),e.OS=R||w?2:y?1:3;let s=!0,t=!1;function a(){if(!t){t=!0;const f=new Uint8Array(2);f[0]=1,f[1]=2,s=new Uint16Array(f.buffer)[0]===(2<<8)+1}return s}e.$x=a,e.$y=!!(e.$p&&e.$p.indexOf("Chrome")>=0),e.$z=!!(e.$p&&e.$p.indexOf("Firefox")>=0),e.$A=!!(!e.$y&&e.$p&&e.$p.indexOf("Safari")>=0),e.$B=!!(e.$p&&e.$p.indexOf("Edg/")>=0),e.$C=!!(e.$p&&e.$p.indexOf("Android")>=0)}),define(be[28],we([1,0,3]),function(ue,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ec=e.$dc=e.env=e.cwd=void 0;let R;if(typeof y.$b.vscode<"u"&&typeof y.$b.vscode.process<"u"){const r=y.$b.vscode.process;R={get platform(){return r.platform},get arch(){return r.arch},get env(){return r.env},cwd(){return r.cwd()}}}else typeof process<"u"?R={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:R={get platform(){return y.$d?"win32":y.$e?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=R.cwd,e.env=R.env,e.$dc=R.platform,e.$ec=R.arch}),define(be[7],we([1,0,28]),function(ue,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tc=e.sep=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=void 0;const R=65,r=97,L=90,I=122,C=46,p=47,w=92,A=58,k=63;class v extends Error{constructor(i,o,s){let t;typeof o=="string"&&o.indexOf("not ")===0?(t="must not be",o=o.replace(/^not /,"")):t="must be";const a=i.indexOf(".")!==-1?"property":"argument";let f=`The "${i}" ${a} ${t} of type ${o}`;f+=`. Received type ${typeof s}`,super(f),this.code="ERR_INVALID_ARG_TYPE"}}function u(n,i){if(n===null||typeof n!="object")throw new v(i,"Object",n)}function b(n,i){if(typeof n!="string")throw new v(i,"string",n)}const m=y.$dc==="win32";function d(n){return n===p||n===w}function h(n){return n===p}function g(n){return n>=R&&n<=L||n>=r&&n<=I}function l(n,i,o,s){let t="",a=0,f=-1,S=0,D=0;for(let E=0;E<=n.length;++E){if(E<n.length)D=n.charCodeAt(E);else{if(s(D))break;D=p}if(s(D)){if(!(f===E-1||S===1))if(S===2){if(t.length<2||a!==2||t.charCodeAt(t.length-1)!==C||t.charCodeAt(t.length-2)!==C){if(t.length>2){const P=t.lastIndexOf(o);P===-1?(t="",a=0):(t=t.slice(0,P),a=t.length-1-t.lastIndexOf(o)),f=E,S=0;continue}else if(t.length!==0){t="",a=0,f=E,S=0;continue}}i&&(t+=t.length>0?`${o}..`:"..",a=2)}else t.length>0?t+=`${o}${n.slice(f+1,E)}`:t=n.slice(f+1,E),a=E-f-1;f=E,S=0}else D===C&&S!==-1?++S:S=-1}return t}function $(n,i){u(i,"pathObject");const o=i.dir||i.root,s=i.base||`${i.name||""}${i.ext||""}`;return o?o===i.root?`${o}${s}`:`${o}${n}${s}`:s}e.$fc={resolve(...n){let i="",o="",s=!1;for(let t=n.length-1;t>=-1;t--){let a;if(t>=0){if(a=n[t],b(a,"path"),a.length===0)continue}else i.length===0?a=y.cwd():(a=y.env[`=${i}`]||y.cwd(),(a===void 0||a.slice(0,2).toLowerCase()!==i.toLowerCase()&&a.charCodeAt(2)===w)&&(a=`${i}\\`));const f=a.length;let S=0,D="",E=!1;const P=a.charCodeAt(0);if(f===1)d(P)&&(S=1,E=!0);else if(d(P))if(E=!0,d(a.charCodeAt(1))){let M=2,ee=M;for(;M<f&&!d(a.charCodeAt(M));)M++;if(M<f&&M!==ee){const se=a.slice(ee,M);for(ee=M;M<f&&d(a.charCodeAt(M));)M++;if(M<f&&M!==ee){for(ee=M;M<f&&!d(a.charCodeAt(M));)M++;(M===f||M!==ee)&&(D=`\\\\${se}\\${a.slice(ee,M)}`,S=M)}}}else S=1;else g(P)&&a.charCodeAt(1)===A&&(D=a.slice(0,2),S=2,f>2&&d(a.charCodeAt(2))&&(E=!0,S=3));if(D.length>0)if(i.length>0){if(D.toLowerCase()!==i.toLowerCase())continue}else i=D;if(s){if(i.length>0)break}else if(o=`${a.slice(S)}\\${o}`,s=E,E&&i.length>0)break}return o=l(o,!s,"\\",d),s?`${i}\\${o}`:`${i}${o}`||"."},normalize(n){b(n,"path");const i=n.length;if(i===0)return".";let o=0,s,t=!1;const a=n.charCodeAt(0);if(i===1)return h(a)?"\\":n;if(d(a))if(t=!0,d(n.charCodeAt(1))){let S=2,D=S;for(;S<i&&!d(n.charCodeAt(S));)S++;if(S<i&&S!==D){const E=n.slice(D,S);for(D=S;S<i&&d(n.charCodeAt(S));)S++;if(S<i&&S!==D){for(D=S;S<i&&!d(n.charCodeAt(S));)S++;if(S===i)return`\\\\${E}\\${n.slice(D)}\\`;S!==D&&(s=`\\\\${E}\\${n.slice(D,S)}`,o=S)}}}else o=1;else g(a)&&n.charCodeAt(1)===A&&(s=n.slice(0,2),o=2,i>2&&d(n.charCodeAt(2))&&(t=!0,o=3));let f=o<i?l(n.slice(o),!t,"\\",d):"";return f.length===0&&!t&&(f="."),f.length>0&&d(n.charCodeAt(i-1))&&(f+="\\"),s===void 0?t?`\\${f}`:f:t?`${s}\\${f}`:`${s}${f}`},isAbsolute(n){b(n,"path");const i=n.length;if(i===0)return!1;const o=n.charCodeAt(0);return d(o)||i>2&&g(o)&&n.charCodeAt(1)===A&&d(n.charCodeAt(2))},join(...n){if(n.length===0)return".";let i,o;for(let a=0;a<n.length;++a){const f=n[a];b(f,"path"),f.length>0&&(i===void 0?i=o=f:i+=`\\${f}`)}if(i===void 0)return".";let s=!0,t=0;if(typeof o=="string"&&d(o.charCodeAt(0))){++t;const a=o.length;a>1&&d(o.charCodeAt(1))&&(++t,a>2&&(d(o.charCodeAt(2))?++t:s=!1))}if(s){for(;t<i.length&&d(i.charCodeAt(t));)t++;t>=2&&(i=`\\${i.slice(t)}`)}return e.$fc.normalize(i)},relative(n,i){if(b(n,"from"),b(i,"to"),n===i)return"";const o=e.$fc.resolve(n),s=e.$fc.resolve(i);if(o===s||(n=o.toLowerCase(),i=s.toLowerCase(),n===i))return"";let t=0;for(;t<n.length&&n.charCodeAt(t)===w;)t++;let a=n.length;for(;a-1>t&&n.charCodeAt(a-1)===w;)a--;const f=a-t;let S=0;for(;S<i.length&&i.charCodeAt(S)===w;)S++;let D=i.length;for(;D-1>S&&i.charCodeAt(D-1)===w;)D--;const E=D-S,P=f<E?f:E;let M=-1,ee=0;for(;ee<P;ee++){const G=n.charCodeAt(t+ee);if(G!==i.charCodeAt(S+ee))break;G===w&&(M=ee)}if(ee!==P){if(M===-1)return s}else{if(E>P){if(i.charCodeAt(S+ee)===w)return s.slice(S+ee+1);if(ee===2)return s.slice(S+ee)}f>P&&(n.charCodeAt(t+ee)===w?M=ee:ee===2&&(M=3)),M===-1&&(M=0)}let se="";for(ee=t+M+1;ee<=a;++ee)(ee===a||n.charCodeAt(ee)===w)&&(se+=se.length===0?"..":"\\..");return S+=M,se.length>0?`${se}${s.slice(S,D)}`:(s.charCodeAt(S)===w&&++S,s.slice(S,D))},toNamespacedPath(n){if(typeof n!="string"||n.length===0)return n;const i=e.$fc.resolve(n);if(i.length<=2)return n;if(i.charCodeAt(0)===w){if(i.charCodeAt(1)===w){const o=i.charCodeAt(2);if(o!==k&&o!==C)return`\\\\?\\UNC\\${i.slice(2)}`}}else if(g(i.charCodeAt(0))&&i.charCodeAt(1)===A&&i.charCodeAt(2)===w)return`\\\\?\\${i}`;return n},dirname(n){b(n,"path");const i=n.length;if(i===0)return".";let o=-1,s=0;const t=n.charCodeAt(0);if(i===1)return d(t)?n:".";if(d(t)){if(o=s=1,d(n.charCodeAt(1))){let S=2,D=S;for(;S<i&&!d(n.charCodeAt(S));)S++;if(S<i&&S!==D){for(D=S;S<i&&d(n.charCodeAt(S));)S++;if(S<i&&S!==D){for(D=S;S<i&&!d(n.charCodeAt(S));)S++;if(S===i)return n;S!==D&&(o=s=S+1)}}}}else g(t)&&n.charCodeAt(1)===A&&(o=i>2&&d(n.charCodeAt(2))?3:2,s=o);let a=-1,f=!0;for(let S=i-1;S>=s;--S)if(d(n.charCodeAt(S))){if(!f){a=S;break}}else f=!1;if(a===-1){if(o===-1)return".";a=o}return n.slice(0,a)},basename(n,i){i!==void 0&&b(i,"ext"),b(n,"path");let o=0,s=-1,t=!0,a;if(n.length>=2&&g(n.charCodeAt(0))&&n.charCodeAt(1)===A&&(o=2),i!==void 0&&i.length>0&&i.length<=n.length){if(i===n)return"";let f=i.length-1,S=-1;for(a=n.length-1;a>=o;--a){const D=n.charCodeAt(a);if(d(D)){if(!t){o=a+1;break}}else S===-1&&(t=!1,S=a+1),f>=0&&(D===i.charCodeAt(f)?--f===-1&&(s=a):(f=-1,s=S))}return o===s?s=S:s===-1&&(s=n.length),n.slice(o,s)}for(a=n.length-1;a>=o;--a)if(d(n.charCodeAt(a))){if(!t){o=a+1;break}}else s===-1&&(t=!1,s=a+1);return s===-1?"":n.slice(o,s)},extname(n){b(n,"path");let i=0,o=-1,s=0,t=-1,a=!0,f=0;n.length>=2&&n.charCodeAt(1)===A&&g(n.charCodeAt(0))&&(i=s=2);for(let S=n.length-1;S>=i;--S){const D=n.charCodeAt(S);if(d(D)){if(!a){s=S+1;break}continue}t===-1&&(a=!1,t=S+1),D===C?o===-1?o=S:f!==1&&(f=1):o!==-1&&(f=-1)}return o===-1||t===-1||f===0||f===1&&o===t-1&&o===s+1?"":n.slice(o,t)},format:$.bind(null,"\\"),parse(n){b(n,"path");const i={root:"",dir:"",base:"",ext:"",name:""};if(n.length===0)return i;const o=n.length;let s=0,t=n.charCodeAt(0);if(o===1)return d(t)?(i.root=i.dir=n,i):(i.base=i.name=n,i);if(d(t)){if(s=1,d(n.charCodeAt(1))){let M=2,ee=M;for(;M<o&&!d(n.charCodeAt(M));)M++;if(M<o&&M!==ee){for(ee=M;M<o&&d(n.charCodeAt(M));)M++;if(M<o&&M!==ee){for(ee=M;M<o&&!d(n.charCodeAt(M));)M++;M===o?s=M:M!==ee&&(s=M+1)}}}}else if(g(t)&&n.charCodeAt(1)===A){if(o<=2)return i.root=i.dir=n,i;if(s=2,d(n.charCodeAt(2))){if(o===3)return i.root=i.dir=n,i;s=3}}s>0&&(i.root=n.slice(0,s));let a=-1,f=s,S=-1,D=!0,E=n.length-1,P=0;for(;E>=s;--E){if(t=n.charCodeAt(E),d(t)){if(!D){f=E+1;break}continue}S===-1&&(D=!1,S=E+1),t===C?a===-1?a=E:P!==1&&(P=1):a!==-1&&(P=-1)}return S!==-1&&(a===-1||P===0||P===1&&a===S-1&&a===f+1?i.base=i.name=n.slice(f,S):(i.name=n.slice(f,a),i.base=n.slice(f,S),i.ext=n.slice(a,S))),f>0&&f!==s?i.dir=n.slice(0,f-1):i.dir=i.root,i},sep:"\\",delimiter:";",win32:null,posix:null};const c=(()=>{if(m){const n=/\\/g;return()=>{const i=y.cwd().replace(n,"/");return i.slice(i.indexOf("/"))}}return()=>y.cwd()})();e.$gc={resolve(...n){let i="",o=!1;for(let s=n.length-1;s>=-1&&!o;s--){const t=s>=0?n[s]:c();b(t,"path"),t.length!==0&&(i=`${t}/${i}`,o=t.charCodeAt(0)===p)}return i=l(i,!o,"/",h),o?`/${i}`:i.length>0?i:"."},normalize(n){if(b(n,"path"),n.length===0)return".";const i=n.charCodeAt(0)===p,o=n.charCodeAt(n.length-1)===p;return n=l(n,!i,"/",h),n.length===0?i?"/":o?"./":".":(o&&(n+="/"),i?`/${n}`:n)},isAbsolute(n){return b(n,"path"),n.length>0&&n.charCodeAt(0)===p},join(...n){if(n.length===0)return".";let i;for(let o=0;o<n.length;++o){const s=n[o];b(s,"path"),s.length>0&&(i===void 0?i=s:i+=`/${s}`)}return i===void 0?".":e.$gc.normalize(i)},relative(n,i){if(b(n,"from"),b(i,"to"),n===i||(n=e.$gc.resolve(n),i=e.$gc.resolve(i),n===i))return"";const o=1,s=n.length,t=s-o,a=1,f=i.length-a,S=t<f?t:f;let D=-1,E=0;for(;E<S;E++){const M=n.charCodeAt(o+E);if(M!==i.charCodeAt(a+E))break;M===p&&(D=E)}if(E===S)if(f>S){if(i.charCodeAt(a+E)===p)return i.slice(a+E+1);if(E===0)return i.slice(a+E)}else t>S&&(n.charCodeAt(o+E)===p?D=E:E===0&&(D=0));let P="";for(E=o+D+1;E<=s;++E)(E===s||n.charCodeAt(E)===p)&&(P+=P.length===0?"..":"/..");return`${P}${i.slice(a+D)}`},toNamespacedPath(n){return n},dirname(n){if(b(n,"path"),n.length===0)return".";const i=n.charCodeAt(0)===p;let o=-1,s=!0;for(let t=n.length-1;t>=1;--t)if(n.charCodeAt(t)===p){if(!s){o=t;break}}else s=!1;return o===-1?i?"/":".":i&&o===1?"//":n.slice(0,o)},basename(n,i){i!==void 0&&b(i,"ext"),b(n,"path");let o=0,s=-1,t=!0,a;if(i!==void 0&&i.length>0&&i.length<=n.length){if(i===n)return"";let f=i.length-1,S=-1;for(a=n.length-1;a>=0;--a){const D=n.charCodeAt(a);if(D===p){if(!t){o=a+1;break}}else S===-1&&(t=!1,S=a+1),f>=0&&(D===i.charCodeAt(f)?--f===-1&&(s=a):(f=-1,s=S))}return o===s?s=S:s===-1&&(s=n.length),n.slice(o,s)}for(a=n.length-1;a>=0;--a)if(n.charCodeAt(a)===p){if(!t){o=a+1;break}}else s===-1&&(t=!1,s=a+1);return s===-1?"":n.slice(o,s)},extname(n){b(n,"path");let i=-1,o=0,s=-1,t=!0,a=0;for(let f=n.length-1;f>=0;--f){const S=n.charCodeAt(f);if(S===p){if(!t){o=f+1;break}continue}s===-1&&(t=!1,s=f+1),S===C?i===-1?i=f:a!==1&&(a=1):i!==-1&&(a=-1)}return i===-1||s===-1||a===0||a===1&&i===s-1&&i===o+1?"":n.slice(i,s)},format:$.bind(null,"/"),parse(n){b(n,"path");const i={root:"",dir:"",base:"",ext:"",name:""};if(n.length===0)return i;const o=n.charCodeAt(0)===p;let s;o?(i.root="/",s=1):s=0;let t=-1,a=0,f=-1,S=!0,D=n.length-1,E=0;for(;D>=s;--D){const P=n.charCodeAt(D);if(P===p){if(!S){a=D+1;break}continue}f===-1&&(S=!1,f=D+1),P===C?t===-1?t=D:E!==1&&(E=1):t!==-1&&(E=-1)}if(f!==-1){const P=a===0&&o?1:a;t===-1||E===0||E===1&&t===f-1&&t===a+1?i.base=i.name=n.slice(P,f):(i.name=n.slice(P,t),i.base=n.slice(P,f),i.ext=n.slice(t,f))}return a>0?i.dir=n.slice(0,a-1):o&&(i.dir="/"),i},sep:"/",delimiter:":",win32:null,posix:null},e.$gc.win32=e.$fc.win32=e.$fc,e.$gc.posix=e.$fc.posix=e.$gc,e.$hc=m?e.$fc.normalize:e.$gc.normalize,e.$ic=m?e.$fc.isAbsolute:e.$gc.isAbsolute,e.$jc=m?e.$fc.join:e.$gc.join,e.$kc=m?e.$fc.resolve:e.$gc.resolve,e.$lc=m?e.$fc.relative:e.$gc.relative,e.$mc=m?e.$fc.dirname:e.$gc.dirname,e.$nc=m?e.$fc.basename:e.$gc.basename,e.$oc=m?e.$fc.extname:e.$gc.extname,e.$pc=m?e.$fc.format:e.$gc.format,e.$qc=m?e.$fc.parse:e.$gc.parse,e.$rc=m?e.$fc.toNamespacedPath:e.$gc.toNamespacedPath,e.sep=m?e.$fc.sep:e.$gc.sep,e.$tc=m?e.$fc.delimiter:e.$gc.delimiter}),define(be[59],we([1,0,7]),function(ue,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yr=e.$Xr=e.$Wr=e.$Vr=e.$Ur=void 0,e.$Ur=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const R={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},r={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function L(A){const k=(0,y.$oc)(A),v=R[k.toLowerCase()];return v!==void 0?v:I(A)}e.$Vr=L;function I(A){const k=(0,y.$oc)(A);return r[k.toLowerCase()]}e.$Wr=I;function C(A){for(const k in r)if(r[k]===A)return k}e.$Xr=C;const p=/^(.+)\/(.+?)(;.+)?$/;function w(A,k){const v=p.exec(A);return v?`${v[1].toLowerCase()}/${v[2].toLowerCase()}${v[3]??""}`:k?void 0:A}e.$Yr=w}),define(be[60],we([1,0,3]),function(ue,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cl=e.$Bl=e.TerminateResponseCode=e.Source=void 0;var R;(function(C){C[C.stdout=0]="stdout",C[C.stderr=1]="stderr"})(R||(e.Source=R={}));var r;(function(C){C[C.Success=0]="Success",C[C.Unknown=1]="Unknown",C[C.AccessDenied=2]="AccessDenied",C[C.ProcessNotFound=3]="ProcessNotFound"})(r||(e.TerminateResponseCode=r={}));function L(C,...p){const w=p.reduce((v,u)=>(v[u]=!0,v),{}),A=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/,/^CODE_SERVER_.+$/,/^CS_.+$/];Object.keys(C).filter(v=>!w[v]).forEach(v=>{for(let u=0;u<A.length;u++)if(v.search(A[u])!==-1){delete C[v];break}})}e.$Bl=L;function I(C){C&&(delete C.DEBUG,y.$e&&delete C.DYLD_LIBRARY_PATH,y.$f&&delete C.LD_PRELOAD)}e.$Cl=I}),function(ue,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var y=e();for(var R in y)(typeof exports=="object"?exports:ue)[R]=y[R]}}(typeof self<"u"?self:this,function(){return function(ue){var e={};function y(R){if(e[R])return e[R].exports;var r=e[R]={i:R,l:!1,exports:{}};return ue[R].call(r.exports,r,r.exports,y),r.l=!0,r.exports}return y.m=ue,y.c=e,y.d=function(R,r,L){y.o(R,r)||Object.defineProperty(R,r,{enumerable:!0,get:L})},y.r=function(R){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(R,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(R,"__esModule",{value:!0})},y.t=function(R,r){if(1&r&&(R=y(R)),8&r||4&r&&typeof R=="object"&&R&&R.__esModule)return R;var L=Object.create(null);if(y.r(L),Object.defineProperty(L,"default",{enumerable:!0,value:R}),2&r&&typeof R!="string")for(var I in R)y.d(L,I,function(C){return R[C]}.bind(null,I));return L},y.n=function(R){var r=R&&R.__esModule?function(){return R.default}:function(){return R};return y.d(r,"a",r),r},y.o=function(R,r){return Object.prototype.hasOwnProperty.call(R,r)},y.p="",y(y.s=0)}([function(ue,e,y){(function(R){var r;e=ue.exports=q,r=typeof R=="object"&&R.env&&R.env.NODE_DEBUG&&/\bsemver\b/i.test(R.env.NODE_DEBUG)?function(){var $e=Array.prototype.slice.call(arguments,0);$e.unshift("SEMVER"),console.log.apply(console,$e)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var L=256,I=Number.MAX_SAFE_INTEGER||9007199254740991,C=e.re=[],p=e.src=[],w=0,A=w++;p[A]="0|[1-9]\\d*";var k=w++;p[k]="[0-9]+";var v=w++;p[v]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var u=w++;p[u]="("+p[A]+")\\.("+p[A]+")\\.("+p[A]+")";var b=w++;p[b]="("+p[k]+")\\.("+p[k]+")\\.("+p[k]+")";var m=w++;p[m]="(?:"+p[A]+"|"+p[v]+")";var d=w++;p[d]="(?:"+p[k]+"|"+p[v]+")";var h=w++;p[h]="(?:-("+p[m]+"(?:\\."+p[m]+")*))";var g=w++;p[g]="(?:-?("+p[d]+"(?:\\."+p[d]+")*))";var l=w++;p[l]="[0-9A-Za-z-]+";var $=w++;p[$]="(?:\\+("+p[l]+"(?:\\."+p[l]+")*))";var c=w++,n="v?"+p[u]+p[h]+"?"+p[$]+"?";p[c]="^"+n+"$";var i="[v=\\s]*"+p[b]+p[g]+"?"+p[$]+"?",o=w++;p[o]="^"+i+"$";var s=w++;p[s]="((?:<|>)?=?)";var t=w++;p[t]=p[k]+"|x|X|\\*";var a=w++;p[a]=p[A]+"|x|X|\\*";var f=w++;p[f]="[v=\\s]*("+p[a]+")(?:\\.("+p[a]+")(?:\\.("+p[a]+")(?:"+p[h]+")?"+p[$]+"?)?)?";var S=w++;p[S]="[v=\\s]*("+p[t]+")(?:\\.("+p[t]+")(?:\\.("+p[t]+")(?:"+p[g]+")?"+p[$]+"?)?)?";var D=w++;p[D]="^"+p[s]+"\\s*"+p[f]+"$";var E=w++;p[E]="^"+p[s]+"\\s*"+p[S]+"$";var P=w++;p[P]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var M=w++;p[M]="(?:~>?)";var ee=w++;p[ee]="(\\s*)"+p[M]+"\\s+",C[ee]=new RegExp(p[ee],"g");var se=w++;p[se]="^"+p[M]+p[f]+"$";var G=w++;p[G]="^"+p[M]+p[S]+"$";var ne=w++;p[ne]="(?:\\^)";var he=w++;p[he]="(\\s*)"+p[ne]+"\\s+",C[he]=new RegExp(p[he],"g");var Z=w++;p[Z]="^"+p[ne]+p[f]+"$";var fe=w++;p[fe]="^"+p[ne]+p[S]+"$";var V=w++;p[V]="^"+p[s]+"\\s*("+i+")$|^$";var ie=w++;p[ie]="^"+p[s]+"\\s*("+n+")$|^$";var Y=w++;p[Y]="(\\s*)"+p[s]+"\\s*("+i+"|"+p[f]+")",C[Y]=new RegExp(p[Y],"g");var J=w++;p[J]="^\\s*("+p[f]+")\\s+-\\s+("+p[f]+")\\s*$";var re=w++;p[re]="^\\s*("+p[S]+")\\s+-\\s+("+p[S]+")\\s*$";var ce=w++;p[ce]="(<|>)?=?\\s*\\*";for(var oe=0;oe<35;oe++)r(oe,p[oe]),C[oe]||(C[oe]=new RegExp(p[oe]));function _($e,ke){if($e instanceof q)return $e;if(typeof $e!="string"||$e.length>L||!(ke?C[o]:C[c]).test($e))return null;try{return new q($e,ke)}catch{return null}}function q($e,ke){if($e instanceof q){if($e.loose===ke)return $e;$e=$e.version}else if(typeof $e!="string")throw new TypeError("Invalid Version: "+$e);if($e.length>L)throw new TypeError("version is longer than "+L+" characters");if(!(this instanceof q))return new q($e,ke);r("SemVer",$e,ke),this.loose=ke;var ve=$e.trim().match(ke?C[o]:C[c]);if(!ve)throw new TypeError("Invalid Version: "+$e);if(this.raw=$e,this.major=+ve[1],this.minor=+ve[2],this.patch=+ve[3],this.major>I||this.major<0)throw new TypeError("Invalid major version");if(this.minor>I||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>I||this.patch<0)throw new TypeError("Invalid patch version");ve[4]?this.prerelease=ve[4].split(".").map(function(je){if(/^[0-9]+$/.test(je)){var Be=+je;if(Be>=0&&Be<I)return Be}return je}):this.prerelease=[],this.build=ve[5]?ve[5].split("."):[],this.format()}e.parse=_,e.valid=function($e,ke){var ve=_($e,ke);return ve?ve.version:null},e.clean=function($e,ke){var ve=_($e.trim().replace(/^[=v]+/,""),ke);return ve?ve.version:null},e.SemVer=q,q.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},q.prototype.toString=function(){return this.version},q.prototype.compare=function($e){return r("SemVer.compare",this.version,this.loose,$e),$e instanceof q||($e=new q($e,this.loose)),this.compareMain($e)||this.comparePre($e)},q.prototype.compareMain=function($e){return $e instanceof q||($e=new q($e,this.loose)),O(this.major,$e.major)||O(this.minor,$e.minor)||O(this.patch,$e.patch)},q.prototype.comparePre=function($e){if($e instanceof q||($e=new q($e,this.loose)),this.prerelease.length&&!$e.prerelease.length)return-1;if(!this.prerelease.length&&$e.prerelease.length)return 1;if(!this.prerelease.length&&!$e.prerelease.length)return 0;var ke=0;do{var ve=this.prerelease[ke],je=$e.prerelease[ke];if(r("prerelease compare",ke,ve,je),ve===void 0&&je===void 0)return 0;if(je===void 0)return 1;if(ve===void 0)return-1;if(ve!==je)return O(ve,je)}while(++ke)},q.prototype.inc=function($e,ke){switch($e){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ke);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ke);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ke),this.inc("pre",ke);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ke),this.inc("pre",ke);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ve=this.prerelease.length;--ve>=0;)typeof this.prerelease[ve]=="number"&&(this.prerelease[ve]++,ve=-2);ve===-1&&this.prerelease.push(0)}ke&&(this.prerelease[0]===ke?isNaN(this.prerelease[1])&&(this.prerelease=[ke,0]):this.prerelease=[ke,0]);break;default:throw new Error("invalid increment argument: "+$e)}return this.format(),this.raw=this.version,this},e.inc=function($e,ke,ve,je){typeof ve=="string"&&(je=ve,ve=void 0);try{return new q($e,ve).inc(ke,je).version}catch{return null}},e.diff=function($e,ke){if(z($e,ke))return null;var ve=_($e),je=_(ke);if(ve.prerelease.length||je.prerelease.length){for(var Be in ve)if((Be==="major"||Be==="minor"||Be==="patch")&&ve[Be]!==je[Be])return"pre"+Be;return"prerelease"}for(var Be in ve)if((Be==="major"||Be==="minor"||Be==="patch")&&ve[Be]!==je[Be])return Be},e.compareIdentifiers=O;var Q=/^[0-9]+$/;function O($e,ke){var ve=Q.test($e),je=Q.test(ke);return ve&&je&&($e=+$e,ke=+ke),ve&&!je?-1:je&&!ve?1:$e<ke?-1:$e>ke?1:0}function N($e,ke,ve){return new q($e,ve).compare(new q(ke,ve))}function U($e,ke,ve){return N($e,ke,ve)>0}function T($e,ke,ve){return N($e,ke,ve)<0}function z($e,ke,ve){return N($e,ke,ve)===0}function B($e,ke,ve){return N($e,ke,ve)!==0}function te($e,ke,ve){return N($e,ke,ve)>=0}function H($e,ke,ve){return N($e,ke,ve)<=0}function x($e,ke,ve,je){var Be;switch(ke){case"===":typeof $e=="object"&&($e=$e.version),typeof ve=="object"&&(ve=ve.version),Be=$e===ve;break;case"!==":typeof $e=="object"&&($e=$e.version),typeof ve=="object"&&(ve=ve.version),Be=$e!==ve;break;case"":case"=":case"==":Be=z($e,ve,je);break;case"!=":Be=B($e,ve,je);break;case">":Be=U($e,ve,je);break;case">=":Be=te($e,ve,je);break;case"<":Be=T($e,ve,je);break;case"<=":Be=H($e,ve,je);break;default:throw new TypeError("Invalid operator: "+ke)}return Be}function W($e,ke){if($e instanceof W){if($e.loose===ke)return $e;$e=$e.value}if(!(this instanceof W))return new W($e,ke);r("comparator",$e,ke),this.loose=ke,this.parse($e),this.semver===X?this.value="":this.value=this.operator+this.semver.version,r("comp",this)}e.rcompareIdentifiers=function($e,ke){return O(ke,$e)},e.major=function($e,ke){return new q($e,ke).major},e.minor=function($e,ke){return new q($e,ke).minor},e.patch=function($e,ke){return new q($e,ke).patch},e.compare=N,e.compareLoose=function($e,ke){return N($e,ke,!0)},e.rcompare=function($e,ke,ve){return N(ke,$e,ve)},e.sort=function($e,ke){return $e.sort(function(ve,je){return e.compare(ve,je,ke)})},e.rsort=function($e,ke){return $e.sort(function(ve,je){return e.rcompare(ve,je,ke)})},e.gt=U,e.lt=T,e.eq=z,e.neq=B,e.gte=te,e.lte=H,e.cmp=x,e.Comparator=W;var X={};function ae($e,ke){if($e instanceof ae)return $e.loose===ke?$e:new ae($e.raw,ke);if($e instanceof W)return new ae($e.value,ke);if(!(this instanceof ae))return new ae($e,ke);if(this.loose=ke,this.raw=$e,this.set=$e.split(/\s*\|\|\s*/).map(function(ve){return this.parseRange(ve.trim())},this).filter(function(ve){return ve.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+$e);this.format()}function ge($e){return!$e||$e.toLowerCase()==="x"||$e==="*"}function Ee($e,ke,ve,je,Be,Ze,qe,Qe,xe,Xe,me,Pe,Ie){return((ke=ge(ve)?"":ge(je)?">="+ve+".0.0":ge(Be)?">="+ve+"."+je+".0":">="+ke)+" "+(Qe=ge(xe)?"":ge(Xe)?"<"+(+xe+1)+".0.0":ge(me)?"<"+xe+"."+(+Xe+1)+".0":Pe?"<="+xe+"."+Xe+"."+me+"-"+Pe:"<="+Qe)).trim()}function Ce($e,ke){for(var ve=0;ve<$e.length;ve++)if(!$e[ve].test(ke))return!1;if(ke.prerelease.length){for(ve=0;ve<$e.length;ve++)if(r($e[ve].semver),$e[ve].semver!==X&&$e[ve].semver.prerelease.length>0){var je=$e[ve].semver;if(je.major===ke.major&&je.minor===ke.minor&&je.patch===ke.patch)return!0}return!1}return!0}function Ne($e,ke,ve){try{ke=new ae(ke,ve)}catch{return!1}return ke.test($e)}function Fe($e,ke,ve,je){var Be,Ze,qe,Qe,xe;switch($e=new q($e,je),ke=new ae(ke,je),ve){case">":Be=U,Ze=H,qe=T,Qe=">",xe=">=";break;case"<":Be=T,Ze=te,qe=U,Qe="<",xe="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ne($e,ke,je))return!1;for(var Xe=0;Xe<ke.set.length;++Xe){var me=ke.set[Xe],Pe=null,Ie=null;if(me.forEach(function(Oe){Oe.semver===X&&(Oe=new W(">=0.0.0")),Pe=Pe||Oe,Ie=Ie||Oe,Be(Oe.semver,Pe.semver,je)?Pe=Oe:qe(Oe.semver,Ie.semver,je)&&(Ie=Oe)}),Pe.operator===Qe||Pe.operator===xe||(!Ie.operator||Ie.operator===Qe)&&Ze($e,Ie.semver)||Ie.operator===xe&&qe($e,Ie.semver))return!1}return!0}W.prototype.parse=function($e){var ke=this.loose?C[V]:C[ie],ve=$e.match(ke);if(!ve)throw new TypeError("Invalid comparator: "+$e);this.operator=ve[1],this.operator==="="&&(this.operator=""),ve[2]?this.semver=new q(ve[2],this.loose):this.semver=X},W.prototype.toString=function(){return this.value},W.prototype.test=function($e){return r("Comparator.test",$e,this.loose),this.semver===X||(typeof $e=="string"&&($e=new q($e,this.loose)),x($e,this.operator,this.semver,this.loose))},W.prototype.intersects=function($e,ke){if(!($e instanceof W))throw new TypeError("a Comparator is required");var ve;if(this.operator==="")return ve=new ae($e.value,ke),Ne(this.value,ve,ke);if($e.operator==="")return ve=new ae(this.value,ke),Ne($e.semver,ve,ke);var je=!(this.operator!==">="&&this.operator!==">"||$e.operator!==">="&&$e.operator!==">"),Be=!(this.operator!=="<="&&this.operator!=="<"||$e.operator!=="<="&&$e.operator!=="<"),Ze=this.semver.version===$e.semver.version,qe=!(this.operator!==">="&&this.operator!=="<="||$e.operator!==">="&&$e.operator!=="<="),Qe=x(this.semver,"<",$e.semver,ke)&&(this.operator===">="||this.operator===">")&&($e.operator==="<="||$e.operator==="<"),xe=x(this.semver,">",$e.semver,ke)&&(this.operator==="<="||this.operator==="<")&&($e.operator===">="||$e.operator===">");return je||Be||Ze&&qe||Qe||xe},e.Range=ae,ae.prototype.format=function(){return this.range=this.set.map(function($e){return $e.join(" ").trim()}).join("||").trim(),this.range},ae.prototype.toString=function(){return this.range},ae.prototype.parseRange=function($e){var ke=this.loose;$e=$e.trim(),r("range",$e,ke);var ve=ke?C[re]:C[J];$e=$e.replace(ve,Ee),r("hyphen replace",$e),$e=$e.replace(C[Y],"$1$2$3"),r("comparator trim",$e,C[Y]),$e=($e=($e=$e.replace(C[ee],"$1~")).replace(C[he],"$1^")).split(/\s+/).join(" ");var je=ke?C[V]:C[ie],Be=$e.split(" ").map(function(Ze){return function(qe,Qe){return r("comp",qe),qe=function(xe,Xe){return xe.trim().split(/\s+/).map(function(me){return function(Pe,Ie){r("caret",Pe,Ie);var Oe=Ie?C[fe]:C[Z];return Pe.replace(Oe,function(Te,ze,He,Ke,Je){var We;return r("caret",Pe,Te,ze,He,Ke,Je),ge(ze)?We="":ge(He)?We=">="+ze+".0.0 <"+(+ze+1)+".0.0":ge(Ke)?We=ze==="0"?">="+ze+"."+He+".0 <"+ze+"."+(+He+1)+".0":">="+ze+"."+He+".0 <"+(+ze+1)+".0.0":Je?(r("replaceCaret pr",Je),Je.charAt(0)!=="-"&&(Je="-"+Je),We=ze==="0"?He==="0"?">="+ze+"."+He+"."+Ke+Je+" <"+ze+"."+He+"."+(+Ke+1):">="+ze+"."+He+"."+Ke+Je+" <"+ze+"."+(+He+1)+".0":">="+ze+"."+He+"."+Ke+Je+" <"+(+ze+1)+".0.0"):(r("no pr"),We=ze==="0"?He==="0"?">="+ze+"."+He+"."+Ke+" <"+ze+"."+He+"."+(+Ke+1):">="+ze+"."+He+"."+Ke+" <"+ze+"."+(+He+1)+".0":">="+ze+"."+He+"."+Ke+" <"+(+ze+1)+".0.0"),r("caret return",We),We})}(me,Xe)}).join(" ")}(qe,Qe),r("caret",qe),qe=function(xe,Xe){return xe.trim().split(/\s+/).map(function(me){return function(Pe,Ie){var Oe=Ie?C[G]:C[se];return Pe.replace(Oe,function(Te,ze,He,Ke,Je){var We;return r("tilde",Pe,Te,ze,He,Ke,Je),ge(ze)?We="":ge(He)?We=">="+ze+".0.0 <"+(+ze+1)+".0.0":ge(Ke)?We=">="+ze+"."+He+".0 <"+ze+"."+(+He+1)+".0":Je?(r("replaceTilde pr",Je),Je.charAt(0)!=="-"&&(Je="-"+Je),We=">="+ze+"."+He+"."+Ke+Je+" <"+ze+"."+(+He+1)+".0"):We=">="+ze+"."+He+"."+Ke+" <"+ze+"."+(+He+1)+".0",r("tilde return",We),We})}(me,Xe)}).join(" ")}(qe,Qe),r("tildes",qe),qe=function(xe,Xe){return r("replaceXRanges",xe,Xe),xe.split(/\s+/).map(function(me){return function(Pe,Ie){Pe=Pe.trim();var Oe=Ie?C[E]:C[D];return Pe.replace(Oe,function(Te,ze,He,Ke,Je,We){r("xRange",Pe,Te,ze,He,Ke,Je,We);var it=ge(He),rt=it||ge(Ke),et=rt||ge(Je);return ze==="="&&et&&(ze=""),it?Te=ze===">"||ze==="<"?"<0.0.0":"*":ze&&et?(rt&&(Ke=0),et&&(Je=0),ze===">"?(ze=">=",rt?(He=+He+1,Ke=0,Je=0):et&&(Ke=+Ke+1,Je=0)):ze==="<="&&(ze="<",rt?He=+He+1:Ke=+Ke+1),Te=ze+He+"."+Ke+"."+Je):rt?Te=">="+He+".0.0 <"+(+He+1)+".0.0":et&&(Te=">="+He+"."+Ke+".0 <"+He+"."+(+Ke+1)+".0"),r("xRange return",Te),Te})}(me,Xe)}).join(" ")}(qe,Qe),r("xrange",qe),qe=function(xe,Xe){return r("replaceStars",xe,Xe),xe.trim().replace(C[ce],"")}(qe,Qe),r("stars",qe),qe}(Ze,ke)}).join(" ").split(/\s+/);return this.loose&&(Be=Be.filter(function(Ze){return!!Ze.match(je)})),Be=Be.map(function(Ze){return new W(Ze,ke)})},ae.prototype.intersects=function($e,ke){if(!($e instanceof ae))throw new TypeError("a Range is required");return this.set.some(function(ve){return ve.every(function(je){return $e.set.some(function(Be){return Be.every(function(Ze){return je.intersects(Ze,ke)})})})})},e.toComparators=function($e,ke){return new ae($e,ke).set.map(function(ve){return ve.map(function(je){return je.value}).join(" ").trim().split(" ")})},ae.prototype.test=function($e){if(!$e)return!1;typeof $e=="string"&&($e=new q($e,this.loose));for(var ke=0;ke<this.set.length;ke++)if(Ce(this.set[ke],$e))return!0;return!1},e.satisfies=Ne,e.maxSatisfying=function($e,ke,ve){var je=null,Be=null;try{var Ze=new ae(ke,ve)}catch{return null}return $e.forEach(function(qe){Ze.test(qe)&&(je&&Be.compare(qe)!==-1||(Be=new q(je=qe,ve)))}),je},e.minSatisfying=function($e,ke,ve){var je=null,Be=null;try{var Ze=new ae(ke,ve)}catch{return null}return $e.forEach(function(qe){Ze.test(qe)&&(je&&Be.compare(qe)!==1||(Be=new q(je=qe,ve)))}),je},e.validRange=function($e,ke){try{return new ae($e,ke).range||"*"}catch{return null}},e.ltr=function($e,ke,ve){return Fe($e,ke,"<",ve)},e.gtr=function($e,ke,ve){return Fe($e,ke,">",ve)},e.outside=Fe,e.prerelease=function($e,ke){var ve=_($e,ke);return ve&&ve.prerelease.length?ve.prerelease:null},e.intersects=function($e,ke,ve){return $e=new ae($e,ve),ke=new ae(ke,ve),$e.intersects(ke)},e.coerce=function($e){if($e instanceof q)return $e;if(typeof $e!="string")return null;var ke=$e.match(C[P]);return ke==null?null:_((ke[1]||"0")+"."+(ke[2]||"0")+"."+(ke[3]||"0"))}}).call(this,y(1))},function(ue,e){var y,R,r=ue.exports={};function L(){throw new Error("setTimeout has not been defined")}function I(){throw new Error("clearTimeout has not been defined")}function C(d){if(y===setTimeout)return setTimeout(d,0);if((y===L||!y)&&setTimeout)return y=setTimeout,setTimeout(d,0);try{return y(d,0)}catch{try{return y.call(null,d,0)}catch{return y.call(this,d,0)}}}(function(){try{y=typeof setTimeout=="function"?setTimeout:L}catch{y=L}try{R=typeof clearTimeout=="function"?clearTimeout:I}catch{R=I}})();var p,w=[],A=!1,k=-1;function v(){A&&p&&(A=!1,p.length?w=p.concat(w):k=-1,w.length&&u())}function u(){if(!A){var d=C(v);A=!0;for(var h=w.length;h;){for(p=w,w=[];++k<h;)p&&p[k].run();k=-1,h=w.length}p=null,A=!1,function(g){if(R===clearTimeout)return clearTimeout(g);if((R===I||!R)&&clearTimeout)return R=clearTimeout,clearTimeout(g);try{R(g)}catch{try{return R.call(null,g)}catch{return R.call(this,g)}}}(d)}}function b(d,h){this.fun=d,this.array=h}function m(){}r.nextTick=function(d){var h=new Array(arguments.length-1);if(arguments.length>1)for(var g=1;g<arguments.length;g++)h[g-1]=arguments[g];w.push(new b(d,h)),w.length!==1||A||C(u)},b.prototype.run=function(){this.fun.apply(null,this.array)},r.title="browser",r.browser=!0,r.env={},r.argv=[],r.version="",r.versions={},r.on=m,r.addListener=m,r.once=m,r.off=m,r.removeListener=m,r.removeAllListeners=m,r.emit=m,r.prependListener=m,r.prependOnceListener=m,r.listeners=function(d){return[]},r.binding=function(d){throw new Error("process.binding is not supported")},r.cwd=function(){return"/"},r.chdir=function(d){throw new Error("process.chdir is not supported")},r.umask=function(){return 0}}])}),define(be[145],we([1,0]),function(ue,e){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.$Dr=void 0;class R{constructor(C,p,w){this.level=C,this.key=p,this.value=w,this.forward=[]}}const r=void 0;class L{constructor(C,p=2**16){this.comparator=C,this[y]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(p)|0),this.e=new R(this.c,r,r)}get size(){return this.f}clear(){this.e=new R(this.c,r,r),this.f=0}has(C){return!!L.g(this,C,this.comparator)}get(C){return L.g(this,C,this.comparator)?.value}set(C,p){return L.h(this,C,p,this.comparator)&&(this.f+=1),this}delete(C){const p=L.k(this,C,this.comparator);return p&&(this.f-=1),p}forEach(C,p){let w=this.e.forward[0];for(;w;)C.call(p,w.value,w.key,this),w=w.forward[0]}[(y=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let C=this.e.forward[0];for(;C;)yield[C.key,C.value],C=C.forward[0]}*keys(){let C=this.e.forward[0];for(;C;)yield C.key,C=C.forward[0]}*values(){let C=this.e.forward[0];for(;C;)yield C.value,C=C.forward[0]}toString(){let C="[SkipList]:",p=this.e.forward[0];for(;p;)C+=`node(${p.key}, ${p.value}, lvl:${p.level})`,p=p.forward[0];return C}static g(C,p,w){let A=C.e;for(let k=C.d-1;k>=0;k--)for(;A.forward[k]&&w(A.forward[k].key,p)<0;)A=A.forward[k];if(A=A.forward[0],A&&w(A.key,p)===0)return A}static h(C,p,w,A){const k=[];let v=C.e;for(let u=C.d-1;u>=0;u--){for(;v.forward[u]&&A(v.forward[u].key,p)<0;)v=v.forward[u];k[u]=v}if(v=v.forward[0],v&&A(v.key,p)===0)return v.value=w,!1;{const u=L.j(C);if(u>C.d){for(let b=C.d;b<u;b++)k[b]=C.e;C.d=u}v=new R(u,p,w);for(let b=0;b<u;b++)v.forward[b]=k[b].forward[b],k[b].forward[b]=v;return!0}}static j(C,p=.5){let w=1;for(;Math.random()<p&&w<C.c;)w+=1;return w}static k(C,p,w){const A=[];let k=C.e;for(let v=C.d-1;v>=0;v--){for(;k.forward[v]&&w(k.forward[v].key,p)<0;)k=k.forward[v];A[v]=k}if(k=k.forward[0],!k||w(k.key,p)!==0)return!1;for(let v=0;v<C.d&&A[v].forward[v]===k;v++)A[v].forward[v]=k.forward[v];for(;C.d>0&&C.e.forward[C.d-1]===r;)C.d-=1;return!0}}e.$Dr=L}),define(be[61],we([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kd=void 0;const y=globalThis.performance&&typeof globalThis.performance.now=="function";class R{static create(L){return new R(L)}constructor(L){this.c=y&&L===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$Kd=R}),define(be[5],we([1,0,11,74,2,97,61]),function(ue,e,y,R,r,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xd=e.$Wd=e.$Vd=e.$Ud=e.$Td=e.$Sd=e.$Rd=e.$Qd=e.$Pd=e.$Od=e.$Nd=e.$Md=e.Event=void 0;const C=!1,p=!1;var w;(function(D){D.None=()=>r.$Sc.None;function E(x){if(p){const{onDidAddListener:W}=x,X=b.create();let ae=0;x.onDidAddListener=()=>{++ae===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),X.print()),W?.()}}}function P(x,W){return ie(x,()=>{},0,void 0,!0,void 0,W)}D.defer=P;function M(x){return(W,X=null,ae)=>{let ge=!1,Ee;return Ee=x(Ce=>{if(!ge)return Ee?Ee.dispose():ge=!0,W.call(X,Ce)},null,ae),ge&&Ee.dispose(),Ee}}D.once=M;function ee(x,W,X){return fe((ae,ge=null,Ee)=>x(Ce=>ae.call(ge,W(Ce)),null,Ee),X)}D.map=ee;function se(x,W,X){return fe((ae,ge=null,Ee)=>x(Ce=>{W(Ce),ae.call(ge,Ce)},null,Ee),X)}D.forEach=se;function G(x,W,X){return fe((ae,ge=null,Ee)=>x(Ce=>W(Ce)&&ae.call(ge,Ce),null,Ee),X)}D.filter=G;function ne(x){return x}D.signal=ne;function he(...x){return(W,X=null,ae)=>{const ge=(0,r.$Pc)(...x.map(Ee=>Ee(Ce=>W.call(X,Ce))));return V(ge,ae)}}D.any=he;function Z(x,W,X,ae){let ge=X;return ee(x,Ee=>(ge=W(ge,Ee),ge),ae)}D.reduce=Z;function fe(x,W){let X;const ae={onWillAddFirstListener(){X=x(ge.fire,ge)},onDidRemoveLastListener(){X?.dispose()}};W||E(ae);const ge=new l(ae);return W?.add(ge),ge.event}function V(x,W){return W instanceof Array?W.push(x):W&&W.add(x),x}function ie(x,W,X=100,ae=!1,ge=!1,Ee,Ce){let Ne,Fe,$e,ke=0,ve;const je={leakWarningThreshold:Ee,onWillAddFirstListener(){Ne=x(Ze=>{ke++,Fe=W(Fe,Ze),ae&&!$e&&(Be.fire(Fe),Fe=void 0),ve=()=>{const qe=Fe;Fe=void 0,$e=void 0,(!ae||ke>1)&&Be.fire(qe),ke=0},typeof X=="number"?(clearTimeout($e),$e=setTimeout(ve,X)):$e===void 0&&($e=0,queueMicrotask(ve))})},onWillRemoveListener(){ge&&ke>0&&ve?.()},onDidRemoveLastListener(){ve=void 0,Ne.dispose()}};Ce||E(je);const Be=new l(je);return Ce?.add(Be),Be.event}D.debounce=ie;function Y(x,W=0,X){return D.debounce(x,(ae,ge)=>ae?(ae.push(ge),ae):[ge],W,void 0,!0,void 0,X)}D.accumulate=Y;function J(x,W=(ae,ge)=>ae===ge,X){let ae=!0,ge;return G(x,Ee=>{const Ce=ae||!W(Ee,ge);return ae=!1,ge=Ee,Ce},X)}D.latch=J;function re(x,W,X){return[D.filter(x,W,X),D.filter(x,ae=>!W(ae),X)]}D.split=re;function ce(x,W=!1,X=[],ae){let ge=X.slice(),Ee=x(Fe=>{ge?ge.push(Fe):Ne.fire(Fe)});ae&&ae.add(Ee);const Ce=()=>{ge?.forEach(Fe=>Ne.fire(Fe)),ge=null},Ne=new l({onWillAddFirstListener(){Ee||(Ee=x(Fe=>Ne.fire(Fe)),ae&&ae.add(Ee))},onDidAddFirstListener(){ge&&(W?setTimeout(Ce):Ce())},onDidRemoveLastListener(){Ee&&Ee.dispose(),Ee=null}});return ae&&ae.add(Ne),Ne.event}D.buffer=ce;function oe(x,W){return(ae,ge,Ee)=>{const Ce=W(new q);return x(function(Ne){const Fe=Ce.evaluate(Ne);Fe!==_&&ae.call(ge,Fe)},void 0,Ee)}}D.chain=oe;const _=Symbol("HaltChainable");class q{constructor(){this.f=[]}map(W){return this.f.push(W),this}forEach(W){return this.f.push(X=>(W(X),X)),this}filter(W){return this.f.push(X=>W(X)?X:_),this}reduce(W,X){let ae=X;return this.f.push(ge=>(ae=W(ae,ge),ae)),this}latch(W=(X,ae)=>X===ae){let X=!0,ae;return this.f.push(ge=>{const Ee=X||!W(ge,ae);return X=!1,ae=ge,Ee?ge:_}),this}evaluate(W){for(const X of this.f)if(W=X(W),W===_)break;return W}}function Q(x,W,X=ae=>ae){const ae=(...Ne)=>Ce.fire(X(...Ne)),ge=()=>x.on(W,ae),Ee=()=>x.removeListener(W,ae),Ce=new l({onWillAddFirstListener:ge,onDidRemoveLastListener:Ee});return Ce.event}D.fromNodeEventEmitter=Q;function O(x,W,X=ae=>ae){const ae=(...Ne)=>Ce.fire(X(...Ne)),ge=()=>x.addEventListener(W,ae),Ee=()=>x.removeEventListener(W,ae),Ce=new l({onWillAddFirstListener:ge,onDidRemoveLastListener:Ee});return Ce.event}D.fromDOMEventEmitter=O;function N(x){return new Promise(W=>M(x)(W))}D.toPromise=N;function U(x){const W=new l;return x.then(X=>{W.fire(X)},()=>{W.fire(void 0)}).finally(()=>{W.dispose()}),W.event}D.fromPromise=U;function T(x,W,X){return W(X),x(ae=>W(ae))}D.runAndSubscribe=T;function z(x,W){let X=null;function ae(Ee){X?.dispose(),X=new r.$Rc,W(Ee,X)}ae(void 0);const ge=x(Ee=>ae(Ee));return(0,r.$Qc)(()=>{ge.dispose(),X?.dispose()})}D.runAndSubscribeWithStore=z;class B{constructor(W,X){this._observable=W,this.f=0,this.g=!1;const ae={onWillAddFirstListener:()=>{W.addObserver(this)},onDidRemoveLastListener:()=>{W.removeObserver(this)}};X||E(ae),this.emitter=new l(ae),X&&X.add(this.emitter)}beginUpdate(W){this.f++}handlePossibleChange(W){}handleChange(W,X){this.g=!0}endUpdate(W){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function te(x,W){return new B(x,W).emitter.event}D.fromObservable=te;function H(x){return W=>{let X=0,ae=!1;const ge={beginUpdate(){X++},endUpdate(){X--,X===0&&(x.reportChanges(),ae&&(ae=!1,W()))},handlePossibleChange(){},handleChange(){ae=!0}};return x.addObserver(ge),x.reportChanges(),{dispose(){x.removeObserver(ge)}}}}D.fromObservableLight=H})(w||(e.Event=w={}));class A{constructor(E){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${E}_${A.f++}`,A.all.add(this)}start(E){this.g=new I.$Kd,this.listenerCount=E}stop(){if(this.g){const E=this.g.elapsed();this.durations.push(E),this.elapsedOverall+=E,this.invocationCount+=1,this.g=void 0}}}e.$Md=A,A.all=new Set,A.f=0;let k=-1;function v(D){const E=k;return k=D,{dispose(){k=E}}}e.$Nd=v;class u{constructor(E,P=Math.random().toString(18).slice(2,5)){this.threshold=E,this.name=P,this.g=0}dispose(){this.f?.clear()}check(E,P){const M=this.threshold;if(M<=0||P<M)return;this.f||(this.f=new Map);const ee=this.f.get(E.value)||0;if(this.f.set(E.value,ee+1),this.g-=1,this.g<=0){this.g=M*.5;let se,G=0;for(const[ne,he]of this.f)(!se||G<he)&&(se=ne,G=he);console.warn(`[${this.name}] potential listener LEAK detected, having ${P} listeners already. MOST frequent listener (${G}):`),console.warn(se)}return()=>{const se=this.f.get(E.value)||0;this.f.set(E.value,se-1)}}}class b{static create(){return new b(new Error().stack??"")}constructor(E){this.value=E}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let m=0;class d{constructor(E){this.value=E,this.id=m++}}const h=2,g=(D,E)=>{if(D instanceof d)E(D);else for(let P=0;P<D.length;P++){const M=D[P];M&&E(M)}};class l{constructor(E){this.w=0,this.f=E,this.g=k>0||this.f?.leakWarningThreshold?new u(this.f?.leakWarningThreshold??k):void 0,this.j=this.f?._profName?new A(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(C){const E=this.t;queueMicrotask(()=>{g(E,P=>P.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??(this.q=(E,P,M)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),r.$Sc.None;if(this.m)return r.$Sc.None;P&&(E=E.bind(P));const ee=new d(E);let se,G;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(ee.stack=b.create(),se=this.g.check(ee.stack,this.w+1)),C&&(ee.stack=G??b.create()),this.t?this.t instanceof d?(this.u??(this.u=new c),this.t=[this.t,ee]):this.t.push(ee):(this.f?.onWillAddFirstListener?.(this),this.t=ee,this.f?.onDidAddFirstListener?.(this)),this.w++;const ne=(0,r.$Qc)(()=>{se?.(),this.x(ee)});return M instanceof r.$Rc?M.add(ne):Array.isArray(M)&&M.push(ne),ne}),this.q}x(E){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const P=this.t,M=P.indexOf(E);if(M===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,P[M]=void 0;const ee=this.u.current===this;if(this.w*h<=P.length){let se=0;for(let G=0;G<P.length;G++)P[G]?P[se++]=P[G]:ee&&(this.u.end--,se<this.u.i&&this.u.i--);P.length=se}}y(E,P){if(!E)return;const M=this.f?.onListenerError||y.$1;if(!M){E.value(P);return}try{E.value(P)}catch(ee){M(ee)}}z(E){const P=E.current.t;for(;E.i<E.end;)this.y(P[E.i++],E.value);E.reset()}fire(E){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof d)this.y(this.t,E);else{const P=this.u;P.enqueue(this,E,this.t.length),this.z(P)}this.j?.stop()}hasListeners(){return this.w>0}}e.$Od=l;const $=()=>new c;e.$Pd=$;class c{constructor(){this.i=-1,this.end=0}enqueue(E,P,M){this.i=0,this.end=M,this.current=E,this.value=P}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class n extends l{async fireAsync(E,P,M){if(this.t)for(this.h||(this.h=new L.$2c),g(this.t,ee=>this.h.push([ee.value,E]));this.h.size>0&&!P.isCancellationRequested;){const[ee,se]=this.h.shift(),G=[],ne={...se,token:P,waitUntil:he=>{if(Object.isFrozen(G))throw new Error("waitUntil can NOT be called asynchronous");M&&(he=M(he,ee)),G.push(he)}};try{ee(ne)}catch(he){(0,y.$1)(he);continue}Object.freeze(G),await Promise.allSettled(G).then(he=>{for(const Z of he)Z.status==="rejected"&&(0,y.$1)(Z.reason)})}}}e.$Qd=n;class i extends l{get isPaused(){return this.h!==0}constructor(E){super(E),this.h=0,this.s=new L.$2c,this.A=E?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const E=Array.from(this.s);this.s.clear(),super.fire(this.A(E))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(E){this.w&&(this.h!==0?this.s.push(E):super.fire(E))}}e.$Rd=i;class o extends i{constructor(E){super(E),this.k=E.delay??100}fire(E){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(E)}}e.$Sd=o;class s extends l{constructor(E){super(E),this.h=[],this.k=E?.merge}fire(E){this.hasListeners()&&(this.h.push(E),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(P=>super.fire(P)),this.h=[]}))}}e.$Td=s;class t{constructor(){this.g=!1,this.h=[],this.f=new l({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(E){const P={event:E,listener:null};this.h.push(P),this.g&&this.m(P);const M=()=>{this.g&&this.o(P);const ee=this.h.indexOf(P);this.h.splice(ee,1)};return(0,r.$Qc)((0,R.$db)(M))}j(){this.g=!0,this.h.forEach(E=>this.m(E))}k(){this.g=!1,this.h.forEach(E=>this.o(E))}m(E){E.listener=E.event(P=>this.f.fire(P))}o(E){E.listener&&E.listener.dispose(),E.listener=null}dispose(){this.f.dispose()}}e.$Ud=t;class a{constructor(E,P,M,ee){this.f=new r.$Rc;const se=this.f.add(new t),G=this.f.add(new r.$1c);function ne(he){G.set(he,se.add(ee(he)))}for(const he of E)ne(he);this.f.add(P(he=>{ne(he)})),this.f.add(M(he=>{G.deleteAndDispose(he)})),this.event=se.event}dispose(){this.f.dispose()}}e.$Vd=a;class f{constructor(){this.f=[]}wrapEvent(E){return(P,M,ee)=>E(se=>{const G=this.f[this.f.length-1];G?G.push(()=>P.call(M,se)):P.call(M,se)},void 0,ee)}bufferEvents(E){const P=[];this.f.push(P);const M=E();return this.f.pop(),P.forEach(ee=>ee()),M}}e.$Wd=f;class S{constructor(){this.f=!1,this.g=w.None,this.h=r.$Sc.None,this.j=new l({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(E){this.g=E,this.f&&(this.h.dispose(),this.h=E(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$Xd=S}),define(be[20],we([1,0,5]),function(ue,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yd=e.CancellationToken=void 0;const R=Object.freeze(function(C,p){const w=setTimeout(C.bind(p),0);return{dispose(){clearTimeout(w)}}});var r;(function(C){function p(w){return w===C.None||w===C.Cancelled||w instanceof L?!0:!w||typeof w!="object"?!1:typeof w.isCancellationRequested=="boolean"&&typeof w.onCancellationRequested=="function"}C.isCancellationToken=p,C.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:y.Event.None}),C.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:R})})(r||(e.CancellationToken=r={}));class L{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?R:(this.b||(this.b=new y.$Od),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class I{constructor(p){this.f=void 0,this.g=void 0,this.g=p&&p.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new L),this.f}cancel(){this.f?this.f instanceof L&&this.f.cancel():this.f=r.Cancelled}dispose(p=!1){p&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof L&&this.f.dispose():this.f=r.None}}e.$Yd=I}),define(be[146],we([1,0,20]),function(ue,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ze=e.$ye=e.$xe=void 0;class R{constructor(C){this.b=C,this.a=null}get(){if(this.a)return this.a;const C=new y.$Yd,p=this.b(C.token);return this.a={promise:p,dispose:()=>{this.a=null,C.cancel(),C.dispose()}},this.a}}e.$xe=R;class r{constructor(C){this.c=C,this.a=void 0,this.b=void 0}get(C){const p=JSON.stringify(C);return this.b!==p&&(this.b=p,this.a=this.c(C)),this.a}}e.$ye=r;class L{get cachedValues(){return this.a}constructor(C){this.b=C,this.a=new Map}get(C){if(this.a.has(C))return this.a.get(C);const p=this.b(C);return this.a.set(C,p),p}}e.$ze=L}),define(be[48],we([1,0,11,2]),function(ue,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=e.$4d=e.$3d=e.$2d=e.$1d=e.$Zd=void 0;function r($){const c=$;return c?typeof c.read=="function":!1}e.$Zd=r;function L($){const c=$;return c?[c.on,c.pause,c.resume,c.destroy].every(n=>typeof n=="function"):!1}e.$1d=L;function I($){const c=$;return c?L(c.stream)&&Array.isArray(c.buffer)&&typeof c.ended=="boolean":!1}e.$2d=I;function C($,c){return new p($,c)}e.$3d=C;class p{constructor(c,n){this.e=c,this.f=n,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(c){if(!this.a.destroyed){if(this.a.flowing)this.g(c);else if(this.b.data.push(c),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(n=>this.d.push(n))}}error(c){this.a.destroyed||(this.a.flowing?this.h(c):this.b.error.push(c))}end(c){this.a.destroyed||(typeof c<"u"&&this.write(c),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(c){this.c.data.slice(0).forEach(n=>n(c))}h(c){this.c.error.length===0?(0,y.$1)(c):this.c.error.slice(0).forEach(n=>n(c))}i(){this.c.end.slice(0).forEach(c=>c())}on(c,n){if(!this.a.destroyed)switch(c){case"data":this.c.data.push(n),this.resume();break;case"end":this.c.end.push(n),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(n),this.a.flowing&&this.k();break}}removeListener(c,n){if(this.a.destroyed)return;let i;switch(c){case"data":i=this.c.data;break;case"end":i=this.c.end;break;case"error":i=this.c.error;break}if(i){const o=i.indexOf(n);o>=0&&i.splice(o,1)}}j(){if(this.b.data.length>0){const c=this.e(this.b.data);this.g(c),this.b.data.length=0;const n=[...this.d];this.d.length=0,n.forEach(i=>i())}}k(){if(this.c.error.length>0){for(const c of this.b.error)this.h(c);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function w($,c){const n=[];let i;for(;(i=$.read())!==null;)n.push(i);return c(n)}e.$4d=w;function A($,c,n){const i=[];let o;for(;(o=$.read())!==null&&i.length<n;)i.push(o);return o===null&&i.length>0?c(i):{read:()=>{if(i.length>0)return i.shift();if(typeof o<"u"){const s=o;return o=void 0,s}return $.read()}}}e.$5d=A;function k($,c){return new Promise((n,i)=>{const o=[];v($,{onData:s=>{c&&o.push(s)},onError:s=>{c?i(s):n(void 0)},onEnd:()=>{n(c?c(o):void 0)}})})}e.$6d=k;function v($,c,n){$.on("error",i=>{n?.isCancellationRequested||c.onError(i)}),$.on("end",()=>{n?.isCancellationRequested||c.onEnd()}),$.on("data",i=>{n?.isCancellationRequested||c.onData(i)})}e.$7d=v;function u($,c){return new Promise((n,i)=>{const o=new R.$Rc,s=[],t=S=>{if(s.push(S),s.length>c)return o.dispose(),$.pause(),n({stream:$,buffer:s,ended:!1})},a=S=>(o.dispose(),i(S)),f=()=>(o.dispose(),n({stream:$,buffer:s,ended:!0}));o.add((0,R.$Qc)(()=>$.removeListener("error",a))),$.on("error",a),o.add((0,R.$Qc)(()=>$.removeListener("end",f))),$.on("end",f),o.add((0,R.$Qc)(()=>$.removeListener("data",t))),$.on("data",t)})}e.$8d=u;function b($,c){const n=C(c);return n.end($),n}e.$9d=b;function m(){const $=C(()=>{throw new Error("not supported")});return $.end(),$}e.$0d=m;function d($){let c=!1;return{read:()=>c?null:(c=!0,$)}}e.$$d=d;function h($,c,n){const i=C(n);return v($,{onData:o=>i.write(c.data(o)),onError:o=>i.error(c.error?c.error(o):o),onEnd:()=>i.end()}),i}e.$_d=h;function g($,c,n){let i=!1;return{read:()=>{const o=c.read();return i?o:(i=!0,o!==null?n([$,o]):$)}}}e.$ae=g;function l($,c,n){let i=!1;const o=C(n);return v(c,{onData:s=>i?o.write(s):(i=!0,o.write(n([$,s]))),onError:s=>o.error(s),onEnd:()=>{i||(i=!0,o.write($)),o.end()}}),o}e.$be=l}),define(be[15],we([1,0,76,48]),function(ue,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$ee=e.$de=e.$ce=void 0;const r=typeof Buffer<"u",L=new y.$V(()=>new Uint8Array(256));let I,C;class p{static alloc(P){return r?new p(Buffer.allocUnsafe(P)):new p(new Uint8Array(P))}static wrap(P){return r&&!Buffer.isBuffer(P)&&(P=Buffer.from(P.buffer,P.byteOffset,P.byteLength)),new p(P)}static fromString(P,M){return!(M?.dontUseNodeBuffer||!1)&&r?new p(Buffer.from(P)):(I||(I=new TextEncoder),new p(I.encode(P)))}static fromByteArray(P){const M=p.alloc(P.length);for(let ee=0,se=P.length;ee<se;ee++)M.buffer[ee]=P[ee];return M}static concat(P,M){if(typeof M>"u"){M=0;for(let G=0,ne=P.length;G<ne;G++)M+=P[G].byteLength}const ee=p.alloc(M);let se=0;for(let G=0,ne=P.length;G<ne;G++){const he=P[G];ee.set(he,se),se+=he.byteLength}return ee}constructor(P){this.buffer=P,this.byteLength=this.buffer.byteLength}clone(){const P=p.alloc(this.byteLength);return P.set(this),P}toString(){return r?this.buffer.toString():(C||(C=new TextDecoder),C.decode(this.buffer))}slice(P,M){return new p(this.buffer.subarray(P,M))}set(P,M){if(P instanceof p)this.buffer.set(P.buffer,M);else if(P instanceof Uint8Array)this.buffer.set(P,M);else if(P instanceof ArrayBuffer)this.buffer.set(new Uint8Array(P),M);else if(ArrayBuffer.isView(P))this.buffer.set(new Uint8Array(P.buffer,P.byteOffset,P.byteLength),M);else throw new Error("Unknown argument 'array'")}readUInt32BE(P){return v(this.buffer,P)}writeUInt32BE(P,M){u(this.buffer,P,M)}readUInt32LE(P){return b(this.buffer,P)}writeUInt32LE(P,M){m(this.buffer,P,M)}readUInt8(P){return d(this.buffer,P)}writeUInt8(P,M){h(this.buffer,P,M)}indexOf(P,M=0){return w(this.buffer,P instanceof p?P.buffer:P,M)}}e.$ce=p;function w(E,P,M=0){const ee=P.byteLength,se=E.byteLength;if(ee===0)return 0;if(ee===1)return E.indexOf(P[0]);if(ee>se-M)return-1;const G=L.value;G.fill(P.length);for(let fe=0;fe<P.length;fe++)G[P[fe]]=P.length-fe-1;let ne=M+P.length-1,he=ne,Z=-1;for(;ne<se;)if(E[ne]===P[he]){if(he===0){Z=ne;break}ne--,he--}else ne+=Math.max(P.length-he,G[E[ne]]),he=P.length-1;return Z}e.$de=w;function A(E,P){return E[P+0]<<0>>>0|E[P+1]<<8>>>0}e.$ee=A;function k(E,P,M){E[M+0]=P&255,P=P>>>8,E[M+1]=P&255}e.$fe=k;function v(E,P){return E[P]*2**24+E[P+1]*2**16+E[P+2]*2**8+E[P+3]}e.$ge=v;function u(E,P,M){E[M+3]=P,P=P>>>8,E[M+2]=P,P=P>>>8,E[M+1]=P,P=P>>>8,E[M]=P}e.$he=u;function b(E,P){return E[P+0]<<0>>>0|E[P+1]<<8>>>0|E[P+2]<<16>>>0|E[P+3]<<24>>>0}e.$ie=b;function m(E,P,M){E[M+0]=P&255,P=P>>>8,E[M+1]=P&255,P=P>>>8,E[M+2]=P&255,P=P>>>8,E[M+3]=P&255}e.$je=m;function d(E,P){return E[P]}e.$ke=d;function h(E,P,M){E[M]=P}e.$le=h;function g(E){return R.$4d(E,P=>p.concat(P))}e.$me=g;function l(E){return R.$$d(E)}e.$ne=l;function $(E){return R.$6d(E,P=>p.concat(P))}e.$oe=$;async function c(E){return E.ended?p.concat(E.buffer):p.concat([...E.buffer,await $(E.stream)])}e.$pe=c;function n(E){return R.$9d(E,P=>p.concat(P))}e.$qe=n;function i(E){return R.$_d(E,{data:P=>typeof P=="string"?p.fromString(P):p.wrap(P)},P=>p.concat(P))}e.$re=i;function o(E){return R.$3d(P=>p.concat(P),E)}e.$se=o;function s(E,P){return R.$ae(E,P,M=>p.concat(M))}e.$te=s;function t(E,P){return R.$be(E,P,M=>p.concat(M))}e.$ue=t;function a(E){let P=0,M=0,ee=0;const se=new Uint8Array(Math.floor(E.length/4*3)),G=he=>{switch(M){case 3:se[ee++]=P|he,M=0;break;case 2:se[ee++]=P|he>>>2,P=he<<6,M=3;break;case 1:se[ee++]=P|he>>>4,P=he<<4,M=2;break;default:P=he<<2,M=1}};for(let he=0;he<E.length;he++){const Z=E.charCodeAt(he);if(Z>=65&&Z<=90)G(Z-65);else if(Z>=97&&Z<=122)G(Z-97+26);else if(Z>=48&&Z<=57)G(Z-48+52);else if(Z===43||Z===45)G(62);else if(Z===47||Z===95)G(63);else{if(Z===61)break;throw new SyntaxError(`Unexpected base64 character ${E[he]}`)}}const ne=ee;for(;M>0;)G(0);return p.wrap(se).slice(0,ne)}e.$ve=a;const f="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",S="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function D({buffer:E},P=!0,M=!1){const ee=M?S:f;let se="";const G=E.byteLength%3;let ne=0;for(;ne<E.byteLength-G;ne+=3){const he=E[ne+0],Z=E[ne+1],fe=E[ne+2];se+=ee[he>>>2],se+=ee[(he<<4|Z>>>4)&63],se+=ee[(Z<<2|fe>>>6)&63],se+=ee[fe&63]}if(G===1){const he=E[ne+0];se+=ee[he>>>2],se+=ee[he<<4&63],P&&(se+="==")}else if(G===2){const he=E[ne+0],Z=E[ne+1];se+=ee[he>>>2],se+=ee[(he<<4|Z>>>4)&63],se+=ee[Z<<2&63],P&&(se+="=")}return se}e.$we=D}),define(be[17],we([1,0,146,76]),function(ue,e,y,R){"use strict";var r;Object.defineProperty(e,"__esModule",{value:!0}),e.$yf=e.$xf=e.$wf=e.$vf=e.GraphemeBreakType=e.$uf=e.$tf=e.$sf=e.$rf=e.$qf=e.$pf=e.$of=e.$nf=e.$mf=e.$lf=e.$kf=e.$jf=e.$if=e.$hf=e.$gf=e.$ff=e.$ef=e.$df=e.$cf=e.$bf=e.$af=e.$_e=e.$$e=e.$0e=e.$9e=e.$8e=e.$7e=e.$6e=e.$5e=e.$4e=e.$3e=e.$2e=e.$1e=e.$Ze=e.$Ye=e.$Xe=e.$We=e.$Ve=e.$Ue=e.$Te=e.$Se=e.$Re=e.$Qe=e.$Pe=e.$Oe=e.$Ne=e.$Me=e.$Le=e.$Ke=e.$Je=e.$Ie=e.$He=e.$Ge=e.$Fe=e.$Ee=e.$De=e.$Ce=void 0;function L(me){return!me||typeof me!="string"?!0:me.trim().length===0}e.$Ce=L;const I=/{(\d+)}/g;function C(me,...Pe){return Pe.length===0?me:me.replace(I,function(Ie,Oe){const Te=parseInt(Oe,10);return isNaN(Te)||Te<0||Te>=Pe.length?Ie:Pe[Te]})}e.$De=C;const p=/{([^}]+)}/g;function w(me,Pe){return Object.keys(Pe).length===0?me:me.replace(p,(Ie,Oe)=>Pe[Oe]??Ie)}e.$Ee=w;function A(me){return me.replace(/[<>&]/g,function(Pe){switch(Pe){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Pe}})}e.$Fe=A;function k(me){return me.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.$Ge=k;function v(me,Pe){let Ie=0;const Oe=Pe.charCodeAt(0);for(let Te=me.length-1;Te>=0;Te--)me.charCodeAt(Te)===Oe&&Ie++;return Ie}e.$He=v;function u(me,Pe,Ie="\u2026"){return me.length<=Pe?me:`${me.substr(0,Pe)}${Ie}`}e.$Ie=u;function b(me,Pe=" "){const Ie=m(me,Pe);return d(Ie,Pe)}e.$Je=b;function m(me,Pe){if(!me||!Pe)return me;const Ie=Pe.length;if(Ie===0||me.length===0)return me;let Oe=0;for(;me.indexOf(Pe,Oe)===Oe;)Oe=Oe+Ie;return me.substring(Oe)}e.$Ke=m;function d(me,Pe){if(!me||!Pe)return me;const Ie=Pe.length,Oe=me.length;if(Ie===0||Oe===0)return me;let Te=Oe,ze=-1;for(;ze=me.lastIndexOf(Pe,Te-1),!(ze===-1||ze+Ie!==Te);){if(ze===0)return"";Te=ze}return me.substring(0,Te)}e.$Le=d;function h(me){return me.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.$Me=h;function g(me){return me.replace(/\*/g,"")}e.$Ne=g;function l(me,Pe,Ie={}){if(!me)throw new Error("Cannot create regex from empty string");Pe||(me=k(me)),Ie.wholeWord&&(/\B/.test(me.charAt(0))||(me="\\b"+me),/\B/.test(me.charAt(me.length-1))||(me=me+"\\b"));let Oe="";return Ie.global&&(Oe+="g"),Ie.matchCase||(Oe+="i"),Ie.multiline&&(Oe+="m"),Ie.unicode&&(Oe+="u"),new RegExp(me,Oe)}e.$Oe=l;function $(me){return me.source==="^"||me.source==="^$"||me.source==="$"||me.source==="^\\s*$"?!1:!!(me.exec("")&&me.lastIndex===0)}e.$Pe=$;function c(me){return me.split(/\r\n|\r|\n/)}e.$Qe=c;function n(me){for(let Pe=0,Ie=me.length;Pe<Ie;Pe++){const Oe=me.charCodeAt(Pe);if(Oe!==32&&Oe!==9)return Pe}return-1}e.$Re=n;function i(me,Pe=0,Ie=me.length){for(let Oe=Pe;Oe<Ie;Oe++){const Te=me.charCodeAt(Oe);if(Te!==32&&Te!==9)return me.substring(Pe,Oe)}return me.substring(Pe,Ie)}e.$Se=i;function o(me,Pe=me.length-1){for(let Ie=Pe;Ie>=0;Ie--){const Oe=me.charCodeAt(Ie);if(Oe!==32&&Oe!==9)return Ie}return-1}e.$Te=o;function s(me,Pe,Ie){const Oe=[];let Te=0;for(const ze of me.matchAll(Pe)){if(Oe.push(me.slice(Te,ze.index)),ze.index===void 0)throw new Error("match.index should be defined");Te=ze.index+ze[0].length,Oe.push(Ie(ze[0],...ze.slice(1),ze.index,me,ze.groups))}return Oe.push(me.slice(Te)),Promise.all(Oe).then(ze=>ze.join(""))}e.$Ue=s;function t(me,Pe){return me<Pe?-1:me>Pe?1:0}e.$Ve=t;function a(me,Pe,Ie=0,Oe=me.length,Te=0,ze=Pe.length){for(;Ie<Oe&&Te<ze;Ie++,Te++){const Je=me.charCodeAt(Ie),We=Pe.charCodeAt(Te);if(Je<We)return-1;if(Je>We)return 1}const He=Oe-Ie,Ke=ze-Te;return He<Ke?-1:He>Ke?1:0}e.$We=a;function f(me,Pe){return S(me,Pe,0,me.length,0,Pe.length)}e.$Xe=f;function S(me,Pe,Ie=0,Oe=me.length,Te=0,ze=Pe.length){for(;Ie<Oe&&Te<ze;Ie++,Te++){let Je=me.charCodeAt(Ie),We=Pe.charCodeAt(Te);if(Je===We)continue;if(Je>=128||We>=128)return a(me.toLowerCase(),Pe.toLowerCase(),Ie,Oe,Te,ze);E(Je)&&(Je-=32),E(We)&&(We-=32);const it=Je-We;if(it!==0)return it}const He=Oe-Ie,Ke=ze-Te;return He<Ke?-1:He>Ke?1:0}e.$Ye=S;function D(me){return me>=48&&me<=57}e.$Ze=D;function E(me){return me>=97&&me<=122}e.$1e=E;function P(me){return me>=65&&me<=90}e.$2e=P;function M(me,Pe){return me.length===Pe.length&&S(me,Pe)===0}e.$3e=M;function ee(me,Pe){const Ie=Pe.length;return Pe.length>me.length?!1:S(me,Pe,0,Ie)===0}e.$4e=ee;function se(me,Pe){const Ie=Math.min(me.length,Pe.length);let Oe;for(Oe=0;Oe<Ie;Oe++)if(me.charCodeAt(Oe)!==Pe.charCodeAt(Oe))return Oe;return Ie}e.$5e=se;function G(me,Pe){const Ie=Math.min(me.length,Pe.length);let Oe;const Te=me.length-1,ze=Pe.length-1;for(Oe=0;Oe<Ie;Oe++)if(me.charCodeAt(Te-Oe)!==Pe.charCodeAt(ze-Oe))return Oe;return Ie}e.$6e=G;function ne(me){return 55296<=me&&me<=56319}e.$7e=ne;function he(me){return 56320<=me&&me<=57343}e.$8e=he;function Z(me,Pe){return(me-55296<<10)+(Pe-56320)+65536}e.$9e=Z;function fe(me,Pe,Ie){const Oe=me.charCodeAt(Ie);if(ne(Oe)&&Ie+1<Pe){const Te=me.charCodeAt(Ie+1);if(he(Te))return Z(Oe,Te)}return Oe}e.$0e=fe;function V(me,Pe){const Ie=me.charCodeAt(Pe-1);if(he(Ie)&&Pe>1){const Oe=me.charCodeAt(Pe-2);if(ne(Oe))return Z(Oe,Ie)}return Ie}class ie{get offset(){return this.e}constructor(Pe,Ie=0){this.c=Pe,this.d=Pe.length,this.e=Ie}setOffset(Pe){this.e=Pe}prevCodePoint(){const Pe=V(this.c,this.e);return this.e-=Pe>=65536?2:1,Pe}nextCodePoint(){const Pe=fe(this.c,this.d,this.e);return this.e+=Pe>=65536?2:1,Pe}eol(){return this.e>=this.d}}e.$$e=ie;class Y{get offset(){return this.c.offset}constructor(Pe,Ie=0){this.c=new ie(Pe,Ie)}nextGraphemeLength(){const Pe=ve.getInstance(),Ie=this.c,Oe=Ie.offset;let Te=Pe.getGraphemeBreakType(Ie.nextCodePoint());for(;!Ie.eol();){const ze=Ie.offset,He=Pe.getGraphemeBreakType(Ie.nextCodePoint());if($e(Te,He)){Ie.setOffset(ze);break}Te=He}return Ie.offset-Oe}prevGraphemeLength(){const Pe=ve.getInstance(),Ie=this.c,Oe=Ie.offset;let Te=Pe.getGraphemeBreakType(Ie.prevCodePoint());for(;Ie.offset>0;){const ze=Ie.offset,He=Pe.getGraphemeBreakType(Ie.prevCodePoint());if($e(He,Te)){Ie.setOffset(ze);break}Te=He}return Oe-Ie.offset}eol(){return this.c.eol()}}e.$_e=Y;function J(me,Pe){return new Y(me,Pe).nextGraphemeLength()}e.$af=J;function re(me,Pe){return new Y(me,Pe).prevGraphemeLength()}e.$bf=re;function ce(me,Pe){Pe>0&&he(me.charCodeAt(Pe))&&Pe--;const Ie=Pe+J(me,Pe);return[Ie-re(me,Ie),Ie]}e.$cf=ce;function oe(me){const Pe=new Y(me);let Ie=0;for(;!Pe.eol();)Ie++,Pe.nextGraphemeLength();return Ie}e.$df=oe;let _;function q(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function Q(me){return _||(_=q()),_.test(me)}e.$ef=Q;const O=/^[\t\n\r\x20-\x7E]*$/;function N(me){return O.test(me)}e.$ff=N,e.$gf=/[\u2028\u2029]/;function U(me){return e.$gf.test(me)}e.$hf=U;function T(me){return me>=11904&&me<=55215||me>=63744&&me<=64255||me>=65281&&me<=65374}e.$if=T;function z(me){return me>=127462&&me<=127487||me===8986||me===8987||me===9200||me===9203||me>=9728&&me<=10175||me===11088||me===11093||me>=127744&&me<=128591||me>=128640&&me<=128764||me>=128992&&me<=129008||me>=129280&&me<=129535||me>=129648&&me<=129782}e.$jf=z;function B(me,Pe){if(me.length<Pe)return me;const Ie=/\b/g;let Oe=0;for(;Ie.test(me)&&!(me.length-Ie.lastIndex<Pe);)Oe=Ie.lastIndex,Ie.lastIndex+=1;return me.substring(Oe).replace(/^\s/,"")}e.$kf=B;const te=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,H=/\x1b\].*?\x07/g;function x(me){return me&&(me=me.replace(te,"").replace(H,"")),me}e.$lf=x,e.$mf=String.fromCharCode(65279);function W(me){return!!(me&&me.length>0&&me.charCodeAt(0)===65279)}e.$nf=W;function X(me){return W(me)?me.substr(1):me}e.$of=X;function ae(me,Pe){if(!me||!Pe||me.length<Pe.length)return!1;const Ie=Pe.length,Oe=me.toLowerCase();let Te=0,ze=-1;for(;Te<Ie;){const He=Oe.indexOf(Pe[Te],ze+1);if(He<0)return!1;ze=He,Te++}return!0}e.$pf=ae;function ge(me,Pe=!1){return me?(Pe&&(me=me.replace(/\\./g,"")),me.toLowerCase()!==me):!1}e.$qf=ge;function Ee(me){return me.charAt(0).toUpperCase()+me.slice(1)}e.$rf=Ee;function Ce(me,Pe=1){if(Pe===0)return"";let Ie=-1;do Ie=me.indexOf(`
`,Ie+1),Pe--;while(Pe>0&&Ie>=0);return Ie===-1?me:(me[Ie-1]==="\r"&&Ie--,me.substr(0,Ie))}e.$sf=Ce;function Ne(me){return me=me%(2*26),me<26?String.fromCharCode(97+me):String.fromCharCode(65+me-26)}e.$tf=Ne;function Fe(me){return ve.getInstance().getGraphemeBreakType(me)}e.$uf=Fe;function $e(me,Pe){return me===0?Pe!==5&&Pe!==7:me===2&&Pe===3?!1:me===4||me===2||me===3||Pe===4||Pe===2||Pe===3?!0:!(me===8&&(Pe===8||Pe===9||Pe===11||Pe===12)||(me===11||me===9)&&(Pe===9||Pe===10)||(me===12||me===10)&&Pe===10||Pe===5||Pe===13||Pe===7||me===1||me===13&&Pe===14||me===6&&Pe===6)}var ke;(function(me){me[me.Other=0]="Other",me[me.Prepend=1]="Prepend",me[me.CR=2]="CR",me[me.LF=3]="LF",me[me.Control=4]="Control",me[me.Extend=5]="Extend",me[me.Regional_Indicator=6]="Regional_Indicator",me[me.SpacingMark=7]="SpacingMark",me[me.L=8]="L",me[me.V=9]="V",me[me.T=10]="T",me[me.LV=11]="LV",me[me.LVT=12]="LVT",me[me.ZWJ=13]="ZWJ",me[me.Extended_Pictographic=14]="Extended_Pictographic"})(ke||(e.GraphemeBreakType=ke={}));class ve{static getInstance(){return ve.c||(ve.c=new ve),ve.c}constructor(){this.d=je()}getGraphemeBreakType(Pe){if(Pe<32)return Pe===10?3:Pe===13?2:4;if(Pe<127)return 0;const Ie=this.d,Oe=Ie.length/3;let Te=1;for(;Te<=Oe;)if(Pe<Ie[3*Te])Te=2*Te;else if(Pe>Ie[3*Te+1])Te=2*Te+1;else return Ie[3*Te+2];return 0}}ve.c=null;function je(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Be(me,Pe){if(me===0)return 0;const Ie=Ze(me,Pe);if(Ie!==void 0)return Ie;const Oe=new ie(Pe,me);return Oe.prevCodePoint(),Oe.offset}e.$vf=Be;function Ze(me,Pe){const Ie=new ie(Pe,me);let Oe=Ie.prevCodePoint();for(;qe(Oe)||Oe===65039||Oe===8419;){if(Ie.offset===0)return;Oe=Ie.prevCodePoint()}if(!z(Oe))return;let Te=Ie.offset;return Te>0&&Ie.prevCodePoint()===8205&&(Te=Ie.offset),Te}function qe(me){return 127995<=me&&me<=127999}var Qe;(function(me){me[me.zwj=8205]="zwj",me[me.emojiVariantSelector=65039]="emojiVariantSelector",me[me.enclosingKeyCap=8419]="enclosingKeyCap"})(Qe||(Qe={})),e.$wf="\xA0";class xe{static getInstance(Pe){return r.d.get(Array.from(Pe))}static getLocales(){return r.e.value}constructor(Pe){this.f=Pe}isAmbiguous(Pe){return this.f.has(Pe)}getPrimaryConfusable(Pe){return this.f.get(Pe)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$xf=xe,r=xe,xe.c=new R.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),xe.d=new y.$ye(me=>{function Pe(We){const it=new Map;for(let rt=0;rt<We.length;rt+=2)it.set(We[rt],We[rt+1]);return it}function Ie(We,it){const rt=new Map(We);for(const[et,mt]of it)rt.set(et,mt);return rt}function Oe(We,it){if(!We)return it;const rt=new Map;for(const[et,mt]of We)it.has(et)&&rt.set(et,mt);return rt}const Te=r.c.value;let ze=me.filter(We=>!We.startsWith("_")&&We in Te);ze.length===0&&(ze=["_default"]);let He;for(const We of ze){const it=Pe(Te[We]);He=Oe(He,it)}const Ke=Pe(Te._common),Je=Ie(Ke,He);return new r(Je)}),xe.e=new R.$V(()=>Object.keys(r.c.value).filter(me=>!me.startsWith("_")));class Xe{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static e(){return this.d||(this.d=new Set(Xe.c())),this.d}static isInvisibleCharacter(Pe){return Xe.e().has(Pe)}static get codePoints(){return Xe.e()}}e.$yf=Xe,Xe.d=void 0}),define(be[147],we([1,0,26,17]),function(ue,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sj=e.$Rj=e.$Qj=e.$Pj=e.FuzzyScore=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.or=void 0;function r(...W){return function(X,ae){for(let ge=0,Ee=W.length;ge<Ee;ge++){const Ce=W[ge](X,ae);if(Ce)return Ce}return null}}e.or=r,e.$Dj=L.bind(void 0,!1),e.$Ej=L.bind(void 0,!0);function L(W,X,ae){if(!ae||ae.length<X.length)return null;let ge;return W?ge=R.$4e(ae,X):ge=ae.indexOf(X)===0,ge?X.length>0?[{start:0,end:X.length}]:[]:null}function I(W,X){const ae=X.toLowerCase().indexOf(W.toLowerCase());return ae===-1?null:[{start:ae,end:ae+W.length}]}e.$Fj=I;function C(W,X){return p(W.toLowerCase(),X.toLowerCase(),0,0)}e.$Gj=C;function p(W,X,ae,ge){if(ae===W.length)return[];if(ge===X.length)return null;if(W[ae]===X[ge]){let Ee=null;return(Ee=p(W,X,ae+1,ge+1))?h({start:ge,end:ge+1},Ee):null}return p(W,X,ae,ge+1)}function w(W){return 97<=W&&W<=122}function A(W){return 65<=W&&W<=90}e.$Hj=A;function k(W){return 48<=W&&W<=57}function v(W){return W===32||W===9||W===10||W===13}const u=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(W=>u.add(W.charCodeAt(0)));function b(W){return v(W)||u.has(W)}function m(W,X){return W===X||b(W)&&b(X)}function d(W){return w(W)||A(W)||k(W)}function h(W,X){return X.length===0?X=[W]:W.end===X[0].start?X[0].start=W.start:X.unshift(W),X}function g(W,X){for(let ae=X;ae<W.length;ae++){const ge=W.charCodeAt(ae);if(A(ge)||k(ge)||ae>0&&!d(W.charCodeAt(ae-1)))return ae}return W.length}function l(W,X,ae,ge){if(ae===W.length)return[];if(ge===X.length)return null;if(W[ae]!==X[ge].toLowerCase())return null;{let Ee=null,Ce=ge+1;for(Ee=l(W,X,ae+1,ge+1);!Ee&&(Ce=g(X,Ce))<X.length;)Ee=l(W,X,ae+1,Ce),Ce++;return Ee===null?null:h({start:ge,end:ge+1},Ee)}}function $(W){let X=0,ae=0,ge=0,Ee=0,Ce=0;for(let ve=0;ve<W.length;ve++)Ce=W.charCodeAt(ve),A(Ce)&&X++,w(Ce)&&ae++,d(Ce)&&ge++,k(Ce)&&Ee++;const Ne=X/W.length,Fe=ae/W.length,$e=ge/W.length,ke=Ee/W.length;return{upperPercent:Ne,lowerPercent:Fe,alphaPercent:$e,numericPercent:ke}}function c(W){const{upperPercent:X,lowerPercent:ae}=W;return ae===0&&X>.6}function n(W){const{upperPercent:X,lowerPercent:ae,alphaPercent:ge,numericPercent:Ee}=W;return ae>.2&&X<.8&&ge>.6&&Ee<.2}function i(W){let X=0,ae=0,ge=0,Ee=0;for(let Ce=0;Ce<W.length;Ce++)ge=W.charCodeAt(Ce),A(ge)&&X++,w(ge)&&ae++,v(ge)&&Ee++;return(X===0||ae===0)&&Ee===0?W.length<=30:X<=5}function o(W,X){if(!X||(X=X.trim(),X.length===0)||!i(W)||X.length>60)return null;const ae=$(X);if(!n(ae)){if(!c(ae))return null;X=X.toLowerCase()}let ge=null,Ee=0;for(W=W.toLowerCase();Ee<X.length&&(ge=l(W,X,0,Ee))===null;)Ee=g(X,Ee+1);return ge}e.$Ij=o;function s(W,X,ae=!1){if(!X||X.length===0)return null;let ge=null,Ee=0;for(W=W.toLowerCase(),X=X.toLowerCase();Ee<X.length&&(ge=t(W,X,0,Ee,ae))===null;)Ee=a(X,Ee+1);return ge}e.$Jj=s;function t(W,X,ae,ge,Ee){if(ae===W.length)return[];if(ge===X.length)return null;if(m(W.charCodeAt(ae),X.charCodeAt(ge))){let Ce=null,Ne=ge+1;if(Ce=t(W,X,ae+1,ge+1,Ee),!Ee)for(;!Ce&&(Ne=a(X,Ne))<X.length;)Ce=t(W,X,ae+1,Ne,Ee),Ne++;return Ce?W.charCodeAt(ae)!==X.charCodeAt(ge)?Ce:h({start:ge,end:ge+1},Ce):null}else return null}function a(W,X){for(let ae=X;ae<W.length;ae++)if(b(W.charCodeAt(ae))||ae>0&&b(W.charCodeAt(ae-1)))return ae;return W.length}const f=r(e.$Ej,o,I),S=r(e.$Ej,o,C),D=new y.$Dc(1e4);function E(W,X,ae=!1){if(typeof W!="string"||typeof X!="string")return null;let ge=D.get(W);ge||(ge=new RegExp(R.$Me(W),"i"),D.set(W,ge));const Ee=ge.exec(X);return Ee?[{start:Ee.index,end:Ee.index+Ee[0].length}]:ae?S(W,X):f(W,X)}e.$Kj=E;function P(W,X){const ae=U(W,W.toLowerCase(),0,X,X.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return ae?ee(ae):null}e.$Lj=P;function M(W,X,ae,ge,Ee,Ce){const Ne=Math.min(13,W.length);for(;ae<Ne;ae++){const Fe=U(W,X,ae,ge,Ee,Ce,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(Fe)return Fe}return[0,Ce]}e.$Mj=M;function ee(W){if(typeof W>"u")return[];const X=[],ae=W[1];for(let ge=W.length-1;ge>1;ge--){const Ee=W[ge]+ae,Ce=X[X.length-1];Ce&&Ce.end===Ee?Ce.end=Ee+1:X.push({start:Ee,end:Ee+1})}return X}e.$Nj=ee;const se=128;function G(){const W=[],X=[];for(let ae=0;ae<=se;ae++)X[ae]=0;for(let ae=0;ae<=se;ae++)W.push(X.slice(0));return W}function ne(W){const X=[];for(let ae=0;ae<=W;ae++)X[ae]=0;return X}const he=ne(2*se),Z=ne(2*se),fe=G(),V=G(),ie=G(),Y=!1;function J(W,X,ae,ge,Ee){function Ce(Fe,$e,ke=" "){for(;Fe.length<$e;)Fe=ke+Fe;return Fe}let Ne=` |   |${ge.split("").map(Fe=>Ce(Fe,3)).join("|")}
`;for(let Fe=0;Fe<=ae;Fe++)Fe===0?Ne+=" |":Ne+=`${X[Fe-1]}|`,Ne+=W[Fe].slice(0,Ee+1).map($e=>Ce($e.toString(),3)).join("|")+`
`;return Ne}function re(W,X,ae,ge){W=W.substr(X),ae=ae.substr(ge),console.log(J(V,W,W.length,ae,ae.length)),console.log(J(ie,W,W.length,ae,ae.length)),console.log(J(fe,W,W.length,ae,ae.length))}function ce(W,X){if(X<0||X>=W.length)return!1;const ae=W.codePointAt(X);switch(ae){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!R.$jf(ae)}}function oe(W,X){if(X<0||X>=W.length)return!1;switch(W.charCodeAt(X)){case 32:case 9:return!0;default:return!1}}function _(W,X,ae){return X[W]!==ae[W]}function q(W,X,ae,ge,Ee,Ce,Ne=!1){for(;X<ae&&Ee<Ce;)W[X]===ge[Ee]&&(Ne&&(he[X]=Ee),X+=1),Ee+=1;return X===ae}e.$Oj=q;var Q;(function(W){W[W.Diag=1]="Diag",W[W.Left=2]="Left",W[W.LeftLeft=3]="LeftLeft"})(Q||(Q={}));var O;(function(W){W.Default=[-100,0];function X(ae){return!ae||ae.length===2&&ae[0]===-100&&ae[1]===0}W.isDefault=X})(O||(e.FuzzyScore=O={}));class N{constructor(X,ae){this.firstMatchCanBeWeak=X,this.boostFullMatch=ae}}e.$Pj=N,N.default={boostFullMatch:!0,firstMatchCanBeWeak:!1};function U(W,X,ae,ge,Ee,Ce,Ne=N.default){const Fe=W.length>se?se:W.length,$e=ge.length>se?se:ge.length;if(ae>=Fe||Ce>=$e||Fe-ae>$e-Ce||!q(X,ae,Fe,Ee,Ce,$e,!0))return;T(Fe,$e,ae,Ce,X,Ee);let ke=1,ve=1,je=ae,Be=Ce;const Ze=[!1];for(ke=1,je=ae;je<Fe;ke++,je++){const me=he[je],Pe=Z[je],Ie=je+1<Fe?Z[je+1]:$e;for(ve=me-Ce+1,Be=me;Be<Ie;ve++,Be++){let Oe=Number.MIN_SAFE_INTEGER,Te=!1;Be<=Pe&&(Oe=z(W,X,je,ae,ge,Ee,Be,$e,Ce,fe[ke-1][ve-1]===0,Ze));let ze=0;Oe!==Number.MAX_SAFE_INTEGER&&(Te=!0,ze=Oe+V[ke-1][ve-1]);const He=Be>me,Ke=He?V[ke][ve-1]+(fe[ke][ve-1]>0?-5:0):0,Je=Be>me+1&&fe[ke][ve-1]>0,We=Je?V[ke][ve-2]+(fe[ke][ve-2]>0?-5:0):0;if(Je&&(!He||We>=Ke)&&(!Te||We>=ze))V[ke][ve]=We,ie[ke][ve]=3,fe[ke][ve]=0;else if(He&&(!Te||Ke>=ze))V[ke][ve]=Ke,ie[ke][ve]=2,fe[ke][ve]=0;else if(Te)V[ke][ve]=ze,ie[ke][ve]=1,fe[ke][ve]=fe[ke-1][ve-1]+1;else throw new Error("not possible")}}if(Y&&re(W,ae,ge,Ce),!Ze[0]&&!Ne.firstMatchCanBeWeak)return;ke--,ve--;const qe=[V[ke][ve],Ce];let Qe=0,xe=0;for(;ke>=1;){let me=ve;do{const Pe=ie[ke][me];if(Pe===3)me=me-2;else if(Pe===2)me=me-1;else break}while(me>=1);Qe>1&&X[ae+ke-1]===Ee[Ce+ve-1]&&!_(me+Ce-1,ge,Ee)&&Qe+1>fe[ke][me]&&(me=ve),me===ve?Qe++:Qe=1,xe||(xe=me),ke--,ve=me-1,qe.push(ve)}$e===Fe&&Ne.boostFullMatch&&(qe[0]+=2);const Xe=xe-Fe;return qe[0]-=Xe,qe}e.$Qj=U;function T(W,X,ae,ge,Ee,Ce){let Ne=W-1,Fe=X-1;for(;Ne>=ae&&Fe>=ge;)Ee[Ne]===Ce[Fe]&&(Z[Ne]=Fe,Ne--),Fe--}function z(W,X,ae,ge,Ee,Ce,Ne,Fe,$e,ke,ve){if(X[ae]!==Ce[Ne])return Number.MIN_SAFE_INTEGER;let je=1,Be=!1;return Ne===ae-ge?je=W[ae]===Ee[Ne]?7:5:_(Ne,Ee,Ce)&&(Ne===0||!_(Ne-1,Ee,Ce))?(je=W[ae]===Ee[Ne]?7:5,Be=!0):ce(Ce,Ne)&&(Ne===0||!ce(Ce,Ne-1))?je=5:(ce(Ce,Ne-1)||oe(Ce,Ne-1))&&(je=5,Be=!0),je>1&&ae===ge&&(ve[0]=!0),Be||(Be=_(Ne,Ee,Ce)||ce(Ce,Ne-1)||oe(Ce,Ne-1)),ae===ge?Ne>$e&&(je-=Be?3:5):ke?je+=Be?2:0:je+=Be?0:1,Ne+1===Fe&&(je-=Be?3:5),je}function B(W,X,ae,ge,Ee,Ce,Ne){return H(W,X,ae,ge,Ee,Ce,!0,Ne)}e.$Rj=B;function te(W,X,ae,ge,Ee,Ce,Ne){return H(W,X,ae,ge,Ee,Ce,!1,Ne)}e.$Sj=te;function H(W,X,ae,ge,Ee,Ce,Ne,Fe){let $e=U(W,X,ae,ge,Ee,Ce,Fe);if($e&&!Ne)return $e;if(W.length>=3){const ke=Math.min(7,W.length-1);for(let ve=ae+1;ve<ke;ve++){const je=x(W,ve);if(je){const Be=U(je,je.toLowerCase(),ae,ge,Ee,Ce,Fe);Be&&(Be[0]-=3,(!$e||Be[0]>$e[0])&&($e=Be))}}}return $e}function x(W,X){if(X+1>=W.length)return;const ae=W[X],ge=W[X+1];if(ae!==ge)return W.slice(0,X)+ge+ae+W.slice(X+2)}}),define(be[62],we([1,0,17]),function(ue,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ki=e.$Ji=e.$Ii=e.$Hi=e.$Gi=e.$Fi=e.$Ei=void 0;function R(h){return r(h,0)}e.$Ei=R;function r(h,g){switch(typeof h){case"object":return h===null?L(349,g):Array.isArray(h)?p(h,g):w(h,g);case"string":return C(h,g);case"boolean":return I(h,g);case"number":return L(h,g);case"undefined":return L(937,g);default:return L(617,g)}}e.$Fi=r;function L(h,g){return(g<<5)-g+h|0}e.$Gi=L;function I(h,g){return L(h?433:863,g)}function C(h,g){g=L(149417,g);for(let l=0,$=h.length;l<$;l++)g=L(h.charCodeAt(l),g);return g}e.$Hi=C;function p(h,g){return g=L(104579,g),h.reduce((l,$)=>r($,l),g)}function w(h,g){return g=L(181387,g),Object.keys(h).sort().reduce((l,$)=>(l=C($,l),r(h[$],l)),g)}class A{constructor(){this.g=0}get value(){return this.g}hash(g){return this.g=r(g,this.g),this.g}}e.$Ii=A;var k;(function(h){h[h.BLOCK_SIZE=64]="BLOCK_SIZE",h[h.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(k||(k={}));function v(h,g,l=32){const $=l-g,c=~((1<<$)-1);return(h<<g|(c&h)>>>$)>>>0}function u(h,g=0,l=h.byteLength,$=0){for(let c=0;c<l;c++)h[g+c]=$}function b(h,g,l="0"){for(;h.length<g;)h=l+h;return h}function m(h,g=32){return h instanceof ArrayBuffer?Array.from(new Uint8Array(h)).map(l=>l.toString(16).padStart(2,"0")).join(""):b((h>>>0).toString(16),g/4)}e.$Ji=m;class d{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(g){const l=g.length;if(l===0)return;const $=this.p;let c=this.r,n=this.u,i,o;for(n!==0?(i=n,o=-1,n=0):(i=g.charCodeAt(0),o=0);;){let s=i;if(y.$7e(i))if(o+1<l){const t=g.charCodeAt(o+1);y.$8e(t)?(o++,s=y.$9e(i,t)):s=65533}else{n=i;break}else y.$8e(i)&&(s=65533);if(c=this.w($,c,s),o++,o<l)i=g.charCodeAt(o);else break}this.r=c,this.u=n}w(g,l,$){return $<128?g[l++]=$:$<2048?(g[l++]=192|($&1984)>>>6,g[l++]=128|($&63)>>>0):$<65536?(g[l++]=224|($&61440)>>>12,g[l++]=128|($&4032)>>>6,g[l++]=128|($&63)>>>0):(g[l++]=240|($&1835008)>>>18,g[l++]=128|($&258048)>>>12,g[l++]=128|($&4032)>>>6,g[l++]=128|($&63)>>>0),l>=64&&(this.y(),l-=64,this.t+=64,g[0]=g[64+0],g[1]=g[64+1],g[2]=g[64+2]),l}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),m(this.h)+m(this.l)+m(this.m)+m(this.n)+m(this.o)}x(){this.p[this.r++]=128,u(this.p,this.r),this.r>56&&(this.y(),u(this.p));const g=8*this.t;this.q.setUint32(56,Math.floor(g/4294967296),!1),this.q.setUint32(60,g%4294967296,!1),this.y()}y(){const g=d.g,l=this.q;for(let f=0;f<64;f+=4)g.setUint32(f,l.getUint32(f,!1),!1);for(let f=64;f<320;f+=4)g.setUint32(f,v(g.getUint32(f-12,!1)^g.getUint32(f-32,!1)^g.getUint32(f-56,!1)^g.getUint32(f-64,!1),1),!1);let $=this.h,c=this.l,n=this.m,i=this.n,o=this.o,s,t,a;for(let f=0;f<80;f++)f<20?(s=c&n|~c&i,t=1518500249):f<40?(s=c^n^i,t=1859775393):f<60?(s=c&n|c&i|n&i,t=2400959708):(s=c^n^i,t=3395469782),a=v($,5)+s+o+t+g.getUint32(f*4,!1)&4294967295,o=i,i=n,n=v(c,30),c=$,$=a;this.h=this.h+$&4294967295,this.l=this.l+c&4294967295,this.m=this.m+n&4294967295,this.n=this.n+i&4294967295,this.o=this.o+o&4294967295}}e.$Ki=d,d.g=new DataView(new ArrayBuffer(320))}),define(be[63],we([1,0,17]),function(ue,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var R;(function(r){r[r.Ignore=0]="Ignore",r[r.Info=1]="Info",r[r.Warning=2]="Warning",r[r.Error=3]="Error"})(R||(R={})),function(r){const L="error",I="warning",C="warn",p="info",w="ignore";function A(v){return v?y.$3e(L,v)?r.Error:y.$3e(I,v)||y.$3e(C,v)?r.Warning:y.$3e(p,v)?r.Info:r.Ignore:r.Ignore}r.fromValue=A;function k(v){switch(v){case r.Error:return L;case r.Warning:return I;case r.Info:return p;default:return w}}r.toString=k}(R||(R={})),e.default=R}),define(be[148],we([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ld=void 0,e.$Ld=Symbol("MicrotaskDelay")}),define(be[64],we([1,0,18,17]),function(ue,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wh=e.$Vh=e.$Uh=e.$Th=e.$Sh=void 0;class r{constructor(){this.b="",this.c=0}reset(u){return this.b=u,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(u){const b=u.charCodeAt(0),m=this.b.charCodeAt(this.c);return b-m}value(){return this.b[this.c]}}e.$Sh=r;class L{constructor(u=!0){this.e=u}reset(u){return this.b=u,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let u=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(u)this.c++;else break;else u=!1;return this}cmp(u){return this.e?(0,R.$We)(u,this.b,0,u.length,this.c,this.d):(0,R.$Ye)(u,this.b,0,u.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Th=L;class I{constructor(u=!0,b=!0){this.f=u,this.g=b}reset(u){this.d=0,this.e=0,this.b=u,this.c=u.length;for(let b=u.length-1;b>=0;b--,this.c--){const m=this.b.charCodeAt(b);if(!(m===47||this.f&&m===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let u=!0;for(;this.e<this.c;this.e++){const b=this.b.charCodeAt(this.e);if(b===47||this.f&&b===92)if(u)this.d++;else break;else u=!1}return this}cmp(u){return this.g?(0,R.$We)(u,this.b,0,u.length,this.d,this.e):(0,R.$Ye)(u,this.b,0,u.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Uh=I;var C;(function(v){v[v.Scheme=1]="Scheme",v[v.Authority=2]="Authority",v[v.Path=3]="Path",v[v.Query=4]="Query",v[v.Fragment=5]="Fragment"})(C||(C={}));class p{constructor(u,b){this.f=u,this.g=b,this.d=[],this.e=0}reset(u){return this.c=u,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new I(!1,!this.f(u)),this.b.reset(u.path),this.b.value()&&this.d.push(3)),this.g(u)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(u){if(this.d[this.e]===1)return(0,R.$Xe)(u,this.c.scheme);if(this.d[this.e]===2)return(0,R.$Xe)(u,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(u);if(this.d[this.e]===4)return(0,R.$Ve)(u,this.c.query);if(this.d[this.e]===5)return(0,R.$Ve)(u,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$Vh=p;class w{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const u=this.right;return this.right=u.left,u.left=this,this.updateHeight(),u.updateHeight(),u}rotateRight(){const u=this.left;return this.left=u.right,u.right=this,this.updateHeight(),u.updateHeight(),u}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var A;(function(v){v[v.Left=-1]="Left",v[v.Mid=0]="Mid",v[v.Right=1]="Right"})(A||(A={}));class k{static forUris(u=()=>!1,b=()=>!1){return new k(new p(u,b))}static forPaths(u=!1){return new k(new I(void 0,!u))}static forStrings(){return new k(new r)}static forConfigKeys(){return new k(new L)}constructor(u){this.b=u}clear(){this.c=void 0}fill(u,b){if(b){const m=b.slice(0);(0,y.$Xb)(m);for(const d of m)this.set(d,u)}else{const m=u.slice(0);(0,y.$Xb)(m);for(const d of m)this.set(d[0],d[1])}}set(u,b){const m=this.b.reset(u);let d;this.c||(this.c=new w,this.c.segment=m.value());const h=[];for(d=this.c;;){const l=m.cmp(d.segment);if(l>0)d.left||(d.left=new w,d.left.segment=m.value()),h.push([-1,d]),d=d.left;else if(l<0)d.right||(d.right=new w,d.right.segment=m.value()),h.push([1,d]),d=d.right;else if(m.hasNext())m.next(),d.mid||(d.mid=new w,d.mid.segment=m.value()),h.push([0,d]),d=d.mid;else break}const g=d.value;d.value=b,d.key=u;for(let l=h.length-1;l>=0;l--){const $=h[l][1];$.updateHeight();const c=$.balanceFactor();if(c<-1||c>1){const n=h[l][0],i=h[l+1][0];if(n===1&&i===1)h[l][1]=$.rotateLeft();else if(n===-1&&i===-1)h[l][1]=$.rotateRight();else if(n===1&&i===-1)$.right=h[l+1][1]=h[l+1][1].rotateRight(),h[l][1]=$.rotateLeft();else if(n===-1&&i===1)$.left=h[l+1][1]=h[l+1][1].rotateLeft(),h[l][1]=$.rotateRight();else throw new Error;if(l>0)switch(h[l-1][0]){case-1:h[l-1][1].left=h[l][1];break;case 1:h[l-1][1].right=h[l][1];break;case 0:h[l-1][1].mid=h[l][1];break}else this.c=h[0][1]}}return g}get(u){return this.d(u)?.value}d(u){const b=this.b.reset(u);let m=this.c;for(;m;){const d=b.cmp(m.segment);if(d>0)m=m.left;else if(d<0)m=m.right;else if(b.hasNext())b.next(),m=m.mid;else break}return m}has(u){const b=this.d(u);return!(b?.value===void 0&&b?.mid===void 0)}delete(u){return this.e(u,!1)}deleteSuperstr(u){return this.e(u,!0)}e(u,b){const m=this.b.reset(u),d=[];let h=this.c;for(;h;){const g=m.cmp(h.segment);if(g>0)d.push([-1,h]),h=h.left;else if(g<0)d.push([1,h]),h=h.right;else if(m.hasNext())m.next(),d.push([0,h]),h=h.mid;else break}if(h){if(b?(h.left=void 0,h.mid=void 0,h.right=void 0,h.height=1):(h.key=void 0,h.value=void 0),!h.mid&&!h.value)if(h.left&&h.right){const g=this.f(h.right);if(g.key){const{key:l,value:$,segment:c}=g;this.e(g.key,!1),h.key=l,h.value=$,h.segment=c}}else{const g=h.left??h.right;if(d.length>0){const[l,$]=d[d.length-1];switch(l){case-1:$.left=g;break;case 0:$.mid=g;break;case 1:$.right=g;break}}else this.c=g}for(let g=d.length-1;g>=0;g--){const l=d[g][1];l.updateHeight();const $=l.balanceFactor();if($>1?(l.right.balanceFactor()>=0||(l.right=l.right.rotateRight()),d[g][1]=l.rotateLeft()):$<-1&&(l.left.balanceFactor()<=0||(l.left=l.left.rotateLeft()),d[g][1]=l.rotateRight()),g>0)switch(d[g-1][0]){case-1:d[g-1][1].left=d[g][1];break;case 1:d[g-1][1].right=d[g][1];break;case 0:d[g-1][1].mid=d[g][1];break}else this.c=d[0][1]}}}f(u){for(;u.left;)u=u.left;return u}findSubstr(u){const b=this.b.reset(u);let m=this.c,d;for(;m;){const h=b.cmp(m.segment);if(h>0)m=m.left;else if(h<0)m=m.right;else if(b.hasNext())b.next(),d=m.value||d,m=m.mid;else break}return m&&m.value||d}findSuperstr(u){return this.g(u,!1)}g(u,b){const m=this.b.reset(u);let d=this.c;for(;d;){const h=m.cmp(d.segment);if(h>0)d=d.left;else if(h<0)d=d.right;else if(m.hasNext())m.next(),d=d.mid;else return d.mid?this.h(d.mid):b?d.value:void 0}}hasElementOrSubtree(u){return this.g(u,!0)!==void 0}forEach(u){for(const[b,m]of this)u(m,b)}*[Symbol.iterator](){yield*this.h(this.c)}h(u){const b=[];return this.j(u,b),b[Symbol.iterator]()}j(u,b){u&&(u.left&&this.j(u.left,b),u.value&&b.push([u.key,u.value]),u.mid&&this.j(u.mid,b),u.right&&this.j(u.right,b))}_isBalanced(){const u=b=>{if(!b)return!0;const m=b.balanceFactor();return m<-1||m>1?!1:u(b.left)&&u(b.right)};return u(this.c)}}e.$Wh=k}),define(be[8],we([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qf=e.$Pf=e.$Of=e.$Nf=e.$Mf=e.$Lf=e.$Kf=e.$Jf=e.$If=e.$Hf=e.$Gf=e.$Ff=e.$Ef=e.$Df=e.$Cf=e.$Bf=e.$Af=e.$zf=void 0;function y(c){return typeof c=="string"}e.$zf=y;function R(c){return Array.isArray(c)&&c.every(n=>y(n))}e.$Af=R;function r(c){return typeof c=="object"&&c!==null&&!Array.isArray(c)&&!(c instanceof RegExp)&&!(c instanceof Date)}e.$Bf=r;function L(c){const n=Object.getPrototypeOf(Uint8Array);return typeof c=="object"&&c instanceof n}e.$Cf=L;function I(c){return typeof c=="number"&&!isNaN(c)}e.$Df=I;function C(c){return!!c&&typeof c[Symbol.iterator]=="function"}e.$Ef=C;function p(c){return c===!0||c===!1}e.$Ff=p;function w(c){return typeof c>"u"}e.$Gf=w;function A(c){return!k(c)}e.$Hf=A;function k(c){return w(c)||c===null}e.$If=k;function v(c,n){if(!c)throw new Error(n?`Unexpected type, expected '${n}'`:"Unexpected type")}e.$Jf=v;function u(c){if(k(c))throw new Error("Assertion Failed: argument is undefined or null");return c}e.$Kf=u;function b(...c){const n=[];for(let i=0;i<c.length;i++){const o=c[i];if(k(o))throw new Error(`Assertion Failed: argument at index ${i} is undefined or null`);n.push(o)}return n}e.$Lf=b;const m=Object.prototype.hasOwnProperty;function d(c){if(!r(c))return!1;for(const n in c)if(m.call(c,n))return!1;return!0}e.$Mf=d;function h(c){return typeof c=="function"}e.$Nf=h;function g(...c){return c.length>0&&c.every(h)}e.$Of=g;function l(c,n){const i=Math.min(c.length,n.length);for(let o=0;o<i;o++)$(c[o],n[o])}e.$Pf=l;function $(c,n){if(y(n)){if(typeof c!==n)throw new Error(`argument does not match constraint: typeof ${n}`)}else if(h(n)){try{if(c instanceof n)return}catch{}if(!k(c)&&c.constructor===n||n.length===1&&n.call(void 0,c)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.$Qf=$}),define(be[49],we([1,0,8]),function(ue,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vj=e.$Uj=e.$Tj=void 0;const R=Object.create(null);function r(C,p){if((0,y.$zf)(p)){const w=R[p];if(w===void 0)throw new Error(`${C} references an unknown codicon: ${p}`);p=w}return R[C]=p,{id:C}}function L(){return R}e.$Tj=L;function I(){return Object.values(e.$Vj)}e.$Uj=I,e.$Vj={add:r("add",6e4),plus:r("plus",6e4),gistNew:r("gist-new",6e4),repoCreate:r("repo-create",6e4),lightbulb:r("lightbulb",60001),lightBulb:r("light-bulb",60001),repo:r("repo",60002),repoDelete:r("repo-delete",60002),gistFork:r("gist-fork",60003),repoForked:r("repo-forked",60003),gitPullRequest:r("git-pull-request",60004),gitPullRequestAbandoned:r("git-pull-request-abandoned",60004),recordKeys:r("record-keys",60005),keyboard:r("keyboard",60005),tag:r("tag",60006),tagAdd:r("tag-add",60006),tagRemove:r("tag-remove",60006),gitPullRequestLabel:r("git-pull-request-label",60006),person:r("person",60007),personFollow:r("person-follow",60007),personOutline:r("person-outline",60007),personFilled:r("person-filled",60007),gitBranch:r("git-branch",60008),gitBranchCreate:r("git-branch-create",60008),gitBranchDelete:r("git-branch-delete",60008),sourceControl:r("source-control",60008),mirror:r("mirror",60009),mirrorPublic:r("mirror-public",60009),star:r("star",60010),starAdd:r("star-add",60010),starDelete:r("star-delete",60010),starEmpty:r("star-empty",60010),comment:r("comment",60011),commentAdd:r("comment-add",60011),alert:r("alert",60012),warning:r("warning",60012),search:r("search",60013),searchSave:r("search-save",60013),logOut:r("log-out",60014),signOut:r("sign-out",60014),logIn:r("log-in",60015),signIn:r("sign-in",60015),eye:r("eye",60016),eyeUnwatch:r("eye-unwatch",60016),eyeWatch:r("eye-watch",60016),circleFilled:r("circle-filled",60017),primitiveDot:r("primitive-dot",60017),closeDirty:r("close-dirty",60017),debugBreakpoint:r("debug-breakpoint",60017),debugBreakpointDisabled:r("debug-breakpoint-disabled",60017),debugHint:r("debug-hint",60017),primitiveSquare:r("primitive-square",60018),edit:r("edit",60019),pencil:r("pencil",60019),info:r("info",60020),issueOpened:r("issue-opened",60020),gistPrivate:r("gist-private",60021),gitForkPrivate:r("git-fork-private",60021),lock:r("lock",60021),mirrorPrivate:r("mirror-private",60021),close:r("close",60022),removeClose:r("remove-close",60022),x:r("x",60022),repoSync:r("repo-sync",60023),sync:r("sync",60023),clone:r("clone",60024),desktopDownload:r("desktop-download",60024),beaker:r("beaker",60025),microscope:r("microscope",60025),vm:r("vm",60026),deviceDesktop:r("device-desktop",60026),file:r("file",60027),fileText:r("file-text",60027),more:r("more",60028),ellipsis:r("ellipsis",60028),kebabHorizontal:r("kebab-horizontal",60028),mailReply:r("mail-reply",60029),reply:r("reply",60029),organization:r("organization",60030),organizationFilled:r("organization-filled",60030),organizationOutline:r("organization-outline",60030),newFile:r("new-file",60031),fileAdd:r("file-add",60031),newFolder:r("new-folder",60032),fileDirectoryCreate:r("file-directory-create",60032),trash:r("trash",60033),trashcan:r("trashcan",60033),history:r("history",60034),clock:r("clock",60034),folder:r("folder",60035),fileDirectory:r("file-directory",60035),symbolFolder:r("symbol-folder",60035),logoGithub:r("logo-github",60036),markGithub:r("mark-github",60036),github:r("github",60036),terminal:r("terminal",60037),console:r("console",60037),repl:r("repl",60037),zap:r("zap",60038),symbolEvent:r("symbol-event",60038),error:r("error",60039),stop:r("stop",60039),variable:r("variable",60040),symbolVariable:r("symbol-variable",60040),array:r("array",60042),symbolArray:r("symbol-array",60042),symbolModule:r("symbol-module",60043),symbolPackage:r("symbol-package",60043),symbolNamespace:r("symbol-namespace",60043),symbolObject:r("symbol-object",60043),symbolMethod:r("symbol-method",60044),symbolFunction:r("symbol-function",60044),symbolConstructor:r("symbol-constructor",60044),symbolBoolean:r("symbol-boolean",60047),symbolNull:r("symbol-null",60047),symbolNumeric:r("symbol-numeric",60048),symbolNumber:r("symbol-number",60048),symbolStructure:r("symbol-structure",60049),symbolStruct:r("symbol-struct",60049),symbolParameter:r("symbol-parameter",60050),symbolTypeParameter:r("symbol-type-parameter",60050),symbolKey:r("symbol-key",60051),symbolText:r("symbol-text",60051),symbolReference:r("symbol-reference",60052),goToFile:r("go-to-file",60052),symbolEnum:r("symbol-enum",60053),symbolValue:r("symbol-value",60053),symbolRuler:r("symbol-ruler",60054),symbolUnit:r("symbol-unit",60054),activateBreakpoints:r("activate-breakpoints",60055),archive:r("archive",60056),arrowBoth:r("arrow-both",60057),arrowDown:r("arrow-down",60058),arrowLeft:r("arrow-left",60059),arrowRight:r("arrow-right",60060),arrowSmallDown:r("arrow-small-down",60061),arrowSmallLeft:r("arrow-small-left",60062),arrowSmallRight:r("arrow-small-right",60063),arrowSmallUp:r("arrow-small-up",60064),arrowUp:r("arrow-up",60065),bell:r("bell",60066),bold:r("bold",60067),book:r("book",60068),bookmark:r("bookmark",60069),debugBreakpointConditionalUnverified:r("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:r("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:r("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:r("debug-breakpoint-data-unverified",60072),debugBreakpointData:r("debug-breakpoint-data",60073),debugBreakpointDataDisabled:r("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:r("debug-breakpoint-log-unverified",60074),debugBreakpointLog:r("debug-breakpoint-log",60075),debugBreakpointLogDisabled:r("debug-breakpoint-log-disabled",60075),briefcase:r("briefcase",60076),broadcast:r("broadcast",60077),browser:r("browser",60078),bug:r("bug",60079),calendar:r("calendar",60080),caseSensitive:r("case-sensitive",60081),check:r("check",60082),checklist:r("checklist",60083),chevronDown:r("chevron-down",60084),dropDownButton:r("drop-down-button",60084),chevronLeft:r("chevron-left",60085),chevronRight:r("chevron-right",60086),chevronUp:r("chevron-up",60087),chromeClose:r("chrome-close",60088),chromeMaximize:r("chrome-maximize",60089),chromeMinimize:r("chrome-minimize",60090),chromeRestore:r("chrome-restore",60091),circle:r("circle",60092),circleOutline:r("circle-outline",60092),debugBreakpointUnverified:r("debug-breakpoint-unverified",60092),circleSlash:r("circle-slash",60093),circuitBoard:r("circuit-board",60094),clearAll:r("clear-all",60095),clippy:r("clippy",60096),closeAll:r("close-all",60097),cloudDownload:r("cloud-download",60098),cloudUpload:r("cloud-upload",60099),code:r("code",60100),collapseAll:r("collapse-all",60101),colorMode:r("color-mode",60102),commentDiscussion:r("comment-discussion",60103),compareChanges:r("compare-changes",60157),creditCard:r("credit-card",60105),dash:r("dash",60108),dashboard:r("dashboard",60109),database:r("database",60110),debugContinue:r("debug-continue",60111),debugDisconnect:r("debug-disconnect",60112),debugPause:r("debug-pause",60113),debugRestart:r("debug-restart",60114),debugStart:r("debug-start",60115),debugStepInto:r("debug-step-into",60116),debugStepOut:r("debug-step-out",60117),debugStepOver:r("debug-step-over",60118),debugStop:r("debug-stop",60119),debug:r("debug",60120),deviceCameraVideo:r("device-camera-video",60121),deviceCamera:r("device-camera",60122),deviceMobile:r("device-mobile",60123),diffAdded:r("diff-added",60124),diffIgnored:r("diff-ignored",60125),diffModified:r("diff-modified",60126),diffRemoved:r("diff-removed",60127),diffRenamed:r("diff-renamed",60128),diff:r("diff",60129),discard:r("discard",60130),editorLayout:r("editor-layout",60131),emptyWindow:r("empty-window",60132),exclude:r("exclude",60133),extensions:r("extensions",60134),eyeClosed:r("eye-closed",60135),fileBinary:r("file-binary",60136),fileCode:r("file-code",60137),fileMedia:r("file-media",60138),filePdf:r("file-pdf",60139),fileSubmodule:r("file-submodule",60140),fileSymlinkDirectory:r("file-symlink-directory",60141),fileSymlinkFile:r("file-symlink-file",60142),fileZip:r("file-zip",60143),files:r("files",60144),filter:r("filter",60145),flame:r("flame",60146),foldDown:r("fold-down",60147),foldUp:r("fold-up",60148),fold:r("fold",60149),folderActive:r("folder-active",60150),folderOpened:r("folder-opened",60151),gear:r("gear",60152),gift:r("gift",60153),gistSecret:r("gist-secret",60154),gist:r("gist",60155),gitCommit:r("git-commit",60156),gitCompare:r("git-compare",60157),gitMerge:r("git-merge",60158),githubAction:r("github-action",60159),githubAlt:r("github-alt",60160),globe:r("globe",60161),grabber:r("grabber",60162),graph:r("graph",60163),gripper:r("gripper",60164),heart:r("heart",60165),home:r("home",60166),horizontalRule:r("horizontal-rule",60167),hubot:r("hubot",60168),inbox:r("inbox",60169),issueClosed:r("issue-closed",60324),issueReopened:r("issue-reopened",60171),issues:r("issues",60172),italic:r("italic",60173),jersey:r("jersey",60174),json:r("json",60175),bracket:r("bracket",60175),kebabVertical:r("kebab-vertical",60176),key:r("key",60177),law:r("law",60178),lightbulbAutofix:r("lightbulb-autofix",60179),linkExternal:r("link-external",60180),link:r("link",60181),listOrdered:r("list-ordered",60182),listUnordered:r("list-unordered",60183),liveShare:r("live-share",60184),loading:r("loading",60185),location:r("location",60186),mailRead:r("mail-read",60187),mail:r("mail",60188),markdown:r("markdown",60189),megaphone:r("megaphone",60190),mention:r("mention",60191),milestone:r("milestone",60192),gitPullRequestMilestone:r("git-pull-request-milestone",60192),mortarBoard:r("mortar-board",60193),move:r("move",60194),multipleWindows:r("multiple-windows",60195),mute:r("mute",60196),noNewline:r("no-newline",60197),note:r("note",60198),octoface:r("octoface",60199),openPreview:r("open-preview",60200),package:r("package",60201),paintcan:r("paintcan",60202),pin:r("pin",60203),play:r("play",60204),run:r("run",60204),plug:r("plug",60205),preserveCase:r("preserve-case",60206),preview:r("preview",60207),project:r("project",60208),pulse:r("pulse",60209),question:r("question",60210),quote:r("quote",60211),radioTower:r("radio-tower",60212),reactions:r("reactions",60213),references:r("references",60214),refresh:r("refresh",60215),regex:r("regex",60216),remoteExplorer:r("remote-explorer",60217),remote:r("remote",60218),remove:r("remove",60219),replaceAll:r("replace-all",60220),replace:r("replace",60221),repoClone:r("repo-clone",60222),repoForcePush:r("repo-force-push",60223),repoPull:r("repo-pull",60224),repoPush:r("repo-push",60225),report:r("report",60226),requestChanges:r("request-changes",60227),rocket:r("rocket",60228),rootFolderOpened:r("root-folder-opened",60229),rootFolder:r("root-folder",60230),rss:r("rss",60231),ruby:r("ruby",60232),saveAll:r("save-all",60233),saveAs:r("save-as",60234),save:r("save",60235),screenFull:r("screen-full",60236),screenNormal:r("screen-normal",60237),searchStop:r("search-stop",60238),server:r("server",60240),settingsGear:r("settings-gear",60241),settings:r("settings",60242),shield:r("shield",60243),smiley:r("smiley",60244),sortPrecedence:r("sort-precedence",60245),splitHorizontal:r("split-horizontal",60246),splitVertical:r("split-vertical",60247),squirrel:r("squirrel",60248),starFull:r("star-full",60249),starHalf:r("star-half",60250),symbolClass:r("symbol-class",60251),symbolColor:r("symbol-color",60252),symbolCustomColor:r("symbol-customcolor",60252),symbolConstant:r("symbol-constant",60253),symbolEnumMember:r("symbol-enum-member",60254),symbolField:r("symbol-field",60255),symbolFile:r("symbol-file",60256),symbolInterface:r("symbol-interface",60257),symbolKeyword:r("symbol-keyword",60258),symbolMisc:r("symbol-misc",60259),symbolOperator:r("symbol-operator",60260),symbolProperty:r("symbol-property",60261),wrench:r("wrench",60261),wrenchSubaction:r("wrench-subaction",60261),symbolSnippet:r("symbol-snippet",60262),tasklist:r("tasklist",60263),telescope:r("telescope",60264),textSize:r("text-size",60265),threeBars:r("three-bars",60266),thumbsdown:r("thumbsdown",60267),thumbsup:r("thumbsup",60268),tools:r("tools",60269),triangleDown:r("triangle-down",60270),triangleLeft:r("triangle-left",60271),triangleRight:r("triangle-right",60272),triangleUp:r("triangle-up",60273),twitter:r("twitter",60274),unfold:r("unfold",60275),unlock:r("unlock",60276),unmute:r("unmute",60277),unverified:r("unverified",60278),verified:r("verified",60279),versions:r("versions",60280),vmActive:r("vm-active",60281),vmOutline:r("vm-outline",60282),vmRunning:r("vm-running",60283),watch:r("watch",60284),whitespace:r("whitespace",60285),wholeWord:r("whole-word",60286),window:r("window",60287),wordWrap:r("word-wrap",60288),zoomIn:r("zoom-in",60289),zoomOut:r("zoom-out",60290),listFilter:r("list-filter",60291),listFlat:r("list-flat",60292),listSelection:r("list-selection",60293),selection:r("selection",60293),listTree:r("list-tree",60294),debugBreakpointFunctionUnverified:r("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:r("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:r("debug-breakpoint-function-disabled",60296),debugStackframeActive:r("debug-stackframe-active",60297),circleSmallFilled:r("circle-small-filled",60298),debugStackframeDot:r("debug-stackframe-dot",60298),debugStackframe:r("debug-stackframe",60299),debugStackframeFocused:r("debug-stackframe-focused",60299),debugBreakpointUnsupported:r("debug-breakpoint-unsupported",60300),symbolString:r("symbol-string",60301),debugReverseContinue:r("debug-reverse-continue",60302),debugStepBack:r("debug-step-back",60303),debugRestartFrame:r("debug-restart-frame",60304),callIncoming:r("call-incoming",60306),callOutgoing:r("call-outgoing",60307),menu:r("menu",60308),expandAll:r("expand-all",60309),feedback:r("feedback",60310),gitPullRequestReviewer:r("git-pull-request-reviewer",60310),groupByRefType:r("group-by-ref-type",60311),ungroupByRefType:r("ungroup-by-ref-type",60312),account:r("account",60313),gitPullRequestAssignee:r("git-pull-request-assignee",60313),bellDot:r("bell-dot",60314),debugConsole:r("debug-console",60315),library:r("library",60316),output:r("output",60317),runAll:r("run-all",60318),syncIgnored:r("sync-ignored",60319),pinned:r("pinned",60320),githubInverted:r("github-inverted",60321),debugAlt:r("debug-alt",60305),serverProcess:r("server-process",60322),serverEnvironment:r("server-environment",60323),pass:r("pass",60324),stopCircle:r("stop-circle",60325),playCircle:r("play-circle",60326),record:r("record",60327),debugAltSmall:r("debug-alt-small",60328),vmConnect:r("vm-connect",60329),cloud:r("cloud",60330),merge:r("merge",60331),exportIcon:r("export",60332),graphLeft:r("graph-left",60333),magnet:r("magnet",60334),notebook:r("notebook",60335),redo:r("redo",60336),checkAll:r("check-all",60337),pinnedDirty:r("pinned-dirty",60338),passFilled:r("pass-filled",60339),circleLargeFilled:r("circle-large-filled",60340),circleLarge:r("circle-large",60341),circleLargeOutline:r("circle-large-outline",60341),combine:r("combine",60342),gather:r("gather",60342),table:r("table",60343),variableGroup:r("variable-group",60344),typeHierarchy:r("type-hierarchy",60345),typeHierarchySub:r("type-hierarchy-sub",60346),typeHierarchySuper:r("type-hierarchy-super",60347),gitPullRequestCreate:r("git-pull-request-create",60348),runAbove:r("run-above",60349),runBelow:r("run-below",60350),notebookTemplate:r("notebook-template",60351),debugRerun:r("debug-rerun",60352),workspaceTrusted:r("workspace-trusted",60353),workspaceUntrusted:r("workspace-untrusted",60354),workspaceUnspecified:r("workspace-unspecified",60355),terminalCmd:r("terminal-cmd",60356),terminalDebian:r("terminal-debian",60357),terminalLinux:r("terminal-linux",60358),terminalPowershell:r("terminal-powershell",60359),terminalTmux:r("terminal-tmux",60360),terminalUbuntu:r("terminal-ubuntu",60361),terminalBash:r("terminal-bash",60362),arrowSwap:r("arrow-swap",60363),copy:r("copy",60364),personAdd:r("person-add",60365),filterFilled:r("filter-filled",60366),wand:r("wand",60367),debugLineByLine:r("debug-line-by-line",60368),inspect:r("inspect",60369),layers:r("layers",60370),layersDot:r("layers-dot",60371),layersActive:r("layers-active",60372),compass:r("compass",60373),compassDot:r("compass-dot",60374),compassActive:r("compass-active",60375),azure:r("azure",60376),issueDraft:r("issue-draft",60377),gitPullRequestClosed:r("git-pull-request-closed",60378),gitPullRequestDraft:r("git-pull-request-draft",60379),debugAll:r("debug-all",60380),debugCoverage:r("debug-coverage",60381),runErrors:r("run-errors",60382),folderLibrary:r("folder-library",60383),debugContinueSmall:r("debug-continue-small",60384),beakerStop:r("beaker-stop",60385),graphLine:r("graph-line",60386),graphScatter:r("graph-scatter",60387),pieChart:r("pie-chart",60388),bracketDot:r("bracket-dot",60389),bracketError:r("bracket-error",60390),lockSmall:r("lock-small",60391),azureDevops:r("azure-devops",60392),verifiedFilled:r("verified-filled",60393),newLine:r("newline",60394),layout:r("layout",60395),layoutActivitybarLeft:r("layout-activitybar-left",60396),layoutActivitybarRight:r("layout-activitybar-right",60397),layoutPanelLeft:r("layout-panel-left",60398),layoutPanelCenter:r("layout-panel-center",60399),layoutPanelJustify:r("layout-panel-justify",60400),layoutPanelRight:r("layout-panel-right",60401),layoutPanel:r("layout-panel",60402),layoutSidebarLeft:r("layout-sidebar-left",60403),layoutSidebarRight:r("layout-sidebar-right",60404),layoutStatusbar:r("layout-statusbar",60405),layoutMenubar:r("layout-menubar",60406),layoutCentered:r("layout-centered",60407),layoutSidebarRightOff:r("layout-sidebar-right-off",60416),layoutPanelOff:r("layout-panel-off",60417),layoutSidebarLeftOff:r("layout-sidebar-left-off",60418),target:r("target",60408),indent:r("indent",60409),recordSmall:r("record-small",60410),errorSmall:r("error-small",60411),arrowCircleDown:r("arrow-circle-down",60412),arrowCircleLeft:r("arrow-circle-left",60413),arrowCircleRight:r("arrow-circle-right",60414),arrowCircleUp:r("arrow-circle-up",60415),heartFilled:r("heart-filled",60420),map:r("map",60421),mapFilled:r("map-filled",60422),circleSmall:r("circle-small",60423),bellSlash:r("bell-slash",60424),bellSlashDot:r("bell-slash-dot",60425),commentUnresolved:r("comment-unresolved",60426),gitPullRequestGoToChanges:r("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:r("git-pull-request-new-changes",60428),searchFuzzy:r("search-fuzzy",60429),commentDraft:r("comment-draft",60430),send:r("send",60431),sparkle:r("sparkle",60432),insert:r("insert",60433),mic:r("mic",60434),thumbsDownFilled:r("thumbsdown-filled",60435),thumbsUpFilled:r("thumbsup-filled",60436),coffee:r("coffee",60437),snake:r("snake",60438),game:r("game",60439),vr:r("vr",60440),chip:r("chip",60441),piano:r("piano",60442),music:r("music",60443),micFilled:r("mic-filled",60444),gitFetch:r("git-fetch",60445),copilot:r("copilot",60446),dialogError:r("dialog-error","error"),dialogWarning:r("dialog-warning","warning"),dialogInfo:r("dialog-info","info"),dialogClose:r("dialog-close","close"),treeItemExpanded:r("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:r("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:r("tree-filter-on-type-off","list-selection"),treeFilterClear:r("tree-filter-clear","close"),treeItemLoading:r("tree-item-loading","loading"),menuSelection:r("menu-selection","check"),menuSubmenu:r("menu-submenu","chevron-right"),menuBarMore:r("menubar-more","more"),scrollbarButtonLeft:r("scrollbar-button-left","triangle-left"),scrollbarButtonRight:r("scrollbar-button-right","triangle-right"),scrollbarButtonUp:r("scrollbar-button-up","triangle-up"),scrollbarButtonDown:r("scrollbar-button-down","triangle-down"),toolBarMore:r("toolbar-more","more"),quickInputBack:r("quick-input-back","arrow-left")}}),define(be[39],we([1,0,7,3,17,8]),function(ue,e,y,R,r,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7f=e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=e.$Vf=e.$Uf=e.$Tf=e.$Sf=e.$Rf=void 0;function I(a){return a===47||a===92}e.$Rf=I;function C(a){return a.replace(/[\\/]/g,y.$gc.sep)}e.$Sf=C;function p(a){return a.indexOf("/")===-1&&(a=C(a)),/^[a-zA-Z]:(\/|$)/.test(a)&&(a="/"+a),a}e.$Tf=p;function w(a,f=y.$gc.sep){if(!a)return"";const S=a.length,D=a.charCodeAt(0);if(I(D)){if(I(a.charCodeAt(1))&&!I(a.charCodeAt(2))){let P=3;const M=P;for(;P<S&&!I(a.charCodeAt(P));P++);if(M!==P&&!I(a.charCodeAt(P+1))){for(P+=1;P<S;P++)if(I(a.charCodeAt(P)))return a.slice(0,P+1).replace(/[\\/]/g,f)}}return f}else if(h(D)&&a.charCodeAt(1)===58)return I(a.charCodeAt(2))?a.slice(0,2)+f:a.slice(0,2);let E=a.indexOf("://");if(E!==-1){for(E+=3;E<S;E++)if(I(a.charCodeAt(E)))return a.slice(0,E+1)}return""}e.$Uf=w;function A(a){if(!R.$d||!a||a.length<5)return!1;let f=a.charCodeAt(0);if(f!==92||(f=a.charCodeAt(1),f!==92))return!1;let S=2;const D=S;for(;S<a.length&&(f=a.charCodeAt(S),f!==92);S++);return!(D===S||(f=a.charCodeAt(S+1),isNaN(f)||f===92))}e.$Vf=A;const k=/[\\/:\*\?"<>\|]/g,v=/[\\/]/g,u=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function b(a,f=R.$d){const S=f?k:v;return!(!a||a.length===0||/^\s+$/.test(a)||(S.lastIndex=0,S.test(a))||f&&u.test(a)||a==="."||a===".."||f&&a[a.length-1]==="."||f&&a.length!==a.trim().length||a.length>255)}e.$Wf=b;function m(a,f,S){const D=a===f;return!S||D?D:!a||!f?!1:(0,r.$3e)(a,f)}e.$Xf=m;function d(a,f,S,D=y.sep){if(a===f)return!0;if(!a||!f||f.length>a.length)return!1;if(S){if(!(0,r.$4e)(a,f))return!1;if(f.length===a.length)return!0;let P=f.length;return f.charAt(f.length-1)===D&&P--,a.charAt(P)===D}return f.charAt(f.length-1)!==D&&(f+=D),a.indexOf(f)===0}e.$Yf=d;function h(a){return a>=65&&a<=90||a>=97&&a<=122}e.$Zf=h;function g(a,f){return R.$d&&a.endsWith(":")&&(a+=y.sep),(0,y.$ic)(a)||(a=(0,y.$jc)(f,a)),a=(0,y.$hc)(a),R.$d?(a=(0,r.$Le)(a,y.sep),a.endsWith(":")&&(a+=y.sep)):(a=(0,r.$Le)(a,y.sep),a||(a=y.sep)),a}e.$1f=g;function l(a){const f=(0,y.$hc)(a);return R.$d?a.length>3?!1:$(f)&&(a.length===2||f.charCodeAt(2)===92):f===y.$gc.sep}e.$2f=l;function $(a,f=R.$d){return f?h(a.charCodeAt(0))&&a.charCodeAt(1)===58:!1}e.$3f=$;function c(a,f=R.$d){return $(a,f)?a[0]:void 0}e.$4f=c;function n(a,f,S){return f.length>a.length?-1:a===f?0:(S&&(a=a.toLowerCase(),f=f.toLowerCase()),a.indexOf(f))}e.$5f=n;function i(a){const f=a.split(":");let S,D,E;for(const P of f){const M=Number(P);(0,L.$Df)(M)?D===void 0?D=M:E===void 0&&(E=M):S=S?[S,P].join(":"):P}if(!S)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:S,line:D!==void 0?D:void 0,column:E!==void 0?E:D!==void 0?1:void 0}}e.$6f=i;const o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",s="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function t(a,f,S=8){let D="";for(let P=0;P<S;P++){let M;P===0&&R.$d&&!f&&(S===3||S===4)?M=s:M=o,D+=M.charAt(Math.floor(Math.random()*M.length))}let E;return f?E=`${f}-${D}`:E=D,a?(0,y.$jc)(a,E):E}e.$7f=t}),define(be[22],we([1,0,8]),function(ue,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kn=e.$jn=e.$in=e.$hn=e.$gn=e.$fn=e.$en=e.$dn=e.$cn=e.$bn=e.$an=e.$_m=e.$$m=e.$0m=e.$9m=void 0;function R($){if(!$||typeof $!="object"||$ instanceof RegExp)return $;const c=Array.isArray($)?[]:{};return Object.entries($).forEach(([n,i])=>{c[n]=i&&typeof i=="object"?R(i):i}),c}e.$9m=R;function r($){if(!$||typeof $!="object")return $;const c=[$];for(;c.length>0;){const n=c.shift();Object.freeze(n);for(const i in n)if(L.call(n,i)){const o=n[i];typeof o=="object"&&!Object.isFrozen(o)&&!(0,y.$Cf)(o)&&c.push(o)}}return $}e.$0m=r;const L=Object.prototype.hasOwnProperty;function I($,c){return C($,c,new Set)}e.$$m=I;function C($,c,n){if((0,y.$If)($))return $;const i=c($);if(typeof i<"u")return i;if(Array.isArray($)){const o=[];for(const s of $)o.push(C(s,c,n));return o}if((0,y.$Bf)($)){if(n.has($))throw new Error("Cannot clone recursive data-structure");n.add($);const o={};for(const s in $)L.call($,s)&&(o[s]=C($[s],c,n));return n.delete($),o}return $}function p($,c,n=!0){return(0,y.$Bf)($)?((0,y.$Bf)(c)&&Object.keys(c).forEach(i=>{i in $?n&&((0,y.$Bf)($[i])&&(0,y.$Bf)(c[i])?p($[i],c[i],n):$[i]=c[i]):$[i]=c[i]}),$):c}e.$_m=p;function w($,c){if($===c)return!0;if($==null||c===null||c===void 0||typeof $!=typeof c||typeof $!="object"||Array.isArray($)!==Array.isArray(c))return!1;let n,i;if(Array.isArray($)){if($.length!==c.length)return!1;for(n=0;n<$.length;n++)if(!w($[n],c[n]))return!1}else{const o=[];for(i in $)o.push(i);o.sort();const s=[];for(i in c)s.push(i);if(s.sort(),!w(o,s))return!1;for(n=0;n<o.length;n++)if(!w($[o[n]],c[o[n]]))return!1}return!0}e.$an=w;function A($){const c=new Set;return JSON.stringify($,(n,i)=>{if((0,y.$Bf)(i)||Array.isArray(i)){if(c.has(i))return"[Circular]";c.add(i)}return i})}e.$bn=A;function k($,c){const n=Object.create(null);return!$||!c||Object.keys(c).forEach(o=>{const s=$[o],t=c[o];w(s,t)||(n[o]=t)}),n}e.$cn=k;function v($,c){const n=c.toLowerCase(),i=Object.keys($).find(o=>o.toLowerCase()===n);return i?$[i]:$[c]}e.$dn=v;function u($,c){const n=Object.create(null);for(const[i,o]of Object.entries($))c(i,o)&&(n[i]=o);return n}e.$en=u;function b($){let c=[];for(;Object.prototype!==$;)c=c.concat(Object.getOwnPropertyNames($)),$=Object.getPrototypeOf($);return c}e.$fn=b;function m($){const c=[];for(const n of b($))typeof $[n]=="function"&&c.push(n);return c}e.$gn=m;function d($,c){const n=o=>function(){const s=Array.prototype.slice.call(arguments,0);return c(o,s)},i={};for(const o of $)i[o]=n(o);return i}e.$hn=d;function h($,c,n){typeof c=="string"&&$[c]!==void 0&&typeof $[c]!="boolean"&&($[c]=n)}e.$in=h;function g($,c,n){typeof c=="string"&&$[c]!==void 0&&typeof $[c]!="number"&&($[c]=n)}e.$jn=g;function l($,c,n,i){if(typeof c!="string")return;const o=$[c];o!==void 0&&(typeof o!="string"||!n.includes(o))&&($[c]=i)}e.$kn=l}),define(be[99],we([1,0,49]),function(ue,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$Wj=e.ThemeColor=void 0;var R;(function(I){function C(p){return p&&typeof p=="object"&&typeof p.id=="string"}I.isThemeColor=C})(R||(e.ThemeColor=R={}));function r(I){return{id:I}}e.$Wj=r;var L;(function(I){I.iconNameSegment="[A-Za-z0-9]+",I.iconNameExpression="[A-Za-z0-9-]+",I.iconModifierExpression="~[A-Za-z]+",I.iconNameCharacter="[A-Za-z0-9~-]";const C=new RegExp(`^(${I.iconNameExpression})(${I.iconModifierExpression})?$`);function p(g){const l=C.exec(g.id);if(!l)return p(y.$Vj.error);const[,$,c]=l,n=["codicon","codicon-"+$];return c&&n.push("codicon-modifier-"+c.substring(1)),n}I.asClassNameArray=p;function w(g){return p(g).join(" ")}I.asClassName=w;function A(g){return"."+p(g).join(".")}I.asCSSSelector=A;function k(g){return g&&typeof g=="object"&&typeof g.id=="string"&&(typeof g.color>"u"||R.isThemeColor(g.color))}I.isThemeIcon=k;const v=new RegExp(`^\\$\\((${I.iconNameExpression}(?:${I.iconModifierExpression})?)\\)$`);function u(g){const l=v.exec(g);if(!l)return;const[,$]=l;return{id:$}}I.fromString=u;function b(g){return{id:g}}I.fromId=b;function m(g,l){let $=g.id;const c=$.lastIndexOf("~");return c!==-1&&($=$.substring(0,c)),l&&($=`${$}~${l}`),{id:$}}I.modify=m;function d(g){const l=g.id.lastIndexOf("~");if(l!==-1)return g.id.substring(l+1)}I.getModifier=d;function h(g,l){return g.id===l.id&&g.color?.id===l.color?.id}I.isEqual=h})(L||(e.ThemeIcon=L={}))}),define(be[149],we([1,0,147,17,99]),function(ue,e,y,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3j=e.$2j=e.$1j=e.$Zj=e.$Yj=e.$Xj=void 0;const L="$(",I=new RegExp(`\\$\\(${r.ThemeIcon.iconNameExpression}(?:${r.ThemeIcon.iconModifierExpression})?\\)`,"g"),C=new RegExp(`(\\\\)?${I.source}`,"g");function p(h){return h.replace(C,(g,l)=>l?g:`\\${g}`)}e.$Xj=p;const w=new RegExp(`\\\\${I.source}`,"g");function A(h){return h.replace(w,g=>`\\${g}`)}e.$Yj=A;const k=new RegExp(`(\\s)?(\\\\)?${I.source}(\\s)?`,"g");function v(h){return h.indexOf(L)===-1?h:h.replace(k,(g,l,$,c)=>$?g:l||c||"")}e.$Zj=v;function u(h){return h?h.replace(/\$\((.*?)\)/g,(g,l)=>` ${l} `).trim():""}e.$1j=u;const b=new RegExp(`\\$\\(${r.ThemeIcon.iconNameCharacter}+\\)`,"g");function m(h){b.lastIndex=0;let g="";const l=[];let $=0;for(;;){const c=b.lastIndex,n=b.exec(h),i=h.substring(c,n?.index);if(i.length>0){g+=i;for(let o=0;o<i.length;o++)l.push($)}if(!n)break;$+=n[0].length}return{text:g,iconOffsets:l}}e.$2j=m;function d(h,g,l=!1){const{text:$,iconOffsets:c}=g;if(!c||c.length===0)return(0,y.$Kj)(h,$,l);const n=(0,R.$Ke)($," "),i=$.length-n.length,o=(0,y.$Kj)(h,n,l);if(o)for(const s of o){const t=c[s.start+i]+i;s.start+=t,s.end+=t}return o}e.$3j=d}),define(be[4],we([1,0,7,3]),function(ue,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wc=e.$vc=e.URI=void 0;const r=/^\w[\w\d+.-]*$/,L=/^\//,I=/^\/\//;function C(s,t){if(!s.scheme&&t)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${s.authority}", path: "${s.path}", query: "${s.query}", fragment: "${s.fragment}"}`);if(s.scheme&&!r.test(s.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(s.path){if(s.authority){if(!L.test(s.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(I.test(s.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function p(s,t){return!s&&!t?"file":s}function w(s,t){switch(s){case"https":case"http":case"file":t?t[0]!==k&&(t=k+t):t=k;break}return t}const A="",k="/",v=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class u{static isUri(t){return t instanceof u?!0:t?typeof t.authority=="string"&&typeof t.fragment=="string"&&typeof t.path=="string"&&typeof t.query=="string"&&typeof t.scheme=="string"&&typeof t.fsPath=="string"&&typeof t.with=="function"&&typeof t.toString=="function":!1}constructor(t,a,f,S,D,E=!1){typeof t=="object"?(this.scheme=t.scheme||A,this.authority=t.authority||A,this.path=t.path||A,this.query=t.query||A,this.fragment=t.fragment||A):(this.scheme=p(t,E),this.authority=a||A,this.path=w(this.scheme,f||A),this.query=S||A,this.fragment=D||A,C(this,E))}get fsPath(){return $(this,!1)}with(t){if(!t)return this;let{scheme:a,authority:f,path:S,query:D,fragment:E}=t;return a===void 0?a=this.scheme:a===null&&(a=A),f===void 0?f=this.authority:f===null&&(f=A),S===void 0?S=this.path:S===null&&(S=A),D===void 0?D=this.query:D===null&&(D=A),E===void 0?E=this.fragment:E===null&&(E=A),a===this.scheme&&f===this.authority&&S===this.path&&D===this.query&&E===this.fragment?this:new d(a,f,S,D,E)}static parse(t,a=!1){const f=v.exec(t);return f?new d(f[2]||A,o(f[4]||A),o(f[5]||A),o(f[7]||A),o(f[9]||A),a):new d(A,A,A,A,A)}static file(t){let a=A;if(R.$d&&(t=t.replace(/\\/g,k)),t[0]===k&&t[1]===k){const f=t.indexOf(k,2);f===-1?(a=t.substring(2),t=k):(a=t.substring(2,f),t=t.substring(f)||k)}return new d("file",a,t,A,A)}static from(t,a){return new d(t.scheme,t.authority,t.path,t.query,t.fragment,a)}static joinPath(t,...a){if(!t.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let f;return R.$d&&t.scheme==="file"?f=u.file(y.$fc.join($(t,!0),...a)).path:f=y.$gc.join(t.path,...a),t.with({path:f})}toString(t=!1){return c(this,t)}toJSON(){return this}static revive(t){if(t){if(t instanceof u)return t;{const a=new d(t);return a._formatted=t.external??null,a._fsPath=t._sep===m?t.fsPath??null:null,a}}else return t}}e.URI=u;function b(s){return!s||typeof s!="object"?!1:typeof s.scheme=="string"&&(typeof s.authority=="string"||typeof s.authority>"u")&&(typeof s.path=="string"||typeof s.path>"u")&&(typeof s.query=="string"||typeof s.query>"u")&&(typeof s.fragment=="string"||typeof s.fragment>"u")}e.$vc=b;const m=R.$d?1:void 0;class d extends u{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=$(this,!1)),this._fsPath}toString(t=!1){return t?c(this,!0):(this._formatted||(this._formatted=c(this,!1)),this._formatted)}toJSON(){const t={$mid:1};return this._fsPath&&(t.fsPath=this._fsPath,t._sep=m),this._formatted&&(t.external=this._formatted),this.path&&(t.path=this.path),this.scheme&&(t.scheme=this.scheme),this.authority&&(t.authority=this.authority),this.query&&(t.query=this.query),this.fragment&&(t.fragment=this.fragment),t}}const h={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function g(s,t,a){let f,S=-1;for(let D=0;D<s.length;D++){const E=s.charCodeAt(D);if(E>=97&&E<=122||E>=65&&E<=90||E>=48&&E<=57||E===45||E===46||E===95||E===126||t&&E===47||a&&E===91||a&&E===93||a&&E===58)S!==-1&&(f+=encodeURIComponent(s.substring(S,D)),S=-1),f!==void 0&&(f+=s.charAt(D));else{f===void 0&&(f=s.substr(0,D));const P=h[E];P!==void 0?(S!==-1&&(f+=encodeURIComponent(s.substring(S,D)),S=-1),f+=P):S===-1&&(S=D)}}return S!==-1&&(f+=encodeURIComponent(s.substring(S))),f!==void 0?f:s}function l(s){let t;for(let a=0;a<s.length;a++){const f=s.charCodeAt(a);f===35||f===63?(t===void 0&&(t=s.substr(0,a)),t+=h[f]):t!==void 0&&(t+=s[a])}return t!==void 0?t:s}function $(s,t){let a;return s.authority&&s.path.length>1&&s.scheme==="file"?a=`//${s.authority}${s.path}`:s.path.charCodeAt(0)===47&&(s.path.charCodeAt(1)>=65&&s.path.charCodeAt(1)<=90||s.path.charCodeAt(1)>=97&&s.path.charCodeAt(1)<=122)&&s.path.charCodeAt(2)===58?t?a=s.path.substr(1):a=s.path[1].toLowerCase()+s.path.substr(2):a=s.path,R.$d&&(a=a.replace(/\//g,"\\")),a}e.$wc=$;function c(s,t){const a=t?l:g;let f="",{scheme:S,authority:D,path:E,query:P,fragment:M}=s;if(S&&(f+=S,f+=":"),(D||S==="file")&&(f+=k,f+=k),D){let ee=D.indexOf("@");if(ee!==-1){const se=D.substr(0,ee);D=D.substr(ee+1),ee=se.lastIndexOf(":"),ee===-1?f+=a(se,!1,!1):(f+=a(se.substr(0,ee),!1,!1),f+=":",f+=a(se.substr(ee+1),!1,!0)),f+="@"}D=D.toLowerCase(),ee=D.lastIndexOf(":"),ee===-1?f+=a(D,!1,!0):(f+=a(D.substr(0,ee),!1,!0),f+=D.substr(ee))}if(E){if(E.length>=3&&E.charCodeAt(0)===47&&E.charCodeAt(2)===58){const ee=E.charCodeAt(1);ee>=65&&ee<=90&&(E=`/${String.fromCharCode(ee+32)}:${E.substr(3)}`)}else if(E.length>=2&&E.charCodeAt(1)===58){const ee=E.charCodeAt(0);ee>=65&&ee<=90&&(E=`${String.fromCharCode(ee+32)}:${E.substr(2)}`)}f+=a(E,!0,!1)}return P&&(f+="?",f+=a(P,!1,!1)),M&&(f+="#",f+=t?M:g(M,!1,!1)),f}function n(s){try{return decodeURIComponent(s)}catch{return s.length>3?s.substr(0,3)+n(s.substr(3)):s}}const i=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function o(s){return s.match(i)?s.replace(i,t=>n(t)):s}}),define(be[150],we([1,0,4]),function(ue,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.$5p=e.$4p=e.$3p=void 0;function R(w){const A=w;return A&&typeof A.type=="string"&&typeof A.severity=="string"}e.$3p=R;function r(w){const A=[];let k;try{const v=JSON.parse(w.arguments),u=v[v.length-1];u&&u.__$stack&&(v.pop(),k=u.__$stack),A.push(...v)}catch{A.push("Unable to log remote console arguments",w.arguments)}return{args:A,stack:k}}e.$4p=r;function L(w){if(typeof w!="string")return L(r(w).stack);const A=w;if(A){const k=I(A),v=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(k||"");if(v&&v.length===4)return{uri:y.URI.file(v[1]),line:Number(v[2]),column:Number(v[3])}}}e.$5p=L;function I(w){if(!w)return w;const A=w.indexOf(`
`);return A===-1?w:w.substring(0,A)}function C(w,A){const{args:k,stack:v}=r(w),u=typeof k[0]=="string"&&k.length===1;let b=I(v);b&&(b=`(${b.trim()})`);let m=[];if(typeof k[0]=="string"?b&&u?m=[`%c[${A}] %c${k[0]} %c${b}`,p("blue"),p(""),p("grey")]:m=[`%c[${A}] %c${k[0]}`,p("blue"),p(""),...k.slice(1)]:m=[`%c[${A}]%`,p("blue"),...k],b&&!u&&m.push(b),typeof console[w.severity]!="function")throw new Error("Unknown console method");console[w.severity].apply(console,m)}e.log=C;function p(w){return`color: ${w}`}}),define(be[50],we([1,0,15,4]),function(ue,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nh=e.$mh=e.$lh=void 0;function r(p){return JSON.stringify(p,I)}e.$lh=r;function L(p){let w=JSON.parse(p);return w=C(w),w}e.$mh=L;function I(p,w){return w instanceof RegExp?{$mid:2,source:w.source,flags:w.flags}:w}function C(p,w=0){if(!p||w>200)return p;if(typeof p=="object"){switch(p.$mid){case 1:return R.URI.revive(p);case 2:return new RegExp(p.source,p.flags);case 17:return new Date(p.source)}if(p instanceof y.$ce||p instanceof Uint8Array)return p;if(Array.isArray(p))for(let A=0;A<p.length;++A)p[A]=C(p[A],w+1);else for(const A in p)Object.hasOwnProperty.call(p,A)&&(p[A]=C(p[A],w+1))}return p}e.$nh=C}),define(be[12],we([1,0,11,3,4]),function(ue,e,y,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$dg=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=e.$0f=e.$9f=e.$8f=e.Schemas=void 0;var L;(function(w){w.inMemory="inmemory",w.vscode="vscode",w.internal="private",w.walkThrough="walkThrough",w.walkThroughSnippet="walkThroughSnippet",w.http="http",w.https="https",w.file="file",w.mailto="mailto",w.untitled="untitled",w.data="data",w.command="command",w.vscodeRemote="vscode-remote",w.vscodeRemoteResource="vscode-remote-resource",w.vscodeManagedRemoteResource="vscode-managed-remote-resource",w.vscodeUserData="vscode-userdata",w.vscodeCustomEditor="vscode-custom-editor",w.vscodeNotebookCell="vscode-notebook-cell",w.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",w.vscodeNotebookCellOutput="vscode-notebook-cell-output",w.vscodeInteractiveInput="vscode-interactive-input",w.vscodeSettings="vscode-settings",w.vscodeWorkspaceTrust="vscode-workspace-trust",w.vscodeTerminal="vscode-terminal",w.vscodeChatSesssion="vscode-chat-editor",w.webviewPanel="webview-panel",w.vscodeWebview="vscode-webview",w.extension="extension",w.vscodeFileResource="vscode-file",w.tmp="tmp",w.vsls="vsls",w.vscodeSourceControl="vscode-scm"})(L||(e.Schemas=L={})),e.$8f="vscode-tkn",e.$9f="tkn";class I{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${L.vscodeRemoteResource}`}setPreferredWebSchema(A){this.d=A}setDelegate(A){this.e=A}setServerRootPath(A){this.f=`${A}/${L.vscodeRemoteResource}`}set(A,k,v){this.a[A]=k,this.b[A]=v}setConnectionToken(A,k){this.c[A]=k}getPreferredWebSchema(){return this.d}rewrite(A){if(this.e)try{return this.e(A)}catch(d){return y.$1(d),A}const k=A.authority;let v=this.a[k];v&&v.indexOf(":")!==-1&&v.indexOf("[")===-1&&(v=`[${v}]`);const u=this.b[k],b=this.c[k];let m=`path=${encodeURIComponent(A.path)}`;return typeof b=="string"&&(m+=`&${e.$9f}=${encodeURIComponent(b)}`),r.URI.from({scheme:R.$j?this.d:L.vscodeRemoteResource,authority:`${v}:${u}`,path:R.$j?(window.location.pathname+"/"+this.f).replace(/\/\/+/g,"/"):this.f,query:m})}}e.$0f=new I,e.$$f="vs/../../extensions",e.$_f="vs/../../node_modules",e.$ag="vs/../../node_modules.asar",e.$bg="vs/../../node_modules.asar.unpacked",e.$cg="vscode-app";class C{asBrowserUri(A){const k=this.b(A,ue);return this.uriToBrowserUri(k)}uriToBrowserUri(A){return A.scheme===L.vscodeRemote?e.$0f.rewrite(A):A.scheme===L.file&&(R.$h||R.$k&&R.$b.origin===`${L.vscodeFileResource}://${C.a}`)?A.with({scheme:L.vscodeFileResource,authority:A.authority||C.a,query:null,fragment:null}):A}asFileUri(A){const k=this.b(A,ue);return this.uriToFileUri(k)}uriToFileUri(A){return A.scheme===L.vscodeFileResource?A.with({scheme:L.file,authority:A.authority!==C.a?A.authority:null,query:null,fragment:null}):A}b(A,k){return r.URI.isUri(A)?A:r.URI.parse(k.toUrl(A))}}C.a=e.$cg,e.$dg=new C;var p;(function(w){const A=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);w.CoopAndCoep=Object.freeze(A.get("3"));const k="vscode-coi";function v(b){let m;typeof b=="string"?m=new URL(b).searchParams:b instanceof URL?m=b.searchParams:r.URI.isUri(b)&&(m=new URL(b.toString(!0)).searchParams);const d=m?.get(k);if(d)return A.get(d)}w.getHeadersFromQuery=v;function u(b,m,d){if(!globalThis.crossOriginIsolated)return;const h=m&&d?"3":d?"2":"1";b instanceof URLSearchParams?b.set(k,h):b[k]=h}w.addSearchParam=u})(p||(e.COI=p={}))}),define(be[151],we([1,0,95,12,3,4]),function(ue,e,y,R,r,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AC=void 0;class I{constructor(v,u,b){this.id=v,this.dependencies=u,this.callback=b}}class C{constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(v,u,b)=>{typeof v!="string"&&(b=u,u=v,v=null),(typeof u!="object"||!Array.isArray(u))&&(b=u,u=null),this.c.push(new I(v,u,b))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(v){if(v.startsWith(window.location.origin)||v.startsWith("vscode-file://vscode-app"))return v;throw new Error(`[trusted_script_src] Invalid script url: ${v}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(v){return v}})))}async load(v){this.g();const u=await(this.a?this.i(v):this.b?this.h(v):this.j(v));if(!u)throw new Error(`Did not receive a define call from script ${v}`);if(Array.isArray(u.dependencies)&&u.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${v}. The dependencies are: ${u.dependencies.join(", ")}`);return typeof u.callback=="function"?u.callback([]):u.callback}h(v){return new Promise((u,b)=>{const m=document.createElement("script");m.setAttribute("async","async"),m.setAttribute("type","text/javascript");const d=()=>{m.removeEventListener("load",h),m.removeEventListener("error",g)},h=l=>{d(),u(this.c.pop())},g=l=>{d(),b(l)};m.addEventListener("load",h),m.addEventListener("error",g),this.f&&(v=this.f.createScriptURL(v)),m.setAttribute("src",v),document.getElementsByTagName("head")[0].appendChild(m)})}i(v){return new Promise((u,b)=>{try{this.f&&(v=this.f.createScriptURL(v)),importScripts(v),u(this.c.pop())}catch(m){b(m)}})}async j(v){try{const u=globalThis._VSCODE_NODE_MODULES.fs,b=globalThis._VSCODE_NODE_MODULES.vm,m=globalThis._VSCODE_NODE_MODULES.module,d=L.URI.parse(v).fsPath,h=u.readFileSync(d).toString(),g=m.wrap(h.replace(/^#!.*/,""));return new b.Script(g).runInThisContext().apply(),this.c.pop()}catch(u){throw u}}}C.INSTANCE=new C;const p=new Map;let w={};typeof globalThis.require=="object"&&(w=globalThis.require.paths??{});async function A(k,v,u){if(y.$T){u===void 0&&(u=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),w[k]&&(k=w[k]);const b=`${k}/${v}`;if(p.has(b))return p.get(b);let m;if(/^\w[\w\d+.-]*:\/\//.test(b))m=b;else{const l=`${u&&!r.$j?R.$ag:R.$_f}/${b}`;m=R.$dg.asBrowserUri(l).toString(!0)}const d=C.INSTANCE.load(m);return p.set(b,d),d}else return await new Promise((b,m)=>{ue([k],b,m)})}e.$AC=A}),define(be[19],we([1,0,39,12,7,3,17,4]),function(ue,e,y,R,r,L,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gg=e.DataUri=e.$Fg=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=e.$rg=e.$qg=e.$pg=e.$og=e.$ng=e.$mg=e.$lg=e.$kg=void 0;function p(u){return(0,C.$wc)(u,!0)}e.$kg=p;class w{constructor(b){this.a=b}compare(b,m,d=!1){return b===m?0:(0,I.$Ve)(this.getComparisonKey(b,d),this.getComparisonKey(m,d))}isEqual(b,m,d=!1){return b===m?!0:!b||!m?!1:this.getComparisonKey(b,d)===this.getComparisonKey(m,d)}getComparisonKey(b,m=!1){return b.with({path:this.a(b)?b.path.toLowerCase():void 0,fragment:m?null:void 0}).toString()}ignorePathCasing(b){return this.a(b)}isEqualOrParent(b,m,d=!1){if(b.scheme===m.scheme){if(b.scheme===R.Schemas.file)return y.$Yf(p(b),p(m),this.a(b))&&b.query===m.query&&(d||b.fragment===m.fragment);if((0,e.$Bg)(b.authority,m.authority))return y.$Yf(b.path,m.path,this.a(b),"/")&&b.query===m.query&&(d||b.fragment===m.fragment)}return!1}joinPath(b,...m){return C.URI.joinPath(b,...m)}basenameOrAuthority(b){return(0,e.$tg)(b)||b.authority}basename(b){return r.$gc.basename(b.path)}extname(b){return r.$gc.extname(b.path)}dirname(b){if(b.path.length===0)return b;let m;return b.scheme===R.Schemas.file?m=C.URI.file(r.$mc(p(b))).path:(m=r.$gc.dirname(b.path),b.authority&&m.length&&m.charCodeAt(0)!==47&&(console.error(`dirname("${b.toString})) resulted in a relative path`),m="/")),b.with({path:m})}normalizePath(b){if(!b.path.length)return b;let m;return b.scheme===R.Schemas.file?m=C.URI.file(r.$hc(p(b))).path:m=r.$gc.normalize(b.path),b.with({path:m})}relativePath(b,m){if(b.scheme!==m.scheme||!(0,e.$Bg)(b.authority,m.authority))return;if(b.scheme===R.Schemas.file){const g=r.$lc(p(b),p(m));return L.$d?y.$Sf(g):g}let d=b.path||"/";const h=m.path||"/";if(this.a(b)){let g=0;for(const l=Math.min(d.length,h.length);g<l&&!(d.charCodeAt(g)!==h.charCodeAt(g)&&d.charAt(g).toLowerCase()!==h.charAt(g).toLowerCase());g++);d=h.substr(0,g)+d.substr(g)}return r.$gc.relative(d,h)}resolvePath(b,m){if(b.scheme===R.Schemas.file){const d=C.URI.file(r.$kc(p(b),m));return b.with({authority:d.authority,path:d.path})}return m=y.$Tf(m),b.with({path:r.$gc.resolve(b.path,m)})}isAbsolutePath(b){return!!b.path&&b.path[0]==="/"}isEqualAuthority(b,m){return b===m||b!==void 0&&m!==void 0&&(0,I.$3e)(b,m)}hasTrailingPathSeparator(b,m=r.sep){if(b.scheme===R.Schemas.file){const d=p(b);return d.length>y.$Uf(d).length&&d[d.length-1]===m}else{const d=b.path;return d.length>1&&d.charCodeAt(d.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(b.fsPath)}}removeTrailingPathSeparator(b,m=r.sep){return(0,e.$Cg)(b,m)?b.with({path:b.path.substr(0,b.path.length-1)}):b}addTrailingPathSeparator(b,m=r.sep){let d=!1;if(b.scheme===R.Schemas.file){const h=p(b);d=h!==void 0&&h.length===y.$Uf(h).length&&h[h.length-1]===m}else{m="/";const h=b.path;d=h.length===1&&h.charCodeAt(h.length-1)===47}return!d&&!(0,e.$Cg)(b,m)?b.with({path:b.path+"/"}):b}}e.$lg=w,e.$mg=new w(()=>!1),e.$ng=new w(u=>u.scheme===R.Schemas.file?!L.$f:!0),e.$og=new w(u=>!0),e.$pg=e.$mg.isEqual.bind(e.$mg),e.$qg=e.$mg.isEqualOrParent.bind(e.$mg),e.$rg=e.$mg.getComparisonKey.bind(e.$mg),e.$sg=e.$mg.basenameOrAuthority.bind(e.$mg),e.$tg=e.$mg.basename.bind(e.$mg),e.$ug=e.$mg.extname.bind(e.$mg),e.$vg=e.$mg.dirname.bind(e.$mg),e.$wg=e.$mg.joinPath.bind(e.$mg),e.$xg=e.$mg.normalizePath.bind(e.$mg),e.$yg=e.$mg.relativePath.bind(e.$mg),e.$zg=e.$mg.resolvePath.bind(e.$mg),e.$Ag=e.$mg.isAbsolutePath.bind(e.$mg),e.$Bg=e.$mg.isEqualAuthority.bind(e.$mg),e.$Cg=e.$mg.hasTrailingPathSeparator.bind(e.$mg),e.$Dg=e.$mg.removeTrailingPathSeparator.bind(e.$mg),e.$Eg=e.$mg.addTrailingPathSeparator.bind(e.$mg);function A(u,b){const m=[];for(let d=0;d<u.length;d++){const h=b(u[d]);u.some((g,l)=>l===d?!1:(0,e.$qg)(h,b(g)))||m.push(u[d])}return m}e.$Fg=A;var k;(function(u){u.META_DATA_LABEL="label",u.META_DATA_DESCRIPTION="description",u.META_DATA_SIZE="size",u.META_DATA_MIME="mime";function b(m){const d=new Map;m.path.substring(m.path.indexOf(";")+1,m.path.lastIndexOf(";")).split(";").forEach(l=>{const[$,c]=l.split(":");$&&c&&d.set($,c)});const g=m.path.substring(0,m.path.indexOf(";"));return g&&d.set(u.META_DATA_MIME,g),d}u.parseMetaData=b})(k||(e.DataUri=k={}));function v(u,b,m){if(b){let d=u.path;return d&&d[0]!==r.$gc.sep&&(d=r.$gc.sep+d),u.with({scheme:m,authority:b,path:d})}return u.with({scheme:m})}e.$Gg=v}),define(be[14],we([1,0,20,11,5,2,19,3,148]),function(ue,e,y,R,r,L,I,C,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hh=e.$gh=e.$fh=e.$eh=e.Promises=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=void 0;function w(N){return!!N&&typeof N.then=="function"}e.$Hg=w;function A(N){const U=new y.$Yd,T=N(U.token),z=new Promise((B,te)=>{const H=U.token.onCancellationRequested(()=>{H.dispose(),U.dispose(),te(new R.$5)});Promise.resolve(T).then(x=>{H.dispose(),U.dispose(),B(x)},x=>{H.dispose(),U.dispose(),te(x)})});return new class{cancel(){U.cancel()}then(B,te){return z.then(B,te)}catch(B){return this.then(void 0,B)}finally(B){return z.finally(B)}}}e.$Ig=A;function k(N,U,T){return new Promise((z,B)=>{const te=U.onCancellationRequested(()=>{te.dispose(),z(T)});N.then(z,B).finally(()=>te.dispose())})}e.$Jg=k;function v(N,U){return new Promise((T,z)=>{const B=U.onCancellationRequested(()=>{B.dispose(),z(new R.$5)});N.then(T,z).finally(()=>B.dispose())})}e.$Kg=v;async function u(N){let U=-1;const T=N.map((z,B)=>z.then(te=>(U=B,te)));try{return await Promise.race(T)}finally{N.forEach((z,B)=>{B!==U&&z.cancel()})}}e.$Lg=u;function b(N,U,T){let z;const B=setTimeout(()=>{z?.(void 0),T?.()},U);return Promise.race([N.finally(()=>clearTimeout(B)),new Promise(te=>z=te)])}e.$Mg=b;function m(N){return new Promise((U,T)=>{const z=N();w(z)?z.then(U,T):U(z)})}e.$Ng=m;class d{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(U){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=U,!this.b){const T=()=>{if(this.b=null,this.f)return;const z=this.queue(this.d);return this.d=null,z};this.b=new Promise(z=>{this.a.then(T,T).then(z)})}return new Promise((T,z)=>{this.b.then(T,z)})}return this.a=U(),new Promise((T,z)=>{this.a.then(B=>{this.a=null,T(B)},B=>{this.a=null,z(B)})})}dispose(){this.f=!0}}e.$Og=d;class h{constructor(){this.a=Promise.resolve(null)}queue(U){return this.a=this.a.then(()=>U(),()=>U())}}e.$Pg=h;class g{constructor(){this.a=new Map}queue(U,T){const B=(this.a.get(U)??Promise.resolve()).catch(()=>{}).then(T).finally(()=>{this.a.get(U)===B&&this.a.delete(U)});return this.a.set(U,B),B}}e.$Qg=g;const l=(N,U)=>{let T=!0;const z=setTimeout(()=>{T=!1,U()},N);return{isTriggered:()=>T,dispose:()=>{clearTimeout(z),T=!1}}},$=N=>{let U=!0;return queueMicrotask(()=>{U&&(U=!1,N())}),{isTriggered:()=>U,dispose:()=>{U=!1}}};class c{constructor(U){this.defaultDelay=U,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(U,T=this.defaultDelay){this.g=U,this.h(),this.b||(this.b=new Promise((B,te)=>{this.d=B,this.f=te}).then(()=>{if(this.b=null,this.d=null,this.g){const B=this.g;return this.g=null,B()}}));const z=()=>{this.a=null,this.d?.(null)};return this.a=T===p.$Ld?$(z):l(T,z),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new R.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Rg=c;class n{constructor(U){this.a=new c(U),this.b=new d}trigger(U,T){return this.a.trigger(()=>this.b.queue(U),T)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Sg=n;class i{constructor(){this.a=!1,this.b=new Promise((U,T)=>{this.d=U})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Tg=i;class o extends i{constructor(U){super(),this.f=setTimeout(()=>this.open(),U)}open(){clearTimeout(this.f),super.open()}}e.$Ug=o;function s(N,U){return U?new Promise((T,z)=>{const B=setTimeout(()=>{te.dispose(),T()},N),te=U.onCancellationRequested(()=>{clearTimeout(B),te.dispose(),z(new R.$5)})}):A(T=>s(N,T))}e.$Vg=s;function t(N,U=0,T){const z=setTimeout(()=>{N(),T&&B.dispose()},U),B=(0,L.$Qc)(()=>{clearTimeout(z),T?.deleteAndLeak(B)});return T?.add(B),B}e.$Wg=t;function a(N){const U=[];let T=0;const z=N.length;function B(){return T<z?N[T++]():null}function te(H){H!=null&&U.push(H);const x=B();return x?x.then(te):Promise.resolve(U)}return Promise.resolve(null).then(te)}e.$Xg=a;function f(N,U=z=>!!z,T=null){let z=0;const B=N.length,te=()=>{if(z>=B)return Promise.resolve(T);const H=N[z++];return Promise.resolve(H()).then(W=>U(W)?Promise.resolve(W):te())};return te()}e.$Yg=f;function S(N,U=z=>!!z,T=null){if(N.length===0)return Promise.resolve(T);let z=N.length;const B=()=>{z=-1;for(const te of N)te.cancel?.()};return new Promise((te,H)=>{for(const x of N)x.then(W=>{--z>=0&&U(W)?(B(),te(W)):z===0&&te(T)}).catch(W=>{--z>=0&&(B(),H(W))})})}e.$Zg=S;class D{constructor(U){this.a=0,this.d=U,this.f=[],this.b=0,this.g=new r.$Od}get onDrained(){return this.g.event}get size(){return this.a}queue(U){return this.a++,new Promise((T,z)=>{this.f.push({factory:U,c:T,e:z}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const U=this.f.shift();this.b++;const T=U.factory();T.then(U.c,U.e),T.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$1g=D;class E extends D{constructor(){super(1)}}e.$2g=E;class P{constructor(){this.a=new ie,this.b=0}queue(U){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,U())):this.a.run(this.b++,U())}}e.$3g=P;class M{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const U=new re;return this.b.add(U),U.p}g(){for(const[,U]of this.a)if(U.size>0)return!1;return!0}queueFor(U,T=I.$mg){const z=T.getComparisonKey(U);let B=this.a.get(z);if(!B){B=new E;const te=this.f++,H=r.Event.once(B.onDrained)(()=>{B?.dispose(),this.a.delete(z),this.h(),this.d?.deleteAndDispose(te),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new L.$1c),this.d.set(te,H),this.a.set(z,B)}return B}h(){this.g()&&this.j()}j(){for(const U of this.b)U.complete();this.b.clear()}dispose(){for(const[,U]of this.a)U.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$4g=M;class ee{constructor(U,T){this.a=-1,typeof U=="function"&&typeof T=="number"&&this.setIfNotSet(U,T)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(U,T){this.cancel(),this.a=setTimeout(()=>{this.a=-1,U()},T)}setIfNotSet(U,T){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,U()},T))}}e.$5g=ee;class se{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(U,T){this.cancel(),this.a=setInterval(()=>{U()},T)}}e.$6g=se;class G{constructor(U,T){this.b=-1,this.a=U,this.d=T,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(U=this.d){this.cancel(),this.b=setTimeout(this.f,U)}get delay(){return this.d}set delay(U){this.d=U}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$7g=G;class ne{constructor(U,T){T%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${T}ms is not a multiple of 1000ms.`),this.a=U,this.b=T,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(U=this.b){U%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${U}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(U/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$8g=ne;class he extends G{constructor(U,T){super(U,T),this.j=[]}work(U){this.j.push(U),this.isScheduled()||this.schedule()}h(){const U=this.j;this.j=[],this.a?.(U)}dispose(){this.j=[],super.dispose()}}e.$9g=he;class Z extends L.$Sc{constructor(U,T){super(),this.g=U,this.h=T,this.a=[],this.b=this.B(new L.$Tc),this.f=!1}get pending(){return this.a.length}work(U){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+U.length>this.g.maxBufferedWork)return!1}else if(this.pending+U.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const T of U)this.a.push(T);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new G(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$0g=Z,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.$$g=N=>{(0,C.$v)(()=>{if(U)return;const T=Date.now()+15;N(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,T-Date.now())}}))});let U=!1;return{dispose(){U||(U=!0)}}}:e.$$g=(N,U)=>{const T=requestIdleCallback(N,typeof U=="number"?{timeout:U}:void 0);let z=!1;return{dispose(){z||(z=!0,cancelIdleCallback(T))}}}}();class fe{constructor(U){this.d=!1,this.a=()=>{try{this.f=U()}catch(T){this.g=T}finally{this.d=!0}},this.b=(0,e.$$g)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.$_g=fe;async function V(N,U,T){let z;for(let B=0;B<T;B++)try{return await N()}catch(te){z=te,await s(U)}throw z}e.$ah=V;class ie{isRunning(U){return typeof U=="number"?this.a?.taskId===U:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(U,T,z){return this.a={taskId:U,cancel:()=>z?.(),promise:T},T.then(()=>this.d(U),()=>this.d(U)),T}d(U){this.a&&U===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const U=this.b;this.b=void 0,U.run().then(U.promiseResolve,U.promiseReject)}}queue(U){if(this.b)this.b.run=U;else{let T,z;const B=new Promise((te,H)=>{T=te,z=H});this.b={run:U,promise:B,promiseResolve:T,promiseReject:z}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$bh=ie;class Y{constructor(U,T=()=>Date.now()){this.d=U,this.f=T,this.a=0,this.b=0}increment(){const U=this.f();return U-this.a>this.d&&(this.a=U,this.b=0),this.b++,this.b}}e.$ch=Y;var J;(function(N){N[N.Resolved=0]="Resolved",N[N.Rejected=1]="Rejected"})(J||(J={}));class re{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((U,T)=>{this.a=U,this.b=T})}complete(U){return new Promise(T=>{this.a(U),this.d={outcome:0,value:U},T()})}error(U){return new Promise(T=>{this.b(U),this.d={outcome:1,value:U},T()})}cancel(){return this.error(new R.$5)}}e.$dh=re;var ce;(function(N){async function U(z){let B;const te=await Promise.all(z.map(H=>H.then(x=>x,x=>{B||(B=x)})));if(typeof B<"u")throw B;return te}N.settled=U;function T(z){return new Promise(async(B,te)=>{try{await z(B,te)}catch(H){te(H)}})}N.withAsyncBody=T})(ce||(e.Promises=ce={}));var oe;(function(N){N[N.Initial=0]="Initial",N[N.DoneOK=1]="DoneOK",N[N.DoneError=2]="DoneError"})(oe||(oe={}));class _{static fromArray(U){return new _(T=>{T.emitMany(U)})}static fromPromise(U){return new _(async T=>{T.emitMany(await U)})}static fromPromises(U){return new _(async T=>{await Promise.all(U.map(async z=>T.emitOne(await z)))})}static merge(U){return new _(async T=>{await Promise.all(U.map(async z=>{for await(const B of z)T.emitOne(B)}))})}constructor(U){this.a=0,this.b=[],this.d=null,this.f=new r.$Od,queueMicrotask(async()=>{const T={emitOne:z=>this.g(z),emitMany:z=>this.h(z),reject:z=>this.k(z)};try{await Promise.resolve(U(T)),this.j()}catch(z){this.k(z)}finally{T.emitOne=void 0,T.emitMany=void 0,T.reject=void 0}})}[Symbol.asyncIterator](){let U=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(U<this.b.length)return{done:!1,value:this.b[U++]};if(this.a===1)return{done:!0,value:void 0};await r.Event.toPromise(this.f.event)}while(!0)}}}static map(U,T){return new _(async z=>{for await(const B of U)z.emitOne(T(B))})}map(U){return _.map(this,U)}static filter(U,T){return new _(async z=>{for await(const B of U)T(B)&&z.emitOne(B)})}filter(U){return _.filter(this,U)}static coalesce(U){return _.filter(U,T=>!!T)}coalesce(){return _.coalesce(this)}static async toPromise(U){const T=[];for await(const z of U)T.push(z);return T}toPromise(){return _.toPromise(this)}g(U){this.a===0&&(this.b.push(U),this.f.fire())}h(U){this.a===0&&(this.b=this.b.concat(U),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(U){this.a===0&&(this.a=2,this.d=U,this.f.fire())}}e.$eh=_,_.EMPTY=_.fromArray([]);class q extends _{constructor(U,T){super(T),this.l=U}cancel(){this.l.cancel()}}e.$fh=q;function Q(N){const U=new y.$Yd,T=N(U.token);return new q(U,async z=>{const B=U.token.onCancellationRequested(()=>{B.dispose(),U.dispose(),z.reject(new R.$5)});try{for await(const te of T){if(U.token.isCancellationRequested)return;z.emitOne(te)}B.dispose(),U.dispose()}catch(te){B.dispose(),U.dispose(),z.reject(te)}})}e.$gh=Q;class O{constructor(){this.a=new re,this.b=new _(z=>{if(U){z.reject(U);return}return T&&z.emitMany(T),this.d=B=>z.reject(B),this.f=B=>z.emitOne(B),this.a.p});let U,T;this.f=z=>{T||(T=[]),T.push(z)},this.d=z=>{U||(U=z)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(U){this.d(U),this.a.complete()}emitOne(U){this.f(U)}}e.$hh=O}),define(be[77],we([1,0,18,14,39,26,7,3,17]),function(ue,e,y,R,r,L,I,C,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bj=e.$Aj=e.$zj=e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=void 0;function w(){return Object.create(null)}e.$sj=w,e.$tj="**",e.$uj="/";const A="[/\\\\]",k="[^/\\\\]",v=/\//g;function u(ie,Y){switch(ie){case 0:return"";case 1:return`${k}*?`;default:return`(?:${A}|${k}+${A}${Y?`|${A}${k}+`:""})*?`}}function b(ie,Y){if(!ie)return[];const J=[];let re=!1,ce=!1,oe="";for(const _ of ie){switch(_){case Y:if(!re&&!ce){J.push(oe),oe="";continue}break;case"{":re=!0;break;case"}":re=!1;break;case"[":ce=!0;break;case"]":ce=!1;break}oe+=_}return oe&&J.push(oe),J}e.$vj=b;function m(ie){if(!ie)return"";let Y="";const J=b(ie,e.$uj);if(J.every(re=>re===e.$tj))Y=".*";else{let re=!1;J.forEach((ce,oe)=>{if(ce===e.$tj){if(re)return;Y+=u(2,oe===J.length-1)}else{let _=!1,q="",Q=!1,O="";for(const N of ce){if(N!=="}"&&_){q+=N;continue}if(Q&&(N!=="]"||!O)){let U;N==="-"?U=N:(N==="^"||N==="!")&&!O?U="^":N===e.$uj?U="":U=(0,p.$Ge)(N),O+=U;continue}switch(N){case"{":_=!0;continue;case"[":Q=!0;continue;case"}":{const T=`(?:${b(q,",").map(z=>m(z)).join("|")})`;Y+=T,_=!1,q="";break}case"]":{Y+="["+O+"]",Q=!1,O="";break}case"?":Y+=k;continue;case"*":Y+=u(1);continue;default:Y+=(0,p.$Ge)(N)}}oe<J.length-1&&(J[oe+1]!==e.$tj||oe+2<J.length)&&(Y+=A)}re=ce===e.$tj})}return Y}const d=/^\*\*\/\*\.[\w\.-]+$/,h=/^\*\*\/([\w\.-]+)\/?$/,g=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,l=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,$=/^\*\*((\/[\w\.-]+)+)\/?$/,c=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,n=new L.$Dc(1e4),i=function(){return!1},o=function(){return null};function s(ie,Y){if(!ie)return o;let J;typeof ie!="string"?J=ie.pattern:J=ie,J=J.trim();const re=`${J}_${!!Y.trimForExclusions}`;let ce=n.get(re);if(ce)return t(ce,ie);let oe;return d.test(J)?ce=f(J.substr(4),J):(oe=h.exec(a(J,Y)))?ce=S(oe[1],J):(Y.trimForExclusions?l:g).test(J)?ce=D(J,Y):(oe=$.exec(a(J,Y)))?ce=E(oe[1].substr(1),J,!0):(oe=c.exec(a(J,Y)))?ce=E(oe[1],J,!1):ce=P(J),n.set(re,ce),t(ce,ie)}function t(ie,Y){if(typeof Y=="string")return ie;const J=function(re,ce){return(0,r.$Yf)(re,Y.base,!C.$f)?ie((0,p.$Ke)(re.substr(Y.base.length),I.sep),ce):null};return J.allBasenames=ie.allBasenames,J.allPaths=ie.allPaths,J.basenames=ie.basenames,J.patterns=ie.patterns,J}function a(ie,Y){return Y.trimForExclusions&&ie.endsWith("/**")?ie.substr(0,ie.length-2):ie}function f(ie,Y){return function(J,re){return typeof J=="string"&&J.endsWith(ie)?Y:null}}function S(ie,Y){const J=`/${ie}`,re=`\\${ie}`,ce=function(_,q){return typeof _!="string"?null:q?q===ie?Y:null:_===ie||_.endsWith(J)||_.endsWith(re)?Y:null},oe=[ie];return ce.basenames=oe,ce.patterns=[Y],ce.allBasenames=oe,ce}function D(ie,Y){const J=fe(ie.slice(1,-1).split(",").map(q=>s(q,Y)).filter(q=>q!==o),ie),re=J.length;if(!re)return o;if(re===1)return J[0];const ce=function(q,Q){for(let O=0,N=J.length;O<N;O++)if(J[O](q,Q))return ie;return null},oe=J.find(q=>!!q.allBasenames);oe&&(ce.allBasenames=oe.allBasenames);const _=J.reduce((q,Q)=>Q.allPaths?q.concat(Q.allPaths):q,[]);return _.length&&(ce.allPaths=_),ce}function E(ie,Y,J){const re=I.sep===I.$gc.sep,ce=re?ie:ie.replace(v,I.sep),oe=I.sep+ce,_=I.$gc.sep+ie;let q;return J?q=function(Q,O){return typeof Q=="string"&&(Q===ce||Q.endsWith(oe)||!re&&(Q===ie||Q.endsWith(_)))?Y:null}:q=function(Q,O){return typeof Q=="string"&&(Q===ce||!re&&Q===ie)?Y:null},q.allPaths=[(J?"*/":"./")+ie],q}function P(ie){try{const Y=new RegExp(`^${m(ie)}$`);return function(J){return Y.lastIndex=0,typeof J=="string"&&Y.test(J)?ie:null}}catch{return o}}function M(ie,Y,J){return!ie||typeof Y!="string"?!1:ee(ie)(Y,void 0,J)}e.$wj=M;function ee(ie,Y={}){if(!ie)return i;if(typeof ie=="string"||se(ie)){const J=s(ie,Y);if(J===o)return i;const re=function(ce,oe){return!!J(ce,oe)};return J.allBasenames&&(re.allBasenames=J.allBasenames),J.allPaths&&(re.allPaths=J.allPaths),re}return he(ie,Y)}e.$xj=ee;function se(ie){const Y=ie;return Y?typeof Y.base=="string"&&typeof Y.pattern=="string":!1}e.$yj=se;function G(ie){return ie.allBasenames||[]}e.$zj=G;function ne(ie){return ie.allPaths||[]}e.$Aj=ne;function he(ie,Y){const J=fe(Object.getOwnPropertyNames(ie).map(q=>Z(q,ie[q],Y)).filter(q=>q!==o)),re=J.length;if(!re)return o;if(!J.some(q=>!!q.requiresSiblings)){if(re===1)return J[0];const q=function(N,U){let T;for(let z=0,B=J.length;z<B;z++){const te=J[z](N,U);if(typeof te=="string")return te;(0,R.$Hg)(te)&&(T||(T=[]),T.push(te))}return T?(async()=>{for(const z of T){const B=await z;if(typeof B=="string")return B}return null})():null},Q=J.find(N=>!!N.allBasenames);Q&&(q.allBasenames=Q.allBasenames);const O=J.reduce((N,U)=>U.allPaths?N.concat(U.allPaths):N,[]);return O.length&&(q.allPaths=O),q}const ce=function(q,Q,O){let N,U;for(let T=0,z=J.length;T<z;T++){const B=J[T];B.requiresSiblings&&O&&(Q||(Q=(0,I.$nc)(q)),N||(N=Q.substr(0,Q.length-(0,I.$oc)(q).length)));const te=B(q,Q,N,O);if(typeof te=="string")return te;(0,R.$Hg)(te)&&(U||(U=[]),U.push(te))}return U?(async()=>{for(const T of U){const z=await T;if(typeof z=="string")return z}return null})():null},oe=J.find(q=>!!q.allBasenames);oe&&(ce.allBasenames=oe.allBasenames);const _=J.reduce((q,Q)=>Q.allPaths?q.concat(Q.allPaths):q,[]);return _.length&&(ce.allPaths=_),ce}function Z(ie,Y,J){if(Y===!1)return o;const re=s(ie,J);if(re===o)return o;if(typeof Y=="boolean")return re;if(Y){const ce=Y.when;if(typeof ce=="string"){const oe=(_,q,Q,O)=>{if(!O||!re(_,q))return null;const N=ce.replace("$(basename)",()=>Q),U=O(N);return(0,R.$Hg)(U)?U.then(T=>T?ie:null):U?ie:null};return oe.requiresSiblings=!0,oe}}return re}function fe(ie,Y){const J=ie.filter(q=>!!q.basenames);if(J.length<2)return ie;const re=J.reduce((q,Q)=>{const O=Q.basenames;return O?q.concat(O):q},[]);let ce;if(Y){ce=[];for(let q=0,Q=re.length;q<Q;q++)ce.push(Y)}else ce=J.reduce((q,Q)=>{const O=Q.patterns;return O?q.concat(O):q},[]);const oe=function(q,Q){if(typeof q!="string")return null;if(!Q){let N;for(N=q.length;N>0;N--){const U=q.charCodeAt(N-1);if(U===47||U===92)break}Q=q.substr(N)}const O=re.indexOf(Q);return O!==-1?ce[O]:null};oe.basenames=re,oe.patterns=ce,oe.allBasenames=re;const _=ie.filter(q=>!q.basenames);return _.push(oe),_}function V(ie,Y){return(0,y.$ub)(ie,Y,(J,re)=>typeof J=="string"&&typeof re=="string"?J===re:typeof J!="string"&&typeof re!="string"?J.base===re.base&&J.pattern===re.pattern:!1)}e.$Bj=V}),define(be[100],we([1,0,11,149,19,17,4]),function(ue,e,y,R,r,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$j=e.$0j=e.$9j=e.$8j=e.$7j=e.$6j=e.$5j=e.$4j=e.MarkdownStringTextNewlineStyle=void 0;var C;(function(d){d[d.Paragraph=0]="Paragraph",d[d.Break=1]="Break"})(C||(e.MarkdownStringTextNewlineStyle=C={}));class p{constructor(h="",g=!1){if(this.value=h,typeof this.value!="string")throw(0,y.$7)("value");typeof g=="boolean"?(this.isTrusted=g,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=g.isTrusted??void 0,this.supportThemeIcons=g.supportThemeIcons??!1,this.supportHtml=g.supportHtml??!1)}appendText(h,g=0){return this.value+=v(this.supportThemeIcons?(0,R.$Xj)(h):h).replace(/([ \t]+)/g,(l,$)=>"&nbsp;".repeat($.length)).replace(/\>/gm,"\\>").replace(/\n/g,g===1?`\\
`:`

`),this}appendMarkdown(h){return this.value+=h,this}appendCodeblock(h,g){return this.value+="\n```",this.value+=h,this.value+=`
`,this.value+=g,this.value+="\n```\n",this}appendLink(h,g,l){return this.value+="[",this.value+=this.c(g,"]"),this.value+="](",this.value+=this.c(String(h),")"),l&&(this.value+=` "${this.c(this.c(l,'"'),")")}"`),this.value+=")",this}c(h,g){const l=new RegExp((0,L.$Ge)(g),"g");return h.replace(l,($,c)=>h.charAt(c-1)!=="\\"?`\\${$}`:$)}}e.$4j=p;function w(d){return A(d)?!d.value:Array.isArray(d)?d.every(w):!0}e.$5j=w;function A(d){return d instanceof p?!0:d&&typeof d=="object"?typeof d.value=="string"&&(typeof d.isTrusted=="boolean"||typeof d.isTrusted=="object"||d.isTrusted===void 0)&&(typeof d.supportThemeIcons=="boolean"||d.supportThemeIcons===void 0):!1}e.$6j=A;function k(d,h){return d===h?!0:!d||!h?!1:d.value===h.value&&d.isTrusted===h.isTrusted&&d.supportThemeIcons===h.supportThemeIcons&&d.supportHtml===h.supportHtml&&(d.baseUri===h.baseUri||!!d.baseUri&&!!h.baseUri&&(0,r.$pg)(I.URI.from(d.baseUri),I.URI.from(h.baseUri)))}e.$7j=k;function v(d){return d.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.$8j=v;function u(d){return d.replace(/"/g,"&quot;")}e.$9j=u;function b(d){return d&&d.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.$0j=b;function m(d){const h=[],g=d.split("|").map($=>$.trim());d=g[0];const l=g[1];if(l){const $=/height=(\d+)/.exec(l),c=/width=(\d+)/.exec(l),n=$?$[1]:"",i=c?c[1]:"",o=isFinite(parseInt(i)),s=isFinite(parseInt(n));o&&h.push(`width="${i}"`),s&&h.push(`height="${n}"`)}return{href:d,dimensions:h}}e.$$j=m}),define(be[152],we([1,0,18,39,7,3,19,17]),function(ue,e,y,R,r,L,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fv=e.$Ev=e.$Dv=e.$Cv=e.$Bv=e.$Av=e.$zv=e.$yv=e.$xv=e.$wv=void 0;function p(s,t){const{os:a,tildify:f,relative:S}=t;if(S){const P=w(s,S,a);if(typeof P=="string")return P}let D=s.fsPath;if(a===1&&!L.$d?D=D.replace(/\//g,"\\"):a!==1&&L.$d&&(D=D.replace(/\\/g,"/")),a!==1&&f?.userHome){const P=f.userHome.fsPath;let M;s.scheme!==f.userHome.scheme&&s.path.startsWith(r.$gc.sep)?M=f.userHome.with({path:s.path}).fsPath:M=s.fsPath,D=v(M,P,a)}return(a===1?r.$fc:r.$gc).normalize(A(D,a===1))}e.$wv=p;function w(s,t,a){const f=a===1?r.$fc:r.$gc,S=a===3?I.$mg:I.$og,D=t.getWorkspace(),E=(0,y.$Ob)(D.folders);if(!E)return;s.scheme!==E.uri.scheme&&s.path.startsWith(r.$gc.sep)&&(s=E.uri.with({path:s.path}));const P=t.getWorkspaceFolder(s);if(!P)return;let M;if(S.isEqual(P.uri,s)?M="":M=S.relativePath(P.uri,s)??"",M&&(M=f.normalize(M)),D.folders.length>1&&!t.noPrefix){const ee=P.name?P.name:S.basenameOrAuthority(P.uri);M=M?`${ee} \u2022 ${M}`:ee}return M}function A(s,t=L.$d){return(0,R.$3f)(s,t)?s.charAt(0).toUpperCase()+s.slice(1):s}e.$xv=A;let k=Object.create(null);function v(s,t,a=L.OS){if(a===1||!s||!t)return s;let f=k.original===t?k.normalized:void 0;f||(f=t,L.$d&&(f=(0,R.$Sf)(f)),f=`${(0,C.$Le)(f,r.$gc.sep)}${r.$gc.sep}`,k={original:t,normalized:f});let S=s;return L.$d&&(S=(0,R.$Sf)(S)),(a===3?S.startsWith(f):(0,C.$4e)(S,f))?`~/${S.substr(f.length)}`:s}e.$yv=v;function u(s,t){return s.replace(/^~($|\/|\\)/,`${t}$1`)}e.$zv=u;const b="\u2026",m="\\\\",d="~";function h(s,t=r.sep){const a=new Array(s.length);let f=!1;for(let S=0;S<s.length;S++){const D=s[S];if(D===""){a[S]=`.${t}`;continue}if(!D){a[S]=D;continue}f=!0;let E="",P=D;P.indexOf(m)===0?(E=P.substr(0,P.indexOf(m)+m.length),P=P.substr(P.indexOf(m)+m.length)):P.indexOf(t)===0?(E=P.substr(0,P.indexOf(t)+t.length),P=P.substr(P.indexOf(t)+t.length)):P.indexOf(d)===0&&(E=P.substr(0,P.indexOf(d)+d.length),P=P.substr(P.indexOf(d)+d.length));const M=P.split(t);for(let ee=1;f&&ee<=M.length;ee++)for(let se=M.length-ee;f&&se>=0;se--){f=!1;let G=M.slice(se,se+ee).join(t);for(let ne=0;!f&&ne<s.length;ne++)if(ne!==S&&s[ne]&&s[ne].indexOf(G)>-1){const he=se+ee===M.length,Z=se>0&&s[ne].indexOf(t)>-1?t+G:G,fe=s[ne].endsWith(Z);f=!he||fe}if(!f){let ne="";(M[0].endsWith(":")||E!=="")&&(se===1&&(se=0,ee++,G=M[0]+t+G),se>0&&(ne=M[0]+t),ne=E+ne),se>0&&(ne=ne+b+t),ne=ne+G,se+ee<M.length&&(ne=ne+t+b),a[S]=ne}}f&&(a[S]=D)}return a}e.$Av=h;var g;(function(s){s[s.TEXT=0]="TEXT",s[s.VARIABLE=1]="VARIABLE",s[s.SEPARATOR=2]="SEPARATOR"})(g||(g={}));function l(s,t=Object.create(null)){const a=[];let f=!1,S="";for(const D of s)if(D==="$"||f&&D==="{")S&&a.push({value:S,type:g.TEXT}),S="",f=!0;else if(D==="}"&&f){const E=t[S];if(typeof E=="string")E.length&&a.push({value:E,type:g.VARIABLE});else if(E){const P=a[a.length-1];(!P||P.type!==g.SEPARATOR)&&a.push({value:E.label,type:g.SEPARATOR})}S="",f=!1}else S+=D;return S&&!f&&a.push({value:S,type:g.TEXT}),a.filter((D,E)=>{if(D.type===g.SEPARATOR){const P=a[E-1],M=a[E+1];return[P,M].every(ee=>ee&&(ee.type===g.VARIABLE||ee.type===g.TEXT)&&ee.value.length>0)}return!0}).map(D=>D.value).join("")}e.$Bv=l;function $(s,t){return L.$e||t?s.replace(/\(&&\w\)|&&/g,"").replace(/&/g,L.$e?"&":"&&"):s.replace(/&&|&/g,a=>a==="&"?"&&":"&")}e.$Cv=$;function c(s,t){return L.$e||t?s.replace(/\(&&\w\)|&&/g,""):L.$d?s.replace(/&&|&/g,a=>a==="&"?"&&":"&"):s.replace(/&&/g,"_")}e.$Dv=c;function n(s){return s.replace(/&/g,"&&")}e.$Ev=n;function i(s){if(s.endsWith("]")){const t=s.lastIndexOf(" [",s.length-2);if(t!==-1){const a=o(s.substring(0,t));return{name:a.name,parentPath:a.parentPath+s.substring(t)}}}return o(s)}e.$Fv=i;function o(s){const t=s.indexOf("/")!==-1?r.$gc:r.$fc,a=t.basename(s),f=t.dirname(s);return a.length?{name:a,parentPath:f}:{name:f,parentPath:""}}}),define(be[51],we([1,0,15,4]),function(ue,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rm=e.$Qm=e.$Pm=e.$Om=e.$Nm=void 0;function r(k){return k.toJSON()}class L{constructor(v){this.a=v}transformIncoming(v){const u=this.a.transformIncoming(v);return u===v?v:r(R.URI.from(u))}transformOutgoing(v){const u=this.a.transformOutgoing(v);return u===v?v:r(R.URI.from(u))}transformOutgoingURI(v){const u=this.a.transformOutgoing(v);return u===v?v:R.URI.from(u)}transformOutgoingScheme(v){return this.a.transformOutgoingScheme(v)}}e.$Nm=L,e.$Om=new class{transformIncoming(k){return k}transformOutgoing(k){return k}transformOutgoingURI(k){return k}transformOutgoingScheme(k){return k}};function I(k,v,u){if(!k||u>200)return null;if(typeof k=="object"){if(k instanceof R.URI)return v.transformOutgoing(k);for(const b in k)if(Object.hasOwnProperty.call(k,b)){const m=I(k[b],v,u+1);m!==null&&(k[b]=m)}}return null}function C(k,v){const u=I(k,v,0);return u===null?k:u}e.$Pm=C;function p(k,v,u,b){if(!k||b>200)return null;if(typeof k=="object"){if(k.$mid===1)return u?R.URI.revive(v.transformIncoming(k)):v.transformIncoming(k);if(k instanceof y.$ce)return null;for(const m in k)if(Object.hasOwnProperty.call(k,m)){const d=p(k[m],v,u,b+1);d!==null&&(k[m]=d)}}return null}function w(k,v){const u=p(k,v,!1,0);return u===null?k:u}e.$Qm=w;function A(k,v){const u=p(k,v,!0,0);return u===null?k:u}e.$Rm=A}),define(be[23],we([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fg=e.$eg=void 0;const y=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function R(r){return y.test(r)}e.$eg=R,e.$fg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let r;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?r=crypto.getRandomValues.bind(crypto):r=function(C){for(let p=0;p<C.length;p++)C[p]=Math.floor(Math.random()*256);return C};const L=new Uint8Array(16),I=[];for(let C=0;C<256;C++)I.push(C.toString(16).padStart(2,"0"));return function(){r(L),L[6]=L[6]&15|64,L[8]=L[8]&63|128;let p=0,w="";return w+=I[L[p++]],w+=I[L[p++]],w+=I[L[p++]],w+=I[L[p++]],w+="-",w+=I[L[p++]],w+=I[L[p++]],w+="-",w+=I[L[p++]],w+=I[L[p++]],w+="-",w+=I[L[p++]],w+=I[L[p++]],w+="-",w+=I[L[p++]],w+=I[L[p++]],w+=I[L[p++]],w+=I[L[p++]],w+=I[L[p++]],w+=I[L[p++]],w}}()}),define(be[153],we([1,0,18,47,23]),function(ue,e,y,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8s=e.$7s=e.$6s=e.$5s=e.$4s=void 0;function L(k){return{asString:async()=>k,asFile:()=>{},value:typeof k=="string"?k:void 0}}e.$4s=L;function I(k,v,u){const b={id:(0,r.$fg)(),name:k,uri:v,data:u};return{asString:async()=>"",asFile:()=>b,value:void 0}}e.$5s=I;class C{constructor(){this.a=new Map}get size(){let v=0;for(const u of this.a)v++;return v}has(v){return this.a.has(this.b(v))}matches(v){const u=[...this.a.keys()];return R.Iterable.some(this,([b,m])=>m.asFile())&&u.push("files"),A(p(v),u)}get(v){return this.a.get(this.b(v))?.[0]}append(v,u){const b=this.a.get(v);b?b.push(u):this.a.set(this.b(v),[u])}replace(v,u){this.a.set(this.b(v),[u])}delete(v){this.a.delete(this.b(v))}*[Symbol.iterator](){for(const[v,u]of this.a)for(const b of u)yield[v,b]}b(v){return p(v)}}e.$6s=C;function p(k){return k.toLowerCase()}function w(k,v){return A(p(k),v.map(p))}e.$7s=w;function A(k,v){if(k==="*/*")return v.length>0;if(v.includes(k))return!0;const u=k.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!u)return!1;const[b,m,d]=u;return d==="*"?v.some(h=>h.startsWith(m+"/")):!1}e.$8s=Object.freeze({create:k=>(0,y.$Mb)(k.map(v=>v.toString())).join(`\r
`),split:k=>k.split(`\r
`),parse:k=>e.$8s.split(k).filter(v=>!v.startsWith("#"))})}),function(){"use strict";function ue(e,y,R){function r(u){return new Promise(b=>y.exists(u,b))}function L(u){return new Promise((b,m)=>{const d=new Date;y.utimes(u,d,d,h=>h?m(h):b())})}function I(u){return new Promise((b,m)=>y.mkdir(u,{recursive:!0},d=>d&&d.code!=="EEXIST"?m(d):b(u)))}function C(u){return new Promise((b,m)=>y.rm(u,{recursive:!0,force:!0,maxRetries:3},d=>d?m(d):b()))}function p(u){return new Promise((b,m)=>y.readFile(u,"utf8",(d,h)=>d?m(d):b(h)))}function w(u,b){return new Promise((m,d)=>y.writeFile(u,b,"utf8",h=>h?d(h):m()))}async function A(u){const b=e.join(u,"languagepacks.json");try{return JSON.parse(await p(b))}catch{}}function k(u,b){try{for(;b;){if(u[b])return b;{const m=b.lastIndexOf("-");if(m>0)b=b.substring(0,m);else return}}}catch(m){console.error("Resolving language pack configuration failed.",m)}}function v(u,b,m,d,h){const g=function($){return R.mark("code/didGenerateNls"),Promise.resolve({locale:$,osLocale:h,availableLanguages:{}})};if(R.mark("code/willGenerateNls"),d==="pseudo")return Promise.resolve({locale:d,osLocale:h,availableLanguages:{},pseudo:!0});if(process.env.VSCODE_DEV)return Promise.resolve({locale:d,osLocale:h,availableLanguages:{}});if(d&&(d==="en"||d==="en-us"))return Promise.resolve({locale:d,osLocale:h,availableLanguages:{}});const l=d;try{return u?A(b).then($=>{if(!$)return g(l);const c=k($,d);if(!c)return g(l);d=c;const n=$[d];let i;return!n||typeof n.hash!="string"||!n.translations||typeof(i=n.translations.vscode)!="string"?g(l):r(i).then(o=>{if(!o)return g(l);const s=n.hash+"."+d,t=e.join(b,"clp",s),a=e.join(t,u),f=e.join(t,"tcf.json"),S=e.join(t,"corrupted.info"),D={locale:l,osLocale:h,availableLanguages:{"*":d},_languagePackId:s,_translationsConfigFile:f,_cacheRoot:t,_resolvedLanguagePackCoreLocation:a,_corruptedFile:S};return r(S).then(E=>{let P;return E?P=C(t):P=Promise.resolve(void 0),P.then(()=>r(a).then(M=>M?(L(a).catch(()=>{}),R.mark("code/didGenerateNls"),D):I(a).then(()=>Promise.all([p(m),p(i)])).then(ee=>{const se=JSON.parse(ee[0]),G=JSON.parse(ee[1]).contents,ne=Object.keys(se.bundles),he=[];for(const Z of ne){const fe=se.bundles[Z],V=Object.create(null);for(const ie of fe){const Y=se.keys[ie],J=se.messages[ie],re=G[ie];let ce;if(re){ce=[];for(let oe=0;oe<Y.length;oe++){const _=Y[oe],q=typeof _=="string"?_:_.key;let Q=re[q];Q===void 0&&(Q=J[oe]),ce.push(Q)}}else ce=J;V[ie]=ce}he.push(w(e.join(a,Z.replace(/\//g,"!")+".nls.json"),JSON.stringify(V)))}return he.push(w(f,JSON.stringify(n.translations))),Promise.all(he)}).then(()=>(R.mark("code/didGenerateNls"),D)).catch(ee=>(console.error("Generating translation files failed.",ee),g(d)))))})})}):g(l)}catch($){return console.error("Generating translation files failed.",$),g(d)}}return{getNLSConfiguration:v}}if(typeof define=="function")define(be[154],we([78,29,41]),function(e,y,R){return ue(e,y,R)});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),y=require("fs"),R=require("../common/performance");module.exports=ue(e,y,R)}else throw new Error("Unknown context")}(),define(be[155],we([1,0,27]),function(ue,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sm=void 0;const R=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function r(I){const C=I.replace(/\-/g,":").toLowerCase();return!R.has(C)}function L(){const I=(0,y.networkInterfaces)();for(const C in I){const p=I[C];if(p){for(const{mac:w}of p)if(r(w))return w}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.$Sm=L}),define(be[101],we([1,0,27,64,23,155,3]),function(ue,e,y,R,r,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vm=e.$Um=e.$Tm=void 0,e.$Tm=new class{c(v){return this.a||(this.a=R.$Wh.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(v)}value(){if(this.b===void 0){let v=0,u=0;const b=(0,y.networkInterfaces)();for(const m in b){const d=b[m];if(d)for(const{mac:h,internal:g}of d)g||(u+=1,this.c(h.toUpperCase())&&(v+=1))}this.b=u>0?v/u:0}return this.b}};let C;async function p(v){return C||(C=(async()=>await w(v)||r.$fg())()),C}e.$Um=p;async function w(v){try{const u=await new Promise((m,d)=>{ue(["crypto"],m,d)}),b=(0,L.$Sm)();return u.createHash("sha256").update(b,"utf8").digest("hex")}catch(u){v(u);return}}const A="Software\\Microsoft\\SQMClient";async function k(v){if(I.$d){const u=await new Promise((b,m)=>{ue(["@vscode/windows-registry"],b,m)});try{return u.GetStringRegKey("HKEY_LOCAL_MACHINE",A,"MachineId")||""}catch(b){return v(b),""}}return""}e.$Vm=k}),define(be[156],we([1,0,29,296,297,3]),function(ue,e,y,R,r,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gg=void 0;async function I(C){if(L.$e||L.$d)return;let p;for(const w of["/etc/os-release","/usr/lib/os-release","/etc/lsb-release"])try{p=await(0,R.open)(w,y.constants.R_OK);break}catch{}if(!p){C("Unable to retrieve release information from known identifier paths.");return}try{const w=new Set(["ID","DISTRIB_ID","ID_LIKE","VERSION_ID","DISTRIB_RELEASE"]),A={id:"unknown"};for await(const k of(0,r.createInterface)({input:p.createReadStream(),crlfDelay:1/0})){if(!k.includes("="))continue;const v=k.split("=")[0].toUpperCase().trim();if(w.has(v)){const u=k.split("=")[1].replace(/"/g,"").toLowerCase().trim();v==="ID"||v==="DISTRIB_ID"?A.id=u:v==="ID_LIKE"?A.id_like=u:(v==="VERSION_ID"||v==="DISTRIB_RELEASE")&&(A.version_id=u)}}return A}catch(w){C(w)}}e.$gg=I}),define(be[21],we([1,0,29,27,298,14,39,98,7,3,19,4]),function(ue,e,y,R,r,L,I,C,p,w,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var v;(function(Z){Z[Z.UNLINK=0]="UNLINK",Z[Z.MOVE=1]="MOVE"})(v||(e.RimRafMode=v={}));async function u(Z,fe=v.UNLINK,V){if((0,I.$2f)(Z))throw new Error("rimraf - will refuse to recursively delete root");return fe===v.UNLINK?m(Z):b(Z,V)}async function b(Z,fe=(0,I.$7f)((0,R.tmpdir)())){try{try{await y.promises.rename(Z,fe)}catch(V){return V.code==="ENOENT"?void 0:m(Z)}m(fe).catch(V=>{})}catch(V){if(V.code!=="ENOENT")throw V}}async function m(Z){return(0,r.promisify)(y.rm)(Z,{recursive:!0,force:!0,maxRetries:3})}function d(Z){if((0,I.$2f)(Z))throw new Error("rimraf - will refuse to recursively delete root");y.rmSync(Z,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=d;async function h(Z,fe){return $(await(fe?g(Z):(0,r.promisify)(y.readdir)(Z)))}async function g(Z){try{return await(0,r.promisify)(y.readdir)(Z,{withFileTypes:!0})}catch(ie){console.warn("[node.js fs] readdir with filetypes failed with error: ",ie)}const fe=[],V=await h(Z);for(const ie of V){let Y=!1,J=!1,re=!1;try{const ce=await e.Promises.lstat((0,p.$jc)(Z,ie));Y=ce.isFile(),J=ce.isDirectory(),re=ce.isSymbolicLink()}catch(ce){console.warn("[node.js fs] unexpected error from lstat after readdir: ",ce)}fe.push({name:ie,isFile:()=>Y,isDirectory:()=>J,isSymbolicLink:()=>re})}return fe}function l(Z){return $(y.readdirSync(Z))}e.readdirSync=l;function $(Z){return Z.map(fe=>typeof fe=="string"?w.$e?(0,C.$ql)(fe):fe:(fe.name=w.$e?(0,C.$ql)(fe.name):fe.name,fe))}async function c(Z){const fe=await h(Z),V=[];for(const ie of fe)await i.existsDirectory((0,p.$jc)(Z,ie))&&V.push(ie);return V}function n(Z,fe=1e3){return new Promise(V=>{let ie=!1;const Y=setInterval(()=>{ie||(ie=!0,y.access(Z,J=>{ie=!1,J&&(clearInterval(Y),V(void 0))}))},fe)})}e.whenDeleted=n;var i;(function(Z){async function fe(Y){let J;try{if(J=await e.Promises.lstat(Y),!J.isSymbolicLink())return{stat:J}}catch{}try{return{stat:await e.Promises.stat(Y),symbolicLink:J?.isSymbolicLink()?{dangling:!1}:void 0}}catch(re){if(re.code==="ENOENT"&&J)return{stat:J,symbolicLink:{dangling:!0}};if(w.$d&&re.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(Y)),symbolicLink:{dangling:!1}}}catch(ce){if(ce.code==="ENOENT"&&J)return{stat:J,symbolicLink:{dangling:!0}};throw ce}throw re}}Z.stat=fe;async function V(Y){try{const{stat:J,symbolicLink:re}=await Z.stat(Y);return J.isFile()&&re?.dangling!==!0}catch{}return!1}Z.existsFile=V;async function ie(Y){try{const{stat:J,symbolicLink:re}=await Z.stat(Y);return J.isDirectory()&&re?.dangling!==!0}catch{}return!1}Z.existsDirectory=ie})(i||(e.SymlinkSupport=i={}));const o=new L.$4g;function s(Z,fe,V){return o.queueFor(k.URI.file(Z),A.$ng).queue(()=>{const ie=D(V);return new Promise((Y,J)=>f(Z,fe,ie,re=>re?J(re):Y()))})}let t=!0;function a(Z){t=Z}e.configureFlushOnWrite=a;function f(Z,fe,V,ie){if(!t)return y.writeFile(Z,fe,{mode:V.mode,flag:V.flag},ie);y.open(Z,V.flag,V.mode,(Y,J)=>{if(Y)return ie(Y);y.writeFile(J,fe,re=>{if(re)return y.close(J,()=>ie(re));y.fdatasync(J,ce=>(ce&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",ce),a(!1)),y.close(J,oe=>ie(oe))))})})}function S(Z,fe,V){const ie=D(V);if(!t)return y.writeFileSync(Z,fe,{mode:ie.mode,flag:ie.flag});const Y=y.openSync(Z,ie.flag,ie.mode);try{y.writeFileSync(Y,fe);try{y.fdatasyncSync(Y)}catch(J){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",J),a(!1)}}finally{y.closeSync(Y)}}e.writeFileSync=S;function D(Z){return Z?{mode:typeof Z.mode=="number"?Z.mode:438,flag:typeof Z.flag=="string"?Z.flag:"w"}:{mode:438,flag:"w"}}async function E(Z,fe,V=6e4){if(Z!==fe)try{w.$d&&typeof V=="number"?await P(Z,fe,Date.now(),V):await(0,r.promisify)(y.rename)(Z,fe)}catch(ie){if(Z.toLowerCase()!==fe.toLowerCase()&&ie.code==="EXDEV"||Z.endsWith("."))await M(Z,fe,{preserveSymlinks:!1}),await u(Z,v.MOVE);else throw ie}}async function P(Z,fe,V,ie,Y=0){try{return await(0,r.promisify)(y.rename)(Z,fe)}catch(J){if(J.code!=="EACCES"&&J.code!=="EPERM"&&J.code!=="EBUSY")throw J;if(Date.now()-V>=ie)throw console.error(`[node.js fs] rename failed after ${Y} retries with error: ${J}`),J;if(Y===0){let re=!1;try{const{stat:ce}=await i.stat(fe);ce.isFile()||(re=!0)}catch{}if(re)throw J}return await(0,L.$Vg)(Math.min(100,Y*10)),P(Z,fe,V,ie,Y+1)}}async function M(Z,fe,V){return se(Z,fe,{root:{source:Z,target:fe},options:V,handledSourcePaths:new Set})}const ee=511;async function se(Z,fe,V){if(V.handledSourcePaths.has(Z))return;V.handledSourcePaths.add(Z);const{stat:ie,symbolicLink:Y}=await i.stat(Z);if(Y){if(V.options.preserveSymlinks)try{return await he(Z,fe,V)}catch(J){console.warn("[node.js fs] copy of symlink failed: ",J)}if(Y.dangling)return}return ie.isDirectory()?G(Z,fe,ie.mode&ee,V):ne(Z,fe,ie.mode&ee)}async function G(Z,fe,V,ie){await e.Promises.mkdir(fe,{recursive:!0,mode:V});const Y=await h(Z);for(const J of Y)await se((0,p.$jc)(Z,J),(0,p.$jc)(fe,J),ie)}async function ne(Z,fe,V){await e.Promises.copyFile(Z,fe),await e.Promises.chmod(fe,V)}async function he(Z,fe,V){let ie=await e.Promises.readlink(Z);(0,I.$Yf)(ie,V.root.source,!w.$f)&&(ie=(0,p.$jc)(V.root.target,ie.substr(V.root.source.length+1))),await e.Promises.symlink(ie,fe)}e.Promises=new class{get access(){return(0,r.promisify)(y.access)}get stat(){return(0,r.promisify)(y.stat)}get lstat(){return(0,r.promisify)(y.lstat)}get utimes(){return(0,r.promisify)(y.utimes)}get read(){return(Z,fe,V,ie,Y)=>new Promise((J,re)=>{y.read(Z,fe,V,ie,Y,(ce,oe,_)=>ce?re(ce):J({bytesRead:oe,buffer:_}))})}get readFile(){return(0,r.promisify)(y.readFile)}get write(){return(Z,fe,V,ie,Y)=>new Promise((J,re)=>{y.write(Z,fe,V,ie,Y,(ce,oe,_)=>ce?re(ce):J({bytesWritten:oe,buffer:_}))})}get appendFile(){return(0,r.promisify)(y.appendFile)}get fdatasync(){return(0,r.promisify)(y.fdatasync)}get truncate(){return(0,r.promisify)(y.truncate)}get copyFile(){return(0,r.promisify)(y.copyFile)}get open(){return(0,r.promisify)(y.open)}get close(){return(0,r.promisify)(y.close)}get symlink(){return(0,r.promisify)(y.symlink)}get readlink(){return(0,r.promisify)(y.readlink)}get chmod(){return(0,r.promisify)(y.chmod)}get mkdir(){return(0,r.promisify)(y.mkdir)}get unlink(){return(0,r.promisify)(y.unlink)}get rmdir(){return(0,r.promisify)(y.rmdir)}get realpath(){return(0,r.promisify)(y.realpath)}async exists(Z){try{return await e.Promises.access(Z),!0}catch{return!1}}get readdir(){return h}get readDirsInDir(){return c}get writeFile(){return s}get rm(){return u}get rename(){return E}get copy(){return M}}}),define(be[157],we([1,0,29,7,3,17,21]),function(ue,e,y,R,r,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aq=e.$_p=e.$$p=e.$0p=void 0;function C(v){if(r.$f)return v;const u=(0,R.$mc)(v);if(v===u)return v;const b=((0,R.$nc)(v)||v).toLowerCase();try{const d=(0,I.readdirSync)(u).filter(h=>h.toLowerCase()===b);if(d.length===1){const h=C(u);if(h)return(0,R.$jc)(h,d[0])}else if(d.length>1){const h=d.indexOf(b);if(h>=0){const g=C(u);if(g)return(0,R.$jc)(g,d[h])}}}catch{}return null}e.$0p=C;async function p(v){if(r.$f)return v;const u=(0,R.$mc)(v);if(v===u)return v;const b=((0,R.$nc)(v)||v).toLowerCase();try{const d=(await I.Promises.readdir(u)).filter(h=>h.toLowerCase()===b);if(d.length===1){const h=await p(u);if(h)return(0,R.$jc)(h,d[0])}else if(d.length>1){const h=d.indexOf(b);if(h>=0){const g=await p(u);if(g)return(0,R.$jc)(g,d[h])}}}catch{}return null}e.$$p=p;async function w(v){try{return await I.Promises.realpath(v)}catch{const b=k(v);return await I.Promises.access(b,y.constants.R_OK),b}}e.$_p=w;function A(v){try{return y.realpathSync(v)}catch{const b=k(v);return y.accessSync(b,y.constants.R_OK),b}}e.$aq=A;function k(v){return(0,L.$Le)((0,R.$hc)(v),R.sep)}}),define(be[158],we([1,0,79]),function(ue,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jg=e.$ig=e.$hg=void 0;function R(C,p,w,A=1){let k=!1;return new Promise(v=>{const u=setTimeout(()=>{if(!k)return k=!0,v(0)},w);r(C,p,A,b=>{if(!k)return k=!0,clearTimeout(u),v(b)})})}e.$hg=R;function r(C,p,w,A){if(p===0)return A(0);const k=new y.Socket;k.once("connect",()=>(I(k),r(C+w,p-1,w,A))),k.once("data",()=>{}),k.once("error",v=>(I(k),v.code!=="ECONNREFUSED"?r(C+w,p-1,w,A):A(C))),k.connect(C,"127.0.0.1")}e.$ig={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function L(C,p,w,A="127.0.0.1"){let k=!1,v,u=1;const b=y.createServer({pauseOnConnect:!0});function m(d,h){k||(k=!0,b.removeAllListeners(),b.close(),v&&clearTimeout(v),h(d))}return new Promise(d=>{v=setTimeout(()=>{m(0,d)},w),b.on("listening",()=>{m(C,d)}),b.on("error",h=>{h&&(h.code==="EADDRINUSE"||h.code==="EACCES")&&u<p?(C++,u++,b.listen(C,A)):m(0,d)}),b.on("close",()=>{m(0,d)}),b.listen(C,A)})}e.$jg=L;function I(C){try{C.removeAllListeners("connect"),C.removeAllListeners("error"),C.end(),C.destroy(),C.unref()}catch(p){console.error(p)}}}),define(be[102],we([1,0,27,7,21]),function(ue,e,y,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Al=e.$zl=void 0;const L=/^\d+$/,I=/^Microsoft.PowerShell_.*/,C=/^Microsoft.PowerShellPreview_.*/;var p;(function($){$[$.x64=0]="x64",$[$.x86=1]="x86",$[$.ARM=2]="ARM"})(p||(p={}));let w;switch(process.arch){case"ia32":w=1;break;case"arm":case"arm64":w=2;break;default:w=0;break}let A;process.env.PROCESSOR_ARCHITEW6432?A=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?A=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?A=1:A=0;class k{constructor(c,n,i){this.exePath=c,this.displayName=n,this.a=i}async exists(){return this.a===void 0&&(this.a=await r.SymlinkSupport.existsFile(this.exePath)),this.a}}function v({useAlternateBitness:$=!1}={}){return $?w===0?process.env["ProgramFiles(x86)"]||null:A===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function u({useAlternateBitness:$=!1,findPreview:c=!1}={}){const n=v({useAlternateBitness:$});if(!n)return null;const i=R.$jc(n,"PowerShell");if(!await r.SymlinkSupport.existsDirectory(i))return null;let o=-1,s=null;for(const f of await r.Promises.readdir(i)){let S=-1;if(c){const E=f.indexOf("-");if(E<0)continue;const P=f.substring(0,E);if(!L.test(P)||f.substring(E+1)!=="preview")continue;S=parseInt(P,10)}else{if(!L.test(f))continue;S=parseInt(f,10)}if(S<=o)continue;const D=R.$jc(i,f,"pwsh.exe");await r.SymlinkSupport.existsFile(D)&&(s=D,o=S)}if(!s)return null;const t=n.includes("x86")?" (x86)":"",a=c?" Preview":"";return new k(s,`PowerShell${a}${t}`,!0)}async function b({findPreview:$}={}){if(!process.env.LOCALAPPDATA)return null;const c=R.$jc(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await r.SymlinkSupport.existsDirectory(c))return null;const{pwshMsixDirRegex:n,pwshMsixName:i}=$?{pwshMsixDirRegex:C,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:I,pwshMsixName:"PowerShell (Store)"};for(const o of await r.Promises.readdir(c))if(n.test(o)){const s=R.$jc(c,o,"pwsh.exe");return new k(s,i)}return null}function m(){const $=R.$jc(y.homedir(),".dotnet","tools","pwsh.exe");return new k($,".NET Core PowerShell Global Tool")}function d(){const $=R.$jc(process.env.windir,w===1&&A!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new k($,"Windows PowerShell",!0)}async function*h(){let $=await u();$&&(yield $),$=await u({useAlternateBitness:!0}),$&&(yield $),$=await b(),$&&(yield $),$=m(),$&&(yield $),$=await u({findPreview:!0}),$&&(yield $),$=await b({findPreview:!0}),$&&(yield $),$=await u({useAlternateBitness:!0,findPreview:!0}),$&&(yield $),$=d(),$&&(yield $)}async function*g(){for await(const $ of h())await $.exists()&&(yield $)}e.$zl=g;async function l(){for await(const $ of g())return $;return null}e.$Al=l}),define(be[103],we([1,0,7,3,28,60,8,21]),function(ue,e,y,R,r,L,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.$El=e.$Dl=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return L.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return L.TerminateResponseCode}});function p(k=r.env){return k.comspec||"cmd.exe"}e.$Dl=p;function w(k){let v=[],u=!1;const b=function(m){if(u){v.push(m);return}(!k.send(m,h=>{if(h&&console.error(h),u=!1,v.length>0){const g=v.slice(0);v=[],g.forEach(l=>b(l))}})||R.$d)&&(u=!0)};return{send:b}}e.$El=w;var A;(function(k){async function v(u,b,m){if(y.$ic(u))return u;if(b===void 0&&(b=r.cwd()),y.$mc(u)!=="."||(m===void 0&&I.$zf(r.env.PATH)&&(m=r.env.PATH.split(y.$tc)),m===void 0||m.length===0))return y.$jc(b,u);async function h(g){if(await C.Promises.exists(g)){let l;try{l=await C.Promises.stat(g)}catch($){$.message.startsWith("EACCES")&&(l=await C.Promises.lstat(g))}return l?!l.isDirectory():!1}return!1}for(const g of m){let l;if(y.$ic(g)?l=y.$jc(g,u):l=y.$jc(b,g,u),await h(l))return l;let $=l+".com";if(await h($)||($=l+".exe",await h($)))return $}return y.$jc(b,u)}k.findExecutable=v})(A||(e.win32=A={}))}),define(be[104],we([1,0,52,12]),function(ue,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hr=void 0;function r(I){return new Promise((C,p)=>{let w;const A=new Map;function k(u,b,m,d,h){const g=A.get(b);if(u===I||g){const l={name:v(m),cmd:m,pid:u,ppid:b,load:d,mem:h};A.set(u,l),u===I&&(w=l),g&&(g.children||(g.children=[]),g.children.push(l),g.children.length>1&&(g.children=g.children.sort(($,c)=>$.pid-c.pid)))}}function v(u){const b=/--utility-sub-type=network/i,m=/--ms-enable-electron-run-as-node/i,d=/--crashes-directory/i,h=/\\pipe\\winpty-control/i,g=/conhost\.exe.+--headless/i,l=/--type=([a-zA-Z-]+)/;if(d.exec(u))return"electron-crash-reporter";if(h.exec(u))return"winpty-agent";if(g.exec(u))return"conpty-agent";let $=l.exec(u);if($&&$.length===2)return $[1]==="renderer"?"window":$[1]==="utility"?b.exec(u)?"utility-network-service":"utility-process":$[1]==="extensionHost"?"extension-host":$[1];const c=/[a-zA-Z-]+\.js/g;let n="";do $=c.exec(u),$&&(n+=$+" ");while($);return n&&u.indexOf("node ")<0&&u.indexOf("node.exe")<0?`electron-nodejs (${n})`:m.exec(u)?`electron-nodejs (${u})`:u}if(process.platform==="win32"){const u=b=>b.indexOf("\\\\?\\")===0||b.indexOf("\\??\\")===0?b.substring(4):b.indexOf('"\\\\?\\')===0||b.indexOf('"\\??\\')===0?'"'+b.substring(5):b;new Promise((b,m)=>{ue(["@vscode/windows-process-tree"],b,m)}).then(b=>{b.getProcessList(I,m=>{if(!m){p(new Error(`Root process ${I} not found`));return}b.getProcessCpuUsage(m,d=>{const h=new Map;d.forEach(g=>{const l=u(g.commandLine||"");h.set(g.pid,{name:v(l),cmd:l,pid:g.pid,ppid:g.ppid,load:g.cpu||0,mem:g.memory||0})}),w=h.get(I),w?(h.forEach(g=>{const l=h.get(g.ppid);l&&(l.children||(l.children=[]),l.children.push(g))}),h.forEach(g=>{g.children&&(g.children=g.children.sort((l,$)=>l.pid-$.pid))}),C(w)):p(new Error(`Root process ${I} not found`))})},b.ProcessDataFlag.CommandLine|b.ProcessDataFlag.Memory)})}else{let u=function(){let b=[w];const m=[];for(;b.length;){const h=b.shift();h&&(m.push(h.pid),h.children&&(b=b.concat(h.children)))}let d=JSON.stringify(R.$dg.asFileUri("vs/base/node/cpuUsage.sh").fsPath);d+=" "+m.join(" "),(0,y.exec)(d,{},(h,g,l)=>{if(h||l)p(h||new Error(l.toString()));else{const $=g.toString().split(`
`);for(let c=0;c<m.length;c++){const n=A.get(m[c]);n.load=parseFloat($[c])}if(!w){p(new Error(`Root process ${I} not found`));return}C(w)}})};(0,y.exec)("which ps",{},(b,m,d)=>{if(b||d)if(process.platform!=="linux")p(b||new Error(d.toString()));else{const h=JSON.stringify(R.$dg.asFileUri("vs/base/node/ps.sh").fsPath);(0,y.exec)(h,{},(g,l,$)=>{g||$?p(g||new Error($.toString())):(L(l,k),u())})}else{const h=m.toString().trim(),g="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,y.exec)(`${h} ${g}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(l,$,c)=>{l||c&&!c.includes("screen size is bogus")?p(l||new Error(c.toString())):(L($,k),process.platform==="linux"?u():w?C(w):p(new Error(`Root process ${I} not found`)))})}})}})}e.$Hr=r;function L(I,C){const p=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,w=I.toString().split(`
`);for(const A of w){const k=p.exec(A.trim());k&&k.length===6&&C(parseInt(k[1]),parseInt(k[2]),k[5],parseFloat(k[3]),parseFloat(k[4]))}}}),define(be[105],we([1,0,27,3,102,103]),function(ue,e,y,R,r,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fl=void 0;async function I(k,v){return k===1?R.$d?A():L.$Dl(v):p(k,v)}e.$Fl=I;let C=null;function p(k,v){if(R.$f&&k===2||R.$e&&k===3)return"/bin/bash";if(!C){let u;if(R.$d)u="/bin/bash";else{if(u=v.SHELL,!u)try{u=(0,y.userInfo)().shell}catch{}u||(u="sh"),u==="/bin/false"&&(u="/bin/bash")}C=u}return C}let w=null;async function A(){return w||(w=(await(0,r.$Al)()).exePath),w}}),function(){function ue(){function e(){return process.uncHostAllowlist}function y(p){const w=new Set;if(Array.isArray(p))for(const A of p)typeof A=="string"&&w.add(A);return Array.from(w)}function R(){const p=e();return p?Array.from(p):[]}function r(p){if(process.platform!=="win32")return;const w=e();if(w)if(typeof p=="string")w.add(p.toLowerCase());else for(const A of y(p))r(A)}function L(p){if(typeof p!="string")return;const w=["\\\\.\\UNC\\","\\\\?\\UNC\\","\\\\"];let A;for(const k of w){if(p.indexOf(k)!==0)continue;const u=p.indexOf("\\",k.length);if(u===-1)continue;const b=p.substring(k.length,u);if(b){A=b;break}}return A}function I(){process.platform==="win32"&&(process.restrictUNCAccess=!1)}function C(){return process.platform!=="win32"?!0:process.restrictUNCAccess===!1}return{getUNCHostAllowlist:R,addUNCHostToAllowlist:r,getUNCHost:L,disableUNCAccessRestrictions:I,isUNCAccessRestrictionsDisabled:C}}typeof define=="function"?define("vs/base/node/unc",[],function(){return ue()}):typeof module=="object"&&typeof module.exports=="object"?module.exports=ue():console.trace("vs/base/node/unc defined in UNKNOWN context (neither requirejs or commonjs)")}();var Re=this&&this.__decorate||function(ue,e,y,R){var r=arguments.length,L=r<3?e:R===null?R=Object.getOwnPropertyDescriptor(e,y):R,I;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")L=Reflect.decorate(ue,e,y,R);else for(var C=ue.length-1;C>=0;C--)(I=ue[C])&&(L=(r<3?I(L):r>3?I(e,y,L):I(e,y))||L);return r>3&&L&&Object.defineProperty(e,y,L),L};define(be[42],we([1,0,18,14,15,20,73,11,5,2,50,17,8]),function(ue,e,y,R,r,L,I,C,p,w,A,k,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zh=e.ProxyChannel=e.$yh=e.$xh=e.$wh=e.$vh=e.$uh=e.$th=e.RequestInitiator=e.$sh=e.$rh=e.$qh=e.$ph=e.$oh=void 0;var u;(function(Y){Y[Y.Promise=100]="Promise",Y[Y.PromiseCancel=101]="PromiseCancel",Y[Y.EventListen=102]="EventListen",Y[Y.EventDispose=103]="EventDispose"})(u||(u={}));function b(Y){switch(Y){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var m;(function(Y){Y[Y.Initialize=200]="Initialize",Y[Y.PromiseSuccess=201]="PromiseSuccess",Y[Y.PromiseError=202]="PromiseError",Y[Y.PromiseErrorObj=203]="PromiseErrorObj",Y[Y.EventFire=204]="EventFire"})(m||(m={}));function d(Y){switch(Y){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var h;(function(Y){Y[Y.Uninitialized=0]="Uninitialized",Y[Y.Idle=1]="Idle"})(h||(h={}));function g(Y){let J=0;for(let re=0;;re+=7){const ce=Y.read(1);if(J|=(ce.buffer[0]&127)<<re,!(ce.buffer[0]&128))return J}}const l=o(0);function $(Y,J){if(J===0){Y.write(l);return}let re=0;for(let oe=J;oe!==0;oe=oe>>>7)re++;const ce=r.$ce.alloc(re);for(let oe=0;J!==0;oe++)ce.buffer[oe]=J&127,J=J>>>7,J>0&&(ce.buffer[oe]|=128);Y.write(ce)}class c{constructor(J){this.b=J,this.a=0}read(J){const re=this.b.slice(this.a,this.a+J);return this.a+=re.byteLength,re}}e.$oh=c;class n{constructor(){this.a=[]}get buffer(){return r.$ce.concat(this.a)}write(J){this.a.push(J)}}e.$ph=n;var i;(function(Y){Y[Y.Undefined=0]="Undefined",Y[Y.String=1]="String",Y[Y.Buffer=2]="Buffer",Y[Y.VSBuffer=3]="VSBuffer",Y[Y.Array=4]="Array",Y[Y.Object=5]="Object",Y[Y.Int=6]="Int"})(i||(i={}));function o(Y){const J=r.$ce.alloc(1);return J.writeUInt8(Y,0),J}const s={Undefined:o(i.Undefined),String:o(i.String),Buffer:o(i.Buffer),VSBuffer:o(i.VSBuffer),Array:o(i.Array),Object:o(i.Object),Uint:o(i.Int)},t=typeof Buffer<"u";function a(Y,J){if(typeof J>"u")Y.write(s.Undefined);else if(typeof J=="string"){const re=r.$ce.fromString(J);Y.write(s.String),$(Y,re.byteLength),Y.write(re)}else if(t&&Buffer.isBuffer(J)){const re=r.$ce.wrap(J);Y.write(s.Buffer),$(Y,re.byteLength),Y.write(re)}else if(J instanceof r.$ce)Y.write(s.VSBuffer),$(Y,J.byteLength),Y.write(J);else if(Array.isArray(J)){Y.write(s.Array),$(Y,J.length);for(const re of J)a(Y,re)}else if(typeof J=="number"&&(J|0)===J)Y.write(s.Uint),$(Y,J);else{const re=r.$ce.fromString(JSON.stringify(J));Y.write(s.Object),$(Y,re.byteLength),Y.write(re)}}e.$qh=a;function f(Y){switch(Y.read(1).readUInt8(0)){case i.Undefined:return;case i.String:return Y.read(g(Y)).toString();case i.Buffer:return Y.read(g(Y)).buffer;case i.VSBuffer:return Y.read(g(Y));case i.Array:{const re=g(Y),ce=[];for(let oe=0;oe<re;oe++)ce.push(f(Y));return ce}case i.Object:return JSON.parse(Y.read(g(Y)).toString());case i.Int:return g(Y)}}e.$rh=f;class S{constructor(J,re,ce=null,oe=1e3){this.h=J,this.j=re,this.k=ce,this.l=oe,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(_=>this.q(_)),this.m({type:200})}registerChannel(J,re){this.b.set(J,re),setTimeout(()=>this.w(J),0)}m(J){switch(J.type){case 200:{const re=this.o([J.type]);this.k?.logOutgoing(re,0,1,d(J.type));return}case 201:case 202:case 204:case 203:{const re=this.o([J.type,J.id],J.data);this.k?.logOutgoing(re,J.id,1,d(J.type),J.data);return}}}o(J,re=void 0){const ce=new n;return a(ce,J),a(ce,re),this.p(ce.buffer)}p(J){try{return this.h.send(J),J.byteLength}catch{return 0}}q(J){const re=new c(J),ce=f(re),oe=f(re),_=ce[0];switch(_){case 100:return this.k?.logIncoming(J.byteLength,ce[1],1,`${b(_)}: ${ce[2]}.${ce[3]}`,oe),this.s({type:_,id:ce[1],channelName:ce[2],name:ce[3],arg:oe});case 102:return this.k?.logIncoming(J.byteLength,ce[1],1,`${b(_)}: ${ce[2]}.${ce[3]}`,oe),this.t({type:_,id:ce[1],channelName:ce[2],name:ce[3],arg:oe});case 101:return this.k?.logIncoming(J.byteLength,ce[1],1,`${b(_)}`),this.u({type:_,id:ce[1]});case 103:return this.k?.logIncoming(J.byteLength,ce[1],1,`${b(_)}`),this.u({type:_,id:ce[1]})}}s(J){const re=this.b.get(J.channelName);if(!re){this.v(J);return}const ce=new L.$Yd;let oe;try{oe=re.call(this.j,J.name,J.arg,ce.token)}catch(Q){oe=Promise.reject(Q)}const _=J.id;oe.then(Q=>{this.m({id:_,data:Q,type:201})},Q=>{Q instanceof Error?this.m({id:_,data:{message:Q.message,name:Q.name,stack:Q.stack?Q.stack.split?Q.stack.split(`
`):Q.stack:void 0},type:202}):this.m({id:_,data:Q,type:203})}).finally(()=>{q.dispose(),this.d.delete(J.id)});const q=(0,w.$Qc)(()=>ce.cancel());this.d.set(J.id,q)}t(J){const re=this.b.get(J.channelName);if(!re){this.v(J);return}const ce=J.id,_=re.listen(this.j,J.name,J.arg)(q=>this.m({id:ce,data:q,type:204}));this.d.set(J.id,_)}u(J){const re=this.d.get(J.id);re&&(re.dispose(),this.d.delete(J.id))}v(J){let re=this.g.get(J.channelName);re||(re=[],this.g.set(J.channelName,re));const ce=setTimeout(()=>{console.error(`Unknown channel: ${J.channelName}`),J.type===100&&this.m({id:J.id,data:{name:"Unknown channel",message:`Channel name '${J.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);re.push({request:J,timeoutTimer:ce})}w(J){const re=this.g.get(J);if(re){for(const ce of re)switch(clearTimeout(ce.timeoutTimer),ce.request.type){case 100:this.s(ce.request);break;case 102:this.t(ce.request);break}this.g.delete(J)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,w.$Nc)(this.d.values()),this.d.clear()}}e.$sh=S;var D;(function(Y){Y[Y.LocalSide=0]="LocalSide",Y[Y.OtherSide=1]="OtherSide"})(D||(e.RequestInitiator=D={}));class E{constructor(J,re=null){this.l=J,this.a=!1,this.b=h.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new p.$Od,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(ce=>this.s(ce)),this.j=re}getChannel(J){const re=this;return{call(ce,oe,_){return re.a?Promise.reject(new C.$5):re.m(J,ce,oe,_)},listen(ce,oe){return re.a?p.Event.None:re.o(J,ce,oe)}}}m(J,re,ce,oe=L.CancellationToken.None){const _=this.g++,Q={id:_,type:100,channelName:J,name:re,arg:ce};if(oe.isCancellationRequested)return Promise.reject(new C.$5);let O;return new Promise((U,T)=>{if(oe.isCancellationRequested)return T(new C.$5);const z=()=>{const x=W=>{switch(W.type){case 201:this.f.delete(_),U(W.data);break;case 202:{this.f.delete(_);const X=new Error(W.data.message);X.stack=Array.isArray(W.data.stack)?W.data.stack.join(`
`):W.data.stack,X.name=W.data.name,T(X);break}case 203:this.f.delete(_),T(W.data);break}};this.f.set(_,x),this.p(Q)};let B=null;this.b===h.Idle?z():(B=(0,R.$Ig)(x=>this.u()),B.then(()=>{B=null,z()}));const te=()=>{B?(B.cancel(),B=null):this.p({id:_,type:101}),T(new C.$5)},H=oe.onCancellationRequested(te);O=(0,w.$Pc)((0,w.$Qc)(te),H),this.d.add(O)}).finally(()=>{O.dispose(),this.d.delete(O)})}o(J,re,ce){const oe=this.g++,q={id:oe,type:102,channelName:J,name:re,arg:ce};let Q=null;const O=new p.$Od({onWillAddFirstListener:()=>{Q=(0,R.$Ig)(U=>this.u()),Q.then(()=>{Q=null,this.d.add(O),this.p(q)})},onDidRemoveLastListener:()=>{Q?(Q.cancel(),Q=null):(this.d.delete(O),this.p({id:oe,type:103}))}}),N=U=>O.fire(U.data);return this.f.set(oe,N),O.event}p(J){switch(J.type){case 100:case 102:{const re=this.q([J.type,J.id,J.channelName,J.name],J.arg);this.j?.logOutgoing(re,J.id,0,`${b(J.type)}: ${J.channelName}.${J.name}`,J.arg);return}case 101:case 103:{const re=this.q([J.type,J.id]);this.j?.logOutgoing(re,J.id,0,b(J.type));return}}}q(J,re=void 0){const ce=new n;return a(ce,J),a(ce,re),this.r(ce.buffer)}r(J){try{return this.l.send(J),J.byteLength}catch{return 0}}s(J){const re=new c(J),ce=f(re),oe=f(re),_=ce[0];switch(_){case 200:return this.j?.logIncoming(J.byteLength,0,0,d(_)),this.t({type:ce[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(J.byteLength,ce[1],0,d(_),oe),this.t({type:ce[0],id:ce[1],data:oe})}}t(J){if(J.type===200){this.b=h.Idle,this.k.fire();return}this.f.get(J.id)?.(J)}get onDidInitializePromise(){return p.Event.toPromise(this.onDidInitialize)}u(){return this.b===h.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,w.$Nc)(this.d.values()),this.d.clear()}}e.$th=E,Re([I.$ih],E.prototype,"onDidInitializePromise",null);class P{get connections(){const J=[];return this.f.forEach(re=>J.push(re)),J}constructor(J){this.a=new Map,this.f=new Set,this.g=new p.$Od,this.onDidAddConnection=this.g.event,this.h=new p.$Od,this.onDidRemoveConnection=this.h.event,this.j=new w.$Rc,this.j.add(J(({protocol:re,onDidClientDisconnect:ce})=>{const oe=p.Event.once(re.onMessage);this.j.add(oe(_=>{const q=new c(_),Q=f(q),O=new S(re,Q),N=new E(re);this.a.forEach((T,z)=>O.registerChannel(z,T));const U={channelServer:O,channelClient:N,ctx:Q};this.f.add(U),this.g.fire(U),this.j.add(ce(()=>{O.dispose(),N.dispose(),this.f.delete(U),this.h.fire(U)}))}))}))}getChannel(J,re){const ce=this;return{call(oe,_,q){let Q;if((0,v.$Nf)(re)){const N=(0,y.$4b)(ce.connections.filter(re));Q=N?Promise.resolve(N):p.Event.toPromise(p.Event.filter(ce.onDidAddConnection,re))}else Q=re.routeCall(ce,oe,_);const O=Q.then(N=>N.channelClient.getChannel(J));return ee(O).call(oe,_,q)},listen(oe,_){if((0,v.$Nf)(re))return ce.k(J,re,oe,_);const q=re.routeEvent(ce,oe,_).then(Q=>Q.channelClient.getChannel(J));return ee(q).listen(oe,_)}}}k(J,re,ce,oe){const _=this;let q;const Q=new p.$Od({onWillAddFirstListener:()=>{q=new w.$Rc;const O=new p.$Ud,N=new Map,U=z=>{const te=z.channelClient.getChannel(J).listen(ce,oe),H=O.add(te);N.set(z,H)},T=z=>{const B=N.get(z);B&&(B.dispose(),N.delete(z))};_.connections.filter(re).forEach(U),p.Event.filter(_.onDidAddConnection,re)(U,void 0,q),_.onDidRemoveConnection(T,void 0,q),O.event(Q.fire,Q,q),q.add(O)},onDidRemoveLastListener:()=>{q?.dispose(),q=void 0}});return Q.event}registerChannel(J,re){this.a.set(J,re);for(const ce of this.f)ce.channelServer.registerChannel(J,re)}dispose(){this.j.dispose();for(const J of this.f)J.channelClient.dispose(),J.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$uh=P;class M{constructor(J,re,ce=null){const oe=new n;a(oe,re),J.send(oe.buffer),this.a=new E(J,ce),this.d=new S(J,re,ce)}getChannel(J){return this.a.getChannel(J)}registerChannel(J,re){this.d.registerChannel(J,re)}dispose(){this.a.dispose(),this.d.dispose()}}e.$vh=M;function ee(Y){return{call(J,re,ce){return Y.then(oe=>oe.call(J,re,ce))},listen(J,re){const ce=new p.$Xd;return Y.then(oe=>ce.input=oe.listen(J,re)),ce.event}}}e.$wh=ee;function se(Y){let J=!1;return{call(re,ce,oe){return J?Y.call(re,ce,oe):(0,R.$Vg)(0).then(()=>J=!0).then(()=>Y.call(re,ce,oe))},listen(re,ce){if(J)return Y.listen(re,ce);const oe=new p.$Xd;return(0,R.$Vg)(0).then(()=>J=!0).then(()=>oe.input=Y.listen(re,ce)),oe.event}}}e.$xh=se;class G{constructor(J){this.a=J}routeCall(J){return this.b(J)}routeEvent(J){return this.b(J)}async b(J){for(const re of J.connections)if(await Promise.resolve(this.a(re.ctx)))return Promise.resolve(re);return await p.Event.toPromise(J.onDidAddConnection),await this.b(J)}}e.$yh=G;var ne;(function(Y){function J(_,q,Q){const O=_,N=Q&&Q.disableMarshalling,U=new Map;for(const T in O)ce(T)&&U.set(T,p.Event.buffer(O[T],!0,void 0,q));return new class{listen(T,z,B){const te=U.get(z);if(te)return te;if(oe(z)){const H=O[z];if(typeof H=="function")return H.call(O,B)}throw new C.$bb(`Event not found: ${z}`)}call(T,z,B){const te=O[z];if(typeof te=="function"){if(!N&&Array.isArray(B))for(let x=0;x<B.length;x++)B[x]=(0,A.$nh)(B[x]);let H=te.apply(O,B);return H instanceof Promise||(H=Promise.resolve(H)),H}throw new C.$bb(`Method not found: ${z}`)}}}Y.fromService=J;function re(_,q){const Q=q&&q.disableMarshalling;return new Proxy({},{get(O,N){if(typeof N=="string")return q?.properties?.has(N)?q.properties.get(N):oe(N)?function(U){return _.listen(N,U)}:ce(N)?_.listen(N):async function(...U){let T;q&&!(0,v.$If)(q.context)?T=[q.context,...U]:T=U;const z=await _.call(N,T);return Q?z:(0,A.$nh)(z)};throw new C.$bb(`Property not found: ${String(N)}`)}})}Y.toService=re;function ce(_){return _[0]==="o"&&_[1]==="n"&&k.$2e(_.charCodeAt(2))}function oe(_){return/^onDynamic/.test(_)&&k.$2e(_.charCodeAt(9))}})(ne||(e.ProxyChannel=ne={}));const he=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function Z(Y){if(Array.isArray(Y))return Y;if(Y&&typeof Y=="object"&&typeof Y.toString=="function"){const J=Y.toString();if(J!=="[object Object]")return J}return Y}function fe(Y){return Array.isArray(Y)?Y.map(Z):Z(Y)}function V(Y,J,re,ce,oe,_,q){q=fe(q);const Q=he[oe],O=Q[ce%Q.length];let N=[`%c[${Y}]%c[${String(J).padStart(7," ")}]%c[len: ${String(re).padStart(5," ")}]%c${String(ce).padStart(5," ")} - ${_}`,"color: darkgreen","color: grey","color: grey",`color: ${O}`];/\($/.test(_)?(N=N.concat(q),N.push(")")):N.push(q),console.log.apply(console,N)}class ie{constructor(J,re){this.d=J,this.f=re,this.a=0,this.b=0}logOutgoing(J,re,ce,oe,_){this.b+=J,V(this.d,this.b,J,re,ce,oe,_)}logIncoming(J,re,ce,oe,_){this.a+=J,V(this.f,this.a,J,re,ce,oe,_)}}e.$zh=ie}),define(be[106],we([1,0,15,5,2,42]),function(ue,e,y,R,r,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eh=e.$Dh=e.$Ch=e.$Bh=e.ProtocolConstants=e.$Ah=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var I;(function(s){s.Created="created",s.Read="read",s.Write="write",s.Open="open",s.Error="error",s.Close="close",s.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",s.NodeEndReceived="nodeEndReceived",s.NodeEndSent="nodeEndSent",s.NodeDrainBegin="nodeDrainBegin",s.NodeDrainEnd="nodeDrainEnd",s.zlibInflateError="zlibInflateError",s.zlibInflateData="zlibInflateData",s.zlibInflateInitialWrite="zlibInflateInitialWrite",s.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",s.zlibInflateWrite="zlibInflateWrite",s.zlibInflateFlushFired="zlibInflateFlushFired",s.zlibDeflateError="zlibDeflateError",s.zlibDeflateData="zlibDeflateData",s.zlibDeflateWrite="zlibDeflateWrite",s.zlibDeflateFlushFired="zlibDeflateFlushFired",s.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",s.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",s.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",s.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",s.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",s.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",s.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",s.ProtocolHeaderRead="protocolHeaderRead",s.ProtocolMessageRead="protocolMessageRead",s.ProtocolHeaderWrite="protocolHeaderWrite",s.ProtocolMessageWrite="protocolMessageWrite",s.ProtocolWrite="protocolWrite"})(I||(e.SocketDiagnosticsEventType=I={}));var C;(function(s){s.enableDiagnostics=!1,s.records=[];const t=new WeakMap;let a=0;function f(D,E){if(!t.has(D)){const P=String(++a);t.set(D,P)}return t.get(D)}function S(D,E,P,M){if(!s.enableDiagnostics)return;const ee=f(D,E);if(M instanceof y.$ce||M instanceof Uint8Array||M instanceof ArrayBuffer||ArrayBuffer.isView(M)){const se=y.$ce.alloc(M.byteLength);se.set(M),s.records.push({timestamp:Date.now(),id:ee,label:E,type:P,buff:se})}else s.records.push({timestamp:Date.now(),id:ee,label:E,type:P,data:M})}s.traceSocketEvent=S})(C||(e.SocketDiagnostics=C={}));var p;(function(s){s[s.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",s[s.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(p||(e.SocketCloseEventType=p={}));let w=null;function A(){return w||(w=y.$ce.alloc(0)),w}class k{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(t){this.a.push(t),this.b+=t.byteLength}read(t){return this.c(t,!0)}peek(t){return this.c(t,!1)}c(t,a){if(t===0)return A();if(t>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===t){const E=this.a[0];return a&&(this.a.shift(),this.b-=t),E}if(this.a[0].byteLength>t){const E=this.a[0].slice(0,t);return a&&(this.a[0]=this.a[0].slice(t),this.b-=t),E}const f=y.$ce.alloc(t);let S=0,D=0;for(;t>0;){const E=this.a[D];if(E.byteLength>t){const P=E.slice(0,t);f.set(P,S),S+=t,a&&(this.a[D]=E.slice(t),this.b-=t),t-=t}else f.set(E,S),S+=E.byteLength,a?(this.a.shift(),this.b-=E.byteLength):D++,t-=E.byteLength}return f}}e.$Ah=k;var v;(function(s){s[s.None=0]="None",s[s.Regular=1]="Regular",s[s.Control=2]="Control",s[s.Ack=3]="Ack",s[s.Disconnect=5]="Disconnect",s[s.ReplayRequest=6]="ReplayRequest",s[s.Pause=7]="Pause",s[s.Resume=8]="Resume",s[s.KeepAlive=9]="KeepAlive"})(v||(v={}));function u(s){switch(s){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var b;(function(s){s[s.HeaderLength=13]="HeaderLength",s[s.AcknowledgeTime=2e3]="AcknowledgeTime",s[s.TimeoutTime=2e4]="TimeoutTime",s[s.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",s[s.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",s[s.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(b||(e.ProtocolConstants=b={}));class m{constructor(t,a,f,S){this.type=t,this.id=a,this.ack=f,this.data=S,this.writtenTime=0}get size(){return this.data.byteLength}}class d extends r.$Sc{constructor(t){super(),this.f=this.B(new R.$Od),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=t,this.b=!1,this.c=new k,this.B(this.a.onData(a=>this.acceptChunk(a))),this.lastReadTime=Date.now()}acceptChunk(t){if(!(!t||t.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(t);this.c.byteLength>=this.g.readLen;){const a=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=a.readUInt32BE(9),this.g.messageType=a.readUInt8(0),this.g.id=a.readUInt32BE(1),this.g.ack=a.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:u(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const f=this.g.messageType,S=this.g.id,D=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",a),this.f.fire(new m(f,S,D,a)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class h{constructor(t){this.k=null,this.a=!1,this.b=!1,this.c=t,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(t){if(this.a)return;t.writtenTime=Date.now(),this.lastWriteTime=Date.now();const a=y.$ce.alloc(13);a.writeUInt8(t.type,0),a.writeUInt32BE(t.id,1),a.writeUInt32BE(t.ack,5),a.writeUInt32BE(t.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:u(t.type),id:t.id,ack:t.ack,messageSize:t.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",t.data),this.j(a,t.data)}g(t,a){const f=this.f===0;return this.d.push(t,a),this.f+=t.byteLength+a.byteLength,f}h(){const t=y.$ce.concat(this.d,this.f);return this.d.length=0,this.f=0,t}j(t,a){this.g(t,a)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const t=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:t.byteLength}),this.c.write(t)}}class g extends r.$Sc{constructor(t){super(),this.f=new R.$Od,this.onMessage=this.f.event,this.g=new R.$Od,this.onDidDispose=this.g.event,this.a=t,this.b=this.B(new h(this.a)),this.c=this.B(new d(this.a)),this.B(this.c.onMessage(a=>{a.type===1&&this.f.fire(a.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(t){this.b.write(new m(1,0,0,t))}}e.$Bh=g;class l extends L.$vh{static fromSocket(t,a){return new l(new g(t),a)}get onDidDispose(){return this.b.onDidDispose}constructor(t,a,f=null){super(t,a,f),this.b=t}dispose(){super.dispose();const t=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),t.end()}}e.$Ch=l;class ${constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new R.$Od({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(t){this.b?this.d.length>0?this.d.push(t):this.a.fire(t):this.d.push(t)}flushBuffer(){this.d=[]}}e.$Dh=$;class c{constructor(t){this.data=t,this.next=null}}class n{constructor(){this.a=null,this.b=null}length(){let t=0,a=this.a;for(;a;)a=a.next,t++;return t}peek(){return this.a?this.a.data:null}toArray(){const t=[];let a=0,f=this.a;for(;f;)t[a++]=f.data,f=f.next;return t}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(t){const a=new c(t);if(!this.a){this.a=a,this.b=a;return}this.b.next=a,this.b=a}}class i{static getInstance(){return i.b||(i.b=new i),i.b}constructor(){this.c=[];const t=Date.now();for(let a=0;a<i.a;a++)this.c[a]=t-1e3*a;setInterval(()=>{for(let a=i.a;a>=1;a--)this.c[a]=this.c[a-1];this.c[0]=Date.now()},1e3)}d(){const t=Date.now(),a=(1+i.a)*1e3;let f=0;for(let S=0;S<i.a;S++)t-this.c[S]<=a&&f++;return 1-f/i.a}hasHighLoad(){return this.d()>=.5}}i.a=10,i.b=null;class o{get unacknowledgedCount(){return this.c-this.d}constructor(t){this.u=new $,this.onControlMessage=this.u.event,this.v=new $,this.onMessage=this.v.event,this.w=new $,this.onDidDispose=this.w.event,this.x=new $,this.onSocketClose=this.x.event,this.y=new $,this.onSocketTimeout=this.y.event,this.s=t.loadEstimator??i.getInstance(),this.t=t.sendKeepAlive??!0,this.a=!1,this.b=new n,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new r.$Rc,this.o=t.socket,this.p=this.r.add(new h(this.o)),this.q=this.r.add(new d(this.o)),this.r.add(this.q.onMessage(a=>this.z(a))),this.r.add(this.o.onClose(a=>this.x.fire(a))),t.initialChunk&&this.q.acceptChunk(t.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const t=new m(5,0,0,A());this.p.write(t),this.p.flush()}sendPause(){const t=new m(7,0,0,A());this.p.write(t)}sendResume(){const t=new m(8,0,0,A());this.p.write(t)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(t,a){this.a=!0,this.r.dispose(),this.r=new r.$Rc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=t,this.p=this.r.add(new h(this.o)),this.q=this.r.add(new d(this.o)),this.r.add(this.q.onMessage(f=>this.z(f))),this.r.add(this.o.onClose(f=>this.x.fire(f))),this.q.acceptChunk(a)}endAcceptReconnection(){this.a=!1,this.h=this.g;const t=new m(3,0,this.h,A());this.p.write(t);const a=this.b.toArray();for(let f=0,S=a.length;f<S;f++)this.p.write(a[f]);this.B()}acceptDisconnect(){this.w.fire()}z(t){if(t.ack>this.d){this.d=t.ack;do{const a=this.b.peek();if(a&&a.id<=t.ack)this.b.pop();else break}while(!0)}switch(t.type){case 0:break;case 1:{if(t.id>this.g)if(t.id!==this.g+1){const a=Date.now();a-this.m>1e4&&(this.m=a,this.p.write(new m(6,0,0,A())))}else this.g=t.id,this.j=Date.now(),this.A(),this.v.fire(t.data);break}case 2:{this.u.fire(t.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const a=this.b.toArray();for(let f=0,S=a.length;f<S;f++)this.p.write(a[f]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(t){const a=++this.c;this.h=this.g;const f=new m(1,a,this.h,t);this.b.push(f),this.a||(this.p.write(f),this.B())}sendControl(t){const a=new m(2,0,0,t);this.p.write(a)}A(){if(this.g<=this.h||this.k)return;const t=Date.now()-this.j;if(t>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-t+5)}B(){if(this.c<=this.d||this.f||this.a)return;const t=this.b.peek(),a=Date.now()-t.writtenTime,f=Date.now()-this.q.lastReadTime,S=Date.now()-this.n;if(a>=2e4&&f>=2e4&&S>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:a,timeSinceLastReceivedSomeData:f});return}const D=Math.max(2e4-a,2e4-f,2e4-S,500);this.f=setTimeout(()=>{this.f=null,this.B()},D)}C(){if(this.g<=this.h)return;this.h=this.g;const t=new m(3,0,this.h,A());this.p.write(t)}D(){this.h=this.g;const t=new m(9,0,this.h,A());this.p.write(t)}}e.$Eh=o}),define(be[107],we([1,0,52,14,15,20,150,11,5,2,22,103,60,42]),function(ue,e,y,R,r,L,I,C,p,w,A,k,v,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8p=e.$7p=void 0;class b extends u.$sh{constructor(h){super({send:g=>{try{process.send?.(g.buffer.toString("base64"))}catch{}},onMessage:p.Event.fromNodeEventEmitter(process,"message",g=>r.$ce.wrap(Buffer.from(g,"base64")))},h),process.once("disconnect",()=>this.dispose())}}e.$7p=b;class m{constructor(h,g){this.i=h,this.j=g,this.c=new Set,this.g=new Map,this.h=new p.$Od,this.onDidProcessExit=this.h.event;const l=g&&g.timeout?g.timeout:6e4;this.b=new R.$Rg(l),this.d=null,this.f=null}getChannel(h){const g=this;return{call(l,$,c){return g.k(h,l,$,c)},listen(l,$){return g.l(h,l,$)}}}k(h,g,l,$=L.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if($.isCancellationRequested)return Promise.reject(C.$6());this.b.cancel();const c=this.n(h),n=(0,R.$Ig)(s=>c.call(g,l,s)),i=$.onCancellationRequested(()=>n.cancel()),o=(0,w.$Qc)(()=>n.cancel());return this.c.add(o),n.finally(()=>{i.dispose(),this.c.delete(o),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),n}l(h,g,l){if(!this.b)return p.Event.None;this.b.cancel();let $;const c=new p.$Od({onWillAddFirstListener:()=>{$=this.n(h).listen(g,l)(c.fire,c),this.c.add($)},onDidRemoveLastListener:()=>{this.c.delete($),$.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return c.event}get m(){if(!this.f){const h=this.j&&this.j.args?this.j.args:[],g=Object.create(null);g.env={...(0,A.$9m)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(g.env={...g.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(g.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(g.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(g.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),g.execArgv===void 0&&(g.execArgv=process.execArgv.filter(t=>!/^--inspect(-brk)?=/.test(t)).filter(t=>!t.startsWith("--vscode-"))),(0,v.$Cl)(g.env),this.d=(0,y.fork)(this.i,h,g);const l=new p.$Od;p.Event.fromNodeEventEmitter(this.d,"message",t=>t)(t=>{if((0,I.$3p)(t)){(0,I.log)(t,`IPC Library: ${this.j.serverName}`);return}l.fire(r.$ce.wrap(Buffer.from(t,"base64")))});const c=this.j.useQueue?(0,k.$El)(this.d):this.d,n=t=>this.d&&this.d.connected&&c.send(t.buffer.toString("base64")),i=l.event,o={send:n,onMessage:i};this.f=new u.$th(o);const s=()=>this.o();process.once("exit",s),this.d.on("error",t=>console.warn('IPC "'+this.j.serverName+'" errored with '+t)),this.d.on("exit",(t,a)=>{process.removeListener("exit",s),this.c.forEach(f=>(0,w.$Nc)(f)),this.c.clear(),t!==0&&a!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+t+" and signal "+a),this.b?.cancel(),this.o(),this.h.fire({code:t,signal:a})})}return this.f}n(h){let g=this.g.get(h);return g||(g=this.m.getChannel(h),this.g.set(h,g)),g}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$8p=m}),define(be[159],we([1,0,14,5,2,50,8]),function(ue,e,y,R,r,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8o=e.$7o=e.StorageState=e.$6o=e.StorageHint=void 0;var C;(function(v){v[v.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",v[v.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(C||(e.StorageHint=C={}));function p(v){const u=v;return u?.changed instanceof Map||u?.deleted instanceof Set}e.$6o=p;var w;(function(v){v[v.None=0]="None",v[v.Initialized=1]="Initialized",v[v.Closed=2]="Closed"})(w||(e.StorageState=w={}));class A extends r.$Sc{constructor(u,b=Object.create(null)){super(),this.r=u,this.s=b,this.b=this.B(new R.$Rd),this.onDidChangeStorage=this.b.event,this.c=w.None,this.f=new Map,this.g=this.B(new y.$Sg(A.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(u=>this.u(u)))}u(u){this.b.pause();try{u.changed?.forEach((b,m)=>this.w(m,b)),u.deleted?.forEach(b=>this.w(b,void 0))}finally{this.b.resume()}}w(u,b){if(this.c===w.Closed)return;let m=!1;(0,I.$If)(b)?m=this.f.delete(u):this.f.get(u)!==b&&(this.f.set(u,b),m=!0),m&&this.b.fire({key:u,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===w.None&&(this.c=w.Initialized,this.s.hint!==C.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(u,b){const m=this.f.get(u);return(0,I.$If)(m)?b:m}getBoolean(u,b){const m=this.get(u);return(0,I.$If)(m)?b:m==="true"}getNumber(u,b){const m=this.get(u);return(0,I.$If)(m)?b:parseInt(m,10)}getObject(u,b){const m=this.get(u);return(0,I.$If)(m)?b:(0,L.$mh)(m)}async set(u,b,m=!1){if(this.c===w.Closed)return;if((0,I.$If)(b))return this.delete(u,m);const d=(0,I.$Bf)(b)||Array.isArray(b)?(0,L.$lh)(b):String(b);if(this.f.get(u)!==d)return this.f.set(u,d),this.j.set(u,d),this.h.delete(u),this.b.fire({key:u,external:m}),this.D()}async delete(u,b=!1){if(!(this.c===w.Closed||!this.f.delete(u)))return this.h.has(u)||this.h.add(u),this.j.delete(u),this.b.fire({key:u,external:b}),this.D()}async optimize(){if(this.c!==w.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=w.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const u={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(u).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(u){if(this.z)return this.D(u)}async D(u){return this.s.hint===C.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),u)}async whenFlushed(){if(this.z)return new Promise(u=>this.n.push(u))}isInMemory(){return this.s.hint===C.STORAGE_IN_MEMORY}}e.$7o=A,A.a=100;class k{constructor(){this.onDidChangeItemsExternal=R.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(u){u.insert?.forEach((b,m)=>this.a.set(m,b)),u.delete?.forEach(b=>this.a.delete(b))}async optimize(){}async close(){}}e.$8o=k}),define(be[108],we([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xs=void 0;class y{constructor(r,L){this.lineNumber=r,this.column=L}with(r=this.lineNumber,L=this.column){return r===this.lineNumber&&L===this.column?this:new y(r,L)}delta(r=0,L=0){return this.with(this.lineNumber+r,this.column+L)}equals(r){return y.equals(this,r)}static equals(r,L){return!r&&!L?!0:!!r&&!!L&&r.lineNumber===L.lineNumber&&r.column===L.column}isBefore(r){return y.isBefore(this,r)}static isBefore(r,L){return r.lineNumber<L.lineNumber?!0:L.lineNumber<r.lineNumber?!1:r.column<L.column}isBeforeOrEqual(r){return y.isBeforeOrEqual(this,r)}static isBeforeOrEqual(r,L){return r.lineNumber<L.lineNumber?!0:L.lineNumber<r.lineNumber?!1:r.column<=L.column}static compare(r,L){const I=r.lineNumber|0,C=L.lineNumber|0;if(I===C){const p=r.column|0,w=L.column|0;return p-w}return I-C}clone(){return new y(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(r){return new y(r.lineNumber,r.column)}static isIPosition(r){return r&&typeof r.lineNumber=="number"&&typeof r.column=="number"}}e.$xs=y}),define(be[43],we([1,0,108]),function(ue,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ys=void 0;class R{constructor(L,I,C,p){L>C||L===C&&I>p?(this.startLineNumber=C,this.startColumn=p,this.endLineNumber=L,this.endColumn=I):(this.startLineNumber=L,this.startColumn=I,this.endLineNumber=C,this.endColumn=p)}isEmpty(){return R.isEmpty(this)}static isEmpty(L){return L.startLineNumber===L.endLineNumber&&L.startColumn===L.endColumn}containsPosition(L){return R.containsPosition(this,L)}static containsPosition(L,I){return!(I.lineNumber<L.startLineNumber||I.lineNumber>L.endLineNumber||I.lineNumber===L.startLineNumber&&I.column<L.startColumn||I.lineNumber===L.endLineNumber&&I.column>L.endColumn)}static strictContainsPosition(L,I){return!(I.lineNumber<L.startLineNumber||I.lineNumber>L.endLineNumber||I.lineNumber===L.startLineNumber&&I.column<=L.startColumn||I.lineNumber===L.endLineNumber&&I.column>=L.endColumn)}containsRange(L){return R.containsRange(this,L)}static containsRange(L,I){return!(I.startLineNumber<L.startLineNumber||I.endLineNumber<L.startLineNumber||I.startLineNumber>L.endLineNumber||I.endLineNumber>L.endLineNumber||I.startLineNumber===L.startLineNumber&&I.startColumn<L.startColumn||I.endLineNumber===L.endLineNumber&&I.endColumn>L.endColumn)}strictContainsRange(L){return R.strictContainsRange(this,L)}static strictContainsRange(L,I){return!(I.startLineNumber<L.startLineNumber||I.endLineNumber<L.startLineNumber||I.startLineNumber>L.endLineNumber||I.endLineNumber>L.endLineNumber||I.startLineNumber===L.startLineNumber&&I.startColumn<=L.startColumn||I.endLineNumber===L.endLineNumber&&I.endColumn>=L.endColumn)}plusRange(L){return R.plusRange(this,L)}static plusRange(L,I){let C,p,w,A;return I.startLineNumber<L.startLineNumber?(C=I.startLineNumber,p=I.startColumn):I.startLineNumber===L.startLineNumber?(C=I.startLineNumber,p=Math.min(I.startColumn,L.startColumn)):(C=L.startLineNumber,p=L.startColumn),I.endLineNumber>L.endLineNumber?(w=I.endLineNumber,A=I.endColumn):I.endLineNumber===L.endLineNumber?(w=I.endLineNumber,A=Math.max(I.endColumn,L.endColumn)):(w=L.endLineNumber,A=L.endColumn),new R(C,p,w,A)}intersectRanges(L){return R.intersectRanges(this,L)}static intersectRanges(L,I){let C=L.startLineNumber,p=L.startColumn,w=L.endLineNumber,A=L.endColumn;const k=I.startLineNumber,v=I.startColumn,u=I.endLineNumber,b=I.endColumn;return C<k?(C=k,p=v):C===k&&(p=Math.max(p,v)),w>u?(w=u,A=b):w===u&&(A=Math.min(A,b)),C>w||C===w&&p>A?null:new R(C,p,w,A)}equalsRange(L){return R.equalsRange(this,L)}static equalsRange(L,I){return!L&&!I?!0:!!L&&!!I&&L.startLineNumber===I.startLineNumber&&L.startColumn===I.startColumn&&L.endLineNumber===I.endLineNumber&&L.endColumn===I.endColumn}getEndPosition(){return R.getEndPosition(this)}static getEndPosition(L){return new y.$xs(L.endLineNumber,L.endColumn)}getStartPosition(){return R.getStartPosition(this)}static getStartPosition(L){return new y.$xs(L.startLineNumber,L.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(L,I){return new R(this.startLineNumber,this.startColumn,L,I)}setStartPosition(L,I){return new R(L,I,this.endLineNumber,this.endColumn)}collapseToStart(){return R.collapseToStart(this)}static collapseToStart(L){return new R(L.startLineNumber,L.startColumn,L.startLineNumber,L.startColumn)}collapseToEnd(){return R.collapseToEnd(this)}static collapseToEnd(L){return new R(L.endLineNumber,L.endColumn,L.endLineNumber,L.endColumn)}delta(L){return new R(this.startLineNumber+L,this.startColumn,this.endLineNumber+L,this.endColumn)}static fromPositions(L,I=L){return new R(L.lineNumber,L.column,I.lineNumber,I.column)}static lift(L){return L?new R(L.startLineNumber,L.startColumn,L.endLineNumber,L.endColumn):null}static isIRange(L){return L&&typeof L.startLineNumber=="number"&&typeof L.startColumn=="number"&&typeof L.endLineNumber=="number"&&typeof L.endColumn=="number"}static areIntersectingOrTouching(L,I){return!(L.endLineNumber<I.startLineNumber||L.endLineNumber===I.startLineNumber&&L.endColumn<I.startColumn||I.endLineNumber<L.startLineNumber||I.endLineNumber===L.startLineNumber&&I.endColumn<L.startColumn)}static areIntersecting(L,I){return!(L.endLineNumber<I.startLineNumber||L.endLineNumber===I.startLineNumber&&L.endColumn<=I.startColumn||I.endLineNumber<L.startLineNumber||I.endLineNumber===L.startLineNumber&&I.endColumn<=L.startColumn)}static compareRangesUsingStarts(L,I){if(L&&I){const w=L.startLineNumber|0,A=I.startLineNumber|0;if(w===A){const k=L.startColumn|0,v=I.startColumn|0;if(k===v){const u=L.endLineNumber|0,b=I.endLineNumber|0;if(u===b){const m=L.endColumn|0,d=I.endColumn|0;return m-d}return u-b}return k-v}return w-A}return(L?1:0)-(I?1:0)}static compareRangesUsingEnds(L,I){return L.endLineNumber===I.endLineNumber?L.endColumn===I.endColumn?L.startLineNumber===I.startLineNumber?L.startColumn-I.startColumn:L.startLineNumber-I.startLineNumber:L.endColumn-I.endColumn:L.endLineNumber-I.endLineNumber}static spansMultipleLines(L){return L.endLineNumber>L.startLineNumber}toJSON(){return this}}e.$ys=R}),define(be[160],we([1,0,43]),function(ue,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zs=void 0;class R{static insert(L,I){return{range:new y.$ys(L.lineNumber,L.column,L.lineNumber,L.column),text:I,forceMoveMarkers:!0}}static delete(L){return{range:L,text:null}}static replace(L,I){return{range:L,text:I}}static replaceMove(L,I){return{range:L,text:I,forceMoveMarkers:!0}}}e.$zs=R}),define(be[161],we([1,0,5,2]),function(ue,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0s=void 0;class r{constructor(){this.a=new Map,this.b=new Map,this.c=new y.$Od,this.onDidChange=this.c.event,this.d=null}handleChange(C){this.c.fire({changedLanguages:C,changedColorMap:!1})}register(C,p){return this.a.set(C,p),this.handleChange([C]),(0,R.$Qc)(()=>{this.a.get(C)===p&&(this.a.delete(C),this.handleChange([C]))})}get(C){return this.a.get(C)||null}registerFactory(C,p){this.b.get(C)?.dispose();const w=new L(this,C,p);return this.b.set(C,w),(0,R.$Qc)(()=>{const A=this.b.get(C);!A||A!==w||(this.b.delete(C),A.dispose())})}async getOrCreate(C){const p=this.get(C);if(p)return p;const w=this.b.get(C);return!w||w.isResolved?null:(await w.resolve(),this.get(C))}isResolved(C){if(this.get(C))return!0;const w=this.b.get(C);return!!(!w||w.isResolved)}setColorMap(C){this.d=C,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}e.$0s=r;class L extends R.$Sc{get isResolved(){return this.c}constructor(C,p,w){super(),this.f=C,this.g=p,this.h=w,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.j()),this.b}async j(){const C=await this.h.tokenizationSupport;this.c=!0,C&&!this.a&&this.B(this.f.register(this.g,C))}}}),define(be[162],we([9,10]),function(ue,e){return ue.create("vs/base/common/actions",e)}),define(be[163],we([1,0,5,2,162]),function(ue,e,y,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ai=e.$zi=e.$yi=e.$xi=e.$wi=e.$vi=void 0;class L extends R.$Sc{constructor(v,u="",b="",m=!0,d){super(),this.h=this.B(new y.$Od),this.onDidChange=this.h.event,this.w=!0,this.j=v,this.m=u,this.u=b,this.w=m,this.C=d}get id(){return this.j}get label(){return this.m}set label(v){this.D(v)}D(v){this.m!==v&&(this.m=v,this.h.fire({label:v}))}get tooltip(){return this.n||""}set tooltip(v){this.F(v)}F(v){this.n!==v&&(this.n=v,this.h.fire({tooltip:v}))}get class(){return this.u}set class(v){this.G(v)}G(v){this.u!==v&&(this.u=v,this.h.fire({class:v}))}get enabled(){return this.w}set enabled(v){this.H(v)}H(v){this.w!==v&&(this.w=v,this.h.fire({enabled:v}))}get checked(){return this.z}set checked(v){this.I(v)}I(v){this.z!==v&&(this.z=v,this.h.fire({checked:v}))}async run(v,u){this.C&&await this.C(v)}}e.$vi=L;class I extends R.$Sc{constructor(){super(...arguments),this.f=this.B(new y.$Od),this.onWillRun=this.f.event,this.m=this.B(new y.$Od),this.onDidRun=this.m.event}async run(v,u){if(!v.enabled)return;this.f.fire({action:v});let b;try{await this.u(v,u)}catch(m){b=m}this.m.fire({action:v,error:b})}async u(v,u){await v.run(u)}}e.$wi=I;class C{constructor(){this.id=C.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...v){let u=[];for(const b of v)b.length&&(u.length?u=[...u,new C,...b]:u=b);return u}async run(){}}e.$xi=C,C.ID="vs.actions.separator";class p{get actions(){return this.a}constructor(v,u,b,m){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=v,this.label=u,this.class=m,this.a=b}async run(){}}e.$yi=p;class w extends L{constructor(){super(w.ID,r.localize(0,null),void 0,!1)}}e.$zi=w,w.ID="vs.actions.empty";function A(k){return{id:k.id,label:k.label,class:void 0,enabled:k.enabled??!0,checked:k.checked??!1,run:async(...v)=>k.run(...v),tooltip:k.label}}e.$Ai=A}),define(be[164],we([9,10]),function(ue,e){return ue.create("vs/base/common/date",e)}),define(be[165],we([1,0,164]),function(ue,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gm=e.$fm=void 0;const R=60,r=R*60,L=r*24,I=L*7,C=L*30,p=L*365;function w(k,v,u,b){typeof k!="number"&&(k=k.getTime());const m=Math.round((new Date().getTime()-k)/1e3);if(m<-30)return(0,y.localize)(0,null,w(new Date().getTime()+m*1e3,!1));if(!b&&m<30)return(0,y.localize)(1,null);let d;return m<R?(d=m,v?d===1?u?(0,y.localize)(2,null,d):(0,y.localize)(3,null,d):u?(0,y.localize)(4,null,d):(0,y.localize)(5,null,d):d===1?u?(0,y.localize)(6,null,d):(0,y.localize)(7,null,d):u?(0,y.localize)(8,null,d):(0,y.localize)(9,null,d)):m<r?(d=Math.floor(m/R),v?d===1?u?(0,y.localize)(10,null,d):(0,y.localize)(11,null,d):u?(0,y.localize)(12,null,d):(0,y.localize)(13,null,d):d===1?u?(0,y.localize)(14,null,d):(0,y.localize)(15,null,d):u?(0,y.localize)(16,null,d):(0,y.localize)(17,null,d)):m<L?(d=Math.floor(m/r),v?d===1?u?(0,y.localize)(18,null,d):(0,y.localize)(19,null,d):u?(0,y.localize)(20,null,d):(0,y.localize)(21,null,d):d===1?u?(0,y.localize)(22,null,d):(0,y.localize)(23,null,d):u?(0,y.localize)(24,null,d):(0,y.localize)(25,null,d)):m<I?(d=Math.floor(m/L),v?d===1?(0,y.localize)(26,null,d):(0,y.localize)(27,null,d):d===1?(0,y.localize)(28,null,d):(0,y.localize)(29,null,d)):m<C?(d=Math.floor(m/I),v?d===1?u?(0,y.localize)(30,null,d):(0,y.localize)(31,null,d):u?(0,y.localize)(32,null,d):(0,y.localize)(33,null,d):d===1?u?(0,y.localize)(34,null,d):(0,y.localize)(35,null,d):u?(0,y.localize)(36,null,d):(0,y.localize)(37,null,d)):m<p?(d=Math.floor(m/C),v?d===1?u?(0,y.localize)(38,null,d):(0,y.localize)(39,null,d):u?(0,y.localize)(40,null,d):(0,y.localize)(41,null,d):d===1?u?(0,y.localize)(42,null,d):(0,y.localize)(43,null,d):u?(0,y.localize)(44,null,d):(0,y.localize)(45,null,d)):(d=Math.floor(m/p),v?d===1?u?(0,y.localize)(46,null,d):(0,y.localize)(47,null,d):u?(0,y.localize)(48,null,d):(0,y.localize)(49,null,d):d===1?u?(0,y.localize)(50,null,d):(0,y.localize)(51,null,d):u?(0,y.localize)(52,null,d):(0,y.localize)(53,null,d))}e.$fm=w;function A(k){return k.getFullYear()+"-"+String(k.getMonth()+1).padStart(2,"0")+"-"+String(k.getDate()).padStart(2,"0")+"T"+String(k.getHours()).padStart(2,"0")+":"+String(k.getMinutes()).padStart(2,"0")+":"+String(k.getSeconds()).padStart(2,"0")+"."+(k.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$gm=A}),define(be[166],we([9,10]),function(ue,e){return ue.create("vs/base/common/errorMessage",e)}),define(be[40],we([1,0,18,8,166]),function(ue,e,y,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Di=e.$Ci=e.$Bi=void 0;function L(k,v){return v&&(k.stack||k.stacktrace)?r.localize(0,null,C(k),I(k.stack)||I(k.stacktrace)):C(k)}function I(k){return Array.isArray(k)?k.join(`
`):k}function C(k){return k.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${k.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof k.code=="string"&&typeof k.errno=="number"&&typeof k.syscall=="string"?r.localize(1,null,k.message):k.message||r.localize(2,null)}function p(k=null,v=!1){if(!k)return r.localize(3,null);if(Array.isArray(k)){const u=y.$Hb(k),b=p(u[0],v);return u.length>1?r.localize(4,null,b,u.length):b}if(R.$zf(k))return k;if(k.detail){const u=k.detail;if(u.error)return L(u.error,v);if(u.exception)return L(u.exception,v)}return k.stack?L(k,v):k.message?k.message:r.localize(5,null)}e.$Bi=p;function w(k){const v=k;return v instanceof Error&&Array.isArray(v.actions)}e.$Ci=w;function A(k,v){let u;return typeof k=="string"?u=new Error(k):u=k,u.actions=v,u}e.$Di=A}),define(be[167],we([9,10]),function(ue,e){return ue.create("vs/base/common/jsonErrorMessages",e)}),define(be[168],we([1,0,167]),function(ue,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bp=void 0;function R(r){switch(r){case 1:return(0,y.localize)(0,null);case 2:return(0,y.localize)(1,null);case 3:return(0,y.localize)(2,null);case 4:return(0,y.localize)(3,null);case 5:return(0,y.localize)(4,null);case 6:return(0,y.localize)(5,null);case 7:return(0,y.localize)(6,null);case 8:return(0,y.localize)(7,null);case 9:return(0,y.localize)(8,null);default:return""}}e.$Bp=R}),define(be[169],we([9,10]),function(ue,e){return ue.create("vs/base/node/zip",e)}),define(be[170],we([9,10]),function(ue,e){return ue.create("vs/editor/common/languages",e)}),define(be[171],we([1,0,49,4,160,43,161,170]),function(ue,e,y,R,r,L,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.$pt=e.$ot=e.InlayHintKind=e.CommentState=e.CommentMode=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.$nt=e.$mt=e.SymbolKinds=e.SymbolTag=e.$lt=e.$kt=e.SymbolKind=e.$jt=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.$it=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.$ht=e.$gt=e.$ft=void 0;class p{constructor(ne,he,Z){this.offset=ne,this.type=he,this.language=Z,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}e.$ft=p;class w{constructor(ne,he){this.tokens=ne,this.endState=he,this._tokenizationResultBrand=void 0}}e.$gt=w;class A{constructor(ne,he){this.tokens=ne,this.endState=he,this._encodedTokenizationResultBrand=void 0}}e.$ht=A;var k;(function(G){G[G.Method=0]="Method",G[G.Function=1]="Function",G[G.Constructor=2]="Constructor",G[G.Field=3]="Field",G[G.Variable=4]="Variable",G[G.Class=5]="Class",G[G.Struct=6]="Struct",G[G.Interface=7]="Interface",G[G.Module=8]="Module",G[G.Property=9]="Property",G[G.Event=10]="Event",G[G.Operator=11]="Operator",G[G.Unit=12]="Unit",G[G.Value=13]="Value",G[G.Constant=14]="Constant",G[G.Enum=15]="Enum",G[G.EnumMember=16]="EnumMember",G[G.Keyword=17]="Keyword",G[G.Text=18]="Text",G[G.Color=19]="Color",G[G.File=20]="File",G[G.Reference=21]="Reference",G[G.Customcolor=22]="Customcolor",G[G.Folder=23]="Folder",G[G.TypeParameter=24]="TypeParameter",G[G.User=25]="User",G[G.Issue=26]="Issue",G[G.Snippet=27]="Snippet"})(k||(e.CompletionItemKind=k={}));var v;(function(G){const ne=new Map;ne.set(0,y.$Vj.symbolMethod),ne.set(1,y.$Vj.symbolFunction),ne.set(2,y.$Vj.symbolConstructor),ne.set(3,y.$Vj.symbolField),ne.set(4,y.$Vj.symbolVariable),ne.set(5,y.$Vj.symbolClass),ne.set(6,y.$Vj.symbolStruct),ne.set(7,y.$Vj.symbolInterface),ne.set(8,y.$Vj.symbolModule),ne.set(9,y.$Vj.symbolProperty),ne.set(10,y.$Vj.symbolEvent),ne.set(11,y.$Vj.symbolOperator),ne.set(12,y.$Vj.symbolUnit),ne.set(13,y.$Vj.symbolValue),ne.set(15,y.$Vj.symbolEnum),ne.set(14,y.$Vj.symbolConstant),ne.set(15,y.$Vj.symbolEnum),ne.set(16,y.$Vj.symbolEnumMember),ne.set(17,y.$Vj.symbolKeyword),ne.set(27,y.$Vj.symbolSnippet),ne.set(18,y.$Vj.symbolText),ne.set(19,y.$Vj.symbolColor),ne.set(20,y.$Vj.symbolFile),ne.set(21,y.$Vj.symbolReference),ne.set(22,y.$Vj.symbolCustomColor),ne.set(23,y.$Vj.symbolFolder),ne.set(24,y.$Vj.symbolTypeParameter),ne.set(25,y.$Vj.account),ne.set(26,y.$Vj.issues);function he(V){let ie=ne.get(V);return ie||(console.info("No codicon found for CompletionItemKind "+V),ie=y.$Vj.symbolProperty),ie}G.toIcon=he;const Z=new Map;Z.set("method",0),Z.set("function",1),Z.set("constructor",2),Z.set("field",3),Z.set("variable",4),Z.set("class",5),Z.set("struct",6),Z.set("interface",7),Z.set("module",8),Z.set("property",9),Z.set("event",10),Z.set("operator",11),Z.set("unit",12),Z.set("value",13),Z.set("constant",14),Z.set("enum",15),Z.set("enum-member",16),Z.set("enumMember",16),Z.set("keyword",17),Z.set("snippet",27),Z.set("text",18),Z.set("color",19),Z.set("file",20),Z.set("reference",21),Z.set("customcolor",22),Z.set("folder",23),Z.set("type-parameter",24),Z.set("typeParameter",24),Z.set("account",25),Z.set("issue",26);function fe(V,ie){let Y=Z.get(V);return typeof Y>"u"&&!ie&&(Y=9),Y}G.fromString=fe})(v||(e.CompletionItemKinds=v={}));var u;(function(G){G[G.Deprecated=1]="Deprecated"})(u||(e.CompletionItemTag=u={}));var b;(function(G){G[G.None=0]="None",G[G.KeepWhitespace=1]="KeepWhitespace",G[G.InsertAsSnippet=4]="InsertAsSnippet"})(b||(e.CompletionItemInsertTextRule=b={}));var m;(function(G){G[G.Invoke=0]="Invoke",G[G.TriggerCharacter=1]="TriggerCharacter",G[G.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(m||(e.CompletionTriggerKind=m={}));var d;(function(G){G[G.Automatic=0]="Automatic",G[G.Explicit=1]="Explicit"})(d||(e.InlineCompletionTriggerKind=d={}));class h{constructor(ne,he,Z,fe){this.range=ne,this.text=he,this.completionKind=Z,this.isSnippetText=fe}equals(ne){return L.$ys.lift(this.range).equalsRange(ne.range)&&this.text===ne.text&&this.completionKind===ne.completionKind&&this.isSnippetText===ne.isSnippetText}}e.$it=h;var g;(function(G){G[G.Invoke=1]="Invoke",G[G.Auto=2]="Auto"})(g||(e.CodeActionTriggerType=g={}));var l;(function(G){G[G.Invoke=1]="Invoke",G[G.TriggerCharacter=2]="TriggerCharacter",G[G.ContentChange=3]="ContentChange"})(l||(e.SignatureHelpTriggerKind=l={}));var $;(function(G){G[G.Text=0]="Text",G[G.Read=1]="Read",G[G.Write=2]="Write"})($||(e.DocumentHighlightKind=$={}));function c(G){return G&&R.URI.isUri(G.uri)&&L.$ys.isIRange(G.range)&&(L.$ys.isIRange(G.originSelectionRange)||L.$ys.isIRange(G.targetSelectionRange))}e.$jt=c;var n;(function(G){G[G.File=0]="File",G[G.Module=1]="Module",G[G.Namespace=2]="Namespace",G[G.Package=3]="Package",G[G.Class=4]="Class",G[G.Method=5]="Method",G[G.Property=6]="Property",G[G.Field=7]="Field",G[G.Constructor=8]="Constructor",G[G.Enum=9]="Enum",G[G.Interface=10]="Interface",G[G.Function=11]="Function",G[G.Variable=12]="Variable",G[G.Constant=13]="Constant",G[G.String=14]="String",G[G.Number=15]="Number",G[G.Boolean=16]="Boolean",G[G.Array=17]="Array",G[G.Object=18]="Object",G[G.Key=19]="Key",G[G.Null=20]="Null",G[G.EnumMember=21]="EnumMember",G[G.Struct=22]="Struct",G[G.Event=23]="Event",G[G.Operator=24]="Operator",G[G.TypeParameter=25]="TypeParameter"})(n||(e.SymbolKind=n={})),e.$kt={[17]:(0,C.localize)(0,null),[16]:(0,C.localize)(1,null),[4]:(0,C.localize)(2,null),[13]:(0,C.localize)(3,null),[8]:(0,C.localize)(4,null),[9]:(0,C.localize)(5,null),[21]:(0,C.localize)(6,null),[23]:(0,C.localize)(7,null),[7]:(0,C.localize)(8,null),[0]:(0,C.localize)(9,null),[11]:(0,C.localize)(10,null),[10]:(0,C.localize)(11,null),[19]:(0,C.localize)(12,null),[5]:(0,C.localize)(13,null),[1]:(0,C.localize)(14,null),[2]:(0,C.localize)(15,null),[20]:(0,C.localize)(16,null),[15]:(0,C.localize)(17,null),[18]:(0,C.localize)(18,null),[24]:(0,C.localize)(19,null),[3]:(0,C.localize)(20,null),[6]:(0,C.localize)(21,null),[14]:(0,C.localize)(22,null),[22]:(0,C.localize)(23,null),[25]:(0,C.localize)(24,null),[12]:(0,C.localize)(25,null)};function i(G,ne){return(0,C.localize)(26,null,G,e.$kt[ne])}e.$lt=i;var o;(function(G){G[G.Deprecated=1]="Deprecated"})(o||(e.SymbolTag=o={}));var s;(function(G){const ne=new Map;ne.set(0,y.$Vj.symbolFile),ne.set(1,y.$Vj.symbolModule),ne.set(2,y.$Vj.symbolNamespace),ne.set(3,y.$Vj.symbolPackage),ne.set(4,y.$Vj.symbolClass),ne.set(5,y.$Vj.symbolMethod),ne.set(6,y.$Vj.symbolProperty),ne.set(7,y.$Vj.symbolField),ne.set(8,y.$Vj.symbolConstructor),ne.set(9,y.$Vj.symbolEnum),ne.set(10,y.$Vj.symbolInterface),ne.set(11,y.$Vj.symbolFunction),ne.set(12,y.$Vj.symbolVariable),ne.set(13,y.$Vj.symbolConstant),ne.set(14,y.$Vj.symbolString),ne.set(15,y.$Vj.symbolNumber),ne.set(16,y.$Vj.symbolBoolean),ne.set(17,y.$Vj.symbolArray),ne.set(18,y.$Vj.symbolObject),ne.set(19,y.$Vj.symbolKey),ne.set(20,y.$Vj.symbolNull),ne.set(21,y.$Vj.symbolEnumMember),ne.set(22,y.$Vj.symbolStruct),ne.set(23,y.$Vj.symbolEvent),ne.set(24,y.$Vj.symbolOperator),ne.set(25,y.$Vj.symbolTypeParameter);function he(Z){let fe=ne.get(Z);return fe||(console.info("No codicon found for SymbolKind "+Z),fe=y.$Vj.symbolProperty),fe}G.toIcon=he})(s||(e.SymbolKinds=s={}));class t{static asEditOperation(ne){return r.$zs.replace(L.$ys.lift(ne.range),ne.text)}}e.$mt=t;class a{static fromValue(ne){switch(ne){case"comment":return a.Comment;case"imports":return a.Imports;case"region":return a.Region}return new a(ne)}constructor(ne){this.value=ne}}e.$nt=a,a.Comment=new a("comment"),a.Imports=new a("imports"),a.Region=new a("region");var f;(function(G){function ne(he){return!he||typeof he!="object"?!1:typeof he.id=="string"&&typeof he.title=="string"}G.is=ne})(f||(e.Command=f={}));var S;(function(G){G[G.Collapsed=0]="Collapsed",G[G.Expanded=1]="Expanded"})(S||(e.CommentThreadCollapsibleState=S={}));var D;(function(G){G[G.Unresolved=0]="Unresolved",G[G.Resolved=1]="Resolved"})(D||(e.CommentThreadState=D={}));var E;(function(G){G[G.Editing=0]="Editing",G[G.Preview=1]="Preview"})(E||(e.CommentMode=E={}));var P;(function(G){G[G.Published=0]="Published",G[G.Draft=1]="Draft"})(P||(e.CommentState=P={}));var M;(function(G){G[G.Type=1]="Type",G[G.Parameter=2]="Parameter"})(M||(e.InlayHintKind=M={}));class ee{constructor(ne){this.b=ne,this.a=null}dispose(){this.a&&this.a.then(ne=>{ne&&ne.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}e.$ot=ee,e.$pt=new I.$0s;var se;(function(G){G[G.None=0]="None",G[G.Option=1]="Option",G[G.Default=2]="Default",G[G.Preferred=3]="Preferred"})(se||(e.ExternalUriOpenerPriority=se={}))}),define(be[172],we([9,10]),function(ue,e){return ue.create("vs/platform/configuration/common/configurationRegistry",e)}),define(be[173],we([9,10]),function(ue,e){return ue.create("vs/platform/contextkey/common/contextkey",e)}),define(be[174],we([9,10]),function(ue,e){return ue.create("vs/platform/contextkey/common/scanner",e)}),define(be[175],we([9,10]),function(ue,e){return ue.create("vs/platform/environment/node/argv",e)}),define(be[176],we([9,10]),function(ue,e){return ue.create("vs/platform/environment/node/argvHelper",e)}),define(be[177],we([9,10]),function(ue,e){return ue.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(be[178],we([9,10]),function(ue,e){return ue.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(be[179],we([9,10]),function(ue,e){return ue.create("vs/platform/extensionManagement/common/extensionManagementCLI",e)}),define(be[180],we([9,10]),function(ue,e){return ue.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(be[181],we([9,10]),function(ue,e){return ue.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(be[182],we([9,10]),function(ue,e){return ue.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(be[183],we([9,10]),function(ue,e){return ue.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(be[184],we([9,10]),function(ue,e){return ue.create("vs/platform/extensions/common/extensionValidator",e)}),define(be[185],we([9,10]),function(ue,e){return ue.create("vs/platform/files/common/fileService",e)}),define(be[186],we([9,10]),function(ue,e){return ue.create("vs/platform/files/common/files",e)}),define(be[187],we([9,10]),function(ue,e){return ue.create("vs/platform/files/common/io",e)}),define(be[188],we([9,10]),function(ue,e){return ue.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(be[189],we([9,10]),function(ue,e){return ue.create("vs/platform/languagePacks/common/languagePacks",e)}),define(be[190],we([9,10]),function(ue,e){return ue.create("vs/platform/markers/common/markers",e)}),define(be[191],we([9,10]),function(ue,e){return ue.create("vs/platform/request/common/request",e)}),define(be[192],we([9,10]),function(ue,e){return ue.create("vs/platform/shell/node/shellEnv",e)}),define(be[193],we([9,10]),function(ue,e){return ue.create("vs/platform/telemetry/common/telemetryService",e)}),define(be[194],we([9,10]),function(ue,e){return ue.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(be[195],we([9,10]),function(ue,e){return ue.create("vs/platform/terminal/common/terminalProfiles",e)}),define(be[196],we([9,10]),function(ue,e){return ue.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(be[197],we([9,10]),function(ue,e){return ue.create("vs/platform/workspace/common/workspace",e)}),define(be[198],we([9,10]),function(ue,e){return ue.create("vs/server/node/remoteExtensionHostAgentCli",e)}),define(be[199],we([9,10]),function(ue,e){return ue.create("vs/server/node/serverEnvironmentService",e)}),define(be[200],we([9,10]),function(ue,e){return ue.create("vs/server/node/serverServices",e)}),define(be[201],we([9,10]),function(ue,e){return ue.create("vs/workbench/api/common/extHostTelemetry",e)}),define(be[202],we([9,10]),function(ue,e){return ue.create("vs/workbench/common/editor",e)}),define(be[203],we([9,10]),function(ue,e){return ue.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(be[204],we([9,10]),function(ue,e){return ue.create("vs/workbench/services/extensions/common/extensionsUtil",e)}),define(be[205],we([1,0,11,174]),function(ue,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Li=e.TokenType=void 0;var r;(function(w){w[w.LParen=0]="LParen",w[w.RParen=1]="RParen",w[w.Neg=2]="Neg",w[w.Eq=3]="Eq",w[w.NotEq=4]="NotEq",w[w.Lt=5]="Lt",w[w.LtEq=6]="LtEq",w[w.Gt=7]="Gt",w[w.GtEq=8]="GtEq",w[w.RegexOp=9]="RegexOp",w[w.RegexStr=10]="RegexStr",w[w.True=11]="True",w[w.False=12]="False",w[w.In=13]="In",w[w.Not=14]="Not",w[w.And=15]="And",w[w.Or=16]="Or",w[w.Str=17]="Str",w[w.QuotedStr=18]="QuotedStr",w[w.Error=19]="Error",w[w.EOF=20]="EOF"})(r||(e.TokenType=r={}));function L(...w){switch(w.length){case 1:return(0,R.localize)(0,null,w[0]);case 2:return(0,R.localize)(1,null,w[0],w[1]);case 3:return(0,R.localize)(2,null,w[0],w[1],w[2]);default:return}}const I=(0,R.localize)(3,null),C=(0,R.localize)(4,null);class p{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(A){switch(A.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return A.isTripleEq?"===":"==";case 4:return A.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return A.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return A.lexeme;case 18:return A.lexeme;case 19:return A.lexeme;case 20:return"EOF";default:throw(0,y.$8)(`unhandled token type: ${JSON.stringify(A)}; have you forgotten to add a case?`)}}get errors(){return this.g}reset(A){return this.c=A,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const k=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:k})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const k=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:k})}else this.h(126)?this.k(9):this.l(L("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(L("&&"));break;case 124:this.h(124)?this.k(16):this.l(L("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(A){return this.r()||this.c.charCodeAt(this.e)!==A?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(A){this.f.push({type:A,offset:this.d})}l(A){const k=this.d,v=this.c.substring(this.d,this.e),u={type:19,offset:this.d,lexeme:v};this.g.push({offset:k,lexeme:v,additionalInfo:A}),this.f.push(u)}n(){this.m.lastIndex=this.d;const A=this.m.exec(this.c);if(A){this.e=this.d+A[0].length;const k=this.c.substring(this.d,this.e),v=p.b.get(k);v?this.k(v):this.f.push({type:17,lexeme:k,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(I);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let A=this.e,k=!1,v=!1;for(;;){if(A>=this.c.length){this.e=A,this.l(C);return}const b=this.c.charCodeAt(A);if(k)k=!1;else if(b===47&&!v){A++;break}else b===91?v=!0:b===92?k=!0:b===93&&(v=!1);A++}for(;A<this.c.length&&p.a.has(this.c.charCodeAt(A));)A++;this.e=A;const u=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:u,offset:this.d})}r(){return this.e>=this.c.length}}e.$Li=p,p.a=new Set(["i","g","s","m","y","u"].map(w=>w.charCodeAt(0))),p.b=new Map([["not",14],["in",13],["false",12],["true",11]])}),define(be[206],we([1,0,5,2]),function(ue,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sn=e.$Rn=void 0;class r{constructor(){this.a=new y.$Od,this.b=new y.$Od,this.c=new y.$Od,this.d=new y.$Od}call(C,p,w){switch(p){case"close":return Promise.resolve(this.a.fire({sessionId:w[0]}));case"reload":return Promise.resolve(this.b.fire({sessionId:w[0]}));case"terminate":return Promise.resolve(this.c.fire({sessionId:w[0]}));case"attach":return Promise.resolve(this.d.fire({sessionId:w[0],port:w[1],subId:w[2]}))}throw new Error("Method not implemented.")}listen(C,p,w){switch(p){case"close":return this.a.event;case"reload":return this.b.event;case"terminate":return this.c.event;case"attach":return this.d.event}throw new Error("Method not implemented.")}}e.$Rn=r,r.ChannelName="extensionhostdebugservice";class L extends R.$Sc{constructor(C){super(),this.b=C}reload(C){this.b.call("reload",[C])}get onReload(){return this.b.listen("reload")}close(C){this.b.call("close",[C])}get onClose(){return this.b.listen("close")}attachSession(C,p,w){this.b.call("attach",[C,p,w])}get onAttachSession(){return this.b.listen("attach")}terminateSession(C,p){this.b.call("terminate",[C,p])}get onTerminateSession(){return this.b.listen("terminate")}openExtensionDevelopmentHostWindow(C,p){return this.b.call("openExtensionDevelopmentHostWindow",[C,p])}}e.$Sn=L}),define(be[207],we([1,0,4]),function(ue,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vn=e.$Un=void 0;class R{constructor(I){this.a=I}listen(I,C,p){throw new Error("Invalid listen")}call(I,C,p){switch(C){case"download":return this.a.download(y.URI.revive(p[0]),y.URI.revive(p[1]))}throw new Error("Invalid call")}}e.$Un=R;class r{constructor(I,C){this.a=I,this.b=C}async download(I,C){const p=this.b();p&&(I=p.transformOutgoingURI(I),C=p.transformOutgoingURI(C)),await this.a.call("download",[I,C])}}e.$Vn=r}),define(be[208],we([1,0,165,73,12,7,28,19,4]),function(ue,e,y,R,r,L,I,C,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$km=e.$jm=e.$im=e.$hm=void 0,e.$hm=/^([^.]+\..+):(.+)$/;class w{get appRoot(){return(0,L.$mc)(r.$dg.asFileUri("").fsPath)}get userHome(){return p.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return p.URI.file((0,L.$jc)(this.userDataPath,"User"))}get tmpDir(){return p.URI.file(this.b.tmpDir)}get cacheHome(){return p.URI.file(this.userDataPath)}get stateResource(){return(0,C.$wg)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:r.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,C.$wg)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const u=(0,y.$gm)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,L.$jc)(this.userDataPath,"logs",u)}return p.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,C.$wg)(p.URI.file((0,L.$jc)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,C.$wg)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,C.$wg)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,C.$wg)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const u=I.env.VSCODE_PORTABLE;return u?p.URI.file((0,L.$jc)(u,"argv.json")):(0,C.$wg)(this.appSettingsHome,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return p.URI.file((0,L.$jc)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const u=this.args["builtin-extensions-dir"];return u?(0,L.$kc)(u):(0,L.$hc)((0,L.$jc)(r.$dg.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const u=this.args["extensions-download-dir"];return u?p.URI.file((0,L.$kc)(u)):p.URI.file((0,L.$jc)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const u=this.args["extensions-dir"];if(u)return(0,L.$kc)(u);const b=I.env.VSCODE_EXTENSIONS;if(b)return b;const m=I.env.VSCODE_PORTABLE;return m?(0,L.$jc)(m,"extensions"):(0,C.$wg)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const u=this.args.extensionDevelopmentPath;if(Array.isArray(u))return u.map(b=>/^[^:/?#]+?:\/\//.test(b)?p.URI.parse(b):p.URI.file((0,L.$hc)(b)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(u=>u==="ui"||u==="workspace"||u==="web"?u:"workspace")}get extensionTestsLocationURI(){const u=this.args.extensionTestsPath;if(u)return/^[^:/?#]+?:\/\//.test(u)?p.URI.parse(u):p.URI.file((0,L.$hc)(u))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const u=this.args["disable-extension"];if(u){if(typeof u=="string")return[u];if(Array.isArray(u)&&u.length>0)return u}return!1}get debugExtensionHost(){return A(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!I.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(u=>!e.$hm.test(u))}get extensionLogLevel(){const u=[];for(const b of this.args.log||[]){const m=e.$hm.exec(b);m&&m[1]&&m[2]&&u.push([m[1],m[2]])}return u.length?u:void 0}get serviceMachineIdResource(){return(0,C.$wg)(p.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const u=I.env.VSCODE_PORTABLE;return u?p.URI.file((0,L.$jc)(u,"policy.json")):(0,C.$wg)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(u){this.args.continueOn=u}get args(){return this.a}constructor(u,b,m){this.a=u,this.b=b,this.c=m,this.editSessionId=this.args.editSessionId}}e.$im=w,Re([R.$ih],w.prototype,"appRoot",null),Re([R.$ih],w.prototype,"userHome",null),Re([R.$ih],w.prototype,"userDataPath",null),Re([R.$ih],w.prototype,"appSettingsHome",null),Re([R.$ih],w.prototype,"tmpDir",null),Re([R.$ih],w.prototype,"cacheHome",null),Re([R.$ih],w.prototype,"stateResource",null),Re([R.$ih],w.prototype,"userRoamingDataHome",null),Re([R.$ih],w.prototype,"userDataSyncHome",null),Re([R.$ih],w.prototype,"sync",null),Re([R.$ih],w.prototype,"machineSettingsResource",null),Re([R.$ih],w.prototype,"workspaceStorageHome",null),Re([R.$ih],w.prototype,"localHistoryHome",null),Re([R.$ih],w.prototype,"keyboardLayoutResource",null),Re([R.$ih],w.prototype,"argvResource",null),Re([R.$ih],w.prototype,"isExtensionDevelopment",null),Re([R.$ih],w.prototype,"untitledWorkspacesHome",null),Re([R.$ih],w.prototype,"builtinExtensionsPath",null),Re([R.$ih],w.prototype,"extensionsPath",null),Re([R.$ih],w.prototype,"extensionDevelopmentLocationURI",null),Re([R.$ih],w.prototype,"extensionDevelopmentKind",null),Re([R.$ih],w.prototype,"extensionTestsLocationURI",null),Re([R.$ih],w.prototype,"debugExtensionHost",null),Re([R.$ih],w.prototype,"logLevel",null),Re([R.$ih],w.prototype,"extensionLogLevel",null),Re([R.$ih],w.prototype,"serviceMachineIdResource",null),Re([R.$ih],w.prototype,"disableTelemetry",null),Re([R.$ih],w.prototype,"disableWorkspaceTrust",null),Re([R.$ih],w.prototype,"useInMemorySecretStorage",null),Re([R.$ih],w.prototype,"policyFile",null);function A(v,u){return k(v["inspect-extensions"],v["inspect-brk-extensions"],5870,u,v.debugId,v.extensionEnvironment)}e.$jm=A;function k(v,u,b,m,d,h){const l=Number(u||v)||(m?null:b),$=l?!!u:!1;let c;if(h)try{c=JSON.parse(h)}catch{}return{port:l,break:$,debugId:d,env:c}}e.$km=k}),define(be[65],we([1,0,299,3,175]),function(ue,e,y,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ll=e.$Kl=e.$Jl=e.$Il=e.$Hl=e.$Gl=void 0;const L={o:(0,r.localize)(0,null),e:(0,r.localize)(1,null),t:(0,r.localize)(2,null)};e.$Gl=["tunnel","serve-web"],e.$Hl={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,r.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},"serve-web":{type:"subcommand",description:"Run a server that displays the editor UI in browsers.",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,r.localize)(4,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,r.localize)(5,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,r.localize)(6,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,r.localize)(7,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,r.localize)(8,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,r.localize)(9,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,r.localize)(10,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,r.localize)(11,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,r.localize)(12,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,r.localize)(13,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,r.localize)(14,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,r.localize)(15,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,r.localize)(16,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,r.localize)(17,null)},"show-versions":{type:"boolean",cat:"e",description:(0,r.localize)(18,null)},category:{type:"string",allowEmptyValue:!0,cat:"e",description:(0,r.localize)(19,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,r.localize)(20,null)},"pre-release":{type:"boolean",cat:"e",description:(0,r.localize)(21,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,r.localize)(22,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,r.localize)(23,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,r.localize)(24,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,r.localize)(25,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,r.localize)(26,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,r.localize)(27,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,r.localize)(28,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,r.localize)(29,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,r.localize)(30,null)},sync:{type:"string",cat:"t",description:(0,r.localize)(31,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,r.localize)(32,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,r.localize)(33,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,r.localize)(34,null)},"disable-chromium-sandbox":{type:"boolean",cat:"t",description:(0,r.localize)(35,null)},"ms-enable-electron-run-as-node":{type:"boolean",global:!0},telemetry:{type:"boolean",cat:"t",description:(0,r.localize)(36,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"inspect-sharedprocess":{type:"string",allowEmptyValue:!0},"inspect-brk-sharedprocess":{type:"string",allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"use-inmemory-secretstorage":{type:"boolean",deprecates:["disable-keytar"]},"password-store":{type:"string"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},"disable-gpu-sandbox":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const I={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function C(m,d,h=I){const g=m.find(a=>a.length>0&&a[0]!=="-"),l={},$=["_"],c=[],n={};let i;for(const a in d){const f=d[a];f.type==="subcommand"?a===g&&(i=f):(f.alias&&(l[a]=f.alias),f.type==="string"||f.type==="string[]"?($.push(a),f.deprecates&&$.push(...f.deprecates)):f.type==="boolean"&&(c.push(a),f.deprecates&&c.push(...f.deprecates)),f.global&&(n[a]=f))}if(i&&g){const a=n;for(const E in i.options)a[E]=i.options[E];const f=m.filter(E=>E!==g),S=h.getSubcommandReporter?h.getSubcommandReporter(g):void 0,D=C(f,a,S);return{[g]:D,_:[]}}const o=y(m,{string:$,boolean:c,alias:l}),s={},t=o;s._=o._.map(a=>String(a)).filter(a=>a.length>0),delete t._;for(const a in d){const f=d[a];if(f.type==="subcommand")continue;f.alias&&delete t[f.alias];let S=t[a];if(f.deprecates)for(const D of f.deprecates)t.hasOwnProperty(D)&&(S||(S=t[D],S&&h.onDeprecatedOption(D,f.deprecationMessage||(0,r.localize)(37,null,a))),delete t[D]);if(typeof S<"u"){if(f.type==="string[]"){if(Array.isArray(S)||(S=[S]),!f.allowEmptyValue){const D=S.filter(E=>E.length>0);D.length!==S.length&&(h.onEmptyValue(a),S=D.length>0?D:void 0)}}else f.type==="string"&&(Array.isArray(S)?(S=S.pop(),h.onMultipleValues(a,S)):!S&&!f.allowEmptyValue&&(h.onEmptyValue(a),S=void 0));s[a]=S,f.deprecationMessage&&h.onDeprecatedOption(a,f.deprecationMessage)}delete t[a]}for(const a in t)h.onUnknownOption(a);return s}e.$Il=C;function p(m,d){let h="";return d.args&&(Array.isArray(d.args)?h=` <${d.args.join("> <")}>`:h=` <${d.args}>`),d.alias?`-${d.alias} --${m}${h}`:`--${m}${h}`}function w(m,d){const h=[];for(const g in m){const l=m[g],$=p(g,l);h.push([$,l.description])}return A(h,d)}e.$Jl=w;function A(m,d){const g=m.reduce((c,n)=>Math.max(c,n[0].length),12)+2+1;if(d-g<25)return m.reduce((c,n)=>c.concat([`  ${n[0]}`,`      ${n[1]}`]),[]);const l=d-g-1,$=[];for(const c of m){const n=c[0],i=v(c[1],l),o=k(g-n.length-2);$.push("  "+n+o+i[0]);for(let s=1;s<i.length;s++)$.push(k(g)+i[s])}return $}function k(m){return" ".repeat(m)}function v(m,d){const h=[];for(;m.length;){const g=m.length<d?m.length:m.lastIndexOf(" ",d),l=m.slice(0,g).trim();m=m.slice(g),h.push(l)}return h}function u(m,d,h,g,l){const $=process.stdout.isTTY&&process.stdout.columns||80,c=l?.noInputFiles!==!0?`[${(0,r.localize)(38,null)}...]`:"",n=[`${m} ${h}`];n.push(""),n.push(`${(0,r.localize)(39,null)}: ${d} [${(0,r.localize)(40,null)}]${c}`),n.push(""),l?.noPipe!==!0&&(R.$d?n.push((0,r.localize)(41,null,d)):n.push((0,r.localize)(42,null,d)),n.push(""));const i={},o=[];for(const s in g){const t=g[s];if(t.type==="subcommand")t.description&&o.push({command:s,description:t.description});else if(t.description&&t.cat){let a=i[t.cat];a||(i[t.cat]=a={}),a[s]=t}}for(const s in i){const t=s,a=i[t];a&&(n.push(L[t]),n.push(...w(a,$)),n.push(""))}return o.length&&(n.push((0,r.localize)(43,null)),n.push(...A(o.map(s=>[s.command,s.description]),$)),n.push("")),n.join(`
`)}e.$Kl=u;function b(m,d){return`${m||(0,r.localize)(44,null)}
${d||(0,r.localize)(45,null)}
${process.arch}`}e.$Ll=b}),define(be[209],we([1,0,300,176,65]),function(ue,e,y,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pl=e.$Ol=e.$Nl=e.$Ml=void 0;function L(k,v){const u=(l,$)=>{console.warn((0,R.localize)(0,null,l,$))},b=l=>{console.warn((0,R.localize)(1,null,l))},m=(l,$)=>{console.warn((0,R.localize)(2,null,l,$))},d=l=>({onUnknownOption:$=>{r.$Gl.includes(l)||console.warn((0,R.localize)(3,null,$,l))},onMultipleValues:u,onEmptyValue:b,onDeprecatedOption:m,getSubcommandReporter:r.$Gl.includes(l)?d:void 0}),h={onUnknownOption:l=>{console.warn((0,R.localize)(4,null,l))},onMultipleValues:u,onEmptyValue:b,onDeprecatedOption:m,getSubcommandReporter:d},g=(0,r.$Il)(k,r.$Hl,v?h:void 0);return g.goto&&g._.forEach(l=>y(/^(\w:)?[^:]+(:\d*){0,2}:?$/.test(l),(0,R.localize)(5,null))),g}function I(k){const v=k.findIndex(u=>!/^-/.test(u));if(v>-1)return[...k.slice(0,v),...k.slice(v+1)]}function C(k){let[,...v]=k;process.env.VSCODE_DEV&&(v=I(v)||[]);const u=!A(process.env);return L(v,u)}e.$Ml=C;function p(k){let[,,...v]=k;return process.env.VSCODE_DEV&&(v=I(v)||[]),L(v,!0)}e.$Nl=p;function w(k,...v){const u=k.indexOf("--");return u===-1?k.push(...v):k.splice(u,0,...v),k}e.$Ol=w;function A(k){return k.VSCODE_CLI==="1"}e.$Pl=A}),function(){"use strict";function ue(e,y,R){function r(I,C){const p=L(I,C),w=[p];return e.isAbsolute(p)||w.unshift(R),e.resolve(...w)}function L(I,C){process.env.VSCODE_DEV&&(C="code-oss-dev");const p=process.env.VSCODE_PORTABLE;if(p)return e.join(p,"user-data");let w=process.env.VSCODE_APPDATA;if(w)return e.join(w,C);const A=I["user-data-dir"];if(A)return A;switch(process.platform){case"win32":if(w=process.env.APPDATA,!w){const k=process.env.USERPROFILE;if(typeof k!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");w=e.join(k,"AppData","Roaming")}break;case"darwin":w=e.join(y.homedir(),"Library","Application Support");break;case"linux":w=process.env.XDG_CONFIG_HOME||e.join(y.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(w,C)}return{getUserDataPath:r}}if(typeof define=="function")define(be[210],we([78,27,28]),function(e,y,R){return ue(e,y,R.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),y=require("os");module.exports=ue(e,y,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(be[109],we([1,0,27,208,210]),function(ue,e,y,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nm=e.$mm=e.$lm=void 0;class L extends R.$im{constructor(w,A){super(w,{homeDir:(0,y.homedir)(),tmpDir:(0,y.tmpdir)(),userDataDir:(0,r.getUserDataPath)(w,A.nameShort)},A)}}e.$lm=L;function I(p,w){return(0,R.$km)(p["inspect-ptyhost"],p["inspect-brk-ptyhost"],5877,w,p.extensionEnvironment)}e.$mm=I;function C(p,w){return(0,R.$km)(p["inspect-sharedprocess"],p["inspect-brk-sharedprocess"],5879,w,p.extensionEnvironment)}e.$nm=C}),define(be[211],we([1,0,8,180]),function(ue,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cp=void 0;function r(I,C,p,w){try{L(I,C,p,w)}catch(A){I.error(A?.message??A)}return C}e.$Cp=r;function L(I,C,p,w){const A=(k,v,u)=>{const b=k[v];if((0,y.$zf)(b)){const m=b,d=m.length;if(d>1&&m[0]==="%"&&m[d-1]==="%"){const h=m.substr(1,d-2);let g=p[h];g===void 0&&w&&(g=w[h]);const l=typeof g=="string"?g:g?.message,$=w?.[h],c=typeof $=="string"?$:$?.message;if(!l){c||I.warn(`[${C.name}]: ${(0,R.localize)(0,null,h)}`);return}if(u&&(v==="title"||v==="category")&&c&&c!==l){const n={value:l,original:c};k[v]=n}else k[v]=l}}else if((0,y.$Bf)(b))for(const m in b)b.hasOwnProperty(m)&&(m==="commands"?A(b,m,!0):A(b,m,u));else if(Array.isArray(b))for(let m=0;m<b.length;m++)A(b,m,u)};for(const k in C)C.hasOwnProperty(k)&&A(C,k)}}),define(be[80],we([1,0,19,63,184,53]),function(ue,e,y,R,r,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wo=e.$Vo=e.$Uo=e.$To=e.$So=e.$Ro=e.$Qo=void 0;const I=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,C=/^-(\d{4})(\d{2})(\d{2})$/;function p(h){return h=h.trim(),h==="*"||I.test(h)}e.$Qo=p;function w(h){if(!p(h))return null;if(h=h.trim(),h==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const g=h.match(I);return g?{hasCaret:g[1]==="^",hasGreaterEquals:g[1]===">=",majorBase:g[2]==="x"?0:parseInt(g[2],10),majorMustEqual:g[2]!=="x",minorBase:g[4]==="x"?0:parseInt(g[4],10),minorMustEqual:g[4]!=="x",patchBase:g[6]==="x"?0:parseInt(g[6],10),patchMustEqual:g[6]!=="x",preRelease:g[8]||null}:null}e.$Ro=w;function A(h){if(!h)return null;const g=h.majorBase,l=h.majorMustEqual,$=h.minorBase;let c=h.minorMustEqual;const n=h.patchBase;let i=h.patchMustEqual;h.hasCaret&&(g===0||(c=!1),i=!1);let o=0;if(h.preRelease){const s=C.exec(h.preRelease);if(s){const[,t,a,f]=s;o=Date.UTC(Number(t),Number(a)-1,Number(f))}}return{majorBase:g,majorMustEqual:l,minorBase:$,minorMustEqual:c,patchBase:n,patchMustEqual:i,isMinimum:h.hasGreaterEquals,notBefore:o}}e.$So=A;function k(h,g,l){let $;typeof h=="string"?$=A(w(h)):$=h;let c;g instanceof Date?c=g.getTime():typeof g=="string"&&(c=new Date(g).getTime());let n;if(typeof l=="string"?n=A(w(l)):n=l,!$||!n)return!1;const i=$.majorBase,o=$.minorBase,s=$.patchBase;let t=n.majorBase,a=n.minorBase,f=n.patchBase;const S=n.notBefore;let D=n.majorMustEqual,E=n.minorMustEqual,P=n.patchMustEqual;return n.isMinimum?i>t?!0:i<t?!1:o>a?!0:o<a||c&&c<S?!1:s>=f:(i===1&&t===0&&(!D||!E||!P)&&(t=1,a=0,f=0,D=!0,E=!1,P=!1),i<t?!1:i>t?!D:o<a?!1:o>a?!E:s<f?!1:s>f?!P:!(c&&c<S))}e.$To=k;function v(h,g,l,$,c){const n=[];if(typeof $.publisher<"u"&&typeof $.publisher!="string")return n.push([R.default.Error,r.localize(0,null)]),n;if(typeof $.name!="string")return n.push([R.default.Error,r.localize(1,null,"name")]),n;if(typeof $.version!="string")return n.push([R.default.Error,r.localize(2,null,"version")]),n;if(!$.engines)return n.push([R.default.Error,r.localize(3,null,"engines")]),n;if(typeof $.engines.vscode!="string")return n.push([R.default.Error,r.localize(4,null,"engines.vscode")]),n;if(typeof $.extensionDependencies<"u"&&!d($.extensionDependencies))return n.push([R.default.Error,r.localize(5,null,"extensionDependencies")]),n;if(typeof $.activationEvents<"u"){if(!d($.activationEvents))return n.push([R.default.Error,r.localize(6,null,"activationEvents")]),n;if(typeof $.main>"u"&&typeof $.browser>"u")return n.push([R.default.Error,r.localize(7,null,"activationEvents","main","browser")]),n}if(typeof $.extensionKind<"u"&&typeof $.main>"u"&&n.push([R.default.Warning,r.localize(8,null,"extensionKind")]),typeof $.main<"u"){if(typeof $.main!="string")return n.push([R.default.Error,r.localize(9,null,"main")]),n;{const s=(0,y.$wg)(l,$.main);(0,y.$qg)(s,l)||n.push([R.default.Warning,r.localize(10,null,s.path,l.path)])}}if(typeof $.browser<"u"){if(typeof $.browser!="string")return n.push([R.default.Error,r.localize(11,null,"browser")]),n;{const s=(0,y.$wg)(l,$.browser);(0,y.$qg)(s,l)||n.push([R.default.Warning,r.localize(12,null,s.path,l.path)])}}if(!L.valid($.version))return n.push([R.default.Error,r.localize(13,null)]),n;const i=[];if(!u(h,g,$,c,i))for(const s of i)n.push([R.default.Error,s]);return n}e.$Uo=v;function u(h,g,l,$,c){return $||typeof l.main>"u"&&typeof l.browser>"u"?!0:m(h,g,l.engines.vscode,c)}e.$Vo=u;function b(h,g,l){return h==="*"||m(g,l,h)}e.$Wo=b;function m(h,g,l,$=[]){const c=A(w(l));if(!c)return $.push(r.localize(14,null,l)),!1;if(c.majorBase===0){if(!c.majorMustEqual||!c.minorMustEqual)return $.push(r.localize(15,null,l)),!1}else if(!c.majorMustEqual)return $.push(r.localize(16,null,l)),!1;return k(h,g,c)?!0:($.push(r.localize(17,null,h,l)),!1)}function d(h){if(!Array.isArray(h))return!1;for(let g=0,l=h.length;g<l;g++)if(typeof h[g]!="string")return!1;return!0}}),define(be[212],we([1,0,15,23]),function(ue,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ep=void 0;async function r(L,I,C){let p=C&&C.get("storage.serviceMachineId",-1)||null;if(p)return p;try{const A=(await I.readFile(L.serviceMachineIdResource)).value.toString();p=(0,R.$eg)(A)?A:null}catch{p=null}if(!p){p=(0,R.$fg)();try{await I.writeFile(L.serviceMachineIdResource,y.$ce.fromString(p))}catch{}}return C?.store("storage.serviceMachineId",p,-1,1),p}e.$ep=r}),define(be[66],we([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nh=void 0;class y{constructor(r,L=[],I=!1){this.ctor=r,this.staticArguments=L,this.supportsDelayedInstantiation=I}}e.$Nh=y}),define(be[213],we([1,0,66]),function(ue,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cr=e.$Br=e.InstantiationType=void 0;const R=[];var r;(function(C){C[C.Eager=0]="Eager",C[C.Delayed=1]="Delayed"})(r||(e.InstantiationType=r={}));function L(C,p,w){p instanceof y.$Nh||(p=new y.$Nh(p,[],!!w)),R.push([C,p])}e.$Br=L;function I(){return R}e.$Cr=I}),define(be[214],we([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hq=e.$gq=void 0;class y{constructor(L,I){this.key=L,this.data=I,this.incoming=new Map,this.outgoing=new Map}}e.$gq=y;class R{constructor(L){this.b=L,this.a=new Map}roots(){const L=[];for(const I of this.a.values())I.outgoing.size===0&&L.push(I);return L}insertEdge(L,I){const C=this.lookupOrInsertNode(L),p=this.lookupOrInsertNode(I);C.outgoing.set(p.key,p),p.incoming.set(C.key,C)}removeNode(L){const I=this.b(L);this.a.delete(I);for(const C of this.a.values())C.outgoing.delete(I),C.incoming.delete(I)}lookupOrInsertNode(L){const I=this.b(L);let C=this.a.get(I);return C||(C=new y(I,L),this.a.set(I,C)),C}lookup(L){return this.a.get(this.b(L))}isEmpty(){return this.a.size===0}toString(){const L=[];for(const[I,C]of this.a)L.push(`${I}
	(-> incoming)[${[...C.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...C.outgoing.keys()].join(",")}]
`);return L.join(`
`)}findCycleSlow(){for(const[L,I]of this.a){const C=new Set([L]),p=this.c(I,C);if(p)return p}}c(L,I){for(const[C,p]of L.outgoing){if(I.has(C))return[...I,C].join(" -> ");I.add(C);const w=this.c(p,I);if(w)return w;I.delete(C)}}}e.$hq=R}),define(be[6],we([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rh=e.$Qh=e.$Ph=e._util=void 0;var y;(function(I){I.serviceIds=new Map,I.DI_TARGET="$di$target",I.DI_DEPENDENCIES="$di$dependencies";function C(p){return p[I.DI_DEPENDENCIES]||[]}I.getServiceDependencies=C})(y||(e._util=y={})),e.$Ph=r("instantiationService");function R(I,C,p){C[y.DI_TARGET]===C?C[y.DI_DEPENDENCIES].push({id:I,index:p}):(C[y.DI_DEPENDENCIES]=[{id:I,index:p}],C[y.DI_TARGET]=C)}function r(I){if(y.serviceIds.has(I))return y.serviceIds.get(I);const C=function(p,w,A){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");R(C,p,A)};return C.toString=()=>I,y.serviceIds.set(I,C),C}e.$Qh=r;function L(I){return I}e.$Rh=L}),define(be[24],we([1,0,8,4,6]),function(ue,e,y,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ui=e.$ti=e.$si=e.$ri=e.$qi=e.$pi=e.$oi=e.$ni=e.ConfigurationTarget=e.$mi=e.$li=e.$ki=void 0,e.$ki=(0,r.$Qh)("configurationService");function L(h){return h&&typeof h=="object"&&(!h.overrideIdentifier||typeof h.overrideIdentifier=="string")&&(!h.resource||h.resource instanceof R.URI)}e.$li=L;function I(h){return h&&typeof h=="object"&&(!h.overrideIdentifiers||Array.isArray(h.overrideIdentifiers))&&!h.overrideIdentifier&&(!h.resource||h.resource instanceof R.URI)}e.$mi=I;var C;(function(h){h[h.APPLICATION=1]="APPLICATION",h[h.USER=2]="USER",h[h.USER_LOCAL=3]="USER_LOCAL",h[h.USER_REMOTE=4]="USER_REMOTE",h[h.WORKSPACE=5]="WORKSPACE",h[h.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",h[h.DEFAULT=7]="DEFAULT",h[h.MEMORY=8]="MEMORY"})(C||(e.ConfigurationTarget=C={}));function p(h){switch(h){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$ni=p;function w(h){return h.applicationValue!==void 0||h.userValue!==void 0||h.userLocalValue!==void 0||h.userRemoteValue!==void 0||h.workspaceValue!==void 0||h.workspaceFolderValue!==void 0}e.$oi=w;function A(h,g){const l=Object.create(null);for(const $ in h)k(l,$,h[$],g);return l}e.$pi=A;function k(h,g,l,$){const c=g.split("."),n=c.pop();let i=h;for(let o=0;o<c.length;o++){const s=c[o];let t=i[s];switch(typeof t){case"undefined":t=i[s]=Object.create(null);break;case"object":break;default:$(`Ignoring ${g} as ${c.slice(0,o+1).join(".")} is ${JSON.stringify(t)}`);return}i=t}if(typeof i=="object"&&i!==null)try{i[n]=l}catch{$(`Ignoring ${g} as ${c.join(".")} is ${JSON.stringify(i)}`)}else $(`Ignoring ${g} as ${c.join(".")} is ${JSON.stringify(i)}`)}e.$qi=k;function v(h,g){const l=g.split(".");u(h,l)}e.$ri=v;function u(h,g){const l=g.shift();if(g.length===0){delete h[l];return}if(Object.keys(h).indexOf(l)!==-1){const $=h[l];typeof $=="object"&&!Array.isArray($)&&(u($,g),Object.keys($).length===0&&delete h[l])}}function b(h,g,l){function $(i,o){let s=i;for(const t of o){if(typeof s!="object"||s===null)return;s=s[t]}return s}const c=g.split("."),n=$(h,c);return typeof n>"u"?l:n}e.$si=b;function m(h,g,l){Object.keys(g).forEach($=>{$!=="__proto__"&&($ in h?y.$Bf(h[$])&&y.$Bf(g[$])?m(h[$],g[$],l):l&&(h[$]=g[$]):h[$]=g[$])})}e.$ti=m;function d(h){return h.replace(/[\[\]]/g,"")}e.$ui=d}),define(be[67],we([1,0,3,17,205,6,173,11]),function(ue,e,y,R,r,L,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0i=e.$9i=e.$8i=e.$7i=e.$6i=e.$5i=e.$4i=e.$3i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Vi=e.$Ui=e.$Ti=e.$Si=e.$Ri=e.$Qi=e.$Pi=e.$Oi=e.$Ni=e.ContextKeyExprType=e.$Mi=void 0;const p=new Map;p.set("false",!1),p.set("true",!0),p.set("isMac",y.$e),p.set("isLinux",y.$f),p.set("isWindows",y.$d),p.set("isWeb",y.$j),p.set("isMacNative",y.$e&&!y.$j),p.set("isEdge",y.$B),p.set("isFirefox",y.$z),p.set("isChrome",y.$y),p.set("isSafari",y.$A);function w(Q,O){if(p.get(Q)!==void 0)throw(0,C.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");p.set(Q,O)}e.$Mi=w;const A=Object.prototype.hasOwnProperty;var k;(function(Q){Q[Q.False=0]="False",Q[Q.True=1]="True",Q[Q.Defined=2]="Defined",Q[Q.Not=3]="Not",Q[Q.Equals=4]="Equals",Q[Q.NotEquals=5]="NotEquals",Q[Q.And=6]="And",Q[Q.Regex=7]="Regex",Q[Q.NotRegex=8]="NotRegex",Q[Q.Or=9]="Or",Q[Q.In=10]="In",Q[Q.NotIn=11]="NotIn",Q[Q.Greater=12]="Greater",Q[Q.GreaterEquals=13]="GreaterEquals",Q[Q.Smaller=14]="Smaller",Q[Q.SmallerEquals=15]="SmallerEquals"})(k||(e.ContextKeyExprType=k={}));const v={regexParsingWithErrorRecovery:!0},u=(0,I.localize)(0,null),b=(0,I.localize)(1,null),m=(0,I.localize)(2,null),d=(0,I.localize)(3,null),h=(0,I.localize)(4,null),g=(0,I.localize)(5,null),l=(0,I.localize)(6,null),$=(0,I.localize)(7,null);class c{get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(O=v){this.k=O,this.d=new r.$Li,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(O){if(O===""){this.h.push({message:u,offset:0,lexeme:"",additionalInfo:b});return}this.f=this.d.reset(O).scan(),this.g=0,this.h=[];try{const N=this.l();if(!this.E()){const U=this.D(),T=U.type===17?g:void 0;throw this.h.push({message:h,offset:U.offset,lexeme:r.$Li.getLexeme(U),additionalInfo:T}),c.c}return N}catch(N){if(N!==c.c)throw N;return}}l(){return this.m()}m(){const O=[this.o()];for(;this.y(16);){const N=this.o();O.push(N)}return O.length===1?O[0]:n.or(...O)}o(){const O=[this.s()];for(;this.y(15);){const N=this.s();O.push(N)}return O.length===1?O[0]:n.and(...O)}s(){if(this.y(2)){const O=this.D();switch(O.type){case 11:return this.z(),t.INSTANCE;case 12:return this.z(),a.INSTANCE;case 0:{this.z();const N=this.l();return this.A(1,d),N?.negate()}case 17:return this.z(),M.create(O.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",O)}}return this.t()}t(){const O=this.D();switch(O.type){case 11:return this.z(),n.true();case 12:return this.z(),n.false();case 0:{this.z();const N=this.l();return this.A(1,d),N}case 17:{const N=O.lexeme;if(this.z(),this.y(9)){const T=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),T.type!==10)throw this.B("REGEX",T);const z=T.lexeme,B=z.lastIndexOf("/"),te=B===z.length-1?void 0:this.w(z.substring(B+1));let H;try{H=new RegExp(z.substring(1,B),te)}catch{throw this.B("REGEX",T)}return Z.create(N,H)}switch(T.type){case 10:case 19:{const z=[T.lexeme];this.z();let B=this.D(),te=0;for(let ae=0;ae<T.lexeme.length;ae++)T.lexeme.charCodeAt(ae)===40?te++:T.lexeme.charCodeAt(ae)===41&&te--;for(;!this.E()&&B.type!==15&&B.type!==16;){switch(B.type){case 0:te++;break;case 1:te--;break;case 10:case 18:for(let ae=0;ae<B.lexeme.length;ae++)B.lexeme.charCodeAt(ae)===40?te++:T.lexeme.charCodeAt(ae)===41&&te--}if(te<0)break;z.push(r.$Li.getLexeme(B)),this.z(),B=this.D()}const H=z.join(""),x=H.lastIndexOf("/"),W=x===H.length-1?void 0:this.w(H.substring(x+1));let X;try{X=new RegExp(H.substring(1,x),W)}catch{throw this.B("REGEX",T)}return n.regex(N,X)}case 18:{const z=T.lexeme;this.z();let B=null;if(!(0,R.$Ce)(z)){const te=z.indexOf("/"),H=z.lastIndexOf("/");if(te!==H&&te>=0){const x=z.slice(te+1,H),W=z[H+1]==="i"?"i":"";try{B=new RegExp(x,W)}catch{throw this.B("REGEX",T)}}}if(B===null)throw this.B("REGEX",T);return Z.create(N,B)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,m);const T=this.u();return n.notIn(N,T)}switch(this.D().type){case 3:{this.z();const T=this.u();if(this.x().type===18)return n.equals(N,T);switch(T){case"true":return n.has(N);case"false":return n.not(N);default:return n.equals(N,T)}}case 4:{this.z();const T=this.u();if(this.x().type===18)return n.notEquals(N,T);switch(T){case"true":return n.not(N);case"false":return n.has(N);default:return n.notEquals(N,T)}}case 5:return this.z(),ne.create(N,this.u());case 6:return this.z(),he.create(N,this.u());case 7:return this.z(),se.create(N,this.u());case 8:return this.z(),G.create(N,this.u());case 13:return this.z(),n.in(N,this.u());default:return n.has(N)}}case 20:throw this.h.push({message:l,offset:O.offset,lexeme:"",additionalInfo:$}),c.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const O=this.D();switch(O.type){case 17:case 18:return this.z(),O.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(O){return O.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(O){return this.C(O)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(O,N){if(this.C(O))return this.z();throw this.B(N,this.D())}B(O,N,U){const T=(0,I.localize)(8,null,O,r.$Li.getLexeme(N)),z=N.offset,B=r.$Li.getLexeme(N);return this.h.push({message:T,offset:z,lexeme:B,additionalInfo:U}),c.c}C(O){return this.D().type===O}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$Ni=c,c.c=new Error;class n{static false(){return t.INSTANCE}static true(){return a.INSTANCE}static has(O){return f.create(O)}static equals(O,N){return S.create(O,N)}static notEquals(O,N){return P.create(O,N)}static regex(O,N){return Z.create(O,N)}static in(O,N){return D.create(O,N)}static notIn(O,N){return E.create(O,N)}static not(O){return M.create(O)}static and(...O){return ie.create(O,null,!0)}static or(...O){return Y.create(O,null,!0)}static greater(O,N){return se.create(O,N)}static greaterEquals(O,N){return G.create(O,N)}static smaller(O,N){return ne.create(O,N)}static smallerEquals(O,N){return he.create(O,N)}static deserialize(O){return O==null?void 0:this.c.parse(O)}}e.$Oi=n,n.c=new c({regexParsingWithErrorRecovery:!1});function i(Q){const O=new c({regexParsingWithErrorRecovery:!1});return Q.map(N=>(O.parse(N),O.lexingErrors.length>0?O.lexingErrors.map(U=>({errorMessage:U.additionalInfo?(0,I.localize)(9,null,U.additionalInfo):(0,I.localize)(10,null),offset:U.offset,length:U.lexeme.length})):O.parsingErrors.length>0?O.parsingErrors.map(U=>({errorMessage:U.additionalInfo?`${U.message}. ${U.additionalInfo}`:U.message,offset:U.offset,length:U.lexeme.length})):[]))}e.$Pi=i;function o(Q,O){const N=Q?Q.substituteConstants():void 0,U=O?O.substituteConstants():void 0;return!N&&!U?!0:!N||!U?!1:N.equals(U)}e.$Qi=o;function s(Q,O){return Q.cmp(O)}class t{constructor(){this.type=0}cmp(O){return this.type-O.type}equals(O){return O.type===this.type}substituteConstants(){return this}evaluate(O){return!1}serialize(){return"false"}keys(){return[]}map(O){return this}negate(){return a.INSTANCE}}e.$Ri=t,t.INSTANCE=new t;class a{constructor(){this.type=1}cmp(O){return this.type-O.type}equals(O){return O.type===this.type}substituteConstants(){return this}evaluate(O){return!0}serialize(){return"true"}keys(){return[]}map(O){return this}negate(){return t.INSTANCE}}e.$Si=a,a.INSTANCE=new a;class f{static create(O,N=null){const U=p.get(O);return typeof U=="boolean"?U?a.INSTANCE:t.INSTANCE:new f(O,N)}constructor(O,N){this.key=O,this.c=N,this.type=2}cmp(O){return O.type!==this.type?this.type-O.type:re(this.key,O.key)}equals(O){return O.type===this.type?this.key===O.key:!1}substituteConstants(){const O=p.get(this.key);return typeof O=="boolean"?O?a.INSTANCE:t.INSTANCE:this}evaluate(O){return!!O.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(O){return O.mapDefined(this.key)}negate(){return this.c||(this.c=M.create(this.key,this)),this.c}}e.$Ti=f;class S{static create(O,N,U=null){if(typeof N=="boolean")return N?f.create(O,U):M.create(O,U);const T=p.get(O);return typeof T=="boolean"?N===(T?"true":"false")?a.INSTANCE:t.INSTANCE:new S(O,N,U)}constructor(O,N,U){this.c=O,this.d=N,this.f=U,this.type=4}cmp(O){return O.type!==this.type?this.type-O.type:ce(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){const O=p.get(this.c);if(typeof O=="boolean"){const N=O?"true":"false";return this.d===N?a.INSTANCE:t.INSTANCE}return this}evaluate(O){return O.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(O){return O.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=P.create(this.c,this.d,this)),this.f}}e.$Ui=S;class D{static create(O,N){return new D(O,N)}constructor(O,N){this.d=O,this.f=N,this.type=10,this.c=null}cmp(O){return O.type!==this.type?this.type-O.type:ce(this.d,this.f,O.d,O.f)}equals(O){return O.type===this.type?this.d===O.d&&this.f===O.f:!1}substituteConstants(){return this}evaluate(O){const N=O.getValue(this.f),U=O.getValue(this.d);return Array.isArray(N)?N.includes(U):typeof U=="string"&&typeof N=="object"&&N!==null?A.call(N,U):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(O){return O.mapIn(this.d,this.f)}negate(){return this.c||(this.c=E.create(this.d,this.f)),this.c}}e.$Vi=D;class E{static create(O,N){return new E(O,N)}constructor(O,N){this.d=O,this.f=N,this.type=11,this.c=D.create(O,N)}cmp(O){return O.type!==this.type?this.type-O.type:this.c.cmp(O.c)}equals(O){return O.type===this.type?this.c.equals(O.c):!1}substituteConstants(){return this}evaluate(O){return!this.c.evaluate(O)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(O){return O.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Wi=E;class P{static create(O,N,U=null){if(typeof N=="boolean")return N?M.create(O,U):f.create(O,U);const T=p.get(O);return typeof T=="boolean"?N===(T?"true":"false")?t.INSTANCE:a.INSTANCE:new P(O,N,U)}constructor(O,N,U){this.c=O,this.d=N,this.f=U,this.type=5}cmp(O){return O.type!==this.type?this.type-O.type:ce(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){const O=p.get(this.c);if(typeof O=="boolean"){const N=O?"true":"false";return this.d===N?t.INSTANCE:a.INSTANCE}return this}evaluate(O){return O.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(O){return O.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=S.create(this.c,this.d,this)),this.f}}e.$Xi=P;class M{static create(O,N=null){const U=p.get(O);return typeof U=="boolean"?U?t.INSTANCE:a.INSTANCE:new M(O,N)}constructor(O,N){this.c=O,this.d=N,this.type=3}cmp(O){return O.type!==this.type?this.type-O.type:re(this.c,O.c)}equals(O){return O.type===this.type?this.c===O.c:!1}substituteConstants(){const O=p.get(this.c);return typeof O=="boolean"?O?t.INSTANCE:a.INSTANCE:this}evaluate(O){return!O.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(O){return O.mapNot(this.c)}negate(){return this.d||(this.d=f.create(this.c,this)),this.d}}e.$Yi=M;function ee(Q,O){if(typeof Q=="string"){const N=parseFloat(Q);isNaN(N)||(Q=N)}return typeof Q=="string"||typeof Q=="number"?O(Q):t.INSTANCE}class se{static create(O,N,U=null){return ee(N,T=>new se(O,T,U))}constructor(O,N,U){this.c=O,this.d=N,this.f=U,this.type=12}cmp(O){return O.type!==this.type?this.type-O.type:ce(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){return this}evaluate(O){return typeof this.d=="string"?!1:parseFloat(O.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(O){return O.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=he.create(this.c,this.d,this)),this.f}}e.$Zi=se;class G{static create(O,N,U=null){return ee(N,T=>new G(O,T,U))}constructor(O,N,U){this.c=O,this.d=N,this.f=U,this.type=13}cmp(O){return O.type!==this.type?this.type-O.type:ce(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){return this}evaluate(O){return typeof this.d=="string"?!1:parseFloat(O.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(O){return O.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=ne.create(this.c,this.d,this)),this.f}}e.$1i=G;class ne{static create(O,N,U=null){return ee(N,T=>new ne(O,T,U))}constructor(O,N,U){this.c=O,this.d=N,this.f=U,this.type=14}cmp(O){return O.type!==this.type?this.type-O.type:ce(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){return this}evaluate(O){return typeof this.d=="string"?!1:parseFloat(O.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(O){return O.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=G.create(this.c,this.d,this)),this.f}}e.$2i=ne;class he{static create(O,N,U=null){return ee(N,T=>new he(O,T,U))}constructor(O,N,U){this.c=O,this.d=N,this.f=U,this.type=15}cmp(O){return O.type!==this.type?this.type-O.type:ce(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){return this}evaluate(O){return typeof this.d=="string"?!1:parseFloat(O.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(O){return O.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=se.create(this.c,this.d,this)),this.f}}e.$3i=he;class Z{static create(O,N){return new Z(O,N)}constructor(O,N){this.d=O,this.f=N,this.type=7,this.c=null}cmp(O){if(O.type!==this.type)return this.type-O.type;if(this.d<O.d)return-1;if(this.d>O.d)return 1;const N=this.f?this.f.source:"",U=O.f?O.f.source:"";return N<U?-1:N>U?1:0}equals(O){if(O.type===this.type){const N=this.f?this.f.source:"",U=O.f?O.f.source:"";return this.d===O.d&&N===U}return!1}substituteConstants(){return this}evaluate(O){const N=O.getValue(this.d);return this.f?this.f.test(N):!1}serialize(){const O=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${O}`}keys(){return[this.d]}map(O){return O.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=fe.create(this)),this.c}}e.$4i=Z;class fe{static create(O){return new fe(O)}constructor(O){this.c=O,this.type=8}cmp(O){return O.type!==this.type?this.type-O.type:this.c.cmp(O.c)}equals(O){return O.type===this.type?this.c.equals(O.c):!1}substituteConstants(){return this}evaluate(O){return!this.c.evaluate(O)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(O){return new fe(this.c.map(O))}negate(){return this.c}}e.$5i=fe;function V(Q){let O=null;for(let N=0,U=Q.length;N<U;N++){const T=Q[N].substituteConstants();if(Q[N]!==T&&O===null){O=[];for(let z=0;z<N;z++)O[z]=Q[z]}O!==null&&(O[N]=T)}return O===null?Q:O}class ie{static create(O,N,U){return ie.d(O,N,U)}constructor(O,N){this.expr=O,this.c=N,this.type=6}cmp(O){if(O.type!==this.type)return this.type-O.type;if(this.expr.length<O.expr.length)return-1;if(this.expr.length>O.expr.length)return 1;for(let N=0,U=this.expr.length;N<U;N++){const T=s(this.expr[N],O.expr[N]);if(T!==0)return T}return 0}equals(O){if(O.type===this.type){if(this.expr.length!==O.expr.length)return!1;for(let N=0,U=this.expr.length;N<U;N++)if(!this.expr[N].equals(O.expr[N]))return!1;return!0}return!1}substituteConstants(){const O=V(this.expr);return O===this.expr?this:ie.create(O,this.c,!1)}evaluate(O){for(let N=0,U=this.expr.length;N<U;N++)if(!this.expr[N].evaluate(O))return!1;return!0}static d(O,N,U){const T=[];let z=!1;for(const B of O)if(B){if(B.type===1){z=!0;continue}if(B.type===0)return t.INSTANCE;if(B.type===6){T.push(...B.expr);continue}T.push(B)}if(T.length===0&&z)return a.INSTANCE;if(T.length!==0){if(T.length===1)return T[0];T.sort(s);for(let B=1;B<T.length;B++)T[B-1].equals(T[B])&&(T.splice(B,1),B--);if(T.length===1)return T[0];for(;T.length>1;){const B=T[T.length-1];if(B.type!==9)break;T.pop();const te=T.pop(),H=T.length===0,x=Y.create(B.expr.map(W=>ie.create([W,te],null,U)),null,H);x&&(T.push(x),T.sort(s))}if(T.length===1)return T[0];if(U){for(let B=0;B<T.length;B++)for(let te=B+1;te<T.length;te++)if(T[B].negate().equals(T[te]))return t.INSTANCE;if(T.length===1)return T[0]}return new ie(T,N)}}serialize(){return this.expr.map(O=>O.serialize()).join(" && ")}keys(){const O=[];for(const N of this.expr)O.push(...N.keys());return O}map(O){return new ie(this.expr.map(N=>N.map(O)),null)}negate(){if(!this.c){const O=[];for(const N of this.expr)O.push(N.negate());this.c=Y.create(O,this,!0)}return this.c}}e.$6i=ie;class Y{static create(O,N,U){return Y.d(O,N,U)}constructor(O,N){this.expr=O,this.c=N,this.type=9}cmp(O){if(O.type!==this.type)return this.type-O.type;if(this.expr.length<O.expr.length)return-1;if(this.expr.length>O.expr.length)return 1;for(let N=0,U=this.expr.length;N<U;N++){const T=s(this.expr[N],O.expr[N]);if(T!==0)return T}return 0}equals(O){if(O.type===this.type){if(this.expr.length!==O.expr.length)return!1;for(let N=0,U=this.expr.length;N<U;N++)if(!this.expr[N].equals(O.expr[N]))return!1;return!0}return!1}substituteConstants(){const O=V(this.expr);return O===this.expr?this:Y.create(O,this.c,!1)}evaluate(O){for(let N=0,U=this.expr.length;N<U;N++)if(this.expr[N].evaluate(O))return!0;return!1}static d(O,N,U){let T=[],z=!1;if(O){for(let B=0,te=O.length;B<te;B++){const H=O[B];if(H){if(H.type===0){z=!0;continue}if(H.type===1)return a.INSTANCE;if(H.type===9){T=T.concat(H.expr);continue}T.push(H)}}if(T.length===0&&z)return t.INSTANCE;T.sort(s)}if(T.length!==0){if(T.length===1)return T[0];for(let B=1;B<T.length;B++)T[B-1].equals(T[B])&&(T.splice(B,1),B--);if(T.length===1)return T[0];if(U){for(let B=0;B<T.length;B++)for(let te=B+1;te<T.length;te++)if(T[B].negate().equals(T[te]))return a.INSTANCE;if(T.length===1)return T[0]}return new Y(T,N)}}serialize(){return this.expr.map(O=>O.serialize()).join(" || ")}keys(){const O=[];for(const N of this.expr)O.push(...N.keys());return O}map(O){return new Y(this.expr.map(N=>N.map(O)),null)}negate(){if(!this.c){const O=[];for(const N of this.expr)O.push(N.negate());for(;O.length>1;){const N=O.shift(),U=O.shift(),T=[];for(const z of q(N))for(const B of q(U))T.push(ie.create([z,B],null,!1));O.unshift(Y.create(T,null,!1))}this.c=Y.create(O,this,!0)}return this.c}}e.$7i=Y;class J extends f{static all(){return J.d.values()}constructor(O,N,U){super(O,null),this.f=N,typeof U=="object"?J.d.push({...U,key:O}):U!==!0&&J.d.push({key:O,description:U,type:N!=null?typeof N:void 0})}bindTo(O){return O.createKey(this.key,this.f)}getValue(O){return O.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(O){return S.create(this.key,O)}notEqualsTo(O){return P.create(this.key,O)}}e.$8i=J,J.d=[],e.$9i=(0,L.$Qh)("contextKeyService");function re(Q,O){return Q<O?-1:Q>O?1:0}function ce(Q,O,N,U){return Q<N?-1:Q>N?1:O<U?-1:O>U?1:0}function oe(Q,O){if(Q.type===0||O.type===1)return!0;if(Q.type===9)return O.type===9?_(Q.expr,O.expr):!1;if(O.type===9){for(const N of O.expr)if(oe(Q,N))return!0;return!1}if(Q.type===6){if(O.type===6)return _(O.expr,Q.expr);for(const N of Q.expr)if(oe(N,O))return!0;return!1}return Q.equals(O)}e.$0i=oe;function _(Q,O){let N=0,U=0;for(;N<Q.length&&U<O.length;){const T=Q[N].cmp(O[U]);if(T<0)return!1;T===0&&N++,U++}return N===Q.length}function q(Q){return Q.type===9?Q.expr:[Q]}}),define(be[215],we([1,0,6]),function(ue,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$um=e.$tm=e.$sm=e.ID=void 0,e.ID="diagnosticsService",e.$sm=(0,y.$Qh)(e.ID);function R(L){return!!L.hostName&&!!L.errorMessage}e.$tm=R;class r{async getPerformanceInfo(I,C){return{}}async getSystemInfo(I,C){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(I,C){return""}async getWorkspaceFileExtensions(I){return{extensions:[]}}async reportWorkspaceStats(I){}}e.$um=r}),define(be[81],we([1,0,6]),function(ue,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tn=void 0,e.$Tn=(0,y.$Qh)("downloadService")}),define(be[25],we([1,0,6]),function(ue,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yh=e.$Xh=void 0,e.$Xh=(0,y.$Qh)("environmentService"),e.$Yh=(0,y.$Rh)(e.$Xh)}),define(be[30],we([1,0,178,6]),function(ue,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lo=e.$ko=e.$jo=e.$io=e.$ho=e.$go=e.$fo=e.$eo=e.$do=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$co=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$bo=e.$ao=e.$_n=e.$$n=e.$0n=e.$9n=e.$8n=e.$7n=e.$6n=e.$5n=e.$4n=e.$3n=void 0,e.$3n="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$4n=new RegExp(e.$3n),e.$5n="__web_extension",e.$6n="skipWalkthrough",e.$7n="extensionsSync",e.$8n="dependecyOrPackExtensionInstall";function r(h){switch(h){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$9n=r;function L(h){switch(h){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$0n=L;function I(h,g){switch(h){case 3:return g==="x64"?"win32-x64":g==="arm64"?"win32-arm64":"unknown";case 2:return g==="x64"?"linux-x64":g==="arm64"?"linux-arm64":g==="arm"?"linux-armhf":"unknown";case"alpine":return g==="x64"?"alpine-x64":g==="arm64"?"alpine-arm64":"unknown";case 1:return g==="x64"?"darwin-x64":g==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$$n=I;function C(h,g){return g==="web"&&!h.includes("web")}e.$_n=C;function p(h,g,l){return C(g,l)?!1:h==="undefined"||h==="universal"?!0:h==="unknown"?!1:h===l}e.$ao=p;function w(h){return h&&typeof h=="object"&&typeof h.id=="string"&&(!h.uuid||typeof h.uuid=="string")}e.$bo=w;var A;(function(h){h[h.NoneOrRelevance=0]="NoneOrRelevance",h[h.LastUpdatedDate=1]="LastUpdatedDate",h[h.Title=2]="Title",h[h.PublisherName=3]="PublisherName",h[h.InstallCount=4]="InstallCount",h[h.PublishedDate=10]="PublishedDate",h[h.AverageRating=6]="AverageRating",h[h.WeightedRating=12]="WeightedRating"})(A||(e.SortBy=A={}));var k;(function(h){h[h.Default=0]="Default",h[h.Ascending=1]="Ascending",h[h.Descending=2]="Descending"})(k||(e.SortOrder=k={}));var v;(function(h){h.Install="install",h.Uninstall="uninstall"})(v||(e.StatisticType=v={}));var u;(function(h){h[h.None=1]="None",h[h.Install=2]="Install",h[h.Update=3]="Update",h[h.Migrate=4]="Migrate"})(u||(e.InstallOperation=u={})),e.$co=(0,R.$Qh)("extensionGalleryService");var b;(function(h){h.Unsupported="Unsupported",h.Deprecated="Deprecated",h.Malicious="Malicious",h.Incompatible="Incompatible",h.IncompatibleTargetPlatform="IncompatibleTargetPlatform",h.ReleaseVersionNotFound="ReleaseVersionNotFound",h.Invalid="Invalid",h.Download="Download",h.Extract="Extract",h.Delete="Delete",h.Rename="Rename",h.CorruptZip="CorruptZip",h.IncompleteZip="IncompleteZip",h.Signature="Signature",h.Internal="Internal"})(b||(e.ExtensionManagementErrorCode=b={}));var m;(function(h){h.UnknownError="UnknownError",h.PackageIsInvalidZip="PackageIsInvalidZip",h.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(m||(e.ExtensionSignaturetErrorCode=m={}));class d extends Error{constructor(g,l){super(g),this.code=l,this.name=l}}e.$do=d,e.$eo=(0,R.$Qh)("extensionManagementService"),e.$fo="extensionsIdentifiers/disabled",e.$go="extensionsIdentifiers/enabled",e.$ho=(0,R.$Qh)("IGlobalExtensionEnablementService"),e.$io=(0,R.$Qh)("IExtensionTipsService"),e.$jo=(0,y.localize)(0,null),e.$ko={value:e.$jo,original:"Extensions"},e.$lo={value:(0,y.localize)(1,null),original:"Preferences"}}),define(be[216],we([1,0,5,2,22,4,51,30]),function(ue,e,y,R,r,L,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$op=e.$np=e.$mp=void 0;function p(d,h){return d?L.URI.revive(h?h.transformIncoming(d):d):void 0}function w(d,h){return h?h.transformOutgoingURI(d):d}function A(d,h){h=h||I.$Om;const g=d.manifest;return{...(0,I.$Rm)({...d,manifest:void 0},h),manifest:g}}function k(d,h){return d?.profileLocation?(0,I.$Rm)(d,h??I.$Om):d}function v(d,h){return h?(0,r.$$m)(d,g=>g instanceof L.URI?h.transformOutgoingURI(g):void 0):d}class u{constructor(h,g){this.a=h,this.b=g,this.onInstallExtension=y.Event.buffer(h.onInstallExtension,!0),this.onDidInstallExtensions=y.Event.buffer(h.onDidInstallExtensions,!0),this.onUninstallExtension=y.Event.buffer(h.onUninstallExtension,!0),this.onDidUninstallExtension=y.Event.buffer(h.onDidUninstallExtension,!0),this.onDidUpdateExtensionMetadata=y.Event.buffer(h.onDidUpdateExtensionMetadata,!0)}listen(h,g){const l=this.b(h);switch(g){case"onInstallExtension":return y.Event.map(this.onInstallExtension,$=>({...$,profileLocation:$.profileLocation?w($.profileLocation,l):$.profileLocation}));case"onDidInstallExtensions":return y.Event.map(this.onDidInstallExtensions,$=>$.map(c=>({...c,local:c.local?v(c.local,l):c.local,profileLocation:c.profileLocation?w(c.profileLocation,l):c.profileLocation})));case"onUninstallExtension":return y.Event.map(this.onUninstallExtension,$=>({...$,profileLocation:$.profileLocation?w($.profileLocation,l):$.profileLocation}));case"onDidUninstallExtension":return y.Event.map(this.onDidUninstallExtension,$=>({...$,profileLocation:$.profileLocation?w($.profileLocation,l):$.profileLocation}));case"onDidUpdateExtensionMetadata":return y.Event.map(this.onDidUpdateExtensionMetadata,$=>v($,l))}throw new Error("Invalid listen")}async call(h,g,l){const $=this.b(h);switch(g){case"zip":{const c=A(l[0],$),n=await this.a.zip(c);return w(n,$)}case"unzip":return this.a.unzip(p(l[0],$));case"install":return this.a.install(p(l[0],$),k(l[1],$));case"installFromLocation":return this.a.installFromLocation(p(l[0],$),p(l[1],$));case"installExtensionsFromProfile":return this.a.installExtensionsFromProfile(l[0],p(l[1],$),p(l[2],$));case"getManifest":return this.a.getManifest(p(l[0],$));case"getTargetPlatform":return this.a.getTargetPlatform();case"canInstall":return this.a.canInstall(l[0]);case"installFromGallery":return this.a.installFromGallery(l[0],k(l[1],$));case"installGalleryExtensions":{const c=l[0];return this.a.installGalleryExtensions(c.map(({extension:n,options:i})=>({extension:n,options:k(i,$)??{}})))}case"uninstall":return this.a.uninstall(A(l[0],$),k(l[1],$));case"reinstallFromGallery":return this.a.reinstallFromGallery(A(l[0],$));case"getInstalled":return(await this.a.getInstalled(l[0],p(l[1],$))).map(n=>v(n,$));case"toggleAppliationScope":{const c=await this.a.toggleAppliationScope(A(l[0],$),p(l[1],$));return v(c,$)}case"copyExtensions":return this.a.copyExtensions(p(l[0],$),p(l[1],$));case"updateMetadata":{const c=await this.a.updateMetadata(A(l[0],$),l[1],p(l[2],$));return v(c,$)}case"getExtensionsControlManifest":return this.a.getExtensionsControlManifest();case"download":return this.a.download(l[0],l[1],l[2]);case"cleanUp":return this.a.cleanUp()}throw new Error("Invalid call")}}e.$mp=u;class b extends R.$Sc{get onInstallExtension(){return this.c.event}get onDidInstallExtensions(){return this.f.event}get onUninstallExtension(){return this.g.event}get onDidUninstallExtension(){return this.h.event}get onDidUpdateExtensionMetadata(){return this.j.event}constructor(h){super(),this.m=h,this.c=this.B(new y.$Od),this.f=this.B(new y.$Od),this.g=this.B(new y.$Od),this.h=this.B(new y.$Od),this.j=this.B(new y.$Od),this.B(this.m.listen("onInstallExtension")(g=>this.n(this.c,{...g,source:this.r(g.source)?L.URI.revive(g.source):g.source,profileLocation:L.URI.revive(g.profileLocation)}))),this.B(this.m.listen("onDidInstallExtensions")(g=>this.n(this.f,g.map(l=>({...l,local:l.local?A(l.local,null):l.local,source:this.r(l.source)?L.URI.revive(l.source):l.source,profileLocation:L.URI.revive(l.profileLocation)}))))),this.B(this.m.listen("onUninstallExtension")(g=>this.n(this.g,{...g,profileLocation:L.URI.revive(g.profileLocation)}))),this.B(this.m.listen("onDidUninstallExtension")(g=>this.n(this.h,{...g,profileLocation:L.URI.revive(g.profileLocation)}))),this.B(this.m.listen("onDidUpdateExtensionMetadata")(g=>this.j.fire(A(g,null))))}n(h,g){h.fire(g)}r(h){return h?typeof h.path=="string"&&typeof h.scheme=="string":!1}getTargetPlatform(){return this.s||(this.s=this.m.call("getTargetPlatform")),this.s}async canInstall(h){const g=await this.getTargetPlatform();return h.allTargetPlatforms.some(l=>(0,C.$ao)(l,h.allTargetPlatforms,g))}zip(h){return Promise.resolve(this.m.call("zip",[h]).then(g=>L.URI.revive(g)))}unzip(h){return Promise.resolve(this.m.call("unzip",[h]))}install(h,g){return Promise.resolve(this.m.call("install",[h,g])).then(l=>A(l,null))}installFromLocation(h,g){return Promise.resolve(this.m.call("installFromLocation",[h,g])).then(l=>A(l,null))}async installExtensionsFromProfile(h,g,l){return(await this.m.call("installExtensionsFromProfile",[h,g,l])).map(c=>A(c,null))}getManifest(h){return Promise.resolve(this.m.call("getManifest",[h]))}installFromGallery(h,g){return Promise.resolve(this.m.call("installFromGallery",[h,g])).then(l=>A(l,null))}async installGalleryExtensions(h){return(await this.m.call("installGalleryExtensions",[h])).map(l=>({...l,local:l.local?A(l.local,null):l.local,source:this.r(l.source)?L.URI.revive(l.source):l.source,profileLocation:L.URI.revive(l.profileLocation)}))}uninstall(h,g){return Promise.resolve(this.m.call("uninstall",[h,g]))}reinstallFromGallery(h){return Promise.resolve(this.m.call("reinstallFromGallery",[h])).then(g=>A(g,null))}getInstalled(h=null,g){return Promise.resolve(this.m.call("getInstalled",[h,g])).then(l=>l.map($=>A($,null)))}updateMetadata(h,g,l){return Promise.resolve(this.m.call("updateMetadata",[h,g,l])).then($=>A($,null))}toggleAppliationScope(h,g){return this.m.call("toggleAppliationScope",[h,g]).then(l=>A(l,null))}copyExtensions(h,g){return this.m.call("copyExtensions",[h,g])}getExtensionsControlManifest(){return Promise.resolve(this.m.call("getExtensionsControlManifest"))}async download(h,g,l){const $=await this.m.call("download",[h,g,l]);return L.URI.revive($)}async cleanUp(){return this.m.call("cleanUp")}registerParticipant(){throw new Error("Not Supported")}}e.$np=b;class m{constructor(h){this.a=h}listen(h,g){throw new Error("Invalid listen")}call(h,g,l){switch(g){case"getConfigBasedTips":return this.a.getConfigBasedTips(L.URI.revive(l[0]));case"getImportantExecutableBasedTips":return this.a.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.a.getOtherExecutableBasedTips()}throw new Error("Invalid call")}}e.$op=m}),define(be[82],we([1,0,6]),function(ue,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kp=e.$jp=void 0,e.$jp=(0,y.$Qh)("IExtensionSignatureVerificationService");class R{b(){return this.a||(this.a=new Promise((L,I)=>ue(["node-vsce-sign"],async C=>L(C),I))),this.a}async verify(L,I,C){let p;try{p=await this.b()}catch{return!1}return p.verify(L,I,C)}}e.$kp=R}),define(be[16],we([1,0,64,7,17,8,4,186,6,3,12,76]),function(ue,e,y,R,r,L,I,C,p,w,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ik=e.$Hk=e.$Gk=e.$Fk=e.$Ek=e.FileKind=e.$Dk=e.$Ck=e.$Bk=e.$Ak=e.$zk=e.$yk=e.$xk=e.FileOperationResult=e.$wk=e.$vk=e.$uk=e.$tk=e.$sk=e.FileChangeType=e.$rk=e.FileOperation=e.$qk=e.$pk=e.$ok=e.$nk=e.$mk=e.$lk=e.FileSystemProviderErrorCode=e.$kk=e.$jk=e.$ik=e.$hk=e.$gk=e.$fk=e.$ek=e.$dk=e.$ck=e.FileSystemProviderCapabilities=e.$bk=e.FilePermission=e.FileType=e.$ak=e.$_j=void 0,e.$_j=(0,p.$Qh)("fileService");function v(oe){return oe.create===!0}e.$ak=v;var u;(function(oe){oe[oe.Unknown=0]="Unknown",oe[oe.File=1]="File",oe[oe.Directory=2]="Directory",oe[oe.SymbolicLink=64]="SymbolicLink"})(u||(e.FileType=u={}));var b;(function(oe){oe[oe.Readonly=1]="Readonly",oe[oe.Locked=2]="Locked"})(b||(e.FilePermission=b={}));function m(oe){const _=oe;return!!_&&typeof _.onDidChange=="function"}e.$bk=m;var d;(function(oe){oe[oe.None=0]="None",oe[oe.FileReadWrite=2]="FileReadWrite",oe[oe.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",oe[oe.FileReadStream=16]="FileReadStream",oe[oe.FileFolderCopy=8]="FileFolderCopy",oe[oe.PathCaseSensitive=1024]="PathCaseSensitive",oe[oe.Readonly=2048]="Readonly",oe[oe.Trash=4096]="Trash",oe[oe.FileWriteUnlock=8192]="FileWriteUnlock",oe[oe.FileAtomicRead=16384]="FileAtomicRead",oe[oe.FileAtomicWrite=32768]="FileAtomicWrite",oe[oe.FileAtomicDelete=65536]="FileAtomicDelete",oe[oe.FileClone=131072]="FileClone"})(d||(e.FileSystemProviderCapabilities=d={}));function h(oe){return!!(oe.capabilities&2)}e.$ck=h;function g(oe){return!!(oe.capabilities&8)}e.$dk=g;function l(oe){return!!(oe.capabilities&131072)}e.$ek=l;function $(oe){return!!(oe.capabilities&4)}e.$fk=$;function c(oe){return!!(oe.capabilities&16)}e.$gk=c;function n(oe){return h(oe)?!!(oe.capabilities&16384):!1}e.$hk=n;function i(oe){return h(oe)?!!(oe.capabilities&32768):!1}e.$ik=i;function o(oe){return!!(oe.capabilities&65536)}e.$jk=o;function s(oe){return!!(oe.capabilities&2048)}e.$kk=s;var t;(function(oe){oe.FileExists="EntryExists",oe.FileNotFound="EntryNotFound",oe.FileNotADirectory="EntryNotADirectory",oe.FileIsADirectory="EntryIsADirectory",oe.FileExceedsStorageQuota="EntryExceedsStorageQuota",oe.FileTooLarge="EntryTooLarge",oe.FileWriteLocked="EntryWriteLocked",oe.NoPermissions="NoPermissions",oe.Unavailable="Unavailable",oe.Unknown="Unknown"})(t||(e.FileSystemProviderErrorCode=t={}));class a extends Error{static create(_,q){const Q=new a(_.toString(),q);return D(Q,q),Q}constructor(_,q){super(_),this.code=q}}e.$lk=a;function f(oe,_){return a.create(oe,_)}e.$mk=f;function S(oe){return oe||f((0,C.localize)(0,null),t.Unknown)}e.$nk=S;function D(oe,_){return oe.name=_?`${_} (FileSystemError)`:"FileSystemError",oe}e.$ok=D;function E(oe){if(!oe)return t.Unknown;if(oe instanceof a)return oe.code;const _=/^(.+) \(FileSystemError\)$/.exec(oe.name);if(!_)return t.Unknown;switch(_[1]){case t.FileExists:return t.FileExists;case t.FileIsADirectory:return t.FileIsADirectory;case t.FileNotADirectory:return t.FileNotADirectory;case t.FileNotFound:return t.FileNotFound;case t.FileTooLarge:return t.FileTooLarge;case t.FileWriteLocked:return t.FileWriteLocked;case t.NoPermissions:return t.NoPermissions;case t.Unavailable:return t.Unavailable}return t.Unknown}e.$pk=E;function P(oe){if(oe instanceof he)return oe.fileOperationResult;switch(E(oe)){case t.FileNotFound:return 1;case t.FileIsADirectory:return 0;case t.FileNotADirectory:return 9;case t.FileWriteLocked:return 5;case t.NoPermissions:return 6;case t.FileExists:return 4;case t.FileTooLarge:return 7;default:return 10}}e.$qk=P;var M;(function(oe){oe[oe.CREATE=0]="CREATE",oe[oe.DELETE=1]="DELETE",oe[oe.MOVE=2]="MOVE",oe[oe.COPY=3]="COPY",oe[oe.WRITE=4]="WRITE"})(M||(e.FileOperation=M={}));class ee{constructor(_,q,Q){this.resource=_,this.operation=q,this.target=Q}isOperation(_){return this.operation===_}}e.$rk=ee;var se;(function(oe){oe[oe.UPDATED=0]="UPDATED",oe[oe.ADDED=1]="ADDED",oe[oe.DELETED=2]="DELETED"})(se||(e.FileChangeType=se={}));class G{constructor(_,q){this.c=q,this.b=void 0,this.d=new k.$V(()=>{const Q=y.$Wh.forUris(()=>this.c);return Q.fill(this.rawAdded.map(O=>[O,!0])),Q}),this.f=new k.$V(()=>{const Q=y.$Wh.forUris(()=>this.c);return Q.fill(this.rawUpdated.map(O=>[O,!0])),Q}),this.g=new k.$V(()=>{const Q=y.$Wh.forUris(()=>this.c);return Q.fill(this.rawDeleted.map(O=>[O,!0])),Q}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const Q of _){switch(Q.type){case 1:this.rawAdded.push(Q.resource);break;case 0:this.rawUpdated.push(Q.resource);break;case 2:this.rawDeleted.push(Q.resource);break}this.b!==G.a&&(typeof Q.cId=="number"?this.b===void 0?this.b=Q.cId:this.b!==Q.cId&&(this.b=G.a):this.b!==void 0&&(this.b=G.a))}}contains(_,...q){return this.h(_,{includeChildren:!1},...q)}affects(_,...q){return this.h(_,{includeChildren:!0},...q)}h(_,q,...Q){if(!_)return!1;const O=Q.length>0;return!!((!O||Q.includes(1))&&(this.d.value.get(_)||q.includeChildren&&this.d.value.findSuperstr(_))||(!O||Q.includes(0))&&(this.f.value.get(_)||q.includeChildren&&this.f.value.findSuperstr(_))||(!O||Q.includes(2))&&(this.g.value.findSubstr(_)||q.includeChildren&&this.g.value.findSuperstr(_)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(_){return this.b===_}hasCorrelation(){return typeof this.b=="number"}}e.$sk=G,G.a=null;function ne(oe,_,q){return!oe||!_||oe===_||_.length>oe.length?!1:(_.charAt(_.length-1)!==R.sep&&(_+=R.sep),q?(0,r.$4e)(oe,_):oe.indexOf(_)===0)}e.$tk=ne;class he extends Error{constructor(_,q,Q){super(_),this.fileOperationResult=q,this.options=Q}}e.$uk=he;class Z extends he{constructor(_,q,Q,O){super(_,q,O),this.fileOperationResult=q,this.size=Q}}e.$vk=Z;class fe extends he{constructor(_,q,Q){super(_,2,Q),this.stat=q}}e.$wk=fe;var V;(function(oe){oe[oe.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",oe[oe.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",oe[oe.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",oe[oe.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",oe[oe.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",oe[oe.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",oe[oe.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",oe[oe.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",oe[oe.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",oe[oe.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",oe[oe.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(V||(e.FileOperationResult=V={})),e.$xk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$yk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$zk="files.associations",e.$Ak="files.exclude",e.$Bk="files.readonlyInclude",e.$Ck="files.readonlyExclude",e.$Dk="files.readonlyFromPermissions";var ie;(function(oe){oe[oe.FILE=0]="FILE",oe[oe.FOLDER=1]="FOLDER",oe[oe.ROOT_FOLDER=2]="ROOT_FOLDER"})(ie||(e.FileKind=ie={})),e.$Ek="";function Y(oe){if(!(typeof oe.size!="number"||typeof oe.mtime!="number"))return oe.mtime.toString(29)+oe.size.toString(31)}e.$Fk=Y;async function J(oe,_){if(!_.hasProvider(I.URI.from({scheme:oe.scheme})))return new Promise(q=>{const Q=_.onDidChangeFileSystemProviderRegistrations(O=>{O.scheme===oe.scheme&&O.added&&(Q.dispose(),q())})})}e.$Gk=J;class re{static formatSize(_){return(0,L.$Df)(_)||(_=0),_<re.KB?(0,C.localize)(1,null,_.toFixed(0)):_<re.MB?(0,C.localize)(2,null,(_/re.KB).toFixed(2)):_<re.GB?(0,C.localize)(3,null,(_/re.MB).toFixed(2)):_<re.TB?(0,C.localize)(4,null,(_/re.GB).toFixed(2)):(0,C.localize)(5,null,(_/re.TB).toFixed(2))}}e.$Hk=re,re.KB=1024,re.MB=re.KB*re.KB,re.GB=re.MB*re.KB,re.TB=re.GB*re.KB;function ce(oe){const _=typeof oe=="string"||oe?.scheme===A.Schemas.vscodeRemote;return typeof oe!="string"&&oe?.scheme===A.Schemas.file?1024*re.MB:_?10*re.MB:w.$j?50*re.MB:1024*re.MB}e.$Ik=ce}),define(be[110],we([1,0,15,11,187,16]),function(ue,e,y,R,r,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rp=void 0;async function I(A,k,v,u,b,m){let d;try{await C(A,k,v,u,b,m)}catch(h){d=h}finally{d&&b.errorTransformer&&(d=b.errorTransformer(d)),typeof d<"u"&&v.error(d),v.end()}}e.$Rp=I;async function C(A,k,v,u,b,m){p(m);const d=await A.open(k,{create:!1});try{p(m);let h=0,g=0,l=b&&typeof b.length=="number"?b.length:void 0,$=y.$ce.alloc(Math.min(b.bufferSize,typeof l=="number"?l:b.bufferSize)),c=b&&typeof b.position=="number"?b.position:0,n=0;do g=await A.read(d,c,$.buffer,n,$.byteLength-n),c+=g,n+=g,h+=g,typeof l=="number"&&(l-=g),n===$.byteLength&&(await v.write(u($)),$=y.$ce.alloc(Math.min(b.bufferSize,typeof l=="number"?l:b.bufferSize)),n=0);while(g>0&&(typeof l!="number"||l>0)&&p(m)&&w(h,b));if(n>0){let i=n;typeof l=="number"&&(i=Math.min(n,l)),v.write(u($.slice(0,i)))}}catch(h){throw(0,L.$nk)(h)}finally{await A.close(d)}}function p(A){if(A.isCancellationRequested)throw(0,R.$6)();return!0}function w(A,k){if(typeof k?.limits?.size=="number"&&A>k.limits.size)throw(0,L.$mk)((0,r.localize)(0,null),L.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(be[54],we([1,0,77,2,7,3,4,16]),function(ue,e,y,R,r,L,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1p=e.$Zp=e.$Yp=e.$Xp=e.$Wp=e.$Vp=e.$Up=e.$Tp=void 0;function p(h){return h.recursive===!0}e.$Tp=p;class w extends R.$Sc{constructor(g,l,$,c){super(),this.h=g,this.j=l,this.m=$,this.n=c,this.c=this.B(new R.$Tc),this.f=void 0,this.g=0}s(){const g=new R.$Rc;this.c.value=g,this.b=this.r(g),this.b.setVerboseLogging(this.m),g.add(this.b.onDidChangeFile(l=>this.h(l))),g.add(this.b.onDidLogMessage(l=>this.j(l))),g.add(this.b.onDidError(l=>this.t(l)))}t(g){this.n.restartOnError?this.g<w.a&&this.f?(this.w(`restarting watcher after error: ${g}`),this.u(this.f)):this.w(`gave up attempting to restart watcher after error: ${g}`):this.w(g)}u(g){this.g++,this.s(),this.watch(g)}async watch(g){this.f=g,await this.b?.watch(g)}async setVerboseLogging(g){this.m=g,await this.b?.setVerboseLogging(g)}w(g){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${g}`})}y(g){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${g}`})}dispose(){return this.b=void 0,super.dispose()}}e.$Up=w,w.a=5;class A extends w{constructor(g,l,$){super(g,l,$,{type:"node.js",restartOnError:!1})}}e.$Vp=A;class k extends w{constructor(g,l,$){super(g,l,$,{type:"universal",restartOnError:!0})}}e.$Wp=k;function v(h){return h.map(g=>({type:g.type,resource:I.URI.revive(g.resource),cId:g.cId}))}e.$Xp=v;function u(h){const g=new d;for(const l of h)g.processEvent(l);return g.coalesce()}e.$Yp=u;function b(h,g){return typeof g=="string"&&!g.startsWith(y.$tj)&&!(0,r.$ic)(g)?{base:h,pattern:g}:g}e.$Zp=b;function m(h,g){const l=[];for(const $ of g)l.push((0,y.$xj)(b(h,$)));return l}e.$1p=m;class d{constructor(){this.a=new Set,this.b=new Map}c(g){return L.$f?g.resource.fsPath:g.resource.fsPath.toLowerCase()}processEvent(g){const l=this.b.get(this.c(g));let $=!1;if(l){const c=l.type,n=g.type;l.resource.fsPath!==g.resource.fsPath&&(g.type===2||g.type===1)?$=!0:c===1&&n===2?(this.b.delete(this.c(g)),this.a.delete(l)):c===2&&n===1?l.type=0:c===1&&n===0||(l.type=n)}else $=!0;$&&(this.a.add(g),this.b.set(this.c(g),g))}coalesce(){const g=[],l=[];return Array.from(this.a).filter($=>$.type!==2?(g.push($),!1):!0).sort(($,c)=>$.resource.fsPath.length-c.resource.fsPath.length).filter($=>l.some(c=>(0,C.$tk)($.resource.fsPath,c,!L.$f))?!1:(l.push($.resource.fsPath),!0)).concat(g)}}}),define(be[217],we([1,0,15,40,11,5,2,48,23,16,54]),function(ue,e,y,R,r,L,I,C,p,w,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xN=e.$wN=void 0,e.$wN="localFilesystem";class k extends I.$Sc{constructor(u,b){super(),this.a=u,this.b=b,this.onDidChangeCapabilities=L.Event.None,this.f=this.B(new L.$Od),this.onDidChangeFile=this.f.event,this.g=this.B(new L.$Od),this.onDidWatchError=this.g.event,this.h=(0,p.$fg)(),this.j()}get capabilities(){return this.c||(this.c=253982,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat(u){return this.a.call("stat",[u])}readdir(u){return this.a.call("readdir",[u])}async readFile(u,b){const{buffer:m}=await this.a.call("readFile",[u,b]);return m}readFileStream(u,b,m){const d=(0,C.$3d)(g=>y.$ce.concat(g.map(l=>y.$ce.wrap(l))).buffer),h=new I.$Rc;return h.add(this.a.listen("readFileStream",[u,b])(g=>{if(g instanceof y.$ce)d.write(g.buffer);else{if(g==="end")d.end();else{let l;if(g instanceof Error)l=g;else{const $=g;l=(0,w.$mk)($.message??(0,R.$Bi)($),$.code??w.FileSystemProviderErrorCode.Unknown)}d.error(l),d.end()}h.dispose()}})),h.add(m.onCancellationRequested(()=>{d.error((0,r.$6)()),d.end(),h.dispose()})),d}writeFile(u,b,m){return this.a.call("writeFile",[u,y.$ce.wrap(b),m])}open(u,b){return this.a.call("open",[u,b])}close(u){return this.a.call("close",[u])}async read(u,b,m,d,h){const[g,l]=await this.a.call("read",[u,b,h]);return m.set(g.buffer.slice(0,l),d),l}write(u,b,m,d,h){return this.a.call("write",[u,b,y.$ce.wrap(m),d,h])}mkdir(u){return this.a.call("mkdir",[u])}delete(u,b){return this.a.call("delete",[u,b])}rename(u,b,m){return this.a.call("rename",[u,b,m])}copy(u,b,m){return this.a.call("copy",[u,b,m])}cloneFile(u,b){return this.a.call("cloneFile",[u,b])}j(){this.B(this.a.listen("fileChange",[this.h])(u=>{if(Array.isArray(u)){const b=u;this.f.fire((0,A.$Xp)(b))}else{const b=u;this.g.fire(b)}}))}watch(u,b){const m=(0,p.$fg)();return this.a.call("watch",[this.h,m,u,b]),(0,I.$Qc)(()=>this.a.call("unwatch",[this.h,m]))}}e.$xN=k}),define(be[218],we([1,0,29,14,20,39,2,98,7,3,19,4,157,21,54]),function(ue,e,y,R,r,L,I,C,p,w,A,k,v,u,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cq=e.$bq=void 0;class m extends I.$Sc{constructor(g,l,$,c){super(),this.m=g,this.n=l,this.r=$,this.s=c,this.c=this.B(new R.$0g({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},n=>this.n(n))),this.f=this.B(new R.$9g(n=>this.z(n),m.b)),this.g=(0,b.$1p)(this.m.path,this.m.excludes),this.h=this.m.includes?(0,b.$1p)(this.m.path,this.m.includes):void 0,this.j=new r.$Yd,this.ready=this.t()}async t(){try{const g=await this.u(this.m);if(this.j.token.isCancellationRequested)return;const l=await u.Promises.stat(g);this.B(await this.w(g,l.isDirectory()))}catch(g){g.code!=="ENOENT"?this.D(g):this.G(g)}}async u(g){let l=g.path;try{l=await u.Promises.realpath(g.path),g.path===l&&(l=await(0,v.$$p)(g.path)??g.path),g.path!==l&&this.G(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${g.path}, real: ${l})`)}catch{}return l}async w(g,l){if(w.$e&&(0,L.$Yf)(g,"/Volumes/",!0))return this.D(`Refusing to watch ${g} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),I.$Sc.None;const $=new r.$Yd(this.j.token),c=new I.$Rc;try{const n=k.URI.file(this.m.path),i=(0,p.$nc)(g),o=(0,y.watch)(g);c.add((0,I.$Qc)(()=>{o.removeAllListeners(),o.close()})),this.G(`Started watching: '${g}'`);const s=new Set;if(l)try{for(const a of await u.Promises.readdir(g))s.add(a)}catch(a){this.D(a)}const t=new Map;c.add((0,I.$Qc)(()=>{for(const[,a]of t)a.dispose();t.clear()})),o.on("error",(a,f)=>{this.D(`Failed to watch ${g} for changes using fs.watch() (${a}, ${f})`),this.dispose()}),o.on("change",(a,f)=>{if($.token.isCancellationRequested)return;this.G(`[raw] ["${a}"] ${f}`);let S="";if(f&&(S=f.toString(),w.$e&&(S=(0,C.$ql)(S))),!(!S||a!=="change"&&a!=="rename"))if(l)if(a==="rename"){t.get(S)?.dispose();const D=setTimeout(async()=>{if(t.delete(S),S===i&&!await u.Promises.exists(g)){this.F("Watcher shutdown because watched path got deleted"),this.dispose();return}const E=await this.C((0,p.$jc)(g,S));if($.token.isCancellationRequested)return;let P;E?s.has(S)?P=0:(P=1,s.add(S)):(s.delete(S),P=2),this.y({resource:(0,A.$wg)(n,S),type:P,cId:this.m.correlationId})},m.a);t.set(S,(0,I.$Qc)(()=>clearTimeout(D)))}else{let D;s.has(S)?D=0:(D=1,s.add(S)),this.y({resource:(0,A.$wg)(n,S),type:D,cId:this.m.correlationId})}else if(a==="rename"||S!==i){const D=setTimeout(async()=>{const E=await u.Promises.exists(g);$.token.isCancellationRequested||(E?(this.y({resource:n,type:0,cId:this.m.correlationId},!0),c.add(await this.w(g,!1))):(this.y({resource:n,type:2,cId:this.m.correlationId},!0),this.f.flush(),this.dispose()))},m.a);c.clear(),c.add((0,I.$Qc)(()=>clearTimeout(D)))}else this.y({resource:n,type:0,cId:this.m.correlationId},!0)})}catch(n){await u.Promises.exists(g)&&!$.token.isCancellationRequested&&this.D(`Failed to watch ${g} for changes using fs.watch() (${n.toString()})`)}return(0,I.$Qc)(()=>{$.dispose(!0),c.dispose()})}y(g,l=!1){this.j.token.isCancellationRequested||(this.s&&this.G(`${g.type===1?"[ADDED]":g.type===2?"[DELETED]":"[CHANGED]"} ${g.resource.fsPath}`),!l&&this.g.some($=>$(g.resource.fsPath))?this.s&&this.G(` >> ignored (excluded) ${g.resource.fsPath}`):!l&&this.h&&this.h.length>0&&!this.h.some($=>$(g.resource.fsPath))?this.s&&this.G(` >> ignored (not included) ${g.resource.fsPath}`):this.f.work(g))}z(g){const l=(0,b.$Yp)(g);if(l.length>0){if(this.s)for(const c of l)this.G(` >> normalized ${c.type===1?"[ADDED]":c.type===2?"[DELETED]":"[CHANGED]"} ${c.resource.fsPath}`);this.c.work(l)?this.c.pending>0&&this.G(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${l[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.F(`started ignoring events due to too many file change events at once (incoming: ${l.length}, most recent change: ${l[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async C(g){if(w.$f)return u.Promises.exists(g);try{const l=(0,p.$nc)(g);return(await u.Promises.readdir((0,p.$mc)(g))).some(c=>c===l)}catch(l){return this.G(l),!1}}setVerboseLogging(g){this.s=g}D(g){this.j.token.isCancellationRequested||this.r?.({type:"error",message:`[File Watcher (node.js)] ${g}`})}F(g){this.j.token.isCancellationRequested||this.r?.({type:"warn",message:`[File Watcher (node.js)] ${g}`})}G(g){!this.j.token.isCancellationRequested&&this.s&&this.r?.({type:"trace",message:`[File Watcher (node.js)] ${g}`})}dispose(){this.G(`stopping file watcher on ${this.m.path}`),this.j.dispose(!0),super.dispose()}}e.$bq=m,m.a=100,m.b=75;async function d(h,g,l,$,c=512){const n=await u.Promises.open(h,"r"),i=Buffer.allocUnsafe(c),o=new r.$Yd($);let s,t=!1;const a={path:h,excludes:[],recursive:!1},f=new m(a,S=>{(async()=>{for(const{type:D}of S)if(D===0){if(t)return;t=!0;try{for(;!o.token.isCancellationRequested;){const{bytesRead:E}=await u.Promises.read(n,i,0,c,null);if(!E||o.token.isCancellationRequested)break;g(i.slice(0,E))}}catch(E){s=new Error(E),o.dispose(!0)}finally{t=!1}}})()});return await f.ready,l(),new Promise((S,D)=>{o.token.onCancellationRequested(async()=>{f.dispose();try{await u.Promises.close(n)}catch(E){s=new Error(E)}s?D(s):S()})})}e.$cq=d}),define(be[219],we([1,0,5,77,2,3,218]),function(ue,e,y,R,r,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dq=void 0;class C extends r.$Sc{constructor(){super(...arguments),this.a=this.B(new y.$Od),this.onDidChangeFile=this.a.event,this.b=this.B(new y.$Od),this.onDidLogMessage=this.b.event,this.onDidError=y.Event.None,this.c=new Map,this.f=!1}async watch(w){const A=this.j(w),k=A.filter(u=>{const b=this.c.get(u.path);return b?!(0,R.$Bj)(b.request.excludes,u.excludes)||!(0,R.$Bj)(b.request.includes,u.includes):!0}),v=Array.from(this.c.values()).filter(({request:u})=>!A.find(b=>b.path===u.path&&(0,R.$Bj)(b.excludes,u.excludes)&&(0,R.$Bj)(b.includes,u.includes))).map(({request:u})=>u.path);k.length&&this.m(`Request to start watching: ${k.map(u=>`${u.path} (excludes: ${u.excludes.length>0?u.excludes:"<none>"}, includes: ${u.includes&&u.includes.length>0?JSON.stringify(u.includes):"<all>"}, correlationId: ${typeof u.correlationId=="number"?u.correlationId:"<none>"})`).join(",")}`),v.length&&this.m(`Request to stop watching: ${v.join(",")}`);for(const u of v)this.h(u);for(const u of k)this.g(u)}g(w){const A=new I.$bq(w,v=>this.a.fire(v),v=>this.b.fire(v),this.f),k={request:w,instance:A};this.c.set(w.path,k)}async stop(){for(const[w]of this.c)this.h(w);this.c.clear()}h(w){const A=this.c.get(w);A&&(this.c.delete(w),A.instance.dispose())}j(w){const A=new Map;for(const k of w){const v=L.$f?k.path:k.path.toLowerCase();let u=A.get(k.correlationId);u||(u=new Map,A.set(k.correlationId,u)),u.set(v,k)}return Array.from(A.values()).map(k=>Array.from(k.values())).flat()}async setVerboseLogging(w){this.f=w;for(const[,A]of this.c)A.instance.setVerboseLogging(w)}m(w){this.f&&this.b.fire({type:"trace",message:this.n(w)})}n(w,A){return A?`[File Watcher (node.js)] ${w} (path: ${A.request.path})`:`[File Watcher (node.js)] ${w}`}}e.$dq=C}),define(be[220],we([1,0,54,219]),function(ue,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eq=void 0;class r extends y.$Vp{constructor(I,C,p){super(I,C,p),this.s()}r(I){return I.add(new R.$dq)}}e.$eq=r}),define(be[221],we([1,0,12,42,107,54]),function(ue,e,y,R,r,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9p=void 0;class I extends L.$Wp{constructor(p,w,A){super(p,w,A),this.s()}r(p){const w=p.add(new r.$8p(y.$dg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return p.add(w.onDidProcessExit(({code:A,signal:k})=>this.t(`terminated by itself with code ${A}, signal: ${k}`))),R.ProxyChannel.toService((0,R.$xh)(w.getChannel("watcher")))}}e.$9p=I}),define(be[83],we([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oh=void 0;class y{constructor(...r){this.a=new Map;for(const[L,I]of r)this.set(L,I)}set(r,L){const I=this.a.get(r);return this.a.set(r,L),I}has(r){return this.a.has(r)}get(r){return this.a.get(r)}}e.$Oh=y}),define(be[111],we([1,0,14,11,2,66,214,6,83,97]),function(ue,e,y,R,r,L,I,C,p,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jq=e.$iq=void 0;const A=!1;class k extends Error{constructor(d){super("cyclic dependency between services"),this.message=d.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${d.toString()}`}}class v{constructor(d=new p.$Oh,h=!1,g,l=A){this.f=d,this.g=h,this.h=g,this.i=l,this.o=new Set,this.f.set(C.$Ph,this),this._globalGraph=l?g?._globalGraph??new I.$hq($=>$):void 0}createChild(d){return new v(d,this.g,this,this.i)}invokeFunction(d,...h){const g=b.traceInvocation(this.i,d);let l=!1;try{return d({get:c=>{if(l)throw(0,R.$8)("service accessor is only valid during the invocation of its target method");const n=this.m(c,g);if(!n)throw new Error(`[invokeFunction] unknown service '${c}'`);return n}},...h)}finally{l=!0,g.stop()}}createInstance(d,...h){let g,l;return d instanceof L.$Nh?(g=b.traceCreation(this.i,d.ctor),l=this.j(d.ctor,d.staticArguments.concat(h),g)):(g=b.traceCreation(this.i,d),l=this.j(d,h,g)),g.stop(),l}j(d,h=[],g){const l=C._util.getServiceDependencies(d).sort((n,i)=>n.index-i.index),$=[];for(const n of l){const i=this.m(n.id,g);i||this.u(`[createInstance] ${d.name} depends on UNKNOWN service ${n.id}.`,!1),$.push(i)}const c=l.length>0?l[0].index:h.length;if(h.length!==c){console.trace(`[createInstance] First service dependency of ${d.name} at position ${c+1} conflicts with ${h.length} static arguments`);const n=c-h.length;n>0?h=h.concat(new Array(n)):h=h.slice(0,c)}return Reflect.construct(d,h.concat($))}k(d,h){if(this.f.get(d)instanceof L.$Nh)this.f.set(d,h);else if(this.h)this.h.k(d,h);else throw new Error("illegalState - setting UNKNOWN service instance")}l(d){const h=this.f.get(d);return!h&&this.h?this.h.l(d):h}m(d,h){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(d));const g=this.l(d);return g instanceof L.$Nh?this.q(d,g,h.branch(d,!0)):(h.branch(d,!1),g)}q(d,h,g){if(this.o.has(d))throw new Error(`illegal state - RECURSIVELY instantiating service '${d}'`);this.o.add(d);try{return this.r(d,h,g)}finally{this.o.delete(d)}}r(d,h,g){const l=new I.$hq(n=>n.id.toString());let $=0;const c=[{id:d,desc:h,_trace:g}];for(;c.length;){const n=c.pop();if(l.lookupOrInsertNode(n),$++>1e3)throw new k(l);for(const i of C._util.getServiceDependencies(n.desc.ctor)){const o=this.l(i.id);if(o||this.u(`[createInstance] ${d} depends on ${i.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(n.id),String(i.id)),o instanceof L.$Nh){const s={id:i.id,desc:o,_trace:n._trace.branch(i.id,!0)};l.insertEdge(n,s),c.push(s)}}}for(;;){const n=l.roots();if(n.length===0){if(!l.isEmpty())throw new k(l);break}for(const{data:i}of n){if(this.l(i.id)instanceof L.$Nh){const s=this.s(i.id,i.desc.ctor,i.desc.staticArguments,i.desc.supportsDelayedInstantiation,i._trace);this.k(i.id,s)}l.removeNode(i)}}return this.l(d)}s(d,h,g=[],l,$){if(this.f.get(d)instanceof L.$Nh)return this.t(d,h,g,l,$);if(this.h)return this.h.s(d,h,g,l,$);throw new Error(`illegalState - creating UNKNOWN service instance ${h.name}`)}t(d,h,g=[],l,$){if(l){const c=new v(void 0,this.g,this,this.i);c.c=String(d);const n=new Map,i=new y.$_g(()=>{const o=c.j(h,g,$);for(const[s,t]of n){const a=o[s];if(typeof a=="function")for(const f of t)a.apply(o,f)}return n.clear(),o});return new Proxy(Object.create(null),{get(o,s){if(!i.isInitialized&&typeof s=="string"&&(s.startsWith("onDid")||s.startsWith("onWill"))){let f=n.get(s);return f||(f=new w.$2c,n.set(s,f)),(D,E,P)=>{const M=f.push([D,E,P]);return(0,r.$Qc)(M)}}if(s in o)return o[s];const t=i.value;let a=t[s];return typeof a!="function"||(a=a.bind(t),o[s]=a),a},set(o,s,t){return i.value[s]=t,!0},getPrototypeOf(o){return h.prototype}})}else return this.j(h,g,$)}u(d,h){if(h&&console.warn(d),this.g)throw new Error(d)}}e.$iq=v;var u;(function(m){m[m.None=0]="None",m[m.Creation=1]="Creation",m[m.Invocation=2]="Invocation",m[m.Branch=3]="Branch"})(u||(u={}));class b{static traceInvocation(d,h){return d?new b(2,h.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):b.c}static traceCreation(d,h){return d?new b(1,h.name):b.c}constructor(d,h){this.type=d,this.name=h,this.g=Date.now(),this.h=[]}branch(d,h){const g=new b(3,d.toString());return this.h.push([d,h,g]),g}stop(){const d=Date.now()-this.g;b.f+=d;let h=!1;function g($,c){const n=[],i=new Array($+1).join("	");for(const[o,s,t]of c.h)if(s&&t){h=!0,n.push(`${i}CREATES -> ${o}`);const a=g($+1,t);a&&n.push(a)}else n.push(`${i}uses -> ${o}`);return n.join(`
`)}const l=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${g(1,this)}`,`DONE, took ${d.toFixed(2)}ms (grand total ${b.f.toFixed(2)}ms)`];(d>2||h)&&b.all.add(l.join(`
`))}}e.$jq=b,b.all=new Set,b.c=new class extends b{constructor(){super(0,null)}stop(){}branch(){return this}},b.f=0}),define(be[222],we([1,0,6]),function(ue,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Verbosity=e.$4u=void 0,e.$4u=(0,y.$Qh)("labelService");var R;(function(r){r[r.SHORT=0]="SHORT",r[r.MEDIUM=1]="MEDIUM",r[r.LONG=2]="LONG"})(R||(e.Verbosity=R={}))});var Ae=this&&this.__param||function(ue,e){return function(y,R){e(y,R,ue)}};define(be[84],we([1,0,20,2,3,189,30,6]),function(ue,e,y,R,r,L,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yq=e.$Xq=e.$Wq=void 0;function p(A){return A.tags.find(k=>k.startsWith("lp-"))?.split("lp-")[1]}e.$Wq=p,e.$Xq=(0,C.$Qh)("languagePackService");let w=class extends R.$Sc{constructor(k){super(),this.c=k}async getAvailableLanguages(){const k=new y.$Yd;setTimeout(()=>k.cancel(),1e3);let v;try{v=await this.c.query({text:'category:"language packs"',pageSize:20},k.token)}catch{return[]}const b=v.firstPage.filter(m=>m.properties.localizedLanguages?.length&&m.tags.some(d=>d.startsWith("lp-"))).map(m=>{const d=m.properties.localizedLanguages?.[0],h=p(m);return{...this.f(h,d,m),extensionId:m.identifier.id,galleryExtension:m}});return b.push(this.f("en","English")),b}f(k,v,u){const b=v??k;let m;if(b!==k&&(m=`(${k})`),k.toLowerCase()===r.$q.toLowerCase()&&(m??(m=""),m+=(0,L.localize)(0,null)),u?.installCount){m??(m="");const d=u.installCount;let h;d>1e6?h=`${Math.floor(d/1e5)/10}M`:d>1e3?h=`${Math.floor(d/1e3)}K`:h=String(d),m+=` $(cloud-download) ${h}`}return{id:k,label:b,description:m}}};e.$Yq=w,e.$Yq=w=Re([Ae(0,I.$co)],w)}),define(be[13],we([1,0,40,5,62,2,26,3,19,8,4,67,6]),function(ue,e,y,R,r,L,I,C,p,w,A,k,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pj=e.$oj=e.$nj=e.$mj=e.$lj=e.$kj=e.$jj=e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.log=e.$bj=e.LogLevel=e.$aj=e.$_i=e.$$i=void 0,e.$$i=(0,v.$Qh)("logService"),e.$_i=(0,v.$Qh)("loggerService");function u(){return new Date().toISOString()}function b(D){return(0,w.$Df)(D)}e.$aj=b;var m;(function(D){D[D.Off=0]="Off",D[D.Trace=1]="Trace",D[D.Debug=2]="Debug",D[D.Info=3]="Info",D[D.Warning=4]="Warning",D[D.Error=5]="Error"})(m||(e.LogLevel=m={})),e.$bj=m.Info;function d(D,E,P){switch(E){case m.Trace:D.trace(P);break;case m.Debug:D.debug(P);break;case m.Info:D.info(P);break;case m.Warning:D.warn(P);break;case m.Error:D.error(P);break;case m.Off:break;default:throw new Error(`Invalid log level ${E}`)}}e.log=d;function h(D,E=!1){let P="";for(let M=0;M<D.length;M++){let ee=D[M];if(ee instanceof Error&&(ee=(0,y.$Bi)(ee,E)),typeof ee=="object")try{ee=JSON.stringify(ee)}catch{}P+=(M>0?" ":"")+ee}return P}class g extends L.$Sc{constructor(){super(...arguments),this.b=e.$bj,this.c=this.B(new R.$Od),this.onDidChangeLogLevel=this.c.event}setLevel(E){this.b!==E&&(this.b=E,this.c.fire(this.b))}getLevel(){return this.b}f(E){return this.b!==m.Off&&this.b<=E}}e.$dj=g;class l extends g{constructor(E){super(),this.h=E}f(E){return this.h||super.f(E)}trace(E,...P){this.f(m.Trace)&&this.g(m.Trace,h([E,...P],!0))}debug(E,...P){this.f(m.Debug)&&this.g(m.Debug,h([E,...P]))}info(E,...P){this.f(m.Info)&&this.g(m.Info,h([E,...P]))}warn(E,...P){this.f(m.Warning)&&this.g(m.Warning,h([E,...P]))}error(E,...P){if(this.f(m.Error))if(E instanceof Error){const M=Array.prototype.slice.call(arguments);M[0]=E.stack,this.g(m.Error,h(M))}else this.g(m.Error,h([E,...P]))}flush(){}}e.$ej=l;class $ extends g{constructor(E=e.$bj){super(),this.setLevel(E),this.g=!C.$d}trace(E,...P){this.f(m.Trace)&&(this.g?console.log(`\x1B[90m[main ${u()}]\x1B[0m`,E,...P):console.log(`[main ${u()}]`,E,...P))}debug(E,...P){this.f(m.Debug)&&(this.g?console.log(`\x1B[90m[main ${u()}]\x1B[0m`,E,...P):console.log(`[main ${u()}]`,E,...P))}info(E,...P){this.f(m.Info)&&(this.g?console.log(`\x1B[90m[main ${u()}]\x1B[0m`,E,...P):console.log(`[main ${u()}]`,E,...P))}warn(E,...P){this.f(m.Warning)&&(this.g?console.warn(`\x1B[93m[main ${u()}]\x1B[0m`,E,...P):console.warn(`[main ${u()}]`,E,...P))}error(E,...P){this.f(m.Error)&&(this.g?console.error(`\x1B[91m[main ${u()}]\x1B[0m`,E,...P):console.error(`[main ${u()}]`,E,...P))}dispose(){}flush(){}}e.$fj=$;class c extends g{constructor(E=e.$bj,P=!0){super(),this.g=P,this.setLevel(E)}trace(E,...P){this.f(m.Trace)&&(this.g?console.log("%cTRACE","color: #888",E,...P):console.log(E,...P))}debug(E,...P){this.f(m.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",E,...P):console.log(E,...P))}info(E,...P){this.f(m.Info)&&(this.g?console.log("%c INFO","color: #33f",E,...P):console.log(E,...P))}warn(E,...P){this.f(m.Warning)&&(this.g?console.log("%c WARN","color: #993",E,...P):console.log(E,...P))}error(E,...P){this.f(m.Error)&&(this.g?console.log("%c  ERR","color: #f33",E,...P):console.error(E,...P))}dispose(){}flush(){}}e.$gj=c;class n extends g{constructor(E,P=e.$bj){super(),this.g=E,this.setLevel(P)}trace(E,...P){this.f(m.Trace)&&this.g.log(m.Trace,[this.h(E),...P])}debug(E,...P){this.f(m.Debug)&&this.g.log(m.Debug,[this.h(E),...P])}info(E,...P){this.f(m.Info)&&this.g.log(m.Info,[this.h(E),...P])}warn(E,...P){this.f(m.Warning)&&this.g.log(m.Warning,[this.h(E),...P])}error(E,...P){this.f(m.Error)&&this.g.log(m.Error,[this.h(E),...P])}h(E){return typeof E=="string"?E:(0,y.$Bi)(E,this.f(m.Trace))}dispose(){}flush(){}}e.$hj=n;class i extends g{constructor(E){super(),this.g=E,E.length&&this.setLevel(E[0].getLevel())}setLevel(E){for(const P of this.g)P.setLevel(E);super.setLevel(E)}trace(E,...P){for(const M of this.g)M.trace(E,...P)}debug(E,...P){for(const M of this.g)M.debug(E,...P)}info(E,...P){for(const M of this.g)M.info(E,...P)}warn(E,...P){for(const M of this.g)M.warn(E,...P)}error(E,...P){for(const M of this.g)M.error(E,...P)}flush(){for(const E of this.g)E.flush()}dispose(){for(const E of this.g)E.dispose()}}e.$ij=i;class o extends L.$Sc{constructor(E,P,M){if(super(),this.h=E,this.j=P,this.b=new I.$Ac,this.c=this.B(new R.$Od),this.onDidChangeLoggers=this.c.event,this.f=this.B(new R.$Od),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new R.$Od),this.onDidChangeVisibility=this.g.event,M)for(const ee of M)this.b.set(ee.resource,{logger:void 0,info:ee})}m(E){return(0,w.$zf)(E)?[...this.b.values()].find(P=>P.info.id===E):this.b.get(E)}getLogger(E){return this.m(E)?.logger}createLogger(E,P){const M=this.n(E),ee=(0,w.$zf)(E)?E:P?.id??(0,r.$Ei)(M.toString()).toString(16);let se=this.b.get(M)?.logger;const G=P?.logLevel==="always"?m.Trace:P?.logLevel;se||(se=this.s(M,G??this.getLogLevel(M)??this.h,{...P,id:ee}));const ne={logger:se,info:{resource:M,id:ee,logLevel:G,name:P?.name,hidden:P?.hidden,extensionId:P?.extensionId,when:P?.when}};return this.registerLogger(ne.info),this.b.set(M,ne),se}n(E){return(0,w.$zf)(E)?(0,p.$wg)(this.j,`${E}.log`):E}setLogLevel(E,P){if(A.URI.isUri(E)){const M=E,ee=P,se=this.b.get(M);se&&ee!==se.info.logLevel&&(se.info.logLevel=ee===this.h?void 0:ee,se.logger?.setLevel(ee),this.b.set(se.info.resource,se),this.f.fire([M,ee]))}else{this.h=E;for(const[M,ee]of this.b.entries())this.b.get(M)?.info.logLevel===void 0&&ee.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(E,P){const M=this.m(E);M&&P!==!M.info.hidden&&(M.info.hidden=!P,this.b.set(M.info.resource,M),this.g.fire([M.info.resource,P]))}getLogLevel(E){let P;return E&&(P=this.b.get(E)?.info.logLevel),P??this.h}registerLogger(E){const P=this.b.get(E.resource);P?P.info.hidden!==E.hidden&&this.setVisibility(E.resource,!E.hidden):(this.b.set(E.resource,{info:E,logger:void 0}),this.c.fire({added:[E],removed:[]}))}deregisterLogger(E){const P=this.b.get(E);P&&(P.logger&&P.logger.dispose(),this.b.delete(E),this.c.fire({added:[],removed:[P.info]}))}*getRegisteredLoggers(){for(const E of this.b.values())yield E.info}getRegisteredLogger(E){return this.b.get(E)?.info}dispose(){this.b.forEach(E=>E.logger?.dispose()),this.b.clear(),super.dispose()}}e.$jj=o;class s{constructor(){this.onDidChangeLogLevel=new R.$Od().event}setLevel(E){}getLevel(){return m.Info}trace(E,...P){}debug(E,...P){}info(E,...P){}warn(E,...P){}error(E,...P){}critical(E,...P){}dispose(){}flush(){}}e.$kj=s;class t extends s{}e.$lj=t;function a(D){if(D.verbose)return m.Trace;if(typeof D.logLevel=="string"){const E=S(D.logLevel.toLowerCase());if(E!==void 0)return E}return e.$bj}e.$mj=a;function f(D){switch(D){case m.Trace:return"trace";case m.Debug:return"debug";case m.Info:return"info";case m.Warning:return"warn";case m.Error:return"error";case m.Off:return"off"}}e.$nj=f;function S(D){switch(D){case"trace":return m.Trace;case"debug":return m.Debug;case"info":return m.Info;case"warn":return m.Warning;case"error":return m.Error;case"critical":return m.Error;case"off":return m.Off}}e.$oj=S,e.$pj=new k.$8i("logLevel",f(m.Info))}),define(be[223],we([1,0,18,14,11,5,2,7,54,13]),function(ue,e,y,R,r,L,I,C,p,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2p=void 0;class A extends I.$Sc{constructor(v,u){super(),this.a=v,this.b=u,this.c=this.B(new L.$Od),this.onDidChangeFile=this.c.event,this.g=this.B(new L.$Od),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new R.$Sg(0)),this.w=[],this.y=this.B(new R.$Sg(0))}watch(v,u){return u.recursive||this.b?.watcher?.forceUniversal?this.n(v,u):this.z(v,u)}n(v,u){const b={path:this.H(v),excludes:u.excludes,includes:u.includes,recursive:u.recursive,correlationId:u.correlationId},m=(0,y.$Ub)(this.j,b);return this.r(),(0,I.$Qc)(()=>{m(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(v=>(0,r.$1)(v))}s(){this.h||(this.h=this.B(this.t(u=>this.c.fire((0,p.$Xp)(u)),u=>this.G(u),this.a.getLevel()===w.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===w.LogLevel.Trace)})));const v=this.b?.watcher?.recursive?.usePolling;if(v===!0)for(const u of this.j)(0,p.$Tp)(u)&&(u.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(v))for(const u of this.j)(0,p.$Tp)(u)&&v.includes(u.path)&&(u.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(v,u){const b={path:this.H(v),excludes:u.excludes,includes:u.includes,recursive:!1,correlationId:u.correlationId},m=(0,y.$Ub)(this.w,b);return this.C(),(0,I.$Qc)(()=>{m(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(v=>(0,r.$1)(v))}D(){return this.u||(this.u=this.B(this.F(v=>this.c.fire((0,p.$Xp)(v)),v=>this.G(v),this.a.getLevel()===w.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===w.LogLevel.Trace)}))),this.u.watch(this.w)}G(v){v.type==="error"&&this.g.fire(v.message),this.a[v.type](v.message)}H(v){return(0,C.$hc)(v.fsPath)}}e.$2p=A}),define(be[112],we([1,0,18,14,15,20,5,62,47,2,64,12,41,19,48,185,16,110,13,11]),function(ue,e,y,R,r,L,I,C,p,w,A,k,v,u,b,m,d,h,g,l){"use strict";var $;Object.defineProperty(e,"__esModule",{value:!0}),e.$Sp=void 0;let c=$=class extends w.$Sc{constructor(i){super(),this.b=i,this.a=256*1024,this.c=this.B(new I.$Od),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new I.$Od),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new I.$Od),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new I.$Od),this.onDidRunOperation=this.r.event,this.X=this.B(new I.$Od),this.Y=this.B(new I.$Od),this.onDidFilesChange=this.Y.event,this.Z=this.B(new I.$Od),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new R.$4g)}registerProvider(i,o){if(this.h.has(i))throw new Error(`A filesystem provider for the scheme '${i}' is already registered.`);(0,v.mark)(`code/registerFilesystem/${i}`);const s=new w.$Rc;return this.h.set(i,o),this.c.fire({added:!0,scheme:i,provider:o}),s.add(o.onDidChangeFile(t=>{const a=new d.$sk(t,!this.S(o));this.X.fire(a),a.hasCorrelation()||this.Y.fire(a)})),typeof o.onDidWatchError=="function"&&s.add(o.onDidWatchError(t=>this.Z.fire(new Error(t)))),s.add(o.onDidChangeCapabilities(()=>this.g.fire({provider:o,scheme:i}))),(0,w.$Qc)(()=>{this.c.fire({added:!1,scheme:i,provider:o}),this.h.delete(i),(0,w.$Nc)(s)})}getProvider(i){return this.h.get(i)}async activateProvider(i){const o=[];this.f.fire({scheme:i,join(s){o.push(s)}}),!this.h.has(i)&&await R.Promises.settled(o)}async canHandleResource(i){return await this.activateProvider(i.scheme),this.hasProvider(i)}hasProvider(i){return this.h.has(i.scheme)}hasCapability(i,o){const s=this.h.get(i.scheme);return!!(s&&s.capabilities&o)}listCapabilities(){return p.Iterable.map(this.h,([i,o])=>({scheme:i,capabilities:o.capabilities}))}async j(i){if(!(0,u.$Ag)(i))throw new d.$uk((0,m.localize)(0,null,this.sb(i)),8);await this.activateProvider(i.scheme);const o=this.h.get(i.scheme);if(!o){const s=new l.$bb;throw s.message=(0,m.localize)(1,null,i.toString()),s}return o}async m(i){const o=await this.j(i);if((0,d.$fk)(o)||(0,d.$ck)(o)||(0,d.$gk)(o))return o;throw new Error(`Filesystem provider for scheme '${i.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(i){const o=await this.j(i);if((0,d.$fk)(o)||(0,d.$ck)(o))return o;throw new Error(`Filesystem provider for scheme '${i.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(i,o){try{return await this.s(i,o)}catch(s){throw(0,d.$pk)(s)===d.FileSystemProviderErrorCode.FileNotFound?new d.$uk((0,m.localize)(2,null,this.sb(i)),1):(0,d.$nk)(s)}}async s(i,o){const s=await this.j(i),t=this.S(s),a=o?.resolveTo,f=o?.resolveSingleChildDescendants,S=o?.resolveMetadata,D=await s.stat(i);let E;return this.t(s,i,D,void 0,!!S,(P,M)=>(E||(E=A.$Wh.forUris(()=>!t),E.set(i,!0),a&&E.fill(!0,a)),E.get(P.resource)||E.findSuperstr(P.resource.with({query:null,fragment:null}))?!0:P.isDirectory&&f?M===1:!1))}async t(i,o,s,t,a,f){const{providerExtUri:S}=this.R(i),D={resource:o,name:S.basename(o),isFile:(s.type&d.FileType.File)!==0,isDirectory:(s.type&d.FileType.Directory)!==0,isSymbolicLink:(s.type&d.FileType.SymbolicLink)!==0,mtime:s.mtime,ctime:s.ctime,size:s.size,readonly:!!((s.permissions??0)&d.FilePermission.Readonly)||!!(i.capabilities&2048),locked:!!((s.permissions??0)&d.FilePermission.Locked),etag:(0,d.$Fk)({mtime:s.mtime,size:s.size}),children:void 0};if(D.isDirectory&&f(D,t)){try{const E=await i.readdir(o),P=await R.Promises.settled(E.map(async([M,ee])=>{try{const se=S.joinPath(o,M),G=a?await i.stat(se):{type:ee};return await this.t(i,se,G,E.length,a,f)}catch(se){return this.b.trace(se),null}}));D.children=(0,y.$Hb)(P)}catch(E){this.b.trace(E),D.children=[]}return D}return D}async resolveAll(i){return R.Promises.settled(i.map(async o=>{try{return{stat:await this.s(o.resource,o.options),success:!0}}catch(s){return this.b.trace(s),{stat:void 0,success:!1}}}))}async stat(i){const o=await this.j(i),s=await o.stat(i);return this.t(o,i,s,void 0,!0,()=>!1)}async exists(i){const o=await this.j(i);try{return!!await o.stat(i)}catch{return!1}}async canCreateFile(i,o){try{await this.u(i,o)}catch(s){return s}return!0}async u(i,o){if(!o?.overwrite&&await this.exists(i))throw new d.$uk((0,m.localize)(3,null,this.sb(i)),3,o)}async createFile(i,o=r.$ce.fromString(""),s){await this.u(i,s);const t=await this.writeFile(i,o);return this.r.fire(new d.$rk(i,0,t)),t}async writeFile(i,o,s){const t=this.qb(await this.n(i),i),{providerExtUri:a}=this.R(t);let f=s;if((0,d.$ik)(t)&&!f?.atomic){const S=t.enforceAtomicWriteFile?.(i);S&&(f={...s,atomic:S})}try{await this.w(t,i,f)||await this.U(t,a.dirname(i));let D;if((0,d.$ck)(t)&&!(o instanceof r.$ce))if((0,b.$1d)(o)){const E=await(0,b.$8d)(o,3);E.ended?D=r.$ce.concat(E.buffer):D=E}else D=(0,b.$5d)(o,E=>r.$ce.concat(E),3);else D=o;!(0,d.$fk)(t)||(0,d.$ck)(t)&&D instanceof r.$ce||(0,d.$ck)(t)&&(0,d.$ik)(t)&&f?.atomic?await this.hb(t,i,f,D):await this.db(t,i,f,D instanceof r.$ce?(0,r.$ne)(D):D),this.r.fire(new d.$rk(i,4))}catch(S){throw new d.$uk((0,m.localize)(4,null,this.sb(i),(0,d.$nk)(S).toString()),(0,d.$qk)(S),f)}return this.resolve(i,{resolveMetadata:!0})}async w(i,o,s){const t=!!s?.unlock;if(t&&!(i.capabilities&8192))throw new Error((0,m.localize)(5,null,this.sb(o)));if(!!s?.atomic){if(!(i.capabilities&32768))throw new Error((0,m.localize)(6,null,this.sb(o)));if(!(i.capabilities&2))throw new Error((0,m.localize)(7,null,this.sb(o)));if(t)throw new Error((0,m.localize)(8,null,this.sb(o)))}let f;try{f=await i.stat(o)}catch{return}if(f.type&d.FileType.Directory)throw new d.$uk((0,m.localize)(9,null,this.sb(o)),0,s);if(this.rb(o,f),typeof s?.mtime=="number"&&typeof s.etag=="string"&&s.etag!==d.$Ek&&typeof f.mtime=="number"&&typeof f.size=="number"&&s.mtime<f.mtime&&s.etag!==(0,d.$Fk)({mtime:s.mtime,size:f.size}))throw new d.$uk((0,m.localize)(10,null),3,s);return f}async readFile(i,o,s){const t=await this.m(i);return o?.atomic?this.z(t,i,o,s):this.C(t,i,o,s)}async z(i,o,s,t){return new Promise((a,f)=>{this.cb.queueFor(o,this.R(i).providerExtUri).queue(async()=>{try{const S=await this.C(i,o,s,t);a(S)}catch(S){f(S)}})})}async C(i,o,s,t){const a=await this.D(i,o,{...s,preferUnbuffered:!0},t);return{...a,value:await(0,r.$oe)(a.value)}}async readFileStream(i,o,s){const t=await this.m(i);return this.D(t,i,o,s)}async D(i,o,s,t){const a=new L.$Yd(t);let f=s;(0,d.$hk)(i)&&i.enforceAtomicReadFile?.(o)&&(f={...s,atomic:!0});const S=this.J(o,f).then(E=>E,E=>{throw a.dispose(!0),E});let D;try{return typeof f?.etag=="string"&&f.etag!==d.$Ek&&await S,f?.atomic&&(0,d.$hk)(i)||!((0,d.$fk)(i)||(0,d.$gk)(i))||(0,d.$ck)(i)&&f?.preferUnbuffered?D=this.I(i,o,f):(0,d.$gk)(i)?D=this.G(i,o,a.token,f):D=this.H(i,o,a.token,f),D.on("end",()=>a.dispose()),D.on("error",()=>a.dispose()),{...await S,value:D}}catch(E){throw D&&await(0,b.$6d)(D),this.F(E,o,f)}}F(i,o,s){const t=(0,m.localize)(11,null,this.sb(o),(0,d.$nk)(i).toString());return i instanceof d.$wk?new d.$wk(t,i.stat,s):i instanceof d.$vk?new d.$vk(t,i.fileOperationResult,i.size,i.options):new d.$uk(t,(0,d.$qk)(i),s)}G(i,o,s,t=Object.create(null)){const a=i.readFileStream(o,t,s);return(0,b.$_d)(a,{data:f=>f instanceof r.$ce?f:r.$ce.wrap(f),error:f=>this.F(f,o,t)},f=>r.$ce.concat(f))}H(i,o,s,t=Object.create(null)){const a=(0,r.$se)();return(0,h.$Rp)(i,o,a,f=>f,{...t,bufferSize:this.a,errorTransformer:f=>this.F(f,o,t)},s),a}I(i,o,s){const t=(0,b.$3d)(a=>r.$ce.concat(a));return(async()=>{try{let a;s?.atomic&&(0,d.$hk)(i)?a=await i.readFile(o,{atomic:!0}):a=await i.readFile(o),typeof s?.position=="number"&&(a=a.slice(s.position)),typeof s?.length=="number"&&(a=a.slice(0,s.length)),this.L(o,a.byteLength,s),t.end(r.$ce.wrap(a))}catch(a){t.error(a),t.end()}})(),t}async J(i,o){const s=await this.resolve(i,{resolveMetadata:!0});if(s.isDirectory)throw new d.$uk((0,m.localize)(12,null,this.sb(i)),0,o);if(typeof o?.etag=="string"&&o.etag!==d.$Ek&&o.etag===s.etag)throw new d.$wk((0,m.localize)(13,null),s,o);return this.L(i,s.size,o),s}L(i,o,s){if(typeof s?.limits?.size=="number"&&o>s.limits.size)throw new d.$vk((0,m.localize)(14,null,this.sb(i)),7,o,s)}async canMove(i,o,s){return this.M(i,o,"move",s)}async canCopy(i,o,s){return this.M(i,o,"copy",s)}async M(i,o,s,t){if(i.toString()!==o.toString())try{const a=s==="move"?this.qb(await this.n(i),i):await this.m(i),f=this.qb(await this.n(o),o);await this.Q(a,i,f,o,s,t)}catch(a){return a}return!0}async move(i,o,s){const t=this.qb(await this.n(i),i),a=this.qb(await this.n(o),o),f=await this.N(t,i,a,o,"move",!!s),S=await this.resolve(o,{resolveMetadata:!0});return this.r.fire(new d.$rk(i,f==="move"?2:3,S)),S}async copy(i,o,s){const t=await this.m(i),a=this.qb(await this.n(o),o),f=await this.N(t,i,a,o,"copy",!!s),S=await this.resolve(o,{resolveMetadata:!0});return this.r.fire(new d.$rk(i,f==="copy"?3:2,S)),S}async N(i,o,s,t,a,f){if(o.toString()===t.toString())return a;const{exists:S,isSameResourceWithDifferentPathCase:D}=await this.Q(i,o,s,t,a,f);if(S&&!D&&f&&await this.del(t,{recursive:!0}),await this.U(s,this.R(s).providerExtUri.dirname(t)),a==="copy"){if(i===s&&(0,d.$dk)(i))await i.copy(o,t,{overwrite:f});else{const E=await this.resolve(o);E.isDirectory?await this.P(i,E,s,t):await this.O(i,o,s,t)}return a}else return i===s?(await i.rename(o,t,{overwrite:f}),a):(await this.N(i,o,s,t,"copy",f),await this.del(o,{recursive:!0}),"copy")}async O(i,o,s,t){if((0,d.$fk)(i)&&(0,d.$fk)(s))return this.jb(i,o,s,t);if((0,d.$fk)(i)&&(0,d.$ck)(s))return this.pb(i,o,s,t);if((0,d.$ck)(i)&&(0,d.$fk)(s))return this.nb(i,o,s,t);if((0,d.$ck)(i)&&(0,d.$ck)(s))return this.lb(i,o,s,t)}async P(i,o,s,t){await s.mkdir(t),Array.isArray(o.children)&&await R.Promises.settled(o.children.map(async a=>{const f=this.R(s).providerExtUri.joinPath(t,a.name);return a.isDirectory?this.P(i,await this.resolve(a.resource),s,f):this.O(i,a.resource,s,f)}))}async Q(i,o,s,t,a,f){let S=!1;if(i===s){const{providerExtUri:E,isPathCaseSensitive:P}=this.R(i);if(P||(S=E.isEqual(o,t)),S&&a==="copy")throw new Error((0,m.localize)(15,null,this.sb(o),this.sb(t)));if(!S&&E.isEqualOrParent(t,o))throw new Error((0,m.localize)(16,null,this.sb(o),this.sb(t)))}const D=await this.exists(t);if(D&&!S){if(!f)throw new d.$uk((0,m.localize)(17,null,this.sb(o),this.sb(t)),4);if(i===s){const{providerExtUri:E}=this.R(i);if(E.isEqualOrParent(o,t))throw new Error((0,m.localize)(18,null,this.sb(o),this.sb(t)))}}return{exists:D,isSameResourceWithDifferentPathCase:S}}R(i){const o=this.S(i);return{providerExtUri:o?u.$mg:u.$og,isPathCaseSensitive:o}}S(i){return!!(i.capabilities&1024)}async createFolder(i){const o=this.qb(await this.j(i),i);await this.U(o,i);const s=await this.resolve(i,{resolveMetadata:!0});return this.r.fire(new d.$rk(i,0,s)),s}async U(i,o){const s=[],{providerExtUri:t}=this.R(i);for(;!t.isEqual(o,t.dirname(o));)try{if(!((await i.stat(o)).type&d.FileType.Directory))throw new Error((0,m.localize)(19,null,this.sb(o)));break}catch(a){if((0,d.$pk)(a)!==d.FileSystemProviderErrorCode.FileNotFound)throw a;s.push(t.basename(o)),o=t.dirname(o)}for(let a=s.length-1;a>=0;a--){o=t.joinPath(o,s[a]);try{await i.mkdir(o)}catch(f){if((0,d.$pk)(f)!==d.FileSystemProviderErrorCode.FileExists)throw f}}}async canDelete(i,o){try{await this.W(i,o)}catch(s){return s}return!0}async W(i,o){const s=this.qb(await this.j(i),i),t=!!o?.useTrash;if(t&&!(s.capabilities&4096))throw new Error((0,m.localize)(20,null,this.sb(i)));const a=o?.atomic;if(a&&!(s.capabilities&65536))throw new Error((0,m.localize)(21,null,this.sb(i)));if(t&&a)throw new Error((0,m.localize)(22,null,this.sb(i)));let f;try{f=await s.stat(i)}catch{}if(f)this.rb(i,f);else throw new d.$uk((0,m.localize)(23,null,this.sb(i)),1);if(!!!o?.recursive){const D=await this.resolve(i);if(D.isDirectory&&Array.isArray(D.children)&&D.children.length>0)throw new Error((0,m.localize)(24,null,this.sb(i)))}return s}async del(i,o){const s=await this.W(i,o);let t=o;if((0,d.$jk)(s)&&!t?.atomic){const D=s.enforceAtomicDelete?.(i);D&&(t={...o,atomic:D})}const a=!!t?.useTrash,f=!!t?.recursive,S=t?.atomic??!1;await s.delete(i,{recursive:f,useTrash:a,atomic:S}),this.r.fire(new d.$rk(i,1))}async cloneFile(i,o){const s=await this.j(i),t=this.qb(await this.n(o),o);if(s===t&&this.R(s).providerExtUri.isEqual(i,o))return;if(s===t&&(0,d.$ek)(s))return s.cloneFile(i,o);await this.U(t,this.R(t).providerExtUri.dirname(o));const a=this.cb.queueFor(i,this.R(s).providerExtUri);return s===t&&(0,d.$dk)(s)?a.queue(()=>s.copy(i,o,{overwrite:!0})):a.queue(()=>this.O(s,i,t,o))}createWatcher(i,o){return this.watch(i,{...o,correlationId:$.ab++})}watch(i,o={recursive:!1,excludes:[]}){const s=new w.$Rc;let t=!1,a=()=>{t=!0};s.add((0,w.$Qc)(()=>a())),(async()=>{try{const S=await this.bb(i,o);t?(0,w.$Nc)(S):a=()=>(0,w.$Nc)(S)}catch(S){this.b.error(S)}})();const f=o.correlationId;if(typeof f=="number"){const S=s.add(new I.$Od);return s.add(this.X.event(E=>{E.correlates(f)&&S.fire(E)})),{onDidChange:S.event,dispose:()=>s.dispose()}}return s}async bb(i,o){const s=await this.j(i),t=(0,C.$Ei)([this.R(s).providerExtUri.getComparisonKey(i),o]);let a=this.$.get(t);return a||(a={count:0,disposable:s.watch(i,o)},this.$.set(t,a)),a.count+=1,(0,w.$Qc)(()=>{a&&(a.count--,a.count===0&&((0,w.$Nc)(a.disposable),this.$.delete(t)))})}dispose(){super.dispose();for(const[,i]of this.$)(0,w.$Nc)(i.disposable);this.$.clear()}async db(i,o,s,t){return this.cb.queueFor(o,this.R(i).providerExtUri).queue(async()=>{const a=await i.open(o,{create:!0,unlock:s?.unlock??!1});try{(0,b.$1d)(t)||(0,b.$2d)(t)?await this.eb(i,a,t):await this.fb(i,a,t)}catch(f){throw(0,d.$nk)(f)}finally{await i.close(a)}})}async eb(i,o,s){let t=0,a;if((0,b.$2d)(s)){if(s.buffer.length>0){const f=r.$ce.concat(s.buffer);await this.gb(i,o,f,f.byteLength,t,0),t+=f.byteLength}if(s.ended)return;a=s.stream}else a=s;return new Promise((f,S)=>{(0,b.$7d)(a,{onData:async D=>{a.pause();try{await this.gb(i,o,D,D.byteLength,t,0)}catch(E){return S(E)}t+=D.byteLength,setTimeout(()=>a.resume())},onError:D=>S(D),onEnd:()=>f()})})}async fb(i,o,s){let t=0,a;for(;(a=s.read())!==null;)await this.gb(i,o,a,a.byteLength,t,0),t+=a.byteLength}async gb(i,o,s,t,a,f){let S=0;for(;S<t;){const D=await i.write(o,a+S,s.buffer,f+S,t-S);S+=D}}async hb(i,o,s,t){return this.cb.queueFor(o,this.R(i).providerExtUri).queue(()=>this.ib(i,o,s,t))}async ib(i,o,s,t){let a;t instanceof r.$ce?a=t:(0,b.$1d)(t)?a=await(0,r.$oe)(t):(0,b.$2d)(t)?a=await(0,r.$pe)(t):a=(0,r.$me)(t),await i.writeFile(o,a.buffer,{create:!0,overwrite:!0,unlock:s?.unlock??!1,atomic:s?.atomic??!1})}async jb(i,o,s,t){return this.cb.queueFor(t,this.R(s).providerExtUri).queue(()=>this.kb(i,o,s,t))}async kb(i,o,s,t){let a,f;try{a=await i.open(o,{create:!1}),f=await s.open(t,{create:!0,unlock:!1});const S=r.$ce.alloc(this.a);let D=0,E=0,P=0;do P=await i.read(a,D,S.buffer,E,S.byteLength-E),await this.gb(s,f,S,P,D,E),D+=P,E+=P,E===S.byteLength&&(E=0);while(P>0)}catch(S){throw(0,d.$nk)(S)}finally{await R.Promises.settled([typeof a=="number"?i.close(a):Promise.resolve(),typeof f=="number"?s.close(f):Promise.resolve()])}}async lb(i,o,s,t){return this.cb.queueFor(t,this.R(s).providerExtUri).queue(()=>this.mb(i,o,s,t))}async mb(i,o,s,t){return s.writeFile(t,await i.readFile(o),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(i,o,s,t){return this.cb.queueFor(t,this.R(s).providerExtUri).queue(()=>this.ob(i,o,s,t))}async ob(i,o,s,t){const a=await s.open(t,{create:!0,unlock:!1});try{const f=await i.readFile(o);await this.gb(s,a,r.$ce.wrap(f),f.byteLength,0,0)}catch(f){throw(0,d.$nk)(f)}finally{await s.close(a)}}async pb(i,o,s,t){const a=await(0,r.$oe)(this.H(i,o,L.CancellationToken.None));await this.hb(s,t,void 0,a)}qb(i,o){if(i.capabilities&2048)throw new d.$uk((0,m.localize)(25,null,this.sb(o)),6);return i}rb(i,o){if((o.permissions??0)&d.FilePermission.Readonly)throw new d.$uk((0,m.localize)(26,null,this.sb(i)),6)}sb(i){return i.scheme===k.Schemas.file?i.fsPath:i.toString(!0)}};e.$Sp=c,c.ab=0,e.$Sp=c=$=Re([Ae(0,g.$$i)],c)}),define(be[68],we([1,0,29,301,14,26,15,5,39,2,7,3,19,48,21,188,16,110,223,40,221,220]),function(ue,e,y,R,r,L,I,C,p,w,A,k,v,u,b,m,d,h,g,l,$,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fq=void 0,(()=>{try{(0,R.gracefulify)(y)}catch(i){console.error(`Error enabling graceful-fs: ${(0,l.$Bi)(i)}`)}})();class n extends g.$2p{constructor(o,s){super(o,s),this.onDidChangeCapabilities=C.Event.None,this.N=new L.$Ac(t=>v.$ng.getComparisonKey(t)),this.U=new Map,this.W=new Map,this.X=new Map}get capabilities(){return this.J||(this.J=253982,k.$f&&(this.J|=1024)),this.J}async stat(o){try{const{stat:s,symbolicLink:t}=await b.SymlinkSupport.stat(this.H(o));return{type:this.M(s,t),ctime:s.birthtime.getTime(),mtime:s.mtime.getTime(),size:s.size,permissions:s.mode&128?void 0:d.FilePermission.Locked}}catch(s){throw this.fb(s)}}async L(o){try{return await this.stat(o)}catch{return}}async readdir(o){try{const s=await b.Promises.readdir(this.H(o),{withFileTypes:!0}),t=[];return await Promise.all(s.map(async a=>{try{let f;a.isSymbolicLink()?f=(await this.stat((0,v.$wg)(o,a.name))).type:f=this.M(a),t.push([a.name,f])}catch(f){this.a.trace(f)}})),t}catch(s){throw this.fb(s)}}M(o,s){let t;return s?.dangling?t=d.FileType.Unknown:o.isFile()?t=d.FileType.File:o.isDirectory()?t=d.FileType.Directory:t=d.FileType.Unknown,s&&(t|=d.FileType.SymbolicLink),t}async O(o){const s=this.H(o);this.P(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${s})`);let t;for(;t=this.N.get(o);)this.P(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${s})`),await t.wait();const a=new r.$Tg;return this.N.set(o,a),this.P(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${s})`),(0,w.$Qc)(()=>{this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${s})`),this.N.get(o)===a&&(this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${s})`),this.N.delete(o)),this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${s})`),a.open()})}async readFile(o,s){let t;try{s?.atomic&&(this.P(`[Disk FileSystemProvider]: atomic read operation started (${this.H(o)})`),t=await this.O(o));const a=this.H(o);return await b.Promises.readFile(a)}catch(a){throw this.fb(a)}finally{t?.dispose()}}P(o){n.I&&this.a.trace(o)}readFileStream(o,s,t){const a=(0,u.$3d)(f=>I.$ce.concat(f.map(S=>I.$ce.wrap(S))).buffer);return(0,h.$Rp)(this,o,a,f=>f.buffer,{...s,bufferSize:256*1024},t),a}async writeFile(o,s,t){return t?.atomic!==!1&&t?.atomic?.postfix&&await this.Q(o)?this.R(o,(0,v.$wg)((0,v.$vg)(o),`${(0,v.$tg)(o)}${t.atomic.postfix}`),s,t):this.S(o,s,t)}async Q(o){try{const s=this.H(o),{symbolicLink:t}=await b.SymlinkSupport.stat(s);if(t)return!1}catch{}return!0}async R(o,s,t,a){const f=new w.$Rc;try{f.add(await this.O(o)),f.add(await this.O(s)),await this.S(s,t,a,!0);try{await this.rename(s,o,{overwrite:!0})}catch(S){try{await this.delete(s,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw S}}finally{f.dispose()}}async S(o,s,t,a){let f;try{const S=this.H(o);if(!t.create||!t.overwrite){if(await b.Promises.exists(S)){if(!t.overwrite)throw(0,d.$mk)((0,m.localize)(0,null),d.FileSystemProviderErrorCode.FileExists)}else if(!t.create)throw(0,d.$mk)((0,m.localize)(1,null),d.FileSystemProviderErrorCode.FileNotFound)}f=await this.open(o,{create:!0,unlock:t.unlock},a),await this.write(f,0,s,0,s.byteLength)}catch(S){throw await this.gb(o,S)}finally{typeof f=="number"&&await this.close(f)}}static configureFlushOnWrite(o){n.Y=o}async open(o,s,t){const a=this.H(o);let f;(0,d.$ak)(s)&&!t&&(f=await this.O(o));let S;try{if((0,d.$ak)(s)&&s.unlock)try{const{stat:E}=await b.SymlinkSupport.stat(a);E.mode&128||await b.Promises.chmod(a,E.mode|128)}catch(E){E.code!=="ENOENT"&&this.a.trace(E)}let D;if((0,d.$ak)(s)){if(k.$d)try{await b.Promises.truncate(a,0),D="r+"}catch(E){E.code!=="ENOENT"&&this.a.trace(E)}D||(D="w")}else D="r";S=await b.Promises.open(a,D)}catch(D){throw f?.dispose(),(0,d.$ak)(s)?await this.gb(o,D):this.fb(D)}if(this.U.set(S,0),(0,d.$ak)(s)&&this.X.set(S,o),f){const D=this.W.get(S);this.P(`[Disk FileSystemProvider]: open() - storing lock for handle ${S} (${a})`),this.W.set(S,f),D&&(this.P(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${S} (${a})`),D.dispose())}return S}async close(o){const s=this.W.get(o);try{if(this.U.delete(o),this.X.delete(o)&&n.Y)try{await b.Promises.fdatasync(o)}catch(t){n.configureFlushOnWrite(!1),this.a.error(t)}return await b.Promises.close(o)}catch(t){throw this.fb(t)}finally{s&&(this.W.get(o)===s&&(this.P(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${o}`),this.W.delete(o)),this.P(`[Disk FileSystemProvider]: close() - disposing lock for handle ${o}`),s.dispose())}}async read(o,s,t,a,f){const S=this.Z(o,s);let D=null;try{D=(await b.Promises.read(o,t,a,f,S)).bytesRead}catch(E){throw this.fb(E)}finally{this.$(o,S,D)}return D}Z(o,s){return s===this.U.get(o)?null:s}$(o,s,t){const a=this.U.get(o);typeof a=="number"&&(typeof s=="number"||(typeof t=="number"?this.U.set(o,a+t):this.U.delete(o)))}async write(o,s,t,a,f){return(0,r.$ah)(()=>this.ab(o,s,t,a,f),100,3)}async ab(o,s,t,a,f){const S=this.Z(o,s);let D=null;try{D=(await b.Promises.write(o,t,a,f,S)).bytesWritten}catch(E){throw await this.gb(this.X.get(o),E)}finally{this.$(o,S,D)}return D}async mkdir(o){try{await b.Promises.mkdir(this.H(o))}catch(s){throw this.fb(s)}}async delete(o,s){try{const t=this.H(o);if(s.recursive){let a;s?.atomic!==!1&&s.atomic.postfix&&(a=(0,A.$jc)((0,A.$mc)(t),`${(0,A.$nc)(t)}${s.atomic.postfix}`)),await b.Promises.rm(t,b.RimRafMode.MOVE,a)}else try{await b.Promises.unlink(t)}catch(a){if(a.code==="EPERM"||a.code==="EISDIR"){let f=!1;try{const{stat:S,symbolicLink:D}=await b.SymlinkSupport.stat(t);f=S.isDirectory()&&!D}catch{}if(f)await b.Promises.rmdir(t);else throw a}else throw a}}catch(t){throw this.fb(t)}}async rename(o,s,t){const a=this.H(o),f=this.H(s);if(a!==f)try{await this.bb(o,s,"move",t.overwrite),await b.Promises.rename(a,f)}catch(S){throw(S.code==="EINVAL"||S.code==="EBUSY"||S.code==="ENAMETOOLONG")&&(S=new Error((0,m.localize)(2,null,(0,A.$nc)(a),(0,A.$nc)((0,A.$mc)(f)),S.toString()))),this.fb(S)}}async copy(o,s,t){const a=this.H(o),f=this.H(s);if(a!==f)try{await this.bb(o,s,"copy",t.overwrite),await b.Promises.copy(a,f,{preserveSymlinks:!0})}catch(S){throw(S.code==="EINVAL"||S.code==="EBUSY"||S.code==="ENAMETOOLONG")&&(S=new Error((0,m.localize)(3,null,(0,A.$nc)(a),(0,A.$nc)((0,A.$mc)(f)),S.toString()))),this.fb(S)}}async bb(o,s,t,a){const f=this.H(o),S=this.H(s);let D=!1;if(!!(this.capabilities&1024)||(D=(0,p.$Xf)(f,S,!0)),D){if(t==="copy")throw(0,d.$mk)((0,m.localize)(4,null),d.FileSystemProviderErrorCode.FileExists);if(t==="move")return}const P=await this.L(o);if(!P)throw(0,d.$mk)((0,m.localize)(5,null),d.FileSystemProviderErrorCode.FileNotFound);const M=await this.L(s);if(M){if(!a)throw(0,d.$mk)((0,m.localize)(6,null),d.FileSystemProviderErrorCode.FileExists);P.type&d.FileType.File&&M.type&d.FileType.File||await this.delete(s,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(o,s){return this.cb(o,s,!1)}async cb(o,s,t){const a=this.H(o),f=this.H(s),S=!!(this.capabilities&1024);if((0,p.$Xf)(a,f,!S))return;const D=new w.$Rc;try{D.add(await this.O(o)),D.add(await this.O(s)),t&&await b.Promises.mkdir((0,A.$mc)(f),{recursive:!0}),await b.Promises.copyFile(a,f)}catch(E){if(E.code==="ENOENT"&&!t)return this.cb(o,s,!0);throw this.fb(E)}finally{D.dispose()}}t(o,s,t){return new $.$9p(a=>o(a),a=>s(a),t)}F(o,s,t){return new c.$eq(a=>o(a),a=>s(a),t)}fb(o){if(o instanceof d.$lk)return o;let s=o,t;switch(o.code){case"ENOENT":t=d.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":t=d.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":t=d.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":t=d.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":t=d.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":s=`${o.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,t=d.FileSystemProviderErrorCode.Unknown;break;default:t=d.FileSystemProviderErrorCode.Unknown}return(0,d.$mk)(s,t)}async gb(o,s){let t=this.fb(s);if(o&&t.code===d.FileSystemProviderErrorCode.NoPermissions)try{const{stat:a}=await b.SymlinkSupport.stat(this.H(o));a.mode&128||(t=(0,d.$mk)(s,d.FileSystemProviderErrorCode.FileWriteLocked))}catch(a){this.a.trace(a)}return t}}e.$fq=n,n.I=!1,n.Y=!0}),define(be[224],we([1,0,5,68,2,15,48,20]),function(ue,e,y,R,r,L,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Or=e.$Nr=void 0;class p extends r.$Sc{constructor(k,v){super(),this.a=k,this.b=v,this.F=new Map,this.G=new Map}call(k,v,u){const b=this.c(k);switch(v){case"stat":return this.g(b,u[0]);case"readdir":return this.h(b,u[0]);case"open":return this.r(b,u[0],u[1]);case"close":return this.s(u[0]);case"read":return this.t(u[0],u[1],u[2]);case"readFile":return this.j(b,u[0],u[1]);case"write":return this.u(u[0],u[1],u[2],u[3],u[4]);case"writeFile":return this.n(b,u[0],u[1],u[2]);case"rename":return this.z(b,u[0],u[1],u[2]);case"copy":return this.C(b,u[0],u[1],u[2]);case"cloneFile":return this.D(b,u[0],u[1]);case"mkdir":return this.w(b,u[0]);case"delete":return this.y(b,u[0],u[1]);case"watch":return this.I(b,u[0],u[1],u[2],u[3]);case"unwatch":return this.J(u[0],u[1])}throw new Error(`IPC Command ${v} not found`)}listen(k,v,u){const b=this.c(k);switch(v){case"fileChange":return this.H(b,u[0]);case"readFileStream":return this.m(b,u[0],u[1])}throw new Error(`Unknown event ${v}`)}g(k,v){const u=this.f(k,v,!0);return this.a.stat(u)}h(k,v){const u=this.f(k,v);return this.a.readdir(u)}async j(k,v,u){const b=this.f(k,v,!0),m=await this.a.readFile(b,u);return L.$ce.wrap(m)}m(k,v,u){const b=this.f(k,v,!0),m=new C.$Yd,d=new y.$Od({onDidRemoveLastListener:()=>{m.cancel()}}),h=this.a.readFileStream(b,u,m.token);return(0,I.$7d)(h,{onData:g=>d.fire(L.$ce.wrap(g)),onError:g=>d.fire(g),onEnd:()=>{d.fire("end"),d.dispose(),m.dispose()}}),d.event}n(k,v,u,b){const m=this.f(k,v);return this.a.writeFile(m,u.buffer,b)}r(k,v,u){const b=this.f(k,v,!0);return this.a.open(b,u)}s(k){return this.a.close(k)}async t(k,v,u){const b=L.$ce.alloc(u),m=0,d=await this.a.read(k,v,b.buffer,m,u);return[b,d]}u(k,v,u,b,m){return this.a.write(k,v,u.buffer,b,m)}w(k,v){const u=this.f(k,v);return this.a.mkdir(u)}y(k,v,u){const b=this.f(k,v);return this.a.delete(b,u)}z(k,v,u,b){const m=this.f(k,v),d=this.f(k,u);return this.a.rename(m,d,b)}C(k,v,u,b){const m=this.f(k,v),d=this.f(k,u);return this.a.copy(m,d,b)}D(k,v,u){const b=this.f(k,v),m=this.f(k,u);return this.a.cloneFile(b,m)}H(k,v){const u=new y.$Od({onWillAddFirstListener:()=>{this.F.set(v,this.L(k,u))},onDidRemoveLastListener:()=>{(0,r.$Nc)(this.F.get(v)),this.F.delete(v)}});return u.event}async I(k,v,u,b,m){const d=this.F.get(v);if(d){const h=this.f(k,b),g=d.watch(u,h,m);this.G.set(v+u,g)}}async J(k,v){const u=k+v,b=this.G.get(u);b&&((0,r.$Nc)(b),this.G.delete(u))}dispose(){super.dispose();for(const[,k]of this.G)k.dispose();this.G.clear();for(const[,k]of this.F)k.dispose();this.F.clear()}}e.$Nr=p;class w extends r.$Sc{constructor(k,v,u,b){super(),this.c=k,this.f=u,this.g=b,this.a=new Map,this.b=this.B(new R.$fq(this.f,{watcher:{recursive:this.j(this.g)}})),this.h(v)}h(k){const v=this.B(new y.$Od);this.B(v.event(u=>{k.fire(u.map(b=>({resource:this.c.transformOutgoingURI(b.resource),type:b.type,cId:b.cId})))})),this.B(this.b.onDidChangeFile(u=>v.fire(u))),this.B(this.b.onDidWatchError(u=>k.fire(u)))}j(k){}m(k){}watch(k,v,u){const b=this.m(this.g);return Array.isArray(b)&&(u.excludes=[...u.excludes,...b]),this.a.set(k,this.b.watch(v,u)),(0,r.$Qc)(()=>{(0,r.$Nc)(this.a.get(k)),this.a.delete(k)})}dispose(){for(const[,k]of this.a)k.dispose();this.a.clear(),super.dispose()}}e.$Or=w}),define(be[113],we([1,0,4,5,13,2]),function(ue,e,y,R,r,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fr=e.$er=e.$dr=void 0;class I extends r.$jj{constructor(k,v,u,b,m){super(v,u,b),this.r=k,this.t=m,this.B(m.listen("onDidChangeLogLevel",k)(d=>{(0,r.$aj)(d)?super.setLogLevel(d):super.setLogLevel(y.URI.revive(d[0]),d[1])})),this.B(m.listen("onDidChangeVisibility",k)(([d,h])=>super.setVisibility(y.URI.revive(d),h))),this.B(m.listen("onDidChangeLoggers",k)(({added:d,removed:h})=>{for(const g of d)super.registerLogger({...g,resource:y.URI.revive(g.resource)});for(const g of h)super.deregisterLogger(g.resource)}))}createConsoleMainLogger(){return new r.$hj({log:(k,v)=>{this.t.call("consoleLog",[k,v])}})}registerLogger(k){super.registerLogger(k),this.t.call("registerLogger",[k,this.r])}deregisterLogger(k){super.deregisterLogger(k),this.t.call("deregisterLogger",[k,this.r])}setLogLevel(k,v){super.setLogLevel(k,v),this.t.call("setLogLevel",[k,v])}setVisibility(k,v){super.setVisibility(k,v),this.t.call("setVisibility",[this.n(k),v])}s(k,v,u){return new C(this.t,k,v,u,this.r)}static setLogLevel(k,v,u){return k.call("setLogLevel",[v,u])}}e.$dr=I;class C extends r.$ej{constructor(k,v,u,b,m){super(b?.logLevel==="always"),this.r=k,this.s=v,this.m=!1,this.n=[],this.setLevel(u),this.r.call("createLogger",[v,b,m]).then(()=>{this.u(this.n),this.m=!0})}g(k,v){const u=[[k,v]];this.m?this.u(u):this.n.push(...u)}u(k){this.r.call("log",[this.s,k])}}class p{constructor(k,v){this.a=k,this.b=v}listen(k,v){const u=this.b(k);switch(v){case"onDidChangeLoggers":return R.Event.map(this.a.onDidChangeLoggers,b=>({added:[...b.added].map(m=>this.c(m,u)),removed:[...b.removed].map(m=>this.c(m,u))}));case"onDidChangeVisibility":return R.Event.map(this.a.onDidChangeVisibility,b=>[u.transformOutgoingURI(b[0]),b[1]]);case"onDidChangeLogLevel":return R.Event.map(this.a.onDidChangeLogLevel,b=>(0,r.$aj)(b)?b:[u.transformOutgoingURI(b[0]),b[1]])}throw new Error(`Event not found: ${v}`)}async call(k,v,u){const b=this.b(k);switch(v){case"setLogLevel":return(0,r.$aj)(u[0])?this.a.setLogLevel(u[0]):this.a.setLogLevel(y.URI.revive(b.transformIncoming(u[0][0])),u[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(m=>this.c(m,b)))}throw new Error(`Call not found: ${v}`)}c(k,v){return{...k,resource:v.transformOutgoingURI(k.resource)}}}e.$er=p;class w extends L.$Sc{constructor(k,v){super(),v.call("setLogLevel",[k.getLogLevel()]),this.B(k.onDidChangeLogLevel(u=>v.call("setLogLevel",[u]))),v.call("getRegisteredLoggers").then(u=>{for(const b of u)k.registerLogger({...b,resource:y.URI.revive(b.resource)})}),this.B(v.listen("onDidChangeVisibility")(([u,b])=>k.setVisibility(y.URI.revive(u),b))),this.B(v.listen("onDidChangeLoggers")(({added:u,removed:b})=>{for(const m of u)k.registerLogger({...m,resource:y.URI.revive(m.resource)});for(const m of b)k.deregisterLogger(m.resource)}))}}e.$fr=w}),define(be[114],we([1,0,2,13]),function(ue,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PN=void 0;class r extends y.$Sc{constructor(I,C=[]){super(),this.a=new R.$ij([I,...C]),this.B(I.onDidChangeLogLevel(p=>this.setLevel(p)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(I){this.a.setLevel(I)}getLevel(){return this.a.getLevel()}trace(I,...C){this.a.trace(I,...C)}debug(I,...C){this.a.debug(I,...C)}info(I,...C){this.a.info(I,...C)}warn(I,...C){this.a.warn(I,...C)}error(I,...C){this.a.error(I,...C)}flush(){this.a.flush()}}e.$PN=r}),define(be[225],we([1,0,16,13]),function(ue,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EN=void 0;var r;(function(w){w[w.Trace=0]="Trace",w[w.Debug=1]="Debug",w[w.Info=2]="Info",w[w.Warning=3]="Warning",w[w.Error=4]="Error",w[w.Critical=5]="Critical",w[w.Off=6]="Off"})(r||(r={}));async function L(w,A,k,v,u){try{const b=await new Promise((d,h)=>{ue(["@vscode/spdlog"],d,h)});b.setFlushOn(r.Trace);const m=await b.createAsyncRotatingLogger(w,A,k,v);return u?m.clearFormatters():m.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),m}catch(b){console.error(b)}return null}function I(w,A,k){switch(A){case R.LogLevel.Trace:w.trace(k);break;case R.LogLevel.Debug:w.debug(k);break;case R.LogLevel.Info:w.info(k);break;case R.LogLevel.Warning:w.warn(k);break;case R.LogLevel.Error:w.error(k);break;case R.LogLevel.Off:break;default:throw new Error(`Invalid log level ${A}`)}}function C(w,A){switch(A){case R.LogLevel.Trace:w.setLevel(r.Trace);break;case R.LogLevel.Debug:w.setLevel(r.Debug);break;case R.LogLevel.Info:w.setLevel(r.Info);break;case R.LogLevel.Warning:w.setLevel(r.Warning);break;case R.LogLevel.Error:w.setLevel(r.Error);break;case R.LogLevel.Off:w.setLevel(r.Off);break;default:throw new Error(`Invalid log level ${A}`)}}class p extends R.$ej{constructor(A,k,v,u,b){super(),this.m=[],this.setLevel(b),this.n=this.s(A,k,v,u),this.B(this.onDidChangeLogLevel(m=>{this.r&&C(this.r,m)}))}async s(A,k,v,u){const b=v?6:1,m=30/b*y.$Hk.MB,d=await L(A,k,m,b,u);if(d){this.r=d,C(this.r,this.getLevel());for(const{level:h,message:g}of this.m)I(this.r,h,g);this.m=[]}}g(A,k){this.r?I(this.r,A,k):this.getLevel()<=A&&this.m.push({level:A,message:k})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u())}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$EN=p}),define(be[115],we([1,0,23,13,225]),function(ue,e,y,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FN=void 0;class L extends R.$jj{s(C,p,w){return new r.$EN((0,y.$fg)(),C.fsPath,!w?.donotRotate,!!w?.donotUseFormatters,p)}}e.$FN=L}),define(be[226],we([1,0,63,190,6]),function(ue,e,y,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$et=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var L;(function(p){p[p.Unnecessary=1]="Unnecessary",p[p.Deprecated=2]="Deprecated"})(L||(e.MarkerTag=L={}));var I;(function(p){p[p.Hint=1]="Hint",p[p.Info=2]="Info",p[p.Warning=4]="Warning",p[p.Error=8]="Error"})(I||(e.MarkerSeverity=I={})),function(p){function w(b,m){return m-b}p.compare=w;const A=Object.create(null);A[p.Error]=(0,R.localize)(0,null),A[p.Warning]=(0,R.localize)(1,null),A[p.Info]=(0,R.localize)(2,null);function k(b){return A[b]||""}p.toString=k;function v(b){switch(b){case y.default.Error:return p.Error;case y.default.Warning:return p.Warning;case y.default.Info:return p.Info;case y.default.Ignore:return p.Hint}}p.fromSeverity=v;function u(b){switch(b){case p.Error:return y.default.Error;case p.Warning:return y.default.Warning;case p.Info:return y.default.Info;case p.Hint:return y.default.Ignore}}p.toSeverity=u}(I||(e.MarkerSeverity=I={}));var C;(function(p){const w="";function A(v){return k(v,!0)}p.makeKey=A;function k(v,u){const b=[w];return v.source?b.push(v.source.replace("\xA6","\\\xA6")):b.push(w),v.code?typeof v.code=="string"?b.push(v.code.replace("\xA6","\\\xA6")):b.push(v.code.value.replace("\xA6","\\\xA6")):b.push(w),v.severity!==void 0&&v.severity!==null?b.push(I.toString(v.severity)):b.push(w),v.message&&u?b.push(v.message.replace("\xA6","\\\xA6")):b.push(w),v.startLineNumber!==void 0&&v.startLineNumber!==null?b.push(v.startLineNumber.toString()):b.push(w),v.startColumn!==void 0&&v.startColumn!==null?b.push(v.startColumn.toString()):b.push(w),v.endLineNumber!==void 0&&v.endLineNumber!==null?b.push(v.endLineNumber.toString()):b.push(w),v.endColumn!==void 0&&v.endColumn!==null?b.push(v.endColumn.toString()):b.push(w),b.push(w),b.join("\xA6")}p.makeKeyOptionalMessage=k})(C||(e.IMarkerData=C={})),e.$et=(0,r.$Qh)("markerService")}),define(be[69],we([1,0,5,47,2,6]),function(ue,e,y,R,r,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pn=e.$on=e.$nn=void 0,e.$nn=(0,L.$Qh)("policy");class I extends r.$Sc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new y.$Od),this.onDidChange=this.h.event}async updatePolicyDefinitions(w){const A=Object.keys(this.f).length;return this.f={...w,...this.f},A!==Object.keys(this.f).length&&await this.j(w),R.Iterable.reduce(this.g.entries(),(k,[v,u])=>({...k,[v]:u}),{})}getPolicyValue(w){return this.g.get(w)}serialize(){return R.Iterable.reduce(Object.entries(this.f),(w,[A,k])=>({...w,[A]:{definition:k,value:this.g.get(A)}}),{})}}e.$on=I;class C{constructor(){this.onDidChange=y.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$pn=C}),define(be[55],we([1,0,3,28]),function(ue,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let r;if(typeof y.$b.vscode<"u"&&typeof y.$b.vscode.context<"u"){const L=y.$b.vscode.context.configuration();if(L)r=L.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(r=globalThis._VSCODE_PRODUCT_JSON,R.env.VSCODE_DEV&&Object.assign(r,{nameShort:`${r.nameShort} Dev`,nameLong:`${r.nameLong} Dev`,dataFolderName:`${r.dataFolderName}-dev`,serverDataFolderName:r.serverDataFolderName?`${r.serverDataFolderName}-dev`:void 0}),!r.version){const L=globalThis._VSCODE_PACKAGE_JSON;Object.assign(r,{version:L.version})}Object.assign(r,{extensionsGallery:R.env.EXTENSIONS_GALLERY?JSON.parse(R.env.EXTENSIONS_GALLERY):r.extensionsGallery||{serviceUrl:"https://open-vsx.org/vscode/gallery",itemUrl:"https://open-vsx.org/vscode/item",resourceUrlTemplate:"https://open-vsx.org/vscode/asset/{publisher}/{name}/{version}/Microsoft.VisualStudio.Code.WebResources/{path}",controlUrl:"",recommendationsUrl:""}})}else r={nameShort:"code-server",nameLong:"code-server",applicationName:"code-server",dataFolderName:".code-server",win32MutexName:"codeserver",licenseName:"MIT",licenseUrl:"https://github.com/coder/code-server/blob/main/LICENSE",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverGreeting:[],serverLicense:[],serverLicensePrompt:"",serverApplicationName:"code-server-oss",serverDataFolderName:".vscode-server-oss",tunnelApplicationName:"code-tunnel-oss",win32DirName:"code-server",win32NameVersion:"code-server",win32RegValueName:"CodeOSS",win32x64AppId:"{{D77B7E06-80BA-4137-BCF4-654B95CCEBC5}",win32arm64AppId:"{{D1ACE434-89C5-48D1-88D3-E2991DF85475}",win32x64UserAppId:"{{CC6B787D-37A0-49E8-AE24-8559A032BE0C}",win32arm64UserAppId:"{{3AEBF0C8-F733-4AD4-BADE-FDB816D53D7B}",win32AppUserModelId:"coder.code-server",win32ShellNameShort:"c&ode-server",win32TunnelServiceMutex:"vscodeoss-tunnelservice",win32TunnelMutex:"vscodeoss-tunnel",darwinBundleIdentifier:"com.coder.code.server",linuxIconName:"com.coder.code.server",licenseFileName:"LICENSE.txt",reportIssueUrl:"https://github.com/coder/code-server/issues/new",nodejsRepository:"https://nodejs.org",urlProtocol:"code-oss",webviewContentExternalBaseUrlTemplate:"https://{{uuid}}.vscode-cdn.net/insider/ef65ac1ba57f57f2a3961bfe94aa20481caca4c6/out/vs/workbench/contrib/webview/browser/pre/",builtInExtensions:[{name:"ms-vscode.js-debug-companion",version:"1.1.2",sha256:"e034b8b41beb4e97e02c70f7175bd88abe66048374c2bd629f54bb33354bc2aa",repo:"https://github.com/microsoft/vscode-js-debug-companion",metadata:{id:"99cb0b7f-7354-4278-b8da-6cc79972169d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.js-debug",version:"1.84.0",sha256:"a57691eb4440e549edba7472c0313e94f24d46ebe1ede18784b552fc5d11e596",repo:"https://github.com/microsoft/vscode-js-debug",metadata:{id:"25629058-ddac-4e17-abba-74678e126c5d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.vscode-js-profile-table",version:"1.0.3",sha256:"b9dab017506d9e6a469a0f82b392e4cb1d7a25a4843f1db8ba396cbee209cfc5",repo:"https://github.com/microsoft/vscode-js-profile-visualizer",metadata:{id:"7e52b41b-71ad-457b-ab7e-0620f1fc4feb",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}}],enableTelemetry:!0,quality:"stable",codeServerVersion:"0.0.0",documentationUrl:"https://go.microsoft.com/fwlink/?LinkID=533484#vscode",keyboardShortcutsUrlMac:"https://go.microsoft.com/fwlink/?linkid=832143",keyboardShortcutsUrlLinux:"https://go.microsoft.com/fwlink/?linkid=832144",keyboardShortcutsUrlWin:"https://go.microsoft.com/fwlink/?linkid=832145",introductoryVideosUrl:"https://go.microsoft.com/fwlink/?linkid=832146",tipsAndTricksUrl:"https://go.microsoft.com/fwlink/?linkid=852118",newsletterSignupUrl:"https://www.research.net/r/vsc-newsletter",linkProtectionTrustedDomains:["https://open-vsx.org"],trustedExtensionAuthAccess:["vscode.git","vscode.github","github.vscode-pull-request-github","github.copilot","github.copilot-chat"],aiConfig:{ariaKey:"code-server"},version:"1.84.2",commit:"9658969084238651b6dde258e04f4abd9b14bfd1",date:"2023-11-14T22:48:03.061Z"},Object.keys(r).length===0&&Object.assign(r,{version:"1.82.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=r}),define(be[31],we([1,0,6]),function(ue,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rj=e.$qj=void 0,e.$qj=(0,y.$Qh)("productService"),e.$rj="vscode://schemas/vscode-product"}),define(be[37],we([1,0,96,8]),function(ue,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ln=void 0;class r{constructor(){this.a=new Map}add(I,C){y.ok(R.$zf(I)),y.ok(R.$Bf(C)),y.ok(!this.a.has(I),"There is already an extension with this id"),this.a.set(I,C)}knows(I){return this.a.has(I)}as(I){return this.a.get(I)||null}}e.$ln=new r}),define(be[227],we([1,0,5,37]),function(ue,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mn=void 0,e.$mn={JSONContribution:"base.contributions.json"};function r(C){return C.length>0&&C.charAt(C.length-1)==="#"?C.substring(0,C.length-1):C}class L{constructor(){this.b=new y.$Od,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(p,w){this.a[r(p)]=w,this.b.fire(p)}notifySchemaChanged(p){this.b.fire(p)}getSchemaContributions(){return{schemas:this.a}}}const I=new L;R.$ln.add(e.$mn.JSONContribution,I)}),define(be[56],we([1,0,18,5,8,172,24,227,37]),function(ue,e,y,R,r,L,I,C,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fn=e.$En=e.$Dn=e.$Cn=e.$Bn=e.$An=e.$zn=e.$yn=e.$xn=e.$wn=e.$vn=e.$un=e.$tn=e.$sn=e.$rn=e.ConfigurationScope=e.$qn=e.EditPresentationTypes=void 0;var w;(function(c){c.Multiline="multilineText",c.Singleline="singlelineText"})(w||(e.EditPresentationTypes=w={})),e.$qn={Configuration:"base.contributions.configuration"};var A;(function(c){c[c.APPLICATION=1]="APPLICATION",c[c.MACHINE=2]="MACHINE",c[c.WINDOW=3]="WINDOW",c[c.RESOURCE=4]="RESOURCE",c[c.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",c[c.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(A||(e.ConfigurationScope=A={})),e.$rn={properties:{},patternProperties:{}},e.$sn={properties:{},patternProperties:{}},e.$tn={properties:{},patternProperties:{}},e.$un={properties:{},patternProperties:{}},e.$vn={properties:{},patternProperties:{}},e.$wn={properties:{},patternProperties:{}},e.$xn="vscode://schemas/settings/resourceLanguage",e.$yn="vscode://schemas/settings/configurationDefaults";const k=p.$ln.as(C.$mn.JSONContribution);class v{constructor(){this.h=new Set,this.i=new R.$Od,this.onDidSchemaChange=this.i.event,this.j=new R.$Od,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:L.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},k.registerSchema(e.$xn,this.g),this.v()}registerConfiguration(n,i=!0){this.registerConfigurations([n],i)}registerConfigurations(n,i=!0){const o=new Set;this.n(n,i,o),k.registerSchema(e.$xn,this.g),this.i.fire(),this.j.fire({properties:o})}deregisterConfigurations(n){const i=new Set;this.o(n,i),k.registerSchema(e.$xn,this.g),this.i.fire(),this.j.fire({properties:i})}updateConfigurations({add:n,remove:i}){const o=new Set;this.o(i,o),this.n(n,!1,o),k.registerSchema(e.$xn,this.g),this.i.fire(),this.j.fire({properties:o})}registerDefaultConfigurations(n){const i=new Set;this.k(n,i),this.i.fire(),this.j.fire({properties:i,defaultsOverrides:!0})}k(n,i){const o=[];for(const{overrides:s,source:t}of n)for(const a in s)if(i.add(a),e.$An.test(a)){const f=this.a.get(a),S=f?.valuesSources??new Map;if(t)for(const M of Object.keys(s[a]))S.set(M,t);const D={...f?.value||{},...s[a]};this.a.set(a,{source:t,value:D,valuesSources:S});const E=(0,I.$ui)(a),P={type:"object",default:D,description:L.localize(1,null,E),$ref:e.$xn,defaultDefaultValue:D,source:r.$zf(t)?void 0:t,defaultValueSource:t};o.push(...m(a)),this.d[a]=P,this.b.properties[a]=P}else{this.a.set(a,{value:s[a],source:t});const f=this.d[a];f&&(this.w(a,f),this.r(a,f))}this.m(o)}deregisterDefaultConfigurations(n){const i=new Set;this.l(n,i),this.i.fire(),this.j.fire({properties:i,defaultsOverrides:!0})}l(n,i){for(const{overrides:o,source:s}of n)for(const t in o){const a=this.a.get(t),f=r.$zf(s)?s:s?.id,S=r.$zf(a?.source)?a?.source:a?.source?.id;if(f===S)if(i.add(t),this.a.delete(t),e.$An.test(t))delete this.d[t],delete this.b.properties[t];else{const D=this.d[t];D&&(this.w(t,D),this.r(t,D))}}this.u()}deltaConfiguration(n){let i=!1;const o=new Set;n.removedDefaults&&(this.l(n.removedDefaults,o),i=!0),n.addedDefaults&&(this.k(n.addedDefaults,o),i=!0),n.removedConfigurations&&this.o(n.removedConfigurations,o),n.addedConfigurations&&this.n(n.addedConfigurations,!1,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:i})}notifyConfigurationSchemaUpdated(...n){this.i.fire()}registerOverrideIdentifiers(n){this.m(n),this.i.fire()}m(n){for(const i of n)this.h.add(i);this.u()}n(n,i,o){n.forEach(s=>{this.p(s,i,s.extensionInfo,s.restrictedProperties,void 0,o),this.c.push(s),this.q(s)})}o(n,i){const o=s=>{if(s.properties)for(const t in s.properties){i.add(t);const a=this.d[t];a?.policy?.name&&this.e.delete(a.policy.name),delete this.d[t],this.s(t,s.properties[t])}s.allOf?.forEach(t=>o(t))};for(const s of n){o(s);const t=this.c.indexOf(s);t!==-1&&this.c.splice(t,1)}}p(n,i=!0,o,s,t=3,a){t=r.$If(n.scope)?t:n.scope;const f=n.properties;if(f)for(const D in f){const E=f[D];if(i&&l(D,E)){delete f[D];continue}if(E.source=o,E.defaultDefaultValue=f[D].default,this.w(D,E),e.$An.test(D)?E.scope=void 0:(E.scope=r.$If(E.scope)?t:E.scope,E.restricted=r.$If(E.restricted)?!!s?.includes(D):E.restricted),f[D].hasOwnProperty("included")&&!f[D].included){this.f[D]=f[D],delete f[D];continue}else this.d[D]=f[D],f[D].policy?.name&&this.e.set(f[D].policy.name,D);!f[D].deprecationMessage&&f[D].markdownDeprecationMessage&&(f[D].deprecationMessage=f[D].markdownDeprecationMessage),a.add(D)}const S=n.allOf;if(S)for(const D of S)this.p(D,i,o,s,t,a)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(n){const i=o=>{const s=o.properties;if(s)for(const a in s)this.r(a,s[a]);o.allOf?.forEach(i)};i(n)}r(n,i){switch(e.$rn.properties[n]=i,i.scope){case 1:e.$sn.properties[n]=i;break;case 2:e.$tn.properties[n]=i;break;case 6:e.$un.properties[n]=i;break;case 3:e.$vn.properties[n]=i;break;case 4:e.$wn.properties[n]=i;break;case 5:e.$wn.properties[n]=i,this.g.properties[n]=i;break}}s(n,i){switch(delete e.$rn.properties[n],i.scope){case 1:delete e.$sn.properties[n];break;case 2:delete e.$tn.properties[n];break;case 6:delete e.$un.properties[n];break;case 3:delete e.$vn.properties[n];break;case 4:case 5:delete e.$wn.properties[n],delete this.g.properties[n];break}}u(){for(const n of this.h.values()){const i=`[${n}]`,o={type:"object",description:L.localize(2,null),errorMessage:L.localize(3,null),$ref:e.$xn};this.w(i,o),e.$rn.properties[i]=o,e.$sn.properties[i]=o,e.$tn.properties[i]=o,e.$un.properties[i]=o,e.$vn.properties[i]=o,e.$wn.properties[i]=o}}v(){const n={type:"object",description:L.localize(4,null),errorMessage:L.localize(5,null),$ref:e.$xn};e.$rn.patternProperties[e.$zn]=n,e.$sn.patternProperties[e.$zn]=n,e.$tn.patternProperties[e.$zn]=n,e.$un.patternProperties[e.$zn]=n,e.$vn.patternProperties[e.$zn]=n,e.$wn.patternProperties[e.$zn]=n,this.i.fire()}w(n,i){const o=this.a.get(n);let s=o?.value,t=o?.source;r.$Gf(s)&&(s=i.defaultDefaultValue,t=void 0),r.$Gf(s)&&(s=h(i.type)),i.default=s,i.defaultValueSource=t}}const u="\\[([^\\]]+)\\]",b=new RegExp(u,"g");e.$zn=`^(${u})+$`,e.$An=new RegExp(e.$zn);function m(c){const n=[];if(e.$An.test(c)){let i=b.exec(c);for(;i?.length;){const o=i[1].trim();o&&n.push(o),i=b.exec(c)}}return(0,y.$Mb)(n)}e.$Bn=m;function d(c){return c.reduce((n,i)=>`${n}[${i}]`,"")}e.$Cn=d;function h(c){switch(Array.isArray(c)?c[0]:c){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$Dn=h;const g=new v;p.$ln.add(e.$qn.Configuration,g);function l(c,n){return c.trim()?e.$An.test(c)?L.localize(7,null,c):g.getConfigurationProperties()[c]!==void 0?L.localize(8,null,c):n.policy?.name&&g.getPolicyConfigurations().get(n.policy?.name)!==void 0?L.localize(9,null,c,n.policy?.name,g.getPolicyConfigurations().get(n.policy?.name)):null:L.localize(6,null)}e.$En=l;function $(){const c=[],n=g.getConfigurationProperties();for(const i of Object.keys(n))c.push([i,n[i].scope]);return c.push(["launch",4]),c.push(["task",4]),c}e.$Fn=$}),define(be[116],we([1,0,18,5,75,2,26,22,8,4,24,56,37]),function(ue,e,y,R,r,L,I,C,p,w,A,k,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ln=e.$Kn=e.$Jn=e.$In=e.$Hn=e.$Gn=void 0;function u(i){return Object.isFrozen(i)?i:C.$0m(i)}class b{constructor(o={},s=[],t=[],a){this.b=o,this.c=s,this.d=t,this.raw=a,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const o=this.raw.map(s=>{if(s instanceof b)return s;const t=new m("");return t.parseRaw(s),t.configurationModel});this.f=o.reduce((s,t)=>t===s?t:s.merge(t),o[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(o){return o?(0,A.$si)(this.contents,o):this.contents}inspect(o,s){const t=this.rawConfiguration.getValue(o),a=s?this.rawConfiguration.getOverrideValue(o,s):void 0,f=s?this.rawConfiguration.override(s).getValue(o):t;return{value:t,override:a,merged:f}}getOverrideValue(o,s){const t=this.i(s);return t?o?(0,A.$si)(t,o):t:void 0}getKeysForOverrideIdentifier(o){const s=[];for(const t of this.overrides)t.identifiers.includes(o)&&s.push(...t.keys);return y.$Mb(s)}getAllOverrideIdentifiers(){const o=[];for(const s of this.overrides)o.push(...s.identifiers);return y.$Mb(o)}override(o){let s=this.a.get(o);return s||(s=this.g(o),this.a.set(o,s)),s}merge(...o){const s=C.$9m(this.contents),t=C.$9m(this.overrides),a=[...this.keys],f=this.raw?.length?[...this.raw]:[this];for(const S of o)if(f.push(...S.raw?.length?S.raw:[S]),!S.isEmpty()){this.h(s,S.contents);for(const D of S.overrides){const[E]=t.filter(P=>y.$ub(P.identifiers,D.identifiers));E?(this.h(E.contents,D.contents),E.keys.push(...D.keys),E.keys=y.$Mb(E.keys)):t.push(C.$9m(D))}for(const D of S.keys)a.indexOf(D)===-1&&a.push(D)}return new b(s,a,t,f.every(S=>S instanceof b)?void 0:f)}g(o){const s=this.i(o);if(!s||typeof s!="object"||!Object.keys(s).length)return this;const t={};for(const a of y.$Mb([...Object.keys(this.contents),...Object.keys(s)])){let f=this.contents[a];const S=s[a];S&&(typeof f=="object"&&typeof S=="object"?(f=C.$9m(f),this.h(f,S)):f=S),t[a]=f}return new b(t,this.keys,this.overrides)}h(o,s){for(const t of Object.keys(s)){if(t in o&&p.$Bf(o[t])&&p.$Bf(s[t])){this.h(o[t],s[t]);continue}o[t]=C.$9m(s[t])}}i(o){let s=null,t=null;const a=f=>{f&&(t?this.h(t,f):t=C.$9m(f))};for(const f of this.overrides)f.identifiers.length===1&&f.identifiers[0]===o?s=f.contents:f.identifiers.includes(o)&&a(f.contents);return a(s),t}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(o,s){this.j(o,s,!0)}setValue(o,s){this.j(o,s,!1)}removeValue(o){const s=this.keys.indexOf(o);s!==-1&&(this.keys.splice(s,1),(0,A.$ri)(this.contents,o),k.$An.test(o)&&this.overrides.splice(this.overrides.findIndex(t=>y.$ub(t.identifiers,(0,k.$Bn)(o))),1))}j(o,s,t){(0,A.$qi)(this.contents,o,s,a=>console.error(a)),t=t||this.keys.indexOf(o)===-1,t&&this.keys.push(o),k.$An.test(o)&&this.overrides.push({identifiers:(0,k.$Bn)(o),keys:Object.keys(this.contents[o]),contents:(0,A.$pi)(this.contents[o],a=>console.error(a))})}}e.$Gn=b;class m{constructor(o){this.f=o,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new b}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(o,s){if(!p.$If(o)){const t=this.g(o);this.parseRaw(t,s)}}reparse(o){this.a&&this.parseRaw(this.a,o)}parseRaw(o,s){this.a=o;const{contents:t,keys:a,overrides:f,restricted:S,hasExcludedProperties:D}=this.h(o,s);this.b=new b(t,a,f,D?[o]:void 0),this.c=S||[]}g(o){let s={},t=null,a=[];const f=[],S=[];function D(P){Array.isArray(a)?a.push(P):t!==null&&(a[t]=P)}const E={onObjectBegin:()=>{const P={};D(P),f.push(a),a=P,t=null},onObjectProperty:P=>{t=P},onObjectEnd:()=>{a=f.pop()},onArrayBegin:()=>{const P=[];D(P),f.push(a),a=P,t=null},onArrayEnd:()=>{a=f.pop()},onLiteralValue:D,onError:(P,M,ee)=>{S.push({error:P,offset:M,length:ee})}};if(o)try{r.$6m(o,E),s=a[0]||{}}catch(P){console.error(`Error while parsing settings file ${this.f}: ${P}`),this.d=[P]}return s}h(o,s){const t=v.$ln.as(k.$qn.Configuration).getConfigurationProperties(),a=this.i(o,t,!0,s);o=a.raw;const f=(0,A.$pi)(o,E=>console.error(`Conflict in settings file ${this.f}: ${E}`)),S=Object.keys(o),D=this.j(o,E=>console.error(`Conflict in settings file ${this.f}: ${E}`));return{contents:f,keys:S,overrides:D,restricted:a.restricted,hasExcludedProperties:a.hasExcludedProperties}}i(o,s,t,a){let f=!1;if(!a?.scopes&&!a?.skipRestricted&&!a?.exclude?.length)return{raw:o,restricted:[],hasExcludedProperties:f};const S={},D=[];for(const E in o)if(k.$An.test(E)&&t){const P=this.i(o[E],s,!1,a);S[E]=P.raw,f=f||P.hasExcludedProperties,D.push(...P.restricted)}else{const P=s[E],M=P?typeof P.scope<"u"?P.scope:3:void 0;P?.restricted&&D.push(E),!a.exclude?.includes(E)&&(a.include?.includes(E)||(M===void 0||a.scopes===void 0||a.scopes.includes(M))&&!(a.skipRestricted&&P?.restricted))?S[E]=o[E]:f=!0}return{raw:S,restricted:D,hasExcludedProperties:f}}j(o,s){const t=[];for(const a of Object.keys(o))if(k.$An.test(a)){const f={};for(const S in o[a])f[S]=o[a][S];t.push({identifiers:(0,k.$Bn)(a),keys:Object.keys(f),contents:(0,A.$pi)(f,s)})}return t}}e.$Hn=m;class d extends L.$Sc{constructor(o,s,t,a){super(),this.c=o,this.f=s,this.g=a,this.b=this.B(new R.$Od),this.onDidChange=this.b.event,this.a=new m(this.c.toString()),this.B(this.g.watch(t.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(R.Event.any(R.Event.filter(this.g.onDidFilesChange,f=>f.contains(this.c)),R.Event.filter(this.g.onDidRunOperation,f=>(f.isOperation(0)||f.isOperation(3)||f.isOperation(1)||f.isOperation(4))&&t.isEqual(f.resource,o)))(()=>this.b.fire()))}async loadConfiguration(){try{const o=await this.g.readFile(this.c);return this.a.parse(o.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new b}}reparse(o){return o&&(this.f=o),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$In=d;class h{constructor(o,s,t,a,f,S,D,E,P,M,ee,se,G){this.a=o,this.b=s,this.c=t,this.overrideIdentifiers=a,this.d=f,this.f=S,this.g=D,this.h=E,this.i=P,this.j=M,this.k=ee,this.l=se,this.m=G}get value(){return u(this.c)}n(o,s,t){const a=o.inspect(s,t);return{get value(){return u(a.value)},get override(){return u(a.override)},get merged(){return u(a.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class g{constructor(o,s,t,a,f=new b,S=new b,D=new I.$Ac,E=new b,P=new I.$Ac){this.c=o,this.d=s,this.f=t,this.g=a,this.h=f,this.i=S,this.j=D,this.l=E,this.m=P,this.a=null,this.b=new I.$Ac,this.n=null}getValue(o,s,t){return this.q(o,s,t).getValue(o)}updateValue(o,s,t={}){let a;t.resource?(a=this.m.get(t.resource),a||(a=new b,this.m.set(t.resource,a))):a=this.l,s===void 0?a.removeValue(o):a.setValue(o,s),t.resource||(this.a=null)}inspect(o,s,t){const a=this.q(o,s,t),f=this.u(s.resource,t),S=s.resource?this.m.get(s.resource)||this.l:this.l,D=new Set;for(const E of a.overrides)for(const P of E.identifiers)a.getOverrideValue(o,P)!==void 0&&D.add(P);return new h(o,s,a.getValue(o),D.size?[...D]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,t?this.i:void 0,f||void 0,S)}keys(o){const s=this.u(void 0,o);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:s?s.keys.slice(0):[]}}updateDefaultConfiguration(o){this.c=o,this.a=null,this.b.clear()}updatePolicyConfiguration(o){this.d=o}updateApplicationConfiguration(o){this.f=o,this.a=null,this.b.clear()}updateLocalUserConfiguration(o){this.g=o,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(o){this.h=o,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(o){this.i=o,this.a=null,this.b.clear()}updateFolderConfiguration(o,s){this.j.set(o,s),this.b.delete(o)}deleteFolderConfiguration(o){this.p.delete(o),this.b.delete(o)}compareAndUpdateDefaultConfiguration(o,s){const t=[];if(!s){const{added:a,updated:f,removed:S}=c(this.c,o);s=[...a,...f,...S]}for(const a of s)for(const f of(0,k.$Bn)(a)){const S=this.c.getKeysForOverrideIdentifier(f),D=o.getKeysForOverrideIdentifier(f),E=[...D.filter(P=>S.indexOf(P)===-1),...S.filter(P=>D.indexOf(P)===-1),...S.filter(P=>!C.$an(this.c.override(f).getValue(P),o.override(f).getValue(P)))];t.push([f,E])}return this.updateDefaultConfiguration(o),{keys:s,overrides:t}}compareAndUpdatePolicyConfiguration(o){const{added:s,updated:t,removed:a}=c(this.d,o),f=[...s,...t,...a];return f.length&&this.updatePolicyConfiguration(o),{keys:f,overrides:[]}}compareAndUpdateApplicationConfiguration(o){const{added:s,updated:t,removed:a,overrides:f}=c(this.applicationConfiguration,o),S=[...s,...t,...a];return S.length&&this.updateApplicationConfiguration(o),{keys:S,overrides:f}}compareAndUpdateLocalUserConfiguration(o){const{added:s,updated:t,removed:a,overrides:f}=c(this.localUserConfiguration,o),S=[...s,...t,...a];return S.length&&this.updateLocalUserConfiguration(o),{keys:S,overrides:f}}compareAndUpdateRemoteUserConfiguration(o){const{added:s,updated:t,removed:a,overrides:f}=c(this.remoteUserConfiguration,o),S=[...s,...t,...a];return S.length&&this.updateRemoteUserConfiguration(o),{keys:S,overrides:f}}compareAndUpdateWorkspaceConfiguration(o){const{added:s,updated:t,removed:a,overrides:f}=c(this.workspaceConfiguration,o),S=[...s,...t,...a];return S.length&&this.updateWorkspaceConfiguration(o),{keys:S,overrides:f}}compareAndUpdateFolderConfiguration(o,s){const t=this.p.get(o),{added:a,updated:f,removed:S,overrides:D}=c(t,s),E=[...a,...f,...S];return(E.length||!t)&&this.updateFolderConfiguration(o,s),{keys:E,overrides:D}}compareAndDeleteFolderConfiguration(o){const s=this.p.get(o);if(!s)throw new Error("Unknown folder");this.deleteFolderConfiguration(o);const{added:t,updated:a,removed:f,overrides:S}=c(s,void 0);return{keys:[...t,...a,...f],overrides:S}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(o,s,t){let a=this.r(s,t);return s.overrideIdentifier&&(a=a.override(s.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(o)!==void 0&&(a=a.merge(this.d)),a}r({resource:o},s){let t=this.s();if(s&&o){const a=s.getFolder(o);a&&(t=this.t(a.uri)||t);const f=this.m.get(o);f&&(t=t.merge(f))}return t}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(o){let s=this.b.get(o);if(!s){const t=this.s(),a=this.j.get(o);a?(s=t.merge(a),this.b.set(o,s)):s=t}return s}u(o,s){if(s&&o){const t=s.getFolder(o);if(t)return this.j.get(t.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((o,s)=>{const{contents:t,overrides:a,keys:f}=this.j.get(s);return o.push([s,{contents:t,overrides:a,keys:f}]),o},[])}}allKeys(){const o=new Set;return this.c.keys.forEach(s=>o.add(s)),this.userConfiguration.keys.forEach(s=>o.add(s)),this.i.keys.forEach(s=>o.add(s)),this.j.forEach(s=>s.keys.forEach(t=>o.add(t))),[...o.values()]}v(){const o=new Set;return this.c.getAllOverrideIdentifiers().forEach(s=>o.add(s)),this.userConfiguration.getAllOverrideIdentifiers().forEach(s=>o.add(s)),this.i.getAllOverrideIdentifiers().forEach(s=>o.add(s)),this.j.forEach(s=>s.getAllOverrideIdentifiers().forEach(t=>o.add(t))),[...o.values()]}w(o){const s=new Set;return this.c.getKeysForOverrideIdentifier(o).forEach(t=>s.add(t)),this.userConfiguration.getKeysForOverrideIdentifier(o).forEach(t=>s.add(t)),this.i.getKeysForOverrideIdentifier(o).forEach(t=>s.add(t)),this.j.forEach(t=>t.getKeysForOverrideIdentifier(o).forEach(a=>s.add(a))),[...s.values()]}static parse(o){const s=this.x(o.defaults),t=this.x(o.policy),a=this.x(o.application),f=this.x(o.user),S=this.x(o.workspace),D=o.folders.reduce((E,P)=>(E.set(w.URI.revive(P[0]),this.x(P[1])),E),new I.$Ac);return new g(s,t,a,f,new b,S,D,new b,new I.$Ac)}static x(o){return new b(o.contents,o.keys,o.overrides)}}e.$Jn=g;function l(...i){if(i.length===0)return{keys:[],overrides:[]};if(i.length===1)return i[0];const o=new Set,s=new Map;for(const a of i)a.keys.forEach(f=>o.add(f)),a.overrides.forEach(([f,S])=>{const D=(0,I.$xc)(s,f,new Set);S.forEach(E=>D.add(E))});const t=[];return s.forEach((a,f)=>t.push([f,[...a.values()]])),{keys:[...o.values()],overrides:t}}e.$Kn=l;class ${constructor(o,s,t,a){this.change=o,this.f=s,this.g=t,this.h=a,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const f of o.keys)this.affectedKeys.add(f);for(const[,f]of o.overrides)for(const S of f)this.affectedKeys.add(S);this.d=this.a;for(const f of this.affectedKeys)this.d+=f+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=g.parse(this.f.data)),this.i}affectsConfiguration(o,s){const t=this.a+o,a=this.d.indexOf(t);if(a<0)return!1;const f=a+t.length;if(f>=this.d.length)return!1;const S=this.d.charCodeAt(f);if(S!==this.b&&S!==this.c)return!1;if(s){const D=this.previousConfiguration?this.previousConfiguration.getValue(o,s,this.f?.workspace):void 0,E=this.g.getValue(o,s,this.h);return!C.$an(D,E)}return!0}}e.$Ln=$;function c(i,o){const{added:s,removed:t,updated:a}=n(o?.rawConfiguration,i?.rawConfiguration),f=[],S=i?.getAllOverrideIdentifiers()||[],D=o?.getAllOverrideIdentifiers()||[];if(o){const E=D.filter(P=>!S.includes(P));for(const P of E)f.push([P,o.getKeysForOverrideIdentifier(P)])}if(i){const E=S.filter(P=>!D.includes(P));for(const P of E)f.push([P,i.getKeysForOverrideIdentifier(P)])}if(o&&i){for(const E of S)if(D.includes(E)){const P=n({contents:i.getOverrideValue(void 0,E)||{},keys:i.getKeysForOverrideIdentifier(E)},{contents:o.getOverrideValue(void 0,E)||{},keys:o.getKeysForOverrideIdentifier(E)});f.push([E,[...P.added,...P.removed,...P.updated]])}}return{added:s,removed:t,updated:a,overrides:f}}function n(i,o){const s=i?o?i.keys.filter(f=>o.keys.indexOf(f)===-1):[...i.keys]:[],t=o?i?o.keys.filter(f=>i.keys.indexOf(f)===-1):[...o.keys]:[],a=[];if(i&&o){for(const f of o.keys)if(i.keys.indexOf(f)!==-1){const S=(0,A.$si)(o.contents,f),D=(0,A.$si)(i.contents,f);C.$an(S,D)||a.push(f)}}return{added:s,removed:t,updated:a}}}),define(be[228],we([1,0,18,5,2,22,8,116,56,13,69,37]),function(ue,e,y,R,r,L,I,C,p,w,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$On=e.$Nn=e.$Mn=void 0;class v extends r.$Sc{constructor(){super(...arguments),this.a=this.B(new R.$Od),this.onDidChangeConfiguration=this.a.event,this.b=new C.$Gn}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(k.$ln.as(p.$qn.Configuration).onDidUpdateConfiguration(({properties:d,defaultsOverrides:h})=>this.c(Array.from(d),h))),this.configurationModel}reload(){return this.g(),this.configurationModel}c(d,h){this.h(d,k.$ln.as(p.$qn.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:d})}f(){return{}}g(){this.b=new C.$Gn;const d=k.$ln.as(p.$qn.Configuration).getConfigurationProperties();this.h(Object.keys(d),d)}h(d,h){const g=this.f();for(const l of d){const $=g[l],c=h[l];$!==void 0?this.b.addValue(l,$):c?this.b.addValue(l,c.default):this.b.removeValue(l)}}}e.$Mn=v;class u{constructor(){this.onDidChangeConfiguration=R.Event.None,this.configurationModel=new C.$Gn}async initialize(){return this.configurationModel}}e.$Nn=u;let b=class extends r.$Sc{get configurationModel(){return this.b}constructor(d,h,g){super(),this.c=d,this.f=h,this.g=g,this.a=this.B(new R.$Od),this.onDidChangeConfiguration=this.a.event,this.b=new C.$Gn}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(d=>this.j(d))),this.B(this.c.onDidChangeConfiguration(async({properties:d})=>this.m(await this.h(d),!0))),this.b}async h(d){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",d);const h={},g=[],l=k.$ln.as(p.$qn.Configuration).getConfigurationProperties();for(const $ of d){const c=l[$];if(!c){g.push($);continue}if(c.policy){if(c.type!=="string"&&c.type!=="number"){this.g.warn(`Policy ${c.policy.name} has unsupported type ${c.type}`);continue}g.push($),h[c.policy.name]={type:c.type}}}return(0,I.$Mf)(h)||await this.f.updatePolicyDefinitions(h),g}j(d){this.g.trace("PolicyConfiguration#onDidChangePolicies",d);const h=k.$ln.as(p.$qn.Configuration).getPolicyConfigurations(),g=(0,y.$Hb)(d.map(l=>h.get(l)));this.m(g,!0)}m(d,h){this.g.trace("PolicyConfiguration#update",d);const g=k.$ln.as(p.$qn.Configuration).getConfigurationProperties(),l=[],$=this.b.isEmpty();for(const c of d){const n=g[c]?.policy?.name;if(n){const i=this.f.getPolicyValue(n);($?i!==void 0:!(0,L.$an)(this.b.getValue(c),i))&&l.push([c,i])}else this.b.getValue(c)!==void 0&&l.push([c,void 0])}if(l.length){this.g.trace("PolicyConfiguration#changed",l);const c=this.b;this.b=new C.$Gn;for(const n of c.keys)this.b.setValue(n,c.getValue(n));for(const[n,i]of l)i===void 0?this.b.removeValue(n):this.b.setValue(n,i);h&&this.a.fire(this.b)}}};e.$On=b,e.$On=b=Re([Ae(1,A.$nn),Ae(2,w.$$i)],b)}),define(be[117],we([1,0,14,5,2,19,24,116,228,69]),function(ue,e,y,R,r,L,I,C,p,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pn=void 0;class A extends r.$Sc{constructor(v,u,b,m){super(),this.j=v,this.h=this.B(new R.$Od),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new p.$Mn),this.c=b instanceof w.$pn?new p.$Nn:this.B(new p.$On(this.b,b,m)),this.f=this.B(new C.$In(this.j,{},L.$ng,u)),this.a=new C.$Jn(this.b.configurationModel,this.c.configurationModel,new C.$Gn,new C.$Gn),this.g=this.B(new y.$7g(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:d,properties:h})=>this.n(d,h))),this.B(this.c.onDidChangeConfiguration(d=>this.r(d))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[v,u,b]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new C.$Jn(v,u,new C.$Gn,b)}getConfigurationData(){return this.a.toData()}getValue(v,u){const b=typeof v=="string"?v:void 0,m=(0,I.$li)(v)?v:(0,I.$li)(u)?u:{};return this.a.getValue(b,m,void 0)}updateValue(v,u,b,m){return Promise.reject(new Error("not supported"))}inspect(v){return this.a.inspect(v,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const v=await this.f.loadConfiguration();this.m(v)}m(v){const u=this.a.toData(),b=this.a.compareAndUpdateLocalUserConfiguration(v);this.s(b,u,2)}n(v,u){const b=this.a.toData(),m=this.a.compareAndUpdateDefaultConfiguration(v,u);this.s(m,b,7)}r(v){const u=this.a.toData(),b=this.a.compareAndUpdatePolicyConfiguration(v);this.s(b,u,7)}s(v,u,b){const m=new C.$Ln(v,{data:u},this.a);m.source=b,m.sourceConfig=this.t(b),this.h.fire(m)}t(v){switch(v){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.$Pn=A}),define(be[118],we([1,0,11,6]),function(ue,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uk=e.$Tk=e.RemoteAuthorityResolverErrorCode=e.$Sk=e.$Rk=e.RemoteConnectionType=e.$Qk=void 0,e.$Qk=(0,R.$Qh)("remoteAuthorityResolverService");var r;(function(A){A[A.WebSocket=0]="WebSocket",A[A.Managed=1]="Managed"})(r||(e.RemoteConnectionType=r={}));class L{constructor(k){this.id=k,this.type=1}toString(){return`Managed(${this.id})`}}e.$Rk=L;class I{constructor(k,v){this.host=k,this.port=v,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Sk=I;var C;(function(A){A.Unknown="Unknown",A.NotAvailable="NotAvailable",A.TemporarilyNotAvailable="TemporarilyNotAvailable",A.NoResolverFound="NoResolverFound",A.InvalidAuthority="InvalidAuthority"})(C||(e.RemoteAuthorityResolverErrorCode=C={}));class p extends y.$bb{static isNotAvailable(k){return k instanceof p&&k._code===C.NotAvailable}static isTemporarilyNotAvailable(k){return k instanceof p&&k._code===C.TemporarilyNotAvailable}static isNoResolverFound(k){return k instanceof p&&k._code===C.NoResolverFound}static isInvalidAuthority(k){return k instanceof p&&k._code===C.InvalidAuthority}static isHandled(k){return k instanceof p&&k.isHandled}constructor(k,v=C.Unknown,u){super(k),this._message=k,this._code=v,this._detail=u,this.isHandled=v===C.NotAvailable&&u===!0,Object.setPrototypeOf(this,p.prototype)}}e.$Tk=p;function w(A){const k=A.indexOf("+");return k===-1?A:A.substring(0,k)}e.$Uk=w}),define(be[229],we([1,0,6]),function(ue,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SN=e.$RN=void 0,e.$RN=(0,y.$Qh)("IRemoteExtensionsScannerService"),e.$SN="remoteExtensionsScanner"}),define(be[57],we([1,0,12]),function(ue,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zk=e.$Yk=e.$Xk=e.$Wk=e.$Vk=void 0;function R(w){return w.scheme===y.Schemas.vscodeRemote?w.authority:void 0}e.$Vk=R;function r(w){if(!w)return;const A=w.indexOf("+");return A<0?w:w.substr(0,A)}e.$Wk=r;function L(w){return`/${w.quality??"oss"}-${w.commit??"dev"}`}e.$Xk=L;function I(w){const{host:A,port:k}=p(w);if(typeof k>"u")throw new Error("Remote authority doesn't contain a port!");return{host:A,port:k}}e.$Yk=I;function C(w,A){let{host:k,port:v}=p(w);return typeof v>"u"&&(v=A),{host:k,port:v}}e.$Zk=C;function p(w){const A=w.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(A)return{host:A[1],port:parseInt(A[2],10)};const k=w.match(/^(\[[0-9a-z:]+\])$/);if(k)return{host:k[1],port:void 0};const v=w.match(/(.*):(\d+)$/);return v?{host:v[1],port:parseInt(v[2],10)}:{host:w,port:void 0}}}),define(be[35],we([1,0,17,6,57]),function(ue,e,y,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cm=e.$bm=e.$am=e.$_l=e.$$l=e.$0l=e.$9l=e.$8l=e.TargetPlatform=e.ExtensionType=e.$7l=e.$6l=e.$5l=e.$4l=e.$3l=e.$2l=void 0,e.$2l="extensions.user.cache",e.$3l="extensions.builtin.cache",e.$4l="undefined_publisher",e.$5l=["ui","workspace","web"];function L(m){if(typeof m=="object"&&m!==null&&m.supported!==!0)return m.description}e.$6l=L,e.$7l=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var I;(function(m){m[m.System=0]="System",m[m.User=1]="User"})(I||(e.ExtensionType=I={}));var C;(function(m){m.WIN32_X64="win32-x64",m.WIN32_ARM64="win32-arm64",m.LINUX_X64="linux-x64",m.LINUX_ARM64="linux-arm64",m.LINUX_ARMHF="linux-armhf",m.ALPINE_X64="alpine-x64",m.ALPINE_ARM64="alpine-arm64",m.DARWIN_X64="darwin-x64",m.DARWIN_ARM64="darwin-arm64",m.WEB="web",m.UNIVERSAL="universal",m.UNKNOWN="unknown",m.UNDEFINED="undefined"})(C||(e.TargetPlatform=C={}));class p{constructor(d){this.value=d,this._lower=d.toLowerCase()}static equals(d,h){if(typeof d>"u"||d===null)return typeof h>"u"||h===null;if(typeof h>"u"||h===null)return!1;if(typeof d=="string"||typeof h=="string"){const g=typeof d=="string"?d:d.value,l=typeof h=="string"?h:h.value;return y.$3e(g,l)}return d._lower===h._lower}static toKey(d){return typeof d=="string"?d.toLowerCase():d._lower}}e.$8l=p;class w{get size(){return this.c.size}constructor(d){if(this.c=new Set,d)for(const h of d)this.add(h)}add(d){this.c.add(p.toKey(d))}delete(d){return this.c.delete(p.toKey(d))}has(d){return this.c.has(p.toKey(d))}}e.$9l=w;class A{constructor(){this.c=new Map}clear(){this.c.clear()}delete(d){this.c.delete(p.toKey(d))}get(d){return this.c.get(p.toKey(d))}has(d){return this.c.has(p.toKey(d))}set(d,h){this.c.set(p.toKey(d),h)}values(){return this.c.values()}forEach(d){this.c.forEach(d)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$0l=A;function k(m){return v(m)}e.$$l=k;function v(m){return m.contributes&&m.contributes.localizations?m.contributes.localizations.length>0:!1}e.$_l=v;function u(m){return m.contributes&&m.contributes.authentication?m.contributes.authentication.length>0:!1}e.$am=u;function b(m,d){if(d){const h=`onResolveRemoteAuthority:${(0,r.$Wk)(d)}`;return!!m.activationEvents?.includes(h)}return!1}e.$bm=b,e.$cm=(0,R.$Qh)("IBuiltinExtensionsScannerService")}),define(be[230],we([1,0,11,35]),function(ue,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4E=e.$3E=void 0;class r{constructor(){this.a=new Map,this.b=new WeakMap}register(I,C){this.a.set(I,C)}readActivationEvents(I){return this.b.has(I)||this.b.set(I,this.c(I)),this.b.get(I)}createActivationEventsMap(I){const C=Object.create(null);for(const p of I){const w=this.readActivationEvents(p);w.length>0&&(C[R.$8l.toKey(p.identifier)]=w)}return C}c(I){if(typeof I.main>"u"&&typeof I.browser>"u")return[];const C=Array.isArray(I.activationEvents)?I.activationEvents.slice(0):[];if(!I.contributes)return C;for(const p in I.contributes){const w=this.a.get(p);if(!w)continue;const A=I.contributes[p],k=Array.isArray(A)?A:[A];try{w(k,C)}catch(v){(0,y.$1)(v)}}return C}}e.$3E=r,e.$4E=new r}),define(be[231],we([1,0,2,35,16]),function(ue,e,y,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lp=void 0;class L extends y.$Sc{constructor(C,p,w,A,k){super(),this.a=C,this.b=p,this.c=w,this.f=k,this.B(A.onDidInstallExtensions(v=>this.g(v))),this.B(A.onDidUninstallExtension(v=>this.h(v)))}g(C){for(const p of C)p.local&&this.invalidate(p.profileLocation)}h(C){C.error||this.invalidate(C.profileLocation)}async invalidate(C){if(C)for(const p of this.a.profiles)this.c.extUri.isEqual(p.extensionsResource,C)&&await this.j(p);else await this.j(this.a.defaultProfile)}async j(C){try{await this.b.del(this.c.extUri.joinPath(C.cacheHome,R.$2l))}catch(p){(0,r.$qk)(p)!==1&&this.f.error(p)}}}e.$Lp=L}),define(be[44],we([1,0,15,11,2,191,56,6,13,37]),function(ue,e,y,R,r,L,I,C,p,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5o=e.$4o=e.$3o=e.$2o=e.$1o=e.$Zo=e.$Yo=e.$Xo=void 0,e.$Xo=(0,C.$Qh)("requestService");class A{constructor(c){this.b=c}toJSON(){if(!this.a){const c=Object.create(null);for(const n in this.b)n.toLowerCase()==="authorization"||n.toLowerCase()==="proxy-authorization"?c[n]="*****":c[n]=this.b[n];this.a=c}return this.a}}class k extends r.$Sc{constructor(c){super(),this.b=0,this.a=c.createLogger("network",{name:(0,L.localize)(0,null),when:p.$pj.isEqualTo((0,p.$nj)(p.LogLevel.Trace)).serialize()})}async c(c,n,i){const o=`${c} #${++this.b}: ${n.url}`;this.a.trace(`${o} - begin`,n.type,new A(n.headers??{}));try{const s=await i();return this.a.trace(`${o} - end`,n.type,s.res.statusCode,s.res.headers),s}catch(s){throw this.a.error(`${o} - error`,n.type,(0,R.$0)(s)),s}}}e.$Yo=k;function v($){return $.res.statusCode&&$.res.statusCode>=200&&$.res.statusCode<300||$.res.statusCode===1223}e.$Zo=v;function u($){return $.res.statusCode===204}e.$1o=u;async function b($){return u($)?null:(await(0,y.$oe)($.stream)).toString()}e.$2o=b;async function m($){if(!v($))throw new Error("Server returned "+$.res.statusCode);return b($)}e.$3o=m;async function d($){if(!v($))throw new Error("Server returned "+$.res.statusCode);if(u($))return null;const n=(await(0,y.$oe)($.stream)).toString();try{return JSON.parse(n)}catch(i){throw i.message+=`:
`+n,i}}e.$4o=d;function h($){l($)}e.$5o=h;let g;function l($){const c=w.$ln.as(I.$qn.Configuration),n=g;g={id:"http",order:15,title:(0,L.localize)(1,null),type:"object",scope:$,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,L.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,L.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,L.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,L.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,L.localize)(6,null),(0,L.localize)(7,null),(0,L.localize)(8,null),(0,L.localize)(9,null)],default:"override",description:(0,L.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,L.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,L.localize)(12,null),restricted:!0}}},c.updateConfigurations({add:[g],remove:n?[n]:[]})}l(1)}),define(be[232],we([1,0,20,12,16,44]),function(ue,e,y,R,r,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9N=void 0;let I=class{constructor(p,w){this.a=p,this.b=w}async download(p,w,A=y.CancellationToken.None){if(p.scheme===R.Schemas.file||p.scheme===R.Schemas.vscodeRemote){await this.b.copy(p,w);return}const k={type:"GET",url:p.toString(!0)},v=await this.a.request(k,A);if(v.res.statusCode===200)await this.b.writeFile(w,v.stream);else{const u=await(0,L.$3o)(v);throw new Error(`Expected 200, got back ${v.res.statusCode} instead.

${u}`)}}};e.$9N=I,e.$9N=I=Re([Ae(0,L.$Xo),Ae(1,r.$_j)],I)}),define(be[233],we([1,0,15,20]),function(ue,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2q=e.$1q=void 0;class r{constructor(C){this.a=C}listen(C,p){throw new Error("Invalid listen")}call(C,p,w,A=R.CancellationToken.None){switch(p){case"request":return this.a.request(w[0],A).then(async({res:k,stream:v})=>{const u=await(0,y.$oe)(v);return[{statusCode:k.statusCode,headers:k.headers},u]});case"resolveProxy":return this.a.resolveProxy(w[0])}throw new Error("Invalid call")}}e.$1q=r;class L{constructor(C){this.a=C}async request(C,p){const[w,A]=await this.a.call("request",[C],p);return{res:w,stream:(0,y.$qe)(A)}}async resolveProxy(C){return this.a.call("resolveProxy",[C])}}e.$2q=L}),define(be[234],we([1,0,85,8]),function(ue,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3q=void 0;function r(I,C){return I.protocol==="http:"?C.HTTP_PROXY||C.http_proxy||null:I.protocol==="https:"&&(C.HTTPS_PROXY||C.https_proxy||C.HTTP_PROXY||C.http_proxy)||null}async function L(I,C,p={}){const w=(0,y.parse)(I),A=p.proxyUrl||r(w,C);if(!A)return null;const k=(0,y.parse)(A);if(!/^https?:$/.test(k.protocol||""))return null;const v={host:k.hostname||"",port:(k.port?+k.port:0)||(k.protocol==="https"?443:80),auth:k.auth,rejectUnauthorized:(0,R.$Ff)(p.strictSSL)?p.strictSSL:!0};return w.protocol==="http:"?new(await new Promise((u,b)=>{ue(["http-proxy-agent"],u,b)})).HttpProxyAgent(A,v):new(await new Promise((u,b)=>{ue(["https-proxy-agent"],u,b)})).HttpsProxyAgent(A,v)}e.$3q=L}),define(be[86],we([1,0,52,7,192,20,40,11,3,23,105,209,14,144]),function(ue,e,y,R,r,L,I,C,p,w,A,k,v,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vl=void 0;let b;async function m(h,g,l,$){return l["force-disable-user-env"]?(g.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):p.$d?(g.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,k.$Pl)($)&&!l["force-user-env"]?(g.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,k.$Pl)($)?g.trace("resolveShellEnv(): running (--force-user-env)"):g.trace("resolveShellEnv(): running (macOS/Linux)"),b||(b=v.Promises.withAsyncBody(async(c,n)=>{const i=new L.$Yd;let o=1e4;const s=h.getValue("application.shellEnvironmentResolutionTimeout");typeof s=="number"&&(o=(0,u.$Ql)(s,1,120)*1e3);const t=setTimeout(()=>{i.dispose(!0),n(new Error((0,r.localize)(0,null)))},o);try{c(await d(g,i.token))}catch(a){!(0,C.$4)(a)&&!i.token.isCancellationRequested?n(new Error((0,r.localize)(1,null,(0,I.$Bi)(a)))):c({})}finally{clearTimeout(t),i.dispose()}})),b)}e.$Vl=m;async function d(h,g){const l=process.env.ELECTRON_RUN_AS_NODE;h.trace("getUnixShellEnvironment#runAsNode",l);const $=process.env.ELECTRON_NO_ATTACH_CONSOLE;h.trace("getUnixShellEnvironment#noAttach",$);const c=(0,w.$fg)().replace(/-/g,"").substr(0,12),n=new RegExp(c+"({.*})"+c),i={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};h.trace("getUnixShellEnvironment#env",i);const o=await(0,A.$Fl)(p.OS,i);return h.trace("getUnixShellEnvironment#shell",o),new Promise((s,t)=>{if(g.isCancellationRequested)return t(new C.$5);const a=(0,R.$nc)(o);let f,S;const D=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(a)?(f=`& '${process.execPath}' ${D} -p '''${c}'' + JSON.stringify(process.env) + ''${c}'''`,S=["-Login","-Command"]):a==="nu"?(f=`^'${process.execPath}' ${D} -p '"${c}" + JSON.stringify(process.env) + "${c}"'`,S=["-i","-l","-c"]):(f=`'${process.execPath}' ${D} -p '"${c}" + JSON.stringify(process.env) + "${c}"'`,a==="tcsh"||a==="csh"?S=["-ic"]:S=["-i","-l","-c"]),h.trace("getUnixShellEnvironment#spawn",JSON.stringify(S),f);const E=(0,y.spawn)(o,[...S,f],{detached:!0,stdio:["ignore","pipe","pipe"],env:i});g.onCancellationRequested(()=>(E.kill(),t(new C.$5))),E.on("error",ee=>{h.error("getUnixShellEnvironment#errorChildProcess",(0,I.$Bi)(ee)),t(ee)});const P=[];E.stdout.on("data",ee=>P.push(ee));const M=[];E.stderr.on("data",ee=>M.push(ee)),E.on("close",(ee,se)=>{const G=Buffer.concat(P).toString("utf8");h.trace("getUnixShellEnvironment#raw",G);const ne=Buffer.concat(M).toString("utf8");if(ne.trim()&&h.trace("getUnixShellEnvironment#stderr",ne),ee||se)return t(new Error((0,r.localize)(2,null,ee,se)));const he=n.exec(G),Z=he?he[1]:"{}";try{const fe=JSON.parse(Z);l?fe.ELECTRON_RUN_AS_NODE=l:delete fe.ELECTRON_RUN_AS_NODE,$?fe.ELECTRON_NO_ATTACH_CONSOLE=$:delete fe.ELECTRON_NO_ATTACH_CONSOLE,delete fe.VSCODE_RESOLVING_ENVIRONMENT,delete fe.XDG_RUNTIME_DIR,h.trace("getUnixShellEnvironment#result",fe),s(fe)}catch(fe){h.error("getUnixShellEnvironment#errorCaught",(0,I.$Bi)(fe)),t(fe)}})})}}),define(be[235],we([1,0,6]),function(ue,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HN=e.$GN=void 0,e.$GN=(0,y.$Qh)("stateReadService"),e.$HN=(0,y.$Qh)("stateService")}),define(be[236],we([1,0,14,15,2,8,25,16,13]),function(ue,e,y,R,r,L,I,C,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KN=e.$JN=e.$IN=e.SaveStrategy=void 0;var w;(function(u){u[u.IMMEDIATE=0]="IMMEDIATE",u[u.DELAYED=1]="DELAYED"})(w||(e.SaveStrategy=w={}));class A extends r.$Sc{constructor(b,m,d,h){super(),this.h=b,this.j=d,this.m=h,this.a=Object.create(null),this.b="",this.f=void 0,this.g=void 0,this.c=m===0?void 0:this.B(new y.$Sg(100))}init(){return this.f||(this.f=this.n()),this.f}async n(){try{this.b=(await this.m.readFile(this.h)).value.toString(),this.a=JSON.parse(this.b)}catch(b){b.fileOperationResult!==1&&this.j.error(b)}}getItem(b,m){const d=this.a[b];return(0,L.$If)(d)?m:d}setItem(b,m){this.setItems([{key:b,data:m}])}setItems(b){let m=!1;for(const{key:d,data:h}of b)this.a[d]!==h&&((0,L.$If)(h)?(0,L.$Gf)(this.a[d])||(this.a[d]=void 0,m=!0):(this.a[d]=h,m=!0));m&&this.r()}removeItem(b){(0,L.$Gf)(this.a[b])||(this.a[b]=void 0,this.r())}async r(){if(!this.g)return this.c?this.c.trigger(()=>this.s()):this.s()}async s(){if(!this.f)return;await this.f;const b=JSON.stringify(this.a,null,4);if(b!==this.b)try{await this.m.writeFile(this.h,R.$ce.fromString(b),{atomic:{postfix:".vsctmp"}}),this.b=b}catch(m){this.j.error(m)}}async close(){return this.g||(this.g=this.c?this.c.trigger(()=>this.s(),0):this.s()),this.g}}e.$IN=A;let k=class extends r.$Sc{constructor(b,m,d,h){super(),this.a=this.B(new A(m.stateResource,b,d,h))}async init(){await this.a.init()}getItem(b,m){return this.a.getItem(b,m)}};e.$JN=k,e.$JN=k=Re([Ae(1,I.$Xh),Ae(2,p.$$i),Ae(3,C.$_j)],k);class v extends k{setItem(b,m){this.a.setItem(b,m)}setItems(b){this.a.setItems(b)}removeItem(b){this.a.removeItem(b)}close(){return this.a.close()}}e.$KN=v}),define(be[119],we([1,0,3,28,23]),function(ue,e,y,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$no=e.$mo=void 0;function L(p){if(y.$o===2&&/^penguin(\.|$)/i.test(p))return"chromebook"}function I(p,w,A,k,v,u,b,m,d){const h=Object.create(null);h["common.machineId"]=u,h["common.sqmId"]=b,h.sessionID=(0,r.$fg)()+Date.now(),h.commitHash=k,h.version=v,h["common.platformVersion"]=(p||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),h["common.platform"]=(0,y.$c)(y.$o),h["common.nodePlatform"]=R.$dc,h["common.nodeArch"]=A,h["common.product"]=d||"desktop",m&&(h["common.msftInternal"]=m);let g=0;const l=Date.now();Object.defineProperties(h,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-l,enumerable:!0},"common.sequence":{get:()=>g++,enumerable:!0}}),y.$g&&(h["common.snap"]="true");const $=L(w);return $&&(h["common.platformDetail"]=$),h}e.$mo=I;function C(p){const w=R.env.USERDNSDOMAIN;if(!w)return!1;const A=w.toLowerCase();return p.some(k=>A===k)}e.$no=C}),define(be[237],we([1,0,18,11,2,22,16]),function(ue,e,y,R,r,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ErrorEvent=void 0;var C;(function(w){function A(k,v){return k.callstack<v.callstack?-1:k.callstack>v.callstack?1:0}w.compare=A})(C||(e.ErrorEvent=C={}));class p{constructor(A,k=p.ERROR_FLUSH_TIMEOUT){this.f=-1,this.g=[],this.h=new r.$Rc,this.c=A,this.d=k;const v=R.$X.addListener(u=>this.j(u));this.h.add((0,r.$Qc)(v)),this.i()}dispose(){clearTimeout(this.f),this.l(),this.h.dispose()}i(){}j(A){if(!A||A.code||(A.detail&&A.detail.stack&&(A=A.detail),R.$bb.isErrorNoTelemetry(A)||A instanceof I.$uk||typeof A?.message=="string"&&A.message.includes("Unable to read file")))return;const k=Array.isArray(A.stack)?A.stack.join(`
`):A.stack,v=A.message?A.message:(0,L.$bn)(A);k&&this.k({msg:v,callstack:k})}k(A){const k=(0,y.$wb)(this.g,A,C.compare);k<0?(A.count=1,this.g.splice(~k,0,A)):(this.g[k].count||(this.g[k].count=0),this.g[k].count+=1),this.f===-1&&(this.f=setTimeout(()=>{this.l(),this.f=-1},this.d))}l(){for(const A of this.g)this.c.publicLogError2("UnhandledError",A);this.g.length=0}}p.ERROR_FLUSH_TIMEOUT=5*1e3,e.default=p}),define(be[238],we([1,0,2]),function(ue,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tr=void 0;class R extends y.$Sc{constructor(L,I){super(),this.a=L,this.b=I}async call(L,I,C){switch(I){case"updateTelemetryLevel":{const{telemetryLevel:p}=C;return this.a.updateInjectedTelemetryLevel(p)}case"logTelemetry":{const{eventName:p,data:w}=C;return this.b?this.b.log(p,w):Promise.resolve()}case"flushTelemetry":return this.b?this.b.flush():Promise.resolve();case"ping":return}throw new Error(`IPC Command ${I} not found`)}listen(L,I,C){throw new Error("Not supported")}dispose(){this.a.updateInjectedTelemetryLevel(0),super.dispose()}}e.$Tr=R}),define(be[32],we([1,0,6]),function(ue,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$nl=e.$ml=e.$ll=e.$kl=e.$jl=e.$il=e.$hl=e.$gl=e.$fl=e.$el=e.$dl=void 0,e.$dl=(0,y.$Qh)("telemetryService"),e.$el=(0,y.$Qh)("customEndpointTelemetryService"),e.$fl="telemetry.currentSessionDate",e.$gl="telemetry.firstSessionDate",e.$hl="telemetry.lastSessionDate",e.$il="telemetry.machineId",e.$jl="telemetry.sqmId",e.$kl="telemetry",e.$ll="telemetry.telemetryLevel",e.$ml="telemetry.enableCrashReporter",e.$nl="telemetry.enableTelemetry";var R;(function(L){L[L.NONE=0]="NONE",L[L.CRASH=1]="CRASH",L[L.ERROR=2]="ERROR",L[L.USAGE=3]="USAGE"})(R||(e.TelemetryLevel=R={}));var r;(function(L){L.OFF="off",L.CRASH="crash",L.ERROR="error",L.ON="all"})(r||(e.TelemetryConfiguration=r={}))}),define(be[239],we([1,0,27,14,75,12,7,3,4,101,21,104,215,16,31,32]),function(ue,e,y,R,r,L,I,C,p,w,A,k,v,u,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lr=e.$Kr=e.$Jr=e.$Ir=void 0;const d=new Map;async function h(n,i){const o=`${n}::${i.join(":")}`,s=d.get(o);if(s)return s;const t=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],a=new Map,f=new Map,S=2e4;function D(P,M,ee,se){const G=M.substring(P.length+1);return R.Promises.withAsyncBody(async ne=>{let he;try{he=await A.Promises.readdir(M,{withFileTypes:!0})}catch{ne();return}if(se.count>=S){se.count+=he.length,se.maxReached=!0,ne();return}let Z=he.length;if(Z===0){ne();return}let fe=he;se.count+he.length>S&&(se.maxReached=!0,Z=S-se.count,fe=he.slice(0,Z)),se.count+=he.length;for(const V of fe)if(V.isDirectory()){if(ee.includes(V.name)||await D(P,(0,I.$jc)(M,V.name),ee,se),--Z===0){ne();return}}else{const ie=V.name.lastIndexOf(".");if(ie>=0){const Y=V.name.substring(ie+1);Y&&a.set(Y,(a.get(Y)??0)+1)}for(const Y of t)Y.relativePathPattern?.test(G)!==!1&&Y.filePattern.test(V.name)&&f.set(Y.tag,(f.get(Y.tag)??0)+1);if(--Z===0){ne();return}}})}const E=R.Promises.withAsyncBody(async P=>{const M={count:0,maxReached:!1};await D(n,n,i,M);const ee=await $(n);P({configFiles:g(f),fileTypes:g(a),fileCount:M.count,maxFilesReached:M.maxReached,launchConfigFiles:ee})});return d.set(o,E),E}e.$Ir=h;function g(n){return Array.from(n.entries(),([i,o])=>({name:i,count:o})).sort((i,o)=>o.count-i.count)}function l(){const n={os:`${y.type()} ${y.arch()} ${y.release()}`,memory:`${(y.totalmem()/u.$Hk.GB).toFixed(2)}GB (${(y.freemem()/u.$Hk.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(w.$Tm.value()*100)}%`},i=y.cpus();return i&&i.length>0&&(n.cpus=`${i[0].model} (${i.length} x ${i[0].speed})`),n}e.$Jr=l;async function $(n){try{const i=new Map,o=(0,I.$jc)(n,".vscode","launch.json"),s=await A.Promises.readFile(o),t=[],a=(0,r.$Ym)(s.toString(),t);if(t.length)return console.log(`Unable to parse ${o}`),[];if((0,r.$8m)(a)==="object"&&a.configurations)for(const f of a.configurations){const S=f.type;S&&(i.has(S)?i.set(S,i.get(S)+1):i.set(S,1))}return g(i)}catch{return[]}}e.$Kr=$;let c=class{constructor(i,o){this.c=i,this.d=o}f(i){const o=[];return o.push(`OS Version:       ${i.os}`),o.push(`CPUs:             ${i.cpus}`),o.push(`Memory (System):  ${i.memory}`),o.push(`VM:               ${i.vmHint}`),o.join(`
`)}g(i){const o=[];o.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),o.push(`OS Version:       ${y.type()} ${y.arch()} ${y.release()}`);const s=y.cpus();return s&&s.length>0&&o.push(`CPUs:             ${s[0].model} (${s.length} x ${s[0].speed})`),o.push(`Memory (System):  ${(y.totalmem()/u.$Hk.GB).toFixed(2)}GB (${(y.freemem()/u.$Hk.GB).toFixed(2)}GB free)`),C.$d||o.push(`Load (avg):       ${y.loadavg().map(t=>Math.round(t)).join(", ")}`),o.push(`VM:               ${Math.round(w.$Tm.value()*100)}%`),o.push(`Screen Reader:    ${i.screenReader?"yes":"no"}`),o.push(`Process Argv:     ${i.mainArguments.join(" ")}`),o.push(`GPU Status:       ${this.j(i.gpuFeatureStatus)}`),o.join(`
`)}async getPerformanceInfo(i,o){return Promise.all([(0,k.$Hr)(i.mainPID),this.k(i)]).then(async s=>{let[t,a]=s,f=this.m(i,t);return o.forEach(S=>{if((0,v.$tm)(S))f+=`
${S.errorMessage}`,a+=`
${S.errorMessage}`;else if(f+=`

Remote: ${S.hostName}`,S.processes&&(f+=`
${this.m(i,S.processes)}`),S.workspaceMetadata){a+=`
|  Remote: ${S.hostName}`;for(const D of Object.keys(S.workspaceMetadata)){const E=S.workspaceMetadata[D];let P=`${E.fileCount} files`;E.maxFilesReached&&(P=`more than ${P}`),a+=`|    Folder (${D}): ${P}`,a+=this.h(E)}}}),{processInfo:f,workspaceInfo:a}})}async getSystemInfo(i,o){const{memory:s,vmHint:t,os:a,cpus:f}=l(),S={os:a,memory:s,cpus:f,vmHint:t,processArgs:`${i.mainArguments.join(" ")}`,gpuStatus:i.gpuFeatureStatus,screenReader:`${i.screenReader?"yes":"no"}`,remoteData:o};return C.$d||(S.load=`${y.loadavg().map(D=>Math.round(D)).join(", ")}`),C.$f&&(S.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(S)}async getDiagnostics(i,o){const s=[];return(0,k.$Hr)(i.mainPID).then(async t=>(s.push(""),s.push(this.g(i)),s.push(""),s.push(this.m(i,t)),i.windows.some(a=>a.folderURIs&&a.folderURIs.length>0&&!a.remoteAuthority)&&(s.push(""),s.push("Workspace Stats: "),s.push(await this.k(i))),o.forEach(a=>{if((0,v.$tm)(a))s.push(`
${a.errorMessage}`);else if(s.push(`

`),s.push(`Remote:           ${a.hostName}`),s.push(this.f(a.machineInfo)),a.processes&&s.push(this.m(i,a.processes)),a.workspaceMetadata)for(const f of Object.keys(a.workspaceMetadata)){const S=a.workspaceMetadata[f];let D=`${S.fileCount} files`;S.maxFilesReached&&(D=`more than ${D}`),s.push(`Folder (${f}): ${D}`),s.push(this.h(S))}}),s.push(""),s.push(""),s.join(`
`)))}h(i){const o=[];let t=0;const a=(E,P)=>{const M=` ${E}(${P})`;t+M.length>60?(o.push(f),f="|                 ",t=f.length):t+=M.length,f+=M};let f="|      File types:";const S=10,D=i.fileTypes.length>S?S:i.fileTypes.length;for(let E=0;E<D;E++){const P=i.fileTypes[E];a(P.name,P.count)}if(o.push(f),i.configFiles.length>=0&&(f="|      Conf files:",t=0,i.configFiles.forEach(E=>{a(E.name,E.count)}),o.push(f)),i.launchConfigFiles.length>0){let E="|      Launch Configs:";i.launchConfigFiles.forEach(P=>{const M=P.count>1?` ${P.name}(${P.count})`:` ${P.name}`;E+=M}),o.push(E)}return o.join(`
`)}j(i){const o=Math.max(...Object.keys(i).map(s=>s.length));return Object.keys(i).map(s=>`${s}:  ${" ".repeat(o-s.length)}  ${i[s]}`).join(`
                  `)}k(i){const o=[],s=[];return i.windows.forEach(t=>{t.folderURIs.length===0||t.remoteAuthority||(o.push(`|  Window (${t.title})`),t.folderURIs.forEach(a=>{const f=p.URI.revive(a);if(f.scheme===L.Schemas.file){const S=f.fsPath;s.push(h(S,["node_modules",".git"]).then(D=>{let E=`${D.fileCount} files`;D.maxFilesReached&&(E=`more than ${E}`),o.push(`|    Folder (${(0,I.$nc)(S)}): ${E}`),o.push(this.h(D))}).catch(D=>{o.push(`|      Error: Unable to collect workspace stats for folder ${S} (${D.toString()})`)}))}else o.push(`|    Folder (${f.toString()}): Workspace stats not available.`)}))}),Promise.all(s).then(t=>o.join(`
`)).catch(t=>`Unable to collect workspace stats: ${t}`)}m(i,o){const s=new Map;i.windows.forEach(a=>s.set(a.pid,`window [${a.id}] (${a.title})`)),i.pidToNames.forEach(({pid:a,name:f})=>s.set(a,f));const t=[];return t.push("CPU %	Mem MB	   PID	Process"),o&&this.n(i.mainPID,s,t,o,0),t.join(`
`)}n(i,o,s,t,a){const f=a===0;let S;f?S=t.pid===i?`${this.d.applicationName} main`:"remote agent":o.has(t.pid)?S=o.get(t.pid):S=`${"  ".repeat(a)} ${t.name}`;const D=process.platform==="win32"?t.mem:y.totalmem()*(t.mem/100);s.push(`${t.load.toFixed(0).padStart(5," ")}	${(D/u.$Hk.MB).toFixed(0).padStart(6," ")}	${t.pid.toFixed(0).padStart(6," ")}	${S}`),Array.isArray(t.children)&&t.children.forEach(E=>this.n(i,o,s,E,a+1))}async getWorkspaceFileExtensions(i){const o=new Set;for(const{uri:s}of i.folders){const t=p.URI.revive(s);if(t.scheme!==L.Schemas.file)continue;const a=t.fsPath;try{(await h(a,["node_modules",".git"])).fileTypes.forEach(S=>o.add(S.name))}catch{}}return{extensions:[...o]}}async reportWorkspaceStats(i){for(const{uri:o}of i.folders){const s=p.URI.revive(o);if(s.scheme!==L.Schemas.file)continue;const t=s.fsPath;try{const a=await h(t,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":i.telemetryId,rendererSessionId:i.rendererSessionId}),a.fileTypes.forEach(f=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:i.rendererSessionId,type:f.name,count:f.count})}),a.launchConfigFiles.forEach(f=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:i.rendererSessionId,type:f.name,count:f.count})}),a.configFiles.forEach(f=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:i.rendererSessionId,type:f.name,count:f.count})})}catch{}}}};e.$Lr=c,e.$Lr=c=Re([Ae(0,m.$dl),Ae(1,b.$qj)],c)}),define(be[38],we([1,0,22,8,5,24,57,119,32]),function(ue,e,y,R,r,L,I,C,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Do=e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=e.$oo=void 0;class w{constructor(t){this.value=t,this.isTrustedTelemetryValue=!0}}e.$oo=w;class A{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$po=A,e.$qo=new A;class k{async publicLog(t,a,f){}async publicLogError(t,a,f){}}e.$ro=k,e.$so="telemetry",e.$to="extensionTelemetryLog",e.$uo={log:()=>null,flush:()=>Promise.resolve(null)};function v(s,t){return r.Event.debounce(t.onDidChangeConfiguration,(f,S)=>{const D=f?new Set([...f.affectedKeys,...S.affectedKeys]):S.affectedKeys;return{...S,affectedKeys:D}},1e3,!0)(f=>{f.source!==7&&s.publicLog2("updateConfiguration",{configurationSource:(0,L.$ni)(f.source),configurationKeys:Array.from(f.affectedKeys)})})}e.$vo=v;function u(s,t){return!t.isBuilt&&!t.disableTelemetry?!0:!(t.disableTelemetry||!s.enableTelemetry)}e.$wo=u;function b(s,t){return t.extensionTestsLocationURI?!0:!(t.isBuilt||t.disableTelemetry||s.enableTelemetry&&s.aiConfig?.ariaKey)}e.$xo=b;function m(s){const t=s.getValue(p.$ll),a=s.getValue(p.$ml);if(s.getValue(p.$nl)===!1||a===!1)return 0;switch(t??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$yo=m;function d(s){const t={},a={},f={};l(s,f);for(let S in f){S=S.length>150?S.substr(S.length-149):S;const D=f[S];typeof D=="number"?a[S]=D:typeof D=="boolean"?a[S]=D?1:0:typeof D=="string"?(D.length>8192&&console.warn(`Telemetry property: ${S} has been trimmed to 8192, the original length is ${D.length}`),t[S]=D.substring(0,8191)):typeof D<"u"&&D!==null&&(t[S]=D)}return{properties:t,measurements:a}}e.$zo=d;const h=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function g(s){if(!s)return"none";const t=(0,I.$Wk)(s);return h.has(t)?t:"other"}e.$Ao=g;function l(s,t,a=0,f){if(s)for(const S of Object.getOwnPropertyNames(s)){const D=s[S],E=f?f+S:S;Array.isArray(D)?t[E]=(0,y.$bn)(D):D instanceof Date?t[E]=D.toISOString():(0,R.$Bf)(D)?a<2?l(D,t,a+1,E+"."):t[E]=(0,y.$bn)(D):t[E]=D}}function $(s,t){const a=s.msftInternalDomains||[],f=t.getValue("telemetry.internalTesting");return(0,C.$no)(a)||f}e.$Bo=$;function c(s){return[s.appRoot,s.extensionsPath,s.userHome.fsPath,s.tmpDir.fsPath,s.userDataPath]}e.$Co=c;function n(s,t){if(!s||!s.includes("/")&&!s.includes("\\"))return s;let a=s;const f=[];for(const P of t)for(;;){const M=P.exec(s);if(!M)break;f.push([M.index,P.lastIndex])}const S=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,D=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let E=0;for(a="";;){const P=D.exec(s);if(!P)break;const M=f.some(([ee,se])=>P.index<se&&ee<D.lastIndex);!S.test(P[0])&&!M&&(a+=s.substring(E,P.index)+"<REDACTED: user-file-path>",E=D.lastIndex)}return E<s.length&&(a+=s.substr(E)),a}function i(s){if(!s)return s;const t=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const a of t)if(a.regex.test(s))return`<REDACTED: ${a.label}>`;return s}function o(s,t){return(0,y.$$m)(s,a=>{if(a instanceof w||Object.hasOwnProperty.call(a,"isTrustedTelemetryValue"))return a.value;if(typeof a=="string"){let f=a.replaceAll("%20"," ");f=n(f,t);for(const S of t)f=f.replace(S,"");return f=i(f),f}})}e.$Do=o}),define(be[36],we([1,0,17,30,35,3,4,11,28,38]),function(ue,e,y,R,r,L,I,C,p,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Po=e.$Oo=e.$No=e.$Mo=e.$Lo=e.$Ko=e.$Jo=e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=void 0;function A(o,s){return o.uuid&&s.uuid?o.uuid===s.uuid:o.id===s.id?!0:(0,y.$Xe)(o.id,s.id)===0}e.$Eo=A;const k=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class v{static create(s){const t=s.manifest?s.manifest.version:s.version,a=s.manifest?s.targetPlatform:s.properties.targetPlatform;return new v(s.identifier,t,a)}static parse(s){const t=k.exec(s);return t&&t[1]&&t[2]?new v({id:t[1]},t[2],t[4]||void 0):null}constructor(s,t,a="undefined"){this.version=t,this.targetPlatform=a,this.id=s.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(s){return s instanceof v?A(this,s)&&this.version===s.version&&this.targetPlatform===s.targetPlatform:!1}}e.$Fo=v;const u=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function b(o){const s=u.exec(o);return s&&s[1]?[d(s[1]),s[2]]:[d(o),void 0]}e.$Go=b;function m(o,s){return`${o}.${s}`}e.$Ho=m;function d(o){return o.toLowerCase()}e.$Io=d;function h(o,s){return d(m(o??r.$4l,s))}e.$Jo=h;function g(o,s){const t=[],a=f=>{for(const S of t)if(S.some(D=>A(s(D),s(f))))return S;return null};for(const f of o){const S=a(f);S?S.push(f):t.push([f])}return t}e.$Ko=g;function l(o){return{id:o.identifier.id,name:o.manifest.name,galleryId:null,publisherId:o.publisherId,publisherName:o.manifest.publisher,publisherDisplayName:o.publisherDisplayName,dependencies:o.manifest.extensionDependencies&&o.manifest.extensionDependencies.length>0}}e.$Lo=l;function $(o){return{id:new w.$oo(o.identifier.id),name:new w.$oo(o.name),galleryId:o.identifier.uuid,publisherId:o.publisherId,publisherName:o.publisher,publisherDisplayName:o.publisherDisplayName,isPreReleaseVersion:o.properties.isPreReleaseVersion,dependencies:!!(o.properties.dependencies&&o.properties.dependencies.length>0),isSigned:o.isSigned,...o.telemetryData}}e.$Mo=$,e.$No=new r.$8l("pprice.better-merge");function c(o,s){const t=[],a=s.manifest.extensionDependencies?.slice(0)??[];for(;a.length;){const f=a.shift();if(f&&t.every(S=>!A(S.identifier,{id:f}))){const S=o.filter(D=>A(D.identifier,{id:f}));S.length===1&&(t.push(S[0]),a.push(...S[0].manifest.extensionDependencies?.slice(0)??[]))}}return t}e.$Oo=c;async function n(o,s){if(!L.$f)return!1;let t;try{t=(await o.readFile(I.URI.file("/etc/os-release"))).value.toString()}catch{try{t=(await o.readFile(I.URI.file("/usr/lib/os-release"))).value.toString()}catch(f){s.debug("Error while getting the os-release file.",(0,C.$0)(f))}}return!!t&&(t.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function i(o,s){const t=await n(o,s),a=(0,R.$$n)(t?"alpine":L.$o,p.$ec);return s.debug("ComputeTargetPlatform:",a),a}e.$Po=i}),define(be[120],we([1,0,20,11,12,19,53,4,179,30,36,35]),function(ue,e,y,R,r,L,I,C,p,w,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lp=void 0;const v=d=>(0,p.localize)(0,null,d),u=(0,p.localize)(1,null,"ms-dotnettools.csharp");function b(d,h){return h?`${d.publisher}.${d.name}@${d.version}`:`${d.publisher}.${d.name}`}let m=class{constructor(h,g,l){this.a=h,this.b=g,this.d=l}get f(){}async listExtensions(h,g,l){let $=await this.b.getInstalled(1,l);const c=k.$7l.map(i=>i.toLowerCase());if(g&&g!==""){if(c.indexOf(g.toLowerCase())<0){this.a.info("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}$=$.filter(i=>i.manifest.categories?i.manifest.categories.map(s=>s.toLowerCase()).indexOf(g.toLowerCase())>-1:!1)}else if(g===""){this.a.info("Possible Categories: "),c.forEach(i=>{this.a.info(i)});return}this.f&&this.a.info((0,p.localize)(2,null,this.f)),$=$.sort((i,o)=>i.identifier.id.localeCompare(o.identifier.id));let n;for(const i of $)n!==i.identifier.id&&(n=i.identifier.id,this.a.info(b(i.manifest,h)))}async installExtensions(h,g,l,$){const c=[];try{const n=[];h.length&&this.a.info(this.f?(0,p.localize)(3,null,this.f):(0,p.localize)(4,null));const i=[];let o=[];const s=(a,f,S)=>{o.push({id:a,version:f!=="prerelease"?f:void 0,installOptions:{...l,isBuiltin:S,installPreReleaseVersion:f==="prerelease"||l.installPreReleaseVersion}})};for(const a of h)if(a instanceof C.URI)i.push({vsix:a,installOptions:l});else{const[f,S]=(0,A.$Go)(a);s(f,S,!1)}for(const a of g)if(a instanceof C.URI)i.push({vsix:a,installOptions:{...l,isBuiltin:!0,donotIncludePackAndDependencies:!0}});else{const[f,S]=(0,A.$Go)(a);s(f,S,!0)}const t=await this.b.getInstalled(1,l.profileLocation);if(i.length&&await Promise.all(i.map(async({vsix:a,installOptions:f})=>{try{const S=await this.g(a,f,$,t);S&&n.push(S)}catch(S){this.a.error(S),c.push(a.toString())}})),o.length&&(o=o.filter(({id:a,version:f})=>{const S=t.find(D=>(0,A.$Eo)(D.identifier,{id:a}));if(S){if(!$&&(!f||f==="prerelease"&&S.preRelease))return this.a.info((0,p.localize)(5,null,a,S.manifest.version,a)),!1;if(f&&S.manifest.version===f)return this.a.info((0,p.localize)(6,null,`${a}@${f}`)),!1}return!0}),o.length)){const a=await this.h(o);await Promise.all(o.map(async f=>{const S=a.get(f.id.toLowerCase());if(S)try{const D=await this.j(f,S,t);D&&n.push(D)}catch(D){this.a.error(D.message||D.stack||D),c.push(f.id)}else this.a.error(`${v(f.version?`${f.id}@${f.version}`:f.id)}
${u}`),c.push(f.id)}))}}catch(n){throw this.a.error((0,p.localize)(7,null,(0,R.$0)(n))),n}if(c.length)throw new Error((0,p.localize)(8,null,c.join(", ")))}async g(h,g,l,$){const c=await this.b.getManifest(h);if(!c)throw new Error("Invalid vsix");if(await this.l(c,l,g.profileLocation,$))try{return await this.b.install(h,g),this.a.info((0,p.localize)(9,null,(0,L.$tg)(h))),c}catch(i){if((0,R.$4)(i))return this.a.info((0,p.localize)(10,null,(0,L.$tg)(h))),null;throw i}return null}async h(h){const g=new Map,l=h.some(n=>n.installOptions.installPreReleaseVersion),$=await this.b.getTargetPlatform(),c=[];for(const n of h)w.$4n.test(n.id)&&c.push({...n,preRelease:l});if(c.length){const n=await this.d.getExtensions(c,{targetPlatform:$},y.CancellationToken.None);for(const i of n)g.set(i.identifier.id.toLowerCase(),i)}return g}async j({id:h,version:g,installOptions:l},$,c){const n=await this.d.getManifest($,y.CancellationToken.None);if(n&&!this.k(n))return null;const i=c.find(o=>(0,A.$Eo)(o.identifier,$.identifier));if(i){if($.version===i.manifest.version)return this.a.info((0,p.localize)(11,null,g?`${h}@${g}`:h)),null;this.a.info((0,p.localize)(12,null,h,$.version))}try{l.isBuiltin?this.a.info(g?(0,p.localize)(13,null,h,g):(0,p.localize)(14,null,h)):this.a.info(g?(0,p.localize)(15,null,h,g):(0,p.localize)(16,null,h));const o=await this.b.installFromGallery($,{...l,installGivenVersion:!!g});return this.a.info((0,p.localize)(17,null,h,o.manifest.version)),n}catch(o){if((0,R.$4)(o))return this.a.info((0,p.localize)(18,null,h)),null;throw o}}k(h){return!0}async l(h,g,l,$){if(!g){const c={id:(0,A.$Jo)(h.publisher,h.name)},n=$.find(i=>(0,A.$Eo)(c,i.identifier)&&(0,I.gt)(i.manifest.version,h.version));if(n)return this.a.info((0,p.localize)(19,null,n.identifier.id,n.manifest.version,h.version)),!1}return this.k(h)}async uninstallExtensions(h,g,l){const $=async n=>{if(n instanceof C.URI){const i=await this.b.getManifest(n);return b(i)}return n},c=[];for(const n of h){const i=await $(n),s=(await this.b.getInstalled(void 0,l)).filter(t=>(0,A.$Eo)(t.identifier,{id:i}));if(!s.length)throw new Error(`${this.m(i)}
${u}`);if(s.some(t=>t.type===0)){this.a.info((0,p.localize)(20,null,i));return}if(!g&&s.some(t=>t.isBuiltin)){this.a.info((0,p.localize)(21,null,i));return}this.a.info((0,p.localize)(22,null,i));for(const t of s)await this.b.uninstall(t,{profileLocation:l}),c.push(t);this.f?this.a.info((0,p.localize)(23,null,i,this.f)):this.a.info((0,p.localize)(24,null,i))}}async locateExtension(h){const g=await this.b.getInstalled();h.forEach(l=>{g.forEach($=>{if($.identifier.id===l&&$.location.scheme===r.Schemas.file){this.a.info($.location.fsPath);return}})})}m(h){return this.f?(0,p.localize)(25,null,h,this.f):(0,p.localize)(26,null,h)}};e.$lp=m,e.$lp=m=Re([Ae(1,w.$eo),Ae(2,w.$co)],m)}),define(be[240],we([1,0,5,2,26,36,35]),function(ue,e,y,R,r,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mp=void 0;class C extends R.$Sc{constructor(w,A,k,v,u,b,m){super(),this.f=w,this.g=A,this.h=k,this.j=v,this.m=u,this.n=b,this.r=m,this.a=this.B(new y.$Od),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new R.$1c),this.s().then(null,d=>m.error(d))}async s(){await this.g.initializeDefaultProfileExtensions(),await this.u(this.h.profiles),this.t(),await this.H()}t(){this.B(this.h.onDidChangeProfiles(w=>this.u(w.added))),this.B(this.j.onAddExtensions(w=>this.w(w))),this.B(this.j.onDidAddExtensions(w=>this.y(w))),this.B(this.j.onRemoveExtensions(w=>this.z(w))),this.B(this.j.onDidRemoveExtensions(w=>this.C(w))),this.B(this.n.onDidFilesChange(w=>this.D(w)))}async u(w){try{w.length&&await Promise.all(w.map(A=>(this.c.set(A.id,(0,R.$Pc)(this.n.watch(this.m.extUri.dirname(A.extensionsResource)),this.n.watch(A.extensionsResource))),this.G(A.extensionsResource))))}catch(A){throw this.r.error(A),A}}async w(w){for(const A of w.extensions)this.I(this.L(A.identifier,A.version),w.profileLocation)}async y(w){for(const A of w.extensions){const k=this.L(A.identifier,A.version);w.error?this.J(k,w.profileLocation):this.I(k,w.profileLocation)}}async z(w){for(const A of w.extensions)this.J(this.L(A.identifier,A.version),w.profileLocation)}async C(w){const A=[],k=[];for(const v of w.extensions){const u=this.L(v.identifier,v.version);w.error?this.I(u,w.profileLocation):(this.J(u,w.profileLocation),this.b.has(u)||(this.r.debug("Extension is removed from all profiles",v.identifier.id,v.version),k.push(this.f.scanInstalledExtensionAtLocation(v.location).then(b=>{b?A.push(b):this.r.info("Extension not found at the location",v.location.toString())},b=>this.r.error(b)))))}try{await Promise.all(k),A.length&&await this.H(A)}catch(v){this.r.error(v)}}D(w){for(const A of this.h.profiles)w.contains(A.extensionsResource,0,1)&&this.F(A.extensionsResource)}async F(w){const A=[],k=[],v=await this.j.scanProfileExtensions(w),u=new Set,b=new Set;for(const[m,d]of this.b)d.has(w)&&b.add(m);for(const m of v){const d=this.L(m.identifier,m.version);u.add(d),b.has(d)||(A.push(m.identifier),this.I(d,w))}for(const m of b)if(!u.has(m)){const d=this.M(m);d&&(k.push(d.identifier),this.J(m,w))}(A.length||k.length)&&this.a.fire({added:A.length?{extensions:A,profileLocation:w}:void 0,removed:k.length?{extensions:k,profileLocation:w}:void 0})}async G(w){const A=await this.j.scanProfileExtensions(w);for(const k of A)this.I(this.L(k.identifier,k.version),w)}async H(w){w||(w=(await this.f.scanAllUserInstalledExtensions()).filter(k=>!this.b.has(this.L(k.identifier,k.manifest.version)))),w.length&&await this.f.markAsUninstalled(...w)}I(w,A){let k=this.b.get(w);k||this.b.set(w,k=new r.$Bc(v=>this.m.extUri.getComparisonKey(v))),k.add(A)}J(w,A){const k=this.b.get(w);k&&k.delete(A),k?.size||this.b.delete(w)}L(w,A){return`${I.$8l.toKey(w.id)}@${A}`}M(w){const[A,k]=(0,L.$Go)(w);return k?{identifier:{id:A},version:k}:void 0}}e.$Mp=C}),define(be[241],we([1,0,212,38]),function(ue,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fp=void 0;async function r(L,I,C,p,w,A,k){const v={"X-Market-Client-Id":`VSCode ${L}`,"User-Agent":`VSCode ${L} (${I.nameShort})`};if((0,R.$wo)(I,C)&&(0,R.$yo)(p)===3){const u=await(0,y.$ep)(C,w,A);v["X-Market-User-Id"]=u,v["VSCode-SessionId"]=k.machineId||u}return v}e.$fp=r}),define(be[121],we([1,0,87,18,14,2,12,7,21,25,30,36,13,84,4]),function(ue,e,y,R,r,L,I,C,p,w,A,k,v,u,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zq=void 0;let m=class extends u.$Yq{constructor(l,$,c,n){super(c),this.h=l,this.j=n,this.g=this.B(new d($,n)),this.h.registerParticipant({postInstall:async i=>this.m(i),postUninstall:async i=>this.n(i)})}async getBuiltInExtensionTranslationsUri(l,$){const n=(await this.g.getLanguagePacks())[$];if(!n){this.j.warn(`No language pack found for ${$}`);return}const i=n.translations[l];return i?b.URI.file(i):void 0}async getInstalledLanguages(){const l=await this.g.getLanguagePacks(),$=Object.keys(l).map(c=>{const n=l[c];return{...this.f(c,n.label),extensionId:n.extensions[0].extensionIdentifier.id}});return $.push(this.f("en","English")),$.sort((c,n)=>c.label.localeCompare(n.label)),$}async m(l){l&&l.manifest&&l.manifest.contributes&&l.manifest.contributes.localizations&&l.manifest.contributes.localizations.length&&(this.j.info("Adding language packs from the extension",l.identifier.id),await this.update())}async n(l){const $=await this.g.getLanguagePacks();Object.keys($).some(c=>$[c]&&$[c].extensions.some(n=>(0,k.$Eo)(n.extensionIdentifier,l.identifier)))&&(this.j.info("Removing language packs from the extension",l.identifier.id),await this.update())}async update(){const[l,$]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),c=await this.g.update($);return!(0,R.$ub)(Object.keys(l),Object.keys(c))}};e.$Zq=m,e.$Zq=m=Re([Ae(0,A.$eo),Ae(1,w.$Yh),Ae(2,A.$co),Ae(3,v.$$i)],m);let d=class extends L.$Sc{constructor(l,$){super(),this.j=$,this.c={},this.f=(0,C.$jc)(l.userDataPath,"languagepacks.json"),this.g=new r.$2g}getLanguagePacks(){return this.g.size||!this.h?this.s().then(()=>this.c):Promise.resolve(this.c)}update(l){return this.s($=>{Object.keys($).forEach(c=>delete $[c]),this.m($,...l)}).then(()=>this.c)}m(l,...$){for(const c of $)c&&c.manifest&&c.manifest.contributes&&c.manifest.contributes.localizations&&c.manifest.contributes.localizations.length&&this.n(l,c);Object.keys(l).forEach(c=>this.r(l[c]))}n(l,$){const c=$.identifier,n=$.manifest.contributes&&$.manifest.contributes.localizations?$.manifest.contributes.localizations:[];for(const i of n)if($.location.scheme===I.Schemas.file&&h(i)){let o=l[i.languageId];o||(o={hash:"",extensions:[],translations:{},label:i.localizedLanguageName??i.languageName},l[i.languageId]=o);const s=o.extensions.filter(t=>(0,k.$Eo)(t.extensionIdentifier,c))[0];s?s.version=$.manifest.version:o.extensions.push({extensionIdentifier:c,version:$.manifest.version});for(const t of i.translations)o.translations[t.id]=(0,C.$jc)($.location.fsPath,t.path)}}r(l){if(l){const $=(0,y.createHash)("md5");for(const c of l.extensions)$.update(c.extensionIdentifier.uuid||c.extensionIdentifier.id).update(c.version);l.hash=$.digest("hex")}}s(l=()=>null){return this.g.queue(()=>{let $=null;return p.Promises.readFile(this.f,"utf8").then(void 0,c=>c.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(c)).then(c=>{try{return JSON.parse(c)}catch{return{}}}).then(c=>($=l(c),c)).then(c=>{for(const i of Object.keys(c))c[i]||delete c[i];this.c=c,this.h=!0;const n=JSON.stringify(this.c);return this.j.debug("Writing language packs",n),p.Promises.writeFile(this.f,n)}).then(()=>$,c=>this.j.error(c))})}};d=Re([Ae(0,w.$Yh),Ae(1,v.$$i)],d);function h(g){if(typeof g.languageId!="string"||!Array.isArray(g.translations)||g.translations.length===0)return!1;for(const l of g.translations)if(typeof l.id!="string"||typeof l.path!="string")return!1;return!(g.languageName&&typeof g.languageName!="string"||g.localizedLanguageName&&typeof g.localizedLanguageName!="string")}}),define(be[242],we([1,0,151,11,22,38]),function(ue,e,y,R,r,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CN=void 0;const I="https://mobile.events.data.microsoft.com/OneCollector/1.0",C="https://mobile.events.data.microsoft.com/ping";async function p(A,k,v){const u=await(0,y.$AC)("@microsoft/1ds-core-js","dist/ms.core.js"),b=await(0,y.$AC)("@microsoft/1ds-post-js","dist/ms.post.js"),m=new u.AppInsightsCore,d=new b.PostChannel,h={instrumentationKey:A,endpointUrl:I,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[d]]};if(v){h.extensionConfig={};const g={alwaysUseXhrOverride:!0,httpXHROverride:v};h.extensionConfig[d.identifier]=g}return m.initialize(h,[]),m.addTelemetryInitializer(g=>{k&&(g.ext=g.ext??{},g.ext.utc=g.ext.utc??{},g.ext.utc.flags=8462029)}),m}class w{constructor(k,v,u,b,m){this.e=k,this.f=v,this.g=u,this.h=m,this.c=I,this.d=C,this.g||(this.g={}),typeof b=="function"?this.a=b():this.a=b,this.b=null}i(k){if(this.a){if(typeof this.a!="string"){k(this.a);return}this.b||(this.b=p(this.a,this.e,this.h)),this.b.then(v=>{k(v)},v=>{(0,R.$1)(v),console.error(v)})}}log(k,v){if(!this.a)return;v=(0,r.$_m)(v,this.g),v=(0,L.$zo)(v);const u=this.f+"/"+k;try{this.i(b=>{b.pluginVersionString=v?.properties.version??"Unknown",b.track({name:u,baseData:{name:u,properties:v?.properties,measurements:v?.measurements}})})}catch{}}flush(){return this.a?new Promise(k=>{this.i(v=>{v.unload(!0,()=>{this.a=void 0,k(void 0)})})}):Promise.resolve(void 0)}}e.$CN=w}),define(be[243],we([1,0,2,22,3,17,193,24,56,55,31,37,32,38]),function(ue,e,y,R,r,L,I,C,p,w,A,k,v,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6q=void 0;let b=class{constructor(h,g,l){this.k=g,this.l=l,this.d={},this.i=new y.$Rc,this.j=[],this.b=h.appenders,this.c=h.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=h.piiPaths||[],this.g=3,this.h=!!h.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const $ of this.f)this.j.push(new RegExp((0,L.$Ge)($),"gi")),$.indexOf("\\")>=0&&this.j.push(new RegExp((0,L.$Ge)($.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration($=>{($.affectsConfiguration(v.$ll)||$.affectsConfiguration(v.$nl)||$.affectsConfiguration(v.$ml))&&this.m()}))}setExperimentProperty(h,g){this.d[h]=g}m(){let h=(0,u.$yo)(this.k);const g=this.l.enabledTelemetryLevels;if(g){this.h=this.sendErrorTelemetry?g.error:!1;const l=g.usage?3:g.error?2:0;h=Math.min(h,l)}this.g=h}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(h,g,l){this.g<g||(l=(0,R.$_m)(l,this.d),l=(0,u.$Do)(l,this.j),l=(0,R.$_m)(l,this.c),this.b.forEach($=>$.log(h,l)))}publicLog(h,g){this.n(h,3,g)}publicLog2(h,g){this.publicLog(h,g)}publicLogError(h,g){this.h&&this.n(h,2,g)}publicLogError2(h,g){this.publicLogError(h,g)}};e.$6q=b,b.IDLE_START_EVENT_NAME="UserIdleStart",b.IDLE_STOP_EVENT_NAME="UserIdleStop",e.$6q=b=Re([Ae(1,C.$ki),Ae(2,A.$qj)],b);function m(){const d=(0,I.localize)(0,null,w.default.nameLong),h=w.default.privacyStatementUrl?(0,I.localize)(2,null,"https://aka.ms/vscode-telemetry",w.default.privacyStatementUrl):(0,I.localize)(1,null,"https://aka.ms/vscode-telemetry"),g=r.$j?"":(0,I.localize)(3,null),l=(0,I.localize)(4,null),$=(0,I.localize)(5,null),c=(0,I.localize)(6,null),n=(0,I.localize)(7,null),i=`
|       | ${l} | ${$} | ${c} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,o=(0,I.localize)(8,null);return`
${d} ${h} ${g}

&nbsp;

${n}
${i}

&nbsp;

${o}
`}k.$ln.as(p.$qn.Configuration).registerConfiguration({id:v.$kl,order:1,type:"object",title:(0,I.localize)(9,null),properties:{[v.$ll]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,I.localize)(10,null),(0,I.localize)(11,null),(0,I.localize)(12,null),(0,I.localize)(13,null)],markdownDescription:m(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),k.$ln.as(p.$qn.Configuration).registerConfiguration({id:v.$kl,order:110,type:"object",title:(0,I.localize)(14,null),properties:{[v.$nl]:{type:"boolean",markdownDescription:w.default.privacyStatementUrl?(0,I.localize)(16,null,w.default.nameLong,w.default.privacyStatementUrl):(0,I.localize)(15,null,w.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,I.localize)(17,null,`\`#${v.$ll}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(be[244],we([1,0,24,6,31,32,243,38]),function(ue,e,y,R,r,L,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sr=e.$Rr=e.$Qr=void 0;let p=class extends I.$6q{constructor(A,k,v,u){super(A,v,u),this.o=k}publicLog(A,k){if(!(this.o<3))return super.publicLog(A,k)}publicLog2(A,k){return this.publicLog(A,k)}publicLogError(A,k){return this.o<2?Promise.resolve(void 0):super.publicLogError(A,k)}publicLogError2(A,k){return this.publicLogError(A,k)}async updateInjectedTelemetryLevel(A){if(A===void 0)throw this.o=0,new Error("Telemetry level cannot be undefined. This will cause infinite looping!");this.o=this.o?Math.min(this.o,A):A,this.o===0&&this.dispose()}};e.$Qr=p,e.$Qr=p=Re([Ae(2,y.$ki),Ae(3,r.$qj)],p),e.$Rr=new class extends C.$po{async updateInjectedTelemetryLevel(){}},e.$Sr=(0,R.$Rh)(L.$dl)}),define(be[245],we([1,0,15,20,246,242]),function(ue,e,y,R,r,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DN=void 0;async function I(A,k){const v=await k.request(A,R.CancellationToken.None),u=(await(0,y.$oe)(v.stream)).toString(),b=v.res.statusCode??200;return{headers:v.res.headers,statusCode:b,responseData:u}}async function C(A){const k={method:A.type,headers:A.headers};return new Promise((u,b)=>{const m=r.request(A.url??"",k,d=>{d.on("data",function(h){u({headers:d.headers,statusCode:d.statusCode??200,responseData:h.toString()})}),d.on("error",function(h){b(h)})});m.write(A.data,d=>{d&&b(d)}),m.end()})}async function p(A,k,v){const u=typeof k.data=="string"?k.data:new TextDecoder().decode(k.data),b={type:"POST",headers:{...k.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(k.data).toString()},url:k.urlString,data:u};try{const m=A?await I(b,A):await C(b);v(m.statusCode,m.headers,m.responseData)}catch{v(0,{})}}class w extends L.$CN{constructor(k,v,u,b,m){const d={sendPOST:(h,g)=>{p(k,h,g)}};super(v,u,b,m,d)}}e.$DN=w}),define(be[247],we([1,0,11,237]),function(ue,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class r extends R.default{i(){(0,y.setUnexpectedErrorHandler)(C=>console.error(C));const I=[];process.on("unhandledRejection",(C,p)=>{I.push(p),setTimeout(()=>{const w=I.indexOf(p);w>=0&&p.catch(A=>{I.splice(w,1),(0,y.$4)(A)||(console.warn(`rejected promise not handled within 1 second: ${A}`),A.stack&&console.warn(`stack trace: ${A.stack}`),C&&(0,y.$1)(C))})},1e3)}),process.on("rejectionHandled",C=>{const p=I.indexOf(C);p>=0&&I.splice(p,1)}),process.on("uncaughtException",C=>{(0,y.$Z)(C)||(0,y.$1)(C)})}}e.default=r}),define(be[122],we([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=void 0;var y;(function(R){R[R.Replace=1]="Replace",R[R.Append=2]="Append",R[R.Prepend=3]="Prepend"})(y||(e.EnvironmentVariableMutatorType=y={}))}),define(be[123],we([1,0,3,122]),function(ue,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vr=void 0;const r=new Map([[R.EnvironmentVariableMutatorType.Append,"APPEND"],[R.EnvironmentVariableMutatorType.Prepend,"PREPEND"],[R.EnvironmentVariableMutatorType.Replace,"REPLACE"]]);class L{constructor(A){this.collections=A,this.a=new Map,this.b=new Map,A.forEach((k,v)=>{this.d(k,v);const u=k.map.entries();let b=u.next();for(;!b.done;){const m=b.value[1],d=b.value[0];let h=this.a.get(d);if(h||(h=[],this.a.set(d,h)),h.length>0&&h[0].type===R.EnvironmentVariableMutatorType.Replace){b=u.next();continue}const g={extensionIdentifier:v,value:m.value,type:m.type,scope:m.scope,variable:m.variable,options:m.options};g.scope||delete g.scope,h.unshift(g),b=u.next()}})}async applyToProcessEnvironment(A,k,v){let u;y.$d&&(u={},Object.keys(A).forEach(b=>u[b.toLowerCase()]=b));for(const[b,m]of this.getVariableMap(k)){const d=y.$d&&u[b.toLowerCase()]||b;for(const h of m){const g=v?await v(h.value):h.value;if(h.options?.applyAtProcessCreation??!0)switch(h.type){case R.EnvironmentVariableMutatorType.Append:A[d]=(A[d]||"")+g;break;case R.EnvironmentVariableMutatorType.Prepend:A[d]=g+(A[d]||"");break;case R.EnvironmentVariableMutatorType.Replace:A[d]=g;break}if(h.options?.applyAtShellIntegration??!1){const l=`VSCODE_ENV_${r.get(h.type)}`;A[l]=(A[l]?A[l]+":":"")+b+"="+this.c(g)}}}}c(A){return A.replaceAll(":","\\x3a")}diff(A,k){const v=new Map,u=new Map,b=new Map;if(A.getVariableMap(k).forEach((m,d)=>{const h=this.getVariableMap(k).get(d),g=C(m,h);g&&v.set(d,g)}),this.getVariableMap(k).forEach((m,d)=>{const h=A.getVariableMap(k).get(d),g=C(m,h);g&&b.set(d,g)}),this.getVariableMap(k).forEach((m,d)=>{const h=A.getVariableMap(k).get(d),g=p(m,h);g&&u.set(d,g)}),!(v.size===0&&u.size===0&&b.size===0))return{added:v,changed:u,removed:b}}getVariableMap(A){const k=new Map;for(const v of this.a.values()){const u=v.filter(b=>I(b,A));u.length>0&&k.set(u[0].variable,u)}return k}getDescriptionMap(A){const k=new Map;for(const v of this.b.values()){const u=v.filter(b=>I(b,A,!0));for(const b of u)k.set(b.extensionIdentifier,b.description)}return k}d(A,k){if(!A.descriptionMap)return;const v=A.descriptionMap.entries();let u=v.next();for(;!u.done;){const b=u.value[1],m=u.value[0];let d=this.b.get(m);d||(d=[],this.b.set(m,d));const h={extensionIdentifier:k,scope:b.scope,description:b.description};h.scope||delete h.scope,d.push(h),u=v.next()}}}e.$vr=L;function I(w,A,k=!1){return w.scope?!!(w.scope.workspaceFolder&&A?.workspaceFolder&&w.scope.workspaceFolder.index===A.workspaceFolder.index):k?A===w.scope:!0}function C(w,A){if(!A)return w;const k=new Set;A.forEach(u=>k.add(u.extensionIdentifier));const v=[];return w.forEach(u=>{k.has(u.extensionIdentifier)||v.push(u)}),v.length===0?void 0:v}function p(w,A){if(!A)return;const k=new Map;A.forEach(u=>k.set(u.extensionIdentifier,u));const v=[];return w.forEach(u=>{const b=k.get(u.extensionIdentifier);b&&(u.type!==b.type||u.value!==b.value||u.scope?.workspaceFolder?.index!==b.scope?.workspaceFolder?.index)&&v.push(b)}),v.length===0?void 0:v}}),define(be[88],we([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ur=e.$tr=e.$sr=e.$rr=e.$qr=e.$pr=void 0;function y(p){return[...p.entries()]}e.$pr=y;function R(p){return p?[...p.entries()]:[]}e.$qr=R;function r(p){return new Map(p)}e.$rr=r;function L(p){return new Map(p??[])}e.$sr=L;function I(p){return Array.from(p.entries()).map(w=>[w[0],y(w[1].map),R(w[1].descriptionMap)])}e.$tr=I;function C(p){return new Map(p.map(w=>[w[0],{map:r(w[1]),descriptionMap:L(w[2])}]))}e.$ur=C}),define(be[248],we([1,0,14,20,5,2,13]),function(ue,e,y,R,r,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gr=void 0;let C=class extends L.$Sc{constructor(w,A){super(),this.h=A,this.a=0,this.c=new Map,this.f=new Map,this.g=this.B(new r.$Od),this.onCreateRequest=this.g.event,this.b=w===void 0?15e3:w,this.B((0,L.$Qc)(()=>{for(const k of this.f.values())(0,L.$Nc)(k)}))}createRequest(w){return new Promise((A,k)=>{const v=++this.a;this.c.set(v,A),this.g.fire({requestId:v,...w});const u=new R.$Yd;(0,y.$Vg)(this.b,u.token).then(()=>k(`Request ${v} timed out (${this.b}ms)`)),this.f.set(v,[(0,L.$Qc)(()=>u.cancel())])})}acceptReply(w,A){const k=this.c.get(w);k?(this.c.delete(w),(0,L.$Nc)(this.f.get(w)||[]),this.f.delete(w),k(A)):this.h.warn(`RequestStore#acceptReply was called without receiving a matching request ${w}`)}};e.$gr=C,e.$gr=C=Re([Ae(1,I.$$i)],C)}),define(be[89],we([1,0,6,67,37]),function(ue,e,y,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cr=e.$br=e.$ar=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.$_q=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.$$q=void 0,e.$$q=new R.$8i("terminalTabFocusMode",!1,!0);var L;(function(c){c.AutomationProfile="terminal.integrated.automationProfile.",c.DefaultProfile="terminal.integrated.defaultProfile.",c.Profiles="terminal.integrated.profiles."})(L||(e.TerminalSettingPrefix=L={}));var I;(function(c){c.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",c.AutomationProfileLinux="terminal.integrated.automationProfile.linux",c.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",c.AutomationProfileWindows="terminal.integrated.automationProfile.windows",c.ProfilesWindows="terminal.integrated.profiles.windows",c.ProfilesMacOs="terminal.integrated.profiles.osx",c.ProfilesLinux="terminal.integrated.profiles.linux",c.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",c.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",c.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",c.UseWslProfiles="terminal.integrated.useWslProfiles",c.TabsDefaultColor="terminal.integrated.tabs.defaultColor",c.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",c.TabsEnabled="terminal.integrated.tabs.enabled",c.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",c.TabsHideCondition="terminal.integrated.tabs.hideCondition",c.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",c.TabsShowActions="terminal.integrated.tabs.showActions",c.TabsLocation="terminal.integrated.tabs.location",c.TabsFocusMode="terminal.integrated.tabs.focusMode",c.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",c.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",c.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",c.CopyOnSelection="terminal.integrated.copyOnSelection",c.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",c.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",c.FontFamily="terminal.integrated.fontFamily",c.FontSize="terminal.integrated.fontSize",c.LetterSpacing="terminal.integrated.letterSpacing",c.LineHeight="terminal.integrated.lineHeight",c.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",c.TabStopWidth="terminal.integrated.tabStopWidth",c.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",c.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",c.BellDuration="terminal.integrated.bellDuration",c.FontWeight="terminal.integrated.fontWeight",c.FontWeightBold="terminal.integrated.fontWeightBold",c.CursorBlinking="terminal.integrated.cursorBlinking",c.CursorStyle="terminal.integrated.cursorStyle",c.CursorStyleInactive="terminal.integrated.cursorStyleInactive",c.CursorWidth="terminal.integrated.cursorWidth",c.Scrollback="terminal.integrated.scrollback",c.DetectLocale="terminal.integrated.detectLocale",c.DefaultLocation="terminal.integrated.defaultLocation",c.GpuAcceleration="terminal.integrated.gpuAcceleration",c.TerminalTitleSeparator="terminal.integrated.tabs.separator",c.TerminalTitle="terminal.integrated.tabs.title",c.TerminalDescription="terminal.integrated.tabs.description",c.RightClickBehavior="terminal.integrated.rightClickBehavior",c.Cwd="terminal.integrated.cwd",c.ConfirmOnExit="terminal.integrated.confirmOnExit",c.ConfirmOnKill="terminal.integrated.confirmOnKill",c.EnableBell="terminal.integrated.enableBell",c.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",c.AllowChords="terminal.integrated.allowChords",c.AllowMnemonics="terminal.integrated.allowMnemonics",c.TabFocusMode="terminal.integrated.tabFocusMode",c.EnvMacOs="terminal.integrated.env.osx",c.EnvLinux="terminal.integrated.env.linux",c.EnvWindows="terminal.integrated.env.windows",c.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",c.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",c.ShowExitAlert="terminal.integrated.showExitAlert",c.SplitCwd="terminal.integrated.splitCwd",c.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",c.WordSeparators="terminal.integrated.wordSeparators",c.EnableFileLinks="terminal.integrated.enableFileLinks",c.UnicodeVersion="terminal.integrated.unicodeVersion",c.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",c.LocalEchoEnabled="terminal.integrated.localEchoEnabled",c.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",c.LocalEchoStyle="terminal.integrated.localEchoStyle",c.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",c.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",c.HideOnStartup="terminal.integrated.hideOnStartup",c.CustomGlyphs="terminal.integrated.customGlyphs",c.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",c.InheritEnv="terminal.integrated.inheritEnv",c.ShowLinkHover="terminal.integrated.showLinkHover",c.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",c.AutoReplies="terminal.integrated.autoReplies",c.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",c.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",c.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",c.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",c.ShellIntegrationSuggestEnabled="terminal.integrated.shellIntegration.suggestEnabled",c.EnableImages="terminal.integrated.enableImages",c.SmoothScrolling="terminal.integrated.smoothScrolling",c.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",c.FocusAfterRun="terminal.integrated.focusAfterRun",c.AccessibleViewPreserveCursorPosition="terminal.integrated.accessibleViewPreserveCursorPosition",c.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",c.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",c.DevMode="terminal.integrated.developer.devMode"})(I||(e.TerminalSettingId=I={}));var C;(function(c){c.PowerShell="pwsh",c.Bash="bash",c.Fish="fish",c.Sh="sh",c.Csh="csh",c.Ksh="ksh",c.Zsh="zsh"})(C||(e.PosixShellType=C={}));var p;(function(c){c.CommandPrompt="cmd",c.PowerShell="pwsh",c.Wsl="wsl",c.GitBash="gitbash"})(p||(e.WindowsShellType=p={}));var w;(function(c){c[c.Api=0]="Api",c[c.Process=1]="Process",c[c.Sequence=2]="Sequence",c[c.Config=3]="Config"})(w||(e.TitleEventSource=w={}));var A;(function(c){c.LocalPty="localPty",c.PtyHost="ptyHost",c.PtyHostWindow="ptyHostWindow",c.Logger="logger",c.Heartbeat="heartbeat"})(A||(e.TerminalIpcChannels=A={}));var k;(function(c){c.Cwd="cwd",c.InitialCwd="initialCwd",c.FixedDimensions="fixedDimensions",c.Title="title",c.ShellType="shellType",c.HasChildProcesses="hasChildProcesses",c.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",c.OverrideDimensions="overrideDimensions",c.FailedShellIntegrationActivation="failedShellIntegrationActivation",c.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(k||(e.ProcessPropertyType=k={})),e.$_q=(0,y.$Qh)("ptyService");var v;(function(c){c[c.BeatInterval=5e3]="BeatInterval",c[c.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",c[c.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",c[c.SecondWaitMultiplier=1]="SecondWaitMultiplier",c[c.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(v||(e.HeartbeatConstants=v={}));var u;(function(c){c[c.Panel=1]="Panel",c[c.Editor=2]="Editor"})(u||(e.TerminalLocation=u={}));var b;(function(c){c.TerminalView="view",c.Editor="editor"})(b||(e.TerminalLocationString=b={}));var m;(function(c){c[c.GraceTime=6e4]="GraceTime",c[c.ShortGraceTime=6e3]="ShortGraceTime"})(m||(e.LocalReconnectConstants=m={}));var d;(function(c){c[c.HighWatermarkChars=1e5]="HighWatermarkChars",c[c.LowWatermarkChars=5e3]="LowWatermarkChars",c[c.CharCountAckSize=5e3]="CharCountAckSize"})(d||(e.FlowControlConstants=d={}));var h;(function(c){c.GitBash="Git Bash",c.Pwsh="PowerShell"})(h||(e.ProfileSource=h={}));var g;(function(c){c[c.Off=0]="Off",c[c.FinalTerm=1]="FinalTerm",c[c.VSCode=2]="VSCode"})(g||(e.ShellIntegrationStatus=g={}));var l;(function(c){c[c.Unknown=0]="Unknown",c[c.Shutdown=1]="Shutdown",c[c.Process=2]="Process",c[c.User=3]="User",c[c.Extension=4]="Extension"})(l||(e.TerminalExitReason=l={})),e.$ar={Backend:"workbench.contributions.terminal.processBackend"};class ${constructor(){this.a=new Map}get backends(){return this.a}registerTerminalBackend(n){const i=this.b(n.remoteAuthority);if(this.a.has(i))throw new Error(`A terminal backend with remote authority '${i}' was already registered.`);this.a.set(i,n)}getTerminalBackend(n){return this.a.get(this.b(n))}b(n){return n?.toLowerCase()??""}}r.$ln.add(e.$ar.Backend,new $),e.$br=(0,y.$Qh)("localPtyService"),e.$cr=(0,y.$Qh)("terminalLogService")}),define(be[249],we([1,0,3]),function(ue,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hN=e.$gN=e.$fN=void 0;function R(I){let C=I;C.includes("\\")&&(C=C.replace(/\\/g,"\\\\"));const p=/[\`\$\|\&\>\~\#\!\^\*\;\<\"\']/g;return C=C.replace(p,""),`'${C}'`}e.$fN=R;function r(I,C,p){if(!I)return"";if(!C)return I;C.match(/[\/\\]$/)&&(C=C.slice(0,C.length-1));const w=I.replace(/\\/g,"/").toLowerCase(),A=C.replace(/\\/g,"/").toLowerCase();return w.includes(A)?`~${p}${I.slice(C.length+1)}`:I}e.$gN=r;function L(I){return I.match(/^['"].*['"]$/)&&(I=I.substring(1,I.length-1)),y.OS===1&&I&&I[1]===":"?I[0].toUpperCase()+I.substring(1):I}e.$hN=L}),define(be[250],we([1,0,49,4,195,99]),function(ue,e,y,R,r,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kr=e.$jr=e.$ir=e.$hr=void 0;function I(v,u){const b=[{name:null,description:(0,r.localize)(0,null)}];return b.push(...v.map(m=>({name:m.profileName,description:C(m)}))),u&&b.push(...u.map(m=>({name:m.title,description:p(m)}))),{values:b.map(m=>m.name),markdownDescriptions:b.map(m=>m.description)}}e.$hr=I;function C(v){let u=`$(${L.ThemeIcon.isThemeIcon(v.icon)?v.icon.id:v.icon?v.icon:y.$Vj.terminal.id}) ${v.profileName}
- path: ${v.path}`;return v.args&&(typeof v.args=="string"?u+=`
- args: "${v.args}"`:u+=`
- args: [${v.args.length===0?"":`'${v.args.join("','")}'`}]`),v.overrideName!==void 0&&(u+=`
- overrideName: ${v.overrideName}`),v.color&&(u+=`
- color: ${v.color}`),v.env&&(u+=`
- env: ${JSON.stringify(v.env)}`),u}function p(v){return`$(${L.ThemeIcon.isThemeIcon(v.icon)?v.icon.id:v.icon?v.icon:y.$Vj.terminal.id}) ${v.title}
- extensionIdentifier: ${v.extensionIdentifier}`}function w(v,u){if(!v&&!u)return!0;if(typeof v=="string"&&typeof u=="string")return v===u;if(Array.isArray(v)&&Array.isArray(u)){if(v.length!==u.length)return!1;for(let b=0;b<v.length;b++)if(v[b]!==u[b])return!1;return!0}return!1}e.$ir=w;function A(v,u){if(!v&&!u)return!0;if(!v||!u)return!1;if(L.ThemeIcon.isThemeIcon(v)&&L.ThemeIcon.isThemeIcon(u))return v.id===u.id&&v.color===u.color;if(typeof v=="object"&&"light"in v&&"dark"in v&&typeof u=="object"&&"light"in u&&"dark"in u){const b=v,m=u;if((R.URI.isUri(b.light)||k(b.light))&&(R.URI.isUri(b.dark)||k(b.dark))&&(R.URI.isUri(m.light)||k(m.light))&&(R.URI.isUri(m.dark)||k(m.dark)))return b.light.path===m.light.path&&b.dark.path===m.dark.path}if(R.URI.isUri(v)&&R.URI.isUri(u)||k(v)||k(u)){const b=v,m=u;return b.path===m.path&&b.scheme===m.scheme}return!1}e.$jr=A;function k(v){return v?typeof v.path=="string"&&typeof v.scheme=="string":!1}e.$kr=k}),define(be[251],we([1,0,49,3,194,56,37,250]),function(ue,e,y,R,r,L,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$or=e.$nr=e.$mr=e.$lr=void 0,e.$lr={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.$mr={type:"string",enum:Array.from((0,y.$Uj)(),d=>d.id),markdownEnumDescriptions:Array.from((0,y.$Uj)(),d=>`$(${d.id})`)};const p={args:{description:(0,r.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,r.localize)(1,null),type:"boolean"},icon:{description:(0,r.localize)(2,null),...e.$mr},color:{description:(0,r.localize)(3,null),...e.$lr},env:{markdownDescription:(0,r.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},w={type:"object",required:["path"],properties:{path:{description:(0,r.localize)(5,null),type:["string","array"],items:{type:"string"}},...p}},A={type:"object",required:["path"],properties:{path:{description:(0,r.localize)(6,null),type:["string"],items:{type:"string"}},...p}};function k(d){const h=d===2?"linux":d===1?"osx":"windows";return(0,r.localize)(7,null,(0,R.$c)(d),'```json\n"terminal.integrated.profile.'+h+'": {\n  "bash": null\n}\n```',"[","](https://code.visualstudio.com/docs/terminal/profiles)")}const v={id:"terminal",order:100,title:(0,r.localize)(8,null),type:"object",properties:{["terminal.integrated.automationProfile.linux"]:{restricted:!0,markdownDescription:(0,r.localize)(9,null),type:["object","null"],default:null,anyOf:[{type:"null"},A],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.osx"]:{restricted:!0,markdownDescription:(0,r.localize)(10,null),type:["object","null"],default:null,anyOf:[{type:"null"},A],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.windows"]:{restricted:!0,markdownDescription:(0,r.localize)(11,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},A],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:k(3),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,r.localize)(12,null),enum:["PowerShell","Git Bash"]},...p}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,r.localize)(13,null),type:"string"},id:{description:(0,r.localize)(14,null),type:"string"},title:{description:(0,r.localize)(15,null),type:"string"},...p}},{type:"null"},w]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:k(1),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,r.localize)(16,null),type:"string"},id:{description:(0,r.localize)(17,null),type:"string"},title:{description:(0,r.localize)(18,null),type:"string"},...p}},{type:"null"},w]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:k(2),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,r.localize)(19,null),type:"string"},id:{description:(0,r.localize)(20,null),type:"string"},title:{description:(0,r.localize)(21,null),type:"string"},...p}},{type:"null"},w]}},["terminal.integrated.useWslProfiles"]:{description:(0,r.localize)(22,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,r.localize)(23,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,r.localize)(24,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,r.localize)(25,null),type:"boolean",default:!0},["terminal.integrated.ignoreProcessNames"]:{markdownDescription:(0,r.localize)(26,null,"`#terminal.integrated.confirmOnKill#`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function u(){I.$ln.as(L.$qn.Configuration).registerConfiguration(v),m()}e.$nr=u;let b;function m(d,h){const g=I.$ln.as(L.$qn.Configuration);let l;d&&(l=(0,C.$hr)(d?.profiles,h));const $=b;b={id:"terminal",order:100,title:(0,r.localize)(27,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,r.localize)(28,null),type:["string","null"],default:null,enum:d?.os===3?l?.values:void 0,markdownEnumDescriptions:d?.os===3?l?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,r.localize)(29,null),type:["string","null"],default:null,enum:d?.os===2?l?.values:void 0,markdownEnumDescriptions:d?.os===2?l?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,r.localize)(30,null),type:["string","null"],default:null,enum:d?.os===1?l?.values:void 0,markdownEnumDescriptions:d?.os===1?l?.markdownDescriptions:void 0}}},g.updateConfigurations({add:[b],remove:$?[$]:[]})}e.$or=m}),define(be[252],we([1,0,2,12,107,25,109]),function(ue,e,y,R,r,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XN=void 0;let C=class extends y.$Sc{constructor(w,A){super(),this.a=w,this.b=A}start(){const w={serverName:"Pty Host",args:["--type=ptyHost","--logsPath",this.b.logsHome.with({scheme:R.Schemas.file}).fsPath],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this.a.graceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this.a.shortGraceTime,VSCODE_RECONNECT_SCROLLBACK:this.a.scrollback}},A=(0,I.$mm)(this.b.args,this.b.isBuilt);A&&(A.break&&A.port?w.debugBrk=A.port:!A.break&&A.port&&(w.debug=A.port));const k=new r.$8p(R.$dg.asFileUri("bootstrap-fork").fsPath,w),v=new y.$Rc;return v.add(k),{client:k,store:v,onDidProcessExit:k.onDidProcessExit}}};e.$XN=C,e.$XN=C=Re([Ae(1,L.$Xh)],C)}),define(be[253],we([1,0,27,12,22,7,3,28,17,8,21,122,88,123]),function(ue,e,y,R,r,L,I,C,p,w,A,k,v,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yr=e.$xr=e.$wr=void 0;function b(){const s=/(\d+)\.(\d+)\.(\d+)/g.exec(y.release());let t=0;return s&&s.length===4&&(t=parseInt(s[3])),t}e.$wr=b;async function m(s,t,a,f=C.env,S=A.Promises.exists){if(L.$ic(s))return await S(s)?s:void 0;if(t===void 0&&(t=C.cwd()),L.$mc(s)!=="."){const M=L.$jc(t,s);return await S(M)?M:void 0}const E=(0,r.$dn)(f,"PATH");if(a===void 0&&(0,w.$zf)(E)&&(a=E.split(L.$tc)),a===void 0||a.length===0){const M=L.$jc(t,s);return await S(M)?M:void 0}for(const M of a){let ee;if(L.$ic(M)?ee=L.$jc(M,s):ee=L.$jc(t,M,s),await S(ee))return ee;if(I.$d){let se=ee+".com";if(await S(se)||(se=ee+".exe",await S(se)))return se}}const P=L.$jc(t,s);return await S(P)?P:void 0}e.$xr=m;function d(s,t,a,f,S){const D=I.$d&&(!t.windowsEnableConpty||b()<18309);if(!t.shellIntegration.enabled||!s.executable||s.isFeatureTerminal||s.hideFromUser||s.ignoreShellIntegration||D)return;const E=s.args,P=C.$dc==="win32"?L.$nc(s.executable).toLowerCase():L.$nc(s.executable),M=L.$mc(R.$dg.asFileUri("").fsPath);let ee;const se={VSCODE_INJECTION:"1"};if(t.shellIntegration.nonce&&(se.VSCODE_NONCE=t.shellIntegration.nonce),I.$d){if(P==="pwsh.exe"||P==="powershell.exe")return!E||i(E)?ee=l.get(g.WindowsPwsh):n(E)&&(ee=l.get(g.WindowsPwshLogin)),ee?(ee=[...ee],ee[ee.length-1]=(0,p.$De)(ee[ee.length-1],M,""),{newArgs:ee,envMixin:se}):void 0;f.warn(`Shell integration cannot be enabled for executable "${s.executable}" and args`,s.args);return}switch(P){case"bash":return!E||E.length===0?ee=l.get(g.Bash):o(E)&&(se.VSCODE_SHELL_LOGIN="1",h(t,se),ee=l.get(g.Bash)),ee?(ee=[...ee],ee[ee.length-1]=(0,p.$De)(ee[ee.length-1],M),{newArgs:ee,envMixin:se}):void 0;case"fish":{const G=a?.XDG_DATA_DIRS??"/usr/local/share:/usr/share",ne=L.$jc(M,"out/vs/workbench/contrib/terminal/browser/media/fish_xdg_data");return se.XDG_DATA_DIRS=`${G}:${ne}`,h(t,se),{newArgs:void 0,envMixin:se}}case"pwsh":return!E||i(E)?ee=l.get(g.Pwsh):n(E)&&(ee=l.get(g.PwshLogin)),ee?(ee=[...ee],ee[ee.length-1]=(0,p.$De)(ee[ee.length-1],M,""),{newArgs:ee,envMixin:se}):void 0;case"zsh":{if(!E||E.length===0?ee=l.get(g.Zsh):o(E)?(ee=l.get(g.ZshLogin),h(t,se)):(E===l.get(g.Zsh)||E===l.get(g.ZshLogin))&&(ee=E),!ee)return;ee=[...ee],ee[ee.length-1]=(0,p.$De)(ee[ee.length-1],M);let G;try{G=y.userInfo().username}catch{G="unknown"}const ne=L.$jc(y.tmpdir(),`${G}-${S.applicationName}-zsh`);se.ZDOTDIR=ne;const he=a?.ZDOTDIR??y.homedir()??"~";se.USER_ZDOTDIR=he;const Z=[];return Z.push({source:L.$jc(M,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:L.$jc(ne,".zshrc")}),Z.push({source:L.$jc(M,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:L.$jc(ne,".zprofile")}),Z.push({source:L.$jc(M,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:L.$jc(ne,".zshenv")}),Z.push({source:L.$jc(M,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:L.$jc(ne,".zlogin")}),{newArgs:ee,envMixin:se,filesToCopy:Z}}}f.warn(`Shell integration cannot be enabled for executable "${s.executable}" and args`,s.args)}e.$yr=d;function h(s,t){if(I.$e&&s.environmentVariableCollections){const a=(0,v.$ur)(s.environmentVariableCollections),S=new u.$vr(a).getVariableMap({workspaceFolder:s.workspaceFolder}).get("PATH"),D=[];if(S)for(const E of S)E.type===k.EnvironmentVariableMutatorType.Prepend&&D.push(E.value);D.length>0&&(t.VSCODE_PATH_PREFIX=D.join(""))}}var g;(function(s){s.WindowsPwsh="windows-pwsh",s.WindowsPwshLogin="windows-pwsh-login",s.Pwsh="pwsh",s.PwshLogin="pwsh-login",s.Zsh="zsh",s.ZshLogin="zsh-login",s.Bash="bash"})(g||(g={}));const l=new Map;l.set(g.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),l.set(g.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),l.set(g.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),l.set(g.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),l.set(g.Zsh,["-i"]),l.set(g.ZshLogin,["-il"]),l.set(g.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const $=["-login","-l"],c=["-nol","-nologo"];function n(s){return typeof s=="string"?$.includes(s.toLowerCase()):s.length===1&&$.includes(s[0].toLowerCase())||s.length===2&&($.includes(s[0].toLowerCase())||$.includes(s[1].toLowerCase()))&&(c.includes(s[0].toLowerCase())||c.includes(s[1].toLowerCase()))}function i(s){return typeof s=="string"?c.includes(s.toLowerCase()):s.length===0||s?.length===1&&c.includes(s[0].toLowerCase())}function o(s){return s==="string"&&$.includes(s.toLowerCase())||typeof s!="string"&&s.length===1&&$.includes(s[0].toLowerCase())}}),define(be[254],we([1,0,52,49,7,3,8,21,102,253,78]),function(ue,e,y,R,r,L,I,C,p,w,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zr=void 0;let k,v=!0;function u(t,a,f,S,D=process.env,E,P,M,ee){return E=E||{existsFile:C.SymlinkSupport.existsFile,readFile:C.Promises.readFile},L.$d?b(f,E,D,P,S.getValue("terminal.integrated.useWslProfiles")!==!1,t&&typeof t=="object"?{...t}:S.getValue("terminal.integrated.profiles.windows"),typeof a=="string"?a:S.getValue("terminal.integrated.defaultProfile.windows"),ee,M):i(E,P,f,t&&typeof t=="object"?{...t}:S.getValue(L.$f?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof a=="string"?a:S.getValue(L.$f?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),ee,M,D)}e.$zr=u;async function b(t,a,f,S,D,E,P,M,ee){const se=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),G=`${process.env.windir}\\${se?"Sysnative":"System32"}`;let ne=!1;(0,w.$wr)()>=16299&&(ne=!0),await g(M);const he=new Map;if(t){he.set("PowerShell",{source:"PowerShell",icon:R.$Vj.terminalPowershell,isAutoDetected:!0}),he.set("Windows PowerShell",{path:`${G}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:R.$Vj.terminalPowershell,isAutoDetected:!0}),he.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),he.set("Command Prompt",{path:`${G}\\cmd.exe`,icon:R.$Vj.terminalCmd,isAutoDetected:!0}),he.set("Cygwin",{path:[{path:`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,isUnsafe:!0},{path:`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`,isUnsafe:!0}],args:["--login"],isAutoDetected:!0}),he.set("bash (MSYS2)",{path:[{path:`${process.env.HOMEDRIVE}\\msys64\\usr\\bin\\bash.exe`,isUnsafe:!0}],args:["--login","-i"],icon:R.$Vj.terminalBash,isAutoDetected:!0});const fe=`${process.env.CMDER_ROOT||`${process.env.HOMEDRIVE}\\cmder`}\\vendor\\bin\\vscode_init.cmd`;he.set("Cmder",{path:`${G}\\cmd.exe`,args:["/K",fe],requiresPath:process.env.CMDER_ROOT?fe:{path:fe,isUnsafe:!0},isAutoDetected:!0})}o(E,he);const Z=await m(he.entries(),P,a,f,S,ee);if(t&&D)try{const fe=await c(`${G}\\${ne?"wsl":"bash"}.exe`,P);for(const V of fe)(!E||!(V.profileName in E))&&Z.push(V)}catch{v&&(S?.info("WSL is not installed, so could not detect WSL profiles"),v=!1)}return Z}async function m(t,a,f,S=process.env,D,E){const P=[];for(const[M,ee]of t)P.push(d(M,ee,a,f,S,D,E));return(await Promise.all(P)).filter(M=>!!M)}async function d(t,a,f,S,D=process.env,E,P){if(a===null)return;let M,ee,se;if("source"in a&&!("path"in a)){const Z=k?.get(a.source);if(!Z)return;M=Z.paths,ee=a.args||Z.args,a.icon?se=h(a.icon):Z.icon&&(se=Z.icon)}else M=Array.isArray(a.path)?a.path:[a.path],ee=L.$d||Array.isArray(a.args)?a.args:void 0,se=h(a.icon);let G;if(P){const Z=M.map(V=>typeof V=="string"?V:V.path),fe=await P(Z);G=new Array(M.length);for(let V=0;V<M.length;V++)typeof M[V]=="string"?G[V]=fe[V]:G[V]={path:fe[V],isUnsafe:!0}}else G=M.slice();let ne;if(a.requiresPath){let Z;if((0,I.$zf)(a.requiresPath)?Z=a.requiresPath:(Z=a.requiresPath.path,a.requiresPath.isUnsafe&&(ne=Z)),!await S.existsFile(Z))return}const he=await s(t,f,G,S,D,ee,a.env,a.overrideName,a.isAutoDetected,ne);if(!he){E?.debug("Terminal profile not validated",t,M);return}return he.isAutoDetected=a.isAutoDetected,he.icon=se,he.color=a.color,he}function h(t){return typeof t=="string"?{id:t}:t}async function g(t){if(k&&!t)return;const[a,f]=await Promise.all([l(),t||$()]);k=new Map,k.set("Git Bash",{profileName:"Git Bash",paths:a,args:["--login","-i"]}),k.set("PowerShell",{profileName:"PowerShell",paths:f,icon:R.$Vj.terminalPowershell})}async function l(){const t=new Set,a=await(0,w.$xr)("git.exe");if(a){const D=(0,A.dirname)(a);t.add((0,A.resolve)(D,"../.."))}function f(D,E){E&&D.add(E)}f(t,process.env.ProgramW6432),f(t,process.env.ProgramFiles),f(t,process.env["ProgramFiles(X86)"]),f(t,`${process.env.LocalAppData}\\Program`);const S=[];for(const D of t)S.push(`${D}\\Git\\bin\\bash.exe`,`${D}\\Git\\usr\\bin\\bash.exe`,`${D}\\usr\\bin\\bash.exe`);return S.push(`${process.env.UserProfile}\\scoop\\apps\\git\\current\\bin\\bash.exe`),S.push(`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`),S}async function $(){const t=[];for await(const a of(0,p.$zl)())t.push(a.exePath);return t}async function c(t,a){const f=[],S=await new Promise((P,M)=>{y.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(ee,se)=>{if(ee)return M("Problem occurred when getting wsl distros");P(se)})});if(!S)return[];const D=new RegExp(/[\r?\n]/),E=S.split(D).filter(P=>P.trim().length>0&&P!=="");for(const P of E){if(P===""||P.startsWith("docker-desktop"))continue;const M=`${P} (WSL)`,ee={profileName:M,path:t,args:["-d",`${P}`],isDefault:M===a,icon:n(P),isAutoDetected:!1};f.push(ee)}return f}function n(t){return t.includes("Ubuntu")?R.$Vj.terminalUbuntu:t.includes("Debian")?R.$Vj.terminalDebian:R.$Vj.terminalLinux}async function i(t,a,f,S,D,E,P,M){const ee=new Map;if(f){const se=(await t.readFile("/etc/shells")).toString(),G=(E||se.split(`
`)).map(he=>{const Z=he.indexOf("#");return Z===-1?he:he.substring(0,Z)}).filter(he=>he.trim().length>0),ne=new Map;for(const he of G){let Z=(0,r.$nc)(he),fe=ne.get(Z)||0;fe++,fe>1&&(Z=`${Z} (${fe})`),ne.set(Z,fe),ee.set(Z,{path:he,isAutoDetected:!0})}}return o(S,ee),await m(ee.entries(),D,t,M,a,P)}function o(t,a){if(t)for(const[f,S]of Object.entries(t))S===null||typeof S!="object"||!("path"in S)&&!("source"in S)?a.delete(f):(S.icon=S.icon||a.get(f)?.icon,a.set(f,S))}async function s(t,a,f,S,D,E,P,M,ee,se){if(f.length===0)return Promise.resolve(void 0);const G=f.shift();if(G==="")return s(t,a,f,S,D,E,P,M,ee);const ne=typeof G!="string"&&G.isUnsafe,he=typeof G=="string"?G:G.path,Z={profileName:t,path:he,args:E,env:P,overrideName:M,isAutoDetected:ee,isDefault:t===a,isUnsafePath:ne,requiresUnsafePath:se};if((0,r.$nc)(he)===he){const V=D.PATH?D.PATH.split(r.$tc):void 0,ie=await(0,w.$xr)(he,void 0,V,void 0,S.existsFile);return ie?(Z.path=ie,Z.isFromPath=!0,Z):s(t,a,f,S,D,E)}return await S.existsFile((0,r.$hc)(he))?Z:s(t,a,f,S,D,E,P,M,ee)}}),define(be[255],we([1,0,5,2,3,42,24,13,113,86,248,89,251,254,105,61]),function(ue,e,y,R,r,L,I,C,p,w,A,k,v,u,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ar=void 0;var d;(function(g){g[g.MaxRestarts=5]="MaxRestarts"})(d||(d={}));let h=class extends R.$Sc{get c(){return this.h(),this.a}get f(){return this.h(),this.b}get g(){return this.b}h(){this.a||this.U()}constructor(l,$,c,n){super(),this.M=l,this.N=$,this.O=c,this.P=n,this.m=!1,this.n=0,this.r=!0,this.u=this.B(new y.$Od),this.onPtyHostExit=this.u.event,this.w=this.B(new y.$Od),this.onPtyHostStart=this.w.event,this.y=this.B(new y.$Od),this.onPtyHostUnresponsive=this.y.event,this.z=this.B(new y.$Od),this.onPtyHostResponsive=this.z.event,this.C=this.B(new y.$Od),this.onPtyHostRequestResolveVariables=this.C.event,this.D=this.B(new y.$Od),this.onProcessData=this.D.event,this.F=this.B(new y.$Od),this.onProcessReady=this.F.event,this.G=this.B(new y.$Od),this.onProcessReplay=this.G.event,this.H=this.B(new y.$Od),this.onProcessOrphanQuestion=this.H.event,this.I=this.B(new y.$Od),this.onDidRequestDetach=this.I.event,this.J=this.B(new y.$Od),this.onDidChangeProperty=this.J.event,this.L=this.B(new y.$Od),this.onProcessExit=this.L.event,(0,v.$nr)(),this.B(this.M),this.B((0,R.$Qc)(()=>this.W())),this.j=this.B(new A.$gr(void 0,this.O)),this.j.onCreateRequest(this.C.fire,this.C),this.M.onRequestConnection&&y.Event.once(this.M.onRequestConnection)(()=>this.h()),this.M.onWillShutdown?.(()=>this.m=!0)}get Q(){return this.N.getValue("terminal.integrated.ignoreProcessNames")}async R(){return this.g?.refreshIgnoreProcessNames?.(this.Q)}async S(){if(r.$d)return process.env;try{return await(0,w.$Vl)(this.N,this.O,{_:[]},process.env)}catch(l){return this.O.error("ptyHost was unable to resolve shell environment",l),{}}}U(){const l=this.M.start(),$=l.client;this.O.getLevel()===C.LogLevel.Trace&&this.O.trace("PtyHostService#_startPtyHost",new Error().stack?.replace(/^Error/,"")),L.ProxyChannel.toService($.getChannel(k.TerminalIpcChannels.Heartbeat)).onBeat(()=>this.X()),this.X(!0),this.B(l.onDidProcessExit(i=>{this.u.fire(i.code),!this.m&&!this.q.isDisposed&&(this.n<=d.MaxRestarts?(this.O.error(`ptyHost terminated unexpectedly with code ${i.code}`),this.n++,this.restartPtyHost()):this.O.error(`ptyHost terminated unexpectedly with code ${i.code}, giving up`))}));const n=L.ProxyChannel.toService($.getChannel(k.TerminalIpcChannels.PtyHost));return this.B(n.onProcessData(i=>this.D.fire(i))),this.B(n.onProcessReady(i=>this.F.fire(i))),this.B(n.onProcessExit(i=>this.L.fire(i))),this.B(n.onDidChangeProperty(i=>this.J.fire(i))),this.B(n.onProcessReplay(i=>this.G.fire(i))),this.B(n.onProcessOrphanQuestion(i=>this.H.fire(i))),this.B(n.onDidRequestDetach(i=>this.I.fire(i))),this.B(new p.$fr(this.P,$.getChannel(k.TerminalIpcChannels.Logger))),this.a=l,this.b=n,this.w.fire(),this.B(this.N.onDidChangeConfiguration(async i=>{i.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this.R()})),this.R(),[l,n]}async createProcess(l,$,c,n,i,o,s,t,a,f,S){const D=setTimeout(()=>this.$(),k.HeartbeatConstants.CreateProcessTimeout),E=await this.f.createProcess(l,$,c,n,i,o,s,t,a,f,S);return clearTimeout(D),E}updateTitle(l,$,c){return this.f.updateTitle(l,$,c)}updateIcon(l,$,c,n){return this.f.updateIcon(l,$,c,n)}attachToProcess(l){return this.f.attachToProcess(l)}detachFromProcess(l,$){return this.f.detachFromProcess(l,$)}shutdownAll(){return this.f.shutdownAll()}listProcesses(){return this.f.listProcesses()}async getPerformanceMarks(){return this.g?.getPerformanceMarks()??[]}async reduceConnectionGraceTime(){return this.g?.reduceConnectionGraceTime()}start(l){return this.f.start(l)}shutdown(l,$){return this.f.shutdown(l,$)}input(l,$){return this.f.input(l,$)}processBinary(l,$){return this.f.processBinary(l,$)}resize(l,$,c){return this.f.resize(l,$,c)}clearBuffer(l){return this.f.clearBuffer(l)}acknowledgeDataEvent(l,$){return this.f.acknowledgeDataEvent(l,$)}setUnicodeVersion(l,$){return this.f.setUnicodeVersion(l,$)}getInitialCwd(l){return this.f.getInitialCwd(l)}getCwd(l){return this.f.getCwd(l)}async getLatency(){const l=new m.$Kd,$=await this.f.getLatency();return l.stop(),[{label:"ptyhostservice<->ptyhost",latency:l.elapsed()},...$]}orphanQuestionReply(l){return this.f.orphanQuestionReply(l)}installAutoReply(l,$){return this.f.installAutoReply(l,$)}uninstallAllAutoReplies(){return this.f.uninstallAllAutoReplies()}uninstallAutoReply(l){return this.f.uninstallAutoReply(l)}getDefaultSystemShell(l){return this.g?.getDefaultSystemShell(l)??(0,b.$Fl)(l??r.OS,process.env)}async getProfiles(l,$,c,n=!1){const i=await this.S();return(0,u.$zr)($,c,n,this.N,i,void 0,this.O,this.bb.bind(this,l))}async getEnvironment(){return this.b?this.f.getEnvironment():{...process.env}}getWslPath(l,$){return this.f.getWslPath(l,$)}getRevivedPtyNewId(l,$){return this.f.getRevivedPtyNewId(l,$)}setTerminalLayoutInfo(l){return this.f.setTerminalLayoutInfo(l)}async getTerminalLayoutInfo(l){return this.g?.getTerminalLayoutInfo(l)}async requestDetachInstance(l,$){return this.f.requestDetachInstance(l,$)}async acceptDetachInstanceReply(l,$){return this.f.acceptDetachInstanceReply(l,$)}async freePortKillProcess(l){if(!this.f.freePortKillProcess)throw new Error("freePortKillProcess does not exist on the pty proxy");return this.f.freePortKillProcess(l)}async serializeTerminalState(l){return this.f.serializeTerminalState(l)}async reviveTerminalProcesses(l,$,c){return this.f.reviveTerminalProcesses(l,$,c)}async refreshProperty(l,$){return this.f.refreshProperty(l,$)}async updateProperty(l,$,c){return this.f.updateProperty(l,$,c)}async restartPtyHost(){this.W(),this.r=!0,this.U()}W(){this.f.shutdownAll(),this.c.store.dispose()}X(l){this.ab(),this.s=setTimeout(()=>this.Y(),l?k.HeartbeatConstants.ConnectingBeatInterval:k.HeartbeatConstants.BeatInterval*k.HeartbeatConstants.FirstWaitMultiplier),this.r||(this.r=!0,this.z.fire())}Y(){this.O.warn(`No ptyHost heartbeat after ${k.HeartbeatConstants.BeatInterval*k.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this.s=void 0,this.t=setTimeout(()=>this.Z(),k.HeartbeatConstants.BeatInterval*k.HeartbeatConstants.SecondWaitMultiplier)}Z(){this.O.error(`No ptyHost heartbeat after ${(k.HeartbeatConstants.BeatInterval*k.HeartbeatConstants.FirstWaitMultiplier+k.HeartbeatConstants.BeatInterval*k.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this.t=void 0,this.r&&(this.r=!1,this.y.fire())}$(){this.ab(),this.O.error(`No ptyHost response to createProcess after ${k.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this.r&&(this.r=!1,this.y.fire())}ab(){this.s&&(clearTimeout(this.s),this.s=void 0),this.t&&(clearTimeout(this.t),this.t=void 0)}bb(l,$){return this.j.createRequest({workspaceId:l,originalText:$})}async acceptPtyHostResolvedVariables(l,$){this.j.acceptReply(l,$)}};e.$Ar=h,e.$Ar=h=Re([Ae(1,I.$ki),Ae(2,C.$$i),Ae(3,C.$_i)],h)}),define(be[34],we([1,0,6]),function(ue,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jk=void 0,e.$Jk=(0,y.$Qh)("IUriIdentityService")}),define(be[124],we([1,0,34,213,16,19,145,5,2]),function(ue,e,y,R,r,L,I,C,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Er=void 0;class w{constructor(v){this.uri=v,this.time=w._clock++}touch(){return this.time=w._clock++,this}}w._clock=0;let A=class{constructor(v){this.g=v,this.c=new p.$Rc,this.f=2**16;const u=new Map,b=m=>{let d=u.get(m.scheme);return d===void 0&&(d=v.hasProvider(m)&&!this.g.hasCapability(m,1024),u.set(m.scheme,d)),d};this.c.add(C.Event.any(v.onDidChangeFileSystemProviderRegistrations,v.onDidChangeFileSystemProviderCapabilities)(m=>{u.delete(m.scheme)})),this.extUri=new L.$lg(b),this.d=new I.$Dr((m,d)=>this.extUri.compare(m,d,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(v){this.g.hasProvider(v)&&(v=(0,L.$xg)(v));const u=this.d.get(v);return u?u.touch().uri.with({fragment:v.fragment}):(this.d.set(v,new w(v)),this.h(),v)}h(){if(this.d.size<this.f)return;const v=[...this.d.entries()].sort((b,m)=>b[1].time<m[1].time?1:b[1].time>m[1].time?-1:0);w._clock=0,this.d.clear();const u=this.f*.5;for(let b=0;b<u;b++)this.d.set(v[b][0],v[b][1].touch())}};e.$Er=A,e.$Er=A=Re([Ae(0,r.$_j)],A),(0,R.$Br)(y.$Jk,A,1)}),define(be[90],we([1,0,197,7,64,19,4,6,12]),function(ue,e,y,R,r,L,I,C,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ji=e.$ii=e.$hi=e.$gi=e.$fi=e.$ei=e.$di=e.$ci=e.$bi=e.$ai=e.$_h=e.$$h=e.$0h=e.$9h=e.$8h=e.WorkbenchState=e.$7h=e.$6h=e.$5h=e.$4h=e.$3h=e.$2h=e.$1h=e.$Zh=void 0,e.$Zh=(0,C.$Qh)("contextService");function w(s){const t=s;return typeof t?.id=="string"&&I.URI.isUri(t.uri)}e.$1h=w;function A(s){return typeof s?.id=="string"&&!w(s)&&!v(s)}e.$2h=A,e.$3h={id:"ext-dev"},e.$4h={id:"empty-window"};function k(s,t){if(typeof s=="string"||typeof s>"u")return typeof s=="string"?{id:(0,R.$nc)(s)}:t?e.$3h:e.$4h;const a=s;return a.configuration?{id:a.id,configPath:a.configuration}:a.folders.length===1?{id:a.id,uri:a.folders[0].uri}:{id:a.id}}e.$5h=k;function v(s){const t=s;return typeof t?.id=="string"&&I.URI.isUri(t.configPath)}e.$6h=v;function u(s){const t=s;if(t?.uri)return{id:t.id,uri:I.URI.revive(t.uri)};const a=s;if(a?.configPath)return{id:a.id,configPath:I.URI.revive(a.configPath)};if(s?.id)return{id:s.id}}e.$7h=u;var b;(function(s){s[s.EMPTY=1]="EMPTY",s[s.FOLDER=2]="FOLDER",s[s.WORKSPACE=3]="WORKSPACE"})(b||(e.WorkbenchState=b={}));function m(s){const t=s;return!!(t&&typeof t=="object"&&typeof t.id=="string"&&Array.isArray(t.folders))}e.$8h=m;function d(s){const t=s;return!!(t&&typeof t=="object"&&I.URI.isUri(t.uri)&&typeof t.name=="string"&&typeof t.toResource=="function")}e.$9h=d;class h{constructor(t,a,f,S,D){this.h=t,this.j=f,this.k=S,this.l=D,this.c=r.$Wh.forUris(this.l,()=>!0),this.folders=a}update(t){this.h=t.id,this.k=t.configuration,this.j=t.transient,this.l=t.l,this.folders=t.folders}get folders(){return this.g}set folders(t){this.g=t,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(t){this.k=t}getFolder(t){return t&&this.c.findSubstr(t)||null}n(){this.c=r.$Wh.forUris(this.l,()=>!0);for(const t of this.folders)this.c.set(t.uri,t)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$0h=h;class g{constructor(t,a){this.raw=a,this.uri=t.uri,this.index=t.index,this.name=t.name}toResource(t){return(0,L.$wg)(this.uri,t)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$$h=g;function l(s){return new g({uri:s,index:0,name:(0,L.$sg)(s)},{uri:s.toString()})}e.$_h=l,e.$ai="code-workspace",e.$bi=`.${e.$ai}`,e.$ci=[{name:(0,y.localize)(0,null),extensions:[e.$ai]}],e.$di="workspace.json";function $(s,t){return L.$ng.isEqualOrParent(s,t.untitledWorkspacesHome)}e.$ei=$;function c(s){let t;return I.URI.isUri(s)?t=s:t=s.configuration,t?.scheme===p.Schemas.tmp}e.$fi=c,e.$gi="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function n(s){return s.id===e.$gi}e.$hi=n;function i(s,t){return!$(s,t)&&!c(s)}e.$ii=i;function o(s){return(typeof s=="string"?(0,R.$oc)(s):(0,L.$ug)(s))===e.$bi}e.$ji=o}),define(be[33],we([1,0,62,5,2,19,4,196,25,16,6,13,90,26,34,14,23,17,8]),function(ue,e,y,R,r,L,I,C,p,w,A,k,v,u,b,m,d,h,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pk=e.$Ok=e.$Nk=e.$Mk=e.$Lk=e.$Kk=e.ProfileResourceType=void 0;var l;(function(s){s.Settings="settings",s.Keybindings="keybindings",s.Snippets="snippets",s.Tasks="tasks",s.Extensions="extensions",s.GlobalState="globalState"})(l||(e.ProfileResourceType=l={}));function $(s){const t=s;return!!(t&&typeof t=="object"&&typeof t.id=="string"&&typeof t.isDefault=="boolean"&&typeof t.name=="string"&&I.URI.isUri(t.location)&&I.URI.isUri(t.globalStorageHome)&&I.URI.isUri(t.settingsResource)&&I.URI.isUri(t.keybindingsResource)&&I.URI.isUri(t.tasksResource)&&I.URI.isUri(t.snippetsHome)&&I.URI.isUri(t.extensionsResource))}e.$Kk=$,e.$Lk=(0,A.$Qh)("IUserDataProfilesService");function c(s,t){return{id:s.id,isDefault:s.isDefault,name:s.name,shortName:s.shortName,icon:s.icon,location:I.URI.revive(s.location).with({scheme:t}),globalStorageHome:I.URI.revive(s.globalStorageHome).with({scheme:t}),settingsResource:I.URI.revive(s.settingsResource).with({scheme:t}),keybindingsResource:I.URI.revive(s.keybindingsResource).with({scheme:t}),tasksResource:I.URI.revive(s.tasksResource).with({scheme:t}),snippetsHome:I.URI.revive(s.snippetsHome).with({scheme:t}),extensionsResource:I.URI.revive(s.extensionsResource).with({scheme:t}),cacheHome:I.URI.revive(s.cacheHome).with({scheme:t}),useDefaultFlags:s.useDefaultFlags,isTransient:s.isTransient}}e.$Mk=c;function n(s,t,a,f,S,D){return{id:s,name:t,location:a,isDefault:!1,shortName:S?.shortName,icon:S?.icon,globalStorageHome:D&&S?.useDefaultFlags?.globalState?D.globalStorageHome:(0,L.$wg)(a,"globalStorage"),settingsResource:D&&S?.useDefaultFlags?.settings?D.settingsResource:(0,L.$wg)(a,"settings.json"),keybindingsResource:D&&S?.useDefaultFlags?.keybindings?D.keybindingsResource:(0,L.$wg)(a,"keybindings.json"),tasksResource:D&&S?.useDefaultFlags?.tasks?D.tasksResource:(0,L.$wg)(a,"tasks.json"),snippetsHome:D&&S?.useDefaultFlags?.snippets?D.snippetsHome:(0,L.$wg)(a,"snippets"),extensionsResource:D&&S?.useDefaultFlags?.extensions?D.extensionsResource:(0,L.$wg)(a,"extensions.json"),cacheHome:(0,L.$wg)(f,s),useDefaultFlags:S?.useDefaultFlags,isTransient:S?.transient}}e.$Nk=n;let i=class extends r.$Sc{get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(t,a,f,S){super(),this.t=t,this.u=a,this.w=f,this.y=S,this.f=!0,this.h=this.B(new R.$Od),this.onDidChangeProfiles=this.h.event,this.j=this.B(new R.$Od),this.onWillCreateProfile=this.j.event,this.m=this.B(new R.$Od),this.onWillRemoveProfile=this.m.event,this.n=this.B(new R.$Od),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new u.$Ac,emptyWindows:new Map},this.profilesHome=(0,L.$wg)(this.t.userRoamingDataHome,"profiles"),this.g=(0,L.$wg)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(t){this.f!==t&&(this.z=void 0,this.f=t)}isEnabled(){return this.f}get C(){if(!this.z){const t=this.D(),a=[t];if(this.f)try{for(const D of this.O()){if(!D.name||!(0,g.$zf)(D.name)||!D.location){this.y.warn("Skipping the invalid stored profile",D.location||D.name);continue}a.push(n((0,L.$tg)(D.location),D.name,D.location,this.g,{shortName:D.shortName,icon:D.icon,useDefaultFlags:D.useDefaultFlags},t))}}catch(D){this.y.error(D)}const f=new u.$Ac,S=new Map;if(a.length)try{const D=this.Q();if(D.workspaces)for(const[E,P]of Object.entries(D.workspaces)){const M=I.URI.parse(E),ee=a.find(se=>se.id===P);ee&&f.set(M,ee)}if(D.emptyWindows)for(const[E,P]of Object.entries(D.emptyWindows)){const M=a.find(ee=>ee.id===P);M&&S.set(E,M)}}catch(D){this.y.error(D)}this.z={profiles:a,workspaces:f,emptyWindows:S}}return this.z}D(){const t=n("__default__profile__",(0,C.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...t,extensionsResource:this.S()??t.extensionsResource,isDefault:!0}}async createTransientProfile(t){const a="Temp",f=new RegExp(`${(0,h.$Ge)(a)}\\s(\\d+)`);let S=0;for(const E of this.profiles){const P=f.exec(E.name),M=P?parseInt(P[1]):0;S=M>S?M:S}const D=`${a} ${S+1}`;return this.createProfile((0,y.$Ei)((0,d.$fg)()).toString(16),D,{transient:!0},t)}async createNamedProfile(t,a,f){return this.createProfile((0,y.$Ei)((0,d.$fg)()).toString(16),t,a,f)}async createProfile(t,a,f,S){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const D=await this.F(t,a,f);return S&&await this.setProfileForWorkspace(S,D),D}async F(t,a,f){if(!(0,g.$zf)(a)||!a)throw new Error("Name of the profile is mandatory and must be of type `string`");let S=this.r.get(a);return S||(S=(async()=>{try{const D=this.profiles.find(M=>M.name===a||M.id===t);if(D)return D;const E=n(t,a,(0,L.$wg)(this.profilesHome,t),this.g,f,this.defaultProfile);await this.u.createFolder(E.location);const P=[];return this.j.fire({profile:E,join(M){P.push(M)}}),await m.Promises.settled(P),this.I([E],[],[]),E}finally{this.r.delete(a)}})(),this.r.set(a,S)),S}async updateProfile(t,a){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let f=this.profiles.find(S=>S.id===t.id);if(!f)throw new Error(`Profile '${t.name}' does not exist`);return f=n(f.id,a.name??f.name,f.location,this.g,{shortName:a.shortName??f.shortName,icon:a.icon===null?void 0:a.icon??f.icon,transient:a.transient??f.isTransient,useDefaultFlags:a.useDefaultFlags??f.useDefaultFlags},this.defaultProfile),this.I([],[],[f]),f}async removeProfile(t){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(t.isDefault)throw new Error("Cannot remove default profile");const a=this.profiles.find(S=>S.id===t.id);if(!a)throw new Error(`Profile '${t.name}' does not exist`);const f=[];this.m.fire({profile:a,join(S){f.push(S)}});try{await Promise.allSettled(f)}catch(S){this.y.error(S)}for(const S of[...this.C.emptyWindows.keys()])a.id===this.C.emptyWindows.get(S)?.id&&this.C.emptyWindows.delete(S);for(const S of[...this.C.workspaces.keys()])a.id===this.C.workspaces.get(S)?.id&&this.C.workspaces.delete(S);this.M(),this.I([],[a],[]);try{await this.u.del(a.cacheHome,{recursive:!0})}catch(S){(0,w.$qk)(S)!==1&&this.y.error(S)}}async setProfileForWorkspace(t,a){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const f=this.profiles.find(S=>S.id===a.id);if(!f)throw new Error(`Profile '${a.name}' does not exist`);this.L(t,f)}unsetWorkspace(t,a){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(t,void 0,a)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const t=await this.u.resolve(this.profilesHome);await Promise.all((t.children||[]).filter(a=>a.isDirectory&&this.profiles.every(f=>!this.w.extUri.isEqual(f.location,a.resource))).map(a=>this.u.del(a.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const t=this.s.profiles.filter(a=>!this.H(a));await Promise.allSettled(t.map(a=>this.removeProfile(a)))}getProfileForWorkspace(t){const a=this.G(t);return I.URI.isUri(a)?this.s.workspaces.get(a)??this.C.workspaces.get(a):this.s.emptyWindows.get(a)??this.C.emptyWindows.get(a)}G(t){return(0,v.$1h)(t)?t.uri:(0,v.$6h)(t)?t.configPath:t.id}H(t){return!!([...this.s.emptyWindows.values()].some(a=>this.w.extUri.isEqual(a.location,t.location))||[...this.s.workspaces.values()].some(a=>this.w.extUri.isEqual(a.location,t.location))||[...this.C.emptyWindows.values()].some(a=>this.w.extUri.isEqual(a.location,t.location))||[...this.C.workspaces.values()].some(a=>this.w.extUri.isEqual(a.location,t.location)))}I(t,a,f){const S=[...this.profiles,...t],D=[];this.s.profiles=[];for(let E of S)E.isDefault||a.some(P=>E.id===P.id)||(E=f.find(P=>E.id===P.id)??E,E.isTransient?this.s.profiles.push(E):D.push({location:E.location,name:E.name,shortName:E.shortName,icon:E.icon,useDefaultFlags:E.useDefaultFlags}));this.P(D),this.z=void 0,this.J(t,a,f)}J(t,a,f){this.h.fire({added:t,removed:a,updated:f,all:this.profiles})}L(t,a,f){f=a?.isTransient?!0:f,f||this.L(t,void 0,!0);const S=this.G(t),D=f?this.s:this.C;I.URI.isUri(S)?(D.workspaces.delete(S),a&&D.workspaces.set(S,a)):(D.emptyWindows.delete(S),a&&D.emptyWindows.set(S,a)),f||this.M()}M(){const t={};for(const[f,S]of this.C.workspaces.entries())t[f.toString()]=S.id;const a={};for(const[f,S]of this.C.emptyWindows.entries())a[f.toString()]=S.id;this.R({workspaces:t,emptyWindows:a}),this.z=void 0}N(t){const a={},f=this.D();if(t.workspaces)for(const[D,E]of Object.entries(t.workspaces)){const P=I.URI.parse(E);a[D]=this.w.extUri.isEqual(P,f.location)?f.id:this.w.extUri.basename(P)}const S={};if(t.emptyWindows)for(const[D,E]of Object.entries(t.emptyWindows)){const P=I.URI.parse(E);S[D]=this.w.extUri.isEqual(P,f.location)?f.id:this.w.extUri.basename(P)}return{workspaces:a,emptyWindows:S}}O(){return[]}P(t){throw new Error("not implemented")}Q(){return{}}R(t){throw new Error("not implemented")}S(){}};e.$Ok=i,i.b="userDataProfiles",i.c="profileAssociations",e.$Ok=i=Re([Ae(0,p.$Xh),Ae(1,w.$_j),Ae(2,b.$Jk),Ae(3,k.$$i)],i);class o extends i{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(t){this.a=t}Q(){return this.X}R(t){this.X=t}}e.$Pk=o}),define(be[256],we([1,0,18,14,20,11,5,2,3,8,4,177,30,36,35,13,31,32,34,33]),function(ue,e,y,R,r,L,I,C,p,w,A,k,v,u,b,m,d,h,g,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xp=e.$wp=e.$vp=e.$up=void 0;let $=class extends C.$Sc{get onInstallExtension(){return this.n.event}get onDidInstallExtensions(){return this.s.event}get onUninstallExtension(){return this.t.event}get onDidUninstallExtension(){return this.u.event}get onDidUpdateExtensionMetadata(){return this.w.event}constructor(t,a,f,S,D,E){super(),this.z=t,this.C=a,this.D=f,this.F=S,this.G=D,this.H=E,this.h=0,this.j=new Map,this.m=new Map,this.n=this.B(new I.$Od),this.s=this.B(new I.$Od),this.t=this.B(new I.$Od),this.u=this.B(new I.$Od),this.w=this.B(new I.$Od),this.y=[],this.B((0,C.$Qc)(()=>{this.j.forEach(({task:P})=>P.cancel()),this.m.forEach(P=>P.cancel()),this.j.clear(),this.m.clear()}))}async canInstall(t){const a=await this.getTargetPlatform();return t.allTargetPlatforms.some(f=>(0,v.$ao)(f,t.allTargetPlatforms,a))}async installFromGallery(t,a={}){try{const S=(await this.installGalleryExtensions([{extension:t,options:a}])).find(({identifier:D})=>(0,u.$Eo)(D,t.identifier));if(S?.local)return S?.local;throw S?.error?S.error:n(new Error(`Unknown error while installing extension ${t.identifier.id}`))}catch(f){throw n(f)}}async installGalleryExtensions(t){if(!this.z.isEnabled())throw new v.$do(k.localize(0,null),v.ExtensionManagementErrorCode.Internal);const a=[],f=[];await Promise.allSettled(t.map(async({extension:S,options:D})=>{try{const E=await this.O(S,!!D?.installGivenVersion,!!D?.installPreReleaseVersion);f.push({...E,options:D})}catch(E){a.push({identifier:S.identifier,operation:2,source:S,error:E})}})),f.length&&a.push(...await this.I(f));for(const S of a)S.error&&(this.F.error("Failed to install extension.",S.identifier.id),this.F.error(S.error),S.source&&!A.URI.isUri(S.source)&&i(this.C,"extensionGallery:install",{extensionData:(0,u.$Mo)(S.source),error:S.error}));return a}async uninstall(t,a={}){return this.F.trace("ExtensionManagementService#uninstall",t.identifier.id),this.Q(t,a)}async toggleAppliationScope(t,a){if((0,b.$$l)(t.manifest)||t.isBuiltin)return t;if(t.isApplicationScoped){let f=await this.updateMetadata(t,{isApplicationScoped:!1},this.H.defaultProfile.extensionsResource);this.D.extUri.isEqual(a,this.H.defaultProfile.extensionsResource)||(f=await this.ab(t,this.H.defaultProfile.extensionsResource,a));for(const S of this.H.profiles){const D=(await this.getInstalled(1,S.extensionsResource)).find(E=>(0,u.$Eo)(E.identifier,t.identifier));D?this.w.fire(D):this.u.fire({identifier:t.identifier,profileLocation:S.extensionsResource})}return f}else{const f=this.D.extUri.isEqual(a,this.H.defaultProfile.extensionsResource)?await this.updateMetadata(t,{isApplicationScoped:!0},this.H.defaultProfile.extensionsResource):await this.ab(t,a,this.H.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this.s.fire([{identifier:f.identifier,operation:2,local:f,profileLocation:this.H.defaultProfile.extensionsResource,applicationScoped:!0}]),f}}getExtensionsControlManifest(){const t=new Date().getTime();return(!this.g||t-this.h>1e3*60*5)&&(this.g=this.X(),this.h=t),this.g}registerParticipant(t){this.y.push(t)}async I(t){const a=[];return await Promise.allSettled(t.map(async f=>{try{const S=await this.J(f,(D,E)=>t.some(P=>(0,u.$Io)(E.identifier.id)===(0,u.$Jo)(P.manifest.publisher,P.manifest.name))?!1:this.L(D,E));a.push(...S)}catch(S){a.push({identifier:{id:(0,u.$Jo)(f.manifest.publisher,f.manifest.name)},operation:2,source:f.extension,error:S})}})),this.s.fire(a),a}async J({manifest:t,extension:a,options:f},S){const D=f.isApplicationScoped||f.isBuiltin||(0,b.$$l)(t),E={...f,installOnlyNewlyAddedFromExtensionPack:A.URI.isUri(a)?f.installOnlyNewlyAddedFromExtensionPack:!0,isApplicationScoped:D,profileLocation:D?this.H.defaultProfile.extensionsResource:f.profileLocation??this.Y()},P=he=>`${u.$Fo.create(he).toString()}${E.profileLocation?`-${E.profileLocation.toString()}`:""}`;if(!A.URI.isUri(a)){const he=this.j.get(P(a));if(he)return this.F.info("Extensions is already requested to install",a.identifier.id),await he.task.waitUntilTaskIsFinished(),[]}const M=[],ee=[],se=[],G=this.Z(t,a,E);A.URI.isUri(a)||this.j.set(P(a),{task:G,waitingTasks:[]}),this.n.fire({identifier:G.identifier,source:a,profileLocation:E.profileLocation}),this.F.info("Installing extension:",G.identifier.id),M.push({task:G,manifest:t});let ne=!1;try{if(E.donotIncludePackAndDependencies)this.F.info("Installing the extension without checking dependencies and pack",G.identifier.id);else try{const Z=await this.N(G.identifier,t,!!E.installOnlyNewlyAddedFromExtensionPack,!!E.installPreReleaseVersion,E.profileLocation),fe=await this.getInstalled(void 0,E.profileLocation),V={...E,donotIncludePackAndDependencies:!0,context:{...E.context,[v.$8n]:!0}};for(const{gallery:ie,manifest:Y}of(0,y.$Mb)(Z,({gallery:J})=>J.identifier.id)){ne=ne||!!Y.extensionDependencies?.some(ce=>(0,u.$Eo)({id:ce},G.identifier));const J=P(ie),re=this.j.get(J);if(re){if(S(G,re.task)){const ce=re.task.identifier;this.F.info("Waiting for already requested installing extension",ce.id,G.identifier.id),re.waitingTasks.push(G),ee.push(I.Event.toPromise(I.Event.filter(this.onDidInstallExtensions,oe=>oe.some(_=>(0,u.$Eo)(_.identifier,ce)))).then(oe=>{if(this.F.info("Finished waiting for already requested installing extension",ce.id,G.identifier.id),!oe.find(q=>(0,u.$Eo)(q.identifier,ce))?.local)throw new Error(`Extension ${ce.id} is not installed`)}))}}else if(!fe.some(({identifier:ce})=>(0,u.$Eo)(ce,ie.identifier))){const ce=this.Z(Y,ie,V);this.j.set(J,{task:ce,waitingTasks:[G]}),this.n.fire({identifier:ce.identifier,source:ie,profileLocation:E.profileLocation}),this.F.info("Installing extension:",ce.identifier.id,G.identifier.id),M.push({task:ce,manifest:Y})}}}catch(Z){if(A.URI.isUri(G.source))(0,y.$Lb)(t.extensionDependencies)&&this.F.warn("Cannot install dependencies of extension:",G.identifier.id,Z.message),(0,y.$Lb)(t.extensionPack)&&this.F.warn("Cannot install packed extensions of extension:",G.identifier.id,Z.message);else throw this.F.error("Error while preparing to install dependencies and extension packs of the extension:",G.identifier.id),Z}const he=M.reduce((Z,{task:fe,manifest:V})=>(Z.set(fe.identifier.id.toLowerCase(),{task:fe,manifest:V}),Z),new Map);for(;he.size;){let Z;const fe=[...he.values()].filter(({manifest:V})=>!V.extensionDependencies?.some(ie=>he.has(ie.toLowerCase())));fe.length?Z=he.size===1?fe:fe.filter(({task:V})=>!(V===G&&!ne)):(this.F.info("Found extensions with circular dependencies",fe.map(({task:V})=>V.identifier.id)),Z=[...he.values()]),await this.M(Z.map(async({task:V})=>{const ie=new Date().getTime();try{const Y=await V.run();if(await this.M(this.y.map(J=>J.postInstall(Y,V.source,E,r.CancellationToken.None))),!A.URI.isUri(V.source)){const J=V.operation===3,re=J?void 0:(new Date().getTime()-V.source.lastUpdated)/1e3;if(i(this.C,J?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,u.$Mo)(V.source),verificationStatus:V.verificationStatus,duration:new Date().getTime()-ie,durationSinceUpdate:re}),p.$j&&V.operation!==3)try{await this.z.reportStatistic(Y.manifest.publisher,Y.manifest.name,Y.manifest.version,"install")}catch{}}se.push({local:Y,identifier:V.identifier,operation:V.operation,source:V.source,context:V.options.context,profileLocation:V.profileLocation,applicationScoped:Y.isApplicationScoped})}catch(Y){throw A.URI.isUri(V.source)||i(this.C,V.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,u.$Mo)(V.source),verificationStatus:V.verificationStatus,duration:new Date().getTime()-ie,error:Y}),this.F.error("Error while installing the extension:",V.identifier.id),Y}finally{he.delete(V.identifier.id.toLowerCase())}}))}return ee.length&&await this.M(ee),se.forEach(({identifier:Z})=>this.F.info("Extension installed successfully:",Z.id)),se}catch(he){if(M.forEach(({task:Z})=>Z.cancel()),se.length)try{const Z=await Promise.allSettled(se.map(({local:fe})=>this.$(fe,{versionOnly:!0,profileLocation:E.profileLocation}).run()));for(let fe=0;fe<Z.length;fe++){const V=Z[fe],{identifier:ie}=se[fe];V.status==="fulfilled"?this.F.info("Rollback: Uninstalled extension",ie.id):this.F.warn("Rollback: Error while uninstalling extension",ie.id,(0,L.$0)(V.reason))}}catch(Z){this.F.warn("Error while rolling back extensions",(0,L.$0)(Z),se.map(({identifier:fe})=>fe.id))}return M.map(({task:Z})=>({identifier:Z.identifier,operation:2,source:Z.source,context:E.context,profileLocation:E.profileLocation,error:he}))}finally{for(const{task:he}of M)he.source&&!A.URI.isUri(he.source)&&this.j.delete(P(he.source))}}L(t,a){for(const[,{task:f,waitingTasks:S}]of this.j.entries())if(f===t&&(S.includes(a)||S.some(D=>this.L(D,a)))||f===a&&S[0]&&!this.L(t,S[0]))return!1;return!0}async M(t){const a=[],f=[],S=await Promise.allSettled(t);for(const D of S)D.status==="fulfilled"?a.push(D.value):f.push(D.reason);if(f.length)throw c(f);return a}async N(t,a,f,S,D){if(!this.z.isEnabled())return[];const E=await this.getInstalled(void 0,D),P=[],M=[],ee=async(se,G)=>{P.push(se);const ne=G.extensionDependencies||[],he=[...ne];if(G.extensionPack){const Z=f?E.find(fe=>(0,u.$Eo)(fe.identifier,se)):void 0;for(const fe of G.extensionPack)Z&&Z.manifest.extensionPack&&Z.manifest.extensionPack.some(V=>(0,u.$Eo)({id:V},{id:fe}))||he.every(V=>!(0,u.$Eo)({id:V},{id:fe}))&&he.push(fe)}if(he.length){const Z=he.filter(fe=>P.every(V=>!(0,u.$Eo)(V,{id:fe})));if(Z.length){const fe=await this.z.getExtensions(Z.map(V=>({id:V,preRelease:S})),r.CancellationToken.None);for(const V of fe){if(P.find(J=>(0,u.$Eo)(J,V.identifier)))continue;const ie=ne.some(J=>(0,u.$Eo)({id:J},V.identifier));let Y;try{Y=await this.O(V,!1,S)}catch(J){if(ie)throw J;this.F.info("Skipping the packed extension as it cannot be installed",V.identifier.id,(0,L.$0)(J));continue}M.push({gallery:Y.extension,manifest:Y.manifest}),await ee(Y.extension.identifier,Y.manifest)}}}};return await ee(t,a),M}async O(t,a,f){let S;const D=await this.getExtensionsControlManifest();if(D.malicious.some(M=>(0,u.$Eo)(t.identifier,M)))throw new v.$do(k.localize(1,null,t.identifier.id),v.ExtensionManagementErrorCode.Malicious);const E=D.deprecated[t.identifier.id.toLowerCase()];if(E?.extension?.autoMigrate){if(this.F.info(`The '${t.identifier.id}' extension is deprecated, fetching the compatible '${E.extension.id}' extension instead.`),S=(await this.z.getExtensions([{id:E.extension.id,preRelease:E.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0},r.CancellationToken.None))[0],!S)throw new v.$do(k.localize(2,null,t.identifier.id,E.extension.id),v.ExtensionManagementErrorCode.Deprecated)}else{if(!await this.canInstall(t)){const M=await this.getTargetPlatform();throw new v.$do(k.localize(3,null,t.identifier.id,this.G.nameLong,(0,v.$9n)(M)),v.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}if(S=await this.P(t,a,f),!S)throw!f&&t.properties.isPreReleaseVersion&&(await this.z.getExtensions([t.identifier],r.CancellationToken.None))[0]?new v.$do(k.localize(4,null,t.identifier.id),v.ExtensionManagementErrorCode.ReleaseVersionNotFound):new v.$do(k.localize(5,null,t.identifier.id,this.G.nameLong,this.G.version),v.ExtensionManagementErrorCode.Incompatible)}this.F.info("Getting Manifest...",S.identifier.id);const P=await this.z.getManifest(S,r.CancellationToken.None);if(P===null)throw new v.$do(`Missing manifest for extension ${S.identifier.id}`,v.ExtensionManagementErrorCode.Invalid);if(P.version!==S.version)throw new v.$do(`Cannot install '${S.identifier.id}' extension because of version mismatch in Marketplace`,v.ExtensionManagementErrorCode.Invalid);return{extension:S,manifest:P}}async P(t,a,f){const S=await this.getTargetPlatform();let D=null;return!a&&t.hasPreReleaseVersion&&t.properties.isPreReleaseVersion!==f&&(D=(await this.z.getExtensions([{...t.identifier,preRelease:f}],{targetPlatform:S,compatible:!0},r.CancellationToken.None))[0]||null),!D&&await this.z.isExtensionCompatible(t,f,S)&&(D=t),D||(a?D=(await this.z.getExtensions([{...t.identifier,version:t.version}],{targetPlatform:S,compatible:!0},r.CancellationToken.None))[0]||null:D=await this.z.getCompatibleExtension(t,f,S)),D}async Q(t,a){const f={...a,profileLocation:t.isApplicationScoped?this.H.defaultProfile.extensionsResource:a.profileLocation??this.Y()},S=se=>`${se.id.toLowerCase()}${f.versionOnly?`-${t.manifest.version}`:""}${f.profileLocation?`@${f.profileLocation.toString()}`:""}`,D=this.m.get(S(t.identifier));if(D)return this.F.info("Extensions is already requested to uninstall",t.identifier.id),D.waitUntilTaskIsFinished();const E=se=>{const G=this.$(se,f);return this.m.set(S(G.extension.identifier),G),f.profileLocation?this.F.info("Uninstalling extension from the profile:",`${se.identifier.id}@${se.manifest.version}`,f.profileLocation.toString()):this.F.info("Uninstalling extension:",`${se.identifier.id}@${se.manifest.version}`),this.t.fire({identifier:se.identifier,profileLocation:f.profileLocation,applicationScoped:se.isApplicationScoped}),G},P=(se,G)=>{G?f.profileLocation?this.F.error("Failed to uninstall extension from the profile:",`${se.identifier.id}@${se.manifest.version}`,f.profileLocation.toString(),G.message):this.F.error("Failed to uninstall extension:",`${se.identifier.id}@${se.manifest.version}`,G.message):f.profileLocation?this.F.info("Successfully uninstalled extension from the profile",`${se.identifier.id}@${se.manifest.version}`,f.profileLocation.toString()):this.F.info("Successfully uninstalled extension:",`${se.identifier.id}@${se.manifest.version}`),i(this.C,"extensionGallery:uninstall",{extensionData:(0,u.$Lo)(se),error:G}),this.u.fire({identifier:se.identifier,error:G?.code,profileLocation:f.profileLocation,applicationScoped:se.isApplicationScoped})},M=[],ee=[];try{M.push(E(t));const se=await this.getInstalled(1,f.profileLocation);if(f.donotIncludePack)this.F.info("Uninstalling the extension without including packed extension",`${t.identifier.id}@${t.manifest.version}`);else{const G=this.U(t,se);for(const ne of G)this.m.has(S(ne.identifier))?this.F.info("Extensions is already requested to uninstall",ne.identifier.id):M.push(E(ne))}f.donotCheckDependents?this.F.info("Uninstalling the extension without checking dependents",`${t.identifier.id}@${t.manifest.version}`):this.R(M.map(G=>G.extension),se,t),await this.M(M.map(async G=>{try{if(await G.run(),await this.M(this.y.map(ne=>ne.postUninstall(G.extension,f,r.CancellationToken.None))),G.extension.identifier.uuid)try{await this.z.reportStatistic(G.extension.manifest.publisher,G.extension.manifest.name,G.extension.manifest.version,"uninstall")}catch{}P(G.extension)}catch(ne){const he=ne instanceof v.$do?ne:new v.$do((0,L.$0)(ne),v.ExtensionManagementErrorCode.Internal);throw P(G.extension,he),he}finally{ee.push(G)}}))}catch(se){const G=se instanceof v.$do?se:new v.$do((0,L.$0)(se),v.ExtensionManagementErrorCode.Internal);for(const ne of M){try{ne.cancel()}catch{}ee.includes(ne)||P(ne.extension,G)}throw G}finally{for(const se of M)this.m.delete(S(se.extension.identifier))||this.F.warn("Uninstallation task is not found in the cache",se.extension.identifier.id)}}R(t,a,f){for(const S of t){const D=this.W(S,a);if(D.length){const E=D.filter(P=>!t.some(M=>(0,u.$Eo)(M.identifier,P.identifier)));if(E.length)throw new Error(this.S(S,E,f))}}}S(t,a,f){return f===t?a.length===1?k.localize(6,null,f.manifest.displayName||f.manifest.name,a[0].manifest.displayName||a[0].manifest.name):a.length===2?k.localize(7,null,f.manifest.displayName||f.manifest.name,a[0].manifest.displayName||a[0].manifest.name,a[1].manifest.displayName||a[1].manifest.name):k.localize(8,null,f.manifest.displayName||f.manifest.name,a[0].manifest.displayName||a[0].manifest.name,a[1].manifest.displayName||a[1].manifest.name):a.length===1?k.localize(9,null,f.manifest.displayName||f.manifest.name,t.manifest.displayName||t.manifest.name,a[0].manifest.displayName||a[0].manifest.name):a.length===2?k.localize(10,null,f.manifest.displayName||f.manifest.name,t.manifest.displayName||t.manifest.name,a[0].manifest.displayName||a[0].manifest.name,a[1].manifest.displayName||a[1].manifest.name):k.localize(11,null,f.manifest.displayName||f.manifest.name,t.manifest.displayName||t.manifest.name,a[0].manifest.displayName||a[0].manifest.name,a[1].manifest.displayName||a[1].manifest.name)}U(t,a,f=[]){if(f.indexOf(t)!==-1)return[];f.push(t);const S=t.manifest.extensionPack?t.manifest.extensionPack:[];if(S.length){const D=a.filter(P=>!P.isBuiltin&&S.some(M=>(0,u.$Eo)({id:M},P.identifier))),E=[];for(const P of D)E.push(...this.U(P,a,f));return[...D,...E]}return[]}W(t,a){return a.filter(f=>f.manifest.extensionDependencies&&f.manifest.extensionDependencies.some(S=>(0,u.$Eo)({id:S},t.identifier)))}async X(){try{this.F.trace("ExtensionManagementService.refreshReportedCache");const t=await this.z.getExtensionsControlManifest();return this.F.trace("ExtensionManagementService.refreshControlCache",t),t}catch{return this.F.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{},search:[]}}}};e.$up=$,e.$up=$=Re([Ae(0,v.$co),Ae(1,h.$dl),Ae(2,g.$Jk),Ae(3,m.$$i),Ae(4,d.$qj),Ae(5,l.$Lk)],$);function c(s){const t=Array.isArray(s)?s:[s];return t.length===1?t[0]instanceof Error?t[0]:new Error(t[0]):t.reduce((a,f)=>new Error(`${a.message}${a.message?",":""}${f instanceof Error?f.message:f}`),new Error(""))}e.$vp=c;function n(s){if(s instanceof v.$do)return s;const t=new v.$do(s.message,v.ExtensionManagementErrorCode.Internal);return t.stack=s.stack,t}e.$wp=n;function i(s,t,{extensionData:a,verificationStatus:f,duration:S,error:D,durationSinceUpdate:E}){let P,M;(0,w.$Hf)(f)&&(f===!0?f="Verified":(f===!1||(P=v.ExtensionManagementErrorCode.Signature,M=f),f="Unverified")),D&&(D instanceof v.$do?(P=D.code,D.code===v.ExtensionManagementErrorCode.Signature&&(M=D.message)):P=v.ExtensionManagementErrorCode.Internal),s.publicLog(t,{...a,verificationStatus:f,success:!D,duration:S,errorcode:P,errorcodeDetail:M,durationSinceUpdate:E})}class o{constructor(){this.d=new R.$Tg}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}async run(){return this.g||(this.g=(0,R.$Ig)(t=>this.h(t))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,R.$Ig)(t=>new Promise((a,f)=>{const S=t.onCancellationRequested(()=>{S.dispose(),f(new L.$5)})})),this.d.open()),this.g.cancel()}}e.$xp=o}),define(be[45],we([1,0,14,15,2,5,26,4,30,36,16,6,13,33,34,8,11,32]),function(ue,e,y,R,r,L,I,C,p,w,A,k,v,u,b,m,d,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ap=e.$zp=e.$yp=e.ExtensionsProfileScanningErrorCode=void 0;var g;(function(i){i.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",i.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(g||(e.ExtensionsProfileScanningErrorCode=g={}));class l extends Error{constructor(o,s){super(o),this.code=s}}e.$yp=l,e.$zp=(0,k.$Qh)("IExtensionsProfileScannerService");let $=class extends r.$Sc{constructor(o,s,t,a,f,S){super(),this.j=o,this.m=s,this.n=t,this.r=a,this.s=f,this.t=S,this.b=this.B(new L.$Od),this.onAddExtensions=this.b.event,this.c=this.B(new L.$Od),this.onDidAddExtensions=this.c.event,this.f=this.B(new L.$Od),this.onRemoveExtensions=this.f.event,this.g=this.B(new L.$Od),this.onDidRemoveExtensions=this.g.event,this.h=new I.$Ac}scanProfileExtensions(o,s){return this.u(o,void 0,s)}async addExtensionsToProfile(o,s){const t=[],a=[];try{return await this.u(s,f=>{const S=[];for(const D of f)o.some(([E])=>(0,w.$Eo)(E.identifier,D.identifier)&&E.manifest.version!==D.version)?t.push(D):S.push(D);for(const[D,E]of o){const P=S.findIndex(ee=>(0,w.$Eo)(ee.identifier,D.identifier)&&ee.version===D.manifest.version),M={identifier:D.identifier,version:D.manifest.version,location:D.location,metadata:E};P===-1?(a.push(M),S.push(M)):S.splice(P,1,M)}return a.length&&this.b.fire({extensions:a,profileLocation:s}),t.length&&this.f.fire({extensions:t,profileLocation:s}),S}),a.length&&this.c.fire({extensions:a,profileLocation:s}),t.length&&this.g.fire({extensions:t,profileLocation:s}),a}catch(f){throw a.length&&this.c.fire({extensions:a,error:f,profileLocation:s}),t.length&&this.g.fire({extensions:t,error:f,profileLocation:s}),f}}async updateMetadata(o,s){const t=[];return await this.u(s,a=>{const f=[];for(const S of a){const D=o.find(([E])=>(0,w.$Eo)(E.identifier,S.identifier)&&E.manifest.version===S.version);D&&(S.metadata={...S.metadata,...D[1]},t.push(S)),f.push(S)}return f}),t}async removeExtensionFromProfile(o,s){const t=[];try{await this.u(s,a=>{const f=[];for(const S of a)(0,w.$Eo)(S.identifier,o.identifier)?t.push(S):f.push(S);return t.length&&this.f.fire({extensions:t,profileLocation:s}),f}),t.length&&this.g.fire({extensions:t,profileLocation:s})}catch(a){throw t.length&&this.g.fire({extensions:t,error:a,profileLocation:s}),a}}async u(o,s,t){return this.F(o).queue(async()=>{let a=[],f;try{const S=await this.m.readFile(o);f=JSON.parse(S.value.toString().trim()||"[]")}catch(S){if((0,A.$qk)(S)!==1)throw S;if(this.r.extUri.isEqual(o,this.n.defaultProfile.extensionsResource)&&(f=await this.D()),!f&&t?.bailOutWhenFileNotFound)throw new l((0,d.$0)(S),"ERROR_PROFILE_NOT_FOUND")}if(f){Array.isArray(f)||this.w(o);let S=!1;for(const D of f){c(D)||this.w(o);let E;if((0,m.$zf)(D.relativeLocation)&&D.relativeLocation)E=this.z(D.relativeLocation);else if((0,m.$zf)(D.location))E=this.z(D.location),S=!0,D.relativeLocation=D.location,D.location=E.toJSON();else{E=C.URI.revive(D.location);const P=this.y(E);P&&(S=!0,D.relativeLocation=P)}a.push({identifier:D.identifier,location:E,version:D.version,metadata:D.metadata})}S&&await this.m.writeFile(o,R.$ce.fromString(JSON.stringify(f)))}if(s){a=s(a);const S=a.map(D=>({identifier:D.identifier,version:D.version,location:D.location.toJSON(),relativeLocation:this.y(D.location),metadata:D.metadata}));await this.m.writeFile(o,R.$ce.fromString(JSON.stringify(S)))}return a})}w(o){const s=new l(`Invalid extensions content in ${o.toString()}`,"ERROR_INVALID_CONTENT");throw this.s.publicLogError2("extensionsProfileScanningError",{code:s.code}),s}y(o){return this.r.extUri.isEqual(this.r.extUri.dirname(o),this.j)?this.r.extUri.basename(o):void 0}z(o){return this.r.extUri.joinPath(this.j,o)}async D(){return this.C||(this.C=(async()=>{const o=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),s=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let t;try{t=(await this.m.readFile(o)).value.toString()}catch(f){if((0,A.$qk)(f)===1)return;throw f}this.t.info("Migrating extensions from old default profile location",o.toString());let a;try{const f=JSON.parse(t);Array.isArray(f)&&f.every(S=>c(S))?a=f:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",f)}catch(f){this.t.error(f)}if(a)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,R.$ce.fromString(JSON.stringify(a)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",o.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(f){if((0,A.$qk)(f)===3)this.t.info("Migration from old default profile location to new location is done by another window",o.toString(),this.n.defaultProfile.extensionsResource.toString());else throw f}try{await this.m.del(o)}catch(f){(0,A.$qk)(f)!==1&&this.t.error(f)}try{await this.m.del(s)}catch(f){(0,A.$qk)(f)!==1&&this.t.error(f)}return a})()),this.C}F(o){let s=this.h.get(o);return s||(s=new y.$2g,this.h.set(o,s)),s}};e.$Ap=$,e.$Ap=$=Re([Ae(1,A.$_j),Ae(2,u.$Lk),Ae(3,b.$Jk),Ae(4,h.$dl),Ae(5,v.$$i)],$);function c(i){return(0,m.$Bf)(i)&&(0,p.$bo)(i.identifier)&&(n(i.location)||(0,m.$zf)(i.location)&&i.location)&&((0,m.$Gf)(i.relativeLocation)||(0,m.$zf)(i.relativeLocation))&&i.version&&(0,m.$zf)(i.version)}function n(i){return i?(0,m.$zf)(i.path)&&(0,m.$zf)(i.scheme):!1}}),define(be[58],we([1,0,18,14,22,15,11,75,168,2,12,7,3,19,53,63,8,4,181,25,36,35,80,16,6,13,31,5,50,45,33,34,211]),function(ue,e,y,R,r,L,I,C,p,w,A,k,v,u,b,m,d,h,g,l,$,c,n,i,o,s,t,a,f,S,D,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hp=e.$Gp=e.$Fp=e.$Ep=e.$Dp=e.Translations=void 0;var M;(function(fe){function V(ie,Y){if(ie===Y)return!0;const J=Object.keys(ie),re=new Set;for(const ce of Object.keys(Y))re.add(ce);if(J.length!==re.size)return!1;for(const ce of J){if(ie[ce]!==Y[ce])return!1;re.delete(ce)}return re.size===0}fe.equals=V})(M||(e.Translations=M={})),e.$Dp=(0,o.$Qh)("IExtensionsScannerService");let ee=class extends w.$Sc{constructor(V,ie,Y,J,re,ce,oe,_,q,Q,O,N){super(),this.systemExtensionsLocation=V,this.userExtensionsLocation=ie,this.r=Y,this.s=J,this.t=re,this.u=ce,this.w=oe,this.y=_,this.z=q,this.C=Q,this.D=O,this.F=N,this.g=this.B(new a.$Od),this.onDidChangeCache=this.g.event,this.h=(0,u.$wg)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(ne,this.s,this.h)),this.m=this.B(this.F.createInstance(ne,this.s,this.h)),this.n=this.B(this.F.createInstance(G,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(0))),this.B(this.m.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.G||(this.G=(0,$.$Po)(this.w,this.y)),this.G}async scanAllExtensions(V,ie,Y){const[J,re]=await Promise.all([this.scanSystemExtensions(V),this.scanUserExtensions(ie)]),ce=Y?await this.scanExtensionsUnderDevelopment(V,[...J,...re]):[];return this.L(J,re,ce,await this.getTargetPlatform(),!0)}async scanSystemExtensions(V){const ie=[];ie.push(this.M(!!V.useCache,V.language)),ie.push(this.N(V.language,!!V.checkControlFile));const[Y,J]=await Promise.all(ie);return this.J([...Y,...J],0,V,!1)}async scanUserExtensions(V){const ie=V.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",ie);const Y=this.D.extUri.isEqual(V.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,J=await this.P(ie,!!V.profileLocation,1,!V.includeUninstalled,V.language,!0,Y),re=V.useCache&&!J.devMode&&J.excludeObsolete?this.m:this.n;let ce;try{ce=await re.scanExtensions(J)}catch(oe){if(oe instanceof S.$yp&&oe.code==="ERROR_PROFILE_NOT_FOUND")await this.I(),ce=await re.scanExtensions(J);else throw oe}return ce=await this.J(ce,1,V,!0),this.y.trace("Scanned user extensions:",ce.length),ce}async scanExtensionsUnderDevelopment(V,ie){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const Y=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(J=>J.scheme===A.Schemas.file).map(async J=>{const re=await this.P(J,!1,1,!0,V.language,!1,void 0);return(await this.n.scanOneOrMultipleExtensions(re)).map(oe=>(oe.type=ie.find(_=>(0,$.$Eo)(_.identifier,oe.identifier))?.type??oe.type,this.n.validate(oe,re)))}))).flat();return this.J(Y,"development",V,!0)}return[]}async scanExistingExtension(V,ie,Y){const J=await this.P(V,!1,ie,!0,Y.language,!0,void 0),re=await this.n.scanExtension(J);return!re||!Y.includeInvalid&&!re.isValid?null:re}async scanOneOrMultipleExtensions(V,ie,Y){const J=await this.P(V,!1,ie,!0,Y.language,!0,void 0),re=await this.n.scanOneOrMultipleExtensions(J);return this.J(re,ie,Y,!0)}async scanMetadata(V){const ie=(0,u.$wg)(V,"package.json"),Y=(await this.w.readFile(ie)).value.toString();return JSON.parse(Y).__metadata}async updateMetadata(V,ie){const Y=(0,u.$wg)(V,"package.json"),J=(await this.w.readFile(Y)).value.toString(),re=JSON.parse(J);ie.isMachineScoped===!1&&delete ie.isMachineScoped,ie.isBuiltin===!1&&delete ie.isBuiltin,re.__metadata={...re.__metadata,...ie},await this.w.writeFile((0,u.$wg)(V,"package.json"),L.$ce.fromString(JSON.stringify(re,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(V){if(V instanceof S.$yp&&V.code==="ERROR_PROFILE_NOT_FOUND")await this.I();else throw V}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const V=await this.scanUserExtensions({includeInvalid:!0});if(V.length)await this.u.addExtensionsToProfile(V.map(ie=>[ie,ie.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,L.$ce.fromString(JSON.stringify([])))}catch(ie){(0,i.$qk)(ie)!==1&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,I.$0)(ie))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(V){this.y.error(V)}finally{this.H=void 0}})()),this.H}async J(V,ie,Y,J){return Y.includeAllVersions||(V=this.L(ie===0?V:void 0,ie===1?V:void 0,ie==="development"?V:void 0,await this.getTargetPlatform(),J)),Y.includeInvalid||(V=V.filter(re=>re.isValid)),V.sort((re,ce)=>{const oe=k.$nc(re.location.fsPath),_=k.$nc(ce.location.fsPath);return oe<_?-1:oe>_?1:0})}L(V,ie,Y,J,re){const ce=(_,q,Q)=>{if(_.isValid&&!q.isValid)return!1;if(_.isValid===q.isValid){if(re&&b.gt(_.manifest.version,q.manifest.version))return this.y.debug(`Skipping extension ${q.location.path} with lower version ${q.manifest.version} in favour of ${_.location.path} with version ${_.manifest.version}`),!1;if(b.eq(_.manifest.version,q.manifest.version)){if(_.type===0)return this.y.debug(`Skipping extension ${q.location.path} in favour of system extension ${_.location.path} with same version`),!1;if(_.targetPlatform===J)return this.y.debug(`Skipping extension ${q.location.path} from different target platform ${q.targetPlatform}`),!1}}return Q?this.y.warn(`Overwriting user extension ${_.location.path} with ${q.location.path}.`):this.y.debug(`Overwriting user extension ${_.location.path} with ${q.location.path}.`),!0},oe=new c.$0l;return V?.forEach(_=>{const q=oe.get(_.identifier.id);(!q||ce(q,_,!1))&&oe.set(_.identifier.id,_)}),ie?.forEach(_=>{const q=oe.get(_.identifier.id);if(!q&&V&&_.type===0){this.y.debug(`Skipping obsolete system extension ${_.location.path}.`);return}(!q||ce(q,_,!1))&&oe.set(_.identifier.id,_)}),Y?.forEach(_=>{const q=oe.get(_.identifier.id);(!q||ce(q,_,!0))&&oe.set(_.identifier.id,_),oe.set(_.identifier.id,_)}),[...oe.values()]}async M(V,ie){this.y.trace("Started scanning system extensions");const Y=await this.P(this.systemExtensionsLocation,!1,0,!0,ie,!0,void 0),re=await(V&&!Y.devMode?this.j:this.n).scanExtensions(Y);return this.y.trace("Scanned system extensions:",re.length),re}async N(V,ie){const Y=this.z.isBuilt?[]:this.C.builtInExtensions;if(!Y?.length)return[];this.y.trace("Started scanning dev system extensions");const J=ie?await this.O():{},re=[],ce=h.URI.file(k.$hc(k.$jc(A.$dg.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const _ of Y){const q=J[_.name]||"marketplace";switch(q){case"disabled":break;case"marketplace":re.push((0,u.$wg)(ce,_.name));break;default:re.push(h.URI.file(q));break}}const oe=await Promise.all(re.map(async _=>this.n.scanExtension(await this.P(_,!1,0,!0,V,!0,void 0))));return this.y.trace("Scanned dev system extensions:",oe.length),(0,y.$Hb)(oe)}async O(){try{const V=await this.w.readFile(this.r);return JSON.parse(V.value.toString())}catch{return{}}}async P(V,ie,Y,J,re,ce,oe){const _=await this.f(re??v.$q),q=await this.Q(V),Q=ie&&!this.D.extUri.isEqual(V,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,O=Q?await this.Q(Q):void 0;return new se(V,q,Q,O,ie,oe,Y,J,ce,this.C.version,this.C.date,this.C.commit,!this.z.isBuilt,re,_)}async Q(V){try{const ie=await this.w.stat(V);if(typeof ie.mtime=="number")return ie.mtime}catch{}}};e.$Ep=ee,e.$Ep=ee=Re([Ae(4,D.$Lk),Ae(5,S.$zp),Ae(6,i.$_j),Ae(7,s.$$i),Ae(8,l.$Xh),Ae(9,t.$qj),Ae(10,E.$Jk),Ae(11,o.$Ph)],ee);class se{constructor(V,ie,Y,J,re,ce,oe,_,q,Q,O,N,U,T,z){this.location=V,this.mtime=ie,this.applicationExtensionslocation=Y,this.applicationExtensionslocationMtime=J,this.profile=re,this.profileScanOptions=ce,this.type=oe,this.excludeObsolete=_,this.validate=q,this.productVersion=Q,this.productDate=O,this.productCommit=N,this.devMode=U,this.language=T,this.translations=z}static createNlsConfiguration(V){return{language:V.language,pseudo:V.language==="pseudo",devMode:V.devMode,translations:V.translations}}static equals(V,ie){return(0,u.$pg)(V.location,ie.location)&&V.mtime===ie.mtime&&(0,u.$pg)(V.applicationExtensionslocation,ie.applicationExtensionslocation)&&V.applicationExtensionslocationMtime===ie.applicationExtensionslocationMtime&&V.profile===ie.profile&&r.$an(V.profileScanOptions,ie.profileScanOptions)&&V.type===ie.type&&V.excludeObsolete===ie.excludeObsolete&&V.validate===ie.validate&&V.productVersion===ie.productVersion&&V.productDate===ie.productDate&&V.productCommit===ie.productCommit&&V.devMode===ie.devMode&&V.language===ie.language&&M.equals(V.translations,ie.translations)}}e.$Fp=se;let G=class extends w.$Sc{constructor(V,ie,Y,J,re){super(),this.f=V,this.g=ie,this.h=Y,this.j=J,this.m=re}async scanExtensions(V){const ie=V.profile?await this.r(V):await this.n(V);let Y={};if(V.excludeObsolete&&V.type===1)try{const J=(await this.j.readFile(this.f)).value.toString();Y=JSON.parse(J)}catch{}return(0,d.$Mf)(Y)?ie:ie.filter(J=>!Y[$.$Fo.create(J).toString()])}async n(V){const ie=await this.j.resolve(V.location);if(!ie.children?.length)return[];const Y=await Promise.all(ie.children.map(async J=>{if(!J.isDirectory||V.type===1&&(0,u.$tg)(J.resource).indexOf(".")===0)return null;const re=new se(J.resource,V.mtime,V.applicationExtensionslocation,V.applicationExtensionslocationMtime,V.profile,V.profileScanOptions,V.type,V.excludeObsolete,V.validate,V.productVersion,V.productDate,V.productCommit,V.devMode,V.language,V.translations);return this.scanExtension(re)}));return(0,y.$Hb)(Y).sort((J,re)=>J.location.path<re.location.path?-1:1)}async r(V){let ie=await this.s(V.location,()=>!0,V);if(V.applicationExtensionslocation&&!this.h.extUri.isEqual(V.location,V.applicationExtensionslocation)){ie=ie.filter(J=>!J.metadata?.isApplicationScoped);const Y=await this.s(V.applicationExtensionslocation,J=>!!J.metadata?.isBuiltin||!!J.metadata?.isApplicationScoped,V);ie.push(...Y)}return ie}async s(V,ie,Y){const J=await this.g.scanProfileExtensions(V,Y.profileScanOptions);if(!J.length)return[];const re=await Promise.all(J.map(async ce=>{if(ie(ce)){const oe=new se(ce.location,Y.mtime,Y.applicationExtensionslocation,Y.applicationExtensionslocationMtime,Y.profile,Y.profileScanOptions,Y.type,Y.excludeObsolete,Y.validate,Y.productVersion,Y.productDate,Y.productCommit,Y.devMode,Y.language,Y.translations);return this.scanExtension(oe,ce.metadata)}return null}));return(0,y.$Hb)(re)}async scanOneOrMultipleExtensions(V){try{if(await this.j.exists((0,u.$wg)(V.location,"package.json"))){const ie=await this.scanExtension(V);return ie?[ie]:[]}else return await this.scanExtensions(V)}catch(ie){return this.m.error(`Error scanning extensions at ${V.location.path}:`,(0,I.$0)(ie)),[]}}async scanExtension(V,ie){try{let Y=await this.scanExtensionManifest(V.location);if(Y){Y.publisher||(Y.publisher=c.$4l),ie=ie??Y.__metadata,delete Y.__metadata;const J=(0,$.$Jo)(Y.publisher,Y.name),re=ie?.id?{id:J,uuid:ie.id}:{id:J},ce=ie?.isSystem?0:V.type,oe=ce===0||!!ie?.isBuiltin;Y=await this.t(V.location,Y,se.createNlsConfiguration(V));const _={type:ce,identifier:re,manifest:Y,location:V.location,isBuiltin:oe,targetPlatform:ie?.targetPlatform??"undefined",metadata:ie,isValid:!0,validations:[]};return V.validate?this.validate(_,V):_}}catch(Y){V.type!==0&&this.m.error(Y)}return null}validate(V,ie){let Y=!0;const J=(0,n.$Uo)(ie.productVersion,ie.productDate,ie.location,V.manifest,V.isBuiltin);for(const[re,ce]of J)re===m.default.Error&&(Y=!1,this.m.error(this.z(ie.location,ce)));return V.isValid=Y,V.validations=J,V}async scanExtensionManifest(V){const ie=(0,u.$wg)(V,"package.json");let Y;try{Y=(await this.j.readFile(ie)).value.toString()}catch(re){return(0,i.$qk)(re)!==1&&this.m.error(this.z(V,(0,g.localize)(0,null,ie.path,re.message))),null}let J;try{J=JSON.parse(Y)}catch{const ce=[];(0,C.$Ym)(Y,ce);for(const oe of ce)this.m.error(this.z(V,(0,g.localize)(1,null,ie.path,oe.offset,oe.length,(0,p.$Bp)(oe.error))));return null}return(0,C.$8m)(J)!=="object"?(this.m.error(this.z(V,(0,g.localize)(2,null,ie.path))),null):J}async t(V,ie,Y){const J=await this.u(V,ie,Y);if(J)try{const re=[],ce=await this.w(J.default,re);if(re.length>0)return re.forEach(_=>{this.m.error(this.z(V,(0,g.localize)(3,null,J.default?.path,(0,p.$Bp)(_.error))))}),ie;if((0,C.$8m)(J)!=="object")return this.m.error(this.z(V,(0,g.localize)(4,null,J.default?.path))),ie;const oe=J.values||Object.create(null);return(0,P.$Cp)(this.m,ie,oe,ce)}catch{}return ie}async u(V,ie,Y){const J=(0,u.$wg)(V,"package.nls.json"),re=(q,Q)=>{Q.forEach(O=>{this.m.error(this.z(V,(0,g.localize)(5,null,q?.path,(0,p.$Bp)(O.error))))})},ce=q=>{this.m.error(this.z(V,(0,g.localize)(6,null,q?.path)))},oe=`${ie.publisher}.${ie.name}`,_=Y.translations[oe];if(_)try{const q=h.URI.file(_),Q=(await this.j.readFile(q)).value.toString(),O=[],N=(0,C.$Ym)(Q,O);return O.length>0?(re(q,O),{values:void 0,default:J}):(0,C.$8m)(N)!=="object"?(ce(q),{values:void 0,default:J}):{values:N.contents?N.contents.package:void 0,default:J}}catch{return{values:void 0,default:J}}else{if(!await this.j.exists(J))return;let Q;try{Q=await this.y(V,Y)}catch{return}if(!Q.localized)return{values:void 0,default:Q.original};try{const O=(await this.j.readFile(Q.localized)).value.toString(),N=[],U=(0,C.$Ym)(O,N);return N.length>0?(re(Q.localized,N),{values:void 0,default:Q.original}):(0,C.$8m)(U)!=="object"?(ce(Q.localized),{values:void 0,default:Q.original}):{values:U,default:Q.original}}catch{return{values:void 0,default:Q.original}}}}async w(V,ie){if(V)try{const Y=(await this.j.readFile(V)).value.toString();return(0,C.$Ym)(Y,ie)}catch{}}y(V,ie){return new Promise((Y,J)=>{const re=ce=>{const oe=(0,u.$wg)(V,`package.nls.${ce}.json`);this.j.exists(oe).then(_=>{_&&Y({localized:oe,original:(0,u.$wg)(V,"package.nls.json")});const q=ce.lastIndexOf("-");q===-1?Y({localized:(0,u.$wg)(V,"package.nls.json"),original:null}):(ce=ce.substring(0,q),re(ce))})};if(ie.devMode||ie.pseudo||!ie.language)return Y({localized:(0,u.$wg)(V,"package.nls.json"),original:null});re(ie.language)})}z(V,ie){return`[${V.path}]: ${ie}`}};G=Re([Ae(1,S.$zp),Ae(2,E.$Jk),Ae(3,i.$_j),Ae(4,s.$$i)],G);let ne=class extends G{constructor(V,ie,Y,J,re,ce,oe){super(ie,J,re,ce,oe),this.G=V,this.H=Y,this.D=this.B(new R.$Sg(3e3)),this.F=this.B(new a.$Od),this.onDidChangeCache=this.F.event}async scanExtensions(V){const ie=this.M(V),Y=await this.I(ie);if(this.C=V,Y&&Y.input&&se.equals(Y.input,this.C))return this.m.debug("Using cached extensions scan result",V.location.toString()),this.D.trigger(()=>this.L()),Y.result.map(re=>(re.location=h.URI.revive(re.location),re));const J=await super.scanExtensions(V);return await this.J(ie,{input:V,result:J}),J}async I(V){try{const ie=await this.j.readFile(V),Y=JSON.parse(ie.value.toString());return{result:Y.result,input:(0,f.$nh)(Y.input)}}catch(ie){this.m.debug("Error while reading the extension cache file:",V.path,(0,I.$0)(ie))}return null}async J(V,ie){try{await this.j.writeFile(V,L.$ce.fromString(JSON.stringify(ie)))}catch(Y){this.m.debug("Error while writing the extension cache file:",V.path,(0,I.$0)(Y))}}async L(){if(!this.C)return;const V=this.M(this.C),ie=await this.I(V);if(!ie)return;const Y=ie.result,J=JSON.parse(JSON.stringify(await super.scanExtensions(this.C)));if(!r.$an(J,Y))try{this.m.info("Invalidating Cache",Y,J),await this.j.del(V),this.F.fire()}catch(re){this.m.error(re)}}M(V){const ie=this.N(V);return this.h.extUri.joinPath(ie.cacheHome,V.type===0?c.$3l:c.$2l)}N(V){return V.type===0?this.H.defaultProfile:V.profile?this.h.extUri.isEqual(V.location,this.G.extensionsResource)?this.G:this.H.profiles.find(ie=>this.h.extUri.isEqual(V.location,ie.extensionsResource))??this.G:this.H.defaultProfile}};ne=Re([Ae(2,D.$Lk),Ae(3,S.$zp),Ae(4,E.$Jk),Ae(5,i.$_j),Ae(6,s.$$i)],ne);function he(fe,V){const ie=(0,$.$Ho)(fe.manifest.publisher,fe.manifest.name);return{id:ie,identifier:new c.$8l(ie),isBuiltin:fe.type===0,isUserBuiltin:fe.type===1&&fe.isBuiltin,isUnderDevelopment:V,extensionLocation:fe.location,uuid:fe.identifier.uuid,targetPlatform:fe.targetPlatform,...fe.manifest}}e.$Gp=he;class Z extends ee{constructor(V,ie,Y,J,re,ce,oe,_,q,Q,O,N){super(V,ie,(0,u.$wg)(Y,".vscode-oss-dev","extensions","control.json"),J,re,ce,oe,_,q,Q,O,N),this.R=(async()=>{if(v.$t)try{const U=await this.w.readFile(h.URI.file(v.$t));return JSON.parse(U.value.toString())}catch{}return Object.create(null)})()}f(V){return this.R}}e.$Hp=Z}),define(be[257],we([1,0,52,14,40,5,2,12,7,21,13,33]),function(ue,e,y,R,r,L,I,C,p,w,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jp=void 0;let v=class extends I.$Sc{constructor(b,m){super(),this.b=b,this.f=m,this.a=new R.$1g(5)}async postUninstall(b){const m=this.g(b,"uninstall");m&&(this.f.info(b.identifier.id,b.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(m.script,"uninstall",m.args,!0,b),this.f.info("Finished running post uninstall script",b.identifier.id,b.manifest.version)}catch(d){this.f.error("Failed to run post uninstall script",b.identifier.id,b.manifest.version),this.f.error(d)}}));try{await w.Promises.rm(this.m(b))}catch(d){this.f.error("Error while removing extension storage path",b.identifier.id),this.f.error(d)}}g(b,m){const d=`vscode:${m}`;if(b.location.scheme===C.Schemas.file&&b.manifest&&b.manifest.scripts&&typeof b.manifest.scripts[d]=="string"){const h=b.manifest.scripts[d].split(" ");return h.length<2||h[0]!=="node"||!h[1]?(this.f.warn(b.identifier.id,b.manifest.version,`${d} should be a node script`),null):{script:(0,p.$jc)(b.location.fsPath,h[1]),args:h.slice(2)||[]}}return null}h(b,m,d,h,g){return new Promise((l,$)=>{const c=this.j(b,m,d,g);let n;const i=o=>{n&&(clearTimeout(n),n=null),o?$(o):l(void 0)};c.on("error",o=>{i((0,r.$Bi)(o)||"Unknown")}),c.on("exit",(o,s)=>{i(o?`post-${m} process exited with code ${o}`:void 0)}),h&&(n=setTimeout(()=>{n=null,c.kill(),$("timed out")},5e3))})}j(b,m,d,h){const g={silent:!0,execArgv:void 0},l=(0,y.fork)(b,[`--type=extension-post-${m}`,...d],g);l.stdout.setEncoding("utf8"),l.stderr.setEncoding("utf8");const $=L.Event.fromNodeEventEmitter(l.stdout,"data"),c=L.Event.fromNodeEventEmitter(l.stderr,"data");$(o=>this.f.info(h.identifier.id,h.manifest.version,`post-${m}`,o)),c(o=>this.f.error(h.identifier.id,h.manifest.version,`post-${m}`,o));const n=L.Event.any(L.Event.map($,o=>({data:`%c${o}`,format:[""]})),L.Event.map(c,o=>({data:`%c${o}`,format:["color: red"]})));return L.Event.debounce(n,(o,s)=>o?{data:o.data+s.data,format:[...o.format,...s.format]}:{data:s.data,format:s.format},100)(o=>{console.group(h.identifier.id),console.log(o.data,...o.format),console.groupEnd()}),l}m(b){return(0,p.$jc)(this.b.defaultProfile.globalStorageHome.fsPath,b.identifier.id.toLowerCase())}};e.$Jp=v,e.$Jp=v=Re([Ae(0,k.$Lk),Ae(1,A.$$i)],v)}),define(be[125],we([1,0,13,33,34,32,45,16,25,4]),function(ue,e,y,R,r,L,I,C,p,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ON=void 0;let A=class extends I.$Ap{constructor(v,u,b,m,d,h){super(w.URI.file(v.extensionsPath),u,b,m,d,h)}};e.$ON=A,e.$ON=A=Re([Ae(0,p.$Yh),Ae(1,C.$_j),Ae(2,R.$Lk),Ae(3,r.$Jk),Ae(4,L.$dl),Ae(5,y.$$i)],A)}),define(be[258],we([1,0,14,5,2,41,8,159,6,33]),function(ue,e,y,R,r,L,I,C,p,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dp=e.$cp=e.$bp=e.$ap=e.$_o=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$$o=e.$0o=e.$9o=void 0,e.$9o="__$__isNewStorageMarker",e.$0o="__$__targetStorageMarker",e.$$o=(0,p.$Qh)("storageService");var A;(function(g){g[g.NONE=0]="NONE",g[g.SHUTDOWN=1]="SHUTDOWN"})(A||(e.WillSaveStateReason=A={}));var k;(function(g){g[g.APPLICATION=-1]="APPLICATION",g[g.PROFILE=0]="PROFILE",g[g.WORKSPACE=1]="WORKSPACE"})(k||(e.StorageScope=k={}));var v;(function(g){g[g.USER=0]="USER",g[g.MACHINE=1]="MACHINE"})(v||(e.StorageTarget=v={}));function u(g){const l=g.get(e.$0o);if(l)try{return JSON.parse(l)}catch{}return Object.create(null)}e.$_o=u;class b extends r.$Sc{constructor(l={flushInterval:b.a}){super(),this.m=l,this.b=this.B(new R.$Rd),this.c=this.B(new R.$Rd),this.onDidChangeTarget=this.c.event,this.f=this.B(new R.$Od),this.onWillSaveState=this.f.event,this.h=this.B(new y.$7g(()=>this.n(),this.m.flushInterval)),this.j=this.B(new r.$Tc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(l,$,c){return R.Event.filter(this.b.event,n=>n.scope===l&&($===void 0||n.key===$),c)}n(){this.j.value=(0,y.$$g)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,r.$Nc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,L.mark)("code/willInitStorage");try{await this.O()}finally{(0,L.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(l,$){const{key:c,external:n}=$;if(c===e.$0o){switch(l){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:l})}else this.b.fire({scope:l,key:c,target:this.J(l)[c],external:n})}w(l){this.f.fire({reason:l})}get(l,$,c){return this.P($)?.get(l,c)}getBoolean(l,$,c){return this.P($)?.getBoolean(l,c)}getNumber(l,$,c){return this.P($)?.getNumber(l,c)}getObject(l,$,c){return this.P($)?.getObject(l,c)}storeAll(l,$){this.y(()=>{for(const c of l)this.store(c.key,c.value,c.scope,c.target,$)})}store(l,$,c,n,i=!1){if((0,I.$If)($)){this.remove(l,c,i);return}this.y(()=>{this.z(l,c,n),this.P(c)?.set(l,$,i)})}remove(l,$,c=!1){this.y(()=>{this.z(l,$,void 0),this.P($)?.delete(l,c)})}y(l){this.b.pause(),this.c.pause();try{l()}finally{this.b.resume(),this.c.resume()}}keys(l,$){const c=[],n=this.J(l);for(const i of Object.keys(n))n[i]===$&&c.push(i);return c}z(l,$,c,n=!1){const i=this.J($);typeof c=="number"?i[l]!==c&&(i[l]=c,this.P($)?.set(e.$0o,JSON.stringify(i),n)):typeof i[l]=="number"&&(delete i[l],this.P($)?.set(e.$0o,JSON.stringify(i),n))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(l){switch(l){case-1:return this.I;case 0:return this.G;default:return this.D}}L(l){const $=this.P(l);return $?u($):Object.create(null)}isNew(l){return this.getBoolean(e.$9o,l)===!0}async flush(l=A.NONE){this.f.fire({reason:l});const $=this.P(-1),c=this.P(0),n=this.P(1);switch(l){case A.NONE:await y.Promises.settled([$?.whenFlushed()??Promise.resolve(),c?.whenFlushed()??Promise.resolve(),n?.whenFlushed()??Promise.resolve()]);break;case A.SHUTDOWN:await y.Promises.settled([$?.flush(0)??Promise.resolve(),c?.flush(0)??Promise.resolve(),n?.flush(0)??Promise.resolve()]);break}}async log(){const l=this.P(-1)?.items??new Map,$=this.P(0)?.items??new Map,c=this.P(1)?.items??new Map;return h(l,$,c,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(l){return await this.flush(),this.P(l)?.optimize()}async switch(l,$){return this.w(A.NONE),(0,w.$Kk)(l)?this.R(l,$):this.S(l,$)}M(l,$){return!(l.id===$.id||m($)&&m(l))}N(l,$,c){this.y(()=>{const n=new Set;for(const[i,o]of l)n.add(i),$.get(i)!==o&&this.u(c,{key:i,external:!0});for(const[i]of $.items)n.has(i)||this.u(c,{key:i,external:!0})})}}e.$ap=b,b.a=60*1e3;function m(g){return g.isDefault||!!g.useDefaultFlags?.globalState}e.$bp=m;class d extends b{constructor(){super(),this.U=this.B(new C.$7o(new C.$8o,{hint:C.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new C.$7o(new C.$8o,{hint:C.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new C.$7o(new C.$8o,{hint:C.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(l=>this.u(1,l))),this.B(this.W.onDidChangeStorage(l=>this.u(0,l))),this.B(this.U.onDidChangeStorage(l=>this.u(-1,l)))}P(l){switch(l){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(l){switch(l){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(l){return!1}}e.$cp=d;async function h(g,l,$,c,n,i){const o=M=>{try{return JSON.parse(M)}catch{return M}},s=new Map,t=new Map;g.forEach((M,ee)=>{s.set(ee,M),t.set(ee,o(M))});const a=new Map,f=new Map;l.forEach((M,ee)=>{a.set(ee,M),f.set(ee,o(M))});const S=new Map,D=new Map;$.forEach((M,ee)=>{S.set(ee,M),D.set(ee,o(M))}),console.group(c!==n?`Storage: Application (path: ${c})`:`Storage: Application & Profile (path: ${c}, default profile)`);const E=[];if(s.forEach((M,ee)=>{E.push({key:ee,value:M})}),console.table(E),console.groupEnd(),console.log(t),c!==n){console.group(`Storage: Profile (path: ${n}, profile specific)`);const M=[];a.forEach((ee,se)=>{M.push({key:se,value:ee})}),console.table(M),console.groupEnd(),console.log(f)}console.group(`Storage: Workspace (path: ${i})`);const P=[];S.forEach((M,ee)=>{P.push({key:ee,value:M})}),console.table(P),console.groupEnd(),console.log(D)}e.$dp=h}),define(be[126],we([1,0,18,20,11,3,28,8,4,24,25,30,36,80,16,13,31,44,241,258,32,61]),function(ue,e,y,R,r,L,I,C,p,w,A,k,v,u,b,m,d,h,g,l,$,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ip=e.$hp=e.$gp=void 0;const n=L.$j?"web":(0,k.$$n)(L.$o,I.$ec),i="X-Market-Search-Activity-Id";var o;(function(O){O[O.None=0]="None",O[O.IncludeVersions=1]="IncludeVersions",O[O.IncludeFiles=2]="IncludeFiles",O[O.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",O[O.IncludeSharedAccounts=8]="IncludeSharedAccounts",O[O.IncludeVersionProperties=16]="IncludeVersionProperties",O[O.ExcludeNonValidated=32]="ExcludeNonValidated",O[O.IncludeInstallationTargets=64]="IncludeInstallationTargets",O[O.IncludeAssetUri=128]="IncludeAssetUri",O[O.IncludeStatistics=256]="IncludeStatistics",O[O.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",O[O.Unpublished=4096]="Unpublished",O[O.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(o||(o={}));function s(...O){return String(O.reduce((N,U)=>N|U,0))}var t;(function(O){O[O.Tag=1]="Tag",O[O.ExtensionId=4]="ExtensionId",O[O.Category=5]="Category",O[O.ExtensionName=7]="ExtensionName",O[O.Target=8]="Target",O[O.Featured=9]="Featured",O[O.SearchText=10]="SearchText",O[O.ExcludeWithFlags=12]="ExcludeWithFlags"})(t||(t={}));const a={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},f={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},D={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:o.None,criteria:[],assetTypes:[]};class E{constructor(N=D){this.d=N}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(N,U=this.d.pageSize){return new E({...this.d,pageNumber:N,pageSize:U})}withFilter(N,...U){const T=[...this.d.criteria,...U.length?U.map(z=>({filterType:N,value:z})):[{filterType:N}]];return new E({...this.d,criteria:T})}withSortBy(N){return new E({...this.d,sortBy:N})}withSortOrder(N){return new E({...this.d,sortOrder:N})}withFlags(...N){return new E({...this.d,flags:N.reduce((U,T)=>U|T,0)})}withAssetTypes(...N){return new E({...this.d,assetTypes:N})}withSource(N){return new E({...this.d,source:N})}get raw(){const{criteria:N,pageNumber:U,pageSize:T,sortBy:z,sortOrder:B,flags:te,assetTypes:H}=this.d;return{filters:[{criteria:N,pageNumber:U,pageSize:T,sortBy:z,sortOrder:B}],assetTypes:H,flags:te}}get searchText(){const N=this.d.criteria.filter(U=>U.filterType===t.SearchText)[0];return N&&N.value?N.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(N=>String(N.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function P(O,N){const U=(O||[]).filter(T=>T.statisticName===N)[0];return U?U.value:0}function M(O){const N="Microsoft.VisualStudio.Code.Translation.";return O.files.filter(T=>T.assetType.indexOf(N)===0).reduce((T,z)=>{const B=G(O,z.assetType);return B&&T.push([z.assetType.substring(N.length),B]),T},[])}function ee(O){if(O.properties){const N=O.properties.filter(z=>z.key===a.Repository),U=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),T=N.filter(z=>U.test(z.value))[0];return T?{uri:T.value,fallbackUri:T.value}:null}return G(O,a.Repository)}function se(O){return{uri:`${O.fallbackAssetUri}/${a.VSIX}?redirect=true${O.targetPlatform?`&targetPlatform=${O.targetPlatform}`:""}`,fallbackUri:`${O.fallbackAssetUri}/${a.VSIX}${O.targetPlatform?`?targetPlatform=${O.targetPlatform}`:""}`}}function G(O,N){return O.files.filter(T=>T.assetType===N)[0]?{uri:`${O.assetUri}/${N}${O.targetPlatform?`?targetPlatform=${O.targetPlatform}`:""}`,fallbackUri:`${O.fallbackAssetUri}/${N}${O.targetPlatform?`?targetPlatform=${O.targetPlatform}`:""}`}:null}function ne(O,N){const U=O.properties?O.properties.filter(z=>z.key===N):[],T=U.length>0&&U[0].value;return T?T.split(",").map(z=>(0,v.$Io)(z)):[]}function he(O){const N=O.properties?O.properties.filter(U=>U.key===f.Engine):[];return N.length>0&&N[0].value||""}function Z(O){const N=O.properties?O.properties.filter(U=>U.key===f.PreRelease):[];return N.length>0&&N[0].value==="true"}function fe(O){const N=O.properties?O.properties.filter(T=>T.key===f.LocalizedLanguages):[],U=N.length>0&&N[0].value||"";return U?U.split(","):[]}function V(O){return O.properties?.find(N=>N.key===f.SponsorLink)?.value}function ie(O){return O.indexOf("preview")!==-1}function Y(O){return O.targetPlatform?(0,k.$0n)(O.targetPlatform):"undefined"}function J(O){const N=(0,y.$Mb)(O.versions.map(Y)),U=!!O.tags?.includes(k.$5n),T=N.indexOf("web");return U?T===-1&&N.push("web"):T!==-1&&N.splice(T,1),N}function re(O,N){for(let U=0;U<O.length;U++){const T=O[U];if(T.version===O[U-1]?.version){let z=U;if(Y(T)===N)for(;z>0&&O[z-1].version===T.version;)z--;z!==U&&(O.splice(U,1),O.splice(z,0,T))}}return O}e.$gp=re;function ce(O,N,U){O.telemetryData={index:N,querySource:U,queryActivityId:O.queryContext?.[i]}}function oe(O,N,U,T){const z=O.versions[0],B={manifest:G(N,a.Manifest),readme:G(N,a.Details),changelog:G(N,a.Changelog),license:G(N,a.License),repository:ee(N),download:se(N),icon:G(N,a.Icon),signature:G(N,a.Signature),coreTranslations:M(N)};return{identifier:{id:(0,v.$Jo)(O.publisher.publisherName,O.extensionName),uuid:O.extensionId},name:O.extensionName,version:N.version,displayName:O.displayName,publisherId:O.publisher.publisherId,publisher:O.publisher.publisherName,publisherDisplayName:O.publisher.displayName,publisherDomain:O.publisher.domain?{link:O.publisher.domain,verified:!!O.publisher.isDomainVerified}:void 0,publisherSponsorLink:V(z),description:O.shortDescription||"",installCount:P(O.statistics,"install"),rating:P(O.statistics,"averagerating"),ratingCount:P(O.statistics,"ratingcount"),categories:O.categories||[],tags:O.tags||[],releaseDate:Date.parse(O.releaseDate),lastUpdated:Date.parse(O.lastUpdated),allTargetPlatforms:U,assets:B,properties:{dependencies:ne(N,f.Dependency),extensionPack:ne(N,f.ExtensionPack),engine:he(N),localizedLanguages:fe(N),targetPlatform:Y(N),isPreReleaseVersion:Z(N)},hasPreReleaseVersion:Z(z),hasReleaseVersion:!0,preview:ie(O.flags),isSigned:!!B.signature,queryContext:T}}let _=class{constructor(N,U,T,z,B,te,H,x){this.k=U,this.l=T,this.n=z,this.o=B,this.q=te,this.u=H,this.w=x;const W=H.extensionsGallery,X=W?.servicePPEUrl&&x.getValue("_extensionsGallery.enablePPE");this.d=X?W.servicePPEUrl:W?.serviceUrl,this.g=X?void 0:W?.searchUrl,this.h=W?.controlUrl,this.j=(0,g.$fp)(H.version,H,this.n,this.w,this.q,N,this.o)}x(N=""){return`${this.d}${N}`}isEnabled(){return!!this.d}async getExtensions(N,U,T){const z=R.CancellationToken.isCancellationToken(U)?{}:U,B=R.CancellationToken.isCancellationToken(U)?U:T,te=[],H=[],x=[],W=[];let X=!0;for(const Ee of N){Ee.uuid?H.push(Ee.uuid):te.push(Ee.id);const Ce=!!(Ee.version||Ee.preRelease);x.push({id:Ee.id,uuid:Ee.uuid,includePreRelease:Ce}),Ee.version&&W.push({id:Ee.id,uuid:Ee.uuid,version:Ee.version}),X=X&&!!Ee.hasPreRelease&&!Ce}if(!H.length&&!te.length)return[];let ae=new E().withPage(1,N.length);H.length&&(ae=ae.withFilter(t.ExtensionId,...H)),te.length&&(ae=ae.withFilter(t.ExtensionName,...te)),(z.queryAllVersions||X)&&(ae=ae.withFlags(ae.flags,o.IncludeVersions)),z.source&&(ae=ae.withSource(z.source));const{extensions:ge}=await this.z(ae,{targetPlatform:z.targetPlatform??n,includePreRelease:x,versions:W,compatible:!!z.compatible},B);return z.source&&ge.forEach((Ee,Ce)=>ce(Ee,Ce,z.source)),ge}async getCompatibleExtension(N,U,T){if((0,k.$_n)(N.allTargetPlatforms,T))return null;if(await this.isExtensionCompatible(N,U,T))return N;const z=new E().withFlags(o.IncludeVersions).withPage(1,1).withFilter(t.ExtensionId,N.identifier.uuid),{extensions:B}=await this.z(z,{targetPlatform:T,compatible:!0,includePreRelease:U},R.CancellationToken.None);return B[0]||null}async isExtensionCompatible(N,U,T){if(!(0,k.$ao)(N.properties.targetPlatform,N.allTargetPlatforms,T)||!U&&N.properties.isPreReleaseVersion)return!1;let z=N.properties.engine;if(!z){const B=await this.getManifest(N,R.CancellationToken.None);if(!B)throw new Error("Manifest was not found");z=B.engines.vscode}return(0,u.$Wo)(z,this.u.version,this.u.date)}async y(N,U,T,z,B){if(!(0,k.$ao)(Y(N),z,B)||U!=="any"&&Z(N)!==(U==="prerelease"))return!1;if(T)try{const te=await this.E(N);if(!(0,u.$Wo)(te,this.u.version,this.u.date))return!1}catch(te){return this.l.error(`Error while getting the engine for the version ${N.version}.`,(0,r.$0)(te)),!1}return!0}async query(N,U){let T=N.text||"";const z=N.pageSize??50;let B=new E().withPage(1,z);T?(T=T.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(X,ae,ge)=>(B=B.withFilter(t.Category,ge||ae),"")),T=T.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(X,ae,ge)=>(B=B.withFilter(t.Tag,ge||ae),"")),T=T.replace(/\bfeatured(\s+|\b|$)/g,()=>(B=B.withFilter(t.Featured),"")),T=T.trim(),T&&(T=T.length<200?T:T.substring(0,200),B=B.withFilter(t.SearchText,T)),B=B.withSortBy(0)):N.ids?B=B.withFilter(t.ExtensionId,...N.ids):N.names?B=B.withFilter(t.ExtensionName,...N.names):B=B.withSortBy(4),typeof N.sortBy=="number"&&(B=B.withSortBy(N.sortBy)),typeof N.sortOrder=="number"&&(B=B.withSortOrder(N.sortOrder)),N.source&&(B=B.withSource(N.source));const te=async(X,ae)=>{const{extensions:ge,total:Ee}=await this.z(X,{targetPlatform:n,compatible:!1,includePreRelease:!!N.includePreRelease},ae);return ge.forEach((Ce,Ne)=>ce(Ce,(X.pageNumber-1)*X.pageSize+Ne,N.source)),{extensions:ge,total:Ee}},{extensions:H,total:x}=await te(B,U),W=async(X,ae)=>{if(ae.isCancellationRequested)throw new r.$5;const{extensions:ge}=await te(B.withPage(X+1),ae);return ge};return{firstPage:H,total:x,pageSize:B.pageSize,getPage:W}}async z(N,U,T){const z=N.flags;N.flags&o.IncludeLatestVersionOnly&&N.flags&o.IncludeVersions&&(N=N.withFlags(N.flags&~o.IncludeVersions,o.IncludeLatestVersionOnly)),!(N.flags&o.IncludeLatestVersionOnly)&&!(N.flags&o.IncludeVersions)&&(N=N.withFlags(N.flags,o.IncludeLatestVersionOnly)),U.versions?.length&&(N=N.withFlags(N.flags&~o.IncludeLatestVersionOnly,o.IncludeVersions)),N=N.withFlags(N.flags,o.IncludeAssetUri,o.IncludeCategoryAndTags,o.IncludeFiles,o.IncludeStatistics,o.IncludeVersionProperties);const{galleryExtensions:B,total:te,context:H}=await this.B(N,T);if(!(N.flags&o.IncludeLatestVersionOnly)){const ae=[];for(const ge of B){const Ee=await this.A(ge,U,H);Ee&&ae.push(Ee)}return{extensions:ae,total:te}}const W=[],X=new Map;for(let ae=0;ae<B.length;ae++){const ge=B[ae],Ee={id:(0,v.$Jo)(ge.publisher.publisherName,ge.extensionName),uuid:ge.extensionId},Ce=(0,C.$Ff)(U.includePreRelease)?U.includePreRelease:!!U.includePreRelease.find(Fe=>(0,v.$Eo)(Fe,Ee))?.includePreRelease;if(U.compatible&&(0,k.$_n)(J(ge),U.targetPlatform))continue;const Ne=await this.A(ge,U,H);!Ne||Ne.properties.isPreReleaseVersion&&(!Ce||!Ne.hasReleaseVersion)||!Ne.properties.isPreReleaseVersion&&Ne.properties.targetPlatform!==U.targetPlatform&&Ne.hasPreReleaseVersion?X.set(ge.extensionId,ae):W.push([ae,Ne])}if(X.size){const ae=new c.$Kd,ge=new E().withFlags(z&~o.IncludeLatestVersionOnly,o.IncludeVersions).withPage(1,X.size).withFilter(t.ExtensionId,...X.keys()),{extensions:Ee}=await this.z(ge,U,T);this.o.publicLog2("galleryService:additionalQuery",{duration:ae.elapsed(),count:X.size});for(const Ce of Ee){const Ne=X.get(Ce.identifier.uuid);W.push([Ne,Ce])}}return{extensions:W.sort((ae,ge)=>ae[0]-ge[0]).map(([,ae])=>ae),total:te}}async A(N,U,T){const z={id:(0,v.$Jo)(N.publisher.publisherName,N.extensionName),uuid:N.extensionId},B=U.versions?.find(W=>(0,v.$Eo)(W,z))?.version,te=(0,C.$Ff)(U.includePreRelease)?U.includePreRelease:!!U.includePreRelease.find(W=>(0,v.$Eo)(W,z))?.includePreRelease,H=J(N),x=re(N.versions,U.targetPlatform);if(U.compatible&&(0,k.$_n)(H,U.targetPlatform))return null;for(let W=0;W<x.length;W++){const X=x[W];if(!(B&&X.version!==B)){if(await this.y(X,te?"any":"release",U.compatible,H,U.targetPlatform))return oe(N,X,H,T);if(B&&X.version===B)return null}}return B||U.compatible?null:oe(N,N.versions[0],H)}async B(N,U){if(!this.isEnabled())throw new Error("No extension gallery service configured.");N=N.withFlags(N.flags,o.ExcludeNonValidated).withFilter(t.Target,"Microsoft.VisualStudio.Code").withFilter(t.ExcludeWithFlags,s(o.Unpublished));const T=await this.j,z=JSON.stringify(N.raw),B={...T,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(z.length)},te=new c.$Kd;let H,x,W=0;try{if(H=await this.k.request({type:"POST",url:this.g&&N.criteria.some(ae=>ae.filterType===t.SearchText)?this.g:this.x("/extensionquery"),data:z,headers:B},U),H.res.statusCode&&H.res.statusCode>=400&&H.res.statusCode<500)return{galleryExtensions:[],total:W};const X=await(0,h.$4o)(H);if(X){const ae=X.results[0],ge=ae.extensions,Ee=ae.resultMetadata&&ae.resultMetadata.filter(Ce=>Ce.metadataType==="ResultCount")[0];return W=Ee&&Ee.metadataItems.filter(Ce=>Ce.name==="TotalCount")[0].count||0,{galleryExtensions:ge,total:W,context:{[i]:H.res.headers.activityid}}}return{galleryExtensions:[],total:W}}catch(X){throw x=X,X}finally{this.o.publicLog2("galleryService:query",{...N.telemetryData,requestBodySize:String(z.length),duration:te.elapsed(),success:!!H&&(0,h.$Zo)(H),responseBodySize:H?.res.headers["Content-Length"],statusCode:H?String(H.res.statusCode):void 0,errorCode:x?(0,r.$4)(x)?"canceled":(0,r.$0)(x).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(W)})}}async reportStatistic(N,U,T,z){if(!this.isEnabled())return;const B=L.$j?this.x(`/itemName/${N}.${U}/version/${T}/statType/${z==="install"?"1":"3"}/vscodewebextension`):this.x(`/publishers/${N}/extensions/${U}/${T}/stats?statType=${z}`),te=L.$j?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",x={...await this.j,Accept:te};try{await this.k.request({type:"POST",url:B,headers:x},R.CancellationToken.None)}catch{}}async download(N,U,T){this.l.trace("ExtensionGalleryService#download",N.identifier.id);const z=(0,v.$Mo)(N),B=new Date().getTime(),te=ae=>this.o.publicLog("galleryService:downloadVSIX",{...z,duration:ae}),H=T===2?"install":T===3?"update":"",x=H?{uri:`${N.assets.download.uri}${p.URI.parse(N.assets.download.uri).query?"&":"?"}${H}=true`,fallbackUri:`${N.assets.download.fallbackUri}${p.URI.parse(N.assets.download.fallbackUri).query?"&":"?"}${H}=true`}:N.assets.download,W=N.queryContext?.[i]?{[i]:N.queryContext[i]}:void 0,X=await this.D(x,W?{headers:W}:void 0);await this.q.writeFile(U,X.stream),te(new Date().getTime()-B)}async downloadSignatureArchive(N,U){if(!N.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",N.identifier.id);const T=await this.D(N.assets.signature);await this.q.writeFile(U,T.stream)}async getReadme(N,U){if(N.assets.readme){const T=await this.D(N.assets.readme,{},U);return await(0,h.$3o)(T)||""}return""}async getManifest(N,U){if(N.assets.manifest){const T=await this.D(N.assets.manifest,{},U),z=await(0,h.$3o)(T);return z?JSON.parse(z):null}return null}async C(N,U){const T=G(N,a.Manifest);if(!T)throw new Error("Manifest was not found");const z={"Accept-Encoding":"gzip"},B=await this.D(T,{headers:z});return await(0,h.$4o)(B)}async getCoreTranslation(N,U){const T=N.assets.coreTranslations.filter(z=>z[0]===U.toUpperCase())[0];if(T){const z=await this.D(T[1]),B=await(0,h.$3o)(z);return B?JSON.parse(B):null}return null}async getChangelog(N,U){if(N.assets.changelog){const T=await this.D(N.assets.changelog,{},U);return await(0,h.$3o)(T)||""}return""}async getAllCompatibleVersions(N,U,T){let z=new E().withFlags(o.IncludeVersions,o.IncludeCategoryAndTags,o.IncludeFiles,o.IncludeVersionProperties).withPage(1,1);N.identifier.uuid?z=z.withFilter(t.ExtensionId,N.identifier.uuid):z=z.withFilter(t.ExtensionName,N.identifier.id);const{galleryExtensions:B}=await this.B(z,R.CancellationToken.None);if(!B.length)return[];const te=J(B[0]);if((0,k.$_n)(te,T))return[];const H=[];await Promise.all(B[0].versions.map(async X=>{try{await this.y(X,U?"any":"release",!0,te,T)&&H.push(X)}catch{}}));const x=[],W=new Set;for(const X of re(H,T))W.has(X.version)||(W.add(X.version),x.push({version:X.version,date:X.lastUpdated,isPreReleaseVersion:Z(X)}));return x}async D(N,U={},T=R.CancellationToken.None){const z=await this.j,B={type:"GET"},te={...z,...U.headers||{}};U={...U,...B,headers:te};const H=N.uri,x=N.fallbackUri,W={...U,url:H};try{const X=await this.k.request(W,T);if(X.res.statusCode===200)return X;const ae=await(0,h.$3o)(X);throw new Error(`Expected 200, got back ${X.res.statusCode} instead.

${ae}`)}catch(X){if((0,r.$4)(X))throw X;const ae=(0,r.$0)(X);this.o.publicLog2("galleryService:cdnFallback",{url:H,message:ae});const ge={...U,url:x};return this.k.request(ge,T)}}async E(N){let U=he(N);if(!U){const T=await this.C(N,R.CancellationToken.None);if(!T)throw new Error("Manifest was not found");U=T.engines.vscode}return U}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{},search:[]};const N=await this.k.request({type:"GET",url:this.h},R.CancellationToken.None);if(N.res.statusCode!==200)throw new Error("Could not get extensions report.");const U=await(0,h.$4o)(N),T=[],z={},B=[];if(U){for(const te of U.malicious)T.push({id:te});if(U.migrateToPreRelease)for(const[te,H]of Object.entries(U.migrateToPreRelease))(!H.engine||(0,u.$Wo)(H.engine,this.u.version,this.u.date))&&(z[te.toLowerCase()]={disallowInstall:!0,extension:{id:H.id,displayName:H.displayName,autoMigrate:{storage:!!H.migrateStorage},preRelease:!0}});if(U.deprecated)for(const[te,H]of Object.entries(U.deprecated))H&&(z[te.toLowerCase()]=(0,C.$Ff)(H)?{}:H);if(U.search)for(const te of U.search)B.push(te)}return{malicious:T,deprecated:z,search:B}}};_=Re([Ae(1,h.$Xo),Ae(2,m.$$i),Ae(3,A.$Xh),Ae(4,$.$dl),Ae(5,b.$_j),Ae(6,d.$qj),Ae(7,w.$ki)],_);let q=class extends _{constructor(N,U,T,z,B,te,H,x){super(N,U,T,z,B,te,H,x)}};e.$hp=q,e.$hp=q=Re([Ae(0,l.$$o),Ae(1,h.$Xo),Ae(2,m.$$i),Ae(3,A.$Xh),Ae(4,$.$dl),Ae(5,b.$_j),Ae(6,d.$qj),Ae(7,w.$ki)],q);let Q=class extends _{constructor(N,U,T,z,B,te,H){super(void 0,N,U,T,z,B,te,H)}};e.$ip=Q,e.$ip=Q=Re([Ae(0,h.$Xo),Ae(1,m.$$i),Ae(2,A.$Xh),Ae(3,$.$dl),Ae(4,b.$_j),Ae(5,d.$qj),Ae(6,w.$ki)],Q)}),define(be[259],we([1,0,5,2,33,51]),function(ue,e,y,R,r,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WN=e.$VN=void 0;class I{constructor(w,A){this.a=w,this.b=A}listen(w,A){const k=this.b(w);switch(A){case"onDidChangeProfiles":return y.Event.map(this.a.onDidChangeProfiles,v=>({all:v.all.map(u=>(0,L.$Pm)({...u},k)),added:v.added.map(u=>(0,L.$Pm)({...u},k)),removed:v.removed.map(u=>(0,L.$Pm)({...u},k)),updated:v.updated.map(u=>(0,L.$Pm)({...u},k))}))}throw new Error(`Invalid listen ${A}`)}async call(w,A,k){const v=this.b(w);switch(A){case"createProfile":{const u=await this.a.createProfile(k[0],k[1],k[2]);return(0,L.$Pm)({...u},v)}case"updateProfile":{let u=(0,r.$Mk)((0,L.$Qm)(k[0],v),this.a.profilesHome.scheme);return u=await this.a.updateProfile(u,k[1]),(0,L.$Pm)({...u},v)}case"removeProfile":{const u=(0,r.$Mk)((0,L.$Qm)(k[0],v),this.a.profilesHome.scheme);return this.a.removeProfile(u)}}throw new Error(`Invalid call ${A}`)}}e.$VN=I;class C extends R.$Sc{get defaultProfile(){return this.profiles[0]}get profiles(){return this.a}constructor(w,A,k){super(),this.profilesHome=A,this.f=k,this.a=[],this.b=this.B(new y.$Od),this.onDidChangeProfiles=this.b.event,this.c=!0,this.a=w.map(v=>(0,r.$Mk)(v,this.profilesHome.scheme)),this.B(this.f.listen("onDidChangeProfiles")(v=>{const u=v.added.map(d=>(0,r.$Mk)(d,this.profilesHome.scheme)),b=v.removed.map(d=>(0,r.$Mk)(d,this.profilesHome.scheme)),m=v.updated.map(d=>(0,r.$Mk)(d,this.profilesHome.scheme));this.a=v.all.map(d=>(0,r.$Mk)(d,this.profilesHome.scheme)),this.b.fire({added:u,removed:b,updated:m,all:this.profiles})})),this.onDidResetWorkspaces=this.f.listen("onDidResetWorkspaces")}setEnablement(w){this.c=w}isEnabled(){return this.c}async createNamedProfile(w,A,k){const v=await this.f.call("createNamedProfile",[w,A,k]);return(0,r.$Mk)(v,this.profilesHome.scheme)}async createProfile(w,A,k,v){const u=await this.f.call("createProfile",[w,A,k,v]);return(0,r.$Mk)(u,this.profilesHome.scheme)}async createTransientProfile(w){const A=await this.f.call("createTransientProfile",[w]);return(0,r.$Mk)(A,this.profilesHome.scheme)}async setProfileForWorkspace(w,A){await this.f.call("setProfileForWorkspace",[w,A])}removeProfile(w){return this.f.call("removeProfile",[w])}async updateProfile(w,A){const k=await this.f.call("updateProfile",[w,A]);return(0,r.$Mk)(k,this.profilesHome.scheme)}resetWorkspaces(){return this.f.call("resetWorkspaces")}cleanUp(){return this.f.call("cleanUp")}cleanUpTransientProfiles(){return this.f.call("cleanUpTransientProfiles")}}e.$WN=C}),define(be[127],we([1,0,4,25,16,13,235,34,33,8,236]),function(ue,e,y,R,r,L,I,C,p,w,A){"use strict";var k,v;Object.defineProperty(e,"__esModule",{value:!0}),e.$NN=e.$MN=e.$LN=void 0;let u=k=class extends p.$Ok{constructor(h,g,l,$,c){super(l,$,g,c),this.U=h,this.W=l}O(){return this.U.getItem(k.b,[]).map(g=>({...g,location:(0,w.$zf)(g.location)?this.w.extUri.joinPath(this.profilesHome,g.location):y.URI.revive(g.location)}))}Q(){const h=this.U.getItem(k.c,{});return this.U.getItem(k.a,!1)?h:this.N(h)}S(){return this.w.extUri.joinPath(y.URI.file(this.W.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.$LN=u,u.a="profileAssociationsMigration",e.$LN=u=k=Re([Ae(0,I.$GN),Ae(1,C.$Jk),Ae(2,R.$Yh),Ae(3,r.$_j),Ae(4,L.$$i)],u);let b=v=class extends u{constructor(h,g,l,$,c){super(h,g,l,$,c),this.$=h}P(h){h.length?this.$.setItem(v.b,h.map(g=>({...g,location:this.w.extUri.basename(g.location)}))):this.$.removeItem(v.b)}O(){const h=super.O();return this.$.getItem("userDataProfilesMigration",!1)||(this.P(h),this.$.setItem("userDataProfilesMigration",!0)),h}R(h){h.emptyWindows||h.workspaces?this.$.setItem(v.c,h):this.$.removeItem(v.c)}Q(){const h="workspaceAndProfileInfo",g=this.$.getItem(h,void 0);if(g){this.$.removeItem(h);const $=g.reduce((c,{workspace:n,profile:i})=>(c[y.URI.revive(n).toString()]=y.URI.revive(i).toString(),c),{});this.$.setItem(v.c,{workspaces:$})}const l=super.Q();return this.$.getItem(v.a,!1)||(this.R(l),this.$.setItem(v.a,!0)),l}};e.$MN=b,e.$MN=b=v=Re([Ae(0,I.$HN),Ae(1,C.$Jk),Ae(2,R.$Yh),Ae(3,r.$_j),Ae(4,L.$$i)],b);let m=class extends b{constructor(h,g,l,$){super(new A.$KN(0,g,$,l),h,g,l,$)}async init(){return await this.$.init(),super.init()}};e.$NN=m,e.$NN=m=Re([Ae(0,C.$Jk),Ae(1,R.$Yh),Ae(2,r.$_j),Ae(3,L.$$i)],m)}),define(be[128],we([1,0,6]),function(ue,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ym=e.$xm=void 0,e.$xm=(0,y.$Qh)("extensionHostStatusService");class R{constructor(){this.a=new Map}setExitInfo(L,I){this.a.set(L,I)}getExitInfo(L){return this.a.get(L)||null}}e.$ym=R}),define(be[260],we([1,0,5,14]),function(ue,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gm=void 0;function r(I){let C=0,p=0,w=0;I>=1e3&&(w=Math.floor(I/1e3),I-=w*1e3),w>=60&&(p=Math.floor(w/60),w-=p*60),p>=60&&(C=Math.floor(p/60),p-=C*60);const A=C?`${C}h`:"",k=p?`${p}m`:"",v=w?`${w}s`:"",u=I?`${I}ms`:"";return`${A}${k}${v}${u}`}class L{constructor(C,p,w,A){this.i=C,this.j=p,this.a=new y.$Od,this.onClose=this.a.event,this.b=108e5,this.c=3e5,this.d=w,this.protocol=A,this.e=!1,this.f=new R.$8g(()=>{this.k(`The reconnection grace time of ${r(this.b)} has expired, so the connection will be disposed.`),this.l()},this.b),this.g=new R.$8g(()=>{this.k(`The reconnection short grace time of ${r(this.c)} has expired, so the connection will be disposed.`),this.l()},this.c),this.protocol.onDidDispose(()=>{this.k("The client has disconnected gracefully, so the connection will be disposed."),this.l()}),this.protocol.onSocketClose(()=>{this.k(`The client has disconnected, will wait for reconnection ${r(this.b)} before disposing...`),this.f.schedule()}),this.k("New connection established.")}k(C){this.i.info(`[${this.d}][${this.j.substr(0,8)}][ManagementConnection] ${C}`)}shortenReconnectionGraceTimeIfNecessary(){this.g.isScheduled()||this.f.isScheduled()&&(this.k(`Another client has connected, will shorten the wait for reconnection ${r(this.c)} before disposing...`),this.g.schedule())}l(){if(this.e)return;this.e=!0,this.f.dispose(),this.g.dispose();const C=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),C.end(),this.a.fire(void 0)}acceptReconnection(C,p,w){this.d=C,this.k("The client has reconnected."),this.f.cancel(),this.g.cancel(),this.protocol.beginAcceptReconnection(p,w),this.protocol.endAcceptReconnection()}}e.$Gm=L}),define(be[91],we([1,0,29,12,7,154,55]),function(ue,e,y,R,r,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pl=e.InternalNLSConfiguration=e.$ol=void 0;const C=r.$jc(R.$dg.asFileUri("").fsPath,"nls.metadata.json"),p=new Map;function w(b){return new Promise(m=>y.exists(b,m))}function A(b,m){return w(C).then(d=>{if(!d||!I.default.commit)return Promise.resolve({locale:"en",osLocale:"en",availableLanguages:{}});const h=`${b}||${m}`;let g=p.get(h);return g||(g=L.getNLSConfiguration(I.default.commit,m,C,b,b).then(l=>(k.is(l)&&(l._languagePackSupport=!0),l.locale!=="en"&&l.locale!=="en-us"&&Object.keys(l.availableLanguages).length===0&&p.delete(h),l)),p.set(h,g)),g})}e.$ol=A;var k;(function(b){function m(d){const h=d;return h&&typeof h._languagePackId=="string"}b.is=m})(k||(e.InternalNLSConfiguration=k={}));const v=async b=>{try{const m=u(await y.promises.readFile(b,"utf8"));return JSON.parse(m).locale}catch(m){return m.code!=="ENOENT"&&console.warn(m),"en"}};e.$pl=v;const u=b=>{const m=/('(?:[^\\']*(?:\\.)?)*')|('(?:[^\\']*(?:\\.)?)*')|(\/\*(?:\r?\n|.)*?\*\/)|(\/{2,}.*?(?:(?:\r?\n)|$))/g;return b.replace(m,(d,h,g,l,$)=>{if(l)return"";if($){const c=$.length;return c>2&&$[c-1]===`
`?$[c-2]==="\r"?`\r
`:`
`:""}else return d})}}),define(be[129],we([1,0,19,4,25,45,58,16,6,13,31,34,33,91]),function(ue,e,y,R,r,L,I,C,p,w,A,k,v,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AN=void 0;let b=class extends I.$Ep{constructor(d,h,g,l,$,c,n,i){super(R.URI.file($.builtinExtensionsPath),R.URI.file($.extensionsPath),(0,y.$wg)($.userHome,".vscode-oss-dev","extensions","control.json"),d.defaultProfile,d,h,g,l,$,c,n,i),this.R=$}async f(d){const h=await(0,u.$ol)(d,this.R.userDataPath);if(u.InternalNLSConfiguration.is(h))try{const g=await this.w.readFile(R.URI.file(h._translationsConfigFile));return JSON.parse(g.value.toString())}catch{}return Object.create(null)}};e.$AN=b,e.$AN=b=Re([Ae(0,v.$Lk),Ae(1,L.$zp),Ae(2,C.$_j),Ae(3,w.$$i),Ae(4,r.$Yh),Ae(5,A.$qj),Ae(6,k.$Jk),Ae(7,p.$Ph)],b)}),define(be[261],we([1,0,262,29,7,23,12,21]),function(ue,e,y,R,r,L,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mm=e.$Lm=e.$Km=e.$Jm=e.$Im=e.$Hm=e.ServerConnectionTokenType=void 0;const p=/^[0-9A-Za-z_-]+$/;var w;(function(d){d[d.None=0]="None",d[d.Optional=1]="Optional",d[d.Mandatory=2]="Mandatory"})(w||(e.ServerConnectionTokenType=w={}));class A{constructor(){this.type=0}validate(h){return!0}}e.$Hm=A;class k{constructor(h){this.value=h,this.type=2}validate(h){return h===this.value}}e.$Im=k;class v{constructor(h){this.message=h}}e.$Jm=v;async function u(d,h){const g=d["without-connection-token"],l=d["connection-token"],$=d["connection-token-file"];if(g)return typeof l<"u"||typeof $<"u"?new v("Please do not use the argument '--connection-token' or '--connection-token-file' at the same time as '--without-connection-token'."):new A;if(typeof $<"u"){if(typeof l<"u")return new v("Please do not use the argument '--connection-token' at the same time as '--connection-token-file'.");let c;try{c=R.readFileSync($).toString().replace(/\r?\n$/,"")}catch{return new v(`Unable to read the connection token file at '${$}'.`)}return p.test(c)?new k(c):new v(`The connection token defined in '${$} does not adhere to the characters 0-9, a-z, A-Z, _, or -.`)}return typeof l<"u"?p.test(l)?new k(l):new v(`The connection token '${l} does not adhere to the characters 0-9, a-z, A-Z or -.`):new k(await h())}e.$Km=u;async function b(d){return u(d,async()=>{if(!d["user-data-dir"])return(0,L.$fg)();const g=r.$jc(d["user-data-dir"],"token");try{const c=(await C.Promises.readFile(g)).toString().replace(/\r?\n$/,"");if(p.test(c))return c}catch{}const l=(0,L.$fg)();try{await C.Promises.writeFile(g,l,{mode:384})}catch{}return l})}e.$Lm=b;function m(d,h,g){if(d.validate(g.query[I.$9f]))return!0;const l=y.parse(h.headers.cookie||"");return d.validate(l[I.$8f])}e.$Mm=m}),define(be[46],we([1,0,199,109,65,6,25,73]),function(ue,e,y,R,r,L,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qm=e.$pm=e.$om=void 0,e.$om={"disable-update-check":{type:"boolean"},auth:{type:"string"},"disable-file-downloads":{type:"boolean"},locale:{type:"string"},"disable-getting-started-override":{type:"boolean"},host:{type:"string",cat:"o",args:"ip-address",description:y.localize(0,null)},port:{type:"string",cat:"o",args:"port | port range",description:y.localize(1,null)},"socket-path":{type:"string",cat:"o",args:"path",description:y.localize(2,null)},"connection-token":{type:"string",cat:"o",args:"token",deprecates:["connectionToken"],description:y.localize(3,null)},"connection-token-file":{type:"string",cat:"o",args:"path",deprecates:["connection-secret","connectionTokenFile"],description:y.localize(4,null)},"without-connection-token":{type:"boolean",cat:"o",description:y.localize(5,null)},"disable-websocket-compression":{type:"boolean"},"print-startup-performance":{type:"boolean"},"print-ip-address":{type:"boolean"},"accept-server-license-terms":{type:"boolean",cat:"o",description:y.localize(6,null)},"server-data-dir":{type:"string",cat:"o",description:y.localize(7,null)},"telemetry-level":{type:"string",cat:"o",args:"level",description:y.localize(8,null)},"user-data-dir":r.$Hl["user-data-dir"],"enable-smoke-test-driver":r.$Hl["enable-smoke-test-driver"],"disable-telemetry":r.$Hl["disable-telemetry"],"disable-workspace-trust":r.$Hl["disable-workspace-trust"],"file-watcher-polling":{type:"string",deprecates:["fileWatcherPolling"]},log:r.$Hl.log,logsPath:r.$Hl.logsPath,"force-disable-user-env":r.$Hl["force-disable-user-env"],folder:{type:"string",deprecationMessage:"No longer supported. Folder needs to be provided in the browser URL or with `default-folder`."},workspace:{type:"string",deprecationMessage:"No longer supported. Workspace needs to be provided in the browser URL or with `default-workspace`."},"default-folder":{type:"string",description:y.localize(9,null)},"default-workspace":{type:"string",description:y.localize(10,null)},"enable-sync":{type:"boolean"},"github-auth":{type:"string"},"use-test-resolver":{type:"boolean"},"extensions-dir":r.$Hl["extensions-dir"],"extensions-download-dir":r.$Hl["extensions-download-dir"],"builtin-extensions-dir":r.$Hl["builtin-extensions-dir"],"install-extension":r.$Hl["install-extension"],"install-builtin-extension":r.$Hl["install-builtin-extension"],"uninstall-extension":r.$Hl["uninstall-extension"],"list-extensions":r.$Hl["list-extensions"],"locate-extension":r.$Hl["locate-extension"],"show-versions":r.$Hl["show-versions"],category:r.$Hl.category,force:r.$Hl.force,"do-not-sync":r.$Hl["do-not-sync"],"pre-release":r.$Hl["pre-release"],"start-server":{type:"boolean",cat:"e",description:y.localize(11,null)},"enable-remote-auto-shutdown":{type:"boolean"},"remote-auto-shutdown-without-delay":{type:"boolean"},"use-host-proxy":{type:"boolean"},"without-browser-env-var":{type:"boolean"},help:r.$Hl.help,version:r.$Hl.version,"locate-shell-integration-path":r.$Hl["locate-shell-integration-path"],compatibility:{type:"string"},_:r.$Hl._},e.$pm=(0,L.$Rh)(I.$Xh);class p extends R.$lm{get userRoamingDataHome(){return this.appSettingsHome}get args(){return super.args}}e.$qm=p,Re([C.$ih],p.prototype,"userRoamingDataHome",null)}),define(be[263],we([1,0,302,246,264,27]),function(ue,e,y,R,r,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BN=void 0;class I extends y.AppInsightsCore{constructor(p){super(),this.a=p}track(p){const w=p.baseData||{};w.properties||(w.properties={}),w.measurements||(w.measurements={});try{const A=L.cpus();w.measurements.cores=A.length,w.properties["common.cpuModel"]=A[0].model}catch{}try{w.measurements.memoryFree=L.freemem(),w.measurements.memoryTotal=L.totalmem()}catch{}try{w.properties["common.shell"]=L.userInfo().shell,w.properties["common.release"]=L.release(),w.properties["common.arch"]=L.arch()}catch{}try{const A=(/^http:/.test(this.a)?r:R).request(this.a,{method:"POST",headers:{"Content-Type":"application/json"}});A.on("error",()=>{}),A.write(JSON.stringify(w)),A.end()}catch{}}}e.$BN=I}),define(be[265],we([1,0,29,21,78,85,262,87,39,59,3,13,46,7,12,23,31,44,20,4,15,8,91,57]),function(ue,e,y,R,r,L,I,C,p,w,A,k,v,u,b,m,d,h,g,l,$,c,n,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7N=e.$6N=e.$5N=e.$4N=e.$3N=e.$2N=e.CacheControl=e.$1N=void 0;const o={".html":"text/html",".js":"text/javascript",".json":"application/json",".css":"text/css",".svg":"image/svg+xml"};async function s(ee,se,G,ne){se.writeHead(G,{"Content-Type":"text/plain"}),se.end(ne)}e.$1N=s;var t;(function(ee){ee[ee.NO_CACHING=0]="NO_CACHING",ee[ee.ETAG=1]="ETAG",ee[ee.NO_EXPIRY=2]="NO_EXPIRY"})(t||(e.CacheControl=t={}));async function a(ee,se,G,ne,he,Z){try{const fe=await R.Promises.stat(ee);if(se===1){const V=`W/"${[fe.ino,fe.size,fe.mtime.getTime()].join("-")}"`;if(ne.headers["if-none-match"]===V)return he.writeHead(304),void he.end();Z.Etag=V}else se===2?Z["Cache-Control"]="public, max-age=31536000":se===0&&(Z["Cache-Control"]="no-store");Z["Content-Type"]=o[(0,u.$oc)(ee)]||(0,w.$Wr)(ee)||"text/plain",he.writeHead(200,Z),(0,y.createReadStream)(ee).pipe(he)}catch(fe){return fe.code!=="ENOENT"?(G.error(fe),console.error(fe.toString())):console.error(`File not found: ${ee}`),he.writeHead(404,{"Content-Type":"text/plain"}),void he.end("Not found")}}e.$2N=a;const f=(0,u.$mc)(b.$dg.asFileUri("").fsPath);let S=class{constructor(se,G,ne,he,Z){this.f=se,this.g=G,this.h=ne,this.i=he,this.j=Z,this.a=this.j.extensionsGallery?.resourceUrlTemplate?l.URI.parse(this.j.extensionsGallery.resourceUrlTemplate):void 0;const fe=(0,i.$Xk)(Z);this.b=`${fe}/static`,this.c=`${fe}/callback`,this.d="/web-extension-resource"}async handle(se,G,ne){try{const he=ne.pathname;return he.startsWith(this.b)&&he.charCodeAt(this.b.length)===47?this.k(se,G,ne):he==="/"?this.n(se,G,ne):he===this.c?this.p(G):he.startsWith(this.d)&&he.charCodeAt(this.d.length)===47?this.m(se,G,ne):s(se,G,404,"Not found.")}catch(he){return this.h.error(he),console.error(he.toString()),s(se,G,500,"Internal Server Error.")}}async k(se,G,ne){const he=Object.create(null),fe=decodeURIComponent(ne.pathname).substring(this.b.length+1),V=(0,u.$jc)(f,fe);return(0,p.$Yf)(V,f,!A.$f)?a(V,this.g.isBuilt?2:1,this.h,se,G,he):s(se,G,400,"Bad request.")}l(se){const G=se.authority.indexOf(".");return G!==-1?se.authority.substring(G+1):void 0}async m(se,G,ne){if(!this.a)return s(se,G,500,"No extension gallery service configured.");const he=decodeURIComponent(ne.pathname),Z=(0,u.$hc)(he.substring(this.d.length+1)),fe=l.URI.parse(Z).with({scheme:this.a.scheme,authority:Z.substring(0,Z.indexOf("/")),path:Z.substring(Z.indexOf("/")+1)});if(this.l(this.a)!==this.l(fe))return s(se,G,403,"Request Forbidden");const V={},ie=_=>{const q=se.headers[_];q&&((0,c.$zf)(q)||q[0])?V[_]=(0,c.$zf)(q)?q:q[0]:_!==_.toLowerCase()&&ie(_.toLowerCase())};ie("X-Client-Name"),ie("X-Client-Version"),ie("X-Machine-Id"),ie("X-Client-Commit");const Y=await this.i.request({type:"GET",url:fe.toString(!0),headers:V},g.CancellationToken.None),J=Y.res.statusCode||500;if(J!==200){let _=null;try{_=await(0,h.$3o)(Y)}catch{}return s(se,G,J,_||`Request failed with status ${J}`)}const re=Object.create(null),ce=_=>{const q=Y.res.headers[_];q?re[_]=q:_!==_.toLowerCase()&&ce(_.toLowerCase())};ce("Cache-Control"),ce("Content-Type"),G.writeHead(200,re);const oe=await(0,$.$oe)(Y.stream);return void G.end(oe.buffer)}async n(se,G,ne){const he=ne.query[b.$9f];if(typeof he=="string"){const te=Object.create(null);te["Set-Cookie"]=I.serialize(b.$8f,he,{sameSite:"lax",maxAge:60*60*24*7});const H=Object.create(null);for(const W in ne.query)W!==b.$9f&&(H[W]=ne.query[W]);const x=L.format({pathname:"/",query:H});return te.Location=x,G.writeHead(302,te),void G.end()}const Z=!this.g.isBuilt&&this.g.args["use-test-resolver"],fe=Z?"test+test":"remote";if(!fe)return s(se,G,400,"Bad request.");function V(te){return JSON.stringify(te).replace(/"/g,"&quot;")}let ie;this.g.args["enable-smoke-test-driver"]&&(ie=!1);const Y=te=>te&&l.URI.file(r.resolve(te)).with({scheme:b.Schemas.vscodeRemote,authority:fe}),J=b.$dg.asFileUri(this.g.isBuilt?"vs/code/browser/workbench/workbench.html":"vs/code/browser/workbench/workbench-dev.html").fsPath,re=!this.g.isBuilt&&this.g.args["github-auth"]?{id:(0,m.$fg)(),providerId:"github",accessToken:this.g.args["github-auth"],scopes:[["user:email"],["repo"]]}:void 0,ce=(0,e.$5N)((0,e.$7N)(se)),oe=(0,e.$6N)((0,e.$7N)(se)),_={codeServerVersion:this.j.codeServerVersion,rootEndpoint:ce,updateEndpoint:this.g.args["disable-update-check"]?void 0:ce+"/update/check",logoutEndpoint:this.g.args.auth&&this.g.args.auth!=="none"?ce+"/logout":void 0,proxyEndpointTemplate:process.env.VSCODE_PROXY_URI??ce+"/proxy/{{port}}/",serviceWorker:{scope:oe+"/",path:ce+"/_static/out/browser/serviceWorker.js"},enableTelemetry:this.j.enableTelemetry,embedderIdentifier:"server-distro",extensionsGallery:this.j.extensionsGallery};if(!this.g.isBuilt)try{const te=JSON.parse((await R.Promises.readFile((0,u.$jc)(f,"product.overrides.json"))).toString());Object.assign(_,te)}catch{}const q={remoteAuthority:fe,webviewEndpoint:oe+this.b+"/out/vs/workbench/contrib/webview/browser/pre",userDataPath:this.g.userDataPath,isEnabledFileDownloads:!this.g.args["disable-file-downloads"],isEnabledCoderGettingStarted:!this.g.args["disable-getting-started-override"],_wrapWebWorkerExtHostInIframe:ie,developmentOptions:{enableSmokeTestDriver:this.g.args["enable-smoke-test-driver"]?!0:void 0,logLevel:this.h.getLevel()},settingsSyncOptions:!this.g.isBuilt&&this.g.args["enable-sync"]?{enabled:!0}:void 0,enableWorkspaceTrust:!this.g.args["disable-workspace-trust"],folderUri:Y(this.g.args["default-folder"]),workspaceUri:Y(this.g.args["default-workspace"]),productConfiguration:_,callbackRoute:this.c},Q=this.g.args.locale||await(0,n.$pl)(this.g.argvResource.fsPath),O=await(0,n.$ol)(Q,this.g.userDataPath),N=this.j.extensionsGallery?.nlsBaseUrl,U={WORKBENCH_WEB_CONFIGURATION:V(q),WORKBENCH_AUTH_SESSION:re?V(re):"",WORKBENCH_WEB_BASE_URL:oe+this.b,WORKBENCH_NLS_BASE_URL:oe+(N?`${N}${N.endsWith("/")?"":"/"}${this.j.commit}/${this.j.version}/`:""),BASE:ce,VS_BASE:oe,NLS_CONFIGURATION:V(O)};if(Z){const te=[];for(const H of["vscode-test-resolver","github-authentication"]){const x=JSON.parse((await R.Promises.readFile(b.$dg.asFileUri(`${b.$$f}/${H}/package.json`).fsPath)).toString());te.push({extensionPath:H,packageJSON:x})}U.WORKBENCH_BUILTIN_EXTENSIONS=V(te)}let T;try{T=(await R.Promises.readFile(J)).toString().replace(/\{\{([^}]+)\}\}/g,(H,x)=>U[x]??"undefined")}catch{return G.writeHead(404,{"Content-Type":"text/plain"}),void G.end("Not found")}const B={"Content-Type":"text/html","Content-Security-Policy":["default-src 'self';","img-src 'self' https: data: blob:;","media-src 'self';",`script-src 'self' 'unsafe-eval' ${this.o(T).join(" ")} 'sha256-fh3TwPMflhsEIpR8g1OYTIMVWhXTLcjQ9kh2tIpmv54=' ;`,"child-src 'self';","frame-src 'self' https://*.vscode-cdn.net data:;","worker-src 'self' data: blob:;","style-src 'self' 'unsafe-inline';","connect-src 'self' ws: wss: https:;","font-src 'self' blob:;","manifest-src 'self';"].join(" ")};return this.f.type!==0&&(B["Set-Cookie"]=I.serialize(b.$8f,this.f.value,{sameSite:"lax",maxAge:60*60*24*7})),G.writeHead(200,B),void G.end(T)}o(se){const G=/<script>([\s\S]+?)<\/script>/img,ne=[];let he;for(;he=G.exec(se);){const Z=C.createHash("sha256"),fe=he[1].replace(/\r\n/g,`
`),V=Z.update(Buffer.from(fe)).digest().toString("base64");ne.push(`'sha256-${V}'`)}return ne}async p(se){const G=b.$dg.asFileUri("vs/code/browser/workbench/callback.html").fsPath,ne=(await R.Promises.readFile(G)).toString(),he=["default-src 'self';","img-src 'self' https: data: blob:;","media-src 'none';",`script-src 'self' ${this.o(ne).join(" ")};`,"style-src 'self' 'unsafe-inline';","font-src 'self' blob:;"].join(" ");return se.writeHead(200,{"Content-Type":"text/html","Content-Security-Policy":he}),void se.end(ne)}};e.$3N=S,e.$3N=S=Re([Ae(1,v.$pm),Ae(2,k.$$i),Ae(3,h.$Xo),Ae(4,d.$qj)],S);const D=(ee,se=!1)=>ee.replace(/\/\/+/g,"/").replace(/\/+$/,se?"/":"");e.$4N=D;const E=ee=>{const se=(ee.split("?",1)[0].match(/\//g)||[]).length;return(0,e.$4N)("./"+(se>1?"../".repeat(se-1):""))};e.$5N=E;const P=ee=>{const se=ee.split("?",1)[0].split("/");return(0,e.$4N)("./"+se[se.length-1])};e.$6N=P;const M=ee=>ee.originalUrl||ee.url;e.$7N=M}),define(be[266],we([1,0,6]),function(ue,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HM=void 0,e.$HM=(0,y.$Qh)("IExtHostInitDataService")}),define(be[267],we([1,0,6]),function(ue,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sM=e.$rM=void 0,e.$rM=(0,y.$Qh)("IExtHostRpcService");class R{constructor(L){this.getProxy=L.getProxy.bind(L),this.set=L.set.bind(L),this.dispose=L.dispose.bind(L),this.assertRegistered=L.assertRegistered.bind(L),this.drain=L.drain.bind(L)}}e.$sM=R}),define(be[70],we([1,0,51]),function(ue,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fr=void 0;function R(L){return{transformIncoming:I=>I.scheme==="vscode-remote"?{scheme:"file",path:I.path,query:I.query,fragment:I.fragment}:I.scheme==="file"?{scheme:"vscode-local",path:I.path,query:I.query,fragment:I.fragment}:I,transformOutgoing:I=>I.scheme==="file"?{scheme:"vscode-remote",authority:L,path:I.path,query:I.query,fragment:I.fragment}:I.scheme==="vscode-local"?{scheme:"file",path:I.path,query:I.query,fragment:I.fragment}:I,transformOutgoingScheme:I=>I==="file"?"vscode-remote":I==="vscode-local"?"file":I}}function r(L){return new y.$Nm(R(L))}e.$Fr=r}),define(be[268],we([1,0,3,41,4,70,51,104,239,7,19]),function(ue,e,y,R,r,L,I,C,p,w,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mr=void 0;class k{constructor(u,b,m,d){this.b=u,this.c=b,this.d=m,this.e=d}async call(u,b,m){switch(b){case"getEnvironmentData":{const d=m,h=(0,L.$Fr)(d.remoteAuthority);let g=await this.f(d.profile);return g=(0,I.$Pm)(g,h),g}case"getExtensionHostExitInfo":{const d=m;return this.e.getExitInfo(d.reconnectionToken)}case"getDiagnosticInfo":{const d=m,h={machineInfo:(0,p.$Jr)()},g=d.includeProcesses?(0,C.$Hr)(process.pid):Promise.resolve();let l=[];const $={};if(d.folders){const c=(0,L.$Fr)("");l=d.folders.map(i=>r.URI.revive(c.transformIncoming(i))).filter(i=>i.scheme==="file").map(i=>(0,p.$Ir)(i.fsPath,["node_modules",".git"]).then(o=>{$[(0,w.$nc)(i.fsPath)]=o}))}return Promise.all([g,...l]).then(([c,n])=>(h.processes=c||void 0,h.workspaceMetadata=d.folders?$:void 0,h))}}throw new Error(`IPC Command ${b} not found`)}listen(u,b,m){throw new Error("Not supported")}async f(u){return u&&!this.d.profiles.some(b=>b.id===u)&&await this.d.createProfile(u,u),{pid:process.pid,connectionToken:this.b.type!==0?this.b.value:"",appRoot:r.URI.file(this.c.appRoot),settingsPath:this.c.machineSettingsResource,logsPath:this.c.logsHome,extensionHostLogsPath:(0,A.$wg)(this.c.logsHome,`exthost${k.a++}`),globalStorageHome:this.d.defaultProfile.globalStorageHome,workspaceStorageHome:this.c.workspaceStorageHome,localHistoryHome:this.c.localHistoryHome,userHome:this.c.userHome,os:y.OS,arch:process.arch,marks:R.getMarks(),useHostProxy:!!this.c.args["use-host-proxy"],profiles:{home:this.d.profilesHome,all:[...this.d.profiles].map(b=>({...b}))}}}}e.$Mr=k,k.a=1}),define(be[269],we([1,0,4,70,68,7,224]),function(ue,e,y,R,r,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pr=void 0;class C extends I.$Nr{constructor(A,k){super(new r.$fq(A),A),this.N=k,this.M=new Map,this.B(this.a)}c(A){let k=this.M.get(A.remoteAuthority);return k||(k=(0,R.$Fr)(A.remoteAuthority),this.M.set(A.remoteAuthority,k)),k}f(A,k,v=!1){if(v&&k.path==="/vscode-resource"&&k.query){const u=JSON.parse(k.query).requestResourcePath;return y.URI.from({scheme:"file",path:u})}return y.URI.revive(A.transformIncoming(k))}L(A,k){return new p(A,k,this.b,this.N)}}e.$Pr=C;class p extends I.$Or{constructor(A,k,v,u){super(A,k,v,u)}j(A){const k=A.args["file-watcher-polling"];if(k){const v=k.split(L.$tc),u=Number(v[0]);if(u>0)return{usePolling:v.length>1?v.slice(1):!0,pollingInterval:u}}}m(A){if(A.extensionsPath)return[L.$gc.join(A.extensionsPath,"**")]}}}),define(be[92],we([1,0,202,8,4,2,6,37,16,12,40,163,63]),function(ue,e,y,R,r,L,I,C,p,w,A,k,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mE=e.$lE=e.$kE=e.EditorsOrder=e.$jE=e.CloseDirection=e.$iE=e.$hE=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$gE=e.$fE=e.$eE=e.$dE=e.$cE=e.$bE=e.$aE=e.$_D=e.EditorInputCapabilities=e.$$D=e.SaveReason=e.Verbosity=e.$0D=e.$9D=e.$8D=e.$7D=e.$6D=e.$5D=e.$4D=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$3D=e.$2D=e.$1D=e.$ZD=e.$YD=void 0,e.$YD={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$ZD={id:"default",displayName:(0,y.localize)(0,null),providerDisplayName:(0,y.localize)(1,null)},e.$1D="workbench.editor.sidebysideEditor",e.$2D="workbench.editors.textDiffEditor",e.$3D="workbench.editors.binaryResourceDiffEditor";var u;(function(_){_[_.PROGRAMMATIC=1]="PROGRAMMATIC",_[_.USER=2]="USER",_[_.EDIT=3]="EDIT",_[_.NAVIGATION=4]="NAVIGATION",_[_.JUMP=5]="JUMP"})(u||(e.EditorPaneSelectionChangeReason=u={}));var b;(function(_){_[_.IDENTICAL=1]="IDENTICAL",_[_.SIMILAR=2]="SIMILAR",_[_.DIFFERENT=3]="DIFFERENT"})(b||(e.EditorPaneSelectionCompareResult=b={}));function m(_){const q=_;return!!q&&typeof q.getSelection=="function"&&!!q.onDidChangeSelection}e.$4D=m;function d(_,q,Q){for(const O of Q.visibleEditorPanes)if(O.group.id===q&&_.matches(O.input))return O.getViewState()}e.$5D=d;function h(_){if(a(_))return!1;const q=_;return r.URI.isUri(q?.resource)}e.$6D=h;function g(_){if(a(_))return!1;const q=_;return q?.original!==void 0&&q.modified!==void 0}e.$7D=g;function l(_){if(a(_)||g(_))return!1;const q=_;return q?.primary!==void 0&&q.secondary!==void 0}e.$8D=l;function $(_){if(a(_))return!1;const q=_;return q?q.resource===void 0||q.resource.scheme===w.Schemas.untitled||q.forceUntitled===!0:!1}e.$9D=$;function c(_){if(a(_))return!1;const q=_;return r.URI.isUri(q?.base?.resource)&&r.URI.isUri(q?.input1?.resource)&&r.URI.isUri(q?.input2?.resource)&&r.URI.isUri(q?.result?.resource)}e.$0D=c;var n;(function(_){_[_.SHORT=0]="SHORT",_[_.MEDIUM=1]="MEDIUM",_[_.LONG=2]="LONG"})(n||(e.Verbosity=n={}));var i;(function(_){_[_.EXPLICIT=1]="EXPLICIT",_[_.AUTO=2]="AUTO",_[_.FOCUS_CHANGE=3]="FOCUS_CHANGE",_[_.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(i||(e.SaveReason=i={}));class o{constructor(){this.a=new Map}registerSource(q,Q){let O=this.a.get(q);return O||(O={source:q,label:Q},this.a.set(q,O)),O.source}getSourceLabel(q){return this.a.get(q)?.label??q}}e.$$D=new o;var s;(function(_){_[_.None=0]="None",_[_.Readonly=2]="Readonly",_[_.Untitled=4]="Untitled",_[_.Singleton=8]="Singleton",_[_.RequiresTrust=16]="RequiresTrust",_[_.CanSplitInGroup=32]="CanSplitInGroup",_[_.ForceDescription=64]="ForceDescription",_[_.CanDropIntoEditor=128]="CanDropIntoEditor",_[_.MultipleEditors=256]="MultipleEditors",_[_.Scratchpad=512]="Scratchpad",_[_.AuxWindowUnsupported=1024]="AuxWindowUnsupported"})(s||(e.EditorInputCapabilities=s={}));class t extends L.$Sc{}e.$_D=t;function a(_){return _ instanceof t}e.$aE=a;function f(_){const q=_;return r.URI.isUri(q?.preferredResource)}function S(_){const q=_;return a(q?.primary)&&a(q?.secondary)}e.$bE=S;function D(_){const q=_;return a(q?.modified)&&a(q?.original)}e.$cE=D;function E(_,q,Q,O,N){return oe(O,[(0,k.$Ai)({id:"workbench.action.openLargeFile",label:(0,y.localize)(2,null),run:()=>{const U={...Q,limits:{size:Number.MAX_VALUE}};_.openEditor(q,U)}}),(0,k.$Ai)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,y.localize)(3,null),run:()=>N.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:v.default.Warning})}e.$dE=E;function P(_){return a(_?.editor)}e.$eE=P;function M(_){const q=_;return P(_)&&q?.group!==void 0}e.$fE=M;function ee(_){const q=_;return typeof q?.groupId=="number"&&a(q.editor)}e.$gE=ee;var se;(function(_){_[_.UNKNOWN=0]="UNKNOWN",_[_.REPLACE=1]="REPLACE",_[_.MOVE=2]="MOVE",_[_.UNPIN=3]="UNPIN"})(se||(e.EditorCloseContext=se={}));var G;(function(_){_[_.GROUP_ACTIVE=0]="GROUP_ACTIVE",_[_.GROUP_INDEX=1]="GROUP_INDEX",_[_.GROUP_LABEL=2]="GROUP_LABEL",_[_.GROUP_LOCKED=3]="GROUP_LOCKED",_[_.EDITOR_OPEN=4]="EDITOR_OPEN",_[_.EDITOR_CLOSE=5]="EDITOR_CLOSE",_[_.EDITOR_MOVE=6]="EDITOR_MOVE",_[_.EDITOR_ACTIVE=7]="EDITOR_ACTIVE",_[_.EDITOR_LABEL=8]="EDITOR_LABEL",_[_.EDITOR_CAPABILITIES=9]="EDITOR_CAPABILITIES",_[_.EDITOR_PIN=10]="EDITOR_PIN",_[_.EDITOR_STICKY=11]="EDITOR_STICKY",_[_.EDITOR_DIRTY=12]="EDITOR_DIRTY",_[_.EDITOR_WILL_DISPOSE=13]="EDITOR_WILL_DISPOSE"})(G||(e.GroupModelChangeKind=G={}));var ne;(function(_){_[_.PRIMARY=1]="PRIMARY",_[_.SECONDARY=2]="SECONDARY",_[_.BOTH=3]="BOTH",_[_.ANY=4]="ANY"})(ne||(e.SideBySideEditor=ne={}));class he{getOriginalUri(q,Q){if(!q)return;if(c(q))return e.$iE.getOriginalUri(q.result,Q);if(Q?.supportSideBySide){const{primary:N,secondary:U}=this.a(q);if(N&&U){if(Q?.supportSideBySide===ne.BOTH)return{primary:this.getOriginalUri(N,{filterByScheme:Q.filterByScheme}),secondary:this.getOriginalUri(U,{filterByScheme:Q.filterByScheme})};if(Q?.supportSideBySide===ne.ANY)return this.getOriginalUri(N,{filterByScheme:Q.filterByScheme})??this.getOriginalUri(U,{filterByScheme:Q.filterByScheme});q=Q.supportSideBySide===ne.PRIMARY?N:U}}if(g(q)||l(q)||c(q))return;const O=f(q)?q.preferredResource:q.resource;return!O||!Q||!Q.filterByScheme?O:this.b(O,Q.filterByScheme)}a(q){return S(q)||l(q)?{primary:q.primary,secondary:q.secondary}:D(q)||g(q)?{primary:q.modified,secondary:q.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(q,Q){if(!q)return;if(c(q))return e.$iE.getCanonicalUri(q.result,Q);if(Q?.supportSideBySide){const{primary:N,secondary:U}=this.a(q);if(N&&U){if(Q?.supportSideBySide===ne.BOTH)return{primary:this.getCanonicalUri(N,{filterByScheme:Q.filterByScheme}),secondary:this.getCanonicalUri(U,{filterByScheme:Q.filterByScheme})};if(Q?.supportSideBySide===ne.ANY)return this.getCanonicalUri(N,{filterByScheme:Q.filterByScheme})??this.getCanonicalUri(U,{filterByScheme:Q.filterByScheme});q=Q.supportSideBySide===ne.PRIMARY?N:U}}if(g(q)||l(q)||c(q))return;const O=q.resource;return!O||!Q||!Q.filterByScheme?O:this.b(O,Q.filterByScheme)}b(q,Q){if(Array.isArray(Q)){if(Q.some(O=>q.scheme===O))return q}else if(Q===q.scheme)return q}}var Z;(function(_){_[_.UNKNOWN=0]="UNKNOWN",_[_.KEYBOARD=1]="KEYBOARD",_[_.MOUSE=2]="MOUSE"})(Z||(e.EditorCloseMethod=Z={}));function fe(_,q,Q,O){if(!_.isSticky(q))return!1;switch(O.preventPinnedEditorClose){case"keyboardAndMouse":return Q===Z.MOUSE||Q===Z.KEYBOARD;case"mouse":return Q===Z.MOUSE;case"keyboard":return Q===Z.KEYBOARD}return!1}e.$hE=fe,e.$iE=new he;var V;(function(_){_[_.LEFT=0]="LEFT",_[_.RIGHT=1]="RIGHT"})(V||(e.CloseDirection=V={}));class ie{constructor(){this.c=new Map,this.d=new Map}start(q){const Q=this.a=q.get(I.$Ph);for(const[O,N]of this.c)this.e(O,N,Q);this.c.clear()}e(q,Q,O){const N=O.createInstance(Q);this.d.set(q,N)}registerFileEditorFactory(q){if(this.b)throw new Error("Can only register one file editor factory.");this.b=q}getFileEditorFactory(){return(0,R.$Kf)(this.b)}registerEditorSerializer(q,Q){if(this.c.has(q)||this.d.has(q))throw new Error(`A editor serializer with type ID '${q}' was already registered.`);return this.a?this.e(q,Q,this.a):this.c.set(q,Q),(0,L.$Qc)(()=>{this.c.delete(q),this.d.delete(q)})}getEditorSerializer(q){return this.d.get(typeof q=="string"?q:q.typeId)}}C.$ln.add(e.$YD.EditorFactory,new ie);async function Y(_,q,Q){return!_||!_.length?[]:await Promise.all(_.map(async O=>{const N=r.URI.revive(O.fileUri);if(!N){Q.info("Cannot resolve the path because it is not valid.",O);return}if(!await q.canHandleResource(N)){Q.info("Cannot resolve the path because it cannot be handled",O);return}let T=O.exists,z=O.type;if(typeof T!="boolean"||typeof z!="number")try{z=(await q.stat(N)).isDirectory?p.FileType.Directory:p.FileType.Unknown,T=!0}catch(te){Q.error(te),T=!1}if(!T&&O.openOnlyIfExists){Q.info("Cannot resolve the path because it does not exist",O);return}if(z===p.FileType.Directory){Q.info("Cannot resolve the path because it is a directory",O);return}const B={...O.options,pinned:!0};return T?{resource:N,options:B}:{resource:N,options:B,forceUntitled:!0}}))}e.$jE=Y;var J;(function(_){_[_.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",_[_.SEQUENTIAL=1]="SEQUENTIAL"})(J||(e.EditorsOrder=J={}));function re(_){const q=_;if(!q)return!1;const Q=q;if(Q.modified)return re(Q.modified);const O=q;return!!(O.contributionsState&&O.viewState&&Array.isArray(O.cursorState))}e.$kE=re;function ce(_){return(0,A.$Ci)(_)}e.$lE=ce;function oe(_,q,Q){const O=(0,A.$Di)(_,q);return O.forceMessage=Q?.forceMessage,O.forceSeverity=Q?.forceSeverity,O.allowDialog=Q?.allowDialog,O}e.$mE=oe}),define(be[130],we([1,0,15,77,47,59,12,7,3,67]),function(ue,e,y,R,r,L,I,C,p,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BI=e.$AI=e.$zI=e.$yI=e.CellStatusbarAlignment=e.$xI=e.$wI=e.$vI=e.NotebookEditorPriority=e.$uI=e.$tI=e.$sI=e.$rI=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$qI=e.$pI=e.$oI=e.$nI=e.CellKind=e.$mI=e.$lI=e.$kI=void 0,e.$kI="workbench.editor.notebook",e.$lI="workbench.editor.notebookTextDiffEditor",e.$mI="workbench.editor.interactive";var A;(function(Z){Z[Z.Markup=1]="Markup",Z[Z.Code=2]="Code"})(A||(e.CellKind=A={})),e.$nI=["application/json","application/javascript","text/html","image/svg+xml",L.$Ur.latex,L.$Ur.markdown,"image/png","image/jpeg",L.$Ur.text],e.$oI=[L.$Ur.latex,L.$Ur.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",L.$Ur.text],e.$pI=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$qI="_notAvailable";var k;(function(Z){Z[Z.Running=1]="Running",Z[Z.Idle=2]="Idle"})(k||(e.NotebookRunState=k={}));var v;(function(Z){Z[Z.Unconfirmed=1]="Unconfirmed",Z[Z.Pending=2]="Pending",Z[Z.Executing=3]="Executing"})(v||(e.NotebookCellExecutionState=v={}));var u;(function(Z){Z[Z.Unconfirmed=1]="Unconfirmed",Z[Z.Pending=2]="Pending",Z[Z.Executing=3]="Executing"})(u||(e.NotebookExecutionState=u={}));var b;(function(Z){Z[Z.WithHardKernelDependency=0]="WithHardKernelDependency",Z[Z.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",Z[Z.Pure=2]="Pure",Z[Z.Never=3]="Never"})(b||(e.NotebookRendererMatch=b={}));var m;(function(Z){Z.Always="always",Z.Never="never",Z.Optional="optional"})(m||(e.RendererMessagingSpec=m={}));var d;(function(Z){Z[Z.ModelChange=1]="ModelChange",Z[Z.Move=2]="Move",Z[Z.ChangeCellLanguage=5]="ChangeCellLanguage",Z[Z.Initialize=6]="Initialize",Z[Z.ChangeCellMetadata=7]="ChangeCellMetadata",Z[Z.Output=8]="Output",Z[Z.OutputItem=9]="OutputItem",Z[Z.ChangeCellContent=10]="ChangeCellContent",Z[Z.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",Z[Z.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",Z[Z.ChangeCellMime=13]="ChangeCellMime",Z[Z.Unknown=100]="Unknown"})(d||(e.NotebookCellsChangeType=d={}));var h;(function(Z){Z[Z.Handle=0]="Handle",Z[Z.Index=1]="Index"})(h||(e.SelectionStateType=h={}));var g;(function(Z){Z[Z.Replace=1]="Replace",Z[Z.Output=2]="Output",Z[Z.Metadata=3]="Metadata",Z[Z.CellLanguage=4]="CellLanguage",Z[Z.DocumentMetadata=5]="DocumentMetadata",Z[Z.Move=6]="Move",Z[Z.OutputItems=7]="OutputItems",Z[Z.PartialMetadata=8]="PartialMetadata",Z[Z.PartialInternalMetadata=9]="PartialInternalMetadata"})(g||(e.CellEditType=g={}));var l;(function(Z){Z.scheme=I.Schemas.vscodeNotebookCell;const fe=["W","X","Y","Z","a","b","c","d","e","f"],V=new RegExp(`^[${fe.join("")}]+`),ie=7;function Y(q,Q){const O=Q.toString(ie),U=`${O.length<fe.length?fe[O.length-1]:"z"}${O}s${(0,y.$we)(y.$ce.fromString(q.scheme),!0,!0)}`;return q.with({scheme:Z.scheme,fragment:U})}Z.generate=Y;function J(q){if(q.scheme!==Z.scheme)return;const Q=q.fragment.indexOf("s");if(Q<0)return;const O=parseInt(q.fragment.substring(0,Q).replace(V,""),ie),N=(0,y.$ve)(q.fragment.substring(Q+1)).toString();if(!isNaN(O))return{handle:O,notebook:q.with({scheme:N,fragment:null})}}Z.parse=J;function re(q,Q){return q.with({scheme:I.Schemas.vscodeNotebookCellOutput,fragment:`op${Q??""},${q.scheme!==I.Schemas.file?q.scheme:""}`})}Z.generateCellOutputUri=re;function ce(q){if(q.scheme!==I.Schemas.vscodeNotebookCellOutput)return;const Q=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(q.fragment);if(!Q)return;const O=Q[1]&&Q[1]!==""?Q[1]:void 0,N=Q[2];return{outputId:O,notebook:q.with({scheme:N||I.Schemas.file,fragment:null})}}Z.parseCellOutputUri=ce;function oe(q,Q,O){return Z.generate(q,Q).with({scheme:O})}Z.generateCellPropertyUri=oe;function _(q,Q){if(q.scheme===Q)return Z.parse(q.with({scheme:Z.scheme}))}Z.parseCellPropertyUri=_})(l||(e.CellUri=l={}));const $=Z=>p.$d?Z.replace(/\//g,"\\"):Z;class c{constructor(fe=[],V=e.$nI){this.e=V,this.d=[...new Set(fe)].map(ie=>({pattern:ie,matches:R.$xj($(ie))}))}sort(fe){const V=new Map(r.Iterable.map(fe,Y=>[Y,$(Y)]));let ie=[];for(const{matches:Y}of this.d)for(const[J,re]of V)if(Y(re)){ie.push(J),V.delete(J);break}return V.size&&(ie=ie.concat([...V.keys()].sort((Y,J)=>this.e.indexOf(Y)-this.e.indexOf(J)))),ie}prioritize(fe,V){const ie=this.f(fe);if(ie===-1){this.d.unshift({pattern:fe,matches:R.$xj($(fe))});return}const Y=new Set(V.map(re=>this.f(re,ie)));Y.delete(-1);const J=Array.from(Y).sort();this.d.splice(ie+1,0,...J.map(re=>this.d[re]));for(let re=J.length-1;re>=0;re--)this.d.splice(J[re],1)}toArray(){return this.d.map(fe=>fe.pattern)}f(fe,V=this.d.length){const ie=$(fe);for(let Y=0;Y<V;Y++)if(this.d[Y].matches(ie))return Y;return-1}}e.$rI=c;function n(Z,fe,V,ie=(Y,J)=>Y===J){const Y=[];function J(oe,_,q){if(_===0&&q.length===0)return;const Q=Y[Y.length-1];Q&&Q.start+Q.deleteCount===oe?(Q.deleteCount+=_,Q.toInsert.push(...q)):Y.push({start:oe,deleteCount:_,toInsert:q})}let re=0,ce=0;for(;;){if(re===Z.length){J(re,0,fe.slice(ce));break}if(ce===fe.length){J(re,Z.length-re,[]);break}const oe=Z[re],_=fe[ce];if(ie(oe,_)){re+=1,ce+=1;continue}V(_)?(J(re,1,[]),re+=1):(J(re,0,[_]),ce+=1)}return Y}e.$sI=n,e.$tI=new w.$8i("notebookEditorCursorAtBoundary","none"),e.$uI=new w.$8i("notebookEditorCursorAtLineBoundary","none");var i;(function(Z){Z.default="default",Z.option="option"})(i||(e.NotebookEditorPriority=i={}));function o(Z){const fe=Z;return!!((typeof fe.include=="string"||R.$yj(fe.include))&&(typeof fe.exclude=="string"||R.$yj(fe.exclude)))}e.$vI=o;function s(Z,fe,V){if(Array.isArray(Z.viewType)&&Z.viewType.indexOf(fe)>=0||Z.viewType===fe)return!0;if(Z.filenamePattern){const ie=o(Z.filenamePattern)?Z.filenamePattern.include:Z.filenamePattern,Y=o(Z.filenamePattern)?Z.filenamePattern.exclude:void 0;if(R.$wj(ie,(0,C.$nc)(V.fsPath).toLowerCase()))return!(Y&&R.$wj(Y,(0,C.$nc)(V.fsPath).toLowerCase()))}return!1}e.$wI=s,e.$xI={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScroll:"notebook.stickyScroll.enabled",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",formatOnSave:"notebook.formatOnSave.enabled",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",anchorToFocusedCell:"notebook.scrolling.experimental.anchorToFocusedCell"};var t;(function(Z){Z[Z.Left=1]="Left",Z[Z.Right=2]="Right"})(t||(e.CellStatusbarAlignment=t={}));class a{static create(fe){return`${a.d}${fe}`}static parse(fe){if(fe.startsWith(a.d))return fe.substring(a.d.length)}}e.$yI=a,a.d="notebook/";function f(Z){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(Z)}e.$zI=f;const S=new TextDecoder;function D(Z){const fe=[];let V=!1;for(const re of Z)(fe.length===0||V)&&(fe.push(re),V=!0);let ie=M(fe);const Y=y.$ce.concat(fe.map(re=>y.$ce.wrap(re))),J=he(Y);return ie=ie||J.byteLength!==Y.byteLength,{data:J,didCompression:ie}}e.$AI=D,e.$BI=`${String.fromCharCode(27)}[A`;const E=e.$BI.split("").map(Z=>Z.charCodeAt(0)),P=10;function M(Z){let fe=!1;return Z.forEach((V,ie)=>{if(ie===0||V.length<e.$BI.length)return;const Y=Z[ie-1],J=V.subarray(0,e.$BI.length);if(J[0]===E[0]&&J[1]===E[1]&&J[2]===E[2]){const re=Y.lastIndexOf(P);if(re===-1)return;fe=!0,Z[ie-1]=Y.subarray(0,re),Z[ie]=V.subarray(e.$BI.length)}}),fe}function ee(Z){let fe=Z;do Z=fe,fe=Z.replace(/[^\n]\x08/gm,"");while(fe.length<Z.length);return Z}function se(Z){for(Z=Z.replace(/\r+\n/gm,`
`);Z.search(/\r[^$]/g)>-1;){const fe=Z.match(/^(.*)\r+/m)[1];let V=Z.match(/\r+(.*)$/m)[1];V=V+fe.slice(V.length,fe.length),Z=Z.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,V)}return Z}const G="\b".charCodeAt(0),ne="\r".charCodeAt(0);function he(Z){return!Z.buffer.includes(G)&&!Z.buffer.includes(ne)?Z:y.$ce.fromString(se(ee(S.decode(Z.buffer))))}});var Ot=this&&this.__classPrivateFieldSet||function(ue,e,y,R,r){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!r)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ue!==e||!r:!e.has(ue))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?r.call(ue,y):r?r.value=y:e.set(ue,y),y},nt=this&&this.__classPrivateFieldGet||function(ue,e,y,R){if(y==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ue!==e||!R:!e.has(ue))throw new TypeError("Cannot read private member from an object whose class did not declare it");return y==="m"?R:y==="a"?R.call(ue):R?R.value:e.get(ue)};define(be[131],we([1,0,18,11,100,26,59,17,8,4,23,35,16,118,130]),function(ue,e,y,R,r,L,I,C,p,w,A,k,v,u,b){"use strict";var m,d,h,g,l,$,c,n,i,o,s,t,a,f,S,D,E,P,M,ee,se,G,ne,he,Z,fe;Object.defineProperty(e,"__esModule",{value:!0}),e.SpeechToTextStatus=e.RelatedInformationType=e.ChatAgentResultFeedbackKind=e.$gM=e.ChatVariableLevel=e.ChatMessageRole=e.InteractiveEditorResponseFeedbackKind=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.$fM=e.$eM=e.$dM=e.$cM=e.$bM=e.$aM=e.$_L=e.$$L=e.$0L=e.$9L=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$8L=e.$7L=e.$6L=e.$5L=e.$4L=e.$3L=e.$2L=e.$1L=e.TestRunProfileKind=e.TestResultState=e.$ZL=e.$YL=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$XL=e.$WL=e.$VL=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$UL=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$TL=e.$SL=e.$RL=e.$QL=e.$PL=e.ColorThemeKind=e.$OL=e.$NL=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$ML=e.DebugConsoleMode=e.$LL=e.$KL=e.$JL=e.$IL=e.$HL=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$GL=e.$FL=e.FileChangeType=e.$EL=e.$DL=e.$CL=e.$BL=e.InlineCompletionTriggerKind=e.$AL=e.$zL=e.$yL=e.$xL=e.$wL=e.$vL=e.$uL=e.$tL=e.$sL=e.$rL=e.$qL=e.$pL=e.$oL=e.ConfigurationTarget=e.$nL=e.$mL=e.$lL=e.$kL=e.$jL=e.$iL=e.$hL=e.$gL=e.$fL=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$eL=e.ViewBadge=e.ProgressLocation=e.$dL=e.$cL=e.TaskScope=e.ShellQuoting=e.$bL=e.$aL=e.$_K=e.TaskPanelKind=e.TaskRevealKind=e.$$K=e.TerminalLocation=e.$0K=e.$9K=e.$8K=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$7K=e.$6K=e.$5K=e.$4K=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.$3K=e.StatusBarAlignment=e.ViewColumn=e.$2K=e.$1K=e.$ZK=e.$YK=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$XK=e.$WK=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$VK=e.$UK=e.$TK=e.$SK=e.$RK=e.LanguageStatusSeverity=e.$QK=e.$PK=e.$OK=e.$NK=e.$MK=e.$LK=e.CodeActionTriggerKind=e.$KK=e.$JK=e.SymbolTag=e.SymbolKind=e.$IK=e.DocumentHighlightKind=e.$HK=e.$GK=e.$FK=e.$EK=e.DiagnosticSeverity=e.DiagnosticTag=e.$DK=e.$CK=e.FileEditType=e.$BK=e.$AK=e.$zK=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$yK=e.$xK=e.$wK=e.$vK=e.$uK=e.$tK=e.$sK=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function V(j){return Object.assign(j,{apply:function(...le){if(le.length===0)return Reflect.construct(j,[]);{const pe=le.length===1?[]:le[1];return Reflect.construct(j,pe,le[0].constructor)}},call:function(...le){if(le.length===0)return Reflect.construct(j,[]);{const[pe,...Me]=le;return Reflect.construct(j,Me,pe.constructor)}}})}var ie;(function(j){j[j.Top=0]="Top",j[j.Bottom=1]="Bottom"})(ie||(e.TerminalOutputAnchor=ie={}));var Y;(function(j){j[j.TerminalCommand=0]="TerminalCommand",j[j.Opener=1]="Opener",j[j.Command=3]="Command"})(Y||(e.TerminalQuickFixType=Y={}));let J=i=class{static from(...F){let le=F;return new i(function(){if(le){for(const pe of le)pe&&typeof pe.dispose=="function"&&pe.dispose();le=void 0}})}constructor(F){m.set(this,void 0),Ot(this,m,F,"f")}dispose(){typeof nt(this,m,"f")=="function"&&(nt(this,m,"f").call(this),Ot(this,m,void 0,"f"))}};e.$sK=J,m=new WeakMap,e.$sK=J=i=Re([V],J);let re=o=class{static Min(...F){if(F.length===0)throw new TypeError;let le=F[0];for(let pe=1;pe<F.length;pe++){const Me=F[pe];Me.isBefore(le)&&(le=Me)}return le}static Max(...F){if(F.length===0)throw new TypeError;let le=F[0];for(let pe=1;pe<F.length;pe++){const Me=F[pe];Me.isAfter(le)&&(le=Me)}return le}static isPosition(F){if(!F)return!1;if(F instanceof o)return!0;const{line:le,character:pe}=F;return typeof le=="number"&&typeof pe=="number"}static of(F){if(F instanceof o)return F;if(this.isPosition(F))return new o(F.line,F.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(F,le){if(F<0)throw(0,R.$7)("line must be non-negative");if(le<0)throw(0,R.$7)("character must be non-negative");this.c=F,this.e=le}isBefore(F){return this.c<F.c?!0:F.c<this.c?!1:this.e<F.e}isBeforeOrEqual(F){return this.c<F.c?!0:F.c<this.c?!1:this.e<=F.e}isAfter(F){return!this.isBeforeOrEqual(F)}isAfterOrEqual(F){return!this.isBefore(F)}isEqual(F){return this.c===F.c&&this.e===F.e}compareTo(F){return this.c<F.c?-1:this.c>F.line?1:this.e<F.e?-1:this.e>F.e?1:0}translate(F,le=0){if(F===null||le===null)throw(0,R.$7)();let pe;return typeof F>"u"?pe=0:typeof F=="number"?pe=F:(pe=typeof F.lineDelta=="number"?F.lineDelta:0,le=typeof F.characterDelta=="number"?F.characterDelta:0),pe===0&&le===0?this:new o(this.line+pe,this.character+le)}with(F,le=this.character){if(F===null||le===null)throw(0,R.$7)();let pe;return typeof F>"u"?pe=this.line:typeof F=="number"?pe=F:(pe=typeof F.line=="number"?F.line:this.line,le=typeof F.character=="number"?F.character:this.character),pe===this.line&&le===this.character?this:new o(pe,le)}toJSON(){return{line:this.line,character:this.character}}};e.$tK=re,e.$tK=re=o=Re([V],re);let ce=s=class{static isRange(F){return F instanceof s?!0:F?re.isPosition(F.start)&&re.isPosition(F.end):!1}static of(F){if(F instanceof s)return F;if(this.isRange(F))return new s(F.start,F.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(F,le,pe,Me){let Ge,_e;if(typeof F=="number"&&typeof le=="number"&&typeof pe=="number"&&typeof Me=="number"?(Ge=new re(F,le),_e=new re(pe,Me)):re.isPosition(F)&&re.isPosition(le)&&(Ge=re.of(F),_e=re.of(le)),!Ge||!_e)throw new Error("Invalid arguments");Ge.isBefore(_e)?(this.c=Ge,this.e=_e):(this.c=_e,this.e=Ge)}contains(F){return s.isRange(F)?this.contains(F.start)&&this.contains(F.end):re.isPosition(F)?!(re.of(F).isBefore(this.c)||this.e.isBefore(F)):!1}isEqual(F){return this.c.isEqual(F.c)&&this.e.isEqual(F.e)}intersection(F){const le=re.Max(F.start,this.c),pe=re.Min(F.end,this.e);if(!le.isAfter(pe))return new s(le,pe)}union(F){if(this.contains(F))return this;if(F.contains(this))return F;const le=re.Min(F.start,this.c),pe=re.Max(F.end,this.end);return new s(le,pe)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(F,le=this.end){if(F===null||le===null)throw(0,R.$7)();let pe;return F?re.isPosition(F)?pe=F:(pe=F.start||this.start,le=F.end||this.end):pe=this.start,pe.isEqual(this.c)&&le.isEqual(this.end)?this:new s(pe,le)}toJSON(){return[this.start,this.end]}};e.$uK=ce,e.$uK=ce=s=Re([V],ce);let oe=t=class extends ce{static isSelection(F){return F instanceof t?!0:F?ce.isRange(F)&&re.isPosition(F.anchor)&&re.isPosition(F.active)&&typeof F.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(F,le,pe,Me){let Ge,_e;if(typeof F=="number"&&typeof le=="number"&&typeof pe=="number"&&typeof Me=="number"?(Ge=new re(F,le),_e=new re(pe,Me)):re.isPosition(F)&&re.isPosition(le)&&(Ge=re.of(F),_e=re.of(le)),!Ge||!_e)throw new Error("Invalid arguments");super(Ge,_e),this.f=Ge,this.g=_e}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$vK=oe,e.$vK=oe=t=Re([V],oe);const _=j=>{if(typeof j!="string"||j.length===0||!/^[0-9A-Za-z_\-]+$/.test(j))throw(0,R.$7)("connectionToken")};class q{static isResolvedAuthority(F){return F&&typeof F=="object"&&typeof F.host=="string"&&typeof F.port=="number"&&(F.connectionToken===void 0||typeof F.connectionToken=="string")}constructor(F,le,pe){if(typeof F!="string"||F.length===0)throw(0,R.$7)("host");if(typeof le!="number"||le===0||Math.round(le)!==le)throw(0,R.$7)("port");typeof pe<"u"&&_(pe),this.host=F,this.port=Math.round(le),this.connectionToken=pe}}e.$wK=q;class Q{static isManagedResolvedAuthority(F){return F&&typeof F=="object"&&typeof F.makeConnection=="function"&&(F.connectionToken===void 0||typeof F.connectionToken=="string")}constructor(F,le){this.makeConnection=F,this.connectionToken=le,typeof le<"u"&&_(le)}}e.$xK=Q;class O extends Error{static NotAvailable(F,le){return new O(F,u.RemoteAuthorityResolverErrorCode.NotAvailable,le)}static TemporarilyNotAvailable(F){return new O(F,u.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(F,le=u.RemoteAuthorityResolverErrorCode.Unknown,pe){super(F),this._message=F,this._code=le,this._detail=pe,Object.setPrototypeOf(this,O.prototype)}}e.$yK=O;var N;(function(j){j[j.LF=1]="LF",j[j.CRLF=2]="CRLF"})(N||(e.EndOfLine=N={}));var U;(function(j){j[j.Replace=1]="Replace",j[j.Append=2]="Append",j[j.Prepend=3]="Prepend"})(U||(e.EnvironmentVariableMutatorType=U={}));let T=a=class{static isTextEdit(F){return F instanceof a?!0:F?ce.isRange(F)&&typeof F.newText=="string":!1}static replace(F,le){return new a(F,le)}static insert(F,le){return a.replace(new ce(F,F),le)}static delete(F){return a.replace(F,"")}static setEndOfLine(F){const le=new a(new ce(new re(0,0),new re(0,0)),"");return le.newEol=F,le}get range(){return this.c}set range(F){if(F&&!ce.isRange(F))throw(0,R.$7)("range");this.c=F}get newText(){return this.e||""}set newText(F){if(F&&typeof F!="string")throw(0,R.$7)("newText");this.e=F}get newEol(){return this.f}set newEol(F){if(F&&typeof F!="number")throw(0,R.$7)("newEol");this.f=F}constructor(F,le){this.c=F,this.e=le}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$zK=T,e.$zK=T=a=Re([V],T);let z=f=class{static isNotebookCellEdit(F){return F instanceof f?!0:F?jt.isNotebookRange(F)&&Array.isArray(F.newCells):!1}static replaceCells(F,le){return new f(F,le)}static insertCells(F,le){return new f(new jt(F,F),le)}static deleteCells(F){return new f(F,[])}static updateCellMetadata(F,le){const pe=new f(new jt(F,F),[]);return pe.newCellMetadata=le,pe}static updateNotebookMetadata(F){const le=new f(new jt(0,0),[]);return le.newNotebookMetadata=F,le}constructor(F,le){this.range=F,this.newCells=le}};e.$AK=z,e.$AK=z=f=Re([V],z);class B{static isSnippetTextEdit(F){return F instanceof B?!0:F?ce.isRange(F.range)&&x.isSnippetString(F.snippet):!1}static replace(F,le){return new B(F,le)}static insert(F,le){return B.replace(new ce(F,F),le)}constructor(F,le){this.range=F,this.snippet=le}}e.$BK=B;var te;(function(j){j[j.File=1]="File",j[j.Text=2]="Text",j[j.Cell=3]="Cell",j[j.CellReplace=5]="CellReplace",j[j.Snippet=6]="Snippet"})(te||(e.FileEditType=te={}));let H=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(F,le,pe,Me){this.c.push({_type:1,from:F,to:le,options:pe,metadata:Me})}createFile(F,le,pe){this.c.push({_type:1,from:void 0,to:F,options:le,metadata:pe})}deleteFile(F,le,pe){this.c.push({_type:1,from:F,to:void 0,options:le,metadata:pe})}e(F,le,pe){this.c.push({_type:3,metadata:pe,uri:F,edit:{editType:5,metadata:le},notebookMetadata:le})}f(F,le,pe,Me){const Ge=le.start,_e=le.end;(Ge!==_e||pe.length>0)&&this.c.push({_type:5,uri:F,index:Ge,count:_e-Ge,cells:pe,metadata:Me})}g(F,le,pe,Me){this.c.push({_type:3,metadata:Me,uri:F,edit:{editType:3,index:le,metadata:pe}})}replace(F,le,pe,Me){this.c.push({_type:2,uri:F,edit:new T(le,pe),metadata:Me})}insert(F,le,pe,Me){this.replace(F,new ce(le,le),pe,Me)}delete(F,le,pe){this.replace(F,le,"",pe)}has(F){return this.c.some(le=>le._type===2&&le.uri.toString()===F.toString())}set(F,le){if(le)for(const pe of le){if(!pe)continue;let Me,Ge;Array.isArray(pe)?(Me=pe[0],Ge=pe[1]):Me=pe,z.isNotebookCellEdit(Me)?Me.newCellMetadata?this.g(F,Me.range.start,Me.newCellMetadata,Ge):Me.newNotebookMetadata?this.e(F,Me.newNotebookMetadata,Ge):this.f(F,Me.range,Me.newCells,Ge):B.isSnippetTextEdit(Me)?this.c.push({_type:6,uri:F,range:Me.range,edit:Me.snippet,metadata:Ge}):this.c.push({_type:2,uri:F,edit:Me,metadata:Ge})}else{for(let pe=0;pe<this.c.length;pe++){const Me=this.c[pe];switch(Me._type){case 2:case 6:case 3:case 5:Me.uri.toString()===F.toString()&&(this.c[pe]=void 0);break}}(0,y.$Ib)(this.c)}}get(F){const le=[];for(const pe of this.c)pe._type===2&&pe.uri.toString()===F.toString()&&le.push(pe.edit);return le}entries(){const F=new L.$Ac;for(const le of this.c)if(le._type===2){let pe=F.get(le.uri);pe||(pe=[le.uri,[]],F.set(le.uri,pe)),pe[1].push(le.edit)}return[...F.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$CK=H,e.$CK=H=Re([V],H);let x=S=class{static isSnippetString(F){return F instanceof S?!0:F?typeof F.value=="string":!1}static c(F){return F.replace(/\$|}|\\/g,"\\$&")}constructor(F){this.e=1,this.value=F||""}appendText(F){return this.value+=S.c(F),this}appendTabstop(F=this.e++){return this.value+="$",this.value+=F,this}appendPlaceholder(F,le=this.e++){if(typeof F=="function"){const pe=new S;pe.e=this.e,F(pe),this.e=pe.e,F=pe.value}else F=S.c(F);return this.value+="${",this.value+=le,this.value+=":",this.value+=F,this.value+="}",this}appendChoice(F,le=this.e++){const pe=F.map(Me=>Me.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=le,this.value+="|",this.value+=pe,this.value+="|}",this}appendVariable(F,le){if(typeof le=="function"){const pe=new S;pe.e=this.e,le(pe),this.e=pe.e,le=pe.value}else typeof le=="string"&&(le=le.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=F,le&&(this.value+=":",this.value+=le),this.value+="}",this}};e.$DK=x,e.$DK=x=S=Re([V],x);var W;(function(j){j[j.Unnecessary=1]="Unnecessary",j[j.Deprecated=2]="Deprecated"})(W||(e.DiagnosticTag=W={}));var X;(function(j){j[j.Hint=3]="Hint",j[j.Information=2]="Information",j[j.Warning=1]="Warning",j[j.Error=0]="Error"})(X||(e.DiagnosticSeverity=X={}));let ae=D=class{static isLocation(F){return F instanceof D?!0:F?ce.isRange(F.range)&&w.URI.isUri(F.uri):!1}constructor(F,le){if(this.uri=F,le)if(ce.isRange(le))this.range=ce.of(le);else if(re.isPosition(le))this.range=new ce(le,le);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$EK=ae,e.$EK=ae=D=Re([V],ae);let ge=class{static is(F){return F?typeof F.message=="string"&&F.location&&ce.isRange(F.location.range)&&w.URI.isUri(F.location.uri):!1}constructor(F,le){this.location=F,this.message=le}static isEqual(F,le){return F===le?!0:!F||!le?!1:F.message===le.message&&F.location.range.isEqual(le.location.range)&&F.location.uri.toString()===le.location.uri.toString()}};e.$FK=ge,e.$FK=ge=Re([V],ge);let Ee=class{constructor(F,le,pe=X.Error){if(!ce.isRange(F))throw new TypeError("range must be set");if(!le)throw new TypeError("message must be set");this.range=F,this.message=le,this.severity=pe}toJSON(){return{severity:X[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(F,le){return F===le?!0:!F||!le?!1:F.message===le.message&&F.severity===le.severity&&F.code===le.code&&F.severity===le.severity&&F.source===le.source&&F.range.isEqual(le.range)&&(0,y.$ub)(F.tags,le.tags)&&(0,y.$ub)(F.relatedInformation,le.relatedInformation,ge.isEqual)}};e.$GK=Ee,e.$GK=Ee=Re([V],Ee);let Ce=class{constructor(F,le){if(!F)throw new Error("Illegal argument, contents must be defined");Array.isArray(F)?this.contents=F:this.contents=[F],this.range=le}};e.$HK=Ce,e.$HK=Ce=Re([V],Ce);var Ne;(function(j){j[j.Text=0]="Text",j[j.Read=1]="Read",j[j.Write=2]="Write"})(Ne||(e.DocumentHighlightKind=Ne={}));let Fe=class{constructor(F,le=Ne.Text){this.range=F,this.kind=le}toJSON(){return{range:this.range,kind:Ne[this.kind]}}};e.$IK=Fe,e.$IK=Fe=Re([V],Fe);var $e;(function(j){j[j.File=0]="File",j[j.Module=1]="Module",j[j.Namespace=2]="Namespace",j[j.Package=3]="Package",j[j.Class=4]="Class",j[j.Method=5]="Method",j[j.Property=6]="Property",j[j.Field=7]="Field",j[j.Constructor=8]="Constructor",j[j.Enum=9]="Enum",j[j.Interface=10]="Interface",j[j.Function=11]="Function",j[j.Variable=12]="Variable",j[j.Constant=13]="Constant",j[j.String=14]="String",j[j.Number=15]="Number",j[j.Boolean=16]="Boolean",j[j.Array=17]="Array",j[j.Object=18]="Object",j[j.Key=19]="Key",j[j.Null=20]="Null",j[j.EnumMember=21]="EnumMember",j[j.Struct=22]="Struct",j[j.Event=23]="Event",j[j.Operator=24]="Operator",j[j.TypeParameter=25]="TypeParameter"})($e||(e.SymbolKind=$e={}));var ke;(function(j){j[j.Deprecated=1]="Deprecated"})(ke||(e.SymbolTag=ke={}));let ve=E=class{static validate(F){if(!F.name)throw new Error("name must not be falsy")}constructor(F,le,pe,Me,Ge){this.name=F,this.kind=le,this.containerName=Ge,typeof pe=="string"&&(this.containerName=pe),Me instanceof ae?this.location=Me:pe instanceof ce&&(this.location=new ae(Me,pe)),E.validate(this)}toJSON(){return{name:this.name,kind:$e[this.kind],location:this.location,containerName:this.containerName}}};e.$JK=ve,e.$JK=ve=E=Re([V],ve);let je=P=class{static validate(F){if(!F.name)throw new Error("name must not be falsy");if(!F.range.contains(F.selectionRange))throw new Error("selectionRange must be contained in fullRange");F.children?.forEach(P.validate)}constructor(F,le,pe,Me,Ge){this.name=F,this.detail=le,this.kind=pe,this.range=Me,this.selectionRange=Ge,this.children=[],P.validate(this)}};e.$KK=je,e.$KK=je=P=Re([V],je);var Be;(function(j){j[j.Invoke=1]="Invoke",j[j.Automatic=2]="Automatic"})(Be||(e.CodeActionTriggerKind=Be={}));let Ze=class{constructor(F,le){this.title=F,this.kind=le}};e.$LK=Ze,e.$LK=Ze=Re([V],Ze);let qe=M=class{constructor(F){this.value=F}append(F){return new M(this.value?this.value+M.c+F:F)}intersects(F){return this.contains(F)||F.contains(this)}contains(F){return this.value===F.value||F.value.startsWith(this.value+M.c)}};e.$MK=qe,qe.c=".",e.$MK=qe=M=Re([V],qe),qe.Empty=new qe(""),qe.QuickFix=qe.Empty.append("quickfix"),qe.Refactor=qe.Empty.append("refactor"),qe.RefactorExtract=qe.Refactor.append("extract"),qe.RefactorInline=qe.Refactor.append("inline"),qe.RefactorMove=qe.Refactor.append("move"),qe.RefactorRewrite=qe.Refactor.append("rewrite"),qe.Source=qe.Empty.append("source"),qe.SourceOrganizeImports=qe.Source.append("organizeImports"),qe.SourceFixAll=qe.Source.append("fixAll"),qe.Notebook=qe.Empty.append("notebook");let Qe=class{constructor(F,le){if(this.range=F,this.parent=le,le&&!le.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$NK=Qe,e.$NK=Qe=Re([V],Qe);class xe{constructor(F,le,pe,Me,Ge,_e){this.kind=F,this.name=le,this.detail=pe,this.uri=Me,this.range=Ge,this.selectionRange=_e}}e.$OK=xe;class Xe{constructor(F,le){this.fromRanges=le,this.from=F}}e.$PK=Xe;class me{constructor(F,le){this.fromRanges=le,this.to=F}}e.$QK=me;var Pe;(function(j){j[j.Information=0]="Information",j[j.Warning=1]="Warning",j[j.Error=2]="Error"})(Pe||(e.LanguageStatusSeverity=Pe={}));let Ie=class{constructor(F,le){this.range=F,this.command=le}get isResolved(){return!!this.command}};e.$RK=Ie,e.$RK=Ie=Re([V],Ie);let Oe=ee=class{static isMarkdownString(F){return F instanceof ee?!0:F&&F.appendCodeblock&&F.appendMarkdown&&F.appendText&&F.value!==void 0}constructor(F,le=!1){d.set(this,void 0),Ot(this,d,new r.$4j(F,{supportThemeIcons:le}),"f")}get value(){return nt(this,d,"f").value}set value(F){nt(this,d,"f").value=F}get isTrusted(){return nt(this,d,"f").isTrusted}set isTrusted(F){nt(this,d,"f").isTrusted=F}get supportThemeIcons(){return nt(this,d,"f").supportThemeIcons}set supportThemeIcons(F){nt(this,d,"f").supportThemeIcons=F}get supportHtml(){return nt(this,d,"f").supportHtml}set supportHtml(F){nt(this,d,"f").supportHtml=F}get baseUri(){return nt(this,d,"f").baseUri}set baseUri(F){nt(this,d,"f").baseUri=F}appendText(F){return nt(this,d,"f").appendText(F),this}appendMarkdown(F){return nt(this,d,"f").appendMarkdown(F),this}appendCodeblock(F,le){return nt(this,d,"f").appendCodeblock(le??"",F),this}};e.$SK=Oe,d=new WeakMap,e.$SK=Oe=ee=Re([V],Oe);let Te=class{constructor(F,le){this.label=F,this.documentation=le}};e.$TK=Te,e.$TK=Te=Re([V],Te);let ze=class{constructor(F,le){this.label=F,this.documentation=le,this.parameters=[]}};e.$UK=ze,e.$UK=ze=Re([V],ze);let He=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$VK=He,e.$VK=He=Re([V],He);var Ke;(function(j){j[j.Invoke=1]="Invoke",j[j.TriggerCharacter=2]="TriggerCharacter",j[j.ContentChange=3]="ContentChange"})(Ke||(e.SignatureHelpTriggerKind=Ke={}));var Je;(function(j){j[j.Type=1]="Type",j[j.Parameter=2]="Parameter"})(Je||(e.InlayHintKind=Je={}));let We=class{constructor(F){this.value=F}};e.$WK=We,e.$WK=We=Re([V],We);let it=class{constructor(F,le,pe){this.position=F,this.label=le,this.kind=pe}};e.$XK=it,e.$XK=it=Re([V],it);var rt;(function(j){j[j.Invoke=0]="Invoke",j[j.TriggerCharacter=1]="TriggerCharacter",j[j.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(rt||(e.CompletionTriggerKind=rt={}));var et;(function(j){j[j.Text=0]="Text",j[j.Method=1]="Method",j[j.Function=2]="Function",j[j.Constructor=3]="Constructor",j[j.Field=4]="Field",j[j.Variable=5]="Variable",j[j.Class=6]="Class",j[j.Interface=7]="Interface",j[j.Module=8]="Module",j[j.Property=9]="Property",j[j.Unit=10]="Unit",j[j.Value=11]="Value",j[j.Enum=12]="Enum",j[j.Keyword=13]="Keyword",j[j.Snippet=14]="Snippet",j[j.Color=15]="Color",j[j.File=16]="File",j[j.Reference=17]="Reference",j[j.Folder=18]="Folder",j[j.EnumMember=19]="EnumMember",j[j.Constant=20]="Constant",j[j.Struct=21]="Struct",j[j.Event=22]="Event",j[j.Operator=23]="Operator",j[j.TypeParameter=24]="TypeParameter",j[j.User=25]="User",j[j.Issue=26]="Issue"})(et||(e.CompletionItemKind=et={}));var mt;(function(j){j[j.Deprecated=1]="Deprecated"})(mt||(e.CompletionItemTag=mt={}));let ut=class{constructor(F,le){this.label=F,this.kind=le}toJSON(){return{label:this.label,kind:this.kind&&et[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$YK=ut,e.$YK=ut=Re([V],ut);let Pt=class{constructor(F=[],le=!1){this.items=F,this.isIncomplete=le}};e.$ZK=Pt,e.$ZK=Pt=Re([V],Pt);let gt=class{constructor(F,le,pe){this.insertText=F,this.range=le,this.command=pe}};e.$1K=gt,e.$1K=gt=Re([V],gt);let wt=class{constructor(F){this.commands=void 0,this.suppressSuggestions=void 0,this.items=F}};e.$2K=wt,e.$2K=wt=Re([V],wt);var Mt;(function(j){j[j.Active=-1]="Active",j[j.Beside=-2]="Beside",j[j.One=1]="One",j[j.Two=2]="Two",j[j.Three=3]="Three",j[j.Four=4]="Four",j[j.Five=5]="Five",j[j.Six=6]="Six",j[j.Seven=7]="Seven",j[j.Eight=8]="Eight",j[j.Nine=9]="Nine"})(Mt||(e.ViewColumn=Mt={}));var Tt;(function(j){j[j.Left=1]="Left",j[j.Right=2]="Right"})(Tt||(e.StatusBarAlignment=Tt={}));function Nt(j,F){return`${k.$8l.toKey(j)}.${F}`}e.$3K=Nt;var $t;(function(j){j[j.Off=0]="Off",j[j.On=1]="On",j[j.Relative=2]="Relative"})($t||(e.TextEditorLineNumbersStyle=$t={}));var pt;(function(j){j[j.Manual=1]="Manual",j[j.AfterDelay=2]="AfterDelay",j[j.FocusOut=3]="FocusOut"})(pt||(e.TextDocumentSaveReason=pt={}));var Ft;(function(j){j[j.Default=0]="Default",j[j.InCenter=1]="InCenter",j[j.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",j[j.AtTop=3]="AtTop"})(Ft||(e.TextEditorRevealType=Ft={}));var Ct;(function(j){j[j.Keyboard=1]="Keyboard",j[j.Mouse=2]="Mouse",j[j.Command=3]="Command"})(Ct||(e.TextEditorSelectionChangeKind=Ct={}));var vt;(function(j){j[j.Undo=1]="Undo",j[j.Redo=2]="Redo"})(vt||(e.TextDocumentChangeReason=vt={}));var Ut;(function(j){j[j.OpenOpen=0]="OpenOpen",j[j.ClosedClosed=1]="ClosedClosed",j[j.OpenClosed=2]="OpenClosed",j[j.ClosedOpen=3]="ClosedOpen"})(Ut||(e.DecorationRangeBehavior=Ut={})),function(j){function F(le){switch(le){case"keyboard":return j.Keyboard;case"mouse":return j.Mouse;case"api":return j.Command}}j.fromValue=F}(Ct||(e.TextEditorSelectionChangeKind=Ct={}));var Dt;(function(j){j[j.Other=0]="Other",j[j.Comment=1]="Comment",j[j.String=2]="String",j[j.RegEx=3]="RegEx"})(Dt||(e.SyntaxTokenType=Dt={})),function(j){function F(le){switch(le){case j.Other:return"other";case j.Comment:return"comment";case j.String:return"string";case j.RegEx:return"regex"}return"other"}j.toString=F}(Dt||(e.SyntaxTokenType=Dt={}));let st=class{constructor(F,le){if(le&&!w.URI.isUri(le))throw(0,R.$7)("target");if(!ce.isRange(F)||F.isEmpty)throw(0,R.$7)("range");this.range=F,this.target=le}};e.$4K=st,e.$4K=st=Re([V],st);let bt=class{constructor(F,le,pe,Me){this.red=F,this.green=le,this.blue=pe,this.alpha=Me}};e.$5K=bt,e.$5K=bt=Re([V],bt);let ht=class{constructor(F,le){if(le&&!(le instanceof bt))throw(0,R.$7)("color");if(!ce.isRange(F)||F.isEmpty)throw(0,R.$7)("range");this.range=F,this.color=le}};e.$6K=ht,e.$6K=ht=Re([V],ht);let ft=class{constructor(F){if(!F||typeof F!="string")throw(0,R.$7)("label");this.label=F}};e.$7K=ft,e.$7K=ft=Re([V],ft);var Bt;(function(j){j[j.RGB=0]="RGB",j[j.HEX=1]="HEX",j[j.HSL=2]="HSL"})(Bt||(e.ColorFormat=Bt={}));var It;(function(j){j[j.Error=0]="Error",j[j.Warning=1]="Warning",j[j.Information=2]="Information"})(It||(e.SourceControlInputBoxValidationType=It={}));var zt;(function(j){j[j.Unknown=0]="Unknown",j[j.Shutdown=1]="Shutdown",j[j.Process=2]="Process",j[j.User=3]="User",j[j.Extension=4]="Extension"})(zt||(e.TerminalExitReason=zt={}));class At{constructor(F,le,pe){if(this.startIndex=F,this.length=le,this.tooltip=pe,typeof F!="number"||F<0)throw(0,R.$7)("startIndex");if(typeof le!="number"||le<1)throw(0,R.$7)("length");if(pe!==void 0&&typeof pe!="string")throw(0,R.$7)("tooltip")}}e.$8K=At;class Ht{constructor(F){this.uri=F}}e.$9K=Ht;class Vt{constructor(F){this.terminalCommand=F}}e.$0K=Vt;var qt;(function(j){j[j.Panel=1]="Panel",j[j.Editor=2]="Editor"})(qt||(e.TerminalLocation=qt={}));class ye{constructor(F){if(this.options=F,typeof F!="object")throw(0,R.$7)("options")}}e.$$K=ye;var De;(function(j){j[j.Always=1]="Always",j[j.Silent=2]="Silent",j[j.Never=3]="Never"})(De||(e.TaskRevealKind=De={}));var de;(function(j){j[j.Shared=1]="Shared",j[j.Dedicated=2]="Dedicated",j[j.New=3]="New"})(de||(e.TaskPanelKind=de={}));let K=se=class{static from(F){switch(F){case"clean":return se.Clean;case"build":return se.Build;case"rebuild":return se.Rebuild;case"test":return se.Test;default:return}}constructor(F,le){if(this.label=le,typeof F!="string"||typeof le!="string")throw(0,R.$7)("name");this.c=F}get id(){return this.c}};e.$_K=K,K.Clean=new se("clean","Clean"),K.Build=new se("build","Build"),K.Rebuild=new se("rebuild","Rebuild"),K.Test=new se("test","Test"),e.$_K=K=se=Re([V],K);function Se(j){let F="";for(let le=0;le<j.length;le++)F+=j[le].replace(/,/g,",,")+",";return F}let Le=class{constructor(F,le,pe){if(typeof F!="string")throw(0,R.$7)("process");this.e=[],this.c=F,le!==void 0&&(Array.isArray(le)?(this.e=le,this.f=pe):this.f=le)}get process(){return this.c}set process(F){if(typeof F!="string")throw(0,R.$7)("process");this.c=F}get args(){return this.e}set args(F){Array.isArray(F)||(F=[]),this.e=F}get options(){return this.f}set options(F){this.f=F}computeId(){const F=[];if(F.push("process"),this.c!==void 0&&F.push(this.c),this.e&&this.e.length>0)for(const le of this.e)F.push(le);return Se(F)}};e.$aL=Le,e.$aL=Le=Re([V],Le);let Ve=class{constructor(F,le,pe){if(this.f=[],Array.isArray(le)){if(!F)throw(0,R.$7)("command can't be undefined or null");if(typeof F!="string"&&typeof F.value!="string")throw(0,R.$7)("command");this.e=F,this.f=le,this.g=pe}else{if(typeof F!="string")throw(0,R.$7)("commandLine");this.c=F,this.g=le}}get commandLine(){return this.c}set commandLine(F){if(typeof F!="string")throw(0,R.$7)("commandLine");this.c=F}get command(){return this.e?this.e:""}set command(F){if(typeof F!="string"&&typeof F.value!="string")throw(0,R.$7)("command");this.e=F}get args(){return this.f}set args(F){this.f=F||[]}get options(){return this.g}set options(F){this.g=F}computeId(){const F=[];if(F.push("shell"),this.c!==void 0&&F.push(this.c),this.e!==void 0&&F.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const le of this.f)F.push(typeof le=="string"?le:le.value);return Se(F)}};e.$bL=Ve,e.$bL=Ve=Re([V],Ve);var Ue;(function(j){j[j.Escape=1]="Escape",j[j.Strong=2]="Strong",j[j.Weak=3]="Weak"})(Ue||(e.ShellQuoting=Ue={}));var Ye;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace"})(Ye||(e.TaskScope=Ye={}));class at{constructor(F){this.c=F}computeId(){return"customExecution"+(0,A.$fg)()}set callback(F){this.c=F}get callback(){return this.c}}e.$cL=at;let ct=G=class{constructor(F,le,pe,Me,Ge,_e){this.j=!1,this.k=this.definition=F;let tt;typeof le=="string"?(this.m=this.name=le,this.t=this.source=pe,this.execution=Me,tt=Ge,this.j=!0):le===Ye.Global||le===Ye.Workspace?(this.target=le,this.m=this.name=pe,this.t=this.source=Me,this.execution=Ge,tt=_e):(this.target=le,this.m=this.name=pe,this.t=this.source=Me,this.execution=Ge,tt=_e),typeof tt=="string"?(this.o=[tt],this.q=!0):Array.isArray(tt)?(this.o=tt,this.q=!0):(this.o=[],this.q=!1),this.r=!1,this.w=Object.create(null),this.x=Object.create(null)}get _id(){return this.h}set _id(F){this.h=F}get _deprecated(){return this.j}z(){this.h!==void 0&&(this.h=void 0,this.l=void 0,this.A())}A(){this.n instanceof Le?this.k={type:G.e,id:this.n.computeId()}:this.n instanceof Ve?this.k={type:G.f,id:this.n.computeId()}:this.n instanceof at?this.k={type:G.c,id:this.n.computeId()}:this.k={type:G.g,id:(0,A.$fg)()}}get definition(){return this.k}set definition(F){if(F==null)throw(0,R.$7)("Kind can't be undefined or null");this.z(),this.k=F}get scope(){return this.l}set target(F){this.z(),this.l=F}get name(){return this.m}set name(F){if(typeof F!="string")throw(0,R.$7)("name");this.z(),this.m=F}get execution(){return this.n}set execution(F){F===null&&(F=void 0),this.z(),this.n=F;const le=this.k.type;(G.g===le||G.e===le||G.f===le||G.c===le)&&this.A()}get problemMatchers(){return this.o}set problemMatchers(F){if(Array.isArray(F))this.z(),this.o=F,this.q=!0;else{this.z(),this.o=[],this.q=!1;return}}get hasDefinedMatchers(){return this.q}get isBackground(){return this.r}set isBackground(F){F!==!0&&F!==!1&&(F=!1),this.z(),this.r=F}get source(){return this.t}set source(F){if(typeof F!="string"||F.length===0)throw(0,R.$7)("source must be a string of length > 0");this.z(),this.t=F}get group(){return this.u}set group(F){F===null&&(F=void 0),this.z(),this.u=F}get detail(){return this.y}set detail(F){F===null&&(F=void 0),this.y=F}get presentationOptions(){return this.w}set presentationOptions(F){F==null&&(F=Object.create(null)),this.z(),this.w=F}get runOptions(){return this.x}set runOptions(F){F==null&&(F=Object.create(null)),this.z(),this.x=F}};e.$dL=ct,ct.c="customExecution",ct.e="process",ct.f="shell",ct.g="$empty",e.$dL=ct=G=Re([V],ct);var yt;(function(j){j[j.SourceControl=1]="SourceControl",j[j.Window=10]="Window",j[j.Notification=15]="Notification"})(yt||(e.ProgressLocation=yt={}));var ot;(function(j){function F(le){const pe=le;return(0,p.$Df)(pe.value)?pe.tooltip&&!(0,p.$zf)(pe.tooltip)?(console.log("INVALID view badge, invalid tooltip",pe.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",pe.value),!1)}j.isViewBadge=F})(ot||(e.ViewBadge=ot={}));let dt=ne=class{static isTreeItem(F,le){const pe=F;if(pe.checkboxState!==void 0){const Me=(0,p.$Df)(pe.checkboxState)?pe.checkboxState:(0,p.$Bf)(pe.checkboxState)&&(0,p.$Df)(pe.checkboxState.state)?pe.checkboxState.state:void 0,Ge=!(0,p.$Df)(pe.checkboxState)&&(0,p.$Bf)(pe.checkboxState)?pe.checkboxState.tooltip:void 0;if(Me===void 0||Me!==Xt.Checked&&Me!==Xt.Unchecked||Ge!==void 0&&!(0,p.$zf)(Ge))return console.log("INVALID tree item, invalid checkboxState",pe.checkboxState),!1}if(F instanceof ne)return!0;if(pe.label!==void 0&&!(0,p.$zf)(pe.label)&&!pe.label?.label)return console.log("INVALID tree item, invalid label",pe.label),!1;if(pe.id!==void 0&&!(0,p.$zf)(pe.id))return console.log("INVALID tree item, invalid id",pe.id),!1;if(pe.iconPath!==void 0&&!(0,p.$zf)(pe.iconPath)&&!w.URI.isUri(pe.iconPath)&&(!pe.iconPath||!(0,p.$zf)(pe.iconPath.id))){const Me=pe.iconPath;if(!Me||!(0,p.$zf)(Me.light)&&!w.URI.isUri(Me.light)&&!(0,p.$zf)(Me.dark)&&!w.URI.isUri(Me.dark))return console.log("INVALID tree item, invalid iconPath",pe.iconPath),!1}return pe.description!==void 0&&!(0,p.$zf)(pe.description)&&typeof pe.description!="boolean"?(console.log("INVALID tree item, invalid description",pe.description),!1):pe.resourceUri!==void 0&&!w.URI.isUri(pe.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",pe.resourceUri),!1):pe.tooltip!==void 0&&!(0,p.$zf)(pe.tooltip)&&!(pe.tooltip instanceof Oe)?(console.log("INVALID tree item, invalid tooltip",pe.tooltip),!1):pe.command!==void 0&&!pe.command.command?(console.log("INVALID tree item, invalid command",pe.command),!1):pe.collapsibleState!==void 0&&pe.collapsibleState<Kt.None&&pe.collapsibleState>Kt.Expanded?(console.log("INVALID tree item, invalid collapsibleState",pe.collapsibleState),!1):pe.contextValue!==void 0&&!(0,p.$zf)(pe.contextValue)?(console.log("INVALID tree item, invalid contextValue",pe.contextValue),!1):pe.accessibilityInformation!==void 0&&!pe.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",pe.accessibilityInformation),!1):!0}constructor(F,le=Kt.None){this.collapsibleState=le,w.URI.isUri(F)?this.resourceUri=F:this.label=F}};e.$eL=dt,e.$eL=dt=ne=Re([V],dt);var Kt;(function(j){j[j.None=0]="None",j[j.Collapsed=1]="Collapsed",j[j.Expanded=2]="Expanded"})(Kt||(e.TreeItemCollapsibleState=Kt={}));var Xt;(function(j){j[j.Unchecked=0]="Unchecked",j[j.Checked=1]="Checked"})(Xt||(e.TreeItemCheckboxState=Xt={}));let Yt=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(F){this.value=F}};e.$fL=Yt,e.$fL=Yt=Re([V],Yt);class Nn extends Yt{}e.$gL=Nn;class wi extends Nn{constructor(F){super(""),h.set(this,void 0),Ot(this,h,F,"f")}asFile(){return nt(this,h,"f")}}e.$hL=wi,h=new WeakMap;class pi{constructor(F,le,pe,Me){this.name=F,this.uri=le,this._itemId=pe,this.c=Me}data(){return this.c()}}e.$iL=pi;let en=class{constructor(F){g.add(this),l.set(this,new Map);for(const[le,pe]of F??[]){const Me=nt(this,l,"f").get(nt(this,g,"m",$).call(this,le));Me?Me.push(pe):nt(this,l,"f").set(nt(this,g,"m",$).call(this,le),[pe])}}get(F){return nt(this,l,"f").get(nt(this,g,"m",$).call(this,F))?.[0]}set(F,le){nt(this,l,"f").set(nt(this,g,"m",$).call(this,F),[le])}forEach(F,le){for(const[pe,Me]of nt(this,l,"f"))for(const Ge of Me)F.call(le,Ge,pe,this)}*[(l=new WeakMap,g=new WeakSet,Symbol.iterator)](){for(const[F,le]of nt(this,l,"f"))for(const pe of le)yield[F,pe]}};e.$jL=en,$=function(F){return F.toLowerCase()},e.$jL=en=Re([V],en);let tn=class{constructor(F){this.insertText=F}};e.$kL=tn,e.$kL=tn=Re([V],tn);let nn=class{constructor(F,le){this.label=le,this.insertText=F}};e.$lL=nn,e.$lL=nn=Re([V],nn);let Lt=class{constructor(F,le){this.id=F,this.color=le}static isThemeIcon(F){return typeof F.id!="string"?(console.log("INVALID ThemeIcon, invalid id",F.id),!1):!0}};e.$mL=Lt,e.$mL=Lt=Re([V],Lt),Lt.File=new Lt("file"),Lt.Folder=new Lt("folder");let sn=class{constructor(F){this.id=F}};e.$nL=sn,e.$nL=sn=Re([V],sn);var Fn;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace",j[j.WorkspaceFolder=3]="WorkspaceFolder"})(Fn||(e.ConfigurationTarget=Fn={}));let rn=class{get base(){return this.c}set base(F){this.c=F,this.e=w.URI.file(F)}get baseUri(){return this.e}set baseUri(F){this.e=F,this.c=F.fsPath}constructor(F,le){if(typeof F!="string"&&(!F||!w.URI.isUri(F)&&!w.URI.isUri(F.uri)))throw(0,R.$7)("base");if(typeof le!="string")throw(0,R.$7)("pattern");typeof F=="string"?this.baseUri=w.URI.file(F):w.URI.isUri(F)?this.baseUri=F:this.baseUri=F.uri,this.pattern=le}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$oL=rn,e.$oL=rn=Re([V],rn);const jn=new WeakMap;function vi(j,F){jn.set(j,F)}e.$pL=vi;let Wt=class{constructor(F,le,pe,Me){this.enabled=typeof F=="boolean"?F:!0,typeof le=="string"&&(this.condition=le),typeof pe=="string"&&(this.hitCondition=pe),typeof Me=="string"&&(this.logMessage=Me)}get id(){return this.c||(this.c=jn.get(this)??(0,A.$fg)()),this.c}};e.$qL=Wt,e.$qL=Wt=Re([V],Wt);let on=class extends Wt{constructor(F,le,pe,Me,Ge){if(super(le,pe,Me,Ge),F===null)throw(0,R.$7)("location");this.location=F}};e.$rL=on,e.$rL=on=Re([V],on);let an=class extends Wt{constructor(F,le,pe,Me,Ge){super(le,pe,Me,Ge),this.functionName=F}};e.$sL=an,e.$sL=an=Re([V],an);let cn=class extends Wt{constructor(F,le,pe,Me,Ge,_e,tt){if(super(Me,Ge,_e,tt),!le)throw(0,R.$7)("dataId");this.label=F,this.dataId=le,this.canPersist=pe}};e.$tL=cn,e.$tL=cn=Re([V],cn);let ln=class{constructor(F,le,pe){this.command=F,this.args=le||[],this.options=pe}};e.$uL=ln,e.$uL=ln=Re([V],ln);let un=class{constructor(F,le){this.port=F,this.host=le}};e.$vL=un,e.$vL=un=Re([V],un);let hn=class{constructor(F){this.path=F}};e.$wL=hn,e.$wL=hn=Re([V],hn);let fn=class{constructor(F){this.implementation=F}};e.$xL=fn,e.$xL=fn=Re([V],fn);let dn=class{constructor(F,le,pe){this.session=F,this.threadId=le,this.frameId=pe}};e.$yL=dn,e.$yL=dn=Re([V],dn);let mn=class{constructor(F,le){this.session=F,this.threadId=le}};e.$zL=mn,e.$zL=mn=Re([V],mn);let gn=class{constructor(F,le){this.range=F,this.expression=le}};e.$AL=gn,e.$AL=gn=Re([V],gn);var Mn;(function(j){j[j.Invoke=0]="Invoke",j[j.Automatic=1]="Automatic"})(Mn||(e.InlineCompletionTriggerKind=Mn={}));let $n=class{constructor(F,le){this.range=F,this.text=le}};e.$BL=$n,e.$BL=$n=Re([V],$n);let bn=class{constructor(F,le,pe=!0){this.range=F,this.variableName=le,this.caseSensitiveLookup=pe}};e.$CL=bn,e.$CL=bn=Re([V],bn);let wn=class{constructor(F,le){this.range=F,this.expression=le}};e.$DL=wn,e.$DL=wn=Re([V],wn);let pn=class{constructor(F,le){this.frameId=F,this.stoppedLocation=le}};e.$EL=pn,e.$EL=pn=Re([V],pn);var Tn;(function(j){j[j.Changed=1]="Changed",j[j.Created=2]="Created",j[j.Deleted=3]="Deleted"})(Tn||(e.FileChangeType=Tn={}));let vn=he=class extends Error{static FileExists(F){return new he(F,v.FileSystemProviderErrorCode.FileExists,he.FileExists)}static FileNotFound(F){return new he(F,v.FileSystemProviderErrorCode.FileNotFound,he.FileNotFound)}static FileNotADirectory(F){return new he(F,v.FileSystemProviderErrorCode.FileNotADirectory,he.FileNotADirectory)}static FileIsADirectory(F){return new he(F,v.FileSystemProviderErrorCode.FileIsADirectory,he.FileIsADirectory)}static NoPermissions(F){return new he(F,v.FileSystemProviderErrorCode.NoPermissions,he.NoPermissions)}static Unavailable(F){return new he(F,v.FileSystemProviderErrorCode.Unavailable,he.Unavailable)}constructor(F,le=v.FileSystemProviderErrorCode.Unknown,pe){super(w.URI.isUri(F)?F.toString(!0):F),this.code=pe?.name??"Unknown",(0,v.$ok)(this,le),Object.setPrototypeOf(this,he.prototype),typeof Error.captureStackTrace=="function"&&typeof pe=="function"&&Error.captureStackTrace(this,pe)}};e.$FL=vn,e.$FL=vn=he=Re([V],vn);let yn=class{constructor(F,le,pe){this.start=F,this.end=le,this.kind=pe}};e.$GL=yn,e.$GL=yn=Re([V],yn);var Un;(function(j){j[j.Comment=1]="Comment",j[j.Imports=2]="Imports",j[j.Region=3]="Region"})(Un||(e.FoldingRangeKind=Un={}));var Bn;(function(j){j[j.Collapsed=0]="Collapsed",j[j.Expanded=1]="Expanded"})(Bn||(e.CommentThreadCollapsibleState=Bn={}));var zn;(function(j){j[j.Editing=0]="Editing",j[j.Preview=1]="Preview"})(zn||(e.CommentMode=zn={}));var qn;(function(j){j[j.Published=0]="Published",j[j.Draft=1]="Draft"})(qn||(e.CommentState=qn={}));var Hn;(function(j){j[j.Unresolved=0]="Unresolved",j[j.Resolved=1]="Resolved"})(Hn||(e.CommentThreadState=Hn={}));class yi{constructor(F,le=[]){this.tokenTypes=F,this.tokenModifiers=le}}e.$HL=yi;function Ei(j){return typeof j>"u"||(0,p.$Af)(j)}class En{constructor(F){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.h=0,this.j=new Map,this.k=new Map,this.l=!1,F){this.l=!0;for(let le=0,pe=F.tokenTypes.length;le<pe;le++)this.j.set(F.tokenTypes[le],le);for(let le=0,pe=F.tokenModifiers.length;le<pe;le++)this.k.set(F.tokenModifiers[le],le)}}push(F,le,pe,Me,Ge){if(typeof F=="number"&&typeof le=="number"&&typeof pe=="number"&&typeof Me=="number"&&(typeof Ge=="number"||typeof Ge>"u"))return typeof Ge>"u"&&(Ge=0),this.n(F,le,pe,Me,Ge);if(ce.isRange(F)&&typeof le=="string"&&Ei(pe))return this.m(F,le,pe);throw(0,R.$7)()}m(F,le,pe){if(!this.l)throw new Error("Legend must be provided in constructor");if(F.start.line!==F.end.line)throw new Error("`range` cannot span multiple lines");if(!this.j.has(le))throw new Error("`tokenType` is not in the provided legend");const Me=F.start.line,Ge=F.start.character,_e=F.end.character-F.start.character,tt=this.j.get(le);let lt=0;if(pe)for(const Et of pe){if(!this.k.has(Et))throw new Error("`tokenModifier` is not in the provided legend");const kt=this.k.get(Et);lt|=1<<kt>>>0}this.n(Me,Ge,_e,tt,lt)}n(F,le,pe,Me,Ge){if(this.f&&(F<this.c||F===this.c&&le<this.e)){this.f=!1;const lt=this.g.length/5|0;let Et=0,kt=0;for(let St=0;St<lt;St++){let Rt=this.g[5*St],Jt=this.g[5*St+1];Rt===0?(Rt=Et,Jt+=kt):Rt+=Et,this.g[5*St]=Rt,this.g[5*St+1]=Jt,Et=Rt,kt=Jt}}let _e=F,tt=le;this.f&&this.h>0&&(_e-=this.c,_e===0&&(tt-=this.e)),this.g[this.h++]=_e,this.g[this.h++]=tt,this.g[this.h++]=pe,this.g[this.h++]=Me,this.g[this.h++]=Ge,this.c=F,this.e=le}static o(F){const le=[],pe=F.length/5|0;for(let tt=0;tt<pe;tt++)le[tt]=tt;le.sort((tt,lt)=>{const Et=F[5*tt],kt=F[5*lt];if(Et===kt){const St=F[5*tt+1],Rt=F[5*lt+1];return St-Rt}return Et-kt});const Me=new Uint32Array(F.length);let Ge=0,_e=0;for(let tt=0;tt<pe;tt++){const lt=5*le[tt],Et=F[lt+0],kt=F[lt+1],St=F[lt+2],Rt=F[lt+3],Jt=F[lt+4],bi=Et-Ge,Vi=bi===0?kt-_e:kt,Qt=5*tt;Me[Qt+0]=bi,Me[Qt+1]=Vi,Me[Qt+2]=St,Me[Qt+3]=Rt,Me[Qt+4]=Jt,Ge=Et,_e=kt}return Me}build(F){return this.f?new kn(new Uint32Array(this.g),F):new kn(En.o(this.g),F)}}e.$IL=En;class kn{constructor(F,le){this.resultId=le,this.data=F}}e.$JL=kn;class ki{constructor(F,le,pe){this.start=F,this.deleteCount=le,this.data=pe}}e.$KL=ki;class Di{constructor(F,le){this.resultId=le,this.edits=F}}e.$LL=Di;var Vn;(function(j){j[j.Separate=0]="Separate",j[j.MergeWithParent=1]="MergeWithParent"})(Vn||(e.DebugConsoleMode=Vn={}));let Zt=class{constructor(){}};e.$ML=Zt,Zt.Back={iconPath:new Lt("arrow-left")},e.$ML=Zt=Re([V],Zt);var Wn;(function(j){j[j.Separator=-1]="Separator",j[j.Default=0]="Default"})(Wn||(e.QuickPickItemKind=Wn={}));var Gn;(function(j){j[j.Info=1]="Info",j[j.Warning=2]="Warning",j[j.Error=3]="Error"})(Gn||(e.InputBoxValidationSeverity=Gn={}));var Kn;(function(j){j[j.UI=1]="UI",j[j.Workspace=2]="Workspace"})(Kn||(e.ExtensionKind=Kn={}));class Si{static validate(F){if(typeof F.badge=="string"){let le=(0,C.$af)(F.badge,0);if(le<F.badge.length&&(le+=(0,C.$af)(F.badge,le)),F.badge.length>le)throw new Error("The 'badge'-property must be undefined or a short character")}else if(F.badge&&!Lt.isThemeIcon(F.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!F.color&&!F.badge&&!F.tooltip)throw new Error("The decoration is empty");return!0}constructor(F,le,pe){this.badge=F,this.tooltip=le,this.color=pe}}e.$NL=Si;let Dn=class{constructor(F){this.kind=F}};e.$OL=Dn,e.$OL=Dn=Re([V],Dn);var Jn;(function(j){j[j.Light=1]="Light",j[j.Dark=2]="Dark",j[j.HighContrast=3]="HighContrast",j[j.HighContrastLight=4]="HighContrastLight"})(Jn||(e.ColorThemeKind=Jn={}));class jt{static isNotebookRange(F){return F instanceof jt?!0:F?typeof F.start=="number"&&typeof F.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(F,le){if(F<0)throw(0,R.$7)("start must be positive");if(le<0)throw(0,R.$7)("end must be positive");F<=le?(this.c=F,this.e=le):(this.c=le,this.e=F)}with(F){let le=this.c,pe=this.e;return F.start!==void 0&&(le=F.start),F.end!==void 0&&(pe=F.end),le===this.c&&pe===this.e?this:new jt(le,pe)}}e.$PL=jt;class xt{static validate(F){if(typeof F.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof F.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof F.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(F){return Array.isArray(F)&&F.every(le=>xt.isNotebookCellData(le))}static isNotebookCellData(F){return!0}constructor(F,le,pe,Me,Ge,_e,tt){this.kind=F,this.value=le,this.languageId=pe,this.mime=Me,this.outputs=Ge??[],this.metadata=_e,this.executionSummary=tt,xt.validate(this)}}e.$QL=xt;class Pi{constructor(F){this.cells=F}}e.$RL=Pi;class Qn{static isNotebookCellOutputItem(F){return F instanceof c?!0:F?typeof F.mime=="string"&&F.data instanceof Uint8Array:!1}static error(F){const le={name:F.name,message:F.message,stack:F.stack};return c.json(le,"application/vnd.code.notebook.error")}static stdout(F){return c.text(F,"application/vnd.code.notebook.stdout")}static stderr(F){return c.text(F,"application/vnd.code.notebook.stderr")}static bytes(F,le="application/octet-stream"){return new c(F,le)}static text(F,le=I.$Ur.text){const pe=nt(c,c,"f",n).encode(String(F));return new c(pe,le)}static json(F,le="text/x-json"){const pe=JSON.stringify(F,void 0,"	");return c.text(pe,le)}constructor(F,le){this.data=F,this.mime=le;const pe=(0,I.$Yr)(le,!0);if(!pe)throw new Error(`INVALID mime type: ${le}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=pe}}e.$SL=Qn,c=Qn,n={value:new TextEncoder};class _t{static isNotebookCellOutput(F){return F instanceof _t?!0:!F||typeof F!="object"?!1:typeof F.id=="string"&&Array.isArray(F.items)}static ensureUniqueMimeTypes(F,le=!1){const pe=new Set,Me=new Set;for(let Ge=0;Ge<F.length;Ge++){const _e=F[Ge],tt=(0,I.$Yr)(_e.mime);if(!pe.has(tt)||(0,b.$zI)(tt)){pe.add(tt);continue}Me.add(Ge),le&&console.warn(`DUPLICATED mime type '${_e.mime}' will be dropped`)}return Me.size===0?F:F.filter((Ge,_e)=>!Me.has(_e))}constructor(F,le,pe){this.items=_t.ensureUniqueMimeTypes(F,!0),typeof le=="string"?(this.id=le,this.metadata=pe):(this.id=(0,A.$fg)(),this.metadata=le??pe)}}e.$TL=_t;var Xn;(function(j){j[j.Markup=1]="Markup",j[j.Code=2]="Code"})(Xn||(e.NotebookCellKind=Xn={}));var Yn;(function(j){j[j.Idle=1]="Idle",j[j.Pending=2]="Pending",j[j.Executing=3]="Executing"})(Yn||(e.NotebookCellExecutionState=Yn={}));var Zn;(function(j){j[j.Left=1]="Left",j[j.Right=2]="Right"})(Zn||(e.NotebookCellStatusBarAlignment=Zn={}));var xn;(function(j){j[j.Default=0]="Default",j[j.InCenter=1]="InCenter",j[j.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",j[j.AtTop=3]="AtTop"})(xn||(e.NotebookEditorRevealType=xn={}));class Ci{constructor(F,le){this.text=F,this.alignment=le}}e.$UL=Ci;var _n;(function(j){j[j.Default=1]="Default",j[j.Preferred=2]="Preferred"})(_n||(e.NotebookControllerAffinity=_n={}));var ei;(function(j){j[j.Default=1]="Default",j[j.Preferred=2]="Preferred",j[j.Hidden=-1]="Hidden"})(ei||(e.NotebookControllerAffinity2=ei={}));class Ii{constructor(F,le=[]){this.uri=F,this.provides=(0,y.$3b)(le)}}e.$VL=Ii;class Ai{constructor(F){this.label=F}}e.$WL=Ai;let Sn=class{constructor(F,le){this.label=F,this.timestamp=le}};e.$XL=Sn,e.$XL=Sn=Re([V],Sn);var ti;(function(j){j[j.Production=1]="Production",j[j.Development=2]="Development",j[j.Test=3]="Test"})(ti||(e.ExtensionMode=ti={}));var ni;(function(j){j[j.Node=1]="Node",j[j.Webworker=2]="Webworker"})(ni||(e.ExtensionRuntime=ni={}));var ii;(function(j){j[j.Other=0]="Other",j[j.Comment=1]="Comment",j[j.String=2]="String",j[j.RegEx=3]="RegEx"})(ii||(e.StandardTokenType=ii={}));class Li{constructor(F,le){this.ranges=F,this.wordPattern=le}}e.$YL=Li;class Ri{constructor(F){this.c=F}get autoForwardAction(){return this.c}}e.$ZL=Ri;var si;(function(j){j[j.Queued=1]="Queued",j[j.Running=2]="Running",j[j.Passed=3]="Passed",j[j.Failed=4]="Failed",j[j.Skipped=5]="Skipped",j[j.Errored=6]="Errored"})(si||(e.TestResultState=si={}));var ri;(function(j){j[j.Run=1]="Run",j[j.Debug=2]="Debug",j[j.Coverage=3]="Coverage"})(ri||(e.TestRunProfileKind=ri={}));let Pn=class{constructor(F=void 0,le=void 0,pe=void 0,Me=!1){this.include=F,this.exclude=le,this.profile=pe,this.continuous=Me}};e.$1L=Pn,e.$1L=Pn=Re([V],Pn);let Cn=Z=class{static diff(F,le,pe){const Me=new Z(F);return Me.expectedOutput=le,Me.actualOutput=pe,Me}constructor(F){this.message=F}};e.$2L=Cn,e.$2L=Cn=Z=Re([V],Cn);let In=class{constructor(F){this.id=F}};e.$3L=In,e.$3L=In=Re([V],In);let Gt=class{constructor(F,le){this.covered=F,this.total=le}};e.$4L=Gt,e.$4L=Gt=Re([V],Gt);let An=fe=class{static fromDetails(F,le){const pe=new Gt(0,0),Me=new Gt(0,0),Ge=new Gt(0,0);for(const tt of le)if("branches"in tt){pe.total+=1,pe.covered+=tt.executionCount>0?1:0;for(const lt of tt.branches)Me.total+=1,Me.covered+=lt.executionCount>0?1:0}else Ge.total+=1,Ge.covered+=tt.executionCount>0?1:0;const _e=new fe(F,pe,Me.total>0?Me:void 0,Ge.total>0?Ge:void 0);return _e.detailedCoverage=le,_e}constructor(F,le,pe,Me){this.uri=F,this.statementCoverage=le,this.branchCoverage=pe,this.functionCoverage=Me}};e.$5L=An,e.$5L=An=fe=Re([V],An);let Ln=class{constructor(F,le,pe=[]){this.executionCount=F,this.location=le,this.branches=pe}};e.$6L=Ln,e.$6L=Ln=Re([V],Ln);let Rn=class{constructor(F,le){this.executionCount=F,this.location=le}};e.$7L=Rn,e.$7L=Rn=Re([V],Rn);let On=class{constructor(F,le){this.executionCount=F,this.location=le}};e.$8L=On,e.$8L=On=Re([V],On);var oi;(function(j){j[j.None=0]="None",j[j.Option=1]="Option",j[j.Default=2]="Default",j[j.Preferred=3]="Preferred"})(oi||(e.ExternalUriOpenerPriority=oi={}));var ai;(function(j){j[j.Untrusted=0]="Untrusted",j[j.Trusted=1]="Trusted",j[j.Unspecified=2]="Unspecified"})(ai||(e.WorkspaceTrustState=ai={}));var ci;(function(j){j[j.Notify=1]="Notify",j[j.OpenBrowser=2]="OpenBrowser",j[j.OpenPreview=3]="OpenPreview",j[j.Silent=4]="Silent",j[j.Ignore=5]="Ignore",j[j.OpenBrowserOnce=6]="OpenBrowserOnce"})(ci||(e.PortAutoForwardAction=ci={}));class Oi{constructor(F,le,pe,Me,Ge,_e){this.kind=F,this.name=le,this.detail=pe,this.uri=Me,this.range=Ge,this.selectionRange=_e}}e.$9L=Oi;class Ni{constructor(F){this.uri=F}}e.$0L=Ni;class Fi{constructor(F,le){this.original=F,this.modified=le}}e.$$L=Fi;class ji{constructor(F,le,pe,Me){this.base=F,this.input1=le,this.input2=pe,this.result=Me}}e.$_L=ji;class Mi{constructor(F,le){this.uri=F,this.viewType=le}}e.$aM=Mi;class Ti{constructor(F){this.viewType=F}}e.$bM=Ti;class Ui{constructor(F,le){this.uri=F,this.notebookType=le}}e.$cM=Ui;class Bi{constructor(F,le,pe){this.original=F,this.modified=le,this.notebookType=pe}}e.$dM=Bi;class zi{constructor(){}}e.$eM=zi;class qi{constructor(F,le){this.uri=F,this.inputBoxUri=le}}e.$fM=qi;var li;(function(j){j[j.Down=0]="Down",j[j.Up=1]="Up"})(li||(e.InteractiveSessionVoteDirection=li={}));var ui;(function(j){j[j.Action=1]="Action",j[j.Toolbar=2]="Toolbar"})(ui||(e.InteractiveSessionCopyKind=ui={}));var hi;(function(j){j[j.Unhelpful=0]="Unhelpful",j[j.Helpful=1]="Helpful",j[j.Undone=2]="Undone",j[j.Accepted=3]="Accepted"})(hi||(e.InteractiveEditorResponseFeedbackKind=hi={}));var fi;(function(j){j[j.System=0]="System",j[j.User=1]="User",j[j.Assistant=2]="Assistant",j[j.Function=3]="Function"})(fi||(e.ChatMessageRole=fi={}));var di;(function(j){j[j.Short=1]="Short",j[j.Medium=2]="Medium",j[j.Full=3]="Full"})(di||(e.ChatVariableLevel=di={}));class Hi{constructor(F,le){this.role=F,this.content=le}}e.$gM=Hi;var mi;(function(j){j[j.Unhelpful=0]="Unhelpful",j[j.Helpful=1]="Helpful"})(mi||(e.ChatAgentResultFeedbackKind=mi={}));var gi;(function(j){j[j.SymbolInformation=1]="SymbolInformation",j[j.CommandInformation=2]="CommandInformation",j[j.SearchInformation=3]="SearchInformation",j[j.SettingInformation=4]="SettingInformation"})(gi||(e.RelatedInformationType=gi={}));var $i;(function(j){j[j.Started=1]="Started",j[j.Recognizing=2]="Recognizing",j[j.Recognized=3]="Recognized",j[j.Stopped=4]="Stopped"})($i||(e.SpeechToTextStatus=$i={}))}),define(be[270],we([1,0,6]),function(ue,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UM=void 0,e.$UM=(0,y.$Qh)("environmentVariableService")}),define(be[271],we([1,0,7,4,60,3,249,8]),function(ue,e,y,R,r,L,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rN=e.$qN=e.$pN=e.$oN=e.$nN=e.$mN=e.$lN=e.$kN=e.$jN=void 0;function p(c,n){if(n)if(L.$d)for(const i in n){let o=i;for(const t in c)if(i.toLowerCase()===t.toLowerCase()){o=t;break}const s=n[i];s!==void 0&&w(c,o,s)}else Object.keys(n).forEach(i=>{const o=n[i];o!==void 0&&w(c,i,o)})}e.$jN=p;function w(c,n,i){typeof i=="string"?c[n]=i:delete c[n]}function A(c,n,i,o){c.TERM_PROGRAM="vscode",n&&(c.TERM_PROGRAM_VERSION=n),u(c,o)&&(c.LANG=b(i)),c.COLORTERM="truecolor"}e.$kN=A;function k(c,n){if(n)for(const i of Object.keys(n)){const o=n[i];o!=null&&(c[i]=o)}}async function v(c,n){return await Promise.all(Object.entries(n).map(async([i,o])=>{if(typeof o=="string")try{n[i]=await c(o)}catch{n[i]=o}})),n}function u(c,n){if(n==="on")return!0;if(n==="auto"){const i=c.LANG;return!i||i.search(/\.UTF\-8$/)===-1&&i.search(/\.utf8$/)===-1&&i.search(/\.euc.+/)===-1}return!1}e.$lN=u;function b(c){const n=c?c.split("-"):[],i=n.length;if(i===0)return"en_US.UTF-8";if(i===1){const o={af:"ZA",am:"ET",be:"BY",bg:"BG",ca:"ES",cs:"CZ",da:"DK",de:"DE",el:"GR",en:"US",es:"ES",et:"EE",eu:"ES",fi:"FI",fr:"FR",he:"IL",hr:"HR",hu:"HU",hy:"AM",is:"IS",it:"IT",ja:"JP",kk:"KZ",ko:"KR",lt:"LT",nl:"NL",no:"NO",pl:"PL",pt:"BR",ro:"RO",ru:"RU",sk:"SK",sl:"SI",sr:"YU",sv:"SE",tr:"TR",uk:"UA",zh:"CN"};n[0]in o&&n.push(o[n[0]])}else n[1]=n[1].toUpperCase();return n.join("_")+".UTF-8"}e.$mN=b;async function m(c,n,i,o,s,t){if(c.cwd){const f=typeof c.cwd=="object"?c.cwd.fsPath:c.cwd,S=await d(f,i);return(0,I.$hN)(S||f)}let a;return!c.ignoreConfigurationCwd&&s&&(i&&(s=await d(s,i,t)),s&&(y.$ic(s)?a=s:o&&(a=y.$jc(o.fsPath,s)))),a||(a=o?o.fsPath:n||""),(0,I.$hN)(a)}e.$nN=m;async function d(c,n,i){if(n)try{return await n(c)}catch(o){i?.error("Could not resolve terminal cwd",o);return}return c}function h(c,n,i){if(i)return o=>i.resolveWithEnvironment(n,c,o)}e.$oN=h;async function g(c,n,i,o,s,t){const a={};if(c.strictEnv)k(a,c.env);else{k(a,t);const f={...n};i&&(f&&await v(i,f),c.env&&await v(i,c.env)),(0,r.$Bl)(a,"VSCODE_IPC_HOOK_CLI","VSCODE_PROXY_URI"),p(a,f),p(a,c.env),A(a,o,L.$q,s)}return a}e.$pN=g;async function l(c,n,i,o,s,t,a=L.$d){let f;if((0,C.$zf)(c)?f=c:(f=c.fsPath,a&&t!==1?f=f.replace(/\\/g,"/"):!a&&t===1&&(f=f.replace(/\//g,"\\"))),!n)return f;const S=f.includes(" "),D=f.includes("(")||f.includes(")"),E=y.$nc(n,".exe"),P=E==="pwsh"||i==="pwsh"||E==="powershell"||i==="powershell";if(P&&(S||f.includes("'")))return`& '${f.replace(/'/g,"''")}'`;if(D&&P)return`& '${f}'`;if(t===1){if(o!==void 0)return o==="gitbash"?(0,I.$fN)(f.replace(/\\/g,"/")):o==="wsl"?s?.getWslPath(f,"win-to-unix")||f:S?`"${f}"`:f;const M=n.toLowerCase();return M.includes("wsl")||M.includes("bash.exe")&&!M.toLowerCase().includes("git")?s?.getWslPath(f,"win-to-unix")||f:S?`"${f}"`:f}return(0,I.$fN)(f)}e.$qN=l;function $(c,n,i){const o=typeof c=="string"?R.URI.parse(c):c;let s=o?n.getWorkspaceFolder(o)??void 0:void 0;if(!s){const t=i.getLastActiveWorkspaceRoot();s=t?n.getWorkspaceFolder(t)??void 0:void 0}return s}e.$rN=$}),define(be[71],we([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jJ=e.TestPosition=e.TestIdPathParts=void 0;var y;(function(L){L.Delimiter="\0"})(y||(e.TestIdPathParts=y={}));var R;(function(L){L[L.IsSame=0]="IsSame",L[L.Disconnected=1]="Disconnected",L[L.IsChild=2]="IsChild",L[L.IsParent=3]="IsParent"})(R||(e.TestPosition=R={}));class r{static fromExtHostTestItem(I,C,p=I.parent){if(I._isRoot)return new r([C]);const w=[I.id];for(let A=p;A&&A.id!==C;A=A.parent)w.push(A.id);return w.push(C),new r(w.reverse())}static isRoot(I){return!I.includes("\0")}static root(I){const C=I.indexOf("\0");return C===-1?I:I.slice(0,C)}static fromString(I){return new r(I.split("\0"))}static join(I,C){return new r([...I.path,C])}static joinToString(I,C){return I.toString()+"\0"+C}static parentId(I){const C=I.lastIndexOf("\0");return C===-1?void 0:I.slice(0,C)}static localId(I){const C=I.lastIndexOf("\0");return C===-1?I:I.slice(C+1)}static isChild(I,C){return C.startsWith(I)&&C[I.length]==="\0"}static compare(I,C){return I===C?0:r.isChild(I,C)?2:r.isChild(C,I)?3:1}constructor(I,C=I.length){if(this.path=I,this.d=C,I.length===0||C<1)throw new Error("cannot create test with empty path")}get rootId(){return new r(this.path,1)}get parentId(){return this.d>1?new r(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let I=1;I<=this.d;I++)yield new r(this.path,I)}*idsToRoot(){for(let I=this.d;I>0;I--)yield new r(this.path,I)}compare(I){if(typeof I=="string")return r.compare(this.toString(),I);for(let C=0;C<I.d&&C<this.d;C++)if(I.path[C]!==this.path[C])return 1;return I.d>this.d?2:I.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let I=1;I<this.d;I++)this.c+="\0",this.c+=this.path[I]}return this.c}}e.$jJ=r}),define(be[93],we([1,0,4,43,71]),function(ue,e,y,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qJ=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.$pJ=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$oJ=e.$nJ=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$mJ=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$lJ=e.$kJ=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.TestResultState=void 0;var L;(function(S){S[S.Unset=0]="Unset",S[S.Queued=1]="Queued",S[S.Running=2]="Running",S[S.Passed=3]="Passed",S[S.Failed=4]="Failed",S[S.Skipped=5]="Skipped",S[S.Errored=6]="Errored"})(L||(e.TestResultState=L={}));var I;(function(S){S[S.Run=1]="Run",S[S.Debug=2]="Debug",S[S.Coverage=3]="Coverage"})(I||(e.ExtTestRunProfileKind=I={}));var C;(function(S){S[S.Run=2]="Run",S[S.Debug=4]="Debug",S[S.Coverage=8]="Coverage",S[S.HasNonDefaultProfile=16]="HasNonDefaultProfile",S[S.HasConfigurable=32]="HasConfigurable",S[S.SupportsContinuousRun=64]="SupportsContinuousRun"})(C||(e.TestRunProfileBitset=C={})),e.$kJ=[2,4,8,16,32,64];const p=S=>"runId"in S;e.$lJ=p;var w;(function(S){S.serialize=D=>({range:D.range.toJSON(),uri:D.uri.toJSON()}),S.deserialize=D=>({range:R.$ys.lift(D.range),uri:y.URI.revive(D.uri)})})(w||(e.IRichLocation=w={}));var A;(function(S){S[S.Error=0]="Error",S[S.Output=1]="Output"})(A||(e.TestMessageType=A={}));var k;(function(S){S.serialize=D=>({message:D.message,type:0,expected:D.expected,actual:D.actual,contextValue:D.contextValue,location:D.location&&w.serialize(D.location)}),S.deserialize=D=>({message:D.message,type:0,expected:D.expected,actual:D.actual,contextValue:D.contextValue,location:D.location&&w.deserialize(D.location)})})(k||(e.ITestErrorMessage=k={}));const v=(S,D)=>`${D?"s":"e"}${S}`;e.$mJ=v;var u;(function(S){S.serialize=D=>({message:D.message,type:1,offset:D.offset,length:D.length,location:D.location&&w.serialize(D.location)}),S.deserialize=D=>({message:D.message,type:1,offset:D.offset,length:D.length,location:D.location&&w.deserialize(D.location)})})(u||(e.ITestOutputMessage=u={}));var b;(function(S){S.serialize=D=>D.type===0?k.serialize(D):u.serialize(D),S.deserialize=D=>D.type===0?k.deserialize(D):u.deserialize(D)})(b||(e.ITestMessage=b={}));var m;(function(S){S.serializeWithoutMessages=D=>({state:D.state,duration:D.duration,messages:[]}),S.serialize=D=>({state:D.state,duration:D.duration,messages:D.messages.map(b.serialize)}),S.deserialize=D=>({state:D.state,duration:D.duration,messages:D.messages.map(b.deserialize)})})(m||(e.ITestTaskState=m={}));const d="\0",h=(S,D)=>S+d+D;e.$nJ=h;const g=S=>{const D=S.indexOf(d);return{ctrlId:S.slice(0,D),tagId:S.slice(D+1)}};e.$oJ=g;var l;(function(S){S.serialize=D=>({extId:D.extId,label:D.label,tags:D.tags,busy:D.busy,children:void 0,uri:D.uri?.toJSON(),range:D.range?.toJSON()||null,description:D.description,error:D.error,sortText:D.sortText}),S.deserialize=D=>({extId:D.extId,label:D.label,tags:D.tags,busy:D.busy,children:void 0,uri:D.uri?y.URI.revive(D.uri):void 0,range:D.range?R.$ys.lift(D.range):null,description:D.description,error:D.error,sortText:D.sortText})})(l||(e.ITestItem=l={}));var $;(function(S){S[S.NotExpandable=0]="NotExpandable",S[S.Expandable=1]="Expandable",S[S.BusyExpanding=2]="BusyExpanding",S[S.Expanded=3]="Expanded"})($||(e.TestItemExpandState=$={}));var c;(function(S){S.serialize=D=>({expand:D.expand,item:l.serialize(D.item)}),S.deserialize=D=>({controllerId:r.$jJ.root(D.item.extId),expand:D.expand,item:l.deserialize(D.item)})})(c||(e.InternalTestItem=c={}));var n;(function(S){S.serialize=D=>{let E;return D.item&&(E={},D.item.label!==void 0&&(E.label=D.item.label),D.item.tags!==void 0&&(E.tags=D.item.tags),D.item.busy!==void 0&&(E.busy=D.item.busy),D.item.uri!==void 0&&(E.uri=D.item.uri?.toJSON()),D.item.range!==void 0&&(E.range=D.item.range?.toJSON()),D.item.description!==void 0&&(E.description=D.item.description),D.item.error!==void 0&&(E.error=D.item.error),D.item.sortText!==void 0&&(E.sortText=D.item.sortText)),{extId:D.extId,expand:D.expand,item:E}},S.deserialize=D=>{let E;return D.item&&(E={},D.item.label!==void 0&&(E.label=D.item.label),D.item.tags!==void 0&&(E.tags=D.item.tags),D.item.busy!==void 0&&(E.busy=D.item.busy),D.item.range!==void 0&&(E.range=D.item.range?R.$ys.lift(D.item.range):null),D.item.description!==void 0&&(E.description=D.item.description),D.item.error!==void 0&&(E.error=D.item.error),D.item.sortText!==void 0&&(E.sortText=D.item.sortText)),{extId:D.extId,expand:D.expand,item:E}}})(n||(e.ITestItemUpdate=n={}));const i=(S,D)=>{D.expand!==void 0&&(S.expand=D.expand),D.item!==void 0&&(S.item=S.item?Object.assign(S.item,D.item):D.item)};e.$pJ=i;var o;(function(S){S.serializeWithoutMessages=D=>({...c.serialize(D),ownComputedState:D.ownComputedState,computedState:D.computedState,tasks:D.tasks.map(m.serializeWithoutMessages)}),S.serialize=D=>({...c.serialize(D),ownComputedState:D.ownComputedState,computedState:D.computedState,tasks:D.tasks.map(m.serialize)}),S.deserialize=D=>({...c.deserialize(D),ownComputedState:D.ownComputedState,computedState:D.computedState,tasks:D.tasks.map(m.deserialize),retired:!0})})(o||(e.TestResultItem=o={}));var s;(function(S){S[S.Function=0]="Function",S[S.Statement=1]="Statement"})(s||(e.DetailType=s={}));var t;(function(S){S[S.Add=0]="Add",S[S.Update=1]="Update",S[S.DocumentSynced=2]="DocumentSynced",S[S.Remove=3]="Remove",S[S.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",S[S.Retire=5]="Retire",S[S.AddTag=6]="AddTag",S[S.RemoveTag=7]="RemoveTag"})(t||(e.TestDiffOpType=t={}));var a;(function(S){S.deserialize=D=>D.op===0?{op:D.op,item:c.deserialize(D.item)}:D.op===1?{op:D.op,item:n.deserialize(D.item)}:D.op===2?{op:D.op,uri:y.URI.revive(D.uri),docv:D.docv}:D,S.serialize=D=>D.op===0?{op:D.op,item:c.serialize(D.item)}:D.op===1?{op:D.op,item:n.serialize(D.item)}:D})(a||(e.TestsDiffOp=a={}));class f{constructor(){this.c=new Map,this.d=new Map,this.f=new Set,this.g=0,this.h=0,this.tags=this.c}apply(D){const E=this.o();for(const P of D)switch(P.op){case 0:this.j(c.deserialize(P.item),E);break;case 1:this.k(n.deserialize(P.item),E);break;case 3:this.l(P.itemId,E);break;case 5:this.m(P.itemId);break;case 4:this.updatePendingRoots(P.amount);break;case 6:this.c.set(P.tag.id,P.tag);break;case 7:this.c.delete(P.id);break}E.complete?.()}j(D,E){const P=r.$jJ.parentId(D.item.extId)?.toString();let M;if(!P)M=this.p(D),this.f.add(M),this.d.set(D.item.extId,M);else if(this.d.has(P)){const ee=this.d.get(P);ee.children.add(D.item.extId),M=this.p(D,ee),this.d.set(D.item.extId,M)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(D)}`);return}return E.add?.(M),D.expand===2&&this.g++,M}k(D,E){const P=this.d.get(D.extId);if(P)return D.expand!==void 0&&(P.expand===2&&this.g--,D.expand===2&&this.g++),(0,e.$pJ)(P,D),E.update?.(P),P}l(D,E){const P=this.d.get(D);if(!P)return;const M=r.$jJ.parentId(P.item.extId)?.toString();M?this.d.get(M).children.delete(P.item.extId):this.f.delete(P);const ee=[[D]];for(;ee.length;)for(const se of ee.pop()){const G=this.d.get(se);G&&(ee.push(G.children),this.d.delete(se),E.remove?.(G,G!==P),G.expand===2&&this.g--)}}m(D){}updatePendingRoots(D){this.h+=D}o(){return{}}}e.$qJ=f}),define(be[132],we([1,0,14,5,2,96,93,71]),function(ue,e,y,R,r,L,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lM=e.$kM=e.$jM=e.$iM=e.$hM=e.TestItemEventOp=void 0;var p;(function(g){g[g.Upsert=0]="Upsert",g[g.SetTags=1]="SetTags",g[g.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",g[g.RemoveChild=3]="RemoveChild",g[g.SetProp=4]="SetProp",g[g.Bulk=5]="Bulk",g[g.DocumentSynced=6]="DocumentSynced"})(p||(e.TestItemEventOp=p={}));const w=(g,l)=>g===l,k=Object.entries({range:(g,l)=>g===l?!0:!g||!l?!1:g.equalsRange(l),busy:w,label:w,description:w,error:w,sortText:w,tags:(g,l)=>!(g.length!==l.length||g.some($=>!l.includes($)))}),v=(g,l)=>{let $;for(const[c,n]of k)n(g[c],l[c])||($?$[c]=l[c]:$={[c]:l[c]});return $};class u extends r.$Sc{get root(){return this.s.root}constructor(l){super(),this.s=l,this.f=this.B(new y.$7g(()=>this.flushDiff(),200)),this.g=this.B(new R.$Od),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.y(this.root,void 0)}set resolveHandler(l){this.h=l;for(const $ of this.tree.values())this.I($)}get resolveHandler(){return this.h}collectDiff(){const l=this.m;return this.m=[],l}pushDiff(l){switch(l.op){case 2:{for(const $ of this.m)if($.op===2&&$.uri===l.uri){$.docv=l.docv;return}break}case 1:{const $=this.m[this.m.length-1];if($){if($.op===1&&$.item.extId===l.item.extId){(0,I.$pJ)($.item,l.item);return}if($.op===0&&$.item.item.extId===l.item.extId){(0,I.$pJ)($.item,l.item);return}}break}}this.m.push(l),this.f.isScheduled()||this.f.schedule()}expand(l,$){const c=this.tree.get(l);if(c){if((c.expandLevels===void 0||$>c.expandLevels)&&(c.expandLevels=$),c.expand===1){const n=this.L(c);return n.isOpen()?this.J(c,$-1):n.wait().then(()=>this.J(c,$-1))}else if(c.expand===3)return c.resolveBarrier?.isOpen()===!1?c.resolveBarrier.wait().then(()=>this.J(c,$-1)):this.J(c,$-1)}}dispose(){for(const l of this.tree.values())this.s.getApiFor(l.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}u(l,$){switch($.op){case 3:this.N(C.$jJ.joinToString(l.fullId,$.id));break;case 0:this.y($.item,l);break;case 5:for(const c of $.ops)this.u(l,c);break;case 1:this.z($.new,$.old,l.fullId.toString());break;case 2:this.I(l);break;case 4:this.pushDiff({op:1,item:{extId:l.fullId.toString(),item:$.update}});break;case 6:this.w(l.actual.uri);break;default:(0,L.$4c)($)}}w(l){l&&this.pushDiff({op:2,uri:l,docv:this.s.getDocumentVersion(l)})}y(l,$){const c=C.$jJ.fromExtHostTestItem(l,this.root.id,$?.actual),n=this.s.getApiFor(l);n.parent&&n.parent!==$?.actual&&this.s.getChildren(n.parent).delete(l.id);let i=this.tree.get(c.toString());if(!i){i={fullId:c,actual:l,expandLevels:$?.expandLevels?$.expandLevels-1:void 0,expand:0},l.tags.forEach(this.C,this),this.tree.set(i.fullId.toString(),i),this.F(l,$),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:i.expand,item:this.s.toITestItem(l)}}),this.H(l,i,$);return}if(i.actual===l){this.G(l,i,$);return}if(i.actual.uri?.toString()!==l.uri?.toString())return this.N(c.toString()),this.y(l,$);const o=this.s.getChildren(i.actual),s=i.actual,t=v(this.s.toITestItem(s),this.s.toITestItem(l));this.s.getApiFor(s).listener=void 0,i.actual=l,i.expand=0,t&&(t.hasOwnProperty("tags")&&(this.z(l.tags,s.tags,c.toString()),delete t.tags),this.u(i,{op:4,update:t})),this.H(l,i,$);for(const[a,f]of o)this.s.getChildren(l).get(f.id)||this.N(C.$jJ.joinToString(c,f.id));this.w(i.actual.uri)}z(l,$,c){const n=new Set($.map(i=>i.id));for(const i of l)n.delete(i.id)||this.C(i);this.pushDiff({op:1,item:{extId:c,item:{tags:l.map(i=>(0,I.$nJ)(this.s.controllerId,i.id))}}}),n.forEach(this.D,this)}C(l){const $=this.j.get(l.id);$?$.refCount++:(this.j.set(l.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,I.$nJ)(this.s.controllerId,l.id)}}))}D(l){const $=this.j.get(l);$&&!--$.refCount&&(this.j.delete(l),this.pushDiff({op:7,id:(0,I.$nJ)(this.s.controllerId,l)}))}F(l,$){this.s.getApiFor(l).parent=$&&$.actual!==this.root?$.actual:void 0}G(l,$,c){this.F(l,c);const n=this.s.getApiFor(l);n.parent=c?.actual,n.listener=i=>this.u($,i),this.I($)}H(l,$,c){this.G(l,$,c);for(const[n,i]of this.s.getChildren(l))this.y(i,$)}I(l){let $;this.h?l.resolveBarrier?$=l.resolveBarrier.isOpen()?3:2:$=l.actual.canResolveChildren?1:0:$=0,$!==l.expand&&(l.expand=$,this.pushDiff({op:1,item:{extId:l.fullId.toString(),expand:$}}),$===1&&l.expandLevels!==void 0&&this.L(l))}J(l,$){if($<0)return;const c=[];for(const[n,i]of this.s.getChildren(l.actual)){const o=this.expand(C.$jJ.joinToString(l.fullId,i.id),$);(0,y.$Hg)(o)&&c.push(o)}if(c.length)return Promise.all(c).then(()=>{})}L(l){if(l.resolveBarrier)return l.resolveBarrier;if(!this.h){const i=new y.$Tg;return i.open(),i}l.expand=2,this.M(l);const $=l.resolveBarrier=new y.$Tg,c=i=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,i)};let n;try{n=this.h(l.actual===this.root?void 0:l.actual)}catch(i){c(i)}return(0,y.$Hg)(n)?n.catch(c).then(()=>{$.open(),this.I(l)}):($.open(),this.I(l)),l.resolveBarrier}M(l){this.pushDiff({op:1,item:{extId:l.fullId.toString(),expand:l.expand}})}N(l){const $=this.tree.get(l);if(!$)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:l});const c=[$];for(;c.length;){const n=c.pop();if(n){this.s.getApiFor(n.actual).listener=void 0;for(const i of n.actual.tags)this.D(i.id);this.tree.delete(n.fullId.toString());for(const[i,o]of this.s.getChildren(n.actual))c.push(this.tree.get(C.$jJ.joinToString(n.fullId,o.id)))}}}flushDiff(){const l=this.collectDiff();l.length&&this.g.fire(l)}}e.$hM=u;class b extends Error{constructor(l){super(`Attempted to insert a duplicate test item ID ${l}`)}}e.$iM=b;class m extends Error{constructor(l){super(`TestItem with ID "${l}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$jM=m;class d extends Error{constructor(l,$,c){super(`TestItem with ID "${l}" is from controller "${$}" and cannot be added as a child of an item from controller "${c}".`)}}e.$kM=d;const h=(g,l,$)=>{let c=new Map;return{get size(){return c.size},forEach(n,i){for(const o of c.values())n.call(i,o,this)},[Symbol.iterator](){return c.entries()},replace(n){const i=new Map,o=new Set(c.keys()),s={op:5,ops:[]};for(const t of n){if(!(t instanceof $))throw new m(t.id);const a=l(t).controllerId;if(a!==g.controllerId)throw new d(t.id,a,g.controllerId);if(i.has(t.id))throw new b(t.id);i.set(t.id,t),o.delete(t.id),s.ops.push({op:0,item:t})}for(const t of o.keys())s.ops.push({op:3,id:t});g.listener?.(s),c=i},add(n){if(!(n instanceof $))throw new m(n.id);c.set(n.id,n),g.listener?.({op:0,item:n})},delete(n){c.delete(n)&&g.listener?.({op:3,id:n})},get(n){return c.get(n)},toJSON(){return Array.from(c.values())}}};e.$lM=h}),define(be[133],we([1,0,132]),function(ue,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nM=e.$mM=void 0;const R=new WeakMap,r=(I,C)=>{const p={controllerId:C};return R.set(I,p),p};e.$mM=r;const L=I=>{const C=R.get(I);if(!C)throw new y.$jM(I?.id||"<unknown>");return C};e.$nM=L}),define(be[272],we([1,0,24,6]),function(ue,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GD=e.$FD=e.$ED=e.$DD=e.$CD=e.$BD=e.$AD=e.$zD=e.$yD=e.$xD=e.$wD=e.$vD=e.$uD=e.$tD=e.$sD=e.$rD=e.$qD=e.$pD=e.$oD=e.$nD=e.$mD=e.$lD=e.$kD=e.$jD=e.$iD=void 0,e.$iD=".vscode",e.$jD="settings",e.$kD=`${e.$iD}/${e.$jD}.json`,e.$lD="vscode://schemas/settings/default",e.$mD="vscode://schemas/settings/user",e.$nD="vscode://schemas/settings/profile",e.$oD="vscode://schemas/settings/machine",e.$pD="vscode://schemas/settings/workspace",e.$qD="vscode://schemas/settings/folder",e.$rD="vscode://schemas/launch",e.$sD="vscode://schemas/tasks",e.$tD=[1],e.$uD=[2,3,4,5,6],e.$vD=[3,4,5],e.$wD=[1,...e.$vD],e.$xD=[2,3,4,5,6],e.$yD=[3,4,5,6],e.$zD=[4,5,6],e.$AD="tasks",e.$BD="launch",e.$CD=Object.create(null),e.$CD[e.$AD]=`${e.$iD}/${e.$AD}.json`,e.$CD[e.$BD]=`${e.$iD}/${e.$BD}.json`,e.$DD=Object.create(null),e.$DD[e.$AD]=`${e.$AD}.json`,e.$ED=(0,R.$Rh)(y.$ki),e.$FD=`{
	"version": "2.0.0",
	"tasks": []
}`,e.$GD="workbench.settings.applyToAllProfiles"}),define(be[134],we([1,0,6]),function(ue,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eN=e.VariableKind=e.$dN=void 0,e.$dN=(0,y.$Qh)("configurationResolverService");var R;(function(L){L.Unknown="unknown",L.Env="env",L.Config="config",L.Command="command",L.Input="input",L.ExtensionInstallFolder="extensionInstallFolder",L.WorkspaceFolder="workspaceFolder",L.Cwd="cwd",L.WorkspaceFolderBasename="workspaceFolderBasename",L.UserHome="userHome",L.LineNumber="lineNumber",L.SelectedText="selectedText",L.File="file",L.FileWorkspaceFolder="fileWorkspaceFolder",L.RelativeFile="relativeFile",L.RelativeFileDirname="relativeFileDirname",L.FileDirname="fileDirname",L.FileExtname="fileExtname",L.FileBasename="fileBasename",L.FileBasenameNoExtension="fileBasenameNoExtension",L.FileDirnameBasename="fileDirnameBasename",L.ExecPath="execPath",L.ExecInstallFolder="execInstallFolder",L.PathSeparator="pathSeparator"})(R||(e.VariableKind=R={}));class r extends Error{constructor(I,C){super(C),this.variable=I}}e.$eN=r}),define(be[273],we([1,0,7,28,8,22,3,152,203,134,17]),function(ue,e,y,R,r,L,I,C,p,w,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sN=void 0;class k{constructor(u,b,m,d){this.h=new Map,this.a=u,this.b=b,this.g=m,d&&(this.c=d.then(h=>this.i(h)))}i(u){if(I.$d){const b=Object.create(null);return Object.keys(u).forEach(m=>{b[m.toLowerCase()]=u[m]}),b}return u}resolveWithEnvironment(u,b,m){return this.l({env:this.i(u),userHome:void 0},b?b.uri:void 0,m)}async resolveAsync(u,b){const m={env:await this.c,userHome:await this.g};return this.l(m,u?u.uri:void 0,b)}async j(u,b,m,d){const h=L.$9m(b);I.$d&&h.windows?Object.keys(h.windows).forEach(l=>h[l]=h.windows[l]):I.$e&&h.osx?Object.keys(h.osx).forEach(l=>h[l]=h.osx[l]):I.$f&&h.linux&&Object.keys(h.linux).forEach(l=>h[l]=h.linux[l]),delete h.windows,delete h.osx,delete h.linux;const g={env:await this.c,userHome:await this.g};return this.l(g,u?u.uri:void 0,h,m,d)}async resolveAnyAsync(u,b,m){return this.j(u,b,m)}async resolveAnyMap(u,b,m){const d=new Map;return{newConfig:await this.j(u,b,m,d),resolvedVariables:d}}resolveWithInteractionReplace(u,b,m,d){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(u,b,m,d){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(u,b){if(this.h.has(u))throw new Error("Variable "+u+" is contributed twice.");this.h.set(u,b)}async l(u,b,m,d,h){if(r.$zf(m))return this.m(u,b,m,d,h);if(Array.isArray(m))return Promise.all(m.map(g=>this.l(u,b,g,d,h)));if(r.$Bf(m)){const g=Object.create(null),l=await Promise.all(Object.keys(m).map(async $=>[await this.m(u,b,$,d,h),await this.l(u,b,m[$],d,h)]));for(const[$,c]of l)g[$]=c;return g}return m}m(u,b,m,d,h){return(0,A.$Ue)(m,k.VARIABLE_REGEXP,async(g,l)=>{if(l.includes(k.VARIABLE_LHS))return g;let $=await this.o(u,g,l,b,d);return h?.set(l,$),$!==g&&r.$zf($)&&$.match(k.VARIABLE_REGEXP)&&($=await this.m(u,b,$,d,h)),$})}n(u){return this.b?this.b.getUriLabel(u,{noPrefix:!0}):u.fsPath}async o(u,b,m,d,h){let g;const l=m.split(":");l.length>1&&(m=l[0],g=l[1]);const $=i=>{const o=this.a.getFilePath();if(o)return(0,C.$xv)(o);throw new w.$eN(i,(0,p.localize)(0,null,b))},c=i=>{const o=$(i);if(this.a.getWorkspaceFolderPathForFile){const s=this.a.getWorkspaceFolderPathForFile();if(s)return(0,C.$xv)(s)}throw new w.$eN(i,(0,p.localize)(1,null,b,y.$nc(o)))},n=i=>{if(g){const o=this.a.getFolderUri(g);if(o)return o;throw new w.$eN(i,(0,p.localize)(2,null,b,g))}if(d)return d;throw this.a.getWorkspaceFolderCount()>1?new w.$eN(i,(0,p.localize)(3,null,b)):new w.$eN(i,(0,p.localize)(4,null,b))};switch(m){case"env":if(g){if(u.env){const i=u.env[I.$d?g.toLowerCase():g];if(r.$zf(i))return i}return""}throw new w.$eN(w.VariableKind.Env,(0,p.localize)(5,null,b));case"config":if(g){const i=this.a.getConfigurationValue(d,g);if(r.$If(i))throw new w.$eN(w.VariableKind.Config,(0,p.localize)(6,null,b,g));if(r.$Bf(i))throw new w.$eN(w.VariableKind.Config,(0,p.localize)(7,null,b,g));return i}throw new w.$eN(w.VariableKind.Config,(0,p.localize)(8,null,b));case"command":return this.p(w.VariableKind.Command,b,g,h,"command");case"input":return this.p(w.VariableKind.Input,b,g,h,"input");case"extensionInstallFolder":if(g){const i=await this.a.getExtension(g);if(!i)throw new w.$eN(w.VariableKind.ExtensionInstallFolder,(0,p.localize)(9,null,b,g));return this.n(i.extensionLocation)}throw new w.$eN(w.VariableKind.ExtensionInstallFolder,(0,p.localize)(10,null,b));default:switch(m){case"workspaceRoot":case"workspaceFolder":return(0,C.$xv)(this.n(n(w.VariableKind.WorkspaceFolder)));case"cwd":return d||g?(0,C.$xv)(this.n(n(w.VariableKind.Cwd))):R.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,C.$xv)(y.$nc(this.n(n(w.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(u.userHome)return u.userHome;throw new w.$eN(w.VariableKind.UserHome,(0,p.localize)(11,null,b))}case"lineNumber":{const i=this.a.getLineNumber();if(i)return i;throw new w.$eN(w.VariableKind.LineNumber,(0,p.localize)(12,null,b))}case"selectedText":{const i=this.a.getSelectedText();if(i)return i;throw new w.$eN(w.VariableKind.SelectedText,(0,p.localize)(13,null,b))}case"file":return $(w.VariableKind.File);case"fileWorkspaceFolder":return c(w.VariableKind.FileWorkspaceFolder);case"relativeFile":return d||g?y.$lc(this.n(n(w.VariableKind.RelativeFile)),$(w.VariableKind.RelativeFile)):$(w.VariableKind.RelativeFile);case"relativeFileDirname":{const i=y.$mc($(w.VariableKind.RelativeFileDirname));if(d||g){const o=y.$lc(this.n(n(w.VariableKind.RelativeFileDirname)),i);return o.length===0?".":o}return i}case"fileDirname":return y.$mc($(w.VariableKind.FileDirname));case"fileExtname":return y.$oc($(w.VariableKind.FileExtname));case"fileBasename":return y.$nc($(w.VariableKind.FileBasename));case"fileBasenameNoExtension":{const i=y.$nc($(w.VariableKind.FileBasenameNoExtension));return i.slice(0,i.length-y.$oc(i).length)}case"fileDirnameBasename":return y.$nc(y.$mc($(w.VariableKind.FileDirnameBasename)));case"execPath":{const i=this.a.getExecPath();return i||b}case"execInstallFolder":{const i=this.a.getAppRoot();return i||b}case"pathSeparator":return y.sep;default:try{const i=g?`${m}:${g}`:m;return this.p(w.VariableKind.Unknown,b,i,h,void 0)}catch{return b}}}}p(u,b,m,d,h){if(m&&d){const g=h===void 0?d[m]:d[h+":"+m];if(typeof g=="string")return g;throw new w.$eN(u,(0,p.localize)(14,null,b))}return b}}e.$sN=k,k.VARIABLE_LHS="${",k.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(be[274],we([1,0,6,92]),function(ue,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vC=e.$uC=e.OpenEditorContext=e.GroupsOrder=e.$tC=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$sC=void 0,e.$sC=(0,y.$Qh)("editorGroupsService");var r;(function(b){b[b.UP=0]="UP",b[b.DOWN=1]="DOWN",b[b.LEFT=2]="LEFT",b[b.RIGHT=3]="RIGHT"})(r||(e.GroupDirection=r={}));var L;(function(b){b[b.HORIZONTAL=0]="HORIZONTAL",b[b.VERTICAL=1]="VERTICAL"})(L||(e.GroupOrientation=L={}));var I;(function(b){b[b.FIRST=0]="FIRST",b[b.LAST=1]="LAST",b[b.NEXT=2]="NEXT",b[b.PREVIOUS=3]="PREVIOUS"})(I||(e.GroupLocation=I={}));var C;(function(b){b[b.MAXIMIZE=0]="MAXIMIZE",b[b.EXPAND=1]="EXPAND",b[b.EVEN=2]="EVEN"})(C||(e.GroupsArrangement=C={}));var p;(function(b){b[b.COPY_EDITORS=0]="COPY_EDITORS",b[b.MOVE_EDITORS=1]="MOVE_EDITORS"})(p||(e.MergeGroupMode=p={}));function w(b){const m=b;return(0,R.$aE)(m?.editor)&&(0,R.$aE)(m?.replacement)}e.$tC=w;var A;(function(b){b[b.CREATION_TIME=0]="CREATION_TIME",b[b.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",b[b.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(A||(e.GroupsOrder=A={}));var k;(function(b){b[b.NEW_EDITOR=1]="NEW_EDITOR",b[b.MOVE_EDITOR=2]="MOVE_EDITOR",b[b.COPY_EDITOR=3]="COPY_EDITOR"})(k||(e.OpenEditorContext=k={}));function v(b){const m=b;return!!m&&typeof m.id=="number"&&Array.isArray(m.editors)}e.$uC=v;function u(b){return b.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.$vC=u}),define(be[135],we([1,0,6,274]),function(ue,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zC=e.$yC=e.$xC=e.$wC=void 0,e.$wC=(0,y.$Qh)("editorService"),e.$xC=-1,e.$yC=-2;function r(L){const I=L;return typeof L=="number"||(0,R.$uC)(I)}e.$zC=r}),define(be[275],we([1,0,272,118,90,88,134,92,135,12,222,270,89]),function(ue,e,y,R,r,L,I,C,p,w,A,k,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vN=e.$uN=void 0,e.$uN="remoteterminal";let u=class{get onPtyHostExit(){return this.b.listen("$onPtyHostExitEvent")}get onPtyHostStart(){return this.b.listen("$onPtyHostStartEvent")}get onPtyHostUnresponsive(){return this.b.listen("$onPtyHostUnresponsiveEvent")}get onPtyHostResponsive(){return this.b.listen("$onPtyHostResponsiveEvent")}get onPtyHostRequestResolveVariables(){return this.b.listen("$onPtyHostRequestResolveVariablesEvent")}get onProcessData(){return this.b.listen("$onProcessDataEvent")}get onProcessExit(){return this.b.listen("$onProcessExitEvent")}get onProcessReady(){return this.b.listen("$onProcessReadyEvent")}get onProcessReplay(){return this.b.listen("$onProcessReplayEvent")}get onProcessOrphanQuestion(){return this.b.listen("$onProcessOrphanQuestion")}get onExecuteCommand(){return this.b.listen("$onExecuteCommand")}get onDidRequestDetach(){return this.b.listen("$onDidRequestDetach")}get onDidChangeProperty(){return this.b.listen("$onDidChangeProperty")}constructor(m,d,h,g,l,$,c,n,i,o){this.a=m,this.b=d,this.c=h,this.d=g,this.e=l,this.f=$,this.g=c,this.h=n,this.i=i,this.j=o}restartPtyHost(){return this.b.call("$restartPtyHost",[])}async createProcess(m,d,h,g,l,$,c,n){await this.c.whenRemoteConfigurationLoaded();const i=Object.create(null),o=h?this.d.getWorkspaceFolder(h)??void 0:void 0;let s;try{s=(await this.e.resolveAnyMap(o,{shellLaunchConfig:m,configuration:d})).resolvedVariables}catch(ee){this.h.error(ee)}if(s)for(const[ee,se]of s.entries())(/^config:/.test(ee)||ee==="selectedText"||ee==="lineNumber")&&(i[ee]=se);const t=[];for(const[ee,se]of this.f.collections.entries())t.push([ee,(0,L.$pr)(se.map),(0,L.$qr)(se.descriptionMap)]);const a=await this.g.resolveAuthority(this.a),f=a.options&&a.options.extensionHostEnv,S=this.d.getWorkspace(),D=S.folders,E=h?this.d.getWorkspaceFolder(h):null,P=C.$iE.getOriginalUri(this.i.activeEditor,{supportSideBySide:C.SideBySideEditor.PRIMARY,filterByScheme:[w.Schemas.file,w.Schemas.vscodeUserData,w.Schemas.vscodeRemote]}),M={configuration:d,resolvedVariables:i,envVariableCollections:t,shellLaunchConfig:m,workspaceId:S.id,workspaceName:this.j.getWorkspaceLabel(S),workspaceFolders:D,activeWorkspaceFolder:E,activeFileResource:P,shouldPersistTerminal:l,options:g,cols:$,rows:c,unicodeVersion:n,resolverEnv:f};return await this.b.call("$createProcess",M)}requestDetachInstance(m,d){return this.b.call("$requestDetachInstance",[m,d])}acceptDetachInstanceReply(m,d){return this.b.call("$acceptDetachInstanceReply",[m,d])}attachToProcess(m){return this.b.call("$attachToProcess",[m])}detachFromProcess(m,d){return this.b.call("$detachFromProcess",[m,d])}listProcesses(){return this.b.call("$listProcesses")}getLatency(){return this.b.call("$getLatency")}getPerformanceMarks(){return this.b.call("$getPerformanceMarks")}reduceConnectionGraceTime(){return this.b.call("$reduceConnectionGraceTime")}processBinary(m,d){return this.b.call("$processBinary",[m,d])}start(m){return this.b.call("$start",[m])}input(m,d){return this.b.call("$input",[m,d])}acknowledgeDataEvent(m,d){return this.b.call("$acknowledgeDataEvent",[m,d])}setUnicodeVersion(m,d){return this.b.call("$setUnicodeVersion",[m,d])}shutdown(m,d){return this.b.call("$shutdown",[m,d])}resize(m,d,h){return this.b.call("$resize",[m,d,h])}clearBuffer(m){return this.b.call("$clearBuffer",[m])}getInitialCwd(m){return this.b.call("$getInitialCwd",[m])}getCwd(m){return this.b.call("$getCwd",[m])}orphanQuestionReply(m){return this.b.call("$orphanQuestionReply",[m])}sendCommandResult(m,d,h){return this.b.call("$sendCommandResult",[m,d,h])}freePortKillProcess(m){return this.b.call("$freePortKillProcess",[m])}installAutoReply(m,d){return this.b.call("$installAutoReply",[m,d])}uninstallAllAutoReplies(){return this.b.call("$uninstallAllAutoReplies",[])}getDefaultSystemShell(m){return this.b.call("$getDefaultSystemShell",[m])}getProfiles(m,d,h){return this.b.call("$getProfiles",[this.d.getWorkspace().id,m,d,h])}acceptPtyHostResolvedVariables(m,d){return this.b.call("$acceptPtyHostResolvedVariables",[m,d])}getEnvironment(){return this.b.call("$getEnvironment")}getWslPath(m,d){return this.b.call("$getWslPath",[m,d])}setTerminalLayoutInfo(m){const h={workspaceId:this.d.getWorkspace().id,tabs:m?m.tabs:[]};return this.b.call("$setTerminalLayoutInfo",h)}updateTitle(m,d,h){return this.b.call("$updateTitle",[m,d,h])}updateIcon(m,d,h,g){return this.b.call("$updateIcon",[m,d,h,g])}refreshProperty(m,d){return this.b.call("$refreshProperty",[m,d])}updateProperty(m,d,h){return this.b.call("$updateProperty",[m,d,h])}getTerminalLayoutInfo(){const d={workspaceId:this.d.getWorkspace().id};return this.b.call("$getTerminalLayoutInfo",d)}reviveTerminalProcesses(m,d,h){return this.b.call("$reviveTerminalProcesses",[m,d,h])}getRevivedPtyNewId(m){return this.b.call("$getRevivedPtyNewId",[m])}serializeTerminalState(m){return this.b.call("$serializeTerminalState",[m])}};e.$vN=u,e.$vN=u=Re([Ae(2,y.$ED),Ae(3,r.$Zh),Ae(4,I.$dN),Ae(5,k.$UM),Ae(6,R.$Qk),Ae(7,v.$cr),Ae(8,p.$wC),Ae(9,A.$4u)],u)}),define(be[276],we([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dm=e.$Cm=e.$Bm=e.$Am=e.$zm=e.ExtHostConnectionType=void 0;var y;(function(A){A[A.IPC=1]="IPC",A[A.Socket=2]="Socket",A[A.MessagePort=3]="MessagePort"})(y||(e.ExtHostConnectionType=y={}));class R{constructor(k){this.pipeName=k,this.type=1}serialize(k){k[R.ENV_KEY]=this.pipeName}}e.$zm=R,R.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK";class r{constructor(){this.type=2}serialize(k){k[r.ENV_KEY]="1"}}e.$Am=r,r.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET";class L{constructor(){this.type=3}serialize(k){k[L.ENV_KEY]="1"}}e.$Bm=L,L.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT";function I(A){delete A[R.ENV_KEY],delete A[r.ENV_KEY],delete A[L.ENV_KEY]}function C(A,k){I(k),A.serialize(k)}e.$Cm=C;function p(A){if(A[R.ENV_KEY])return w(A,new R(A[R.ENV_KEY]));if(A[r.ENV_KEY])return w(A,new r);if(A[L.ENV_KEY])return w(A,new L);throw new Error("No connection information defined in environment!")}e.$Dm=p;function w(A,k){return I(A),k}}),define(be[277],we([1,0,15]),function(ue,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.$em=e.$dm=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var R;(function(w){w[w.Desktop=1]="Desktop",w[w.Web=2]="Web"})(R||(e.UIKind=R={}));var r;(function(w){w[w.VersionMismatch=55]="VersionMismatch",w[w.UnexpectedError=81]="UnexpectedError"})(r||(e.ExtensionHostExitCode=r={}));var L;(function(w){w[w.Initialized=0]="Initialized",w[w.Ready=1]="Ready",w[w.Terminate=2]="Terminate"})(L||(e.MessageType=L={}));function I(w){const A=y.$ce.alloc(1);switch(w){case 0:A.writeUInt8(1,0);break;case 1:A.writeUInt8(2,0);break;case 2:A.writeUInt8(3,0);break}return A}e.$dm=I;function C(w,A){if(w.byteLength!==1)return!1;switch(w.readUInt8(0)){case 1:return A===0;case 2:return A===1;case 3:return A===2;default:return!1}}e.$em=C;var p;(function(w){w.Start="START_NATIVE_LOG",w.End="END_NATIVE_LOG"})(p||(e.NativeLogMarkers=p={}))}),define(be[278],we([1,0,6,5,13,266,277,57,38,22,4,2,201]),function(ue,e,y,R,r,L,I,C,p,w,A,k,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LM=e.$KM=e.$JM=e.$IM=void 0;let u=class extends k.$Sc{constructor(h,g){super(),this.s=h,this.t=g,this.a=this.B(new R.$Od),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new R.$Od),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=A.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=g.createLogger(this.m,{id:p.$to,name:(0,v.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(g.onDidChangeLogLevel(l=>{(0,r.$aj)(l)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===r.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(h,g,l){const $=this.getTelemetryDetails(),c=new b(g,l,h,this.n,this.j,this.getBuiltInCommonProperties(h),{isUsageEnabled:$.isUsageEnabled,isErrorsEnabled:$.isErrorsEnabled}),n=this.r.get(h.identifier.value)??[];return this.r.set(h.identifier.value,[...n,c]),c.apiTelemetryLogger}$initializeTelemetryLevel(h,g,l){this.f=h,this.g=g,this.c=l??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(h){const g=Object.create(null);switch(g["common.extname"]=`${h.publisher}.${h.name}`,g["common.extversion"]=h.version,g["common.vscodemachineid"]=this.s.telemetryInfo.machineId,g["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,g["common.vscodeversion"]=this.s.version,g["common.isnewappinstall"]=m(this.s.telemetryInfo.firstSessionDate),g["common.product"]=this.s.environment.appHost,this.s.uiKind){case I.UIKind.Web:g["common.uikind"]="web";break;case I.UIKind.Desktop:g["common.uikind"]="desktop";break;default:g["common.uikind"]="unknown"}return g["common.remotename"]=(0,C.$Wk)((0,p.$Ao)(this.s.remote.authority)),g}$onDidChangeTelemetryLevel(h){this.h=this.getTelemetryConfiguration(),this.f=h;const g=this.getTelemetryDetails();this.r.forEach((l,$)=>{const c=l.filter(n=>!n.isDisposed);c.length===0?this.r.delete($):this.r.set($,c)}),this.r.forEach(l=>{for(const $ of l)$.updateTelemetryEnablements(g.isUsageEnabled,g.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(h,g){const $=this.r.get(h.value)?.filter(n=>!n.isDisposed);if(!$)return this.r.delete(h.value),!1;let c=!1;for(const n of $)n.ignoreUnhandledExtHostErrors||(n.logError(g),c=!0);return c}};e.$IM=u,e.$IM=u=Re([Ae(0,L.$HM),Ae(1,r.$_i)],u);class b{static validateSender(h){if(typeof h!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof h.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof h.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof h.flush<"u"&&typeof h.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(h,g,l,$,c,n,i){this.g=l,this.h=$,this.i=c,this.j=n,this.a=new R.$Od,this.ignoreUnhandledExtHostErrors=g?.ignoreUnhandledErrors??!1,this.b=g?.ignoreBuiltInCommonProperties??!1,this.c=g?.additionalCommonProperties,this.f=h,this.d={isUsageEnabled:i.isUsageEnabled,isErrorsEnabled:i.isErrorsEnabled}}updateTelemetryEnablements(h,g){this.e&&(this.d={isUsageEnabled:h,isErrorsEnabled:g},this.a.fire(this.e))}mixInCommonPropsAndCleanData(h){let g="properties"in h?h.properties??{}:h;return g=(0,p.$Do)(g,[]),this.c&&(g=(0,w.$_m)(g,this.c)),this.b||(g=(0,w.$_m)(g,this.j)),"properties"in h?h.properties=g:h=g,h}k(h,g){this.f&&(this.g.publisher==="vscode"?h=this.g.name+"/"+h:h=this.g.identifier.value+"/"+h,g=this.mixInCommonPropsAndCleanData(g||{}),this.i||this.f?.sendEventData(h,g),this.h.trace(h,g))}logUsage(h,g){this.d.isUsageEnabled&&this.k(h,g)}logError(h,g){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof h=="string")this.k(h,g);else{const l={name:h.name,message:h.message,stack:h.stack,cause:h.cause},$=(0,p.$Do)(l,[]),c=new Error($.message,{cause:$.cause});c.stack=$.stack,c.name=$.name,g=this.mixInCommonPropsAndCleanData(g||{}),this.i||this.f.sendErrorData(c,g),this.h.trace("exception",g)}}get apiTelemetryLogger(){if(!this.e){const h=this,g={logUsage:h.logUsage.bind(h),get isUsageEnabled(){return h.d.isUsageEnabled},get isErrorsEnabled(){return h.d.isErrorsEnabled},logError:h.logError.bind(h),dispose:h.dispose.bind(h),onDidChangeEnableStates:h.a.event.bind(h)};this.e=Object.freeze(g)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let h=this.f;this.f=void 0,Promise.resolve(h.flush()).then(h=void 0),this.e=void 0}else this.f=void 0}}e.$JM=b;function m(d){const h=Date.now()-new Date(d).getTime();return isNaN(h)?!1:h<1e3*60*60*24}e.$KM=m,e.$LM=(0,y.$Qh)("IExtHostTelemetry")}),define(be[279],we([1,0,5,4,36,230,35,6]),function(ue,e,y,R,r,L,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rF=e.$qF=e.$pF=e.ActivationKind=e.$oF=e.$nF=e.$mF=e.$lF=e.$kF=e.ExtensionHostStartup=e.$jF=e.$iF=e.$hF=e.$gF=void 0,e.$gF=Object.freeze({identifier:new I.$8l("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:R.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$hF="extensions.webWorker",e.$iF=(0,C.$Qh)("extensionService");class p{constructor(c){this.dependency=c}}e.$jF=p;var w;(function($){$[$.EagerAutoStart=1]="EagerAutoStart",$[$.EagerManualStart=2]="EagerManualStart",$[$.Lazy=3]="Lazy"})(w||(e.ExtensionHostStartup=w={}));class A{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(c,n,i){this.c=c,this.d=n.slice(0),this.e=i.slice(0)}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:L.$4E.createActivationEventsMap(this.d)}}set(c,n,i){if(this.c>c)throw new Error(`ExtensionHostExtensions: invalid versionId ${c} (current: ${this.c})`);const o=[],s=[],t=[],a=[],f=k(this.d),S=k(n),D=(se,G)=>se.extensionLocation.toString()===G.extensionLocation.toString()||se.isBuiltin===G.isBuiltin||se.isUserBuiltin===G.isUserBuiltin||se.isUnderDevelopment===G.isUnderDevelopment;for(const se of this.d){const G=S.get(se.identifier);if(!G){o.push(se.identifier),f.delete(se.identifier);continue}if(!D(se,G)){o.push(se.identifier),f.delete(se.identifier);continue}}for(const se of n){const G=f.get(se.identifier);if(!G){s.push(se);continue}if(!D(G,se)){o.push(G.identifier),f.delete(G.identifier);continue}}const E=new I.$9l(this.e),P=new I.$9l(i);for(const se of this.e)P.has(se)||t.push(se);for(const se of i)E.has(se)||a.push(se);const M=L.$4E.createActivationEventsMap(s),ee={versionId:c,toRemove:o,toAdd:s,addActivationEvents:M,myToRemove:t,myToAdd:a};return this.delta(ee),ee}delta(c){if(this.c>=c.versionId)return null;const{toRemove:n,toAdd:i,myToRemove:o,myToAdd:s}=c,t=new I.$9l(n),a=new I.$9l(o);for(let f=0;f<this.d.length;f++)t.has(this.d[f].identifier)&&(this.d.splice(f,1),f--);for(let f=0;f<this.e.length;f++)a.has(this.e[f])&&(this.e.splice(f,1),f--);for(const f of i)this.d.push(f);for(const f of s)this.e.push(f);return c}containsExtension(c){for(const n of this.e)if(I.$8l.equals(n,c))return!0;return!1}}e.$kF=A;function k($){const c=new I.$0l;for(const n of $)c.set(n.identifier,n);return c}function v($,c){return!0}e.$lF=v;function u($,c){if(!v($,c))throw new Error(`Extension '${$.identifier.value}' CANNOT use API proposal: ${c}.
Its package.json#enabledApiProposals-property declares: ${$.enabledApiProposals?.join(", ")??"[]"} but NOT ${c}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${$.identifier.value}`)}e.$mF=u;class b{constructor(c,n,i,o){this.codeLoadingTime=c,this.activateCallTime=n,this.activateResolvedTime=i,this.activationReason=o}}e.$nF=b;class m{constructor(c,n){this.description=c,this.value=n}}e.$oF=m;var d;(function($){$[$.Normal=0]="Normal",$[$.Immediate=1]="Immediate"})(d||(e.ActivationKind=d={}));function h($){return{type:$.isBuiltin?0:1,isBuiltin:$.isBuiltin||$.isUserBuiltin,identifier:{id:(0,r.$Jo)($.publisher,$.name),uuid:$.uuid},manifest:$,location:$.extensionLocation,targetPlatform:$.targetPlatform,validations:[],isValid:!0}}e.$pF=h;function g($,c){return{identifier:new I.$8l((0,r.$Ho)($.manifest.publisher,$.manifest.name)),isBuiltin:$.type===0,isUserBuiltin:$.type===1&&$.isBuiltin,isUnderDevelopment:!!c,extensionLocation:$.location,...$.manifest,uuid:$.identifier.uuid,targetPlatform:$.targetPlatform}}e.$qF=g;class l{constructor(){this.onDidRegisterExtensions=y.Event.None,this.onDidChangeExtensionsStatus=y.Event.None,this.onDidChangeExtensions=y.Event.None,this.onWillActivateByEvent=y.Event.None,this.onDidChangeResponsiveChange=y.Event.None,this.onWillStop=y.Event.None,this.extensions=[]}activateByEvent(c){return Promise.resolve(void 0)}activationEventIsDone(c){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(c){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(c,n){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(c){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$rF=l}),define(be[136],we([1,0,18,15,153,74,100,26,143,50,59,22,8,4,43,171,226,133,92,130,71,93,135,131,279]),function(ue,e,y,R,r,L,I,C,p,w,A,k,v,u,b,m,d,h,g,l,$,c,n,i,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalQuickFix=e.ChatResponseProgress=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.ChatMessageRole=e.ChatMessage=e.ChatFollowup=e.ChatReplyFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.$qM=e.$pM=e.MarkdownString=e.$oM=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var s;(function(ye){function De(K){const{selectionStartLineNumber:Se,selectionStartColumn:Le,positionLineNumber:Ve,positionColumn:Ue}=K,Ye=new i.$tK(Se-1,Le-1),at=new i.$tK(Ve-1,Ue-1);return new i.$vK(Ye,at)}ye.to=De;function de(K){const{anchor:Se,active:Le}=K;return{selectionStartLineNumber:Se.line+1,selectionStartColumn:Se.character+1,positionLineNumber:Le.line+1,positionColumn:Le.character+1}}ye.from=de})(s||(e.Selection=s={}));var t;(function(ye){function De(K){if(!K)return;const{start:Se,end:Le}=K;return{startLineNumber:Se.line+1,startColumn:Se.character+1,endLineNumber:Le.line+1,endColumn:Le.character+1}}ye.from=De;function de(K){if(!K)return;const{startLineNumber:Se,startColumn:Le,endLineNumber:Ve,endColumn:Ue}=K;return new i.$uK(Se-1,Le-1,Ve-1,Ue-1)}ye.to=de})(t||(e.Range=t={}));var a;(function(ye){function De(de){switch(de){case 1:return i.StandardTokenType.Comment;case 0:return i.StandardTokenType.Other;case 3:return i.StandardTokenType.RegEx;case 2:return i.StandardTokenType.String}}ye.to=De})(a||(e.TokenType=a={}));var f;(function(ye){function De(K){return new i.$tK(K.lineNumber-1,K.column-1)}ye.to=De;function de(K){return{lineNumber:K.line+1,column:K.character+1}}ye.from=de})(f||(e.Position=f={}));var S;(function(ye){function De(Se,Le,Ve){return(0,y.$Hb)((0,y.$3b)(Se).map(Ue=>de(Ue,Le,Ve)))}ye.from=De;function de(Se,Le,Ve){if(typeof Se=="string")return{$serialized:!0,language:Se,isBuiltin:Ve?.isBuiltin};if(Se)return{$serialized:!0,language:Se.language,scheme:K(Se.scheme,Le),pattern:Te.from(Se.pattern)??void 0,exclusive:Se.exclusive,notebookType:Se.notebookType,isBuiltin:Ve?.isBuiltin}}function K(Se,Le){return Le&&typeof Se=="string"?Le.transformOutgoingScheme(Se):Se}})(S||(e.DocumentSelector=S={}));var D;(function(ye){function De(K){switch(K){case i.DiagnosticTag.Unnecessary:return 1;case i.DiagnosticTag.Deprecated:return 2}}ye.from=De;function de(K){switch(K){case 1:return i.DiagnosticTag.Unnecessary;case 2:return i.DiagnosticTag.Deprecated;default:return}}ye.to=de})(D||(e.DiagnosticTag=D={}));var E;(function(ye){function De(K){let Se;return K.code&&((0,v.$zf)(K.code)||(0,v.$Df)(K.code)?Se=String(K.code):Se={value:String(K.code.value),target:K.code.target}),{...t.from(K.range),message:K.message,source:K.source,code:Se,severity:M.from(K.severity),relatedInformation:K.relatedInformation&&K.relatedInformation.map(P.from),tags:Array.isArray(K.tags)?(0,y.$Hb)(K.tags.map(D.from)):void 0}}ye.from=De;function de(K){const Se=new i.$GK(t.to(K),K.message,M.to(K.severity));return Se.source=K.source,Se.code=(0,v.$zf)(K.code)?K.code:K.code?.value,Se.relatedInformation=K.relatedInformation&&K.relatedInformation.map(P.to),Se.tags=K.tags&&(0,y.$Hb)(K.tags.map(D.to)),Se}ye.to=de})(E||(e.Diagnostic=E={}));var P;(function(ye){function De(K){return{...t.from(K.location.range),message:K.message,resource:K.location.uri}}ye.from=De;function de(K){return new i.$FK(new i.$EK(K.resource,t.to(K)),K.message)}ye.to=de})(P||(e.DiagnosticRelatedInformation=P={}));var M;(function(ye){function De(K){switch(K){case i.DiagnosticSeverity.Error:return d.MarkerSeverity.Error;case i.DiagnosticSeverity.Warning:return d.MarkerSeverity.Warning;case i.DiagnosticSeverity.Information:return d.MarkerSeverity.Info;case i.DiagnosticSeverity.Hint:return d.MarkerSeverity.Hint}return d.MarkerSeverity.Error}ye.from=De;function de(K){switch(K){case d.MarkerSeverity.Info:return i.DiagnosticSeverity.Information;case d.MarkerSeverity.Warning:return i.DiagnosticSeverity.Warning;case d.MarkerSeverity.Error:return i.DiagnosticSeverity.Error;case d.MarkerSeverity.Hint:return i.DiagnosticSeverity.Hint;default:return i.DiagnosticSeverity.Error}}ye.to=de})(M||(e.DiagnosticSeverity=M={}));var ee;(function(ye){function De(K){return typeof K=="number"&&K>=i.ViewColumn.One?K-1:K===i.ViewColumn.Beside?n.$yC:n.$xC}ye.from=De;function de(K){if(typeof K=="number"&&K>=0)return K+1;throw new Error("invalid 'EditorGroupColumn'")}ye.to=de})(ee||(e.ViewColumn=ee={}));function se(ye){return typeof ye.range<"u"}function G(ye){return ye.length===0?!0:!!se(ye[0])}e.$oM=G;var ne;(function(ye){function De(Ue){return Ue.map(ye.from)}ye.fromMany=De;function de(Ue){return Ue&&typeof Ue=="object"&&typeof Ue.language=="string"&&typeof Ue.value=="string"}function K(Ue){let Ye;if(de(Ue)){const{language:ot,value:dt}=Ue;Ye={value:"```"+ot+`
`+dt+"\n```\n"}}else i.$SK.isMarkdownString(Ue)?Ye={value:Ue.value,isTrusted:Ue.isTrusted,supportThemeIcons:Ue.supportThemeIcons,supportHtml:Ue.supportHtml,baseUri:Ue.baseUri}:typeof Ue=="string"?Ye={value:Ue}:Ye={value:""};const at=Object.create(null);Ye.uris=at;const ct=ot=>{try{let dt=u.URI.parse(ot,!0);dt=dt.with({query:Se(dt.query,at)}),at[ot]=dt}catch{}return""},yt=new p.marked.Renderer;return yt.link=ct,yt.image=ot=>typeof ot=="string"?ct(I.$$j(ot).href):"",(0,p.marked)(Ye.value,{renderer:yt}),Ye}ye.from=K;function Se(Ue,Ye){if(!Ue)return Ue;let at;try{at=(0,w.$mh)(Ue)}catch{}if(!at)return Ue;let ct=!1;return at=(0,k.$$m)(at,yt=>{if(u.URI.isUri(yt)){const ot=`__uri_${Math.random().toString(16).slice(2,8)}`;return Ye[ot]=yt,ct=!0,ot}else return}),ct?JSON.stringify(at):Ue}function Le(Ue){const Ye=new i.$SK(Ue.value,Ue.supportThemeIcons);return Ye.isTrusted=Ue.isTrusted,Ye.supportHtml=Ue.supportHtml,Ye.baseUri=Ue.baseUri?u.URI.from(Ue.baseUri):void 0,Ye}ye.to=Le;function Ve(Ue){if(Ue)return typeof Ue=="string"?Ue:ye.from(Ue)}ye.fromStrict=Ve})(ne||(e.MarkdownString=ne={}));function he(ye){return G(ye)?ye.map(De=>({range:t.from(De.range),hoverMessage:Array.isArray(De.hoverMessage)?ne.fromMany(De.hoverMessage):De.hoverMessage?ne.from(De.hoverMessage):void 0,renderOptions:De.renderOptions})):ye.map(De=>({range:t.from(De)}))}e.$pM=he;function Z(ye){return typeof ye>"u"?ye:typeof ye=="string"?u.URI.file(ye):ye}e.$qM=Z;var fe;(function(ye){function De(de){return typeof de>"u"?de:{contentText:de.contentText,contentIconPath:de.contentIconPath?Z(de.contentIconPath):void 0,border:de.border,borderColor:de.borderColor,fontStyle:de.fontStyle,fontWeight:de.fontWeight,textDecoration:de.textDecoration,color:de.color,backgroundColor:de.backgroundColor,margin:de.margin,width:de.width,height:de.height}}ye.from=De})(fe||(e.ThemableDecorationAttachmentRenderOptions=fe={}));var V;(function(ye){function De(de){return typeof de>"u"?de:{backgroundColor:de.backgroundColor,outline:de.outline,outlineColor:de.outlineColor,outlineStyle:de.outlineStyle,outlineWidth:de.outlineWidth,border:de.border,borderColor:de.borderColor,borderRadius:de.borderRadius,borderSpacing:de.borderSpacing,borderStyle:de.borderStyle,borderWidth:de.borderWidth,fontStyle:de.fontStyle,fontWeight:de.fontWeight,textDecoration:de.textDecoration,cursor:de.cursor,color:de.color,opacity:de.opacity,letterSpacing:de.letterSpacing,gutterIconPath:de.gutterIconPath?Z(de.gutterIconPath):void 0,gutterIconSize:de.gutterIconSize,overviewRulerColor:de.overviewRulerColor,before:de.before?fe.from(de.before):void 0,after:de.after?fe.from(de.after):void 0}}ye.from=De})(V||(e.ThemableDecorationRenderOptions=V={}));var ie;(function(ye){function De(de){if(typeof de>"u")return de;switch(de){case i.DecorationRangeBehavior.OpenOpen:return 0;case i.DecorationRangeBehavior.ClosedClosed:return 1;case i.DecorationRangeBehavior.OpenClosed:return 2;case i.DecorationRangeBehavior.ClosedOpen:return 3}}ye.from=De})(ie||(e.DecorationRangeBehavior=ie={}));var Y;(function(ye){function De(de){return{isWholeLine:de.isWholeLine,rangeBehavior:de.rangeBehavior?ie.from(de.rangeBehavior):void 0,overviewRulerLane:de.overviewRulerLane,light:de.light?V.from(de.light):void 0,dark:de.dark?V.from(de.dark):void 0,backgroundColor:de.backgroundColor,outline:de.outline,outlineColor:de.outlineColor,outlineStyle:de.outlineStyle,outlineWidth:de.outlineWidth,border:de.border,borderColor:de.borderColor,borderRadius:de.borderRadius,borderSpacing:de.borderSpacing,borderStyle:de.borderStyle,borderWidth:de.borderWidth,fontStyle:de.fontStyle,fontWeight:de.fontWeight,textDecoration:de.textDecoration,cursor:de.cursor,color:de.color,opacity:de.opacity,letterSpacing:de.letterSpacing,gutterIconPath:de.gutterIconPath?Z(de.gutterIconPath):void 0,gutterIconSize:de.gutterIconSize,overviewRulerColor:de.overviewRulerColor,before:de.before?fe.from(de.before):void 0,after:de.after?fe.from(de.after):void 0}}ye.from=De})(Y||(e.DecorationRenderOptions=Y={}));var J;(function(ye){function De(K){return{text:K.newText,eol:K.newEol&&Xe.from(K.newEol),range:t.from(K.range)}}ye.from=De;function de(K){const Se=new i.$zK(t.to(K.range),K.text);return Se.newEol=typeof K.eol>"u"?void 0:Xe.to(K.eol),Se}ye.to=de})(J||(e.TextEdit=J={}));var re;(function(ye){function De(K,Se){const Le={edits:[]};if(K instanceof i.$CK){const Ve=new C.$Bc;for(const Ue of K._allEntries())Ue._type===1&&u.URI.isUri(Ue.to)&&Ue.from===void 0&&Ve.add(Ue.to);for(const Ue of K._allEntries())if(Ue._type===1){let Ye;Ue.options?.contents&&(ArrayBuffer.isView(Ue.options.contents)?Ye={type:"base64",value:(0,R.$we)(R.$ce.wrap(Ue.options.contents))}:Ye={type:"dataTransferItem",id:Ue.options.contents._itemId}),Le.edits.push({oldResource:Ue.from,newResource:Ue.to,options:{...Ue.options,contents:Ye},metadata:Ue.metadata})}else Ue._type===2?Le.edits.push({resource:Ue.uri,textEdit:J.from(Ue.edit),versionId:Ve.has(Ue.uri)?void 0:Se?.getTextDocumentVersion(Ue.uri),metadata:Ue.metadata}):Ue._type===6?Le.edits.push({resource:Ue.uri,textEdit:{range:t.from(Ue.range),text:Ue.edit.value,insertAsSnippet:!0},versionId:Ve.has(Ue.uri)?void 0:Se?.getTextDocumentVersion(Ue.uri),metadata:Ue.metadata}):Ue._type===3?Le.edits.push({metadata:Ue.metadata,resource:Ue.uri,cellEdit:Ue.edit,notebookMetadata:Ue.notebookMetadata,notebookVersionId:Se?.getNotebookDocumentVersion(Ue.uri)}):Ue._type===5&&Le.edits.push({metadata:Ue.metadata,resource:Ue.uri,notebookVersionId:Se?.getNotebookDocumentVersion(Ue.uri),cellEdit:{editType:1,index:Ue.index,count:Ue.count,cells:Ue.cells.map(et.from)}})}return Le}ye.from=De;function de(K){const Se=new i.$CK,Le=new C.$Ac;for(const Ve of K.edits)if(Ve.textEdit){const Ue=Ve,Ye=u.URI.revive(Ue.resource),at=t.to(Ue.textEdit.range),ct=Ue.textEdit.text,yt=Ue.textEdit.insertAsSnippet;let ot;yt?ot=i.$BK.replace(at,new i.$DK(ct)):ot=i.$zK.replace(at,ct);const dt=Le.get(Ye);dt?dt.push(ot):Le.set(Ye,[ot])}else Se.renameFile(u.URI.revive(Ve.oldResource),u.URI.revive(Ve.newResource),Ve.options);for(const[Ve,Ue]of Le)Se.set(Ve,Ue);return Se}ye.to=de})(re||(e.WorkspaceEdit=re={}));var ce;(function(ye){const De=Object.create(null);De[i.SymbolKind.File]=0,De[i.SymbolKind.Module]=1,De[i.SymbolKind.Namespace]=2,De[i.SymbolKind.Package]=3,De[i.SymbolKind.Class]=4,De[i.SymbolKind.Method]=5,De[i.SymbolKind.Property]=6,De[i.SymbolKind.Field]=7,De[i.SymbolKind.Constructor]=8,De[i.SymbolKind.Enum]=9,De[i.SymbolKind.Interface]=10,De[i.SymbolKind.Function]=11,De[i.SymbolKind.Variable]=12,De[i.SymbolKind.Constant]=13,De[i.SymbolKind.String]=14,De[i.SymbolKind.Number]=15,De[i.SymbolKind.Boolean]=16,De[i.SymbolKind.Array]=17,De[i.SymbolKind.Object]=18,De[i.SymbolKind.Key]=19,De[i.SymbolKind.Null]=20,De[i.SymbolKind.EnumMember]=21,De[i.SymbolKind.Struct]=22,De[i.SymbolKind.Event]=23,De[i.SymbolKind.Operator]=24,De[i.SymbolKind.TypeParameter]=25;function de(Se){return typeof De[Se]=="number"?De[Se]:6}ye.from=de;function K(Se){for(const Le in De)if(De[Le]===Se)return Number(Le);return i.SymbolKind.Property}ye.to=K})(ce||(e.SymbolKind=ce={}));var oe;(function(ye){function De(K){switch(K){case i.SymbolTag.Deprecated:return 1}}ye.from=De;function de(K){switch(K){case 1:return i.SymbolTag.Deprecated}}ye.to=de})(oe||(e.SymbolTag=oe={}));var _;(function(ye){function De(K){return{name:K.name,kind:ce.from(K.kind),tags:K.tags&&K.tags.map(oe.from),containerName:K.containerName,location:U.from(K.location)}}ye.from=De;function de(K){const Se=new i.$JK(K.name,ce.to(K.kind),K.containerName,U.to(K.location));return Se.tags=K.tags&&K.tags.map(oe.to),Se}ye.to=de})(_||(e.WorkspaceSymbol=_={}));var q;(function(ye){function De(K){const Se={name:K.name||"!!MISSING: name!!",detail:K.detail,range:t.from(K.range),selectionRange:t.from(K.selectionRange),kind:ce.from(K.kind),tags:K.tags?.map(oe.from)??[]};return K.children&&(Se.children=K.children.map(De)),Se}ye.from=De;function de(K){const Se=new i.$KK(K.name,K.detail,ce.to(K.kind),t.to(K.range),t.to(K.selectionRange));return(0,y.$Lb)(K.tags)&&(Se.tags=K.tags.map(oe.to)),K.children&&(Se.children=K.children.map(de)),Se}ye.to=de})(q||(e.DocumentSymbol=q={}));var Q;(function(ye){function De(K){const Se=new i.$OK(ce.to(K.kind),K.name,K.detail||"",u.URI.revive(K.uri),t.to(K.range),t.to(K.selectionRange));return Se._sessionId=K._sessionId,Se._itemId=K._itemId,Se}ye.to=De;function de(K,Se,Le){if(Se=Se??K._sessionId,Le=Le??K._itemId,Se===void 0||Le===void 0)throw new Error("invalid item");return{_sessionId:Se,_itemId:Le,name:K.name,detail:K.detail,kind:ce.from(K.kind),uri:K.uri,range:t.from(K.range),selectionRange:t.from(K.selectionRange),tags:K.tags?.map(oe.from)}}ye.from=de})(Q||(e.CallHierarchyItem=Q={}));var O;(function(ye){function De(de){return new i.$PK(Q.to(de.from),de.fromRanges.map(K=>t.to(K)))}ye.to=De})(O||(e.CallHierarchyIncomingCall=O={}));var N;(function(ye){function De(de){return new i.$QK(Q.to(de.to),de.fromRanges.map(K=>t.to(K)))}ye.to=De})(N||(e.CallHierarchyOutgoingCall=N={}));var U;(function(ye){function De(K){return{range:K.range&&t.from(K.range),uri:K.uri}}ye.from=De;function de(K){return new i.$EK(u.URI.revive(K.uri),t.to(K.range))}ye.to=de})(U||(e.location=U={}));var T;(function(ye){function De(K){const Se=K,Le=K;return{originSelectionRange:Se.originSelectionRange?t.from(Se.originSelectionRange):void 0,uri:Se.targetUri?Se.targetUri:Le.uri,range:t.from(Se.targetRange?Se.targetRange:Le.range),targetSelectionRange:Se.targetSelectionRange?t.from(Se.targetSelectionRange):void 0}}ye.from=De;function de(K){return{targetUri:u.URI.revive(K.uri),targetRange:t.to(K.range),targetSelectionRange:K.targetSelectionRange?t.to(K.targetSelectionRange):void 0,originSelectionRange:K.originSelectionRange?t.to(K.originSelectionRange):void 0}}ye.to=de})(T||(e.DefinitionLink=T={}));var z;(function(ye){function De(K){return{range:t.from(K.range),contents:ne.fromMany(K.contents)}}ye.from=De;function de(K){return new i.$HK(K.contents.map(ne.to),t.to(K.range))}ye.to=de})(z||(e.Hover=z={}));var B;(function(ye){function De(K){return{range:t.from(K.range),expression:K.expression}}ye.from=De;function de(K){return new i.$AL(t.to(K.range),K.expression)}ye.to=de})(B||(e.EvaluatableExpression=B={}));var te;(function(ye){function De(K){if(K instanceof i.$BL)return{type:"text",range:t.from(K.range),text:K.text};if(K instanceof i.$CL)return{type:"variable",range:t.from(K.range),variableName:K.variableName,caseSensitiveLookup:K.caseSensitiveLookup};if(K instanceof i.$DL)return{type:"expression",range:t.from(K.range),expression:K.expression};throw new Error("Unknown 'InlineValue' type")}ye.from=De;function de(K){switch(K.type){case"text":return{range:t.to(K.range),text:K.text};case"variable":return{range:t.to(K.range),variableName:K.variableName,caseSensitiveLookup:K.caseSensitiveLookup};case"expression":return{range:t.to(K.range),expression:K.expression}}}ye.to=de})(te||(e.InlineValue=te={}));var H;(function(ye){function De(K){return{frameId:K.frameId,stoppedLocation:t.from(K.stoppedLocation)}}ye.from=De;function de(K){return new i.$EL(K.frameId,t.to(K.stoppedLocation))}ye.to=de})(H||(e.InlineValueContext=H={}));var x;(function(ye){function De(K){return{range:t.from(K.range),kind:K.kind}}ye.from=De;function de(K){return new i.$IK(t.to(K.range),K.kind)}ye.to=de})(x||(e.DocumentHighlight=x={}));var W;(function(ye){function De(de){switch(de){case 1:return i.CompletionTriggerKind.TriggerCharacter;case 2:return i.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return i.CompletionTriggerKind.Invoke}}ye.to=De})(W||(e.CompletionTriggerKind=W={}));var X;(function(ye){function De(de){return{triggerKind:W.to(de.triggerKind),triggerCharacter:de.triggerCharacter}}ye.to=De})(X||(e.CompletionContext=X={}));var ae;(function(ye){function De(K){switch(K){case i.CompletionItemTag.Deprecated:return 1}}ye.from=De;function de(K){switch(K){case 1:return i.CompletionItemTag.Deprecated}}ye.to=de})(ae||(e.CompletionItemTag=ae={}));var ge;(function(ye){const De=new Map([[i.CompletionItemKind.Method,0],[i.CompletionItemKind.Function,1],[i.CompletionItemKind.Constructor,2],[i.CompletionItemKind.Field,3],[i.CompletionItemKind.Variable,4],[i.CompletionItemKind.Class,5],[i.CompletionItemKind.Interface,7],[i.CompletionItemKind.Struct,6],[i.CompletionItemKind.Module,8],[i.CompletionItemKind.Property,9],[i.CompletionItemKind.Unit,12],[i.CompletionItemKind.Value,13],[i.CompletionItemKind.Constant,14],[i.CompletionItemKind.Enum,15],[i.CompletionItemKind.EnumMember,16],[i.CompletionItemKind.Keyword,17],[i.CompletionItemKind.Snippet,27],[i.CompletionItemKind.Text,18],[i.CompletionItemKind.Color,19],[i.CompletionItemKind.File,20],[i.CompletionItemKind.Reference,21],[i.CompletionItemKind.Folder,23],[i.CompletionItemKind.Event,10],[i.CompletionItemKind.Operator,11],[i.CompletionItemKind.TypeParameter,24],[i.CompletionItemKind.Issue,26],[i.CompletionItemKind.User,25]]);function de(Le){return De.get(Le)??9}ye.from=de;const K=new Map([[0,i.CompletionItemKind.Method],[1,i.CompletionItemKind.Function],[2,i.CompletionItemKind.Constructor],[3,i.CompletionItemKind.Field],[4,i.CompletionItemKind.Variable],[5,i.CompletionItemKind.Class],[7,i.CompletionItemKind.Interface],[6,i.CompletionItemKind.Struct],[8,i.CompletionItemKind.Module],[9,i.CompletionItemKind.Property],[12,i.CompletionItemKind.Unit],[13,i.CompletionItemKind.Value],[14,i.CompletionItemKind.Constant],[15,i.CompletionItemKind.Enum],[16,i.CompletionItemKind.EnumMember],[17,i.CompletionItemKind.Keyword],[27,i.CompletionItemKind.Snippet],[18,i.CompletionItemKind.Text],[19,i.CompletionItemKind.Color],[20,i.CompletionItemKind.File],[21,i.CompletionItemKind.Reference],[23,i.CompletionItemKind.Folder],[10,i.CompletionItemKind.Event],[11,i.CompletionItemKind.Operator],[24,i.CompletionItemKind.TypeParameter],[25,i.CompletionItemKind.User],[26,i.CompletionItemKind.Issue]]);function Se(Le){return K.get(Le)??i.CompletionItemKind.Property}ye.to=Se})(ge||(e.CompletionItemKind=ge={}));var Ee;(function(ye){function De(de,K){const Se=new i.$YK(de.label);return Se.insertText=de.insertText,Se.kind=ge.to(de.kind),Se.tags=de.tags?.map(ae.to),Se.detail=de.detail,Se.documentation=I.$6j(de.documentation)?ne.to(de.documentation):de.documentation,Se.sortText=de.sortText,Se.filterText=de.filterText,Se.preselect=de.preselect,Se.commitCharacters=de.commitCharacters,b.$ys.isIRange(de.range)?Se.range=t.to(de.range):typeof de.range=="object"&&(Se.range={inserting:t.to(de.range.insert),replacing:t.to(de.range.replace)}),Se.keepWhitespace=typeof de.insertTextRules>"u"?!1:!!(de.insertTextRules&1),typeof de.insertTextRules<"u"&&de.insertTextRules&4?Se.insertText=new i.$DK(de.insertText):(Se.insertText=de.insertText,Se.textEdit=Se.range instanceof i.$uK?new i.$zK(Se.range,Se.insertText):void 0),de.additionalTextEdits&&de.additionalTextEdits.length>0&&(Se.additionalTextEdits=de.additionalTextEdits.map(Le=>J.to(Le))),Se.command=K&&de.command?K.fromInternal(de.command):void 0,Se}ye.to=De})(Ee||(e.CompletionItem=Ee={}));var Ce;(function(ye){function De(K){if(typeof K.label!="string"&&!Array.isArray(K.label))throw new TypeError("Invalid label");return{label:K.label,documentation:ne.fromStrict(K.documentation)}}ye.from=De;function de(K){return{label:K.label,documentation:I.$6j(K.documentation)?ne.to(K.documentation):K.documentation}}ye.to=de})(Ce||(e.ParameterInformation=Ce={}));var Ne;(function(ye){function De(K){return{label:K.label,documentation:ne.fromStrict(K.documentation),parameters:Array.isArray(K.parameters)?K.parameters.map(Ce.from):[],activeParameter:K.activeParameter}}ye.from=De;function de(K){return{label:K.label,documentation:I.$6j(K.documentation)?ne.to(K.documentation):K.documentation,parameters:Array.isArray(K.parameters)?K.parameters.map(Ce.to):[],activeParameter:K.activeParameter}}ye.to=de})(Ne||(e.SignatureInformation=Ne={}));var Fe;(function(ye){function De(K){return{activeSignature:K.activeSignature,activeParameter:K.activeParameter,signatures:Array.isArray(K.signatures)?K.signatures.map(Ne.from):[]}}ye.from=De;function de(K){return{activeSignature:K.activeSignature,activeParameter:K.activeParameter,signatures:Array.isArray(K.signatures)?K.signatures.map(Ne.to):[]}}ye.to=de})(Fe||(e.SignatureHelp=Fe={}));var $e;(function(ye){function De(de,K){const Se=new i.$XK(f.to(K.position),typeof K.label=="string"?K.label:K.label.map(ke.to.bind(void 0,de)),K.kind&&ve.to(K.kind));return Se.textEdits=K.textEdits&&K.textEdits.map(J.to),Se.tooltip=I.$6j(K.tooltip)?ne.to(K.tooltip):K.tooltip,Se.paddingLeft=K.paddingLeft,Se.paddingRight=K.paddingRight,Se}ye.to=De})($e||(e.InlayHint=$e={}));var ke;(function(ye){function De(de,K){const Se=new i.$WK(K.label);return Se.tooltip=I.$6j(K.tooltip)?ne.to(K.tooltip):K.tooltip,m.Command.is(K.command)&&(Se.command=de.fromInternal(K.command)),K.location&&(Se.location=U.to(K.location)),Se}ye.to=De})(ke||(e.InlayHintLabelPart=ke={}));var ve;(function(ye){function De(K){return K}ye.from=De;function de(K){return K}ye.to=de})(ve||(e.InlayHintKind=ve={}));var je;(function(ye){function De(K){return{range:t.from(K.range),url:K.target,tooltip:K.tooltip}}ye.from=De;function de(K){let Se;if(K.url)try{Se=typeof K.url=="string"?u.URI.parse(K.url,!0):u.URI.revive(K.url)}catch{}return new i.$4K(t.to(K.range),Se)}ye.to=de})(je||(e.DocumentLink=je={}));var Be;(function(ye){function De(K){const Se=new i.$7K(K.label);return K.textEdit&&(Se.textEdit=J.to(K.textEdit)),K.additionalTextEdits&&(Se.additionalTextEdits=K.additionalTextEdits.map(Le=>J.to(Le))),Se}ye.to=De;function de(K){return{label:K.label,textEdit:K.textEdit?J.from(K.textEdit):void 0,additionalTextEdits:K.additionalTextEdits?K.additionalTextEdits.map(Se=>J.from(Se)):void 0}}ye.from=de})(Be||(e.ColorPresentation=Be={}));var Ze;(function(ye){function De(K){return new i.$5K(K[0],K[1],K[2],K[3])}ye.to=De;function de(K){return[K.red,K.green,K.blue,K.alpha]}ye.from=de})(Ze||(e.Color=Ze={}));var qe;(function(ye){function De(K){return{range:t.from(K.range)}}ye.from=De;function de(K){return new i.$NK(t.to(K.range))}ye.to=de})(qe||(e.SelectionRange=qe={}));var Qe;(function(ye){function De(de){switch(de){case 2:return i.TextDocumentSaveReason.AfterDelay;case 1:return i.TextDocumentSaveReason.Manual;case 3:case 4:return i.TextDocumentSaveReason.FocusOut}}ye.to=De})(Qe||(e.TextDocumentSaveReason=Qe={}));var xe;(function(ye){function De(K){switch(K){case i.TextEditorLineNumbersStyle.Off:return 0;case i.TextEditorLineNumbersStyle.Relative:return 2;case i.TextEditorLineNumbersStyle.On:default:return 1}}ye.from=De;function de(K){switch(K){case 0:return i.TextEditorLineNumbersStyle.Off;case 2:return i.TextEditorLineNumbersStyle.Relative;case 1:default:return i.TextEditorLineNumbersStyle.On}}ye.to=de})(xe||(e.TextEditorLineNumbersStyle=xe={}));var Xe;(function(ye){function De(K){if(K===i.EndOfLine.CRLF)return 1;if(K===i.EndOfLine.LF)return 0}ye.from=De;function de(K){if(K===1)return i.EndOfLine.CRLF;if(K===0)return i.EndOfLine.LF}ye.to=de})(Xe||(e.EndOfLine=Xe={}));var me;(function(ye){function De(de){if(typeof de=="object")return de.viewId;switch(de){case i.ProgressLocation.SourceControl:return 3;case i.ProgressLocation.Window:return 10;case i.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}ye.from=De})(me||(e.ProgressLocation=me={}));var Pe;(function(ye){function De(K){const Se={start:K.start+1,end:K.end+1};return K.kind&&(Se.kind=Ie.from(K.kind)),Se}ye.from=De;function de(K){const Se={start:K.start-1,end:K.end-1};return K.kind&&(Se.kind=Ie.to(K.kind)),Se}ye.to=de})(Pe||(e.FoldingRange=Pe={}));var Ie;(function(ye){function De(K){if(K)switch(K){case i.FoldingRangeKind.Comment:return m.$nt.Comment;case i.FoldingRangeKind.Imports:return m.$nt.Imports;case i.FoldingRangeKind.Region:return m.$nt.Region}}ye.from=De;function de(K){if(K)switch(K.value){case m.$nt.Comment.value:return i.FoldingRangeKind.Comment;case m.$nt.Imports.value:return i.FoldingRangeKind.Imports;case m.$nt.Region.value:return i.FoldingRangeKind.Region}}ye.to=de})(Ie||(e.FoldingRangeKind=Ie={}));var Oe;(function(ye){function De(de){if(de)return{pinned:typeof de.preview=="boolean"?!de.preview:void 0,inactive:de.background,preserveFocus:de.preserveFocus,selection:typeof de.selection=="object"?t.from(de.selection):void 0,override:typeof de.override=="boolean"?g.$ZD.id:void 0}}ye.from=De})(Oe||(e.TextEditorOpenOptions=Oe={}));var Te;(function(ye){function De(Le){return Le instanceof i.$oL?Le.toJSON():typeof Le=="string"?Le:de(Le)||K(Le)?new i.$oL(Le.baseUri??Le.base,Le.pattern).toJSON():Le}ye.from=De;function de(Le){const Ve=Le;return Ve?u.URI.isUri(Ve.baseUri)&&typeof Ve.pattern=="string":!1}function K(Le){const Ve=Le;return Ve?typeof Ve.base=="string"&&typeof Ve.pattern=="string":!1}function Se(Le){return typeof Le=="string"?Le:new i.$oL(u.URI.revive(Le.baseUri),Le.pattern)}ye.to=Se})(Te||(e.GlobPattern=Te={}));var ze;(function(ye){function De(de){if(de){if(Array.isArray(de))return de.map(De);if(typeof de=="string")return de;{const K=de;return{language:K.language,scheme:K.scheme,pattern:Te.from(K.pattern),exclusive:K.exclusive,notebookType:K.notebookType}}}else return}ye.from=De})(ze||(e.LanguageSelector=ze={}));var He;(function(ye){function De(K){return!!K&&typeof K=="object"&&"documents"in K&&Array.isArray(K.documents)&&K.documents.every(Se=>Array.isArray(Se)&&Se.every(Le=>Le&&typeof Le=="object"&&"uri"in Le&&u.URI.isUri(Le.uri)&&"version"in Le&&typeof Le.version=="number"&&"ranges"in Le&&Array.isArray(Le.ranges)&&Le.ranges.every(Ve=>Ve instanceof i.$uK)))}ye.is=De;function de(K){return{documents:K.documents.map(Se=>Se.map(Le=>({uri:u.URI.from(Le.uri),version:Le.version,ranges:Le.ranges.map(Ve=>t.from(Ve))})))}}ye.from=de})(He||(e.MappedEditsContext=He={}));var Ke;(function(ye){function De(K){return{start:K.start,end:K.end}}ye.from=De;function de(K){return new i.$PL(K.start,K.end)}ye.to=de})(Ke||(e.NotebookRange=Ke={}));var Je;(function(ye){function De(K){return{timing:typeof K.runStartTime=="number"&&typeof K.runEndTime=="number"?{startTime:K.runStartTime,endTime:K.runEndTime}:void 0,executionOrder:K.executionOrder,success:K.lastRunSuccess}}ye.to=De;function de(K){return{lastRunSuccess:K.success,runStartTime:K.timing?.startTime,runEndTime:K.timing?.endTime,executionOrder:K.executionOrder}}ye.from=de})(Je||(e.NotebookCellExecutionSummary=Je={}));var We;(function(ye){function De(de){if(de===l.NotebookCellExecutionState.Unconfirmed)return i.NotebookCellExecutionState.Pending;if(de===l.NotebookCellExecutionState.Pending)return;if(de===l.NotebookCellExecutionState.Executing)return i.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${de}`)}ye.to=De})(We||(e.NotebookCellExecutionState=We={}));var it;(function(ye){function De(K){switch(K){case i.NotebookCellKind.Markup:return l.CellKind.Markup;case i.NotebookCellKind.Code:default:return l.CellKind.Code}}ye.from=De;function de(K){switch(K){case l.CellKind.Markup:return i.NotebookCellKind.Markup;case l.CellKind.Code:default:return i.NotebookCellKind.Code}}ye.to=de})(it||(e.NotebookCellKind=it={}));var rt;(function(ye){function De(K){const Se={metadata:K.metadata??Object.create(null),cells:[]};for(const Le of K.cells)i.$QL.validate(Le),Se.cells.push(et.from(Le));return Se}ye.from=De;function de(K){const Se=new i.$RL(K.cells.map(et.to));return(0,v.$Mf)(K.metadata)||(Se.metadata=K.metadata),Se}ye.to=de})(rt||(e.NotebookData=rt={}));var et;(function(ye){function De(K){return{cellKind:it.from(K.kind),language:K.languageId,mime:K.mime,source:K.value,metadata:K.metadata,internalMetadata:Je.from(K.executionSummary??{}),outputs:K.outputs?K.outputs.map(ut.from):[]}}ye.from=De;function de(K){return new i.$QL(it.to(K.cellKind),K.source,K.language,K.mime,K.outputs?K.outputs.map(ut.to):void 0,K.metadata,K.internalMetadata?Je.to(K.internalMetadata):void 0)}ye.to=de})(et||(e.NotebookCellData=et={}));var mt;(function(ye){function De(K){return{mime:K.mime,valueBytes:R.$ce.wrap(K.data)}}ye.from=De;function de(K){return new i.$SL(K.valueBytes.buffer,K.mime)}ye.to=de})(mt||(e.NotebookCellOutputItem=mt={}));var ut;(function(ye){function De(K){return{outputId:K.id,items:K.items.map(mt.from),metadata:K.metadata}}ye.from=De;function de(K){const Se=K.items.map(mt.to);return new i.$TL(Se,K.outputId,K.metadata)}ye.to=de})(ut||(e.NotebookCellOutput=ut={}));var Pt;(function(ye){function De(Se){return K(Se)?{include:Te.from(Se.include)??void 0,exclude:Te.from(Se.exclude)??void 0}:Te.from(Se)??void 0}ye.from=De;function de(Se){return K(Se)?{include:Te.to(Se.include),exclude:Te.to(Se.exclude)}:Te.to(Se)}ye.to=de;function K(Se){const Le=Se;return Le?!(0,v.$If)(Le.include)&&!(0,v.$If)(Le.exclude):!1}})(Pt||(e.NotebookExclusiveDocumentPattern=Pt={}));var gt;(function(ye){function De(de,K,Se){const Le=typeof de.command=="string"?{title:"",command:de.command}:de.command;return{alignment:de.alignment===i.NotebookCellStatusBarAlignment.Left?1:2,command:K.toInternal(Le,Se),text:de.text,tooltip:de.tooltip,accessibilityInformation:de.accessibilityInformation,priority:de.priority}}ye.from=De})(gt||(e.NotebookStatusBarItem=gt={}));var wt;(function(ye){function De(de,K,Se){const Le=typeof de.command=="string"?{title:"",command:de.command}:de.command;return{command:K.toInternal(Le,Se),label:de.label,description:de.description,detail:de.detail,documentation:de.documentation}}ye.from=De})(wt||(e.NotebookKernelSourceAction=wt={}));var Mt;(function(ye){function De(de){return{transientOutputs:de?.transientOutputs??!1,transientCellMetadata:de?.transientCellMetadata??{},transientDocumentMetadata:de?.transientDocumentMetadata??{},cellContentMetadata:de?.cellContentMetadata??{}}}ye.from=De})(Mt||(e.NotebookDocumentContentOptions=Mt={}));var Tt;(function(ye){function De(K){return{uri:K.uri,provides:K.provides}}ye.from=De;function de(K){return new i.$VL(u.URI.revive(K.uri),K.provides)}ye.to=de})(Tt||(e.NotebookRendererScript=Tt={}));var Nt;(function(ye){function De(K){return{message:ne.fromStrict(K.message)||"",type:0,expected:K.expectedOutput,actual:K.actualOutput,contextValue:K.contextValue,location:K.location&&{range:t.from(K.location.range),uri:K.location.uri}}}ye.from=De;function de(K){const Se=new i.$2L(typeof K.message=="string"?K.message:ne.to(K.message));return Se.actualOutput=K.actual,Se.expectedOutput=K.expected,Se.contextValue=K.contextValue,Se.location=K.location?U.to(K.location):void 0,Se}ye.to=de})(Nt||(e.TestMessage=Nt={}));var $t;(function(ye){ye.namespace=c.$nJ,ye.denamespace=c.$oJ})($t||(e.TestTag=$t={}));var pt;(function(ye){function De(K){const Se=(0,h.$nM)(K).controllerId;return{extId:$.$jJ.fromExtHostTestItem(K,Se).toString(),label:K.label,uri:u.URI.revive(K.uri),busy:K.busy,tags:K.tags.map(Le=>$t.namespace(Se,Le.id)),range:b.$ys.lift(t.from(K.range)),description:K.description||null,sortText:K.sortText||null,error:K.error&&ne.fromStrict(K.error)||null}}ye.from=De;function de(K){return{parent:void 0,error:void 0,id:$.$jJ.fromString(K.extId).localId,label:K.label,uri:u.URI.revive(K.uri),tags:(K.tags||[]).map(Se=>{const{tagId:Le}=$t.denamespace(Se);return new i.$3L(Le)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:t.to(K.range||void 0),canResolveChildren:!1,busy:K.busy,description:K.description||void 0,sortText:K.sortText||void 0}}ye.toPlain=de})(pt||(e.TestItem=pt={})),function(ye){function De(K){return{id:K.id}}ye.from=De;function de(K){return new i.$3L(K.id)}ye.to=de}($t||(e.TestTag=$t={}));var Ft;(function(ye){const De=(K,Se)=>{const Le=[];for(const[Ue,Ye]of Se)$.$jJ.compare(Ye.item.extId,Ue)===2&&(Se.delete(Ue),Le.push(Ye));const Ve={...pt.toPlain(K.item),parent:void 0,taskStates:K.tasks.map(Ue=>({state:Ue.state,duration:Ue.duration,messages:Ue.messages.filter(Ye=>Ye.type===0).map(Nt.to)})),children:Le.map(Ue=>De(Ue,Se))};for(const Ue of Ve.children)Ue.parent=Ve;return Ve};function de(K){const Se=[],Le=new Map;for(const Ve of K.items){Le.set(Ve.item.extId,Ve);const Ue=$.$jJ.root(Ve.item.extId);K.request.targets.some(Ye=>Ye.controllerId===Ue&&Ye.testIds.includes(Ve.item.extId))&&Se.push(Ve)}return{completedAt:K.completedAt,results:Se.map(Ve=>De(Ve,Le))}}ye.to=de})(Ft||(e.TestResults=Ft={}));var Ct;(function(ye){function De(Le){return{covered:Le.covered,total:Le.covered}}function de(Le){return"line"in Le?f.from(Le):t.from(Le)}function K(Le){return"branches"in Le?{count:Le.executionCount,location:de(Le.location),type:1,branches:Le.branches.length?Le.branches.map(Ve=>({count:Ve.executionCount,location:Ve.location&&de(Ve.location)})):void 0}:{type:0,count:Le.executionCount,location:de(Le.location)}}ye.fromDetailed=K;function Se(Le){return{uri:Le.uri,statement:De(Le.statementCoverage),branch:Le.branchCoverage&&De(Le.branchCoverage),function:Le.functionCoverage&&De(Le.functionCoverage),details:Le.detailedCoverage?.map(K)}}ye.fromFile=Se})(Ct||(e.TestCoverage=Ct={}));var vt;(function(ye){function De(de){switch(de){case 1:return i.CodeActionTriggerKind.Invoke;case 2:return i.CodeActionTriggerKind.Automatic}}ye.to=De})(vt||(e.CodeActionTriggerKind=vt={}));var Ut;(function(ye){function De(K){const Se=new i.$9L(ce.to(K.kind),K.name,K.detail||"",u.URI.revive(K.uri),t.to(K.range),t.to(K.selectionRange));return Se._sessionId=K._sessionId,Se._itemId=K._itemId,Se}ye.to=De;function de(K,Se,Le){if(Se=Se??K._sessionId,Le=Le??K._itemId,Se===void 0||Le===void 0)throw new Error("invalid item");return{_sessionId:Se,_itemId:Le,kind:ce.from(K.kind),name:K.name,detail:K.detail??"",uri:K.uri,range:t.from(K.range),selectionRange:t.from(K.selectionRange),tags:K.tags?.map(oe.from)}}ye.from=de})(Ut||(e.TypeHierarchyItem=Ut={}));var Dt;(function(ye){function De(de){if(de)return{value:de.value,tooltip:de.tooltip}}ye.from=De})(Dt||(e.ViewBadge=Dt={}));var st;(function(ye){function De(Le,Ve,Ue){const Ye=Ve.fileData;return Ye?new i.$hL(new i.$iL(Ye.name,u.URI.revive(Ye.uri),Ye.id,(0,L.$db)(()=>Ue(Ye.id)))):Le===A.$Ur.uriList&&Ve.uriListData?new i.$gL(Se(Ve.uriListData)):new i.$gL(Ve.asString)}ye.to=De;async function de(Le,Ve){const Ue=await Ve.asString();if(Le===A.$Ur.uriList)return{asString:Ue,fileData:void 0,uriListData:K(Ue)};const Ye=Ve.asFile();return{asString:Ue,fileData:Ye?{name:Ye.name,uri:Ye.uri,id:Ye._itemId??Ye.id}:void 0}}ye.from=de;function K(Le){return r.$8s.split(Le).map(Ve=>{if(Ve.startsWith("#"))return Ve;try{return u.URI.parse(Ve)}catch{}return Ve})}function Se(Le){return r.$8s.create(Le.map(Ve=>typeof Ve=="string"?Ve:u.URI.revive(Ve)))}})(st||(e.DataTransferItem=st={}));var bt;(function(ye){function De(K,Se){const Le=K.items.map(([Ve,Ue])=>[Ve,st.to(Ve,Ue,Se)]);return new i.$jL(Le)}ye.toDataTransfer=De;async function de(K){const Se={items:[]},Le=[];for(const[Ve,Ue]of K)Le.push((async()=>{Se.items.push([Ve,await st.from(Ve,Ue)])})());return await Promise.all(Le),Se}ye.from=de})(bt||(e.DataTransfer=bt={}));var ht;(function(ye){function De(K){return{message:K.message,metadata:K.metadata,title:K.title,tooltip:K.tooltip}}ye.to=De;function de(K){return{kind:"reply",message:K.message,metadata:K.metadata,title:K.title,tooltip:K.tooltip}}ye.from=de})(ht||(e.ChatReplyFollowup=ht={}));var ft;(function(ye){function De(de){return typeof de=="string"?{title:de,message:de,kind:"reply"}:"commandId"in de?{kind:"command",title:de.title??"",commandId:de.commandId??"",when:de.when??"",args:de.args}:ht.from(de)}ye.from=De})(ft||(e.ChatFollowup=ft={}));var Bt;(function(ye){function De(K){const Se=new i.$gM(It.to(K.role),K.content);return Se.name=K.name,Se}ye.to=De;function de(K){return{role:It.from(K.role),content:K.content,name:K.name}}ye.from=de})(Bt||(e.ChatMessage=Bt={}));var It;(function(ye){function De(K){switch(K){case 0:return i.ChatMessageRole.System;case 1:return i.ChatMessageRole.User;case 2:return i.ChatMessageRole.Assistant;case 3:return i.ChatMessageRole.Function}}ye.to=De;function de(K){switch(K){case i.ChatMessageRole.System:return 0;case i.ChatMessageRole.Assistant:return 2;case i.ChatMessageRole.Function:return 3;case i.ChatMessageRole.User:default:return 1}}ye.from=de})(It||(e.ChatMessageRole=It={}));var zt;(function(ye){function De(Se){const Le={};for(const Ve of Object.keys(Se))Le[Ve]=Se[Ve].map(ye.to);return Le}ye.objectTo=De;function de(Se){return{level:At.to(Se.level),value:Se.value,description:Se.description}}ye.to=de;function K(Se){return{level:At.from(Se.level),value:Se.value,description:Se.description}}ye.from=K})(zt||(e.ChatVariable=zt={}));var At;(function(ye){function De(K){switch(K){case"short":return i.ChatVariableLevel.Short;case"medium":return i.ChatVariableLevel.Medium;case"full":default:return i.ChatVariableLevel.Full}}ye.to=De;function de(K){switch(K){case i.ChatVariableLevel.Short:return"short";case i.ChatVariableLevel.Medium:return"medium";case i.ChatVariableLevel.Full:default:return"full"}}ye.from=de})(At||(e.ChatVariableLevel=At={}));var Ht;(function(ye){function De(de){switch(de){case 1:return i.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return i.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return i.InteractiveEditorResponseFeedbackKind.Undone;case 3:return i.InteractiveEditorResponseFeedbackKind.Accepted}}ye.to=De})(Ht||(e.InteractiveEditorResponseFeedbackKind=Ht={}));var Vt;(function(ye){function De(de,K){return"placeholder"in K&&"resolvedContent"in K?{placeholder:K.placeholder}:"responseId"in K?{requestId:K.responseId}:"markdownContent"in K?((0,o.$mF)(de,"chatAgents2Additions"),{content:ne.from(K.markdownContent)}):"content"in K?typeof K.content=="string"?K:((0,o.$mF)(de,"chatAgents2Additions"),{content:ne.from(K.content)}):"documents"in K?{documents:K.documents.map(Se=>({uri:Se.uri,version:Se.version,ranges:Se.ranges.map(Le=>t.from(Le))}))}:"reference"in K?{reference:"uri"in K.reference?{uri:K.reference.uri,range:t.from(K.reference.range)}:K.reference}:"inlineReference"in K?{inlineReference:"uri"in K.inlineReference?{uri:K.inlineReference.uri,range:t.from(K.inlineReference.range)}:K.inlineReference,title:K.title}:("agentName"in K&&(0,o.$mF)(de,"chatAgents2Additions"),K)}ye.from=De})(Vt||(e.ChatResponseProgress=Vt={}));var qt;(function(ye){function De(de,K,Se){return"terminalCommand"in de?{terminalCommand:de.terminalCommand}:"uri"in de?{uri:de.uri}:K.toInternal(de,Se)}ye.from=De})(qt||(e.TerminalQuickFix=qt={}))}),define(be[280],we([1,0,43,133,71,132,93,136,4]),function(ue,e,y,R,r,L,I,C,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GM=e.$FM=e.$EM=e.$DM=void 0;const w=(l,$,c,n)=>{let i=$;return{enumerable:!0,configurable:!1,get(){return i},set(o){if(!c(i,o)){const s=i;i=o,l.listener?.(n(o,s))}}}},A=(l,$)=>l===$,k={range:(l,$)=>l===$?!0:!l||!$?!1:l.isEqual($),label:A,description:A,sortText:A,busy:A,error:A,canResolveChildren:A,tags:(l,$)=>!(l.length!==$.length||l.some(c=>!$.find(n=>c.id===n.id)))},v=l=>$=>({op:4,update:l($)}),u=(l,$)=>({range:(()=>{let c;const n=v(i=>({range:y.$ys.lift(C.Range.from(i))}));return{enumerable:!0,configurable:!1,get(){return c},set(i){l.listener?.({op:6}),k.range(c,i)||(c=i,l.listener?.(n(i)))}}})(),label:w(l,$,k.label,v(c=>({label:c}))),description:w(l,void 0,k.description,v(c=>({description:c}))),sortText:w(l,void 0,k.sortText,v(c=>({sortText:c}))),canResolveChildren:w(l,!1,k.canResolveChildren,c=>({op:2,state:c})),busy:w(l,!1,k.busy,v(c=>({busy:c}))),error:w(l,void 0,k.error,v(c=>({error:C.MarkdownString.fromStrict(c)||null}))),tags:w(l,[],k.tags,(c,n)=>({op:1,new:c.map(C.TestTag.from),old:n.map(C.TestTag.from)}))}),b=l=>{const $=r.$jJ.fromString(l.extId),c=new d($.controllerId,$.localId,l.label,p.URI.revive(l.uri)||void 0);return c.range=C.Range.to(l.range||void 0),c.description=l.description||void 0,c.sortText=l.sortText||void 0,c.tags=l.tags.map(n=>C.TestTag.to({id:(0,I.$oJ)(n).tagId})),c},m=l=>{let $;for(const c of l.tests){const n=b(c.item);(0,R.$nM)(n).parent=$,$=n}return $};e.$DM=m;class d{constructor($,c,n,i){if(c.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(c)} symbol`);const o=(0,R.$mM)(this,$);Object.defineProperties(this,{id:{value:c,enumerable:!0,writable:!1},uri:{value:i,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return o.parent instanceof h?void 0:o.parent}},children:{value:(0,L.$lM)(o,R.$nM,d),enumerable:!0,writable:!1},...u(o,n)})}}e.$EM=d;class h extends d{constructor($,c){super($,$,c,void 0),this._isRoot=!0}}e.$FM=h;class g extends L.$hM{constructor($,c,n){super({controllerId:$,getDocumentVersion:i=>i&&n.getDocument(i)?.version,getApiFor:R.$nM,getChildren:i=>i.children,root:new h($,c),toITestItem:C.TestItem.from})}}e.$GM=g}),define(be[281],we([1,0,35,204,53]),function(ue,e,y,R,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QN=void 0;function L(I,C,p,w){const A=new y.$0l;return I.forEach(k=>{const v=A.get(k.identifier);v&&w.warn((0,R.localize)(0,null,v.extensionLocation.fsPath,k.extensionLocation.fsPath)),A.set(k.identifier,k)}),C.forEach(k=>{const v=A.get(k.identifier);if(v)if(v.isBuiltin){if(r.gte(v.version,k.version)){w.warn(`Skipping extension ${k.extensionLocation.path} in favour of the builtin extension ${v.extensionLocation.path}.`);return}k.isBuiltin=!0}else w.warn((0,R.localize)(1,null,v.extensionLocation.fsPath,k.extensionLocation.fsPath));else if(k.isBuiltin){w.warn(`Skipping obsolete builtin extension ${k.extensionLocation.path}`);return}A.set(k.identifier,k)}),p.forEach(k=>{w.info((0,R.localize)(2,null,k.extensionLocation.fsPath));const v=A.get(k.identifier);v&&v.isBuiltin&&(k.isBuiltin=!0),A.set(k.identifier,k)}),Array.from(A.values())}e.$QN=L}),define(be[282],we([1,0,7,3,28,4,41,51,67,58,281,12]),function(ue,e,y,R,r,L,I,C,p,w,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UN=e.$TN=void 0;class v{constructor(m,d,h,g,l,$,c){this.c=m,this.d=h,this.f=g,this.g=l,this.h=$,this.i=c,this.a=Promise.resolve(),this.b=Promise.resolve();const n=d.args["install-builtin-extension"];if(n){l.trace("Installing builtin extensions passed via args...");const o={isMachineScoped:!!d.args["do-not-sync"],installPreReleaseVersion:!!d.args["pre-release"]};I.mark("code/server/willInstallBuiltinExtensions"),this.b=this.a=m.installExtensions([],this.j(n),o,!!d.args.force).then(()=>{I.mark("code/server/didInstallBuiltinExtensions"),l.trace("Finished installing builtin extensions")},s=>{l.error(s)})}const i=d.args["install-extension"];i&&(l.trace("Installing extensions passed via args..."),this.b=this.a.then(()=>m.installExtensions(this.j(i),[],{isMachineScoped:!!d.args["do-not-sync"],installPreReleaseVersion:!!d.args["pre-release"],isApplicationScoped:!0},!!d.args.force)).then(()=>{l.trace("Finished installing extensions")},o=>{l.error(o)}))}j(m){return m.map(d=>/\.vsix$/i.test(d)?L.URI.file((0,y.$ic)(d)?d:(0,y.$jc)((0,r.cwd)(),d)):d)}whenExtensionsReady(){return this.b}async scanExtensions(m,d,h,g){I.mark("code/server/willScanExtensions"),this.g.trace(`Scanning extensions using UI language: ${m}`),await this.a;const l=h?h.filter(c=>c.scheme===k.Schemas.file).map(c=>c.fsPath):void 0;d=d??this.d.defaultProfile.extensionsResource;const $=await this.k(d,m??R.$q,l,g);return this.g.trace("Scanned Extensions",$),this.r($),I.mark("code/server/didScanExtensions"),$}async scanSingleExtension(m,d,h){await this.a;const g=m.scheme===k.Schemas.file?m.fsPath:null;if(!g)return null;const l=await this.o(g,d,h??R.$q);return l?(this.r([l]),l):null}async k(m,d,h,g){await this.q(d,g);const[l,$,c]=await Promise.all([this.m(d),this.n(m,d),this.l(d,h)]);return(0,A.$QN)(l,$,c,this.g)}async l(m,d){return d?(await Promise.all(d.map(h=>this.f.scanOneOrMultipleExtensions(L.URI.file((0,y.$kc)(h)),1,{language:m})))).flat().map(h=>(0,w.$Gp)(h,!0)):[]}async m(m){return(await this.f.scanSystemExtensions({language:m,useCache:!0})).map(h=>(0,w.$Gp)(h,!1))}async n(m,d){return(await this.f.scanUserExtensions({profileLocation:m,language:d,useCache:!0})).map(g=>(0,w.$Gp)(g,!1))}async o(m,d,h){const g=L.URI.file((0,y.$kc)(m)),l=d?0:1,$=await this.f.scanExistingExtension(g,l,{language:h});return $?(0,w.$Gp)($,!1):null}async q(m,d){if(!(m===R.$a||!this.h.isEnabled())){try{if((await this.i.getInstalledLanguages()).find(g=>g.id===m)){this.g.trace(`Language Pack ${m} is already installed. Skipping language pack installation.`);return}}catch(h){this.g.error(h)}if(!d){this.g.trace(`No language pack id provided for language ${m}. Skipping language pack installation.`);return}this.g.trace(`Language Pack ${d} for language ${m} is not installed. It will be installed now.`);try{await this.c.installExtensions([d],[],{isMachineScoped:!0},!0)}catch(h){this.g.error(h)}}}r(m){const d=(n,i)=>n.replace(/file/g,"vscode-remote"),h=n=>{let i="";return i+=n.global?"g":"",i+=n.ignoreCase?"i":"",i+=n.multiline?"m":"",new RegExp(d(n.source,!0),i)},g=new class{mapDefined(n){return p.$Ti.create(n)}mapNot(n){return p.$Yi.create(n)}mapEquals(n,i){return n==="resourceScheme"&&typeof i=="string"?p.$Ui.create(n,d(i,!1)):p.$Ui.create(n,i)}mapNotEquals(n,i){return n==="resourceScheme"&&typeof i=="string"?p.$Xi.create(n,d(i,!1)):p.$Xi.create(n,i)}mapGreater(n,i){return p.$Zi.create(n,i)}mapGreaterEquals(n,i){return p.$1i.create(n,i)}mapSmaller(n,i){return p.$2i.create(n,i)}mapSmallerEquals(n,i){return p.$3i.create(n,i)}mapRegex(n,i){return n==="resourceScheme"&&i?p.$4i.create(n,h(i)):p.$4i.create(n,i)}mapIn(n,i){return p.$Vi.create(n,i)}mapNotIn(n,i){return p.$Wi.create(n,i)}},l=n=>{if(!n||!n.when||!/resourceScheme/.test(n.when))return;const i=p.$Oi.deserialize(n.when);if(!i)return;const o=i.map(g);n.when=o.serialize()},$=n=>{if(Array.isArray(n))for(const i of n)l(i);else l(n)},c=n=>{for(const i in n)$(n[i])};m.forEach(n=>{n.contributes&&(n.contributes.menus&&c(n.contributes.menus),n.contributes.keybindings&&$(n.contributes.keybindings),n.contributes.views&&c(n.contributes.views))})}}e.$TN=v;class u{constructor(m,d){this.a=m,this.b=d}listen(m,d){throw new Error("Invalid listen")}async call(m,d,h){const g=this.b(m);switch(d){case"whenExtensionsReady":return this.a.whenExtensionsReady();case"scanExtensions":{const l=h[0],$=h[1]?L.URI.revive(g.transformIncoming(h[1])):void 0,c=Array.isArray(h[2])?h[2].map(o=>L.URI.revive(g.transformIncoming(o))):void 0,n=h[3];return(await this.a.scanExtensions(l,$,c,n)).map(o=>(0,C.$Pm)(o,g))}case"scanSingleExtension":{const l=await this.a.scanSingleExtension(L.URI.revive(g.transformIncoming(h[0])),h[1],h[2]);return l?(0,C.$Pm)(l,g):null}}throw new Error("Invalid call")}}e.$UN=u}),define(be[137],we([1,0]),function(ue,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vv=e.$uv=e.$tv=e.$sv=void 0;class y{constructor(p){this._proxyIdentifierBrand=void 0,this.sid=p,this.nid=++y.count}}e.$sv=y,y.count=0;const R=[];function r(C){const p=new y(C);return R[p.nid]=p,p}e.$tv=r;function L(C){return R[C].sid}e.$uv=L;class I{constructor(p){this.value=p}}e.$vv=I}),define(be[283],we([1,0,137]),function(ue,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rK=e.$qK=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$pK=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var R;(function(m){m[m.Default=0]="Default",m[m.InCenter=1]="InCenter",m[m.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",m[m.AtTop=3]="AtTop"})(R||(e.TextEditorRevealType=R={}));var r;(function(m){m[m.UnknownInput=0]="UnknownInput",m[m.TextInput=1]="TextInput",m[m.TextDiffInput=2]="TextDiffInput",m[m.TextMergeInput=3]="TextMergeInput",m[m.NotebookInput=4]="NotebookInput",m[m.NotebookDiffInput=5]="NotebookDiffInput",m[m.CustomEditorInput=6]="CustomEditorInput",m[m.WebviewEditorInput=7]="WebviewEditorInput",m[m.TerminalEditorInput=8]="TerminalEditorInput",m[m.InteractiveEditorInput=9]="InteractiveEditorInput"})(r||(e.TabInputKind=r={}));var L;(function(m){m[m.TAB_OPEN=0]="TAB_OPEN",m[m.TAB_CLOSE=1]="TAB_CLOSE",m[m.TAB_UPDATE=2]="TAB_UPDATE",m[m.TAB_MOVE=3]="TAB_MOVE"})(L||(e.TabModelOperationKind=L={}));var I;(function(m){m[m.Editable=0]="Editable",m[m.SupportsHotExit=1]="SupportsHotExit"})(I||(e.WebviewEditorCapabilities=I={}));var C;(function(m){m[m.Int8Array=1]="Int8Array",m[m.Uint8Array=2]="Uint8Array",m[m.Uint8ClampedArray=3]="Uint8ClampedArray",m[m.Int16Array=4]="Int16Array",m[m.Uint16Array=5]="Uint16Array",m[m.Int32Array=6]="Int32Array",m[m.Uint32Array=7]="Uint32Array",m[m.Float32Array=8]="Float32Array",m[m.Float64Array=9]="Float64Array",m[m.BigInt64Array=10]="BigInt64Array",m[m.BigUint64Array=11]="BigUint64Array"})(C||(e.WebviewMessageArrayBufferViewType=C={}));var p;(function(m){m[m.Text=1]="Text",m[m.Error=2]="Error",m[m.Rich=3]="Rich"})(p||(e.CellOutputKind=p={}));var w;(function(m){m[m.Default=0]="Default",m[m.InCenter=1]="InCenter",m[m.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",m[m.AtTop=3]="AtTop"})(w||(e.NotebookEditorRevealType=w={}));var A;(function(m){m[m.None=0]="None",m[m.Process=1]="Process",m[m.Output=2]="Output"})(A||(e.CandidatePortSource=A={}));class k{static mixin(d){return d._id=k.a++,d}}e.$pK=k,k.a=0;var v;(function(m){m.label="a",m.kind="b",m.detail="c",m.documentation="d",m.sortText="e",m.filterText="f",m.preselect="g",m.insertText="h",m.insertTextRules="i",m.range="j",m.commitCharacters="k",m.additionalTextEdits="l",m.kindModifier="m",m.commandIdent="n",m.commandId="o",m.commandArguments="p"})(v||(e.ISuggestDataDtoField=v={}));var u;(function(m){m.defaultRanges="a",m.completions="b",m.isIncomplete="c",m.duration="d"})(u||(e.ISuggestResultDtoField=u={}));var b;(function(m){m[m.Workspace=0]="Workspace",m[m.TextDocument=1]="TextDocument"})(b||(e.ExtHostTestingResource=b={})),e.$qK={MainThreadAuthentication:(0,y.$tv)("MainThreadAuthentication"),MainThreadBulkEdits:(0,y.$tv)("MainThreadBulkEdits"),MainThreadChatProvider:(0,y.$tv)("MainThreadChatProvider"),MainThreadChatAgents:(0,y.$tv)("MainThreadChatAgents"),MainThreadChatAgents2:(0,y.$tv)("MainThreadChatAgents2"),MainThreadChatVariables:(0,y.$tv)("MainThreadChatVariables"),MainThreadClipboard:(0,y.$tv)("MainThreadClipboard"),MainThreadCommands:(0,y.$tv)("MainThreadCommands"),MainThreadComments:(0,y.$tv)("MainThreadComments"),MainThreadConfiguration:(0,y.$tv)("MainThreadConfiguration"),MainThreadConsole:(0,y.$tv)("MainThreadConsole"),MainThreadDebugService:(0,y.$tv)("MainThreadDebugService"),MainThreadDecorations:(0,y.$tv)("MainThreadDecorations"),MainThreadDiagnostics:(0,y.$tv)("MainThreadDiagnostics"),MainThreadDialogs:(0,y.$tv)("MainThreadDiaglogs"),MainThreadDocuments:(0,y.$tv)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,y.$tv)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,y.$tv)("MainThreadTextEditors"),MainThreadEditorInsets:(0,y.$tv)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,y.$tv)("MainThreadEditorTabs"),MainThreadErrors:(0,y.$tv)("MainThreadErrors"),MainThreadTreeViews:(0,y.$tv)("MainThreadTreeViews"),MainThreadDownloadService:(0,y.$tv)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,y.$tv)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,y.$tv)("MainThreadLanguages"),MainThreadLogger:(0,y.$tv)("MainThreadLogger"),MainThreadMessageService:(0,y.$tv)("MainThreadMessageService"),MainThreadOutputService:(0,y.$tv)("MainThreadOutputService"),MainThreadProgress:(0,y.$tv)("MainThreadProgress"),MainThreadQuickDiff:(0,y.$tv)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,y.$tv)("MainThreadQuickOpen"),MainThreadStatusBar:(0,y.$tv)("MainThreadStatusBar"),MainThreadSecretState:(0,y.$tv)("MainThreadSecretState"),MainThreadStorage:(0,y.$tv)("MainThreadStorage"),MainThreadSpeech:(0,y.$tv)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,y.$tv)("MainThreadTelemetry"),MainThreadTerminalService:(0,y.$tv)("MainThreadTerminalService"),MainThreadWebviews:(0,y.$tv)("MainThreadWebviews"),MainThreadWebviewPanels:(0,y.$tv)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,y.$tv)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,y.$tv)("MainThreadCustomEditors"),MainThreadUrls:(0,y.$tv)("MainThreadUrls"),MainThreadUriOpeners:(0,y.$tv)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,y.$tv)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,y.$tv)("MainThreadWorkspace"),MainThreadFileSystem:(0,y.$tv)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,y.$tv)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,y.$tv)("MainThreadExtensionService"),MainThreadSCM:(0,y.$tv)("MainThreadSCM"),MainThreadSearch:(0,y.$tv)("MainThreadSearch"),MainThreadShare:(0,y.$tv)("MainThreadShare"),MainThreadTask:(0,y.$tv)("MainThreadTask"),MainThreadWindow:(0,y.$tv)("MainThreadWindow"),MainThreadLabelService:(0,y.$tv)("MainThreadLabelService"),MainThreadNotebook:(0,y.$tv)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,y.$tv)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,y.$tv)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,y.$tv)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,y.$tv)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,y.$tv)("MainThreadInteractive"),MainThreadChat:(0,y.$tv)("MainThreadChat"),MainThreadInlineChat:(0,y.$tv)("MainThreadInlineChatShape"),MainThreadTheming:(0,y.$tv)("MainThreadTheming"),MainThreadTunnelService:(0,y.$tv)("MainThreadTunnelService"),MainThreadManagedSockets:(0,y.$tv)("MainThreadManagedSockets"),MainThreadTimeline:(0,y.$tv)("MainThreadTimeline"),MainThreadTesting:(0,y.$tv)("MainThreadTesting"),MainThreadLocalization:(0,y.$tv)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,y.$tv)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,y.$tv)("MainThreadAiEmbeddingVector"),MainThreadIssueReporter:(0,y.$tv)("MainThreadIssueReporter")},e.$rK={ExtHostCommands:(0,y.$tv)("ExtHostCommands"),ExtHostConfiguration:(0,y.$tv)("ExtHostConfiguration"),ExtHostDiagnostics:(0,y.$tv)("ExtHostDiagnostics"),ExtHostDebugService:(0,y.$tv)("ExtHostDebugService"),ExtHostDecorations:(0,y.$tv)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,y.$tv)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,y.$tv)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,y.$tv)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,y.$tv)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,y.$tv)("ExtHostEditors"),ExtHostTreeViews:(0,y.$tv)("ExtHostTreeViews"),ExtHostFileSystem:(0,y.$tv)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,y.$tv)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,y.$tv)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,y.$tv)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,y.$tv)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,y.$tv)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,y.$tv)("ExtHostQuickDiff"),ExtHostStatusBar:(0,y.$tv)("ExtHostStatusBar"),ExtHostShare:(0,y.$tv)("ExtHostShare"),ExtHostExtensionService:(0,y.$tv)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,y.$tv)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,y.$tv)("ExtHostTerminalService"),ExtHostSCM:(0,y.$tv)("ExtHostSCM"),ExtHostSearch:(0,y.$tv)("ExtHostSearch"),ExtHostTask:(0,y.$tv)("ExtHostTask"),ExtHostWorkspace:(0,y.$tv)("ExtHostWorkspace"),ExtHostWindow:(0,y.$tv)("ExtHostWindow"),ExtHostWebviews:(0,y.$tv)("ExtHostWebviews"),ExtHostWebviewPanels:(0,y.$tv)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,y.$tv)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,y.$tv)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,y.$tv)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,y.$tv)("ExtHostEditorTabs"),ExtHostProgress:(0,y.$tv)("ExtHostProgress"),ExtHostComments:(0,y.$tv)("ExtHostComments"),ExtHostSecretState:(0,y.$tv)("ExtHostSecretState"),ExtHostStorage:(0,y.$tv)("ExtHostStorage"),ExtHostUrls:(0,y.$tv)("ExtHostUrls"),ExtHostUriOpeners:(0,y.$tv)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,y.$tv)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,y.$tv)("ExtHostOutputService"),ExtHosLabelService:(0,y.$tv)("ExtHostLabelService"),ExtHostNotebook:(0,y.$tv)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,y.$tv)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,y.$tv)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,y.$tv)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,y.$tv)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,y.$tv)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,y.$tv)("ExtHostInteractive"),ExtHostInlineChat:(0,y.$tv)("ExtHostInlineChatShape"),ExtHostChat:(0,y.$tv)("ExtHostChat"),ExtHostChatAgents:(0,y.$tv)("ExtHostChatAgents"),ExtHostChatAgents2:(0,y.$tv)("ExtHostChatAgents"),ExtHostChatVariables:(0,y.$tv)("ExtHostChatVariables"),ExtHostChatProvider:(0,y.$tv)("ExtHostChatProvider"),ExtHostSpeech:(0,y.$tv)("ExtHostSpeech"),ExtHostAiRelatedInformation:(0,y.$tv)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,y.$tv)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,y.$tv)("ExtHostTheming"),ExtHostTunnelService:(0,y.$tv)("ExtHostTunnelService"),ExtHostManagedSockets:(0,y.$tv)("ExtHostManagedSockets"),ExtHostAuthentication:(0,y.$tv)("ExtHostAuthentication"),ExtHostTimeline:(0,y.$tv)("ExtHostTimeline"),ExtHostTesting:(0,y.$tv)("ExtHostTesting"),ExtHostTelemetry:(0,y.$tv)("ExtHostTelemetry"),ExtHostLocalization:(0,y.$tv)("ExtHostLocalization"),ExtHostIssueReporter:(0,y.$tv)("ExtHostIssueReporter")}});var Ot=this&&this.__classPrivateFieldSet||function(ue,e,y,R,r){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!r)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ue!==e||!r:!e.has(ue))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?r.call(ue,y):r?r.value=y:e.set(ue,y),y},nt=this&&this.__classPrivateFieldGet||function(ue,e,y,R){if(y==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ue!==e||!R:!e.has(ue))throw new TypeError("Cannot read private member from an object whose class did not declare it");return y==="m"?R:y==="a"?R.call(ue):R?R.value:e.get(ue)};define(be[284],we([1,0,8,131,136,22,283,18,13,50,43,108,4,2,6,267,280,15,137,40,61,38,278]),function(ue,e,y,R,r,L,I,C,p,w,A,k,v,u,b,m,d,h,g,l,$,c,n){"use strict";var i,o,s;Object.defineProperty(e,"__esModule",{value:!0}),e.$RM=e.$QM=e.$PM=e.$OM=e.$NM=e.$MM=void 0;let t=class{constructor(P,M,ee){i.set(this,void 0),this.b=new Map,this.c=new Map,o.set(this,void 0),s.set(this,void 0),Ot(this,i,P.getProxy(I.$qK.MainThreadCommands),"f"),this.d=M,Ot(this,s,ee,"f"),Ot(this,o,P.getProxy(I.$qK.MainThreadTelemetry),"f"),this.converter=new a(this,se=>{const G=this.c.get(se);return G?.result===S.Void?G:void 0},M),this.f=[{processArgument(se){return(0,w.$nh)(se)}},{processArgument(se){return(0,L.$$m)(se,function(G){if(A.$ys.isIRange(G))return r.Range.to(G);if(k.$xs.isIPosition(G))return r.Position.to(G);if(A.$ys.isIRange(G.range)&&v.URI.isUri(G.uri))return r.location.to(G);if(G instanceof h.$ce)return G.buffer.buffer;if(!Array.isArray(G))return G})}}]}registerArgumentProcessor(P){this.f.push(P)}registerApiCommand(P){const M=this.registerCommand(!1,P.id,async(...ee)=>{const se=P.args.map((ne,he)=>{if(!ne.validate(ee[he]))throw new Error(`Invalid argument '${ne.name}' when running '${P.id}', received: ${typeof ee[he]=="object"?JSON.stringify(ee[he],null,"	"):ee[he]} `);return ne.convert(ee[he])}),G=await this.executeCommand(P.internalId,...se);return P.result.convert(G,ee,this.converter)},void 0,{description:P.description,args:P.args,returns:P.result.description});return this.c.set(P.id,P),new R.$sK(()=>{M.dispose(),this.c.delete(P.id)})}registerCommand(P,M,ee,se,G,ne){if(this.d.trace("ExtHostCommands#registerCommand",M),!M.trim().length)throw new Error("invalid id");if(this.b.has(M))throw new Error(`command '${M}' already exists`);return this.b.set(M,{callback:ee,thisArg:se,metadata:G,extension:ne}),P&&nt(this,i,"f").$registerCommand(M),new R.$sK(()=>{this.b.delete(M)&&P&&nt(this,i,"f").$unregisterCommand(M)})}executeCommand(P,...M){return this.d.trace("ExtHostCommands#executeCommand",P),this.g(P,M,!0)}async g(P,M,ee){if(this.b.has(P))return nt(this,i,"f").$fireCommandActivationEvent(P),this.h(P,M,!1);{let se=!1;const G=(0,L.$$m)(M,function(ne){if(ne instanceof R.$tK)return r.Position.from(ne);if(ne instanceof R.$uK)return r.Range.from(ne);if(ne instanceof R.$EK)return r.location.from(ne);if(R.$PL.isNotebookRange(ne))return r.NotebookRange.from(ne);if(ne instanceof ArrayBuffer)return se=!0,h.$ce.wrap(new Uint8Array(ne));if(ne instanceof Uint8Array)return se=!0,h.$ce.wrap(ne);if(ne instanceof h.$ce)return se=!0,ne;if(!Array.isArray(ne))return ne});try{const ne=await nt(this,i,"f").$executeCommand(P,se?new g.$vv(G):G,ee);return(0,w.$nh)(ne)}catch(ne){if(ne instanceof Error&&ne.message==="$executeCommand:retry")return this.g(P,M,!1);throw ne}}}async h(P,M,ee){const se=this.b.get(P);if(!se)throw new Error("Unknown command");const{callback:G,thisArg:ne,metadata:he}=se;if(he?.args)for(let fe=0;fe<he.args.length;fe++)try{(0,y.$Qf)(M[fe],he.args[fe].constraint)}catch{throw new Error(`Running the contributed command: '${P}' failed. Illegal argument '${he.args[fe].name}' - ${he.args[fe].description}`)}const Z=$.$Kd.create();try{return await G.apply(ne,M)}catch(fe){if(P===this.converter.delegatingCommandId){const V=this.converter.getActualCommand(...M);V&&(P=V.command)}if(this.d.error(fe,P,se.extension?.identifier),!ee)throw fe;if(se.extension?.identifier){const V=nt(this,s,"f").onExtensionError(se.extension.identifier,fe);this.d.trace("forwarded error to extension?",V,se.extension?.identifier)}throw new class extends Error{constructor(){super((0,l.$Bi)(fe)),this.id=P,this.source=se.extension?.displayName??se.extension?.name}}}finally{this.j(se,P,Z.elapsed())}}j(P,M,ee){P.extension&&nt(this,o,"f").$publicLog2("Extension:ActionExecuted",{extensionId:P.extension.identifier.value,id:new c.$oo(M),duration:ee})}$executeContributedCommand(P,...M){this.d.trace("ExtHostCommands#$executeContributedCommand",P);const ee=this.b.get(P);return ee?(M=M.map(se=>this.f.reduce((G,ne)=>ne.processArgument(G,ee.extension?.identifier),se)),this.h(P,M,!0)):Promise.reject(new Error(`Contributed command '${P}' does not exist.`))}getCommands(P=!1){return this.d.trace("ExtHostCommands#getCommands",P),nt(this,i,"f").$getCommands().then(M=>(P&&(M=M.filter(ee=>ee[0]!=="_")),M))}$getContributedCommandMetadata(){const P=Object.create(null);for(const[M,ee]of this.b){const{metadata:se}=ee;se&&(P[M]=se)}return Promise.resolve(P)}};e.$MM=t,i=new WeakMap,o=new WeakMap,s=new WeakMap,e.$MM=t=Re([Ae(0,m.$rM),Ae(1,p.$$i),Ae(2,n.$LM)],t),e.$NM=(0,b.$Qh)("IExtHostCommands");class a{constructor(P,M,ee){this.d=P,this.f=M,this.g=ee,this.delegatingCommandId=`__vsc${Date.now().toString(36)} `,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(P,M){if(!P)return;const ee={$ident:void 0,id:P.command,title:P.title,tooltip:P.tooltip};if(!P.command)return ee;const se=this.f(P.command);if(se)ee.id=se.internalId,ee.arguments=se.args.map((G,ne)=>G.convert(P.arguments&&P.arguments[ne]));else if((0,C.$Lb)(P.arguments)){const G=`${P.command} /${++this.c}`;this.b.set(G,P),M.add((0,u.$Qc)(()=>{this.b.delete(G),this.g.trace("CommandsConverter#DISPOSE",G)})),ee.$ident=G,ee.id=this.delegatingCommandId,ee.arguments=[G],this.g.trace("CommandsConverter#CREATE",P.command,G)}return ee}fromInternal(P){return typeof P.$ident=="string"?this.b.get(P.$ident):{command:P.id,title:P.title,arguments:P.arguments}}getActualCommand(...P){return this.b.get(P[0])}h(...P){const M=this.getActualCommand(...P);return this.g.trace("CommandsConverter#EXECUTE",P[0],M?M.command:"MISSING"),M?this.d.executeCommand(M.command,...M.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${P[0]}`)}}e.$OM=a;class f{static Arr(P){return new f(`${P.name}_array`,`Array of ${P.name}, ${P.description}`,M=>Array.isArray(M)&&M.every(ee=>P.validate(ee)),M=>M.map(ee=>P.convert(ee)))}constructor(P,M,ee,se){this.name=P,this.description=M,this.validate=ee,this.convert=se}optional(){return new f(this.name,`(optional) ${this.description}`,P=>P==null||this.validate(P),P=>P===void 0?void 0:P===null?null:this.convert(P))}with(P,M){return new f(P??this.name,M??this.description,this.validate,this.convert)}}e.$PM=f,f.Uri=new f("uri","Uri of a text document",E=>v.URI.isUri(E),E=>E),f.Position=new f("position","A position in a text document",E=>R.$tK.isPosition(E),r.Position.from),f.Range=new f("range","A range in a text document",E=>R.$uK.isRange(E),r.Range.from),f.Selection=new f("selection","A selection in a text document",E=>R.$vK.isSelection(E),r.Selection.from),f.Number=new f("number","",E=>typeof E=="number",E=>E),f.String=new f("string","",E=>typeof E=="string",E=>E),f.StringArray=f.Arr(f.String),f.CallHierarchyItem=new f("item","A call hierarchy item",E=>E instanceof R.$OK,r.CallHierarchyItem.from),f.TypeHierarchyItem=new f("item","A type hierarchy item",E=>E instanceof R.$9L,r.TypeHierarchyItem.from),f.TestItem=new f("testItem","A VS Code TestItem",E=>E instanceof d.$EM,r.TestItem.from);class S{constructor(P,M){this.description=P,this.convert=M}}e.$QM=S,S.Void=new S("no result",E=>E);class D{constructor(P,M,ee,se,G){this.id=P,this.internalId=M,this.description=ee,this.args=se,this.result=G}}e.$RM=D}),define(be[285],we([1,0,11,2,12,217]),function(ue,e,y,R,r,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zN=e.$yN=void 0,e.$yN="remoteFilesystem";class I extends L.$xN{static register(p,w,A){const k=p.getConnection();if(!k)return R.$Sc.None;const v=new R.$Rc,u=(async()=>{try{const b=await p.getRawEnvironment();b?w.registerProvider(r.Schemas.vscodeRemote,v.add(new I(b,k))):A.error("Cannot register remote filesystem provider. Remote environment doesnot exist.")}catch(b){A.error("Cannot register remote filesystem provider. Error while fetching remote environment.",(0,y.$0)(b))}})();return v.add(w.onWillActivateFileSystemProvider(b=>{b.scheme===r.Schemas.vscodeRemote&&b.join(u)})),v}constructor(p,w){super(w.getChannel(e.$yN),{pathCaseSensitive:p.os===3})}}e.$zN=I}),define(be[94],we([1,0,29,14,7,8,21,169,303,304]),function(ue,e,y,R,r,L,I,C,p,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tp=e.$sp=e.zip=e.$qp=e.$pp=void 0,e.$pp="end of central directory record signature not found";const A=new RegExp(e.$pp);class k extends Error{constructor(i,o){let s=o.message;switch(i){case"CorruptZip":s=`Corrupt ZIP: ${s}`;break}super(s),this.type=i,this.cause=o}}e.$qp=k;function v(n){const i=n.externalFileAttributes>>16||33188;return[448,56,7].map(o=>i&o).reduce((o,s)=>o+s,i&61440)}function u(n){if(n instanceof k)return n;let i;return A.test(n.message)&&(i="CorruptZip"),new k(i,n)}function b(n,i,o,s,t,a){const f=r.$mc(i),S=r.$jc(s,f);if(!S.startsWith(s))return Promise.reject(new Error(C.localize(0,null,i)));const D=r.$jc(s,i);let E;return a.onCancellationRequested(()=>{E?.destroy()}),Promise.resolve(I.Promises.mkdir(S,{recursive:!0})).then(()=>new Promise((P,M)=>{if(!a.isCancellationRequested)try{E=(0,y.createWriteStream)(D,{mode:o}),E.once("close",()=>P()),E.once("error",M),n.once("error",M),n.pipe(E)}catch(ee){M(ee)}}))}function m(n,i,o,s){let t=(0,R.$Ig)(()=>Promise.resolve()),a=0;const f=s.onCancellationRequested(()=>{t.cancel(),n.close()});return new Promise((S,D)=>{const E=new R.$Pg,P=M=>{M.isCancellationRequested||(a++,n.readEntry())};n.once("error",D),n.once("close",()=>t.then(()=>{s.isCancellationRequested||n.entryCount===a?S():D(new k("Incomplete",new Error(C.localize(1,null,a,n.entryCount))))},D)),n.readEntry(),n.on("entry",M=>{if(s.isCancellationRequested)return;if(!o.sourcePathRegex.test(M.fileName)){P(s);return}const ee=M.fileName.replace(o.sourcePathRegex,"");if(/\/$/.test(ee)){const ne=r.$jc(i,ee);t=(0,R.$Ig)(he=>I.Promises.mkdir(ne,{recursive:!0}).then(()=>P(he)).then(void 0,D));return}const se=h(n,M),G=v(M);t=(0,R.$Ig)(ne=>E.queue(()=>se.then(he=>b(he,ee,G,i,o,ne).then(()=>P(ne)))).then(null,D))})}).finally(()=>f.dispose())}function d(n,i=!1){return new Promise((o,s)=>{(0,p.open)(n,i?{lazyEntries:!0}:void 0,(t,a)=>{t?s(u(t)):o((0,L.$Kf)(a))})})}function h(n,i){return new Promise((o,s)=>{n.openReadStream(i,(t,a)=>{t?s(u(t)):o((0,L.$Kf)(a))})})}function g(n,i){return new Promise((o,s)=>{const t=new w.ZipFile;i.forEach(f=>{f.contents?t.addBuffer(typeof f.contents=="string"?Buffer.from(f.contents,"utf8"):f.contents,f.path):f.localPath&&t.addFile(f.localPath,f.path)}),t.end();const a=(0,y.createWriteStream)(n);t.outputStream.pipe(a),t.outputStream.once("error",s),a.once("error",s),a.once("finish",()=>o(n))})}e.zip=g;function l(n,i,o={},s){const t=new RegExp(o.sourcePath?`^${o.sourcePath}`:"");let a=d(n,!0);return o.overwrite&&(a=a.then(f=>I.Promises.rm(i).then(()=>f))),a.then(f=>m(f,i,{sourcePathRegex:t},s))}e.$sp=l;function $(n,i){return d(n).then(o=>new Promise((s,t)=>{o.on("entry",a=>{a.fileName===i&&h(o,a).then(f=>s(f),f=>t(f))}),o.once("close",()=>t(new Error(C.localize(2,null,i))))}))}function c(n,i){return $(n,i).then(o=>new Promise((s,t)=>{const a=[];o.once("error",t),o.on("data",f=>a.push(f)),o.on("end",()=>s(Buffer.concat(a)))}))}e.$tp=c}),define(be[286],we([1,0,14,11,2,12,19,53,8,23,21,94,24,25,30,36,82,16,13]),function(ue,e,y,R,r,L,I,C,p,w,A,k,v,u,b,m,d,h,g){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ip=void 0;let $=l=class extends r.$Sc{constructor(n,i,o,s,t,a){super(),this.h=i,this.j=o,this.m=s,this.n=t,this.r=a,this.extensionsDownloadDir=n.extensionsDownloadLocation,this.f=20,this.g=this.y()}async download(n,i,o){await this.g;const s=(0,I.$wg)(this.extensionsDownloadDir,this.z(n));try{await this.w(n,s,a=>this.j.download(n,a,i))}catch(a){throw new b.$do(a.message,b.ExtensionManagementErrorCode.Download)}let t=!1;if(o&&this.t(n)){const a=await this.u(n);try{t=await this.n.verify(s.fsPath,a.fsPath,this.r.getLevel()===g.LogLevel.Trace)}catch(f){const S=f;if(t=S.code,S.output&&this.r.trace(`Extension signature verification details for ${n.identifier.id} ${n.version}:
${S.output}`),t===b.ExtensionSignaturetErrorCode.PackageIsInvalidZip||t===b.ExtensionSignaturetErrorCode.SignatureArchiveIsInvalidZip)throw new b.$do(k.$pp,b.ExtensionManagementErrorCode.CorruptZip)}finally{try{await this.delete(a)}catch(f){this.r.error(f)}}}return t===!0?this.r.info(`Extension signature is verified: ${n.identifier.id}`):t===!1?this.r.info(`Extension signature verification is not done: ${n.identifier.id}`):this.r.warn(`Extension signature verification failed with error '${t}': ${n.identifier.id}`),{location:s,verificationStatus:t}}t(n){if(!n.isSigned)return!1;const i=this.m.getValue("extensions.verifySignature");return(0,p.$Ff)(i)?i:!0}async u(n){await this.g;const i=(0,I.$wg)(this.extensionsDownloadDir,`${this.z(n)}${l.c}`);return await this.w(n,i,o=>this.j.downloadSignatureArchive(n,o)),i}async w(n,i,o){if(await this.h.exists(i))return;if(i.scheme!==L.Schemas.file){await o(i);return}const s=(0,I.$wg)(this.extensionsDownloadDir,`.${(0,w.$fg)()}`);await this.h.exists(s)||await o(s);try{await A.Promises.rename(s.fsPath,i.fsPath,2*60*1e3)}catch(t){try{await this.h.del(s)}catch{}if(t.code==="ENOTEMPTY")this.r.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",n.identifier.id,i.path);else throw this.r.info(`Rename failed because of ${(0,R.$0)(t)}. Deleted the file from downloaded location`,s.path),t}}async delete(n){await this.g,await this.h.del(n)}async y(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.r.trace("Extension VSIX downloads cache dir does not exist");return}const n=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(n.children){const i=[],o=[],s=[];for(const f of n.children)if(f.name.endsWith(l.c))s.push(f.resource);else{const S=m.$Fo.parse(f.name);S&&o.push([S,f])}const t=(0,m.$Ko)(o,([f])=>f),a=[];for(const f of t)f.sort((S,D)=>C.rcompare(S[0].version,D[0].version)),i.push(...f.slice(1).map(S=>S[1].resource)),a.push(f[0][1]);a.sort((f,S)=>f.mtime-S.mtime),i.push(...a.slice(0,Math.max(0,a.length-this.f)).map(f=>f.resource)),i.push(...s),await y.Promises.settled(i.map(f=>(this.r.trace("Deleting from cache",f.path),this.h.del(f))))}}catch(n){this.r.error(n)}}z(n){return this.f?m.$Fo.create(n).toString().toLowerCase():(0,w.$fg)()}};e.$Ip=$,$.c=".sigzip",e.$Ip=$=l=Re([Ae(0,u.$Yh),Ae(1,h.$_j),Ae(2,b.$co),Ae(3,v.$ki),Ae(4,d.$jp),Ae(5,g.$$i)],$)}),define(be[287],we([1,0,94,183]),function(ue,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kp=void 0;function r(L){return(0,y.$tp)(L,"extension/package.json").then(I=>{try{return JSON.parse(I.toString("utf8"))}catch{throw new Error((0,R.localize)(0,null))}})}e.$Kp=r}),define(be[138],we([1,0,14,15,20,40,11,5,62,2,26,12,7,19,53,8,4,23,21,94,182,81,25,256,30,36,45,58,286,257,287,231,240,80,16,6,13,31,32,34,33]),function(ue,e,y,R,r,L,I,C,p,w,A,k,v,u,b,m,d,h,g,l,$,c,n,i,o,s,t,a,f,S,D,E,P,M,ee,se,G,ne,he,Z,fe){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qp=e.$Pp=e.$Op=e.$Np=void 0,e.$Np=(0,se.$Rh)(o.$eo);const V=".vsctmp";let ie=class extends i.$up{constructor(q,Q,O,N,U,T,z,B,te,H,x,W){super(q,Q,x,O,H,W),this.fb=U,this.gb=T,this.hb=z,this.ib=te,this.eb=new Map,this.rb=new A.$Bc;const X=this.B(B.createInstance(S.$Jp));this.bb=this.B(B.createInstance(Y,ge=>X.postUninstall(ge))),this.cb=this.B(new E.$Lp(W,te,x,this,this.F)),this.db=this.B(B.createInstance(f.$Ip));const ae=this.B(new P.$Mp(this,this.fb,W,T,x,te,O));this.B(ae.onDidChangeExtensionsByAnotherSource(ge=>this.qb(ge))),this.sb()}getTargetPlatform(){return this.jb||(this.jb=(0,s.$Po)(this.ib,this.F)),this.jb}async zip(q){this.F.trace("ExtensionManagementService#zip",q.identifier.id);const Q=await this.pb(q),O=await(0,l.zip)((0,u.$wg)(this.db.extensionsDownloadDir,(0,h.$fg)()).fsPath,Q);return d.URI.file(O)}async unzip(q){return this.F.trace("ExtensionManagementService#unzip",q.toString()),(await this.install(q)).identifier}async getManifest(q){const{location:Q,cleanup:O}=await this.lb(q),N=v.$kc(Q.fsPath);try{return await(0,D.$Kp)(N)}finally{await O()}}getInstalled(q,Q=this.H.defaultProfile.extensionsResource){return this.bb.scanExtensions(q??null,Q)}scanAllUserInstalledExtensions(){return this.bb.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(q){return this.bb.scanUserExtensionAtLocation(q)}async install(q,Q={}){this.F.trace("ExtensionManagementService#install",q.toString());const{location:O,cleanup:N}=await this.lb(q);try{const U=await(0,D.$Kp)(v.$kc(O.fsPath)),T=(0,s.$Jo)(U.publisher,U.name);if(U.engines&&U.engines.vscode&&!(0,M.$Wo)(U.engines.vscode,this.G.version,this.G.date))throw new Error($.localize(0,null,T,this.G.version));const B=(await this.I([{manifest:U,extension:O,options:Q}])).find(({identifier:te})=>(0,s.$Eo)(te,{id:T}));if(B?.local)return B.local;throw B?.error?B.error:(0,i.$wp)(new Error(`Unknown error while installing extension ${T}`))}finally{await N()}}async installFromLocation(q,Q){this.F.trace("ExtensionManagementService#installFromLocation",q.toString());const O=await this.bb.scanUserExtensionAtLocation(q);if(!O)throw new Error(`Cannot find a valid extension from the location ${q.toString()}`);return await this.ub([[O,void 0]],Q),this.F.info("Successfully installed extension",O.identifier.id,Q.toString()),O}async installExtensionsFromProfile(q,Q,O){this.F.trace("ExtensionManagementService#installExtensionsFromProfile",q,Q.toString(),O.toString());const N=(await this.bb.scanExtensions(1,Q)).filter(U=>q.some(T=>(0,s.$Eo)(T,U.identifier)));if(N.length){const U=await Promise.all(N.map(T=>this.bb.scanMetadata(T,Q)));await this.ub(N.map((T,z)=>[T,U[z]]),O),this.F.info("Successfully installed extensions",N.map(T=>T.identifier.id),O.toString())}return N}async updateMetadata(q,Q,O=this.H.defaultProfile.extensionsResource){return this.F.trace("ExtensionManagementService#updateMetadata",q.identifier.id),Q.isPreReleaseVersion&&(Q.preRelease=!0),Q.isMachineScoped===!1&&(Q.isMachineScoped=void 0),Q.isBuiltin===!1&&(Q.isBuiltin=void 0),Q.pinned===!1&&(Q.pinned=void 0),q=await this.bb.updateMetadata(q,Q,O),this.cb.invalidate(O),this.w.fire(q),q}async reinstallFromGallery(q){if(this.F.trace("ExtensionManagementService#reinstallFromGallery",q.identifier.id),!this.z.isEnabled())throw new Error($.localize(1,null));const Q=await this.getTargetPlatform(),[O]=await this.z.getExtensions([{...q.identifier,preRelease:q.preRelease}],{targetPlatform:Q,compatible:!0},r.CancellationToken.None);if(!O)throw new Error($.localize(2,null));await this.bb.setUninstalled(q);try{await this.bb.removeUninstalledExtension(q)}catch(N){throw new Error($.localize(3,null,(0,L.$Bi)(N)))}return this.installFromGallery(O)}ab(q,Q,O,N){return this.bb.copyExtension(q,Q,O,N)}copyExtensions(q,Q){return this.bb.copyExtensions(q,Q)}markAsUninstalled(...q){return this.bb.setUninstalled(...q)}async cleanUp(){this.F.trace("ExtensionManagementService#cleanUp");try{await this.bb.cleanUp()}catch(q){this.F.error(q)}}async download(q,Q,O){const{location:N}=await this.db.download(q,Q,!O);return N}async lb(q){if(q.scheme===k.Schemas.file)return{location:q,async cleanup(){}};this.F.trace("Downloading extension from",q.toString());const Q=(0,u.$wg)(this.db.extensionsDownloadDir,(0,h.$fg)());return await this.hb.download(q,Q),this.F.info("Downloaded extension to",Q.toString()),{location:Q,cleanup:async()=>{try{await this.ib.del(Q)}catch(N){this.F.error(N)}}}}Y(){return this.H.defaultProfile.extensionsResource}Z(q,Q,O){if(d.URI.isUri(Q))return new ce(q,Q,O,this.z,this.bb,this.D,this.H,this.fb,this.gb,this.F);const N=s.$Fo.create(Q).toString();let U=this.eb.get(N);return U||(this.eb.set(N,U=new re(q,Q,O,this.db,this.bb,this.D,this.H,this.fb,this.gb,this.F)),U.waitUntilTaskIsFinished().finally(()=>this.eb.delete(N))),U}$(q,Q){return new oe(q,Q.profileLocation,this.gb)}async pb(q){const Q=async N=>{let U=await g.Promises.readdir(N);U=U.map(B=>v.$jc(N,B));const T=await Promise.all(U.map(B=>g.Promises.stat(B)));let z=Promise.resolve([]);return T.forEach((B,te)=>{const H=U[te];B.isFile()&&(z=z.then(x=>[...x,H])),B.isDirectory()&&(z=z.then(x=>Q(H).then(W=>[...x,...W])))}),z};return(await Q(q.location.fsPath)).map(N=>({path:`extension/${v.$lc(q.location.fsPath,N)}`,localPath:N}))}async qb({added:q,removed:Q}){if(Q){const O=q&&this.D.extUri.isEqual(Q.profileLocation,q.profileLocation)?Q.extensions.filter(N=>q.extensions.every(U=>!(0,s.$Eo)(U,N))):Q.extensions;for(const N of O)this.F.info("Extensions removed from another source",N.id,Q.profileLocation.toString()),this.u.fire({identifier:N,profileLocation:Q.profileLocation})}if(q){const N=(await this.bb.scanExtensions(1,q.profileLocation)).filter(U=>q.extensions.some(T=>(0,s.$Eo)(T,U.identifier)));this.s.fire(N.map(U=>(this.F.info("Extensions added from another source",U.identifier.id,q.profileLocation.toString()),{identifier:U.identifier,local:U,profileLocation:q.profileLocation,operation:1})))}}async sb(){this.B(this.bb.onExtract(Q=>this.rb.add(Q)));const q=await this.ib.resolve(this.fb.userExtensionsLocation);for(const Q of q.children??[])Q.isDirectory&&this.rb.add(Q.resource);this.B(this.ib.watch(this.fb.userExtensionsLocation)),this.B(this.ib.onDidFilesChange(Q=>this.tb(Q)))}async tb(q){if(!q.affects(this.fb.userExtensionsLocation,1))return;const Q=[];for(const O of q.rawAdded){if(this.rb.has(O)||!this.D.extUri.isEqual(this.D.extUri.dirname(O),this.fb.userExtensionsLocation)||this.D.extUri.isEqual(O,this.D.extUri.joinPath(this.fb.userExtensionsLocation,".obsolete"))||this.D.extUri.basename(O).startsWith(".")||!(await this.ib.stat(O)).isDirectory)continue;const N=await this.bb.scanUserExtensionAtLocation(O);N&&N.installedTimestamp===void 0&&(this.rb.add(O),Q.push(N))}Q.length&&(await this.ub(Q.map(O=>[O,void 0]),this.H.defaultProfile.extensionsResource),this.F.info("Added extensions to default profile from external source",Q.map(O=>O.identifier.id)))}async ub(q,Q){const O=q.map(N=>N[0]);await this.vb(O),await this.gb.addExtensionsToProfile(q,Q),this.s.fire(O.map(N=>({local:N,identifier:N.identifier,operation:1,profileLocation:Q})))}async vb(q){const Q=await this.bb.getUninstalledExtensions();for(const O of q){const N=s.$Fo.create(O);Q[N.toString()]&&(this.F.trace("Removing the extension from uninstalled list:",N.id),await this.bb.setInstalled(N),this.F.info("Removed the extension from uninstalled list:",N.id))}}};e.$Op=ie,e.$Op=ie=Re([Ae(0,o.$co),Ae(1,he.$dl),Ae(2,G.$$i),Ae(3,n.$Yh),Ae(4,a.$Dp),Ae(5,t.$zp),Ae(6,c.$Tn),Ae(7,se.$Ph),Ae(8,ee.$_j),Ae(9,ne.$qj),Ae(10,Z.$Jk),Ae(11,fe.$Lk)],ie);let Y=class extends w.$Sc{constructor(q,Q,O,N,U,T){super(),this.j=q,this.m=Q,this.n=O,this.s=N,this.t=U,this.u=T,this.h=this.B(new C.$Od),this.onExtract=this.h.event,this.c=(0,u.$wg)(this.n.userExtensionsLocation,".obsolete"),this.g=new y.$2g}async cleanUp(){await this.H(),await this.G()}async scanExtensions(q,Q){const O={includeInvalid:!0,profileLocation:Q};let N=[];return q===null||q===0?N.push(...await this.n.scanAllExtensions({includeInvalid:!0},O,!1)):q===1&&N.push(...await this.n.scanUserExtensions(O)),N=q!==null?N.filter(U=>U.type===q):N,Promise.all(N.map(U=>this.F(U)))}async scanAllUserExtensions(q){const Q=await this.n.scanUserExtensions({includeAllVersions:!q,includeInvalid:!0});return Promise.all(Q.map(O=>this.F(O)))}async scanUserExtensionAtLocation(q){try{const Q=await this.n.scanExistingExtension(q,1,{includeInvalid:!0});if(Q)return await this.F(Q)}catch(Q){this.u.error(Q)}return null}async extractUserExtension(q,Q,O,N,U){const T=q.toString(),z=d.URI.file(v.$jc(this.n.userExtensionsLocation.fsPath,`.${(0,h.$fg)()}`)),B=d.URI.file(v.$jc(this.n.userExtensionsLocation.fsPath,T));let te=await this.m.exists(B);if(te&&N){try{await this.y(q.id,B,"removeExisting")}catch{throw new o.$do($.localize(4,null,B.fsPath,q.id),o.ExtensionManagementErrorCode.Delete)}te=!1}if(!te)try{try{this.u.trace(`Started extracting the extension from ${Q} to ${B.fsPath}`),await(0,l.$sp)(Q,z.fsPath,{sourcePath:"extension",overwrite:!0},U),this.u.info(`Extracted extension to ${B}:`,q.id)}catch(H){let x=o.ExtensionManagementErrorCode.Extract;throw H instanceof l.$qp&&(H.type==="CorruptZip"?x=o.ExtensionManagementErrorCode.CorruptZip:H.type==="Incomplete"&&(x=o.ExtensionManagementErrorCode.IncompleteZip)),new o.$do(H.message,x)}await this.n.updateMetadata(z,O);try{this.u.trace(`Started renaming the extension from ${z.fsPath} to ${B.fsPath}`),await this.C(z.fsPath,B.fsPath),this.u.info("Renamed to",B.fsPath)}catch(H){if(H.code==="ENOTEMPTY")this.u.info("Rename failed because extension was installed by another source. So ignoring renaming.",q.id);else throw this.u.info(`Rename failed because of ${(0,I.$0)(H)}. Deleted from extracted location`,z),H}this.h.fire(B)}catch(H){try{await this.m.del(z,{recursive:!0})}catch{}throw H}return this.D(B,1)}async scanMetadata(q,Q){return Q?(await this.w(q,Q))?.metadata:this.n.scanMetadata(q.location)}async w(q,Q){return(await this.s.scanProfileExtensions(Q)).find(N=>(0,s.$Eo)(N.identifier,q.identifier))}async updateMetadata(q,Q,O){return O?await this.s.updateMetadata([[q,Q]],O):await this.n.updateMetadata(q.location,Q),this.D(q.location,q.type,O)}getUninstalledExtensions(){return this.z()}async setUninstalled(...q){const Q=q.map(O=>s.$Fo.create(O));await this.z(O=>Q.forEach(N=>{O[N.toString()]=!0,this.u.info("Marked extension as uninstalled",N.toString())}))}async setInstalled(q){await this.z(Q=>delete Q[q.toString()])}async removeExtension(q,Q){if(this.t.extUri.isEqualOrParent(q.location,this.n.userExtensionsLocation))return this.y(q.identifier.id,q.location,Q)}async removeUninstalledExtension(q){await this.removeExtension(q,"uninstalled"),await this.z(Q=>delete Q[s.$Fo.create(q).toString()])}async copyExtension(q,Q,O,N){const U=await this.w(q,Q),T=await this.w(q,O);return N={...U?.metadata,...N},T?await this.s.updateMetadata([[q,{...T.metadata,...N}]],O):await this.s.addExtensionsToProfile([[q,N]],O),this.D(q.location,q.type,O)}async copyExtensions(q,Q){const O=await this.scanExtensions(1,q),N=await Promise.all(O.filter(U=>!U.isApplicationScoped).map(async U=>[U,await this.scanMetadata(U,q)]));await this.s.addExtensionsToProfile(N,Q)}async y(q,Q,O){this.u.trace(`Deleting ${O} extension from disk`,q,Q.fsPath);const N=this.t.extUri.joinPath(this.t.extUri.dirname(Q),`${this.t.extUri.basename(Q)}.${(0,p.$Ei)((0,h.$fg)()).toString(16)}${V}`);await this.C(Q.fsPath,N.fsPath),await this.m.del(N,{recursive:!0}),this.u.info(`Deleted ${O} extension from disk`,q,Q.fsPath)}async z(q){return this.g.queue(async()=>{let Q;try{Q=(await this.m.readFile(this.c,"utf8")).value.toString()}catch(N){if((0,ee.$qk)(N)!==1)throw N}let O={};if(Q)try{O=JSON.parse(Q)}catch{}return q&&(q(O),Object.keys(O).length?await this.m.writeFile(this.c,R.$ce.fromString(JSON.stringify(O))):await this.m.del(this.c)),O})}async C(q,Q){try{await g.Promises.rename(q,Q,2*60*1e3)}catch(O){throw new o.$do(O.message||$.localize(5,null,q,Q),O.code||o.ExtensionManagementErrorCode.Rename)}}async D(q,Q,O){if(O){const U=(await this.n.scanUserExtensions({profileLocation:O})).find(T=>this.t.extUri.isEqual(T.location,q));if(U)return this.F(U)}else{const N=await this.n.scanExistingExtension(q,Q,{includeInvalid:!0});if(N)return this.F(N)}throw new Error($.localize(6,null,q.path))}async F(q){const Q=await this.m.resolve(q.location);let O,N;return Q.children&&(O=Q.children.find(({name:U})=>/^readme(\.txt|\.md|)$/i.test(U))?.resource,N=Q.children.find(({name:U})=>/^changelog(\.txt|\.md|)$/i.test(U))?.resource),{identifier:q.identifier,type:q.type,isBuiltin:q.isBuiltin||!!q.metadata?.isBuiltin,location:q.location,manifest:q.manifest,targetPlatform:q.targetPlatform,validations:q.validations,isValid:q.isValid,readmeUrl:O,changelogUrl:N,publisherDisplayName:q.metadata?.publisherDisplayName||null,publisherId:q.metadata?.publisherId||null,isApplicationScoped:!!q.metadata?.isApplicationScoped,isMachineScoped:!!q.metadata?.isMachineScoped,isPreReleaseVersion:!!q.metadata?.isPreReleaseVersion,preRelease:!!q.metadata?.preRelease,installedTimestamp:q.metadata?.installedTimestamp,updated:!!q.metadata?.updated,pinned:!!q.metadata?.pinned}}async G(){const q=await this.getUninstalledExtensions();if(Object.keys(q).length===0){this.u.debug("No uninstalled extensions found.");return}this.u.debug("Removing uninstalled extensions:",Object.keys(q));const Q=await this.n.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),O=new Set;for(const U of Q)q[s.$Fo.create(U).toString()]||O.add(U.identifier.id.toLowerCase());try{const U=(0,s.$Ko)(Q,T=>T.identifier);await y.Promises.settled(U.map(async T=>{const z=T.sort((B,te)=>b.rcompare(B.manifest.version,te.manifest.version))[0];O.has(z.identifier.id.toLowerCase())||await this.j(await this.F(z))}))}catch(U){this.u.error(U)}const N=Q.filter(U=>U.metadata&&q[s.$Fo.create(U).toString()]);await Promise.allSettled(N.map(U=>this.removeUninstalledExtension(U)))}async H(){this.u.trace("ExtensionManagementService#removeTempDeleteFolders");let q;try{q=await this.m.resolve(this.n.userExtensionsLocation)}catch(Q){(0,ee.$qk)(Q)!==1&&this.u.error(Q);return}if(q?.children)try{await Promise.allSettled(q.children.map(async Q=>{if(!(!Q.isDirectory||!Q.name.endsWith(V))){this.u.trace("Deleting the temporarily deleted folder",Q.resource.toString());try{await this.m.del(Q.resource,{recursive:!0}),this.u.trace("Deleted the temporarily deleted folder",Q.resource.toString())}catch(O){(0,ee.$qk)(O)!==1&&this.u.error(O)}}}))}catch{}}};e.$Pp=Y,e.$Pp=Y=Re([Ae(1,ee.$_j),Ae(2,a.$Dp),Ae(3,t.$zp),Ae(4,Z.$Jk),Ae(5,G.$$i)],Y);class J extends i.$xp{get profileLocation(){return this.j}get verificationStatus(){return this.k}get operation(){return(0,m.$Gf)(this.options.operation)?this.l:this.options.operation}constructor(q,Q,O,N,U,T,z,B,te){super(),this.identifier=q,this.source=Q,this.options=O,this.m=N,this.n=U,this.o=T,this.p=z,this.q=B,this.s=te,this.j=this.options.profileLocation,this.k=!1,this.l=2}async h(q){const[Q,O]=await this.x(q);return this.j=Q.isBuiltin||Q.isApplicationScoped?this.o.defaultProfile.extensionsResource:this.options.profileLocation,this.n.extUri.isEqual(this.o.defaultProfile.extensionsResource,this.j)&&await this.p.initializeDefaultProfileExtensions(),await this.q.addExtensionsToProfile([[Q,O]],this.j),Q}async u({zipPath:q,key:Q,metadata:O},N,U){let T=await this.v(Q);return T||(this.s.trace("Extracting extension...",Q.id),T=await this.m.extractUserExtension(Q,q,O,N,U),this.s.info("Extracting extension completed.",Q.id)),T}async v(q){return await this.w(q)?(this.s.trace("Removing the extension from uninstalled list:",q.id),await this.m.setInstalled(q),this.s.info("Removed the extension from uninstalled list:",q.id),(await this.m.scanAllUserExtensions(!0)).find(N=>s.$Fo.create(N).equals(q))):void 0}async w(q){return!!(await this.m.getUninstalledExtensions())[q.toString()]}}class re extends J{constructor(q,Q,O,N,U,T,z,B,te,H){super(Q.identifier,Q,O,U,T,z,B,te,H),this.y=Q,this.z=N}async x(q){const O=(await this.m.scanExtensions(null,this.options.profileLocation)).find(z=>(0,s.$Eo)(z.identifier,this.y.identifier));O&&(this.l=3);const N={id:this.y.identifier.uuid,publisherId:this.y.publisherId,publisherDisplayName:this.y.publisherDisplayName,targetPlatform:this.y.properties.targetPlatform,isApplicationScoped:this.options.isApplicationScoped||O?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||O?.isMachineScoped,isBuiltin:this.options.isBuiltin||O?.isBuiltin,isSystem:O?.type===0?!0:void 0,updated:!!O,isPreReleaseVersion:this.y.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:void 0,preRelease:this.y.properties.isPreReleaseVersion||((0,m.$Ff)(this.options.installPreReleaseVersion)?this.options.installPreReleaseVersion:O?.preRelease)};if(O?.manifest.version===this.y.version)return[await this.m.updateMetadata(O,N),N];const{location:U,verificationStatus:T}=await this.z.download(this.y,this.l,!this.options.donotVerifySignature);try{return this.k=T,this.B(U.fsPath),[await this.u({zipPath:U.fsPath,key:s.$Fo.create(this.y),metadata:N},!1,q),N]}catch(z){try{await this.z.delete(U)}catch(B){this.s.warn("Error while deleting the downloaded file",U.toString(),(0,I.$0)(B))}throw z}}async B(q){try{await(0,D.$Kp)(q)}catch(Q){throw new o.$do((0,i.$vp)(Q).message,o.ExtensionManagementErrorCode.Invalid)}}}e.$Qp=re;class ce extends J{constructor(q,Q,O,N,U,T,z,B,te,H){super({id:(0,s.$Jo)(q.publisher,q.name)},Q,O,U,T,z,B,te,H),this.y=q,this.z=Q,this.A=N}async h(q){const Q=await super.h(q);return this.D(Q,q),Q}async x(q){const Q=new s.$Fo(this.identifier,this.y.version),N=(await this.m.scanExtensions(1,this.options.profileLocation)).find(z=>(0,s.$Eo)(this.identifier,z.identifier)),U={isApplicationScoped:this.options.isApplicationScoped||N?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||N?.isMachineScoped,isBuiltin:this.options.isBuiltin||N?.isBuiltin,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:void 0};if(N)if(this.l=3,Q.equals(new s.$Fo(N.identifier,N.manifest.version)))try{await this.m.removeExtension(N,"existing")}catch{throw new Error($.localize(7,null,this.y.displayName||this.y.name))}else!this.options.profileLocation&&b.gt(N.manifest.version,this.y.version)&&await this.m.setUninstalled(N);else{const z=await this.v(Q);if(z)try{await this.m.removeExtension(z,"existing")}catch{throw new Error($.localize(8,null,this.y.displayName||this.y.name))}}return[await this.u({zipPath:v.$kc(this.z.fsPath),key:Q,metadata:U},!0,q),U]}async D(q,Q){try{let[O]=await this.A.getExtensions([{id:q.identifier.id,version:q.manifest.version}],Q);if(O||([O]=await this.A.getExtensions([{id:q.identifier.id}],Q)),O){const N={id:O.identifier.uuid,publisherDisplayName:O.publisherDisplayName,publisherId:O.publisherId,isPreReleaseVersion:O.properties.isPreReleaseVersion,preRelease:O.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.m.updateMetadata(q,N,this.options.profileLocation)}}catch{}}}class oe extends i.$xp{constructor(q,Q,O){super(),this.extension=q,this.j=Q,this.k=O}async h(q){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(be[72],we([1,0,87,79,27,288,15,11,5,2,7,3,23,42,106]),function(ue,e,y,R,r,L,I,C,p,w,A,k,v,u,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mh=e.$Lh=e.$Kh=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.$Fh=void 0;class m{traceSocketEvent(E,P){b.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,E,P)}constructor(E,P=""){this.f=!0,this.debugLabel=P,this.socket=E,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=M=>{if(this.traceSocketEvent("error",{code:M?.code,message:M?.message}),M){if(M.code==="EPIPE")return;(0,C.$1)(M)}},this.socket.on("error",this.a),this.b=M=>{this.traceSocketEvent("close",{hadError:M}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(E){const P=M=>{this.traceSocketEvent("read",M),E(I.$ce.wrap(M))};return this.socket.on("data",P),{dispose:()=>this.socket.off("data",P)}}onClose(E){const P=M=>{E({type:0,hadError:M,error:void 0})};return this.socket.on("close",P),{dispose:()=>this.socket.off("close",P)}}onEnd(E){const P=()=>{E()};return this.socket.on("end",P),{dispose:()=>this.socket.off("end",P)}}write(E){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",E),this.socket.write(E.buffer,P=>{if(P){if(P.code==="EPIPE")return;(0,C.$1)(P)}})}catch(P){if(P.code==="EPIPE")return;(0,C.$1)(P)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((E,P)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),E();return}const M=()=>{this.socket.off("close",M),this.socket.off("end",M),this.socket.off("error",M),this.socket.off("timeout",M),this.socket.off("drain",M),this.traceSocketEvent("nodeDrainEnd"),E()};this.socket.on("close",M),this.socket.on("end",M),this.socket.on("error",M),this.socket.on("timeout",M),this.socket.on("drain",M)})}}e.$Fh=m;var d;(function(D){D[D.MinHeaderByteSize=2]="MinHeaderByteSize",D[D.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(d||(d={}));var h;(function(D){D[D.PeekHeader=1]="PeekHeader",D[D.ReadHeader=2]="ReadHeader",D[D.ReadBody=3]="ReadBody",D[D.Fin=4]="Fin"})(h||(h={}));class g extends w.$Sc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(E,P){this.socket.traceSocketEvent(E,P)}constructor(E,P,M,ee){super(),this.f=this.B(new p.$Od),this.g=this.B(new p.$Od),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=E,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:P,inflateBytesLength:M?.byteLength||0,recordInflateBytes:ee}),this.a=this.B(new l(this,P,M,ee,this.f,(se,G)=>this.m(se,G))),this.B(this.a.onError(se=>{console.error(se),(0,C.$1)(se),this.g.fire({type:0,hadError:!0,error:se})})),this.b=new b.$Ah,this.B(this.socket.onData(se=>this.n(se))),this.B(this.socket.onClose(async se=>{this.a.isProcessingReadQueue()&&await p.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(se)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(E){return this.f.event(E)}onClose(E){return this.g.event(E)}onEnd(E){return this.socket.onEnd(E)}write(E){let P=0;for(;P<E.byteLength;)this.a.writeMessage(E.slice(P,Math.min(P+262144,E.byteLength)),{compressed:!0,opcode:2}),P+=262144}m(E,{compressed:P,opcode:M}){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",E);let ee=2;E.byteLength<126?ee+=0:E.byteLength<2**16?ee+=2:ee+=8;const se=I.$ce.alloc(ee),G=P?64:0,ne=M&15;if(se.writeUInt8(128|G|ne,0),E.byteLength<126)se.writeUInt8(E.byteLength,1);else if(E.byteLength<2**16){se.writeUInt8(126,1);let he=1;se.writeUInt8(E.byteLength>>>8&255,++he),se.writeUInt8(E.byteLength>>>0&255,++he)}else{se.writeUInt8(127,1);let he=1;se.writeUInt8(0,++he),se.writeUInt8(0,++he),se.writeUInt8(0,++he),se.writeUInt8(0,++he),se.writeUInt8(E.byteLength>>>24&255,++he),se.writeUInt8(E.byteLength>>>16&255,++he),se.writeUInt8(E.byteLength>>>8&255,++he),se.writeUInt8(E.byteLength>>>0&255,++he)}this.socket.write(I.$ce.concat([se,E]))}end(){this.h=!0,this.socket.end()}n(E){if(E.byteLength!==0){for(this.b.acceptChunk(E);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const P=this.b.peek(this.j.readLen),M=P.readUInt8(0),ee=(M&128)>>>7,se=(M&64)>>>6,G=M&15,ne=P.readUInt8(1),he=(ne&128)>>>7,Z=ne&127;this.j.state=2,this.j.readLen=2+(he?4:0)+(Z===126?2:0)+(Z===127?8:0),this.j.fin=ee,this.j.firstFrameOfMessage&&(this.j.compressed=!!se),this.j.firstFrameOfMessage=!!ee,this.j.mask=0,this.j.opcode=G,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===2){const P=this.b.read(this.j.readLen),M=P.readUInt8(1),ee=(M&128)>>>7;let se=M&127,G=1;se===126?se=P.readUInt8(++G)*2**8+P.readUInt8(++G):se===127&&(se=P.readUInt8(++G)*0+P.readUInt8(++G)*0+P.readUInt8(++G)*0+P.readUInt8(++G)*0+P.readUInt8(++G)*2**24+P.readUInt8(++G)*2**16+P.readUInt8(++G)*2**8+P.readUInt8(++G));let ne=0;ee&&(ne=P.readUInt8(++G)*2**24+P.readUInt8(++G)*2**16+P.readUInt8(++G)*2**8+P.readUInt8(++G)),this.j.state=3,this.j.readLen=se,this.j.mask=ne,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===3){const P=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",P),n(P,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",P),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(P,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(P,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await p.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$Gh=g;class l extends w.$Sc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:I.$ce.alloc(0)}constructor(E,P,M,ee,se,G){super(),this.n=E,this.r=se,this.s=G,this.a=this.B(new p.$Od),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new p.$Od),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new p.$Od),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,P?(this.b=this.B(new $(this.n,ee,M,{windowBits:15})),this.f=this.B(new c(this.n,{windowBits:15})),this.B(this.b.onError(ne=>this.a.fire(ne))),this.B(this.f.onError(ne=>this.a.fire(ne)))):(this.b=null,this.f=null)}writeMessage(E,P){this.g.push({data:E,options:P}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:E,options:P}=this.g.shift();if(this.f&&P.compressed){const M=await this.w(this.f,E);this.s(M,P)}else this.s(E,{...P,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(E,P){return new Promise((M,ee)=>{E.write(P),E.flush(se=>M(se))})}acceptFrame(E,P,M){this.h.push({data:E,isCompressed:P,isLastFrameOfMessage:M}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const E=this.h.shift();if(this.b&&E.isCompressed){const P=await this.C(this.b,E.data,E.isLastFrameOfMessage);this.r.fire(P)}else this.r.fire(E.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(E,P,M){return new Promise((ee,se)=>{E.write(P),M&&E.write(I.$ce.fromByteArray([0,0,255,255])),E.flush(G=>ee(G))})}}class $ extends w.$Sc{get recordedInflateBytes(){return this.j?I.$ce.concat(this.f):I.$ce.alloc(0)}constructor(E,P,M,ee){super(),this.h=E,this.j=P,this.a=this.B(new p.$Od),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,L.createInflateRaw)(ee),this.b.on("error",se=>{this.h.traceSocketEvent("zlibInflateError",{message:se?.message,code:se?.code}),this.a.fire(se)}),this.b.on("data",se=>{this.h.traceSocketEvent("zlibInflateData",se),this.g.push(I.$ce.wrap(se))}),M&&(this.h.traceSocketEvent("zlibInflateInitialWrite",M.buffer),this.b.write(M.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(E){this.j&&this.f.push(E.clone()),this.h.traceSocketEvent("zlibInflateWrite",E),this.b.write(E.buffer)}flush(E){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const P=I.$ce.concat(this.g);this.g.length=0,E(P)})}}class c extends w.$Sc{constructor(E,P){super(),this.g=E,this.a=this.B(new p.$Od),this.onError=this.a.event,this.f=[],this.b=(0,L.createDeflateRaw)({windowBits:15}),this.b.on("error",M=>{this.g.traceSocketEvent("zlibDeflateError",{message:M?.message,code:M?.code}),this.a.fire(M)}),this.b.on("data",M=>{this.g.traceSocketEvent("zlibDeflateData",M),this.f.push(I.$ce.wrap(M))})}write(E){this.g.traceSocketEvent("zlibDeflateWrite",E.buffer),this.b.write(E.buffer)}flush(E){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let P=I.$ce.concat(this.f);this.f.length=0,P=P.slice(0,P.byteLength-4),E(P)})}}function n(D,E){if(E===0)return;const P=D.byteLength>>>2;for(let he=0;he<P;he++){const Z=D.readUInt32BE(he*4);D.writeUInt32BE(Z^E,he*4)}const M=P*4,ee=D.byteLength-M,se=E>>>24&255,G=E>>>16&255,ne=E>>>8&255;ee>=1&&D.writeUInt8(D.readUInt8(M)^se,M),ee>=2&&D.writeUInt8(D.readUInt8(M+1)^G,M+1),ee>=3&&D.writeUInt8(D.readUInt8(M+2)^ne,M+2)}e.$Hh=process.env.XDG_RUNTIME_DIR;const i={[2]:107,[1]:103};function o(){const D=(0,v.$fg)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${D}-sock`;const E=process.platform!=="darwin"&&e.$Hh?e.$Hh:(0,r.tmpdir)(),P=(0,A.$jc)(E,`vscode-ipc-${D}.sock`);return t(P),P}e.$Ih=o;function s(D,E,P){const M=(0,y.createHash)("md5").update(D).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${M}-${P}-${E}-sock`;const ee=P.substr(0,4),se=E.substr(0,6),G=M.substr(0,8);let ne;return process.platform!=="darwin"&&e.$Hh&&!process.env.VSCODE_PORTABLE?ne=(0,A.$jc)(e.$Hh,`vscode-${G}-${ee}-${se}.sock`):ne=(0,A.$jc)(D,`${ee}-${se}.sock`),t(ne),ne}e.$Jh=s;function t(D){const E=i[k.$o];typeof E=="number"&&D.length>=E&&console.warn(`WARNING: IPC handle "${D}" is longer than ${E} chars, try a shorter --user-data-dir`)}class a extends u.$uh{static b(E){const P=p.Event.fromNodeEventEmitter(E,"connection");return p.Event.map(P,M=>({protocol:new b.$Bh(new m(M,"ipc-server-connection")),onDidClientDisconnect:p.Event.once(p.Event.fromNodeEventEmitter(M,"close"))}))}constructor(E){super(a.b(E)),this.d=E}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$Kh=a;function f(D){return new Promise((E,P)=>{const M=(0,R.createServer)();M.on("error",P),M.listen(D,()=>{M.removeListener("error",P),E(new a(M))})})}e.$Lh=f;function S(D,E){return new Promise((P,M)=>{const ee=(0,R.createConnection)(D,()=>{ee.removeListener("error",M),P(b.$Ch.fromSocket(new m(ee,`ipc-client${E}`),E))});ee.once("error",M)})}e.$Mh=S}),define(be[139],we([1,0,85,14,15,11,8,24,25,86,13,44,234,288]),function(ue,e,y,R,r,L,I,C,p,w,A,k,v,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5q=e.$4q=void 0;let b=class extends k.$Yo{constructor(g,l,$,c){super(c),this.m=g,this.n=l,this.r=$,this.s(),this.B(g.onDidChangeConfiguration(n=>{n.affectsConfiguration("http")&&this.s()}))}s(){const g=this.m.getValue("http");this.f=g?.proxy,this.g=!!g?.proxyStrictSSL,this.h=g?.proxyAuthorization}async request(g,l){const{f:$,g:c}=this;let n;try{n=await(0,w.$Vl)(this.m,this.r,this.n.args,process.env)}catch(s){this.j||(this.j=!0,this.r.error("resolving shell environment failed",(0,L.$0)(s)))}const i={...process.env,...n},o=g.agent?g.agent:await(0,v.$3q)(g.url||"",i,{proxyUrl:$,strictSSL:c});return g.agent=o,g.strictSSL=c,this.h&&(g.headers={...g.headers||{},"Proxy-Authorization":this.h}),this.c(g.isChromiumNetwork?"electron":"node",g,()=>d(g,l))}async resolveProxy(g){}};e.$4q=b,e.$4q=b=Re([Ae(0,C.$ki),Ae(1,p.$Yh),Ae(2,A.$$i),Ae(3,A.$_i)],b);async function m(h){return((0,y.parse)(h.url).protocol==="https:"?await new Promise(($,c)=>{ue(["https"],$,c)}):await new Promise(($,c)=>{ue(["http"],$,c)})).request}async function d(h,g){return R.Promises.withAsyncBody(async(l,$)=>{const c=(0,y.parse)(h.url),n=h.getRawRequest?h.getRawRequest(h):await m(h),i={hostname:c.hostname,port:c.port?parseInt(c.port):c.protocol==="https:"?443:80,protocol:c.protocol,path:c.path,method:h.type||"GET",headers:h.headers,agent:h.agent,rejectUnauthorized:(0,I.$Ff)(h.strictSSL)?h.strictSSL:!0};h.user&&h.password&&(i.auth=h.user+":"+h.password);const o=n(i,s=>{const t=(0,I.$Df)(h.followRedirects)?h.followRedirects:3;if(s.statusCode&&s.statusCode>=300&&s.statusCode<400&&t>0&&s.headers.location)d({...h,url:s.headers.location,followRedirects:t-1},g).then(l,$);else{let a=s;!h.isChromiumNetwork&&s.headers["content-encoding"]==="gzip"&&(a=s.pipe((0,u.createGunzip)())),l({res:s,stream:(0,r.$re)(a)})}});o.on("error",$),h.timeout&&o.setTimeout(h.timeout),h.isChromiumNetwork&&o.removeHeader("Content-Length"),h.data&&typeof h.data=="string"&&o.write(h.data),o.end(),g.onCancellationRequested(()=>{o.abort(),$(new L.$5)})})}e.$5q=d}),define(be[140],we([1,0,52,79,91,12,7,15,5,72,86,13,46,3,60,128,2,276,24]),function(ue,e,y,R,r,L,I,C,p,w,A,k,v,u,b,m,d,h,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fm=e.$Em=void 0;async function l(s={},t,a,f,S,D){const E=await(0,r.$ol)(a,f.userDataPath);let P={};if(t)try{P=await(0,A.$Vl)(D,S,f.args,process.env)}catch(he){S.error("ExtensionHostConnection#buildUserEnvironment resolving shell environment failed",he)}const ee={...process.env,...P,VSCODE_AMD_ENTRYPOINT:"vs/workbench/api/node/extensionHostProcess",VSCODE_HANDLES_UNCAUGHT_ERRORS:"true",VSCODE_NLS_CONFIG:JSON.stringify(E,void 0,0),...s},se=f.isBuilt?(0,I.$jc)(f.appRoot,"bin"):(0,I.$jc)(f.appRoot,"resources","server","bin-dev"),G=(0,I.$jc)(se,"remote-cli");let ne=n(ee,"PATH");return ne?ne=G+I.$tc+ne:ne=G,i(ee,"PATH",ne),f.args["without-browser-env-var"]||(ee.BROWSER=(0,I.$jc)(se,"helpers",u.$d?"browser.cmd":"browser.sh")),o(ee),ee}e.$Em=l;class ${constructor(t,a){this.socket=t,this.initialDataChunk=a}socketDrain(){return this.socket.drain()}toIExtHostSocketMessage(){let t,a,f;return this.socket instanceof w.$Fh?(t=!0,a=!1,f=C.$ce.alloc(0)):(t=!1,a=this.socket.permessageDeflate,f=this.socket.recordedInflateBytes),{type:"VSCODE_EXTHOST_IPC_SOCKET",initialDataChunk:this.initialDataChunk.buffer.toString("base64"),skipWebSocketFrames:t,permessageDeflate:a,inflateBytes:f.buffer.toString("base64")}}}let c=class{constructor(t,a,f,S,D,E,P,M){this.i=t,this.j=D,this.l=E,this.m=P,this.n=M,this.b=new p.$Od,this.onClose=this.b.event,this.c=!u.$d||!this.j.args["socket-path"],this.d=!1,this.f=a,this.g=null,this.h=new $(f,S),this.p("New connection established.")}get o(){return`[${this.f}][${this.i.substr(0,8)}][ExtensionHostConnection] `}p(t){this.l.info(`${this.o}${t}`)}q(t){this.l.error(`${this.o}${t}`)}async r(t,a){const f=new d.$Rc;f.add(a.socket),f.add((0,d.$Qc)(()=>{t.destroy()}));const S=()=>{f.dispose()};f.add(a.socket.onEnd(S)),f.add(a.socket.onClose(S)),f.add(p.Event.fromNodeEventEmitter(t,"end")(S)),f.add(p.Event.fromNodeEventEmitter(t,"close")(S)),f.add(p.Event.fromNodeEventEmitter(t,"error")(S)),f.add(a.socket.onData(D=>t.write(D.buffer))),f.add(p.Event.fromNodeEventEmitter(t,"data")(D=>{a.socket.write(C.$ce.wrap(D))})),a.initialDataChunk.byteLength>0&&t.write(a.initialDataChunk.buffer)}async s(t,a){await a.socketDrain();const f=a.toIExtHostSocketMessage();let S;a.socket instanceof w.$Fh?S=a.socket.socket:S=a.socket.socket.socket,t.send(f,S)}shortenReconnectionGraceTimeIfNecessary(){if(!this.g)return;const t={type:"VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"};this.g.send(t)}acceptReconnection(t,a,f){this.f=t,this.p("The client has reconnected.");const S=new $(a,f);if(!this.g){this.h=S;return}this.s(this.g,S)}t(){this.d||(this.d=!0,this.h&&(this.h.socket.end(),this.h=null),this.g&&(this.g.kill(),this.g=null),this.b.fire(void 0))}async start(t){try{let a=process.execArgv?process.execArgv.filter(G=>!/^--inspect(-brk)?=/.test(G)):[];t.port&&!process.pkg&&(a=[`--inspect${t.break?"-brk":""}=${t.port}`]);const f=await l(t.env,!0,t.language,this.j,this.l,this.n);(0,b.$Cl)(f);let S;if(this.c)(0,h.$Cm)(new h.$Am,f),S=null;else{const{namedPipeServer:G,pipeName:ne}=await this.u();(0,h.$Cm)(new h.$zm(ne),f),S=G}const D={env:f,execArgv:a,silent:!0};D.execArgv.unshift("--dns-result-order=ipv4first");const E=["--type=extensionHost","--transformURIs"],P=this.j.args["use-host-proxy"];E.push(`--useHostProxy=${P?"true":"false"}`),this.g=y.fork(L.$dg.asFileUri("bootstrap-fork").fsPath,E,D);const M=this.g.pid;this.p(`<${M}> Launched Extension Host Process.`),this.g.stdout.setEncoding("utf8"),this.g.stderr.setEncoding("utf8");const ee=p.Event.fromNodeEventEmitter(this.g.stdout,"data"),se=p.Event.fromNodeEventEmitter(this.g.stderr,"data");if(ee(G=>this.p(`<${M}> ${G}`)),se(G=>this.p(`<${M}><stderr> ${G}`)),this.g.on("error",G=>{this.q(`<${M}> Extension Host Process had an error`),this.l.error(G),this.t()}),this.g.on("exit",(G,ne)=>{this.m.setExitInfo(this.i,{code:G,signal:ne}),this.p(`<${M}> Extension Host Process exited with code: ${G}, signal: ${ne}.`),this.t()}),S)S.on("connection",G=>{S.close(),this.r(G,this.h)});else{const G=ne=>{ne.type==="VSCODE_EXTHOST_IPC_READY"&&(this.g.removeListener("message",G),this.s(this.g,this.h),this.h=null)};this.g.on("message",G)}}catch(a){console.error("ExtensionHostConnection errored"),a&&console.error(a)}}u(){return new Promise((t,a)=>{const f=(0,w.$Ih)(),S=R.createServer();S.on("error",a),S.listen(f,()=>{S?.removeListener("error",a),t({pipeName:f,namedPipeServer:S})})})}};e.$Fm=c,e.$Fm=c=Re([Ae(4,v.$pm),Ae(5,k.$$i),Ae(6,m.$xm),Ae(7,g.$ki)],c);function n(s,t){const a=Object.keys(s).filter(S=>S.toLowerCase()===t.toLowerCase()),f=a.length>0?a[0]:t;return s[f]}function i(s,t,a){const f=Object.keys(s).filter(D=>D.toLowerCase()===t.toLowerCase()),S=f.length>0?f[0]:t;s[S]=a}function o(s){for(const t of Object.keys(s))s[t]===null&&delete s[t]}}),define(be[289],we([1,0,83,13,66,117,24,44,139,38,32,30,126,138,82,111,55,2,112,68,12,16,31,46,120,84,121,11,4,7,28,232,81,34,124,65,3,58,129,33,45,69,127,125,114,115,198,290]),function(ue,e,y,R,r,L,I,C,p,w,A,k,v,u,b,m,d,h,g,l,$,c,n,i,o,s,t,a,f,S,D,E,P,M,ee,se,G,ne,he,Z,fe,V,ie,Y,J,re,ce,oe){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.run=void 0;class _ extends h.$Sc{constructor(N,U){super(),this.a=N,this.b=U,this.c()}c(){process.once("exit",()=>this.dispose())}async run(){const N=await this.f();await N.invokeFunction(async U=>{const T=U.get(I.$ki),z=U.get(R.$$i);G.$d&&(T.getValue("security.restrictUNCAccess")===!1?(0,oe.disableUNCAccessRestrictions)():(0,oe.addUNCHostToAllowlist)(T.getValue("security.allowedUNCHosts")));try{await this.g(N.createInstance(o.$lp,new R.$gj(z.getLevel(),!1)))}catch(B){throw z.error(B),console.error((0,a.$0)(B)),B}})}async f(){const N=new y.$Oh,U={_serviceBrand:void 0,...d.default};N.set(n.$qj,U);const T=new i.$qm(this.a,U);N.set(i.$pm,T);const z=new re.$FN((0,R.$mj)(T),T.logsHome);N.set(R.$_i,z);const B=new J.$PN(this.B(z.createLogger("remoteCLI",{name:(0,ce.localize)(0,null)})));N.set(R.$$i,B),B.trace(`Remote configuration data at ${this.b}`),B.trace("process arguments:",this.a);const te=this.B(new g.$Sp(B));N.set(c.$_j,te),te.registerProvider($.Schemas.file,this.B(new l.$fq(B)));const H=new ee.$Er(te);N.set(M.$Jk,H);const x=this.B(new ie.$NN(H,T,te,B));N.set(Z.$Lk,x);const W=this.B(new L.$Pn(x.defaultProfile.settingsResource,te,new V.$pn,B));return N.set(I.$ki,W),await Promise.all([W.initialize(),x.init()]),N.set(C.$Xo,new r.$Nh(p.$4q)),N.set(P.$Tn,new r.$Nh(E.$9N)),N.set(A.$dl,w.$qo),N.set(k.$co,new r.$Nh(v.$ip)),N.set(fe.$zp,new r.$Nh(Y.$ON)),N.set(ne.$Dp,new r.$Nh(he.$AN)),N.set(b.$jp,new r.$Nh(b.$kp)),N.set(u.$Np,new r.$Nh(u.$Op)),N.set(s.$Xq,new r.$Nh(t.$Zq)),new m.$iq(N)}async g(N){if(this.a["list-extensions"])return N.listExtensions(!!this.a["show-versions"],this.a.category);if(this.a["install-extension"]||this.a["install-builtin-extension"]){const U={isMachineScoped:!!this.a["do-not-sync"],installPreReleaseVersion:!!this.a["pre-release"]};return N.installExtensions(this.h(this.a["install-extension"]||[]),this.h(this.a["install-builtin-extension"]||[]),U,!!this.a.force)}else{if(this.a["uninstall-extension"])return N.uninstallExtensions(this.h(this.a["uninstall-extension"]),!!this.a.force);if(this.a["locate-extension"])return N.locateExtension(this.a["locate-extension"])}}h(N){return N.map(U=>/\.vsix$/i.test(U)?f.URI.file((0,S.$ic)(U)?U:(0,S.$jc)((0,D.cwd)(),U)):U)}}function q(O){setTimeout(()=>process.exit(O),0)}async function Q(O,N,U){if(O.help){const z=d.default.serverApplicationName+(G.$d?".cmd":"");console.log((0,se.$Kl)(d.default.nameLong,z,d.default.version,U,{noInputFiles:!0,noPipe:!0}));return}if(O.version){console.log((0,se.$Ll)(d.default.version,d.default.commit));return}const T=new _(O,N);try{await T.run(),q(0)}catch{q(1)}finally{T.dispose()}}e.run=Q}),define(be[291],we([1,0,72,264,29,284,4,13,90]),function(ue,e,y,R,r,L,I,C,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TM=e.$SM=void 0;class w{constructor(v,u,b){this.b=v,this.c=u,this.f=b,this.a=R.createServer((m,d)=>this.h(m,d)),this.g().catch(m=>(u.error(m),""))}get ipcHandlePath(){return this.f}async g(){try{this.a.listen(this.ipcHandlePath),this.a.on("error",v=>this.c.error(v))}catch{this.c.error("Could not start open from terminal server.")}return this.f}h(v,u){const b=(d,h)=>{u.writeHead(d,{"content-type":"application/json"}),u.end(JSON.stringify(h||null),g=>g&&this.c.error(g))},m=[];v.setEncoding("utf8"),v.on("data",d=>m.push(d)),v.on("end",async()=>{try{const d=JSON.parse(m.join(""));let h;switch(d.type){case"open":h=await this.i(d);break;case"openExternal":h=await this.j(d);break;case"status":h=await this.l(d);break;case"extensionManagement":h=await this.k(d);break;default:b(404,`Unknown message type: ${d.type}`);break}b(200,h)}catch(d){const h=d instanceof Error?d.message:JSON.stringify(d);b(500,h),this.c.error("Error while processing pipe request",d)}})}async i(v){const{fileURIs:u,folderURIs:b,forceNewWindow:m,diffMode:d,mergeMode:h,addMode:g,forceReuseWindow:l,gotoLineMode:$,waitMarkerFilePath:c,remoteAuthority:n}=v,i=[];if(Array.isArray(b))for(const a of b)try{i.push({folderUri:I.URI.parse(a)})}catch{}if(Array.isArray(u))for(const a of u)try{(0,p.$ji)(a)?i.push({workspaceUri:I.URI.parse(a)}):i.push({fileUri:I.URI.parse(a)})}catch{}const o=c?I.URI.file(c):void 0,t={forceNewWindow:m,diffMode:d,mergeMode:h,addMode:g,gotoLineMode:$,forceReuseWindow:l,preferNewWindow:!l&&!o&&!g,waitMarkerFileURI:o,remoteAuthority:n};this.b.executeCommand("_remoteCLI.windowOpen",i,t)}async j(v){for(const u of v.uris){const b=I.URI.parse(u),m=b.scheme==="file"?b:u;await this.b.executeCommand("_remoteCLI.openExternal",m)}}async k(v){const u=m=>m?.map(d=>/\.vsix$/i.test(d)?I.URI.parse(d):d),b={list:v.list,install:u(v.install),uninstall:u(v.uninstall),force:v.force};return await this.b.executeCommand("_remoteCLI.manageExtensions",b)}async l(v){return await this.b.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this.a.close(),this.f&&process.platform!=="win32"&&r.existsSync(this.f)&&r.unlinkSync(this.f)}}e.$SM=w;let A=class extends w{constructor(v,u){super(v,u,(0,y.$Ih)())}};e.$TM=A,e.$TM=A=Re([Ae(0,L.$NM),Ae(1,C.$$i)],A)}),define(be[292],we([1,0,27,5,22,2,7,3,4,72,70,291,123,88,271,273,140]),function(ue,e,y,R,r,L,I,C,p,w,A,k,v,u,b,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tN=void 0;class h extends m.$sN{constructor($,c,n,i,o){super({getFolderUri:s=>{const t=c.filter(a=>a.name===s);if(t&&t.length>0)return t[0].uri},getWorkspaceFolderCount:()=>c.length,getConfigurationValue:(s,t)=>i[`config:${t}`],getExecPath:()=>$.VSCODE_EXEC_PATH,getAppRoot:()=>$.VSCODE_CWD,getFilePath:()=>{if(n)return I.$hc(n.fsPath)},getSelectedText:()=>i.selectedText,getLineNumber:()=>i.lineNumber,getExtension:async s=>{const a=(await o.getInstalled()).find(f=>f.identifier.id===s);return a&&{extensionLocation:a.location}}},void 0,Promise.resolve(y.homedir()),Promise.resolve($))}}class g extends L.$Sc{constructor($,c,n,i,o,s){super(),this.g=$,this.h=c,this.j=n,this.m=i,this.n=o,this.r=s,this.a=0,this.b=new Map,this.c=this.B(new R.$Od),this.onExecuteCommand=this.c.event}async call($,c,n){switch(c){case"$restartPtyHost":return this.j.restartPtyHost.apply(this.j,n);case"$createProcess":{const i=(0,A.$Fr)($.remoteAuthority);return this.s(i,n)}case"$attachToProcess":return this.j.attachToProcess.apply(this.j,n);case"$detachFromProcess":return this.j.detachFromProcess.apply(this.j,n);case"$listProcesses":return this.j.listProcesses.apply(this.j,n);case"$getLatency":return this.j.getLatency.apply(this.j,n);case"$getPerformanceMarks":return this.j.getPerformanceMarks.apply(this.j,n);case"$orphanQuestionReply":return this.j.orphanQuestionReply.apply(this.j,n);case"$acceptPtyHostResolvedVariables":return this.j.acceptPtyHostResolvedVariables.apply(this.j,n);case"$start":return this.j.start.apply(this.j,n);case"$input":return this.j.input.apply(this.j,n);case"$acknowledgeDataEvent":return this.j.acknowledgeDataEvent.apply(this.j,n);case"$shutdown":return this.j.shutdown.apply(this.j,n);case"$resize":return this.j.resize.apply(this.j,n);case"$clearBuffer":return this.j.clearBuffer.apply(this.j,n);case"$getInitialCwd":return this.j.getInitialCwd.apply(this.j,n);case"$getCwd":return this.j.getCwd.apply(this.j,n);case"$processBinary":return this.j.processBinary.apply(this.j,n);case"$sendCommandResult":return this.u(n[0],n[1],n[2]);case"$installAutoReply":return this.j.installAutoReply.apply(this.j,n);case"$uninstallAllAutoReplies":return this.j.uninstallAllAutoReplies.apply(this.j,n);case"$getDefaultSystemShell":return this.w.apply(this,n);case"$getProfiles":return this.y.apply(this,n);case"$getEnvironment":return this.z();case"$getWslPath":return this.C(n[0],n[1]);case"$getTerminalLayoutInfo":return this.j.getTerminalLayoutInfo(n);case"$setTerminalLayoutInfo":return this.j.setTerminalLayoutInfo(n);case"$serializeTerminalState":return this.j.serializeTerminalState.apply(this.j,n);case"$reviveTerminalProcesses":return this.j.reviveTerminalProcesses.apply(this.j,n);case"$getRevivedPtyNewId":return this.j.getRevivedPtyNewId.apply(this.j,n);case"$setUnicodeVersion":return this.j.setUnicodeVersion.apply(this.j,n);case"$reduceConnectionGraceTime":return this.D();case"$updateIcon":return this.j.updateIcon.apply(this.j,n);case"$updateTitle":return this.j.updateTitle.apply(this.j,n);case"$updateProperty":return this.j.updateProperty.apply(this.j,n);case"$refreshProperty":return this.j.refreshProperty.apply(this.j,n);case"$requestDetachInstance":return this.j.requestDetachInstance(n[0],n[1]);case"$acceptDetachedInstance":return this.j.acceptDetachInstanceReply(n[0],n[1]);case"$freePortKillProcess":return this.j.freePortKillProcess.apply(this.j,n);case"$acceptDetachInstanceReply":return this.j.acceptDetachInstanceReply.apply(this.j,n)}throw new Error(`IPC Command ${c} not found`)}listen($,c,n){switch(c){case"$onPtyHostExitEvent":return this.j.onPtyHostExit||R.Event.None;case"$onPtyHostStartEvent":return this.j.onPtyHostStart||R.Event.None;case"$onPtyHostUnresponsiveEvent":return this.j.onPtyHostUnresponsive||R.Event.None;case"$onPtyHostResponsiveEvent":return this.j.onPtyHostResponsive||R.Event.None;case"$onPtyHostRequestResolveVariablesEvent":return this.j.onPtyHostRequestResolveVariables||R.Event.None;case"$onProcessDataEvent":return this.j.onProcessData;case"$onProcessReadyEvent":return this.j.onProcessReady;case"$onProcessExitEvent":return this.j.onProcessExit;case"$onProcessReplayEvent":return this.j.onProcessReplay;case"$onProcessOrphanQuestion":return this.j.onProcessOrphanQuestion;case"$onExecuteCommand":return this.onExecuteCommand;case"$onDidRequestDetach":return this.j.onDidRequestDetach||R.Event.None;case"$onDidChangeProperty":return this.j.onDidChangeProperty}throw new Error(`IPC Command ${c} not found`)}async s($,c){const n={name:c.shellLaunchConfig.name,executable:c.shellLaunchConfig.executable,args:c.shellLaunchConfig.args,cwd:typeof c.shellLaunchConfig.cwd=="string"||typeof c.shellLaunchConfig.cwd>"u"?c.shellLaunchConfig.cwd:p.URI.revive($.transformIncoming(c.shellLaunchConfig.cwd)),env:c.shellLaunchConfig.env,useShellEnvironment:c.shellLaunchConfig.useShellEnvironment,reconnectionProperties:c.shellLaunchConfig.reconnectionProperties,type:c.shellLaunchConfig.type,isFeatureTerminal:c.shellLaunchConfig.isFeatureTerminal},i=await(0,d.$Em)(c.resolverEnv,!!c.shellLaunchConfig.useShellEnvironment,C.$q,this.g,this.h,this.r);this.h.trace("baseEnv",i);const o=he=>({uri:p.URI.revive($.transformIncoming(he.uri)),name:he.name,index:he.index,toResource:()=>{throw new Error("Not implemented")}}),s=c.workspaceFolders.map(o),t=c.activeWorkspaceFolder?o(c.activeWorkspaceFolder):void 0,a=c.activeFileResource?p.URI.revive($.transformIncoming(c.activeFileResource)):void 0,f=new h(i,s,a,c.resolvedVariables,this.n),S=b.$oN(t,process.env,f),D=await b.$nN(n,y.homedir(),S,t?.uri,c.configuration["terminal.integrated.cwd"],this.h);n.cwd=D;const E=C.$d?"terminal.integrated.env.windows":C.$e?"terminal.integrated.env.osx":"terminal.integrated.env.linux",P=c.configuration[E],M=await b.$pN(n,P,S,this.m.version,c.configuration["terminal.integrated.detectLocale"],i);if(!n.strictEnv){const he=[];for(const[ie,Y,J]of c.envVariableCollections)he.push([ie,{map:(0,u.$rr)(Y),descriptionMap:(0,u.$sr)(J)}]);const Z=new Map(he),fe=new v.$vr(Z),V=t?t??void 0:void 0;await fe.applyToProcessEnvironment(M,{workspaceFolder:V},S)}this.h.debug("Terminal process launching on remote agent",{shellLaunchConfig:n,initialCwd:D,cols:c.cols,rows:c.rows,env:M});const ee=(0,w.$Ih)();M.VSCODE_IPC_HOOK_CLI=ee;const se=await this.j.createProcess(n,D,c.cols,c.rows,c.unicodeVersion,M,i,c.options,c.shouldPersistTerminal,c.workspaceId,c.workspaceName),G={executeCommand:(he,...Z)=>this.t(se,he,Z,$)},ne=new k.$SM(G,this.h,ee);return this.j.onProcessExit(he=>he.id===se&&ne.dispose()),{persistentTerminalId:se,resolvedShellLaunchConfig:n}}t($,c,n,i){let o,s;const t=new Promise((S,D)=>{o=S,s=D}),a=++this.a;this.b.set(a,{resolve:o,reject:s,uriTransformer:i});const f=(0,r.$$m)(n,S=>{if(S&&S.$mid===1)return i.transformOutgoing(S);if(S&&S instanceof p.URI)return i.transformOutgoingURI(S)});return this.c.fire({reqId:a,persistentProcessId:$,commandId:c,commandArgs:f}),t}u($,c,n){const i=this.b.get($);if(!i)return;this.b.delete($);const o=(0,r.$$m)(n,s=>{if(s&&s.$mid===1)return i.uriTransformer.transformIncoming(s)});c?i.reject(o):i.resolve(o)}w($){return this.j.getDefaultSystemShell($)}async y($,c,n,i){return this.j.getProfiles($,c,n,i)||[]}z(){return{...process.env}}C($,c){return this.j.getWslPath($,c)}D(){return this.j.reduceConnectionGraceTime()}}e.$tN=g}),define(be[293],we([1,0,27,5,2,12,7,101,21,42,24,117,206,81,207,25,126,30,82,120,216,138,16,112,68,66,111,83,84,121,13,55,31,44,233,139,119,32,38,247,89,255,34,124,268,269,238,244,292,70,46,275,285,128,58,129,45,33,263,69,245,115,127,125,114,113,200,282,229,259,252]),function(ue,e,y,R,r,L,I,C,p,w,A,k,v,u,b,m,d,h,g,l,$,c,n,i,o,s,t,a,f,S,D,E,P,M,ee,se,G,ne,he,Z,fe,V,ie,Y,J,re,ce,oe,_,q,Q,O,N,U,T,z,B,te,H,x,W,X,ae,ge,Ee,Ce,Ne,Fe,$e,ke,ve){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZN=e.$YN=void 0;const je="monacoworkbench";async function Be(Ie,Oe,Te,ze){const He=new a.$Oh,Ke=new Qe,Je={_serviceBrand:void 0,...E.default};He.set(P.$qj,Je);const We=new Q.$qm(Oe,Je);He.set(m.$Xh,We),He.set(m.$Yh,We);const it=new X.$FN((0,D.$mj)(We),We.logsHome);He.set(D.$_i,it),Ke.registerChannel("logger",new Ce.$er(it,st=>qe(st.remoteAuthority)));const rt=it.createLogger("remoteagent",{name:(0,Ne.localize)(0,null)}),et=new Ee.$PN(rt,[new xe((0,D.$mj)(We))]);He.set(D.$$i,et),setTimeout(()=>Pe(We.logsHome.with({scheme:L.Schemas.file}).fsPath).then(null,st=>et.error(st)),1e4),et.onDidChangeLogLevel(st=>(0,D.log)(et,st,`Log level changed to ${(0,D.$nj)(et.getLevel())}`)),et.trace(`Remote configuration data at ${Te}`),et.trace("process arguments:",We.args),Array.isArray(Je.serverGreeting)&&et.info(`

${Je.serverGreeting.join(`
`)}

`),Ke.registerChannel(v.$Rn.ChannelName,new v.$Rn);const mt=new w.$yh(st=>st.clientId==="renderer"),ut=ze.add(new i.$Sp(et));He.set(n.$_j,ut),ut.registerProvider(L.Schemas.file,ze.add(new o.$fq(et)));const Pt=new Y.$Er(ut);He.set(ie.$Jk,Pt);const gt=new k.$Pn(We.machineSettingsResource,ut,new x.$pn,et);He.set(A.$ki,gt);const wt=new ae.$NN(Pt,We,ut,et);He.set(te.$Lk,wt),Ke.registerChannel("userDataProfiles",new ke.$VN(wt,st=>qe(st.remoteAuthority)));const[,,Mt,Tt]=await Promise.all([gt.initialize(),wt.init(),(0,C.$Um)(et.error.bind(et)),(0,C.$Vm)(et.error.bind(et))]),Nt=new U.$ym;He.set(U.$xm,Nt);const $t=new se.$4q(gt,We,et,it);He.set(M.$Xo,$t);let pt=he.$uo;const Ft=(0,he.$Bo)(Je,gt);if((0,he.$wo)(Je,We)){const st=process.env.CS_TELEMETRY_URL||"https://v1.telemetry.coder.com/track";st?pt=new W.$DN($t,!1,je,null,()=>new H.$BN(st)):!(0,he.$xo)(Je,We)&&Je.aiConfig?.ariaKey&&(pt=new W.$DN($t,Ft,je,null,Je.aiConfig.ariaKey),ze.add((0,r.$Qc)(()=>pt?.flush())));const bt={appenders:[pt],commonProperties:(0,G.$mo)((0,y.release)(),(0,y.hostname)(),process.arch,Je.commit,Je.version+"-remote",Mt,Tt,Ft,"remoteAgent"),piiPaths:(0,he.$Co)(We)},ht=We.args["telemetry-level"];let ft=3;ht==="all"?ft=3:ht==="error"?ft=2:ht==="crash"?ft=1:ht!==void 0&&(ft=0),He.set(oe.$Sr,new s.$Nh(oe.$Qr,[bt,ft]))}else He.set(oe.$Sr,oe.$Rr);He.set(h.$co,new s.$Nh(d.$ip));const Ct=Ke.getChannel("download",mt);He.set(u.$Tn,new b.$Vn(Ct,()=>qe("renderer"))),He.set(B.$zp,new s.$Nh(ge.$ON)),He.set(T.$Dp,new s.$Nh(z.$AN)),He.set(g.$jp,new s.$Nh(g.$kp)),He.set(c.$Np,new s.$Nh(c.$Op));const vt=new t.$iq(He);He.set(f.$Xq,vt.createInstance(S.$Zq));const Ut=vt.createInstance(ve.$XN,{graceTime:108e5,shortGraceTime:3e5,scrollback:gt.getValue("terminal.integrated.persistentSessionScrollback")??100}),Dt=vt.createInstance(V.$Ar,Ut);return He.set(fe.$_q,Dt),vt.invokeFunction(st=>{const bt=st.get(c.$Np),ht=st.get(T.$Dp),ft=st.get(h.$co),Bt=st.get(f.$Xq),It=new J.$Mr(Ie,We,wt,Nt);Ke.registerChannel("remoteextensionsenvironment",It);const zt=new ce.$Tr(st.get(oe.$Sr),pt);Ke.registerChannel("telemetry",zt),Ke.registerChannel(O.$uN,new _.$tN(We,et,Dt,Je,bt,gt));const At=new Fe.$TN(vt.createInstance(l.$lp,et),We,wt,ht,et,ft,Bt);Ke.registerChannel($e.$SN,new Fe.$UN(At,ye=>qe(ye.remoteAuthority)));const Ht=new re.$Pr(et,We);Ke.registerChannel(N.$yN,Ht),Ke.registerChannel("request",new ee.$1q(st.get(M.$Xo)));const Vt=new $.$mp(bt,ye=>qe(ye.remoteAuthority));Ke.registerChannel("extensions",Vt);const qt=w.ProxyChannel.fromService(st.get(f.$Xq),ze);return Ke.registerChannel("languagePacks",qt),At.whenExtensionsReady().then(()=>bt.cleanUp()),ze.add(new Z.default(st.get(ne.$dl))),{telemetryService:st.get(ne.$dl)}}),{socketServer:Ke,instantiationService:vt}}e.$YN=Be;const Ze=Object.create(null);function qe(Ie){return Ze[Ie]||(Ze[Ie]=(0,q.$Fr)(Ie)),Ze[Ie]}class Qe extends w.$uh{constructor(){const Oe=new R.$Od;super(Oe.event),this.b=Oe}acceptConnection(Oe,Te){this.b.fire({protocol:Oe,onDidClientDisconnect:Te})}}e.$ZN=Qe;class xe extends D.$dj{constructor(Oe=D.$bj){super(),this.setLevel(Oe),this.g=!!process.stdout.isTTY}trace(Oe,...Te){this.f(D.LogLevel.Trace)&&(this.g?console.log(`\x1B[90m[${Xe()}]\x1B[0m`,Oe,...Te):console.log(`[${Xe()}]`,Oe,...Te))}debug(Oe,...Te){this.f(D.LogLevel.Debug)&&(this.g?console.log(`\x1B[90m[${Xe()}]\x1B[0m`,Oe,...Te):console.log(`[${Xe()}]`,Oe,...Te))}info(Oe,...Te){this.f(D.LogLevel.Info)&&(this.g?console.log(`\x1B[90m[${Xe()}]\x1B[0m`,Oe,...Te):console.log(`[${Xe()}]`,Oe,...Te))}warn(Oe,...Te){this.f(D.LogLevel.Warning)&&(this.g?console.warn(`\x1B[93m[${Xe()}]\x1B[0m`,Oe,...Te):console.warn(`[${Xe()}]`,Oe,...Te))}error(Oe,...Te){this.f(D.LogLevel.Error)&&(this.g?console.error(`\x1B[91m[${Xe()}]\x1B[0m`,Oe,...Te):console.error(`[${Xe()}]`,Oe,...Te))}dispose(){}flush(){}}function Xe(){const Ie=new Date;return`${me(Ie.getHours())}:${me(Ie.getMinutes())}:${me(Ie.getSeconds())}`}function me(Ie){return Ie<10?`0${Ie}`:String(Ie)}async function Pe(Ie){const Oe=I.$nc(Ie),Te=I.$mc(Ie),Ke=(await p.Promises.readdir(Te)).filter(We=>/^\d{8}T\d{6}$/.test(We)).sort().filter(We=>We!==Oe),Je=Ke.slice(0,Math.max(0,Ke.length-9));await Promise.all(Je.map(We=>p.Promises.rm(I.$jc(Te,We))))}}),define(be[294],we([1,0,87,29,79,295,85,95,15,11,39,2,12,7,41,3,17,4,23,156,158,290,106,72,24,6,13,31,57,32,140,260,261,46,293,265]),function(ue,e,y,R,r,L,I,C,p,w,A,k,v,u,b,m,d,h,g,l,$,c,n,i,o,s,t,a,f,S,D,E,P,M,ee,se){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8N=void 0;const G=5*60*1e3;let ne=class extends k.$Sc{constructor(V,ie,Y,J,re,ce,oe,_){super(),this.n=V,this.r=ie,this.s=Y,this.t=re,this.u=ce,this.w=oe,this.y=_,this.h=Z.create(this.u),this.j=(0,f.$Xk)(ce),this.a=Object.create(null),this.b=Object.create(null),this.f=new Set,this.g=J?this.y.createInstance(se.$3N,this.r):null,this.w.info("Extension host agent started."),this.L(!0)}async handleRequest(V,ie){if(V.method!=="GET")return(0,se.$1N)(V,ie,405,`Unsupported method ${V.method}`);if(!V.url)return(0,se.$1N)(V,ie,400,"Bad request.");const Y=I.parse(V.url,!0);let J=Y.pathname;if(!J)return(0,se.$1N)(V,ie,400,"Bad request.");if(J.startsWith(this.j)&&J.charCodeAt(this.j.length)===47&&(J=J.substring(this.j.length)),J==="/version")return ie.writeHead(200,{"Content-Type":"text/plain"}),void ie.end(this.u.commit||"");if(J==="/delay-shutdown")return this.N(),ie.writeHead(200),void ie.end("OK");if(!(0,P.$Mm)(this.r,V,Y))return(0,se.$1N)(V,ie,403,"Forbidden.");if(J==="/vscode-remote-resource"){const re=Y.query.path;if(typeof re!="string")return(0,se.$1N)(V,ie,400,"Bad request.");let ce;try{ce=h.URI.from({scheme:v.Schemas.file,path:re}).fsPath}catch{return(0,se.$1N)(V,ie,400,"Bad request.")}const oe=Object.create(null);this.t.isBuilt&&((0,A.$Yf)(ce,this.t.builtinExtensionsPath,!m.$f)||(0,A.$Yf)(ce,this.t.extensionsPath,!m.$f))&&(oe["Cache-Control"]="public, max-age=31536000"),oe.Vary="Origin";const _=V.headers.origin;return _&&this.h.matches(_)&&(oe["Access-Control-Allow-Origin"]=_),(0,se.$2N)(ce,1,this.w,V,ie,oe)}if(this.g){this.g.handle(V,ie,Y);return}return ie.writeHead(404,{"Content-Type":"text/plain"}),void ie.end("Not found")}handleUpgrade(V,ie){let Y=(0,g.$fg)(),J=!1,re=!1;if(V.url){const O=I.parse(V.url,!0).query;typeof O.reconnectionToken=="string"&&(Y=O.reconnectionToken),O.reconnection==="true"&&(J=!0),O.skipWebSocketFrames==="true"&&(re=!0)}if(V.headers.upgrade===void 0||V.headers.upgrade.toLowerCase()!=="websocket"){ie.end("HTTP/1.1 400 Bad Request");return}const ce=V.headers["sec-websocket-key"],oe=y.createHash("sha1");oe.update(ce+"258EAFA5-E914-47DA-95CA-C5AB0DC85B11");const q=["HTTP/1.1 101 Switching Protocols","Upgrade: websocket","Connection: Upgrade",`Sec-WebSocket-Accept: ${oe.digest("base64")}`];let Q=!1;if(!re&&!this.t.args["disable-websocket-compression"]&&V.headers["sec-websocket-extensions"]){const O=Array.isArray(V.headers["sec-websocket-extensions"])?V.headers["sec-websocket-extensions"]:[V.headers["sec-websocket-extensions"]];for(const N of O)if(!/\b((server_max_window_bits)|(server_no_context_takeover)|(client_no_context_takeover))\b/.test(N)){if(/\b(permessage-deflate)\b/.test(N)){Q=!0,q.push("Sec-WebSocket-Extensions: permessage-deflate");break}if(/\b(x-webkit-deflate-frame)\b/.test(N)){Q=!0,q.push("Sec-WebSocket-Extensions: x-webkit-deflate-frame");break}}}ie.write(q.join(`\r
`)+`\r
\r
`),ie.setTimeout(0),ie.setNoDelay(!0),re?this.D(new i.$Fh(ie,`server-connection-${Y}`),J,Y):this.D(new i.$Gh(new i.$Fh(ie,`server-connection-${Y}`),Q,null,!0),J,Y)}handleServerError(V){this.w.error("Error occurred in server"),this.w.error(V)}z(V){let ie;return V instanceof i.$Fh?ie=V.socket:ie=V.socket.socket,ie.remoteAddress||"<unknown>"}async C(V,ie,Y){const J=ie.getSocket();this.w.error(`${V} ${Y}.`);const re={type:"error",reason:Y};ie.sendControl(p.$ce.fromString(JSON.stringify(re))),ie.dispose(),await J.drain(),J.dispose()}D(V,ie,Y){const J=this.z(V),re=`[${J}][${Y.substr(0,8)}]`,ce=new n.$Eh({socket:V}),oe=this.s?new this.s.validator:null,_=this.s?new this.s.signer:null;let q;(function(U){U[U.WaitingForAuth=0]="WaitingForAuth",U[U.WaitingForConnectionType=1]="WaitingForConnectionType",U[U.Done=2]="Done",U[U.Error=3]="Error"})(q||(q={}));let Q=0;const O=U=>{Q=3,N.dispose(),this.C(re,ce,U)},N=ce.onControlMessage(U=>{if(Q===0){let T;try{T=JSON.parse(U.toString())}catch{return O("Malformed first message")}if(T.type!=="auth")return O("Invalid first message");if(this.r.type===2&&!this.r.validate(T.auth))return O("Unauthorized client refused: auth mismatch");let z=(0,g.$fg)();if(_)try{z=_.sign(T.data)}catch{}let B=(0,g.$fg)();if(oe)try{B=oe.createNewMessage(B)}catch{}const te={type:"sign",data:B,signedData:z};ce.sendControl(p.$ce.fromString(JSON.stringify(te))),Q=1}else if(Q===1){let T;try{T=JSON.parse(U.toString())}catch{return O("Malformed second message")}if(T.type!=="connectionType")return O("Invalid second message");if(typeof T.signedData!="string")return O("Invalid second message field type");const z=T.commit,B=this.u.commit;if(z&&B&&z!==B)return O("Client refused: version mismatch");let te=!1;if(!oe)te=!0;else if(this.r.validate(T.signedData))te=!0;else try{te=oe.validate(T.signedData)==="ok"}catch{}if(!te){if(this.t.isBuilt)return O("Unauthorized client refused");this.w.error(`${re} Unauthorized client handshake failed but we proceed because of dev mode.`)}for(const H in this.b)this.b[H].shortenReconnectionGraceTimeIfNecessary();for(const H in this.a)this.a[H].shortenReconnectionGraceTimeIfNecessary();Q=2,N.dispose(),this.F(J,re,ce,V,ie,Y,T)}})}async F(V,ie,Y,J,re,ce,oe){const _=oe.desiredConnectionType===1?`${ie}[ManagementConnection]`:oe.desiredConnectionType===2?`${ie}[ExtensionHostConnection]`:ie;if(oe.desiredConnectionType===1)if(re){if(!this.b[ce])return this.f.has(ce)?this.C(_,Y,"Unknown reconnection token (seen before)"):this.C(_,Y,"Unknown reconnection token (never seen)");Y.sendControl(p.$ce.fromString(JSON.stringify({type:"ok"})));const q=Y.readEntireBuffer();Y.dispose(),this.b[ce].acceptReconnection(V,J,q)}else{if(this.b[ce])return this.C(_,Y,"Duplicate reconnection token");Y.sendControl(p.$ce.fromString(JSON.stringify({type:"ok"})));const q=new E.$Gm(this.w,ce,V,Y);this.n.acceptConnection(q.protocol,q.onClose),this.b[ce]=q,this.f.add(ce),q.onClose(()=>{delete this.b[ce]})}else if(oe.desiredConnectionType===2){const q=oe.args||{language:"en"},Q=await this.I(q);if(Q.port&&this.w.trace(`${_} - startParams debug port ${Q.port}`),this.w.trace(`${_} - startParams language: ${Q.language}`),this.w.trace(`${_} - startParams env: ${JSON.stringify(Q.env)}`),re){if(!this.a[ce])return this.f.has(ce)?this.C(_,Y,"Unknown reconnection token (seen before)"):this.C(_,Y,"Unknown reconnection token (never seen)");Y.sendPause(),Y.sendControl(p.$ce.fromString(JSON.stringify(Q.port?{debugPort:Q.port}:{})));const O=Y.readEntireBuffer();Y.dispose(),this.a[ce].acceptReconnection(V,J,O)}else{if(this.a[ce])return this.C(_,Y,"Duplicate reconnection token");Y.sendPause(),Y.sendControl(p.$ce.fromString(JSON.stringify(Q.port?{debugPort:Q.port}:{})));const O=Y.readEntireBuffer();Y.dispose();const N=this.y.createInstance(D.$Fm,ce,V,J,O);this.a[ce]=N,this.f.add(ce),N.onClose(()=>{delete this.a[ce],this.J()}),N.start(Q)}}else if(oe.desiredConnectionType===3){const q=oe.args;this.G(Y,q)}else return this.C(_,Y,"Unknown initial data received")}async G(V,ie){const Y=V.getSocket().socket,J=V.readEntireBuffer();V.dispose(),Y.pause();const re=await this.H(ie.host,ie.port);J.byteLength>0&&re.write(J.buffer),re.on("end",()=>Y.end()),re.on("close",()=>Y.end()),re.on("error",()=>Y.destroy()),Y.on("end",()=>re.end()),Y.on("close",()=>re.end()),Y.on("error",()=>re.destroy()),re.pipe(Y),Y.pipe(re)}H(V,ie){return new Promise((Y,J)=>{const re=r.createConnection({host:V,port:ie,autoSelectFamily:!0},()=>{re.removeListener("error",J),re.pause(),Y(re)});re.once("error",J)})}I(V){return typeof V.port=="number"?(0,$.$hg)(V.port,10,5e3).then(ie=>(V.port=ie,V)):(V.debugId=void 0,V.port=void 0,V.break=void 0,Promise.resolve(V))}async J(){if(!this.t.args["enable-remote-auto-shutdown"])return;this.O(),!!Object.keys(this.a).length||(console.log("Last EH closed, waiting before shutting down"),this.w.info("Last EH closed, waiting before shutting down"),this.L())}L(V=!1){this.t.args["enable-remote-auto-shutdown"]&&(this.t.args["remote-auto-shutdown-without-delay"]&&!V?this.M():this.m=setTimeout(()=>{this.m=void 0,this.M()},G))}M(){if(!!Object.keys(this.a).length){console.log("New EH opened, aborting shutdown"),this.w.info("New EH opened, aborting shutdown");return}else console.log("Last EH closed, shutting down"),this.w.info("Last EH closed, shutting down"),this.dispose(),process.exit(0)}N(){this.m&&(console.log("Got delay-shutdown request while in shutdown timeout, delaying"),this.w.info("Got delay-shutdown request while in shutdown timeout, delaying"),this.O(),this.L())}O(){this.m&&(console.log("Cancelling previous shutdown timeout"),this.w.info("Cancelling previous shutdown timeout"),clearTimeout(this.m),this.m=void 0)}};ne=Re([Ae(4,M.$pm),Ae(5,a.$qj),Ae(6,t.$$i),Ae(7,s.$Ph)],ne);async function he(fe,V,ie){const Y=await(0,P.$Lm)(V);Y instanceof P.$Jm&&(console.warn(Y.message),process.exit(1));function J(te){(0,w.setUnexpectedErrorHandler)(H=>{(0,w.$Z)(H)&&H.stack&&/unexpectedErrorHandler/.test(H.stack)||te(H)})}const re=[];J(te=>{re.push(te),console.error(te)});let ce=!1;process.on("SIGPIPE",()=>{ce||(ce=!0,(0,w.$1)(new Error("Unexpected SIGPIPE")))});const oe=new k.$Rc,{socketServer:_,instantiationService:q}=await(0,ee.$YN)(Y,V,ie,oe);q.invokeFunction(te=>{const H=te.get(t.$$i);re.forEach(x=>H.error(x)),re.length=0,J(x=>H.error(x))}),q.invokeFunction(te=>{const H=te.get(o.$ki);m.$d&&(H.getValue("security.restrictUNCAccess")===!1?(0,c.disableUNCAccessRestrictions)():(0,c.addUNCHostToAllowlist)(H.getValue("security.allowedUNCHosts")))}),q.invokeFunction(te=>{const H=te.get(t.$$i);if(m.$d&&process.env.HOMEDRIVE&&process.env.HOMEPATH){const x=(0,u.$jc)(process.env.HOMEDRIVE,"node_modules"),W=(0,u.$mc)((0,u.$jc)(process.env.HOMEDRIVE,process.env.HOMEPATH)),X=(0,u.$jc)(W,"node_modules");if(R.existsSync(x)||R.existsSync(X)){const ae=`

*
* !!!! Server terminated due to presence of CVE-2020-1416 !!!!
*
* Please remove the following directories and re-try
* ${x}
* ${X}
*
* For more information on the vulnerability https://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2020-1416
*

`;H.warn(ae),console.warn(ae),process.exit(0)}}});const Q=q.invokeFunction(te=>{const H=te.get(t.$$i);if(R.existsSync((0,u.$jc)(v.$dg.asFileUri("").fsPath,"../node_modules/vsda")))try{return globalThis._VSCODE_NODE_MODULES.vsda}catch(W){H.error(W)}return null}),O=R.existsSync(v.$dg.asFileUri("vs/code/browser/workbench/workbench.html").fsPath);if(O&&fe&&typeof fe!="string"){const te=Y.type!==0?`?${v.$9f}=${Y.value}`:"";console.log(`Web UI available at http://localhost${fe.port===80?"":`:${fe.port}`}/${te}`)}const N=q.createInstance(ne,_,Y,Q,O);b.mark("code/server/ready");const U=L.performance.now(),T=global.vscodeServerStartTime,z=global.vscodeServerListenTime,B=global.vscodeServerCodeLoadedTime;if(q.invokeFunction(async te=>{const H=te.get(S.$dl);if(H.publicLog2("serverStart",{startTime:T,startedTime:z,codeLoadedTime:B,readyTime:U}),m.$f){const x=te.get(t.$$i),W=await(0,l.$gg)(x.error.bind(x));W&&H.publicLog2("serverPlatformInfo",{platformId:W.id,platformVersionId:W.version_id,platformIdLike:W.id_like})}}),V["print-startup-performance"]){const te=C.$U.get();let H="";H+=`

### Load AMD-module
`,H+=C.$U.toMarkdownTable(["Module","Duration"],te.amdLoad),H+=`

### Load commonjs-module
`,H+=C.$U.toMarkdownTable(["Module","Duration"],te.nodeRequire),H+=`

### Invoke AMD-module factory
`,H+=C.$U.toMarkdownTable(["Module","Duration"],te.amdInvoke),H+=`

### Invoke commonjs-module
`,H+=C.$U.toMarkdownTable(["Module","Duration"],te.nodeEval),H+=`Start-up time: ${z-T}
`,H+=`Code loading time: ${B-T}
`,H+=`Initialized time: ${U-T}
`,H+=`
`,console.log(H)}return N}e.$8N=he;class Z{static create(V){const ie=V.webEndpointUrlTemplate,Y=V.commit,J=V.quality;if(!ie||!Y||!J)return new Z(null);const re=(0,g.$fg)(),oe=new URL(ie.replace("{{uuid}}",re).replace("{{commit}}",Y).replace("{{quality}}",J)).origin,_=(0,d.$Ge)(oe).replace(re,"[a-zA-Z0-9\\-]+");try{const q=(0,d.$Oe)(`^${_}$`,!0,{matchCase:!1});return new Z(q)}catch{return new Z(null)}}constructor(V){this.a=V}matches(V){return this.a?this.a.test(V):!1}}}),define(be[305],we([1,0,27,29,12,289,294,65,7,295,46,55,41]),function(ue,e,y,R,r,L,I,C,p,w,A,k,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createServer=e.spawnCli=void 0,v.mark("code/server/codeLoaded"),global.vscodeServerCodeLoadedTime=w.performance.now();const u={onMultipleValues:(g,l)=>{console.error(`Option '${g}' can only be defined once. Using value ${l}.`)},onEmptyValue:g=>{console.error(`Ignoring option '${g}': Value must not be empty.`)},onUnknownOption:g=>{console.error(`Ignoring option '${g}': not supported for server.`)},onDeprecatedOption:(g,l)=>{console.warn(`Option '${g}' is deprecated: ${l}`)}};function b(){return(0,C.$Il)(process.argv.slice(2),A.$om,u)}function m(g){const l=g["server-data-dir"]||g["user-data-dir"]||process.env.VSCODE_AGENT_FOLDER||(0,p.$jc)(y.homedir(),k.default.serverDataFolderName||".vscode-remote"),$=g["user-data-dir"]||(0,p.$jc)(l,"data"),c=(0,p.$jc)($,"User"),n=(0,p.$jc)(c,"globalStorage"),i=(0,p.$jc)(c,"History"),o=(0,p.$jc)($,"Machine");g["user-data-dir"]=$;const s=(0,p.$mc)(r.$dg.asFileUri("").fsPath),t=g["builtin-extensions-dir"]||(0,p.$jc)(s,"extensions");return g["builtin-extensions-dir"]=t,g["extensions-dir"]=g["extensions-dir"]||(0,p.$jc)(l,"extensions"),[l,g["extensions-dir"],$,c,o,n,i].forEach(a=>{try{R.existsSync(a)||R.mkdirSync(a,{mode:448})}catch(f){console.error(f)}}),l}function d(g=b()){return(0,L.run)(g,m(g),A.$om)}e.spawnCli=d;function h(g,l=b()){return(0,I.$8N)(g,l,m(l))}e.createServer=h})}).call(this);

//# sourceMappingURL=server.main.js.map
