"use strict";/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var De=["exports","require","vs/base/common/uri","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/workbench/api/common/extHostTypes","vs/base/common/async","vs/base/common/errors","vs/nls","vs/nls!vs/workbench/api/node/extensionHostProcess","vs/base/common/platform","vs/workbench/api/common/extHostTypeConverters","vs/platform/log/common/log","vs/base/common/path","vs/base/common/strings","vs/base/common/types","vs/base/common/network","vs/base/common/arrays","vs/workbench/api/common/extHostRpcService","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/resources","vs/base/common/objects","vs/platform/extensions/common/extensions","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/base/node/pfs","vs/platform/files/common/files","vs/base/common/uuid","vs/base/common/extpath","vs/editor/common/core/range","vs/workbench/api/common/extHostCommands","vs/base/common/stopwatch","vs/base/common/glob","vs/workbench/services/search/common/search","vs/workbench/api/common/extHostWorkspace","vs/base/common/severity","vs/workbench/api/common/extHostConfiguration","vs/base/common/errorMessage","vs/platform/contextkey/common/contextkey","vs/platform/registry/common/platform","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostExtensionService","vs/base/common/lazy","vs/base/common/process","child_process","vs/platform/configuration/common/configuration","vs/base/common/iterator","vs/base/common/hash","fs","vs/base/common/performance","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostVariableResolverService","vs/base/common/decorators","vs/base/common/assert","vs/base/common/themables","vs/base/common/marshalling","os","net","vs/editor/common/core/position","vs/platform/progress/common/progress","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTunnelService","vs/base/common/collections","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/ternarySearchTree","vs/base/common/codicons","vs/base/common/htmlContent","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/languages","vs/platform/files/common/watcher","vs/platform/telemetry/common/telemetryUtils","vs/platform/tunnel/common/tunnel","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/mime","vs/base/common/processes","vs/base/common/stream","vs/base/common/labels","vs/base/node/extpath","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/sign/common/sign","vs/workbench/api/common/cache","http","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/parts/ipc/node/ipc.net","vs/base/common/arraysFind","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/comparers","vs/base/common/filters","vs/base/common/fuzzyScorer","vs/base/common/uint","vs/base/common/uriIpc","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model","vs/editor/common/services/semanticTokensDto","vs/editor/common/config/editorOptions","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/product/common/productService","vs/platform/configuration/common/configurationRegistry","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/sign/node/signService","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/common/amd","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/cache","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/console","vs/amdX","vs/base/common/dataTransfer","vs/base/node/ports","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/editor/common/core/editOperation","vs/editor/common/core/selection","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languageSelector","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/services/treeViewsDnd","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/editor/common/languages","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChat","vs/nls!vs/workbench/api/common/extHostChatAgents2","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/remote/common/tunnelModel","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/dialogs/common/dialogs","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/io","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/sign/common/abstractSignService","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/uriIdentity/common/uriIdentity","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/platform/userDataProfile/common/userDataProfile","vs/platform/storage/common/storage","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/proxyResolver","vs/workbench/api/node/uriTransformer","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/api/common/extHostTheming","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChat","vs/workbench/api/common/extHostChatAgents","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatProvider","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostIssueReporter","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostConsoleForwarder","vs/workbench/api/node/extHostDiskFileSystemProvider","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostLoggerService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/remote/common/tunnelModel","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","string_decoder","vs/workbench/services/textfile/common/encoding","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/platform/tunnel/node/tunnelService","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHostTunnelService","vs/workbench/api/node/extHost.node.services","util","vs/base/common/semver/semver","graceful-fs","https","tls","@vscode/proxy-agent","events","vscode-regexpp","crypto","zlib","vs/workbench/api/node/extensionHostProcess","minimist"],Ce=function(re){for(var e=[],y=0,M=re.length;y<M;y++)e[y]=De[re[y]];return e};define(De[157],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=e.$T=void 0,e.$T=!1;class y{static get(){const l=new Map,L=new Map,A=new Map,g=new Map;function k(S,D){S.has(D.detail)||S.set(D.detail,-D.timestamp)}function $(S,D){const E=S.get(D.detail);E&&(E>=0||S.set(D.detail,E+D.timestamp))}let R=[];typeof re=="function"&&typeof re.getStats=="function"&&(R=re.getStats().slice(0).sort((S,D)=>S.timestamp-D.timestamp));for(const S of R)switch(S.type){case 10:k(l,S);break;case 11:case 12:$(l,S);break;case 21:k(L,S);break;case 22:$(L,S);break;case 33:k(A,S);break;case 34:$(A,S);break;case 31:k(g,S);break;case 32:$(g,S);break}let P=0;A.forEach(S=>P+=S);function p(S){const D=[];return S.forEach((E,h)=>D.push([h,E])),D}return{amdLoad:p(l),amdInvoke:p(L),nodeRequire:p(A),nodeEval:p(g),nodeRequireTotal:P}}static toMarkdownTable(l,L){let A="";const g=[];return l.forEach((k,$)=>{g[$]=k.length}),L.forEach(k=>{k.forEach(($,R)=>{typeof $>"u"&&($=k[R]="-");const P=$.toString().length;g[R]=Math.max(P,g[R])})}),l.forEach((k,$)=>{A+=`| ${k+" ".repeat(g[$]-k.toString().length)} `}),A+=`|
`,l.forEach((k,$)=>{A+=`| ${"-".repeat(g[$])} `}),A+=`|
`,L.forEach(k=>{k.forEach(($,R)=>{typeof $<"u"&&(A+=`| ${$+" ".repeat(g[R]-$.toString().length)} `)}),A+=`|
`}),A}}e.$U=y}),define(De[119],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rb=e.$qb=e.$pb=e.$ob=e.$nb=e.$mb=e.$lb=e.$kb=e.$jb=e.$ib=e.$hb=e.$gb=e.$fb=void 0;function y(E,h,u){const d=M(E,h);if(d!==-1)return E[d]}e.$fb=y;function M(E,h,u=E.length-1){for(let d=u;d>=0;d--){const c=E[d];if(h(c))return d}return-1}e.$gb=M;function l(E,h){const u=L(E,h);return u===-1?void 0:E[u]}e.$hb=l;function L(E,h,u=0,d=E.length){let c=u,f=d;for(;c<f;){const a=Math.floor((c+f)/2);h(E[a])?c=a+1:f=a}return c-1}e.$ib=L;function A(E,h){const u=g(E,h);return u===E.length?void 0:E[u]}e.$jb=A;function g(E,h,u=0,d=E.length){let c=u,f=d;for(;c<f;){const a=Math.floor((c+f)/2);h(E[a])?f=a:c=a+1}return c}e.$kb=g;function k(E,h,u=0,d=E.length){const c=g(E,h,u,d);return c===E.length?-1:c}e.$lb=k;class ${constructor(h){this.e=h,this.c=0}findLastMonotonous(h){if($.assertInvariants){if(this.d){for(const d of this.e)if(this.d(d)&&!h(d))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=h}const u=L(this.e,h,this.c);return this.c=u+1,u===-1?void 0:this.e[u]}}e.$mb=$,$.assertInvariants=!1;function R(E,h){if(E.length===0)return;let u=E[0];for(let d=1;d<E.length;d++){const c=E[d];h(c,u)>0&&(u=c)}return u}e.$nb=R;function P(E,h){if(E.length===0)return;let u=E[0];for(let d=1;d<E.length;d++){const c=E[d];h(c,u)>=0&&(u=c)}return u}e.$ob=P;function p(E,h){return R(E,(u,d)=>-h(u,d))}e.$pb=p;function S(E,h){if(E.length===0)return-1;let u=0;for(let d=1;d<E.length;d++){const c=E[d];h(c,E[u])>0&&(u=d)}return u}e.$qb=S;function D(E,h){for(const u of E){const d=h(u);if(d!==void 0)return d}}e.$rb=D}),define(De[74],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$G=e.$F=e.$E=e.$D=void 0;function y(A,g){const k=Object.create(null);for(const $ of A){const R=g($);let P=k[R];P||(P=k[R]=[]),P.push($)}return k}e.$D=y;function M(A,g){const k=[],$=[];for(const R of A)g.has(R)||k.push(R);for(const R of g)A.has(R)||$.push(R);return{removed:k,added:$}}e.$E=M;function l(A,g){const k=[],$=[];for(const[R,P]of A)g.has(R)||k.push(P);for(const[R,P]of g)A.has(R)||$.push(P);return{removed:k,added:$}}e.$F=l;function L(A,g){const k=new Set;for(const $ of g)A.has($)&&k.add($);return k}e.$G=L}),define(De[57],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kh=e.$jh=e.$ih=void 0;function y(A){return(g,k,$)=>{let R=null,P=null;if(typeof $.value=="function"?(R="value",P=$.value):typeof $.get=="function"&&(R="get",P=$.get),!P)throw new Error("not supported");$[R]=A(P,k)}}function M(A,g,k){let $=null,R=null;if(typeof k.value=="function"?($="value",R=k.value,R.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof k.get=="function"&&($="get",R=k.get),!R)throw new Error("not supported");const P=`$memoize$${g}`;k[$]=function(...p){return this.hasOwnProperty(P)||Object.defineProperty(this,P,{configurable:!1,enumerable:!1,writable:!1,value:R.apply(this,p)}),this[P]}}e.$ih=M;function l(A,g,k){return y(($,R)=>{const P=`$debounce$${R}`,p=`$debounce$result$${R}`;return function(...S){this[p]||(this[p]=k?k():void 0),clearTimeout(this[P]),g&&(this[p]=g(this[p],...S),S=[this[p]]),this[P]=setTimeout(()=>{$.apply(this,S),this[p]=k?k():void 0},A)}})}e.$jh=l;function L(A,g,k){return y(($,R)=>{const P=`$throttle$timer$${R}`,p=`$throttle$result$${R}`,S=`$throttle$lastRun$${R}`,D=`$throttle$pending$${R}`;return function(...E){if(this[p]||(this[p]=k?k():void 0),(this[S]===null||this[S]===void 0)&&(this[S]=-Number.MAX_VALUE),g&&(this[p]=g(this[p],...E)),this[D])return;const h=this[S]+A;h<=Date.now()?(this[S]=Date.now(),$.apply(this,[this[p]]),this[p]=k?k():void 0):(this[D]=!0,this[P]=setTimeout(()=>{this[D]=!1,this[S]=Date.now(),$.apply(this,[this[p]]),this[p]=k?k():void 0},h-Date.now()))}})}e.$kh=L}),define(De[9],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=e.$bb=e.$ab=e.$_=e.$$=e.$0=e.$9=e.$8=e.$7=e.$6=e.$5=e.$4=e.$3=e.$2=e.$1=e.$Z=e.setUnexpectedErrorHandler=e.$X=e.$W=void 0;class y{constructor(){this.b=[],this.a=function(t){setTimeout(()=>{throw t.stack?c.isErrorNoTelemetry(t)?new c(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.b.push(t),()=>{this.d(t)}}c(t){this.b.forEach(i=>{i(t)})}d(t){this.b.splice(this.b.indexOf(t),1)}setUnexpectedErrorHandler(t){this.a=t}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(t){this.a(t),this.c(t)}onUnexpectedExternalError(t){this.a(t)}}e.$W=y,e.$X=new y;function M(a){e.$X.setUnexpectedErrorHandler(a)}e.setUnexpectedErrorHandler=M;function l(a){if(!a||typeof a!="object")return!1;const t=a;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}e.$Z=l;function L(a){$(a)||e.$X.onUnexpectedError(a)}e.$1=L;function A(a){$(a)||e.$X.onUnexpectedExternalError(a)}e.$2=A;function g(a){if(a instanceof Error){const{name:t,message:i}=a,s=a.stacktrace||a.stack;return{$isError:!0,name:t,message:i,stack:s,noTelemetry:c.isErrorNoTelemetry(a)}}return a}e.$3=g;const k="Canceled";function $(a){return a instanceof R?!0:a instanceof Error&&a.name===k&&a.message===k}e.$4=$;class R extends Error{constructor(){super(k),this.name=this.message}}e.$5=R;function P(){const a=new Error(k);return a.name=a.message,a}e.$6=P;function p(a){return a?new Error(`Illegal argument: ${a}`):new Error("Illegal argument")}e.$7=p;function S(a){return a?new Error(`Illegal state: ${a}`):new Error("Illegal state")}e.$8=S;class D extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$9=D;function E(a){return a?a.message?a.message:a.stack?a.stack.split(`
`)[0]:String(a):"Error"}e.$0=E;class h extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.$$=h;class u extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.$_=u;class d extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$ab=d;class c extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof c)return t;const i=new c;return i.message=t.message,i.stack=t.stack,i}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.$bb=c;class f extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,f.prototype)}}e.$cb=f}),define(De[19],Ce([1,0,9,119]),function(re,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ac=e.$_b=e.$$b=e.$0b=e.$9b=e.$8b=e.$7b=e.CompareResult=e.$6b=e.$5b=e.$4b=e.$3b=e.$2b=e.$1b=e.$Zb=e.$Yb=e.$Xb=e.$Wb=e.$Vb=e.$Ub=e.$Tb=e.$Sb=e.$Rb=e.$Qb=e.$Pb=e.$Ob=e.$Nb=e.$Mb=e.$Lb=e.$Kb=e.$Jb=e.$Ib=e.$Hb=e.$Gb=e.top=e.$Eb=e.$Db=e.$Cb=e.$Bb=e.$Ab=e.$zb=e.$yb=e.$xb=e.$wb=e.$vb=e.$ub=e.$tb=e.$sb=void 0;function l(G,Y=0){return G[G.length-(1+Y)]}e.$sb=l;function L(G){if(G.length===0)throw new Error("Invalid tail call");return[G.slice(0,G.length-1),G[G.length-1]]}e.$tb=L;function A(G,Y,X=(be,se)=>be===se){if(G===Y)return!0;if(!G||!Y||G.length!==Y.length)return!1;for(let be=0,se=G.length;be<se;be++)if(!X(G[be],Y[be]))return!1;return!0}e.$ub=A;function g(G,Y){const X=G.length-1;Y<X&&(G[Y]=G[X]),G.pop()}e.$vb=g;function k(G,Y,X){return $(G.length,be=>X(G[be],Y))}e.$wb=k;function $(G,Y){let X=0,be=G-1;for(;X<=be;){const se=(X+be)/2|0,ge=Y(se);if(ge<0)X=se+1;else if(ge>0)be=se-1;else return se}return-(X+1)}e.$xb=$;function R(G,Y,X){if(G=G|0,G>=Y.length)throw new TypeError("invalid index");const be=Y[Math.floor(Y.length*Math.random())],se=[],ge=[],te=[];for(const me of Y){const we=X(me,be);we<0?se.push(me):we>0?ge.push(me):te.push(me)}return G<se.length?R(G,se,X):G<se.length+te.length?te[0]:R(G-(se.length+te.length),ge,X)}e.$yb=R;function P(G,Y){const X=[];let be;for(const se of G.slice(0).sort(Y))!be||Y(be[0],se)!==0?(be=[se],X.push(be)):be.push(se);return X}e.$zb=P;function*p(G,Y){let X,be;for(const se of G)be!==void 0&&Y(be,se)?X.push(se):(X&&(yield X),X=[se]),be=se;X&&(yield X)}e.$Ab=p;function S(G,Y){for(let X=0;X<=G.length;X++)Y(X===0?void 0:G[X-1],X===G.length?void 0:G[X])}e.$Bb=S;function D(G,Y){for(let X=0;X<G.length;X++)Y(X===0?void 0:G[X-1],G[X],X+1===G.length?void 0:G[X+1])}e.$Cb=D;function E(G,Y,X){const be=[];function se(me,we,Ie){if(we===0&&Ie.length===0)return;const W=be[be.length-1];W&&W.start+W.deleteCount===me?(W.deleteCount+=we,W.toInsert.push(...Ie)):be.push({start:me,deleteCount:we,toInsert:Ie})}let ge=0,te=0;for(;;){if(ge===G.length){se(ge,0,Y.slice(te));break}if(te===Y.length){se(ge,G.length-ge,[]);break}const me=G[ge],we=Y[te],Ie=X(me,we);Ie===0?(ge+=1,te+=1):Ie<0?(se(ge,1,[]),ge+=1):Ie>0&&(se(ge,0,[we]),te+=1)}return be}e.$Db=E;function h(G,Y,X){const be=E(G,Y,X),se=[],ge=[];for(const te of be)se.push(...G.slice(te.start,te.start+te.deleteCount)),ge.push(...te.toInsert);return{removed:se,added:ge}}e.$Eb=h;function u(G,Y,X){if(X===0)return[];const be=G.slice(0,X).sort(Y);return c(G,Y,be,X,G.length),be}e.top=u;function d(G,Y,X,be,se){return X===0?Promise.resolve([]):new Promise((ge,te)=>{(async()=>{const me=G.length,we=G.slice(0,X).sort(Y);for(let Ie=X,W=Math.min(X+be,me);Ie<me;Ie=W,W=Math.min(W+be,me)){if(Ie>X&&await new Promise(J=>setTimeout(J)),se&&se.isCancellationRequested)throw new y.$5;c(G,Y,we,Ie,W)}return we})().then(ge,te)})}e.$Gb=d;function c(G,Y,X,be,se){for(const ge=X.length;be<se;be++){const te=G[be];if(Y(te,X[ge-1])<0){X.pop();const me=(0,M.$kb)(X,we=>Y(te,we)<0);X.splice(me,0,te)}}}function f(G){return G.filter(Y=>!!Y)}e.$Hb=f;function a(G){let Y=0;for(let X=0;X<G.length;X++)G[X]&&(G[Y]=G[X],Y+=1);G.length=Y}e.$Ib=a;function t(G,Y,X){G.splice(X,0,G.splice(Y,1)[0])}e.$Jb=t;function i(G){return!Array.isArray(G)||G.length===0}e.$Kb=i;function s(G){return Array.isArray(G)&&G.length>0}e.$Lb=s;function n(G,Y=X=>X){const X=new Set;return G.filter(be=>{const se=Y(be);return X.has(se)?!1:(X.add(se),!0)})}e.$Mb=n;function r(G){const Y=new Set;return X=>{const be=G(X);return Y.has(be)?!1:(Y.add(be),!0)}}e.$Nb=r;function o(G,Y){return G.length>0?G[0]:Y}e.$Ob=o;function v(G,Y){return G.length>0?G[G.length-1]:Y}e.$Pb=v;function C(G,Y,X=(be,se)=>be===se){let be=0;for(let se=0,ge=Math.min(G.length,Y.length);se<ge&&X(G[se],Y[se]);se++)be++;return be}e.$Qb=C;function w(G){return[].concat(...G)}e.$Rb=w;function m(G,Y){let X=typeof Y=="number"?G:0;typeof Y=="number"?X=G:(X=0,Y=G);const be=[];if(X<=Y)for(let se=X;se<Y;se++)be.push(se);else for(let se=X;se>Y;se--)be.push(se);return be}e.$Sb=m;function b(G,Y,X){return G.reduce((be,se)=>(be[Y(se)]=X?X(se):se,be),Object.create(null))}e.$Tb=b;function I(G,Y){return G.push(Y),()=>z(G,Y)}e.$Ub=I;function z(G,Y){const X=G.indexOf(Y);if(X>-1)return G.splice(X,1),Y}e.$Vb=z;function O(G,Y,X){const be=G.slice(0,Y),se=G.slice(Y);return be.concat(X,se)}e.$Wb=O;function F(G,Y){let X;if(typeof Y=="number"){let be=Y;X=()=>{const se=Math.sin(be++)*179426549;return se-Math.floor(se)}}else X=Math.random;for(let be=G.length-1;be>0;be-=1){const se=Math.floor(X()*(be+1)),ge=G[be];G[be]=G[se],G[se]=ge}}e.$Xb=F;function T(G,Y){const X=G.indexOf(Y);X>-1&&(G.splice(X,1),G.unshift(Y))}e.$Yb=T;function N(G,Y){const X=G.indexOf(Y);X>-1&&(G.splice(X,1),G.push(Y))}e.$Zb=N;function j(G,Y){for(const X of Y)G.push(X)}e.$1b=j;function U(G,Y){return Array.isArray(G)?G.map(Y):Y(G)}e.$2b=U;function B(G){return Array.isArray(G)?G:[G]}e.$3b=B;function he(G){return G[Math.floor(Math.random()*G.length)]}e.$4b=he;function x(G,Y,X){const be=Z(G,Y),se=G.length,ge=X.length;G.length=se+ge;for(let te=se-1;te>=be;te--)G[te+ge]=G[te];for(let te=0;te<ge;te++)G[te+be]=X[te]}e.$5b=x;function Q(G,Y,X,be){const se=Z(G,Y);let ge=G.splice(se,X);return ge===void 0&&(ge=[]),x(G,se,be),ge}e.$6b=Q;function Z(G,Y){return Y<0?Math.max(Y+G.length,0):Math.min(Y,G.length)}var ie;(function(G){function Y(ge){return ge<0}G.isLessThan=Y;function X(ge){return ge<=0}G.isLessThanOrEqual=X;function be(ge){return ge>0}G.isGreaterThan=be;function se(ge){return ge===0}G.isNeitherLessOrGreaterThan=se,G.greaterThan=1,G.lessThan=-1,G.neitherLessOrGreaterThan=0})(ie||(e.CompareResult=ie={}));function _(G,Y){return(X,be)=>Y(G(X),G(be))}e.$7b=_;function oe(...G){return(Y,X)=>{for(const be of G){const se=be(Y,X);if(!ie.isNeitherLessOrGreaterThan(se))return se}return ie.neitherLessOrGreaterThan}}e.$8b=oe;const ye=(G,Y)=>G-Y;e.$9b=ye;const fe=(G,Y)=>(0,e.$9b)(G?1:0,Y?1:0);e.$0b=fe;function V(G){return(Y,X)=>-G(Y,X)}e.$$b=V;class le{constructor(Y){this.g=Y,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(Y){let X=this.c;for(;X<this.g.length&&Y(this.g[X]);)X++;const be=X===this.c?null:this.g.slice(this.c,X);return this.c=X,be}takeFromEndWhile(Y){let X=this.d;for(;X>=0&&Y(this.g[X]);)X--;const be=X===this.d?null:this.g.slice(X+1,this.d+1);return this.d=X,be}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const Y=this.g[this.c];return this.c++,Y}removeLast(){const Y=this.g[this.d];return this.d--,Y}takeCount(Y){const X=this.g.slice(this.c,this.c+Y);return this.c+=Y,X}}e.$_b=le;class H{constructor(Y){this.iterate=Y}forEach(Y){this.iterate(X=>(Y(X),!0))}toArray(){const Y=[];return this.iterate(X=>(Y.push(X),!0)),Y}filter(Y){return new H(X=>this.iterate(be=>Y(be)?X(be):!0))}map(Y){return new H(X=>this.iterate(be=>X(Y(be))))}some(Y){let X=!1;return this.iterate(be=>(X=Y(be),!X)),X}findFirst(Y){let X;return this.iterate(be=>Y(be)?(X=be,!1):!0),X}findLast(Y){let X;return this.iterate(be=>(Y(be)&&(X=be),!0)),X}findLastMaxBy(Y){let X,be=!0;return this.iterate(se=>((be||ie.isGreaterThan(Y(se,X)))&&(be=!1,X=se),!0)),X}}e.$ac=H,H.empty=new H(G=>{})}),define(De[58],Ce([1,0,9]),function(re,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7c=e.$6c=e.$5c=e.$4c=e.ok=void 0;function M(k,$){if(!k)throw new Error($?`Assertion failed (${$})`:"Assertion Failed")}e.ok=M;function l(k,$="Unreachable"){throw new Error($)}e.$4c=l;function L(k){if(!k)throw new y.$cb("Assertion Failed")}e.$5c=L;function A(k){if(!k()){debugger;k(),(0,y.$1)(new y.$cb("Assertion Failed"))}}e.$6c=A;function g(k,$){let R=0;for(;R<k.length-1;){const P=k[R],p=k[R+1];if(!$(P,p))return!1;R++}return!0}e.$7c=g}),define(De[75],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$db=void 0;function y(M){const l=this;let L=!1,A;return function(){return L||(L=!0,A=M.apply(l,arguments)),A}}e.$db=y}),define(De[120],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xM=e.$wM=void 0;class y{constructor(l){this.a=l,this.b=0}nextId(){return this.a+ ++this.b}}e.$wM=y,e.$xM=new y("id#")}),define(De[51],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var y;(function(M){function l(a){return a&&typeof a=="object"&&typeof a[Symbol.iterator]=="function"}M.is=l;const L=Object.freeze([]);function A(){return L}M.empty=A;function*g(a){yield a}M.single=g;function k(a){return l(a)?a:g(a)}M.wrap=k;function $(a){return a||L}M.from=$;function*R(a){for(let t=a.length-1;t>=0;t--)yield a[t]}M.reverse=R;function P(a){return!a||a[Symbol.iterator]().next().done===!0}M.isEmpty=P;function p(a){return a[Symbol.iterator]().next().value}M.first=p;function S(a,t){for(const i of a)if(t(i))return!0;return!1}M.some=S;function D(a,t){for(const i of a)if(t(i))return i}M.find=D;function*E(a,t){for(const i of a)t(i)&&(yield i)}M.filter=E;function*h(a,t){let i=0;for(const s of a)yield t(s,i++)}M.map=h;function*u(...a){for(const t of a)for(const i of t)yield i}M.concat=u;function d(a,t,i){let s=i;for(const n of a)s=t(s,n);return s}M.reduce=d;function*c(a,t,i=a.length){for(t<0&&(t+=a.length),i<0?i+=a.length:i>a.length&&(i=a.length);t<i;t++)yield a[t]}M.slice=c;function f(a,t=Number.POSITIVE_INFINITY){const i=[];if(t===0)return[i,a];const s=a[Symbol.iterator]();for(let n=0;n<t;n++){const r=s.next();if(r.done)return[i,M.empty()];i.push(r.value)}return[i,{[Symbol.iterator](){return s}}]}M.consume=f})(y||(e.Iterable=y={}))}),define(De[158],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8m=e.$7m=e.$6m=e.$5m=e.$4m=e.$3m=e.$2m=e.$1m=e.$Zm=e.$Ym=e.$Xm=e.$Wm=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var y;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(y||(e.ScanError=y={}));var M;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(M||(e.SyntaxKind=M={}));var l;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(l||(e.ParseErrorCode=l={}));var L;(function(t){t.DEFAULT={allowTrailingComma:!0}})(L||(e.ParseOptions=L={}));function A(t,i=!1){let s=0;const n=t.length;let r="",o=0,v=16,C=0;function w(T){let N=0,j=0;for(;N<T;){const U=t.charCodeAt(s);if(U>=48&&U<=57)j=j*16+U-48;else if(U>=65&&U<=70)j=j*16+U-65+10;else if(U>=97&&U<=102)j=j*16+U-97+10;else break;s++,N++}return N<T&&(j=-1),j}function m(T){s=T,r="",o=0,v=16,C=0}function b(){const T=s;if(t.charCodeAt(s)===48)s++;else for(s++;s<t.length&&$(t.charCodeAt(s));)s++;if(s<t.length&&t.charCodeAt(s)===46)if(s++,s<t.length&&$(t.charCodeAt(s)))for(s++;s<t.length&&$(t.charCodeAt(s));)s++;else return C=3,t.substring(T,s);let N=s;if(s<t.length&&(t.charCodeAt(s)===69||t.charCodeAt(s)===101))if(s++,(s<t.length&&t.charCodeAt(s)===43||t.charCodeAt(s)===45)&&s++,s<t.length&&$(t.charCodeAt(s))){for(s++;s<t.length&&$(t.charCodeAt(s));)s++;N=s}else C=3;return t.substring(T,N)}function I(){let T="",N=s;for(;;){if(s>=n){T+=t.substring(N,s),C=2;break}const j=t.charCodeAt(s);if(j===34){T+=t.substring(N,s),s++;break}if(j===92){if(T+=t.substring(N,s),s++,s>=n){C=2;break}switch(t.charCodeAt(s++)){case 34:T+='"';break;case 92:T+="\\";break;case 47:T+="/";break;case 98:T+="\b";break;case 102:T+="\f";break;case 110:T+=`
`;break;case 114:T+="\r";break;case 116:T+="	";break;case 117:{const B=w(4);B>=0?T+=String.fromCharCode(B):C=4;break}default:C=5}N=s;continue}if(j>=0&&j<=31)if(k(j)){T+=t.substring(N,s),C=2;break}else C=6;s++}return T}function z(){if(r="",C=0,o=s,s>=n)return o=n,v=17;let T=t.charCodeAt(s);if(g(T)){do s++,r+=String.fromCharCode(T),T=t.charCodeAt(s);while(g(T));return v=15}if(k(T))return s++,r+=String.fromCharCode(T),T===13&&t.charCodeAt(s)===10&&(s++,r+=`
`),v=14;switch(T){case 123:return s++,v=1;case 125:return s++,v=2;case 91:return s++,v=3;case 93:return s++,v=4;case 58:return s++,v=6;case 44:return s++,v=5;case 34:return s++,r=I(),v=10;case 47:{const N=s-1;if(t.charCodeAt(s+1)===47){for(s+=2;s<n&&!k(t.charCodeAt(s));)s++;return r=t.substring(N,s),v=12}if(t.charCodeAt(s+1)===42){s+=2;const j=n-1;let U=!1;for(;s<j;){if(t.charCodeAt(s)===42&&t.charCodeAt(s+1)===47){s+=2,U=!0;break}s++}return U||(s++,C=1),r=t.substring(N,s),v=13}return r+=String.fromCharCode(T),s++,v=16}case 45:if(r+=String.fromCharCode(T),s++,s===n||!$(t.charCodeAt(s)))return v=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return r+=b(),v=11;default:for(;s<n&&O(T);)s++,T=t.charCodeAt(s);if(o!==s){switch(r=t.substring(o,s),r){case"true":return v=8;case"false":return v=9;case"null":return v=7}return v=16}return r+=String.fromCharCode(T),s++,v=16}}function O(T){if(g(T)||k(T))return!1;switch(T){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function F(){let T;do T=z();while(T>=12&&T<=15);return T}return{setPosition:m,getPosition:()=>s,scan:i?F:z,getToken:()=>v,getTokenValue:()=>r,getTokenOffset:()=>o,getTokenLength:()=>s-o,getTokenError:()=>C}}e.$Wm=A;function g(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function k(t){return t===10||t===13||t===8232||t===8233}function $(t){return t>=48&&t<=57}var R;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(R||(R={}));function P(t,i){const s=[],n=new Object;let r;const o={value:{},offset:0,length:0,type:"object",parent:void 0};let v=!1;function C(w,m,b,I){o.value=w,o.offset=m,o.length=b,o.type=I,o.colonOffset=void 0,r=o}try{c(t,{onObjectBegin:(w,m)=>{if(i<=w)throw n;r=void 0,v=i>w,s.push("")},onObjectProperty:(w,m,b)=>{if(i<m||(C(w,m,b,"property"),s[s.length-1]=w,i<=m+b))throw n},onObjectEnd:(w,m)=>{if(i<=w)throw n;r=void 0,s.pop()},onArrayBegin:(w,m)=>{if(i<=w)throw n;r=void 0,s.push(0)},onArrayEnd:(w,m)=>{if(i<=w)throw n;r=void 0,s.pop()},onLiteralValue:(w,m,b)=>{if(i<m||(C(w,m,b,a(w)),i<=m+b))throw n},onSeparator:(w,m,b)=>{if(i<=m)throw n;if(w===":"&&r&&r.type==="property")r.colonOffset=m,v=!1,r=void 0;else if(w===","){const I=s[s.length-1];typeof I=="number"?s[s.length-1]=I+1:(v=!0,s[s.length-1]=""),r=void 0}}})}catch(w){if(w!==n)throw w}return{path:s,previousNode:r,isAtPropertyKey:v,matches:w=>{let m=0;for(let b=0;m<w.length&&b<s.length;b++)if(w[m]===s[b]||w[m]==="*")m++;else if(w[m]!=="**")return!1;return m===w.length}}}e.$Xm=P;function p(t,i=[],s=L.DEFAULT){let n=null,r=[];const o=[];function v(w){Array.isArray(r)?r.push(w):n!==null&&(r[n]=w)}return c(t,{onObjectBegin:()=>{const w={};v(w),o.push(r),r=w,n=null},onObjectProperty:w=>{n=w},onObjectEnd:()=>{r=o.pop()},onArrayBegin:()=>{const w=[];v(w),o.push(r),r=w,n=null},onArrayEnd:()=>{r=o.pop()},onLiteralValue:v,onError:(w,m,b)=>{i.push({error:w,offset:m,length:b})}},s),r[0]}e.$Ym=p;function S(t,i=[],s=L.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function r(w){n.type==="property"&&(n.length=w-n.offset,n=n.parent)}function o(w){return n.children.push(w),w}c(t,{onObjectBegin:w=>{n=o({type:"object",offset:w,length:-1,parent:n,children:[]})},onObjectProperty:(w,m,b)=>{n=o({type:"property",offset:m,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:w,offset:m,length:b,parent:n})},onObjectEnd:(w,m)=>{n.length=w+m-n.offset,n=n.parent,r(w+m)},onArrayBegin:(w,m)=>{n=o({type:"array",offset:w,length:-1,parent:n,children:[]})},onArrayEnd:(w,m)=>{n.length=w+m-n.offset,n=n.parent,r(w+m)},onLiteralValue:(w,m,b)=>{o({type:a(w),offset:m,length:b,parent:n,value:w}),r(m+b)},onSeparator:(w,m,b)=>{n.type==="property"&&(w===":"?n.colonOffset=m:w===","&&r(m))},onError:(w,m,b)=>{i.push({error:w,offset:m,length:b})}},s);const C=n.children[0];return C&&delete C.parent,C}e.$Zm=S;function D(t,i){if(!t)return;let s=t;for(const n of i)if(typeof n=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let r=!1;for(const o of s.children)if(Array.isArray(o.children)&&o.children[0].value===n){s=o.children[1],r=!0;break}if(!r)return}else{const r=n;if(s.type!=="array"||r<0||!Array.isArray(s.children)||r>=s.children.length)return;s=s.children[r]}return s}e.$1m=D;function E(t){if(!t.parent||!t.parent.children)return[];const i=E(t.parent);if(t.parent.type==="property"){const s=t.parent.children[0].value;i.push(s)}else if(t.parent.type==="array"){const s=t.parent.children.indexOf(t);s!==-1&&i.push(s)}return i}e.$2m=E;function h(t){switch(t.type){case"array":return t.children.map(h);case"object":{const i=Object.create(null);for(const s of t.children){const n=s.children[1];n&&(i[s.children[0].value]=h(n))}return i}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.$3m=h;function u(t,i,s=!1){return i>=t.offset&&i<t.offset+t.length||s&&i===t.offset+t.length}e.$4m=u;function d(t,i,s=!1){if(u(t,i,s)){const n=t.children;if(Array.isArray(n))for(let r=0;r<n.length&&n[r].offset<=i;r++){const o=d(n[r],i,s);if(o)return o}return t}}e.$5m=d;function c(t,i,s=L.DEFAULT){const n=A(t,!1);function r(_){return _?()=>_(n.getTokenOffset(),n.getTokenLength()):()=>!0}function o(_){return _?oe=>_(oe,n.getTokenOffset(),n.getTokenLength()):()=>!0}const v=r(i.onObjectBegin),C=o(i.onObjectProperty),w=r(i.onObjectEnd),m=r(i.onArrayBegin),b=r(i.onArrayEnd),I=o(i.onLiteralValue),z=o(i.onSeparator),O=r(i.onComment),F=o(i.onError),T=s&&s.disallowComments,N=s&&s.allowTrailingComma;function j(){for(;;){const _=n.scan();switch(n.getTokenError()){case 4:U(14);break;case 5:U(15);break;case 3:U(13);break;case 1:T||U(11);break;case 2:U(12);break;case 6:U(16);break}switch(_){case 12:case 13:T?U(10):O();break;case 16:U(1);break;case 15:case 14:break;default:return _}}}function U(_,oe=[],ye=[]){if(F(_),oe.length+ye.length>0){let fe=n.getToken();for(;fe!==17;){if(oe.indexOf(fe)!==-1){j();break}else if(ye.indexOf(fe)!==-1)break;fe=j()}}}function B(_){const oe=n.getTokenValue();return _?I(oe):C(oe),j(),!0}function he(){switch(n.getToken()){case 11:{let _=0;try{_=JSON.parse(n.getTokenValue()),typeof _!="number"&&(U(2),_=0)}catch{U(2)}I(_);break}case 7:I(null);break;case 8:I(!0);break;case 9:I(!1);break;default:return!1}return j(),!0}function x(){return n.getToken()!==10?(U(3,[],[2,5]),!1):(B(!1),n.getToken()===6?(z(":"),j(),ie()||U(4,[],[2,5])):U(5,[],[2,5]),!0)}function Q(){v(),j();let _=!1;for(;n.getToken()!==2&&n.getToken()!==17;){if(n.getToken()===5){if(_||U(4,[],[]),z(","),j(),n.getToken()===2&&N)break}else _&&U(6,[],[]);x()||U(4,[],[2,5]),_=!0}return w(),n.getToken()!==2?U(7,[2],[]):j(),!0}function Z(){m(),j();let _=!1;for(;n.getToken()!==4&&n.getToken()!==17;){if(n.getToken()===5){if(_||U(4,[],[]),z(","),j(),n.getToken()===4&&N)break}else _&&U(6,[],[]);ie()||U(4,[],[4,5]),_=!0}return b(),n.getToken()!==4?U(8,[4],[]):j(),!0}function ie(){switch(n.getToken()){case 3:return Z();case 1:return Q();case 10:return B(!0);default:return he()}}return j(),n.getToken()===17?s.allowEmptyContent?!0:(U(4,[],[]),!1):ie()?(n.getToken()!==17&&U(9,[],[]),!0):(U(4,[],[]),!1)}e.$6m=c;function f(t,i){const s=A(t),n=[];let r,o=0,v;do switch(v=s.getPosition(),r=s.scan(),r){case 12:case 13:case 17:o!==v&&n.push(t.substring(o,v)),i!==void 0&&n.push(s.getTokenValue().replace(/[^\r\n]/g,i)),o=s.getPosition();break}while(r!==17);return n.join("")}e.$7m=f;function a(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.$8m=a}),define(De[47],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V=void 0;class y{constructor(l){this.d=l,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(l){this.c=l}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$V=y}),define(De[76],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2c=void 0;class y{constructor(L){this.element=L,this.next=y.Undefined,this.prev=y.Undefined}}y.Undefined=new y(void 0);class M{constructor(){this.a=y.Undefined,this.b=y.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===y.Undefined}clear(){let L=this.a;for(;L!==y.Undefined;){const A=L.next;L.prev=y.Undefined,L.next=y.Undefined,L=A}this.a=y.Undefined,this.b=y.Undefined,this.c=0}unshift(L){return this.d(L,!1)}push(L){return this.d(L,!0)}d(L,A){const g=new y(L);if(this.a===y.Undefined)this.a=g,this.b=g;else if(A){const $=this.b;this.b=g,g.prev=$,$.next=g}else{const $=this.a;this.a=g,g.next=$,$.prev=g}this.c+=1;let k=!1;return()=>{k||(k=!0,this.e(g))}}shift(){if(this.a!==y.Undefined){const L=this.a.element;return this.e(this.a),L}}pop(){if(this.b!==y.Undefined){const L=this.b.element;return this.e(this.b),L}}e(L){if(L.prev!==y.Undefined&&L.next!==y.Undefined){const A=L.prev;A.next=L.next,L.next.prev=A}else L.prev===y.Undefined&&L.next===y.Undefined?(this.a=y.Undefined,this.b=y.Undefined):L.next===y.Undefined?(this.b=this.b.prev,this.b.next=y.Undefined):L.prev===y.Undefined&&(this.a=this.a.next,this.a.prev=y.Undefined);this.c-=1}*[Symbol.iterator](){let L=this.a;for(;L!==y.Undefined;)yield L.element,L=L.next}}e.$2c=M}),define(De[28],Ce([1,0]),function(re,e){"use strict";var y,M,l;Object.defineProperty(e,"__esModule",{value:!0}),e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.$Cc=e.Touch=e.$Bc=e.$Ac=e.$zc=e.$yc=e.$xc=void 0;function L(d,c,f){let a=d.get(c);return a===void 0&&(a=f,d.set(c,a)),a}e.$xc=L;function A(d){const c=[];return d.forEach((f,a)=>{c.push(`${a} => ${f}`)}),`Map(${d.size}) {${c.join(", ")}}`}e.$yc=A;function g(d){const c=[];return d.forEach(f=>{c.push(f)}),`Set(${d.size}) {${c.join(", ")}}`}e.$zc=g;class k{constructor(c,f){this.uri=c,this.value=f}}function $(d){return Array.isArray(d)}class R{constructor(c,f){if(this[y]="ResourceMap",c instanceof R)this.b=new Map(c.b),this.c=f??R.a;else if($(c)){this.b=new Map,this.c=f??R.a;for(const[a,t]of c)this.set(a,t)}else this.b=new Map,this.c=c??R.a}set(c,f){return this.b.set(this.c(c),new k(c,f)),this}get(c){return this.b.get(this.c(c))?.value}has(c){return this.b.has(this.c(c))}get size(){return this.b.size}clear(){this.b.clear()}delete(c){return this.b.delete(this.c(c))}forEach(c,f){typeof f<"u"&&(c=c.bind(f));for(const[a,t]of this.b)c(t.value,t.uri,this)}*values(){for(const c of this.b.values())yield c.value}*keys(){for(const c of this.b.values())yield c.uri}*entries(){for(const c of this.b.values())yield[c.uri,c.value]}*[(y=Symbol.toStringTag,Symbol.iterator)](){for(const[,c]of this.b)yield[c.uri,c.value]}}e.$Ac=R,R.a=d=>d.toString();class P{constructor(c,f){this[M]="ResourceSet",!c||typeof c=="function"?this.a=new R(c):(this.a=new R(f),c.forEach(this.add,this))}get size(){return this.a.size}add(c){return this.a.set(c,c),this}clear(){this.a.clear()}delete(c){return this.a.delete(c)}forEach(c,f){this.a.forEach((a,t)=>c.call(f,t,t,this))}has(c){return this.a.has(c)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(M=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Bc=P;var p;(function(d){d[d.None=0]="None",d[d.AsOld=1]="AsOld",d[d.AsNew=2]="AsNew"})(p||(e.Touch=p={}));class S{constructor(){this[l]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(c){return this.a.has(c)}get(c,f=0){const a=this.a.get(c);if(a)return f!==0&&this.j(a,f),a.value}set(c,f,a=0){let t=this.a.get(c);if(t)t.value=f,a!==0&&this.j(t,a);else{switch(t={key:c,value:f,next:void 0,previous:void 0},a){case 0:this.h(t);break;case 1:this.g(t);break;case 2:this.h(t);break;default:this.h(t);break}this.a.set(c,t),this.d++}return this}delete(c){return!!this.remove(c)}remove(c){const f=this.a.get(c);if(f)return this.a.delete(c),this.i(f),this.d--,f.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const c=this.b;return this.a.delete(c.key),this.i(c),this.d--,c.value}forEach(c,f){const a=this.e;let t=this.b;for(;t;){if(f?c.bind(f)(t.value,t.key,this):c(t.value,t.key,this),this.e!==a)throw new Error("LinkedMap got modified during iteration.");t=t.next}}keys(){const c=this,f=this.e;let a=this.b;const t={[Symbol.iterator](){return t},next(){if(c.e!==f)throw new Error("LinkedMap got modified during iteration.");if(a){const i={value:a.key,done:!1};return a=a.next,i}else return{value:void 0,done:!0}}};return t}values(){const c=this,f=this.e;let a=this.b;const t={[Symbol.iterator](){return t},next(){if(c.e!==f)throw new Error("LinkedMap got modified during iteration.");if(a){const i={value:a.value,done:!1};return a=a.next,i}else return{value:void 0,done:!0}}};return t}entries(){const c=this,f=this.e;let a=this.b;const t={[Symbol.iterator](){return t},next(){if(c.e!==f)throw new Error("LinkedMap got modified during iteration.");if(a){const i={value:[a.key,a.value],done:!1};return a=a.next,i}else return{value:void 0,done:!0}}};return t}[(l=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(c){if(c>=this.size)return;if(c===0){this.clear();return}let f=this.b,a=this.size;for(;f&&a>c;)this.a.delete(f.key),f=f.next,a--;this.b=f,this.d=a,f&&(f.previous=void 0),this.e++}g(c){if(!this.b&&!this.c)this.c=c;else if(this.b)c.next=this.b,this.b.previous=c;else throw new Error("Invalid list");this.b=c,this.e++}h(c){if(!this.b&&!this.c)this.b=c;else if(this.c)c.previous=this.c,this.c.next=c;else throw new Error("Invalid list");this.c=c,this.e++}i(c){if(c===this.b&&c===this.c)this.b=void 0,this.c=void 0;else if(c===this.b){if(!c.next)throw new Error("Invalid list");c.next.previous=void 0,this.b=c.next}else if(c===this.c){if(!c.previous)throw new Error("Invalid list");c.previous.next=void 0,this.c=c.previous}else{const f=c.next,a=c.previous;if(!f||!a)throw new Error("Invalid list");f.previous=a,a.next=f}c.next=void 0,c.previous=void 0,this.e++}j(c,f){if(!this.b||!this.c)throw new Error("Invalid list");if(!(f!==1&&f!==2)){if(f===1){if(c===this.b)return;const a=c.next,t=c.previous;c===this.c?(t.next=void 0,this.c=t):(a.previous=t,t.next=a),c.previous=void 0,c.next=this.b,this.b.previous=c,this.b=c,this.e++}else if(f===2){if(c===this.c)return;const a=c.next,t=c.previous;c===this.b?(a.previous=void 0,this.b=a):(a.previous=t,t.next=a),c.next=void 0,c.previous=this.c,this.c.next=c,this.c=c,this.e++}}}toJSON(){const c=[];return this.forEach((f,a)=>{c.push([a,f])}),c}fromJSON(c){this.clear();for(const[f,a]of c)this.set(f,a)}}e.$Cc=S;class D extends S{constructor(c,f=1){super(),this.k=c,this.l=Math.min(Math.max(0,f),1)}get limit(){return this.k}set limit(c){this.k=c,this.m()}get ratio(){return this.l}set ratio(c){this.l=Math.min(Math.max(0,c),1),this.m()}get(c,f=2){return super.get(c,f)}peek(c){return super.get(c,0)}set(c,f){return super.set(c,f,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.$Dc=D;class E{constructor(){this.a=new Map}add(c){return this.a.set(c,(this.a.get(c)||0)+1),this}delete(c){let f=this.a.get(c)||0;return f===0?!1:(f--,f===0?this.a.delete(c):this.a.set(c,f),!0)}has(c){return this.a.has(c)}}e.$Ec=E;class h{constructor(c){if(this.a=new Map,this.b=new Map,c)for(const[f,a]of c)this.set(f,a)}clear(){this.a.clear(),this.b.clear()}set(c,f){this.a.set(c,f),this.b.set(f,c)}get(c){return this.a.get(c)}getKey(c){return this.b.get(c)}delete(c){const f=this.a.get(c);return f===void 0?!1:(this.a.delete(c),this.b.delete(f),!0)}forEach(c,f){this.a.forEach((a,t)=>{c.call(f,a,t,this)})}keys(){return this.a.keys()}values(){return this.a.values()}}e.$Fc=h;class u{constructor(){this.a=new Map}add(c,f){let a=this.a.get(c);a||(a=new Set,this.a.set(c,a)),a.add(f)}delete(c,f){const a=this.a.get(c);a&&(a.delete(f),a.size===0&&this.a.delete(c))}forEach(c,f){const a=this.a.get(c);a&&a.forEach(f)}get(c){const f=this.a.get(c);return f||new Set}}e.$Gc=u}),define(De[3],Ce([1,0,19,74,28,75,51]),function(re,e,y,M,l,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Sc=e.$Rc=e.$Qc=e.$Pc=e.$Oc=e.$Nc=e.$Mc=e.$Lc=e.$Kc=e.$Jc=e.$Ic=e.$Hc=void 0;const g=!1;let k=null;class ${constructor(){this.b=new Map}c(b){let I=this.b.get(b);return I||(I={parent:null,source:null,isSingleton:!1,value:b,idx:$.a++},this.b.set(b,I)),I}trackDisposable(b){const I=this.c(b);I.source||(I.source=new Error().stack)}setParent(b,I){const z=this.c(b);z.parent=I}markAsDisposed(b){this.b.delete(b)}markAsSingleton(b){this.c(b).isSingleton=!0}f(b,I){const z=I.get(b);if(z)return z;const O=b.parent?this.f(this.c(b.parent),I):b;return I.set(b,O),O}getTrackedDisposables(){const b=new Map;return[...this.b.entries()].filter(([,z])=>z.source!==null&&!this.f(z,b).isSingleton).flatMap(([z])=>z)}computeLeakingDisposables(b=10,I){let z;if(I)z=I;else{const j=new Map,U=[...this.b.values()].filter(he=>he.source!==null&&!this.f(he,j).isSingleton);if(U.length===0)return;const B=new Set(U.map(he=>he.value));if(z=U.filter(he=>!(he.parent&&B.has(he.parent))),z.length===0)throw new Error("There are cyclic diposable chains!")}if(!z)return;function O(j){function U(he,x){for(;he.length>0&&x.some(Q=>typeof Q=="string"?Q===he[0]:he[0].match(Q));)he.shift()}const B=j.source.split(`
`).map(he=>he.trim().replace("at ","")).filter(he=>he!=="");return U(B,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),B.reverse()}const F=new l.$Gc;for(const j of z){const U=O(j);for(let B=0;B<=U.length;B++)F.add(U.slice(0,B).join(`
`),j)}z.sort((0,y.$7b)(j=>j.idx,y.$9b));let T="",N=0;for(const j of z.slice(0,b)){N++;const U=O(j),B=[];for(let he=0;he<U.length;he++){let x=U[he];x=`(shared with ${F.get(U.slice(0,he+1).join(`
`)).size}/${z.length} leaks) at ${x}`;const Z=F.get(U.slice(0,he).join(`
`)),ie=(0,M.$D)([...Z].map(_=>O(_)[he]),_=>_);delete ie[U[he]];for(const[_,oe]of Object.entries(ie))B.unshift(`    - stacktraces of ${oe.length} other leaks continue with ${_}`);B.unshift(x)}T+=`


==================== Leaking disposable ${N}/${z.length}: ${j.value.constructor.name} ====================
${B.join(`
`)}
============================================================

`}return z.length>b&&(T+=`


... and ${z.length-b} more leaking disposables

`),{leaks:z,details:T}}}e.$Hc=$,$.a=0;function R(m){k=m}if(e.$Ic=R,g){const m="__is_disposable_tracked__";R(new class{trackDisposable(b){const I=new Error("Potentially leaked disposable").stack;setTimeout(()=>{b[m]||console.log(I)},3e3)}setParent(b,I){if(b&&b!==t.None)try{b[m]=!0}catch{}}markAsDisposed(b){if(b&&b!==t.None)try{b[m]=!0}catch{}}markAsSingleton(b){}})}function P(m){return k?.trackDisposable(m),m}e.$Jc=P;function p(m){k?.markAsDisposed(m)}e.$Kc=p;function S(m,b){k?.setParent(m,b)}function D(m,b){if(k)for(const I of m)k.setParent(I,b)}function E(m){return k?.markAsSingleton(m),m}e.$Lc=E;function h(m){return typeof m.dispose=="function"&&m.dispose.length===0}e.$Mc=h;function u(m){if(A.Iterable.is(m)){const b=[];for(const I of m)if(I)try{I.dispose()}catch(z){b.push(z)}if(b.length===1)throw b[0];if(b.length>1)throw new AggregateError(b,"Encountered errors while disposing of store");return Array.isArray(m)?[]:m}else if(m)return m.dispose(),m}e.$Nc=u;function d(m){for(const b of m)h(b)&&b.dispose();return[]}e.$Oc=d;function c(...m){const b=f(()=>u(m));return D(m,b),b}e.$Pc=c;function f(m){const b=P({dispose:(0,L.$db)(()=>{p(b),m()})});return b}e.$Qc=f;class a{constructor(){this.f=new Set,this.g=!1,P(this)}dispose(){this.g||(p(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{u(this.f)}finally{this.f.clear()}}add(b){if(!b)return b;if(b===this)throw new Error("Cannot register a disposable on itself!");return S(b,this),this.g?a.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(b),b}delete(b){if(b){if(b===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(b),b.dispose()}}deleteAndLeak(b){b&&this.f.has(b)&&(this.f.delete(b),S(b,null))}}e.$Rc=a,a.DISABLE_DISPOSED_WARNING=!1;class t{constructor(){this.q=new a,P(this),S(this.q,this)}dispose(){p(this),this.q.dispose()}B(b){if(b===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(b)}}e.$Sc=t,t.None=Object.freeze({dispose(){}});class i{constructor(){this.b=!1,P(this)}get value(){return this.b?void 0:this.a}set value(b){this.b||b===this.a||(this.a?.dispose(),b&&S(b,this),this.a=b)}clear(){this.value=void 0}dispose(){this.b=!0,p(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const b=this.a;return this.a=void 0,b&&S(b,null),b}}e.$Tc=i;class s{constructor(b){this.b=b,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Uc=s;class n{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,P(this)}set(b){let I=b;return this.unset=()=>I=void 0,this.isset=()=>I!==void 0,this.dispose=()=>{I&&(I(),I=void 0,p(this))},this}}e.$Vc=n;class r{constructor(){this.a=new Map}acquire(b,...I){let z=this.a.get(b);z||(z={counter:0,object:this.b(b,...I)},this.a.set(b,z));const{object:O}=z,F=(0,L.$db)(()=>{--z.counter===0&&(this.c(b,z.object),this.a.delete(b))});return z.counter++,{object:O,dispose:F}}}e.$Wc=r;class o{constructor(b){this.a=b}async acquire(b,...I){const z=this.a.acquire(b,...I);try{return{object:await z.object,dispose:()=>z.dispose()}}catch(O){throw z.dispose(),O}}}e.$Xc=o;class v{constructor(b){this.object=b}dispose(){}}e.$Yc=v;function C(m){const b=new a;try{m(b)}finally{b.dispose()}}e.$Zc=C;class w{constructor(){this.a=new Map,this.b=!1,P(this)}dispose(){p(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{u(this.a.values())}finally{this.a.clear()}}has(b){return this.a.has(b)}get size(){return this.a.size}get(b){return this.a.get(b)}set(b,I,z=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),z||this.a.get(b)?.dispose(),this.a.set(b,I)}deleteAndDispose(b){this.a.get(b)?.dispose(),this.a.delete(b)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$1c=w}),function(re,e){typeof define=="function"&&define.amd?define(De[159],Ce([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(re=typeof globalThis<"u"?globalThis:re||self,e(re.marked={}))}(this,function(re){"use strict";function e(Y,X){for(var be=0;be<X.length;be++){var se=X[be];se.enumerable=se.enumerable||!1,se.configurable=!0,"value"in se&&(se.writable=!0),Object.defineProperty(Y,se.key,se)}}function y(Y,X,be){return X&&e(Y.prototype,X),be&&e(Y,be),Object.defineProperty(Y,"prototype",{writable:!1}),Y}function M(Y,X){if(Y){if(typeof Y=="string")return l(Y,X);var be=Object.prototype.toString.call(Y).slice(8,-1);if(be==="Object"&&Y.constructor&&(be=Y.constructor.name),be==="Map"||be==="Set")return Array.from(Y);if(be==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(be))return l(Y,X)}}function l(Y,X){(X==null||X>Y.length)&&(X=Y.length);for(var be=0,se=new Array(X);be<X;be++)se[be]=Y[be];return se}function L(Y,X){var be=typeof Symbol<"u"&&Y[Symbol.iterator]||Y["@@iterator"];if(be)return(be=be.call(Y)).next.bind(be);if(Array.isArray(Y)||(be=M(Y))||X&&Y&&typeof Y.length=="number"){be&&(Y=be);var se=0;return function(){return se>=Y.length?{done:!0}:{done:!1,value:Y[se++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function A(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}re.defaults=A();function g(Y){re.defaults=Y}var k=/[&<>"']/,$=/[&<>"']/g,R=/[<>"']|&(?!#?\w+;)/,P=/[<>"']|&(?!#?\w+;)/g,p={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},S=function(X){return p[X]};function D(Y,X){if(X){if(k.test(Y))return Y.replace($,S)}else if(R.test(Y))return Y.replace(P,S);return Y}var E=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function h(Y){return Y.replace(E,function(X,be){return be=be.toLowerCase(),be==="colon"?":":be.charAt(0)==="#"?be.charAt(1)==="x"?String.fromCharCode(parseInt(be.substring(2),16)):String.fromCharCode(+be.substring(1)):""})}var u=/(^|[^\[])\^/g;function d(Y,X){Y=typeof Y=="string"?Y:Y.source,X=X||"";var be={replace:function(ge,te){return te=te.source||te,te=te.replace(u,"$1"),Y=Y.replace(ge,te),be},getRegex:function(){return new RegExp(Y,X)}};return be}var c=/[^\w:]/g,f=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function a(Y,X,be){if(Y){var se;try{se=decodeURIComponent(h(be)).replace(c,"").toLowerCase()}catch{return null}if(se.indexOf("javascript:")===0||se.indexOf("vbscript:")===0||se.indexOf("data:")===0)return null}X&&!f.test(be)&&(be=r(X,be));try{be=encodeURI(be).replace(/%25/g,"%")}catch{return null}return be}var t={},i=/^[^:]+:\/*[^/]*$/,s=/^([^:]+:)[\s\S]*$/,n=/^([^:]+:\/*[^/]*)[\s\S]*$/;function r(Y,X){t[" "+Y]||(i.test(Y)?t[" "+Y]=Y+"/":t[" "+Y]=w(Y,"/",!0)),Y=t[" "+Y];var be=Y.indexOf(":")===-1;return X.substring(0,2)==="//"?be?X:Y.replace(s,"$1")+X:X.charAt(0)==="/"?be?X:Y.replace(n,"$1")+X:Y+X}var o={exec:function(){}};function v(Y){for(var X=1,be,se;X<arguments.length;X++){be=arguments[X];for(se in be)Object.prototype.hasOwnProperty.call(be,se)&&(Y[se]=be[se])}return Y}function C(Y,X){var be=Y.replace(/\|/g,function(te,me,we){for(var Ie=!1,W=me;--W>=0&&we[W]==="\\";)Ie=!Ie;return Ie?"|":" |"}),se=be.split(/ \|/),ge=0;if(se[0].trim()||se.shift(),se.length>0&&!se[se.length-1].trim()&&se.pop(),se.length>X)se.splice(X);else for(;se.length<X;)se.push("");for(;ge<se.length;ge++)se[ge]=se[ge].trim().replace(/\\\|/g,"|");return se}function w(Y,X,be){var se=Y.length;if(se===0)return"";for(var ge=0;ge<se;){var te=Y.charAt(se-ge-1);if(te===X&&!be)ge++;else if(te!==X&&be)ge++;else break}return Y.slice(0,se-ge)}function m(Y,X){if(Y.indexOf(X[1])===-1)return-1;for(var be=Y.length,se=0,ge=0;ge<be;ge++)if(Y[ge]==="\\")ge++;else if(Y[ge]===X[0])se++;else if(Y[ge]===X[1]&&(se--,se<0))return ge;return-1}function b(Y){Y&&Y.sanitize&&!Y.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function I(Y,X){if(X<1)return"";for(var be="";X>1;)X&1&&(be+=Y),X>>=1,Y+=Y;return be+Y}function z(Y,X,be,se){var ge=X.href,te=X.title?D(X.title):null,me=Y[1].replace(/\\([\[\]])/g,"$1");if(Y[0].charAt(0)!=="!"){se.state.inLink=!0;var we={type:"link",raw:be,href:ge,title:te,text:me,tokens:se.inlineTokens(me)};return se.state.inLink=!1,we}return{type:"image",raw:be,href:ge,title:te,text:D(me)}}function O(Y,X){var be=Y.match(/^(\s+)(?:```)/);if(be===null)return X;var se=be[1];return X.split(`
`).map(function(ge){var te=ge.match(/^\s+/);if(te===null)return ge;var me=te[0];return me.length>=se.length?ge.slice(se.length):ge}).join(`
`)}var F=function(){function Y(be){this.options=be||re.defaults}var X=Y.prototype;return X.space=function(se){var ge=this.rules.block.newline.exec(se);if(ge&&ge[0].length>0)return{type:"space",raw:ge[0]}},X.code=function(se){var ge=this.rules.block.code.exec(se);if(ge){var te=ge[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ge[0],codeBlockStyle:"indented",text:this.options.pedantic?te:w(te,`
`)}}},X.fences=function(se){var ge=this.rules.block.fences.exec(se);if(ge){var te=ge[0],me=O(te,ge[3]||"");return{type:"code",raw:te,lang:ge[2]?ge[2].trim():ge[2],text:me}}},X.heading=function(se){var ge=this.rules.block.heading.exec(se);if(ge){var te=ge[2].trim();if(/#$/.test(te)){var me=w(te,"#");(this.options.pedantic||!me||/ $/.test(me))&&(te=me.trim())}return{type:"heading",raw:ge[0],depth:ge[1].length,text:te,tokens:this.lexer.inline(te)}}},X.hr=function(se){var ge=this.rules.block.hr.exec(se);if(ge)return{type:"hr",raw:ge[0]}},X.blockquote=function(se){var ge=this.rules.block.blockquote.exec(se);if(ge){var te=ge[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:ge[0],tokens:this.lexer.blockTokens(te,[]),text:te}}},X.list=function(se){var ge=this.rules.block.list.exec(se);if(ge){var te,me,we,Ie,W,J,ce,de,ee,$e,ve,Ne,qe=ge[1].trim(),xe=qe.length>1,Ge={type:"list",raw:"",ordered:xe,start:xe?+qe.slice(0,-1):"",loose:!1,items:[]};qe=xe?"\\d{1,9}\\"+qe.slice(-1):"\\"+qe,this.options.pedantic&&(qe=xe?qe:"[*+-]");for(var st=new RegExp("^( {0,3}"+qe+")((?:[	 ][^\\n]*)?(?:\\n|$))");se&&(Ne=!1,!(!(ge=st.exec(se))||this.rules.block.hr.test(se)));){if(te=ge[0],se=se.substring(te.length),de=ge[2].split(`
`,1)[0],ee=se.split(`
`,1)[0],this.options.pedantic?(Ie=2,ve=de.trimLeft()):(Ie=ge[2].search(/[^ ]/),Ie=Ie>4?1:Ie,ve=de.slice(Ie),Ie+=ge[1].length),J=!1,!de&&/^ *$/.test(ee)&&(te+=ee+`
`,se=se.substring(ee.length+1),Ne=!0),!Ne)for(var it=new RegExp("^ {0,"+Math.min(3,Ie-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),nt=new RegExp("^ {0,"+Math.min(3,Ie-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),Ae=new RegExp("^ {0,"+Math.min(3,Ie-1)+"}(?:```|~~~)"),Oe=new RegExp("^ {0,"+Math.min(3,Ie-1)+"}#");se&&($e=se.split(`
`,1)[0],de=$e,this.options.pedantic&&(de=de.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(Ae.test(de)||Oe.test(de)||it.test(de)||nt.test(se)));){if(de.search(/[^ ]/)>=Ie||!de.trim())ve+=`
`+de.slice(Ie);else if(!J)ve+=`
`+de;else break;!J&&!de.trim()&&(J=!0),te+=$e+`
`,se=se.substring($e.length+1)}Ge.loose||(ce?Ge.loose=!0:/\n *\n *$/.test(te)&&(ce=!0)),this.options.gfm&&(me=/^\[[ xX]\] /.exec(ve),me&&(we=me[0]!=="[ ] ",ve=ve.replace(/^\[[ xX]\] +/,""))),Ge.items.push({type:"list_item",raw:te,task:!!me,checked:we,loose:!1,text:ve}),Ge.raw+=te}Ge.items[Ge.items.length-1].raw=te.trimRight(),Ge.items[Ge.items.length-1].text=ve.trimRight(),Ge.raw=Ge.raw.trimRight();var Re=Ge.items.length;for(W=0;W<Re;W++){this.lexer.state.top=!1,Ge.items[W].tokens=this.lexer.blockTokens(Ge.items[W].text,[]);var Qe=Ge.items[W].tokens.filter(function(ae){return ae.type==="space"}),ue=Qe.every(function(ae){for(var Pe=ae.raw.split(""),Ke=0,Ue=L(Pe),Ze;!(Ze=Ue()).done;){var rt=Ze.value;if(rt===`
`&&(Ke+=1),Ke>1)return!0}return!1});!Ge.loose&&Qe.length&&ue&&(Ge.loose=!0,Ge.items[W].loose=!0)}return Ge}},X.html=function(se){var ge=this.rules.block.html.exec(se);if(ge){var te={type:"html",raw:ge[0],pre:!this.options.sanitizer&&(ge[1]==="pre"||ge[1]==="script"||ge[1]==="style"),text:ge[0]};if(this.options.sanitize){var me=this.options.sanitizer?this.options.sanitizer(ge[0]):D(ge[0]);te.type="paragraph",te.text=me,te.tokens=this.lexer.inline(me)}return te}},X.def=function(se){var ge=this.rules.block.def.exec(se);if(ge){ge[3]&&(ge[3]=ge[3].substring(1,ge[3].length-1));var te=ge[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:te,raw:ge[0],href:ge[2],title:ge[3]}}},X.table=function(se){var ge=this.rules.block.table.exec(se);if(ge){var te={type:"table",header:C(ge[1]).map(function(ce){return{text:ce}}),align:ge[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ge[3]&&ge[3].trim()?ge[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(te.header.length===te.align.length){te.raw=ge[0];var me=te.align.length,we,Ie,W,J;for(we=0;we<me;we++)/^ *-+: *$/.test(te.align[we])?te.align[we]="right":/^ *:-+: *$/.test(te.align[we])?te.align[we]="center":/^ *:-+ *$/.test(te.align[we])?te.align[we]="left":te.align[we]=null;for(me=te.rows.length,we=0;we<me;we++)te.rows[we]=C(te.rows[we],te.header.length).map(function(ce){return{text:ce}});for(me=te.header.length,Ie=0;Ie<me;Ie++)te.header[Ie].tokens=this.lexer.inline(te.header[Ie].text);for(me=te.rows.length,Ie=0;Ie<me;Ie++)for(J=te.rows[Ie],W=0;W<J.length;W++)J[W].tokens=this.lexer.inline(J[W].text);return te}}},X.lheading=function(se){var ge=this.rules.block.lheading.exec(se);if(ge)return{type:"heading",raw:ge[0],depth:ge[2].charAt(0)==="="?1:2,text:ge[1],tokens:this.lexer.inline(ge[1])}},X.paragraph=function(se){var ge=this.rules.block.paragraph.exec(se);if(ge){var te=ge[1].charAt(ge[1].length-1)===`
`?ge[1].slice(0,-1):ge[1];return{type:"paragraph",raw:ge[0],text:te,tokens:this.lexer.inline(te)}}},X.text=function(se){var ge=this.rules.block.text.exec(se);if(ge)return{type:"text",raw:ge[0],text:ge[0],tokens:this.lexer.inline(ge[0])}},X.escape=function(se){var ge=this.rules.inline.escape.exec(se);if(ge)return{type:"escape",raw:ge[0],text:D(ge[1])}},X.tag=function(se){var ge=this.rules.inline.tag.exec(se);if(ge)return!this.lexer.state.inLink&&/^<a /i.test(ge[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ge[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ge[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ge[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ge[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ge[0]):D(ge[0]):ge[0]}},X.link=function(se){var ge=this.rules.inline.link.exec(se);if(ge){var te=ge[2].trim();if(!this.options.pedantic&&/^</.test(te)){if(!/>$/.test(te))return;var me=w(te.slice(0,-1),"\\");if((te.length-me.length)%2===0)return}else{var we=m(ge[2],"()");if(we>-1){var Ie=ge[0].indexOf("!")===0?5:4,W=Ie+ge[1].length+we;ge[2]=ge[2].substring(0,we),ge[0]=ge[0].substring(0,W).trim(),ge[3]=""}}var J=ge[2],ce="";if(this.options.pedantic){var de=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(J);de&&(J=de[1],ce=de[3])}else ce=ge[3]?ge[3].slice(1,-1):"";return J=J.trim(),/^</.test(J)&&(this.options.pedantic&&!/>$/.test(te)?J=J.slice(1):J=J.slice(1,-1)),z(ge,{href:J&&J.replace(this.rules.inline._escapes,"$1"),title:ce&&ce.replace(this.rules.inline._escapes,"$1")},ge[0],this.lexer)}},X.reflink=function(se,ge){var te;if((te=this.rules.inline.reflink.exec(se))||(te=this.rules.inline.nolink.exec(se))){var me=(te[2]||te[1]).replace(/\s+/g," ");if(me=ge[me.toLowerCase()],!me||!me.href){var we=te[0].charAt(0);return{type:"text",raw:we,text:we}}return z(te,me,te[0],this.lexer)}},X.emStrong=function(se,ge,te){te===void 0&&(te="");var me=this.rules.inline.emStrong.lDelim.exec(se);if(me&&!(me[3]&&te.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var we=me[1]||me[2]||"";if(!we||we&&(te===""||this.rules.inline.punctuation.exec(te))){var Ie=me[0].length-1,W,J,ce=Ie,de=0,ee=me[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(ee.lastIndex=0,ge=ge.slice(-1*se.length+Ie);(me=ee.exec(ge))!=null;)if(W=me[1]||me[2]||me[3]||me[4]||me[5]||me[6],!!W){if(J=W.length,me[3]||me[4]){ce+=J;continue}else if((me[5]||me[6])&&Ie%3&&!((Ie+J)%3)){de+=J;continue}if(ce-=J,!(ce>0)){if(J=Math.min(J,J+ce+de),Math.min(Ie,J)%2){var $e=se.slice(1,Ie+me.index+J);return{type:"em",raw:se.slice(0,Ie+me.index+J+1),text:$e,tokens:this.lexer.inlineTokens($e)}}var ve=se.slice(2,Ie+me.index+J-1);return{type:"strong",raw:se.slice(0,Ie+me.index+J+1),text:ve,tokens:this.lexer.inlineTokens(ve)}}}}}},X.codespan=function(se){var ge=this.rules.inline.code.exec(se);if(ge){var te=ge[2].replace(/\n/g," "),me=/[^ ]/.test(te),we=/^ /.test(te)&&/ $/.test(te);return me&&we&&(te=te.substring(1,te.length-1)),te=D(te,!0),{type:"codespan",raw:ge[0],text:te}}},X.br=function(se){var ge=this.rules.inline.br.exec(se);if(ge)return{type:"br",raw:ge[0]}},X.del=function(se){var ge=this.rules.inline.del.exec(se);if(ge)return{type:"del",raw:ge[0],text:ge[2],tokens:this.lexer.inlineTokens(ge[2])}},X.autolink=function(se,ge){var te=this.rules.inline.autolink.exec(se);if(te){var me,we;return te[2]==="@"?(me=D(this.options.mangle?ge(te[1]):te[1]),we="mailto:"+me):(me=D(te[1]),we=me),{type:"link",raw:te[0],text:me,href:we,tokens:[{type:"text",raw:me,text:me}]}}},X.url=function(se,ge){var te;if(te=this.rules.inline.url.exec(se)){var me,we;if(te[2]==="@")me=D(this.options.mangle?ge(te[0]):te[0]),we="mailto:"+me;else{var Ie;do Ie=te[0],te[0]=this.rules.inline._backpedal.exec(te[0])[0];while(Ie!==te[0]);me=D(te[0]),te[1]==="www."?we="http://"+me:we=me}return{type:"link",raw:te[0],text:me,href:we,tokens:[{type:"text",raw:me,text:me}]}}},X.inlineText=function(se,ge){var te=this.rules.inline.text.exec(se);if(te){var me;return this.lexer.state.inRawBlock?me=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(te[0]):D(te[0]):te[0]:me=D(this.options.smartypants?ge(te[0]):te[0]),{type:"text",raw:te[0],text:me}}},Y}(),T={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:o,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};T._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,T._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,T.def=d(T.def).replace("label",T._label).replace("title",T._title).getRegex(),T.bullet=/(?:[*+-]|\d{1,9}[.)])/,T.listItemStart=d(/^( *)(bull) */).replace("bull",T.bullet).getRegex(),T.list=d(T.list).replace(/bull/g,T.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+T.def.source+")").getRegex(),T._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",T._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,T.html=d(T.html,"i").replace("comment",T._comment).replace("tag",T._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),T.paragraph=d(T._paragraph).replace("hr",T.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",T._tag).getRegex(),T.blockquote=d(T.blockquote).replace("paragraph",T.paragraph).getRegex(),T.normal=v({},T),T.gfm=v({},T.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),T.gfm.table=d(T.gfm.table).replace("hr",T.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",T._tag).getRegex(),T.gfm.paragraph=d(T._paragraph).replace("hr",T.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",T.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",T._tag).getRegex(),T.pedantic=v({},T.normal,{html:d(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",T._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:o,paragraph:d(T.normal._paragraph).replace("hr",T.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",T.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var N={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:o,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:o,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};N._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",N.punctuation=d(N.punctuation).replace(/punctuation/g,N._punctuation).getRegex(),N.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,N.escapedEmSt=/\\\*|\\_/g,N._comment=d(T._comment).replace("(?:-->|$)","-->").getRegex(),N.emStrong.lDelim=d(N.emStrong.lDelim).replace(/punct/g,N._punctuation).getRegex(),N.emStrong.rDelimAst=d(N.emStrong.rDelimAst,"g").replace(/punct/g,N._punctuation).getRegex(),N.emStrong.rDelimUnd=d(N.emStrong.rDelimUnd,"g").replace(/punct/g,N._punctuation).getRegex(),N._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,N._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,N._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,N.autolink=d(N.autolink).replace("scheme",N._scheme).replace("email",N._email).getRegex(),N._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,N.tag=d(N.tag).replace("comment",N._comment).replace("attribute",N._attribute).getRegex(),N._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,N._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,N._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,N.link=d(N.link).replace("label",N._label).replace("href",N._href).replace("title",N._title).getRegex(),N.reflink=d(N.reflink).replace("label",N._label).replace("ref",T._label).getRegex(),N.nolink=d(N.nolink).replace("ref",T._label).getRegex(),N.reflinkSearch=d(N.reflinkSearch,"g").replace("reflink",N.reflink).replace("nolink",N.nolink).getRegex(),N.normal=v({},N),N.pedantic=v({},N.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:d(/^!?\[(label)\]\((.*?)\)/).replace("label",N._label).getRegex(),reflink:d(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",N._label).getRegex()}),N.gfm=v({},N.normal,{escape:d(N.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),N.gfm.url=d(N.gfm.url,"i").replace("email",N.gfm._extended_email).getRegex(),N.breaks=v({},N.gfm,{br:d(N.br).replace("{2,}","*").getRegex(),text:d(N.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function j(Y){return Y.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function U(Y){var X="",be,se,ge=Y.length;for(be=0;be<ge;be++)se=Y.charCodeAt(be),Math.random()>.5&&(se="x"+se.toString(16)),X+="&#"+se+";";return X}var B=function(){function Y(be){this.tokens=[],this.tokens.links=Object.create(null),this.options=be||re.defaults,this.options.tokenizer=this.options.tokenizer||new F,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var se={block:T.normal,inline:N.normal};this.options.pedantic?(se.block=T.pedantic,se.inline=N.pedantic):this.options.gfm&&(se.block=T.gfm,this.options.breaks?se.inline=N.breaks:se.inline=N.gfm),this.tokenizer.rules=se}Y.lex=function(se,ge){var te=new Y(ge);return te.lex(se)},Y.lexInline=function(se,ge){var te=new Y(ge);return te.inlineTokens(se)};var X=Y.prototype;return X.lex=function(se){se=se.replace(/\r\n|\r/g,`
`),this.blockTokens(se,this.tokens);for(var ge;ge=this.inlineQueue.shift();)this.inlineTokens(ge.src,ge.tokens);return this.tokens},X.blockTokens=function(se,ge){var te=this;ge===void 0&&(ge=[]),this.options.pedantic?se=se.replace(/\t/g,"    ").replace(/^ +$/gm,""):se=se.replace(/^( *)(\t+)/gm,function(ce,de,ee){return de+"    ".repeat(ee.length)});for(var me,we,Ie,W;se;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(ce){return(me=ce.call({lexer:te},se,ge))?(se=se.substring(me.raw.length),ge.push(me),!0):!1}))){if(me=this.tokenizer.space(se)){se=se.substring(me.raw.length),me.raw.length===1&&ge.length>0?ge[ge.length-1].raw+=`
`:ge.push(me);continue}if(me=this.tokenizer.code(se)){se=se.substring(me.raw.length),we=ge[ge.length-1],we&&(we.type==="paragraph"||we.type==="text")?(we.raw+=`
`+me.raw,we.text+=`
`+me.text,this.inlineQueue[this.inlineQueue.length-1].src=we.text):ge.push(me);continue}if(me=this.tokenizer.fences(se)){se=se.substring(me.raw.length),ge.push(me);continue}if(me=this.tokenizer.heading(se)){se=se.substring(me.raw.length),ge.push(me);continue}if(me=this.tokenizer.hr(se)){se=se.substring(me.raw.length),ge.push(me);continue}if(me=this.tokenizer.blockquote(se)){se=se.substring(me.raw.length),ge.push(me);continue}if(me=this.tokenizer.list(se)){se=se.substring(me.raw.length),ge.push(me);continue}if(me=this.tokenizer.html(se)){se=se.substring(me.raw.length),ge.push(me);continue}if(me=this.tokenizer.def(se)){se=se.substring(me.raw.length),we=ge[ge.length-1],we&&(we.type==="paragraph"||we.type==="text")?(we.raw+=`
`+me.raw,we.text+=`
`+me.raw,this.inlineQueue[this.inlineQueue.length-1].src=we.text):this.tokens.links[me.tag]||(this.tokens.links[me.tag]={href:me.href,title:me.title});continue}if(me=this.tokenizer.table(se)){se=se.substring(me.raw.length),ge.push(me);continue}if(me=this.tokenizer.lheading(se)){se=se.substring(me.raw.length),ge.push(me);continue}if(Ie=se,this.options.extensions&&this.options.extensions.startBlock&&function(){var ce=1/0,de=se.slice(1),ee=void 0;te.options.extensions.startBlock.forEach(function($e){ee=$e.call({lexer:this},de),typeof ee=="number"&&ee>=0&&(ce=Math.min(ce,ee))}),ce<1/0&&ce>=0&&(Ie=se.substring(0,ce+1))}(),this.state.top&&(me=this.tokenizer.paragraph(Ie))){we=ge[ge.length-1],W&&we.type==="paragraph"?(we.raw+=`
`+me.raw,we.text+=`
`+me.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=we.text):ge.push(me),W=Ie.length!==se.length,se=se.substring(me.raw.length);continue}if(me=this.tokenizer.text(se)){se=se.substring(me.raw.length),we=ge[ge.length-1],we&&we.type==="text"?(we.raw+=`
`+me.raw,we.text+=`
`+me.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=we.text):ge.push(me);continue}if(se){var J="Infinite loop on byte: "+se.charCodeAt(0);if(this.options.silent){console.error(J);break}else throw new Error(J)}}return this.state.top=!0,ge},X.inline=function(se,ge){return ge===void 0&&(ge=[]),this.inlineQueue.push({src:se,tokens:ge}),ge},X.inlineTokens=function(se,ge){var te=this;ge===void 0&&(ge=[]);var me,we,Ie,W=se,J,ce,de;if(this.tokens.links){var ee=Object.keys(this.tokens.links);if(ee.length>0)for(;(J=this.tokenizer.rules.inline.reflinkSearch.exec(W))!=null;)ee.includes(J[0].slice(J[0].lastIndexOf("[")+1,-1))&&(W=W.slice(0,J.index)+"["+I("a",J[0].length-2)+"]"+W.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(J=this.tokenizer.rules.inline.blockSkip.exec(W))!=null;)W=W.slice(0,J.index)+"["+I("a",J[0].length-2)+"]"+W.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(J=this.tokenizer.rules.inline.escapedEmSt.exec(W))!=null;)W=W.slice(0,J.index)+"++"+W.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;se;)if(ce||(de=""),ce=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ve){return(me=ve.call({lexer:te},se,ge))?(se=se.substring(me.raw.length),ge.push(me),!0):!1}))){if(me=this.tokenizer.escape(se)){se=se.substring(me.raw.length),ge.push(me);continue}if(me=this.tokenizer.tag(se)){se=se.substring(me.raw.length),we=ge[ge.length-1],we&&me.type==="text"&&we.type==="text"?(we.raw+=me.raw,we.text+=me.text):ge.push(me);continue}if(me=this.tokenizer.link(se)){se=se.substring(me.raw.length),ge.push(me);continue}if(me=this.tokenizer.reflink(se,this.tokens.links)){se=se.substring(me.raw.length),we=ge[ge.length-1],we&&me.type==="text"&&we.type==="text"?(we.raw+=me.raw,we.text+=me.text):ge.push(me);continue}if(me=this.tokenizer.emStrong(se,W,de)){se=se.substring(me.raw.length),ge.push(me);continue}if(me=this.tokenizer.codespan(se)){se=se.substring(me.raw.length),ge.push(me);continue}if(me=this.tokenizer.br(se)){se=se.substring(me.raw.length),ge.push(me);continue}if(me=this.tokenizer.del(se)){se=se.substring(me.raw.length),ge.push(me);continue}if(me=this.tokenizer.autolink(se,U)){se=se.substring(me.raw.length),ge.push(me);continue}if(!this.state.inLink&&(me=this.tokenizer.url(se,U))){se=se.substring(me.raw.length),ge.push(me);continue}if(Ie=se,this.options.extensions&&this.options.extensions.startInline&&function(){var ve=1/0,Ne=se.slice(1),qe=void 0;te.options.extensions.startInline.forEach(function(xe){qe=xe.call({lexer:this},Ne),typeof qe=="number"&&qe>=0&&(ve=Math.min(ve,qe))}),ve<1/0&&ve>=0&&(Ie=se.substring(0,ve+1))}(),me=this.tokenizer.inlineText(Ie,j)){se=se.substring(me.raw.length),me.raw.slice(-1)!=="_"&&(de=me.raw.slice(-1)),ce=!0,we=ge[ge.length-1],we&&we.type==="text"?(we.raw+=me.raw,we.text+=me.text):ge.push(me);continue}if(se){var $e="Infinite loop on byte: "+se.charCodeAt(0);if(this.options.silent){console.error($e);break}else throw new Error($e)}}return ge},y(Y,null,[{key:"rules",get:function(){return{block:T,inline:N}}}]),Y}(),he=function(){function Y(be){this.options=be||re.defaults}var X=Y.prototype;return X.code=function(se,ge,te){var me=(ge||"").match(/\S*/)[0];if(this.options.highlight){var we=this.options.highlight(se,me);we!=null&&we!==se&&(te=!0,se=we)}return se=se.replace(/\n$/,"")+`
`,me?'<pre><code class="'+this.options.langPrefix+D(me,!0)+'">'+(te?se:D(se,!0))+`</code></pre>
`:"<pre><code>"+(te?se:D(se,!0))+`</code></pre>
`},X.blockquote=function(se){return`<blockquote>
`+se+`</blockquote>
`},X.html=function(se){return se},X.heading=function(se,ge,te,me){if(this.options.headerIds){var we=this.options.headerPrefix+me.slug(te);return"<h"+ge+' id="'+we+'">'+se+"</h"+ge+`>
`}return"<h"+ge+">"+se+"</h"+ge+`>
`},X.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},X.list=function(se,ge,te){var me=ge?"ol":"ul",we=ge&&te!==1?' start="'+te+'"':"";return"<"+me+we+`>
`+se+"</"+me+`>
`},X.listitem=function(se){return"<li>"+se+`</li>
`},X.checkbox=function(se){return"<input "+(se?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},X.paragraph=function(se){return"<p>"+se+`</p>
`},X.table=function(se,ge){return ge&&(ge="<tbody>"+ge+"</tbody>"),`<table>
<thead>
`+se+`</thead>
`+ge+`</table>
`},X.tablerow=function(se){return`<tr>
`+se+`</tr>
`},X.tablecell=function(se,ge){var te=ge.header?"th":"td",me=ge.align?"<"+te+' align="'+ge.align+'">':"<"+te+">";return me+se+("</"+te+`>
`)},X.strong=function(se){return"<strong>"+se+"</strong>"},X.em=function(se){return"<em>"+se+"</em>"},X.codespan=function(se){return"<code>"+se+"</code>"},X.br=function(){return this.options.xhtml?"<br/>":"<br>"},X.del=function(se){return"<del>"+se+"</del>"},X.link=function(se,ge,te){if(se=a(this.options.sanitize,this.options.baseUrl,se),se===null)return te;var me='<a href="'+D(se)+'"';return ge&&(me+=' title="'+ge+'"'),me+=">"+te+"</a>",me},X.image=function(se,ge,te){if(se=a(this.options.sanitize,this.options.baseUrl,se),se===null)return te;var me='<img src="'+se+'" alt="'+te+'"';return ge&&(me+=' title="'+ge+'"'),me+=this.options.xhtml?"/>":">",me},X.text=function(se){return se},Y}(),x=function(){function Y(){}var X=Y.prototype;return X.strong=function(se){return se},X.em=function(se){return se},X.codespan=function(se){return se},X.del=function(se){return se},X.html=function(se){return se},X.text=function(se){return se},X.link=function(se,ge,te){return""+te},X.image=function(se,ge,te){return""+te},X.br=function(){return""},Y}(),Q=function(){function Y(){this.seen={}}var X=Y.prototype;return X.serialize=function(se){return se.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},X.getNextSafeSlug=function(se,ge){var te=se,me=0;if(this.seen.hasOwnProperty(te)){me=this.seen[se];do me++,te=se+"-"+me;while(this.seen.hasOwnProperty(te))}return ge||(this.seen[se]=me,this.seen[te]=0),te},X.slug=function(se,ge){ge===void 0&&(ge={});var te=this.serialize(se);return this.getNextSafeSlug(te,ge.dryrun)},Y}(),Z=function(){function Y(be){this.options=be||re.defaults,this.options.renderer=this.options.renderer||new he,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new x,this.slugger=new Q}Y.parse=function(se,ge){var te=new Y(ge);return te.parse(se)},Y.parseInline=function(se,ge){var te=new Y(ge);return te.parseInline(se)};var X=Y.prototype;return X.parse=function(se,ge){ge===void 0&&(ge=!0);var te="",me,we,Ie,W,J,ce,de,ee,$e,ve,Ne,qe,xe,Ge,st,it,nt,Ae,Oe,Re=se.length;for(me=0;me<Re;me++){if(ve=se[me],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ve.type]&&(Oe=this.options.extensions.renderers[ve.type].call({parser:this},ve),Oe!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ve.type))){te+=Oe||"";continue}switch(ve.type){case"space":continue;case"hr":{te+=this.renderer.hr();continue}case"heading":{te+=this.renderer.heading(this.parseInline(ve.tokens),ve.depth,h(this.parseInline(ve.tokens,this.textRenderer)),this.slugger);continue}case"code":{te+=this.renderer.code(ve.text,ve.lang,ve.escaped);continue}case"table":{for(ee="",de="",W=ve.header.length,we=0;we<W;we++)de+=this.renderer.tablecell(this.parseInline(ve.header[we].tokens),{header:!0,align:ve.align[we]});for(ee+=this.renderer.tablerow(de),$e="",W=ve.rows.length,we=0;we<W;we++){for(ce=ve.rows[we],de="",J=ce.length,Ie=0;Ie<J;Ie++)de+=this.renderer.tablecell(this.parseInline(ce[Ie].tokens),{header:!1,align:ve.align[Ie]});$e+=this.renderer.tablerow(de)}te+=this.renderer.table(ee,$e);continue}case"blockquote":{$e=this.parse(ve.tokens),te+=this.renderer.blockquote($e);continue}case"list":{for(Ne=ve.ordered,qe=ve.start,xe=ve.loose,W=ve.items.length,$e="",we=0;we<W;we++)st=ve.items[we],it=st.checked,nt=st.task,Ge="",st.task&&(Ae=this.renderer.checkbox(it),xe?st.tokens.length>0&&st.tokens[0].type==="paragraph"?(st.tokens[0].text=Ae+" "+st.tokens[0].text,st.tokens[0].tokens&&st.tokens[0].tokens.length>0&&st.tokens[0].tokens[0].type==="text"&&(st.tokens[0].tokens[0].text=Ae+" "+st.tokens[0].tokens[0].text)):st.tokens.unshift({type:"text",text:Ae}):Ge+=Ae),Ge+=this.parse(st.tokens,xe),$e+=this.renderer.listitem(Ge,nt,it);te+=this.renderer.list($e,Ne,qe);continue}case"html":{te+=this.renderer.html(ve.text);continue}case"paragraph":{te+=this.renderer.paragraph(this.parseInline(ve.tokens));continue}case"text":{for($e=ve.tokens?this.parseInline(ve.tokens):ve.text;me+1<Re&&se[me+1].type==="text";)ve=se[++me],$e+=`
`+(ve.tokens?this.parseInline(ve.tokens):ve.text);te+=ge?this.renderer.paragraph($e):$e;continue}default:{var Qe='Token with "'+ve.type+'" type was not found.';if(this.options.silent){console.error(Qe);return}else throw new Error(Qe)}}}return te},X.parseInline=function(se,ge){ge=ge||this.renderer;var te="",me,we,Ie,W=se.length;for(me=0;me<W;me++){if(we=se[me],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[we.type]&&(Ie=this.options.extensions.renderers[we.type].call({parser:this},we),Ie!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(we.type))){te+=Ie||"";continue}switch(we.type){case"escape":{te+=ge.text(we.text);break}case"html":{te+=ge.html(we.text);break}case"link":{te+=ge.link(we.href,we.title,this.parseInline(we.tokens,ge));break}case"image":{te+=ge.image(we.href,we.title,we.text);break}case"strong":{te+=ge.strong(this.parseInline(we.tokens,ge));break}case"em":{te+=ge.em(this.parseInline(we.tokens,ge));break}case"codespan":{te+=ge.codespan(we.text);break}case"br":{te+=ge.br();break}case"del":{te+=ge.del(this.parseInline(we.tokens,ge));break}case"text":{te+=ge.text(we.text);break}default:{var J='Token with "'+we.type+'" type was not found.';if(this.options.silent){console.error(J);return}else throw new Error(J)}}}return te},Y}();function ie(Y,X,be){if(typeof Y>"u"||Y===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Y!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Y)+", string expected");if(typeof X=="function"&&(be=X,X=null),X=v({},ie.defaults,X||{}),b(X),be){var se=X.highlight,ge;try{ge=B.lex(Y,X)}catch(W){return be(W)}var te=function(J){var ce;if(!J)try{X.walkTokens&&ie.walkTokens(ge,X.walkTokens),ce=Z.parse(ge,X)}catch(de){J=de}return X.highlight=se,J?be(J):be(null,ce)};if(!se||se.length<3||(delete X.highlight,!ge.length))return te();var me=0;ie.walkTokens(ge,function(W){W.type==="code"&&(me++,setTimeout(function(){se(W.text,W.lang,function(J,ce){if(J)return te(J);ce!=null&&ce!==W.text&&(W.text=ce,W.escaped=!0),me--,me===0&&te()})},0))}),me===0&&te();return}function we(W){if(W.message+=`
Please report this to https://github.com/markedjs/marked.`,X.silent)return"<p>An error occurred:</p><pre>"+D(W.message+"",!0)+"</pre>";throw W}try{var Ie=B.lex(Y,X);if(X.walkTokens){if(X.async)return Promise.all(ie.walkTokens(Ie,X.walkTokens)).then(function(){return Z.parse(Ie,X)}).catch(we);ie.walkTokens(Ie,X.walkTokens)}return Z.parse(Ie,X)}catch(W){we(W)}}ie.options=ie.setOptions=function(Y){return v(ie.defaults,Y),g(ie.defaults),ie},ie.getDefaults=A,ie.defaults=re.defaults,ie.use=function(){for(var Y=arguments.length,X=new Array(Y),be=0;be<Y;be++)X[be]=arguments[be];var se=v.apply(void 0,[{}].concat(X)),ge=ie.defaults.extensions||{renderers:{},childTokens:{}},te;X.forEach(function(me){if(me.extensions&&(te=!0,me.extensions.forEach(function(Ie){if(!Ie.name)throw new Error("extension name required");if(Ie.renderer){var W=ge.renderers?ge.renderers[Ie.name]:null;W?ge.renderers[Ie.name]=function(){for(var J=arguments.length,ce=new Array(J),de=0;de<J;de++)ce[de]=arguments[de];var ee=Ie.renderer.apply(this,ce);return ee===!1&&(ee=W.apply(this,ce)),ee}:ge.renderers[Ie.name]=Ie.renderer}if(Ie.tokenizer){if(!Ie.level||Ie.level!=="block"&&Ie.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");ge[Ie.level]?ge[Ie.level].unshift(Ie.tokenizer):ge[Ie.level]=[Ie.tokenizer],Ie.start&&(Ie.level==="block"?ge.startBlock?ge.startBlock.push(Ie.start):ge.startBlock=[Ie.start]:Ie.level==="inline"&&(ge.startInline?ge.startInline.push(Ie.start):ge.startInline=[Ie.start]))}Ie.childTokens&&(ge.childTokens[Ie.name]=Ie.childTokens)})),me.renderer&&function(){var Ie=ie.defaults.renderer||new he,W=function(de){var ee=Ie[de];Ie[de]=function(){for(var $e=arguments.length,ve=new Array($e),Ne=0;Ne<$e;Ne++)ve[Ne]=arguments[Ne];var qe=me.renderer[de].apply(Ie,ve);return qe===!1&&(qe=ee.apply(Ie,ve)),qe}};for(var J in me.renderer)W(J);se.renderer=Ie}(),me.tokenizer&&function(){var Ie=ie.defaults.tokenizer||new F,W=function(de){var ee=Ie[de];Ie[de]=function(){for(var $e=arguments.length,ve=new Array($e),Ne=0;Ne<$e;Ne++)ve[Ne]=arguments[Ne];var qe=me.tokenizer[de].apply(Ie,ve);return qe===!1&&(qe=ee.apply(Ie,ve)),qe}};for(var J in me.tokenizer)W(J);se.tokenizer=Ie}(),me.walkTokens){var we=ie.defaults.walkTokens;se.walkTokens=function(Ie){var W=[];return W.push(me.walkTokens.call(this,Ie)),we&&(W=W.concat(we.call(this,Ie))),W}}te&&(se.extensions=ge),ie.setOptions(se)})},ie.walkTokens=function(Y,X){for(var be=[],se=function(){var we=te.value;switch(be=be.concat(X.call(ie,we)),we.type){case"table":{for(var Ie=L(we.header),W;!(W=Ie()).done;){var J=W.value;be=be.concat(ie.walkTokens(J.tokens,X))}for(var ce=L(we.rows),de;!(de=ce()).done;)for(var ee=de.value,$e=L(ee),ve;!(ve=$e()).done;){var Ne=ve.value;be=be.concat(ie.walkTokens(Ne.tokens,X))}break}case"list":{be=be.concat(ie.walkTokens(we.items,X));break}default:ie.defaults.extensions&&ie.defaults.extensions.childTokens&&ie.defaults.extensions.childTokens[we.type]?ie.defaults.extensions.childTokens[we.type].forEach(function(qe){be=be.concat(ie.walkTokens(we[qe],X))}):we.tokens&&(be=be.concat(ie.walkTokens(we.tokens,X)))}},ge=L(Y),te;!(te=ge()).done;)se();return be},ie.parseInline=function(Y,X){if(typeof Y>"u"||Y===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Y!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Y)+", string expected");X=v({},ie.defaults,X||{}),b(X);try{var be=B.lexInline(Y,X);return X.walkTokens&&ie.walkTokens(be,X.walkTokens),Z.parseInline(be,X)}catch(se){if(se.message+=`
Please report this to https://github.com/markedjs/marked.`,X.silent)return"<p>An error occurred:</p><pre>"+D(se.message+"",!0)+"</pre>";throw se}},ie.Parser=Z,ie.parser=Z.parse,ie.Renderer=he,ie.TextRenderer=x,ie.Lexer=B,ie.lexer=B.lex,ie.Tokenizer=F,ie.Slugger=Q,ie.parse=ie;var _=ie.options,oe=ie.setOptions,ye=ie.use,fe=ie.walkTokens,V=ie.parseInline,le=ie,H=Z.parse,G=B.lex;re.Lexer=B,re.Parser=Z,re.Renderer=he,re.Slugger=Q,re.TextRenderer=x,re.Tokenizer=F,re.getDefaults=A,re.lexer=G,re.marked=ie,re.options=_,re.parse=le,re.parseInline=V,re.parser=H,re.setOptions=oe,re.use=ye,re.walkTokens=fe,Object.defineProperty(re,"__esModule",{value:!0})}),define(De[77],Ce([1,0,28]),function(re,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sl=e.$rl=e.$ql=void 0;const M=new y.$Dc(1e4);function l($){return k($,"NFC",M)}e.$ql=l;const L=new y.$Dc(1e4);function A($){return k($,"NFD",L)}e.$rl=A;const g=/[^\u0000-\u0080]/;function k($,R,P){if(!$)return $;const p=P.get($);if(p)return p;let S;return g.test($)?S=$.normalize(R):S=$,P.set($,S),S}e.$sl=function(){const $=/[\u0300-\u036f]/g;return function(R){return A(R).replace($,"")}}()}),define(De[121],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ul=e.$Tl=e.$Sl=e.rot=e.$Ql=void 0;function y(g,k,$){return Math.min(Math.max(g,k),$)}e.$Ql=y;function M(g,k){return(k+g%k)%k}e.rot=M;class l{constructor(){this.a=0}getNext(){return this.a++}}e.$Sl=l;class L{constructor(){this.a=1,this.b=0}update(k){return this.b=this.b+(k-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Tl=L;class A{constructor(k){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(k),this.c.fill(0,0,k)}update(k){const $=this.c[this.d];return this.c[this.d]=k,this.d=(this.d+1)%this.c.length,this.e-=$,this.e+=k,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Ul=A}),function(){function re(l){const L=[];typeof l=="number"&&L.push("code/timeOrigin",l);function A(k){L.push(k,Date.now())}function g(){const k=[];for(let $=0;$<L.length;$+=2)k.push({name:L[$],startTime:L[$+1]});return k}return{mark:A,getMarks:g}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?re():{mark(l){performance.mark(l)},getMarks(){let l=performance.timeOrigin;typeof l!="number"&&(l=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const L=[{name:"code/timeOrigin",startTime:Math.round(l)}];for(const A of performance.getEntriesByType("mark"))L.push({name:A.name,startTime:Math.round(l+A.startTime)});return L}};if(typeof process=="object"){const l=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return re(l)}else return console.trace("perf-util loaded in UNKNOWN environment"),re()}function y(l){return l.MonacoPerformanceMarks||(l.MonacoPerformanceMarks=e()),l.MonacoPerformanceMarks}var M;typeof global=="object"?M=global:typeof self=="object"?M=self:M={},typeof define=="function"?define("vs/base/common/performance",[],function(){return y(M)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=y(M):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),M.perf=y(M))}(),define(De[12],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$C=e.$B=e.$A=e.$z=e.$y=e.$x=e.OS=e.OperatingSystem=e.$v=e.$u=e.$t=e.$s=e.$r=e.Language=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.$h=e.$g=e.$f=e.$e=e.$d=e.$c=e.Platform=e.$b=e.$a=void 0,e.$a="en";let y=!1,M=!1,l=!1,L=!1,A=!1,g=!1,k=!1,$=!1,R=!1,P=!1,p,S=e.$a,D=e.$a,E,h;e.$b=typeof self=="object"?self:typeof global=="object"?global:{};let u;typeof e.$b.vscode<"u"&&typeof e.$b.vscode.process<"u"?u=e.$b.vscode.process:typeof process<"u"&&(u=process);const d=typeof u?.versions?.electron=="string",c=d&&u?.type==="renderer";if(typeof navigator=="object"&&!c){h=navigator.userAgent,y=h.indexOf("Windows")>=0,M=h.indexOf("Macintosh")>=0,$=(h.indexOf("Macintosh")>=0||h.indexOf("iPad")>=0||h.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,l=h.indexOf("Linux")>=0,P=h?.indexOf("Mobi")>=0,g=!0,p=e.$a,S=p,D=navigator.language;const v=typeof document<"u"&&document.getElementById("vscode-remote-nls-configuration"),C=v&&v.getAttribute("data-settings");if(C)try{const w=JSON.parse(C),m=w.availableLanguages["*"];p=w.locale,D=w.osLocale,S=m||e.$a,E=w._translationsConfigFile}catch{}}else if(typeof u=="object"){y=u.platform==="win32",M=u.platform==="darwin",l=u.platform==="linux",L=l&&!!u.env.SNAP&&!!u.env.SNAP_REVISION,k=d,R=!!u.env.CI||!!u.env.BUILD_ARTIFACTSTAGINGDIRECTORY,p=e.$a,S=e.$a;const v=u.env.VSCODE_NLS_CONFIG;if(v)try{const C=JSON.parse(v),w=C.availableLanguages["*"];p=C.locale,D=C.osLocale,S=w||e.$a,E=C._translationsConfigFile}catch{}A=!0}else console.error("Unable to resolve platform.");var f;(function(v){v[v.Web=0]="Web",v[v.Mac=1]="Mac",v[v.Linux=2]="Linux",v[v.Windows=3]="Windows"})(f||(e.Platform=f={}));function a(v){switch(v){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.$c=a;let t=0;M?t=1:y?t=3:l&&(t=2),e.$d=y,e.$e=M,e.$f=l,e.$g=L,e.$h=A,e.$i=k,e.$j=g,e.$k=g&&typeof e.$b.importScripts=="function",e.$l=$,e.$m=P,e.$n=R,e.$o=t,e.$p=h,e.$q=S;var i;(function(v){function C(){return e.$q}v.value=C;function w(){return e.$q.length===2?e.$q==="en":e.$q.length>=3?e.$q[0]==="e"&&e.$q[1]==="n"&&e.$q[2]==="-":!1}v.isDefaultVariant=w;function m(){return e.$q==="en"}v.isDefault=m})(i||(e.Language=i={})),e.$r=p,e.$s=D,e.$t=E,e.$u=typeof e.$b.postMessage=="function"&&!e.$b.importScripts,e.$v=(()=>{if(e.$u){const v=[];e.$b.addEventListener("message",w=>{if(w.data&&w.data.vscodeScheduleAsyncWork)for(let m=0,b=v.length;m<b;m++){const I=v[m];if(I.id===w.data.vscodeScheduleAsyncWork){v.splice(m,1),I.callback();return}}});let C=0;return w=>{const m=++C;v.push({id:m,callback:w}),e.$b.postMessage({vscodeScheduleAsyncWork:m},"*")}}return v=>setTimeout(v)})();var s;(function(v){v[v.Windows=1]="Windows",v[v.Macintosh=2]="Macintosh",v[v.Linux=3]="Linux"})(s||(e.OperatingSystem=s={})),e.OS=M||$?2:y?1:3;let n=!0,r=!1;function o(){if(!r){r=!0;const v=new Uint8Array(2);v[0]=1,v[1]=2,n=new Uint16Array(v.buffer)[0]===(2<<8)+1}return n}e.$x=o,e.$y=!!(e.$p&&e.$p.indexOf("Chrome")>=0),e.$z=!!(e.$p&&e.$p.indexOf("Firefox")>=0),e.$A=!!(!e.$y&&e.$p&&e.$p.indexOf("Safari")>=0),e.$B=!!(e.$p&&e.$p.indexOf("Edg/")>=0),e.$C=!!(e.$p&&e.$p.indexOf("Android")>=0)}),define(De[48],Ce([1,0,12]),function(re,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ec=e.$dc=e.env=e.cwd=void 0;let M;if(typeof y.$b.vscode<"u"&&typeof y.$b.vscode.process<"u"){const l=y.$b.vscode.process;M={get platform(){return l.platform},get arch(){return l.arch},get env(){return l.env},cwd(){return l.cwd()}}}else typeof process<"u"?M={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:M={get platform(){return y.$d?"win32":y.$e?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=M.cwd,e.env=M.env,e.$dc=M.platform,e.$ec=M.arch}),define(De[15],Ce([1,0,48]),function(re,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tc=e.sep=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=void 0;const M=65,l=97,L=90,A=122,g=46,k=47,$=92,R=58,P=63;class p extends Error{constructor(i,s,n){let r;typeof s=="string"&&s.indexOf("not ")===0?(r="must not be",s=s.replace(/^not /,"")):r="must be";const o=i.indexOf(".")!==-1?"property":"argument";let v=`The "${i}" ${o} ${r} of type ${s}`;v+=`. Received type ${typeof n}`,super(v),this.code="ERR_INVALID_ARG_TYPE"}}function S(t,i){if(t===null||typeof t!="object")throw new p(i,"Object",t)}function D(t,i){if(typeof t!="string")throw new p(i,"string",t)}const E=y.$dc==="win32";function h(t){return t===k||t===$}function u(t){return t===k}function d(t){return t>=M&&t<=L||t>=l&&t<=A}function c(t,i,s,n){let r="",o=0,v=-1,C=0,w=0;for(let m=0;m<=t.length;++m){if(m<t.length)w=t.charCodeAt(m);else{if(n(w))break;w=k}if(n(w)){if(!(v===m-1||C===1))if(C===2){if(r.length<2||o!==2||r.charCodeAt(r.length-1)!==g||r.charCodeAt(r.length-2)!==g){if(r.length>2){const b=r.lastIndexOf(s);b===-1?(r="",o=0):(r=r.slice(0,b),o=r.length-1-r.lastIndexOf(s)),v=m,C=0;continue}else if(r.length!==0){r="",o=0,v=m,C=0;continue}}i&&(r+=r.length>0?`${s}..`:"..",o=2)}else r.length>0?r+=`${s}${t.slice(v+1,m)}`:r=t.slice(v+1,m),o=m-v-1;v=m,C=0}else w===g&&C!==-1?++C:C=-1}return r}function f(t,i){S(i,"pathObject");const s=i.dir||i.root,n=i.base||`${i.name||""}${i.ext||""}`;return s?s===i.root?`${s}${n}`:`${s}${t}${n}`:n}e.$fc={resolve(...t){let i="",s="",n=!1;for(let r=t.length-1;r>=-1;r--){let o;if(r>=0){if(o=t[r],D(o,"path"),o.length===0)continue}else i.length===0?o=y.cwd():(o=y.env[`=${i}`]||y.cwd(),(o===void 0||o.slice(0,2).toLowerCase()!==i.toLowerCase()&&o.charCodeAt(2)===$)&&(o=`${i}\\`));const v=o.length;let C=0,w="",m=!1;const b=o.charCodeAt(0);if(v===1)h(b)&&(C=1,m=!0);else if(h(b))if(m=!0,h(o.charCodeAt(1))){let I=2,z=I;for(;I<v&&!h(o.charCodeAt(I));)I++;if(I<v&&I!==z){const O=o.slice(z,I);for(z=I;I<v&&h(o.charCodeAt(I));)I++;if(I<v&&I!==z){for(z=I;I<v&&!h(o.charCodeAt(I));)I++;(I===v||I!==z)&&(w=`\\\\${O}\\${o.slice(z,I)}`,C=I)}}}else C=1;else d(b)&&o.charCodeAt(1)===R&&(w=o.slice(0,2),C=2,v>2&&h(o.charCodeAt(2))&&(m=!0,C=3));if(w.length>0)if(i.length>0){if(w.toLowerCase()!==i.toLowerCase())continue}else i=w;if(n){if(i.length>0)break}else if(s=`${o.slice(C)}\\${s}`,n=m,m&&i.length>0)break}return s=c(s,!n,"\\",h),n?`${i}\\${s}`:`${i}${s}`||"."},normalize(t){D(t,"path");const i=t.length;if(i===0)return".";let s=0,n,r=!1;const o=t.charCodeAt(0);if(i===1)return u(o)?"\\":t;if(h(o))if(r=!0,h(t.charCodeAt(1))){let C=2,w=C;for(;C<i&&!h(t.charCodeAt(C));)C++;if(C<i&&C!==w){const m=t.slice(w,C);for(w=C;C<i&&h(t.charCodeAt(C));)C++;if(C<i&&C!==w){for(w=C;C<i&&!h(t.charCodeAt(C));)C++;if(C===i)return`\\\\${m}\\${t.slice(w)}\\`;C!==w&&(n=`\\\\${m}\\${t.slice(w,C)}`,s=C)}}}else s=1;else d(o)&&t.charCodeAt(1)===R&&(n=t.slice(0,2),s=2,i>2&&h(t.charCodeAt(2))&&(r=!0,s=3));let v=s<i?c(t.slice(s),!r,"\\",h):"";return v.length===0&&!r&&(v="."),v.length>0&&h(t.charCodeAt(i-1))&&(v+="\\"),n===void 0?r?`\\${v}`:v:r?`${n}\\${v}`:`${n}${v}`},isAbsolute(t){D(t,"path");const i=t.length;if(i===0)return!1;const s=t.charCodeAt(0);return h(s)||i>2&&d(s)&&t.charCodeAt(1)===R&&h(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let i,s;for(let o=0;o<t.length;++o){const v=t[o];D(v,"path"),v.length>0&&(i===void 0?i=s=v:i+=`\\${v}`)}if(i===void 0)return".";let n=!0,r=0;if(typeof s=="string"&&h(s.charCodeAt(0))){++r;const o=s.length;o>1&&h(s.charCodeAt(1))&&(++r,o>2&&(h(s.charCodeAt(2))?++r:n=!1))}if(n){for(;r<i.length&&h(i.charCodeAt(r));)r++;r>=2&&(i=`\\${i.slice(r)}`)}return e.$fc.normalize(i)},relative(t,i){if(D(t,"from"),D(i,"to"),t===i)return"";const s=e.$fc.resolve(t),n=e.$fc.resolve(i);if(s===n||(t=s.toLowerCase(),i=n.toLowerCase(),t===i))return"";let r=0;for(;r<t.length&&t.charCodeAt(r)===$;)r++;let o=t.length;for(;o-1>r&&t.charCodeAt(o-1)===$;)o--;const v=o-r;let C=0;for(;C<i.length&&i.charCodeAt(C)===$;)C++;let w=i.length;for(;w-1>C&&i.charCodeAt(w-1)===$;)w--;const m=w-C,b=v<m?v:m;let I=-1,z=0;for(;z<b;z++){const F=t.charCodeAt(r+z);if(F!==i.charCodeAt(C+z))break;F===$&&(I=z)}if(z!==b){if(I===-1)return n}else{if(m>b){if(i.charCodeAt(C+z)===$)return n.slice(C+z+1);if(z===2)return n.slice(C+z)}v>b&&(t.charCodeAt(r+z)===$?I=z:z===2&&(I=3)),I===-1&&(I=0)}let O="";for(z=r+I+1;z<=o;++z)(z===o||t.charCodeAt(z)===$)&&(O+=O.length===0?"..":"\\..");return C+=I,O.length>0?`${O}${n.slice(C,w)}`:(n.charCodeAt(C)===$&&++C,n.slice(C,w))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const i=e.$fc.resolve(t);if(i.length<=2)return t;if(i.charCodeAt(0)===$){if(i.charCodeAt(1)===$){const s=i.charCodeAt(2);if(s!==P&&s!==g)return`\\\\?\\UNC\\${i.slice(2)}`}}else if(d(i.charCodeAt(0))&&i.charCodeAt(1)===R&&i.charCodeAt(2)===$)return`\\\\?\\${i}`;return t},dirname(t){D(t,"path");const i=t.length;if(i===0)return".";let s=-1,n=0;const r=t.charCodeAt(0);if(i===1)return h(r)?t:".";if(h(r)){if(s=n=1,h(t.charCodeAt(1))){let C=2,w=C;for(;C<i&&!h(t.charCodeAt(C));)C++;if(C<i&&C!==w){for(w=C;C<i&&h(t.charCodeAt(C));)C++;if(C<i&&C!==w){for(w=C;C<i&&!h(t.charCodeAt(C));)C++;if(C===i)return t;C!==w&&(s=n=C+1)}}}}else d(r)&&t.charCodeAt(1)===R&&(s=i>2&&h(t.charCodeAt(2))?3:2,n=s);let o=-1,v=!0;for(let C=i-1;C>=n;--C)if(h(t.charCodeAt(C))){if(!v){o=C;break}}else v=!1;if(o===-1){if(s===-1)return".";o=s}return t.slice(0,o)},basename(t,i){i!==void 0&&D(i,"ext"),D(t,"path");let s=0,n=-1,r=!0,o;if(t.length>=2&&d(t.charCodeAt(0))&&t.charCodeAt(1)===R&&(s=2),i!==void 0&&i.length>0&&i.length<=t.length){if(i===t)return"";let v=i.length-1,C=-1;for(o=t.length-1;o>=s;--o){const w=t.charCodeAt(o);if(h(w)){if(!r){s=o+1;break}}else C===-1&&(r=!1,C=o+1),v>=0&&(w===i.charCodeAt(v)?--v===-1&&(n=o):(v=-1,n=C))}return s===n?n=C:n===-1&&(n=t.length),t.slice(s,n)}for(o=t.length-1;o>=s;--o)if(h(t.charCodeAt(o))){if(!r){s=o+1;break}}else n===-1&&(r=!1,n=o+1);return n===-1?"":t.slice(s,n)},extname(t){D(t,"path");let i=0,s=-1,n=0,r=-1,o=!0,v=0;t.length>=2&&t.charCodeAt(1)===R&&d(t.charCodeAt(0))&&(i=n=2);for(let C=t.length-1;C>=i;--C){const w=t.charCodeAt(C);if(h(w)){if(!o){n=C+1;break}continue}r===-1&&(o=!1,r=C+1),w===g?s===-1?s=C:v!==1&&(v=1):s!==-1&&(v=-1)}return s===-1||r===-1||v===0||v===1&&s===r-1&&s===n+1?"":t.slice(s,r)},format:f.bind(null,"\\"),parse(t){D(t,"path");const i={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return i;const s=t.length;let n=0,r=t.charCodeAt(0);if(s===1)return h(r)?(i.root=i.dir=t,i):(i.base=i.name=t,i);if(h(r)){if(n=1,h(t.charCodeAt(1))){let I=2,z=I;for(;I<s&&!h(t.charCodeAt(I));)I++;if(I<s&&I!==z){for(z=I;I<s&&h(t.charCodeAt(I));)I++;if(I<s&&I!==z){for(z=I;I<s&&!h(t.charCodeAt(I));)I++;I===s?n=I:I!==z&&(n=I+1)}}}}else if(d(r)&&t.charCodeAt(1)===R){if(s<=2)return i.root=i.dir=t,i;if(n=2,h(t.charCodeAt(2))){if(s===3)return i.root=i.dir=t,i;n=3}}n>0&&(i.root=t.slice(0,n));let o=-1,v=n,C=-1,w=!0,m=t.length-1,b=0;for(;m>=n;--m){if(r=t.charCodeAt(m),h(r)){if(!w){v=m+1;break}continue}C===-1&&(w=!1,C=m+1),r===g?o===-1?o=m:b!==1&&(b=1):o!==-1&&(b=-1)}return C!==-1&&(o===-1||b===0||b===1&&o===C-1&&o===v+1?i.base=i.name=t.slice(v,C):(i.name=t.slice(v,o),i.base=t.slice(v,C),i.ext=t.slice(o,C))),v>0&&v!==n?i.dir=t.slice(0,v-1):i.dir=i.root,i},sep:"\\",delimiter:";",win32:null,posix:null};const a=(()=>{if(E){const t=/\\/g;return()=>{const i=y.cwd().replace(t,"/");return i.slice(i.indexOf("/"))}}return()=>y.cwd()})();e.$gc={resolve(...t){let i="",s=!1;for(let n=t.length-1;n>=-1&&!s;n--){const r=n>=0?t[n]:a();D(r,"path"),r.length!==0&&(i=`${r}/${i}`,s=r.charCodeAt(0)===k)}return i=c(i,!s,"/",u),s?`/${i}`:i.length>0?i:"."},normalize(t){if(D(t,"path"),t.length===0)return".";const i=t.charCodeAt(0)===k,s=t.charCodeAt(t.length-1)===k;return t=c(t,!i,"/",u),t.length===0?i?"/":s?"./":".":(s&&(t+="/"),i?`/${t}`:t)},isAbsolute(t){return D(t,"path"),t.length>0&&t.charCodeAt(0)===k},join(...t){if(t.length===0)return".";let i;for(let s=0;s<t.length;++s){const n=t[s];D(n,"path"),n.length>0&&(i===void 0?i=n:i+=`/${n}`)}return i===void 0?".":e.$gc.normalize(i)},relative(t,i){if(D(t,"from"),D(i,"to"),t===i||(t=e.$gc.resolve(t),i=e.$gc.resolve(i),t===i))return"";const s=1,n=t.length,r=n-s,o=1,v=i.length-o,C=r<v?r:v;let w=-1,m=0;for(;m<C;m++){const I=t.charCodeAt(s+m);if(I!==i.charCodeAt(o+m))break;I===k&&(w=m)}if(m===C)if(v>C){if(i.charCodeAt(o+m)===k)return i.slice(o+m+1);if(m===0)return i.slice(o+m)}else r>C&&(t.charCodeAt(s+m)===k?w=m:m===0&&(w=0));let b="";for(m=s+w+1;m<=n;++m)(m===n||t.charCodeAt(m)===k)&&(b+=b.length===0?"..":"/..");return`${b}${i.slice(o+w)}`},toNamespacedPath(t){return t},dirname(t){if(D(t,"path"),t.length===0)return".";const i=t.charCodeAt(0)===k;let s=-1,n=!0;for(let r=t.length-1;r>=1;--r)if(t.charCodeAt(r)===k){if(!n){s=r;break}}else n=!1;return s===-1?i?"/":".":i&&s===1?"//":t.slice(0,s)},basename(t,i){i!==void 0&&D(i,"ext"),D(t,"path");let s=0,n=-1,r=!0,o;if(i!==void 0&&i.length>0&&i.length<=t.length){if(i===t)return"";let v=i.length-1,C=-1;for(o=t.length-1;o>=0;--o){const w=t.charCodeAt(o);if(w===k){if(!r){s=o+1;break}}else C===-1&&(r=!1,C=o+1),v>=0&&(w===i.charCodeAt(v)?--v===-1&&(n=o):(v=-1,n=C))}return s===n?n=C:n===-1&&(n=t.length),t.slice(s,n)}for(o=t.length-1;o>=0;--o)if(t.charCodeAt(o)===k){if(!r){s=o+1;break}}else n===-1&&(r=!1,n=o+1);return n===-1?"":t.slice(s,n)},extname(t){D(t,"path");let i=-1,s=0,n=-1,r=!0,o=0;for(let v=t.length-1;v>=0;--v){const C=t.charCodeAt(v);if(C===k){if(!r){s=v+1;break}continue}n===-1&&(r=!1,n=v+1),C===g?i===-1?i=v:o!==1&&(o=1):i!==-1&&(o=-1)}return i===-1||n===-1||o===0||o===1&&i===n-1&&i===s+1?"":t.slice(i,n)},format:f.bind(null,"/"),parse(t){D(t,"path");const i={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return i;const s=t.charCodeAt(0)===k;let n;s?(i.root="/",n=1):n=0;let r=-1,o=0,v=-1,C=!0,w=t.length-1,m=0;for(;w>=n;--w){const b=t.charCodeAt(w);if(b===k){if(!C){o=w+1;break}continue}v===-1&&(C=!1,v=w+1),b===g?r===-1?r=w:m!==1&&(m=1):r!==-1&&(m=-1)}if(v!==-1){const b=o===0&&s?1:o;r===-1||m===0||m===1&&r===v-1&&r===o+1?i.base=i.name=t.slice(b,v):(i.name=t.slice(b,r),i.base=t.slice(b,v),i.ext=t.slice(r,v))}return o>0?i.dir=t.slice(0,o-1):s&&(i.dir="/"),i},sep:"/",delimiter:":",win32:null,posix:null},e.$gc.win32=e.$fc.win32=e.$fc,e.$gc.posix=e.$fc.posix=e.$gc,e.$hc=E?e.$fc.normalize:e.$gc.normalize,e.$ic=E?e.$fc.isAbsolute:e.$gc.isAbsolute,e.$jc=E?e.$fc.join:e.$gc.join,e.$kc=E?e.$fc.resolve:e.$gc.resolve,e.$lc=E?e.$fc.relative:e.$gc.relative,e.$mc=E?e.$fc.dirname:e.$gc.dirname,e.$nc=E?e.$fc.basename:e.$gc.basename,e.$oc=E?e.$fc.extname:e.$gc.extname,e.$pc=E?e.$fc.format:e.$gc.format,e.$qc=E?e.$fc.parse:e.$gc.parse,e.$rc=E?e.$fc.toNamespacedPath:e.$gc.toNamespacedPath,e.sep=E?e.$fc.sep:e.$gc.sep,e.$tc=E?e.$fc.delimiter:e.$gc.delimiter}),define(De[122],Ce([1,0,47,15]),function(re,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yq=e.$xq=e.$wq=e.$vq=e.$uq=e.$tq=e.$sq=e.$rq=e.$qq=e.$pq=e.$oq=e.$nq=e.$mq=void 0;const l=new y.$V(()=>{const C=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:C,collatorIsNumeric:C.resolvedOptions().numeric}}),L=new y.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),A=new y.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function g(C,w,m=!1){const b=C||"",I=w||"",z=l.value.collator.compare(b,I);return l.value.collatorIsNumeric&&z===0&&b!==I?b<I?-1:1:z}e.$mq=g;function k(C,w){const m=L.value.collator;return C=C||"",w=w||"",f(m,C,w)}e.$nq=k;function $(C,w){const m=L.value.collator;return C=C||"",w=w||"",s(C,w)||f(m,C,w)}e.$oq=$;function R(C,w){const m=L.value.collator;return C=C||"",w=w||"",i(C,w)||f(m,C,w)}e.$pq=R;function P(C,w){return C=C||"",w=w||"",C===w?0:C<w?-1:1}e.$qq=P;function p(C,w){const[m,b]=d(C),[I,z]=d(w);let O=l.value.collator.compare(b,z);if(O===0){if(l.value.collatorIsNumeric&&b!==z)return b<z?-1:1;if(O=l.value.collator.compare(m,I),l.value.collatorIsNumeric&&O===0&&m!==I)return m<I?-1:1}return O}e.$rq=p;function S(C,w){C=C||"",w=w||"";const m=c(C),b=c(w),I=L.value.collator,z=A.value.collator;return f(z,m,b)||f(I,C,w)}e.$sq=S;function D(C,w){C=C||"",w=w||"";const m=c(C),b=c(w),I=L.value.collator,z=A.value.collator;return f(z,m,b)||s(C,w)||f(I,C,w)}e.$tq=D;function E(C,w){C=C||"",w=w||"";const m=c(C),b=c(w),I=L.value.collator,z=A.value.collator;return f(z,m,b)||i(C,w)||f(I,C,w)}e.$uq=E;function h(C,w){C=C||"",w=w||"";const m=c(C).toLowerCase(),b=c(w).toLowerCase();return m!==b?m<b?-1:1:C!==w?C<w?-1:1:0}e.$vq=h;const u=/^(.*?)(\.([^.]*))?$/;function d(C,w=!1){const m=C?u.exec(C):[];let b=[m&&m[1]||"",m&&m[3]||""];return w&&(!b[0]&&b[1]||b[0]&&b[0].charAt(0)===".")&&(b=[b[0]+"."+b[1],""]),b}function c(C){const w=C?u.exec(C):[];return w&&w[1]&&w[1].charAt(0)!=="."&&w[3]||""}function f(C,w,m){const b=C.compare(w,m);return b!==0?b:w.length!==m.length?w.length<m.length?-1:1:0}function a(C){const w=C.charAt(0);return w.toLocaleUpperCase()!==w}function t(C){const w=C.charAt(0);return w.toLocaleLowerCase()!==w}function i(C,w){return a(C)&&t(w)?-1:t(C)&&a(w)?1:0}function s(C,w){return t(C)&&a(w)?-1:a(C)&&t(w)?1:0}function n(C,w,m=!1){return m||(C=C&&C.toLowerCase(),w=w&&w.toLowerCase()),C===w?0:C<w?-1:1}function r(C,w,m=!1){const b=C.split(M.sep),I=w.split(M.sep),z=b.length-1,O=I.length-1;let F,T;for(let N=0;;N++){if(F=z===N,T=O===N,F&&T)return g(b[N],I[N],m);if(F)return-1;if(T)return 1;const j=n(b[N],I[N],m);if(j!==0)return j}}e.$wq=r;function o(C,w,m){const b=C.toLowerCase(),I=w.toLowerCase(),z=v(C,w,m);if(z)return z;const O=b.endsWith(m),F=I.endsWith(m);if(O!==F)return O?-1:1;const T=g(b,I);return T!==0?T:b.localeCompare(I)}e.$xq=o;function v(C,w,m){const b=C.toLowerCase(),I=w.toLowerCase(),z=b.startsWith(m),O=I.startsWith(m);if(z!==O)return z?-1:1;if(z&&O){if(b.length<I.length)return-1;if(b.length>I.length)return 1}return 0}e.$yq=v}),define(De[96],Ce([1,0,15]),function(re,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yr=e.$Xr=e.$Wr=e.$Vr=e.$Ur=void 0,e.$Ur=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const M={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},l={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function L(R){const P=(0,y.$oc)(R),p=M[P.toLowerCase()];return p!==void 0?p:A(R)}e.$Vr=L;function A(R){const P=(0,y.$oc)(R);return l[P.toLowerCase()]}e.$Wr=A;function g(R){for(const P in l)if(l[P]===R)return P}e.$Xr=g;const k=/^(.+)\/(.+?)(;.+)?$/;function $(R,P){const p=k.exec(R);return p?`${p[1].toLowerCase()}/${p[2].toLowerCase()}${p[3]??""}`:P?void 0:R}e.$Yr=$}),define(De[97],Ce([1,0,12]),function(re,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cl=e.$Bl=e.TerminateResponseCode=e.Source=void 0;var M;(function(g){g[g.stdout=0]="stdout",g[g.stderr=1]="stderr"})(M||(e.Source=M={}));var l;(function(g){g[g.Success=0]="Success",g[g.Unknown=1]="Unknown",g[g.AccessDenied=2]="AccessDenied",g[g.ProcessNotFound=3]="ProcessNotFound"})(l||(e.TerminateResponseCode=l={}));function L(g,...k){const $=k.reduce((p,S)=>(p[S]=!0,p),{}),R=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/,/^CODE_SERVER_.+$/,/^CS_.+$/];Object.keys(g).filter(p=>!$[p]).forEach(p=>{for(let S=0;S<R.length;S++)if(p.search(R[S])!==-1){delete g[p];break}})}e.$Bl=L;function A(g){g&&(delete g.DEBUG,y.$e&&delete g.DYLD_LIBRARY_PATH,y.$f&&delete g.LD_PRELOAD)}e.$Cl=A}),function(re,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var y=e();for(var M in y)(typeof exports=="object"?exports:re)[M]=y[M]}}(typeof self<"u"?self:this,function(){return function(re){var e={};function y(M){if(e[M])return e[M].exports;var l=e[M]={i:M,l:!1,exports:{}};return re[M].call(l.exports,l,l.exports,y),l.l=!0,l.exports}return y.m=re,y.c=e,y.d=function(M,l,L){y.o(M,l)||Object.defineProperty(M,l,{enumerable:!0,get:L})},y.r=function(M){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(M,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(M,"__esModule",{value:!0})},y.t=function(M,l){if(1&l&&(M=y(M)),8&l||4&l&&typeof M=="object"&&M&&M.__esModule)return M;var L=Object.create(null);if(y.r(L),Object.defineProperty(L,"default",{enumerable:!0,value:M}),2&l&&typeof M!="string")for(var A in M)y.d(L,A,function(g){return M[g]}.bind(null,A));return L},y.n=function(M){var l=M&&M.__esModule?function(){return M.default}:function(){return M};return y.d(l,"a",l),l},y.o=function(M,l){return Object.prototype.hasOwnProperty.call(M,l)},y.p="",y(y.s=0)}([function(re,e,y){(function(M){var l;e=re.exports=ye,l=typeof M=="object"&&M.env&&M.env.NODE_DEBUG&&/\bsemver\b/i.test(M.env.NODE_DEBUG)?function(){var ee=Array.prototype.slice.call(arguments,0);ee.unshift("SEMVER"),console.log.apply(console,ee)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var L=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,g=e.re=[],k=e.src=[],$=0,R=$++;k[R]="0|[1-9]\\d*";var P=$++;k[P]="[0-9]+";var p=$++;k[p]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var S=$++;k[S]="("+k[R]+")\\.("+k[R]+")\\.("+k[R]+")";var D=$++;k[D]="("+k[P]+")\\.("+k[P]+")\\.("+k[P]+")";var E=$++;k[E]="(?:"+k[R]+"|"+k[p]+")";var h=$++;k[h]="(?:"+k[P]+"|"+k[p]+")";var u=$++;k[u]="(?:-("+k[E]+"(?:\\."+k[E]+")*))";var d=$++;k[d]="(?:-?("+k[h]+"(?:\\."+k[h]+")*))";var c=$++;k[c]="[0-9A-Za-z-]+";var f=$++;k[f]="(?:\\+("+k[c]+"(?:\\."+k[c]+")*))";var a=$++,t="v?"+k[S]+k[u]+"?"+k[f]+"?";k[a]="^"+t+"$";var i="[v=\\s]*"+k[D]+k[d]+"?"+k[f]+"?",s=$++;k[s]="^"+i+"$";var n=$++;k[n]="((?:<|>)?=?)";var r=$++;k[r]=k[P]+"|x|X|\\*";var o=$++;k[o]=k[R]+"|x|X|\\*";var v=$++;k[v]="[v=\\s]*("+k[o]+")(?:\\.("+k[o]+")(?:\\.("+k[o]+")(?:"+k[u]+")?"+k[f]+"?)?)?";var C=$++;k[C]="[v=\\s]*("+k[r]+")(?:\\.("+k[r]+")(?:\\.("+k[r]+")(?:"+k[d]+")?"+k[f]+"?)?)?";var w=$++;k[w]="^"+k[n]+"\\s*"+k[v]+"$";var m=$++;k[m]="^"+k[n]+"\\s*"+k[C]+"$";var b=$++;k[b]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var I=$++;k[I]="(?:~>?)";var z=$++;k[z]="(\\s*)"+k[I]+"\\s+",g[z]=new RegExp(k[z],"g");var O=$++;k[O]="^"+k[I]+k[v]+"$";var F=$++;k[F]="^"+k[I]+k[C]+"$";var T=$++;k[T]="(?:\\^)";var N=$++;k[N]="(\\s*)"+k[T]+"\\s+",g[N]=new RegExp(k[N],"g");var j=$++;k[j]="^"+k[T]+k[v]+"$";var U=$++;k[U]="^"+k[T]+k[C]+"$";var B=$++;k[B]="^"+k[n]+"\\s*("+i+")$|^$";var he=$++;k[he]="^"+k[n]+"\\s*("+t+")$|^$";var x=$++;k[x]="(\\s*)"+k[n]+"\\s*("+i+"|"+k[v]+")",g[x]=new RegExp(k[x],"g");var Q=$++;k[Q]="^\\s*("+k[v]+")\\s+-\\s+("+k[v]+")\\s*$";var Z=$++;k[Z]="^\\s*("+k[C]+")\\s+-\\s+("+k[C]+")\\s*$";var ie=$++;k[ie]="(<|>)?=?\\s*\\*";for(var _=0;_<35;_++)l(_,k[_]),g[_]||(g[_]=new RegExp(k[_]));function oe(ee,$e){if(ee instanceof ye)return ee;if(typeof ee!="string"||ee.length>L||!($e?g[s]:g[a]).test(ee))return null;try{return new ye(ee,$e)}catch{return null}}function ye(ee,$e){if(ee instanceof ye){if(ee.loose===$e)return ee;ee=ee.version}else if(typeof ee!="string")throw new TypeError("Invalid Version: "+ee);if(ee.length>L)throw new TypeError("version is longer than "+L+" characters");if(!(this instanceof ye))return new ye(ee,$e);l("SemVer",ee,$e),this.loose=$e;var ve=ee.trim().match($e?g[s]:g[a]);if(!ve)throw new TypeError("Invalid Version: "+ee);if(this.raw=ee,this.major=+ve[1],this.minor=+ve[2],this.patch=+ve[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");ve[4]?this.prerelease=ve[4].split(".").map(function(Ne){if(/^[0-9]+$/.test(Ne)){var qe=+Ne;if(qe>=0&&qe<A)return qe}return Ne}):this.prerelease=[],this.build=ve[5]?ve[5].split("."):[],this.format()}e.parse=oe,e.valid=function(ee,$e){var ve=oe(ee,$e);return ve?ve.version:null},e.clean=function(ee,$e){var ve=oe(ee.trim().replace(/^[=v]+/,""),$e);return ve?ve.version:null},e.SemVer=ye,ye.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},ye.prototype.toString=function(){return this.version},ye.prototype.compare=function(ee){return l("SemVer.compare",this.version,this.loose,ee),ee instanceof ye||(ee=new ye(ee,this.loose)),this.compareMain(ee)||this.comparePre(ee)},ye.prototype.compareMain=function(ee){return ee instanceof ye||(ee=new ye(ee,this.loose)),V(this.major,ee.major)||V(this.minor,ee.minor)||V(this.patch,ee.patch)},ye.prototype.comparePre=function(ee){if(ee instanceof ye||(ee=new ye(ee,this.loose)),this.prerelease.length&&!ee.prerelease.length)return-1;if(!this.prerelease.length&&ee.prerelease.length)return 1;if(!this.prerelease.length&&!ee.prerelease.length)return 0;var $e=0;do{var ve=this.prerelease[$e],Ne=ee.prerelease[$e];if(l("prerelease compare",$e,ve,Ne),ve===void 0&&Ne===void 0)return 0;if(Ne===void 0)return 1;if(ve===void 0)return-1;if(ve!==Ne)return V(ve,Ne)}while(++$e)},ye.prototype.inc=function(ee,$e){switch(ee){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",$e);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",$e);break;case"prepatch":this.prerelease.length=0,this.inc("patch",$e),this.inc("pre",$e);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",$e),this.inc("pre",$e);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ve=this.prerelease.length;--ve>=0;)typeof this.prerelease[ve]=="number"&&(this.prerelease[ve]++,ve=-2);ve===-1&&this.prerelease.push(0)}$e&&(this.prerelease[0]===$e?isNaN(this.prerelease[1])&&(this.prerelease=[$e,0]):this.prerelease=[$e,0]);break;default:throw new Error("invalid increment argument: "+ee)}return this.format(),this.raw=this.version,this},e.inc=function(ee,$e,ve,Ne){typeof ve=="string"&&(Ne=ve,ve=void 0);try{return new ye(ee,ve).inc($e,Ne).version}catch{return null}},e.diff=function(ee,$e){if(Y(ee,$e))return null;var ve=oe(ee),Ne=oe($e);if(ve.prerelease.length||Ne.prerelease.length){for(var qe in ve)if((qe==="major"||qe==="minor"||qe==="patch")&&ve[qe]!==Ne[qe])return"pre"+qe;return"prerelease"}for(var qe in ve)if((qe==="major"||qe==="minor"||qe==="patch")&&ve[qe]!==Ne[qe])return qe},e.compareIdentifiers=V;var fe=/^[0-9]+$/;function V(ee,$e){var ve=fe.test(ee),Ne=fe.test($e);return ve&&Ne&&(ee=+ee,$e=+$e),ve&&!Ne?-1:Ne&&!ve?1:ee<$e?-1:ee>$e?1:0}function le(ee,$e,ve){return new ye(ee,ve).compare(new ye($e,ve))}function H(ee,$e,ve){return le(ee,$e,ve)>0}function G(ee,$e,ve){return le(ee,$e,ve)<0}function Y(ee,$e,ve){return le(ee,$e,ve)===0}function X(ee,$e,ve){return le(ee,$e,ve)!==0}function be(ee,$e,ve){return le(ee,$e,ve)>=0}function se(ee,$e,ve){return le(ee,$e,ve)<=0}function ge(ee,$e,ve,Ne){var qe;switch($e){case"===":typeof ee=="object"&&(ee=ee.version),typeof ve=="object"&&(ve=ve.version),qe=ee===ve;break;case"!==":typeof ee=="object"&&(ee=ee.version),typeof ve=="object"&&(ve=ve.version),qe=ee!==ve;break;case"":case"=":case"==":qe=Y(ee,ve,Ne);break;case"!=":qe=X(ee,ve,Ne);break;case">":qe=H(ee,ve,Ne);break;case">=":qe=be(ee,ve,Ne);break;case"<":qe=G(ee,ve,Ne);break;case"<=":qe=se(ee,ve,Ne);break;default:throw new TypeError("Invalid operator: "+$e)}return qe}function te(ee,$e){if(ee instanceof te){if(ee.loose===$e)return ee;ee=ee.value}if(!(this instanceof te))return new te(ee,$e);l("comparator",ee,$e),this.loose=$e,this.parse(ee),this.semver===me?this.value="":this.value=this.operator+this.semver.version,l("comp",this)}e.rcompareIdentifiers=function(ee,$e){return V($e,ee)},e.major=function(ee,$e){return new ye(ee,$e).major},e.minor=function(ee,$e){return new ye(ee,$e).minor},e.patch=function(ee,$e){return new ye(ee,$e).patch},e.compare=le,e.compareLoose=function(ee,$e){return le(ee,$e,!0)},e.rcompare=function(ee,$e,ve){return le($e,ee,ve)},e.sort=function(ee,$e){return ee.sort(function(ve,Ne){return e.compare(ve,Ne,$e)})},e.rsort=function(ee,$e){return ee.sort(function(ve,Ne){return e.rcompare(ve,Ne,$e)})},e.gt=H,e.lt=G,e.eq=Y,e.neq=X,e.gte=be,e.lte=se,e.cmp=ge,e.Comparator=te;var me={};function we(ee,$e){if(ee instanceof we)return ee.loose===$e?ee:new we(ee.raw,$e);if(ee instanceof te)return new we(ee.value,$e);if(!(this instanceof we))return new we(ee,$e);if(this.loose=$e,this.raw=ee,this.set=ee.split(/\s*\|\|\s*/).map(function(ve){return this.parseRange(ve.trim())},this).filter(function(ve){return ve.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ee);this.format()}function Ie(ee){return!ee||ee.toLowerCase()==="x"||ee==="*"}function W(ee,$e,ve,Ne,qe,xe,Ge,st,it,nt,Ae,Oe,Re){return(($e=Ie(ve)?"":Ie(Ne)?">="+ve+".0.0":Ie(qe)?">="+ve+"."+Ne+".0":">="+$e)+" "+(st=Ie(it)?"":Ie(nt)?"<"+(+it+1)+".0.0":Ie(Ae)?"<"+it+"."+(+nt+1)+".0":Oe?"<="+it+"."+nt+"."+Ae+"-"+Oe:"<="+st)).trim()}function J(ee,$e){for(var ve=0;ve<ee.length;ve++)if(!ee[ve].test($e))return!1;if($e.prerelease.length){for(ve=0;ve<ee.length;ve++)if(l(ee[ve].semver),ee[ve].semver!==me&&ee[ve].semver.prerelease.length>0){var Ne=ee[ve].semver;if(Ne.major===$e.major&&Ne.minor===$e.minor&&Ne.patch===$e.patch)return!0}return!1}return!0}function ce(ee,$e,ve){try{$e=new we($e,ve)}catch{return!1}return $e.test(ee)}function de(ee,$e,ve,Ne){var qe,xe,Ge,st,it;switch(ee=new ye(ee,Ne),$e=new we($e,Ne),ve){case">":qe=H,xe=se,Ge=G,st=">",it=">=";break;case"<":qe=G,xe=be,Ge=H,st="<",it="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(ce(ee,$e,Ne))return!1;for(var nt=0;nt<$e.set.length;++nt){var Ae=$e.set[nt],Oe=null,Re=null;if(Ae.forEach(function(Qe){Qe.semver===me&&(Qe=new te(">=0.0.0")),Oe=Oe||Qe,Re=Re||Qe,qe(Qe.semver,Oe.semver,Ne)?Oe=Qe:Ge(Qe.semver,Re.semver,Ne)&&(Re=Qe)}),Oe.operator===st||Oe.operator===it||(!Re.operator||Re.operator===st)&&xe(ee,Re.semver)||Re.operator===it&&Ge(ee,Re.semver))return!1}return!0}te.prototype.parse=function(ee){var $e=this.loose?g[B]:g[he],ve=ee.match($e);if(!ve)throw new TypeError("Invalid comparator: "+ee);this.operator=ve[1],this.operator==="="&&(this.operator=""),ve[2]?this.semver=new ye(ve[2],this.loose):this.semver=me},te.prototype.toString=function(){return this.value},te.prototype.test=function(ee){return l("Comparator.test",ee,this.loose),this.semver===me||(typeof ee=="string"&&(ee=new ye(ee,this.loose)),ge(ee,this.operator,this.semver,this.loose))},te.prototype.intersects=function(ee,$e){if(!(ee instanceof te))throw new TypeError("a Comparator is required");var ve;if(this.operator==="")return ve=new we(ee.value,$e),ce(this.value,ve,$e);if(ee.operator==="")return ve=new we(this.value,$e),ce(ee.semver,ve,$e);var Ne=!(this.operator!==">="&&this.operator!==">"||ee.operator!==">="&&ee.operator!==">"),qe=!(this.operator!=="<="&&this.operator!=="<"||ee.operator!=="<="&&ee.operator!=="<"),xe=this.semver.version===ee.semver.version,Ge=!(this.operator!==">="&&this.operator!=="<="||ee.operator!==">="&&ee.operator!=="<="),st=ge(this.semver,"<",ee.semver,$e)&&(this.operator===">="||this.operator===">")&&(ee.operator==="<="||ee.operator==="<"),it=ge(this.semver,">",ee.semver,$e)&&(this.operator==="<="||this.operator==="<")&&(ee.operator===">="||ee.operator===">");return Ne||qe||xe&&Ge||st||it},e.Range=we,we.prototype.format=function(){return this.range=this.set.map(function(ee){return ee.join(" ").trim()}).join("||").trim(),this.range},we.prototype.toString=function(){return this.range},we.prototype.parseRange=function(ee){var $e=this.loose;ee=ee.trim(),l("range",ee,$e);var ve=$e?g[Z]:g[Q];ee=ee.replace(ve,W),l("hyphen replace",ee),ee=ee.replace(g[x],"$1$2$3"),l("comparator trim",ee,g[x]),ee=(ee=(ee=ee.replace(g[z],"$1~")).replace(g[N],"$1^")).split(/\s+/).join(" ");var Ne=$e?g[B]:g[he],qe=ee.split(" ").map(function(xe){return function(Ge,st){return l("comp",Ge),Ge=function(it,nt){return it.trim().split(/\s+/).map(function(Ae){return function(Oe,Re){l("caret",Oe,Re);var Qe=Re?g[U]:g[j];return Oe.replace(Qe,function(ue,ae,Pe,Ke,Ue){var Ze;return l("caret",Oe,ue,ae,Pe,Ke,Ue),Ie(ae)?Ze="":Ie(Pe)?Ze=">="+ae+".0.0 <"+(+ae+1)+".0.0":Ie(Ke)?Ze=ae==="0"?">="+ae+"."+Pe+".0 <"+ae+"."+(+Pe+1)+".0":">="+ae+"."+Pe+".0 <"+(+ae+1)+".0.0":Ue?(l("replaceCaret pr",Ue),Ue.charAt(0)!=="-"&&(Ue="-"+Ue),Ze=ae==="0"?Pe==="0"?">="+ae+"."+Pe+"."+Ke+Ue+" <"+ae+"."+Pe+"."+(+Ke+1):">="+ae+"."+Pe+"."+Ke+Ue+" <"+ae+"."+(+Pe+1)+".0":">="+ae+"."+Pe+"."+Ke+Ue+" <"+(+ae+1)+".0.0"):(l("no pr"),Ze=ae==="0"?Pe==="0"?">="+ae+"."+Pe+"."+Ke+" <"+ae+"."+Pe+"."+(+Ke+1):">="+ae+"."+Pe+"."+Ke+" <"+ae+"."+(+Pe+1)+".0":">="+ae+"."+Pe+"."+Ke+" <"+(+ae+1)+".0.0"),l("caret return",Ze),Ze})}(Ae,nt)}).join(" ")}(Ge,st),l("caret",Ge),Ge=function(it,nt){return it.trim().split(/\s+/).map(function(Ae){return function(Oe,Re){var Qe=Re?g[F]:g[O];return Oe.replace(Qe,function(ue,ae,Pe,Ke,Ue){var Ze;return l("tilde",Oe,ue,ae,Pe,Ke,Ue),Ie(ae)?Ze="":Ie(Pe)?Ze=">="+ae+".0.0 <"+(+ae+1)+".0.0":Ie(Ke)?Ze=">="+ae+"."+Pe+".0 <"+ae+"."+(+Pe+1)+".0":Ue?(l("replaceTilde pr",Ue),Ue.charAt(0)!=="-"&&(Ue="-"+Ue),Ze=">="+ae+"."+Pe+"."+Ke+Ue+" <"+ae+"."+(+Pe+1)+".0"):Ze=">="+ae+"."+Pe+"."+Ke+" <"+ae+"."+(+Pe+1)+".0",l("tilde return",Ze),Ze})}(Ae,nt)}).join(" ")}(Ge,st),l("tildes",Ge),Ge=function(it,nt){return l("replaceXRanges",it,nt),it.split(/\s+/).map(function(Ae){return function(Oe,Re){Oe=Oe.trim();var Qe=Re?g[m]:g[w];return Oe.replace(Qe,function(ue,ae,Pe,Ke,Ue,Ze){l("xRange",Oe,ue,ae,Pe,Ke,Ue,Ze);var rt=Ie(Pe),ht=rt||Ie(Ke),pt=ht||Ie(Ue);return ae==="="&&pt&&(ae=""),rt?ue=ae===">"||ae==="<"?"<0.0.0":"*":ae&&pt?(ht&&(Ke=0),pt&&(Ue=0),ae===">"?(ae=">=",ht?(Pe=+Pe+1,Ke=0,Ue=0):pt&&(Ke=+Ke+1,Ue=0)):ae==="<="&&(ae="<",ht?Pe=+Pe+1:Ke=+Ke+1),ue=ae+Pe+"."+Ke+"."+Ue):ht?ue=">="+Pe+".0.0 <"+(+Pe+1)+".0.0":pt&&(ue=">="+Pe+"."+Ke+".0 <"+Pe+"."+(+Ke+1)+".0"),l("xRange return",ue),ue})}(Ae,nt)}).join(" ")}(Ge,st),l("xrange",Ge),Ge=function(it,nt){return l("replaceStars",it,nt),it.trim().replace(g[ie],"")}(Ge,st),l("stars",Ge),Ge}(xe,$e)}).join(" ").split(/\s+/);return this.loose&&(qe=qe.filter(function(xe){return!!xe.match(Ne)})),qe=qe.map(function(xe){return new te(xe,$e)})},we.prototype.intersects=function(ee,$e){if(!(ee instanceof we))throw new TypeError("a Range is required");return this.set.some(function(ve){return ve.every(function(Ne){return ee.set.some(function(qe){return qe.every(function(xe){return Ne.intersects(xe,$e)})})})})},e.toComparators=function(ee,$e){return new we(ee,$e).set.map(function(ve){return ve.map(function(Ne){return Ne.value}).join(" ").trim().split(" ")})},we.prototype.test=function(ee){if(!ee)return!1;typeof ee=="string"&&(ee=new ye(ee,this.loose));for(var $e=0;$e<this.set.length;$e++)if(J(this.set[$e],ee))return!0;return!1},e.satisfies=ce,e.maxSatisfying=function(ee,$e,ve){var Ne=null,qe=null;try{var xe=new we($e,ve)}catch{return null}return ee.forEach(function(Ge){xe.test(Ge)&&(Ne&&qe.compare(Ge)!==-1||(qe=new ye(Ne=Ge,ve)))}),Ne},e.minSatisfying=function(ee,$e,ve){var Ne=null,qe=null;try{var xe=new we($e,ve)}catch{return null}return ee.forEach(function(Ge){xe.test(Ge)&&(Ne&&qe.compare(Ge)!==1||(qe=new ye(Ne=Ge,ve)))}),Ne},e.validRange=function(ee,$e){try{return new we(ee,$e).range||"*"}catch{return null}},e.ltr=function(ee,$e,ve){return de(ee,$e,"<",ve)},e.gtr=function(ee,$e,ve){return de(ee,$e,">",ve)},e.outside=de,e.prerelease=function(ee,$e){var ve=oe(ee,$e);return ve&&ve.prerelease.length?ve.prerelease:null},e.intersects=function(ee,$e,ve){return ee=new we(ee,ve),$e=new we($e,ve),ee.intersects($e)},e.coerce=function(ee){if(ee instanceof ye)return ee;if(typeof ee!="string")return null;var $e=ee.match(g[b]);return $e==null?null:oe(($e[1]||"0")+"."+($e[2]||"0")+"."+($e[3]||"0"))}}).call(this,y(1))},function(re,e){var y,M,l=re.exports={};function L(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function g(h){if(y===setTimeout)return setTimeout(h,0);if((y===L||!y)&&setTimeout)return y=setTimeout,setTimeout(h,0);try{return y(h,0)}catch{try{return y.call(null,h,0)}catch{return y.call(this,h,0)}}}(function(){try{y=typeof setTimeout=="function"?setTimeout:L}catch{y=L}try{M=typeof clearTimeout=="function"?clearTimeout:A}catch{M=A}})();var k,$=[],R=!1,P=-1;function p(){R&&k&&(R=!1,k.length?$=k.concat($):P=-1,$.length&&S())}function S(){if(!R){var h=g(p);R=!0;for(var u=$.length;u;){for(k=$,$=[];++P<u;)k&&k[P].run();P=-1,u=$.length}k=null,R=!1,function(d){if(M===clearTimeout)return clearTimeout(d);if((M===A||!M)&&clearTimeout)return M=clearTimeout,clearTimeout(d);try{M(d)}catch{try{return M.call(null,d)}catch{return M.call(this,d)}}}(h)}}function D(h,u){this.fun=h,this.array=u}function E(){}l.nextTick=function(h){var u=new Array(arguments.length-1);if(arguments.length>1)for(var d=1;d<arguments.length;d++)u[d-1]=arguments[d];$.push(new D(h,u)),$.length!==1||R||g(S)},D.prototype.run=function(){this.fun.apply(null,this.array)},l.title="browser",l.browser=!0,l.env={},l.argv=[],l.version="",l.versions={},l.on=E,l.addListener=E,l.once=E,l.off=E,l.removeListener=E,l.removeAllListeners=E,l.emit=E,l.prependListener=E,l.prependOnceListener=E,l.listeners=function(h){return[]},l.binding=function(h){throw new Error("process.binding is not supported")},l.cwd=function(){return"/"},l.chdir=function(h){throw new Error("process.chdir is not supported")},l.umask=function(){return 0}}])}),define(De[35],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kd=void 0;const y=globalThis.performance&&typeof globalThis.performance.now=="function";class M{static create(L){return new M(L)}constructor(L){this.c=y&&L===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$Kd=M}),define(De[4],Ce([1,0,9,75,3,76,35]),function(re,e,y,M,l,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xd=e.$Wd=e.$Vd=e.$Ud=e.$Td=e.$Sd=e.$Rd=e.$Qd=e.$Pd=e.$Od=e.$Nd=e.$Md=e.Event=void 0;const g=!1,k=!1;var $;(function(w){w.None=()=>l.$Sc.None;function m(ge){if(k){const{onDidAddListener:te}=ge,me=D.create();let we=0;ge.onDidAddListener=()=>{++we===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),me.print()),te?.()}}}function b(ge,te){return he(ge,()=>{},0,void 0,!0,void 0,te)}w.defer=b;function I(ge){return(te,me=null,we)=>{let Ie=!1,W;return W=ge(J=>{if(!Ie)return W?W.dispose():Ie=!0,te.call(me,J)},null,we),Ie&&W.dispose(),W}}w.once=I;function z(ge,te,me){return U((we,Ie=null,W)=>ge(J=>we.call(Ie,te(J)),null,W),me)}w.map=z;function O(ge,te,me){return U((we,Ie=null,W)=>ge(J=>{te(J),we.call(Ie,J)},null,W),me)}w.forEach=O;function F(ge,te,me){return U((we,Ie=null,W)=>ge(J=>te(J)&&we.call(Ie,J),null,W),me)}w.filter=F;function T(ge){return ge}w.signal=T;function N(...ge){return(te,me=null,we)=>{const Ie=(0,l.$Pc)(...ge.map(W=>W(J=>te.call(me,J))));return B(Ie,we)}}w.any=N;function j(ge,te,me,we){let Ie=me;return z(ge,W=>(Ie=te(Ie,W),Ie),we)}w.reduce=j;function U(ge,te){let me;const we={onWillAddFirstListener(){me=ge(Ie.fire,Ie)},onDidRemoveLastListener(){me?.dispose()}};te||m(we);const Ie=new c(we);return te?.add(Ie),Ie.event}function B(ge,te){return te instanceof Array?te.push(ge):te&&te.add(ge),ge}function he(ge,te,me=100,we=!1,Ie=!1,W,J){let ce,de,ee,$e=0,ve;const Ne={leakWarningThreshold:W,onWillAddFirstListener(){ce=ge(xe=>{$e++,de=te(de,xe),we&&!ee&&(qe.fire(de),de=void 0),ve=()=>{const Ge=de;de=void 0,ee=void 0,(!we||$e>1)&&qe.fire(Ge),$e=0},typeof me=="number"?(clearTimeout(ee),ee=setTimeout(ve,me)):ee===void 0&&(ee=0,queueMicrotask(ve))})},onWillRemoveListener(){Ie&&$e>0&&ve?.()},onDidRemoveLastListener(){ve=void 0,ce.dispose()}};J||m(Ne);const qe=new c(Ne);return J?.add(qe),qe.event}w.debounce=he;function x(ge,te=0,me){return w.debounce(ge,(we,Ie)=>we?(we.push(Ie),we):[Ie],te,void 0,!0,void 0,me)}w.accumulate=x;function Q(ge,te=(we,Ie)=>we===Ie,me){let we=!0,Ie;return F(ge,W=>{const J=we||!te(W,Ie);return we=!1,Ie=W,J},me)}w.latch=Q;function Z(ge,te,me){return[w.filter(ge,te,me),w.filter(ge,we=>!te(we),me)]}w.split=Z;function ie(ge,te=!1,me=[],we){let Ie=me.slice(),W=ge(de=>{Ie?Ie.push(de):ce.fire(de)});we&&we.add(W);const J=()=>{Ie?.forEach(de=>ce.fire(de)),Ie=null},ce=new c({onWillAddFirstListener(){W||(W=ge(de=>ce.fire(de)),we&&we.add(W))},onDidAddFirstListener(){Ie&&(te?setTimeout(J):J())},onDidRemoveLastListener(){W&&W.dispose(),W=null}});return we&&we.add(ce),ce.event}w.buffer=ie;function _(ge,te){return(we,Ie,W)=>{const J=te(new ye);return ge(function(ce){const de=J.evaluate(ce);de!==oe&&we.call(Ie,de)},void 0,W)}}w.chain=_;const oe=Symbol("HaltChainable");class ye{constructor(){this.f=[]}map(te){return this.f.push(te),this}forEach(te){return this.f.push(me=>(te(me),me)),this}filter(te){return this.f.push(me=>te(me)?me:oe),this}reduce(te,me){let we=me;return this.f.push(Ie=>(we=te(we,Ie),we)),this}latch(te=(me,we)=>me===we){let me=!0,we;return this.f.push(Ie=>{const W=me||!te(Ie,we);return me=!1,we=Ie,W?Ie:oe}),this}evaluate(te){for(const me of this.f)if(te=me(te),te===oe)break;return te}}function fe(ge,te,me=we=>we){const we=(...ce)=>J.fire(me(...ce)),Ie=()=>ge.on(te,we),W=()=>ge.removeListener(te,we),J=new c({onWillAddFirstListener:Ie,onDidRemoveLastListener:W});return J.event}w.fromNodeEventEmitter=fe;function V(ge,te,me=we=>we){const we=(...ce)=>J.fire(me(...ce)),Ie=()=>ge.addEventListener(te,we),W=()=>ge.removeEventListener(te,we),J=new c({onWillAddFirstListener:Ie,onDidRemoveLastListener:W});return J.event}w.fromDOMEventEmitter=V;function le(ge){return new Promise(te=>I(ge)(te))}w.toPromise=le;function H(ge){const te=new c;return ge.then(me=>{te.fire(me)},()=>{te.fire(void 0)}).finally(()=>{te.dispose()}),te.event}w.fromPromise=H;function G(ge,te,me){return te(me),ge(we=>te(we))}w.runAndSubscribe=G;function Y(ge,te){let me=null;function we(W){me?.dispose(),me=new l.$Rc,te(W,me)}we(void 0);const Ie=ge(W=>we(W));return(0,l.$Qc)(()=>{Ie.dispose(),me?.dispose()})}w.runAndSubscribeWithStore=Y;class X{constructor(te,me){this._observable=te,this.f=0,this.g=!1;const we={onWillAddFirstListener:()=>{te.addObserver(this)},onDidRemoveLastListener:()=>{te.removeObserver(this)}};me||m(we),this.emitter=new c(we),me&&me.add(this.emitter)}beginUpdate(te){this.f++}handlePossibleChange(te){}handleChange(te,me){this.g=!0}endUpdate(te){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function be(ge,te){return new X(ge,te).emitter.event}w.fromObservable=be;function se(ge){return te=>{let me=0,we=!1;const Ie={beginUpdate(){me++},endUpdate(){me--,me===0&&(ge.reportChanges(),we&&(we=!1,te()))},handlePossibleChange(){},handleChange(){we=!0}};return ge.addObserver(Ie),ge.reportChanges(),{dispose(){ge.removeObserver(Ie)}}}}w.fromObservableLight=se})($||(e.Event=$={}));class R{constructor(m){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${m}_${R.f++}`,R.all.add(this)}start(m){this.g=new A.$Kd,this.listenerCount=m}stop(){if(this.g){const m=this.g.elapsed();this.durations.push(m),this.elapsedOverall+=m,this.invocationCount+=1,this.g=void 0}}}e.$Md=R,R.all=new Set,R.f=0;let P=-1;function p(w){const m=P;return P=w,{dispose(){P=m}}}e.$Nd=p;class S{constructor(m,b=Math.random().toString(18).slice(2,5)){this.threshold=m,this.name=b,this.g=0}dispose(){this.f?.clear()}check(m,b){const I=this.threshold;if(I<=0||b<I)return;this.f||(this.f=new Map);const z=this.f.get(m.value)||0;if(this.f.set(m.value,z+1),this.g-=1,this.g<=0){this.g=I*.5;let O,F=0;for(const[T,N]of this.f)(!O||F<N)&&(O=T,F=N);console.warn(`[${this.name}] potential listener LEAK detected, having ${b} listeners already. MOST frequent listener (${F}):`),console.warn(O)}return()=>{const O=this.f.get(m.value)||0;this.f.set(m.value,O-1)}}}class D{static create(){return new D(new Error().stack??"")}constructor(m){this.value=m}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let E=0;class h{constructor(m){this.value=m,this.id=E++}}const u=2,d=(w,m)=>{if(w instanceof h)m(w);else for(let b=0;b<w.length;b++){const I=w[b];I&&m(I)}};class c{constructor(m){this.w=0,this.f=m,this.g=P>0||this.f?.leakWarningThreshold?new S(this.f?.leakWarningThreshold??P):void 0,this.j=this.f?._profName?new R(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(g){const m=this.t;queueMicrotask(()=>{d(m,b=>b.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??(this.q=(m,b,I)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),l.$Sc.None;if(this.m)return l.$Sc.None;b&&(m=m.bind(b));const z=new h(m);let O,F;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(z.stack=D.create(),O=this.g.check(z.stack,this.w+1)),g&&(z.stack=F??D.create()),this.t?this.t instanceof h?(this.u??(this.u=new a),this.t=[this.t,z]):this.t.push(z):(this.f?.onWillAddFirstListener?.(this),this.t=z,this.f?.onDidAddFirstListener?.(this)),this.w++;const T=(0,l.$Qc)(()=>{O?.(),this.x(z)});return I instanceof l.$Rc?I.add(T):Array.isArray(I)&&I.push(T),T}),this.q}x(m){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const b=this.t,I=b.indexOf(m);if(I===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,b[I]=void 0;const z=this.u.current===this;if(this.w*u<=b.length){let O=0;for(let F=0;F<b.length;F++)b[F]?b[O++]=b[F]:z&&(this.u.end--,O<this.u.i&&this.u.i--);b.length=O}}y(m,b){if(!m)return;const I=this.f?.onListenerError||y.$1;if(!I){m.value(b);return}try{m.value(b)}catch(z){I(z)}}z(m){const b=m.current.t;for(;m.i<m.end;)this.y(b[m.i++],m.value);m.reset()}fire(m){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof h)this.y(this.t,m);else{const b=this.u;b.enqueue(this,m,this.t.length),this.z(b)}this.j?.stop()}hasListeners(){return this.w>0}}e.$Od=c;const f=()=>new a;e.$Pd=f;class a{constructor(){this.i=-1,this.end=0}enqueue(m,b,I){this.i=0,this.end=I,this.current=m,this.value=b}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class t extends c{async fireAsync(m,b,I){if(this.t)for(this.h||(this.h=new L.$2c),d(this.t,z=>this.h.push([z.value,m]));this.h.size>0&&!b.isCancellationRequested;){const[z,O]=this.h.shift(),F=[],T={...O,token:b,waitUntil:N=>{if(Object.isFrozen(F))throw new Error("waitUntil can NOT be called asynchronous");I&&(N=I(N,z)),F.push(N)}};try{z(T)}catch(N){(0,y.$1)(N);continue}Object.freeze(F),await Promise.allSettled(F).then(N=>{for(const j of N)j.status==="rejected"&&(0,y.$1)(j.reason)})}}}e.$Qd=t;class i extends c{get isPaused(){return this.h!==0}constructor(m){super(m),this.h=0,this.s=new L.$2c,this.A=m?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const m=Array.from(this.s);this.s.clear(),super.fire(this.A(m))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(m){this.w&&(this.h!==0?this.s.push(m):super.fire(m))}}e.$Rd=i;class s extends i{constructor(m){super(m),this.k=m.delay??100}fire(m){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(m)}}e.$Sd=s;class n extends c{constructor(m){super(m),this.h=[],this.k=m?.merge}fire(m){this.hasListeners()&&(this.h.push(m),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(b=>super.fire(b)),this.h=[]}))}}e.$Td=n;class r{constructor(){this.g=!1,this.h=[],this.f=new c({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(m){const b={event:m,listener:null};this.h.push(b),this.g&&this.m(b);const I=()=>{this.g&&this.o(b);const z=this.h.indexOf(b);this.h.splice(z,1)};return(0,l.$Qc)((0,M.$db)(I))}j(){this.g=!0,this.h.forEach(m=>this.m(m))}k(){this.g=!1,this.h.forEach(m=>this.o(m))}m(m){m.listener=m.event(b=>this.f.fire(b))}o(m){m.listener&&m.listener.dispose(),m.listener=null}dispose(){this.f.dispose()}}e.$Ud=r;class o{constructor(m,b,I,z){this.f=new l.$Rc;const O=this.f.add(new r),F=this.f.add(new l.$1c);function T(N){F.set(N,O.add(z(N)))}for(const N of m)T(N);this.f.add(b(N=>{T(N)})),this.f.add(I(N=>{F.deleteAndDispose(N)})),this.event=O.event}dispose(){this.f.dispose()}}e.$Vd=o;class v{constructor(){this.f=[]}wrapEvent(m){return(b,I,z)=>m(O=>{const F=this.f[this.f.length-1];F?F.push(()=>b.call(I,O)):b.call(I,O)},void 0,z)}bufferEvents(m){const b=[];this.f.push(b);const I=m();return this.f.pop(),b.forEach(z=>z()),I}}e.$Wd=v;class C{constructor(){this.f=!1,this.g=$.None,this.h=l.$Sc.None,this.j=new c({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(m){this.g=m,this.f&&(this.h.dispose(),this.h=m(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$Xd=C}),define(De[21],Ce([1,0,4]),function(re,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yd=e.CancellationToken=void 0;const M=Object.freeze(function(g,k){const $=setTimeout(g.bind(k),0);return{dispose(){clearTimeout($)}}});var l;(function(g){function k($){return $===g.None||$===g.Cancelled||$ instanceof L?!0:!$||typeof $!="object"?!1:typeof $.isCancellationRequested=="boolean"&&typeof $.onCancellationRequested=="function"}g.isCancellationToken=k,g.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:y.Event.None}),g.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:M})})(l||(e.CancellationToken=l={}));class L{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?M:(this.b||(this.b=new y.$Od),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class A{constructor(k){this.f=void 0,this.g=void 0,this.g=k&&k.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new L),this.f}cancel(){this.f?this.f instanceof L&&this.f.cancel():this.f=l.Cancelled}dispose(k=!1){k&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof L&&this.f.dispose():this.f=l.None}}e.$Yd=A}),define(De[160],Ce([1,0,21]),function(re,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ze=e.$ye=e.$xe=void 0;class M{constructor(g){this.b=g,this.a=null}get(){if(this.a)return this.a;const g=new y.$Yd,k=this.b(g.token);return this.a={promise:k,dispose:()=>{this.a=null,g.cancel(),g.dispose()}},this.a}}e.$xe=M;class l{constructor(g){this.c=g,this.a=void 0,this.b=void 0}get(g){const k=JSON.stringify(g);return this.b!==k&&(this.b=k,this.a=this.c(g)),this.a}}e.$ye=l;class L{get cachedValues(){return this.a}constructor(g){this.b=g,this.a=new Map}get(g){if(this.a.has(g))return this.a.get(g);const k=this.b(g);return this.a.set(g,k),k}}e.$ze=L}),define(De[98],Ce([1,0,9,3]),function(re,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=e.$4d=e.$3d=e.$2d=e.$1d=e.$Zd=void 0;function l(f){const a=f;return a?typeof a.read=="function":!1}e.$Zd=l;function L(f){const a=f;return a?[a.on,a.pause,a.resume,a.destroy].every(t=>typeof t=="function"):!1}e.$1d=L;function A(f){const a=f;return a?L(a.stream)&&Array.isArray(a.buffer)&&typeof a.ended=="boolean":!1}e.$2d=A;function g(f,a){return new k(f,a)}e.$3d=g;class k{constructor(a,t){this.e=a,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(a){if(!this.a.destroyed){if(this.a.flowing)this.g(a);else if(this.b.data.push(a),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(a){this.a.destroyed||(this.a.flowing?this.h(a):this.b.error.push(a))}end(a){this.a.destroyed||(typeof a<"u"&&this.write(a),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(a){this.c.data.slice(0).forEach(t=>t(a))}h(a){this.c.error.length===0?(0,y.$1)(a):this.c.error.slice(0).forEach(t=>t(a))}i(){this.c.end.slice(0).forEach(a=>a())}on(a,t){if(!this.a.destroyed)switch(a){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(a,t){if(this.a.destroyed)return;let i;switch(a){case"data":i=this.c.data;break;case"end":i=this.c.end;break;case"error":i=this.c.error;break}if(i){const s=i.indexOf(t);s>=0&&i.splice(s,1)}}j(){if(this.b.data.length>0){const a=this.e(this.b.data);this.g(a),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(i=>i())}}k(){if(this.c.error.length>0){for(const a of this.b.error)this.h(a);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function $(f,a){const t=[];let i;for(;(i=f.read())!==null;)t.push(i);return a(t)}e.$4d=$;function R(f,a,t){const i=[];let s;for(;(s=f.read())!==null&&i.length<t;)i.push(s);return s===null&&i.length>0?a(i):{read:()=>{if(i.length>0)return i.shift();if(typeof s<"u"){const n=s;return s=void 0,n}return f.read()}}}e.$5d=R;function P(f,a){return new Promise((t,i)=>{const s=[];p(f,{onData:n=>{a&&s.push(n)},onError:n=>{a?i(n):t(void 0)},onEnd:()=>{t(a?a(s):void 0)}})})}e.$6d=P;function p(f,a,t){f.on("error",i=>{t?.isCancellationRequested||a.onError(i)}),f.on("end",()=>{t?.isCancellationRequested||a.onEnd()}),f.on("data",i=>{t?.isCancellationRequested||a.onData(i)})}e.$7d=p;function S(f,a){return new Promise((t,i)=>{const s=new M.$Rc,n=[],r=C=>{if(n.push(C),n.length>a)return s.dispose(),f.pause(),t({stream:f,buffer:n,ended:!1})},o=C=>(s.dispose(),i(C)),v=()=>(s.dispose(),t({stream:f,buffer:n,ended:!0}));s.add((0,M.$Qc)(()=>f.removeListener("error",o))),f.on("error",o),s.add((0,M.$Qc)(()=>f.removeListener("end",v))),f.on("end",v),s.add((0,M.$Qc)(()=>f.removeListener("data",r))),f.on("data",r)})}e.$8d=S;function D(f,a){const t=g(a);return t.end(f),t}e.$9d=D;function E(){const f=g(()=>{throw new Error("not supported")});return f.end(),f}e.$0d=E;function h(f){let a=!1;return{read:()=>a?null:(a=!0,f)}}e.$$d=h;function u(f,a,t){const i=g(t);return p(f,{onData:s=>i.write(a.data(s)),onError:s=>i.error(a.error?a.error(s):s),onEnd:()=>i.end()}),i}e.$_d=u;function d(f,a,t){let i=!1;return{read:()=>{const s=a.read();return i?s:(i=!0,s!==null?t([f,s]):f)}}}e.$ae=d;function c(f,a,t){let i=!1;const s=g(t);return p(a,{onData:n=>i?s.write(n):(i=!0,s.write(t([f,n]))),onError:n=>s.error(n),onEnd:()=>{i||(i=!0,s.write(f)),s.end()}}),s}e.$be=c}),define(De[22],Ce([1,0,47,98]),function(re,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$ee=e.$de=e.$ce=void 0;const l=typeof Buffer<"u",L=new y.$V(()=>new Uint8Array(256));let A,g;class k{static alloc(b){return l?new k(Buffer.allocUnsafe(b)):new k(new Uint8Array(b))}static wrap(b){return l&&!Buffer.isBuffer(b)&&(b=Buffer.from(b.buffer,b.byteOffset,b.byteLength)),new k(b)}static fromString(b,I){return!(I?.dontUseNodeBuffer||!1)&&l?new k(Buffer.from(b)):(A||(A=new TextEncoder),new k(A.encode(b)))}static fromByteArray(b){const I=k.alloc(b.length);for(let z=0,O=b.length;z<O;z++)I.buffer[z]=b[z];return I}static concat(b,I){if(typeof I>"u"){I=0;for(let F=0,T=b.length;F<T;F++)I+=b[F].byteLength}const z=k.alloc(I);let O=0;for(let F=0,T=b.length;F<T;F++){const N=b[F];z.set(N,O),O+=N.byteLength}return z}constructor(b){this.buffer=b,this.byteLength=this.buffer.byteLength}clone(){const b=k.alloc(this.byteLength);return b.set(this),b}toString(){return l?this.buffer.toString():(g||(g=new TextDecoder),g.decode(this.buffer))}slice(b,I){return new k(this.buffer.subarray(b,I))}set(b,I){if(b instanceof k)this.buffer.set(b.buffer,I);else if(b instanceof Uint8Array)this.buffer.set(b,I);else if(b instanceof ArrayBuffer)this.buffer.set(new Uint8Array(b),I);else if(ArrayBuffer.isView(b))this.buffer.set(new Uint8Array(b.buffer,b.byteOffset,b.byteLength),I);else throw new Error("Unknown argument 'array'")}readUInt32BE(b){return p(this.buffer,b)}writeUInt32BE(b,I){S(this.buffer,b,I)}readUInt32LE(b){return D(this.buffer,b)}writeUInt32LE(b,I){E(this.buffer,b,I)}readUInt8(b){return h(this.buffer,b)}writeUInt8(b,I){u(this.buffer,b,I)}indexOf(b,I=0){return $(this.buffer,b instanceof k?b.buffer:b,I)}}e.$ce=k;function $(m,b,I=0){const z=b.byteLength,O=m.byteLength;if(z===0)return 0;if(z===1)return m.indexOf(b[0]);if(z>O-I)return-1;const F=L.value;F.fill(b.length);for(let U=0;U<b.length;U++)F[b[U]]=b.length-U-1;let T=I+b.length-1,N=T,j=-1;for(;T<O;)if(m[T]===b[N]){if(N===0){j=T;break}T--,N--}else T+=Math.max(b.length-N,F[m[T]]),N=b.length-1;return j}e.$de=$;function R(m,b){return m[b+0]<<0>>>0|m[b+1]<<8>>>0}e.$ee=R;function P(m,b,I){m[I+0]=b&255,b=b>>>8,m[I+1]=b&255}e.$fe=P;function p(m,b){return m[b]*2**24+m[b+1]*2**16+m[b+2]*2**8+m[b+3]}e.$ge=p;function S(m,b,I){m[I+3]=b,b=b>>>8,m[I+2]=b,b=b>>>8,m[I+1]=b,b=b>>>8,m[I]=b}e.$he=S;function D(m,b){return m[b+0]<<0>>>0|m[b+1]<<8>>>0|m[b+2]<<16>>>0|m[b+3]<<24>>>0}e.$ie=D;function E(m,b,I){m[I+0]=b&255,b=b>>>8,m[I+1]=b&255,b=b>>>8,m[I+2]=b&255,b=b>>>8,m[I+3]=b&255}e.$je=E;function h(m,b){return m[b]}e.$ke=h;function u(m,b,I){m[I]=b}e.$le=u;function d(m){return M.$4d(m,b=>k.concat(b))}e.$me=d;function c(m){return M.$$d(m)}e.$ne=c;function f(m){return M.$6d(m,b=>k.concat(b))}e.$oe=f;async function a(m){return m.ended?k.concat(m.buffer):k.concat([...m.buffer,await f(m.stream)])}e.$pe=a;function t(m){return M.$9d(m,b=>k.concat(b))}e.$qe=t;function i(m){return M.$_d(m,{data:b=>typeof b=="string"?k.fromString(b):k.wrap(b)},b=>k.concat(b))}e.$re=i;function s(m){return M.$3d(b=>k.concat(b),m)}e.$se=s;function n(m,b){return M.$ae(m,b,I=>k.concat(I))}e.$te=n;function r(m,b){return M.$be(m,b,I=>k.concat(I))}e.$ue=r;function o(m){let b=0,I=0,z=0;const O=new Uint8Array(Math.floor(m.length/4*3)),F=N=>{switch(I){case 3:O[z++]=b|N,I=0;break;case 2:O[z++]=b|N>>>2,b=N<<6,I=3;break;case 1:O[z++]=b|N>>>4,b=N<<4,I=2;break;default:b=N<<2,I=1}};for(let N=0;N<m.length;N++){const j=m.charCodeAt(N);if(j>=65&&j<=90)F(j-65);else if(j>=97&&j<=122)F(j-97+26);else if(j>=48&&j<=57)F(j-48+52);else if(j===43||j===45)F(62);else if(j===47||j===95)F(63);else{if(j===61)break;throw new SyntaxError(`Unexpected base64 character ${m[N]}`)}}const T=z;for(;I>0;)F(0);return k.wrap(O).slice(0,T)}e.$ve=o;const v="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",C="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function w({buffer:m},b=!0,I=!1){const z=I?C:v;let O="";const F=m.byteLength%3;let T=0;for(;T<m.byteLength-F;T+=3){const N=m[T+0],j=m[T+1],U=m[T+2];O+=z[N>>>2],O+=z[(N<<4|j>>>4)&63],O+=z[(j<<2|U>>>6)&63],O+=z[U&63]}if(F===1){const N=m[T+0];O+=z[N>>>2],O+=z[N<<4&63],b&&(O+="==")}else if(F===2){const N=m[T+0],j=m[T+1];O+=z[N>>>2],O+=z[(N<<4|j>>>4)&63],O+=z[j<<2&63],b&&(O+="=")}return O}e.$we=w}),define(De[16],Ce([1,0,160,47]),function(re,e,y,M){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.$yf=e.$xf=e.$wf=e.$vf=e.GraphemeBreakType=e.$uf=e.$tf=e.$sf=e.$rf=e.$qf=e.$pf=e.$of=e.$nf=e.$mf=e.$lf=e.$kf=e.$jf=e.$if=e.$hf=e.$gf=e.$ff=e.$ef=e.$df=e.$cf=e.$bf=e.$af=e.$_e=e.$$e=e.$0e=e.$9e=e.$8e=e.$7e=e.$6e=e.$5e=e.$4e=e.$3e=e.$2e=e.$1e=e.$Ze=e.$Ye=e.$Xe=e.$We=e.$Ve=e.$Ue=e.$Te=e.$Se=e.$Re=e.$Qe=e.$Pe=e.$Oe=e.$Ne=e.$Me=e.$Le=e.$Ke=e.$Je=e.$Ie=e.$He=e.$Ge=e.$Fe=e.$Ee=e.$De=e.$Ce=void 0;function L(Ae){return!Ae||typeof Ae!="string"?!0:Ae.trim().length===0}e.$Ce=L;const A=/{(\d+)}/g;function g(Ae,...Oe){return Oe.length===0?Ae:Ae.replace(A,function(Re,Qe){const ue=parseInt(Qe,10);return isNaN(ue)||ue<0||ue>=Oe.length?Re:Oe[ue]})}e.$De=g;const k=/{([^}]+)}/g;function $(Ae,Oe){return Object.keys(Oe).length===0?Ae:Ae.replace(k,(Re,Qe)=>Oe[Qe]??Re)}e.$Ee=$;function R(Ae){return Ae.replace(/[<>&]/g,function(Oe){switch(Oe){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Oe}})}e.$Fe=R;function P(Ae){return Ae.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.$Ge=P;function p(Ae,Oe){let Re=0;const Qe=Oe.charCodeAt(0);for(let ue=Ae.length-1;ue>=0;ue--)Ae.charCodeAt(ue)===Qe&&Re++;return Re}e.$He=p;function S(Ae,Oe,Re="\u2026"){return Ae.length<=Oe?Ae:`${Ae.substr(0,Oe)}${Re}`}e.$Ie=S;function D(Ae,Oe=" "){const Re=E(Ae,Oe);return h(Re,Oe)}e.$Je=D;function E(Ae,Oe){if(!Ae||!Oe)return Ae;const Re=Oe.length;if(Re===0||Ae.length===0)return Ae;let Qe=0;for(;Ae.indexOf(Oe,Qe)===Qe;)Qe=Qe+Re;return Ae.substring(Qe)}e.$Ke=E;function h(Ae,Oe){if(!Ae||!Oe)return Ae;const Re=Oe.length,Qe=Ae.length;if(Re===0||Qe===0)return Ae;let ue=Qe,ae=-1;for(;ae=Ae.lastIndexOf(Oe,ue-1),!(ae===-1||ae+Re!==ue);){if(ae===0)return"";ue=ae}return Ae.substring(0,ue)}e.$Le=h;function u(Ae){return Ae.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.$Me=u;function d(Ae){return Ae.replace(/\*/g,"")}e.$Ne=d;function c(Ae,Oe,Re={}){if(!Ae)throw new Error("Cannot create regex from empty string");Oe||(Ae=P(Ae)),Re.wholeWord&&(/\B/.test(Ae.charAt(0))||(Ae="\\b"+Ae),/\B/.test(Ae.charAt(Ae.length-1))||(Ae=Ae+"\\b"));let Qe="";return Re.global&&(Qe+="g"),Re.matchCase||(Qe+="i"),Re.multiline&&(Qe+="m"),Re.unicode&&(Qe+="u"),new RegExp(Ae,Qe)}e.$Oe=c;function f(Ae){return Ae.source==="^"||Ae.source==="^$"||Ae.source==="$"||Ae.source==="^\\s*$"?!1:!!(Ae.exec("")&&Ae.lastIndex===0)}e.$Pe=f;function a(Ae){return Ae.split(/\r\n|\r|\n/)}e.$Qe=a;function t(Ae){for(let Oe=0,Re=Ae.length;Oe<Re;Oe++){const Qe=Ae.charCodeAt(Oe);if(Qe!==32&&Qe!==9)return Oe}return-1}e.$Re=t;function i(Ae,Oe=0,Re=Ae.length){for(let Qe=Oe;Qe<Re;Qe++){const ue=Ae.charCodeAt(Qe);if(ue!==32&&ue!==9)return Ae.substring(Oe,Qe)}return Ae.substring(Oe,Re)}e.$Se=i;function s(Ae,Oe=Ae.length-1){for(let Re=Oe;Re>=0;Re--){const Qe=Ae.charCodeAt(Re);if(Qe!==32&&Qe!==9)return Re}return-1}e.$Te=s;function n(Ae,Oe,Re){const Qe=[];let ue=0;for(const ae of Ae.matchAll(Oe)){if(Qe.push(Ae.slice(ue,ae.index)),ae.index===void 0)throw new Error("match.index should be defined");ue=ae.index+ae[0].length,Qe.push(Re(ae[0],...ae.slice(1),ae.index,Ae,ae.groups))}return Qe.push(Ae.slice(ue)),Promise.all(Qe).then(ae=>ae.join(""))}e.$Ue=n;function r(Ae,Oe){return Ae<Oe?-1:Ae>Oe?1:0}e.$Ve=r;function o(Ae,Oe,Re=0,Qe=Ae.length,ue=0,ae=Oe.length){for(;Re<Qe&&ue<ae;Re++,ue++){const Ue=Ae.charCodeAt(Re),Ze=Oe.charCodeAt(ue);if(Ue<Ze)return-1;if(Ue>Ze)return 1}const Pe=Qe-Re,Ke=ae-ue;return Pe<Ke?-1:Pe>Ke?1:0}e.$We=o;function v(Ae,Oe){return C(Ae,Oe,0,Ae.length,0,Oe.length)}e.$Xe=v;function C(Ae,Oe,Re=0,Qe=Ae.length,ue=0,ae=Oe.length){for(;Re<Qe&&ue<ae;Re++,ue++){let Ue=Ae.charCodeAt(Re),Ze=Oe.charCodeAt(ue);if(Ue===Ze)continue;if(Ue>=128||Ze>=128)return o(Ae.toLowerCase(),Oe.toLowerCase(),Re,Qe,ue,ae);m(Ue)&&(Ue-=32),m(Ze)&&(Ze-=32);const rt=Ue-Ze;if(rt!==0)return rt}const Pe=Qe-Re,Ke=ae-ue;return Pe<Ke?-1:Pe>Ke?1:0}e.$Ye=C;function w(Ae){return Ae>=48&&Ae<=57}e.$Ze=w;function m(Ae){return Ae>=97&&Ae<=122}e.$1e=m;function b(Ae){return Ae>=65&&Ae<=90}e.$2e=b;function I(Ae,Oe){return Ae.length===Oe.length&&C(Ae,Oe)===0}e.$3e=I;function z(Ae,Oe){const Re=Oe.length;return Oe.length>Ae.length?!1:C(Ae,Oe,0,Re)===0}e.$4e=z;function O(Ae,Oe){const Re=Math.min(Ae.length,Oe.length);let Qe;for(Qe=0;Qe<Re;Qe++)if(Ae.charCodeAt(Qe)!==Oe.charCodeAt(Qe))return Qe;return Re}e.$5e=O;function F(Ae,Oe){const Re=Math.min(Ae.length,Oe.length);let Qe;const ue=Ae.length-1,ae=Oe.length-1;for(Qe=0;Qe<Re;Qe++)if(Ae.charCodeAt(ue-Qe)!==Oe.charCodeAt(ae-Qe))return Qe;return Re}e.$6e=F;function T(Ae){return 55296<=Ae&&Ae<=56319}e.$7e=T;function N(Ae){return 56320<=Ae&&Ae<=57343}e.$8e=N;function j(Ae,Oe){return(Ae-55296<<10)+(Oe-56320)+65536}e.$9e=j;function U(Ae,Oe,Re){const Qe=Ae.charCodeAt(Re);if(T(Qe)&&Re+1<Oe){const ue=Ae.charCodeAt(Re+1);if(N(ue))return j(Qe,ue)}return Qe}e.$0e=U;function B(Ae,Oe){const Re=Ae.charCodeAt(Oe-1);if(N(Re)&&Oe>1){const Qe=Ae.charCodeAt(Oe-2);if(T(Qe))return j(Qe,Re)}return Re}class he{get offset(){return this.e}constructor(Oe,Re=0){this.c=Oe,this.d=Oe.length,this.e=Re}setOffset(Oe){this.e=Oe}prevCodePoint(){const Oe=B(this.c,this.e);return this.e-=Oe>=65536?2:1,Oe}nextCodePoint(){const Oe=U(this.c,this.d,this.e);return this.e+=Oe>=65536?2:1,Oe}eol(){return this.e>=this.d}}e.$$e=he;class x{get offset(){return this.c.offset}constructor(Oe,Re=0){this.c=new he(Oe,Re)}nextGraphemeLength(){const Oe=ve.getInstance(),Re=this.c,Qe=Re.offset;let ue=Oe.getGraphemeBreakType(Re.nextCodePoint());for(;!Re.eol();){const ae=Re.offset,Pe=Oe.getGraphemeBreakType(Re.nextCodePoint());if(ee(ue,Pe)){Re.setOffset(ae);break}ue=Pe}return Re.offset-Qe}prevGraphemeLength(){const Oe=ve.getInstance(),Re=this.c,Qe=Re.offset;let ue=Oe.getGraphemeBreakType(Re.prevCodePoint());for(;Re.offset>0;){const ae=Re.offset,Pe=Oe.getGraphemeBreakType(Re.prevCodePoint());if(ee(Pe,ue)){Re.setOffset(ae);break}ue=Pe}return Qe-Re.offset}eol(){return this.c.eol()}}e.$_e=x;function Q(Ae,Oe){return new x(Ae,Oe).nextGraphemeLength()}e.$af=Q;function Z(Ae,Oe){return new x(Ae,Oe).prevGraphemeLength()}e.$bf=Z;function ie(Ae,Oe){Oe>0&&N(Ae.charCodeAt(Oe))&&Oe--;const Re=Oe+Q(Ae,Oe);return[Re-Z(Ae,Re),Re]}e.$cf=ie;function _(Ae){const Oe=new x(Ae);let Re=0;for(;!Oe.eol();)Re++,Oe.nextGraphemeLength();return Re}e.$df=_;let oe;function ye(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function fe(Ae){return oe||(oe=ye()),oe.test(Ae)}e.$ef=fe;const V=/^[\t\n\r\x20-\x7E]*$/;function le(Ae){return V.test(Ae)}e.$ff=le,e.$gf=/[\u2028\u2029]/;function H(Ae){return e.$gf.test(Ae)}e.$hf=H;function G(Ae){return Ae>=11904&&Ae<=55215||Ae>=63744&&Ae<=64255||Ae>=65281&&Ae<=65374}e.$if=G;function Y(Ae){return Ae>=127462&&Ae<=127487||Ae===8986||Ae===8987||Ae===9200||Ae===9203||Ae>=9728&&Ae<=10175||Ae===11088||Ae===11093||Ae>=127744&&Ae<=128591||Ae>=128640&&Ae<=128764||Ae>=128992&&Ae<=129008||Ae>=129280&&Ae<=129535||Ae>=129648&&Ae<=129782}e.$jf=Y;function X(Ae,Oe){if(Ae.length<Oe)return Ae;const Re=/\b/g;let Qe=0;for(;Re.test(Ae)&&!(Ae.length-Re.lastIndex<Oe);)Qe=Re.lastIndex,Re.lastIndex+=1;return Ae.substring(Qe).replace(/^\s/,"")}e.$kf=X;const be=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,se=/\x1b\].*?\x07/g;function ge(Ae){return Ae&&(Ae=Ae.replace(be,"").replace(se,"")),Ae}e.$lf=ge,e.$mf=String.fromCharCode(65279);function te(Ae){return!!(Ae&&Ae.length>0&&Ae.charCodeAt(0)===65279)}e.$nf=te;function me(Ae){return te(Ae)?Ae.substr(1):Ae}e.$of=me;function we(Ae,Oe){if(!Ae||!Oe||Ae.length<Oe.length)return!1;const Re=Oe.length,Qe=Ae.toLowerCase();let ue=0,ae=-1;for(;ue<Re;){const Pe=Qe.indexOf(Oe[ue],ae+1);if(Pe<0)return!1;ae=Pe,ue++}return!0}e.$pf=we;function Ie(Ae,Oe=!1){return Ae?(Oe&&(Ae=Ae.replace(/\\./g,"")),Ae.toLowerCase()!==Ae):!1}e.$qf=Ie;function W(Ae){return Ae.charAt(0).toUpperCase()+Ae.slice(1)}e.$rf=W;function J(Ae,Oe=1){if(Oe===0)return"";let Re=-1;do Re=Ae.indexOf(`
`,Re+1),Oe--;while(Oe>0&&Re>=0);return Re===-1?Ae:(Ae[Re-1]==="\r"&&Re--,Ae.substr(0,Re))}e.$sf=J;function ce(Ae){return Ae=Ae%(2*26),Ae<26?String.fromCharCode(97+Ae):String.fromCharCode(65+Ae-26)}e.$tf=ce;function de(Ae){return ve.getInstance().getGraphemeBreakType(Ae)}e.$uf=de;function ee(Ae,Oe){return Ae===0?Oe!==5&&Oe!==7:Ae===2&&Oe===3?!1:Ae===4||Ae===2||Ae===3||Oe===4||Oe===2||Oe===3?!0:!(Ae===8&&(Oe===8||Oe===9||Oe===11||Oe===12)||(Ae===11||Ae===9)&&(Oe===9||Oe===10)||(Ae===12||Ae===10)&&Oe===10||Oe===5||Oe===13||Oe===7||Ae===1||Ae===13&&Oe===14||Ae===6&&Oe===6)}var $e;(function(Ae){Ae[Ae.Other=0]="Other",Ae[Ae.Prepend=1]="Prepend",Ae[Ae.CR=2]="CR",Ae[Ae.LF=3]="LF",Ae[Ae.Control=4]="Control",Ae[Ae.Extend=5]="Extend",Ae[Ae.Regional_Indicator=6]="Regional_Indicator",Ae[Ae.SpacingMark=7]="SpacingMark",Ae[Ae.L=8]="L",Ae[Ae.V=9]="V",Ae[Ae.T=10]="T",Ae[Ae.LV=11]="LV",Ae[Ae.LVT=12]="LVT",Ae[Ae.ZWJ=13]="ZWJ",Ae[Ae.Extended_Pictographic=14]="Extended_Pictographic"})($e||(e.GraphemeBreakType=$e={}));class ve{static getInstance(){return ve.c||(ve.c=new ve),ve.c}constructor(){this.d=Ne()}getGraphemeBreakType(Oe){if(Oe<32)return Oe===10?3:Oe===13?2:4;if(Oe<127)return 0;const Re=this.d,Qe=Re.length/3;let ue=1;for(;ue<=Qe;)if(Oe<Re[3*ue])ue=2*ue;else if(Oe>Re[3*ue+1])ue=2*ue+1;else return Re[3*ue+2];return 0}}ve.c=null;function Ne(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function qe(Ae,Oe){if(Ae===0)return 0;const Re=xe(Ae,Oe);if(Re!==void 0)return Re;const Qe=new he(Oe,Ae);return Qe.prevCodePoint(),Qe.offset}e.$vf=qe;function xe(Ae,Oe){const Re=new he(Oe,Ae);let Qe=Re.prevCodePoint();for(;Ge(Qe)||Qe===65039||Qe===8419;){if(Re.offset===0)return;Qe=Re.prevCodePoint()}if(!Y(Qe))return;let ue=Re.offset;return ue>0&&Re.prevCodePoint()===8205&&(ue=Re.offset),ue}function Ge(Ae){return 127995<=Ae&&Ae<=127999}var st;(function(Ae){Ae[Ae.zwj=8205]="zwj",Ae[Ae.emojiVariantSelector=65039]="emojiVariantSelector",Ae[Ae.enclosingKeyCap=8419]="enclosingKeyCap"})(st||(st={})),e.$wf="\xA0";class it{static getInstance(Oe){return l.d.get(Array.from(Oe))}static getLocales(){return l.e.value}constructor(Oe){this.f=Oe}isAmbiguous(Oe){return this.f.has(Oe)}getPrimaryConfusable(Oe){return this.f.get(Oe)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$xf=it,l=it,it.c=new M.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),it.d=new y.$ye(Ae=>{function Oe(Ze){const rt=new Map;for(let ht=0;ht<Ze.length;ht+=2)rt.set(Ze[ht],Ze[ht+1]);return rt}function Re(Ze,rt){const ht=new Map(Ze);for(const[pt,Dt]of rt)ht.set(pt,Dt);return ht}function Qe(Ze,rt){if(!Ze)return rt;const ht=new Map;for(const[pt,Dt]of Ze)rt.has(pt)&&ht.set(pt,Dt);return ht}const ue=l.c.value;let ae=Ae.filter(Ze=>!Ze.startsWith("_")&&Ze in ue);ae.length===0&&(ae=["_default"]);let Pe;for(const Ze of ae){const rt=Oe(ue[Ze]);Pe=Qe(Pe,rt)}const Ke=Oe(ue._common),Ue=Re(Ke,Pe);return new l(Ue)}),it.e=new M.$V(()=>Object.keys(l.c.value).filter(Ae=>!Ae.startsWith("_")));class nt{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static e(){return this.d||(this.d=new Set(nt.c())),this.d}static isInvisibleCharacter(Oe){return nt.e().has(Oe)}static get codePoints(){return nt.e()}}e.$yf=nt,nt.d=void 0}),define(De[123],Ce([1,0,28,16]),function(re,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sj=e.$Rj=e.$Qj=e.$Pj=e.FuzzyScore=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.or=void 0;function l(...te){return function(me,we){for(let Ie=0,W=te.length;Ie<W;Ie++){const J=te[Ie](me,we);if(J)return J}return null}}e.or=l,e.$Dj=L.bind(void 0,!1),e.$Ej=L.bind(void 0,!0);function L(te,me,we){if(!we||we.length<me.length)return null;let Ie;return te?Ie=M.$4e(we,me):Ie=we.indexOf(me)===0,Ie?me.length>0?[{start:0,end:me.length}]:[]:null}function A(te,me){const we=me.toLowerCase().indexOf(te.toLowerCase());return we===-1?null:[{start:we,end:we+te.length}]}e.$Fj=A;function g(te,me){return k(te.toLowerCase(),me.toLowerCase(),0,0)}e.$Gj=g;function k(te,me,we,Ie){if(we===te.length)return[];if(Ie===me.length)return null;if(te[we]===me[Ie]){let W=null;return(W=k(te,me,we+1,Ie+1))?u({start:Ie,end:Ie+1},W):null}return k(te,me,we,Ie+1)}function $(te){return 97<=te&&te<=122}function R(te){return 65<=te&&te<=90}e.$Hj=R;function P(te){return 48<=te&&te<=57}function p(te){return te===32||te===9||te===10||te===13}const S=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(te=>S.add(te.charCodeAt(0)));function D(te){return p(te)||S.has(te)}function E(te,me){return te===me||D(te)&&D(me)}function h(te){return $(te)||R(te)||P(te)}function u(te,me){return me.length===0?me=[te]:te.end===me[0].start?me[0].start=te.start:me.unshift(te),me}function d(te,me){for(let we=me;we<te.length;we++){const Ie=te.charCodeAt(we);if(R(Ie)||P(Ie)||we>0&&!h(te.charCodeAt(we-1)))return we}return te.length}function c(te,me,we,Ie){if(we===te.length)return[];if(Ie===me.length)return null;if(te[we]!==me[Ie].toLowerCase())return null;{let W=null,J=Ie+1;for(W=c(te,me,we+1,Ie+1);!W&&(J=d(me,J))<me.length;)W=c(te,me,we+1,J),J++;return W===null?null:u({start:Ie,end:Ie+1},W)}}function f(te){let me=0,we=0,Ie=0,W=0,J=0;for(let ve=0;ve<te.length;ve++)J=te.charCodeAt(ve),R(J)&&me++,$(J)&&we++,h(J)&&Ie++,P(J)&&W++;const ce=me/te.length,de=we/te.length,ee=Ie/te.length,$e=W/te.length;return{upperPercent:ce,lowerPercent:de,alphaPercent:ee,numericPercent:$e}}function a(te){const{upperPercent:me,lowerPercent:we}=te;return we===0&&me>.6}function t(te){const{upperPercent:me,lowerPercent:we,alphaPercent:Ie,numericPercent:W}=te;return we>.2&&me<.8&&Ie>.6&&W<.2}function i(te){let me=0,we=0,Ie=0,W=0;for(let J=0;J<te.length;J++)Ie=te.charCodeAt(J),R(Ie)&&me++,$(Ie)&&we++,p(Ie)&&W++;return(me===0||we===0)&&W===0?te.length<=30:me<=5}function s(te,me){if(!me||(me=me.trim(),me.length===0)||!i(te)||me.length>60)return null;const we=f(me);if(!t(we)){if(!a(we))return null;me=me.toLowerCase()}let Ie=null,W=0;for(te=te.toLowerCase();W<me.length&&(Ie=c(te,me,0,W))===null;)W=d(me,W+1);return Ie}e.$Ij=s;function n(te,me,we=!1){if(!me||me.length===0)return null;let Ie=null,W=0;for(te=te.toLowerCase(),me=me.toLowerCase();W<me.length&&(Ie=r(te,me,0,W,we))===null;)W=o(me,W+1);return Ie}e.$Jj=n;function r(te,me,we,Ie,W){if(we===te.length)return[];if(Ie===me.length)return null;if(E(te.charCodeAt(we),me.charCodeAt(Ie))){let J=null,ce=Ie+1;if(J=r(te,me,we+1,Ie+1,W),!W)for(;!J&&(ce=o(me,ce))<me.length;)J=r(te,me,we+1,ce,W),ce++;return J?te.charCodeAt(we)!==me.charCodeAt(Ie)?J:u({start:Ie,end:Ie+1},J):null}else return null}function o(te,me){for(let we=me;we<te.length;we++)if(D(te.charCodeAt(we))||we>0&&D(te.charCodeAt(we-1)))return we;return te.length}const v=l(e.$Ej,s,A),C=l(e.$Ej,s,g),w=new y.$Dc(1e4);function m(te,me,we=!1){if(typeof te!="string"||typeof me!="string")return null;let Ie=w.get(te);Ie||(Ie=new RegExp(M.$Me(te),"i"),w.set(te,Ie));const W=Ie.exec(me);return W?[{start:W.index,end:W.index+W[0].length}]:we?C(te,me):v(te,me)}e.$Kj=m;function b(te,me){const we=H(te,te.toLowerCase(),0,me,me.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return we?z(we):null}e.$Lj=b;function I(te,me,we,Ie,W,J){const ce=Math.min(13,te.length);for(;we<ce;we++){const de=H(te,me,we,Ie,W,J,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(de)return de}return[0,J]}e.$Mj=I;function z(te){if(typeof te>"u")return[];const me=[],we=te[1];for(let Ie=te.length-1;Ie>1;Ie--){const W=te[Ie]+we,J=me[me.length-1];J&&J.end===W?J.end=W+1:me.push({start:W,end:W+1})}return me}e.$Nj=z;const O=128;function F(){const te=[],me=[];for(let we=0;we<=O;we++)me[we]=0;for(let we=0;we<=O;we++)te.push(me.slice(0));return te}function T(te){const me=[];for(let we=0;we<=te;we++)me[we]=0;return me}const N=T(2*O),j=T(2*O),U=F(),B=F(),he=F(),x=!1;function Q(te,me,we,Ie,W){function J(de,ee,$e=" "){for(;de.length<ee;)de=$e+de;return de}let ce=` |   |${Ie.split("").map(de=>J(de,3)).join("|")}
`;for(let de=0;de<=we;de++)de===0?ce+=" |":ce+=`${me[de-1]}|`,ce+=te[de].slice(0,W+1).map(ee=>J(ee.toString(),3)).join("|")+`
`;return ce}function Z(te,me,we,Ie){te=te.substr(me),we=we.substr(Ie),console.log(Q(B,te,te.length,we,we.length)),console.log(Q(he,te,te.length,we,we.length)),console.log(Q(U,te,te.length,we,we.length))}function ie(te,me){if(me<0||me>=te.length)return!1;const we=te.codePointAt(me);switch(we){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!M.$jf(we)}}function _(te,me){if(me<0||me>=te.length)return!1;switch(te.charCodeAt(me)){case 32:case 9:return!0;default:return!1}}function oe(te,me,we){return me[te]!==we[te]}function ye(te,me,we,Ie,W,J,ce=!1){for(;me<we&&W<J;)te[me]===Ie[W]&&(ce&&(N[me]=W),me+=1),W+=1;return me===we}e.$Oj=ye;var fe;(function(te){te[te.Diag=1]="Diag",te[te.Left=2]="Left",te[te.LeftLeft=3]="LeftLeft"})(fe||(fe={}));var V;(function(te){te.Default=[-100,0];function me(we){return!we||we.length===2&&we[0]===-100&&we[1]===0}te.isDefault=me})(V||(e.FuzzyScore=V={}));class le{constructor(me,we){this.firstMatchCanBeWeak=me,this.boostFullMatch=we}}e.$Pj=le,le.default={boostFullMatch:!0,firstMatchCanBeWeak:!1};function H(te,me,we,Ie,W,J,ce=le.default){const de=te.length>O?O:te.length,ee=Ie.length>O?O:Ie.length;if(we>=de||J>=ee||de-we>ee-J||!ye(me,we,de,W,J,ee,!0))return;G(de,ee,we,J,me,W);let $e=1,ve=1,Ne=we,qe=J;const xe=[!1];for($e=1,Ne=we;Ne<de;$e++,Ne++){const Ae=N[Ne],Oe=j[Ne],Re=Ne+1<de?j[Ne+1]:ee;for(ve=Ae-J+1,qe=Ae;qe<Re;ve++,qe++){let Qe=Number.MIN_SAFE_INTEGER,ue=!1;qe<=Oe&&(Qe=Y(te,me,Ne,we,Ie,W,qe,ee,J,U[$e-1][ve-1]===0,xe));let ae=0;Qe!==Number.MAX_SAFE_INTEGER&&(ue=!0,ae=Qe+B[$e-1][ve-1]);const Pe=qe>Ae,Ke=Pe?B[$e][ve-1]+(U[$e][ve-1]>0?-5:0):0,Ue=qe>Ae+1&&U[$e][ve-1]>0,Ze=Ue?B[$e][ve-2]+(U[$e][ve-2]>0?-5:0):0;if(Ue&&(!Pe||Ze>=Ke)&&(!ue||Ze>=ae))B[$e][ve]=Ze,he[$e][ve]=3,U[$e][ve]=0;else if(Pe&&(!ue||Ke>=ae))B[$e][ve]=Ke,he[$e][ve]=2,U[$e][ve]=0;else if(ue)B[$e][ve]=ae,he[$e][ve]=1,U[$e][ve]=U[$e-1][ve-1]+1;else throw new Error("not possible")}}if(x&&Z(te,we,Ie,J),!xe[0]&&!ce.firstMatchCanBeWeak)return;$e--,ve--;const Ge=[B[$e][ve],J];let st=0,it=0;for(;$e>=1;){let Ae=ve;do{const Oe=he[$e][Ae];if(Oe===3)Ae=Ae-2;else if(Oe===2)Ae=Ae-1;else break}while(Ae>=1);st>1&&me[we+$e-1]===W[J+ve-1]&&!oe(Ae+J-1,Ie,W)&&st+1>U[$e][Ae]&&(Ae=ve),Ae===ve?st++:st=1,it||(it=Ae),$e--,ve=Ae-1,Ge.push(ve)}ee===de&&ce.boostFullMatch&&(Ge[0]+=2);const nt=it-de;return Ge[0]-=nt,Ge}e.$Qj=H;function G(te,me,we,Ie,W,J){let ce=te-1,de=me-1;for(;ce>=we&&de>=Ie;)W[ce]===J[de]&&(j[ce]=de,ce--),de--}function Y(te,me,we,Ie,W,J,ce,de,ee,$e,ve){if(me[we]!==J[ce])return Number.MIN_SAFE_INTEGER;let Ne=1,qe=!1;return ce===we-Ie?Ne=te[we]===W[ce]?7:5:oe(ce,W,J)&&(ce===0||!oe(ce-1,W,J))?(Ne=te[we]===W[ce]?7:5,qe=!0):ie(J,ce)&&(ce===0||!ie(J,ce-1))?Ne=5:(ie(J,ce-1)||_(J,ce-1))&&(Ne=5,qe=!0),Ne>1&&we===Ie&&(ve[0]=!0),qe||(qe=oe(ce,W,J)||ie(J,ce-1)||_(J,ce-1)),we===Ie?ce>ee&&(Ne-=qe?3:5):$e?Ne+=qe?2:0:Ne+=qe?0:1,ce+1===de&&(Ne-=qe?3:5),Ne}function X(te,me,we,Ie,W,J,ce){return se(te,me,we,Ie,W,J,!0,ce)}e.$Rj=X;function be(te,me,we,Ie,W,J,ce){return se(te,me,we,Ie,W,J,!1,ce)}e.$Sj=be;function se(te,me,we,Ie,W,J,ce,de){let ee=H(te,me,we,Ie,W,J,de);if(ee&&!ce)return ee;if(te.length>=3){const $e=Math.min(7,te.length-1);for(let ve=we+1;ve<$e;ve++){const Ne=ge(te,ve);if(Ne){const qe=H(Ne,Ne.toLowerCase(),we,Ie,W,J,de);qe&&(qe[0]-=3,(!ee||qe[0]>ee[0])&&(ee=qe))}}}return ee}function ge(te,me){if(me+1>=te.length)return;const we=te[me],Ie=te[me+1];if(we!==Ie)return te.slice(0,me)+Ie+we+te.slice(me+2)}}),define(De[52],Ce([1,0,16]),function(re,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ki=e.$Ji=e.$Ii=e.$Hi=e.$Gi=e.$Fi=e.$Ei=void 0;function M(u){return l(u,0)}e.$Ei=M;function l(u,d){switch(typeof u){case"object":return u===null?L(349,d):Array.isArray(u)?k(u,d):$(u,d);case"string":return g(u,d);case"boolean":return A(u,d);case"number":return L(u,d);case"undefined":return L(937,d);default:return L(617,d)}}e.$Fi=l;function L(u,d){return(d<<5)-d+u|0}e.$Gi=L;function A(u,d){return L(u?433:863,d)}function g(u,d){d=L(149417,d);for(let c=0,f=u.length;c<f;c++)d=L(u.charCodeAt(c),d);return d}e.$Hi=g;function k(u,d){return d=L(104579,d),u.reduce((c,f)=>l(f,c),d)}function $(u,d){return d=L(181387,d),Object.keys(u).sort().reduce((c,f)=>(c=g(f,c),l(u[f],c)),d)}class R{constructor(){this.g=0}get value(){return this.g}hash(d){return this.g=l(d,this.g),this.g}}e.$Ii=R;var P;(function(u){u[u.BLOCK_SIZE=64]="BLOCK_SIZE",u[u.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(P||(P={}));function p(u,d,c=32){const f=c-d,a=~((1<<f)-1);return(u<<d|(a&u)>>>f)>>>0}function S(u,d=0,c=u.byteLength,f=0){for(let a=0;a<c;a++)u[d+a]=f}function D(u,d,c="0"){for(;u.length<d;)u=c+u;return u}function E(u,d=32){return u instanceof ArrayBuffer?Array.from(new Uint8Array(u)).map(c=>c.toString(16).padStart(2,"0")).join(""):D((u>>>0).toString(16),d/4)}e.$Ji=E;class h{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(d){const c=d.length;if(c===0)return;const f=this.p;let a=this.r,t=this.u,i,s;for(t!==0?(i=t,s=-1,t=0):(i=d.charCodeAt(0),s=0);;){let n=i;if(y.$7e(i))if(s+1<c){const r=d.charCodeAt(s+1);y.$8e(r)?(s++,n=y.$9e(i,r)):n=65533}else{t=i;break}else y.$8e(i)&&(n=65533);if(a=this.w(f,a,n),s++,s<c)i=d.charCodeAt(s);else break}this.r=a,this.u=t}w(d,c,f){return f<128?d[c++]=f:f<2048?(d[c++]=192|(f&1984)>>>6,d[c++]=128|(f&63)>>>0):f<65536?(d[c++]=224|(f&61440)>>>12,d[c++]=128|(f&4032)>>>6,d[c++]=128|(f&63)>>>0):(d[c++]=240|(f&1835008)>>>18,d[c++]=128|(f&258048)>>>12,d[c++]=128|(f&4032)>>>6,d[c++]=128|(f&63)>>>0),c>=64&&(this.y(),c-=64,this.t+=64,d[0]=d[64+0],d[1]=d[64+1],d[2]=d[64+2]),c}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),E(this.h)+E(this.l)+E(this.m)+E(this.n)+E(this.o)}x(){this.p[this.r++]=128,S(this.p,this.r),this.r>56&&(this.y(),S(this.p));const d=8*this.t;this.q.setUint32(56,Math.floor(d/4294967296),!1),this.q.setUint32(60,d%4294967296,!1),this.y()}y(){const d=h.g,c=this.q;for(let v=0;v<64;v+=4)d.setUint32(v,c.getUint32(v,!1),!1);for(let v=64;v<320;v+=4)d.setUint32(v,p(d.getUint32(v-12,!1)^d.getUint32(v-32,!1)^d.getUint32(v-56,!1)^d.getUint32(v-64,!1),1),!1);let f=this.h,a=this.l,t=this.m,i=this.n,s=this.o,n,r,o;for(let v=0;v<80;v++)v<20?(n=a&t|~a&i,r=1518500249):v<40?(n=a^t^i,r=1859775393):v<60?(n=a&t|a&i|t&i,r=2400959708):(n=a^t^i,r=3395469782),o=p(f,5)+n+s+r+d.getUint32(v*4,!1)&4294967295,s=i,i=t,t=p(a,30),a=f,f=o;this.h=this.h+f&4294967295,this.l=this.l+a&4294967295,this.m=this.m+t&4294967295,this.n=this.n+i&4294967295,this.o=this.o+s&4294967295}}e.$Ki=h,h.g=new DataView(new ArrayBuffer(320))}),define(De[124],Ce([1,0,122,123,52,15,12,16]),function(re,e,y,M,l,L,A,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eq=e.$Dq=e.$Cq=e.$Bq=e.$Aq=e.$zq=void 0;const k=0,$=[k,[]];function R(U,B,he,x){if(!U||!B)return $;const Q=U.length,Z=B.length;if(Q<Z)return $;const ie=U.toLowerCase();return P(B,he,Z,U,ie,Q,x)}e.$zq=R;function P(U,B,he,x,Q,Z,ie){const _=[],oe=[];for(let le=0;le<he;le++){const H=le*Z,G=H-Z,Y=le>0,X=U[le],be=B[le];for(let se=0;se<Z;se++){const ge=se>0,te=H+se,me=te-1,we=G+se-1,Ie=ge?_[me]:0,W=Y&&ge?_[we]:0,J=Y&&ge?oe[we]:0;let ce;!W&&Y?ce=0:ce=p(X,be,x,Q,se,J),ce&&W+ce>=Ie&&(ie||Y||Q.startsWith(B,se))?(oe[te]=J+1,_[te]=W+ce):(oe[te]=k,_[te]=Ie)}}const ye=[];let fe=he-1,V=Z-1;for(;fe>=0&&V>=0;){const le=fe*Z+V;oe[le]===k||(ye.push(V),fe--),V--}return[_[he*Z-1],ye.reverse()]}function p(U,B,he,x,Q,Z){let ie=0;if(!S(B,x[Q]))return ie;if(ie+=1,Z>0&&(ie+=Z*5),U===he[Q]&&(ie+=1),Q===0)ie+=8;else{const _=D(he.charCodeAt(Q-1));_?ie+=_:(0,M.$Hj)(he.charCodeAt(Q))&&Z===0&&(ie+=2)}return ie}function S(U,B){return U===B?!0:U==="/"||U==="\\"?B==="/"||B==="\\":!1}function D(U){switch(U){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const E=[void 0,[]];function h(U,B,he=0,x=0){const Q=B;return Q.values&&Q.values.length>1?u(U,Q.values,he,x):d(U,B,he,x)}e.$Aq=h;function u(U,B,he,x){let Q=0;const Z=[];for(const ie of B){const[_,oe]=d(U,ie,he,x);if(typeof _!="number")return E;Q+=_,Z.push(...oe)}return[Q,C(Z)]}function d(U,B,he,x){const Q=(0,M.$Qj)(B.original,B.originalLowercase,he,U,U.toLowerCase(),x,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Q?[Q[0],(0,M.$Nj)(Q)]:E}const c=Object.freeze({score:0}),f=1<<18,a=1<<17,t=1<<16;function i(U,B,he,x){const Q=x.values?x.values:[x];return(0,l.$Ei)({[x.normalized]:{values:Q.map(ie=>({value:ie.normalized,expectContiguousMatch:ie.expectContiguousMatch})),label:U,description:B,allowNonContiguousMatches:he}})}function s(U,B,he,x,Q){if(!U||!B.normalized)return c;const Z=x.getItemLabel(U);if(!Z)return c;const ie=x.getItemDescription(U),_=i(Z,ie,he,B),oe=Q[_];if(oe)return oe;const ye=n(Z,ie,x.getItemPath(U),B,he);return Q[_]=ye,ye}e.$Bq=s;function n(U,B,he,x,Q){const Z=!he||!x.containsPathSeparator;return he&&(A.$f?x.pathNormalized===he:(0,g.$3e)(x.pathNormalized,he))?{score:f,labelMatch:[{start:0,end:U.length}],descriptionMatch:B?[{start:0,end:B.length}]:void 0}:x.values&&x.values.length>1?r(U,B,he,x.values,Z,Q):o(U,B,he,x,Z,Q)}function r(U,B,he,x,Q,Z){let ie=0;const _=[],oe=[];for(const ye of x){const{score:fe,labelMatch:V,descriptionMatch:le}=o(U,B,he,ye,Q,Z);if(fe===k)return c;ie+=fe,V&&_.push(...V),le&&oe.push(...le)}return{score:ie,labelMatch:C(_),descriptionMatch:C(oe)}}function o(U,B,he,x,Q,Z){if(Q||!B){const[ie,_]=R(U,x.normalized,x.normalizedLowercase,Z&&!x.expectContiguousMatch);if(ie){const oe=(0,M.$Ej)(x.normalized,U);let ye;if(oe){ye=a;const fe=Math.round(x.normalized.length/U.length*100);ye+=fe}else ye=t;return{score:ye+ie,labelMatch:oe||v(_)}}}if(B){let ie=B;he&&(ie=`${B}${L.sep}`);const _=ie.length,oe=`${ie}${U}`,[ye,fe]=R(oe,x.normalized,x.normalizedLowercase,Z&&!x.expectContiguousMatch);if(ye){const V=v(fe),le=[],H=[];return V.forEach(G=>{G.start<_&&G.end>_?(le.push({start:0,end:G.end-_}),H.push({start:G.start,end:_})):G.start>=_?le.push({start:G.start-_,end:G.end-_}):H.push(G)}),{score:ye,labelMatch:le,descriptionMatch:H}}}return c}function v(U){const B=[];if(!U)return B;let he;for(const x of U)he&&he.end===x?he.end+=1:(he={start:x,end:x+1},B.push(he));return B}function C(U){const B=U.sort((Q,Z)=>Q.start-Z.start),he=[];let x;for(const Q of B)!x||!w(x,Q)?(x=Q,he.push(Q)):(x.start=Math.min(x.start,Q.start),x.end=Math.max(x.end,Q.end));return he}function w(U,B){return!(U.end<B.start||B.end<U.start)}function m(U,B,he,x,Q,Z){const ie=s(U,he,x,Q,Z),_=s(B,he,x,Q,Z),oe=ie.score,ye=_.score;if((oe===f||ye===f)&&oe!==ye)return oe===f?-1:1;if(oe>t||ye>t){if(oe!==ye)return oe>ye?-1:1;if(oe<a&&ye<a){const X=I(ie.labelMatch,_.labelMatch);if(X!==0)return X}const G=Q.getItemLabel(U)||"",Y=Q.getItemLabel(B)||"";if(G.length!==Y.length)return G.length-Y.length}if(oe!==ye)return oe>ye?-1:1;const fe=Array.isArray(ie.labelMatch)&&ie.labelMatch.length>0,V=Array.isArray(_.labelMatch)&&_.labelMatch.length>0;if(fe&&!V)return-1;if(V&&!fe)return 1;const le=b(U,ie,Q),H=b(B,_,Q);return le&&H&&le!==H?H>le?-1:1:z(U,B,he,Q)}e.$Cq=m;function b(U,B,he){let x=-1,Q=-1;if(B.descriptionMatch&&B.descriptionMatch.length?x=B.descriptionMatch[0].start:B.labelMatch&&B.labelMatch.length&&(x=B.labelMatch[0].start),B.labelMatch&&B.labelMatch.length){if(Q=B.labelMatch[B.labelMatch.length-1].end,B.descriptionMatch&&B.descriptionMatch.length){const Z=he.getItemDescription(U);Z&&(Q+=Z.length)}}else B.descriptionMatch&&B.descriptionMatch.length&&(Q=B.descriptionMatch[B.descriptionMatch.length-1].end);return Q-x}function I(U,B){if(!U&&!B||(!U||!U.length)&&(!B||!B.length))return 0;if(!B||!B.length)return-1;if(!U||!U.length)return 1;const he=U[0].start,Q=U[U.length-1].end-he,Z=B[0].start,_=B[B.length-1].end-Z;return Q===_?0:_<Q?1:-1}function z(U,B,he,x){const Q=x.getItemLabel(U)||"",Z=x.getItemLabel(B)||"",ie=x.getItemDescription(U),_=x.getItemDescription(B),oe=Q.length+(ie?ie.length:0),ye=Z.length+(_?_.length:0);if(oe!==ye)return oe-ye;const fe=x.getItemPath(U),V=x.getItemPath(B);return fe&&V&&fe.length!==V.length?fe.length-V.length:Q!==Z?(0,y.$xq)(Q,Z,he.normalized):ie&&_&&ie!==_?(0,y.$xq)(ie,_,he.normalized):fe&&V&&fe!==V?(0,y.$xq)(fe,V,he.normalized):0}function O(U){return U.startsWith('"')&&U.endsWith('"')}const F=" ";function T(U){typeof U!="string"&&(U="");const B=U.toLowerCase(),{pathNormalized:he,normalized:x,normalizedLowercase:Q}=N(U),Z=he.indexOf(L.sep)>=0,ie=O(U);let _;const oe=U.split(F);if(oe.length>1)for(const ye of oe){const fe=O(ye),{pathNormalized:V,normalized:le,normalizedLowercase:H}=N(ye);le&&(_||(_=[]),_.push({original:ye,originalLowercase:ye.toLowerCase(),pathNormalized:V,normalized:le,normalizedLowercase:H,expectContiguousMatch:fe}))}return{original:U,originalLowercase:B,pathNormalized:he,normalized:x,normalizedLowercase:Q,values:_,containsPathSeparator:Z,expectContiguousMatch:ie}}e.$Dq=T;function N(U){let B;A.$d?B=U.replace(/\//g,L.sep):B=U.replace(/\\/g,L.sep);const he=(0,g.$Ne)(B).replace(/\s|"/g,"");return{pathNormalized:B,normalized:he,normalizedLowercase:he.toLowerCase()}}function j(U){return Array.isArray(U)?T(U.map(B=>B.original).join(F)):T(U.original)}e.$Eq=j}),define(De[39],Ce([1,0,16]),function(re,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var M;(function(l){l[l.Ignore=0]="Ignore",l[l.Info=1]="Info",l[l.Warning=2]="Warning",l[l.Error=3]="Error"})(M||(M={})),function(l){const L="error",A="warning",g="warn",k="info",$="ignore";function R(p){return p?y.$3e(L,p)?l.Error:y.$3e(A,p)||y.$3e(g,p)?l.Warning:y.$3e(k,p)?l.Info:l.Ignore:l.Ignore}l.fromValue=R;function P(p){switch(p){case l.Error:return L;case l.Warning:return A;case l.Info:return k;default:return $}}l.toString=P}(M||(M={})),e.default=M}),define(De[161],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ld=void 0,e.$Ld=Symbol("MicrotaskDelay")}),define(De[78],Ce([1,0,19,16]),function(re,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wh=e.$Vh=e.$Uh=e.$Th=e.$Sh=void 0;class l{constructor(){this.b="",this.c=0}reset(S){return this.b=S,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(S){const D=S.charCodeAt(0),E=this.b.charCodeAt(this.c);return D-E}value(){return this.b[this.c]}}e.$Sh=l;class L{constructor(S=!0){this.e=S}reset(S){return this.b=S,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let S=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(S)this.c++;else break;else S=!1;return this}cmp(S){return this.e?(0,M.$We)(S,this.b,0,S.length,this.c,this.d):(0,M.$Ye)(S,this.b,0,S.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Th=L;class A{constructor(S=!0,D=!0){this.f=S,this.g=D}reset(S){this.d=0,this.e=0,this.b=S,this.c=S.length;for(let D=S.length-1;D>=0;D--,this.c--){const E=this.b.charCodeAt(D);if(!(E===47||this.f&&E===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let S=!0;for(;this.e<this.c;this.e++){const D=this.b.charCodeAt(this.e);if(D===47||this.f&&D===92)if(S)this.d++;else break;else S=!1}return this}cmp(S){return this.g?(0,M.$We)(S,this.b,0,S.length,this.d,this.e):(0,M.$Ye)(S,this.b,0,S.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Uh=A;var g;(function(p){p[p.Scheme=1]="Scheme",p[p.Authority=2]="Authority",p[p.Path=3]="Path",p[p.Query=4]="Query",p[p.Fragment=5]="Fragment"})(g||(g={}));class k{constructor(S,D){this.f=S,this.g=D,this.d=[],this.e=0}reset(S){return this.c=S,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new A(!1,!this.f(S)),this.b.reset(S.path),this.b.value()&&this.d.push(3)),this.g(S)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(S){if(this.d[this.e]===1)return(0,M.$Xe)(S,this.c.scheme);if(this.d[this.e]===2)return(0,M.$Xe)(S,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(S);if(this.d[this.e]===4)return(0,M.$Ve)(S,this.c.query);if(this.d[this.e]===5)return(0,M.$Ve)(S,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$Vh=k;class ${constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const S=this.right;return this.right=S.left,S.left=this,this.updateHeight(),S.updateHeight(),S}rotateRight(){const S=this.left;return this.left=S.right,S.right=this,this.updateHeight(),S.updateHeight(),S}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var R;(function(p){p[p.Left=-1]="Left",p[p.Mid=0]="Mid",p[p.Right=1]="Right"})(R||(R={}));class P{static forUris(S=()=>!1,D=()=>!1){return new P(new k(S,D))}static forPaths(S=!1){return new P(new A(void 0,!S))}static forStrings(){return new P(new l)}static forConfigKeys(){return new P(new L)}constructor(S){this.b=S}clear(){this.c=void 0}fill(S,D){if(D){const E=D.slice(0);(0,y.$Xb)(E);for(const h of E)this.set(h,S)}else{const E=S.slice(0);(0,y.$Xb)(E);for(const h of E)this.set(h[0],h[1])}}set(S,D){const E=this.b.reset(S);let h;this.c||(this.c=new $,this.c.segment=E.value());const u=[];for(h=this.c;;){const c=E.cmp(h.segment);if(c>0)h.left||(h.left=new $,h.left.segment=E.value()),u.push([-1,h]),h=h.left;else if(c<0)h.right||(h.right=new $,h.right.segment=E.value()),u.push([1,h]),h=h.right;else if(E.hasNext())E.next(),h.mid||(h.mid=new $,h.mid.segment=E.value()),u.push([0,h]),h=h.mid;else break}const d=h.value;h.value=D,h.key=S;for(let c=u.length-1;c>=0;c--){const f=u[c][1];f.updateHeight();const a=f.balanceFactor();if(a<-1||a>1){const t=u[c][0],i=u[c+1][0];if(t===1&&i===1)u[c][1]=f.rotateLeft();else if(t===-1&&i===-1)u[c][1]=f.rotateRight();else if(t===1&&i===-1)f.right=u[c+1][1]=u[c+1][1].rotateRight(),u[c][1]=f.rotateLeft();else if(t===-1&&i===1)f.left=u[c+1][1]=u[c+1][1].rotateLeft(),u[c][1]=f.rotateRight();else throw new Error;if(c>0)switch(u[c-1][0]){case-1:u[c-1][1].left=u[c][1];break;case 1:u[c-1][1].right=u[c][1];break;case 0:u[c-1][1].mid=u[c][1];break}else this.c=u[0][1]}}return d}get(S){return this.d(S)?.value}d(S){const D=this.b.reset(S);let E=this.c;for(;E;){const h=D.cmp(E.segment);if(h>0)E=E.left;else if(h<0)E=E.right;else if(D.hasNext())D.next(),E=E.mid;else break}return E}has(S){const D=this.d(S);return!(D?.value===void 0&&D?.mid===void 0)}delete(S){return this.e(S,!1)}deleteSuperstr(S){return this.e(S,!0)}e(S,D){const E=this.b.reset(S),h=[];let u=this.c;for(;u;){const d=E.cmp(u.segment);if(d>0)h.push([-1,u]),u=u.left;else if(d<0)h.push([1,u]),u=u.right;else if(E.hasNext())E.next(),h.push([0,u]),u=u.mid;else break}if(u){if(D?(u.left=void 0,u.mid=void 0,u.right=void 0,u.height=1):(u.key=void 0,u.value=void 0),!u.mid&&!u.value)if(u.left&&u.right){const d=this.f(u.right);if(d.key){const{key:c,value:f,segment:a}=d;this.e(d.key,!1),u.key=c,u.value=f,u.segment=a}}else{const d=u.left??u.right;if(h.length>0){const[c,f]=h[h.length-1];switch(c){case-1:f.left=d;break;case 0:f.mid=d;break;case 1:f.right=d;break}}else this.c=d}for(let d=h.length-1;d>=0;d--){const c=h[d][1];c.updateHeight();const f=c.balanceFactor();if(f>1?(c.right.balanceFactor()>=0||(c.right=c.right.rotateRight()),h[d][1]=c.rotateLeft()):f<-1&&(c.left.balanceFactor()<=0||(c.left=c.left.rotateLeft()),h[d][1]=c.rotateRight()),d>0)switch(h[d-1][0]){case-1:h[d-1][1].left=h[d][1];break;case 1:h[d-1][1].right=h[d][1];break;case 0:h[d-1][1].mid=h[d][1];break}else this.c=h[0][1]}}}f(S){for(;S.left;)S=S.left;return S}findSubstr(S){const D=this.b.reset(S);let E=this.c,h;for(;E;){const u=D.cmp(E.segment);if(u>0)E=E.left;else if(u<0)E=E.right;else if(D.hasNext())D.next(),h=E.value||h,E=E.mid;else break}return E&&E.value||h}findSuperstr(S){return this.g(S,!1)}g(S,D){const E=this.b.reset(S);let h=this.c;for(;h;){const u=E.cmp(h.segment);if(u>0)h=h.left;else if(u<0)h=h.right;else if(E.hasNext())E.next(),h=h.mid;else return h.mid?this.h(h.mid):D?h.value:void 0}}hasElementOrSubtree(S){return this.g(S,!0)!==void 0}forEach(S){for(const[D,E]of this)S(E,D)}*[Symbol.iterator](){yield*this.h(this.c)}h(S){const D=[];return this.j(S,D),D[Symbol.iterator]()}j(S,D){S&&(S.left&&this.j(S.left,D),S.value&&D.push([S.key,S.value]),S.mid&&this.j(S.mid,D),S.right&&this.j(S.right,D))}_isBalanced(){const S=D=>{if(!D)return!0;const E=D.balanceFactor();return E<-1||E>1?!1:S(D.left)&&S(D.right)};return S(this.c)}}e.$Wh=P}),define(De[17],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qf=e.$Pf=e.$Of=e.$Nf=e.$Mf=e.$Lf=e.$Kf=e.$Jf=e.$If=e.$Hf=e.$Gf=e.$Ff=e.$Ef=e.$Df=e.$Cf=e.$Bf=e.$Af=e.$zf=void 0;function y(a){return typeof a=="string"}e.$zf=y;function M(a){return Array.isArray(a)&&a.every(t=>y(t))}e.$Af=M;function l(a){return typeof a=="object"&&a!==null&&!Array.isArray(a)&&!(a instanceof RegExp)&&!(a instanceof Date)}e.$Bf=l;function L(a){const t=Object.getPrototypeOf(Uint8Array);return typeof a=="object"&&a instanceof t}e.$Cf=L;function A(a){return typeof a=="number"&&!isNaN(a)}e.$Df=A;function g(a){return!!a&&typeof a[Symbol.iterator]=="function"}e.$Ef=g;function k(a){return a===!0||a===!1}e.$Ff=k;function $(a){return typeof a>"u"}e.$Gf=$;function R(a){return!P(a)}e.$Hf=R;function P(a){return $(a)||a===null}e.$If=P;function p(a,t){if(!a)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}e.$Jf=p;function S(a){if(P(a))throw new Error("Assertion Failed: argument is undefined or null");return a}e.$Kf=S;function D(...a){const t=[];for(let i=0;i<a.length;i++){const s=a[i];if(P(s))throw new Error(`Assertion Failed: argument at index ${i} is undefined or null`);t.push(s)}return t}e.$Lf=D;const E=Object.prototype.hasOwnProperty;function h(a){if(!l(a))return!1;for(const t in a)if(E.call(a,t))return!1;return!0}e.$Mf=h;function u(a){return typeof a=="function"}e.$Nf=u;function d(...a){return a.length>0&&a.every(u)}e.$Of=d;function c(a,t){const i=Math.min(a.length,t.length);for(let s=0;s<i;s++)f(a[s],t[s])}e.$Pf=c;function f(a,t){if(y(t)){if(typeof a!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(u(t)){try{if(a instanceof t)return}catch{}if(!P(a)&&a.constructor===t||t.length===1&&t.call(void 0,a)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.$Qf=f}),define(De[79],Ce([1,0,17]),function(re,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vj=e.$Uj=e.$Tj=void 0;const M=Object.create(null);function l(g,k){if((0,y.$zf)(k)){const $=M[k];if($===void 0)throw new Error(`${g} references an unknown codicon: ${k}`);k=$}return M[g]=k,{id:g}}function L(){return M}e.$Tj=L;function A(){return Object.values(e.$Vj)}e.$Uj=A,e.$Vj={add:l("add",6e4),plus:l("plus",6e4),gistNew:l("gist-new",6e4),repoCreate:l("repo-create",6e4),lightbulb:l("lightbulb",60001),lightBulb:l("light-bulb",60001),repo:l("repo",60002),repoDelete:l("repo-delete",60002),gistFork:l("gist-fork",60003),repoForked:l("repo-forked",60003),gitPullRequest:l("git-pull-request",60004),gitPullRequestAbandoned:l("git-pull-request-abandoned",60004),recordKeys:l("record-keys",60005),keyboard:l("keyboard",60005),tag:l("tag",60006),tagAdd:l("tag-add",60006),tagRemove:l("tag-remove",60006),gitPullRequestLabel:l("git-pull-request-label",60006),person:l("person",60007),personFollow:l("person-follow",60007),personOutline:l("person-outline",60007),personFilled:l("person-filled",60007),gitBranch:l("git-branch",60008),gitBranchCreate:l("git-branch-create",60008),gitBranchDelete:l("git-branch-delete",60008),sourceControl:l("source-control",60008),mirror:l("mirror",60009),mirrorPublic:l("mirror-public",60009),star:l("star",60010),starAdd:l("star-add",60010),starDelete:l("star-delete",60010),starEmpty:l("star-empty",60010),comment:l("comment",60011),commentAdd:l("comment-add",60011),alert:l("alert",60012),warning:l("warning",60012),search:l("search",60013),searchSave:l("search-save",60013),logOut:l("log-out",60014),signOut:l("sign-out",60014),logIn:l("log-in",60015),signIn:l("sign-in",60015),eye:l("eye",60016),eyeUnwatch:l("eye-unwatch",60016),eyeWatch:l("eye-watch",60016),circleFilled:l("circle-filled",60017),primitiveDot:l("primitive-dot",60017),closeDirty:l("close-dirty",60017),debugBreakpoint:l("debug-breakpoint",60017),debugBreakpointDisabled:l("debug-breakpoint-disabled",60017),debugHint:l("debug-hint",60017),primitiveSquare:l("primitive-square",60018),edit:l("edit",60019),pencil:l("pencil",60019),info:l("info",60020),issueOpened:l("issue-opened",60020),gistPrivate:l("gist-private",60021),gitForkPrivate:l("git-fork-private",60021),lock:l("lock",60021),mirrorPrivate:l("mirror-private",60021),close:l("close",60022),removeClose:l("remove-close",60022),x:l("x",60022),repoSync:l("repo-sync",60023),sync:l("sync",60023),clone:l("clone",60024),desktopDownload:l("desktop-download",60024),beaker:l("beaker",60025),microscope:l("microscope",60025),vm:l("vm",60026),deviceDesktop:l("device-desktop",60026),file:l("file",60027),fileText:l("file-text",60027),more:l("more",60028),ellipsis:l("ellipsis",60028),kebabHorizontal:l("kebab-horizontal",60028),mailReply:l("mail-reply",60029),reply:l("reply",60029),organization:l("organization",60030),organizationFilled:l("organization-filled",60030),organizationOutline:l("organization-outline",60030),newFile:l("new-file",60031),fileAdd:l("file-add",60031),newFolder:l("new-folder",60032),fileDirectoryCreate:l("file-directory-create",60032),trash:l("trash",60033),trashcan:l("trashcan",60033),history:l("history",60034),clock:l("clock",60034),folder:l("folder",60035),fileDirectory:l("file-directory",60035),symbolFolder:l("symbol-folder",60035),logoGithub:l("logo-github",60036),markGithub:l("mark-github",60036),github:l("github",60036),terminal:l("terminal",60037),console:l("console",60037),repl:l("repl",60037),zap:l("zap",60038),symbolEvent:l("symbol-event",60038),error:l("error",60039),stop:l("stop",60039),variable:l("variable",60040),symbolVariable:l("symbol-variable",60040),array:l("array",60042),symbolArray:l("symbol-array",60042),symbolModule:l("symbol-module",60043),symbolPackage:l("symbol-package",60043),symbolNamespace:l("symbol-namespace",60043),symbolObject:l("symbol-object",60043),symbolMethod:l("symbol-method",60044),symbolFunction:l("symbol-function",60044),symbolConstructor:l("symbol-constructor",60044),symbolBoolean:l("symbol-boolean",60047),symbolNull:l("symbol-null",60047),symbolNumeric:l("symbol-numeric",60048),symbolNumber:l("symbol-number",60048),symbolStructure:l("symbol-structure",60049),symbolStruct:l("symbol-struct",60049),symbolParameter:l("symbol-parameter",60050),symbolTypeParameter:l("symbol-type-parameter",60050),symbolKey:l("symbol-key",60051),symbolText:l("symbol-text",60051),symbolReference:l("symbol-reference",60052),goToFile:l("go-to-file",60052),symbolEnum:l("symbol-enum",60053),symbolValue:l("symbol-value",60053),symbolRuler:l("symbol-ruler",60054),symbolUnit:l("symbol-unit",60054),activateBreakpoints:l("activate-breakpoints",60055),archive:l("archive",60056),arrowBoth:l("arrow-both",60057),arrowDown:l("arrow-down",60058),arrowLeft:l("arrow-left",60059),arrowRight:l("arrow-right",60060),arrowSmallDown:l("arrow-small-down",60061),arrowSmallLeft:l("arrow-small-left",60062),arrowSmallRight:l("arrow-small-right",60063),arrowSmallUp:l("arrow-small-up",60064),arrowUp:l("arrow-up",60065),bell:l("bell",60066),bold:l("bold",60067),book:l("book",60068),bookmark:l("bookmark",60069),debugBreakpointConditionalUnverified:l("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:l("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:l("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:l("debug-breakpoint-data-unverified",60072),debugBreakpointData:l("debug-breakpoint-data",60073),debugBreakpointDataDisabled:l("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:l("debug-breakpoint-log-unverified",60074),debugBreakpointLog:l("debug-breakpoint-log",60075),debugBreakpointLogDisabled:l("debug-breakpoint-log-disabled",60075),briefcase:l("briefcase",60076),broadcast:l("broadcast",60077),browser:l("browser",60078),bug:l("bug",60079),calendar:l("calendar",60080),caseSensitive:l("case-sensitive",60081),check:l("check",60082),checklist:l("checklist",60083),chevronDown:l("chevron-down",60084),dropDownButton:l("drop-down-button",60084),chevronLeft:l("chevron-left",60085),chevronRight:l("chevron-right",60086),chevronUp:l("chevron-up",60087),chromeClose:l("chrome-close",60088),chromeMaximize:l("chrome-maximize",60089),chromeMinimize:l("chrome-minimize",60090),chromeRestore:l("chrome-restore",60091),circle:l("circle",60092),circleOutline:l("circle-outline",60092),debugBreakpointUnverified:l("debug-breakpoint-unverified",60092),circleSlash:l("circle-slash",60093),circuitBoard:l("circuit-board",60094),clearAll:l("clear-all",60095),clippy:l("clippy",60096),closeAll:l("close-all",60097),cloudDownload:l("cloud-download",60098),cloudUpload:l("cloud-upload",60099),code:l("code",60100),collapseAll:l("collapse-all",60101),colorMode:l("color-mode",60102),commentDiscussion:l("comment-discussion",60103),compareChanges:l("compare-changes",60157),creditCard:l("credit-card",60105),dash:l("dash",60108),dashboard:l("dashboard",60109),database:l("database",60110),debugContinue:l("debug-continue",60111),debugDisconnect:l("debug-disconnect",60112),debugPause:l("debug-pause",60113),debugRestart:l("debug-restart",60114),debugStart:l("debug-start",60115),debugStepInto:l("debug-step-into",60116),debugStepOut:l("debug-step-out",60117),debugStepOver:l("debug-step-over",60118),debugStop:l("debug-stop",60119),debug:l("debug",60120),deviceCameraVideo:l("device-camera-video",60121),deviceCamera:l("device-camera",60122),deviceMobile:l("device-mobile",60123),diffAdded:l("diff-added",60124),diffIgnored:l("diff-ignored",60125),diffModified:l("diff-modified",60126),diffRemoved:l("diff-removed",60127),diffRenamed:l("diff-renamed",60128),diff:l("diff",60129),discard:l("discard",60130),editorLayout:l("editor-layout",60131),emptyWindow:l("empty-window",60132),exclude:l("exclude",60133),extensions:l("extensions",60134),eyeClosed:l("eye-closed",60135),fileBinary:l("file-binary",60136),fileCode:l("file-code",60137),fileMedia:l("file-media",60138),filePdf:l("file-pdf",60139),fileSubmodule:l("file-submodule",60140),fileSymlinkDirectory:l("file-symlink-directory",60141),fileSymlinkFile:l("file-symlink-file",60142),fileZip:l("file-zip",60143),files:l("files",60144),filter:l("filter",60145),flame:l("flame",60146),foldDown:l("fold-down",60147),foldUp:l("fold-up",60148),fold:l("fold",60149),folderActive:l("folder-active",60150),folderOpened:l("folder-opened",60151),gear:l("gear",60152),gift:l("gift",60153),gistSecret:l("gist-secret",60154),gist:l("gist",60155),gitCommit:l("git-commit",60156),gitCompare:l("git-compare",60157),gitMerge:l("git-merge",60158),githubAction:l("github-action",60159),githubAlt:l("github-alt",60160),globe:l("globe",60161),grabber:l("grabber",60162),graph:l("graph",60163),gripper:l("gripper",60164),heart:l("heart",60165),home:l("home",60166),horizontalRule:l("horizontal-rule",60167),hubot:l("hubot",60168),inbox:l("inbox",60169),issueClosed:l("issue-closed",60324),issueReopened:l("issue-reopened",60171),issues:l("issues",60172),italic:l("italic",60173),jersey:l("jersey",60174),json:l("json",60175),bracket:l("bracket",60175),kebabVertical:l("kebab-vertical",60176),key:l("key",60177),law:l("law",60178),lightbulbAutofix:l("lightbulb-autofix",60179),linkExternal:l("link-external",60180),link:l("link",60181),listOrdered:l("list-ordered",60182),listUnordered:l("list-unordered",60183),liveShare:l("live-share",60184),loading:l("loading",60185),location:l("location",60186),mailRead:l("mail-read",60187),mail:l("mail",60188),markdown:l("markdown",60189),megaphone:l("megaphone",60190),mention:l("mention",60191),milestone:l("milestone",60192),gitPullRequestMilestone:l("git-pull-request-milestone",60192),mortarBoard:l("mortar-board",60193),move:l("move",60194),multipleWindows:l("multiple-windows",60195),mute:l("mute",60196),noNewline:l("no-newline",60197),note:l("note",60198),octoface:l("octoface",60199),openPreview:l("open-preview",60200),package:l("package",60201),paintcan:l("paintcan",60202),pin:l("pin",60203),play:l("play",60204),run:l("run",60204),plug:l("plug",60205),preserveCase:l("preserve-case",60206),preview:l("preview",60207),project:l("project",60208),pulse:l("pulse",60209),question:l("question",60210),quote:l("quote",60211),radioTower:l("radio-tower",60212),reactions:l("reactions",60213),references:l("references",60214),refresh:l("refresh",60215),regex:l("regex",60216),remoteExplorer:l("remote-explorer",60217),remote:l("remote",60218),remove:l("remove",60219),replaceAll:l("replace-all",60220),replace:l("replace",60221),repoClone:l("repo-clone",60222),repoForcePush:l("repo-force-push",60223),repoPull:l("repo-pull",60224),repoPush:l("repo-push",60225),report:l("report",60226),requestChanges:l("request-changes",60227),rocket:l("rocket",60228),rootFolderOpened:l("root-folder-opened",60229),rootFolder:l("root-folder",60230),rss:l("rss",60231),ruby:l("ruby",60232),saveAll:l("save-all",60233),saveAs:l("save-as",60234),save:l("save",60235),screenFull:l("screen-full",60236),screenNormal:l("screen-normal",60237),searchStop:l("search-stop",60238),server:l("server",60240),settingsGear:l("settings-gear",60241),settings:l("settings",60242),shield:l("shield",60243),smiley:l("smiley",60244),sortPrecedence:l("sort-precedence",60245),splitHorizontal:l("split-horizontal",60246),splitVertical:l("split-vertical",60247),squirrel:l("squirrel",60248),starFull:l("star-full",60249),starHalf:l("star-half",60250),symbolClass:l("symbol-class",60251),symbolColor:l("symbol-color",60252),symbolCustomColor:l("symbol-customcolor",60252),symbolConstant:l("symbol-constant",60253),symbolEnumMember:l("symbol-enum-member",60254),symbolField:l("symbol-field",60255),symbolFile:l("symbol-file",60256),symbolInterface:l("symbol-interface",60257),symbolKeyword:l("symbol-keyword",60258),symbolMisc:l("symbol-misc",60259),symbolOperator:l("symbol-operator",60260),symbolProperty:l("symbol-property",60261),wrench:l("wrench",60261),wrenchSubaction:l("wrench-subaction",60261),symbolSnippet:l("symbol-snippet",60262),tasklist:l("tasklist",60263),telescope:l("telescope",60264),textSize:l("text-size",60265),threeBars:l("three-bars",60266),thumbsdown:l("thumbsdown",60267),thumbsup:l("thumbsup",60268),tools:l("tools",60269),triangleDown:l("triangle-down",60270),triangleLeft:l("triangle-left",60271),triangleRight:l("triangle-right",60272),triangleUp:l("triangle-up",60273),twitter:l("twitter",60274),unfold:l("unfold",60275),unlock:l("unlock",60276),unmute:l("unmute",60277),unverified:l("unverified",60278),verified:l("verified",60279),versions:l("versions",60280),vmActive:l("vm-active",60281),vmOutline:l("vm-outline",60282),vmRunning:l("vm-running",60283),watch:l("watch",60284),whitespace:l("whitespace",60285),wholeWord:l("whole-word",60286),window:l("window",60287),wordWrap:l("word-wrap",60288),zoomIn:l("zoom-in",60289),zoomOut:l("zoom-out",60290),listFilter:l("list-filter",60291),listFlat:l("list-flat",60292),listSelection:l("list-selection",60293),selection:l("selection",60293),listTree:l("list-tree",60294),debugBreakpointFunctionUnverified:l("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:l("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:l("debug-breakpoint-function-disabled",60296),debugStackframeActive:l("debug-stackframe-active",60297),circleSmallFilled:l("circle-small-filled",60298),debugStackframeDot:l("debug-stackframe-dot",60298),debugStackframe:l("debug-stackframe",60299),debugStackframeFocused:l("debug-stackframe-focused",60299),debugBreakpointUnsupported:l("debug-breakpoint-unsupported",60300),symbolString:l("symbol-string",60301),debugReverseContinue:l("debug-reverse-continue",60302),debugStepBack:l("debug-step-back",60303),debugRestartFrame:l("debug-restart-frame",60304),callIncoming:l("call-incoming",60306),callOutgoing:l("call-outgoing",60307),menu:l("menu",60308),expandAll:l("expand-all",60309),feedback:l("feedback",60310),gitPullRequestReviewer:l("git-pull-request-reviewer",60310),groupByRefType:l("group-by-ref-type",60311),ungroupByRefType:l("ungroup-by-ref-type",60312),account:l("account",60313),gitPullRequestAssignee:l("git-pull-request-assignee",60313),bellDot:l("bell-dot",60314),debugConsole:l("debug-console",60315),library:l("library",60316),output:l("output",60317),runAll:l("run-all",60318),syncIgnored:l("sync-ignored",60319),pinned:l("pinned",60320),githubInverted:l("github-inverted",60321),debugAlt:l("debug-alt",60305),serverProcess:l("server-process",60322),serverEnvironment:l("server-environment",60323),pass:l("pass",60324),stopCircle:l("stop-circle",60325),playCircle:l("play-circle",60326),record:l("record",60327),debugAltSmall:l("debug-alt-small",60328),vmConnect:l("vm-connect",60329),cloud:l("cloud",60330),merge:l("merge",60331),exportIcon:l("export",60332),graphLeft:l("graph-left",60333),magnet:l("magnet",60334),notebook:l("notebook",60335),redo:l("redo",60336),checkAll:l("check-all",60337),pinnedDirty:l("pinned-dirty",60338),passFilled:l("pass-filled",60339),circleLargeFilled:l("circle-large-filled",60340),circleLarge:l("circle-large",60341),circleLargeOutline:l("circle-large-outline",60341),combine:l("combine",60342),gather:l("gather",60342),table:l("table",60343),variableGroup:l("variable-group",60344),typeHierarchy:l("type-hierarchy",60345),typeHierarchySub:l("type-hierarchy-sub",60346),typeHierarchySuper:l("type-hierarchy-super",60347),gitPullRequestCreate:l("git-pull-request-create",60348),runAbove:l("run-above",60349),runBelow:l("run-below",60350),notebookTemplate:l("notebook-template",60351),debugRerun:l("debug-rerun",60352),workspaceTrusted:l("workspace-trusted",60353),workspaceUntrusted:l("workspace-untrusted",60354),workspaceUnspecified:l("workspace-unspecified",60355),terminalCmd:l("terminal-cmd",60356),terminalDebian:l("terminal-debian",60357),terminalLinux:l("terminal-linux",60358),terminalPowershell:l("terminal-powershell",60359),terminalTmux:l("terminal-tmux",60360),terminalUbuntu:l("terminal-ubuntu",60361),terminalBash:l("terminal-bash",60362),arrowSwap:l("arrow-swap",60363),copy:l("copy",60364),personAdd:l("person-add",60365),filterFilled:l("filter-filled",60366),wand:l("wand",60367),debugLineByLine:l("debug-line-by-line",60368),inspect:l("inspect",60369),layers:l("layers",60370),layersDot:l("layers-dot",60371),layersActive:l("layers-active",60372),compass:l("compass",60373),compassDot:l("compass-dot",60374),compassActive:l("compass-active",60375),azure:l("azure",60376),issueDraft:l("issue-draft",60377),gitPullRequestClosed:l("git-pull-request-closed",60378),gitPullRequestDraft:l("git-pull-request-draft",60379),debugAll:l("debug-all",60380),debugCoverage:l("debug-coverage",60381),runErrors:l("run-errors",60382),folderLibrary:l("folder-library",60383),debugContinueSmall:l("debug-continue-small",60384),beakerStop:l("beaker-stop",60385),graphLine:l("graph-line",60386),graphScatter:l("graph-scatter",60387),pieChart:l("pie-chart",60388),bracketDot:l("bracket-dot",60389),bracketError:l("bracket-error",60390),lockSmall:l("lock-small",60391),azureDevops:l("azure-devops",60392),verifiedFilled:l("verified-filled",60393),newLine:l("newline",60394),layout:l("layout",60395),layoutActivitybarLeft:l("layout-activitybar-left",60396),layoutActivitybarRight:l("layout-activitybar-right",60397),layoutPanelLeft:l("layout-panel-left",60398),layoutPanelCenter:l("layout-panel-center",60399),layoutPanelJustify:l("layout-panel-justify",60400),layoutPanelRight:l("layout-panel-right",60401),layoutPanel:l("layout-panel",60402),layoutSidebarLeft:l("layout-sidebar-left",60403),layoutSidebarRight:l("layout-sidebar-right",60404),layoutStatusbar:l("layout-statusbar",60405),layoutMenubar:l("layout-menubar",60406),layoutCentered:l("layout-centered",60407),layoutSidebarRightOff:l("layout-sidebar-right-off",60416),layoutPanelOff:l("layout-panel-off",60417),layoutSidebarLeftOff:l("layout-sidebar-left-off",60418),target:l("target",60408),indent:l("indent",60409),recordSmall:l("record-small",60410),errorSmall:l("error-small",60411),arrowCircleDown:l("arrow-circle-down",60412),arrowCircleLeft:l("arrow-circle-left",60413),arrowCircleRight:l("arrow-circle-right",60414),arrowCircleUp:l("arrow-circle-up",60415),heartFilled:l("heart-filled",60420),map:l("map",60421),mapFilled:l("map-filled",60422),circleSmall:l("circle-small",60423),bellSlash:l("bell-slash",60424),bellSlashDot:l("bell-slash-dot",60425),commentUnresolved:l("comment-unresolved",60426),gitPullRequestGoToChanges:l("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:l("git-pull-request-new-changes",60428),searchFuzzy:l("search-fuzzy",60429),commentDraft:l("comment-draft",60430),send:l("send",60431),sparkle:l("sparkle",60432),insert:l("insert",60433),mic:l("mic",60434),thumbsDownFilled:l("thumbsdown-filled",60435),thumbsUpFilled:l("thumbsup-filled",60436),coffee:l("coffee",60437),snake:l("snake",60438),game:l("game",60439),vr:l("vr",60440),chip:l("chip",60441),piano:l("piano",60442),music:l("music",60443),micFilled:l("mic-filled",60444),gitFetch:l("git-fetch",60445),copilot:l("copilot",60446),dialogError:l("dialog-error","error"),dialogWarning:l("dialog-warning","warning"),dialogInfo:l("dialog-info","info"),dialogClose:l("dialog-close","close"),treeItemExpanded:l("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:l("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:l("tree-filter-on-type-off","list-selection"),treeFilterClear:l("tree-filter-clear","close"),treeItemLoading:l("tree-item-loading","loading"),menuSelection:l("menu-selection","check"),menuSubmenu:l("menu-submenu","chevron-right"),menuBarMore:l("menubar-more","more"),scrollbarButtonLeft:l("scrollbar-button-left","triangle-left"),scrollbarButtonRight:l("scrollbar-button-right","triangle-right"),scrollbarButtonUp:l("scrollbar-button-up","triangle-up"),scrollbarButtonDown:l("scrollbar-button-down","triangle-down"),toolBarMore:l("toolbar-more","more"),quickInputBack:l("quick-input-back","arrow-left")}}),define(De[32],Ce([1,0,15,12,16,17]),function(re,e,y,M,l,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7f=e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=e.$Vf=e.$Uf=e.$Tf=e.$Sf=e.$Rf=void 0;function A(o){return o===47||o===92}e.$Rf=A;function g(o){return o.replace(/[\\/]/g,y.$gc.sep)}e.$Sf=g;function k(o){return o.indexOf("/")===-1&&(o=g(o)),/^[a-zA-Z]:(\/|$)/.test(o)&&(o="/"+o),o}e.$Tf=k;function $(o,v=y.$gc.sep){if(!o)return"";const C=o.length,w=o.charCodeAt(0);if(A(w)){if(A(o.charCodeAt(1))&&!A(o.charCodeAt(2))){let b=3;const I=b;for(;b<C&&!A(o.charCodeAt(b));b++);if(I!==b&&!A(o.charCodeAt(b+1))){for(b+=1;b<C;b++)if(A(o.charCodeAt(b)))return o.slice(0,b+1).replace(/[\\/]/g,v)}}return v}else if(u(w)&&o.charCodeAt(1)===58)return A(o.charCodeAt(2))?o.slice(0,2)+v:o.slice(0,2);let m=o.indexOf("://");if(m!==-1){for(m+=3;m<C;m++)if(A(o.charCodeAt(m)))return o.slice(0,m+1)}return""}e.$Uf=$;function R(o){if(!M.$d||!o||o.length<5)return!1;let v=o.charCodeAt(0);if(v!==92||(v=o.charCodeAt(1),v!==92))return!1;let C=2;const w=C;for(;C<o.length&&(v=o.charCodeAt(C),v!==92);C++);return!(w===C||(v=o.charCodeAt(C+1),isNaN(v)||v===92))}e.$Vf=R;const P=/[\\/:\*\?"<>\|]/g,p=/[\\/]/g,S=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function D(o,v=M.$d){const C=v?P:p;return!(!o||o.length===0||/^\s+$/.test(o)||(C.lastIndex=0,C.test(o))||v&&S.test(o)||o==="."||o===".."||v&&o[o.length-1]==="."||v&&o.length!==o.trim().length||o.length>255)}e.$Wf=D;function E(o,v,C){const w=o===v;return!C||w?w:!o||!v?!1:(0,l.$3e)(o,v)}e.$Xf=E;function h(o,v,C,w=y.sep){if(o===v)return!0;if(!o||!v||v.length>o.length)return!1;if(C){if(!(0,l.$4e)(o,v))return!1;if(v.length===o.length)return!0;let b=v.length;return v.charAt(v.length-1)===w&&b--,o.charAt(b)===w}return v.charAt(v.length-1)!==w&&(v+=w),o.indexOf(v)===0}e.$Yf=h;function u(o){return o>=65&&o<=90||o>=97&&o<=122}e.$Zf=u;function d(o,v){return M.$d&&o.endsWith(":")&&(o+=y.sep),(0,y.$ic)(o)||(o=(0,y.$jc)(v,o)),o=(0,y.$hc)(o),M.$d?(o=(0,l.$Le)(o,y.sep),o.endsWith(":")&&(o+=y.sep)):(o=(0,l.$Le)(o,y.sep),o||(o=y.sep)),o}e.$1f=d;function c(o){const v=(0,y.$hc)(o);return M.$d?o.length>3?!1:f(v)&&(o.length===2||v.charCodeAt(2)===92):v===y.$gc.sep}e.$2f=c;function f(o,v=M.$d){return v?u(o.charCodeAt(0))&&o.charCodeAt(1)===58:!1}e.$3f=f;function a(o,v=M.$d){return f(o,v)?o[0]:void 0}e.$4f=a;function t(o,v,C){return v.length>o.length?-1:o===v?0:(C&&(o=o.toLowerCase(),v=v.toLowerCase()),o.indexOf(v))}e.$5f=t;function i(o){const v=o.split(":");let C,w,m;for(const b of v){const I=Number(b);(0,L.$Df)(I)?w===void 0?w=I:m===void 0&&(m=I):C=C?[C,b].join(":"):b}if(!C)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:C,line:w!==void 0?w:void 0,column:m!==void 0?m:w!==void 0?1:void 0}}e.$6f=i;const s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",n="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function r(o,v,C=8){let w="";for(let b=0;b<C;b++){let I;b===0&&M.$d&&!v&&(C===3||C===4)?I=n:I=s,w+=I.charAt(Math.floor(Math.random()*I.length))}let m;return v?m=`${v}-${w}`:m=w,o?(0,y.$jc)(o,m):m}e.$7f=r}),define(De[24],Ce([1,0,17]),function(re,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kn=e.$jn=e.$in=e.$hn=e.$gn=e.$fn=e.$en=e.$dn=e.$cn=e.$bn=e.$an=e.$_m=e.$$m=e.$0m=e.$9m=void 0;function M(f){if(!f||typeof f!="object"||f instanceof RegExp)return f;const a=Array.isArray(f)?[]:{};return Object.entries(f).forEach(([t,i])=>{a[t]=i&&typeof i=="object"?M(i):i}),a}e.$9m=M;function l(f){if(!f||typeof f!="object")return f;const a=[f];for(;a.length>0;){const t=a.shift();Object.freeze(t);for(const i in t)if(L.call(t,i)){const s=t[i];typeof s=="object"&&!Object.isFrozen(s)&&!(0,y.$Cf)(s)&&a.push(s)}}return f}e.$0m=l;const L=Object.prototype.hasOwnProperty;function A(f,a){return g(f,a,new Set)}e.$$m=A;function g(f,a,t){if((0,y.$If)(f))return f;const i=a(f);if(typeof i<"u")return i;if(Array.isArray(f)){const s=[];for(const n of f)s.push(g(n,a,t));return s}if((0,y.$Bf)(f)){if(t.has(f))throw new Error("Cannot clone recursive data-structure");t.add(f);const s={};for(const n in f)L.call(f,n)&&(s[n]=g(f[n],a,t));return t.delete(f),s}return f}function k(f,a,t=!0){return(0,y.$Bf)(f)?((0,y.$Bf)(a)&&Object.keys(a).forEach(i=>{i in f?t&&((0,y.$Bf)(f[i])&&(0,y.$Bf)(a[i])?k(f[i],a[i],t):f[i]=a[i]):f[i]=a[i]}),f):a}e.$_m=k;function $(f,a){if(f===a)return!0;if(f==null||a===null||a===void 0||typeof f!=typeof a||typeof f!="object"||Array.isArray(f)!==Array.isArray(a))return!1;let t,i;if(Array.isArray(f)){if(f.length!==a.length)return!1;for(t=0;t<f.length;t++)if(!$(f[t],a[t]))return!1}else{const s=[];for(i in f)s.push(i);s.sort();const n=[];for(i in a)n.push(i);if(n.sort(),!$(s,n))return!1;for(t=0;t<s.length;t++)if(!$(f[s[t]],a[s[t]]))return!1}return!0}e.$an=$;function R(f){const a=new Set;return JSON.stringify(f,(t,i)=>{if((0,y.$Bf)(i)||Array.isArray(i)){if(a.has(i))return"[Circular]";a.add(i)}return i})}e.$bn=R;function P(f,a){const t=Object.create(null);return!f||!a||Object.keys(a).forEach(s=>{const n=f[s],r=a[s];$(n,r)||(t[s]=r)}),t}e.$cn=P;function p(f,a){const t=a.toLowerCase(),i=Object.keys(f).find(s=>s.toLowerCase()===t);return i?f[i]:f[a]}e.$dn=p;function S(f,a){const t=Object.create(null);for(const[i,s]of Object.entries(f))a(i,s)&&(t[i]=s);return t}e.$en=S;function D(f){let a=[];for(;Object.prototype!==f;)a=a.concat(Object.getOwnPropertyNames(f)),f=Object.getPrototypeOf(f);return a}e.$fn=D;function E(f){const a=[];for(const t of D(f))typeof f[t]=="function"&&a.push(t);return a}e.$gn=E;function h(f,a){const t=s=>function(){const n=Array.prototype.slice.call(arguments,0);return a(s,n)},i={};for(const s of f)i[s]=t(s);return i}e.$hn=h;function u(f,a,t){typeof a=="string"&&f[a]!==void 0&&typeof f[a]!="boolean"&&(f[a]=t)}e.$in=u;function d(f,a,t){typeof a=="string"&&f[a]!==void 0&&typeof f[a]!="number"&&(f[a]=t)}e.$jn=d;function c(f,a,t,i){if(typeof a!="string")return;const s=f[a];s!==void 0&&(typeof s!="string"||!t.includes(s))&&(f[a]=i)}e.$kn=c}),define(De[59],Ce([1,0,79]),function(re,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$Wj=e.ThemeColor=void 0;var M;(function(A){function g(k){return k&&typeof k=="object"&&typeof k.id=="string"}A.isThemeColor=g})(M||(e.ThemeColor=M={}));function l(A){return{id:A}}e.$Wj=l;var L;(function(A){A.iconNameSegment="[A-Za-z0-9]+",A.iconNameExpression="[A-Za-z0-9-]+",A.iconModifierExpression="~[A-Za-z]+",A.iconNameCharacter="[A-Za-z0-9~-]";const g=new RegExp(`^(${A.iconNameExpression})(${A.iconModifierExpression})?$`);function k(d){const c=g.exec(d.id);if(!c)return k(y.$Vj.error);const[,f,a]=c,t=["codicon","codicon-"+f];return a&&t.push("codicon-modifier-"+a.substring(1)),t}A.asClassNameArray=k;function $(d){return k(d).join(" ")}A.asClassName=$;function R(d){return"."+k(d).join(".")}A.asCSSSelector=R;function P(d){return d&&typeof d=="object"&&typeof d.id=="string"&&(typeof d.color>"u"||M.isThemeColor(d.color))}A.isThemeIcon=P;const p=new RegExp(`^\\$\\((${A.iconNameExpression}(?:${A.iconModifierExpression})?)\\)$`);function S(d){const c=p.exec(d);if(!c)return;const[,f]=c;return{id:f}}A.fromString=S;function D(d){return{id:d}}A.fromId=D;function E(d,c){let f=d.id;const a=f.lastIndexOf("~");return a!==-1&&(f=f.substring(0,a)),c&&(f=`${f}~${c}`),{id:f}}A.modify=E;function h(d){const c=d.id.lastIndexOf("~");if(c!==-1)return d.id.substring(c+1)}A.getModifier=h;function u(d,c){return d.id===c.id&&d.color?.id===c.color?.id}A.isEqual=u})(L||(e.ThemeIcon=L={}))}),define(De[162],Ce([1,0,123,16,59]),function(re,e,y,M,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3j=e.$2j=e.$1j=e.$Zj=e.$Yj=e.$Xj=void 0;const L="$(",A=new RegExp(`\\$\\(${l.ThemeIcon.iconNameExpression}(?:${l.ThemeIcon.iconModifierExpression})?\\)`,"g"),g=new RegExp(`(\\\\)?${A.source}`,"g");function k(u){return u.replace(g,(d,c)=>c?d:`\\${d}`)}e.$Xj=k;const $=new RegExp(`\\\\${A.source}`,"g");function R(u){return u.replace($,d=>`\\${d}`)}e.$Yj=R;const P=new RegExp(`(\\s)?(\\\\)?${A.source}(\\s)?`,"g");function p(u){return u.indexOf(L)===-1?u:u.replace(P,(d,c,f,a)=>f?d:c||a||"")}e.$Zj=p;function S(u){return u?u.replace(/\$\((.*?)\)/g,(d,c)=>` ${c} `).trim():""}e.$1j=S;const D=new RegExp(`\\$\\(${l.ThemeIcon.iconNameCharacter}+\\)`,"g");function E(u){D.lastIndex=0;let d="";const c=[];let f=0;for(;;){const a=D.lastIndex,t=D.exec(u),i=u.substring(a,t?.index);if(i.length>0){d+=i;for(let s=0;s<i.length;s++)c.push(f)}if(!t)break;f+=t[0].length}return{text:d,iconOffsets:c}}e.$2j=E;function h(u,d,c=!1){const{text:f,iconOffsets:a}=d;if(!a||a.length===0)return(0,y.$Kj)(u,f,c);const t=(0,M.$Ke)(f," "),i=f.length-t.length,s=(0,y.$Kj)(u,t,c);if(s)for(const n of s){const r=a[n.start+i]+i;n.start+=r,n.end+=r}return s}e.$3j=h}),define(De[125],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Be=e.$Ae=e.Constants=void 0;var y;(function(L){L[L.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",L[L.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",L[L.MAX_UINT_8=255]="MAX_UINT_8",L[L.MAX_UINT_16=65535]="MAX_UINT_16",L[L.MAX_UINT_32=4294967295]="MAX_UINT_32",L[L.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(y||(e.Constants=y={}));function M(L){return L<0?0:L>255?255:L|0}e.$Ae=M;function l(L){return L<0?0:L>4294967295?4294967295:L|0}e.$Be=l}),define(De[2],Ce([1,0,15,12]),function(re,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wc=e.$vc=e.URI=void 0;const l=/^\w[\w\d+.-]*$/,L=/^\//,A=/^\/\//;function g(n,r){if(!n.scheme&&r)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${n.authority}", path: "${n.path}", query: "${n.query}", fragment: "${n.fragment}"}`);if(n.scheme&&!l.test(n.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(n.path){if(n.authority){if(!L.test(n.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(A.test(n.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function k(n,r){return!n&&!r?"file":n}function $(n,r){switch(n){case"https":case"http":case"file":r?r[0]!==P&&(r=P+r):r=P;break}return r}const R="",P="/",p=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class S{static isUri(r){return r instanceof S?!0:r?typeof r.authority=="string"&&typeof r.fragment=="string"&&typeof r.path=="string"&&typeof r.query=="string"&&typeof r.scheme=="string"&&typeof r.fsPath=="string"&&typeof r.with=="function"&&typeof r.toString=="function":!1}constructor(r,o,v,C,w,m=!1){typeof r=="object"?(this.scheme=r.scheme||R,this.authority=r.authority||R,this.path=r.path||R,this.query=r.query||R,this.fragment=r.fragment||R):(this.scheme=k(r,m),this.authority=o||R,this.path=$(this.scheme,v||R),this.query=C||R,this.fragment=w||R,g(this,m))}get fsPath(){return f(this,!1)}with(r){if(!r)return this;let{scheme:o,authority:v,path:C,query:w,fragment:m}=r;return o===void 0?o=this.scheme:o===null&&(o=R),v===void 0?v=this.authority:v===null&&(v=R),C===void 0?C=this.path:C===null&&(C=R),w===void 0?w=this.query:w===null&&(w=R),m===void 0?m=this.fragment:m===null&&(m=R),o===this.scheme&&v===this.authority&&C===this.path&&w===this.query&&m===this.fragment?this:new h(o,v,C,w,m)}static parse(r,o=!1){const v=p.exec(r);return v?new h(v[2]||R,s(v[4]||R),s(v[5]||R),s(v[7]||R),s(v[9]||R),o):new h(R,R,R,R,R)}static file(r){let o=R;if(M.$d&&(r=r.replace(/\\/g,P)),r[0]===P&&r[1]===P){const v=r.indexOf(P,2);v===-1?(o=r.substring(2),r=P):(o=r.substring(2,v),r=r.substring(v)||P)}return new h("file",o,r,R,R)}static from(r,o){return new h(r.scheme,r.authority,r.path,r.query,r.fragment,o)}static joinPath(r,...o){if(!r.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let v;return M.$d&&r.scheme==="file"?v=S.file(y.$fc.join(f(r,!0),...o)).path:v=y.$gc.join(r.path,...o),r.with({path:v})}toString(r=!1){return a(this,r)}toJSON(){return this}static revive(r){if(r){if(r instanceof S)return r;{const o=new h(r);return o._formatted=r.external??null,o._fsPath=r._sep===E?r.fsPath??null:null,o}}else return r}}e.URI=S;function D(n){return!n||typeof n!="object"?!1:typeof n.scheme=="string"&&(typeof n.authority=="string"||typeof n.authority>"u")&&(typeof n.path=="string"||typeof n.path>"u")&&(typeof n.query=="string"||typeof n.query>"u")&&(typeof n.fragment=="string"||typeof n.fragment>"u")}e.$vc=D;const E=M.$d?1:void 0;class h extends S{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=f(this,!1)),this._fsPath}toString(r=!1){return r?a(this,!0):(this._formatted||(this._formatted=a(this,!1)),this._formatted)}toJSON(){const r={$mid:1};return this._fsPath&&(r.fsPath=this._fsPath,r._sep=E),this._formatted&&(r.external=this._formatted),this.path&&(r.path=this.path),this.scheme&&(r.scheme=this.scheme),this.authority&&(r.authority=this.authority),this.query&&(r.query=this.query),this.fragment&&(r.fragment=this.fragment),r}}const u={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function d(n,r,o){let v,C=-1;for(let w=0;w<n.length;w++){const m=n.charCodeAt(w);if(m>=97&&m<=122||m>=65&&m<=90||m>=48&&m<=57||m===45||m===46||m===95||m===126||r&&m===47||o&&m===91||o&&m===93||o&&m===58)C!==-1&&(v+=encodeURIComponent(n.substring(C,w)),C=-1),v!==void 0&&(v+=n.charAt(w));else{v===void 0&&(v=n.substr(0,w));const b=u[m];b!==void 0?(C!==-1&&(v+=encodeURIComponent(n.substring(C,w)),C=-1),v+=b):C===-1&&(C=w)}}return C!==-1&&(v+=encodeURIComponent(n.substring(C))),v!==void 0?v:n}function c(n){let r;for(let o=0;o<n.length;o++){const v=n.charCodeAt(o);v===35||v===63?(r===void 0&&(r=n.substr(0,o)),r+=u[v]):r!==void 0&&(r+=n[o])}return r!==void 0?r:n}function f(n,r){let o;return n.authority&&n.path.length>1&&n.scheme==="file"?o=`//${n.authority}${n.path}`:n.path.charCodeAt(0)===47&&(n.path.charCodeAt(1)>=65&&n.path.charCodeAt(1)<=90||n.path.charCodeAt(1)>=97&&n.path.charCodeAt(1)<=122)&&n.path.charCodeAt(2)===58?r?o=n.path.substr(1):o=n.path[1].toLowerCase()+n.path.substr(2):o=n.path,M.$d&&(o=o.replace(/\//g,"\\")),o}e.$wc=f;function a(n,r){const o=r?c:d;let v="",{scheme:C,authority:w,path:m,query:b,fragment:I}=n;if(C&&(v+=C,v+=":"),(w||C==="file")&&(v+=P,v+=P),w){let z=w.indexOf("@");if(z!==-1){const O=w.substr(0,z);w=w.substr(z+1),z=O.lastIndexOf(":"),z===-1?v+=o(O,!1,!1):(v+=o(O.substr(0,z),!1,!1),v+=":",v+=o(O.substr(z+1),!1,!0)),v+="@"}w=w.toLowerCase(),z=w.lastIndexOf(":"),z===-1?v+=o(w,!1,!0):(v+=o(w.substr(0,z),!1,!0),v+=w.substr(z))}if(m){if(m.length>=3&&m.charCodeAt(0)===47&&m.charCodeAt(2)===58){const z=m.charCodeAt(1);z>=65&&z<=90&&(m=`/${String.fromCharCode(z+32)}:${m.substr(3)}`)}else if(m.length>=2&&m.charCodeAt(1)===58){const z=m.charCodeAt(0);z>=65&&z<=90&&(m=`${String.fromCharCode(z+32)}:${m.substr(2)}`)}v+=o(m,!0,!1)}return b&&(v+="?",v+=o(b,!1,!1)),I&&(v+="#",v+=r?I:d(I,!1,!1)),v}function t(n){try{return decodeURIComponent(n)}catch{return n.length>3?n.substr(0,3)+t(n.substr(3)):n}}const i=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function s(n){return n.match(i)?n.replace(i,r=>t(r)):n}}),define(De[163],Ce([1,0,2]),function(re,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.$5p=e.$4p=e.$3p=void 0;function M($){const R=$;return R&&typeof R.type=="string"&&typeof R.severity=="string"}e.$3p=M;function l($){const R=[];let P;try{const p=JSON.parse($.arguments),S=p[p.length-1];S&&S.__$stack&&(p.pop(),P=S.__$stack),R.push(...p)}catch{R.push("Unable to log remote console arguments",$.arguments)}return{args:R,stack:P}}e.$4p=l;function L($){if(typeof $!="string")return L(l($).stack);const R=$;if(R){const P=A(R),p=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(P||"");if(p&&p.length===4)return{uri:y.URI.file(p[1]),line:Number(p[2]),column:Number(p[3])}}}e.$5p=L;function A($){if(!$)return $;const R=$.indexOf(`
`);return R===-1?$:$.substring(0,R)}function g($,R){const{args:P,stack:p}=l($),S=typeof P[0]=="string"&&P.length===1;let D=A(p);D&&(D=`(${D.trim()})`);let E=[];if(typeof P[0]=="string"?D&&S?E=[`%c[${R}] %c${P[0]} %c${D}`,k("blue"),k(""),k("grey")]:E=[`%c[${R}] %c${P[0]}`,k("blue"),k(""),...P.slice(1)]:E=[`%c[${R}]%`,k("blue"),...P],D&&!S&&E.push(D),typeof console[$.severity]!="function")throw new Error("Unknown console method");console[$.severity].apply(console,E)}e.log=g;function k($){return`color: ${$}`}}),define(De[60],Ce([1,0,22,2]),function(re,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nh=e.$mh=e.$lh=void 0;function l(k){return JSON.stringify(k,A)}e.$lh=l;function L(k){let $=JSON.parse(k);return $=g($),$}e.$mh=L;function A(k,$){return $ instanceof RegExp?{$mid:2,source:$.source,flags:$.flags}:$}function g(k,$=0){if(!k||$>200)return k;if(typeof k=="object"){switch(k.$mid){case 1:return M.URI.revive(k);case 2:return new RegExp(k.source,k.flags);case 17:return new Date(k.source)}if(k instanceof y.$ce||k instanceof Uint8Array)return k;if(Array.isArray(k))for(let R=0;R<k.length;++R)k[R]=g(k[R],$+1);else for(const R in k)Object.hasOwnProperty.call(k,R)&&(k[R]=g(k[R],$+1))}return k}e.$nh=g}),define(De[18],Ce([1,0,9,12,2]),function(re,e,y,M,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$dg=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=e.$0f=e.$9f=e.$8f=e.Schemas=void 0;var L;(function($){$.inMemory="inmemory",$.vscode="vscode",$.internal="private",$.walkThrough="walkThrough",$.walkThroughSnippet="walkThroughSnippet",$.http="http",$.https="https",$.file="file",$.mailto="mailto",$.untitled="untitled",$.data="data",$.command="command",$.vscodeRemote="vscode-remote",$.vscodeRemoteResource="vscode-remote-resource",$.vscodeManagedRemoteResource="vscode-managed-remote-resource",$.vscodeUserData="vscode-userdata",$.vscodeCustomEditor="vscode-custom-editor",$.vscodeNotebookCell="vscode-notebook-cell",$.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",$.vscodeNotebookCellOutput="vscode-notebook-cell-output",$.vscodeInteractiveInput="vscode-interactive-input",$.vscodeSettings="vscode-settings",$.vscodeWorkspaceTrust="vscode-workspace-trust",$.vscodeTerminal="vscode-terminal",$.vscodeChatSesssion="vscode-chat-editor",$.webviewPanel="webview-panel",$.vscodeWebview="vscode-webview",$.extension="extension",$.vscodeFileResource="vscode-file",$.tmp="tmp",$.vsls="vsls",$.vscodeSourceControl="vscode-scm"})(L||(e.Schemas=L={})),e.$8f="vscode-tkn",e.$9f="tkn";class A{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${L.vscodeRemoteResource}`}setPreferredWebSchema(R){this.d=R}setDelegate(R){this.e=R}setServerRootPath(R){this.f=`${R}/${L.vscodeRemoteResource}`}set(R,P,p){this.a[R]=P,this.b[R]=p}setConnectionToken(R,P){this.c[R]=P}getPreferredWebSchema(){return this.d}rewrite(R){if(this.e)try{return this.e(R)}catch(h){return y.$1(h),R}const P=R.authority;let p=this.a[P];p&&p.indexOf(":")!==-1&&p.indexOf("[")===-1&&(p=`[${p}]`);const S=this.b[P],D=this.c[P];let E=`path=${encodeURIComponent(R.path)}`;return typeof D=="string"&&(E+=`&${e.$9f}=${encodeURIComponent(D)}`),l.URI.from({scheme:M.$j?this.d:L.vscodeRemoteResource,authority:`${p}:${S}`,path:M.$j?(window.location.pathname+"/"+this.f).replace(/\/\/+/g,"/"):this.f,query:E})}}e.$0f=new A,e.$$f="vs/../../extensions",e.$_f="vs/../../node_modules",e.$ag="vs/../../node_modules.asar",e.$bg="vs/../../node_modules.asar.unpacked",e.$cg="vscode-app";class g{asBrowserUri(R){const P=this.b(R,re);return this.uriToBrowserUri(P)}uriToBrowserUri(R){return R.scheme===L.vscodeRemote?e.$0f.rewrite(R):R.scheme===L.file&&(M.$h||M.$k&&M.$b.origin===`${L.vscodeFileResource}://${g.a}`)?R.with({scheme:L.vscodeFileResource,authority:R.authority||g.a,query:null,fragment:null}):R}asFileUri(R){const P=this.b(R,re);return this.uriToFileUri(P)}uriToFileUri(R){return R.scheme===L.vscodeFileResource?R.with({scheme:L.file,authority:R.authority!==g.a?R.authority:null,query:null,fragment:null}):R}b(R,P){return l.URI.isUri(R)?R:l.URI.parse(P.toUrl(R))}}g.a=e.$cg,e.$dg=new g;var k;(function($){const R=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);$.CoopAndCoep=Object.freeze(R.get("3"));const P="vscode-coi";function p(D){let E;typeof D=="string"?E=new URL(D).searchParams:D instanceof URL?E=D.searchParams:l.URI.isUri(D)&&(E=new URL(D.toString(!0)).searchParams);const h=E?.get(P);if(h)return R.get(h)}$.getHeadersFromQuery=p;function S(D,E,h){if(!globalThis.crossOriginIsolated)return;const u=E&&h?"3":h?"2":"1";D instanceof URLSearchParams?D.set(P,u):D[P]=u}$.addSearchParam=S})(k||(e.COI=k={}))}),define(De[164],Ce([1,0,157,18,12,2]),function(re,e,y,M,l,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AC=void 0;class A{constructor(p,S,D){this.id=p,this.dependencies=S,this.callback=D}}class g{constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(p,S,D)=>{typeof p!="string"&&(D=S,S=p,p=null),(typeof S!="object"||!Array.isArray(S))&&(D=S,S=null),this.c.push(new A(p,S,D))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(p){if(p.startsWith(window.location.origin)||p.startsWith("vscode-file://vscode-app"))return p;throw new Error(`[trusted_script_src] Invalid script url: ${p}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(p){return p}})))}async load(p){this.g();const S=await(this.a?this.i(p):this.b?this.h(p):this.j(p));if(!S)throw new Error(`Did not receive a define call from script ${p}`);if(Array.isArray(S.dependencies)&&S.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${p}. The dependencies are: ${S.dependencies.join(", ")}`);return typeof S.callback=="function"?S.callback([]):S.callback}h(p){return new Promise((S,D)=>{const E=document.createElement("script");E.setAttribute("async","async"),E.setAttribute("type","text/javascript");const h=()=>{E.removeEventListener("load",u),E.removeEventListener("error",d)},u=c=>{h(),S(this.c.pop())},d=c=>{h(),D(c)};E.addEventListener("load",u),E.addEventListener("error",d),this.f&&(p=this.f.createScriptURL(p)),E.setAttribute("src",p),document.getElementsByTagName("head")[0].appendChild(E)})}i(p){return new Promise((S,D)=>{try{this.f&&(p=this.f.createScriptURL(p)),importScripts(p),S(this.c.pop())}catch(E){D(E)}})}async j(p){try{const S=globalThis._VSCODE_NODE_MODULES.fs,D=globalThis._VSCODE_NODE_MODULES.vm,E=globalThis._VSCODE_NODE_MODULES.module,h=L.URI.parse(p).fsPath,u=S.readFileSync(h).toString(),d=E.wrap(u.replace(/^#!.*/,""));return new D.Script(d).runInThisContext().apply(),this.c.pop()}catch(S){throw S}}}g.INSTANCE=new g;const k=new Map;let $={};typeof globalThis.require=="object"&&($=globalThis.require.paths??{});async function R(P,p,S){if(y.$T){S===void 0&&(S=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),$[P]&&(P=$[P]);const D=`${P}/${p}`;if(k.has(D))return k.get(D);let E;if(/^\w[\w\d+.-]*:\/\//.test(D))E=D;else{const c=`${S&&!l.$j?M.$ag:M.$_f}/${D}`;E=M.$dg.asBrowserUri(c).toString(!0)}const h=g.INSTANCE.load(E);return k.set(D,h),h}else return await new Promise((D,E)=>{re([P],D,E)})}e.$AC=R}),define(De[23],Ce([1,0,32,18,15,12,16,2]),function(re,e,y,M,l,L,A,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gg=e.DataUri=e.$Fg=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=e.$rg=e.$qg=e.$pg=e.$og=e.$ng=e.$mg=e.$lg=e.$kg=void 0;function k(S){return(0,g.$wc)(S,!0)}e.$kg=k;class ${constructor(D){this.a=D}compare(D,E,h=!1){return D===E?0:(0,A.$Ve)(this.getComparisonKey(D,h),this.getComparisonKey(E,h))}isEqual(D,E,h=!1){return D===E?!0:!D||!E?!1:this.getComparisonKey(D,h)===this.getComparisonKey(E,h)}getComparisonKey(D,E=!1){return D.with({path:this.a(D)?D.path.toLowerCase():void 0,fragment:E?null:void 0}).toString()}ignorePathCasing(D){return this.a(D)}isEqualOrParent(D,E,h=!1){if(D.scheme===E.scheme){if(D.scheme===M.Schemas.file)return y.$Yf(k(D),k(E),this.a(D))&&D.query===E.query&&(h||D.fragment===E.fragment);if((0,e.$Bg)(D.authority,E.authority))return y.$Yf(D.path,E.path,this.a(D),"/")&&D.query===E.query&&(h||D.fragment===E.fragment)}return!1}joinPath(D,...E){return g.URI.joinPath(D,...E)}basenameOrAuthority(D){return(0,e.$tg)(D)||D.authority}basename(D){return l.$gc.basename(D.path)}extname(D){return l.$gc.extname(D.path)}dirname(D){if(D.path.length===0)return D;let E;return D.scheme===M.Schemas.file?E=g.URI.file(l.$mc(k(D))).path:(E=l.$gc.dirname(D.path),D.authority&&E.length&&E.charCodeAt(0)!==47&&(console.error(`dirname("${D.toString})) resulted in a relative path`),E="/")),D.with({path:E})}normalizePath(D){if(!D.path.length)return D;let E;return D.scheme===M.Schemas.file?E=g.URI.file(l.$hc(k(D))).path:E=l.$gc.normalize(D.path),D.with({path:E})}relativePath(D,E){if(D.scheme!==E.scheme||!(0,e.$Bg)(D.authority,E.authority))return;if(D.scheme===M.Schemas.file){const d=l.$lc(k(D),k(E));return L.$d?y.$Sf(d):d}let h=D.path||"/";const u=E.path||"/";if(this.a(D)){let d=0;for(const c=Math.min(h.length,u.length);d<c&&!(h.charCodeAt(d)!==u.charCodeAt(d)&&h.charAt(d).toLowerCase()!==u.charAt(d).toLowerCase());d++);h=u.substr(0,d)+h.substr(d)}return l.$gc.relative(h,u)}resolvePath(D,E){if(D.scheme===M.Schemas.file){const h=g.URI.file(l.$kc(k(D),E));return D.with({authority:h.authority,path:h.path})}return E=y.$Tf(E),D.with({path:l.$gc.resolve(D.path,E)})}isAbsolutePath(D){return!!D.path&&D.path[0]==="/"}isEqualAuthority(D,E){return D===E||D!==void 0&&E!==void 0&&(0,A.$3e)(D,E)}hasTrailingPathSeparator(D,E=l.sep){if(D.scheme===M.Schemas.file){const h=k(D);return h.length>y.$Uf(h).length&&h[h.length-1]===E}else{const h=D.path;return h.length>1&&h.charCodeAt(h.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(D.fsPath)}}removeTrailingPathSeparator(D,E=l.sep){return(0,e.$Cg)(D,E)?D.with({path:D.path.substr(0,D.path.length-1)}):D}addTrailingPathSeparator(D,E=l.sep){let h=!1;if(D.scheme===M.Schemas.file){const u=k(D);h=u!==void 0&&u.length===y.$Uf(u).length&&u[u.length-1]===E}else{E="/";const u=D.path;h=u.length===1&&u.charCodeAt(u.length-1)===47}return!h&&!(0,e.$Cg)(D,E)?D.with({path:D.path+"/"}):D}}e.$lg=$,e.$mg=new $(()=>!1),e.$ng=new $(S=>S.scheme===M.Schemas.file?!L.$f:!0),e.$og=new $(S=>!0),e.$pg=e.$mg.isEqual.bind(e.$mg),e.$qg=e.$mg.isEqualOrParent.bind(e.$mg),e.$rg=e.$mg.getComparisonKey.bind(e.$mg),e.$sg=e.$mg.basenameOrAuthority.bind(e.$mg),e.$tg=e.$mg.basename.bind(e.$mg),e.$ug=e.$mg.extname.bind(e.$mg),e.$vg=e.$mg.dirname.bind(e.$mg),e.$wg=e.$mg.joinPath.bind(e.$mg),e.$xg=e.$mg.normalizePath.bind(e.$mg),e.$yg=e.$mg.relativePath.bind(e.$mg),e.$zg=e.$mg.resolvePath.bind(e.$mg),e.$Ag=e.$mg.isAbsolutePath.bind(e.$mg),e.$Bg=e.$mg.isEqualAuthority.bind(e.$mg),e.$Cg=e.$mg.hasTrailingPathSeparator.bind(e.$mg),e.$Dg=e.$mg.removeTrailingPathSeparator.bind(e.$mg),e.$Eg=e.$mg.addTrailingPathSeparator.bind(e.$mg);function R(S,D){const E=[];for(let h=0;h<S.length;h++){const u=D(S[h]);S.some((d,c)=>c===h?!1:(0,e.$qg)(u,D(d)))||E.push(S[h])}return E}e.$Fg=R;var P;(function(S){S.META_DATA_LABEL="label",S.META_DATA_DESCRIPTION="description",S.META_DATA_SIZE="size",S.META_DATA_MIME="mime";function D(E){const h=new Map;E.path.substring(E.path.indexOf(";")+1,E.path.lastIndexOf(";")).split(";").forEach(c=>{const[f,a]=c.split(":");f&&a&&h.set(f,a)});const d=E.path.substring(0,E.path.indexOf(";"));return d&&h.set(S.META_DATA_MIME,d),h}S.parseMetaData=D})(P||(e.DataUri=P={}));function p(S,D,E){if(D){let h=S.path;return h&&h[0]!==l.$gc.sep&&(h=l.$gc.sep+h),S.with({scheme:E,authority:D,path:h})}return S.with({scheme:E})}e.$Gg=p}),define(De[8],Ce([1,0,21,9,4,3,23,12,161]),function(re,e,y,M,l,L,A,g,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hh=e.$gh=e.$fh=e.$eh=e.Promises=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=void 0;function $(le){return!!le&&typeof le.then=="function"}e.$Hg=$;function R(le){const H=new y.$Yd,G=le(H.token),Y=new Promise((X,be)=>{const se=H.token.onCancellationRequested(()=>{se.dispose(),H.dispose(),be(new M.$5)});Promise.resolve(G).then(ge=>{se.dispose(),H.dispose(),X(ge)},ge=>{se.dispose(),H.dispose(),be(ge)})});return new class{cancel(){H.cancel()}then(X,be){return Y.then(X,be)}catch(X){return this.then(void 0,X)}finally(X){return Y.finally(X)}}}e.$Ig=R;function P(le,H,G){return new Promise((Y,X)=>{const be=H.onCancellationRequested(()=>{be.dispose(),Y(G)});le.then(Y,X).finally(()=>be.dispose())})}e.$Jg=P;function p(le,H){return new Promise((G,Y)=>{const X=H.onCancellationRequested(()=>{X.dispose(),Y(new M.$5)});le.then(G,Y).finally(()=>X.dispose())})}e.$Kg=p;async function S(le){let H=-1;const G=le.map((Y,X)=>Y.then(be=>(H=X,be)));try{return await Promise.race(G)}finally{le.forEach((Y,X)=>{X!==H&&Y.cancel()})}}e.$Lg=S;function D(le,H,G){let Y;const X=setTimeout(()=>{Y?.(void 0),G?.()},H);return Promise.race([le.finally(()=>clearTimeout(X)),new Promise(be=>Y=be)])}e.$Mg=D;function E(le){return new Promise((H,G)=>{const Y=le();$(Y)?Y.then(H,G):H(Y)})}e.$Ng=E;class h{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(H){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=H,!this.b){const G=()=>{if(this.b=null,this.f)return;const Y=this.queue(this.d);return this.d=null,Y};this.b=new Promise(Y=>{this.a.then(G,G).then(Y)})}return new Promise((G,Y)=>{this.b.then(G,Y)})}return this.a=H(),new Promise((G,Y)=>{this.a.then(X=>{this.a=null,G(X)},X=>{this.a=null,Y(X)})})}dispose(){this.f=!0}}e.$Og=h;class u{constructor(){this.a=Promise.resolve(null)}queue(H){return this.a=this.a.then(()=>H(),()=>H())}}e.$Pg=u;class d{constructor(){this.a=new Map}queue(H,G){const X=(this.a.get(H)??Promise.resolve()).catch(()=>{}).then(G).finally(()=>{this.a.get(H)===X&&this.a.delete(H)});return this.a.set(H,X),X}}e.$Qg=d;const c=(le,H)=>{let G=!0;const Y=setTimeout(()=>{G=!1,H()},le);return{isTriggered:()=>G,dispose:()=>{clearTimeout(Y),G=!1}}},f=le=>{let H=!0;return queueMicrotask(()=>{H&&(H=!1,le())}),{isTriggered:()=>H,dispose:()=>{H=!1}}};class a{constructor(H){this.defaultDelay=H,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(H,G=this.defaultDelay){this.g=H,this.h(),this.b||(this.b=new Promise((X,be)=>{this.d=X,this.f=be}).then(()=>{if(this.b=null,this.d=null,this.g){const X=this.g;return this.g=null,X()}}));const Y=()=>{this.a=null,this.d?.(null)};return this.a=G===k.$Ld?f(Y):c(G,Y),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new M.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Rg=a;class t{constructor(H){this.a=new a(H),this.b=new h}trigger(H,G){return this.a.trigger(()=>this.b.queue(H),G)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Sg=t;class i{constructor(){this.a=!1,this.b=new Promise((H,G)=>{this.d=H})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Tg=i;class s extends i{constructor(H){super(),this.f=setTimeout(()=>this.open(),H)}open(){clearTimeout(this.f),super.open()}}e.$Ug=s;function n(le,H){return H?new Promise((G,Y)=>{const X=setTimeout(()=>{be.dispose(),G()},le),be=H.onCancellationRequested(()=>{clearTimeout(X),be.dispose(),Y(new M.$5)})}):R(G=>n(le,G))}e.$Vg=n;function r(le,H=0,G){const Y=setTimeout(()=>{le(),G&&X.dispose()},H),X=(0,L.$Qc)(()=>{clearTimeout(Y),G?.deleteAndLeak(X)});return G?.add(X),X}e.$Wg=r;function o(le){const H=[];let G=0;const Y=le.length;function X(){return G<Y?le[G++]():null}function be(se){se!=null&&H.push(se);const ge=X();return ge?ge.then(be):Promise.resolve(H)}return Promise.resolve(null).then(be)}e.$Xg=o;function v(le,H=Y=>!!Y,G=null){let Y=0;const X=le.length,be=()=>{if(Y>=X)return Promise.resolve(G);const se=le[Y++];return Promise.resolve(se()).then(te=>H(te)?Promise.resolve(te):be())};return be()}e.$Yg=v;function C(le,H=Y=>!!Y,G=null){if(le.length===0)return Promise.resolve(G);let Y=le.length;const X=()=>{Y=-1;for(const be of le)be.cancel?.()};return new Promise((be,se)=>{for(const ge of le)ge.then(te=>{--Y>=0&&H(te)?(X(),be(te)):Y===0&&be(G)}).catch(te=>{--Y>=0&&(X(),se(te))})})}e.$Zg=C;class w{constructor(H){this.a=0,this.d=H,this.f=[],this.b=0,this.g=new l.$Od}get onDrained(){return this.g.event}get size(){return this.a}queue(H){return this.a++,new Promise((G,Y)=>{this.f.push({factory:H,c:G,e:Y}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const H=this.f.shift();this.b++;const G=H.factory();G.then(H.c,H.e),G.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$1g=w;class m extends w{constructor(){super(1)}}e.$2g=m;class b{constructor(){this.a=new he,this.b=0}queue(H){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,H())):this.a.run(this.b++,H())}}e.$3g=b;class I{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const H=new Z;return this.b.add(H),H.p}g(){for(const[,H]of this.a)if(H.size>0)return!1;return!0}queueFor(H,G=A.$mg){const Y=G.getComparisonKey(H);let X=this.a.get(Y);if(!X){X=new m;const be=this.f++,se=l.Event.once(X.onDrained)(()=>{X?.dispose(),this.a.delete(Y),this.h(),this.d?.deleteAndDispose(be),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new L.$1c),this.d.set(be,se),this.a.set(Y,X)}return X}h(){this.g()&&this.j()}j(){for(const H of this.b)H.complete();this.b.clear()}dispose(){for(const[,H]of this.a)H.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$4g=I;class z{constructor(H,G){this.a=-1,typeof H=="function"&&typeof G=="number"&&this.setIfNotSet(H,G)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(H,G){this.cancel(),this.a=setTimeout(()=>{this.a=-1,H()},G)}setIfNotSet(H,G){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,H()},G))}}e.$5g=z;class O{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(H,G){this.cancel(),this.a=setInterval(()=>{H()},G)}}e.$6g=O;class F{constructor(H,G){this.b=-1,this.a=H,this.d=G,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(H=this.d){this.cancel(),this.b=setTimeout(this.f,H)}get delay(){return this.d}set delay(H){this.d=H}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$7g=F;class T{constructor(H,G){G%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${G}ms is not a multiple of 1000ms.`),this.a=H,this.b=G,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(H=this.b){H%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${H}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(H/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$8g=T;class N extends F{constructor(H,G){super(H,G),this.j=[]}work(H){this.j.push(H),this.isScheduled()||this.schedule()}h(){const H=this.j;this.j=[],this.a?.(H)}dispose(){this.j=[],super.dispose()}}e.$9g=N;class j extends L.$Sc{constructor(H,G){super(),this.g=H,this.h=G,this.a=[],this.b=this.B(new L.$Tc),this.f=!1}get pending(){return this.a.length}work(H){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+H.length>this.g.maxBufferedWork)return!1}else if(this.pending+H.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const G of H)this.a.push(G);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new F(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$0g=j,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.$$g=le=>{(0,g.$v)(()=>{if(H)return;const G=Date.now()+15;le(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,G-Date.now())}}))});let H=!1;return{dispose(){H||(H=!0)}}}:e.$$g=(le,H)=>{const G=requestIdleCallback(le,typeof H=="number"?{timeout:H}:void 0);let Y=!1;return{dispose(){Y||(Y=!0,cancelIdleCallback(G))}}}}();class U{constructor(H){this.d=!1,this.a=()=>{try{this.f=H()}catch(G){this.g=G}finally{this.d=!0}},this.b=(0,e.$$g)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.$_g=U;async function B(le,H,G){let Y;for(let X=0;X<G;X++)try{return await le()}catch(be){Y=be,await n(H)}throw Y}e.$ah=B;class he{isRunning(H){return typeof H=="number"?this.a?.taskId===H:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(H,G,Y){return this.a={taskId:H,cancel:()=>Y?.(),promise:G},G.then(()=>this.d(H),()=>this.d(H)),G}d(H){this.a&&H===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const H=this.b;this.b=void 0,H.run().then(H.promiseResolve,H.promiseReject)}}queue(H){if(this.b)this.b.run=H;else{let G,Y;const X=new Promise((be,se)=>{G=be,Y=se});this.b={run:H,promise:X,promiseResolve:G,promiseReject:Y}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$bh=he;class x{constructor(H,G=()=>Date.now()){this.d=H,this.f=G,this.a=0,this.b=0}increment(){const H=this.f();return H-this.a>this.d&&(this.a=H,this.b=0),this.b++,this.b}}e.$ch=x;var Q;(function(le){le[le.Resolved=0]="Resolved",le[le.Rejected=1]="Rejected"})(Q||(Q={}));class Z{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((H,G)=>{this.a=H,this.b=G})}complete(H){return new Promise(G=>{this.a(H),this.d={outcome:0,value:H},G()})}error(H){return new Promise(G=>{this.b(H),this.d={outcome:1,value:H},G()})}cancel(){return this.error(new M.$5)}}e.$dh=Z;var ie;(function(le){async function H(Y){let X;const be=await Promise.all(Y.map(se=>se.then(ge=>ge,ge=>{X||(X=ge)})));if(typeof X<"u")throw X;return be}le.settled=H;function G(Y){return new Promise(async(X,be)=>{try{await Y(X,be)}catch(se){be(se)}})}le.withAsyncBody=G})(ie||(e.Promises=ie={}));var _;(function(le){le[le.Initial=0]="Initial",le[le.DoneOK=1]="DoneOK",le[le.DoneError=2]="DoneError"})(_||(_={}));class oe{static fromArray(H){return new oe(G=>{G.emitMany(H)})}static fromPromise(H){return new oe(async G=>{G.emitMany(await H)})}static fromPromises(H){return new oe(async G=>{await Promise.all(H.map(async Y=>G.emitOne(await Y)))})}static merge(H){return new oe(async G=>{await Promise.all(H.map(async Y=>{for await(const X of Y)G.emitOne(X)}))})}constructor(H){this.a=0,this.b=[],this.d=null,this.f=new l.$Od,queueMicrotask(async()=>{const G={emitOne:Y=>this.g(Y),emitMany:Y=>this.h(Y),reject:Y=>this.k(Y)};try{await Promise.resolve(H(G)),this.j()}catch(Y){this.k(Y)}finally{G.emitOne=void 0,G.emitMany=void 0,G.reject=void 0}})}[Symbol.asyncIterator](){let H=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(H<this.b.length)return{done:!1,value:this.b[H++]};if(this.a===1)return{done:!0,value:void 0};await l.Event.toPromise(this.f.event)}while(!0)}}}static map(H,G){return new oe(async Y=>{for await(const X of H)Y.emitOne(G(X))})}map(H){return oe.map(this,H)}static filter(H,G){return new oe(async Y=>{for await(const X of H)G(X)&&Y.emitOne(X)})}filter(H){return oe.filter(this,H)}static coalesce(H){return oe.filter(H,G=>!!G)}coalesce(){return oe.coalesce(this)}static async toPromise(H){const G=[];for await(const Y of H)G.push(Y);return G}toPromise(){return oe.toPromise(this)}g(H){this.a===0&&(this.b.push(H),this.f.fire())}h(H){this.a===0&&(this.b=this.b.concat(H),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(H){this.a===0&&(this.a=2,this.d=H,this.f.fire())}}e.$eh=oe,oe.EMPTY=oe.fromArray([]);class ye extends oe{constructor(H,G){super(G),this.l=H}cancel(){this.l.cancel()}}e.$fh=ye;function fe(le){const H=new y.$Yd,G=le(H.token);return new ye(H,async Y=>{const X=H.token.onCancellationRequested(()=>{X.dispose(),H.dispose(),Y.reject(new M.$5)});try{for await(const be of G){if(H.token.isCancellationRequested)return;Y.emitOne(be)}X.dispose(),H.dispose()}catch(be){X.dispose(),H.dispose(),Y.reject(be)}})}e.$gh=fe;class V{constructor(){this.a=new Z,this.b=new oe(Y=>{if(H){Y.reject(H);return}return G&&Y.emitMany(G),this.d=X=>Y.reject(X),this.f=X=>Y.emitOne(X),this.a.p});let H,G;this.f=Y=>{G||(G=[]),G.push(Y)},this.d=Y=>{H||(H=Y)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(H){this.d(H),this.a.complete()}emitOne(H){this.f(H)}}e.$hh=V}),define(De[36],Ce([1,0,19,8,32,28,15,12,16]),function(re,e,y,M,l,L,A,g,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bj=e.$Aj=e.$zj=e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=void 0;function $(){return Object.create(null)}e.$sj=$,e.$tj="**",e.$uj="/";const R="[/\\\\]",P="[^/\\\\]",p=/\//g;function S(he,x){switch(he){case 0:return"";case 1:return`${P}*?`;default:return`(?:${R}|${P}+${R}${x?`|${R}${P}+`:""})*?`}}function D(he,x){if(!he)return[];const Q=[];let Z=!1,ie=!1,_="";for(const oe of he){switch(oe){case x:if(!Z&&!ie){Q.push(_),_="";continue}break;case"{":Z=!0;break;case"}":Z=!1;break;case"[":ie=!0;break;case"]":ie=!1;break}_+=oe}return _&&Q.push(_),Q}e.$vj=D;function E(he){if(!he)return"";let x="";const Q=D(he,e.$uj);if(Q.every(Z=>Z===e.$tj))x=".*";else{let Z=!1;Q.forEach((ie,_)=>{if(ie===e.$tj){if(Z)return;x+=S(2,_===Q.length-1)}else{let oe=!1,ye="",fe=!1,V="";for(const le of ie){if(le!=="}"&&oe){ye+=le;continue}if(fe&&(le!=="]"||!V)){let H;le==="-"?H=le:(le==="^"||le==="!")&&!V?H="^":le===e.$uj?H="":H=(0,k.$Ge)(le),V+=H;continue}switch(le){case"{":oe=!0;continue;case"[":fe=!0;continue;case"}":{const G=`(?:${D(ye,",").map(Y=>E(Y)).join("|")})`;x+=G,oe=!1,ye="";break}case"]":{x+="["+V+"]",fe=!1,V="";break}case"?":x+=P;continue;case"*":x+=S(1);continue;default:x+=(0,k.$Ge)(le)}}_<Q.length-1&&(Q[_+1]!==e.$tj||_+2<Q.length)&&(x+=R)}Z=ie===e.$tj})}return x}const h=/^\*\*\/\*\.[\w\.-]+$/,u=/^\*\*\/([\w\.-]+)\/?$/,d=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,c=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,f=/^\*\*((\/[\w\.-]+)+)\/?$/,a=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new L.$Dc(1e4),i=function(){return!1},s=function(){return null};function n(he,x){if(!he)return s;let Q;typeof he!="string"?Q=he.pattern:Q=he,Q=Q.trim();const Z=`${Q}_${!!x.trimForExclusions}`;let ie=t.get(Z);if(ie)return r(ie,he);let _;return h.test(Q)?ie=v(Q.substr(4),Q):(_=u.exec(o(Q,x)))?ie=C(_[1],Q):(x.trimForExclusions?c:d).test(Q)?ie=w(Q,x):(_=f.exec(o(Q,x)))?ie=m(_[1].substr(1),Q,!0):(_=a.exec(o(Q,x)))?ie=m(_[1],Q,!1):ie=b(Q),t.set(Z,ie),r(ie,he)}function r(he,x){if(typeof x=="string")return he;const Q=function(Z,ie){return(0,l.$Yf)(Z,x.base,!g.$f)?he((0,k.$Ke)(Z.substr(x.base.length),A.sep),ie):null};return Q.allBasenames=he.allBasenames,Q.allPaths=he.allPaths,Q.basenames=he.basenames,Q.patterns=he.patterns,Q}function o(he,x){return x.trimForExclusions&&he.endsWith("/**")?he.substr(0,he.length-2):he}function v(he,x){return function(Q,Z){return typeof Q=="string"&&Q.endsWith(he)?x:null}}function C(he,x){const Q=`/${he}`,Z=`\\${he}`,ie=function(oe,ye){return typeof oe!="string"?null:ye?ye===he?x:null:oe===he||oe.endsWith(Q)||oe.endsWith(Z)?x:null},_=[he];return ie.basenames=_,ie.patterns=[x],ie.allBasenames=_,ie}function w(he,x){const Q=U(he.slice(1,-1).split(",").map(ye=>n(ye,x)).filter(ye=>ye!==s),he),Z=Q.length;if(!Z)return s;if(Z===1)return Q[0];const ie=function(ye,fe){for(let V=0,le=Q.length;V<le;V++)if(Q[V](ye,fe))return he;return null},_=Q.find(ye=>!!ye.allBasenames);_&&(ie.allBasenames=_.allBasenames);const oe=Q.reduce((ye,fe)=>fe.allPaths?ye.concat(fe.allPaths):ye,[]);return oe.length&&(ie.allPaths=oe),ie}function m(he,x,Q){const Z=A.sep===A.$gc.sep,ie=Z?he:he.replace(p,A.sep),_=A.sep+ie,oe=A.$gc.sep+he;let ye;return Q?ye=function(fe,V){return typeof fe=="string"&&(fe===ie||fe.endsWith(_)||!Z&&(fe===he||fe.endsWith(oe)))?x:null}:ye=function(fe,V){return typeof fe=="string"&&(fe===ie||!Z&&fe===he)?x:null},ye.allPaths=[(Q?"*/":"./")+he],ye}function b(he){try{const x=new RegExp(`^${E(he)}$`);return function(Q){return x.lastIndex=0,typeof Q=="string"&&x.test(Q)?he:null}}catch{return s}}function I(he,x,Q){return!he||typeof x!="string"?!1:z(he)(x,void 0,Q)}e.$wj=I;function z(he,x={}){if(!he)return i;if(typeof he=="string"||O(he)){const Q=n(he,x);if(Q===s)return i;const Z=function(ie,_){return!!Q(ie,_)};return Q.allBasenames&&(Z.allBasenames=Q.allBasenames),Q.allPaths&&(Z.allPaths=Q.allPaths),Z}return N(he,x)}e.$xj=z;function O(he){const x=he;return x?typeof x.base=="string"&&typeof x.pattern=="string":!1}e.$yj=O;function F(he){return he.allBasenames||[]}e.$zj=F;function T(he){return he.allPaths||[]}e.$Aj=T;function N(he,x){const Q=U(Object.getOwnPropertyNames(he).map(ye=>j(ye,he[ye],x)).filter(ye=>ye!==s)),Z=Q.length;if(!Z)return s;if(!Q.some(ye=>!!ye.requiresSiblings)){if(Z===1)return Q[0];const ye=function(le,H){let G;for(let Y=0,X=Q.length;Y<X;Y++){const be=Q[Y](le,H);if(typeof be=="string")return be;(0,M.$Hg)(be)&&(G||(G=[]),G.push(be))}return G?(async()=>{for(const Y of G){const X=await Y;if(typeof X=="string")return X}return null})():null},fe=Q.find(le=>!!le.allBasenames);fe&&(ye.allBasenames=fe.allBasenames);const V=Q.reduce((le,H)=>H.allPaths?le.concat(H.allPaths):le,[]);return V.length&&(ye.allPaths=V),ye}const ie=function(ye,fe,V){let le,H;for(let G=0,Y=Q.length;G<Y;G++){const X=Q[G];X.requiresSiblings&&V&&(fe||(fe=(0,A.$nc)(ye)),le||(le=fe.substr(0,fe.length-(0,A.$oc)(ye).length)));const be=X(ye,fe,le,V);if(typeof be=="string")return be;(0,M.$Hg)(be)&&(H||(H=[]),H.push(be))}return H?(async()=>{for(const G of H){const Y=await G;if(typeof Y=="string")return Y}return null})():null},_=Q.find(ye=>!!ye.allBasenames);_&&(ie.allBasenames=_.allBasenames);const oe=Q.reduce((ye,fe)=>fe.allPaths?ye.concat(fe.allPaths):ye,[]);return oe.length&&(ie.allPaths=oe),ie}function j(he,x,Q){if(x===!1)return s;const Z=n(he,Q);if(Z===s)return s;if(typeof x=="boolean")return Z;if(x){const ie=x.when;if(typeof ie=="string"){const _=(oe,ye,fe,V)=>{if(!V||!Z(oe,ye))return null;const le=ie.replace("$(basename)",()=>fe),H=V(le);return(0,M.$Hg)(H)?H.then(G=>G?he:null):H?he:null};return _.requiresSiblings=!0,_}}return Z}function U(he,x){const Q=he.filter(ye=>!!ye.basenames);if(Q.length<2)return he;const Z=Q.reduce((ye,fe)=>{const V=fe.basenames;return V?ye.concat(V):ye},[]);let ie;if(x){ie=[];for(let ye=0,fe=Z.length;ye<fe;ye++)ie.push(x)}else ie=Q.reduce((ye,fe)=>{const V=fe.patterns;return V?ye.concat(V):ye},[]);const _=function(ye,fe){if(typeof ye!="string")return null;if(!fe){let le;for(le=ye.length;le>0;le--){const H=ye.charCodeAt(le-1);if(H===47||H===92)break}fe=ye.substr(le)}const V=Z.indexOf(fe);return V!==-1?ie[V]:null};_.basenames=Z,_.patterns=ie,_.allBasenames=Z;const oe=he.filter(ye=>!ye.basenames);return oe.push(_),oe}function B(he,x){return(0,y.$ub)(he,x,(Q,Z)=>typeof Q=="string"&&typeof Z=="string"?Q===Z:typeof Q!="string"&&typeof Z!="string"?Q.base===Z.base&&Q.pattern===Z.pattern:!1)}e.$Bj=B}),define(De[80],Ce([1,0,9,162,23,16,2]),function(re,e,y,M,l,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$j=e.$0j=e.$9j=e.$8j=e.$7j=e.$6j=e.$5j=e.$4j=e.MarkdownStringTextNewlineStyle=void 0;var g;(function(h){h[h.Paragraph=0]="Paragraph",h[h.Break=1]="Break"})(g||(e.MarkdownStringTextNewlineStyle=g={}));class k{constructor(u="",d=!1){if(this.value=u,typeof this.value!="string")throw(0,y.$7)("value");typeof d=="boolean"?(this.isTrusted=d,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=d.isTrusted??void 0,this.supportThemeIcons=d.supportThemeIcons??!1,this.supportHtml=d.supportHtml??!1)}appendText(u,d=0){return this.value+=p(this.supportThemeIcons?(0,M.$Xj)(u):u).replace(/([ \t]+)/g,(c,f)=>"&nbsp;".repeat(f.length)).replace(/\>/gm,"\\>").replace(/\n/g,d===1?`\\
`:`

`),this}appendMarkdown(u){return this.value+=u,this}appendCodeblock(u,d){return this.value+="\n```",this.value+=u,this.value+=`
`,this.value+=d,this.value+="\n```\n",this}appendLink(u,d,c){return this.value+="[",this.value+=this.c(d,"]"),this.value+="](",this.value+=this.c(String(u),")"),c&&(this.value+=` "${this.c(this.c(c,'"'),")")}"`),this.value+=")",this}c(u,d){const c=new RegExp((0,L.$Ge)(d),"g");return u.replace(c,(f,a)=>u.charAt(a-1)!=="\\"?`\\${f}`:f)}}e.$4j=k;function $(h){return R(h)?!h.value:Array.isArray(h)?h.every($):!0}e.$5j=$;function R(h){return h instanceof k?!0:h&&typeof h=="object"?typeof h.value=="string"&&(typeof h.isTrusted=="boolean"||typeof h.isTrusted=="object"||h.isTrusted===void 0)&&(typeof h.supportThemeIcons=="boolean"||h.supportThemeIcons===void 0):!1}e.$6j=R;function P(h,u){return h===u?!0:!h||!u?!1:h.value===u.value&&h.isTrusted===u.isTrusted&&h.supportThemeIcons===u.supportThemeIcons&&h.supportHtml===u.supportHtml&&(h.baseUri===u.baseUri||!!h.baseUri&&!!u.baseUri&&(0,l.$pg)(A.URI.from(h.baseUri),A.URI.from(u.baseUri)))}e.$7j=P;function p(h){return h.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.$8j=p;function S(h){return h.replace(/"/g,"&quot;")}e.$9j=S;function D(h){return h&&h.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.$0j=D;function E(h){const u=[],d=h.split("|").map(f=>f.trim());h=d[0];const c=d[1];if(c){const f=/height=(\d+)/.exec(c),a=/width=(\d+)/.exec(c),t=f?f[1]:"",i=a?a[1]:"",s=isFinite(parseInt(i)),n=isFinite(parseInt(t));s&&u.push(`width="${i}"`),n&&u.push(`height="${t}"`)}return{href:h,dimensions:u}}e.$$j=E}),define(De[99],Ce([1,0,19,32,15,12,23,16]),function(re,e,y,M,l,L,A,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fv=e.$Ev=e.$Dv=e.$Cv=e.$Bv=e.$Av=e.$zv=e.$yv=e.$xv=e.$wv=void 0;function k(n,r){const{os:o,tildify:v,relative:C}=r;if(C){const b=$(n,C,o);if(typeof b=="string")return b}let w=n.fsPath;if(o===1&&!L.$d?w=w.replace(/\//g,"\\"):o!==1&&L.$d&&(w=w.replace(/\\/g,"/")),o!==1&&v?.userHome){const b=v.userHome.fsPath;let I;n.scheme!==v.userHome.scheme&&n.path.startsWith(l.$gc.sep)?I=v.userHome.with({path:n.path}).fsPath:I=n.fsPath,w=p(I,b,o)}return(o===1?l.$fc:l.$gc).normalize(R(w,o===1))}e.$wv=k;function $(n,r,o){const v=o===1?l.$fc:l.$gc,C=o===3?A.$mg:A.$og,w=r.getWorkspace(),m=(0,y.$Ob)(w.folders);if(!m)return;n.scheme!==m.uri.scheme&&n.path.startsWith(l.$gc.sep)&&(n=m.uri.with({path:n.path}));const b=r.getWorkspaceFolder(n);if(!b)return;let I;if(C.isEqual(b.uri,n)?I="":I=C.relativePath(b.uri,n)??"",I&&(I=v.normalize(I)),w.folders.length>1&&!r.noPrefix){const z=b.name?b.name:C.basenameOrAuthority(b.uri);I=I?`${z} \u2022 ${I}`:z}return I}function R(n,r=L.$d){return(0,M.$3f)(n,r)?n.charAt(0).toUpperCase()+n.slice(1):n}e.$xv=R;let P=Object.create(null);function p(n,r,o=L.OS){if(o===1||!n||!r)return n;let v=P.original===r?P.normalized:void 0;v||(v=r,L.$d&&(v=(0,M.$Sf)(v)),v=`${(0,g.$Le)(v,l.$gc.sep)}${l.$gc.sep}`,P={original:r,normalized:v});let C=n;return L.$d&&(C=(0,M.$Sf)(C)),(o===3?C.startsWith(v):(0,g.$4e)(C,v))?`~/${C.substr(v.length)}`:n}e.$yv=p;function S(n,r){return n.replace(/^~($|\/|\\)/,`${r}$1`)}e.$zv=S;const D="\u2026",E="\\\\",h="~";function u(n,r=l.sep){const o=new Array(n.length);let v=!1;for(let C=0;C<n.length;C++){const w=n[C];if(w===""){o[C]=`.${r}`;continue}if(!w){o[C]=w;continue}v=!0;let m="",b=w;b.indexOf(E)===0?(m=b.substr(0,b.indexOf(E)+E.length),b=b.substr(b.indexOf(E)+E.length)):b.indexOf(r)===0?(m=b.substr(0,b.indexOf(r)+r.length),b=b.substr(b.indexOf(r)+r.length)):b.indexOf(h)===0&&(m=b.substr(0,b.indexOf(h)+h.length),b=b.substr(b.indexOf(h)+h.length));const I=b.split(r);for(let z=1;v&&z<=I.length;z++)for(let O=I.length-z;v&&O>=0;O--){v=!1;let F=I.slice(O,O+z).join(r);for(let T=0;!v&&T<n.length;T++)if(T!==C&&n[T]&&n[T].indexOf(F)>-1){const N=O+z===I.length,j=O>0&&n[T].indexOf(r)>-1?r+F:F,U=n[T].endsWith(j);v=!N||U}if(!v){let T="";(I[0].endsWith(":")||m!=="")&&(O===1&&(O=0,z++,F=I[0]+r+F),O>0&&(T=I[0]+r),T=m+T),O>0&&(T=T+D+r),T=T+F,O+z<I.length&&(T=T+r+D),o[C]=T}}v&&(o[C]=w)}return o}e.$Av=u;var d;(function(n){n[n.TEXT=0]="TEXT",n[n.VARIABLE=1]="VARIABLE",n[n.SEPARATOR=2]="SEPARATOR"})(d||(d={}));function c(n,r=Object.create(null)){const o=[];let v=!1,C="";for(const w of n)if(w==="$"||v&&w==="{")C&&o.push({value:C,type:d.TEXT}),C="",v=!0;else if(w==="}"&&v){const m=r[C];if(typeof m=="string")m.length&&o.push({value:m,type:d.VARIABLE});else if(m){const b=o[o.length-1];(!b||b.type!==d.SEPARATOR)&&o.push({value:m.label,type:d.SEPARATOR})}C="",v=!1}else C+=w;return C&&!v&&o.push({value:C,type:d.TEXT}),o.filter((w,m)=>{if(w.type===d.SEPARATOR){const b=o[m-1],I=o[m+1];return[b,I].every(z=>z&&(z.type===d.VARIABLE||z.type===d.TEXT)&&z.value.length>0)}return!0}).map(w=>w.value).join("")}e.$Bv=c;function f(n,r){return L.$e||r?n.replace(/\(&&\w\)|&&/g,"").replace(/&/g,L.$e?"&":"&&"):n.replace(/&&|&/g,o=>o==="&"?"&&":"&")}e.$Cv=f;function a(n,r){return L.$e||r?n.replace(/\(&&\w\)|&&/g,""):L.$d?n.replace(/&&|&/g,o=>o==="&"?"&&":"&"):n.replace(/&&/g,"_")}e.$Dv=a;function t(n){return n.replace(/&/g,"&&")}e.$Ev=t;function i(n){if(n.endsWith("]")){const r=n.lastIndexOf(" [",n.length-2);if(r!==-1){const o=s(n.substring(0,r));return{name:o.name,parentPath:o.parentPath+n.substring(r)}}}return s(n)}e.$Fv=i;function s(n){const r=n.indexOf("/")!==-1?l.$gc:l.$fc,o=r.basename(n),v=r.dirname(n);return o.length?{name:o,parentPath:v}:{name:v,parentPath:""}}}),define(De[126],Ce([1,0,22,2]),function(re,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rm=e.$Qm=e.$Pm=e.$Om=e.$Nm=void 0;function l(P){return P.toJSON()}class L{constructor(p){this.a=p}transformIncoming(p){const S=this.a.transformIncoming(p);return S===p?p:l(M.URI.from(S))}transformOutgoing(p){const S=this.a.transformOutgoing(p);return S===p?p:l(M.URI.from(S))}transformOutgoingURI(p){const S=this.a.transformOutgoing(p);return S===p?p:M.URI.from(S)}transformOutgoingScheme(p){return this.a.transformOutgoingScheme(p)}}e.$Nm=L,e.$Om=new class{transformIncoming(P){return P}transformOutgoing(P){return P}transformOutgoingURI(P){return P}transformOutgoingScheme(P){return P}};function A(P,p,S){if(!P||S>200)return null;if(typeof P=="object"){if(P instanceof M.URI)return p.transformOutgoing(P);for(const D in P)if(Object.hasOwnProperty.call(P,D)){const E=A(P[D],p,S+1);E!==null&&(P[D]=E)}}return null}function g(P,p){const S=A(P,p,0);return S===null?P:S}e.$Pm=g;function k(P,p,S,D){if(!P||D>200)return null;if(typeof P=="object"){if(P.$mid===1)return S?M.URI.revive(p.transformIncoming(P)):p.transformIncoming(P);if(P instanceof y.$ce)return null;for(const E in P)if(Object.hasOwnProperty.call(P,E)){const h=k(P[E],p,S,D+1);h!==null&&(P[E]=h)}}return null}function $(P,p){const S=k(P,p,!1,0);return S===null?P:S}e.$Qm=$;function R(P,p){const S=k(P,p,!0,0);return S===null?P:S}e.$Rm=R}),define(De[31],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fg=e.$eg=void 0;const y=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function M(l){return y.test(l)}e.$eg=M,e.$fg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let l;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?l=crypto.getRandomValues.bind(crypto):l=function(g){for(let k=0;k<g.length;k++)g[k]=Math.floor(Math.random()*256);return g};const L=new Uint8Array(16),A=[];for(let g=0;g<256;g++)A.push(g.toString(16).padStart(2,"0"));return function(){l(L),L[6]=L[6]&15|64,L[8]=L[8]&63|128;let k=0,$="";return $+=A[L[k++]],$+=A[L[k++]],$+=A[L[k++]],$+=A[L[k++]],$+="-",$+=A[L[k++]],$+=A[L[k++]],$+="-",$+=A[L[k++]],$+=A[L[k++]],$+="-",$+=A[L[k++]],$+=A[L[k++]],$+="-",$+=A[L[k++]],$+=A[L[k++]],$+=A[L[k++]],$+=A[L[k++]],$+=A[L[k++]],$+=A[L[k++]],$}}()}),define(De[165],Ce([1,0,19,51,31]),function(re,e,y,M,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8s=e.$7s=e.$6s=e.$5s=e.$4s=void 0;function L(P){return{asString:async()=>P,asFile:()=>{},value:typeof P=="string"?P:void 0}}e.$4s=L;function A(P,p,S){const D={id:(0,l.$fg)(),name:P,uri:p,data:S};return{asString:async()=>"",asFile:()=>D,value:void 0}}e.$5s=A;class g{constructor(){this.a=new Map}get size(){let p=0;for(const S of this.a)p++;return p}has(p){return this.a.has(this.b(p))}matches(p){const S=[...this.a.keys()];return M.Iterable.some(this,([D,E])=>E.asFile())&&S.push("files"),R(k(p),S)}get(p){return this.a.get(this.b(p))?.[0]}append(p,S){const D=this.a.get(p);D?D.push(S):this.a.set(this.b(p),[S])}replace(p,S){this.a.set(this.b(p),[S])}delete(p){this.a.delete(this.b(p))}*[Symbol.iterator](){for(const[p,S]of this.a)for(const D of S)yield[p,D]}b(p){return k(p)}}e.$6s=g;function k(P){return P.toLowerCase()}function $(P,p){return R(k(P),p.map(k))}e.$7s=$;function R(P,p){if(P==="*/*")return p.length>0;if(p.includes(P))return!0;const S=P.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!S)return!1;const[D,E,h]=S;return h==="*"?p.some(u=>u.startsWith(E+"/")):!1}e.$8s=Object.freeze({create:P=>(0,y.$Mb)(P.map(p=>p.toString())).join(`\r
`),split:P=>P.split(`\r
`),parse:P=>e.$8s.split(P).filter(p=>!p.startsWith("#"))})}),define(De[29],Ce([1,0,53,61,373,8,32,77,15,12,23,2]),function(re,e,y,M,l,L,A,g,k,$,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var p;(function(j){j[j.UNLINK=0]="UNLINK",j[j.MOVE=1]="MOVE"})(p||(e.RimRafMode=p={}));async function S(j,U=p.UNLINK,B){if((0,A.$2f)(j))throw new Error("rimraf - will refuse to recursively delete root");return U===p.UNLINK?E(j):D(j,B)}async function D(j,U=(0,A.$7f)((0,M.tmpdir)())){try{try{await y.promises.rename(j,U)}catch(B){return B.code==="ENOENT"?void 0:E(j)}E(U).catch(B=>{})}catch(B){if(B.code!=="ENOENT")throw B}}async function E(j){return(0,l.promisify)(y.rm)(j,{recursive:!0,force:!0,maxRetries:3})}function h(j){if((0,A.$2f)(j))throw new Error("rimraf - will refuse to recursively delete root");y.rmSync(j,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=h;async function u(j,U){return f(await(U?d(j):(0,l.promisify)(y.readdir)(j)))}async function d(j){try{return await(0,l.promisify)(y.readdir)(j,{withFileTypes:!0})}catch(he){console.warn("[node.js fs] readdir with filetypes failed with error: ",he)}const U=[],B=await u(j);for(const he of B){let x=!1,Q=!1,Z=!1;try{const ie=await e.Promises.lstat((0,k.$jc)(j,he));x=ie.isFile(),Q=ie.isDirectory(),Z=ie.isSymbolicLink()}catch(ie){console.warn("[node.js fs] unexpected error from lstat after readdir: ",ie)}U.push({name:he,isFile:()=>x,isDirectory:()=>Q,isSymbolicLink:()=>Z})}return U}function c(j){return f(y.readdirSync(j))}e.readdirSync=c;function f(j){return j.map(U=>typeof U=="string"?$.$e?(0,g.$ql)(U):U:(U.name=$.$e?(0,g.$ql)(U.name):U.name,U))}async function a(j){const U=await u(j),B=[];for(const he of U)await i.existsDirectory((0,k.$jc)(j,he))&&B.push(he);return B}function t(j,U=1e3){return new Promise(B=>{let he=!1;const x=setInterval(()=>{he||(he=!0,y.access(j,Q=>{he=!1,Q&&(clearInterval(x),B(void 0))}))},U)})}e.whenDeleted=t;var i;(function(j){async function U(x){let Q;try{if(Q=await e.Promises.lstat(x),!Q.isSymbolicLink())return{stat:Q}}catch{}try{return{stat:await e.Promises.stat(x),symbolicLink:Q?.isSymbolicLink()?{dangling:!1}:void 0}}catch(Z){if(Z.code==="ENOENT"&&Q)return{stat:Q,symbolicLink:{dangling:!0}};if($.$d&&Z.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(x)),symbolicLink:{dangling:!1}}}catch(ie){if(ie.code==="ENOENT"&&Q)return{stat:Q,symbolicLink:{dangling:!0}};throw ie}throw Z}}j.stat=U;async function B(x){try{const{stat:Q,symbolicLink:Z}=await j.stat(x);return Q.isFile()&&Z?.dangling!==!0}catch{}return!1}j.existsFile=B;async function he(x){try{const{stat:Q,symbolicLink:Z}=await j.stat(x);return Q.isDirectory()&&Z?.dangling!==!0}catch{}return!1}j.existsDirectory=he})(i||(e.SymlinkSupport=i={}));const s=new L.$4g;function n(j,U,B){return s.queueFor(P.URI.file(j),R.$ng).queue(()=>{const he=w(B);return new Promise((x,Q)=>v(j,U,he,Z=>Z?Q(Z):x()))})}let r=!0;function o(j){r=j}e.configureFlushOnWrite=o;function v(j,U,B,he){if(!r)return y.writeFile(j,U,{mode:B.mode,flag:B.flag},he);y.open(j,B.flag,B.mode,(x,Q)=>{if(x)return he(x);y.writeFile(Q,U,Z=>{if(Z)return y.close(Q,()=>he(Z));y.fdatasync(Q,ie=>(ie&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",ie),o(!1)),y.close(Q,_=>he(_))))})})}function C(j,U,B){const he=w(B);if(!r)return y.writeFileSync(j,U,{mode:he.mode,flag:he.flag});const x=y.openSync(j,he.flag,he.mode);try{y.writeFileSync(x,U);try{y.fdatasyncSync(x)}catch(Q){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",Q),o(!1)}}finally{y.closeSync(x)}}e.writeFileSync=C;function w(j){return j?{mode:typeof j.mode=="number"?j.mode:438,flag:typeof j.flag=="string"?j.flag:"w"}:{mode:438,flag:"w"}}async function m(j,U,B=6e4){if(j!==U)try{$.$d&&typeof B=="number"?await b(j,U,Date.now(),B):await(0,l.promisify)(y.rename)(j,U)}catch(he){if(j.toLowerCase()!==U.toLowerCase()&&he.code==="EXDEV"||j.endsWith("."))await I(j,U,{preserveSymlinks:!1}),await S(j,p.MOVE);else throw he}}async function b(j,U,B,he,x=0){try{return await(0,l.promisify)(y.rename)(j,U)}catch(Q){if(Q.code!=="EACCES"&&Q.code!=="EPERM"&&Q.code!=="EBUSY")throw Q;if(Date.now()-B>=he)throw console.error(`[node.js fs] rename failed after ${x} retries with error: ${Q}`),Q;if(x===0){let Z=!1;try{const{stat:ie}=await i.stat(U);ie.isFile()||(Z=!0)}catch{}if(Z)throw Q}return await(0,L.$Vg)(Math.min(100,x*10)),b(j,U,B,he,x+1)}}async function I(j,U,B){return O(j,U,{root:{source:j,target:U},options:B,handledSourcePaths:new Set})}const z=511;async function O(j,U,B){if(B.handledSourcePaths.has(j))return;B.handledSourcePaths.add(j);const{stat:he,symbolicLink:x}=await i.stat(j);if(x){if(B.options.preserveSymlinks)try{return await N(j,U,B)}catch(Q){console.warn("[node.js fs] copy of symlink failed: ",Q)}if(x.dangling)return}return he.isDirectory()?F(j,U,he.mode&z,B):T(j,U,he.mode&z)}async function F(j,U,B,he){await e.Promises.mkdir(U,{recursive:!0,mode:B});const x=await u(j);for(const Q of x)await O((0,k.$jc)(j,Q),(0,k.$jc)(U,Q),he)}async function T(j,U,B){await e.Promises.copyFile(j,U),await e.Promises.chmod(U,B)}async function N(j,U,B){let he=await e.Promises.readlink(j);(0,A.$Yf)(he,B.root.source,!$.$f)&&(he=(0,k.$jc)(B.root.target,he.substr(B.root.source.length+1))),await e.Promises.symlink(he,U)}e.Promises=new class{get access(){return(0,l.promisify)(y.access)}get stat(){return(0,l.promisify)(y.stat)}get lstat(){return(0,l.promisify)(y.lstat)}get utimes(){return(0,l.promisify)(y.utimes)}get read(){return(j,U,B,he,x)=>new Promise((Q,Z)=>{y.read(j,U,B,he,x,(ie,_,oe)=>ie?Z(ie):Q({bytesRead:_,buffer:oe}))})}get readFile(){return(0,l.promisify)(y.readFile)}get write(){return(j,U,B,he,x)=>new Promise((Q,Z)=>{y.write(j,U,B,he,x,(ie,_,oe)=>ie?Z(ie):Q({bytesWritten:_,buffer:oe}))})}get appendFile(){return(0,l.promisify)(y.appendFile)}get fdatasync(){return(0,l.promisify)(y.fdatasync)}get truncate(){return(0,l.promisify)(y.truncate)}get copyFile(){return(0,l.promisify)(y.copyFile)}get open(){return(0,l.promisify)(y.open)}get close(){return(0,l.promisify)(y.close)}get symlink(){return(0,l.promisify)(y.symlink)}get readlink(){return(0,l.promisify)(y.readlink)}get chmod(){return(0,l.promisify)(y.chmod)}get mkdir(){return(0,l.promisify)(y.mkdir)}get unlink(){return(0,l.promisify)(y.unlink)}get rmdir(){return(0,l.promisify)(y.rmdir)}get realpath(){return(0,l.promisify)(y.realpath)}async exists(j){try{return await e.Promises.access(j),!0}catch{return!1}}get readdir(){return u}get readDirsInDir(){return a}get writeFile(){return n}get rm(){return S}get rename(){return m}get copy(){return I}}}),define(De[100],Ce([1,0,53,15,12,16,29]),function(re,e,y,M,l,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aq=e.$_p=e.$$p=e.$0p=void 0;function g(p){if(l.$f)return p;const S=(0,M.$mc)(p);if(p===S)return p;const D=((0,M.$nc)(p)||p).toLowerCase();try{const h=(0,A.readdirSync)(S).filter(u=>u.toLowerCase()===D);if(h.length===1){const u=g(S);if(u)return(0,M.$jc)(u,h[0])}else if(h.length>1){const u=h.indexOf(D);if(u>=0){const d=g(S);if(d)return(0,M.$jc)(d,h[u])}}}catch{}return null}e.$0p=g;async function k(p){if(l.$f)return p;const S=(0,M.$mc)(p);if(p===S)return p;const D=((0,M.$nc)(p)||p).toLowerCase();try{const h=(await A.Promises.readdir(S)).filter(u=>u.toLowerCase()===D);if(h.length===1){const u=await k(S);if(u)return(0,M.$jc)(u,h[0])}else if(h.length>1){const u=h.indexOf(D);if(u>=0){const d=await k(S);if(d)return(0,M.$jc)(d,h[u])}}}catch{}return null}e.$$p=k;async function $(p){try{return await A.Promises.realpath(p)}catch{const D=P(p);return await A.Promises.access(D,y.constants.R_OK),D}}e.$_p=$;function R(p){try{return y.realpathSync(p)}catch{const D=P(p);return y.accessSync(D,y.constants.R_OK),D}}e.$aq=R;function P(p){return(0,L.$Le)((0,M.$hc)(p),M.sep)}}),define(De[166],Ce([1,0,62]),function(re,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jg=e.$ig=e.$hg=void 0;function M(g,k,$,R=1){let P=!1;return new Promise(p=>{const S=setTimeout(()=>{if(!P)return P=!0,p(0)},$);l(g,k,R,D=>{if(!P)return P=!0,clearTimeout(S),p(D)})})}e.$hg=M;function l(g,k,$,R){if(k===0)return R(0);const P=new y.Socket;P.once("connect",()=>(A(P),l(g+$,k-1,$,R))),P.once("data",()=>{}),P.once("error",p=>(A(P),p.code!=="ECONNREFUSED"?l(g+$,k-1,$,R):R(g))),P.connect(g,"127.0.0.1")}e.$ig={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function L(g,k,$,R="127.0.0.1"){let P=!1,p,S=1;const D=y.createServer({pauseOnConnect:!0});function E(h,u){P||(P=!0,D.removeAllListeners(),D.close(),p&&clearTimeout(p),u(h))}return new Promise(h=>{p=setTimeout(()=>{E(0,h)},$),D.on("listening",()=>{E(g,h)}),D.on("error",u=>{u&&(u.code==="EADDRINUSE"||u.code==="EACCES")&&S<k?(g++,S++,D.listen(g,R)):E(0,h)}),D.on("close",()=>{E(0,h)}),D.listen(g,R)})}e.$jg=L;function A(g){try{g.removeAllListeners("connect"),g.removeAllListeners("error"),g.end(),g.destroy(),g.unref()}catch(k){console.error(k)}}}),define(De[101],Ce([1,0,15,12,48,97,17,29]),function(re,e,y,M,l,L,A,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.$El=e.$Dl=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return L.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return L.TerminateResponseCode}});function k(P=l.env){return P.comspec||"cmd.exe"}e.$Dl=k;function $(P){let p=[],S=!1;const D=function(E){if(S){p.push(E);return}(!P.send(E,u=>{if(u&&console.error(u),S=!1,p.length>0){const d=p.slice(0);p=[],d.forEach(c=>D(c))}})||M.$d)&&(S=!0)};return{send:D}}e.$El=$;var R;(function(P){async function p(S,D,E){if(y.$ic(S))return S;if(D===void 0&&(D=l.cwd()),y.$mc(S)!=="."||(E===void 0&&A.$zf(l.env.PATH)&&(E=l.env.PATH.split(y.$tc)),E===void 0||E.length===0))return y.$jc(D,S);async function u(d){if(await g.Promises.exists(d)){let c;try{c=await g.Promises.stat(d)}catch(f){f.message.startsWith("EACCES")&&(c=await g.Promises.lstat(d))}return c?!c.isDirectory():!1}return!1}for(const d of E){let c;if(y.$ic(d)?c=y.$jc(d,S):c=y.$jc(D,d,S),await u(c))return c;let f=c+".com";if(await u(f)||(f=c+".exe",await u(f)))return f}return y.$jc(D,S)}P.findExecutable=p})(R||(e.win32=R={}))});var He=this&&this.__decorate||function(re,e,y,M){var l=arguments.length,L=l<3?e:M===null?M=Object.getOwnPropertyDescriptor(e,y):M,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")L=Reflect.decorate(re,e,y,M);else for(var g=re.length-1;g>=0;g--)(A=re[g])&&(L=(l<3?A(L):l>3?A(e,y,L):A(e,y))||L);return l>3&&L&&Object.defineProperty(e,y,L),L};define(De[81],Ce([1,0,19,8,22,21,57,9,4,3,60,16,17]),function(re,e,y,M,l,L,A,g,k,$,R,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zh=e.ProxyChannel=e.$yh=e.$xh=e.$wh=e.$vh=e.$uh=e.$th=e.RequestInitiator=e.$sh=e.$rh=e.$qh=e.$ph=e.$oh=void 0;var S;(function(x){x[x.Promise=100]="Promise",x[x.PromiseCancel=101]="PromiseCancel",x[x.EventListen=102]="EventListen",x[x.EventDispose=103]="EventDispose"})(S||(S={}));function D(x){switch(x){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var E;(function(x){x[x.Initialize=200]="Initialize",x[x.PromiseSuccess=201]="PromiseSuccess",x[x.PromiseError=202]="PromiseError",x[x.PromiseErrorObj=203]="PromiseErrorObj",x[x.EventFire=204]="EventFire"})(E||(E={}));function h(x){switch(x){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var u;(function(x){x[x.Uninitialized=0]="Uninitialized",x[x.Idle=1]="Idle"})(u||(u={}));function d(x){let Q=0;for(let Z=0;;Z+=7){const ie=x.read(1);if(Q|=(ie.buffer[0]&127)<<Z,!(ie.buffer[0]&128))return Q}}const c=s(0);function f(x,Q){if(Q===0){x.write(c);return}let Z=0;for(let _=Q;_!==0;_=_>>>7)Z++;const ie=l.$ce.alloc(Z);for(let _=0;Q!==0;_++)ie.buffer[_]=Q&127,Q=Q>>>7,Q>0&&(ie.buffer[_]|=128);x.write(ie)}class a{constructor(Q){this.b=Q,this.a=0}read(Q){const Z=this.b.slice(this.a,this.a+Q);return this.a+=Z.byteLength,Z}}e.$oh=a;class t{constructor(){this.a=[]}get buffer(){return l.$ce.concat(this.a)}write(Q){this.a.push(Q)}}e.$ph=t;var i;(function(x){x[x.Undefined=0]="Undefined",x[x.String=1]="String",x[x.Buffer=2]="Buffer",x[x.VSBuffer=3]="VSBuffer",x[x.Array=4]="Array",x[x.Object=5]="Object",x[x.Int=6]="Int"})(i||(i={}));function s(x){const Q=l.$ce.alloc(1);return Q.writeUInt8(x,0),Q}const n={Undefined:s(i.Undefined),String:s(i.String),Buffer:s(i.Buffer),VSBuffer:s(i.VSBuffer),Array:s(i.Array),Object:s(i.Object),Uint:s(i.Int)},r=typeof Buffer<"u";function o(x,Q){if(typeof Q>"u")x.write(n.Undefined);else if(typeof Q=="string"){const Z=l.$ce.fromString(Q);x.write(n.String),f(x,Z.byteLength),x.write(Z)}else if(r&&Buffer.isBuffer(Q)){const Z=l.$ce.wrap(Q);x.write(n.Buffer),f(x,Z.byteLength),x.write(Z)}else if(Q instanceof l.$ce)x.write(n.VSBuffer),f(x,Q.byteLength),x.write(Q);else if(Array.isArray(Q)){x.write(n.Array),f(x,Q.length);for(const Z of Q)o(x,Z)}else if(typeof Q=="number"&&(Q|0)===Q)x.write(n.Uint),f(x,Q);else{const Z=l.$ce.fromString(JSON.stringify(Q));x.write(n.Object),f(x,Z.byteLength),x.write(Z)}}e.$qh=o;function v(x){switch(x.read(1).readUInt8(0)){case i.Undefined:return;case i.String:return x.read(d(x)).toString();case i.Buffer:return x.read(d(x)).buffer;case i.VSBuffer:return x.read(d(x));case i.Array:{const Z=d(x),ie=[];for(let _=0;_<Z;_++)ie.push(v(x));return ie}case i.Object:return JSON.parse(x.read(d(x)).toString());case i.Int:return d(x)}}e.$rh=v;class C{constructor(Q,Z,ie=null,_=1e3){this.h=Q,this.j=Z,this.k=ie,this.l=_,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(oe=>this.q(oe)),this.m({type:200})}registerChannel(Q,Z){this.b.set(Q,Z),setTimeout(()=>this.w(Q),0)}m(Q){switch(Q.type){case 200:{const Z=this.o([Q.type]);this.k?.logOutgoing(Z,0,1,h(Q.type));return}case 201:case 202:case 204:case 203:{const Z=this.o([Q.type,Q.id],Q.data);this.k?.logOutgoing(Z,Q.id,1,h(Q.type),Q.data);return}}}o(Q,Z=void 0){const ie=new t;return o(ie,Q),o(ie,Z),this.p(ie.buffer)}p(Q){try{return this.h.send(Q),Q.byteLength}catch{return 0}}q(Q){const Z=new a(Q),ie=v(Z),_=v(Z),oe=ie[0];switch(oe){case 100:return this.k?.logIncoming(Q.byteLength,ie[1],1,`${D(oe)}: ${ie[2]}.${ie[3]}`,_),this.s({type:oe,id:ie[1],channelName:ie[2],name:ie[3],arg:_});case 102:return this.k?.logIncoming(Q.byteLength,ie[1],1,`${D(oe)}: ${ie[2]}.${ie[3]}`,_),this.t({type:oe,id:ie[1],channelName:ie[2],name:ie[3],arg:_});case 101:return this.k?.logIncoming(Q.byteLength,ie[1],1,`${D(oe)}`),this.u({type:oe,id:ie[1]});case 103:return this.k?.logIncoming(Q.byteLength,ie[1],1,`${D(oe)}`),this.u({type:oe,id:ie[1]})}}s(Q){const Z=this.b.get(Q.channelName);if(!Z){this.v(Q);return}const ie=new L.$Yd;let _;try{_=Z.call(this.j,Q.name,Q.arg,ie.token)}catch(fe){_=Promise.reject(fe)}const oe=Q.id;_.then(fe=>{this.m({id:oe,data:fe,type:201})},fe=>{fe instanceof Error?this.m({id:oe,data:{message:fe.message,name:fe.name,stack:fe.stack?fe.stack.split?fe.stack.split(`
`):fe.stack:void 0},type:202}):this.m({id:oe,data:fe,type:203})}).finally(()=>{ye.dispose(),this.d.delete(Q.id)});const ye=(0,$.$Qc)(()=>ie.cancel());this.d.set(Q.id,ye)}t(Q){const Z=this.b.get(Q.channelName);if(!Z){this.v(Q);return}const ie=Q.id,oe=Z.listen(this.j,Q.name,Q.arg)(ye=>this.m({id:ie,data:ye,type:204}));this.d.set(Q.id,oe)}u(Q){const Z=this.d.get(Q.id);Z&&(Z.dispose(),this.d.delete(Q.id))}v(Q){let Z=this.g.get(Q.channelName);Z||(Z=[],this.g.set(Q.channelName,Z));const ie=setTimeout(()=>{console.error(`Unknown channel: ${Q.channelName}`),Q.type===100&&this.m({id:Q.id,data:{name:"Unknown channel",message:`Channel name '${Q.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);Z.push({request:Q,timeoutTimer:ie})}w(Q){const Z=this.g.get(Q);if(Z){for(const ie of Z)switch(clearTimeout(ie.timeoutTimer),ie.request.type){case 100:this.s(ie.request);break;case 102:this.t(ie.request);break}this.g.delete(Q)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,$.$Nc)(this.d.values()),this.d.clear()}}e.$sh=C;var w;(function(x){x[x.LocalSide=0]="LocalSide",x[x.OtherSide=1]="OtherSide"})(w||(e.RequestInitiator=w={}));class m{constructor(Q,Z=null){this.l=Q,this.a=!1,this.b=u.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new k.$Od,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(ie=>this.s(ie)),this.j=Z}getChannel(Q){const Z=this;return{call(ie,_,oe){return Z.a?Promise.reject(new g.$5):Z.m(Q,ie,_,oe)},listen(ie,_){return Z.a?k.Event.None:Z.o(Q,ie,_)}}}m(Q,Z,ie,_=L.CancellationToken.None){const oe=this.g++,fe={id:oe,type:100,channelName:Q,name:Z,arg:ie};if(_.isCancellationRequested)return Promise.reject(new g.$5);let V;return new Promise((H,G)=>{if(_.isCancellationRequested)return G(new g.$5);const Y=()=>{const ge=te=>{switch(te.type){case 201:this.f.delete(oe),H(te.data);break;case 202:{this.f.delete(oe);const me=new Error(te.data.message);me.stack=Array.isArray(te.data.stack)?te.data.stack.join(`
`):te.data.stack,me.name=te.data.name,G(me);break}case 203:this.f.delete(oe),G(te.data);break}};this.f.set(oe,ge),this.p(fe)};let X=null;this.b===u.Idle?Y():(X=(0,M.$Ig)(ge=>this.u()),X.then(()=>{X=null,Y()}));const be=()=>{X?(X.cancel(),X=null):this.p({id:oe,type:101}),G(new g.$5)},se=_.onCancellationRequested(be);V=(0,$.$Pc)((0,$.$Qc)(be),se),this.d.add(V)}).finally(()=>{V.dispose(),this.d.delete(V)})}o(Q,Z,ie){const _=this.g++,ye={id:_,type:102,channelName:Q,name:Z,arg:ie};let fe=null;const V=new k.$Od({onWillAddFirstListener:()=>{fe=(0,M.$Ig)(H=>this.u()),fe.then(()=>{fe=null,this.d.add(V),this.p(ye)})},onDidRemoveLastListener:()=>{fe?(fe.cancel(),fe=null):(this.d.delete(V),this.p({id:_,type:103}))}}),le=H=>V.fire(H.data);return this.f.set(_,le),V.event}p(Q){switch(Q.type){case 100:case 102:{const Z=this.q([Q.type,Q.id,Q.channelName,Q.name],Q.arg);this.j?.logOutgoing(Z,Q.id,0,`${D(Q.type)}: ${Q.channelName}.${Q.name}`,Q.arg);return}case 101:case 103:{const Z=this.q([Q.type,Q.id]);this.j?.logOutgoing(Z,Q.id,0,D(Q.type));return}}}q(Q,Z=void 0){const ie=new t;return o(ie,Q),o(ie,Z),this.r(ie.buffer)}r(Q){try{return this.l.send(Q),Q.byteLength}catch{return 0}}s(Q){const Z=new a(Q),ie=v(Z),_=v(Z),oe=ie[0];switch(oe){case 200:return this.j?.logIncoming(Q.byteLength,0,0,h(oe)),this.t({type:ie[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(Q.byteLength,ie[1],0,h(oe),_),this.t({type:ie[0],id:ie[1],data:_})}}t(Q){if(Q.type===200){this.b=u.Idle,this.k.fire();return}this.f.get(Q.id)?.(Q)}get onDidInitializePromise(){return k.Event.toPromise(this.onDidInitialize)}u(){return this.b===u.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,$.$Nc)(this.d.values()),this.d.clear()}}e.$th=m,He([A.$ih],m.prototype,"onDidInitializePromise",null);class b{get connections(){const Q=[];return this.f.forEach(Z=>Q.push(Z)),Q}constructor(Q){this.a=new Map,this.f=new Set,this.g=new k.$Od,this.onDidAddConnection=this.g.event,this.h=new k.$Od,this.onDidRemoveConnection=this.h.event,this.j=new $.$Rc,this.j.add(Q(({protocol:Z,onDidClientDisconnect:ie})=>{const _=k.Event.once(Z.onMessage);this.j.add(_(oe=>{const ye=new a(oe),fe=v(ye),V=new C(Z,fe),le=new m(Z);this.a.forEach((G,Y)=>V.registerChannel(Y,G));const H={channelServer:V,channelClient:le,ctx:fe};this.f.add(H),this.g.fire(H),this.j.add(ie(()=>{V.dispose(),le.dispose(),this.f.delete(H),this.h.fire(H)}))}))}))}getChannel(Q,Z){const ie=this;return{call(_,oe,ye){let fe;if((0,p.$Nf)(Z)){const le=(0,y.$4b)(ie.connections.filter(Z));fe=le?Promise.resolve(le):k.Event.toPromise(k.Event.filter(ie.onDidAddConnection,Z))}else fe=Z.routeCall(ie,_,oe);const V=fe.then(le=>le.channelClient.getChannel(Q));return z(V).call(_,oe,ye)},listen(_,oe){if((0,p.$Nf)(Z))return ie.k(Q,Z,_,oe);const ye=Z.routeEvent(ie,_,oe).then(fe=>fe.channelClient.getChannel(Q));return z(ye).listen(_,oe)}}}k(Q,Z,ie,_){const oe=this;let ye;const fe=new k.$Od({onWillAddFirstListener:()=>{ye=new $.$Rc;const V=new k.$Ud,le=new Map,H=Y=>{const be=Y.channelClient.getChannel(Q).listen(ie,_),se=V.add(be);le.set(Y,se)},G=Y=>{const X=le.get(Y);X&&(X.dispose(),le.delete(Y))};oe.connections.filter(Z).forEach(H),k.Event.filter(oe.onDidAddConnection,Z)(H,void 0,ye),oe.onDidRemoveConnection(G,void 0,ye),V.event(fe.fire,fe,ye),ye.add(V)},onDidRemoveLastListener:()=>{ye?.dispose(),ye=void 0}});return fe.event}registerChannel(Q,Z){this.a.set(Q,Z);for(const ie of this.f)ie.channelServer.registerChannel(Q,Z)}dispose(){this.j.dispose();for(const Q of this.f)Q.channelClient.dispose(),Q.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$uh=b;class I{constructor(Q,Z,ie=null){const _=new t;o(_,Z),Q.send(_.buffer),this.a=new m(Q,ie),this.d=new C(Q,Z,ie)}getChannel(Q){return this.a.getChannel(Q)}registerChannel(Q,Z){this.d.registerChannel(Q,Z)}dispose(){this.a.dispose(),this.d.dispose()}}e.$vh=I;function z(x){return{call(Q,Z,ie){return x.then(_=>_.call(Q,Z,ie))},listen(Q,Z){const ie=new k.$Xd;return x.then(_=>ie.input=_.listen(Q,Z)),ie.event}}}e.$wh=z;function O(x){let Q=!1;return{call(Z,ie,_){return Q?x.call(Z,ie,_):(0,M.$Vg)(0).then(()=>Q=!0).then(()=>x.call(Z,ie,_))},listen(Z,ie){if(Q)return x.listen(Z,ie);const _=new k.$Xd;return(0,M.$Vg)(0).then(()=>Q=!0).then(()=>_.input=x.listen(Z,ie)),_.event}}}e.$xh=O;class F{constructor(Q){this.a=Q}routeCall(Q){return this.b(Q)}routeEvent(Q){return this.b(Q)}async b(Q){for(const Z of Q.connections)if(await Promise.resolve(this.a(Z.ctx)))return Promise.resolve(Z);return await k.Event.toPromise(Q.onDidAddConnection),await this.b(Q)}}e.$yh=F;var T;(function(x){function Q(oe,ye,fe){const V=oe,le=fe&&fe.disableMarshalling,H=new Map;for(const G in V)ie(G)&&H.set(G,k.Event.buffer(V[G],!0,void 0,ye));return new class{listen(G,Y,X){const be=H.get(Y);if(be)return be;if(_(Y)){const se=V[Y];if(typeof se=="function")return se.call(V,X)}throw new g.$bb(`Event not found: ${Y}`)}call(G,Y,X){const be=V[Y];if(typeof be=="function"){if(!le&&Array.isArray(X))for(let ge=0;ge<X.length;ge++)X[ge]=(0,R.$nh)(X[ge]);let se=be.apply(V,X);return se instanceof Promise||(se=Promise.resolve(se)),se}throw new g.$bb(`Method not found: ${Y}`)}}}x.fromService=Q;function Z(oe,ye){const fe=ye&&ye.disableMarshalling;return new Proxy({},{get(V,le){if(typeof le=="string")return ye?.properties?.has(le)?ye.properties.get(le):_(le)?function(H){return oe.listen(le,H)}:ie(le)?oe.listen(le):async function(...H){let G;ye&&!(0,p.$If)(ye.context)?G=[ye.context,...H]:G=H;const Y=await oe.call(le,G);return fe?Y:(0,R.$nh)(Y)};throw new g.$bb(`Property not found: ${String(le)}`)}})}x.toService=Z;function ie(oe){return oe[0]==="o"&&oe[1]==="n"&&P.$2e(oe.charCodeAt(2))}function _(oe){return/^onDynamic/.test(oe)&&P.$2e(oe.charCodeAt(9))}})(T||(e.ProxyChannel=T={}));const N=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function j(x){if(Array.isArray(x))return x;if(x&&typeof x=="object"&&typeof x.toString=="function"){const Q=x.toString();if(Q!=="[object Object]")return Q}return x}function U(x){return Array.isArray(x)?x.map(j):j(x)}function B(x,Q,Z,ie,_,oe,ye){ye=U(ye);const fe=N[_],V=fe[ie%fe.length];let le=[`%c[${x}]%c[${String(Q).padStart(7," ")}]%c[len: ${String(Z).padStart(5," ")}]%c${String(ie).padStart(5," ")} - ${oe}`,"color: darkgreen","color: grey","color: grey",`color: ${V}`];/\($/.test(oe)?(le=le.concat(ye),le.push(")")):le.push(ye),console.log.apply(console,le)}class he{constructor(Q,Z){this.d=Q,this.f=Z,this.a=0,this.b=0}logOutgoing(Q,Z,ie,_,oe){this.b+=Q,B(this.d,this.b,Q,Z,ie,_,oe)}logIncoming(Q,Z,ie,_,oe){this.a+=Q,B(this.f,this.a,Q,Z,ie,_,oe)}}e.$zh=he}),define(De[82],Ce([1,0,22,4,3,81]),function(re,e,y,M,l,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eh=e.$Dh=e.$Ch=e.$Bh=e.ProtocolConstants=e.$Ah=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var A;(function(n){n.Created="created",n.Read="read",n.Write="write",n.Open="open",n.Error="error",n.Close="close",n.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",n.NodeEndReceived="nodeEndReceived",n.NodeEndSent="nodeEndSent",n.NodeDrainBegin="nodeDrainBegin",n.NodeDrainEnd="nodeDrainEnd",n.zlibInflateError="zlibInflateError",n.zlibInflateData="zlibInflateData",n.zlibInflateInitialWrite="zlibInflateInitialWrite",n.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",n.zlibInflateWrite="zlibInflateWrite",n.zlibInflateFlushFired="zlibInflateFlushFired",n.zlibDeflateError="zlibDeflateError",n.zlibDeflateData="zlibDeflateData",n.zlibDeflateWrite="zlibDeflateWrite",n.zlibDeflateFlushFired="zlibDeflateFlushFired",n.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",n.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",n.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",n.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",n.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",n.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",n.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",n.ProtocolHeaderRead="protocolHeaderRead",n.ProtocolMessageRead="protocolMessageRead",n.ProtocolHeaderWrite="protocolHeaderWrite",n.ProtocolMessageWrite="protocolMessageWrite",n.ProtocolWrite="protocolWrite"})(A||(e.SocketDiagnosticsEventType=A={}));var g;(function(n){n.enableDiagnostics=!1,n.records=[];const r=new WeakMap;let o=0;function v(w,m){if(!r.has(w)){const b=String(++o);r.set(w,b)}return r.get(w)}function C(w,m,b,I){if(!n.enableDiagnostics)return;const z=v(w,m);if(I instanceof y.$ce||I instanceof Uint8Array||I instanceof ArrayBuffer||ArrayBuffer.isView(I)){const O=y.$ce.alloc(I.byteLength);O.set(I),n.records.push({timestamp:Date.now(),id:z,label:m,type:b,buff:O})}else n.records.push({timestamp:Date.now(),id:z,label:m,type:b,data:I})}n.traceSocketEvent=C})(g||(e.SocketDiagnostics=g={}));var k;(function(n){n[n.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",n[n.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(k||(e.SocketCloseEventType=k={}));let $=null;function R(){return $||($=y.$ce.alloc(0)),$}class P{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(r){this.a.push(r),this.b+=r.byteLength}read(r){return this.c(r,!0)}peek(r){return this.c(r,!1)}c(r,o){if(r===0)return R();if(r>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===r){const m=this.a[0];return o&&(this.a.shift(),this.b-=r),m}if(this.a[0].byteLength>r){const m=this.a[0].slice(0,r);return o&&(this.a[0]=this.a[0].slice(r),this.b-=r),m}const v=y.$ce.alloc(r);let C=0,w=0;for(;r>0;){const m=this.a[w];if(m.byteLength>r){const b=m.slice(0,r);v.set(b,C),C+=r,o&&(this.a[w]=m.slice(r),this.b-=r),r-=r}else v.set(m,C),C+=m.byteLength,o?(this.a.shift(),this.b-=m.byteLength):w++,r-=m.byteLength}return v}}e.$Ah=P;var p;(function(n){n[n.None=0]="None",n[n.Regular=1]="Regular",n[n.Control=2]="Control",n[n.Ack=3]="Ack",n[n.Disconnect=5]="Disconnect",n[n.ReplayRequest=6]="ReplayRequest",n[n.Pause=7]="Pause",n[n.Resume=8]="Resume",n[n.KeepAlive=9]="KeepAlive"})(p||(p={}));function S(n){switch(n){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var D;(function(n){n[n.HeaderLength=13]="HeaderLength",n[n.AcknowledgeTime=2e3]="AcknowledgeTime",n[n.TimeoutTime=2e4]="TimeoutTime",n[n.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",n[n.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",n[n.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(D||(e.ProtocolConstants=D={}));class E{constructor(r,o,v,C){this.type=r,this.id=o,this.ack=v,this.data=C,this.writtenTime=0}get size(){return this.data.byteLength}}class h extends l.$Sc{constructor(r){super(),this.f=this.B(new M.$Od),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=r,this.b=!1,this.c=new P,this.B(this.a.onData(o=>this.acceptChunk(o))),this.lastReadTime=Date.now()}acceptChunk(r){if(!(!r||r.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(r);this.c.byteLength>=this.g.readLen;){const o=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=o.readUInt32BE(9),this.g.messageType=o.readUInt8(0),this.g.id=o.readUInt32BE(1),this.g.ack=o.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:S(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const v=this.g.messageType,C=this.g.id,w=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",o),this.f.fire(new E(v,C,w,o)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class u{constructor(r){this.k=null,this.a=!1,this.b=!1,this.c=r,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(r){if(this.a)return;r.writtenTime=Date.now(),this.lastWriteTime=Date.now();const o=y.$ce.alloc(13);o.writeUInt8(r.type,0),o.writeUInt32BE(r.id,1),o.writeUInt32BE(r.ack,5),o.writeUInt32BE(r.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:S(r.type),id:r.id,ack:r.ack,messageSize:r.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",r.data),this.j(o,r.data)}g(r,o){const v=this.f===0;return this.d.push(r,o),this.f+=r.byteLength+o.byteLength,v}h(){const r=y.$ce.concat(this.d,this.f);return this.d.length=0,this.f=0,r}j(r,o){this.g(r,o)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const r=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:r.byteLength}),this.c.write(r)}}class d extends l.$Sc{constructor(r){super(),this.f=new M.$Od,this.onMessage=this.f.event,this.g=new M.$Od,this.onDidDispose=this.g.event,this.a=r,this.b=this.B(new u(this.a)),this.c=this.B(new h(this.a)),this.B(this.c.onMessage(o=>{o.type===1&&this.f.fire(o.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(r){this.b.write(new E(1,0,0,r))}}e.$Bh=d;class c extends L.$vh{static fromSocket(r,o){return new c(new d(r),o)}get onDidDispose(){return this.b.onDidDispose}constructor(r,o,v=null){super(r,o,v),this.b=r}dispose(){super.dispose();const r=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),r.end()}}e.$Ch=c;class f{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new M.$Od({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(r){this.b?this.d.length>0?this.d.push(r):this.a.fire(r):this.d.push(r)}flushBuffer(){this.d=[]}}e.$Dh=f;class a{constructor(r){this.data=r,this.next=null}}class t{constructor(){this.a=null,this.b=null}length(){let r=0,o=this.a;for(;o;)o=o.next,r++;return r}peek(){return this.a?this.a.data:null}toArray(){const r=[];let o=0,v=this.a;for(;v;)r[o++]=v.data,v=v.next;return r}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(r){const o=new a(r);if(!this.a){this.a=o,this.b=o;return}this.b.next=o,this.b=o}}class i{static getInstance(){return i.b||(i.b=new i),i.b}constructor(){this.c=[];const r=Date.now();for(let o=0;o<i.a;o++)this.c[o]=r-1e3*o;setInterval(()=>{for(let o=i.a;o>=1;o--)this.c[o]=this.c[o-1];this.c[0]=Date.now()},1e3)}d(){const r=Date.now(),o=(1+i.a)*1e3;let v=0;for(let C=0;C<i.a;C++)r-this.c[C]<=o&&v++;return 1-v/i.a}hasHighLoad(){return this.d()>=.5}}i.a=10,i.b=null;class s{get unacknowledgedCount(){return this.c-this.d}constructor(r){this.u=new f,this.onControlMessage=this.u.event,this.v=new f,this.onMessage=this.v.event,this.w=new f,this.onDidDispose=this.w.event,this.x=new f,this.onSocketClose=this.x.event,this.y=new f,this.onSocketTimeout=this.y.event,this.s=r.loadEstimator??i.getInstance(),this.t=r.sendKeepAlive??!0,this.a=!1,this.b=new t,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new l.$Rc,this.o=r.socket,this.p=this.r.add(new u(this.o)),this.q=this.r.add(new h(this.o)),this.r.add(this.q.onMessage(o=>this.z(o))),this.r.add(this.o.onClose(o=>this.x.fire(o))),r.initialChunk&&this.q.acceptChunk(r.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const r=new E(5,0,0,R());this.p.write(r),this.p.flush()}sendPause(){const r=new E(7,0,0,R());this.p.write(r)}sendResume(){const r=new E(8,0,0,R());this.p.write(r)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(r,o){this.a=!0,this.r.dispose(),this.r=new l.$Rc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=r,this.p=this.r.add(new u(this.o)),this.q=this.r.add(new h(this.o)),this.r.add(this.q.onMessage(v=>this.z(v))),this.r.add(this.o.onClose(v=>this.x.fire(v))),this.q.acceptChunk(o)}endAcceptReconnection(){this.a=!1,this.h=this.g;const r=new E(3,0,this.h,R());this.p.write(r);const o=this.b.toArray();for(let v=0,C=o.length;v<C;v++)this.p.write(o[v]);this.B()}acceptDisconnect(){this.w.fire()}z(r){if(r.ack>this.d){this.d=r.ack;do{const o=this.b.peek();if(o&&o.id<=r.ack)this.b.pop();else break}while(!0)}switch(r.type){case 0:break;case 1:{if(r.id>this.g)if(r.id!==this.g+1){const o=Date.now();o-this.m>1e4&&(this.m=o,this.p.write(new E(6,0,0,R())))}else this.g=r.id,this.j=Date.now(),this.A(),this.v.fire(r.data);break}case 2:{this.u.fire(r.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const o=this.b.toArray();for(let v=0,C=o.length;v<C;v++)this.p.write(o[v]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(r){const o=++this.c;this.h=this.g;const v=new E(1,o,this.h,r);this.b.push(v),this.a||(this.p.write(v),this.B())}sendControl(r){const o=new E(2,0,0,r);this.p.write(o)}A(){if(this.g<=this.h||this.k)return;const r=Date.now()-this.j;if(r>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-r+5)}B(){if(this.c<=this.d||this.f||this.a)return;const r=this.b.peek(),o=Date.now()-r.writtenTime,v=Date.now()-this.q.lastReadTime,C=Date.now()-this.n;if(o>=2e4&&v>=2e4&&C>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:o,timeSinceLastReceivedSomeData:v});return}const w=Math.max(2e4-o,2e4-v,2e4-C,500);this.f=setTimeout(()=>{this.f=null,this.B()},w)}C(){if(this.g<=this.h)return;this.h=this.g;const r=new E(3,0,this.h,R());this.p.write(r)}D(){this.h=this.g;const r=new E(9,0,this.h,R());this.p.write(r)}}e.$Eh=s}),define(De[167],Ce([1,0,49,8,22,21,163,9,4,3,24,101,97,81]),function(re,e,y,M,l,L,A,g,k,$,R,P,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8p=e.$7p=void 0;class D extends S.$sh{constructor(u){super({send:d=>{try{process.send?.(d.buffer.toString("base64"))}catch{}},onMessage:k.Event.fromNodeEventEmitter(process,"message",d=>l.$ce.wrap(Buffer.from(d,"base64")))},u),process.once("disconnect",()=>this.dispose())}}e.$7p=D;class E{constructor(u,d){this.i=u,this.j=d,this.c=new Set,this.g=new Map,this.h=new k.$Od,this.onDidProcessExit=this.h.event;const c=d&&d.timeout?d.timeout:6e4;this.b=new M.$Rg(c),this.d=null,this.f=null}getChannel(u){const d=this;return{call(c,f,a){return d.k(u,c,f,a)},listen(c,f){return d.l(u,c,f)}}}k(u,d,c,f=L.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(f.isCancellationRequested)return Promise.reject(g.$6());this.b.cancel();const a=this.n(u),t=(0,M.$Ig)(n=>a.call(d,c,n)),i=f.onCancellationRequested(()=>t.cancel()),s=(0,$.$Qc)(()=>t.cancel());return this.c.add(s),t.finally(()=>{i.dispose(),this.c.delete(s),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(u,d,c){if(!this.b)return k.Event.None;this.b.cancel();let f;const a=new k.$Od({onWillAddFirstListener:()=>{f=this.n(u).listen(d,c)(a.fire,a),this.c.add(f)},onDidRemoveLastListener:()=>{this.c.delete(f),f.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return a.event}get m(){if(!this.f){const u=this.j&&this.j.args?this.j.args:[],d=Object.create(null);d.env={...(0,R.$9m)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(d.env={...d.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(d.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(d.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(d.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),d.execArgv===void 0&&(d.execArgv=process.execArgv.filter(r=>!/^--inspect(-brk)?=/.test(r)).filter(r=>!r.startsWith("--vscode-"))),(0,p.$Cl)(d.env),this.d=(0,y.fork)(this.i,u,d);const c=new k.$Od;k.Event.fromNodeEventEmitter(this.d,"message",r=>r)(r=>{if((0,A.$3p)(r)){(0,A.log)(r,`IPC Library: ${this.j.serverName}`);return}c.fire(l.$ce.wrap(Buffer.from(r,"base64")))});const a=this.j.useQueue?(0,P.$El)(this.d):this.d,t=r=>this.d&&this.d.connected&&a.send(r.buffer.toString("base64")),i=c.event,s={send:t,onMessage:i};this.f=new S.$th(s);const n=()=>this.o();process.once("exit",n),this.d.on("error",r=>console.warn('IPC "'+this.j.serverName+'" errored with '+r)),this.d.on("exit",(r,o)=>{process.removeListener("exit",n),this.c.forEach(v=>(0,$.$Nc)(v)),this.c.clear(),r!==0&&o!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+r+" and signal "+o),this.b?.cancel(),this.o(),this.h.fire({code:r,signal:o})})}return this.f}n(u){let d=this.g.get(u);return d||(d=this.m.getChannel(u),this.g.set(u,d)),d}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$8p=E}),define(De[168],Ce([1,0,8,4,3,60,17]),function(re,e,y,M,l,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8o=e.$7o=e.StorageState=e.$6o=e.StorageHint=void 0;var g;(function(p){p[p.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",p[p.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(g||(e.StorageHint=g={}));function k(p){const S=p;return S?.changed instanceof Map||S?.deleted instanceof Set}e.$6o=k;var $;(function(p){p[p.None=0]="None",p[p.Initialized=1]="Initialized",p[p.Closed=2]="Closed"})($||(e.StorageState=$={}));class R extends l.$Sc{constructor(S,D=Object.create(null)){super(),this.r=S,this.s=D,this.b=this.B(new M.$Rd),this.onDidChangeStorage=this.b.event,this.c=$.None,this.f=new Map,this.g=this.B(new y.$Sg(R.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(S=>this.u(S)))}u(S){this.b.pause();try{S.changed?.forEach((D,E)=>this.w(E,D)),S.deleted?.forEach(D=>this.w(D,void 0))}finally{this.b.resume()}}w(S,D){if(this.c===$.Closed)return;let E=!1;(0,A.$If)(D)?E=this.f.delete(S):this.f.get(S)!==D&&(this.f.set(S,D),E=!0),E&&this.b.fire({key:S,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===$.None&&(this.c=$.Initialized,this.s.hint!==g.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(S,D){const E=this.f.get(S);return(0,A.$If)(E)?D:E}getBoolean(S,D){const E=this.get(S);return(0,A.$If)(E)?D:E==="true"}getNumber(S,D){const E=this.get(S);return(0,A.$If)(E)?D:parseInt(E,10)}getObject(S,D){const E=this.get(S);return(0,A.$If)(E)?D:(0,L.$mh)(E)}async set(S,D,E=!1){if(this.c===$.Closed)return;if((0,A.$If)(D))return this.delete(S,E);const h=(0,A.$Bf)(D)||Array.isArray(D)?(0,L.$lh)(D):String(D);if(this.f.get(S)!==h)return this.f.set(S,h),this.j.set(S,h),this.h.delete(S),this.b.fire({key:S,external:E}),this.D()}async delete(S,D=!1){if(!(this.c===$.Closed||!this.f.delete(S)))return this.h.has(S)||this.h.add(S),this.j.delete(S),this.b.fire({key:S,external:D}),this.D()}async optimize(){if(this.c!==$.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=$.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const S={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(S).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(S){if(this.z)return this.D(S)}async D(S){return this.s.hint===g.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),S)}async whenFlushed(){if(this.z)return new Promise(S=>this.n.push(S))}isInMemory(){return this.s.hint===g.STORAGE_IN_MEMORY}}e.$7o=R,R.a=100;class P{constructor(){this.onDidChangeItemsExternal=M.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(S){S.insert?.forEach((D,E)=>this.a.set(E,D)),S.delete?.forEach(D=>this.a.delete(D))}async optimize(){}async close(){}}e.$8o=P}),define(De[127],Ce([1,0,125]),function(re,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ws=e.$Vs=void 0;class M{constructor(g){const k=(0,y.$Ae)(g);this.c=k,this.a=M.d(k),this.b=new Map}static d(g){const k=new Uint8Array(256);return k.fill(g),k}set(g,k){const $=(0,y.$Ae)(k);g>=0&&g<256?this.a[g]=$:this.b.set(g,$)}get(g){return g>=0&&g<256?this.a[g]:this.b.get(g)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}e.$Vs=M;var l;(function(A){A[A.False=0]="False",A[A.True=1]="True"})(l||(l={}));class L{constructor(){this.a=new M(0)}add(g){this.a.set(g,1)}has(g){return this.a.get(g)===1}clear(){return this.a.clear()}}e.$Ws=L}),define(De[63],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xs=void 0;class y{constructor(l,L){this.lineNumber=l,this.column=L}with(l=this.lineNumber,L=this.column){return l===this.lineNumber&&L===this.column?this:new y(l,L)}delta(l=0,L=0){return this.with(this.lineNumber+l,this.column+L)}equals(l){return y.equals(this,l)}static equals(l,L){return!l&&!L?!0:!!l&&!!L&&l.lineNumber===L.lineNumber&&l.column===L.column}isBefore(l){return y.isBefore(this,l)}static isBefore(l,L){return l.lineNumber<L.lineNumber?!0:L.lineNumber<l.lineNumber?!1:l.column<L.column}isBeforeOrEqual(l){return y.isBeforeOrEqual(this,l)}static isBeforeOrEqual(l,L){return l.lineNumber<L.lineNumber?!0:L.lineNumber<l.lineNumber?!1:l.column<=L.column}static compare(l,L){const A=l.lineNumber|0,g=L.lineNumber|0;if(A===g){const k=l.column|0,$=L.column|0;return k-$}return A-g}clone(){return new y(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(l){return new y(l.lineNumber,l.column)}static isIPosition(l){return l&&typeof l.lineNumber=="number"&&typeof l.column=="number"}}e.$xs=y}),define(De[33],Ce([1,0,63]),function(re,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ys=void 0;class M{constructor(L,A,g,k){L>g||L===g&&A>k?(this.startLineNumber=g,this.startColumn=k,this.endLineNumber=L,this.endColumn=A):(this.startLineNumber=L,this.startColumn=A,this.endLineNumber=g,this.endColumn=k)}isEmpty(){return M.isEmpty(this)}static isEmpty(L){return L.startLineNumber===L.endLineNumber&&L.startColumn===L.endColumn}containsPosition(L){return M.containsPosition(this,L)}static containsPosition(L,A){return!(A.lineNumber<L.startLineNumber||A.lineNumber>L.endLineNumber||A.lineNumber===L.startLineNumber&&A.column<L.startColumn||A.lineNumber===L.endLineNumber&&A.column>L.endColumn)}static strictContainsPosition(L,A){return!(A.lineNumber<L.startLineNumber||A.lineNumber>L.endLineNumber||A.lineNumber===L.startLineNumber&&A.column<=L.startColumn||A.lineNumber===L.endLineNumber&&A.column>=L.endColumn)}containsRange(L){return M.containsRange(this,L)}static containsRange(L,A){return!(A.startLineNumber<L.startLineNumber||A.endLineNumber<L.startLineNumber||A.startLineNumber>L.endLineNumber||A.endLineNumber>L.endLineNumber||A.startLineNumber===L.startLineNumber&&A.startColumn<L.startColumn||A.endLineNumber===L.endLineNumber&&A.endColumn>L.endColumn)}strictContainsRange(L){return M.strictContainsRange(this,L)}static strictContainsRange(L,A){return!(A.startLineNumber<L.startLineNumber||A.endLineNumber<L.startLineNumber||A.startLineNumber>L.endLineNumber||A.endLineNumber>L.endLineNumber||A.startLineNumber===L.startLineNumber&&A.startColumn<=L.startColumn||A.endLineNumber===L.endLineNumber&&A.endColumn>=L.endColumn)}plusRange(L){return M.plusRange(this,L)}static plusRange(L,A){let g,k,$,R;return A.startLineNumber<L.startLineNumber?(g=A.startLineNumber,k=A.startColumn):A.startLineNumber===L.startLineNumber?(g=A.startLineNumber,k=Math.min(A.startColumn,L.startColumn)):(g=L.startLineNumber,k=L.startColumn),A.endLineNumber>L.endLineNumber?($=A.endLineNumber,R=A.endColumn):A.endLineNumber===L.endLineNumber?($=A.endLineNumber,R=Math.max(A.endColumn,L.endColumn)):($=L.endLineNumber,R=L.endColumn),new M(g,k,$,R)}intersectRanges(L){return M.intersectRanges(this,L)}static intersectRanges(L,A){let g=L.startLineNumber,k=L.startColumn,$=L.endLineNumber,R=L.endColumn;const P=A.startLineNumber,p=A.startColumn,S=A.endLineNumber,D=A.endColumn;return g<P?(g=P,k=p):g===P&&(k=Math.max(k,p)),$>S?($=S,R=D):$===S&&(R=Math.min(R,D)),g>$||g===$&&k>R?null:new M(g,k,$,R)}equalsRange(L){return M.equalsRange(this,L)}static equalsRange(L,A){return!L&&!A?!0:!!L&&!!A&&L.startLineNumber===A.startLineNumber&&L.startColumn===A.startColumn&&L.endLineNumber===A.endLineNumber&&L.endColumn===A.endColumn}getEndPosition(){return M.getEndPosition(this)}static getEndPosition(L){return new y.$xs(L.endLineNumber,L.endColumn)}getStartPosition(){return M.getStartPosition(this)}static getStartPosition(L){return new y.$xs(L.startLineNumber,L.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(L,A){return new M(this.startLineNumber,this.startColumn,L,A)}setStartPosition(L,A){return new M(L,A,this.endLineNumber,this.endColumn)}collapseToStart(){return M.collapseToStart(this)}static collapseToStart(L){return new M(L.startLineNumber,L.startColumn,L.startLineNumber,L.startColumn)}collapseToEnd(){return M.collapseToEnd(this)}static collapseToEnd(L){return new M(L.endLineNumber,L.endColumn,L.endLineNumber,L.endColumn)}delta(L){return new M(this.startLineNumber+L,this.startColumn,this.endLineNumber+L,this.endColumn)}static fromPositions(L,A=L){return new M(L.lineNumber,L.column,A.lineNumber,A.column)}static lift(L){return L?new M(L.startLineNumber,L.startColumn,L.endLineNumber,L.endColumn):null}static isIRange(L){return L&&typeof L.startLineNumber=="number"&&typeof L.startColumn=="number"&&typeof L.endLineNumber=="number"&&typeof L.endColumn=="number"}static areIntersectingOrTouching(L,A){return!(L.endLineNumber<A.startLineNumber||L.endLineNumber===A.startLineNumber&&L.endColumn<A.startColumn||A.endLineNumber<L.startLineNumber||A.endLineNumber===L.startLineNumber&&A.endColumn<L.startColumn)}static areIntersecting(L,A){return!(L.endLineNumber<A.startLineNumber||L.endLineNumber===A.startLineNumber&&L.endColumn<=A.startColumn||A.endLineNumber<L.startLineNumber||A.endLineNumber===L.startLineNumber&&A.endColumn<=L.startColumn)}static compareRangesUsingStarts(L,A){if(L&&A){const $=L.startLineNumber|0,R=A.startLineNumber|0;if($===R){const P=L.startColumn|0,p=A.startColumn|0;if(P===p){const S=L.endLineNumber|0,D=A.endLineNumber|0;if(S===D){const E=L.endColumn|0,h=A.endColumn|0;return E-h}return S-D}return P-p}return $-R}return(L?1:0)-(A?1:0)}static compareRangesUsingEnds(L,A){return L.endLineNumber===A.endLineNumber?L.endColumn===A.endColumn?L.startLineNumber===A.startLineNumber?L.startColumn-A.startColumn:L.startLineNumber-A.startLineNumber:L.endColumn-A.endColumn:L.endLineNumber-A.endLineNumber}static spansMultipleLines(L){return L.endLineNumber>L.startLineNumber}toJSON(){return this}}e.$ys=M}),define(De[169],Ce([1,0,33]),function(re,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zs=void 0;class M{static insert(L,A){return{range:new y.$ys(L.lineNumber,L.column,L.lineNumber,L.column),text:A,forceMoveMarkers:!0}}static delete(L){return{range:L,text:null}}static replace(L,A){return{range:L,text:A}}static replaceMove(L,A){return{range:L,text:A,forceMoveMarkers:!0}}}e.$zs=M}),define(De[170],Ce([1,0,63,33]),function(re,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$As=e.SelectionDirection=void 0;var l;(function(A){A[A.LTR=0]="LTR",A[A.RTL=1]="RTL"})(l||(e.SelectionDirection=l={}));class L extends M.$ys{constructor(g,k,$,R){super(g,k,$,R),this.selectionStartLineNumber=g,this.selectionStartColumn=k,this.positionLineNumber=$,this.positionColumn=R}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(g){return L.selectionsEqual(this,g)}static selectionsEqual(g,k){return g.selectionStartLineNumber===k.selectionStartLineNumber&&g.selectionStartColumn===k.selectionStartColumn&&g.positionLineNumber===k.positionLineNumber&&g.positionColumn===k.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(g,k){return this.getDirection()===0?new L(this.startLineNumber,this.startColumn,g,k):new L(g,k,this.startLineNumber,this.startColumn)}getPosition(){return new y.$xs(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new y.$xs(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(g,k){return this.getDirection()===0?new L(g,k,this.endLineNumber,this.endColumn):new L(this.endLineNumber,this.endColumn,g,k)}static fromPositions(g,k=g){return new L(g.lineNumber,g.column,k.lineNumber,k.column)}static fromRange(g,k){return k===0?new L(g.startLineNumber,g.startColumn,g.endLineNumber,g.endColumn):new L(g.endLineNumber,g.endColumn,g.startLineNumber,g.startColumn)}static liftSelection(g){return new L(g.selectionStartLineNumber,g.selectionStartColumn,g.positionLineNumber,g.positionColumn)}static selectionsArrEqual(g,k){if(g&&!k||!g&&k)return!1;if(!g&&!k)return!0;if(g.length!==k.length)return!1;for(let $=0,R=g.length;$<R;$++)if(!this.selectionsEqual(g[$],k[$]))return!1;return!0}static isISelection(g){return g&&typeof g.selectionStartLineNumber=="number"&&typeof g.selectionStartColumn=="number"&&typeof g.positionLineNumber=="number"&&typeof g.positionColumn=="number"}static createWithDirection(g,k,$,R,P){return P===0?new L(g,k,$,R):new L($,R,g,k)}}e.$As=L}),define(De[171],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8r=void 0,e.$8r={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(De[172],Ce([1,0,127]),function(re,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ys=e.$Xs=e.WordCharacterClass=void 0;var M;(function(A){A[A.Regular=0]="Regular",A[A.Whitespace=1]="Whitespace",A[A.WordSeparator=2]="WordSeparator"})(M||(e.WordCharacterClass=M={}));class l extends y.$Vs{constructor(g){super(0);for(let k=0,$=g.length;k<$;k++)this.set(g.charCodeAt(k),2);this.set(32,1),this.set(9,1)}}e.$Xs=l;function L(A){const g={};return k=>(g.hasOwnProperty(k)||(g[k]=A(k)),g[k])}e.$Ys=L(A=>new l(A))}),define(De[128],Ce([1,0,51,3,76]),function(re,e,y,M,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$as=e.$_r=e.$$r=e.$0r=e.$9r=void 0,e.$9r="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function L(P=""){let p="(-?\\d*\\.\\d\\w*)|([^";for(const S of e.$9r)P.indexOf(S)>=0||(p+="\\"+S);return p+="\\s]+)",new RegExp(p,"g")}e.$0r=L();function A(P){let p=e.$0r;if(P&&P instanceof RegExp)if(P.global)p=P;else{let S="g";P.ignoreCase&&(S+="i"),P.multiline&&(S+="m"),P.unicode&&(S+="u"),p=new RegExp(P.source,S)}return p.lastIndex=0,p}e.$$r=A;const g=new l.$2c;g.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function k(P){const p=g.unshift(P);return(0,M.$Qc)(p)}e.$_r=k;function $(P,p,S,D,E){if(E||(E=y.Iterable.first(g)),S.length>E.maxLen){let f=P-E.maxLen/2;return f<0?f=0:D+=f,S=S.substring(f,P+E.maxLen/2),$(P,p,S,D,E)}const h=Date.now(),u=P-1-D;let d=-1,c=null;for(let f=1;!(Date.now()-h>=E.timeBudget);f++){const a=u-E.windowSize*f;p.lastIndex=Math.max(0,a);const t=R(p,S,u,d);if(!t&&c||(c=t,a<=0))break;d=a}if(c){const f={word:c[0],startColumn:D+1+c.index,endColumn:D+1+c.index+c[0].length};return p.lastIndex=0,f}return null}e.$as=$;function R(P,p,S,D){let E;for(;E=P.exec(p);){const h=E.index||0;if(h<=S&&P.lastIndex>=S)return E;if(D>0&&h>D)return null}return null}}),define(De[173],Ce([1,0,36,15]),function(re,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yE=void 0;function l(L,A,g,k,$,R){if(Array.isArray(L)){let P=0;for(const p of L){const S=l(p,A,g,k,$,R);if(S===10)return S;S>P&&(P=S)}return P}else{if(typeof L=="string")return k?L==="*"?5:L===g?10:0:0;if(L){const{language:P,pattern:p,scheme:S,hasAccessToAllModels:D,notebookType:E}=L;if(!k&&!D)return 0;E&&$&&(A=$);let h=0;if(S)if(S===A.scheme)h=10;else if(S==="*")h=5;else return 0;if(P)if(P===g)h=10;else if(P==="*")h=Math.max(h,5);else return 0;if(E)if(E===R)h=10;else if(E==="*"&&R!==void 0)h=Math.max(h,5);else return 0;if(p){let u;if(typeof p=="string"?u=p:u={...p,base:(0,M.$hc)(p.base)},u===A.fsPath||(0,y.$wj)(u,A.fsPath))h=10;else return 0}return h}else return 0}}e.$yE=l}),define(De[174],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vt=e.$ut=e.IndentAction=void 0;var y;(function(A){A[A.None=0]="None",A[A.Indent=1]="Indent",A[A.IndentOutdent=2]="IndentOutdent",A[A.Outdent=3]="Outdent"})(y||(e.IndentAction=y={}));class M{constructor(g){if(this.e=null,this.f=!1,this.open=g.open,this.close=g.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(g.notIn))for(let k=0,$=g.notIn.length;k<$;k++)switch(g.notIn[k]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(g){switch(g){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(g,k){if(g.getTokenCount()===0)return!0;const $=g.findTokenIndexAtOffset(k-2),R=g.getStandardTokenType($);return this.isOK(R)}g(g,k){for(let $=g;$<=k;$++){const R=String.fromCharCode($);if(!this.open.includes(R)&&!this.close.includes(R))return R}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$ut=M;class l{constructor(g){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const k of g)L(this.autoClosingPairsOpenByStart,k.open.charAt(0),k),L(this.autoClosingPairsOpenByEnd,k.open.charAt(k.open.length-1),k),L(this.autoClosingPairsCloseByStart,k.close.charAt(0),k),L(this.autoClosingPairsCloseByEnd,k.close.charAt(k.close.length-1),k),k.close.length===1&&k.open.length===1&&L(this.autoClosingPairsCloseSingleChar,k.close,k)}}e.$vt=l;function L(A,g,k){A.has(g)?A.get(g).push(k):A.set(g,[k])}}),define(De[175],Ce([1,0,127]),function(re,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hZ=e.$gZ=e.$fZ=e.State=void 0;var M;(function(S){S[S.Invalid=0]="Invalid",S[S.Start=1]="Start",S[S.H=2]="H",S[S.HT=3]="HT",S[S.HTT=4]="HTT",S[S.HTTP=5]="HTTP",S[S.F=6]="F",S[S.FI=7]="FI",S[S.FIL=8]="FIL",S[S.BeforeColon=9]="BeforeColon",S[S.AfterColon=10]="AfterColon",S[S.AlmostThere=11]="AlmostThere",S[S.End=12]="End",S[S.Accept=13]="Accept",S[S.LastKnownState=14]="LastKnownState"})(M||(e.State=M={}));class l{constructor(D,E,h){const u=new Uint8Array(D*E);for(let d=0,c=D*E;d<c;d++)u[d]=h;this.a=u,this.rows=D,this.cols=E}get(D,E){return this.a[D*this.cols+E]}set(D,E,h){this.a[D*this.cols+E]=h}}class L{constructor(D){let E=0,h=0;for(let d=0,c=D.length;d<c;d++){const[f,a,t]=D[d];a>E&&(E=a),f>h&&(h=f),t>h&&(h=t)}E++,h++;const u=new l(h,E,0);for(let d=0,c=D.length;d<c;d++){const[f,a,t]=D[d];u.set(f,a,t)}this.a=u,this.b=E}nextState(D,E){return E<0||E>=this.b?0:this.a.get(D,E)}}e.$fZ=L;let A=null;function g(){return A===null&&(A=new L([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),A}var k;(function(S){S[S.None=0]="None",S[S.ForceTermination=1]="ForceTermination",S[S.CannotEndIn=2]="CannotEndIn"})(k||(k={}));let $=null;function R(){if($===null){$=new y.$Vs(0);const S=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let E=0;E<S.length;E++)$.set(S.charCodeAt(E),1);const D=".,;:";for(let E=0;E<D.length;E++)$.set(D.charCodeAt(E),2)}return $}class P{static a(D,E,h,u,d){let c=d-1;do{const f=E.charCodeAt(c);if(D.get(f)!==2)break;c--}while(c>u);if(u>0){const f=E.charCodeAt(u-1),a=E.charCodeAt(c);(f===40&&a===41||f===91&&a===93||f===123&&a===125)&&c--}return{range:{startLineNumber:h,startColumn:u+1,endLineNumber:h,endColumn:c+2},url:E.substring(u,c+1)}}static computeLinks(D,E=g()){const h=R(),u=[];for(let d=1,c=D.getLineCount();d<=c;d++){const f=D.getLineContent(d),a=f.length;let t=0,i=0,s=0,n=1,r=!1,o=!1,v=!1,C=!1;for(;t<a;){let w=!1;const m=f.charCodeAt(t);if(n===13){let b;switch(m){case 40:r=!0,b=0;break;case 41:b=r?0:1;break;case 91:v=!0,o=!0,b=0;break;case 93:v=!1,b=o?0:1;break;case 123:C=!0,b=0;break;case 125:b=C?0:1;break;case 39:case 34:case 96:s===m?b=1:s===39||s===34||s===96?b=0:b=1;break;case 42:b=s===42?1:0;break;case 124:b=s===124?1:0;break;case 32:b=v?0:1;break;default:b=h.get(m)}b===1&&(u.push(P.a(h,f,d,i,t)),w=!0)}else if(n===12){let b;m===91?(o=!0,b=0):b=h.get(m),b===1?w=!0:n=13}else n=E.nextState(n,m),n===0&&(w=!0);w&&(n=1,r=!1,o=!1,C=!1,i=t+1,s=m),t++}n===13&&u.push(P.a(h,f,d,i,a))}return u}}e.$gZ=P;function p(S){return!S||typeof S.getLineCount!="function"||typeof S.getLineContent!="function"?[]:P.computeLinks(S)}e.$hZ=p}),define(De[129],Ce([1,0,24]),function(re,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uu=e.$Tu=e.$Su=e.$Ru=e.ModelConstants=e.PositionAffinity=e.$Qu=e.TrackedRangeStickiness=e.$Pu=e.$Ou=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapPosition=e.GlyphMarginLane=e.OverviewRulerLane=void 0;var M;(function(f){f[f.Left=1]="Left",f[f.Center=2]="Center",f[f.Right=4]="Right",f[f.Full=7]="Full"})(M||(e.OverviewRulerLane=M={}));var l;(function(f){f[f.Left=1]="Left",f[f.Right=2]="Right"})(l||(e.GlyphMarginLane=l={}));var L;(function(f){f[f.Inline=1]="Inline",f[f.Gutter=2]="Gutter"})(L||(e.MinimapPosition=L={}));var A;(function(f){f[f.Both=0]="Both",f[f.Right=1]="Right",f[f.Left=2]="Left",f[f.None=3]="None"})(A||(e.InjectedTextCursorStops=A={}));var g;(function(f){f[f.TextDefined=0]="TextDefined",f[f.LF=1]="LF",f[f.CRLF=2]="CRLF"})(g||(e.EndOfLinePreference=g={}));var k;(function(f){f[f.LF=1]="LF",f[f.CRLF=2]="CRLF"})(k||(e.DefaultEndOfLine=k={}));var $;(function(f){f[f.LF=0]="LF",f[f.CRLF=1]="CRLF"})($||(e.EndOfLineSequence=$={}));class R{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(a){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,a.tabSize|0),a.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,a.indentSize|0),this.a=!1),this.insertSpaces=!!a.insertSpaces,this.defaultEOL=a.defaultEOL|0,this.trimAutoWhitespace=!!a.trimAutoWhitespace,this.bracketPairColorizationOptions=a.bracketPairColorizationOptions}equals(a){return this.tabSize===a.tabSize&&this.a===a.a&&this.indentSize===a.indentSize&&this.insertSpaces===a.insertSpaces&&this.defaultEOL===a.defaultEOL&&this.trimAutoWhitespace===a.trimAutoWhitespace&&(0,y.$an)(this.bracketPairColorizationOptions,a.bracketPairColorizationOptions)}createChangeEvent(a){return{tabSize:this.tabSize!==a.tabSize,indentSize:this.indentSize!==a.indentSize,insertSpaces:this.insertSpaces!==a.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==a.trimAutoWhitespace}}}e.$Ou=R;class P{constructor(a,t){this._findMatchBrand=void 0,this.range=a,this.matches=t}}e.$Pu=P;var p;(function(f){f[f.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",f[f.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",f[f.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",f[f.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(p||(e.TrackedRangeStickiness=p={}));function S(f){return f&&typeof f.read=="function"}e.$Qu=S;var D;(function(f){f[f.Left=0]="Left",f[f.Right=1]="Right",f[f.None=2]="None",f[f.LeftOfInjectedText=3]="LeftOfInjectedText",f[f.RightOfInjectedText=4]="RightOfInjectedText"})(D||(e.PositionAffinity=D={}));var E;(function(f){f[f.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(E||(e.ModelConstants=E={}));class h{constructor(a,t,i,s,n,r){this.identifier=a,this.range=t,this.text=i,this.forceMoveMarkers=s,this.isAutoWhitespaceEdit=n,this._isTracked=r}}e.$Ru=h;class u{constructor(a,t,i){this.regex=a,this.wordSeparators=t,this.simpleSearch=i}}e.$Su=u;class d{constructor(a,t,i){this.reverseEdits=a,this.changes=t,this.trimAutoWhitespaceLineNumbers=i}}e.$Tu=d;function c(f){return!f.isTooLargeForSyncing()&&!f.isForSimpleWidget}e.$Uu=c}),define(De[176],Ce([1,0,19,125]),function(re,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zu=e.$Yu=e.$Xu=void 0;class l{constructor(k){this.a=k,this.b=new Uint32Array(k.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues(k,$){k=(0,M.$Be)(k);const R=this.a,P=this.b,p=$.length;return p===0?!1:(this.a=new Uint32Array(R.length+p),this.a.set(R.subarray(0,k),0),this.a.set(R.subarray(k),k+p),this.a.set($,k),k-1<this.c[0]&&(this.c[0]=k-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(P.subarray(0,this.c[0]+1)),!0)}setValue(k,$){return k=(0,M.$Be)(k),$=(0,M.$Be)($),this.a[k]===$?!1:(this.a[k]=$,k-1<this.c[0]&&(this.c[0]=k-1),!0)}removeValues(k,$){k=(0,M.$Be)(k),$=(0,M.$Be)($);const R=this.a,P=this.b;if(k>=R.length)return!1;const p=R.length-k;return $>=p&&($=p),$===0?!1:(this.a=new Uint32Array(R.length-$),this.a.set(R.subarray(0,k),0),this.a.set(R.subarray(k+$),k),this.b=new Uint32Array(this.a.length),k-1<this.c[0]&&(this.c[0]=k-1),this.c[0]>=0&&this.b.set(P.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum(k){return k<0?0:(k=(0,M.$Be)(k),this.d(k))}d(k){if(k<=this.c[0])return this.b[k];let $=this.c[0]+1;$===0&&(this.b[0]=this.a[0],$++),k>=this.a.length&&(k=this.a.length-1);for(let R=$;R<=k;R++)this.b[R]=this.b[R-1]+this.a[R];return this.c[0]=Math.max(this.c[0],k),this.b[k]}getIndexOf(k){k=Math.floor(k),this.getTotalSum();let $=0,R=this.a.length-1,P=0,p=0,S=0;for(;$<=R;)if(P=$+(R-$)/2|0,p=this.b[P],S=p-this.a[P],k<S)R=P-1;else if(k>=p)$=P+1;else break;return new A(P,k-S)}}e.$Xu=l;class L{constructor(k){this.a=k,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum(k){return this.g(),k===0?0:this.d[k-1]}getIndexOf(k){this.g();const $=this.e[k],R=$>0?this.d[$-1]:0;return new A($,k-R)}removeValues(k,$){this.a.splice(k,$),this.f(k)}insertValues(k,$){this.a=(0,y.$Wb)(this.a,k,$),this.f(k)}f(k){this.b=!1,this.c=Math.min(this.c,k-1)}g(){if(!this.b){for(let k=this.c+1,$=this.a.length;k<$;k++){const R=this.a[k],P=k>0?this.d[k-1]:0;this.d[k]=P+R;for(let p=0;p<R;p++)this.e[P+p]=k}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue(k,$){this.a[k]!==$&&(this.a[k]=$,this.f(k))}}e.$Yu=L;class A{constructor(k,$){this.index=k,this.remainder=$,this._prefixSumIndexOfResultBrand=void 0,this.index=k,this.remainder=$}}e.$Zu=A}),define(De[177],Ce([1,0,16,63,176]),function(re,e,y,M,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1u=void 0;class L{constructor(g,k,$,R){this.d=g,this.f=k,this.g=$,this.h=R,this.j=null,this.k=null}dispose(){this.f.length=0}get version(){return this.h}getText(){return this.k===null&&(this.k=this.f.join(this.g)),this.k}onEvents(g){g.eol&&g.eol!==this.g&&(this.g=g.eol,this.j=null);const k=g.changes;for(const $ of k)this.o($.range),this.p(new M.$xs($.range.startLineNumber,$.range.startColumn),$.text);this.h=g.versionId,this.k=null}l(){if(!this.j){const g=this.g.length,k=this.f.length,$=new Uint32Array(k);for(let R=0;R<k;R++)$[R]=this.f[R].length+g;this.j=new l.$Xu($)}}n(g,k){this.f[g]=k,this.j&&this.j.setValue(g,this.f[g].length+this.g.length)}o(g){if(g.startLineNumber===g.endLineNumber){if(g.startColumn===g.endColumn)return;this.n(g.startLineNumber-1,this.f[g.startLineNumber-1].substring(0,g.startColumn-1)+this.f[g.startLineNumber-1].substring(g.endColumn-1));return}this.n(g.startLineNumber-1,this.f[g.startLineNumber-1].substring(0,g.startColumn-1)+this.f[g.endLineNumber-1].substring(g.endColumn-1)),this.f.splice(g.startLineNumber,g.endLineNumber-g.startLineNumber),this.j&&this.j.removeValues(g.startLineNumber,g.endLineNumber-g.startLineNumber)}p(g,k){if(k.length===0)return;const $=(0,y.$Qe)(k);if($.length===1){this.n(g.lineNumber-1,this.f[g.lineNumber-1].substring(0,g.column-1)+$[0]+this.f[g.lineNumber-1].substring(g.column-1));return}$[$.length-1]+=this.f[g.lineNumber-1].substring(g.column-1),this.n(g.lineNumber-1,this.f[g.lineNumber-1].substring(0,g.column-1)+$[0]);const R=new Uint32Array($.length-1);for(let P=1;P<$.length;P++)this.f.splice(g.lineNumber+P-1,0,$[P]),R[P-1]=$[P].length+this.g.length;this.j&&this.j.insertValues(g.lineNumber,R)}}e.$1u=L}),define(De[178],Ce([1,0,16,172,63,33,129]),function(re,e,y,M,l,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EB=e.$DB=e.$CB=e.$BB=e.$AB=e.$zB=void 0;const g=999;class k{constructor(d,c,f,a){this.searchString=d,this.isRegex=c,this.matchCase=f,this.wordSeparators=a}parseSearchRequest(){if(this.searchString==="")return null;let d;this.isRegex?d=$(this.searchString):d=this.searchString.indexOf(`
`)>=0;let c=null;try{c=y.$Oe(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:d,global:!0,unicode:!0})}catch{return null}if(!c)return null;let f=!this.isRegex&&!d;return f&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(f=this.matchCase),new A.$Su(c,this.wordSeparators?(0,M.$Ys)(this.wordSeparators):null,f?this.searchString:null)}}e.$zB=k;function $(u){if(!u||u.length===0)return!1;for(let d=0,c=u.length;d<c;d++){const f=u.charCodeAt(d);if(f===10)return!0;if(f===92){if(d++,d>=c)break;const a=u.charCodeAt(d);if(a===110||a===114||a===87)return!0}}return!1}e.$AB=$;function R(u,d,c){if(!c)return new A.$Pu(u,null);const f=[];for(let a=0,t=d.length;a<t;a++)f[a]=d[a];return new A.$Pu(u,f)}e.$BB=R;class P{constructor(d){const c=[];let f=0;for(let a=0,t=d.length;a<t;a++)d.charCodeAt(a)===10&&(c[f++]=a);this.a=c}findLineFeedCountBeforeOffset(d){const c=this.a;let f=0,a=c.length-1;if(a===-1||d<=c[0])return 0;for(;f<a;){const t=f+((a-f)/2>>0);c[t]>=d?a=t-1:c[t+1]>=d?(f=t,a=t):f=t+1}return f+1}}class p{static findMatches(d,c,f,a,t){const i=c.parseSearchRequest();return i?i.regex.multiline?this.b(d,f,new h(i.wordSeparators,i.regex),a,t):this.c(d,f,i,a,t):[]}static a(d,c,f,a,t,i){let s,n=0;a?(n=a.findLineFeedCountBeforeOffset(t),s=c+t+n):s=c+t;let r;if(a){const w=a.findLineFeedCountBeforeOffset(t+i.length)-n;r=s+i.length+w}else r=s+i.length;const o=d.getPositionAt(s),v=d.getPositionAt(r);return new L.$ys(o.lineNumber,o.column,v.lineNumber,v.column)}static b(d,c,f,a,t){const i=d.getOffsetAt(c.getStartPosition()),s=d.getValueInRange(c,1),n=d.getEOL()===`\r
`?new P(s):null,r=[];let o=0,v;for(f.reset(0);v=f.next(s);)if(r[o++]=R(this.a(d,i,s,n,v.index,v[0]),v,a),o>=t)return r;return r}static c(d,c,f,a,t){const i=[];let s=0;if(c.startLineNumber===c.endLineNumber){const r=d.getLineContent(c.startLineNumber).substring(c.startColumn-1,c.endColumn-1);return s=this.d(f,r,c.startLineNumber,c.startColumn-1,s,i,a,t),i}const n=d.getLineContent(c.startLineNumber).substring(c.startColumn-1);s=this.d(f,n,c.startLineNumber,c.startColumn-1,s,i,a,t);for(let r=c.startLineNumber+1;r<c.endLineNumber&&s<t;r++)s=this.d(f,d.getLineContent(r),r,0,s,i,a,t);if(s<t){const r=d.getLineContent(c.endLineNumber).substring(0,c.endColumn-1);s=this.d(f,r,c.endLineNumber,0,s,i,a,t)}return i}static d(d,c,f,a,t,i,s,n){const r=d.wordSeparators;if(!s&&d.simpleSearch){const C=d.simpleSearch,w=C.length,m=c.length;let b=-w;for(;(b=c.indexOf(C,b+w))!==-1;)if((!r||E(r,c,m,b,w))&&(i[t++]=new A.$Pu(new L.$ys(f,b+1+a,f,b+1+w+a),null),t>=n))return t;return t}const o=new h(d.wordSeparators,d.regex);let v;o.reset(0);do if(v=o.next(c),v&&(i[t++]=R(new L.$ys(f,v.index+1+a,f,v.index+1+v[0].length+a),v,s),t>=n))return t;while(v);return t}static findNextMatch(d,c,f,a){const t=c.parseSearchRequest();if(!t)return null;const i=new h(t.wordSeparators,t.regex);return t.regex.multiline?this.e(d,f,i,a):this.f(d,f,i,a)}static e(d,c,f,a){const t=new l.$xs(c.lineNumber,1),i=d.getOffsetAt(t),s=d.getLineCount(),n=d.getValueInRange(new L.$ys(t.lineNumber,t.column,s,d.getLineMaxColumn(s)),1),r=d.getEOL()===`\r
`?new P(n):null;f.reset(c.column-1);const o=f.next(n);return o?R(this.a(d,i,n,r,o.index,o[0]),o,a):c.lineNumber!==1||c.column!==1?this.e(d,new l.$xs(1,1),f,a):null}static f(d,c,f,a){const t=d.getLineCount(),i=c.lineNumber,s=d.getLineContent(i),n=this.g(f,s,i,c.column,a);if(n)return n;for(let r=1;r<=t;r++){const o=(i+r-1)%t,v=d.getLineContent(o+1),C=this.g(f,v,o+1,1,a);if(C)return C}return null}static g(d,c,f,a,t){d.reset(a-1);const i=d.next(c);return i?R(new L.$ys(f,i.index+1,f,i.index+1+i[0].length),i,t):null}static findPreviousMatch(d,c,f,a){const t=c.parseSearchRequest();if(!t)return null;const i=new h(t.wordSeparators,t.regex);return t.regex.multiline?this.h(d,f,i,a):this.j(d,f,i,a)}static h(d,c,f,a){const t=this.b(d,new L.$ys(1,1,c.lineNumber,c.column),f,a,10*g);if(t.length>0)return t[t.length-1];const i=d.getLineCount();return c.lineNumber!==i||c.column!==d.getLineMaxColumn(i)?this.h(d,new l.$xs(i,d.getLineMaxColumn(i)),f,a):null}static j(d,c,f,a){const t=d.getLineCount(),i=c.lineNumber,s=d.getLineContent(i).substring(0,c.column-1),n=this.k(f,s,i,a);if(n)return n;for(let r=1;r<=t;r++){const o=(t+i-r-1)%t,v=d.getLineContent(o+1),C=this.k(f,v,o+1,a);if(C)return C}return null}static k(d,c,f,a){let t=null,i;for(d.reset(0);i=d.next(c);)t=R(new L.$ys(f,i.index+1,f,i.index+1+i[0].length),i,a);return t}}e.$CB=p;function S(u,d,c,f,a){if(f===0)return!0;const t=d.charCodeAt(f-1);if(u.get(t)!==0||t===13||t===10)return!0;if(a>0){const i=d.charCodeAt(f);if(u.get(i)!==0)return!0}return!1}function D(u,d,c,f,a){if(f+a===c)return!0;const t=d.charCodeAt(f+a);if(u.get(t)!==0||t===13||t===10)return!0;if(a>0){const i=d.charCodeAt(f+a-1);if(u.get(i)!==0)return!0}return!1}function E(u,d,c,f,a){return S(u,d,c,f,a)&&D(u,d,c,f,a)}e.$DB=E;class h{constructor(d,c){this._wordSeparators=d,this.a=c,this.b=-1,this.c=0}reset(d){this.a.lastIndex=d,this.b=-1,this.c=0}next(d){const c=d.length;let f;do{if(this.b+this.c===c||(f=this.a.exec(d),!f))return null;const a=f.index,t=f[0].length;if(a===this.b&&t===this.c){if(t===0){y.$0e(d,c,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=a,this.c=t,!this._wordSeparators||E(this._wordSeparators,d,c,a,t))return f}while(f);return null}}e.$EB=h}),define(De[130],Ce([1,0,22,12]),function(re,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$c$=e.$b$=void 0;var l;(function(P){P[P.Full=1]="Full",P[P.Delta=2]="Delta"})(l||(l={}));function L(P){for(let p=0,S=P.length;p<S;p+=4){const D=P[p+0],E=P[p+1],h=P[p+2],u=P[p+3];P[p+0]=u,P[p+1]=h,P[p+2]=E,P[p+3]=D}}function A(P){const p=new Uint8Array(P.buffer,P.byteOffset,P.length*4);return M.$x()||L(p),y.$ce.wrap(p)}function g(P){const p=P.buffer;if(M.$x()||L(p),p.byteOffset%4===0)return new Uint32Array(p.buffer,p.byteOffset,p.length/4);{const S=new Uint8Array(p.byteLength);return S.set(p),new Uint32Array(S.buffer,S.byteOffset,S.length/4)}}function k(P){const p=new Uint32Array($(P));let S=0;if(p[S++]=P.id,P.type==="full")p[S++]=1,p[S++]=P.data.length,p.set(P.data,S),S+=P.data.length;else{p[S++]=2,p[S++]=P.deltas.length;for(const D of P.deltas)p[S++]=D.start,p[S++]=D.deleteCount,D.data?(p[S++]=D.data.length,p.set(D.data,S),S+=D.data.length):p[S++]=0}return A(p)}e.$b$=k;function $(P){let p=0;if(p+=1+1,P.type==="full")p+=1+P.data.length;else{p+=1,p+=(1+1+1)*P.deltas.length;for(const S of P.deltas)S.data&&(p+=S.data.length)}return p}function R(P){const p=g(P);let S=0;const D=p[S++];if(p[S++]===1){const d=p[S++],c=p.subarray(S,S+d);return S+=d,{id:D,type:"full",data:c}}const h=p[S++],u=[];for(let d=0;d<h;d++){const c=p[S++],f=p[S++],a=p[S++];let t;a>0&&(t=p.subarray(S,S+a),S+=a),u[d]={start:c,deleteCount:f,data:t}}return{id:D,type:"delta",deltas:u}}e.$c$=R}),define(De[179],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$67=e.$57=void 0;class y{constructor(){this.a=new Map}removeDragOperationTransfer(L){if(L&&this.a.has(L)){const A=this.a.get(L);return this.a.delete(L),A}}addDragOperationTransfer(L,A){this.a.set(L,A)}}e.$57=y;class M{constructor(L){this.identifier=L}}e.$67=M}),define(De[180],Ce([1,0,4,3]),function(re,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0s=void 0;class l{constructor(){this.a=new Map,this.b=new Map,this.c=new y.$Od,this.onDidChange=this.c.event,this.d=null}handleChange(g){this.c.fire({changedLanguages:g,changedColorMap:!1})}register(g,k){return this.a.set(g,k),this.handleChange([g]),(0,M.$Qc)(()=>{this.a.get(g)===k&&(this.a.delete(g),this.handleChange([g]))})}get(g){return this.a.get(g)||null}registerFactory(g,k){this.b.get(g)?.dispose();const $=new L(this,g,k);return this.b.set(g,$),(0,M.$Qc)(()=>{const R=this.b.get(g);!R||R!==$||(this.b.delete(g),R.dispose())})}async getOrCreate(g){const k=this.get(g);if(k)return k;const $=this.b.get(g);return!$||$.isResolved?null:(await $.resolve(),this.get(g))}isResolved(g){if(this.get(g))return!0;const $=this.b.get(g);return!!(!$||$.isResolved)}setColorMap(g){this.d=g,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}e.$0s=l;class L extends M.$Sc{get isResolved(){return this.c}constructor(g,k,$){super(),this.f=g,this.g=k,this.h=$,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.j()),this.b}async j(){const g=await this.h.tokenizationSupport;this.c=!0,g&&!this.a&&this.B(this.f.register(this.g,g))}}}),define(De[181],Ce([10,11]),function(re,e){return re.create("vs/base/common/actions",e)}),define(De[182],Ce([1,0,4,3,181]),function(re,e,y,M,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ai=e.$zi=e.$yi=e.$xi=e.$wi=e.$vi=void 0;class L extends M.$Sc{constructor(p,S="",D="",E=!0,h){super(),this.h=this.B(new y.$Od),this.onDidChange=this.h.event,this.w=!0,this.j=p,this.m=S,this.u=D,this.w=E,this.C=h}get id(){return this.j}get label(){return this.m}set label(p){this.D(p)}D(p){this.m!==p&&(this.m=p,this.h.fire({label:p}))}get tooltip(){return this.n||""}set tooltip(p){this.F(p)}F(p){this.n!==p&&(this.n=p,this.h.fire({tooltip:p}))}get class(){return this.u}set class(p){this.G(p)}G(p){this.u!==p&&(this.u=p,this.h.fire({class:p}))}get enabled(){return this.w}set enabled(p){this.H(p)}H(p){this.w!==p&&(this.w=p,this.h.fire({enabled:p}))}get checked(){return this.z}set checked(p){this.I(p)}I(p){this.z!==p&&(this.z=p,this.h.fire({checked:p}))}async run(p,S){this.C&&await this.C(p)}}e.$vi=L;class A extends M.$Sc{constructor(){super(...arguments),this.f=this.B(new y.$Od),this.onWillRun=this.f.event,this.m=this.B(new y.$Od),this.onDidRun=this.m.event}async run(p,S){if(!p.enabled)return;this.f.fire({action:p});let D;try{await this.u(p,S)}catch(E){D=E}this.m.fire({action:p,error:D})}async u(p,S){await p.run(S)}}e.$wi=A;class g{constructor(){this.id=g.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...p){let S=[];for(const D of p)D.length&&(S.length?S=[...S,new g,...D]:S=D);return S}async run(){}}e.$xi=g,g.ID="vs.actions.separator";class k{get actions(){return this.a}constructor(p,S,D,E){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=p,this.label=S,this.class=E,this.a=D}async run(){}}e.$yi=k;class $ extends L{constructor(){super($.ID,l.localize(0,null),void 0,!1)}}e.$zi=$,$.ID="vs.actions.empty";function R(P){return{id:P.id,label:P.label,class:void 0,enabled:P.enabled??!0,checked:P.checked??!1,run:async(...p)=>P.run(...p),tooltip:P.label}}e.$Ai=R}),define(De[183],Ce([10,11]),function(re,e){return re.create("vs/base/common/date",e)}),define(De[184],Ce([1,0,183]),function(re,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gm=e.$fm=void 0;const M=60,l=M*60,L=l*24,A=L*7,g=L*30,k=L*365;function $(P,p,S,D){typeof P!="number"&&(P=P.getTime());const E=Math.round((new Date().getTime()-P)/1e3);if(E<-30)return(0,y.localize)(0,null,$(new Date().getTime()+E*1e3,!1));if(!D&&E<30)return(0,y.localize)(1,null);let h;return E<M?(h=E,p?h===1?S?(0,y.localize)(2,null,h):(0,y.localize)(3,null,h):S?(0,y.localize)(4,null,h):(0,y.localize)(5,null,h):h===1?S?(0,y.localize)(6,null,h):(0,y.localize)(7,null,h):S?(0,y.localize)(8,null,h):(0,y.localize)(9,null,h)):E<l?(h=Math.floor(E/M),p?h===1?S?(0,y.localize)(10,null,h):(0,y.localize)(11,null,h):S?(0,y.localize)(12,null,h):(0,y.localize)(13,null,h):h===1?S?(0,y.localize)(14,null,h):(0,y.localize)(15,null,h):S?(0,y.localize)(16,null,h):(0,y.localize)(17,null,h)):E<L?(h=Math.floor(E/l),p?h===1?S?(0,y.localize)(18,null,h):(0,y.localize)(19,null,h):S?(0,y.localize)(20,null,h):(0,y.localize)(21,null,h):h===1?S?(0,y.localize)(22,null,h):(0,y.localize)(23,null,h):S?(0,y.localize)(24,null,h):(0,y.localize)(25,null,h)):E<A?(h=Math.floor(E/L),p?h===1?(0,y.localize)(26,null,h):(0,y.localize)(27,null,h):h===1?(0,y.localize)(28,null,h):(0,y.localize)(29,null,h)):E<g?(h=Math.floor(E/A),p?h===1?S?(0,y.localize)(30,null,h):(0,y.localize)(31,null,h):S?(0,y.localize)(32,null,h):(0,y.localize)(33,null,h):h===1?S?(0,y.localize)(34,null,h):(0,y.localize)(35,null,h):S?(0,y.localize)(36,null,h):(0,y.localize)(37,null,h)):E<k?(h=Math.floor(E/g),p?h===1?S?(0,y.localize)(38,null,h):(0,y.localize)(39,null,h):S?(0,y.localize)(40,null,h):(0,y.localize)(41,null,h):h===1?S?(0,y.localize)(42,null,h):(0,y.localize)(43,null,h):S?(0,y.localize)(44,null,h):(0,y.localize)(45,null,h)):(h=Math.floor(E/k),p?h===1?S?(0,y.localize)(46,null,h):(0,y.localize)(47,null,h):S?(0,y.localize)(48,null,h):(0,y.localize)(49,null,h):h===1?S?(0,y.localize)(50,null,h):(0,y.localize)(51,null,h):S?(0,y.localize)(52,null,h):(0,y.localize)(53,null,h))}e.$fm=$;function R(P){return P.getFullYear()+"-"+String(P.getMonth()+1).padStart(2,"0")+"-"+String(P.getDate()).padStart(2,"0")+"T"+String(P.getHours()).padStart(2,"0")+":"+String(P.getMinutes()).padStart(2,"0")+":"+String(P.getSeconds()).padStart(2,"0")+"."+(P.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$gm=R}),define(De[185],Ce([10,11]),function(re,e){return re.create("vs/base/common/errorMessage",e)}),define(De[41],Ce([1,0,19,17,185]),function(re,e,y,M,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Di=e.$Ci=e.$Bi=void 0;function L(P,p){return p&&(P.stack||P.stacktrace)?l.localize(0,null,g(P),A(P.stack)||A(P.stacktrace)):g(P)}function A(P){return Array.isArray(P)?P.join(`
`):P}function g(P){return P.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${P.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof P.code=="string"&&typeof P.errno=="number"&&typeof P.syscall=="string"?l.localize(1,null,P.message):P.message||l.localize(2,null)}function k(P=null,p=!1){if(!P)return l.localize(3,null);if(Array.isArray(P)){const S=y.$Hb(P),D=k(S[0],p);return S.length>1?l.localize(4,null,D,S.length):D}if(M.$zf(P))return P;if(P.detail){const S=P.detail;if(S.error)return L(S.error,p);if(S.exception)return L(S.exception,p)}return P.stack?L(P,p):P.message?P.message:l.localize(5,null)}e.$Bi=k;function $(P){const p=P;return p instanceof Error&&Array.isArray(p.actions)}e.$Ci=$;function R(P,p){let S;return typeof P=="string"?S=new Error(P):S=P,S.actions=p,S}e.$Di=R}),define(De[186],Ce([10,11]),function(re,e){return re.create("vs/editor/common/config/editorOptions",e)}),define(De[131],Ce([1,0,19,24,12,171,128,186]),function(re,e,y,M,l,L,A,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedFloat=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var k;(function(ue){ue[ue.None=0]="None",ue[ue.Keep=1]="Keep",ue[ue.Brackets=2]="Brackets",ue[ue.Advanced=3]="Advanced",ue[ue.Full=4]="Full"})(k||(e.EditorAutoIndentStrategy=k={})),e.MINIMAP_GUTTER_WIDTH=8;class ${constructor(ae){this.c=ae}hasChanged(ae){return this.c[ae]}}e.ConfigurationChangedEvent=$;class R{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=R;class P{constructor(ae,Pe,Ke,Ue){this.id=ae,this.name=Pe,this.defaultValue=Ke,this.schema=Ue}applyUpdate(ae,Pe){return S(ae,Pe)}compute(ae,Pe,Ke){return Ke}}class p{constructor(ae,Pe){this.newValue=ae,this.didChange=Pe}}e.ApplyUpdateResult=p;function S(ue,ae){if(typeof ue!="object"||typeof ae!="object"||!ue||!ae)return new p(ae,ue!==ae);if(Array.isArray(ue)||Array.isArray(ae)){const Ke=Array.isArray(ue)&&Array.isArray(ae)&&y.$ub(ue,ae);return new p(ae,!Ke)}let Pe=!1;for(const Ke in ae)if(ae.hasOwnProperty(Ke)){const Ue=S(ue[Ke],ae[Ke]);Ue.didChange&&(ue[Ke]=Ue.newValue,Pe=!0)}return new p(ue,Pe)}class D{constructor(ae){this.schema=void 0,this.id=ae,this.name="_never_",this.defaultValue=void 0}applyUpdate(ae,Pe){return S(ae,Pe)}validate(ae){return this.defaultValue}}class E{constructor(ae,Pe,Ke,Ue){this.id=ae,this.name=Pe,this.defaultValue=Ke,this.schema=Ue}applyUpdate(ae,Pe){return S(ae,Pe)}validate(ae){return typeof ae>"u"?this.defaultValue:ae}compute(ae,Pe,Ke){return Ke}}function h(ue,ae){return typeof ue>"u"?ae:ue==="false"?!1:!!ue}e.boolean=h;class u extends E{constructor(ae,Pe,Ke,Ue=void 0){typeof Ue<"u"&&(Ue.type="boolean",Ue.default=Ke),super(ae,Pe,Ke,Ue)}validate(ae){return h(ae,this.defaultValue)}}function d(ue,ae,Pe,Ke){if(typeof ue>"u")return ae;let Ue=parseInt(ue,10);return isNaN(Ue)?ae:(Ue=Math.max(Pe,Ue),Ue=Math.min(Ke,Ue),Ue|0)}e.clampedInt=d;class c extends E{static clampedInt(ae,Pe,Ke,Ue){return d(ae,Pe,Ke,Ue)}constructor(ae,Pe,Ke,Ue,Ze,rt=void 0){typeof rt<"u"&&(rt.type="integer",rt.default=Ke,rt.minimum=Ue,rt.maximum=Ze),super(ae,Pe,Ke,rt),this.minimum=Ue,this.maximum=Ze}validate(ae){return c.clampedInt(ae,this.defaultValue,this.minimum,this.maximum)}}function f(ue,ae,Pe,Ke){if(typeof ue>"u")return ae;const Ue=a.float(ue,ae);return a.clamp(Ue,Pe,Ke)}e.clampedFloat=f;class a extends E{static clamp(ae,Pe,Ke){return ae<Pe?Pe:ae>Ke?Ke:ae}static float(ae,Pe){if(typeof ae=="number")return ae;if(typeof ae>"u")return Pe;const Ke=parseFloat(ae);return isNaN(Ke)?Pe:Ke}constructor(ae,Pe,Ke,Ue,Ze){typeof Ze<"u"&&(Ze.type="number",Ze.default=Ke),super(ae,Pe,Ke,Ze),this.validationFn=Ue}validate(ae){return this.validationFn(a.float(ae,this.defaultValue))}}class t extends E{static string(ae,Pe){return typeof ae!="string"?Pe:ae}constructor(ae,Pe,Ke,Ue=void 0){typeof Ue<"u"&&(Ue.type="string",Ue.default=Ke),super(ae,Pe,Ke,Ue)}validate(ae){return t.string(ae,this.defaultValue)}}function i(ue,ae,Pe,Ke){return typeof ue!="string"?ae:Ke&&ue in Ke?Ke[ue]:Pe.indexOf(ue)===-1?ae:ue}e.stringSet=i;class s extends E{constructor(ae,Pe,Ke,Ue,Ze=void 0){typeof Ze<"u"&&(Ze.type="string",Ze.enum=Ue,Ze.default=Ke),super(ae,Pe,Ke,Ze),this.c=Ue}validate(ae){return i(ae,this.defaultValue,this.c)}}class n extends P{constructor(ae,Pe,Ke,Ue,Ze,rt,ht=void 0){typeof ht<"u"&&(ht.type="string",ht.enum=Ze,ht.default=Ue),super(ae,Pe,Ke,ht),this.c=Ze,this.d=rt}validate(ae){return typeof ae!="string"?this.defaultValue:this.c.indexOf(ae)===-1?this.defaultValue:this.d(ae)}}function r(ue){switch(ue){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class o extends P{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[g.localize(0,null),g.localize(1,null),g.localize(2,null)],default:"auto",tags:["accessibility"],description:g.localize(3,null)})}validate(ae){switch(ae){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(ae,Pe,Ke){return Ke===0?ae.accessibilitySupport:Ke}}class v extends P{constructor(){const ae={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",ae,{"editor.comments.insertSpace":{type:"boolean",default:ae.insertSpace,description:g.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:ae.ignoreEmptyLines,description:g.localize(5,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Pe=ae;return{insertSpace:h(Pe.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:h(Pe.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var C;(function(ue){ue[ue.Hidden=0]="Hidden",ue[ue.Blink=1]="Blink",ue[ue.Smooth=2]="Smooth",ue[ue.Phase=3]="Phase",ue[ue.Expand=4]="Expand",ue[ue.Solid=5]="Solid"})(C||(e.TextEditorCursorBlinkingStyle=C={}));function w(ue){switch(ue){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var m;(function(ue){ue[ue.Line=1]="Line",ue[ue.Block=2]="Block",ue[ue.Underline=3]="Underline",ue[ue.LineThin=4]="LineThin",ue[ue.BlockOutline=5]="BlockOutline",ue[ue.UnderlineThin=6]="UnderlineThin"})(m||(e.TextEditorCursorStyle=m={}));function b(ue){switch(ue){case m.Line:return"line";case m.Block:return"block";case m.Underline:return"underline";case m.LineThin:return"line-thin";case m.BlockOutline:return"block-outline";case m.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=b;function I(ue){switch(ue){case"line":return m.Line;case"block":return m.Block;case"underline":return m.Underline;case"line-thin":return m.LineThin;case"block-outline":return m.BlockOutline;case"underline-thin":return m.UnderlineThin}}class z extends D{constructor(){super(141)}compute(ae,Pe,Ke){const Ue=["monaco-editor"];return Pe.get(39)&&Ue.push(Pe.get(39)),ae.extraEditorClassName&&Ue.push(ae.extraEditorClassName),Pe.get(73)==="default"?Ue.push("mouse-default"):Pe.get(73)==="copy"&&Ue.push("mouse-copy"),Pe.get(111)&&Ue.push("showUnused"),Pe.get(139)&&Ue.push("showDeprecated"),Ue.join(" ")}}class O extends u{constructor(){super(37,"emptySelectionClipboard",!0,{description:g.localize(6,null)})}compute(ae,Pe,Ke){return Ke&&ae.emptySelectionClipboard}}class F extends P{constructor(){const ae={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",ae,{"editor.find.cursorMoveOnType":{type:"boolean",default:ae.cursorMoveOnType,description:g.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:ae.seedSearchStringFromSelection,enumDescriptions:[g.localize(8,null),g.localize(9,null),g.localize(10,null)],description:g.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:ae.autoFindInSelection,enumDescriptions:[g.localize(12,null),g.localize(13,null),g.localize(14,null)],description:g.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:ae.globalFindClipboard,description:g.localize(16,null),included:l.$e},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:ae.addExtraSpaceOnTop,description:g.localize(17,null)},"editor.find.loop":{type:"boolean",default:ae.loop,description:g.localize(18,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Pe=ae;return{cursorMoveOnType:h(Pe.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof ae.seedSearchStringFromSelection=="boolean"?ae.seedSearchStringFromSelection?"always":"never":i(Pe.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof ae.autoFindInSelection=="boolean"?ae.autoFindInSelection?"always":"never":i(Pe.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:h(Pe.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:h(Pe.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:h(Pe.loop,this.defaultValue.loop)}}}class T extends P{constructor(){super(51,"fontLigatures",T.OFF,{anyOf:[{type:"boolean",description:g.localize(19,null)},{type:"string",description:g.localize(20,null)}],description:g.localize(21,null),default:!1})}validate(ae){return typeof ae>"u"?this.defaultValue:typeof ae=="string"?ae==="false"?T.OFF:ae==="true"?T.ON:ae:ae?T.ON:T.OFF}}e.EditorFontLigatures=T,T.OFF='"liga" off, "calt" off',T.ON='"liga" on, "calt" on';class N extends P{constructor(){super(54,"fontVariations",N.OFF,{anyOf:[{type:"boolean",description:g.localize(22,null)},{type:"string",description:g.localize(23,null)}],description:g.localize(24,null),default:!1})}validate(ae){return typeof ae>"u"?this.defaultValue:typeof ae=="string"?ae==="false"?N.OFF:ae==="true"?N.TRANSLATE:ae:ae?N.TRANSLATE:N.OFF}compute(ae,Pe,Ke){return ae.fontInfo.fontVariationSettings}}e.EditorFontVariations=N,N.OFF="normal",N.TRANSLATE="translate";class j extends D{constructor(){super(50)}compute(ae,Pe,Ke){return ae.fontInfo}}class U extends E{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:g.localize(25,null)})}validate(ae){const Pe=a.float(ae,this.defaultValue);return Pe===0?e.EDITOR_FONT_DEFAULTS.fontSize:a.clamp(Pe,6,100)}compute(ae,Pe,Ke){return ae.fontInfo.fontSize}}class B extends P{constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:B.d,maximum:B.e,errorMessage:g.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:B.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:g.localize(27,null)})}validate(ae){return ae==="normal"||ae==="bold"?ae:String(c.clampedInt(ae,e.EDITOR_FONT_DEFAULTS.fontWeight,B.d,B.e))}}B.c=["normal","bold","100","200","300","400","500","600","700","800","900"],B.d=1,B.e=1e3;class he extends P{constructor(){const ae={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},Pe={type:"string",enum:["peek","gotoAndPeek","goto"],default:ae.multiple,enumDescriptions:[g.localize(28,null),g.localize(29,null),g.localize(30,null)]},Ke=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",ae,{"editor.gotoLocation.multiple":{deprecationMessage:g.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:g.localize(32,null),...Pe},"editor.gotoLocation.multipleTypeDefinitions":{description:g.localize(33,null),...Pe},"editor.gotoLocation.multipleDeclarations":{description:g.localize(34,null),...Pe},"editor.gotoLocation.multipleImplementations":{description:g.localize(35,null),...Pe},"editor.gotoLocation.multipleReferences":{description:g.localize(36,null),...Pe},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:ae.alternativeDefinitionCommand,enum:Ke,description:g.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:ae.alternativeTypeDefinitionCommand,enum:Ke,description:g.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:ae.alternativeDeclarationCommand,enum:Ke,description:g.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:ae.alternativeImplementationCommand,enum:Ke,description:g.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:ae.alternativeReferenceCommand,enum:Ke,description:g.localize(41,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Pe=ae;return{multiple:i(Pe.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:Pe.multipleDefinitions??i(Pe.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:Pe.multipleTypeDefinitions??i(Pe.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:Pe.multipleDeclarations??i(Pe.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:Pe.multipleImplementations??i(Pe.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:Pe.multipleReferences??i(Pe.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:t.string(Pe.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:t.string(Pe.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:t.string(Pe.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:t.string(Pe.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:t.string(Pe.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class x extends P{constructor(){const ae={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",ae,{"editor.hover.enabled":{type:"boolean",default:ae.enabled,description:g.localize(42,null)},"editor.hover.delay":{type:"number",default:ae.delay,minimum:0,maximum:1e4,description:g.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:ae.sticky,description:g.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:ae.hidingDelay,description:g.localize(45,null)},"editor.hover.above":{type:"boolean",default:ae.above,description:g.localize(46,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Pe=ae;return{enabled:h(Pe.enabled,this.defaultValue.enabled),delay:c.clampedInt(Pe.delay,this.defaultValue.delay,0,1e4),sticky:h(Pe.sticky,this.defaultValue.sticky),hidingDelay:c.clampedInt(Pe.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:h(Pe.above,this.defaultValue.above)}}}var Q;(function(ue){ue[ue.None=0]="None",ue[ue.Text=1]="Text",ue[ue.Blocks=2]="Blocks"})(Q||(e.RenderMinimap=Q={}));class Z extends D{constructor(){super(144)}compute(ae,Pe,Ke){return Z.computeLayout(Pe,{memory:ae.memory,outerWidth:ae.outerWidth,outerHeight:ae.outerHeight,isDominatedByLongLines:ae.isDominatedByLongLines,lineHeight:ae.fontInfo.lineHeight,viewLineCount:ae.viewLineCount,lineNumbersDigitCount:ae.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:ae.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:ae.fontInfo.maxDigitWidth,pixelRatio:ae.pixelRatio,glyphMarginDecorationLaneCount:ae.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(ae){const Pe=ae.height/ae.lineHeight,Ke=Math.floor(ae.paddingTop/ae.lineHeight);let Ue=Math.floor(ae.paddingBottom/ae.lineHeight);ae.scrollBeyondLastLine&&(Ue=Math.max(Ue,Pe-1));const Ze=(Ke+ae.viewLineCount+Ue)/(ae.pixelRatio*ae.height),rt=Math.floor(ae.viewLineCount/Ze);return{typicalViewportLineCount:Pe,extraLinesBeforeFirstLine:Ke,extraLinesBeyondLastLine:Ue,desiredRatio:Ze,minimapLineCount:rt}}static c(ae,Pe){const Ke=ae.outerWidth,Ue=ae.outerHeight,Ze=ae.pixelRatio;if(!ae.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Ze*Ue),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Ue};const rt=Pe.stableMinimapLayoutInput,ht=rt&&ae.outerHeight===rt.outerHeight&&ae.lineHeight===rt.lineHeight&&ae.typicalHalfwidthCharacterWidth===rt.typicalHalfwidthCharacterWidth&&ae.pixelRatio===rt.pixelRatio&&ae.scrollBeyondLastLine===rt.scrollBeyondLastLine&&ae.paddingTop===rt.paddingTop&&ae.paddingBottom===rt.paddingBottom&&ae.minimap.enabled===rt.minimap.enabled&&ae.minimap.side===rt.minimap.side&&ae.minimap.size===rt.minimap.size&&ae.minimap.showSlider===rt.minimap.showSlider&&ae.minimap.renderCharacters===rt.minimap.renderCharacters&&ae.minimap.maxColumn===rt.minimap.maxColumn&&ae.minimap.scale===rt.minimap.scale&&ae.verticalScrollbarWidth===rt.verticalScrollbarWidth&&ae.isViewportWrapping===rt.isViewportWrapping,pt=ae.lineHeight,Dt=ae.typicalHalfwidthCharacterWidth,qt=ae.scrollBeyondLastLine,Vt=ae.minimap.renderCharacters;let Et=Ze>=2?Math.round(ae.minimap.scale*2):ae.minimap.scale;const Tt=ae.minimap.maxColumn,Ot=ae.minimap.size,_t=ae.minimap.side,Yt=ae.verticalScrollbarWidth,Pt=ae.viewLineCount,Nt=ae.remainingWidth,Jt=ae.isViewportWrapping,jt=Vt?2:3;let Kt=Math.floor(Ze*Ue);const Ht=Kt/Ze;let It=!1,ut=!1,ft=jt*Et,At=Et/Ze,Ft=1;if(Ot==="fill"||Ot==="fit"){const{typicalViewportLineCount:Qt,extraLinesBeforeFirstLine:Me,extraLinesBeyondLastLine:Te,desiredRatio:Se,minimapLineCount:ne}=Z.computeContainedMinimapLineCount({viewLineCount:Pt,scrollBeyondLastLine:qt,paddingTop:ae.paddingTop,paddingBottom:ae.paddingBottom,height:Ue,lineHeight:pt,pixelRatio:Ze});if(Pt/ne>1)It=!0,ut=!0,Et=1,ft=1,At=Et/Ze;else{let Ve=!1,_e=Et+1;if(Ot==="fit"){const Ye=Math.ceil((Me+Pt+Te)*ft);Jt&&ht&&Nt<=Pe.stableFitRemainingWidth?(Ve=!0,_e=Pe.stableFitMaxMinimapScale):Ve=Ye>Kt}if(Ot==="fill"||Ve){It=!0;const Ye=Et;ft=Math.min(pt*Ze,Math.max(1,Math.floor(1/Se))),Jt&&ht&&Nt<=Pe.stableFitRemainingWidth&&(_e=Pe.stableFitMaxMinimapScale),Et=Math.min(_e,Math.max(1,Math.floor(ft/jt))),Et>Ye&&(Ft=Math.min(2,Et/Ye)),At=Et/Ze/Ft,Kt=Math.ceil(Math.max(Qt,Me+Pt+Te)*ft),Jt?(Pe.stableMinimapLayoutInput=ae,Pe.stableFitRemainingWidth=Nt,Pe.stableFitMaxMinimapScale=Et):(Pe.stableMinimapLayoutInput=null,Pe.stableFitRemainingWidth=0)}}}const Mt=Math.floor(Tt*At),lt=Math.min(Mt,Math.max(0,Math.floor((Nt-Yt-2)*At/(Dt+At)))+e.MINIMAP_GUTTER_WIDTH);let kt=Math.floor(Ze*lt);const zt=kt/Ze;kt=Math.floor(kt*Ft);const Ut=Vt?1:2,Je=_t==="left"?0:Ke-lt-Yt;return{renderMinimap:Ut,minimapLeft:Je,minimapWidth:lt,minimapHeightIsEditorHeight:It,minimapIsSampling:ut,minimapScale:Et,minimapLineHeight:ft,minimapCanvasInnerWidth:kt,minimapCanvasInnerHeight:Kt,minimapCanvasOuterWidth:zt,minimapCanvasOuterHeight:Ht}}static computeLayout(ae,Pe){const Ke=Pe.outerWidth|0,Ue=Pe.outerHeight|0,Ze=Pe.lineHeight|0,rt=Pe.lineNumbersDigitCount|0,ht=Pe.typicalHalfwidthCharacterWidth,pt=Pe.maxDigitWidth,Dt=Pe.pixelRatio,qt=Pe.viewLineCount,Vt=ae.get(136),Et=Vt==="inherit"?ae.get(135):Vt,Tt=Et==="inherit"?ae.get(131):Et,Ot=ae.get(134),_t=Pe.isDominatedByLongLines,Yt=ae.get(57),Pt=ae.get(67).renderType!==0,Nt=ae.get(68),Jt=ae.get(105),jt=ae.get(84),Kt=ae.get(72),Ht=ae.get(103),It=Ht.verticalScrollbarSize,ut=Ht.verticalHasArrows,ft=Ht.arrowSize,At=Ht.horizontalScrollbarSize,Ft=ae.get(43),Mt=ae.get(110)!=="never";let lt=ae.get(65);Ft&&Mt&&(lt+=16);let kt=0;if(Pt){const Ct=Math.max(rt,Nt);kt=Math.round(Ct*pt)}let zt=0;Yt&&(zt=Ze*Pe.glyphMarginDecorationLaneCount);let Ut=0,Je=Ut+zt,Qt=Je+kt,Me=Qt+lt;const Te=Ke-zt-kt-lt;let Se=!1,ne=!1,Fe=-1;Et==="inherit"&&_t?(Se=!0,ne=!0):Tt==="on"||Tt==="bounded"?ne=!0:Tt==="wordWrapColumn"&&(Fe=Ot);const Ve=Z.c({outerWidth:Ke,outerHeight:Ue,lineHeight:Ze,typicalHalfwidthCharacterWidth:ht,pixelRatio:Dt,scrollBeyondLastLine:Jt,paddingTop:jt.top,paddingBottom:jt.bottom,minimap:Kt,verticalScrollbarWidth:It,viewLineCount:qt,remainingWidth:Te,isViewportWrapping:ne},Pe.memory||new R);Ve.renderMinimap!==0&&Ve.minimapLeft===0&&(Ut+=Ve.minimapWidth,Je+=Ve.minimapWidth,Qt+=Ve.minimapWidth,Me+=Ve.minimapWidth);const _e=Te-Ve.minimapWidth,Ye=Math.max(1,Math.floor((_e-It-2)/ht)),ot=ut?ft:0;return ne&&(Fe=Math.max(1,Ye),Tt==="bounded"&&(Fe=Math.min(Fe,Ot))),{width:Ke,height:Ue,glyphMarginLeft:Ut,glyphMarginWidth:zt,glyphMarginDecorationLaneCount:Pe.glyphMarginDecorationLaneCount,lineNumbersLeft:Je,lineNumbersWidth:kt,decorationsLeft:Qt,decorationsWidth:lt,contentLeft:Me,contentWidth:_e,minimap:Ve,viewportColumn:Ye,isWordWrapMinified:Se,isViewportWrapping:ne,wrappingColumn:Fe,verticalScrollbarWidth:It,horizontalScrollbarHeight:At,overviewRuler:{top:ot,width:It,height:Ue-2*ot,right:0}}}}e.EditorLayoutInfoComputer=Z;class ie extends P{constructor(){super(138,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[g.localize(47,null),g.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:g.localize(49,null)}})}validate(ae){return i(ae,"simple",["simple","advanced"])}compute(ae,Pe,Ke){return Pe.get(2)===2?"advanced":Ke}}class _ extends P{constructor(){const ae={enabled:!0};super(64,"lightbulb",ae,{"editor.lightbulb.enabled":{type:"boolean",default:ae.enabled,description:g.localize(50,null)}})}validate(ae){return!ae||typeof ae!="object"?this.defaultValue:{enabled:h(ae.enabled,this.defaultValue.enabled)}}}class oe extends P{constructor(){const ae={enabled:!1,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(115,"stickyScroll",ae,{"editor.stickyScroll.enabled":{type:"boolean",default:ae.enabled,description:g.localize(51,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:ae.maxLineCount,minimum:1,maximum:10,description:g.localize(52,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:ae.defaultModel,description:g.localize(53,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:ae.scrollWithEditor,description:g.localize(54,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Pe=ae;return{enabled:h(Pe.enabled,this.defaultValue.enabled),maxLineCount:c.clampedInt(Pe.maxLineCount,this.defaultValue.maxLineCount,1,10),defaultModel:i(Pe.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:h(Pe.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class ye extends P{constructor(){const ae={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(140,"inlayHints",ae,{"editor.inlayHints.enabled":{type:"string",default:ae.enabled,description:g.localize(55,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[g.localize(56,null),g.localize(57,null,l.$e?"Ctrl+Option":"Ctrl+Alt"),g.localize(58,null,l.$e?"Ctrl+Option":"Ctrl+Alt"),g.localize(59,null)]},"editor.inlayHints.fontSize":{type:"number",default:ae.fontSize,markdownDescription:g.localize(60,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:ae.fontFamily,markdownDescription:g.localize(61,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:ae.padding,description:g.localize(62,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Pe=ae;return typeof Pe.enabled=="boolean"&&(Pe.enabled=Pe.enabled?"on":"off"),{enabled:i(Pe.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:c.clampedInt(Pe.fontSize,this.defaultValue.fontSize,0,100),fontFamily:t.string(Pe.fontFamily,this.defaultValue.fontFamily),padding:h(Pe.padding,this.defaultValue.padding)}}}class fe extends P{constructor(){super(65,"lineDecorationsWidth",10)}validate(ae){return typeof ae=="string"&&/^\d+(\.\d+)?ch$/.test(ae)?-parseFloat(ae.substring(0,ae.length-2)):c.clampedInt(ae,this.defaultValue,0,1e3)}compute(ae,Pe,Ke){return Ke<0?c.clampedInt(-Ke*ae.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Ke}}class V extends a{constructor(){super(66,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,ae=>a.clamp(ae,0,150),{markdownDescription:g.localize(63,null)})}compute(ae,Pe,Ke){return ae.fontInfo.lineHeight}}class le extends P{constructor(){const ae={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(72,"minimap",ae,{"editor.minimap.enabled":{type:"boolean",default:ae.enabled,description:g.localize(64,null)},"editor.minimap.autohide":{type:"boolean",default:ae.autohide,description:g.localize(65,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[g.localize(66,null),g.localize(67,null),g.localize(68,null)],default:ae.size,description:g.localize(69,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:ae.side,description:g.localize(70,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:ae.showSlider,description:g.localize(71,null)},"editor.minimap.scale":{type:"number",default:ae.scale,minimum:1,maximum:3,enum:[1,2,3],description:g.localize(72,null)},"editor.minimap.renderCharacters":{type:"boolean",default:ae.renderCharacters,description:g.localize(73,null)},"editor.minimap.maxColumn":{type:"number",default:ae.maxColumn,description:g.localize(74,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Pe=ae;return{enabled:h(Pe.enabled,this.defaultValue.enabled),autohide:h(Pe.autohide,this.defaultValue.autohide),size:i(Pe.size,this.defaultValue.size,["proportional","fill","fit"]),side:i(Pe.side,this.defaultValue.side,["right","left"]),showSlider:i(Pe.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:h(Pe.renderCharacters,this.defaultValue.renderCharacters),scale:c.clampedInt(Pe.scale,1,1,3),maxColumn:c.clampedInt(Pe.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function H(ue){return ue==="ctrlCmd"?l.$e?"metaKey":"ctrlKey":"altKey"}class G extends P{constructor(){super(84,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:g.localize(75,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:g.localize(76,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Pe=ae;return{top:c.clampedInt(Pe.top,0,0,1e3),bottom:c.clampedInt(Pe.bottom,0,0,1e3)}}}class Y extends P{constructor(){const ae={enabled:!0,cycle:!0};super(86,"parameterHints",ae,{"editor.parameterHints.enabled":{type:"boolean",default:ae.enabled,description:g.localize(77,null)},"editor.parameterHints.cycle":{type:"boolean",default:ae.cycle,description:g.localize(78,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Pe=ae;return{enabled:h(Pe.enabled,this.defaultValue.enabled),cycle:h(Pe.cycle,this.defaultValue.cycle)}}}class X extends D{constructor(){super(142)}compute(ae,Pe,Ke){return ae.pixelRatio}}class be extends P{constructor(){const ae={other:"on",comments:"off",strings:"off"},Pe=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[g.localize(79,null),g.localize(80,null),g.localize(81,null)]}];super(89,"quickSuggestions",ae,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:Pe,default:ae.strings,description:g.localize(82,null)},comments:{anyOf:Pe,default:ae.comments,description:g.localize(83,null)},other:{anyOf:Pe,default:ae.other,description:g.localize(84,null)}},default:ae,markdownDescription:g.localize(85,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=ae}validate(ae){if(typeof ae=="boolean"){const Dt=ae?"on":"off";return{comments:Dt,strings:Dt,other:Dt}}if(!ae||typeof ae!="object")return this.defaultValue;const{other:Pe,comments:Ke,strings:Ue}=ae,Ze=["on","inline","off"];let rt,ht,pt;return typeof Pe=="boolean"?rt=Pe?"on":"off":rt=i(Pe,this.defaultValue.other,Ze),typeof Ke=="boolean"?ht=Ke?"on":"off":ht=i(Ke,this.defaultValue.comments,Ze),typeof Ue=="boolean"?pt=Ue?"on":"off":pt=i(Ue,this.defaultValue.strings,Ze),{other:rt,comments:ht,strings:pt}}}var se;(function(ue){ue[ue.Off=0]="Off",ue[ue.On=1]="On",ue[ue.Relative=2]="Relative",ue[ue.Interval=3]="Interval",ue[ue.Custom=4]="Custom"})(se||(e.RenderLineNumbersType=se={}));class ge extends P{constructor(){super(67,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[g.localize(86,null),g.localize(87,null),g.localize(88,null),g.localize(89,null)],default:"on",description:g.localize(90,null)})}validate(ae){let Pe=this.defaultValue.renderType,Ke=this.defaultValue.renderFn;return typeof ae<"u"&&(typeof ae=="function"?(Pe=4,Ke=ae):ae==="interval"?Pe=3:ae==="relative"?Pe=2:ae==="on"?Pe=1:Pe=0),{renderType:Pe,renderFn:Ke}}}function te(ue){const ae=ue.get(98);return ae==="editable"?ue.get(91):ae!=="on"}e.filterValidationDecorations=te;class me extends P{constructor(){const ae=[],Pe={type:"number",description:g.localize(91,null)};super(102,"rulers",ae,{type:"array",items:{anyOf:[Pe,{type:["object"],properties:{column:Pe,color:{type:"string",description:g.localize(92,null),format:"color-hex"}}}]},default:ae,description:g.localize(93,null)})}validate(ae){if(Array.isArray(ae)){const Pe=[];for(const Ke of ae)if(typeof Ke=="number")Pe.push({column:c.clampedInt(Ke,0,0,1e4),color:null});else if(Ke&&typeof Ke=="object"){const Ue=Ke;Pe.push({column:c.clampedInt(Ue.column,0,0,1e4),color:Ue.color})}return Pe.sort((Ke,Ue)=>Ke.column-Ue.column),Pe}return this.defaultValue}}class we extends P{constructor(){super(92,"readOnlyMessage",void 0)}validate(ae){return!ae||typeof ae!="object"?this.defaultValue:ae}}function Ie(ue,ae){if(typeof ue!="string")return ae;switch(ue){case"hidden":return 2;case"visible":return 3;default:return 1}}class W extends P{constructor(){const ae={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(103,"scrollbar",ae,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[g.localize(94,null),g.localize(95,null),g.localize(96,null)],default:"auto",description:g.localize(97,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[g.localize(98,null),g.localize(99,null),g.localize(100,null)],default:"auto",description:g.localize(101,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:ae.verticalScrollbarSize,description:g.localize(102,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:ae.horizontalScrollbarSize,description:g.localize(103,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:ae.scrollByPage,description:g.localize(104,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:ae.ignoreHorizontalScrollbarInContentHeight,description:g.localize(105,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Pe=ae,Ke=c.clampedInt(Pe.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Ue=c.clampedInt(Pe.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:c.clampedInt(Pe.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Ie(Pe.vertical,this.defaultValue.vertical),horizontal:Ie(Pe.horizontal,this.defaultValue.horizontal),useShadows:h(Pe.useShadows,this.defaultValue.useShadows),verticalHasArrows:h(Pe.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:h(Pe.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:h(Pe.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:h(Pe.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ke,horizontalSliderSize:c.clampedInt(Pe.horizontalSliderSize,Ke,0,1e3),verticalScrollbarSize:Ue,verticalSliderSize:c.clampedInt(Pe.verticalSliderSize,Ue,0,1e3),scrollByPage:h(Pe.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:h(Pe.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class J extends P{constructor(){const ae={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(125,"unicodeHighlight",ae,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ae.nonBasicASCII,description:g.localize(106,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:ae.invisibleCharacters,description:g.localize(107,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:ae.ambiguousCharacters,description:g.localize(108,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ae.includeComments,description:g.localize(109,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ae.includeStrings,description:g.localize(110,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:ae.allowedCharacters,description:g.localize(111,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:ae.allowedLocales,description:g.localize(112,null)}})}applyUpdate(ae,Pe){let Ke=!1;Pe.allowedCharacters&&ae&&(M.$an(ae.allowedCharacters,Pe.allowedCharacters)||(ae={...ae,allowedCharacters:Pe.allowedCharacters},Ke=!0)),Pe.allowedLocales&&ae&&(M.$an(ae.allowedLocales,Pe.allowedLocales)||(ae={...ae,allowedLocales:Pe.allowedLocales},Ke=!0));const Ue=super.applyUpdate(ae,Pe);return Ke?new p(Ue.newValue,!0):Ue}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Pe=ae;return{nonBasicASCII:$e(Pe.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:h(Pe.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:h(Pe.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:$e(Pe.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:$e(Pe.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(ae.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(ae.allowedLocales,this.defaultValue.allowedLocales)}}c(ae,Pe){if(typeof ae!="object"||!ae)return Pe;const Ke={};for(const[Ue,Ze]of Object.entries(ae))Ze===!0&&(Ke[Ue]=!0);return Ke}}class ce extends P{constructor(){const ae={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1};super(62,"inlineSuggest",ae,{"editor.inlineSuggest.enabled":{type:"boolean",default:ae.enabled,description:g.localize(113,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:ae.showToolbar,enum:["always","onHover"],enumDescriptions:[g.localize(114,null),g.localize(115,null)],description:g.localize(116,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:ae.suppressSuggestions,description:g.localize(117,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Pe=ae;return{enabled:h(Pe.enabled,this.defaultValue.enabled),mode:i(Pe.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:i(Pe.showToolbar,this.defaultValue.showToolbar,["always","onHover"]),suppressSuggestions:h(Pe.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:h(Pe.keepOnBlur,this.defaultValue.keepOnBlur)}}}class de extends P{constructor(){const ae={enabled:L.$8r.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:L.$8r.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",ae,{"editor.bracketPairColorization.enabled":{type:"boolean",default:ae.enabled,markdownDescription:g.localize(118,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:ae.independentColorPoolPerBracketType,description:g.localize(119,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Pe=ae;return{enabled:h(Pe.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:h(Pe.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class ee extends P{constructor(){const ae={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",ae,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[g.localize(120,null),g.localize(121,null),g.localize(122,null)],default:ae.bracketPairs,description:g.localize(123,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[g.localize(124,null),g.localize(125,null),g.localize(126,null)],default:ae.bracketPairsHorizontal,description:g.localize(127,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:ae.highlightActiveBracketPair,description:g.localize(128,null)},"editor.guides.indentation":{type:"boolean",default:ae.indentation,description:g.localize(129,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[g.localize(130,null),g.localize(131,null),g.localize(132,null)],default:ae.highlightActiveIndentation,description:g.localize(133,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Pe=ae;return{bracketPairs:$e(Pe.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:$e(Pe.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:h(Pe.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:h(Pe.indentation,this.defaultValue.indentation),highlightActiveIndentation:$e(Pe.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function $e(ue,ae,Pe){const Ke=Pe.indexOf(ue);return Ke===-1?ae:Pe[Ke]}class ve extends P{constructor(){const ae={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(118,"suggest",ae,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[g.localize(134,null),g.localize(135,null)],default:ae.insertMode,description:g.localize(136,null)},"editor.suggest.filterGraceful":{type:"boolean",default:ae.filterGraceful,description:g.localize(137,null)},"editor.suggest.localityBonus":{type:"boolean",default:ae.localityBonus,description:g.localize(138,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:ae.shareSuggestSelections,markdownDescription:g.localize(139,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[g.localize(140,null),g.localize(141,null),g.localize(142,null),g.localize(143,null)],default:ae.selectionMode,markdownDescription:g.localize(144,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:ae.snippetsPreventQuickSuggestions,description:g.localize(145,null)},"editor.suggest.showIcons":{type:"boolean",default:ae.showIcons,description:g.localize(146,null)},"editor.suggest.showStatusBar":{type:"boolean",default:ae.showStatusBar,description:g.localize(147,null)},"editor.suggest.preview":{type:"boolean",default:ae.preview,description:g.localize(148,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:ae.showInlineDetails,description:g.localize(149,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:g.localize(150,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:g.localize(151,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:g.localize(152,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:g.localize(153,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:g.localize(154,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:g.localize(155,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:g.localize(156,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:g.localize(157,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:g.localize(158,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:g.localize(159,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:g.localize(160,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:g.localize(161,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:g.localize(162,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:g.localize(163,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:g.localize(164,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:g.localize(165,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:g.localize(166,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:g.localize(167,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:g.localize(168,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:g.localize(169,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:g.localize(170,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:g.localize(171,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:g.localize(172,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:g.localize(173,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:g.localize(174,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:g.localize(175,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:g.localize(176,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:g.localize(177,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:g.localize(178,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:g.localize(179,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:g.localize(180,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:g.localize(181,null)}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Pe=ae;return{insertMode:i(Pe.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:h(Pe.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:h(Pe.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:h(Pe.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:h(Pe.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:i(Pe.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:h(Pe.showIcons,this.defaultValue.showIcons),showStatusBar:h(Pe.showStatusBar,this.defaultValue.showStatusBar),preview:h(Pe.preview,this.defaultValue.preview),previewMode:i(Pe.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:h(Pe.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:h(Pe.showMethods,this.defaultValue.showMethods),showFunctions:h(Pe.showFunctions,this.defaultValue.showFunctions),showConstructors:h(Pe.showConstructors,this.defaultValue.showConstructors),showDeprecated:h(Pe.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:h(Pe.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:h(Pe.showFields,this.defaultValue.showFields),showVariables:h(Pe.showVariables,this.defaultValue.showVariables),showClasses:h(Pe.showClasses,this.defaultValue.showClasses),showStructs:h(Pe.showStructs,this.defaultValue.showStructs),showInterfaces:h(Pe.showInterfaces,this.defaultValue.showInterfaces),showModules:h(Pe.showModules,this.defaultValue.showModules),showProperties:h(Pe.showProperties,this.defaultValue.showProperties),showEvents:h(Pe.showEvents,this.defaultValue.showEvents),showOperators:h(Pe.showOperators,this.defaultValue.showOperators),showUnits:h(Pe.showUnits,this.defaultValue.showUnits),showValues:h(Pe.showValues,this.defaultValue.showValues),showConstants:h(Pe.showConstants,this.defaultValue.showConstants),showEnums:h(Pe.showEnums,this.defaultValue.showEnums),showEnumMembers:h(Pe.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:h(Pe.showKeywords,this.defaultValue.showKeywords),showWords:h(Pe.showWords,this.defaultValue.showWords),showColors:h(Pe.showColors,this.defaultValue.showColors),showFiles:h(Pe.showFiles,this.defaultValue.showFiles),showReferences:h(Pe.showReferences,this.defaultValue.showReferences),showFolders:h(Pe.showFolders,this.defaultValue.showFolders),showTypeParameters:h(Pe.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:h(Pe.showSnippets,this.defaultValue.showSnippets),showUsers:h(Pe.showUsers,this.defaultValue.showUsers),showIssues:h(Pe.showIssues,this.defaultValue.showIssues)}}}class Ne extends P{constructor(){super(113,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:g.localize(182,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:g.localize(183,null),default:!0,type:"boolean"}})}validate(ae){return!ae||typeof ae!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:h(ae.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:h(ae.selectSubwords,this.defaultValue.selectSubwords)}}}var qe;(function(ue){ue[ue.None=0]="None",ue[ue.Same=1]="Same",ue[ue.Indent=2]="Indent",ue[ue.DeepIndent=3]="DeepIndent"})(qe||(e.WrappingIndent=qe={}));class xe extends P{constructor(){super(137,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[g.localize(184,null),g.localize(185,null),g.localize(186,null),g.localize(187,null)],description:g.localize(188,null),default:"same"}})}validate(ae){switch(ae){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(ae,Pe,Ke){return Pe.get(2)===2?0:Ke}}class Ge extends D{constructor(){super(145)}compute(ae,Pe,Ke){const Ue=Pe.get(144);return{isDominatedByLongLines:ae.isDominatedByLongLines,isWordWrapMinified:Ue.isWordWrapMinified,isViewportWrapping:Ue.isViewportWrapping,wrappingColumn:Ue.wrappingColumn}}}class st extends P{constructor(){const ae={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",ae,{"editor.dropIntoEditor.enabled":{type:"boolean",default:ae.enabled,markdownDescription:g.localize(189,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:g.localize(190,null),enum:["afterDrop","never"],enumDescriptions:[g.localize(191,null),g.localize(192,null)],default:"afterDrop"}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Pe=ae;return{enabled:h(Pe.enabled,this.defaultValue.enabled),showDropSelector:i(Pe.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class it extends P{constructor(){const ae={enabled:!0,showPasteSelector:"afterPaste"};super(85,"pasteAs",ae,{"editor.pasteAs.enabled":{type:"boolean",default:ae.enabled,markdownDescription:g.localize(193,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:g.localize(194,null),enum:["afterPaste","never"],enumDescriptions:[g.localize(195,null),g.localize(196,null)],default:"afterPaste"}})}validate(ae){if(!ae||typeof ae!="object")return this.defaultValue;const Pe=ae;return{enabled:h(Pe.enabled,this.defaultValue.enabled),showPasteSelector:i(Pe.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const nt="Consolas, 'Courier New', monospace",Ae="Menlo, Monaco, 'Courier New', monospace",Oe="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:l.$e?Ae:l.$f?Oe:nt,fontWeight:"normal",fontSize:l.$e?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Re(ue){return e.editorOptionsRegistry[ue.id]=ue,ue}var Qe;(function(ue){ue[ue.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",ue[ue.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",ue[ue.accessibilitySupport=2]="accessibilitySupport",ue[ue.accessibilityPageSize=3]="accessibilityPageSize",ue[ue.ariaLabel=4]="ariaLabel",ue[ue.ariaRequired=5]="ariaRequired",ue[ue.autoClosingBrackets=6]="autoClosingBrackets",ue[ue.autoClosingComments=7]="autoClosingComments",ue[ue.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",ue[ue.autoClosingDelete=9]="autoClosingDelete",ue[ue.autoClosingOvertype=10]="autoClosingOvertype",ue[ue.autoClosingQuotes=11]="autoClosingQuotes",ue[ue.autoIndent=12]="autoIndent",ue[ue.automaticLayout=13]="automaticLayout",ue[ue.autoSurround=14]="autoSurround",ue[ue.bracketPairColorization=15]="bracketPairColorization",ue[ue.guides=16]="guides",ue[ue.codeLens=17]="codeLens",ue[ue.codeLensFontFamily=18]="codeLensFontFamily",ue[ue.codeLensFontSize=19]="codeLensFontSize",ue[ue.colorDecorators=20]="colorDecorators",ue[ue.colorDecoratorsLimit=21]="colorDecoratorsLimit",ue[ue.columnSelection=22]="columnSelection",ue[ue.comments=23]="comments",ue[ue.contextmenu=24]="contextmenu",ue[ue.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",ue[ue.cursorBlinking=26]="cursorBlinking",ue[ue.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",ue[ue.cursorStyle=28]="cursorStyle",ue[ue.cursorSurroundingLines=29]="cursorSurroundingLines",ue[ue.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",ue[ue.cursorWidth=31]="cursorWidth",ue[ue.disableLayerHinting=32]="disableLayerHinting",ue[ue.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",ue[ue.domReadOnly=34]="domReadOnly",ue[ue.dragAndDrop=35]="dragAndDrop",ue[ue.dropIntoEditor=36]="dropIntoEditor",ue[ue.emptySelectionClipboard=37]="emptySelectionClipboard",ue[ue.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",ue[ue.extraEditorClassName=39]="extraEditorClassName",ue[ue.fastScrollSensitivity=40]="fastScrollSensitivity",ue[ue.find=41]="find",ue[ue.fixedOverflowWidgets=42]="fixedOverflowWidgets",ue[ue.folding=43]="folding",ue[ue.foldingStrategy=44]="foldingStrategy",ue[ue.foldingHighlight=45]="foldingHighlight",ue[ue.foldingImportsByDefault=46]="foldingImportsByDefault",ue[ue.foldingMaximumRegions=47]="foldingMaximumRegions",ue[ue.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",ue[ue.fontFamily=49]="fontFamily",ue[ue.fontInfo=50]="fontInfo",ue[ue.fontLigatures=51]="fontLigatures",ue[ue.fontSize=52]="fontSize",ue[ue.fontWeight=53]="fontWeight",ue[ue.fontVariations=54]="fontVariations",ue[ue.formatOnPaste=55]="formatOnPaste",ue[ue.formatOnType=56]="formatOnType",ue[ue.glyphMargin=57]="glyphMargin",ue[ue.gotoLocation=58]="gotoLocation",ue[ue.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",ue[ue.hover=60]="hover",ue[ue.inDiffEditor=61]="inDiffEditor",ue[ue.inlineSuggest=62]="inlineSuggest",ue[ue.letterSpacing=63]="letterSpacing",ue[ue.lightbulb=64]="lightbulb",ue[ue.lineDecorationsWidth=65]="lineDecorationsWidth",ue[ue.lineHeight=66]="lineHeight",ue[ue.lineNumbers=67]="lineNumbers",ue[ue.lineNumbersMinChars=68]="lineNumbersMinChars",ue[ue.linkedEditing=69]="linkedEditing",ue[ue.links=70]="links",ue[ue.matchBrackets=71]="matchBrackets",ue[ue.minimap=72]="minimap",ue[ue.mouseStyle=73]="mouseStyle",ue[ue.mouseWheelScrollSensitivity=74]="mouseWheelScrollSensitivity",ue[ue.mouseWheelZoom=75]="mouseWheelZoom",ue[ue.multiCursorMergeOverlapping=76]="multiCursorMergeOverlapping",ue[ue.multiCursorModifier=77]="multiCursorModifier",ue[ue.multiCursorPaste=78]="multiCursorPaste",ue[ue.multiCursorLimit=79]="multiCursorLimit",ue[ue.multiDocumentOccurrencesHighlight=80]="multiDocumentOccurrencesHighlight",ue[ue.occurrencesHighlight=81]="occurrencesHighlight",ue[ue.overviewRulerBorder=82]="overviewRulerBorder",ue[ue.overviewRulerLanes=83]="overviewRulerLanes",ue[ue.padding=84]="padding",ue[ue.pasteAs=85]="pasteAs",ue[ue.parameterHints=86]="parameterHints",ue[ue.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",ue[ue.definitionLinkOpensInPeek=88]="definitionLinkOpensInPeek",ue[ue.quickSuggestions=89]="quickSuggestions",ue[ue.quickSuggestionsDelay=90]="quickSuggestionsDelay",ue[ue.readOnly=91]="readOnly",ue[ue.readOnlyMessage=92]="readOnlyMessage",ue[ue.renameOnType=93]="renameOnType",ue[ue.renderControlCharacters=94]="renderControlCharacters",ue[ue.renderFinalNewline=95]="renderFinalNewline",ue[ue.renderLineHighlight=96]="renderLineHighlight",ue[ue.renderLineHighlightOnlyWhenFocus=97]="renderLineHighlightOnlyWhenFocus",ue[ue.renderValidationDecorations=98]="renderValidationDecorations",ue[ue.renderWhitespace=99]="renderWhitespace",ue[ue.revealHorizontalRightPadding=100]="revealHorizontalRightPadding",ue[ue.roundedSelection=101]="roundedSelection",ue[ue.rulers=102]="rulers",ue[ue.scrollbar=103]="scrollbar",ue[ue.scrollBeyondLastColumn=104]="scrollBeyondLastColumn",ue[ue.scrollBeyondLastLine=105]="scrollBeyondLastLine",ue[ue.scrollPredominantAxis=106]="scrollPredominantAxis",ue[ue.selectionClipboard=107]="selectionClipboard",ue[ue.selectionHighlight=108]="selectionHighlight",ue[ue.selectOnLineNumbers=109]="selectOnLineNumbers",ue[ue.showFoldingControls=110]="showFoldingControls",ue[ue.showUnused=111]="showUnused",ue[ue.snippetSuggestions=112]="snippetSuggestions",ue[ue.smartSelect=113]="smartSelect",ue[ue.smoothScrolling=114]="smoothScrolling",ue[ue.stickyScroll=115]="stickyScroll",ue[ue.stickyTabStops=116]="stickyTabStops",ue[ue.stopRenderingLineAfter=117]="stopRenderingLineAfter",ue[ue.suggest=118]="suggest",ue[ue.suggestFontSize=119]="suggestFontSize",ue[ue.suggestLineHeight=120]="suggestLineHeight",ue[ue.suggestOnTriggerCharacters=121]="suggestOnTriggerCharacters",ue[ue.suggestSelection=122]="suggestSelection",ue[ue.tabCompletion=123]="tabCompletion",ue[ue.tabIndex=124]="tabIndex",ue[ue.unicodeHighlighting=125]="unicodeHighlighting",ue[ue.unusualLineTerminators=126]="unusualLineTerminators",ue[ue.useShadowDOM=127]="useShadowDOM",ue[ue.useTabStops=128]="useTabStops",ue[ue.wordBreak=129]="wordBreak",ue[ue.wordSeparators=130]="wordSeparators",ue[ue.wordWrap=131]="wordWrap",ue[ue.wordWrapBreakAfterCharacters=132]="wordWrapBreakAfterCharacters",ue[ue.wordWrapBreakBeforeCharacters=133]="wordWrapBreakBeforeCharacters",ue[ue.wordWrapColumn=134]="wordWrapColumn",ue[ue.wordWrapOverride1=135]="wordWrapOverride1",ue[ue.wordWrapOverride2=136]="wordWrapOverride2",ue[ue.wrappingIndent=137]="wrappingIndent",ue[ue.wrappingStrategy=138]="wrappingStrategy",ue[ue.showDeprecated=139]="showDeprecated",ue[ue.inlayHints=140]="inlayHints",ue[ue.editorClassName=141]="editorClassName",ue[ue.pixelRatio=142]="pixelRatio",ue[ue.tabFocusMode=143]="tabFocusMode",ue[ue.layoutInfo=144]="layoutInfo",ue[ue.wrappingInfo=145]="wrappingInfo",ue[ue.defaultColorDecorators=146]="defaultColorDecorators",ue[ue.colorDecoratorsActivatedOn=147]="colorDecoratorsActivatedOn",ue[ue.inlineCompletionsAccessibilityVerbose=148]="inlineCompletionsAccessibilityVerbose"})(Qe||(e.EditorOption=Qe={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Re(new u(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:g.localize(197,null)})),acceptSuggestionOnEnter:Re(new s(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",g.localize(198,null),""],markdownDescription:g.localize(199,null)})),accessibilitySupport:Re(new o),accessibilityPageSize:Re(new c(3,"accessibilityPageSize",10,1,1073741824,{description:g.localize(200,null),tags:["accessibility"]})),ariaLabel:Re(new t(4,"ariaLabel",g.localize(201,null))),ariaRequired:Re(new u(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:Re(new u(8,"screenReaderAnnounceInlineSuggestion",!0,{description:g.localize(202,null),tags:["accessibility"]})),autoClosingBrackets:Re(new s(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",g.localize(203,null),g.localize(204,null),""],description:g.localize(205,null)})),autoClosingComments:Re(new s(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",g.localize(206,null),g.localize(207,null),""],description:g.localize(208,null)})),autoClosingDelete:Re(new s(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",g.localize(209,null),""],description:g.localize(210,null)})),autoClosingOvertype:Re(new s(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",g.localize(211,null),""],description:g.localize(212,null)})),autoClosingQuotes:Re(new s(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",g.localize(213,null),g.localize(214,null),""],description:g.localize(215,null)})),autoIndent:Re(new n(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],r,{enumDescriptions:[g.localize(216,null),g.localize(217,null),g.localize(218,null),g.localize(219,null),g.localize(220,null)],description:g.localize(221,null)})),automaticLayout:Re(new u(13,"automaticLayout",!1)),autoSurround:Re(new s(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[g.localize(222,null),g.localize(223,null),g.localize(224,null),""],description:g.localize(225,null)})),bracketPairColorization:Re(new de),bracketPairGuides:Re(new ee),stickyTabStops:Re(new u(116,"stickyTabStops",!1,{description:g.localize(226,null)})),codeLens:Re(new u(17,"codeLens",!0,{description:g.localize(227,null)})),codeLensFontFamily:Re(new t(18,"codeLensFontFamily","",{description:g.localize(228,null)})),codeLensFontSize:Re(new c(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:g.localize(229,null)})),colorDecorators:Re(new u(20,"colorDecorators",!0,{description:g.localize(230,null)})),colorDecoratorActivatedOn:Re(new s(147,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[g.localize(231,null),g.localize(232,null),g.localize(233,null)],description:g.localize(234,null)})),colorDecoratorsLimit:Re(new c(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:g.localize(235,null)})),columnSelection:Re(new u(22,"columnSelection",!1,{description:g.localize(236,null)})),comments:Re(new v),contextmenu:Re(new u(24,"contextmenu",!0)),copyWithSyntaxHighlighting:Re(new u(25,"copyWithSyntaxHighlighting",!0,{description:g.localize(237,null)})),cursorBlinking:Re(new n(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],w,{description:g.localize(238,null)})),cursorSmoothCaretAnimation:Re(new s(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[g.localize(239,null),g.localize(240,null),g.localize(241,null)],description:g.localize(242,null)})),cursorStyle:Re(new n(28,"cursorStyle",m.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],I,{description:g.localize(243,null)})),cursorSurroundingLines:Re(new c(29,"cursorSurroundingLines",0,0,1073741824,{description:g.localize(244,null)})),cursorSurroundingLinesStyle:Re(new s(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[g.localize(245,null),g.localize(246,null)],markdownDescription:g.localize(247,null)})),cursorWidth:Re(new c(31,"cursorWidth",0,0,1073741824,{markdownDescription:g.localize(248,null)})),disableLayerHinting:Re(new u(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:Re(new u(33,"disableMonospaceOptimizations",!1)),domReadOnly:Re(new u(34,"domReadOnly",!1)),dragAndDrop:Re(new u(35,"dragAndDrop",!0,{description:g.localize(249,null)})),emptySelectionClipboard:Re(new O),dropIntoEditor:Re(new st),stickyScroll:Re(new oe),experimentalWhitespaceRendering:Re(new s(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[g.localize(250,null),g.localize(251,null),g.localize(252,null)],description:g.localize(253,null)})),extraEditorClassName:Re(new t(39,"extraEditorClassName","")),fastScrollSensitivity:Re(new a(40,"fastScrollSensitivity",5,ue=>ue<=0?5:ue,{markdownDescription:g.localize(254,null)})),find:Re(new F),fixedOverflowWidgets:Re(new u(42,"fixedOverflowWidgets",!1)),folding:Re(new u(43,"folding",!0,{description:g.localize(255,null)})),foldingStrategy:Re(new s(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[g.localize(256,null),g.localize(257,null)],description:g.localize(258,null)})),foldingHighlight:Re(new u(45,"foldingHighlight",!0,{description:g.localize(259,null)})),foldingImportsByDefault:Re(new u(46,"foldingImportsByDefault",!1,{description:g.localize(260,null)})),foldingMaximumRegions:Re(new c(47,"foldingMaximumRegions",5e3,10,65e3,{description:g.localize(261,null)})),unfoldOnClickAfterEndOfLine:Re(new u(48,"unfoldOnClickAfterEndOfLine",!1,{description:g.localize(262,null)})),fontFamily:Re(new t(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:g.localize(263,null)})),fontInfo:Re(new j),fontLigatures2:Re(new T),fontSize:Re(new U),fontWeight:Re(new B),fontVariations:Re(new N),formatOnPaste:Re(new u(55,"formatOnPaste",!1,{description:g.localize(264,null)})),formatOnType:Re(new u(56,"formatOnType",!1,{description:g.localize(265,null)})),glyphMargin:Re(new u(57,"glyphMargin",!0,{description:g.localize(266,null)})),gotoLocation:Re(new he),hideCursorInOverviewRuler:Re(new u(59,"hideCursorInOverviewRuler",!1,{description:g.localize(267,null)})),hover:Re(new x),inDiffEditor:Re(new u(61,"inDiffEditor",!1)),letterSpacing:Re(new a(63,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,ue=>a.clamp(ue,-5,20),{description:g.localize(268,null)})),lightbulb:Re(new _),lineDecorationsWidth:Re(new fe),lineHeight:Re(new V),lineNumbers:Re(new ge),lineNumbersMinChars:Re(new c(68,"lineNumbersMinChars",5,1,300)),linkedEditing:Re(new u(69,"linkedEditing",!1,{description:g.localize(269,null)})),links:Re(new u(70,"links",!0,{description:g.localize(270,null)})),matchBrackets:Re(new s(71,"matchBrackets","always",["always","near","never"],{description:g.localize(271,null)})),minimap:Re(new le),mouseStyle:Re(new s(73,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Re(new a(74,"mouseWheelScrollSensitivity",1,ue=>ue===0?1:ue,{markdownDescription:g.localize(272,null)})),mouseWheelZoom:Re(new u(75,"mouseWheelZoom",!1,{markdownDescription:g.localize(273,null)})),multiCursorMergeOverlapping:Re(new u(76,"multiCursorMergeOverlapping",!0,{description:g.localize(274,null)})),multiCursorModifier:Re(new n(77,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],H,{markdownEnumDescriptions:[g.localize(275,null),g.localize(276,null)],markdownDescription:g.localize(277,null)})),multiCursorPaste:Re(new s(78,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[g.localize(278,null),g.localize(279,null)],markdownDescription:g.localize(280,null)})),multiCursorLimit:Re(new c(79,"multiCursorLimit",1e4,1,1e5,{markdownDescription:g.localize(281,null)})),occurrencesHighlight:Re(new u(81,"occurrencesHighlight",!0,{description:g.localize(282,null)})),multiDocumentOccurrencesHighlight:Re(new u(80,"multiDocumentOccurrencesHighlight",!1,{description:g.localize(283,null)})),overviewRulerBorder:Re(new u(82,"overviewRulerBorder",!0,{description:g.localize(284,null)})),overviewRulerLanes:Re(new c(83,"overviewRulerLanes",3,0,3)),padding:Re(new G),pasteAs:Re(new it),parameterHints:Re(new Y),peekWidgetDefaultFocus:Re(new s(87,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[g.localize(285,null),g.localize(286,null)],description:g.localize(287,null)})),definitionLinkOpensInPeek:Re(new u(88,"definitionLinkOpensInPeek",!1,{description:g.localize(288,null)})),quickSuggestions:Re(new be),quickSuggestionsDelay:Re(new c(90,"quickSuggestionsDelay",10,0,1073741824,{description:g.localize(289,null)})),readOnly:Re(new u(91,"readOnly",!1)),readOnlyMessage:Re(new we),renameOnType:Re(new u(93,"renameOnType",!1,{description:g.localize(290,null),markdownDeprecationMessage:g.localize(291,null)})),renderControlCharacters:Re(new u(94,"renderControlCharacters",!0,{description:g.localize(292,null),restricted:!0})),renderFinalNewline:Re(new s(95,"renderFinalNewline",l.$f?"dimmed":"on",["off","on","dimmed"],{description:g.localize(293,null)})),renderLineHighlight:Re(new s(96,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",g.localize(294,null)],description:g.localize(295,null)})),renderLineHighlightOnlyWhenFocus:Re(new u(97,"renderLineHighlightOnlyWhenFocus",!1,{description:g.localize(296,null)})),renderValidationDecorations:Re(new s(98,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Re(new s(99,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",g.localize(297,null),g.localize(298,null),g.localize(299,null),""],description:g.localize(300,null)})),revealHorizontalRightPadding:Re(new c(100,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Re(new u(101,"roundedSelection",!0,{description:g.localize(301,null)})),rulers:Re(new me),scrollbar:Re(new W),scrollBeyondLastColumn:Re(new c(104,"scrollBeyondLastColumn",4,0,1073741824,{description:g.localize(302,null)})),scrollBeyondLastLine:Re(new u(105,"scrollBeyondLastLine",!0,{description:g.localize(303,null)})),scrollPredominantAxis:Re(new u(106,"scrollPredominantAxis",!0,{description:g.localize(304,null)})),selectionClipboard:Re(new u(107,"selectionClipboard",!0,{description:g.localize(305,null),included:l.$f})),selectionHighlight:Re(new u(108,"selectionHighlight",!0,{description:g.localize(306,null)})),selectOnLineNumbers:Re(new u(109,"selectOnLineNumbers",!0)),showFoldingControls:Re(new s(110,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[g.localize(307,null),g.localize(308,null),g.localize(309,null)],description:g.localize(310,null)})),showUnused:Re(new u(111,"showUnused",!0,{description:g.localize(311,null)})),showDeprecated:Re(new u(139,"showDeprecated",!0,{description:g.localize(312,null)})),inlayHints:Re(new ye),snippetSuggestions:Re(new s(112,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[g.localize(313,null),g.localize(314,null),g.localize(315,null),g.localize(316,null)],description:g.localize(317,null)})),smartSelect:Re(new Ne),smoothScrolling:Re(new u(114,"smoothScrolling",!1,{description:g.localize(318,null)})),stopRenderingLineAfter:Re(new c(117,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Re(new ve),inlineSuggest:Re(new ce),inlineCompletionsAccessibilityVerbose:Re(new u(148,"inlineCompletionsAccessibilityVerbose",!1,{description:g.localize(319,null)})),suggestFontSize:Re(new c(119,"suggestFontSize",0,0,1e3,{markdownDescription:g.localize(320,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Re(new c(120,"suggestLineHeight",0,0,1e3,{markdownDescription:g.localize(321,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Re(new u(121,"suggestOnTriggerCharacters",!0,{description:g.localize(322,null)})),suggestSelection:Re(new s(122,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[g.localize(323,null),g.localize(324,null),g.localize(325,null)],description:g.localize(326,null)})),tabCompletion:Re(new s(123,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[g.localize(327,null),g.localize(328,null),g.localize(329,null)],description:g.localize(330,null)})),tabIndex:Re(new c(124,"tabIndex",0,-1,1073741824)),unicodeHighlight:Re(new J),unusualLineTerminators:Re(new s(126,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[g.localize(331,null),g.localize(332,null),g.localize(333,null)],description:g.localize(334,null)})),useShadowDOM:Re(new u(127,"useShadowDOM",!0)),useTabStops:Re(new u(128,"useTabStops",!0,{description:g.localize(335,null)})),wordBreak:Re(new s(129,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[g.localize(336,null),g.localize(337,null)],description:g.localize(338,null)})),wordSeparators:Re(new t(130,"wordSeparators",A.$9r,{description:g.localize(339,null)})),wordWrap:Re(new s(131,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[g.localize(340,null),g.localize(341,null),g.localize(342,null),g.localize(343,null)],description:g.localize(344,null)})),wordWrapBreakAfterCharacters:Re(new t(132,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Re(new t(133,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Re(new c(134,"wordWrapColumn",80,1,1073741824,{markdownDescription:g.localize(345,null)})),wordWrapOverride1:Re(new s(135,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Re(new s(136,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Re(new z),defaultColorDecorators:Re(new u(146,"defaultColorDecorators",!1,{markdownDescription:g.localize(346,null)})),pixelRatio:Re(new X),tabFocusMode:Re(new u(143,"tabFocusMode",!1,{markdownDescription:g.localize(347,null)})),layoutInfo:Re(new Z),wrappingInfo:Re(new Ge),wrappingIndent:Re(new xe),wrappingStrategy:Re(new ie)}}),define(De[187],Ce([10,11]),function(re,e){return re.create("vs/editor/common/languages",e)}),define(De[83],Ce([1,0,79,2,169,33,180,187]),function(re,e,y,M,l,L,A,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.$pt=e.$ot=e.InlayHintKind=e.CommentState=e.CommentMode=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.$nt=e.$mt=e.SymbolKinds=e.SymbolTag=e.$lt=e.$kt=e.SymbolKind=e.$jt=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.$it=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.$ht=e.$gt=e.$ft=void 0;class k{constructor(T,N,j){this.offset=T,this.type=N,this.language=j,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}e.$ft=k;class ${constructor(T,N){this.tokens=T,this.endState=N,this._tokenizationResultBrand=void 0}}e.$gt=$;class R{constructor(T,N){this.tokens=T,this.endState=N,this._encodedTokenizationResultBrand=void 0}}e.$ht=R;var P;(function(F){F[F.Method=0]="Method",F[F.Function=1]="Function",F[F.Constructor=2]="Constructor",F[F.Field=3]="Field",F[F.Variable=4]="Variable",F[F.Class=5]="Class",F[F.Struct=6]="Struct",F[F.Interface=7]="Interface",F[F.Module=8]="Module",F[F.Property=9]="Property",F[F.Event=10]="Event",F[F.Operator=11]="Operator",F[F.Unit=12]="Unit",F[F.Value=13]="Value",F[F.Constant=14]="Constant",F[F.Enum=15]="Enum",F[F.EnumMember=16]="EnumMember",F[F.Keyword=17]="Keyword",F[F.Text=18]="Text",F[F.Color=19]="Color",F[F.File=20]="File",F[F.Reference=21]="Reference",F[F.Customcolor=22]="Customcolor",F[F.Folder=23]="Folder",F[F.TypeParameter=24]="TypeParameter",F[F.User=25]="User",F[F.Issue=26]="Issue",F[F.Snippet=27]="Snippet"})(P||(e.CompletionItemKind=P={}));var p;(function(F){const T=new Map;T.set(0,y.$Vj.symbolMethod),T.set(1,y.$Vj.symbolFunction),T.set(2,y.$Vj.symbolConstructor),T.set(3,y.$Vj.symbolField),T.set(4,y.$Vj.symbolVariable),T.set(5,y.$Vj.symbolClass),T.set(6,y.$Vj.symbolStruct),T.set(7,y.$Vj.symbolInterface),T.set(8,y.$Vj.symbolModule),T.set(9,y.$Vj.symbolProperty),T.set(10,y.$Vj.symbolEvent),T.set(11,y.$Vj.symbolOperator),T.set(12,y.$Vj.symbolUnit),T.set(13,y.$Vj.symbolValue),T.set(15,y.$Vj.symbolEnum),T.set(14,y.$Vj.symbolConstant),T.set(15,y.$Vj.symbolEnum),T.set(16,y.$Vj.symbolEnumMember),T.set(17,y.$Vj.symbolKeyword),T.set(27,y.$Vj.symbolSnippet),T.set(18,y.$Vj.symbolText),T.set(19,y.$Vj.symbolColor),T.set(20,y.$Vj.symbolFile),T.set(21,y.$Vj.symbolReference),T.set(22,y.$Vj.symbolCustomColor),T.set(23,y.$Vj.symbolFolder),T.set(24,y.$Vj.symbolTypeParameter),T.set(25,y.$Vj.account),T.set(26,y.$Vj.issues);function N(B){let he=T.get(B);return he||(console.info("No codicon found for CompletionItemKind "+B),he=y.$Vj.symbolProperty),he}F.toIcon=N;const j=new Map;j.set("method",0),j.set("function",1),j.set("constructor",2),j.set("field",3),j.set("variable",4),j.set("class",5),j.set("struct",6),j.set("interface",7),j.set("module",8),j.set("property",9),j.set("event",10),j.set("operator",11),j.set("unit",12),j.set("value",13),j.set("constant",14),j.set("enum",15),j.set("enum-member",16),j.set("enumMember",16),j.set("keyword",17),j.set("snippet",27),j.set("text",18),j.set("color",19),j.set("file",20),j.set("reference",21),j.set("customcolor",22),j.set("folder",23),j.set("type-parameter",24),j.set("typeParameter",24),j.set("account",25),j.set("issue",26);function U(B,he){let x=j.get(B);return typeof x>"u"&&!he&&(x=9),x}F.fromString=U})(p||(e.CompletionItemKinds=p={}));var S;(function(F){F[F.Deprecated=1]="Deprecated"})(S||(e.CompletionItemTag=S={}));var D;(function(F){F[F.None=0]="None",F[F.KeepWhitespace=1]="KeepWhitespace",F[F.InsertAsSnippet=4]="InsertAsSnippet"})(D||(e.CompletionItemInsertTextRule=D={}));var E;(function(F){F[F.Invoke=0]="Invoke",F[F.TriggerCharacter=1]="TriggerCharacter",F[F.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(E||(e.CompletionTriggerKind=E={}));var h;(function(F){F[F.Automatic=0]="Automatic",F[F.Explicit=1]="Explicit"})(h||(e.InlineCompletionTriggerKind=h={}));class u{constructor(T,N,j,U){this.range=T,this.text=N,this.completionKind=j,this.isSnippetText=U}equals(T){return L.$ys.lift(this.range).equalsRange(T.range)&&this.text===T.text&&this.completionKind===T.completionKind&&this.isSnippetText===T.isSnippetText}}e.$it=u;var d;(function(F){F[F.Invoke=1]="Invoke",F[F.Auto=2]="Auto"})(d||(e.CodeActionTriggerType=d={}));var c;(function(F){F[F.Invoke=1]="Invoke",F[F.TriggerCharacter=2]="TriggerCharacter",F[F.ContentChange=3]="ContentChange"})(c||(e.SignatureHelpTriggerKind=c={}));var f;(function(F){F[F.Text=0]="Text",F[F.Read=1]="Read",F[F.Write=2]="Write"})(f||(e.DocumentHighlightKind=f={}));function a(F){return F&&M.URI.isUri(F.uri)&&L.$ys.isIRange(F.range)&&(L.$ys.isIRange(F.originSelectionRange)||L.$ys.isIRange(F.targetSelectionRange))}e.$jt=a;var t;(function(F){F[F.File=0]="File",F[F.Module=1]="Module",F[F.Namespace=2]="Namespace",F[F.Package=3]="Package",F[F.Class=4]="Class",F[F.Method=5]="Method",F[F.Property=6]="Property",F[F.Field=7]="Field",F[F.Constructor=8]="Constructor",F[F.Enum=9]="Enum",F[F.Interface=10]="Interface",F[F.Function=11]="Function",F[F.Variable=12]="Variable",F[F.Constant=13]="Constant",F[F.String=14]="String",F[F.Number=15]="Number",F[F.Boolean=16]="Boolean",F[F.Array=17]="Array",F[F.Object=18]="Object",F[F.Key=19]="Key",F[F.Null=20]="Null",F[F.EnumMember=21]="EnumMember",F[F.Struct=22]="Struct",F[F.Event=23]="Event",F[F.Operator=24]="Operator",F[F.TypeParameter=25]="TypeParameter"})(t||(e.SymbolKind=t={})),e.$kt={[17]:(0,g.localize)(0,null),[16]:(0,g.localize)(1,null),[4]:(0,g.localize)(2,null),[13]:(0,g.localize)(3,null),[8]:(0,g.localize)(4,null),[9]:(0,g.localize)(5,null),[21]:(0,g.localize)(6,null),[23]:(0,g.localize)(7,null),[7]:(0,g.localize)(8,null),[0]:(0,g.localize)(9,null),[11]:(0,g.localize)(10,null),[10]:(0,g.localize)(11,null),[19]:(0,g.localize)(12,null),[5]:(0,g.localize)(13,null),[1]:(0,g.localize)(14,null),[2]:(0,g.localize)(15,null),[20]:(0,g.localize)(16,null),[15]:(0,g.localize)(17,null),[18]:(0,g.localize)(18,null),[24]:(0,g.localize)(19,null),[3]:(0,g.localize)(20,null),[6]:(0,g.localize)(21,null),[14]:(0,g.localize)(22,null),[22]:(0,g.localize)(23,null),[25]:(0,g.localize)(24,null),[12]:(0,g.localize)(25,null)};function i(F,T){return(0,g.localize)(26,null,F,e.$kt[T])}e.$lt=i;var s;(function(F){F[F.Deprecated=1]="Deprecated"})(s||(e.SymbolTag=s={}));var n;(function(F){const T=new Map;T.set(0,y.$Vj.symbolFile),T.set(1,y.$Vj.symbolModule),T.set(2,y.$Vj.symbolNamespace),T.set(3,y.$Vj.symbolPackage),T.set(4,y.$Vj.symbolClass),T.set(5,y.$Vj.symbolMethod),T.set(6,y.$Vj.symbolProperty),T.set(7,y.$Vj.symbolField),T.set(8,y.$Vj.symbolConstructor),T.set(9,y.$Vj.symbolEnum),T.set(10,y.$Vj.symbolInterface),T.set(11,y.$Vj.symbolFunction),T.set(12,y.$Vj.symbolVariable),T.set(13,y.$Vj.symbolConstant),T.set(14,y.$Vj.symbolString),T.set(15,y.$Vj.symbolNumber),T.set(16,y.$Vj.symbolBoolean),T.set(17,y.$Vj.symbolArray),T.set(18,y.$Vj.symbolObject),T.set(19,y.$Vj.symbolKey),T.set(20,y.$Vj.symbolNull),T.set(21,y.$Vj.symbolEnumMember),T.set(22,y.$Vj.symbolStruct),T.set(23,y.$Vj.symbolEvent),T.set(24,y.$Vj.symbolOperator),T.set(25,y.$Vj.symbolTypeParameter);function N(j){let U=T.get(j);return U||(console.info("No codicon found for SymbolKind "+j),U=y.$Vj.symbolProperty),U}F.toIcon=N})(n||(e.SymbolKinds=n={}));class r{static asEditOperation(T){return l.$zs.replace(L.$ys.lift(T.range),T.text)}}e.$mt=r;class o{static fromValue(T){switch(T){case"comment":return o.Comment;case"imports":return o.Imports;case"region":return o.Region}return new o(T)}constructor(T){this.value=T}}e.$nt=o,o.Comment=new o("comment"),o.Imports=new o("imports"),o.Region=new o("region");var v;(function(F){function T(N){return!N||typeof N!="object"?!1:typeof N.id=="string"&&typeof N.title=="string"}F.is=T})(v||(e.Command=v={}));var C;(function(F){F[F.Collapsed=0]="Collapsed",F[F.Expanded=1]="Expanded"})(C||(e.CommentThreadCollapsibleState=C={}));var w;(function(F){F[F.Unresolved=0]="Unresolved",F[F.Resolved=1]="Resolved"})(w||(e.CommentThreadState=w={}));var m;(function(F){F[F.Editing=0]="Editing",F[F.Preview=1]="Preview"})(m||(e.CommentMode=m={}));var b;(function(F){F[F.Published=0]="Published",F[F.Draft=1]="Draft"})(b||(e.CommentState=b={}));var I;(function(F){F[F.Type=1]="Type",F[F.Parameter=2]="Parameter"})(I||(e.InlayHintKind=I={}));class z{constructor(T){this.b=T,this.a=null}dispose(){this.a&&this.a.then(T=>{T&&T.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}e.$ot=z,e.$pt=new A.$0s;var O;(function(F){F[F.None=0]="None",F[F.Option=1]="Option",F[F.Default=2]="Default",F[F.Preferred=3]="Preferred"})(O||(e.ExternalUriOpenerPriority=O={}))}),define(De[188],Ce([10,11]),function(re,e){return re.create("vs/platform/configuration/common/configurationRegistry",e)}),define(De[189],Ce([10,11]),function(re,e){return re.create("vs/platform/contextkey/common/contextkey",e)}),define(De[190],Ce([10,11]),function(re,e){return re.create("vs/platform/contextkey/common/scanner",e)}),define(De[191],Ce([10,11]),function(re,e){return re.create("vs/platform/dialogs/common/dialogs",e)}),define(De[192],Ce([10,11]),function(re,e){return re.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(De[193],Ce([10,11]),function(re,e){return re.create("vs/platform/extensions/common/extensionValidator",e)}),define(De[194],Ce([10,11]),function(re,e){return re.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(De[195],Ce([10,11]),function(re,e){return re.create("vs/platform/files/common/files",e)}),define(De[196],Ce([10,11]),function(re,e){return re.create("vs/platform/files/common/io",e)}),define(De[197],Ce([10,11]),function(re,e){return re.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(De[198],Ce([10,11]),function(re,e){return re.create("vs/platform/markers/common/markers",e)}),define(De[199],Ce([10,11]),function(re,e){return re.create("vs/platform/theme/common/iconRegistry",e)}),define(De[200],Ce([10,11]),function(re,e){return re.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(De[201],Ce([10,11]),function(re,e){return re.create("vs/platform/workspace/common/workspace",e)}),define(De[202],Ce([10,11]),function(re,e){return re.create("vs/workbench/api/common/extHostChat",e)}),define(De[203],Ce([10,11]),function(re,e){return re.create("vs/workbench/api/common/extHostChatAgents2",e)}),define(De[204],Ce([10,11]),function(re,e){return re.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(De[205],Ce([10,11]),function(re,e){return re.create("vs/workbench/api/common/extHostExtensionService",e)}),define(De[206],Ce([10,11]),function(re,e){return re.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(De[207],Ce([10,11]),function(re,e){return re.create("vs/workbench/api/common/extHostLogService",e)}),define(De[208],Ce([10,11]),function(re,e){return re.create("vs/workbench/api/common/extHostNotebook",e)}),define(De[209],Ce([10,11]),function(re,e){return re.create("vs/workbench/api/common/extHostProgress",e)}),define(De[210],Ce([10,11]),function(re,e){return re.create("vs/workbench/api/common/extHostStatusBar",e)}),define(De[211],Ce([10,11]),function(re,e){return re.create("vs/workbench/api/common/extHostTelemetry",e)}),define(De[212],Ce([10,11]),function(re,e){return re.create("vs/workbench/api/common/extHostTerminalService",e)}),define(De[213],Ce([10,11]),function(re,e){return re.create("vs/workbench/api/common/extHostTreeViews",e)}),define(De[214],Ce([10,11]),function(re,e){return re.create("vs/workbench/api/common/extHostTunnelService",e)}),define(De[215],Ce([10,11]),function(re,e){return re.create("vs/workbench/api/common/extHostWorkspace",e)}),define(De[216],Ce([10,11]),function(re,e){return re.create("vs/workbench/api/node/extHostDebugService",e)}),define(De[217],Ce([10,11]),function(re,e){return re.create("vs/workbench/common/editor",e)}),define(De[218],Ce([10,11]),function(re,e){return re.create("vs/workbench/common/views",e)}),define(De[219],Ce([10,11]),function(re,e){return re.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(De[220],Ce([10,11]),function(re,e){return re.create("vs/workbench/contrib/debug/common/debug",e)}),define(De[221],Ce([10,11]),function(re,e){return re.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(De[222],Ce([10,11]),function(re,e){return re.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(De[223],Ce([10,11]),function(re,e){return re.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(De[224],Ce([10,11]),function(re,e){return re.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(De[225],Ce([10,11]),function(re,e){return re.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(De[226],Ce([10,11]),function(re,e){return re.create("vs/workbench/services/remote/common/tunnelModel",e)}),define(De[227],Ce([10,11]),function(re,e){return re.create("vs/workbench/services/search/common/queryBuilder",e)}),define(De[228],Ce([1,0,9,190]),function(re,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Li=e.TokenType=void 0;var l;(function($){$[$.LParen=0]="LParen",$[$.RParen=1]="RParen",$[$.Neg=2]="Neg",$[$.Eq=3]="Eq",$[$.NotEq=4]="NotEq",$[$.Lt=5]="Lt",$[$.LtEq=6]="LtEq",$[$.Gt=7]="Gt",$[$.GtEq=8]="GtEq",$[$.RegexOp=9]="RegexOp",$[$.RegexStr=10]="RegexStr",$[$.True=11]="True",$[$.False=12]="False",$[$.In=13]="In",$[$.Not=14]="Not",$[$.And=15]="And",$[$.Or=16]="Or",$[$.Str=17]="Str",$[$.QuotedStr=18]="QuotedStr",$[$.Error=19]="Error",$[$.EOF=20]="EOF"})(l||(e.TokenType=l={}));function L(...$){switch($.length){case 1:return(0,M.localize)(0,null,$[0]);case 2:return(0,M.localize)(1,null,$[0],$[1]);case 3:return(0,M.localize)(2,null,$[0],$[1],$[2]);default:return}}const A=(0,M.localize)(3,null),g=(0,M.localize)(4,null);class k{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(R){switch(R.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return R.isTripleEq?"===":"==";case 4:return R.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return R.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return R.lexeme;case 18:return R.lexeme;case 19:return R.lexeme;case 20:return"EOF";default:throw(0,y.$8)(`unhandled token type: ${JSON.stringify(R)}; have you forgotten to add a case?`)}}get errors(){return this.g}reset(R){return this.c=R,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const P=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:P})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const P=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:P})}else this.h(126)?this.k(9):this.l(L("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(L("&&"));break;case 124:this.h(124)?this.k(16):this.l(L("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(R){return this.r()||this.c.charCodeAt(this.e)!==R?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(R){this.f.push({type:R,offset:this.d})}l(R){const P=this.d,p=this.c.substring(this.d,this.e),S={type:19,offset:this.d,lexeme:p};this.g.push({offset:P,lexeme:p,additionalInfo:R}),this.f.push(S)}n(){this.m.lastIndex=this.d;const R=this.m.exec(this.c);if(R){this.e=this.d+R[0].length;const P=this.c.substring(this.d,this.e),p=k.b.get(P);p?this.k(p):this.f.push({type:17,lexeme:P,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(A);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let R=this.e,P=!1,p=!1;for(;;){if(R>=this.c.length){this.e=R,this.l(g);return}const D=this.c.charCodeAt(R);if(P)P=!1;else if(D===47&&!p){R++;break}else D===91?p=!0:D===92?P=!0:D===93&&(p=!1);R++}for(;R<this.c.length&&k.a.has(this.c.charCodeAt(R));)R++;this.e=R;const S=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:S,offset:this.d})}r(){return this.e>=this.c.length}}e.$Li=k,k.a=new Set(["i","g","s","m","y","u"].map($=>$.charCodeAt(0))),k.b=new Map([["not",14],["in",13],["false",12],["true",11]])}),define(De[229],Ce([1,0,23,39,193,374]),function(re,e,y,M,l,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wo=e.$Vo=e.$Uo=e.$To=e.$So=e.$Ro=e.$Qo=void 0;const A=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,g=/^-(\d{4})(\d{2})(\d{2})$/;function k(u){return u=u.trim(),u==="*"||A.test(u)}e.$Qo=k;function $(u){if(!k(u))return null;if(u=u.trim(),u==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const d=u.match(A);return d?{hasCaret:d[1]==="^",hasGreaterEquals:d[1]===">=",majorBase:d[2]==="x"?0:parseInt(d[2],10),majorMustEqual:d[2]!=="x",minorBase:d[4]==="x"?0:parseInt(d[4],10),minorMustEqual:d[4]!=="x",patchBase:d[6]==="x"?0:parseInt(d[6],10),patchMustEqual:d[6]!=="x",preRelease:d[8]||null}:null}e.$Ro=$;function R(u){if(!u)return null;const d=u.majorBase,c=u.majorMustEqual,f=u.minorBase;let a=u.minorMustEqual;const t=u.patchBase;let i=u.patchMustEqual;u.hasCaret&&(d===0||(a=!1),i=!1);let s=0;if(u.preRelease){const n=g.exec(u.preRelease);if(n){const[,r,o,v]=n;s=Date.UTC(Number(r),Number(o)-1,Number(v))}}return{majorBase:d,majorMustEqual:c,minorBase:f,minorMustEqual:a,patchBase:t,patchMustEqual:i,isMinimum:u.hasGreaterEquals,notBefore:s}}e.$So=R;function P(u,d,c){let f;typeof u=="string"?f=R($(u)):f=u;let a;d instanceof Date?a=d.getTime():typeof d=="string"&&(a=new Date(d).getTime());let t;if(typeof c=="string"?t=R($(c)):t=c,!f||!t)return!1;const i=f.majorBase,s=f.minorBase,n=f.patchBase;let r=t.majorBase,o=t.minorBase,v=t.patchBase;const C=t.notBefore;let w=t.majorMustEqual,m=t.minorMustEqual,b=t.patchMustEqual;return t.isMinimum?i>r?!0:i<r?!1:s>o?!0:s<o||a&&a<C?!1:n>=v:(i===1&&r===0&&(!w||!m||!b)&&(r=1,o=0,v=0,w=!0,m=!1,b=!1),i<r?!1:i>r?!w:s<o?!1:s>o?!m:n<v?!1:n>v?!b:!(a&&a<C))}e.$To=P;function p(u,d,c,f,a){const t=[];if(typeof f.publisher<"u"&&typeof f.publisher!="string")return t.push([M.default.Error,l.localize(0,null)]),t;if(typeof f.name!="string")return t.push([M.default.Error,l.localize(1,null,"name")]),t;if(typeof f.version!="string")return t.push([M.default.Error,l.localize(2,null,"version")]),t;if(!f.engines)return t.push([M.default.Error,l.localize(3,null,"engines")]),t;if(typeof f.engines.vscode!="string")return t.push([M.default.Error,l.localize(4,null,"engines.vscode")]),t;if(typeof f.extensionDependencies<"u"&&!h(f.extensionDependencies))return t.push([M.default.Error,l.localize(5,null,"extensionDependencies")]),t;if(typeof f.activationEvents<"u"){if(!h(f.activationEvents))return t.push([M.default.Error,l.localize(6,null,"activationEvents")]),t;if(typeof f.main>"u"&&typeof f.browser>"u")return t.push([M.default.Error,l.localize(7,null,"activationEvents","main","browser")]),t}if(typeof f.extensionKind<"u"&&typeof f.main>"u"&&t.push([M.default.Warning,l.localize(8,null,"extensionKind")]),typeof f.main<"u"){if(typeof f.main!="string")return t.push([M.default.Error,l.localize(9,null,"main")]),t;{const n=(0,y.$wg)(c,f.main);(0,y.$qg)(n,c)||t.push([M.default.Warning,l.localize(10,null,n.path,c.path)])}}if(typeof f.browser<"u"){if(typeof f.browser!="string")return t.push([M.default.Error,l.localize(11,null,"browser")]),t;{const n=(0,y.$wg)(c,f.browser);(0,y.$qg)(n,c)||t.push([M.default.Warning,l.localize(12,null,n.path,c.path)])}}if(!L.valid(f.version))return t.push([M.default.Error,l.localize(13,null)]),t;const i=[];if(!S(u,d,f,a,i))for(const n of i)t.push([M.default.Error,n]);return t}e.$Uo=p;function S(u,d,c,f,a){return f||typeof c.main>"u"&&typeof c.browser>"u"?!0:E(u,d,c.engines.vscode,a)}e.$Vo=S;function D(u,d,c){return u==="*"||E(d,c,u)}e.$Wo=D;function E(u,d,c,f=[]){const a=R($(c));if(!a)return f.push(l.localize(14,null,c)),!1;if(a.majorBase===0){if(!a.majorMustEqual||!a.minorMustEqual)return f.push(l.localize(15,null,c)),!1}else if(!a.majorMustEqual)return f.push(l.localize(16,null,c)),!1;return P(u,d,a)?!0:(f.push(l.localize(17,null,u,c)),!1)}function h(u){if(!Array.isArray(u))return!1;for(let d=0,c=u.length;d<c;d++)if(typeof u[d]!="string")return!1;return!0}}),define(De[102],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nh=void 0;class y{constructor(l,L=[],A=!1){this.ctor=l,this.staticArguments=L,this.supportsDelayedInstantiation=A}}e.$Nh=y}),define(De[103],Ce([1,0,102]),function(re,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cr=e.$Br=e.InstantiationType=void 0;const M=[];var l;(function(g){g[g.Eager=0]="Eager",g[g.Delayed=1]="Delayed"})(l||(e.InstantiationType=l={}));function L(g,k,$){k instanceof y.$Nh||(k=new y.$Nh(k,[],!!$)),M.push([g,k])}e.$Br=L;function A(){return M}e.$Cr=A}),define(De[230],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hq=e.$gq=void 0;class y{constructor(L,A){this.key=L,this.data=A,this.incoming=new Map,this.outgoing=new Map}}e.$gq=y;class M{constructor(L){this.b=L,this.a=new Map}roots(){const L=[];for(const A of this.a.values())A.outgoing.size===0&&L.push(A);return L}insertEdge(L,A){const g=this.lookupOrInsertNode(L),k=this.lookupOrInsertNode(A);g.outgoing.set(k.key,k),k.incoming.set(g.key,g)}removeNode(L){const A=this.b(L);this.a.delete(A);for(const g of this.a.values())g.outgoing.delete(A),g.incoming.delete(A)}lookupOrInsertNode(L){const A=this.b(L);let g=this.a.get(A);return g||(g=new y(A,L),this.a.set(A,g)),g}lookup(L){return this.a.get(this.b(L))}isEmpty(){return this.a.size===0}toString(){const L=[];for(const[A,g]of this.a)L.push(`${A}
	(-> incoming)[${[...g.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...g.outgoing.keys()].join(",")}]
`);return L.join(`
`)}findCycleSlow(){for(const[L,A]of this.a){const g=new Set([L]),k=this.c(A,g);if(k)return k}}c(L,A){for(const[g,k]of L.outgoing){if(A.has(g))return[...A,g].join(" -> ");A.add(g);const $=this.c(k,A);if($)return $;A.delete(g)}}}e.$hq=M}),define(De[5],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rh=e.$Qh=e.$Ph=e._util=void 0;var y;(function(A){A.serviceIds=new Map,A.DI_TARGET="$di$target",A.DI_DEPENDENCIES="$di$dependencies";function g(k){return k[A.DI_DEPENDENCIES]||[]}A.getServiceDependencies=g})(y||(e._util=y={})),e.$Ph=l("instantiationService");function M(A,g,k){g[y.DI_TARGET]===g?g[y.DI_DEPENDENCIES].push({id:A,index:k}):(g[y.DI_DEPENDENCIES]=[{id:A,index:k}],g[y.DI_TARGET]=g)}function l(A){if(y.serviceIds.has(A))return y.serviceIds.get(A);const g=function(k,$,R){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");M(g,k,R)};return g.toString=()=>A,y.serviceIds.set(A,g),g}e.$Qh=l;function L(A){return A}e.$Rh=L}),define(De[50],Ce([1,0,17,2,5]),function(re,e,y,M,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ui=e.$ti=e.$si=e.$ri=e.$qi=e.$pi=e.$oi=e.$ni=e.ConfigurationTarget=e.$mi=e.$li=e.$ki=void 0,e.$ki=(0,l.$Qh)("configurationService");function L(u){return u&&typeof u=="object"&&(!u.overrideIdentifier||typeof u.overrideIdentifier=="string")&&(!u.resource||u.resource instanceof M.URI)}e.$li=L;function A(u){return u&&typeof u=="object"&&(!u.overrideIdentifiers||Array.isArray(u.overrideIdentifiers))&&!u.overrideIdentifier&&(!u.resource||u.resource instanceof M.URI)}e.$mi=A;var g;(function(u){u[u.APPLICATION=1]="APPLICATION",u[u.USER=2]="USER",u[u.USER_LOCAL=3]="USER_LOCAL",u[u.USER_REMOTE=4]="USER_REMOTE",u[u.WORKSPACE=5]="WORKSPACE",u[u.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",u[u.DEFAULT=7]="DEFAULT",u[u.MEMORY=8]="MEMORY"})(g||(e.ConfigurationTarget=g={}));function k(u){switch(u){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$ni=k;function $(u){return u.applicationValue!==void 0||u.userValue!==void 0||u.userLocalValue!==void 0||u.userRemoteValue!==void 0||u.workspaceValue!==void 0||u.workspaceFolderValue!==void 0}e.$oi=$;function R(u,d){const c=Object.create(null);for(const f in u)P(c,f,u[f],d);return c}e.$pi=R;function P(u,d,c,f){const a=d.split("."),t=a.pop();let i=u;for(let s=0;s<a.length;s++){const n=a[s];let r=i[n];switch(typeof r){case"undefined":r=i[n]=Object.create(null);break;case"object":break;default:f(`Ignoring ${d} as ${a.slice(0,s+1).join(".")} is ${JSON.stringify(r)}`);return}i=r}if(typeof i=="object"&&i!==null)try{i[t]=c}catch{f(`Ignoring ${d} as ${a.join(".")} is ${JSON.stringify(i)}`)}else f(`Ignoring ${d} as ${a.join(".")} is ${JSON.stringify(i)}`)}e.$qi=P;function p(u,d){const c=d.split(".");S(u,c)}e.$ri=p;function S(u,d){const c=d.shift();if(d.length===0){delete u[c];return}if(Object.keys(u).indexOf(c)!==-1){const f=u[c];typeof f=="object"&&!Array.isArray(f)&&(S(f,d),Object.keys(f).length===0&&delete u[c])}}function D(u,d,c){function f(i,s){let n=i;for(const r of s){if(typeof n!="object"||n===null)return;n=n[r]}return n}const a=d.split("."),t=f(u,a);return typeof t>"u"?c:t}e.$si=D;function E(u,d,c){Object.keys(d).forEach(f=>{f!=="__proto__"&&(f in u?y.$Bf(u[f])&&y.$Bf(d[f])?E(u[f],d[f],c):c&&(u[f]=d[f]):u[f]=d[f])})}e.$ti=E;function h(u){return u.replace(/[\[\]]/g,"")}e.$ui=h}),define(De[42],Ce([1,0,12,16,228,5,189,9]),function(re,e,y,M,l,L,A,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0i=e.$9i=e.$8i=e.$7i=e.$6i=e.$5i=e.$4i=e.$3i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Vi=e.$Ui=e.$Ti=e.$Si=e.$Ri=e.$Qi=e.$Pi=e.$Oi=e.$Ni=e.ContextKeyExprType=e.$Mi=void 0;const k=new Map;k.set("false",!1),k.set("true",!0),k.set("isMac",y.$e),k.set("isLinux",y.$f),k.set("isWindows",y.$d),k.set("isWeb",y.$j),k.set("isMacNative",y.$e&&!y.$j),k.set("isEdge",y.$B),k.set("isFirefox",y.$z),k.set("isChrome",y.$y),k.set("isSafari",y.$A);function $(fe,V){if(k.get(fe)!==void 0)throw(0,g.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");k.set(fe,V)}e.$Mi=$;const R=Object.prototype.hasOwnProperty;var P;(function(fe){fe[fe.False=0]="False",fe[fe.True=1]="True",fe[fe.Defined=2]="Defined",fe[fe.Not=3]="Not",fe[fe.Equals=4]="Equals",fe[fe.NotEquals=5]="NotEquals",fe[fe.And=6]="And",fe[fe.Regex=7]="Regex",fe[fe.NotRegex=8]="NotRegex",fe[fe.Or=9]="Or",fe[fe.In=10]="In",fe[fe.NotIn=11]="NotIn",fe[fe.Greater=12]="Greater",fe[fe.GreaterEquals=13]="GreaterEquals",fe[fe.Smaller=14]="Smaller",fe[fe.SmallerEquals=15]="SmallerEquals"})(P||(e.ContextKeyExprType=P={}));const p={regexParsingWithErrorRecovery:!0},S=(0,A.localize)(0,null),D=(0,A.localize)(1,null),E=(0,A.localize)(2,null),h=(0,A.localize)(3,null),u=(0,A.localize)(4,null),d=(0,A.localize)(5,null),c=(0,A.localize)(6,null),f=(0,A.localize)(7,null);class a{get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(V=p){this.k=V,this.d=new l.$Li,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(V){if(V===""){this.h.push({message:S,offset:0,lexeme:"",additionalInfo:D});return}this.f=this.d.reset(V).scan(),this.g=0,this.h=[];try{const le=this.l();if(!this.E()){const H=this.D(),G=H.type===17?d:void 0;throw this.h.push({message:u,offset:H.offset,lexeme:l.$Li.getLexeme(H),additionalInfo:G}),a.c}return le}catch(le){if(le!==a.c)throw le;return}}l(){return this.m()}m(){const V=[this.o()];for(;this.y(16);){const le=this.o();V.push(le)}return V.length===1?V[0]:t.or(...V)}o(){const V=[this.s()];for(;this.y(15);){const le=this.s();V.push(le)}return V.length===1?V[0]:t.and(...V)}s(){if(this.y(2)){const V=this.D();switch(V.type){case 11:return this.z(),r.INSTANCE;case 12:return this.z(),o.INSTANCE;case 0:{this.z();const le=this.l();return this.A(1,h),le?.negate()}case 17:return this.z(),I.create(V.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",V)}}return this.t()}t(){const V=this.D();switch(V.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const le=this.l();return this.A(1,h),le}case 17:{const le=V.lexeme;if(this.z(),this.y(9)){const G=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),G.type!==10)throw this.B("REGEX",G);const Y=G.lexeme,X=Y.lastIndexOf("/"),be=X===Y.length-1?void 0:this.w(Y.substring(X+1));let se;try{se=new RegExp(Y.substring(1,X),be)}catch{throw this.B("REGEX",G)}return j.create(le,se)}switch(G.type){case 10:case 19:{const Y=[G.lexeme];this.z();let X=this.D(),be=0;for(let we=0;we<G.lexeme.length;we++)G.lexeme.charCodeAt(we)===40?be++:G.lexeme.charCodeAt(we)===41&&be--;for(;!this.E()&&X.type!==15&&X.type!==16;){switch(X.type){case 0:be++;break;case 1:be--;break;case 10:case 18:for(let we=0;we<X.lexeme.length;we++)X.lexeme.charCodeAt(we)===40?be++:G.lexeme.charCodeAt(we)===41&&be--}if(be<0)break;Y.push(l.$Li.getLexeme(X)),this.z(),X=this.D()}const se=Y.join(""),ge=se.lastIndexOf("/"),te=ge===se.length-1?void 0:this.w(se.substring(ge+1));let me;try{me=new RegExp(se.substring(1,ge),te)}catch{throw this.B("REGEX",G)}return t.regex(le,me)}case 18:{const Y=G.lexeme;this.z();let X=null;if(!(0,M.$Ce)(Y)){const be=Y.indexOf("/"),se=Y.lastIndexOf("/");if(be!==se&&be>=0){const ge=Y.slice(be+1,se),te=Y[se+1]==="i"?"i":"";try{X=new RegExp(ge,te)}catch{throw this.B("REGEX",G)}}}if(X===null)throw this.B("REGEX",G);return j.create(le,X)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,E);const G=this.u();return t.notIn(le,G)}switch(this.D().type){case 3:{this.z();const G=this.u();if(this.x().type===18)return t.equals(le,G);switch(G){case"true":return t.has(le);case"false":return t.not(le);default:return t.equals(le,G)}}case 4:{this.z();const G=this.u();if(this.x().type===18)return t.notEquals(le,G);switch(G){case"true":return t.not(le);case"false":return t.has(le);default:return t.notEquals(le,G)}}case 5:return this.z(),T.create(le,this.u());case 6:return this.z(),N.create(le,this.u());case 7:return this.z(),O.create(le,this.u());case 8:return this.z(),F.create(le,this.u());case 13:return this.z(),t.in(le,this.u());default:return t.has(le)}}case 20:throw this.h.push({message:c,offset:V.offset,lexeme:"",additionalInfo:f}),a.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const V=this.D();switch(V.type){case 17:case 18:return this.z(),V.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(V){return V.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(V){return this.C(V)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(V,le){if(this.C(V))return this.z();throw this.B(le,this.D())}B(V,le,H){const G=(0,A.localize)(8,null,V,l.$Li.getLexeme(le)),Y=le.offset,X=l.$Li.getLexeme(le);return this.h.push({message:G,offset:Y,lexeme:X,additionalInfo:H}),a.c}C(V){return this.D().type===V}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$Ni=a,a.c=new Error;class t{static false(){return r.INSTANCE}static true(){return o.INSTANCE}static has(V){return v.create(V)}static equals(V,le){return C.create(V,le)}static notEquals(V,le){return b.create(V,le)}static regex(V,le){return j.create(V,le)}static in(V,le){return w.create(V,le)}static notIn(V,le){return m.create(V,le)}static not(V){return I.create(V)}static and(...V){return he.create(V,null,!0)}static or(...V){return x.create(V,null,!0)}static greater(V,le){return O.create(V,le)}static greaterEquals(V,le){return F.create(V,le)}static smaller(V,le){return T.create(V,le)}static smallerEquals(V,le){return N.create(V,le)}static deserialize(V){return V==null?void 0:this.c.parse(V)}}e.$Oi=t,t.c=new a({regexParsingWithErrorRecovery:!1});function i(fe){const V=new a({regexParsingWithErrorRecovery:!1});return fe.map(le=>(V.parse(le),V.lexingErrors.length>0?V.lexingErrors.map(H=>({errorMessage:H.additionalInfo?(0,A.localize)(9,null,H.additionalInfo):(0,A.localize)(10,null),offset:H.offset,length:H.lexeme.length})):V.parsingErrors.length>0?V.parsingErrors.map(H=>({errorMessage:H.additionalInfo?`${H.message}. ${H.additionalInfo}`:H.message,offset:H.offset,length:H.lexeme.length})):[]))}e.$Pi=i;function s(fe,V){const le=fe?fe.substituteConstants():void 0,H=V?V.substituteConstants():void 0;return!le&&!H?!0:!le||!H?!1:le.equals(H)}e.$Qi=s;function n(fe,V){return fe.cmp(V)}class r{constructor(){this.type=0}cmp(V){return this.type-V.type}equals(V){return V.type===this.type}substituteConstants(){return this}evaluate(V){return!1}serialize(){return"false"}keys(){return[]}map(V){return this}negate(){return o.INSTANCE}}e.$Ri=r,r.INSTANCE=new r;class o{constructor(){this.type=1}cmp(V){return this.type-V.type}equals(V){return V.type===this.type}substituteConstants(){return this}evaluate(V){return!0}serialize(){return"true"}keys(){return[]}map(V){return this}negate(){return r.INSTANCE}}e.$Si=o,o.INSTANCE=new o;class v{static create(V,le=null){const H=k.get(V);return typeof H=="boolean"?H?o.INSTANCE:r.INSTANCE:new v(V,le)}constructor(V,le){this.key=V,this.c=le,this.type=2}cmp(V){return V.type!==this.type?this.type-V.type:Z(this.key,V.key)}equals(V){return V.type===this.type?this.key===V.key:!1}substituteConstants(){const V=k.get(this.key);return typeof V=="boolean"?V?o.INSTANCE:r.INSTANCE:this}evaluate(V){return!!V.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(V){return V.mapDefined(this.key)}negate(){return this.c||(this.c=I.create(this.key,this)),this.c}}e.$Ti=v;class C{static create(V,le,H=null){if(typeof le=="boolean")return le?v.create(V,H):I.create(V,H);const G=k.get(V);return typeof G=="boolean"?le===(G?"true":"false")?o.INSTANCE:r.INSTANCE:new C(V,le,H)}constructor(V,le,H){this.c=V,this.d=le,this.f=H,this.type=4}cmp(V){return V.type!==this.type?this.type-V.type:ie(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){const V=k.get(this.c);if(typeof V=="boolean"){const le=V?"true":"false";return this.d===le?o.INSTANCE:r.INSTANCE}return this}evaluate(V){return V.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(V){return V.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=b.create(this.c,this.d,this)),this.f}}e.$Ui=C;class w{static create(V,le){return new w(V,le)}constructor(V,le){this.d=V,this.f=le,this.type=10,this.c=null}cmp(V){return V.type!==this.type?this.type-V.type:ie(this.d,this.f,V.d,V.f)}equals(V){return V.type===this.type?this.d===V.d&&this.f===V.f:!1}substituteConstants(){return this}evaluate(V){const le=V.getValue(this.f),H=V.getValue(this.d);return Array.isArray(le)?le.includes(H):typeof H=="string"&&typeof le=="object"&&le!==null?R.call(le,H):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(V){return V.mapIn(this.d,this.f)}negate(){return this.c||(this.c=m.create(this.d,this.f)),this.c}}e.$Vi=w;class m{static create(V,le){return new m(V,le)}constructor(V,le){this.d=V,this.f=le,this.type=11,this.c=w.create(V,le)}cmp(V){return V.type!==this.type?this.type-V.type:this.c.cmp(V.c)}equals(V){return V.type===this.type?this.c.equals(V.c):!1}substituteConstants(){return this}evaluate(V){return!this.c.evaluate(V)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(V){return V.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Wi=m;class b{static create(V,le,H=null){if(typeof le=="boolean")return le?I.create(V,H):v.create(V,H);const G=k.get(V);return typeof G=="boolean"?le===(G?"true":"false")?r.INSTANCE:o.INSTANCE:new b(V,le,H)}constructor(V,le,H){this.c=V,this.d=le,this.f=H,this.type=5}cmp(V){return V.type!==this.type?this.type-V.type:ie(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){const V=k.get(this.c);if(typeof V=="boolean"){const le=V?"true":"false";return this.d===le?r.INSTANCE:o.INSTANCE}return this}evaluate(V){return V.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(V){return V.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=C.create(this.c,this.d,this)),this.f}}e.$Xi=b;class I{static create(V,le=null){const H=k.get(V);return typeof H=="boolean"?H?r.INSTANCE:o.INSTANCE:new I(V,le)}constructor(V,le){this.c=V,this.d=le,this.type=3}cmp(V){return V.type!==this.type?this.type-V.type:Z(this.c,V.c)}equals(V){return V.type===this.type?this.c===V.c:!1}substituteConstants(){const V=k.get(this.c);return typeof V=="boolean"?V?r.INSTANCE:o.INSTANCE:this}evaluate(V){return!V.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(V){return V.mapNot(this.c)}negate(){return this.d||(this.d=v.create(this.c,this)),this.d}}e.$Yi=I;function z(fe,V){if(typeof fe=="string"){const le=parseFloat(fe);isNaN(le)||(fe=le)}return typeof fe=="string"||typeof fe=="number"?V(fe):r.INSTANCE}class O{static create(V,le,H=null){return z(le,G=>new O(V,G,H))}constructor(V,le,H){this.c=V,this.d=le,this.f=H,this.type=12}cmp(V){return V.type!==this.type?this.type-V.type:ie(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){return this}evaluate(V){return typeof this.d=="string"?!1:parseFloat(V.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(V){return V.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=N.create(this.c,this.d,this)),this.f}}e.$Zi=O;class F{static create(V,le,H=null){return z(le,G=>new F(V,G,H))}constructor(V,le,H){this.c=V,this.d=le,this.f=H,this.type=13}cmp(V){return V.type!==this.type?this.type-V.type:ie(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){return this}evaluate(V){return typeof this.d=="string"?!1:parseFloat(V.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(V){return V.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=T.create(this.c,this.d,this)),this.f}}e.$1i=F;class T{static create(V,le,H=null){return z(le,G=>new T(V,G,H))}constructor(V,le,H){this.c=V,this.d=le,this.f=H,this.type=14}cmp(V){return V.type!==this.type?this.type-V.type:ie(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){return this}evaluate(V){return typeof this.d=="string"?!1:parseFloat(V.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(V){return V.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=F.create(this.c,this.d,this)),this.f}}e.$2i=T;class N{static create(V,le,H=null){return z(le,G=>new N(V,G,H))}constructor(V,le,H){this.c=V,this.d=le,this.f=H,this.type=15}cmp(V){return V.type!==this.type?this.type-V.type:ie(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){return this}evaluate(V){return typeof this.d=="string"?!1:parseFloat(V.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(V){return V.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=O.create(this.c,this.d,this)),this.f}}e.$3i=N;class j{static create(V,le){return new j(V,le)}constructor(V,le){this.d=V,this.f=le,this.type=7,this.c=null}cmp(V){if(V.type!==this.type)return this.type-V.type;if(this.d<V.d)return-1;if(this.d>V.d)return 1;const le=this.f?this.f.source:"",H=V.f?V.f.source:"";return le<H?-1:le>H?1:0}equals(V){if(V.type===this.type){const le=this.f?this.f.source:"",H=V.f?V.f.source:"";return this.d===V.d&&le===H}return!1}substituteConstants(){return this}evaluate(V){const le=V.getValue(this.d);return this.f?this.f.test(le):!1}serialize(){const V=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${V}`}keys(){return[this.d]}map(V){return V.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=U.create(this)),this.c}}e.$4i=j;class U{static create(V){return new U(V)}constructor(V){this.c=V,this.type=8}cmp(V){return V.type!==this.type?this.type-V.type:this.c.cmp(V.c)}equals(V){return V.type===this.type?this.c.equals(V.c):!1}substituteConstants(){return this}evaluate(V){return!this.c.evaluate(V)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(V){return new U(this.c.map(V))}negate(){return this.c}}e.$5i=U;function B(fe){let V=null;for(let le=0,H=fe.length;le<H;le++){const G=fe[le].substituteConstants();if(fe[le]!==G&&V===null){V=[];for(let Y=0;Y<le;Y++)V[Y]=fe[Y]}V!==null&&(V[le]=G)}return V===null?fe:V}class he{static create(V,le,H){return he.d(V,le,H)}constructor(V,le){this.expr=V,this.c=le,this.type=6}cmp(V){if(V.type!==this.type)return this.type-V.type;if(this.expr.length<V.expr.length)return-1;if(this.expr.length>V.expr.length)return 1;for(let le=0,H=this.expr.length;le<H;le++){const G=n(this.expr[le],V.expr[le]);if(G!==0)return G}return 0}equals(V){if(V.type===this.type){if(this.expr.length!==V.expr.length)return!1;for(let le=0,H=this.expr.length;le<H;le++)if(!this.expr[le].equals(V.expr[le]))return!1;return!0}return!1}substituteConstants(){const V=B(this.expr);return V===this.expr?this:he.create(V,this.c,!1)}evaluate(V){for(let le=0,H=this.expr.length;le<H;le++)if(!this.expr[le].evaluate(V))return!1;return!0}static d(V,le,H){const G=[];let Y=!1;for(const X of V)if(X){if(X.type===1){Y=!0;continue}if(X.type===0)return r.INSTANCE;if(X.type===6){G.push(...X.expr);continue}G.push(X)}if(G.length===0&&Y)return o.INSTANCE;if(G.length!==0){if(G.length===1)return G[0];G.sort(n);for(let X=1;X<G.length;X++)G[X-1].equals(G[X])&&(G.splice(X,1),X--);if(G.length===1)return G[0];for(;G.length>1;){const X=G[G.length-1];if(X.type!==9)break;G.pop();const be=G.pop(),se=G.length===0,ge=x.create(X.expr.map(te=>he.create([te,be],null,H)),null,se);ge&&(G.push(ge),G.sort(n))}if(G.length===1)return G[0];if(H){for(let X=0;X<G.length;X++)for(let be=X+1;be<G.length;be++)if(G[X].negate().equals(G[be]))return r.INSTANCE;if(G.length===1)return G[0]}return new he(G,le)}}serialize(){return this.expr.map(V=>V.serialize()).join(" && ")}keys(){const V=[];for(const le of this.expr)V.push(...le.keys());return V}map(V){return new he(this.expr.map(le=>le.map(V)),null)}negate(){if(!this.c){const V=[];for(const le of this.expr)V.push(le.negate());this.c=x.create(V,this,!0)}return this.c}}e.$6i=he;class x{static create(V,le,H){return x.d(V,le,H)}constructor(V,le){this.expr=V,this.c=le,this.type=9}cmp(V){if(V.type!==this.type)return this.type-V.type;if(this.expr.length<V.expr.length)return-1;if(this.expr.length>V.expr.length)return 1;for(let le=0,H=this.expr.length;le<H;le++){const G=n(this.expr[le],V.expr[le]);if(G!==0)return G}return 0}equals(V){if(V.type===this.type){if(this.expr.length!==V.expr.length)return!1;for(let le=0,H=this.expr.length;le<H;le++)if(!this.expr[le].equals(V.expr[le]))return!1;return!0}return!1}substituteConstants(){const V=B(this.expr);return V===this.expr?this:x.create(V,this.c,!1)}evaluate(V){for(let le=0,H=this.expr.length;le<H;le++)if(this.expr[le].evaluate(V))return!0;return!1}static d(V,le,H){let G=[],Y=!1;if(V){for(let X=0,be=V.length;X<be;X++){const se=V[X];if(se){if(se.type===0){Y=!0;continue}if(se.type===1)return o.INSTANCE;if(se.type===9){G=G.concat(se.expr);continue}G.push(se)}}if(G.length===0&&Y)return r.INSTANCE;G.sort(n)}if(G.length!==0){if(G.length===1)return G[0];for(let X=1;X<G.length;X++)G[X-1].equals(G[X])&&(G.splice(X,1),X--);if(G.length===1)return G[0];if(H){for(let X=0;X<G.length;X++)for(let be=X+1;be<G.length;be++)if(G[X].negate().equals(G[be]))return o.INSTANCE;if(G.length===1)return G[0]}return new x(G,le)}}serialize(){return this.expr.map(V=>V.serialize()).join(" || ")}keys(){const V=[];for(const le of this.expr)V.push(...le.keys());return V}map(V){return new x(this.expr.map(le=>le.map(V)),null)}negate(){if(!this.c){const V=[];for(const le of this.expr)V.push(le.negate());for(;V.length>1;){const le=V.shift(),H=V.shift(),G=[];for(const Y of ye(le))for(const X of ye(H))G.push(he.create([Y,X],null,!1));V.unshift(x.create(G,null,!1))}this.c=x.create(V,this,!0)}return this.c}}e.$7i=x;class Q extends v{static all(){return Q.d.values()}constructor(V,le,H){super(V,null),this.f=le,typeof H=="object"?Q.d.push({...H,key:V}):H!==!0&&Q.d.push({key:V,description:H,type:le!=null?typeof le:void 0})}bindTo(V){return V.createKey(this.key,this.f)}getValue(V){return V.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(V){return C.create(this.key,V)}notEqualsTo(V){return b.create(this.key,V)}}e.$8i=Q,Q.d=[],e.$9i=(0,L.$Qh)("contextKeyService");function Z(fe,V){return fe<V?-1:fe>V?1:0}function ie(fe,V,le,H){return fe<le?-1:fe>le?1:V<H?-1:V>H?1:0}function _(fe,V){if(fe.type===0||V.type===1)return!0;if(fe.type===9)return V.type===9?oe(fe.expr,V.expr):!1;if(V.type===9){for(const le of V.expr)if(_(fe,le))return!0;return!1}if(fe.type===6){if(V.type===6)return oe(V.expr,fe.expr);for(const le of fe.expr)if(_(le,V))return!0;return!1}return fe.equals(V)}e.$0i=_;function oe(fe,V){let le=0,H=0;for(;le<fe.length&&H<V.length;){const G=fe[le].cmp(V[H]);if(G<0)return!1;G===0&&le++,H++}return le===fe.length}function ye(fe){return fe.type===9?fe.expr:[fe]}}),define(De[231],Ce([1,0,23,39,191,5,99,12,24]),function(re,e,y,M,l,L,A,g,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kv=e.$Jv=e.ConfirmResult=e.$Iv=e.$Hv=e.$Gv=void 0,e.$Gv=(0,L.$Qh)("dialogService");var $;(function(E){E[E.Confirmation=1]="Confirmation",E[E.Prompt=2]="Prompt",E[E.Input=3]="Input"})($||($={}));class R{a(h){return this.d(h,$.Confirmation)}b(h){return this.d(h,$.Prompt)}c(h){return this.d(h,$.Input)}d(h,u){const d=[];switch(u){case $.Confirmation:{const c=h;c.primaryButton?d.push(c.primaryButton):d.push((0,l.localize)(0,null)),c.cancelButton?d.push(c.cancelButton):d.push((0,l.localize)(1,null));break}case $.Prompt:{const c=h;Array.isArray(c.buttons)&&c.buttons.length>0&&d.push(...c.buttons.map(f=>f.label)),c.cancelButton&&(c.cancelButton===!0?d.push((0,l.localize)(2,null)):typeof c.cancelButton=="string"?d.push(c.cancelButton):c.cancelButton.label?d.push(c.cancelButton.label):d.push((0,l.localize)(3,null))),d.length===0&&d.push((0,l.localize)(4,null));break}case $.Input:{const c=h;c.primaryButton?d.push(c.primaryButton):d.push((0,l.localize)(5,null)),c.cancelButton?d.push(c.cancelButton):d.push((0,l.localize)(6,null));break}}return d}e(h){if(typeof h=="string")return h;if(typeof h=="number")return h===M.default.Info?"info":h===M.default.Error?"error":h===M.default.Warning?"warning":"none"}f(h,u,d){const c=[...h.buttons??[]];h.cancelButton&&typeof h.cancelButton!="string"&&typeof h.cancelButton!="boolean"&&c.push(h.cancelButton);let f=c[u]?.run({checkboxChecked:d});return f instanceof Promise||(f=Promise.resolve(f)),{result:f,checkboxChecked:d}}}e.$Hv=R,e.$Iv=(0,L.$Qh)("fileDialogService");var P;(function(E){E[E.SAVE=0]="SAVE",E[E.DONT_SAVE=1]="DONT_SAVE",E[E.CANCEL=2]="CANCEL"})(P||(e.ConfirmResult=P={}));const p=10;function S(E){const h=[];return h.push(...E.slice(0,p).map(u=>typeof u=="string"?u:(0,y.$tg)(u))),E.length>p&&(E.length-p===1?h.push((0,l.localize)(7,null)):h.push((0,l.localize)(8,null,E.length-p))),h.push(""),h.join(`
`)}e.$Jv=S;function D(E,h){const u=(0,k.$9m)(E);let d=(u.buttons??[]).map(t=>(0,A.$Dv)(t)),c=(E.buttons||[]).map((t,i)=>i),f=0,a=u.cancelId??d.length-1;if(d.length>1){const t=typeof a=="number"?d[a]:void 0;if(g.$f||g.$e){if(typeof t=="string"&&d.length>1&&a!==1){d.splice(a,1),d.splice(1,0,t);const i=c[a];c.splice(a,1),c.splice(1,0,i),a=1}g.$f&&d.length>1&&(d=d.reverse(),c=c.reverse(),f=d.length-1,typeof t=="string"&&(a=f-1))}else if(g.$d&&typeof t=="string"&&d.length>1&&a!==d.length-1){d.splice(a,1),d.push(t);const i=c[a];c.splice(a,1),c.push(i),a=d.length-1}}return u.buttons=d,u.defaultId=f,u.cancelId=a,u.noLink=!0,u.title=u.title||h.nameLong,{options:u,buttonIndeces:c}}e.$Kv=D}),define(De[132],Ce([1,0,5]),function(re,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yh=e.$Xh=void 0,e.$Xh=(0,y.$Qh)("environmentService"),e.$Yh=(0,y.$Rh)(e.$Xh)}),define(De[133],Ce([1,0,192,5]),function(re,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lo=e.$ko=e.$jo=e.$io=e.$ho=e.$go=e.$fo=e.$eo=e.$do=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$co=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$bo=e.$ao=e.$_n=e.$$n=e.$0n=e.$9n=e.$8n=e.$7n=e.$6n=e.$5n=e.$4n=e.$3n=void 0,e.$3n="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$4n=new RegExp(e.$3n),e.$5n="__web_extension",e.$6n="skipWalkthrough",e.$7n="extensionsSync",e.$8n="dependecyOrPackExtensionInstall";function l(u){switch(u){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$9n=l;function L(u){switch(u){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$0n=L;function A(u,d){switch(u){case 3:return d==="x64"?"win32-x64":d==="arm64"?"win32-arm64":"unknown";case 2:return d==="x64"?"linux-x64":d==="arm64"?"linux-arm64":d==="arm"?"linux-armhf":"unknown";case"alpine":return d==="x64"?"alpine-x64":d==="arm64"?"alpine-arm64":"unknown";case 1:return d==="x64"?"darwin-x64":d==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$$n=A;function g(u,d){return d==="web"&&!u.includes("web")}e.$_n=g;function k(u,d,c){return g(d,c)?!1:u==="undefined"||u==="universal"?!0:u==="unknown"?!1:u===c}e.$ao=k;function $(u){return u&&typeof u=="object"&&typeof u.id=="string"&&(!u.uuid||typeof u.uuid=="string")}e.$bo=$;var R;(function(u){u[u.NoneOrRelevance=0]="NoneOrRelevance",u[u.LastUpdatedDate=1]="LastUpdatedDate",u[u.Title=2]="Title",u[u.PublisherName=3]="PublisherName",u[u.InstallCount=4]="InstallCount",u[u.PublishedDate=10]="PublishedDate",u[u.AverageRating=6]="AverageRating",u[u.WeightedRating=12]="WeightedRating"})(R||(e.SortBy=R={}));var P;(function(u){u[u.Default=0]="Default",u[u.Ascending=1]="Ascending",u[u.Descending=2]="Descending"})(P||(e.SortOrder=P={}));var p;(function(u){u.Install="install",u.Uninstall="uninstall"})(p||(e.StatisticType=p={}));var S;(function(u){u[u.None=1]="None",u[u.Install=2]="Install",u[u.Update=3]="Update",u[u.Migrate=4]="Migrate"})(S||(e.InstallOperation=S={})),e.$co=(0,M.$Qh)("extensionGalleryService");var D;(function(u){u.Unsupported="Unsupported",u.Deprecated="Deprecated",u.Malicious="Malicious",u.Incompatible="Incompatible",u.IncompatibleTargetPlatform="IncompatibleTargetPlatform",u.ReleaseVersionNotFound="ReleaseVersionNotFound",u.Invalid="Invalid",u.Download="Download",u.Extract="Extract",u.Delete="Delete",u.Rename="Rename",u.CorruptZip="CorruptZip",u.IncompleteZip="IncompleteZip",u.Signature="Signature",u.Internal="Internal"})(D||(e.ExtensionManagementErrorCode=D={}));var E;(function(u){u.UnknownError="UnknownError",u.PackageIsInvalidZip="PackageIsInvalidZip",u.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(E||(e.ExtensionSignaturetErrorCode=E={}));class h extends Error{constructor(d,c){super(d),this.code=c,this.name=c}}e.$do=h,e.$eo=(0,M.$Qh)("extensionManagementService"),e.$fo="extensionsIdentifiers/disabled",e.$go="extensionsIdentifiers/enabled",e.$ho=(0,M.$Qh)("IGlobalExtensionEnablementService"),e.$io=(0,M.$Qh)("IExtensionTipsService"),e.$jo=(0,y.localize)(0,null),e.$ko={value:e.$jo,original:"Extensions"},e.$lo={value:(0,y.localize)(1,null),original:"Preferences"}}),define(De[232],Ce([1,0,5]),function(re,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FYb=e.$EYb=void 0,e.$EYb=(0,y.$Qh)("externalTerminal"),e.$FYb="Terminal.app"}),define(De[233],Ce([1,0,49,18,15,12,97,29,101,194,232]),function(re,e,y,M,l,L,A,g,k,$,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$B7b=e.$A7b=e.$z7b=void 0;const P=$.localize(0,null);class p{async getDefaultTerminalForPlatforms(){return{windows:S.getDefaultTerminalWindows(),linux:await E.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class S extends p{openTerminal(f,a){return this.spawnTerminal(y,f,k.$Dl(),a)}spawnTerminal(f,a,t,i){const s=a.windowsExec||S.getDefaultTerminalWindows();i&&i[1]===":"&&(i=i[0].toUpperCase()+i.substr(1));const n=l.$nc(s,".exe").toLowerCase();if(n==="cmder")return f.spawn(s,i?[i]:void 0),Promise.resolve(void 0);const r=["/c","start","/wait"];return s.indexOf(" ")>=0&&r.push('""'),r.push(s),n==="wt"&&r.push("-d ."),new Promise((o,v)=>{const C=h(process),w=f.spawn(t,r,{cwd:i,env:C});w.on("error",v),w.on("exit",()=>o())})}runInTerminal(f,a,t,i,s){const n="windowsExec"in s&&s.windowsExec?s.windowsExec:S.getDefaultTerminalWindows();return new Promise((r,o)=>{const v=`"${a} - ${P}"`,C=`""${t.join('" "')}" & pause"`,w=Object.assign({},h(process),i);Object.keys(w).filter(O=>w[O]===null).forEach(O=>delete w[O]);const m={cwd:a,env:w,windowsVerbatimArguments:!0};let b,I;l.$nc(n,".exe")==="wt"?(b=n,I=["-d",".",S.b,"/c",C]):(b=S.b,I=["/c","start",v,"/wait",n,"/c",C]),y.spawn(b,I,m).on("error",O=>{o(u(O))}),r(void 0)})}static getDefaultTerminalWindows(){if(!S.d){const f=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");S.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${f?"Sysnative":"System32"}\\cmd.exe`}return S.d}}e.$z7b=S,S.b="cmd.exe";class D extends p{openTerminal(f,a){return this.spawnTerminal(y,f,a)}runInTerminal(f,a,t,i,s){const n=s.osxExec||R.$FYb;return new Promise((r,o)=>{if(n===R.$FYb||n==="iTerm.app"){const v=n===R.$FYb?"TerminalHelper":"iTermHelper",w=[M.$dg.asFileUri(`vs/workbench/contrib/externalTerminal/node/${v}.scpt`).fsPath,"-t",f||P,"-w",a];for(const I of t)w.push("-a"),w.push(I);if(i){const I=Object.assign({},h(process),i);for(const z in I){const O=I[z];O===null?(w.push("-u"),w.push(z)):(w.push("-e"),w.push(`${z}=${O}`))}}let m="";const b=y.spawn(D.b,w);b.on("error",I=>{o(u(I))}),b.stderr.on("data",I=>{m+=I.toString()}),b.on("exit",I=>{if(I===0)r(void 0);else if(m){const z=m.split(`
`,1);o(new Error(z[0]))}else o(new Error($.localize(1,null,v,I)))})}else o(new Error($.localize(2,null,n)))})}spawnTerminal(f,a,t){const i=a.osxExec||R.$FYb;return new Promise((s,n)=>{const r=["-a",i];t&&r.push(t);const o=h(process),v=f.spawn("/usr/bin/open",r,{cwd:t,env:o});v.on("error",n),v.on("exit",()=>s())})}}e.$A7b=D,D.b="/usr/bin/osascript";class E extends p{openTerminal(f,a){return this.spawnTerminal(y,f,a)}runInTerminal(f,a,t,i,s){const n=s.linuxExec?Promise.resolve(s.linuxExec):E.getDefaultTerminalLinuxReady();return new Promise((r,o)=>{const v=[];n.then(C=>{C.indexOf("gnome-terminal")>=0?v.push("-x"):v.push("-e"),v.push("bash"),v.push("-c");const w=`${d(t)}; echo; read -p "${E.b}" -n1;`;v.push(`''${w}''`);const m=Object.assign({},h(process),i);Object.keys(m).filter(O=>m[O]===null).forEach(O=>delete m[O]);const b={cwd:a,env:m};let I="";const z=y.spawn(C,v,b);z.on("error",O=>{o(u(O))}),z.stderr.on("data",O=>{I+=O.toString()}),z.on("exit",O=>{if(O===0)r(void 0);else if(I){const F=I.split(`
`,1);o(new Error(F[0]))}else o(new Error($.localize(4,null,C,O)))})})})}static async getDefaultTerminalLinuxReady(){if(!E.d)if(!L.$f)E.d=Promise.resolve("xterm");else{const f=await g.Promises.exists("/etc/debian_version");E.d=new Promise(a=>{f?a("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?a("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?a("konsole"):process.env.COLORTERM?a(process.env.COLORTERM):process.env.TERM?a(process.env.TERM):a("xterm")})}return E.d}spawnTerminal(f,a,t){const i=a.linuxExec?Promise.resolve(a.linuxExec):E.getDefaultTerminalLinuxReady();return new Promise((s,n)=>{i.then(r=>{const o=h(process),v=f.spawn(r,[],{cwd:t,env:o});v.on("error",n),v.on("exit",()=>s())})})}}e.$B7b=E,E.b=$.localize(3,null);function h(c){const f={...c.env};return(0,A.$Bl)(f),f}function u(c){return"errno"in c&&c.errno==="ENOENT"&&"path"in c&&typeof c.path=="string"?new Error($.localize(5,null,c.path)):c}function d(c){let f="";for(const a of c)a.indexOf(" ")>=0?f+='"'+a+'"':f+=a,f+=" ";return f}}),define(De[30],Ce([1,0,78,15,16,17,2,195,5,12,18,47]),function(re,e,y,M,l,L,A,g,k,$,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ik=e.$Hk=e.$Gk=e.$Fk=e.$Ek=e.FileKind=e.$Dk=e.$Ck=e.$Bk=e.$Ak=e.$zk=e.$yk=e.$xk=e.FileOperationResult=e.$wk=e.$vk=e.$uk=e.$tk=e.$sk=e.FileChangeType=e.$rk=e.FileOperation=e.$qk=e.$pk=e.$ok=e.$nk=e.$mk=e.$lk=e.FileSystemProviderErrorCode=e.$kk=e.$jk=e.$ik=e.$hk=e.$gk=e.$fk=e.$ek=e.$dk=e.$ck=e.FileSystemProviderCapabilities=e.$bk=e.FilePermission=e.FileType=e.$ak=e.$_j=void 0,e.$_j=(0,k.$Qh)("fileService");function p(_){return _.create===!0}e.$ak=p;var S;(function(_){_[_.Unknown=0]="Unknown",_[_.File=1]="File",_[_.Directory=2]="Directory",_[_.SymbolicLink=64]="SymbolicLink"})(S||(e.FileType=S={}));var D;(function(_){_[_.Readonly=1]="Readonly",_[_.Locked=2]="Locked"})(D||(e.FilePermission=D={}));function E(_){const oe=_;return!!oe&&typeof oe.onDidChange=="function"}e.$bk=E;var h;(function(_){_[_.None=0]="None",_[_.FileReadWrite=2]="FileReadWrite",_[_.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",_[_.FileReadStream=16]="FileReadStream",_[_.FileFolderCopy=8]="FileFolderCopy",_[_.PathCaseSensitive=1024]="PathCaseSensitive",_[_.Readonly=2048]="Readonly",_[_.Trash=4096]="Trash",_[_.FileWriteUnlock=8192]="FileWriteUnlock",_[_.FileAtomicRead=16384]="FileAtomicRead",_[_.FileAtomicWrite=32768]="FileAtomicWrite",_[_.FileAtomicDelete=65536]="FileAtomicDelete",_[_.FileClone=131072]="FileClone"})(h||(e.FileSystemProviderCapabilities=h={}));function u(_){return!!(_.capabilities&2)}e.$ck=u;function d(_){return!!(_.capabilities&8)}e.$dk=d;function c(_){return!!(_.capabilities&131072)}e.$ek=c;function f(_){return!!(_.capabilities&4)}e.$fk=f;function a(_){return!!(_.capabilities&16)}e.$gk=a;function t(_){return u(_)?!!(_.capabilities&16384):!1}e.$hk=t;function i(_){return u(_)?!!(_.capabilities&32768):!1}e.$ik=i;function s(_){return!!(_.capabilities&65536)}e.$jk=s;function n(_){return!!(_.capabilities&2048)}e.$kk=n;var r;(function(_){_.FileExists="EntryExists",_.FileNotFound="EntryNotFound",_.FileNotADirectory="EntryNotADirectory",_.FileIsADirectory="EntryIsADirectory",_.FileExceedsStorageQuota="EntryExceedsStorageQuota",_.FileTooLarge="EntryTooLarge",_.FileWriteLocked="EntryWriteLocked",_.NoPermissions="NoPermissions",_.Unavailable="Unavailable",_.Unknown="Unknown"})(r||(e.FileSystemProviderErrorCode=r={}));class o extends Error{static create(oe,ye){const fe=new o(oe.toString(),ye);return w(fe,ye),fe}constructor(oe,ye){super(oe),this.code=ye}}e.$lk=o;function v(_,oe){return o.create(_,oe)}e.$mk=v;function C(_){return _||v((0,g.localize)(0,null),r.Unknown)}e.$nk=C;function w(_,oe){return _.name=oe?`${oe} (FileSystemError)`:"FileSystemError",_}e.$ok=w;function m(_){if(!_)return r.Unknown;if(_ instanceof o)return _.code;const oe=/^(.+) \(FileSystemError\)$/.exec(_.name);if(!oe)return r.Unknown;switch(oe[1]){case r.FileExists:return r.FileExists;case r.FileIsADirectory:return r.FileIsADirectory;case r.FileNotADirectory:return r.FileNotADirectory;case r.FileNotFound:return r.FileNotFound;case r.FileTooLarge:return r.FileTooLarge;case r.FileWriteLocked:return r.FileWriteLocked;case r.NoPermissions:return r.NoPermissions;case r.Unavailable:return r.Unavailable}return r.Unknown}e.$pk=m;function b(_){if(_ instanceof N)return _.fileOperationResult;switch(m(_)){case r.FileNotFound:return 1;case r.FileIsADirectory:return 0;case r.FileNotADirectory:return 9;case r.FileWriteLocked:return 5;case r.NoPermissions:return 6;case r.FileExists:return 4;case r.FileTooLarge:return 7;default:return 10}}e.$qk=b;var I;(function(_){_[_.CREATE=0]="CREATE",_[_.DELETE=1]="DELETE",_[_.MOVE=2]="MOVE",_[_.COPY=3]="COPY",_[_.WRITE=4]="WRITE"})(I||(e.FileOperation=I={}));class z{constructor(oe,ye,fe){this.resource=oe,this.operation=ye,this.target=fe}isOperation(oe){return this.operation===oe}}e.$rk=z;var O;(function(_){_[_.UPDATED=0]="UPDATED",_[_.ADDED=1]="ADDED",_[_.DELETED=2]="DELETED"})(O||(e.FileChangeType=O={}));class F{constructor(oe,ye){this.c=ye,this.b=void 0,this.d=new P.$V(()=>{const fe=y.$Wh.forUris(()=>this.c);return fe.fill(this.rawAdded.map(V=>[V,!0])),fe}),this.f=new P.$V(()=>{const fe=y.$Wh.forUris(()=>this.c);return fe.fill(this.rawUpdated.map(V=>[V,!0])),fe}),this.g=new P.$V(()=>{const fe=y.$Wh.forUris(()=>this.c);return fe.fill(this.rawDeleted.map(V=>[V,!0])),fe}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const fe of oe){switch(fe.type){case 1:this.rawAdded.push(fe.resource);break;case 0:this.rawUpdated.push(fe.resource);break;case 2:this.rawDeleted.push(fe.resource);break}this.b!==F.a&&(typeof fe.cId=="number"?this.b===void 0?this.b=fe.cId:this.b!==fe.cId&&(this.b=F.a):this.b!==void 0&&(this.b=F.a))}}contains(oe,...ye){return this.h(oe,{includeChildren:!1},...ye)}affects(oe,...ye){return this.h(oe,{includeChildren:!0},...ye)}h(oe,ye,...fe){if(!oe)return!1;const V=fe.length>0;return!!((!V||fe.includes(1))&&(this.d.value.get(oe)||ye.includeChildren&&this.d.value.findSuperstr(oe))||(!V||fe.includes(0))&&(this.f.value.get(oe)||ye.includeChildren&&this.f.value.findSuperstr(oe))||(!V||fe.includes(2))&&(this.g.value.findSubstr(oe)||ye.includeChildren&&this.g.value.findSuperstr(oe)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(oe){return this.b===oe}hasCorrelation(){return typeof this.b=="number"}}e.$sk=F,F.a=null;function T(_,oe,ye){return!_||!oe||_===oe||oe.length>_.length?!1:(oe.charAt(oe.length-1)!==M.sep&&(oe+=M.sep),ye?(0,l.$4e)(_,oe):_.indexOf(oe)===0)}e.$tk=T;class N extends Error{constructor(oe,ye,fe){super(oe),this.fileOperationResult=ye,this.options=fe}}e.$uk=N;class j extends N{constructor(oe,ye,fe,V){super(oe,ye,V),this.fileOperationResult=ye,this.size=fe}}e.$vk=j;class U extends N{constructor(oe,ye,fe){super(oe,2,fe),this.stat=ye}}e.$wk=U;var B;(function(_){_[_.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",_[_.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",_[_.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",_[_.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",_[_.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",_[_.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",_[_.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",_[_.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",_[_.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",_[_.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",_[_.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(B||(e.FileOperationResult=B={})),e.$xk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$yk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$zk="files.associations",e.$Ak="files.exclude",e.$Bk="files.readonlyInclude",e.$Ck="files.readonlyExclude",e.$Dk="files.readonlyFromPermissions";var he;(function(_){_[_.FILE=0]="FILE",_[_.FOLDER=1]="FOLDER",_[_.ROOT_FOLDER=2]="ROOT_FOLDER"})(he||(e.FileKind=he={})),e.$Ek="";function x(_){if(!(typeof _.size!="number"||typeof _.mtime!="number"))return _.mtime.toString(29)+_.size.toString(31)}e.$Fk=x;async function Q(_,oe){if(!oe.hasProvider(A.URI.from({scheme:_.scheme})))return new Promise(ye=>{const fe=oe.onDidChangeFileSystemProviderRegistrations(V=>{V.scheme===_.scheme&&V.added&&(fe.dispose(),ye())})})}e.$Gk=Q;class Z{static formatSize(oe){return(0,L.$Df)(oe)||(oe=0),oe<Z.KB?(0,g.localize)(1,null,oe.toFixed(0)):oe<Z.MB?(0,g.localize)(2,null,(oe/Z.KB).toFixed(2)):oe<Z.GB?(0,g.localize)(3,null,(oe/Z.MB).toFixed(2)):oe<Z.TB?(0,g.localize)(4,null,(oe/Z.GB).toFixed(2)):(0,g.localize)(5,null,(oe/Z.TB).toFixed(2))}}e.$Hk=Z,Z.KB=1024,Z.MB=Z.KB*Z.KB,Z.GB=Z.MB*Z.KB,Z.TB=Z.GB*Z.KB;function ie(_){const oe=typeof _=="string"||_?.scheme===R.Schemas.vscodeRemote;return typeof _!="string"&&_?.scheme===R.Schemas.file?1024*Z.MB:oe?10*Z.MB:$.$j?50*Z.MB:1024*Z.MB}e.$Ik=ie}),define(De[234],Ce([1,0,22,9,196,30]),function(re,e,y,M,l,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rp=void 0;async function A(R,P,p,S,D,E){let h;try{await g(R,P,p,S,D,E)}catch(u){h=u}finally{h&&D.errorTransformer&&(h=D.errorTransformer(h)),typeof h<"u"&&p.error(h),p.end()}}e.$Rp=A;async function g(R,P,p,S,D,E){k(E);const h=await R.open(P,{create:!1});try{k(E);let u=0,d=0,c=D&&typeof D.length=="number"?D.length:void 0,f=y.$ce.alloc(Math.min(D.bufferSize,typeof c=="number"?c:D.bufferSize)),a=D&&typeof D.position=="number"?D.position:0,t=0;do d=await R.read(h,a,f.buffer,t,f.byteLength-t),a+=d,t+=d,u+=d,typeof c=="number"&&(c-=d),t===f.byteLength&&(await p.write(S(f)),f=y.$ce.alloc(Math.min(D.bufferSize,typeof c=="number"?c:D.bufferSize)),t=0);while(d>0&&(typeof c!="number"||c>0)&&k(E)&&$(u,D));if(t>0){let i=t;typeof c=="number"&&(i=Math.min(t,c)),p.write(S(f.slice(0,i)))}}catch(u){throw(0,L.$nk)(u)}finally{await R.close(h)}}function k(R){if(R.isCancellationRequested)throw(0,M.$6)();return!0}function $(R,P){if(typeof P?.limits?.size=="number"&&R>P.limits.size)throw(0,L.$mk)((0,l.localize)(0,null),L.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(De[84],Ce([1,0,36,3,15,12,2,30]),function(re,e,y,M,l,L,A,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1p=e.$Zp=e.$Yp=e.$Xp=e.$Wp=e.$Vp=e.$Up=e.$Tp=void 0;function k(u){return u.recursive===!0}e.$Tp=k;class $ extends M.$Sc{constructor(d,c,f,a){super(),this.h=d,this.j=c,this.m=f,this.n=a,this.c=this.B(new M.$Tc),this.f=void 0,this.g=0}s(){const d=new M.$Rc;this.c.value=d,this.b=this.r(d),this.b.setVerboseLogging(this.m),d.add(this.b.onDidChangeFile(c=>this.h(c))),d.add(this.b.onDidLogMessage(c=>this.j(c))),d.add(this.b.onDidError(c=>this.t(c)))}t(d){this.n.restartOnError?this.g<$.a&&this.f?(this.w(`restarting watcher after error: ${d}`),this.u(this.f)):this.w(`gave up attempting to restart watcher after error: ${d}`):this.w(d)}u(d){this.g++,this.s(),this.watch(d)}async watch(d){this.f=d,await this.b?.watch(d)}async setVerboseLogging(d){this.m=d,await this.b?.setVerboseLogging(d)}w(d){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${d}`})}y(d){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${d}`})}dispose(){return this.b=void 0,super.dispose()}}e.$Up=$,$.a=5;class R extends ${constructor(d,c,f){super(d,c,f,{type:"node.js",restartOnError:!1})}}e.$Vp=R;class P extends ${constructor(d,c,f){super(d,c,f,{type:"universal",restartOnError:!0})}}e.$Wp=P;function p(u){return u.map(d=>({type:d.type,resource:A.URI.revive(d.resource),cId:d.cId}))}e.$Xp=p;function S(u){const d=new h;for(const c of u)d.processEvent(c);return d.coalesce()}e.$Yp=S;function D(u,d){return typeof d=="string"&&!d.startsWith(y.$tj)&&!(0,l.$ic)(d)?{base:u,pattern:d}:d}e.$Zp=D;function E(u,d){const c=[];for(const f of d)c.push((0,y.$xj)(D(u,f)));return c}e.$1p=E;class h{constructor(){this.a=new Set,this.b=new Map}c(d){return L.$f?d.resource.fsPath:d.resource.fsPath.toLowerCase()}processEvent(d){const c=this.b.get(this.c(d));let f=!1;if(c){const a=c.type,t=d.type;c.resource.fsPath!==d.resource.fsPath&&(d.type===2||d.type===1)?f=!0:a===1&&t===2?(this.b.delete(this.c(d)),this.a.delete(c)):a===2&&t===1?c.type=0:a===1&&t===0||(c.type=t)}else f=!0;f&&(this.a.add(d),this.b.set(this.c(d),d))}coalesce(){const d=[],c=[];return Array.from(this.a).filter(f=>f.type!==2?(d.push(f),!1):!0).sort((f,a)=>f.resource.fsPath.length-a.resource.fsPath.length).filter(f=>c.some(a=>(0,g.$tk)(f.resource.fsPath,a,!L.$f))?!1:(c.push(f.resource.fsPath),!0)).concat(d)}}}),define(De[235],Ce([1,0,53,8,21,32,3,77,15,12,23,2,100,29,84]),function(re,e,y,M,l,L,A,g,k,$,R,P,p,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cq=e.$bq=void 0;class E extends A.$Sc{constructor(d,c,f,a){super(),this.m=d,this.n=c,this.r=f,this.s=a,this.c=this.B(new M.$0g({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},t=>this.n(t))),this.f=this.B(new M.$9g(t=>this.z(t),E.b)),this.g=(0,D.$1p)(this.m.path,this.m.excludes),this.h=this.m.includes?(0,D.$1p)(this.m.path,this.m.includes):void 0,this.j=new l.$Yd,this.ready=this.t()}async t(){try{const d=await this.u(this.m);if(this.j.token.isCancellationRequested)return;const c=await S.Promises.stat(d);this.B(await this.w(d,c.isDirectory()))}catch(d){d.code!=="ENOENT"?this.D(d):this.G(d)}}async u(d){let c=d.path;try{c=await S.Promises.realpath(d.path),d.path===c&&(c=await(0,p.$$p)(d.path)??d.path),d.path!==c&&this.G(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${d.path}, real: ${c})`)}catch{}return c}async w(d,c){if($.$e&&(0,L.$Yf)(d,"/Volumes/",!0))return this.D(`Refusing to watch ${d} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),A.$Sc.None;const f=new l.$Yd(this.j.token),a=new A.$Rc;try{const t=P.URI.file(this.m.path),i=(0,k.$nc)(d),s=(0,y.watch)(d);a.add((0,A.$Qc)(()=>{s.removeAllListeners(),s.close()})),this.G(`Started watching: '${d}'`);const n=new Set;if(c)try{for(const o of await S.Promises.readdir(d))n.add(o)}catch(o){this.D(o)}const r=new Map;a.add((0,A.$Qc)(()=>{for(const[,o]of r)o.dispose();r.clear()})),s.on("error",(o,v)=>{this.D(`Failed to watch ${d} for changes using fs.watch() (${o}, ${v})`),this.dispose()}),s.on("change",(o,v)=>{if(f.token.isCancellationRequested)return;this.G(`[raw] ["${o}"] ${v}`);let C="";if(v&&(C=v.toString(),$.$e&&(C=(0,g.$ql)(C))),!(!C||o!=="change"&&o!=="rename"))if(c)if(o==="rename"){r.get(C)?.dispose();const w=setTimeout(async()=>{if(r.delete(C),C===i&&!await S.Promises.exists(d)){this.F("Watcher shutdown because watched path got deleted"),this.dispose();return}const m=await this.C((0,k.$jc)(d,C));if(f.token.isCancellationRequested)return;let b;m?n.has(C)?b=0:(b=1,n.add(C)):(n.delete(C),b=2),this.y({resource:(0,R.$wg)(t,C),type:b,cId:this.m.correlationId})},E.a);r.set(C,(0,A.$Qc)(()=>clearTimeout(w)))}else{let w;n.has(C)?w=0:(w=1,n.add(C)),this.y({resource:(0,R.$wg)(t,C),type:w,cId:this.m.correlationId})}else if(o==="rename"||C!==i){const w=setTimeout(async()=>{const m=await S.Promises.exists(d);f.token.isCancellationRequested||(m?(this.y({resource:t,type:0,cId:this.m.correlationId},!0),a.add(await this.w(d,!1))):(this.y({resource:t,type:2,cId:this.m.correlationId},!0),this.f.flush(),this.dispose()))},E.a);a.clear(),a.add((0,A.$Qc)(()=>clearTimeout(w)))}else this.y({resource:t,type:0,cId:this.m.correlationId},!0)})}catch(t){await S.Promises.exists(d)&&!f.token.isCancellationRequested&&this.D(`Failed to watch ${d} for changes using fs.watch() (${t.toString()})`)}return(0,A.$Qc)(()=>{f.dispose(!0),a.dispose()})}y(d,c=!1){this.j.token.isCancellationRequested||(this.s&&this.G(`${d.type===1?"[ADDED]":d.type===2?"[DELETED]":"[CHANGED]"} ${d.resource.fsPath}`),!c&&this.g.some(f=>f(d.resource.fsPath))?this.s&&this.G(` >> ignored (excluded) ${d.resource.fsPath}`):!c&&this.h&&this.h.length>0&&!this.h.some(f=>f(d.resource.fsPath))?this.s&&this.G(` >> ignored (not included) ${d.resource.fsPath}`):this.f.work(d))}z(d){const c=(0,D.$Yp)(d);if(c.length>0){if(this.s)for(const a of c)this.G(` >> normalized ${a.type===1?"[ADDED]":a.type===2?"[DELETED]":"[CHANGED]"} ${a.resource.fsPath}`);this.c.work(c)?this.c.pending>0&&this.G(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${c[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.F(`started ignoring events due to too many file change events at once (incoming: ${c.length}, most recent change: ${c[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async C(d){if($.$f)return S.Promises.exists(d);try{const c=(0,k.$nc)(d);return(await S.Promises.readdir((0,k.$mc)(d))).some(a=>a===c)}catch(c){return this.G(c),!1}}setVerboseLogging(d){this.s=d}D(d){this.j.token.isCancellationRequested||this.r?.({type:"error",message:`[File Watcher (node.js)] ${d}`})}F(d){this.j.token.isCancellationRequested||this.r?.({type:"warn",message:`[File Watcher (node.js)] ${d}`})}G(d){!this.j.token.isCancellationRequested&&this.s&&this.r?.({type:"trace",message:`[File Watcher (node.js)] ${d}`})}dispose(){this.G(`stopping file watcher on ${this.m.path}`),this.j.dispose(!0),super.dispose()}}e.$bq=E,E.a=100,E.b=75;async function h(u,d,c,f,a=512){const t=await S.Promises.open(u,"r"),i=Buffer.allocUnsafe(a),s=new l.$Yd(f);let n,r=!1;const o={path:u,excludes:[],recursive:!1},v=new E(o,C=>{(async()=>{for(const{type:w}of C)if(w===0){if(r)return;r=!0;try{for(;!s.token.isCancellationRequested;){const{bytesRead:m}=await S.Promises.read(t,i,0,a,null);if(!m||s.token.isCancellationRequested)break;d(i.slice(0,m))}}catch(m){n=new Error(m),s.dispose(!0)}finally{r=!1}}})()});return await v.ready,c(),new Promise((C,w)=>{s.token.onCancellationRequested(async()=>{v.dispose();try{await S.Promises.close(t)}catch(m){n=new Error(m)}n?w(n):C()})})}e.$cq=h}),define(De[236],Ce([1,0,4,36,3,12,235]),function(re,e,y,M,l,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dq=void 0;class g extends l.$Sc{constructor(){super(...arguments),this.a=this.B(new y.$Od),this.onDidChangeFile=this.a.event,this.b=this.B(new y.$Od),this.onDidLogMessage=this.b.event,this.onDidError=y.Event.None,this.c=new Map,this.f=!1}async watch($){const R=this.j($),P=R.filter(S=>{const D=this.c.get(S.path);return D?!(0,M.$Bj)(D.request.excludes,S.excludes)||!(0,M.$Bj)(D.request.includes,S.includes):!0}),p=Array.from(this.c.values()).filter(({request:S})=>!R.find(D=>D.path===S.path&&(0,M.$Bj)(D.excludes,S.excludes)&&(0,M.$Bj)(D.includes,S.includes))).map(({request:S})=>S.path);P.length&&this.m(`Request to start watching: ${P.map(S=>`${S.path} (excludes: ${S.excludes.length>0?S.excludes:"<none>"}, includes: ${S.includes&&S.includes.length>0?JSON.stringify(S.includes):"<all>"}, correlationId: ${typeof S.correlationId=="number"?S.correlationId:"<none>"})`).join(",")}`),p.length&&this.m(`Request to stop watching: ${p.join(",")}`);for(const S of p)this.h(S);for(const S of P)this.g(S)}g($){const R=new A.$bq($,p=>this.a.fire(p),p=>this.b.fire(p),this.f),P={request:$,instance:R};this.c.set($.path,P)}async stop(){for(const[$]of this.c)this.h($);this.c.clear()}h($){const R=this.c.get($);R&&(this.c.delete($),R.instance.dispose())}j($){const R=new Map;for(const P of $){const p=L.$f?P.path:P.path.toLowerCase();let S=R.get(P.correlationId);S||(S=new Map,R.set(P.correlationId,S)),S.set(p,P)}return Array.from(R.values()).map(P=>Array.from(P.values())).flat()}async setVerboseLogging($){this.f=$;for(const[,R]of this.c)R.instance.setVerboseLogging($)}m($){this.f&&this.b.fire({type:"trace",message:this.n($)})}n($,R){return R?`[File Watcher (node.js)] ${$} (path: ${R.request.path})`:`[File Watcher (node.js)] ${$}`}}e.$dq=g}),define(De[237],Ce([1,0,84,236]),function(re,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eq=void 0;class l extends y.$Vp{constructor(A,g,k){super(A,g,k),this.s()}r(A){return A.add(new M.$dq)}}e.$eq=l}),define(De[238],Ce([1,0,18,81,167,84]),function(re,e,y,M,l,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9p=void 0;class A extends L.$Wp{constructor(k,$,R){super(k,$,R),this.s()}r(k){const $=k.add(new l.$8p(y.$dg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return k.add($.onDidProcessExit(({code:R,signal:P})=>this.t(`terminated by itself with code ${R}, signal: ${P}`))),M.ProxyChannel.toService((0,M.$xh)($.getChannel("watcher")))}}e.$9p=A}),define(De[104],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oh=void 0;class y{constructor(...l){this.a=new Map;for(const[L,A]of l)this.set(L,A)}set(l,L){const A=this.a.get(l);return this.a.set(l,L),A}has(l){return this.a.has(l)}get(l){return this.a.get(l)}}e.$Oh=y}),define(De[239],Ce([1,0,8,9,3,102,230,5,104,76]),function(re,e,y,M,l,L,A,g,k,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jq=e.$iq=void 0;const R=!1;class P extends Error{constructor(h){super("cyclic dependency between services"),this.message=h.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${h.toString()}`}}class p{constructor(h=new k.$Oh,u=!1,d,c=R){this.f=h,this.g=u,this.h=d,this.i=c,this.o=new Set,this.f.set(g.$Ph,this),this._globalGraph=c?d?._globalGraph??new A.$hq(f=>f):void 0}createChild(h){return new p(h,this.g,this,this.i)}invokeFunction(h,...u){const d=D.traceInvocation(this.i,h);let c=!1;try{return h({get:a=>{if(c)throw(0,M.$8)("service accessor is only valid during the invocation of its target method");const t=this.m(a,d);if(!t)throw new Error(`[invokeFunction] unknown service '${a}'`);return t}},...u)}finally{c=!0,d.stop()}}createInstance(h,...u){let d,c;return h instanceof L.$Nh?(d=D.traceCreation(this.i,h.ctor),c=this.j(h.ctor,h.staticArguments.concat(u),d)):(d=D.traceCreation(this.i,h),c=this.j(h,u,d)),d.stop(),c}j(h,u=[],d){const c=g._util.getServiceDependencies(h).sort((t,i)=>t.index-i.index),f=[];for(const t of c){const i=this.m(t.id,d);i||this.u(`[createInstance] ${h.name} depends on UNKNOWN service ${t.id}.`,!1),f.push(i)}const a=c.length>0?c[0].index:u.length;if(u.length!==a){console.trace(`[createInstance] First service dependency of ${h.name} at position ${a+1} conflicts with ${u.length} static arguments`);const t=a-u.length;t>0?u=u.concat(new Array(t)):u=u.slice(0,a)}return Reflect.construct(h,u.concat(f))}k(h,u){if(this.f.get(h)instanceof L.$Nh)this.f.set(h,u);else if(this.h)this.h.k(h,u);else throw new Error("illegalState - setting UNKNOWN service instance")}l(h){const u=this.f.get(h);return!u&&this.h?this.h.l(h):u}m(h,u){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(h));const d=this.l(h);return d instanceof L.$Nh?this.q(h,d,u.branch(h,!0)):(u.branch(h,!1),d)}q(h,u,d){if(this.o.has(h))throw new Error(`illegal state - RECURSIVELY instantiating service '${h}'`);this.o.add(h);try{return this.r(h,u,d)}finally{this.o.delete(h)}}r(h,u,d){const c=new A.$hq(t=>t.id.toString());let f=0;const a=[{id:h,desc:u,_trace:d}];for(;a.length;){const t=a.pop();if(c.lookupOrInsertNode(t),f++>1e3)throw new P(c);for(const i of g._util.getServiceDependencies(t.desc.ctor)){const s=this.l(i.id);if(s||this.u(`[createInstance] ${h} depends on ${i.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(i.id)),s instanceof L.$Nh){const n={id:i.id,desc:s,_trace:t._trace.branch(i.id,!0)};c.insertEdge(t,n),a.push(n)}}}for(;;){const t=c.roots();if(t.length===0){if(!c.isEmpty())throw new P(c);break}for(const{data:i}of t){if(this.l(i.id)instanceof L.$Nh){const n=this.s(i.id,i.desc.ctor,i.desc.staticArguments,i.desc.supportsDelayedInstantiation,i._trace);this.k(i.id,n)}c.removeNode(i)}}return this.l(h)}s(h,u,d=[],c,f){if(this.f.get(h)instanceof L.$Nh)return this.t(h,u,d,c,f);if(this.h)return this.h.s(h,u,d,c,f);throw new Error(`illegalState - creating UNKNOWN service instance ${u.name}`)}t(h,u,d=[],c,f){if(c){const a=new p(void 0,this.g,this,this.i);a.c=String(h);const t=new Map,i=new y.$_g(()=>{const s=a.j(u,d,f);for(const[n,r]of t){const o=s[n];if(typeof o=="function")for(const v of r)o.apply(s,v)}return t.clear(),s});return new Proxy(Object.create(null),{get(s,n){if(!i.isInitialized&&typeof n=="string"&&(n.startsWith("onDid")||n.startsWith("onWill"))){let v=t.get(n);return v||(v=new $.$2c,t.set(n,v)),(w,m,b)=>{const I=v.push([w,m,b]);return(0,l.$Qc)(I)}}if(n in s)return s[n];const r=i.value;let o=r[n];return typeof o!="function"||(o=o.bind(r),s[n]=o),o},set(s,n,r){return i.value[n]=r,!0},getPrototypeOf(s){return u.prototype}})}else return this.j(u,d,f)}u(h,u){if(u&&console.warn(h),this.g)throw new Error(h)}}e.$iq=p;var S;(function(E){E[E.None=0]="None",E[E.Creation=1]="Creation",E[E.Invocation=2]="Invocation",E[E.Branch=3]="Branch"})(S||(S={}));class D{static traceInvocation(h,u){return h?new D(2,u.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):D.c}static traceCreation(h,u){return h?new D(1,u.name):D.c}constructor(h,u){this.type=h,this.name=u,this.g=Date.now(),this.h=[]}branch(h,u){const d=new D(3,h.toString());return this.h.push([h,u,d]),d}stop(){const h=Date.now()-this.g;D.f+=h;let u=!1;function d(f,a){const t=[],i=new Array(f+1).join("	");for(const[s,n,r]of a.h)if(n&&r){u=!0,t.push(`${i}CREATES -> ${s}`);const o=d(f+1,r);o&&t.push(o)}else t.push(`${i}uses -> ${s}`);return t.join(`
`)}const c=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${d(1,this)}`,`DONE, took ${h.toFixed(2)}ms (grand total ${D.f.toFixed(2)}ms)`];(h>2||u)&&D.all.add(c.join(`
`))}}e.$jq=D,D.all=new Set,D.c=new class extends D{constructor(){super(0,null)}stop(){}branch(){return this}},D.f=0}),define(De[14],Ce([1,0,41,4,52,3,28,12,23,17,2,42,5]),function(re,e,y,M,l,L,A,g,k,$,R,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pj=e.$oj=e.$nj=e.$mj=e.$lj=e.$kj=e.$jj=e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.log=e.$bj=e.LogLevel=e.$aj=e.$_i=e.$$i=void 0,e.$$i=(0,p.$Qh)("logService"),e.$_i=(0,p.$Qh)("loggerService");function S(){return new Date().toISOString()}function D(w){return(0,$.$Df)(w)}e.$aj=D;var E;(function(w){w[w.Off=0]="Off",w[w.Trace=1]="Trace",w[w.Debug=2]="Debug",w[w.Info=3]="Info",w[w.Warning=4]="Warning",w[w.Error=5]="Error"})(E||(e.LogLevel=E={})),e.$bj=E.Info;function h(w,m,b){switch(m){case E.Trace:w.trace(b);break;case E.Debug:w.debug(b);break;case E.Info:w.info(b);break;case E.Warning:w.warn(b);break;case E.Error:w.error(b);break;case E.Off:break;default:throw new Error(`Invalid log level ${m}`)}}e.log=h;function u(w,m=!1){let b="";for(let I=0;I<w.length;I++){let z=w[I];if(z instanceof Error&&(z=(0,y.$Bi)(z,m)),typeof z=="object")try{z=JSON.stringify(z)}catch{}b+=(I>0?" ":"")+z}return b}class d extends L.$Sc{constructor(){super(...arguments),this.b=e.$bj,this.c=this.B(new M.$Od),this.onDidChangeLogLevel=this.c.event}setLevel(m){this.b!==m&&(this.b=m,this.c.fire(this.b))}getLevel(){return this.b}f(m){return this.b!==E.Off&&this.b<=m}}e.$dj=d;class c extends d{constructor(m){super(),this.h=m}f(m){return this.h||super.f(m)}trace(m,...b){this.f(E.Trace)&&this.g(E.Trace,u([m,...b],!0))}debug(m,...b){this.f(E.Debug)&&this.g(E.Debug,u([m,...b]))}info(m,...b){this.f(E.Info)&&this.g(E.Info,u([m,...b]))}warn(m,...b){this.f(E.Warning)&&this.g(E.Warning,u([m,...b]))}error(m,...b){if(this.f(E.Error))if(m instanceof Error){const I=Array.prototype.slice.call(arguments);I[0]=m.stack,this.g(E.Error,u(I))}else this.g(E.Error,u([m,...b]))}flush(){}}e.$ej=c;class f extends d{constructor(m=e.$bj){super(),this.setLevel(m),this.g=!g.$d}trace(m,...b){this.f(E.Trace)&&(this.g?console.log(`\x1B[90m[main ${S()}]\x1B[0m`,m,...b):console.log(`[main ${S()}]`,m,...b))}debug(m,...b){this.f(E.Debug)&&(this.g?console.log(`\x1B[90m[main ${S()}]\x1B[0m`,m,...b):console.log(`[main ${S()}]`,m,...b))}info(m,...b){this.f(E.Info)&&(this.g?console.log(`\x1B[90m[main ${S()}]\x1B[0m`,m,...b):console.log(`[main ${S()}]`,m,...b))}warn(m,...b){this.f(E.Warning)&&(this.g?console.warn(`\x1B[93m[main ${S()}]\x1B[0m`,m,...b):console.warn(`[main ${S()}]`,m,...b))}error(m,...b){this.f(E.Error)&&(this.g?console.error(`\x1B[91m[main ${S()}]\x1B[0m`,m,...b):console.error(`[main ${S()}]`,m,...b))}dispose(){}flush(){}}e.$fj=f;class a extends d{constructor(m=e.$bj,b=!0){super(),this.g=b,this.setLevel(m)}trace(m,...b){this.f(E.Trace)&&(this.g?console.log("%cTRACE","color: #888",m,...b):console.log(m,...b))}debug(m,...b){this.f(E.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",m,...b):console.log(m,...b))}info(m,...b){this.f(E.Info)&&(this.g?console.log("%c INFO","color: #33f",m,...b):console.log(m,...b))}warn(m,...b){this.f(E.Warning)&&(this.g?console.log("%c WARN","color: #993",m,...b):console.log(m,...b))}error(m,...b){this.f(E.Error)&&(this.g?console.log("%c  ERR","color: #f33",m,...b):console.error(m,...b))}dispose(){}flush(){}}e.$gj=a;class t extends d{constructor(m,b=e.$bj){super(),this.g=m,this.setLevel(b)}trace(m,...b){this.f(E.Trace)&&this.g.log(E.Trace,[this.h(m),...b])}debug(m,...b){this.f(E.Debug)&&this.g.log(E.Debug,[this.h(m),...b])}info(m,...b){this.f(E.Info)&&this.g.log(E.Info,[this.h(m),...b])}warn(m,...b){this.f(E.Warning)&&this.g.log(E.Warning,[this.h(m),...b])}error(m,...b){this.f(E.Error)&&this.g.log(E.Error,[this.h(m),...b])}h(m){return typeof m=="string"?m:(0,y.$Bi)(m,this.f(E.Trace))}dispose(){}flush(){}}e.$hj=t;class i extends d{constructor(m){super(),this.g=m,m.length&&this.setLevel(m[0].getLevel())}setLevel(m){for(const b of this.g)b.setLevel(m);super.setLevel(m)}trace(m,...b){for(const I of this.g)I.trace(m,...b)}debug(m,...b){for(const I of this.g)I.debug(m,...b)}info(m,...b){for(const I of this.g)I.info(m,...b)}warn(m,...b){for(const I of this.g)I.warn(m,...b)}error(m,...b){for(const I of this.g)I.error(m,...b)}flush(){for(const m of this.g)m.flush()}dispose(){for(const m of this.g)m.dispose()}}e.$ij=i;class s extends L.$Sc{constructor(m,b,I){if(super(),this.h=m,this.j=b,this.b=new A.$Ac,this.c=this.B(new M.$Od),this.onDidChangeLoggers=this.c.event,this.f=this.B(new M.$Od),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new M.$Od),this.onDidChangeVisibility=this.g.event,I)for(const z of I)this.b.set(z.resource,{logger:void 0,info:z})}m(m){return(0,$.$zf)(m)?[...this.b.values()].find(b=>b.info.id===m):this.b.get(m)}getLogger(m){return this.m(m)?.logger}createLogger(m,b){const I=this.n(m),z=(0,$.$zf)(m)?m:b?.id??(0,l.$Ei)(I.toString()).toString(16);let O=this.b.get(I)?.logger;const F=b?.logLevel==="always"?E.Trace:b?.logLevel;O||(O=this.s(I,F??this.getLogLevel(I)??this.h,{...b,id:z}));const T={logger:O,info:{resource:I,id:z,logLevel:F,name:b?.name,hidden:b?.hidden,extensionId:b?.extensionId,when:b?.when}};return this.registerLogger(T.info),this.b.set(I,T),O}n(m){return(0,$.$zf)(m)?(0,k.$wg)(this.j,`${m}.log`):m}setLogLevel(m,b){if(R.URI.isUri(m)){const I=m,z=b,O=this.b.get(I);O&&z!==O.info.logLevel&&(O.info.logLevel=z===this.h?void 0:z,O.logger?.setLevel(z),this.b.set(O.info.resource,O),this.f.fire([I,z]))}else{this.h=m;for(const[I,z]of this.b.entries())this.b.get(I)?.info.logLevel===void 0&&z.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(m,b){const I=this.m(m);I&&b!==!I.info.hidden&&(I.info.hidden=!b,this.b.set(I.info.resource,I),this.g.fire([I.info.resource,b]))}getLogLevel(m){let b;return m&&(b=this.b.get(m)?.info.logLevel),b??this.h}registerLogger(m){const b=this.b.get(m.resource);b?b.info.hidden!==m.hidden&&this.setVisibility(m.resource,!m.hidden):(this.b.set(m.resource,{info:m,logger:void 0}),this.c.fire({added:[m],removed:[]}))}deregisterLogger(m){const b=this.b.get(m);b&&(b.logger&&b.logger.dispose(),this.b.delete(m),this.c.fire({added:[],removed:[b.info]}))}*getRegisteredLoggers(){for(const m of this.b.values())yield m.info}getRegisteredLogger(m){return this.b.get(m)?.info}dispose(){this.b.forEach(m=>m.logger?.dispose()),this.b.clear(),super.dispose()}}e.$jj=s;class n{constructor(){this.onDidChangeLogLevel=new M.$Od().event}setLevel(m){}getLevel(){return E.Info}trace(m,...b){}debug(m,...b){}info(m,...b){}warn(m,...b){}error(m,...b){}critical(m,...b){}dispose(){}flush(){}}e.$kj=n;class r extends n{}e.$lj=r;function o(w){if(w.verbose)return E.Trace;if(typeof w.logLevel=="string"){const m=C(w.logLevel.toLowerCase());if(m!==void 0)return m}return e.$bj}e.$mj=o;function v(w){switch(w){case E.Trace:return"trace";case E.Debug:return"debug";case E.Info:return"info";case E.Warning:return"warn";case E.Error:return"error";case E.Off:return"off"}}e.$nj=v;function C(w){switch(w){case"trace":return E.Trace;case"debug":return E.Debug;case"info":return E.Info;case"warn":return E.Warning;case"error":return E.Error;case"critical":return E.Error;case"off":return E.Off}}e.$oj=C,e.$pj=new P.$8i("logLevel",v(E.Info))}),define(De[240],Ce([1,0,19,8,9,4,3,15,84,14]),function(re,e,y,M,l,L,A,g,k,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2p=void 0;class R extends A.$Sc{constructor(p,S){super(),this.a=p,this.b=S,this.c=this.B(new L.$Od),this.onDidChangeFile=this.c.event,this.g=this.B(new L.$Od),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new M.$Sg(0)),this.w=[],this.y=this.B(new M.$Sg(0))}watch(p,S){return S.recursive||this.b?.watcher?.forceUniversal?this.n(p,S):this.z(p,S)}n(p,S){const D={path:this.H(p),excludes:S.excludes,includes:S.includes,recursive:S.recursive,correlationId:S.correlationId},E=(0,y.$Ub)(this.j,D);return this.r(),(0,A.$Qc)(()=>{E(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(p=>(0,l.$1)(p))}s(){this.h||(this.h=this.B(this.t(S=>this.c.fire((0,k.$Xp)(S)),S=>this.G(S),this.a.getLevel()===$.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===$.LogLevel.Trace)})));const p=this.b?.watcher?.recursive?.usePolling;if(p===!0)for(const S of this.j)(0,k.$Tp)(S)&&(S.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(p))for(const S of this.j)(0,k.$Tp)(S)&&p.includes(S.path)&&(S.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(p,S){const D={path:this.H(p),excludes:S.excludes,includes:S.includes,recursive:!1,correlationId:S.correlationId},E=(0,y.$Ub)(this.w,D);return this.C(),(0,A.$Qc)(()=>{E(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(p=>(0,l.$1)(p))}D(){return this.u||(this.u=this.B(this.F(p=>this.c.fire((0,k.$Xp)(p)),p=>this.G(p),this.a.getLevel()===$.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===$.LogLevel.Trace)}))),this.u.watch(this.w)}G(p){p.type==="error"&&this.g.fire(p.message),this.a[p.type](p.message)}H(p){return(0,g.$hc)(p.fsPath)}}e.$2p=R}),define(De[241],Ce([1,0,53,375,8,28,22,4,32,3,15,12,23,98,29,197,30,234,240,41,238,237]),function(re,e,y,M,l,L,A,g,k,$,R,P,p,S,D,E,h,u,d,c,f,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fq=void 0,(()=>{try{(0,M.gracefulify)(y)}catch(i){console.error(`Error enabling graceful-fs: ${(0,c.$Bi)(i)}`)}})();class t extends d.$2p{constructor(s,n){super(s,n),this.onDidChangeCapabilities=g.Event.None,this.N=new L.$Ac(r=>p.$ng.getComparisonKey(r)),this.U=new Map,this.W=new Map,this.X=new Map}get capabilities(){return this.J||(this.J=253982,P.$f&&(this.J|=1024)),this.J}async stat(s){try{const{stat:n,symbolicLink:r}=await D.SymlinkSupport.stat(this.H(s));return{type:this.M(n,r),ctime:n.birthtime.getTime(),mtime:n.mtime.getTime(),size:n.size,permissions:n.mode&128?void 0:h.FilePermission.Locked}}catch(n){throw this.fb(n)}}async L(s){try{return await this.stat(s)}catch{return}}async readdir(s){try{const n=await D.Promises.readdir(this.H(s),{withFileTypes:!0}),r=[];return await Promise.all(n.map(async o=>{try{let v;o.isSymbolicLink()?v=(await this.stat((0,p.$wg)(s,o.name))).type:v=this.M(o),r.push([o.name,v])}catch(v){this.a.trace(v)}})),r}catch(n){throw this.fb(n)}}M(s,n){let r;return n?.dangling?r=h.FileType.Unknown:s.isFile()?r=h.FileType.File:s.isDirectory()?r=h.FileType.Directory:r=h.FileType.Unknown,n&&(r|=h.FileType.SymbolicLink),r}async O(s){const n=this.H(s);this.P(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${n})`);let r;for(;r=this.N.get(s);)this.P(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${n})`),await r.wait();const o=new l.$Tg;return this.N.set(s,o),this.P(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${n})`),(0,$.$Qc)(()=>{this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${n})`),this.N.get(s)===o&&(this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${n})`),this.N.delete(s)),this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${n})`),o.open()})}async readFile(s,n){let r;try{n?.atomic&&(this.P(`[Disk FileSystemProvider]: atomic read operation started (${this.H(s)})`),r=await this.O(s));const o=this.H(s);return await D.Promises.readFile(o)}catch(o){throw this.fb(o)}finally{r?.dispose()}}P(s){t.I&&this.a.trace(s)}readFileStream(s,n,r){const o=(0,S.$3d)(v=>A.$ce.concat(v.map(C=>A.$ce.wrap(C))).buffer);return(0,u.$Rp)(this,s,o,v=>v.buffer,{...n,bufferSize:256*1024},r),o}async writeFile(s,n,r){return r?.atomic!==!1&&r?.atomic?.postfix&&await this.Q(s)?this.R(s,(0,p.$wg)((0,p.$vg)(s),`${(0,p.$tg)(s)}${r.atomic.postfix}`),n,r):this.S(s,n,r)}async Q(s){try{const n=this.H(s),{symbolicLink:r}=await D.SymlinkSupport.stat(n);if(r)return!1}catch{}return!0}async R(s,n,r,o){const v=new $.$Rc;try{v.add(await this.O(s)),v.add(await this.O(n)),await this.S(n,r,o,!0);try{await this.rename(n,s,{overwrite:!0})}catch(C){try{await this.delete(n,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw C}}finally{v.dispose()}}async S(s,n,r,o){let v;try{const C=this.H(s);if(!r.create||!r.overwrite){if(await D.Promises.exists(C)){if(!r.overwrite)throw(0,h.$mk)((0,E.localize)(0,null),h.FileSystemProviderErrorCode.FileExists)}else if(!r.create)throw(0,h.$mk)((0,E.localize)(1,null),h.FileSystemProviderErrorCode.FileNotFound)}v=await this.open(s,{create:!0,unlock:r.unlock},o),await this.write(v,0,n,0,n.byteLength)}catch(C){throw await this.gb(s,C)}finally{typeof v=="number"&&await this.close(v)}}static configureFlushOnWrite(s){t.Y=s}async open(s,n,r){const o=this.H(s);let v;(0,h.$ak)(n)&&!r&&(v=await this.O(s));let C;try{if((0,h.$ak)(n)&&n.unlock)try{const{stat:m}=await D.SymlinkSupport.stat(o);m.mode&128||await D.Promises.chmod(o,m.mode|128)}catch(m){m.code!=="ENOENT"&&this.a.trace(m)}let w;if((0,h.$ak)(n)){if(P.$d)try{await D.Promises.truncate(o,0),w="r+"}catch(m){m.code!=="ENOENT"&&this.a.trace(m)}w||(w="w")}else w="r";C=await D.Promises.open(o,w)}catch(w){throw v?.dispose(),(0,h.$ak)(n)?await this.gb(s,w):this.fb(w)}if(this.U.set(C,0),(0,h.$ak)(n)&&this.X.set(C,s),v){const w=this.W.get(C);this.P(`[Disk FileSystemProvider]: open() - storing lock for handle ${C} (${o})`),this.W.set(C,v),w&&(this.P(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${C} (${o})`),w.dispose())}return C}async close(s){const n=this.W.get(s);try{if(this.U.delete(s),this.X.delete(s)&&t.Y)try{await D.Promises.fdatasync(s)}catch(r){t.configureFlushOnWrite(!1),this.a.error(r)}return await D.Promises.close(s)}catch(r){throw this.fb(r)}finally{n&&(this.W.get(s)===n&&(this.P(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${s}`),this.W.delete(s)),this.P(`[Disk FileSystemProvider]: close() - disposing lock for handle ${s}`),n.dispose())}}async read(s,n,r,o,v){const C=this.Z(s,n);let w=null;try{w=(await D.Promises.read(s,r,o,v,C)).bytesRead}catch(m){throw this.fb(m)}finally{this.$(s,C,w)}return w}Z(s,n){return n===this.U.get(s)?null:n}$(s,n,r){const o=this.U.get(s);typeof o=="number"&&(typeof n=="number"||(typeof r=="number"?this.U.set(s,o+r):this.U.delete(s)))}async write(s,n,r,o,v){return(0,l.$ah)(()=>this.ab(s,n,r,o,v),100,3)}async ab(s,n,r,o,v){const C=this.Z(s,n);let w=null;try{w=(await D.Promises.write(s,r,o,v,C)).bytesWritten}catch(m){throw await this.gb(this.X.get(s),m)}finally{this.$(s,C,w)}return w}async mkdir(s){try{await D.Promises.mkdir(this.H(s))}catch(n){throw this.fb(n)}}async delete(s,n){try{const r=this.H(s);if(n.recursive){let o;n?.atomic!==!1&&n.atomic.postfix&&(o=(0,R.$jc)((0,R.$mc)(r),`${(0,R.$nc)(r)}${n.atomic.postfix}`)),await D.Promises.rm(r,D.RimRafMode.MOVE,o)}else try{await D.Promises.unlink(r)}catch(o){if(o.code==="EPERM"||o.code==="EISDIR"){let v=!1;try{const{stat:C,symbolicLink:w}=await D.SymlinkSupport.stat(r);v=C.isDirectory()&&!w}catch{}if(v)await D.Promises.rmdir(r);else throw o}else throw o}}catch(r){throw this.fb(r)}}async rename(s,n,r){const o=this.H(s),v=this.H(n);if(o!==v)try{await this.bb(s,n,"move",r.overwrite),await D.Promises.rename(o,v)}catch(C){throw(C.code==="EINVAL"||C.code==="EBUSY"||C.code==="ENAMETOOLONG")&&(C=new Error((0,E.localize)(2,null,(0,R.$nc)(o),(0,R.$nc)((0,R.$mc)(v)),C.toString()))),this.fb(C)}}async copy(s,n,r){const o=this.H(s),v=this.H(n);if(o!==v)try{await this.bb(s,n,"copy",r.overwrite),await D.Promises.copy(o,v,{preserveSymlinks:!0})}catch(C){throw(C.code==="EINVAL"||C.code==="EBUSY"||C.code==="ENAMETOOLONG")&&(C=new Error((0,E.localize)(3,null,(0,R.$nc)(o),(0,R.$nc)((0,R.$mc)(v)),C.toString()))),this.fb(C)}}async bb(s,n,r,o){const v=this.H(s),C=this.H(n);let w=!1;if(!!(this.capabilities&1024)||(w=(0,k.$Xf)(v,C,!0)),w){if(r==="copy")throw(0,h.$mk)((0,E.localize)(4,null),h.FileSystemProviderErrorCode.FileExists);if(r==="move")return}const b=await this.L(s);if(!b)throw(0,h.$mk)((0,E.localize)(5,null),h.FileSystemProviderErrorCode.FileNotFound);const I=await this.L(n);if(I){if(!o)throw(0,h.$mk)((0,E.localize)(6,null),h.FileSystemProviderErrorCode.FileExists);b.type&h.FileType.File&&I.type&h.FileType.File||await this.delete(n,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(s,n){return this.cb(s,n,!1)}async cb(s,n,r){const o=this.H(s),v=this.H(n),C=!!(this.capabilities&1024);if((0,k.$Xf)(o,v,!C))return;const w=new $.$Rc;try{w.add(await this.O(s)),w.add(await this.O(n)),r&&await D.Promises.mkdir((0,R.$mc)(v),{recursive:!0}),await D.Promises.copyFile(o,v)}catch(m){if(m.code==="ENOENT"&&!r)return this.cb(s,n,!0);throw this.fb(m)}finally{w.dispose()}}t(s,n,r){return new f.$9p(o=>s(o),o=>n(o),r)}F(s,n,r){return new a.$eq(o=>s(o),o=>n(o),r)}fb(s){if(s instanceof h.$lk)return s;let n=s,r;switch(s.code){case"ENOENT":r=h.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":r=h.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":r=h.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":r=h.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":r=h.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":n=`${s.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,r=h.FileSystemProviderErrorCode.Unknown;break;default:r=h.FileSystemProviderErrorCode.Unknown}return(0,h.$mk)(n,r)}async gb(s,n){let r=this.fb(n);if(s&&r.code===h.FileSystemProviderErrorCode.NoPermissions)try{const{stat:o}=await D.SymlinkSupport.stat(this.H(s));o.mode&128||(r=(0,h.$mk)(n,h.FileSystemProviderErrorCode.FileWriteLocked))}catch(o){this.a.trace(o)}return r}}e.$fq=t,t.I=!1,t.Y=!0}),define(De[242],Ce([1,0,3,14]),function(re,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PN=void 0;class l extends y.$Sc{constructor(A,g=[]){super(),this.a=new M.$ij([A,...g]),this.B(A.onDidChangeLogLevel(k=>this.setLevel(k)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(A){this.a.setLevel(A)}getLevel(){return this.a.getLevel()}trace(A,...g){this.a.trace(A,...g)}debug(A,...g){this.a.debug(A,...g)}info(A,...g){this.a.info(A,...g)}warn(A,...g){this.a.warn(A,...g)}error(A,...g){this.a.error(A,...g)}flush(){this.a.flush()}}e.$PN=l}),define(De[243],Ce([1,0,30,14]),function(re,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EN=void 0;var l;(function($){$[$.Trace=0]="Trace",$[$.Debug=1]="Debug",$[$.Info=2]="Info",$[$.Warning=3]="Warning",$[$.Error=4]="Error",$[$.Critical=5]="Critical",$[$.Off=6]="Off"})(l||(l={}));async function L($,R,P,p,S){try{const D=await new Promise((h,u)=>{re(["@vscode/spdlog"],h,u)});D.setFlushOn(l.Trace);const E=await D.createAsyncRotatingLogger($,R,P,p);return S?E.clearFormatters():E.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),E}catch(D){console.error(D)}return null}function A($,R,P){switch(R){case M.LogLevel.Trace:$.trace(P);break;case M.LogLevel.Debug:$.debug(P);break;case M.LogLevel.Info:$.info(P);break;case M.LogLevel.Warning:$.warn(P);break;case M.LogLevel.Error:$.error(P);break;case M.LogLevel.Off:break;default:throw new Error(`Invalid log level ${R}`)}}function g($,R){switch(R){case M.LogLevel.Trace:$.setLevel(l.Trace);break;case M.LogLevel.Debug:$.setLevel(l.Debug);break;case M.LogLevel.Info:$.setLevel(l.Info);break;case M.LogLevel.Warning:$.setLevel(l.Warning);break;case M.LogLevel.Error:$.setLevel(l.Error);break;case M.LogLevel.Off:$.setLevel(l.Off);break;default:throw new Error(`Invalid log level ${R}`)}}class k extends M.$ej{constructor(R,P,p,S,D){super(),this.m=[],this.setLevel(D),this.n=this.s(R,P,p,S),this.B(this.onDidChangeLogLevel(E=>{this.r&&g(this.r,E)}))}async s(R,P,p,S){const D=p?6:1,E=30/D*y.$Hk.MB,h=await L(R,P,E,D,S);if(h){this.r=h,g(this.r,this.getLevel());for(const{level:u,message:d}of this.m)A(this.r,u,d);this.m=[]}}g(R,P){this.r?A(this.r,R,P):this.getLevel()<=R&&this.m.push({level:R,message:P})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u())}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$EN=k}),define(De[134],Ce([1,0,39,198,5]),function(re,e,y,M,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$et=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var L;(function(k){k[k.Unnecessary=1]="Unnecessary",k[k.Deprecated=2]="Deprecated"})(L||(e.MarkerTag=L={}));var A;(function(k){k[k.Hint=1]="Hint",k[k.Info=2]="Info",k[k.Warning=4]="Warning",k[k.Error=8]="Error"})(A||(e.MarkerSeverity=A={})),function(k){function $(D,E){return E-D}k.compare=$;const R=Object.create(null);R[k.Error]=(0,M.localize)(0,null),R[k.Warning]=(0,M.localize)(1,null),R[k.Info]=(0,M.localize)(2,null);function P(D){return R[D]||""}k.toString=P;function p(D){switch(D){case y.default.Error:return k.Error;case y.default.Warning:return k.Warning;case y.default.Info:return k.Info;case y.default.Ignore:return k.Hint}}k.fromSeverity=p;function S(D){switch(D){case k.Error:return y.default.Error;case k.Warning:return y.default.Warning;case k.Info:return y.default.Info;case k.Hint:return y.default.Ignore}}k.toSeverity=S}(A||(e.MarkerSeverity=A={}));var g;(function(k){const $="";function R(p){return P(p,!0)}k.makeKey=R;function P(p,S){const D=[$];return p.source?D.push(p.source.replace("\xA6","\\\xA6")):D.push($),p.code?typeof p.code=="string"?D.push(p.code.replace("\xA6","\\\xA6")):D.push(p.code.value.replace("\xA6","\\\xA6")):D.push($),p.severity!==void 0&&p.severity!==null?D.push(A.toString(p.severity)):D.push($),p.message&&S?D.push(p.message.replace("\xA6","\\\xA6")):D.push($),p.startLineNumber!==void 0&&p.startLineNumber!==null?D.push(p.startLineNumber.toString()):D.push($),p.startColumn!==void 0&&p.startColumn!==null?D.push(p.startColumn.toString()):D.push($),p.endLineNumber!==void 0&&p.endLineNumber!==null?D.push(p.endLineNumber.toString()):D.push($),p.endColumn!==void 0&&p.endColumn!==null?D.push(p.endColumn.toString()):D.push($),D.push($),D.join("\xA6")}k.makeKeyOptionalMessage=P})(g||(e.IMarkerData=g={})),e.$et=(0,l.$Qh)("markerService")}),define(De[244],Ce([1,0,4,39,5]),function(re,e,y,M,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7u=e.$6u=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$5u=e.Severity=void 0,e.Severity=M.default,e.$5u=(0,l.$Qh)("notificationService");var L;(function(R){R[R.DEFAULT=0]="DEFAULT",R[R.SILENT=1]="SILENT",R[R.URGENT=2]="URGENT"})(L||(e.NotificationPriority=L={}));var A;(function(R){R[R.WORKSPACE=0]="WORKSPACE",R[R.PROFILE=1]="PROFILE",R[R.APPLICATION=2]="APPLICATION"})(A||(e.NeverShowAgainScope=A={}));var g;(function(R){R[R.OFF=0]="OFF",R[R.SILENT=1]="SILENT",R[R.ERROR=2]="ERROR"})(g||(e.NotificationsFilter=g={}));class k{constructor(){this.progress=new $,this.onDidClose=y.Event.None,this.onDidChangeVisibility=y.Event.None}updateSeverity(P){}updateMessage(P){}updateActions(P){}close(){}}e.$6u=k;class ${infinite(){}done(){}total(P){}worked(P){}}e.$7u=$}),define(De[135],Ce([1,0,16,2,5]),function(re,e,y,M,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zU=e.$yU=e.$xU=e.$wU=e.$vU=void 0,e.$vU=(0,l.$Qh)("openerService");function L($,R){return M.URI.isUri($)?(0,y.$3e)($.scheme,R):(0,y.$4e)($,R+":")}e.$wU=L;function A($,...R){return R.some(P=>L($,P))}e.$xU=A;function g($,R){return $.with({fragment:`${R.startLineNumber},${R.startColumn}${R.endLineNumber?`-${R.endLineNumber}${R.endColumn?`,${R.endColumn}`:""}`:""}`})}e.$yU=g;function k($){let R;const P=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec($.fragment);return P&&(R={startLineNumber:parseInt(P[1]),startColumn:P[2]?parseInt(P[2]):1,endLineNumber:P[4]?parseInt(P[4]):void 0,endColumn:P[4]?P[5]?parseInt(P[5]):1:void 0},$=$.with({fragment:""})),{selection:R,uri:$}}e.$zU=k}),define(De[245],Ce([1,0,12,48]),function(re,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let l;if(typeof y.$b.vscode<"u"&&typeof y.$b.vscode.context<"u"){const L=y.$b.vscode.context.configuration();if(L)l=L.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(l=globalThis._VSCODE_PRODUCT_JSON,M.env.VSCODE_DEV&&Object.assign(l,{nameShort:`${l.nameShort} Dev`,nameLong:`${l.nameLong} Dev`,dataFolderName:`${l.dataFolderName}-dev`,serverDataFolderName:l.serverDataFolderName?`${l.serverDataFolderName}-dev`:void 0}),!l.version){const L=globalThis._VSCODE_PACKAGE_JSON;Object.assign(l,{version:L.version})}Object.assign(l,{extensionsGallery:M.env.EXTENSIONS_GALLERY?JSON.parse(M.env.EXTENSIONS_GALLERY):l.extensionsGallery||{serviceUrl:"https://open-vsx.org/vscode/gallery",itemUrl:"https://open-vsx.org/vscode/item",resourceUrlTemplate:"https://open-vsx.org/vscode/asset/{publisher}/{name}/{version}/Microsoft.VisualStudio.Code.WebResources/{path}",controlUrl:"",recommendationsUrl:""}})}else l={nameShort:"code-server",nameLong:"code-server",applicationName:"code-server",dataFolderName:".code-server",win32MutexName:"codeserver",licenseName:"MIT",licenseUrl:"https://github.com/coder/code-server/blob/main/LICENSE",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverGreeting:[],serverLicense:[],serverLicensePrompt:"",serverApplicationName:"code-server-oss",serverDataFolderName:".vscode-server-oss",tunnelApplicationName:"code-tunnel-oss",win32DirName:"code-server",win32NameVersion:"code-server",win32RegValueName:"CodeOSS",win32x64AppId:"{{D77B7E06-80BA-4137-BCF4-654B95CCEBC5}",win32arm64AppId:"{{D1ACE434-89C5-48D1-88D3-E2991DF85475}",win32x64UserAppId:"{{CC6B787D-37A0-49E8-AE24-8559A032BE0C}",win32arm64UserAppId:"{{3AEBF0C8-F733-4AD4-BADE-FDB816D53D7B}",win32AppUserModelId:"coder.code-server",win32ShellNameShort:"c&ode-server",win32TunnelServiceMutex:"vscodeoss-tunnelservice",win32TunnelMutex:"vscodeoss-tunnel",darwinBundleIdentifier:"com.coder.code.server",linuxIconName:"com.coder.code.server",licenseFileName:"LICENSE.txt",reportIssueUrl:"https://github.com/coder/code-server/issues/new",nodejsRepository:"https://nodejs.org",urlProtocol:"code-oss",webviewContentExternalBaseUrlTemplate:"https://{{uuid}}.vscode-cdn.net/insider/ef65ac1ba57f57f2a3961bfe94aa20481caca4c6/out/vs/workbench/contrib/webview/browser/pre/",builtInExtensions:[{name:"ms-vscode.js-debug-companion",version:"1.1.2",sha256:"e034b8b41beb4e97e02c70f7175bd88abe66048374c2bd629f54bb33354bc2aa",repo:"https://github.com/microsoft/vscode-js-debug-companion",metadata:{id:"99cb0b7f-7354-4278-b8da-6cc79972169d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.js-debug",version:"1.84.0",sha256:"a57691eb4440e549edba7472c0313e94f24d46ebe1ede18784b552fc5d11e596",repo:"https://github.com/microsoft/vscode-js-debug",metadata:{id:"25629058-ddac-4e17-abba-74678e126c5d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.vscode-js-profile-table",version:"1.0.3",sha256:"b9dab017506d9e6a469a0f82b392e4cb1d7a25a4843f1db8ba396cbee209cfc5",repo:"https://github.com/microsoft/vscode-js-profile-visualizer",metadata:{id:"7e52b41b-71ad-457b-ab7e-0620f1fc4feb",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}}],enableTelemetry:!0,quality:"stable",codeServerVersion:"0.0.0",documentationUrl:"https://go.microsoft.com/fwlink/?LinkID=533484#vscode",keyboardShortcutsUrlMac:"https://go.microsoft.com/fwlink/?linkid=832143",keyboardShortcutsUrlLinux:"https://go.microsoft.com/fwlink/?linkid=832144",keyboardShortcutsUrlWin:"https://go.microsoft.com/fwlink/?linkid=832145",introductoryVideosUrl:"https://go.microsoft.com/fwlink/?linkid=832146",tipsAndTricksUrl:"https://go.microsoft.com/fwlink/?linkid=852118",newsletterSignupUrl:"https://www.research.net/r/vsc-newsletter",linkProtectionTrustedDomains:["https://open-vsx.org"],trustedExtensionAuthAccess:["vscode.git","vscode.github","github.vscode-pull-request-github","github.copilot","github.copilot-chat"],aiConfig:{ariaKey:"code-server"},version:"1.84.2",commit:"9658969084238651b6dde258e04f4abd9b14bfd1",date:"2023-11-14T22:48:03.061Z"},Object.keys(l).length===0&&Object.assign(l,{version:"1.82.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=l}),define(De[136],Ce([1,0,5]),function(re,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rj=e.$qj=void 0,e.$qj=(0,y.$Qh)("productService"),e.$rj="vscode://schemas/vscode-product"});var We=this&&this.__param||function(re,e){return function(y,M){e(y,M,re)}};define(De[64],Ce([1,0,8,21,3,5]),function(re,e,y,M,l,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bv=e.$av=e.$_u=e.$$u=e.$0u=e.$9u=e.ProgressLocation=e.$8u=void 0,e.$8u=(0,L.$Qh)("progressService");var A;(function(P){P[P.Explorer=1]="Explorer",P[P.Scm=3]="Scm",P[P.Extensions=5]="Extensions",P[P.Window=10]="Window",P[P.Notification=15]="Notification",P[P.Dialog=20]="Dialog"})(A||(e.ProgressLocation=A={})),e.$9u=Object.freeze({total(){},worked(){},done(){}});class g{get value(){return this.a}constructor(p){this.b=p}report(p){this.a=p,this.b(this.a)}}e.$0u=g,g.None=Object.freeze({report(){}});class k{get value(){return this.a}constructor(p){this.e=p}report(p){this.b?this.b.push(p):this.b=[p],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const p=this.b.shift();this.a=p,await this.e(this.a)}}finally{this.c=!1;const p=this.d;this.d=void 0,p?.()}}drain(){return this.c?new Promise(p=>{const S=this.d;this.d=()=>{S?.(),p()}}):Promise.resolve()}}e.$$u=k;let $=class extends l.$Sc{constructor(p,S){super(),this.a=new y.$dh,S.withProgress(p,D=>(this.b=D,this.c&&D.report(this.c),this.a.p)),this.B((0,l.$Qc)(()=>this.a.complete()))}report(p){this.b?this.b.report(p):this.c=p}};e.$_u=$,e.$_u=$=He([We(1,e.$8u)],$);class R extends l.$Sc{constructor(p){super(),this.g=p,this.a=0,this.b=this.B(new l.$Rc)}start(p){this.stop();const S=++this.a,D=new M.$Yd;return this.f=setTimeout(()=>{S===this.a&&(this.c=this.g.show(!0))},p),this.b.add((0,l.$Qc)(()=>clearTimeout(this.f))),this.b.add((0,l.$Qc)(()=>D.cancel())),this.b.add((0,l.$Qc)(()=>this.c?this.c.done():void 0)),{id:S,token:D.token,stop:()=>this.h(S),isCurrent:()=>this.a===S}}stop(){this.h(this.a)}h(p){this.a===p&&this.b.clear()}}e.$av=R,e.$bv=(0,L.$Qh)("editorProgressService")}),define(De[43],Ce([1,0,58,17]),function(re,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ln=void 0;class l{constructor(){this.a=new Map}add(A,g){y.ok(M.$zf(A)),y.ok(M.$Bf(g)),y.ok(!this.a.has(A),"There is already an extension with this id"),this.a.set(A,g)}knows(A){return this.a.has(A)}as(A){return this.a.get(A)||null}}e.$ln=new l}),define(De[105],Ce([1,0,4,43]),function(re,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mn=void 0,e.$mn={JSONContribution:"base.contributions.json"};function l(g){return g.length>0&&g.charAt(g.length-1)==="#"?g.substring(0,g.length-1):g}class L{constructor(){this.b=new y.$Od,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(k,$){this.a[l(k)]=$,this.b.fire(k)}notifySchemaChanged(k){this.b.fire(k)}getSchemaContributions(){return{schemas:this.a}}}const A=new L;M.$ln.add(e.$mn.JSONContribution,A)}),define(De[137],Ce([1,0,19,4,17,188,50,105,43]),function(re,e,y,M,l,L,A,g,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fn=e.$En=e.$Dn=e.$Cn=e.$Bn=e.$An=e.$zn=e.$yn=e.$xn=e.$wn=e.$vn=e.$un=e.$tn=e.$sn=e.$rn=e.ConfigurationScope=e.$qn=e.EditPresentationTypes=void 0;var $;(function(a){a.Multiline="multilineText",a.Singleline="singlelineText"})($||(e.EditPresentationTypes=$={})),e.$qn={Configuration:"base.contributions.configuration"};var R;(function(a){a[a.APPLICATION=1]="APPLICATION",a[a.MACHINE=2]="MACHINE",a[a.WINDOW=3]="WINDOW",a[a.RESOURCE=4]="RESOURCE",a[a.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",a[a.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(R||(e.ConfigurationScope=R={})),e.$rn={properties:{},patternProperties:{}},e.$sn={properties:{},patternProperties:{}},e.$tn={properties:{},patternProperties:{}},e.$un={properties:{},patternProperties:{}},e.$vn={properties:{},patternProperties:{}},e.$wn={properties:{},patternProperties:{}},e.$xn="vscode://schemas/settings/resourceLanguage",e.$yn="vscode://schemas/settings/configurationDefaults";const P=k.$ln.as(g.$mn.JSONContribution);class p{constructor(){this.h=new Set,this.i=new M.$Od,this.onDidSchemaChange=this.i.event,this.j=new M.$Od,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:L.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},P.registerSchema(e.$xn,this.g),this.v()}registerConfiguration(t,i=!0){this.registerConfigurations([t],i)}registerConfigurations(t,i=!0){const s=new Set;this.n(t,i,s),P.registerSchema(e.$xn,this.g),this.i.fire(),this.j.fire({properties:s})}deregisterConfigurations(t){const i=new Set;this.o(t,i),P.registerSchema(e.$xn,this.g),this.i.fire(),this.j.fire({properties:i})}updateConfigurations({add:t,remove:i}){const s=new Set;this.o(i,s),this.n(t,!1,s),P.registerSchema(e.$xn,this.g),this.i.fire(),this.j.fire({properties:s})}registerDefaultConfigurations(t){const i=new Set;this.k(t,i),this.i.fire(),this.j.fire({properties:i,defaultsOverrides:!0})}k(t,i){const s=[];for(const{overrides:n,source:r}of t)for(const o in n)if(i.add(o),e.$An.test(o)){const v=this.a.get(o),C=v?.valuesSources??new Map;if(r)for(const I of Object.keys(n[o]))C.set(I,r);const w={...v?.value||{},...n[o]};this.a.set(o,{source:r,value:w,valuesSources:C});const m=(0,A.$ui)(o),b={type:"object",default:w,description:L.localize(1,null,m),$ref:e.$xn,defaultDefaultValue:w,source:l.$zf(r)?void 0:r,defaultValueSource:r};s.push(...E(o)),this.d[o]=b,this.b.properties[o]=b}else{this.a.set(o,{value:n[o],source:r});const v=this.d[o];v&&(this.w(o,v),this.r(o,v))}this.m(s)}deregisterDefaultConfigurations(t){const i=new Set;this.l(t,i),this.i.fire(),this.j.fire({properties:i,defaultsOverrides:!0})}l(t,i){for(const{overrides:s,source:n}of t)for(const r in s){const o=this.a.get(r),v=l.$zf(n)?n:n?.id,C=l.$zf(o?.source)?o?.source:o?.source?.id;if(v===C)if(i.add(r),this.a.delete(r),e.$An.test(r))delete this.d[r],delete this.b.properties[r];else{const w=this.d[r];w&&(this.w(r,w),this.r(r,w))}}this.u()}deltaConfiguration(t){let i=!1;const s=new Set;t.removedDefaults&&(this.l(t.removedDefaults,s),i=!0),t.addedDefaults&&(this.k(t.addedDefaults,s),i=!0),t.removedConfigurations&&this.o(t.removedConfigurations,s),t.addedConfigurations&&this.n(t.addedConfigurations,!1,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:i})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const i of t)this.h.add(i);this.u()}n(t,i,s){t.forEach(n=>{this.p(n,i,n.extensionInfo,n.restrictedProperties,void 0,s),this.c.push(n),this.q(n)})}o(t,i){const s=n=>{if(n.properties)for(const r in n.properties){i.add(r);const o=this.d[r];o?.policy?.name&&this.e.delete(o.policy.name),delete this.d[r],this.s(r,n.properties[r])}n.allOf?.forEach(r=>s(r))};for(const n of t){s(n);const r=this.c.indexOf(n);r!==-1&&this.c.splice(r,1)}}p(t,i=!0,s,n,r=3,o){r=l.$If(t.scope)?r:t.scope;const v=t.properties;if(v)for(const w in v){const m=v[w];if(i&&c(w,m)){delete v[w];continue}if(m.source=s,m.defaultDefaultValue=v[w].default,this.w(w,m),e.$An.test(w)?m.scope=void 0:(m.scope=l.$If(m.scope)?r:m.scope,m.restricted=l.$If(m.restricted)?!!n?.includes(w):m.restricted),v[w].hasOwnProperty("included")&&!v[w].included){this.f[w]=v[w],delete v[w];continue}else this.d[w]=v[w],v[w].policy?.name&&this.e.set(v[w].policy.name,w);!v[w].deprecationMessage&&v[w].markdownDeprecationMessage&&(v[w].deprecationMessage=v[w].markdownDeprecationMessage),o.add(w)}const C=t.allOf;if(C)for(const w of C)this.p(w,i,s,n,r,o)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const i=s=>{const n=s.properties;if(n)for(const o in n)this.r(o,n[o]);s.allOf?.forEach(i)};i(t)}r(t,i){switch(e.$rn.properties[t]=i,i.scope){case 1:e.$sn.properties[t]=i;break;case 2:e.$tn.properties[t]=i;break;case 6:e.$un.properties[t]=i;break;case 3:e.$vn.properties[t]=i;break;case 4:e.$wn.properties[t]=i;break;case 5:e.$wn.properties[t]=i,this.g.properties[t]=i;break}}s(t,i){switch(delete e.$rn.properties[t],i.scope){case 1:delete e.$sn.properties[t];break;case 2:delete e.$tn.properties[t];break;case 6:delete e.$un.properties[t];break;case 3:delete e.$vn.properties[t];break;case 4:case 5:delete e.$wn.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const i=`[${t}]`,s={type:"object",description:L.localize(2,null),errorMessage:L.localize(3,null),$ref:e.$xn};this.w(i,s),e.$rn.properties[i]=s,e.$sn.properties[i]=s,e.$tn.properties[i]=s,e.$un.properties[i]=s,e.$vn.properties[i]=s,e.$wn.properties[i]=s}}v(){const t={type:"object",description:L.localize(4,null),errorMessage:L.localize(5,null),$ref:e.$xn};e.$rn.patternProperties[e.$zn]=t,e.$sn.patternProperties[e.$zn]=t,e.$tn.patternProperties[e.$zn]=t,e.$un.patternProperties[e.$zn]=t,e.$vn.patternProperties[e.$zn]=t,e.$wn.patternProperties[e.$zn]=t,this.i.fire()}w(t,i){const s=this.a.get(t);let n=s?.value,r=s?.source;l.$Gf(n)&&(n=i.defaultDefaultValue,r=void 0),l.$Gf(n)&&(n=u(i.type)),i.default=n,i.defaultValueSource=r}}const S="\\[([^\\]]+)\\]",D=new RegExp(S,"g");e.$zn=`^(${S})+$`,e.$An=new RegExp(e.$zn);function E(a){const t=[];if(e.$An.test(a)){let i=D.exec(a);for(;i?.length;){const s=i[1].trim();s&&t.push(s),i=D.exec(a)}}return(0,y.$Mb)(t)}e.$Bn=E;function h(a){return a.reduce((t,i)=>`${t}[${i}]`,"")}e.$Cn=h;function u(a){switch(Array.isArray(a)?a[0]:a){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$Dn=u;const d=new p;k.$ln.add(e.$qn.Configuration,d);function c(a,t){return a.trim()?e.$An.test(a)?L.localize(7,null,a):d.getConfigurationProperties()[a]!==void 0?L.localize(8,null,a):t.policy?.name&&d.getPolicyConfigurations().get(t.policy?.name)!==void 0?L.localize(9,null,a,t.policy?.name,d.getPolicyConfigurations().get(t.policy?.name)):null:L.localize(6,null)}e.$En=c;function f(){const a=[],t=d.getConfigurationProperties();for(const i of Object.keys(t))a.push([i,t[i].scope]);return a.push(["launch",4]),a.push(["task",4]),a}e.$Fn=f}),define(De[246],Ce([1,0,19,4,158,3,28,24,17,2,50,137,43]),function(re,e,y,M,l,L,A,g,k,$,R,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ln=e.$Kn=e.$Jn=e.$In=e.$Hn=e.$Gn=void 0;function S(i){return Object.isFrozen(i)?i:g.$0m(i)}class D{constructor(s={},n=[],r=[],o){this.b=s,this.c=n,this.d=r,this.raw=o,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const s=this.raw.map(n=>{if(n instanceof D)return n;const r=new E("");return r.parseRaw(n),r.configurationModel});this.f=s.reduce((n,r)=>r===n?r:n.merge(r),s[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(s){return s?(0,R.$si)(this.contents,s):this.contents}inspect(s,n){const r=this.rawConfiguration.getValue(s),o=n?this.rawConfiguration.getOverrideValue(s,n):void 0,v=n?this.rawConfiguration.override(n).getValue(s):r;return{value:r,override:o,merged:v}}getOverrideValue(s,n){const r=this.i(n);return r?s?(0,R.$si)(r,s):r:void 0}getKeysForOverrideIdentifier(s){const n=[];for(const r of this.overrides)r.identifiers.includes(s)&&n.push(...r.keys);return y.$Mb(n)}getAllOverrideIdentifiers(){const s=[];for(const n of this.overrides)s.push(...n.identifiers);return y.$Mb(s)}override(s){let n=this.a.get(s);return n||(n=this.g(s),this.a.set(s,n)),n}merge(...s){const n=g.$9m(this.contents),r=g.$9m(this.overrides),o=[...this.keys],v=this.raw?.length?[...this.raw]:[this];for(const C of s)if(v.push(...C.raw?.length?C.raw:[C]),!C.isEmpty()){this.h(n,C.contents);for(const w of C.overrides){const[m]=r.filter(b=>y.$ub(b.identifiers,w.identifiers));m?(this.h(m.contents,w.contents),m.keys.push(...w.keys),m.keys=y.$Mb(m.keys)):r.push(g.$9m(w))}for(const w of C.keys)o.indexOf(w)===-1&&o.push(w)}return new D(n,o,r,v.every(C=>C instanceof D)?void 0:v)}g(s){const n=this.i(s);if(!n||typeof n!="object"||!Object.keys(n).length)return this;const r={};for(const o of y.$Mb([...Object.keys(this.contents),...Object.keys(n)])){let v=this.contents[o];const C=n[o];C&&(typeof v=="object"&&typeof C=="object"?(v=g.$9m(v),this.h(v,C)):v=C),r[o]=v}return new D(r,this.keys,this.overrides)}h(s,n){for(const r of Object.keys(n)){if(r in s&&k.$Bf(s[r])&&k.$Bf(n[r])){this.h(s[r],n[r]);continue}s[r]=g.$9m(n[r])}}i(s){let n=null,r=null;const o=v=>{v&&(r?this.h(r,v):r=g.$9m(v))};for(const v of this.overrides)v.identifiers.length===1&&v.identifiers[0]===s?n=v.contents:v.identifiers.includes(s)&&o(v.contents);return o(n),r}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(s,n){this.j(s,n,!0)}setValue(s,n){this.j(s,n,!1)}removeValue(s){const n=this.keys.indexOf(s);n!==-1&&(this.keys.splice(n,1),(0,R.$ri)(this.contents,s),P.$An.test(s)&&this.overrides.splice(this.overrides.findIndex(r=>y.$ub(r.identifiers,(0,P.$Bn)(s))),1))}j(s,n,r){(0,R.$qi)(this.contents,s,n,o=>console.error(o)),r=r||this.keys.indexOf(s)===-1,r&&this.keys.push(s),P.$An.test(s)&&this.overrides.push({identifiers:(0,P.$Bn)(s),keys:Object.keys(this.contents[s]),contents:(0,R.$pi)(this.contents[s],o=>console.error(o))})}}e.$Gn=D;class E{constructor(s){this.f=s,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new D}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(s,n){if(!k.$If(s)){const r=this.g(s);this.parseRaw(r,n)}}reparse(s){this.a&&this.parseRaw(this.a,s)}parseRaw(s,n){this.a=s;const{contents:r,keys:o,overrides:v,restricted:C,hasExcludedProperties:w}=this.h(s,n);this.b=new D(r,o,v,w?[s]:void 0),this.c=C||[]}g(s){let n={},r=null,o=[];const v=[],C=[];function w(b){Array.isArray(o)?o.push(b):r!==null&&(o[r]=b)}const m={onObjectBegin:()=>{const b={};w(b),v.push(o),o=b,r=null},onObjectProperty:b=>{r=b},onObjectEnd:()=>{o=v.pop()},onArrayBegin:()=>{const b=[];w(b),v.push(o),o=b,r=null},onArrayEnd:()=>{o=v.pop()},onLiteralValue:w,onError:(b,I,z)=>{C.push({error:b,offset:I,length:z})}};if(s)try{l.$6m(s,m),n=o[0]||{}}catch(b){console.error(`Error while parsing settings file ${this.f}: ${b}`),this.d=[b]}return n}h(s,n){const r=p.$ln.as(P.$qn.Configuration).getConfigurationProperties(),o=this.i(s,r,!0,n);s=o.raw;const v=(0,R.$pi)(s,m=>console.error(`Conflict in settings file ${this.f}: ${m}`)),C=Object.keys(s),w=this.j(s,m=>console.error(`Conflict in settings file ${this.f}: ${m}`));return{contents:v,keys:C,overrides:w,restricted:o.restricted,hasExcludedProperties:o.hasExcludedProperties}}i(s,n,r,o){let v=!1;if(!o?.scopes&&!o?.skipRestricted&&!o?.exclude?.length)return{raw:s,restricted:[],hasExcludedProperties:v};const C={},w=[];for(const m in s)if(P.$An.test(m)&&r){const b=this.i(s[m],n,!1,o);C[m]=b.raw,v=v||b.hasExcludedProperties,w.push(...b.restricted)}else{const b=n[m],I=b?typeof b.scope<"u"?b.scope:3:void 0;b?.restricted&&w.push(m),!o.exclude?.includes(m)&&(o.include?.includes(m)||(I===void 0||o.scopes===void 0||o.scopes.includes(I))&&!(o.skipRestricted&&b?.restricted))?C[m]=s[m]:v=!0}return{raw:C,restricted:w,hasExcludedProperties:v}}j(s,n){const r=[];for(const o of Object.keys(s))if(P.$An.test(o)){const v={};for(const C in s[o])v[C]=s[o][C];r.push({identifiers:(0,P.$Bn)(o),keys:Object.keys(v),contents:(0,R.$pi)(v,n)})}return r}}e.$Hn=E;class h extends L.$Sc{constructor(s,n,r,o){super(),this.c=s,this.f=n,this.g=o,this.b=this.B(new M.$Od),this.onDidChange=this.b.event,this.a=new E(this.c.toString()),this.B(this.g.watch(r.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(M.Event.any(M.Event.filter(this.g.onDidFilesChange,v=>v.contains(this.c)),M.Event.filter(this.g.onDidRunOperation,v=>(v.isOperation(0)||v.isOperation(3)||v.isOperation(1)||v.isOperation(4))&&r.isEqual(v.resource,s)))(()=>this.b.fire()))}async loadConfiguration(){try{const s=await this.g.readFile(this.c);return this.a.parse(s.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new D}}reparse(s){return s&&(this.f=s),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$In=h;class u{constructor(s,n,r,o,v,C,w,m,b,I,z,O,F){this.a=s,this.b=n,this.c=r,this.overrideIdentifiers=o,this.d=v,this.f=C,this.g=w,this.h=m,this.i=b,this.j=I,this.k=z,this.l=O,this.m=F}get value(){return S(this.c)}n(s,n,r){const o=s.inspect(n,r);return{get value(){return S(o.value)},get override(){return S(o.override)},get merged(){return S(o.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class d{constructor(s,n,r,o,v=new D,C=new D,w=new A.$Ac,m=new D,b=new A.$Ac){this.c=s,this.d=n,this.f=r,this.g=o,this.h=v,this.i=C,this.j=w,this.l=m,this.m=b,this.a=null,this.b=new A.$Ac,this.n=null}getValue(s,n,r){return this.q(s,n,r).getValue(s)}updateValue(s,n,r={}){let o;r.resource?(o=this.m.get(r.resource),o||(o=new D,this.m.set(r.resource,o))):o=this.l,n===void 0?o.removeValue(s):o.setValue(s,n),r.resource||(this.a=null)}inspect(s,n,r){const o=this.q(s,n,r),v=this.u(n.resource,r),C=n.resource?this.m.get(n.resource)||this.l:this.l,w=new Set;for(const m of o.overrides)for(const b of m.identifiers)o.getOverrideValue(s,b)!==void 0&&w.add(b);return new u(s,n,o.getValue(s),w.size?[...w]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,r?this.i:void 0,v||void 0,C)}keys(s){const n=this.u(void 0,s);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:n?n.keys.slice(0):[]}}updateDefaultConfiguration(s){this.c=s,this.a=null,this.b.clear()}updatePolicyConfiguration(s){this.d=s}updateApplicationConfiguration(s){this.f=s,this.a=null,this.b.clear()}updateLocalUserConfiguration(s){this.g=s,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(s){this.h=s,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(s){this.i=s,this.a=null,this.b.clear()}updateFolderConfiguration(s,n){this.j.set(s,n),this.b.delete(s)}deleteFolderConfiguration(s){this.p.delete(s),this.b.delete(s)}compareAndUpdateDefaultConfiguration(s,n){const r=[];if(!n){const{added:o,updated:v,removed:C}=a(this.c,s);n=[...o,...v,...C]}for(const o of n)for(const v of(0,P.$Bn)(o)){const C=this.c.getKeysForOverrideIdentifier(v),w=s.getKeysForOverrideIdentifier(v),m=[...w.filter(b=>C.indexOf(b)===-1),...C.filter(b=>w.indexOf(b)===-1),...C.filter(b=>!g.$an(this.c.override(v).getValue(b),s.override(v).getValue(b)))];r.push([v,m])}return this.updateDefaultConfiguration(s),{keys:n,overrides:r}}compareAndUpdatePolicyConfiguration(s){const{added:n,updated:r,removed:o}=a(this.d,s),v=[...n,...r,...o];return v.length&&this.updatePolicyConfiguration(s),{keys:v,overrides:[]}}compareAndUpdateApplicationConfiguration(s){const{added:n,updated:r,removed:o,overrides:v}=a(this.applicationConfiguration,s),C=[...n,...r,...o];return C.length&&this.updateApplicationConfiguration(s),{keys:C,overrides:v}}compareAndUpdateLocalUserConfiguration(s){const{added:n,updated:r,removed:o,overrides:v}=a(this.localUserConfiguration,s),C=[...n,...r,...o];return C.length&&this.updateLocalUserConfiguration(s),{keys:C,overrides:v}}compareAndUpdateRemoteUserConfiguration(s){const{added:n,updated:r,removed:o,overrides:v}=a(this.remoteUserConfiguration,s),C=[...n,...r,...o];return C.length&&this.updateRemoteUserConfiguration(s),{keys:C,overrides:v}}compareAndUpdateWorkspaceConfiguration(s){const{added:n,updated:r,removed:o,overrides:v}=a(this.workspaceConfiguration,s),C=[...n,...r,...o];return C.length&&this.updateWorkspaceConfiguration(s),{keys:C,overrides:v}}compareAndUpdateFolderConfiguration(s,n){const r=this.p.get(s),{added:o,updated:v,removed:C,overrides:w}=a(r,n),m=[...o,...v,...C];return(m.length||!r)&&this.updateFolderConfiguration(s,n),{keys:m,overrides:w}}compareAndDeleteFolderConfiguration(s){const n=this.p.get(s);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(s);const{added:r,updated:o,removed:v,overrides:C}=a(n,void 0);return{keys:[...r,...o,...v],overrides:C}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(s,n,r){let o=this.r(n,r);return n.overrideIdentifier&&(o=o.override(n.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(s)!==void 0&&(o=o.merge(this.d)),o}r({resource:s},n){let r=this.s();if(n&&s){const o=n.getFolder(s);o&&(r=this.t(o.uri)||r);const v=this.m.get(s);v&&(r=r.merge(v))}return r}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(s){let n=this.b.get(s);if(!n){const r=this.s(),o=this.j.get(s);o?(n=r.merge(o),this.b.set(s,n)):n=r}return n}u(s,n){if(n&&s){const r=n.getFolder(s);if(r)return this.j.get(r.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((s,n)=>{const{contents:r,overrides:o,keys:v}=this.j.get(n);return s.push([n,{contents:r,overrides:o,keys:v}]),s},[])}}allKeys(){const s=new Set;return this.c.keys.forEach(n=>s.add(n)),this.userConfiguration.keys.forEach(n=>s.add(n)),this.i.keys.forEach(n=>s.add(n)),this.j.forEach(n=>n.keys.forEach(r=>s.add(r))),[...s.values()]}v(){const s=new Set;return this.c.getAllOverrideIdentifiers().forEach(n=>s.add(n)),this.userConfiguration.getAllOverrideIdentifiers().forEach(n=>s.add(n)),this.i.getAllOverrideIdentifiers().forEach(n=>s.add(n)),this.j.forEach(n=>n.getAllOverrideIdentifiers().forEach(r=>s.add(r))),[...s.values()]}w(s){const n=new Set;return this.c.getKeysForOverrideIdentifier(s).forEach(r=>n.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(s).forEach(r=>n.add(r)),this.i.getKeysForOverrideIdentifier(s).forEach(r=>n.add(r)),this.j.forEach(r=>r.getKeysForOverrideIdentifier(s).forEach(o=>n.add(o))),[...n.values()]}static parse(s){const n=this.x(s.defaults),r=this.x(s.policy),o=this.x(s.application),v=this.x(s.user),C=this.x(s.workspace),w=s.folders.reduce((m,b)=>(m.set($.URI.revive(b[0]),this.x(b[1])),m),new A.$Ac);return new d(n,r,o,v,new D,C,w,new D,new A.$Ac)}static x(s){return new D(s.contents,s.keys,s.overrides)}}e.$Jn=d;function c(...i){if(i.length===0)return{keys:[],overrides:[]};if(i.length===1)return i[0];const s=new Set,n=new Map;for(const o of i)o.keys.forEach(v=>s.add(v)),o.overrides.forEach(([v,C])=>{const w=(0,A.$xc)(n,v,new Set);C.forEach(m=>w.add(m))});const r=[];return n.forEach((o,v)=>r.push([v,[...o.values()]])),{keys:[...s.values()],overrides:r}}e.$Kn=c;class f{constructor(s,n,r,o){this.change=s,this.f=n,this.g=r,this.h=o,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const v of s.keys)this.affectedKeys.add(v);for(const[,v]of s.overrides)for(const C of v)this.affectedKeys.add(C);this.d=this.a;for(const v of this.affectedKeys)this.d+=v+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=d.parse(this.f.data)),this.i}affectsConfiguration(s,n){const r=this.a+s,o=this.d.indexOf(r);if(o<0)return!1;const v=o+r.length;if(v>=this.d.length)return!1;const C=this.d.charCodeAt(v);if(C!==this.b&&C!==this.c)return!1;if(n){const w=this.previousConfiguration?this.previousConfiguration.getValue(s,n,this.f?.workspace):void 0,m=this.g.getValue(s,n,this.h);return!g.$an(w,m)}return!0}}e.$Ln=f;function a(i,s){const{added:n,removed:r,updated:o}=t(s?.rawConfiguration,i?.rawConfiguration),v=[],C=i?.getAllOverrideIdentifiers()||[],w=s?.getAllOverrideIdentifiers()||[];if(s){const m=w.filter(b=>!C.includes(b));for(const b of m)v.push([b,s.getKeysForOverrideIdentifier(b)])}if(i){const m=C.filter(b=>!w.includes(b));for(const b of m)v.push([b,i.getKeysForOverrideIdentifier(b)])}if(s&&i){for(const m of C)if(w.includes(m)){const b=t({contents:i.getOverrideValue(void 0,m)||{},keys:i.getKeysForOverrideIdentifier(m)},{contents:s.getOverrideValue(void 0,m)||{},keys:s.getKeysForOverrideIdentifier(m)});v.push([m,[...b.added,...b.removed,...b.updated]])}}return{added:n,removed:r,updated:o,overrides:v}}function t(i,s){const n=i?s?i.keys.filter(v=>s.keys.indexOf(v)===-1):[...i.keys]:[],r=s?i?s.keys.filter(v=>i.keys.indexOf(v)===-1):[...s.keys]:[],o=[];if(i&&s){for(const v of s.keys)if(i.keys.indexOf(v)!==-1){const C=(0,R.$si)(s.contents,v),w=(0,R.$si)(i.contents,v);g.$an(C,w)||o.push(v)}}return{added:n,removed:r,updated:o}}}),define(De[247],Ce([1,0,22,4,3,82]),function(re,e,y,M,l,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xkb=e.$Wkb=e.$Vkb=e.$Ukb=void 0;const A=($,R,P)=>{const p=new Uint8Array(16);for(let E=0;E<16;E++)p[E]=Math.round(Math.random()*256);const S=(0,y.$we)(y.$ce.wrap(p));return[`GET ws://localhost${$}?${R}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${S}`].join(`\r
`)+`\r
\r
`};e.$Ukb=A,e.$Vkb=y.$ce.fromString(`\r
\r
`);async function g($,R,P,p,S){$.write(y.$ce.fromString((0,e.$Ukb)(R,P,p)));const D=new l.$Rc;try{return await new Promise((E,h)=>{let u;D.add($.onData(d=>{u?u=y.$ce.concat([u,d],u.byteLength+d.byteLength):u=d;const c=u.indexOf(e.$Vkb);if(c===-1)return;E($),$.pauseData();const f=u.slice(c+e.$Vkb.byteLength);f.byteLength&&S.onData.fire(f)})),D.add($.onClose(d=>h(d??new Error("socket closed")))),D.add($.onEnd(()=>h(new Error("socket ended"))))})}catch(E){throw $.dispose(),E}finally{D.dispose()}}e.$Wkb=g;class k extends l.$Sc{constructor(R,P){super(),this.g=R,this.a=this.B(new M.$Rd),this.onData=(...p)=>(this.a.isPaused&&queueMicrotask(()=>this.a.resume()),this.a.event(...p)),this.b=this.B(new M.$Od),this.onDidDispose=this.b.event,this.f=!1,this.B(P.onData),this.B(P.onData.event(p=>this.a.fire(p))),this.onClose=this.B(P.onClose).event,this.onEnd=this.B(P.onEnd).event}pauseData(){this.a.pause()}drain(){return Promise.resolve()}end(){this.f=!0,this.h()}traceSocketEvent(R,P){L.SocketDiagnostics.traceSocketEvent(this,this.g,R,P)}dispose(){this.f||this.h(),this.b.fire(),super.dispose()}}e.$Xkb=k}),define(De[65],Ce([1,0,9,5]),function(re,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uk=e.$Tk=e.RemoteAuthorityResolverErrorCode=e.$Sk=e.$Rk=e.RemoteConnectionType=e.$Qk=void 0,e.$Qk=(0,M.$Qh)("remoteAuthorityResolverService");var l;(function(R){R[R.WebSocket=0]="WebSocket",R[R.Managed=1]="Managed"})(l||(e.RemoteConnectionType=l={}));class L{constructor(P){this.id=P,this.type=1}toString(){return`Managed(${this.id})`}}e.$Rk=L;class A{constructor(P,p){this.host=P,this.port=p,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Sk=A;var g;(function(R){R.Unknown="Unknown",R.NotAvailable="NotAvailable",R.TemporarilyNotAvailable="TemporarilyNotAvailable",R.NoResolverFound="NoResolverFound",R.InvalidAuthority="InvalidAuthority"})(g||(e.RemoteAuthorityResolverErrorCode=g={}));class k extends y.$bb{static isNotAvailable(P){return P instanceof k&&P._code===g.NotAvailable}static isTemporarilyNotAvailable(P){return P instanceof k&&P._code===g.TemporarilyNotAvailable}static isNoResolverFound(P){return P instanceof k&&P._code===g.NoResolverFound}static isInvalidAuthority(P){return P instanceof k&&P._code===g.InvalidAuthority}static isHandled(P){return P instanceof k&&P.isHandled}constructor(P,p=g.Unknown,S){super(P),this._message=P,this._code=p,this._detail=S,this.isHandled=p===g.NotAvailable&&S===!0,Object.setPrototypeOf(this,k.prototype)}}e.$Tk=k;function $(R){const P=R.indexOf("+");return P===-1?R:R.substring(0,P)}e.$Uk=$}),define(De[66],Ce([1,0,18]),function(re,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zk=e.$Yk=e.$Xk=e.$Wk=e.$Vk=void 0;function M($){return $.scheme===y.Schemas.vscodeRemote?$.authority:void 0}e.$Vk=M;function l($){if(!$)return;const R=$.indexOf("+");return R<0?$:$.substr(0,R)}e.$Wk=l;function L($){return`/${$.quality??"oss"}-${$.commit??"dev"}`}e.$Xk=L;function A($){const{host:R,port:P}=k($);if(typeof P>"u")throw new Error("Remote authority doesn't contain a port!");return{host:R,port:P}}e.$Yk=A;function g($,R){let{host:P,port:p}=k($);return typeof p>"u"&&(p=R),{host:P,port:p}}e.$Zk=g;function k($){const R=$.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(R)return{host:R[1],port:parseInt(R[2],10)};const P=$.match(/^(\[[0-9a-z:]+\])$/);if(P)return{host:P[1],port:void 0};const p=$.match(/(.*):(\d+)$/);return p?{host:p[1],port:parseInt(p[2],10)}:{host:$,port:void 0}}}),define(De[25],Ce([1,0,16,5,66]),function(re,e,y,M,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cm=e.$bm=e.$am=e.$_l=e.$$l=e.$0l=e.$9l=e.$8l=e.TargetPlatform=e.ExtensionType=e.$7l=e.$6l=e.$5l=e.$4l=e.$3l=e.$2l=void 0,e.$2l="extensions.user.cache",e.$3l="extensions.builtin.cache",e.$4l="undefined_publisher",e.$5l=["ui","workspace","web"];function L(E){if(typeof E=="object"&&E!==null&&E.supported!==!0)return E.description}e.$6l=L,e.$7l=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var A;(function(E){E[E.System=0]="System",E[E.User=1]="User"})(A||(e.ExtensionType=A={}));var g;(function(E){E.WIN32_X64="win32-x64",E.WIN32_ARM64="win32-arm64",E.LINUX_X64="linux-x64",E.LINUX_ARM64="linux-arm64",E.LINUX_ARMHF="linux-armhf",E.ALPINE_X64="alpine-x64",E.ALPINE_ARM64="alpine-arm64",E.DARWIN_X64="darwin-x64",E.DARWIN_ARM64="darwin-arm64",E.WEB="web",E.UNIVERSAL="universal",E.UNKNOWN="unknown",E.UNDEFINED="undefined"})(g||(e.TargetPlatform=g={}));class k{constructor(h){this.value=h,this._lower=h.toLowerCase()}static equals(h,u){if(typeof h>"u"||h===null)return typeof u>"u"||u===null;if(typeof u>"u"||u===null)return!1;if(typeof h=="string"||typeof u=="string"){const d=typeof h=="string"?h:h.value,c=typeof u=="string"?u:u.value;return y.$3e(d,c)}return h._lower===u._lower}static toKey(h){return typeof h=="string"?h.toLowerCase():h._lower}}e.$8l=k;class ${get size(){return this.c.size}constructor(h){if(this.c=new Set,h)for(const u of h)this.add(u)}add(h){this.c.add(k.toKey(h))}delete(h){return this.c.delete(k.toKey(h))}has(h){return this.c.has(k.toKey(h))}}e.$9l=$;class R{constructor(){this.c=new Map}clear(){this.c.clear()}delete(h){this.c.delete(k.toKey(h))}get(h){return this.c.get(k.toKey(h))}has(h){return this.c.has(k.toKey(h))}set(h,u){this.c.set(k.toKey(h),u)}values(){return this.c.values()}forEach(h){this.c.forEach(h)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$0l=R;function P(E){return p(E)}e.$$l=P;function p(E){return E.contributes&&E.contributes.localizations?E.contributes.localizations.length>0:!1}e.$_l=p;function S(E){return E.contributes&&E.contributes.authentication?E.contributes.authentication.length>0:!1}e.$am=S;function D(E,h){if(h){const u=`onResolveRemoteAuthority:${(0,l.$Wk)(h)}`;return!!E.activationEvents?.includes(u)}return!1}e.$bm=D,e.$cm=(0,M.$Qh)("IBuiltinExtensionsScannerService")}),define(De[138],Ce([1,0,9,25]),function(re,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4E=e.$3E=void 0;class l{constructor(){this.a=new Map,this.b=new WeakMap}register(A,g){this.a.set(A,g)}readActivationEvents(A){return this.b.has(A)||this.b.set(A,this.c(A)),this.b.get(A)}createActivationEventsMap(A){const g=Object.create(null);for(const k of A){const $=this.readActivationEvents(k);$.length>0&&(g[M.$8l.toKey(k.identifier)]=$)}return g}c(A){if(typeof A.main>"u"&&typeof A.browser>"u")return[];const g=Array.isArray(A.activationEvents)?A.activationEvents.slice(0):[];if(!A.contributes)return g;for(const k in A.contributes){const $=this.a.get(k);if(!$)continue;const R=A.contributes[k],P=Array.isArray(R)?R:[R];try{$(P,g)}catch(p){(0,y.$1)(p)}}return g}}e.$3E=l,e.$4E=new l}),define(De[248],Ce([1,0,8,22,21,9,4,3,54,35,31,82,65,66]),function(re,e,y,M,l,L,A,g,k,$,R,P,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cl=e.$bl=e.$al=e.$_k=e.$$k=e.$0k=e.$9k=e.$8k=e.PersistentConnectionEventType=e.$7k=e.$6k=e.$5k=e.ConnectionType=void 0;const D=30*1e3;var E;(function(fe){fe[fe.Management=1]="Management",fe[fe.ExtensionHost=2]="ExtensionHost",fe[fe.Tunnel=3]="Tunnel"})(E||(e.ConnectionType=E={}));function h(fe){switch(fe){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function u(fe){const V=new l.$Yd;return setTimeout(()=>V.cancel(),fe),V.token}function d(fe,V){if(fe.isCancellationRequested||V.isCancellationRequested)return l.CancellationToken.Cancelled;const le=new l.$Yd;return fe.onCancellationRequested(()=>le.cancel()),V.onCancellationRequested(()=>le.cancel()),le.token}class c{get didTimeout(){return this.c==="timedout"}constructor(V){this.c="pending",this.d=new g.$Rc,this.promise=new Promise((le,H)=>{this.f=le,this.g=H}),V.isCancellationRequested?this.h():this.d.add(V.onCancellationRequested(()=>this.h()))}registerDisposable(V){this.c==="pending"?this.d.add(V):V.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const V=new Error("Time limit reached");return V.code="ETIMEDOUT",V.syscall="connect",V}resolve(V){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(V))}reject(V){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(V))}}function f(fe,V){const le=new c(V);return le.registerDisposable(fe.onControlMessage(H=>{const G=JSON.parse(H.toString()),Y=Q(G);Y?le.reject(Y):le.resolve(G)})),le.promise}function a(fe,V,le,H,G,Y,X,be){const se=new c(be),ge=$.$Kd.create(!1);return fe.info(`Creating a socket (${X})...`),k.mark(`code/willCreateSocket/${Y}`),V.connect(le,H,G,X).then(te=>{se.didTimeout?(k.mark(`code/didCreateSocketError/${Y}`),fe.info(`Creating a socket (${X}) finished after ${ge.elapsed()} ms, but this is too late and has timed out already.`),te?.dispose()):(k.mark(`code/didCreateSocketOK/${Y}`),fe.info(`Creating a socket (${X}) was successful after ${ge.elapsed()} ms.`),se.resolve(te))},te=>{k.mark(`code/didCreateSocketError/${Y}`),fe.info(`Creating a socket (${X}) returned an error after ${ge.elapsed()} ms.`),fe.error(te),se.reject(te)}),se.promise}function t(fe,V){const le=new c(V);return fe.then(H=>{le.didTimeout||le.resolve(H)},H=>{le.didTimeout||le.reject(H)}),le.promise}async function i(fe,V,le,H){const G=oe(fe,V);fe.logService.trace(`${G} 1/6. invoking socketFactory.connect().`);let Y;try{Y=await a(fe.logService,fe.remoteSocketFactoryService,fe.connectTo,(0,S.$Xk)(fe),`reconnectionToken=${fe.reconnectionToken}&reconnection=${fe.reconnectionProtocol?"true":"false"}`,h(V),`renderer-${h(V)}-${fe.reconnectionToken}`,H)}catch(te){throw fe.logService.error(`${G} socketFactory.connect() failed or timed out. Error:`),fe.logService.error(te),te}fe.logService.trace(`${G} 2/6. socketFactory.connect() was successful.`);let X,be;fe.reconnectionProtocol?(fe.reconnectionProtocol.beginAcceptReconnection(Y,null),X=fe.reconnectionProtocol,be=!1):(X=new P.$Eh({socket:Y}),be=!0),fe.logService.trace(`${G} 3/6. sending AuthRequest control message.`);const se=await t(fe.signService.createNewMessage((0,R.$fg)()),H),ge={type:"auth",auth:fe.connectionToken||"00000000000000000000",data:se.data};X.sendControl(M.$ce.fromString(JSON.stringify(ge)));try{const te=await f(X,d(H,u(1e4)));if(te.type!=="sign"||typeof te.data!="string"){const W=new Error("Unexpected handshake message");throw W.code="VSCODE_CONNECTION_ERROR",W}if(fe.logService.trace(`${G} 4/6. received SignRequest control message.`),!await t(fe.signService.validate(se,te.signedData),H)){const W=new Error("Refused to connect to unsupported server");throw W.code="VSCODE_CONNECTION_ERROR",W}const we=await t(fe.signService.sign(te.data),H),Ie={type:"connectionType",commit:fe.commit,signedData:we,desiredConnectionType:V};return le&&(Ie.args=le),fe.logService.trace(`${G} 5/6. sending ConnectionTypeRequest control message.`),X.sendControl(M.$ce.fromString(JSON.stringify(Ie))),{protocol:X,ownsProtocol:be}}catch(te){throw te&&te.code==="ETIMEDOUT"&&(fe.logService.error(`${G} the handshake timed out. Error:`),fe.logService.error(te)),te&&te.code==="VSCODE_CONNECTION_ERROR"&&(fe.logService.error(`${G} received error control message when negotiating connection. Error:`),fe.logService.error(te)),be&&x(X),te}}async function s(fe,V,le,H){const G=Date.now(),Y=oe(fe,V),{protocol:X,ownsProtocol:be}=await i(fe,V,le,H),se=new c(H);return se.registerDisposable(X.onControlMessage(ge=>{const te=JSON.parse(ge.toString()),me=Q(te);me?(fe.logService.error(`${Y} received error control message when negotiating connection. Error:`),fe.logService.error(me),be&&x(X),se.reject(me)):(fe.reconnectionProtocol?.endAcceptReconnection(),fe.logService.trace(`${Y} 6/6. handshake finished, connection is up and running after ${ye(G)}!`),se.resolve({protocol:X,firstMessage:te}))})),se.promise}async function n(fe,V){const{protocol:le}=await s(fe,1,void 0,V);return{protocol:le}}async function r(fe,V,le){const{protocol:H,firstMessage:G}=await s(fe,2,V,le),Y=G&&G.debugPort;return{protocol:H,debugPort:Y}}async function o(fe,V,le){const H=Date.now(),G=oe(fe,3),{protocol:Y}=await i(fe,3,V,le);return fe.logService.trace(`${G} 6/6. handshake finished, connection is up and running after ${ye(H)}!`),Y}async function v(fe,V,le){const{connectTo:H,connectionToken:G}=await fe.addressProvider.getAddress();return{commit:fe.commit,quality:fe.quality,connectTo:H,connectionToken:G,reconnectionToken:V,reconnectionProtocol:le,remoteSocketFactoryService:fe.remoteSocketFactoryService,signService:fe.signService,logService:fe.logService}}async function C(fe,V,le){return m(fe,async H=>{const{protocol:G}=await n(H,l.CancellationToken.None);return new B(fe,V,le,H.reconnectionToken,G)})}e.$5k=C;async function w(fe,V){return m(fe,async le=>{const{protocol:H,debugPort:G}=await r(le,V,l.CancellationToken.None);return new he(fe,V,le.reconnectionToken,H,G)})}e.$6k=w;async function m(fe,V){for(let H=1;;H++)try{const G=(0,R.$fg)(),Y=await v(fe,G,null);return await V(Y)}catch(G){if(H<5)fe.logService.error(`[remote-connection][attempt ${H}] An error occurred in initial connection! Will retry... Error:`),fe.logService.error(G);else throw fe.logService.error(`[remote-connection][attempt ${H}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),fe.logService.error(G),U.triggerPermanentFailure(0,0,p.$Tk.isHandled(G)),G}}async function b(fe,V,le){const H=await v(fe,(0,R.$fg)(),null);return await o(H,{host:V,port:le},l.CancellationToken.None)}e.$7k=b;function I(fe){return(0,y.$Ig)(V=>new Promise((le,H)=>{const G=setTimeout(le,fe*1e3);V.onCancellationRequested(()=>{clearTimeout(G),le()})}))}var z;(function(fe){fe[fe.ConnectionLost=0]="ConnectionLost",fe[fe.ReconnectionWait=1]="ReconnectionWait",fe[fe.ReconnectionRunning=2]="ReconnectionRunning",fe[fe.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",fe[fe.ConnectionGain=4]="ConnectionGain"})(z||(e.PersistentConnectionEventType=z={}));class O{constructor(V,le){this.reconnectionToken=V,this.millisSinceLastIncomingData=le,this.type=0}}e.$8k=O;class F{constructor(V,le,H,G){this.reconnectionToken=V,this.millisSinceLastIncomingData=le,this.durationSeconds=H,this.c=G,this.type=1}skipWait(){this.c.cancel()}}e.$9k=F;class T{constructor(V,le,H){this.reconnectionToken=V,this.millisSinceLastIncomingData=le,this.attempt=H,this.type=2}}e.$0k=T;class N{constructor(V,le,H){this.reconnectionToken=V,this.millisSinceLastIncomingData=le,this.attempt=H,this.type=4}}e.$$k=N;class j{constructor(V,le,H,G){this.reconnectionToken=V,this.millisSinceLastIncomingData=le,this.attempt=H,this.handled=G,this.type=3}}e.$_k=j;class U extends g.$Sc{static triggerPermanentFailure(V,le,H){this._permanentFailure=!0,this.f=V,this.g=le,this.h=H,this.j.forEach(G=>G.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(V=>V.y())}static debugPauseSocketWriting(){this.j.forEach(V=>V.F())}get n(){return this.c||U._permanentFailure}constructor(V,le,H,G,Y){super(),this.t=V,this.u=le,this.reconnectionToken=H,this.protocol=G,this.w=Y,this.m=this.B(new A.$Od),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new N(this.reconnectionToken,0,0)),this.B(G.onSocketClose(X=>{const be=_(this.t,this.reconnectionToken,!0);X?X.type===0?(this.u.logService.info(`${be} received socket close event (hadError: ${X.hadError}).`),X.error&&this.u.logService.error(X.error)):(this.u.logService.info(`${be} received socket close event (wasClean: ${X.wasClean}, code: ${X.code}, reason: ${X.reason}).`),X.event&&this.u.logService.error(X.event)):this.u.logService.info(`${be} received socket close event.`),this.y()})),this.B(G.onSocketTimeout(X=>{const be=_(this.t,this.reconnectionToken,!0);this.u.logService.info(`${be} received socket timeout event (unacknowledgedMsgCount: ${X.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${X.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${X.timeSinceLastReceivedSomeData}).`),this.y()})),U.j.push(this),this.B((0,g.$Qc)(()=>{const X=U.j.indexOf(this);X>=0&&U.j.splice(X,1)})),this.n&&this.D(U.f,U.g,U.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const V=_(this.t,this.reconnectionToken,!0);this.u.logService.info(`${V} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new O(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const le=[0,5,5,10,10,10,10,10,30];let H=-1;do{H++;const G=H<le.length?le[H]:le[le.length-1];try{if(G>0){const X=I(G);this.m.fire(new F(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),G,X)),this.u.logService.info(`${V} waiting for ${G} seconds before reconnecting...`);try{await X}catch{}}if(this.n){this.u.logService.error(`${V} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new T(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),H+1)),this.u.logService.info(`${V} resolving connection...`);const Y=await v(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${V} connecting to ${Y.connectTo}...`),await this.G(Y,u(D)),this.u.logService.info(`${V} reconnected!`),this.m.fire(new N(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),H+1));break}catch(Y){if(Y.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${V} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(Y),this.C(this.protocol.getMillisSinceLastIncomingData(),H+1,!1);break}if(H>360){this.u.logService.error(`${V} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(Y),this.C(this.protocol.getMillisSinceLastIncomingData(),H+1,!1);break}if(p.$Tk.isTemporarilyNotAvailable(Y)){this.u.logService.info(`${V} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(Y);continue}if((Y.code==="ETIMEDOUT"||Y.code==="ENETUNREACH"||Y.code==="ECONNREFUSED"||Y.code==="ECONNRESET")&&Y.syscall==="connect"){this.u.logService.info(`${V} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(Y);continue}if((0,L.$4)(Y)){this.u.logService.info(`${V} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(Y);continue}if(Y instanceof p.$Tk){this.u.logService.error(`${V} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(Y),this.C(this.protocol.getMillisSinceLastIncomingData(),H+1,p.$Tk.isHandled(Y));break}this.u.logService.error(`${V} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(Y),this.C(this.protocol.getMillisSinceLastIncomingData(),H+1,!1);break}}while(!this.n&&!this.s)}C(V,le,H){this.w?U.triggerPermanentFailure(V,le,H):this.D(V,le,H)}D(V,le,H){this.m.fire(new j(this.reconnectionToken,V,le,H)),x(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$al=U,U._permanentFailure=!1,U.f=0,U.g=0,U.h=!1,U.j=[];class B extends U{constructor(V,le,H,G,Y){super(1,V,G,Y,!0),this.client=this.B(new P.$Ch(Y,{remoteAuthority:le,clientId:H},V.ipcLogger))}async G(V,le){await n(V,le)}}e.$bl=B;class he extends U{constructor(V,le,H,G,Y){super(2,V,H,G,!1),this.H=le,this.debugPort=Y}async G(V,le){await r(V,this.H,le)}}e.$cl=he;function x(fe){try{fe.acceptDisconnect();const V=fe.getSocket();fe.dispose(),V.dispose()}catch(V){(0,L.$1)(V)}}function Q(fe){if(fe&&fe.type==="error"){const V=new Error(`Connection error: ${fe.reason}`);return V.code="VSCODE_CONNECTION_ERROR",V}return null}function Z(fe,V){for(;fe.length<V;)fe+=" ";return fe}function ie(fe,V){return`[remote-connection][${Z(h(fe),13)}][${V.substr(0,5)}\u2026]`}function _(fe,V,le){return`${ie(fe,V)}[${le?"reconnect":"initial"}]`}function oe(fe,V){return`${_(V,fe.reconnectionToken,!!fe.reconnectionProtocol)}[${fe.connectTo}]`}function ye(fe){return`${Date.now()-fe} ms`}}),define(De[249],Ce([1,0,3,5]),function(re,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2k=e.$1k=void 0,e.$1k=(0,M.$Qh)("remoteSocketFactoryService");class l{constructor(){this.a={}}register(A,g){var k;return(k=this.a)[A]??(k[A]=[]),this.a[A].push(g),(0,y.$Qc)(()=>{const $=this.a[A]?.indexOf(g);typeof $=="number"&&$>=0&&this.a[A]?.splice($,1)})}b(A){return(this.a[A.type]||[]).find(k=>k.supports(A))}connect(A,g,k,$){const R=this.b(A);if(!R)throw new Error(`No socket factory found for ${A}`);return R.connect(A,g,k,$)}}e.$2k=l}),define(De[250],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T3b=void 0;class y{constructor(){this.b=new Map}async createNewMessage(l){try{const L=await this.c();if(L){const A=String(y.a++);return this.b.set(A,L),{id:A,data:L.createNewMessage(l)}}}catch{}return{id:"",data:l}}async validate(l,L){if(!l.id)return!0;const A=this.b.get(l.id);if(!A)return!1;this.b.delete(l.id);try{return A.validate(L)==="ok"}catch{return!1}finally{A.dispose?.()}}async sign(l){try{return await this.d(l)}catch{}return l}}e.$T3b=y,y.a=1}),define(De[106],Ce([1,0,5]),function(re,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4k=e.$3k=void 0,e.$3k="signService",e.$4k=(0,y.$Qh)(e.$3k)}),define(De[139],Ce([1,0,250]),function(re,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$N8b=void 0;class M extends y.$T3b{c(){return this.h().then(L=>new L.validator)}d(L){return this.h().then(A=>new A.signer().sign(L))}h(){return new Promise((L,A)=>re(["vsda"],L,A))}}e.$N8b=M}),define(De[251],Ce([1,0,12,48,31]),function(re,e,y,M,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$no=e.$mo=void 0;function L(k){if(y.$o===2&&/^penguin(\.|$)/i.test(k))return"chromebook"}function A(k,$,R,P,p,S,D,E,h){const u=Object.create(null);u["common.machineId"]=S,u["common.sqmId"]=D,u.sessionID=(0,l.$fg)()+Date.now(),u.commitHash=P,u.version=p,u["common.platformVersion"]=(k||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),u["common.platform"]=(0,y.$c)(y.$o),u["common.nodePlatform"]=M.$dc,u["common.nodeArch"]=R,u["common.product"]=h||"desktop",E&&(u["common.msftInternal"]=E);let d=0;const c=Date.now();Object.defineProperties(u,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-c,enumerable:!0},"common.sequence":{get:()=>d++,enumerable:!0}}),y.$g&&(u["common.snap"]="true");const f=L($);return f&&(u["common.platformDetail"]=f),u}e.$mo=A;function g(k){const $=M.env.USERDNSDOMAIN;if(!$)return!1;const R=$.toLowerCase();return k.some(P=>R===P)}e.$no=g}),define(De[252],Ce([1,0,5]),function(re,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$nl=e.$ml=e.$ll=e.$kl=e.$jl=e.$il=e.$hl=e.$gl=e.$fl=e.$el=e.$dl=void 0,e.$dl=(0,y.$Qh)("telemetryService"),e.$el=(0,y.$Qh)("customEndpointTelemetryService"),e.$fl="telemetry.currentSessionDate",e.$gl="telemetry.firstSessionDate",e.$hl="telemetry.lastSessionDate",e.$il="telemetry.machineId",e.$jl="telemetry.sqmId",e.$kl="telemetry",e.$ll="telemetry.telemetryLevel",e.$ml="telemetry.enableCrashReporter",e.$nl="telemetry.enableTelemetry";var M;(function(L){L[L.NONE=0]="NONE",L[L.CRASH=1]="CRASH",L[L.ERROR=2]="ERROR",L[L.USAGE=3]="USAGE"})(M||(e.TelemetryLevel=M={}));var l;(function(L){L.OFF="off",L.CRASH="crash",L.ERROR="error",L.ON="all"})(l||(e.TelemetryConfiguration=l={}))}),define(De[85],Ce([1,0,24,17,4,50,66,251,252]),function(re,e,y,M,l,L,A,g,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Do=e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=e.$oo=void 0;class ${constructor(r){this.value=r,this.isTrustedTelemetryValue=!0}}e.$oo=$;class R{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$po=R,e.$qo=new R;class P{async publicLog(r,o,v){}async publicLogError(r,o,v){}}e.$ro=P,e.$so="telemetry",e.$to="extensionTelemetryLog",e.$uo={log:()=>null,flush:()=>Promise.resolve(null)};function p(n,r){return l.Event.debounce(r.onDidChangeConfiguration,(v,C)=>{const w=v?new Set([...v.affectedKeys,...C.affectedKeys]):C.affectedKeys;return{...C,affectedKeys:w}},1e3,!0)(v=>{v.source!==7&&n.publicLog2("updateConfiguration",{configurationSource:(0,L.$ni)(v.source),configurationKeys:Array.from(v.affectedKeys)})})}e.$vo=p;function S(n,r){return!r.isBuilt&&!r.disableTelemetry?!0:!(r.disableTelemetry||!n.enableTelemetry)}e.$wo=S;function D(n,r){return r.extensionTestsLocationURI?!0:!(r.isBuilt||r.disableTelemetry||n.enableTelemetry&&n.aiConfig?.ariaKey)}e.$xo=D;function E(n){const r=n.getValue(k.$ll),o=n.getValue(k.$ml);if(n.getValue(k.$nl)===!1||o===!1)return 0;switch(r??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$yo=E;function h(n){const r={},o={},v={};c(n,v);for(let C in v){C=C.length>150?C.substr(C.length-149):C;const w=v[C];typeof w=="number"?o[C]=w:typeof w=="boolean"?o[C]=w?1:0:typeof w=="string"?(w.length>8192&&console.warn(`Telemetry property: ${C} has been trimmed to 8192, the original length is ${w.length}`),r[C]=w.substring(0,8191)):typeof w<"u"&&w!==null&&(r[C]=w)}return{properties:r,measurements:o}}e.$zo=h;const u=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function d(n){if(!n)return"none";const r=(0,A.$Wk)(n);return u.has(r)?r:"other"}e.$Ao=d;function c(n,r,o=0,v){if(n)for(const C of Object.getOwnPropertyNames(n)){const w=n[C],m=v?v+C:C;Array.isArray(w)?r[m]=(0,y.$bn)(w):w instanceof Date?r[m]=w.toISOString():(0,M.$Bf)(w)?o<2?c(w,r,o+1,m+"."):r[m]=(0,y.$bn)(w):r[m]=w}}function f(n,r){const o=n.msftInternalDomains||[],v=r.getValue("telemetry.internalTesting");return(0,g.$no)(o)||v}e.$Bo=f;function a(n){return[n.appRoot,n.extensionsPath,n.userHome.fsPath,n.tmpDir.fsPath,n.userDataPath]}e.$Co=a;function t(n,r){if(!n||!n.includes("/")&&!n.includes("\\"))return n;let o=n;const v=[];for(const b of r)for(;;){const I=b.exec(n);if(!I)break;v.push([I.index,b.lastIndex])}const C=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,w=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let m=0;for(o="";;){const b=w.exec(n);if(!b)break;const I=v.some(([z,O])=>b.index<O&&z<w.lastIndex);!C.test(b[0])&&!I&&(o+=n.substring(m,b.index)+"<REDACTED: user-file-path>",m=w.lastIndex)}return m<n.length&&(o+=n.substr(m)),o}function i(n){if(!n)return n;const r=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const o of r)if(o.regex.test(n))return`<REDACTED: ${o.label}>`;return n}function s(n,r){return(0,y.$$m)(n,o=>{if(o instanceof $||Object.hasOwnProperty.call(o,"isTrustedTelemetryValue"))return o.value;if(typeof o=="string"){let v=o.replaceAll("%20"," ");v=t(v,r);for(const C of r)v=v.replace(C,"");return v=i(v),v}})}e.$Do=s}),define(De[253],Ce([1,0,16,133,25,12,2,9,48,85]),function(re,e,y,M,l,L,A,g,k,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Po=e.$Oo=e.$No=e.$Mo=e.$Lo=e.$Ko=e.$Jo=e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=void 0;function R(s,n){return s.uuid&&n.uuid?s.uuid===n.uuid:s.id===n.id?!0:(0,y.$Xe)(s.id,n.id)===0}e.$Eo=R;const P=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class p{static create(n){const r=n.manifest?n.manifest.version:n.version,o=n.manifest?n.targetPlatform:n.properties.targetPlatform;return new p(n.identifier,r,o)}static parse(n){const r=P.exec(n);return r&&r[1]&&r[2]?new p({id:r[1]},r[2],r[4]||void 0):null}constructor(n,r,o="undefined"){this.version=r,this.targetPlatform=o,this.id=n.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(n){return n instanceof p?R(this,n)&&this.version===n.version&&this.targetPlatform===n.targetPlatform:!1}}e.$Fo=p;const S=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function D(s){const n=S.exec(s);return n&&n[1]?[h(n[1]),n[2]]:[h(s),void 0]}e.$Go=D;function E(s,n){return`${s}.${n}`}e.$Ho=E;function h(s){return s.toLowerCase()}e.$Io=h;function u(s,n){return h(E(s??l.$4l,n))}e.$Jo=u;function d(s,n){const r=[],o=v=>{for(const C of r)if(C.some(w=>R(n(w),n(v))))return C;return null};for(const v of s){const C=o(v);C?C.push(v):r.push([v])}return r}e.$Ko=d;function c(s){return{id:s.identifier.id,name:s.manifest.name,galleryId:null,publisherId:s.publisherId,publisherName:s.manifest.publisher,publisherDisplayName:s.publisherDisplayName,dependencies:s.manifest.extensionDependencies&&s.manifest.extensionDependencies.length>0}}e.$Lo=c;function f(s){return{id:new $.$oo(s.identifier.id),name:new $.$oo(s.name),galleryId:s.identifier.uuid,publisherId:s.publisherId,publisherName:s.publisher,publisherDisplayName:s.publisherDisplayName,isPreReleaseVersion:s.properties.isPreReleaseVersion,dependencies:!!(s.properties.dependencies&&s.properties.dependencies.length>0),isSigned:s.isSigned,...s.telemetryData}}e.$Mo=f,e.$No=new l.$8l("pprice.better-merge");function a(s,n){const r=[],o=n.manifest.extensionDependencies?.slice(0)??[];for(;o.length;){const v=o.shift();if(v&&r.every(C=>!R(C.identifier,{id:v}))){const C=s.filter(w=>R(w.identifier,{id:v}));C.length===1&&(r.push(C[0]),o.push(...C[0].manifest.extensionDependencies?.slice(0)??[]))}}return r}e.$Oo=a;async function t(s,n){if(!L.$f)return!1;let r;try{r=(await s.readFile(A.URI.file("/etc/os-release"))).value.toString()}catch{try{r=(await s.readFile(A.URI.file("/usr/lib/os-release"))).value.toString()}catch(v){n.debug("Error while getting the os-release file.",(0,g.$0)(v))}}return!!r&&(r.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function i(s,n){const r=await t(s,n),o=(0,M.$$n)(r?"alpine":L.$o,k.$ec);return n.debug("ComputeTargetPlatform:",o),o}e.$Po=i}),define(De[254],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ur=e.$tr=e.$sr=e.$rr=e.$qr=e.$pr=void 0;function y(k){return[...k.entries()]}e.$pr=y;function M(k){return k?[...k.entries()]:[]}e.$qr=M;function l(k){return new Map(k)}e.$rr=l;function L(k){return new Map(k??[])}e.$sr=L;function A(k){return Array.from(k.entries()).map($=>[$[0],y($[1].map),M($[1].descriptionMap)])}e.$tr=A;function g(k){return new Map(k.map($=>[$[0],{map:l($[1]),descriptionMap:L($[2])}]))}e.$ur=g}),define(De[255],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$clb=void 0;class y{constructor(l){this.b=l,this.a=new Map}dispose(){for(const l of this.a.values())l.dispose()}startBuffering(l,L,A=5){const g=L(k=>{const $=typeof k=="string"?k:k.data;let R=this.a.get(l);if(R){R.data.push($);return}const P=setTimeout(()=>this.flushBuffer(l),A);R={data:[$],timeoutId:P,dispose:()=>{clearTimeout(P),this.flushBuffer(l),g.dispose()}},this.a.set(l,R)});return g}stopBuffering(l){this.a.get(l)?.dispose()}flushBuffer(l){const L=this.a.get(l);L&&(this.a.delete(l),this.b(l,L.data.join("")))}}e.$clb=y}),define(De[256],Ce([1,0,8,79,59,4,17,2,199,105,43]),function(re,e,y,M,l,L,A,g,k,$,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fw=e.$ew=e.$dw=e.$cw=e.$bw=e.$aw=e.$_v=e.$$v=e.IconFontDefinition=e.IconContribution=e.$0v=void 0,e.$0v={IconContribution:"base.contributions.icons"};var P;(function(f){function a(t,i){let s=t.defaults;for(;l.ThemeIcon.isThemeIcon(s);){const n=D.getIcon(s.id);if(!n)return;s=n.defaults}return s}f.getDefinition=a})(P||(e.IconContribution=P={}));var p;(function(f){function a(i){return{weight:i.weight,style:i.style,src:i.src.map(s=>({format:s.format,location:s.location.toString()}))}}f.toJSONObject=a;function t(i){const s=n=>(0,A.$zf)(n)?n:void 0;if(i&&Array.isArray(i.src)&&i.src.every(n=>(0,A.$zf)(n.format)&&(0,A.$zf)(n.location)))return{weight:s(i.weight),style:s(i.style),src:i.src.map(n=>({format:n.format,location:g.URI.parse(n.location)}))}}f.fromJSONObject=t})(p||(e.IconFontDefinition=p={}));class S{constructor(){this.a=new L.$Od,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,k.localize)(0,null)},fontCharacter:{type:"string",description:(0,k.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${l.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(a,t,i,s){const n=this.b[a];if(n){if(i&&!n.description){n.description=i,this.d.properties[a].markdownDescription=`${i} $(${a})`;const v=this.e.enum.indexOf(a);v!==-1&&(this.e.enumDescriptions[v]=i),this.a.fire()}return n}const r={id:a,description:i,defaults:t,deprecationMessage:s};this.b[a]=r;const o={$ref:"#/definitions/icons"};return s&&(o.deprecationMessage=s),i&&(o.markdownDescription=`${i}: $(${a})`),this.d.properties[a]=o,this.e.enum.push(a),this.e.enumDescriptions.push(i||""),this.a.fire(),{id:a}}deregisterIcon(a){delete this.b[a],delete this.d.properties[a];const t=this.e.enum.indexOf(a);t!==-1&&(this.e.enum.splice(t,1),this.e.enumDescriptions.splice(t,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(a=>this.b[a])}getIcon(a){return this.b[a]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(a,t){const i=this.f[a];return i||(this.f[a]=t,this.a.fire(),t)}deregisterIconFont(a){delete this.f[a]}getIconFont(a){return this.f[a]}toString(){const a=(n,r)=>n.id.localeCompare(r.id),t=n=>{for(;l.ThemeIcon.isThemeIcon(n.defaults);)n=this.b[n.defaults.id];return`codicon codicon-${n?n.id:""}`},i=[];i.push("| preview     | identifier                        | default codicon ID                | description"),i.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const s=Object.keys(this.b).map(n=>this.b[n]);for(const n of s.filter(r=>!!r.description).sort(a))i.push(`|<i class="${t(n)}"></i>|${n.id}|${l.ThemeIcon.isThemeIcon(n.defaults)?n.defaults.id:n.id}|${n.description||""}|`);i.push("| preview     | identifier                        "),i.push("| ----------- | --------------------------------- |");for(const n of s.filter(r=>!l.ThemeIcon.isThemeIcon(r.defaults)).sort(a))i.push(`|<i class="${t(n)}"></i>|${n.id}|`);return i.join(`
`)}}const D=new S;R.$ln.add(e.$0v.IconContribution,D);function E(f,a,t,i){return D.registerIcon(f,a,t,i)}e.$$v=E;function h(){return D}e.$_v=h;function u(){const f=(0,M.$Tj)();for(const a in f){const t="\\"+f[a].toString(16);D.registerIcon(a,{fontCharacter:t})}}u(),e.$aw="vscode://schemas/icons";const d=R.$ln.as($.$mn.JSONContribution);d.registerSchema(e.$aw,D.getIconSchema());const c=new y.$7g(()=>d.notifySchemaChanged(e.$aw),200);D.onDidChange(()=>{c.isScheduled()||c.schedule()}),e.$bw=E("widget-close",M.$Vj.close,(0,k.localize)(2,null)),e.$cw=E("goto-previous-location",M.$Vj.arrowUp,(0,k.localize)(3,null)),e.$dw=E("goto-next-location",M.$Vj.arrowDown,(0,k.localize)(4,null)),e.$ew=l.ThemeIcon.modify(M.$Vj.sync,"spin"),e.$fw=l.ThemeIcon.modify(M.$Vj.loading,"spin")}),define(De[86],Ce([1,0,4,50,5,14]),function(re,e,y,M,l,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mv=e.$lv=e.$kv=e.$jv=e.$iv=e.$hv=e.$gv=e.$fv=e.ProvidedOnAutoForward=e.$ev=e.TunnelPrivacyId=e.TunnelProtocol=e.$dv=e.$cv=void 0,e.$cv=(0,l.$Qh)("tunnelService"),e.$dv=(0,l.$Qh)("sharedTunnelsService");var A;(function(h){h.Http="http",h.Https="https"})(A||(e.TunnelProtocol=A={}));var g;(function(h){h.ConstantPrivate="constantPrivate",h.Private="private",h.Public="public"})(g||(e.TunnelPrivacyId=g={}));function k(h){return!!h.forwardPort}e.$ev=k;var $;(function(h){h[h.Notify=1]="Notify",h[h.OpenBrowser=2]="OpenBrowser",h[h.OpenPreview=3]="OpenPreview",h[h.Silent=4]="Silent",h[h.Ignore=5]="Ignore",h[h.OpenBrowserOnce=6]="OpenBrowserOnce"})($||(e.ProvidedOnAutoForward=$={}));function R(h){if(h.scheme!=="http"&&h.scheme!=="https")return;const u=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(h.authority);if(u)return{address:u[1],port:+u[2]}}e.$fv=R,e.$gv=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function P(h){return e.$gv.indexOf(h)>=0}e.$hv=P,e.$iv=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function p(h){return e.$iv.indexOf(h)>=0}e.$jv=p;function S(h,u,d,c){if(d===1)return!1;if(d===2&&p(u)){const f=/(\d+)\.(\d+)\.(\d+)/g.exec(c);if(f?.length===4&&parseInt(f[1])>=18)return!1}return h<1024}e.$kv=S;class D{constructor(u,d,c){this.remoteAddress=u,this.localAddress=d,this.b=c,this.a=new y.$Od,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$lv=D;let E=class{constructor(u,d){this.j=u,this.k=d,this.a=new y.$Od,this.onTunnelOpened=this.a.event,this.b=new y.$Od,this.onTunnelClosed=this.b.event,this.c=new y.$Od,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=[],this.i=new Set}get hasTunnelProvider(){return!!this.f}get l(){const u=this.k.getValue("remote.localPortHost");return!u||u==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(u){return this.f=u,u?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.h=[]}}):(this.g=!1,this.h=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(u){this.g=u.elevation,this.h=u.privacyOptions}get canElevate(){return this.g}get canChangePrivacy(){return this.h.length>0}get privacyOptions(){return this.h}get tunnels(){return this.m()}async m(){const u=[],d=Array.from(this.e.values());for(const c of d){const f=Array.from(c.values());for(const a of f){const t=await a.value;t&&typeof t!="string"&&u.push(t)}}return u}async dispose(){for(const u of this.e.values()){for(const{value:d}of u.values())await d.then(c=>typeof c!="string"?c?.dispose():void 0);u.clear()}this.e.clear()}setEnvironmentTunnel(u,d,c,f,a){this.p(u,d,Promise.resolve({tunnelRemoteHost:u,tunnelRemotePort:d,localAddress:c,privacy:f,protocol:a,dispose:()=>Promise.resolve()}))}async getExistingTunnel(u,d){(p(u)||P(u))&&(u=e.$gv[0]);const c=this.r(u,d);if(c)return++c.refcount,c.value}openTunnel(u,d,c,f,a,t=!1,i,s){this.j.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${d}:${c} on local port ${a}.`);const n=this.f??u;if(!n)return;if(d||(d="localhost"),f||(f=this.l),this.f&&this.i.has(c)){this.j.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const r=this.s(n,d,c,f,a,t,i,s);return r?r.then(o=>{if(o){if(typeof o=="string")return this.j.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.q(d,c),o}else{this.j.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.q(d,c);return}this.j.trace("ForwardedPorts: (TunnelService) New tunnel established.");const v=this.n(o);return(o.tunnelRemoteHost!==d||o.tunnelRemotePort!==c)&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),i&&o.privacy!==i&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(v),v}):(this.j.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),r)}n(u){return{tunnelRemotePort:u.tunnelRemotePort,tunnelRemoteHost:u.tunnelRemoteHost,tunnelLocalPort:u.tunnelLocalPort,localAddress:u.localAddress,privacy:u.privacy,protocol:u.protocol,dispose:async()=>{this.j.trace(`ForwardedPorts: (TunnelService) dispose request for ${u.tunnelRemoteHost}:${u.tunnelRemotePort} `);const d=this.e.get(u.tunnelRemoteHost);if(d){const c=d.get(u.tunnelRemotePort);c&&(c.refcount--,await this.o(u.tunnelRemoteHost,u.tunnelRemotePort,c))}}}}async o(u,d,c){if(c.refcount<=0){this.j.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${u}:${d}.`);const f=c.value.then(async a=>{a&&typeof a!="string"&&(await a.dispose(!0),this.b.fire({host:a.tunnelRemoteHost,port:a.tunnelRemotePort}))});return this.e.has(u)&&this.e.get(u).delete(d),f}}async closeTunnel(u,d){this.j.trace(`ForwardedPorts: (TunnelService) close request for ${u}:${d} `);const c=this.e.get(u);if(c&&c.has(d)){const f=c.get(d);f.refcount=0,await this.o(u,d,f)}}p(u,d,c){this.e.has(u)||this.e.set(u,new Map),this.e.get(u).set(d,{refcount:1,value:c})}async q(u,d){const c=this.e.get(u);if(c){const f=c.get(d),a=f?await f.value:void 0;(!a||typeof a=="string")&&c.delete(d),c.size===0&&this.e.delete(u)}}r(u,d){const c=[u];P(u)?(c.push(...e.$gv),c.push(...e.$iv)):p(u)&&c.push(...e.$iv);const f=c.map(a=>this.e.get(a));for(const a of f){const t=a?.get(d);if(t)return t}}canTunnel(u){return!!R(u)}t(u,d,c,f,a,t,i){this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${d}:${c} on local port ${f}.`);const s=c;this.i.add(s);const n=f===void 0?c:f,r={elevationRequired:a?this.isPortPrivileged(n):!1},o={remoteAddress:{host:d,port:c},localAddressPort:f,privacy:t,public:t?t!==g.Private:void 0,protocol:i},v=u.forwardPort(o,r);return v?(this.p(d,c,v),v.finally(()=>{this.j.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.i.delete(s)})):this.i.delete(s),v}};e.$mv=E,e.$mv=E=He([We(0,L.$$i),We(1,M.$ki)],E)}),define(De[257],Ce([1,0,5]),function(re,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jk=void 0,e.$Jk=(0,y.$Qh)("IUriIdentityService")}),define(De[258],Ce([1,0,5]),function(re,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$nv=void 0,e.$nv=(0,y.$Qh)("editSessionIdentityService");var M;(function(l){l[l.Complete=100]="Complete",l[l.Partial=50]="Partial",l[l.None=0]="None"})(M||(e.EditSessionIdentityMatch=M={}))}),define(De[259],Ce([1,0,18]),function(re,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4J=e.$3J=e.$2J=e.$1J=e.$ZJ=void 0;function M(k){return k.scheme!==y.Schemas.file&&k.scheme!==y.Schemas.vscodeRemote}e.$ZJ=M;function l(k){if(k.folders.length)return k.folders.every($=>M($.uri))?k.folders[0].uri:void 0;if(k.configuration&&M(k.configuration))return k.configuration}e.$1J=l;function L(k){return l(k)?.scheme}e.$2J=L;function A(k){return l(k)?.authority}e.$3J=A;function g(k){return l(k)!==void 0}e.$4J=g}),define(De[44],Ce([1,0,201,15,78,23,2,5,18]),function(re,e,y,M,l,L,A,g,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ji=e.$ii=e.$hi=e.$gi=e.$fi=e.$ei=e.$di=e.$ci=e.$bi=e.$ai=e.$_h=e.$$h=e.$0h=e.$9h=e.$8h=e.WorkbenchState=e.$7h=e.$6h=e.$5h=e.$4h=e.$3h=e.$2h=e.$1h=e.$Zh=void 0,e.$Zh=(0,g.$Qh)("contextService");function $(n){const r=n;return typeof r?.id=="string"&&A.URI.isUri(r.uri)}e.$1h=$;function R(n){return typeof n?.id=="string"&&!$(n)&&!p(n)}e.$2h=R,e.$3h={id:"ext-dev"},e.$4h={id:"empty-window"};function P(n,r){if(typeof n=="string"||typeof n>"u")return typeof n=="string"?{id:(0,M.$nc)(n)}:r?e.$3h:e.$4h;const o=n;return o.configuration?{id:o.id,configPath:o.configuration}:o.folders.length===1?{id:o.id,uri:o.folders[0].uri}:{id:o.id}}e.$5h=P;function p(n){const r=n;return typeof r?.id=="string"&&A.URI.isUri(r.configPath)}e.$6h=p;function S(n){const r=n;if(r?.uri)return{id:r.id,uri:A.URI.revive(r.uri)};const o=n;if(o?.configPath)return{id:o.id,configPath:A.URI.revive(o.configPath)};if(n?.id)return{id:n.id}}e.$7h=S;var D;(function(n){n[n.EMPTY=1]="EMPTY",n[n.FOLDER=2]="FOLDER",n[n.WORKSPACE=3]="WORKSPACE"})(D||(e.WorkbenchState=D={}));function E(n){const r=n;return!!(r&&typeof r=="object"&&typeof r.id=="string"&&Array.isArray(r.folders))}e.$8h=E;function h(n){const r=n;return!!(r&&typeof r=="object"&&A.URI.isUri(r.uri)&&typeof r.name=="string"&&typeof r.toResource=="function")}e.$9h=h;class u{constructor(r,o,v,C,w){this.h=r,this.j=v,this.k=C,this.l=w,this.c=l.$Wh.forUris(this.l,()=>!0),this.folders=o}update(r){this.h=r.id,this.k=r.configuration,this.j=r.transient,this.l=r.l,this.folders=r.folders}get folders(){return this.g}set folders(r){this.g=r,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(r){this.k=r}getFolder(r){return r&&this.c.findSubstr(r)||null}n(){this.c=l.$Wh.forUris(this.l,()=>!0);for(const r of this.folders)this.c.set(r.uri,r)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$0h=u;class d{constructor(r,o){this.raw=o,this.uri=r.uri,this.index=r.index,this.name=r.name}toResource(r){return(0,L.$wg)(this.uri,r)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$$h=d;function c(n){return new d({uri:n,index:0,name:(0,L.$sg)(n)},{uri:n.toString()})}e.$_h=c,e.$ai="code-workspace",e.$bi=`.${e.$ai}`,e.$ci=[{name:(0,y.localize)(0,null),extensions:[e.$ai]}],e.$di="workspace.json";function f(n,r){return L.$ng.isEqualOrParent(n,r.untitledWorkspacesHome)}e.$ei=f;function a(n){let r;return A.URI.isUri(n)?r=n:r=n.configuration,r?.scheme===k.Schemas.tmp}e.$fi=a,e.$gi="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(n){return n.id===e.$gi}e.$hi=t;function i(n,r){return!f(n,r)&&!a(n)}e.$ii=i;function s(n){return(typeof n=="string"?(0,M.$oc)(n):(0,L.$ug)(n))===e.$bi}e.$ji=s}),define(De[260],Ce([1,0,52,4,3,23,2,200,132,30,5,14,44,28,257,8,31,16,17]),function(re,e,y,M,l,L,A,g,k,$,R,P,p,S,D,E,h,u,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pk=e.$Ok=e.$Nk=e.$Mk=e.$Lk=e.$Kk=e.ProfileResourceType=void 0;var c;(function(n){n.Settings="settings",n.Keybindings="keybindings",n.Snippets="snippets",n.Tasks="tasks",n.Extensions="extensions",n.GlobalState="globalState"})(c||(e.ProfileResourceType=c={}));function f(n){const r=n;return!!(r&&typeof r=="object"&&typeof r.id=="string"&&typeof r.isDefault=="boolean"&&typeof r.name=="string"&&A.URI.isUri(r.location)&&A.URI.isUri(r.globalStorageHome)&&A.URI.isUri(r.settingsResource)&&A.URI.isUri(r.keybindingsResource)&&A.URI.isUri(r.tasksResource)&&A.URI.isUri(r.snippetsHome)&&A.URI.isUri(r.extensionsResource))}e.$Kk=f,e.$Lk=(0,R.$Qh)("IUserDataProfilesService");function a(n,r){return{id:n.id,isDefault:n.isDefault,name:n.name,shortName:n.shortName,icon:n.icon,location:A.URI.revive(n.location).with({scheme:r}),globalStorageHome:A.URI.revive(n.globalStorageHome).with({scheme:r}),settingsResource:A.URI.revive(n.settingsResource).with({scheme:r}),keybindingsResource:A.URI.revive(n.keybindingsResource).with({scheme:r}),tasksResource:A.URI.revive(n.tasksResource).with({scheme:r}),snippetsHome:A.URI.revive(n.snippetsHome).with({scheme:r}),extensionsResource:A.URI.revive(n.extensionsResource).with({scheme:r}),cacheHome:A.URI.revive(n.cacheHome).with({scheme:r}),useDefaultFlags:n.useDefaultFlags,isTransient:n.isTransient}}e.$Mk=a;function t(n,r,o,v,C,w){return{id:n,name:r,location:o,isDefault:!1,shortName:C?.shortName,icon:C?.icon,globalStorageHome:w&&C?.useDefaultFlags?.globalState?w.globalStorageHome:(0,L.$wg)(o,"globalStorage"),settingsResource:w&&C?.useDefaultFlags?.settings?w.settingsResource:(0,L.$wg)(o,"settings.json"),keybindingsResource:w&&C?.useDefaultFlags?.keybindings?w.keybindingsResource:(0,L.$wg)(o,"keybindings.json"),tasksResource:w&&C?.useDefaultFlags?.tasks?w.tasksResource:(0,L.$wg)(o,"tasks.json"),snippetsHome:w&&C?.useDefaultFlags?.snippets?w.snippetsHome:(0,L.$wg)(o,"snippets"),extensionsResource:w&&C?.useDefaultFlags?.extensions?w.extensionsResource:(0,L.$wg)(o,"extensions.json"),cacheHome:(0,L.$wg)(v,n),useDefaultFlags:C?.useDefaultFlags,isTransient:C?.transient}}e.$Nk=t;let i=class extends l.$Sc{get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(r,o,v,C){super(),this.t=r,this.u=o,this.w=v,this.y=C,this.f=!0,this.h=this.B(new M.$Od),this.onDidChangeProfiles=this.h.event,this.j=this.B(new M.$Od),this.onWillCreateProfile=this.j.event,this.m=this.B(new M.$Od),this.onWillRemoveProfile=this.m.event,this.n=this.B(new M.$Od),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new S.$Ac,emptyWindows:new Map},this.profilesHome=(0,L.$wg)(this.t.userRoamingDataHome,"profiles"),this.g=(0,L.$wg)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(r){this.f!==r&&(this.z=void 0,this.f=r)}isEnabled(){return this.f}get C(){if(!this.z){const r=this.D(),o=[r];if(this.f)try{for(const w of this.O()){if(!w.name||!(0,d.$zf)(w.name)||!w.location){this.y.warn("Skipping the invalid stored profile",w.location||w.name);continue}o.push(t((0,L.$tg)(w.location),w.name,w.location,this.g,{shortName:w.shortName,icon:w.icon,useDefaultFlags:w.useDefaultFlags},r))}}catch(w){this.y.error(w)}const v=new S.$Ac,C=new Map;if(o.length)try{const w=this.Q();if(w.workspaces)for(const[m,b]of Object.entries(w.workspaces)){const I=A.URI.parse(m),z=o.find(O=>O.id===b);z&&v.set(I,z)}if(w.emptyWindows)for(const[m,b]of Object.entries(w.emptyWindows)){const I=o.find(z=>z.id===b);I&&C.set(m,I)}}catch(w){this.y.error(w)}this.z={profiles:o,workspaces:v,emptyWindows:C}}return this.z}D(){const r=t("__default__profile__",(0,g.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...r,extensionsResource:this.S()??r.extensionsResource,isDefault:!0}}async createTransientProfile(r){const o="Temp",v=new RegExp(`${(0,u.$Ge)(o)}\\s(\\d+)`);let C=0;for(const m of this.profiles){const b=v.exec(m.name),I=b?parseInt(b[1]):0;C=I>C?I:C}const w=`${o} ${C+1}`;return this.createProfile((0,y.$Ei)((0,h.$fg)()).toString(16),w,{transient:!0},r)}async createNamedProfile(r,o,v){return this.createProfile((0,y.$Ei)((0,h.$fg)()).toString(16),r,o,v)}async createProfile(r,o,v,C){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const w=await this.F(r,o,v);return C&&await this.setProfileForWorkspace(C,w),w}async F(r,o,v){if(!(0,d.$zf)(o)||!o)throw new Error("Name of the profile is mandatory and must be of type `string`");let C=this.r.get(o);return C||(C=(async()=>{try{const w=this.profiles.find(I=>I.name===o||I.id===r);if(w)return w;const m=t(r,o,(0,L.$wg)(this.profilesHome,r),this.g,v,this.defaultProfile);await this.u.createFolder(m.location);const b=[];return this.j.fire({profile:m,join(I){b.push(I)}}),await E.Promises.settled(b),this.I([m],[],[]),m}finally{this.r.delete(o)}})(),this.r.set(o,C)),C}async updateProfile(r,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let v=this.profiles.find(C=>C.id===r.id);if(!v)throw new Error(`Profile '${r.name}' does not exist`);return v=t(v.id,o.name??v.name,v.location,this.g,{shortName:o.shortName??v.shortName,icon:o.icon===null?void 0:o.icon??v.icon,transient:o.transient??v.isTransient,useDefaultFlags:o.useDefaultFlags??v.useDefaultFlags},this.defaultProfile),this.I([],[],[v]),v}async removeProfile(r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(r.isDefault)throw new Error("Cannot remove default profile");const o=this.profiles.find(C=>C.id===r.id);if(!o)throw new Error(`Profile '${r.name}' does not exist`);const v=[];this.m.fire({profile:o,join(C){v.push(C)}});try{await Promise.allSettled(v)}catch(C){this.y.error(C)}for(const C of[...this.C.emptyWindows.keys()])o.id===this.C.emptyWindows.get(C)?.id&&this.C.emptyWindows.delete(C);for(const C of[...this.C.workspaces.keys()])o.id===this.C.workspaces.get(C)?.id&&this.C.workspaces.delete(C);this.M(),this.I([],[o],[]);try{await this.u.del(o.cacheHome,{recursive:!0})}catch(C){(0,$.$qk)(C)!==1&&this.y.error(C)}}async setProfileForWorkspace(r,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const v=this.profiles.find(C=>C.id===o.id);if(!v)throw new Error(`Profile '${o.name}' does not exist`);this.L(r,v)}unsetWorkspace(r,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(r,void 0,o)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const r=await this.u.resolve(this.profilesHome);await Promise.all((r.children||[]).filter(o=>o.isDirectory&&this.profiles.every(v=>!this.w.extUri.isEqual(v.location,o.resource))).map(o=>this.u.del(o.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const r=this.s.profiles.filter(o=>!this.H(o));await Promise.allSettled(r.map(o=>this.removeProfile(o)))}getProfileForWorkspace(r){const o=this.G(r);return A.URI.isUri(o)?this.s.workspaces.get(o)??this.C.workspaces.get(o):this.s.emptyWindows.get(o)??this.C.emptyWindows.get(o)}G(r){return(0,p.$1h)(r)?r.uri:(0,p.$6h)(r)?r.configPath:r.id}H(r){return!!([...this.s.emptyWindows.values()].some(o=>this.w.extUri.isEqual(o.location,r.location))||[...this.s.workspaces.values()].some(o=>this.w.extUri.isEqual(o.location,r.location))||[...this.C.emptyWindows.values()].some(o=>this.w.extUri.isEqual(o.location,r.location))||[...this.C.workspaces.values()].some(o=>this.w.extUri.isEqual(o.location,r.location)))}I(r,o,v){const C=[...this.profiles,...r],w=[];this.s.profiles=[];for(let m of C)m.isDefault||o.some(b=>m.id===b.id)||(m=v.find(b=>m.id===b.id)??m,m.isTransient?this.s.profiles.push(m):w.push({location:m.location,name:m.name,shortName:m.shortName,icon:m.icon,useDefaultFlags:m.useDefaultFlags}));this.P(w),this.z=void 0,this.J(r,o,v)}J(r,o,v){this.h.fire({added:r,removed:o,updated:v,all:this.profiles})}L(r,o,v){v=o?.isTransient?!0:v,v||this.L(r,void 0,!0);const C=this.G(r),w=v?this.s:this.C;A.URI.isUri(C)?(w.workspaces.delete(C),o&&w.workspaces.set(C,o)):(w.emptyWindows.delete(C),o&&w.emptyWindows.set(C,o)),v||this.M()}M(){const r={};for(const[v,C]of this.C.workspaces.entries())r[v.toString()]=C.id;const o={};for(const[v,C]of this.C.emptyWindows.entries())o[v.toString()]=C.id;this.R({workspaces:r,emptyWindows:o}),this.z=void 0}N(r){const o={},v=this.D();if(r.workspaces)for(const[w,m]of Object.entries(r.workspaces)){const b=A.URI.parse(m);o[w]=this.w.extUri.isEqual(b,v.location)?v.id:this.w.extUri.basename(b)}const C={};if(r.emptyWindows)for(const[w,m]of Object.entries(r.emptyWindows)){const b=A.URI.parse(m);C[w]=this.w.extUri.isEqual(b,v.location)?v.id:this.w.extUri.basename(b)}return{workspaces:o,emptyWindows:C}}O(){return[]}P(r){throw new Error("not implemented")}Q(){return{}}R(r){throw new Error("not implemented")}S(){}};e.$Ok=i,i.b="userDataProfiles",i.c="profileAssociations",e.$Ok=i=He([We(0,k.$Xh),We(1,$.$_j),We(2,D.$Jk),We(3,P.$$i)],i);class s extends i{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(r){this.a=r}Q(){return this.X}R(r){this.X=r}}e.$Pk=s}),define(De[261],Ce([1,0,8,4,3,54,17,168,5,260]),function(re,e,y,M,l,L,A,g,k,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dp=e.$cp=e.$bp=e.$ap=e.$_o=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$$o=e.$0o=e.$9o=void 0,e.$9o="__$__isNewStorageMarker",e.$0o="__$__targetStorageMarker",e.$$o=(0,k.$Qh)("storageService");var R;(function(d){d[d.NONE=0]="NONE",d[d.SHUTDOWN=1]="SHUTDOWN"})(R||(e.WillSaveStateReason=R={}));var P;(function(d){d[d.APPLICATION=-1]="APPLICATION",d[d.PROFILE=0]="PROFILE",d[d.WORKSPACE=1]="WORKSPACE"})(P||(e.StorageScope=P={}));var p;(function(d){d[d.USER=0]="USER",d[d.MACHINE=1]="MACHINE"})(p||(e.StorageTarget=p={}));function S(d){const c=d.get(e.$0o);if(c)try{return JSON.parse(c)}catch{}return Object.create(null)}e.$_o=S;class D extends l.$Sc{constructor(c={flushInterval:D.a}){super(),this.m=c,this.b=this.B(new M.$Rd),this.c=this.B(new M.$Rd),this.onDidChangeTarget=this.c.event,this.f=this.B(new M.$Od),this.onWillSaveState=this.f.event,this.h=this.B(new y.$7g(()=>this.n(),this.m.flushInterval)),this.j=this.B(new l.$Tc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(c,f,a){return M.Event.filter(this.b.event,t=>t.scope===c&&(f===void 0||t.key===f),a)}n(){this.j.value=(0,y.$$g)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,l.$Nc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,L.mark)("code/willInitStorage");try{await this.O()}finally{(0,L.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(c,f){const{key:a,external:t}=f;if(a===e.$0o){switch(c){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:c})}else this.b.fire({scope:c,key:a,target:this.J(c)[a],external:t})}w(c){this.f.fire({reason:c})}get(c,f,a){return this.P(f)?.get(c,a)}getBoolean(c,f,a){return this.P(f)?.getBoolean(c,a)}getNumber(c,f,a){return this.P(f)?.getNumber(c,a)}getObject(c,f,a){return this.P(f)?.getObject(c,a)}storeAll(c,f){this.y(()=>{for(const a of c)this.store(a.key,a.value,a.scope,a.target,f)})}store(c,f,a,t,i=!1){if((0,A.$If)(f)){this.remove(c,a,i);return}this.y(()=>{this.z(c,a,t),this.P(a)?.set(c,f,i)})}remove(c,f,a=!1){this.y(()=>{this.z(c,f,void 0),this.P(f)?.delete(c,a)})}y(c){this.b.pause(),this.c.pause();try{c()}finally{this.b.resume(),this.c.resume()}}keys(c,f){const a=[],t=this.J(c);for(const i of Object.keys(t))t[i]===f&&a.push(i);return a}z(c,f,a,t=!1){const i=this.J(f);typeof a=="number"?i[c]!==a&&(i[c]=a,this.P(f)?.set(e.$0o,JSON.stringify(i),t)):typeof i[c]=="number"&&(delete i[c],this.P(f)?.set(e.$0o,JSON.stringify(i),t))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(c){switch(c){case-1:return this.I;case 0:return this.G;default:return this.D}}L(c){const f=this.P(c);return f?S(f):Object.create(null)}isNew(c){return this.getBoolean(e.$9o,c)===!0}async flush(c=R.NONE){this.f.fire({reason:c});const f=this.P(-1),a=this.P(0),t=this.P(1);switch(c){case R.NONE:await y.Promises.settled([f?.whenFlushed()??Promise.resolve(),a?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case R.SHUTDOWN:await y.Promises.settled([f?.flush(0)??Promise.resolve(),a?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const c=this.P(-1)?.items??new Map,f=this.P(0)?.items??new Map,a=this.P(1)?.items??new Map;return u(c,f,a,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(c){return await this.flush(),this.P(c)?.optimize()}async switch(c,f){return this.w(R.NONE),(0,$.$Kk)(c)?this.R(c,f):this.S(c,f)}M(c,f){return!(c.id===f.id||E(f)&&E(c))}N(c,f,a){this.y(()=>{const t=new Set;for(const[i,s]of c)t.add(i),f.get(i)!==s&&this.u(a,{key:i,external:!0});for(const[i]of f.items)t.has(i)||this.u(a,{key:i,external:!0})})}}e.$ap=D,D.a=60*1e3;function E(d){return d.isDefault||!!d.useDefaultFlags?.globalState}e.$bp=E;class h extends D{constructor(){super(),this.U=this.B(new g.$7o(new g.$8o,{hint:g.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new g.$7o(new g.$8o,{hint:g.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new g.$7o(new g.$8o,{hint:g.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(c=>this.u(1,c))),this.B(this.W.onDidChangeStorage(c=>this.u(0,c))),this.B(this.U.onDidChangeStorage(c=>this.u(-1,c)))}P(c){switch(c){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(c){switch(c){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(c){return!1}}e.$cp=h;async function u(d,c,f,a,t,i){const s=I=>{try{return JSON.parse(I)}catch{return I}},n=new Map,r=new Map;d.forEach((I,z)=>{n.set(z,I),r.set(z,s(I))});const o=new Map,v=new Map;c.forEach((I,z)=>{o.set(z,I),v.set(z,s(I))});const C=new Map,w=new Map;f.forEach((I,z)=>{C.set(z,I),w.set(z,s(I))}),console.group(a!==t?`Storage: Application (path: ${a})`:`Storage: Application & Profile (path: ${a}, default profile)`);const m=[];if(n.forEach((I,z)=>{m.push({key:z,value:I})}),console.table(m),console.groupEnd(),console.log(r),a!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const I=[];o.forEach((z,O)=>{I.push({key:O,value:z})}),console.table(I),console.groupEnd(),console.log(v)}console.group(`Storage: Workspace (path: ${i})`);const b=[];C.forEach((I,z)=>{b.push({key:z,value:I})}),console.table(b),console.groupEnd(),console.log(w)}e.$dp=u}),define(De[107],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ccc=void 0;class y{constructor(l){this.d=l,this.b=new Map,this.c=1}add(l){const L=this.c++;return this.b.set(L,l),this.e(),L}get(l,L){return this.b.has(l)?this.b.get(l)[L]:void 0}delete(l){this.b.delete(l),this.e()}e(){y.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$Ccc=y,y.a=!1}),define(De[55],Ce([1,0,18,23,5]),function(re,e,y,M,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fcc=e.$Ecc=void 0;class L{constructor(){this.a=new Set(Object.keys(y.Schemas)),this.b=new Map,this.extUri=new M.$lg(g=>{const k=this.b.get(g.scheme);return!(k===void 0||k&1024)})}$acceptProviderInfos(g,k){k===null?this.b.delete(g.scheme):this.b.set(g.scheme,k)}isFreeScheme(g){return!this.b.has(g)&&!this.a.has(g)}getCapabilities(g){return this.b.get(g)}}e.$Ecc=L,e.$Fcc=(0,l.$Qh)("IExtHostFileSystemInfo")}),define(De[27],Ce([1,0,5]),function(re,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HM=void 0,e.$HM=(0,y.$Qh)("IExtHostInitDataService")}),define(De[262],Ce([1,0,207,14,242,27]),function(re,e,y,M,l,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nec=void 0;let A=class extends l.$PN{constructor(k,$,R){const P=R.remote.isRemote?"remoteexthost":k?"workerexthost":"exthost",p=R.remote.isRemote?(0,y.localize)(0,null):k?(0,y.localize)(1,null):(0,y.localize)(2,null);super($.createLogger(P,{name:p}))}};e.$Nec=A,e.$Nec=A=He([We(1,M.$_i),We(2,L.$HM)],A)}),define(De[263],Ce([1,0,8]),function(re,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9cc=e.$8cc=void 0;class M{constructor(A,g,k){this.h=new Map,this.a=A,this.b=g,this.c=k,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then($=>(this.f=$,this)),this.g=this.c.onDidChangeStorage($=>{$.shared===this.b&&$.key===this.a&&(this.f=$.value)}),this.i=new y.$7g(()=>{const $=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const R of $.values())R.complete()}catch(R){for(const P of $.values())P.error(R)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,A])=>A!==void 0).map(([A])=>A)}get whenReady(){return this.d}get(A,g){let k=this.f[A];return typeof k>"u"&&(k=g),k}update(A,g){this.f[A]=g;const k=this.h.get(A);if(k!==void 0)return k.p;const $=new y.$dh;return this.h.set(A,$),this.i.isScheduled()||this.i.schedule(),$.p}dispose(){this.g.dispose()}}e.$8cc=M;class l extends M{setKeysForSync(A){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},A)}constructor(A,g){super(A.identifier.value,!0,g),this.j=A}}e.$9cc=l}),define(De[264],Ce([1,0,4,2]),function(re,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uec=void 0;class l{constructor(A){this.c=A,this.a=new y.$Od,this.onDidSaveNotebookDocument=this.a.event,this.b=new y.$Od,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(A,g,k,$){const P=this.c.getNotebookDocument(M.URI.revive(A)).acceptModelChanged(g.value,k,$);this.b.fire(P)}$acceptDirtyStateChanged(A,g){this.c.getNotebookDocument(M.URI.revive(A)).acceptDirty(g)}$acceptModelSaved(A){const g=this.c.getNotebookDocument(M.URI.revive(A));this.a.fire(g.apiNotebook)}}e.$uec=l}),define(De[20],Ce([1,0,5]),function(re,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sM=e.$rM=void 0,e.$rM=(0,y.$Qh)("IExtHostRpcService");class M{constructor(L){this.getProxy=L.getProxy.bind(L),this.set=L.set.bind(L),this.dispose=L.dispose.bind(L),this.assertRegistered=L.assertRegistered.bind(L),this.drain=L.drain.bind(L)}}e.$sM=M});var et=this&&this.__classPrivateFieldSet||function(re,e,y,M,l){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!l)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!l:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?l.call(re,y):l?l.value=y:e.set(re,y),y},Be=this&&this.__classPrivateFieldGet||function(re,e,y,M){if(y==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!M:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return y==="m"?M:y==="a"?M.call(re):M?M.value:e.get(re)};define(De[265],Ce([1,0,25,4]),function(re,e,y,M){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.$hdc=void 0;class L{constructor(g,k){l.set(this,void 0),this.b=new M.$Od,this.onDidChange=this.b.event,this.a=y.$8l.toKey(g.identifier),et(this,l,k,"f"),Be(this,l,"f").onDidChangePassword($=>{$.extensionId===this.a&&this.b.fire({key:$.key})})}get(g){return Be(this,l,"f").get(this.a,g)}store(g,k){return Be(this,l,"f").store(this.a,g,k)}delete(g){return Be(this,l,"f").delete(this.a,g)}}e.$hdc=L,l=new WeakMap}),define(De[67],Ce([1,0,5]),function(re,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qcc=e.$Pcc=void 0,e.$Pcc=(0,y.$Qh)("IURITransformerService");class M{constructor(L){L?(this.transformIncoming=L.transformIncoming.bind(L),this.transformOutgoing=L.transformOutgoing.bind(L),this.transformOutgoingURI=L.transformOutgoingURI.bind(L),this.transformOutgoingScheme=L.transformOutgoingScheme.bind(L)):(this.transformIncoming=A=>A,this.transformOutgoing=A=>A,this.transformOutgoingURI=A=>A,this.transformOutgoingScheme=A=>A)}}e.$Qcc=M}),define(De[266],Ce([1,0,22]),function(re,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Scb=e.$Rcb=void 0;class M{constructor(){this.buffers=[]}add(k){let $=this.buffers.indexOf(k);return $<0&&($=this.buffers.length,this.buffers.push(k)),$}}function l(g,k){if(k.serializeBuffersForPostMessage){const $=new M,P=JSON.stringify(g,(S,D)=>{if(D instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:$.add(D)};if(ArrayBuffer.isView(D)){const E=L(D);if(E)return{$$vscode_array_buffer_reference$$:!0,index:$.add(D.buffer),view:{type:E,byteLength:D.byteLength,byteOffset:D.byteOffset}}}return D}),p=$.buffers.map(S=>{const D=new Uint8Array(S);return y.$ce.wrap(D)});return{message:P,buffers:p}}else return{message:JSON.stringify(g),buffers:[]}}e.$Rcb=l;function L(g){switch(g.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function A(g,k){const $=k.map(p=>{const S=new ArrayBuffer(p.byteLength);return new Uint8Array(S).set(p.buffer),S}),R=k.length?(p,S)=>{if(S&&typeof S=="object"&&S.$$vscode_array_buffer_reference$$){const D=S,{index:E}=D,h=$[E];if(D.view)switch(D.view.type){case 1:return new Int8Array(h,D.view.byteOffset,D.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(h,D.view.byteOffset,D.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(h,D.view.byteOffset,D.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(h,D.view.byteOffset,D.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(h,D.view.byteOffset,D.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(h,D.view.byteOffset,D.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(h,D.view.byteOffset,D.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(h,D.view.byteOffset,D.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(h,D.view.byteOffset,D.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(h,D.view.byteOffset,D.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(h,D.view.byteOffset,D.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return h}return S}:void 0;return{message:JSON.parse(g,R),arrayBuffers:$}}e.$Scb=A}),define(De[267],Ce([1,0,108,376,377,62,2,14,378]),function(re,e,y,M,l,L,A,g,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jfc=void 0;const $=!1;function R(c,f,a,t,i,s){const n=s.environment.useHostProxy,r=typeof n=="boolean"?n:!s.remote.isRemote,o={resolveProxy:w=>c.resolveProxy(w),lookupProxyAuthorization:h.bind(void 0,t,i,f,{},s.remote.isRemote),getProxyURL:()=>f.getConfiguration("http").get("proxy"),getProxySupport:()=>f.getConfiguration("http").get("proxySupport")||"off",getSystemCertificatesV1:()=>p(f),getSystemCertificatesV2:()=>S(f),log:(w,m,...b)=>{switch(w){case k.LogLevel.Trace:t.trace(m,...b);break;case k.LogLevel.Debug:t.debug(m,...b);break;case k.LogLevel.Info:t.info(m,...b);break;case k.LogLevel.Warning:t.warn(m,...b);break;case k.LogLevel.Error:t.error(m,...b);break;case k.LogLevel.Critical:t.error(m,...b);break;case k.LogLevel.Off:break;default:I(w,m,b);break}function I(z,O,...F){t.error("Unknown log level",z),t.error(O,...F)}},getLogLevel:()=>{const w=t.getLevel();switch(w){case g.LogLevel.Trace:return k.LogLevel.Trace;case g.LogLevel.Debug:return k.LogLevel.Debug;case g.LogLevel.Info:return k.LogLevel.Info;case g.LogLevel.Warning:return k.LogLevel.Warning;case g.LogLevel.Error:return k.LogLevel.Error;case g.LogLevel.Off:return k.LogLevel.Off;default:return m(w)}function m(b){return t.error("Unknown log level",b),k.LogLevel.Debug}},proxyResolveTelemetry:()=>{},useHostProxy:r,addCertificates:[],env:process.env},v=(0,k.createProxyResolver)(o),C=P(o,v);return E(a,C)}e.$jfc=R;function P(c,f){return{http:Object.assign(y,(0,k.createHttpPatch)(c,y,f)),https:Object.assign(M,(0,k.createHttpPatch)(c,M,f)),net:Object.assign(L,(0,k.createNetPatch)(c,L)),tls:Object.assign(l,(0,k.createTlsPatch)(c,l))}}function p(c){const f=c.getConfiguration("http");return!f.get("experimental.systemCertificatesV2",$)&&!!f.get("systemCertificates")}function S(c){const f=c.getConfiguration("http");return!!f.get("experimental.systemCertificatesV2",$)&&!!f.get("systemCertificates")}const D=new Map;function E(c,f){return c.getExtensionPathIndex().then(a=>{const t=globalThis._VSCODE_NODE_MODULES.module,i=t._load;t._load=function(n,r,o){if(n==="net")return f.net;if(n==="tls")return f.tls;if(n!=="http"&&n!=="https")return i.apply(this,arguments);const v=a.findSubstr(A.URI.file(r.filename));let C=D.get(v);if(C||D.set(v,C={}),!C[n]){const w=f[n];C[n]={...w}}return C[n]}})}async function h(c,f,a,t,i,s,n,r){const o=t[s];n&&(t[s]=n),c.trace("ProxyResolver#lookupProxyAuthorization callback",`proxyURL:${s}`,`proxyAuthenticate:${n}`,`proxyAuthenticateCache:${o}`);const v=n||o,C=Array.isArray(v)?v:typeof v=="string"?[v]:[];if(d(f,C,i),C.some(w=>/^(Negotiate|Kerberos)( |$)/i.test(w))&&!r.kerberosRequested)try{r.kerberosRequested=!0;const w=await new Promise((O,F)=>{re(["kerberos"],O,F)}),m=new URL(s),b=a.getConfiguration("http").get("proxyKerberosServicePrincipal")||(process.platform==="win32"?`HTTP/${m.hostname}`:`HTTP@${m.hostname}`);return c.debug("ProxyResolver#lookupProxyAuthorization Kerberos authentication lookup",`proxyURL:${s}`,`spn:${b}`),"Negotiate "+await(await w.initializeClient(b)).step("")}catch(w){c.error("ProxyResolver#lookupProxyAuthorization Kerberos authentication failed",w)}}let u=!1;function d(c,f,a){u||!f.length||(u=!0,c.$publicLog2("proxyAuthenticationRequest",{authenticationType:f.map(t=>t.split(" ")[0]).join(","),extensionHostType:a?"remote":"local"}))}}),define(De[268],Ce([1,0,126]),function(re,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fr=void 0;function M(L){return{transformIncoming:A=>A.scheme==="vscode-remote"?{scheme:"file",path:A.path,query:A.query,fragment:A.fragment}:A.scheme==="file"?{scheme:"vscode-local",path:A.path,query:A.query,fragment:A.fragment}:A,transformOutgoing:A=>A.scheme==="file"?{scheme:"vscode-remote",authority:L,path:A.path,query:A.query,fragment:A.fragment}:A.scheme==="vscode-local"?{scheme:"file",path:A.path,query:A.query,fragment:A.fragment}:A,transformOutgoingScheme:A=>A==="file"?"vscode-remote":A==="vscode-local"?"file":A}}function l(L){return new y.$Nm(M(L))}e.$Fr=l}),define(De[140],Ce([1,0,217,17,2,3,5,43,30,18,41,182,39]),function(re,e,y,M,l,L,A,g,k,$,R,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mE=e.$lE=e.$kE=e.EditorsOrder=e.$jE=e.CloseDirection=e.$iE=e.$hE=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$gE=e.$fE=e.$eE=e.$dE=e.$cE=e.$bE=e.$aE=e.$_D=e.EditorInputCapabilities=e.$$D=e.SaveReason=e.Verbosity=e.$0D=e.$9D=e.$8D=e.$7D=e.$6D=e.$5D=e.$4D=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$3D=e.$2D=e.$1D=e.$ZD=e.$YD=void 0,e.$YD={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$ZD={id:"default",displayName:(0,y.localize)(0,null),providerDisplayName:(0,y.localize)(1,null)},e.$1D="workbench.editor.sidebysideEditor",e.$2D="workbench.editors.textDiffEditor",e.$3D="workbench.editors.binaryResourceDiffEditor";var S;(function(oe){oe[oe.PROGRAMMATIC=1]="PROGRAMMATIC",oe[oe.USER=2]="USER",oe[oe.EDIT=3]="EDIT",oe[oe.NAVIGATION=4]="NAVIGATION",oe[oe.JUMP=5]="JUMP"})(S||(e.EditorPaneSelectionChangeReason=S={}));var D;(function(oe){oe[oe.IDENTICAL=1]="IDENTICAL",oe[oe.SIMILAR=2]="SIMILAR",oe[oe.DIFFERENT=3]="DIFFERENT"})(D||(e.EditorPaneSelectionCompareResult=D={}));function E(oe){const ye=oe;return!!ye&&typeof ye.getSelection=="function"&&!!ye.onDidChangeSelection}e.$4D=E;function h(oe,ye,fe){for(const V of fe.visibleEditorPanes)if(V.group.id===ye&&oe.matches(V.input))return V.getViewState()}e.$5D=h;function u(oe){if(o(oe))return!1;const ye=oe;return l.URI.isUri(ye?.resource)}e.$6D=u;function d(oe){if(o(oe))return!1;const ye=oe;return ye?.original!==void 0&&ye.modified!==void 0}e.$7D=d;function c(oe){if(o(oe)||d(oe))return!1;const ye=oe;return ye?.primary!==void 0&&ye.secondary!==void 0}e.$8D=c;function f(oe){if(o(oe))return!1;const ye=oe;return ye?ye.resource===void 0||ye.resource.scheme===$.Schemas.untitled||ye.forceUntitled===!0:!1}e.$9D=f;function a(oe){if(o(oe))return!1;const ye=oe;return l.URI.isUri(ye?.base?.resource)&&l.URI.isUri(ye?.input1?.resource)&&l.URI.isUri(ye?.input2?.resource)&&l.URI.isUri(ye?.result?.resource)}e.$0D=a;var t;(function(oe){oe[oe.SHORT=0]="SHORT",oe[oe.MEDIUM=1]="MEDIUM",oe[oe.LONG=2]="LONG"})(t||(e.Verbosity=t={}));var i;(function(oe){oe[oe.EXPLICIT=1]="EXPLICIT",oe[oe.AUTO=2]="AUTO",oe[oe.FOCUS_CHANGE=3]="FOCUS_CHANGE",oe[oe.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(i||(e.SaveReason=i={}));class s{constructor(){this.a=new Map}registerSource(ye,fe){let V=this.a.get(ye);return V||(V={source:ye,label:fe},this.a.set(ye,V)),V.source}getSourceLabel(ye){return this.a.get(ye)?.label??ye}}e.$$D=new s;var n;(function(oe){oe[oe.None=0]="None",oe[oe.Readonly=2]="Readonly",oe[oe.Untitled=4]="Untitled",oe[oe.Singleton=8]="Singleton",oe[oe.RequiresTrust=16]="RequiresTrust",oe[oe.CanSplitInGroup=32]="CanSplitInGroup",oe[oe.ForceDescription=64]="ForceDescription",oe[oe.CanDropIntoEditor=128]="CanDropIntoEditor",oe[oe.MultipleEditors=256]="MultipleEditors",oe[oe.Scratchpad=512]="Scratchpad",oe[oe.AuxWindowUnsupported=1024]="AuxWindowUnsupported"})(n||(e.EditorInputCapabilities=n={}));class r extends L.$Sc{}e.$_D=r;function o(oe){return oe instanceof r}e.$aE=o;function v(oe){const ye=oe;return l.URI.isUri(ye?.preferredResource)}function C(oe){const ye=oe;return o(ye?.primary)&&o(ye?.secondary)}e.$bE=C;function w(oe){const ye=oe;return o(ye?.modified)&&o(ye?.original)}e.$cE=w;function m(oe,ye,fe,V,le){return _(V,[(0,P.$Ai)({id:"workbench.action.openLargeFile",label:(0,y.localize)(2,null),run:()=>{const H={...fe,limits:{size:Number.MAX_VALUE}};oe.openEditor(ye,H)}}),(0,P.$Ai)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,y.localize)(3,null),run:()=>le.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:p.default.Warning})}e.$dE=m;function b(oe){return o(oe?.editor)}e.$eE=b;function I(oe){const ye=oe;return b(oe)&&ye?.group!==void 0}e.$fE=I;function z(oe){const ye=oe;return typeof ye?.groupId=="number"&&o(ye.editor)}e.$gE=z;var O;(function(oe){oe[oe.UNKNOWN=0]="UNKNOWN",oe[oe.REPLACE=1]="REPLACE",oe[oe.MOVE=2]="MOVE",oe[oe.UNPIN=3]="UNPIN"})(O||(e.EditorCloseContext=O={}));var F;(function(oe){oe[oe.GROUP_ACTIVE=0]="GROUP_ACTIVE",oe[oe.GROUP_INDEX=1]="GROUP_INDEX",oe[oe.GROUP_LABEL=2]="GROUP_LABEL",oe[oe.GROUP_LOCKED=3]="GROUP_LOCKED",oe[oe.EDITOR_OPEN=4]="EDITOR_OPEN",oe[oe.EDITOR_CLOSE=5]="EDITOR_CLOSE",oe[oe.EDITOR_MOVE=6]="EDITOR_MOVE",oe[oe.EDITOR_ACTIVE=7]="EDITOR_ACTIVE",oe[oe.EDITOR_LABEL=8]="EDITOR_LABEL",oe[oe.EDITOR_CAPABILITIES=9]="EDITOR_CAPABILITIES",oe[oe.EDITOR_PIN=10]="EDITOR_PIN",oe[oe.EDITOR_STICKY=11]="EDITOR_STICKY",oe[oe.EDITOR_DIRTY=12]="EDITOR_DIRTY",oe[oe.EDITOR_WILL_DISPOSE=13]="EDITOR_WILL_DISPOSE"})(F||(e.GroupModelChangeKind=F={}));var T;(function(oe){oe[oe.PRIMARY=1]="PRIMARY",oe[oe.SECONDARY=2]="SECONDARY",oe[oe.BOTH=3]="BOTH",oe[oe.ANY=4]="ANY"})(T||(e.SideBySideEditor=T={}));class N{getOriginalUri(ye,fe){if(!ye)return;if(a(ye))return e.$iE.getOriginalUri(ye.result,fe);if(fe?.supportSideBySide){const{primary:le,secondary:H}=this.a(ye);if(le&&H){if(fe?.supportSideBySide===T.BOTH)return{primary:this.getOriginalUri(le,{filterByScheme:fe.filterByScheme}),secondary:this.getOriginalUri(H,{filterByScheme:fe.filterByScheme})};if(fe?.supportSideBySide===T.ANY)return this.getOriginalUri(le,{filterByScheme:fe.filterByScheme})??this.getOriginalUri(H,{filterByScheme:fe.filterByScheme});ye=fe.supportSideBySide===T.PRIMARY?le:H}}if(d(ye)||c(ye)||a(ye))return;const V=v(ye)?ye.preferredResource:ye.resource;return!V||!fe||!fe.filterByScheme?V:this.b(V,fe.filterByScheme)}a(ye){return C(ye)||c(ye)?{primary:ye.primary,secondary:ye.secondary}:w(ye)||d(ye)?{primary:ye.modified,secondary:ye.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(ye,fe){if(!ye)return;if(a(ye))return e.$iE.getCanonicalUri(ye.result,fe);if(fe?.supportSideBySide){const{primary:le,secondary:H}=this.a(ye);if(le&&H){if(fe?.supportSideBySide===T.BOTH)return{primary:this.getCanonicalUri(le,{filterByScheme:fe.filterByScheme}),secondary:this.getCanonicalUri(H,{filterByScheme:fe.filterByScheme})};if(fe?.supportSideBySide===T.ANY)return this.getCanonicalUri(le,{filterByScheme:fe.filterByScheme})??this.getCanonicalUri(H,{filterByScheme:fe.filterByScheme});ye=fe.supportSideBySide===T.PRIMARY?le:H}}if(d(ye)||c(ye)||a(ye))return;const V=ye.resource;return!V||!fe||!fe.filterByScheme?V:this.b(V,fe.filterByScheme)}b(ye,fe){if(Array.isArray(fe)){if(fe.some(V=>ye.scheme===V))return ye}else if(fe===ye.scheme)return ye}}var j;(function(oe){oe[oe.UNKNOWN=0]="UNKNOWN",oe[oe.KEYBOARD=1]="KEYBOARD",oe[oe.MOUSE=2]="MOUSE"})(j||(e.EditorCloseMethod=j={}));function U(oe,ye,fe,V){if(!oe.isSticky(ye))return!1;switch(V.preventPinnedEditorClose){case"keyboardAndMouse":return fe===j.MOUSE||fe===j.KEYBOARD;case"mouse":return fe===j.MOUSE;case"keyboard":return fe===j.KEYBOARD}return!1}e.$hE=U,e.$iE=new N;var B;(function(oe){oe[oe.LEFT=0]="LEFT",oe[oe.RIGHT=1]="RIGHT"})(B||(e.CloseDirection=B={}));class he{constructor(){this.c=new Map,this.d=new Map}start(ye){const fe=this.a=ye.get(A.$Ph);for(const[V,le]of this.c)this.e(V,le,fe);this.c.clear()}e(ye,fe,V){const le=V.createInstance(fe);this.d.set(ye,le)}registerFileEditorFactory(ye){if(this.b)throw new Error("Can only register one file editor factory.");this.b=ye}getFileEditorFactory(){return(0,M.$Kf)(this.b)}registerEditorSerializer(ye,fe){if(this.c.has(ye)||this.d.has(ye))throw new Error(`A editor serializer with type ID '${ye}' was already registered.`);return this.a?this.e(ye,fe,this.a):this.c.set(ye,fe),(0,L.$Qc)(()=>{this.c.delete(ye),this.d.delete(ye)})}getEditorSerializer(ye){return this.d.get(typeof ye=="string"?ye:ye.typeId)}}g.$ln.add(e.$YD.EditorFactory,new he);async function x(oe,ye,fe){return!oe||!oe.length?[]:await Promise.all(oe.map(async V=>{const le=l.URI.revive(V.fileUri);if(!le){fe.info("Cannot resolve the path because it is not valid.",V);return}if(!await ye.canHandleResource(le)){fe.info("Cannot resolve the path because it cannot be handled",V);return}let G=V.exists,Y=V.type;if(typeof G!="boolean"||typeof Y!="number")try{Y=(await ye.stat(le)).isDirectory?k.FileType.Directory:k.FileType.Unknown,G=!0}catch(be){fe.error(be),G=!1}if(!G&&V.openOnlyIfExists){fe.info("Cannot resolve the path because it does not exist",V);return}if(Y===k.FileType.Directory){fe.info("Cannot resolve the path because it is a directory",V);return}const X={...V.options,pinned:!0};return G?{resource:le,options:X}:{resource:le,options:X,forceUntitled:!0}}))}e.$jE=x;var Q;(function(oe){oe[oe.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",oe[oe.SEQUENTIAL=1]="SEQUENTIAL"})(Q||(e.EditorsOrder=Q={}));function Z(oe){const ye=oe;if(!ye)return!1;const fe=ye;if(fe.modified)return Z(fe.modified);const V=ye;return!!(V.contributionsState&&V.viewState&&Array.isArray(V.cursorState))}e.$kE=Z;function ie(oe){return(0,R.$Ci)(oe)}e.$lE=ie;function _(oe,ye,fe){const V=(0,R.$Di)(oe,ye);return V.forceMessage=fe?.forceMessage,V.forceSeverity=fe?.forceSeverity,V.allowDialog=fe?.allowDialog,V}e.$mE=_}),define(De[269],Ce([1,0,4,218,5,3,28,43,19,24,79,256]),function(re,e,y,M,l,L,A,g,k,$,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xE=e.$wE=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$vE=e.$uE=e.ViewContentGroups=e.$tE=e.$sE=e.ViewContainerLocation=e.Extensions=e.$rE=e.$qE=e.$pE=void 0,e.$pE="views",e.$qE=(0,M.localize)(0,null),e.$rE=(0,P.$$v)("default-view-icon",R.$Vj.window,(0,M.localize)(1,null));var p;(function(i){i.ViewContainersRegistry="workbench.registry.view.containers",i.ViewsRegistry="workbench.registry.view"})(p||(e.Extensions=p={}));var S;(function(i){i[i.Sidebar=0]="Sidebar",i[i.Panel=1]="Panel",i[i.AuxiliaryBar=2]="AuxiliaryBar"})(S||(e.ViewContainerLocation=S={})),e.$sE=[0,1,2];function D(i){switch(i){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.$tE=D;class E extends L.$Sc{constructor(){super(...arguments),this.c=this.B(new y.$Od),this.onDidRegister=this.c.event,this.f=this.B(new y.$Od),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,k.$Rb)([...this.g.values()])}registerViewContainer(s,n,r){const o=this.get(s.id);if(o)return o;const v=s;return v.openCommandActionDescriptor=r?.doNotRegisterOpenCommand?void 0:v.openCommandActionDescriptor??{id:v.id},(0,A.$xc)(this.g,n,[]).push(v),r?.isDefault&&this.h.push(v),this.c.fire({viewContainer:v,viewContainerLocation:n}),v}deregisterViewContainer(s){for(const n of this.g.keys()){const r=this.g.get(n),o=r?.indexOf(s);if(o!==-1){r?.splice(o,1),r.length===0&&this.g.delete(n),this.f.fire({viewContainer:s,viewContainerLocation:n});return}}}get(s){return this.all.filter(n=>n.id===s)[0]}getViewContainers(s){return[...this.g.get(s)||[]]}getViewContainerLocation(s){return[...this.g.keys()].filter(n=>this.getViewContainers(n).filter(r=>r?.id===s.id).length>0)[0]}getDefaultViewContainer(s){return this.h.find(n=>this.getViewContainerLocation(n)===s)}}g.$ln.add(p.ViewContainersRegistry,new E);var h;(function(i){i.Open="2_open",i.Debug="4_debug",i.SCM="5_scm",i.More="9_more"})(h||(e.ViewContentGroups=h={}));function u(i,s){const n=i.group??h.More,r=s.group??h.More;return n!==r?n.localeCompare(r):(i.order??5)-(s.order??5)}class d extends L.$Sc{constructor(){super(...arguments),this.c=this.B(new y.$Od),this.onViewsRegistered=this.c.event,this.f=this.B(new y.$Od),this.onViewsDeregistered=this.f.event,this.g=this.B(new y.$Od),this.onDidChangeContainer=this.g.event,this.h=this.B(new y.$Od),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new A.$Gc}registerViews(s,n){this.registerViews2([{views:s,viewContainer:n}])}registerViews2(s){s.forEach(({views:n,viewContainer:r})=>this.r(n,r)),this.c.fire(s)}deregisterViews(s,n){const r=this.s(s,n);r.length&&this.f.fire({views:r,viewContainer:n})}moveViews(s,n){for(const r of this.m.keys())if(r!==n){const o=this.s(s,r);o.length&&(this.r(o,n),this.g.fire({views:o,from:r,to:n}))}}getViews(s){return this.m.get(s)||[]}getView(s){for(const n of this.j){const r=(this.m.get(n)||[]).filter(o=>o.id===s)[0];if(r)return r}return null}getViewContainer(s){for(const n of this.j)if((this.m.get(n)||[]).filter(o=>o.id===s)[0])return n;return null}registerViewWelcomeContent(s,n){return this.n.add(s,n),this.h.fire(s),(0,L.$Qc)(()=>{this.n.delete(s,n),this.h.fire(s)})}registerViewWelcomeContent2(s,n){const r=new Map;for(const[o,v]of n)this.n.add(s,v),r.set(o,(0,L.$Qc)(()=>{this.n.delete(s,v),this.h.fire(s)}));return this.h.fire(s),r}getViewWelcomeContent(s){const n=[];return this.n.forEach(s,r=>n.push(r)),n.sort(u)}r(s,n){let r=this.m.get(n);r||(r=[],this.m.set(n,r),this.j.push(n));for(const o of s){if(this.getView(o.id)!==null)throw new Error((0,M.localize)(2,null,o.id));r.push(o)}}s(s,n){const r=this.m.get(n);if(!r)return[];const o=[],v=[];for(const C of r)s.includes(C)?o.push(C):v.push(C);return o.length&&(v.length?this.m.set(n,v):(this.m.delete(n),this.j.splice(this.j.indexOf(n),1))),o}}g.$ln.add(p.ViewsRegistry,new d),e.$uE=(0,l.$Qh)("viewsService"),e.$vE=(0,l.$Qh)("viewDescriptorService");var c;(function(i){i[i.Default=0]="Default",i[i.Expand=1]="Expand"})(c||(e.ViewVisibilityState=c={}));var f;(function(i){i[i.None=0]="None",i[i.Collapsed=1]="Collapsed",i[i.Expanded=2]="Expanded"})(f||(e.TreeItemCollapsibleState=f={}));class a{constructor(s,n){this.c=!1,this.d=!1,(0,$.$_m)(this,s),this.d=!!n,this.resolve=async r=>{if(n&&!this.c){const o=await n(r);o&&(this.tooltip=this.tooltip??o.tooltip,this.command=this.command??o.command)}r.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$wE=a;class t extends Error{constructor(s){super((0,M.localize)(3,null,s)),this.name="NoTreeViewError"}static is(s){return s.name==="NoTreeViewError"}}e.$xE=t}),define(De[270],Ce([1,0,2,33,5]),function(re,e,y,M,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZE=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.$YE=e.$XE=void 0;function L($){return!!$&&typeof $=="object"&&"uri"in $&&$.uri instanceof y.URI&&"version"in $&&typeof $.version=="number"&&"ranges"in $&&Array.isArray($.ranges)&&$.ranges.every(M.$ys.isIRange)}e.$XE=L;function A($){return!!$&&typeof $=="object"&&"documents"in $&&Array.isArray($.documents)&&$.documents.every(L)}e.$YE=A;var g;(function($){$[$.Down=0]="Down",$[$.Up=1]="Up"})(g||(e.InteractiveSessionVoteDirection=g={}));var k;(function($){$[$.Action=1]="Action",$[$.Toolbar=2]="Toolbar"})(k||(e.InteractiveSessionCopyKind=k={})),e.$ZE=(0,l.$Qh)("IChatService")}),define(De[141],Ce([1,0,4,8,219]),function(re,e,y,M,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ldb=void 0;class L{constructor(){this.f=new Map,this.k=[],this.m=new y.$Od,this.n=new y.$Od,this.d=1}get onError(){return this.m.event}get onExit(){return this.n.event}onMessage(g){this.j&&this.m.fire(new Error("attempt to set more than one 'Message' callback")),this.j=g}onEvent(g){this.i&&this.m.fire(new Error("attempt to set more than one 'Event' callback")),this.i=g}onRequest(g){this.g&&this.m.fire(new Error("attempt to set more than one 'Request' callback")),this.g=g}sendResponse(g){g.seq>0?this.m.fire(new Error(`attempt to send more than one response for command ${g.command}`)):this.s("response",g)}sendRequest(g,k,$,R){const P={command:g};if(k&&Object.keys(k).length>0&&(P.arguments=k),this.s("request",P),typeof R=="number"){const p=setTimeout(()=>{clearTimeout(p);const S=this.f.get(P.seq);if(S){this.f.delete(P.seq);const D={type:"response",seq:0,request_seq:P.seq,success:!1,command:g,message:(0,l.localize)(0,null,R,g)};S(D)}},R)}return $&&this.f.set(P.seq,$),P.seq}acceptMessage(g){this.j?this.j(g):(this.k.push(g),this.k.length===1&&this.q())}o(g,k){return g.type!=="event"||k.type!=="event"}async q(){let g;for(;this.k.length;){if((!g||this.o(this.k[0],g))&&await(0,M.$Vg)(0),g=this.k.shift(),!g)return;switch(g.type){case"event":this.i?.(g);break;case"request":this.g?.(g);break;case"response":{const k=g,$=this.f.get(k.request_seq);$&&(this.f.delete(k.request_seq),$(k));break}}}}s(g,k){k.type=g,k.seq=this.d++,this.sendMessage(k)}async u(){if(this.f.size===0)return Promise.resolve();const g=new Map;this.f.forEach((k,$)=>g.set($,k)),await(0,M.$Vg)(500),g.forEach((k,$)=>{k({type:"response",seq:0,request_seq:$,success:!1,command:"canceled",message:"canceled"}),this.f.delete($)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.k=[]}}e.$ldb=L}),define(De[271],Ce([1,0,220,42,5]),function(re,e,y,M,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.$_G=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.$$G=e.MemoryRangeType=e.$0G=e.State=e.$9G=e.$8G=e.$7G=e.$6G=e.$5G=e.$4G=e.$3G=e.$2G=e.$1G=e.$ZG=e.$YG=e.$XG=e.$WG=e.$VG=e.$UG=e.$TG=e.$SG=e.$RG=e.$QG=e.$PG=e.$OG=e.$NG=e.$MG=e.$LG=e.$KG=e.$JG=e.$IG=e.$HG=e.$GG=e.$FG=e.$EG=e.$DG=e.$CG=e.$BG=e.$AG=e.$zG=e.$yG=e.$xG=e.$wG=e.$vG=e.$uG=e.$tG=e.$sG=e.$rG=e.$qG=e.$pG=e.$oG=e.$nG=e.$mG=e.$lG=e.$kG=e.$jG=e.$iG=e.$hG=e.$gG=e.$fG=e.$eG=e.$dG=e.$cG=e.$bG=e.$aG=e.$_F=e.$$F=e.$0F=e.$9F=e.$8F=void 0,e.$8F="workbench.view.debug",e.$9F="workbench.debug.variablesView",e.$0F="workbench.debug.watchExpressionsView",e.$$F="workbench.debug.callStackView",e.$_F="workbench.debug.loadedScriptsView",e.$aG="workbench.debug.breakPointsView",e.$bG="workbench.debug.disassemblyView",e.$cG="workbench.panel.repl",e.$dG="workbench.panel.repl.view",e.$eG=new M.$8i("debugType",void 0,{type:"string",description:y.localize(0,null)}),e.$fG=new M.$8i("debugConfigurationType",void 0,{type:"string",description:y.localize(1,null)}),e.$gG=new M.$8i("debugState","inactive",{type:"string",description:y.localize(2,null)}),e.$hG="debugUx",e.$iG=new M.$8i(e.$hG,"default",{type:"string",description:y.localize(3,null)}),e.$jG=new M.$8i("hasDebugged",!1,{type:"boolean",description:y.localize(4,null)}),e.$kG=new M.$8i("inDebugMode",!1,{type:"boolean",description:y.localize(5,null)}),e.$lG=new M.$8i("inDebugRepl",!1,{type:"boolean",description:y.localize(6,null)}),e.$mG=new M.$8i("breakpointWidgetVisible",!1,{type:"boolean",description:y.localize(7,null)}),e.$nG=new M.$8i("inBreakpointWidget",!1,{type:"boolean",description:y.localize(8,null)}),e.$oG=new M.$8i("breakpointsFocused",!0,{type:"boolean",description:y.localize(9,null)}),e.$pG=new M.$8i("watchExpressionsFocused",!0,{type:"boolean",description:y.localize(10,null)}),e.$qG=new M.$8i("watchExpressionsExist",!1,{type:"boolean",description:y.localize(11,null)}),e.$rG=new M.$8i("variablesFocused",!0,{type:"boolean",description:y.localize(12,null)}),e.$sG=new M.$8i("expressionSelected",!1,{type:"boolean",description:y.localize(13,null)}),e.$tG=new M.$8i("breakpointInputFocused",!1,{type:"boolean",description:y.localize(14,null)}),e.$uG=new M.$8i("callStackItemType",void 0,{type:"string",description:y.localize(15,null)}),e.$vG=new M.$8i("callStackSessionIsAttach",!1,{type:"boolean",description:y.localize(16,null)}),e.$wG=new M.$8i("callStackItemStopped",!1,{type:"boolean",description:y.localize(17,null)}),e.$xG=new M.$8i("callStackSessionHasOneThread",!1,{type:"boolean",description:y.localize(18,null)}),e.$yG=new M.$8i("watchItemType",void 0,{type:"string",description:y.localize(19,null)}),e.$zG=new M.$8i("canViewMemory",void 0,{type:"boolean",description:y.localize(20,null)}),e.$AG=new M.$8i("breakpointItemType",void 0,{type:"string",description:y.localize(21,null)}),e.$BG=new M.$8i("breakpointSupportsCondition",!1,{type:"boolean",description:y.localize(22,null)}),e.$CG=new M.$8i("loadedScriptsSupported",!1,{type:"boolean",description:y.localize(23,null)}),e.$DG=new M.$8i("loadedScriptsItemType",void 0,{type:"string",description:y.localize(24,null)}),e.$EG=new M.$8i("focusedSessionIsAttach",!1,{type:"boolean",description:y.localize(25,null)}),e.$FG=new M.$8i("stepBackSupported",!1,{type:"boolean",description:y.localize(26,null)}),e.$GG=new M.$8i("restartFrameSupported",!1,{type:"boolean",description:y.localize(27,null)}),e.$HG=new M.$8i("stackFrameSupportsRestart",!1,{type:"boolean",description:y.localize(28,null)}),e.$IG=new M.$8i("jumpToCursorSupported",!1,{type:"boolean",description:y.localize(29,null)}),e.$JG=new M.$8i("stepIntoTargetsSupported",!1,{type:"boolean",description:y.localize(30,null)}),e.$KG=new M.$8i("breakpointsExist",!1,{type:"boolean",description:y.localize(31,null)}),e.$LG=new M.$8i("debuggersAvailable",!1,{type:"boolean",description:y.localize(32,null)}),e.$MG=new M.$8i("debugExtensionAvailable",!0,{type:"boolean",description:y.localize(33,null)}),e.$NG=new M.$8i("debugProtocolVariableMenuContext",void 0,{type:"string",description:y.localize(34,null)}),e.$OG=new M.$8i("debugSetVariableSupported",!1,{type:"boolean",description:y.localize(35,null)}),e.$PG=new M.$8i("debugSetExpressionSupported",!1,{type:"boolean",description:y.localize(36,null)}),e.$QG=new M.$8i("breakWhenValueChangesSupported",!1,{type:"boolean",description:y.localize(37,null)}),e.$RG=new M.$8i("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:y.localize(38,null)}),e.$SG=new M.$8i("breakWhenValueIsReadSupported",!1,{type:"boolean",description:y.localize(39,null)}),e.$TG=new M.$8i("terminateDebuggeeSupported",!1,{type:"boolean",description:y.localize(40,null)}),e.$UG=new M.$8i("suspendDebuggeeSupported",!1,{type:"boolean",description:y.localize(41,null)}),e.$VG=new M.$8i("variableEvaluateNamePresent",!1,{type:"boolean",description:y.localize(42,null)}),e.$WG=new M.$8i("variableIsReadonly",!1,{type:"boolean",description:y.localize(43,null)}),e.$XG=new M.$8i("exceptionWidgetVisible",!1,{type:"boolean",description:y.localize(44,null)}),e.$YG=new M.$8i("multiSessionRepl",!1,{type:"boolean",description:y.localize(45,null)}),e.$ZG=new M.$8i("multiSessionDebug",!1,{type:"boolean",description:y.localize(46,null)}),e.$1G=new M.$8i("disassembleRequestSupported",!1,{type:"boolean",description:y.localize(47,null)}),e.$2G=new M.$8i("disassemblyViewFocus",!1,{type:"boolean",description:y.localize(48,null)}),e.$3G=new M.$8i("languageSupportsDisassembleRequest",!1,{type:"boolean",description:y.localize(49,null)}),e.$4G=new M.$8i("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:y.localize(50,null)});const L=p=>y.localize(51,null,p);e.$5G=L,e.$6G="editor.contrib.debug",e.$7G="editor.contrib.breakpoint",e.$8G="debug",e.$9G={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:y.localize(52,null)};var A;(function(p){p[p.Inactive=0]="Inactive",p[p.Initializing=1]="Initializing",p[p.Stopped=2]="Stopped",p[p.Running=3]="Running"})(A||(e.State=A={}));function g(p){switch(p){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.$0G=g;var k;(function(p){p[p.Valid=0]="Valid",p[p.Unreadable=1]="Unreadable",p[p.Error=2]="Error"})(k||(e.MemoryRangeType=k={})),e.$$G="vscode-debug-memory";var $;(function(p){p[p.Initial=1]="Initial",p[p.Dynamic=2]="Dynamic"})($||(e.DebugConfigurationProviderTriggerKind=$={}));var R;(function(p){p.UnverifiedBreakpoints="unverifiedBreakpoints"})(R||(e.DebuggerString=R={})),e.$_G=(0,l.$Qh)("debugService");var P;(function(p){p[p.CONDITION=0]="CONDITION",p[p.HIT_COUNT=1]="HIT_COUNT",p[p.LOG_MESSAGE=2]="LOG_MESSAGE"})(P||(e.BreakpointWidgetContext=P={}))}),define(De[272],Ce([1,0,16,2,15,24,18,33,21,19]),function(re,e,y,M,l,L,A,g,k,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IF=e.$HF=e.$GF=e.$FF=e.$EF=e.$DF=e.$CF=e.$BF=e.$AF=e.$zF=e.$yF=e.$xF=e.$wF=void 0;const R=/{([^}]+)}/g;function P(C,w,m){return C.replace(R,function(b,I){return w&&I.length>0&&I[0]!=="_"?b:m&&m.hasOwnProperty(I)?m[I]:b})}e.$wF=P;function p(C){const w={};for(const m of Object.keys(C))m.startsWith("!")||(w[m]=C[m]);return w}e.$xF=p;function S(C){return C.configuration.request==="attach"&&!D(C)&&(!C.parentSession||S(C.parentSession))}e.$yF=S;function D(C){let w=C.configuration.type;if(w)return w==="vslsShare"&&(w=C.configuration.adapterProxy.configuration.type),(0,y.$3e)(w,"extensionhost")||(0,y.$3e)(w,"pwa-extensionhost")?C:C.parentSession?D(C.parentSession):void 0}e.$zF=D;function E(C){return C.type&&(C.label||C.program||C.runtime)}e.$AF=E;function h(C,w,m){let b,I=0;const z=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let O=null;for(;O=z.exec(C);){const F=O.index+1,T=F+O[0].length;if(F<=w&&T>=m){b=O[0],I=F;break}}if(b){const F=/\w+/g;let T=null;for(;(T=F.exec(b))&&!(T.index+1+I+T[0].length>=m););T&&(b=b.substring(0,F.lastIndex))}return b?{start:I,end:I+b.length-1}:{start:0,end:0}}e.$BF=h;async function u(C,w,m,b){if(C.evaluatableExpressionProvider.has(w)){const I=C.evaluatableExpressionProvider.ordered(w),z=(0,$.$Hb)(await Promise.all(I.map(async O=>{try{return await O.provideEvaluatableExpression(w,m,b??k.CancellationToken.None)}catch{return}})));if(z.length>0){let O=z[0].expression;const F=z[0].range;return O||(O=w.getLineContent(m.lineNumber).substring(F.startColumn-1,F.endColumn-1)),{range:F,matchingExpression:O}}}else{const I=w.getLineContent(m.lineNumber),{start:z,end:O}=h(I,m.column,m.column),F=I.substring(z-1,O);return{matchingExpression:F,range:new g.$ys(m.lineNumber,z,m.lineNumber,z+F.length)}}return null}e.$CF=u;const d=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function c(C){return!!(C&&C.match(d))}e.$DF=c;function f(C){if(typeof C.path=="string"&&!(typeof C.sourceReference=="number"&&C.sourceReference>0)){if(c(C.path))return M.URI.parse(C.path);if((0,l.$ic)(C.path))return M.URI.file(C.path)}return C.path}function a(C){if(typeof C.path=="object"){const w=M.URI.revive(C.path);if(w)return w.scheme===A.Schemas.file?w.fsPath:w.toString()}return C.path}function t(C,w){const m=w?f:a,b=(0,L.$9m)(C);return s(b,(I,z)=>{I&&z&&(z.path=m(z))}),b}e.$EF=t;function i(C,w){const m=w?f:a,b=(0,L.$9m)(C);return s(b,(I,z)=>{!I&&z&&(z.path=m(z))}),b}e.$FF=i;function s(C,w){switch(C.type){case"event":{const m=C;switch(m.event){case"output":w(!1,m.body.source);break;case"loadedSource":w(!1,m.body.source);break;case"breakpoint":w(!1,m.body.breakpoint.source);break;default:break}break}case"request":{const m=C;switch(m.command){case"setBreakpoints":w(!0,m.arguments.source);break;case"breakpointLocations":w(!0,m.arguments.source);break;case"source":w(!0,m.arguments.source);break;case"gotoTargets":w(!0,m.arguments.source);break;case"launchVSCode":m.arguments.args.forEach(b=>w(!1,b));break;default:break}break}case"response":{const m=C;if(m.success&&m.body)switch(m.command){case"stackTrace":m.body.stackFrames.forEach(b=>w(!1,b.source));break;case"loadedSources":m.body.sources.forEach(b=>w(!1,b));break;case"scopes":m.body.scopes.forEach(b=>w(!1,b.source));break;case"setFunctionBreakpoints":m.body.breakpoints.forEach(b=>w(!1,b.source));break;case"setBreakpoints":m.body.breakpoints.forEach(b=>w(!1,b.source));break;case"disassemble":m.body?.instructions.forEach(I=>w(!1,I.location));break;default:break}break}}}function n(C){return C.filter(w=>!w.presentation?.hidden).sort((w,m)=>w.presentation?m.presentation?w.presentation.group?m.presentation.group?w.presentation.group!==m.presentation.group?w.presentation.group.localeCompare(m.presentation.group):r(w.presentation.order,m.presentation.order):-1:m.presentation.group?1:r(w.presentation.order,m.presentation.order):-1:m.presentation?1:0)}e.$GF=n;function r(C,w){return typeof C!="number"?typeof w!="number"?0:1:typeof w!="number"?-1:C-w}async function o(C,w){const m=C.getValue("debug.saveBeforeStart",{overrideIdentifier:w.activeTextEditorLanguageId});if(m!=="none"&&(await w.saveAll(),m==="allEditorsInActiveGroup")){const b=w.activeEditorPane;b&&b.input.resource?.scheme===A.Schemas.untitled&&await w.save({editor:b.input,groupId:b.group.id})}await C.reloadConfiguration()}e.$HF=o;const v=(C,w)=>!C||!w?C===w:C.name===w.name&&C.path===w.path&&C.sourceReference===w.sourceReference;e.$IF=v}),define(De[273],Ce([1,0,49,62,24,15,12,16,29,221,141]),function(re,e,y,M,l,L,A,g,k,$,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xec=e.$Wec=e.$Vec=e.$Uec=e.$Tec=void 0;class P extends R.$ldb{constructor(){super(),this.r=Buffer.allocUnsafe(0),this.t=-1}v(u,d){this.p=d,this.r=Buffer.allocUnsafe(0),this.t=-1,u.on("data",c=>this.w(c))}sendMessage(u){if(this.p){const d=JSON.stringify(u);this.p.write(`Content-Length: ${Buffer.byteLength(d,"utf8")}${P.a}${d}`,"utf8")}}w(u){for(this.r=Buffer.concat([this.r,u]);;){if(this.t>=0){if(this.r.length>=this.t){const d=this.r.toString("utf8",0,this.t);if(this.r=this.r.slice(this.t),this.t=-1,d.length>0)try{this.acceptMessage(JSON.parse(d))}catch(c){this.m.fire(new Error((c.message||c)+`
`+d))}continue}}else{const d=this.r.indexOf(P.a);if(d!==-1){const f=this.r.toString("utf8",0,d).split(P.b);for(const a of f){const t=a.split(P.l);t[0]==="Content-Length"&&(this.t=Number(t[1]))}this.r=this.r.slice(d+P.a.length);continue}}break}}}e.$Tec=P,P.a=`\r
\r
`,P.b=/\r?\n/,P.l=/: */;class p extends P{startSession(){return new Promise((u,d)=>{let c=!1;this.x=this.y(()=>{this.v(this.x,this.x),u(),c=!0}),this.x.on("close",()=>{c?this.m.fire(new Error("connection closed")):d(new Error("connection closed"))}),this.x.on("error",f=>{c?this.m.fire(f):d(f)})})}async stopSession(){await this.u(),this.x&&(this.x.end(),this.x=void 0)}}e.$Uec=p;class S extends p{constructor(u){super(),this.z=u}y(u){return M.createConnection(this.z.port,this.z.host||"127.0.0.1",u)}}e.$Vec=S;class D extends p{constructor(u){super(),this.z=u}y(u){return M.createConnection(this.z.path,u)}}e.$Wec=D;class E extends P{constructor(u,d){super(),this.y=u,this.z=d}async startSession(){const u=this.y.command,d=this.y.args,c=this.y.options||{};try{if(u)if(L.$ic(u)){if(!await k.Promises.exists(u))throw new Error($.localize(0,null,u))}else u.indexOf("/")<0&&u.indexOf("\\")<0;else throw new Error($.localize(1,null,this.z));let f=process.env;if(c.env&&Object.keys(c.env).length>0&&(f=l.$_m(l.$9m(process.env),c.env)),u==="node")if(Array.isArray(d)&&d.length>0){const a=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,t={env:f,execArgv:a?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};c.cwd&&(t.cwd=c.cwd);const i=y.fork(d[0],d.slice(1),t);if(!i.pid)throw new Error($.localize(2,null,d[0]));this.x=i}else throw new Error($.localize(3,null));else{const a={env:f};c.cwd&&(a.cwd=c.cwd),this.x=y.spawn(u,d,a)}this.x.on("error",a=>{this.m.fire(a)}),this.x.on("exit",(a,t)=>{this.n.fire(a)}),this.x.stdout.on("close",()=>{this.m.fire(new Error("read error"))}),this.x.stdout.on("error",a=>{this.m.fire(a)}),this.x.stdin.on("error",a=>{this.m.fire(a)}),this.x.stderr.resume(),this.v(this.x.stdout,this.x.stdin)}catch(f){this.m.fire(f)}}async stopSession(){return this.x?(await this.u(),A.$d?new Promise((u,d)=>{const c=y.exec(`taskkill /F /T /PID ${this.x.pid}`,function(f,a,t){if(f)return d(f)});c.on("exit",u),c.on("error",d)}):(this.x.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static A(u,d){if(!u)return;const c=Object.create(null);u.runtime&&(u.runtime.indexOf("./")===0?c.runtime=L.$jc(d,u.runtime):c.runtime=u.runtime),u.runtimeArgs&&(c.runtimeArgs=u.runtimeArgs),u.program&&(L.$ic(u.program)?c.program=u.program:c.program=L.$jc(d,u.program)),u.args&&(c.args=u.args);const f=u;return f.win&&(c.win=E.A(f.win,d)),f.winx86&&(c.winx86=E.A(f.winx86,d)),f.windows&&(c.windows=E.A(f.windows,d)),f.osx&&(c.osx=E.A(f.osx,d)),f.linux&&(c.linux=E.A(f.linux,d)),c}static platformAdapterExecutable(u,d){let c=Object.create(null);d=d.toLowerCase();for(const n of u)if(n.contributes){const r=n.contributes.debuggers;r&&r.length>0&&r.filter(o=>typeof o.type=="string"&&g.$3e(o.type,d)).forEach(o=>{const v=E.A(o,n.extensionLocation.fsPath);c=l.$_m(c,v,n.isBuiltin)})}let f;A.$d&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?f=c.winx86||c.win||c.windows:A.$d?f=c.win||c.windows:A.$e?f=c.osx:A.$f&&(f=c.linux),f=f||c;const a=f.program||c.program,t=f.args||c.args,i=f.runtime||c.runtime,s=f.runtimeArgs||c.runtimeArgs;if(i)return{type:"executable",command:i,args:(s||[]).concat(typeof a=="string"?[a]:[]).concat(t||[])};if(a)return{type:"executable",command:a,args:t||[]}}}e.$Xec=E}),define(De[274],Ce([1,0,49,32,12]),function(re,e,y,M,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zec=e.$Yec=void 0;function L($,R){return new Promise((P,p)=>{let S="";const D=y.spawn($,R);D.pid&&D.stdout.on("data",E=>{S+=E.toString()}),D.on("error",E=>{p(E)}),D.on("close",E=>{P(S)})})}async function A($){if($)if(l.$d){const R=await new Promise((P,p)=>{re(["@vscode/windows-process-tree"],P,p)});return new Promise(P=>{R.getProcessTree($,p=>{P(!!p&&p.children.length>0)})})}else return L("/usr/bin/pgrep",["-lP",String($)]).then(R=>{const P=R.trim();return!(P.length===0||P.indexOf(" tmux")>=0)},R=>!0);return Promise.resolve(!0)}e.$Yec=A;var g;(function($){$[$.cmd=0]="cmd",$[$.powershell=1]="powershell",$[$.bash=2]="bash"})(g||(g={}));function k($,R,P,p,S){$=$.trim().toLowerCase();let D;$.indexOf("powershell")>=0||$.indexOf("pwsh")>=0?D=1:$.indexOf("cmd.exe")>=0?D=0:$.indexOf("bash")>=0?D=2:l.$d?D=0:D=2;let E,h=" ";switch(D){case 1:if(E=u=>(u=u.replace(/\'/g,"''"),u.length>0&&u.charAt(u.length-1)==="\\"?`'${u}\\'`:`'${u}'`),p){const u=(0,M.$4f)(p);u&&(h+=`${u}:; `),h+=`cd ${E(p)}; `}if(S)for(const u in S){const d=S[u];d===null?h+=`Remove-Item env:${u}; `:h+=`\${env:${u}}='${d}'; `}if(R.length>0){const u=R.shift(),d=P?u:E(u);h+=d[0]==="'"?`& ${d} `:`${d} `;for(const c of R)h+=c==="<"||c===">"||P?c:E(c),h+=" "}break;case 0:if(E=u=>(u=u.replace(/\"/g,'""'),u=u.replace(/([><!^&|])/g,"^$1"),' "'.split("").some(d=>u.includes(d))||u.length===0?`"${u}"`:u),p){const u=(0,M.$4f)(p);u&&(h+=`${u}: && `),h+=`cd ${E(p)} && `}if(S){h+='cmd /C "';for(const u in S){let d=S[u];d===null?h+=`set "${u}=" && `:(d=d.replace(/[&^|<>]/g,c=>`^${c}`),h+=`set "${u}=${d}" && `)}}for(const u of R)h+=u==="<"||u===">"||P?u:E(u),h+=" ";S&&(h+='"');break;case 2:{E=d=>(d=d.replace(/(["'\\\$!><#()\[\]*&^| ;{}`])/g,"\\$1"),d.length===0?'""':d);const u=d=>/[^\w@%\/+=,.:^-]/.test(d)?`'${d.replace(/'/g,"'\\''")}'`:d;if(p&&(h+=`cd ${E(p)} ; `),S){h+="/usr/bin/env";for(const d in S){const c=S[d];c===null?h+=` -u ${u(d)}`:h+=` ${u(`${d}=${c}`)}`}h+=" "}for(const d of R)h+=d==="<"||d===">"||P?d:E(d),h+=" ";break}}return h}e.$Zec=k}),define(De[109],Ce([1,0,22,36,51,96,18,15,12,42]),function(re,e,y,M,l,L,A,g,k,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BI=e.$AI=e.$zI=e.$yI=e.CellStatusbarAlignment=e.$xI=e.$wI=e.$vI=e.NotebookEditorPriority=e.$uI=e.$tI=e.$sI=e.$rI=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$qI=e.$pI=e.$oI=e.$nI=e.CellKind=e.$mI=e.$lI=e.$kI=void 0,e.$kI="workbench.editor.notebook",e.$lI="workbench.editor.notebookTextDiffEditor",e.$mI="workbench.editor.interactive";var R;(function(j){j[j.Markup=1]="Markup",j[j.Code=2]="Code"})(R||(e.CellKind=R={})),e.$nI=["application/json","application/javascript","text/html","image/svg+xml",L.$Ur.latex,L.$Ur.markdown,"image/png","image/jpeg",L.$Ur.text],e.$oI=[L.$Ur.latex,L.$Ur.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",L.$Ur.text],e.$pI=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$qI="_notAvailable";var P;(function(j){j[j.Running=1]="Running",j[j.Idle=2]="Idle"})(P||(e.NotebookRunState=P={}));var p;(function(j){j[j.Unconfirmed=1]="Unconfirmed",j[j.Pending=2]="Pending",j[j.Executing=3]="Executing"})(p||(e.NotebookCellExecutionState=p={}));var S;(function(j){j[j.Unconfirmed=1]="Unconfirmed",j[j.Pending=2]="Pending",j[j.Executing=3]="Executing"})(S||(e.NotebookExecutionState=S={}));var D;(function(j){j[j.WithHardKernelDependency=0]="WithHardKernelDependency",j[j.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",j[j.Pure=2]="Pure",j[j.Never=3]="Never"})(D||(e.NotebookRendererMatch=D={}));var E;(function(j){j.Always="always",j.Never="never",j.Optional="optional"})(E||(e.RendererMessagingSpec=E={}));var h;(function(j){j[j.ModelChange=1]="ModelChange",j[j.Move=2]="Move",j[j.ChangeCellLanguage=5]="ChangeCellLanguage",j[j.Initialize=6]="Initialize",j[j.ChangeCellMetadata=7]="ChangeCellMetadata",j[j.Output=8]="Output",j[j.OutputItem=9]="OutputItem",j[j.ChangeCellContent=10]="ChangeCellContent",j[j.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",j[j.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",j[j.ChangeCellMime=13]="ChangeCellMime",j[j.Unknown=100]="Unknown"})(h||(e.NotebookCellsChangeType=h={}));var u;(function(j){j[j.Handle=0]="Handle",j[j.Index=1]="Index"})(u||(e.SelectionStateType=u={}));var d;(function(j){j[j.Replace=1]="Replace",j[j.Output=2]="Output",j[j.Metadata=3]="Metadata",j[j.CellLanguage=4]="CellLanguage",j[j.DocumentMetadata=5]="DocumentMetadata",j[j.Move=6]="Move",j[j.OutputItems=7]="OutputItems",j[j.PartialMetadata=8]="PartialMetadata",j[j.PartialInternalMetadata=9]="PartialInternalMetadata"})(d||(e.CellEditType=d={}));var c;(function(j){j.scheme=A.Schemas.vscodeNotebookCell;const U=["W","X","Y","Z","a","b","c","d","e","f"],B=new RegExp(`^[${U.join("")}]+`),he=7;function x(ye,fe){const V=fe.toString(he),H=`${V.length<U.length?U[V.length-1]:"z"}${V}s${(0,y.$we)(y.$ce.fromString(ye.scheme),!0,!0)}`;return ye.with({scheme:j.scheme,fragment:H})}j.generate=x;function Q(ye){if(ye.scheme!==j.scheme)return;const fe=ye.fragment.indexOf("s");if(fe<0)return;const V=parseInt(ye.fragment.substring(0,fe).replace(B,""),he),le=(0,y.$ve)(ye.fragment.substring(fe+1)).toString();if(!isNaN(V))return{handle:V,notebook:ye.with({scheme:le,fragment:null})}}j.parse=Q;function Z(ye,fe){return ye.with({scheme:A.Schemas.vscodeNotebookCellOutput,fragment:`op${fe??""},${ye.scheme!==A.Schemas.file?ye.scheme:""}`})}j.generateCellOutputUri=Z;function ie(ye){if(ye.scheme!==A.Schemas.vscodeNotebookCellOutput)return;const fe=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(ye.fragment);if(!fe)return;const V=fe[1]&&fe[1]!==""?fe[1]:void 0,le=fe[2];return{outputId:V,notebook:ye.with({scheme:le||A.Schemas.file,fragment:null})}}j.parseCellOutputUri=ie;function _(ye,fe,V){return j.generate(ye,fe).with({scheme:V})}j.generateCellPropertyUri=_;function oe(ye,fe){if(ye.scheme===fe)return j.parse(ye.with({scheme:j.scheme}))}j.parseCellPropertyUri=oe})(c||(e.CellUri=c={}));const f=j=>k.$d?j.replace(/\//g,"\\"):j;class a{constructor(U=[],B=e.$nI){this.e=B,this.d=[...new Set(U)].map(he=>({pattern:he,matches:M.$xj(f(he))}))}sort(U){const B=new Map(l.Iterable.map(U,x=>[x,f(x)]));let he=[];for(const{matches:x}of this.d)for(const[Q,Z]of B)if(x(Z)){he.push(Q),B.delete(Q);break}return B.size&&(he=he.concat([...B.keys()].sort((x,Q)=>this.e.indexOf(x)-this.e.indexOf(Q)))),he}prioritize(U,B){const he=this.f(U);if(he===-1){this.d.unshift({pattern:U,matches:M.$xj(f(U))});return}const x=new Set(B.map(Z=>this.f(Z,he)));x.delete(-1);const Q=Array.from(x).sort();this.d.splice(he+1,0,...Q.map(Z=>this.d[Z]));for(let Z=Q.length-1;Z>=0;Z--)this.d.splice(Q[Z],1)}toArray(){return this.d.map(U=>U.pattern)}f(U,B=this.d.length){const he=f(U);for(let x=0;x<B;x++)if(this.d[x].matches(he))return x;return-1}}e.$rI=a;function t(j,U,B,he=(x,Q)=>x===Q){const x=[];function Q(_,oe,ye){if(oe===0&&ye.length===0)return;const fe=x[x.length-1];fe&&fe.start+fe.deleteCount===_?(fe.deleteCount+=oe,fe.toInsert.push(...ye)):x.push({start:_,deleteCount:oe,toInsert:ye})}let Z=0,ie=0;for(;;){if(Z===j.length){Q(Z,0,U.slice(ie));break}if(ie===U.length){Q(Z,j.length-Z,[]);break}const _=j[Z],oe=U[ie];if(he(_,oe)){Z+=1,ie+=1;continue}B(oe)?(Q(Z,1,[]),Z+=1):(Q(Z,0,[oe]),ie+=1)}return x}e.$sI=t,e.$tI=new $.$8i("notebookEditorCursorAtBoundary","none"),e.$uI=new $.$8i("notebookEditorCursorAtLineBoundary","none");var i;(function(j){j.default="default",j.option="option"})(i||(e.NotebookEditorPriority=i={}));function s(j){const U=j;return!!((typeof U.include=="string"||M.$yj(U.include))&&(typeof U.exclude=="string"||M.$yj(U.exclude)))}e.$vI=s;function n(j,U,B){if(Array.isArray(j.viewType)&&j.viewType.indexOf(U)>=0||j.viewType===U)return!0;if(j.filenamePattern){const he=s(j.filenamePattern)?j.filenamePattern.include:j.filenamePattern,x=s(j.filenamePattern)?j.filenamePattern.exclude:void 0;if(M.$wj(he,(0,g.$nc)(B.fsPath).toLowerCase()))return!(x&&M.$wj(x,(0,g.$nc)(B.fsPath).toLowerCase()))}return!1}e.$wI=n,e.$xI={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScroll:"notebook.stickyScroll.enabled",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",formatOnSave:"notebook.formatOnSave.enabled",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",anchorToFocusedCell:"notebook.scrolling.experimental.anchorToFocusedCell"};var r;(function(j){j[j.Left=1]="Left",j[j.Right=2]="Right"})(r||(e.CellStatusbarAlignment=r={}));class o{static create(U){return`${o.d}${U}`}static parse(U){if(U.startsWith(o.d))return U.substring(o.d.length)}}e.$yI=o,o.d="notebook/";function v(j){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(j)}e.$zI=v;const C=new TextDecoder;function w(j){const U=[];let B=!1;for(const Z of j)(U.length===0||B)&&(U.push(Z),B=!0);let he=I(U);const x=y.$ce.concat(U.map(Z=>y.$ce.wrap(Z))),Q=N(x);return he=he||Q.byteLength!==x.byteLength,{data:Q,didCompression:he}}e.$AI=w,e.$BI=`${String.fromCharCode(27)}[A`;const m=e.$BI.split("").map(j=>j.charCodeAt(0)),b=10;function I(j){let U=!1;return j.forEach((B,he)=>{if(he===0||B.length<e.$BI.length)return;const x=j[he-1],Q=B.subarray(0,e.$BI.length);if(Q[0]===m[0]&&Q[1]===m[1]&&Q[2]===m[2]){const Z=x.lastIndexOf(b);if(Z===-1)return;U=!0,j[he-1]=x.subarray(0,Z),j[he]=B.subarray(e.$BI.length)}}),U}function z(j){let U=j;do j=U,U=j.replace(/[^\n]\x08/gm,"");while(U.length<j.length);return j}function O(j){for(j=j.replace(/\r+\n/gm,`
`);j.search(/\r[^$]/g)>-1;){const U=j.match(/^(.*)\r+/m)[1];let B=j.match(/\r+(.*)$/m)[1];B=B+U.slice(B.length,U.length),j=j.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,B)}return j}const F="\b".charCodeAt(0),T="\r".charCodeAt(0);function N(j){return!j.buffer.includes(F)&&!j.buffer.includes(T)?j:y.$ce.fromString(O(z(C.decode(j.buffer))))}});var et=this&&this.__classPrivateFieldSet||function(re,e,y,M,l){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!l)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!l:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?l.call(re,y):l?l.value=y:e.set(re,y),y},Be=this&&this.__classPrivateFieldGet||function(re,e,y,M){if(y==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!M:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return y==="m"?M:y==="a"?M.call(re):M?M.value:e.get(re)};define(De[7],Ce([1,0,19,9,80,28,96,16,17,2,31,25,30,65,109]),function(re,e,y,M,l,L,A,g,k,$,R,P,p,S,D){"use strict";var E,h,u,d,c,f,a,t,i,s,n,r,o,v,C,w,m,b,I,z,O,F,T,N,j,U;Object.defineProperty(e,"__esModule",{value:!0}),e.SpeechToTextStatus=e.RelatedInformationType=e.ChatAgentResultFeedbackKind=e.$gM=e.ChatVariableLevel=e.ChatMessageRole=e.InteractiveEditorResponseFeedbackKind=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.$fM=e.$eM=e.$dM=e.$cM=e.$bM=e.$aM=e.$_L=e.$$L=e.$0L=e.$9L=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$8L=e.$7L=e.$6L=e.$5L=e.$4L=e.$3L=e.$2L=e.$1L=e.TestRunProfileKind=e.TestResultState=e.$ZL=e.$YL=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$XL=e.$WL=e.$VL=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$UL=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$TL=e.$SL=e.$RL=e.$QL=e.$PL=e.ColorThemeKind=e.$OL=e.$NL=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$ML=e.DebugConsoleMode=e.$LL=e.$KL=e.$JL=e.$IL=e.$HL=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$GL=e.$FL=e.FileChangeType=e.$EL=e.$DL=e.$CL=e.$BL=e.InlineCompletionTriggerKind=e.$AL=e.$zL=e.$yL=e.$xL=e.$wL=e.$vL=e.$uL=e.$tL=e.$sL=e.$rL=e.$qL=e.$pL=e.$oL=e.ConfigurationTarget=e.$nL=e.$mL=e.$lL=e.$kL=e.$jL=e.$iL=e.$hL=e.$gL=e.$fL=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$eL=e.ViewBadge=e.ProgressLocation=e.$dL=e.$cL=e.TaskScope=e.ShellQuoting=e.$bL=e.$aL=e.$_K=e.TaskPanelKind=e.TaskRevealKind=e.$$K=e.TerminalLocation=e.$0K=e.$9K=e.$8K=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$7K=e.$6K=e.$5K=e.$4K=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.$3K=e.StatusBarAlignment=e.ViewColumn=e.$2K=e.$1K=e.$ZK=e.$YK=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$XK=e.$WK=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$VK=e.$UK=e.$TK=e.$SK=e.$RK=e.LanguageStatusSeverity=e.$QK=e.$PK=e.$OK=e.$NK=e.$MK=e.$LK=e.CodeActionTriggerKind=e.$KK=e.$JK=e.SymbolTag=e.SymbolKind=e.$IK=e.DocumentHighlightKind=e.$HK=e.$GK=e.$FK=e.$EK=e.DiagnosticSeverity=e.DiagnosticTag=e.$DK=e.$CK=e.FileEditType=e.$BK=e.$AK=e.$zK=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$yK=e.$xK=e.$wK=e.$vK=e.$uK=e.$tK=e.$sK=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function B(K){return Object.assign(K,{apply:function(...Ee){if(Ee.length===0)return Reflect.construct(K,[]);{const Le=Ee.length===1?[]:Ee[1];return Reflect.construct(K,Le,Ee[0].constructor)}},call:function(...Ee){if(Ee.length===0)return Reflect.construct(K,[]);{const[Le,...Xe]=Ee;return Reflect.construct(K,Xe,Le.constructor)}}})}var he;(function(K){K[K.Top=0]="Top",K[K.Bottom=1]="Bottom"})(he||(e.TerminalOutputAnchor=he={}));var x;(function(K){K[K.TerminalCommand=0]="TerminalCommand",K[K.Opener=1]="Opener",K[K.Command=3]="Command"})(x||(e.TerminalQuickFixType=x={}));let Q=i=class{static from(...q){let Ee=q;return new i(function(){if(Ee){for(const Le of Ee)Le&&typeof Le.dispose=="function"&&Le.dispose();Ee=void 0}})}constructor(q){E.set(this,void 0),et(this,E,q,"f")}dispose(){typeof Be(this,E,"f")=="function"&&(Be(this,E,"f").call(this),et(this,E,void 0,"f"))}};e.$sK=Q,E=new WeakMap,e.$sK=Q=i=He([B],Q);let Z=s=class{static Min(...q){if(q.length===0)throw new TypeError;let Ee=q[0];for(let Le=1;Le<q.length;Le++){const Xe=q[Le];Xe.isBefore(Ee)&&(Ee=Xe)}return Ee}static Max(...q){if(q.length===0)throw new TypeError;let Ee=q[0];for(let Le=1;Le<q.length;Le++){const Xe=q[Le];Xe.isAfter(Ee)&&(Ee=Xe)}return Ee}static isPosition(q){if(!q)return!1;if(q instanceof s)return!0;const{line:Ee,character:Le}=q;return typeof Ee=="number"&&typeof Le=="number"}static of(q){if(q instanceof s)return q;if(this.isPosition(q))return new s(q.line,q.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(q,Ee){if(q<0)throw(0,M.$7)("line must be non-negative");if(Ee<0)throw(0,M.$7)("character must be non-negative");this.c=q,this.e=Ee}isBefore(q){return this.c<q.c?!0:q.c<this.c?!1:this.e<q.e}isBeforeOrEqual(q){return this.c<q.c?!0:q.c<this.c?!1:this.e<=q.e}isAfter(q){return!this.isBeforeOrEqual(q)}isAfterOrEqual(q){return!this.isBefore(q)}isEqual(q){return this.c===q.c&&this.e===q.e}compareTo(q){return this.c<q.c?-1:this.c>q.line?1:this.e<q.e?-1:this.e>q.e?1:0}translate(q,Ee=0){if(q===null||Ee===null)throw(0,M.$7)();let Le;return typeof q>"u"?Le=0:typeof q=="number"?Le=q:(Le=typeof q.lineDelta=="number"?q.lineDelta:0,Ee=typeof q.characterDelta=="number"?q.characterDelta:0),Le===0&&Ee===0?this:new s(this.line+Le,this.character+Ee)}with(q,Ee=this.character){if(q===null||Ee===null)throw(0,M.$7)();let Le;return typeof q>"u"?Le=this.line:typeof q=="number"?Le=q:(Le=typeof q.line=="number"?q.line:this.line,Ee=typeof q.character=="number"?q.character:this.character),Le===this.line&&Ee===this.character?this:new s(Le,Ee)}toJSON(){return{line:this.line,character:this.character}}};e.$tK=Z,e.$tK=Z=s=He([B],Z);let ie=n=class{static isRange(q){return q instanceof n?!0:q?Z.isPosition(q.start)&&Z.isPosition(q.end):!1}static of(q){if(q instanceof n)return q;if(this.isRange(q))return new n(q.start,q.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(q,Ee,Le,Xe){let tt,ct;if(typeof q=="number"&&typeof Ee=="number"&&typeof Le=="number"&&typeof Xe=="number"?(tt=new Z(q,Ee),ct=new Z(Le,Xe)):Z.isPosition(q)&&Z.isPosition(Ee)&&(tt=Z.of(q),ct=Z.of(Ee)),!tt||!ct)throw new Error("Invalid arguments");tt.isBefore(ct)?(this.c=tt,this.e=ct):(this.c=ct,this.e=tt)}contains(q){return n.isRange(q)?this.contains(q.start)&&this.contains(q.end):Z.isPosition(q)?!(Z.of(q).isBefore(this.c)||this.e.isBefore(q)):!1}isEqual(q){return this.c.isEqual(q.c)&&this.e.isEqual(q.e)}intersection(q){const Ee=Z.Max(q.start,this.c),Le=Z.Min(q.end,this.e);if(!Ee.isAfter(Le))return new n(Ee,Le)}union(q){if(this.contains(q))return this;if(q.contains(this))return q;const Ee=Z.Min(q.start,this.c),Le=Z.Max(q.end,this.end);return new n(Ee,Le)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(q,Ee=this.end){if(q===null||Ee===null)throw(0,M.$7)();let Le;return q?Z.isPosition(q)?Le=q:(Le=q.start||this.start,Ee=q.end||this.end):Le=this.start,Le.isEqual(this.c)&&Ee.isEqual(this.end)?this:new n(Le,Ee)}toJSON(){return[this.start,this.end]}};e.$uK=ie,e.$uK=ie=n=He([B],ie);let _=r=class extends ie{static isSelection(q){return q instanceof r?!0:q?ie.isRange(q)&&Z.isPosition(q.anchor)&&Z.isPosition(q.active)&&typeof q.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(q,Ee,Le,Xe){let tt,ct;if(typeof q=="number"&&typeof Ee=="number"&&typeof Le=="number"&&typeof Xe=="number"?(tt=new Z(q,Ee),ct=new Z(Le,Xe)):Z.isPosition(q)&&Z.isPosition(Ee)&&(tt=Z.of(q),ct=Z.of(Ee)),!tt||!ct)throw new Error("Invalid arguments");super(tt,ct),this.f=tt,this.g=ct}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$vK=_,e.$vK=_=r=He([B],_);const oe=K=>{if(typeof K!="string"||K.length===0||!/^[0-9A-Za-z_\-]+$/.test(K))throw(0,M.$7)("connectionToken")};class ye{static isResolvedAuthority(q){return q&&typeof q=="object"&&typeof q.host=="string"&&typeof q.port=="number"&&(q.connectionToken===void 0||typeof q.connectionToken=="string")}constructor(q,Ee,Le){if(typeof q!="string"||q.length===0)throw(0,M.$7)("host");if(typeof Ee!="number"||Ee===0||Math.round(Ee)!==Ee)throw(0,M.$7)("port");typeof Le<"u"&&oe(Le),this.host=q,this.port=Math.round(Ee),this.connectionToken=Le}}e.$wK=ye;class fe{static isManagedResolvedAuthority(q){return q&&typeof q=="object"&&typeof q.makeConnection=="function"&&(q.connectionToken===void 0||typeof q.connectionToken=="string")}constructor(q,Ee){this.makeConnection=q,this.connectionToken=Ee,typeof Ee<"u"&&oe(Ee)}}e.$xK=fe;class V extends Error{static NotAvailable(q,Ee){return new V(q,S.RemoteAuthorityResolverErrorCode.NotAvailable,Ee)}static TemporarilyNotAvailable(q){return new V(q,S.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(q,Ee=S.RemoteAuthorityResolverErrorCode.Unknown,Le){super(q),this._message=q,this._code=Ee,this._detail=Le,Object.setPrototypeOf(this,V.prototype)}}e.$yK=V;var le;(function(K){K[K.LF=1]="LF",K[K.CRLF=2]="CRLF"})(le||(e.EndOfLine=le={}));var H;(function(K){K[K.Replace=1]="Replace",K[K.Append=2]="Append",K[K.Prepend=3]="Prepend"})(H||(e.EnvironmentVariableMutatorType=H={}));let G=o=class{static isTextEdit(q){return q instanceof o?!0:q?ie.isRange(q)&&typeof q.newText=="string":!1}static replace(q,Ee){return new o(q,Ee)}static insert(q,Ee){return o.replace(new ie(q,q),Ee)}static delete(q){return o.replace(q,"")}static setEndOfLine(q){const Ee=new o(new ie(new Z(0,0),new Z(0,0)),"");return Ee.newEol=q,Ee}get range(){return this.c}set range(q){if(q&&!ie.isRange(q))throw(0,M.$7)("range");this.c=q}get newText(){return this.e||""}set newText(q){if(q&&typeof q!="string")throw(0,M.$7)("newText");this.e=q}get newEol(){return this.f}set newEol(q){if(q&&typeof q!="number")throw(0,M.$7)("newEol");this.f=q}constructor(q,Ee){this.c=q,this.e=Ee}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$zK=G,e.$zK=G=o=He([B],G);let Y=v=class{static isNotebookCellEdit(q){return q instanceof v?!0:q?Zt.isNotebookRange(q)&&Array.isArray(q.newCells):!1}static replaceCells(q,Ee){return new v(q,Ee)}static insertCells(q,Ee){return new v(new Zt(q,q),Ee)}static deleteCells(q){return new v(q,[])}static updateCellMetadata(q,Ee){const Le=new v(new Zt(q,q),[]);return Le.newCellMetadata=Ee,Le}static updateNotebookMetadata(q){const Ee=new v(new Zt(0,0),[]);return Ee.newNotebookMetadata=q,Ee}constructor(q,Ee){this.range=q,this.newCells=Ee}};e.$AK=Y,e.$AK=Y=v=He([B],Y);class X{static isSnippetTextEdit(q){return q instanceof X?!0:q?ie.isRange(q.range)&&ge.isSnippetString(q.snippet):!1}static replace(q,Ee){return new X(q,Ee)}static insert(q,Ee){return X.replace(new ie(q,q),Ee)}constructor(q,Ee){this.range=q,this.snippet=Ee}}e.$BK=X;var be;(function(K){K[K.File=1]="File",K[K.Text=2]="Text",K[K.Cell=3]="Cell",K[K.CellReplace=5]="CellReplace",K[K.Snippet=6]="Snippet"})(be||(e.FileEditType=be={}));let se=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(q,Ee,Le,Xe){this.c.push({_type:1,from:q,to:Ee,options:Le,metadata:Xe})}createFile(q,Ee,Le){this.c.push({_type:1,from:void 0,to:q,options:Ee,metadata:Le})}deleteFile(q,Ee,Le){this.c.push({_type:1,from:q,to:void 0,options:Ee,metadata:Le})}e(q,Ee,Le){this.c.push({_type:3,metadata:Le,uri:q,edit:{editType:5,metadata:Ee},notebookMetadata:Ee})}f(q,Ee,Le,Xe){const tt=Ee.start,ct=Ee.end;(tt!==ct||Le.length>0)&&this.c.push({_type:5,uri:q,index:tt,count:ct-tt,cells:Le,metadata:Xe})}g(q,Ee,Le,Xe){this.c.push({_type:3,metadata:Xe,uri:q,edit:{editType:3,index:Ee,metadata:Le}})}replace(q,Ee,Le,Xe){this.c.push({_type:2,uri:q,edit:new G(Ee,Le),metadata:Xe})}insert(q,Ee,Le,Xe){this.replace(q,new ie(Ee,Ee),Le,Xe)}delete(q,Ee,Le){this.replace(q,Ee,"",Le)}has(q){return this.c.some(Ee=>Ee._type===2&&Ee.uri.toString()===q.toString())}set(q,Ee){if(Ee)for(const Le of Ee){if(!Le)continue;let Xe,tt;Array.isArray(Le)?(Xe=Le[0],tt=Le[1]):Xe=Le,Y.isNotebookCellEdit(Xe)?Xe.newCellMetadata?this.g(q,Xe.range.start,Xe.newCellMetadata,tt):Xe.newNotebookMetadata?this.e(q,Xe.newNotebookMetadata,tt):this.f(q,Xe.range,Xe.newCells,tt):X.isSnippetTextEdit(Xe)?this.c.push({_type:6,uri:q,range:Xe.range,edit:Xe.snippet,metadata:tt}):this.c.push({_type:2,uri:q,edit:Xe,metadata:tt})}else{for(let Le=0;Le<this.c.length;Le++){const Xe=this.c[Le];switch(Xe._type){case 2:case 6:case 3:case 5:Xe.uri.toString()===q.toString()&&(this.c[Le]=void 0);break}}(0,y.$Ib)(this.c)}}get(q){const Ee=[];for(const Le of this.c)Le._type===2&&Le.uri.toString()===q.toString()&&Ee.push(Le.edit);return Ee}entries(){const q=new L.$Ac;for(const Ee of this.c)if(Ee._type===2){let Le=q.get(Ee.uri);Le||(Le=[Ee.uri,[]],q.set(Ee.uri,Le)),Le[1].push(Ee.edit)}return[...q.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$CK=se,e.$CK=se=He([B],se);let ge=C=class{static isSnippetString(q){return q instanceof C?!0:q?typeof q.value=="string":!1}static c(q){return q.replace(/\$|}|\\/g,"\\$&")}constructor(q){this.e=1,this.value=q||""}appendText(q){return this.value+=C.c(q),this}appendTabstop(q=this.e++){return this.value+="$",this.value+=q,this}appendPlaceholder(q,Ee=this.e++){if(typeof q=="function"){const Le=new C;Le.e=this.e,q(Le),this.e=Le.e,q=Le.value}else q=C.c(q);return this.value+="${",this.value+=Ee,this.value+=":",this.value+=q,this.value+="}",this}appendChoice(q,Ee=this.e++){const Le=q.map(Xe=>Xe.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=Ee,this.value+="|",this.value+=Le,this.value+="|}",this}appendVariable(q,Ee){if(typeof Ee=="function"){const Le=new C;Le.e=this.e,Ee(Le),this.e=Le.e,Ee=Le.value}else typeof Ee=="string"&&(Ee=Ee.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=q,Ee&&(this.value+=":",this.value+=Ee),this.value+="}",this}};e.$DK=ge,e.$DK=ge=C=He([B],ge);var te;(function(K){K[K.Unnecessary=1]="Unnecessary",K[K.Deprecated=2]="Deprecated"})(te||(e.DiagnosticTag=te={}));var me;(function(K){K[K.Hint=3]="Hint",K[K.Information=2]="Information",K[K.Warning=1]="Warning",K[K.Error=0]="Error"})(me||(e.DiagnosticSeverity=me={}));let we=w=class{static isLocation(q){return q instanceof w?!0:q?ie.isRange(q.range)&&$.URI.isUri(q.uri):!1}constructor(q,Ee){if(this.uri=q,Ee)if(ie.isRange(Ee))this.range=ie.of(Ee);else if(Z.isPosition(Ee))this.range=new ie(Ee,Ee);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$EK=we,e.$EK=we=w=He([B],we);let Ie=class{static is(q){return q?typeof q.message=="string"&&q.location&&ie.isRange(q.location.range)&&$.URI.isUri(q.location.uri):!1}constructor(q,Ee){this.location=q,this.message=Ee}static isEqual(q,Ee){return q===Ee?!0:!q||!Ee?!1:q.message===Ee.message&&q.location.range.isEqual(Ee.location.range)&&q.location.uri.toString()===Ee.location.uri.toString()}};e.$FK=Ie,e.$FK=Ie=He([B],Ie);let W=class{constructor(q,Ee,Le=me.Error){if(!ie.isRange(q))throw new TypeError("range must be set");if(!Ee)throw new TypeError("message must be set");this.range=q,this.message=Ee,this.severity=Le}toJSON(){return{severity:me[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(q,Ee){return q===Ee?!0:!q||!Ee?!1:q.message===Ee.message&&q.severity===Ee.severity&&q.code===Ee.code&&q.severity===Ee.severity&&q.source===Ee.source&&q.range.isEqual(Ee.range)&&(0,y.$ub)(q.tags,Ee.tags)&&(0,y.$ub)(q.relatedInformation,Ee.relatedInformation,Ie.isEqual)}};e.$GK=W,e.$GK=W=He([B],W);let J=class{constructor(q,Ee){if(!q)throw new Error("Illegal argument, contents must be defined");Array.isArray(q)?this.contents=q:this.contents=[q],this.range=Ee}};e.$HK=J,e.$HK=J=He([B],J);var ce;(function(K){K[K.Text=0]="Text",K[K.Read=1]="Read",K[K.Write=2]="Write"})(ce||(e.DocumentHighlightKind=ce={}));let de=class{constructor(q,Ee=ce.Text){this.range=q,this.kind=Ee}toJSON(){return{range:this.range,kind:ce[this.kind]}}};e.$IK=de,e.$IK=de=He([B],de);var ee;(function(K){K[K.File=0]="File",K[K.Module=1]="Module",K[K.Namespace=2]="Namespace",K[K.Package=3]="Package",K[K.Class=4]="Class",K[K.Method=5]="Method",K[K.Property=6]="Property",K[K.Field=7]="Field",K[K.Constructor=8]="Constructor",K[K.Enum=9]="Enum",K[K.Interface=10]="Interface",K[K.Function=11]="Function",K[K.Variable=12]="Variable",K[K.Constant=13]="Constant",K[K.String=14]="String",K[K.Number=15]="Number",K[K.Boolean=16]="Boolean",K[K.Array=17]="Array",K[K.Object=18]="Object",K[K.Key=19]="Key",K[K.Null=20]="Null",K[K.EnumMember=21]="EnumMember",K[K.Struct=22]="Struct",K[K.Event=23]="Event",K[K.Operator=24]="Operator",K[K.TypeParameter=25]="TypeParameter"})(ee||(e.SymbolKind=ee={}));var $e;(function(K){K[K.Deprecated=1]="Deprecated"})($e||(e.SymbolTag=$e={}));let ve=m=class{static validate(q){if(!q.name)throw new Error("name must not be falsy")}constructor(q,Ee,Le,Xe,tt){this.name=q,this.kind=Ee,this.containerName=tt,typeof Le=="string"&&(this.containerName=Le),Xe instanceof we?this.location=Xe:Le instanceof ie&&(this.location=new we(Xe,Le)),m.validate(this)}toJSON(){return{name:this.name,kind:ee[this.kind],location:this.location,containerName:this.containerName}}};e.$JK=ve,e.$JK=ve=m=He([B],ve);let Ne=b=class{static validate(q){if(!q.name)throw new Error("name must not be falsy");if(!q.range.contains(q.selectionRange))throw new Error("selectionRange must be contained in fullRange");q.children?.forEach(b.validate)}constructor(q,Ee,Le,Xe,tt){this.name=q,this.detail=Ee,this.kind=Le,this.range=Xe,this.selectionRange=tt,this.children=[],b.validate(this)}};e.$KK=Ne,e.$KK=Ne=b=He([B],Ne);var qe;(function(K){K[K.Invoke=1]="Invoke",K[K.Automatic=2]="Automatic"})(qe||(e.CodeActionTriggerKind=qe={}));let xe=class{constructor(q,Ee){this.title=q,this.kind=Ee}};e.$LK=xe,e.$LK=xe=He([B],xe);let Ge=I=class{constructor(q){this.value=q}append(q){return new I(this.value?this.value+I.c+q:q)}intersects(q){return this.contains(q)||q.contains(this)}contains(q){return this.value===q.value||q.value.startsWith(this.value+I.c)}};e.$MK=Ge,Ge.c=".",e.$MK=Ge=I=He([B],Ge),Ge.Empty=new Ge(""),Ge.QuickFix=Ge.Empty.append("quickfix"),Ge.Refactor=Ge.Empty.append("refactor"),Ge.RefactorExtract=Ge.Refactor.append("extract"),Ge.RefactorInline=Ge.Refactor.append("inline"),Ge.RefactorMove=Ge.Refactor.append("move"),Ge.RefactorRewrite=Ge.Refactor.append("rewrite"),Ge.Source=Ge.Empty.append("source"),Ge.SourceOrganizeImports=Ge.Source.append("organizeImports"),Ge.SourceFixAll=Ge.Source.append("fixAll"),Ge.Notebook=Ge.Empty.append("notebook");let st=class{constructor(q,Ee){if(this.range=q,this.parent=Ee,Ee&&!Ee.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$NK=st,e.$NK=st=He([B],st);class it{constructor(q,Ee,Le,Xe,tt,ct){this.kind=q,this.name=Ee,this.detail=Le,this.uri=Xe,this.range=tt,this.selectionRange=ct}}e.$OK=it;class nt{constructor(q,Ee){this.fromRanges=Ee,this.from=q}}e.$PK=nt;class Ae{constructor(q,Ee){this.fromRanges=Ee,this.to=q}}e.$QK=Ae;var Oe;(function(K){K[K.Information=0]="Information",K[K.Warning=1]="Warning",K[K.Error=2]="Error"})(Oe||(e.LanguageStatusSeverity=Oe={}));let Re=class{constructor(q,Ee){this.range=q,this.command=Ee}get isResolved(){return!!this.command}};e.$RK=Re,e.$RK=Re=He([B],Re);let Qe=z=class{static isMarkdownString(q){return q instanceof z?!0:q&&q.appendCodeblock&&q.appendMarkdown&&q.appendText&&q.value!==void 0}constructor(q,Ee=!1){h.set(this,void 0),et(this,h,new l.$4j(q,{supportThemeIcons:Ee}),"f")}get value(){return Be(this,h,"f").value}set value(q){Be(this,h,"f").value=q}get isTrusted(){return Be(this,h,"f").isTrusted}set isTrusted(q){Be(this,h,"f").isTrusted=q}get supportThemeIcons(){return Be(this,h,"f").supportThemeIcons}set supportThemeIcons(q){Be(this,h,"f").supportThemeIcons=q}get supportHtml(){return Be(this,h,"f").supportHtml}set supportHtml(q){Be(this,h,"f").supportHtml=q}get baseUri(){return Be(this,h,"f").baseUri}set baseUri(q){Be(this,h,"f").baseUri=q}appendText(q){return Be(this,h,"f").appendText(q),this}appendMarkdown(q){return Be(this,h,"f").appendMarkdown(q),this}appendCodeblock(q,Ee){return Be(this,h,"f").appendCodeblock(Ee??"",q),this}};e.$SK=Qe,h=new WeakMap,e.$SK=Qe=z=He([B],Qe);let ue=class{constructor(q,Ee){this.label=q,this.documentation=Ee}};e.$TK=ue,e.$TK=ue=He([B],ue);let ae=class{constructor(q,Ee){this.label=q,this.documentation=Ee,this.parameters=[]}};e.$UK=ae,e.$UK=ae=He([B],ae);let Pe=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$VK=Pe,e.$VK=Pe=He([B],Pe);var Ke;(function(K){K[K.Invoke=1]="Invoke",K[K.TriggerCharacter=2]="TriggerCharacter",K[K.ContentChange=3]="ContentChange"})(Ke||(e.SignatureHelpTriggerKind=Ke={}));var Ue;(function(K){K[K.Type=1]="Type",K[K.Parameter=2]="Parameter"})(Ue||(e.InlayHintKind=Ue={}));let Ze=class{constructor(q){this.value=q}};e.$WK=Ze,e.$WK=Ze=He([B],Ze);let rt=class{constructor(q,Ee,Le){this.position=q,this.label=Ee,this.kind=Le}};e.$XK=rt,e.$XK=rt=He([B],rt);var ht;(function(K){K[K.Invoke=0]="Invoke",K[K.TriggerCharacter=1]="TriggerCharacter",K[K.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(ht||(e.CompletionTriggerKind=ht={}));var pt;(function(K){K[K.Text=0]="Text",K[K.Method=1]="Method",K[K.Function=2]="Function",K[K.Constructor=3]="Constructor",K[K.Field=4]="Field",K[K.Variable=5]="Variable",K[K.Class=6]="Class",K[K.Interface=7]="Interface",K[K.Module=8]="Module",K[K.Property=9]="Property",K[K.Unit=10]="Unit",K[K.Value=11]="Value",K[K.Enum=12]="Enum",K[K.Keyword=13]="Keyword",K[K.Snippet=14]="Snippet",K[K.Color=15]="Color",K[K.File=16]="File",K[K.Reference=17]="Reference",K[K.Folder=18]="Folder",K[K.EnumMember=19]="EnumMember",K[K.Constant=20]="Constant",K[K.Struct=21]="Struct",K[K.Event=22]="Event",K[K.Operator=23]="Operator",K[K.TypeParameter=24]="TypeParameter",K[K.User=25]="User",K[K.Issue=26]="Issue"})(pt||(e.CompletionItemKind=pt={}));var Dt;(function(K){K[K.Deprecated=1]="Deprecated"})(Dt||(e.CompletionItemTag=Dt={}));let qt=class{constructor(q,Ee){this.label=q,this.kind=Ee}toJSON(){return{label:this.label,kind:this.kind&&pt[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$YK=qt,e.$YK=qt=He([B],qt);let Vt=class{constructor(q=[],Ee=!1){this.items=q,this.isIncomplete=Ee}};e.$ZK=Vt,e.$ZK=Vt=He([B],Vt);let Et=class{constructor(q,Ee,Le){this.insertText=q,this.range=Ee,this.command=Le}};e.$1K=Et,e.$1K=Et=He([B],Et);let Tt=class{constructor(q){this.commands=void 0,this.suppressSuggestions=void 0,this.items=q}};e.$2K=Tt,e.$2K=Tt=He([B],Tt);var Ot;(function(K){K[K.Active=-1]="Active",K[K.Beside=-2]="Beside",K[K.One=1]="One",K[K.Two=2]="Two",K[K.Three=3]="Three",K[K.Four=4]="Four",K[K.Five=5]="Five",K[K.Six=6]="Six",K[K.Seven=7]="Seven",K[K.Eight=8]="Eight",K[K.Nine=9]="Nine"})(Ot||(e.ViewColumn=Ot={}));var _t;(function(K){K[K.Left=1]="Left",K[K.Right=2]="Right"})(_t||(e.StatusBarAlignment=_t={}));function Yt(K,q){return`${P.$8l.toKey(K)}.${q}`}e.$3K=Yt;var Pt;(function(K){K[K.Off=0]="Off",K[K.On=1]="On",K[K.Relative=2]="Relative"})(Pt||(e.TextEditorLineNumbersStyle=Pt={}));var Nt;(function(K){K[K.Manual=1]="Manual",K[K.AfterDelay=2]="AfterDelay",K[K.FocusOut=3]="FocusOut"})(Nt||(e.TextDocumentSaveReason=Nt={}));var Jt;(function(K){K[K.Default=0]="Default",K[K.InCenter=1]="InCenter",K[K.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",K[K.AtTop=3]="AtTop"})(Jt||(e.TextEditorRevealType=Jt={}));var jt;(function(K){K[K.Keyboard=1]="Keyboard",K[K.Mouse=2]="Mouse",K[K.Command=3]="Command"})(jt||(e.TextEditorSelectionChangeKind=jt={}));var Kt;(function(K){K[K.Undo=1]="Undo",K[K.Redo=2]="Redo"})(Kt||(e.TextDocumentChangeReason=Kt={}));var Ht;(function(K){K[K.OpenOpen=0]="OpenOpen",K[K.ClosedClosed=1]="ClosedClosed",K[K.OpenClosed=2]="OpenClosed",K[K.ClosedOpen=3]="ClosedOpen"})(Ht||(e.DecorationRangeBehavior=Ht={})),function(K){function q(Ee){switch(Ee){case"keyboard":return K.Keyboard;case"mouse":return K.Mouse;case"api":return K.Command}}K.fromValue=q}(jt||(e.TextEditorSelectionChangeKind=jt={}));var It;(function(K){K[K.Other=0]="Other",K[K.Comment=1]="Comment",K[K.String=2]="String",K[K.RegEx=3]="RegEx"})(It||(e.SyntaxTokenType=It={})),function(K){function q(Ee){switch(Ee){case K.Other:return"other";case K.Comment:return"comment";case K.String:return"string";case K.RegEx:return"regex"}return"other"}K.toString=q}(It||(e.SyntaxTokenType=It={}));let ut=class{constructor(q,Ee){if(Ee&&!$.URI.isUri(Ee))throw(0,M.$7)("target");if(!ie.isRange(q)||q.isEmpty)throw(0,M.$7)("range");this.range=q,this.target=Ee}};e.$4K=ut,e.$4K=ut=He([B],ut);let ft=class{constructor(q,Ee,Le,Xe){this.red=q,this.green=Ee,this.blue=Le,this.alpha=Xe}};e.$5K=ft,e.$5K=ft=He([B],ft);let At=class{constructor(q,Ee){if(Ee&&!(Ee instanceof ft))throw(0,M.$7)("color");if(!ie.isRange(q)||q.isEmpty)throw(0,M.$7)("range");this.range=q,this.color=Ee}};e.$6K=At,e.$6K=At=He([B],At);let Ft=class{constructor(q){if(!q||typeof q!="string")throw(0,M.$7)("label");this.label=q}};e.$7K=Ft,e.$7K=Ft=He([B],Ft);var Mt;(function(K){K[K.RGB=0]="RGB",K[K.HEX=1]="HEX",K[K.HSL=2]="HSL"})(Mt||(e.ColorFormat=Mt={}));var lt;(function(K){K[K.Error=0]="Error",K[K.Warning=1]="Warning",K[K.Information=2]="Information"})(lt||(e.SourceControlInputBoxValidationType=lt={}));var kt;(function(K){K[K.Unknown=0]="Unknown",K[K.Shutdown=1]="Shutdown",K[K.Process=2]="Process",K[K.User=3]="User",K[K.Extension=4]="Extension"})(kt||(e.TerminalExitReason=kt={}));class zt{constructor(q,Ee,Le){if(this.startIndex=q,this.length=Ee,this.tooltip=Le,typeof q!="number"||q<0)throw(0,M.$7)("startIndex");if(typeof Ee!="number"||Ee<1)throw(0,M.$7)("length");if(Le!==void 0&&typeof Le!="string")throw(0,M.$7)("tooltip")}}e.$8K=zt;class Ut{constructor(q){this.uri=q}}e.$9K=Ut;class Je{constructor(q){this.terminalCommand=q}}e.$0K=Je;var Qt;(function(K){K[K.Panel=1]="Panel",K[K.Editor=2]="Editor"})(Qt||(e.TerminalLocation=Qt={}));class Me{constructor(q){if(this.options=q,typeof q!="object")throw(0,M.$7)("options")}}e.$$K=Me;var Te;(function(K){K[K.Always=1]="Always",K[K.Silent=2]="Silent",K[K.Never=3]="Never"})(Te||(e.TaskRevealKind=Te={}));var Se;(function(K){K[K.Shared=1]="Shared",K[K.Dedicated=2]="Dedicated",K[K.New=3]="New"})(Se||(e.TaskPanelKind=Se={}));let ne=O=class{static from(q){switch(q){case"clean":return O.Clean;case"build":return O.Build;case"rebuild":return O.Rebuild;case"test":return O.Test;default:return}}constructor(q,Ee){if(this.label=Ee,typeof q!="string"||typeof Ee!="string")throw(0,M.$7)("name");this.c=q}get id(){return this.c}};e.$_K=ne,ne.Clean=new O("clean","Clean"),ne.Build=new O("build","Build"),ne.Rebuild=new O("rebuild","Rebuild"),ne.Test=new O("test","Test"),e.$_K=ne=O=He([B],ne);function Fe(K){let q="";for(let Ee=0;Ee<K.length;Ee++)q+=K[Ee].replace(/,/g,",,")+",";return q}let Ve=class{constructor(q,Ee,Le){if(typeof q!="string")throw(0,M.$7)("process");this.e=[],this.c=q,Ee!==void 0&&(Array.isArray(Ee)?(this.e=Ee,this.f=Le):this.f=Ee)}get process(){return this.c}set process(q){if(typeof q!="string")throw(0,M.$7)("process");this.c=q}get args(){return this.e}set args(q){Array.isArray(q)||(q=[]),this.e=q}get options(){return this.f}set options(q){this.f=q}computeId(){const q=[];if(q.push("process"),this.c!==void 0&&q.push(this.c),this.e&&this.e.length>0)for(const Ee of this.e)q.push(Ee);return Fe(q)}};e.$aL=Ve,e.$aL=Ve=He([B],Ve);let _e=class{constructor(q,Ee,Le){if(this.f=[],Array.isArray(Ee)){if(!q)throw(0,M.$7)("command can't be undefined or null");if(typeof q!="string"&&typeof q.value!="string")throw(0,M.$7)("command");this.e=q,this.f=Ee,this.g=Le}else{if(typeof q!="string")throw(0,M.$7)("commandLine");this.c=q,this.g=Ee}}get commandLine(){return this.c}set commandLine(q){if(typeof q!="string")throw(0,M.$7)("commandLine");this.c=q}get command(){return this.e?this.e:""}set command(q){if(typeof q!="string"&&typeof q.value!="string")throw(0,M.$7)("command");this.e=q}get args(){return this.f}set args(q){this.f=q||[]}get options(){return this.g}set options(q){this.g=q}computeId(){const q=[];if(q.push("shell"),this.c!==void 0&&q.push(this.c),this.e!==void 0&&q.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const Ee of this.f)q.push(typeof Ee=="string"?Ee:Ee.value);return Fe(q)}};e.$bL=_e,e.$bL=_e=He([B],_e);var Ye;(function(K){K[K.Escape=1]="Escape",K[K.Strong=2]="Strong",K[K.Weak=3]="Weak"})(Ye||(e.ShellQuoting=Ye={}));var ot;(function(K){K[K.Global=1]="Global",K[K.Workspace=2]="Workspace"})(ot||(e.TaskScope=ot={}));class Ct{constructor(q){this.c=q}computeId(){return"customExecution"+(0,R.$fg)()}set callback(q){this.c=q}get callback(){return this.c}}e.$cL=Ct;let yt=F=class{constructor(q,Ee,Le,Xe,tt,ct){this.j=!1,this.k=this.definition=q;let mt;typeof Ee=="string"?(this.m=this.name=Ee,this.t=this.source=Le,this.execution=Xe,mt=tt,this.j=!0):Ee===ot.Global||Ee===ot.Workspace?(this.target=Ee,this.m=this.name=Le,this.t=this.source=Xe,this.execution=tt,mt=ct):(this.target=Ee,this.m=this.name=Le,this.t=this.source=Xe,this.execution=tt,mt=ct),typeof mt=="string"?(this.o=[mt],this.q=!0):Array.isArray(mt)?(this.o=mt,this.q=!0):(this.o=[],this.q=!1),this.r=!1,this.w=Object.create(null),this.x=Object.create(null)}get _id(){return this.h}set _id(q){this.h=q}get _deprecated(){return this.j}z(){this.h!==void 0&&(this.h=void 0,this.l=void 0,this.A())}A(){this.n instanceof Ve?this.k={type:F.e,id:this.n.computeId()}:this.n instanceof _e?this.k={type:F.f,id:this.n.computeId()}:this.n instanceof Ct?this.k={type:F.c,id:this.n.computeId()}:this.k={type:F.g,id:(0,R.$fg)()}}get definition(){return this.k}set definition(q){if(q==null)throw(0,M.$7)("Kind can't be undefined or null");this.z(),this.k=q}get scope(){return this.l}set target(q){this.z(),this.l=q}get name(){return this.m}set name(q){if(typeof q!="string")throw(0,M.$7)("name");this.z(),this.m=q}get execution(){return this.n}set execution(q){q===null&&(q=void 0),this.z(),this.n=q;const Ee=this.k.type;(F.g===Ee||F.e===Ee||F.f===Ee||F.c===Ee)&&this.A()}get problemMatchers(){return this.o}set problemMatchers(q){if(Array.isArray(q))this.z(),this.o=q,this.q=!0;else{this.z(),this.o=[],this.q=!1;return}}get hasDefinedMatchers(){return this.q}get isBackground(){return this.r}set isBackground(q){q!==!0&&q!==!1&&(q=!1),this.z(),this.r=q}get source(){return this.t}set source(q){if(typeof q!="string"||q.length===0)throw(0,M.$7)("source must be a string of length > 0");this.z(),this.t=q}get group(){return this.u}set group(q){q===null&&(q=void 0),this.z(),this.u=q}get detail(){return this.y}set detail(q){q===null&&(q=void 0),this.y=q}get presentationOptions(){return this.w}set presentationOptions(q){q==null&&(q=Object.create(null)),this.z(),this.w=q}get runOptions(){return this.x}set runOptions(q){q==null&&(q=Object.create(null)),this.z(),this.x=q}};e.$dL=yt,yt.c="customExecution",yt.e="process",yt.f="shell",yt.g="$empty",e.$dL=yt=F=He([B],yt);var bt;(function(K){K[K.SourceControl=1]="SourceControl",K[K.Window=10]="Window",K[K.Notification=15]="Notification"})(bt||(e.ProgressLocation=bt={}));var gt;(function(K){function q(Ee){const Le=Ee;return(0,k.$Df)(Le.value)?Le.tooltip&&!(0,k.$zf)(Le.tooltip)?(console.log("INVALID view badge, invalid tooltip",Le.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Le.value),!1)}K.isViewBadge=q})(gt||(e.ViewBadge=gt={}));let $t=T=class{static isTreeItem(q,Ee){const Le=q;if(Le.checkboxState!==void 0){const Xe=(0,k.$Df)(Le.checkboxState)?Le.checkboxState:(0,k.$Bf)(Le.checkboxState)&&(0,k.$Df)(Le.checkboxState.state)?Le.checkboxState.state:void 0,tt=!(0,k.$Df)(Le.checkboxState)&&(0,k.$Bf)(Le.checkboxState)?Le.checkboxState.tooltip:void 0;if(Xe===void 0||Xe!==Gt.Checked&&Xe!==Gt.Unchecked||tt!==void 0&&!(0,k.$zf)(tt))return console.log("INVALID tree item, invalid checkboxState",Le.checkboxState),!1}if(q instanceof T)return!0;if(Le.label!==void 0&&!(0,k.$zf)(Le.label)&&!Le.label?.label)return console.log("INVALID tree item, invalid label",Le.label),!1;if(Le.id!==void 0&&!(0,k.$zf)(Le.id))return console.log("INVALID tree item, invalid id",Le.id),!1;if(Le.iconPath!==void 0&&!(0,k.$zf)(Le.iconPath)&&!$.URI.isUri(Le.iconPath)&&(!Le.iconPath||!(0,k.$zf)(Le.iconPath.id))){const Xe=Le.iconPath;if(!Xe||!(0,k.$zf)(Xe.light)&&!$.URI.isUri(Xe.light)&&!(0,k.$zf)(Xe.dark)&&!$.URI.isUri(Xe.dark))return console.log("INVALID tree item, invalid iconPath",Le.iconPath),!1}return Le.description!==void 0&&!(0,k.$zf)(Le.description)&&typeof Le.description!="boolean"?(console.log("INVALID tree item, invalid description",Le.description),!1):Le.resourceUri!==void 0&&!$.URI.isUri(Le.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Le.resourceUri),!1):Le.tooltip!==void 0&&!(0,k.$zf)(Le.tooltip)&&!(Le.tooltip instanceof Qe)?(console.log("INVALID tree item, invalid tooltip",Le.tooltip),!1):Le.command!==void 0&&!Le.command.command?(console.log("INVALID tree item, invalid command",Le.command),!1):Le.collapsibleState!==void 0&&Le.collapsibleState<ci.None&&Le.collapsibleState>ci.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Le.collapsibleState),!1):Le.contextValue!==void 0&&!(0,k.$zf)(Le.contextValue)?(console.log("INVALID tree item, invalid contextValue",Le.contextValue),!1):Le.accessibilityInformation!==void 0&&!Le.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Le.accessibilityInformation),!1):!0}constructor(q,Ee=ci.None){this.collapsibleState=Ee,$.URI.isUri(q)?this.resourceUri=q:this.label=q}};e.$eL=$t,e.$eL=$t=T=He([B],$t);var ci;(function(K){K[K.None=0]="None",K[K.Collapsed=1]="Collapsed",K[K.Expanded=2]="Expanded"})(ci||(e.TreeItemCollapsibleState=ci={}));var Gt;(function(K){K[K.Unchecked=0]="Unchecked",K[K.Checked=1]="Checked"})(Gt||(e.TreeItemCheckboxState=Gt={}));let pi=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(q){this.value=q}};e.$fL=pi,e.$fL=pi=He([B],pi);class di extends pi{}e.$gL=di;class Qi extends di{constructor(q){super(""),u.set(this,void 0),et(this,u,q,"f")}asFile(){return Be(this,u,"f")}}e.$hL=Qi,u=new WeakMap;class Rt{constructor(q,Ee,Le,Xe){this.name=q,this.uri=Ee,this._itemId=Le,this.c=Xe}data(){return this.c()}}e.$iL=Rt;let Ii=class{constructor(q){d.add(this),c.set(this,new Map);for(const[Ee,Le]of q??[]){const Xe=Be(this,c,"f").get(Be(this,d,"m",f).call(this,Ee));Xe?Xe.push(Le):Be(this,c,"f").set(Be(this,d,"m",f).call(this,Ee),[Le])}}get(q){return Be(this,c,"f").get(Be(this,d,"m",f).call(this,q))?.[0]}set(q,Ee){Be(this,c,"f").set(Be(this,d,"m",f).call(this,q),[Ee])}forEach(q,Ee){for(const[Le,Xe]of Be(this,c,"f"))for(const tt of Xe)q.call(Ee,tt,Le,this)}*[(c=new WeakMap,d=new WeakSet,Symbol.iterator)](){for(const[q,Ee]of Be(this,c,"f"))for(const Le of Ee)yield[q,Le]}};e.$jL=Ii,f=function(q){return q.toLowerCase()},e.$jL=Ii=He([B],Ii);let Ai=class{constructor(q){this.insertText=q}};e.$kL=Ai,e.$kL=Ai=He([B],Ai);let St=class{constructor(q,Ee){this.label=Ee,this.insertText=q}};e.$lL=St,e.$lL=St=He([B],St);let Xt=class{constructor(q,Ee){this.id=q,this.color=Ee}static isThemeIcon(q){return typeof q.id!="string"?(console.log("INVALID ThemeIcon, invalid id",q.id),!1):!0}};e.$mL=Xt,e.$mL=Xt=He([B],Xt),Xt.File=new Xt("file"),Xt.Folder=new Xt("folder");let vi=class{constructor(q){this.id=q}};e.$nL=vi,e.$nL=vi=He([B],vi);var fi;(function(K){K[K.Global=1]="Global",K[K.Workspace=2]="Workspace",K[K.WorkspaceFolder=3]="WorkspaceFolder"})(fi||(e.ConfigurationTarget=fi={}));let Ri=class{get base(){return this.c}set base(q){this.c=q,this.e=$.URI.file(q)}get baseUri(){return this.e}set baseUri(q){this.e=q,this.c=q.fsPath}constructor(q,Ee){if(typeof q!="string"&&(!q||!$.URI.isUri(q)&&!$.URI.isUri(q.uri)))throw(0,M.$7)("base");if(typeof Ee!="string")throw(0,M.$7)("pattern");typeof q=="string"?this.baseUri=$.URI.file(q):$.URI.isUri(q)?this.baseUri=q:this.baseUri=q.uri,this.pattern=Ee}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$oL=Ri,e.$oL=Ri=He([B],Ri);const Yi=new WeakMap;function Bt(K,q){Yi.set(K,q)}e.$pL=Bt;let ri=class{constructor(q,Ee,Le,Xe){this.enabled=typeof q=="boolean"?q:!0,typeof Ee=="string"&&(this.condition=Ee),typeof Le=="string"&&(this.hitCondition=Le),typeof Xe=="string"&&(this.logMessage=Xe)}get id(){return this.c||(this.c=Yi.get(this)??(0,R.$fg)()),this.c}};e.$qL=ri,e.$qL=ri=He([B],ri);let Li=class extends ri{constructor(q,Ee,Le,Xe,tt){if(super(Ee,Le,Xe,tt),q===null)throw(0,M.$7)("location");this.location=q}};e.$rL=Li,e.$rL=Li=He([B],Li);let ui=class extends ri{constructor(q,Ee,Le,Xe,tt){super(Ee,Le,Xe,tt),this.functionName=q}};e.$sL=ui,e.$sL=ui=He([B],ui);let li=class extends ri{constructor(q,Ee,Le,Xe,tt,ct,mt){if(super(Xe,tt,ct,mt),!Ee)throw(0,M.$7)("dataId");this.label=q,this.dataId=Ee,this.canPersist=Le}};e.$tL=li,e.$tL=li=He([B],li);let dt=class{constructor(q,Ee,Le){this.command=q,this.args=Ee||[],this.options=Le}};e.$uL=dt,e.$uL=dt=He([B],dt);let Mi=class{constructor(q,Ee){this.port=q,this.host=Ee}};e.$vL=Mi,e.$vL=Mi=He([B],Mi);let ei=class{constructor(q){this.path=q}};e.$wL=ei,e.$wL=ei=He([B],ei);let si=class{constructor(q){this.implementation=q}};e.$xL=si,e.$xL=si=He([B],si);let yi=class{constructor(q,Ee,Le){this.session=q,this.threadId=Ee,this.frameId=Le}};e.$yL=yi,e.$yL=yi=He([B],yi);let Fi=class{constructor(q,Ee){this.session=q,this.threadId=Ee}};e.$zL=Fi,e.$zL=Fi=He([B],Fi);let Ti=class{constructor(q,Ee){this.range=q,this.expression=Ee}};e.$AL=Ti,e.$AL=Ti=He([B],Ti);var Xi;(function(K){K[K.Invoke=0]="Invoke",K[K.Automatic=1]="Automatic"})(Xi||(e.InlineCompletionTriggerKind=Xi={}));let Ei=class{constructor(q,Ee){this.range=q,this.text=Ee}};e.$BL=Ei,e.$BL=Ei=He([B],Ei);let Oi=class{constructor(q,Ee,Le=!0){this.range=q,this.variableName=Ee,this.caseSensitiveLookup=Le}};e.$CL=Oi,e.$CL=Oi=He([B],Oi);let ki=class{constructor(q,Ee){this.range=q,this.expression=Ee}};e.$DL=ki,e.$DL=ki=He([B],ki);let oi=class{constructor(q,Ee){this.frameId=q,this.stoppedLocation=Ee}};e.$EL=oi,e.$EL=oi=He([B],oi);var Zi;(function(K){K[K.Changed=1]="Changed",K[K.Created=2]="Created",K[K.Deleted=3]="Deleted"})(Zi||(e.FileChangeType=Zi={}));let mi=N=class extends Error{static FileExists(q){return new N(q,p.FileSystemProviderErrorCode.FileExists,N.FileExists)}static FileNotFound(q){return new N(q,p.FileSystemProviderErrorCode.FileNotFound,N.FileNotFound)}static FileNotADirectory(q){return new N(q,p.FileSystemProviderErrorCode.FileNotADirectory,N.FileNotADirectory)}static FileIsADirectory(q){return new N(q,p.FileSystemProviderErrorCode.FileIsADirectory,N.FileIsADirectory)}static NoPermissions(q){return new N(q,p.FileSystemProviderErrorCode.NoPermissions,N.NoPermissions)}static Unavailable(q){return new N(q,p.FileSystemProviderErrorCode.Unavailable,N.Unavailable)}constructor(q,Ee=p.FileSystemProviderErrorCode.Unknown,Le){super($.URI.isUri(q)?q.toString(!0):q),this.code=Le?.name??"Unknown",(0,p.$ok)(this,Ee),Object.setPrototypeOf(this,N.prototype),typeof Error.captureStackTrace=="function"&&typeof Le=="function"&&Error.captureStackTrace(this,Le)}};e.$FL=mi,e.$FL=mi=N=He([B],mi);let gi=class{constructor(q,Ee,Le){this.start=q,this.end=Ee,this.kind=Le}};e.$GL=gi,e.$GL=gi=He([B],gi);var xi;(function(K){K[K.Comment=1]="Comment",K[K.Imports=2]="Imports",K[K.Region=3]="Region"})(xi||(e.FoldingRangeKind=xi={}));var _i;(function(K){K[K.Collapsed=0]="Collapsed",K[K.Expanded=1]="Expanded"})(_i||(e.CommentThreadCollapsibleState=_i={}));var hi;(function(K){K[K.Editing=0]="Editing",K[K.Preview=1]="Preview"})(hi||(e.CommentMode=hi={}));var en;(function(K){K[K.Published=0]="Published",K[K.Draft=1]="Draft"})(en||(e.CommentState=en={}));var tn;(function(K){K[K.Unresolved=0]="Unresolved",K[K.Resolved=1]="Resolved"})(tn||(e.CommentThreadState=tn={}));class fn{constructor(q,Ee=[]){this.tokenTypes=q,this.tokenModifiers=Ee}}e.$HL=fn;function Si(K){return typeof K>"u"||(0,k.$Af)(K)}class Ni{constructor(q){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.h=0,this.j=new Map,this.k=new Map,this.l=!1,q){this.l=!0;for(let Ee=0,Le=q.tokenTypes.length;Ee<Le;Ee++)this.j.set(q.tokenTypes[Ee],Ee);for(let Ee=0,Le=q.tokenModifiers.length;Ee<Le;Ee++)this.k.set(q.tokenModifiers[Ee],Ee)}}push(q,Ee,Le,Xe,tt){if(typeof q=="number"&&typeof Ee=="number"&&typeof Le=="number"&&typeof Xe=="number"&&(typeof tt=="number"||typeof tt>"u"))return typeof tt>"u"&&(tt=0),this.n(q,Ee,Le,Xe,tt);if(ie.isRange(q)&&typeof Ee=="string"&&Si(Le))return this.m(q,Ee,Le);throw(0,M.$7)()}m(q,Ee,Le){if(!this.l)throw new Error("Legend must be provided in constructor");if(q.start.line!==q.end.line)throw new Error("`range` cannot span multiple lines");if(!this.j.has(Ee))throw new Error("`tokenType` is not in the provided legend");const Xe=q.start.line,tt=q.start.character,ct=q.end.character-q.start.character,mt=this.j.get(Ee);let Wt=0;if(Le)for(const xt of Le){if(!this.k.has(xt))throw new Error("`tokenModifier` is not in the provided legend");const ii=this.k.get(xt);Wt|=1<<ii>>>0}this.n(Xe,tt,ct,mt,Wt)}n(q,Ee,Le,Xe,tt){if(this.f&&(q<this.c||q===this.c&&Ee<this.e)){this.f=!1;const Wt=this.g.length/5|0;let xt=0,ii=0;for(let ni=0;ni<Wt;ni++){let ai=this.g[5*ni],Gi=this.g[5*ni+1];ai===0?(ai=xt,Gi+=ii):ai+=xt,this.g[5*ni]=ai,this.g[5*ni+1]=Gi,xt=ai,ii=Gi}}let ct=q,mt=Ee;this.f&&this.h>0&&(ct-=this.c,ct===0&&(mt-=this.e)),this.g[this.h++]=ct,this.g[this.h++]=mt,this.g[this.h++]=Le,this.g[this.h++]=Xe,this.g[this.h++]=tt,this.c=q,this.e=Ee}static o(q){const Ee=[],Le=q.length/5|0;for(let mt=0;mt<Le;mt++)Ee[mt]=mt;Ee.sort((mt,Wt)=>{const xt=q[5*mt],ii=q[5*Wt];if(xt===ii){const ni=q[5*mt+1],ai=q[5*Wt+1];return ni-ai}return xt-ii});const Xe=new Uint32Array(q.length);let tt=0,ct=0;for(let mt=0;mt<Le;mt++){const Wt=5*Ee[mt],xt=q[Wt+0],ii=q[Wt+1],ni=q[Wt+2],ai=q[Wt+3],Gi=q[Wt+4],Ln=xt-tt,Vn=Ln===0?ii-ct:ii,Ji=5*mt;Xe[Ji+0]=Ln,Xe[Ji+1]=Vn,Xe[Ji+2]=ni,Xe[Ji+3]=ai,Xe[Ji+4]=Gi,tt=xt,ct=ii}return Xe}build(q){return this.f?new ji(new Uint32Array(this.g),q):new ji(Ni.o(this.g),q)}}e.$IL=Ni;class ji{constructor(q,Ee){this.resultId=Ee,this.data=q}}e.$JL=ji;class mn{constructor(q,Ee,Le){this.start=q,this.deleteCount=Ee,this.data=Le}}e.$KL=mn;class Di{constructor(q,Ee){this.resultId=Ee,this.edits=q}}e.$LL=Di;var zi;(function(K){K[K.Separate=0]="Separate",K[K.MergeWithParent=1]="MergeWithParent"})(zi||(e.DebugConsoleMode=zi={}));let Ci=class{constructor(){}};e.$ML=Ci,Ci.Back={iconPath:new Xt("arrow-left")},e.$ML=Ci=He([B],Ci);var Ui;(function(K){K[K.Separator=-1]="Separator",K[K.Default=0]="Default"})(Ui||(e.QuickPickItemKind=Ui={}));var Bi;(function(K){K[K.Info=1]="Info",K[K.Warning=2]="Warning",K[K.Error=3]="Error"})(Bi||(e.InputBoxValidationSeverity=Bi={}));var nn;(function(K){K[K.UI=1]="UI",K[K.Workspace=2]="Workspace"})(nn||(e.ExtensionKind=nn={}));class gn{static validate(q){if(typeof q.badge=="string"){let Ee=(0,g.$af)(q.badge,0);if(Ee<q.badge.length&&(Ee+=(0,g.$af)(q.badge,Ee)),q.badge.length>Ee)throw new Error("The 'badge'-property must be undefined or a short character")}else if(q.badge&&!Xt.isThemeIcon(q.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!q.color&&!q.badge&&!q.tooltip)throw new Error("The decoration is empty");return!0}constructor(q,Ee,Le){this.badge=q,this.tooltip=Ee,this.color=Le}}e.$NL=gn;let Wi=class{constructor(q){this.kind=q}};e.$OL=Wi,e.$OL=Wi=He([B],Wi);var rn;(function(K){K[K.Light=1]="Light",K[K.Dark=2]="Dark",K[K.HighContrast=3]="HighContrast",K[K.HighContrastLight=4]="HighContrastLight"})(rn||(e.ColorThemeKind=rn={}));class Zt{static isNotebookRange(q){return q instanceof Zt?!0:q?typeof q.start=="number"&&typeof q.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(q,Ee){if(q<0)throw(0,M.$7)("start must be positive");if(Ee<0)throw(0,M.$7)("end must be positive");q<=Ee?(this.c=q,this.e=Ee):(this.c=Ee,this.e=q)}with(q){let Ee=this.c,Le=this.e;return q.start!==void 0&&(Ee=q.start),q.end!==void 0&&(Le=q.end),Ee===this.c&&Le===this.e?this:new Zt(Ee,Le)}}e.$PL=Zt;class $i{static validate(q){if(typeof q.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof q.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof q.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(q){return Array.isArray(q)&&q.every(Ee=>$i.isNotebookCellData(Ee))}static isNotebookCellData(q){return!0}constructor(q,Ee,Le,Xe,tt,ct,mt){this.kind=q,this.value=Ee,this.languageId=Le,this.mime=Xe,this.outputs=tt??[],this.metadata=ct,this.executionSummary=mt,$i.validate(this)}}e.$QL=$i;class ze{constructor(q){this.cells=q}}e.$RL=ze;class ti{static isNotebookCellOutputItem(q){return q instanceof a?!0:q?typeof q.mime=="string"&&q.data instanceof Uint8Array:!1}static error(q){const Ee={name:q.name,message:q.message,stack:q.stack};return a.json(Ee,"application/vnd.code.notebook.error")}static stdout(q){return a.text(q,"application/vnd.code.notebook.stdout")}static stderr(q){return a.text(q,"application/vnd.code.notebook.stderr")}static bytes(q,Ee="application/octet-stream"){return new a(q,Ee)}static text(q,Ee=A.$Ur.text){const Le=Be(a,a,"f",t).encode(String(q));return new a(Le,Ee)}static json(q,Ee="text/x-json"){const Le=JSON.stringify(q,void 0,"	");return a.text(Le,Ee)}constructor(q,Ee){this.data=q,this.mime=Ee;const Le=(0,A.$Yr)(Ee,!0);if(!Le)throw new Error(`INVALID mime type: ${Ee}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Le}}e.$SL=ti,a=ti,t={value:new TextEncoder};class bi{static isNotebookCellOutput(q){return q instanceof bi?!0:!q||typeof q!="object"?!1:typeof q.id=="string"&&Array.isArray(q.items)}static ensureUniqueMimeTypes(q,Ee=!1){const Le=new Set,Xe=new Set;for(let tt=0;tt<q.length;tt++){const ct=q[tt],mt=(0,A.$Yr)(ct.mime);if(!Le.has(mt)||(0,D.$zI)(mt)){Le.add(mt);continue}Xe.add(tt),Ee&&console.warn(`DUPLICATED mime type '${ct.mime}' will be dropped`)}return Xe.size===0?q:q.filter((tt,ct)=>!Xe.has(ct))}constructor(q,Ee,Le){this.items=bi.ensureUniqueMimeTypes(q,!0),typeof Ee=="string"?(this.id=Ee,this.metadata=Le):(this.id=(0,R.$fg)(),this.metadata=Ee??Le)}}e.$TL=bi;var wt;(function(K){K[K.Markup=1]="Markup",K[K.Code=2]="Code"})(wt||(e.NotebookCellKind=wt={}));var sn;(function(K){K[K.Idle=1]="Idle",K[K.Pending=2]="Pending",K[K.Executing=3]="Executing"})(sn||(e.NotebookCellExecutionState=sn={}));var on;(function(K){K[K.Left=1]="Left",K[K.Right=2]="Right"})(on||(e.NotebookCellStatusBarAlignment=on={}));var qi;(function(K){K[K.Default=0]="Default",K[K.InCenter=1]="InCenter",K[K.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",K[K.AtTop=3]="AtTop"})(qi||(e.NotebookEditorRevealType=qi={}));class $n{constructor(q,Ee){this.text=q,this.alignment=Ee}}e.$UL=$n;var wi;(function(K){K[K.Default=1]="Default",K[K.Preferred=2]="Preferred"})(wi||(e.NotebookControllerAffinity=wi={}));var an;(function(K){K[K.Default=1]="Default",K[K.Preferred=2]="Preferred",K[K.Hidden=-1]="Hidden"})(an||(e.NotebookControllerAffinity2=an={}));class bn{constructor(q,Ee=[]){this.uri=q,this.provides=(0,y.$3b)(Ee)}}e.$VL=bn;class wn{constructor(q){this.label=q}}e.$WL=wn;let Pi=class{constructor(q,Ee){this.label=q,this.timestamp=Ee}};e.$XL=Pi,e.$XL=Pi=He([B],Pi);var cn;(function(K){K[K.Production=1]="Production",K[K.Development=2]="Development",K[K.Test=3]="Test"})(cn||(e.ExtensionMode=cn={}));var un;(function(K){K[K.Node=1]="Node",K[K.Webworker=2]="Webworker"})(un||(e.ExtensionRuntime=un={}));var ln;(function(K){K[K.Other=0]="Other",K[K.Comment=1]="Comment",K[K.String=2]="String",K[K.RegEx=3]="RegEx"})(ln||(e.StandardTokenType=ln={}));class pn{constructor(q,Ee){this.ranges=q,this.wordPattern=Ee}}e.$YL=pn;class vn{constructor(q){this.c=q}get autoForwardAction(){return this.c}}e.$ZL=vn;var hn;(function(K){K[K.Queued=1]="Queued",K[K.Running=2]="Running",K[K.Passed=3]="Passed",K[K.Failed=4]="Failed",K[K.Skipped=5]="Skipped",K[K.Errored=6]="Errored"})(hn||(e.TestResultState=hn={}));var dn;(function(K){K[K.Run=1]="Run",K[K.Debug=2]="Debug",K[K.Coverage=3]="Coverage"})(dn||(e.TestRunProfileKind=dn={}));let Vi=class{constructor(q=void 0,Ee=void 0,Le=void 0,Xe=!1){this.include=q,this.exclude=Ee,this.profile=Le,this.continuous=Xe}};e.$1L=Vi,e.$1L=Vi=He([B],Vi);let Ki=j=class{static diff(q,Ee,Le){const Xe=new j(q);return Xe.expectedOutput=Ee,Xe.actualOutput=Le,Xe}constructor(q){this.message=q}};e.$2L=Ki,e.$2L=Ki=j=He([B],Ki);let Hi=class{constructor(q){this.id=q}};e.$3L=Hi,e.$3L=Hi=He([B],Hi);let pe=class{constructor(q,Ee){this.covered=q,this.total=Ee}};e.$4L=pe,e.$4L=pe=He([B],pe);let ke=U=class{static fromDetails(q,Ee){const Le=new pe(0,0),Xe=new pe(0,0),tt=new pe(0,0);for(const mt of Ee)if("branches"in mt){Le.total+=1,Le.covered+=mt.executionCount>0?1:0;for(const Wt of mt.branches)Xe.total+=1,Xe.covered+=Wt.executionCount>0?1:0}else tt.total+=1,tt.covered+=mt.executionCount>0?1:0;const ct=new U(q,Le,Xe.total>0?Xe:void 0,tt.total>0?tt:void 0);return ct.detailedCoverage=Ee,ct}constructor(q,Ee,Le,Xe){this.uri=q,this.statementCoverage=Ee,this.branchCoverage=Le,this.functionCoverage=Xe}};e.$5L=ke,e.$5L=ke=U=He([B],ke);let je=class{constructor(q,Ee,Le=[]){this.executionCount=q,this.location=Ee,this.branches=Le}};e.$6L=je,e.$6L=je=He([B],je);let at=class{constructor(q,Ee){this.executionCount=q,this.location=Ee}};e.$7L=at,e.$7L=at=He([B],at);let vt=class{constructor(q,Ee){this.executionCount=q,this.location=Ee}};e.$8L=vt,e.$8L=vt=He([B],vt);var Lt;(function(K){K[K.None=0]="None",K[K.Option=1]="Option",K[K.Default=2]="Default",K[K.Preferred=3]="Preferred"})(Lt||(e.ExternalUriOpenerPriority=Lt={}));var yn;(function(K){K[K.Untrusted=0]="Untrusted",K[K.Trusted=1]="Trusted",K[K.Unspecified=2]="Unspecified"})(yn||(e.WorkspaceTrustState=yn={}));var En;(function(K){K[K.Notify=1]="Notify",K[K.OpenBrowser=2]="OpenBrowser",K[K.OpenPreview=3]="OpenPreview",K[K.Silent=4]="Silent",K[K.Ignore=5]="Ignore",K[K.OpenBrowserOnce=6]="OpenBrowserOnce"})(En||(e.PortAutoForwardAction=En={}));class Mn{constructor(q,Ee,Le,Xe,tt,ct){this.kind=q,this.name=Ee,this.detail=Le,this.uri=Xe,this.range=tt,this.selectionRange=ct}}e.$9L=Mn;class Fn{constructor(q){this.uri=q}}e.$0L=Fn;class Tn{constructor(q,Ee){this.original=q,this.modified=Ee}}e.$$L=Tn;class On{constructor(q,Ee,Le,Xe){this.base=q,this.input1=Ee,this.input2=Le,this.result=Xe}}e.$_L=On;class Nn{constructor(q,Ee){this.uri=q,this.viewType=Ee}}e.$aM=Nn;class jn{constructor(q){this.viewType=q}}e.$bM=jn;class zn{constructor(q,Ee){this.uri=q,this.notebookType=Ee}}e.$cM=zn;class Un{constructor(q,Ee,Le){this.original=q,this.modified=Ee,this.notebookType=Le}}e.$dM=Un;class Bn{constructor(){}}e.$eM=Bn;class Wn{constructor(q,Ee){this.uri=q,this.inputBoxUri=Ee}}e.$fM=Wn;var kn;(function(K){K[K.Down=0]="Down",K[K.Up=1]="Up"})(kn||(e.InteractiveSessionVoteDirection=kn={}));var Sn;(function(K){K[K.Action=1]="Action",K[K.Toolbar=2]="Toolbar"})(Sn||(e.InteractiveSessionCopyKind=Sn={}));var Dn;(function(K){K[K.Unhelpful=0]="Unhelpful",K[K.Helpful=1]="Helpful",K[K.Undone=2]="Undone",K[K.Accepted=3]="Accepted"})(Dn||(e.InteractiveEditorResponseFeedbackKind=Dn={}));var Cn;(function(K){K[K.System=0]="System",K[K.User=1]="User",K[K.Assistant=2]="Assistant",K[K.Function=3]="Function"})(Cn||(e.ChatMessageRole=Cn={}));var Pn;(function(K){K[K.Short=1]="Short",K[K.Medium=2]="Medium",K[K.Full=3]="Full"})(Pn||(e.ChatVariableLevel=Pn={}));class qn{constructor(q,Ee){this.role=q,this.content=Ee}}e.$gM=qn;var In;(function(K){K[K.Unhelpful=0]="Unhelpful",K[K.Helpful=1]="Helpful"})(In||(e.ChatAgentResultFeedbackKind=In={}));var An;(function(K){K[K.SymbolInformation=1]="SymbolInformation",K[K.CommandInformation=2]="CommandInformation",K[K.SearchInformation=3]="SearchInformation",K[K.SettingInformation=4]="SettingInformation"})(An||(e.RelatedInformationType=An={}));var Rn;(function(K){K[K.Started=1]="Started",K[K.Recognizing=2]="Recognizing",K[K.Recognized=3]="Recognized",K[K.Stopped=4]="Stopped"})(Rn||(e.SpeechToTextStatus=Rn={}))}),define(De[142],Ce([1,0,58,18,16,177,128,7,19]),function(re,e,y,M,l,L,A,g,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vM=e.$uM=e.$tM=void 0;const $=new Map;function R(D,E){E?$.set(D,E):$.delete(D)}e.$tM=R;function P(D){return $.get(D)}class p extends L.$1u{constructor(E,h,u,d,c,f,a,t){super(h,u,d,c),this.c=E,this.m=f,this.q=a,this.notebook=t,this.b=!1}dispose(){(0,y.ok)(!this.b),this.b=!0,this.q=!1}equalLines(E){return(0,k.$ub)(this.f,E)}get document(){if(!this.a){const E=this;this.a={get uri(){return E.d},get fileName(){return E.d.fsPath},get isUntitled(){return E.d.scheme===M.Schemas.untitled},get languageId(){return E.m},get version(){return E.h},get isClosed(){return E.b},get isDirty(){return E.q},save(){return E.r()},getText(h){return h?E.s(h):E.getText()},get eol(){return E.g===`
`?g.EndOfLine.LF:g.EndOfLine.CRLF},get lineCount(){return E.f.length},lineAt(h){return E.t(h)},offsetAt(h){return E.u(h)},positionAt(h){return E.v(h)},validateRange(h){return E.w(h)},validatePosition(h){return E.x(h)},getWordRangeAtPosition(h,u){return E.y(h,u)}}}return Object.freeze(this.a)}_acceptLanguageId(E){(0,y.ok)(!this.b),this.m=E}_acceptIsDirty(E){(0,y.ok)(!this.b),this.q=E}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(E){const h=this.w(E);if(h.isEmpty)return"";if(h.isSingleLine)return this.f[h.start.line].substring(h.start.character,h.end.character);const u=this.g,d=h.start.line,c=h.end.line,f=[];f.push(this.f[d].substring(h.start.character));for(let a=d+1;a<c;a++)f.push(this.f[a]);return f.push(this.f[c].substring(0,h.end.character)),f.join(u)}t(E){let h;if(E instanceof g.$tK?h=E.line:typeof E=="number"&&(h=E),typeof h!="number"||h<0||h>=this.f.length||Math.floor(h)!==h)throw new Error("Illegal value for `line`");return new S(h,this.f[h],h===this.f.length-1)}u(E){return E=this.x(E),this.l(),this.j.getPrefixSum(E.line-1)+E.character}v(E){E=Math.floor(E),E=Math.max(0,E),this.l();const h=this.j.getIndexOf(E),u=this.f[h.index].length;return new g.$tK(h.index,Math.min(h.remainder,u))}w(E){if(!(E instanceof g.$uK))throw new Error("Invalid argument");const h=this.x(E.start),u=this.x(E.end);return h===E.start&&u===E.end?E:new g.$uK(h.line,h.character,u.line,u.character)}x(E){if(!(E instanceof g.$tK))throw new Error("Invalid argument");if(this.f.length===0)return E.with(0,0);let{line:h,character:u}=E,d=!1;if(h<0)h=0,u=0,d=!0;else if(h>=this.f.length)h=this.f.length-1,u=this.f[h].length,d=!0;else{const c=this.f[h].length;u<0?(u=0,d=!0):u>c&&(u=c,d=!0)}return d?new g.$tK(h,u):E}y(E,h){const u=this.x(E);if(!h)h=P(this.m);else if((0,l.$Pe)(h))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${h.source}' because it matches the empty string.`);const d=(0,A.$as)(u.character+1,(0,A.$$r)(h),this.f[u.line],0);if(d)return new g.$uK(u.line,d.startColumn-1,u.line,d.endColumn-1)}}e.$uM=p;class S{constructor(E,h,u){this.a=E,this.b=h,this.c=u}get lineNumber(){return this.a}get text(){return this.b}get range(){return new g.$uK(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new g.$uK(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$vM=S}),define(De[275],Ce([1,0,7,20,4]),function(re,e,y,M,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dec=void 0;let L=class{constructor(g){this.a=new y.$OL(y.ColorThemeKind.Dark),this.b=new l.$Od}get activeColorTheme(){return this.a}$onColorThemeChange(g){let k;switch(g){case"light":k=y.ColorThemeKind.Light;break;case"hcDark":k=y.ColorThemeKind.HighContrast;break;case"hcLight":k=y.ColorThemeKind.HighContrastLight;break;default:k=y.ColorThemeKind.Dark}this.a=new y.$OL(k),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$dec=L,e.$dec=L=He([We(0,M.$rM)],L)}),define(De[276],Ce([1,0,5]),function(re,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DI=e.CellExecutionUpdateType=void 0;var M;(function(l){l[l.Output=1]="Output",l[l.OutputItems=2]="OutputItems",l[l.ExecutionState=3]="ExecutionState"})(M||(e.CellExecutionUpdateType=M={})),e.$DI=(0,y.$Qh)("INotebookExecutionService")}),define(De[68],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jJ=e.TestPosition=e.TestIdPathParts=void 0;var y;(function(L){L.Delimiter="\0"})(y||(e.TestIdPathParts=y={}));var M;(function(L){L[L.IsSame=0]="IsSame",L[L.Disconnected=1]="Disconnected",L[L.IsChild=2]="IsChild",L[L.IsParent=3]="IsParent"})(M||(e.TestPosition=M={}));class l{static fromExtHostTestItem(A,g,k=A.parent){if(A._isRoot)return new l([g]);const $=[A.id];for(let R=k;R&&R.id!==g;R=R.parent)$.push(R.id);return $.push(g),new l($.reverse())}static isRoot(A){return!A.includes("\0")}static root(A){const g=A.indexOf("\0");return g===-1?A:A.slice(0,g)}static fromString(A){return new l(A.split("\0"))}static join(A,g){return new l([...A.path,g])}static joinToString(A,g){return A.toString()+"\0"+g}static parentId(A){const g=A.lastIndexOf("\0");return g===-1?void 0:A.slice(0,g)}static localId(A){const g=A.lastIndexOf("\0");return g===-1?A:A.slice(g+1)}static isChild(A,g){return g.startsWith(A)&&g[A.length]==="\0"}static compare(A,g){return A===g?0:l.isChild(A,g)?2:l.isChild(g,A)?3:1}constructor(A,g=A.length){if(this.path=A,this.d=g,A.length===0||g<1)throw new Error("cannot create test with empty path")}get rootId(){return new l(this.path,1)}get parentId(){return this.d>1?new l(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let A=1;A<=this.d;A++)yield new l(this.path,A)}*idsToRoot(){for(let A=this.d;A>0;A--)yield new l(this.path,A)}compare(A){if(typeof A=="string")return l.compare(this.toString(),A);for(let g=0;g<A.d&&g<this.d;g++)if(A.path[g]!==this.path[g])return 1;return A.d>this.d?2:A.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let A=1;A<this.d;A++)this.c+="\0",this.c+=this.path[A]}return this.c}}e.$jJ=l}),define(De[87],Ce([1,0,2,33,68]),function(re,e,y,M,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qJ=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.$pJ=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$oJ=e.$nJ=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$mJ=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$lJ=e.$kJ=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.TestResultState=void 0;var L;(function(C){C[C.Unset=0]="Unset",C[C.Queued=1]="Queued",C[C.Running=2]="Running",C[C.Passed=3]="Passed",C[C.Failed=4]="Failed",C[C.Skipped=5]="Skipped",C[C.Errored=6]="Errored"})(L||(e.TestResultState=L={}));var A;(function(C){C[C.Run=1]="Run",C[C.Debug=2]="Debug",C[C.Coverage=3]="Coverage"})(A||(e.ExtTestRunProfileKind=A={}));var g;(function(C){C[C.Run=2]="Run",C[C.Debug=4]="Debug",C[C.Coverage=8]="Coverage",C[C.HasNonDefaultProfile=16]="HasNonDefaultProfile",C[C.HasConfigurable=32]="HasConfigurable",C[C.SupportsContinuousRun=64]="SupportsContinuousRun"})(g||(e.TestRunProfileBitset=g={})),e.$kJ=[2,4,8,16,32,64];const k=C=>"runId"in C;e.$lJ=k;var $;(function(C){C.serialize=w=>({range:w.range.toJSON(),uri:w.uri.toJSON()}),C.deserialize=w=>({range:M.$ys.lift(w.range),uri:y.URI.revive(w.uri)})})($||(e.IRichLocation=$={}));var R;(function(C){C[C.Error=0]="Error",C[C.Output=1]="Output"})(R||(e.TestMessageType=R={}));var P;(function(C){C.serialize=w=>({message:w.message,type:0,expected:w.expected,actual:w.actual,contextValue:w.contextValue,location:w.location&&$.serialize(w.location)}),C.deserialize=w=>({message:w.message,type:0,expected:w.expected,actual:w.actual,contextValue:w.contextValue,location:w.location&&$.deserialize(w.location)})})(P||(e.ITestErrorMessage=P={}));const p=(C,w)=>`${w?"s":"e"}${C}`;e.$mJ=p;var S;(function(C){C.serialize=w=>({message:w.message,type:1,offset:w.offset,length:w.length,location:w.location&&$.serialize(w.location)}),C.deserialize=w=>({message:w.message,type:1,offset:w.offset,length:w.length,location:w.location&&$.deserialize(w.location)})})(S||(e.ITestOutputMessage=S={}));var D;(function(C){C.serialize=w=>w.type===0?P.serialize(w):S.serialize(w),C.deserialize=w=>w.type===0?P.deserialize(w):S.deserialize(w)})(D||(e.ITestMessage=D={}));var E;(function(C){C.serializeWithoutMessages=w=>({state:w.state,duration:w.duration,messages:[]}),C.serialize=w=>({state:w.state,duration:w.duration,messages:w.messages.map(D.serialize)}),C.deserialize=w=>({state:w.state,duration:w.duration,messages:w.messages.map(D.deserialize)})})(E||(e.ITestTaskState=E={}));const h="\0",u=(C,w)=>C+h+w;e.$nJ=u;const d=C=>{const w=C.indexOf(h);return{ctrlId:C.slice(0,w),tagId:C.slice(w+1)}};e.$oJ=d;var c;(function(C){C.serialize=w=>({extId:w.extId,label:w.label,tags:w.tags,busy:w.busy,children:void 0,uri:w.uri?.toJSON(),range:w.range?.toJSON()||null,description:w.description,error:w.error,sortText:w.sortText}),C.deserialize=w=>({extId:w.extId,label:w.label,tags:w.tags,busy:w.busy,children:void 0,uri:w.uri?y.URI.revive(w.uri):void 0,range:w.range?M.$ys.lift(w.range):null,description:w.description,error:w.error,sortText:w.sortText})})(c||(e.ITestItem=c={}));var f;(function(C){C[C.NotExpandable=0]="NotExpandable",C[C.Expandable=1]="Expandable",C[C.BusyExpanding=2]="BusyExpanding",C[C.Expanded=3]="Expanded"})(f||(e.TestItemExpandState=f={}));var a;(function(C){C.serialize=w=>({expand:w.expand,item:c.serialize(w.item)}),C.deserialize=w=>({controllerId:l.$jJ.root(w.item.extId),expand:w.expand,item:c.deserialize(w.item)})})(a||(e.InternalTestItem=a={}));var t;(function(C){C.serialize=w=>{let m;return w.item&&(m={},w.item.label!==void 0&&(m.label=w.item.label),w.item.tags!==void 0&&(m.tags=w.item.tags),w.item.busy!==void 0&&(m.busy=w.item.busy),w.item.uri!==void 0&&(m.uri=w.item.uri?.toJSON()),w.item.range!==void 0&&(m.range=w.item.range?.toJSON()),w.item.description!==void 0&&(m.description=w.item.description),w.item.error!==void 0&&(m.error=w.item.error),w.item.sortText!==void 0&&(m.sortText=w.item.sortText)),{extId:w.extId,expand:w.expand,item:m}},C.deserialize=w=>{let m;return w.item&&(m={},w.item.label!==void 0&&(m.label=w.item.label),w.item.tags!==void 0&&(m.tags=w.item.tags),w.item.busy!==void 0&&(m.busy=w.item.busy),w.item.range!==void 0&&(m.range=w.item.range?M.$ys.lift(w.item.range):null),w.item.description!==void 0&&(m.description=w.item.description),w.item.error!==void 0&&(m.error=w.item.error),w.item.sortText!==void 0&&(m.sortText=w.item.sortText)),{extId:w.extId,expand:w.expand,item:m}}})(t||(e.ITestItemUpdate=t={}));const i=(C,w)=>{w.expand!==void 0&&(C.expand=w.expand),w.item!==void 0&&(C.item=C.item?Object.assign(C.item,w.item):w.item)};e.$pJ=i;var s;(function(C){C.serializeWithoutMessages=w=>({...a.serialize(w),ownComputedState:w.ownComputedState,computedState:w.computedState,tasks:w.tasks.map(E.serializeWithoutMessages)}),C.serialize=w=>({...a.serialize(w),ownComputedState:w.ownComputedState,computedState:w.computedState,tasks:w.tasks.map(E.serialize)}),C.deserialize=w=>({...a.deserialize(w),ownComputedState:w.ownComputedState,computedState:w.computedState,tasks:w.tasks.map(E.deserialize),retired:!0})})(s||(e.TestResultItem=s={}));var n;(function(C){C[C.Function=0]="Function",C[C.Statement=1]="Statement"})(n||(e.DetailType=n={}));var r;(function(C){C[C.Add=0]="Add",C[C.Update=1]="Update",C[C.DocumentSynced=2]="DocumentSynced",C[C.Remove=3]="Remove",C[C.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",C[C.Retire=5]="Retire",C[C.AddTag=6]="AddTag",C[C.RemoveTag=7]="RemoveTag"})(r||(e.TestDiffOpType=r={}));var o;(function(C){C.deserialize=w=>w.op===0?{op:w.op,item:a.deserialize(w.item)}:w.op===1?{op:w.op,item:t.deserialize(w.item)}:w.op===2?{op:w.op,uri:y.URI.revive(w.uri),docv:w.docv}:w,C.serialize=w=>w.op===0?{op:w.op,item:a.serialize(w.item)}:w.op===1?{op:w.op,item:t.serialize(w.item)}:w})(o||(e.TestsDiffOp=o={}));class v{constructor(){this.c=new Map,this.d=new Map,this.f=new Set,this.g=0,this.h=0,this.tags=this.c}apply(w){const m=this.o();for(const b of w)switch(b.op){case 0:this.j(a.deserialize(b.item),m);break;case 1:this.k(t.deserialize(b.item),m);break;case 3:this.l(b.itemId,m);break;case 5:this.m(b.itemId);break;case 4:this.updatePendingRoots(b.amount);break;case 6:this.c.set(b.tag.id,b.tag);break;case 7:this.c.delete(b.id);break}m.complete?.()}j(w,m){const b=l.$jJ.parentId(w.item.extId)?.toString();let I;if(!b)I=this.p(w),this.f.add(I),this.d.set(w.item.extId,I);else if(this.d.has(b)){const z=this.d.get(b);z.children.add(w.item.extId),I=this.p(w,z),this.d.set(w.item.extId,I)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(w)}`);return}return m.add?.(I),w.expand===2&&this.g++,I}k(w,m){const b=this.d.get(w.extId);if(b)return w.expand!==void 0&&(b.expand===2&&this.g--,w.expand===2&&this.g++),(0,e.$pJ)(b,w),m.update?.(b),b}l(w,m){const b=this.d.get(w);if(!b)return;const I=l.$jJ.parentId(b.item.extId)?.toString();I?this.d.get(I).children.delete(b.item.extId):this.f.delete(b);const z=[[w]];for(;z.length;)for(const O of z.pop()){const F=this.d.get(O);F&&(z.push(F.children),this.d.delete(O),m.remove?.(F,F!==b),F.expand===2&&this.g--)}}m(w){}updatePendingRoots(w){this.h+=w}o(){return{}}}e.$qJ=v}),define(De[110],Ce([1,0,8,4,3,58,87,68]),function(re,e,y,M,l,L,A,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lM=e.$kM=e.$jM=e.$iM=e.$hM=e.TestItemEventOp=void 0;var k;(function(d){d[d.Upsert=0]="Upsert",d[d.SetTags=1]="SetTags",d[d.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",d[d.RemoveChild=3]="RemoveChild",d[d.SetProp=4]="SetProp",d[d.Bulk=5]="Bulk",d[d.DocumentSynced=6]="DocumentSynced"})(k||(e.TestItemEventOp=k={}));const $=(d,c)=>d===c,P=Object.entries({range:(d,c)=>d===c?!0:!d||!c?!1:d.equalsRange(c),busy:$,label:$,description:$,error:$,sortText:$,tags:(d,c)=>!(d.length!==c.length||d.some(f=>!c.includes(f)))}),p=(d,c)=>{let f;for(const[a,t]of P)t(d[a],c[a])||(f?f[a]=c[a]:f={[a]:c[a]});return f};class S extends l.$Sc{get root(){return this.s.root}constructor(c){super(),this.s=c,this.f=this.B(new y.$7g(()=>this.flushDiff(),200)),this.g=this.B(new M.$Od),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.y(this.root,void 0)}set resolveHandler(c){this.h=c;for(const f of this.tree.values())this.I(f)}get resolveHandler(){return this.h}collectDiff(){const c=this.m;return this.m=[],c}pushDiff(c){switch(c.op){case 2:{for(const f of this.m)if(f.op===2&&f.uri===c.uri){f.docv=c.docv;return}break}case 1:{const f=this.m[this.m.length-1];if(f){if(f.op===1&&f.item.extId===c.item.extId){(0,A.$pJ)(f.item,c.item);return}if(f.op===0&&f.item.item.extId===c.item.extId){(0,A.$pJ)(f.item,c.item);return}}break}}this.m.push(c),this.f.isScheduled()||this.f.schedule()}expand(c,f){const a=this.tree.get(c);if(a){if((a.expandLevels===void 0||f>a.expandLevels)&&(a.expandLevels=f),a.expand===1){const t=this.L(a);return t.isOpen()?this.J(a,f-1):t.wait().then(()=>this.J(a,f-1))}else if(a.expand===3)return a.resolveBarrier?.isOpen()===!1?a.resolveBarrier.wait().then(()=>this.J(a,f-1)):this.J(a,f-1)}}dispose(){for(const c of this.tree.values())this.s.getApiFor(c.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}u(c,f){switch(f.op){case 3:this.N(g.$jJ.joinToString(c.fullId,f.id));break;case 0:this.y(f.item,c);break;case 5:for(const a of f.ops)this.u(c,a);break;case 1:this.z(f.new,f.old,c.fullId.toString());break;case 2:this.I(c);break;case 4:this.pushDiff({op:1,item:{extId:c.fullId.toString(),item:f.update}});break;case 6:this.w(c.actual.uri);break;default:(0,L.$4c)(f)}}w(c){c&&this.pushDiff({op:2,uri:c,docv:this.s.getDocumentVersion(c)})}y(c,f){const a=g.$jJ.fromExtHostTestItem(c,this.root.id,f?.actual),t=this.s.getApiFor(c);t.parent&&t.parent!==f?.actual&&this.s.getChildren(t.parent).delete(c.id);let i=this.tree.get(a.toString());if(!i){i={fullId:a,actual:c,expandLevels:f?.expandLevels?f.expandLevels-1:void 0,expand:0},c.tags.forEach(this.C,this),this.tree.set(i.fullId.toString(),i),this.F(c,f),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:i.expand,item:this.s.toITestItem(c)}}),this.H(c,i,f);return}if(i.actual===c){this.G(c,i,f);return}if(i.actual.uri?.toString()!==c.uri?.toString())return this.N(a.toString()),this.y(c,f);const s=this.s.getChildren(i.actual),n=i.actual,r=p(this.s.toITestItem(n),this.s.toITestItem(c));this.s.getApiFor(n).listener=void 0,i.actual=c,i.expand=0,r&&(r.hasOwnProperty("tags")&&(this.z(c.tags,n.tags,a.toString()),delete r.tags),this.u(i,{op:4,update:r})),this.H(c,i,f);for(const[o,v]of s)this.s.getChildren(c).get(v.id)||this.N(g.$jJ.joinToString(a,v.id));this.w(i.actual.uri)}z(c,f,a){const t=new Set(f.map(i=>i.id));for(const i of c)t.delete(i.id)||this.C(i);this.pushDiff({op:1,item:{extId:a,item:{tags:c.map(i=>(0,A.$nJ)(this.s.controllerId,i.id))}}}),t.forEach(this.D,this)}C(c){const f=this.j.get(c.id);f?f.refCount++:(this.j.set(c.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,A.$nJ)(this.s.controllerId,c.id)}}))}D(c){const f=this.j.get(c);f&&!--f.refCount&&(this.j.delete(c),this.pushDiff({op:7,id:(0,A.$nJ)(this.s.controllerId,c)}))}F(c,f){this.s.getApiFor(c).parent=f&&f.actual!==this.root?f.actual:void 0}G(c,f,a){this.F(c,a);const t=this.s.getApiFor(c);t.parent=a?.actual,t.listener=i=>this.u(f,i),this.I(f)}H(c,f,a){this.G(c,f,a);for(const[t,i]of this.s.getChildren(c))this.y(i,f)}I(c){let f;this.h?c.resolveBarrier?f=c.resolveBarrier.isOpen()?3:2:f=c.actual.canResolveChildren?1:0:f=0,f!==c.expand&&(c.expand=f,this.pushDiff({op:1,item:{extId:c.fullId.toString(),expand:f}}),f===1&&c.expandLevels!==void 0&&this.L(c))}J(c,f){if(f<0)return;const a=[];for(const[t,i]of this.s.getChildren(c.actual)){const s=this.expand(g.$jJ.joinToString(c.fullId,i.id),f);(0,y.$Hg)(s)&&a.push(s)}if(a.length)return Promise.all(a).then(()=>{})}L(c){if(c.resolveBarrier)return c.resolveBarrier;if(!this.h){const i=new y.$Tg;return i.open(),i}c.expand=2,this.M(c);const f=c.resolveBarrier=new y.$Tg,a=i=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,i)};let t;try{t=this.h(c.actual===this.root?void 0:c.actual)}catch(i){a(i)}return(0,y.$Hg)(t)?t.catch(a).then(()=>{f.open(),this.I(c)}):(f.open(),this.I(c)),c.resolveBarrier}M(c){this.pushDiff({op:1,item:{extId:c.fullId.toString(),expand:c.expand}})}N(c){const f=this.tree.get(c);if(!f)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:c});const a=[f];for(;a.length;){const t=a.pop();if(t){this.s.getApiFor(t.actual).listener=void 0;for(const i of t.actual.tags)this.D(i.id);this.tree.delete(t.fullId.toString());for(const[i,s]of this.s.getChildren(t.actual))a.push(this.tree.get(g.$jJ.joinToString(t.fullId,s.id)))}}}flushDiff(){const c=this.collectDiff();c.length&&this.g.fire(c)}}e.$hM=S;class D extends Error{constructor(c){super(`Attempted to insert a duplicate test item ID ${c}`)}}e.$iM=D;class E extends Error{constructor(c){super(`TestItem with ID "${c}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$jM=E;class h extends Error{constructor(c,f,a){super(`TestItem with ID "${c}" is from controller "${f}" and cannot be added as a child of an item from controller "${a}".`)}}e.$kM=h;const u=(d,c,f)=>{let a=new Map;return{get size(){return a.size},forEach(t,i){for(const s of a.values())t.call(i,s,this)},[Symbol.iterator](){return a.entries()},replace(t){const i=new Map,s=new Set(a.keys()),n={op:5,ops:[]};for(const r of t){if(!(r instanceof f))throw new E(r.id);const o=c(r).controllerId;if(o!==d.controllerId)throw new h(r.id,o,d.controllerId);if(i.has(r.id))throw new D(r.id);i.set(r.id,r),s.delete(r.id),n.ops.push({op:0,item:r})}for(const r of s.keys())n.ops.push({op:3,id:r});d.listener?.(n),a=i},add(t){if(!(t instanceof f))throw new E(t.id);a.set(t.id,t),d.listener?.({op:0,item:t})},delete(t){a.delete(t)&&d.listener?.({op:3,id:t})},get(t){return a.get(t)},toJSON(){return Array.from(a.values())}}};e.$lM=u}),define(De[143],Ce([1,0,110]),function(re,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nM=e.$mM=void 0;const M=new WeakMap,l=(A,g)=>{const k={controllerId:g};return M.set(A,k),k};e.$mM=l;const L=A=>{const g=M.get(A);if(!g)throw new y.$jM(A?.id||"<unknown>");return g};e.$nM=L}),define(De[111],Ce([1,0,18,2]),function(re,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tpb=e.$spb=e.$rpb=e.$qpb=e.$ppb=void 0,e.$ppb="vscode-cdn.net",e.$qpb=`vscode-resource.${e.$ppb}`,e.$rpb=`'self' https://*.${e.$ppb}`;function l(g,k){return g.scheme===y.Schemas.http||g.scheme===y.Schemas.https?g:(k&&k.authority&&k.isRemote&&g.scheme===y.Schemas.file&&(g=M.URI.from({scheme:y.Schemas.vscodeRemote,authority:k.authority,path:g.path})),M.URI.from({scheme:y.Schemas.https,authority:`${g.scheme}+${L(g.authority)}.${e.$qpb}`,path:g.path,fragment:g.fragment,query:g.query}))}e.$spb=l;function L(g){return g.replace(/./g,k=>{const $=k.charCodeAt(0);return $>=97&&$<=122||$>=65&&$<=90||$>=48&&$<=57?k:"-"+$.toString(16).padStart(4,"0")})}function A(g){return g.replace(/-([0-9a-f]{4})/g,(k,$)=>String.fromCharCode(parseInt($,16)))}e.$tpb=A}),define(De[277],Ce([1,0,4,3,111]),function(re,e,y,M,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ndc=void 0;class L{constructor(g,k,$){this.d=g,this.e=k,this.f=$,this.a=0,this.b=new M.$Rc,this.c=new Map,this.b.add(k.onDidChangeVisibleTextEditors(()=>{const R=k.getVisibleTextEditors();for(const P of this.c.values())R.indexOf(P.editor)<0&&P.inset.dispose()}))}dispose(){this.c.forEach(g=>g.inset.dispose()),this.b.dispose()}createWebviewEditorInset(g,k,$,R,P){let p;for(const c of this.e.getVisibleTextEditors(!0))if(c.value===g){p=c;break}if(!p)throw new Error("not a visible editor");const S=this,D=this.a++,E=new y.$Od,h=new y.$Od,u=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(c){return(0,l.$spb)(c,S.f)}get cspSource(){return l.$rpb}set options(c){this.b=c,S.d.$setOptions(D,c)}get options(){return this.b}set html(c){this.a=c,S.d.$setHtml(D,c)}get html(){return this.a}get onDidReceiveMessage(){return E.event}postMessage(c){return S.d.$postMessage(D,c)}},d=new class{constructor(){this.editor=g,this.line=k,this.height=$,this.webview=u,this.onDidDispose=h.event}dispose(){S.c.has(D)&&(S.c.delete(D),S.d.$disposeEditorInset(D),h.fire(),h.dispose(),E.dispose())}};return this.d.$createEditorInset(D,p.id,p.value.document.uri,k+1,$,R||{},P.identifier,P.extensionLocation),this.c.set(D,{editor:g,inset:d,onDidReceiveMessage:E}),d}$onDidDispose(g){const k=this.c.get(g);k&&k.inset.dispose()}$onDidReceiveMessage(g,k){this.c.get(g)?.onDidReceiveMessage.fire(k)}}e.$Ndc=L}),define(De[278],Ce([1,0,5]),function(re,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eN=e.VariableKind=e.$dN=void 0,e.$dN=(0,y.$Qh)("configurationResolverService");var M;(function(L){L.Unknown="unknown",L.Env="env",L.Config="config",L.Command="command",L.Input="input",L.ExtensionInstallFolder="extensionInstallFolder",L.WorkspaceFolder="workspaceFolder",L.Cwd="cwd",L.WorkspaceFolderBasename="workspaceFolderBasename",L.UserHome="userHome",L.LineNumber="lineNumber",L.SelectedText="selectedText",L.File="file",L.FileWorkspaceFolder="fileWorkspaceFolder",L.RelativeFile="relativeFile",L.RelativeFileDirname="relativeFileDirname",L.FileDirname="fileDirname",L.FileExtname="fileExtname",L.FileBasename="fileBasename",L.FileBasenameNoExtension="fileBasenameNoExtension",L.FileDirnameBasename="fileDirnameBasename",L.ExecPath="execPath",L.ExecInstallFolder="execInstallFolder",L.PathSeparator="pathSeparator"})(M||(e.VariableKind=M={}));class l extends Error{constructor(A,g){super(g),this.variable=A}}e.$eN=l}),define(De[279],Ce([1,0,15,48,17,24,12,99,224,278,16]),function(re,e,y,M,l,L,A,g,k,$,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sN=void 0;class P{constructor(S,D,E,h){this.h=new Map,this.a=S,this.b=D,this.g=E,h&&(this.c=h.then(u=>this.i(u)))}i(S){if(A.$d){const D=Object.create(null);return Object.keys(S).forEach(E=>{D[E.toLowerCase()]=S[E]}),D}return S}resolveWithEnvironment(S,D,E){return this.l({env:this.i(S),userHome:void 0},D?D.uri:void 0,E)}async resolveAsync(S,D){const E={env:await this.c,userHome:await this.g};return this.l(E,S?S.uri:void 0,D)}async j(S,D,E,h){const u=L.$9m(D);A.$d&&u.windows?Object.keys(u.windows).forEach(c=>u[c]=u.windows[c]):A.$e&&u.osx?Object.keys(u.osx).forEach(c=>u[c]=u.osx[c]):A.$f&&u.linux&&Object.keys(u.linux).forEach(c=>u[c]=u.linux[c]),delete u.windows,delete u.osx,delete u.linux;const d={env:await this.c,userHome:await this.g};return this.l(d,S?S.uri:void 0,u,E,h)}async resolveAnyAsync(S,D,E){return this.j(S,D,E)}async resolveAnyMap(S,D,E){const h=new Map;return{newConfig:await this.j(S,D,E,h),resolvedVariables:h}}resolveWithInteractionReplace(S,D,E,h){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(S,D,E,h){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(S,D){if(this.h.has(S))throw new Error("Variable "+S+" is contributed twice.");this.h.set(S,D)}async l(S,D,E,h,u){if(l.$zf(E))return this.m(S,D,E,h,u);if(Array.isArray(E))return Promise.all(E.map(d=>this.l(S,D,d,h,u)));if(l.$Bf(E)){const d=Object.create(null),c=await Promise.all(Object.keys(E).map(async f=>[await this.m(S,D,f,h,u),await this.l(S,D,E[f],h,u)]));for(const[f,a]of c)d[f]=a;return d}return E}m(S,D,E,h,u){return(0,R.$Ue)(E,P.VARIABLE_REGEXP,async(d,c)=>{if(c.includes(P.VARIABLE_LHS))return d;let f=await this.o(S,d,c,D,h);return u?.set(c,f),f!==d&&l.$zf(f)&&f.match(P.VARIABLE_REGEXP)&&(f=await this.m(S,D,f,h,u)),f})}n(S){return this.b?this.b.getUriLabel(S,{noPrefix:!0}):S.fsPath}async o(S,D,E,h,u){let d;const c=E.split(":");c.length>1&&(E=c[0],d=c[1]);const f=i=>{const s=this.a.getFilePath();if(s)return(0,g.$xv)(s);throw new $.$eN(i,(0,k.localize)(0,null,D))},a=i=>{const s=f(i);if(this.a.getWorkspaceFolderPathForFile){const n=this.a.getWorkspaceFolderPathForFile();if(n)return(0,g.$xv)(n)}throw new $.$eN(i,(0,k.localize)(1,null,D,y.$nc(s)))},t=i=>{if(d){const s=this.a.getFolderUri(d);if(s)return s;throw new $.$eN(i,(0,k.localize)(2,null,D,d))}if(h)return h;throw this.a.getWorkspaceFolderCount()>1?new $.$eN(i,(0,k.localize)(3,null,D)):new $.$eN(i,(0,k.localize)(4,null,D))};switch(E){case"env":if(d){if(S.env){const i=S.env[A.$d?d.toLowerCase():d];if(l.$zf(i))return i}return""}throw new $.$eN($.VariableKind.Env,(0,k.localize)(5,null,D));case"config":if(d){const i=this.a.getConfigurationValue(h,d);if(l.$If(i))throw new $.$eN($.VariableKind.Config,(0,k.localize)(6,null,D,d));if(l.$Bf(i))throw new $.$eN($.VariableKind.Config,(0,k.localize)(7,null,D,d));return i}throw new $.$eN($.VariableKind.Config,(0,k.localize)(8,null,D));case"command":return this.p($.VariableKind.Command,D,d,u,"command");case"input":return this.p($.VariableKind.Input,D,d,u,"input");case"extensionInstallFolder":if(d){const i=await this.a.getExtension(d);if(!i)throw new $.$eN($.VariableKind.ExtensionInstallFolder,(0,k.localize)(9,null,D,d));return this.n(i.extensionLocation)}throw new $.$eN($.VariableKind.ExtensionInstallFolder,(0,k.localize)(10,null,D));default:switch(E){case"workspaceRoot":case"workspaceFolder":return(0,g.$xv)(this.n(t($.VariableKind.WorkspaceFolder)));case"cwd":return h||d?(0,g.$xv)(this.n(t($.VariableKind.Cwd))):M.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,g.$xv)(y.$nc(this.n(t($.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(S.userHome)return S.userHome;throw new $.$eN($.VariableKind.UserHome,(0,k.localize)(11,null,D))}case"lineNumber":{const i=this.a.getLineNumber();if(i)return i;throw new $.$eN($.VariableKind.LineNumber,(0,k.localize)(12,null,D))}case"selectedText":{const i=this.a.getSelectedText();if(i)return i;throw new $.$eN($.VariableKind.SelectedText,(0,k.localize)(13,null,D))}case"file":return f($.VariableKind.File);case"fileWorkspaceFolder":return a($.VariableKind.FileWorkspaceFolder);case"relativeFile":return h||d?y.$lc(this.n(t($.VariableKind.RelativeFile)),f($.VariableKind.RelativeFile)):f($.VariableKind.RelativeFile);case"relativeFileDirname":{const i=y.$mc(f($.VariableKind.RelativeFileDirname));if(h||d){const s=y.$lc(this.n(t($.VariableKind.RelativeFileDirname)),i);return s.length===0?".":s}return i}case"fileDirname":return y.$mc(f($.VariableKind.FileDirname));case"fileExtname":return y.$oc(f($.VariableKind.FileExtname));case"fileBasename":return y.$nc(f($.VariableKind.FileBasename));case"fileBasenameNoExtension":{const i=y.$nc(f($.VariableKind.FileBasenameNoExtension));return i.slice(0,i.length-y.$oc(i).length)}case"fileDirnameBasename":return y.$nc(y.$mc(f($.VariableKind.FileDirnameBasename)));case"execPath":{const i=this.a.getExecPath();return i||D}case"execInstallFolder":{const i=this.a.getAppRoot();return i||D}case"pathSeparator":return y.sep;default:try{const i=d?`${E}:${d}`:E;return this.p($.VariableKind.Unknown,D,i,u,void 0)}catch{return D}}}}p(S,D,E,h,u){if(E&&h){const d=u===void 0?h[E]:h[u+":"+E];if(typeof d=="string")return d;throw new $.$eN(S,(0,k.localize)(14,null,D))}return D}}e.$sN=P,P.VARIABLE_LHS="${",P.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(De[144],Ce([1,0,5,140]),function(re,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vC=e.$uC=e.OpenEditorContext=e.GroupsOrder=e.$tC=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$sC=void 0,e.$sC=(0,y.$Qh)("editorGroupsService");var l;(function(D){D[D.UP=0]="UP",D[D.DOWN=1]="DOWN",D[D.LEFT=2]="LEFT",D[D.RIGHT=3]="RIGHT"})(l||(e.GroupDirection=l={}));var L;(function(D){D[D.HORIZONTAL=0]="HORIZONTAL",D[D.VERTICAL=1]="VERTICAL"})(L||(e.GroupOrientation=L={}));var A;(function(D){D[D.FIRST=0]="FIRST",D[D.LAST=1]="LAST",D[D.NEXT=2]="NEXT",D[D.PREVIOUS=3]="PREVIOUS"})(A||(e.GroupLocation=A={}));var g;(function(D){D[D.MAXIMIZE=0]="MAXIMIZE",D[D.EXPAND=1]="EXPAND",D[D.EVEN=2]="EVEN"})(g||(e.GroupsArrangement=g={}));var k;(function(D){D[D.COPY_EDITORS=0]="COPY_EDITORS",D[D.MOVE_EDITORS=1]="MOVE_EDITORS"})(k||(e.MergeGroupMode=k={}));function $(D){const E=D;return(0,M.$aE)(E?.editor)&&(0,M.$aE)(E?.replacement)}e.$tC=$;var R;(function(D){D[D.CREATION_TIME=0]="CREATION_TIME",D[D.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",D[D.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(R||(e.GroupsOrder=R={}));var P;(function(D){D[D.NEW_EDITOR=1]="NEW_EDITOR",D[D.MOVE_EDITOR=2]="MOVE_EDITOR",D[D.COPY_EDITOR=3]="COPY_EDITOR"})(P||(e.OpenEditorContext=P={}));function p(D){const E=D;return!!E&&typeof E.id=="number"&&Array.isArray(E.editors)}e.$uC=p;function S(D){return D.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.$vC=S}),define(De[280],Ce([1,0,5,144]),function(re,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zC=e.$yC=e.$xC=e.$wC=void 0,e.$wC=(0,y.$Qh)("editorService"),e.$xC=-1,e.$yC=-2;function l(L){const A=L;return typeof L=="number"||(0,M.$uC)(A)}e.$zC=l}),define(De[145],Ce([1,0,5,132]),function(re,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NJ=void 0,e.$NJ=(0,y.$Rh)(M.$Xh)}),define(De[146],Ce([1,0,25,4,15,3]),function(re,e,y,M,l,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Z4b=e.$Y4b=e.$X4b=e.$W4b=e.$V4b=e.$U4b=void 0;class A{constructor(u,d){this.versionId=u,this.removedDueToLooping=d}}e.$U4b=A;class g{static isHostExtension(u,d,c){if(d.getExtensionDescription(u))return!1;const f=c.getExtensionDescription(u);return f?!!((f.main||f.browser)&&f.api==="none"):!1}constructor(u,d){this.j=u,this.c=new M.$Od,this.onDidChange=this.c.event,this.d=0,this.e=d,this.k()}k(){this.e.sort(D),this.f=new y.$0l,this.g=[],this.h=new Map;for(const u of this.e){if(this.f.has(u.identifier)){console.error("Extension `"+u.identifier.value+"` is already registered");continue}this.f.set(u.identifier,u),this.g.push(u);const d=this.j.readActivationEvents(u);if(Array.isArray(d))for(let c of d)c==="onUri"&&(c=`onUri:${y.$8l.toKey(u.identifier)}`),this.h.has(c)||this.h.set(c,[]),this.h.get(c).push(u)}}set(u){return this.e=u,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(u,d){this.e=E(this.e,d),this.e=this.e.concat(u);const c=g.l(this.e);return this.e=E(this.e,c.map(f=>f.identifier)),this.k(),this.d++,this.c.fire(void 0),new A(this.d,c)}static l(u){const d=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(i){this.d.has(i)||(this.d.add(i),this.e.push(i))}addArc(i,s){this.addNode(i),this.addNode(s),this.c.has(i)?this.c.get(i).push(s):this.c.set(i,[s])}getArcs(i){return this.c.has(i)?this.c.get(i):[]}hasOnlyGoodArcs(i,s){const n=d.getArcs(i);for(let r=0;r<n.length;r++)if(!s.has(n[r]))return!1;return!0}getNodes(){return this.e}},c=new y.$0l;for(const i of u)if(c.set(i.identifier,i),i.extensionDependencies)for(const s of i.extensionDependencies)d.addArc(y.$8l.toKey(i.identifier),y.$8l.toKey(s));const f=new Set;d.getNodes().filter(i=>d.getArcs(i).length===0).forEach(i=>f.add(i));const a=d.getNodes().filter(i=>!f.has(i));let t;do{t=!1;for(let i=0;i<a.length;i++){const s=a[i];d.hasOnlyGoodArcs(s,f)&&(a.splice(i,1),i--,f.add(s),t=!0)}}while(t);return a.map(i=>c.get(i))}containsActivationEvent(u){return this.h.has(u)}containsExtension(u){return this.f.has(u)}getExtensionDescriptionsForActivationEvent(u){const d=this.h.get(u);return d?d.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new k(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(u){const d=this.f.get(u);return d||void 0}getExtensionDescriptionByUUID(u){for(const d of this.g)if(d.uuid===u)return d}getExtensionDescriptionByIdOrUUID(u,d){return this.getExtensionDescription(u)??(d?this.getExtensionDescriptionByUUID(d):void 0)}}e.$V4b=g;class k{constructor(u,d){this.versionId=u,this.extensions=d}}e.$W4b=k,e.$X4b={readActivationEvents:h=>h.activationEvents};class ${constructor(u){this.d=new p,this.c=new g(u,[])}async acquireLock(u){const d=await this.d.acquire(u);return new R(this,d)}deltaExtensions(u,d,c){if(!u.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(d,c)}containsActivationEvent(u){return this.c.containsActivationEvent(u)}containsExtension(u){return this.c.containsExtension(u)}getExtensionDescriptionsForActivationEvent(u){return this.c.getExtensionDescriptionsForActivationEvent(u)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(u){return this.c.getExtensionDescription(u)}getExtensionDescriptionByUUID(u){return this.c.getExtensionDescriptionByUUID(u)}getExtensionDescriptionByIdOrUUID(u,d){return this.c.getExtensionDescriptionByIdOrUUID(u,d)}}e.$Y4b=$;class R extends L.$Sc{constructor(u,d){super(),this.f=u,this.c=!1,this.B(d)}isAcquiredFor(u){return!this.c&&this.f===u}}e.$Z4b=R;class P{constructor(u){this.name=u,this.promise=new Promise((d,c)=>{this.c=d})}resolve(u){this.c(u)}}class p{constructor(){this.c=[],this.d=!1}async acquire(u){const d=new P(u);return this.c.push(d),this.e(),d.promise}e(){if(this.d||this.c.length===0)return;const u=this.c.shift();this.d=!0;let d=!0;const c=setTimeout(()=>{d&&console.warn(`The customer named ${u.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),f=()=>{d&&(clearTimeout(c),d=!1,this.d=!1,this.e())};u.resolve((0,L.$Qc)(f))}}var S;(function(h){h[h.Builtin=0]="Builtin",h[h.User=1]="User",h[h.Dev=2]="Dev"})(S||(S={}));function D(h,u){const d=h.isBuiltin?0:h.isUnderDevelopment?2:1,c=u.isBuiltin?0:u.isUnderDevelopment?2:1;if(d!==c)return d-c;const f=l.$gc.basename(h.extensionLocation.path),a=l.$gc.basename(u.extensionLocation.path);return f<a?-1:f>a?1:0}function E(h,u){const d=new y.$9l(u);return h.filter(c=>!d.has(c.identifier))}}),define(De[281],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dm=e.$Cm=e.$Bm=e.$Am=e.$zm=e.ExtHostConnectionType=void 0;var y;(function(R){R[R.IPC=1]="IPC",R[R.Socket=2]="Socket",R[R.MessagePort=3]="MessagePort"})(y||(e.ExtHostConnectionType=y={}));class M{constructor(P){this.pipeName=P,this.type=1}serialize(P){P[M.ENV_KEY]=this.pipeName}}e.$zm=M,M.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK";class l{constructor(){this.type=2}serialize(P){P[l.ENV_KEY]="1"}}e.$Am=l,l.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET";class L{constructor(){this.type=3}serialize(P){P[L.ENV_KEY]="1"}}e.$Bm=L,L.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT";function A(R){delete R[M.ENV_KEY],delete R[l.ENV_KEY],delete R[L.ENV_KEY]}function g(R,P){A(P),R.serialize(P)}e.$Cm=g;function k(R){if(R[M.ENV_KEY])return $(R,new M(R[M.ENV_KEY]));if(R[l.ENV_KEY])return $(R,new l);if(R[L.ENV_KEY])return $(R,new L);throw new Error("No connection information defined in environment!")}e.$Dm=k;function $(R,P){return A(R),P}}),define(De[112],Ce([1,0,22]),function(re,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.$em=e.$dm=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var M;(function($){$[$.Desktop=1]="Desktop",$[$.Web=2]="Web"})(M||(e.UIKind=M={}));var l;(function($){$[$.VersionMismatch=55]="VersionMismatch",$[$.UnexpectedError=81]="UnexpectedError"})(l||(e.ExtensionHostExitCode=l={}));var L;(function($){$[$.Initialized=0]="Initialized",$[$.Ready=1]="Ready",$[$.Terminate=2]="Terminate"})(L||(e.MessageType=L={}));function A($){const R=y.$ce.alloc(1);switch($){case 0:R.writeUInt8(1,0);break;case 1:R.writeUInt8(2,0);break;case 2:R.writeUInt8(3,0);break}return R}e.$dm=A;function g($,R){if($.byteLength!==1)return!1;switch($.readUInt8(0)){case 1:return R===0;case 2:return R===1;case 3:return R===2;default:return!1}}e.$em=g;var k;(function($){$.Start="START_NATIVE_LOG",$.End="END_NATIVE_LOG"})(k||(e.NativeLogMarkers=k={}))}),define(De[88],Ce([1,0,5,4,14,27,112,66,85,24,2,3,211]),function(re,e,y,M,l,L,A,g,k,$,R,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LM=e.$KM=e.$JM=e.$IM=void 0;let S=class extends P.$Sc{constructor(u,d){super(),this.s=u,this.t=d,this.a=this.B(new M.$Od),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new M.$Od),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=R.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=d.createLogger(this.m,{id:k.$to,name:(0,p.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(d.onDidChangeLogLevel(c=>{(0,l.$aj)(c)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===l.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(u,d,c){const f=this.getTelemetryDetails(),a=new D(d,c,u,this.n,this.j,this.getBuiltInCommonProperties(u),{isUsageEnabled:f.isUsageEnabled,isErrorsEnabled:f.isErrorsEnabled}),t=this.r.get(u.identifier.value)??[];return this.r.set(u.identifier.value,[...t,a]),a.apiTelemetryLogger}$initializeTelemetryLevel(u,d,c){this.f=u,this.g=d,this.c=c??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(u){const d=Object.create(null);switch(d["common.extname"]=`${u.publisher}.${u.name}`,d["common.extversion"]=u.version,d["common.vscodemachineid"]=this.s.telemetryInfo.machineId,d["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,d["common.vscodeversion"]=this.s.version,d["common.isnewappinstall"]=E(this.s.telemetryInfo.firstSessionDate),d["common.product"]=this.s.environment.appHost,this.s.uiKind){case A.UIKind.Web:d["common.uikind"]="web";break;case A.UIKind.Desktop:d["common.uikind"]="desktop";break;default:d["common.uikind"]="unknown"}return d["common.remotename"]=(0,g.$Wk)((0,k.$Ao)(this.s.remote.authority)),d}$onDidChangeTelemetryLevel(u){this.h=this.getTelemetryConfiguration(),this.f=u;const d=this.getTelemetryDetails();this.r.forEach((c,f)=>{const a=c.filter(t=>!t.isDisposed);a.length===0?this.r.delete(f):this.r.set(f,a)}),this.r.forEach(c=>{for(const f of c)f.updateTelemetryEnablements(d.isUsageEnabled,d.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(u,d){const f=this.r.get(u.value)?.filter(t=>!t.isDisposed);if(!f)return this.r.delete(u.value),!1;let a=!1;for(const t of f)t.ignoreUnhandledExtHostErrors||(t.logError(d),a=!0);return a}};e.$IM=S,e.$IM=S=He([We(0,L.$HM),We(1,l.$_i)],S);class D{static validateSender(u){if(typeof u!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof u.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof u.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof u.flush<"u"&&typeof u.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(u,d,c,f,a,t,i){this.g=c,this.h=f,this.i=a,this.j=t,this.a=new M.$Od,this.ignoreUnhandledExtHostErrors=d?.ignoreUnhandledErrors??!1,this.b=d?.ignoreBuiltInCommonProperties??!1,this.c=d?.additionalCommonProperties,this.f=u,this.d={isUsageEnabled:i.isUsageEnabled,isErrorsEnabled:i.isErrorsEnabled}}updateTelemetryEnablements(u,d){this.e&&(this.d={isUsageEnabled:u,isErrorsEnabled:d},this.a.fire(this.e))}mixInCommonPropsAndCleanData(u){let d="properties"in u?u.properties??{}:u;return d=(0,k.$Do)(d,[]),this.c&&(d=(0,$.$_m)(d,this.c)),this.b||(d=(0,$.$_m)(d,this.j)),"properties"in u?u.properties=d:u=d,u}k(u,d){this.f&&(this.g.publisher==="vscode"?u=this.g.name+"/"+u:u=this.g.identifier.value+"/"+u,d=this.mixInCommonPropsAndCleanData(d||{}),this.i||this.f?.sendEventData(u,d),this.h.trace(u,d))}logUsage(u,d){this.d.isUsageEnabled&&this.k(u,d)}logError(u,d){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof u=="string")this.k(u,d);else{const c={name:u.name,message:u.message,stack:u.stack,cause:u.cause},f=(0,k.$Do)(c,[]),a=new Error(f.message,{cause:f.cause});a.stack=f.stack,a.name=f.name,d=this.mixInCommonPropsAndCleanData(d||{}),this.i||this.f.sendErrorData(a,d),this.h.trace("exception",d)}}get apiTelemetryLogger(){if(!this.e){const u=this,d={logUsage:u.logUsage.bind(u),get isUsageEnabled(){return u.d.isUsageEnabled},get isErrorsEnabled(){return u.d.isErrorsEnabled},logError:u.logError.bind(u),dispose:u.dispose.bind(u),onDidChangeEnableStates:u.a.event.bind(u)};this.e=Object.freeze(d)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let u=this.f;this.f=void 0,Promise.resolve(u.flush()).then(u=void 0),this.e=void 0}else this.f=void 0}}e.$JM=D;function E(h){const u=Date.now()-new Date(h).getTime();return isNaN(u)?!1:u<1e3*60*60*24}e.$KM=E,e.$LM=(0,y.$Qh)("IExtHostTelemetry")}),define(De[26],Ce([1,0,4,2,253,138,25,5]),function(re,e,y,M,l,L,A,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rF=e.$qF=e.$pF=e.ActivationKind=e.$oF=e.$nF=e.$mF=e.$lF=e.$kF=e.ExtensionHostStartup=e.$jF=e.$iF=e.$hF=e.$gF=void 0,e.$gF=Object.freeze({identifier:new A.$8l("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:M.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$hF="extensions.webWorker",e.$iF=(0,g.$Qh)("extensionService");class k{constructor(a){this.dependency=a}}e.$jF=k;var $;(function(f){f[f.EagerAutoStart=1]="EagerAutoStart",f[f.EagerManualStart=2]="EagerManualStart",f[f.Lazy=3]="Lazy"})($||(e.ExtensionHostStartup=$={}));class R{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(a,t,i){this.c=a,this.d=t.slice(0),this.e=i.slice(0)}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:L.$4E.createActivationEventsMap(this.d)}}set(a,t,i){if(this.c>a)throw new Error(`ExtensionHostExtensions: invalid versionId ${a} (current: ${this.c})`);const s=[],n=[],r=[],o=[],v=P(this.d),C=P(t),w=(O,F)=>O.extensionLocation.toString()===F.extensionLocation.toString()||O.isBuiltin===F.isBuiltin||O.isUserBuiltin===F.isUserBuiltin||O.isUnderDevelopment===F.isUnderDevelopment;for(const O of this.d){const F=C.get(O.identifier);if(!F){s.push(O.identifier),v.delete(O.identifier);continue}if(!w(O,F)){s.push(O.identifier),v.delete(O.identifier);continue}}for(const O of t){const F=v.get(O.identifier);if(!F){n.push(O);continue}if(!w(F,O)){s.push(F.identifier),v.delete(F.identifier);continue}}const m=new A.$9l(this.e),b=new A.$9l(i);for(const O of this.e)b.has(O)||r.push(O);for(const O of i)m.has(O)||o.push(O);const I=L.$4E.createActivationEventsMap(n),z={versionId:a,toRemove:s,toAdd:n,addActivationEvents:I,myToRemove:r,myToAdd:o};return this.delta(z),z}delta(a){if(this.c>=a.versionId)return null;const{toRemove:t,toAdd:i,myToRemove:s,myToAdd:n}=a,r=new A.$9l(t),o=new A.$9l(s);for(let v=0;v<this.d.length;v++)r.has(this.d[v].identifier)&&(this.d.splice(v,1),v--);for(let v=0;v<this.e.length;v++)o.has(this.e[v])&&(this.e.splice(v,1),v--);for(const v of i)this.d.push(v);for(const v of n)this.e.push(v);return a}containsExtension(a){for(const t of this.e)if(A.$8l.equals(t,a))return!0;return!1}}e.$kF=R;function P(f){const a=new A.$0l;for(const t of f)a.set(t.identifier,t);return a}function p(f,a){return!0}e.$lF=p;function S(f,a){if(!p(f,a))throw new Error(`Extension '${f.identifier.value}' CANNOT use API proposal: ${a}.
Its package.json#enabledApiProposals-property declares: ${f.enabledApiProposals?.join(", ")??"[]"} but NOT ${a}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${f.identifier.value}`)}e.$mF=S;class D{constructor(a,t,i,s){this.codeLoadingTime=a,this.activateCallTime=t,this.activateResolvedTime=i,this.activationReason=s}}e.$nF=D;class E{constructor(a,t){this.description=a,this.value=t}}e.$oF=E;var h;(function(f){f[f.Normal=0]="Normal",f[f.Immediate=1]="Immediate"})(h||(e.ActivationKind=h={}));function u(f){return{type:f.isBuiltin?0:1,isBuiltin:f.isBuiltin||f.isUserBuiltin,identifier:{id:(0,l.$Jo)(f.publisher,f.name),uuid:f.uuid},manifest:f,location:f.extensionLocation,targetPlatform:f.targetPlatform,validations:[],isValid:!0}}e.$pF=u;function d(f,a){return{identifier:new A.$8l((0,l.$Ho)(f.manifest.publisher,f.manifest.name)),isBuiltin:f.type===0,isUserBuiltin:f.type===1&&f.isBuiltin,isUnderDevelopment:!!a,extensionLocation:f.location,...f.manifest,uuid:f.identifier.uuid,targetPlatform:f.targetPlatform}}e.$qF=d;class c{constructor(){this.onDidRegisterExtensions=y.Event.None,this.onDidChangeExtensionsStatus=y.Event.None,this.onDidChangeExtensions=y.Event.None,this.onWillActivateByEvent=y.Event.None,this.onDidChangeResponsiveChange=y.Event.None,this.onWillStop=y.Event.None,this.extensions=[]}activateByEvent(a){return Promise.resolve(void 0)}activationEventIsDone(a){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(a){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(a,t){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(a){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$rF=c}),define(De[282],Ce([1,0,9,146,25,26,14,8]),function(re,e,y,M,l,L,A,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5cc=e.$4cc=e.$3cc=e.$2cc=e.$1cc=e.$Zcc=void 0;class k{constructor(u,d,c,f){this.startup=u,this.codeLoadingTime=d,this.activateCallTime=c,this.activateResolvedTime=f}}e.$Zcc=k,k.NONE=new k(!1,-1,-1,-1);class ${constructor(u){this.a=u,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(u,d){return u===-1||d===-1?-1:d-u}build(){return new k(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$1cc=$;class R{constructor(u,d,c,f,a,t){this.activationFailed=u,this.activationFailedError=d,this.activationTimes=c,this.module=f,this.exports=a,this.subscriptions=t}}e.$2cc=R;class P extends R{constructor(u){super(!1,null,u,{activate:void 0,deactivate:void 0},void 0,[])}}e.$3cc=P;class p extends R{constructor(){super(!1,null,k.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$4cc=p;class S extends R{constructor(u){super(!0,u,k.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let D=class{constructor(u,d,c,f){this.g=f,this.a=u,this.b=d,this.c=c,this.d=new l.$0l,this.f=Object.create(null)}dispose(){for(const[u,d]of this.d)d.dispose()}async waitForActivatingExtensions(){const u=[];for(const[d,c]of this.d)u.push(c.wait());await Promise.all(u)}isActivated(u){const d=this.d.get(u);return!!(d&&d.value)}getActivatedExtension(u){const d=this.d.get(u);if(!d||!d.value)throw new Error(`Extension '${u.value}' is not known or not activated`);return d.value}async activateByEvent(u,d){if(this.f[u])return;const c=this.a.getExtensionDescriptionsForActivationEvent(u);await this.h(c.map(f=>({id:f.identifier,reason:{startup:d,extensionId:f.identifier,activationEvent:u}}))),this.f[u]=!0}activateById(u,d){const c=this.a.getExtensionDescription(u);if(!c)throw new Error(`Extension '${u}' is not known`);return this.h([{id:c.identifier,reason:d}])}async h(u){const d=u.filter(c=>!this.isActivated(c.id)).map(c=>this.j(c));await Promise.all(d.map(c=>c.wait()))}j(u){if(this.d.has(u.id))return this.d.get(u.id);if(this.l(u.id))return this.k(u,null,[],null);const d=this.a.getExtensionDescription(u.id);if(!d){const a=new Error(`Cannot activate unknown extension '${u.id.value}'`),t=this.k(u,null,[],new S(a));return this.c.onExtensionActivationError(u.id,a,new L.$jF(u.id.value)),t}const c=[],f=typeof d.extensionDependencies>"u"?[]:d.extensionDependencies;for(const a of f){if(this.m(a))continue;const t=this.d.get(a);if(t){c.push(t);continue}if(this.l(a)){c.push(this.j({id:this.b.getExtensionDescription(a).identifier,reason:u.reason}));continue}const i=this.a.getExtensionDescription(a);if(i){if(!i.main&&!i.browser)continue;c.push(this.j({id:i.identifier,reason:u.reason}));continue}const s=d.displayName||d.identifier.value,n=new Error(`Cannot activate the '${s}' extension because it depends on unknown extension '${a}'`),r=this.k(u,d.displayName,[],new S(n));return this.c.onExtensionActivationError(d.identifier,n,new L.$jF(a)),r}return this.k(u,d.displayName,c,null)}k(u,d,c,f){const a=new E(u.id,d,u.reason,c,f,this.c,this.g);return this.d.set(u.id,a),a}l(u){return M.$V4b.isHostExtension(u,this.a,this.b)}m(u){const d=this.b.getExtensionDescription(u);return d?!d.main&&!d.browser:!1}};e.$5cc=D,e.$5cc=D=He([We(3,A.$$i)],D);let E=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(u,d,c,f,a,t,i){this.c=u,this.d=d,this.f=c,this.g=f,this.h=a,this.j=t,this.k=i,this.a=new g.$Tg,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let u=0;u<this.g.length;u++){const d=this.g[u];if(d.value&&!d.value.activationFailed){this.g.splice(u,1),u--;continue}if(d.value&&d.value.activationFailed){const c=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${d.friendlyName}' failed to activate`);c.detail=d.value.activationFailedError,this.h=new S(c),this.j.onExtensionActivationError(this.c,c,null);return}}this.g.length>0&&await Promise.race(this.g.map(u=>u.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(u){const d=new Error;if(u&&u.name&&(d.name=u.name),u&&u.message?d.message=`Activating extension '${this.c.value}' failed: ${u.message}.`:d.message=`Activating extension '${this.c.value}' failed: ${u}.`,u&&u.stack&&(d.stack=u.stack),this.h=new S(d),this.b&&y.$4(u))return;this.j.onExtensionActivationError(this.c,d,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(u)}}};E=He([We(6,A.$$i)],E)}),define(De[13],Ce([1,0,19,22,165,75,80,28,159,60,96,24,17,2,33,83,134,143,140,109,68,87,280,7,26]),function(re,e,y,M,l,L,A,g,k,$,R,P,p,S,D,E,h,u,d,c,f,a,t,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalQuickFix=e.ChatResponseProgress=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.ChatMessageRole=e.ChatMessage=e.ChatFollowup=e.ChatReplyFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.$qM=e.$pM=e.MarkdownString=e.$oM=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var n;(function(Me){function Te(ne){const{selectionStartLineNumber:Fe,selectionStartColumn:Ve,positionLineNumber:_e,positionColumn:Ye}=ne,ot=new i.$tK(Fe-1,Ve-1),Ct=new i.$tK(_e-1,Ye-1);return new i.$vK(ot,Ct)}Me.to=Te;function Se(ne){const{anchor:Fe,active:Ve}=ne;return{selectionStartLineNumber:Fe.line+1,selectionStartColumn:Fe.character+1,positionLineNumber:Ve.line+1,positionColumn:Ve.character+1}}Me.from=Se})(n||(e.Selection=n={}));var r;(function(Me){function Te(ne){if(!ne)return;const{start:Fe,end:Ve}=ne;return{startLineNumber:Fe.line+1,startColumn:Fe.character+1,endLineNumber:Ve.line+1,endColumn:Ve.character+1}}Me.from=Te;function Se(ne){if(!ne)return;const{startLineNumber:Fe,startColumn:Ve,endLineNumber:_e,endColumn:Ye}=ne;return new i.$uK(Fe-1,Ve-1,_e-1,Ye-1)}Me.to=Se})(r||(e.Range=r={}));var o;(function(Me){function Te(Se){switch(Se){case 1:return i.StandardTokenType.Comment;case 0:return i.StandardTokenType.Other;case 3:return i.StandardTokenType.RegEx;case 2:return i.StandardTokenType.String}}Me.to=Te})(o||(e.TokenType=o={}));var v;(function(Me){function Te(ne){return new i.$tK(ne.lineNumber-1,ne.column-1)}Me.to=Te;function Se(ne){return{lineNumber:ne.line+1,column:ne.character+1}}Me.from=Se})(v||(e.Position=v={}));var C;(function(Me){function Te(Fe,Ve,_e){return(0,y.$Hb)((0,y.$3b)(Fe).map(Ye=>Se(Ye,Ve,_e)))}Me.from=Te;function Se(Fe,Ve,_e){if(typeof Fe=="string")return{$serialized:!0,language:Fe,isBuiltin:_e?.isBuiltin};if(Fe)return{$serialized:!0,language:Fe.language,scheme:ne(Fe.scheme,Ve),pattern:ue.from(Fe.pattern)??void 0,exclusive:Fe.exclusive,notebookType:Fe.notebookType,isBuiltin:_e?.isBuiltin}}function ne(Fe,Ve){return Ve&&typeof Fe=="string"?Ve.transformOutgoingScheme(Fe):Fe}})(C||(e.DocumentSelector=C={}));var w;(function(Me){function Te(ne){switch(ne){case i.DiagnosticTag.Unnecessary:return 1;case i.DiagnosticTag.Deprecated:return 2}}Me.from=Te;function Se(ne){switch(ne){case 1:return i.DiagnosticTag.Unnecessary;case 2:return i.DiagnosticTag.Deprecated;default:return}}Me.to=Se})(w||(e.DiagnosticTag=w={}));var m;(function(Me){function Te(ne){let Fe;return ne.code&&((0,p.$zf)(ne.code)||(0,p.$Df)(ne.code)?Fe=String(ne.code):Fe={value:String(ne.code.value),target:ne.code.target}),{...r.from(ne.range),message:ne.message,source:ne.source,code:Fe,severity:I.from(ne.severity),relatedInformation:ne.relatedInformation&&ne.relatedInformation.map(b.from),tags:Array.isArray(ne.tags)?(0,y.$Hb)(ne.tags.map(w.from)):void 0}}Me.from=Te;function Se(ne){const Fe=new i.$GK(r.to(ne),ne.message,I.to(ne.severity));return Fe.source=ne.source,Fe.code=(0,p.$zf)(ne.code)?ne.code:ne.code?.value,Fe.relatedInformation=ne.relatedInformation&&ne.relatedInformation.map(b.to),Fe.tags=ne.tags&&(0,y.$Hb)(ne.tags.map(w.to)),Fe}Me.to=Se})(m||(e.Diagnostic=m={}));var b;(function(Me){function Te(ne){return{...r.from(ne.location.range),message:ne.message,resource:ne.location.uri}}Me.from=Te;function Se(ne){return new i.$FK(new i.$EK(ne.resource,r.to(ne)),ne.message)}Me.to=Se})(b||(e.DiagnosticRelatedInformation=b={}));var I;(function(Me){function Te(ne){switch(ne){case i.DiagnosticSeverity.Error:return h.MarkerSeverity.Error;case i.DiagnosticSeverity.Warning:return h.MarkerSeverity.Warning;case i.DiagnosticSeverity.Information:return h.MarkerSeverity.Info;case i.DiagnosticSeverity.Hint:return h.MarkerSeverity.Hint}return h.MarkerSeverity.Error}Me.from=Te;function Se(ne){switch(ne){case h.MarkerSeverity.Info:return i.DiagnosticSeverity.Information;case h.MarkerSeverity.Warning:return i.DiagnosticSeverity.Warning;case h.MarkerSeverity.Error:return i.DiagnosticSeverity.Error;case h.MarkerSeverity.Hint:return i.DiagnosticSeverity.Hint;default:return i.DiagnosticSeverity.Error}}Me.to=Se})(I||(e.DiagnosticSeverity=I={}));var z;(function(Me){function Te(ne){return typeof ne=="number"&&ne>=i.ViewColumn.One?ne-1:ne===i.ViewColumn.Beside?t.$yC:t.$xC}Me.from=Te;function Se(ne){if(typeof ne=="number"&&ne>=0)return ne+1;throw new Error("invalid 'EditorGroupColumn'")}Me.to=Se})(z||(e.ViewColumn=z={}));function O(Me){return typeof Me.range<"u"}function F(Me){return Me.length===0?!0:!!O(Me[0])}e.$oM=F;var T;(function(Me){function Te(Ye){return Ye.map(Me.from)}Me.fromMany=Te;function Se(Ye){return Ye&&typeof Ye=="object"&&typeof Ye.language=="string"&&typeof Ye.value=="string"}function ne(Ye){let ot;if(Se(Ye)){const{language:gt,value:$t}=Ye;ot={value:"```"+gt+`
`+$t+"\n```\n"}}else i.$SK.isMarkdownString(Ye)?ot={value:Ye.value,isTrusted:Ye.isTrusted,supportThemeIcons:Ye.supportThemeIcons,supportHtml:Ye.supportHtml,baseUri:Ye.baseUri}:typeof Ye=="string"?ot={value:Ye}:ot={value:""};const Ct=Object.create(null);ot.uris=Ct;const yt=gt=>{try{let $t=S.URI.parse(gt,!0);$t=$t.with({query:Fe($t.query,Ct)}),Ct[gt]=$t}catch{}return""},bt=new k.marked.Renderer;return bt.link=yt,bt.image=gt=>typeof gt=="string"?yt(A.$$j(gt).href):"",(0,k.marked)(ot.value,{renderer:bt}),ot}Me.from=ne;function Fe(Ye,ot){if(!Ye)return Ye;let Ct;try{Ct=(0,$.$mh)(Ye)}catch{}if(!Ct)return Ye;let yt=!1;return Ct=(0,P.$$m)(Ct,bt=>{if(S.URI.isUri(bt)){const gt=`__uri_${Math.random().toString(16).slice(2,8)}`;return ot[gt]=bt,yt=!0,gt}else return}),yt?JSON.stringify(Ct):Ye}function Ve(Ye){const ot=new i.$SK(Ye.value,Ye.supportThemeIcons);return ot.isTrusted=Ye.isTrusted,ot.supportHtml=Ye.supportHtml,ot.baseUri=Ye.baseUri?S.URI.from(Ye.baseUri):void 0,ot}Me.to=Ve;function _e(Ye){if(Ye)return typeof Ye=="string"?Ye:Me.from(Ye)}Me.fromStrict=_e})(T||(e.MarkdownString=T={}));function N(Me){return F(Me)?Me.map(Te=>({range:r.from(Te.range),hoverMessage:Array.isArray(Te.hoverMessage)?T.fromMany(Te.hoverMessage):Te.hoverMessage?T.from(Te.hoverMessage):void 0,renderOptions:Te.renderOptions})):Me.map(Te=>({range:r.from(Te)}))}e.$pM=N;function j(Me){return typeof Me>"u"?Me:typeof Me=="string"?S.URI.file(Me):Me}e.$qM=j;var U;(function(Me){function Te(Se){return typeof Se>"u"?Se:{contentText:Se.contentText,contentIconPath:Se.contentIconPath?j(Se.contentIconPath):void 0,border:Se.border,borderColor:Se.borderColor,fontStyle:Se.fontStyle,fontWeight:Se.fontWeight,textDecoration:Se.textDecoration,color:Se.color,backgroundColor:Se.backgroundColor,margin:Se.margin,width:Se.width,height:Se.height}}Me.from=Te})(U||(e.ThemableDecorationAttachmentRenderOptions=U={}));var B;(function(Me){function Te(Se){return typeof Se>"u"?Se:{backgroundColor:Se.backgroundColor,outline:Se.outline,outlineColor:Se.outlineColor,outlineStyle:Se.outlineStyle,outlineWidth:Se.outlineWidth,border:Se.border,borderColor:Se.borderColor,borderRadius:Se.borderRadius,borderSpacing:Se.borderSpacing,borderStyle:Se.borderStyle,borderWidth:Se.borderWidth,fontStyle:Se.fontStyle,fontWeight:Se.fontWeight,textDecoration:Se.textDecoration,cursor:Se.cursor,color:Se.color,opacity:Se.opacity,letterSpacing:Se.letterSpacing,gutterIconPath:Se.gutterIconPath?j(Se.gutterIconPath):void 0,gutterIconSize:Se.gutterIconSize,overviewRulerColor:Se.overviewRulerColor,before:Se.before?U.from(Se.before):void 0,after:Se.after?U.from(Se.after):void 0}}Me.from=Te})(B||(e.ThemableDecorationRenderOptions=B={}));var he;(function(Me){function Te(Se){if(typeof Se>"u")return Se;switch(Se){case i.DecorationRangeBehavior.OpenOpen:return 0;case i.DecorationRangeBehavior.ClosedClosed:return 1;case i.DecorationRangeBehavior.OpenClosed:return 2;case i.DecorationRangeBehavior.ClosedOpen:return 3}}Me.from=Te})(he||(e.DecorationRangeBehavior=he={}));var x;(function(Me){function Te(Se){return{isWholeLine:Se.isWholeLine,rangeBehavior:Se.rangeBehavior?he.from(Se.rangeBehavior):void 0,overviewRulerLane:Se.overviewRulerLane,light:Se.light?B.from(Se.light):void 0,dark:Se.dark?B.from(Se.dark):void 0,backgroundColor:Se.backgroundColor,outline:Se.outline,outlineColor:Se.outlineColor,outlineStyle:Se.outlineStyle,outlineWidth:Se.outlineWidth,border:Se.border,borderColor:Se.borderColor,borderRadius:Se.borderRadius,borderSpacing:Se.borderSpacing,borderStyle:Se.borderStyle,borderWidth:Se.borderWidth,fontStyle:Se.fontStyle,fontWeight:Se.fontWeight,textDecoration:Se.textDecoration,cursor:Se.cursor,color:Se.color,opacity:Se.opacity,letterSpacing:Se.letterSpacing,gutterIconPath:Se.gutterIconPath?j(Se.gutterIconPath):void 0,gutterIconSize:Se.gutterIconSize,overviewRulerColor:Se.overviewRulerColor,before:Se.before?U.from(Se.before):void 0,after:Se.after?U.from(Se.after):void 0}}Me.from=Te})(x||(e.DecorationRenderOptions=x={}));var Q;(function(Me){function Te(ne){return{text:ne.newText,eol:ne.newEol&&nt.from(ne.newEol),range:r.from(ne.range)}}Me.from=Te;function Se(ne){const Fe=new i.$zK(r.to(ne.range),ne.text);return Fe.newEol=typeof ne.eol>"u"?void 0:nt.to(ne.eol),Fe}Me.to=Se})(Q||(e.TextEdit=Q={}));var Z;(function(Me){function Te(ne,Fe){const Ve={edits:[]};if(ne instanceof i.$CK){const _e=new g.$Bc;for(const Ye of ne._allEntries())Ye._type===1&&S.URI.isUri(Ye.to)&&Ye.from===void 0&&_e.add(Ye.to);for(const Ye of ne._allEntries())if(Ye._type===1){let ot;Ye.options?.contents&&(ArrayBuffer.isView(Ye.options.contents)?ot={type:"base64",value:(0,M.$we)(M.$ce.wrap(Ye.options.contents))}:ot={type:"dataTransferItem",id:Ye.options.contents._itemId}),Ve.edits.push({oldResource:Ye.from,newResource:Ye.to,options:{...Ye.options,contents:ot},metadata:Ye.metadata})}else Ye._type===2?Ve.edits.push({resource:Ye.uri,textEdit:Q.from(Ye.edit),versionId:_e.has(Ye.uri)?void 0:Fe?.getTextDocumentVersion(Ye.uri),metadata:Ye.metadata}):Ye._type===6?Ve.edits.push({resource:Ye.uri,textEdit:{range:r.from(Ye.range),text:Ye.edit.value,insertAsSnippet:!0},versionId:_e.has(Ye.uri)?void 0:Fe?.getTextDocumentVersion(Ye.uri),metadata:Ye.metadata}):Ye._type===3?Ve.edits.push({metadata:Ye.metadata,resource:Ye.uri,cellEdit:Ye.edit,notebookMetadata:Ye.notebookMetadata,notebookVersionId:Fe?.getNotebookDocumentVersion(Ye.uri)}):Ye._type===5&&Ve.edits.push({metadata:Ye.metadata,resource:Ye.uri,notebookVersionId:Fe?.getNotebookDocumentVersion(Ye.uri),cellEdit:{editType:1,index:Ye.index,count:Ye.count,cells:Ye.cells.map(pt.from)}})}return Ve}Me.from=Te;function Se(ne){const Fe=new i.$CK,Ve=new g.$Ac;for(const _e of ne.edits)if(_e.textEdit){const Ye=_e,ot=S.URI.revive(Ye.resource),Ct=r.to(Ye.textEdit.range),yt=Ye.textEdit.text,bt=Ye.textEdit.insertAsSnippet;let gt;bt?gt=i.$BK.replace(Ct,new i.$DK(yt)):gt=i.$zK.replace(Ct,yt);const $t=Ve.get(ot);$t?$t.push(gt):Ve.set(ot,[gt])}else Fe.renameFile(S.URI.revive(_e.oldResource),S.URI.revive(_e.newResource),_e.options);for(const[_e,Ye]of Ve)Fe.set(_e,Ye);return Fe}Me.to=Se})(Z||(e.WorkspaceEdit=Z={}));var ie;(function(Me){const Te=Object.create(null);Te[i.SymbolKind.File]=0,Te[i.SymbolKind.Module]=1,Te[i.SymbolKind.Namespace]=2,Te[i.SymbolKind.Package]=3,Te[i.SymbolKind.Class]=4,Te[i.SymbolKind.Method]=5,Te[i.SymbolKind.Property]=6,Te[i.SymbolKind.Field]=7,Te[i.SymbolKind.Constructor]=8,Te[i.SymbolKind.Enum]=9,Te[i.SymbolKind.Interface]=10,Te[i.SymbolKind.Function]=11,Te[i.SymbolKind.Variable]=12,Te[i.SymbolKind.Constant]=13,Te[i.SymbolKind.String]=14,Te[i.SymbolKind.Number]=15,Te[i.SymbolKind.Boolean]=16,Te[i.SymbolKind.Array]=17,Te[i.SymbolKind.Object]=18,Te[i.SymbolKind.Key]=19,Te[i.SymbolKind.Null]=20,Te[i.SymbolKind.EnumMember]=21,Te[i.SymbolKind.Struct]=22,Te[i.SymbolKind.Event]=23,Te[i.SymbolKind.Operator]=24,Te[i.SymbolKind.TypeParameter]=25;function Se(Fe){return typeof Te[Fe]=="number"?Te[Fe]:6}Me.from=Se;function ne(Fe){for(const Ve in Te)if(Te[Ve]===Fe)return Number(Ve);return i.SymbolKind.Property}Me.to=ne})(ie||(e.SymbolKind=ie={}));var _;(function(Me){function Te(ne){switch(ne){case i.SymbolTag.Deprecated:return 1}}Me.from=Te;function Se(ne){switch(ne){case 1:return i.SymbolTag.Deprecated}}Me.to=Se})(_||(e.SymbolTag=_={}));var oe;(function(Me){function Te(ne){return{name:ne.name,kind:ie.from(ne.kind),tags:ne.tags&&ne.tags.map(_.from),containerName:ne.containerName,location:H.from(ne.location)}}Me.from=Te;function Se(ne){const Fe=new i.$JK(ne.name,ie.to(ne.kind),ne.containerName,H.to(ne.location));return Fe.tags=ne.tags&&ne.tags.map(_.to),Fe}Me.to=Se})(oe||(e.WorkspaceSymbol=oe={}));var ye;(function(Me){function Te(ne){const Fe={name:ne.name||"!!MISSING: name!!",detail:ne.detail,range:r.from(ne.range),selectionRange:r.from(ne.selectionRange),kind:ie.from(ne.kind),tags:ne.tags?.map(_.from)??[]};return ne.children&&(Fe.children=ne.children.map(Te)),Fe}Me.from=Te;function Se(ne){const Fe=new i.$KK(ne.name,ne.detail,ie.to(ne.kind),r.to(ne.range),r.to(ne.selectionRange));return(0,y.$Lb)(ne.tags)&&(Fe.tags=ne.tags.map(_.to)),ne.children&&(Fe.children=ne.children.map(Se)),Fe}Me.to=Se})(ye||(e.DocumentSymbol=ye={}));var fe;(function(Me){function Te(ne){const Fe=new i.$OK(ie.to(ne.kind),ne.name,ne.detail||"",S.URI.revive(ne.uri),r.to(ne.range),r.to(ne.selectionRange));return Fe._sessionId=ne._sessionId,Fe._itemId=ne._itemId,Fe}Me.to=Te;function Se(ne,Fe,Ve){if(Fe=Fe??ne._sessionId,Ve=Ve??ne._itemId,Fe===void 0||Ve===void 0)throw new Error("invalid item");return{_sessionId:Fe,_itemId:Ve,name:ne.name,detail:ne.detail,kind:ie.from(ne.kind),uri:ne.uri,range:r.from(ne.range),selectionRange:r.from(ne.selectionRange),tags:ne.tags?.map(_.from)}}Me.from=Se})(fe||(e.CallHierarchyItem=fe={}));var V;(function(Me){function Te(Se){return new i.$PK(fe.to(Se.from),Se.fromRanges.map(ne=>r.to(ne)))}Me.to=Te})(V||(e.CallHierarchyIncomingCall=V={}));var le;(function(Me){function Te(Se){return new i.$QK(fe.to(Se.to),Se.fromRanges.map(ne=>r.to(ne)))}Me.to=Te})(le||(e.CallHierarchyOutgoingCall=le={}));var H;(function(Me){function Te(ne){return{range:ne.range&&r.from(ne.range),uri:ne.uri}}Me.from=Te;function Se(ne){return new i.$EK(S.URI.revive(ne.uri),r.to(ne.range))}Me.to=Se})(H||(e.location=H={}));var G;(function(Me){function Te(ne){const Fe=ne,Ve=ne;return{originSelectionRange:Fe.originSelectionRange?r.from(Fe.originSelectionRange):void 0,uri:Fe.targetUri?Fe.targetUri:Ve.uri,range:r.from(Fe.targetRange?Fe.targetRange:Ve.range),targetSelectionRange:Fe.targetSelectionRange?r.from(Fe.targetSelectionRange):void 0}}Me.from=Te;function Se(ne){return{targetUri:S.URI.revive(ne.uri),targetRange:r.to(ne.range),targetSelectionRange:ne.targetSelectionRange?r.to(ne.targetSelectionRange):void 0,originSelectionRange:ne.originSelectionRange?r.to(ne.originSelectionRange):void 0}}Me.to=Se})(G||(e.DefinitionLink=G={}));var Y;(function(Me){function Te(ne){return{range:r.from(ne.range),contents:T.fromMany(ne.contents)}}Me.from=Te;function Se(ne){return new i.$HK(ne.contents.map(T.to),r.to(ne.range))}Me.to=Se})(Y||(e.Hover=Y={}));var X;(function(Me){function Te(ne){return{range:r.from(ne.range),expression:ne.expression}}Me.from=Te;function Se(ne){return new i.$AL(r.to(ne.range),ne.expression)}Me.to=Se})(X||(e.EvaluatableExpression=X={}));var be;(function(Me){function Te(ne){if(ne instanceof i.$BL)return{type:"text",range:r.from(ne.range),text:ne.text};if(ne instanceof i.$CL)return{type:"variable",range:r.from(ne.range),variableName:ne.variableName,caseSensitiveLookup:ne.caseSensitiveLookup};if(ne instanceof i.$DL)return{type:"expression",range:r.from(ne.range),expression:ne.expression};throw new Error("Unknown 'InlineValue' type")}Me.from=Te;function Se(ne){switch(ne.type){case"text":return{range:r.to(ne.range),text:ne.text};case"variable":return{range:r.to(ne.range),variableName:ne.variableName,caseSensitiveLookup:ne.caseSensitiveLookup};case"expression":return{range:r.to(ne.range),expression:ne.expression}}}Me.to=Se})(be||(e.InlineValue=be={}));var se;(function(Me){function Te(ne){return{frameId:ne.frameId,stoppedLocation:r.from(ne.stoppedLocation)}}Me.from=Te;function Se(ne){return new i.$EL(ne.frameId,r.to(ne.stoppedLocation))}Me.to=Se})(se||(e.InlineValueContext=se={}));var ge;(function(Me){function Te(ne){return{range:r.from(ne.range),kind:ne.kind}}Me.from=Te;function Se(ne){return new i.$IK(r.to(ne.range),ne.kind)}Me.to=Se})(ge||(e.DocumentHighlight=ge={}));var te;(function(Me){function Te(Se){switch(Se){case 1:return i.CompletionTriggerKind.TriggerCharacter;case 2:return i.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return i.CompletionTriggerKind.Invoke}}Me.to=Te})(te||(e.CompletionTriggerKind=te={}));var me;(function(Me){function Te(Se){return{triggerKind:te.to(Se.triggerKind),triggerCharacter:Se.triggerCharacter}}Me.to=Te})(me||(e.CompletionContext=me={}));var we;(function(Me){function Te(ne){switch(ne){case i.CompletionItemTag.Deprecated:return 1}}Me.from=Te;function Se(ne){switch(ne){case 1:return i.CompletionItemTag.Deprecated}}Me.to=Se})(we||(e.CompletionItemTag=we={}));var Ie;(function(Me){const Te=new Map([[i.CompletionItemKind.Method,0],[i.CompletionItemKind.Function,1],[i.CompletionItemKind.Constructor,2],[i.CompletionItemKind.Field,3],[i.CompletionItemKind.Variable,4],[i.CompletionItemKind.Class,5],[i.CompletionItemKind.Interface,7],[i.CompletionItemKind.Struct,6],[i.CompletionItemKind.Module,8],[i.CompletionItemKind.Property,9],[i.CompletionItemKind.Unit,12],[i.CompletionItemKind.Value,13],[i.CompletionItemKind.Constant,14],[i.CompletionItemKind.Enum,15],[i.CompletionItemKind.EnumMember,16],[i.CompletionItemKind.Keyword,17],[i.CompletionItemKind.Snippet,27],[i.CompletionItemKind.Text,18],[i.CompletionItemKind.Color,19],[i.CompletionItemKind.File,20],[i.CompletionItemKind.Reference,21],[i.CompletionItemKind.Folder,23],[i.CompletionItemKind.Event,10],[i.CompletionItemKind.Operator,11],[i.CompletionItemKind.TypeParameter,24],[i.CompletionItemKind.Issue,26],[i.CompletionItemKind.User,25]]);function Se(Ve){return Te.get(Ve)??9}Me.from=Se;const ne=new Map([[0,i.CompletionItemKind.Method],[1,i.CompletionItemKind.Function],[2,i.CompletionItemKind.Constructor],[3,i.CompletionItemKind.Field],[4,i.CompletionItemKind.Variable],[5,i.CompletionItemKind.Class],[7,i.CompletionItemKind.Interface],[6,i.CompletionItemKind.Struct],[8,i.CompletionItemKind.Module],[9,i.CompletionItemKind.Property],[12,i.CompletionItemKind.Unit],[13,i.CompletionItemKind.Value],[14,i.CompletionItemKind.Constant],[15,i.CompletionItemKind.Enum],[16,i.CompletionItemKind.EnumMember],[17,i.CompletionItemKind.Keyword],[27,i.CompletionItemKind.Snippet],[18,i.CompletionItemKind.Text],[19,i.CompletionItemKind.Color],[20,i.CompletionItemKind.File],[21,i.CompletionItemKind.Reference],[23,i.CompletionItemKind.Folder],[10,i.CompletionItemKind.Event],[11,i.CompletionItemKind.Operator],[24,i.CompletionItemKind.TypeParameter],[25,i.CompletionItemKind.User],[26,i.CompletionItemKind.Issue]]);function Fe(Ve){return ne.get(Ve)??i.CompletionItemKind.Property}Me.to=Fe})(Ie||(e.CompletionItemKind=Ie={}));var W;(function(Me){function Te(Se,ne){const Fe=new i.$YK(Se.label);return Fe.insertText=Se.insertText,Fe.kind=Ie.to(Se.kind),Fe.tags=Se.tags?.map(we.to),Fe.detail=Se.detail,Fe.documentation=A.$6j(Se.documentation)?T.to(Se.documentation):Se.documentation,Fe.sortText=Se.sortText,Fe.filterText=Se.filterText,Fe.preselect=Se.preselect,Fe.commitCharacters=Se.commitCharacters,D.$ys.isIRange(Se.range)?Fe.range=r.to(Se.range):typeof Se.range=="object"&&(Fe.range={inserting:r.to(Se.range.insert),replacing:r.to(Se.range.replace)}),Fe.keepWhitespace=typeof Se.insertTextRules>"u"?!1:!!(Se.insertTextRules&1),typeof Se.insertTextRules<"u"&&Se.insertTextRules&4?Fe.insertText=new i.$DK(Se.insertText):(Fe.insertText=Se.insertText,Fe.textEdit=Fe.range instanceof i.$uK?new i.$zK(Fe.range,Fe.insertText):void 0),Se.additionalTextEdits&&Se.additionalTextEdits.length>0&&(Fe.additionalTextEdits=Se.additionalTextEdits.map(Ve=>Q.to(Ve))),Fe.command=ne&&Se.command?ne.fromInternal(Se.command):void 0,Fe}Me.to=Te})(W||(e.CompletionItem=W={}));var J;(function(Me){function Te(ne){if(typeof ne.label!="string"&&!Array.isArray(ne.label))throw new TypeError("Invalid label");return{label:ne.label,documentation:T.fromStrict(ne.documentation)}}Me.from=Te;function Se(ne){return{label:ne.label,documentation:A.$6j(ne.documentation)?T.to(ne.documentation):ne.documentation}}Me.to=Se})(J||(e.ParameterInformation=J={}));var ce;(function(Me){function Te(ne){return{label:ne.label,documentation:T.fromStrict(ne.documentation),parameters:Array.isArray(ne.parameters)?ne.parameters.map(J.from):[],activeParameter:ne.activeParameter}}Me.from=Te;function Se(ne){return{label:ne.label,documentation:A.$6j(ne.documentation)?T.to(ne.documentation):ne.documentation,parameters:Array.isArray(ne.parameters)?ne.parameters.map(J.to):[],activeParameter:ne.activeParameter}}Me.to=Se})(ce||(e.SignatureInformation=ce={}));var de;(function(Me){function Te(ne){return{activeSignature:ne.activeSignature,activeParameter:ne.activeParameter,signatures:Array.isArray(ne.signatures)?ne.signatures.map(ce.from):[]}}Me.from=Te;function Se(ne){return{activeSignature:ne.activeSignature,activeParameter:ne.activeParameter,signatures:Array.isArray(ne.signatures)?ne.signatures.map(ce.to):[]}}Me.to=Se})(de||(e.SignatureHelp=de={}));var ee;(function(Me){function Te(Se,ne){const Fe=new i.$XK(v.to(ne.position),typeof ne.label=="string"?ne.label:ne.label.map($e.to.bind(void 0,Se)),ne.kind&&ve.to(ne.kind));return Fe.textEdits=ne.textEdits&&ne.textEdits.map(Q.to),Fe.tooltip=A.$6j(ne.tooltip)?T.to(ne.tooltip):ne.tooltip,Fe.paddingLeft=ne.paddingLeft,Fe.paddingRight=ne.paddingRight,Fe}Me.to=Te})(ee||(e.InlayHint=ee={}));var $e;(function(Me){function Te(Se,ne){const Fe=new i.$WK(ne.label);return Fe.tooltip=A.$6j(ne.tooltip)?T.to(ne.tooltip):ne.tooltip,E.Command.is(ne.command)&&(Fe.command=Se.fromInternal(ne.command)),ne.location&&(Fe.location=H.to(ne.location)),Fe}Me.to=Te})($e||(e.InlayHintLabelPart=$e={}));var ve;(function(Me){function Te(ne){return ne}Me.from=Te;function Se(ne){return ne}Me.to=Se})(ve||(e.InlayHintKind=ve={}));var Ne;(function(Me){function Te(ne){return{range:r.from(ne.range),url:ne.target,tooltip:ne.tooltip}}Me.from=Te;function Se(ne){let Fe;if(ne.url)try{Fe=typeof ne.url=="string"?S.URI.parse(ne.url,!0):S.URI.revive(ne.url)}catch{}return new i.$4K(r.to(ne.range),Fe)}Me.to=Se})(Ne||(e.DocumentLink=Ne={}));var qe;(function(Me){function Te(ne){const Fe=new i.$7K(ne.label);return ne.textEdit&&(Fe.textEdit=Q.to(ne.textEdit)),ne.additionalTextEdits&&(Fe.additionalTextEdits=ne.additionalTextEdits.map(Ve=>Q.to(Ve))),Fe}Me.to=Te;function Se(ne){return{label:ne.label,textEdit:ne.textEdit?Q.from(ne.textEdit):void 0,additionalTextEdits:ne.additionalTextEdits?ne.additionalTextEdits.map(Fe=>Q.from(Fe)):void 0}}Me.from=Se})(qe||(e.ColorPresentation=qe={}));var xe;(function(Me){function Te(ne){return new i.$5K(ne[0],ne[1],ne[2],ne[3])}Me.to=Te;function Se(ne){return[ne.red,ne.green,ne.blue,ne.alpha]}Me.from=Se})(xe||(e.Color=xe={}));var Ge;(function(Me){function Te(ne){return{range:r.from(ne.range)}}Me.from=Te;function Se(ne){return new i.$NK(r.to(ne.range))}Me.to=Se})(Ge||(e.SelectionRange=Ge={}));var st;(function(Me){function Te(Se){switch(Se){case 2:return i.TextDocumentSaveReason.AfterDelay;case 1:return i.TextDocumentSaveReason.Manual;case 3:case 4:return i.TextDocumentSaveReason.FocusOut}}Me.to=Te})(st||(e.TextDocumentSaveReason=st={}));var it;(function(Me){function Te(ne){switch(ne){case i.TextEditorLineNumbersStyle.Off:return 0;case i.TextEditorLineNumbersStyle.Relative:return 2;case i.TextEditorLineNumbersStyle.On:default:return 1}}Me.from=Te;function Se(ne){switch(ne){case 0:return i.TextEditorLineNumbersStyle.Off;case 2:return i.TextEditorLineNumbersStyle.Relative;case 1:default:return i.TextEditorLineNumbersStyle.On}}Me.to=Se})(it||(e.TextEditorLineNumbersStyle=it={}));var nt;(function(Me){function Te(ne){if(ne===i.EndOfLine.CRLF)return 1;if(ne===i.EndOfLine.LF)return 0}Me.from=Te;function Se(ne){if(ne===1)return i.EndOfLine.CRLF;if(ne===0)return i.EndOfLine.LF}Me.to=Se})(nt||(e.EndOfLine=nt={}));var Ae;(function(Me){function Te(Se){if(typeof Se=="object")return Se.viewId;switch(Se){case i.ProgressLocation.SourceControl:return 3;case i.ProgressLocation.Window:return 10;case i.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Me.from=Te})(Ae||(e.ProgressLocation=Ae={}));var Oe;(function(Me){function Te(ne){const Fe={start:ne.start+1,end:ne.end+1};return ne.kind&&(Fe.kind=Re.from(ne.kind)),Fe}Me.from=Te;function Se(ne){const Fe={start:ne.start-1,end:ne.end-1};return ne.kind&&(Fe.kind=Re.to(ne.kind)),Fe}Me.to=Se})(Oe||(e.FoldingRange=Oe={}));var Re;(function(Me){function Te(ne){if(ne)switch(ne){case i.FoldingRangeKind.Comment:return E.$nt.Comment;case i.FoldingRangeKind.Imports:return E.$nt.Imports;case i.FoldingRangeKind.Region:return E.$nt.Region}}Me.from=Te;function Se(ne){if(ne)switch(ne.value){case E.$nt.Comment.value:return i.FoldingRangeKind.Comment;case E.$nt.Imports.value:return i.FoldingRangeKind.Imports;case E.$nt.Region.value:return i.FoldingRangeKind.Region}}Me.to=Se})(Re||(e.FoldingRangeKind=Re={}));var Qe;(function(Me){function Te(Se){if(Se)return{pinned:typeof Se.preview=="boolean"?!Se.preview:void 0,inactive:Se.background,preserveFocus:Se.preserveFocus,selection:typeof Se.selection=="object"?r.from(Se.selection):void 0,override:typeof Se.override=="boolean"?d.$ZD.id:void 0}}Me.from=Te})(Qe||(e.TextEditorOpenOptions=Qe={}));var ue;(function(Me){function Te(Ve){return Ve instanceof i.$oL?Ve.toJSON():typeof Ve=="string"?Ve:Se(Ve)||ne(Ve)?new i.$oL(Ve.baseUri??Ve.base,Ve.pattern).toJSON():Ve}Me.from=Te;function Se(Ve){const _e=Ve;return _e?S.URI.isUri(_e.baseUri)&&typeof _e.pattern=="string":!1}function ne(Ve){const _e=Ve;return _e?typeof _e.base=="string"&&typeof _e.pattern=="string":!1}function Fe(Ve){return typeof Ve=="string"?Ve:new i.$oL(S.URI.revive(Ve.baseUri),Ve.pattern)}Me.to=Fe})(ue||(e.GlobPattern=ue={}));var ae;(function(Me){function Te(Se){if(Se){if(Array.isArray(Se))return Se.map(Te);if(typeof Se=="string")return Se;{const ne=Se;return{language:ne.language,scheme:ne.scheme,pattern:ue.from(ne.pattern),exclusive:ne.exclusive,notebookType:ne.notebookType}}}else return}Me.from=Te})(ae||(e.LanguageSelector=ae={}));var Pe;(function(Me){function Te(ne){return!!ne&&typeof ne=="object"&&"documents"in ne&&Array.isArray(ne.documents)&&ne.documents.every(Fe=>Array.isArray(Fe)&&Fe.every(Ve=>Ve&&typeof Ve=="object"&&"uri"in Ve&&S.URI.isUri(Ve.uri)&&"version"in Ve&&typeof Ve.version=="number"&&"ranges"in Ve&&Array.isArray(Ve.ranges)&&Ve.ranges.every(_e=>_e instanceof i.$uK)))}Me.is=Te;function Se(ne){return{documents:ne.documents.map(Fe=>Fe.map(Ve=>({uri:S.URI.from(Ve.uri),version:Ve.version,ranges:Ve.ranges.map(_e=>r.from(_e))})))}}Me.from=Se})(Pe||(e.MappedEditsContext=Pe={}));var Ke;(function(Me){function Te(ne){return{start:ne.start,end:ne.end}}Me.from=Te;function Se(ne){return new i.$PL(ne.start,ne.end)}Me.to=Se})(Ke||(e.NotebookRange=Ke={}));var Ue;(function(Me){function Te(ne){return{timing:typeof ne.runStartTime=="number"&&typeof ne.runEndTime=="number"?{startTime:ne.runStartTime,endTime:ne.runEndTime}:void 0,executionOrder:ne.executionOrder,success:ne.lastRunSuccess}}Me.to=Te;function Se(ne){return{lastRunSuccess:ne.success,runStartTime:ne.timing?.startTime,runEndTime:ne.timing?.endTime,executionOrder:ne.executionOrder}}Me.from=Se})(Ue||(e.NotebookCellExecutionSummary=Ue={}));var Ze;(function(Me){function Te(Se){if(Se===c.NotebookCellExecutionState.Unconfirmed)return i.NotebookCellExecutionState.Pending;if(Se===c.NotebookCellExecutionState.Pending)return;if(Se===c.NotebookCellExecutionState.Executing)return i.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${Se}`)}Me.to=Te})(Ze||(e.NotebookCellExecutionState=Ze={}));var rt;(function(Me){function Te(ne){switch(ne){case i.NotebookCellKind.Markup:return c.CellKind.Markup;case i.NotebookCellKind.Code:default:return c.CellKind.Code}}Me.from=Te;function Se(ne){switch(ne){case c.CellKind.Markup:return i.NotebookCellKind.Markup;case c.CellKind.Code:default:return i.NotebookCellKind.Code}}Me.to=Se})(rt||(e.NotebookCellKind=rt={}));var ht;(function(Me){function Te(ne){const Fe={metadata:ne.metadata??Object.create(null),cells:[]};for(const Ve of ne.cells)i.$QL.validate(Ve),Fe.cells.push(pt.from(Ve));return Fe}Me.from=Te;function Se(ne){const Fe=new i.$RL(ne.cells.map(pt.to));return(0,p.$Mf)(ne.metadata)||(Fe.metadata=ne.metadata),Fe}Me.to=Se})(ht||(e.NotebookData=ht={}));var pt;(function(Me){function Te(ne){return{cellKind:rt.from(ne.kind),language:ne.languageId,mime:ne.mime,source:ne.value,metadata:ne.metadata,internalMetadata:Ue.from(ne.executionSummary??{}),outputs:ne.outputs?ne.outputs.map(qt.from):[]}}Me.from=Te;function Se(ne){return new i.$QL(rt.to(ne.cellKind),ne.source,ne.language,ne.mime,ne.outputs?ne.outputs.map(qt.to):void 0,ne.metadata,ne.internalMetadata?Ue.to(ne.internalMetadata):void 0)}Me.to=Se})(pt||(e.NotebookCellData=pt={}));var Dt;(function(Me){function Te(ne){return{mime:ne.mime,valueBytes:M.$ce.wrap(ne.data)}}Me.from=Te;function Se(ne){return new i.$SL(ne.valueBytes.buffer,ne.mime)}Me.to=Se})(Dt||(e.NotebookCellOutputItem=Dt={}));var qt;(function(Me){function Te(ne){return{outputId:ne.id,items:ne.items.map(Dt.from),metadata:ne.metadata}}Me.from=Te;function Se(ne){const Fe=ne.items.map(Dt.to);return new i.$TL(Fe,ne.outputId,ne.metadata)}Me.to=Se})(qt||(e.NotebookCellOutput=qt={}));var Vt;(function(Me){function Te(Fe){return ne(Fe)?{include:ue.from(Fe.include)??void 0,exclude:ue.from(Fe.exclude)??void 0}:ue.from(Fe)??void 0}Me.from=Te;function Se(Fe){return ne(Fe)?{include:ue.to(Fe.include),exclude:ue.to(Fe.exclude)}:ue.to(Fe)}Me.to=Se;function ne(Fe){const Ve=Fe;return Ve?!(0,p.$If)(Ve.include)&&!(0,p.$If)(Ve.exclude):!1}})(Vt||(e.NotebookExclusiveDocumentPattern=Vt={}));var Et;(function(Me){function Te(Se,ne,Fe){const Ve=typeof Se.command=="string"?{title:"",command:Se.command}:Se.command;return{alignment:Se.alignment===i.NotebookCellStatusBarAlignment.Left?1:2,command:ne.toInternal(Ve,Fe),text:Se.text,tooltip:Se.tooltip,accessibilityInformation:Se.accessibilityInformation,priority:Se.priority}}Me.from=Te})(Et||(e.NotebookStatusBarItem=Et={}));var Tt;(function(Me){function Te(Se,ne,Fe){const Ve=typeof Se.command=="string"?{title:"",command:Se.command}:Se.command;return{command:ne.toInternal(Ve,Fe),label:Se.label,description:Se.description,detail:Se.detail,documentation:Se.documentation}}Me.from=Te})(Tt||(e.NotebookKernelSourceAction=Tt={}));var Ot;(function(Me){function Te(Se){return{transientOutputs:Se?.transientOutputs??!1,transientCellMetadata:Se?.transientCellMetadata??{},transientDocumentMetadata:Se?.transientDocumentMetadata??{},cellContentMetadata:Se?.cellContentMetadata??{}}}Me.from=Te})(Ot||(e.NotebookDocumentContentOptions=Ot={}));var _t;(function(Me){function Te(ne){return{uri:ne.uri,provides:ne.provides}}Me.from=Te;function Se(ne){return new i.$VL(S.URI.revive(ne.uri),ne.provides)}Me.to=Se})(_t||(e.NotebookRendererScript=_t={}));var Yt;(function(Me){function Te(ne){return{message:T.fromStrict(ne.message)||"",type:0,expected:ne.expectedOutput,actual:ne.actualOutput,contextValue:ne.contextValue,location:ne.location&&{range:r.from(ne.location.range),uri:ne.location.uri}}}Me.from=Te;function Se(ne){const Fe=new i.$2L(typeof ne.message=="string"?ne.message:T.to(ne.message));return Fe.actualOutput=ne.actual,Fe.expectedOutput=ne.expected,Fe.contextValue=ne.contextValue,Fe.location=ne.location?H.to(ne.location):void 0,Fe}Me.to=Se})(Yt||(e.TestMessage=Yt={}));var Pt;(function(Me){Me.namespace=a.$nJ,Me.denamespace=a.$oJ})(Pt||(e.TestTag=Pt={}));var Nt;(function(Me){function Te(ne){const Fe=(0,u.$nM)(ne).controllerId;return{extId:f.$jJ.fromExtHostTestItem(ne,Fe).toString(),label:ne.label,uri:S.URI.revive(ne.uri),busy:ne.busy,tags:ne.tags.map(Ve=>Pt.namespace(Fe,Ve.id)),range:D.$ys.lift(r.from(ne.range)),description:ne.description||null,sortText:ne.sortText||null,error:ne.error&&T.fromStrict(ne.error)||null}}Me.from=Te;function Se(ne){return{parent:void 0,error:void 0,id:f.$jJ.fromString(ne.extId).localId,label:ne.label,uri:S.URI.revive(ne.uri),tags:(ne.tags||[]).map(Fe=>{const{tagId:Ve}=Pt.denamespace(Fe);return new i.$3L(Ve)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:r.to(ne.range||void 0),canResolveChildren:!1,busy:ne.busy,description:ne.description||void 0,sortText:ne.sortText||void 0}}Me.toPlain=Se})(Nt||(e.TestItem=Nt={})),function(Me){function Te(ne){return{id:ne.id}}Me.from=Te;function Se(ne){return new i.$3L(ne.id)}Me.to=Se}(Pt||(e.TestTag=Pt={}));var Jt;(function(Me){const Te=(ne,Fe)=>{const Ve=[];for(const[Ye,ot]of Fe)f.$jJ.compare(ot.item.extId,Ye)===2&&(Fe.delete(Ye),Ve.push(ot));const _e={...Nt.toPlain(ne.item),parent:void 0,taskStates:ne.tasks.map(Ye=>({state:Ye.state,duration:Ye.duration,messages:Ye.messages.filter(ot=>ot.type===0).map(Yt.to)})),children:Ve.map(Ye=>Te(Ye,Fe))};for(const Ye of _e.children)Ye.parent=_e;return _e};function Se(ne){const Fe=[],Ve=new Map;for(const _e of ne.items){Ve.set(_e.item.extId,_e);const Ye=f.$jJ.root(_e.item.extId);ne.request.targets.some(ot=>ot.controllerId===Ye&&ot.testIds.includes(_e.item.extId))&&Fe.push(_e)}return{completedAt:ne.completedAt,results:Fe.map(_e=>Te(_e,Ve))}}Me.to=Se})(Jt||(e.TestResults=Jt={}));var jt;(function(Me){function Te(Ve){return{covered:Ve.covered,total:Ve.covered}}function Se(Ve){return"line"in Ve?v.from(Ve):r.from(Ve)}function ne(Ve){return"branches"in Ve?{count:Ve.executionCount,location:Se(Ve.location),type:1,branches:Ve.branches.length?Ve.branches.map(_e=>({count:_e.executionCount,location:_e.location&&Se(_e.location)})):void 0}:{type:0,count:Ve.executionCount,location:Se(Ve.location)}}Me.fromDetailed=ne;function Fe(Ve){return{uri:Ve.uri,statement:Te(Ve.statementCoverage),branch:Ve.branchCoverage&&Te(Ve.branchCoverage),function:Ve.functionCoverage&&Te(Ve.functionCoverage),details:Ve.detailedCoverage?.map(ne)}}Me.fromFile=Fe})(jt||(e.TestCoverage=jt={}));var Kt;(function(Me){function Te(Se){switch(Se){case 1:return i.CodeActionTriggerKind.Invoke;case 2:return i.CodeActionTriggerKind.Automatic}}Me.to=Te})(Kt||(e.CodeActionTriggerKind=Kt={}));var Ht;(function(Me){function Te(ne){const Fe=new i.$9L(ie.to(ne.kind),ne.name,ne.detail||"",S.URI.revive(ne.uri),r.to(ne.range),r.to(ne.selectionRange));return Fe._sessionId=ne._sessionId,Fe._itemId=ne._itemId,Fe}Me.to=Te;function Se(ne,Fe,Ve){if(Fe=Fe??ne._sessionId,Ve=Ve??ne._itemId,Fe===void 0||Ve===void 0)throw new Error("invalid item");return{_sessionId:Fe,_itemId:Ve,kind:ie.from(ne.kind),name:ne.name,detail:ne.detail??"",uri:ne.uri,range:r.from(ne.range),selectionRange:r.from(ne.selectionRange),tags:ne.tags?.map(_.from)}}Me.from=Se})(Ht||(e.TypeHierarchyItem=Ht={}));var It;(function(Me){function Te(Se){if(Se)return{value:Se.value,tooltip:Se.tooltip}}Me.from=Te})(It||(e.ViewBadge=It={}));var ut;(function(Me){function Te(Ve,_e,Ye){const ot=_e.fileData;return ot?new i.$hL(new i.$iL(ot.name,S.URI.revive(ot.uri),ot.id,(0,L.$db)(()=>Ye(ot.id)))):Ve===R.$Ur.uriList&&_e.uriListData?new i.$gL(Fe(_e.uriListData)):new i.$gL(_e.asString)}Me.to=Te;async function Se(Ve,_e){const Ye=await _e.asString();if(Ve===R.$Ur.uriList)return{asString:Ye,fileData:void 0,uriListData:ne(Ye)};const ot=_e.asFile();return{asString:Ye,fileData:ot?{name:ot.name,uri:ot.uri,id:ot._itemId??ot.id}:void 0}}Me.from=Se;function ne(Ve){return l.$8s.split(Ve).map(_e=>{if(_e.startsWith("#"))return _e;try{return S.URI.parse(_e)}catch{}return _e})}function Fe(Ve){return l.$8s.create(Ve.map(_e=>typeof _e=="string"?_e:S.URI.revive(_e)))}})(ut||(e.DataTransferItem=ut={}));var ft;(function(Me){function Te(ne,Fe){const Ve=ne.items.map(([_e,Ye])=>[_e,ut.to(_e,Ye,Fe)]);return new i.$jL(Ve)}Me.toDataTransfer=Te;async function Se(ne){const Fe={items:[]},Ve=[];for(const[_e,Ye]of ne)Ve.push((async()=>{Fe.items.push([_e,await ut.from(_e,Ye)])})());return await Promise.all(Ve),Fe}Me.from=Se})(ft||(e.DataTransfer=ft={}));var At;(function(Me){function Te(ne){return{message:ne.message,metadata:ne.metadata,title:ne.title,tooltip:ne.tooltip}}Me.to=Te;function Se(ne){return{kind:"reply",message:ne.message,metadata:ne.metadata,title:ne.title,tooltip:ne.tooltip}}Me.from=Se})(At||(e.ChatReplyFollowup=At={}));var Ft;(function(Me){function Te(Se){return typeof Se=="string"?{title:Se,message:Se,kind:"reply"}:"commandId"in Se?{kind:"command",title:Se.title??"",commandId:Se.commandId??"",when:Se.when??"",args:Se.args}:At.from(Se)}Me.from=Te})(Ft||(e.ChatFollowup=Ft={}));var Mt;(function(Me){function Te(ne){const Fe=new i.$gM(lt.to(ne.role),ne.content);return Fe.name=ne.name,Fe}Me.to=Te;function Se(ne){return{role:lt.from(ne.role),content:ne.content,name:ne.name}}Me.from=Se})(Mt||(e.ChatMessage=Mt={}));var lt;(function(Me){function Te(ne){switch(ne){case 0:return i.ChatMessageRole.System;case 1:return i.ChatMessageRole.User;case 2:return i.ChatMessageRole.Assistant;case 3:return i.ChatMessageRole.Function}}Me.to=Te;function Se(ne){switch(ne){case i.ChatMessageRole.System:return 0;case i.ChatMessageRole.Assistant:return 2;case i.ChatMessageRole.Function:return 3;case i.ChatMessageRole.User:default:return 1}}Me.from=Se})(lt||(e.ChatMessageRole=lt={}));var kt;(function(Me){function Te(Fe){const Ve={};for(const _e of Object.keys(Fe))Ve[_e]=Fe[_e].map(Me.to);return Ve}Me.objectTo=Te;function Se(Fe){return{level:zt.to(Fe.level),value:Fe.value,description:Fe.description}}Me.to=Se;function ne(Fe){return{level:zt.from(Fe.level),value:Fe.value,description:Fe.description}}Me.from=ne})(kt||(e.ChatVariable=kt={}));var zt;(function(Me){function Te(ne){switch(ne){case"short":return i.ChatVariableLevel.Short;case"medium":return i.ChatVariableLevel.Medium;case"full":default:return i.ChatVariableLevel.Full}}Me.to=Te;function Se(ne){switch(ne){case i.ChatVariableLevel.Short:return"short";case i.ChatVariableLevel.Medium:return"medium";case i.ChatVariableLevel.Full:default:return"full"}}Me.from=Se})(zt||(e.ChatVariableLevel=zt={}));var Ut;(function(Me){function Te(Se){switch(Se){case 1:return i.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return i.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return i.InteractiveEditorResponseFeedbackKind.Undone;case 3:return i.InteractiveEditorResponseFeedbackKind.Accepted}}Me.to=Te})(Ut||(e.InteractiveEditorResponseFeedbackKind=Ut={}));var Je;(function(Me){function Te(Se,ne){return"placeholder"in ne&&"resolvedContent"in ne?{placeholder:ne.placeholder}:"responseId"in ne?{requestId:ne.responseId}:"markdownContent"in ne?((0,s.$mF)(Se,"chatAgents2Additions"),{content:T.from(ne.markdownContent)}):"content"in ne?typeof ne.content=="string"?ne:((0,s.$mF)(Se,"chatAgents2Additions"),{content:T.from(ne.content)}):"documents"in ne?{documents:ne.documents.map(Fe=>({uri:Fe.uri,version:Fe.version,ranges:Fe.ranges.map(Ve=>r.from(Ve))}))}:"reference"in ne?{reference:"uri"in ne.reference?{uri:ne.reference.uri,range:r.from(ne.reference.range)}:ne.reference}:"inlineReference"in ne?{inlineReference:"uri"in ne.inlineReference?{uri:ne.inlineReference.uri,range:r.from(ne.inlineReference.range)}:ne.inlineReference,title:ne.title}:("agentName"in ne&&(0,s.$mF)(Se,"chatAgents2Additions"),ne)}Me.from=Te})(Je||(e.ChatResponseProgress=Je={}));var Qt;(function(Me){function Te(Se,ne,Fe){return"terminalCommand"in Se?{terminalCommand:Se.terminalCommand}:"uri"in Se?{uri:Se.uri}:ne.toInternal(Se,Fe)}Me.from=Te})(Qt||(e.TerminalQuickFix=Qt={}))}),define(De[283],Ce([1,0,2,9,7,13,76]),function(re,e,y,M,l,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ycc=void 0;class g{constructor($,R,P,p={timeout:1500,errors:3}){this.c=$,this.d=R,this.f=P,this.g=p,this.a=new A.$2c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent($){return(R,P,p)=>{const D={dispose:this.a.push([R,P,$])};return Array.isArray(p)&&p.push(D),D}}async $participateInSave($,R){const P=y.URI.revive($);let p=!1;const S=setTimeout(()=>p=!0,this.g.timeout),D=[];try{for(const E of[...this.a]){if(p)break;const h=this.d.getDocument(P),u=await this.h(E,{document:h,reason:L.TextDocumentSaveReason.to(R)});D.push(u)}}finally{clearTimeout(S)}return D}h([$,R,P],p){const S=this.b.get($);return typeof S=="number"&&S>this.g.errors?Promise.resolve(!1):this.i(P,$,R,p).then(()=>!0,D=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${P.identifier.value}' threw ERROR`),this.c.error(D),!(D instanceof Error)||D.message!=="concurrent_edits"){const E=this.b.get($);this.b.set($,E?E+1:1),typeof E=="number"&&E>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${P.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i($,R,P,p){const S=[],D=Date.now(),{document:E,reason:h}=p,{version:u}=E,d=Object.freeze({document:E,reason:h,waitUntil(c){if(Object.isFrozen(S))throw(0,M.$8)("waitUntil can not be called async");S.push(Promise.resolve(c))}});try{R.apply(P,[d])}catch(c){return Promise.reject(c)}return Object.freeze(S),new Promise((c,f)=>{const a=setTimeout(()=>f(new Error("timeout")),this.g.timeout);return Promise.all(S).then(t=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${$.identifier.value}' finished after ${Date.now()-D}ms`),clearTimeout(a),c(t)}).catch(t=>{clearTimeout(a),f(t)})}).then(c=>{const f={edits:[]};for(const a of c)if(Array.isArray(a)&&a.every(t=>t instanceof l.$zK))for(const{newText:t,newEol:i,range:s}of a)f.edits.push({resource:E.uri,versionId:void 0,textEdit:{range:s&&L.Range.from(s),text:t,eol:i&&L.EndOfLine.from(i)}});if(f.edits.length!==0)return u===E.version?this.f.$tryApplyWorkspaceEdit(f):Promise.reject(new Error("concurrent_edits"))})}}e.$Ycc=g}),define(De[284],Ce([1,0,18,2,13,7,109]),function(re,e,y,M,l,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aec=e.$_dc=void 0;class g{constructor(P,p,S,D){this.start=P,this.deletedCount=p,this.deletedItems=S,this.items=D}asApiEvent(){return{range:new L.$PL(this.start,this.start+this.deletedCount),addedCells:this.items.map(P=>P.apiCell),removedCells:this.deletedItems}}}class k{static asModelAddData(P,p){return{EOL:p.eol,lines:p.source,languageId:p.language,uri:p.uri,isDirty:!1,versionId:1,notebook:P}}constructor(P,p,S){this.notebook=P,this.h=p,this.j=S,this.handle=S.handle,this.uri=M.URI.revive(S.uri),this.cellKind=S.cellKind,this.a=S.outputs.map(l.NotebookCellOutput.to),this.e=S.internalMetadata??{},this.b=Object.freeze(S.metadata??{}),this.d=Object.freeze(l.NotebookCellExecutionSummary.to(S.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const P=this,p=this.h.getDocument(this.uri);if(!p)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const S={get index(){return P.notebook.getCellIndex(P)},notebook:P.notebook.apiNotebook,kind:l.NotebookCellKind.to(this.j.cellKind),document:p.document,get mime(){return P.g},set mime(D){P.g=D},get outputs(){return P.a.slice(0)},get metadata(){return P.b},get executionSummary(){return P.d}};this.f=Object.freeze(S)}return this.f}setOutputs(P){this.a=P.map(l.NotebookCellOutput.to)}setOutputItems(P,p,S){const D=S.map(l.NotebookCellOutputItem.to),E=this.a.find(h=>h.id===P);if(E&&(p||(E.items.length=0),E.items.push(...D),E.items.length>1&&E.items.every(h=>A.$zI(h.mime)))){const h=new Map,u=[];E.items.forEach(d=>{let c;h.has(d.mime)?c=h.get(d.mime):(c=[],h.set(d.mime,c),u.push(d.mime)),c.push(d.data)}),E.items.length=0,u.forEach(d=>{const c=A.$AI(h.get(d));E.items.push({mime:d,data:c.data.buffer})})}}setMetadata(P){this.b=Object.freeze(P)}setInternalMetadata(P){this.e=P,this.d=Object.freeze(l.NotebookCellExecutionSummary.to(P))}setMime(P){}}e.$_dc=k;class ${constructor(P,p,S,D,E){this.k=P,this.l=p,this.m=S,this.uri=D,this.handle=$.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=E.viewType,this.f=Object.freeze(E.metadata??Object.create(null)),this.r([[0,0,E.cells]],!0,void 0),this.g=E.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const P=this,p={get uri(){return P.uri},get version(){return P.g},get notebookType(){return P.d},get isDirty(){return P.h},get isUntitled(){return P.uri.scheme===y.Schemas.untitled},get isClosed(){return P.j},get metadata(){return P.f},get cellCount(){return P.b.length},cellAt(S){return S=P.n(S),P.b[S].apiCell},getCells(S){return(S?P.p(S):P.b).map(E=>E.apiCell)},save(){return P.q()}};this.e=Object.freeze(p)}return this.e}acceptDocumentPropertiesChanged(P){P.metadata&&(this.f=Object.freeze({...this.f,...P.metadata}))}acceptDirty(P){this.h=P}acceptModelChanged(P,p,S){this.g=P.versionId,this.h=p,this.acceptDocumentPropertiesChanged({metadata:S});const D={notebook:this.apiNotebook,metadata:S,cellChanges:[],contentChanges:[]},E=[];for(const u of P.rawEvents)u.kind===A.NotebookCellsChangeType.ModelChange?this.r(u.changes,!1,D.contentChanges):u.kind===A.NotebookCellsChangeType.Move?this.s(u.index,u.length,u.newIdx,D.contentChanges):u.kind===A.NotebookCellsChangeType.Output?(this.t(u.index,u.outputs),E.push({cell:this.b[u.index].apiCell,outputs:this.b[u.index].apiCell.outputs})):u.kind===A.NotebookCellsChangeType.OutputItem?(this.u(u.index,u.outputId,u.append,u.outputItems),E.push({cell:this.b[u.index].apiCell,outputs:this.b[u.index].apiCell.outputs})):u.kind===A.NotebookCellsChangeType.ChangeCellLanguage?(this.v(u.index,u.language),E.push({cell:this.b[u.index].apiCell,document:this.b[u.index].apiCell.document})):u.kind===A.NotebookCellsChangeType.ChangeCellContent?E.push({cell:this.b[u.index].apiCell,document:this.b[u.index].apiCell.document}):u.kind===A.NotebookCellsChangeType.ChangeCellMime?this.w(u.index,u.mime):u.kind===A.NotebookCellsChangeType.ChangeCellMetadata?(this.x(u.index,u.metadata),E.push({cell:this.b[u.index].apiCell,metadata:this.b[u.index].apiCell.metadata})):u.kind===A.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(u.index,u.internalMetadata),E.push({cell:this.b[u.index].apiCell,executionSummary:this.b[u.index].apiCell.executionSummary}));const h=new Map;for(let u=0;u<E.length;u++){const d=E[u],c=h.get(d.cell);if(c===void 0){const f=D.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...d});h.set(d.cell,f-1)}else D.cellChanges[c]={...D.cellChanges[c],...d}}return Object.freeze(D),Object.freeze(D.cellChanges),Object.freeze(D.contentChanges),D}n(P){return P=P|0,P<0?0:P>=this.b.length?this.b.length-1:P}o(P){let p=P.start|0,S=P.end|0;return p<0&&(p=0),S>this.b.length&&(S=this.b.length),P.with({start:p,end:S})}p(P){P=this.o(P);const p=[];for(let S=P.start;S<P.end;S++)p.push(this.b[S]);return p}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(P,p,S){if(this.j)return;const D=[],E=[],h=[];if(P.reverse().forEach(u=>{const c=u[2].map(t=>{const i=new k(this,this.l,t);return p||E.push(k.asModelAddData(this.apiNotebook,t)),i}),f=new g(u[0],u[1],[],c),a=this.b.splice(u[0],u[1],...c);for(const t of a)h.push(t.uri),f.deletedItems.push(t.apiCell);D.push(f)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:E,removedDocuments:h}),S)for(const u of D)S.push(u.asApiEvent())}s(P,p,S,D){const E=this.b.splice(P,p);this.b.splice(S,0,...E);const h=[new g(P,p,E.map(u=>u.apiCell),[]),new g(S,0,[],E)];for(const u of h)D.push(u.asApiEvent())}t(P,p){this.b[P].setOutputs(p)}u(P,p,S,D){this.b[P].setOutputItems(p,S,D)}v(P,p){const S=this.b[P];S.apiCell.document.languageId!==p&&this.m.$acceptModelLanguageChanged(S.uri,p)}w(P,p){const S=this.b[P];S.apiCell.mime=p}x(P,p){this.b[P].setMetadata(p)}y(P,p){this.b[P].setInternalMetadata(p)}getCellFromApiCell(P){return this.b.find(p=>p.apiCell===P)}getCellFromIndex(P){return this.b[P]}getCell(P){return this.b.find(p=>p.handle===P)}getCellIndex(P){return this.b.indexOf(P)}}e.$aec=$,$.a=0}),define(De[285],Ce([1,0,4,2,13,7]),function(re,e,y,M,l,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aec=void 0;class A{constructor(k,$,R,P={timeout:1500,errors:3}){this.b=k,this.c=$,this.d=R,this.f=P,this.a=new y.$Qd}dispose(){}getOnWillSaveNotebookDocumentEvent(k){return($,R,P)=>{const p=function(D){$.call(R,D)};return p.extension=k,this.a.event(p,void 0,P)}}async $participateInSave(k,$,R){const P=M.URI.revive(k),p=this.c.getNotebookDocument(P);if(!p)throw new Error("Unable to resolve notebook document");const S=[];if(await this.a.fireAsync({notebook:p.apiNotebook,reason:l.TextDocumentSaveReason.to($)},R,async(E,h)=>{const u=Date.now(),d=await await Promise.resolve(E);Date.now()-u>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",h.extension.identifier),!R.isCancellationRequested&&d&&(d instanceof L.$CK?S.push(d):this.b.warn("onWillSaveNotebookDocument-listener from extension",h.extension.identifier,"ignored due to invalid data"))}),R.isCancellationRequested)return!1;if(S.length===0)return!0;const D={edits:[]};for(const E of S){const{edits:h}=l.WorkspaceEdit.from(E);D.edits=D.edits.concat(h)}return this.d.$tryApplyWorkspaceEdit(D)}}e.$Aec=A}),define(De[147],Ce([1,0,9,13,7]),function(re,e,y,M,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bec=void 0;class L{constructor(g,k,$,R,P,p){this.id=g,this.f=k,this.notebookData=$,this.a=[],this.b=[],this.d=!1,this.a=P,this.b=R,this.c=p}get apiEditor(){if(!this.e){const g=this;this.e={get notebook(){return g.notebookData.apiNotebook},get selection(){return g.a[0]},set selection(k){this.selections=[k]},get selections(){return g.a},set selections(k){if(!Array.isArray(k)||!k.every(l.$PL.isNotebookRange))throw(0,y.$7)("selections");g.a=k,g.g(k)},get visibleRanges(){return g.b},revealRange(k,$){g.f.$tryRevealRange(g.id,M.NotebookRange.from(k),$??l.NotebookEditorRevealType.Default)},get viewColumn(){return g.c}},L.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(g){this.d=g}_acceptVisibleRanges(g){this.b=g}_acceptSelections(g){this.a=g}g(g){this.f.$trySetSelections(this.id,g.map(M.NotebookRange.from))}_acceptViewColumn(g){this.c=g}}e.$bec=L,L.apiEditorsToExtHost=new WeakMap}),define(De[286],Ce([1,0,9,4,14,13]),function(re,e,y,M,l,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tec=void 0;let A=class{constructor(k,$){this.c=k,this.d=$,this.a=new M.$Od({onListenerError:y.$2}),this.b=new M.$Od({onListenerError:y.$2}),this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(k,$){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",k,$);const R=this.d.getEditorById(k);$.visibleRanges&&R._acceptVisibleRanges($.visibleRanges.ranges.map(L.NotebookRange.to)),$.selections&&R._acceptSelections($.selections.selections.map(L.NotebookRange.to)),$.visibleRanges&&this.b.fire({notebookEditor:R.apiEditor,visibleRanges:R.apiEditor.visibleRanges}),$.selections&&this.a.fire(Object.freeze({notebookEditor:R.apiEditor,selections:R.apiEditor.selections}))}$acceptEditorViewColumns(k){for(const $ in k)this.d.getEditorById($)._acceptViewColumn(L.ViewColumn.to(k[$]))}};e.$tec=A,e.$tec=A=He([We(0,l.$$i)],A)}),define(De[287],Ce([1,0,13,64,209,21,57,9]),function(re,e,y,M,l,L,A,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xdc=void 0;class k{constructor(p){this.b=0,this.c=new Map,this.a=p}async withProgress(p,S,D){const E=this.b++,{title:h,location:u,cancellable:d}=S,c={label:(0,l.localize)(0,null,p.displayName||p.name),id:p.identifier.value};return this.a.$startProgress(E,{location:y.ProgressLocation.from(u),title:h,source:c,cancellable:d},p.isUnderDevelopment?void 0:p.identifier.value).catch(g.$2),this.d(E,D,!!d)}d(p,S,D){let E;D&&(E=new L.$Yd,this.c.set(p,E));const h=d=>{this.a.$progressEnd(d),this.c.delete(d),E?.dispose()};let u;try{u=S(new R(this.a,p),D&&E?E.token:L.CancellationToken.None)}catch(d){throw h(p),d}return u.then(d=>h(p),d=>h(p)),u}$acceptProgressCanceled(p){const S=this.c.get(p);S&&(S.cancel(),this.c.delete(p))}}e.$xdc=k;function $(P,p){return P.message=p.message,typeof p.increment=="number"&&(typeof P.increment=="number"?P.increment+=p.increment:P.increment=p.increment),P}class R extends M.$0u{constructor(p,S){super(D=>this.throttledReport(D)),this.c=p,this.d=S}throttledReport(p){this.c.$progressReport(this.d,p)}}He([(0,A.$kh)(100,(P,p)=>$(P,p),()=>Object.create(null))],R.prototype,"throttledReport",null)}),define(De[148],Ce([1,0,33,143,68,110,87,13,2]),function(re,e,y,M,l,L,A,g,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GM=e.$FM=e.$EM=e.$DM=void 0;const $=(c,f,a,t)=>{let i=f;return{enumerable:!0,configurable:!1,get(){return i},set(s){if(!a(i,s)){const n=i;i=s,c.listener?.(t(s,n))}}}},R=(c,f)=>c===f,P={range:(c,f)=>c===f?!0:!c||!f?!1:c.isEqual(f),label:R,description:R,sortText:R,busy:R,error:R,canResolveChildren:R,tags:(c,f)=>!(c.length!==f.length||c.some(a=>!f.find(t=>a.id===t.id)))},p=c=>f=>({op:4,update:c(f)}),S=(c,f)=>({range:(()=>{let a;const t=p(i=>({range:y.$ys.lift(g.Range.from(i))}));return{enumerable:!0,configurable:!1,get(){return a},set(i){c.listener?.({op:6}),P.range(a,i)||(a=i,c.listener?.(t(i)))}}})(),label:$(c,f,P.label,p(a=>({label:a}))),description:$(c,void 0,P.description,p(a=>({description:a}))),sortText:$(c,void 0,P.sortText,p(a=>({sortText:a}))),canResolveChildren:$(c,!1,P.canResolveChildren,a=>({op:2,state:a})),busy:$(c,!1,P.busy,p(a=>({busy:a}))),error:$(c,void 0,P.error,p(a=>({error:g.MarkdownString.fromStrict(a)||null}))),tags:$(c,[],P.tags,(a,t)=>({op:1,new:a.map(g.TestTag.from),old:t.map(g.TestTag.from)}))}),D=c=>{const f=l.$jJ.fromString(c.extId),a=new h(f.controllerId,f.localId,c.label,k.URI.revive(c.uri)||void 0);return a.range=g.Range.to(c.range||void 0),a.description=c.description||void 0,a.sortText=c.sortText||void 0,a.tags=c.tags.map(t=>g.TestTag.to({id:(0,A.$oJ)(t).tagId})),a},E=c=>{let f;for(const a of c.tests){const t=D(a.item);(0,M.$nM)(t).parent=f,f=t}return f};e.$DM=E;class h{constructor(f,a,t,i){if(a.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(a)} symbol`);const s=(0,M.$mM)(this,f);Object.defineProperties(this,{id:{value:a,enumerable:!0,writable:!1},uri:{value:i,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return s.parent instanceof u?void 0:s.parent}},children:{value:(0,L.$lM)(s,M.$nM,h),enumerable:!0,writable:!1},...S(s,t)})}}e.$EM=h;class u extends h{constructor(f,a){super(f,f,a,void 0),this._isRoot=!0}}e.$FM=u;class d extends L.$hM{constructor(f,a,t){super({controllerId:f,getDocumentVersion:i=>i&&t.getDocument(i)?.version,getApiFor:M.$nM,getChildren:i=>i.children,root:new u(f,a),toITestItem:g.TestItem.from})}}e.$GM=d}),define(De[149],Ce([1,0,58,9,120,13,7]),function(re,e,y,M,l,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AM=e.$zM=e.$yM=void 0;class g{constructor(p,S,D){const E=g.c.nextId();p.$registerTextEditorDecorationType(S.identifier,E,L.DecorationRenderOptions.from(D)),this.value=Object.freeze({key:E,dispose(){p.$removeTextEditorDecorationType(E)}})}}e.$yM=g,g.c=new l.$wM("TextEditorDecorationType");class k{constructor(p,S){this.g=[],this.h=void 0,this.j=!1,this.c=p,this.d=p.version,this.e=S.undoStopBefore,this.f=S.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(p,S){this.k();let D=null;if(p instanceof A.$tK)D=new A.$uK(p,p);else if(p instanceof A.$uK)D=p;else throw new Error("Unrecognized location");this.l(D,S,!1)}insert(p,S){this.k(),this.l(new A.$uK(p,p),S,!0)}delete(p){this.k();let S=null;if(p instanceof A.$uK)S=p;else throw new Error("Unrecognized location");this.l(S,null,!0)}l(p,S,D){const E=this.c.validateRange(p);this.g.push({range:E,text:S,forceMoveMarkers:D})}setEndOfLine(p){if(this.k(),p!==A.EndOfLine.LF&&p!==A.EndOfLine.CRLF)throw(0,M.$7)("endOfLine");this.h=p}}class ${constructor(p,S,D,E){this.c=p,this.d=S,this._accept(D),this.e=E;const h=this;this.value={get tabSize(){return h.f},set tabSize(u){h.m(u)},get indentSize(){return h.g},set indentSize(u){h.o(u)},get insertSpaces(){return h.h},set insertSpaces(u){h.q(u)},get cursorStyle(){return h.j},set cursorStyle(u){h.s(u)},get lineNumbers(){return h.k},set lineNumbers(u){h.t(u)}}}_accept(p){this.f=p.tabSize,this.g=p.indentSize,this.h=p.insertSpaces,this.j=p.cursorStyle,this.k=L.TextEditorLineNumbersStyle.to(p.lineNumbers)}l(p){if(p==="auto")return"auto";if(typeof p=="number"){const S=Math.floor(p);return S>0?S:null}if(typeof p=="string"){const S=parseInt(p,10);return isNaN(S)?null:S>0?S:null}return null}m(p){const S=this.l(p);if(S!==null){if(typeof S=="number"){if(this.f===S)return;this.f=S}this.u("setTabSize",this.c.$trySetOptions(this.d,{tabSize:S}))}}n(p){if(p==="tabSize")return"tabSize";if(typeof p=="number"){const S=Math.floor(p);return S>0?S:null}if(typeof p=="string"){const S=parseInt(p,10);return isNaN(S)?null:S>0?S:null}return null}o(p){const S=this.n(p);if(S!==null){if(typeof S=="number"){if(this.g===S)return;this.g=S}this.u("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:S}))}}p(p){return p==="auto"?"auto":p==="false"?!1:!!p}q(p){const S=this.p(p);if(typeof S=="boolean"){if(this.h===S)return;this.h=S}this.u("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:S}))}s(p){this.j!==p&&(this.j=p,this.u("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:p})))}t(p){this.k!==p&&(this.k=p,this.u("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:L.TextEditorLineNumbersStyle.from(p)})))}assign(p){const S={};let D=!1;if(typeof p.tabSize<"u"){const E=this.l(p.tabSize);E==="auto"?(D=!0,S.tabSize=E):typeof E=="number"&&this.f!==E&&(this.f=E,D=!0,S.tabSize=E)}if(typeof p.indentSize<"u"){const E=this.n(p.indentSize);E==="tabSize"?(D=!0,S.indentSize=E):typeof E=="number"&&this.g!==E&&(this.g=E,D=!0,S.indentSize=E)}if(typeof p.insertSpaces<"u"){const E=this.p(p.insertSpaces);E==="auto"?(D=!0,S.insertSpaces=E):this.h!==E&&(this.h=E,D=!0,S.insertSpaces=E)}typeof p.cursorStyle<"u"&&this.j!==p.cursorStyle&&(this.j=p.cursorStyle,D=!0,S.cursorStyle=p.cursorStyle),typeof p.lineNumbers<"u"&&this.k!==p.lineNumbers&&(this.k=p.lineNumbers,D=!0,S.lineNumbers=L.TextEditorLineNumbersStyle.from(p.lineNumbers)),D&&this.u("setOptions",this.c.$trySetOptions(this.d,S))}u(p,S){S.catch(D=>{this.e.warn(`ExtHostTextEditorOptions '${p}' failed:'`),this.e.warn(D)})}}e.$zM=$;class R{constructor(p,S,D,E,h,u,d,c){this.id=p,this.j=S,this.k=D,this.g=!1,this.h=new Set,this.c=h,this.d=new $(this.j,this.id,u,D),this.e=d,this.f=c;const f=this;this.value=Object.freeze({get document(){return E.value},set document(a){throw new M.$9("document")},get selection(){return f.c&&f.c[0]},set selection(a){if(!(a instanceof A.$vK))throw(0,M.$7)("selection");f.c=[a],f.l()},get selections(){return f.c},set selections(a){if(!Array.isArray(a)||a.some(t=>!(t instanceof A.$vK)))throw(0,M.$7)("selections");f.c=a,f.l()},get visibleRanges(){return f.e},set visibleRanges(a){throw new M.$9("visibleRanges")},get options(){return f.d.value},set options(a){f.g||f.d.assign(a)},get viewColumn(){return f.f},set viewColumn(a){throw new M.$9("viewColumn")},edit(a,t={undoStopBefore:!0,undoStopAfter:!0}){if(f.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const i=new k(E.value,t);return a(i),f.m(i)},insertSnippet(a,t,i={undoStopBefore:!0,undoStopAfter:!0}){if(f.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let s;if(!t||Array.isArray(t)&&t.length===0)s=f.c.map(n=>L.Range.from(n));else if(t instanceof A.$tK){const{lineNumber:n,column:r}=L.Position.from(t);s=[{startLineNumber:n,startColumn:r,endLineNumber:n,endColumn:r}]}else if(t instanceof A.$uK)s=[L.Range.from(t)];else{s=[];for(const n of t)if(n instanceof A.$uK)s.push(L.Range.from(n));else{const{lineNumber:r,column:o}=L.Position.from(n);s.push({startLineNumber:r,startColumn:o,endLineNumber:r,endColumn:o})}}return S.$tryInsertSnippet(p,E.value.version,a.value,s,i)},setDecorations(a,t){const i=t.length===0;i&&!f.h.has(a.key)||(i?f.h.delete(a.key):f.h.add(a.key),f.n(()=>{if(L.$oM(t))return S.$trySetDecorations(p,a.key,L.$pM(t));{const s=new Array(4*t.length);for(let n=0,r=t.length;n<r;n++){const o=t[n];s[4*n]=o.start.line+1,s[4*n+1]=o.start.character+1,s[4*n+2]=o.end.line+1,s[4*n+3]=o.end.character+1}return S.$trySetDecorationsFast(p,a.key,s)}}))},revealRange(a,t){f.n(()=>S.$tryRevealRange(p,L.Range.from(a),t||A.TextEditorRevealType.Default))},show(a){S.$tryShowEditor(p,L.ViewColumn.from(a))},hide(){S.$tryHideEditor(p)}})}dispose(){(0,y.ok)(!this.g),this.g=!0}_acceptOptions(p){(0,y.ok)(!this.g),this.d._accept(p)}_acceptVisibleRanges(p){(0,y.ok)(!this.g),this.e=p}_acceptViewColumn(p){(0,y.ok)(!this.g),this.f=p}_acceptSelections(p){(0,y.ok)(!this.g),this.c=p}async l(){const p=this.c.map(L.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,p)),this.value}m(p){const S=p.finalize();if(S.edits.length===0&&!S.setEndOfLine)return Promise.resolve(!0);const D=S.edits.map(h=>h.range);D.sort((h,u)=>h.end.line===u.end.line?h.end.character===u.end.character?h.start.line===u.start.line?h.start.character-u.start.character:h.start.line-u.start.line:h.end.character-u.end.character:h.end.line-u.end.line);for(let h=0,u=D.length-1;h<u;h++){const d=D[h].end;if(D[h+1].start.isBefore(d))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const E=S.edits.map(h=>({range:L.Range.from(h.range),text:h.text,forceMoveMarkers:h.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,S.documentVersionId,E,{setEndOfLine:typeof S.setEndOfLine=="number"?L.EndOfLine.from(S.setEndOfLine):void 0,undoStopBefore:S.undoStopBefore,undoStopAfter:S.undoStopAfter})}n(p){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):p().then(()=>this,S=>(S instanceof Error&&S.name==="DISPOSED"||this.k.warn(S),null))}}e.$AM=R}),define(De[288],Ce([1,0,213,23,2,4,3,269,8,7,17,19,13,80,21,179,26]),function(re,e,y,M,l,L,A,g,k,$,R,P,p,S,D,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Edc=void 0;function u(f,a){if((0,R.$zf)(f))return{label:f};if(f&&typeof f=="object"&&typeof f.label=="string"){let t;return Array.isArray(f.highlights)&&(t=f.highlights.filter(i=>i.length===2&&typeof i[0]=="number"&&typeof i[1]=="number"),t=t.length?t:void 0),{label:f.label,highlights:t}}}class d extends A.$Sc{constructor(a,t,i){super(),this.f=a,this.g=t,this.h=i,this.a=new Map,this.b=new E.$57;function s(n){return n&&n.$treeViewId&&(n.$treeItemHandle||n.$selectedTreeItems||n.$focusedTreeItem)}t.registerArgumentProcessor({processArgument:n=>s(n)?this.r(n):Array.isArray(n)&&n.length>0?n.map(r=>s(r)?this.r(r):r):n})}registerTreeDataProvider(a,t,i){const s=this.createTreeView(a,{treeDataProvider:t},i);return{dispose:()=>s.dispose()}}createTreeView(a,t,i){if(!t||!t.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const s=t.dragAndDropController?.dropMimeTypes??[],n=t.dragAndDropController?.dragMimeTypes??[],r=!!t.dragAndDropController?.handleDrag,o=!!t.dragAndDropController?.handleDrop,v=this.m(a,t,i),C={showCollapseAll:!!t.showCollapseAll,canSelectMany:!!t.canSelectMany,dropMimeTypes:s,dragMimeTypes:n,hasHandleDrag:r,hasHandleDrop:o,manuallyManageCheckboxes:!!t.manageCheckboxStateManually},w=this.f.$registerTreeViewDataProvider(a,C),m={get onDidCollapseElement(){return v.onDidCollapseElement},get onDidExpandElement(){return v.onDidExpandElement},get selection(){return v.selectedElements},get onDidChangeSelection(){return v.onDidChangeSelection},get activeItem(){return(0,h.$mF)(i,"treeViewActiveItem"),v.focusedElement},get onDidChangeActiveItem(){return(0,h.$mF)(i,"treeViewActiveItem"),v.onDidChangeActiveItem},get visible(){return v.visible},get onDidChangeVisibility(){return v.onDidChangeVisibility},get onDidChangeCheckboxState(){return v.onDidChangeCheckboxState},get message(){return v.message},set message(b){(0,S.$6j)(b)&&(0,h.$mF)(i,"treeViewMarkdownMessage"),v.message=b},get title(){return v.title},set title(b){v.title=b},get description(){return v.description},set description(b){v.description=b},get badge(){return v.badge},set badge(b){b!==void 0&&$.ViewBadge.isViewBadge(b)?v.badge={value:Math.floor(Math.abs(b.value)),tooltip:b.tooltip}:b===void 0&&(v.badge=void 0)},reveal:(b,I)=>v.reveal(b,I),dispose:async()=>{await w,this.a.delete(a),v.dispose()}};return this.B(m),m}$getChildren(a,t){const i=this.a.get(a);return i?i.getChildren(t):Promise.reject(new g.$xE(a))}async $handleDrop(a,t,i,s,n,r,o,v){const C=this.a.get(a);if(!C)return Promise.reject(new g.$xE(a));const w=p.DataTransfer.toDataTransfer(i,async m=>(await this.f.$resolveDropFileData(a,t,m)).buffer);return o===a&&v&&await this.j(w,C,v,n,r),C.onDrop(w,s,n)}async j(a,t,i,s,n){const r=this.b.removeDragOperationTransfer(n);if(r)(await r)?.forEach((o,v)=>{o&&a.set(v,o)});else if(n&&t.handleDrag){const o=t.handleDrag(i,a,s);this.b.addDragOperationTransfer(n,o),await o}return a}async $handleDrag(a,t,i,s){const n=this.a.get(a);if(!n)return Promise.reject(new g.$xE(a));const r=await this.j(new $.$jL,n,t,s,i);if(!(!r||s.isCancellationRequested))return p.DataTransfer.from(r)}async $hasResolve(a){const t=this.a.get(a);if(!t)throw new g.$xE(a);return t.hasResolve}$resolve(a,t,i){const s=this.a.get(a);if(!s)throw new g.$xE(a);return s.resolveTreeItem(t,i)}$setExpanded(a,t,i){const s=this.a.get(a);if(!s)throw new g.$xE(a);s.setExpanded(t,i)}$setSelectionAndFocus(a,t,i){const s=this.a.get(a);if(!s)throw new g.$xE(a);s.setSelectionAndFocus(t,i)}$setVisible(a,t){const i=this.a.get(a);if(!i){if(!t)return;throw new g.$xE(a)}i.setVisible(t)}$changeCheckboxState(a,t){const i=this.a.get(a);if(!i)throw new g.$xE(a);i.setCheckboxState(t)}m(a,t,i){const s=this.B(new c(a,t,this.f,this.g.converter,this.h,i));return this.a.set(a,s),s}r(a){const t=this.a.get(a.$treeViewId);return t&&"$treeItemHandle"in a?t.getExtensionElement(a.$treeItemHandle):t&&"$focusedTreeItem"in a&&a.$focusedTreeItem?t.focusedElement:null}}e.$Edc=d;class c extends A.$Sc{get visible(){return this.r}get selectedElements(){return this.s.map(a=>this.getExtensionElement(a)).filter(a=>!(0,R.$If)(a))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(a,t,i,s,n,r){if(super(),this.I=a,this.J=i,this.L=s,this.M=n,this.N=r,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new L.$Od),this.onDidExpandElement=this.u.event,this.w=this.B(new L.$Od),this.onDidCollapseElement=this.w.event,this.y=this.B(new L.$Od),this.onDidChangeSelection=this.y.event,this.z=this.B(new L.$Od),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new L.$Od),this.onDidChangeVisibility=this.C.event,this.D=this.B(new L.$Od),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new L.$Od),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new D.$Yd,r.contributes&&r.contributes.views)for(const w in r.contributes.views)for(const m of r.contributes.views[w])m.id===a&&(this.P=m.name);this.f=t.treeDataProvider,this.g=t.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(w=>this.F.fire({message:!1,element:w})));let o,v;const C=L.Event.debounce(this.F.event,(w,m)=>(w||(w={message:!1,elements:[]}),m.element!==!1&&(o||(o=new Promise(b=>v=b),this.G=this.G.then(()=>o)),Array.isArray(m.element)?w.elements.push(...m.element):w.elements.push(m.element)),m.message&&(w.message=!0),w),200,!0);this.B(C(({message:w,elements:m})=>{m.length&&(this.H=this.H.then(()=>{const b=v;return o=null,this.$(m).then(()=>b())})),w&&this.J.$setMessage(this.I,p.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(a){const t=a?this.getExtensionElement(a):void 0;if(a&&!t)return this.M.error(`No tree item with id '${a}' found.`),Promise.resolve([]);let i=this.X(a);return i||(i=await this.Y(t)),i?i.map(s=>s.item):void 0}getExtensionElement(a){return this.j.get(a)}reveal(a,t){t=t||{select:!0,focus:!1};const i=(0,R.$If)(t.select)?!0:t.select,s=(0,R.$If)(t.focus)?!1:t.focus,n=(0,R.$If)(t.expand)?!1:t.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):a?this.G.then(()=>this.S(a)).then(r=>this.W(a,r[r.length-1]).then(o=>this.J.$reveal(this.I,{item:o.item,parentChain:r.map(v=>v.item)},{select:i,focus:s,expand:n})),r=>this.M.error(r)):this.J.$reveal(this.I,void 0,{select:i,focus:s,expand:n})}get message(){return this.O}set message(a){this.O=a,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(a){this.P=a,this.J.$setTitle(this.I,a,this.Q)}get description(){return this.Q}set description(a){this.Q=a,this.J.$setTitle(this.I,this.P,a)}get badge(){return this.R}set badge(a){this.R?.value===a?.value&&this.R?.tooltip===a?.tooltip||(this.R=p.ViewBadge.from(a),this.J.$setBadge(this.I,a))}setExpanded(a,t){const i=this.getExtensionElement(a);i&&(t?this.u.fire(Object.freeze({element:i})):this.w.fire(Object.freeze({element:i})))}setSelectionAndFocus(a,t){const i=!(0,P.$ub)(this.s,a);this.s=a;const s=this.t!==t;this.t=t,i&&this.y.fire(Object.freeze({selection:this.selectedElements})),s&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(a){a!==this.r&&(this.r=a,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(a){const t=(await Promise.all(a.map(async i=>{const s=this.getExtensionElement(i.treeItemHandle);return s?{extensionItem:s,treeItem:await this.f.getTreeItem(s),newState:i.newState?$.TreeItemCheckboxState.Checked:$.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(i=>i!==void 0);t.forEach(i=>{i.treeItem.checkboxState=i.newState?$.TreeItemCheckboxState.Checked:$.TreeItemCheckboxState.Unchecked}),this.D.fire({items:t.map(i=>[i.extensionItem,i.newState])})}async handleDrag(a,t,i){const s=[];for(const n of a){const r=this.getExtensionElement(n);r&&s.push(r)}if(!(!this.g?.handleDrag||s.length===0))return await this.g.handleDrag(s,t,i),t}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(a,t,i){const s=t?this.getExtensionElement(t):void 0;if(!(!s&&t||!this.g?.handleDrop))return(0,k.$Ng)(()=>this.g?.handleDrop?this.g.handleDrop(s,a,i):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(a,t){if(!this.f.resolveTreeItem)return;const i=this.j.get(a);if(i){const s=this.m.get(i);if(s){const n=await this.f.resolveTreeItem(s.extensionItem,i,t)??s.extensionItem;return this.hb(n),s.item.tooltip=this.eb(n.tooltip),s.item.command=this.fb(s.disposableStore,n.command),s.item}}}S(a){return this.U(a).then(t=>t?this.S(t).then(i=>this.W(t,i[i.length-1]).then(s=>(i.push(s),i))):Promise.resolve([]))}U(a){const t=this.m.get(a);return t?Promise.resolve(t.parent?this.j.get(t.parent.item.handle):void 0):(0,k.$Ng)(()=>this.f.getParent(a))}W(a,t){const i=this.m.get(a);return i?Promise.resolve(i):(0,k.$Ng)(()=>this.f.getTreeItem(a)).then(s=>this.kb(a,s,t,!0)).then(s=>this.getChildren(t?t.item.handle:void 0).then(()=>{const n=this.getExtensionElement(s);if(n){const r=this.m.get(n);if(r)return Promise.resolve(r)}throw new Error(`Cannot resolve tree item for element ${s} from extension ${this.N.identifier.value}`)}))}X(a){if(a){let t;if(typeof a=="string"){const i=this.getExtensionElement(a);t=i?this.m.get(i):void 0}else t=a;return t&&t.children||void 0}return this.h}async Y(a){this.rb(a);const t=new D.$Yd(this.Z.token);try{const i=a?this.m.get(a):void 0,s=await this.f.getChildren(a);if(t.token.isCancellationRequested)return;const n=await Promise.all((0,P.$Hb)(s||[]).map(async r=>{const o=await this.f.getTreeItem(r);return o&&!t.token.isCancellationRequested?this.db(r,o,i):null}));return t.token.isCancellationRequested?void 0:(0,P.$Hb)(n)}finally{t.dispose()}}$(a){if(a.some(i=>!i))return this.Z.dispose(!0),this.Z=new D.$Yd,this.tb(),this.J.$refresh(this.I);{const i=this.ab(a);if(i.length)return this.bb(i)}return Promise.resolve(void 0)}ab(a){const t=new Set,i=a.map(n=>this.m.get(n));for(const n of i)if(n&&!t.has(n.item.handle)){let r=n;for(;r&&r.parent&&i.findIndex(o=>r&&r.parent&&o&&o.item.handle===r.parent.item.handle)===-1;){const o=this.j.get(r.parent.item.handle);r=o?this.m.get(o):void 0}r&&!r.parent&&t.add(n.item.handle)}const s=[];return t.forEach(n=>{const r=this.j.get(n);if(r){const o=this.m.get(r);o&&(!o.parent||!t.has(o.parent.item.handle))&&s.push(n)}}),s}bb(a){const t={};return Promise.all(a.map(i=>this.cb(i).then(s=>{s&&(t[i]=s.item)}))).then(()=>Object.keys(t).length?this.J.$refresh(this.I,t):void 0)}cb(a){const t=this.getExtensionElement(a);if(t){const i=this.m.get(t);if(i)return this.rb(t),(0,k.$Ng)(()=>this.f.getTreeItem(t)).then(s=>{if(s){const n=this.ib(t,s,i.parent);return this.pb(t,n,i,i.parent),i.dispose(),n}return null})}return Promise.resolve(null)}db(a,t,i){const s=this.ib(a,t,i);if(t.id&&this.j.has(s.item.handle))throw new Error((0,y.localize)(0,null,t.id));return this.ob(a,s),this.qb(s,i),s}eb(a){return $.$SK.isMarkdownString(a)?p.MarkdownString.from(a):a}fb(a,t){return t?{...this.L.toInternal(t,a),originalId:t.command}:void 0}gb(a){if(a.checkboxState===void 0)return;let t,i,s;return typeof a.checkboxState=="number"?t=a.checkboxState:(t=a.checkboxState.state,i=a.checkboxState.tooltip,s=a.checkboxState.accessibilityInformation),{isChecked:t===$.TreeItemCheckboxState.Checked,tooltip:i,accessibilityInformation:s}}hb(a){if(!$.$eL.isTreeItem(a,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(a,t,i){this.hb(t);const s=this.B(new A.$Rc),n=this.kb(a,t,i),r=this.lb(t);return{item:{handle:n,parentHandle:i?i.item.handle:void 0,label:u(t.label,this.N),description:t.description,resourceUri:t.resourceUri,tooltip:this.eb(t.tooltip),command:this.fb(s,t.command),contextValue:t.contextValue,icon:r,iconDark:this.mb(t)||r,themeIcon:this.jb(t),collapsibleState:(0,R.$If)(t.collapsibleState)?$.TreeItemCollapsibleState.None:t.collapsibleState,accessibilityInformation:t.accessibilityInformation,checkbox:this.gb(t)},extensionItem:t,parent:i,children:void 0,disposableStore:s,dispose(){s.dispose()}}}jb(a){return a.iconPath instanceof $.$mL?a.iconPath:void 0}kb(a,{id:t,label:i,resourceUri:s},n,r){if(t)return`${c.b}/${t}`;const o=u(i,this.N),v=n?n.item.handle:c.a;let C=o?o.label:s?(0,M.$tg)(s):"";C=C.indexOf("/")!==-1?C.replace("/","//"):C;const w=this.m.has(a)?this.m.get(a).item.handle:void 0,m=this.X(n)||[];let b,I=0;do{if(b=`${v}/${I}:${C}`,r||!this.j.has(b)||w===b)break;I++}while(I<=m.length);return b}lb(a){if(a.iconPath&&!(a.iconPath instanceof $.$mL))return typeof a.iconPath=="string"||l.URI.isUri(a.iconPath)?this.nb(a.iconPath):this.nb(a.iconPath.light)}mb(a){if(a.iconPath&&!(a.iconPath instanceof $.$mL)&&a.iconPath.dark)return this.nb(a.iconPath.dark)}nb(a){return l.URI.isUri(a)?a:l.URI.file(a)}ob(a,t){this.j.set(t.item.handle,a),this.m.set(a,t)}pb(a,t,i,s){this.j.delete(t.item.handle),this.m.delete(a),t.item.handle!==i.item.handle&&this.j.delete(i.item.handle),this.ob(a,t);const n=this.X(s)||[],r=n.filter(o=>o.item.handle===i.item.handle)[0];r&&n.splice(n.indexOf(r),1,t)}qb(a,t){t?(t.children||(t.children=[]),t.children.push(a)):(this.h||(this.h=[]),this.h.push(a))}rb(a){if(a){const t=this.m.get(a);if(t){if(t.children)for(const i of t.children){const s=this.j.get(i.item.handle);s&&this.sb(s)}t.children=void 0}}else this.tb()}sb(a){const t=this.m.get(a);if(t){if(t.children)for(const i of t.children){const s=this.j.get(i.item.handle);s&&this.sb(s)}this.m.delete(a),this.j.delete(t.item.handle),t.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(a=>a.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}c.a="0",c.b="1"}),define(De[289],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chat:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chat.d.ts",chatAgents:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents.d.ts",chatAgents2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents2.d.ts",chatAgents2Additions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents2Additions.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatRequestAccess:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatRequestAccess.d.ts",chatVariables:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariables.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",defaultChatAgent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatAgent.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",dropMetadata:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dropMetadata.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",handleIssueUri:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.handleIssueUri.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveUserActions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveUserActions.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",readonlyMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.readonlyMessage.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",saveEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.saveEditor.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmInputBoxActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmInputBoxActionButton.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(De[290],Ce([1,0,225,9,39,133,105,43,25,289,136,138]),function(re,e,y,M,l,L,A,g,k,$,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fF=e.$eF=e.$dF=e.$cF=e.$bF=e.$aF=void 0;const p=g.$ln.as(A.$mn.JSONContribution);class S{constructor(a,t,i){this.a=a,this.b=t,this.c=i}d(a,t){this.a({type:a,message:t,extensionId:this.b.identifier,extensionPointId:this.c})}error(a){this.d(l.default.Error,a)}warn(a){this.d(l.default.Warning,a)}info(a){this.d(l.default.Info,a)}}e.$aF=S;class D{static a(a){const t=new k.$9l;for(let i=0,s=a.length;i<s;i++)t.add(a[i].description.identifier);return t}static compute(a,t){if(!a||!a.length)return new D(t,[]);if(!t||!t.length)return new D([],a);const i=this.a(a),s=this.a(t),n=t.filter(o=>!i.has(o.description.identifier)),r=a.filter(o=>!s.has(o.description.identifier));return new D(n,r)}constructor(a,t){this.added=a,this.removed=t}}e.$bF=D;class E{constructor(a,t){this.name=a,this.defaultExtensionKind=t,this.a=null,this.b=null,this.c=null}setHandler(a){if(this.a!==null)throw new Error("Handler already set!");this.a=a,this.d()}acceptUsers(a){this.c=D.compute(this.b,a),this.b=a,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(a){(0,M.$1)(a)}}}e.$cF=E;const h={type:"string",enum:["ui","workspace"],enumDescriptions:[y.localize(0,null),y.localize(1,null)]},u="vscode://schemas/vscode-extensions";e.$dF={properties:{engines:{type:"object",description:y.localize(2,null),properties:{vscode:{type:"string",description:y.localize(3,null),default:"^1.22.0"}}},publisher:{description:y.localize(4,null),type:"string"},displayName:{description:y.localize(5,null),type:"string"},categories:{description:y.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:k.$7l},{type:"string",const:"Languages",deprecationMessage:y.localize(7,null)}]}},galleryBanner:{type:"object",description:y.localize(8,null),properties:{color:{description:y.localize(9,null),type:"string"},theme:{description:y.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:y.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:y.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:y.localize(13,null)},enabledApiProposals:{markdownDescription:y.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys($.allApiProposals),markdownEnumDescriptions:Object.values($.allApiProposals)}},api:{markdownDescription:y.localize(15,null),type:"string",enum:["none"],enumDescriptions:[y.localize(16,null)]},activationEvents:{description:y.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:y.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:y.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:y.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:y.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:y.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:y.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:y.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:y.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:y.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:y.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:y.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:y.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:y.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:y.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:y.localize(32,null)},{label:"onUri",body:"onUri",description:y.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:y.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:y.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:y.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:y.localize(37,null)},{label:"onRenderer",description:y.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:y.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:y.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:y.localize(41,null)},{label:"*",description:y.localize(42,null),body:"*"}]}},badges:{type:"array",description:y.localize(43,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:y.localize(44,null)},href:{type:"string",description:y.localize(45,null)},description:{type:"string",description:y.localize(46,null)}}}},markdown:{type:"string",description:y.localize(47,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:y.localize(48,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:y.localize(49,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:L.$3n}},extensionPack:{description:y.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:L.$3n}},extensionKind:{description:y.localize(51,null),type:"array",items:h,default:["workspace"],defaultSnippets:[{body:["ui"],description:y.localize(52,null)},{body:["workspace"],description:y.localize(53,null)},{body:["ui","workspace"],description:y.localize(54,null)},{body:["workspace","ui"],description:y.localize(55,null)},{body:[],description:y.localize(56,null)}]},capabilities:{description:y.localize(57,null),type:"object",properties:{virtualWorkspaces:{description:y.localize(58,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:y.localize(59,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[y.localize(60,null),y.localize(61,null),y.localize(62,null)]},description:{type:"string",markdownDescription:y.localize(63,null)}}},untrustedWorkspaces:{description:y.localize(64,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:y.localize(65,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[y.localize(66,null),y.localize(67,null),y.localize(68,null)]},restrictedConfigurations:{description:y.localize(69,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:y.localize(70,null)}}}}},sponsor:{description:y.localize(71,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:y.localize(72,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:y.localize(73,null),type:"string"},"vscode:uninstall":{description:y.localize(74,null),type:"string"}}},icon:{type:"string",description:y.localize(75,null)},l10n:{type:"string",description:y.localize(76,null)},pricing:{type:"string",markdownDescription:y.localize(77,null),enum:["Free","Trial"],default:"Free"}}};class d{constructor(){this.a=new Map}registerExtensionPoint(a){if(this.a.has(a.extensionPoint))throw new Error("Duplicate extension point: "+a.extensionPoint);const t=new E(a.extensionPoint,a.defaultExtensionKind);return this.a.set(a.extensionPoint,t),a.activationEventsGenerator&&P.$4E.register(a.extensionPoint,a.activationEventsGenerator),e.$dF.properties.contributes.properties[a.extensionPoint]=a.jsonSchema,p.registerSchema(u,e.$dF),t}getExtensionPoints(){return Array.from(this.a.values())}}e.$eF=d;const c={ExtensionsRegistry:"ExtensionsRegistry"};g.$ln.add(c.ExtensionsRegistry,new d),e.$fF=g.$ln.as(c.ExtensionsRegistry),p.registerSchema(u,e.$dF),p.registerSchema(R.$rj,{properties:{extensionEnabledApiProposals:{description:y.localize(78,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys($.allApiProposals),markdownEnumDescriptions:Object.values($.allApiProposals)}}]}}}})}),define(De[291],Ce([1,0,222,17,24,290,42,4]),function(re,e,y,M,l,L,A,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WF=void 0;const k={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:y.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:y.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:y.localize(2,null),default:""}}};var $;(function(p){function S(D,E,h){if(!D)return;const u=M.$zf(D.type)?D.type:void 0;if(!u||u.length===0){h.error(y.localize(3,null));return}const d=[];if(Array.isArray(D.required))for(const c of D.required)M.$zf(c)&&d.push(c);return{extensionId:E.value,taskType:u,required:d,properties:D.properties?l.$9m(D.properties):{},when:D.when?A.$Oi.deserialize(D.when):void 0}}p.from=S})($||($={}));const R=L.$fF.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(p,S)=>{for(const D of p)D.type&&S.push(`onTaskType:${D.type}`)},jsonSchema:{description:y.localize(4,null),type:"array",items:k}});class P{constructor(){this.d=new g.$Od,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((S,D)=>{R.setHandler((E,h)=>{this.c=void 0;try{for(const u of h.removed){const d=u.value;for(const c of d)this.a&&c.type&&this.a[c.type]&&delete this.a[c.type]}for(const u of h.added){const d=u.value;for(const c of d){const f=$.from(c,u.description.identifier,u.collector);f&&(this.a[f.taskType]=f)}}(h.removed.length>0||h.added.length>0)&&this.d.fire()}catch{}S(void 0)})})}onReady(){return this.b}get(S){return this.a[S]}all(){return Object.keys(this.a).map(S=>this.a[S])}getJsonSchema(){if(this.c===void 0){const S=[];for(const D of this.all()){const E={type:"object",additionalProperties:!1};D.required.length>0&&(E.required=D.required.slice(0)),D.properties!==void 0?E.properties=l.$9m(D.properties):E.properties=Object.create(null),E.properties.type={type:"string",enum:[D.taskType]},S.push(E)}this.c={oneOf:S}}return this.c}}e.$WF=new P}),define(De[292],Ce([1,0,223,17,23,24,42,291]),function(re,e,y,M,l,L,A,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$7F=e.JsonSchemaVersion=e.ExecutionEngine=e.$6F=e.$5F=e.$4F=e.$3F=e.$2F=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$1F=e.ShellQuoting=e.$ZF=e.$YF=e.$XF=void 0,e.$XF="settings",e.$YF=new A.$8i("taskRunning",!1,y.localize(0,null)),e.$ZF={value:y.localize(1,null),original:"Tasks"};var k;(function(N){N[N.Escape=1]="Escape",N[N.Strong=2]="Strong",N[N.Weak=3]="Weak"})(k||(e.ShellQuoting=k={})),e.$1F="$customized",function(N){function j(U){if(!U)return N.Strong;switch(U.toLowerCase()){case"escape":return N.Escape;case"strong":return N.Strong;case"weak":return N.Weak;default:return N.Strong}}N.from=j}(k||(e.ShellQuoting=k={}));var $;(function(N){N.defaults={cwd:"${workspaceFolder}"}})($||(e.CommandOptions=$={}));var R;(function(N){N[N.Always=1]="Always",N[N.Silent=2]="Silent",N[N.Never=3]="Never"})(R||(e.RevealKind=R={})),function(N){function j(U){switch(U.toLowerCase()){case"always":return N.Always;case"silent":return N.Silent;case"never":return N.Never;default:return N.Always}}N.fromString=j}(R||(e.RevealKind=R={}));var P;(function(N){N[N.Never=1]="Never",N[N.OnProblem=2]="OnProblem",N[N.Always=3]="Always"})(P||(e.RevealProblemKind=P={})),function(N){function j(U){switch(U.toLowerCase()){case"always":return N.Always;case"never":return N.Never;case"onproblem":return N.OnProblem;default:return N.OnProblem}}N.fromString=j}(P||(e.RevealProblemKind=P={}));var p;(function(N){N[N.Shared=1]="Shared",N[N.Dedicated=2]="Dedicated",N[N.New=3]="New"})(p||(e.PanelKind=p={})),function(N){function j(U){switch(U.toLowerCase()){case"shared":return N.Shared;case"dedicated":return N.Dedicated;case"new":return N.New;default:return N.Shared}}N.fromString=j}(p||(e.PanelKind=p={}));var S;(function(N){N.defaults={echo:!0,reveal:R.Always,revealProblems:P.Never,focus:!1,panel:p.Shared,showReuseMessage:!0,clear:!1}})(S||(e.PresentationOptions=S={}));var D;(function(N){N[N.Shell=1]="Shell",N[N.Process=2]="Process",N[N.CustomExecution=3]="CustomExecution"})(D||(e.RuntimeType=D={})),function(N){function j(B){switch(B.toLowerCase()){case"shell":return N.Shell;case"process":return N.Process;case"customExecution":return N.CustomExecution;default:return N.Process}}N.fromString=j;function U(B){switch(B){case N.Shell:return"shell";case N.Process:return"process";case N.CustomExecution:return"customExecution";default:return"process"}}N.toString=U}(D||(e.RuntimeType=D={}));var E;(function(N){function j(U){return M.$zf(U)?U:U.value}N.value=j})(E||(e.CommandString=E={}));var h;(function(N){N.Clean={_id:"clean",isDefault:!1},N.Build={_id:"build",isDefault:!1},N.Rebuild={_id:"rebuild",isDefault:!1},N.Test={_id:"test",isDefault:!1};function j(B){return B===N.Clean._id||B===N.Build._id||B===N.Rebuild._id||B===N.Test._id}N.is=j;function U(B){if(B!==void 0)return M.$zf(B)?j(B)?{_id:B,isDefault:!1}:void 0:B}N.from=U})(h||(e.TaskGroup=h={}));var u;(function(N){N[N.Global=1]="Global",N[N.Workspace=2]="Workspace",N[N.Folder=3]="Folder"})(u||(e.TaskScope=u={}));var d;(function(N){N.Workspace="workspace",N.Extension="extension",N.InMemory="inMemory",N.WorkspaceFile="workspaceFile",N.User="user";function j(U){switch(U){case N.User:return 2;case N.WorkspaceFile:return 5;default:return 6}}N.toConfigurationTarget=j})(d||(e.TaskSourceKind=d={}));var c;(function(N){N.parallel="parallel",N.sequence="sequence"})(c||(e.DependsOrder=c={}));var f;(function(N){N[N.default=1]="default",N[N.folderOpen=2]="folderOpen"})(f||(e.RunOnOptions=f={}));var a;(function(N){N.defaults={reevaluateOnRerun:!0,runOn:f.default,instanceLimit:1}})(a||(e.RunOptions=a={}));class t{constructor(j,U,B,he,x,Q){this._label="",this._id=j,U&&(this._label=U),B&&(this.type=B),this.runOptions=he,this.configurationProperties=x,this._source=Q}getDefinition(j){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const j={folder:this.d(),id:this._id};return JSON.stringify(j)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(j,U=!1){if(j===void 0)return!1;if(M.$zf(j))return j===this._label||j===this.configurationProperties.identifier||U&&j===this._id;const B=this.getDefinition(!0);return B!==void 0&&B._key===j._key}getQualifiedLabel(){const j=this.getWorkspaceFolder();return j?`${this._label} (${j.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(j){this.c===void 0&&(this.c=[]),j&&(this.c=this.c.concat(j))}get taskLoadMessages(){return this.c}}e.$2F=t;class i extends t{constructor(j,U,B,he,x,Q,Z,ie){super(j,B,void 0,Z,ie,U),this.command={},this._source=U,this.hasDefinedMatchers=Q,x&&(this.command=x)}clone(){return new i(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(j=!1){if(j&&this._source.customizes!==void 0)return this._source.customizes;{let U;switch(this.command?this.command.runtime:void 0){case D.Shell:U="shell";break;case D.Process:U="process";break;case D.CustomExecution:U="customExecution";break;case void 0:U="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:U,_key:this._id,id:this._id}}}static is(j){return j instanceof i}getMapKey(){const j=this._source.config.workspaceFolder;return j?`${j.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===d.User?e.$XF:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const j=this.d();if(!j)return;let U=this.configurationProperties.identifier;this._source.kind!==d.Workspace&&(U+=this._source.kind);const B={type:e.$1F,folder:j,id:U};return JSON.stringify(B)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?l.$tg(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(j){return new i(j._id,j._source,j._label,j.type,j.command,j.hasDefinedMatchers,j.runOptions,j.configurationProperties)}}e.$3F=i;class s extends t{constructor(j,U,B,he,x,Q,Z){super(j,B,he,Q,Z,U),this._source=U,this.configures=x}static is(j){return j instanceof s}f(j){return j}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?l.$tg(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===d.User?e.$XF:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const j=this.d();if(!j)return;let U=this.configurationProperties.identifier;this._source.kind!==d.Workspace&&(U+=this._source.kind);const B={type:e.$1F,folder:j,id:U};return JSON.stringify(B)}}e.$4F=s;class n extends t{constructor(j,U,B,he,x,Q,Z,ie,_){super(j,B,he,ie,_,U),this.defines=x,this.hasDefinedMatchers=Z,this.command=Q,this.icon=_.icon,this.hide=_.hide}clone(){return new n(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(j){return j instanceof n}getMapKey(){const j=this._source.workspaceFolder;return j?`${this._source.scope.toString()}|${j.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const j={type:"contributed",scope:this._source.scope,id:this._id};return j.folder=this.d(),JSON.stringify(j)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(j){return new n(j._id,j._source,j._label,j.type,j.defines,j.command,j.hasDefinedMatchers,j.runOptions,j.configurationProperties)}}e.$5F=n;class r extends t{constructor(j,U,B,he,x,Q){super(j,B,he,x,Q,U),this._source=U}clone(){return new r(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(j){return j instanceof r}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(j){return new r(j._id,j._source,j._label,j.type,j.runOptions,j.configurationProperties)}}e.$6F=r;var o;(function(N){N[N.Process=1]="Process",N[N.Terminal=2]="Terminal"})(o||(e.ExecutionEngine=o={})),function(N){N._default=N.Terminal}(o||(e.ExecutionEngine=o={}));var v;(function(N){N[N.V0_1_0=1]="V0_1_0",N[N.V2_0_0=2]="V2_0_0"})(v||(e.JsonSchemaVersion=v={}));class C{constructor(j){this.c=new Map;for(let U=0;U<j.length;U++)this.c.set(j[U].uri.toString(),U)}compare(j,U){const B=j.getWorkspaceFolder(),he=U.getWorkspaceFolder();if(B&&he){let x=this.c.get(B.uri.toString());x=x===void 0?0:x+1;let Q=this.c.get(he.uri.toString());return Q=Q===void 0?0:Q+1,x===Q?j._label.localeCompare(U._label):x-Q}else return!B&&he?-1:B&&!he?1:0}}e.$7F=C;var w;(function(N){N.DependsOnStarted="dependsOnStarted",N.AcquiredInput="acquiredInput",N.Start="start",N.ProcessStarted="processStarted",N.Active="active",N.Inactive="inactive",N.Changed="changed",N.Terminated="terminated",N.ProcessEnded="processEnded",N.End="end"})(w||(e.TaskEventKind=w={}));var m;(function(N){N.SingleRun="singleRun",N.Background="background"})(m||(e.TaskRunType=m={}));var b;(function(N){N[N.System=0]="System",N[N.User=1]="User",N[N.FolderOpen=2]="FolderOpen",N[N.ConfigurationChange=3]="ConfigurationChange",N[N.Reconnect=4]="Reconnect"})(b||(e.TaskRunSource=b={}));var I;(function(N){function j(ie){return{taskId:ie._id,taskName:ie.configurationProperties.name,runType:ie.configurationProperties.isBackground?"background":"singleRun",group:ie.configurationProperties.group,__task:ie}}function U(ie,_,oe){return{...j(ie),kind:"start",terminalId:_,resolvedVariables:oe}}N.start=U;function B(ie,_,oe){return{...j(ie),kind:"processStarted",terminalId:_,processId:oe}}N.processStarted=B;function he(ie,_,oe){return{...j(ie),kind:"processEnded",terminalId:_,exitCode:oe}}N.processEnded=he;function x(ie,_,oe){return{...j(ie),kind:"terminated",exitReason:oe,terminalId:_}}N.terminated=x;function Q(ie,_,oe){return{...j(_),kind:ie,terminalId:oe}}N.general=Q;function Z(){return{kind:"changed"}}N.changed=Z})(I||(e.TaskEvent=I={}));var z;(function(N){function j(B){const he=Object.keys(B).sort();let x="";for(const Q of he){let Z=B[Q];Z instanceof Object?Z=j(Z):typeof Z=="string"&&(Z=Z.replace(/,/g,",,")),x+=Q+","+Z+","}return x}function U(B){const x={_key:j(B),type:B.taskType};return Object.assign(x,B),x}N.create=U})(z||(e.KeyedTaskIdentifier=z={}));var O;(function(N){N.AutoDetect="task.autoDetect",N.SaveBeforeRun="task.saveBeforeRun",N.ShowDecorations="task.showDecorations",N.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",N.SlowProviderWarning="task.slowProviderWarning",N.QuickOpenHistory="task.quickOpen.history",N.QuickOpenDetail="task.quickOpen.detail",N.QuickOpenSkip="task.quickOpen.skip",N.QuickOpenShowAll="task.quickOpen.showAll",N.AllowAutomaticTasks="task.allowAutomaticTasks",N.Reconnection="task.reconnection"})(O||(e.TaskSettingId=O={}));var F;(function(N){N.Tasks="tasks",N.SuppressTaskName="tasks.suppressTaskName",N.Windows="tasks.windows",N.Osx="tasks.osx",N.Linux="tasks.linux",N.ShowOutput="tasks.showOutput",N.IsShellCommand="tasks.isShellCommand",N.ServiceTestSetting="tasks.service.testSetting"})(F||(e.TasksSchemaProperties=F={}));var T;(function(N){function j(U,B){const he=g.$WF.get(U.type);if(he===void 0){const ie=L.$9m(U);return delete ie._key,z.create(ie)}const x=Object.create(null);x.type=he.taskType;const Q=new Set;he.required.forEach(ie=>Q.add(ie));const Z=he.properties;for(const ie of Object.keys(Z)){const _=U[ie];if(_!=null)x[ie]=_;else if(Q.has(ie)){const oe=Z[ie];if(oe.default!==void 0)x[ie]=L.$9m(oe.default);else switch(oe.type){case"boolean":x[ie]=!1;break;case"number":case"integer":x[ie]=0;break;case"string":x[ie]="";break;default:B.error(y.localize(2,null,JSON.stringify(U,void 0,0),ie));return}}}return z.create(x)}N.createTaskIdentifier=j})(T||(e.TaskDefinition=T={}))}),define(De[293],Ce([1,0,9]),function(re,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$24b=e.$14b=void 0;class M{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((A,g)=>{this.b=A,this.d=g,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(A){this.f||this.h||(this.f=!0,this.g=A,this.a&&this.b(A))}resolveErr(A){this.f||this.h||(this.h=!0,this.i=A,this.a?this.d(A):(0,y.$1)(A))}then(A,g){return this.j().then(A,g)}catch(A){return this.j().then(void 0,A)}finally(A){return this.j().finally(A)}}e.$14b=M;class l extends M{constructor(){super(),this.h=!0,this.i=new y.$5}}e.$24b=l}),define(De[69],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vv=e.$uv=e.$tv=e.$sv=void 0;class y{constructor(k){this._proxyIdentifierBrand=void 0,this.sid=k,this.nid=++y.count}}e.$sv=y,y.count=0;const M=[];function l(g){const k=new y(g);return M[k.nid]=k,k}e.$tv=l;function L(g){return M[g].sid}e.$uv=L;class A{constructor(k){this.value=k}}e.$vv=A}),define(De[6],Ce([1,0,69]),function(re,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rK=e.$qK=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$pK=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var M;(function(E){E[E.Default=0]="Default",E[E.InCenter=1]="InCenter",E[E.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",E[E.AtTop=3]="AtTop"})(M||(e.TextEditorRevealType=M={}));var l;(function(E){E[E.UnknownInput=0]="UnknownInput",E[E.TextInput=1]="TextInput",E[E.TextDiffInput=2]="TextDiffInput",E[E.TextMergeInput=3]="TextMergeInput",E[E.NotebookInput=4]="NotebookInput",E[E.NotebookDiffInput=5]="NotebookDiffInput",E[E.CustomEditorInput=6]="CustomEditorInput",E[E.WebviewEditorInput=7]="WebviewEditorInput",E[E.TerminalEditorInput=8]="TerminalEditorInput",E[E.InteractiveEditorInput=9]="InteractiveEditorInput"})(l||(e.TabInputKind=l={}));var L;(function(E){E[E.TAB_OPEN=0]="TAB_OPEN",E[E.TAB_CLOSE=1]="TAB_CLOSE",E[E.TAB_UPDATE=2]="TAB_UPDATE",E[E.TAB_MOVE=3]="TAB_MOVE"})(L||(e.TabModelOperationKind=L={}));var A;(function(E){E[E.Editable=0]="Editable",E[E.SupportsHotExit=1]="SupportsHotExit"})(A||(e.WebviewEditorCapabilities=A={}));var g;(function(E){E[E.Int8Array=1]="Int8Array",E[E.Uint8Array=2]="Uint8Array",E[E.Uint8ClampedArray=3]="Uint8ClampedArray",E[E.Int16Array=4]="Int16Array",E[E.Uint16Array=5]="Uint16Array",E[E.Int32Array=6]="Int32Array",E[E.Uint32Array=7]="Uint32Array",E[E.Float32Array=8]="Float32Array",E[E.Float64Array=9]="Float64Array",E[E.BigInt64Array=10]="BigInt64Array",E[E.BigUint64Array=11]="BigUint64Array"})(g||(e.WebviewMessageArrayBufferViewType=g={}));var k;(function(E){E[E.Text=1]="Text",E[E.Error=2]="Error",E[E.Rich=3]="Rich"})(k||(e.CellOutputKind=k={}));var $;(function(E){E[E.Default=0]="Default",E[E.InCenter=1]="InCenter",E[E.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",E[E.AtTop=3]="AtTop"})($||(e.NotebookEditorRevealType=$={}));var R;(function(E){E[E.None=0]="None",E[E.Process=1]="Process",E[E.Output=2]="Output"})(R||(e.CandidatePortSource=R={}));class P{static mixin(h){return h._id=P.a++,h}}e.$pK=P,P.a=0;var p;(function(E){E.label="a",E.kind="b",E.detail="c",E.documentation="d",E.sortText="e",E.filterText="f",E.preselect="g",E.insertText="h",E.insertTextRules="i",E.range="j",E.commitCharacters="k",E.additionalTextEdits="l",E.kindModifier="m",E.commandIdent="n",E.commandId="o",E.commandArguments="p"})(p||(e.ISuggestDataDtoField=p={}));var S;(function(E){E.defaultRanges="a",E.completions="b",E.isIncomplete="c",E.duration="d"})(S||(e.ISuggestResultDtoField=S={}));var D;(function(E){E[E.Workspace=0]="Workspace",E[E.TextDocument=1]="TextDocument"})(D||(e.ExtHostTestingResource=D={})),e.$qK={MainThreadAuthentication:(0,y.$tv)("MainThreadAuthentication"),MainThreadBulkEdits:(0,y.$tv)("MainThreadBulkEdits"),MainThreadChatProvider:(0,y.$tv)("MainThreadChatProvider"),MainThreadChatAgents:(0,y.$tv)("MainThreadChatAgents"),MainThreadChatAgents2:(0,y.$tv)("MainThreadChatAgents2"),MainThreadChatVariables:(0,y.$tv)("MainThreadChatVariables"),MainThreadClipboard:(0,y.$tv)("MainThreadClipboard"),MainThreadCommands:(0,y.$tv)("MainThreadCommands"),MainThreadComments:(0,y.$tv)("MainThreadComments"),MainThreadConfiguration:(0,y.$tv)("MainThreadConfiguration"),MainThreadConsole:(0,y.$tv)("MainThreadConsole"),MainThreadDebugService:(0,y.$tv)("MainThreadDebugService"),MainThreadDecorations:(0,y.$tv)("MainThreadDecorations"),MainThreadDiagnostics:(0,y.$tv)("MainThreadDiagnostics"),MainThreadDialogs:(0,y.$tv)("MainThreadDiaglogs"),MainThreadDocuments:(0,y.$tv)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,y.$tv)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,y.$tv)("MainThreadTextEditors"),MainThreadEditorInsets:(0,y.$tv)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,y.$tv)("MainThreadEditorTabs"),MainThreadErrors:(0,y.$tv)("MainThreadErrors"),MainThreadTreeViews:(0,y.$tv)("MainThreadTreeViews"),MainThreadDownloadService:(0,y.$tv)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,y.$tv)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,y.$tv)("MainThreadLanguages"),MainThreadLogger:(0,y.$tv)("MainThreadLogger"),MainThreadMessageService:(0,y.$tv)("MainThreadMessageService"),MainThreadOutputService:(0,y.$tv)("MainThreadOutputService"),MainThreadProgress:(0,y.$tv)("MainThreadProgress"),MainThreadQuickDiff:(0,y.$tv)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,y.$tv)("MainThreadQuickOpen"),MainThreadStatusBar:(0,y.$tv)("MainThreadStatusBar"),MainThreadSecretState:(0,y.$tv)("MainThreadSecretState"),MainThreadStorage:(0,y.$tv)("MainThreadStorage"),MainThreadSpeech:(0,y.$tv)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,y.$tv)("MainThreadTelemetry"),MainThreadTerminalService:(0,y.$tv)("MainThreadTerminalService"),MainThreadWebviews:(0,y.$tv)("MainThreadWebviews"),MainThreadWebviewPanels:(0,y.$tv)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,y.$tv)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,y.$tv)("MainThreadCustomEditors"),MainThreadUrls:(0,y.$tv)("MainThreadUrls"),MainThreadUriOpeners:(0,y.$tv)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,y.$tv)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,y.$tv)("MainThreadWorkspace"),MainThreadFileSystem:(0,y.$tv)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,y.$tv)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,y.$tv)("MainThreadExtensionService"),MainThreadSCM:(0,y.$tv)("MainThreadSCM"),MainThreadSearch:(0,y.$tv)("MainThreadSearch"),MainThreadShare:(0,y.$tv)("MainThreadShare"),MainThreadTask:(0,y.$tv)("MainThreadTask"),MainThreadWindow:(0,y.$tv)("MainThreadWindow"),MainThreadLabelService:(0,y.$tv)("MainThreadLabelService"),MainThreadNotebook:(0,y.$tv)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,y.$tv)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,y.$tv)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,y.$tv)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,y.$tv)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,y.$tv)("MainThreadInteractive"),MainThreadChat:(0,y.$tv)("MainThreadChat"),MainThreadInlineChat:(0,y.$tv)("MainThreadInlineChatShape"),MainThreadTheming:(0,y.$tv)("MainThreadTheming"),MainThreadTunnelService:(0,y.$tv)("MainThreadTunnelService"),MainThreadManagedSockets:(0,y.$tv)("MainThreadManagedSockets"),MainThreadTimeline:(0,y.$tv)("MainThreadTimeline"),MainThreadTesting:(0,y.$tv)("MainThreadTesting"),MainThreadLocalization:(0,y.$tv)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,y.$tv)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,y.$tv)("MainThreadAiEmbeddingVector"),MainThreadIssueReporter:(0,y.$tv)("MainThreadIssueReporter")},e.$rK={ExtHostCommands:(0,y.$tv)("ExtHostCommands"),ExtHostConfiguration:(0,y.$tv)("ExtHostConfiguration"),ExtHostDiagnostics:(0,y.$tv)("ExtHostDiagnostics"),ExtHostDebugService:(0,y.$tv)("ExtHostDebugService"),ExtHostDecorations:(0,y.$tv)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,y.$tv)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,y.$tv)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,y.$tv)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,y.$tv)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,y.$tv)("ExtHostEditors"),ExtHostTreeViews:(0,y.$tv)("ExtHostTreeViews"),ExtHostFileSystem:(0,y.$tv)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,y.$tv)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,y.$tv)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,y.$tv)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,y.$tv)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,y.$tv)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,y.$tv)("ExtHostQuickDiff"),ExtHostStatusBar:(0,y.$tv)("ExtHostStatusBar"),ExtHostShare:(0,y.$tv)("ExtHostShare"),ExtHostExtensionService:(0,y.$tv)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,y.$tv)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,y.$tv)("ExtHostTerminalService"),ExtHostSCM:(0,y.$tv)("ExtHostSCM"),ExtHostSearch:(0,y.$tv)("ExtHostSearch"),ExtHostTask:(0,y.$tv)("ExtHostTask"),ExtHostWorkspace:(0,y.$tv)("ExtHostWorkspace"),ExtHostWindow:(0,y.$tv)("ExtHostWindow"),ExtHostWebviews:(0,y.$tv)("ExtHostWebviews"),ExtHostWebviewPanels:(0,y.$tv)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,y.$tv)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,y.$tv)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,y.$tv)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,y.$tv)("ExtHostEditorTabs"),ExtHostProgress:(0,y.$tv)("ExtHostProgress"),ExtHostComments:(0,y.$tv)("ExtHostComments"),ExtHostSecretState:(0,y.$tv)("ExtHostSecretState"),ExtHostStorage:(0,y.$tv)("ExtHostStorage"),ExtHostUrls:(0,y.$tv)("ExtHostUrls"),ExtHostUriOpeners:(0,y.$tv)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,y.$tv)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,y.$tv)("ExtHostOutputService"),ExtHosLabelService:(0,y.$tv)("ExtHostLabelService"),ExtHostNotebook:(0,y.$tv)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,y.$tv)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,y.$tv)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,y.$tv)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,y.$tv)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,y.$tv)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,y.$tv)("ExtHostInteractive"),ExtHostInlineChat:(0,y.$tv)("ExtHostInlineChatShape"),ExtHostChat:(0,y.$tv)("ExtHostChat"),ExtHostChatAgents:(0,y.$tv)("ExtHostChatAgents"),ExtHostChatAgents2:(0,y.$tv)("ExtHostChatAgents"),ExtHostChatVariables:(0,y.$tv)("ExtHostChatVariables"),ExtHostChatProvider:(0,y.$tv)("ExtHostChatProvider"),ExtHostSpeech:(0,y.$tv)("ExtHostSpeech"),ExtHostAiRelatedInformation:(0,y.$tv)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,y.$tv)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,y.$tv)("ExtHostTheming"),ExtHostTunnelService:(0,y.$tv)("ExtHostTunnelService"),ExtHostManagedSockets:(0,y.$tv)("ExtHostManagedSockets"),ExtHostAuthentication:(0,y.$tv)("ExtHostAuthentication"),ExtHostTimeline:(0,y.$tv)("ExtHostTimeline"),ExtHostTesting:(0,y.$tv)("ExtHostTesting"),ExtHostTelemetry:(0,y.$tv)("ExtHostTelemetry"),ExtHostLocalization:(0,y.$tv)("ExtHostLocalization"),ExtHostIssueReporter:(0,y.$tv)("ExtHostIssueReporter")}}),define(De[294],Ce([1,0,6,7]),function(re,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gec=void 0;class l{constructor(A){this.a=new Map,this.b=0,this.c=A.getProxy(y.$qK.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(A,g,k){if(this.a.size===0)throw new Error("No related information providers registered");const $=this.a.get(A);if(!$)throw new Error("related information provider not found");return await $.provideRelatedInformation(g,k)??[]}getRelatedInformation(A,g,k){return this.c.$getAiRelatedInformation(g,k)}registerRelatedInformationProvider(A,g,k){const $=this.b;return this.b++,this.a.set($,k),this.c.$registerAiRelatedInformationProvider($,g),new M.$sK(()=>{this.c.$unregisterAiRelatedInformationProvider($),this.a.delete($)})}}e.$Gec=l}),define(De[89],Ce([1,0,5,14,6,20]),function(re,e,y,M,l,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kcc=e.$Jcc=e.$Icc=void 0,e.$Icc=(0,y.$Qh)("IExtHostApiDeprecationService");let A=class{constructor(k,$){this.c=$,this.a=new Set,this.b=k.getProxy(l.$qK.MainThreadTelemetry)}report(k,$,R){const P=this.d(k,$);this.a.has(P)||(this.a.add(P),$.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${k}' is deprecated. ${R}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:$.identifier.value,apiId:k}))}d(k,$){return`${k}-${$.identifier.value}`}};e.$Jcc=A,e.$Jcc=A=He([We(0,L.$rM),We(1,M.$$i)],A),e.$Kcc=Object.freeze(new class{report(g,k,$){}})}),define(De[295],Ce([1,0,4,6,7,25]),function(re,e,y,M,l,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eec=void 0;class A{constructor($){this.b=new Map,this.c=[],this.d=new y.$Od,this.onDidChangeSessions=this.d.event,this.f=new g,this.g=new g,this.a=$.getProxy(M.$qK.MainThreadAuthentication)}$setProviders($){return this.c=$,Promise.resolve()}async getSession($,R,P,p={}){const S=L.$8l.toKey($.identifier),D=[...P].sort().join(" ");return await this.f.getOrCreate(`${S} ${R} ${D}`,async()=>{await this.a.$ensureProvider(R);const E=$.displayName||$.name;return this.a.$getSession(R,P,S,E,p)})}async getSessions($,R,P){const p=L.$8l.toKey($.identifier),S=[...P].sort().join(" ");return await this.g.getOrCreate(`${p} ${S}`,async()=>{await this.a.$ensureProvider(R);const D=$.displayName||$.name;return this.a.$getSessions(R,P,p,D)})}async removeSession($,R){const P=this.b.get($);return P?P.provider.removeSession(R):this.a.$removeSession($,R)}registerAuthenticationProvider($,R,P,p){if(this.b.get($))throw new Error(`An authentication provider with id '${$}' is already registered.`);this.b.set($,{label:R,provider:P,options:p??{supportsMultipleAccounts:!1}}),this.c.find(D=>D.id===$)||this.c.push({id:$,label:R});const S=P.onDidChangeSessions(D=>{this.a.$sendDidChangeSessions($,{added:D.added??[],changed:D.changed??[],removed:D.removed??[]})});return this.a.$registerAuthenticationProvider($,R,p?.supportsMultipleAccounts??!1),new l.$sK(()=>{S.dispose(),this.b.delete($);const D=this.c.findIndex(E=>E.id===$);D>-1&&this.c.splice(D),this.a.$unregisterAuthenticationProvider($)})}$createSession($,R,P){const p=this.b.get($);if(p)return Promise.resolve(p.provider.createSession(R,P));throw new Error(`Unable to find authentication provider with handle: ${$}`)}$removeSession($,R){const P=this.b.get($);if(P)return Promise.resolve(P.provider.removeSession(R));throw new Error(`Unable to find authentication provider with handle: ${$}`)}$getSessions($,R){const P=this.b.get($);if(P)return Promise.resolve(P.provider.getSessions(R));throw new Error(`Unable to find authentication provider with handle: ${$}`)}$onDidChangeAuthenticationSessions($,R){return this.d.fire({provider:{id:$,label:R}}),Promise.resolve()}}e.$eec=A;class g{constructor(){this.a=new Map}getOrCreate($,R){const P=this.a.get($);if(P)return P;const p=R().finally(()=>this.a.delete($));return this.a.set($,p),p}}}),define(De[296],Ce([1,0,6,20,13]),function(re,e,y,M,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kec=void 0;let L=class{constructor(g,k){this.a=g.getProxy(y.$qK.MainThreadBulkEdits),this.b={getTextDocumentVersion:$=>k.getDocument($)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(g,k,$){const R=l.WorkspaceEdit.from(g,this.b);return this.a.$tryApplyWorkspaceEdit(R,void 0,$?.isRefactoring??!1)}};e.$kec=L,e.$kec=L=He([We(0,M.$rM)],L)}),define(De[297],Ce([1,0,8,4,51,3,35,202,6,13]),function(re,e,y,M,l,L,A,g,k,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yec=void 0;class R{constructor(S,D){this.extension=S,this.provider=D,this.handle=R.a++}}R.a=0;class P{constructor(S,D){this.h=D,this.b=new Map,this.d=new Map,this.e=new M.$Od,this.onDidPerformUserAction=this.e.event,this.g=S.getProxy(k.$qK.MainThreadChat)}registerChatProvider(S,D,E){const h=new R(S,E);return this.b.set(h.handle,h),this.g.$registerChatProvider(h.handle,D),(0,L.$Qc)(()=>{this.g.$unregisterChatProvider(h.handle),this.b.delete(h.handle)})}transferChatSession(S,D){const E=l.Iterable.find(this.d.keys(),h=>this.d.get(h)===S)??0;typeof E=="number"&&this.g.$transferChatSession(E,D)}sendInteractiveRequestToProvider(S,D){this.g.$sendRequestToProvider(S,D)}async $prepareChat(S,D,E){const h=this.b.get(S);if(!h)return;const u=await h.provider.prepareSession(D,E);if(!u)return;const d=P.a++;return this.d.set(d,u),{id:d,requesterUsername:u.requester?.name,requesterAvatarIconUri:u.requester?.icon,responderUsername:u.responder?.name,responderAvatarIconUri:u.responder?.icon,inputPlaceholder:u.inputPlaceholder}}async $provideWelcomeMessage(S,D){const E=this.b.get(S);if(!E||!E.provider.provideWelcomeMessage)return;const h=await E.provider.provideWelcomeMessage(D);if(h)return h.map(u=>typeof u=="string"?u:Array.isArray(u)?u.map(d=>$.ChatReplyFollowup.from(d)):$.MarkdownString.from(u))}async $provideFollowups(S,D,E){const h=this.b.get(S);if(!h)return;const u=this.d.get(D);return!u||!h.provider.provideFollowups?void 0:(await h.provider.provideFollowups(u,E))?.map(c=>$.ChatFollowup.from(c))}async $provideSampleQuestions(S,D){const E=this.b.get(S);if(!E||!E.provider.provideSampleQuestions)return;const h=await E.provider.provideSampleQuestions(D);if(h)return h?.map(u=>$.ChatReplyFollowup.from(u))}$removeRequest(S,D,E){const h=this.b.get(S);if(!h)return;const u=this.d.get(D);u&&h.provider.removeRequest&&h.provider.removeRequest(u,E)}async $provideReply(S,D,E,h){const u=this.b.get(S);if(!u)return;const d=this.d.get(D);if(!d)return;const c={session:d,message:E.message,variables:{}};if(E.variables)for(const n of Object.keys(E.variables))c.variables[n]=E.variables[n].map($.ChatVariable.to);const f=A.$Kd.create(!1);let a;const t={report:n=>{if(h.isCancellationRequested)return;typeof a>"u"&&(a=f.elapsed());const r=$.ChatResponseProgress.from(u.extension,n);if("placeholder"in n&&"resolvedContent"in n){const o=Promise.all([this.g.$acceptResponseProgress(S,D,r),n.resolvedContent]);(0,y.$Jg)(o,h).then(v=>{if(!v)return;const[C,w]=v;this.g.$acceptResponseProgress(S,D,w,C??void 0)})}else this.g.$acceptResponseProgress(S,D,r)}};let i;try{i=await u.provider.provideResponseWithProgress(c,t,h),i||(i={errorDetails:{message:(0,g.localize)(0,null)}})}catch(n){i={errorDetails:{message:(0,g.localize)(1,null,n.message),responseIsIncomplete:!0}},this.h.error(n)}try{if(d.saveState&&this.d.has(D)){const n=d.saveState();this.g.$acceptChatState(D,n)}}catch(n){this.h.warn(n)}const s={firstProgress:a??0,totalElapsed:f.elapsed()};return{errorDetails:i.errorDetails,timings:s}}async $provideSlashCommands(S,D,E){const h=this.b.get(S);if(!h)return;const u=this.d.get(D);return!u||!h.provider.provideSlashCommands?void 0:(await h.provider.provideSlashCommands(u,E))?.map(c=>({...c,kind:$.CompletionItemKind.from(c.kind)}))}$releaseSession(S){this.d.delete(S)}async $onDidPerformUserAction(S){this.e.fire(S)}}e.$yec=P,P.a=0}),define(De[298],Ce([1,0,8,3,64,6,13,7]),function(re,e,y,M,l,L,A,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Iec=void 0;class k{constructor(P,p,S){this.d=p,this.e=S,this.b=new Map,this.c=P.getProxy(L.$qK.MainThreadChatAgents)}registerAgent(P,p,S,D){const E=k.a++;return this.b.set(E,{extension:P,agent:S}),this.c.$registerAgent(E,p,D),(0,M.$Qc)(()=>{this.c.$unregisterAgent(E),this.b.delete(E)})}async $invokeAgent(P,p,S,D,E){const h=this.b.get(P);if(!h){this.e.warn(`[CHAT](${P}) CANNOT invoke agent because the agent is not registered`);return}let u=!1;function d(){if(u)throw new Error("Only valid while executing the command")}const c=new y.$dh;E.onCancellationRequested(()=>c.complete()),setTimeout(()=>c.complete(),10*1e3),this.d.allowListExtensionWhile(h.extension,c.p);const f=h.agent({role:g.ChatMessageRole.User,content:S},{history:D.history.map(A.ChatMessage.to)},new l.$0u(a=>{d(),this.c.$handleProgressChunk(p,{content:$(a.message)?a.message:a.message.value})}),E);try{return await(0,y.$Jg)(Promise.resolve(f).then(a=>{if(a&&"followUp"in a)return{followUp:a?.followUp?.map(i=>A.ChatFollowup.from(i))}}),E)}finally{u=!0,c.complete()}}}e.$Iec=k,k.a=0;function $(R){return!!R&&typeof R=="object"&&"treeData"in R}}),define(De[299],Ce([1,0,8,21,41,4,35,17,2,203,64,6,13,7,270,26]),function(re,e,y,M,l,L,A,g,k,$,R,P,p,S,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jec=void 0;class h{constructor(c,f,a){this.i=f,this.j=a,this.b=new Map,this.g=new Map,this.h=new Map,this.d=c.getProxy(P.$qK.MainThreadChatAgents2)}createChatAgent(c,f,a){const t=h.a++,i=new u(c,f,this.d,t,a);return this.b.set(t,i),this.d.$registerAgent(t,f,{}),i.apiAgent}async $invokeAgent(c,f,a,t,i,s){this.g.delete(f);const n=this.b.get(c);if(!n)throw new Error(`[CHAT](${c}) CANNOT invoke agent because the agent is not registered`);let r=!1;function o(){if(r)throw new Error("Only valid while executing the command")}const v=new y.$dh;s.onCancellationRequested(()=>v.complete()),setTimeout(()=>v.complete(),10*1e3),this.i.allowListExtensionWhile(n.extension.identifier,v.p);const C=t.command?await n.validateSlashCommand(t.command):void 0,w=A.$Kd.create(!1);let m;try{const b=n.invoke({prompt:t.message,variables:p.ChatVariable.objectTo(t.variables),slashCommand:C},{history:i.history.map(p.ChatMessage.to)},new R.$0u(I=>{o(),typeof m>"u"&&"content"in I&&(m=w.elapsed());const z=p.ChatResponseProgress.from(n.extension,I);if("placeholder"in I&&"resolvedContent"in I){const O=Promise.all([this.d.$handleProgressChunk(a,z),I.resolvedContent]);(0,y.$Jg)(O,s).then(F=>{if(!F)return;const[T,N]=F;this.d.$handleProgressChunk(a,N,T??void 0)})}else this.d.$handleProgressChunk(a,z)}),s);return await(0,y.$Jg)(Promise.resolve(b).then(I=>{if(I){this.g.set(f,I);let z=this.h.get(f);z||(z=new Map,this.h.set(f,z)),z.set(a,I);const O={firstProgress:m,totalElapsed:w.elapsed()};return{errorDetails:I.errorDetails,timings:O}}else this.g.delete(f)}),s)}catch(b){return this.j.error(b,n.extension),{errorDetails:{message:(0,$.localize)(0,null,(0,l.$Bi)(b)),responseIsIncomplete:!0}}}finally{r=!0,v.complete()}}$releaseSession(c){this.g.delete(c),this.h.delete(c)}async $provideSlashCommands(c,f){const a=this.b.get(c);return a?a.provideSlashCommand(f):[]}$provideFollowups(c,f,a){const t=this.b.get(c);if(!t)return Promise.resolve([]);const i=this.g.get(f);return i?t.provideFollowups(i,a):Promise.resolve([])}$acceptFeedback(c,f,a,t){const i=this.b.get(c);if(!i)return;const s=this.h.get(f)?.get(a);if(!s)return;let n;switch(t){case D.InteractiveSessionVoteDirection.Down:n=S.ChatAgentResultFeedbackKind.Unhelpful;break;case D.InteractiveSessionVoteDirection.Up:n=S.ChatAgentResultFeedbackKind.Helpful;break}i.acceptFeedback(Object.freeze({result:s,kind:n}))}$acceptAction(c,f,a,t){const i=this.b.get(c);if(!i)return;const s=this.h.get(f)?.get(a);s&&t.action.kind!=="vote"&&i.acceptAction(Object.freeze({action:t.action,result:s}))}}e.$Jec=h,h.a=0;class u{constructor(c,f,a,t,i){this.extension=c,this.n=f,this.o=a,this.q=t,this.r=i,this.l=new L.$Od,this.m=new L.$Od}acceptFeedback(c){this.l.fire(c)}acceptAction(c){this.m.fire(c)}async validateSlashCommand(c){this.b||(await this.provideSlashCommand(M.CancellationToken.None),(0,g.$Jf)(this.b));const f=this.b.find(a=>a.name===c);if(!f)throw new Error(`Unknown slashCommand: ${c}`);return f}async provideSlashCommand(c){if(!this.a)return[];const f=await this.a.provideSlashCommands(c);return f?(this.b=f,f.map(a=>({name:a.name,description:a.description,followupPlaceholder:a.followupPlaceholder,shouldRepopulate:a.shouldRepopulate}))):[]}async provideFollowups(c,f){if(!this.d)return[];const a=await this.d.provideFollowups(c,f);return a?a.map(t=>p.ChatFollowup.from(t)):[]}get apiAgent(){let c=!1,f=!1;const a=()=>{c||f||(f=!0,queueMicrotask(()=>{this.o.$updateAgent(this.q,{description:this.g??"",fullName:this.h,icon:this.i?this.i instanceof k.URI?this.i:"light"in this.i?this.i.light:void 0:void 0,iconDark:this.i&&"dark"in this.i?this.i.dark:void 0,themeIcon:this.i instanceof S.$mL?this.i:void 0,hasSlashCommands:this.a!==void 0,hasFollowup:this.d!==void 0,isDefault:this.j,isSecondary:this.k}),f=!1}))},t=this;return{get name(){return t.n},get description(){return t.g??""},set description(i){t.g=i,a()},get fullName(){return t.h??t.extension.displayName??t.extension.name},set fullName(i){t.h=i,a()},get iconPath(){return t.i},set iconPath(i){t.i=i,a()},get slashCommandProvider(){return t.a},set slashCommandProvider(i){t.a=i,a()},get followupProvider(){return t.d},set followupProvider(i){t.d=i,a()},get isDefault(){return(0,E.$mF)(t.extension,"defaultChatAgent"),t.j},set isDefault(i){(0,E.$mF)(t.extension,"defaultChatAgent"),t.j=i,a()},get isSecondary(){return(0,E.$mF)(t.extension,"defaultChatAgent"),t.k},set isSecondary(i){(0,E.$mF)(t.extension,"defaultChatAgent"),t.k=i,a()},get onDidReceiveFeedback(){return t.l.event},onDidPerformAction:(0,E.$lF)(this.extension,"chatAgents2Additions")?this.m.event:void 0,dispose(){c=!0,t.a=void 0,t.d=void 0,t.l.dispose(),t.o.$unregisterAgent(t.q)}}}invoke(c,f,a,t){return this.r(c,f,a,t)}}}),define(De[300],Ce([1,0,21,3,6,13,64,25,8,4]),function(re,e,y,M,l,L,A,g,k,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dec=void 0;class R{constructor(D,E){this.stream=new k.$hh,this.stream=E??new k.$hh;const h=this;this.apiObj={option:D,response:h.stream.asyncIterable}}}class P{constructor(D,E){this.a=new $.$Od,this.b=new Map,this.c=new k.$hh,this.d=!1;const h=this;this.apiObject={result:D,response:h.c.asyncIterable,onDidStartResponseStream:h.a.event,cancel(){E.cancel()}},D.finally(()=>{if(this.d=!0,this.b.size>0)for(const[,u]of this.b)u.stream.resolve();else this.c.resolve()})}handleFragment(D){if(this.d)return;let E=this.b.get(D.index);E||(this.b.size===0?E=new R(D.index,this.c):E=new R(D.index),this.b.set(D.index,E),this.a.fire(E.apiObj)),E.stream.emitOne(D.part)}}class p{constructor(D,E){this.d=E,this.c=new Map,this.e=new Map,this.f=new g.$0l,this.b=D.getProxy(l.$qK.MainThreadChatProvider)}registerProvider(D,E,h,u){const d=p.a++;return this.c.set(d,{extension:D,provider:h}),this.b.$registerProvider(d,E,{extension:D,displayName:u.name??D.value}),(0,M.$Qc)(()=>{this.b.$unregisterProvider(d),this.c.delete(d)})}async $provideChatResponse(D,E,h,u,d){const c=this.c.get(D);if(!c)return;const f=new A.$0u(async a=>{if(d.isCancellationRequested){this.d.warn(`[CHAT](${c.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}this.b.$handleProgressChunk(E,{index:a.index,part:a.part})});return c.provider.provideChatResponse(h.map(L.ChatMessage.to),u,f,d)}allowListExtensionWhile(D,E){this.f.set(D,E),E.finally(()=>this.f.delete(D))}async requestChatResponseProvider(D,E){if(!this.f.has(D))throw new Error("Extension is NOT allowed to make chat requests");const h=this;return{get isRevoked(){return!h.f.has(D)},makeRequest(u,d,c){if(!h.f.has(D))throw new Error("Access to chat has been revoked");const f=new y.$Yd(c),a=Math.random()*1e6|0,t=h.b.$fetchResponse(D,E,a,u.map(L.ChatMessage.from),d??{},f.token),i=new P(t,f);return h.e.set(a,{res:i}),t.finally(()=>{h.e.delete(a)}),i.apiObject}}}async $handleResponseFragment(D,E){const h=this.e.get(D);h&&h.res.handleFragment(E)}}e.$Dec=p,p.a=1}),define(De[301],Ce([1,0,3,6,9,13]),function(re,e,y,M,l,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fec=void 0;class A{constructor(k){this.b=new Map,this.c=k.getProxy(M.$qK.MainThreadChatVariables)}async $resolveVariable(k,$,R){const P=this.b.get(k);if(P)try{const p=await P.resolver.resolve(P.data.name,{message:$},R);if(p)return p.map(L.ChatVariable.from)}catch(p){(0,l.$2)(p)}}registerVariableResolver(k,$,R,P){const p=A.a++;return this.b.set(p,{extension:k.identifier,data:{name:$,description:R},resolver:P}),this.c.$registerVariable(p,{name:$,description:R}),(0,y.$Qc)(()=>{this.b.delete(p),this.c.$unregisterVariable(p)})}}e.$Fec=A,A.a=0}),define(De[302],Ce([1,0,6]),function(re,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ncc=void 0;class M{constructor(L){const A=L.getProxy(y.$qK.MainThreadClipboard);this.value=Object.freeze({readText(){return A.$readText()},writeText(g){return A.$writeText(g)}})}}e.$Ncc=M});var et=this&&this.__classPrivateFieldSet||function(re,e,y,M,l){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!l)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!l:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?l.call(re,y):l?l.value=y:e.set(re,y),y},Be=this&&this.__classPrivateFieldGet||function(re,e,y,M){if(y==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!M:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return y==="m"?M:y==="a"?M.call(re):M?M.value:e.get(re)};define(De[34],Ce([1,0,17,7,13,24,6,19,14,60,33,63,2,3,5,20,148,22,69,41,35,85,88]),function(re,e,y,M,l,L,A,g,k,$,R,P,p,S,D,E,h,u,d,c,f,a,t){"use strict";var i,s,n;Object.defineProperty(e,"__esModule",{value:!0}),e.$RM=e.$QM=e.$PM=e.$OM=e.$NM=e.$MM=void 0;let r=class{constructor(b,I,z){i.set(this,void 0),this.b=new Map,this.c=new Map,s.set(this,void 0),n.set(this,void 0),et(this,i,b.getProxy(A.$qK.MainThreadCommands),"f"),this.d=I,et(this,n,z,"f"),et(this,s,b.getProxy(A.$qK.MainThreadTelemetry),"f"),this.converter=new o(this,O=>{const F=this.c.get(O);return F?.result===C.Void?F:void 0},I),this.f=[{processArgument(O){return(0,$.$nh)(O)}},{processArgument(O){return(0,L.$$m)(O,function(F){if(R.$ys.isIRange(F))return l.Range.to(F);if(P.$xs.isIPosition(F))return l.Position.to(F);if(R.$ys.isIRange(F.range)&&p.URI.isUri(F.uri))return l.location.to(F);if(F instanceof u.$ce)return F.buffer.buffer;if(!Array.isArray(F))return F})}}]}registerArgumentProcessor(b){this.f.push(b)}registerApiCommand(b){const I=this.registerCommand(!1,b.id,async(...z)=>{const O=b.args.map((T,N)=>{if(!T.validate(z[N]))throw new Error(`Invalid argument '${T.name}' when running '${b.id}', received: ${typeof z[N]=="object"?JSON.stringify(z[N],null,"	"):z[N]} `);return T.convert(z[N])}),F=await this.executeCommand(b.internalId,...O);return b.result.convert(F,z,this.converter)},void 0,{description:b.description,args:b.args,returns:b.result.description});return this.c.set(b.id,b),new M.$sK(()=>{I.dispose(),this.c.delete(b.id)})}registerCommand(b,I,z,O,F,T){if(this.d.trace("ExtHostCommands#registerCommand",I),!I.trim().length)throw new Error("invalid id");if(this.b.has(I))throw new Error(`command '${I}' already exists`);return this.b.set(I,{callback:z,thisArg:O,metadata:F,extension:T}),b&&Be(this,i,"f").$registerCommand(I),new M.$sK(()=>{this.b.delete(I)&&b&&Be(this,i,"f").$unregisterCommand(I)})}executeCommand(b,...I){return this.d.trace("ExtHostCommands#executeCommand",b),this.g(b,I,!0)}async g(b,I,z){if(this.b.has(b))return Be(this,i,"f").$fireCommandActivationEvent(b),this.h(b,I,!1);{let O=!1;const F=(0,L.$$m)(I,function(T){if(T instanceof M.$tK)return l.Position.from(T);if(T instanceof M.$uK)return l.Range.from(T);if(T instanceof M.$EK)return l.location.from(T);if(M.$PL.isNotebookRange(T))return l.NotebookRange.from(T);if(T instanceof ArrayBuffer)return O=!0,u.$ce.wrap(new Uint8Array(T));if(T instanceof Uint8Array)return O=!0,u.$ce.wrap(T);if(T instanceof u.$ce)return O=!0,T;if(!Array.isArray(T))return T});try{const T=await Be(this,i,"f").$executeCommand(b,O?new d.$vv(F):F,z);return(0,$.$nh)(T)}catch(T){if(T instanceof Error&&T.message==="$executeCommand:retry")return this.g(b,I,!1);throw T}}}async h(b,I,z){const O=this.b.get(b);if(!O)throw new Error("Unknown command");const{callback:F,thisArg:T,metadata:N}=O;if(N?.args)for(let U=0;U<N.args.length;U++)try{(0,y.$Qf)(I[U],N.args[U].constraint)}catch{throw new Error(`Running the contributed command: '${b}' failed. Illegal argument '${N.args[U].name}' - ${N.args[U].description}`)}const j=f.$Kd.create();try{return await F.apply(T,I)}catch(U){if(b===this.converter.delegatingCommandId){const B=this.converter.getActualCommand(...I);B&&(b=B.command)}if(this.d.error(U,b,O.extension?.identifier),!z)throw U;if(O.extension?.identifier){const B=Be(this,n,"f").onExtensionError(O.extension.identifier,U);this.d.trace("forwarded error to extension?",B,O.extension?.identifier)}throw new class extends Error{constructor(){super((0,c.$Bi)(U)),this.id=b,this.source=O.extension?.displayName??O.extension?.name}}}finally{this.j(O,b,j.elapsed())}}j(b,I,z){b.extension&&Be(this,s,"f").$publicLog2("Extension:ActionExecuted",{extensionId:b.extension.identifier.value,id:new a.$oo(I),duration:z})}$executeContributedCommand(b,...I){this.d.trace("ExtHostCommands#$executeContributedCommand",b);const z=this.b.get(b);return z?(I=I.map(O=>this.f.reduce((F,T)=>T.processArgument(F,z.extension?.identifier),O)),this.h(b,I,!0)):Promise.reject(new Error(`Contributed command '${b}' does not exist.`))}getCommands(b=!1){return this.d.trace("ExtHostCommands#getCommands",b),Be(this,i,"f").$getCommands().then(I=>(b&&(I=I.filter(z=>z[0]!=="_")),I))}$getContributedCommandMetadata(){const b=Object.create(null);for(const[I,z]of this.b){const{metadata:O}=z;O&&(b[I]=O)}return Promise.resolve(b)}};e.$MM=r,i=new WeakMap,s=new WeakMap,n=new WeakMap,e.$MM=r=He([We(0,E.$rM),We(1,k.$$i),We(2,t.$LM)],r),e.$NM=(0,D.$Qh)("IExtHostCommands");class o{constructor(b,I,z){this.d=b,this.f=I,this.g=z,this.delegatingCommandId=`__vsc${Date.now().toString(36)} `,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(b,I){if(!b)return;const z={$ident:void 0,id:b.command,title:b.title,tooltip:b.tooltip};if(!b.command)return z;const O=this.f(b.command);if(O)z.id=O.internalId,z.arguments=O.args.map((F,T)=>F.convert(b.arguments&&b.arguments[T]));else if((0,g.$Lb)(b.arguments)){const F=`${b.command} /${++this.c}`;this.b.set(F,b),I.add((0,S.$Qc)(()=>{this.b.delete(F),this.g.trace("CommandsConverter#DISPOSE",F)})),z.$ident=F,z.id=this.delegatingCommandId,z.arguments=[F],this.g.trace("CommandsConverter#CREATE",b.command,F)}return z}fromInternal(b){return typeof b.$ident=="string"?this.b.get(b.$ident):{command:b.id,title:b.title,arguments:b.arguments}}getActualCommand(...b){return this.b.get(b[0])}h(...b){const I=this.getActualCommand(...b);return this.g.trace("CommandsConverter#EXECUTE",b[0],I?I.command:"MISSING"),I?this.d.executeCommand(I.command,...I.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${b[0]}`)}}e.$OM=o;class v{static Arr(b){return new v(`${b.name}_array`,`Array of ${b.name}, ${b.description}`,I=>Array.isArray(I)&&I.every(z=>b.validate(z)),I=>I.map(z=>b.convert(z)))}constructor(b,I,z,O){this.name=b,this.description=I,this.validate=z,this.convert=O}optional(){return new v(this.name,`(optional) ${this.description}`,b=>b==null||this.validate(b),b=>b===void 0?void 0:b===null?null:this.convert(b))}with(b,I){return new v(b??this.name,I??this.description,this.validate,this.convert)}}e.$PM=v,v.Uri=new v("uri","Uri of a text document",m=>p.URI.isUri(m),m=>m),v.Position=new v("position","A position in a text document",m=>M.$tK.isPosition(m),l.Position.from),v.Range=new v("range","A range in a text document",m=>M.$uK.isRange(m),l.Range.from),v.Selection=new v("selection","A selection in a text document",m=>M.$vK.isSelection(m),l.Selection.from),v.Number=new v("number","",m=>typeof m=="number",m=>m),v.String=new v("string","",m=>typeof m=="string",m=>m),v.StringArray=v.Arr(v.String),v.CallHierarchyItem=new v("item","A call hierarchy item",m=>m instanceof M.$OK,l.CallHierarchyItem.from),v.TypeHierarchyItem=new v("item","A type hierarchy item",m=>m instanceof M.$9L,l.TypeHierarchyItem.from),v.TestItem=new v("testItem","A VS Code TestItem",m=>m instanceof h.$EM,l.TestItem.from);class C{constructor(b,I){this.description=b,this.convert=I}}e.$QM=C,C.Void=new C("no result",m=>m);class w{constructor(b,I,z,O,F){this.id=b,this.internalId=I,this.description=z,this.args=O,this.result=F}}e.$RM=w}),define(De[303],Ce([1,0,19,18,2,83,130,42,135,34,13,7]),function(re,e,y,M,l,L,A,g,k,$,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mcc=void 0;const p=[new $.$RM("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[$.$PM.Uri,$.$PM.Position],new $.$QM("A promise that resolves to an array of DocumentHighlight-instances.",D(R.DocumentHighlight.to))),new $.$RM("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[$.$PM.Uri],new $.$QM("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(h,u)=>{if((0,y.$Kb)(h))return;class d extends P.$JK{static to(f){const a=new d(f.name,R.SymbolKind.to(f.kind),f.containerName||"",new P.$EK(u[0],R.Range.to(f.range)));return a.detail=f.detail,a.range=a.location.range,a.selectionRange=R.Range.to(f.selectionRange),a.children=f.children?f.children.map(d.to):[],a}}return h.map(d.to)})),new $.$RM("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[$.$PM.Uri,new $.$PM("options","Formatting options",h=>!0,h=>h)],new $.$QM("A promise that resolves to an array of TextEdits.",D(R.TextEdit.to))),new $.$RM("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[$.$PM.Uri,$.$PM.Range,new $.$PM("options","Formatting options",h=>!0,h=>h)],new $.$QM("A promise that resolves to an array of TextEdits.",D(R.TextEdit.to))),new $.$RM("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[$.$PM.Uri,$.$PM.Position,new $.$PM("ch","Trigger character",h=>typeof h=="string",h=>h),new $.$PM("options","Formatting options",h=>!0,h=>h)],new $.$QM("A promise that resolves to an array of TextEdits.",D(R.TextEdit.to))),new $.$RM("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[$.$PM.Uri,$.$PM.Position],new $.$QM("A promise that resolves to an array of Location or LocationLink instances.",E)),new $.$RM("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[$.$PM.Uri,$.$PM.Position],new $.$QM("A promise that resolves to an array of Location or LocationLink instances.",E)),new $.$RM("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[$.$PM.Uri,$.$PM.Position],new $.$QM("A promise that resolves to an array of Location or LocationLink instances.",E)),new $.$RM("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[$.$PM.Uri,$.$PM.Position],new $.$QM("A promise that resolves to an array of Location or LocationLink instances.",E)),new $.$RM("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[$.$PM.Uri,$.$PM.Position],new $.$QM("A promise that resolves to an array of Location-instances.",D(R.location.to))),new $.$RM("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[$.$PM.Uri,$.$PM.Position],new $.$QM("A promise that resolves to an array of Hover-instances.",D(R.Hover.to))),new $.$RM("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[$.$PM.Uri,new $.$PM("position","A position in a text document",h=>Array.isArray(h)&&h.every(u=>P.$tK.isPosition(u)),h=>h.map(R.Position.from))],new $.$QM("A promise that resolves to an array of ranges.",h=>h.map(u=>{let d;for(const c of u.reverse())d=new P.$NK(R.Range.to(c),d);return d}))),new $.$RM("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[$.$PM.String.with("query","Search string")],new $.$QM("A promise that resolves to an array of SymbolInformation-instances.",h=>h.map(R.WorkspaceSymbol.to))),new $.$RM("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[$.$PM.Uri,$.$PM.Position],new $.$QM("A promise that resolves to an array of CallHierarchyItem-instances",h=>h.map(R.CallHierarchyItem.to))),new $.$RM("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[$.$PM.CallHierarchyItem],new $.$QM("A promise that resolves to an array of CallHierarchyIncomingCall-instances",h=>h.map(R.CallHierarchyIncomingCall.to))),new $.$RM("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[$.$PM.CallHierarchyItem],new $.$QM("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",h=>h.map(R.CallHierarchyOutgoingCall.to))),new $.$RM("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[$.$PM.Uri,$.$PM.Position],new $.$QM("A promise that resolves to a range and placeholder text.",h=>{if(h)return{range:R.Range.to(h.range),placeholder:h.text}})),new $.$RM("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[$.$PM.Uri,$.$PM.Position,$.$PM.String.with("newName","The new symbol name")],new $.$QM("A promise that resolves to a WorkspaceEdit.",h=>{if(h){if(h.rejectReason)throw new Error(h.rejectReason);return R.WorkspaceEdit.to(h)}})),new $.$RM("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[$.$PM.Uri,$.$PM.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new $.$QM("A promise that resolves to an array of DocumentLink-instances.",h=>h.map(R.DocumentLink.to))),new $.$RM("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[$.$PM.Uri],new $.$QM("A promise that resolves to SemanticTokensLegend.",h=>{if(h)return new P.$HL(h.tokenTypes,h.tokenModifiers)})),new $.$RM("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[$.$PM.Uri],new $.$QM("A promise that resolves to SemanticTokens.",h=>{if(!h)return;const u=(0,A.$c$)(h);if(u.type==="full")return new P.$JL(u.data,void 0)})),new $.$RM("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[$.$PM.Uri,$.$PM.Range.optional()],new $.$QM("A promise that resolves to SemanticTokensLegend.",h=>{if(h)return new P.$HL(h.tokenTypes,h.tokenModifiers)})),new $.$RM("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[$.$PM.Uri,$.$PM.Range],new $.$QM("A promise that resolves to SemanticTokens.",h=>{if(!h)return;const u=(0,A.$c$)(h);if(u.type==="full")return new P.$JL(u.data,void 0)})),new $.$RM("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[$.$PM.Uri,$.$PM.Position,$.$PM.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),$.$PM.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new $.$QM("A promise that resolves to a CompletionList-instance.",(h,u,d)=>{if(!h)return new P.$ZK([]);const c=h.suggestions.map(f=>R.CompletionItem.to(f,d));return new P.$ZK(c,h.incomplete)})),new $.$RM("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[$.$PM.Uri,$.$PM.Position,$.$PM.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new $.$QM("A promise that resolves to SignatureHelp.",h=>{if(h)return R.SignatureHelp.to(h)})),new $.$RM("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[$.$PM.Uri,$.$PM.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new $.$QM("A promise that resolves to an array of CodeLens-instances.",(h,u,d)=>D(c=>new P.$RK(R.Range.to(c.range),c.command&&d.fromInternal(c.command)))(h))),new $.$RM("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[$.$PM.Uri,new $.$PM("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",h=>P.$uK.isRange(h),h=>P.$vK.isSelection(h)?R.Selection.from(h):R.Range.from(h)),$.$PM.String.with("kind","Code action kind to return code actions for").optional(),$.$PM.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new $.$QM("A promise that resolves to an array of Command-instances.",(h,u,d)=>D(c=>{if(c._isSynthetic){if(!c.command)throw new Error("Synthetic code actions must have a command");return d.fromInternal(c.command)}else{const f=new P.$LK(c.title,c.kind?new P.$MK(c.kind):void 0);return c.edit&&(f.edit=R.WorkspaceEdit.to(c.edit)),c.command&&(f.command=d.fromInternal(c.command)),f.isPreferred=c.isPreferred,f}})(h))),new $.$RM("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[$.$PM.Uri],new $.$QM("A promise that resolves to an array of ColorInformation objects.",h=>h?h.map(u=>new P.$6K(R.Range.to(u.range),R.Color.to(u.color))):[])),new $.$RM("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new $.$PM("color","The color to show and insert",h=>h instanceof P.$5K,R.Color.from),new $.$PM("context","Context object with uri and range",h=>!0,h=>({uri:h.uri,range:R.Range.from(h.range)}))],new $.$QM("A promise that resolves to an array of ColorPresentation objects.",h=>h?h.map(R.ColorPresentation.to):[])),new $.$RM("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[$.$PM.Uri,$.$PM.Range],new $.$QM("A promise that resolves to an array of Inlay objects",(h,u,d)=>h.map(R.InlayHint.to.bind(void 0,d)))),new $.$RM("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[$.$PM.Uri],new $.$QM("A promise that resolves to an array of FoldingRange objects",(h,u)=>{if(h)return h.map(R.FoldingRange.to)})),new $.$RM("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new $.$QM("A promise that resolves to an array of NotebookContentProvider static info objects.",D(h=>({viewType:h.viewType,displayName:h.displayName,options:{transientOutputs:h.options.transientOutputs,transientCellMetadata:h.options.transientCellMetadata,transientDocumentMetadata:h.options.transientDocumentMetadata},filenamePattern:h.filenamePattern.map(u=>R.NotebookExclusiveDocumentPattern.to(u))})))),new $.$RM("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[$.$PM.Uri,$.$PM.Range,new $.$PM("context","An InlineValueContext",h=>h&&typeof h.frameId=="number"&&h.stoppedLocation instanceof P.$uK,h=>R.InlineValueContext.from(h))],new $.$QM("A promise that resolves to an array of InlineValue objects",h=>h.map(R.InlineValue.to))),new $.$RM("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new $.$PM("uriOrString","Uri-instance or string (only http/https)",h=>l.URI.isUri(h)||typeof h=="string"&&(0,k.$xU)(h,M.Schemas.http,M.Schemas.https),h=>h),new $.$PM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",h=>h===void 0||typeof h=="number"||typeof h=="object",h=>h&&(typeof h=="number"?[R.ViewColumn.from(h),void 0]:[R.ViewColumn.from(h.viewColumn),R.TextEditorOpenOptions.from(h)])).optional(),$.$PM.String.with("label","").optional()],$.$QM.Void),new $.$RM("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[$.$PM.Uri.with("resource","Resource to open"),$.$PM.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new $.$PM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",h=>h===void 0||typeof h=="number"||typeof h=="object",h=>h&&(typeof h=="number"?[R.ViewColumn.from(h),void 0]:[R.ViewColumn.from(h.viewColumn),R.TextEditorOpenOptions.from(h)])).optional()],$.$QM.Void),new $.$RM("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[$.$PM.Uri.with("left","Left-hand side resource of the diff editor"),$.$PM.Uri.with("right","Right-hand side resource of the diff editor"),$.$PM.String.with("title","Human readable title for the diff editor").optional(),new $.$PM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",h=>h===void 0||typeof h=="object",h=>h&&[R.ViewColumn.from(h.viewColumn),R.TextEditorOpenOptions.from(h)]).optional()],$.$QM.Void),new $.$RM("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[$.$PM.Uri,$.$PM.Position],new $.$QM("A promise that resolves to an array of TypeHierarchyItem-instances",h=>h.map(R.TypeHierarchyItem.to))),new $.$RM("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[$.$PM.TypeHierarchyItem],new $.$QM("A promise that resolves to an array of TypeHierarchyItem-instances",h=>h.map(R.TypeHierarchyItem.to))),new $.$RM("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[$.$PM.TypeHierarchyItem],new $.$QM("A promise that resolves to an array of TypeHierarchyItem-instances",h=>h.map(R.TypeHierarchyItem.to))),new $.$RM("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[$.$PM.TestItem],$.$QM.Void),new $.$RM("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[$.$PM.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],$.$QM.Void),new $.$RM("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[$.$PM.String.with("name","The context key name"),new $.$PM("value","The context key value",()=>!0,h=>h)],$.$QM.Void),new $.$RM("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[$.$PM.Uri,$.$PM.StringArray,new $.$PM("MappedEditsContext","Mapped Edits Context",h=>R.MappedEditsContext.is(h),h=>R.MappedEditsContext.from(h))],new $.$QM("A promise that resolves to a workspace edit or null",h=>h?R.WorkspaceEdit.to(h):null))];class S{static register(u){p.forEach(u.registerApiCommand,u),this.a(u)}static a(u){u.registerCommand(!1,"_validateWhenClauses",g.$Pi)}}e.$Mcc=S;function D(h){return u=>{if(Array.isArray(u))return u.map(h)}}function E(h){if(!Array.isArray(h))return;const u=[];for(const d of h)L.$jt(d)?u.push(R.DefinitionLink.to(d)):u.push(R.location.to(d));return u}}),define(De[304],Ce([1,0,8,57,4,3,2,83,25,13,7,6,26]),function(re,e,y,M,l,L,A,g,k,$,R,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Occ=void 0;function S(D,E,h){const u=D.getProxy(P.$qK.MainThreadComments);class d{constructor(){this.b=new Map,this.c=new k.$0l,E.registerArgumentProcessor({processArgument:o=>{if(o&&o.$mid===6){const v=this.b.get(o.handle);return v?v.value:o}else if(o&&o.$mid===7){const v=this.b.get(o.commentControlHandle);if(!v)return o;const C=v.getCommentThread(o.commentThreadHandle);return C?C.value:o}else if(o&&(o.$mid===9||o.$mid===8)){const v=this.b.get(o.thread.commentControlHandle);if(!v)return o;const C=v.getCommentThread(o.thread.commentThreadHandle);return C?o.$mid===8?C.value:{thread:C.value,text:o.text}:o}else if(o&&o.$mid===10){const v=this.b.get(o.thread.commentControlHandle);if(!v)return o;const C=v.getCommentThread(o.thread.commentThreadHandle);if(!C)return o;const w=o.commentUniqueId,m=C.getCommentByUniqueId(w);return m||o}else if(o&&o.$mid===11){const v=this.b.get(o.thread.commentControlHandle);if(!v)return o;const C=v.getCommentThread(o.thread.commentThreadHandle);if(!C)return o;const w=o.text,m=o.commentUniqueId,b=C.getCommentByUniqueId(m);return b?(typeof b.body=="string"?b.body=w:b.body=new R.$SK(w),b):o}return o}})}createCommentController(o,v,C){const w=d.a++,m=new f(o,w,v,C);this.b.set(m.handle,m);const b=this.c.get(o.identifier)||[];return b.push(m),this.c.set(o.identifier,b),m.value}async $createCommentThreadTemplate(o,v,C){const w=this.b.get(o);w&&w.$createCommentThreadTemplate(v,C)}async $updateCommentThreadTemplate(o,v,C){const w=this.b.get(o);w&&w.$updateCommentThreadTemplate(v,C)}$deleteCommentThread(o,v){this.b.get(o)?.$deleteCommentThread(v)}$provideCommentingRanges(o,v,C){const w=this.b.get(o);if(!w||!w.commentingRangeProvider)return Promise.resolve(void 0);const m=h.getDocument(A.URI.revive(v));return(0,y.$Ng)(async()=>{const b=await w.commentingRangeProvider.provideCommentingRanges(m,C);let I;return Array.isArray(b)?I={ranges:b,fileComments:!1}:b?I={ranges:b.ranges||[],fileComments:b.fileComments||!1}:I=b??void 0,I}).then(b=>{let I;return b&&(I={ranges:b.ranges.map(z=>$.Range.from(z)),fileComments:b.fileComments}),I})}$toggleReaction(o,v,C,w,m){const b=this.b.get(o);return!b||!b.reactionHandler?Promise.resolve(void 0):(0,y.$Ng)(()=>{const I=b.getCommentThread(v);if(I){const z=I.getCommentByUniqueId(w.uniqueIdInThread);if(b!==void 0&&z&&b.reactionHandler)return b.reactionHandler(z,i(m))}return Promise.resolve(void 0)})}}d.a=0;class c{set threadId(o){this.n=o}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(o){(o===void 0!=(this.p===void 0)||!o||!this.p||!o.isEqual(this.p))&&(this.p=o,this.b.range=o,this.c.fire())}get range(){return this.p}set canReply(o){this.d!==o&&(this.d=o,this.b.canReply=o,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(o){this.e=o,this.b.label=o,this.c.fire()}get contextValue(){return this.f}set contextValue(o){this.f=o,this.b.contextValue=o,this.c.fire()}get comments(){return this.q}set comments(o){this.q=o,this.b.comments=o,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(o){this.g=o,this.b.collapsibleState=o,this.c.fire()}get state(){return this.h}set state(o){this.h=o,this.b.state=o,this.c.fire()}get isDisposed(){return this.j}constructor(o,v,C,w,m,b,I,z){this.m=v,this.n=C,this.o=w,this.p=m,this.q=b,this.extensionDescription=I,this.r=z,this.handle=c.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new l.$Od,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new L.$Tc,this.l.value=new L.$Rc,this.n===void 0&&(this.n=`${o}.${this.handle}`),u.$createCommentThread(v,this.handle,this.n,this.o,$.Range.from(this.p),I.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=b,this.i.push({dispose:()=>{u.$deleteCommentThread(v,this.handle)}});const O=this;this.value={get uri(){return O.uri},get range(){return O.range},set range(F){O.range=F},get comments(){return O.comments},set comments(F){O.comments=F},get collapsibleState(){return O.collapsibleState},set collapsibleState(F){O.collapsibleState=F},get canReply(){return O.canReply},set canReply(F){O.canReply=F},get contextValue(){return O.contextValue},set contextValue(F){O.contextValue=F},get label(){return O.label},set label(F){O.label=F},get state(){return O.state},set state(F){O.state=F},dispose:()=>{O.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new L.$Rc);const o=C=>Object.prototype.hasOwnProperty.call(this.b,C),v={};o("range")&&(v.range=$.Range.from(this.p)),o("label")&&(v.label=this.label),o("contextValue")&&(v.contextValue=this.contextValue??null),o("comments")&&(v.comments=this.q.map(C=>a(this,C,this.k,this.extensionDescription))),o("collapsibleState")&&(v.collapseState=s(this.g)),o("canReply")&&(v.canReply=this.canReply),o("state")&&(v.state=n(this.h)),o("isTemplate")&&(v.isTemplate=this.r),this.b={},u.$updateCommentThread(this.m,this.handle,this.n,this.o,v)}getCommentByUniqueId(o){for(const v of this.k){const C=v[0],w=v[1];if(o===w)return C}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(o=>o.dispose())}}c.a=0,He([(0,M.$jh)(100)],c.prototype,"eventuallyUpdateCommentThread",null);class f{get id(){return this.h}get label(){return this.i}get handle(){return this.g}get commentingRangeProvider(){return this.b}set commentingRangeProvider(o){this.b=o,u.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(o){this.c=o,u.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!o})}get options(){return this.d}set options(o){this.d=o,u.$updateCommentControllerFeatures(this.handle,{options:this.d})}constructor(o,v,C,w){this.f=o,this.g=v,this.h=C,this.i=w,this.a=new Map,u.$registerCommentController(this.handle,C,w,this.f.identifier.value);const m=this;this.value=Object.freeze({id:m.id,label:m.label,get options(){return m.options},set options(b){m.options=b},get commentingRangeProvider(){return m.commentingRangeProvider},set commentingRangeProvider(b){m.commentingRangeProvider=b},get reactionHandler(){return m.reactionHandler},set reactionHandler(b){m.reactionHandler=b},createCommentThread(b,I,z){return m.createCommentThread(b,I,z).value},dispose:()=>{m.dispose()}}),this.e=[],this.e.push({dispose:()=>{u.$unregisterCommentController(this.handle)}})}createCommentThread(o,v,C){v===void 0&&(0,p.$mF)(this.f,"fileComments");const w=new c(this.id,this.handle,void 0,o,v,C,this.f,!1);return this.a.set(w.handle,w),w}$createCommentThreadTemplate(o,v){const C=new c(this.id,this.handle,void 0,A.URI.revive(o),$.Range.to(v),[],this.f,!0);return C.collapsibleState=g.CommentThreadCollapsibleState.Expanded,this.a.set(C.handle,C),C}$updateCommentThreadTemplate(o,v){const C=this.a.get(o);C&&(C.range=$.Range.to(v))}$deleteCommentThread(o){this.a.get(o)?.dispose(),this.a.delete(o)}getCommentThread(o){return this.a.get(o)}dispose(){this.a.forEach(o=>{o.dispose()}),this.e.forEach(o=>o.dispose())}}function a(r,o,v,C){let w=v.get(o);return w||(w=++r.commentHandle,v.set(o,w)),o.state!==void 0&&(0,p.$mF)(C,"commentsDraftState"),{mode:o.mode,contextValue:o.contextValue,uniqueIdInThread:w,body:typeof o.body=="string"?o.body:$.MarkdownString.from(o.body),userName:o.author.name,userIconPath:o.author.iconPath,label:o.label,commentReactions:o.reactions?o.reactions.map(m=>t(m)):void 0,state:o.state,timestamp:o.timestamp?.toJSON()}}function t(r){return{label:r.label,iconPath:r.iconPath?$.$qM(r.iconPath):void 0,count:r.count,hasReacted:r.authorHasReacted}}function i(r){return{label:r.label||"",count:r.count||0,iconPath:r.iconPath?A.URI.revive(r.iconPath):"",authorHasReacted:r.hasReacted||!1}}function s(r){if(r!==void 0)switch(r){case R.CommentThreadCollapsibleState.Expanded:return g.CommentThreadCollapsibleState.Expanded;case R.CommentThreadCollapsibleState.Collapsed:return g.CommentThreadCollapsibleState.Collapsed}return g.CommentThreadCollapsibleState.Collapsed}function n(r){if(r!==void 0)switch(r){case R.CommentThreadState.Unresolved:return g.CommentThreadState.Unresolved;case R.CommentThreadState.Resolved:return g.CommentThreadState.Resolved}return g.CommentThreadState.Unresolved}return new d}e.$Occ=S}),define(De[305],Ce([1,0,24,6,27,20]),function(re,e,y,M,l,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mec=void 0;let A=class{constructor(R,P){this.a=R.getProxy(M.$qK.MainThreadConsole),this.b=P.consoleForward.includeStack,this.c=P.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("error","error")}d(R,P){const p=this,S=console[R];Object.defineProperty(console,R,{set:()=>{},get:()=>function(){p.e(R,P,S,arguments)}})}e(R,P,p,S){this.a.$logExtensionHostMessage({type:"__$console",severity:P,arguments:k(S,this.b)}),this.c&&this.f(R,p,S)}};e.$Mec=A,e.$Mec=A=He([We(0,L.$rM),We(1,l.$HM)],A);const g=1e5;function k($,R){const P=[];if($.length)for(let p=0;p<$.length;p++){let S=$[p];if(typeof S>"u")S="undefined";else if(S instanceof Error){const D=S;D.stack?S=D.stack:S=D.toString()}P.push(S)}if(R){const p=new Error().stack;p&&P.push({__$stack:p.split(`
`).slice(3).join(`
`)})}try{const p=(0,y.$bn)(P);return p.length>g?"Output omitted for a large object that exceeds the limits":p}catch(p){return`Output omitted for an object that cannot be inspected ('${p.toString()}')`}}}),define(De[150],Ce([1,0,2,6,7,5,20,14,19,16,15,26]),function(re,e,y,M,l,L,A,g,k,$,R,P){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.$Qdc=e.$Pdc=void 0;let S=p=class{constructor(E,h){this.h=h,this.f=new Map,this.g=E.getProxy(M.$qK.MainThreadDecorations)}registerFileDecorationProvider(E,h){const u=p.c++;this.f.set(u,{provider:E,extensionDescription:h}),this.g.$registerDecorationProvider(u,h.identifier.value);const d=E.onDidChangeFileDecorations&&E.onDidChangeFileDecorations(c=>{if(!c){this.g.$onDidChange(u,null);return}const f=(0,k.$3b)(c);if(f.length<=p.d){this.g.$onDidChange(u,f);return}this.h.warn("[Decorations] CAPPING events from decorations provider",h.identifier.value,f.length);const a=f.map(s=>({uri:s,rank:(0,$.$He)(s.path,"/")})),t=(0,k.$zb)(a,(s,n)=>s.rank-n.rank||(0,$.$Ve)(s.uri.path,n.uri.path)),i=[];e:for(const s of t){let n;for(const r of s){const o=(0,R.$mc)(r.uri.path);if(n!==o&&(n=o,i.push(r.uri)>=p.d))break e}}this.g.$onDidChange(u,i)});return new l.$sK(()=>{d?.dispose(),this.g.$unregisterDecorationProvider(u),this.f.delete(u)})}async $provideDecorations(E,h,u){if(!this.f.has(E))return Object.create(null);const d=Object.create(null),{provider:c,extensionDescription:f}=this.f.get(E);return await Promise.all(h.map(async a=>{try{const{uri:t,id:i}=a,s=await Promise.resolve(c.provideFileDecoration(y.URI.revive(t),u));if(!s)return;try{l.$NL.validate(s),s.badge&&typeof s.badge!="string"&&(0,P.$mF)(f,"codiconDecoration"),d[i]=[s.propagate,s.tooltip,s.badge,s.color]}catch(n){this.h.warn(`INVALID decoration from extension '${f.identifier.value}': ${n}`)}}catch(t){this.h.error(t)}})),d}};e.$Pdc=S,S.c=0,S.d=250,e.$Pdc=S=p=He([We(0,A.$rM),We(1,g.$$i)],S),e.$Qdc=(0,L.$Qh)("IExtHostDecorations")});var et=this&&this.__classPrivateFieldSet||function(re,e,y,M,l){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!l)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!l:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?l.call(re,y):l?l.value=y:e.set(re,y),y},Be=this&&this.__classPrivateFieldGet||function(re,e,y,M){if(y==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!M:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return y==="m"?M:y==="a"?M.call(re):M?M.value:e.get(re)};define(De[306],Ce([1,0,204,134,2,6,7,13,4,14,28,55]),function(re,e,y,M,l,L,A,g,k,$,R,P){"use strict";var p,S,D,E;Object.defineProperty(e,"__esModule",{value:!0}),e.$Hcc=e.$Gcc=void 0;class h{constructor(c,f,a,t,i,s,n,r){this.d=c,this.e=f,this.f=a,this.g=t,this.h=i,p.set(this,void 0),S.set(this,void 0),D.set(this,void 0),this.c=!1,this.f=Math.max(t,a),et(this,D,new R.$Ac(o=>s.getComparisonKey(o)),"f"),et(this,p,n,"f"),et(this,S,r,"f")}dispose(){this.c||(Be(this,S,"f").fire([...Be(this,D,"f").keys()]),Be(this,p,"f")?.$clear(this.e),Be(this,D,"f").clear(),this.c=!0)}get name(){return this.j(),this.d}set(c,f){if(!c){this.clear();return}this.j();let a=[];if(l.URI.isUri(c)){if(!f){this.delete(c);return}Be(this,D,"f").set(c,f.slice()),a=[c]}else if(Array.isArray(c)){a=[];let s;c=[...c].sort(h.k);for(const n of c){const[r,o]=n;if((!s||r.toString()!==s.toString())&&(s&&Be(this,D,"f").get(s).length===0&&Be(this,D,"f").delete(s),s=r,a.push(r),Be(this,D,"f").set(r,[])),o)Be(this,D,"f").get(r)?.push(...o);else{const v=Be(this,D,"f").get(r);v&&(v.length=0)}}}if(Be(this,S,"f").fire(a),!Be(this,p,"f"))return;const t=[];let i=0;for(const s of a){let n=[];const r=Be(this,D,"f").get(s);if(r)if(r.length>this.g){n=[];const o=[A.DiagnosticSeverity.Error,A.DiagnosticSeverity.Warning,A.DiagnosticSeverity.Information,A.DiagnosticSeverity.Hint];e:for(let v=0;v<4;v++)for(const C of r)if(C.severity===o[v]&&n.push({...g.Diagnostic.from(C),modelVersionId:this.h(s)})===this.g)break e;n.push({severity:M.MarkerSeverity.Info,message:(0,y.localize)(0,null,r.length-this.g),startLineNumber:n[n.length-1].startLineNumber,startColumn:n[n.length-1].startColumn,endLineNumber:n[n.length-1].endLineNumber,endColumn:n[n.length-1].endColumn})}else n=r.map(o=>({...g.Diagnostic.from(o),modelVersionId:this.h(s)}));if(t.push([s,n]),i+=n.length,i>this.f)break}Be(this,p,"f").$changeMany(this.e,t)}delete(c){this.j(),Be(this,S,"f").fire([c]),Be(this,D,"f").delete(c),Be(this,p,"f")?.$changeMany(this.e,[[c,void 0]])}clear(){this.j(),Be(this,S,"f").fire([...Be(this,D,"f").keys()]),Be(this,D,"f").clear(),Be(this,p,"f")?.$clear(this.e)}forEach(c,f){this.j();for(const[a,t]of this)c.call(f,a,t,this)}*[(p=new WeakMap,S=new WeakMap,D=new WeakMap,Symbol.iterator)](){this.j();for(const c of Be(this,D,"f").keys())yield[c,this.get(c)]}get(c){this.j();const f=Be(this,D,"f").get(c);return Array.isArray(f)?Object.freeze(f.slice(0)):[]}has(c){return this.j(),Array.isArray(Be(this,D,"f").get(c))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(c,f){return c[0].toString()<f[0].toString()?-1:c[0].toString()>f[0].toString()?1:0}}e.$Gcc=h;let u=E=class{static _mapper(c){const f=new R.$Ac;for(const a of c)f.set(a,a);return{uris:Object.freeze(Array.from(f.values()))}}constructor(c,f,a,t){this.j=f,this.k=a,this.l=t,this.g=new Map,this.h=new k.$Sd({merge:i=>i.flat(),delay:50}),this.onDidChangeDiagnostics=k.Event.map(this.h.event,E._mapper),this.f=c.getProxy(L.$qK.MainThreadDiagnostics)}createDiagnosticCollection(c,f){const{g:a,f:t,h:i,j:s,k:n,l:r}=this,o=new class{$changeMany(w,m){t.$changeMany(w,m),s.trace("[DiagnosticCollection] change many (extension, owner, uris)",c.value,w,m.length===0?"CLEARING":m)}$clear(w){t.$clear(w),s.trace("[DiagnosticCollection] remove all (extension, owner)",c.value,w)}dispose(){t.dispose()}};let v;if(!f)f="_generated_diagnostic_collection_name_#"+E.c++,v=f;else if(!a.has(f))v=f;else{this.j.warn(`DiagnosticCollection with name '${f}' does already exist.`);do v=f+E.c++;while(a.has(v))}return new class extends h{constructor(){super(f,v,E.e,E.d,w=>r.getDocument(w)?.version,n.extUri,o,i),a.set(v,this)}dispose(){super.dispose(),a.delete(v)}}}getDiagnostics(c){if(c)return this.m(c);{const f=new Map,a=[];for(const t of this.g.values())t.forEach((i,s)=>{let n=f.get(i.toString());typeof n>"u"&&(n=a.length,f.set(i.toString(),n),a.push([i,[]])),a[n][1]=a[n][1].concat(...s)});return a}}m(c){let f=[];for(const a of this.g.values())a.has(c)&&(f=f.concat(a.get(c)));return f}$acceptMarkersChange(c){if(!this.n){const f="_generated_mirror",a=new h(f,f,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,t=>{},this.k.extUri,void 0,this.h);this.g.set(f,a),this.n=a}for(const[f,a]of c)this.n.set(l.URI.revive(f),a.map(g.Diagnostic.to))}};e.$Hcc=u,u.c=0,u.d=1e3,u.e=1.1*E.d,e.$Hcc=u=E=He([We(1,$.$$i),We(2,P.$Fcc)],u)}),define(De[307],Ce([1,0,2,6,26]),function(re,e,y,M,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wcc=void 0;class L{constructor(g){this.a=g.getProxy(M.$qK.MainThreadDialogs)}showOpenDialog(g,k){return k?.allowUIResources&&(0,l.$mF)(g,"showLocal"),this.a.$showOpenDialog(k).then($=>$?$.map(R=>y.URI.revive(R)):void 0)}showSaveDialog(g){return this.a.$showSaveDialog(g).then(k=>k?y.URI.revive(k):void 0)}}e.$Wcc=L}),define(De[308],Ce([1,0,9,2,7,6,18,21,16]),function(re,e,y,M,l,L,A,g,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xcc=void 0;class ${constructor(P,p,S){this.d=p,this.e=S,this.b=new Map,this.c=P.getProxy(L.$qK.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(P,p){if(Object.keys(A.Schemas).indexOf(P)>=0)throw new Error(`scheme '${P}' already registered`);const S=$.a++;this.b.set(S,p),this.c.$registerTextContentProvider(S,P);let D;return typeof p.onDidChange=="function"&&(D=p.onDidChange(E=>{if(E.scheme!==P){this.e.warn(`Provider for scheme '${P}' is firing event for schema '${E.scheme}' which will be IGNORED`);return}this.d.getDocument(E)&&this.$provideTextDocumentContent(S,E).then(h=>{if(!h&&typeof h!="string")return;const u=this.d.getDocument(E);if(!u)return;const d=(0,k.$Qe)(h);if(!u.equalLines(d))return this.c.$onVirtualDocumentChange(E,h)},y.$1)})),new l.$sK(()=>{this.b.delete(S)&&this.c.$unregisterTextContentProvider(S),D&&(D.dispose(),D=void 0)})}$provideTextDocumentContent(P,p){const S=this.b.get(P);return S?Promise.resolve(S.provideTextDocumentContent(M.URI.revive(p),g.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${p.scheme}`))}}e.$Xcc=$,$.a=0}),define(De[309],Ce([1,0,4,3,2,6,142,13,17,24,7,9]),function(re,e,y,M,l,L,A,g,k,$,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dcc=void 0;class p{constructor(D,E){this.a=new y.$Od({onListenerError:P.$2}),this.b=new y.$Od({onListenerError:P.$2}),this.c=new y.$Od({onListenerError:P.$2}),this.d=new y.$Od({onListenerError:P.$2}),this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new M.$Rc,this.h=new Map,this.f=D.getProxy(L.$qK.MainThreadDocuments),this.g=E,this.g.onDidRemoveDocuments(h=>{for(const u of h)this.b.fire(u.document)},void 0,this.e),this.g.onDidAddDocuments(h=>{for(const u of h)this.a.fire(u.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(D){if(!D)return;const E=this.g.getDocument(D);if(E)return E}getDocument(D){const E=this.getDocumentData(D);if(!E?.document)throw new Error(`Unable to retrieve document from URI '${D}'`);return E.document}ensureDocumentData(D){const E=this.g.getDocument(D);if(E)return Promise.resolve(E);let h=this.h.get(D.toString());return h||(h=this.f.$tryOpenDocument(D).then(u=>{this.h.delete(D.toString());const d=l.URI.revive(u);return(0,k.$Kf)(this.g.getDocument(d))},u=>(this.h.delete(D.toString()),Promise.reject(u))),this.h.set(D.toString(),h)),h}createDocumentData(D){return this.f.$tryCreateDocument(D).then(E=>l.URI.revive(E))}$acceptModelLanguageChanged(D,E){const h=l.URI.revive(D),u=this.g.getDocument(h);if(!u)throw new Error("unknown document");this.b.fire(u.document),u._acceptLanguageId(E),this.a.fire(u.document)}$acceptModelSaved(D){const E=l.URI.revive(D),h=this.g.getDocument(E);if(!h)throw new Error("unknown document");this.$acceptDirtyStateChanged(D,!1),this.d.fire(h.document)}$acceptDirtyStateChanged(D,E){const h=l.URI.revive(D),u=this.g.getDocument(h);if(!u)throw new Error("unknown document");u._acceptIsDirty(E),this.c.fire({document:u.document,contentChanges:[],reason:void 0})}$acceptModelChanged(D,E,h){const u=l.URI.revive(D),d=this.g.getDocument(u);if(!d)throw new Error("unknown document");d._acceptIsDirty(h),d.onEvents(E);let c;E.isUndoing?c=R.TextDocumentChangeReason.Undo:E.isRedoing&&(c=R.TextDocumentChangeReason.Redo),this.c.fire((0,$.$0m)({document:d.document,contentChanges:E.changes.map(f=>({range:g.Range.to(f.range),rangeOffset:f.rangeOffset,rangeLength:f.rangeLength,text:f.text})),reason:c}))}setWordDefinitionFor(D,E){(0,A.$tM)(D,E)}}e.$Dcc=p}),define(De[70],Ce([1,0,58,4,3,2,5,6,142,20,149,13,14,28,18,51,47]),function(re,e,y,M,l,L,A,g,k,$,R,P,p,S,D,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CM=e.$BM=void 0;class u{constructor(f){this.value=f,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let d=class{constructor(f,a){this.h=f,this.i=a,this.a=null,this.b=new Map,this.c=new S.$Ac,this.d=new M.$Od,this.e=new M.$Od,this.f=new M.$Od,this.g=new M.$Od,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(f){this.acceptDocumentsAndEditorsDelta(f)}acceptDocumentsAndEditorsDelta(f){const a=[],t=[],i=[];if(f.removedDocuments)for(const s of f.removedDocuments){const n=L.URI.revive(s),r=this.c.get(n);r?.unref()&&(this.c.delete(n),a.push(r.value))}if(f.addedDocuments)for(const s of f.addedDocuments){const n=L.URI.revive(s.uri);let r=this.c.get(n);if(r&&n.scheme!==D.Schemas.vscodeNotebookCell&&n.scheme!==D.Schemas.vscodeInteractiveInput)throw new Error(`document '${n} already exists!'`);r||(r=new u(new k.$uM(this.h.getProxy(g.$qK.MainThreadDocuments),n,s.lines,s.EOL,s.versionId,s.languageId,s.isDirty,s.notebook)),this.c.set(n,r),t.push(r.value)),r.ref()}if(f.removedEditors)for(const s of f.removedEditors){const n=this.b.get(s);this.b.delete(s),n&&i.push(n)}if(f.addedEditors)for(const s of f.addedEditors){const n=L.URI.revive(s.documentUri);y.ok(this.c.has(n),`document '${n}' does not exist`),y.ok(!this.b.has(s.id),`editor '${s.id}' already exists!`);const r=this.c.get(n).value,o=new R.$AM(s.id,this.h.getProxy(g.$qK.MainThreadTextEditors),this.i,new h.$V(()=>r.document),s.selections.map(P.Selection.to),s.options,s.visibleRanges.map(v=>P.Range.to(v)),typeof s.editorPosition=="number"?P.ViewColumn.to(s.editorPosition):void 0);this.b.set(s.id,o)}f.newActiveEditor!==void 0&&(y.ok(f.newActiveEditor===null||this.b.has(f.newActiveEditor),`active editor '${f.newActiveEditor}' does not exist`),this.a=f.newActiveEditor),(0,l.$Nc)(a),(0,l.$Nc)(i),f.removedDocuments&&this.e.fire(a),f.addedDocuments&&this.d.fire(t),(f.removedEditors||f.addedEditors)&&this.f.fire(this.allEditors().map(s=>s.value)),f.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(f){return this.c.get(f)?.value}allDocuments(){return E.Iterable.map(this.c.values(),f=>f.value)}getEditor(f){return this.b.get(f)}activeEditor(f){if(!this.a)return;const a=this.b.get(this.a);return f?a:a?.value}allEditors(){return[...this.b.values()]}};e.$BM=d,e.$BM=d=He([We(0,$.$rM),We(1,p.$$i)],d),e.$CM=(0,A.$Qh)("IExtHostDocumentsAndEditors")}),define(De[71],Ce([1,0,13,6,2,4,5,7,20,17,74]),function(re,e,y,M,l,L,A,g,k,$,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vdc=e.$Udc=void 0,e.$Udc=(0,A.$Qh)("IExtHostEditorTabs");class P{constructor(h,u,d){this.e=d,this.d=u,this.acceptDtoUpdate(h)}get apiObject(){if(!this.a){const h=this,u={get isActive(){return h.b.id===h.e()},get label(){return h.b.label},get input(){return h.c},get isDirty(){return h.b.isDirty},get isPinned(){return h.b.isPinned},get isPreview(){return h.b.isPreview},get group(){return h.d.apiObject}};this.a=Object.freeze(u)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(h){this.b=h,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new g.$0L(l.URI.revive(this.b.input.uri));case 2:return new g.$$L(l.URI.revive(this.b.input.original),l.URI.revive(this.b.input.modified));case 3:return new g.$_L(l.URI.revive(this.b.input.base),l.URI.revive(this.b.input.input1),l.URI.revive(this.b.input.input2),l.URI.revive(this.b.input.result));case 6:return new g.$aM(l.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new g.$bM(this.b.input.viewType);case 4:return new g.$cM(l.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new g.$dM(l.URI.revive(this.b.input.original),l.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new g.$eM;case 9:return new g.$fM(l.URI.revive(this.b.input.uri),l.URI.revive(this.b.input.inputBoxUri));default:return}}}class p{constructor(h,u){this.c=[],this.d="",this.b=h,this.e=u;for(const d of h.tabs)d.isActive&&(this.d=d.id),this.c.push(new P(d,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const h=this,u={get isActive(){return h.b.groupId===h.e()},get viewColumn(){return y.ViewColumn.to(h.b.viewColumn)},get activeTab(){return h.c.find(d=>d.tabId===h.d)?.apiObject},get tabs(){return Object.freeze(h.c.map(d=>d.apiObject))}};this.a=Object.freeze(u)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(h){this.b=h}acceptTabOperation(h){if(h.kind===0){const d=new P(h.tabDto,this,()=>this.activeTabId());return this.c.splice(h.index,0,d),h.tabDto.isActive&&(this.d=d.tabId),d}else if(h.kind===1){const d=this.c.splice(h.index,1)[0];if(!d)throw new Error(`Tab close updated received for index ${h.index} which does not exist`);return d.tabId===this.d&&(this.d=""),d}else if(h.kind===3){if(h.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const d=this.c.splice(h.oldIndex,1)[0];if(!d)throw new Error(`Tab move updated received for index ${h.oldIndex} which does not exist`);return this.c.splice(h.index,0,d),d}const u=this.c.find(d=>d.tabId===h.tabDto.id);if(!u)throw new Error("INVALID tab");return h.tabDto.isActive?this.d=h.tabDto.id:this.d===h.tabDto.id&&!h.tabDto.isActive&&(this.d=""),u.acceptDtoUpdate(h.tabDto),u}activeTabId(){return this.d}}let S=class{constructor(h){this.b=new L.$Od,this.c=new L.$Od,this.e=[],this.a=h.getProxy(M.$qK.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const h=this,u={onDidChangeTabGroups:h.c.event,onDidChangeTabs:h.b.event,get all(){return Object.freeze(h.e.map(d=>d.apiObject))},get activeTabGroup(){const d=h.d;return(0,$.$Kf)(h.e.find(f=>f.groupId===d)?.apiObject)},close:async(d,c)=>{const f=Array.isArray(d)?d:[d];return f.length?D(f[0])?this.j(f,c):this.i(f,c):!0}};this.f=Object.freeze(u)}return this.f}$acceptEditorTabModel(h){const u=new Set(this.e.map(s=>s.groupId)),d=new Set(h.map(s=>s.groupId)),c=(0,R.$E)(u,d),f=this.e.filter(s=>c.removed.includes(s.groupId)).map(s=>s.apiObject),a=[],t=[];this.e=h.map(s=>{const n=new p(s,()=>this.d);return c.added.includes(n.groupId)?a.push(n.apiObject):t.push(n.apiObject),n});const i=(0,$.$Kf)(h.find(s=>s.isActive===!0)?.groupId);i!==void 0&&this.d!==i&&(this.d=i),this.c.fire(Object.freeze({opened:a,closed:f,changed:t}))}$acceptTabGroupUpdate(h){const u=this.e.find(d=>d.groupId===h.groupId);if(!u)throw new Error("Update Group IPC call received before group creation.");u.acceptGroupDtoUpdate(h),h.isActive&&(this.d=h.groupId),this.c.fire(Object.freeze({changed:[u.apiObject],opened:[],closed:[]}))}$acceptTabOperation(h){const u=this.e.find(c=>c.groupId===h.groupId);if(!u)throw new Error("Update Tabs IPC call received before group creation.");const d=u.acceptTabOperation(h);switch(h.kind){case 0:this.b.fire(Object.freeze({opened:[d.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[d.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[d.apiObject]}));return}}g(h){for(const u of this.e)for(const d of u.tabs)if(d.apiObject===h)return d}h(h){return this.e.find(u=>u.apiObject===h)}async i(h,u){const d=[];for(const c of h){const f=this.g(c);if(!f)throw new Error("Tab close: Invalid tab not found!");d.push(f.tabId)}return this.a.$closeTab(d,u)}async j(h,u){const d=[];for(const c of h){const f=this.h(c);if(!f)throw new Error("Group close: Invalid group not found!");d.push(f.groupId)}return this.a.$closeGroup(d,u)}};e.$Vdc=S,e.$Vdc=S=He([We(0,k.$rM)],S);function D(E){return E.tabs!==void 0}}),define(De[310],Ce([1,0,6,7]),function(re,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hec=void 0;class l{constructor(A){this.a=new Map,this.b=0,this.c=A.getProxy(y.$qK.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(A,g,k){if(this.a.size===0)throw new Error("No embedding vector providers registered");const $=this.a.get(A);if(!$)throw new Error("Embedding vector provider not found");const R=await $.provideEmbeddingVector(g,k);if(!R)throw new Error("Embedding vector provider returned undefined");return R}registerEmbeddingVectorProvider(A,g,k){const $=this.b;return this.b++,this.a.set($,k),this.c.$registerAiEmbeddingVectorProvider(g,$),new M.$sK(()=>{this.c.$unregisterAiEmbeddingVectorProvider($),this.a.delete($)})}}e.$Hec=l}),define(De[311],Ce([1,0,2,6,3,7,13,175,16,22,26,80]),function(re,e,y,M,l,L,A,g,k,$,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rdc=void 0;class p{constructor(){this.a=[]}add(E){this.b=void 0,this.a.push(E)}delete(E){const h=this.a.indexOf(E);h>=0&&(this.a.splice(h,1),this.b=void 0)}c(){if(!this.b){const E=this.a.sort(),h=[];let u,d,c=14,f=14;for(const a of E){let t=u?(0,k.$5e)(u,a):0;for(t===0?d=1:d=f;t<a.length;t++)t+1===a.length?(c=f,f=9):f+=1,h.push([d,a.toUpperCase().charCodeAt(t),f]),h.push([d,a.toLowerCase().charCodeAt(t),f]),d=f;u=a,f=c}h.push([9,58,10]),h.push([10,47,12]),this.b=new g.$fZ(h)}}provideDocumentLinks(E){this.c();const h=[],u=g.$gZ.computeLinks({getLineContent(d){return E.lineAt(d-1).text},getLineCount(){return E.lineCount}},this.b);for(const d of u){const c=A.DocumentLink.to(d);c.target&&h.push(c)}return h}}class S{constructor(E,h){this.i=h,this.b=new p,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=E.getProxy(M.$qK.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(E,h,u,d={}){if(S.j(u),this.d.has(h))throw new Error(`a provider for the scheme '${h}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(E,"*",this.b));const c=this.h++;this.b.add(h),this.d.add(h),this.c.set(c,u);let f=2;d.isCaseSensitive&&(f+=1024),d.isReadonly&&(f+=2048),typeof u.copy=="function"&&(f+=8),typeof u.open=="function"&&typeof u.close=="function"&&typeof u.read=="function"&&typeof u.write=="function"&&((0,R.$mF)(E,"fsChunks"),f+=4);let a;d.isReadonly&&(0,P.$6j)(d.isReadonly)&&((0,R.$mF)(E,"readonlyMessage"),a={value:d.isReadonly.value,isTrusted:d.isReadonly.isTrusted,supportThemeIcons:d.isReadonly.supportThemeIcons,supportHtml:d.isReadonly.supportHtml,baseUri:d.isReadonly.baseUri,uris:d.isReadonly.uris}),this.a.$registerFileSystemProvider(c,h,f,a).catch(i=>{console.error(`FAILED to register filesystem provider of ${E.identifier.value}-extension for the scheme ${h}`),console.error(i)});const t=u.onDidChangeFile(i=>{const s=[];for(const n of i){const{uri:r,type:o}=n;if(r.scheme!==h)continue;let v;switch(o){case L.FileChangeType.Changed:v=0;break;case L.FileChangeType.Created:v=1;break;case L.FileChangeType.Deleted:v=2;break;default:throw new Error("Unknown FileChangeType")}s.push({resource:r,type:v})}this.a.$onFileSystemChange(c,s)});return(0,l.$Qc)(()=>{t.dispose(),this.b.delete(h),this.d.delete(h),this.c.delete(c),this.a.$unregisterProvider(c)})}static j(E){if(!E)throw new Error("MISSING provider");if(typeof E.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof E.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof E.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof E.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof E.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof E.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof E.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof E.rename!="function")throw new Error("Provider does NOT implement rename")}static k(E){const{type:h,ctime:u,mtime:d,size:c,permissions:f}=E;return{type:h,ctime:u,mtime:d,size:c,permissions:f}}$stat(E,h){return Promise.resolve(this.l(E).stat(y.URI.revive(h))).then(u=>S.k(u))}$readdir(E,h){return Promise.resolve(this.l(E).readDirectory(y.URI.revive(h)))}$readFile(E,h){return Promise.resolve(this.l(E).readFile(y.URI.revive(h))).then(u=>$.$ce.wrap(u))}$writeFile(E,h,u,d){return Promise.resolve(this.l(E).writeFile(y.URI.revive(h),u.buffer,d))}$delete(E,h,u){return Promise.resolve(this.l(E).delete(y.URI.revive(h),u))}$rename(E,h,u,d){return Promise.resolve(this.l(E).rename(y.URI.revive(h),y.URI.revive(u),d))}$copy(E,h,u,d){const c=this.l(E);if(!c.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(c.copy(y.URI.revive(h),y.URI.revive(u),d))}$mkdir(E,h){return Promise.resolve(this.l(E).createDirectory(y.URI.revive(h)))}$watch(E,h,u,d){const c=this.l(E).watch(y.URI.revive(u),d);this.f.set(h,c)}$unwatch(E,h){const u=this.f.get(h);u&&(u.dispose(),this.f.delete(h))}$open(E,h,u){const d=this.l(E);if(!d.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(d.open(y.URI.revive(h),u))}$close(E,h){const u=this.l(E);if(!u.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(u.close(h))}$read(E,h,u,d){const c=this.l(E);if(!c.read)throw new Error('FileSystemProvider does not implement "read"');const f=$.$ce.alloc(d);return Promise.resolve(c.read(h,u,f.buffer,0,d)).then(a=>f.slice(0,a))}$write(E,h,u,d){const c=this.l(E);if(!c.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(c.write(h,u,d.buffer,0,d.byteLength))}l(E){const h=this.c.get(E);if(!h){const u=new Error;throw u.name="ENOPRO",u.message="no provider",u}return h}}e.$rdc=S}),define(De[72],Ce([1,0,6,30,7,22,5,20,55,3,8,23,18]),function(re,e,y,M,l,L,A,g,k,$,R,P,p){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.$$cc=e.$0cc=void 0;let D=S=class{constructor(h,u){this.b=new Map,this.c=new R.$4g,this.a=h.getProxy(y.$qK.MainThreadFileSystem);const d=this;this.value=Object.freeze({async stat(c){try{let f;const a=d.b.get(c.scheme);return a?(await d.a.$ensureActivation(c.scheme),f=await a.impl.stat(c)):f=await d.a.$stat(c),{type:f.type,ctime:f.ctime,mtime:f.mtime,size:f.size,permissions:f.permissions===M.FilePermission.Readonly?1:void 0}}catch(f){S.e(f)}},async readDirectory(c){try{const f=d.b.get(c.scheme);return f?(await d.a.$ensureActivation(c.scheme),(await f.impl.readDirectory(c)).slice()):await d.a.$readdir(c)}catch(f){return S.e(f)}},async createDirectory(c){try{const f=d.b.get(c.scheme);return f&&!f.isReadonly?(await d.a.$ensureActivation(c.scheme),await d.d(f.impl,f.extUri,c)):await d.a.$mkdir(c)}catch(f){return S.e(f)}},async readFile(c){try{const f=d.b.get(c.scheme);return f?(await d.a.$ensureActivation(c.scheme),(await f.impl.readFile(c)).slice()):(await d.a.$readFile(c)).buffer}catch(f){return S.e(f)}},async writeFile(c,f){try{const a=d.b.get(c.scheme);return a&&!a.isReadonly?(await d.a.$ensureActivation(c.scheme),await d.d(a.impl,a.extUri,a.extUri.dirname(c)),await d.c.queueFor(c).queue(()=>Promise.resolve(a.impl.writeFile(c,f,{create:!0,overwrite:!0})))):await d.a.$writeFile(c,L.$ce.wrap(f))}catch(a){return S.e(a)}},async delete(c,f){try{const a=d.b.get(c.scheme);return a&&!a.isReadonly?(await d.a.$ensureActivation(c.scheme),await a.impl.delete(c,{recursive:!1,...f})):await d.a.$delete(c,{recursive:!1,useTrash:!1,atomic:!1,...f})}catch(a){return S.e(a)}},async rename(c,f,a){try{return await d.a.$rename(c,f,{overwrite:!1,...a})}catch(t){return S.e(t)}},async copy(c,f,a){try{return await d.a.$copy(c,f,{overwrite:!1,...a})}catch(t){return S.e(t)}},isWritableFileSystem(c){const f=u.getCapabilities(c);if(typeof f=="number")return!(f&2048)}})}async d(h,u,d){const c=[];for(;!u.isEqual(d,u.dirname(d));)try{if(!((await h.stat(d)).type&M.FileType.Directory))throw l.$FL.FileExists(`Unable to create folder '${d.scheme===p.Schemas.file?d.fsPath:d.toString(!0)}' that already exists but is not a directory`);break}catch(f){if(M.$pk(f)!==M.FileSystemProviderErrorCode.FileNotFound)throw f;c.push(u.basename(d)),d=u.dirname(d)}for(let f=c.length-1;f>=0;f--){d=u.joinPath(d,c[f]);try{await h.createDirectory(d)}catch(a){if(M.$pk(a)!==M.FileSystemProviderErrorCode.FileExists)throw a}}}static e(h){if(h instanceof l.$FL)throw h;if(h instanceof M.$lk)switch(h.code){case M.FileSystemProviderErrorCode.FileExists:throw l.$FL.FileExists(h.message);case M.FileSystemProviderErrorCode.FileNotFound:throw l.$FL.FileNotFound(h.message);case M.FileSystemProviderErrorCode.FileNotADirectory:throw l.$FL.FileNotADirectory(h.message);case M.FileSystemProviderErrorCode.FileIsADirectory:throw l.$FL.FileIsADirectory(h.message);case M.FileSystemProviderErrorCode.NoPermissions:throw l.$FL.NoPermissions(h.message);case M.FileSystemProviderErrorCode.Unavailable:throw l.$FL.Unavailable(h.message);default:throw new l.$FL(h.message,h.name)}if(!(h instanceof Error))throw new l.$FL(String(h));if(h.name==="ENOPRO"||h.message.includes("ENOPRO"))throw l.$FL.Unavailable(h.message);switch(h.name){case M.FileSystemProviderErrorCode.FileExists:throw l.$FL.FileExists(h.message);case M.FileSystemProviderErrorCode.FileNotFound:throw l.$FL.FileNotFound(h.message);case M.FileSystemProviderErrorCode.FileNotADirectory:throw l.$FL.FileNotADirectory(h.message);case M.FileSystemProviderErrorCode.FileIsADirectory:throw l.$FL.FileIsADirectory(h.message);case M.FileSystemProviderErrorCode.NoPermissions:throw l.$FL.NoPermissions(h.message);case M.FileSystemProviderErrorCode.Unavailable:throw l.$FL.Unavailable(h.message);default:throw new l.$FL(h.message,h.name)}}addFileSystemProvider(h,u,d){return this.b.set(h,{impl:u,extUri:d?.isCaseSensitive?P.$mg:P.$og,isReadonly:!!d?.isReadonly}),(0,$.$Qc)(()=>this.b.delete(h))}getFileSystemProviderExtUri(h){return this.b.get(h)?.extUri??P.$mg}};e.$0cc=D,e.$0cc=D=S=He([We(0,g.$rM),We(1,k.$Fcc)],D),e.$$cc=(0,A.$Qh)("IExtHostConsumerFileSystem")}),define(De[312],Ce([1,0,4,36,2,6,13,7,47]),function(re,e,y,M,l,L,A,g,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sdc=void 0;class ${get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(S,D,E,h,u,d){this.a=Math.random(),this.b=new y.$Od,this.c=new y.$Od,this.d=new y.$Od,this.h=0,d?.ignoreCreateEvents&&(this.h+=1),d?.ignoreChangeEvents&&(this.h+=2),d?.ignoreDeleteEvents&&(this.h+=4);const c=(0,M.$xj)(u),f=typeof u=="string",a=d?.correlate,t=h(i=>{if(!(typeof i.session=="number"&&i.session!==this.a)&&!(a&&typeof i.session>"u")){if(!d?.ignoreCreateEvents)for(const s of i.created){const n=l.URI.revive(s);c(n.fsPath)&&(!f||D.getWorkspaceFolder(n))&&this.b.fire(n)}if(!d?.ignoreChangeEvents)for(const s of i.changed){const n=l.URI.revive(s);c(n.fsPath)&&(!f||D.getWorkspaceFolder(n))&&this.c.fire(n)}if(!d?.ignoreDeleteEvents)for(const s of i.deleted){const n=l.URI.revive(s);c(n.fsPath)&&(!f||D.getWorkspaceFolder(n))&&this.d.fire(n)}}});this.g=g.$sK.from(this.i(S,E,u,d,d?.correlate),this.b,this.c,this.d,t)}i(S,D,E,h,u){const d=g.$sK.from();if(typeof E=="string")return d;const c=S.getProxy(L.$qK.MainThreadFileSystemEventService);let f=!1;return(E.pattern.includes(M.$tj)||E.pattern.includes(M.$uj))&&(f=!0),c.$watch(D.identifier.value,this.a,E.baseUri,{recursive:f,excludes:h?.excludes??[]},!!u),g.$sK.from({dispose:()=>c.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class R{constructor(S){this.a=S,this.session=this.a.session,this.b=new k.$V(()=>this.a.created.map(l.URI.revive)),this.c=new k.$V(()=>this.a.changed.map(l.URI.revive)),this.d=new k.$V(()=>this.a.deleted.map(l.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class P{constructor(S,D,E){this.j=S,this.k=D,this.l=E,this.a=new y.$Od,this.b=new y.$Od,this.c=new y.$Od,this.d=new y.$Od,this.g=new y.$Qd,this.h=new y.$Qd,this.i=new y.$Qd,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(S,D,E,h){return new $(this.j,S,D,this.a.event,A.GlobPattern.from(E),h)}$onFileEvent(S){this.a.fire(new R(S))}$onDidRunFileOperation(S,D){switch(S){case 2:this.b.fire(Object.freeze({files:D.map(E=>({oldUri:l.URI.revive(E.source),newUri:l.URI.revive(E.target)}))}));break;case 1:this.d.fire(Object.freeze({files:D.map(E=>l.URI.revive(E.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:D.map(E=>l.URI.revive(E.target))}));break;default:}}getOnWillRenameFileEvent(S){return this.m(S,this.g)}getOnWillCreateFileEvent(S){return this.m(S,this.h)}getOnWillDeleteFileEvent(S){return this.m(S,this.i)}m(S,D){return(E,h,u)=>{const d=function(f){E.call(h,f)};return d.extension=S,D.event(d,void 0,u)}}async $onWillRunFileOperation(S,D,E,h){switch(S){case 2:return await this.n(this.g,{files:D.map(u=>({oldUri:l.URI.revive(u.source),newUri:l.URI.revive(u.target)}))},E,h);case 1:return await this.n(this.i,{files:D.map(u=>l.URI.revive(u.target))},E,h);case 0:case 3:return await this.n(this.h,{files:D.map(u=>l.URI.revive(u.target))},E,h)}}async n(S,D,E,h){const u=new Set,d=[];if(await S.fireAsync(D,h,async(f,a)=>{const t=Date.now(),i=await Promise.resolve(f);i instanceof g.$CK&&(d.push([a.extension,i]),u.add(a.extension.displayName??a.extension.identifier.value)),Date.now()-t>E&&this.k.warn("SLOW file-participant",a.extension.identifier)}),h.isCancellationRequested||d.length===0)return;const c={edits:[]};for(const[,f]of d){const{edits:a}=A.WorkspaceEdit.from(f,{getTextDocumentVersion:t=>this.l.getDocument(t)?.version,getNotebookDocumentVersion:()=>{}});c.edits=c.edits.concat(a)}return{edit:c,extensionNames:Array.from(u)}}}e.$sdc=P}),define(De[313],Ce([1,0,3,2,6,13,7,34,8]),function(re,e,y,M,l,L,A,g,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zec=void 0;class ${constructor(S,D){this.extension=S,this.provider=D,this.handle=$.a++}}$.a=0;class R{constructor(S){this.session=S,this.responses=[]}}class P{constructor(S,D,E,h){this.f=E,this.g=h,this.b=new Map,this.d=new Map,this.e=S.getProxy(l.$qK.MainThreadInlineChat),D.registerApiCommand(new g.$RM("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new g.$PM("Run arguments","",u=>!0,u=>{if(u)return{initialRange:u.initialRange?L.Range.from(u.initialRange):void 0,initialSelection:u.initialSelection?L.Selection.from(u.initialSelection):void 0,message:u.message,autoSend:u.autoSend,position:u.position?L.Position.from(u.position):void 0}})],g.$QM.Void))}registerProvider(S,D,E){const h=new $(S,D);return this.b.set(h.handle,h),this.e.$registerInteractiveEditorProvider(h.handle,E.label,S.identifier.value,typeof D.handleInteractiveEditorResponseFeedback=="function"),(0,y.$Qc)(()=>{this.e.$unregisterInteractiveEditorProvider(h.handle),this.b.delete(h.handle)})}async $prepareSession(S,D,E,h){const u=this.b.get(S);if(!u){this.g.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const d=this.f.getDocument(M.URI.revive(D)),c=L.Selection.to(E),f=await u.provider.prepareInteractiveEditorSession({document:d,selection:c},h);if(!f)return;if(f.wholeRange&&!f.wholeRange.contains(c))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const a=P.a++;return this.d.set(a,new R(f)),{id:a,placeholder:f.placeholder,input:f.input,slashCommands:f.slashCommands?.map(t=>({command:t.command,detail:t.detail,refer:t.refer,executeImmediately:t.executeImmediately})),wholeRange:L.Range.from(f.wholeRange),message:f.message}}async $provideResponse(S,D,E,h){const u=this.b.get(S);if(!u)return;const d=this.d.get(D.id);if(!d)return;const c={prompt:E.prompt,selection:L.Selection.to(E.selection),wholeRange:L.Range.to(E.wholeRange),attempt:E.attempt,live:E.live};let f=!1;const a={report:async o=>{if(!E.live&&o.edits?.length)throw new Error("Progress reporting is only supported for live sessions");f||h.isCancellationRequested||await this.e.$handleProgressChunk(E.requestId,{message:o.message,edits:o.edits?.map(L.TextEdit.from),editsShouldBeInstant:o.editsShouldBeInstant,slashCommand:o.slashCommand?.command,markdownFragment:A.$SK.isMarkdownString(o.content)?o.content.value:o.content})}},t=Promise.resolve(u.provider.provideInteractiveEditorResponse(d.session,c,a,h));let i;try{i=await(0,k.$Jg)(t,h)}finally{f=!0}if(!i)return;const s=d.responses.push(i)-1,n={wholeRange:L.Range.from(i.wholeRange),placeholder:i.placeholder};if(P.h(i))return{...n,id:s,type:"message",message:L.MarkdownString.from(i.contents)};const{edits:r}=i;return r instanceof A.$CK?{...n,id:s,type:"bulkEdit",edits:L.WorkspaceEdit.from(r)}:{...n,id:s,type:"editorEdit",edits:r.map(L.TextEdit.from)}}$handleFeedback(S,D,E,h){const u=this.b.get(S),d=this.d.get(D),c=d?.responses[E];if(u&&c){const f=L.InteractiveEditorResponseFeedbackKind.to(h);u.provider.handleInteractiveEditorResponseFeedback?.(d.session,c,f)}}$releaseSession(S,D){}static h(S){return typeof S=="object"&&typeof S.contents=="object"}}e.$zec=P,P.a=0}),define(De[314],Ce([1,0,2,34]),function(re,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vec=void 0;class l{constructor(A,g,k,$,R){this.a=g,this.b=k,this.c=$;const P=new M.$RM("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new M.$PM("showOptions","Show Options",p=>!0,p=>p),new M.$PM("resource","Interactive resource Uri",p=>!0,p=>p),new M.$PM("controllerId","Notebook controller Id",p=>!0,p=>p),new M.$PM("title","Interactive editor title",p=>!0,p=>p)],new M.$QM("Notebook and input URI",p=>{if(R.debug("[ExtHostInteractive] open iw with notebook editor id",p.notebookEditorId),p.notebookEditorId!==void 0){const S=this.a.getEditorById(p.notebookEditorId);return R.debug("[ExtHostInteractive] notebook editor found",S.id),{notebookUri:y.URI.revive(p.notebookUri),inputUri:y.URI.revive(p.inputUri),notebookEditor:S.apiEditor}}return R.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",p.notebookUri,p.inputUri),{notebookUri:y.URI.revive(p.notebookUri),inputUri:y.URI.revive(p.inputUri)}}));this.c.registerApiCommand(P)}$willAddInteractiveDocument(A,g,k,$){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:g,lines:[""],languageId:k,uri:A,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument(y.URI.revive($))?.apiNotebook}]})}$willRemoveInteractiveDocument(A,g){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[A]})}}e.$vec=l}),define(De[315],Ce([1,0,6,7]),function(re,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bec=void 0;class l{constructor(A){this.a=new Map,this.b=new Map,this.c=A.getProxy(y.$qK.MainThreadIssueReporter)}async $getIssueReporterUri(A,g){if(this.a.size===0)throw new Error("No issue request handlers registered");const k=this.a.get(A);if(!k)throw new Error("Issue request handler not found");const $=await k.handleIssueUrlRequest();if(!$)throw new Error("Issue request handler returned no result");return $}async $getIssueReporterData(A,g){if(this.b.size===0)throw new Error("No issue request handlers registered");const k=this.b.get(A);if(!k)throw new Error("Issue data provider not found");const $=await k.provideIssueData(g);if(!$)throw new Error("Issue data provider returned no result");return $}async $getIssueReporterTemplate(A,g){if(this.b.size===0)throw new Error("No issue request handlers registered");const k=this.b.get(A);if(!k)throw new Error("Issue data provider not found");const $=await k.provideIssueTemplate(g);if(!$)throw new Error("Issue template provider returned no result");return $}registerIssueUriRequestHandler(A,g){const k=A.identifier.value;return this.a.set(k,g),this.c.$registerIssueUriRequestHandler(k),new M.$sK(()=>{this.c.$unregisterIssueUriRequestHandler(k),this.a.delete(k)})}registerIssueDataProvider(A,g){const k=A.identifier.value;return this.b.set(k,g),this.c.$registerIssueDataProvider(k),new M.$sK(()=>{this.c.$unregisterIssueDataProvider(k),this.b.delete(k)})}}e.$Bec=l}),define(De[316],Ce([1,0,3,6]),function(re,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Odc=void 0;class l{constructor(A){this.b=0,this.a=A.getProxy(M.$qK.MainThreadLabelService)}$registerResourceLabelFormatter(A){const g=this.b++;return this.a.$registerResourceLabelFormatter(g,A),(0,y.$Qc)(()=>{this.a.$unregisterResourceLabelFormatter(g)})}}e.$Odc=l}),define(De[317],Ce([1,0,2,24,13,7,83,6,16,33,19,17,170,21,25,3,130,120,107,35,9,8,26,206]),function(re,e,y,M,l,L,A,g,k,$,R,P,p,S,D,E,h,u,d,c,f,a,t,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lcc=void 0;class s{constructor(W,J){this.d=W,this.e=J}async provideDocumentSymbols(W,J){const ce=this.d.getDocument(W),de=await this.e.provideDocumentSymbols(ce,J);if(!(0,R.$Kb)(de))return de[0]instanceof L.$KK?de.map(l.DocumentSymbol.from):s.f(de)}static f(W){W=W.slice(0).sort((de,ee)=>{let $e=de.location.range.start.compareTo(ee.location.range.start);return $e===0&&($e=ee.location.range.end.compareTo(de.location.range.end)),$e});const J=[],ce=[];for(const de of W){const ee={name:de.name||"!!MISSING: name!!",kind:l.SymbolKind.from(de.kind),tags:de.tags?.map(l.SymbolTag.from)||[],detail:"",containerName:de.containerName,range:l.Range.from(de.location.range),selectionRange:l.Range.from(de.location.range),children:[]};for(;;){if(ce.length===0){ce.push(ee),J.push(ee);break}const $e=ce[ce.length-1];if($.$ys.containsRange($e.range,ee.range)&&!$.$ys.equalsRange($e.range,ee.range)){$e.children?.push(ee),ce.push(ee);break}ce.pop()}}return J}}class n{constructor(W,J,ce){this.g=W,this.h=J,this.j=ce,this.e=new d.$Ccc("CodeLens"),this.f=new Map}async provideCodeLenses(W,J){const ce=this.g.getDocument(W),de=await this.j.provideCodeLenses(ce,J);if(!de||J.isCancellationRequested)return;const ee=this.e.add(de),$e=new E.$Rc;this.f.set(ee,$e);const ve={cacheId:ee,lenses:[]};for(let Ne=0;Ne<de.length;Ne++)ve.lenses.push({cacheId:[ee,Ne],range:l.Range.from(de[Ne].range),command:this.h.toInternal(de[Ne].command,$e)});return ve}async resolveCodeLens(W,J){const ce=W.cacheId&&this.e.get(...W.cacheId);if(!ce)return;let de;if(typeof this.j.resolveCodeLens!="function"||ce.isResolved?de=ce:de=await this.j.resolveCodeLens(ce,J),de||(de=ce),J.isCancellationRequested)return;const ee=W.cacheId&&this.f.get(W.cacheId[0]);if(ee)return W.command=this.h.toInternal(de.command??n.d,ee),W}releaseCodeLenses(W){this.f.get(W)?.dispose(),this.f.delete(W),this.e.delete(W)}}n.d={command:"missing",title:"!!MISSING: command!!"};function r(Ie){return Array.isArray(Ie)?Ie.map(l.DefinitionLink.from):Ie?[l.DefinitionLink.from(Ie)]:[]}class o{constructor(W,J){this.d=W,this.e=J}async provideDefinition(W,J,ce){const de=this.d.getDocument(W),ee=l.Position.to(J),$e=await this.e.provideDefinition(de,ee,ce);return r($e)}}class v{constructor(W,J){this.d=W,this.e=J}async provideDeclaration(W,J,ce){const de=this.d.getDocument(W),ee=l.Position.to(J),$e=await this.e.provideDeclaration(de,ee,ce);return r($e)}}class C{constructor(W,J){this.d=W,this.e=J}async provideImplementation(W,J,ce){const de=this.d.getDocument(W),ee=l.Position.to(J),$e=await this.e.provideImplementation(de,ee,ce);return r($e)}}class w{constructor(W,J){this.d=W,this.e=J}async provideTypeDefinition(W,J,ce){const de=this.d.getDocument(W),ee=l.Position.to(J),$e=await this.e.provideTypeDefinition(de,ee,ce);return r($e)}}class m{constructor(W,J){this.d=W,this.e=J}async provideHover(W,J,ce){const de=this.d.getDocument(W),ee=l.Position.to(J),$e=await this.e.provideHover(de,ee,ce);if(!(!$e||(0,R.$Kb)($e.contents)))return $e.range||($e.range=de.getWordRangeAtPosition(ee)),$e.range||($e.range=new L.$uK(ee,ee)),l.Hover.from($e)}}class b{constructor(W,J){this.d=W,this.e=J}async provideEvaluatableExpression(W,J,ce){const de=this.d.getDocument(W),ee=l.Position.to(J),$e=await this.e.provideEvaluatableExpression(de,ee,ce);if($e)return l.EvaluatableExpression.from($e)}}class I{constructor(W,J){this.d=W,this.e=J}async provideInlineValues(W,J,ce,de){const ee=this.d.getDocument(W),$e=await this.e.provideInlineValues(ee,l.Range.to(J),l.InlineValueContext.to(ce),de);if(Array.isArray($e))return $e.map(ve=>l.InlineValue.from(ve))}}class z{constructor(W,J){this.d=W,this.e=J}async provideDocumentHighlights(W,J,ce){const de=this.d.getDocument(W),ee=l.Position.to(J),$e=await this.e.provideDocumentHighlights(de,ee,ce);if(Array.isArray($e))return $e.map(l.DocumentHighlight.from)}}class O{constructor(W,J){this.d=W,this.e=J}async provideLinkedEditingRanges(W,J,ce){const de=this.d.getDocument(W),ee=l.Position.to(J),$e=await this.e.provideLinkedEditingRanges(de,ee,ce);if($e&&Array.isArray($e.ranges))return{ranges:(0,R.$Hb)($e.ranges.map(l.Range.from)),wordPattern:$e.wordPattern}}}class F{constructor(W,J){this.d=W,this.e=J}async provideReferences(W,J,ce,de){const ee=this.d.getDocument(W),$e=l.Position.to(J),ve=await this.e.provideReferences(ee,$e,ce,de);if(Array.isArray(ve))return ve.map(l.location.from)}}class T{constructor(W,J,ce,de,ee,$e,ve){this.g=W,this.h=J,this.j=ce,this.k=de,this.l=ee,this.m=$e,this.n=ve,this.e=new d.$Ccc("CodeAction"),this.f=new Map}async provideCodeActions(W,J,ce,de){const ee=this.g.getDocument(W),$e=p.$As.isISelection(J)?l.Selection.to(J):l.Range.to(J),ve=[];for(const it of this.j.getDiagnostics(W))if($e.intersection(it.range)&&ve.push(it)>T.d)break;const Ne={diagnostics:ve,only:ce.only?new L.$MK(ce.only):void 0,triggerKind:l.CodeActionTriggerKind.to(ce.trigger)},qe=await this.k.provideCodeActions(ee,$e,Ne,de);if(!(0,R.$Lb)(qe)||de.isCancellationRequested)return;const xe=this.e.add(qe),Ge=new E.$Rc;this.f.set(xe,Ge);const st=[];for(let it=0;it<qe.length;it++){const nt=qe[it];nt&&(T.o(nt)?(this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),st.push({_isSynthetic:!0,title:nt.title,command:this.h.toInternal(nt,Ge)})):(Ne.only&&(nt.kind?Ne.only.contains(nt.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Ne.only.value} 'requested but returned code action is of kind '${nt.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Ne.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),st.push({cacheId:[xe,it],title:nt.title,command:nt.command&&this.h.toInternal(nt.command,Ge),diagnostics:nt.diagnostics&&nt.diagnostics.map(l.Diagnostic.from),edit:nt.edit&&l.WorkspaceEdit.from(nt.edit,void 0),kind:nt.kind&&nt.kind.value,isPreferred:nt.isPreferred,isAI:(0,t.$lF)(this.m,"codeActionAI")?nt.isAI:!1,disabled:nt.disabled?.reason})))}return{cacheId:xe,actions:st}}async resolveCodeAction(W,J){const[ce,de]=W,ee=this.e.get(ce,de);if(!ee||T.o(ee))return{};if(!this.k.resolveCodeAction)return{};const $e=await this.k.resolveCodeAction(ee,J)??ee;let ve;$e.edit&&(ve=l.WorkspaceEdit.from($e.edit,void 0));let Ne;if($e.command){const qe=this.f.get(ce);qe&&(Ne=this.h.toInternal($e.command,qe))}return{edit:ve,command:Ne}}releaseCodeActions(W){this.f.get(W)?.dispose(),this.f.delete(W),this.e.delete(W)}static o(W){return typeof W.command=="string"&&typeof W.title=="string"}}T.d=1e3;class N{static toInternalProviderId(W,J){return W+"."+J}constructor(W,J,ce,de,ee){this.d=W,this.e=J,this.f=ce,this.g=de,this.h=ee}async prepareDocumentPaste(W,J,ce,de){if(!this.f.prepareDocumentPaste)return;const ee=this.e.getDocument(W),$e=J.map(qe=>l.Range.to(qe)),ve=l.DataTransfer.toDataTransfer(ce,()=>{throw new f.$$});if(await this.f.prepareDocumentPaste(ee,$e,ve,de),de.isCancellationRequested)return;const Ne=Array.from(ve).filter(([,qe])=>!(qe instanceof L.$gL));return l.DataTransfer.from(Ne)}async providePasteEdits(W,J,ce,de,ee){if(!this.f.provideDocumentPasteEdits)return;const $e=this.e.getDocument(J),ve=ce.map(xe=>l.Range.to(xe)),Ne=l.DataTransfer.toDataTransfer(de,async xe=>(await this.d.$resolvePasteFileData(this.g,W,xe)).buffer),qe=await this.f.provideDocumentPasteEdits($e,ve,Ne,ee);if(qe)return{label:qe.label??(0,i.localize)(0,null,this.h.displayName||this.h.name),detail:this.h.displayName||this.h.name,yieldTo:qe.yieldTo?.map(xe=>"mimeType"in xe?xe:{providerId:N.toInternalProviderId(xe.extensionId,xe.providerId)}),insertText:typeof qe.insertText=="string"?qe.insertText:{snippet:qe.insertText.value},additionalEdit:qe.additionalEdit?l.WorkspaceEdit.from(qe.additionalEdit,void 0):void 0}}}class j{constructor(W,J){this.d=W,this.e=J}async provideDocumentFormattingEdits(W,J,ce){const de=this.d.getDocument(W),ee=await this.e.provideDocumentFormattingEdits(de,J,ce);if(Array.isArray(ee))return ee.map(l.TextEdit.from)}}class U{constructor(W,J){this.d=W,this.e=J}async provideDocumentRangeFormattingEdits(W,J,ce,de){const ee=this.d.getDocument(W),$e=l.Range.to(J),ve=await this.e.provideDocumentRangeFormattingEdits(ee,$e,ce,de);if(Array.isArray(ve))return ve.map(l.TextEdit.from)}async provideDocumentRangesFormattingEdits(W,J,ce,de){(0,P.$Jf)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const ee=this.d.getDocument(W),$e=J.map(l.Range.to),ve=await this.e.provideDocumentRangesFormattingEdits(ee,$e,ce,de);if(Array.isArray(ve))return ve.map(l.TextEdit.from)}}class B{constructor(W,J){this.d=W,this.e=J,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(W,J,ce,de,ee){const $e=this.d.getDocument(W),ve=l.Position.to(J),Ne=await this.e.provideOnTypeFormattingEdits($e,ve,ce,de,ee);if(Array.isArray(Ne))return Ne.map(l.TextEdit.from)}}class he{constructor(W,J){this.e=W,this.f=J,this.d=new d.$Ccc("WorkspaceSymbols")}async provideWorkspaceSymbols(W,J){const ce=await this.e.provideWorkspaceSymbols(W,J);if(!(0,R.$Lb)(ce))return{symbols:[]};const de=this.d.add(ce),ee={cacheId:de,symbols:[]};for(let $e=0;$e<ce.length;$e++){const ve=ce[$e];if(!ve||!ve.name){this.f.warn("INVALID SymbolInformation",ve);continue}ee.symbols.push({...l.WorkspaceSymbol.from(ve),cacheId:[de,$e]})}return ee}async resolveWorkspaceSymbol(W,J){if(typeof this.e.resolveWorkspaceSymbol!="function"||!W.cacheId)return W;const ce=this.d.get(...W.cacheId);if(ce){const de=await this.e.resolveWorkspaceSymbol(ce,J);return de&&(0,M.$_m)(W,l.WorkspaceSymbol.from(de),!0)}}releaseWorkspaceSymbols(W){this.d.delete(W)}}class x{static supportsResolving(W){return typeof W.prepareRename=="function"}constructor(W,J,ce){this.d=W,this.e=J,this.f=ce}async provideRenameEdits(W,J,ce,de){const ee=this.d.getDocument(W),$e=l.Position.to(J);try{const ve=await this.e.provideRenameEdits(ee,$e,ce,de);return ve?l.WorkspaceEdit.from(ve):void 0}catch(ve){const Ne=x.g(ve);return Ne?{rejectReason:Ne,edits:void 0}:Promise.reject(ve)}}async resolveRenameLocation(W,J,ce){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const de=this.d.getDocument(W),ee=l.Position.to(J);try{const $e=await this.e.prepareRename(de,ee,ce);let ve,Ne;if(L.$uK.isRange($e)?(ve=$e,Ne=de.getText($e)):(0,P.$Bf)($e)&&(ve=$e.range,Ne=$e.placeholder),!ve||!Ne)return;if(ve.start.line>ee.line||ve.end.line<ee.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:l.Range.from(ve),text:Ne}}catch($e){const ve=x.g($e);return ve?{rejectReason:ve,range:void 0,text:void 0}:Promise.reject($e)}}static g(W){return typeof W=="string"?W:W instanceof Error&&typeof W.message=="string"?W.message:void 0}}class Q{constructor(W,J){this.resultId=W,this.tokens=J}}class Z{constructor(W,J){this.f=W,this.g=J,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(W,J,ce){const de=this.f.getDocument(W),ee=J!==0?this.d.get(J):null;let $e=typeof ee?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(de,ee.resultId,ce):await this.g.provideDocumentSemanticTokens(de,ce);return ee&&this.d.delete(J),$e?($e=Z.h($e),this.o(Z.n(ee,$e),$e)):null}async releaseDocumentSemanticColoring(W){this.d.delete(W)}static h(W){return Z.j(W)?Z.k(W)?W:new L.$JL(new Uint32Array(W.data),W.resultId):Z.l(W)?Z.m(W)?W:new L.$LL(W.edits.map(J=>new L.$KL(J.start,J.deleteCount,J.data?new Uint32Array(J.data):J.data)),W.resultId):W}static j(W){return W&&!!W.data}static k(W){return W.data instanceof Uint32Array}static l(W){return W&&Array.isArray(W.edits)}static m(W){for(const J of W.edits)if(!(J.data instanceof Uint32Array))return!1;return!0}static n(W,J){if(!Z.j(J)||!W||!W.tokens)return J;const ce=W.tokens,de=ce.length,ee=J.data,$e=ee.length;let ve=0;const Ne=Math.min(de,$e);for(;ve<Ne&&ce[ve]===ee[ve];)ve++;if(ve===de&&ve===$e)return new L.$LL([],J.resultId);let qe=0;const xe=Ne-ve;for(;qe<xe&&ce[de-qe-1]===ee[$e-qe-1];)qe++;return new L.$LL([{start:ve,deleteCount:de-ve-qe,data:ee.subarray(ve,$e-qe)}],J.resultId)}o(W,J){if(Z.j(W)){const ce=this.e++;return this.d.set(ce,new Q(W.resultId,W.data)),(0,h.$b$)({id:ce,type:"full",data:W.data})}if(Z.l(W)){const ce=this.e++;return Z.j(J)?this.d.set(ce,new Q(J.resultId,J.data)):this.d.set(ce,new Q(W.resultId)),(0,h.$b$)({id:ce,type:"delta",deltas:(W.edits||[]).map(de=>({start:de.start,deleteCount:de.deleteCount,data:de.data}))})}return null}}class ie{constructor(W,J){this.d=W,this.e=J}async provideDocumentRangeSemanticTokens(W,J,ce){const de=this.d.getDocument(W),ee=await this.e.provideDocumentRangeSemanticTokens(de,l.Range.to(J),ce);return ee?this.f(ee):null}f(W){return(0,h.$b$)({id:0,type:"full",data:W.data})}}class _{static supportsResolving(W){return typeof W.resolveCompletionItem=="function"}constructor(W,J,ce,de,ee){this.f=W,this.g=J,this.h=ce,this.j=de,this.k=ee,this.d=new d.$Ccc("CompletionItem"),this.e=new Map}async provideCompletionItems(W,J,ce,de){const ee=this.f.getDocument(W),$e=l.Position.to(J),ve=ee.getWordRangeAtPosition($e)||new L.$uK($e,$e),Ne=ve.with({end:$e}),qe=new c.$Kd,xe=await this.h.provideCompletionItems(ee,$e,de,l.CompletionContext.to(ce));if(!xe||de.isCancellationRequested)return;const Ge=Array.isArray(xe)?new L.$ZK(xe):xe,st=_.supportsResolving(this.h)?this.d.add(Ge.items):this.d.add([]),it=new E.$Rc;this.e.set(st,it);const nt=[],Ae={x:st,b:nt,a:{replace:l.Range.from(ve),insert:l.Range.from(Ne)},c:Ge.isIncomplete||void 0,d:qe.elapsed()};for(let Oe=0;Oe<Ge.items.length;Oe++){const Re=Ge.items[Oe],Qe=this.l(Re,[st,Oe],Ne,ve);nt.push(Qe)}return Ae}async resolveCompletionItem(W,J){if(typeof this.h.resolveCompletionItem!="function")return;const ce=this.d.get(...W);if(!ce)return;const de=this.l(ce,W),ee=await this.h.resolveCompletionItem(ce,J);if(!ee)return;const $e=this.l(ee,W);return(de.h!==$e.h||de.i!==$e.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(de.n!==$e.n||de.o!==$e.o||!(0,M.$an)(de.p,$e.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...de,d:$e.d,c:$e.c,l:$e.l,h:$e.h,i:$e.i,n:$e.n,o:$e.o,p:$e.p}}releaseCompletionItems(W){this.e.get(W)?.dispose(),this.e.delete(W),this.d.delete(W)}l(W,J,ce,de){const ee=this.e.get(J[0]);if(!ee)throw Error("DisposableStore is missing...");const $e=this.g.toInternal(W.command,ee),ve={x:J,a:W.label,b:W.kind!==void 0?l.CompletionItemKind.from(W.kind):void 0,m:W.tags&&W.tags.map(l.CompletionItemTag.from),c:W.detail,d:typeof W.documentation>"u"?void 0:l.MarkdownString.fromStrict(W.documentation),e:W.sortText!==W.label?W.sortText:void 0,f:W.filterText!==W.label?W.filterText:void 0,g:W.preselect||void 0,i:W.keepWhitespace?1:0,k:W.commitCharacters?.join(""),l:W.additionalTextEdits&&W.additionalTextEdits.map(l.TextEdit.from),n:$e?.$ident,o:$e?.id,p:$e?.$ident?void 0:$e?.arguments};W.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),ve.h=W.textEdit.newText):typeof W.insertText=="string"?ve.h=W.insertText:W.insertText instanceof L.$DK&&(ve.h=W.insertText.value,ve.i|=4);let Ne;return W.textEdit?Ne=W.textEdit.range:W.range&&(Ne=W.range),L.$uK.isRange(Ne)?ve.j=l.Range.from(Ne):Ne&&(!ce?.isEqual(Ne.inserting)||!de?.isEqual(Ne.replacing))&&(ve.j={insert:l.Range.from(Ne.inserting),replace:l.Range.from(Ne.replacing)}),ve}}class oe{async provideInlineCompletions(W,J,ce,de){}disposeCompletions(W){}handleDidShowCompletionItem(W,J,ce){}handlePartialAccept(W,J,ce){}}class ye extends oe{constructor(W,J,ce,de){super(),this.f=W,this.g=J,this.h=ce,this.j=de,this.d=new fe,this.e=(0,t.$lF)(this.f,"inlineCompletionsAdditions"),this.k={[A.InlineCompletionTriggerKind.Automatic]:L.InlineCompletionTriggerKind.Automatic,[A.InlineCompletionTriggerKind.Explicit]:L.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,t.$lF)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(W,J,ce,de){const ee=this.g.getDocument(W),$e=l.Position.to(J),ve=await this.h.provideInlineCompletionItems(ee,$e,{selectedCompletionInfo:ce.selectedSuggestionInfo?{range:l.Range.to(ce.selectedSuggestionInfo.range),text:ce.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[ce.triggerKind]},de);if(!ve||de.isCancellationRequested)return;const Ne=Array.isArray(ve)?ve:ve.items,qe=this.e?Array.isArray(ve)?[]:ve.commands||[]:[],xe=this.e&&!Array.isArray(ve)?ve.enableForwardStability:void 0;let Ge;return{pid:this.d.createReferenceId({dispose(){Ge?.dispose()},items:Ne}),items:Ne.map((it,nt)=>{let Ae;it.command&&(Ge||(Ge=new E.$Rc),Ae=this.j.toInternal(it.command,Ge));const Oe=it.insertText;return{insertText:typeof Oe=="string"?Oe:{snippet:Oe.value},filterText:it.filterText,range:it.range?l.Range.from(it.range):void 0,command:Ae,idx:nt,completeBracketPairs:this.e?it.completeBracketPairs:!1}}),commands:qe.map(it=>(Ge||(Ge=new E.$Rc),this.j.toInternal(it,Ge))),suppressSuggestions:!1,enableForwardStability:xe}}disposeCompletions(W){this.d.disposeReferenceId(W)?.dispose()}handleDidShowCompletionItem(W,J,ce){const de=this.d.get(W)?.items[J];de&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(de,ce)}handlePartialAccept(W,J,ce){const de=this.d.get(W)?.items[J];de&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&this.h.handleDidPartiallyAcceptCompletionItem(de,ce)}}class fe{constructor(){this.d=new Map,this.e=1}createReferenceId(W){const J=this.e++;return this.d.set(J,W),J}disposeReferenceId(W){const J=this.d.get(W);return this.d.delete(W),J}get(W){return this.d.get(W)}}class V{constructor(W,J){this.e=W,this.f=J,this.d=new d.$Ccc("SignatureHelp")}async provideSignatureHelp(W,J,ce,de){const ee=this.e.getDocument(W),$e=l.Position.to(J),ve=this.g(ce),Ne=await this.f.provideSignatureHelp(ee,$e,de,ve);if(Ne){const qe=this.d.add([Ne]);return{...l.SignatureHelp.from(Ne),id:qe}}}g(W){let J;if(W.activeSignatureHelp){const ce=l.SignatureHelp.to(W.activeSignatureHelp),de=this.d.get(W.activeSignatureHelp.id,0);de?(J=de,J.activeSignature=ce.activeSignature,J.activeParameter=ce.activeParameter):J=ce}return{...W,activeSignatureHelp:J}}releaseSignatureHelp(W){this.d.delete(W)}}class le{constructor(W,J,ce,de,ee){this.f=W,this.g=J,this.h=ce,this.j=de,this.k=ee,this.d=new d.$Ccc("InlayHints"),this.e=new Map}async provideInlayHints(W,J,ce){const de=this.f.getDocument(W),ee=l.Range.to(J),$e=await this.h.provideInlayHints(de,ee,ce);if(!Array.isArray($e)||$e.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for ${J}`);return}if(ce.isCancellationRequested)return;const ve=this.d.add($e);this.e.set(ve,new E.$Rc);const Ne={hints:[],cacheId:ve};for(let qe=0;qe<$e.length;qe++)this.l($e[qe],ee)&&Ne.hints.push(this.m($e[qe],[ve,qe]));return this.j.trace(`[InlayHints] ${Ne.hints.length} inlay hints from '${this.k.identifier.value}' for ${J}`),Ne}async resolveInlayHint(W,J){if(typeof this.h.resolveInlayHint!="function")return;const ce=this.d.get(...W);if(!ce)return;const de=await this.h.resolveInlayHint(ce,J);if(de&&this.l(de))return this.m(de,W)}releaseHints(W){this.e.get(W)?.dispose(),this.e.delete(W),this.d.delete(W)}l(W,J){return W.label.length===0||Array.isArray(W.label)&&W.label.every(ce=>ce.value.length===0)?(console.log("INVALID inlay hint, empty label",W),!1):!(J&&!J.contains(W.position))}m(W,J){const ce=this.e.get(J[0]);if(!ce)throw Error("DisposableStore is missing...");const de={label:"",cacheId:J,tooltip:l.MarkdownString.fromStrict(W.tooltip),position:l.Position.from(W.position),textEdits:W.textEdits&&W.textEdits.map(l.TextEdit.from),kind:W.kind&&l.InlayHintKind.from(W.kind),paddingLeft:W.paddingLeft,paddingRight:W.paddingRight};return typeof W.label=="string"?de.label=W.label:de.label=W.label.map(ee=>{const $e={label:ee.value};return $e.tooltip=l.MarkdownString.fromStrict(ee.tooltip),L.$EK.isLocation(ee.location)&&($e.location=l.location.from(ee.location)),ee.command&&($e.command=this.g.toInternal(ee.command,ce)),$e}),de}}class H{constructor(W,J){this.e=W,this.f=J,this.d=new d.$Ccc("DocumentLink")}async provideLinks(W,J){const ce=this.e.getDocument(W),de=await this.f.provideDocumentLinks(ce,J);if(!(!Array.isArray(de)||de.length===0)&&!J.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:de.filter(H.g).map(l.DocumentLink.from)};{const ee=this.d.add(de),$e={links:[],cacheId:ee};for(let ve=0;ve<de.length;ve++){if(!H.g(de[ve]))continue;const Ne=l.DocumentLink.from(de[ve]);Ne.cacheId=[ee,ve],$e.links.push(Ne)}return $e}}}static g(W){return W.target&&W.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(W,J){if(typeof this.f.resolveDocumentLink!="function")return;const ce=this.d.get(...W);if(!ce)return;const de=await this.f.resolveDocumentLink(ce,J);if(!(!de||!H.g(de)))return l.DocumentLink.from(de)}releaseLinks(W){this.d.delete(W)}}class G{constructor(W,J){this.d=W,this.e=J}async provideColors(W,J){const ce=this.d.getDocument(W),de=await this.e.provideDocumentColors(ce,J);return Array.isArray(de)?de.map($e=>({color:l.Color.from($e.color),range:l.Range.from($e.range)})):[]}async provideColorPresentations(W,J,ce){const de=this.d.getDocument(W),ee=l.Range.to(J.range),$e=l.Color.to(J.color),ve=await this.e.provideColorPresentations($e,{document:de,range:ee},ce);if(Array.isArray(ve))return ve.map(l.ColorPresentation.from)}}class Y{constructor(W,J){this.d=W,this.e=J}async provideFoldingRanges(W,J,ce){const de=this.d.getDocument(W),ee=await this.e.provideFoldingRanges(de,J,ce);if(Array.isArray(ee))return ee.map(l.FoldingRange.from)}}class X{constructor(W,J,ce){this.d=W,this.e=J,this.f=ce}async provideSelectionRanges(W,J,ce){const de=this.d.getDocument(W),ee=J.map(l.Position.to),$e=await this.e.provideSelectionRanges(de,ee,ce);if(!(0,R.$Lb)($e))return[];if($e.length!==ee.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const ve=[];for(let Ne=0;Ne<ee.length;Ne++){const qe=[];ve.push(qe);let xe=ee[Ne],Ge=$e[Ne];for(;;){if(!Ge.range.contains(xe))throw new Error("INVALID selection range, must contain the previous range");if(qe.push(l.SelectionRange.from(Ge)),!Ge.parent)break;xe=Ge.range,Ge=Ge.parent}}return ve}}class be{constructor(W,J){this.f=W,this.g=J,this.d=new u.$wM(""),this.e=new Map}async prepareSession(W,J,ce){const de=this.f.getDocument(W),ee=l.Position.to(J),$e=await this.g.prepareCallHierarchy(de,ee,ce);if(!$e)return;const ve=this.d.nextId();return this.e.set(ve,new Map),Array.isArray($e)?$e.map(Ne=>this.h(ve,Ne)):[this.h(ve,$e)]}async provideCallsTo(W,J,ce){const de=this.j(W,J);if(!de)throw new Error("missing call hierarchy item");const ee=await this.g.provideCallHierarchyIncomingCalls(de,ce);if(ee)return ee.map($e=>({from:this.h(W,$e.from),fromRanges:$e.fromRanges.map(ve=>l.Range.from(ve))}))}async provideCallsFrom(W,J,ce){const de=this.j(W,J);if(!de)throw new Error("missing call hierarchy item");const ee=await this.g.provideCallHierarchyOutgoingCalls(de,ce);if(ee)return ee.map($e=>({to:this.h(W,$e.to),fromRanges:$e.fromRanges.map(ve=>l.Range.from(ve))}))}releaseSession(W){this.e.delete(W)}h(W,J){const ce=this.e.get(W),de=l.CallHierarchyItem.from(J,W,ce.size.toString(36));return ce.set(de._itemId,J),de}j(W,J){return this.e.get(W)?.get(J)}}class se{constructor(W,J){this.f=W,this.g=J,this.d=new u.$wM(""),this.e=new Map}async prepareSession(W,J,ce){const de=this.f.getDocument(W),ee=l.Position.to(J),$e=await this.g.prepareTypeHierarchy(de,ee,ce);if(!$e)return;const ve=this.d.nextId();return this.e.set(ve,new Map),Array.isArray($e)?$e.map(Ne=>this.h(ve,Ne)):[this.h(ve,$e)]}async provideSupertypes(W,J,ce){const de=this.j(W,J);if(!de)throw new Error("missing type hierarchy item");const ee=await this.g.provideTypeHierarchySupertypes(de,ce);if(ee)return ee.map($e=>this.h(W,$e))}async provideSubtypes(W,J,ce){const de=this.j(W,J);if(!de)throw new Error("missing type hierarchy item");const ee=await this.g.provideTypeHierarchySubtypes(de,ce);if(ee)return ee.map($e=>this.h(W,$e))}releaseSession(W){this.e.delete(W)}h(W,J){const ce=this.e.get(W),de=l.TypeHierarchyItem.from(J,W,ce.size.toString(36));return ce.set(de._itemId,J),de}j(W,J){return this.e.get(W)?.get(J)}}class ge{static toInternalProviderId(W,J){return W+"."+J}constructor(W,J,ce,de,ee){this.d=W,this.e=J,this.f=ce,this.g=de,this.h=ee}async provideDocumentOnDropEdits(W,J,ce,de,ee){const $e=this.e.getDocument(J),ve=l.Position.to(ce),Ne=l.DataTransfer.toDataTransfer(de,async xe=>(await this.d.$resolveDocumentOnDropFileData(this.g,W,xe)).buffer),qe=await this.f.provideDocumentDropEdits($e,ve,Ne,ee);if(qe)return{label:qe.label??(0,i.localize)(1,null,this.h.displayName||this.h.name),yieldTo:qe.yieldTo?.map(xe=>"mimeType"in xe?xe:{providerId:ge.toInternalProviderId(xe.extensionId,xe.providerId)}),insertText:typeof qe.insertText=="string"?qe.insertText:{snippet:qe.insertText.value},additionalEdit:qe.additionalEdit?l.WorkspaceEdit.from(qe.additionalEdit,void 0):void 0}}}class te{constructor(W,J){this.d=W,this.e=J}async provideMappedEdits(W,J,ce,de){const ee=y.URI.revive(W),$e=this.d.getDocument(ee),ve=ce.documents.map(xe=>xe.map(Ge=>({uri:y.URI.revive(Ge.uri),version:Ge.version,ranges:Ge.ranges.map(st=>l.Range.to(st))}))),Ne={documents:ve,selections:ve[0]?.[0]?.ranges??[]},qe=await this.e.provideMappedEdits($e,J,Ne,de);return qe?l.WorkspaceEdit.from(qe):null}}class me{constructor(W,J){this.adapter=W,this.extension=J}}class we{constructor(W,J,ce,de,ee,$e,ve,Ne){this.g=J,this.h=ce,this.j=de,this.k=ee,this.l=$e,this.m=ve,this.n=Ne,this.f=new Map,this.e=W.getProxy(g.$qK.MainThreadLanguageFeatures)}o(W,J){return l.DocumentSelector.from(W,this.g,J)}p(W){return new L.$sK(()=>{this.f.delete(W),this.e.$unregister(W)})}q(){return we.d++}async s(W,J,ce,de,ee,$e=!1){const ve=this.f.get(W);if(!ve||!(ve.adapter instanceof J))return de;const Ne=Date.now();$e||this.l.trace(`[${ve.extension.identifier.value}] INVOKE provider '${ce.toString().replace(/[\r\n]/g,"")}'`);const qe=ce(ve.adapter,ve.extension);return Promise.resolve(qe).catch(xe=>{(0,f.$4)(xe)||(this.l.error(`[${ve.extension.identifier.value}] provider FAILED`),this.l.error(xe),this.n.onExtensionError(ve.extension.identifier,xe))}).finally(()=>{$e||this.l.trace(`[${ve.extension.identifier.value}] provider DONE after ${Date.now()-Ne}ms`)}),S.CancellationToken.isCancellationToken(ee)?(0,a.$Kg)(qe,ee):qe}t(W,J){const ce=this.q();return this.f.set(ce,new me(W,J)),ce}static u(W){return W.displayName||W.name}registerDocumentSymbolProvider(W,J,ce,de){const ee=this.t(new s(this.h,ce),W),$e=de&&de.label||we.u(W);return this.e.$registerDocumentSymbolProvider(ee,this.o(J,W),$e),this.p(ee)}$provideDocumentSymbols(W,J,ce){return this.s(W,s,de=>de.provideDocumentSymbols(y.URI.revive(J),ce),void 0,ce)}registerCodeLensProvider(W,J,ce){const de=this.q(),ee=typeof ce.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(de,new me(new n(this.h,this.j.converter,ce),W)),this.e.$registerCodeLensSupport(de,this.o(J,W),ee);let $e=this.p(de);if(ee!==void 0){const ve=ce.onDidChangeCodeLenses(Ne=>this.e.$emitCodeLensEvent(ee));$e=L.$sK.from($e,ve)}return $e}$provideCodeLenses(W,J,ce){return this.s(W,n,de=>de.provideCodeLenses(y.URI.revive(J),ce),void 0,ce)}$resolveCodeLens(W,J,ce){return this.s(W,n,de=>de.resolveCodeLens(J,ce),void 0,void 0)}$releaseCodeLenses(W,J){this.s(W,n,ce=>Promise.resolve(ce.releaseCodeLenses(J)),void 0,void 0)}registerDefinitionProvider(W,J,ce){const de=this.t(new o(this.h,ce),W);return this.e.$registerDefinitionSupport(de,this.o(J,W)),this.p(de)}$provideDefinition(W,J,ce,de){return this.s(W,o,ee=>ee.provideDefinition(y.URI.revive(J),ce,de),[],de)}registerDeclarationProvider(W,J,ce){const de=this.t(new v(this.h,ce),W);return this.e.$registerDeclarationSupport(de,this.o(J,W)),this.p(de)}$provideDeclaration(W,J,ce,de){return this.s(W,v,ee=>ee.provideDeclaration(y.URI.revive(J),ce,de),[],de)}registerImplementationProvider(W,J,ce){const de=this.t(new C(this.h,ce),W);return this.e.$registerImplementationSupport(de,this.o(J,W)),this.p(de)}$provideImplementation(W,J,ce,de){return this.s(W,C,ee=>ee.provideImplementation(y.URI.revive(J),ce,de),[],de)}registerTypeDefinitionProvider(W,J,ce){const de=this.t(new w(this.h,ce),W);return this.e.$registerTypeDefinitionSupport(de,this.o(J,W)),this.p(de)}$provideTypeDefinition(W,J,ce,de){return this.s(W,w,ee=>ee.provideTypeDefinition(y.URI.revive(J),ce,de),[],de)}registerHoverProvider(W,J,ce,de){const ee=this.t(new m(this.h,ce),W);return this.e.$registerHoverProvider(ee,this.o(J,W)),this.p(ee)}$provideHover(W,J,ce,de){return this.s(W,m,ee=>ee.provideHover(y.URI.revive(J),ce,de),void 0,de)}registerEvaluatableExpressionProvider(W,J,ce,de){const ee=this.t(new b(this.h,ce),W);return this.e.$registerEvaluatableExpressionProvider(ee,this.o(J,W)),this.p(ee)}$provideEvaluatableExpression(W,J,ce,de){return this.s(W,b,ee=>ee.provideEvaluatableExpression(y.URI.revive(J),ce,de),void 0,de)}registerInlineValuesProvider(W,J,ce,de){const ee=typeof ce.onDidChangeInlineValues=="function"?this.q():void 0,$e=this.t(new I(this.h,ce),W);this.e.$registerInlineValuesProvider($e,this.o(J,W),ee);let ve=this.p($e);if(ee!==void 0){const Ne=ce.onDidChangeInlineValues(qe=>this.e.$emitInlineValuesEvent(ee));ve=L.$sK.from(ve,Ne)}return ve}$provideInlineValues(W,J,ce,de,ee){return this.s(W,I,$e=>$e.provideInlineValues(y.URI.revive(J),ce,de,ee),void 0,ee)}registerDocumentHighlightProvider(W,J,ce){const de=this.t(new z(this.h,ce),W);return this.e.$registerDocumentHighlightProvider(de,this.o(J,W)),this.p(de)}$provideDocumentHighlights(W,J,ce,de){return this.s(W,z,ee=>ee.provideDocumentHighlights(y.URI.revive(J),ce,de),void 0,de)}registerLinkedEditingRangeProvider(W,J,ce){const de=this.t(new O(this.h,ce),W);return this.e.$registerLinkedEditingRangeProvider(de,this.o(J,W)),this.p(de)}$provideLinkedEditingRanges(W,J,ce,de){return this.s(W,O,async ee=>{const $e=await ee.provideLinkedEditingRanges(y.URI.revive(J),ce,de);if($e)return{ranges:$e.ranges,wordPattern:$e.wordPattern?we.w($e.wordPattern):void 0}},void 0,de)}registerReferenceProvider(W,J,ce){const de=this.t(new F(this.h,ce),W);return this.e.$registerReferenceSupport(de,this.o(J,W)),this.p(de)}$provideReferences(W,J,ce,de,ee){return this.s(W,F,$e=>$e.provideReferences(y.URI.revive(J),ce,de,ee),void 0,ee)}registerCodeActionProvider(W,J,ce,de){const ee=new E.$Rc,$e=this.t(new T(this.h,this.j.converter,this.k,ce,this.l,W,this.m),W);return this.e.$registerQuickFixSupport($e,this.o(J,W),{providedKinds:de?.providedCodeActionKinds?.map(ve=>ve.value),documentation:de?.documentation?.map(ve=>({kind:ve.kind.value,command:this.j.converter.toInternal(ve.command,ee)}))},we.u(W),!!ce.resolveCodeAction),ee.add(this.p($e)),ee}$provideCodeActions(W,J,ce,de,ee){return this.s(W,T,$e=>$e.provideCodeActions(y.URI.revive(J),ce,de,ee),void 0,ee)}$resolveCodeAction(W,J,ce){return this.s(W,T,de=>de.resolveCodeAction(J,ce),{},void 0)}$releaseCodeActions(W,J){this.s(W,T,ce=>Promise.resolve(ce.releaseCodeActions(J)),void 0,void 0)}registerDocumentFormattingEditProvider(W,J,ce){const de=this.t(new j(this.h,ce),W);return this.e.$registerDocumentFormattingSupport(de,this.o(J,W),W.identifier,W.displayName||W.name),this.p(de)}$provideDocumentFormattingEdits(W,J,ce,de){return this.s(W,j,ee=>ee.provideDocumentFormattingEdits(y.URI.revive(J),ce,de),void 0,de)}registerDocumentRangeFormattingEditProvider(W,J,ce){const de=typeof ce.provideDocumentRangesFormattingEdits=="function",ee=this.t(new U(this.h,ce),W);return this.e.$registerRangeFormattingSupport(ee,this.o(J,W),W.identifier,W.displayName||W.name,de),this.p(ee)}$provideDocumentRangeFormattingEdits(W,J,ce,de,ee){return this.s(W,U,$e=>$e.provideDocumentRangeFormattingEdits(y.URI.revive(J),ce,de,ee),void 0,ee)}$provideDocumentRangesFormattingEdits(W,J,ce,de,ee){return this.s(W,U,$e=>$e.provideDocumentRangesFormattingEdits(y.URI.revive(J),ce,de,ee),void 0,ee)}registerOnTypeFormattingEditProvider(W,J,ce,de){const ee=this.t(new B(this.h,ce),W);return this.e.$registerOnTypeFormattingSupport(ee,this.o(J,W),de,W.identifier),this.p(ee)}$provideOnTypeFormattingEdits(W,J,ce,de,ee,$e){return this.s(W,B,ve=>ve.provideOnTypeFormattingEdits(y.URI.revive(J),ce,de,ee,$e),void 0,$e)}registerWorkspaceSymbolProvider(W,J){const ce=this.t(new he(J,this.l),W);return this.e.$registerNavigateTypeSupport(ce,typeof J.resolveWorkspaceSymbol=="function"),this.p(ce)}$provideWorkspaceSymbols(W,J,ce){return this.s(W,he,de=>de.provideWorkspaceSymbols(J,ce),{symbols:[]},ce)}$resolveWorkspaceSymbol(W,J,ce){return this.s(W,he,de=>de.resolveWorkspaceSymbol(J,ce),void 0,void 0)}$releaseWorkspaceSymbols(W,J){this.s(W,he,ce=>ce.releaseWorkspaceSymbols(J),void 0,void 0)}registerRenameProvider(W,J,ce){const de=this.t(new x(this.h,ce,this.l),W);return this.e.$registerRenameSupport(de,this.o(J,W),x.supportsResolving(ce)),this.p(de)}$provideRenameEdits(W,J,ce,de,ee){return this.s(W,x,$e=>$e.provideRenameEdits(y.URI.revive(J),ce,de,ee),void 0,ee)}$resolveRenameLocation(W,J,ce,de){return this.s(W,x,ee=>ee.resolveRenameLocation(y.URI.revive(J),ce,de),void 0,de)}registerDocumentSemanticTokensProvider(W,J,ce,de){const ee=this.t(new Z(this.h,ce),W),$e=typeof ce.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(ee,this.o(J,W),de,$e);let ve=this.p(ee);if($e){const Ne=ce.onDidChangeSemanticTokens(qe=>this.e.$emitDocumentSemanticTokensEvent($e));ve=L.$sK.from(ve,Ne)}return ve}$provideDocumentSemanticTokens(W,J,ce,de){return this.s(W,Z,ee=>ee.provideDocumentSemanticTokens(y.URI.revive(J),ce,de),null,de)}$releaseDocumentSemanticTokens(W,J){this.s(W,Z,ce=>ce.releaseDocumentSemanticColoring(J),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(W,J,ce,de){const ee=this.t(new ie(this.h,ce),W);return this.e.$registerDocumentRangeSemanticTokensProvider(ee,this.o(J,W),de),this.p(ee)}$provideDocumentRangeSemanticTokens(W,J,ce,de){return this.s(W,ie,ee=>ee.provideDocumentRangeSemanticTokens(y.URI.revive(J),ce,de),null,de)}registerCompletionItemProvider(W,J,ce,de){const ee=this.t(new _(this.h,this.j.converter,ce,this.m,W),W);return this.e.$registerCompletionsProvider(ee,this.o(J,W),de,_.supportsResolving(ce),W.identifier),this.p(ee)}$provideCompletionItems(W,J,ce,de,ee){return this.s(W,_,$e=>$e.provideCompletionItems(y.URI.revive(J),ce,de,ee),void 0,ee)}$resolveCompletionItem(W,J,ce){return this.s(W,_,de=>de.resolveCompletionItem(J,ce),void 0,ce)}$releaseCompletionItems(W,J){this.s(W,_,ce=>ce.releaseCompletionItems(J),void 0,void 0)}registerInlineCompletionsProvider(W,J,ce,de){const ee=new ye(W,this.h,ce,this.j.converter),$e=this.t(ee,W);return this.e.$registerInlineCompletionsSupport($e,this.o(J,W),ee.supportsHandleEvents,D.$8l.toKey(W.identifier.value),de?.yieldTo?.map(ve=>D.$8l.toKey(ve))||[]),this.p($e)}$provideInlineCompletions(W,J,ce,de,ee){return this.s(W,oe,$e=>$e.provideInlineCompletions(y.URI.revive(J),ce,de,ee),void 0,ee)}$handleInlineCompletionDidShow(W,J,ce,de){this.s(W,oe,async ee=>{ee.handleDidShowCompletionItem(J,ce,de)},void 0,void 0)}$handleInlineCompletionPartialAccept(W,J,ce,de){this.s(W,oe,async ee=>{ee.handlePartialAccept(J,ce,de)},void 0,void 0)}$freeInlineCompletionsList(W,J){this.s(W,oe,async ce=>{ce.disposeCompletions(J)},void 0,void 0)}registerSignatureHelpProvider(W,J,ce,de){const ee=Array.isArray(de)?{triggerCharacters:de,retriggerCharacters:[]}:de,$e=this.t(new V(this.h,ce),W);return this.e.$registerSignatureHelpProvider($e,this.o(J,W),ee),this.p($e)}$provideSignatureHelp(W,J,ce,de,ee){return this.s(W,V,$e=>$e.provideSignatureHelp(y.URI.revive(J),ce,de,ee),void 0,ee)}$releaseSignatureHelp(W,J){this.s(W,V,ce=>ce.releaseSignatureHelp(J),void 0,void 0)}registerInlayHintsProvider(W,J,ce){const de=typeof ce.onDidChangeInlayHints=="function"?this.q():void 0,ee=this.t(new le(this.h,this.j.converter,ce,this.l,W),W);this.e.$registerInlayHintsProvider(ee,this.o(J,W),typeof ce.resolveInlayHint=="function",de,we.u(W));let $e=this.p(ee);if(de!==void 0){const ve=ce.onDidChangeInlayHints(Ne=>this.e.$emitInlayHintsEvent(de));$e=L.$sK.from($e,ve)}return $e}$provideInlayHints(W,J,ce,de){return this.s(W,le,ee=>ee.provideInlayHints(y.URI.revive(J),ce,de),void 0,de)}$resolveInlayHint(W,J,ce){return this.s(W,le,de=>de.resolveInlayHint(J,ce),void 0,ce)}$releaseInlayHints(W,J){this.s(W,le,ce=>ce.releaseHints(J),void 0,void 0)}registerDocumentLinkProvider(W,J,ce){const de=this.t(new H(this.h,ce),W);return this.e.$registerDocumentLinkProvider(de,this.o(J,W),typeof ce.resolveDocumentLink=="function"),this.p(de)}$provideDocumentLinks(W,J,ce){return this.s(W,H,de=>de.provideLinks(y.URI.revive(J),ce),void 0,ce,J.scheme==="output")}$resolveDocumentLink(W,J,ce){return this.s(W,H,de=>de.resolveLink(J,ce),void 0,void 0,!0)}$releaseDocumentLinks(W,J){this.s(W,H,ce=>ce.releaseLinks(J),void 0,void 0,!0)}registerColorProvider(W,J,ce){const de=this.t(new G(this.h,ce),W);return this.e.$registerDocumentColorProvider(de,this.o(J,W)),this.p(de)}$provideDocumentColors(W,J,ce){return this.s(W,G,de=>de.provideColors(y.URI.revive(J),ce),[],ce)}$provideColorPresentations(W,J,ce,de){return this.s(W,G,ee=>ee.provideColorPresentations(y.URI.revive(J),ce,de),void 0,de)}registerFoldingRangeProvider(W,J,ce){const de=this.q(),ee=typeof ce.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(de,new me(new Y(this.h,ce),W)),this.e.$registerFoldingRangeProvider(de,this.o(J,W),W.identifier,ee);let $e=this.p(de);if(ee!==void 0){const ve=ce.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(ee));$e=L.$sK.from($e,ve)}return $e}$provideFoldingRanges(W,J,ce,de){return this.s(W,Y,ee=>ee.provideFoldingRanges(y.URI.revive(J),ce,de),void 0,de)}registerSelectionRangeProvider(W,J,ce){const de=this.t(new X(this.h,ce,this.l),W);return this.e.$registerSelectionRangeProvider(de,this.o(J,W)),this.p(de)}$provideSelectionRanges(W,J,ce,de){return this.s(W,X,ee=>ee.provideSelectionRanges(y.URI.revive(J),ce,de),[],de)}registerCallHierarchyProvider(W,J,ce){const de=this.t(new be(this.h,ce),W);return this.e.$registerCallHierarchyProvider(de,this.o(J,W)),this.p(de)}$prepareCallHierarchy(W,J,ce,de){return this.s(W,be,ee=>Promise.resolve(ee.prepareSession(y.URI.revive(J),ce,de)),void 0,de)}$provideCallHierarchyIncomingCalls(W,J,ce,de){return this.s(W,be,ee=>ee.provideCallsTo(J,ce,de),void 0,de)}$provideCallHierarchyOutgoingCalls(W,J,ce,de){return this.s(W,be,ee=>ee.provideCallsFrom(J,ce,de),void 0,de)}$releaseCallHierarchy(W,J){this.s(W,be,ce=>Promise.resolve(ce.releaseSession(J)),void 0,void 0)}registerTypeHierarchyProvider(W,J,ce){const de=this.t(new se(this.h,ce),W);return this.e.$registerTypeHierarchyProvider(de,this.o(J,W)),this.p(de)}$prepareTypeHierarchy(W,J,ce,de){return this.s(W,se,ee=>Promise.resolve(ee.prepareSession(y.URI.revive(J),ce,de)),void 0,de)}$provideTypeHierarchySupertypes(W,J,ce,de){return this.s(W,se,ee=>ee.provideSupertypes(J,ce,de),void 0,de)}$provideTypeHierarchySubtypes(W,J,ce,de){return this.s(W,se,ee=>ee.provideSubtypes(J,ce,de),void 0,de)}$releaseTypeHierarchy(W,J){this.s(W,se,ce=>Promise.resolve(ce.releaseSession(J)),void 0,void 0)}registerDocumentOnDropEditProvider(W,J,ce,de){const ee=this.q();this.f.set(ee,new me(new ge(this.e,this.h,ce,ee,W),W));const $e=(0,t.$lF)(W,"dropMetadata")&&de?ge.toInternalProviderId(W.identifier.value,de.id):void 0;return this.e.$registerDocumentOnDropEditProvider(ee,this.o(J,W),$e,(0,t.$lF)(W,"dropMetadata")?de:void 0),this.p(ee)}$provideDocumentOnDropEdits(W,J,ce,de,ee,$e){return this.s(W,ge,ve=>Promise.resolve(ve.provideDocumentOnDropEdits(J,y.URI.revive(ce),de,ee,$e)),void 0,void 0)}registerMappedEditsProvider(W,J,ce){const de=this.t(new te(this.h,ce),W);return this.e.$registerMappedEditsProvider(de,this.o(J,W)),this.p(de)}$provideMappedEdits(W,J,ce,de,ee){return this.s(W,te,$e=>Promise.resolve($e.provideMappedEdits(J,ce,de,ee)),null,ee)}registerDocumentPasteEditProvider(W,J,ce,de){const ee=this.q();this.f.set(ee,new me(new N(this.e,this.h,ce,ee,W),W));const $e=N.toInternalProviderId(W.identifier.value,de.id);return this.e.$registerPasteEditProvider(ee,this.o(J,W),$e,{supportsCopy:!!ce.prepareDocumentPaste,supportsPaste:!!ce.provideDocumentPasteEdits,copyMimeTypes:de.copyMimeTypes,pasteMimeTypes:de.pasteMimeTypes}),this.p(ee)}$prepareDocumentPaste(W,J,ce,de,ee){return this.s(W,N,$e=>$e.prepareDocumentPaste(y.URI.revive(J),ce,de,ee),void 0,ee)}$providePasteEdits(W,J,ce,de,ee,$e){return this.s(W,N,ve=>ve.providePasteEdits(J,y.URI.revive(ce),de,ee,$e),void 0,$e)}static w(W){return{pattern:W.source,flags:W.flags}}static y(W){return{decreaseIndentPattern:we.w(W.decreaseIndentPattern),increaseIndentPattern:we.w(W.increaseIndentPattern),indentNextLinePattern:W.indentNextLinePattern?we.w(W.indentNextLinePattern):void 0,unIndentedLinePattern:W.unIndentedLinePattern?we.w(W.unIndentedLinePattern):void 0}}static z(W){return{beforeText:we.w(W.beforeText),afterText:W.afterText?we.w(W.afterText):void 0,previousLineText:W.previousLineText?we.w(W.previousLineText):void 0,action:W.action}}static B(W){return W.map(we.z)}static C(W){return{open:W.open,close:W.close,notIn:W.notIn?W.notIn.map(J=>L.SyntaxTokenType.toString(J)):void 0}}static D(W){return W.map(we.C)}setLanguageConfiguration(W,J,ce){const{wordPattern:de}=ce;if(de&&(0,k.$Pe)(de))throw new Error(`Invalid language configuration: wordPattern '${de}' is not allowed to match the empty string.`);de?this.h.setWordDefinitionFor(J,de):this.h.setWordDefinitionFor(J,void 0),ce.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",W,"Do not use."),ce.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",W,"Do not use.");const ee=this.q(),$e={comments:ce.comments,brackets:ce.brackets,wordPattern:ce.wordPattern?we.w(ce.wordPattern):void 0,indentationRules:ce.indentationRules?we.y(ce.indentationRules):void 0,onEnterRules:ce.onEnterRules?we.B(ce.onEnterRules):void 0,__electricCharacterSupport:ce.__electricCharacterSupport,__characterPairSupport:ce.__characterPairSupport,autoClosingPairs:ce.autoClosingPairs?we.D(ce.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(ee,J,$e),this.p(ee)}$setWordDefinitions(W){for(const J of W)this.h.setWordDefinitionFor(J.languageId,new RegExp(J.regexSource,J.regexFlags))}}e.$Lcc=we,we.d=0}),define(De[318],Ce([1,0,6,13,7,39,8,3,26]),function(re,e,y,M,l,L,A,g,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tdc=void 0;class ${constructor(P,p,S,D){this.c=p,this.d=S,this.e=D,this.b=[],this.f=0,this.g=new Set,this.a=P.getProxy(y.$qK.MainThreadLanguages)}$acceptLanguageIds(P){this.b=P}async getLanguages(){return this.b.slice(0)}async changeLanguage(P,p){await this.a.$changeLanguage(P,p);const S=this.c.getDocumentData(P);if(!S)throw new Error(`document '${P.toString()}' NOT found`);return S.document}async tokenAtPosition(P,p){const S=P.version,D=M.Position.from(p),E=await this.a.$tokensAtPosition(P.uri,D),h={type:l.StandardTokenType.Other,range:P.getWordRangeAtPosition(p)??new l.$uK(p.line,p.character,p.line,p.character)};if(!E)return h;const u={range:M.Range.to(E.range),type:M.TokenType.to(E.type)};return!u.range.contains(p)||S!==P.version?h:u}createLanguageStatusItem(P,p,S){const D=this.f++,E=this.a,h=this.g,u=`${P.identifier.value}/${p}`;if(h.has(u))throw new Error(`LanguageStatusItem with id '${p}' ALREADY exists`);h.add(u);const d={selector:S,id:p,name:P.displayName??P.name,severity:l.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let c;const f=new g.$Rc,a=()=>{if(c?.dispose(),!h.has(u)){console.warn(`LanguageStatusItem (${p}) from ${P.identifier.value} has been disposed and CANNOT be updated anymore`);return}c=(0,A.$Wg)(()=>{f.clear(),this.a.$setLanguageStatus(D,{id:u,name:d.name??P.displayName??P.name,source:P.displayName??P.name,selector:M.DocumentSelector.from(d.selector,this.e),label:d.text,detail:d.detail??"",severity:d.severity===l.LanguageStatusSeverity.Error?L.default.Error:d.severity===l.LanguageStatusSeverity.Warning?L.default.Warning:L.default.Info,command:d.command&&this.d.toInternal(d.command,f),accessibilityInfo:d.accessibilityInformation,busy:d.busy})},0)},t={dispose(){f.dispose(),c?.dispose(),E.$removeLanguageStatus(D),h.delete(u)},get id(){return d.id},get name(){return d.name},set name(i){d.name=i,a()},get selector(){return d.selector},set selector(i){d.selector=i,a()},get text(){return d.text},set text(i){d.text=i,a()},set text2(i){(0,k.$mF)(P,"languageStatusText"),d.text=i,a()},get text2(){return(0,k.$mF)(P,"languageStatusText"),d.text},get detail(){return d.detail},set detail(i){d.detail=i,a()},get severity(){return d.severity},set severity(i){d.severity=i,a()},get accessibilityInformation(){return d.accessibilityInformation},set accessibilityInformation(i){d.accessibilityInformation=i,a()},get command(){return d.command},set command(i){d.command=i,a()},get busy(){return d.busy},set busy(i){d.busy=i,a()}};return a(),t}}e.$tdc=$}),define(De[113],Ce([1,0,12,16,2,5,14,6,27,20]),function(re,e,y,M,l,L,A,g,k,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jdc=e.$idc=void 0;let R=class{constructor(p,S,D){this.f=D,this.d=new Map,this.a=S.getProxy(g.$qK.MainThreadLocalization),this.b=p.environment.appLanguage,this.c=this.b===y.$a}getMessage(p,S){const{message:D,args:E,comment:h}=S;if(this.c)return(0,M.$Ee)(D,E??{});let u=D;h&&h.length>0&&(u+=`/${Array.isArray(h)?h.join(""):h}`);const d=this.d.get(p)?.contents[u];return d||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${u}`),(0,M.$Ee)(d??D,E??{})}getBundle(p){return this.d.get(p)?.contents}getBundleUri(p){return this.d.get(p)?.uri}async initializeLocalizedMessages(p){if(this.c||!p.l10n&&!p.isBuiltin||this.d.has(p.identifier.value))return;let S;const D=await this.g(p);if(!D){this.f.error(`No bundle location found for extension ${p.identifier.value}`);return}try{const E=await this.a.$fetchBundleContents(D),h=JSON.parse(E);S=p.isBuiltin?h.contents?.bundle:h}catch(E){this.f.error(`Failed to load translations for ${p.identifier.value} from ${D}: ${E.message}`);return}S&&this.d.set(p.identifier.value,{contents:S,uri:D})}async g(p){if(p.isBuiltin){const S=await this.a.$fetchBuiltInBundleUri(p.identifier.value,this.b);return l.URI.revive(S)}return p.l10n?l.URI.joinPath(p.extensionLocation,p.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$idc=R,e.$idc=R=He([We(0,k.$HM),We(1,$.$rM),We(2,A.$$i)],R),e.$jdc=(0,L.$Qh)("IExtHostLocalizationService")}),define(De[151],Ce([1,0,14,6,27,20,2,60]),function(re,e,y,M,l,L,A,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lec=void 0;let k=class extends y.$jj{constructor(P,p){super(p.logLevel,p.logsLocation,p.loggers.map(S=>(0,g.$nh)(S))),this.r=P.getProxy(M.$qK.MainThreadLogger)}$setLogLevel(P,p){p?this.setLogLevel(A.URI.revive(p),P):this.setLogLevel(P)}setVisibility(P,p){super.setVisibility(P,p),this.r.$setVisibility(P,p)}s(P,p,S){return new $(this.r,P,p,S)}};e.$Lec=k,e.$Lec=k=He([We(0,L.$rM),We(1,l.$HM)],k);class $ extends y.$ej{constructor(P,p,S,D){super(D?.logLevel==="always"),this.r=P,this.s=p,this.m=!1,this.n=[],this.setLevel(S),this.r.$createLogger(p,D).then(()=>{this.u(this.n),this.m=!0})}g(P,p){const S=[[P,p]];this.m?this.u(S):this.n.push(...S)}u(P){this.r.$log(this.s,P)}flush(){this.r.$flush(this.s)}}}),define(De[114],Ce([1,0,6,5,3,20,22]),function(re,e,y,M,l,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ldc=e.$kdc=void 0,e.$kdc=(0,M.$Qh)("IExtHostManagedSockets");let g=class{constructor(P){this.b=0,this.c=null,this.d=new Map,this.a=P.getProxy(y.$qK.MainThreadManagedSockets)}setFactory(P,p){for(const S of this.d.values())S.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new k(P,p),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(P){if(!this.c||this.c.socketFactoryId!==P)throw new Error(`No socket factory with id ${P}`);const p=++this.b,S=await this.c.makeConnection(),D=new l.$Rc;return this.d.set(p,new $(p,S,D)),D.add((0,l.$Qc)(()=>this.d.delete(p))),D.add(S.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(p),D.dispose()})),D.add(S.onDidClose(E=>{this.a.$onDidManagedSocketClose(p,E?.stack??E?.message),D.dispose()})),D.add(S.onDidReceiveMessage(E=>this.a.$onDidManagedSocketHaveData(p,A.$ce.wrap(E)))),p}$remoteSocketWrite(P,p){this.d.get(P)?.actual.send(p.buffer)}$remoteSocketEnd(P){const p=this.d.get(P);p&&(p.actual.end(),p.dispose())}async $remoteSocketDrain(P){await this.d.get(P)?.actual.drain?.()}};e.$ldc=g,e.$ldc=g=He([We(0,L.$rM)],g);class k{constructor(P,p){this.socketFactoryId=P,this.makeConnection=p}}class $ extends l.$Sc{constructor(P,p,S){super(),this.socketId=P,this.actual=p,this.B(S)}}}),define(De[319],Ce([1,0,6,14,26]),function(re,e,y,M,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$udc=void 0;function L(g){return g&&g.title}let A=class{constructor(k,$){this.b=$,this.a=k.getProxy(y.$qK.MainThreadMessageService)}showMessage(k,$,R,P,p){const S={source:{identifier:k.identifier,label:k.displayName||k.name}};let D;typeof P=="string"||L(P)?D=[P,...p]:(S.modal=P?.modal,S.useCustom=P?.useCustom,S.detail=P?.detail,D=p),S.useCustom&&(0,l.$mF)(k,"resolvers");const E=[];for(let h=0;h<D.length;h++){const u=D[h];if(typeof u=="string")E.push({title:u,handle:h,isCloseAffordance:!1});else if(typeof u=="object"){const{title:d,isCloseAffordance:c}=u;E.push({title:d,isCloseAffordance:!!c,handle:h})}else this.b.warn("Invalid message item:",u)}return this.a.$showMessage($,R,S,E).then(h=>{if(typeof h=="number")return D[h]})}};e.$udc=A,e.$udc=A=He([We(1,M.$$i)],A)}),define(De[320],Ce([1,0,208,22,4,3,28,16,17,2,30,107,6,34,13,7,69,284,147,9,24,18]),function(re,e,y,M,l,L,A,g,k,$,R,P,p,S,D,E,h,u,d,c,f,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cec=void 0;class t{get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(s=>s.apiEditor)}constructor(s,n,r,o,v){this.q=r,this.r=o,this.s=v,this.f=new Map,this.g=new A.$Ac,this.h=new Map,this.j=new l.$Od({onListenerError:c.$2}),this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new l.$Od({onListenerError:c.$2}),this.onDidOpenNotebookDocument=this.m.event,this.n=new l.$Od({onListenerError:c.$2}),this.onDidCloseNotebookDocument=this.n.event,this.o=new l.$Od({onListenerError:c.$2}),this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new P.$Ccc("NotebookCellStatusBarCache"),this.u=0,this.w=new Map,this.b=s.getProxy(p.$qK.MainThreadNotebook),this.c=s.getProxy(p.$qK.MainThreadNotebookDocuments),this.d=s.getProxy(p.$qK.MainThreadNotebookEditors),this.i=n.converter,n.registerArgumentProcessor({processArgument:C=>{if(C&&C.$mid===13){const w=C.notebookEditor?.notebookUri,m=C.cell.handle,I=this.g.get(w)?.getCell(m);if(I)return I.apiCell}if(C&&C.$mid===14){const w=C.uri,m=this.g.get(w);if(m)return m.apiNotebook}return C}}),t.A(n)}getEditorById(s){const n=this.h.get(s);if(!n)throw new Error(`unknown text editor: ${s}. known editors: ${[...this.h.keys()]} `);return n}getIdByEditor(s){for(const[n,r]of this.h)if(r.apiEditor===s)return n}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(s,n){const r=this.g.get(s);if(!r&&!n)throw new Error(`NO notebook document for '${s}'`);return r}static t(s,n){if(!n)return;const r=n.filenamePattern.map(o=>D.NotebookExclusiveDocumentPattern.from(o)).filter(o=>o!==void 0);if(n.filenamePattern&&!r){console.warn(`Notebook content provider view options file name pattern is invalid ${n.filenamePattern}`);return}return{extension:s.identifier,providerDisplayName:s.displayName||s.name,displayName:n.displayName,filenamePattern:r,exclusive:n.exclusive||!1}}registerNotebookCellStatusBarItemProvider(s,n,r){const o=t.a++,v=typeof r.onDidChangeCellStatusBarItems=="function"?t.a++:void 0;this.f.set(o,r),this.b.$registerNotebookCellStatusBarItemProvider(o,v,n);let C;return v!==void 0&&(C=r.onDidChangeCellStatusBarItems(w=>this.b.$emitCellStatusBarEvent(v))),new E.$sK(()=>{this.f.delete(o),this.b.$unregisterNotebookCellStatusBarItemProvider(o,v),C?.dispose()})}async createNotebookDocument(s){const n=await this.c.$tryCreateNotebook({viewType:s.viewType,content:s.content&&D.NotebookData.from(s.content)});return $.URI.revive(n)}async openNotebookDocument(s){const n=this.g.get(s);if(n)return n.apiNotebook;const r=await this.c.$tryOpenNotebook(s),o=this.g.get($.URI.revive(r));return(0,k.$Kf)(o?.apiNotebook)}async showNotebookDocument(s,n){$.URI.isUri(s)&&(s=await this.openNotebookDocument(s));let r;typeof n=="object"?r={position:D.ViewColumn.from(n.viewColumn),preserveFocus:n.preserveFocus,selections:n.selections&&n.selections.map(D.NotebookRange.from),pinned:typeof n.preview=="boolean"?!n.preview:void 0}:r={preserveFocus:!1};const o=await this.d.$tryShowNotebookDocument(s.uri,s.notebookType,r),v=o&&this.h.get(o)?.apiEditor;if(v)return v;throw o?new Error(`Could NOT open editor for "${s.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${s.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(s,n,r,o){const v=this.f.get(s),C=$.URI.revive(n),w=this.g.get(C);if(!w||!v)return;const m=w.getCellFromIndex(r);if(!m)return;const b=await v.provideCellStatusBarItems(m.apiCell,o);if(!b)return;const I=new L.$Rc,z=this.p.add([I]),F=(Array.isArray(b)?b:[b]).map(T=>D.NotebookStatusBarItem.from(T,this.i,I));return{cacheId:z,items:F}}$releaseNotebookCellStatusBarItems(s){this.p.delete(s)}registerNotebookSerializer(s,n,r,o,v){if((0,g.$Ce)(n))throw new Error("viewType cannot be empty or just whitespace");const C=this.u++;return this.w.set(C,{viewType:n,serializer:r,options:o}),this.b.$registerNotebookSerializer(C,{id:s.identifier,location:s.extensionLocation},n,D.NotebookDocumentContentOptions.from(o),t.t(s,v)),(0,L.$Qc)(()=>{this.b.$unregisterNotebookSerializer(C)})}async $dataToNotebook(s,n,r){const o=this.w.get(s);if(!o)throw new Error("NO serializer found");const v=await o.serializer.deserializeNotebook(n.buffer,r);return new h.$vv(D.NotebookData.from(v))}async $notebookToData(s,n,r){const o=this.w.get(s);if(!o)throw new Error("NO serializer found");const v=await o.serializer.serializeNotebook(D.NotebookData.to(n.value),r);return M.$ce.wrap(v)}async $saveNotebook(s,n,r,o,v){const C=$.URI.revive(n),w=this.w.get(s);if(!w)throw new Error("NO serializer found");const m=this.g.get(C);if(!m)throw new Error("Document NOT found");if(m.versionId!==r)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(C.scheme))throw new R.$uk((0,y.localize)(0,null,this.y(C)),6);await this.x(C,o);const b={metadata:(0,f.$en)(m.apiNotebook.metadata,T=>!(w.options?.transientDocumentMetadata??{})[T]),cells:[]};for(const T of m.apiNotebook.getCells()){const N=new E.$QL(T.kind,T.document.getText(),T.document.languageId,T.mime,w.options?.transientOutputs?[]:[...T.outputs],T.metadata,T.executionSummary);N.metadata=(0,f.$en)(T.metadata,j=>!(w.options?.transientCellMetadata??{})[j]),b.cells.push(N)}const I=await w.serializer.serializeNotebook(b,v);await this.s.value.writeFile(C,I);const z=this.s.getFileSystemProviderExtUri(C.scheme),O=await this.s.value.stat(C);return{name:z.basename(C),isFile:(O.type&R.FileType.File)!==0,isDirectory:(O.type&R.FileType.Directory)!==0,isSymbolicLink:(O.type&R.FileType.SymbolicLink)!==0,mtime:O.mtime,ctime:O.ctime,size:O.size,readonly:!!((O.permissions??0)&R.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(C.scheme),locked:!!((O.permissions??0)&R.FilePermission.Locked),etag:R.$Fk({mtime:O.mtime,size:O.size}),children:void 0}}async x(s,n){const r=await this.s.value.stat(s);if(typeof n?.mtime=="number"&&typeof n.etag=="string"&&n.etag!==R.$Ek&&typeof r.mtime=="number"&&typeof r.size=="number"&&n.mtime<r.mtime&&n.etag!==R.$Fk({mtime:n.mtime,size:r.size}))throw new R.$uk((0,y.localize)(1,null),3,n)}y(s){return s.scheme===a.Schemas.file?s.fsPath:s.toString()}z(s,n,r){if(this.h.has(n))throw new Error(`editor with id ALREADY EXSIST: ${n}`);const o=new d.$bec(n,this.d,s,r.visibleRanges.map(D.NotebookRange.to),r.selections.map(D.NotebookRange.to),typeof r.viewColumn=="number"?D.ViewColumn.to(r.viewColumn):void 0);this.h.set(n,o)}$acceptDocumentAndEditorsDelta(s){if(s.value.removedDocuments)for(const r of s.value.removedDocuments){const o=$.URI.revive(r),v=this.g.get(o);v&&(v.dispose(),this.g.delete(o),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:v.apiNotebook.getCells().map(C=>C.document.uri)}),this.n.fire(v.apiNotebook));for(const C of this.h.values())C.notebookData.uri.toString()===o.toString()&&this.h.delete(C.id)}if(s.value.addedDocuments){const r=[];for(const o of s.value.addedDocuments){const v=$.URI.revive(o.uri);if(this.g.has(v))throw new Error(`adding EXISTING notebook ${v} `);const C=new u.$aec(this.c,this.q,this.r,v,o);r.push(...o.cells.map(w=>u.$_dc.asModelAddData(C.apiNotebook,w))),this.g.get(v)?.dispose(),this.g.set(v,C),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:r}),this.m.fire(C.apiNotebook)}}if(s.value.addedEditors)for(const r of s.value.addedEditors){if(this.h.has(r.id))return;const o=$.URI.revive(r.documentUri),v=this.g.get(o);v&&this.z(v,r.id,r)}const n=[];if(s.value.removedEditors)for(const r of s.value.removedEditors){const o=this.h.get(r);o&&(this.h.delete(r),this.k?.id===o.id&&(this.k=void 0),n.push(o))}if(s.value.visibleEditors){this.l=s.value.visibleEditors.map(o=>this.h.get(o)).filter(o=>!!o);const r=new Set;this.l.forEach(o=>r.add(o.id));for(const o of this.h.values()){const v=r.has(o.id);o._acceptVisibility(v)}this.l=[...this.h.values()].map(o=>o).filter(o=>o.visible),this.o.fire(this.visibleNotebookEditors)}s.value.newActiveEditor===null?this.k=void 0:s.value.newActiveEditor&&(this.h.get(s.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${s.value.newActiveEditor}`),this.k=this.h.get(s.value.newActiveEditor)),s.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static A(s){const n=S.$PM.String.with("notebookType","A notebook type"),r=new S.$RM("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[n,new S.$PM("data","Bytes to convert to data",v=>v instanceof Uint8Array,v=>M.$ce.wrap(v))],new S.$QM("Notebook Data",v=>D.NotebookData.to(v.value))),o=new S.$RM("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[n,new S.$PM("NotebookData","Notebook data to convert to bytes",v=>!0,v=>new h.$vv(D.NotebookData.from(v)))],new S.$QM("Bytes",v=>v.buffer));s.registerApiCommand(r),s.registerApiCommand(o)}}e.$cec=t,t.a=0}),define(De[321],Ce([1,0,19,8,21,4,3,28,2,25,14,6,34,13,7,111,276,26,69]),function(re,e,y,M,l,L,A,g,k,$,R,P,p,S,D,E,h,u,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rec=e.$qec=void 0;let c=class{constructor(o,v,C,w,m){this.l=v,this.m=C,this.n=w,this.o=m,this.b=new g.$Ac,this.c=new g.$Ac,this.e=new Map,this.f=0,this.g=new Map,this.h=0,this.i=new Map,this.j=0,this.k=new L.$Od,this.onDidChangeNotebookCellExecutionState=this.k.event,this.a=o.getProxy(P.$qK.MainThreadNotebookKernels);const b=new p.$RM("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new p.$PM("options","Select kernel options",I=>!0,I=>{if(I&&"notebookEditor"in I&&"id"in I){const z=this.m.getIdByEditor(I.notebookEditor);return{id:I.id,extension:I.extension,notebookEditorId:z}}else if(I&&"notebookEditor"in I){const z=this.m.getIdByEditor(I.notebookEditor);if(z===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${I.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:z}}return I})],p.$QM.Void);this.n.registerApiCommand(b)}createNotebookController(o,v,C,w,m,b){for(const ie of this.i.values())if(ie.controller.id===v&&$.$8l.equals(o.identifier,ie.extensionId))throw new Error(`notebook controller with id '${v}' ALREADY exist`);const I=this.j++,z=this;this.o.trace(`NotebookController[${I}], CREATED by ${o.identifier.value}, ${v}`);const O=()=>console.warn(`NO execute handler from notebook controller '${j.id}' of extension: '${o.identifier}'`);let F=!1;const T=new L.$Od,N=new L.$Od,j={id:n(o.identifier,v),notebookType:C,extensionId:o.identifier,extensionLocation:o.extensionLocation,label:w||o.identifier.value,preloads:b?b.map(S.NotebookRendererScript.from):[]};let U=m??O,B;this.a.$addKernel(I,j).catch(ie=>{console.log(ie),F=!0});let he=0;const x=()=>{if(F)return;const ie=++he;Promise.resolve().then(()=>{ie===he&&this.a.$updateKernel(I,j)})},Q=new g.$Ac,Z={get id(){return v},get notebookType(){return j.notebookType},onDidChangeSelectedNotebooks:T.event,get label(){return j.label},set label(ie){j.label=ie??o.displayName??o.name,x()},get detail(){return j.detail??""},set detail(ie){j.detail=ie,x()},get description(){return j.description??""},set description(ie){j.description=ie,x()},get supportedLanguages(){return j.supportedLanguages},set supportedLanguages(ie){j.supportedLanguages=ie,x()},get supportsExecutionOrder(){return j.supportsExecutionOrder??!1},set supportsExecutionOrder(ie){j.supportsExecutionOrder=ie,x()},get rendererScripts(){return j.preloads?j.preloads.map(S.NotebookRendererScript.to):[]},get executeHandler(){return U},set executeHandler(ie){U=ie??O},get interruptHandler(){return B},set interruptHandler(ie){B=ie,j.supportsInterrupt=!!ie,x()},createNotebookCellExecution(ie){if(F)throw new Error("notebook controller is DISPOSED");if(!Q.has(ie.notebook.uri))throw z.o.trace(`NotebookController[${I}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(Q.keys()).map(_=>_.toString())),new Error(`notebook controller is NOT associated to notebook: ${ie.notebook.uri.toString()}`);return z._createNotebookCellExecution(ie,n(o.identifier,this.id))},createNotebookExecution(ie){if((0,u.$mF)(o,"notebookExecution"),F)throw new Error("notebook controller is DISPOSED");if(!Q.has(ie.uri))throw z.o.trace(`NotebookController[${I}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(Q.keys()).map(_=>_.toString())),new Error(`notebook controller is NOT associated to notebook: ${ie.uri.toString()}`);return z._createNotebookExecution(ie,n(o.identifier,this.id))},dispose:()=>{F||(this.o.trace(`NotebookController[${I}], DISPOSED`),F=!0,this.i.delete(I),T.dispose(),N.dispose(),this.a.$removeKernel(I))},updateNotebookAffinity(ie,_){_===D.NotebookControllerAffinity2.Hidden&&(0,u.$mF)(o,"notebookControllerAffinityHidden"),z.a.$updateNotebookPriority(I,ie.uri,_)},onDidReceiveMessage:N.event,postMessage(ie,_){return(0,u.$mF)(o,"notebookMessaging"),z.a.$postMessage(I,_&&z.m.getIdByEditor(_),ie)},asWebviewUri(ie){return(0,u.$mF)(o,"notebookMessaging"),(0,E.$spb)(ie,z.l.remote)}};return this.i.set(I,{extensionId:o.identifier,controller:Z,onDidReceiveMessage:N,onDidChangeSelection:T,associatedNotebooks:Q}),Z}getIdByController(o){for(const[v,C]of this.i)if(C.controller===o)return n(C.extensionId,o.id);return null}createNotebookControllerDetectionTask(o,v){const C=this.f++,w=this;this.o.trace(`NotebookControllerDetectionTask[${C}], CREATED by ${o.identifier.value}`),this.a.$addKernelDetectionTask(C,v);const m={dispose:()=>{this.e.delete(C),w.a.$removeKernelDetectionTask(C)}};return this.e.set(C,m),m}registerKernelSourceActionProvider(o,v,C){const w=this.h++,m=typeof C.onDidChangeNotebookKernelSourceActions=="function"?w:void 0,b=this;this.g.set(w,C),this.o.trace(`NotebookKernelSourceActionProvider[${w}], CREATED by ${o.identifier.value}`),this.a.$addKernelSourceActionProvider(w,w,v);let I;return m!==void 0&&(I=C.onDidChangeNotebookKernelSourceActions(z=>this.a.$emitNotebookKernelSourceActionsChangeEvent(m))),{dispose:()=>{this.g.delete(w),b.a.$removeKernelSourceActionProvider(w,w),I?.dispose()}}}async $provideKernelSourceActions(o,v){const C=this.g.get(o);if(C){const w=new A.$Rc;return(await C.provideNotebookKernelSourceActions(v)??[]).map(b=>S.NotebookKernelSourceAction.from(b,this.n.converter,w))}return[]}$acceptNotebookAssociation(o,v,C){const w=this.i.get(o);if(w){const m=this.m.getNotebookDocument(k.URI.revive(v));C?w.associatedNotebooks.set(m.uri,!0):w.associatedNotebooks.delete(m.uri),this.o.trace(`NotebookController[${o}] ASSOCIATE notebook`,m.uri.toString(),C),w.onDidChangeSelection.fire({selected:C,notebook:m.apiNotebook})}}async $executeCells(o,v,C){const w=this.i.get(o);if(!w)return;const m=this.m.getNotebookDocument(k.URI.revive(v)),b=[];for(const I of C){const z=m.getCell(I);z&&b.push(z.apiCell)}try{this.o.trace(`NotebookController[${o}] EXECUTE cells`,m.uri.toString(),b.length),await w.controller.executeHandler.call(w.controller,b,m.apiNotebook,w.controller)}catch(I){this.o.error(`NotebookController[${o}] execute cells FAILED`,I),console.error(I)}}async $cancelCells(o,v,C){const w=this.i.get(o);if(!w)return;const m=this.m.getNotebookDocument(k.URI.revive(v));if(w.controller.interruptHandler)await w.controller.interruptHandler.call(w.controller,m.apiNotebook);else for(const b of C){const I=m.getCell(b);I&&this.b.get(I.uri)?.cancel()}if(w.controller.interruptHandler){const b=this.c.get(m.uri);C.length&&Array.isArray(b)&&b.length&&b.forEach(I=>I.dispose())}}$acceptKernelMessageFromRenderer(o,v,C){const w=this.i.get(o);if(!w)return;const m=this.m.getEditorById(v);w.onDidReceiveMessage.fire(Object.freeze({editor:m.apiEditor,message:C}))}$cellExecutionChanged(o,v,C){const m=this.m.getNotebookDocument(k.URI.revive(o)).getCell(v);if(m){const b=C?S.NotebookCellExecutionState.to(C):D.NotebookCellExecutionState.Idle;b!==void 0&&this.k.fire({cell:m.apiCell,state:b})}}_createNotebookCellExecution(o,v){if(o.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const w=this.m.getNotebookDocument(o.notebook.uri).getCellFromApiCell(o);if(!w)throw new Error("invalid cell");if(this.b.has(w.uri))throw new Error(`duplicate execution for ${w.uri}`);const m=new a(v,w,this.a);this.b.set(w.uri,m);const b=m.onDidChangeState(()=>{m.state===f.Resolved&&(m.dispose(),b.dispose(),this.b.delete(w.uri))});return m.asApiObject()}_createNotebookExecution(o,v){const C=this.m.getNotebookDocument(o.uri),w=o.getCells().find(I=>{const z=C.getCellFromApiCell(I);return z&&this.b.has(z.uri)});if(w)throw new Error(`duplicate cell execution for ${w.document.uri}`);if(this.c.has(C.uri))throw new Error(`duplicate notebook execution for ${C.uri}`);const m=new i(v,C,this.a),b=m.onDidChangeState(()=>{m.state===t.Resolved&&(m.dispose(),b.dispose(),this.c.delete(C.uri))});return this.c.set(C.uri,[m,b]),m.asApiObject()}};e.$qec=c,e.$qec=c=He([We(4,R.$$i)],c);var f;(function(r){r[r.Init=0]="Init",r[r.Started=1]="Started",r[r.Resolved=2]="Resolved"})(f||(f={}));class a extends A.$Sc{get state(){return this.f}constructor(o,v,C){super(),this.m=v,this.n=C,this.b=a.a++,this.c=new L.$Od,this.onDidChangeState=this.c.event,this.f=f.Init,this.g=this.B(new l.$Yd),this.h=new s(10,w=>this.s(w)),this.j=v.internalMetadata.executionOrder,this.n.$createExecution(this.b,o,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(o){await this.h.addItem(o)}async s(o){const v=Array.isArray(o)?o:[o];return this.n.$updateExecution(this.b,new d.$vv(v))}t(){if(this.f===f.Init)throw new Error("Must call start before modifying cell output");if(this.f===f.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(o){let v=this.m;if(o&&(v=this.m.notebook.getCellFromApiCell(o)),!v)throw new Error("INVALID cell");return v.handle}y(o){return o.map(v=>{const C=D.$TL.ensureUniqueMimeTypes(v.items,!0);return C===v.items?S.NotebookCellOutput.from(v):S.NotebookCellOutput.from({items:C,id:v.id,metadata:v.metadata})})}async z(o,v,C){const w=this.w(v),m=this.y((0,y.$3b)(o));return this.r({editType:h.CellExecutionUpdateType.Output,cellHandle:w,append:C,outputs:m})}async C(o,v,C){return o=D.$TL.ensureUniqueMimeTypes((0,y.$3b)(o),!0),this.r({editType:h.CellExecutionUpdateType.OutputItems,items:o.map(S.NotebookCellOutputItem.from),outputId:v.id,append:C})}asApiObject(){const o=this;return Object.freeze({get token(){return o.g.token},get cell(){return o.m.apiCell},get executionOrder(){return o.j},set executionOrder(C){o.j=C,o.s([{editType:h.CellExecutionUpdateType.ExecutionState,executionOrder:o.j}])},start(C){if(o.f===f.Resolved||o.f===f.Started)throw new Error("Cannot call start again");o.f=f.Started,o.c.fire(),o.s({editType:h.CellExecutionUpdateType.ExecutionState,runStartTime:C})},end(C,w){if(o.f===f.Resolved)throw new Error("Cannot call resolve twice");o.f=f.Resolved,o.c.fire(),o.h.flush(),o.n.$completeExecution(o.b,new d.$vv({runEndTime:w,lastRunSuccess:C}))},clearOutput(C){return o.t(),o.z([],C,!1)},appendOutput(C,w){return o.t(),o.z(C,w,!0)},replaceOutput(C,w){return o.t(),o.z(C,w,!1)},appendOutputItems(C,w){return o.t(),o.C(C,w,!0)},replaceOutputItems(C,w){return o.t(),o.C(C,w,!1)}})}}a.a=0;var t;(function(r){r[r.Init=0]="Init",r[r.Started=1]="Started",r[r.Resolved=2]="Resolved"})(t||(t={}));class i extends A.$Sc{get state(){return this.f}constructor(o,v,C){super(),this.h=v,this.j=C,this.b=i.a++,this.c=new L.$Od,this.onDidChangeState=this.c.event,this.f=t.Init,this.g=this.B(new l.$Yd),this.j.$createNotebookExecution(this.b,o,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===t.Resolved||this.f===t.Started)throw new Error("Cannot call start again");this.f=t.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===t.Resolved)throw new Error("Cannot call resolve twice");this.f=t.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}i.a=0;class s{constructor(o,v){this.e=o,this.f=v,this.a=[],this.b=Date.now()}addItem(o){return this.a.push(o),this.c||(this.c=new M.$dh,this.b=Date.now(),(0,M.$Vg)(this.e).then(()=>this.flush())),Date.now()-this.b>this.e?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const o=this.c;this.c=void 0;const v=this.a;return this.a=[],this.f(v).finally(()=>o.complete())}}function n(r,o){return`${r.value}/${o}`}e.$rec=n}),define(De[322],Ce([1,0,4,6,147]),function(re,e,y,M,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sec=void 0;class L{constructor(g,k){this.c=k,this.a=new Map,this.b=g.getProxy(M.$qK.MainThreadNotebookRenderers)}$postRendererMessage(g,k,$){const R=this.c.getEditorById(g);this.a.get(k)?.fire({editor:R.apiEditor,message:$})}createRendererMessaging(g,k){if(!g.contributes?.notebookRenderer?.some(R=>R.id===k))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${k})`);return{onDidReceiveMessage:(R,P,p)=>this.d(k).event(R,P,p),postMessage:(R,P)=>{l.$bec.apiEditorsToExtHost.has(R)&&([R,P]=[P,R]);const p=P&&l.$bec.apiEditorsToExtHost.get(P);return this.b.$postMessage(p?.id,k,R)}}}d(g){let k=this.a.get(g);return k||(k=new y.$Od({onDidRemoveLastListener:()=>{k?.dispose(),this.a.delete(g)}}),this.a.set(g,k),k)}}e.$sec=L}),define(De[323],Ce([1,0,3,17,2,26,6]),function(re,e,y,M,l,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wec=void 0;class g{constructor($){this.b=new Map,this.a=$.getProxy(A.$qK.MainThreadProfileContentHandlers)}registrProfileContentHandler($,R,P){if((0,L.$mF)($,"profileContentHandlers"),this.b.has(R))throw new Error(`Handler with id '${R}' already registered`);return this.b.set(R,P),this.a.$registerProfileContentHandler(R,P.name,P.description,$.identifier.value),(0,y.$Qc)(()=>{this.b.delete(R),this.a.$unregisterProfileContentHandler(R)})}async $saveProfile($,R,P,p){const S=this.b.get($);if(!S)throw new Error(`Unknown handler with id: ${$}`);return S.saveProfile(R,P,p)}async $readProfile($,R,P){const p=this.b.get($);if(!p)throw new Error(`Unknown handler with id: ${$}`);return p.readProfile((0,M.$zf)(R)?R:l.URI.revive(R),P)}}e.$wec=g}),define(De[324],Ce([1,0,2,6,8,13]),function(re,e,y,M,l,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xec=void 0;class A{constructor(k,$){this.d=$,this.c=new Map,this.b=k.getProxy(M.$qK.MainThreadQuickDiff)}$provideOriginalResource(k,$,R){const P=y.URI.revive($),p=this.c.get(k);return p?(0,l.$Ng)(()=>p.provideOriginalResource(P,R)).then(S=>S||null):Promise.resolve(null)}registerQuickDiffProvider(k,$,R,P){const p=A.a++;return this.c.set(p,$),this.b.$registerQuickDiffProvider(p,L.DocumentSelector.from(k,this.d),R,P),{dispose:()=>{this.b.$unregisterQuickDiffProvider(p),this.c.delete(p)}}}}e.$xec=A,A.a=0}),define(De[325],Ce([1,0,21,4,3,6,2,7,9,19,39,59,26,13]),function(re,e,y,M,l,L,A,g,k,$,R,P,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ydc=void 0;function D(E,h,u){const d=E.getProxy(L.$qK.MainThreadQuickOpen);class c{constructor(v,C){this.e=new Map,this.f=0,this.a=v,this.b=C}showQuickPick(v,C,w,m=y.CancellationToken.None){this.c=void 0;const b=Promise.resolve(C),I=++this.f,z=d.$show(I,{title:w?.title,placeHolder:w?.placeHolder,matchOnDescription:w?.matchOnDescription,matchOnDetail:w?.matchOnDetail,ignoreFocusLost:w?.ignoreFocusOut,canPickMany:w?.canPickMany},m),O={},F=z.then(()=>O);return Promise.race([F,b]).then(T=>{if(T===O)return;const N=(0,p.$lF)(v,"quickPickItemTooltip");return b.then(j=>{const U=[];for(let B=0;B<j.length;B++){const he=j[B];if(typeof he=="string")U.push({label:he,handle:B});else if(he.kind===g.QuickPickItemKind.Separator)U.push({type:"separator",label:he.label});else{he.tooltip&&!N&&console.warn(`Extension '${v.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${v.identifier.value}`);const x=he.iconPath?s(he.iconPath):void 0;U.push({label:he.label,iconPath:x?.iconPath,iconClass:x?.iconClass,description:he.description,detail:he.detail,picked:he.picked,alwaysShow:he.alwaysShow,tooltip:N?S.MarkdownString.fromStrict(he.tooltip):void 0,handle:B})}}return w&&typeof w.onDidSelectItem=="function"&&(this.c=B=>{w.onDidSelectItem(j[B])}),d.$setItems(I,U),z.then(B=>{if(typeof B=="number")return j[B];if(Array.isArray(B))return B.map(he=>j[he])})})}).then(void 0,T=>{if(!(0,k.$4)(T))return d.$setError(I,T),Promise.reject(T)})}$onItemSelected(v){this.c?.(v)}showInput(v,C=y.CancellationToken.None){return this.d=v?.validateInput,d.$input(v,typeof this.d=="function",C).then(void 0,w=>{if(!(0,k.$4)(w))return Promise.reject(w)})}async $validateInput(v){if(!this.d)return;const C=await this.d(v);if(!C||typeof C=="string")return C;let w;switch(C.severity){case g.InputBoxValidationSeverity.Info:w=R.default.Info;break;case g.InputBoxValidationSeverity.Warning:w=R.default.Warning;break;case g.InputBoxValidationSeverity.Error:w=R.default.Error;break;default:w=C.message?R.default.Error:R.default.Ignore;break}return{content:C.message,severity:w}}async showWorkspaceFolderPick(v,C=y.CancellationToken.None){const w=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[v]);if(!w)return;const m=await this.a.getWorkspaceFolders2();if(m)return m.find(b=>b.uri.toString()===w.uri.toString())}createQuickPick(v){const C=new n(v,()=>this.e.delete(C._id));return this.e.set(C._id,C),C}createInputBox(v){const C=new r(v,()=>this.e.delete(C._id));return this.e.set(C._id,C),C}$onDidChangeValue(v,C){this.e.get(v)?._fireDidChangeValue(C)}$onDidAccept(v){this.e.get(v)?._fireDidAccept()}$onDidChangeActive(v,C){const w=this.e.get(v);w instanceof n&&w._fireDidChangeActive(C)}$onDidChangeSelection(v,C){const w=this.e.get(v);w instanceof n&&w._fireDidChangeSelection(C)}$onDidTriggerButton(v,C){this.e.get(v)?._fireDidTriggerButton(C)}$onDidTriggerItemButton(v,C,w){const m=this.e.get(v);m instanceof n&&m._fireDidTriggerItemButton(C,w)}$onDidHide(v){this.e.get(v)?._fireDidHide()}}class f{constructor(v,C){this.x=v,this.y=C,this._id=n.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new M.$Od,this.q=new M.$Od,this.r=new M.$Od,this.s=new M.$Od,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(v){this.b=v,this.z({title:v})}get step(){return this.c}set step(v){this.c=v,this.z({step:v})}get totalSteps(){return this.d}set totalSteps(v){this.d=v,this.z({totalSteps:v})}get enabled(){return this.g}set enabled(v){this.g=v,this.z({enabled:v})}get busy(){return this.j}set busy(v){this.j=v,this.z({busy:v})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(v){this.k=v,this.z({ignoreFocusOut:v})}get value(){return this.l}set value(v){this.l=v,this.z({value:v})}get placeholder(){return this.m}set placeholder(v){this.m=v,this.z({placeholder:v})}get buttons(){return this.n}set buttons(v){this.n=v.slice(),this.o.clear(),v.forEach((C,w)=>{const m=C===g.$ML.Back?-1:w;this.o.set(m,C)}),this.z({buttons:v.map((C,w)=>({...s(C.iconPath),tooltip:C.tooltip,handle:C===g.$ML.Back?-1:w}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(v){this.l=v,this.q.fire(v)}_fireDidTriggerButton(v){const C=this.o.get(v);C&&this.r.fire(C)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,l.$Nc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),d.$dispose(this._id))}z(v){if(!this.v){for(const C of Object.keys(v)){const w=v[C];this.u[C]=w===void 0?null:w}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){d.$createOrUpdate(this.u),this.u={id:this._id}}}f.a=1;function a(o){if(o instanceof g.$mL)return{id:o.id};const v=i(o),C=t(o);return{dark:typeof v=="string"?A.URI.file(v):v,light:typeof C=="string"?A.URI.file(C):C}}function t(o){return typeof o=="object"&&"light"in o?o.light:o}function i(o){return typeof o=="object"&&"dark"in o?o.dark:o}function s(o){const v=a(o);let C,w;return"id"in v?w=P.ThemeIcon.asClassName(v):C=v,{iconPath:C,iconClass:w}}class n extends f{constructor(v,C){super(v.identifier,C),this.O=v,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new M.$Od,this.L=[],this.M=new M.$Od,this.N=new M.$Od,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(v){this.B=v.slice(),this.C.clear(),this.D.clear(),v.forEach((m,b)=>{this.C.set(b,m),this.D.set(m,b)});const C=(0,p.$lF)(this.O,"quickPickItemTooltip"),w=[];for(let m=0;m<v.length;m++){const b=v[m];if(b.kind===g.QuickPickItemKind.Separator)w.push({type:"separator",label:b.label});else{b.tooltip&&!C&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const I=b.iconPath?s(b.iconPath):void 0;w.push({handle:m,label:b.label,iconPath:I?.iconPath,iconClass:I?.iconClass,description:b.description,detail:b.detail,picked:b.picked,alwaysShow:b.alwaysShow,tooltip:C?S.MarkdownString.fromStrict(b.tooltip):void 0,buttons:b.buttons?.map((z,O)=>({...s(z.iconPath),tooltip:z.tooltip,handle:O}))})}}this.z({items:w})}get canSelectMany(){return this.E}set canSelectMany(v){this.E=v,this.z({canSelectMany:v})}get matchOnDescription(){return this.F}set matchOnDescription(v){this.F=v,this.z({matchOnDescription:v})}get matchOnDetail(){return this.G}set matchOnDetail(v){this.G=v,this.z({matchOnDetail:v})}get sortByLabel(){return this.H}set sortByLabel(v){this.H=v,this.z({sortByLabel:v})}get keepScrollPosition(){return this.I}set keepScrollPosition(v){this.I=v,this.z({keepScrollPosition:v})}get activeItems(){return this.J}set activeItems(v){this.J=v.filter(C=>this.D.has(C)),this.z({activeItems:this.J.map(C=>this.D.get(C))})}get selectedItems(){return this.L}set selectedItems(v){this.L=v.filter(C=>this.D.has(C)),this.z({selectedItems:this.L.map(C=>this.D.get(C))})}_fireDidChangeActive(v){const C=(0,$.$Hb)(v.map(w=>this.C.get(w)));this.J=C,this.K.fire(C)}_fireDidChangeSelection(v){const C=(0,$.$Hb)(v.map(w=>this.C.get(w)));this.L=C,this.M.fire(C)}_fireDidTriggerItemButton(v,C){const w=this.C.get(v);if(!w||!w.buttons||!w.buttons.length)return;const m=w.buttons[C];m&&this.N.fire({button:m,item:w})}}class r extends f{constructor(v,C){super(v.identifier,C),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(v){this.B=v,this.z({password:v})}get prompt(){return this.C}set prompt(v){this.C=v,this.z({prompt:v})}get valueSelection(){return this.D}set valueSelection(v){this.D=v,this.z({valueSelection:v})}get validationMessage(){return this.E}set validationMessage(v){this.E=v,v?typeof v=="string"?this.z({validationMessage:v,severity:R.default.Error}):this.z({validationMessage:v.message,severity:v.severity??R.default.Error}):this.z({validationMessage:void 0,severity:R.default.Ignore})}}return new c(h,u)}e.$ydc=D});var Be=this&&this.__classPrivateFieldGet||function(re,e,y,M){if(y==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!M:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return y==="m"?M:y==="a"?M.call(re):M?M.value:e.get(re)},et=this&&this.__classPrivateFieldSet||function(re,e,y,M,l){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!l)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!l:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?l.call(re,y):l?l.value=y:e.set(re,y),y};define(De[326],Ce([1,0,2,4,57,3,8,6,19,122,14,25,59,13,26,18]),function(re,e,y,M,l,L,A,g,k,$,R,P,p,S,D,E){"use strict";var h,u,d,c;Object.defineProperty(e,"__esModule",{value:!0}),e.$Adc=e.$zdc=void 0;function f(O){if(O)return typeof O.iconPath=="string"?y.URI.file(O.iconPath):y.URI.isUri(O.iconPath)||p.ThemeIcon.isThemeIcon(O.iconPath)?O.iconPath:void 0}function a(O){if(O?.icon){if(y.URI.isUri(O.icon))return O.icon;if(p.ThemeIcon.isThemeIcon(O.icon))return O.icon;{const F=O.icon;return{light:F.light,dark:F.dark}}}else return}function t(O){if(O.icon){if(y.URI.isUri(O.icon))return O.icon;if(p.ThemeIcon.isThemeIcon(O.icon))return O.icon;{const F=O.icon;return{light:F.light,dark:F.dark}}}else return}function i(O,F){if(!O.iconPath&&!F.iconPath)return 0;if(O.iconPath){if(!F.iconPath)return 1}else return-1;const T=typeof O.iconPath=="string"?O.iconPath:y.URI.isUri(O.iconPath)?O.iconPath.fsPath:O.iconPath.id,N=typeof F.iconPath=="string"?F.iconPath:y.URI.isUri(F.iconPath)?F.iconPath.fsPath:F.iconPath.id;return(0,$.$wq)(T,N)}function s(O,F){let T=0;if(O.strikeThrough!==F.strikeThrough)return O.strikeThrough?1:-1;if(O.faded!==F.faded)return O.faded?1:-1;if(O.tooltip!==F.tooltip)return(O.tooltip||"").localeCompare(F.tooltip||"");if(T=i(O,F),T!==0)return T;if(O.light&&F.light)T=i(O.light,F.light);else{if(O.light)return 1;if(F.light)return-1}if(T!==0)return T;if(O.dark&&F.dark)T=i(O.dark,F.dark);else{if(O.dark)return 1;if(F.dark)return-1}return T}function n(O,F){if(O.command!==F.command)return O.command<F.command?-1:1;if(O.title!==F.title)return O.title<F.title?-1:1;if(O.tooltip!==F.tooltip){if(O.tooltip!==void 0&&F.tooltip!==void 0)return O.tooltip<F.tooltip?-1:1;if(O.tooltip!==void 0)return 1;if(F.tooltip!==void 0)return-1}if(O.arguments===F.arguments)return 0;if(O.arguments)if(F.arguments){if(O.arguments.length!==F.arguments.length)return O.arguments.length-F.arguments.length}else return 1;else return-1;for(let T=0;T<O.arguments.length;T++){const N=O.arguments[T],j=F.arguments[T];if(N!==j)return N<j?-1:1}return 0}function r(O,F){let T=(0,$.$wq)(O.resourceUri.fsPath,F.resourceUri.fsPath,!0);if(T!==0)return T;if(O.command&&F.command)T=n(O.command,F.command);else{if(O.command)return 1;if(F.command)return-1}if(T!==0)return T;if(O.decorations&&F.decorations)T=s(O.decorations,F.decorations);else{if(O.decorations)return 1;if(F.decorations)return-1}return T}function o(O,F){for(let T=0;T<O.length;T++)if(O[T]!==F[T])return!1;return!0}function v(O,F){return O.command===F.command&&O.title===F.title&&O.tooltip===F.tooltip&&(O.arguments&&F.arguments?o(O.arguments,F.arguments):O.arguments===F.arguments)}function C(O,F){return(0,k.$ub)(O,F,v)}function w(O,F){return O===F?!0:!O||!F?!1:O.id===F.id&&O.label===F.label&&O.upstream?.id===F.upstream?.id&&O.upstream?.label===F.upstream?.label}class m{get value(){return this.d}set value(F){F=F??"",Be(this,h,"f").$setInputBoxValue(this.o,F),this.q(F)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(F){Be(this,h,"f").$setInputBoxPlaceholder(this.o,F),this.f=F}get validateInput(){return(0,D.$mF)(this.m,"scmValidation"),this.g}set validateInput(F){if((0,D.$mF)(this.m,"scmValidation"),F&&typeof F!="function")throw new Error(`[${this.m.identifier.value}]: Invalid SCM input box validation function`);this.g=F,Be(this,h,"f").$setValidationProviderIsEnabled(this.o,!!F)}get enabled(){return this.h}set enabled(F){F=!!F,this.h!==F&&(this.h=F,Be(this,h,"f").$setInputBoxEnablement(this.o,F))}get visible(){return this.j}set visible(F){F=!!F,this.j!==F&&(this.j=F,Be(this,h,"f").$setInputBoxVisibility(this.o,F))}get actionButton(){return(0,D.$mF)(this.m,"scmInputBoxActionButton"),this.k}set actionButton(F){(0,D.$mF)(this.m,"scmInputBoxActionButton"),this.l.value=new L.$Rc,this.k=F;const T=F!==void 0?{command:this.n.converter.toInternal(F.command,this.l.value),icon:a(F),enabled:F.enabled}:void 0;Be(this,h,"f").$setInputBoxActionButton(this.o,T??null)}get document(){return(0,D.$mF)(this.m,"scmTextDocument"),Be(this,u,"f").getDocument(this.p)}constructor(F,T,N,j,U,B){this.m=F,this.n=T,this.o=U,this.p=B,h.set(this,void 0),u.set(this,void 0),this.d="",this.e=new M.$Od,this.f="",this.h=!0,this.j=!0,this.l=new L.$Tc,et(this,u,N,"f"),et(this,h,j,"f")}showValidationMessage(F,T){(0,D.$mF)(this.m,"scmValidation"),Be(this,h,"f").$showValidationMessage(this.o,F,T)}$onInputBoxValueChange(F){this.q(F)}q(F){this.d=F,this.e.fire(F)}}e.$zdc=m,h=new WeakMap,u=new WeakMap;class b{get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(F){this.v=F,this.q.$updateGroupLabel(this.t,this.handle,F)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(F){this.p=F,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(F){this.f=[...F],this.k.fire()}constructor(F,T,N,j,U){this.q=F,this.s=T,this.t=N,this.u=j,this.v=U,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new M.$Od,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new M.$Od,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=b.d++}getResourceState(F){return this.g.get(F)}$executeResourceCommand(F,T){const N=this.h.get(F);return N?(0,A.$Ng)(()=>this.s.executeCommand(N.command,...N.arguments||[],T)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const F=[...this.f].sort(r),N=(0,k.$Db)(this.o,F,r).map(B=>{const he=B.toInsert.map(x=>{const Q=this.e++;this.g.set(Q,x);const Z=x.resourceUri;let ie;if(x.command)if(x.command.command==="vscode.open"||x.command.command==="vscode.diff"){const X=new L.$Rc;ie=this.s.converter.toInternal(x.command,X),this.j.set(Q,X)}else this.h.set(Q,x.command);const _=f(x.decorations),oe=x.decorations&&f(x.decorations.light)||_,ye=x.decorations&&f(x.decorations.dark)||_,fe=[oe,ye],V=x.decorations&&x.decorations.tooltip||"",le=x.decorations&&!!x.decorations.strikeThrough,H=x.decorations&&!!x.decorations.faded,G=x.contextValue||"";return{rawResource:[Q,Z,fe,V,le,H,G,ie],handle:Q}});return{start:B.start,deleteCount:B.deleteCount,toInsert:he}}),j=N.map(({start:B,deleteCount:he,toInsert:x})=>[B,he,x.map(Q=>Q.rawResource)]),U=N.reverse();for(const{start:B,deleteCount:he,toInsert:x}of U){const Q=x.map(ie=>ie.handle),Z=this.n.splice(B,he,...Q);for(const ie of Z)this.g.delete(ie),this.h.delete(ie),this.j.get(ie)?.dispose(),this.j.delete(ie)}return this.o=F,j}dispose(){this.l=!0,this.m.fire()}}b.d=0;class I{get id(){return this.A}get label(){return this.B}get rootUri(){return this.C}get inputBox(){return this.f}get count(){return this.g}set count(F){this.g!==F&&(this.g=F,Be(this,d,"f").$updateSourceControl(this.x,{count:F}))}get quickDiffProvider(){return this.h}set quickDiffProvider(F){this.h=F;let T;(0,D.$lF)(this.y,"quickDiffProvider")&&(T=F?.label),Be(this,d,"f").$updateSourceControl(this.x,{hasQuickDiffProvider:!!F,quickDiffLabel:T})}get historyProvider(){return(0,D.$mF)(this.y,"scmHistoryProvider"),this.j}set historyProvider(F){(0,D.$mF)(this.y,"scmHistoryProvider"),this.j=F,this.k.value=new L.$Rc,Be(this,d,"f").$updateSourceControl(this.x,{hasHistoryProvider:!!F}),F&&(this.k.value.add(F.onDidChangeCurrentHistoryItemGroup(()=>{w(this.l,F?.currentHistoryItemGroup)||(this.l=F?.currentHistoryItemGroup,Be(this,d,"f").$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.x,this.l))})),this.k.value.add(F.onDidChangeActionButton(()=>{(0,D.$mF)(this.y,"scmActionButton"),this.m.value=new L.$Rc;const T=F.actionButton!==void 0?{command:this.z.converter.toInternal(F.actionButton.command,this.m.value),description:F.actionButton.description,enabled:F.actionButton.enabled}:void 0;Be(this,d,"f").$onDidChangeHistoryProviderActionButton(this.x,T??null)})))}get commitTemplate(){return this.n}set commitTemplate(F){F!==this.n&&(this.n=F,Be(this,d,"f").$updateSourceControl(this.x,{commitTemplate:F}))}get acceptInputCommand(){return this.p}set acceptInputCommand(F){this.o.value=new L.$Rc,this.p=F;const T=this.z.converter.toInternal(F,this.o.value);Be(this,d,"f").$updateSourceControl(this.x,{acceptInputCommand:T})}get actionButton(){return(0,D.$mF)(this.y,"scmActionButton"),this.s}set actionButton(F){(0,D.$mF)(this.y,"scmActionButton"),this.q.value=new L.$Rc,this.s=F;const T=F!==void 0?{command:this.z.converter.toInternal(F.command,this.q.value),secondaryCommands:F.secondaryCommands?.map(N=>N.map(j=>this.z.converter.toInternal(j,this.q.value))),description:F.description,enabled:F.enabled}:void 0;Be(this,d,"f").$updateSourceControl(this.x,{actionButton:T??null})}get statusBarCommands(){return this.u}set statusBarCommands(F){if(this.u&&F&&C(this.u,F))return;this.t.value=new L.$Rc,this.u=F;const T=(F||[]).map(N=>this.z.converter.toInternal(N,this.t.value));Be(this,d,"f").$updateSourceControl(this.x,{statusBarCommands:T})}get selected(){return this.v}constructor(F,T,N,j,U,B,he){this.y=F,this.z=j,this.A=U,this.B=B,this.C=he,d.set(this,void 0),this.e=new Map,this.g=void 0,this.h=void 0,this.k=new L.$Tc,this.m=new L.$Tc,this.n=void 0,this.o=new L.$Tc,this.p=void 0,this.q=new L.$Tc,this.t=new L.$Tc,this.u=void 0,this.v=!1,this.w=new M.$Od,this.onDidChangeSelection=this.w.event,this.x=I.d++,this.D=new Map,this.E=new Set,et(this,d,N,"f");const x=y.URI.from({scheme:E.Schemas.vscodeSourceControl,path:`${U}/scm${this.x}/input`,query:he?`rootUri=${encodeURIComponent(he.toString())}`:void 0});this.f=new m(F,j,T,Be(this,d,"f"),this.x,x),Be(this,d,"f").$registerSourceControl(this.x,U,B,he,x)}createResourceGroup(F,T){const N=new b(Be(this,d,"f"),this.z,this.x,F,T),j=M.Event.once(N.onDidDispose)(()=>this.D.delete(N));return this.D.set(N,j),this.eventuallyAddResourceGroups(),N}eventuallyAddResourceGroups(){const F=[],T=[];for(const[N,j]of this.D){j.dispose();const U=N.onDidUpdateResourceStates(()=>{this.E.add(N),this.eventuallyUpdateResourceStates()});M.Event.once(N.onDidDispose)(()=>{this.E.delete(N),U.dispose(),this.e.delete(N.handle),Be(this,d,"f").$unregisterGroup(this.x,N.handle)}),F.push([N.handle,N.id,N.label,N.features]);const B=N._takeResourceStateSnapshot();B.length>0&&T.push([N.handle,B]),this.e.set(N.handle,N)}Be(this,d,"f").$registerGroups(this.x,F,T),this.D.clear()}eventuallyUpdateResourceStates(){const F=[];this.E.forEach(T=>{const N=T._takeResourceStateSnapshot();N.length!==0&&F.push([T.handle,N])}),F.length>0&&Be(this,d,"f").$spliceResourceStates(this.x,F),this.E.clear()}getResourceGroup(F){return this.e.get(F)}setSelectionState(F){this.v=F,this.w.fire(F)}dispose(){this.o.dispose(),this.q.dispose(),this.t.dispose(),this.e.forEach(F=>F.dispose()),Be(this,d,"f").$unregisterSourceControl(this.x)}}d=new WeakMap,I.d=0,He([(0,l.$jh)(100)],I.prototype,"eventuallyAddResourceGroups",null),He([(0,l.$jh)(100)],I.prototype,"eventuallyUpdateResourceStates",null);let z=c=class{get onDidChangeActiveProvider(){return this.j.event}constructor(F,T,N,j){this.l=T,this.m=N,this.n=j,this.g=new Map,this.h=new P.$0l,this.j=new M.$Od,this.e=F.getProxy(g.$qK.MainThreadSCM),this.f=F.getProxy(g.$qK.MainThreadTelemetry),T.registerArgumentProcessor({processArgument:U=>{if(U&&U.$mid===3){const B=this.g.get(U.sourceControlHandle);if(!B)return U;const he=B.getResourceGroup(U.groupHandle);return he?he.getResourceState(U.handle):U}else if(U&&U.$mid===4){const B=this.g.get(U.sourceControlHandle);return B?B.getResourceGroup(U.groupHandle):U}else if(U&&U.$mid===5){const B=this.g.get(U.handle);return B||U}return U}})}createSourceControl(F,T,N,j){this.n.trace("ExtHostSCM#createSourceControl",F.identifier.value,T,N,j),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:F.identifier.value});const U=c.d++,B=new I(F,this.m,this.e,this.l,T,N,j);this.g.set(U,B);const he=this.h.get(F.identifier)||[];return he.push(B),this.h.set(F.identifier,he),B}getLastInputBox(F){this.n.trace("ExtHostSCM#getLastInputBox",F.identifier.value);const T=this.h.get(F.identifier),N=T&&T[T.length-1];return N&&N.inputBox}$provideOriginalResource(F,T,N){const j=y.URI.revive(T);this.n.trace("ExtHostSCM#$provideOriginalResource",F,j.toString());const U=this.g.get(F);return!U||!U.quickDiffProvider||!U.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,A.$Ng)(()=>U.quickDiffProvider.provideOriginalResource(j,N)).then(B=>B||null)}$onInputBoxValueChange(F,T){this.n.trace("ExtHostSCM#$onInputBoxValueChange",F);const N=this.g.get(F);return N&&N.inputBox.$onInputBoxValueChange(T),Promise.resolve(void 0)}$executeResourceCommand(F,T,N,j){this.n.trace("ExtHostSCM#$executeResourceCommand",F,T,N);const U=this.g.get(F);if(!U)return Promise.resolve(void 0);const B=U.getResourceGroup(T);return B?B.$executeResourceCommand(N,j):Promise.resolve(void 0)}$validateInput(F,T,N){this.n.trace("ExtHostSCM#$validateInput",F);const j=this.g.get(F);return!j||!j.inputBox.validateInput?Promise.resolve(void 0):(0,A.$Ng)(()=>j.inputBox.validateInput(T,N)).then(U=>{if(!U)return Promise.resolve(void 0);const B=S.MarkdownString.fromStrict(U.message);return B?Promise.resolve([B,U.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(F){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",F),F!==void 0&&this.g.get(F)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=F,Promise.resolve(void 0)}async $resolveHistoryItemGroupBase(F,T,N){return await this.g.get(F)?.historyProvider?.resolveHistoryItemGroupBase(T,N)??void 0}async $resolveHistoryItemGroupCommonAncestor(F,T,N,j){return await this.g.get(F)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(T,N,j)??void 0}async $provideHistoryItems(F,T,N,j){return(await this.g.get(F)?.historyProvider?.provideHistoryItems(T,N,j))?.map(he=>({id:he.id,parentIds:he.parentIds,label:he.label,description:he.description,icon:t(he),timestamp:he.timestamp}))??void 0}async $provideHistoryItemChanges(F,T,N){return await this.g.get(F)?.historyProvider?.provideHistoryItemChanges(T,N)??void 0}};e.$Adc=z,z.d=0,e.$Adc=z=c=He([We(3,R.$$i)],z)}),define(De[115],Ce([1,0,6,4,5]),function(re,e,y,M,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gdc=e.$fdc=void 0;class L{constructor(g){this.b=new M.$Od,this.onDidChangePassword=this.b.event,this.a=g.getProxy(y.$qK.MainThreadSecretState)}async $onDidChangePassword(g){this.b.fire(g)}get(g,k){return this.a.$getPassword(g,k)}store(g,k,$){return this.a.$setPassword(g,k,$)}delete(g,k){return this.a.$deletePassword(g,k)}}e.$fdc=L,e.$gdc=(0,l.$Qh)("IExtHostSecretState")}),define(De[327],Ce([1,0,6,13,2]),function(re,e,y,M,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cec=void 0;class L{constructor(g,k){this.d=k,this.c=new Map,this.b=g.getProxy(y.$qK.MainThreadShare)}async $provideShare(g,k,$){return await this.c.get(g)?.provideShare({selection:M.Range.to(k.selection),resourceUri:l.URI.revive(k.resourceUri)},$)??void 0}registerShareProvider(g,k){const $=L.a++;return this.c.set($,k),this.b.$registerShareProvider($,M.DocumentSelector.from(g,this.d),k.id,k.label,k.priority),{dispose:()=>{this.b.$unregisterShareProvider($),this.c.delete($)}}}}e.$Cec=L,L.a=0}),define(De[328],Ce([1,0,21,3,6]),function(re,e,y,M,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eec=void 0;class L{constructor(g){this.c=new Map,this.d=new Map,this.b=g.getProxy(l.$qK.MainThreadSpeech)}async $createSpeechToTextSession(g,k){const $=this.c.get(g);if(!$)return;const R=new M.$Rc,P=new y.$Yd;this.d.set(k,P);const p=R.add($.provideSpeechToTextSession(P.token));R.add(p.onDidChange(S=>{P.token.isCancellationRequested||this.b.$emitSpeechToTextEvent(k,S)})),R.add(P.token.onCancellationRequested(()=>R.dispose()))}async $cancelSpeechToTextSession(g){this.d.get(g)?.dispose(!0),this.d.delete(g)}registerProvider(g,k,$){const R=L.a++;return this.c.set(R,$),this.b.$registerProvider(R,k,{extension:g,displayName:g.value}),(0,M.$Qc)(()=>{this.b.$unregisterProvider(R),this.c.delete(R)})}}e.$Eec=L,L.a=1});var et=this&&this.__classPrivateFieldSet||function(re,e,y,M,l){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!l)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!l:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?l.call(re,y):l?l.value=y:e.set(re,y),y},Be=this&&this.__classPrivateFieldGet||function(re,e,y,M){if(y==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!M:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return y==="m"?M:y==="a"?M.call(re):M?M.value:e.get(re)};define(De[329],Ce([1,0,7,6,210,3,13,17]),function(re,e,y,M,l,L,A,g){"use strict";var k,$;Object.defineProperty(e,"__esModule",{value:!0}),e.$Cdc=e.$Bdc=void 0;class R{constructor(D,E,h,u,d,c=y.StatusBarAlignment.Left,f){if(k.set(this,void 0),$.set(this,void 0),this.i=!1,this.k="",this.q=new L.$Rc,et(this,k,D,"f"),et(this,$,E,"f"),d&&u){this.c=(0,y.$3K)(u.identifier,d);const a=h.get(this.c);a&&(c=a.alignLeft?y.StatusBarAlignment.Left:y.StatusBarAlignment.Right,f=a.priority,this.j=!0,this.name=a.name,this.text=a.text,this.tooltip=a.tooltip,this.command=a.command,this.accessibilityInformation=a.accessibilityInformation)}else this.c=String(R.a++);this.e=u,this.f=d,this.g=c,this.h=this.u(f)}u(D){if((0,g.$Df)(D))return D===Number.POSITIVE_INFINITY?Number.MAX_VALUE:D===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:D}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(D){this.k=D,this.v()}set name(D){this.m=D,this.v()}set tooltip(D){this.l=D,this.v()}set color(D){this.n=D,this.v()}set backgroundColor(D){D&&!R.b.has(D.id)&&(D=void 0),this.o=D,this.v()}set command(D){this.r?.fromApi!==D&&(this.p&&this.q.add(this.p),this.p=new L.$Rc,typeof D=="string"?this.r={fromApi:D,internal:Be(this,$,"f").toInternal({title:"",command:D},this.p)}:D?this.r={fromApi:D,internal:Be(this,$,"f").toInternal(D,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(D){this.t=D,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,Be(this,k,"f").$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let D;this.e?this.f?D=`${this.e.identifier.value}.${this.f}`:D=this.e.identifier.value:D=this.f;let E;this.m?E=this.m:E=(0,l.localize)(0,null,this.e.displayName||this.e.name);let h=this.n;this.o&&(h=R.b.get(this.o.id));const u=A.MarkdownString.fromStrict(this.l);Be(this,k,"f").$setEntry(this.c,D,this.e?.identifier.value,E,this.k,u,this.r?.internal,h,this.o,this.g===y.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$Bdc=R,k=new WeakMap,$=new WeakMap,R.a=0,R.b=new Map([["statusBarItem.errorBackground",new y.$nL("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new y.$nL("statusBarItem.warningForeground")]]);class P{constructor(D){this.b=[],this.a=D.createStatusBarEntry(void 0,"status.extensionMessage",y.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,l.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(D){const E={message:D};return this.b.unshift(E),this.c(),new y.$sK(()=>{const h=this.b.indexOf(E);h>=0&&(this.b.splice(h,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class p{constructor(D,E){this.e=new Map,this.a=D.getProxy(M.$qK.MainThreadStatusBar),this.b=E,this.c=new P(this)}$acceptStaticEntries(D){for(const E of D)this.e.set(E.entryId,E)}createStatusBarEntry(D,E,h,u){return new R(this.a,this.b,this.e,D,E,h,u)}setStatusBarMessage(D,E){const h=this.c.setMessage(D);let u;return typeof E=="number"?u=setTimeout(()=>h.dispose(),E):typeof E<"u"&&E.then(()=>h.dispose(),()=>h.dispose()),new y.$sK(()=>{h.dispose(),clearTimeout(u)})}}e.$Cdc=p}),define(De[116],Ce([1,0,6,4,5]),function(re,e,y,M,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7cc=e.$6cc=void 0;class L{constructor(g,k){this.c=k,this.b=new M.$Od,this.onDidChangeStorage=this.b.event,this.a=g.getProxy(y.$qK.MainThreadStorage)}registerExtensionStorageKeysToSync(g,k){this.a.$registerExtensionStorageKeysToSync(g,k)}async initializeExtensionStorage(g,k,$){const R=await this.a.$initializeExtensionStorage(g,k);let P;return R&&(P=this.d(g,k,R)),P||$}setValue(g,k,$){return this.a.$setValue(g,k,$)}$acceptValue(g,k,$){const R=this.d(g,k,$);R&&this.b.fire({shared:g,key:k,value:R})}d(g,k,$){try{return JSON.parse($)}catch(R){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${k}, global: ${g}): ${R}`)}}}e.$6cc=L,e.$7cc=(0,l.$Qh)("IExtHostStorage")}),define(De[90],Ce([1,0,5,27,14,72,2]),function(re,e,y,M,l,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$adc=e.$_cc=void 0,e.$_cc=(0,y.$Qh)("IExtensionStoragePaths");let g=class{constructor($,R,P){this.d=R,this.f=P,this.a=$.workspace??void 0,this.b=$.environment,this.whenReady=this.h().then(p=>this.c=p)}async g($){return A.URI.joinPath(this.b.workspaceStorageHome,$)}async h(){if(!this.a)return Promise.resolve(void 0);const $=this.a.id,R=await this.g($);try{return await this.f.value.stat(R),this.d.trace("[ExtHostStorage] storage dir already exists",R),R}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",R),await this.f.value.createDirectory(R),await this.f.value.writeFile(A.URI.joinPath(R,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:A.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),R}catch(P){this.d.error("[ExtHostStorage]",P);return}}workspaceValue($){if(this.c)return A.URI.joinPath(this.c,$.identifier.value)}globalValue($){return A.URI.joinPath(this.b.globalStorageHome,$.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$adc=g,e.$adc=g=He([We(0,M.$HM),We(1,l.$$i),We(2,L.$$cc)],g)}),define(De[45],Ce([1,0,4,6,5,2,20,3,7,212,9,254,21,31,255,59,8,13,34]),function(re,e,y,M,l,L,A,g,k,$,R,P,p,S,D,E,h,u,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$edc=e.$ddc=e.$cdc=e.$bdc=void 0,e.$bdc=(0,l.$Qh)("IExtHostTerminalService");class c{constructor(w,m,b,I){this.l=w,this._id=m,this.m=b,this.n=I,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.m=Object.freeze(this.m),this.b=new Promise(O=>this.f=O);const z=this;this.value={get name(){return z.n||""},get processId(){return z.b},get creationOptions(){return z.m},get exitStatus(){return z.h},get state(){return z.j},get selection(){return z.k},sendText(O,F=!0){z.q(),z.l.$sendText(z._id,O,F)},show(O){z.q(),z.l.$show(z._id,O)},hide(){z.q(),z.l.$hide(z._id)},dispose(){z.a||(z.a=!0,z.l.$dispose(z._id))},get dimensions(){if(!(z.d===void 0||z.g===void 0))return{columns:z.d,rows:z.g}}}}async create(w,m){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.l.$createTerminal(this._id,{name:w.name,shellPath:w.shellPath??void 0,shellArgs:w.shellArgs??void 0,cwd:w.cwd??void 0,env:w.env??void 0,icon:r(w.iconPath)??void 0,color:E.ThemeColor.isThemeColor(w.color)?w.color.id:void 0,initialText:w.message??void 0,strictEnv:w.strictEnv??void 0,hideFromUser:w.hideFromUser??void 0,isFeatureTerminal:m?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:m?.useShellEnvironment??void 0,location:m?.location||this.o(w.location,m?.resolvedExtHostIdentifier),isTransient:w.isTransient??void 0})}async createExtensionTerminal(w,m,b,I){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.l.$createTerminal(this._id,{name:this.n,isExtensionCustomPtyTerminal:!0,icon:b,color:E.ThemeColor.isThemeColor(I)?I.id:void 0,location:this.o(w,m),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}o(w,m){return typeof w=="object"?"parentTerminal"in w&&w.parentTerminal&&m?{parentTerminal:m}:"viewColumn"in w?{viewColumn:u.ViewColumn.from(w.viewColumn),preserveFocus:w.preserveFocus}:void 0:w}q(){if(this.a)throw new Error("Terminal has already been disposed")}set name(w){this.n=w}setExitStatus(w,m){this.h=Object.freeze({code:w,reason:m})}setDimensions(w,m){return w===this.d&&m===this.g||w===0||m===0?!1:(this.d=w,this.g=m,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}setSelection(w){this.k=w}_setProcessId(w){this.f?(this.f(w),this.f=void 0):this.b.then(m=>{m!==w&&(this.b=Promise.resolve(w))})}}e.$cdc=c;class f{get onProcessReady(){return this.b.event}constructor(w){this.g=w,this.id=0,this.shouldPersist=!1,this.a=new y.$Od,this.onProcessData=this.a.event,this.b=new y.$Od,this.d=new y.$Od,this.onDidChangeProperty=this.d.event,this.f=new y.$Od,this.onProcessExit=this.f.event}refreshProperty(w){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${w}`)}updateProperty(w,m){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${w}, value: ${m}`)}async start(){}shutdown(){this.g.close()}input(w){this.g.handleInput?.(w)}resize(w,m){this.g.setDimensions?.({columns:w,rows:m})}clearBuffer(){}async processBinary(w){}acknowledgeDataEvent(w){}async setUnicodeVersion(w){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(w){this.g.onDidWrite(m=>this.a.fire(m)),this.g.onDidClose?.((m=void 0)=>{this.f.fire(m===void 0?void 0:m)}),this.g.onDidOverrideDimensions?.(m=>{m&&this.d.fire({type:"overrideDimensions",value:{cols:m.columns,rows:m.rows}})}),this.g.onDidChangeName?.(m=>{this.d.fire({type:"title",value:m})}),this.g.open(w||void 0),w&&this.g.setDimensions?.(w),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let a=1,t=class extends g.$Sc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(w=>w.value)}constructor(w,m,b){super(),this.Q=m,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new g.$Tc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new y.$Od,this.onDidCloseTerminal=this.H.event,this.I=new y.$Od,this.onDidOpenTerminal=this.I.event,this.J=new y.$Od,this.onDidChangeActiveTerminal=this.J.event,this.L=new y.$Od,this.onDidChangeTerminalDimensions=this.L.event,this.M=new y.$Od,this.onDidChangeTerminalState=this.M.event,this.N=new y.$Od,this.onDidChangeShell=this.N.event,this.O=new y.$Od({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new y.$Od({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=b.getProxy(M.$qK.MainThreadTerminalService),this.y=new D.$clb(this.a.$sendProcessData),this.a.$registerProcessSupport(w),this.Q.registerArgumentProcessor({processArgument:I=>{const z=O=>{const F=O;return this.W(F.instanceId)?.value};switch(I?.$mid){case 15:return z(I);default:{if(Array.isArray(I))for(let O=0;O<I.length&&I[O].$mid===15;O++)I[O]=z(I[O]);return I}}}}),this.B({dispose:()=>{for(const[I,z]of this.g)z.shutdown(!0)}})}getDefaultShell(w){return(w?this.u:this.s)?.path||""}getDefaultShellArgs(w){return(w?this.u:this.s)?.args||[]}createExtensionTerminal(w,m){const b=new c(this.a,(0,S.$fg)(),w,w.name),I=new f(w.pty);return b.createExtensionTerminal(w.location,this.R(w,m).resolvedExtHostIdentifier,r(w.iconPath),o(w.color)).then(z=>{const O=this.S(z,I);this.h[z]=O}),this.f.push(b),b.value}R(w,m){if(m=m||{},w.location&&typeof w.location=="object"&&"parentTerminal"in w.location){const b=w.location.parentTerminal;if(b){const I=this.f.find(z=>z.value===b);I&&(m.resolvedExtHostIdentifier=I._id)}}else w.location&&typeof w.location!="object"?m.location=w.location:m.location&&typeof m.location=="object"&&"splitActiveTerminal"in m.location&&(m.location={splitActiveTerminal:!0});return m}attachPtyToTerminal(w,m){if(!this.W(w))throw new Error(`Cannot resolve terminal with id ${w} for virtual process`);const I=new f(m),z=this.S(w,I);this.h[w]=z}async $acceptActiveTerminalChanged(w){const m=this.b;if(w===null){this.b=void 0,m!==this.b&&this.J.fire(this.b);return}const b=this.W(w);b&&(this.b=b,m!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(w,m){const b=this.W(w);b&&this.O.fire({terminal:b.value,data:m})}async $acceptTerminalDimensions(w,m,b){const I=this.W(w);I&&I.setDimensions(m,b)&&this.L.fire({terminal:I.value,dimensions:I.value.dimensions})}async $acceptDidExecuteCommand(w,m){const b=this.W(w);b&&this.P.fire({terminal:b.value,...m})}async $acceptTerminalMaximumDimensions(w,m,b){this.g.get(w)?.resize(m,b)}async $acceptTerminalTitleChange(w,m){const b=this.W(w);b&&(b.name=m)}async $acceptTerminalClosed(w,m,b){const I=this.Y(this.f,w);if(I!==null){const z=this.f.splice(I,1)[0];z.setExitStatus(m,b),this.H.fire(z.value)}}$acceptTerminalOpened(w,m,b,I){if(m){const F=this.Y(this.f,m);if(F!==null){this.f[F]._id=w,this.I.fire(this.terminals[F]),this.f[F].isOpen=!0;return}}const z={name:I.name,shellPath:I.executable,shellArgs:I.args,cwd:typeof I.cwd=="string"?I.cwd:L.URI.revive(I.cwd),env:I.env,hideFromUser:I.hideFromUser},O=new c(this.a,w,z,b);this.f.push(O),this.I.fire(O.value),O.isOpen=!0}async $acceptTerminalProcessId(w,m){this.W(w)?._setProcessId(m)}async $startExtensionTerminal(w,m){const b=this.W(w);if(!b)return{message:(0,$.localize)(0,null,w)};b.isOpen||await new Promise(z=>{const O=this.onDidOpenTerminal(async F=>{F===b.value&&(O.dispose(),z())})});const I=this.g.get(w);I?I.startSendingEvents(m):this.j[w]={initialDimensions:m}}S(w,m){const b=new g.$Rc;b.add(m.onProcessReady(z=>this.a.$sendProcessReady(w,z.pid,z.cwd,z.windowsPty))),b.add(m.onDidChangeProperty(z=>this.a.$sendProcessProperty(w,z))),this.y.startBuffering(w,m.onProcessData),b.add(m.onProcessExit(z=>this.U(w,z))),this.g.set(w,m);const I=this.j[w];return I&&m instanceof f&&(m.startSendingEvents(I.initialDimensions),delete this.j[w]),b}$acceptProcessAckDataEvent(w,m){this.g.get(w)?.acknowledgeDataEvent(m)}$acceptProcessInput(w,m){this.g.get(w)?.input(m)}$acceptTerminalInteraction(w){const m=this.W(w);m?.setInteractedWith()&&this.M.fire(m.value)}$acceptTerminalSelection(w,m){this.W(w)?.setSelection(m)}$acceptProcessResize(w,m,b){try{this.g.get(w)?.resize(m,b)}catch(I){if(I.code!=="EPIPE"&&I.code!=="ERR_IPC_CHANNEL_CLOSED")throw I}}$acceptProcessShutdown(w,m){this.g.get(w)?.shutdown(m)}$acceptProcessRequestInitialCwd(w){this.g.get(w)?.getInitialCwd().then(m=>this.a.$sendProcessProperty(w,{type:"initialCwd",value:m}))}$acceptProcessRequestCwd(w){this.g.get(w)?.getCwd().then(m=>this.a.$sendProcessProperty(w,{type:"cwd",value:m}))}$acceptProcessRequestLatency(w){return Promise.resolve(w)}registerLinkProvider(w){return this.z.add(w),this.z.size===1&&this.a.$startLinkProvider(),new k.$sK(()=>{this.z.delete(w),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(w,m,b){if(this.C.has(m))throw new Error(`Terminal profile provider "${m}" already registered`);return this.C.set(m,b),this.a.$registerProfileProvider(m,w.identifier.value),new k.$sK(()=>{this.C.delete(m),this.a.$unregisterProfileProvider(m)})}registerTerminalQuickFixProvider(w,m,b){if(this.D.has(w))throw new Error(`Terminal quick fix provider "${w}" is already registered`);return this.D.set(w,b),this.a.$registerQuickFixProvider(w,m),new k.$sK(()=>{this.D.delete(w),this.a.$unregisterQuickFixProvider(w)})}async $provideTerminalQuickFixes(w,m){const b=new p.$Yd().token;if(b.isCancellationRequested)return;const I=this.D.get(w);if(!I)return;const z=await I.provideTerminalQuickFixes(m,b);if(z===null||Array.isArray(z)&&z.length===0)return;const O=new g.$Rc;if(this.w.value=O,!Array.isArray(z))return z?u.TerminalQuickFix.from(z,this.Q.converter,O):void 0;const F=[];for(const T of z){const N=u.TerminalQuickFix.from(T,this.Q.converter,O);N&&F.push(N)}return F}async $createContributedProfileTerminal(w,m){const b=new p.$Yd().token;let I=await this.C.get(w)?.provideTerminalProfile(b);if(!b.isCancellationRequested){if(I&&!("options"in I)&&(I={options:I}),!I||!("options"in I))throw new Error(`No terminal profile options provided for id "${w}"`);if("pty"in I.options){this.createExtensionTerminal(I.options,m);return}this.createTerminalFromOptions(I.options,m)}}async $provideLinks(w,m){const b=this.W(w);if(!b)return[];this.F.delete(w),this.G.get(w)?.dispose(!0);const z=new p.$Yd;this.G.set(w,z);const O=[],F={terminal:b.value,line:m},T=[];for(const U of this.z)T.push(h.Promises.withAsyncBody(async B=>{z.token.onCancellationRequested(()=>B({provider:U,links:[]}));const he=await U.provideTerminalLinks(F,z.token)||[];z.token.isCancellationRequested||B({provider:U,links:he})}));const N=await Promise.all(T);if(z.token.isCancellationRequested)return[];const j=new Map;for(const U of N)U&&U.links.length>0&&O.push(...U.links.map(B=>{const he={id:a++,startIndex:B.startIndex,length:B.length,label:B.tooltip};return j.set(he.id,{provider:U.provider,link:B}),he}));return this.F.set(w,j),O}$activateLink(w,m){const b=this.F.get(w)?.get(m);b&&b.provider.handleTerminalLink(b.link)}U(w,m){this.y.stopBuffering(w),this.g.delete(w),delete this.j[w];const b=this.h[w];b&&(b.dispose(),delete this.h[w]),this.a.$sendProcessExit(w,m)}W(w){return this.X(this.f,w)}X(w,m){const b=this.Y(w,m);return b!==null?w[b]:null}Y(w,m){const b=w.findIndex(I=>I._id===m);return b===-1?null:b}getEnvironmentVariableCollection(w){let m=this.n.get(w.identifier.value);return m||(m=new i,this.$(w.identifier.value,m)),m.getScopedEnvironmentVariableCollection(void 0)}Z(w,m){const b=(0,P.$pr)(m.map),I=(0,P.$qr)(m.descriptionMap);this.a.$setEnvironmentVariableCollection(w,m.persistent,b.length===0?void 0:b,I)}$initEnvironmentVariableCollections(w){w.forEach(m=>{const b=m[0],I=new i(m[1]);this.$(b,I)})}$acceptDefaultProfile(w,m){const b=this.s;this.s=w,this.u=m,b?.path!==w.path&&this.N.fire(w.path)}$(w,m){this.n.set(w,m),m.onDidChangeCollection(()=>{this.Z(w,m)})}};e.$ddc=t,e.$ddc=t=He([We(1,d.$NM),We(2,A.$rM)],t);class i{get persistent(){return this.b}set persistent(w){this.b=w,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor(w){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new y.$Od,this.map=new Map(w)}getScopedEnvironmentVariableCollection(w){const m=this.h(w);let b=this.a.get(m);return b||(b=new s(this,w),this.a.set(m,b),b.onDidChangeCollection(()=>this.d.fire())),b}replace(w,m,b,I){this.f(w,{value:m,type:k.EnvironmentVariableMutatorType.Replace,options:b??{applyAtProcessCreation:!0},scope:I})}append(w,m,b,I){this.f(w,{value:m,type:k.EnvironmentVariableMutatorType.Append,options:b??{applyAtProcessCreation:!0},scope:I})}prepend(w,m,b,I){this.f(w,{value:m,type:k.EnvironmentVariableMutatorType.Prepend,options:b??{applyAtProcessCreation:!0},scope:I})}f(w,m){if(m.options&&m.options.applyAtProcessCreation===!1&&!m.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const b=this.g(w,m.scope),I=this.map.get(b),z=m.options?{applyAtProcessCreation:m.options.applyAtProcessCreation??!1,applyAtShellIntegration:m.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!I||I.value!==m.value||I.type!==m.type||I.options?.applyAtProcessCreation!==z.applyAtProcessCreation||I.options?.applyAtShellIntegration!==z.applyAtShellIntegration||I.scope?.workspaceFolder?.index!==m.scope?.workspaceFolder?.index){const O=this.g(w,m.scope),F={variable:w,...m,options:z};this.map.set(O,F),this.d.fire()}}get(w,m){const b=this.g(w,m),I=this.map.get(b);return I?v(I):void 0}g(w,m){const b=this.h(m);return b.length?`${w}:::${b}`:w}h(w){return this.j(w?.workspaceFolder)??""}j(w){return w?w.uri.toString():void 0}getVariableMap(w){const m=new Map;for(const[b,I]of this.map)this.h(I.scope)===this.h(w)&&m.set(I.variable,v(I));return m}delete(w,m){const b=this.g(w,m);this.map.delete(b),this.d.fire()}clear(w){if(w?.workspaceFolder){for(const[m,b]of this.map)b.scope?.workspaceFolder?.index===w.workspaceFolder.index&&this.map.delete(m);this.k(w)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription(w,m){const b=this.h(m),I=this.descriptionMap.get(b);if(!I||I.description!==w){let z;typeof w=="string"?z=w:z=w?.value.split(`

`)[0];const O={description:z,scope:m};this.descriptionMap.set(b,O),this.d.fire()}}getDescription(w){const m=this.h(w);return this.descriptionMap.get(m)?.description}k(w){const m=this.h(w);this.descriptionMap.delete(m)}}class s{get persistent(){return this.b.persistent}set persistent(w){this.b.persistent=w}get onDidChangeCollection(){return this.a&&this.a.event}constructor(w,m){this.b=w,this.d=m,this.a=new y.$Od}getScoped(w){return this.b.getScopedEnvironmentVariableCollection(w)}replace(w,m,b){this.b.replace(w,m,b,this.d)}append(w,m,b){this.b.append(w,m,b,this.d)}prepend(w,m,b){this.b.prepend(w,m,b,this.d)}get(w){return this.b.get(w,this.d)}forEach(w,m){this.b.getVariableMap(this.d).forEach((b,I)=>w.call(m,I,b,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(w){this.b.delete(w,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(w){this.b.setDescription(w,this.d)}get description(){return this.b.getDescription(this.d)}}let n=class extends t{constructor(w,m){super(!1,w,m)}createTerminal(w,m,b){throw new R.$_}createTerminalFromOptions(w,m){throw new R.$_}};e.$edc=n,e.$edc=n=He([We(0,d.$NM),We(1,A.$rM)],n);function r(C){if(!(!C||typeof C=="string"))return"id"in C?{id:C.id,color:C.color}:C}function o(C){return E.ThemeColor.isThemeColor(C)?C:void 0}function v(C){const w={...C};return delete w.scope,w.options=w.options??void 0,delete w.variable,w}});var Be=this&&this.__classPrivateFieldGet||function(re,e,y,M){if(y==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!M:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return y==="m"?M:y==="a"?M.call(re):M?M.value:e.get(re)},et=this&&this.__classPrivateFieldSet||function(re,e,y,M,l){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!l)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!l:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?l.call(re,y):l?l.value=y:e.set(re,y),y};define(De[330],Ce([1,0,119,8,22,21,4,75,52,3,24,17,31,6,20,148,13,7,68,110,87]),function(re,e,y,M,l,L,A,g,k,$,R,P,p,S,D,E,h,u,d,c,f){"use strict";var a,t;Object.defineProperty(e,"__esModule",{value:!0}),e.$oec=e.$nec=e.$mec=e.$lec=void 0;let i=class{constructor(T,N,j){this.j=j,this.c=new A.$Od,this.d=new Map,this.onResultsChanged=this.c.event,this.results=[],this.f=T.getProxy(S.$qK.MainThreadTesting),this.h=new I(this.f),this.g=new o(this.f),N.registerArgumentProcessor({processArgument:U=>{switch(U?.$mid){case 16:{const B=U,he=B.tests[B.tests.length-1].item.extId;return this.d.get(d.$jJ.root(he))?.collection.tree.get(he)?.actual??(0,E.$DM)(U)}case 18:{const{extId:B,message:he}=U;return{test:this.d.get(d.$jJ.root(B))?.collection.tree.get(B)?.actual,message:h.TestMessage.to(he)}}default:return U}}}),N.registerCommand(!1,"testing.getExplorerSelection",async()=>{const U=await N.executeCommand("_testing.getExplorerSelection"),B=he=>{const x=this.d.get(d.$jJ.root(he));if(x)return d.$jJ.isRoot(he)?x.controller:x.collection.tree.get(he)?.actual};return{include:U?.include.map(B).filter(P.$Hf)||[],exclude:U?.exclude.map(B).filter(P.$Hf)||[]}})}createTestController(T,N,j,U){if(this.d.has(N))throw new Error(`Attempt to insert a duplicate controller with ID "${N}"`);const B=new $.$Rc,he=B.add(new E.$GM(N,j,this.j));he.root.label=j;const x=new Map,Q=this.f,Z={items:he.root.children,get label(){return j},set label(_){j=_,he.root.label=_,Q.$updateController(N,{label:j})},get refreshHandler(){return U},set refreshHandler(_){U=_,Q.$updateController(N,{canRefresh:!!_})},get id(){return N},createRunProfile:(_,oe,ye,fe,V,le)=>{let H=(0,k.$Ei)(_);for(;x.has(H);)H++;return new z(this.f,x,N,H,_,oe,ye,fe,V,le)},createTestItem(_,oe,ye){return new E.$EM(N,_,oe,ye)},createTestRun:(_,oe,ye=!0)=>this.g.createTestRun(T,N,he,_,oe,ye),invalidateTestResults:_=>{if(_===void 0)this.f.$markTestRetired(void 0);else{const oe=_ instanceof Array?_:[_];this.f.$markTestRetired(oe.map(ye=>d.$jJ.fromExtHostTestItem(ye,N).toString()))}},set resolveHandler(_){he.resolveHandler=_},get resolveHandler(){return he.resolveHandler},dispose:()=>{B.dispose()}};Q.$registerTestController(N,j,!!U),B.add((0,$.$Qc)(()=>Q.$unregisterTestController(N)));const ie={controller:Z,collection:he,profiles:x,extension:T};return this.d.set(N,ie),B.add((0,$.$Qc)(()=>this.d.delete(N))),B.add(he.onDidGenerateDiff(_=>Q.$publishDiff(N,_.map(f.TestsDiffOp.serialize)))),Z}createTestObserver(){return this.h.checkout()}async runTests(T,N=L.CancellationToken.None){const j=v(T);if(!j)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const U=this.d.get(j.controllerId);if(!U)throw new Error("Controller not found");await this.f.$runTests({isUiTriggered:!1,targets:[{testIds:T.include?.map(B=>d.$jJ.fromExtHostTestItem(B,U.collection.root.id).toString())??[U.collection.root.id],profileGroup:O[j.kind],profileId:j.profileId,controllerId:j.controllerId}],exclude:T.exclude?.map(B=>B.id)},N)}$syncTests(){for(const{collection:T}of this.d.values())T.flushDiff();return Promise.resolve()}$provideFileCoverage(T,N,j){return(0,y.$rb)(this.g.trackers,B=>B.id===T?B.getCoverage(N):void 0)?.provideFileCoverage(j)??Promise.resolve([])}$resolveFileCoverage(T,N,j,U){return(0,y.$rb)(this.g.trackers,he=>he.id===T?he.getCoverage(N):void 0)?.resolveFileCoverage(j,U)??Promise.resolve([])}$configureRunProfile(T,N){this.d.get(T)?.profiles.get(N)?.configureHandler?.()}async $refreshTests(T,N){await this.d.get(T)?.controller.refreshHandler?.(N)}$publishTestResults(T){this.results=Object.freeze(T.map(N=>(0,R.$0m)(h.TestResults.to(N))).concat(this.results).sort((N,j)=>j.completedAt-N.completedAt).slice(0,32)),this.c.fire()}async $expandTest(T,N){const j=this.d.get(d.$jJ.fromString(T).controllerId)?.collection;j&&(await j.expand(T,N<0?1/0:N),j.flushDiff())}$acceptDiff(T){this.h.applyDiff(T.map(f.TestsDiffOp.deserialize))}async $runControllerTests(T,N){return Promise.all(T.map(j=>this.k(j,!1,N)))}async $startContinuousRun(T,N){const j=new L.$Yd(N),U=await Promise.all(T.map(B=>this.k(B,!0,j.token)));return!N.isCancellationRequested&&!U.some(B=>B.error)&&await new Promise(B=>N.onCancellationRequested(B)),j.dispose(!0),U}async k(T,N,j){const U=this.d.get(T.controllerId);if(!U)return{};const{collection:B,profiles:he,extension:x}=U,Q=he.get(T.profileId);if(!Q)return{};const Z=T.testIds.map(ye=>B.tree.get(ye)).filter(P.$Hf),ie=T.excludeExtIds.map(ye=>U.collection.tree.get(ye)).filter(P.$Hf).filter(ye=>Z.some(fe=>fe.fullId.compare(ye.fullId)===2));if(!Z.length)return{};const _=new u.$1L(Z.some(ye=>ye.actual instanceof E.$FM)?void 0:Z.map(ye=>ye.actual),ie.map(ye=>ye.actual),Q,N),oe=(0,f.$lJ)(T)&&this.g.prepareForMainThreadTestRun(_,C.fromInternal(T,U.collection),x,j);try{return await Q.runHandler(_,j),{}}catch(ye){return{error:String(ye)}}finally{oe&&(oe.hasRunningTasks&&!j.isCancellationRequested&&await A.Event.toPromise(oe.onEnd),oe.dispose())}}$cancelExtensionTestRun(T){T===void 0?this.g.cancelAllRuns():this.g.cancelRunById(T)}};e.$lec=i,e.$lec=i=He([We(0,D.$rM)],i);const s=1e4;var n;(function(F){F[F.Running=0]="Running",F[F.Cancelling=1]="Cancelling",F[F.Ended=2]="Ended"})(n||(n={}));class r extends $.$Sc{get hasRunningTasks(){return this.f.size>0}get id(){return this.m.id}constructor(T,N,j){super(),this.m=T,this.s=N,this.c=0,this.f=new Map,this.g=new Set,this.j=this.B(new A.$Od),this.onEnd=this.j.event,this.h=this.B(new L.$Yd(j));const U=this.B(new M.$7g(()=>this.u(),s));this.B(this.h.token.onCancellationRequested(()=>U.schedule()))}cancel(){this.c===0?(this.h.cancel(),this.c=1):this.c===1&&this.u()}getCoverage(T){return this.f.get(T)?.coverage}createRun(T){const N=this.m.id,j=this.m.controllerId,U=(0,p.$fg)(),B=new w(this.s,N,U),he=ie=>(_,...oe)=>{if(Q){console.warn(`Setting the state of test "${_.id}" is a no-op after the run ends.`);return}this.m.isIncluded(_)&&(this.y(_),ie(_,...oe))},x=(ie,_)=>{const oe=_ instanceof Array?_.map(h.TestMessage.from):[h.TestMessage.from(_)];if(ie.uri&&ie.range){const ye={range:h.Range.from(ie.range),uri:ie.uri};for(const fe of oe)fe.location=fe.location||ye}this.s.$appendTestMessagesInRun(N,U,d.$jJ.fromExtHostTestItem(ie,j).toString(),oe)};let Q=!1;const Z={isPersisted:this.m.isPersisted,token:this.h.token,name:T,get coverageProvider(){return B.coverageProvider},set coverageProvider(ie){B.coverageProvider=ie},enqueued:he(ie=>{this.s.$updateTestStateInRun(N,U,d.$jJ.fromExtHostTestItem(ie,j).toString(),1)}),skipped:he(ie=>{this.s.$updateTestStateInRun(N,U,d.$jJ.fromExtHostTestItem(ie,j).toString(),5)}),started:he(ie=>{this.s.$updateTestStateInRun(N,U,d.$jJ.fromExtHostTestItem(ie,j).toString(),2)}),errored:he((ie,_,oe)=>{x(ie,_),this.s.$updateTestStateInRun(N,U,d.$jJ.fromExtHostTestItem(ie,j).toString(),6,oe)}),failed:he((ie,_,oe)=>{x(ie,_),this.s.$updateTestStateInRun(N,U,d.$jJ.fromExtHostTestItem(ie,j).toString(),4,oe)}),passed:he((ie,_)=>{this.s.$updateTestStateInRun(N,U,d.$jJ.fromExtHostTestItem(ie,this.m.controllerId).toString(),3,_)}),appendOutput:(ie,_,oe)=>{Q||(oe&&(this.m.isIncluded(oe)?this.y(oe):oe=void 0),this.s.$appendOutputToRun(N,U,l.$ce.fromString(ie),_&&h.location.from(_),oe&&d.$jJ.fromExtHostTestItem(oe,j).toString()))},end:()=>{Q||(Q=!0,this.s.$finishedTestRunTask(N,U),this.f.delete(U),this.f.size||this.w())}};return this.f.set(U,{run:Z,coverage:B}),this.s.$startedTestRunTask(N,{id:U,name:T,running:!0}),Z}u(){for(const{run:T}of this.f.values())T.end()}w(){this.c!==2&&(this.c=2,this.j.fire())}y(T){if(!(T instanceof E.$EM))throw new c.$jM(T.id);if(this.g.has(d.$jJ.fromExtHostTestItem(T,this.m.controllerId).toString()))return;const N=[],j=this.m.colllection.root;for(;;){const U=h.TestItem.from(T);if(N.unshift(U),this.g.has(U.extId)||(this.g.add(U.extId),T===j))break;T=T.parent||j}this.s.$addTestsToRun(this.m.controllerId,this.m.id,N)}dispose(){this.w(),super.dispose()}}class o{get trackers(){return this.c.values()}constructor(T){this.d=T,this.c=new Map}prepareForMainThreadTestRun(T,N,j,U){return this.f(T,N,j,U)}cancelRunById(T){for(const N of this.c.values())if(N.id===T){N.cancel();return}}cancelAllRuns(){for(const T of this.c.values())T.cancel()}createTestRun(T,N,j,U,B,he){const x=this.c.get(U);if(x)return x.createRun(B);const Q=C.fromPublic(N,j,U,he),Z=v(U);this.d.$startedExtensionTestRun({controllerId:N,continuous:!!U.continuous,profile:Z&&{group:O[Z.kind],id:Z.profileId},exclude:U.exclude?.map(_=>d.$jJ.fromExtHostTestItem(_,j.root.id).toString())??[],id:Q.id,include:U.include?.map(_=>d.$jJ.fromExtHostTestItem(_,j.root.id).toString())??[j.root.id],persist:he});const ie=this.f(U,Q,T);return A.Event.once(ie.onEnd)(()=>{this.d.$finishedExtensionTestRun(Q.id),ie.dispose()}),ie.createRun(B)}f(T,N,j,U){const B=new r(N,this.d,U);return this.c.set(T,B),A.Event.once(B.onEnd)(()=>this.c.delete(T)),B}}e.$mec=o;const v=F=>{if(F.profile){if(!(F.profile instanceof z))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return F.profile}};class C{static fromPublic(T,N,j,U){return new C(T,(0,p.$fg)(),j.include?.map(B=>d.$jJ.fromExtHostTestItem(B,T).toString())??[T],j.exclude?.map(B=>d.$jJ.fromExtHostTestItem(B,T).toString())??[],U,N)}static fromInternal(T,N){return new C(T.controllerId,T.runId,T.testIds,T.excludeExtIds,!0,N)}constructor(T,N,j,U,B,he){this.controllerId=T,this.id=N,this.isPersisted=B,this.colllection=he,this.c=j.map(x=>x+"\0"),this.d=U.map(x=>x+"\0")}isIncluded(T){const N=d.$jJ.fromExtHostTestItem(T,this.controllerId).toString()+"\0";for(const j of this.d)if(N===j||N.startsWith(j))return!1;for(const j of this.c)if(N===j||N.startsWith(j))return!0;return!1}}e.$nec=C;class w{set coverageProvider(T){if(this.c)throw new Error("The TestCoverageProvider cannot be replaced after being provided");T&&(this.c=T,this.f.$signalCoverageAvailable(this.g,this.h))}get coverageProvider(){return this.c}constructor(T,N,j){this.f=T,this.g=N,this.h=j}async provideFileCoverage(T){if(!this.c)return[];this.d||(this.d=(async()=>this.c.provideFileCoverage(T))());try{return(await this.d)?.map(h.TestCoverage.fromFile)??[]}catch(N){throw this.d=void 0,N}}async resolveFileCoverage(T,N){const j=await this.d;let U=j?.[T];return!this.c||!j||!U?[]:(U.detailedCoverage||(U=j[T]=await this.c.resolveFileCoverage?.(U,N)??U),U.detailedCoverage?.map(h.TestCoverage.fromDetailed)??[])}}class m{get isEmpty(){return this.c.size===0&&this.f.size===0&&this.d.size===0}constructor(T){this.h=T,this.c=new Set,this.d=new Set,this.f=new Set,this.g=new Set}add(T){this.c.add(T)}update(T){Object.assign(T.revived,h.TestItem.toPlain(T.item)),this.c.has(T)||this.d.add(T)}remove(T){if(this.c.has(T)){this.c.delete(T);return}this.d.delete(T);const N=d.$jJ.parentId(T.item.extId);if(N&&this.g.has(N.toString())){this.g.add(T.item.extId);return}this.f.add(T)}getChangeEvent(){const{c:T,d:N,f:j}=this;return{get added(){return[...T].map(U=>U.revived)},get updated(){return[...N].map(U=>U.revived)},get removed(){return[...j].map(U=>U.revived)}}}complete(){this.isEmpty||this.h.fire(this.getChangeEvent())}}class b extends f.$qJ{constructor(){super(...arguments),this.q=new A.$Od,this.onDidChangeTests=this.q.event}get rootTests(){return this.f}getMirroredTestDataById(T){return this.d.get(T)}getMirroredTestDataByReference(T){return this.d.get(T.id)}p(T,N){return{...T,revived:h.TestItem.toPlain(T.item),depth:N?N.depth+1:0,children:new Set}}o(){return new m(this.q)}}class I{constructor(T){this.d=T}checkout(){this.c||(this.c=this.f());const T=this.c;return T.observers++,{onDidChangeTest:T.tests.onDidChangeTests,get tests(){return[...T.tests.rootTests].map(N=>N.revived)},dispose:(0,g.$db)(()=>{--T.observers===0&&(this.d.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(T){return this.c?.tests.getMirroredTestDataByReference(T)}applyDiff(T){this.c?.tests.apply(T)}f(){const T=new b;return this.d.$subscribeToDiffs(),{observers:0,tests:T}}}class z{get label(){return this.d}set label(T){T!==this.d&&(this.d=T,Be(this,a,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:T}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(T){T!==this.g&&(this.g=T,Be(this,a,"f").$updateTestRunConfig(this.controllerId,this.profileId,{supportsContinuousRun:T}))}get isDefault(){return this.f}set isDefault(T){T!==this.f&&(this.f=T,Be(this,a,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:T}))}get tag(){return this._tag}set tag(T){T?.id!==this._tag?.id&&(this._tag=T,Be(this,a,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:T?h.TestTag.namespace(this.controllerId,T.id):null}))}get configureHandler(){return this.c}set configureHandler(T){T!==this.c&&(this.c=T,Be(this,a,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!T}))}constructor(T,N,j,U,B,he,x,Q=!1,Z=void 0,ie=!1){this.controllerId=j,this.profileId=U,this.d=B,this.kind=he,this.runHandler=x,this.f=Q,this._tag=Z,this.g=ie,a.set(this,void 0),t.set(this,void 0),et(this,a,T,"f"),et(this,t,N,"f"),N.set(U,this);const _=O[he];if(typeof _!="number")throw new Error(`Unknown TestRunProfile.group ${he}`);Be(this,a,"f").$publishTestRunProfile({profileId:U,controllerId:j,tag:Z?h.TestTag.namespace(this.controllerId,Z.id):null,label:B,group:_,isDefault:Q,hasConfigurationHandler:!1,supportsContinuousRun:ie})}dispose(){Be(this,t,"f")?.delete(this.profileId)&&(et(this,t,void 0,"f"),Be(this,a,"f").$removeTestProfile(this.controllerId,this.profileId))}}e.$oec=z,a=new WeakMap,t=new WeakMap;const O={[u.TestRunProfileKind.Coverage]:8,[u.TestRunProfileKind.Debug]:4,[u.TestRunProfileKind.Run]:2}}),define(De[331],Ce([1,0,19,9,4,6,149,13,7]),function(re,e,y,M,l,L,A,g,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ddc=void 0;class ${constructor(P,p){this.i=p,this.a=new l.$Od({onListenerError:M.$2}),this.b=new l.$Od({onListenerError:M.$2}),this.c=new l.$Od({onListenerError:M.$2}),this.d=new l.$Od({onListenerError:M.$2}),this.f=new l.$Od({onListenerError:M.$2}),this.g=new l.$Od({onListenerError:M.$2}),this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=P.getProxy(L.$qK.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(S=>this.g.fire(S)),this.i.onDidChangeActiveTextEditor(S=>this.f.fire(S))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(P){const p=this.i.allEditors();return P?p:p.map(S=>S.value)}async showTextDocument(P,p,S){let D;typeof p=="number"?D={position:g.ViewColumn.from(p),preserveFocus:S}:typeof p=="object"?D={position:g.ViewColumn.from(p.viewColumn),preserveFocus:p.preserveFocus,selection:typeof p.selection=="object"?g.Range.from(p.selection):void 0,pinned:typeof p.preview=="boolean"?!p.preview:void 0}:D={preserveFocus:!1};const E=await this.h.$tryShowTextDocument(P.uri,D),h=E&&this.i.getEditor(E);if(h)return h.value;throw E?new Error(`Could NOT open editor for "${P.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${P.uri.toString()}".`)}createTextEditorDecorationType(P,p){return new A.$yM(this.h,P,p).value}$acceptEditorPropertiesChanged(P,p){const S=this.i.getEditor(P);if(!S)throw new Error("unknown text editor");if(p.options&&S._acceptOptions(p.options),p.selections){const D=p.selections.selections.map(g.Selection.to);S._acceptSelections(D)}if(p.visibleRanges){const D=y.$Hb(p.visibleRanges.map(g.Range.to));S._acceptVisibleRanges(D)}if(p.options&&this.b.fire({textEditor:S.value,options:{...p.options,lineNumbers:g.TextEditorLineNumbersStyle.to(p.options.lineNumbers)}}),p.selections){const D=k.TextEditorSelectionChangeKind.fromValue(p.selections.source),E=p.selections.selections.map(g.Selection.to);this.a.fire({textEditor:S.value,selections:E,kind:D})}if(p.visibleRanges){const D=y.$Hb(p.visibleRanges.map(g.Range.to));this.c.fire({textEditor:S.value,visibleRanges:D})}}$acceptEditorPositionData(P){for(const p in P){const S=this.i.getEditor(p);if(!S)throw new Error("Unknown text editor");const D=g.ViewColumn.to(P[p]);S.value.viewColumn!==D&&(S._acceptViewColumn(D),this.d.fire({textEditor:S.value,viewColumn:D}))}}getDiffInformation(P){return Promise.resolve(this.h.$getDiffInformation(P))}}e.$Ddc=$}),define(De[332],Ce([1,0,2,5,6,3,7,13,25,17]),function(re,e,y,M,l,L,A,g,k,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gec=e.$fec=void 0,e.$fec=(0,M.$Qh)("IExtHostTimeline");class R{constructor(S,D){this.b=new Map,this.c=new Map,this.a=S.getProxy(l.$qK.MainThreadTimeline),D.registerArgumentProcessor({processArgument:(E,h)=>{if(E&&E.$mid===12)if(this.b.get(E.source)&&k.$8l.equals(h,this.b.get(E.source)?.extension)){const u=E.uri===void 0?void 0:y.URI.revive(E.uri);return this.c.get(E.source)?.get(P(u))?.get(E.handle)}else return;return E}})}async $getTimeline(S,D,E,h){return this.b.get(S)?.provider.provideTimeline(y.URI.revive(D),E,h)}registerTimelineProvider(S,D,E,h){const u=new L.$Rc,d=this.d(D.id,h,u).bind(this);let c;D.onDidChange&&(c=D.onDidChange(a=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...a,id:D.id}),this));const f=this.c;return this.f({...D,scheme:S,onDidChange:void 0,async provideTimeline(a,t,i){t?.resetCache&&(u.clear(),f.get(D.id)?.clear());const s=await D.provideTimeline(a,t,i);if(s==null)return;const n=d(a,t);return{...s,source:D.id,items:s.items.map(n)}},dispose(){for(const a of f.values())a.get(D.id)?.clear();c?.dispose(),u.dispose()}},E)}d(S,D,E){return(h,u)=>{let d;if(u?.cacheResults){let c=this.c.get(S);c===void 0&&(c=new Map,this.c.set(S,c));const f=P(h);d=c.get(f),d===void 0&&(d=new Map,c.set(f,d))}return c=>{const{iconPath:f,...a}=c,t=`${S}|${c.id??c.timestamp}`;d?.set(t,c);let i,s,n;c.iconPath&&(f instanceof A.$mL?n={id:f.id,color:f.color}:y.URI.isUri(f)?(i=f,s=f):{light:i,dark:s}=f);let r;return A.$SK.isMarkdownString(a.tooltip)?r=g.MarkdownString.from(a.tooltip):(0,$.$zf)(a.tooltip)?r=a.tooltip:A.$SK.isMarkdownString(a.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),r=g.MarkdownString.from(a.detail)):(0,$.$zf)(a.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),r=a.detail),{...a,id:a.id??void 0,handle:t,source:S,command:c.command?D.toInternal(c.command,E):void 0,icon:i,iconDark:s,themeIcon:n,tooltip:r,accessibilityInformation:c.accessibilityInformation}}}}f(S,D){if(this.b.get(S.id))throw new Error(`Timeline Provider ${S.id} already exists.`);return this.a.$registerTimelineProvider({id:S.id,label:S.label,scheme:S.scheme}),this.b.set(S.id,{provider:S,extension:D}),(0,L.$Qc)(()=>{for(const h of this.c.values())h.get(S.id)?.clear();this.b.delete(S.id),this.a.$unregisterTimelineProvider(S.id),S.dispose()})}}e.$gec=R;function P(p){return p?.toString()}}),define(De[73],Ce([1,0,21,4,3,214,5,14,86,6,27,20,7]),function(re,e,y,M,l,L,A,g,k,$,R,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vwb=e.$uwb=e.TunnelDtoConverter=void 0;class S extends k.$lv{}var D;(function(h){function u(c){return{remoteAddress:c.remoteAddress,localAddress:c.localAddress,public:!!c.public,privacy:c.privacy??(c.public?k.TunnelPrivacyId.Public:k.TunnelPrivacyId.Private),protocol:c.protocol}}h.fromApiTunnel=u;function d(c){return{remoteAddress:{host:c.tunnelRemoteHost,port:c.tunnelRemotePort},localAddress:c.localAddress,public:c.privacy!==k.TunnelPrivacyId.ConstantPrivate&&c.privacy!==k.TunnelPrivacyId.ConstantPrivate,privacy:c.privacy,protocol:c.protocol}}h.fromServiceTunnel=d})(D||(e.TunnelDtoConverter=D={})),e.$uwb=(0,A.$Qh)("IExtHostTunnelService");let E=class extends l.$Sc{constructor(u,d,c){super(),this.s=c,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new M.$Od,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=u.getProxy($.$qK.MainThreadTunnelService)}async openTunnel(u,d){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${u.identifier.value} called openTunnel API for ${d.remoteAddress.host}:${d.remoteAddress.port}.`);const c=await this.a.$openTunnel(d,u.displayName);if(c){const f=new S(c.remoteAddress,c.localAddress,()=>this.a.$closeTunnel(c.remoteAddress));return this.B(f),f}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(u,d){const c=this.u();return this.r.set(c,{selector:u,provider:d}),this.a.$registerPortsAttributesProvider(u,c),new p.$sK(()=>{this.r.delete(c),this.a.$unregisterPortsAttributesProvider(c)})}async $providePortAttributes(u,d,c,f,a){const t=[];for(const s of u){const n=this.r.get(s);if(!n)return[];t.push(...await Promise.all(d.map(async r=>{let o;try{o=await n.provider.providePortAttributes({port:r,pid:c,commandLine:f},a)}catch{o=await n.provider.providePortAttributes(r,c,f,a)}return{providedAttributes:o,port:r}})))}const i=t.filter(s=>!!s.providedAttributes);return i.length>0?i.map(s=>({autoForwardAction:s.providedAttributes.autoForwardAction,port:s.port})):[]}async $registerCandidateFinder(u){}registerTunnelProvider(u,d){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(f,a)=>await u.provideTunnel(f,a,new y.$Yd().token)??void 0;const c=d.tunnelFeatures?{elevation:!!d.tunnelFeatures?.elevation,privacyOptions:d.tunnelFeatures?.privacyOptions}:void 0;return this.a.$setTunnelProvider(c),Promise.resolve((0,l.$Qc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(u,d){if(u){u.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(u.candidatePortSource),u.showCandidatePort&&(this.f=u.showCandidatePort,this.a.$setCandidateFilter());const c=u.tunnelFactory??(d?this.w(d):void 0);if(c){this.b=c;let f=u.tunnelFeatures?.privacyOptions??[];u.tunnelFeatures?.public&&f.length===0&&(f=[{id:"private",label:L.localize(0,null),themeIcon:"lock"},{id:"public",label:L.localize(1,null),themeIcon:"eye"}]);const a=u.tunnelFeatures?{elevation:!!u.tunnelFeatures?.elevation,public:!!u.tunnelFeatures?.public,privacyOptions:f}:void 0;this.a.$setTunnelProvider(a)}}else this.b=void 0;return(0,l.$Qc)(()=>{this.b=void 0})}w(u){}async $closeTunnel(u,d){if(this.g.has(u.host)){const c=this.g.get(u.host);c.has(u.port)&&(d&&c.get(u.port).disposeListener.dispose(),await c.get(u.port).tunnel.dispose(),c.delete(u.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(u,d){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const c=this.b(u,d);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),c!==void 0){const f=await c;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),f===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(u.remoteAddress.host)||this.g.set(u.remoteAddress.host,new Map);const a=this.B(f.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(f.remoteAddress))));return this.g.get(u.remoteAddress.host).set(u.remoteAddress.port,{tunnel:f,disposeListener:a}),D.fromApiTunnel(f)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(c){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),c instanceof Error)return c.message}}async $applyCandidateFilter(u){const d=await Promise.all(u.map(f=>this.f(f.host,f.port,f.detail??""))),c=u.filter((f,a)=>d[a]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${u.map(f=>f.port).join(", ")} to ${c.map(f=>f.port).join(", ")}`),c}};e.$vwb=E,e.$vwb=E=He([We(0,P.$rM),We(1,R.$HM),We(2,g.$$i)],E)}),define(De[333],Ce([1,0,3,18,2,6]),function(re,e,y,M,l,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pec=void 0;class A{constructor(k){this.c=new Map,this.b=k.getProxy(L.$qK.MainThreadUriOpeners)}registerExternalUriOpener(k,$,R,P){if(this.c.has($))throw new Error(`Opener with id '${$}' already registered`);const p=P.schemes.find(S=>!A.a.has(S));if(p)throw new Error(`Scheme '${p}' is not supported. Only http and https are currently supported.`);return this.c.set($,R),this.b.$registerUriOpener($,P.schemes,k,P.label),(0,y.$Qc)(()=>{this.c.delete($),this.b.$unregisterUriOpener($)})}async $canOpenUri(k,$,R){const P=this.c.get(k);if(!P)throw new Error(`Unknown opener with id: ${k}`);const p=l.URI.revive($);return P.canOpenExternalUri(p,R)}async $openUri(k,$,R){const P=this.c.get(k);if(!P)throw new Error(`Unknown opener id: '${k}'`);return P.openExternalUri(l.URI.revive($.resolvedUri),{sourceUri:l.URI.revive($.sourceUri)},R)}}e.$pec=A,A.a=new Set([M.Schemas.http,M.Schemas.https])}),define(De[334],Ce([1,0,6,2,3,9,25]),function(re,e,y,M,l,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fdc=void 0;class g{constructor($){this.c=new A.$9l,this.d=new Map,this.b=$.getProxy(y.$qK.MainThreadUrls)}registerUriHandler($,R){const P=$.identifier;if(this.c.has(P))throw new Error(`Protocol handler already registered for extension ${P}`);const p=g.a++;return this.c.add(P),this.d.set(p,R),this.b.$registerUriHandler(p,P,$.displayName||$.name),(0,l.$Qc)(()=>{this.c.delete(P),this.d.delete(p),this.b.$unregisterUriHandler(p)})}$handleExternalUri($,R){const P=this.d.get($);if(!P)return Promise.resolve(void 0);try{P.handleUri(M.URI.revive(R))}catch(p){(0,L.$1)(p)}return Promise.resolve(void 0)}async createAppUri($){return M.URI.revive(await this.b.$createAppUri($))}}e.$Fdc=g,g.a=0});var et=this&&this.__classPrivateFieldSet||function(re,e,y,M,l){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!l)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!l:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?l.call(re,y):l?l.value=y:e.set(re,y),y},Be=this&&this.__classPrivateFieldGet||function(re,e,y,M){if(y==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!M:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return y==="m"?M:y==="a"?M.call(re):M?M.value:e.get(re)};define(De[91],Ce([1,0,4,3,18,24,2,229,266,111,6]),function(re,e,y,M,l,L,A,g,k,$,R){"use strict";var P,p,S,D,E,h,u,d,c,f,a,t,i;Object.defineProperty(e,"__esModule",{value:!0}),e.$Kdc=e.$Jdc=e.$Idc=e.$Hdc=e.$Gdc=void 0;class s{constructor(I,z,O,F,T,N,j){P.set(this,void 0),p.set(this,void 0),S.set(this,void 0),D.set(this,void 0),E.set(this,void 0),h.set(this,void 0),u.set(this,""),d.set(this,void 0),c.set(this,!1),f.set(this,!1),a.set(this,void 0),t.set(this,void 0),this._onMessageEmitter=new y.$Od,this.onDidReceiveMessage=this._onMessageEmitter.event,i.set(this,new y.$Od),this._onDidDispose=Be(this,i,"f").event,et(this,P,I,"f"),et(this,p,z,"f"),et(this,d,O,"f"),et(this,D,F,"f"),et(this,E,T,"f"),et(this,h,N,"f"),et(this,a,n(N),"f"),et(this,t,r(N),"f"),et(this,S,j,"f")}dispose(){et(this,c,!0,"f"),Be(this,i,"f").fire(),Be(this,i,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(I){return et(this,f,!0,"f"),(0,$.$spb)(I,Be(this,D,"f"))}get cspSource(){const I=Be(this,h,"f").extensionLocation;if(I.scheme===l.Schemas.https||I.scheme===l.Schemas.http){let z=I.toString();return z.endsWith("/")||(z+="/"),z+" "+$.$rpb}return $.$rpb}get html(){return this.a(),Be(this,u,"f")}set html(I){this.a(),Be(this,u,"f")!==I&&(et(this,u,I,"f"),Be(this,t,"f")&&!Be(this,f,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(I)&&(et(this,f,!0,"f"),Be(this,S,"f").report("Webview vscode-resource: uris",Be(this,h,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Be(this,p,"f").$setHtml(Be(this,P,"f"),this.b(I)))}get options(){return this.a(),Be(this,d,"f")}set options(I){this.a(),L.$an(Be(this,d,"f"),I)||Be(this,p,"f").$setOptions(Be(this,P,"f"),C(Be(this,h,"f"),Be(this,E,"f"),I)),et(this,d,I,"f")}async postMessage(I){if(Be(this,c,"f"))return!1;const z=(0,k.$Rcb)(I,{serializeBuffersForPostMessage:Be(this,a,"f")});return Be(this,p,"f").$postMessage(Be(this,P,"f"),z.message,...z.buffers)}a(){if(Be(this,c,"f"))throw new Error("Webview is disposed")}b(I){if(!Be(this,t,"f"))return I;const z=Be(this,h,"f").extensionLocation?.scheme===l.Schemas.vscodeRemote,O=Be(this,h,"f").extensionLocation.scheme===l.Schemas.vscodeRemote?Be(this,h,"f").extensionLocation.authority:void 0;return I.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(F,T,N,j,U,B)=>{const he=A.URI.from({scheme:j||"file",path:decodeURIComponent(U)}),x=(0,$.$spb)(he,{isRemote:z,authority:O}).toString();return`${T}${x}${B}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(F,T,N,j,U,B)=>{const he=A.URI.from({scheme:j||"file",path:decodeURIComponent(U)}),x=(0,$.$spb)(he,{isRemote:z,authority:O}).toString();return`${T}${x}${B}`})}}e.$Gdc=s,P=new WeakMap,p=new WeakMap,S=new WeakMap,D=new WeakMap,E=new WeakMap,h=new WeakMap,u=new WeakMap,d=new WeakMap,c=new WeakMap,f=new WeakMap,a=new WeakMap,t=new WeakMap,i=new WeakMap;function n(b){try{const I=(0,g.$So)((0,g.$Ro)(b.engines.vscode));return!!I&&I.majorBase>=1&&I.minorBase>=57}catch{return!1}}e.$Hdc=n;function r(b){try{const I=(0,g.$So)((0,g.$Ro)(b.engines.vscode));return I?I.majorBase<1||I.majorBase===1&&I.minorBase<60:!1}catch{return!1}}class o extends M.$Sc{constructor(I,z,O,F,T){super(),this.c=z,this.f=O,this.g=F,this.h=T,this.b=new Map,this.a=I.getProxy(R.$qK.MainThreadWebviews)}dispose(){super.dispose();for(const I of this.b.values())I.dispose();this.b.clear()}$onMessage(I,z,O){const F=this.j(I);if(F){const{message:T}=(0,k.$Scb)(z,O.value);F._onMessageEmitter.fire(T)}}$onMissingCsp(I,z){this.g.warn(`${z} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(I,z,O){const F=new s(I,this.a,w(z),this.c,this.f,O,this.h);this.b.set(I,F);const T=F._onDidDispose(()=>{T.dispose(),this.deleteWebview(I)});return F}deleteWebview(I){this.b.delete(I)}j(I){return this.b.get(I)}}e.$Idc=o;function v(b){return{id:b.identifier,location:b.extensionLocation}}e.$Jdc=v;function C(b,I,z){return{enableCommandUris:z.enableCommandUris,enableScripts:z.enableScripts,enableForms:z.enableForms,portMapping:z.portMapping,localResourceRoots:z.localResourceRoots||m(b,I)}}e.$Kdc=C;function w(b){return{enableCommandUris:b.enableCommandUris,enableScripts:b.enableScripts,enableForms:b.enableForms,portMapping:b.portMapping,localResourceRoots:b.localResourceRoots?.map(I=>A.URI.from(I))}}function m(b,I){return[...(I?.getWorkspaceFolders()||[]).map(z=>z.uri),b.extensionLocation]}}),define(De[335],Ce([1,0,21,52,3,18,23,2,13,91,107,6,7]),function(re,e,y,M,l,L,A,g,k,$,R,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jec=void 0;class S{constructor(i,s){this.document=i,this.b=s,this.a=1,this.c=new R.$Ccc("custom documents")}addEdit(i){return this.c.add([i])}async undo(i,s){await this.f(i).undo(),s||this.disposeBackup()}async redo(i,s){await this.f(i).redo(),s||this.disposeBackup()}disposeEdits(i){for(const s of i)this.c.delete(s)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const i=a(this.document.uri)+this.a++;return(0,A.$wg)(this.b,i)}updateBackup(i){this.d?.delete(),this.d=i}disposeBackup(){this.d?.delete(),this.d=void 0}f(i){const s=this.c.get(i,0);if(!s)throw new Error("No edit found");return s}}class D{constructor(){this.a=new Map}get(i,s){return this.a.get(this.b(i,s))}add(i,s,n){const r=this.b(i,s.uri);if(this.a.has(r))throw new Error(`Document already exists for viewType:${i} resource:${s.uri}`);const o=new S(s,n);return this.a.set(r,o),o}delete(i,s){const n=this.b(i,s.uri);this.a.delete(n)}b(i,s){return`${i}@@@${s}`}}var E;(function(t){t[t.Text=0]="Text",t[t.Custom=1]="Custom"})(E||(E={}));class h{constructor(){this.a=new Map}addTextProvider(i,s,n){return this.b(0,i,s,n)}addCustomProvider(i,s,n){return this.b(1,i,s,n)}get(i){return this.a.get(i)}b(i,s,n,r){if(this.a.has(s))throw new Error(`Provider for viewType:${s} already registered`);return this.a.set(s,{type:i,extension:n,provider:r}),new p.$sK(()=>this.a.delete(s))}}class u{constructor(i,s,n,r,o){this.d=s,this.f=n,this.g=r,this.h=o,this.b=new h,this.c=new D,this.a=i.getProxy(P.$qK.MainThreadCustomEditors)}registerCustomEditorProvider(i,s,n,r){const o=new l.$Rc;return c(n)?(o.add(this.b.addTextProvider(s,i,n)),this.a.$registerTextEditorProvider((0,$.$Jdc)(i),s,r.webviewOptions||{},{supportsMove:!!n.moveCustomTextEditor},(0,$.$Hdc)(i))):(o.add(this.b.addCustomProvider(s,i,n)),d(n)&&o.add(n.onDidChangeCustomDocument(v=>{const C=this.i(s,v.document.uri);if(f(v)){const w=C.addEdit(v);this.a.$onDidEdit(v.document.uri,s,w,v.label)}else this.a.$onContentChange(v.document.uri,s)})),this.a.$registerCustomEditorProvider((0,$.$Jdc)(i),s,r.webviewOptions||{},!!r.supportsMultipleEditorsPerDocument,(0,$.$Hdc)(i))),p.$sK.from(o,new p.$sK(()=>{this.a.$unregisterEditorProvider(s)}))}async $createCustomDocument(i,s,n,r,o){const v=this.b.get(s);if(!v)throw new Error(`No provider found for '${s}'`);if(v.type!==1)throw new Error(`Invalid provide type for '${s}'`);const C=g.URI.revive(i),w=await v.provider.openCustomDocument(C,{backupId:n,untitledDocumentData:r?.buffer},o);let m;return d(v.provider)&&this.f&&(m=this.f.workspaceValue(v.extension)??this.f.globalValue(v.extension)),this.c.add(s,w,m),{editable:d(v.provider)}}async $disposeCustomDocument(i,s){const n=this.b.get(s);if(!n)throw new Error(`No provider found for '${s}'`);if(n.type!==1)throw new Error(`Invalid provider type for '${s}'`);const r=g.URI.revive(i),{document:o}=this.i(s,r);this.c.delete(s,o),o.dispose()}async $resolveCustomEditor(i,s,n,r,o,v){const C=this.b.get(n);if(!C)throw new Error(`No provider found for '${n}'`);const w=k.ViewColumn.to(o),m=this.g.createNewWebview(s,r.contentOptions,C.extension),b=this.h.createNewWebviewPanel(s,n,r.title,w,r.options,m,r.active),I=g.URI.revive(i);switch(C.type){case 1:{const{document:z}=this.i(n,I);return C.provider.resolveCustomEditor(z,b,v)}case 0:{const z=this.d.getDocument(I);return C.provider.resolveCustomTextEditor(z,b,v)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(i,s,n){this.i(s,i).disposeEdits(n)}async $onMoveCustomEditor(i,s,n){const r=this.b.get(n);if(!r)throw new Error(`No provider found for '${n}'`);if(!r.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${n}'`);const o=this.h.getWebviewPanel(i);if(!o)throw new Error("No webview found");const v=g.URI.revive(s),C=this.d.getDocument(v);await r.provider.moveCustomTextEditor(C,o,y.CancellationToken.None)}async $undo(i,s,n,r){return this.i(s,i).undo(n,r)}async $redo(i,s,n,r){return this.i(s,i).redo(n,r)}async $revert(i,s,n){const r=this.i(s,i);await this.j(s).revertCustomDocument(r.document,n),r.disposeBackup()}async $onSave(i,s,n){const r=this.i(s,i);await this.j(s).saveCustomDocument(r.document,n),r.disposeBackup()}async $onSaveAs(i,s,n,r){const o=this.i(s,i);return this.j(s).saveCustomDocumentAs(o.document,g.URI.revive(n),r)}async $backup(i,s,n){const r=this.i(s,i),v=await this.j(s).backupCustomDocument(r.document,{destination:r.getNewBackupUri()},n);return r.updateBackup(v),v.id}i(i,s){const n=this.c.get(i,g.URI.revive(s));if(!n)throw new Error("No custom document found");return n}j(i){const n=this.b.get(i)?.provider;if(!n||!d(n))throw new Error("Custom document is not editable");return n}}e.$jec=u;function d(t){return!!t.onDidChangeCustomDocument}function c(t){return typeof t.resolveCustomTextEditor=="function"}function f(t){return typeof t.undo=="function"&&typeof t.redo=="function"}function a(t){const i=t.scheme===L.Schemas.file||t.scheme===L.Schemas.untitled?t.fsPath:t.toString();return(0,M.$Ei)(i)+""}});var et=this&&this.__classPrivateFieldSet||function(re,e,y,M,l){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!l)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!l:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?l.call(re,y):l?l.value=y:e.set(re,y),y},Be=this&&this.__classPrivateFieldGet||function(re,e,y,M){if(y==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!M:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return y==="m"?M:y==="a"?M.call(re):M?M.value:e.get(re)};define(De[336],Ce([1,0,4,3,2,31,13,91,6,7]),function(re,e,y,M,l,L,A,g,k,$){"use strict";var R,P,p,S,D,E,h,u,d,c,f,a,t;Object.defineProperty(e,"__esModule",{value:!0}),e.$iec=void 0;class i extends M.$Sc{constructor(o,v,C,w){super(),R.set(this,void 0),P.set(this,void 0),p.set(this,void 0),S.set(this,void 0),D.set(this,void 0),E.set(this,void 0),h.set(this,void 0),u.set(this,void 0),d.set(this,!0),c.set(this,void 0),f.set(this,!1),a.set(this,this.B(new y.$Od)),this.onDidDispose=Be(this,a,"f").event,t.set(this,this.B(new y.$Od)),this.onDidChangeViewState=Be(this,t,"f").event,et(this,R,o,"f"),et(this,P,v,"f"),et(this,S,C,"f"),et(this,p,w.viewType,"f"),et(this,D,w.panelOptions,"f"),et(this,u,w.viewColumn,"f"),et(this,E,w.title,"f"),et(this,c,w.active,"f")}dispose(){Be(this,f,"f")||(et(this,f,!0,"f"),Be(this,a,"f").fire(),Be(this,P,"f").$disposeWebview(Be(this,R,"f")),Be(this,S,"f").dispose(),super.dispose())}get webview(){return this.c(),Be(this,S,"f")}get viewType(){return this.c(),Be(this,p,"f")}get title(){return this.c(),Be(this,E,"f")}set title(o){this.c(),Be(this,E,"f")!==o&&(et(this,E,o,"f"),Be(this,P,"f").$setTitle(Be(this,R,"f"),o))}get iconPath(){return this.c(),Be(this,h,"f")}set iconPath(o){this.c(),Be(this,h,"f")!==o&&(et(this,h,o,"f"),Be(this,P,"f").$setIconPath(Be(this,R,"f"),l.URI.isUri(o)?{light:o,dark:o}:o))}get options(){return Be(this,D,"f")}get viewColumn(){if(this.c(),!(typeof Be(this,u,"f")=="number"&&Be(this,u,"f")<0))return Be(this,u,"f")}get active(){return this.c(),Be(this,c,"f")}get visible(){return this.c(),Be(this,d,"f")}_updateViewState(o){Be(this,f,"f")||(this.active!==o.active||this.visible!==o.visible||this.viewColumn!==o.viewColumn)&&(et(this,c,o.active,"f"),et(this,d,o.visible,"f"),et(this,u,o.viewColumn,"f"),Be(this,t,"f").fire({webviewPanel:this}))}reveal(o,v){this.c(),Be(this,P,"f").$reveal(Be(this,R,"f"),{viewColumn:typeof o>"u"?void 0:A.ViewColumn.from(o),preserveFocus:!!v})}c(){if(Be(this,f,"f"))throw new Error("Webview is disposed")}}R=new WeakMap,P=new WeakMap,p=new WeakMap,S=new WeakMap,D=new WeakMap,E=new WeakMap,h=new WeakMap,u=new WeakMap,d=new WeakMap,c=new WeakMap,f=new WeakMap,a=new WeakMap,t=new WeakMap;class s extends M.$Sc{static c(){return(0,L.$fg)()}constructor(o,v,C){super(),this.j=v,this.m=C,this.g=new Map,this.h=new Map,this.f=o.getProxy(k.$qK.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(o=>o.dispose()),this.g.clear()}createWebviewPanel(o,v,C,w,m={}){const b=typeof w=="object"?w.viewColumn:w,I={viewColumn:A.ViewColumn.from(b),preserveFocus:typeof w=="object"&&!!w.preserveFocus},z=(0,g.$Hdc)(o),O=s.c();this.f.$createWebviewPanel((0,g.$Jdc)(o),O,v,{title:C,panelOptions:n(m),webviewOptions:(0,g.$Kdc)(o,this.m,m),serializeBuffersForPostMessage:z},I);const F=this.j.createNewWebview(O,m,o);return this.createNewWebviewPanel(O,v,C,b,m,F,!0)}$onDidChangeWebviewPanelViewStates(o){const v=Object.keys(o);v.sort((C,w)=>{const m=o[C],b=o[w];return m.active?1:b.active?-1:+m.visible-+b.visible});for(const C of v){const w=this.getWebviewPanel(C);if(!w)continue;const m=o[C];w._updateViewState({active:m.active,visible:m.visible,viewColumn:A.ViewColumn.to(m.position)})}}async $onDidDisposeWebviewPanel(o){this.getWebviewPanel(o)?.dispose(),this.g.delete(o),this.j.deleteWebview(o)}registerWebviewPanelSerializer(o,v,C){if(this.h.has(v))throw new Error(`Serializer for '${v}' already registered`);return this.h.set(v,{serializer:C,extension:o}),this.f.$registerSerializer(v,{serializeBuffersForPostMessage:(0,g.$Hdc)(o)}),new $.$sK(()=>{this.h.delete(v),this.f.$unregisterSerializer(v)})}async $deserializeWebviewPanel(o,v,C,w){const m=this.h.get(v);if(!m)throw new Error(`No serializer found for '${v}'`);const{serializer:b,extension:I}=m,z=this.j.createNewWebview(o,C.webviewOptions,I),O=this.createNewWebviewPanel(o,v,C.title,w,C.panelOptions,z,C.active);await b.deserializeWebviewPanel(O,C.state)}createNewWebviewPanel(o,v,C,w,m,b,I){const z=new i(o,this.f,b,{viewType:v,title:C,viewColumn:w,panelOptions:m,active:I});return this.g.set(o,z),z}getWebviewPanel(o){return this.g.get(o)}}e.$iec=s;function n(r){return{enableFindWidget:r.enableFindWidget,retainContextWhenHidden:r.retainContextWhenHidden}}});var et=this&&this.__classPrivateFieldSet||function(re,e,y,M,l){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!l)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!l:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?l.call(re,y):l?l.value=y:e.set(re,y),y},Be=this&&this.__classPrivateFieldGet||function(re,e,y,M){if(y==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!M:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return y==="m"?M:y==="a"?M.call(re):M?M.value:e.get(re)};define(De[337],Ce([1,0,4,3,91,13,6,7]),function(re,e,y,M,l,L,A,g){"use strict";var k,$,R,P,p,S,D,E,h,u,d;Object.defineProperty(e,"__esModule",{value:!0}),e.$hec=void 0;class c extends M.$Sc{constructor(t,i,s,n,r,o){super(),k.set(this,void 0),$.set(this,void 0),R.set(this,void 0),P.set(this,void 0),p.set(this,!1),S.set(this,void 0),D.set(this,void 0),E.set(this,void 0),h.set(this,void 0),u.set(this,this.B(new y.$Od)),this.onDidChangeVisibility=Be(this,u,"f").event,d.set(this,this.B(new y.$Od)),this.onDidDispose=Be(this,d,"f").event,et(this,R,s,"f"),et(this,D,n,"f"),et(this,k,t,"f"),et(this,$,i,"f"),et(this,P,r,"f"),et(this,S,o,"f")}dispose(){Be(this,p,"f")||(et(this,p,!0,"f"),Be(this,d,"f").fire(),Be(this,P,"f").dispose(),super.dispose())}get title(){return this.a(),Be(this,D,"f")}set title(t){this.a(),Be(this,D,"f")!==t&&(et(this,D,t,"f"),Be(this,$,"f").$setWebviewViewTitle(Be(this,k,"f"),t))}get description(){return this.a(),Be(this,E,"f")}set description(t){this.a(),Be(this,E,"f")!==t&&(et(this,E,t,"f"),Be(this,$,"f").$setWebviewViewDescription(Be(this,k,"f"),t))}get visible(){return Be(this,S,"f")}get webview(){return Be(this,P,"f")}get viewType(){return Be(this,R,"f")}_setVisible(t){t===Be(this,S,"f")||Be(this,p,"f")||(et(this,S,t,"f"),Be(this,u,"f").fire())}get badge(){return this.a(),Be(this,h,"f")}set badge(t){this.a(),!(t?.value===Be(this,h,"f")?.value&&t?.tooltip===Be(this,h,"f")?.tooltip)&&(et(this,h,L.ViewBadge.from(t),"f"),Be(this,$,"f").$setWebviewViewBadge(Be(this,k,"f"),t))}show(t){this.a(),Be(this,$,"f").$show(Be(this,k,"f"),!!t)}a(){if(Be(this,p,"f"))throw new Error("Webview is disposed")}}k=new WeakMap,$=new WeakMap,R=new WeakMap,P=new WeakMap,p=new WeakMap,S=new WeakMap,D=new WeakMap,E=new WeakMap,h=new WeakMap,u=new WeakMap,d=new WeakMap;class f{constructor(t,i){this.d=i,this.b=new Map,this.c=new Map,this.a=t.getProxy(A.$qK.MainThreadWebviewViews)}registerWebviewViewProvider(t,i,s,n){if(this.b.has(i))throw new Error(`View provider for '${i}' already registered`);return this.b.set(i,{provider:s,extension:t}),this.a.$registerWebviewViewProvider((0,l.$Jdc)(t),i,{retainContextWhenHidden:n?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,l.$Hdc)(t)}),new g.$sK(()=>{this.b.delete(i),this.a.$unregisterWebviewViewProvider(i)})}async $resolveWebviewView(t,i,s,n,r){const o=this.b.get(i);if(!o)throw new Error(`No view provider found for '${i}'`);const{provider:v,extension:C}=o,w=this.d.createNewWebview(t,{},C),m=new c(t,this.a,i,s,w,!0);this.c.set(t,m),await v.resolveWebviewView(m,{state:n},r)}async $onDidChangeWebviewViewVisibility(t,i){this.e(t)._setVisible(i)}async $disposeWebviewView(t){const i=this.e(t);this.c.delete(t),i.dispose(),this.d.deleteWebview(t)}e(t){const i=this.c.get(t);if(!i)throw new Error("No webview found");return i}}e.$hec=f}),define(De[152],Ce([1,0,4,6,2,18,16,5,20,26]),function(re,e,y,M,l,L,A,g,k,$){"use strict";var R;Object.defineProperty(e,"__esModule",{value:!0}),e.$Mdc=e.$Ldc=void 0;let P=R=class{getState(S){const D=this.d;return{get focused(){return D.focused},get active(){return(0,$.$mF)(S,"windowActivity"),D.active}}}constructor(S){this.c=new y.$Od,this.onDidChangeWindowState=this.c.event,this.d=R.a,this.b=S.getProxy(M.$qK.MainThreadWindow),this.b.$getInitialState().then(({isFocused:D,isActive:E})=>{this.onDidChangeWindowProperty("focused",D),this.onDidChangeWindowProperty("active",E)})}$onDidChangeWindowFocus(S){this.onDidChangeWindowProperty("focused",S)}$onDidChangeWindowActive(S){this.onDidChangeWindowProperty("active",S)}onDidChangeWindowProperty(S,D){D!==this.d[S]&&(this.d={...this.d,[S]:D},this.c.fire(this.d))}openUri(S,D){let E;if(typeof S=="string"){E=S;try{S=l.URI.parse(S)}catch{return Promise.reject(`Invalid uri - '${S}'`)}}return(0,A.$Ce)(S.scheme)?Promise.reject("Invalid scheme - cannot be empty"):S.scheme===L.Schemas.command?Promise.reject(`Invalid scheme '${S.scheme}'`):this.b.$openUri(S,E,D)}async asExternalUri(S,D){if((0,A.$Ce)(S.scheme))return Promise.reject("Invalid scheme - cannot be empty");const E=await this.b.$asExternalUri(S,D);return l.URI.from(E)}};e.$Ldc=P,P.a={focused:!0,active:!0},e.$Ldc=P=R=He([We(0,k.$rM)],P),e.$Mdc=(0,g.$Qh)("IExtHostWindow")}),define(De[338],Ce([1,0,305,27,20]),function(re,e,y,M,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lfc=void 0;const L=1024*1024;let A=class extends y.$Mec{constructor(k,$){super(k,$),this.g=!1,this.j("stderr","error"),this.j("stdout","log")}f(k,$,R){const P=k==="error"||k==="warn"?process.stderr:process.stdout;this.g=!0,P.write(`
START_NATIVE_LOG
`),$.apply(console,R),P.write(`
END_NATIVE_LOG
`),this.g=!1}j(k,$){const R=process[k],P=R.write;let p="";Object.defineProperty(R,"write",{set:()=>{},get:()=>(S,D,E)=>{if(!this.g){p+=S.toString(D);const h=p.length>L?p.length:p.lastIndexOf(`
`);h!==-1&&(console[$](p.slice(0,h)),p=p.slice(h+1))}P.call(R,S,D,E)}})}};e.$lfc=A,e.$lfc=A=He([We(0,l.$rM),We(1,M.$HM)],A)}),define(De[339],Ce([1,0,72,18,14,241,30,12]),function(re,e,y,M,l,L,A,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mfc=void 0;let k=class{constructor(P,p){P.addFileSystemProvider(M.Schemas.file,new $(p),{isCaseSensitive:g.$f})}};e.$mfc=k,e.$mfc=k=He([We(0,y.$$cc),We(1,l.$$i)],k);class ${constructor(P){this.b=P,this.a=new L.$fq(this.b)}async stat(P){const p=await this.a.stat(P);return{type:p.type,ctime:p.ctime,mtime:p.mtime,size:p.size,permissions:p.permissions===A.FilePermission.Readonly?1:void 0}}readDirectory(P){return this.a.readdir(P)}createDirectory(P){return this.a.mkdir(P)}readFile(P){return this.a.readFile(P)}writeFile(P,p,S){return this.a.writeFile(P,p,{...S,unlock:!1,atomic:!1})}delete(P,p){return this.a.delete(P,{...p,useTrash:!1,atomic:!1})}rename(P,p,S){return this.a.rename(P,p,S)}copy(P,p,S){return this.a.copy(P,p,S)}get onDidChangeFile(){throw new Error("Method not implemented.")}watch(P,p){throw new Error("Method not implemented.")}}}),define(De[340],Ce([1,0,15,61,31,34,3,6,2,20]),function(re,e,y,M,l,L,A,g,k,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kfc=void 0;let R=class extends A.$Sc{constructor(p,S){super();const D=p.getProxy(g.$qK.MainThreadDownloadService);S.registerCommand(!1,"_workbench.downloadResource",async E=>{const h=k.URI.file((0,y.$jc)((0,M.tmpdir)(),(0,l.$fg)()));return await D.$download(E,h),h})}};e.$kfc=R,e.$kfc=R=He([We(0,$.$rM),We(1,L.$NM)],R)}),define(De[341],Ce([1,0,151,18,243,31]),function(re,e,y,M,l,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xfc=void 0;class A extends y.$Lec{s(k,$,R){return k.scheme===M.Schemas.file?new l.$EN(R?.name||(0,L.$fg)(),k.fsPath,!R?.donotRotate,!!R?.donotUseFormatters,$):super.s(k,$,R)}registerLogger(k){super.registerLogger(k),this.r.$registerLogger(k)}deregisterLogger(k){super.deregisterLogger(k),this.r.$deregisterLogger(k)}}e.$xfc=A}),define(De[342],Ce([1,0,53,15,2,90,3,18,8,29]),function(re,e,y,M,l,L,A,g,k,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wfc=void 0;class R extends L.$adc{constructor(){super(...arguments),this.i=null}async g(t){const i=await super.g(t);if(i.scheme!==g.Schemas.file)return i;if(this.b.skipWorkspaceStorageLock)return this.d.info(`Skipping acquiring lock for ${i.fsPath}.`),i;const s=i.fsPath;let n=0;do{let r;n===0?r=s:r=/[/\\]$/.test(s)?`${s.substr(0,s.length-1)}-${n}`:`${s}-${n}`,await P(r);const o=M.$jc(r,"vscode.lock"),v=await E(this.d,o,!1);if(v)return this.i=v,process.on("exit",()=>{v.dispose()}),l.URI.file(r);n++}while(n<10);return i}onWillDeactivateAll(){this.i?.setWillRelease(6e3)}}e.$wfc=R;async function P(a){try{await $.Promises.stat(a);return}catch{}try{await $.Promises.mkdir(a,{recursive:!0})}catch{}}const p=1e3,S=10*60*1e3;class D extends A.$Sc{constructor(t,i){super(),this.b=t,this.c=i,this.a=this.B(new k.$6g),this.a.cancelAndSet(async()=>{const s=await h(t,i);(!s||s.pid!==process.pid)&&(t.info(`Lock '${i}': The lock was lost unexpectedly.`),this.a.cancel());try{await $.Promises.utimes(i,new Date,new Date)}catch(n){t.error(n),t.info(`Lock '${i}': Could not update mtime.`)}},p)}dispose(){super.dispose();try{y.unlinkSync(this.c)}catch{}}async setWillRelease(t){this.b.info(`Lock '${this.c}': Marking the lockfile as scheduled to be released in ${t} ms.`);try{const i={pid:process.pid,willReleaseAt:Date.now()+t};await $.Promises.writeFile(this.c,JSON.stringify(i),{flag:"w"})}catch(i){this.b.error(i)}}}async function E(a,t,i){try{const n={pid:process.pid,willReleaseAt:0};await $.Promises.writeFile(t,JSON.stringify(n),{flag:"wx"})}catch(n){a.error(n)}const s=await h(a,t);return!s||s.pid!==process.pid?i?(a.info(`Lock '${t}': Could not acquire lock, giving up.`),null):(a.info(`Lock '${t}': Could not acquire lock, checking if the file is stale.`),c(a,t)):(a.info(`Lock '${t}': Lock acquired.`),new D(a,t))}async function h(a,t){let i;try{i=await $.Promises.readFile(t)}catch(s){return a.error(s),null}try{return JSON.parse(String(i))}catch(s){return a.error(s),null}}async function u(a,t){let i;try{i=await $.Promises.stat(t)}catch(s){return a.error(s),0}return i.mtime.getTime()}function d(a){try{return process.kill(a,0),!0}catch{return!1}}async function c(a,t){const i=await h(a,t);if(!i)return a.info(`Lock '${t}': Could not read pid of lock holder.`),f(a,t);if(i.willReleaseAt){let v=i.willReleaseAt-Date.now();if(v<5e3){for(v>0?a.info(`Lock '${t}': The lockfile is scheduled to be released in ${v} ms.`):a.info(`Lock '${t}': The lockfile is scheduled to have been released.`);v>0;){if(await(0,k.$Vg)(Math.min(100,v)),await u(a,t)===0)return f(a,t);v=i.willReleaseAt-Date.now()}return f(a,t)}}if(!d(i.pid))return a.info(`Lock '${t}': The pid ${i.pid} appears to be gone.`),f(a,t);const s=await u(a,t),n=Date.now()-s;if(n<=S)return a.info(`Lock '${t}': The lock does not look stale, elapsed: ${n} ms, giving up.`),null;a.info(`Lock '${t}': The lock looks stale, waiting for 2s.`),await(0,k.$Vg)(2e3);const r=await u(a,t),o=Date.now()-r;return o<=S?(a.info(`Lock '${t}': The lock does not look stale, elapsed: ${o} ms, giving up.`),null):(a.info(`Lock '${t}': The lock looks stale even after waiting for 2s.`),f(a,t))}async function f(a,t){a.info(`Lock '${t}': Deleting a stale lock.`);try{await $.Promises.unlink(t)}catch{}return E(a,t,!0)}}),define(De[343],Ce([1,0,31,20,45,34]),function(re,e,y,M,l,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rec=void 0;let A=class extends l.$ddc{constructor(k,$){super(!0,k,$)}createTerminal(k,$,R){return this.createTerminalFromOptions({name:k,shellPath:$,shellArgs:R})}createTerminalFromOptions(k,$){const R=new l.$cdc(this.a,(0,y.$fg)(),k,k.name);return this.f.push(R),R.create(k,this.R(k,$)),R.value}};e.$Rec=A,e.$Rec=A=He([We(0,L.$NM),We(1,M.$rM)],A)}),define(De[344],Ce([1,0,8,22,21,9,4,3,126,293,69]),function(re,e,y,M,l,L,A,g,k,$,R){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.$54b=e.ResponsiveState=e.RequestInitiator=e.$44b=e.$34b=void 0;function p(b,I){try{return JSON.stringify(b,I)}catch{return"null"}}const S="$$ref$$",D={[S]:-1};class E{constructor(I,z){this.jsonString=I,this.referencedBuffers=z}}function h(b,I=null,z=!1){const O=[];return{jsonString:(z?p:JSON.stringify)(b,(T,N)=>{if(typeof N>"u")return D;if(typeof N=="object"){if(N instanceof M.$ce){const j=O.push(N)-1;return{[S]:j}}if(I)return I(T,N)}return N}),referencedBuffers:O}}e.$34b=h;function u(b,I,z){return JSON.parse(b,(O,F)=>{if(F){const T=F[S];if(typeof T=="number")return I[T];if(z&&F.$mid===1)return z.transformIncoming(F)}return F})}e.$44b=u;function d(b,I){return JSON.stringify(b,I)}function c(b){return b?(I,z)=>z&&z.$mid===1?b.transformOutgoing(z):z:null}var f;(function(b){b[b.LocalSide=0]="LocalSide",b[b.OtherSide=1]="OtherSide"})(f||(e.RequestInitiator=f={}));var a;(function(b){b[b.Responsive=0]="Responsive",b[b.Unresponsive=1]="Unresponsive"})(a||(e.ResponsiveState=a={}));const t=()=>{},i=Symbol.for("rpcProtocol"),s=Symbol.for("rpcProxy");class n extends g.$Sc{constructor(I,z=null,O=null){super(),this[P]=!0,this.b=this.B(new A.$Od),this.onDidChangeResponsiveState=this.b.event,this.c=I,this.f=z,this.g=O,this.h=c(this.g),this.j=!1,this.m=[],this.s=[];for(let F=0,T=R.$sv.count;F<T;F++)this.m[F]=null,this.s[F]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=0,this.z=0,this.C=0,this.D=this.B(new y.$7g(()=>this.H(),1e3)),this.c.onMessage(F=>this.L(F))}dispose(){this.j=!0,Object.keys(this.w).forEach(I=>{const z=this.w[I];delete this.w[I],z.resolveErr(L.$6())})}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(I){this.z===0&&(this.C=Date.now()+n.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(I){this.C=Date.now()+n.a,this.z--,this.z===0&&this.D.cancel(),this.I(0)}H(){this.z!==0&&(Date.now()>this.C?this.I(1):this.D.schedule())}I(I){this.y!==I&&(this.y=I,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(I){return this.g?(0,k.$Qm)(I,this.g):I}getProxy(I){const{nid:z,sid:O}=I;return this.s[z]||(this.s[z]=this.J(z,O)),this.s[z]}J(I,z){const O={get:(F,T)=>(typeof T=="string"&&!F[T]&&T.charCodeAt(0)===36&&(F[T]=(...N)=>this.U(I,T,N)),T===s?z:F[T])};return new Proxy(Object.create(null),O)}set(I,z){return this.m[I.nid]=z,z}assertRegistered(I){for(let z=0,O=I.length;z<O;z++){const F=I[z];if(!this.m[F.nid])throw new Error(`Missing proxy instance ${F.sid}`)}}L(I){if(this.j)return;const z=I.byteLength,O=o.read(I,0),F=O.readUInt8(),T=O.readUInt32();switch(F){case 1:case 2:{let{rpcId:N,method:j,args:U}=C.deserializeRequestJSONArgs(O);this.g&&(U=(0,k.$Qm)(U,this.g)),this.M(z,T,N,j,U,F===2);break}case 3:case 4:{let{rpcId:N,method:j,args:U}=C.deserializeRequestMixedArgs(O);this.g&&(U=(0,k.$Qm)(U,this.g)),this.M(z,T,N,j,U,F===4);break}case 5:{this.f?.logIncoming(z,T,0,"ack"),this.G(T);break}case 6:{this.N(z,T);break}case 7:{this.O(z,T,void 0);break}case 9:{let N=C.deserializeReplyOKJSON(O);this.g&&(N=(0,k.$Qm)(N,this.g)),this.O(z,T,N);break}case 10:{const N=C.deserializeReplyOKJSONWithBuffers(O,this.g);this.O(z,T,N);break}case 8:{const N=C.deserializeReplyOKVSBuffer(O);this.O(z,T,N);break}case 11:{let N=C.deserializeReplyErrError(O);this.g&&(N=(0,k.$Qm)(N,this.g)),this.P(z,T,N);break}case 12:{this.P(z,T,void 0);break}default:console.error("received unexpected message"),console.error(I)}}M(I,z,O,F,T,N){this.f?.logIncoming(I,z,1,`receiveRequest ${(0,R.$uv)(O)}.${F}(`,T);const j=String(z);let U,B;if(N){const x=new l.$Yd;T.push(x.token),U=this.Q(O,F,T),B=()=>x.cancel()}else U=this.Q(O,F,T),B=t;this.u[j]=B;const he=C.serializeAcknowledged(z);this.f?.logOutgoing(he.byteLength,z,1,"ack"),this.c.send(he),U.then(x=>{delete this.u[j];const Q=C.serializeReplyOK(z,x,this.h);this.f?.logOutgoing(Q.byteLength,z,1,"reply:",x),this.c.send(Q)},x=>{delete this.u[j];const Q=C.serializeReplyErr(z,x);this.f?.logOutgoing(Q.byteLength,z,1,"replyErr:",x),this.c.send(Q)})}N(I,z){this.f?.logIncoming(I,z,1,"receiveCancel");const O=String(z);this.u[O]?.()}O(I,z,O){this.f?.logIncoming(I,z,0,"receiveReply:",O);const F=String(z);if(!this.w.hasOwnProperty(F))return;const T=this.w[F];delete this.w[F],T.resolveOk(O)}P(I,z,O){this.f?.logIncoming(I,z,0,"receiveReplyErr:",O);const F=String(z);if(!this.w.hasOwnProperty(F))return;const T=this.w[F];delete this.w[F];let N;O&&(O.$isError?(N=new Error,N.name=O.name,N.message=O.message,N.stack=O.stack):N=O),T.resolveErr(N)}Q(I,z,O){try{return Promise.resolve(this.S(I,z,O))}catch(F){return Promise.reject(F)}}S(I,z,O){const F=this.m[I];if(!F)throw new Error("Unknown actor "+(0,R.$uv)(I));const T=F[z];if(typeof T!="function")throw new Error("Unknown method "+z+" on actor "+(0,R.$uv)(I));return T.apply(F,O)}U(I,z,O){if(this.j)return new $.$24b;let F=null;if(O.length>0&&l.CancellationToken.isCancellationToken(O[O.length-1])&&(F=O.pop()),F&&F.isCancellationRequested)return Promise.reject(L.$6());const T=C.serializeRequestArguments(O,this.h),N=++this.t,j=String(N),U=new $.$14b,B=new g.$Rc;F&&B.add(F.onCancellationRequested(()=>{const x=C.serializeCancel(N);this.f?.logOutgoing(x.byteLength,N,0,"cancel"),this.c.send(C.serializeCancel(N))})),this.w[j]=new r(U,B),this.F(N);const he=C.serializeRequest(N,I,z,T,!!F);return this.f?.logOutgoing(he.byteLength,N,0,`request: ${(0,R.$uv)(I)}.${z}(`,O),this.c.send(he),U}}e.$54b=n,P=i,n.a=3*1e3;class r{constructor(I,z){this.a=I,this.b=z}resolveOk(I){this.a.resolveOk(I),this.b.dispose()}resolveErr(I){this.a.resolveErr(I),this.b.dispose()}}class o{static alloc(I,z,O){const F=new o(M.$ce.alloc(O+1+4),0);return F.writeUInt8(I),F.writeUInt32(z),F}static read(I,z){return new o(I,z)}get buffer(){return this.a}constructor(I,z){this.a=I,this.b=z}static sizeUInt8(){return 1}writeUInt8(I){this.a.writeUInt8(I,this.b),this.b+=1}readUInt8(){const I=this.a.readUInt8(this.b);return this.b+=1,I}writeUInt32(I){this.a.writeUInt32BE(I,this.b),this.b+=4}readUInt32(){const I=this.a.readUInt32BE(this.b);return this.b+=4,I}static sizeShortString(I){return 1+I.byteLength}writeShortString(I){this.a.writeUInt8(I.byteLength,this.b),this.b+=1,this.a.set(I,this.b),this.b+=I.byteLength}readShortString(){const I=this.a.readUInt8(this.b);this.b+=1;const O=this.a.slice(this.b,this.b+I).toString();return this.b+=I,O}static sizeLongString(I){return 4+I.byteLength}writeLongString(I){this.a.writeUInt32BE(I.byteLength,this.b),this.b+=4,this.a.set(I,this.b),this.b+=I.byteLength}readLongString(){const I=this.a.readUInt32BE(this.b);this.b+=4;const O=this.a.slice(this.b,this.b+I).toString();return this.b+=I,O}writeBuffer(I){this.a.writeUInt32BE(I.byteLength,this.b),this.b+=4,this.a.set(I,this.b),this.b+=I.byteLength}static sizeVSBuffer(I){return 4+I.byteLength}writeVSBuffer(I){this.a.writeUInt32BE(I.byteLength,this.b),this.b+=4,this.a.set(I,this.b),this.b+=I.byteLength}readVSBuffer(){const I=this.a.readUInt32BE(this.b);this.b+=4;const z=this.a.slice(this.b,this.b+I);return this.b+=I,z}static sizeMixedArray(I){let z=0;z+=1;for(let O=0,F=I.length;O<F;O++){const T=I[O];switch(z+=1,T.type){case 1:z+=this.sizeLongString(T.value);break;case 2:z+=this.sizeVSBuffer(T.value);break;case 3:z+=this.sizeUInt32,z+=this.sizeLongString(T.value);for(let N=0;N<T.buffers.length;++N)z+=this.sizeVSBuffer(T.buffers[N]);break;case 4:break}}return z}writeMixedArray(I){this.a.writeUInt8(I.length,this.b),this.b+=1;for(let z=0,O=I.length;z<O;z++){const F=I[z];switch(F.type){case 1:this.writeUInt8(1),this.writeLongString(F.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(F.value);break;case 3:this.writeUInt8(3),this.writeUInt32(F.buffers.length),this.writeLongString(F.value);for(let T=0;T<F.buffers.length;++T)this.writeBuffer(F.buffers[T]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const I=this.a.readUInt8(this.b);this.b+=1;const z=new Array(I);for(let O=0;O<I;O++)switch(this.readUInt8()){case 1:z[O]=this.readLongString();break;case 2:z[O]=this.readVSBuffer();break;case 3:{const T=this.readUInt32(),N=this.readLongString(),j=[];for(let U=0;U<T;++U)j.push(this.readVSBuffer());z[O]=new R.$vv(u(N,j,null));break}case 4:z[O]=void 0;break}return z}}o.sizeUInt32=4;var v;(function(b){b[b.Simple=0]="Simple",b[b.Mixed=1]="Mixed"})(v||(v={}));class C{static a(I){for(let z=0,O=I.length;z<O;z++)if(I[z]instanceof M.$ce||I[z]instanceof R.$vv||typeof I[z]>"u")return!0;return!1}static serializeRequestArguments(I,z){if(this.a(I)){const O=[];for(let F=0,T=I.length;F<T;F++){const N=I[F];if(N instanceof M.$ce)O[F]={type:2,value:N};else if(typeof N>"u")O[F]={type:4};else if(N instanceof R.$vv){const{jsonString:j,referencedBuffers:U}=h(N.value,z);O[F]={type:3,value:M.$ce.fromString(j),buffers:U}}else O[F]={type:1,value:M.$ce.fromString(d(N,z))}}return{type:1,args:O}}return{type:0,args:d(I,z)}}static serializeRequest(I,z,O,F,T){switch(F.type){case 0:return this.b(I,z,O,F.args,T);case 1:return this.c(I,z,O,F.args,T)}}static b(I,z,O,F,T){const N=M.$ce.fromString(O),j=M.$ce.fromString(F);let U=0;U+=o.sizeUInt8(),U+=o.sizeShortString(N),U+=o.sizeLongString(j);const B=o.alloc(T?2:1,I,U);return B.writeUInt8(z),B.writeShortString(N),B.writeLongString(j),B.buffer}static deserializeRequestJSONArgs(I){const z=I.readUInt8(),O=I.readShortString(),F=I.readLongString();return{rpcId:z,method:O,args:JSON.parse(F)}}static c(I,z,O,F,T){const N=M.$ce.fromString(O);let j=0;j+=o.sizeUInt8(),j+=o.sizeShortString(N),j+=o.sizeMixedArray(F);const U=o.alloc(T?4:3,I,j);return U.writeUInt8(z),U.writeShortString(N),U.writeMixedArray(F),U.buffer}static deserializeRequestMixedArgs(I){const z=I.readUInt8(),O=I.readShortString(),F=I.readMixedArray(),T=new Array(F.length);for(let N=0,j=F.length;N<j;N++){const U=F[N];typeof U=="string"?T[N]=JSON.parse(U):T[N]=U}return{rpcId:z,method:O,args:T}}static serializeAcknowledged(I){return o.alloc(5,I,0).buffer}static serializeCancel(I){return o.alloc(6,I,0).buffer}static serializeReplyOK(I,z,O){if(typeof z>"u")return this.d(I);if(z instanceof M.$ce)return this.e(I,z);if(z instanceof R.$vv){const{jsonString:F,referencedBuffers:T}=h(z.value,O,!0);return this.g(I,F,T)}else return this.f(I,p(z,O))}static d(I){return o.alloc(7,I,0).buffer}static e(I,z){let O=0;O+=o.sizeVSBuffer(z);const F=o.alloc(8,I,O);return F.writeVSBuffer(z),F.buffer}static deserializeReplyOKVSBuffer(I){return I.readVSBuffer()}static f(I,z){const O=M.$ce.fromString(z);let F=0;F+=o.sizeLongString(O);const T=o.alloc(9,I,F);return T.writeLongString(O),T.buffer}static g(I,z,O){const F=M.$ce.fromString(z);let T=0;T+=o.sizeUInt32,T+=o.sizeLongString(F);for(const j of O)T+=o.sizeVSBuffer(j);const N=o.alloc(10,I,T);N.writeUInt32(O.length),N.writeLongString(F);for(const j of O)N.writeBuffer(j);return N.buffer}static deserializeReplyOKJSON(I){const z=I.readLongString();return JSON.parse(z)}static deserializeReplyOKJSONWithBuffers(I,z){const O=I.readUInt32(),F=I.readLongString(),T=[];for(let N=0;N<O;++N)T.push(I.readVSBuffer());return new R.$vv(u(F,T,z))}static serializeReplyErr(I,z){const O=z?p(L.$3(z),null):void 0;if(typeof O!="string")return this.h(I);const F=M.$ce.fromString(O);let T=0;T+=o.sizeLongString(F);const N=o.alloc(11,I,T);return N.writeLongString(F),N.buffer}static deserializeReplyErrError(I){const z=I.readLongString();return JSON.parse(z)}static h(I){return o.alloc(12,I,0).buffer}}var w;(function(b){b[b.RequestJSONArgs=1]="RequestJSONArgs",b[b.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",b[b.RequestMixedArgs=3]="RequestMixedArgs",b[b.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",b[b.Acknowledged=5]="Acknowledged",b[b.Cancel=6]="Cancel",b[b.ReplyOKEmpty=7]="ReplyOKEmpty",b[b.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",b[b.ReplyOKJSON=9]="ReplyOKJSON",b[b.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",b[b.ReplyErrError=11]="ReplyErrError",b[b.ReplyErrEmpty=12]="ReplyErrEmpty"})(w||(w={}));var m;(function(b){b[b.String=1]="String",b[b.VSBuffer=2]="VSBuffer",b[b.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",b[b.Undefined=4]="Undefined"})(m||(m={}))}),define(De[345],Ce([1,0,4,43,42,5]),function(re,e,y,M,l,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MJ=e.$LJ=e.OutputChannelUpdateMode=e.$KJ=e.$JJ=e.$IJ=e.$HJ=e.$GJ=e.$FJ=e.$EJ=e.$DJ=e.$CJ=e.$BJ=void 0,e.$BJ="text/x-code-output",e.$CJ="output",e.$DJ="Log",e.$EJ="text/x-code-log-output",e.$FJ="log",e.$GJ="workbench.panel.output",e.$HJ=new l.$8i("inOutput",!1),e.$IJ=new l.$8i("activeLogOutput",!1),e.$JJ=new l.$8i("outputView.scrollLock",!1),e.$KJ=(0,L.$Qh)("outputService");var A;(function(k){k[k.Append=1]="Append",k[k.Replace=2]="Replace",k[k.Clear=3]="Clear"})(A||(e.OutputChannelUpdateMode=A={})),e.$LJ={OutputChannels:"workbench.contributions.outputChannels"};class g{constructor(){this.a=new Map,this.b=new y.$Od,this.onDidRegisterChannel=this.b.event,this.c=new y.$Od,this.onDidRemoveChannel=this.c.event}registerChannel($){this.a.has($.id)||(this.a.set($.id,$),this.b.fire($.id))}getChannels(){const $=[];return this.a.forEach(R=>$.push(R)),$}getChannel($){return this.a.get($)}removeChannel($){this.a.delete($),this.c.fire($)}}M.$ln.add(e.$LJ.OutputChannels,new g),e.$MJ=new l.$8i("activeOutputChannel","")}),define(De[153],Ce([1,0,6,5,20,25,14,345,72,27,55,184,22,17,30,4,3]),function(re,e,y,M,l,L,A,g,k,$,R,P,p,S,D,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wdc=e.$vdc=void 0;class u extends A.$ej{get disposed(){return this.n}constructor(a,t,i,s,n){super(),this.id=a,this.name=t,this.r=i,this.s=s,this.extension=n,this.m=0,this.n=!1,this.visible=!1,this.setLevel(i.getLevel()),this.B(i.onDidChangeLogLevel(r=>this.setLevel(r)))}get logLevel(){return this.getLevel()}appendLine(a){this.append(a+`
`)}append(a){this.info(a)}clear(){const a=this.m;this.r.flush(),this.s.$update(this.id,g.OutputChannelUpdateMode.Clear,a)}replace(a){const t=this.m;this.info(a),this.s.$update(this.id,g.OutputChannelUpdateMode.Replace,t),this.visible&&this.r.flush()}show(a,t){this.r.flush(),this.s.$reveal(this.id,!!(typeof a=="boolean"?a:t))}hide(){this.s.$close(this.id)}g(a,t){this.m+=p.$ce.fromString(t).byteLength,(0,A.log)(this.r,a,t),this.visible&&(this.r.flush(),this.s.$update(this.id,g.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class d extends u{appendLine(a){this.append(a)}}let c=class{constructor(a,t,i,s,n,r){this.i=t,this.j=i,this.k=s,this.l=n,this.m=r,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=a.getProxy(y.$qK.MainThreadOutputService),this.b=this.k.extUri.joinPath(t.logsLocation,`output_logging_${(0,P.$gm)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(a){this.h=a;for(const[t,i]of this.g)i.visible=t===this.h}createOutputChannel(a,t,i){if(a=a.trim(),!a)throw new Error("illegal argument `name`. must not be falsy");const s=typeof t=="object"&&t.log,n=(0,S.$zf)(t)?t:void 0;if((0,S.$zf)(n)&&!n.trim())throw new Error("illegal argument `languageId`. must not be empty");let r;const o=this.i.environment.extensionLogLevel?.find(([C])=>L.$8l.equals(i.identifier,C))?.[1];o&&(r=(0,A.$oj)(o));const v=s?this.o(a,r,i):this.n(a,n,i);return v.then(C=>{this.g.set(C.id,C),C.visible=C.id===this.h}),s?this.r(a,r??this.m.getLevel(),v):this.q(a,v)}async n(a,t,i){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const s=await this.c,n=this.k.extUri.joinPath(s,`${this.f++}-${a.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),r=this.l.createLogger(n,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),o=await this.a.$register(a,n,t,i.identifier.value);return new u(o,a,r,this.a,i)}async o(a,t,i){const s=await this.p(i),n=a.replace(/[\\/:\*\?"<>\|]/g,""),r=this.k.extUri.joinPath(s,`${n}.log`),o=`${i.identifier.value}.${n}`,v=this.l.createLogger(r,{id:o,name:a,logLevel:t,extensionId:i.identifier.value});return new d(o,a,v,this.a,i)}p(a){let t=this.d.get(a.identifier.value);if(!t){const i=this.k.extUri.joinPath(this.i.logsLocation,a.identifier.value);this.d.set(a.identifier.value,t=(async()=>{try{await this.j.value.createDirectory(i)}catch(s){if((0,D.$pk)(s)!==D.FileSystemProviderErrorCode.FileExists)throw s}return i})())}return t}q(a,t){let i=!1;const s=()=>{if(i)throw new Error("Channel has been closed")};return{get name(){return a},append(n){s(),t.then(r=>r.append(n))},appendLine(n){s(),t.then(r=>r.appendLine(n))},clear(){s(),t.then(n=>n.clear())},replace(n){s(),t.then(r=>r.replace(n))},show(n,r){s(),t.then(o=>o.show(n,r))},hide(){s(),t.then(n=>n.hide())},dispose(){i=!0,t.then(n=>n.dispose())}}}r(a,t,i){const s=new h.$Rc,n=()=>{if(s.isDisposed)throw new Error("Channel has been closed")},r=s.add(new E.$Od);function o(v){t=v,r.fire(v)}return i.then(v=>{s.add(v),v.logLevel!==t&&o(v.logLevel),s.add(v.onDidChangeLogLevel(C=>o(C)))}),{...this.q(a,i),get logLevel(){return t},onDidChangeLogLevel:r.event,trace(v,...C){n(),i.then(w=>w.trace(v,...C))},debug(v,...C){n(),i.then(w=>w.debug(v,...C))},info(v,...C){n(),i.then(w=>w.info(v,...C))},warn(v,...C){n(),i.then(w=>w.warn(v,...C))},error(v,...C){n(),i.then(w=>w.error(v,...C))},dispose(){s.dispose()}}}};e.$vdc=c,e.$vdc=c=He([We(0,l.$rM),We(1,$.$HM),We(2,k.$$cc),We(3,R.$Fcc),We(4,A.$_i),We(5,A.$$i)],c),e.$wdc=(0,M.$Qh)("IExtHostOutputService")}),define(De[346],Ce([1,0,5,8]),function(re,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wm=e.$vm=void 0,e.$vm=(0,y.$Qh)("remoteAgentService"),e.$wm=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(l){let L=1/0;for(let g=0;g<this.maxSampleCount;g++){const k=await l.getRoundTripTime();if(k===void 0)return;L=Math.min(L,k/2),await(0,M.$Vg)(this.sampleDelay)}this.average.push(L),this.average.length>this.maxAverageCount&&this.average.shift();let A;return this.initial.length<this.maxInitialCount?this.initial.push(L):A=this.initial.reduce((g,k)=>g+k,0)/this.initial.length,this.lastMeasurement={initial:A,current:L,average:this.average.reduce((g,k)=>g+k,0)/this.average.length,high:(()=>typeof A>"u"?!1:L>this.highLatencyMaxThreshold||L>this.highLatencyMinThreshold&&L>A*this.highLatencyMultiple)()},this.lastMeasurement}}}),define(De[347],Ce([1,0,32,18,15,12,23,2,5,259,44,145,346]),function(re,e,y,M,l,L,A,g,k,$,R,P,p){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.$6J=e.$5J=void 0,e.$5J=(0,k.$Qh)("pathService");let D=S=class{constructor(h,u,d,c){this.d=h,this.e=u,this.f=d,this.g=c,this.a=(async()=>(await this.e.getEnvironment())?.os||L.OS)(),this.b=(async()=>{const f=await this.e.getEnvironment();return this.c=f?.userHome??h})()}hasValidBasename(h,u,d){return typeof u=="string"||typeof u>"u"?this.a.then(c=>this.h(h,c,u)):this.h(h,u,d)}h(h,u,d){return h.scheme===M.Schemas.file||h.scheme===M.Schemas.vscodeRemote?(0,y.$Wf)(d??(0,A.$tg)(h),u===1):!0}get defaultUriScheme(){return S.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(h,u){if(h.remoteAuthority)return M.Schemas.vscodeRemote;const d=(0,$.$2J)(u.getWorkspace());if(d)return d;const c=u.getWorkspace().folders[0];if(c)return c.uri.scheme;const f=u.getWorkspace().configuration;return f?f.scheme:M.Schemas.file}userHome(h){return h?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(h=>h===1?l.$fc:l.$gc)}async fileURI(h){let u="";if(await this.a===1&&(h=h.replace(/\\/g,"/")),h[0]==="/"&&h[1]==="/"){const c=h.indexOf("/",2);c===-1?(u=h.substring(2),h="/"):(u=h.substring(2,c),h=h.substring(c)||"/")}return g.URI.from({scheme:M.Schemas.file,authority:u,path:h,query:"",fragment:""})}};e.$6J=D,e.$6J=D=S=He([We(1,p.$vm),We(2,P.$NJ),We(3,R.$Zh)],D)}),define(De[348],Ce([1,0,226,19,57,4,52,3,2,50,231,14,65,261,86,44,145,26,21,17,24,42]),function(re,e,y,M,l,L,A,g,k,$,R,P,p,S,D,E,h,u,d,c,f,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YJ=e.$XJ=e.$WJ=e.OnPortForward=e.$VJ=e.$UJ=e.$TJ=e.$SJ=e.$RJ=e.TunnelSource=e.TunnelCloseReason=e.$QJ=e.$PJ=e.$OJ=void 0;const t=10*1e3,i="remote.tunnels.toRestore";e.$OJ="onTunnel",e.$PJ=new a.$8i("forwardedPortsViewEnabled",!1,y.localize(0,null));function s(z){const O=z.match(/^([a-zA-Z0-9_-]+(?:\.[a-zA-Z0-9_-]+)*:)?([0-9]+)$/);if(O)return{host:O[1]?.substring(0,O[1].length-1)||"localhost",port:Number(O[2])}}e.$QJ=s;var n;(function(z){z.Other="Other",z.User="User",z.AutoForwardEnd="AutoForwardEnd"})(n||(e.TunnelCloseReason=n={}));var r;(function(z){z[z.User=0]="User",z[z.Auto=1]="Auto",z[z.Extension=2]="Extension"})(r||(e.TunnelSource=r={})),e.$RJ={source:r.User,description:y.localize(1,null)},e.$SJ={source:r.Auto,description:y.localize(2,null)};function o(z,O,F){const T=z.get(C(O,F));if(T)return T;if((0,D.$hv)(O))for(const N of D.$gv){const j=C(N,F);if(z.has(j))return z.get(j)}else if((0,D.$jv)(O))for(const N of D.$iv){const j=C(N,F);if(z.has(j))return z.get(j)}}e.$TJ=o;function v(z,O,F){const T=o(z,O,F);if(T)return T;const N=(0,D.$jv)(O)?"localhost":(0,D.$hv)(O)?"0.0.0.0":void 0;if(N)return o(z,N,F)}e.$UJ=v;function C(z,O){return z+":"+O}e.$VJ=C;var w;(function(z){z.Notify="notify",z.OpenBrowser="openBrowser",z.OpenBrowserOnce="openBrowserOnce",z.OpenPreview="openPreview",z.Silent="silent",z.Ignore="ignore"})(w||(e.OnPortForward=w={}));function m(z){return z&&"host"in z&&typeof z.host=="string"&&"port"in z&&typeof z.port=="number"&&(!("detail"in z)||typeof z.detail=="string")&&(!("pid"in z)||typeof z.pid=="string")}e.$WJ=m;class b extends g.$Sc{constructor(O){super(),this.r=O,this.j=[],this.n=new L.$Od,this.onDidChangeAttributes=this.n.event,this.B(O.onDidChangeConfiguration(F=>{(F.affectsConfiguration(b.c)||F.affectsConfiguration(b.f))&&this.s()})),this.s()}s(){this.j=this.y(),this.n.fire()}getAttributes(O,F,T){let N=this.w(O,F,T,this.j,0);const j={label:void 0,onAutoForward:void 0,elevateIfNeeded:void 0,requireLocalPort:void 0,protocol:void 0};for(;N>=0;){const U=this.j[N];U.key===O?(j.onAutoForward=U.onAutoForward??j.onAutoForward,j.elevateIfNeeded=U.elevateIfNeeded!==void 0?U.elevateIfNeeded:j.elevateIfNeeded,j.label=U.label??j.label,j.requireLocalPort=U.requireLocalPort,j.protocol=U.protocol):(j.onAutoForward=j.onAutoForward??U.onAutoForward,j.elevateIfNeeded=j.elevateIfNeeded!==void 0?j.elevateIfNeeded:U.elevateIfNeeded,j.label=j.label??U.label,j.requireLocalPort=j.requireLocalPort!==void 0?j.requireLocalPort:void 0,j.protocol=j.protocol??U.protocol),N=this.w(O,F,T,this.j,N+1)}return j.onAutoForward!==void 0||j.elevateIfNeeded!==void 0||j.label!==void 0||j.requireLocalPort!==void 0||j.protocol!==void 0?j:this.C()}t(O){return O.start!==void 0&&O.end!==void 0}u(O){return O.host!==void 0&&O.port!==void 0&&(0,c.$zf)(O.host)&&(0,c.$Df)(O.port)}w(O,F,T,N,j){if(j>=N.length)return-1;const U=!(0,D.$hv)(F)&&!(0,D.$jv)(F),he=N.slice(j).findIndex(x=>(0,c.$Df)(x.key)?U?!1:x.key===O:this.t(x.key)?U?!1:O>=x.key.start&&O<=x.key.end:this.u(x.key)?O===x.key.port&&F===x.key.host:T?x.key.test(T):!1);return he>=0?he+j:-1}y(){const O=this.r.getValue(b.c);if(!O||!(0,c.$Bf)(O))return[];const F=[];for(const N in O){if(N===void 0)continue;const j=O[N];let U;if(Number(N))U=Number(N);else if((0,c.$zf)(N))if(b.g.test(N)){const B=N.match(b.g);U={start:Number(B[1]),end:Number(B[2])}}else if(b.h.test(N)){const B=N.match(b.h);U={host:B[1],port:Number(B[2])}}else{let B;try{B=RegExp(N)}catch{}B&&(U=B)}U&&F.push({key:U,elevateIfNeeded:j.elevateIfNeeded,onAutoForward:j.onAutoForward,label:j.label,requireLocalPort:j.requireLocalPort,protocol:j.protocol})}const T=this.r.getValue(b.f);return T&&(this.m={elevateIfNeeded:T.elevateIfNeeded,label:T.label,onAutoForward:T.onAutoForward,requireLocalPort:T.requireLocalPort,protocol:T.protocol}),this.z(F)}z(O){function F(T,N){return(0,c.$Df)(T.key)?T.key:N.t(T.key)?T.key.start:N.u(T.key)?T.key.port:Number.MAX_VALUE}return O.sort((T,N)=>F(T,this)-F(N,this))}C(){return this.m}static providedActionToAction(O){switch(O){case D.ProvidedOnAutoForward.Notify:return w.Notify;case D.ProvidedOnAutoForward.OpenBrowser:return w.OpenBrowser;case D.ProvidedOnAutoForward.OpenBrowserOnce:return w.OpenBrowserOnce;case D.ProvidedOnAutoForward.OpenPreview:return w.OpenPreview;case D.ProvidedOnAutoForward.Silent:return w.Silent;case D.ProvidedOnAutoForward.Ignore:return w.Ignore;default:return}}async addAttributes(O,F,T){const j=this.r.inspect(b.c).userRemoteValue;let U;!j||!(0,c.$Bf)(j)?U={}:U=(0,f.$9m)(j),U[`${O}`]||(U[`${O}`]={});for(const B in F)U[`${O}`][B]=F[B];return this.r.updateValue(b.c,U,T)}}e.$XJ=b,b.c="remote.portsAttributes",b.f="remote.otherPortsAttributes",b.g=/^(\d+)\-(\d+)$/,b.h=/^([a-z0-9\-]+):(\d{1,5})$/;let I=class extends g.$Sc{constructor(O,F,T,N,j,U,B,he,x,Q){super(),this.H=O,this.I=F,this.J=T,this.L=N,this.M=j,this.N=U,this.O=B,this.P=he,this.Q=x,this.R=Q,this.c=new Map,this.g=new L.$Od,this.onForwardPort=this.g.event,this.h=new L.$Od,this.onClosePort=this.h.event,this.j=new L.$Od,this.onPortName=this.j.event,this.n=new L.$Od,this.onCandidatesChanged=this.n.event,this.t=new L.$Od,this.onEnvironmentTunnelsSet=this.t.event,this.u=!1,this.w=void 0,this.z=!1,this.C=new L.$Od,this.D=new Map,this.F=new Map,this.G=[],this.ab=new Date,this.configPortsAttributes=new b(T),this.s=this.Z(),this.B(this.configPortsAttributes.onDidChangeAttributes(this.gb,this)),this.forwarded=new Map,this.f=new Map,this.H.tunnels.then(async Z=>{const ie=await this.getAttributes(Z.map(_=>({port:_.tunnelRemotePort,host:_.tunnelRemoteHost})));for(const _ of Z)if(_.localAddress){const oe=C(_.tunnelRemoteHost,_.tunnelRemotePort),ye=v(this.m??new Map,_.tunnelRemoteHost,_.tunnelRemotePort);this.forwarded.set(oe,{remotePort:_.tunnelRemotePort,remoteHost:_.tunnelRemoteHost,localAddress:_.localAddress,protocol:ie?.get(_.tunnelRemotePort)?.protocol??D.TunnelProtocol.Http,localUri:await this.X(_.localAddress,ie?.get(_.tunnelRemotePort)),localPort:_.tunnelLocalPort,runningProcess:ye?.detail,hasRunningProcess:!!ye,pid:ye?.pid,privacy:_.privacy,source:e.$RJ}),this.f.set(oe,_)}}),this.detected=new Map,this.B(this.H.onTunnelOpened(async Z=>{const ie=C(Z.tunnelRemoteHost,Z.tunnelRemotePort);if(!v(this.forwarded,Z.tunnelRemoteHost,Z.tunnelRemotePort)&&!v(this.detected,Z.tunnelRemoteHost,Z.tunnelRemotePort)&&!v(this.c,Z.tunnelRemoteHost,Z.tunnelRemotePort)&&Z.localAddress){const _=v(this.m??new Map,Z.tunnelRemoteHost,Z.tunnelRemotePort),oe=(await this.getAttributes([{port:Z.tunnelRemotePort,host:Z.tunnelRemoteHost}]))?.get(Z.tunnelRemotePort);this.forwarded.set(ie,{remoteHost:Z.tunnelRemoteHost,remotePort:Z.tunnelRemotePort,localAddress:Z.localAddress,protocol:oe?.protocol??D.TunnelProtocol.Http,localUri:await this.X(Z.localAddress,oe),localPort:Z.tunnelLocalPort,closeable:!0,runningProcess:_?.detail,hasRunningProcess:!!_,pid:_?.pid,privacy:Z.privacy,source:e.$RJ})}await this.$(),this.f.set(ie,Z),this.g.fire(this.forwarded.get(ie))})),this.B(this.H.onTunnelClosed(Z=>this.W(Z,n.Other))),this.U()}S(){return this.Q.extensions.find(O=>O.activationEvents?.includes(e.$OJ))?(this.R.createKey(e.$PJ.key,!0),!0):!1}U(){if(this.S())return;const O=this.B(this.Q.onDidRegisterExtensions(()=>{this.S()&&O.dispose()}))}async W(O,F){const T=C(O.host,O.port);this.forwarded.has(T)&&(this.forwarded.delete(T),await this.$(),this.h.fire(O))}X(O,F){if(O.startsWith("http"))return k.URI.parse(O);const T=F?.protocol??"http";return k.URI.parse(`${T}://${O}`)}async Y(){const O=this.N.getWorkspace(),F=O.configuration?(0,A.$Ei)(O.configuration.path):O.folders.length>0?(0,A.$Ei)(O.folders[0].uri.path):void 0;if(F===void 0){this.O.debug("Could not get workspace hash for forwarded ports storage key.");return}return`${i}.${this.L.remoteAuthority}.${F}`}async Z(){const O=this.I.get(i,1);if(O)return this.I.remove(i,1),await this.$(),O;const F=await this.Y();if(F)return this.I.get(F,0)}async restoreForwarded(){if(this.J.getValue("remote.restoreForwardedPorts")){const O=await this.s;if(O&&O!==this.y){const F=JSON.parse(O)??[];this.O.trace(`ForwardedPorts: (TunnelModel) restoring ports ${F.map(T=>T.remotePort).join(", ")}`);for(const T of F){const N=v(this.detected,T.remoteHost,T.remotePort);T.source.source!==r.Extension&&!N||T.source.source===r.Extension&&N?await this.cb({remote:{host:T.remoteHost,port:T.remotePort},local:T.localPort,name:T.name,privacy:T.privacy,elevateIfNeeded:!0,source:T.source}):T.source.source===r.Extension&&!N&&this.D.set(C(T.remoteHost,T.remotePort),T)}}}if(this.z=!0,this.C.fire(),!this.w){const O=await this.Y();this.w=this.B(new g.$Rc),this.w.add(this.I.onDidChangeValue(0,void 0,this.w)(async F=>{F.key===O&&(this.s=Promise.resolve(this.I.get(O,0)),await this.restoreForwarded())}))}}async $(){if(this.J.getValue("remote.restoreForwardedPorts")){const O=JSON.stringify(Array.from(this.forwarded.values()));if(O!==this.y){this.y=O;const F=await this.Y();F&&this.I.store(F,this.y,0,0)}}}async bb(O,F,T){if(!O.tunnelLocalPort||!T?.requireLocalPort||O.tunnelLocalPort===F)return;const N=new Date;if(this.ab.getTime()+t>N.getTime())return;this.ab=N;const j=y.localize(3,null,F,O.tunnelRemotePort,O.tunnelLocalPort);return this.P.info(j)}async forward(O,F){return!this.z&&this.L.remoteAuthority&&await L.Event.toPromise(this.C.event),this.cb(O,F)}async cb(O,F){await this.Q.activateByEvent(e.$OJ);const T=v(this.forwarded,O.remote.host,O.remote.port);F=F??(F!==null?(await this.getAttributes([O.remote]))?.get(O.remote.port):void 0);const N=O.local!==void 0?O.local:O.remote.port;let j;if(T)return this.eb(T,O,F);{const U=this.L.remoteAuthority,B=U?{getAddress:async()=>(await this.M.resolveAuthority(U)).authority}:void 0,he=C(O.remote.host,O.remote.port);this.c.set(he,!0),O=this.db(he,O);const x=await this.H.openTunnel(B,O.remote.host,O.remote.port,void 0,N,O.elevateIfNeeded?O.elevateIfNeeded:F?.elevateIfNeeded,O.privacy,F?.protocol);if(typeof x=="string")j=x;else if(x&&x.localAddress){const Q=v(this.m??new Map,O.remote.host,O.remote.port),Z=x.protocol?x.protocol===D.TunnelProtocol.Https?D.TunnelProtocol.Https:D.TunnelProtocol.Http:F?.protocol??D.TunnelProtocol.Http,ie={remoteHost:x.tunnelRemoteHost,remotePort:x.tunnelRemotePort,localPort:x.tunnelLocalPort,name:F?.label??O.name,closeable:!0,localAddress:x.localAddress,protocol:Z,localUri:await this.X(x.localAddress,F),runningProcess:Q?.detail,hasRunningProcess:!!Q,pid:Q?.pid,source:O.source??e.$RJ,privacy:x.privacy};return this.forwarded.set(he,ie),this.f.set(he,x),this.c.delete(he),await this.$(),await this.bb(x,N,F),this.g.fire(ie),x}this.c.delete(he)}return j}db(O,F){const T=this.D.has(O)?this.D:this.F.has(O)?this.F:void 0;if(T){const N=T.get(O);T.delete(O),N&&(F.name=N.name??F.name,F.local=("local"in N?N.local:"localPort"in N?N.localPort:void 0)??F.local,F.privacy=N.privacy??F.privacy)}return F}async eb(O,F,T){const N=T?.label??F.name;let j;(function(B){B[B.None=0]="None",B[B.Fire=1]="Fire",B[B.Reopen=2]="Reopen"})(j||(j={}));let U=j.None;switch(N!==O.name&&(O.name=N,U=j.Fire),(T?.protocol||O.protocol!==D.TunnelProtocol.Http)&&T?.protocol!==O.protocol&&(F.source=O.source,U=j.Reopen),F.privacy&&O.privacy!==F.privacy&&(U=j.Reopen),U){case j.Fire:{this.g.fire();break}case j.Reopen:await this.close(O.remoteHost,O.remotePort,n.User),await this.cb(F,T)}return v(this.f,F.remote.host,F.remote.port)}async name(O,F,T){const N=v(this.forwarded,O,F),j=C(O,F);if(N){N.name=T,await this.$(),this.j.fire({host:O,port:F});return}else this.detected.has(j)&&(this.detected.get(j).name=T,this.j.fire({host:O,port:F}))}async close(O,F,T){const N=C(O,F),j=this.forwarded.get(N);return T===n.AutoForwardEnd&&j&&j.source.source===r.Auto&&this.F.set(N,{local:j.localPort,name:j.name,privacy:j.privacy}),await this.H.closeTunnel(O,F),this.W({host:O,port:F},T)}address(O,F){const T=C(O,F);return(this.forwarded.get(T)||this.detected.get(T))?.localAddress}get environmentTunnelsSet(){return this.u}addEnvironmentTunnels(O){if(O)for(const F of O){const T=v(this.m??new Map,F.remoteAddress.host,F.remoteAddress.port),N=typeof F.localAddress=="string"?F.localAddress:C(F.localAddress.host,F.localAddress.port);this.detected.set(C(F.remoteAddress.host,F.remoteAddress.port),{remoteHost:F.remoteAddress.host,remotePort:F.remoteAddress.port,localAddress:N,protocol:D.TunnelProtocol.Http,localUri:this.X(N),closeable:!1,runningProcess:T?.detail,hasRunningProcess:!!T,pid:T?.pid,privacy:D.TunnelPrivacyId.ConstantPrivate,source:{source:r.Extension,description:y.localize(4,null)}}),this.H.setEnvironmentTunnel(F.remoteAddress.host,F.remoteAddress.port,N,D.TunnelPrivacyId.ConstantPrivate,D.TunnelProtocol.Http)}this.u=!0,this.t.fire(),this.g.fire()}setCandidateFilter(O){this.r=O}async setCandidates(O){let F=O;this.r&&(F=await this.r(O));const T=this.fb(F);this.O.trace(`ForwardedPorts: (TunnelModel) removed candidates ${Array.from(T.values()).map(N=>N.port).join(", ")}`),this.n.fire(T)}fb(O){const F=this.m??new Map,T=new Map;return this.m=T,O.forEach(N=>{const j=C(N.host,N.port);T.set(j,{host:N.host,port:N.port,detail:N.detail,pid:N.pid}),F.has(j)&&F.delete(j);const U=v(this.forwarded,N.host,N.port);U&&(U.runningProcess=N.detail,U.hasRunningProcess=!0,U.pid=N.pid)}),F.forEach((N,j)=>{const U=s(j);if(!U)return;const B=v(this.forwarded,U.host,U.port);B&&(B.runningProcess=void 0,B.hasRunningProcess=!1,B.pid=void 0);const he=v(this.detected,U.host,U.port);he&&(he.runningProcess=void 0,he.hasRunningProcess=!1,he.pid=void 0)}),F}get candidates(){return this.m?Array.from(this.m.values()):[]}get candidatesOrUndefined(){return this.m?this.candidates:void 0}async gb(){const O=Array.from(this.forwarded.values()),F=await this.getAttributes(O.map(T=>({port:T.remotePort,host:T.remoteHost})),!1);if(F)for(const T of O){const N=F.get(T.remotePort);(N?.protocol||T.protocol!==D.TunnelProtocol.Http)&&N?.protocol!==T.protocol&&await this.cb({remote:{host:T.remoteHost,port:T.remotePort},local:T.localPort,name:T.name,source:T.source},N),N&&N.label&&N.label!==T.name&&await this.name(T.remoteHost,T.remotePort,N.label)}}async getAttributes(O,F=!0){const T=new Map,N=new Map;O.forEach(x=>{const Q=v(this.m??new Map,D.$gv[0],x.port)??x;if(Q){T.set(x.port,Q);const Z=m(Q)?Q.pid:void 0;N.has(Z)||N.set(Z,[]),N.get(Z)?.push(x.port)}});const j=new Map;if(O.forEach(x=>{const Q=this.configPortsAttributes.getAttributes(x.port,x.host,T.get(x.port)?.detail);Q&&j.set(x.port,Q)}),this.G.length===0||!F)return j.size>0?j:void 0;const U=await Promise.all((0,M.$Rb)(this.G.map(x=>Array.from(N.entries()).map(Q=>{const Z=Q[1],ie=T.get(Z[0]);return x.providePortAttributes(Z,ie?.pid,ie?.detail,new d.$Yd().token)})))),B=new Map;if(U.forEach(x=>x.forEach(Q=>{Q&&B.set(Q.port,Q)})),!j&&!B)return;const he=new Map;return O.forEach(x=>{const Q=j.get(x.port),Z=B.get(x.port);he.set(x.port,{elevateIfNeeded:Q?.elevateIfNeeded,label:Q?.label,onAutoForward:Q?.onAutoForward??b.providedActionToAction(Z?.autoForwardAction),requireLocalPort:Q?.requireLocalPort,protocol:Q?.protocol})}),he}addAttributesProvider(O){this.G.push(O)}};e.$YJ=I,He([(0,l.$jh)(1e3)],I.prototype,"$",null),e.$YJ=I=He([We(0,D.$cv),We(1,S.$$o),We(2,$.$ki),We(3,h.$NJ),We(4,p.$Qk),We(5,E.$Zh),We(6,P.$$i),We(7,R.$Gv),We(8,u.$iF),We(9,a.$9i)],I)}),define(De[92],Ce([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$LI=e.$KI=void 0;class y{constructor(A,g){this.line=A,this.character=g}isBefore(A){return!1}isBeforeOrEqual(A){return!1}isAfter(A){return!1}isAfterOrEqual(A){return!1}isEqual(A){return!1}compareTo(A){return 0}translate(A,g){return new y(0,0)}with(A){return new y(0,0)}}e.$KI=y;class M{constructor(A,g,k,$){this.isEmpty=!1,this.isSingleLine=!1,this.start=new y(A,g),this.end=new y(k,$)}contains(A){return!1}isEqual(A){return!1}intersection(A){}union(A){return new M(0,0,0,0)}with(A){return new M(0,0,0,0)}}e.$LI=M;var l;(function(L){L[L.Information=1]="Information",L[L.Warning=2]="Warning"})(l||(e.TextSearchCompleteMessageType=l={}))}),define(De[37],Ce([1,0,19,36,24,32,16,5,15,9,92,8]),function(re,e,y,M,l,L,A,g,k,$,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aJ=e.$_I=e.$$I=e.$0I=e.$9I=e.$8I=e.$7I=e.$6I=e.$5I=e.$4I=e.$3I=e.$2I=e.SearchErrorCode=e.$1I=e.$ZI=e.SearchSortOrder=e.ViewMode=e.$YI=e.$XI=e.$WI=e.$VI=e.SearchCompletionExitCode=e.$UI=e.$TI=e.$SI=e.QueryType=e.SearchProviderType=e.$RI=e.$QI=e.$PI=e.$OI=e.$NI=e.$MI=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return R.TextSearchCompleteMessageType}}),e.$MI="workbench.view.search",e.$NI="workbench.panel.search",e.$OI="workbench.view.search",e.$PI="search-result",e.$QI="search.exclude";const p="\u27EA ",S=" characters skipped \u27EB",D=(p.length+S.length+5)*2;e.$RI=(0,g.$Qh)("searchService");var E;(function(Z){Z[Z.file=0]="file",Z[Z.text=1]="text"})(E||(e.SearchProviderType=E={}));var h;(function(Z){Z[Z.File=1]="File",Z[Z.Text=2]="Text"})(h||(e.QueryType=h={}));function u(Z){return!!Z.preview}e.$SI=u;function d(Z){return!!Z.resource}e.$TI=d;function c(Z){return!!Z.message}e.$UI=c;var f;(function(Z){Z[Z.Normal=0]="Normal",Z[Z.NewSearchStarted=1]="NewSearchStarted"})(f||(e.SearchCompletionExitCode=f={}));class a{constructor(ie){this.resource=ie,this.results=[]}}e.$VI=a;class t{constructor(ie,_,oe,ye){this.ranges=_,this.webviewIndex=ye;const fe=Array.isArray(_)?_:[_];if(oe&&oe.matchLines===1&&i(fe)){ie=(0,A.$sf)(ie,oe.matchLines);let V="",le=0,H=0;const G=Math.floor(oe.charsPerLine/5),Y=[];for(const X of fe){const be=Math.max(X.startColumn-G,0),se=X.startColumn+oe.charsPerLine;if(be>H+G+D){const ge=p+(be-H)+S;V+=ge+ie.slice(be,se),le+=be-(H+ge.length)}else V+=ie.slice(H,se);Y.push(new n(0,X.startColumn-le,X.endColumn-le)),H=se}this.preview={text:V,matches:Array.isArray(this.ranges)?Y:Y[0]}}else{const V=Array.isArray(_)?_[0].startLineNumber:_.startLineNumber;this.preview={text:ie,matches:(0,y.$2b)(_,le=>new s(le.startLineNumber-V,le.startColumn,le.endLineNumber-V,le.endColumn))}}}}e.$WI=t;function i(Z){const ie=Z[0].startLineNumber;for(const _ of Z)if(_.startLineNumber!==ie||_.endLineNumber!==ie)return!1;return!0}class s{constructor(ie,_,oe,ye){this.startLineNumber=ie,this.startColumn=_,this.endLineNumber=oe,this.endColumn=ye}}e.$XI=s;class n extends s{constructor(ie,_,oe){super(ie,_,ie,oe)}}e.$YI=n;var r;(function(Z){Z.List="list",Z.Tree="tree"})(r||(e.ViewMode=r={}));var o;(function(Z){Z.Default="default",Z.FileNames="fileNames",Z.Type="type",Z.Modified="modified",Z.CountDescending="countDescending",Z.CountAscending="countAscending"})(o||(e.SearchSortOrder=o={}));function v(Z,ie=!0){const _=Z&&Z.files&&Z.files.exclude,oe=ie&&Z&&Z.search&&Z.search.exclude;if(!_&&!oe)return;if(!_||!oe)return _||oe;let ye=Object.create(null);return ye=l.$_m(ye,l.$9m(_)),ye=l.$_m(ye,l.$9m(oe),!0),ye}e.$ZI=v;function C(Z,ie){return Z.excludePattern&&M.$wj(Z.excludePattern,ie)?!1:Z.includePattern||Z.usingSearchPaths?Z.includePattern&&M.$wj(Z.includePattern,ie)?!0:Z.usingSearchPaths?!!Z.folderQueries&&Z.folderQueries.some(_=>{const oe=_.folder.fsPath;if(L.$Yf(ie,oe)){const ye=k.$lc(oe,ie);return!_.includePattern||!!M.$wj(_.includePattern,ye)}else return!1}):!1:!0}e.$1I=C;var w;(function(Z){Z[Z.unknownEncoding=1]="unknownEncoding",Z[Z.regexParseError=2]="regexParseError",Z[Z.globParseError=3]="globParseError",Z[Z.invalidLiteral=4]="invalidLiteral",Z[Z.rgProcessError=5]="rgProcessError",Z[Z.other=6]="other",Z[Z.canceled=7]="canceled"})(w||(e.SearchErrorCode=w={}));class m extends Error{constructor(ie,_){super(ie),this.code=_}}e.$2I=m;function b(Z){const ie=Z.message;if((0,$.$4)(Z))return new m(ie,w.canceled);try{const _=JSON.parse(ie);return new m(_.message,_.code)}catch{return new m(ie,w.other)}}e.$3I=b;function I(Z){const ie={message:Z.message,code:Z.code};return new Error(JSON.stringify(ie))}e.$4I=I;function z(Z){return Z.type==="error"?!0:Z.type==="success"}e.$5I=z;function O(Z){return Z.type==="success"}e.$6I=O;function F(Z){return!!Z.path}e.$7I=F;function T(Z,ie){const _=Z.searchPath?Z.searchPath:Z.relativePath;return(0,A.$pf)(_,ie)}e.$8I=T;class N{constructor(ie){this.path=ie,this.results=[]}addMatch(ie){this.results.push(ie)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$9I=N;function j(Z,ie){const _={...Z||{},...ie||{}};return Object.keys(_).filter(oe=>{const ye=_[oe];return typeof ye=="boolean"&&ye})}e.$0I=j;class U{constructor(ie,_){this.c=null,this.a={...ie.excludePattern||{},..._.excludePattern||{}},this.b=M.$xj(this.a);let oe=ie.includePattern;_.includePattern&&(oe?oe={...oe,..._.includePattern}:oe=_.includePattern),oe&&(this.c=M.$xj(oe))}matchesExcludesSync(ie,_,oe){return!!(this.b&&this.b(ie,_,oe))}includedInQuerySync(ie,_,oe){return!(this.b&&this.b(ie,_,oe)||this.c&&!this.c(ie,_,oe))}includedInQuery(ie,_,oe){const ye=this.b(ie,_,oe),fe=()=>this.c?!!this.c(ie,_,oe):!0;return(0,P.$Hg)(ye)?ye.then(V=>V?!1:fe()):fe()}hasSiblingExcludeClauses(){return B(this.a)}}e.$$I=U;function B(Z){for(const ie in Z)if(typeof Z[ie]!="boolean")return!0;return!1}function he(Z){if(!Z)return;let ie;return _=>(ie||(ie=(Z()||Promise.resolve([])).then(oe=>oe?Q(oe):{})),ie.then(oe=>!!oe[_]))}e.$_I=he;function x(Z){if(!Z)return;let ie;return _=>{if(!ie){const oe=Z();ie=oe?Q(oe):{}}return!!ie[_]}}e.$aJ=x;function Q(Z){const ie={};for(const _ of Z)ie[_]=!0;return ie}}),define(De[38],Ce([1,0,19,8,21,4,3,78,18,121,23,16,2,215,5,14,244,44,55,27,20,13,7,67,37,6]),function(re,e,y,M,l,L,A,g,k,$,R,P,p,S,D,E,h,u,d,c,f,a,t,i,s,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Scc=e.$Rcc=void 0;function r(z,O,F){return new R.$lg(T=>w(T,F)).isEqual(z,O)}function o(z,O,F){return r(z.uri,O.uri,F)?0:(0,P.$Ve)(z.uri.toString(),O.uri.toString())}function v(z,O,F){return z.index!==O.index?z.index<O.index?-1:1:r(z.uri,O.uri,F)?(0,P.$Ve)(z.name,O.name):(0,P.$Ve)(z.uri.toString(),O.uri.toString())}function C(z,O,F,T){const N=z.slice(0).sort((U,B)=>F(U,B,T)),j=O.slice(0).sort((U,B)=>F(U,B,T));return(0,y.$Eb)(N,j,(U,B)=>F(U,B,T))}function w(z,O){const F=O.getCapabilities(z.scheme);return!(F&&F&1024)}class m extends u.$0h{static toExtHostWorkspace(O,F,T,N){if(!O)return{workspace:null,added:[],removed:[]};const{id:j,name:U,folders:B,configuration:he,transient:x,isUntitled:Q}=O,Z=[],ie=F;F?B.forEach((fe,V)=>{const le=p.URI.revive(fe.uri),H=m.o(T||F,le,N);H?(H.name=fe.name,H.index=fe.index,Z.push(H)):Z.push({uri:le,name:fe.name,index:V})}):Z.push(...B.map(({uri:fe,name:V,index:le})=>({uri:p.URI.revive(fe),name:V,index:le}))),Z.sort((fe,V)=>fe.index<V.index?-1:1);const _=new m(j,U,Z,!!x,he?p.URI.revive(he):null,!!Q,fe=>w(fe,N)),{added:oe,removed:ye}=C(ie?ie.workspaceFolders:[],_.workspaceFolders,o,N);return{workspace:_,added:oe,removed:ye}}static o(O,F,T){for(let N=0;N<O.folders.length;N++){const j=O.workspaceFolders[N];if(r(j.uri,F,T))return j}}constructor(O,F,T,N,j,U,B){super(O,T.map(he=>new u.$$h(he)),N,j,B),this.t=F,this.u=U,this.q=[],this.s=g.$Wh.forUris(B),T.forEach(he=>{this.q.push(he),this.s.set(he.uri,he)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(O,F){return F&&this.s.get(O)&&(O=(0,R.$vg)(O)),this.s.findSubstr(O)}resolveWorkspaceFolder(O){return this.s.get(O)}}let b=class{constructor(O,F,T,N,j){this.c=new L.$Od,this.onDidChangeWorkspace=this.c.event,this.g=new L.$Od,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.z=0,this.A=new L.$Qd,this.B=new Map,this.h=N,this.s=T,this.t=j,this.j=new $.$Sl,this.k=new M.$Tg,this.o=O.getProxy(n.$qK.MainThreadWorkspace),this.q=O.getProxy(n.$qK.MainThreadMessageService);const U=F.workspace;this.l=U?new m(U.id,U.name,[],!!U.transient,U.configuration?p.URI.revive(U.configuration):null,!!U.isUntitled,B=>w(B,T)):void 0}$initializeWorkspace(O,F){this.v=F,this.$acceptWorkspaceData(O),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?p.URI.from({scheme:k.Schemas.untitled,path:(0,R.$tg)((0,R.$vg)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(O,F,T,...N){const j=[];if(Array.isArray(N)&&N.forEach(Q=>{p.URI.isUri(Q.uri)&&!j.some(Z=>r(Z.uri,Q.uri,this.s))&&j.push({uri:Q.uri,name:Q.name||(0,R.$sg)(Q.uri)})}),this.n||[F,T].some(Q=>typeof Q!="number"||Q<0)||T===0&&j.length===0)return!1;const U=this.x?this.x.workspaceFolders:[];if(F+T>U.length)return!1;const B=U.slice(0);B.splice(F,T,...j.map(Q=>({uri:Q.uri,name:Q.name||(0,R.$sg)(Q.uri),index:void 0})));for(let Q=0;Q<B.length;Q++){const Z=B[Q];if(B.some((ie,_)=>_!==Q&&r(Z.uri,ie.uri,this.s)))return!1}B.forEach((Q,Z)=>Q.index=Z);const{added:he,removed:x}=C(U,B,v,this.s);if(he.length===0&&x.length===0)return!1;if(this.o){const Q=O.displayName||O.name;this.o.$updateWorkspaceFolders(Q,F,T,j).then(void 0,Z=>{this.n=void 0;const ie={source:{identifier:O.identifier,label:O.displayName||O.name}};this.q.$showMessage(h.Severity.Error,(0,S.localize)(0,null,Q,Z.toString()),ie,[])})}return this.y(B),!0}getWorkspaceFolder(O,F){if(this.x)return this.x.getWorkspaceFolder(O,F)}async getWorkspaceFolder2(O,F){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(O,F)}async resolveWorkspaceFolder(O){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(O)}getPath(){if(!this.x)return;const{folders:O}=this.x;if(O.length!==0)return O[0].uri.fsPath}getRelativePath(O,F){let T,N="";if(typeof O=="string"?(T=p.URI.file(O),N=O):typeof O<"u"&&(T=O,N=O.fsPath),!T)return N;const j=this.getWorkspaceFolder(T,!0);if(!j)return N;typeof F>"u"&&this.x&&(F=this.x.folders.length>1);let U=(0,R.$yg)(j.uri,T);return F&&j.name&&(U=`${j.name}/${U}`),U}y(O){this.x&&(this.n=m.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:O,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(O){const{workspace:F,added:T,removed:N}=m.toExtHostWorkspace(O,this.l,this.n,this.s);this.l=F||void 0,this.n=void 0,this.c.fire(Object.freeze({added:T,removed:N}))}findFiles(O,F,T,N,j=l.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${N.value}, entryPoint: findFiles`);let U;if(F===null?U=!1:F&&(typeof F=="string"?U=F:U=F.pattern),j&&j.isCancellationRequested)return Promise.resolve([]);const{includePattern:B,folder:he}=I(a.GlobPattern.from(O));return this.o.$startFileSearch(B??null,he??null,U??null,T??null,j).then(x=>Array.isArray(x)?x.map(Q=>p.URI.revive(Q)):[])}async findTextInFiles(O,F,T,N,j=l.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${N.value}, entryPoint: findTextInFiles`);const U=this.j.getNext(),B=typeof F.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:F.previewOptions,{includePattern:he,folder:x}=I(a.GlobPattern.from(F.include)),Q=typeof F.exclude=="string"?F.exclude:F.exclude?F.exclude.pattern:void 0,Z={ignoreSymlinks:typeof F.followSymlinks=="boolean"?!F.followSymlinks:void 0,disregardIgnoreFiles:typeof F.useIgnoreFiles=="boolean"?!F.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof F.useGlobalIgnoreFiles=="boolean"?!F.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof F.useParentIgnoreFiles=="boolean"?!F.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof F.useDefaultExcludes=="boolean"?!F.useDefaultExcludes:!0,fileEncoding:F.encoding,maxResults:F.maxResults,previewOptions:B,afterContext:F.afterContext,beforeContext:F.beforeContext,includePattern:he,excludePattern:Q},ie=!1;if(this.u[U]=_=>{if(ie)return;const oe=p.URI.revive(_.resource);_.results.forEach(ye=>{(0,s.$SI)(ye)?T({uri:oe,preview:{text:ye.preview.text,matches:(0,y.$2b)(ye.preview.matches,fe=>new t.$uK(fe.startLineNumber,fe.startColumn,fe.endLineNumber,fe.endColumn))},ranges:(0,y.$2b)(ye.ranges,fe=>new t.$uK(fe.startLineNumber,fe.startColumn,fe.endLineNumber,fe.endColumn))}):T({uri:oe,text:ye.text,lineNumber:ye.lineNumber})})},j.isCancellationRequested)return{};try{const _=await this.o.$startTextSearch(O,x??null,Z,U,j);return delete this.u[U],_||{}}catch(_){throw delete this.u[U],_}}$handleTextSearchResult(O,F){this.u[F]?.(O)}async save(O){const F=await this.o.$save(O,{saveAs:!1});return p.URI.revive(F)}async saveAs(O){const F=await this.o.$save(O,{saveAs:!0});return p.URI.revive(F)}saveAll(O){return this.o.$saveAll(O)}resolveProxy(O){return this.o.$resolveProxy(O)}get trusted(){return this.v}requestWorkspaceTrust(O){return this.o.$requestWorkspaceTrust(O)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(O,F){if(this.w.has(O))throw new Error(`A provider has already been registered for scheme ${O}`);this.w.set(O,F);const T=this.t.transformOutgoingScheme(O),N=this.z++;return this.o.$registerEditSessionIdentityProvider(N,T),(0,A.$Qc)(()=>{this.w.delete(O),this.o.$unregisterEditSessionIdentityProvider(N)})}async $getEditSessionIdentifier(O,F){this.h.info("Getting edit session identifier for workspaceFolder",O);const T=await this.resolveWorkspaceFolder(p.URI.revive(O));if(!T){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",T);const N=this.w.get(T.uri.scheme);if(this.h.info(`Provider for scheme ${T.uri.scheme} is defined: `,!!N),!N)return;const j=await N.provideEditSessionIdentity(T,F);if(this.h.info("Provider returned edit session identifier: ",j),!!j)return j}async $provideEditSessionIdentityMatch(O,F,T,N){this.h.info("Getting edit session identifier for workspaceFolder",O);const j=await this.resolveWorkspaceFolder(p.URI.revive(O));if(!j){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",j);const U=this.w.get(j.uri.scheme);if(this.h.info(`Provider for scheme ${j.uri.scheme} is defined: `,!!U),!U)return;const B=await U.provideEditSessionIdentityMatch?.(F,T,N);if(this.h.info("Provider returned edit session identifier match result: ",B),!!B)return B}getOnWillCreateEditSessionIdentityEvent(O){return(F,T,N)=>{const j=function(B){F.call(T,B)};return j.extension=O,this.A.event(j,void 0,N)}}async $onWillCreateEditSessionIdentity(O,F,T){const N=await this.resolveWorkspaceFolder(p.URI.revive(O));if(N===void 0)throw new Error("Unable to resolve workspace folder");await this.A.fireAsync({workspaceFolder:N},F,async(j,U)=>{const B=Date.now();await Promise.resolve(j),Date.now()-B>T&&this.h.warn("SLOW edit session create-participant",U.extension.identifier)}),F.isCancellationRequested}registerCanonicalUriProvider(O,F){if(this.B.has(O))throw new Error(`A provider has already been registered for scheme ${O}`);this.B.set(O,F);const T=this.t.transformOutgoingScheme(O),N=this.z++;return this.o.$registerCanonicalUriProvider(N,T),(0,A.$Qc)(()=>{this.B.delete(O),this.o.$unregisterCanonicalUriProvider(N)})}async provideCanonicalUri(O,F,T){const N=this.B.get(O.scheme);if(!N)return;const j=await N.provideCanonicalUri?.(p.URI.revive(O),F,T);if(j)return j}async $provideCanonicalUri(O,F,T){return this.provideCanonicalUri(p.URI.revive(O),{targetScheme:F},T)}};e.$Rcc=b,e.$Rcc=b=He([We(0,f.$rM),We(1,c.$HM),We(2,d.$Fcc),We(3,E.$$i),We(4,i.$Pcc)],b),e.$Scc=(0,D.$Qh)("IExtHostWorkspace");function I(z){let O,F;return z&&(typeof z=="string"?O=z:(O=z.pattern,F=p.URI.revive(z.baseUri))),{includePattern:O,folder:F}}}),define(De[40],Ce([1,0,24,4,38,6,7,246,137,17,8,5,20,14,2]),function(re,e,y,M,l,L,A,g,k,$,R,P,p,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vcc=e.$Ucc=e.$Tcc=void 0;function E(i,s){if(s){const n=s.split(".");let r=i;for(let o=0;r&&o<n.length;o++)r=r[n[o]];return r}}function h(i){return i instanceof D.URI}function u(i){return i&&i.uri instanceof D.URI&&i.languageId&&typeof i.languageId=="string"}function d(i){return i&&!i.uri&&i.languageId&&typeof i.languageId=="string"}function c(i){return i&&i.uri instanceof D.URI&&(!i.name||typeof i.name=="string")&&(!i.index||typeof i.index=="number")}function f(i){if(h(i))return{resource:i};if(u(i))return{resource:i.uri,overrideIdentifier:i.languageId};if(d(i))return{overrideIdentifier:i.languageId};if(c(i))return{resource:i.uri};if(i===null)return{resource:null}}let a=class{constructor(s,n,r){this.a=s.getProxy(L.$qK.MainThreadConfiguration),this.c=n,this.b=r,this.d=new R.$Tg,this.e=null}getConfigProvider(){return this.d.wait().then(s=>this.e)}$initializeConfiguration(s){this.e=new t(this.a,this.c,s,this.b),this.d.open()}$acceptConfigurationChanged(s,n){this.getConfigProvider().then(r=>r.$acceptConfigurationChanged(s,n))}};e.$Tcc=a,e.$Tcc=a=He([We(0,p.$rM),We(1,l.$Scc),We(2,S.$$i)],a);class t{constructor(s,n,r,o){this.a=new M.$Od,this.b=s,this.f=o,this.c=n,this.e=g.$Jn.parse(r),this.d=this.k(r.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(s,n){const r={data:this.e.toData(),workspace:this.c.workspace};this.e=g.$Jn.parse(s),this.d=this.k(s.configurationScopes),this.a.fire(this.j(n,r))}getConfiguration(s,n,r){const o=f(n)||{},v=this.g(s?E(this.e.getValue(void 0,o,this.c.workspace),s):this.e.getValue(void 0,o,this.c.workspace));s&&this.h(s,o,r?.identifier);function C(m){if(m==null)return null;if(typeof m=="boolean")return m?2:5;switch(m){case A.ConfigurationTarget.Global:return 2;case A.ConfigurationTarget.Workspace:return 5;case A.ConfigurationTarget.WorkspaceFolder:return 6}}const w={has(m){return typeof E(v,m)<"u"},get:(m,b)=>{this.h(s?`${s}.${m}`:m,o,r?.identifier);let I=E(v,m);if(typeof I>"u")I=b;else{let z;const O=(F,T)=>{if((0,$.$Bf)(F)){let N;const j=()=>{z=z||(0,y.$9m)(v),N=N||E(z,T)};return new Proxy(F,{get:(U,B)=>{if(typeof B=="string"&&B.toLowerCase()==="tojson")return j(),()=>N;if(z)return N=N||E(z,T),N[B];const he=U[B];return typeof B=="string"?O(he,`${T}.${B}`):he},set:(U,B,he)=>(j(),N&&(N[B]=he),!0),deleteProperty:(U,B)=>(j(),N&&delete N[B],!0),defineProperty:(U,B,he)=>(j(),N&&Object.defineProperty(N,B,he),!0)})}return Array.isArray(F)?(0,y.$9m)(F):F};I=O(I,m)}return I},update:(m,b,I,z)=>{m=s?`${s}.${m}`:m;const O=C(I);return b!==void 0?this.b.$updateConfigurationOption(O,m,b,o,z):this.b.$removeConfigurationOption(O,m,o,z)},inspect:m=>{m=s?`${s}.${m}`:m;const b=this.e.inspect(m,o,this.c.workspace);if(b)return{key:m,defaultValue:(0,y.$9m)(b.policy?.value??b.default?.value),globalValue:(0,y.$9m)(b.user?.value??b.application?.value),workspaceValue:(0,y.$9m)(b.workspace?.value),workspaceFolderValue:(0,y.$9m)(b.workspaceFolder?.value),defaultLanguageValue:(0,y.$9m)(b.default?.override),globalLanguageValue:(0,y.$9m)(b.user?.override??b.application?.override),workspaceLanguageValue:(0,y.$9m)(b.workspace?.override),workspaceFolderLanguageValue:(0,y.$9m)(b.workspaceFolder?.override),languageIds:(0,y.$9m)(b.overrideIdentifiers)}}};return typeof v=="object"&&(0,y.$_m)(w,v,!1),Object.freeze(w)}g(s){const n=r=>(0,$.$Bf)(r)?new Proxy(r,{get:(o,v)=>n(o[v]),set:(o,v,C)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(v)}' of object`)},deleteProperty:(o,v)=>{throw new Error(`TypeError: Cannot delete read only property '${String(v)}' of object`)},defineProperty:(o,v)=>{throw new Error(`TypeError: Cannot define property '${String(v)}' for a readonly object`)},setPrototypeOf:o=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):r;return n(s)}h(s,n,r){const o=k.$An.test(s)?4:this.d.get(s),v=r?`[${r.value}] `:"";if(o===4){typeof n?.resource>"u"&&this.f.warn(`${v}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${s}', provide the URI of a resource or 'null' for any resource.`);return}if(o===3){n?.resource&&this.f.warn(`${v}Accessing a window scoped configuration for a resource is not expected. To associate '${s}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(s,n){const r=new g.$Ln(s,n,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(o,v)=>r.affectsConfiguration(o,f(v))})}k(s){return s.reduce((n,r)=>(n.set(r[0],r[1]),n),new Map)}}e.$Ucc=t,e.$Vcc=(0,P.$Qh)("IExtHostConfiguration")});var et=this&&this.__classPrivateFieldSet||function(re,e,y,M,l){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!l)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!l:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?l.call(re,y):l?l.value=y:e.set(re,y),y},Be=this&&this.__classPrivateFieldGet||function(re,e,y,M){if(y==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!M:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return y==="m"?M:y==="a"?M.call(re):M?M.value:e.get(re)};define(De[93],Ce([1,0,2,8,4,6,7,38,70,40,21,45,20,27,5,18,12,14,89,292,9]),function(re,e,y,M,l,L,A,g,k,$,R,P,p,S,D,E,h,u,d,c,f){"use strict";var a;Object.defineProperty(e,"__esModule",{value:!0}),e.$Tdc=e.$Sdc=e.$Rdc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var t;(function(F){function T(j){if(j!=null)return j}F.from=T;function N(j){if(j!=null)return j}F.to=N})(t||(t={}));var i;(function(F){function T(j){if(j!=null)return j}F.from=T;function N(j){if(j!=null)return j}F.to=N})(i||(i={}));var s;(function(F){function T(j){if(j!=null)return j}F.from=T;function N(j){if(j!=null)return j}F.to=N})(s||(s={}));var n;(function(F){function T(U){if(U){const B=U;return B&&!!B.process}else return!1}F.is=T;function N(U){if(U==null)return;const B={process:U.process,args:U.args};return U.options&&(B.options=s.from(U.options)),B}F.from=N;function j(U){if(U!=null)return new A.$aL(U.process,U.args,U.options)}F.to=j})(n||(n={}));var r;(function(F){function T(j){if(j!=null)return j}F.from=T;function N(j){if(j!=null)return j}F.to=N})(r||(r={}));var o;(function(F){function T(U){if(U){const B=U;return B&&(!!B.commandLine||!!B.command)}else return!1}F.is=T;function N(U){if(U==null)return;const B={};return U.commandLine!==void 0?B.commandLine=U.commandLine:(B.command=U.command,B.args=U.args),U.options&&(B.options=r.from(U.options)),B}F.from=N;function j(U){if(!(U==null||U.command===void 0&&U.commandLine===void 0))return U.commandLine?new A.$bL(U.commandLine,U.options):new A.$bL(U.command,U.args?U.args:[],U.options)}F.to=j})(o||(o={}));var v;(function(F){function T(U){if(U){const B=U;return B&&B.customExecution==="customExecution"}else return!1}F.is=T;function N(U){return{customExecution:"customExecution"}}F.from=N;function j(U,B){return B.get(U)}F.to=j})(v||(e.CustomExecutionDTO=v={}));var C;(function(F){function T(N,j){let U;return N.scope!==void 0&&typeof N.scope!="number"?U=N.scope.uri:N.scope!==void 0&&typeof N.scope=="number"&&(N.scope===A.TaskScope.Workspace&&j&&j.workspaceFile?U=j.workspaceFile:U=c.$XF),{id:N._id,workspaceFolder:U}}F.from=T})(C||(e.TaskHandleDTO=C={}));var w;(function(F){function T(N){if(N!=null)return{_id:N.id,isDefault:N.isDefault}}F.from=T})(w||(w={}));var m;(function(F){function T(U,B){if(U==null)return[];const he=[];for(const x of U){const Q=N(x,B);Q&&he.push(Q)}return he}F.fromMany=T;function N(U,B){if(U==null)return;let he;U.execution instanceof A.$aL?he=n.from(U.execution):U.execution instanceof A.$bL?he=o.from(U.execution):U.execution&&U.execution instanceof A.$cL&&(he=v.from(U.execution));const x=t.from(U.definition);let Q;return U.scope?typeof U.scope=="number"?Q=U.scope:Q=U.scope.uri:Q=A.TaskScope.Workspace,!x||!Q?void 0:{_id:U._id,definition:x,name:U.name,source:{extensionId:B.identifier.value,label:U.source,scope:Q},execution:he,isBackground:U.isBackground,group:w.from(U.group),presentationOptions:i.from(U.presentationOptions),problemMatchers:U.problemMatchers,hasDefinedMatchers:U.hasDefinedMatchers,runOptions:U.runOptions?U.runOptions:{reevaluateOnRerun:!0},detail:U.detail}}F.from=N;async function j(U,B,he){if(U==null)return;let x;n.is(U.execution)?x=n.to(U.execution):o.is(U.execution)?x=o.to(U.execution):v.is(U.execution)&&(x=v.to(U._id,he));const Q=t.to(U.definition);let Z;if(U.source&&(U.source.scope!==void 0?typeof U.source.scope=="number"?Z=U.source.scope:Z=await B.resolveWorkspaceFolder(y.URI.revive(U.source.scope)):Z=A.TaskScope.Workspace),!Q||!Z)return;const ie=new A.$dL(Q,Z,U.name,U.source.label,x,U.problemMatchers);return U.isBackground!==void 0&&(ie.isBackground=U.isBackground),U.group!==void 0&&(ie.group=A.$_K.from(U.group._id),ie.group&&U.group.isDefault&&(ie.group=new A.$_K(ie.group.id,ie.group.label),U.group.isDefault===!0&&(ie.group.isDefault=U.group.isDefault))),U.presentationOptions&&(ie.presentationOptions=i.to(U.presentationOptions)),U._id&&(ie._id=U._id),U.detail&&(ie.detail=U.detail),ie}F.to=j})(m||(e.TaskDTO=m={}));var b;(function(F){function T(j){return j}F.from=T;function N(j){if(j)return Object.assign(Object.create(null),j)}F.to=N})(b||(b={}));class I{constructor(T,N,j){this._id=N,this.a=j,a.set(this,void 0),et(this,a,T,"f")}get task(){return this.a}terminate(){Be(this,a,"f").terminateTask(this)}fireDidStartProcess(T){}fireDidEndProcess(T){}}a=new WeakMap;let z=class{constructor(T,N,j,U,B,he,x,Q){this.q=new l.$Od,this.r=new l.$Od,this.s=new l.$Od,this.t=new l.$Od,this.a=T.getProxy(L.$qK.MainThreadTask),this.b=j,this.c=U,this.d=B,this.e=he,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=x,this.g=Q,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(T,N,j){if(!j)return new A.$sK(()=>{});const U=this.w();return this.j.set(U,{type:N,provider:j,extension:T}),this.a.$registerTaskProvider(U,N),new A.$sK(()=>{this.j.delete(U),this.a.$unregisterTaskProvider(U)})}registerTaskSystem(T,N){this.a.$registerTaskSystem(T,N)}fetchTasks(T){return this.a.$fetchTasks(b.from(T)).then(async N=>{const j=[];for(const U of N){const B=await m.to(U,this.b,this.m);B&&j.push(B)}return j})}get taskExecutions(){const T=[];return this.k.forEach(N=>T.push(N)),T}terminateTask(T){if(!(T instanceof I))throw new Error("No valid task execution provided");return this.a.$terminateTask(T._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(T,N,j){const U=this.m.get(T.id);U&&(this.o.set(T.id,U),this.e.attachPtyToTerminal(N,await U.callback(j))),this.p=T.id,this.q.fire({execution:await this.y(T)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(T){const N=await this.y(T);this.l.delete(T.id),this.k.delete(T.id),this.A(T),this.r.fire({execution:N})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(T){const N=await this.y(T.id);this.s.fire({execution:N,processId:T.processId})}get onDidEndTaskProcess(){return this.t.event}async $onDidEndTaskProcess(T){const N=await this.y(T.id);this.t.fire({execution:N,exitCode:T.exitCode})}$provideTasks(T,N){const j=this.j.get(T);if(!j)return Promise.reject(new Error("no handler found"));const U=[],B=(0,M.$Ng)(()=>j.provider.provideTasks(R.CancellationToken.None)).then(he=>this.u(N,U,j,he));return new Promise(he=>{B.then(x=>{Promise.all(U).then(()=>{he(x)})})})}async $resolveTask(T,N){const j=this.j.get(T);if(!j)return Promise.reject(new Error("no handler found"));if(N.definition.type!==j.type)throw new Error(`Unexpected: Task of type [${N.definition.type}] cannot be resolved by provider of type [${j.type}].`);const U=await m.to(N,this.b,this.m);if(!U)throw new Error("Unexpected: Task cannot be resolved.");const B=await j.provider.resolveTask(U,R.CancellationToken.None);if(!B)return;this.z(B,j);const he=m.from(B,j.extension);if(!he)throw new Error("Unexpected: Task cannot be resolved.");if(B.definition!==U.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return v.is(he.execution)&&await this.x(he,B,!0),await this.v(he)}w(){return this.h++}async x(T,N,j){const U=await this.a.$createTaskId(T);!j&&!this.m.has(U)&&(this.n.add(U),this.o.set(U,N.execution)),this.m.set(U,N.execution)}async y(T,N){if(typeof T=="string"){const B=this.l.get(T);if(!B)throw new f.$bb("Unexpected: The specified task is missing an execution");return B}const j=this.l.get(T.id);if(j)return j;const U=new Promise((B,he)=>{function x(Q,Z,ie){ie?B(new I(Q,Z.id,ie)):he("Unexpected: Task does not exist.")}N?x(this,T,N):m.to(T.task,this.b,this.m).then(Q=>x(this,T,Q))});return this.l.set(T.id,U),U.then(B=>(this.k.set(T.id,B),B),B=>Promise.reject(B))}z(T,N){T._deprecated&&this.g.report("Task.constructor",N.extension,"Use the Task constructor that takes a `scope` instead.")}A(T){this.o.get(T.id)&&this.o.delete(T.id),this.n.has(T.id)&&this.p!==T.id&&(this.m.delete(T.id),this.n.delete(T.id));const j=this.n.values();let U=j.next();for(;!U.done;)!this.o.has(U.value)&&this.p!==U.value&&(this.m.delete(U.value),this.n.delete(U.value)),U=j.next()}};e.$Rdc=z,e.$Rdc=z=He([We(0,p.$rM),We(1,S.$HM),We(2,g.$Scc),We(3,k.$CM),We(4,$.$Vcc),We(5,P.$bdc),We(6,u.$$i),We(7,d.$Icc)],z);let O=class extends z{constructor(T,N,j,U,B,he,x,Q){super(T,N,j,U,B,he,x,Q),this.registerTaskSystem(E.Schemas.vscodeRemote,{scheme:E.Schemas.vscodeRemote,authority:"",platform:h.$c(0)})}async executeTask(T,N){if(!N.execution)throw new Error("Tasks to execute must include an execution");const j=m.from(N,T);if(j===void 0)throw new Error("Task is not valid");if(v.is(j.execution))await this.x(j,N,!1);else throw new f.$_;const U=await this.y(await this.a.$getTaskExecution(j),N);return this.a.$executeTask(j).catch(B=>{throw new Error(B)}),U}u(T,N,j,U){const B=[];if(U)for(const he of U){this.z(he,j),(!he.definition||!T[he.definition.type])&&this.f.warn(`The task [${he.source}, ${he.name}] uses an undefined task type. The task will be ignored in the future.`);const x=m.from(he,j.extension);x&&v.is(x.execution)?(B.push(x),N.push(this.x(x,he,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:B,extension:j.extension}}async v(T){if(v.is(T.execution))return T;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(T,N){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(T,N,j){}};e.$Sdc=O,e.$Sdc=O=He([We(0,p.$rM),We(1,S.$HM),We(2,g.$Scc),We(3,k.$CM),We(4,$.$Vcc),We(5,P.$bdc),We(6,u.$$i),We(7,d.$Icc)],O),e.$Tdc=(0,D.$Qh)("IExtHostTask")}),define(De[349],Ce([1,0,15,21,41,36,23,35,37]),function(re,e,y,M,l,L,A,g,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4dc=void 0;class ${constructor(p,S,D){this.k=p,this.l=S,this.o=D,this.e=!1,this.f=0,this.g=!1,this.a=p.filePattern,this.b=p.includePattern&&L.$xj(p.includePattern),this.c=p.maxResults||void 0,this.d=p.exists,this.h=new Set,this.j=p.excludePattern&&L.$xj(p.excludePattern)}cancel(){this.g=!0,this.h.forEach(p=>p.cancel()),this.h=new Set}search(p){const S=this.k.folderQueries||[];return new Promise((D,E)=>{const h=u=>{this.f++,p(u)};if(this.g)return D({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(u=>{const d=u.toString(),c=y.$nc(d);this.j&&this.j(d,c)||this.v(h,{base:u,basename:c})}),Promise.all(S.map(u=>this.p(u,h))).then(u=>{D({limitHit:this.e,stats:u[0]||void 0})},u=>{E(new Error((0,l.$Bi)(u)))})})}async p(p,S){const D=new M.$Yd,E=this.q(p),h=this.r(),u=new k.$$I(this.k,p),d=!u.hasSiblingExcludeClauses();let c;try{this.h.add(D),c=g.$Kd.create();const f=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},E,D.token),a=c.elapsed(),t=g.$Kd.create();return this.g&&!this.e||(f&&f.forEach(i=>{const s=y.$gc.relative(p.folder.path,i.path);if(d){const n=y.$nc(i.path);this.v(S,{base:p.folder,relativePath:s,basename:n});return}this.s(h,p.folder,s,S)}),this.g&&!this.e)?null:(this.u(h,u,S),{providerTime:a,postProcessTime:t.elapsed()})}finally{D.dispose(),this.h.delete(D)}}q(p){const S=(0,k.$0I)(this.k.includePattern,p.includePattern),D=(0,k.$0I)(this.k.excludePattern,p.excludePattern);return{folder:p.folder,excludes:D,includes:S,useIgnoreFiles:!p.disregardIgnoreFiles,useGlobalIgnoreFiles:!p.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!p.disregardParentIgnoreFiles,followSymlinks:!p.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const p={rootEntries:[],pathToEntries:Object.create(null)};return p.pathToEntries["."]=p.rootEntries,p}s({pathToEntries:p},S,D,E){if(D===this.a){const u=y.$nc(this.a);this.v(E,{base:S,relativePath:this.a,basename:u})}function h(u){const d=y.$nc(u),c=y.$mc(u);let f=p[c];f||(f=p[c]=[],h(c)),f.push({base:S,relativePath:u,basename:d})}h(D)}u({rootEntries:p,pathToEntries:S},D,E){const h=this,u=this.a;function d(c){const f=(0,k.$aJ)(()=>c.map(a=>a.basename));for(let a=0,t=c.length;a<t;a++){const i=c[a],{relativePath:s,basename:n}=i;if(D.matchesExcludesSync(s,n,u!==n?f:void 0))continue;const r=S[s];if(r)d(r);else{if(s===u)continue;h.v(E,i)}if(h.e)break}}d(p)}v(p,S){(!this.b||S.relativePath&&this.b(S.relativePath,S.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||p(S))}}class R{constructor(){this.b=new Map}fileSearch(p,S,D,E){const h=this.c(p.cacheKey),u=new $(p,S,h&&h.token);let d=0;const c=f=>{d+=f.length,D(f.map(a=>this.d(a)))};return this.e(u,R.a,c,E).then(f=>({limitHit:f.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:d,detailStats:f.stats}}))}clearCache(p){this.c(p)?.cancel()}c(p){if(p)return this.b.has(p)||this.b.set(p,new M.$Yd),this.b.get(p)}d(p){return p.relativePath?{resource:A.$wg(p.base,p.relativePath)}:{resource:p.base}}e(p,S,D,E){const h=E.onCancellationRequested(()=>{p.cancel()}),u=c=>{c&&(d.push(c),S>0&&d.length>=S&&(D(d),d=[]))};let d=[];return p.search(u).then(c=>(d.length&&D(d),h.dispose(),c),c=>(d.length&&D(d),h.dispose(),Promise.reject(c)))}}e.$4dc=R,R.a=512}),define(De[350],Ce([1,0,19,74,36,99,28,18,15,23,16,17,2,178,227,50,14,44,144,347,37]),function(re,e,y,M,l,L,A,g,k,$,R,P,p,S,D,E,h,u,d,c,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8J=e.$7J=void 0;let a=class{constructor(m,b,I,z,O){this.a=m,this.b=b,this.c=I,this.d=z,this.e=O}text(m,b,I={}){m=this.f(m,I);const z=this.a.getValue(),O=b&&b.some(T=>!this.a.getValue({resource:T}).search.useRipgrep);return{...this.h(b?.map(u.$_h),I),type:2,contentPattern:m,previewOptions:I.previewOptions,maxFileSize:I.maxFileSize,usePCRE2:z.search.usePCRE2||O||!1,beforeContext:I.beforeContext,afterContext:I.afterContext,userDisabledExcludesAndIgnoreFiles:I.disregardExcludeSettings&&I.disregardIgnoreFiles}}f(m,b){const I=this.a.getValue();m.isRegExp&&(m.pattern=m.pattern.replace(/\r?\n/g,"\\n"));const z={...m,wordSeparators:I.editor.wordSeparators};return this.j(m,b)&&(z.isCaseSensitive=!0),this.k(m)&&(z.isMultiline=!0),b.notebookSearchConfig?.includeMarkupInput&&(z.notebookInfo||(z.notebookInfo={}),z.notebookInfo.isInNotebookMarkdownInput=b.notebookSearchConfig.includeMarkupInput),b.notebookSearchConfig?.includeMarkupPreview&&(z.notebookInfo||(z.notebookInfo={}),z.notebookInfo.isInNotebookMarkdownPreview=b.notebookSearchConfig.includeMarkupPreview),b.notebookSearchConfig?.includeCodeInput&&(z.notebookInfo||(z.notebookInfo={}),z.notebookInfo.isInNotebookCellInput=b.notebookSearchConfig.includeCodeInput),b.notebookSearchConfig?.includeOutput&&(z.notebookInfo||(z.notebookInfo={}),z.notebookInfo.isInNotebookCellOutput=b.notebookSearchConfig.includeOutput),z}file(m,b={}){return{...this.h(m,b),type:1,filePattern:b.filePattern?b.filePattern.trim():b.filePattern,exists:b.exists,sortByScore:b.sortByScore,cacheKey:b.cacheKey}}g(m,b){return m?(m=Array.isArray(m)?m.map(r):r(m),b?this.parseSearchPaths(m):{pattern:i(...Array.isArray(m)?m:[m])}):{}}h(m=[],b={}){const I=this.g(b.includePattern,b.expandPatterns),z=this.g(b.excludePattern,b.expandPatterns),O=m.length>1,F=(I.searchPaths&&I.searchPaths.length?I.searchPaths.map(j=>this.q(j,b,z)):m.map(j=>this.r(j,b,z,O))).filter(j=>!!j),T={_reason:b._reason,folderQueries:F,usingSearchPaths:!!(I.searchPaths&&I.searchPaths.length),extraFileResources:b.extraFileResources,excludePattern:z.pattern,includePattern:I.pattern,onlyOpenEditors:b.onlyOpenEditors,maxResults:b.maxResults};if(b.onlyOpenEditors){const j=y.$Hb(y.$Rb(this.c.groups.map(he=>he.editors.map(x=>x.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(j));const U=j.filter(he=>(0,f.$1I)(T,he.fsPath)),B=this.i(U);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(B)),{...T,...B}}const N=b.extraFileResources&&b.extraFileResources.filter(j=>(0,f.$1I)(T,j.fsPath));return T.extraFileResources=N&&N.length?N:void 0,T}i(m){const b=[],I=new A.$Ac,z={};let O=!1;return m.forEach(F=>{if(F.scheme===g.Schemas.walkThrough)return;if((0,$.$Ag)(F)){const N=this.b.getWorkspaceFolder(F)?.uri??F.with({path:k.$mc(F.fsPath)});let j=I.get(N);j||(O=!0,j={folder:N,includePattern:{}},b.push(j),I.set(N,j));const U=k.$lc(N.fsPath,F.fsPath);(0,P.$Kf)(j.includePattern)[U.replace(/\\/g,"/")]=!0}else F.fsPath&&(O=!0,z[F.fsPath]=!0)}),{folderQueries:b,includePattern:z,usingSearchPaths:!0,excludePattern:O?void 0:{"**/*":!0}}}j(m,b){if(b.isSmartCase){if(m.isRegExp){if(R.$qf(m.pattern,!0))return!0}else if(R.$qf(m.pattern))return!0}return!!m.isCaseSensitive}k(m){return m.isMultiline||m.isRegExp&&(0,S.$AB)(m.pattern)||m.pattern.indexOf(`
`)>=0?!0:!!m.isMultiline}parseSearchPaths(m){const b=B=>k.$ic(B)||/^\.\.?([\/\\]|$)/.test(B),z=(Array.isArray(m)?m:s(m)).map(B=>{const he=this.e.resolvedUserHome;return he?(0,L.$zv)(B,he.scheme===g.Schemas.file?he.fsPath:he.path):B}),O=M.$D(z,B=>b(B)?"searchPaths":"exprSegments"),F=(O.exprSegments||[]).map(B=>R.$Le(B,"/")).map(B=>R.$Le(B,"\\")).map(B=>(B[0]==="."&&(B="*"+B),n(B))),T={},N=this.m(O.searchPaths||[]);N&&N.length&&(T.searchPaths=N);const j=y.$Rb(F),U=i(...j);return U&&(T.pattern=U),T}l(m,b){return b.disregardExcludeSettings?void 0:(0,f.$ZI)(m,!b.disregardSearchExcludeSettings)}m(m){if(!m||!m.length)return[];const b=m.flatMap(z=>{let{pathPortion:O,globPortion:F}=t(z);return F&&(F=o(F)),this.n(O).flatMap(N=>this.o(N,F))}),I=new Map;return b.forEach(z=>{const O=z.searchPath.toString(),F=I.get(O);F?z.pattern&&(F.pattern=F.pattern||{},F.pattern[z.pattern]=!0):I.set(O,{searchPath:z.searchPath,pattern:z.pattern?i(z.pattern):void 0})}),Array.from(I.values())}n(m){if(k.$ic(m)){const b=this.b.getWorkspace().folders;return b[0]&&b[0].uri.scheme!==g.Schemas.file?[{searchPath:b[0].uri.with({path:m})}]:[{searchPath:p.URI.file(k.$hc(m))}]}if(this.b.getWorkbenchState()===2){const b=this.b.getWorkspace().folders[0].uri;if(m=r(m),m.startsWith("../")||m===".."){const z=k.$gc.resolve(b.path,m);return[{searchPath:b.with({path:z})}]}const I=o(m);return[{searchPath:b,pattern:I}]}else{if(m==="./"||m===".\\")return[];{const b=m.replace(/^\.[\/\\]/,""),z=this.b.getWorkspace().folders.map(O=>{const F=b.match(new RegExp(`^${R.$Ge(O.name)}(?:/(.*)|$)`));return F?{match:F,folder:O}:null}).filter(P.$Hf);if(z.length)return z.map(O=>{const F=O.match[1];return{searchPath:O.folder.uri,pattern:F&&o(F)}});{const O=m.match(/\.[\/\\](.+)[\/\\]?/),F=O?O[1]:m,T=D.localize(0,null,F);throw new Error(T)}}}}o(m,b){const I=m.pattern&&b?`${m.pattern}/${b}`:m.pattern||b,z=[{searchPath:m.searchPath,pattern:I}];return I&&!I.endsWith("**")&&z.push({searchPath:m.searchPath,pattern:I+"/**"}),z}q(m,b,I){const z=this.r((0,u.$_h)(m.searchPath),b,I,!1);return z?{...z,includePattern:m.pattern}:null}r(m,b,I,z){let O;const F=p.URI.isUri(m)?m:m.uri;if(I.searchPaths){const B=I.searchPaths.filter(he=>(0,$.$pg)(he.searchPath,F))[0];if(B&&!B.pattern)return null;B&&(O=B.pattern)}const T=this.a.getValue({resource:F}),j={...this.l(T,b)||{},...O||{}},U=p.URI.isUri(m)?(0,$.$tg)(m):m.name;return{folder:F,folderName:z?U:void 0,excludePattern:Object.keys(j).length>0?j:void 0,fileEncoding:T.files&&T.files.encoding,disregardIgnoreFiles:typeof b.disregardIgnoreFiles=="boolean"?b.disregardIgnoreFiles:!T.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof b.disregardGlobalIgnoreFiles=="boolean"?b.disregardGlobalIgnoreFiles:!T.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof b.disregardParentIgnoreFiles=="boolean"?b.disregardParentIgnoreFiles:!T.search.useParentIgnoreFiles,ignoreSymlinks:typeof b.ignoreSymlinks=="boolean"?b.ignoreSymlinks:!T.search.followSymlinks}}};e.$7J=a,e.$7J=a=He([We(0,E.$ki),We(1,u.$Zh),We(2,d.$sC),We(3,h.$$i),We(4,c.$5J)],a);function t(w){const m=w.match(/[\*\{\}\(\)\[\]\?]/);if(m){const b=m.index,I=w.substr(0,b).match(/[/|\\][^/\\]*$/);if(I){let z=w.substr(0,I.index);return z.match(/[/\\]/)||(z+="/"),{pathPortion:z,globPortion:w.substr((I.index||0)+1)}}}return{pathPortion:w}}function i(...w){return w.length?w.reduce((m,b)=>(m[b]=!0,m),Object.create(null)):void 0}function s(w){return l.$vj(w,",").map(m=>m.trim()).filter(m=>!!m.length)}function n(w){return[`**/${w}/**`,`**/${w}`].map(b=>b.replace(/\*\*\/\*\*/g,"**"))}function r(w){return w.replace(/\\/g,"/")}function o(w){return r(w).replace(/^\.\//,"").replace(/\/+$/g,"")}function v(w){return w.replace(/([?*[\]])/g,"[$1]")}function C(w,m){w=y.$Mb(w,z=>z.toString());const b=[],I=m.getWorkspace();return w&&w.forEach(z=>{let O;if(m.getWorkbenchState()===2)O=(0,$.$yg)(I.folders[0].uri,z),O&&O!=="."&&(O="./"+O);else{const F=m.getWorkspaceFolder(z);if(F){const T=F.name;if(I.folders.filter(j=>j.name===T).length===1){const j=(0,$.$yg)(F.uri,z);j===""?O=`./${F.name}`:O=`./${F.name}/${j}`}else O=z.fsPath}}O&&b.push(v(O))}),b}e.$8J=C}),define(De[351],Ce([1,0,23,2,21,9,5,350,37,44]),function(re,e,y,M,l,L,A,g,k,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vlb=e.$Ulb=void 0;const R=7e3;function P(E,h){const u=h.activationEvents;if(!u)return Promise.resolve(void 0);const d=[],c=[];for(const n of u)if(/^workspaceContains:/.test(n)){const r=n.substr(18);r.indexOf("*")>=0||r.indexOf("?")>=0||E.forceUsingSearch?c.push(r):d.push(r)}if(d.length===0&&c.length===0)return Promise.resolve(void 0);let f;const a=new Promise((n,r)=>{f=n}),t=n=>f({activationEvent:n}),i=Promise.all(d.map(n=>p(E,n,t))).then(()=>{}),s=S(E,h.identifier,c,t);return Promise.all([i,s]).then(()=>{f(void 0)}),a}e.$Ulb=P;async function p(E,h,u){for(const d of E.folders)if(await E.exists(y.$wg(M.URI.revive(d),h))){u(`workspaceContains:${h}`);return}}async function S(E,h,u,d){if(u.length===0)return Promise.resolve(void 0);const c=new l.$Yd,f=E.checkExists(E.folders,u,c.token),a=setTimeout(async()=>{c.cancel(),E.logService.info(`Not activating extension '${h.value}': Timed out while searching for 'workspaceContains' pattern ${u.join(",")}`)},R);let t=!1;try{t=await f}catch(i){L.$4(i)||L.$1(i)}c.dispose(),clearTimeout(a),t&&d(`workspaceContains:${u.join(",")}`)}function D(E,h,u,d){const c=E.get(A.$Ph),f=E.get(k.$RI),t=c.createInstance(g.$7J).file(h.map(i=>(0,$.$_h)(M.URI.revive(i))),{_reason:"checkExists",includePattern:u,exists:!0});return f.fileSearch(t,d).then(i=>!!i.limitHit,i=>L.$4(i)?!1:Promise.reject(i))}e.$Vlb=D});var et=this&&this.__classPrivateFieldSet||function(re,e,y,M,l){if(M==="m")throw new TypeError("Private method is not writable");if(M==="a"&&!l)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!l:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return M==="a"?l.call(re,y):l?l.value=y:e.set(re,y),y},Be=this&&this.__classPrivateFieldGet||function(re,e,y,M){if(y==="a"&&!M)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!M:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return y==="m"?M:y==="a"?M.call(re):M?M.value:e.get(re)};define(De[46],Ce([1,0,205,15,54,23,8,3,78,2,14,6,40,282,116,38,26,146,9,25,22,263,7,65,5,27,90,20,104,73,45,4,351,115,265,18,113,35,12,114]),function(re,e,y,M,l,L,A,g,k,$,R,P,p,S,D,E,h,u,d,c,f,a,t,i,s,n,r,o,v,C,w,m,b,I,z,O,F,T,N,j){"use strict";var U,B,he,x;Object.defineProperty(e,"__esModule",{value:!0}),e.$qdc=e.$pdc=e.$odc=e.$ndc=e.$mdc=void 0,e.$mdc=(0,s.$Qh)("IHostUtils");let Q=x=class extends g.$Sc{constructor(H,G,Y,X,be,se,ge,te,me,we,Ie,W){super(),this.X=W,this.a=this.B(new m.$Od),this.onDidChangeRemoteConnectionData=this.a.event,this.U=!1,this.c=G,this.g=Y,this.f=ge,this.j=X,this.m=be,this.s=se,this.t=me,this.u=we,this.w=Ie,this.y=this.g.getProxy(P.$qK.MainThreadWorkspace),this.z=this.g.getProxy(P.$qK.MainThreadTelemetry),this.C=this.g.getProxy(P.$qK.MainThreadExtensionService),this.D=new A.$Tg,this.F=new A.$Tg,this.G=new A.$Tg,this.H=new A.$Tg,this.I=new V(this.f.extensions.activationEvents),this.L=new u.$V4b(this.I,this.f.extensions.allExtensions);const J=new c.$9l(this.f.extensions.myExtensions);this.J=new u.$V4b(this.I,ye(this.L,J)),N.$n&&(this.s.info(`Creating extension host with the following global extensions: ${_(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${_(this.J)}`)),this.M=new D.$6cc(this.g,this.s),this.N=new I.$fdc(this.g),this.O=te,this.h=H.createChild(new v.$Oh([D.$7cc,this.M],[I.$gdc,this.N])),this.P=this.B(new S.$5cc(this.J,this.L,{onExtensionActivationError:(ce,de,ee)=>{this.C.$onExtensionActivationError(ce,d.$3(de),ee)},actualActivateExtension:async(ce,de)=>{if(u.$V4b.isHostExtension(ce,this.J,this.L))return await this.C.$activateExtension(ce,de),new S.$4cc;const ee=this.J.getExtensionDescription(ce);return this.db(ee,de)}},this.s)),this.Q=null,this.R=Object.create(null),this.S=!1,this.W=this.f.remote.connectionData}getRemoteConnectionData(){return this.W}async initialize(){try{await this.tb(),this.D.open(),await this.j.waitForInitializeCall(),l.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.rb()}catch(H){d.$1(H)}}async Y(){this.O.onWillDeactivateAll();let H=[];try{H=this.J.getAllExtensionDescriptions().map(be=>be.identifier).filter(be=>this.isActivated(be)).map(be=>this.cb(be))}catch{}await Promise.all(H)}terminate(H,G=0){if(this.U)return;this.U=!0,this.s.info(`Extension host terminating: ${H}`),this.s.flush(),this.u.dispose(),this.P.dispose(),d.setUnexpectedErrorHandler(X=>{this.s.error(X)}),this.g.dispose();const Y=this.Y();Promise.race([(0,A.$Vg)(5e3),Y]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${G}`):this.s.info(`Extension host exiting with code ${G}`),this.s.flush(),this.s.dispose(),this.c.exit(G)})}isActivated(H){return this.G.isOpen()?this.P.isActivated(H):!1}async getExtension(H){const G=await this.C.$getExtension(H);return G&&{...G,identifier:new c.$8l(G.identifier.value),extensionLocation:$.URI.revive(G.extensionLocation)}}Z(H,G){return this.P.activateByEvent(H,G)}$(H,G){return this.P.activateById(H,G)}activateByIdWithErrors(H,G){return this.$(H,G).then(()=>{const Y=this.P.getActivatedExtension(H);if(Y.activationFailed)return Promise.reject(Y.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(H=>this.J)}getExtensionExports(H){if(this.G.isOpen())return this.P.getActivatedExtension(H).exports;try{return this.P.getActivatedExtension(H).exports}catch{return null}}async ab(H){if(H.scheme===O.Schemas.file&&this.c.fsRealpath){const G=await this.c.fsRealpath(H.fsPath);return $.URI.file(G)}return H}async getExtensionPathIndex(){return this.Q||(this.Q=this.bb(this.J.getAllExtensionDescriptions()).then(H=>new fe(H))),this.Q}async bb(H){const G=k.$Wh.forUris(Y=>L.$ng.ignorePathCasing(Y));return await Promise.all(H.map(async Y=>{if(this.ub(Y)){const X=await this.ab(Y.extensionLocation);G.set(X,Y)}})),G}cb(H){let G=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(H))return G;const Y=this.P.getActivatedExtension(H);if(!Y)return G;try{typeof Y.module.deactivate=="function"&&(G=Promise.resolve(Y.module.deactivate()).then(void 0,X=>(this.s.error(X),Promise.resolve(void 0))))}catch(X){this.s.error(`An error occurred when deactivating the extension '${H.value}':`),this.s.error(X)}try{(0,g.$Nc)(Y.subscriptions)}catch(X){this.s.error(`An error occurred when deactivating the subscriptions for extension '${H.value}':`),this.s.error(X)}return G}async db(H,G){return this.f.remote.isRemote?this.C.$onWillActivateExtension(H.identifier):await this.C.$onWillActivateExtension(H.identifier),this.fb(H,G).then(Y=>{const X=Y.activationTimes;return this.C.$onDidActivateExtension(H.identifier,X.codeLoadingTime,X.activateCallTime,X.activateResolvedTime,G),this.eb(H,G,"success",X),Y},Y=>{throw this.eb(H,G,"failure"),Y})}eb(H,G,Y,X){const be=ie(H,G);this.z.$publicLog2("extensionActivationTimes",{...be,...X||{},outcome:Y})}fb(H,G){const Y=ie(H,G);this.z.$publicLog2("activatePlugin",Y);const X=this.ub(H);if(!X)return Promise.resolve(new S.$3cc(S.$Zcc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${H.identifier.value}, startup: ${G.startup}, activationEvent: '${G.activationEvent}'${H.identifier.value!==G.extensionId.value?`, root cause: ${G.extensionId.value}`:""}`),this.s.flush();const be=new S.$1cc(G.startup);return Promise.all([this.vb(H,(0,L.$wg)(H.extensionLocation,X),be),this.gb(H)]).then(se=>(l.mark(`code/extHost/willActivateExtension/${H.identifier.value}`),x.hb(this.s,H.identifier,se[0],se[1],be))).then(se=>(l.mark(`code/extHost/didActivateExtension/${H.identifier.value}`),se))}gb(H){const G=new a.$9cc(H,this.M),Y=new a.$8cc(H.identifier.value,!1,this.M),X=new z.$hdc(H,this.N),be=H.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,se=this.f.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${H.identifier.value}`),Promise.all([G.whenReady,Y.whenReady,this.O.whenReady]).then(()=>{const ge=this;let te,me;const we=(0,h.$lF)(H,"ipc")?this.f.messagePorts?.get(c.$8l.toKey(H.identifier)):void 0;return Object.freeze({globalState:G,workspaceState:Y,secrets:X,subscriptions:[],get extensionUri(){return H.extensionLocation},get extensionPath(){return H.extensionLocation.fsPath},asAbsolutePath(Ie){return M.$jc(H.extensionLocation.fsPath,Ie)},get storagePath(){return ge.O.workspaceValue(H)?.fsPath},get globalStoragePath(){return ge.O.globalValue(H).fsPath},get logPath(){return M.$jc(ge.f.logsLocation.fsPath,H.identifier.value)},get logUri(){return $.URI.joinPath(ge.f.logsLocation,H.identifier.value)},get storageUri(){return ge.O.workspaceValue(H)},get globalStorageUri(){return ge.O.globalValue(H)},get extensionMode(){return be},get extension(){return te===void 0&&(te=new oe(ge,H.identifier,H,se,!1)),te},get extensionRuntime(){return(0,h.$mF)(H,"extensionRuntime"),ge.extensionRuntime},get environmentVariableCollection(){return ge.u.getEnvironmentVariableCollection(H)},get messagePassingProtocol(){if(!me){if(!we)return;const Ie=m.Event.buffer(m.Event.fromDOMEventEmitter(we,"message",W=>W.data));we.start(),me={onDidReceiveMessage:Ie,postMessage:we.postMessage.bind(we)}}return me}})})}static hb(H,G,Y,X,be){return Y=Y||{activate:void 0,deactivate:void 0},this.ib(H,G,Y,X,be).then(se=>new S.$2cc(!1,null,be.build(),Y,se,X.subscriptions))}static ib(H,G,Y,X,be){if(typeof Y.activate=="function")try{be.activateCallStart(),H.trace(`ExtensionService#_callActivateOptional ${G.value}`);const se=typeof global=="object"?global:self,ge=Y.activate.apply(se,[X]);return be.activateCallStop(),be.activateResolveStart(),Promise.resolve(ge).then(te=>(be.activateResolveStop(),te))}catch(se){return Promise.reject(se)}else return Promise.resolve(Y)}jb(H,G){this.$(H.identifier,{startup:!1,extensionId:H.identifier,activationEvent:G}).then(void 0,Y=>{this.s.error(Y)})}kb(H,G=0){const X=Date.now();(0,N.$v)(()=>{for(let be=G;be<H.length;be+=1){const se=H[be];for(const ge of se.activationEvents??[])if(ge==="onStartupFinished")if(Date.now()-X>50){this.kb(H,be);break}else this.jb(se,ge)}})}lb(){this.C.$setPerformanceMarks(l.getMarks()),this.m.getConfigProvider().then(H=>{const G=H.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),Y=this.J.getAllExtensionDescriptions();if(G)this.kb(Y);else for(const X of Y)if(X.activationEvents)for(const be of X.activationEvents)be==="onStartupFinished"&&this.jb(X,be)})}mb(){const H=this.Z("*",!0).then(void 0,se=>{this.s.error(se)});this.B(this.j.onDidChangeWorkspace(se=>this.nb(se.added)));const G=this.j.workspace?this.j.workspace.folders:[],Y=this.nb(G),X=this.pb(),be=Promise.all([X,H,Y]).then(()=>{});return Promise.race([be,(0,A.$Vg)(1e4)]).then(()=>{this.lb()}),be}nb(H){return H.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(G=>this.ob(H,G))).then(()=>{})}async ob(H,G){if(this.isActivated(G.identifier))return;const Y=!this.f.remote.isRemote&&!!this.f.remote.authority,X={logService:this.s,folders:H.map(se=>se.uri),forceUsingSearch:Y||!this.c.fsExists,exists:se=>this.c.fsExists(se.fsPath),checkExists:(se,ge,te)=>this.y.$checkExists(se,ge,te)},be=await(0,b.$Ulb)(X,G);if(be)return this.$(G.identifier,{startup:!0,extensionId:G.identifier,activationEvent:be.activationEvent}).then(void 0,se=>this.s.error(se))}async pb(){if(this.f.remote.authority)return this.Z(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.qb()}catch(H){throw console.error(H),H}}async qb(){const{extensionDevelopmentLocationURI:H,extensionTestsLocationURI:G}=this.f.environment;if(!H||!G)throw new Error(y.localize(0,null));const Y=await this.vb(null,G,new S.$1cc(!1));if(!Y||typeof Y.run!="function")throw new Error(y.localize(1,null,G.toString()));return new Promise((X,be)=>{const se=(me,we)=>{me?(N.$n&&this.s.error("Test runner called back with error",me),be(me)):(N.$n&&(we?this.s.info(`Test runner called back with ${we} failures.`):this.s.info("Test runner called back with successful outcome.")),X(typeof we=="number"&&we>0?1:0))},ge=(0,L.$kg)(G),te=Y.run(ge,se);te&&te.then&&te.then(()=>{N.$n&&this.s.info("Test runner finished successfully."),X(0)}).catch(me=>{N.$n&&this.s.error("Test runner finished with error",me),be(me instanceof Error&&me.stack?me.stack:String(me))})})}rb(){if(this.S)throw new Error("Extension host is already started!");return this.S=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,A.$Vg)(1e3)])).then(()=>this.mb()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(H,G){return this.R[H]=G,(0,g.$Qc)(()=>{delete this.R[H]})}async getRemoteExecServer(H){const{resolver:G}=await this.sb(H);return G?.resolveExecServer?.(H,{resolveAttempt:0})}async sb(H){const G=H.indexOf("+");if(G===-1)throw new t.$yK("Not an authority that can be resolved!",i.RemoteAuthorityResolverErrorCode.InvalidAuthority);const Y=H.substr(0,G);return await this.D.wait(),await this.Z(`onResolveRemoteAuthority:${Y}`,!1),{authorityPrefix:Y,resolver:this.R[Y]}}async $resolveAuthority(H,G){const Y=T.$Kd.create(!1),X=()=>`[resolveAuthority(${(0,i.$Uk)(H)},${G})][${Y.elapsed()}ms] `,be=ve=>this.s.info(`${X()}${ve}`),se=ve=>this.s.warn(`${X()}${ve}`),ge=(ve,Ne=void 0)=>this.s.error(`${X()}${ve}`,Ne),te=ve=>{if(ve instanceof t.$yK)return{type:"error",error:{code:ve._code,message:ve._message,detail:ve._detail}};throw ve},me=async ve=>{be(`activating resolver for ${ve}...`);const{resolver:Ne,authorityPrefix:qe}=await this.sb(ve);if(!Ne)throw ge(`no resolver for ${qe}`),new t.$yK(`No remote extension installed to resolve ${qe}.`,i.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:Ne,authorityPrefix:qe,remoteAuthority:ve}},we=H.split(/@|%40/g).reverse();be(`activating remote resolvers ${we.join(" -> ")}`);let Ie;try{Ie=await Promise.all(we.map(me)).catch(async ve=>{if(!(ve instanceof t.$yK)||ve._code!==i.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw ve;return se(`resolving nested authorities failed: ${ve.message}`),[await me(H)]})}catch(ve){return te(ve)}const W=new A.$6g;W.cancelAndSet(()=>be("waiting..."),1e3);let J,ce;for(const[ve,{authorityPrefix:Ne,resolver:qe,remoteAuthority:xe}]of Ie.entries())try{if(ve===Ie.length-1)be("invoking final resolve()..."),l.mark(`code/extHost/willResolveAuthority/${Ne}`),J=await qe.resolve(xe,{resolveAttempt:G,execServer:ce}),l.mark(`code/extHost/didResolveAuthorityOK/${Ne}`),be("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(qe,t.$xK.isManagedResolvedAuthority(J)?J:void 0));else{if(be(`invoking resolveExecServer() for ${xe}`),l.mark(`code/extHost/willResolveExecServer/${Ne}`),ce=await qe.resolveExecServer?.(xe,{resolveAttempt:G,execServer:ce}),!ce)throw new t.$yK(`Exec server was not available for ${xe}`,i.RemoteAuthorityResolverErrorCode.NoResolverFound);l.mark(`code/extHost/didResolveExecServerOK/${Ne}`)}}catch(Ge){return l.mark(`code/extHost/didResolveAuthorityError/${Ne}`),ge("returned an error",Ge),W.dispose(),te(Ge)}W.dispose();const de={environmentTunnels:J.environmentTunnels,features:J.tunnelFeatures},ee={extensionHostEnv:J.extensionHostEnv,isTrusted:J.isTrusted,authenticationSession:J.authenticationSessionForInitializingExtensions?{id:J.authenticationSessionForInitializingExtensions.id,providerId:J.authenticationSessionForInitializingExtensions.providerId}:void 0};be(`returned ${t.$xK.isManagedResolvedAuthority(J)?"managed authority":`${J.host}:${J.port}`}`);let $e;if(t.$xK.isManagedResolvedAuthority(J)){const ve=G;this.X.setFactory(ve,J.makeConnection),$e={authority:H,connectTo:new i.$Rk(ve),connectionToken:J.connectionToken}}else $e={authority:H,connectTo:new i.$Sk(J.host,J.port),connectionToken:J.connectionToken};return{type:"ok",value:{authority:$e,options:ee,tunnelInformation:de}}}async $getCanonicalURI(H,G){this.s.info(`$getCanonicalURI invoked for authority (${(0,i.$Uk)(H)})`);const{resolver:Y}=await this.sb(H);if(!Y)return null;const X=$.URI.revive(G);if(typeof Y.getCanonicalURI>"u")return X;const be=await(0,A.$Ng)(()=>Y.getCanonicalURI(X));return be||X}$startExtensionHost(H){H.toAdd.forEach(X=>X.extensionLocation=$.URI.revive(X.extensionLocation));const{globalRegistry:G,myExtensions:Y}=Z(this.I,this.L,this.J,H);return this.L.set(G.getAllExtensionDescriptions()),this.J.set(Y),N.$n&&(this.s.info(`$startExtensionHost: global extensions: ${_(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${_(this.J)}`)),this.rb()}$activateByEvent(H,G){return G===1?this.D.wait().then(Y=>this.Z(H,!1)):this.G.wait().then(Y=>this.Z(H,!1))}async $activate(H,G){return await this.G.wait(),this.J.getExtensionDescription(H)?(await this.$(H,G),!0):!1}async $deltaExtensions(H){H.toAdd.forEach(se=>se.extensionLocation=$.URI.revive(se.extensionLocation));const{globalRegistry:G,myExtensions:Y}=Z(this.I,this.L,this.J,H),X=await this.bb(Y);return(await this.getExtensionPathIndex()).setSearchTree(X),this.L.set(G.getAllExtensionDescriptions()),this.J.set(Y),N.$n&&(this.s.info(`$deltaExtensions: global extensions: ${_(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${_(this.J)}`)),Promise.resolve(void 0)}async $test_latency(H){return H}async $test_up(H){return H.byteLength}async $test_down(H){const G=f.$ce.alloc(H),Y=Math.random()%256;for(let X=0;X<H;X++)G.writeUInt8(Y,X);return G}async $updateRemoteConnectionData(H){this.W=H,this.a.fire()}};e.$ndc=Q,e.$ndc=Q=x=He([We(0,s.$Ph),We(1,e.$mdc),We(2,o.$rM),We(3,E.$Scc),We(4,p.$Vcc),We(5,R.$$i),We(6,n.$HM),We(7,r.$_cc),We(8,C.$uwb),We(9,w.$bdc),We(10,F.$jdc),We(11,j.$kdc)],Q);function Z(le,H,G,Y){le.addActivationEvents(Y.addActivationEvents);const X=new u.$V4b(le,H.getAllExtensionDescriptions());X.deltaExtensions(Y.toAdd,Y.toRemove);const be=new c.$9l(G.getAllExtensionDescriptions().map(ge=>ge.identifier));for(const ge of Y.myToRemove)be.delete(ge);for(const ge of Y.myToAdd)be.add(ge);const se=ye(X,be);return{globalRegistry:X,myExtensions:se}}function ie(le,H){return{id:le.identifier.value,name:le.name,extensionVersion:le.version,publisherDisplayName:le.publisher,activationEvents:le.activationEvents?le.activationEvents.join(","):null,isBuiltin:le.isBuiltin,reason:H.activationEvent,reasonId:H.extensionId.value}}function _(le){return le.getAllExtensionDescriptions().map(H=>H.identifier.value).join(",")}e.$odc=(0,s.$Qh)("IExtHostExtensionService");class oe{constructor(H,G,Y,X,be){U.set(this,void 0),B.set(this,void 0),he.set(this,void 0),et(this,U,H,"f"),et(this,B,G,"f"),et(this,he,Y.identifier,"f"),this.id=Y.identifier.value,this.extensionUri=Y.extensionLocation,this.extensionPath=M.$hc((0,L.$kg)(Y.extensionLocation)),this.packageJSON=Y,this.extensionKind=X,this.isFromDifferentExtensionHost=be}get isActive(){return Be(this,U,"f").isActivated(Be(this,he,"f"))}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return Be(this,U,"f").getExtensionExports(Be(this,he,"f"))}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await Be(this,U,"f").activateByIdWithErrors(Be(this,he,"f"),{startup:!1,extensionId:Be(this,B,"f"),activationEvent:"api"}),this.exports}}e.$pdc=oe,U=new WeakMap,B=new WeakMap,he=new WeakMap;function ye(le,H){return le.getAllExtensionDescriptions().filter(G=>H.has(G.identifier))}class fe{constructor(H){this.a=H}setSearchTree(H){this.a=H}findSubstr(H){return this.a.findSubstr(H)}forEach(H){return this.a.forEach(H)}}e.$qdc=fe;class V{constructor(H){this.a=new c.$0l,this.addActivationEvents(H)}readActivationEvents(H){return this.a.get(H.identifier)}addActivationEvents(H){for(const G of Object.keys(H))this.a.set(G,H[G])}}}),define(De[352],Ce([1,0,54,2,6,40,26,25,20,27,5,46,14,16]),function(re,e,y,M,l,L,A,g,k,$,R,P,p,S){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.$Oec=void 0;let E=class{constructor(f,a,t,i,s,n,r){this.c=f,this.d=a,this.f=t,this.g=i,this.h=s,this.i=n,this.j=r,this.a=new Map,this.b=[]}async install(){this.k(),y.mark("code/extHost/willWaitForConfig");const f=await this.g.getConfigProvider();y.mark("code/extHost/didWaitForConfig");const a=await this.h.getExtensionPathIndex();this.register(new u(this.c,a,this.d,f,this.j)),this.register(this.f.createInstance(h)),this.i.remote.isRemote&&this.register(this.f.createInstance(d,a,this.i.environment.appUriScheme))}register(f){if("nodeModuleName"in f)if(Array.isArray(f.nodeModuleName))for(const a of f.nodeModuleName)this.a.set(a,f);else this.a.set(f.nodeModuleName,f);typeof f.alternativeModuleName=="function"&&this.b.push(a=>f.alternativeModuleName(a))}};e.$Oec=E,e.$Oec=E=He([We(2,R.$Ph),We(3,L.$Vcc),We(4,P.$odc),We(5,$.$HM),We(6,p.$$i)],E);let h=D=class{constructor(f){if(f.environment.appRoot&&D.a.size){const a=(0,S.$Ge)(this.c(f.environment.appRoot.fsPath)),t="[a-z0-9_.-]",i=`@${t}+\\/${t}+|${t}+`,s="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${a}/${s}\\/)(${i})(.*)$`,"i")}}alternativeModuleName(f){if(!this.b)return;const a=this.b.exec(this.c(f));if(!a)return;const[,t,i,s]=a,n=D.a.get(i);if(n!==void 0)return console.warn(`${i} as been renamed to ${n}, please update your imports`),t+n+s}c(f){return f.replace(/\\/g,"/")}};h.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]]),h=D=He([We(0,$.$HM)],h);class u{constructor(f,a,t,i,s){this.c=f,this.d=a,this.e=t,this.f=i,this.g=s,this.nodeModuleName="vscode",this.a=new g.$0l}load(f,a){const t=this.d.findSubstr(a);if(t){let i=this.a.get(t.identifier);return i||(i=this.c(t,this.e,this.f),this.a.set(t.identifier,i)),i}if(!this.b){let i="";this.d.forEach((s,n)=>i+=`	${n} -> ${s.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${a}. These are the extension path mappings: 
${i}`),this.b=this.c(A.$gF,this.e,this.f)}return this.b}}let d=class{constructor(f,a,t){this.e=f,this.f=a,this.nodeModuleName=["open","opn"],this.d=t.getProxy(l.$qK.MainThreadTelemetry);const i=t.getProxy(l.$qK.MainThreadWindow);this.c=(s,n)=>{const r=M.URI.parse(s);return n?this.g(s,n):r.scheme==="http"||r.scheme==="https"?i.$openUri(r,s,{allowTunneling:!0}):r.scheme==="mailto"||r.scheme===this.f?i.$openUri(r,s,{}):this.g(s,n)}}load(f,a,t){const i=this.e.findSubstr(a);return i&&(this.a=i.identifier.value,this.h()),this.b=t(f),this.c}g(f,a){return this.i(),this.b(f,a)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};d=He([We(2,k.$rM)],d)}),define(De[56],Ce([1,0,47,3,15,48,5,70,71,46,7,38,279,40]),function(re,e,y,M,l,L,A,g,k,$,R,P,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xdc=e.$Wdc=void 0,e.$Wdc=(0,A.$Qh)("IExtHostVariableResolverProvider");class D extends p.$sN{constructor(u,d,c,f,a,t,i){function s(){if(c){const n=c.activeEditor();if(n)return n.document.uri;const r=f.tabGroups.all.find(o=>o.isActive)?.activeTab;if(r!==void 0){if(r.input instanceof R.$$L||r.input instanceof R.$dM)return r.input.modified;if(r.input instanceof R.$0L||r.input instanceof R.$cM||r.input instanceof R.$aM)return r.input.uri}}}super({getFolderUri:n=>{const r=t.folders.filter(o=>o.name===n);if(r&&r.length>0)return r[0].uri},getWorkspaceFolderCount:()=>t.folders.length,getConfigurationValue:(n,r)=>a.getConfiguration(void 0,n).get(r),getAppRoot:()=>L.cwd(),getExecPath:()=>L.env.VSCODE_EXEC_PATH,getFilePath:()=>{const n=s();if(n)return l.$hc(n.fsPath)},getWorkspaceFolderPathForFile:()=>{if(d){const n=s();if(n){const r=d.getWorkspaceFolder(n);if(r)return l.$hc(r.uri.fsPath)}}},getSelectedText:()=>{if(c){const n=c.activeEditor();if(n&&!n.selection.isEmpty)return n.document.getText(n.selection)}},getLineNumber:()=>{if(c){const n=c.activeEditor();if(n)return String(n.selection.end.line+1)}},getExtension:n=>u.getExtension(n)},void 0,i?Promise.resolve(i):void 0,Promise.resolve(L.env))}}let E=class extends M.$Sc{constructor(u,d,c,f,a){super(),this.b=u,this.c=d,this.g=c,this.h=f,this.j=a,this.a=new y.$V(async()=>{const t=await this.h.getConfigProvider(),s={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async n=>{s.folders=await this.c.getWorkspaceFolders2()||[]})),new D(this.b,this.c,this.g,this.j,t,s,this.m())})}getResolver(){return this.a.value}m(){}};e.$Xdc=E,e.$Xdc=E=He([We(0,$.$odc),We(1,P.$Scc),We(2,g.$CM),We(3,S.$Vcc),We(4,k.$Udc)],E)}),define(De[94],Ce([1,0,8,4,2,5,6,71,46,20,7,38,141,272,40,56]),function(re,e,y,M,l,L,A,g,k,$,R,P,p,S,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3dc=e.$2dc=e.$1dc=e.$Zdc=e.$Ydc=void 0,e.$Ydc=(0,L.$Qh)("IExtHostDebugService");let h=class{get onDidStartDebugSession(){return this.m.event}get onDidTerminateDebugSession(){return this.n.event}get onDidChangeActiveDebugSession(){return this.o.event}get activeDebugSession(){return this.q}get onDidReceiveDebugSessionCustomEvent(){return this.u.event}get activeDebugConsole(){return this.v.value}constructor(i,s,n,r,o,v){this.E=s,this.F=n,this.G=r,this.H=o,this.I=v,this.l=new Map,this.d=0,this.f=[],this.g=0,this.h=[],this.i=0,this.j=[],this.B=new Map,this.C=new Map,this.m=new M.$Od,this.n=new M.$Od,this.o=new M.$Od,this.u=new M.$Od,this.k=i.getProxy(A.$qK.MainThreadDebugService),this.y=new M.$Od,this.A=new M.$Od,this.v=new d(this.k),this.w=new Map,this.F.getExtensionRegistry().then(C=>{C.onDidChange(w=>{this.J(C)}),this.J(C)})}asDebugSourceUri(i,s){const n=i;if(typeof n.sourceReference=="number"&&n.sourceReference>0){let r=`debug:${encodeURIComponent(n.path||"")}`,o="?";return s&&(r+=`${o}session=${encodeURIComponent(s.id)}`,o="&"),r+=`${o}ref=${n.sourceReference}`,l.URI.parse(r)}else{if(n.path)return l.URI.file(n.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}J(i){const s=[];for(const n of i.getAllExtensionDescriptions())if(n.contributes){const r=n.contributes.debuggers;if(r&&r.length>0)for(const o of r)(0,S.$AF)(o)&&s.push(o.type)}this.k.$registerDebugTypes(s)}get stackFrameFocus(){return this.z}get onDidChangeStackFrameFocus(){return this.A.event}get onDidChangeBreakpoints(){return this.y.event}get breakpoints(){const i=[];return this.w.forEach(s=>i.push(s)),i}addBreakpoints(i){const s=i.filter(o=>{const v=o.id;return this.w.has(v)?!1:(this.w.set(v,o),!0)});this.U(s,[],[]);const n=[],r=new Map;for(const o of s)if(o instanceof R.$rL){let v=r.get(o.location.uri.toString());v||(v={type:"sourceMulti",uri:o.location.uri,lines:[]},r.set(o.location.uri.toString(),v),n.push(v)),v.lines.push({id:o.id,enabled:o.enabled,condition:o.condition,hitCondition:o.hitCondition,logMessage:o.logMessage,line:o.location.range.start.line,character:o.location.range.start.character})}else o instanceof R.$sL&&n.push({type:"function",id:o.id,enabled:o.enabled,hitCondition:o.hitCondition,logMessage:o.logMessage,condition:o.condition,functionName:o.functionName});return this.k.$registerBreakpoints(n)}removeBreakpoints(i){const s=i.filter(v=>this.w.delete(v.id));this.U([],s,[]);const n=s.filter(v=>v instanceof R.$rL).map(v=>v.id),r=s.filter(v=>v instanceof R.$sL).map(v=>v.id),o=s.filter(v=>v instanceof R.$tL).map(v=>v.id);return this.k.$unregisterBreakpoints(n,r,o)}startDebugging(i,s,n){return this.k.$startDebugging(i?i.uri:void 0,s,{parentSessionID:n.parentSession?n.parentSession.id:void 0,lifecycleManagedByParent:n.lifecycleManagedByParent,repl:n.consoleMode===R.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:n.noDebug,compact:n.compact,suppressSaveBeforeStart:n.suppressSaveBeforeStart,suppressDebugStatusbar:n.suppressDebugStatusbar??n.debugUI?.simple,suppressDebugToolbar:n.suppressDebugToolbar??n.debugUI?.simple,suppressDebugView:n.suppressDebugView??n.debugUI?.simple})}stopDebugging(i){return this.k.$stopDebugging(i?i.id:void 0)}registerDebugConfigurationProvider(i,s,n){if(!s)return new R.$sK(()=>{});const r=this.d++;return this.f.push({type:i,handle:r,provider:s}),this.k.$registerDebugConfigurationProvider(i,n,!!s.provideDebugConfigurations,!!s.resolveDebugConfiguration,!!s.resolveDebugConfigurationWithSubstitutedVariables,r),new R.$sK(()=>{this.f=this.f.filter(o=>o.provider!==s),this.k.$unregisterDebugConfigurationProvider(r)})}registerDebugAdapterDescriptorFactory(i,s,n){if(!n)return new R.$sK(()=>{});if(!this.Q(i,s))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${s}' debugger.`);if(this.N(s))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const r=this.g++;return this.h.push({type:s,handle:r,factory:n}),this.k.$registerDebugAdapterDescriptorFactory(s,r),new R.$sK(()=>{this.h=this.h.filter(o=>o.factory!==n),this.k.$unregisterDebugAdapterDescriptorFactory(r)})}registerDebugAdapterTrackerFactory(i,s){if(!s)return new R.$sK(()=>{});const n=this.i++;return this.j.push({type:i,handle:n,factory:s}),new R.$sK(()=>{this.j=this.j.filter(r=>r.factory!==s)})}async $runInTerminal(i,s){return Promise.resolve(void 0)}async $substituteVariables(i,s){let n;const r=await this.W(i);return r&&(n={uri:r.uri,name:r.name,index:r.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.I.getResolver()).resolveAnyAsync(n,s)}K(i,s){if(i.type==="implementation")return new f(i.implementation)}L(){}async $startDASession(i,s){const n=this,r=await this.V(s);return this.S(this.N(r.type),r).then(o=>{if(!o)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${r.type}' (extension might have failed to activate)`);const v=this.M(o),C=this.K(v,r);if(!C)throw new Error(`Couldn't create a debug adapter for type '${r.type}'.`);const w=C;return this.B.set(i,w),this.R(r).then(m=>(m&&this.C.set(i,m),w.onMessage(async b=>{if(b.type==="request"&&b.command==="handshake"){const I=b,z={type:"response",seq:0,command:I.command,request_seq:I.seq,success:!0};this.D||(this.D=this.L());try{if(this.D){const O=await this.D.sign(I.arguments.value);z.body={signature:O},w.sendResponse(z)}else throw new Error("no signer")}catch(O){z.success=!1,z.message=O.message,w.sendResponse(z)}}else m&&m.onDidSendMessage&&m.onDidSendMessage(b),b=(0,S.$FF)(b,!0),n.k.$acceptDAMessage(i,b)}),w.onError(b=>{m&&m.onError&&m.onError(b),this.k.$acceptDAError(i,b.name,b.message,b.stack)}),w.onExit(b=>{m&&m.onExit&&m.onExit(b??void 0,void 0),this.k.$acceptDAExit(i,b??void 0,void 0)}),m&&m.onWillStartSession&&m.onWillStartSession(),w.startSession()))})}$sendDAMessage(i,s){s=(0,S.$EF)(s,!1);const n=this.C.get(i);n&&n.onWillReceiveMessage&&n.onWillReceiveMessage(s),this.B.get(i)?.sendMessage(s)}$stopDASession(i){const s=this.C.get(i);this.C.delete(i),s&&s.onWillStopSession&&s.onWillStopSession();const n=this.B.get(i);return this.B.delete(i),n?n.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(i){const s=[],n=[],r=[];if(i.added)for(const o of i.added){const v=o.id;if(v&&!this.w.has(v)){let C;if(o.type==="function")C=new R.$sL(o.functionName,o.enabled,o.condition,o.hitCondition,o.logMessage);else if(o.type==="data")C=new R.$tL(o.label,o.dataId,o.canPersist,o.enabled,o.hitCondition,o.condition,o.logMessage);else{const w=l.URI.revive(o.uri);C=new R.$rL(new R.$EK(w,new R.$tK(o.line,o.character)),o.enabled,o.condition,o.hitCondition,o.logMessage)}(0,R.$pL)(C,v),this.w.set(v,C),s.push(C)}}if(i.removed)for(const o of i.removed){const v=this.w.get(o);v&&(this.w.delete(o),n.push(v))}if(i.changed){for(const o of i.changed)if(o.id){const v=this.w.get(o.id);if(v){if(v instanceof R.$sL&&o.type==="function"){const C=v;C.enabled=o.enabled,C.condition=o.condition,C.hitCondition=o.hitCondition,C.logMessage=o.logMessage,C.functionName=o.functionName}else if(v instanceof R.$rL&&o.type==="source"){const C=v;C.enabled=o.enabled,C.condition=o.condition,C.hitCondition=o.hitCondition,C.logMessage=o.logMessage,C.location=new R.$EK(l.URI.revive(o.uri),new R.$tK(o.line,o.character))}r.push(v)}}}this.U(s,n,r)}async $acceptStackFrameFocus(i){let s;const n=i.sessionId?await this.V(i.sessionId):void 0;if(!n)throw new Error("no DebugSession found for debug focus context");i.kind==="thread"?s=new R.$zL(n,i.threadId):s=new R.$yL(n,i.threadId,i.frameId),this.z=s,this.A.fire(this.z)}$provideDebugConfigurations(i,s,n){return(0,y.$Ng)(async()=>{const r=this.P(i);if(!r)throw new Error("no DebugConfigurationProvider found");if(!r.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const o=await this.W(s);return r.provideDebugConfigurations(o,n)}).then(r=>{if(!r)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return r})}$resolveDebugConfiguration(i,s,n,r){return(0,y.$Ng)(async()=>{const o=this.P(i);if(!o)throw new Error("no DebugConfigurationProvider found");if(!o.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const v=await this.W(s);return o.resolveDebugConfiguration(v,n,r)})}$resolveDebugConfigurationWithSubstitutedVariables(i,s,n,r){return(0,y.$Ng)(async()=>{const o=this.P(i);if(!o)throw new Error("no DebugConfigurationProvider found");if(!o.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const v=await this.W(s);return o.resolveDebugConfigurationWithSubstitutedVariables(v,n,r)})}async $provideDebugAdapter(i,s){const n=this.O(i);if(!n)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const r=await this.V(s);return this.S(n,r).then(o=>{if(!o)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${r.type}'`);return this.M(o)})}async $acceptDebugSessionStarted(i){const s=await this.V(i);this.m.fire(s)}async $acceptDebugSessionTerminated(i){const s=await this.V(i);s&&(this.n.fire(s),this.l.delete(s.id))}async $acceptDebugSessionActiveChanged(i){this.q=i?await this.V(i):void 0,this.o.fire(this.q)}async $acceptDebugSessionNameChanged(i,s){(await this.V(i))?._acceptNameChanged(s)}async $acceptDebugSessionCustomEvent(i,s){const r={session:await this.V(i),event:s.event,body:s.body};this.u.fire(r)}M(i){if(i instanceof R.$uL)return{type:"executable",command:i.command,args:i.args,options:i.options};if(i instanceof R.$vL)return{type:"server",port:i.port,host:i.host};if(i instanceof R.$wL)return{type:"pipeServer",path:i.path};if(i instanceof R.$xL)return{type:"implementation",implementation:i.implementation};throw new Error("convertToDto unexpected type")}N(i){const s=this.h.filter(n=>n.type===i);if(s.length>0)return s[0].factory}O(i){const s=this.h.filter(n=>n.handle===i);if(s.length>0)return s[0].factory}P(i){const s=this.f.filter(n=>n.handle===i);if(s.length>0)return s[0].provider}Q(i,s){if(i.contributes){const n=i.contributes.debuggers;if(n&&n.length>0){for(const r of n)if(r.label&&r.type&&r.type===s)return!0}}return!1}R(i){const n=i.configuration.type,r=this.j.filter(o=>o.type===n||o.type==="*").map(o=>(0,y.$Ng)(()=>o.factory.createDebugAdapterTracker(i)).then(v=>v,v=>null));return Promise.race([Promise.all(r).then(o=>{const v=o.filter(C=>!!C);if(v.length>0)return new c(v)}),new Promise(o=>setTimeout(()=>o(void 0),1e3))]).catch(o=>{})}async S(i,s){const n=s.configuration.debugServer;if(typeof n=="number")return Promise.resolve(new R.$vL(n));if(i){const o=await this.F.getExtensionRegistry();return(0,y.$Ng)(()=>i.createDebugAdapterDescriptor(s,this.T(s,o))).then(v=>{if(v)return v})}const r=await this.F.getExtensionRegistry();return Promise.resolve(this.T(s,r))}T(i,s){}U(i,s,n){(i.length>0||s.length>0||n.length>0)&&this.y.fire(Object.freeze({added:i,removed:s,changed:n}))}async V(i){if(i)if(typeof i=="string"){const s=this.l.get(i);if(s)return s}else{let s=this.l.get(i.id);if(!s){const n=await this.W(i.folderUri),r=i.parent?this.l.get(i.parent):void 0;s=new u(this.k,i.id,i.type,i.name,n,i.configuration,r),this.l.set(s.id,s),this.k.$sessionCached(s.id)}return s}throw new Error("cannot find session")}W(i){if(i){const s=l.URI.revive(i);return this.E.resolveWorkspaceFolder(s)}return Promise.resolve(void 0)}};e.$Zdc=h,e.$Zdc=h=He([We(0,$.$rM),We(1,P.$Scc),We(2,k.$odc),We(3,D.$Vcc),We(4,g.$Udc),We(5,E.$Wdc)],h);class u{constructor(i,s,n,r,o,v,C){this.d=i,this.f=s,this.g=n,this.h=r,this.i=o,this.j=v,this.k=C}get id(){return this.f}get type(){return this.g}get name(){return this.h}set name(i){this.h=i,this.d.$setDebugSessionName(this.f,i)}get parentSession(){return this.k}_acceptNameChanged(i){this.h=i}get workspaceFolder(){return this.i}get configuration(){return this.j}customRequest(i,s){return this.d.$customDebugAdapterRequest(this.f,i,s)}getDebugProtocolBreakpoint(i){return this.d.$getDebugProtocolBreakpoint(this.f,i.id)}}e.$1dc=u;class d{constructor(i){this.value=Object.freeze({append(s){i.$appendDebugConsole(s)},appendLine(s){this.append(s+`
`)}})}}e.$2dc=d;class c{constructor(i){this.d=i}onWillStartSession(){this.d.forEach(i=>i.onWillStartSession?i.onWillStartSession():void 0)}onWillReceiveMessage(i){this.d.forEach(s=>s.onWillReceiveMessage?s.onWillReceiveMessage(i):void 0)}onDidSendMessage(i){this.d.forEach(s=>s.onDidSendMessage?s.onDidSendMessage(i):void 0)}onWillStopSession(){this.d.forEach(i=>i.onWillStopSession?i.onWillStopSession():void 0)}onError(i){this.d.forEach(s=>s.onError?s.onError(i):void 0)}onExit(i,s){this.d.forEach(n=>n.onExit?n.onExit(i,s):void 0)}}class f extends p.$ldb{constructor(i){super(),this.h=i,i.onDidSendMessage(s=>{this.acceptMessage(s)})}startSession(){return Promise.resolve(void 0)}sendMessage(i){this.h.handleMessage(i)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let a=class extends h{constructor(i,s,n,r,o,v){super(i,s,n,r,o,v)}};e.$3dc=a,e.$3dc=a=He([We(0,$.$rM),We(1,P.$Scc),We(2,k.$odc),We(3,D.$Vcc),We(4,g.$Udc),We(5,E.$Wdc)],a)}),define(De[353],Ce([1,0,9,54,2,6,344,14,103,104,27,239,20,67,46,88]),function(re,e,y,M,l,L,A,g,k,$,R,P,p,S,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qec=e.$Pec=void 0;class h{static async installEarlyHandler(c){Error.stackTraceLimit=100;const f=c.get(g.$$i),t=c.get(p.$rM).getProxy(L.$qK.MainThreadErrors);y.setUnexpectedErrorHandler(i=>{f.error(i);const s=y.$3(i);t.$onUnexpectedError(s)})}static async installFullHandler(c){const f=c.get(g.$$i),a=c.get(p.$rM),t=c.get(D.$odc),i=c.get(E.$LM),s=a.getProxy(L.$qK.MainThreadExtensionService),n=a.getProxy(L.$qK.MainThreadErrors),r=await t.getExtensionPathIndex(),o=new WeakMap;function v(m,b){if(o.has(m))return o.get(m).stack;let I="",z,O;for(const T of b)I+=`
	at ${T.toString()}`,O=T.getFileName(),!z&&O&&(z=r.findSubstr(l.URI.file(O)));const F=`${m.name||"Error"}: ${m.message||""}${I}`;return o.set(m,{extensionIdentifier:z?.identifier,stack:F}),F}const C=Symbol("prepareStackTrace wrapped");let w=v;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return w},set(m){if(m===v||!m||m[C]){w=m||v;return}w=function(b,I){return v(b,I),m.call(Error,b,I)},Object.assign(w,{[C]:!0})}}),y.setUnexpectedErrorHandler(m=>{f.error(m);const b=y.$3(m),I=o.get(m);if(!I?.extensionIdentifier){n.$onUnexpectedError(b);return}s.$onExtensionRuntimeError(I.extensionIdentifier,b);const z=i.onExtensionError(I.extensionIdentifier,m);f.trace("forwarded error to extension?",z,I)})}}e.$Pec=h;class u{constructor(c,f,a,t,i){this.a=a,this.b=new A.$54b(c,null,t),f=u.e(f,this.b);const s=new $.$Oh(...(0,k.$Cr)());s.set(R.$HM,{_serviceBrand:void 0,...f,messagePorts:i}),s.set(p.$rM,new p.$sM(this.b)),s.set(S.$Pcc,new S.$Qcc(t)),s.set(D.$mdc,a);const n=new P.$iq(s,!0);n.invokeFunction(h.installEarlyHandler),this.d=n.invokeFunction(r=>r.get(g.$$i)),M.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",f),this.c=n.invokeFunction(r=>r.get(D.$odc)),this.c.initialize(),n.invokeFunction(h.installFullHandler)}async asBrowserUri(c){const f=this.b.getProxy(L.$qK.MainThreadExtensionService);return l.URI.revive(await f.$asBrowserUri(c))}terminate(c){this.c.terminate(c)}static e(c,f){c.extensions.allExtensions.forEach(t=>{t.extensionLocation=l.URI.revive(f.transformIncomingURIs(t.extensionLocation))}),c.environment.appRoot=l.URI.revive(f.transformIncomingURIs(c.environment.appRoot));const a=c.environment.extensionDevelopmentLocationURI;return a&&(c.environment.extensionDevelopmentLocationURI=a.map(t=>l.URI.revive(f.transformIncomingURIs(t)))),c.environment.extensionTestsLocationURI=l.URI.revive(f.transformIncomingURIs(c.environment.extensionTestsLocationURI)),c.environment.globalStorageHome=l.URI.revive(f.transformIncomingURIs(c.environment.globalStorageHome)),c.environment.workspaceStorageHome=l.URI.revive(f.transformIncomingURIs(c.environment.workspaceStorageHome)),c.environment.extensionTelemetryLogResource=l.URI.revive(f.transformIncomingURIs(c.environment.extensionTelemetryLogResource)),c.nlsBaseUrl=l.URI.revive(f.transformIncomingURIs(c.nlsBaseUrl)),c.logsLocation=l.URI.revive(f.transformIncomingURIs(c.logsLocation)),c.workspace=f.transformIncomingURIs(c.workspace),c}}e.$Qec=u}),define(De[354],Ce([1,0,8,12,216,233,139,94,71,46,20,45,7,56,38,273,274,40]),function(re,e,y,M,l,L,A,g,k,$,R,P,p,S,D,E,h,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1ec=void 0;let d=class extends g.$Zdc{constructor(i,s,n,r,o,v,C){super(i,s,n,r,v,C),this.Z=o,this.X=new a}K(i,s){switch(i.type){case"server":return new E.$Vec(i);case"pipeServer":return new E.$Wec(i);case"executable":return new E.$Xec(i,s.type)}return super.K(i,s)}T(i,s){const n=E.$Xec.platformAdapterExecutable(s.getAllExtensionDescriptions(),i.type);if(n)return new p.$uL(n.command,n.args,n.options)}L(){return new A.$N8b}async $runInTerminal(i,s){if(i.kind==="integrated"){this.Y||(this.Y=this.Z.onDidCloseTerminal(F=>{this.X.onTerminalClosed(F)}));const n=await this.G.getConfigProvider(),r=this.Z.getDefaultShell(!0),o=this.Z.getDefaultShellArgs(!0),v=i.title||l.localize(0,null),C=JSON.stringify({shell:r,shellArgs:o});let w=await this.X.checkout(C,v),m,b=!1;if(w)m=i.cwd;else{const F={shellPath:r,shellArgs:o,cwd:i.cwd,name:v,iconPath:new p.$mL("debug")};b=!0,w=this.Z.createTerminalFromOptions(F,{isFeatureTerminal:!0,useShellEnvironment:!0}),this.X.insert(w,C)}w.show(!0);const I=await w.processId;b?await new Promise(F=>setTimeout(F,1e3)):n.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(r.indexOf("powershell")>=0||r.indexOf("pwsh")>=0||r.indexOf("cmd.exe")>=0?w.sendText("cls"):r.indexOf("bash")>=0?w.sendText("clear"):M.$d?w.sendText("cls"):w.sendText("clear"));const z=(0,h.$Zec)(r,i.args,!!i.argsCanBeInterpretedByShell,m,i.env);w.sendText(z);const O=this.onDidTerminateDebugSession(F=>{F.id===s&&(this.X.free(w),O.dispose())});return I}else if(i.kind==="external")return f(i,await this.G.getConfigProvider());return super.$runInTerminal(i,s)}};e.$1ec=d,e.$1ec=d=He([We(0,R.$rM),We(1,D.$Scc),We(2,$.$odc),We(3,u.$Vcc),We(4,P.$bdc),We(5,k.$Udc),We(6,S.$Wdc)],d);let c;function f(t,i){if(!c)if(M.$d)c=new L.$z7b;else if(M.$e)c=new L.$A7b;else if(M.$f)c=new L.$B7b;else throw new Error("external terminals not supported on this platform");const s=i.getConfiguration("terminal");return c.runInTerminal(t.title,t.cwd,t.args,t.env||{},s.external||{})}class a{constructor(){this.b=new Map}async checkout(i,s){const r=[...this.b.entries()].map(([o,v])=>(0,y.$Ig)(async C=>{if(o.name!==s||v.lastUsedAt!==-1&&await(0,h.$Yec)(await o.processId))return null;const w=Date.now();return v.lastUsedAt+a.a>w||C.isCancellationRequested||v.config!==i?null:(v.lastUsedAt=w,o)}));return await(0,y.$Zg)(r,o=>!!o)}insert(i,s){this.b.set(i,{lastUsedAt:Date.now(),config:s})}free(i){const s=this.b.get(i);s&&(s.lastUsedAt=-1)}onTerminalClosed(i){this.b.delete(i)}}a.a=1e3}),define(De[355],Ce([1,0,15,2,101,38,70,40,44,45,20,27,93,18,14,89,23,61,56]),function(re,e,y,M,l,L,A,g,k,$,R,P,p,S,D,E,h,u,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sec=void 0;let c=class extends p.$Rdc{constructor(a,t,i,s,n,r,o,v,C){super(a,t,i,s,n,r,o,v),this.B=i,this.C=C,t.remote.isRemote&&t.remote.authority?this.registerTaskSystem(S.Schemas.vscodeRemote,{scheme:S.Schemas.vscodeRemote,authority:t.remote.authority,platform:process.platform}):this.registerTaskSystem(S.Schemas.file,{scheme:S.Schemas.file,authority:"",platform:process.platform}),this.a.$registerSupportedExecutions(!0,!0,!0)}async executeTask(a,t){const i=t;if(!t.execution&&i._id===void 0)throw new Error("Tasks to execute must include an execution");if(i._id!==void 0){const s=p.TaskHandleDTO.from(i,this.B),n=await this.a.$getTaskExecution(s);if(n.task===void 0)throw new Error("Task from execution DTO is undefined");const r=await this.y(n,t);return this.a.$executeTask(s).catch(()=>{}),r}else{const s=p.TaskDTO.from(t,a);if(s===void 0)return Promise.reject(new Error("Task is not valid"));p.CustomExecutionDTO.is(s.execution)&&await this.x(s,t,!1);const n=await this.y(await this.a.$getTaskExecution(s),t);return this.a.$executeTask(s).catch(()=>{}),n}}u(a,t,i,s){const n=[];if(s)for(const r of s){this.z(r,i),(!r.definition||!a[r.definition.type])&&this.f.warn(`The task [${r.source}, ${r.name}] uses an undefined task type. The task will be ignored in the future.`);const o=p.TaskDTO.from(r,i.extension);o&&(n.push(o),p.CustomExecutionDTO.is(o.execution)&&t.push(this.x(o,r,!0)))}return{tasks:n,extension:i.extension}}async v(a){return a}async F(a){let t=a&&a.length>0?a[0]:void 0;if(!t){const i=M.URI.file((0,u.homedir)());t=new k.$$h({uri:i,name:h.$tg(i),index:0})}return{uri:t.uri,name:t.name,index:t.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(a,t){const i=M.URI.revive(a),s={process:void 0,variables:Object.create(null)},n=await this.b.resolveWorkspaceFolder(i),r=await this.b.getWorkspaceFolders2()??[],o=await this.C.getResolver(),v=n?{uri:n.uri,name:n.name,index:n.index,toResource:()=>{throw new Error("Not implemented")}}:await this.F(r);for(const C of t.variables)s.variables[C]=await o.resolveAsync(v,C);if(t.process!==void 0){let C;if(t.process.path!==void 0){C=t.process.path.split(y.$tc);for(let w=0;w<C.length;w++)C[w]=await o.resolveAsync(v,C[w])}s.process=await l.win32.findExecutable(await o.resolveAsync(v,t.process.name),t.process.cwd!==void 0?await o.resolveAsync(v,t.process.cwd):void 0,C)}return s}async $jsonTasksSupported(){return!0}async $findExecutable(a,t,i){return l.win32.findExecutable(a,t,i)}};e.$Sec=c,e.$Sec=c=He([We(0,R.$rM),We(1,P.$HM),We(2,L.$Scc),We(3,A.$CM),We(4,g.$Vcc),We(5,$.$bdc),We(6,D.$$i),We(7,E.$Icc),We(8,d.$Wdc)],c)}),define(De[356],Ce([1,0,61,56]),function(re,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yfc=void 0;class l extends M.$Xdc{m(){return(0,y.homedir)()}}e.$yfc=l}),define(De[154],Ce([1,0,19,8,21,41,18,15,23,2,37]),function(re,e,y,M,l,L,A,g,k,$,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8dc=e.$7dc=e.$6dc=e.$5dc=void 0;class P{constructor(d,c,f,a){this.d=d,this.e=c,this.f=f,this.g=a,this.a=null,this.b=!1,this.c=0}search(d,c){const f=this.d.folderQueries||[],a=new l.$Yd(c);return new Promise((t,i)=>{this.a=new S(d);let s=!1;const n=(r,o)=>{if(!s&&!this.b){const v=this.h(r);E(r)&&typeof this.d.maxResults=="number"&&this.c+v>this.d.maxResults&&(this.b=!0,s=!0,a.cancel(),r=this.j(r,this.d.maxResults-this.c));const C=this.h(r);this.c+=C,(C>0||!E(r))&&this.a.add(r,o)}};Promise.all(f.map((r,o)=>this.k(r,v=>n(v,o),a.token))).then(r=>{a.dispose(),this.a.flush();const o=r.some(v=>!!v&&!!v.limitHit);t({limitHit:this.b||o,messages:(0,y.$Rb)(r.map(v=>v?.message?Array.isArray(v.message)?v.message:[v.message]:[])),stats:{type:this.g}})},r=>{a.dispose();const o=(0,L.$Bi)(r);i(new Error(o))})})}h(d){return E(d)?Array.isArray(d.ranges)?d.ranges.length:1:0}j(d,c){const f=Array.isArray(d.ranges)?d.ranges:[d.ranges],a=Array.isArray(d.preview.matches)?d.preview.matches:[d.preview.matches];return{ranges:f.slice(0,c),preview:{matches:a.slice(0,c),text:d.preview.text},uri:d.uri}}async k(d,c,f){const a=new R.$$I(this.d,d),t=[],i={report:r=>{if(!this.l(r))return;const o=d.folder.scheme===A.Schemas.file?(0,R.$_I)(()=>this.f.readdir(k.$vg(r.uri))):void 0,v=k.$yg(d.folder,r.uri);if(v){const C=a.includedInQuery(v,g.$nc(v),o);(0,M.$Hg)(C)?t.push(C.then(w=>{w&&c(r)})):C&&c(r)}}},s=this.n(d),n=await this.e.provideTextSearchResults(p(this.d.contentPattern),s,i,f);return t.length&&await Promise.all(t),n}l(d){if(E(d)){if(Array.isArray(d.ranges)){if(!Array.isArray(d.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(d.preview.matches.length!==d.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(d.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(d){const c=(0,R.$0I)(this.d.includePattern,d.includePattern),f=(0,R.$0I)(this.d.excludePattern,d.excludePattern),a={folder:$.URI.from(d.folder),excludes:f,includes:c,useIgnoreFiles:!d.disregardIgnoreFiles,useGlobalIgnoreFiles:!d.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!d.disregardParentIgnoreFiles,followSymlinks:!d.ignoreSymlinks,encoding:d.fileEncoding&&this.f.toCanonicalName(d.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return a.usePCRE2=this.d.usePCRE2,a}}e.$5dc=P;function p(u){return{isCaseSensitive:u.isCaseSensitive||!1,isRegExp:u.isRegExp||!1,isWordMatch:u.isWordMatch||!1,isMultiline:u.isMultiline||!1,pattern:u.pattern}}class S{constructor(d){this.e=d,this.b=-1,this.d=null,this.a=new h(512,c=>this.g(c))}add(d,c){this.d&&(this.b!==c||!k.$pg(this.c,d.uri))&&(this.f(),this.d=null),this.d||(this.b=c,this.d={resource:d.uri,results:[]}),this.d.results.push(D(d))}f(){const d=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,d)}flush(){this.f(),this.a.flush()}g(d){this.e(d)}}e.$6dc=S;function D(u){return E(u)?{preview:{matches:(0,y.$2b)(u.preview.matches,d=>({startLineNumber:d.start.line,startColumn:d.start.character,endLineNumber:d.end.line,endColumn:d.end.character})),text:u.preview.text},ranges:(0,y.$2b)(u.ranges,d=>({startLineNumber:d.start.line,startColumn:d.start.character,endLineNumber:d.end.line,endColumn:d.end.character}))}:{text:u.text,lineNumber:u.lineNumber}}function E(u){return!!u.preview}e.$7dc=E;class h{constructor(d,c){this.g=d,this.h=c,this.c=0,this.d=[],this.e=0}addItem(d,c){d&&this.j(d,c)}addItems(d,c){d&&this.k(d,c)}j(d,c){this.d.push(d),this.e+=c,this.l()}k(d,c){this.d=this.d.concat(d),this.e+=c,this.l()}l(){this.c<h.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},h.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$8dc=h,h.a=4e3,h.b=50}),define(De[95],Ce([1,0,3,6,5,349,20,67,14,2,154]),function(re,e,y,M,l,L,A,g,k,$,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$dc=e.$0dc=e.$9dc=void 0,e.$9dc=(0,l.$Qh)("IExtHostSearch");let P=class{constructor(E,h,u){this.k=E,this.l=h,this.n=u,this.c=this.k.getProxy(M.$qK.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new L.$4dc}o(E){return this.l.transformOutgoingScheme(E)}registerTextSearchProvider(E,h){if(this.g.has(E))throw new Error(`a text search provider for the scheme '${E}' is already registered`);this.g.add(E);const u=this.d++;return this.e.set(u,h),this.c.$registerTextSearchProvider(u,this.o(E)),(0,y.$Qc)(()=>{this.g.delete(E),this.e.delete(u),this.c.$unregisterProvider(u)})}registerFileSearchProvider(E,h){if(this.i.has(E))throw new Error(`a file search provider for the scheme '${E}' is already registered`);this.i.add(E);const u=this.d++;return this.h.set(u,h),this.c.$registerFileSearchProvider(u,this.o(E)),(0,y.$Qc)(()=>{this.i.delete(E),this.h.delete(u),this.c.$unregisterProvider(u)})}$provideFileSearchResults(E,h,u,d){const c=p(u),f=this.h.get(E);if(f)return this.j.fileSearch(c,f,a=>{this.c.$handleFileMatch(E,h,a.map(t=>t.resource))},d);throw new Error("unknown provider: "+E)}$clearCache(E){return this.j.clearCache(E),Promise.resolve(void 0)}$provideTextSearchResults(E,h,u,d){const c=this.e.get(E);if(!c||!c.provideTextSearchResults)throw new Error(`Unknown provider ${E}`);const f=p(u);return this.q(f,c).search(t=>this.c.$handleTextMatch(E,h,t),d)}$enableExtensionHostSearch(){}q(E,h){return new R.$5dc(E,h,{readdir:u=>Promise.resolve([]),toCanonicalName:u=>u},"textSearchProvider")}};e.$0dc=P,e.$0dc=P=He([We(0,A.$rM),We(1,g.$Pcc),We(2,k.$$i)],P);function p(D){return{...D,folderQueries:D.folderQueries&&D.folderQueries.map(S),extraFileResources:D.extraFileResources&&D.extraFileResources.map(E=>$.URI.revive(E))}}e.$$dc=p;function S(D){return{...D,folder:$.URI.revive(D.folder)}}}),define(De[357],Ce([1,0,21,9,4,39,2,131,129,174,173,30,6,112,303,302,34,304,40,306,307,308,283,309,70,46,311,312,317,318,319,153,287,325,326,329,116,45,331,288,13,7,85,334,91,152,38,25,277,316,66,150,93,94,95,14,67,20,27,320,275,73,89,295,332,90,72,337,335,336,296,55,330,333,115,71,88,321,92,322,18,135,286,264,314,3,26,271,113,258,323,324,297,313,285,315,114,327,300,328,301,294,310,298,299]),function(re,e,y,M,l,L,A,g,k,$,R,P,p,S,D,E,h,u,d,c,f,a,t,i,s,n,r,o,v,C,w,m,b,I,z,O,F,T,N,j,U,B,he,x,Q,Z,ie,_,oe,ye,fe,V,le,H,G,Y,X,be,se,ge,te,me,we,Ie,W,J,ce,de,ee,$e,ve,Ne,qe,xe,Ge,st,it,nt,Ae,Oe,Re,Qe,ue,ae,Pe,Ke,Ue,Ze,rt,ht,pt,Dt,qt,Vt,Et,Tt,Ot,_t,Yt,Pt,Nt,Jt,jt,Kt,Ht){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kec=void 0;function It(ut){const ft=ut.get(se.$HM),At=ut.get(Ne.$Fcc),Ft=ut.get(ce.$$cc),Mt=ut.get(n.$odc),lt=ut.get(ie.$Scc),kt=ut.get(it.$LM),zt=ut.get(d.$Vcc),Ut=ut.get(X.$Pcc),Je=ut.get(be.$rM),Qt=ut.get(F.$7cc),Me=ut.get(J.$_cc),Te=ut.get(Y.$_i),Se=ut.get(Y.$$i),ne=ut.get(me.$uwb),Fe=ut.get(we.$Icc),Ve=ut.get(Z.$Mdc),_e=ut.get(Ge.$gdc),Ye=ut.get(st.$Udc),ot=ut.get(Ot.$kdc);Je.set(p.$rK.ExtHostFileSystemInfo,At),Je.set(p.$rK.ExtHostLogLevelServiceShape,Te),Je.set(p.$rK.ExtHostWorkspace,lt),Je.set(p.$rK.ExtHostConfiguration,zt),Je.set(p.$rK.ExtHostExtensionService,Mt),Je.set(p.$rK.ExtHostStorage,Qt),Je.set(p.$rK.ExtHostTunnelService,ne),Je.set(p.$rK.ExtHostWindow,Ve),Je.set(p.$rK.ExtHostSecretState,_e),Je.set(p.$rK.ExtHostTelemetry,kt),Je.set(p.$rK.ExtHostEditorTabs,Ye),Je.set(p.$rK.ExtHostManagedSockets,ot);const Ct=Je.set(p.$rK.ExtHostDecorations,ut.get(V.$Qdc)),yt=Je.set(p.$rK.ExtHostDocumentsAndEditors,ut.get(s.$CM)),bt=Je.set(p.$rK.ExtHostCommands,ut.get(h.$NM)),gt=Je.set(p.$rK.ExtHostTerminalService,ut.get(T.$bdc)),$t=Je.set(p.$rK.ExtHostDebugService,ut.get(H.$Ydc)),ci=Je.set(p.$rK.ExtHostSearch,ut.get(G.$9dc)),Gt=Je.set(p.$rK.ExtHostTask,ut.get(le.$Tdc)),pi=Je.set(p.$rK.ExtHostOutputService,ut.get(m.$wdc)),di=Je.set(p.$rK.ExtHostLocalization,ut.get(rt.$jdc)),Qi=Je.set(p.$rK.ExtHostUrls,new x.$Fdc(Je)),Rt=Je.set(p.$rK.ExtHostDocuments,new i.$Dcc(Je,yt)),Ii=Je.set(p.$rK.ExtHostDocumentContentProviders,new a.$Xcc(Je,yt,Se)),Ai=Je.set(p.$rK.ExtHostDocumentSaveParticipant,new t.$Ycc(Se,Rt,Je.getProxy(p.$qK.MainThreadBulkEdits))),St=Je.set(p.$rK.ExtHostNotebook,new ge.$cec(Je,bt,yt,Rt,Ft)),Xt=Je.set(p.$rK.ExtHostNotebookDocuments,new ae.$uec(St)),vi=Je.set(p.$rK.ExtHostNotebookEditors,new ue.$tec(Se,St)),fi=Je.set(p.$rK.ExtHostNotebookKernels,new nt.$qec(Je,ft,St,bt,Se)),Ri=Je.set(p.$rK.ExtHostNotebookRenderers,new Oe.$sec(Je,St)),Yi=Je.set(p.$rK.ExtHostNotebookDocumentSaveParticipant,new Et.$Aec(Se,St,Je.getProxy(p.$qK.MainThreadBulkEdits))),Bt=Je.set(p.$rK.ExtHostEditors,new N.$Ddc(Je,yt)),ri=Je.set(p.$rK.ExtHostTreeViews,new j.$Edc(Je.getProxy(p.$qK.MainThreadTreeViews),bt,Se)),Li=Je.set(p.$rK.ExtHostEditorInsets,new oe.$Ndc(Je.getProxy(p.$qK.MainThreadEditorInsets),Bt,ft.remote)),ui=Je.set(p.$rK.ExtHostDiagnostics,new c.$Hcc(Je,Se,At,yt)),li=Je.set(p.$rK.ExtHostLanguages,new C.$tdc(Je,Rt,bt.converter,Ut)),dt=Je.set(p.$rK.ExtHostLanguageFeatures,new v.$Lcc(Je,Ut,Rt,bt,ui,Se,Fe,kt)),Mi=Je.set(p.$rK.ExtHostFileSystem,new r.$rdc(Je,dt)),ei=Je.set(p.$rK.ExtHostFileSystemEventService,new o.$sdc(Je,Se,yt)),si=Je.set(p.$rK.ExtHostQuickOpen,(0,I.$ydc)(Je,lt,bt)),yi=Je.set(p.$rK.ExtHostSCM,new z.$Adc(Je,bt,Rt,Se)),Fi=Je.set(p.$rK.ExtHostQuickDiff,new Dt.$xec(Je,Ut)),Ti=Je.set(p.$rK.ExtHostShare,new _t.$Cec(Je,Ut)),Xi=Je.set(p.$rK.ExtHostComments,(0,u.$Occ)(Je,bt,Rt)),Ei=Je.set(p.$rK.ExtHostProgress,new b.$xdc(Je.getProxy(p.$qK.MainThreadProgress))),Oi=Je.set(p.$rK.ExtHosLabelService,new ye.$Odc(Je)),ki=Je.set(p.$rK.ExtHostTheming,new te.$dec(Je)),oi=Je.set(p.$rK.ExtHostAuthentication,new Ie.$eec(Je)),Zi=Je.set(p.$rK.ExtHostTimeline,new W.$gec(Je,bt)),mi=Je.set(p.$rK.ExtHostWebviews,new Q.$Idc(Je,ft.remote,lt,Se,Fe)),gi=Je.set(p.$rK.ExtHostWebviewPanels,new $e.$iec(Je,mi,lt)),xi=Je.set(p.$rK.ExtHostCustomEditors,new ee.$jec(Je,Rt,Me,mi,gi)),_i=Je.set(p.$rK.ExtHostWebviewViews,new de.$hec(Je,mi)),hi=Je.set(p.$rK.ExtHostTesting,new qe.$lec(Je,bt,yt)),en=Je.set(p.$rK.ExtHostUriOpeners,new xe.$pec(Je)),tn=Je.set(p.$rK.ExtHostProfileContentHandlers,new pt.$wec(Je));Je.set(p.$rK.ExtHostInteractive,new Pe.$vec(Je,St,yt,bt,Se));const fn=Je.set(p.$rK.ExtHostInlineChat,new Vt.$zec(Je,bt,Rt,Se)),Si=Je.set(p.$rK.ExtHostChatProvider,new Yt.$Dec(Je,Se)),Ni=Je.set(p.$rK.ExtHostChatAgents,new Kt.$Iec(Je,Si,Se)),ji=Je.set(p.$rK.ExtHostChatAgents2,new Ht.$Jec(Je,Si,Se)),mn=Je.set(p.$rK.ExtHostChatVariables,new Nt.$Fec(Je)),Di=Je.set(p.$rK.ExtHostChat,new qt.$yec(Je,Se)),zi=Je.set(p.$rK.ExtHostAiRelatedInformation,new Jt.$Gec(Je)),Ci=Je.set(p.$rK.ExtHostAiEmbeddingVector,new jt.$Hec(Je)),Ui=Je.set(p.$rK.ExtHostIssueReporter,new Tt.$Bec(Je)),Bi=Je.set(p.$rK.ExtHostStatusBar,new O.$Cdc(Je,bt.converter)),nn=Je.set(p.$rK.ExtHostSpeech,new Pt.$Eec(Je)),gn=Object.values(p.$rK);Je.assertRegistered(gn);const Wi=new ve.$kec(Je,yt),rn=new E.$Ncc(Je),Zt=new w.$udc(Je,Se),$i=new f.$Wcc(Je);return D.$Mcc.register(bt),function(ze,ti,bi){const wt=function(){let pe=!ze.isUnderDevelopment;function ke(){pe||(Se.info(`Extension '${ze.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),pe=!0)}return function je(at){if(Array.isArray(at))at.forEach(je);else if(typeof at=="string")ke();else{const vt=at;typeof vt.scheme>"u"&&ke(),typeof vt.exclusive=="boolean"&&(0,Ue.$mF)(ze,"documentFiltersExclusive")}return at}}(),sn={getSession(pe,ke,je){return oi.getSession(ze,pe,ke,je)},getSessions(pe,ke){return(0,Ue.$mF)(ze,"authGetSessions"),oi.getSessions(ze,pe,ke)},async hasSession(pe,ke){return(0,Ue.$mF)(ze,"authSession"),!!await oi.getSession(ze,pe,ke,{silent:!0})},get onDidChangeSessions(){return oi.onDidChangeSessions},registerAuthenticationProvider(pe,ke,je,at){return oi.registerAuthenticationProvider(pe,ke,je,at)}},on={registerCommand(pe,ke,je){return bt.registerCommand(!0,pe,ke,je,void 0,ze)},registerTextEditorCommand(pe,ke,je){return bt.registerCommand(!0,pe,(...at)=>{const vt=Bt.getActiveTextEditor();if(!vt){Se.warn("Cannot execute "+pe+" because there is no active text editor.");return}return vt.edit(Lt=>{ke.apply(je,[vt,Lt,...at])}).then(Lt=>{Lt||Se.warn("Edits from command "+pe+" were not applied.")},Lt=>{Se.warn("An error occurred while running command "+pe,Lt)})},void 0,void 0,ze)},registerDiffInformationCommand:(pe,ke,je)=>((0,Ue.$mF)(ze,"diffCommand"),bt.registerCommand(!0,pe,async(...at)=>{const vt=yt.activeEditor(!0);if(!vt){Se.warn("Cannot execute "+pe+" because there is no active text editor.");return}const Lt=await Bt.getDiffInformation(vt.id);ke.apply(je,[Lt,...at])},void 0,void 0,ze)),executeCommand(pe,...ke){return bt.executeCommand(pe,...ke)},getCommands(pe=!1){return bt.getCommands(pe)}},qi={get machineId(){return ft.telemetryInfo.machineId},get sessionId(){return ft.telemetryInfo.sessionId},get language(){return ft.environment.appLanguage},get appName(){return ft.environment.appName},get appRoot(){return ft.environment.appRoot?.fsPath??""},get appHost(){return ft.environment.appHost},get uriScheme(){return ft.environment.appUriScheme},get clipboard(){return rn.value},get shell(){return gt.getDefaultShell(!1)},get onDidChangeShell(){return gt.onDidChangeShell},get isTelemetryEnabled(){return kt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return kt.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,Ue.$mF)(ze,"telemetry"),kt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Ue.$mF)(ze,"telemetry"),kt.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,it.$KM)(ft.telemetryInfo.firstSessionDate)},createTelemetryLogger(pe,ke){return it.$JM.validateSender(pe),kt.instantiateLogger(ze,pe,ke)},openExternal(pe,ke){return Ve.openUri(pe,{allowTunneling:!!ft.remote.authority,allowContributedOpeners:ke?.allowContributedOpeners})},async asExternalUri(pe){if(pe.scheme===ft.environment.appUriScheme)return Qi.createAppUri(pe);try{return await Ve.asExternalUri(pe,{allowTunneling:!!ft.remote.authority})}catch(ke){if((0,Qe.$wU)(pe,Re.Schemas.http)||(0,Qe.$wU)(pe,Re.Schemas.https))return pe;throw ke}},get remoteName(){return(0,fe.$Wk)(ft.remote.authority)},get remoteAuthority(){return(0,Ue.$mF)(ze,"resolvers"),ft.remote.authority},get uiKind(){return ft.uiKind},get logLevel(){return Se.getLevel()},get onDidChangeLogLevel(){return Se.onDidChangeLogLevel},registerIssueUriRequestHandler(pe){return(0,Ue.$mF)(ze,"handleIssueUri"),Ui.registerIssueUriRequestHandler(ze,pe)},registerIssueDataProvider(pe){return(0,Ue.$mF)(ze,"handleIssueUri"),Ui.registerIssueDataProvider(ze,pe)},get appQuality(){return(0,Ue.$mF)(ze,"resolvers"),ft.quality},get appCommit(){return(0,Ue.$mF)(ze,"resolvers"),ft.commit}};ft.environment.extensionTestsLocationURI||Object.freeze(qi);const $n={createTestController(pe,ke,je){return hi.createTestController(ze,pe,ke,je)},createTestObserver(){return(0,Ue.$mF)(ze,"testObserver"),hi.createTestObserver()},runTests(pe){return(0,Ue.$mF)(ze,"testObserver"),hi.runTests(pe)},get onDidChangeTestResults(){return(0,Ue.$mF)(ze,"testObserver"),hi.onResultsChanged},get testResults(){return(0,Ue.$mF)(ze,"testObserver"),hi.results}},wi=ft.remote.isRemote?B.ExtensionKind.Workspace:B.ExtensionKind.UI,an={getExtension(pe,ke){(0,Ue.$lF)(ze,"extensionsAny")||(ke=!1);const je=ti.mine.getExtensionDescription(pe);if(je)return new n.$pdc(Mt,ze.identifier,je,wi,!1);if(ke){const at=ti.all.getExtensionDescription(pe);if(at)return new n.$pdc(Mt,ze.identifier,at,wi,!0)}},get all(){const pe=[];for(const ke of ti.mine.getAllExtensionDescriptions())pe.push(new n.$pdc(Mt,ze.identifier,ke,wi,!1));return pe},get allAcrossExtensionHosts(){(0,Ue.$mF)(ze,"extensionsAny");const pe=new _.$9l(ti.mine.getAllExtensionDescriptions().map(je=>je.identifier)),ke=[];for(const je of ti.all.getAllExtensionDescriptions()){const at=!pe.has(je.identifier);ke.push(new n.$pdc(Mt,ze.identifier,je,wi,at))}return ke},get onDidChange(){return(0,Ue.$lF)(ze,"extensionsAny")?l.Event.any(ti.mine.onDidChange,ti.all.onDidChange):ti.mine.onDidChange}},bn={createDiagnosticCollection(pe){return ui.createDiagnosticCollection(ze.identifier,pe)},get onDidChangeDiagnostics(){return ui.onDidChangeDiagnostics},getDiagnostics:pe=>ui.getDiagnostics(pe),getLanguages(){return li.getLanguages()},setTextDocumentLanguage(pe,ke){return li.changeLanguage(pe.uri,ke)},match(pe,ke){const je=Rt.getDocumentData(ke.uri)?.notebook;return(0,R.$yE)(U.LanguageSelector.from(pe),ke.uri,ke.languageId,!0,je?.uri,je?.notebookType)},registerCodeActionsProvider(pe,ke,je){return dt.registerCodeActionProvider(ze,wt(pe),ke,je)},registerDocumentPasteEditProvider(pe,ke,je){return(0,Ue.$mF)(ze,"documentPaste"),dt.registerDocumentPasteEditProvider(ze,wt(pe),ke,je)},registerCodeLensProvider(pe,ke){return dt.registerCodeLensProvider(ze,wt(pe),ke)},registerDefinitionProvider(pe,ke){return dt.registerDefinitionProvider(ze,wt(pe),ke)},registerDeclarationProvider(pe,ke){return dt.registerDeclarationProvider(ze,wt(pe),ke)},registerImplementationProvider(pe,ke){return dt.registerImplementationProvider(ze,wt(pe),ke)},registerTypeDefinitionProvider(pe,ke){return dt.registerTypeDefinitionProvider(ze,wt(pe),ke)},registerHoverProvider(pe,ke){return dt.registerHoverProvider(ze,wt(pe),ke,ze.identifier)},registerEvaluatableExpressionProvider(pe,ke){return dt.registerEvaluatableExpressionProvider(ze,wt(pe),ke,ze.identifier)},registerInlineValuesProvider(pe,ke){return dt.registerInlineValuesProvider(ze,wt(pe),ke,ze.identifier)},registerDocumentHighlightProvider(pe,ke){return dt.registerDocumentHighlightProvider(ze,wt(pe),ke)},registerLinkedEditingRangeProvider(pe,ke){return dt.registerLinkedEditingRangeProvider(ze,wt(pe),ke)},registerReferenceProvider(pe,ke){return dt.registerReferenceProvider(ze,wt(pe),ke)},registerRenameProvider(pe,ke){return dt.registerRenameProvider(ze,wt(pe),ke)},registerDocumentSymbolProvider(pe,ke,je){return dt.registerDocumentSymbolProvider(ze,wt(pe),ke,je)},registerWorkspaceSymbolProvider(pe){return dt.registerWorkspaceSymbolProvider(ze,pe)},registerDocumentFormattingEditProvider(pe,ke){return dt.registerDocumentFormattingEditProvider(ze,wt(pe),ke)},registerDocumentRangeFormattingEditProvider(pe,ke){return dt.registerDocumentRangeFormattingEditProvider(ze,wt(pe),ke)},registerOnTypeFormattingEditProvider(pe,ke,je,...at){return dt.registerOnTypeFormattingEditProvider(ze,wt(pe),ke,[je].concat(at))},registerDocumentSemanticTokensProvider(pe,ke,je){return dt.registerDocumentSemanticTokensProvider(ze,wt(pe),ke,je)},registerDocumentRangeSemanticTokensProvider(pe,ke,je){return dt.registerDocumentRangeSemanticTokensProvider(ze,wt(pe),ke,je)},registerSignatureHelpProvider(pe,ke,je,...at){return typeof je=="object"?dt.registerSignatureHelpProvider(ze,wt(pe),ke,je):dt.registerSignatureHelpProvider(ze,wt(pe),ke,typeof je>"u"?[]:[je,...at])},registerCompletionItemProvider(pe,ke,...je){return dt.registerCompletionItemProvider(ze,wt(pe),ke,je)},registerInlineCompletionItemProvider(pe,ke,je){return ke.handleDidShowCompletionItem&&(0,Ue.$mF)(ze,"inlineCompletionsAdditions"),ke.handleDidPartiallyAcceptCompletionItem&&(0,Ue.$mF)(ze,"inlineCompletionsAdditions"),je&&(0,Ue.$mF)(ze,"inlineCompletionsAdditions"),dt.registerInlineCompletionsProvider(ze,wt(pe),ke,je)},registerDocumentLinkProvider(pe,ke){return dt.registerDocumentLinkProvider(ze,wt(pe),ke)},registerColorProvider(pe,ke){return dt.registerColorProvider(ze,wt(pe),ke)},registerFoldingRangeProvider(pe,ke){return dt.registerFoldingRangeProvider(ze,wt(pe),ke)},registerSelectionRangeProvider(pe,ke){return dt.registerSelectionRangeProvider(ze,pe,ke)},registerCallHierarchyProvider(pe,ke){return dt.registerCallHierarchyProvider(ze,pe,ke)},registerTypeHierarchyProvider(pe,ke){return dt.registerTypeHierarchyProvider(ze,pe,ke)},setLanguageConfiguration:(pe,ke)=>dt.setLanguageConfiguration(ze,pe,ke),getTokenInformationAtPosition(pe,ke){return(0,Ue.$mF)(ze,"tokenInformation"),li.tokenAtPosition(pe,ke)},registerInlayHintsProvider(pe,ke){return dt.registerInlayHintsProvider(ze,pe,ke)},createLanguageStatusItem(pe,ke){return li.createLanguageStatusItem(ze,pe,ke)},registerDocumentDropEditProvider(pe,ke,je){return dt.registerDocumentOnDropEditProvider(ze,pe,ke,(0,Ue.$lF)(ze,"dropMetadata")?je:void 0)}},wn={get activeTextEditor(){return Bt.getActiveTextEditor()},get visibleTextEditors(){return Bt.getVisibleTextEditors()},get activeTerminal(){return gt.activeTerminal},get terminals(){return gt.terminals},async showTextDocument(pe,ke,je){const at=await(A.URI.isUri(pe)?Promise.resolve(Pi.openTextDocument(pe)):Promise.resolve(pe));return Bt.showTextDocument(at,ke,je)},createTextEditorDecorationType(pe){return Bt.createTextEditorDecorationType(ze,pe)},onDidChangeActiveTextEditor(pe,ke,je){return Bt.onDidChangeActiveTextEditor(pe,ke,je)},onDidChangeVisibleTextEditors(pe,ke,je){return Bt.onDidChangeVisibleTextEditors(pe,ke,je)},onDidChangeTextEditorSelection(pe,ke,je){return Bt.onDidChangeTextEditorSelection(pe,ke,je)},onDidChangeTextEditorOptions(pe,ke,je){return Bt.onDidChangeTextEditorOptions(pe,ke,je)},onDidChangeTextEditorVisibleRanges(pe,ke,je){return Bt.onDidChangeTextEditorVisibleRanges(pe,ke,je)},onDidChangeTextEditorViewColumn(pe,ke,je){return Bt.onDidChangeTextEditorViewColumn(pe,ke,je)},onDidCloseTerminal(pe,ke,je){return gt.onDidCloseTerminal(pe,ke,je)},onDidOpenTerminal(pe,ke,je){return gt.onDidOpenTerminal(pe,ke,je)},onDidChangeActiveTerminal(pe,ke,je){return gt.onDidChangeActiveTerminal(pe,ke,je)},onDidChangeTerminalDimensions(pe,ke,je){return(0,Ue.$mF)(ze,"terminalDimensions"),gt.onDidChangeTerminalDimensions(pe,ke,je)},onDidChangeTerminalState(pe,ke,je){return gt.onDidChangeTerminalState(pe,ke,je)},onDidWriteTerminalData(pe,ke,je){return(0,Ue.$mF)(ze,"terminalDataWriteEvent"),gt.onDidWriteTerminalData(pe,ke,je)},onDidExecuteTerminalCommand(pe,ke,je){return(0,Ue.$mF)(ze,"terminalExecuteCommandEvent"),gt.onDidExecuteTerminalCommand(pe,ke,je)},get state(){return Ve.getState(ze)},onDidChangeWindowState(pe,ke,je){return Ve.onDidChangeWindowState(pe,ke,je)},showInformationMessage(pe,...ke){return Zt.showMessage(ze,L.default.Info,pe,ke[0],ke.slice(1))},showWarningMessage(pe,...ke){return Zt.showMessage(ze,L.default.Warning,pe,ke[0],ke.slice(1))},showErrorMessage(pe,...ke){return Zt.showMessage(ze,L.default.Error,pe,ke[0],ke.slice(1))},showQuickPick(pe,ke,je){return si.showQuickPick(ze,pe,ke,je)},showWorkspaceFolderPick(pe){return si.showWorkspaceFolderPick(pe)},showInputBox(pe,ke){return si.showInput(pe,ke)},showOpenDialog(pe){return $i.showOpenDialog(ze,pe)},showSaveDialog(pe){return $i.showSaveDialog(pe)},createStatusBarItem(pe,ke,je){let at,vt,Lt;return typeof pe=="string"?(at=pe,vt=ke,Lt=je):(vt=pe,Lt=ke),Bi.createStatusBarEntry(ze,at,vt,Lt)},setStatusBarMessage(pe,ke){return Bi.setStatusBarMessage(pe,ke)},withScmProgress(pe){return Fe.report("window.withScmProgress",ze,"Use 'withProgress' instead."),Ei.withProgress(ze,{location:B.ProgressLocation.SourceControl},(ke,je)=>pe({report(at){}}))},withProgress(pe,ke){return Ei.withProgress(ze,pe,ke)},createOutputChannel(pe,ke){return pi.createOutputChannel(pe,ke,ze)},createWebviewPanel(pe,ke,je,at){return gi.createWebviewPanel(ze,pe,ke,je,at)},createWebviewTextEditorInset(pe,ke,je,at){return(0,Ue.$mF)(ze,"editorInsets"),Li.createWebviewEditorInset(pe,ke,je,at,ze)},createTerminal(pe,ke,je){return typeof pe=="object"?"pty"in pe?gt.createExtensionTerminal(pe):gt.createTerminalFromOptions(pe):gt.createTerminal(pe,ke,je)},registerTerminalLinkProvider(pe){return gt.registerLinkProvider(pe)},registerTerminalProfileProvider(pe,ke){return gt.registerProfileProvider(ze,pe,ke)},registerTerminalQuickFixProvider(pe,ke){return(0,Ue.$mF)(ze,"terminalQuickFixProvider"),gt.registerTerminalQuickFixProvider(pe,ze.identifier.value,ke)},registerTreeDataProvider(pe,ke){return ri.registerTreeDataProvider(pe,ke,ze)},createTreeView(pe,ke){return ri.createTreeView(pe,ke,ze)},registerWebviewPanelSerializer:(pe,ke)=>gi.registerWebviewPanelSerializer(ze,pe,ke),registerCustomEditorProvider:(pe,ke,je={})=>xi.registerCustomEditorProvider(ze,pe,ke,je),registerFileDecorationProvider(pe){return Ct.registerFileDecorationProvider(pe,ze)},registerUriHandler(pe){return Qi.registerUriHandler(ze,pe)},createQuickPick(){return si.createQuickPick(ze)},createInputBox(){return si.createInputBox(ze)},get activeColorTheme(){return ki.activeColorTheme},onDidChangeActiveColorTheme(pe,ke,je){return ki.onDidChangeActiveColorTheme(pe,ke,je)},registerWebviewViewProvider(pe,ke,je){return _i.registerWebviewViewProvider(ze,pe,ke,je?.webviewOptions)},get activeNotebookEditor(){return St.activeNotebookEditor},onDidChangeActiveNotebookEditor(pe,ke,je){return St.onDidChangeActiveNotebookEditor(pe,ke,je)},get visibleNotebookEditors(){return St.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return St.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(pe,ke,je){return vi.onDidChangeNotebookEditorSelection(pe,ke,je)},onDidChangeNotebookEditorVisibleRanges(pe,ke,je){return vi.onDidChangeNotebookEditorVisibleRanges(pe,ke,je)},showNotebookDocument(pe,ke){return St.showNotebookDocument(pe,ke)},registerExternalUriOpener(pe,ke,je){return(0,Ue.$mF)(ze,"externalUriOpener"),en.registerExternalUriOpener(ze.identifier,pe,ke,je)},registerProfileContentHandler(pe,ke){return(0,Ue.$mF)(ze,"profileContentHandlers"),tn.registrProfileContentHandler(ze,pe,ke)},registerQuickDiffProvider(pe,ke,je,at){return(0,Ue.$mF)(ze,"quickDiffProvider"),Fi.registerQuickDiffProvider(wt(pe),ke,je,at)},get tabGroups(){return Ye.tabGroups},registerShareProvider(pe,ke){return(0,Ue.$mF)(ze,"shareProvider"),Ti.registerShareProvider(wt(pe),ke)}},Pi={get rootPath(){return Fe.report("workspace.rootPath",ze,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),lt.getPath()},set rootPath(pe){throw new M.$9("rootPath")},getWorkspaceFolder(pe){return lt.getWorkspaceFolder(pe)},get workspaceFolders(){return lt.getWorkspaceFolders()},get name(){return lt.name},set name(pe){throw new M.$9("name")},get workspaceFile(){return lt.workspaceFile},set workspaceFile(pe){throw new M.$9("workspaceFile")},updateWorkspaceFolders:(pe,ke,...je)=>lt.updateWorkspaceFolders(ze,pe,ke||0,...je),onDidChangeWorkspaceFolders:function(pe,ke,je){return lt.onDidChangeWorkspace(pe,ke,je)},asRelativePath:(pe,ke)=>lt.getRelativePath(pe,ke),findFiles:(pe,ke,je,at)=>lt.findFiles(pe,ke,je,ze.identifier,at),findTextInFiles:(pe,ke,je,at)=>{(0,Ue.$mF)(ze,"findTextInFiles");let vt,Lt;return typeof ke=="object"?(vt=ke,Lt=je):(vt={},Lt=ke,at=je),lt.findTextInFiles(pe,vt||{},Lt,ze.identifier,at)},save:pe=>((0,Ue.$mF)(ze,"saveEditor"),lt.save(pe)),saveAs:pe=>((0,Ue.$mF)(ze,"saveEditor"),lt.saveAs(pe)),saveAll:pe=>lt.saveAll(pe),applyEdit(pe,ke){return Wi.applyWorkspaceEdit(pe,ze,ke)},createFileSystemWatcher:(pe,ke,je,at)=>{let vt;return typeof ke=="boolean"?vt={ignoreCreateEvents:!!ke,ignoreChangeEvents:!!je,ignoreDeleteEvents:!!at,correlate:!1}:ke&&((0,Ue.$mF)(ze,"createFileSystemWatcher"),vt={...ke,correlate:!0}),ei.createFileSystemWatcher(lt,ze,pe,vt)},get textDocuments(){return Rt.getAllDocumentData().map(pe=>pe.document)},set textDocuments(pe){throw new M.$9("textDocuments")},openTextDocument(pe){let ke;const je=pe;if(typeof pe=="string")ke=Promise.resolve(A.URI.file(pe));else if(A.URI.isUri(pe))ke=Promise.resolve(pe);else if(!je||typeof je=="object")ke=Rt.createDocumentData(je);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ke.then(at=>Rt.ensureDocumentData(at).then(vt=>vt.document))},onDidOpenTextDocument:(pe,ke,je)=>Rt.onDidAddDocument(pe,ke,je),onDidCloseTextDocument:(pe,ke,je)=>Rt.onDidRemoveDocument(pe,ke,je),onDidChangeTextDocument:(pe,ke,je)=>Rt.onDidChangeDocument(pe,ke,je),onDidSaveTextDocument:(pe,ke,je)=>Rt.onDidSaveDocument(pe,ke,je),onWillSaveTextDocument:(pe,ke,je)=>Ai.getOnWillSaveTextDocumentEvent(ze)(pe,ke,je),get notebookDocuments(){return St.notebookDocuments.map(pe=>pe.apiNotebook)},async openNotebookDocument(pe,ke){let je;if(A.URI.isUri(pe))je=pe,await St.openNotebookDocument(pe);else if(typeof pe=="string")je=A.URI.revive(await St.createNotebookDocument({viewType:pe,content:ke}));else throw new Error("Invalid arguments");return St.getNotebookDocument(je).apiNotebook},onDidSaveNotebookDocument(pe,ke,je){return Xt.onDidSaveNotebookDocument(pe,ke,je)},onDidChangeNotebookDocument(pe,ke,je){return Xt.onDidChangeNotebookDocument(pe,ke,je)},onWillSaveNotebookDocument(pe,ke,je){return Yi.getOnWillSaveNotebookDocumentEvent(ze)(pe,ke,je)},get onDidOpenNotebookDocument(){return St.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return St.onDidCloseNotebookDocument},registerNotebookSerializer(pe,ke,je,at){return St.registerNotebookSerializer(ze,pe,ke,je,(0,Ue.$lF)(ze,"notebookLiveShare")?at:void 0)},onDidChangeConfiguration:(pe,ke,je)=>bi.onDidChangeConfiguration(pe,ke,je),getConfiguration(pe,ke){return ke=arguments.length===1?void 0:ke,bi.getConfiguration(pe,ke,ze)},registerTextDocumentContentProvider(pe,ke){return Ii.registerTextDocumentContentProvider(pe,ke)},registerTaskProvider:(pe,ke)=>(Fe.report("window.registerTaskProvider",ze,"Use the corresponding function on the 'tasks' namespace instead"),Gt.registerTaskProvider(ze,pe,ke)),registerFileSystemProvider(pe,ke,je){return(0,Ke.$Pc)(Mi.registerFileSystemProvider(ze,pe,ke,je),Ft.addFileSystemProvider(pe,ke,je))},get fs(){return Ft.value},registerFileSearchProvider:(pe,ke)=>((0,Ue.$mF)(ze,"fileSearchProvider"),ci.registerFileSearchProvider(pe,ke)),registerTextSearchProvider:(pe,ke)=>((0,Ue.$mF)(ze,"textSearchProvider"),ci.registerTextSearchProvider(pe,ke)),registerRemoteAuthorityResolver:(pe,ke)=>((0,Ue.$mF)(ze,"resolvers"),Mt.registerRemoteAuthorityResolver(pe,ke)),registerResourceLabelFormatter:pe=>((0,Ue.$mF)(ze,"resolvers"),Oi.$registerResourceLabelFormatter(pe)),getRemoteExecServer:pe=>((0,Ue.$mF)(ze,"resolvers"),Mt.getRemoteExecServer(pe)),onDidCreateFiles:(pe,ke,je)=>ei.onDidCreateFile(pe,ke,je),onDidDeleteFiles:(pe,ke,je)=>ei.onDidDeleteFile(pe,ke,je),onDidRenameFiles:(pe,ke,je)=>ei.onDidRenameFile(pe,ke,je),onWillCreateFiles:(pe,ke,je)=>ei.getOnWillCreateFileEvent(ze)(pe,ke,je),onWillDeleteFiles:(pe,ke,je)=>ei.getOnWillDeleteFileEvent(ze)(pe,ke,je),onWillRenameFiles:(pe,ke,je)=>ei.getOnWillRenameFileEvent(ze)(pe,ke,je),openTunnel:pe=>((0,Ue.$mF)(ze,"tunnels"),ne.openTunnel(ze,pe).then(ke=>{if(!ke)throw new Error("cannot open tunnel");return ke})),get tunnels(){return(0,Ue.$mF)(ze,"tunnels"),ne.getTunnels()},onDidChangeTunnels:(pe,ke,je)=>((0,Ue.$mF)(ze,"tunnels"),ne.onDidChangeTunnels(pe,ke,je)),registerPortAttributesProvider:(pe,ke)=>((0,Ue.$mF)(ze,"portsAttributes"),ne.registerPortsAttributesProvider(pe,ke)),registerTunnelProvider:(pe,ke)=>((0,Ue.$mF)(ze,"tunnelFactory"),ne.registerTunnelProvider(pe,ke)),registerTimelineProvider:(pe,ke)=>((0,Ue.$mF)(ze,"timeline"),Zi.registerTimelineProvider(pe,ke,ze.identifier,bt.converter)),get isTrusted(){return lt.trusted},requestWorkspaceTrust:pe=>((0,Ue.$mF)(ze,"workspaceTrust"),lt.requestWorkspaceTrust(pe)),onDidGrantWorkspaceTrust:(pe,ke,je)=>lt.onDidGrantWorkspaceTrust(pe,ke,je),registerEditSessionIdentityProvider:(pe,ke)=>((0,Ue.$mF)(ze,"editSessionIdentityProvider"),lt.registerEditSessionIdentityProvider(pe,ke)),onWillCreateEditSessionIdentity:(pe,ke,je)=>((0,Ue.$mF)(ze,"editSessionIdentityProvider"),lt.getOnWillCreateEditSessionIdentityEvent(ze)(pe,ke,je)),registerCanonicalUriProvider:(pe,ke)=>((0,Ue.$mF)(ze,"canonicalUriProvider"),lt.registerCanonicalUriProvider(pe,ke)),getCanonicalUri:(pe,ke,je)=>((0,Ue.$mF)(ze,"canonicalUriProvider"),lt.provideCanonicalUri(pe,ke,je))},cn={get inputBox(){return Fe.report("scm.inputBox",ze,"Use 'SourceControl.inputBox' instead"),yi.getLastInputBox(ze)},createSourceControl(pe,ke,je){return yi.createSourceControl(ze,pe,ke,je)}},un={createCommentController(pe,ke){return Xi.createCommentController(ze,pe,ke)}},ln={get activeDebugSession(){return $t.activeDebugSession},get activeDebugConsole(){return $t.activeDebugConsole},get breakpoints(){return $t.breakpoints},get stackFrameFocus(){return $t.stackFrameFocus},onDidStartDebugSession(pe,ke,je){return $t.onDidStartDebugSession(pe,ke,je)},onDidTerminateDebugSession(pe,ke,je){return $t.onDidTerminateDebugSession(pe,ke,je)},onDidChangeActiveDebugSession(pe,ke,je){return $t.onDidChangeActiveDebugSession(pe,ke,je)},onDidReceiveDebugSessionCustomEvent(pe,ke,je){return $t.onDidReceiveDebugSessionCustomEvent(pe,ke,je)},onDidChangeBreakpoints(pe,ke,je){return $t.onDidChangeBreakpoints(pe,ke,je)},onDidChangeStackFrameFocus(pe,ke,je){return(0,Ue.$mF)(ze,"debugFocus"),$t.onDidChangeStackFrameFocus(pe,ke,je)},registerDebugConfigurationProvider(pe,ke,je){return $t.registerDebugConfigurationProvider(pe,ke,je||Ze.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(pe,ke){return $t.registerDebugAdapterDescriptorFactory(ze,pe,ke)},registerDebugAdapterTrackerFactory(pe,ke){return $t.registerDebugAdapterTrackerFactory(pe,ke)},startDebugging(pe,ke,je){return!je||typeof je=="object"&&"configuration"in je?$t.startDebugging(pe,ke,{parentSession:je}):$t.startDebugging(pe,ke,je||{})},stopDebugging(pe){return $t.stopDebugging(pe)},addBreakpoints(pe){return $t.addBreakpoints(pe)},removeBreakpoints(pe){return $t.removeBreakpoints(pe)},asDebugSourceUri(pe,ke){return $t.asDebugSourceUri(pe,ke)}},pn={registerTaskProvider:(pe,ke)=>Gt.registerTaskProvider(ze,pe,ke),fetchTasks:pe=>Gt.fetchTasks(pe),executeTask:pe=>Gt.executeTask(ze,pe),get taskExecutions(){return Gt.taskExecutions},onDidStartTask:(pe,ke,je)=>Gt.onDidStartTask(pe,ke,je),onDidEndTask:(pe,ke,je)=>Gt.onDidEndTask(pe,ke,je),onDidStartTaskProcess:(pe,ke,je)=>Gt.onDidStartTaskProcess(pe,ke,je),onDidEndTaskProcess:(pe,ke,je)=>Gt.onDidEndTaskProcess(pe,ke,je)},vn={createNotebookController(pe,ke,je,at,vt){return fi.createNotebookController(ze,pe,ke,je,at,(0,Ue.$lF)(ze,"notebookMessaging")?vt:void 0)},registerNotebookCellStatusBarItemProvider:(pe,ke)=>St.registerNotebookCellStatusBarItemProvider(ze,pe,ke),createRendererMessaging(pe){return Ri.createRendererMessaging(ze,pe)},createNotebookControllerDetectionTask(pe){return(0,Ue.$mF)(ze,"notebookKernelSource"),fi.createNotebookControllerDetectionTask(ze,pe)},registerKernelSourceActionProvider(pe,ke){return(0,Ue.$mF)(ze,"notebookKernelSource"),fi.registerKernelSourceActionProvider(ze,pe,ke)},onDidChangeNotebookCellExecutionState(pe,ke,je){return(0,Ue.$mF)(ze,"notebookCellExecutionState"),fi.onDidChangeNotebookCellExecutionState(pe,ke,je)}},hn={t(...pe){if(typeof pe[0]=="string"){const ke=pe.shift(),je=!pe||typeof pe[0]!="object"?pe:pe[0];return di.getMessage(ze.identifier.value,{message:ke,args:je})}return di.getMessage(ze.identifier.value,pe[0])},get bundle(){return di.getBundle(ze.identifier.value)},get uri(){return di.getBundleUri(ze.identifier.value)}},dn={_version:1,registerInteractiveEditorSessionProvider(pe,ke){return(0,Ue.$mF)(ze,"interactive"),fn.registerProvider(ze,pe,ke={label:ke?.label??ze.displayName??ze.name})},registerInteractiveSessionProvider(pe,ke){return(0,Ue.$mF)(ze,"interactive"),Di.registerChatProvider(ze,pe,ke)},sendInteractiveRequestToProvider(pe,ke){return(0,Ue.$mF)(ze,"interactive"),Di.sendInteractiveRequestToProvider(pe,ke)},get onDidPerformUserAction(){return(0,Ue.$mF)(ze,"interactiveUserActions"),Di.onDidPerformUserAction},transferChatSession(pe,ke){return(0,Ue.$mF)(ze,"interactive"),Di.transferChatSession(pe,ke)}},Vi={getRelatedInformation(pe,ke){return(0,Ue.$mF)(ze,"aiRelatedInformation"),zi.getRelatedInformation(ze,pe,ke)},registerRelatedInformationProvider(pe,ke){return(0,Ue.$mF)(ze,"aiRelatedInformation"),zi.registerRelatedInformationProvider(ze,pe,ke)},registerEmbeddingVectorProvider(pe,ke){return(0,Ue.$mF)(ze,"aiRelatedInformation"),Ci.registerEmbeddingVectorProvider(ze,pe,ke)}},Ki={registerChatResponseProvider(pe,ke,je){return(0,Ue.$mF)(ze,"chatProvider"),Si.registerProvider(ze.identifier,pe,ke,je)},requestChatAccess(pe){return(0,Ue.$mF)(ze,"chatRequestAccess"),Si.requestChatResponseProvider(ze.identifier,pe)},registerVariable(pe,ke,je){return(0,Ue.$mF)(ze,"chatVariables"),mn.registerVariableResolver(ze,pe,ke,je)},registerMappedEditsProvider(pe,ke){return(0,Ue.$mF)(ze,"mappedEditsProvider"),dt.registerMappedEditsProvider(ze,pe,ke)},createChatAgent(pe,ke){return(0,Ue.$mF)(ze,"chatAgents2"),ji.createChatAgent(ze,pe,ke)},registerAgent(pe,ke,je){return(0,Ue.$mF)(ze,"chatAgents"),Ni.registerAgent(ze.identifier,pe,ke,je)}},Hi={registerSpeechProvider(pe,ke){return(0,Ue.$mF)(ze,"speech"),nn.registerProvider(ze.identifier,pe,ke)}};return{version:ft.version,ai:Vi,authentication:sn,commands:on,comments:un,chat:Ki,debug:ln,env:qi,extensions:an,interactive:dn,l10n:hn,languages:bn,notebooks:vn,scm:cn,speech:Hi,tasks:pn,tests:$n,window:wn,workspace:Pi,Breakpoint:B.$qL,TerminalOutputAnchor:B.TerminalOutputAnchor,ChatAgentResultFeedbackKind:B.ChatAgentResultFeedbackKind,ChatMessage:B.$gM,ChatMessageRole:B.ChatMessageRole,ChatVariableLevel:B.ChatVariableLevel,CallHierarchyIncomingCall:B.$PK,CallHierarchyItem:B.$OK,CallHierarchyOutgoingCall:B.$QK,CancellationError:M.$5,CancellationTokenSource:y.$Yd,CandidatePortSource:p.CandidatePortSource,CodeAction:B.$LK,CodeActionKind:B.$MK,CodeActionTriggerKind:B.CodeActionTriggerKind,CodeLens:B.$RK,Color:B.$5K,ColorInformation:B.$6K,ColorPresentation:B.$7K,ColorThemeKind:B.ColorThemeKind,CommentMode:B.CommentMode,CommentState:B.CommentState,CommentThreadCollapsibleState:B.CommentThreadCollapsibleState,CommentThreadState:B.CommentThreadState,CompletionItem:B.$YK,CompletionItemKind:B.CompletionItemKind,CompletionItemTag:B.CompletionItemTag,CompletionList:B.$ZK,CompletionTriggerKind:B.CompletionTriggerKind,ConfigurationTarget:B.ConfigurationTarget,CustomExecution:B.$cL,DebugAdapterExecutable:B.$uL,DebugAdapterInlineImplementation:B.$xL,DebugAdapterNamedPipeServer:B.$wL,DebugAdapterServer:B.$vL,DebugConfigurationProviderTriggerKind:Ze.DebugConfigurationProviderTriggerKind,DebugConsoleMode:B.DebugConsoleMode,DecorationRangeBehavior:B.DecorationRangeBehavior,Diagnostic:B.$GK,DiagnosticRelatedInformation:B.$FK,DiagnosticSeverity:B.DiagnosticSeverity,DiagnosticTag:B.DiagnosticTag,Disposable:B.$sK,DocumentHighlight:B.$IK,DocumentHighlightKind:B.DocumentHighlightKind,DocumentLink:B.$4K,DocumentSymbol:B.$KK,EndOfLine:B.EndOfLine,EnvironmentVariableMutatorType:B.EnvironmentVariableMutatorType,EvaluatableExpression:B.$AL,InlineValueText:B.$BL,InlineValueVariableLookup:B.$CL,InlineValueEvaluatableExpression:B.$DL,InlineCompletionTriggerKind:B.InlineCompletionTriggerKind,EventEmitter:l.$Od,ExtensionKind:B.ExtensionKind,ExtensionMode:B.ExtensionMode,ExternalUriOpenerPriority:B.ExternalUriOpenerPriority,FileChangeType:B.FileChangeType,FileDecoration:B.$NL,FileDecoration2:B.$NL,FileSystemError:B.$FL,FileType:P.FileType,FilePermission:P.FilePermission,FoldingRange:B.$GL,FoldingRangeKind:B.FoldingRangeKind,FunctionBreakpoint:B.$sL,InlineCompletionItem:B.$1K,InlineCompletionList:B.$2K,Hover:B.$HK,IndentAction:$.IndentAction,Location:B.$EK,MarkdownString:B.$SK,OverviewRulerLane:k.OverviewRulerLane,ParameterInformation:B.$TK,PortAutoForwardAction:B.PortAutoForwardAction,Position:B.$tK,ProcessExecution:B.$aL,ProgressLocation:B.ProgressLocation,QuickInputButtons:B.$ML,Range:B.$uK,RelativePattern:B.$oL,Selection:B.$vK,SelectionRange:B.$NK,SemanticTokens:B.$JL,SemanticTokensBuilder:B.$IL,SemanticTokensEdit:B.$KL,SemanticTokensEdits:B.$LL,SemanticTokensLegend:B.$HL,ShellExecution:B.$bL,ShellQuoting:B.ShellQuoting,SignatureHelp:B.$VK,SignatureHelpTriggerKind:B.SignatureHelpTriggerKind,SignatureInformation:B.$UK,SnippetString:B.$DK,SourceBreakpoint:B.$rL,StandardTokenType:B.StandardTokenType,StatusBarAlignment:B.StatusBarAlignment,SymbolInformation:B.$JK,SymbolKind:B.SymbolKind,SymbolTag:B.SymbolTag,Task:B.$dL,TaskGroup:B.$_K,TaskPanelKind:B.TaskPanelKind,TaskRevealKind:B.TaskRevealKind,TaskScope:B.TaskScope,TerminalLink:B.$8K,TerminalQuickFixExecuteTerminalCommand:B.$0K,TerminalQuickFixOpener:B.$9K,TerminalLocation:B.TerminalLocation,TerminalProfile:B.$$K,TerminalExitReason:B.TerminalExitReason,TextDocumentSaveReason:B.TextDocumentSaveReason,TextEdit:B.$zK,SnippetTextEdit:B.$BK,TextEditorCursorStyle:g.TextEditorCursorStyle,TextEditorLineNumbersStyle:B.TextEditorLineNumbersStyle,TextEditorRevealType:B.TextEditorRevealType,TextEditorSelectionChangeKind:B.TextEditorSelectionChangeKind,SyntaxTokenType:B.SyntaxTokenType,TextDocumentChangeReason:B.TextDocumentChangeReason,ThemeColor:B.$nL,ThemeIcon:B.$mL,TreeItem:B.$eL,TreeItemCheckboxState:B.TreeItemCheckboxState,TreeItemCollapsibleState:B.TreeItemCollapsibleState,TypeHierarchyItem:B.$9L,UIKind:S.UIKind,Uri:A.URI,ViewColumn:B.ViewColumn,WorkspaceEdit:B.$CK,DocumentDropEdit:B.$kL,DocumentPasteEdit:B.$lL,InlayHint:B.$XK,InlayHintLabelPart:B.$WK,InlayHintKind:B.InlayHintKind,RemoteAuthorityResolverError:B.$yK,ResolvedAuthority:B.$wK,ManagedResolvedAuthority:B.$xK,SourceControlInputBoxValidationType:B.SourceControlInputBoxValidationType,ExtensionRuntime:B.ExtensionRuntime,TimelineItem:B.$XL,NotebookRange:B.$PL,NotebookCellKind:B.NotebookCellKind,NotebookCellExecutionState:B.NotebookCellExecutionState,NotebookCellData:B.$QL,NotebookData:B.$RL,NotebookRendererScript:B.$VL,NotebookCellStatusBarAlignment:B.NotebookCellStatusBarAlignment,NotebookEditorRevealType:B.NotebookEditorRevealType,NotebookCellOutput:B.$TL,NotebookCellOutputItem:B.$SL,NotebookCellStatusBarItem:B.$UL,NotebookControllerAffinity:B.NotebookControllerAffinity,NotebookControllerAffinity2:B.NotebookControllerAffinity2,NotebookEdit:B.$AK,NotebookKernelSourceAction:B.$WL,PortAttributes:B.$ZL,LinkedEditingRanges:B.$YL,TestResultState:B.TestResultState,TestRunRequest:B.$1L,TestMessage:B.$2L,TestMessage2:B.$2L,TestTag:B.$3L,TestRunProfileKind:B.TestRunProfileKind,TextSearchCompleteMessageType:Ae.TextSearchCompleteMessageType,DataTransfer:B.$jL,DataTransferItem:B.$fL,CoveredCount:B.$4L,FileCoverage:B.$5L,StatementCoverage:B.$6L,BranchCoverage:B.$7L,FunctionCoverage:B.$8L,WorkspaceTrustState:B.WorkspaceTrustState,LanguageStatusSeverity:B.LanguageStatusSeverity,QuickPickItemKind:B.QuickPickItemKind,InputBoxValidationSeverity:B.InputBoxValidationSeverity,TabInputText:B.$0L,TabInputTextDiff:B.$$L,TabInputTextMerge:B.$_L,TabInputCustom:B.$aM,TabInputNotebook:B.$cM,TabInputNotebookDiff:B.$dM,TabInputWebview:B.$bM,TabInputTerminal:B.$eM,TabInputInteractiveWindow:B.$fM,TelemetryTrustedValue:he.$oo,LogLevel:Y.LogLevel,EditSessionIdentityMatch:ht.EditSessionIdentityMatch,InteractiveSessionVoteDirection:B.InteractiveSessionVoteDirection,InteractiveSessionCopyKind:B.InteractiveSessionCopyKind,InteractiveEditorResponseFeedbackKind:B.InteractiveEditorResponseFeedbackKind,StackFrameFocus:B.$yL,ThreadFocus:B.$zL,RelatedInformationType:B.RelatedInformationType,SpeechToTextStatus:B.SpeechToTextStatus}}}e.$Kec=It}),define(De[358],Ce([1,0,103,153,38,150,40,34,70,45,93,94,95,116,73,89,152,72,55,115,88,71,151,14,56,113,114]),function(re,e,y,M,l,L,A,g,k,$,R,P,p,S,D,E,h,u,d,c,f,a,t,i,s,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,y.$Br)(n.$jdc,n.$idc,1),(0,y.$Br)(i.$_i,t.$Lec,1),(0,y.$Br)(E.$Icc,E.$Jcc,1),(0,y.$Br)(g.$NM,g.$MM,0),(0,y.$Br)(A.$Vcc,A.$Tcc,0),(0,y.$Br)(u.$$cc,u.$0cc,0),(0,y.$Br)(P.$Ydc,P.$3dc,0),(0,y.$Br)(L.$Qdc,L.$Pdc,0),(0,y.$Br)(k.$CM,k.$BM,0),(0,y.$Br)(r.$kdc,r.$ldc,0),(0,y.$Br)(d.$Fcc,d.$Ecc,0),(0,y.$Br)(M.$wdc,M.$vdc,1),(0,y.$Br)(p.$9dc,p.$0dc,0),(0,y.$Br)(S.$7cc,S.$6cc,0),(0,y.$Br)(R.$Tdc,R.$Sdc,0),(0,y.$Br)($.$bdc,$.$edc,0),(0,y.$Br)(D.$uwb,D.$vwb,0),(0,y.$Br)(h.$Mdc,h.$Ldc,0),(0,y.$Br)(l.$Scc,l.$Rcc,0),(0,y.$Br)(c.$gdc,c.$fdc,0),(0,y.$Br)(f.$LM,f.$IM,0),(0,y.$Br)(a.$Udc,a.$Vdc,0),(0,y.$Br)(s.$Wdc,s.$Xdc,0)}),define(De[117],Ce([1,0,19,14,37,92]),function(re,e,y,M,l,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4ec=e.$3ec=e.$2ec=void 0;function A(P){return P.startsWith("**")||P.startsWith("/")?P:`/${P}`}e.$2ec=A;function g(P,p,S,D){const E=(0,y.$2b)(S,k),h=new l.$WI(p,E,D),u=h.preview.matches;return{ranges:(0,y.$2b)(E,$),uri:P,preview:{text:h.preview.text,matches:(0,y.$2b)(u,$)}}}e.$3ec=g;function k(P){return new l.$XI(P.start.line,P.start.character,P.end.line,P.end.character)}function $(P){return new L.$LI(P.startLineNumber,P.startColumn,P.endLineNumber,P.endColumn)}let R=class{constructor(p,S){this.a=p,this.b=S}appendLine(p){this.b.debug(`${this.a}#search`,p)}};e.$4ec=R,e.$4ec=R=He([We(1,M.$$i)],R)}),define(De[359],Ce([1,0,49,15,77,32,12,16,117,360]),function(re,e,y,M,l,L,A,g,k,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7ec=e.$6ec=e.$5ec=void 0;const R=$.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function P(c,f,a,t){const i=p(c,f,a,t),s=f.folder.fsPath;return{cmd:y.spawn(R,i.args,{cwd:s}),rgDiskPath:R,siblingClauses:i.siblingClauses,rgArgs:i,cwd:s}}e.$5ec=P;function p(c,f,a,t){const i=["--files","--hidden","--case-sensitive","--no-require-git"];D([f],a,!1).forEach(n=>{const r=(0,k.$2ec)(n);if(i.push("-g",r),A.$e){const o=(0,l.$rl)(r);o!==r&&i.push("-g",o)}});const s=S([f],t,void 0,!1);return s.globArgs.forEach(n=>{const r=`!${(0,k.$2ec)(n)}`;if(i.push("-g",r),A.$e){const o=(0,l.$rl)(r);o!==r&&i.push("-g",o)}}),f.disregardIgnoreFiles!==!1?i.push("--no-ignore"):f.disregardParentIgnoreFiles!==!1&&i.push("--no-ignore-parent"),f.ignoreSymlinks||i.push("--follow"),c.exists&&i.push("--quiet"),i.push("--no-config"),f.disregardGlobalIgnoreFiles&&i.push("--no-ignore-global"),{args:i,siblingClauses:s.siblingClauses}}function S(c,f,a,t=!0){const i=[];let s={};return c.forEach(n=>{const r=Object.assign({},n.excludePattern||{},f||{}),o=E(r,t?n.folder.fsPath:void 0,a);i.push(...o.globArgs),o.siblingClauses&&(s=Object.assign(s,o.siblingClauses))}),{globArgs:i,siblingClauses:s}}function D(c,f,a=!0){const t=[];return c.forEach(i=>{const s=Object.assign({},f||{},i.includePattern||{}),n=E(s,a?i.folder.fsPath:void 0);t.push(...n.globArgs)}),t}function E(c,f,a){const t=[],i={};return Object.keys(c).forEach(s=>{if(a&&a.has(s)||!s)return;const n=c[s];s=u(f?h(f,s):s),s.startsWith("\\\\")?s="\\\\"+s.substr(2).replace(/\\/g,"/"):s=s.replace(/\\/g,"/"),typeof n=="boolean"&&n?(s.startsWith("\\\\")&&(s+="**"),t.push(d(s))):n&&n.when&&(i[s]=n)}),{globArgs:t,siblingClauses:i}}function h(c,f){return M.$ic(f)?f:M.$jc(c,f)}e.$6ec=h;function u(c){return c=g.$Le(c,"\\"),g.$Le(c,"/")}function d(c){return L.$Uf(c).toLowerCase()==="c:/"?c.replace(/^c:[/\\]/i,"/"):c}e.$7ec=d}),define(De[361],Ce([1,0,49,53,15,362,19,41,36,77,32,12,35,16,17,29,37,359,124]),function(re,e,y,M,l,L,A,g,k,$,R,P,p,S,D,E,h,u,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9ec=e.$8ec=void 0;const c=new Set;process.on("exit",()=>{c.forEach(s=>s())});class f{constructor(n){this.c=null,this.h=null,this.l=!1,this.m=null,this.r=null,this.s=0,this.a=n,this.b=n.filePattern||"",this.d=n.includePattern&&k.$xj(n.includePattern),this.f=n.maxResults||null,this.g=!!n.exists,this.v=Object.create(null),this.k=0,this.j=!1,this.o=0,this.p=0,this.q=[],this.b&&(this.c=(0,d.$Dq)(this.b).normalizedLowercase),this.u=n.excludePattern&&k.$xj(n.excludePattern),this.t=new Map,n.folderQueries.forEach(r=>{const o=Object.assign({},r.excludePattern||{},this.a.excludePattern||{}),v=r.folder.fsPath;n.folderQueries.map(C=>C.folder.fsPath).filter(C=>C!==v).forEach(C=>{(0,R.$Yf)(C,v)&&(o[l.$lc(v,C)]=!0)}),this.t.set(v,new t(o,v))})}cancel(){this.l=!0,c.forEach(n=>n())}walk(n,r,o,v,C){if(this.m=p.$Kd.create(!1),this.l)return C(null,this.j);r.forEach(w=>{const m=l.$nc(w.fsPath);this.u&&this.u(w.fsPath,m)||this.J(o,{relativePath:w.fsPath,searchPath:void 0})}),this.r=p.$Kd.create(!1),this.w(n,(w,m)=>{this.x(this.y,this,w,o,v,b=>{if(b){const I=(0,g.$Bi)(b);console.error(I),this.q.push(I),m(b,void 0)}else m(null,void 0)})},(w,m)=>{this.m.stop();const b=w?A.$Hb(w)[0]:null;C(b,this.j)})}w(n,r,o){const v=new Array(n.length),C=new Array(n.length);let w=!1,m=0;if(n.length===0)return o(null,[]);n.forEach((b,I)=>{r(b,(z,O)=>{if(z?(w=!0,v[I]=null,C[I]=z):(v[I]=O,C[I]=null),++m===n.length)return o(w?C:null,v)})})}x(n,r,...o){try{n.apply(r,o)}catch(v){o[o.length-1](v)}}y(n,r,o,v){const C=n.folder.fsPath,w=P.$e,m=()=>F&&F.kill();c.add(m);let b=U=>{c.delete(m),b=()=>{},v(U)},I="";const z=this.D(),O=(0,u.$5ec)(this.a,n,this.a.includePattern,this.t.get(n.folder.fsPath).expression),F=O.cmd,T=!Object.keys(O.siblingClauses).length,N=O.rgArgs.args.map(U=>U.match(/^-/)?U:`'${U}'`).join(" ");let j=`${O.rgDiskPath} ${N}
 - cwd: ${O.cwd}`;O.rgArgs.siblingClauses&&(j+=`
 - Sibling clauses: ${JSON.stringify(O.rgArgs.siblingClauses)}`),o({message:j}),this.s=0,this.z(F,"utf8",o,(U,B,he)=>{if(U){b(U);return}if(this.j){b();return}const Q=(I+(w?$.$ql(B||""):B)).split(`
`);if(he){const Z=Q.length;Q[Z-1]=Q[Z-1].trim(),Q[Z-1]||Q.pop()}else I=Q.pop()||"";if(Q.length&&Q[0].indexOf(`
`)!==-1){b(new Error("Splitting up files failed"));return}if(this.s+=Q.length,T){for(const Z of Q)if(this.J(r,{base:C,relativePath:Z,searchPath:this.N(n,Z)}),this.j){m();break}(he||this.j)&&b();return}this.G(n,z,C,Q,r),he&&(this.H(z,C,r),b())})}spawnFindCmd(n){const r=this.t.get(n.folder.fsPath),o=r.getBasenameTerms(),v=r.getPathTerms(),C=["-L","."];if(o.length||v.length){C.push("-not","(","(");for(const w of o)C.push("-name",w),C.push("-o");for(const w of v)C.push("-path",w),C.push("-o");C.pop(),C.push(")","-prune",")")}return C.push("-type","f"),y.spawn("find",C,{cwd:n.folder.fsPath})}readStdout(n,r,o){let v="";this.z(n,r,()=>{},(C,w,m)=>{if(C){o(C);return}v+=w,m&&o(null,v)})}z(n,r,o,v){let C=(b,I,z)=>{(b||z)&&(C=()=>{},this.r?.stop()),v(b,I,z)},w=!1;n.stdout?(this.A(n.stdout,r,C),n.stdout.once("data",()=>w=!0)):o({message:"stdout is null"});let m;n.stderr?m=this.B(n.stderr):o({message:"stderr is null"}),n.on("error",b=>{C(b)}),n.on("close",b=>{let I;!w&&(I=this.C(m,r))&&i(I)?C(new Error(`command failed with error code ${b}: ${this.C(m,r)}`)):(this.g&&b===0&&(this.j=!0),C(null,"",!0))})}A(n,r,o){const v=new L.StringDecoder(r);return n.on("data",C=>{o(null,v.write(C))}),v}B(n){const r=[];return n.on("data",o=>{r.push(o)}),r}C(n,r){const o=new L.StringDecoder(r);return n.map(v=>o.write(v)).join("")}D(){const n={rootEntries:[],pathToEntries:Object.create(null)};return n.pathToEntries["."]=n.rootEntries,n}G(n,{pathToEntries:r},o,v,C){v.indexOf(this.b)!==-1&&this.J(C,{base:o,relativePath:this.b,searchPath:this.N(n,this.b)});const w=m=>{const b=l.$nc(m),I=l.$mc(m);let z=r[I];z||(z=r[I]=[],w(I)),z.push({base:o,relativePath:m,basename:b,searchPath:this.N(n,m)})};v.forEach(w)}H({rootEntries:n,pathToEntries:r},o,v){const C=this,w=this.t.get(o),m=this.b;function b(I){C.o++;const z=(0,h.$aJ)(()=>I.map(O=>O.basename));for(let O=0,F=I.length;O<F;O++){const T=I[O],{relativePath:N,basename:j}=T;if(w.test(N,j,m!==j?z:void 0))continue;const U=r[N];if(U)b(U);else{if(C.p++,N===m)continue;C.J(v,T)}if(C.j)break}}b(n)}getStats(){return{cmdTime:this.r.elapsed(),fileWalkTime:this.m.elapsed(),directoriesWalked:this.o,filesWalked:this.p,cmdResultCount:this.s}}I(n,r,o,v,C){const w=n.folder,m=(0,h.$aJ)(()=>o);this.w(o,(b,I)=>{if(this.l||this.j)return I(null);const z=r?[r,b].join(l.sep):b;if(this.t.get(n.folder.fsPath).test(z,b,this.a.filePattern!==b?m:void 0))return I(null);const O=[w.fsPath,z].join(l.sep);M.lstat(O,(F,T)=>{if(F||this.l||this.j)return I(null);this.L(O,T,(N,j)=>N||this.l||this.j?I(null):j.isDirectory()?(this.o++,this.M(O,T,(U,B)=>U||this.l||this.j||(B=B||"",this.v[B])?I(null):(this.v[B]=!0,E.Promises.readdir(O).then(he=>{if(this.l||this.j)return I(null);this.I(n,z,he,v,x=>I(x||null))},he=>{I(null)})))):(this.p++,z===this.b||this.h&&D.$Df(j.size)&&j.size>this.h||this.J(v,{base:w.fsPath,relativePath:z,searchPath:this.N(n,z)}),I(null,void 0)))})},b=>{const I=b&&A.$Hb(b);return C(I&&I.length>0?I[0]:void 0)})}J(n,r){this.K(r)&&(!this.d||this.d(r.relativePath,l.$nc(r.relativePath)))&&(this.k++,(this.g||this.f&&this.k>this.f)&&(this.j=!0),this.j||n(r))}K(n){if(this.b){if(this.b==="*")return!0;if(this.c)return(0,h.$8I)(n,this.c)}return!0}L(n,r,o){return r.isSymbolicLink()?M.stat(n,o):o(null,r)}M(n,r,o){return r.isSymbolicLink()?M.realpath(n,(v,C)=>v?o(v):o(null,C)):o(null,n)}N(n,r){return n.folderName?l.$jc(n.folderName,r):r}}e.$8ec=f;class a{constructor(n){this.a=n.folderQueries,this.b=n.extraFileResources||[],this.c=new f(n)}search(n,r,o){this.c.walk(this.a,this.b,n,r,(v,C)=>{o(v,{limitHit:C,stats:this.c.getStats(),messages:[]})})}cancel(){this.c.cancel()}}e.$9ec=a;class t{constructor(n,r){this.expression=n,this.c=r,this.d(n)}d(n){let r,o;Object.keys(n).filter(v=>n[v]).forEach(v=>{l.$ic(v)?(r=r||k.$sj(),r[v]=n[v]):(o=o||k.$sj(),o[v]=n[v])}),this.a=r&&k.$xj(r,{trimForExclusions:!0}),this.b=o&&k.$xj(o,{trimForExclusions:!0})}test(n,r,o){return this.b&&this.b(n,r,o)||this.a&&this.a(l.$jc(this.c,n),r,o)}getBasenameTerms(){const n=[];return this.a&&n.push(...k.$zj(this.a)),this.b&&n.push(...k.$zj(this.b)),n}getPathTerms(){const n=[];return this.a&&n.push(...k.$Aj(this.a)),this.b&&n.push(...k.$Aj(this.b)),n}}function i(s){const n=s.trim().split(`
`),r=n[0].trim();if(r.startsWith("Error parsing regex"))return r;if(r.startsWith("regex parse error"))return S.$rf(n[n.length-1].trim());if(r.startsWith("error parsing glob")||r.startsWith("unsupported encoding"))return r.charAt(0).toUpperCase()+r.substr(1);if(r==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(r.startsWith("Literal "))return r}}),define(De[363],Ce([1,0,98,22,164,21]),function(re,e,y,M,l,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RC=e.$QC=e.$PC=e.$OC=e.$NC=e.$MC=e.$LC=e.$KC=e.$JC=e.DecodeStreamErrorKind=e.$IC=e.$HC=e.$GC=e.$FC=e.$EC=e.$DC=e.$CC=e.$BC=void 0,e.$BC="utf8",e.$CC="utf8bom",e.$DC="utf16be",e.$EC="utf16le";function A(r){return[e.$BC,e.$CC,e.$DC,e.$EC].some(o=>o===r)}e.$FC=A,e.$GC=[254,255],e.$HC=[255,254],e.$IC=[239,187,191];const g=512,k=512,$=512*8,R=512*128;var P;(function(r){r[r.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(P||(e.DecodeStreamErrorKind=P={}));class p extends Error{constructor(o,v){super(o),this.decodeStreamErrorKind=v}}e.$JC=p;class S{static async create(o){let v;if(o!==e.$BC)v=(await(0,l.$AC)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getDecoder(u(o));else{const C=new TextDecoder;v={write(w){return C.decode(w,{stream:!0})},end(){return C.decode()}}}return new S(v)}constructor(o){this.a=o}write(o){return this.a.write(o)}end(){return this.a.end()}}function D(r,o){const v=o.minBytesRequiredForDetection??o.guessEncoding?$:k;return new Promise((C,w)=>{const m=(0,y.$3d)(T=>T.join("")),b=[];let I=0,z;const O=new L.$Yd,F=async()=>{try{const T=await n({buffer:M.$ce.concat(b),bytesRead:I},o.guessEncoding);if(T.seemsBinary&&o.acceptTextOnly)throw new p("Stream is binary but only text is accepted for decoding",1);T.encoding=await o.overwriteEncoding(T.encoding),z=await S.create(T.encoding);const N=z.write(M.$ce.concat(b).buffer);m.write(N),b.length=0,I=0,C({stream:m,detected:T})}catch(T){O.cancel(),m.destroy(),w(T)}};(0,y.$7d)(r,{onData:async T=>{z?m.write(z.write(T.buffer)):(b.push(T),I+=T.byteLength,I>=v&&(r.pause(),await F(),setTimeout(()=>r.resume())))},onError:T=>m.error(T),onEnd:async()=>{z||await F(),m.end(z?.end())}},O.token)})}e.$KC=D;async function E(r,o,v){const w=(await(0,l.$AC)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getEncoder(u(o),v);let m=!1,b=!1;return{read(){if(b)return null;const I=r.read();if(typeof I!="string"){if(b=!0,!m&&v?.addBOM)switch(o){case e.$BC:case e.$CC:return M.$ce.wrap(Uint8Array.from(e.$IC));case e.$DC:return M.$ce.wrap(Uint8Array.from(e.$GC));case e.$EC:return M.$ce.wrap(Uint8Array.from(e.$HC))}const z=w.end();return z&&z.length>0?(m=!0,M.$ce.wrap(z)):null}return m=!0,M.$ce.wrap(w.write(I))}}}e.$LC=E;async function h(r){return(await(0,l.$AC)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).encodingExists(u(r))}e.$MC=h;function u(r){return r===e.$CC||r===null?e.$BC:r}e.$NC=u;function d(r,o){if(!r||o<e.$GC.length)return null;const v=r.readUInt8(0),C=r.readUInt8(1);if(v===e.$GC[0]&&C===e.$GC[1])return e.$DC;if(v===e.$HC[0]&&C===e.$HC[1])return e.$EC;if(o<e.$IC.length)return null;const w=r.readUInt8(2);return v===e.$IC[0]&&C===e.$IC[1]&&w===e.$IC[2]?e.$CC:null}e.$OC=d;const c=["ascii","utf-16","utf-32"];async function f(r){const o=await(0,l.$AC)("jschardet","dist/jschardet.min.js"),v=r.slice(0,R),C=i(v.buffer),w=o.detect(C);if(!w||!w.encoding)return null;const m=w.encoding.toLowerCase();return 0<=c.indexOf(m)?null:t(w.encoding)}const a={ibm866:"cp866",big5:"cp950"};function t(r){const o=r.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return a[o]||o}function i(r){let o="";for(let v=0;v<r.length;v++)o+=String.fromCharCode(r[v]);return o}function s(r){switch(r){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const o=r.match(/windows(\d+)/);return o?"windows-"+o[1]:r}}}e.$PC=s;function n({buffer:r,bytesRead:o},v){let C=d(r,o),w=!1;if(C!==e.$DC&&C!==e.$EC&&r){let m=!0,b=!0,I=!1;for(let z=0;z<o&&z<g;z++){const O=z%2===1,F=r.readUInt8(z)===0;if(F&&(I=!0),m&&(O&&!F||!O&&F)&&(m=!1),b&&(O&&F||!O&&!F)&&(b=!1),F&&!m&&!b)break}I&&(m?C=e.$EC:b?C=e.$DC:w=!0)}return v&&!w&&!C&&r?f(r.slice(0,o)).then(m=>({seemsBinary:!1,encoding:m})):{seemsBinary:w,encoding:C}}e.$QC=n,e.$RC={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(De[155],Ce([1,0,363,29,154]),function(re,e,y,M,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$efc=void 0;class L extends l.$5dc{constructor(g,k,$=M,R="searchProcess"){super(g,k,{readdir:P=>$.Promises.readdir(P.fsPath),toCanonicalName:P=>(0,y.$PC)(P)},R)}}e.$efc=L}),define(De[156],Ce([1,0,49,379,362,19,74,36,15,16,2,37,92,380,360,117]),function(re,e,y,M,l,L,A,g,k,$,R,P,p,S,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dfc=e.$cfc=e.$bfc=e.$afc=e.$_ec=e.$$ec=e.$0ec=void 0;const h=D.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class u{constructor(b){this.a=b}provideTextSearchResults(b,I,z,O){return this.a.appendLine(`provideTextSearchResults ${b.pattern}, ${JSON.stringify({...I,folder:I.folder.toString()})}`),new Promise((F,T)=>{O.onCancellationRequested(()=>Z());const N=i(b,I),j=I.folder.fsPath,U=N.map(fe=>fe.match(/^-/)?fe:`'${fe}'`).join(" ");this.a.appendLine(`${h} ${U}
 - cwd: ${j}`);let B=y.spawn(h,N,{cwd:j});B.on("error",fe=>{console.error(fe),this.a.appendLine("Error: "+(fe&&fe.message)),T((0,P.$4I)(new P.$2I(fe&&fe.message,P.SearchErrorCode.rgProcessError)))});let he=!1;const x=new f(I.maxResults,j,I.previewOptions);x.on("result",fe=>{he=!0,_="",z.report(fe)});let Q=!1;const Z=()=>{Q=!0,B?.kill(),x?.cancel()};let ie=!1;x.on("hitLimit",()=>{ie=!0,Z()});let _="";B.stdout.on("data",fe=>{x.handleData(fe),he||(_+=fe)});let oe=!1;B.stdout.once("data",()=>oe=!0);let ye="";B.stderr.on("data",fe=>{const V=fe.toString();this.a.appendLine(V),ye.length+V.length<1e6&&(ye+=V)}),B.on("close",()=>{if(this.a.appendLine(oe?"Got data from stdout":"No data from stdout"),this.a.appendLine(he?"Got result from parser":"No result from parser"),_&&this.a.appendLine(`Got data without result: ${_}`),this.a.appendLine(""),Q)F({limitHit:ie});else{x.flush(),B=null;let fe;ye&&!oe&&(fe=d(ye))?T((0,P.$4I)(new P.$2I(fe.message,fe.code))):F({limitHit:ie})}})})}}e.$0ec=u;function d(m){const b=m.split(`
`),I=b[0].trim();if(b.some(O=>O.startsWith("regex parse error")))return new P.$2I(c(b),P.SearchErrorCode.regexParseError);const z=I.match(/grep config error: unknown encoding: (.*)/);if(z)return new P.$2I(`Unknown encoding: ${z[1]}`,P.SearchErrorCode.unknownEncoding);if(I.startsWith("error parsing glob"))return new P.$2I(I.charAt(0).toUpperCase()+I.substr(1),P.SearchErrorCode.globParseError);if(I.startsWith("the literal"))return new P.$2I(I.charAt(0).toUpperCase()+I.substr(1),P.SearchErrorCode.invalidLiteral);if(I.startsWith("PCRE2: error compiling pattern"))return new P.$2I(I,P.SearchErrorCode.regexParseError)}function c(m){const b=["Regex parse error"],I=m.filter(z=>z.startsWith("PCRE2:"));if(I.length>=1){const z=I[0].replace("PCRE2:","");if(z.indexOf(":")!==-1&&z.split(":").length>=2){const O=z.split(":")[1];b.push(":"+O)}}return b.join("")}class f extends M.EventEmitter{constructor(b,I,z){super(),this.g=b,this.h=I,this.j=z,this.a="",this.b=!1,this.c=!1,this.f=0,this.d=new l.StringDecoder}cancel(){this.b=!0}flush(){this.k(this.d.end())}on(b,I){return super.on(b,I),this}handleData(b){if(this.b)return;const I=typeof b=="string"?b:this.d.write(b);this.k(I)}k(b){let I=b.indexOf(`
`);const z=this.a+b;if(I>=0)I+=this.a.length;else{this.a=z;return}let O=0;for(;I>=0;)this.m(z.substring(O,I).trim()),O=I+1,I=z.indexOf(`
`,O);this.a=z.substring(O)}m(b){if(this.b||!b)return;let I;try{I=JSON.parse(b)}catch{throw new Error(`malformed line from rg: ${b}`)}if(I.type==="match"){const z=a(I.data.path),O=R.URI.file(k.$jc(this.h,z)),F=this.n(I.data,O);this.p(F),this.c&&(this.cancel(),this.emit("hitLimit"))}else if(I.type==="context"){const z=a(I.data.path),O=R.URI.file(k.$jc(this.h,z));this.o(I.data,O).forEach(T=>this.p(T))}}n(b,I){const z=b.line_number-1,O=a(b.lines),F=Buffer.from(O);let T=0,N=0,j=z;b.submatches.length===0&&b.submatches.push(O.length?{start:0,end:1,match:{text:O[0]}}:{start:0,end:0,match:{text:""}});const U=(0,L.$Hb)(b.submatches.map((B,he)=>{if(this.c)return null;this.f++,this.f>=this.g&&(this.c=!0);const x=a(B.match),Q=F.slice(T,B.start).toString(),Z=t(Q),ie=Z.numLines>0?Z.lastLineLength:Z.lastLineLength+N,_=t(x),oe=Z.numLines+j,ye=_.numLines+oe,fe=_.numLines>0?_.lastLineLength:_.lastLineLength+ie;return T=B.end,N=fe,j=ye,new p.$LI(oe,ie,ye,fe)}));return(0,E.$3ec)(I,O,U,this.j)}o(b,I){const z=a(b.lines),O=b.line_number;return z.replace(/\r?\n$/,"").split(`
`).map((F,T)=>({text:F,uri:I,lineNumber:O+T}))}p(b){this.emit("result",b)}}e.$$ec=f;function a(m){return m.bytes?Buffer.from(m.bytes,"base64").toString():m.text}function t(m){const b=/\n/g;let I=0,z=-1,O;for(;O=b.exec(m);)I++,z=O.index;const F=z>=0?m.length-z-1:m.length;return{numLines:I,lastLineLength:F}}function i(m,b){const I=["--hidden","--no-require-git"];I.push(m.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:z,otherIncludes:O}=(0,A.$D)(b.includes,T=>T.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(O&&O.length){const T=new Set;O.forEach(N=>{T.add(N)}),I.push("-g","!*"),T.forEach(N=>{s(N).map(E.$2ec).forEach(j=>{I.push("-g",j)})})}z&&z.length&&z.forEach(T=>{I.push("-g",T)}),b.excludes.map(E.$2ec).forEach(T=>I.push("-g",`!${T}`)),b.maxFileSize&&I.push("--max-filesize",b.maxFileSize+""),b.useIgnoreFiles?b.useParentIgnoreFiles||I.push("--no-ignore-parent"):I.push("--no-ignore"),b.followSymlinks&&I.push("--follow"),b.encoding&&b.encoding!=="utf8"&&I.push("--encoding",b.encoding),m.pattern==="--"&&(m.isRegExp=!0,m.pattern="\\-\\-"),m.isMultiline&&!m.isRegExp&&(m.pattern=(0,$.$Ge)(m.pattern),m.isRegExp=!0),b.usePCRE2&&I.push("--pcre2"),I.push("--crlf"),m.isRegExp&&(m.pattern=n(m.pattern),I.push("--engine","auto"));let F;if(m.isWordMatch){const N=(0,$.$Oe)(m.pattern,!!m.isRegExp,{wholeWord:m.isWordMatch}).source.replace(/\\\//g,"/");I.push("--regexp",N)}else if(m.isRegExp){let T=o(m.pattern);T=v(T),I.push("--regexp",T)}else F=m.pattern,I.push("--fixed-strings");return I.push("--no-config"),b.useGlobalIgnoreFiles||I.push("--no-ignore-global"),I.push("--json"),m.isMultiline&&I.push("--multiline"),b.beforeContext&&I.push("--before-context",b.beforeContext+""),b.afterContext&&I.push("--after-context",b.afterContext+""),I.push("--"),F&&I.push(F),I.push("."),I}e.$_ec=i;function s(m){return w(m).flatMap(I=>{const z=(0,g.$vj)(I,"/");return z.map((O,F)=>z.slice(0,F+1).join("/"))})}function n(m){const b=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;m.match(b);)m=m.replace(b,"$1\\x{$2}");const I=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;m.match(I);)m=m.replace(I,"$1\\x{$2}");return m}e.$afc=n;const r=m=>m.type==="Assertion"&&m.kind==="lookbehind";function o(m){let b;try{b=new S.RegExpParser().parsePattern(m)}catch{return m}let I="",z=0;const O=(N,j,U)=>{I+=m.slice(z,N)+U,z=j},F=[];return new S.RegExpVisitor({onCharacterEnter(N){if(N.raw!=="\\n")return;const j=F[0];if(!j)O(N.start,N.end,"\\r?\\n");else if(!F.some(r))if(j.type==="CharacterClass")if(j.negate){const U=m.slice(j.start+2,N.start)+m.slice(N.end,j.end-1);j.parent?.type==="Quantifier"?O(j.start,j.end,U?`[^${U}]`:"."):O(j.start,j.end,"(?!\\r?\\n"+(U?`|[${U}]`:"")+")")}else{const U=m.slice(j.start+1,N.start)+m.slice(N.end,j.end-1);O(j.start,j.end,U===""?"\\r?\\n":`(?:[${U}]|\\r?\\n)`)}else j.type==="Quantifier"&&O(N.start,N.end,"(?:\\r?\\n)")},onQuantifierEnter(N){F.unshift(N)},onQuantifierLeave(){F.shift()},onCharacterClassRangeEnter(N){F.unshift(N)},onCharacterClassRangeLeave(){F.shift()},onCharacterClassEnter(N){F.unshift(N)},onCharacterClassLeave(){F.shift()},onAssertionEnter(N){r(N)&&F.push(N)},onAssertionLeave(N){F[0]===N&&F.shift()}}).visit(b),I+=m.slice(z),I}e.$bfc=o;function v(m){return m.replace(/\n/g,"\\r?\\n")}e.$cfc=v;function C(m){let b=!1,I=!1,z="",O="";for(let F=0;F<m.length;F++){const T=m[F];switch(T){case"\\":I?(b?O+="\\"+T:z+="\\"+T,I=!1):I=!0;break;case"{":if(I)b?O+=T:z+=T,I=!1;else{if(b)return{strInBraces:z+"{"+O+"{"+m.substring(F+1)};b=!0}break;case"}":if(I)b?O+=T:z+=T,I=!1;else{if(b)return{fixedStart:z,strInBraces:O,fixedEnd:m.substring(F+1)};z+=T}break;default:b?O+=(I?"\\":"")+T:z+=(I?"\\":"")+T,I=!1;break}}return{strInBraces:z+(b?"{"+O:"")}}function w(m){const{fixedStart:b,strInBraces:I,fixedEnd:z}=C(m);if(b===void 0||z===void 0)return[I];let O=(0,g.$vj)(I,",");O.length||(O=[""]);const F=w(z);return O.flatMap(T=>{const N=b+T;return F.map(j=>N+j)})}e.$dfc=w}),define(De[364],Ce([1,0,21,156,64,18]),function(re,e,y,M,l,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hfc=void 0;class A{constructor($){this.b=$,this.a=new Set,process.once("exit",()=>this.d())}provideTextSearchResults($,R,P,p){const S=new M.$0ec(this.b);if(R.folder.scheme===L.Schemas.vscodeUserData){const D={...R,folder:R.folder.with({scheme:L.Schemas.file})},E=new l.$0u(h=>P.report({...h,uri:h.uri.with({scheme:R.folder.scheme})}));return this.c(p,h=>S.provideTextSearchResults($,D,E,h))}else return this.c(p,D=>S.provideTextSearchResults($,R,P,D))}async c($,R){const P=g($);this.a.add(P);const p=await R(P.token);return this.a.delete(P),p}d(){this.a.forEach($=>$.cancel())}}e.$hfc=A;function g(k){const $=new y.$Yd;return k.onCancellationRequested(()=>$.cancel()),$}}),define(De[365],Ce([1,0,29,156,155]),function(re,e,y,M,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ffc=void 0;class L{constructor(k){this.a=k}search(k,$,R){if((!this.a.folderQueries||!this.a.folderQueries.length)&&(!this.a.extraFileResources||!this.a.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const P={appendLine(S){R({message:S})}},p=new l.$efc(this.a,new M.$0ec(P),y);return new Promise((S,D)=>p.search(E=>{$(E.map(A))},k).then(E=>S({limitHit:E.limitHit,type:"success",stats:E.stats}),D))}}e.$ffc=L;function A(g){return{path:g.resource&&g.resource.fsPath,results:g.results,numMatches:(g.results||[]).reduce((k,$)=>{if($.ranges){const R=$;return k+(Array.isArray(R.ranges)?R.ranges.length:1)}else return k+1},0)}}}),define(De[366],Ce([1,0,19,8,9,4,124,15,35,2,30,37,361,365]),function(re,e,y,M,l,L,A,g,k,$,R,P,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gfc=void 0;class D{constructor(f="searchProcess"){this.d=f,this.b=Object.create(null)}fileSearch(f){let a;const t=u(f),i=new L.$Od({onDidAddFirstListener:()=>{a=(0,M.$Ig)(s=>this.doFileSearchWithEngine(p.$9ec,t,n=>i.fire(n),s)),a.then(s=>i.fire(s),s=>i.fire({type:"error",error:{message:s.message,stack:s.stack}}))},onDidRemoveLastListener:()=>{a.cancel()}});return i.event}textSearch(f){let a;const t=u(f),i=new L.$Od({onDidAddFirstListener:()=>{a=(0,M.$Ig)(s=>this.f(t,n=>i.fire(n),s)),a.then(s=>i.fire(s),s=>i.fire({type:"error",error:{message:s.message,stack:s.stack}}))},onDidRemoveLastListener:()=>{a.cancel()}});return i.event}f(f,a,t){return f.maxFileSize=this.g().maxFileSize,new S.$ffc(f).search(t,a,a)}g(){return{maxFileSize:16*R.$Hk.GB}}doFileSearch(f,a,t){return this.doFileSearchWithEngine(p.$9ec,f,a,t)}doFileSearchWithEngine(f,a,t,i,s=D.a){let n=0;const r=v=>{Array.isArray(v)?(n+=v.length,t(v.map(C=>this.h(C)))):v.relativePath?(n++,t(this.h(v))):t(v)};if(a.sortByScore){let v=this.l(a,r,i);if(!v){const C=a.maxResults?Object.assign({},a,{maxResults:null}):a,w=new f(C);v=this.j(w,a,t,r,i)}return new Promise((C,w)=>{v.then(([m,b])=>{const I=b.map(z=>this.h(z));this.o(I,t,s),C(m)},w)})}const o=new f(a);return this.r(o,r,s,i).then(v=>({limitHit:v.limitHit,type:"success",stats:{detailStats:v.stats,type:this.d,fromCache:!1,resultCount:n,sortingTime:void 0}}))}h(f){return{path:f.base?(0,g.$jc)(f.base,f.relativePath):f.relativePath}}j(f,a,t,i,s){const n=new L.$Od;let r=(0,M.$Ig)(v=>{let C=[];const w=m=>{Array.isArray(m)?C=m:(i(m),n.fire(m))};return this.r(f,w,-1,v).then(m=>[m,C])}),o;if(a.cacheKey){o=this.k(a.cacheKey);const v={promise:r,event:n.event,resolved:!1};o.resultsToSearchCache[a.filePattern||""]=v,r.then(()=>{v.resolved=!0},C=>{delete o.resultsToSearchCache[a.filePattern||""]}),r=this.s(r)}return r.then(([v,C])=>{const w=o?o.scorerCache:Object.create(null),m=(typeof a.maxResults!="number"||a.maxResults>0)&&k.$Kd.create(!1);return this.n(a,C,w,s).then(b=>{const I=m?m.elapsed():-1;return[{type:"success",stats:{detailStats:v.stats,sortingTime:I,fromCache:!1,type:this.d,workspaceFolderCount:a.folderQueries.length,resultCount:b.length},messages:v.messages,limitHit:v.limitHit||typeof a.maxResults=="number"&&C.length>a.maxResults},b]})})}k(f){const a=this.b[f];return a||(this.b[f]=new E)}l(f,a,t){const i=f.cacheKey&&this.b[f.cacheKey];if(!i)return;const s=this.q(i,f.filePattern||"",a,t);if(s)return s.then(([n,r,o])=>{const v=k.$Kd.create(!1);return this.n(f,r,i.scorerCache,t).then(C=>{const w=v.elapsed(),m={fromCache:!0,detailStats:o,type:this.d,resultCount:r.length,sortingTime:w};return[{type:"success",limitHit:n.limitHit||typeof f.maxResults=="number"&&r.length>f.maxResults,stats:m},C]})})}n(f,a,t,i){const s=(0,A.$Dq)(f.filePattern||""),n=(o,v)=>(0,A.$Cq)(o,v,s,!0,h,t),r=typeof f.maxResults=="number"?f.maxResults:Number.MAX_VALUE;return y.$Gb(a,n,r,1e4,i)}o(f,a,t){if(t&&t>0)for(let i=0;i<f.length;i+=t)a(f.slice(i,i+t));else a(f)}q(f,a,t,i){const s=k.$Kd.create(!1),n=a.indexOf(g.sep)>=0;let r;for(const w in f.resultsToSearchCache)if(a.startsWith(w)){if(n&&w.indexOf(g.sep)<0&&w!=="")continue;const m=f.resultsToSearchCache[w];r={promise:this.s(m.promise),event:m.event,resolved:m.resolved};break}if(!r)return null;const o=s.elapsed(),v=k.$Kd.create(!1),C=r.event(t);return i&&i.onCancellationRequested(()=>{C.dispose()}),r.promise.then(([w,m])=>{if(i&&i.isCancellationRequested)throw(0,l.$6)();const b=[],I=(0,A.$Dq)(a).normalizedLowercase;for(const z of m)(0,P.$8I)(z,I)&&b.push(z);return[w,b,{cacheWasResolved:r.resolved,cacheLookupTime:o,cacheFilterTime:v.elapsed(),cacheEntryCount:m.length}]})}r(f,a,t,i){return new Promise((s,n)=>{let r=[];i?.onCancellationRequested(()=>f.cancel()),f.search(o=>{o&&(t?(r.push(o),t>0&&r.length>=t&&(a(r),r=[])):a(o))},o=>{a(o)},(o,v)=>{r.length&&a(r),o?n(o):s(v)})})}clearCache(f){return delete this.b[f],Promise.resolve(void 0)}s(f){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(a,t){return f.then(a,t)}catch(a){return this.then(void 0,a)}finally(a){return f.finally(a)}}}}e.$gfc=D,D.a=512;class E{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const h=new class{getItemLabel(c){return(0,g.$nc)(c.relativePath)}getItemDescription(c){return(0,g.$mc)(c.relativePath)}getItemPath(c){return c.relativePath}};function u(c){return{...c,folderQueries:c.folderQueries&&c.folderQueries.map(d),extraFileResources:c.extraFileResources&&c.extraFileResources.map(f=>$.URI.revive(f))}}function d(c){return{...c,folder:$.URI.revive(c.folder)}}}),define(De[367],Ce([1,0,3,18,2,29,14,27,20,95,67,37,366,364,117,155]),function(re,e,y,M,l,L,A,g,k,$,R,P,p,S,D,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ifc=void 0;let h=class extends $.$0dc{constructor(d,c,f,a){super(d,f,a),this.s=L,this.t=-1,this.v=null,this.w=!1,this.x=new y.$Rc;const t=new D.$4ec("RipgrepSearchUD",this.n);this.x.add(this.registerTextSearchProvider(M.Schemas.vscodeUserData,new S.$hfc(t))),c.remote.isRemote&&c.remote.authority&&this.y()}dispose(){this.x.dispose()}$enableExtensionHostSearch(){this.y()}y(){if(this.w)return;this.w=!0;const d=new D.$4ec("RipgrepSearchEH",this.n);this.x.add(this.registerTextSearchProvider(M.Schemas.file,new S.$hfc(d))),this.x.add(this.z(M.Schemas.file,new p.$gfc("fileSearchProvider")))}z(d,c){const f=this.d++;return this.v=c,this.t=f,this.c.$registerFileSearchProvider(f,this.o(d)),(0,y.$Qc)(()=>{this.v=null,this.c.$unregisterProvider(f)})}$provideFileSearchResults(d,c,f,a){const t=(0,$.$$dc)(f);return d===this.t?this.A(d,c,t,a):super.$provideFileSearchResults(d,c,f,a)}A(d,c,f,a){const t=i=>{if((0,P.$7I)(i)&&(i=[i]),Array.isArray(i)){this.c.$handleFileMatch(d,c,i.map(s=>l.URI.file(s.path)));return}i.message&&this.n.debug("ExtHostSearch",i.message)};if(!this.v)throw new Error("No internal file search handler");return this.v.doFileSearch(f,t,a)}$clearCache(d){return this.v?.clearCache(d),super.$clearCache(d)}q(d,c){return new E.$efc(d,c,void 0,"textSearchProvider")}};e.$ifc=h,e.$ifc=h=He([We(0,k.$rM),We(1,g.$HM),We(2,R.$Pcc),We(3,A.$$i)],h)}),define(De[118],Ce([1,0,381,62,61,382,22,9,4,3,15,12,31,81,82]),function(re,e,y,M,l,L,A,g,k,$,R,P,p,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mh=e.$Lh=e.$Kh=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.$Fh=void 0;class E{traceSocketEvent(m,b){D.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,m,b)}constructor(m,b=""){this.f=!0,this.debugLabel=b,this.socket=m,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=I=>{if(this.traceSocketEvent("error",{code:I?.code,message:I?.message}),I){if(I.code==="EPIPE")return;(0,g.$1)(I)}},this.socket.on("error",this.a),this.b=I=>{this.traceSocketEvent("close",{hadError:I}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(m){const b=I=>{this.traceSocketEvent("read",I),m(A.$ce.wrap(I))};return this.socket.on("data",b),{dispose:()=>this.socket.off("data",b)}}onClose(m){const b=I=>{m({type:0,hadError:I,error:void 0})};return this.socket.on("close",b),{dispose:()=>this.socket.off("close",b)}}onEnd(m){const b=()=>{m()};return this.socket.on("end",b),{dispose:()=>this.socket.off("end",b)}}write(m){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",m),this.socket.write(m.buffer,b=>{if(b){if(b.code==="EPIPE")return;(0,g.$1)(b)}})}catch(b){if(b.code==="EPIPE")return;(0,g.$1)(b)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((m,b)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),m();return}const I=()=>{this.socket.off("close",I),this.socket.off("end",I),this.socket.off("error",I),this.socket.off("timeout",I),this.socket.off("drain",I),this.traceSocketEvent("nodeDrainEnd"),m()};this.socket.on("close",I),this.socket.on("end",I),this.socket.on("error",I),this.socket.on("timeout",I),this.socket.on("drain",I)})}}e.$Fh=E;var h;(function(w){w[w.MinHeaderByteSize=2]="MinHeaderByteSize",w[w.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(h||(h={}));var u;(function(w){w[w.PeekHeader=1]="PeekHeader",w[w.ReadHeader=2]="ReadHeader",w[w.ReadBody=3]="ReadBody",w[w.Fin=4]="Fin"})(u||(u={}));class d extends $.$Sc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(m,b){this.socket.traceSocketEvent(m,b)}constructor(m,b,I,z){super(),this.f=this.B(new k.$Od),this.g=this.B(new k.$Od),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=m,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:b,inflateBytesLength:I?.byteLength||0,recordInflateBytes:z}),this.a=this.B(new c(this,b,I,z,this.f,(O,F)=>this.m(O,F))),this.B(this.a.onError(O=>{console.error(O),(0,g.$1)(O),this.g.fire({type:0,hadError:!0,error:O})})),this.b=new D.$Ah,this.B(this.socket.onData(O=>this.n(O))),this.B(this.socket.onClose(async O=>{this.a.isProcessingReadQueue()&&await k.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(O)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(m){return this.f.event(m)}onClose(m){return this.g.event(m)}onEnd(m){return this.socket.onEnd(m)}write(m){let b=0;for(;b<m.byteLength;)this.a.writeMessage(m.slice(b,Math.min(b+262144,m.byteLength)),{compressed:!0,opcode:2}),b+=262144}m(m,{compressed:b,opcode:I}){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",m);let z=2;m.byteLength<126?z+=0:m.byteLength<2**16?z+=2:z+=8;const O=A.$ce.alloc(z),F=b?64:0,T=I&15;if(O.writeUInt8(128|F|T,0),m.byteLength<126)O.writeUInt8(m.byteLength,1);else if(m.byteLength<2**16){O.writeUInt8(126,1);let N=1;O.writeUInt8(m.byteLength>>>8&255,++N),O.writeUInt8(m.byteLength>>>0&255,++N)}else{O.writeUInt8(127,1);let N=1;O.writeUInt8(0,++N),O.writeUInt8(0,++N),O.writeUInt8(0,++N),O.writeUInt8(0,++N),O.writeUInt8(m.byteLength>>>24&255,++N),O.writeUInt8(m.byteLength>>>16&255,++N),O.writeUInt8(m.byteLength>>>8&255,++N),O.writeUInt8(m.byteLength>>>0&255,++N)}this.socket.write(A.$ce.concat([O,m]))}end(){this.h=!0,this.socket.end()}n(m){if(m.byteLength!==0){for(this.b.acceptChunk(m);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const b=this.b.peek(this.j.readLen),I=b.readUInt8(0),z=(I&128)>>>7,O=(I&64)>>>6,F=I&15,T=b.readUInt8(1),N=(T&128)>>>7,j=T&127;this.j.state=2,this.j.readLen=2+(N?4:0)+(j===126?2:0)+(j===127?8:0),this.j.fin=z,this.j.firstFrameOfMessage&&(this.j.compressed=!!O),this.j.firstFrameOfMessage=!!z,this.j.mask=0,this.j.opcode=F,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===2){const b=this.b.read(this.j.readLen),I=b.readUInt8(1),z=(I&128)>>>7;let O=I&127,F=1;O===126?O=b.readUInt8(++F)*2**8+b.readUInt8(++F):O===127&&(O=b.readUInt8(++F)*0+b.readUInt8(++F)*0+b.readUInt8(++F)*0+b.readUInt8(++F)*0+b.readUInt8(++F)*2**24+b.readUInt8(++F)*2**16+b.readUInt8(++F)*2**8+b.readUInt8(++F));let T=0;z&&(T=b.readUInt8(++F)*2**24+b.readUInt8(++F)*2**16+b.readUInt8(++F)*2**8+b.readUInt8(++F)),this.j.state=3,this.j.readLen=O,this.j.mask=T,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===3){const b=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",b),t(b,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",b),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(b,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(b,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await k.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$Gh=d;class c extends $.$Sc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:A.$ce.alloc(0)}constructor(m,b,I,z,O,F){super(),this.n=m,this.r=O,this.s=F,this.a=this.B(new k.$Od),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new k.$Od),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new k.$Od),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,b?(this.b=this.B(new f(this.n,z,I,{windowBits:15})),this.f=this.B(new a(this.n,{windowBits:15})),this.B(this.b.onError(T=>this.a.fire(T))),this.B(this.f.onError(T=>this.a.fire(T)))):(this.b=null,this.f=null)}writeMessage(m,b){this.g.push({data:m,options:b}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:m,options:b}=this.g.shift();if(this.f&&b.compressed){const I=await this.w(this.f,m);this.s(I,b)}else this.s(m,{...b,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(m,b){return new Promise((I,z)=>{m.write(b),m.flush(O=>I(O))})}acceptFrame(m,b,I){this.h.push({data:m,isCompressed:b,isLastFrameOfMessage:I}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const m=this.h.shift();if(this.b&&m.isCompressed){const b=await this.C(this.b,m.data,m.isLastFrameOfMessage);this.r.fire(b)}else this.r.fire(m.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(m,b,I){return new Promise((z,O)=>{m.write(b),I&&m.write(A.$ce.fromByteArray([0,0,255,255])),m.flush(F=>z(F))})}}class f extends $.$Sc{get recordedInflateBytes(){return this.j?A.$ce.concat(this.f):A.$ce.alloc(0)}constructor(m,b,I,z){super(),this.h=m,this.j=b,this.a=this.B(new k.$Od),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,L.createInflateRaw)(z),this.b.on("error",O=>{this.h.traceSocketEvent("zlibInflateError",{message:O?.message,code:O?.code}),this.a.fire(O)}),this.b.on("data",O=>{this.h.traceSocketEvent("zlibInflateData",O),this.g.push(A.$ce.wrap(O))}),I&&(this.h.traceSocketEvent("zlibInflateInitialWrite",I.buffer),this.b.write(I.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(m){this.j&&this.f.push(m.clone()),this.h.traceSocketEvent("zlibInflateWrite",m),this.b.write(m.buffer)}flush(m){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const b=A.$ce.concat(this.g);this.g.length=0,m(b)})}}class a extends $.$Sc{constructor(m,b){super(),this.g=m,this.a=this.B(new k.$Od),this.onError=this.a.event,this.f=[],this.b=(0,L.createDeflateRaw)({windowBits:15}),this.b.on("error",I=>{this.g.traceSocketEvent("zlibDeflateError",{message:I?.message,code:I?.code}),this.a.fire(I)}),this.b.on("data",I=>{this.g.traceSocketEvent("zlibDeflateData",I),this.f.push(A.$ce.wrap(I))})}write(m){this.g.traceSocketEvent("zlibDeflateWrite",m.buffer),this.b.write(m.buffer)}flush(m){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let b=A.$ce.concat(this.f);this.f.length=0,b=b.slice(0,b.byteLength-4),m(b)})}}function t(w,m){if(m===0)return;const b=w.byteLength>>>2;for(let N=0;N<b;N++){const j=w.readUInt32BE(N*4);w.writeUInt32BE(j^m,N*4)}const I=b*4,z=w.byteLength-I,O=m>>>24&255,F=m>>>16&255,T=m>>>8&255;z>=1&&w.writeUInt8(w.readUInt8(I)^O,I),z>=2&&w.writeUInt8(w.readUInt8(I+1)^F,I+1),z>=3&&w.writeUInt8(w.readUInt8(I+2)^T,I+2)}e.$Hh=process.env.XDG_RUNTIME_DIR;const i={[2]:107,[1]:103};function s(){const w=(0,p.$fg)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${w}-sock`;const m=process.platform!=="darwin"&&e.$Hh?e.$Hh:(0,l.tmpdir)(),b=(0,R.$jc)(m,`vscode-ipc-${w}.sock`);return r(b),b}e.$Ih=s;function n(w,m,b){const I=(0,y.createHash)("md5").update(w).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${I}-${b}-${m}-sock`;const z=b.substr(0,4),O=m.substr(0,6),F=I.substr(0,8);let T;return process.platform!=="darwin"&&e.$Hh&&!process.env.VSCODE_PORTABLE?T=(0,R.$jc)(e.$Hh,`vscode-${F}-${z}-${O}.sock`):T=(0,R.$jc)(w,`${z}-${O}.sock`),r(T),T}e.$Jh=n;function r(w){const m=i[P.$o];typeof m=="number"&&w.length>=m&&console.warn(`WARNING: IPC handle "${w}" is longer than ${m} chars, try a shorter --user-data-dir`)}class o extends S.$uh{static b(m){const b=k.Event.fromNodeEventEmitter(m,"connection");return k.Event.map(b,I=>({protocol:new D.$Bh(new E(I,"ipc-server-connection")),onDidClientDisconnect:k.Event.once(k.Event.fromNodeEventEmitter(I,"close"))}))}constructor(m){super(o.b(m)),this.d=m}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$Kh=o;function v(w){return new Promise((m,b)=>{const I=(0,M.createServer)();I.on("error",b),I.listen(w,()=>{I.removeListener("error",b),m(new o(I))})})}e.$Lh=v;function C(w,m){return new Promise((b,I)=>{const z=(0,M.createConnection)(w,()=>{z.removeListener("error",I),b(D.$Ch.fromSocket(new E(z,`ipc-client${m}`),m))});z.once("error",I)})}e.$Mh=C}),define(De[368],Ce([1,0,62,61,166,118,8,3,12,50,14,136,248,249,106,86,22]),function(re,e,y,M,l,L,A,g,k,$,R,P,p,S,D,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$L8b=e.$K8b=e.$J8b=e.$I8b=void 0;async function u(t,i,s,n,r){let o;for(let v=3;v&&(o?.dispose(),o=await new d(t,i,s,n,r).waitForReady(),!(r&&l.$ig[r]||!l.$ig[o.tunnelLocalPort]));v--);return o}class d extends g.$Sc{constructor(i,s,n,r,o){super(),this.m=s,this.n=o,this.privacy=E.TunnelPrivacyId.Private,this.j=new Map,this.a=i,this.b=y.createServer(),this.c=new A.$Tg,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=v=>this.r(v),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=r,this.tunnelRemoteHost=n}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(s=>{s()})}async waitForReady(){const i=this.n??this.tunnelRemotePort,s=(0,E.$jv)(this.m)?"0.0.0.0":"127.0.0.1";let n=await(0,l.$jg)(i,2,1e3,s),r=null;return this.b.listen(n,this.m),await this.c.wait(),r=this.b.address(),r||(n=0,this.b.listen(n,this.m),await this.c.wait(),r=this.b.address()),this.tunnelLocalPort=r.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${r.port}`,this}async r(i){i.pause();const s=(0,E.$hv)(this.tunnelRemoteHost)||(0,E.$jv)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,n=await(0,p.$7k)(this.a,s,this.tunnelRemotePort),r=n.getSocket(),o=n.readEntireBuffer();n.dispose(),o.byteLength>0&&i.write(o.buffer),i.on("end",()=>{i.localAddress&&this.j.delete(i.localAddress),r.end()}),i.on("close",()=>r.end()),i.on("error",()=>{i.localAddress&&this.j.delete(i.localAddress),r instanceof L.$Fh?r.socket.destroy():r.end()}),r instanceof L.$Fh?this.t(i,r):this.s(i,r),i.localAddress&&this.j.set(i.localAddress,()=>{i.end(),r.end()})}s(i,s){s.onClose(()=>i.destroy()),s.onEnd(()=>i.end()),s.onData(n=>i.write(n.buffer)),i.on("data",n=>s.write(h.$ce.wrap(n))),i.resume()}t(i,s){const n=s.socket;n.on("end",()=>i.end()),n.on("close",()=>i.end()),n.on("error",()=>{i.destroy()}),n.pipe(i),i.pipe(n)}}e.$I8b=d;let c=class extends E.$mv{constructor(i,s,n,r,o){super(s,o),this.u=i,this.v=n,this.w=r}isPortPrivileged(i){return(0,E.$kv)(i,this.l,k.OS,M.release())}s(i,s,n,r,o,v,C,w){const m=this.r(s,n);if(m)return++m.refcount,m.value;if((0,E.$ev)(i))return this.t(i,s,n,o,v,C,w);{this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${s}:${n} on local port ${o}.`);const b={commit:this.w.commit,quality:this.w.quality,addressProvider:i,remoteSocketFactoryService:this.u,signService:this.v,logService:this.j,ipcLogger:null},I=u(b,r,s,n,o);return this.j.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.p(s,n,I),I}}};e.$J8b=c,e.$J8b=c=He([We(0,S.$1k),We(1,R.$$i),We(2,D.$4k),We(3,P.$qj),We(4,$.$ki)],c);let f=class extends c{constructor(i,s,n,r,o){super(i,s,n,r,o)}};e.$K8b=f,e.$K8b=f=He([We(0,S.$1k),We(1,R.$$i),We(2,D.$4k),We(3,P.$qj),We(4,$.$ki)],f);let a=class extends g.$Sc{constructor(i,s,n,r,o){super(),this.b=i,this.c=s,this.f=n,this.g=r,this.h=o,this.a=new Map}async openTunnel(i,s,n,r,o,v,C,w,m){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${n}:${r} on local port ${v}.`),!this.a.has(i)){const b=new f(this.b,this.c,this.g,this.f,this.h);this.B(b),this.a.set(i,b),b.onTunnelClosed(async()=>{(await b.tunnels).length===0&&(b.dispose(),this.a.delete(i))})}return this.a.get(i).openTunnel(s,n,r,o,v,C,w,m)}};e.$L8b=a,e.$L8b=a=He([We(0,S.$1k),We(1,R.$$i),We(2,P.$qj),We(3,D.$4k),We(4,$.$ki)],a)}),define(De[369],Ce([1,0,118,108,53,34,2,14,44]),function(re,e,y,M,l,L,A,g,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TM=e.$SM=void 0;class ${constructor(p,S,D){this.b=p,this.c=S,this.f=D,this.a=M.createServer((E,h)=>this.h(E,h)),this.g().catch(E=>(S.error(E),""))}get ipcHandlePath(){return this.f}async g(){try{this.a.listen(this.ipcHandlePath),this.a.on("error",p=>this.c.error(p))}catch{this.c.error("Could not start open from terminal server.")}return this.f}h(p,S){const D=(h,u)=>{S.writeHead(h,{"content-type":"application/json"}),S.end(JSON.stringify(u||null),d=>d&&this.c.error(d))},E=[];p.setEncoding("utf8"),p.on("data",h=>E.push(h)),p.on("end",async()=>{try{const h=JSON.parse(E.join(""));let u;switch(h.type){case"open":u=await this.i(h);break;case"openExternal":u=await this.j(h);break;case"status":u=await this.l(h);break;case"extensionManagement":u=await this.k(h);break;default:D(404,`Unknown message type: ${h.type}`);break}D(200,u)}catch(h){const u=h instanceof Error?h.message:JSON.stringify(h);D(500,u),this.c.error("Error while processing pipe request",h)}})}async i(p){const{fileURIs:S,folderURIs:D,forceNewWindow:E,diffMode:h,mergeMode:u,addMode:d,forceReuseWindow:c,gotoLineMode:f,waitMarkerFilePath:a,remoteAuthority:t}=p,i=[];if(Array.isArray(D))for(const o of D)try{i.push({folderUri:A.URI.parse(o)})}catch{}if(Array.isArray(S))for(const o of S)try{(0,k.$ji)(o)?i.push({workspaceUri:A.URI.parse(o)}):i.push({fileUri:A.URI.parse(o)})}catch{}const s=a?A.URI.file(a):void 0,r={forceNewWindow:E,diffMode:h,mergeMode:u,addMode:d,gotoLineMode:f,forceReuseWindow:c,preferNewWindow:!c&&!s&&!d,waitMarkerFileURI:s,remoteAuthority:t};this.b.executeCommand("_remoteCLI.windowOpen",i,r)}async j(p){for(const S of p.uris){const D=A.URI.parse(S),E=D.scheme==="file"?D:S;await this.b.executeCommand("_remoteCLI.openExternal",E)}}async k(p){const S=E=>E?.map(h=>/\.vsix$/i.test(h)?A.URI.parse(h):h),D={list:p.list,install:S(p.install),uninstall:S(p.uninstall),force:p.force};return await this.b.executeCommand("_remoteCLI.manageExtensions",D)}async l(p){return await this.b.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this.a.close(),this.f&&process.platform!=="win32"&&l.existsSync(this.f)&&l.unlinkSync(this.f)}}e.$SM=$;let R=class extends ${constructor(p,S){super(p,S,(0,y.$Ih)())}};e.$TM=R,e.$TM=R=He([We(0,L.$NM),We(1,g.$$i)],R)}),define(De[370],Ce([1,0,108,54,357,352,267,46,340,2,18,7,369,100,338,38,339]),function(re,e,y,M,l,L,A,g,k,$,R,P,p,S,D,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nfc=void 0;class u extends L.$Oec{k(){const f=this,a=globalThis._VSCODE_NODE_MODULES.module,t=a._load;a._load=function(r,o,v){return r=s(r),f.a.has(r)?f.a.get(r).load(r,$.URI.file((0,S.$aq)(o.filename)),C=>t.apply(this,[C,o,v])):t.apply(this,arguments)};const i=a._resolveLookupPaths;a._resolveLookupPaths=(n,r)=>i.call(this,s(n),r);const s=n=>{for(const r of f.b){const o=r(n);if(o){n=o;break}}return n}}}class d extends g.$ndc{constructor(){super(...arguments),this.extensionRuntime=P.ExtensionRuntime.Node}async tb(){this.h.createInstance(D.$lfc);const f=this.h.invokeFunction(l.$Kec);if(this.h.createInstance(k.$kfc),this.f.remote.isRemote&&this.f.remote.authority){const i=this.h.createInstance(p.$TM);process.env.VSCODE_IPC_HOOK_CLI=i.ipcHandlePath}this.h.createInstance(h.$mfc),await this.h.createInstance(u,f,{mine:this.J,all:this.L}).install(),M.mark("code/extHost/didInitAPI"),(async()=>{const i=process.env.VSCODE_IPC_HOOK_CLI,s=process.env.CODE_SERVER_SESSION_SOCKET;if(!i||!s)return;const r={workspace:this.h.invokeFunction(v=>v.get(E.$Scc).workspace),socketPath:i},o=JSON.stringify({entry:r});await new Promise((v,C)=>{const w={path:"/add-session",socketPath:s,method:"POST",headers:{"content-type":"application/json"}},m=y.request(w,b=>{b.on("error",C),b.on("end",()=>{try{b.statusCode===200?v():C(new Error("Unexpected status code: "+b.statusCode))}catch(I){C(I)}})});m.on("error",C),m.write(o),m.end()})})().catch(i=>{this.s.error(i)});const t=await this.m.getConfigProvider();await(0,A.$jfc)(this.j,t,this,this.s,this.z,this.f),M.mark("code/extHost/didInitProxyResolver")}ub(f){return f.main}async vb(f,a,t){if(a.scheme!==R.Schemas.file)throw new Error(`Cannot load URI: '${a}', must be of file-scheme`);let i=null;t.codeLoadingStart(),this.s.trace(`ExtensionService#loadCommonJSModule ${a.toString(!0)}`),this.s.flush();const s=f?.identifier.value;f&&await this.w.initializeLocalizedMessages(f);try{s&&M.mark(`code/extHost/willLoadExtensionCode/${s}`),i=re.__$__nodeRequire(a.fsPath)}finally{s&&M.mark(`code/extHost/didLoadExtensionCode/${s}`),t.codeLoadingStop()}return i}async $setRemoteEnvironment(f){if(this.f.remote.isRemote)for(const a in f){const t=f[a];t===null?delete process.env[a]:process.env[a]=t}}}e.$nfc=d}),define(De[371],Ce([1,0,49,22,4,3,121,12,23,2,29,14,247,65,106,86,368,27,20,73,348]),function(re,e,y,M,l,L,A,g,k,$,R,P,p,S,D,E,h,u,d,c,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vfc=e.$ufc=e.$tfc=e.$sfc=e.$rfc=e.$qfc=e.$pfc=e.$ofc=void 0;function a(m){const b=m.trim().split(`
`),I=[];return b.forEach(O=>{const F=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(O);F&&F.length>=3&&I.push({pid:parseInt(F[1],10),socket:parseInt(F[2],10)})}),I.reduce((O,F)=>(O[F.socket]=F,O),{})}e.$ofc=a;function t(...m){const b=[].concat(...m.map(s));return[...new Map(b.filter(I=>I.st==="0A").map(I=>{const z=I.local_address.split(":");return{socket:parseInt(I.inode,10),ip:i(z[0]),port:parseInt(z[1],16)}}).map(I=>[I.ip+":"+I.port,I])).values()]}e.$pfc=t;function i(m){let b="";if(m.length===8)for(let I=m.length-2;I>=0;I-=2)b+=parseInt(m.substr(I,2),16),I!==0&&(b+=".");else for(let I=0;I<m.length;I+=8){const z=m.substring(I,I+8);let O="";for(let F=8;F>=2;F-=2)O+=z.substring(F-2,F),(F===6||F===2)&&(O=parseInt(O,16).toString(16),b+=`${O}`,O="",I+F!==m.length-6&&(b+=":"))}return b}e.$qfc=i;function s(m){const b=m.trim().split(`
`),I=b.shift().trim().split(/\s+/).filter(O=>O!=="rx_queue"&&O!=="tm->when");return b.map(O=>O.trim().split(/\s+/).reduce((F,T,N)=>(F[I[N]||N]=T,F),{}))}e.$rfc=s;function n(m){return!!m.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||m.indexOf("out/server-main.js")!==-1||m.indexOf("_productName=VSCode")!==-1}function r(m){const b=m.trim().split(`
`),I=[];return b.forEach(z=>{const O=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(z);O&&O.length>=4&&I.push({pid:parseInt(O[1],10),ppid:parseInt(O[2]),cmd:O[3]})}),I}e.$sfc=r;async function o(m,b,I){const z=I.reduce((F,T)=>(F[T.pid]=T,F),{}),O=[];return m.forEach(({socket:F,ip:T,port:N})=>{const j=b[F]?b[F].pid:void 0,U=j?z[j]?.cmd:void 0;j&&U&&!n(U)&&O.push({host:T,port:N,detail:U,pid:j})}),O}e.$tfc=o;function v(m,b,I){const z=new Map,O=r(b);for(const F of m){const T=I.get(F.port);if(T){z.set(F.port,T);continue}const N=O.find(j=>j.cmd.includes(`${F.port}`));if(N){let j=N,U;do U=O.find(B=>B.ppid===j.pid),U&&(j=U);while(U);z.set(F.port,{host:F.ip,port:F.port,pid:j.pid,detail:j.cmd,ppid:j.ppid})}else z.set(F.port,{host:F.ip,port:F.port,ppid:Number.MAX_VALUE})}return z}e.$ufc=v;let C=class extends c.$vwb{constructor(b,I,z,O){super(b,I,z),this.D=I,this.F=O,this.y=void 0,this.z=new Map,this.C=!1,g.$f&&I.remote.isRemote&&I.remote.authority&&(this.a.$setRemoteTunnelService(process.pid),this.H())}async $registerCandidateFinder(b){if(b&&this.C)return;this.C=b;let I;this.y&&(I=this.y,await this.a.$onFoundNewCandidates(this.y));const z=new A.$Tl;let O=0;for(;this.C;){const F=new Date().getTime(),T=(await this.I()).filter(U=>(0,E.$hv)(U.host)||(0,E.$jv)(U.host));this.s.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${T.map(U=>U.port).join(", ")}`);const N=new Date().getTime()-F;this.s.trace(`ForwardedPorts: (ExtHostTunnelService) candidate port scan took ${N} ms.`),O++>3&&z.update(N),(!I||JSON.stringify(I)!==JSON.stringify(T))&&(I=T,await this.a.$onFoundNewCandidates(I));const j=this.G(z.value);this.s.trace(`ForwardedPorts: (ExtHostTunnelService) next candidate port scan in ${j} ms.`),await new Promise(U=>setTimeout(()=>U(),j))}}G(b){return Math.max(b*20,2e3)}async H(){this.y=await this.I(),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) Initial candidates found: ${this.y.map(b=>b.port).join(", ")}`)}async I(){let b="",I="";try{b=await R.Promises.readFile("/proc/net/tcp","utf8"),I=await R.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const z=t(b,I),O=await new Promise(x=>{(0,y.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(Q,Z,ie)=>{x(Z)})}),F=a(O),T=await R.Promises.readdir("/proc"),N=[];for(const x of T)try{const Q=Number(x),Z=k.$wg($.URI.file("/proc"),x);if((await R.Promises.stat(Z.fsPath)).isDirectory()&&!isNaN(Q)){const _=await R.Promises.readlink(k.$wg(Z,"cwd").fsPath),oe=await R.Promises.readFile(k.$wg(Z,"cmdline").fsPath,"utf8");N.push({pid:Q,cwd:_,cmd:oe})}}catch{}const j=[],U=z.filter(x=>{const Q=F[x.socket];return Q||j.push(x),Q}),B=o(U,F,N);let he;if(this.s.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${j.length}`),j.length>0){const x=await new Promise(Q=>{(0,y.exec)("ps -F -A -l | grep root",(Z,ie,_)=>{Q(ie)})});this.z=v(j,x,this.z),he=Array.from(this.z.values()),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${he.map(Q=>Q.port).join(", ")}`)}return B.then(x=>he?x.concat(he):x)}w(b){return async I=>{const z=new h.$I8b({commit:this.D.commit,quality:this.D.quality,logService:this.s,ipcLogger:null,remoteSocketFactoryService:{_serviceBrand:void 0,async connect(F,T,N,j){const U=await b.makeConnection();return w.connect(U,T,N,j)},register(){throw new Error("not implemented")}},addressProvider:{getAddress(){return Promise.resolve({connectTo:new S.$Rk(0),connectionToken:b.connectionToken})}},signService:this.F},"localhost",I.remoteAddress.host||"localhost",I.remoteAddress.port,I.localAddressPort);await z.waitForReady();const O=new l.$Od;return{localAddress:(0,f.$QJ)(z.localAddress)??z.localAddress,remoteAddress:{port:z.tunnelRemotePort,host:z.tunnelRemoteHost},onDidDispose:O.event,dispose:()=>{z.dispose(),O.fire(),O.dispose()}}}}};e.$vfc=C,e.$vfc=C=He([We(0,d.$rM),We(1,u.$HM),We(2,P.$$i),We(3,D.$4k)],C);class w extends p.$Xkb{static connect(b,I,z,O){const F=new L.$Rc,T={onClose:F.add(new l.$Od),onData:F.add(new l.$Od),onEnd:F.add(new l.$Od)};F.add(b.onDidReceiveMessage(j=>T.onData.fire(M.$ce.wrap(j)))),F.add(b.onDidEnd(()=>T.onEnd.fire())),F.add(b.onDidClose(j=>T.onClose.fire({type:0,error:j,hadError:!!j})));const N=new w(b,O,T);return N.B(F),(0,p.$Wkb)(N,I,z,O,T)}constructor(b,I,z){super(I,z),this.n=b}write(b){this.n.send(b.buffer)}h(){this.n.end()}async drain(){await this.n.drain?.()}}}),define(De[372],Ce([1,0,103,343,355,354,367,370,371,94,46,95,93,45,73,90,342,341,14,356,56,262,102,106,139]),function(re,e,y,M,l,L,A,g,k,$,R,P,p,S,D,E,h,u,d,c,f,a,t,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,y.$Br)(R.$odc,g.$nfc,0),(0,y.$Br)(d.$_i,u.$xfc,1),(0,y.$Br)(d.$$i,new t.$Nh(a.$Nec,[!1],!0)),(0,y.$Br)(i.$4k,s.$N8b,1),(0,y.$Br)(E.$_cc,h.$wfc,0),(0,y.$Br)($.$Ydc,L.$1ec,0),(0,y.$Br)(P.$9dc,A.$ifc,0),(0,y.$Br)(p.$Tdc,l.$Sec,0),(0,y.$Br)(S.$bdc,M.$Rec,0),(0,y.$Br)(D.$uwb,k.$vfc,0),(0,y.$Br)(f.$Wdc,c.$yfc,0)}),define(De[383],Ce([1,0,108,62,384,54,9,82,118,245,112,353,22,29,100,8,131,268,281,358,372]),function(re,e,y,M,l,L,A,g,k,$,R,P,p,S,D,E,h,u,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),function(){for(let v=0;v<process.execArgv.length;v++)process.execArgv[v]==="--inspect-port=0"&&(process.execArgv.splice(v,1),v--)}();const c=l(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const o=globalThis._VSCODE_NODE_MODULES.module,v=o._load;o._load=function(C){if(C==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return v.apply(this,arguments)}})();const f=process.exit.bind(process);function a(o){process.exit=function(v){if(o)f(v);else{const C=new Error("An extension called process.exit() and this was prevented.");console.warn(C.stack)}},process.crash=function(){const v=new Error("An extension called process.crash() and this was prevented.");console.warn(v.stack)},process.env.ELECTRON_RUN_AS_NODE="1"}let t=function(o){f()};function i(){const o=(0,d.$Dm)(process.env);if(o.type===3)return new Promise((v,C)=>{const w=m=>{const b=m[0],I=new g.$Dh;b.on("message",z=>I.fire(p.$ce.wrap(z.data))),b.on("close",()=>{t("renderer closed the MessagePort")}),b.start(),v({onMessage:I.event,send:z=>b.postMessage(z.buffer)})};process.parentPort.on("message",m=>w(m.ports))});if(o.type===2)return new Promise((v,C)=>{let w=null;const m=setTimeout(()=>{t("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4),b=108e5,I=3e5,z=new E.$8g(()=>t("renderer disconnected for too long (1)"),b),O=new E.$8g(()=>t("renderer disconnected for too long (2)"),I);process.on("message",(T,N)=>{if(T&&T.type==="VSCODE_EXTHOST_IPC_SOCKET"){N.setNoDelay(!0);const j=p.$ce.wrap(Buffer.from(T.initialDataChunk,"base64"));let U;if(T.skipWebSocketFrames)U=new k.$Fh(N,"extHost-socket");else{const B=p.$ce.wrap(Buffer.from(T.inflateBytes,"base64"));U=new k.$Gh(new k.$Fh(N,"extHost-socket"),T.permessageDeflate,B,!1)}w?(z.cancel(),O.cancel(),w.beginAcceptReconnection(U,j),w.endAcceptReconnection(),w.sendResume()):(clearTimeout(m),w=new g.$Eh({socket:U,initialChunk:j}),w.sendResume(),w.onDidDispose(()=>t("renderer disconnected")),v(w),w.onSocketClose(()=>{z.schedule()}))}if(T&&T.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(O.isScheduled())return;z.isScheduled()&&O.schedule()}});const F={type:"VSCODE_EXTHOST_IPC_READY"};process.send?.(F)});{const v=o.pipeName;return new Promise((C,w)=>{const m=M.createConnection(v,()=>{m.removeListener("error",w);const b=new g.$Eh({socket:new k.$Fh(m,"extHost-renderer")});b.sendResume(),C(b)});m.once("error",w),m.on("close",()=>{t("renderer closed the socket")})})}}async function s(){const o=await i();return new class{constructor(){this.a=new g.$Dh,this.onMessage=this.a.event,this.b=!1,o.onMessage(v=>{(0,R.$em)(v,2)?(this.b=!0,t("received terminate message from renderer")):this.a.fire(v)})}send(v){this.b||o.send(v)}async drain(){if(o.drain)return o.drain()}}}function n(o){return new Promise(v=>{const C=o.onMessage(w=>{C.dispose();const m=JSON.parse(w.toString()),b=m.commit,I=$.default.commit;if(b&&I&&b!==I&&f(55),m.parentPid){let z=0;setInterval(function(){try{process.kill(m.parentPid,0),z=0}catch(F){F&&F.code==="EPERM"?(z++,z>=3&&t(`parent process ${m.parentPid} does not exist anymore (3 x EPERM): ${F.message} (code: ${F.code}) (errno: ${F.errno})`)):t(`parent process ${m.parentPid} does not exist anymore: ${F.message} (code: ${F.code}) (errno: ${F.errno})`)}},1e3);let O;try{O=globalThis._VSCODE_NODE_MODULES["native-watchdog"],O.start(m.parentPid)}catch(F){(0,A.$1)(F)}}o.send((0,R.$dm)(0)),v({protocol:o,initData:m})});o.send((0,R.$dm)(1))})}async function r(){const o=[];process.on("unhandledRejection",(z,O)=>{o.push(O),setTimeout(()=>{const F=o.indexOf(O);F>=0&&O.catch(T=>{o.splice(F,1),(0,A.$4)(T)||(console.warn(`rejected promise not handled within 1 second: ${T}`),T&&T.stack&&console.warn(`stack trace: ${T.stack}`),z&&(0,A.$1)(z))})},1e3)}),process.on("rejectionHandled",z=>{const O=o.indexOf(z);O>=0&&o.splice(O,1)}),process.on("uncaughtException",function(z){(0,A.$Z)(z)||(0,A.$1)(z)}),L.mark("code/extHost/willConnectToRenderer");const v=await s();L.mark("code/extHost/didConnectToRenderer");const C=await n(v);L.mark("code/extHost/didWaitForInitData");const{initData:w}=C;a(!!w.environment.extensionTestsLocationURI),w.environment.useHostProxy=c.useHostProxy!==void 0?c.useHostProxy!=="false":void 0,w.environment.skipWorkspaceStorageLock=(0,h.boolean)(c.skipWorkspaceStorageLock,!1);const m=new class{constructor(){this.pid=process.pid}exit(O){f(O)}fsExists(O){return S.Promises.exists(O)}fsRealpath(O){return(0,D.$_p)(O)}};let b=null;w.remote.authority&&c.transformURIs&&(b=(0,u.$Fr)(w.remote.authority));const I=new P.$Qec(C.protocol,w,m,b);t=z=>{I.terminate(z);const O=process.env.VSCODE_IPC_HOOK_CLI,F=process.env.CODE_SERVER_SESSION_SOCKET;if(!O||!F)return;const T=JSON.stringify({socketPath:O}),N={path:"/delete-session",socketPath:F,method:"POST",headers:{"content-type":"application/json",accept:"application/json"}},j=y.request(N);j.write(T),j.end()}}r().catch(o=>console.log(o))})}).call(this);

//# sourceMappingURL=extensionHostProcess.js.map
