"use strict";/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Ae=["exports","require","vs/base/common/uri","vs/workbench/api/common/extHost.protocol","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/errors","vs/base/common/async","vs/base/common/network","vs/platform/log/common/log","vs/base/common/types","vs/base/common/strings","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/base/common/cancellation","vs/base/common/path","vs/platform/extensions/common/extensions","vs/workbench/services/extensions/common/extensions","vs/base/common/platform","vs/base/common/resources","vs/base/common/objects","vs/base/common/buffer","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/base/common/severity","vs/platform/registry/common/platform","vs/workbench/api/common/extHostCommands","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/glob","vs/base/common/uuid","vs/base/common/errorMessage","vs/platform/files/common/files","vs/workbench/api/common/extHostFileSystemInfo","vs/editor/common/core/range","vs/base/common/lazy","vs/base/common/extpath","vs/base/common/themables","vs/platform/configuration/common/configuration","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/base/common/stopwatch","vs/workbench/services/search/common/search","vs/base/common/ternarySearchTree","vs/base/common/htmlContent","vs/platform/progress/common/progress","vs/base/common/assert","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWebview","vs/base/common/decorators","vs/base/common/mime","vs/base/common/marshalling","vs/base/common/iterator","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/base/common/process","vs/workbench/api/common/cache","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/editor/common/languages","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostTunnelService","vs/base/common/performance","vs/base/common/idGenerator","vs/base/common/codicons","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/hash","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/implicitActivationEvents","vs/workbench/common/editor","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/numbers","vs/base/common/comparers","vs/base/common/stream","vs/base/common/filters","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/uriIpc","vs/base/common/dataTransfer","vs/editor/common/core/textModelDefaults","vs/editor/common/languageSelector","vs/editor/common/languages/languageConfiguration","vs/editor/common/services/treeViewsDnd","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChat","vs/nls!vs/workbench/api/common/extHostChatAgents2","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/log/common/logService","vs/platform/notification/common/notification","vs/platform/product/common/productService","vs/platform/configuration/common/configurationModels","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/api/common/extHostTheming","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/base/common/functional","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChat","vs/workbench/api/common/extHostChatAgents","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatProvider","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/base/common/collections","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostIssueReporter","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/editor/common/model/mirrorTextModel","vs/editor/common/core/position","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/base/common/arraysFind","vs/editor/common/model/textModelSearch","vs/editor/common/model","vs/workbench/api/worker/extensionHostWorker"],Re=function(ee){for(var e=[],f=0,C=ee.length;f<C;f++)e[f]=Ae[ee[f]];return e};define(Ae[65],Re([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kh=e.$jh=e.$ih=void 0;function f(A){return(c,E,d)=>{let R=null,S=null;if(typeof d.value=="function"?(R="value",S=d.value):typeof d.get=="function"&&(R="get",S=d.get),!S)throw new Error("not supported");d[R]=A(S,E)}}function C(A,c,E){let d=null,R=null;if(typeof E.value=="function"?(d="value",R=E.value,R.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof E.get=="function"&&(d="get",R=E.get),!R)throw new Error("not supported");const S=`$memoize$${c}`;E[d]=function(...u){return this.hasOwnProperty(S)||Object.defineProperty(this,S,{configurable:!1,enumerable:!1,writable:!1,value:R.apply(this,u)}),this[S]}}e.$ih=C;function I(A,c,E){return f((d,R)=>{const S=`$debounce$${R}`,u=`$debounce$result$${R}`;return function(...b){this[u]||(this[u]=E?E():void 0),clearTimeout(this[S]),c&&(this[u]=c(this[u],...b),b=[this[u]]),this[S]=setTimeout(()=>{d.apply(this,b),this[u]=E?E():void 0},A)}})}e.$jh=I;function O(A,c,E){return f((d,R)=>{const S=`$throttle$timer$${R}`,u=`$throttle$result$${R}`,b=`$throttle$lastRun$${R}`,p=`$throttle$pending$${R}`;return function(...g){if(this[u]||(this[u]=E?E():void 0),(this[b]===null||this[b]===void 0)&&(this[b]=-Number.MAX_VALUE),c&&(this[u]=c(this[u],...g)),this[p])return;const t=this[b]+A;t<=Date.now()?(this[b]=Date.now(),d.apply(this,[this[u]]),this[u]=E?E():void 0):(this[p]=!0,this[S]=setTimeout(()=>{this[p]=!1,this[b]=Date.now(),d.apply(this,[this[u]]),this[u]=E?E():void 0},t-Date.now()))}})}e.$kh=O}),define(Ae[88],Re([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xM=e.$wM=void 0;class f{constructor(I){this.a=I,this.b=0}nextId(){return this.a+ ++this.b}}e.$wM=f,e.$xM=new f("id#")}),define(Ae[115],Re([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8m=e.$7m=e.$6m=e.$5m=e.$4m=e.$3m=e.$2m=e.$1m=e.$Zm=e.$Ym=e.$Xm=e.$Wm=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var f;(function(n){n[n.None=0]="None",n[n.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=2]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",n[n.InvalidUnicode=4]="InvalidUnicode",n[n.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",n[n.InvalidCharacter=6]="InvalidCharacter"})(f||(e.ScanError=f={}));var C;(function(n){n[n.OpenBraceToken=1]="OpenBraceToken",n[n.CloseBraceToken=2]="CloseBraceToken",n[n.OpenBracketToken=3]="OpenBracketToken",n[n.CloseBracketToken=4]="CloseBracketToken",n[n.CommaToken=5]="CommaToken",n[n.ColonToken=6]="ColonToken",n[n.NullKeyword=7]="NullKeyword",n[n.TrueKeyword=8]="TrueKeyword",n[n.FalseKeyword=9]="FalseKeyword",n[n.StringLiteral=10]="StringLiteral",n[n.NumericLiteral=11]="NumericLiteral",n[n.LineCommentTrivia=12]="LineCommentTrivia",n[n.BlockCommentTrivia=13]="BlockCommentTrivia",n[n.LineBreakTrivia=14]="LineBreakTrivia",n[n.Trivia=15]="Trivia",n[n.Unknown=16]="Unknown",n[n.EOF=17]="EOF"})(C||(e.SyntaxKind=C={}));var I;(function(n){n[n.InvalidSymbol=1]="InvalidSymbol",n[n.InvalidNumberFormat=2]="InvalidNumberFormat",n[n.PropertyNameExpected=3]="PropertyNameExpected",n[n.ValueExpected=4]="ValueExpected",n[n.ColonExpected=5]="ColonExpected",n[n.CommaExpected=6]="CommaExpected",n[n.CloseBraceExpected=7]="CloseBraceExpected",n[n.CloseBracketExpected=8]="CloseBracketExpected",n[n.EndOfFileExpected=9]="EndOfFileExpected",n[n.InvalidCommentToken=10]="InvalidCommentToken",n[n.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=12]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",n[n.InvalidUnicode=14]="InvalidUnicode",n[n.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",n[n.InvalidCharacter=16]="InvalidCharacter"})(I||(e.ParseErrorCode=I={}));var O;(function(n){n.DEFAULT={allowTrailingComma:!0}})(O||(e.ParseOptions=O={}));function A(n,r=!1){let s=0;const o=n.length;let $="",a=0,k=16,P=0;function h(T){let F=0,j=0;for(;F<T;){const q=n.charCodeAt(s);if(q>=48&&q<=57)j=j*16+q-48;else if(q>=65&&q<=70)j=j*16+q-65+10;else if(q>=97&&q<=102)j=j*16+q-97+10;else break;s++,F++}return F<T&&(j=-1),j}function w(T){s=T,$="",a=0,k=16,P=0}function y(){const T=s;if(n.charCodeAt(s)===48)s++;else for(s++;s<n.length&&d(n.charCodeAt(s));)s++;if(s<n.length&&n.charCodeAt(s)===46)if(s++,s<n.length&&d(n.charCodeAt(s)))for(s++;s<n.length&&d(n.charCodeAt(s));)s++;else return P=3,n.substring(T,s);let F=s;if(s<n.length&&(n.charCodeAt(s)===69||n.charCodeAt(s)===101))if(s++,(s<n.length&&n.charCodeAt(s)===43||n.charCodeAt(s)===45)&&s++,s<n.length&&d(n.charCodeAt(s))){for(s++;s<n.length&&d(n.charCodeAt(s));)s++;F=s}else P=3;return n.substring(T,F)}function M(){let T="",F=s;for(;;){if(s>=o){T+=n.substring(F,s),P=2;break}const j=n.charCodeAt(s);if(j===34){T+=n.substring(F,s),s++;break}if(j===92){if(T+=n.substring(F,s),s++,s>=o){P=2;break}switch(n.charCodeAt(s++)){case 34:T+='"';break;case 92:T+="\\";break;case 47:T+="/";break;case 98:T+="\b";break;case 102:T+="\f";break;case 110:T+=`
`;break;case 114:T+="\r";break;case 116:T+="	";break;case 117:{const W=h(4);W>=0?T+=String.fromCharCode(W):P=4;break}default:P=5}F=s;continue}if(j>=0&&j<=31)if(E(j)){T+=n.substring(F,s),P=2;break}else P=6;s++}return T}function V(){if($="",P=0,a=s,s>=o)return a=o,k=17;let T=n.charCodeAt(s);if(c(T)){do s++,$+=String.fromCharCode(T),T=n.charCodeAt(s);while(c(T));return k=15}if(E(T))return s++,$+=String.fromCharCode(T),T===13&&n.charCodeAt(s)===10&&(s++,$+=`
`),k=14;switch(T){case 123:return s++,k=1;case 125:return s++,k=2;case 91:return s++,k=3;case 93:return s++,k=4;case 58:return s++,k=6;case 44:return s++,k=5;case 34:return s++,$=M(),k=10;case 47:{const F=s-1;if(n.charCodeAt(s+1)===47){for(s+=2;s<o&&!E(n.charCodeAt(s));)s++;return $=n.substring(F,s),k=12}if(n.charCodeAt(s+1)===42){s+=2;const j=o-1;let q=!1;for(;s<j;){if(n.charCodeAt(s)===42&&n.charCodeAt(s+1)===47){s+=2,q=!0;break}s++}return q||(s++,P=1),$=n.substring(F,s),k=13}return $+=String.fromCharCode(T),s++,k=16}case 45:if($+=String.fromCharCode(T),s++,s===o||!d(n.charCodeAt(s)))return k=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return $+=y(),k=11;default:for(;s<o&&B(T);)s++,T=n.charCodeAt(s);if(a!==s){switch($=n.substring(a,s),$){case"true":return k=8;case"false":return k=9;case"null":return k=7}return k=16}return $+=String.fromCharCode(T),s++,k=16}}function B(T){if(c(T)||E(T))return!1;switch(T){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function z(){let T;do T=V();while(T>=12&&T<=15);return T}return{setPosition:w,getPosition:()=>s,scan:r?z:V,getToken:()=>k,getTokenValue:()=>$,getTokenOffset:()=>a,getTokenLength:()=>s-a,getTokenError:()=>P}}e.$Wm=A;function c(n){return n===32||n===9||n===11||n===12||n===160||n===5760||n>=8192&&n<=8203||n===8239||n===8287||n===12288||n===65279}function E(n){return n===10||n===13||n===8232||n===8233}function d(n){return n>=48&&n<=57}var R;(function(n){n[n.nullCharacter=0]="nullCharacter",n[n.maxAsciiCharacter=127]="maxAsciiCharacter",n[n.lineFeed=10]="lineFeed",n[n.carriageReturn=13]="carriageReturn",n[n.lineSeparator=8232]="lineSeparator",n[n.paragraphSeparator=8233]="paragraphSeparator",n[n.nextLine=133]="nextLine",n[n.space=32]="space",n[n.nonBreakingSpace=160]="nonBreakingSpace",n[n.enQuad=8192]="enQuad",n[n.emQuad=8193]="emQuad",n[n.enSpace=8194]="enSpace",n[n.emSpace=8195]="emSpace",n[n.threePerEmSpace=8196]="threePerEmSpace",n[n.fourPerEmSpace=8197]="fourPerEmSpace",n[n.sixPerEmSpace=8198]="sixPerEmSpace",n[n.figureSpace=8199]="figureSpace",n[n.punctuationSpace=8200]="punctuationSpace",n[n.thinSpace=8201]="thinSpace",n[n.hairSpace=8202]="hairSpace",n[n.zeroWidthSpace=8203]="zeroWidthSpace",n[n.narrowNoBreakSpace=8239]="narrowNoBreakSpace",n[n.ideographicSpace=12288]="ideographicSpace",n[n.mathematicalSpace=8287]="mathematicalSpace",n[n.ogham=5760]="ogham",n[n._=95]="_",n[n.$=36]="$",n[n._0=48]="_0",n[n._1=49]="_1",n[n._2=50]="_2",n[n._3=51]="_3",n[n._4=52]="_4",n[n._5=53]="_5",n[n._6=54]="_6",n[n._7=55]="_7",n[n._8=56]="_8",n[n._9=57]="_9",n[n.a=97]="a",n[n.b=98]="b",n[n.c=99]="c",n[n.d=100]="d",n[n.e=101]="e",n[n.f=102]="f",n[n.g=103]="g",n[n.h=104]="h",n[n.i=105]="i",n[n.j=106]="j",n[n.k=107]="k",n[n.l=108]="l",n[n.m=109]="m",n[n.n=110]="n",n[n.o=111]="o",n[n.p=112]="p",n[n.q=113]="q",n[n.r=114]="r",n[n.s=115]="s",n[n.t=116]="t",n[n.u=117]="u",n[n.v=118]="v",n[n.w=119]="w",n[n.x=120]="x",n[n.y=121]="y",n[n.z=122]="z",n[n.A=65]="A",n[n.B=66]="B",n[n.C=67]="C",n[n.D=68]="D",n[n.E=69]="E",n[n.F=70]="F",n[n.G=71]="G",n[n.H=72]="H",n[n.I=73]="I",n[n.J=74]="J",n[n.K=75]="K",n[n.L=76]="L",n[n.M=77]="M",n[n.N=78]="N",n[n.O=79]="O",n[n.P=80]="P",n[n.Q=81]="Q",n[n.R=82]="R",n[n.S=83]="S",n[n.T=84]="T",n[n.U=85]="U",n[n.V=86]="V",n[n.W=87]="W",n[n.X=88]="X",n[n.Y=89]="Y",n[n.Z=90]="Z",n[n.ampersand=38]="ampersand",n[n.asterisk=42]="asterisk",n[n.at=64]="at",n[n.backslash=92]="backslash",n[n.bar=124]="bar",n[n.caret=94]="caret",n[n.closeBrace=125]="closeBrace",n[n.closeBracket=93]="closeBracket",n[n.closeParen=41]="closeParen",n[n.colon=58]="colon",n[n.comma=44]="comma",n[n.dot=46]="dot",n[n.doubleQuote=34]="doubleQuote",n[n.equals=61]="equals",n[n.exclamation=33]="exclamation",n[n.greaterThan=62]="greaterThan",n[n.lessThan=60]="lessThan",n[n.minus=45]="minus",n[n.openBrace=123]="openBrace",n[n.openBracket=91]="openBracket",n[n.openParen=40]="openParen",n[n.percent=37]="percent",n[n.plus=43]="plus",n[n.question=63]="question",n[n.semicolon=59]="semicolon",n[n.singleQuote=39]="singleQuote",n[n.slash=47]="slash",n[n.tilde=126]="tilde",n[n.backspace=8]="backspace",n[n.formFeed=12]="formFeed",n[n.byteOrderMark=65279]="byteOrderMark",n[n.tab=9]="tab",n[n.verticalTab=11]="verticalTab"})(R||(R={}));function S(n,r){const s=[],o=new Object;let $;const a={value:{},offset:0,length:0,type:"object",parent:void 0};let k=!1;function P(h,w,y,M){a.value=h,a.offset=w,a.length=y,a.type=M,a.colonOffset=void 0,$=a}try{v(n,{onObjectBegin:(h,w)=>{if(r<=h)throw o;$=void 0,k=r>h,s.push("")},onObjectProperty:(h,w,y)=>{if(r<w||(P(h,w,y,"property"),s[s.length-1]=h,r<=w+y))throw o},onObjectEnd:(h,w)=>{if(r<=h)throw o;$=void 0,s.pop()},onArrayBegin:(h,w)=>{if(r<=h)throw o;$=void 0,s.push(0)},onArrayEnd:(h,w)=>{if(r<=h)throw o;$=void 0,s.pop()},onLiteralValue:(h,w,y)=>{if(r<w||(P(h,w,y,m(h)),r<=w+y))throw o},onSeparator:(h,w,y)=>{if(r<=w)throw o;if(h===":"&&$&&$.type==="property")$.colonOffset=w,k=!1,$=void 0;else if(h===","){const M=s[s.length-1];typeof M=="number"?s[s.length-1]=M+1:(k=!0,s[s.length-1]=""),$=void 0}}})}catch(h){if(h!==o)throw h}return{path:s,previousNode:$,isAtPropertyKey:k,matches:h=>{let w=0;for(let y=0;w<h.length&&y<s.length;y++)if(h[w]===s[y]||h[w]==="*")w++;else if(h[w]!=="**")return!1;return w===h.length}}}e.$Xm=S;function u(n,r=[],s=O.DEFAULT){let o=null,$=[];const a=[];function k(h){Array.isArray($)?$.push(h):o!==null&&($[o]=h)}return v(n,{onObjectBegin:()=>{const h={};k(h),a.push($),$=h,o=null},onObjectProperty:h=>{o=h},onObjectEnd:()=>{$=a.pop()},onArrayBegin:()=>{const h=[];k(h),a.push($),$=h,o=null},onArrayEnd:()=>{$=a.pop()},onLiteralValue:k,onError:(h,w,y)=>{r.push({error:h,offset:w,length:y})}},s),$[0]}e.$Ym=u;function b(n,r=[],s=O.DEFAULT){let o={type:"array",offset:-1,length:-1,children:[],parent:void 0};function $(h){o.type==="property"&&(o.length=h-o.offset,o=o.parent)}function a(h){return o.children.push(h),h}v(n,{onObjectBegin:h=>{o=a({type:"object",offset:h,length:-1,parent:o,children:[]})},onObjectProperty:(h,w,y)=>{o=a({type:"property",offset:w,length:-1,parent:o,children:[]}),o.children.push({type:"string",value:h,offset:w,length:y,parent:o})},onObjectEnd:(h,w)=>{o.length=h+w-o.offset,o=o.parent,$(h+w)},onArrayBegin:(h,w)=>{o=a({type:"array",offset:h,length:-1,parent:o,children:[]})},onArrayEnd:(h,w)=>{o.length=h+w-o.offset,o=o.parent,$(h+w)},onLiteralValue:(h,w,y)=>{a({type:m(h),offset:w,length:y,parent:o,value:h}),$(w+y)},onSeparator:(h,w,y)=>{o.type==="property"&&(h===":"?o.colonOffset=w:h===","&&$(w))},onError:(h,w,y)=>{r.push({error:h,offset:w,length:y})}},s);const P=o.children[0];return P&&delete P.parent,P}e.$Zm=b;function p(n,r){if(!n)return;let s=n;for(const o of r)if(typeof o=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let $=!1;for(const a of s.children)if(Array.isArray(a.children)&&a.children[0].value===o){s=a.children[1],$=!0;break}if(!$)return}else{const $=o;if(s.type!=="array"||$<0||!Array.isArray(s.children)||$>=s.children.length)return;s=s.children[$]}return s}e.$1m=p;function g(n){if(!n.parent||!n.parent.children)return[];const r=g(n.parent);if(n.parent.type==="property"){const s=n.parent.children[0].value;r.push(s)}else if(n.parent.type==="array"){const s=n.parent.children.indexOf(n);s!==-1&&r.push(s)}return r}e.$2m=g;function t(n){switch(n.type){case"array":return n.children.map(t);case"object":{const r=Object.create(null);for(const s of n.children){const o=s.children[1];o&&(r[s.children[0].value]=t(o))}return r}case"null":case"string":case"number":case"boolean":return n.value;default:return}}e.$3m=t;function i(n,r,s=!1){return r>=n.offset&&r<n.offset+n.length||s&&r===n.offset+n.length}e.$4m=i;function l(n,r,s=!1){if(i(n,r,s)){const o=n.children;if(Array.isArray(o))for(let $=0;$<o.length&&o[$].offset<=r;$++){const a=l(o[$],r,s);if(a)return a}return n}}e.$5m=l;function v(n,r,s=O.DEFAULT){const o=A(n,!1);function $(re){return re?()=>re(o.getTokenOffset(),o.getTokenLength()):()=>!0}function a(re){return re?oe=>re(oe,o.getTokenOffset(),o.getTokenLength()):()=>!0}const k=$(r.onObjectBegin),P=a(r.onObjectProperty),h=$(r.onObjectEnd),w=$(r.onArrayBegin),y=$(r.onArrayEnd),M=a(r.onLiteralValue),V=a(r.onSeparator),B=$(r.onComment),z=a(r.onError),T=s&&s.disallowComments,F=s&&s.allowTrailingComma;function j(){for(;;){const re=o.scan();switch(o.getTokenError()){case 4:q(14);break;case 5:q(15);break;case 3:q(13);break;case 1:T||q(11);break;case 2:q(12);break;case 6:q(16);break}switch(re){case 12:case 13:T?q(10):B();break;case 16:q(1);break;case 15:case 14:break;default:return re}}}function q(re,oe=[],ye=[]){if(z(re),oe.length+ye.length>0){let De=o.getToken();for(;De!==17;){if(oe.indexOf(De)!==-1){j();break}else if(ye.indexOf(De)!==-1)break;De=j()}}}function W(re){const oe=o.getTokenValue();return re?M(oe):P(oe),j(),!0}function we(){switch(o.getToken()){case 11:{let re=0;try{re=JSON.parse(o.getTokenValue()),typeof re!="number"&&(q(2),re=0)}catch{q(2)}M(re);break}case 7:M(null);break;case 8:M(!0);break;case 9:M(!1);break;default:return!1}return j(),!0}function ke(){return o.getToken()!==10?(q(3,[],[2,5]),!1):(W(!1),o.getToken()===6?(V(":"),j(),ge()||q(4,[],[2,5])):q(5,[],[2,5]),!0)}function Se(){k(),j();let re=!1;for(;o.getToken()!==2&&o.getToken()!==17;){if(o.getToken()===5){if(re||q(4,[],[]),V(","),j(),o.getToken()===2&&F)break}else re&&q(6,[],[]);ke()||q(4,[],[2,5]),re=!0}return h(),o.getToken()!==2?q(7,[2],[]):j(),!0}function ve(){w(),j();let re=!1;for(;o.getToken()!==4&&o.getToken()!==17;){if(o.getToken()===5){if(re||q(4,[],[]),V(","),j(),o.getToken()===4&&F)break}else re&&q(6,[],[]);ge()||q(4,[],[4,5]),re=!0}return y(),o.getToken()!==4?q(8,[4],[]):j(),!0}function ge(){switch(o.getToken()){case 3:return ve();case 1:return Se();case 10:return W(!0);default:return we()}}return j(),o.getToken()===17?s.allowEmptyContent?!0:(q(4,[],[]),!1):ge()?(o.getToken()!==17&&q(9,[],[]),!0):(q(4,[],[]),!1)}e.$6m=v;function D(n,r){const s=A(n),o=[];let $,a=0,k;do switch(k=s.getPosition(),$=s.scan(),$){case 12:case 13:case 17:a!==k&&o.push(n.substring(a,k)),r!==void 0&&o.push(s.getTokenValue().replace(/[^\r\n]/g,r)),a=s.getPosition();break}while($!==17);return o.join("")}e.$7m=D;function m(n){switch(typeof n){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(n){if(Array.isArray(n))return"array"}else return"null";return"object"}default:return"null"}}e.$8m=m}),function(ee,e){typeof define=="function"&&define.amd?define(Ae[116],Re([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(ee=typeof globalThis<"u"?globalThis:ee||self,e(ee.marked={}))}(this,function(ee){"use strict";function e(de,le){for(var be=0;be<le.length;be++){var ie=le[be];ie.enumerable=ie.enumerable||!1,ie.configurable=!0,"value"in ie&&(ie.writable=!0),Object.defineProperty(de,ie.key,ie)}}function f(de,le,be){return le&&e(de.prototype,le),be&&e(de,be),Object.defineProperty(de,"prototype",{writable:!1}),de}function C(de,le){if(de){if(typeof de=="string")return I(de,le);var be=Object.prototype.toString.call(de).slice(8,-1);if(be==="Object"&&de.constructor&&(be=de.constructor.name),be==="Map"||be==="Set")return Array.from(de);if(be==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(be))return I(de,le)}}function I(de,le){(le==null||le>de.length)&&(le=de.length);for(var be=0,ie=new Array(le);be<le;be++)ie[be]=de[be];return ie}function O(de,le){var be=typeof Symbol<"u"&&de[Symbol.iterator]||de["@@iterator"];if(be)return(be=be.call(de)).next.bind(be);if(Array.isArray(de)||(be=C(de))||le&&de&&typeof de.length=="number"){be&&(de=be);var ie=0;return function(){return ie>=de.length?{done:!0}:{done:!1,value:de[ie++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function A(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}ee.defaults=A();function c(de){ee.defaults=de}var E=/[&<>"']/,d=/[&<>"']/g,R=/[<>"']|&(?!#?\w+;)/,S=/[<>"']|&(?!#?\w+;)/g,u={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},b=function(le){return u[le]};function p(de,le){if(le){if(E.test(de))return de.replace(d,b)}else if(R.test(de))return de.replace(S,b);return de}var g=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function t(de){return de.replace(g,function(le,be){return be=be.toLowerCase(),be==="colon"?":":be.charAt(0)==="#"?be.charAt(1)==="x"?String.fromCharCode(parseInt(be.substring(2),16)):String.fromCharCode(+be.substring(1)):""})}var i=/(^|[^\[])\^/g;function l(de,le){de=typeof de=="string"?de:de.source,le=le||"";var be={replace:function(fe,ne){return ne=ne.source||ne,ne=ne.replace(i,"$1"),de=de.replace(fe,ne),be},getRegex:function(){return new RegExp(de,le)}};return be}var v=/[^\w:]/g,D=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function m(de,le,be){if(de){var ie;try{ie=decodeURIComponent(t(be)).replace(v,"").toLowerCase()}catch{return null}if(ie.indexOf("javascript:")===0||ie.indexOf("vbscript:")===0||ie.indexOf("data:")===0)return null}le&&!D.test(be)&&(be=$(le,be));try{be=encodeURI(be).replace(/%25/g,"%")}catch{return null}return be}var n={},r=/^[^:]+:\/*[^/]*$/,s=/^([^:]+:)[\s\S]*$/,o=/^([^:]+:\/*[^/]*)[\s\S]*$/;function $(de,le){n[" "+de]||(r.test(de)?n[" "+de]=de+"/":n[" "+de]=h(de,"/",!0)),de=n[" "+de];var be=de.indexOf(":")===-1;return le.substring(0,2)==="//"?be?le:de.replace(s,"$1")+le:le.charAt(0)==="/"?be?le:de.replace(o,"$1")+le:de+le}var a={exec:function(){}};function k(de){for(var le=1,be,ie;le<arguments.length;le++){be=arguments[le];for(ie in be)Object.prototype.hasOwnProperty.call(be,ie)&&(de[ie]=be[ie])}return de}function P(de,le){var be=de.replace(/\|/g,function(ne,ce,pe){for(var Ce=!1,L=ce;--L>=0&&pe[L]==="\\";)Ce=!Ce;return Ce?"|":" |"}),ie=be.split(/ \|/),fe=0;if(ie[0].trim()||ie.shift(),ie.length>0&&!ie[ie.length-1].trim()&&ie.pop(),ie.length>le)ie.splice(le);else for(;ie.length<le;)ie.push("");for(;fe<ie.length;fe++)ie[fe]=ie[fe].trim().replace(/\\\|/g,"|");return ie}function h(de,le,be){var ie=de.length;if(ie===0)return"";for(var fe=0;fe<ie;){var ne=de.charAt(ie-fe-1);if(ne===le&&!be)fe++;else if(ne!==le&&be)fe++;else break}return de.slice(0,ie-fe)}function w(de,le){if(de.indexOf(le[1])===-1)return-1;for(var be=de.length,ie=0,fe=0;fe<be;fe++)if(de[fe]==="\\")fe++;else if(de[fe]===le[0])ie++;else if(de[fe]===le[1]&&(ie--,ie<0))return fe;return-1}function y(de){de&&de.sanitize&&!de.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function M(de,le){if(le<1)return"";for(var be="";le>1;)le&1&&(be+=de),le>>=1,de+=de;return be+de}function V(de,le,be,ie){var fe=le.href,ne=le.title?p(le.title):null,ce=de[1].replace(/\\([\[\]])/g,"$1");if(de[0].charAt(0)!=="!"){ie.state.inLink=!0;var pe={type:"link",raw:be,href:fe,title:ne,text:ce,tokens:ie.inlineTokens(ce)};return ie.state.inLink=!1,pe}return{type:"image",raw:be,href:fe,title:ne,text:p(ce)}}function B(de,le){var be=de.match(/^(\s+)(?:```)/);if(be===null)return le;var ie=be[1];return le.split(`
`).map(function(fe){var ne=fe.match(/^\s+/);if(ne===null)return fe;var ce=ne[0];return ce.length>=ie.length?fe.slice(ie.length):fe}).join(`
`)}var z=function(){function de(be){this.options=be||ee.defaults}var le=de.prototype;return le.space=function(ie){var fe=this.rules.block.newline.exec(ie);if(fe&&fe[0].length>0)return{type:"space",raw:fe[0]}},le.code=function(ie){var fe=this.rules.block.code.exec(ie);if(fe){var ne=fe[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:fe[0],codeBlockStyle:"indented",text:this.options.pedantic?ne:h(ne,`
`)}}},le.fences=function(ie){var fe=this.rules.block.fences.exec(ie);if(fe){var ne=fe[0],ce=B(ne,fe[3]||"");return{type:"code",raw:ne,lang:fe[2]?fe[2].trim():fe[2],text:ce}}},le.heading=function(ie){var fe=this.rules.block.heading.exec(ie);if(fe){var ne=fe[2].trim();if(/#$/.test(ne)){var ce=h(ne,"#");(this.options.pedantic||!ce||/ $/.test(ce))&&(ne=ce.trim())}return{type:"heading",raw:fe[0],depth:fe[1].length,text:ne,tokens:this.lexer.inline(ne)}}},le.hr=function(ie){var fe=this.rules.block.hr.exec(ie);if(fe)return{type:"hr",raw:fe[0]}},le.blockquote=function(ie){var fe=this.rules.block.blockquote.exec(ie);if(fe){var ne=fe[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:fe[0],tokens:this.lexer.blockTokens(ne,[]),text:ne}}},le.list=function(ie){var fe=this.rules.block.list.exec(ie);if(fe){var ne,ce,pe,Ce,L,K,Y,X,H,x,se,Le,je=fe[1].trim(),Ye=je.length>1,Ke={type:"list",raw:"",ordered:Ye,start:Ye?+je.slice(0,-1):"",loose:!1,items:[]};je=Ye?"\\d{1,9}\\"+je.slice(-1):"\\"+je,this.options.pedantic&&(je=Ye?je:"[*+-]");for(var tt=new RegExp("^( {0,3}"+je+")((?:[	 ][^\\n]*)?(?:\\n|$))");ie&&(Le=!1,!(!(fe=tt.exec(ie))||this.rules.block.hr.test(ie)));){if(ne=fe[0],ie=ie.substring(ne.length),X=fe[2].split(`
`,1)[0],H=ie.split(`
`,1)[0],this.options.pedantic?(Ce=2,se=X.trimLeft()):(Ce=fe[2].search(/[^ ]/),Ce=Ce>4?1:Ce,se=X.slice(Ce),Ce+=fe[1].length),K=!1,!X&&/^ *$/.test(H)&&(ne+=H+`
`,ie=ie.substring(H.length+1),Le=!0),!Le)for(var xe=new RegExp("^ {0,"+Math.min(3,Ce-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),et=new RegExp("^ {0,"+Math.min(3,Ce-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),rt=new RegExp("^ {0,"+Math.min(3,Ce-1)+"}(?:```|~~~)"),nt=new RegExp("^ {0,"+Math.min(3,Ce-1)+"}#");ie&&(x=ie.split(`
`,1)[0],X=x,this.options.pedantic&&(X=X.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(rt.test(X)||nt.test(X)||xe.test(X)||et.test(ie)));){if(X.search(/[^ ]/)>=Ce||!X.trim())se+=`
`+X.slice(Ce);else if(!K)se+=`
`+X;else break;!K&&!X.trim()&&(K=!0),ne+=x+`
`,ie=ie.substring(x.length+1)}Ke.loose||(Y?Ke.loose=!0:/\n *\n *$/.test(ne)&&(Y=!0)),this.options.gfm&&(ce=/^\[[ xX]\] /.exec(se),ce&&(pe=ce[0]!=="[ ] ",se=se.replace(/^\[[ xX]\] +/,""))),Ke.items.push({type:"list_item",raw:ne,task:!!ce,checked:pe,loose:!1,text:se}),Ke.raw+=ne}Ke.items[Ke.items.length-1].raw=ne.trimRight(),Ke.items[Ke.items.length-1].text=se.trimRight(),Ke.raw=Ke.raw.trimRight();var Ue=Ke.items.length;for(L=0;L<Ue;L++){this.lexer.state.top=!1,Ke.items[L].tokens=this.lexer.blockTokens(Ke.items[L].text,[]);var lt=Ke.items[L].tokens.filter(function(Z){return Z.type==="space"}),_=lt.every(function(Z){for(var Ee=Z.raw.split(""),We=0,ze=O(Ee),Ze;!(Ze=ze()).done;){var st=Ze.value;if(st===`
`&&(We+=1),We>1)return!0}return!1});!Ke.loose&&lt.length&&_&&(Ke.loose=!0,Ke.items[L].loose=!0)}return Ke}},le.html=function(ie){var fe=this.rules.block.html.exec(ie);if(fe){var ne={type:"html",raw:fe[0],pre:!this.options.sanitizer&&(fe[1]==="pre"||fe[1]==="script"||fe[1]==="style"),text:fe[0]};if(this.options.sanitize){var ce=this.options.sanitizer?this.options.sanitizer(fe[0]):p(fe[0]);ne.type="paragraph",ne.text=ce,ne.tokens=this.lexer.inline(ce)}return ne}},le.def=function(ie){var fe=this.rules.block.def.exec(ie);if(fe){fe[3]&&(fe[3]=fe[3].substring(1,fe[3].length-1));var ne=fe[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:ne,raw:fe[0],href:fe[2],title:fe[3]}}},le.table=function(ie){var fe=this.rules.block.table.exec(ie);if(fe){var ne={type:"table",header:P(fe[1]).map(function(Y){return{text:Y}}),align:fe[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:fe[3]&&fe[3].trim()?fe[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(ne.header.length===ne.align.length){ne.raw=fe[0];var ce=ne.align.length,pe,Ce,L,K;for(pe=0;pe<ce;pe++)/^ *-+: *$/.test(ne.align[pe])?ne.align[pe]="right":/^ *:-+: *$/.test(ne.align[pe])?ne.align[pe]="center":/^ *:-+ *$/.test(ne.align[pe])?ne.align[pe]="left":ne.align[pe]=null;for(ce=ne.rows.length,pe=0;pe<ce;pe++)ne.rows[pe]=P(ne.rows[pe],ne.header.length).map(function(Y){return{text:Y}});for(ce=ne.header.length,Ce=0;Ce<ce;Ce++)ne.header[Ce].tokens=this.lexer.inline(ne.header[Ce].text);for(ce=ne.rows.length,Ce=0;Ce<ce;Ce++)for(K=ne.rows[Ce],L=0;L<K.length;L++)K[L].tokens=this.lexer.inline(K[L].text);return ne}}},le.lheading=function(ie){var fe=this.rules.block.lheading.exec(ie);if(fe)return{type:"heading",raw:fe[0],depth:fe[2].charAt(0)==="="?1:2,text:fe[1],tokens:this.lexer.inline(fe[1])}},le.paragraph=function(ie){var fe=this.rules.block.paragraph.exec(ie);if(fe){var ne=fe[1].charAt(fe[1].length-1)===`
`?fe[1].slice(0,-1):fe[1];return{type:"paragraph",raw:fe[0],text:ne,tokens:this.lexer.inline(ne)}}},le.text=function(ie){var fe=this.rules.block.text.exec(ie);if(fe)return{type:"text",raw:fe[0],text:fe[0],tokens:this.lexer.inline(fe[0])}},le.escape=function(ie){var fe=this.rules.inline.escape.exec(ie);if(fe)return{type:"escape",raw:fe[0],text:p(fe[1])}},le.tag=function(ie){var fe=this.rules.inline.tag.exec(ie);if(fe)return!this.lexer.state.inLink&&/^<a /i.test(fe[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(fe[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(fe[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(fe[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:fe[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(fe[0]):p(fe[0]):fe[0]}},le.link=function(ie){var fe=this.rules.inline.link.exec(ie);if(fe){var ne=fe[2].trim();if(!this.options.pedantic&&/^</.test(ne)){if(!/>$/.test(ne))return;var ce=h(ne.slice(0,-1),"\\");if((ne.length-ce.length)%2===0)return}else{var pe=w(fe[2],"()");if(pe>-1){var Ce=fe[0].indexOf("!")===0?5:4,L=Ce+fe[1].length+pe;fe[2]=fe[2].substring(0,pe),fe[0]=fe[0].substring(0,L).trim(),fe[3]=""}}var K=fe[2],Y="";if(this.options.pedantic){var X=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(K);X&&(K=X[1],Y=X[3])}else Y=fe[3]?fe[3].slice(1,-1):"";return K=K.trim(),/^</.test(K)&&(this.options.pedantic&&!/>$/.test(ne)?K=K.slice(1):K=K.slice(1,-1)),V(fe,{href:K&&K.replace(this.rules.inline._escapes,"$1"),title:Y&&Y.replace(this.rules.inline._escapes,"$1")},fe[0],this.lexer)}},le.reflink=function(ie,fe){var ne;if((ne=this.rules.inline.reflink.exec(ie))||(ne=this.rules.inline.nolink.exec(ie))){var ce=(ne[2]||ne[1]).replace(/\s+/g," ");if(ce=fe[ce.toLowerCase()],!ce||!ce.href){var pe=ne[0].charAt(0);return{type:"text",raw:pe,text:pe}}return V(ne,ce,ne[0],this.lexer)}},le.emStrong=function(ie,fe,ne){ne===void 0&&(ne="");var ce=this.rules.inline.emStrong.lDelim.exec(ie);if(ce&&!(ce[3]&&ne.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var pe=ce[1]||ce[2]||"";if(!pe||pe&&(ne===""||this.rules.inline.punctuation.exec(ne))){var Ce=ce[0].length-1,L,K,Y=Ce,X=0,H=ce[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(H.lastIndex=0,fe=fe.slice(-1*ie.length+Ce);(ce=H.exec(fe))!=null;)if(L=ce[1]||ce[2]||ce[3]||ce[4]||ce[5]||ce[6],!!L){if(K=L.length,ce[3]||ce[4]){Y+=K;continue}else if((ce[5]||ce[6])&&Ce%3&&!((Ce+K)%3)){X+=K;continue}if(Y-=K,!(Y>0)){if(K=Math.min(K,K+Y+X),Math.min(Ce,K)%2){var x=ie.slice(1,Ce+ce.index+K);return{type:"em",raw:ie.slice(0,Ce+ce.index+K+1),text:x,tokens:this.lexer.inlineTokens(x)}}var se=ie.slice(2,Ce+ce.index+K-1);return{type:"strong",raw:ie.slice(0,Ce+ce.index+K+1),text:se,tokens:this.lexer.inlineTokens(se)}}}}}},le.codespan=function(ie){var fe=this.rules.inline.code.exec(ie);if(fe){var ne=fe[2].replace(/\n/g," "),ce=/[^ ]/.test(ne),pe=/^ /.test(ne)&&/ $/.test(ne);return ce&&pe&&(ne=ne.substring(1,ne.length-1)),ne=p(ne,!0),{type:"codespan",raw:fe[0],text:ne}}},le.br=function(ie){var fe=this.rules.inline.br.exec(ie);if(fe)return{type:"br",raw:fe[0]}},le.del=function(ie){var fe=this.rules.inline.del.exec(ie);if(fe)return{type:"del",raw:fe[0],text:fe[2],tokens:this.lexer.inlineTokens(fe[2])}},le.autolink=function(ie,fe){var ne=this.rules.inline.autolink.exec(ie);if(ne){var ce,pe;return ne[2]==="@"?(ce=p(this.options.mangle?fe(ne[1]):ne[1]),pe="mailto:"+ce):(ce=p(ne[1]),pe=ce),{type:"link",raw:ne[0],text:ce,href:pe,tokens:[{type:"text",raw:ce,text:ce}]}}},le.url=function(ie,fe){var ne;if(ne=this.rules.inline.url.exec(ie)){var ce,pe;if(ne[2]==="@")ce=p(this.options.mangle?fe(ne[0]):ne[0]),pe="mailto:"+ce;else{var Ce;do Ce=ne[0],ne[0]=this.rules.inline._backpedal.exec(ne[0])[0];while(Ce!==ne[0]);ce=p(ne[0]),ne[1]==="www."?pe="http://"+ce:pe=ce}return{type:"link",raw:ne[0],text:ce,href:pe,tokens:[{type:"text",raw:ce,text:ce}]}}},le.inlineText=function(ie,fe){var ne=this.rules.inline.text.exec(ie);if(ne){var ce;return this.lexer.state.inRawBlock?ce=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ne[0]):p(ne[0]):ne[0]:ce=p(this.options.smartypants?fe(ne[0]):ne[0]),{type:"text",raw:ne[0],text:ce}}},de}(),T={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:a,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};T._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,T._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,T.def=l(T.def).replace("label",T._label).replace("title",T._title).getRegex(),T.bullet=/(?:[*+-]|\d{1,9}[.)])/,T.listItemStart=l(/^( *)(bull) */).replace("bull",T.bullet).getRegex(),T.list=l(T.list).replace(/bull/g,T.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+T.def.source+")").getRegex(),T._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",T._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,T.html=l(T.html,"i").replace("comment",T._comment).replace("tag",T._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),T.paragraph=l(T._paragraph).replace("hr",T.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",T._tag).getRegex(),T.blockquote=l(T.blockquote).replace("paragraph",T.paragraph).getRegex(),T.normal=k({},T),T.gfm=k({},T.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),T.gfm.table=l(T.gfm.table).replace("hr",T.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",T._tag).getRegex(),T.gfm.paragraph=l(T._paragraph).replace("hr",T.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",T.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",T._tag).getRegex(),T.pedantic=k({},T.normal,{html:l(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",T._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:a,paragraph:l(T.normal._paragraph).replace("hr",T.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",T.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var F={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:a,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:a,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};F._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",F.punctuation=l(F.punctuation).replace(/punctuation/g,F._punctuation).getRegex(),F.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,F.escapedEmSt=/\\\*|\\_/g,F._comment=l(T._comment).replace("(?:-->|$)","-->").getRegex(),F.emStrong.lDelim=l(F.emStrong.lDelim).replace(/punct/g,F._punctuation).getRegex(),F.emStrong.rDelimAst=l(F.emStrong.rDelimAst,"g").replace(/punct/g,F._punctuation).getRegex(),F.emStrong.rDelimUnd=l(F.emStrong.rDelimUnd,"g").replace(/punct/g,F._punctuation).getRegex(),F._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,F._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,F._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,F.autolink=l(F.autolink).replace("scheme",F._scheme).replace("email",F._email).getRegex(),F._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,F.tag=l(F.tag).replace("comment",F._comment).replace("attribute",F._attribute).getRegex(),F._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,F._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,F._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,F.link=l(F.link).replace("label",F._label).replace("href",F._href).replace("title",F._title).getRegex(),F.reflink=l(F.reflink).replace("label",F._label).replace("ref",T._label).getRegex(),F.nolink=l(F.nolink).replace("ref",T._label).getRegex(),F.reflinkSearch=l(F.reflinkSearch,"g").replace("reflink",F.reflink).replace("nolink",F.nolink).getRegex(),F.normal=k({},F),F.pedantic=k({},F.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:l(/^!?\[(label)\]\((.*?)\)/).replace("label",F._label).getRegex(),reflink:l(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",F._label).getRegex()}),F.gfm=k({},F.normal,{escape:l(F.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),F.gfm.url=l(F.gfm.url,"i").replace("email",F.gfm._extended_email).getRegex(),F.breaks=k({},F.gfm,{br:l(F.br).replace("{2,}","*").getRegex(),text:l(F.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function j(de){return de.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function q(de){var le="",be,ie,fe=de.length;for(be=0;be<fe;be++)ie=de.charCodeAt(be),Math.random()>.5&&(ie="x"+ie.toString(16)),le+="&#"+ie+";";return le}var W=function(){function de(be){this.tokens=[],this.tokens.links=Object.create(null),this.options=be||ee.defaults,this.options.tokenizer=this.options.tokenizer||new z,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var ie={block:T.normal,inline:F.normal};this.options.pedantic?(ie.block=T.pedantic,ie.inline=F.pedantic):this.options.gfm&&(ie.block=T.gfm,this.options.breaks?ie.inline=F.breaks:ie.inline=F.gfm),this.tokenizer.rules=ie}de.lex=function(ie,fe){var ne=new de(fe);return ne.lex(ie)},de.lexInline=function(ie,fe){var ne=new de(fe);return ne.inlineTokens(ie)};var le=de.prototype;return le.lex=function(ie){ie=ie.replace(/\r\n|\r/g,`
`),this.blockTokens(ie,this.tokens);for(var fe;fe=this.inlineQueue.shift();)this.inlineTokens(fe.src,fe.tokens);return this.tokens},le.blockTokens=function(ie,fe){var ne=this;fe===void 0&&(fe=[]),this.options.pedantic?ie=ie.replace(/\t/g,"    ").replace(/^ +$/gm,""):ie=ie.replace(/^( *)(\t+)/gm,function(Y,X,H){return X+"    ".repeat(H.length)});for(var ce,pe,Ce,L;ie;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Y){return(ce=Y.call({lexer:ne},ie,fe))?(ie=ie.substring(ce.raw.length),fe.push(ce),!0):!1}))){if(ce=this.tokenizer.space(ie)){ie=ie.substring(ce.raw.length),ce.raw.length===1&&fe.length>0?fe[fe.length-1].raw+=`
`:fe.push(ce);continue}if(ce=this.tokenizer.code(ie)){ie=ie.substring(ce.raw.length),pe=fe[fe.length-1],pe&&(pe.type==="paragraph"||pe.type==="text")?(pe.raw+=`
`+ce.raw,pe.text+=`
`+ce.text,this.inlineQueue[this.inlineQueue.length-1].src=pe.text):fe.push(ce);continue}if(ce=this.tokenizer.fences(ie)){ie=ie.substring(ce.raw.length),fe.push(ce);continue}if(ce=this.tokenizer.heading(ie)){ie=ie.substring(ce.raw.length),fe.push(ce);continue}if(ce=this.tokenizer.hr(ie)){ie=ie.substring(ce.raw.length),fe.push(ce);continue}if(ce=this.tokenizer.blockquote(ie)){ie=ie.substring(ce.raw.length),fe.push(ce);continue}if(ce=this.tokenizer.list(ie)){ie=ie.substring(ce.raw.length),fe.push(ce);continue}if(ce=this.tokenizer.html(ie)){ie=ie.substring(ce.raw.length),fe.push(ce);continue}if(ce=this.tokenizer.def(ie)){ie=ie.substring(ce.raw.length),pe=fe[fe.length-1],pe&&(pe.type==="paragraph"||pe.type==="text")?(pe.raw+=`
`+ce.raw,pe.text+=`
`+ce.raw,this.inlineQueue[this.inlineQueue.length-1].src=pe.text):this.tokens.links[ce.tag]||(this.tokens.links[ce.tag]={href:ce.href,title:ce.title});continue}if(ce=this.tokenizer.table(ie)){ie=ie.substring(ce.raw.length),fe.push(ce);continue}if(ce=this.tokenizer.lheading(ie)){ie=ie.substring(ce.raw.length),fe.push(ce);continue}if(Ce=ie,this.options.extensions&&this.options.extensions.startBlock&&function(){var Y=1/0,X=ie.slice(1),H=void 0;ne.options.extensions.startBlock.forEach(function(x){H=x.call({lexer:this},X),typeof H=="number"&&H>=0&&(Y=Math.min(Y,H))}),Y<1/0&&Y>=0&&(Ce=ie.substring(0,Y+1))}(),this.state.top&&(ce=this.tokenizer.paragraph(Ce))){pe=fe[fe.length-1],L&&pe.type==="paragraph"?(pe.raw+=`
`+ce.raw,pe.text+=`
`+ce.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=pe.text):fe.push(ce),L=Ce.length!==ie.length,ie=ie.substring(ce.raw.length);continue}if(ce=this.tokenizer.text(ie)){ie=ie.substring(ce.raw.length),pe=fe[fe.length-1],pe&&pe.type==="text"?(pe.raw+=`
`+ce.raw,pe.text+=`
`+ce.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=pe.text):fe.push(ce);continue}if(ie){var K="Infinite loop on byte: "+ie.charCodeAt(0);if(this.options.silent){console.error(K);break}else throw new Error(K)}}return this.state.top=!0,fe},le.inline=function(ie,fe){return fe===void 0&&(fe=[]),this.inlineQueue.push({src:ie,tokens:fe}),fe},le.inlineTokens=function(ie,fe){var ne=this;fe===void 0&&(fe=[]);var ce,pe,Ce,L=ie,K,Y,X;if(this.tokens.links){var H=Object.keys(this.tokens.links);if(H.length>0)for(;(K=this.tokenizer.rules.inline.reflinkSearch.exec(L))!=null;)H.includes(K[0].slice(K[0].lastIndexOf("[")+1,-1))&&(L=L.slice(0,K.index)+"["+M("a",K[0].length-2)+"]"+L.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(K=this.tokenizer.rules.inline.blockSkip.exec(L))!=null;)L=L.slice(0,K.index)+"["+M("a",K[0].length-2)+"]"+L.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(K=this.tokenizer.rules.inline.escapedEmSt.exec(L))!=null;)L=L.slice(0,K.index)+"++"+L.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;ie;)if(Y||(X=""),Y=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(se){return(ce=se.call({lexer:ne},ie,fe))?(ie=ie.substring(ce.raw.length),fe.push(ce),!0):!1}))){if(ce=this.tokenizer.escape(ie)){ie=ie.substring(ce.raw.length),fe.push(ce);continue}if(ce=this.tokenizer.tag(ie)){ie=ie.substring(ce.raw.length),pe=fe[fe.length-1],pe&&ce.type==="text"&&pe.type==="text"?(pe.raw+=ce.raw,pe.text+=ce.text):fe.push(ce);continue}if(ce=this.tokenizer.link(ie)){ie=ie.substring(ce.raw.length),fe.push(ce);continue}if(ce=this.tokenizer.reflink(ie,this.tokens.links)){ie=ie.substring(ce.raw.length),pe=fe[fe.length-1],pe&&ce.type==="text"&&pe.type==="text"?(pe.raw+=ce.raw,pe.text+=ce.text):fe.push(ce);continue}if(ce=this.tokenizer.emStrong(ie,L,X)){ie=ie.substring(ce.raw.length),fe.push(ce);continue}if(ce=this.tokenizer.codespan(ie)){ie=ie.substring(ce.raw.length),fe.push(ce);continue}if(ce=this.tokenizer.br(ie)){ie=ie.substring(ce.raw.length),fe.push(ce);continue}if(ce=this.tokenizer.del(ie)){ie=ie.substring(ce.raw.length),fe.push(ce);continue}if(ce=this.tokenizer.autolink(ie,q)){ie=ie.substring(ce.raw.length),fe.push(ce);continue}if(!this.state.inLink&&(ce=this.tokenizer.url(ie,q))){ie=ie.substring(ce.raw.length),fe.push(ce);continue}if(Ce=ie,this.options.extensions&&this.options.extensions.startInline&&function(){var se=1/0,Le=ie.slice(1),je=void 0;ne.options.extensions.startInline.forEach(function(Ye){je=Ye.call({lexer:this},Le),typeof je=="number"&&je>=0&&(se=Math.min(se,je))}),se<1/0&&se>=0&&(Ce=ie.substring(0,se+1))}(),ce=this.tokenizer.inlineText(Ce,j)){ie=ie.substring(ce.raw.length),ce.raw.slice(-1)!=="_"&&(X=ce.raw.slice(-1)),Y=!0,pe=fe[fe.length-1],pe&&pe.type==="text"?(pe.raw+=ce.raw,pe.text+=ce.text):fe.push(ce);continue}if(ie){var x="Infinite loop on byte: "+ie.charCodeAt(0);if(this.options.silent){console.error(x);break}else throw new Error(x)}}return fe},f(de,null,[{key:"rules",get:function(){return{block:T,inline:F}}}]),de}(),we=function(){function de(be){this.options=be||ee.defaults}var le=de.prototype;return le.code=function(ie,fe,ne){var ce=(fe||"").match(/\S*/)[0];if(this.options.highlight){var pe=this.options.highlight(ie,ce);pe!=null&&pe!==ie&&(ne=!0,ie=pe)}return ie=ie.replace(/\n$/,"")+`
`,ce?'<pre><code class="'+this.options.langPrefix+p(ce,!0)+'">'+(ne?ie:p(ie,!0))+`</code></pre>
`:"<pre><code>"+(ne?ie:p(ie,!0))+`</code></pre>
`},le.blockquote=function(ie){return`<blockquote>
`+ie+`</blockquote>
`},le.html=function(ie){return ie},le.heading=function(ie,fe,ne,ce){if(this.options.headerIds){var pe=this.options.headerPrefix+ce.slug(ne);return"<h"+fe+' id="'+pe+'">'+ie+"</h"+fe+`>
`}return"<h"+fe+">"+ie+"</h"+fe+`>
`},le.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},le.list=function(ie,fe,ne){var ce=fe?"ol":"ul",pe=fe&&ne!==1?' start="'+ne+'"':"";return"<"+ce+pe+`>
`+ie+"</"+ce+`>
`},le.listitem=function(ie){return"<li>"+ie+`</li>
`},le.checkbox=function(ie){return"<input "+(ie?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},le.paragraph=function(ie){return"<p>"+ie+`</p>
`},le.table=function(ie,fe){return fe&&(fe="<tbody>"+fe+"</tbody>"),`<table>
<thead>
`+ie+`</thead>
`+fe+`</table>
`},le.tablerow=function(ie){return`<tr>
`+ie+`</tr>
`},le.tablecell=function(ie,fe){var ne=fe.header?"th":"td",ce=fe.align?"<"+ne+' align="'+fe.align+'">':"<"+ne+">";return ce+ie+("</"+ne+`>
`)},le.strong=function(ie){return"<strong>"+ie+"</strong>"},le.em=function(ie){return"<em>"+ie+"</em>"},le.codespan=function(ie){return"<code>"+ie+"</code>"},le.br=function(){return this.options.xhtml?"<br/>":"<br>"},le.del=function(ie){return"<del>"+ie+"</del>"},le.link=function(ie,fe,ne){if(ie=m(this.options.sanitize,this.options.baseUrl,ie),ie===null)return ne;var ce='<a href="'+p(ie)+'"';return fe&&(ce+=' title="'+fe+'"'),ce+=">"+ne+"</a>",ce},le.image=function(ie,fe,ne){if(ie=m(this.options.sanitize,this.options.baseUrl,ie),ie===null)return ne;var ce='<img src="'+ie+'" alt="'+ne+'"';return fe&&(ce+=' title="'+fe+'"'),ce+=this.options.xhtml?"/>":">",ce},le.text=function(ie){return ie},de}(),ke=function(){function de(){}var le=de.prototype;return le.strong=function(ie){return ie},le.em=function(ie){return ie},le.codespan=function(ie){return ie},le.del=function(ie){return ie},le.html=function(ie){return ie},le.text=function(ie){return ie},le.link=function(ie,fe,ne){return""+ne},le.image=function(ie,fe,ne){return""+ne},le.br=function(){return""},de}(),Se=function(){function de(){this.seen={}}var le=de.prototype;return le.serialize=function(ie){return ie.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},le.getNextSafeSlug=function(ie,fe){var ne=ie,ce=0;if(this.seen.hasOwnProperty(ne)){ce=this.seen[ie];do ce++,ne=ie+"-"+ce;while(this.seen.hasOwnProperty(ne))}return fe||(this.seen[ie]=ce,this.seen[ne]=0),ne},le.slug=function(ie,fe){fe===void 0&&(fe={});var ne=this.serialize(ie);return this.getNextSafeSlug(ne,fe.dryrun)},de}(),ve=function(){function de(be){this.options=be||ee.defaults,this.options.renderer=this.options.renderer||new we,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new ke,this.slugger=new Se}de.parse=function(ie,fe){var ne=new de(fe);return ne.parse(ie)},de.parseInline=function(ie,fe){var ne=new de(fe);return ne.parseInline(ie)};var le=de.prototype;return le.parse=function(ie,fe){fe===void 0&&(fe=!0);var ne="",ce,pe,Ce,L,K,Y,X,H,x,se,Le,je,Ye,Ke,tt,xe,et,rt,nt,Ue=ie.length;for(ce=0;ce<Ue;ce++){if(se=ie[ce],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[se.type]&&(nt=this.options.extensions.renderers[se.type].call({parser:this},se),nt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(se.type))){ne+=nt||"";continue}switch(se.type){case"space":continue;case"hr":{ne+=this.renderer.hr();continue}case"heading":{ne+=this.renderer.heading(this.parseInline(se.tokens),se.depth,t(this.parseInline(se.tokens,this.textRenderer)),this.slugger);continue}case"code":{ne+=this.renderer.code(se.text,se.lang,se.escaped);continue}case"table":{for(H="",X="",L=se.header.length,pe=0;pe<L;pe++)X+=this.renderer.tablecell(this.parseInline(se.header[pe].tokens),{header:!0,align:se.align[pe]});for(H+=this.renderer.tablerow(X),x="",L=se.rows.length,pe=0;pe<L;pe++){for(Y=se.rows[pe],X="",K=Y.length,Ce=0;Ce<K;Ce++)X+=this.renderer.tablecell(this.parseInline(Y[Ce].tokens),{header:!1,align:se.align[Ce]});x+=this.renderer.tablerow(X)}ne+=this.renderer.table(H,x);continue}case"blockquote":{x=this.parse(se.tokens),ne+=this.renderer.blockquote(x);continue}case"list":{for(Le=se.ordered,je=se.start,Ye=se.loose,L=se.items.length,x="",pe=0;pe<L;pe++)tt=se.items[pe],xe=tt.checked,et=tt.task,Ke="",tt.task&&(rt=this.renderer.checkbox(xe),Ye?tt.tokens.length>0&&tt.tokens[0].type==="paragraph"?(tt.tokens[0].text=rt+" "+tt.tokens[0].text,tt.tokens[0].tokens&&tt.tokens[0].tokens.length>0&&tt.tokens[0].tokens[0].type==="text"&&(tt.tokens[0].tokens[0].text=rt+" "+tt.tokens[0].tokens[0].text)):tt.tokens.unshift({type:"text",text:rt}):Ke+=rt),Ke+=this.parse(tt.tokens,Ye),x+=this.renderer.listitem(Ke,et,xe);ne+=this.renderer.list(x,Le,je);continue}case"html":{ne+=this.renderer.html(se.text);continue}case"paragraph":{ne+=this.renderer.paragraph(this.parseInline(se.tokens));continue}case"text":{for(x=se.tokens?this.parseInline(se.tokens):se.text;ce+1<Ue&&ie[ce+1].type==="text";)se=ie[++ce],x+=`
`+(se.tokens?this.parseInline(se.tokens):se.text);ne+=fe?this.renderer.paragraph(x):x;continue}default:{var lt='Token with "'+se.type+'" type was not found.';if(this.options.silent){console.error(lt);return}else throw new Error(lt)}}}return ne},le.parseInline=function(ie,fe){fe=fe||this.renderer;var ne="",ce,pe,Ce,L=ie.length;for(ce=0;ce<L;ce++){if(pe=ie[ce],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[pe.type]&&(Ce=this.options.extensions.renderers[pe.type].call({parser:this},pe),Ce!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(pe.type))){ne+=Ce||"";continue}switch(pe.type){case"escape":{ne+=fe.text(pe.text);break}case"html":{ne+=fe.html(pe.text);break}case"link":{ne+=fe.link(pe.href,pe.title,this.parseInline(pe.tokens,fe));break}case"image":{ne+=fe.image(pe.href,pe.title,pe.text);break}case"strong":{ne+=fe.strong(this.parseInline(pe.tokens,fe));break}case"em":{ne+=fe.em(this.parseInline(pe.tokens,fe));break}case"codespan":{ne+=fe.codespan(pe.text);break}case"br":{ne+=fe.br();break}case"del":{ne+=fe.del(this.parseInline(pe.tokens,fe));break}case"text":{ne+=fe.text(pe.text);break}default:{var K='Token with "'+pe.type+'" type was not found.';if(this.options.silent){console.error(K);return}else throw new Error(K)}}}return ne},de}();function ge(de,le,be){if(typeof de>"u"||de===null)throw new Error("marked(): input parameter is undefined or null");if(typeof de!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(de)+", string expected");if(typeof le=="function"&&(be=le,le=null),le=k({},ge.defaults,le||{}),y(le),be){var ie=le.highlight,fe;try{fe=W.lex(de,le)}catch(L){return be(L)}var ne=function(K){var Y;if(!K)try{le.walkTokens&&ge.walkTokens(fe,le.walkTokens),Y=ve.parse(fe,le)}catch(X){K=X}return le.highlight=ie,K?be(K):be(null,Y)};if(!ie||ie.length<3||(delete le.highlight,!fe.length))return ne();var ce=0;ge.walkTokens(fe,function(L){L.type==="code"&&(ce++,setTimeout(function(){ie(L.text,L.lang,function(K,Y){if(K)return ne(K);Y!=null&&Y!==L.text&&(L.text=Y,L.escaped=!0),ce--,ce===0&&ne()})},0))}),ce===0&&ne();return}function pe(L){if(L.message+=`
Please report this to https://github.com/markedjs/marked.`,le.silent)return"<p>An error occurred:</p><pre>"+p(L.message+"",!0)+"</pre>";throw L}try{var Ce=W.lex(de,le);if(le.walkTokens){if(le.async)return Promise.all(ge.walkTokens(Ce,le.walkTokens)).then(function(){return ve.parse(Ce,le)}).catch(pe);ge.walkTokens(Ce,le.walkTokens)}return ve.parse(Ce,le)}catch(L){pe(L)}}ge.options=ge.setOptions=function(de){return k(ge.defaults,de),c(ge.defaults),ge},ge.getDefaults=A,ge.defaults=ee.defaults,ge.use=function(){for(var de=arguments.length,le=new Array(de),be=0;be<de;be++)le[be]=arguments[be];var ie=k.apply(void 0,[{}].concat(le)),fe=ge.defaults.extensions||{renderers:{},childTokens:{}},ne;le.forEach(function(ce){if(ce.extensions&&(ne=!0,ce.extensions.forEach(function(Ce){if(!Ce.name)throw new Error("extension name required");if(Ce.renderer){var L=fe.renderers?fe.renderers[Ce.name]:null;L?fe.renderers[Ce.name]=function(){for(var K=arguments.length,Y=new Array(K),X=0;X<K;X++)Y[X]=arguments[X];var H=Ce.renderer.apply(this,Y);return H===!1&&(H=L.apply(this,Y)),H}:fe.renderers[Ce.name]=Ce.renderer}if(Ce.tokenizer){if(!Ce.level||Ce.level!=="block"&&Ce.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");fe[Ce.level]?fe[Ce.level].unshift(Ce.tokenizer):fe[Ce.level]=[Ce.tokenizer],Ce.start&&(Ce.level==="block"?fe.startBlock?fe.startBlock.push(Ce.start):fe.startBlock=[Ce.start]:Ce.level==="inline"&&(fe.startInline?fe.startInline.push(Ce.start):fe.startInline=[Ce.start]))}Ce.childTokens&&(fe.childTokens[Ce.name]=Ce.childTokens)})),ce.renderer&&function(){var Ce=ge.defaults.renderer||new we,L=function(X){var H=Ce[X];Ce[X]=function(){for(var x=arguments.length,se=new Array(x),Le=0;Le<x;Le++)se[Le]=arguments[Le];var je=ce.renderer[X].apply(Ce,se);return je===!1&&(je=H.apply(Ce,se)),je}};for(var K in ce.renderer)L(K);ie.renderer=Ce}(),ce.tokenizer&&function(){var Ce=ge.defaults.tokenizer||new z,L=function(X){var H=Ce[X];Ce[X]=function(){for(var x=arguments.length,se=new Array(x),Le=0;Le<x;Le++)se[Le]=arguments[Le];var je=ce.tokenizer[X].apply(Ce,se);return je===!1&&(je=H.apply(Ce,se)),je}};for(var K in ce.tokenizer)L(K);ie.tokenizer=Ce}(),ce.walkTokens){var pe=ge.defaults.walkTokens;ie.walkTokens=function(Ce){var L=[];return L.push(ce.walkTokens.call(this,Ce)),pe&&(L=L.concat(pe.call(this,Ce))),L}}ne&&(ie.extensions=fe),ge.setOptions(ie)})},ge.walkTokens=function(de,le){for(var be=[],ie=function(){var pe=ne.value;switch(be=be.concat(le.call(ge,pe)),pe.type){case"table":{for(var Ce=O(pe.header),L;!(L=Ce()).done;){var K=L.value;be=be.concat(ge.walkTokens(K.tokens,le))}for(var Y=O(pe.rows),X;!(X=Y()).done;)for(var H=X.value,x=O(H),se;!(se=x()).done;){var Le=se.value;be=be.concat(ge.walkTokens(Le.tokens,le))}break}case"list":{be=be.concat(ge.walkTokens(pe.items,le));break}default:ge.defaults.extensions&&ge.defaults.extensions.childTokens&&ge.defaults.extensions.childTokens[pe.type]?ge.defaults.extensions.childTokens[pe.type].forEach(function(je){be=be.concat(ge.walkTokens(pe[je],le))}):pe.tokens&&(be=be.concat(ge.walkTokens(pe.tokens,le)))}},fe=O(de),ne;!(ne=fe()).done;)ie();return be},ge.parseInline=function(de,le){if(typeof de>"u"||de===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof de!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(de)+", string expected");le=k({},ge.defaults,le||{}),y(le);try{var be=W.lexInline(de,le);return le.walkTokens&&ge.walkTokens(be,le.walkTokens),ve.parseInline(be,le)}catch(ie){if(ie.message+=`
Please report this to https://github.com/markedjs/marked.`,le.silent)return"<p>An error occurred:</p><pre>"+p(ie.message+"",!0)+"</pre>";throw ie}},ge.Parser=ve,ge.parser=ve.parse,ge.Renderer=we,ge.TextRenderer=ke,ge.Lexer=W,ge.lexer=W.lex,ge.Tokenizer=z,ge.Slugger=Se,ge.parse=ge;var re=ge.options,oe=ge.setOptions,ye=ge.use,De=ge.walkTokens,Q=ge.parseInline,ue=ge,J=ve.parse,he=W.lex;ee.Lexer=W,ee.Parser=ve,ee.Renderer=we,ee.Slugger=Se,ee.TextRenderer=ke,ee.Tokenizer=z,ee.getDefaults=A,ee.lexer=he,ee.marked=ge,ee.options=re,ee.parse=ue,ee.parseInline=Q,ee.parser=J,ee.setOptions=oe,ee.use=ye,ee.walkTokens=De,Object.defineProperty(ee,"__esModule",{value:!0})}),define(Ae[117],Re([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ul=e.$Tl=e.$Sl=e.rot=e.$Ql=void 0;function f(c,E,d){return Math.min(Math.max(c,E),d)}e.$Ql=f;function C(c,E){return(E+c%E)%E}e.rot=C;class I{constructor(){this.a=0}getNext(){return this.a++}}e.$Sl=I;class O{constructor(){this.a=1,this.b=0}update(E){return this.b=this.b+(E-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Tl=O;class A{constructor(E){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(E),this.c.fill(0,0,E)}update(E){const d=this.c[this.d];return this.c[this.d]=E,this.d=(this.d+1)%this.c.length,this.e-=d,this.e+=E,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Ul=A}),function(){function ee(I){const O=[];typeof I=="number"&&O.push("code/timeOrigin",I);function A(E){O.push(E,Date.now())}function c(){const E=[];for(let d=0;d<O.length;d+=2)E.push({name:O[d],startTime:O[d+1]});return E}return{mark:A,getMarks:c}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ee():{mark(I){performance.mark(I)},getMarks(){let I=performance.timeOrigin;typeof I!="number"&&(I=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const O=[{name:"code/timeOrigin",startTime:Math.round(I)}];for(const A of performance.getEntriesByType("mark"))O.push({name:A.name,startTime:Math.round(I+A.startTime)});return O}};if(typeof process=="object"){const I=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return ee(I)}else return console.trace("perf-util loaded in UNKNOWN environment"),ee()}function f(I){return I.MonacoPerformanceMarks||(I.MonacoPerformanceMarks=e()),I.MonacoPerformanceMarks}var C;typeof global=="object"?C=global:typeof self=="object"?C=self:C={},typeof define=="function"?define("vs/base/common/performance",[],function(){return f(C)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=f(C):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),C.perf=f(C))}(),define(Ae[118],Re([1,0,42,20]),function(ee,e,f,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yq=e.$xq=e.$wq=e.$vq=e.$uq=e.$tq=e.$sq=e.$rq=e.$qq=e.$pq=e.$oq=e.$nq=e.$mq=void 0;const I=new f.$V(()=>{const P=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:P,collatorIsNumeric:P.resolvedOptions().numeric}}),O=new f.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),A=new f.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function c(P,h,w=!1){const y=P||"",M=h||"",V=I.value.collator.compare(y,M);return I.value.collatorIsNumeric&&V===0&&y!==M?y<M?-1:1:V}e.$mq=c;function E(P,h){const w=O.value.collator;return P=P||"",h=h||"",D(w,P,h)}e.$nq=E;function d(P,h){const w=O.value.collator;return P=P||"",h=h||"",s(P,h)||D(w,P,h)}e.$oq=d;function R(P,h){const w=O.value.collator;return P=P||"",h=h||"",r(P,h)||D(w,P,h)}e.$pq=R;function S(P,h){return P=P||"",h=h||"",P===h?0:P<h?-1:1}e.$qq=S;function u(P,h){const[w,y]=l(P),[M,V]=l(h);let B=I.value.collator.compare(y,V);if(B===0){if(I.value.collatorIsNumeric&&y!==V)return y<V?-1:1;if(B=I.value.collator.compare(w,M),I.value.collatorIsNumeric&&B===0&&w!==M)return w<M?-1:1}return B}e.$rq=u;function b(P,h){P=P||"",h=h||"";const w=v(P),y=v(h),M=O.value.collator,V=A.value.collator;return D(V,w,y)||D(M,P,h)}e.$sq=b;function p(P,h){P=P||"",h=h||"";const w=v(P),y=v(h),M=O.value.collator,V=A.value.collator;return D(V,w,y)||s(P,h)||D(M,P,h)}e.$tq=p;function g(P,h){P=P||"",h=h||"";const w=v(P),y=v(h),M=O.value.collator,V=A.value.collator;return D(V,w,y)||r(P,h)||D(M,P,h)}e.$uq=g;function t(P,h){P=P||"",h=h||"";const w=v(P).toLowerCase(),y=v(h).toLowerCase();return w!==y?w<y?-1:1:P!==h?P<h?-1:1:0}e.$vq=t;const i=/^(.*?)(\.([^.]*))?$/;function l(P,h=!1){const w=P?i.exec(P):[];let y=[w&&w[1]||"",w&&w[3]||""];return h&&(!y[0]&&y[1]||y[0]&&y[0].charAt(0)===".")&&(y=[y[0]+"."+y[1],""]),y}function v(P){const h=P?i.exec(P):[];return h&&h[1]&&h[1].charAt(0)!=="."&&h[3]||""}function D(P,h,w){const y=P.compare(h,w);return y!==0?y:h.length!==w.length?h.length<w.length?-1:1:0}function m(P){const h=P.charAt(0);return h.toLocaleUpperCase()!==h}function n(P){const h=P.charAt(0);return h.toLocaleLowerCase()!==h}function r(P,h){return m(P)&&n(h)?-1:n(P)&&m(h)?1:0}function s(P,h){return n(P)&&m(h)?-1:m(P)&&n(h)?1:0}function o(P,h,w=!1){return w||(P=P&&P.toLowerCase(),h=h&&h.toLowerCase()),P===h?0:P<h?-1:1}function $(P,h,w=!1){const y=P.split(C.sep),M=h.split(C.sep),V=y.length-1,B=M.length-1;let z,T;for(let F=0;;F++){if(z=V===F,T=B===F,z&&T)return c(y[F],M[F],w);if(z)return-1;if(T)return 1;const j=o(y[F],M[F],w);if(j!==0)return j}}e.$wq=$;function a(P,h,w){const y=P.toLowerCase(),M=h.toLowerCase(),V=k(P,h,w);if(V)return V;const B=y.endsWith(w),z=M.endsWith(w);if(B!==z)return B?-1:1;const T=c(y,M);return T!==0?T:y.localeCompare(M)}e.$xq=a;function k(P,h,w){const y=P.toLowerCase(),M=h.toLowerCase(),V=y.startsWith(w),B=M.startsWith(w);if(V!==B)return V?-1:1;if(V&&B){if(y.length<M.length)return-1;if(y.length>M.length)return 1}return 0}e.$yq=k}),define(Ae[66],Re([1,0,20]),function(ee,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yr=e.$Xr=e.$Wr=e.$Vr=e.$Ur=void 0,e.$Ur=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const C={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},I={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function O(R){const S=(0,f.$oc)(R),u=C[S.toLowerCase()];return u!==void 0?u:A(R)}e.$Vr=O;function A(R){const S=(0,f.$oc)(R);return I[S.toLowerCase()]}e.$Wr=A;function c(R){for(const S in I)if(I[S]===R)return S}e.$Xr=c;const E=/^(.+)\/(.+?)(;.+)?$/;function d(R,S){const u=E.exec(R);return u?`${u[1].toLowerCase()}/${u[2].toLowerCase()}${u[3]??""}`:S?void 0:R}e.$Yr=d}),function(ee,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var f=e();for(var C in f)(typeof exports=="object"?exports:ee)[C]=f[C]}}(typeof self<"u"?self:this,function(){return function(ee){var e={};function f(C){if(e[C])return e[C].exports;var I=e[C]={i:C,l:!1,exports:{}};return ee[C].call(I.exports,I,I.exports,f),I.l=!0,I.exports}return f.m=ee,f.c=e,f.d=function(C,I,O){f.o(C,I)||Object.defineProperty(C,I,{enumerable:!0,get:O})},f.r=function(C){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(C,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(C,"__esModule",{value:!0})},f.t=function(C,I){if(1&I&&(C=f(C)),8&I||4&I&&typeof C=="object"&&C&&C.__esModule)return C;var O=Object.create(null);if(f.r(O),Object.defineProperty(O,"default",{enumerable:!0,value:C}),2&I&&typeof C!="string")for(var A in C)f.d(O,A,function(c){return C[c]}.bind(null,A));return O},f.n=function(C){var I=C&&C.__esModule?function(){return C.default}:function(){return C};return f.d(I,"a",I),I},f.o=function(C,I){return Object.prototype.hasOwnProperty.call(C,I)},f.p="",f(f.s=0)}([function(ee,e,f){(function(C){var I;e=ee.exports=ye,I=typeof C=="object"&&C.env&&C.env.NODE_DEBUG&&/\bsemver\b/i.test(C.env.NODE_DEBUG)?function(){var H=Array.prototype.slice.call(arguments,0);H.unshift("SEMVER"),console.log.apply(console,H)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var O=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,c=e.re=[],E=e.src=[],d=0,R=d++;E[R]="0|[1-9]\\d*";var S=d++;E[S]="[0-9]+";var u=d++;E[u]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var b=d++;E[b]="("+E[R]+")\\.("+E[R]+")\\.("+E[R]+")";var p=d++;E[p]="("+E[S]+")\\.("+E[S]+")\\.("+E[S]+")";var g=d++;E[g]="(?:"+E[R]+"|"+E[u]+")";var t=d++;E[t]="(?:"+E[S]+"|"+E[u]+")";var i=d++;E[i]="(?:-("+E[g]+"(?:\\."+E[g]+")*))";var l=d++;E[l]="(?:-?("+E[t]+"(?:\\."+E[t]+")*))";var v=d++;E[v]="[0-9A-Za-z-]+";var D=d++;E[D]="(?:\\+("+E[v]+"(?:\\."+E[v]+")*))";var m=d++,n="v?"+E[b]+E[i]+"?"+E[D]+"?";E[m]="^"+n+"$";var r="[v=\\s]*"+E[p]+E[l]+"?"+E[D]+"?",s=d++;E[s]="^"+r+"$";var o=d++;E[o]="((?:<|>)?=?)";var $=d++;E[$]=E[S]+"|x|X|\\*";var a=d++;E[a]=E[R]+"|x|X|\\*";var k=d++;E[k]="[v=\\s]*("+E[a]+")(?:\\.("+E[a]+")(?:\\.("+E[a]+")(?:"+E[i]+")?"+E[D]+"?)?)?";var P=d++;E[P]="[v=\\s]*("+E[$]+")(?:\\.("+E[$]+")(?:\\.("+E[$]+")(?:"+E[l]+")?"+E[D]+"?)?)?";var h=d++;E[h]="^"+E[o]+"\\s*"+E[k]+"$";var w=d++;E[w]="^"+E[o]+"\\s*"+E[P]+"$";var y=d++;E[y]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var M=d++;E[M]="(?:~>?)";var V=d++;E[V]="(\\s*)"+E[M]+"\\s+",c[V]=new RegExp(E[V],"g");var B=d++;E[B]="^"+E[M]+E[k]+"$";var z=d++;E[z]="^"+E[M]+E[P]+"$";var T=d++;E[T]="(?:\\^)";var F=d++;E[F]="(\\s*)"+E[T]+"\\s+",c[F]=new RegExp(E[F],"g");var j=d++;E[j]="^"+E[T]+E[k]+"$";var q=d++;E[q]="^"+E[T]+E[P]+"$";var W=d++;E[W]="^"+E[o]+"\\s*("+r+")$|^$";var we=d++;E[we]="^"+E[o]+"\\s*("+n+")$|^$";var ke=d++;E[ke]="(\\s*)"+E[o]+"\\s*("+r+"|"+E[k]+")",c[ke]=new RegExp(E[ke],"g");var Se=d++;E[Se]="^\\s*("+E[k]+")\\s+-\\s+("+E[k]+")\\s*$";var ve=d++;E[ve]="^\\s*("+E[P]+")\\s+-\\s+("+E[P]+")\\s*$";var ge=d++;E[ge]="(<|>)?=?\\s*\\*";for(var re=0;re<35;re++)I(re,E[re]),c[re]||(c[re]=new RegExp(E[re]));function oe(H,x){if(H instanceof ye)return H;if(typeof H!="string"||H.length>O||!(x?c[s]:c[m]).test(H))return null;try{return new ye(H,x)}catch{return null}}function ye(H,x){if(H instanceof ye){if(H.loose===x)return H;H=H.version}else if(typeof H!="string")throw new TypeError("Invalid Version: "+H);if(H.length>O)throw new TypeError("version is longer than "+O+" characters");if(!(this instanceof ye))return new ye(H,x);I("SemVer",H,x),this.loose=x;var se=H.trim().match(x?c[s]:c[m]);if(!se)throw new TypeError("Invalid Version: "+H);if(this.raw=H,this.major=+se[1],this.minor=+se[2],this.patch=+se[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");se[4]?this.prerelease=se[4].split(".").map(function(Le){if(/^[0-9]+$/.test(Le)){var je=+Le;if(je>=0&&je<A)return je}return Le}):this.prerelease=[],this.build=se[5]?se[5].split("."):[],this.format()}e.parse=oe,e.valid=function(H,x){var se=oe(H,x);return se?se.version:null},e.clean=function(H,x){var se=oe(H.trim().replace(/^[=v]+/,""),x);return se?se.version:null},e.SemVer=ye,ye.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},ye.prototype.toString=function(){return this.version},ye.prototype.compare=function(H){return I("SemVer.compare",this.version,this.loose,H),H instanceof ye||(H=new ye(H,this.loose)),this.compareMain(H)||this.comparePre(H)},ye.prototype.compareMain=function(H){return H instanceof ye||(H=new ye(H,this.loose)),Q(this.major,H.major)||Q(this.minor,H.minor)||Q(this.patch,H.patch)},ye.prototype.comparePre=function(H){if(H instanceof ye||(H=new ye(H,this.loose)),this.prerelease.length&&!H.prerelease.length)return-1;if(!this.prerelease.length&&H.prerelease.length)return 1;if(!this.prerelease.length&&!H.prerelease.length)return 0;var x=0;do{var se=this.prerelease[x],Le=H.prerelease[x];if(I("prerelease compare",x,se,Le),se===void 0&&Le===void 0)return 0;if(Le===void 0)return 1;if(se===void 0)return-1;if(se!==Le)return Q(se,Le)}while(++x)},ye.prototype.inc=function(H,x){switch(H){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",x);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",x);break;case"prepatch":this.prerelease.length=0,this.inc("patch",x),this.inc("pre",x);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",x),this.inc("pre",x);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var se=this.prerelease.length;--se>=0;)typeof this.prerelease[se]=="number"&&(this.prerelease[se]++,se=-2);se===-1&&this.prerelease.push(0)}x&&(this.prerelease[0]===x?isNaN(this.prerelease[1])&&(this.prerelease=[x,0]):this.prerelease=[x,0]);break;default:throw new Error("invalid increment argument: "+H)}return this.format(),this.raw=this.version,this},e.inc=function(H,x,se,Le){typeof se=="string"&&(Le=se,se=void 0);try{return new ye(H,se).inc(x,Le).version}catch{return null}},e.diff=function(H,x){if(de(H,x))return null;var se=oe(H),Le=oe(x);if(se.prerelease.length||Le.prerelease.length){for(var je in se)if((je==="major"||je==="minor"||je==="patch")&&se[je]!==Le[je])return"pre"+je;return"prerelease"}for(var je in se)if((je==="major"||je==="minor"||je==="patch")&&se[je]!==Le[je])return je},e.compareIdentifiers=Q;var De=/^[0-9]+$/;function Q(H,x){var se=De.test(H),Le=De.test(x);return se&&Le&&(H=+H,x=+x),se&&!Le?-1:Le&&!se?1:H<x?-1:H>x?1:0}function ue(H,x,se){return new ye(H,se).compare(new ye(x,se))}function J(H,x,se){return ue(H,x,se)>0}function he(H,x,se){return ue(H,x,se)<0}function de(H,x,se){return ue(H,x,se)===0}function le(H,x,se){return ue(H,x,se)!==0}function be(H,x,se){return ue(H,x,se)>=0}function ie(H,x,se){return ue(H,x,se)<=0}function fe(H,x,se,Le){var je;switch(x){case"===":typeof H=="object"&&(H=H.version),typeof se=="object"&&(se=se.version),je=H===se;break;case"!==":typeof H=="object"&&(H=H.version),typeof se=="object"&&(se=se.version),je=H!==se;break;case"":case"=":case"==":je=de(H,se,Le);break;case"!=":je=le(H,se,Le);break;case">":je=J(H,se,Le);break;case">=":je=be(H,se,Le);break;case"<":je=he(H,se,Le);break;case"<=":je=ie(H,se,Le);break;default:throw new TypeError("Invalid operator: "+x)}return je}function ne(H,x){if(H instanceof ne){if(H.loose===x)return H;H=H.value}if(!(this instanceof ne))return new ne(H,x);I("comparator",H,x),this.loose=x,this.parse(H),this.semver===ce?this.value="":this.value=this.operator+this.semver.version,I("comp",this)}e.rcompareIdentifiers=function(H,x){return Q(x,H)},e.major=function(H,x){return new ye(H,x).major},e.minor=function(H,x){return new ye(H,x).minor},e.patch=function(H,x){return new ye(H,x).patch},e.compare=ue,e.compareLoose=function(H,x){return ue(H,x,!0)},e.rcompare=function(H,x,se){return ue(x,H,se)},e.sort=function(H,x){return H.sort(function(se,Le){return e.compare(se,Le,x)})},e.rsort=function(H,x){return H.sort(function(se,Le){return e.rcompare(se,Le,x)})},e.gt=J,e.lt=he,e.eq=de,e.neq=le,e.gte=be,e.lte=ie,e.cmp=fe,e.Comparator=ne;var ce={};function pe(H,x){if(H instanceof pe)return H.loose===x?H:new pe(H.raw,x);if(H instanceof ne)return new pe(H.value,x);if(!(this instanceof pe))return new pe(H,x);if(this.loose=x,this.raw=H,this.set=H.split(/\s*\|\|\s*/).map(function(se){return this.parseRange(se.trim())},this).filter(function(se){return se.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+H);this.format()}function Ce(H){return!H||H.toLowerCase()==="x"||H==="*"}function L(H,x,se,Le,je,Ye,Ke,tt,xe,et,rt,nt,Ue){return((x=Ce(se)?"":Ce(Le)?">="+se+".0.0":Ce(je)?">="+se+"."+Le+".0":">="+x)+" "+(tt=Ce(xe)?"":Ce(et)?"<"+(+xe+1)+".0.0":Ce(rt)?"<"+xe+"."+(+et+1)+".0":nt?"<="+xe+"."+et+"."+rt+"-"+nt:"<="+tt)).trim()}function K(H,x){for(var se=0;se<H.length;se++)if(!H[se].test(x))return!1;if(x.prerelease.length){for(se=0;se<H.length;se++)if(I(H[se].semver),H[se].semver!==ce&&H[se].semver.prerelease.length>0){var Le=H[se].semver;if(Le.major===x.major&&Le.minor===x.minor&&Le.patch===x.patch)return!0}return!1}return!0}function Y(H,x,se){try{x=new pe(x,se)}catch{return!1}return x.test(H)}function X(H,x,se,Le){var je,Ye,Ke,tt,xe;switch(H=new ye(H,Le),x=new pe(x,Le),se){case">":je=J,Ye=ie,Ke=he,tt=">",xe=">=";break;case"<":je=he,Ye=be,Ke=J,tt="<",xe="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Y(H,x,Le))return!1;for(var et=0;et<x.set.length;++et){var rt=x.set[et],nt=null,Ue=null;if(rt.forEach(function(lt){lt.semver===ce&&(lt=new ne(">=0.0.0")),nt=nt||lt,Ue=Ue||lt,je(lt.semver,nt.semver,Le)?nt=lt:Ke(lt.semver,Ue.semver,Le)&&(Ue=lt)}),nt.operator===tt||nt.operator===xe||(!Ue.operator||Ue.operator===tt)&&Ye(H,Ue.semver)||Ue.operator===xe&&Ke(H,Ue.semver))return!1}return!0}ne.prototype.parse=function(H){var x=this.loose?c[W]:c[we],se=H.match(x);if(!se)throw new TypeError("Invalid comparator: "+H);this.operator=se[1],this.operator==="="&&(this.operator=""),se[2]?this.semver=new ye(se[2],this.loose):this.semver=ce},ne.prototype.toString=function(){return this.value},ne.prototype.test=function(H){return I("Comparator.test",H,this.loose),this.semver===ce||(typeof H=="string"&&(H=new ye(H,this.loose)),fe(H,this.operator,this.semver,this.loose))},ne.prototype.intersects=function(H,x){if(!(H instanceof ne))throw new TypeError("a Comparator is required");var se;if(this.operator==="")return se=new pe(H.value,x),Y(this.value,se,x);if(H.operator==="")return se=new pe(this.value,x),Y(H.semver,se,x);var Le=!(this.operator!==">="&&this.operator!==">"||H.operator!==">="&&H.operator!==">"),je=!(this.operator!=="<="&&this.operator!=="<"||H.operator!=="<="&&H.operator!=="<"),Ye=this.semver.version===H.semver.version,Ke=!(this.operator!==">="&&this.operator!=="<="||H.operator!==">="&&H.operator!=="<="),tt=fe(this.semver,"<",H.semver,x)&&(this.operator===">="||this.operator===">")&&(H.operator==="<="||H.operator==="<"),xe=fe(this.semver,">",H.semver,x)&&(this.operator==="<="||this.operator==="<")&&(H.operator===">="||H.operator===">");return Le||je||Ye&&Ke||tt||xe},e.Range=pe,pe.prototype.format=function(){return this.range=this.set.map(function(H){return H.join(" ").trim()}).join("||").trim(),this.range},pe.prototype.toString=function(){return this.range},pe.prototype.parseRange=function(H){var x=this.loose;H=H.trim(),I("range",H,x);var se=x?c[ve]:c[Se];H=H.replace(se,L),I("hyphen replace",H),H=H.replace(c[ke],"$1$2$3"),I("comparator trim",H,c[ke]),H=(H=(H=H.replace(c[V],"$1~")).replace(c[F],"$1^")).split(/\s+/).join(" ");var Le=x?c[W]:c[we],je=H.split(" ").map(function(Ye){return function(Ke,tt){return I("comp",Ke),Ke=function(xe,et){return xe.trim().split(/\s+/).map(function(rt){return function(nt,Ue){I("caret",nt,Ue);var lt=Ue?c[q]:c[j];return nt.replace(lt,function(_,Z,Ee,We,ze){var Ze;return I("caret",nt,_,Z,Ee,We,ze),Ce(Z)?Ze="":Ce(Ee)?Ze=">="+Z+".0.0 <"+(+Z+1)+".0.0":Ce(We)?Ze=Z==="0"?">="+Z+"."+Ee+".0 <"+Z+"."+(+Ee+1)+".0":">="+Z+"."+Ee+".0 <"+(+Z+1)+".0.0":ze?(I("replaceCaret pr",ze),ze.charAt(0)!=="-"&&(ze="-"+ze),Ze=Z==="0"?Ee==="0"?">="+Z+"."+Ee+"."+We+ze+" <"+Z+"."+Ee+"."+(+We+1):">="+Z+"."+Ee+"."+We+ze+" <"+Z+"."+(+Ee+1)+".0":">="+Z+"."+Ee+"."+We+ze+" <"+(+Z+1)+".0.0"):(I("no pr"),Ze=Z==="0"?Ee==="0"?">="+Z+"."+Ee+"."+We+" <"+Z+"."+Ee+"."+(+We+1):">="+Z+"."+Ee+"."+We+" <"+Z+"."+(+Ee+1)+".0":">="+Z+"."+Ee+"."+We+" <"+(+Z+1)+".0.0"),I("caret return",Ze),Ze})}(rt,et)}).join(" ")}(Ke,tt),I("caret",Ke),Ke=function(xe,et){return xe.trim().split(/\s+/).map(function(rt){return function(nt,Ue){var lt=Ue?c[z]:c[B];return nt.replace(lt,function(_,Z,Ee,We,ze){var Ze;return I("tilde",nt,_,Z,Ee,We,ze),Ce(Z)?Ze="":Ce(Ee)?Ze=">="+Z+".0.0 <"+(+Z+1)+".0.0":Ce(We)?Ze=">="+Z+"."+Ee+".0 <"+Z+"."+(+Ee+1)+".0":ze?(I("replaceTilde pr",ze),ze.charAt(0)!=="-"&&(ze="-"+ze),Ze=">="+Z+"."+Ee+"."+We+ze+" <"+Z+"."+(+Ee+1)+".0"):Ze=">="+Z+"."+Ee+"."+We+" <"+Z+"."+(+Ee+1)+".0",I("tilde return",Ze),Ze})}(rt,et)}).join(" ")}(Ke,tt),I("tildes",Ke),Ke=function(xe,et){return I("replaceXRanges",xe,et),xe.split(/\s+/).map(function(rt){return function(nt,Ue){nt=nt.trim();var lt=Ue?c[w]:c[h];return nt.replace(lt,function(_,Z,Ee,We,ze,Ze){I("xRange",nt,_,Z,Ee,We,ze,Ze);var st=Ce(Ee),vt=st||Ce(We),yt=vt||Ce(ze);return Z==="="&&yt&&(Z=""),st?_=Z===">"||Z==="<"?"<0.0.0":"*":Z&&yt?(vt&&(We=0),yt&&(ze=0),Z===">"?(Z=">=",vt?(Ee=+Ee+1,We=0,ze=0):yt&&(We=+We+1,ze=0)):Z==="<="&&(Z="<",vt?Ee=+Ee+1:We=+We+1),_=Z+Ee+"."+We+"."+ze):vt?_=">="+Ee+".0.0 <"+(+Ee+1)+".0.0":yt&&(_=">="+Ee+"."+We+".0 <"+Ee+"."+(+We+1)+".0"),I("xRange return",_),_})}(rt,et)}).join(" ")}(Ke,tt),I("xrange",Ke),Ke=function(xe,et){return I("replaceStars",xe,et),xe.trim().replace(c[ge],"")}(Ke,tt),I("stars",Ke),Ke}(Ye,x)}).join(" ").split(/\s+/);return this.loose&&(je=je.filter(function(Ye){return!!Ye.match(Le)})),je=je.map(function(Ye){return new ne(Ye,x)})},pe.prototype.intersects=function(H,x){if(!(H instanceof pe))throw new TypeError("a Range is required");return this.set.some(function(se){return se.every(function(Le){return H.set.some(function(je){return je.every(function(Ye){return Le.intersects(Ye,x)})})})})},e.toComparators=function(H,x){return new pe(H,x).set.map(function(se){return se.map(function(Le){return Le.value}).join(" ").trim().split(" ")})},pe.prototype.test=function(H){if(!H)return!1;typeof H=="string"&&(H=new ye(H,this.loose));for(var x=0;x<this.set.length;x++)if(K(this.set[x],H))return!0;return!1},e.satisfies=Y,e.maxSatisfying=function(H,x,se){var Le=null,je=null;try{var Ye=new pe(x,se)}catch{return null}return H.forEach(function(Ke){Ye.test(Ke)&&(Le&&je.compare(Ke)!==-1||(je=new ye(Le=Ke,se)))}),Le},e.minSatisfying=function(H,x,se){var Le=null,je=null;try{var Ye=new pe(x,se)}catch{return null}return H.forEach(function(Ke){Ye.test(Ke)&&(Le&&je.compare(Ke)!==1||(je=new ye(Le=Ke,se)))}),Le},e.validRange=function(H,x){try{return new pe(H,x).range||"*"}catch{return null}},e.ltr=function(H,x,se){return X(H,x,"<",se)},e.gtr=function(H,x,se){return X(H,x,">",se)},e.outside=X,e.prerelease=function(H,x){var se=oe(H,x);return se&&se.prerelease.length?se.prerelease:null},e.intersects=function(H,x,se){return H=new pe(H,se),x=new pe(x,se),H.intersects(x)},e.coerce=function(H){if(H instanceof ye)return H;if(typeof H!="string")return null;var x=H.match(c[y]);return x==null?null:oe((x[1]||"0")+"."+(x[2]||"0")+"."+(x[3]||"0"))}}).call(this,f(1))},function(ee,e){var f,C,I=ee.exports={};function O(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function c(t){if(f===setTimeout)return setTimeout(t,0);if((f===O||!f)&&setTimeout)return f=setTimeout,setTimeout(t,0);try{return f(t,0)}catch{try{return f.call(null,t,0)}catch{return f.call(this,t,0)}}}(function(){try{f=typeof setTimeout=="function"?setTimeout:O}catch{f=O}try{C=typeof clearTimeout=="function"?clearTimeout:A}catch{C=A}})();var E,d=[],R=!1,S=-1;function u(){R&&E&&(R=!1,E.length?d=E.concat(d):S=-1,d.length&&b())}function b(){if(!R){var t=c(u);R=!0;for(var i=d.length;i;){for(E=d,d=[];++S<i;)E&&E[S].run();S=-1,i=d.length}E=null,R=!1,function(l){if(C===clearTimeout)return clearTimeout(l);if((C===A||!C)&&clearTimeout)return C=clearTimeout,clearTimeout(l);try{C(l)}catch{try{return C.call(null,l)}catch{return C.call(this,l)}}}(t)}}function p(t,i){this.fun=t,this.array=i}function g(){}I.nextTick=function(t){var i=new Array(arguments.length-1);if(arguments.length>1)for(var l=1;l<arguments.length;l++)i[l-1]=arguments[l];d.push(new p(t,i)),d.length!==1||R||c(b)},p.prototype.run=function(){this.fun.apply(null,this.array)},I.title="browser",I.browser=!0,I.env={},I.argv=[],I.version="",I.versions={},I.on=g,I.addListener=g,I.once=g,I.off=g,I.removeListener=g,I.removeAllListeners=g,I.emit=g,I.prependListener=g,I.prependOnceListener=g,I.listeners=function(t){return[]},I.binding=function(t){throw new Error("process.binding is not supported")},I.cwd=function(){return"/"},I.chdir=function(t){throw new Error("process.chdir is not supported")},I.umask=function(){return 0}}])}),define(Ae[119],Re([1,0,11,6]),function(ee,e,f,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=e.$4d=e.$3d=e.$2d=e.$1d=e.$Zd=void 0;function I(D){const m=D;return m?typeof m.read=="function":!1}e.$Zd=I;function O(D){const m=D;return m?[m.on,m.pause,m.resume,m.destroy].every(n=>typeof n=="function"):!1}e.$1d=O;function A(D){const m=D;return m?O(m.stream)&&Array.isArray(m.buffer)&&typeof m.ended=="boolean":!1}e.$2d=A;function c(D,m){return new E(D,m)}e.$3d=c;class E{constructor(m,n){this.e=m,this.f=n,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(m){if(!this.a.destroyed){if(this.a.flowing)this.g(m);else if(this.b.data.push(m),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(n=>this.d.push(n))}}error(m){this.a.destroyed||(this.a.flowing?this.h(m):this.b.error.push(m))}end(m){this.a.destroyed||(typeof m<"u"&&this.write(m),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(m){this.c.data.slice(0).forEach(n=>n(m))}h(m){this.c.error.length===0?(0,f.$1)(m):this.c.error.slice(0).forEach(n=>n(m))}i(){this.c.end.slice(0).forEach(m=>m())}on(m,n){if(!this.a.destroyed)switch(m){case"data":this.c.data.push(n),this.resume();break;case"end":this.c.end.push(n),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(n),this.a.flowing&&this.k();break}}removeListener(m,n){if(this.a.destroyed)return;let r;switch(m){case"data":r=this.c.data;break;case"end":r=this.c.end;break;case"error":r=this.c.error;break}if(r){const s=r.indexOf(n);s>=0&&r.splice(s,1)}}j(){if(this.b.data.length>0){const m=this.e(this.b.data);this.g(m),this.b.data.length=0;const n=[...this.d];this.d.length=0,n.forEach(r=>r())}}k(){if(this.c.error.length>0){for(const m of this.b.error)this.h(m);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function d(D,m){const n=[];let r;for(;(r=D.read())!==null;)n.push(r);return m(n)}e.$4d=d;function R(D,m,n){const r=[];let s;for(;(s=D.read())!==null&&r.length<n;)r.push(s);return s===null&&r.length>0?m(r):{read:()=>{if(r.length>0)return r.shift();if(typeof s<"u"){const o=s;return s=void 0,o}return D.read()}}}e.$5d=R;function S(D,m){return new Promise((n,r)=>{const s=[];u(D,{onData:o=>{m&&s.push(o)},onError:o=>{m?r(o):n(void 0)},onEnd:()=>{n(m?m(s):void 0)}})})}e.$6d=S;function u(D,m,n){D.on("error",r=>{n?.isCancellationRequested||m.onError(r)}),D.on("end",()=>{n?.isCancellationRequested||m.onEnd()}),D.on("data",r=>{n?.isCancellationRequested||m.onData(r)})}e.$7d=u;function b(D,m){return new Promise((n,r)=>{const s=new C.$Rc,o=[],$=P=>{if(o.push(P),o.length>m)return s.dispose(),D.pause(),n({stream:D,buffer:o,ended:!1})},a=P=>(s.dispose(),r(P)),k=()=>(s.dispose(),n({stream:D,buffer:o,ended:!0}));s.add((0,C.$Qc)(()=>D.removeListener("error",a))),D.on("error",a),s.add((0,C.$Qc)(()=>D.removeListener("end",k))),D.on("end",k),s.add((0,C.$Qc)(()=>D.removeListener("data",$))),D.on("data",$)})}e.$8d=b;function p(D,m){const n=c(m);return n.end(D),n}e.$9d=p;function g(){const D=c(()=>{throw new Error("not supported")});return D.end(),D}e.$0d=g;function t(D){let m=!1;return{read:()=>m?null:(m=!0,D)}}e.$$d=t;function i(D,m,n){const r=c(n);return u(D,{onData:s=>r.write(m.data(s)),onError:s=>r.error(m.error?m.error(s):s),onEnd:()=>r.end()}),r}e.$_d=i;function l(D,m,n){let r=!1;return{read:()=>{const s=m.read();return r?s:(r=!0,s!==null?n([D,s]):D)}}}e.$ae=l;function v(D,m,n){let r=!1;const s=c(n);return u(m,{onData:o=>r?s.write(o):(r=!0,s.write(n([D,o]))),onError:o=>s.error(o),onEnd:()=>{r||(r=!0,s.write(D)),s.end()}}),s}e.$be=v}),define(Ae[26],Re([1,0,42,119]),function(ee,e,f,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$ee=e.$de=e.$ce=void 0;const I=typeof Buffer<"u",O=new f.$V(()=>new Uint8Array(256));let A,c;class E{static alloc(y){return I?new E(Buffer.allocUnsafe(y)):new E(new Uint8Array(y))}static wrap(y){return I&&!Buffer.isBuffer(y)&&(y=Buffer.from(y.buffer,y.byteOffset,y.byteLength)),new E(y)}static fromString(y,M){return!(M?.dontUseNodeBuffer||!1)&&I?new E(Buffer.from(y)):(A||(A=new TextEncoder),new E(A.encode(y)))}static fromByteArray(y){const M=E.alloc(y.length);for(let V=0,B=y.length;V<B;V++)M.buffer[V]=y[V];return M}static concat(y,M){if(typeof M>"u"){M=0;for(let z=0,T=y.length;z<T;z++)M+=y[z].byteLength}const V=E.alloc(M);let B=0;for(let z=0,T=y.length;z<T;z++){const F=y[z];V.set(F,B),B+=F.byteLength}return V}constructor(y){this.buffer=y,this.byteLength=this.buffer.byteLength}clone(){const y=E.alloc(this.byteLength);return y.set(this),y}toString(){return I?this.buffer.toString():(c||(c=new TextDecoder),c.decode(this.buffer))}slice(y,M){return new E(this.buffer.subarray(y,M))}set(y,M){if(y instanceof E)this.buffer.set(y.buffer,M);else if(y instanceof Uint8Array)this.buffer.set(y,M);else if(y instanceof ArrayBuffer)this.buffer.set(new Uint8Array(y),M);else if(ArrayBuffer.isView(y))this.buffer.set(new Uint8Array(y.buffer,y.byteOffset,y.byteLength),M);else throw new Error("Unknown argument 'array'")}readUInt32BE(y){return u(this.buffer,y)}writeUInt32BE(y,M){b(this.buffer,y,M)}readUInt32LE(y){return p(this.buffer,y)}writeUInt32LE(y,M){g(this.buffer,y,M)}readUInt8(y){return t(this.buffer,y)}writeUInt8(y,M){i(this.buffer,y,M)}indexOf(y,M=0){return d(this.buffer,y instanceof E?y.buffer:y,M)}}e.$ce=E;function d(w,y,M=0){const V=y.byteLength,B=w.byteLength;if(V===0)return 0;if(V===1)return w.indexOf(y[0]);if(V>B-M)return-1;const z=O.value;z.fill(y.length);for(let q=0;q<y.length;q++)z[y[q]]=y.length-q-1;let T=M+y.length-1,F=T,j=-1;for(;T<B;)if(w[T]===y[F]){if(F===0){j=T;break}T--,F--}else T+=Math.max(y.length-F,z[w[T]]),F=y.length-1;return j}e.$de=d;function R(w,y){return w[y+0]<<0>>>0|w[y+1]<<8>>>0}e.$ee=R;function S(w,y,M){w[M+0]=y&255,y=y>>>8,w[M+1]=y&255}e.$fe=S;function u(w,y){return w[y]*2**24+w[y+1]*2**16+w[y+2]*2**8+w[y+3]}e.$ge=u;function b(w,y,M){w[M+3]=y,y=y>>>8,w[M+2]=y,y=y>>>8,w[M+1]=y,y=y>>>8,w[M]=y}e.$he=b;function p(w,y){return w[y+0]<<0>>>0|w[y+1]<<8>>>0|w[y+2]<<16>>>0|w[y+3]<<24>>>0}e.$ie=p;function g(w,y,M){w[M+0]=y&255,y=y>>>8,w[M+1]=y&255,y=y>>>8,w[M+2]=y&255,y=y>>>8,w[M+3]=y&255}e.$je=g;function t(w,y){return w[y]}e.$ke=t;function i(w,y,M){w[M]=y}e.$le=i;function l(w){return C.$4d(w,y=>E.concat(y))}e.$me=l;function v(w){return C.$$d(w)}e.$ne=v;function D(w){return C.$6d(w,y=>E.concat(y))}e.$oe=D;async function m(w){return w.ended?E.concat(w.buffer):E.concat([...w.buffer,await D(w.stream)])}e.$pe=m;function n(w){return C.$9d(w,y=>E.concat(y))}e.$qe=n;function r(w){return C.$_d(w,{data:y=>typeof y=="string"?E.fromString(y):E.wrap(y)},y=>E.concat(y))}e.$re=r;function s(w){return C.$3d(y=>E.concat(y),w)}e.$se=s;function o(w,y){return C.$ae(w,y,M=>E.concat(M))}e.$te=o;function $(w,y){return C.$be(w,y,M=>E.concat(M))}e.$ue=$;function a(w){let y=0,M=0,V=0;const B=new Uint8Array(Math.floor(w.length/4*3)),z=F=>{switch(M){case 3:B[V++]=y|F,M=0;break;case 2:B[V++]=y|F>>>2,y=F<<6,M=3;break;case 1:B[V++]=y|F>>>4,y=F<<4,M=2;break;default:y=F<<2,M=1}};for(let F=0;F<w.length;F++){const j=w.charCodeAt(F);if(j>=65&&j<=90)z(j-65);else if(j>=97&&j<=122)z(j-97+26);else if(j>=48&&j<=57)z(j-48+52);else if(j===43||j===45)z(62);else if(j===47||j===95)z(63);else{if(j===61)break;throw new SyntaxError(`Unexpected base64 character ${w[F]}`)}}const T=V;for(;M>0;)z(0);return E.wrap(B).slice(0,T)}e.$ve=a;const k="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",P="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function h({buffer:w},y=!0,M=!1){const V=M?P:k;let B="";const z=w.byteLength%3;let T=0;for(;T<w.byteLength-z;T+=3){const F=w[T+0],j=w[T+1],q=w[T+2];B+=V[F>>>2],B+=V[(F<<4|j>>>4)&63],B+=V[(j<<2|q>>>6)&63],B+=V[q&63]}if(z===1){const F=w[T+0];B+=V[F>>>2],B+=V[F<<4&63],y&&(B+="==")}else if(z===2){const F=w[T+0],j=w[T+1];B+=V[F>>>2],B+=V[(F<<4|j>>>4)&63],B+=V[j<<2&63],y&&(B+="=")}return B}e.$we=h}),define(Ae[120],Re([1,0,28,16]),function(ee,e,f,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sj=e.$Rj=e.$Qj=e.$Pj=e.FuzzyScore=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.or=void 0;function I(...ne){return function(ce,pe){for(let Ce=0,L=ne.length;Ce<L;Ce++){const K=ne[Ce](ce,pe);if(K)return K}return null}}e.or=I,e.$Dj=O.bind(void 0,!1),e.$Ej=O.bind(void 0,!0);function O(ne,ce,pe){if(!pe||pe.length<ce.length)return null;let Ce;return ne?Ce=C.$4e(pe,ce):Ce=pe.indexOf(ce)===0,Ce?ce.length>0?[{start:0,end:ce.length}]:[]:null}function A(ne,ce){const pe=ce.toLowerCase().indexOf(ne.toLowerCase());return pe===-1?null:[{start:pe,end:pe+ne.length}]}e.$Fj=A;function c(ne,ce){return E(ne.toLowerCase(),ce.toLowerCase(),0,0)}e.$Gj=c;function E(ne,ce,pe,Ce){if(pe===ne.length)return[];if(Ce===ce.length)return null;if(ne[pe]===ce[Ce]){let L=null;return(L=E(ne,ce,pe+1,Ce+1))?i({start:Ce,end:Ce+1},L):null}return E(ne,ce,pe,Ce+1)}function d(ne){return 97<=ne&&ne<=122}function R(ne){return 65<=ne&&ne<=90}e.$Hj=R;function S(ne){return 48<=ne&&ne<=57}function u(ne){return ne===32||ne===9||ne===10||ne===13}const b=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(ne=>b.add(ne.charCodeAt(0)));function p(ne){return u(ne)||b.has(ne)}function g(ne,ce){return ne===ce||p(ne)&&p(ce)}function t(ne){return d(ne)||R(ne)||S(ne)}function i(ne,ce){return ce.length===0?ce=[ne]:ne.end===ce[0].start?ce[0].start=ne.start:ce.unshift(ne),ce}function l(ne,ce){for(let pe=ce;pe<ne.length;pe++){const Ce=ne.charCodeAt(pe);if(R(Ce)||S(Ce)||pe>0&&!t(ne.charCodeAt(pe-1)))return pe}return ne.length}function v(ne,ce,pe,Ce){if(pe===ne.length)return[];if(Ce===ce.length)return null;if(ne[pe]!==ce[Ce].toLowerCase())return null;{let L=null,K=Ce+1;for(L=v(ne,ce,pe+1,Ce+1);!L&&(K=l(ce,K))<ce.length;)L=v(ne,ce,pe+1,K),K++;return L===null?null:i({start:Ce,end:Ce+1},L)}}function D(ne){let ce=0,pe=0,Ce=0,L=0,K=0;for(let se=0;se<ne.length;se++)K=ne.charCodeAt(se),R(K)&&ce++,d(K)&&pe++,t(K)&&Ce++,S(K)&&L++;const Y=ce/ne.length,X=pe/ne.length,H=Ce/ne.length,x=L/ne.length;return{upperPercent:Y,lowerPercent:X,alphaPercent:H,numericPercent:x}}function m(ne){const{upperPercent:ce,lowerPercent:pe}=ne;return pe===0&&ce>.6}function n(ne){const{upperPercent:ce,lowerPercent:pe,alphaPercent:Ce,numericPercent:L}=ne;return pe>.2&&ce<.8&&Ce>.6&&L<.2}function r(ne){let ce=0,pe=0,Ce=0,L=0;for(let K=0;K<ne.length;K++)Ce=ne.charCodeAt(K),R(Ce)&&ce++,d(Ce)&&pe++,u(Ce)&&L++;return(ce===0||pe===0)&&L===0?ne.length<=30:ce<=5}function s(ne,ce){if(!ce||(ce=ce.trim(),ce.length===0)||!r(ne)||ce.length>60)return null;const pe=D(ce);if(!n(pe)){if(!m(pe))return null;ce=ce.toLowerCase()}let Ce=null,L=0;for(ne=ne.toLowerCase();L<ce.length&&(Ce=v(ne,ce,0,L))===null;)L=l(ce,L+1);return Ce}e.$Ij=s;function o(ne,ce,pe=!1){if(!ce||ce.length===0)return null;let Ce=null,L=0;for(ne=ne.toLowerCase(),ce=ce.toLowerCase();L<ce.length&&(Ce=$(ne,ce,0,L,pe))===null;)L=a(ce,L+1);return Ce}e.$Jj=o;function $(ne,ce,pe,Ce,L){if(pe===ne.length)return[];if(Ce===ce.length)return null;if(g(ne.charCodeAt(pe),ce.charCodeAt(Ce))){let K=null,Y=Ce+1;if(K=$(ne,ce,pe+1,Ce+1,L),!L)for(;!K&&(Y=a(ce,Y))<ce.length;)K=$(ne,ce,pe+1,Y,L),Y++;return K?ne.charCodeAt(pe)!==ce.charCodeAt(Ce)?K:i({start:Ce,end:Ce+1},K):null}else return null}function a(ne,ce){for(let pe=ce;pe<ne.length;pe++)if(p(ne.charCodeAt(pe))||pe>0&&p(ne.charCodeAt(pe-1)))return pe;return ne.length}const k=I(e.$Ej,s,A),P=I(e.$Ej,s,c),h=new f.$Dc(1e4);function w(ne,ce,pe=!1){if(typeof ne!="string"||typeof ce!="string")return null;let Ce=h.get(ne);Ce||(Ce=new RegExp(C.$Me(ne),"i"),h.set(ne,Ce));const L=Ce.exec(ce);return L?[{start:L.index,end:L.index+L[0].length}]:pe?P(ne,ce):k(ne,ce)}e.$Kj=w;function y(ne,ce){const pe=J(ne,ne.toLowerCase(),0,ce,ce.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return pe?V(pe):null}e.$Lj=y;function M(ne,ce,pe,Ce,L,K){const Y=Math.min(13,ne.length);for(;pe<Y;pe++){const X=J(ne,ce,pe,Ce,L,K,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(X)return X}return[0,K]}e.$Mj=M;function V(ne){if(typeof ne>"u")return[];const ce=[],pe=ne[1];for(let Ce=ne.length-1;Ce>1;Ce--){const L=ne[Ce]+pe,K=ce[ce.length-1];K&&K.end===L?K.end=L+1:ce.push({start:L,end:L+1})}return ce}e.$Nj=V;const B=128;function z(){const ne=[],ce=[];for(let pe=0;pe<=B;pe++)ce[pe]=0;for(let pe=0;pe<=B;pe++)ne.push(ce.slice(0));return ne}function T(ne){const ce=[];for(let pe=0;pe<=ne;pe++)ce[pe]=0;return ce}const F=T(2*B),j=T(2*B),q=z(),W=z(),we=z(),ke=!1;function Se(ne,ce,pe,Ce,L){function K(X,H,x=" "){for(;X.length<H;)X=x+X;return X}let Y=` |   |${Ce.split("").map(X=>K(X,3)).join("|")}
`;for(let X=0;X<=pe;X++)X===0?Y+=" |":Y+=`${ce[X-1]}|`,Y+=ne[X].slice(0,L+1).map(H=>K(H.toString(),3)).join("|")+`
`;return Y}function ve(ne,ce,pe,Ce){ne=ne.substr(ce),pe=pe.substr(Ce),console.log(Se(W,ne,ne.length,pe,pe.length)),console.log(Se(we,ne,ne.length,pe,pe.length)),console.log(Se(q,ne,ne.length,pe,pe.length))}function ge(ne,ce){if(ce<0||ce>=ne.length)return!1;const pe=ne.codePointAt(ce);switch(pe){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!C.$jf(pe)}}function re(ne,ce){if(ce<0||ce>=ne.length)return!1;switch(ne.charCodeAt(ce)){case 32:case 9:return!0;default:return!1}}function oe(ne,ce,pe){return ce[ne]!==pe[ne]}function ye(ne,ce,pe,Ce,L,K,Y=!1){for(;ce<pe&&L<K;)ne[ce]===Ce[L]&&(Y&&(F[ce]=L),ce+=1),L+=1;return ce===pe}e.$Oj=ye;var De;(function(ne){ne[ne.Diag=1]="Diag",ne[ne.Left=2]="Left",ne[ne.LeftLeft=3]="LeftLeft"})(De||(De={}));var Q;(function(ne){ne.Default=[-100,0];function ce(pe){return!pe||pe.length===2&&pe[0]===-100&&pe[1]===0}ne.isDefault=ce})(Q||(e.FuzzyScore=Q={}));class ue{constructor(ce,pe){this.firstMatchCanBeWeak=ce,this.boostFullMatch=pe}}e.$Pj=ue,ue.default={boostFullMatch:!0,firstMatchCanBeWeak:!1};function J(ne,ce,pe,Ce,L,K,Y=ue.default){const X=ne.length>B?B:ne.length,H=Ce.length>B?B:Ce.length;if(pe>=X||K>=H||X-pe>H-K||!ye(ce,pe,X,L,K,H,!0))return;he(X,H,pe,K,ce,L);let x=1,se=1,Le=pe,je=K;const Ye=[!1];for(x=1,Le=pe;Le<X;x++,Le++){const rt=F[Le],nt=j[Le],Ue=Le+1<X?j[Le+1]:H;for(se=rt-K+1,je=rt;je<Ue;se++,je++){let lt=Number.MIN_SAFE_INTEGER,_=!1;je<=nt&&(lt=de(ne,ce,Le,pe,Ce,L,je,H,K,q[x-1][se-1]===0,Ye));let Z=0;lt!==Number.MAX_SAFE_INTEGER&&(_=!0,Z=lt+W[x-1][se-1]);const Ee=je>rt,We=Ee?W[x][se-1]+(q[x][se-1]>0?-5:0):0,ze=je>rt+1&&q[x][se-1]>0,Ze=ze?W[x][se-2]+(q[x][se-2]>0?-5:0):0;if(ze&&(!Ee||Ze>=We)&&(!_||Ze>=Z))W[x][se]=Ze,we[x][se]=3,q[x][se]=0;else if(Ee&&(!_||We>=Z))W[x][se]=We,we[x][se]=2,q[x][se]=0;else if(_)W[x][se]=Z,we[x][se]=1,q[x][se]=q[x-1][se-1]+1;else throw new Error("not possible")}}if(ke&&ve(ne,pe,Ce,K),!Ye[0]&&!Y.firstMatchCanBeWeak)return;x--,se--;const Ke=[W[x][se],K];let tt=0,xe=0;for(;x>=1;){let rt=se;do{const nt=we[x][rt];if(nt===3)rt=rt-2;else if(nt===2)rt=rt-1;else break}while(rt>=1);tt>1&&ce[pe+x-1]===L[K+se-1]&&!oe(rt+K-1,Ce,L)&&tt+1>q[x][rt]&&(rt=se),rt===se?tt++:tt=1,xe||(xe=rt),x--,se=rt-1,Ke.push(se)}H===X&&Y.boostFullMatch&&(Ke[0]+=2);const et=xe-X;return Ke[0]-=et,Ke}e.$Qj=J;function he(ne,ce,pe,Ce,L,K){let Y=ne-1,X=ce-1;for(;Y>=pe&&X>=Ce;)L[Y]===K[X]&&(j[Y]=X,Y--),X--}function de(ne,ce,pe,Ce,L,K,Y,X,H,x,se){if(ce[pe]!==K[Y])return Number.MIN_SAFE_INTEGER;let Le=1,je=!1;return Y===pe-Ce?Le=ne[pe]===L[Y]?7:5:oe(Y,L,K)&&(Y===0||!oe(Y-1,L,K))?(Le=ne[pe]===L[Y]?7:5,je=!0):ge(K,Y)&&(Y===0||!ge(K,Y-1))?Le=5:(ge(K,Y-1)||re(K,Y-1))&&(Le=5,je=!0),Le>1&&pe===Ce&&(se[0]=!0),je||(je=oe(Y,L,K)||ge(K,Y-1)||re(K,Y-1)),pe===Ce?Y>H&&(Le-=je?3:5):x?Le+=je?2:0:Le+=je?0:1,Y+1===X&&(Le-=je?3:5),Le}function le(ne,ce,pe,Ce,L,K,Y){return ie(ne,ce,pe,Ce,L,K,!0,Y)}e.$Rj=le;function be(ne,ce,pe,Ce,L,K,Y){return ie(ne,ce,pe,Ce,L,K,!1,Y)}e.$Sj=be;function ie(ne,ce,pe,Ce,L,K,Y,X){let H=J(ne,ce,pe,Ce,L,K,X);if(H&&!Y)return H;if(ne.length>=3){const x=Math.min(7,ne.length-1);for(let se=pe+1;se<x;se++){const Le=fe(ne,se);if(Le){const je=J(Le,Le.toLowerCase(),pe,Ce,L,K,X);je&&(je[0]-=3,(!H||je[0]>H[0])&&(H=je))}}}return H}function fe(ne,ce){if(ce+1>=ne.length)return;const pe=ne[ce],Ce=ne[ce+1];if(pe!==Ce)return ne.slice(0,ce)+Ce+pe+ne.slice(ce+2)}}),define(Ae[29],Re([1,0,16]),function(ee,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var C;(function(I){I[I.Ignore=0]="Ignore",I[I.Info=1]="Info",I[I.Warning=2]="Warning",I[I.Error=3]="Error"})(C||(C={})),function(I){const O="error",A="warning",c="warn",E="info",d="ignore";function R(u){return u?f.$3e(O,u)?I.Error:f.$3e(A,u)||f.$3e(c,u)?I.Warning:f.$3e(E,u)?I.Info:I.Ignore:I.Ignore}I.fromValue=R;function S(u){switch(u){case I.Error:return O;case I.Warning:return A;case I.Info:return E;default:return d}}I.toString=S}(C||(C={})),e.default=C}),define(Ae[121],Re([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ld=void 0,e.$Ld=Symbol("MicrotaskDelay")}),define(Ae[50],Re([1,0,18,16]),function(ee,e,f,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wh=e.$Vh=e.$Uh=e.$Th=e.$Sh=void 0;class I{constructor(){this.b="",this.c=0}reset(b){return this.b=b,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(b){const p=b.charCodeAt(0),g=this.b.charCodeAt(this.c);return p-g}value(){return this.b[this.c]}}e.$Sh=I;class O{constructor(b=!0){this.e=b}reset(b){return this.b=b,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let b=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(b)this.c++;else break;else b=!1;return this}cmp(b){return this.e?(0,C.$We)(b,this.b,0,b.length,this.c,this.d):(0,C.$Ye)(b,this.b,0,b.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Th=O;class A{constructor(b=!0,p=!0){this.f=b,this.g=p}reset(b){this.d=0,this.e=0,this.b=b,this.c=b.length;for(let p=b.length-1;p>=0;p--,this.c--){const g=this.b.charCodeAt(p);if(!(g===47||this.f&&g===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let b=!0;for(;this.e<this.c;this.e++){const p=this.b.charCodeAt(this.e);if(p===47||this.f&&p===92)if(b)this.d++;else break;else b=!1}return this}cmp(b){return this.g?(0,C.$We)(b,this.b,0,b.length,this.d,this.e):(0,C.$Ye)(b,this.b,0,b.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Uh=A;var c;(function(u){u[u.Scheme=1]="Scheme",u[u.Authority=2]="Authority",u[u.Path=3]="Path",u[u.Query=4]="Query",u[u.Fragment=5]="Fragment"})(c||(c={}));class E{constructor(b,p){this.f=b,this.g=p,this.d=[],this.e=0}reset(b){return this.c=b,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new A(!1,!this.f(b)),this.b.reset(b.path),this.b.value()&&this.d.push(3)),this.g(b)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(b){if(this.d[this.e]===1)return(0,C.$Xe)(b,this.c.scheme);if(this.d[this.e]===2)return(0,C.$Xe)(b,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(b);if(this.d[this.e]===4)return(0,C.$Ve)(b,this.c.query);if(this.d[this.e]===5)return(0,C.$Ve)(b,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$Vh=E;class d{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const b=this.right;return this.right=b.left,b.left=this,this.updateHeight(),b.updateHeight(),b}rotateRight(){const b=this.left;return this.left=b.right,b.right=this,this.updateHeight(),b.updateHeight(),b}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var R;(function(u){u[u.Left=-1]="Left",u[u.Mid=0]="Mid",u[u.Right=1]="Right"})(R||(R={}));class S{static forUris(b=()=>!1,p=()=>!1){return new S(new E(b,p))}static forPaths(b=!1){return new S(new A(void 0,!b))}static forStrings(){return new S(new I)}static forConfigKeys(){return new S(new O)}constructor(b){this.b=b}clear(){this.c=void 0}fill(b,p){if(p){const g=p.slice(0);(0,f.$Xb)(g);for(const t of g)this.set(t,b)}else{const g=b.slice(0);(0,f.$Xb)(g);for(const t of g)this.set(t[0],t[1])}}set(b,p){const g=this.b.reset(b);let t;this.c||(this.c=new d,this.c.segment=g.value());const i=[];for(t=this.c;;){const v=g.cmp(t.segment);if(v>0)t.left||(t.left=new d,t.left.segment=g.value()),i.push([-1,t]),t=t.left;else if(v<0)t.right||(t.right=new d,t.right.segment=g.value()),i.push([1,t]),t=t.right;else if(g.hasNext())g.next(),t.mid||(t.mid=new d,t.mid.segment=g.value()),i.push([0,t]),t=t.mid;else break}const l=t.value;t.value=p,t.key=b;for(let v=i.length-1;v>=0;v--){const D=i[v][1];D.updateHeight();const m=D.balanceFactor();if(m<-1||m>1){const n=i[v][0],r=i[v+1][0];if(n===1&&r===1)i[v][1]=D.rotateLeft();else if(n===-1&&r===-1)i[v][1]=D.rotateRight();else if(n===1&&r===-1)D.right=i[v+1][1]=i[v+1][1].rotateRight(),i[v][1]=D.rotateLeft();else if(n===-1&&r===1)D.left=i[v+1][1]=i[v+1][1].rotateLeft(),i[v][1]=D.rotateRight();else throw new Error;if(v>0)switch(i[v-1][0]){case-1:i[v-1][1].left=i[v][1];break;case 1:i[v-1][1].right=i[v][1];break;case 0:i[v-1][1].mid=i[v][1];break}else this.c=i[0][1]}}return l}get(b){return this.d(b)?.value}d(b){const p=this.b.reset(b);let g=this.c;for(;g;){const t=p.cmp(g.segment);if(t>0)g=g.left;else if(t<0)g=g.right;else if(p.hasNext())p.next(),g=g.mid;else break}return g}has(b){const p=this.d(b);return!(p?.value===void 0&&p?.mid===void 0)}delete(b){return this.e(b,!1)}deleteSuperstr(b){return this.e(b,!0)}e(b,p){const g=this.b.reset(b),t=[];let i=this.c;for(;i;){const l=g.cmp(i.segment);if(l>0)t.push([-1,i]),i=i.left;else if(l<0)t.push([1,i]),i=i.right;else if(g.hasNext())g.next(),t.push([0,i]),i=i.mid;else break}if(i){if(p?(i.left=void 0,i.mid=void 0,i.right=void 0,i.height=1):(i.key=void 0,i.value=void 0),!i.mid&&!i.value)if(i.left&&i.right){const l=this.f(i.right);if(l.key){const{key:v,value:D,segment:m}=l;this.e(l.key,!1),i.key=v,i.value=D,i.segment=m}}else{const l=i.left??i.right;if(t.length>0){const[v,D]=t[t.length-1];switch(v){case-1:D.left=l;break;case 0:D.mid=l;break;case 1:D.right=l;break}}else this.c=l}for(let l=t.length-1;l>=0;l--){const v=t[l][1];v.updateHeight();const D=v.balanceFactor();if(D>1?(v.right.balanceFactor()>=0||(v.right=v.right.rotateRight()),t[l][1]=v.rotateLeft()):D<-1&&(v.left.balanceFactor()<=0||(v.left=v.left.rotateLeft()),t[l][1]=v.rotateRight()),l>0)switch(t[l-1][0]){case-1:t[l-1][1].left=t[l][1];break;case 1:t[l-1][1].right=t[l][1];break;case 0:t[l-1][1].mid=t[l][1];break}else this.c=t[0][1]}}}f(b){for(;b.left;)b=b.left;return b}findSubstr(b){const p=this.b.reset(b);let g=this.c,t;for(;g;){const i=p.cmp(g.segment);if(i>0)g=g.left;else if(i<0)g=g.right;else if(p.hasNext())p.next(),t=g.value||t,g=g.mid;else break}return g&&g.value||t}findSuperstr(b){return this.g(b,!1)}g(b,p){const g=this.b.reset(b);let t=this.c;for(;t;){const i=g.cmp(t.segment);if(i>0)t=t.left;else if(i<0)t=t.right;else if(g.hasNext())g.next(),t=t.mid;else return t.mid?this.h(t.mid):p?t.value:void 0}}hasElementOrSubtree(b){return this.g(b,!0)!==void 0}forEach(b){for(const[p,g]of this)b(g,p)}*[Symbol.iterator](){yield*this.h(this.c)}h(b){const p=[];return this.j(b,p),p[Symbol.iterator]()}j(b,p){b&&(b.left&&this.j(b.left,p),b.value&&p.push([b.key,b.value]),b.mid&&this.j(b.mid,p),b.right&&this.j(b.right,p))}_isBalanced(){const b=p=>{if(!p)return!0;const g=p.balanceFactor();return g<-1||g>1?!1:b(p.left)&&b(p.right)};return b(this.c)}}e.$Wh=S}),define(Ae[43],Re([1,0,20,23,16,15]),function(ee,e,f,C,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7f=e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=e.$Vf=e.$Uf=e.$Tf=e.$Sf=e.$Rf=void 0;function A(a){return a===47||a===92}e.$Rf=A;function c(a){return a.replace(/[\\/]/g,f.$gc.sep)}e.$Sf=c;function E(a){return a.indexOf("/")===-1&&(a=c(a)),/^[a-zA-Z]:(\/|$)/.test(a)&&(a="/"+a),a}e.$Tf=E;function d(a,k=f.$gc.sep){if(!a)return"";const P=a.length,h=a.charCodeAt(0);if(A(h)){if(A(a.charCodeAt(1))&&!A(a.charCodeAt(2))){let y=3;const M=y;for(;y<P&&!A(a.charCodeAt(y));y++);if(M!==y&&!A(a.charCodeAt(y+1))){for(y+=1;y<P;y++)if(A(a.charCodeAt(y)))return a.slice(0,y+1).replace(/[\\/]/g,k)}}return k}else if(i(h)&&a.charCodeAt(1)===58)return A(a.charCodeAt(2))?a.slice(0,2)+k:a.slice(0,2);let w=a.indexOf("://");if(w!==-1){for(w+=3;w<P;w++)if(A(a.charCodeAt(w)))return a.slice(0,w+1)}return""}e.$Uf=d;function R(a){if(!C.$d||!a||a.length<5)return!1;let k=a.charCodeAt(0);if(k!==92||(k=a.charCodeAt(1),k!==92))return!1;let P=2;const h=P;for(;P<a.length&&(k=a.charCodeAt(P),k!==92);P++);return!(h===P||(k=a.charCodeAt(P+1),isNaN(k)||k===92))}e.$Vf=R;const S=/[\\/:\*\?"<>\|]/g,u=/[\\/]/g,b=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function p(a,k=C.$d){const P=k?S:u;return!(!a||a.length===0||/^\s+$/.test(a)||(P.lastIndex=0,P.test(a))||k&&b.test(a)||a==="."||a===".."||k&&a[a.length-1]==="."||k&&a.length!==a.trim().length||a.length>255)}e.$Wf=p;function g(a,k,P){const h=a===k;return!P||h?h:!a||!k?!1:(0,I.$3e)(a,k)}e.$Xf=g;function t(a,k,P,h=f.sep){if(a===k)return!0;if(!a||!k||k.length>a.length)return!1;if(P){if(!(0,I.$4e)(a,k))return!1;if(k.length===a.length)return!0;let y=k.length;return k.charAt(k.length-1)===h&&y--,a.charAt(y)===h}return k.charAt(k.length-1)!==h&&(k+=h),a.indexOf(k)===0}e.$Yf=t;function i(a){return a>=65&&a<=90||a>=97&&a<=122}e.$Zf=i;function l(a,k){return C.$d&&a.endsWith(":")&&(a+=f.sep),(0,f.$ic)(a)||(a=(0,f.$jc)(k,a)),a=(0,f.$hc)(a),C.$d?(a=(0,I.$Le)(a,f.sep),a.endsWith(":")&&(a+=f.sep)):(a=(0,I.$Le)(a,f.sep),a||(a=f.sep)),a}e.$1f=l;function v(a){const k=(0,f.$hc)(a);return C.$d?a.length>3?!1:D(k)&&(a.length===2||k.charCodeAt(2)===92):k===f.$gc.sep}e.$2f=v;function D(a,k=C.$d){return k?i(a.charCodeAt(0))&&a.charCodeAt(1)===58:!1}e.$3f=D;function m(a,k=C.$d){return D(a,k)?a[0]:void 0}e.$4f=m;function n(a,k,P){return k.length>a.length?-1:a===k?0:(P&&(a=a.toLowerCase(),k=k.toLowerCase()),a.indexOf(k))}e.$5f=n;function r(a){const k=a.split(":");let P,h,w;for(const y of k){const M=Number(y);(0,O.$Df)(M)?h===void 0?h=M:w===void 0&&(w=M):P=P?[P,y].join(":"):y}if(!P)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:P,line:h!==void 0?h:void 0,column:w!==void 0?w:h!==void 0?1:void 0}}e.$6f=r;const s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",o="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function $(a,k,P=8){let h="";for(let y=0;y<P;y++){let M;y===0&&C.$d&&!k&&(P===3||P===4)?M=o:M=s,h+=M.charAt(Math.floor(Math.random()*M.length))}let w;return k?w=`${k}-${h}`:w=h,a?(0,f.$jc)(a,w):w}e.$7f=$}),define(Ae[44],Re([1,0,89]),function(ee,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$Wj=e.ThemeColor=void 0;var C;(function(A){function c(E){return E&&typeof E=="object"&&typeof E.id=="string"}A.isThemeColor=c})(C||(e.ThemeColor=C={}));function I(A){return{id:A}}e.$Wj=I;var O;(function(A){A.iconNameSegment="[A-Za-z0-9]+",A.iconNameExpression="[A-Za-z0-9-]+",A.iconModifierExpression="~[A-Za-z]+",A.iconNameCharacter="[A-Za-z0-9~-]";const c=new RegExp(`^(${A.iconNameExpression})(${A.iconModifierExpression})?$`);function E(l){const v=c.exec(l.id);if(!v)return E(f.$Vj.error);const[,D,m]=v,n=["codicon","codicon-"+D];return m&&n.push("codicon-modifier-"+m.substring(1)),n}A.asClassNameArray=E;function d(l){return E(l).join(" ")}A.asClassName=d;function R(l){return"."+E(l).join(".")}A.asCSSSelector=R;function S(l){return l&&typeof l=="object"&&typeof l.id=="string"&&(typeof l.color>"u"||C.isThemeColor(l.color))}A.isThemeIcon=S;const u=new RegExp(`^\\$\\((${A.iconNameExpression}(?:${A.iconModifierExpression})?)\\)$`);function b(l){const v=u.exec(l);if(!v)return;const[,D]=v;return{id:D}}A.fromString=b;function p(l){return{id:l}}A.fromId=p;function g(l,v){let D=l.id;const m=D.lastIndexOf("~");return m!==-1&&(D=D.substring(0,m)),v&&(D=`${D}~${v}`),{id:D}}A.modify=g;function t(l){const v=l.id.lastIndexOf("~");if(v!==-1)return l.id.substring(v+1)}A.getModifier=t;function i(l,v){return l.id===v.id&&l.color?.id===v.color?.id}A.isEqual=i})(O||(e.ThemeIcon=O={}))}),define(Ae[122],Re([1,0,120,16,44]),function(ee,e,f,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3j=e.$2j=e.$1j=e.$Zj=e.$Yj=e.$Xj=void 0;const O="$(",A=new RegExp(`\\$\\(${I.ThemeIcon.iconNameExpression}(?:${I.ThemeIcon.iconModifierExpression})?\\)`,"g"),c=new RegExp(`(\\\\)?${A.source}`,"g");function E(i){return i.replace(c,(l,v)=>v?l:`\\${l}`)}e.$Xj=E;const d=new RegExp(`\\\\${A.source}`,"g");function R(i){return i.replace(d,l=>`\\${l}`)}e.$Yj=R;const S=new RegExp(`(\\s)?(\\\\)?${A.source}(\\s)?`,"g");function u(i){return i.indexOf(O)===-1?i:i.replace(S,(l,v,D,m)=>D?l:v||m||"")}e.$Zj=u;function b(i){return i?i.replace(/\$\((.*?)\)/g,(l,v)=>` ${v} `).trim():""}e.$1j=b;const p=new RegExp(`\\$\\(${I.ThemeIcon.iconNameCharacter}+\\)`,"g");function g(i){p.lastIndex=0;let l="";const v=[];let D=0;for(;;){const m=p.lastIndex,n=p.exec(i),r=i.substring(m,n?.index);if(r.length>0){l+=r;for(let s=0;s<r.length;s++)v.push(D)}if(!n)break;D+=n[0].length}return{text:l,iconOffsets:v}}e.$2j=g;function t(i,l,v=!1){const{text:D,iconOffsets:m}=l;if(!m||m.length===0)return(0,f.$Kj)(i,D,v);const n=(0,C.$Ke)(D," "),r=D.length-n.length,s=(0,f.$Kj)(i,n,v);if(s)for(const o of s){const $=m[o.start+r]+r;o.start+=$,o.end+=$}return s}e.$3j=t}),define(Ae[67],Re([1,0,26,2]),function(ee,e,f,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nh=e.$mh=e.$lh=void 0;function I(E){return JSON.stringify(E,A)}e.$lh=I;function O(E){let d=JSON.parse(E);return d=c(d),d}e.$mh=O;function A(E,d){return d instanceof RegExp?{$mid:2,source:d.source,flags:d.flags}:d}function c(E,d=0){if(!E||d>200)return E;if(typeof E=="object"){switch(E.$mid){case 1:return C.URI.revive(E);case 2:return new RegExp(E.source,E.flags);case 17:return new Date(E.source)}if(E instanceof f.$ce||E instanceof Uint8Array)return E;if(Array.isArray(E))for(let R=0;R<E.length;++R)E[R]=c(E[R],d+1);else for(const R in E)Object.hasOwnProperty.call(E,R)&&(E[R]=c(E[R],d+1))}return E}e.$nh=c}),define(Ae[13],Re([1,0,11,23,2]),function(ee,e,f,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$dg=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=e.$0f=e.$9f=e.$8f=e.Schemas=void 0;var O;(function(d){d.inMemory="inmemory",d.vscode="vscode",d.internal="private",d.walkThrough="walkThrough",d.walkThroughSnippet="walkThroughSnippet",d.http="http",d.https="https",d.file="file",d.mailto="mailto",d.untitled="untitled",d.data="data",d.command="command",d.vscodeRemote="vscode-remote",d.vscodeRemoteResource="vscode-remote-resource",d.vscodeManagedRemoteResource="vscode-managed-remote-resource",d.vscodeUserData="vscode-userdata",d.vscodeCustomEditor="vscode-custom-editor",d.vscodeNotebookCell="vscode-notebook-cell",d.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",d.vscodeNotebookCellOutput="vscode-notebook-cell-output",d.vscodeInteractiveInput="vscode-interactive-input",d.vscodeSettings="vscode-settings",d.vscodeWorkspaceTrust="vscode-workspace-trust",d.vscodeTerminal="vscode-terminal",d.vscodeChatSesssion="vscode-chat-editor",d.webviewPanel="webview-panel",d.vscodeWebview="vscode-webview",d.extension="extension",d.vscodeFileResource="vscode-file",d.tmp="tmp",d.vsls="vsls",d.vscodeSourceControl="vscode-scm"})(O||(e.Schemas=O={})),e.$8f="vscode-tkn",e.$9f="tkn";class A{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${O.vscodeRemoteResource}`}setPreferredWebSchema(R){this.d=R}setDelegate(R){this.e=R}setServerRootPath(R){this.f=`${R}/${O.vscodeRemoteResource}`}set(R,S,u){this.a[R]=S,this.b[R]=u}setConnectionToken(R,S){this.c[R]=S}getPreferredWebSchema(){return this.d}rewrite(R){if(this.e)try{return this.e(R)}catch(t){return f.$1(t),R}const S=R.authority;let u=this.a[S];u&&u.indexOf(":")!==-1&&u.indexOf("[")===-1&&(u=`[${u}]`);const b=this.b[S],p=this.c[S];let g=`path=${encodeURIComponent(R.path)}`;return typeof p=="string"&&(g+=`&${e.$9f}=${encodeURIComponent(p)}`),I.URI.from({scheme:C.$j?this.d:O.vscodeRemoteResource,authority:`${u}:${b}`,path:C.$j?(window.location.pathname+"/"+this.f).replace(/\/\/+/g,"/"):this.f,query:g})}}e.$0f=new A,e.$$f="vs/../../extensions",e.$_f="vs/../../node_modules",e.$ag="vs/../../node_modules.asar",e.$bg="vs/../../node_modules.asar.unpacked",e.$cg="vscode-app";class c{asBrowserUri(R){const S=this.b(R,ee);return this.uriToBrowserUri(S)}uriToBrowserUri(R){return R.scheme===O.vscodeRemote?e.$0f.rewrite(R):R.scheme===O.file&&(C.$h||C.$k&&C.$b.origin===`${O.vscodeFileResource}://${c.a}`)?R.with({scheme:O.vscodeFileResource,authority:R.authority||c.a,query:null,fragment:null}):R}asFileUri(R){const S=this.b(R,ee);return this.uriToFileUri(S)}uriToFileUri(R){return R.scheme===O.vscodeFileResource?R.with({scheme:O.file,authority:R.authority!==c.a?R.authority:null,query:null,fragment:null}):R}b(R,S){return I.URI.isUri(R)?R:I.URI.parse(S.toUrl(R))}}c.a=e.$cg,e.$dg=new c;var E;(function(d){const R=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);d.CoopAndCoep=Object.freeze(R.get("3"));const S="vscode-coi";function u(p){let g;typeof p=="string"?g=new URL(p).searchParams:p instanceof URL?g=p.searchParams:I.URI.isUri(p)&&(g=new URL(p.toString(!0)).searchParams);const t=g?.get(S);if(t)return R.get(t)}d.getHeadersFromQuery=u;function b(p,g,t){if(!globalThis.crossOriginIsolated)return;const i=g&&t?"3":t?"2":"1";p instanceof URLSearchParams?p.set(S,i):p[S]=i}d.addSearchParam=b})(E||(e.COI=E={}))}),define(Ae[24],Re([1,0,43,13,20,23,16,2]),function(ee,e,f,C,I,O,A,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gg=e.DataUri=e.$Fg=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=e.$rg=e.$qg=e.$pg=e.$og=e.$ng=e.$mg=e.$lg=e.$kg=void 0;function E(b){return(0,c.$wc)(b,!0)}e.$kg=E;class d{constructor(p){this.a=p}compare(p,g,t=!1){return p===g?0:(0,A.$Ve)(this.getComparisonKey(p,t),this.getComparisonKey(g,t))}isEqual(p,g,t=!1){return p===g?!0:!p||!g?!1:this.getComparisonKey(p,t)===this.getComparisonKey(g,t)}getComparisonKey(p,g=!1){return p.with({path:this.a(p)?p.path.toLowerCase():void 0,fragment:g?null:void 0}).toString()}ignorePathCasing(p){return this.a(p)}isEqualOrParent(p,g,t=!1){if(p.scheme===g.scheme){if(p.scheme===C.Schemas.file)return f.$Yf(E(p),E(g),this.a(p))&&p.query===g.query&&(t||p.fragment===g.fragment);if((0,e.$Bg)(p.authority,g.authority))return f.$Yf(p.path,g.path,this.a(p),"/")&&p.query===g.query&&(t||p.fragment===g.fragment)}return!1}joinPath(p,...g){return c.URI.joinPath(p,...g)}basenameOrAuthority(p){return(0,e.$tg)(p)||p.authority}basename(p){return I.$gc.basename(p.path)}extname(p){return I.$gc.extname(p.path)}dirname(p){if(p.path.length===0)return p;let g;return p.scheme===C.Schemas.file?g=c.URI.file(I.$mc(E(p))).path:(g=I.$gc.dirname(p.path),p.authority&&g.length&&g.charCodeAt(0)!==47&&(console.error(`dirname("${p.toString})) resulted in a relative path`),g="/")),p.with({path:g})}normalizePath(p){if(!p.path.length)return p;let g;return p.scheme===C.Schemas.file?g=c.URI.file(I.$hc(E(p))).path:g=I.$gc.normalize(p.path),p.with({path:g})}relativePath(p,g){if(p.scheme!==g.scheme||!(0,e.$Bg)(p.authority,g.authority))return;if(p.scheme===C.Schemas.file){const l=I.$lc(E(p),E(g));return O.$d?f.$Sf(l):l}let t=p.path||"/";const i=g.path||"/";if(this.a(p)){let l=0;for(const v=Math.min(t.length,i.length);l<v&&!(t.charCodeAt(l)!==i.charCodeAt(l)&&t.charAt(l).toLowerCase()!==i.charAt(l).toLowerCase());l++);t=i.substr(0,l)+t.substr(l)}return I.$gc.relative(t,i)}resolvePath(p,g){if(p.scheme===C.Schemas.file){const t=c.URI.file(I.$kc(E(p),g));return p.with({authority:t.authority,path:t.path})}return g=f.$Tf(g),p.with({path:I.$gc.resolve(p.path,g)})}isAbsolutePath(p){return!!p.path&&p.path[0]==="/"}isEqualAuthority(p,g){return p===g||p!==void 0&&g!==void 0&&(0,A.$3e)(p,g)}hasTrailingPathSeparator(p,g=I.sep){if(p.scheme===C.Schemas.file){const t=E(p);return t.length>f.$Uf(t).length&&t[t.length-1]===g}else{const t=p.path;return t.length>1&&t.charCodeAt(t.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(p.fsPath)}}removeTrailingPathSeparator(p,g=I.sep){return(0,e.$Cg)(p,g)?p.with({path:p.path.substr(0,p.path.length-1)}):p}addTrailingPathSeparator(p,g=I.sep){let t=!1;if(p.scheme===C.Schemas.file){const i=E(p);t=i!==void 0&&i.length===f.$Uf(i).length&&i[i.length-1]===g}else{g="/";const i=p.path;t=i.length===1&&i.charCodeAt(i.length-1)===47}return!t&&!(0,e.$Cg)(p,g)?p.with({path:p.path+"/"}):p}}e.$lg=d,e.$mg=new d(()=>!1),e.$ng=new d(b=>b.scheme===C.Schemas.file?!O.$f:!0),e.$og=new d(b=>!0),e.$pg=e.$mg.isEqual.bind(e.$mg),e.$qg=e.$mg.isEqualOrParent.bind(e.$mg),e.$rg=e.$mg.getComparisonKey.bind(e.$mg),e.$sg=e.$mg.basenameOrAuthority.bind(e.$mg),e.$tg=e.$mg.basename.bind(e.$mg),e.$ug=e.$mg.extname.bind(e.$mg),e.$vg=e.$mg.dirname.bind(e.$mg),e.$wg=e.$mg.joinPath.bind(e.$mg),e.$xg=e.$mg.normalizePath.bind(e.$mg),e.$yg=e.$mg.relativePath.bind(e.$mg),e.$zg=e.$mg.resolvePath.bind(e.$mg),e.$Ag=e.$mg.isAbsolutePath.bind(e.$mg),e.$Bg=e.$mg.isEqualAuthority.bind(e.$mg),e.$Cg=e.$mg.hasTrailingPathSeparator.bind(e.$mg),e.$Dg=e.$mg.removeTrailingPathSeparator.bind(e.$mg),e.$Eg=e.$mg.addTrailingPathSeparator.bind(e.$mg);function R(b,p){const g=[];for(let t=0;t<b.length;t++){const i=p(b[t]);b.some((l,v)=>v===t?!1:(0,e.$qg)(i,p(l)))||g.push(b[t])}return g}e.$Fg=R;var S;(function(b){b.META_DATA_LABEL="label",b.META_DATA_DESCRIPTION="description",b.META_DATA_SIZE="size",b.META_DATA_MIME="mime";function p(g){const t=new Map;g.path.substring(g.path.indexOf(";")+1,g.path.lastIndexOf(";")).split(";").forEach(v=>{const[D,m]=v.split(":");D&&m&&t.set(D,m)});const l=g.path.substring(0,g.path.indexOf(";"));return l&&t.set(b.META_DATA_MIME,l),t}b.parseMetaData=p})(S||(e.DataUri=S={}));function u(b,p,g){if(p){let t=b.path;return t&&t[0]!==I.$gc.sep&&(t=I.$gc.sep+t),b.with({scheme:g,authority:p,path:t})}return b.with({scheme:g})}e.$Gg=u}),define(Ae[12],Re([1,0,19,11,5,6,24,23,121]),function(ee,e,f,C,I,O,A,c,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hh=e.$gh=e.$fh=e.$eh=e.Promises=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=void 0;function d(ue){return!!ue&&typeof ue.then=="function"}e.$Hg=d;function R(ue){const J=new f.$Yd,he=ue(J.token),de=new Promise((le,be)=>{const ie=J.token.onCancellationRequested(()=>{ie.dispose(),J.dispose(),be(new C.$5)});Promise.resolve(he).then(fe=>{ie.dispose(),J.dispose(),le(fe)},fe=>{ie.dispose(),J.dispose(),be(fe)})});return new class{cancel(){J.cancel()}then(le,be){return de.then(le,be)}catch(le){return this.then(void 0,le)}finally(le){return de.finally(le)}}}e.$Ig=R;function S(ue,J,he){return new Promise((de,le)=>{const be=J.onCancellationRequested(()=>{be.dispose(),de(he)});ue.then(de,le).finally(()=>be.dispose())})}e.$Jg=S;function u(ue,J){return new Promise((he,de)=>{const le=J.onCancellationRequested(()=>{le.dispose(),de(new C.$5)});ue.then(he,de).finally(()=>le.dispose())})}e.$Kg=u;async function b(ue){let J=-1;const he=ue.map((de,le)=>de.then(be=>(J=le,be)));try{return await Promise.race(he)}finally{ue.forEach((de,le)=>{le!==J&&de.cancel()})}}e.$Lg=b;function p(ue,J,he){let de;const le=setTimeout(()=>{de?.(void 0),he?.()},J);return Promise.race([ue.finally(()=>clearTimeout(le)),new Promise(be=>de=be)])}e.$Mg=p;function g(ue){return new Promise((J,he)=>{const de=ue();d(de)?de.then(J,he):J(de)})}e.$Ng=g;class t{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(J){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=J,!this.b){const he=()=>{if(this.b=null,this.f)return;const de=this.queue(this.d);return this.d=null,de};this.b=new Promise(de=>{this.a.then(he,he).then(de)})}return new Promise((he,de)=>{this.b.then(he,de)})}return this.a=J(),new Promise((he,de)=>{this.a.then(le=>{this.a=null,he(le)},le=>{this.a=null,de(le)})})}dispose(){this.f=!0}}e.$Og=t;class i{constructor(){this.a=Promise.resolve(null)}queue(J){return this.a=this.a.then(()=>J(),()=>J())}}e.$Pg=i;class l{constructor(){this.a=new Map}queue(J,he){const le=(this.a.get(J)??Promise.resolve()).catch(()=>{}).then(he).finally(()=>{this.a.get(J)===le&&this.a.delete(J)});return this.a.set(J,le),le}}e.$Qg=l;const v=(ue,J)=>{let he=!0;const de=setTimeout(()=>{he=!1,J()},ue);return{isTriggered:()=>he,dispose:()=>{clearTimeout(de),he=!1}}},D=ue=>{let J=!0;return queueMicrotask(()=>{J&&(J=!1,ue())}),{isTriggered:()=>J,dispose:()=>{J=!1}}};class m{constructor(J){this.defaultDelay=J,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(J,he=this.defaultDelay){this.g=J,this.h(),this.b||(this.b=new Promise((le,be)=>{this.d=le,this.f=be}).then(()=>{if(this.b=null,this.d=null,this.g){const le=this.g;return this.g=null,le()}}));const de=()=>{this.a=null,this.d?.(null)};return this.a=he===E.$Ld?D(de):v(he,de),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new C.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Rg=m;class n{constructor(J){this.a=new m(J),this.b=new t}trigger(J,he){return this.a.trigger(()=>this.b.queue(J),he)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Sg=n;class r{constructor(){this.a=!1,this.b=new Promise((J,he)=>{this.d=J})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Tg=r;class s extends r{constructor(J){super(),this.f=setTimeout(()=>this.open(),J)}open(){clearTimeout(this.f),super.open()}}e.$Ug=s;function o(ue,J){return J?new Promise((he,de)=>{const le=setTimeout(()=>{be.dispose(),he()},ue),be=J.onCancellationRequested(()=>{clearTimeout(le),be.dispose(),de(new C.$5)})}):R(he=>o(ue,he))}e.$Vg=o;function $(ue,J=0,he){const de=setTimeout(()=>{ue(),he&&le.dispose()},J),le=(0,O.$Qc)(()=>{clearTimeout(de),he?.deleteAndLeak(le)});return he?.add(le),le}e.$Wg=$;function a(ue){const J=[];let he=0;const de=ue.length;function le(){return he<de?ue[he++]():null}function be(ie){ie!=null&&J.push(ie);const fe=le();return fe?fe.then(be):Promise.resolve(J)}return Promise.resolve(null).then(be)}e.$Xg=a;function k(ue,J=de=>!!de,he=null){let de=0;const le=ue.length,be=()=>{if(de>=le)return Promise.resolve(he);const ie=ue[de++];return Promise.resolve(ie()).then(ne=>J(ne)?Promise.resolve(ne):be())};return be()}e.$Yg=k;function P(ue,J=de=>!!de,he=null){if(ue.length===0)return Promise.resolve(he);let de=ue.length;const le=()=>{de=-1;for(const be of ue)be.cancel?.()};return new Promise((be,ie)=>{for(const fe of ue)fe.then(ne=>{--de>=0&&J(ne)?(le(),be(ne)):de===0&&be(he)}).catch(ne=>{--de>=0&&(le(),ie(ne))})})}e.$Zg=P;class h{constructor(J){this.a=0,this.d=J,this.f=[],this.b=0,this.g=new I.$Od}get onDrained(){return this.g.event}get size(){return this.a}queue(J){return this.a++,new Promise((he,de)=>{this.f.push({factory:J,c:he,e:de}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const J=this.f.shift();this.b++;const he=J.factory();he.then(J.c,J.e),he.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$1g=h;class w extends h{constructor(){super(1)}}e.$2g=w;class y{constructor(){this.a=new we,this.b=0}queue(J){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,J())):this.a.run(this.b++,J())}}e.$3g=y;class M{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const J=new ve;return this.b.add(J),J.p}g(){for(const[,J]of this.a)if(J.size>0)return!1;return!0}queueFor(J,he=A.$mg){const de=he.getComparisonKey(J);let le=this.a.get(de);if(!le){le=new w;const be=this.f++,ie=I.Event.once(le.onDrained)(()=>{le?.dispose(),this.a.delete(de),this.h(),this.d?.deleteAndDispose(be),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new O.$1c),this.d.set(be,ie),this.a.set(de,le)}return le}h(){this.g()&&this.j()}j(){for(const J of this.b)J.complete();this.b.clear()}dispose(){for(const[,J]of this.a)J.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$4g=M;class V{constructor(J,he){this.a=-1,typeof J=="function"&&typeof he=="number"&&this.setIfNotSet(J,he)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(J,he){this.cancel(),this.a=setTimeout(()=>{this.a=-1,J()},he)}setIfNotSet(J,he){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,J()},he))}}e.$5g=V;class B{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(J,he){this.cancel(),this.a=setInterval(()=>{J()},he)}}e.$6g=B;class z{constructor(J,he){this.b=-1,this.a=J,this.d=he,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(J=this.d){this.cancel(),this.b=setTimeout(this.f,J)}get delay(){return this.d}set delay(J){this.d=J}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$7g=z;class T{constructor(J,he){he%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${he}ms is not a multiple of 1000ms.`),this.a=J,this.b=he,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(J=this.b){J%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${J}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(J/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$8g=T;class F extends z{constructor(J,he){super(J,he),this.j=[]}work(J){this.j.push(J),this.isScheduled()||this.schedule()}h(){const J=this.j;this.j=[],this.a?.(J)}dispose(){this.j=[],super.dispose()}}e.$9g=F;class j extends O.$Sc{constructor(J,he){super(),this.g=J,this.h=he,this.a=[],this.b=this.B(new O.$Tc),this.f=!1}get pending(){return this.a.length}work(J){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+J.length>this.g.maxBufferedWork)return!1}else if(this.pending+J.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const he of J)this.a.push(he);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new z(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$0g=j,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.$$g=ue=>{(0,c.$v)(()=>{if(J)return;const he=Date.now()+15;ue(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,he-Date.now())}}))});let J=!1;return{dispose(){J||(J=!0)}}}:e.$$g=(ue,J)=>{const he=requestIdleCallback(ue,typeof J=="number"?{timeout:J}:void 0);let de=!1;return{dispose(){de||(de=!0,cancelIdleCallback(he))}}}}();class q{constructor(J){this.d=!1,this.a=()=>{try{this.f=J()}catch(he){this.g=he}finally{this.d=!0}},this.b=(0,e.$$g)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.$_g=q;async function W(ue,J,he){let de;for(let le=0;le<he;le++)try{return await ue()}catch(be){de=be,await o(J)}throw de}e.$ah=W;class we{isRunning(J){return typeof J=="number"?this.a?.taskId===J:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(J,he,de){return this.a={taskId:J,cancel:()=>de?.(),promise:he},he.then(()=>this.d(J),()=>this.d(J)),he}d(J){this.a&&J===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const J=this.b;this.b=void 0,J.run().then(J.promiseResolve,J.promiseReject)}}queue(J){if(this.b)this.b.run=J;else{let he,de;const le=new Promise((be,ie)=>{he=be,de=ie});this.b={run:J,promise:le,promiseResolve:he,promiseReject:de}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$bh=we;class ke{constructor(J,he=()=>Date.now()){this.d=J,this.f=he,this.a=0,this.b=0}increment(){const J=this.f();return J-this.a>this.d&&(this.a=J,this.b=0),this.b++,this.b}}e.$ch=ke;var Se;(function(ue){ue[ue.Resolved=0]="Resolved",ue[ue.Rejected=1]="Rejected"})(Se||(Se={}));class ve{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((J,he)=>{this.a=J,this.b=he})}complete(J){return new Promise(he=>{this.a(J),this.d={outcome:0,value:J},he()})}error(J){return new Promise(he=>{this.b(J),this.d={outcome:1,value:J},he()})}cancel(){return this.error(new C.$5)}}e.$dh=ve;var ge;(function(ue){async function J(de){let le;const be=await Promise.all(de.map(ie=>ie.then(fe=>fe,fe=>{le||(le=fe)})));if(typeof le<"u")throw le;return be}ue.settled=J;function he(de){return new Promise(async(le,be)=>{try{await de(le,be)}catch(ie){be(ie)}})}ue.withAsyncBody=he})(ge||(e.Promises=ge={}));var re;(function(ue){ue[ue.Initial=0]="Initial",ue[ue.DoneOK=1]="DoneOK",ue[ue.DoneError=2]="DoneError"})(re||(re={}));class oe{static fromArray(J){return new oe(he=>{he.emitMany(J)})}static fromPromise(J){return new oe(async he=>{he.emitMany(await J)})}static fromPromises(J){return new oe(async he=>{await Promise.all(J.map(async de=>he.emitOne(await de)))})}static merge(J){return new oe(async he=>{await Promise.all(J.map(async de=>{for await(const le of de)he.emitOne(le)}))})}constructor(J){this.a=0,this.b=[],this.d=null,this.f=new I.$Od,queueMicrotask(async()=>{const he={emitOne:de=>this.g(de),emitMany:de=>this.h(de),reject:de=>this.k(de)};try{await Promise.resolve(J(he)),this.j()}catch(de){this.k(de)}finally{he.emitOne=void 0,he.emitMany=void 0,he.reject=void 0}})}[Symbol.asyncIterator](){let J=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(J<this.b.length)return{done:!1,value:this.b[J++]};if(this.a===1)return{done:!0,value:void 0};await I.Event.toPromise(this.f.event)}while(!0)}}}static map(J,he){return new oe(async de=>{for await(const le of J)de.emitOne(he(le))})}map(J){return oe.map(this,J)}static filter(J,he){return new oe(async de=>{for await(const le of J)he(le)&&de.emitOne(le)})}filter(J){return oe.filter(this,J)}static coalesce(J){return oe.filter(J,he=>!!he)}coalesce(){return oe.coalesce(this)}static async toPromise(J){const he=[];for await(const de of J)he.push(de);return he}toPromise(){return oe.toPromise(this)}g(J){this.a===0&&(this.b.push(J),this.f.fire())}h(J){this.a===0&&(this.b=this.b.concat(J),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(J){this.a===0&&(this.a=2,this.d=J,this.f.fire())}}e.$eh=oe,oe.EMPTY=oe.fromArray([]);class ye extends oe{constructor(J,he){super(he),this.l=J}cancel(){this.l.cancel()}}e.$fh=ye;function De(ue){const J=new f.$Yd,he=ue(J.token);return new ye(J,async de=>{const le=J.token.onCancellationRequested(()=>{le.dispose(),J.dispose(),de.reject(new C.$5)});try{for await(const be of he){if(J.token.isCancellationRequested)return;de.emitOne(be)}le.dispose(),J.dispose()}catch(be){le.dispose(),J.dispose(),de.reject(be)}})}e.$gh=De;class Q{constructor(){this.a=new ve,this.b=new oe(de=>{if(J){de.reject(J);return}return he&&de.emitMany(he),this.d=le=>de.reject(le),this.f=le=>de.emitOne(le),this.a.p});let J,he;this.f=de=>{he||(he=[]),he.push(de)},this.d=de=>{J||(J=de)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(J){this.d(J),this.a.complete()}emitOne(J){this.f(J)}}e.$hh=Q}),define(Ae[36],Re([1,0,18,12,43,28,20,23,16]),function(ee,e,f,C,I,O,A,c,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bj=e.$Aj=e.$zj=e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=void 0;function d(){return Object.create(null)}e.$sj=d,e.$tj="**",e.$uj="/";const R="[/\\\\]",S="[^/\\\\]",u=/\//g;function b(we,ke){switch(we){case 0:return"";case 1:return`${S}*?`;default:return`(?:${R}|${S}+${R}${ke?`|${R}${S}+`:""})*?`}}function p(we,ke){if(!we)return[];const Se=[];let ve=!1,ge=!1,re="";for(const oe of we){switch(oe){case ke:if(!ve&&!ge){Se.push(re),re="";continue}break;case"{":ve=!0;break;case"}":ve=!1;break;case"[":ge=!0;break;case"]":ge=!1;break}re+=oe}return re&&Se.push(re),Se}e.$vj=p;function g(we){if(!we)return"";let ke="";const Se=p(we,e.$uj);if(Se.every(ve=>ve===e.$tj))ke=".*";else{let ve=!1;Se.forEach((ge,re)=>{if(ge===e.$tj){if(ve)return;ke+=b(2,re===Se.length-1)}else{let oe=!1,ye="",De=!1,Q="";for(const ue of ge){if(ue!=="}"&&oe){ye+=ue;continue}if(De&&(ue!=="]"||!Q)){let J;ue==="-"?J=ue:(ue==="^"||ue==="!")&&!Q?J="^":ue===e.$uj?J="":J=(0,E.$Ge)(ue),Q+=J;continue}switch(ue){case"{":oe=!0;continue;case"[":De=!0;continue;case"}":{const he=`(?:${p(ye,",").map(de=>g(de)).join("|")})`;ke+=he,oe=!1,ye="";break}case"]":{ke+="["+Q+"]",De=!1,Q="";break}case"?":ke+=S;continue;case"*":ke+=b(1);continue;default:ke+=(0,E.$Ge)(ue)}}re<Se.length-1&&(Se[re+1]!==e.$tj||re+2<Se.length)&&(ke+=R)}ve=ge===e.$tj})}return ke}const t=/^\*\*\/\*\.[\w\.-]+$/,i=/^\*\*\/([\w\.-]+)\/?$/,l=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,v=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,D=/^\*\*((\/[\w\.-]+)+)\/?$/,m=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,n=new O.$Dc(1e4),r=function(){return!1},s=function(){return null};function o(we,ke){if(!we)return s;let Se;typeof we!="string"?Se=we.pattern:Se=we,Se=Se.trim();const ve=`${Se}_${!!ke.trimForExclusions}`;let ge=n.get(ve);if(ge)return $(ge,we);let re;return t.test(Se)?ge=k(Se.substr(4),Se):(re=i.exec(a(Se,ke)))?ge=P(re[1],Se):(ke.trimForExclusions?v:l).test(Se)?ge=h(Se,ke):(re=D.exec(a(Se,ke)))?ge=w(re[1].substr(1),Se,!0):(re=m.exec(a(Se,ke)))?ge=w(re[1],Se,!1):ge=y(Se),n.set(ve,ge),$(ge,we)}function $(we,ke){if(typeof ke=="string")return we;const Se=function(ve,ge){return(0,I.$Yf)(ve,ke.base,!c.$f)?we((0,E.$Ke)(ve.substr(ke.base.length),A.sep),ge):null};return Se.allBasenames=we.allBasenames,Se.allPaths=we.allPaths,Se.basenames=we.basenames,Se.patterns=we.patterns,Se}function a(we,ke){return ke.trimForExclusions&&we.endsWith("/**")?we.substr(0,we.length-2):we}function k(we,ke){return function(Se,ve){return typeof Se=="string"&&Se.endsWith(we)?ke:null}}function P(we,ke){const Se=`/${we}`,ve=`\\${we}`,ge=function(oe,ye){return typeof oe!="string"?null:ye?ye===we?ke:null:oe===we||oe.endsWith(Se)||oe.endsWith(ve)?ke:null},re=[we];return ge.basenames=re,ge.patterns=[ke],ge.allBasenames=re,ge}function h(we,ke){const Se=q(we.slice(1,-1).split(",").map(ye=>o(ye,ke)).filter(ye=>ye!==s),we),ve=Se.length;if(!ve)return s;if(ve===1)return Se[0];const ge=function(ye,De){for(let Q=0,ue=Se.length;Q<ue;Q++)if(Se[Q](ye,De))return we;return null},re=Se.find(ye=>!!ye.allBasenames);re&&(ge.allBasenames=re.allBasenames);const oe=Se.reduce((ye,De)=>De.allPaths?ye.concat(De.allPaths):ye,[]);return oe.length&&(ge.allPaths=oe),ge}function w(we,ke,Se){const ve=A.sep===A.$gc.sep,ge=ve?we:we.replace(u,A.sep),re=A.sep+ge,oe=A.$gc.sep+we;let ye;return Se?ye=function(De,Q){return typeof De=="string"&&(De===ge||De.endsWith(re)||!ve&&(De===we||De.endsWith(oe)))?ke:null}:ye=function(De,Q){return typeof De=="string"&&(De===ge||!ve&&De===we)?ke:null},ye.allPaths=[(Se?"*/":"./")+we],ye}function y(we){try{const ke=new RegExp(`^${g(we)}$`);return function(Se){return ke.lastIndex=0,typeof Se=="string"&&ke.test(Se)?we:null}}catch{return s}}function M(we,ke,Se){return!we||typeof ke!="string"?!1:V(we)(ke,void 0,Se)}e.$wj=M;function V(we,ke={}){if(!we)return r;if(typeof we=="string"||B(we)){const Se=o(we,ke);if(Se===s)return r;const ve=function(ge,re){return!!Se(ge,re)};return Se.allBasenames&&(ve.allBasenames=Se.allBasenames),Se.allPaths&&(ve.allPaths=Se.allPaths),ve}return F(we,ke)}e.$xj=V;function B(we){const ke=we;return ke?typeof ke.base=="string"&&typeof ke.pattern=="string":!1}e.$yj=B;function z(we){return we.allBasenames||[]}e.$zj=z;function T(we){return we.allPaths||[]}e.$Aj=T;function F(we,ke){const Se=q(Object.getOwnPropertyNames(we).map(ye=>j(ye,we[ye],ke)).filter(ye=>ye!==s)),ve=Se.length;if(!ve)return s;if(!Se.some(ye=>!!ye.requiresSiblings)){if(ve===1)return Se[0];const ye=function(ue,J){let he;for(let de=0,le=Se.length;de<le;de++){const be=Se[de](ue,J);if(typeof be=="string")return be;(0,C.$Hg)(be)&&(he||(he=[]),he.push(be))}return he?(async()=>{for(const de of he){const le=await de;if(typeof le=="string")return le}return null})():null},De=Se.find(ue=>!!ue.allBasenames);De&&(ye.allBasenames=De.allBasenames);const Q=Se.reduce((ue,J)=>J.allPaths?ue.concat(J.allPaths):ue,[]);return Q.length&&(ye.allPaths=Q),ye}const ge=function(ye,De,Q){let ue,J;for(let he=0,de=Se.length;he<de;he++){const le=Se[he];le.requiresSiblings&&Q&&(De||(De=(0,A.$nc)(ye)),ue||(ue=De.substr(0,De.length-(0,A.$oc)(ye).length)));const be=le(ye,De,ue,Q);if(typeof be=="string")return be;(0,C.$Hg)(be)&&(J||(J=[]),J.push(be))}return J?(async()=>{for(const he of J){const de=await he;if(typeof de=="string")return de}return null})():null},re=Se.find(ye=>!!ye.allBasenames);re&&(ge.allBasenames=re.allBasenames);const oe=Se.reduce((ye,De)=>De.allPaths?ye.concat(De.allPaths):ye,[]);return oe.length&&(ge.allPaths=oe),ge}function j(we,ke,Se){if(ke===!1)return s;const ve=o(we,Se);if(ve===s)return s;if(typeof ke=="boolean")return ve;if(ke){const ge=ke.when;if(typeof ge=="string"){const re=(oe,ye,De,Q)=>{if(!Q||!ve(oe,ye))return null;const ue=ge.replace("$(basename)",()=>De),J=Q(ue);return(0,C.$Hg)(J)?J.then(he=>he?we:null):J?we:null};return re.requiresSiblings=!0,re}}return ve}function q(we,ke){const Se=we.filter(ye=>!!ye.basenames);if(Se.length<2)return we;const ve=Se.reduce((ye,De)=>{const Q=De.basenames;return Q?ye.concat(Q):ye},[]);let ge;if(ke){ge=[];for(let ye=0,De=ve.length;ye<De;ye++)ge.push(ke)}else ge=Se.reduce((ye,De)=>{const Q=De.patterns;return Q?ye.concat(Q):ye},[]);const re=function(ye,De){if(typeof ye!="string")return null;if(!De){let ue;for(ue=ye.length;ue>0;ue--){const J=ye.charCodeAt(ue-1);if(J===47||J===92)break}De=ye.substr(ue)}const Q=ve.indexOf(De);return Q!==-1?ge[Q]:null};re.basenames=ve,re.patterns=ge,re.allBasenames=ve;const oe=we.filter(ye=>!ye.basenames);return oe.push(re),oe}function W(we,ke){return(0,f.$ub)(we,ke,(Se,ve)=>typeof Se=="string"&&typeof ve=="string"?Se===ve:typeof Se!="string"&&typeof ve!="string"?Se.base===ve.base&&Se.pattern===ve.pattern:!1)}e.$Bj=W}),define(Ae[51],Re([1,0,11,122,24,16,2]),function(ee,e,f,C,I,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$j=e.$0j=e.$9j=e.$8j=e.$7j=e.$6j=e.$5j=e.$4j=e.MarkdownStringTextNewlineStyle=void 0;var c;(function(t){t[t.Paragraph=0]="Paragraph",t[t.Break=1]="Break"})(c||(e.MarkdownStringTextNewlineStyle=c={}));class E{constructor(i="",l=!1){if(this.value=i,typeof this.value!="string")throw(0,f.$7)("value");typeof l=="boolean"?(this.isTrusted=l,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=l.isTrusted??void 0,this.supportThemeIcons=l.supportThemeIcons??!1,this.supportHtml=l.supportHtml??!1)}appendText(i,l=0){return this.value+=u(this.supportThemeIcons?(0,C.$Xj)(i):i).replace(/([ \t]+)/g,(v,D)=>"&nbsp;".repeat(D.length)).replace(/\>/gm,"\\>").replace(/\n/g,l===1?`\\
`:`

`),this}appendMarkdown(i){return this.value+=i,this}appendCodeblock(i,l){return this.value+="\n```",this.value+=i,this.value+=`
`,this.value+=l,this.value+="\n```\n",this}appendLink(i,l,v){return this.value+="[",this.value+=this.c(l,"]"),this.value+="](",this.value+=this.c(String(i),")"),v&&(this.value+=` "${this.c(this.c(v,'"'),")")}"`),this.value+=")",this}c(i,l){const v=new RegExp((0,O.$Ge)(l),"g");return i.replace(v,(D,m)=>i.charAt(m-1)!=="\\"?`\\${D}`:D)}}e.$4j=E;function d(t){return R(t)?!t.value:Array.isArray(t)?t.every(d):!0}e.$5j=d;function R(t){return t instanceof E?!0:t&&typeof t=="object"?typeof t.value=="string"&&(typeof t.isTrusted=="boolean"||typeof t.isTrusted=="object"||t.isTrusted===void 0)&&(typeof t.supportThemeIcons=="boolean"||t.supportThemeIcons===void 0):!1}e.$6j=R;function S(t,i){return t===i?!0:!t||!i?!1:t.value===i.value&&t.isTrusted===i.isTrusted&&t.supportThemeIcons===i.supportThemeIcons&&t.supportHtml===i.supportHtml&&(t.baseUri===i.baseUri||!!t.baseUri&&!!i.baseUri&&(0,I.$pg)(A.URI.from(t.baseUri),A.URI.from(i.baseUri)))}e.$7j=S;function u(t){return t.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.$8j=u;function b(t){return t.replace(/"/g,"&quot;")}e.$9j=b;function p(t){return t&&t.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.$0j=p;function g(t){const i=[],l=t.split("|").map(D=>D.trim());t=l[0];const v=l[1];if(v){const D=/height=(\d+)/.exec(v),m=/width=(\d+)/.exec(v),n=D?D[1]:"",r=m?m[1]:"",s=isFinite(parseInt(r)),o=isFinite(parseInt(n));s&&i.push(`width="${r}"`),o&&i.push(`height="${n}"`)}return{href:t,dimensions:i}}e.$$j=g}),define(Ae[90],Re([1,0,18,43,20,23,24,16]),function(ee,e,f,C,I,O,A,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fv=e.$Ev=e.$Dv=e.$Cv=e.$Bv=e.$Av=e.$zv=e.$yv=e.$xv=e.$wv=void 0;function E(o,$){const{os:a,tildify:k,relative:P}=$;if(P){const y=d(o,P,a);if(typeof y=="string")return y}let h=o.fsPath;if(a===1&&!O.$d?h=h.replace(/\//g,"\\"):a!==1&&O.$d&&(h=h.replace(/\\/g,"/")),a!==1&&k?.userHome){const y=k.userHome.fsPath;let M;o.scheme!==k.userHome.scheme&&o.path.startsWith(I.$gc.sep)?M=k.userHome.with({path:o.path}).fsPath:M=o.fsPath,h=u(M,y,a)}return(a===1?I.$fc:I.$gc).normalize(R(h,a===1))}e.$wv=E;function d(o,$,a){const k=a===1?I.$fc:I.$gc,P=a===3?A.$mg:A.$og,h=$.getWorkspace(),w=(0,f.$Ob)(h.folders);if(!w)return;o.scheme!==w.uri.scheme&&o.path.startsWith(I.$gc.sep)&&(o=w.uri.with({path:o.path}));const y=$.getWorkspaceFolder(o);if(!y)return;let M;if(P.isEqual(y.uri,o)?M="":M=P.relativePath(y.uri,o)??"",M&&(M=k.normalize(M)),h.folders.length>1&&!$.noPrefix){const V=y.name?y.name:P.basenameOrAuthority(y.uri);M=M?`${V} \u2022 ${M}`:V}return M}function R(o,$=O.$d){return(0,C.$3f)(o,$)?o.charAt(0).toUpperCase()+o.slice(1):o}e.$xv=R;let S=Object.create(null);function u(o,$,a=O.OS){if(a===1||!o||!$)return o;let k=S.original===$?S.normalized:void 0;k||(k=$,O.$d&&(k=(0,C.$Sf)(k)),k=`${(0,c.$Le)(k,I.$gc.sep)}${I.$gc.sep}`,S={original:$,normalized:k});let P=o;return O.$d&&(P=(0,C.$Sf)(P)),(a===3?P.startsWith(k):(0,c.$4e)(P,k))?`~/${P.substr(k.length)}`:o}e.$yv=u;function b(o,$){return o.replace(/^~($|\/|\\)/,`${$}$1`)}e.$zv=b;const p="\u2026",g="\\\\",t="~";function i(o,$=I.sep){const a=new Array(o.length);let k=!1;for(let P=0;P<o.length;P++){const h=o[P];if(h===""){a[P]=`.${$}`;continue}if(!h){a[P]=h;continue}k=!0;let w="",y=h;y.indexOf(g)===0?(w=y.substr(0,y.indexOf(g)+g.length),y=y.substr(y.indexOf(g)+g.length)):y.indexOf($)===0?(w=y.substr(0,y.indexOf($)+$.length),y=y.substr(y.indexOf($)+$.length)):y.indexOf(t)===0&&(w=y.substr(0,y.indexOf(t)+t.length),y=y.substr(y.indexOf(t)+t.length));const M=y.split($);for(let V=1;k&&V<=M.length;V++)for(let B=M.length-V;k&&B>=0;B--){k=!1;let z=M.slice(B,B+V).join($);for(let T=0;!k&&T<o.length;T++)if(T!==P&&o[T]&&o[T].indexOf(z)>-1){const F=B+V===M.length,j=B>0&&o[T].indexOf($)>-1?$+z:z,q=o[T].endsWith(j);k=!F||q}if(!k){let T="";(M[0].endsWith(":")||w!=="")&&(B===1&&(B=0,V++,z=M[0]+$+z),B>0&&(T=M[0]+$),T=w+T),B>0&&(T=T+p+$),T=T+z,B+V<M.length&&(T=T+$+p),a[P]=T}}k&&(a[P]=h)}return a}e.$Av=i;var l;(function(o){o[o.TEXT=0]="TEXT",o[o.VARIABLE=1]="VARIABLE",o[o.SEPARATOR=2]="SEPARATOR"})(l||(l={}));function v(o,$=Object.create(null)){const a=[];let k=!1,P="";for(const h of o)if(h==="$"||k&&h==="{")P&&a.push({value:P,type:l.TEXT}),P="",k=!0;else if(h==="}"&&k){const w=$[P];if(typeof w=="string")w.length&&a.push({value:w,type:l.VARIABLE});else if(w){const y=a[a.length-1];(!y||y.type!==l.SEPARATOR)&&a.push({value:w.label,type:l.SEPARATOR})}P="",k=!1}else P+=h;return P&&!k&&a.push({value:P,type:l.TEXT}),a.filter((h,w)=>{if(h.type===l.SEPARATOR){const y=a[w-1],M=a[w+1];return[y,M].every(V=>V&&(V.type===l.VARIABLE||V.type===l.TEXT)&&V.value.length>0)}return!0}).map(h=>h.value).join("")}e.$Bv=v;function D(o,$){return O.$e||$?o.replace(/\(&&\w\)|&&/g,"").replace(/&/g,O.$e?"&":"&&"):o.replace(/&&|&/g,a=>a==="&"?"&&":"&")}e.$Cv=D;function m(o,$){return O.$e||$?o.replace(/\(&&\w\)|&&/g,""):O.$d?o.replace(/&&|&/g,a=>a==="&"?"&&":"&"):o.replace(/&&/g,"_")}e.$Dv=m;function n(o){return o.replace(/&/g,"&&")}e.$Ev=n;function r(o){if(o.endsWith("]")){const $=o.lastIndexOf(" [",o.length-2);if($!==-1){const a=s(o.substring(0,$));return{name:a.name,parentPath:a.parentPath+o.substring($)}}}return s(o)}e.$Fv=r;function s(o){const $=o.indexOf("/")!==-1?I.$gc:I.$fc,a=$.basename(o),k=$.dirname(o);return a.length?{name:a,parentPath:k}:{name:k,parentPath:""}}}),define(Ae[123],Re([1,0,26,2]),function(ee,e,f,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rm=e.$Qm=e.$Pm=e.$Om=e.$Nm=void 0;function I(S){return S.toJSON()}class O{constructor(u){this.a=u}transformIncoming(u){const b=this.a.transformIncoming(u);return b===u?u:I(C.URI.from(b))}transformOutgoing(u){const b=this.a.transformOutgoing(u);return b===u?u:I(C.URI.from(b))}transformOutgoingURI(u){const b=this.a.transformOutgoing(u);return b===u?u:C.URI.from(b)}transformOutgoingScheme(u){return this.a.transformOutgoingScheme(u)}}e.$Nm=O,e.$Om=new class{transformIncoming(S){return S}transformOutgoing(S){return S}transformOutgoingURI(S){return S}transformOutgoingScheme(S){return S}};function A(S,u,b){if(!S||b>200)return null;if(typeof S=="object"){if(S instanceof C.URI)return u.transformOutgoing(S);for(const p in S)if(Object.hasOwnProperty.call(S,p)){const g=A(S[p],u,b+1);g!==null&&(S[p]=g)}}return null}function c(S,u){const b=A(S,u,0);return b===null?S:b}e.$Pm=c;function E(S,u,b,p){if(!S||p>200)return null;if(typeof S=="object"){if(S.$mid===1)return b?C.URI.revive(u.transformIncoming(S)):u.transformIncoming(S);if(S instanceof f.$ce)return null;for(const g in S)if(Object.hasOwnProperty.call(S,g)){const t=E(S[g],u,b,p+1);t!==null&&(S[g]=t)}}return null}function d(S,u){const b=E(S,u,!1,0);return b===null?S:b}e.$Qm=d;function R(S,u){const b=E(S,u,!0,0);return b===null?S:b}e.$Rm=R}),define(Ae[37],Re([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fg=e.$eg=void 0;const f=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function C(I){return f.test(I)}e.$eg=C,e.$fg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let I;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?I=crypto.getRandomValues.bind(crypto):I=function(c){for(let E=0;E<c.length;E++)c[E]=Math.floor(Math.random()*256);return c};const O=new Uint8Array(16),A=[];for(let c=0;c<256;c++)A.push(c.toString(16).padStart(2,"0"));return function(){I(O),O[6]=O[6]&15|64,O[8]=O[8]&63|128;let E=0,d="";return d+=A[O[E++]],d+=A[O[E++]],d+=A[O[E++]],d+=A[O[E++]],d+="-",d+=A[O[E++]],d+=A[O[E++]],d+="-",d+=A[O[E++]],d+=A[O[E++]],d+="-",d+=A[O[E++]],d+=A[O[E++]],d+="-",d+=A[O[E++]],d+=A[O[E++]],d+=A[O[E++]],d+=A[O[E++]],d+=A[O[E++]],d+=A[O[E++]],d}}()}),define(Ae[124],Re([1,0,18,68,37]),function(ee,e,f,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8s=e.$7s=e.$6s=e.$5s=e.$4s=void 0;function O(S){return{asString:async()=>S,asFile:()=>{},value:typeof S=="string"?S:void 0}}e.$4s=O;function A(S,u,b){const p={id:(0,I.$fg)(),name:S,uri:u,data:b};return{asString:async()=>"",asFile:()=>p,value:void 0}}e.$5s=A;class c{constructor(){this.a=new Map}get size(){let u=0;for(const b of this.a)u++;return u}has(u){return this.a.has(this.b(u))}matches(u){const b=[...this.a.keys()];return C.Iterable.some(this,([p,g])=>g.asFile())&&b.push("files"),R(E(u),b)}get(u){return this.a.get(this.b(u))?.[0]}append(u,b){const p=this.a.get(u);p?p.push(b):this.a.set(this.b(u),[b])}replace(u,b){this.a.set(this.b(u),[b])}delete(u){this.a.delete(this.b(u))}*[Symbol.iterator](){for(const[u,b]of this.a)for(const p of b)yield[u,p]}b(u){return E(u)}}e.$6s=c;function E(S){return S.toLowerCase()}function d(S,u){return R(E(S),u.map(E))}e.$7s=d;function R(S,u){if(S==="*/*")return u.length>0;if(u.includes(S))return!0;const b=S.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!b)return!1;const[p,g,t]=b;return t==="*"?u.some(i=>i.startsWith(g+"/")):!1}e.$8s=Object.freeze({create:S=>(0,f.$Mb)(S.map(u=>u.toString())).join(`\r
`),split:S=>S.split(`\r
`),parse:S=>e.$8s.split(S).filter(u=>!u.startsWith("#"))})}),define(Ae[125],Re([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8r=void 0,e.$8r={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Ae[126],Re([1,0,36,20]),function(ee,e,f,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yE=void 0;function I(O,A,c,E,d,R){if(Array.isArray(O)){let S=0;for(const u of O){const b=I(u,A,c,E,d,R);if(b===10)return b;b>S&&(S=b)}return S}else{if(typeof O=="string")return E?O==="*"?5:O===c?10:0:0;if(O){const{language:S,pattern:u,scheme:b,hasAccessToAllModels:p,notebookType:g}=O;if(!E&&!p)return 0;g&&d&&(A=d);let t=0;if(b)if(b===A.scheme)t=10;else if(b==="*")t=5;else return 0;if(S)if(S===c)t=10;else if(S==="*")t=Math.max(t,5);else return 0;if(g)if(g===R)t=10;else if(g==="*"&&R!==void 0)t=Math.max(t,5);else return 0;if(u){let i;if(typeof u=="string"?i=u:i={...u,base:(0,C.$hc)(u.base)},i===A.fsPath||(0,f.$wj)(i,A.fsPath))t=10;else return 0}return t}else return 0}}e.$yE=I}),define(Ae[127],Re([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vt=e.$ut=e.IndentAction=void 0;var f;(function(A){A[A.None=0]="None",A[A.Indent=1]="Indent",A[A.IndentOutdent=2]="IndentOutdent",A[A.Outdent=3]="Outdent"})(f||(e.IndentAction=f={}));class C{constructor(c){if(this.e=null,this.f=!1,this.open=c.open,this.close=c.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(c.notIn))for(let E=0,d=c.notIn.length;E<d;E++)switch(c.notIn[E]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(c){switch(c){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(c,E){if(c.getTokenCount()===0)return!0;const d=c.findTokenIndexAtOffset(E-2),R=c.getStandardTokenType(d);return this.isOK(R)}g(c,E){for(let d=c;d<=E;d++){const R=String.fromCharCode(d);if(!this.open.includes(R)&&!this.close.includes(R))return R}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$ut=C;class I{constructor(c){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const E of c)O(this.autoClosingPairsOpenByStart,E.open.charAt(0),E),O(this.autoClosingPairsOpenByEnd,E.open.charAt(E.open.length-1),E),O(this.autoClosingPairsCloseByStart,E.close.charAt(0),E),O(this.autoClosingPairsCloseByEnd,E.close.charAt(E.close.length-1),E),E.close.length===1&&E.open.length===1&&O(this.autoClosingPairsCloseSingleChar,E.close,E)}}e.$vt=I;function O(A,c,E){A.has(c)?A.get(c).push(E):A.set(c,[E])}}),define(Ae[91],Re([1,0,26,23]),function(ee,e,f,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$c$=e.$b$=void 0;var I;(function(S){S[S.Full=1]="Full",S[S.Delta=2]="Delta"})(I||(I={}));function O(S){for(let u=0,b=S.length;u<b;u+=4){const p=S[u+0],g=S[u+1],t=S[u+2],i=S[u+3];S[u+0]=i,S[u+1]=t,S[u+2]=g,S[u+3]=p}}function A(S){const u=new Uint8Array(S.buffer,S.byteOffset,S.length*4);return C.$x()||O(u),f.$ce.wrap(u)}function c(S){const u=S.buffer;if(C.$x()||O(u),u.byteOffset%4===0)return new Uint32Array(u.buffer,u.byteOffset,u.length/4);{const b=new Uint8Array(u.byteLength);return b.set(u),new Uint32Array(b.buffer,b.byteOffset,b.length/4)}}function E(S){const u=new Uint32Array(d(S));let b=0;if(u[b++]=S.id,S.type==="full")u[b++]=1,u[b++]=S.data.length,u.set(S.data,b),b+=S.data.length;else{u[b++]=2,u[b++]=S.deltas.length;for(const p of S.deltas)u[b++]=p.start,u[b++]=p.deleteCount,p.data?(u[b++]=p.data.length,u.set(p.data,b),b+=p.data.length):u[b++]=0}return A(u)}e.$b$=E;function d(S){let u=0;if(u+=1+1,S.type==="full")u+=1+S.data.length;else{u+=1,u+=(1+1+1)*S.deltas.length;for(const b of S.deltas)b.data&&(u+=b.data.length)}return u}function R(S){const u=c(S);let b=0;const p=u[b++];if(u[b++]===1){const l=u[b++],v=u.subarray(b,b+l);return b+=l,{id:p,type:"full",data:v}}const t=u[b++],i=[];for(let l=0;l<t;l++){const v=u[b++],D=u[b++],m=u[b++];let n;m>0&&(n=u.subarray(b,b+m),b+=m),i[l]={start:v,deleteCount:D,data:n}}return{id:p,type:"delta",deltas:i}}e.$c$=R}),define(Ae[128],Re([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$67=e.$57=void 0;class f{constructor(){this.a=new Map}removeDragOperationTransfer(O){if(O&&this.a.has(O)){const A=this.a.get(O);return this.a.delete(O),A}}addDragOperationTransfer(O,A){this.a.set(O,A)}}e.$57=f;class C{constructor(O){this.identifier=O}}e.$67=C}),define(Ae[129],Re([9,10]),function(ee,e){return ee.create("vs/base/common/actions",e)}),define(Ae[130],Re([1,0,5,6,129]),function(ee,e,f,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ai=e.$zi=e.$yi=e.$xi=e.$wi=e.$vi=void 0;class O extends C.$Sc{constructor(u,b="",p="",g=!0,t){super(),this.h=this.B(new f.$Od),this.onDidChange=this.h.event,this.w=!0,this.j=u,this.m=b,this.u=p,this.w=g,this.C=t}get id(){return this.j}get label(){return this.m}set label(u){this.D(u)}D(u){this.m!==u&&(this.m=u,this.h.fire({label:u}))}get tooltip(){return this.n||""}set tooltip(u){this.F(u)}F(u){this.n!==u&&(this.n=u,this.h.fire({tooltip:u}))}get class(){return this.u}set class(u){this.G(u)}G(u){this.u!==u&&(this.u=u,this.h.fire({class:u}))}get enabled(){return this.w}set enabled(u){this.H(u)}H(u){this.w!==u&&(this.w=u,this.h.fire({enabled:u}))}get checked(){return this.z}set checked(u){this.I(u)}I(u){this.z!==u&&(this.z=u,this.h.fire({checked:u}))}async run(u,b){this.C&&await this.C(u)}}e.$vi=O;class A extends C.$Sc{constructor(){super(...arguments),this.f=this.B(new f.$Od),this.onWillRun=this.f.event,this.m=this.B(new f.$Od),this.onDidRun=this.m.event}async run(u,b){if(!u.enabled)return;this.f.fire({action:u});let p;try{await this.u(u,b)}catch(g){p=g}this.m.fire({action:u,error:p})}async u(u,b){await u.run(b)}}e.$wi=A;class c{constructor(){this.id=c.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...u){let b=[];for(const p of u)p.length&&(b.length?b=[...b,new c,...p]:b=p);return b}async run(){}}e.$xi=c,c.ID="vs.actions.separator";class E{get actions(){return this.a}constructor(u,b,p,g){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=u,this.label=b,this.class=g,this.a=p}async run(){}}e.$yi=E;class d extends O{constructor(){super(d.ID,I.localize(0,null),void 0,!1)}}e.$zi=d,d.ID="vs.actions.empty";function R(S){return{id:S.id,label:S.label,class:void 0,enabled:S.enabled??!0,checked:S.checked??!1,run:async(...u)=>S.run(...u),tooltip:S.label}}e.$Ai=R}),define(Ae[131],Re([9,10]),function(ee,e){return ee.create("vs/base/common/date",e)}),define(Ae[132],Re([1,0,131]),function(ee,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gm=e.$fm=void 0;const C=60,I=C*60,O=I*24,A=O*7,c=O*30,E=O*365;function d(S,u,b,p){typeof S!="number"&&(S=S.getTime());const g=Math.round((new Date().getTime()-S)/1e3);if(g<-30)return(0,f.localize)(0,null,d(new Date().getTime()+g*1e3,!1));if(!p&&g<30)return(0,f.localize)(1,null);let t;return g<C?(t=g,u?t===1?b?(0,f.localize)(2,null,t):(0,f.localize)(3,null,t):b?(0,f.localize)(4,null,t):(0,f.localize)(5,null,t):t===1?b?(0,f.localize)(6,null,t):(0,f.localize)(7,null,t):b?(0,f.localize)(8,null,t):(0,f.localize)(9,null,t)):g<I?(t=Math.floor(g/C),u?t===1?b?(0,f.localize)(10,null,t):(0,f.localize)(11,null,t):b?(0,f.localize)(12,null,t):(0,f.localize)(13,null,t):t===1?b?(0,f.localize)(14,null,t):(0,f.localize)(15,null,t):b?(0,f.localize)(16,null,t):(0,f.localize)(17,null,t)):g<O?(t=Math.floor(g/I),u?t===1?b?(0,f.localize)(18,null,t):(0,f.localize)(19,null,t):b?(0,f.localize)(20,null,t):(0,f.localize)(21,null,t):t===1?b?(0,f.localize)(22,null,t):(0,f.localize)(23,null,t):b?(0,f.localize)(24,null,t):(0,f.localize)(25,null,t)):g<A?(t=Math.floor(g/O),u?t===1?(0,f.localize)(26,null,t):(0,f.localize)(27,null,t):t===1?(0,f.localize)(28,null,t):(0,f.localize)(29,null,t)):g<c?(t=Math.floor(g/A),u?t===1?b?(0,f.localize)(30,null,t):(0,f.localize)(31,null,t):b?(0,f.localize)(32,null,t):(0,f.localize)(33,null,t):t===1?b?(0,f.localize)(34,null,t):(0,f.localize)(35,null,t):b?(0,f.localize)(36,null,t):(0,f.localize)(37,null,t)):g<E?(t=Math.floor(g/c),u?t===1?b?(0,f.localize)(38,null,t):(0,f.localize)(39,null,t):b?(0,f.localize)(40,null,t):(0,f.localize)(41,null,t):t===1?b?(0,f.localize)(42,null,t):(0,f.localize)(43,null,t):b?(0,f.localize)(44,null,t):(0,f.localize)(45,null,t)):(t=Math.floor(g/E),u?t===1?b?(0,f.localize)(46,null,t):(0,f.localize)(47,null,t):b?(0,f.localize)(48,null,t):(0,f.localize)(49,null,t):t===1?b?(0,f.localize)(50,null,t):(0,f.localize)(51,null,t):b?(0,f.localize)(52,null,t):(0,f.localize)(53,null,t))}e.$fm=d;function R(S){return S.getFullYear()+"-"+String(S.getMonth()+1).padStart(2,"0")+"-"+String(S.getDate()).padStart(2,"0")+"T"+String(S.getHours()).padStart(2,"0")+":"+String(S.getMinutes()).padStart(2,"0")+":"+String(S.getSeconds()).padStart(2,"0")+"."+(S.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$gm=R}),define(Ae[133],Re([9,10]),function(ee,e){return ee.create("vs/base/common/errorMessage",e)}),define(Ae[38],Re([1,0,18,15,133]),function(ee,e,f,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Di=e.$Ci=e.$Bi=void 0;function O(S,u){return u&&(S.stack||S.stacktrace)?I.localize(0,null,c(S),A(S.stack)||A(S.stacktrace)):c(S)}function A(S){return Array.isArray(S)?S.join(`
`):S}function c(S){return S.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${S.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof S.code=="string"&&typeof S.errno=="number"&&typeof S.syscall=="string"?I.localize(1,null,S.message):S.message||I.localize(2,null)}function E(S=null,u=!1){if(!S)return I.localize(3,null);if(Array.isArray(S)){const b=f.$Hb(S),p=E(b[0],u);return b.length>1?I.localize(4,null,p,b.length):p}if(C.$zf(S))return S;if(S.detail){const b=S.detail;if(b.error)return O(b.error,u);if(b.exception)return O(b.exception,u)}return S.stack?O(S,u):S.message?S.message:I.localize(5,null)}e.$Bi=E;function d(S){const u=S;return u instanceof Error&&Array.isArray(u.actions)}e.$Ci=d;function R(S,u){let b;return typeof S=="string"?b=new Error(S):b=S,b.actions=u,b}e.$Di=R}),define(Ae[134],Re([9,10]),function(ee,e){return ee.create("vs/editor/common/config/editorOptions",e)}),define(Ae[135],Re([1,0,18,25,23,125,136,134]),function(ee,e,f,C,I,O,A,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedFloat=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var E;(function(_){_[_.None=0]="None",_[_.Keep=1]="Keep",_[_.Brackets=2]="Brackets",_[_.Advanced=3]="Advanced",_[_.Full=4]="Full"})(E||(e.EditorAutoIndentStrategy=E={})),e.MINIMAP_GUTTER_WIDTH=8;class d{constructor(Z){this.c=Z}hasChanged(Z){return this.c[Z]}}e.ConfigurationChangedEvent=d;class R{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=R;class S{constructor(Z,Ee,We,ze){this.id=Z,this.name=Ee,this.defaultValue=We,this.schema=ze}applyUpdate(Z,Ee){return b(Z,Ee)}compute(Z,Ee,We){return We}}class u{constructor(Z,Ee){this.newValue=Z,this.didChange=Ee}}e.ApplyUpdateResult=u;function b(_,Z){if(typeof _!="object"||typeof Z!="object"||!_||!Z)return new u(Z,_!==Z);if(Array.isArray(_)||Array.isArray(Z)){const We=Array.isArray(_)&&Array.isArray(Z)&&f.$ub(_,Z);return new u(Z,!We)}let Ee=!1;for(const We in Z)if(Z.hasOwnProperty(We)){const ze=b(_[We],Z[We]);ze.didChange&&(_[We]=ze.newValue,Ee=!0)}return new u(_,Ee)}class p{constructor(Z){this.schema=void 0,this.id=Z,this.name="_never_",this.defaultValue=void 0}applyUpdate(Z,Ee){return b(Z,Ee)}validate(Z){return this.defaultValue}}class g{constructor(Z,Ee,We,ze){this.id=Z,this.name=Ee,this.defaultValue=We,this.schema=ze}applyUpdate(Z,Ee){return b(Z,Ee)}validate(Z){return typeof Z>"u"?this.defaultValue:Z}compute(Z,Ee,We){return We}}function t(_,Z){return typeof _>"u"?Z:_==="false"?!1:!!_}e.boolean=t;class i extends g{constructor(Z,Ee,We,ze=void 0){typeof ze<"u"&&(ze.type="boolean",ze.default=We),super(Z,Ee,We,ze)}validate(Z){return t(Z,this.defaultValue)}}function l(_,Z,Ee,We){if(typeof _>"u")return Z;let ze=parseInt(_,10);return isNaN(ze)?Z:(ze=Math.max(Ee,ze),ze=Math.min(We,ze),ze|0)}e.clampedInt=l;class v extends g{static clampedInt(Z,Ee,We,ze){return l(Z,Ee,We,ze)}constructor(Z,Ee,We,ze,Ze,st=void 0){typeof st<"u"&&(st.type="integer",st.default=We,st.minimum=ze,st.maximum=Ze),super(Z,Ee,We,st),this.minimum=ze,this.maximum=Ze}validate(Z){return v.clampedInt(Z,this.defaultValue,this.minimum,this.maximum)}}function D(_,Z,Ee,We){if(typeof _>"u")return Z;const ze=m.float(_,Z);return m.clamp(ze,Ee,We)}e.clampedFloat=D;class m extends g{static clamp(Z,Ee,We){return Z<Ee?Ee:Z>We?We:Z}static float(Z,Ee){if(typeof Z=="number")return Z;if(typeof Z>"u")return Ee;const We=parseFloat(Z);return isNaN(We)?Ee:We}constructor(Z,Ee,We,ze,Ze){typeof Ze<"u"&&(Ze.type="number",Ze.default=We),super(Z,Ee,We,Ze),this.validationFn=ze}validate(Z){return this.validationFn(m.float(Z,this.defaultValue))}}class n extends g{static string(Z,Ee){return typeof Z!="string"?Ee:Z}constructor(Z,Ee,We,ze=void 0){typeof ze<"u"&&(ze.type="string",ze.default=We),super(Z,Ee,We,ze)}validate(Z){return n.string(Z,this.defaultValue)}}function r(_,Z,Ee,We){return typeof _!="string"?Z:We&&_ in We?We[_]:Ee.indexOf(_)===-1?Z:_}e.stringSet=r;class s extends g{constructor(Z,Ee,We,ze,Ze=void 0){typeof Ze<"u"&&(Ze.type="string",Ze.enum=ze,Ze.default=We),super(Z,Ee,We,Ze),this.c=ze}validate(Z){return r(Z,this.defaultValue,this.c)}}class o extends S{constructor(Z,Ee,We,ze,Ze,st,vt=void 0){typeof vt<"u"&&(vt.type="string",vt.enum=Ze,vt.default=ze),super(Z,Ee,We,vt),this.c=Ze,this.d=st}validate(Z){return typeof Z!="string"?this.defaultValue:this.c.indexOf(Z)===-1?this.defaultValue:this.d(Z)}}function $(_){switch(_){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class a extends S{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[c.localize(0,null),c.localize(1,null),c.localize(2,null)],default:"auto",tags:["accessibility"],description:c.localize(3,null)})}validate(Z){switch(Z){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(Z,Ee,We){return We===0?Z.accessibilitySupport:We}}class k extends S{constructor(){const Z={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",Z,{"editor.comments.insertSpace":{type:"boolean",default:Z.insertSpace,description:c.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:Z.ignoreEmptyLines,description:c.localize(5,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const Ee=Z;return{insertSpace:t(Ee.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:t(Ee.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var P;(function(_){_[_.Hidden=0]="Hidden",_[_.Blink=1]="Blink",_[_.Smooth=2]="Smooth",_[_.Phase=3]="Phase",_[_.Expand=4]="Expand",_[_.Solid=5]="Solid"})(P||(e.TextEditorCursorBlinkingStyle=P={}));function h(_){switch(_){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var w;(function(_){_[_.Line=1]="Line",_[_.Block=2]="Block",_[_.Underline=3]="Underline",_[_.LineThin=4]="LineThin",_[_.BlockOutline=5]="BlockOutline",_[_.UnderlineThin=6]="UnderlineThin"})(w||(e.TextEditorCursorStyle=w={}));function y(_){switch(_){case w.Line:return"line";case w.Block:return"block";case w.Underline:return"underline";case w.LineThin:return"line-thin";case w.BlockOutline:return"block-outline";case w.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=y;function M(_){switch(_){case"line":return w.Line;case"block":return w.Block;case"underline":return w.Underline;case"line-thin":return w.LineThin;case"block-outline":return w.BlockOutline;case"underline-thin":return w.UnderlineThin}}class V extends p{constructor(){super(141)}compute(Z,Ee,We){const ze=["monaco-editor"];return Ee.get(39)&&ze.push(Ee.get(39)),Z.extraEditorClassName&&ze.push(Z.extraEditorClassName),Ee.get(73)==="default"?ze.push("mouse-default"):Ee.get(73)==="copy"&&ze.push("mouse-copy"),Ee.get(111)&&ze.push("showUnused"),Ee.get(139)&&ze.push("showDeprecated"),ze.join(" ")}}class B extends i{constructor(){super(37,"emptySelectionClipboard",!0,{description:c.localize(6,null)})}compute(Z,Ee,We){return We&&Z.emptySelectionClipboard}}class z extends S{constructor(){const Z={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",Z,{"editor.find.cursorMoveOnType":{type:"boolean",default:Z.cursorMoveOnType,description:c.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:Z.seedSearchStringFromSelection,enumDescriptions:[c.localize(8,null),c.localize(9,null),c.localize(10,null)],description:c.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:Z.autoFindInSelection,enumDescriptions:[c.localize(12,null),c.localize(13,null),c.localize(14,null)],description:c.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:Z.globalFindClipboard,description:c.localize(16,null),included:I.$e},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:Z.addExtraSpaceOnTop,description:c.localize(17,null)},"editor.find.loop":{type:"boolean",default:Z.loop,description:c.localize(18,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const Ee=Z;return{cursorMoveOnType:t(Ee.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof Z.seedSearchStringFromSelection=="boolean"?Z.seedSearchStringFromSelection?"always":"never":r(Ee.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof Z.autoFindInSelection=="boolean"?Z.autoFindInSelection?"always":"never":r(Ee.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:t(Ee.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:t(Ee.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:t(Ee.loop,this.defaultValue.loop)}}}class T extends S{constructor(){super(51,"fontLigatures",T.OFF,{anyOf:[{type:"boolean",description:c.localize(19,null)},{type:"string",description:c.localize(20,null)}],description:c.localize(21,null),default:!1})}validate(Z){return typeof Z>"u"?this.defaultValue:typeof Z=="string"?Z==="false"?T.OFF:Z==="true"?T.ON:Z:Z?T.ON:T.OFF}}e.EditorFontLigatures=T,T.OFF='"liga" off, "calt" off',T.ON='"liga" on, "calt" on';class F extends S{constructor(){super(54,"fontVariations",F.OFF,{anyOf:[{type:"boolean",description:c.localize(22,null)},{type:"string",description:c.localize(23,null)}],description:c.localize(24,null),default:!1})}validate(Z){return typeof Z>"u"?this.defaultValue:typeof Z=="string"?Z==="false"?F.OFF:Z==="true"?F.TRANSLATE:Z:Z?F.TRANSLATE:F.OFF}compute(Z,Ee,We){return Z.fontInfo.fontVariationSettings}}e.EditorFontVariations=F,F.OFF="normal",F.TRANSLATE="translate";class j extends p{constructor(){super(50)}compute(Z,Ee,We){return Z.fontInfo}}class q extends g{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:c.localize(25,null)})}validate(Z){const Ee=m.float(Z,this.defaultValue);return Ee===0?e.EDITOR_FONT_DEFAULTS.fontSize:m.clamp(Ee,6,100)}compute(Z,Ee,We){return Z.fontInfo.fontSize}}class W extends S{constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:W.d,maximum:W.e,errorMessage:c.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:W.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:c.localize(27,null)})}validate(Z){return Z==="normal"||Z==="bold"?Z:String(v.clampedInt(Z,e.EDITOR_FONT_DEFAULTS.fontWeight,W.d,W.e))}}W.c=["normal","bold","100","200","300","400","500","600","700","800","900"],W.d=1,W.e=1e3;class we extends S{constructor(){const Z={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},Ee={type:"string",enum:["peek","gotoAndPeek","goto"],default:Z.multiple,enumDescriptions:[c.localize(28,null),c.localize(29,null),c.localize(30,null)]},We=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",Z,{"editor.gotoLocation.multiple":{deprecationMessage:c.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:c.localize(32,null),...Ee},"editor.gotoLocation.multipleTypeDefinitions":{description:c.localize(33,null),...Ee},"editor.gotoLocation.multipleDeclarations":{description:c.localize(34,null),...Ee},"editor.gotoLocation.multipleImplementations":{description:c.localize(35,null),...Ee},"editor.gotoLocation.multipleReferences":{description:c.localize(36,null),...Ee},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:Z.alternativeDefinitionCommand,enum:We,description:c.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:Z.alternativeTypeDefinitionCommand,enum:We,description:c.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:Z.alternativeDeclarationCommand,enum:We,description:c.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:Z.alternativeImplementationCommand,enum:We,description:c.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:Z.alternativeReferenceCommand,enum:We,description:c.localize(41,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const Ee=Z;return{multiple:r(Ee.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:Ee.multipleDefinitions??r(Ee.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:Ee.multipleTypeDefinitions??r(Ee.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:Ee.multipleDeclarations??r(Ee.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:Ee.multipleImplementations??r(Ee.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:Ee.multipleReferences??r(Ee.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:n.string(Ee.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:n.string(Ee.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:n.string(Ee.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:n.string(Ee.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:n.string(Ee.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class ke extends S{constructor(){const Z={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",Z,{"editor.hover.enabled":{type:"boolean",default:Z.enabled,description:c.localize(42,null)},"editor.hover.delay":{type:"number",default:Z.delay,minimum:0,maximum:1e4,description:c.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:Z.sticky,description:c.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:Z.hidingDelay,description:c.localize(45,null)},"editor.hover.above":{type:"boolean",default:Z.above,description:c.localize(46,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const Ee=Z;return{enabled:t(Ee.enabled,this.defaultValue.enabled),delay:v.clampedInt(Ee.delay,this.defaultValue.delay,0,1e4),sticky:t(Ee.sticky,this.defaultValue.sticky),hidingDelay:v.clampedInt(Ee.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:t(Ee.above,this.defaultValue.above)}}}var Se;(function(_){_[_.None=0]="None",_[_.Text=1]="Text",_[_.Blocks=2]="Blocks"})(Se||(e.RenderMinimap=Se={}));class ve extends p{constructor(){super(144)}compute(Z,Ee,We){return ve.computeLayout(Ee,{memory:Z.memory,outerWidth:Z.outerWidth,outerHeight:Z.outerHeight,isDominatedByLongLines:Z.isDominatedByLongLines,lineHeight:Z.fontInfo.lineHeight,viewLineCount:Z.viewLineCount,lineNumbersDigitCount:Z.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:Z.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:Z.fontInfo.maxDigitWidth,pixelRatio:Z.pixelRatio,glyphMarginDecorationLaneCount:Z.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(Z){const Ee=Z.height/Z.lineHeight,We=Math.floor(Z.paddingTop/Z.lineHeight);let ze=Math.floor(Z.paddingBottom/Z.lineHeight);Z.scrollBeyondLastLine&&(ze=Math.max(ze,Ee-1));const Ze=(We+Z.viewLineCount+ze)/(Z.pixelRatio*Z.height),st=Math.floor(Z.viewLineCount/Ze);return{typicalViewportLineCount:Ee,extraLinesBeforeFirstLine:We,extraLinesBeyondLastLine:ze,desiredRatio:Ze,minimapLineCount:st}}static c(Z,Ee){const We=Z.outerWidth,ze=Z.outerHeight,Ze=Z.pixelRatio;if(!Z.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Ze*ze),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:ze};const st=Ee.stableMinimapLayoutInput,vt=st&&Z.outerHeight===st.outerHeight&&Z.lineHeight===st.lineHeight&&Z.typicalHalfwidthCharacterWidth===st.typicalHalfwidthCharacterWidth&&Z.pixelRatio===st.pixelRatio&&Z.scrollBeyondLastLine===st.scrollBeyondLastLine&&Z.paddingTop===st.paddingTop&&Z.paddingBottom===st.paddingBottom&&Z.minimap.enabled===st.minimap.enabled&&Z.minimap.side===st.minimap.side&&Z.minimap.size===st.minimap.size&&Z.minimap.showSlider===st.minimap.showSlider&&Z.minimap.renderCharacters===st.minimap.renderCharacters&&Z.minimap.maxColumn===st.minimap.maxColumn&&Z.minimap.scale===st.minimap.scale&&Z.verticalScrollbarWidth===st.verticalScrollbarWidth&&Z.isViewportWrapping===st.isViewportWrapping,yt=Z.lineHeight,Mt=Z.typicalHalfwidthCharacterWidth,Vt=Z.scrollBeyondLastLine,qt=Z.minimap.renderCharacters;let Et=Ze>=2?Math.round(Z.minimap.scale*2):Z.minimap.scale;const Lt=Z.minimap.maxColumn,Ot=Z.minimap.size,xt=Z.minimap.side,Yt=Z.verticalScrollbarWidth,It=Z.viewLineCount,Nt=Z.remainingWidth,Qt=Z.isViewportWrapping,zt=qt?2:3;let Kt=Math.floor(Ze*ze);const Ht=Kt/Ze;let Ct=!1,ct=!1,ht=zt*Et,Pt=Et/Ze,Tt=1;if(Ot==="fill"||Ot==="fit"){const{typicalViewportLineCount:Jt,extraLinesBeforeFirstLine:Pe,extraLinesBeyondLastLine:Fe,desiredRatio:$e,minimapLineCount:G}=ve.computeContainedMinimapLineCount({viewLineCount:It,scrollBeyondLastLine:Vt,paddingTop:Z.paddingTop,paddingBottom:Z.paddingBottom,height:ze,lineHeight:yt,pixelRatio:Ze});if(It/G>1)Ct=!0,ct=!0,Et=1,ht=1,Pt=Et/Ze;else{let Be=!1,Je=Et+1;if(Ot==="fit"){const He=Math.ceil((Pe+It+Fe)*ht);Qt&&vt&&Nt<=Ee.stableFitRemainingWidth?(Be=!0,Je=Ee.stableFitMaxMinimapScale):Be=He>Kt}if(Ot==="fill"||Be){Ct=!0;const He=Et;ht=Math.min(yt*Ze,Math.max(1,Math.floor(1/$e))),Qt&&vt&&Nt<=Ee.stableFitRemainingWidth&&(Je=Ee.stableFitMaxMinimapScale),Et=Math.min(Je,Math.max(1,Math.floor(ht/zt))),Et>He&&(Tt=Math.min(2,Et/He)),Pt=Et/Ze/Tt,Kt=Math.ceil(Math.max(Jt,Pe+It+Fe)*ht),Qt?(Ee.stableMinimapLayoutInput=Z,Ee.stableFitRemainingWidth=Nt,Ee.stableFitMaxMinimapScale=Et):(Ee.stableMinimapLayoutInput=null,Ee.stableFitRemainingWidth=0)}}}const Ft=Math.floor(Lt*Pt),ut=Math.min(Ft,Math.max(0,Math.floor((Nt-Yt-2)*Pt/(Mt+Pt)))+e.MINIMAP_GUTTER_WIDTH);let Dt=Math.floor(Ze*ut);const Ut=Dt/Ze;Dt=Math.floor(Dt*Tt);const jt=qt?1:2,Ve=xt==="left"?0:We-ut-Yt;return{renderMinimap:jt,minimapLeft:Ve,minimapWidth:ut,minimapHeightIsEditorHeight:Ct,minimapIsSampling:ct,minimapScale:Et,minimapLineHeight:ht,minimapCanvasInnerWidth:Dt,minimapCanvasInnerHeight:Kt,minimapCanvasOuterWidth:Ut,minimapCanvasOuterHeight:Ht}}static computeLayout(Z,Ee){const We=Ee.outerWidth|0,ze=Ee.outerHeight|0,Ze=Ee.lineHeight|0,st=Ee.lineNumbersDigitCount|0,vt=Ee.typicalHalfwidthCharacterWidth,yt=Ee.maxDigitWidth,Mt=Ee.pixelRatio,Vt=Ee.viewLineCount,qt=Z.get(136),Et=qt==="inherit"?Z.get(135):qt,Lt=Et==="inherit"?Z.get(131):Et,Ot=Z.get(134),xt=Ee.isDominatedByLongLines,Yt=Z.get(57),It=Z.get(67).renderType!==0,Nt=Z.get(68),Qt=Z.get(105),zt=Z.get(84),Kt=Z.get(72),Ht=Z.get(103),Ct=Ht.verticalScrollbarSize,ct=Ht.verticalHasArrows,ht=Ht.arrowSize,Pt=Ht.horizontalScrollbarSize,Tt=Z.get(43),Ft=Z.get(110)!=="never";let ut=Z.get(65);Tt&&Ft&&(ut+=16);let Dt=0;if(It){const St=Math.max(st,Nt);Dt=Math.round(St*yt)}let Ut=0;Yt&&(Ut=Ze*Ee.glyphMarginDecorationLaneCount);let jt=0,Ve=jt+Ut,Jt=Ve+Dt,Pe=Jt+ut;const Fe=We-Ut-Dt-ut;let $e=!1,G=!1,Me=-1;Et==="inherit"&&xt?($e=!0,G=!0):Lt==="on"||Lt==="bounded"?G=!0:Lt==="wordWrapColumn"&&(Me=Ot);const Be=ve.c({outerWidth:We,outerHeight:ze,lineHeight:Ze,typicalHalfwidthCharacterWidth:vt,pixelRatio:Mt,scrollBeyondLastLine:Qt,paddingTop:zt.top,paddingBottom:zt.bottom,minimap:Kt,verticalScrollbarWidth:Ct,viewLineCount:Vt,remainingWidth:Fe,isViewportWrapping:G},Ee.memory||new R);Be.renderMinimap!==0&&Be.minimapLeft===0&&(jt+=Be.minimapWidth,Ve+=Be.minimapWidth,Jt+=Be.minimapWidth,Pe+=Be.minimapWidth);const Je=Fe-Be.minimapWidth,He=Math.max(1,Math.floor((Je-Ct-2)/vt)),it=ct?ht:0;return G&&(Me=Math.max(1,He),Lt==="bounded"&&(Me=Math.min(Me,Ot))),{width:We,height:ze,glyphMarginLeft:jt,glyphMarginWidth:Ut,glyphMarginDecorationLaneCount:Ee.glyphMarginDecorationLaneCount,lineNumbersLeft:Ve,lineNumbersWidth:Dt,decorationsLeft:Jt,decorationsWidth:ut,contentLeft:Pe,contentWidth:Je,minimap:Be,viewportColumn:He,isWordWrapMinified:$e,isViewportWrapping:G,wrappingColumn:Me,verticalScrollbarWidth:Ct,horizontalScrollbarHeight:Pt,overviewRuler:{top:it,width:Ct,height:ze-2*it,right:0}}}}e.EditorLayoutInfoComputer=ve;class ge extends S{constructor(){super(138,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[c.localize(47,null),c.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:c.localize(49,null)}})}validate(Z){return r(Z,"simple",["simple","advanced"])}compute(Z,Ee,We){return Ee.get(2)===2?"advanced":We}}class re extends S{constructor(){const Z={enabled:!0};super(64,"lightbulb",Z,{"editor.lightbulb.enabled":{type:"boolean",default:Z.enabled,description:c.localize(50,null)}})}validate(Z){return!Z||typeof Z!="object"?this.defaultValue:{enabled:t(Z.enabled,this.defaultValue.enabled)}}}class oe extends S{constructor(){const Z={enabled:!1,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(115,"stickyScroll",Z,{"editor.stickyScroll.enabled":{type:"boolean",default:Z.enabled,description:c.localize(51,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:Z.maxLineCount,minimum:1,maximum:10,description:c.localize(52,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:Z.defaultModel,description:c.localize(53,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:Z.scrollWithEditor,description:c.localize(54,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const Ee=Z;return{enabled:t(Ee.enabled,this.defaultValue.enabled),maxLineCount:v.clampedInt(Ee.maxLineCount,this.defaultValue.maxLineCount,1,10),defaultModel:r(Ee.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:t(Ee.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class ye extends S{constructor(){const Z={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(140,"inlayHints",Z,{"editor.inlayHints.enabled":{type:"string",default:Z.enabled,description:c.localize(55,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[c.localize(56,null),c.localize(57,null,I.$e?"Ctrl+Option":"Ctrl+Alt"),c.localize(58,null,I.$e?"Ctrl+Option":"Ctrl+Alt"),c.localize(59,null)]},"editor.inlayHints.fontSize":{type:"number",default:Z.fontSize,markdownDescription:c.localize(60,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:Z.fontFamily,markdownDescription:c.localize(61,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:Z.padding,description:c.localize(62,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const Ee=Z;return typeof Ee.enabled=="boolean"&&(Ee.enabled=Ee.enabled?"on":"off"),{enabled:r(Ee.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:v.clampedInt(Ee.fontSize,this.defaultValue.fontSize,0,100),fontFamily:n.string(Ee.fontFamily,this.defaultValue.fontFamily),padding:t(Ee.padding,this.defaultValue.padding)}}}class De extends S{constructor(){super(65,"lineDecorationsWidth",10)}validate(Z){return typeof Z=="string"&&/^\d+(\.\d+)?ch$/.test(Z)?-parseFloat(Z.substring(0,Z.length-2)):v.clampedInt(Z,this.defaultValue,0,1e3)}compute(Z,Ee,We){return We<0?v.clampedInt(-We*Z.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):We}}class Q extends m{constructor(){super(66,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,Z=>m.clamp(Z,0,150),{markdownDescription:c.localize(63,null)})}compute(Z,Ee,We){return Z.fontInfo.lineHeight}}class ue extends S{constructor(){const Z={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(72,"minimap",Z,{"editor.minimap.enabled":{type:"boolean",default:Z.enabled,description:c.localize(64,null)},"editor.minimap.autohide":{type:"boolean",default:Z.autohide,description:c.localize(65,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[c.localize(66,null),c.localize(67,null),c.localize(68,null)],default:Z.size,description:c.localize(69,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:Z.side,description:c.localize(70,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:Z.showSlider,description:c.localize(71,null)},"editor.minimap.scale":{type:"number",default:Z.scale,minimum:1,maximum:3,enum:[1,2,3],description:c.localize(72,null)},"editor.minimap.renderCharacters":{type:"boolean",default:Z.renderCharacters,description:c.localize(73,null)},"editor.minimap.maxColumn":{type:"number",default:Z.maxColumn,description:c.localize(74,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const Ee=Z;return{enabled:t(Ee.enabled,this.defaultValue.enabled),autohide:t(Ee.autohide,this.defaultValue.autohide),size:r(Ee.size,this.defaultValue.size,["proportional","fill","fit"]),side:r(Ee.side,this.defaultValue.side,["right","left"]),showSlider:r(Ee.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:t(Ee.renderCharacters,this.defaultValue.renderCharacters),scale:v.clampedInt(Ee.scale,1,1,3),maxColumn:v.clampedInt(Ee.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function J(_){return _==="ctrlCmd"?I.$e?"metaKey":"ctrlKey":"altKey"}class he extends S{constructor(){super(84,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:c.localize(75,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:c.localize(76,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const Ee=Z;return{top:v.clampedInt(Ee.top,0,0,1e3),bottom:v.clampedInt(Ee.bottom,0,0,1e3)}}}class de extends S{constructor(){const Z={enabled:!0,cycle:!0};super(86,"parameterHints",Z,{"editor.parameterHints.enabled":{type:"boolean",default:Z.enabled,description:c.localize(77,null)},"editor.parameterHints.cycle":{type:"boolean",default:Z.cycle,description:c.localize(78,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const Ee=Z;return{enabled:t(Ee.enabled,this.defaultValue.enabled),cycle:t(Ee.cycle,this.defaultValue.cycle)}}}class le extends p{constructor(){super(142)}compute(Z,Ee,We){return Z.pixelRatio}}class be extends S{constructor(){const Z={other:"on",comments:"off",strings:"off"},Ee=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[c.localize(79,null),c.localize(80,null),c.localize(81,null)]}];super(89,"quickSuggestions",Z,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:Ee,default:Z.strings,description:c.localize(82,null)},comments:{anyOf:Ee,default:Z.comments,description:c.localize(83,null)},other:{anyOf:Ee,default:Z.other,description:c.localize(84,null)}},default:Z,markdownDescription:c.localize(85,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=Z}validate(Z){if(typeof Z=="boolean"){const Mt=Z?"on":"off";return{comments:Mt,strings:Mt,other:Mt}}if(!Z||typeof Z!="object")return this.defaultValue;const{other:Ee,comments:We,strings:ze}=Z,Ze=["on","inline","off"];let st,vt,yt;return typeof Ee=="boolean"?st=Ee?"on":"off":st=r(Ee,this.defaultValue.other,Ze),typeof We=="boolean"?vt=We?"on":"off":vt=r(We,this.defaultValue.comments,Ze),typeof ze=="boolean"?yt=ze?"on":"off":yt=r(ze,this.defaultValue.strings,Ze),{other:st,comments:vt,strings:yt}}}var ie;(function(_){_[_.Off=0]="Off",_[_.On=1]="On",_[_.Relative=2]="Relative",_[_.Interval=3]="Interval",_[_.Custom=4]="Custom"})(ie||(e.RenderLineNumbersType=ie={}));class fe extends S{constructor(){super(67,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[c.localize(86,null),c.localize(87,null),c.localize(88,null),c.localize(89,null)],default:"on",description:c.localize(90,null)})}validate(Z){let Ee=this.defaultValue.renderType,We=this.defaultValue.renderFn;return typeof Z<"u"&&(typeof Z=="function"?(Ee=4,We=Z):Z==="interval"?Ee=3:Z==="relative"?Ee=2:Z==="on"?Ee=1:Ee=0),{renderType:Ee,renderFn:We}}}function ne(_){const Z=_.get(98);return Z==="editable"?_.get(91):Z!=="on"}e.filterValidationDecorations=ne;class ce extends S{constructor(){const Z=[],Ee={type:"number",description:c.localize(91,null)};super(102,"rulers",Z,{type:"array",items:{anyOf:[Ee,{type:["object"],properties:{column:Ee,color:{type:"string",description:c.localize(92,null),format:"color-hex"}}}]},default:Z,description:c.localize(93,null)})}validate(Z){if(Array.isArray(Z)){const Ee=[];for(const We of Z)if(typeof We=="number")Ee.push({column:v.clampedInt(We,0,0,1e4),color:null});else if(We&&typeof We=="object"){const ze=We;Ee.push({column:v.clampedInt(ze.column,0,0,1e4),color:ze.color})}return Ee.sort((We,ze)=>We.column-ze.column),Ee}return this.defaultValue}}class pe extends S{constructor(){super(92,"readOnlyMessage",void 0)}validate(Z){return!Z||typeof Z!="object"?this.defaultValue:Z}}function Ce(_,Z){if(typeof _!="string")return Z;switch(_){case"hidden":return 2;case"visible":return 3;default:return 1}}class L extends S{constructor(){const Z={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(103,"scrollbar",Z,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[c.localize(94,null),c.localize(95,null),c.localize(96,null)],default:"auto",description:c.localize(97,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[c.localize(98,null),c.localize(99,null),c.localize(100,null)],default:"auto",description:c.localize(101,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:Z.verticalScrollbarSize,description:c.localize(102,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:Z.horizontalScrollbarSize,description:c.localize(103,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:Z.scrollByPage,description:c.localize(104,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:Z.ignoreHorizontalScrollbarInContentHeight,description:c.localize(105,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const Ee=Z,We=v.clampedInt(Ee.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),ze=v.clampedInt(Ee.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:v.clampedInt(Ee.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Ce(Ee.vertical,this.defaultValue.vertical),horizontal:Ce(Ee.horizontal,this.defaultValue.horizontal),useShadows:t(Ee.useShadows,this.defaultValue.useShadows),verticalHasArrows:t(Ee.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:t(Ee.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:t(Ee.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:t(Ee.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:We,horizontalSliderSize:v.clampedInt(Ee.horizontalSliderSize,We,0,1e3),verticalScrollbarSize:ze,verticalSliderSize:v.clampedInt(Ee.verticalSliderSize,ze,0,1e3),scrollByPage:t(Ee.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:t(Ee.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class K extends S{constructor(){const Z={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(125,"unicodeHighlight",Z,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Z.nonBasicASCII,description:c.localize(106,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:Z.invisibleCharacters,description:c.localize(107,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:Z.ambiguousCharacters,description:c.localize(108,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Z.includeComments,description:c.localize(109,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Z.includeStrings,description:c.localize(110,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:Z.allowedCharacters,description:c.localize(111,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:Z.allowedLocales,description:c.localize(112,null)}})}applyUpdate(Z,Ee){let We=!1;Ee.allowedCharacters&&Z&&(C.$an(Z.allowedCharacters,Ee.allowedCharacters)||(Z={...Z,allowedCharacters:Ee.allowedCharacters},We=!0)),Ee.allowedLocales&&Z&&(C.$an(Z.allowedLocales,Ee.allowedLocales)||(Z={...Z,allowedLocales:Ee.allowedLocales},We=!0));const ze=super.applyUpdate(Z,Ee);return We?new u(ze.newValue,!0):ze}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const Ee=Z;return{nonBasicASCII:x(Ee.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:t(Ee.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:t(Ee.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:x(Ee.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:x(Ee.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(Z.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(Z.allowedLocales,this.defaultValue.allowedLocales)}}c(Z,Ee){if(typeof Z!="object"||!Z)return Ee;const We={};for(const[ze,Ze]of Object.entries(Z))Ze===!0&&(We[ze]=!0);return We}}class Y extends S{constructor(){const Z={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1};super(62,"inlineSuggest",Z,{"editor.inlineSuggest.enabled":{type:"boolean",default:Z.enabled,description:c.localize(113,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:Z.showToolbar,enum:["always","onHover"],enumDescriptions:[c.localize(114,null),c.localize(115,null)],description:c.localize(116,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:Z.suppressSuggestions,description:c.localize(117,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const Ee=Z;return{enabled:t(Ee.enabled,this.defaultValue.enabled),mode:r(Ee.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:r(Ee.showToolbar,this.defaultValue.showToolbar,["always","onHover"]),suppressSuggestions:t(Ee.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:t(Ee.keepOnBlur,this.defaultValue.keepOnBlur)}}}class X extends S{constructor(){const Z={enabled:O.$8r.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:O.$8r.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",Z,{"editor.bracketPairColorization.enabled":{type:"boolean",default:Z.enabled,markdownDescription:c.localize(118,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:Z.independentColorPoolPerBracketType,description:c.localize(119,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const Ee=Z;return{enabled:t(Ee.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:t(Ee.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class H extends S{constructor(){const Z={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",Z,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[c.localize(120,null),c.localize(121,null),c.localize(122,null)],default:Z.bracketPairs,description:c.localize(123,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[c.localize(124,null),c.localize(125,null),c.localize(126,null)],default:Z.bracketPairsHorizontal,description:c.localize(127,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:Z.highlightActiveBracketPair,description:c.localize(128,null)},"editor.guides.indentation":{type:"boolean",default:Z.indentation,description:c.localize(129,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[c.localize(130,null),c.localize(131,null),c.localize(132,null)],default:Z.highlightActiveIndentation,description:c.localize(133,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const Ee=Z;return{bracketPairs:x(Ee.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:x(Ee.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:t(Ee.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:t(Ee.indentation,this.defaultValue.indentation),highlightActiveIndentation:x(Ee.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function x(_,Z,Ee){const We=Ee.indexOf(_);return We===-1?Z:Ee[We]}class se extends S{constructor(){const Z={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(118,"suggest",Z,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[c.localize(134,null),c.localize(135,null)],default:Z.insertMode,description:c.localize(136,null)},"editor.suggest.filterGraceful":{type:"boolean",default:Z.filterGraceful,description:c.localize(137,null)},"editor.suggest.localityBonus":{type:"boolean",default:Z.localityBonus,description:c.localize(138,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:Z.shareSuggestSelections,markdownDescription:c.localize(139,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[c.localize(140,null),c.localize(141,null),c.localize(142,null),c.localize(143,null)],default:Z.selectionMode,markdownDescription:c.localize(144,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:Z.snippetsPreventQuickSuggestions,description:c.localize(145,null)},"editor.suggest.showIcons":{type:"boolean",default:Z.showIcons,description:c.localize(146,null)},"editor.suggest.showStatusBar":{type:"boolean",default:Z.showStatusBar,description:c.localize(147,null)},"editor.suggest.preview":{type:"boolean",default:Z.preview,description:c.localize(148,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:Z.showInlineDetails,description:c.localize(149,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:c.localize(150,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:c.localize(151,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:c.localize(152,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:c.localize(153,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:c.localize(154,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:c.localize(155,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:c.localize(156,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:c.localize(157,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:c.localize(158,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:c.localize(159,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:c.localize(160,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:c.localize(161,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:c.localize(162,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:c.localize(163,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:c.localize(164,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:c.localize(165,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:c.localize(166,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:c.localize(167,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:c.localize(168,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:c.localize(169,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:c.localize(170,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:c.localize(171,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:c.localize(172,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:c.localize(173,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:c.localize(174,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:c.localize(175,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:c.localize(176,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:c.localize(177,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:c.localize(178,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:c.localize(179,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:c.localize(180,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:c.localize(181,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const Ee=Z;return{insertMode:r(Ee.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:t(Ee.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:t(Ee.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:t(Ee.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:t(Ee.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:r(Ee.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:t(Ee.showIcons,this.defaultValue.showIcons),showStatusBar:t(Ee.showStatusBar,this.defaultValue.showStatusBar),preview:t(Ee.preview,this.defaultValue.preview),previewMode:r(Ee.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:t(Ee.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:t(Ee.showMethods,this.defaultValue.showMethods),showFunctions:t(Ee.showFunctions,this.defaultValue.showFunctions),showConstructors:t(Ee.showConstructors,this.defaultValue.showConstructors),showDeprecated:t(Ee.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:t(Ee.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:t(Ee.showFields,this.defaultValue.showFields),showVariables:t(Ee.showVariables,this.defaultValue.showVariables),showClasses:t(Ee.showClasses,this.defaultValue.showClasses),showStructs:t(Ee.showStructs,this.defaultValue.showStructs),showInterfaces:t(Ee.showInterfaces,this.defaultValue.showInterfaces),showModules:t(Ee.showModules,this.defaultValue.showModules),showProperties:t(Ee.showProperties,this.defaultValue.showProperties),showEvents:t(Ee.showEvents,this.defaultValue.showEvents),showOperators:t(Ee.showOperators,this.defaultValue.showOperators),showUnits:t(Ee.showUnits,this.defaultValue.showUnits),showValues:t(Ee.showValues,this.defaultValue.showValues),showConstants:t(Ee.showConstants,this.defaultValue.showConstants),showEnums:t(Ee.showEnums,this.defaultValue.showEnums),showEnumMembers:t(Ee.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:t(Ee.showKeywords,this.defaultValue.showKeywords),showWords:t(Ee.showWords,this.defaultValue.showWords),showColors:t(Ee.showColors,this.defaultValue.showColors),showFiles:t(Ee.showFiles,this.defaultValue.showFiles),showReferences:t(Ee.showReferences,this.defaultValue.showReferences),showFolders:t(Ee.showFolders,this.defaultValue.showFolders),showTypeParameters:t(Ee.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:t(Ee.showSnippets,this.defaultValue.showSnippets),showUsers:t(Ee.showUsers,this.defaultValue.showUsers),showIssues:t(Ee.showIssues,this.defaultValue.showIssues)}}}class Le extends S{constructor(){super(113,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:c.localize(182,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:c.localize(183,null),default:!0,type:"boolean"}})}validate(Z){return!Z||typeof Z!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:t(Z.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:t(Z.selectSubwords,this.defaultValue.selectSubwords)}}}var je;(function(_){_[_.None=0]="None",_[_.Same=1]="Same",_[_.Indent=2]="Indent",_[_.DeepIndent=3]="DeepIndent"})(je||(e.WrappingIndent=je={}));class Ye extends S{constructor(){super(137,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[c.localize(184,null),c.localize(185,null),c.localize(186,null),c.localize(187,null)],description:c.localize(188,null),default:"same"}})}validate(Z){switch(Z){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(Z,Ee,We){return Ee.get(2)===2?0:We}}class Ke extends p{constructor(){super(145)}compute(Z,Ee,We){const ze=Ee.get(144);return{isDominatedByLongLines:Z.isDominatedByLongLines,isWordWrapMinified:ze.isWordWrapMinified,isViewportWrapping:ze.isViewportWrapping,wrappingColumn:ze.wrappingColumn}}}class tt extends S{constructor(){const Z={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",Z,{"editor.dropIntoEditor.enabled":{type:"boolean",default:Z.enabled,markdownDescription:c.localize(189,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:c.localize(190,null),enum:["afterDrop","never"],enumDescriptions:[c.localize(191,null),c.localize(192,null)],default:"afterDrop"}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const Ee=Z;return{enabled:t(Ee.enabled,this.defaultValue.enabled),showDropSelector:r(Ee.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class xe extends S{constructor(){const Z={enabled:!0,showPasteSelector:"afterPaste"};super(85,"pasteAs",Z,{"editor.pasteAs.enabled":{type:"boolean",default:Z.enabled,markdownDescription:c.localize(193,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:c.localize(194,null),enum:["afterPaste","never"],enumDescriptions:[c.localize(195,null),c.localize(196,null)],default:"afterPaste"}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const Ee=Z;return{enabled:t(Ee.enabled,this.defaultValue.enabled),showPasteSelector:r(Ee.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const et="Consolas, 'Courier New', monospace",rt="Menlo, Monaco, 'Courier New', monospace",nt="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:I.$e?rt:I.$f?nt:et,fontWeight:"normal",fontSize:I.$e?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Ue(_){return e.editorOptionsRegistry[_.id]=_,_}var lt;(function(_){_[_.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",_[_.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",_[_.accessibilitySupport=2]="accessibilitySupport",_[_.accessibilityPageSize=3]="accessibilityPageSize",_[_.ariaLabel=4]="ariaLabel",_[_.ariaRequired=5]="ariaRequired",_[_.autoClosingBrackets=6]="autoClosingBrackets",_[_.autoClosingComments=7]="autoClosingComments",_[_.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",_[_.autoClosingDelete=9]="autoClosingDelete",_[_.autoClosingOvertype=10]="autoClosingOvertype",_[_.autoClosingQuotes=11]="autoClosingQuotes",_[_.autoIndent=12]="autoIndent",_[_.automaticLayout=13]="automaticLayout",_[_.autoSurround=14]="autoSurround",_[_.bracketPairColorization=15]="bracketPairColorization",_[_.guides=16]="guides",_[_.codeLens=17]="codeLens",_[_.codeLensFontFamily=18]="codeLensFontFamily",_[_.codeLensFontSize=19]="codeLensFontSize",_[_.colorDecorators=20]="colorDecorators",_[_.colorDecoratorsLimit=21]="colorDecoratorsLimit",_[_.columnSelection=22]="columnSelection",_[_.comments=23]="comments",_[_.contextmenu=24]="contextmenu",_[_.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",_[_.cursorBlinking=26]="cursorBlinking",_[_.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",_[_.cursorStyle=28]="cursorStyle",_[_.cursorSurroundingLines=29]="cursorSurroundingLines",_[_.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",_[_.cursorWidth=31]="cursorWidth",_[_.disableLayerHinting=32]="disableLayerHinting",_[_.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",_[_.domReadOnly=34]="domReadOnly",_[_.dragAndDrop=35]="dragAndDrop",_[_.dropIntoEditor=36]="dropIntoEditor",_[_.emptySelectionClipboard=37]="emptySelectionClipboard",_[_.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",_[_.extraEditorClassName=39]="extraEditorClassName",_[_.fastScrollSensitivity=40]="fastScrollSensitivity",_[_.find=41]="find",_[_.fixedOverflowWidgets=42]="fixedOverflowWidgets",_[_.folding=43]="folding",_[_.foldingStrategy=44]="foldingStrategy",_[_.foldingHighlight=45]="foldingHighlight",_[_.foldingImportsByDefault=46]="foldingImportsByDefault",_[_.foldingMaximumRegions=47]="foldingMaximumRegions",_[_.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",_[_.fontFamily=49]="fontFamily",_[_.fontInfo=50]="fontInfo",_[_.fontLigatures=51]="fontLigatures",_[_.fontSize=52]="fontSize",_[_.fontWeight=53]="fontWeight",_[_.fontVariations=54]="fontVariations",_[_.formatOnPaste=55]="formatOnPaste",_[_.formatOnType=56]="formatOnType",_[_.glyphMargin=57]="glyphMargin",_[_.gotoLocation=58]="gotoLocation",_[_.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",_[_.hover=60]="hover",_[_.inDiffEditor=61]="inDiffEditor",_[_.inlineSuggest=62]="inlineSuggest",_[_.letterSpacing=63]="letterSpacing",_[_.lightbulb=64]="lightbulb",_[_.lineDecorationsWidth=65]="lineDecorationsWidth",_[_.lineHeight=66]="lineHeight",_[_.lineNumbers=67]="lineNumbers",_[_.lineNumbersMinChars=68]="lineNumbersMinChars",_[_.linkedEditing=69]="linkedEditing",_[_.links=70]="links",_[_.matchBrackets=71]="matchBrackets",_[_.minimap=72]="minimap",_[_.mouseStyle=73]="mouseStyle",_[_.mouseWheelScrollSensitivity=74]="mouseWheelScrollSensitivity",_[_.mouseWheelZoom=75]="mouseWheelZoom",_[_.multiCursorMergeOverlapping=76]="multiCursorMergeOverlapping",_[_.multiCursorModifier=77]="multiCursorModifier",_[_.multiCursorPaste=78]="multiCursorPaste",_[_.multiCursorLimit=79]="multiCursorLimit",_[_.multiDocumentOccurrencesHighlight=80]="multiDocumentOccurrencesHighlight",_[_.occurrencesHighlight=81]="occurrencesHighlight",_[_.overviewRulerBorder=82]="overviewRulerBorder",_[_.overviewRulerLanes=83]="overviewRulerLanes",_[_.padding=84]="padding",_[_.pasteAs=85]="pasteAs",_[_.parameterHints=86]="parameterHints",_[_.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",_[_.definitionLinkOpensInPeek=88]="definitionLinkOpensInPeek",_[_.quickSuggestions=89]="quickSuggestions",_[_.quickSuggestionsDelay=90]="quickSuggestionsDelay",_[_.readOnly=91]="readOnly",_[_.readOnlyMessage=92]="readOnlyMessage",_[_.renameOnType=93]="renameOnType",_[_.renderControlCharacters=94]="renderControlCharacters",_[_.renderFinalNewline=95]="renderFinalNewline",_[_.renderLineHighlight=96]="renderLineHighlight",_[_.renderLineHighlightOnlyWhenFocus=97]="renderLineHighlightOnlyWhenFocus",_[_.renderValidationDecorations=98]="renderValidationDecorations",_[_.renderWhitespace=99]="renderWhitespace",_[_.revealHorizontalRightPadding=100]="revealHorizontalRightPadding",_[_.roundedSelection=101]="roundedSelection",_[_.rulers=102]="rulers",_[_.scrollbar=103]="scrollbar",_[_.scrollBeyondLastColumn=104]="scrollBeyondLastColumn",_[_.scrollBeyondLastLine=105]="scrollBeyondLastLine",_[_.scrollPredominantAxis=106]="scrollPredominantAxis",_[_.selectionClipboard=107]="selectionClipboard",_[_.selectionHighlight=108]="selectionHighlight",_[_.selectOnLineNumbers=109]="selectOnLineNumbers",_[_.showFoldingControls=110]="showFoldingControls",_[_.showUnused=111]="showUnused",_[_.snippetSuggestions=112]="snippetSuggestions",_[_.smartSelect=113]="smartSelect",_[_.smoothScrolling=114]="smoothScrolling",_[_.stickyScroll=115]="stickyScroll",_[_.stickyTabStops=116]="stickyTabStops",_[_.stopRenderingLineAfter=117]="stopRenderingLineAfter",_[_.suggest=118]="suggest",_[_.suggestFontSize=119]="suggestFontSize",_[_.suggestLineHeight=120]="suggestLineHeight",_[_.suggestOnTriggerCharacters=121]="suggestOnTriggerCharacters",_[_.suggestSelection=122]="suggestSelection",_[_.tabCompletion=123]="tabCompletion",_[_.tabIndex=124]="tabIndex",_[_.unicodeHighlighting=125]="unicodeHighlighting",_[_.unusualLineTerminators=126]="unusualLineTerminators",_[_.useShadowDOM=127]="useShadowDOM",_[_.useTabStops=128]="useTabStops",_[_.wordBreak=129]="wordBreak",_[_.wordSeparators=130]="wordSeparators",_[_.wordWrap=131]="wordWrap",_[_.wordWrapBreakAfterCharacters=132]="wordWrapBreakAfterCharacters",_[_.wordWrapBreakBeforeCharacters=133]="wordWrapBreakBeforeCharacters",_[_.wordWrapColumn=134]="wordWrapColumn",_[_.wordWrapOverride1=135]="wordWrapOverride1",_[_.wordWrapOverride2=136]="wordWrapOverride2",_[_.wrappingIndent=137]="wrappingIndent",_[_.wrappingStrategy=138]="wrappingStrategy",_[_.showDeprecated=139]="showDeprecated",_[_.inlayHints=140]="inlayHints",_[_.editorClassName=141]="editorClassName",_[_.pixelRatio=142]="pixelRatio",_[_.tabFocusMode=143]="tabFocusMode",_[_.layoutInfo=144]="layoutInfo",_[_.wrappingInfo=145]="wrappingInfo",_[_.defaultColorDecorators=146]="defaultColorDecorators",_[_.colorDecoratorsActivatedOn=147]="colorDecoratorsActivatedOn",_[_.inlineCompletionsAccessibilityVerbose=148]="inlineCompletionsAccessibilityVerbose"})(lt||(e.EditorOption=lt={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Ue(new i(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:c.localize(197,null)})),acceptSuggestionOnEnter:Ue(new s(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",c.localize(198,null),""],markdownDescription:c.localize(199,null)})),accessibilitySupport:Ue(new a),accessibilityPageSize:Ue(new v(3,"accessibilityPageSize",10,1,1073741824,{description:c.localize(200,null),tags:["accessibility"]})),ariaLabel:Ue(new n(4,"ariaLabel",c.localize(201,null))),ariaRequired:Ue(new i(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:Ue(new i(8,"screenReaderAnnounceInlineSuggestion",!0,{description:c.localize(202,null),tags:["accessibility"]})),autoClosingBrackets:Ue(new s(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",c.localize(203,null),c.localize(204,null),""],description:c.localize(205,null)})),autoClosingComments:Ue(new s(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",c.localize(206,null),c.localize(207,null),""],description:c.localize(208,null)})),autoClosingDelete:Ue(new s(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",c.localize(209,null),""],description:c.localize(210,null)})),autoClosingOvertype:Ue(new s(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",c.localize(211,null),""],description:c.localize(212,null)})),autoClosingQuotes:Ue(new s(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",c.localize(213,null),c.localize(214,null),""],description:c.localize(215,null)})),autoIndent:Ue(new o(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],$,{enumDescriptions:[c.localize(216,null),c.localize(217,null),c.localize(218,null),c.localize(219,null),c.localize(220,null)],description:c.localize(221,null)})),automaticLayout:Ue(new i(13,"automaticLayout",!1)),autoSurround:Ue(new s(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[c.localize(222,null),c.localize(223,null),c.localize(224,null),""],description:c.localize(225,null)})),bracketPairColorization:Ue(new X),bracketPairGuides:Ue(new H),stickyTabStops:Ue(new i(116,"stickyTabStops",!1,{description:c.localize(226,null)})),codeLens:Ue(new i(17,"codeLens",!0,{description:c.localize(227,null)})),codeLensFontFamily:Ue(new n(18,"codeLensFontFamily","",{description:c.localize(228,null)})),codeLensFontSize:Ue(new v(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:c.localize(229,null)})),colorDecorators:Ue(new i(20,"colorDecorators",!0,{description:c.localize(230,null)})),colorDecoratorActivatedOn:Ue(new s(147,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[c.localize(231,null),c.localize(232,null),c.localize(233,null)],description:c.localize(234,null)})),colorDecoratorsLimit:Ue(new v(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:c.localize(235,null)})),columnSelection:Ue(new i(22,"columnSelection",!1,{description:c.localize(236,null)})),comments:Ue(new k),contextmenu:Ue(new i(24,"contextmenu",!0)),copyWithSyntaxHighlighting:Ue(new i(25,"copyWithSyntaxHighlighting",!0,{description:c.localize(237,null)})),cursorBlinking:Ue(new o(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],h,{description:c.localize(238,null)})),cursorSmoothCaretAnimation:Ue(new s(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[c.localize(239,null),c.localize(240,null),c.localize(241,null)],description:c.localize(242,null)})),cursorStyle:Ue(new o(28,"cursorStyle",w.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],M,{description:c.localize(243,null)})),cursorSurroundingLines:Ue(new v(29,"cursorSurroundingLines",0,0,1073741824,{description:c.localize(244,null)})),cursorSurroundingLinesStyle:Ue(new s(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[c.localize(245,null),c.localize(246,null)],markdownDescription:c.localize(247,null)})),cursorWidth:Ue(new v(31,"cursorWidth",0,0,1073741824,{markdownDescription:c.localize(248,null)})),disableLayerHinting:Ue(new i(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:Ue(new i(33,"disableMonospaceOptimizations",!1)),domReadOnly:Ue(new i(34,"domReadOnly",!1)),dragAndDrop:Ue(new i(35,"dragAndDrop",!0,{description:c.localize(249,null)})),emptySelectionClipboard:Ue(new B),dropIntoEditor:Ue(new tt),stickyScroll:Ue(new oe),experimentalWhitespaceRendering:Ue(new s(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[c.localize(250,null),c.localize(251,null),c.localize(252,null)],description:c.localize(253,null)})),extraEditorClassName:Ue(new n(39,"extraEditorClassName","")),fastScrollSensitivity:Ue(new m(40,"fastScrollSensitivity",5,_=>_<=0?5:_,{markdownDescription:c.localize(254,null)})),find:Ue(new z),fixedOverflowWidgets:Ue(new i(42,"fixedOverflowWidgets",!1)),folding:Ue(new i(43,"folding",!0,{description:c.localize(255,null)})),foldingStrategy:Ue(new s(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[c.localize(256,null),c.localize(257,null)],description:c.localize(258,null)})),foldingHighlight:Ue(new i(45,"foldingHighlight",!0,{description:c.localize(259,null)})),foldingImportsByDefault:Ue(new i(46,"foldingImportsByDefault",!1,{description:c.localize(260,null)})),foldingMaximumRegions:Ue(new v(47,"foldingMaximumRegions",5e3,10,65e3,{description:c.localize(261,null)})),unfoldOnClickAfterEndOfLine:Ue(new i(48,"unfoldOnClickAfterEndOfLine",!1,{description:c.localize(262,null)})),fontFamily:Ue(new n(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:c.localize(263,null)})),fontInfo:Ue(new j),fontLigatures2:Ue(new T),fontSize:Ue(new q),fontWeight:Ue(new W),fontVariations:Ue(new F),formatOnPaste:Ue(new i(55,"formatOnPaste",!1,{description:c.localize(264,null)})),formatOnType:Ue(new i(56,"formatOnType",!1,{description:c.localize(265,null)})),glyphMargin:Ue(new i(57,"glyphMargin",!0,{description:c.localize(266,null)})),gotoLocation:Ue(new we),hideCursorInOverviewRuler:Ue(new i(59,"hideCursorInOverviewRuler",!1,{description:c.localize(267,null)})),hover:Ue(new ke),inDiffEditor:Ue(new i(61,"inDiffEditor",!1)),letterSpacing:Ue(new m(63,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,_=>m.clamp(_,-5,20),{description:c.localize(268,null)})),lightbulb:Ue(new re),lineDecorationsWidth:Ue(new De),lineHeight:Ue(new Q),lineNumbers:Ue(new fe),lineNumbersMinChars:Ue(new v(68,"lineNumbersMinChars",5,1,300)),linkedEditing:Ue(new i(69,"linkedEditing",!1,{description:c.localize(269,null)})),links:Ue(new i(70,"links",!0,{description:c.localize(270,null)})),matchBrackets:Ue(new s(71,"matchBrackets","always",["always","near","never"],{description:c.localize(271,null)})),minimap:Ue(new ue),mouseStyle:Ue(new s(73,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Ue(new m(74,"mouseWheelScrollSensitivity",1,_=>_===0?1:_,{markdownDescription:c.localize(272,null)})),mouseWheelZoom:Ue(new i(75,"mouseWheelZoom",!1,{markdownDescription:c.localize(273,null)})),multiCursorMergeOverlapping:Ue(new i(76,"multiCursorMergeOverlapping",!0,{description:c.localize(274,null)})),multiCursorModifier:Ue(new o(77,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],J,{markdownEnumDescriptions:[c.localize(275,null),c.localize(276,null)],markdownDescription:c.localize(277,null)})),multiCursorPaste:Ue(new s(78,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[c.localize(278,null),c.localize(279,null)],markdownDescription:c.localize(280,null)})),multiCursorLimit:Ue(new v(79,"multiCursorLimit",1e4,1,1e5,{markdownDescription:c.localize(281,null)})),occurrencesHighlight:Ue(new i(81,"occurrencesHighlight",!0,{description:c.localize(282,null)})),multiDocumentOccurrencesHighlight:Ue(new i(80,"multiDocumentOccurrencesHighlight",!1,{description:c.localize(283,null)})),overviewRulerBorder:Ue(new i(82,"overviewRulerBorder",!0,{description:c.localize(284,null)})),overviewRulerLanes:Ue(new v(83,"overviewRulerLanes",3,0,3)),padding:Ue(new he),pasteAs:Ue(new xe),parameterHints:Ue(new de),peekWidgetDefaultFocus:Ue(new s(87,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[c.localize(285,null),c.localize(286,null)],description:c.localize(287,null)})),definitionLinkOpensInPeek:Ue(new i(88,"definitionLinkOpensInPeek",!1,{description:c.localize(288,null)})),quickSuggestions:Ue(new be),quickSuggestionsDelay:Ue(new v(90,"quickSuggestionsDelay",10,0,1073741824,{description:c.localize(289,null)})),readOnly:Ue(new i(91,"readOnly",!1)),readOnlyMessage:Ue(new pe),renameOnType:Ue(new i(93,"renameOnType",!1,{description:c.localize(290,null),markdownDeprecationMessage:c.localize(291,null)})),renderControlCharacters:Ue(new i(94,"renderControlCharacters",!0,{description:c.localize(292,null),restricted:!0})),renderFinalNewline:Ue(new s(95,"renderFinalNewline",I.$f?"dimmed":"on",["off","on","dimmed"],{description:c.localize(293,null)})),renderLineHighlight:Ue(new s(96,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",c.localize(294,null)],description:c.localize(295,null)})),renderLineHighlightOnlyWhenFocus:Ue(new i(97,"renderLineHighlightOnlyWhenFocus",!1,{description:c.localize(296,null)})),renderValidationDecorations:Ue(new s(98,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Ue(new s(99,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",c.localize(297,null),c.localize(298,null),c.localize(299,null),""],description:c.localize(300,null)})),revealHorizontalRightPadding:Ue(new v(100,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Ue(new i(101,"roundedSelection",!0,{description:c.localize(301,null)})),rulers:Ue(new ce),scrollbar:Ue(new L),scrollBeyondLastColumn:Ue(new v(104,"scrollBeyondLastColumn",4,0,1073741824,{description:c.localize(302,null)})),scrollBeyondLastLine:Ue(new i(105,"scrollBeyondLastLine",!0,{description:c.localize(303,null)})),scrollPredominantAxis:Ue(new i(106,"scrollPredominantAxis",!0,{description:c.localize(304,null)})),selectionClipboard:Ue(new i(107,"selectionClipboard",!0,{description:c.localize(305,null),included:I.$f})),selectionHighlight:Ue(new i(108,"selectionHighlight",!0,{description:c.localize(306,null)})),selectOnLineNumbers:Ue(new i(109,"selectOnLineNumbers",!0)),showFoldingControls:Ue(new s(110,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[c.localize(307,null),c.localize(308,null),c.localize(309,null)],description:c.localize(310,null)})),showUnused:Ue(new i(111,"showUnused",!0,{description:c.localize(311,null)})),showDeprecated:Ue(new i(139,"showDeprecated",!0,{description:c.localize(312,null)})),inlayHints:Ue(new ye),snippetSuggestions:Ue(new s(112,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[c.localize(313,null),c.localize(314,null),c.localize(315,null),c.localize(316,null)],description:c.localize(317,null)})),smartSelect:Ue(new Le),smoothScrolling:Ue(new i(114,"smoothScrolling",!1,{description:c.localize(318,null)})),stopRenderingLineAfter:Ue(new v(117,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Ue(new se),inlineSuggest:Ue(new Y),inlineCompletionsAccessibilityVerbose:Ue(new i(148,"inlineCompletionsAccessibilityVerbose",!1,{description:c.localize(319,null)})),suggestFontSize:Ue(new v(119,"suggestFontSize",0,0,1e3,{markdownDescription:c.localize(320,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Ue(new v(120,"suggestLineHeight",0,0,1e3,{markdownDescription:c.localize(321,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Ue(new i(121,"suggestOnTriggerCharacters",!0,{description:c.localize(322,null)})),suggestSelection:Ue(new s(122,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[c.localize(323,null),c.localize(324,null),c.localize(325,null)],description:c.localize(326,null)})),tabCompletion:Ue(new s(123,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[c.localize(327,null),c.localize(328,null),c.localize(329,null)],description:c.localize(330,null)})),tabIndex:Ue(new v(124,"tabIndex",0,-1,1073741824)),unicodeHighlight:Ue(new K),unusualLineTerminators:Ue(new s(126,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[c.localize(331,null),c.localize(332,null),c.localize(333,null)],description:c.localize(334,null)})),useShadowDOM:Ue(new i(127,"useShadowDOM",!0)),useTabStops:Ue(new i(128,"useTabStops",!0,{description:c.localize(335,null)})),wordBreak:Ue(new s(129,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[c.localize(336,null),c.localize(337,null)],description:c.localize(338,null)})),wordSeparators:Ue(new n(130,"wordSeparators",A.$9r,{description:c.localize(339,null)})),wordWrap:Ue(new s(131,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[c.localize(340,null),c.localize(341,null),c.localize(342,null),c.localize(343,null)],description:c.localize(344,null)})),wordWrapBreakAfterCharacters:Ue(new n(132,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Ue(new n(133,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Ue(new v(134,"wordWrapColumn",80,1,1073741824,{markdownDescription:c.localize(345,null)})),wordWrapOverride1:Ue(new s(135,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Ue(new s(136,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Ue(new V),defaultColorDecorators:Ue(new i(146,"defaultColorDecorators",!1,{markdownDescription:c.localize(346,null)})),pixelRatio:Ue(new le),tabFocusMode:Ue(new i(143,"tabFocusMode",!1,{markdownDescription:c.localize(347,null)})),layoutInfo:Ue(new ve),wrappingInfo:Ue(new Ke),wrappingIndent:Ue(new Ye),wrappingStrategy:Ue(new ge)}}),define(Ae[137],Re([9,10]),function(ee,e){return ee.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Ae[138],Re([9,10]),function(ee,e){return ee.create("vs/platform/contextkey/common/contextkey",e)}),define(Ae[139],Re([9,10]),function(ee,e){return ee.create("vs/platform/contextkey/common/scanner",e)}),define(Ae[140],Re([9,10]),function(ee,e){return ee.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Ae[141],Re([9,10]),function(ee,e){return ee.create("vs/platform/extensions/common/extensionValidator",e)}),define(Ae[142],Re([9,10]),function(ee,e){return ee.create("vs/platform/files/common/files",e)}),define(Ae[143],Re([9,10]),function(ee,e){return ee.create("vs/platform/markers/common/markers",e)}),define(Ae[144],Re([9,10]),function(ee,e){return ee.create("vs/platform/theme/common/iconRegistry",e)}),define(Ae[145],Re([9,10]),function(ee,e){return ee.create("vs/platform/workspace/common/workspace",e)}),define(Ae[146],Re([9,10]),function(ee,e){return ee.create("vs/workbench/api/common/extHostChat",e)}),define(Ae[147],Re([9,10]),function(ee,e){return ee.create("vs/workbench/api/common/extHostChatAgents2",e)}),define(Ae[148],Re([9,10]),function(ee,e){return ee.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Ae[149],Re([9,10]),function(ee,e){return ee.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Ae[150],Re([9,10]),function(ee,e){return ee.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(Ae[151],Re([9,10]),function(ee,e){return ee.create("vs/workbench/api/common/extHostLogService",e)}),define(Ae[152],Re([9,10]),function(ee,e){return ee.create("vs/workbench/api/common/extHostNotebook",e)}),define(Ae[153],Re([9,10]),function(ee,e){return ee.create("vs/workbench/api/common/extHostProgress",e)}),define(Ae[154],Re([9,10]),function(ee,e){return ee.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Ae[155],Re([9,10]),function(ee,e){return ee.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Ae[156],Re([9,10]),function(ee,e){return ee.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Ae[157],Re([9,10]),function(ee,e){return ee.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Ae[158],Re([9,10]),function(ee,e){return ee.create("vs/workbench/api/common/extHostTunnelService",e)}),define(Ae[159],Re([9,10]),function(ee,e){return ee.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Ae[160],Re([9,10]),function(ee,e){return ee.create("vs/workbench/common/editor",e)}),define(Ae[161],Re([9,10]),function(ee,e){return ee.create("vs/workbench/common/views",e)}),define(Ae[162],Re([9,10]),function(ee,e){return ee.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Ae[163],Re([9,10]),function(ee,e){return ee.create("vs/workbench/contrib/debug/common/debug",e)}),define(Ae[164],Re([9,10]),function(ee,e){return ee.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Ae[165],Re([9,10]),function(ee,e){return ee.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Ae[166],Re([9,10]),function(ee,e){return ee.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Ae[167],Re([9,10]),function(ee,e){return ee.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Ae[168],Re([9,10]),function(ee,e){return ee.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Ae[169],Re([1,0,11,139]),function(ee,e,f,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Li=e.TokenType=void 0;var I;(function(d){d[d.LParen=0]="LParen",d[d.RParen=1]="RParen",d[d.Neg=2]="Neg",d[d.Eq=3]="Eq",d[d.NotEq=4]="NotEq",d[d.Lt=5]="Lt",d[d.LtEq=6]="LtEq",d[d.Gt=7]="Gt",d[d.GtEq=8]="GtEq",d[d.RegexOp=9]="RegexOp",d[d.RegexStr=10]="RegexStr",d[d.True=11]="True",d[d.False=12]="False",d[d.In=13]="In",d[d.Not=14]="Not",d[d.And=15]="And",d[d.Or=16]="Or",d[d.Str=17]="Str",d[d.QuotedStr=18]="QuotedStr",d[d.Error=19]="Error",d[d.EOF=20]="EOF"})(I||(e.TokenType=I={}));function O(...d){switch(d.length){case 1:return(0,C.localize)(0,null,d[0]);case 2:return(0,C.localize)(1,null,d[0],d[1]);case 3:return(0,C.localize)(2,null,d[0],d[1],d[2]);default:return}}const A=(0,C.localize)(3,null),c=(0,C.localize)(4,null);class E{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(R){switch(R.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return R.isTripleEq?"===":"==";case 4:return R.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return R.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return R.lexeme;case 18:return R.lexeme;case 19:return R.lexeme;case 20:return"EOF";default:throw(0,f.$8)(`unhandled token type: ${JSON.stringify(R)}; have you forgotten to add a case?`)}}get errors(){return this.g}reset(R){return this.c=R,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const S=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:S})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const S=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:S})}else this.h(126)?this.k(9):this.l(O("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(O("&&"));break;case 124:this.h(124)?this.k(16):this.l(O("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(R){return this.r()||this.c.charCodeAt(this.e)!==R?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(R){this.f.push({type:R,offset:this.d})}l(R){const S=this.d,u=this.c.substring(this.d,this.e),b={type:19,offset:this.d,lexeme:u};this.g.push({offset:S,lexeme:u,additionalInfo:R}),this.f.push(b)}n(){this.m.lastIndex=this.d;const R=this.m.exec(this.c);if(R){this.e=this.d+R[0].length;const S=this.c.substring(this.d,this.e),u=E.b.get(S);u?this.k(u):this.f.push({type:17,lexeme:S,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(A);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let R=this.e,S=!1,u=!1;for(;;){if(R>=this.c.length){this.e=R,this.l(c);return}const p=this.c.charCodeAt(R);if(S)S=!1;else if(p===47&&!u){R++;break}else p===91?u=!0:p===92?S=!0:p===93&&(u=!1);R++}for(;R<this.c.length&&E.a.has(this.c.charCodeAt(R));)R++;this.e=R;const b=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:b,offset:this.d})}r(){return this.e>=this.c.length}}e.$Li=E,E.a=new Set(["i","g","s","m","y","u"].map(d=>d.charCodeAt(0))),E.b=new Map([["not",14],["in",13],["false",12],["true",11]])}),define(Ae[170],Re([1,0,24,29,141,280]),function(ee,e,f,C,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wo=e.$Vo=e.$Uo=e.$To=e.$So=e.$Ro=e.$Qo=void 0;const A=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,c=/^-(\d{4})(\d{2})(\d{2})$/;function E(i){return i=i.trim(),i==="*"||A.test(i)}e.$Qo=E;function d(i){if(!E(i))return null;if(i=i.trim(),i==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const l=i.match(A);return l?{hasCaret:l[1]==="^",hasGreaterEquals:l[1]===">=",majorBase:l[2]==="x"?0:parseInt(l[2],10),majorMustEqual:l[2]!=="x",minorBase:l[4]==="x"?0:parseInt(l[4],10),minorMustEqual:l[4]!=="x",patchBase:l[6]==="x"?0:parseInt(l[6],10),patchMustEqual:l[6]!=="x",preRelease:l[8]||null}:null}e.$Ro=d;function R(i){if(!i)return null;const l=i.majorBase,v=i.majorMustEqual,D=i.minorBase;let m=i.minorMustEqual;const n=i.patchBase;let r=i.patchMustEqual;i.hasCaret&&(l===0||(m=!1),r=!1);let s=0;if(i.preRelease){const o=c.exec(i.preRelease);if(o){const[,$,a,k]=o;s=Date.UTC(Number($),Number(a)-1,Number(k))}}return{majorBase:l,majorMustEqual:v,minorBase:D,minorMustEqual:m,patchBase:n,patchMustEqual:r,isMinimum:i.hasGreaterEquals,notBefore:s}}e.$So=R;function S(i,l,v){let D;typeof i=="string"?D=R(d(i)):D=i;let m;l instanceof Date?m=l.getTime():typeof l=="string"&&(m=new Date(l).getTime());let n;if(typeof v=="string"?n=R(d(v)):n=v,!D||!n)return!1;const r=D.majorBase,s=D.minorBase,o=D.patchBase;let $=n.majorBase,a=n.minorBase,k=n.patchBase;const P=n.notBefore;let h=n.majorMustEqual,w=n.minorMustEqual,y=n.patchMustEqual;return n.isMinimum?r>$?!0:r<$?!1:s>a?!0:s<a||m&&m<P?!1:o>=k:(r===1&&$===0&&(!h||!w||!y)&&($=1,a=0,k=0,h=!0,w=!1,y=!1),r<$?!1:r>$?!h:s<a?!1:s>a?!w:o<k?!1:o>k?!y:!(m&&m<P))}e.$To=S;function u(i,l,v,D,m){const n=[];if(typeof D.publisher<"u"&&typeof D.publisher!="string")return n.push([C.default.Error,I.localize(0,null)]),n;if(typeof D.name!="string")return n.push([C.default.Error,I.localize(1,null,"name")]),n;if(typeof D.version!="string")return n.push([C.default.Error,I.localize(2,null,"version")]),n;if(!D.engines)return n.push([C.default.Error,I.localize(3,null,"engines")]),n;if(typeof D.engines.vscode!="string")return n.push([C.default.Error,I.localize(4,null,"engines.vscode")]),n;if(typeof D.extensionDependencies<"u"&&!t(D.extensionDependencies))return n.push([C.default.Error,I.localize(5,null,"extensionDependencies")]),n;if(typeof D.activationEvents<"u"){if(!t(D.activationEvents))return n.push([C.default.Error,I.localize(6,null,"activationEvents")]),n;if(typeof D.main>"u"&&typeof D.browser>"u")return n.push([C.default.Error,I.localize(7,null,"activationEvents","main","browser")]),n}if(typeof D.extensionKind<"u"&&typeof D.main>"u"&&n.push([C.default.Warning,I.localize(8,null,"extensionKind")]),typeof D.main<"u"){if(typeof D.main!="string")return n.push([C.default.Error,I.localize(9,null,"main")]),n;{const o=(0,f.$wg)(v,D.main);(0,f.$qg)(o,v)||n.push([C.default.Warning,I.localize(10,null,o.path,v.path)])}}if(typeof D.browser<"u"){if(typeof D.browser!="string")return n.push([C.default.Error,I.localize(11,null,"browser")]),n;{const o=(0,f.$wg)(v,D.browser);(0,f.$qg)(o,v)||n.push([C.default.Warning,I.localize(12,null,o.path,v.path)])}}if(!O.valid(D.version))return n.push([C.default.Error,I.localize(13,null)]),n;const r=[];if(!b(i,l,D,m,r))for(const o of r)n.push([C.default.Error,o]);return n}e.$Uo=u;function b(i,l,v,D,m){return D||typeof v.main>"u"&&typeof v.browser>"u"?!0:g(i,l,v.engines.vscode,m)}e.$Vo=b;function p(i,l,v){return i==="*"||g(l,v,i)}e.$Wo=p;function g(i,l,v,D=[]){const m=R(d(v));if(!m)return D.push(I.localize(14,null,v)),!1;if(m.majorBase===0){if(!m.majorMustEqual||!m.minorMustEqual)return D.push(I.localize(15,null,v)),!1}else if(!m.majorMustEqual)return D.push(I.localize(16,null,v)),!1;return S(i,l,m)?!0:(D.push(I.localize(17,null,i,v)),!1)}function t(i){if(!Array.isArray(i))return!1;for(let l=0,v=i.length;l<v;l++)if(typeof i[l]!="string")return!1;return!0}}),define(Ae[69],Re([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nh=void 0;class f{constructor(I,O=[],A=!1){this.ctor=I,this.staticArguments=O,this.supportsDelayedInstantiation=A}}e.$Nh=f}),define(Ae[70],Re([1,0,69]),function(ee,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cr=e.$Br=e.InstantiationType=void 0;const C=[];var I;(function(c){c[c.Eager=0]="Eager",c[c.Delayed=1]="Delayed"})(I||(e.InstantiationType=I={}));function O(c,E,d){E instanceof f.$Nh||(E=new f.$Nh(E,[],!!d)),C.push([c,E])}e.$Br=O;function A(){return C}e.$Cr=A}),define(Ae[171],Re([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hq=e.$gq=void 0;class f{constructor(O,A){this.key=O,this.data=A,this.incoming=new Map,this.outgoing=new Map}}e.$gq=f;class C{constructor(O){this.b=O,this.a=new Map}roots(){const O=[];for(const A of this.a.values())A.outgoing.size===0&&O.push(A);return O}insertEdge(O,A){const c=this.lookupOrInsertNode(O),E=this.lookupOrInsertNode(A);c.outgoing.set(E.key,E),E.incoming.set(c.key,c)}removeNode(O){const A=this.b(O);this.a.delete(A);for(const c of this.a.values())c.outgoing.delete(A),c.incoming.delete(A)}lookupOrInsertNode(O){const A=this.b(O);let c=this.a.get(A);return c||(c=new f(A,O),this.a.set(A,c)),c}lookup(O){return this.a.get(this.b(O))}isEmpty(){return this.a.size===0}toString(){const O=[];for(const[A,c]of this.a)O.push(`${A}
	(-> incoming)[${[...c.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...c.outgoing.keys()].join(",")}]
`);return O.join(`
`)}findCycleSlow(){for(const[O,A]of this.a){const c=new Set([O]),E=this.c(A,c);if(E)return E}}c(O,A){for(const[c,E]of O.outgoing){if(A.has(c))return[...A,c].join(" -> ");A.add(c);const d=this.c(E,A);if(d)return d;A.delete(c)}}}e.$hq=C}),define(Ae[4],Re([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rh=e.$Qh=e.$Ph=e._util=void 0;var f;(function(A){A.serviceIds=new Map,A.DI_TARGET="$di$target",A.DI_DEPENDENCIES="$di$dependencies";function c(E){return E[A.DI_DEPENDENCIES]||[]}A.getServiceDependencies=c})(f||(e._util=f={})),e.$Ph=I("instantiationService");function C(A,c,E){c[f.DI_TARGET]===c?c[f.DI_DEPENDENCIES].push({id:A,index:E}):(c[f.DI_DEPENDENCIES]=[{id:A,index:E}],c[f.DI_TARGET]=c)}function I(A){if(f.serviceIds.has(A))return f.serviceIds.get(A);const c=function(E,d,R){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");C(c,E,R)};return c.toString=()=>A,f.serviceIds.set(A,c),c}e.$Qh=I;function O(A){return A}e.$Rh=O}),define(Ae[45],Re([1,0,15,2,4]),function(ee,e,f,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ui=e.$ti=e.$si=e.$ri=e.$qi=e.$pi=e.$oi=e.$ni=e.ConfigurationTarget=e.$mi=e.$li=e.$ki=void 0,e.$ki=(0,I.$Qh)("configurationService");function O(i){return i&&typeof i=="object"&&(!i.overrideIdentifier||typeof i.overrideIdentifier=="string")&&(!i.resource||i.resource instanceof C.URI)}e.$li=O;function A(i){return i&&typeof i=="object"&&(!i.overrideIdentifiers||Array.isArray(i.overrideIdentifiers))&&!i.overrideIdentifier&&(!i.resource||i.resource instanceof C.URI)}e.$mi=A;var c;(function(i){i[i.APPLICATION=1]="APPLICATION",i[i.USER=2]="USER",i[i.USER_LOCAL=3]="USER_LOCAL",i[i.USER_REMOTE=4]="USER_REMOTE",i[i.WORKSPACE=5]="WORKSPACE",i[i.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",i[i.DEFAULT=7]="DEFAULT",i[i.MEMORY=8]="MEMORY"})(c||(e.ConfigurationTarget=c={}));function E(i){switch(i){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$ni=E;function d(i){return i.applicationValue!==void 0||i.userValue!==void 0||i.userLocalValue!==void 0||i.userRemoteValue!==void 0||i.workspaceValue!==void 0||i.workspaceFolderValue!==void 0}e.$oi=d;function R(i,l){const v=Object.create(null);for(const D in i)S(v,D,i[D],l);return v}e.$pi=R;function S(i,l,v,D){const m=l.split("."),n=m.pop();let r=i;for(let s=0;s<m.length;s++){const o=m[s];let $=r[o];switch(typeof $){case"undefined":$=r[o]=Object.create(null);break;case"object":break;default:D(`Ignoring ${l} as ${m.slice(0,s+1).join(".")} is ${JSON.stringify($)}`);return}r=$}if(typeof r=="object"&&r!==null)try{r[n]=v}catch{D(`Ignoring ${l} as ${m.join(".")} is ${JSON.stringify(r)}`)}else D(`Ignoring ${l} as ${m.join(".")} is ${JSON.stringify(r)}`)}e.$qi=S;function u(i,l){const v=l.split(".");b(i,v)}e.$ri=u;function b(i,l){const v=l.shift();if(l.length===0){delete i[v];return}if(Object.keys(i).indexOf(v)!==-1){const D=i[v];typeof D=="object"&&!Array.isArray(D)&&(b(D,l),Object.keys(D).length===0&&delete i[v])}}function p(i,l,v){function D(r,s){let o=r;for(const $ of s){if(typeof o!="object"||o===null)return;o=o[$]}return o}const m=l.split("."),n=D(i,m);return typeof n>"u"?v:n}e.$si=p;function g(i,l,v){Object.keys(l).forEach(D=>{D!=="__proto__"&&(D in i?f.$Bf(i[D])&&f.$Bf(l[D])?g(i[D],l[D],v):v&&(i[D]=l[D]):i[D]=l[D])})}e.$ti=g;function t(i){return i.replace(/[\[\]]/g,"")}e.$ui=t}),define(Ae[32],Re([1,0,23,16,169,4,138,11]),function(ee,e,f,C,I,O,A,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0i=e.$9i=e.$8i=e.$7i=e.$6i=e.$5i=e.$4i=e.$3i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Vi=e.$Ui=e.$Ti=e.$Si=e.$Ri=e.$Qi=e.$Pi=e.$Oi=e.$Ni=e.ContextKeyExprType=e.$Mi=void 0;const E=new Map;E.set("false",!1),E.set("true",!0),E.set("isMac",f.$e),E.set("isLinux",f.$f),E.set("isWindows",f.$d),E.set("isWeb",f.$j),E.set("isMacNative",f.$e&&!f.$j),E.set("isEdge",f.$B),E.set("isFirefox",f.$z),E.set("isChrome",f.$y),E.set("isSafari",f.$A);function d(De,Q){if(E.get(De)!==void 0)throw(0,c.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");E.set(De,Q)}e.$Mi=d;const R=Object.prototype.hasOwnProperty;var S;(function(De){De[De.False=0]="False",De[De.True=1]="True",De[De.Defined=2]="Defined",De[De.Not=3]="Not",De[De.Equals=4]="Equals",De[De.NotEquals=5]="NotEquals",De[De.And=6]="And",De[De.Regex=7]="Regex",De[De.NotRegex=8]="NotRegex",De[De.Or=9]="Or",De[De.In=10]="In",De[De.NotIn=11]="NotIn",De[De.Greater=12]="Greater",De[De.GreaterEquals=13]="GreaterEquals",De[De.Smaller=14]="Smaller",De[De.SmallerEquals=15]="SmallerEquals"})(S||(e.ContextKeyExprType=S={}));const u={regexParsingWithErrorRecovery:!0},b=(0,A.localize)(0,null),p=(0,A.localize)(1,null),g=(0,A.localize)(2,null),t=(0,A.localize)(3,null),i=(0,A.localize)(4,null),l=(0,A.localize)(5,null),v=(0,A.localize)(6,null),D=(0,A.localize)(7,null);class m{get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(Q=u){this.k=Q,this.d=new I.$Li,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(Q){if(Q===""){this.h.push({message:b,offset:0,lexeme:"",additionalInfo:p});return}this.f=this.d.reset(Q).scan(),this.g=0,this.h=[];try{const ue=this.l();if(!this.E()){const J=this.D(),he=J.type===17?l:void 0;throw this.h.push({message:i,offset:J.offset,lexeme:I.$Li.getLexeme(J),additionalInfo:he}),m.c}return ue}catch(ue){if(ue!==m.c)throw ue;return}}l(){return this.m()}m(){const Q=[this.o()];for(;this.y(16);){const ue=this.o();Q.push(ue)}return Q.length===1?Q[0]:n.or(...Q)}o(){const Q=[this.s()];for(;this.y(15);){const ue=this.s();Q.push(ue)}return Q.length===1?Q[0]:n.and(...Q)}s(){if(this.y(2)){const Q=this.D();switch(Q.type){case 11:return this.z(),$.INSTANCE;case 12:return this.z(),a.INSTANCE;case 0:{this.z();const ue=this.l();return this.A(1,t),ue?.negate()}case 17:return this.z(),M.create(Q.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",Q)}}return this.t()}t(){const Q=this.D();switch(Q.type){case 11:return this.z(),n.true();case 12:return this.z(),n.false();case 0:{this.z();const ue=this.l();return this.A(1,t),ue}case 17:{const ue=Q.lexeme;if(this.z(),this.y(9)){const he=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),he.type!==10)throw this.B("REGEX",he);const de=he.lexeme,le=de.lastIndexOf("/"),be=le===de.length-1?void 0:this.w(de.substring(le+1));let ie;try{ie=new RegExp(de.substring(1,le),be)}catch{throw this.B("REGEX",he)}return j.create(ue,ie)}switch(he.type){case 10:case 19:{const de=[he.lexeme];this.z();let le=this.D(),be=0;for(let pe=0;pe<he.lexeme.length;pe++)he.lexeme.charCodeAt(pe)===40?be++:he.lexeme.charCodeAt(pe)===41&&be--;for(;!this.E()&&le.type!==15&&le.type!==16;){switch(le.type){case 0:be++;break;case 1:be--;break;case 10:case 18:for(let pe=0;pe<le.lexeme.length;pe++)le.lexeme.charCodeAt(pe)===40?be++:he.lexeme.charCodeAt(pe)===41&&be--}if(be<0)break;de.push(I.$Li.getLexeme(le)),this.z(),le=this.D()}const ie=de.join(""),fe=ie.lastIndexOf("/"),ne=fe===ie.length-1?void 0:this.w(ie.substring(fe+1));let ce;try{ce=new RegExp(ie.substring(1,fe),ne)}catch{throw this.B("REGEX",he)}return n.regex(ue,ce)}case 18:{const de=he.lexeme;this.z();let le=null;if(!(0,C.$Ce)(de)){const be=de.indexOf("/"),ie=de.lastIndexOf("/");if(be!==ie&&be>=0){const fe=de.slice(be+1,ie),ne=de[ie+1]==="i"?"i":"";try{le=new RegExp(fe,ne)}catch{throw this.B("REGEX",he)}}}if(le===null)throw this.B("REGEX",he);return j.create(ue,le)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,g);const he=this.u();return n.notIn(ue,he)}switch(this.D().type){case 3:{this.z();const he=this.u();if(this.x().type===18)return n.equals(ue,he);switch(he){case"true":return n.has(ue);case"false":return n.not(ue);default:return n.equals(ue,he)}}case 4:{this.z();const he=this.u();if(this.x().type===18)return n.notEquals(ue,he);switch(he){case"true":return n.not(ue);case"false":return n.has(ue);default:return n.notEquals(ue,he)}}case 5:return this.z(),T.create(ue,this.u());case 6:return this.z(),F.create(ue,this.u());case 7:return this.z(),B.create(ue,this.u());case 8:return this.z(),z.create(ue,this.u());case 13:return this.z(),n.in(ue,this.u());default:return n.has(ue)}}case 20:throw this.h.push({message:v,offset:Q.offset,lexeme:"",additionalInfo:D}),m.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const Q=this.D();switch(Q.type){case 17:case 18:return this.z(),Q.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(Q){return Q.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(Q){return this.C(Q)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(Q,ue){if(this.C(Q))return this.z();throw this.B(ue,this.D())}B(Q,ue,J){const he=(0,A.localize)(8,null,Q,I.$Li.getLexeme(ue)),de=ue.offset,le=I.$Li.getLexeme(ue);return this.h.push({message:he,offset:de,lexeme:le,additionalInfo:J}),m.c}C(Q){return this.D().type===Q}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$Ni=m,m.c=new Error;class n{static false(){return $.INSTANCE}static true(){return a.INSTANCE}static has(Q){return k.create(Q)}static equals(Q,ue){return P.create(Q,ue)}static notEquals(Q,ue){return y.create(Q,ue)}static regex(Q,ue){return j.create(Q,ue)}static in(Q,ue){return h.create(Q,ue)}static notIn(Q,ue){return w.create(Q,ue)}static not(Q){return M.create(Q)}static and(...Q){return we.create(Q,null,!0)}static or(...Q){return ke.create(Q,null,!0)}static greater(Q,ue){return B.create(Q,ue)}static greaterEquals(Q,ue){return z.create(Q,ue)}static smaller(Q,ue){return T.create(Q,ue)}static smallerEquals(Q,ue){return F.create(Q,ue)}static deserialize(Q){return Q==null?void 0:this.c.parse(Q)}}e.$Oi=n,n.c=new m({regexParsingWithErrorRecovery:!1});function r(De){const Q=new m({regexParsingWithErrorRecovery:!1});return De.map(ue=>(Q.parse(ue),Q.lexingErrors.length>0?Q.lexingErrors.map(J=>({errorMessage:J.additionalInfo?(0,A.localize)(9,null,J.additionalInfo):(0,A.localize)(10,null),offset:J.offset,length:J.lexeme.length})):Q.parsingErrors.length>0?Q.parsingErrors.map(J=>({errorMessage:J.additionalInfo?`${J.message}. ${J.additionalInfo}`:J.message,offset:J.offset,length:J.lexeme.length})):[]))}e.$Pi=r;function s(De,Q){const ue=De?De.substituteConstants():void 0,J=Q?Q.substituteConstants():void 0;return!ue&&!J?!0:!ue||!J?!1:ue.equals(J)}e.$Qi=s;function o(De,Q){return De.cmp(Q)}class ${constructor(){this.type=0}cmp(Q){return this.type-Q.type}equals(Q){return Q.type===this.type}substituteConstants(){return this}evaluate(Q){return!1}serialize(){return"false"}keys(){return[]}map(Q){return this}negate(){return a.INSTANCE}}e.$Ri=$,$.INSTANCE=new $;class a{constructor(){this.type=1}cmp(Q){return this.type-Q.type}equals(Q){return Q.type===this.type}substituteConstants(){return this}evaluate(Q){return!0}serialize(){return"true"}keys(){return[]}map(Q){return this}negate(){return $.INSTANCE}}e.$Si=a,a.INSTANCE=new a;class k{static create(Q,ue=null){const J=E.get(Q);return typeof J=="boolean"?J?a.INSTANCE:$.INSTANCE:new k(Q,ue)}constructor(Q,ue){this.key=Q,this.c=ue,this.type=2}cmp(Q){return Q.type!==this.type?this.type-Q.type:ve(this.key,Q.key)}equals(Q){return Q.type===this.type?this.key===Q.key:!1}substituteConstants(){const Q=E.get(this.key);return typeof Q=="boolean"?Q?a.INSTANCE:$.INSTANCE:this}evaluate(Q){return!!Q.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(Q){return Q.mapDefined(this.key)}negate(){return this.c||(this.c=M.create(this.key,this)),this.c}}e.$Ti=k;class P{static create(Q,ue,J=null){if(typeof ue=="boolean")return ue?k.create(Q,J):M.create(Q,J);const he=E.get(Q);return typeof he=="boolean"?ue===(he?"true":"false")?a.INSTANCE:$.INSTANCE:new P(Q,ue,J)}constructor(Q,ue,J){this.c=Q,this.d=ue,this.f=J,this.type=4}cmp(Q){return Q.type!==this.type?this.type-Q.type:ge(this.c,this.d,Q.c,Q.d)}equals(Q){return Q.type===this.type?this.c===Q.c&&this.d===Q.d:!1}substituteConstants(){const Q=E.get(this.c);if(typeof Q=="boolean"){const ue=Q?"true":"false";return this.d===ue?a.INSTANCE:$.INSTANCE}return this}evaluate(Q){return Q.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(Q){return Q.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=y.create(this.c,this.d,this)),this.f}}e.$Ui=P;class h{static create(Q,ue){return new h(Q,ue)}constructor(Q,ue){this.d=Q,this.f=ue,this.type=10,this.c=null}cmp(Q){return Q.type!==this.type?this.type-Q.type:ge(this.d,this.f,Q.d,Q.f)}equals(Q){return Q.type===this.type?this.d===Q.d&&this.f===Q.f:!1}substituteConstants(){return this}evaluate(Q){const ue=Q.getValue(this.f),J=Q.getValue(this.d);return Array.isArray(ue)?ue.includes(J):typeof J=="string"&&typeof ue=="object"&&ue!==null?R.call(ue,J):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(Q){return Q.mapIn(this.d,this.f)}negate(){return this.c||(this.c=w.create(this.d,this.f)),this.c}}e.$Vi=h;class w{static create(Q,ue){return new w(Q,ue)}constructor(Q,ue){this.d=Q,this.f=ue,this.type=11,this.c=h.create(Q,ue)}cmp(Q){return Q.type!==this.type?this.type-Q.type:this.c.cmp(Q.c)}equals(Q){return Q.type===this.type?this.c.equals(Q.c):!1}substituteConstants(){return this}evaluate(Q){return!this.c.evaluate(Q)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(Q){return Q.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Wi=w;class y{static create(Q,ue,J=null){if(typeof ue=="boolean")return ue?M.create(Q,J):k.create(Q,J);const he=E.get(Q);return typeof he=="boolean"?ue===(he?"true":"false")?$.INSTANCE:a.INSTANCE:new y(Q,ue,J)}constructor(Q,ue,J){this.c=Q,this.d=ue,this.f=J,this.type=5}cmp(Q){return Q.type!==this.type?this.type-Q.type:ge(this.c,this.d,Q.c,Q.d)}equals(Q){return Q.type===this.type?this.c===Q.c&&this.d===Q.d:!1}substituteConstants(){const Q=E.get(this.c);if(typeof Q=="boolean"){const ue=Q?"true":"false";return this.d===ue?$.INSTANCE:a.INSTANCE}return this}evaluate(Q){return Q.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(Q){return Q.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=P.create(this.c,this.d,this)),this.f}}e.$Xi=y;class M{static create(Q,ue=null){const J=E.get(Q);return typeof J=="boolean"?J?$.INSTANCE:a.INSTANCE:new M(Q,ue)}constructor(Q,ue){this.c=Q,this.d=ue,this.type=3}cmp(Q){return Q.type!==this.type?this.type-Q.type:ve(this.c,Q.c)}equals(Q){return Q.type===this.type?this.c===Q.c:!1}substituteConstants(){const Q=E.get(this.c);return typeof Q=="boolean"?Q?$.INSTANCE:a.INSTANCE:this}evaluate(Q){return!Q.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(Q){return Q.mapNot(this.c)}negate(){return this.d||(this.d=k.create(this.c,this)),this.d}}e.$Yi=M;function V(De,Q){if(typeof De=="string"){const ue=parseFloat(De);isNaN(ue)||(De=ue)}return typeof De=="string"||typeof De=="number"?Q(De):$.INSTANCE}class B{static create(Q,ue,J=null){return V(ue,he=>new B(Q,he,J))}constructor(Q,ue,J){this.c=Q,this.d=ue,this.f=J,this.type=12}cmp(Q){return Q.type!==this.type?this.type-Q.type:ge(this.c,this.d,Q.c,Q.d)}equals(Q){return Q.type===this.type?this.c===Q.c&&this.d===Q.d:!1}substituteConstants(){return this}evaluate(Q){return typeof this.d=="string"?!1:parseFloat(Q.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(Q){return Q.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=F.create(this.c,this.d,this)),this.f}}e.$Zi=B;class z{static create(Q,ue,J=null){return V(ue,he=>new z(Q,he,J))}constructor(Q,ue,J){this.c=Q,this.d=ue,this.f=J,this.type=13}cmp(Q){return Q.type!==this.type?this.type-Q.type:ge(this.c,this.d,Q.c,Q.d)}equals(Q){return Q.type===this.type?this.c===Q.c&&this.d===Q.d:!1}substituteConstants(){return this}evaluate(Q){return typeof this.d=="string"?!1:parseFloat(Q.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(Q){return Q.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=T.create(this.c,this.d,this)),this.f}}e.$1i=z;class T{static create(Q,ue,J=null){return V(ue,he=>new T(Q,he,J))}constructor(Q,ue,J){this.c=Q,this.d=ue,this.f=J,this.type=14}cmp(Q){return Q.type!==this.type?this.type-Q.type:ge(this.c,this.d,Q.c,Q.d)}equals(Q){return Q.type===this.type?this.c===Q.c&&this.d===Q.d:!1}substituteConstants(){return this}evaluate(Q){return typeof this.d=="string"?!1:parseFloat(Q.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(Q){return Q.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=z.create(this.c,this.d,this)),this.f}}e.$2i=T;class F{static create(Q,ue,J=null){return V(ue,he=>new F(Q,he,J))}constructor(Q,ue,J){this.c=Q,this.d=ue,this.f=J,this.type=15}cmp(Q){return Q.type!==this.type?this.type-Q.type:ge(this.c,this.d,Q.c,Q.d)}equals(Q){return Q.type===this.type?this.c===Q.c&&this.d===Q.d:!1}substituteConstants(){return this}evaluate(Q){return typeof this.d=="string"?!1:parseFloat(Q.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(Q){return Q.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=B.create(this.c,this.d,this)),this.f}}e.$3i=F;class j{static create(Q,ue){return new j(Q,ue)}constructor(Q,ue){this.d=Q,this.f=ue,this.type=7,this.c=null}cmp(Q){if(Q.type!==this.type)return this.type-Q.type;if(this.d<Q.d)return-1;if(this.d>Q.d)return 1;const ue=this.f?this.f.source:"",J=Q.f?Q.f.source:"";return ue<J?-1:ue>J?1:0}equals(Q){if(Q.type===this.type){const ue=this.f?this.f.source:"",J=Q.f?Q.f.source:"";return this.d===Q.d&&ue===J}return!1}substituteConstants(){return this}evaluate(Q){const ue=Q.getValue(this.d);return this.f?this.f.test(ue):!1}serialize(){const Q=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${Q}`}keys(){return[this.d]}map(Q){return Q.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=q.create(this)),this.c}}e.$4i=j;class q{static create(Q){return new q(Q)}constructor(Q){this.c=Q,this.type=8}cmp(Q){return Q.type!==this.type?this.type-Q.type:this.c.cmp(Q.c)}equals(Q){return Q.type===this.type?this.c.equals(Q.c):!1}substituteConstants(){return this}evaluate(Q){return!this.c.evaluate(Q)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(Q){return new q(this.c.map(Q))}negate(){return this.c}}e.$5i=q;function W(De){let Q=null;for(let ue=0,J=De.length;ue<J;ue++){const he=De[ue].substituteConstants();if(De[ue]!==he&&Q===null){Q=[];for(let de=0;de<ue;de++)Q[de]=De[de]}Q!==null&&(Q[ue]=he)}return Q===null?De:Q}class we{static create(Q,ue,J){return we.d(Q,ue,J)}constructor(Q,ue){this.expr=Q,this.c=ue,this.type=6}cmp(Q){if(Q.type!==this.type)return this.type-Q.type;if(this.expr.length<Q.expr.length)return-1;if(this.expr.length>Q.expr.length)return 1;for(let ue=0,J=this.expr.length;ue<J;ue++){const he=o(this.expr[ue],Q.expr[ue]);if(he!==0)return he}return 0}equals(Q){if(Q.type===this.type){if(this.expr.length!==Q.expr.length)return!1;for(let ue=0,J=this.expr.length;ue<J;ue++)if(!this.expr[ue].equals(Q.expr[ue]))return!1;return!0}return!1}substituteConstants(){const Q=W(this.expr);return Q===this.expr?this:we.create(Q,this.c,!1)}evaluate(Q){for(let ue=0,J=this.expr.length;ue<J;ue++)if(!this.expr[ue].evaluate(Q))return!1;return!0}static d(Q,ue,J){const he=[];let de=!1;for(const le of Q)if(le){if(le.type===1){de=!0;continue}if(le.type===0)return $.INSTANCE;if(le.type===6){he.push(...le.expr);continue}he.push(le)}if(he.length===0&&de)return a.INSTANCE;if(he.length!==0){if(he.length===1)return he[0];he.sort(o);for(let le=1;le<he.length;le++)he[le-1].equals(he[le])&&(he.splice(le,1),le--);if(he.length===1)return he[0];for(;he.length>1;){const le=he[he.length-1];if(le.type!==9)break;he.pop();const be=he.pop(),ie=he.length===0,fe=ke.create(le.expr.map(ne=>we.create([ne,be],null,J)),null,ie);fe&&(he.push(fe),he.sort(o))}if(he.length===1)return he[0];if(J){for(let le=0;le<he.length;le++)for(let be=le+1;be<he.length;be++)if(he[le].negate().equals(he[be]))return $.INSTANCE;if(he.length===1)return he[0]}return new we(he,ue)}}serialize(){return this.expr.map(Q=>Q.serialize()).join(" && ")}keys(){const Q=[];for(const ue of this.expr)Q.push(...ue.keys());return Q}map(Q){return new we(this.expr.map(ue=>ue.map(Q)),null)}negate(){if(!this.c){const Q=[];for(const ue of this.expr)Q.push(ue.negate());this.c=ke.create(Q,this,!0)}return this.c}}e.$6i=we;class ke{static create(Q,ue,J){return ke.d(Q,ue,J)}constructor(Q,ue){this.expr=Q,this.c=ue,this.type=9}cmp(Q){if(Q.type!==this.type)return this.type-Q.type;if(this.expr.length<Q.expr.length)return-1;if(this.expr.length>Q.expr.length)return 1;for(let ue=0,J=this.expr.length;ue<J;ue++){const he=o(this.expr[ue],Q.expr[ue]);if(he!==0)return he}return 0}equals(Q){if(Q.type===this.type){if(this.expr.length!==Q.expr.length)return!1;for(let ue=0,J=this.expr.length;ue<J;ue++)if(!this.expr[ue].equals(Q.expr[ue]))return!1;return!0}return!1}substituteConstants(){const Q=W(this.expr);return Q===this.expr?this:ke.create(Q,this.c,!1)}evaluate(Q){for(let ue=0,J=this.expr.length;ue<J;ue++)if(this.expr[ue].evaluate(Q))return!0;return!1}static d(Q,ue,J){let he=[],de=!1;if(Q){for(let le=0,be=Q.length;le<be;le++){const ie=Q[le];if(ie){if(ie.type===0){de=!0;continue}if(ie.type===1)return a.INSTANCE;if(ie.type===9){he=he.concat(ie.expr);continue}he.push(ie)}}if(he.length===0&&de)return $.INSTANCE;he.sort(o)}if(he.length!==0){if(he.length===1)return he[0];for(let le=1;le<he.length;le++)he[le-1].equals(he[le])&&(he.splice(le,1),le--);if(he.length===1)return he[0];if(J){for(let le=0;le<he.length;le++)for(let be=le+1;be<he.length;be++)if(he[le].negate().equals(he[be]))return a.INSTANCE;if(he.length===1)return he[0]}return new ke(he,ue)}}serialize(){return this.expr.map(Q=>Q.serialize()).join(" || ")}keys(){const Q=[];for(const ue of this.expr)Q.push(...ue.keys());return Q}map(Q){return new ke(this.expr.map(ue=>ue.map(Q)),null)}negate(){if(!this.c){const Q=[];for(const ue of this.expr)Q.push(ue.negate());for(;Q.length>1;){const ue=Q.shift(),J=Q.shift(),he=[];for(const de of ye(ue))for(const le of ye(J))he.push(we.create([de,le],null,!1));Q.unshift(ke.create(he,null,!1))}this.c=ke.create(Q,this,!0)}return this.c}}e.$7i=ke;class Se extends k{static all(){return Se.d.values()}constructor(Q,ue,J){super(Q,null),this.f=ue,typeof J=="object"?Se.d.push({...J,key:Q}):J!==!0&&Se.d.push({key:Q,description:J,type:ue!=null?typeof ue:void 0})}bindTo(Q){return Q.createKey(this.key,this.f)}getValue(Q){return Q.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(Q){return P.create(this.key,Q)}notEqualsTo(Q){return y.create(this.key,Q)}}e.$8i=Se,Se.d=[],e.$9i=(0,O.$Qh)("contextKeyService");function ve(De,Q){return De<Q?-1:De>Q?1:0}function ge(De,Q,ue,J){return De<ue?-1:De>ue?1:Q<J?-1:Q>J?1:0}function re(De,Q){if(De.type===0||Q.type===1)return!0;if(De.type===9)return Q.type===9?oe(De.expr,Q.expr):!1;if(Q.type===9){for(const ue of Q.expr)if(re(De,ue))return!0;return!1}if(De.type===6){if(Q.type===6)return oe(Q.expr,De.expr);for(const ue of De.expr)if(re(ue,Q))return!0;return!1}return De.equals(Q)}e.$0i=re;function oe(De,Q){let ue=0,J=0;for(;ue<De.length&&J<Q.length;){const he=De[ue].cmp(Q[J]);if(he<0)return!1;he===0&&ue++,J++}return ue===De.length}function ye(De){return De.type===9?De.expr:[De]}}),define(Ae[172],Re([1,0,4]),function(ee,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yh=e.$Xh=void 0,e.$Xh=(0,f.$Qh)("environmentService"),e.$Yh=(0,f.$Rh)(e.$Xh)}),define(Ae[92],Re([1,0,140,4]),function(ee,e,f,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lo=e.$ko=e.$jo=e.$io=e.$ho=e.$go=e.$fo=e.$eo=e.$do=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$co=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$bo=e.$ao=e.$_n=e.$$n=e.$0n=e.$9n=e.$8n=e.$7n=e.$6n=e.$5n=e.$4n=e.$3n=void 0,e.$3n="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$4n=new RegExp(e.$3n),e.$5n="__web_extension",e.$6n="skipWalkthrough",e.$7n="extensionsSync",e.$8n="dependecyOrPackExtensionInstall";function I(i){switch(i){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$9n=I;function O(i){switch(i){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$0n=O;function A(i,l){switch(i){case 3:return l==="x64"?"win32-x64":l==="arm64"?"win32-arm64":"unknown";case 2:return l==="x64"?"linux-x64":l==="arm64"?"linux-arm64":l==="arm"?"linux-armhf":"unknown";case"alpine":return l==="x64"?"alpine-x64":l==="arm64"?"alpine-arm64":"unknown";case 1:return l==="x64"?"darwin-x64":l==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$$n=A;function c(i,l){return l==="web"&&!i.includes("web")}e.$_n=c;function E(i,l,v){return c(l,v)?!1:i==="undefined"||i==="universal"?!0:i==="unknown"?!1:i===v}e.$ao=E;function d(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(!i.uuid||typeof i.uuid=="string")}e.$bo=d;var R;(function(i){i[i.NoneOrRelevance=0]="NoneOrRelevance",i[i.LastUpdatedDate=1]="LastUpdatedDate",i[i.Title=2]="Title",i[i.PublisherName=3]="PublisherName",i[i.InstallCount=4]="InstallCount",i[i.PublishedDate=10]="PublishedDate",i[i.AverageRating=6]="AverageRating",i[i.WeightedRating=12]="WeightedRating"})(R||(e.SortBy=R={}));var S;(function(i){i[i.Default=0]="Default",i[i.Ascending=1]="Ascending",i[i.Descending=2]="Descending"})(S||(e.SortOrder=S={}));var u;(function(i){i.Install="install",i.Uninstall="uninstall"})(u||(e.StatisticType=u={}));var b;(function(i){i[i.None=1]="None",i[i.Install=2]="Install",i[i.Update=3]="Update",i[i.Migrate=4]="Migrate"})(b||(e.InstallOperation=b={})),e.$co=(0,C.$Qh)("extensionGalleryService");var p;(function(i){i.Unsupported="Unsupported",i.Deprecated="Deprecated",i.Malicious="Malicious",i.Incompatible="Incompatible",i.IncompatibleTargetPlatform="IncompatibleTargetPlatform",i.ReleaseVersionNotFound="ReleaseVersionNotFound",i.Invalid="Invalid",i.Download="Download",i.Extract="Extract",i.Delete="Delete",i.Rename="Rename",i.CorruptZip="CorruptZip",i.IncompleteZip="IncompleteZip",i.Signature="Signature",i.Internal="Internal"})(p||(e.ExtensionManagementErrorCode=p={}));var g;(function(i){i.UnknownError="UnknownError",i.PackageIsInvalidZip="PackageIsInvalidZip",i.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(g||(e.ExtensionSignaturetErrorCode=g={}));class t extends Error{constructor(l,v){super(l),this.code=v,this.name=v}}e.$do=t,e.$eo=(0,C.$Qh)("extensionManagementService"),e.$fo="extensionsIdentifiers/disabled",e.$go="extensionsIdentifiers/enabled",e.$ho=(0,C.$Qh)("IGlobalExtensionEnablementService"),e.$io=(0,C.$Qh)("IExtensionTipsService"),e.$jo=(0,f.localize)(0,null),e.$ko={value:e.$jo,original:"Extensions"},e.$lo={value:(0,f.localize)(1,null),original:"Preferences"}}),define(Ae[39],Re([1,0,50,20,16,15,2,142,4,23,13,42]),function(ee,e,f,C,I,O,A,c,E,d,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ik=e.$Hk=e.$Gk=e.$Fk=e.$Ek=e.FileKind=e.$Dk=e.$Ck=e.$Bk=e.$Ak=e.$zk=e.$yk=e.$xk=e.FileOperationResult=e.$wk=e.$vk=e.$uk=e.$tk=e.$sk=e.FileChangeType=e.$rk=e.FileOperation=e.$qk=e.$pk=e.$ok=e.$nk=e.$mk=e.$lk=e.FileSystemProviderErrorCode=e.$kk=e.$jk=e.$ik=e.$hk=e.$gk=e.$fk=e.$ek=e.$dk=e.$ck=e.FileSystemProviderCapabilities=e.$bk=e.FilePermission=e.FileType=e.$ak=e.$_j=void 0,e.$_j=(0,E.$Qh)("fileService");function u(re){return re.create===!0}e.$ak=u;var b;(function(re){re[re.Unknown=0]="Unknown",re[re.File=1]="File",re[re.Directory=2]="Directory",re[re.SymbolicLink=64]="SymbolicLink"})(b||(e.FileType=b={}));var p;(function(re){re[re.Readonly=1]="Readonly",re[re.Locked=2]="Locked"})(p||(e.FilePermission=p={}));function g(re){const oe=re;return!!oe&&typeof oe.onDidChange=="function"}e.$bk=g;var t;(function(re){re[re.None=0]="None",re[re.FileReadWrite=2]="FileReadWrite",re[re.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",re[re.FileReadStream=16]="FileReadStream",re[re.FileFolderCopy=8]="FileFolderCopy",re[re.PathCaseSensitive=1024]="PathCaseSensitive",re[re.Readonly=2048]="Readonly",re[re.Trash=4096]="Trash",re[re.FileWriteUnlock=8192]="FileWriteUnlock",re[re.FileAtomicRead=16384]="FileAtomicRead",re[re.FileAtomicWrite=32768]="FileAtomicWrite",re[re.FileAtomicDelete=65536]="FileAtomicDelete",re[re.FileClone=131072]="FileClone"})(t||(e.FileSystemProviderCapabilities=t={}));function i(re){return!!(re.capabilities&2)}e.$ck=i;function l(re){return!!(re.capabilities&8)}e.$dk=l;function v(re){return!!(re.capabilities&131072)}e.$ek=v;function D(re){return!!(re.capabilities&4)}e.$fk=D;function m(re){return!!(re.capabilities&16)}e.$gk=m;function n(re){return i(re)?!!(re.capabilities&16384):!1}e.$hk=n;function r(re){return i(re)?!!(re.capabilities&32768):!1}e.$ik=r;function s(re){return!!(re.capabilities&65536)}e.$jk=s;function o(re){return!!(re.capabilities&2048)}e.$kk=o;var $;(function(re){re.FileExists="EntryExists",re.FileNotFound="EntryNotFound",re.FileNotADirectory="EntryNotADirectory",re.FileIsADirectory="EntryIsADirectory",re.FileExceedsStorageQuota="EntryExceedsStorageQuota",re.FileTooLarge="EntryTooLarge",re.FileWriteLocked="EntryWriteLocked",re.NoPermissions="NoPermissions",re.Unavailable="Unavailable",re.Unknown="Unknown"})($||(e.FileSystemProviderErrorCode=$={}));class a extends Error{static create(oe,ye){const De=new a(oe.toString(),ye);return h(De,ye),De}constructor(oe,ye){super(oe),this.code=ye}}e.$lk=a;function k(re,oe){return a.create(re,oe)}e.$mk=k;function P(re){return re||k((0,c.localize)(0,null),$.Unknown)}e.$nk=P;function h(re,oe){return re.name=oe?`${oe} (FileSystemError)`:"FileSystemError",re}e.$ok=h;function w(re){if(!re)return $.Unknown;if(re instanceof a)return re.code;const oe=/^(.+) \(FileSystemError\)$/.exec(re.name);if(!oe)return $.Unknown;switch(oe[1]){case $.FileExists:return $.FileExists;case $.FileIsADirectory:return $.FileIsADirectory;case $.FileNotADirectory:return $.FileNotADirectory;case $.FileNotFound:return $.FileNotFound;case $.FileTooLarge:return $.FileTooLarge;case $.FileWriteLocked:return $.FileWriteLocked;case $.NoPermissions:return $.NoPermissions;case $.Unavailable:return $.Unavailable}return $.Unknown}e.$pk=w;function y(re){if(re instanceof F)return re.fileOperationResult;switch(w(re)){case $.FileNotFound:return 1;case $.FileIsADirectory:return 0;case $.FileNotADirectory:return 9;case $.FileWriteLocked:return 5;case $.NoPermissions:return 6;case $.FileExists:return 4;case $.FileTooLarge:return 7;default:return 10}}e.$qk=y;var M;(function(re){re[re.CREATE=0]="CREATE",re[re.DELETE=1]="DELETE",re[re.MOVE=2]="MOVE",re[re.COPY=3]="COPY",re[re.WRITE=4]="WRITE"})(M||(e.FileOperation=M={}));class V{constructor(oe,ye,De){this.resource=oe,this.operation=ye,this.target=De}isOperation(oe){return this.operation===oe}}e.$rk=V;var B;(function(re){re[re.UPDATED=0]="UPDATED",re[re.ADDED=1]="ADDED",re[re.DELETED=2]="DELETED"})(B||(e.FileChangeType=B={}));class z{constructor(oe,ye){this.c=ye,this.b=void 0,this.d=new S.$V(()=>{const De=f.$Wh.forUris(()=>this.c);return De.fill(this.rawAdded.map(Q=>[Q,!0])),De}),this.f=new S.$V(()=>{const De=f.$Wh.forUris(()=>this.c);return De.fill(this.rawUpdated.map(Q=>[Q,!0])),De}),this.g=new S.$V(()=>{const De=f.$Wh.forUris(()=>this.c);return De.fill(this.rawDeleted.map(Q=>[Q,!0])),De}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const De of oe){switch(De.type){case 1:this.rawAdded.push(De.resource);break;case 0:this.rawUpdated.push(De.resource);break;case 2:this.rawDeleted.push(De.resource);break}this.b!==z.a&&(typeof De.cId=="number"?this.b===void 0?this.b=De.cId:this.b!==De.cId&&(this.b=z.a):this.b!==void 0&&(this.b=z.a))}}contains(oe,...ye){return this.h(oe,{includeChildren:!1},...ye)}affects(oe,...ye){return this.h(oe,{includeChildren:!0},...ye)}h(oe,ye,...De){if(!oe)return!1;const Q=De.length>0;return!!((!Q||De.includes(1))&&(this.d.value.get(oe)||ye.includeChildren&&this.d.value.findSuperstr(oe))||(!Q||De.includes(0))&&(this.f.value.get(oe)||ye.includeChildren&&this.f.value.findSuperstr(oe))||(!Q||De.includes(2))&&(this.g.value.findSubstr(oe)||ye.includeChildren&&this.g.value.findSuperstr(oe)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(oe){return this.b===oe}hasCorrelation(){return typeof this.b=="number"}}e.$sk=z,z.a=null;function T(re,oe,ye){return!re||!oe||re===oe||oe.length>re.length?!1:(oe.charAt(oe.length-1)!==C.sep&&(oe+=C.sep),ye?(0,I.$4e)(re,oe):re.indexOf(oe)===0)}e.$tk=T;class F extends Error{constructor(oe,ye,De){super(oe),this.fileOperationResult=ye,this.options=De}}e.$uk=F;class j extends F{constructor(oe,ye,De,Q){super(oe,ye,Q),this.fileOperationResult=ye,this.size=De}}e.$vk=j;class q extends F{constructor(oe,ye,De){super(oe,2,De),this.stat=ye}}e.$wk=q;var W;(function(re){re[re.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",re[re.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",re[re.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",re[re.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",re[re.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",re[re.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",re[re.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",re[re.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",re[re.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",re[re.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",re[re.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(W||(e.FileOperationResult=W={})),e.$xk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$yk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$zk="files.associations",e.$Ak="files.exclude",e.$Bk="files.readonlyInclude",e.$Ck="files.readonlyExclude",e.$Dk="files.readonlyFromPermissions";var we;(function(re){re[re.FILE=0]="FILE",re[re.FOLDER=1]="FOLDER",re[re.ROOT_FOLDER=2]="ROOT_FOLDER"})(we||(e.FileKind=we={})),e.$Ek="";function ke(re){if(!(typeof re.size!="number"||typeof re.mtime!="number"))return re.mtime.toString(29)+re.size.toString(31)}e.$Fk=ke;async function Se(re,oe){if(!oe.hasProvider(A.URI.from({scheme:re.scheme})))return new Promise(ye=>{const De=oe.onDidChangeFileSystemProviderRegistrations(Q=>{Q.scheme===re.scheme&&Q.added&&(De.dispose(),ye())})})}e.$Gk=Se;class ve{static formatSize(oe){return(0,O.$Df)(oe)||(oe=0),oe<ve.KB?(0,c.localize)(1,null,oe.toFixed(0)):oe<ve.MB?(0,c.localize)(2,null,(oe/ve.KB).toFixed(2)):oe<ve.GB?(0,c.localize)(3,null,(oe/ve.MB).toFixed(2)):oe<ve.TB?(0,c.localize)(4,null,(oe/ve.GB).toFixed(2)):(0,c.localize)(5,null,(oe/ve.TB).toFixed(2))}}e.$Hk=ve,ve.KB=1024,ve.MB=ve.KB*ve.KB,ve.GB=ve.MB*ve.KB,ve.TB=ve.GB*ve.KB;function ge(re){const oe=typeof re=="string"||re?.scheme===R.Schemas.vscodeRemote;return typeof re!="string"&&re?.scheme===R.Schemas.file?1024*ve.MB:oe?10*ve.MB:d.$j?50*ve.MB:1024*ve.MB}e.$Ik=ge}),define(Ae[71],Re([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oh=void 0;class f{constructor(...I){this.a=new Map;for(const[O,A]of I)this.set(O,A)}set(I,O){const A=this.a.get(I);return this.a.set(I,O),A}has(I){return this.a.has(I)}get(I){return this.a.get(I)}}e.$Oh=f}),define(Ae[173],Re([1,0,12,11,6,69,171,4,71,174]),function(ee,e,f,C,I,O,A,c,E,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jq=e.$iq=void 0;const R=!1;class S extends Error{constructor(t){super("cyclic dependency between services"),this.message=t.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${t.toString()}`}}class u{constructor(t=new E.$Oh,i=!1,l,v=R){this.f=t,this.g=i,this.h=l,this.i=v,this.o=new Set,this.f.set(c.$Ph,this),this._globalGraph=v?l?._globalGraph??new A.$hq(D=>D):void 0}createChild(t){return new u(t,this.g,this,this.i)}invokeFunction(t,...i){const l=p.traceInvocation(this.i,t);let v=!1;try{return t({get:m=>{if(v)throw(0,C.$8)("service accessor is only valid during the invocation of its target method");const n=this.m(m,l);if(!n)throw new Error(`[invokeFunction] unknown service '${m}'`);return n}},...i)}finally{v=!0,l.stop()}}createInstance(t,...i){let l,v;return t instanceof O.$Nh?(l=p.traceCreation(this.i,t.ctor),v=this.j(t.ctor,t.staticArguments.concat(i),l)):(l=p.traceCreation(this.i,t),v=this.j(t,i,l)),l.stop(),v}j(t,i=[],l){const v=c._util.getServiceDependencies(t).sort((n,r)=>n.index-r.index),D=[];for(const n of v){const r=this.m(n.id,l);r||this.u(`[createInstance] ${t.name} depends on UNKNOWN service ${n.id}.`,!1),D.push(r)}const m=v.length>0?v[0].index:i.length;if(i.length!==m){console.trace(`[createInstance] First service dependency of ${t.name} at position ${m+1} conflicts with ${i.length} static arguments`);const n=m-i.length;n>0?i=i.concat(new Array(n)):i=i.slice(0,m)}return Reflect.construct(t,i.concat(D))}k(t,i){if(this.f.get(t)instanceof O.$Nh)this.f.set(t,i);else if(this.h)this.h.k(t,i);else throw new Error("illegalState - setting UNKNOWN service instance")}l(t){const i=this.f.get(t);return!i&&this.h?this.h.l(t):i}m(t,i){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(t));const l=this.l(t);return l instanceof O.$Nh?this.q(t,l,i.branch(t,!0)):(i.branch(t,!1),l)}q(t,i,l){if(this.o.has(t))throw new Error(`illegal state - RECURSIVELY instantiating service '${t}'`);this.o.add(t);try{return this.r(t,i,l)}finally{this.o.delete(t)}}r(t,i,l){const v=new A.$hq(n=>n.id.toString());let D=0;const m=[{id:t,desc:i,_trace:l}];for(;m.length;){const n=m.pop();if(v.lookupOrInsertNode(n),D++>1e3)throw new S(v);for(const r of c._util.getServiceDependencies(n.desc.ctor)){const s=this.l(r.id);if(s||this.u(`[createInstance] ${t} depends on ${r.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(n.id),String(r.id)),s instanceof O.$Nh){const o={id:r.id,desc:s,_trace:n._trace.branch(r.id,!0)};v.insertEdge(n,o),m.push(o)}}}for(;;){const n=v.roots();if(n.length===0){if(!v.isEmpty())throw new S(v);break}for(const{data:r}of n){if(this.l(r.id)instanceof O.$Nh){const o=this.s(r.id,r.desc.ctor,r.desc.staticArguments,r.desc.supportsDelayedInstantiation,r._trace);this.k(r.id,o)}v.removeNode(r)}}return this.l(t)}s(t,i,l=[],v,D){if(this.f.get(t)instanceof O.$Nh)return this.t(t,i,l,v,D);if(this.h)return this.h.s(t,i,l,v,D);throw new Error(`illegalState - creating UNKNOWN service instance ${i.name}`)}t(t,i,l=[],v,D){if(v){const m=new u(void 0,this.g,this,this.i);m.c=String(t);const n=new Map,r=new f.$_g(()=>{const s=m.j(i,l,D);for(const[o,$]of n){const a=s[o];if(typeof a=="function")for(const k of $)a.apply(s,k)}return n.clear(),s});return new Proxy(Object.create(null),{get(s,o){if(!r.isInitialized&&typeof o=="string"&&(o.startsWith("onDid")||o.startsWith("onWill"))){let k=n.get(o);return k||(k=new d.$2c,n.set(o,k)),(h,w,y)=>{const M=k.push([h,w,y]);return(0,I.$Qc)(M)}}if(o in s)return s[o];const $=r.value;let a=$[o];return typeof a!="function"||(a=a.bind($),s[o]=a),a},set(s,o,$){return r.value[o]=$,!0},getPrototypeOf(s){return i.prototype}})}else return this.j(i,l,D)}u(t,i){if(i&&console.warn(t),this.g)throw new Error(t)}}e.$iq=u;var b;(function(g){g[g.None=0]="None",g[g.Creation=1]="Creation",g[g.Invocation=2]="Invocation",g[g.Branch=3]="Branch"})(b||(b={}));class p{static traceInvocation(t,i){return t?new p(2,i.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):p.c}static traceCreation(t,i){return t?new p(1,i.name):p.c}constructor(t,i){this.type=t,this.name=i,this.g=Date.now(),this.h=[]}branch(t,i){const l=new p(3,t.toString());return this.h.push([t,i,l]),l}stop(){const t=Date.now()-this.g;p.f+=t;let i=!1;function l(D,m){const n=[],r=new Array(D+1).join("	");for(const[s,o,$]of m.h)if(o&&$){i=!0,n.push(`${r}CREATES -> ${s}`);const a=l(D+1,$);a&&n.push(a)}else n.push(`${r}uses -> ${s}`);return n.join(`
`)}const v=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${l(1,this)}`,`DONE, took ${t.toFixed(2)}ms (grand total ${p.f.toFixed(2)}ms)`];(t>2||i)&&p.all.add(v.join(`
`))}}e.$jq=p,p.all=new Set,p.c=new class extends p{constructor(){super(0,null)}stop(){}branch(){return this}},p.f=0}),define(Ae[14],Re([1,0,38,5,93,6,28,23,24,15,2,32,4]),function(ee,e,f,C,I,O,A,c,E,d,R,S,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pj=e.$oj=e.$nj=e.$mj=e.$lj=e.$kj=e.$jj=e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.log=e.$bj=e.LogLevel=e.$aj=e.$_i=e.$$i=void 0,e.$$i=(0,u.$Qh)("logService"),e.$_i=(0,u.$Qh)("loggerService");function b(){return new Date().toISOString()}function p(h){return(0,d.$Df)(h)}e.$aj=p;var g;(function(h){h[h.Off=0]="Off",h[h.Trace=1]="Trace",h[h.Debug=2]="Debug",h[h.Info=3]="Info",h[h.Warning=4]="Warning",h[h.Error=5]="Error"})(g||(e.LogLevel=g={})),e.$bj=g.Info;function t(h,w,y){switch(w){case g.Trace:h.trace(y);break;case g.Debug:h.debug(y);break;case g.Info:h.info(y);break;case g.Warning:h.warn(y);break;case g.Error:h.error(y);break;case g.Off:break;default:throw new Error(`Invalid log level ${w}`)}}e.log=t;function i(h,w=!1){let y="";for(let M=0;M<h.length;M++){let V=h[M];if(V instanceof Error&&(V=(0,f.$Bi)(V,w)),typeof V=="object")try{V=JSON.stringify(V)}catch{}y+=(M>0?" ":"")+V}return y}class l extends O.$Sc{constructor(){super(...arguments),this.b=e.$bj,this.c=this.B(new C.$Od),this.onDidChangeLogLevel=this.c.event}setLevel(w){this.b!==w&&(this.b=w,this.c.fire(this.b))}getLevel(){return this.b}f(w){return this.b!==g.Off&&this.b<=w}}e.$dj=l;class v extends l{constructor(w){super(),this.h=w}f(w){return this.h||super.f(w)}trace(w,...y){this.f(g.Trace)&&this.g(g.Trace,i([w,...y],!0))}debug(w,...y){this.f(g.Debug)&&this.g(g.Debug,i([w,...y]))}info(w,...y){this.f(g.Info)&&this.g(g.Info,i([w,...y]))}warn(w,...y){this.f(g.Warning)&&this.g(g.Warning,i([w,...y]))}error(w,...y){if(this.f(g.Error))if(w instanceof Error){const M=Array.prototype.slice.call(arguments);M[0]=w.stack,this.g(g.Error,i(M))}else this.g(g.Error,i([w,...y]))}flush(){}}e.$ej=v;class D extends l{constructor(w=e.$bj){super(),this.setLevel(w),this.g=!c.$d}trace(w,...y){this.f(g.Trace)&&(this.g?console.log(`\x1B[90m[main ${b()}]\x1B[0m`,w,...y):console.log(`[main ${b()}]`,w,...y))}debug(w,...y){this.f(g.Debug)&&(this.g?console.log(`\x1B[90m[main ${b()}]\x1B[0m`,w,...y):console.log(`[main ${b()}]`,w,...y))}info(w,...y){this.f(g.Info)&&(this.g?console.log(`\x1B[90m[main ${b()}]\x1B[0m`,w,...y):console.log(`[main ${b()}]`,w,...y))}warn(w,...y){this.f(g.Warning)&&(this.g?console.warn(`\x1B[93m[main ${b()}]\x1B[0m`,w,...y):console.warn(`[main ${b()}]`,w,...y))}error(w,...y){this.f(g.Error)&&(this.g?console.error(`\x1B[91m[main ${b()}]\x1B[0m`,w,...y):console.error(`[main ${b()}]`,w,...y))}dispose(){}flush(){}}e.$fj=D;class m extends l{constructor(w=e.$bj,y=!0){super(),this.g=y,this.setLevel(w)}trace(w,...y){this.f(g.Trace)&&(this.g?console.log("%cTRACE","color: #888",w,...y):console.log(w,...y))}debug(w,...y){this.f(g.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",w,...y):console.log(w,...y))}info(w,...y){this.f(g.Info)&&(this.g?console.log("%c INFO","color: #33f",w,...y):console.log(w,...y))}warn(w,...y){this.f(g.Warning)&&(this.g?console.log("%c WARN","color: #993",w,...y):console.log(w,...y))}error(w,...y){this.f(g.Error)&&(this.g?console.log("%c  ERR","color: #f33",w,...y):console.error(w,...y))}dispose(){}flush(){}}e.$gj=m;class n extends l{constructor(w,y=e.$bj){super(),this.g=w,this.setLevel(y)}trace(w,...y){this.f(g.Trace)&&this.g.log(g.Trace,[this.h(w),...y])}debug(w,...y){this.f(g.Debug)&&this.g.log(g.Debug,[this.h(w),...y])}info(w,...y){this.f(g.Info)&&this.g.log(g.Info,[this.h(w),...y])}warn(w,...y){this.f(g.Warning)&&this.g.log(g.Warning,[this.h(w),...y])}error(w,...y){this.f(g.Error)&&this.g.log(g.Error,[this.h(w),...y])}h(w){return typeof w=="string"?w:(0,f.$Bi)(w,this.f(g.Trace))}dispose(){}flush(){}}e.$hj=n;class r extends l{constructor(w){super(),this.g=w,w.length&&this.setLevel(w[0].getLevel())}setLevel(w){for(const y of this.g)y.setLevel(w);super.setLevel(w)}trace(w,...y){for(const M of this.g)M.trace(w,...y)}debug(w,...y){for(const M of this.g)M.debug(w,...y)}info(w,...y){for(const M of this.g)M.info(w,...y)}warn(w,...y){for(const M of this.g)M.warn(w,...y)}error(w,...y){for(const M of this.g)M.error(w,...y)}flush(){for(const w of this.g)w.flush()}dispose(){for(const w of this.g)w.dispose()}}e.$ij=r;class s extends O.$Sc{constructor(w,y,M){if(super(),this.h=w,this.j=y,this.b=new A.$Ac,this.c=this.B(new C.$Od),this.onDidChangeLoggers=this.c.event,this.f=this.B(new C.$Od),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new C.$Od),this.onDidChangeVisibility=this.g.event,M)for(const V of M)this.b.set(V.resource,{logger:void 0,info:V})}m(w){return(0,d.$zf)(w)?[...this.b.values()].find(y=>y.info.id===w):this.b.get(w)}getLogger(w){return this.m(w)?.logger}createLogger(w,y){const M=this.n(w),V=(0,d.$zf)(w)?w:y?.id??(0,I.$Ei)(M.toString()).toString(16);let B=this.b.get(M)?.logger;const z=y?.logLevel==="always"?g.Trace:y?.logLevel;B||(B=this.s(M,z??this.getLogLevel(M)??this.h,{...y,id:V}));const T={logger:B,info:{resource:M,id:V,logLevel:z,name:y?.name,hidden:y?.hidden,extensionId:y?.extensionId,when:y?.when}};return this.registerLogger(T.info),this.b.set(M,T),B}n(w){return(0,d.$zf)(w)?(0,E.$wg)(this.j,`${w}.log`):w}setLogLevel(w,y){if(R.URI.isUri(w)){const M=w,V=y,B=this.b.get(M);B&&V!==B.info.logLevel&&(B.info.logLevel=V===this.h?void 0:V,B.logger?.setLevel(V),this.b.set(B.info.resource,B),this.f.fire([M,V]))}else{this.h=w;for(const[M,V]of this.b.entries())this.b.get(M)?.info.logLevel===void 0&&V.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(w,y){const M=this.m(w);M&&y!==!M.info.hidden&&(M.info.hidden=!y,this.b.set(M.info.resource,M),this.g.fire([M.info.resource,y]))}getLogLevel(w){let y;return w&&(y=this.b.get(w)?.info.logLevel),y??this.h}registerLogger(w){const y=this.b.get(w.resource);y?y.info.hidden!==w.hidden&&this.setVisibility(w.resource,!w.hidden):(this.b.set(w.resource,{info:w,logger:void 0}),this.c.fire({added:[w],removed:[]}))}deregisterLogger(w){const y=this.b.get(w);y&&(y.logger&&y.logger.dispose(),this.b.delete(w),this.c.fire({added:[],removed:[y.info]}))}*getRegisteredLoggers(){for(const w of this.b.values())yield w.info}getRegisteredLogger(w){return this.b.get(w)?.info}dispose(){this.b.forEach(w=>w.logger?.dispose()),this.b.clear(),super.dispose()}}e.$jj=s;class o{constructor(){this.onDidChangeLogLevel=new C.$Od().event}setLevel(w){}getLevel(){return g.Info}trace(w,...y){}debug(w,...y){}info(w,...y){}warn(w,...y){}error(w,...y){}critical(w,...y){}dispose(){}flush(){}}e.$kj=o;class $ extends o{}e.$lj=$;function a(h){if(h.verbose)return g.Trace;if(typeof h.logLevel=="string"){const w=P(h.logLevel.toLowerCase());if(w!==void 0)return w}return e.$bj}e.$mj=a;function k(h){switch(h){case g.Trace:return"trace";case g.Debug:return"debug";case g.Info:return"info";case g.Warning:return"warn";case g.Error:return"error";case g.Off:return"off"}}e.$nj=k;function P(h){switch(h){case"trace":return g.Trace;case"debug":return g.Debug;case"info":return g.Info;case"warn":return g.Warning;case"error":return g.Error;case"critical":return g.Error;case"off":return g.Off}}e.$oj=P,e.$pj=new S.$8i("logLevel",k(g.Info))}),define(Ae[175],Re([1,0,6,14]),function(ee,e,f,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PN=void 0;class I extends f.$Sc{constructor(A,c=[]){super(),this.a=new C.$ij([A,...c]),this.B(A.onDidChangeLogLevel(E=>this.setLevel(E)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(A){this.a.setLevel(A)}getLevel(){return this.a.getLevel()}trace(A,...c){this.a.trace(A,...c)}debug(A,...c){this.a.debug(A,...c)}info(A,...c){this.a.info(A,...c)}warn(A,...c){this.a.warn(A,...c)}error(A,...c){this.a.error(A,...c)}flush(){this.a.flush()}}e.$PN=I}),define(Ae[94],Re([1,0,29,143,4]),function(ee,e,f,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$et=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var O;(function(E){E[E.Unnecessary=1]="Unnecessary",E[E.Deprecated=2]="Deprecated"})(O||(e.MarkerTag=O={}));var A;(function(E){E[E.Hint=1]="Hint",E[E.Info=2]="Info",E[E.Warning=4]="Warning",E[E.Error=8]="Error"})(A||(e.MarkerSeverity=A={})),function(E){function d(p,g){return g-p}E.compare=d;const R=Object.create(null);R[E.Error]=(0,C.localize)(0,null),R[E.Warning]=(0,C.localize)(1,null),R[E.Info]=(0,C.localize)(2,null);function S(p){return R[p]||""}E.toString=S;function u(p){switch(p){case f.default.Error:return E.Error;case f.default.Warning:return E.Warning;case f.default.Info:return E.Info;case f.default.Ignore:return E.Hint}}E.fromSeverity=u;function b(p){switch(p){case E.Error:return f.default.Error;case E.Warning:return f.default.Warning;case E.Info:return f.default.Info;case E.Hint:return f.default.Ignore}}E.toSeverity=b}(A||(e.MarkerSeverity=A={}));var c;(function(E){const d="";function R(u){return S(u,!0)}E.makeKey=R;function S(u,b){const p=[d];return u.source?p.push(u.source.replace("\xA6","\\\xA6")):p.push(d),u.code?typeof u.code=="string"?p.push(u.code.replace("\xA6","\\\xA6")):p.push(u.code.value.replace("\xA6","\\\xA6")):p.push(d),u.severity!==void 0&&u.severity!==null?p.push(A.toString(u.severity)):p.push(d),u.message&&b?p.push(u.message.replace("\xA6","\\\xA6")):p.push(d),u.startLineNumber!==void 0&&u.startLineNumber!==null?p.push(u.startLineNumber.toString()):p.push(d),u.startColumn!==void 0&&u.startColumn!==null?p.push(u.startColumn.toString()):p.push(d),u.endLineNumber!==void 0&&u.endLineNumber!==null?p.push(u.endLineNumber.toString()):p.push(d),u.endColumn!==void 0&&u.endColumn!==null?p.push(u.endColumn.toString()):p.push(d),p.push(d),p.join("\xA6")}E.makeKeyOptionalMessage=S})(c||(e.IMarkerData=c={})),e.$et=(0,I.$Qh)("markerService")}),define(Ae[176],Re([1,0,5,29,4]),function(ee,e,f,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7u=e.$6u=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$5u=e.Severity=void 0,e.Severity=C.default,e.$5u=(0,I.$Qh)("notificationService");var O;(function(R){R[R.DEFAULT=0]="DEFAULT",R[R.SILENT=1]="SILENT",R[R.URGENT=2]="URGENT"})(O||(e.NotificationPriority=O={}));var A;(function(R){R[R.WORKSPACE=0]="WORKSPACE",R[R.PROFILE=1]="PROFILE",R[R.APPLICATION=2]="APPLICATION"})(A||(e.NeverShowAgainScope=A={}));var c;(function(R){R[R.OFF=0]="OFF",R[R.SILENT=1]="SILENT",R[R.ERROR=2]="ERROR"})(c||(e.NotificationsFilter=c={}));class E{constructor(){this.progress=new d,this.onDidClose=f.Event.None,this.onDidChangeVisibility=f.Event.None}updateSeverity(S){}updateMessage(S){}updateActions(S){}close(){}}e.$6u=E;class d{infinite(){}done(){}total(S){}worked(S){}}e.$7u=d}),define(Ae[95],Re([1,0,16,2,4]),function(ee,e,f,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zU=e.$yU=e.$xU=e.$wU=e.$vU=void 0,e.$vU=(0,I.$Qh)("openerService");function O(d,R){return C.URI.isUri(d)?(0,f.$3e)(d.scheme,R):(0,f.$4e)(d,R+":")}e.$wU=O;function A(d,...R){return R.some(S=>O(d,S))}e.$xU=A;function c(d,R){return d.with({fragment:`${R.startLineNumber},${R.startColumn}${R.endLineNumber?`-${R.endLineNumber}${R.endColumn?`,${R.endColumn}`:""}`:""}`})}e.$yU=c;function E(d){let R;const S=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(d.fragment);return S&&(R={startLineNumber:parseInt(S[1]),startColumn:S[2]?parseInt(S[2]):1,endLineNumber:S[4]?parseInt(S[4]):void 0,endColumn:S[4]?S[5]?parseInt(S[5]):1:void 0},d=d.with({fragment:""})),{selection:R,uri:d}}e.$zU=E}),define(Ae[177],Re([1,0,4]),function(ee,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rj=e.$qj=void 0,e.$qj=(0,f.$Qh)("productService"),e.$rj="vscode://schemas/vscode-product"});var Ge=this&&this.__decorate||function(ee,e,f,C){var I=arguments.length,O=I<3?e:C===null?C=Object.getOwnPropertyDescriptor(e,f):C,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")O=Reflect.decorate(ee,e,f,C);else for(var c=ee.length-1;c>=0;c--)(A=ee[c])&&(O=(I<3?A(O):I>3?A(e,f,O):A(e,f))||O);return I>3&&O&&Object.defineProperty(e,f,O),O},qe=this&&this.__param||function(ee,e){return function(f,C){e(f,C,ee)}};define(Ae[52],Re([1,0,12,19,6,4]),function(ee,e,f,C,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bv=e.$av=e.$_u=e.$$u=e.$0u=e.$9u=e.ProgressLocation=e.$8u=void 0,e.$8u=(0,O.$Qh)("progressService");var A;(function(S){S[S.Explorer=1]="Explorer",S[S.Scm=3]="Scm",S[S.Extensions=5]="Extensions",S[S.Window=10]="Window",S[S.Notification=15]="Notification",S[S.Dialog=20]="Dialog"})(A||(e.ProgressLocation=A={})),e.$9u=Object.freeze({total(){},worked(){},done(){}});class c{get value(){return this.a}constructor(u){this.b=u}report(u){this.a=u,this.b(this.a)}}e.$0u=c,c.None=Object.freeze({report(){}});class E{get value(){return this.a}constructor(u){this.e=u}report(u){this.b?this.b.push(u):this.b=[u],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const u=this.b.shift();this.a=u,await this.e(this.a)}}finally{this.c=!1;const u=this.d;this.d=void 0,u?.()}}drain(){return this.c?new Promise(u=>{const b=this.d;this.d=()=>{b?.(),u()}}):Promise.resolve()}}e.$$u=E;let d=class extends I.$Sc{constructor(u,b){super(),this.a=new f.$dh,b.withProgress(u,p=>(this.b=p,this.c&&p.report(this.c),this.a.p)),this.B((0,I.$Qc)(()=>this.a.complete()))}report(u){this.b?this.b.report(u):this.c=u}};e.$_u=d,e.$_u=d=Ge([qe(1,e.$8u)],d);class R extends I.$Sc{constructor(u){super(),this.g=u,this.a=0,this.b=this.B(new I.$Rc)}start(u){this.stop();const b=++this.a,p=new C.$Yd;return this.f=setTimeout(()=>{b===this.a&&(this.c=this.g.show(!0))},u),this.b.add((0,I.$Qc)(()=>clearTimeout(this.f))),this.b.add((0,I.$Qc)(()=>p.cancel())),this.b.add((0,I.$Qc)(()=>this.c?this.c.done():void 0)),{id:b,token:p.token,stop:()=>this.h(b),isCurrent:()=>this.a===b}}stop(){this.h(this.a)}h(u){this.a===u&&this.b.clear()}}e.$av=R,e.$bv=(0,O.$Qh)("editorProgressService")}),define(Ae[30],Re([1,0,53,15]),function(ee,e,f,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ln=void 0;class I{constructor(){this.a=new Map}add(A,c){f.ok(C.$zf(A)),f.ok(C.$Bf(c)),f.ok(!this.a.has(A),"There is already an extension with this id"),this.a.set(A,c)}knows(A){return this.a.has(A)}as(A){return this.a.get(A)||null}}e.$ln=new I}),define(Ae[72],Re([1,0,5,30]),function(ee,e,f,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mn=void 0,e.$mn={JSONContribution:"base.contributions.json"};function I(c){return c.length>0&&c.charAt(c.length-1)==="#"?c.substring(0,c.length-1):c}class O{constructor(){this.b=new f.$Od,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(E,d){this.a[I(E)]=d,this.b.fire(E)}notifySchemaChanged(E){this.b.fire(E)}getSchemaContributions(){return{schemas:this.a}}}const A=new O;C.$ln.add(e.$mn.JSONContribution,A)}),define(Ae[96],Re([1,0,18,5,15,137,45,72,30]),function(ee,e,f,C,I,O,A,c,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fn=e.$En=e.$Dn=e.$Cn=e.$Bn=e.$An=e.$zn=e.$yn=e.$xn=e.$wn=e.$vn=e.$un=e.$tn=e.$sn=e.$rn=e.ConfigurationScope=e.$qn=e.EditPresentationTypes=void 0;var d;(function(m){m.Multiline="multilineText",m.Singleline="singlelineText"})(d||(e.EditPresentationTypes=d={})),e.$qn={Configuration:"base.contributions.configuration"};var R;(function(m){m[m.APPLICATION=1]="APPLICATION",m[m.MACHINE=2]="MACHINE",m[m.WINDOW=3]="WINDOW",m[m.RESOURCE=4]="RESOURCE",m[m.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",m[m.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(R||(e.ConfigurationScope=R={})),e.$rn={properties:{},patternProperties:{}},e.$sn={properties:{},patternProperties:{}},e.$tn={properties:{},patternProperties:{}},e.$un={properties:{},patternProperties:{}},e.$vn={properties:{},patternProperties:{}},e.$wn={properties:{},patternProperties:{}},e.$xn="vscode://schemas/settings/resourceLanguage",e.$yn="vscode://schemas/settings/configurationDefaults";const S=E.$ln.as(c.$mn.JSONContribution);class u{constructor(){this.h=new Set,this.i=new C.$Od,this.onDidSchemaChange=this.i.event,this.j=new C.$Od,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:O.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},S.registerSchema(e.$xn,this.g),this.v()}registerConfiguration(n,r=!0){this.registerConfigurations([n],r)}registerConfigurations(n,r=!0){const s=new Set;this.n(n,r,s),S.registerSchema(e.$xn,this.g),this.i.fire(),this.j.fire({properties:s})}deregisterConfigurations(n){const r=new Set;this.o(n,r),S.registerSchema(e.$xn,this.g),this.i.fire(),this.j.fire({properties:r})}updateConfigurations({add:n,remove:r}){const s=new Set;this.o(r,s),this.n(n,!1,s),S.registerSchema(e.$xn,this.g),this.i.fire(),this.j.fire({properties:s})}registerDefaultConfigurations(n){const r=new Set;this.k(n,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}k(n,r){const s=[];for(const{overrides:o,source:$}of n)for(const a in o)if(r.add(a),e.$An.test(a)){const k=this.a.get(a),P=k?.valuesSources??new Map;if($)for(const M of Object.keys(o[a]))P.set(M,$);const h={...k?.value||{},...o[a]};this.a.set(a,{source:$,value:h,valuesSources:P});const w=(0,A.$ui)(a),y={type:"object",default:h,description:O.localize(1,null,w),$ref:e.$xn,defaultDefaultValue:h,source:I.$zf($)?void 0:$,defaultValueSource:$};s.push(...g(a)),this.d[a]=y,this.b.properties[a]=y}else{this.a.set(a,{value:o[a],source:$});const k=this.d[a];k&&(this.w(a,k),this.r(a,k))}this.m(s)}deregisterDefaultConfigurations(n){const r=new Set;this.l(n,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}l(n,r){for(const{overrides:s,source:o}of n)for(const $ in s){const a=this.a.get($),k=I.$zf(o)?o:o?.id,P=I.$zf(a?.source)?a?.source:a?.source?.id;if(k===P)if(r.add($),this.a.delete($),e.$An.test($))delete this.d[$],delete this.b.properties[$];else{const h=this.d[$];h&&(this.w($,h),this.r($,h))}}this.u()}deltaConfiguration(n){let r=!1;const s=new Set;n.removedDefaults&&(this.l(n.removedDefaults,s),r=!0),n.addedDefaults&&(this.k(n.addedDefaults,s),r=!0),n.removedConfigurations&&this.o(n.removedConfigurations,s),n.addedConfigurations&&this.n(n.addedConfigurations,!1,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:r})}notifyConfigurationSchemaUpdated(...n){this.i.fire()}registerOverrideIdentifiers(n){this.m(n),this.i.fire()}m(n){for(const r of n)this.h.add(r);this.u()}n(n,r,s){n.forEach(o=>{this.p(o,r,o.extensionInfo,o.restrictedProperties,void 0,s),this.c.push(o),this.q(o)})}o(n,r){const s=o=>{if(o.properties)for(const $ in o.properties){r.add($);const a=this.d[$];a?.policy?.name&&this.e.delete(a.policy.name),delete this.d[$],this.s($,o.properties[$])}o.allOf?.forEach($=>s($))};for(const o of n){s(o);const $=this.c.indexOf(o);$!==-1&&this.c.splice($,1)}}p(n,r=!0,s,o,$=3,a){$=I.$If(n.scope)?$:n.scope;const k=n.properties;if(k)for(const h in k){const w=k[h];if(r&&v(h,w)){delete k[h];continue}if(w.source=s,w.defaultDefaultValue=k[h].default,this.w(h,w),e.$An.test(h)?w.scope=void 0:(w.scope=I.$If(w.scope)?$:w.scope,w.restricted=I.$If(w.restricted)?!!o?.includes(h):w.restricted),k[h].hasOwnProperty("included")&&!k[h].included){this.f[h]=k[h],delete k[h];continue}else this.d[h]=k[h],k[h].policy?.name&&this.e.set(k[h].policy.name,h);!k[h].deprecationMessage&&k[h].markdownDeprecationMessage&&(k[h].deprecationMessage=k[h].markdownDeprecationMessage),a.add(h)}const P=n.allOf;if(P)for(const h of P)this.p(h,r,s,o,$,a)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(n){const r=s=>{const o=s.properties;if(o)for(const a in o)this.r(a,o[a]);s.allOf?.forEach(r)};r(n)}r(n,r){switch(e.$rn.properties[n]=r,r.scope){case 1:e.$sn.properties[n]=r;break;case 2:e.$tn.properties[n]=r;break;case 6:e.$un.properties[n]=r;break;case 3:e.$vn.properties[n]=r;break;case 4:e.$wn.properties[n]=r;break;case 5:e.$wn.properties[n]=r,this.g.properties[n]=r;break}}s(n,r){switch(delete e.$rn.properties[n],r.scope){case 1:delete e.$sn.properties[n];break;case 2:delete e.$tn.properties[n];break;case 6:delete e.$un.properties[n];break;case 3:delete e.$vn.properties[n];break;case 4:case 5:delete e.$wn.properties[n],delete this.g.properties[n];break}}u(){for(const n of this.h.values()){const r=`[${n}]`,s={type:"object",description:O.localize(2,null),errorMessage:O.localize(3,null),$ref:e.$xn};this.w(r,s),e.$rn.properties[r]=s,e.$sn.properties[r]=s,e.$tn.properties[r]=s,e.$un.properties[r]=s,e.$vn.properties[r]=s,e.$wn.properties[r]=s}}v(){const n={type:"object",description:O.localize(4,null),errorMessage:O.localize(5,null),$ref:e.$xn};e.$rn.patternProperties[e.$zn]=n,e.$sn.patternProperties[e.$zn]=n,e.$tn.patternProperties[e.$zn]=n,e.$un.patternProperties[e.$zn]=n,e.$vn.patternProperties[e.$zn]=n,e.$wn.patternProperties[e.$zn]=n,this.i.fire()}w(n,r){const s=this.a.get(n);let o=s?.value,$=s?.source;I.$Gf(o)&&(o=r.defaultDefaultValue,$=void 0),I.$Gf(o)&&(o=i(r.type)),r.default=o,r.defaultValueSource=$}}const b="\\[([^\\]]+)\\]",p=new RegExp(b,"g");e.$zn=`^(${b})+$`,e.$An=new RegExp(e.$zn);function g(m){const n=[];if(e.$An.test(m)){let r=p.exec(m);for(;r?.length;){const s=r[1].trim();s&&n.push(s),r=p.exec(m)}}return(0,f.$Mb)(n)}e.$Bn=g;function t(m){return m.reduce((n,r)=>`${n}[${r}]`,"")}e.$Cn=t;function i(m){switch(Array.isArray(m)?m[0]:m){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$Dn=i;const l=new u;E.$ln.add(e.$qn.Configuration,l);function v(m,n){return m.trim()?e.$An.test(m)?O.localize(7,null,m):l.getConfigurationProperties()[m]!==void 0?O.localize(8,null,m):n.policy?.name&&l.getPolicyConfigurations().get(n.policy?.name)!==void 0?O.localize(9,null,m,n.policy?.name,l.getPolicyConfigurations().get(n.policy?.name)):null:O.localize(6,null)}e.$En=v;function D(){const m=[],n=l.getConfigurationProperties();for(const r of Object.keys(n))m.push([r,n[r].scope]);return m.push(["launch",4]),m.push(["task",4]),m}e.$Fn=D}),define(Ae[178],Re([1,0,18,5,115,6,28,25,15,2,45,96,30]),function(ee,e,f,C,I,O,A,c,E,d,R,S,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ln=e.$Kn=e.$Jn=e.$In=e.$Hn=e.$Gn=void 0;function b(r){return Object.isFrozen(r)?r:c.$0m(r)}class p{constructor(s={},o=[],$=[],a){this.b=s,this.c=o,this.d=$,this.raw=a,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const s=this.raw.map(o=>{if(o instanceof p)return o;const $=new g("");return $.parseRaw(o),$.configurationModel});this.f=s.reduce((o,$)=>$===o?$:o.merge($),s[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(s){return s?(0,R.$si)(this.contents,s):this.contents}inspect(s,o){const $=this.rawConfiguration.getValue(s),a=o?this.rawConfiguration.getOverrideValue(s,o):void 0,k=o?this.rawConfiguration.override(o).getValue(s):$;return{value:$,override:a,merged:k}}getOverrideValue(s,o){const $=this.i(o);return $?s?(0,R.$si)($,s):$:void 0}getKeysForOverrideIdentifier(s){const o=[];for(const $ of this.overrides)$.identifiers.includes(s)&&o.push(...$.keys);return f.$Mb(o)}getAllOverrideIdentifiers(){const s=[];for(const o of this.overrides)s.push(...o.identifiers);return f.$Mb(s)}override(s){let o=this.a.get(s);return o||(o=this.g(s),this.a.set(s,o)),o}merge(...s){const o=c.$9m(this.contents),$=c.$9m(this.overrides),a=[...this.keys],k=this.raw?.length?[...this.raw]:[this];for(const P of s)if(k.push(...P.raw?.length?P.raw:[P]),!P.isEmpty()){this.h(o,P.contents);for(const h of P.overrides){const[w]=$.filter(y=>f.$ub(y.identifiers,h.identifiers));w?(this.h(w.contents,h.contents),w.keys.push(...h.keys),w.keys=f.$Mb(w.keys)):$.push(c.$9m(h))}for(const h of P.keys)a.indexOf(h)===-1&&a.push(h)}return new p(o,a,$,k.every(P=>P instanceof p)?void 0:k)}g(s){const o=this.i(s);if(!o||typeof o!="object"||!Object.keys(o).length)return this;const $={};for(const a of f.$Mb([...Object.keys(this.contents),...Object.keys(o)])){let k=this.contents[a];const P=o[a];P&&(typeof k=="object"&&typeof P=="object"?(k=c.$9m(k),this.h(k,P)):k=P),$[a]=k}return new p($,this.keys,this.overrides)}h(s,o){for(const $ of Object.keys(o)){if($ in s&&E.$Bf(s[$])&&E.$Bf(o[$])){this.h(s[$],o[$]);continue}s[$]=c.$9m(o[$])}}i(s){let o=null,$=null;const a=k=>{k&&($?this.h($,k):$=c.$9m(k))};for(const k of this.overrides)k.identifiers.length===1&&k.identifiers[0]===s?o=k.contents:k.identifiers.includes(s)&&a(k.contents);return a(o),$}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(s,o){this.j(s,o,!0)}setValue(s,o){this.j(s,o,!1)}removeValue(s){const o=this.keys.indexOf(s);o!==-1&&(this.keys.splice(o,1),(0,R.$ri)(this.contents,s),S.$An.test(s)&&this.overrides.splice(this.overrides.findIndex($=>f.$ub($.identifiers,(0,S.$Bn)(s))),1))}j(s,o,$){(0,R.$qi)(this.contents,s,o,a=>console.error(a)),$=$||this.keys.indexOf(s)===-1,$&&this.keys.push(s),S.$An.test(s)&&this.overrides.push({identifiers:(0,S.$Bn)(s),keys:Object.keys(this.contents[s]),contents:(0,R.$pi)(this.contents[s],a=>console.error(a))})}}e.$Gn=p;class g{constructor(s){this.f=s,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new p}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(s,o){if(!E.$If(s)){const $=this.g(s);this.parseRaw($,o)}}reparse(s){this.a&&this.parseRaw(this.a,s)}parseRaw(s,o){this.a=s;const{contents:$,keys:a,overrides:k,restricted:P,hasExcludedProperties:h}=this.h(s,o);this.b=new p($,a,k,h?[s]:void 0),this.c=P||[]}g(s){let o={},$=null,a=[];const k=[],P=[];function h(y){Array.isArray(a)?a.push(y):$!==null&&(a[$]=y)}const w={onObjectBegin:()=>{const y={};h(y),k.push(a),a=y,$=null},onObjectProperty:y=>{$=y},onObjectEnd:()=>{a=k.pop()},onArrayBegin:()=>{const y=[];h(y),k.push(a),a=y,$=null},onArrayEnd:()=>{a=k.pop()},onLiteralValue:h,onError:(y,M,V)=>{P.push({error:y,offset:M,length:V})}};if(s)try{I.$6m(s,w),o=a[0]||{}}catch(y){console.error(`Error while parsing settings file ${this.f}: ${y}`),this.d=[y]}return o}h(s,o){const $=u.$ln.as(S.$qn.Configuration).getConfigurationProperties(),a=this.i(s,$,!0,o);s=a.raw;const k=(0,R.$pi)(s,w=>console.error(`Conflict in settings file ${this.f}: ${w}`)),P=Object.keys(s),h=this.j(s,w=>console.error(`Conflict in settings file ${this.f}: ${w}`));return{contents:k,keys:P,overrides:h,restricted:a.restricted,hasExcludedProperties:a.hasExcludedProperties}}i(s,o,$,a){let k=!1;if(!a?.scopes&&!a?.skipRestricted&&!a?.exclude?.length)return{raw:s,restricted:[],hasExcludedProperties:k};const P={},h=[];for(const w in s)if(S.$An.test(w)&&$){const y=this.i(s[w],o,!1,a);P[w]=y.raw,k=k||y.hasExcludedProperties,h.push(...y.restricted)}else{const y=o[w],M=y?typeof y.scope<"u"?y.scope:3:void 0;y?.restricted&&h.push(w),!a.exclude?.includes(w)&&(a.include?.includes(w)||(M===void 0||a.scopes===void 0||a.scopes.includes(M))&&!(a.skipRestricted&&y?.restricted))?P[w]=s[w]:k=!0}return{raw:P,restricted:h,hasExcludedProperties:k}}j(s,o){const $=[];for(const a of Object.keys(s))if(S.$An.test(a)){const k={};for(const P in s[a])k[P]=s[a][P];$.push({identifiers:(0,S.$Bn)(a),keys:Object.keys(k),contents:(0,R.$pi)(k,o)})}return $}}e.$Hn=g;class t extends O.$Sc{constructor(s,o,$,a){super(),this.c=s,this.f=o,this.g=a,this.b=this.B(new C.$Od),this.onDidChange=this.b.event,this.a=new g(this.c.toString()),this.B(this.g.watch($.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(C.Event.any(C.Event.filter(this.g.onDidFilesChange,k=>k.contains(this.c)),C.Event.filter(this.g.onDidRunOperation,k=>(k.isOperation(0)||k.isOperation(3)||k.isOperation(1)||k.isOperation(4))&&$.isEqual(k.resource,s)))(()=>this.b.fire()))}async loadConfiguration(){try{const s=await this.g.readFile(this.c);return this.a.parse(s.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new p}}reparse(s){return s&&(this.f=s),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$In=t;class i{constructor(s,o,$,a,k,P,h,w,y,M,V,B,z){this.a=s,this.b=o,this.c=$,this.overrideIdentifiers=a,this.d=k,this.f=P,this.g=h,this.h=w,this.i=y,this.j=M,this.k=V,this.l=B,this.m=z}get value(){return b(this.c)}n(s,o,$){const a=s.inspect(o,$);return{get value(){return b(a.value)},get override(){return b(a.override)},get merged(){return b(a.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class l{constructor(s,o,$,a,k=new p,P=new p,h=new A.$Ac,w=new p,y=new A.$Ac){this.c=s,this.d=o,this.f=$,this.g=a,this.h=k,this.i=P,this.j=h,this.l=w,this.m=y,this.a=null,this.b=new A.$Ac,this.n=null}getValue(s,o,$){return this.q(s,o,$).getValue(s)}updateValue(s,o,$={}){let a;$.resource?(a=this.m.get($.resource),a||(a=new p,this.m.set($.resource,a))):a=this.l,o===void 0?a.removeValue(s):a.setValue(s,o),$.resource||(this.a=null)}inspect(s,o,$){const a=this.q(s,o,$),k=this.u(o.resource,$),P=o.resource?this.m.get(o.resource)||this.l:this.l,h=new Set;for(const w of a.overrides)for(const y of w.identifiers)a.getOverrideValue(s,y)!==void 0&&h.add(y);return new i(s,o,a.getValue(s),h.size?[...h]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,$?this.i:void 0,k||void 0,P)}keys(s){const o=this.u(void 0,s);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:o?o.keys.slice(0):[]}}updateDefaultConfiguration(s){this.c=s,this.a=null,this.b.clear()}updatePolicyConfiguration(s){this.d=s}updateApplicationConfiguration(s){this.f=s,this.a=null,this.b.clear()}updateLocalUserConfiguration(s){this.g=s,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(s){this.h=s,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(s){this.i=s,this.a=null,this.b.clear()}updateFolderConfiguration(s,o){this.j.set(s,o),this.b.delete(s)}deleteFolderConfiguration(s){this.p.delete(s),this.b.delete(s)}compareAndUpdateDefaultConfiguration(s,o){const $=[];if(!o){const{added:a,updated:k,removed:P}=m(this.c,s);o=[...a,...k,...P]}for(const a of o)for(const k of(0,S.$Bn)(a)){const P=this.c.getKeysForOverrideIdentifier(k),h=s.getKeysForOverrideIdentifier(k),w=[...h.filter(y=>P.indexOf(y)===-1),...P.filter(y=>h.indexOf(y)===-1),...P.filter(y=>!c.$an(this.c.override(k).getValue(y),s.override(k).getValue(y)))];$.push([k,w])}return this.updateDefaultConfiguration(s),{keys:o,overrides:$}}compareAndUpdatePolicyConfiguration(s){const{added:o,updated:$,removed:a}=m(this.d,s),k=[...o,...$,...a];return k.length&&this.updatePolicyConfiguration(s),{keys:k,overrides:[]}}compareAndUpdateApplicationConfiguration(s){const{added:o,updated:$,removed:a,overrides:k}=m(this.applicationConfiguration,s),P=[...o,...$,...a];return P.length&&this.updateApplicationConfiguration(s),{keys:P,overrides:k}}compareAndUpdateLocalUserConfiguration(s){const{added:o,updated:$,removed:a,overrides:k}=m(this.localUserConfiguration,s),P=[...o,...$,...a];return P.length&&this.updateLocalUserConfiguration(s),{keys:P,overrides:k}}compareAndUpdateRemoteUserConfiguration(s){const{added:o,updated:$,removed:a,overrides:k}=m(this.remoteUserConfiguration,s),P=[...o,...$,...a];return P.length&&this.updateRemoteUserConfiguration(s),{keys:P,overrides:k}}compareAndUpdateWorkspaceConfiguration(s){const{added:o,updated:$,removed:a,overrides:k}=m(this.workspaceConfiguration,s),P=[...o,...$,...a];return P.length&&this.updateWorkspaceConfiguration(s),{keys:P,overrides:k}}compareAndUpdateFolderConfiguration(s,o){const $=this.p.get(s),{added:a,updated:k,removed:P,overrides:h}=m($,o),w=[...a,...k,...P];return(w.length||!$)&&this.updateFolderConfiguration(s,o),{keys:w,overrides:h}}compareAndDeleteFolderConfiguration(s){const o=this.p.get(s);if(!o)throw new Error("Unknown folder");this.deleteFolderConfiguration(s);const{added:$,updated:a,removed:k,overrides:P}=m(o,void 0);return{keys:[...$,...a,...k],overrides:P}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(s,o,$){let a=this.r(o,$);return o.overrideIdentifier&&(a=a.override(o.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(s)!==void 0&&(a=a.merge(this.d)),a}r({resource:s},o){let $=this.s();if(o&&s){const a=o.getFolder(s);a&&($=this.t(a.uri)||$);const k=this.m.get(s);k&&($=$.merge(k))}return $}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(s){let o=this.b.get(s);if(!o){const $=this.s(),a=this.j.get(s);a?(o=$.merge(a),this.b.set(s,o)):o=$}return o}u(s,o){if(o&&s){const $=o.getFolder(s);if($)return this.j.get($.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((s,o)=>{const{contents:$,overrides:a,keys:k}=this.j.get(o);return s.push([o,{contents:$,overrides:a,keys:k}]),s},[])}}allKeys(){const s=new Set;return this.c.keys.forEach(o=>s.add(o)),this.userConfiguration.keys.forEach(o=>s.add(o)),this.i.keys.forEach(o=>s.add(o)),this.j.forEach(o=>o.keys.forEach($=>s.add($))),[...s.values()]}v(){const s=new Set;return this.c.getAllOverrideIdentifiers().forEach(o=>s.add(o)),this.userConfiguration.getAllOverrideIdentifiers().forEach(o=>s.add(o)),this.i.getAllOverrideIdentifiers().forEach(o=>s.add(o)),this.j.forEach(o=>o.getAllOverrideIdentifiers().forEach($=>s.add($))),[...s.values()]}w(s){const o=new Set;return this.c.getKeysForOverrideIdentifier(s).forEach($=>o.add($)),this.userConfiguration.getKeysForOverrideIdentifier(s).forEach($=>o.add($)),this.i.getKeysForOverrideIdentifier(s).forEach($=>o.add($)),this.j.forEach($=>$.getKeysForOverrideIdentifier(s).forEach(a=>o.add(a))),[...o.values()]}static parse(s){const o=this.x(s.defaults),$=this.x(s.policy),a=this.x(s.application),k=this.x(s.user),P=this.x(s.workspace),h=s.folders.reduce((w,y)=>(w.set(d.URI.revive(y[0]),this.x(y[1])),w),new A.$Ac);return new l(o,$,a,k,new p,P,h,new p,new A.$Ac)}static x(s){return new p(s.contents,s.keys,s.overrides)}}e.$Jn=l;function v(...r){if(r.length===0)return{keys:[],overrides:[]};if(r.length===1)return r[0];const s=new Set,o=new Map;for(const a of r)a.keys.forEach(k=>s.add(k)),a.overrides.forEach(([k,P])=>{const h=(0,A.$xc)(o,k,new Set);P.forEach(w=>h.add(w))});const $=[];return o.forEach((a,k)=>$.push([k,[...a.values()]])),{keys:[...s.values()],overrides:$}}e.$Kn=v;class D{constructor(s,o,$,a){this.change=s,this.f=o,this.g=$,this.h=a,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const k of s.keys)this.affectedKeys.add(k);for(const[,k]of s.overrides)for(const P of k)this.affectedKeys.add(P);this.d=this.a;for(const k of this.affectedKeys)this.d+=k+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=l.parse(this.f.data)),this.i}affectsConfiguration(s,o){const $=this.a+s,a=this.d.indexOf($);if(a<0)return!1;const k=a+$.length;if(k>=this.d.length)return!1;const P=this.d.charCodeAt(k);if(P!==this.b&&P!==this.c)return!1;if(o){const h=this.previousConfiguration?this.previousConfiguration.getValue(s,o,this.f?.workspace):void 0,w=this.g.getValue(s,o,this.h);return!c.$an(h,w)}return!0}}e.$Ln=D;function m(r,s){const{added:o,removed:$,updated:a}=n(s?.rawConfiguration,r?.rawConfiguration),k=[],P=r?.getAllOverrideIdentifiers()||[],h=s?.getAllOverrideIdentifiers()||[];if(s){const w=h.filter(y=>!P.includes(y));for(const y of w)k.push([y,s.getKeysForOverrideIdentifier(y)])}if(r){const w=P.filter(y=>!h.includes(y));for(const y of w)k.push([y,r.getKeysForOverrideIdentifier(y)])}if(s&&r){for(const w of P)if(h.includes(w)){const y=n({contents:r.getOverrideValue(void 0,w)||{},keys:r.getKeysForOverrideIdentifier(w)},{contents:s.getOverrideValue(void 0,w)||{},keys:s.getKeysForOverrideIdentifier(w)});k.push([w,[...y.added,...y.removed,...y.updated]])}}return{added:o,removed:$,updated:a,overrides:k}}function n(r,s){const o=r?s?r.keys.filter(k=>s.keys.indexOf(k)===-1):[...r.keys]:[],$=s?r?s.keys.filter(k=>r.keys.indexOf(k)===-1):[...s.keys]:[],a=[];if(r&&s){for(const k of s.keys)if(r.keys.indexOf(k)!==-1){const P=(0,R.$si)(s.contents,k),h=(0,R.$si)(r.contents,k);c.$an(P,h)||a.push(k)}}return{added:o,removed:$,updated:a}}}),define(Ae[97],Re([1,0,11,4]),function(ee,e,f,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uk=e.$Tk=e.RemoteAuthorityResolverErrorCode=e.$Sk=e.$Rk=e.RemoteConnectionType=e.$Qk=void 0,e.$Qk=(0,C.$Qh)("remoteAuthorityResolverService");var I;(function(R){R[R.WebSocket=0]="WebSocket",R[R.Managed=1]="Managed"})(I||(e.RemoteConnectionType=I={}));class O{constructor(S){this.id=S,this.type=1}toString(){return`Managed(${this.id})`}}e.$Rk=O;class A{constructor(S,u){this.host=S,this.port=u,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Sk=A;var c;(function(R){R.Unknown="Unknown",R.NotAvailable="NotAvailable",R.TemporarilyNotAvailable="TemporarilyNotAvailable",R.NoResolverFound="NoResolverFound",R.InvalidAuthority="InvalidAuthority"})(c||(e.RemoteAuthorityResolverErrorCode=c={}));class E extends f.$bb{static isNotAvailable(S){return S instanceof E&&S._code===c.NotAvailable}static isTemporarilyNotAvailable(S){return S instanceof E&&S._code===c.TemporarilyNotAvailable}static isNoResolverFound(S){return S instanceof E&&S._code===c.NoResolverFound}static isInvalidAuthority(S){return S instanceof E&&S._code===c.InvalidAuthority}static isHandled(S){return S instanceof E&&S.isHandled}constructor(S,u=c.Unknown,b){super(S),this._message=S,this._code=u,this._detail=b,this.isHandled=u===c.NotAvailable&&b===!0,Object.setPrototypeOf(this,E.prototype)}}e.$Tk=E;function d(R){const S=R.indexOf("+");return S===-1?R:R.substring(0,S)}e.$Uk=d}),define(Ae[54],Re([1,0,13]),function(ee,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zk=e.$Yk=e.$Xk=e.$Wk=e.$Vk=void 0;function C(d){return d.scheme===f.Schemas.vscodeRemote?d.authority:void 0}e.$Vk=C;function I(d){if(!d)return;const R=d.indexOf("+");return R<0?d:d.substr(0,R)}e.$Wk=I;function O(d){return`/${d.quality??"oss"}-${d.commit??"dev"}`}e.$Xk=O;function A(d){const{host:R,port:S}=E(d);if(typeof S>"u")throw new Error("Remote authority doesn't contain a port!");return{host:R,port:S}}e.$Yk=A;function c(d,R){let{host:S,port:u}=E(d);return typeof u>"u"&&(u=R),{host:S,port:u}}e.$Zk=c;function E(d){const R=d.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(R)return{host:R[1],port:parseInt(R[2],10)};const S=d.match(/^(\[[0-9a-z:]+\])$/);if(S)return{host:S[1],port:void 0};const u=d.match(/(.*):(\d+)$/);return u?{host:u[1],port:parseInt(u[2],10)}:{host:d,port:void 0}}}),define(Ae[21],Re([1,0,16,4,54]),function(ee,e,f,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cm=e.$bm=e.$am=e.$_l=e.$$l=e.$0l=e.$9l=e.$8l=e.TargetPlatform=e.ExtensionType=e.$7l=e.$6l=e.$5l=e.$4l=e.$3l=e.$2l=void 0,e.$2l="extensions.user.cache",e.$3l="extensions.builtin.cache",e.$4l="undefined_publisher",e.$5l=["ui","workspace","web"];function O(g){if(typeof g=="object"&&g!==null&&g.supported!==!0)return g.description}e.$6l=O,e.$7l=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var A;(function(g){g[g.System=0]="System",g[g.User=1]="User"})(A||(e.ExtensionType=A={}));var c;(function(g){g.WIN32_X64="win32-x64",g.WIN32_ARM64="win32-arm64",g.LINUX_X64="linux-x64",g.LINUX_ARM64="linux-arm64",g.LINUX_ARMHF="linux-armhf",g.ALPINE_X64="alpine-x64",g.ALPINE_ARM64="alpine-arm64",g.DARWIN_X64="darwin-x64",g.DARWIN_ARM64="darwin-arm64",g.WEB="web",g.UNIVERSAL="universal",g.UNKNOWN="unknown",g.UNDEFINED="undefined"})(c||(e.TargetPlatform=c={}));class E{constructor(t){this.value=t,this._lower=t.toLowerCase()}static equals(t,i){if(typeof t>"u"||t===null)return typeof i>"u"||i===null;if(typeof i>"u"||i===null)return!1;if(typeof t=="string"||typeof i=="string"){const l=typeof t=="string"?t:t.value,v=typeof i=="string"?i:i.value;return f.$3e(l,v)}return t._lower===i._lower}static toKey(t){return typeof t=="string"?t.toLowerCase():t._lower}}e.$8l=E;class d{get size(){return this.c.size}constructor(t){if(this.c=new Set,t)for(const i of t)this.add(i)}add(t){this.c.add(E.toKey(t))}delete(t){return this.c.delete(E.toKey(t))}has(t){return this.c.has(E.toKey(t))}}e.$9l=d;class R{constructor(){this.c=new Map}clear(){this.c.clear()}delete(t){this.c.delete(E.toKey(t))}get(t){return this.c.get(E.toKey(t))}has(t){return this.c.has(E.toKey(t))}set(t,i){this.c.set(E.toKey(t),i)}values(){return this.c.values()}forEach(t){this.c.forEach(t)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$0l=R;function S(g){return u(g)}e.$$l=S;function u(g){return g.contributes&&g.contributes.localizations?g.contributes.localizations.length>0:!1}e.$_l=u;function b(g){return g.contributes&&g.contributes.authentication?g.contributes.authentication.length>0:!1}e.$am=b;function p(g,t){if(t){const i=`onResolveRemoteAuthority:${(0,I.$Wk)(t)}`;return!!g.activationEvents?.includes(i)}return!1}e.$bm=p,e.$cm=(0,C.$Qh)("IBuiltinExtensionsScannerService")}),define(Ae[98],Re([1,0,11,21]),function(ee,e,f,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4E=e.$3E=void 0;class I{constructor(){this.a=new Map,this.b=new WeakMap}register(A,c){this.a.set(A,c)}readActivationEvents(A){return this.b.has(A)||this.b.set(A,this.c(A)),this.b.get(A)}createActivationEventsMap(A){const c=Object.create(null);for(const E of A){const d=this.readActivationEvents(E);d.length>0&&(c[C.$8l.toKey(E.identifier)]=d)}return c}c(A){if(typeof A.main>"u"&&typeof A.browser>"u")return[];const c=Array.isArray(A.activationEvents)?A.activationEvents.slice(0):[];if(!A.contributes)return c;for(const E in A.contributes){const d=this.a.get(E);if(!d)continue;const R=A.contributes[E],S=Array.isArray(R)?R:[R];try{d(S,c)}catch(u){(0,f.$1)(u)}}return c}}e.$3E=I,e.$4E=new I}),define(Ae[179],Re([1,0,23,73,37]),function(ee,e,f,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$no=e.$mo=void 0;function O(E){if(f.$o===2&&/^penguin(\.|$)/i.test(E))return"chromebook"}function A(E,d,R,S,u,b,p,g,t){const i=Object.create(null);i["common.machineId"]=b,i["common.sqmId"]=p,i.sessionID=(0,I.$fg)()+Date.now(),i.commitHash=S,i.version=u,i["common.platformVersion"]=(E||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),i["common.platform"]=(0,f.$c)(f.$o),i["common.nodePlatform"]=C.$dc,i["common.nodeArch"]=R,i["common.product"]=t||"desktop",g&&(i["common.msftInternal"]=g);let l=0;const v=Date.now();Object.defineProperties(i,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-v,enumerable:!0},"common.sequence":{get:()=>l++,enumerable:!0}}),f.$g&&(i["common.snap"]="true");const D=O(d);return D&&(i["common.platformDetail"]=D),i}e.$mo=A;function c(E){const d=C.env.USERDNSDOMAIN;if(!d)return!1;const R=d.toLowerCase();return E.some(S=>R===S)}e.$no=c}),define(Ae[180],Re([1,0,4]),function(ee,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$nl=e.$ml=e.$ll=e.$kl=e.$jl=e.$il=e.$hl=e.$gl=e.$fl=e.$el=e.$dl=void 0,e.$dl=(0,f.$Qh)("telemetryService"),e.$el=(0,f.$Qh)("customEndpointTelemetryService"),e.$fl="telemetry.currentSessionDate",e.$gl="telemetry.firstSessionDate",e.$hl="telemetry.lastSessionDate",e.$il="telemetry.machineId",e.$jl="telemetry.sqmId",e.$kl="telemetry",e.$ll="telemetry.telemetryLevel",e.$ml="telemetry.enableCrashReporter",e.$nl="telemetry.enableTelemetry";var C;(function(O){O[O.NONE=0]="NONE",O[O.CRASH=1]="CRASH",O[O.ERROR=2]="ERROR",O[O.USAGE=3]="USAGE"})(C||(e.TelemetryLevel=C={}));var I;(function(O){O.OFF="off",O.CRASH="crash",O.ERROR="error",O.ON="all"})(I||(e.TelemetryConfiguration=I={}))}),define(Ae[55],Re([1,0,25,15,5,45,54,179,180]),function(ee,e,f,C,I,O,A,c,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Do=e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=e.$oo=void 0;class d{constructor($){this.value=$,this.isTrustedTelemetryValue=!0}}e.$oo=d;class R{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$po=R,e.$qo=new R;class S{async publicLog($,a,k){}async publicLogError($,a,k){}}e.$ro=S,e.$so="telemetry",e.$to="extensionTelemetryLog",e.$uo={log:()=>null,flush:()=>Promise.resolve(null)};function u(o,$){return I.Event.debounce($.onDidChangeConfiguration,(k,P)=>{const h=k?new Set([...k.affectedKeys,...P.affectedKeys]):P.affectedKeys;return{...P,affectedKeys:h}},1e3,!0)(k=>{k.source!==7&&o.publicLog2("updateConfiguration",{configurationSource:(0,O.$ni)(k.source),configurationKeys:Array.from(k.affectedKeys)})})}e.$vo=u;function b(o,$){return!$.isBuilt&&!$.disableTelemetry?!0:!($.disableTelemetry||!o.enableTelemetry)}e.$wo=b;function p(o,$){return $.extensionTestsLocationURI?!0:!($.isBuilt||$.disableTelemetry||o.enableTelemetry&&o.aiConfig?.ariaKey)}e.$xo=p;function g(o){const $=o.getValue(E.$ll),a=o.getValue(E.$ml);if(o.getValue(E.$nl)===!1||a===!1)return 0;switch($??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$yo=g;function t(o){const $={},a={},k={};v(o,k);for(let P in k){P=P.length>150?P.substr(P.length-149):P;const h=k[P];typeof h=="number"?a[P]=h:typeof h=="boolean"?a[P]=h?1:0:typeof h=="string"?(h.length>8192&&console.warn(`Telemetry property: ${P} has been trimmed to 8192, the original length is ${h.length}`),$[P]=h.substring(0,8191)):typeof h<"u"&&h!==null&&($[P]=h)}return{properties:$,measurements:a}}e.$zo=t;const i=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function l(o){if(!o)return"none";const $=(0,A.$Wk)(o);return i.has($)?$:"other"}e.$Ao=l;function v(o,$,a=0,k){if(o)for(const P of Object.getOwnPropertyNames(o)){const h=o[P],w=k?k+P:P;Array.isArray(h)?$[w]=(0,f.$bn)(h):h instanceof Date?$[w]=h.toISOString():(0,C.$Bf)(h)?a<2?v(h,$,a+1,w+"."):$[w]=(0,f.$bn)(h):$[w]=h}}function D(o,$){const a=o.msftInternalDomains||[],k=$.getValue("telemetry.internalTesting");return(0,c.$no)(a)||k}e.$Bo=D;function m(o){return[o.appRoot,o.extensionsPath,o.userHome.fsPath,o.tmpDir.fsPath,o.userDataPath]}e.$Co=m;function n(o,$){if(!o||!o.includes("/")&&!o.includes("\\"))return o;let a=o;const k=[];for(const y of $)for(;;){const M=y.exec(o);if(!M)break;k.push([M.index,y.lastIndex])}const P=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,h=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let w=0;for(a="";;){const y=h.exec(o);if(!y)break;const M=k.some(([V,B])=>y.index<B&&V<h.lastIndex);!P.test(y[0])&&!M&&(a+=o.substring(w,y.index)+"<REDACTED: user-file-path>",w=h.lastIndex)}return w<o.length&&(a+=o.substr(w)),a}function r(o){if(!o)return o;const $=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const a of $)if(a.regex.test(o))return`<REDACTED: ${a.label}>`;return o}function s(o,$){return(0,f.$$m)(o,a=>{if(a instanceof d||Object.hasOwnProperty.call(a,"isTrustedTelemetryValue"))return a.value;if(typeof a=="string"){let k=a.replaceAll("%20"," ");k=n(k,$);for(const P of $)k=k.replace(P,"");return k=r(k),k}})}e.$Do=s}),define(Ae[181],Re([1,0,16,92,21,23,2,11,73,55]),function(ee,e,f,C,I,O,A,c,E,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Po=e.$Oo=e.$No=e.$Mo=e.$Lo=e.$Ko=e.$Jo=e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=void 0;function R(s,o){return s.uuid&&o.uuid?s.uuid===o.uuid:s.id===o.id?!0:(0,f.$Xe)(s.id,o.id)===0}e.$Eo=R;const S=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class u{static create(o){const $=o.manifest?o.manifest.version:o.version,a=o.manifest?o.targetPlatform:o.properties.targetPlatform;return new u(o.identifier,$,a)}static parse(o){const $=S.exec(o);return $&&$[1]&&$[2]?new u({id:$[1]},$[2],$[4]||void 0):null}constructor(o,$,a="undefined"){this.version=$,this.targetPlatform=a,this.id=o.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(o){return o instanceof u?R(this,o)&&this.version===o.version&&this.targetPlatform===o.targetPlatform:!1}}e.$Fo=u;const b=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function p(s){const o=b.exec(s);return o&&o[1]?[t(o[1]),o[2]]:[t(s),void 0]}e.$Go=p;function g(s,o){return`${s}.${o}`}e.$Ho=g;function t(s){return s.toLowerCase()}e.$Io=t;function i(s,o){return t(g(s??I.$4l,o))}e.$Jo=i;function l(s,o){const $=[],a=k=>{for(const P of $)if(P.some(h=>R(o(h),o(k))))return P;return null};for(const k of s){const P=a(k);P?P.push(k):$.push([k])}return $}e.$Ko=l;function v(s){return{id:s.identifier.id,name:s.manifest.name,galleryId:null,publisherId:s.publisherId,publisherName:s.manifest.publisher,publisherDisplayName:s.publisherDisplayName,dependencies:s.manifest.extensionDependencies&&s.manifest.extensionDependencies.length>0}}e.$Lo=v;function D(s){return{id:new d.$oo(s.identifier.id),name:new d.$oo(s.name),galleryId:s.identifier.uuid,publisherId:s.publisherId,publisherName:s.publisher,publisherDisplayName:s.publisherDisplayName,isPreReleaseVersion:s.properties.isPreReleaseVersion,dependencies:!!(s.properties.dependencies&&s.properties.dependencies.length>0),isSigned:s.isSigned,...s.telemetryData}}e.$Mo=D,e.$No=new I.$8l("pprice.better-merge");function m(s,o){const $=[],a=o.manifest.extensionDependencies?.slice(0)??[];for(;a.length;){const k=a.shift();if(k&&$.every(P=>!R(P.identifier,{id:k}))){const P=s.filter(h=>R(h.identifier,{id:k}));P.length===1&&($.push(P[0]),a.push(...P[0].manifest.extensionDependencies?.slice(0)??[]))}}return $}e.$Oo=m;async function n(s,o){if(!O.$f)return!1;let $;try{$=(await s.readFile(A.URI.file("/etc/os-release"))).value.toString()}catch{try{$=(await s.readFile(A.URI.file("/usr/lib/os-release"))).value.toString()}catch(k){o.debug("Error while getting the os-release file.",(0,c.$0)(k))}}return!!$&&($.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function r(s,o){const $=await n(s,o),a=(0,C.$$n)($?"alpine":O.$o,E.$ec);return o.debug("ComputeTargetPlatform:",a),a}e.$Po=r}),define(Ae[182],Re([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ur=e.$tr=e.$sr=e.$rr=e.$qr=e.$pr=void 0;function f(E){return[...E.entries()]}e.$pr=f;function C(E){return E?[...E.entries()]:[]}e.$qr=C;function I(E){return new Map(E)}e.$rr=I;function O(E){return new Map(E??[])}e.$sr=O;function A(E){return Array.from(E.entries()).map(d=>[d[0],f(d[1].map),C(d[1].descriptionMap)])}e.$tr=A;function c(E){return new Map(E.map(d=>[d[0],{map:I(d[1]),descriptionMap:O(d[2])}]))}e.$ur=c}),define(Ae[183],Re([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$clb=void 0;class f{constructor(I){this.b=I,this.a=new Map}dispose(){for(const I of this.a.values())I.dispose()}startBuffering(I,O,A=5){const c=O(E=>{const d=typeof E=="string"?E:E.data;let R=this.a.get(I);if(R){R.data.push(d);return}const S=setTimeout(()=>this.flushBuffer(I),A);R={data:[d],timeoutId:S,dispose:()=>{clearTimeout(S),this.flushBuffer(I),c.dispose()}},this.a.set(I,R)});return c}stopBuffering(I){this.a.get(I)?.dispose()}flushBuffer(I){const O=this.a.get(I);O&&(this.a.delete(I),this.b(I,O.data.join("")))}}e.$clb=f}),define(Ae[184],Re([1,0,12,89,44,5,15,2,144,72,30]),function(ee,e,f,C,I,O,A,c,E,d,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fw=e.$ew=e.$dw=e.$cw=e.$bw=e.$aw=e.$_v=e.$$v=e.IconFontDefinition=e.IconContribution=e.$0v=void 0,e.$0v={IconContribution:"base.contributions.icons"};var S;(function(D){function m(n,r){let s=n.defaults;for(;I.ThemeIcon.isThemeIcon(s);){const o=p.getIcon(s.id);if(!o)return;s=o.defaults}return s}D.getDefinition=m})(S||(e.IconContribution=S={}));var u;(function(D){function m(r){return{weight:r.weight,style:r.style,src:r.src.map(s=>({format:s.format,location:s.location.toString()}))}}D.toJSONObject=m;function n(r){const s=o=>(0,A.$zf)(o)?o:void 0;if(r&&Array.isArray(r.src)&&r.src.every(o=>(0,A.$zf)(o.format)&&(0,A.$zf)(o.location)))return{weight:s(r.weight),style:s(r.style),src:r.src.map(o=>({format:o.format,location:c.URI.parse(o.location)}))}}D.fromJSONObject=n})(u||(e.IconFontDefinition=u={}));class b{constructor(){this.a=new O.$Od,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,E.localize)(0,null)},fontCharacter:{type:"string",description:(0,E.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${I.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(m,n,r,s){const o=this.b[m];if(o){if(r&&!o.description){o.description=r,this.d.properties[m].markdownDescription=`${r} $(${m})`;const k=this.e.enum.indexOf(m);k!==-1&&(this.e.enumDescriptions[k]=r),this.a.fire()}return o}const $={id:m,description:r,defaults:n,deprecationMessage:s};this.b[m]=$;const a={$ref:"#/definitions/icons"};return s&&(a.deprecationMessage=s),r&&(a.markdownDescription=`${r}: $(${m})`),this.d.properties[m]=a,this.e.enum.push(m),this.e.enumDescriptions.push(r||""),this.a.fire(),{id:m}}deregisterIcon(m){delete this.b[m],delete this.d.properties[m];const n=this.e.enum.indexOf(m);n!==-1&&(this.e.enum.splice(n,1),this.e.enumDescriptions.splice(n,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(m=>this.b[m])}getIcon(m){return this.b[m]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(m,n){const r=this.f[m];return r||(this.f[m]=n,this.a.fire(),n)}deregisterIconFont(m){delete this.f[m]}getIconFont(m){return this.f[m]}toString(){const m=(o,$)=>o.id.localeCompare($.id),n=o=>{for(;I.ThemeIcon.isThemeIcon(o.defaults);)o=this.b[o.defaults.id];return`codicon codicon-${o?o.id:""}`},r=[];r.push("| preview     | identifier                        | default codicon ID                | description"),r.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const s=Object.keys(this.b).map(o=>this.b[o]);for(const o of s.filter($=>!!$.description).sort(m))r.push(`|<i class="${n(o)}"></i>|${o.id}|${I.ThemeIcon.isThemeIcon(o.defaults)?o.defaults.id:o.id}|${o.description||""}|`);r.push("| preview     | identifier                        "),r.push("| ----------- | --------------------------------- |");for(const o of s.filter($=>!I.ThemeIcon.isThemeIcon($.defaults)).sort(m))r.push(`|<i class="${n(o)}"></i>|${o.id}|`);return r.join(`
`)}}const p=new b;R.$ln.add(e.$0v.IconContribution,p);function g(D,m,n,r){return p.registerIcon(D,m,n,r)}e.$$v=g;function t(){return p}e.$_v=t;function i(){const D=(0,C.$Tj)();for(const m in D){const n="\\"+D[m].toString(16);p.registerIcon(m,{fontCharacter:n})}}i(),e.$aw="vscode://schemas/icons";const l=R.$ln.as(d.$mn.JSONContribution);l.registerSchema(e.$aw,p.getIconSchema());const v=new f.$7g(()=>l.notifySchemaChanged(e.$aw),200);p.onDidChange(()=>{v.isScheduled()||v.schedule()}),e.$bw=g("widget-close",C.$Vj.close,(0,E.localize)(2,null)),e.$cw=g("goto-previous-location",C.$Vj.arrowUp,(0,E.localize)(3,null)),e.$dw=g("goto-next-location",C.$Vj.arrowDown,(0,E.localize)(4,null)),e.$ew=I.ThemeIcon.modify(C.$Vj.sync,"spin"),e.$fw=I.ThemeIcon.modify(C.$Vj.loading,"spin")}),define(Ae[185],Re([1,0,5,45,4,14]),function(ee,e,f,C,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mv=e.$lv=e.$kv=e.$jv=e.$iv=e.$hv=e.$gv=e.$fv=e.ProvidedOnAutoForward=e.$ev=e.TunnelPrivacyId=e.TunnelProtocol=e.$dv=e.$cv=void 0,e.$cv=(0,I.$Qh)("tunnelService"),e.$dv=(0,I.$Qh)("sharedTunnelsService");var A;(function(t){t.Http="http",t.Https="https"})(A||(e.TunnelProtocol=A={}));var c;(function(t){t.ConstantPrivate="constantPrivate",t.Private="private",t.Public="public"})(c||(e.TunnelPrivacyId=c={}));function E(t){return!!t.forwardPort}e.$ev=E;var d;(function(t){t[t.Notify=1]="Notify",t[t.OpenBrowser=2]="OpenBrowser",t[t.OpenPreview=3]="OpenPreview",t[t.Silent=4]="Silent",t[t.Ignore=5]="Ignore",t[t.OpenBrowserOnce=6]="OpenBrowserOnce"})(d||(e.ProvidedOnAutoForward=d={}));function R(t){if(t.scheme!=="http"&&t.scheme!=="https")return;const i=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(t.authority);if(i)return{address:i[1],port:+i[2]}}e.$fv=R,e.$gv=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function S(t){return e.$gv.indexOf(t)>=0}e.$hv=S,e.$iv=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function u(t){return e.$iv.indexOf(t)>=0}e.$jv=u;function b(t,i,l,v){if(l===1)return!1;if(l===2&&u(i)){const D=/(\d+)\.(\d+)\.(\d+)/g.exec(v);if(D?.length===4&&parseInt(D[1])>=18)return!1}return t<1024}e.$kv=b;class p{constructor(i,l,v){this.remoteAddress=i,this.localAddress=l,this.b=v,this.a=new f.$Od,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$lv=p;let g=class{constructor(i,l){this.j=i,this.k=l,this.a=new f.$Od,this.onTunnelOpened=this.a.event,this.b=new f.$Od,this.onTunnelClosed=this.b.event,this.c=new f.$Od,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=[],this.i=new Set}get hasTunnelProvider(){return!!this.f}get l(){const i=this.k.getValue("remote.localPortHost");return!i||i==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(i){return this.f=i,i?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.h=[]}}):(this.g=!1,this.h=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(i){this.g=i.elevation,this.h=i.privacyOptions}get canElevate(){return this.g}get canChangePrivacy(){return this.h.length>0}get privacyOptions(){return this.h}get tunnels(){return this.m()}async m(){const i=[],l=Array.from(this.e.values());for(const v of l){const D=Array.from(v.values());for(const m of D){const n=await m.value;n&&typeof n!="string"&&i.push(n)}}return i}async dispose(){for(const i of this.e.values()){for(const{value:l}of i.values())await l.then(v=>typeof v!="string"?v?.dispose():void 0);i.clear()}this.e.clear()}setEnvironmentTunnel(i,l,v,D,m){this.p(i,l,Promise.resolve({tunnelRemoteHost:i,tunnelRemotePort:l,localAddress:v,privacy:D,protocol:m,dispose:()=>Promise.resolve()}))}async getExistingTunnel(i,l){(u(i)||S(i))&&(i=e.$gv[0]);const v=this.r(i,l);if(v)return++v.refcount,v.value}openTunnel(i,l,v,D,m,n=!1,r,s){this.j.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${l}:${v} on local port ${m}.`);const o=this.f??i;if(!o)return;if(l||(l="localhost"),D||(D=this.l),this.f&&this.i.has(v)){this.j.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const $=this.s(o,l,v,D,m,n,r,s);return $?$.then(a=>{if(a){if(typeof a=="string")return this.j.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.q(l,v),a}else{this.j.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.q(l,v);return}this.j.trace("ForwardedPorts: (TunnelService) New tunnel established.");const k=this.n(a);return(a.tunnelRemoteHost!==l||a.tunnelRemotePort!==v)&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),r&&a.privacy!==r&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(k),k}):(this.j.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),$)}n(i){return{tunnelRemotePort:i.tunnelRemotePort,tunnelRemoteHost:i.tunnelRemoteHost,tunnelLocalPort:i.tunnelLocalPort,localAddress:i.localAddress,privacy:i.privacy,protocol:i.protocol,dispose:async()=>{this.j.trace(`ForwardedPorts: (TunnelService) dispose request for ${i.tunnelRemoteHost}:${i.tunnelRemotePort} `);const l=this.e.get(i.tunnelRemoteHost);if(l){const v=l.get(i.tunnelRemotePort);v&&(v.refcount--,await this.o(i.tunnelRemoteHost,i.tunnelRemotePort,v))}}}}async o(i,l,v){if(v.refcount<=0){this.j.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${i}:${l}.`);const D=v.value.then(async m=>{m&&typeof m!="string"&&(await m.dispose(!0),this.b.fire({host:m.tunnelRemoteHost,port:m.tunnelRemotePort}))});return this.e.has(i)&&this.e.get(i).delete(l),D}}async closeTunnel(i,l){this.j.trace(`ForwardedPorts: (TunnelService) close request for ${i}:${l} `);const v=this.e.get(i);if(v&&v.has(l)){const D=v.get(l);D.refcount=0,await this.o(i,l,D)}}p(i,l,v){this.e.has(i)||this.e.set(i,new Map),this.e.get(i).set(l,{refcount:1,value:v})}async q(i,l){const v=this.e.get(i);if(v){const D=v.get(l),m=D?await D.value:void 0;(!m||typeof m=="string")&&v.delete(l),v.size===0&&this.e.delete(i)}}r(i,l){const v=[i];S(i)?(v.push(...e.$gv),v.push(...e.$iv)):u(i)&&v.push(...e.$iv);const D=v.map(m=>this.e.get(m));for(const m of D){const n=m?.get(l);if(n)return n}}canTunnel(i){return!!R(i)}t(i,l,v,D,m,n,r){this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${l}:${v} on local port ${D}.`);const s=v;this.i.add(s);const o=D===void 0?v:D,$={elevationRequired:m?this.isPortPrivileged(o):!1},a={remoteAddress:{host:l,port:v},localAddressPort:D,privacy:n,public:n?n!==c.Private:void 0,protocol:r},k=i.forwardPort(a,$);return k?(this.p(l,v,k),k.finally(()=>{this.j.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.i.delete(s)})):this.i.delete(s),k}};e.$mv=g,e.$mv=g=Ge([qe(0,O.$$i),qe(1,C.$ki)],g)}),define(Ae[186],Re([1,0,4]),function(ee,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$nv=void 0,e.$nv=(0,f.$Qh)("editSessionIdentityService");var C;(function(I){I[I.Complete=100]="Complete",I[I.Partial=50]="Partial",I[I.None=0]="None"})(C||(e.EditSessionIdentityMatch=C={}))}),define(Ae[187],Re([1,0,13]),function(ee,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4J=e.$3J=e.$2J=e.$1J=e.$ZJ=void 0;function C(E){return E.scheme!==f.Schemas.file&&E.scheme!==f.Schemas.vscodeRemote}e.$ZJ=C;function I(E){if(E.folders.length)return E.folders.every(d=>C(d.uri))?E.folders[0].uri:void 0;if(E.configuration&&C(E.configuration))return E.configuration}e.$1J=I;function O(E){return I(E)?.scheme}e.$2J=O;function A(E){return I(E)?.authority}e.$3J=A;function c(E){return I(E)!==void 0}e.$4J=c}),define(Ae[56],Re([1,0,145,20,50,24,2,4,13]),function(ee,e,f,C,I,O,A,c,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ji=e.$ii=e.$hi=e.$gi=e.$fi=e.$ei=e.$di=e.$ci=e.$bi=e.$ai=e.$_h=e.$$h=e.$0h=e.$9h=e.$8h=e.WorkbenchState=e.$7h=e.$6h=e.$5h=e.$4h=e.$3h=e.$2h=e.$1h=e.$Zh=void 0,e.$Zh=(0,c.$Qh)("contextService");function d(o){const $=o;return typeof $?.id=="string"&&A.URI.isUri($.uri)}e.$1h=d;function R(o){return typeof o?.id=="string"&&!d(o)&&!u(o)}e.$2h=R,e.$3h={id:"ext-dev"},e.$4h={id:"empty-window"};function S(o,$){if(typeof o=="string"||typeof o>"u")return typeof o=="string"?{id:(0,C.$nc)(o)}:$?e.$3h:e.$4h;const a=o;return a.configuration?{id:a.id,configPath:a.configuration}:a.folders.length===1?{id:a.id,uri:a.folders[0].uri}:{id:a.id}}e.$5h=S;function u(o){const $=o;return typeof $?.id=="string"&&A.URI.isUri($.configPath)}e.$6h=u;function b(o){const $=o;if($?.uri)return{id:$.id,uri:A.URI.revive($.uri)};const a=o;if(a?.configPath)return{id:a.id,configPath:A.URI.revive(a.configPath)};if(o?.id)return{id:o.id}}e.$7h=b;var p;(function(o){o[o.EMPTY=1]="EMPTY",o[o.FOLDER=2]="FOLDER",o[o.WORKSPACE=3]="WORKSPACE"})(p||(e.WorkbenchState=p={}));function g(o){const $=o;return!!($&&typeof $=="object"&&typeof $.id=="string"&&Array.isArray($.folders))}e.$8h=g;function t(o){const $=o;return!!($&&typeof $=="object"&&A.URI.isUri($.uri)&&typeof $.name=="string"&&typeof $.toResource=="function")}e.$9h=t;class i{constructor($,a,k,P,h){this.h=$,this.j=k,this.k=P,this.l=h,this.c=I.$Wh.forUris(this.l,()=>!0),this.folders=a}update($){this.h=$.id,this.k=$.configuration,this.j=$.transient,this.l=$.l,this.folders=$.folders}get folders(){return this.g}set folders($){this.g=$,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration($){this.k=$}getFolder($){return $&&this.c.findSubstr($)||null}n(){this.c=I.$Wh.forUris(this.l,()=>!0);for(const $ of this.folders)this.c.set($.uri,$)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$0h=i;class l{constructor($,a){this.raw=a,this.uri=$.uri,this.index=$.index,this.name=$.name}toResource($){return(0,O.$wg)(this.uri,$)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$$h=l;function v(o){return new l({uri:o,index:0,name:(0,O.$sg)(o)},{uri:o.toString()})}e.$_h=v,e.$ai="code-workspace",e.$bi=`.${e.$ai}`,e.$ci=[{name:(0,f.localize)(0,null),extensions:[e.$ai]}],e.$di="workspace.json";function D(o,$){return O.$ng.isEqualOrParent(o,$.untitledWorkspacesHome)}e.$ei=D;function m(o){let $;return A.URI.isUri(o)?$=o:$=o.configuration,$?.scheme===E.Schemas.tmp}e.$fi=m,e.$gi="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function n(o){return o.id===e.$gi}e.$hi=n;function r(o,$){return!D(o,$)&&!m(o)}e.$ii=r;function s(o){return(typeof o=="string"?(0,C.$oc)(o):(0,O.$ug)(o))===e.$bi}e.$ji=s}),define(Ae[74],Re([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ccc=void 0;class f{constructor(I){this.d=I,this.b=new Map,this.c=1}add(I){const O=this.c++;return this.b.set(O,I),this.e(),O}get(I,O){return this.b.has(I)?this.b.get(I)[O]:void 0}delete(I){this.b.delete(I),this.e()}e(){f.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$Ccc=f,f.a=!1}),define(Ae[40],Re([1,0,13,24,4]),function(ee,e,f,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fcc=e.$Ecc=void 0;class O{constructor(){this.a=new Set(Object.keys(f.Schemas)),this.b=new Map,this.extUri=new C.$lg(c=>{const E=this.b.get(c.scheme);return!(E===void 0||E&1024)})}$acceptProviderInfos(c,E){E===null?this.b.delete(c.scheme):this.b.set(c.scheme,E)}isFreeScheme(c){return!this.b.has(c)&&!this.a.has(c)}getCapabilities(c){return this.b.get(c)}}e.$Ecc=O,e.$Fcc=(0,I.$Qh)("IExtHostFileSystemInfo")}),define(Ae[27],Re([1,0,4]),function(ee,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HM=void 0,e.$HM=(0,f.$Qh)("IExtHostInitDataService")}),define(Ae[188],Re([1,0,151,14,175,27]),function(ee,e,f,C,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nec=void 0;let A=class extends I.$PN{constructor(E,d,R){const S=R.remote.isRemote?"remoteexthost":E?"workerexthost":"exthost",u=R.remote.isRemote?(0,f.localize)(0,null):E?(0,f.localize)(1,null):(0,f.localize)(2,null);super(d.createLogger(S,{name:u}))}};e.$Nec=A,e.$Nec=A=Ge([qe(1,C.$_i),qe(2,O.$HM)],A)}),define(Ae[189],Re([1,0,12]),function(ee,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9cc=e.$8cc=void 0;class C{constructor(A,c,E){this.h=new Map,this.a=A,this.b=c,this.c=E,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(d=>(this.f=d,this)),this.g=this.c.onDidChangeStorage(d=>{d.shared===this.b&&d.key===this.a&&(this.f=d.value)}),this.i=new f.$7g(()=>{const d=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const R of d.values())R.complete()}catch(R){for(const S of d.values())S.error(R)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,A])=>A!==void 0).map(([A])=>A)}get whenReady(){return this.d}get(A,c){let E=this.f[A];return typeof E>"u"&&(E=c),E}update(A,c){this.f[A]=c;const E=this.h.get(A);if(E!==void 0)return E.p;const d=new f.$dh;return this.h.set(A,d),this.i.isScheduled()||this.i.schedule(),d.p}dispose(){this.g.dispose()}}e.$8cc=C;class I extends C{setKeysForSync(A){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},A)}constructor(A,c){super(A.identifier.value,!0,c),this.j=A}}e.$9cc=I}),define(Ae[190],Re([1,0,5,2]),function(ee,e,f,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uec=void 0;class I{constructor(A){this.c=A,this.a=new f.$Od,this.onDidSaveNotebookDocument=this.a.event,this.b=new f.$Od,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(A,c,E,d){const S=this.c.getNotebookDocument(C.URI.revive(A)).acceptModelChanged(c.value,E,d);this.b.fire(S)}$acceptDirtyStateChanged(A,c){this.c.getNotebookDocument(C.URI.revive(A)).acceptDirty(c)}$acceptModelSaved(A){const c=this.c.getNotebookDocument(C.URI.revive(A));this.a.fire(c.apiNotebook)}}e.$uec=I}),define(Ae[17],Re([1,0,4]),function(ee,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sM=e.$rM=void 0,e.$rM=(0,f.$Qh)("IExtHostRpcService");class C{constructor(O){this.getProxy=O.getProxy.bind(O),this.set=O.set.bind(O),this.dispose=O.dispose.bind(O),this.assertRegistered=O.assertRegistered.bind(O),this.drain=O.drain.bind(O)}}e.$sM=C});var Xe=this&&this.__classPrivateFieldSet||function(ee,e,f,C,I){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!I:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?I.call(ee,f):I?I.value=f:e.set(ee,f),f},Ne=this&&this.__classPrivateFieldGet||function(ee,e,f,C){if(f==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!C:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return f==="m"?C:f==="a"?C.call(ee):C?C.value:e.get(ee)};define(Ae[191],Re([1,0,21,5]),function(ee,e,f,C){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.$hdc=void 0;class O{constructor(c,E){I.set(this,void 0),this.b=new C.$Od,this.onDidChange=this.b.event,this.a=f.$8l.toKey(c.identifier),Xe(this,I,E,"f"),Ne(this,I,"f").onDidChangePassword(d=>{d.extensionId===this.a&&this.b.fire({key:d.key})})}get(c){return Ne(this,I,"f").get(this.a,c)}store(c,E){return Ne(this,I,"f").store(this.a,c,E)}delete(c){return Ne(this,I,"f").delete(this.a,c)}}e.$hdc=O,I=new WeakMap}),define(Ae[57],Re([1,0,4]),function(ee,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qcc=e.$Pcc=void 0,e.$Pcc=(0,f.$Qh)("IURITransformerService");class C{constructor(O){O?(this.transformIncoming=O.transformIncoming.bind(O),this.transformOutgoing=O.transformOutgoing.bind(O),this.transformOutgoingURI=O.transformOutgoingURI.bind(O),this.transformOutgoingScheme=O.transformOutgoingScheme.bind(O)):(this.transformIncoming=A=>A,this.transformOutgoing=A=>A,this.transformOutgoingURI=A=>A,this.transformOutgoingScheme=A=>A)}}e.$Qcc=C}),define(Ae[192],Re([1,0,26]),function(ee,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Scb=e.$Rcb=void 0;class C{constructor(){this.buffers=[]}add(E){let d=this.buffers.indexOf(E);return d<0&&(d=this.buffers.length,this.buffers.push(E)),d}}function I(c,E){if(E.serializeBuffersForPostMessage){const d=new C,S=JSON.stringify(c,(b,p)=>{if(p instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:d.add(p)};if(ArrayBuffer.isView(p)){const g=O(p);if(g)return{$$vscode_array_buffer_reference$$:!0,index:d.add(p.buffer),view:{type:g,byteLength:p.byteLength,byteOffset:p.byteOffset}}}return p}),u=d.buffers.map(b=>{const p=new Uint8Array(b);return f.$ce.wrap(p)});return{message:S,buffers:u}}else return{message:JSON.stringify(c),buffers:[]}}e.$Rcb=I;function O(c){switch(c.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function A(c,E){const d=E.map(u=>{const b=new ArrayBuffer(u.byteLength);return new Uint8Array(b).set(u.buffer),b}),R=E.length?(u,b)=>{if(b&&typeof b=="object"&&b.$$vscode_array_buffer_reference$$){const p=b,{index:g}=p,t=d[g];if(p.view)switch(p.view.type){case 1:return new Int8Array(t,p.view.byteOffset,p.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(t,p.view.byteOffset,p.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(t,p.view.byteOffset,p.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(t,p.view.byteOffset,p.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(t,p.view.byteOffset,p.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(t,p.view.byteOffset,p.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(t,p.view.byteOffset,p.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(t,p.view.byteOffset,p.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(t,p.view.byteOffset,p.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(t,p.view.byteOffset,p.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(t,p.view.byteOffset,p.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return t}return b}:void 0;return{message:JSON.parse(c,R),arrayBuffers:d}}e.$Scb=A}),define(Ae[99],Re([1,0,160,15,2,6,4,30,39,13,38,130,29]),function(ee,e,f,C,I,O,A,c,E,d,R,S,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mE=e.$lE=e.$kE=e.EditorsOrder=e.$jE=e.CloseDirection=e.$iE=e.$hE=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$gE=e.$fE=e.$eE=e.$dE=e.$cE=e.$bE=e.$aE=e.$_D=e.EditorInputCapabilities=e.$$D=e.SaveReason=e.Verbosity=e.$0D=e.$9D=e.$8D=e.$7D=e.$6D=e.$5D=e.$4D=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$3D=e.$2D=e.$1D=e.$ZD=e.$YD=void 0,e.$YD={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$ZD={id:"default",displayName:(0,f.localize)(0,null),providerDisplayName:(0,f.localize)(1,null)},e.$1D="workbench.editor.sidebysideEditor",e.$2D="workbench.editors.textDiffEditor",e.$3D="workbench.editors.binaryResourceDiffEditor";var b;(function(oe){oe[oe.PROGRAMMATIC=1]="PROGRAMMATIC",oe[oe.USER=2]="USER",oe[oe.EDIT=3]="EDIT",oe[oe.NAVIGATION=4]="NAVIGATION",oe[oe.JUMP=5]="JUMP"})(b||(e.EditorPaneSelectionChangeReason=b={}));var p;(function(oe){oe[oe.IDENTICAL=1]="IDENTICAL",oe[oe.SIMILAR=2]="SIMILAR",oe[oe.DIFFERENT=3]="DIFFERENT"})(p||(e.EditorPaneSelectionCompareResult=p={}));function g(oe){const ye=oe;return!!ye&&typeof ye.getSelection=="function"&&!!ye.onDidChangeSelection}e.$4D=g;function t(oe,ye,De){for(const Q of De.visibleEditorPanes)if(Q.group.id===ye&&oe.matches(Q.input))return Q.getViewState()}e.$5D=t;function i(oe){if(a(oe))return!1;const ye=oe;return I.URI.isUri(ye?.resource)}e.$6D=i;function l(oe){if(a(oe))return!1;const ye=oe;return ye?.original!==void 0&&ye.modified!==void 0}e.$7D=l;function v(oe){if(a(oe)||l(oe))return!1;const ye=oe;return ye?.primary!==void 0&&ye.secondary!==void 0}e.$8D=v;function D(oe){if(a(oe))return!1;const ye=oe;return ye?ye.resource===void 0||ye.resource.scheme===d.Schemas.untitled||ye.forceUntitled===!0:!1}e.$9D=D;function m(oe){if(a(oe))return!1;const ye=oe;return I.URI.isUri(ye?.base?.resource)&&I.URI.isUri(ye?.input1?.resource)&&I.URI.isUri(ye?.input2?.resource)&&I.URI.isUri(ye?.result?.resource)}e.$0D=m;var n;(function(oe){oe[oe.SHORT=0]="SHORT",oe[oe.MEDIUM=1]="MEDIUM",oe[oe.LONG=2]="LONG"})(n||(e.Verbosity=n={}));var r;(function(oe){oe[oe.EXPLICIT=1]="EXPLICIT",oe[oe.AUTO=2]="AUTO",oe[oe.FOCUS_CHANGE=3]="FOCUS_CHANGE",oe[oe.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(r||(e.SaveReason=r={}));class s{constructor(){this.a=new Map}registerSource(ye,De){let Q=this.a.get(ye);return Q||(Q={source:ye,label:De},this.a.set(ye,Q)),Q.source}getSourceLabel(ye){return this.a.get(ye)?.label??ye}}e.$$D=new s;var o;(function(oe){oe[oe.None=0]="None",oe[oe.Readonly=2]="Readonly",oe[oe.Untitled=4]="Untitled",oe[oe.Singleton=8]="Singleton",oe[oe.RequiresTrust=16]="RequiresTrust",oe[oe.CanSplitInGroup=32]="CanSplitInGroup",oe[oe.ForceDescription=64]="ForceDescription",oe[oe.CanDropIntoEditor=128]="CanDropIntoEditor",oe[oe.MultipleEditors=256]="MultipleEditors",oe[oe.Scratchpad=512]="Scratchpad",oe[oe.AuxWindowUnsupported=1024]="AuxWindowUnsupported"})(o||(e.EditorInputCapabilities=o={}));class $ extends O.$Sc{}e.$_D=$;function a(oe){return oe instanceof $}e.$aE=a;function k(oe){const ye=oe;return I.URI.isUri(ye?.preferredResource)}function P(oe){const ye=oe;return a(ye?.primary)&&a(ye?.secondary)}e.$bE=P;function h(oe){const ye=oe;return a(ye?.modified)&&a(ye?.original)}e.$cE=h;function w(oe,ye,De,Q,ue){return re(Q,[(0,S.$Ai)({id:"workbench.action.openLargeFile",label:(0,f.localize)(2,null),run:()=>{const J={...De,limits:{size:Number.MAX_VALUE}};oe.openEditor(ye,J)}}),(0,S.$Ai)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,f.localize)(3,null),run:()=>ue.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:u.default.Warning})}e.$dE=w;function y(oe){return a(oe?.editor)}e.$eE=y;function M(oe){const ye=oe;return y(oe)&&ye?.group!==void 0}e.$fE=M;function V(oe){const ye=oe;return typeof ye?.groupId=="number"&&a(ye.editor)}e.$gE=V;var B;(function(oe){oe[oe.UNKNOWN=0]="UNKNOWN",oe[oe.REPLACE=1]="REPLACE",oe[oe.MOVE=2]="MOVE",oe[oe.UNPIN=3]="UNPIN"})(B||(e.EditorCloseContext=B={}));var z;(function(oe){oe[oe.GROUP_ACTIVE=0]="GROUP_ACTIVE",oe[oe.GROUP_INDEX=1]="GROUP_INDEX",oe[oe.GROUP_LABEL=2]="GROUP_LABEL",oe[oe.GROUP_LOCKED=3]="GROUP_LOCKED",oe[oe.EDITOR_OPEN=4]="EDITOR_OPEN",oe[oe.EDITOR_CLOSE=5]="EDITOR_CLOSE",oe[oe.EDITOR_MOVE=6]="EDITOR_MOVE",oe[oe.EDITOR_ACTIVE=7]="EDITOR_ACTIVE",oe[oe.EDITOR_LABEL=8]="EDITOR_LABEL",oe[oe.EDITOR_CAPABILITIES=9]="EDITOR_CAPABILITIES",oe[oe.EDITOR_PIN=10]="EDITOR_PIN",oe[oe.EDITOR_STICKY=11]="EDITOR_STICKY",oe[oe.EDITOR_DIRTY=12]="EDITOR_DIRTY",oe[oe.EDITOR_WILL_DISPOSE=13]="EDITOR_WILL_DISPOSE"})(z||(e.GroupModelChangeKind=z={}));var T;(function(oe){oe[oe.PRIMARY=1]="PRIMARY",oe[oe.SECONDARY=2]="SECONDARY",oe[oe.BOTH=3]="BOTH",oe[oe.ANY=4]="ANY"})(T||(e.SideBySideEditor=T={}));class F{getOriginalUri(ye,De){if(!ye)return;if(m(ye))return e.$iE.getOriginalUri(ye.result,De);if(De?.supportSideBySide){const{primary:ue,secondary:J}=this.a(ye);if(ue&&J){if(De?.supportSideBySide===T.BOTH)return{primary:this.getOriginalUri(ue,{filterByScheme:De.filterByScheme}),secondary:this.getOriginalUri(J,{filterByScheme:De.filterByScheme})};if(De?.supportSideBySide===T.ANY)return this.getOriginalUri(ue,{filterByScheme:De.filterByScheme})??this.getOriginalUri(J,{filterByScheme:De.filterByScheme});ye=De.supportSideBySide===T.PRIMARY?ue:J}}if(l(ye)||v(ye)||m(ye))return;const Q=k(ye)?ye.preferredResource:ye.resource;return!Q||!De||!De.filterByScheme?Q:this.b(Q,De.filterByScheme)}a(ye){return P(ye)||v(ye)?{primary:ye.primary,secondary:ye.secondary}:h(ye)||l(ye)?{primary:ye.modified,secondary:ye.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(ye,De){if(!ye)return;if(m(ye))return e.$iE.getCanonicalUri(ye.result,De);if(De?.supportSideBySide){const{primary:ue,secondary:J}=this.a(ye);if(ue&&J){if(De?.supportSideBySide===T.BOTH)return{primary:this.getCanonicalUri(ue,{filterByScheme:De.filterByScheme}),secondary:this.getCanonicalUri(J,{filterByScheme:De.filterByScheme})};if(De?.supportSideBySide===T.ANY)return this.getCanonicalUri(ue,{filterByScheme:De.filterByScheme})??this.getCanonicalUri(J,{filterByScheme:De.filterByScheme});ye=De.supportSideBySide===T.PRIMARY?ue:J}}if(l(ye)||v(ye)||m(ye))return;const Q=ye.resource;return!Q||!De||!De.filterByScheme?Q:this.b(Q,De.filterByScheme)}b(ye,De){if(Array.isArray(De)){if(De.some(Q=>ye.scheme===Q))return ye}else if(De===ye.scheme)return ye}}var j;(function(oe){oe[oe.UNKNOWN=0]="UNKNOWN",oe[oe.KEYBOARD=1]="KEYBOARD",oe[oe.MOUSE=2]="MOUSE"})(j||(e.EditorCloseMethod=j={}));function q(oe,ye,De,Q){if(!oe.isSticky(ye))return!1;switch(Q.preventPinnedEditorClose){case"keyboardAndMouse":return De===j.MOUSE||De===j.KEYBOARD;case"mouse":return De===j.MOUSE;case"keyboard":return De===j.KEYBOARD}return!1}e.$hE=q,e.$iE=new F;var W;(function(oe){oe[oe.LEFT=0]="LEFT",oe[oe.RIGHT=1]="RIGHT"})(W||(e.CloseDirection=W={}));class we{constructor(){this.c=new Map,this.d=new Map}start(ye){const De=this.a=ye.get(A.$Ph);for(const[Q,ue]of this.c)this.e(Q,ue,De);this.c.clear()}e(ye,De,Q){const ue=Q.createInstance(De);this.d.set(ye,ue)}registerFileEditorFactory(ye){if(this.b)throw new Error("Can only register one file editor factory.");this.b=ye}getFileEditorFactory(){return(0,C.$Kf)(this.b)}registerEditorSerializer(ye,De){if(this.c.has(ye)||this.d.has(ye))throw new Error(`A editor serializer with type ID '${ye}' was already registered.`);return this.a?this.e(ye,De,this.a):this.c.set(ye,De),(0,O.$Qc)(()=>{this.c.delete(ye),this.d.delete(ye)})}getEditorSerializer(ye){return this.d.get(typeof ye=="string"?ye:ye.typeId)}}c.$ln.add(e.$YD.EditorFactory,new we);async function ke(oe,ye,De){return!oe||!oe.length?[]:await Promise.all(oe.map(async Q=>{const ue=I.URI.revive(Q.fileUri);if(!ue){De.info("Cannot resolve the path because it is not valid.",Q);return}if(!await ye.canHandleResource(ue)){De.info("Cannot resolve the path because it cannot be handled",Q);return}let he=Q.exists,de=Q.type;if(typeof he!="boolean"||typeof de!="number")try{de=(await ye.stat(ue)).isDirectory?E.FileType.Directory:E.FileType.Unknown,he=!0}catch(be){De.error(be),he=!1}if(!he&&Q.openOnlyIfExists){De.info("Cannot resolve the path because it does not exist",Q);return}if(de===E.FileType.Directory){De.info("Cannot resolve the path because it is a directory",Q);return}const le={...Q.options,pinned:!0};return he?{resource:ue,options:le}:{resource:ue,options:le,forceUntitled:!0}}))}e.$jE=ke;var Se;(function(oe){oe[oe.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",oe[oe.SEQUENTIAL=1]="SEQUENTIAL"})(Se||(e.EditorsOrder=Se={}));function ve(oe){const ye=oe;if(!ye)return!1;const De=ye;if(De.modified)return ve(De.modified);const Q=ye;return!!(Q.contributionsState&&Q.viewState&&Array.isArray(Q.cursorState))}e.$kE=ve;function ge(oe){return(0,R.$Ci)(oe)}e.$lE=ge;function re(oe,ye,De){const Q=(0,R.$Di)(oe,ye);return Q.forceMessage=De?.forceMessage,Q.forceSeverity=De?.forceSeverity,Q.allowDialog=De?.allowDialog,Q}e.$mE=re}),define(Ae[193],Re([1,0,5,161,4,6,28,30,18,25,89,184]),function(ee,e,f,C,I,O,A,c,E,d,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xE=e.$wE=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$vE=e.$uE=e.ViewContentGroups=e.$tE=e.$sE=e.ViewContainerLocation=e.Extensions=e.$rE=e.$qE=e.$pE=void 0,e.$pE="views",e.$qE=(0,C.localize)(0,null),e.$rE=(0,S.$$v)("default-view-icon",R.$Vj.window,(0,C.localize)(1,null));var u;(function(r){r.ViewContainersRegistry="workbench.registry.view.containers",r.ViewsRegistry="workbench.registry.view"})(u||(e.Extensions=u={}));var b;(function(r){r[r.Sidebar=0]="Sidebar",r[r.Panel=1]="Panel",r[r.AuxiliaryBar=2]="AuxiliaryBar"})(b||(e.ViewContainerLocation=b={})),e.$sE=[0,1,2];function p(r){switch(r){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.$tE=p;class g extends O.$Sc{constructor(){super(...arguments),this.c=this.B(new f.$Od),this.onDidRegister=this.c.event,this.f=this.B(new f.$Od),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,E.$Rb)([...this.g.values()])}registerViewContainer(s,o,$){const a=this.get(s.id);if(a)return a;const k=s;return k.openCommandActionDescriptor=$?.doNotRegisterOpenCommand?void 0:k.openCommandActionDescriptor??{id:k.id},(0,A.$xc)(this.g,o,[]).push(k),$?.isDefault&&this.h.push(k),this.c.fire({viewContainer:k,viewContainerLocation:o}),k}deregisterViewContainer(s){for(const o of this.g.keys()){const $=this.g.get(o),a=$?.indexOf(s);if(a!==-1){$?.splice(a,1),$.length===0&&this.g.delete(o),this.f.fire({viewContainer:s,viewContainerLocation:o});return}}}get(s){return this.all.filter(o=>o.id===s)[0]}getViewContainers(s){return[...this.g.get(s)||[]]}getViewContainerLocation(s){return[...this.g.keys()].filter(o=>this.getViewContainers(o).filter($=>$?.id===s.id).length>0)[0]}getDefaultViewContainer(s){return this.h.find(o=>this.getViewContainerLocation(o)===s)}}c.$ln.add(u.ViewContainersRegistry,new g);var t;(function(r){r.Open="2_open",r.Debug="4_debug",r.SCM="5_scm",r.More="9_more"})(t||(e.ViewContentGroups=t={}));function i(r,s){const o=r.group??t.More,$=s.group??t.More;return o!==$?o.localeCompare($):(r.order??5)-(s.order??5)}class l extends O.$Sc{constructor(){super(...arguments),this.c=this.B(new f.$Od),this.onViewsRegistered=this.c.event,this.f=this.B(new f.$Od),this.onViewsDeregistered=this.f.event,this.g=this.B(new f.$Od),this.onDidChangeContainer=this.g.event,this.h=this.B(new f.$Od),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new A.$Gc}registerViews(s,o){this.registerViews2([{views:s,viewContainer:o}])}registerViews2(s){s.forEach(({views:o,viewContainer:$})=>this.r(o,$)),this.c.fire(s)}deregisterViews(s,o){const $=this.s(s,o);$.length&&this.f.fire({views:$,viewContainer:o})}moveViews(s,o){for(const $ of this.m.keys())if($!==o){const a=this.s(s,$);a.length&&(this.r(a,o),this.g.fire({views:a,from:$,to:o}))}}getViews(s){return this.m.get(s)||[]}getView(s){for(const o of this.j){const $=(this.m.get(o)||[]).filter(a=>a.id===s)[0];if($)return $}return null}getViewContainer(s){for(const o of this.j)if((this.m.get(o)||[]).filter(a=>a.id===s)[0])return o;return null}registerViewWelcomeContent(s,o){return this.n.add(s,o),this.h.fire(s),(0,O.$Qc)(()=>{this.n.delete(s,o),this.h.fire(s)})}registerViewWelcomeContent2(s,o){const $=new Map;for(const[a,k]of o)this.n.add(s,k),$.set(a,(0,O.$Qc)(()=>{this.n.delete(s,k),this.h.fire(s)}));return this.h.fire(s),$}getViewWelcomeContent(s){const o=[];return this.n.forEach(s,$=>o.push($)),o.sort(i)}r(s,o){let $=this.m.get(o);$||($=[],this.m.set(o,$),this.j.push(o));for(const a of s){if(this.getView(a.id)!==null)throw new Error((0,C.localize)(2,null,a.id));$.push(a)}}s(s,o){const $=this.m.get(o);if(!$)return[];const a=[],k=[];for(const P of $)s.includes(P)?a.push(P):k.push(P);return a.length&&(k.length?this.m.set(o,k):(this.m.delete(o),this.j.splice(this.j.indexOf(o),1))),a}}c.$ln.add(u.ViewsRegistry,new l),e.$uE=(0,I.$Qh)("viewsService"),e.$vE=(0,I.$Qh)("viewDescriptorService");var v;(function(r){r[r.Default=0]="Default",r[r.Expand=1]="Expand"})(v||(e.ViewVisibilityState=v={}));var D;(function(r){r[r.None=0]="None",r[r.Collapsed=1]="Collapsed",r[r.Expanded=2]="Expanded"})(D||(e.TreeItemCollapsibleState=D={}));class m{constructor(s,o){this.c=!1,this.d=!1,(0,d.$_m)(this,s),this.d=!!o,this.resolve=async $=>{if(o&&!this.c){const a=await o($);a&&(this.tooltip=this.tooltip??a.tooltip,this.command=this.command??a.command)}$.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$wE=m;class n extends Error{constructor(s){super((0,C.localize)(3,null,s)),this.name="NoTreeViewError"}static is(s){return s.name==="NoTreeViewError"}}e.$xE=n}),define(Ae[194],Re([1,0,2,41,4]),function(ee,e,f,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZE=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.$YE=e.$XE=void 0;function O(d){return!!d&&typeof d=="object"&&"uri"in d&&d.uri instanceof f.URI&&"version"in d&&typeof d.version=="number"&&"ranges"in d&&Array.isArray(d.ranges)&&d.ranges.every(C.$ys.isIRange)}e.$XE=O;function A(d){return!!d&&typeof d=="object"&&"documents"in d&&Array.isArray(d.documents)&&d.documents.every(O)}e.$YE=A;var c;(function(d){d[d.Down=0]="Down",d[d.Up=1]="Up"})(c||(e.InteractiveSessionVoteDirection=c={}));var E;(function(d){d[d.Action=1]="Action",d[d.Toolbar=2]="Toolbar"})(E||(e.InteractiveSessionCopyKind=E={})),e.$ZE=(0,I.$Qh)("IChatService")}),define(Ae[195],Re([1,0,5,12,162]),function(ee,e,f,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ldb=void 0;class O{constructor(){this.f=new Map,this.k=[],this.m=new f.$Od,this.n=new f.$Od,this.d=1}get onError(){return this.m.event}get onExit(){return this.n.event}onMessage(c){this.j&&this.m.fire(new Error("attempt to set more than one 'Message' callback")),this.j=c}onEvent(c){this.i&&this.m.fire(new Error("attempt to set more than one 'Event' callback")),this.i=c}onRequest(c){this.g&&this.m.fire(new Error("attempt to set more than one 'Request' callback")),this.g=c}sendResponse(c){c.seq>0?this.m.fire(new Error(`attempt to send more than one response for command ${c.command}`)):this.s("response",c)}sendRequest(c,E,d,R){const S={command:c};if(E&&Object.keys(E).length>0&&(S.arguments=E),this.s("request",S),typeof R=="number"){const u=setTimeout(()=>{clearTimeout(u);const b=this.f.get(S.seq);if(b){this.f.delete(S.seq);const p={type:"response",seq:0,request_seq:S.seq,success:!1,command:c,message:(0,I.localize)(0,null,R,c)};b(p)}},R)}return d&&this.f.set(S.seq,d),S.seq}acceptMessage(c){this.j?this.j(c):(this.k.push(c),this.k.length===1&&this.q())}o(c,E){return c.type!=="event"||E.type!=="event"}async q(){let c;for(;this.k.length;){if((!c||this.o(this.k[0],c))&&await(0,C.$Vg)(0),c=this.k.shift(),!c)return;switch(c.type){case"event":this.i?.(c);break;case"request":this.g?.(c);break;case"response":{const E=c,d=this.f.get(E.request_seq);d&&(this.f.delete(E.request_seq),d(E));break}}}}s(c,E){E.type=c,E.seq=this.d++,this.sendMessage(E)}async u(){if(this.f.size===0)return Promise.resolve();const c=new Map;this.f.forEach((E,d)=>c.set(d,E)),await(0,C.$Vg)(500),c.forEach((E,d)=>{E({type:"response",seq:0,request_seq:d,success:!1,command:"canceled",message:"canceled"}),this.f.delete(d)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.k=[]}}e.$ldb=O}),define(Ae[196],Re([1,0,163,32,4]),function(ee,e,f,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.$_G=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.$$G=e.MemoryRangeType=e.$0G=e.State=e.$9G=e.$8G=e.$7G=e.$6G=e.$5G=e.$4G=e.$3G=e.$2G=e.$1G=e.$ZG=e.$YG=e.$XG=e.$WG=e.$VG=e.$UG=e.$TG=e.$SG=e.$RG=e.$QG=e.$PG=e.$OG=e.$NG=e.$MG=e.$LG=e.$KG=e.$JG=e.$IG=e.$HG=e.$GG=e.$FG=e.$EG=e.$DG=e.$CG=e.$BG=e.$AG=e.$zG=e.$yG=e.$xG=e.$wG=e.$vG=e.$uG=e.$tG=e.$sG=e.$rG=e.$qG=e.$pG=e.$oG=e.$nG=e.$mG=e.$lG=e.$kG=e.$jG=e.$iG=e.$hG=e.$gG=e.$fG=e.$eG=e.$dG=e.$cG=e.$bG=e.$aG=e.$_F=e.$$F=e.$0F=e.$9F=e.$8F=void 0,e.$8F="workbench.view.debug",e.$9F="workbench.debug.variablesView",e.$0F="workbench.debug.watchExpressionsView",e.$$F="workbench.debug.callStackView",e.$_F="workbench.debug.loadedScriptsView",e.$aG="workbench.debug.breakPointsView",e.$bG="workbench.debug.disassemblyView",e.$cG="workbench.panel.repl",e.$dG="workbench.panel.repl.view",e.$eG=new C.$8i("debugType",void 0,{type:"string",description:f.localize(0,null)}),e.$fG=new C.$8i("debugConfigurationType",void 0,{type:"string",description:f.localize(1,null)}),e.$gG=new C.$8i("debugState","inactive",{type:"string",description:f.localize(2,null)}),e.$hG="debugUx",e.$iG=new C.$8i(e.$hG,"default",{type:"string",description:f.localize(3,null)}),e.$jG=new C.$8i("hasDebugged",!1,{type:"boolean",description:f.localize(4,null)}),e.$kG=new C.$8i("inDebugMode",!1,{type:"boolean",description:f.localize(5,null)}),e.$lG=new C.$8i("inDebugRepl",!1,{type:"boolean",description:f.localize(6,null)}),e.$mG=new C.$8i("breakpointWidgetVisible",!1,{type:"boolean",description:f.localize(7,null)}),e.$nG=new C.$8i("inBreakpointWidget",!1,{type:"boolean",description:f.localize(8,null)}),e.$oG=new C.$8i("breakpointsFocused",!0,{type:"boolean",description:f.localize(9,null)}),e.$pG=new C.$8i("watchExpressionsFocused",!0,{type:"boolean",description:f.localize(10,null)}),e.$qG=new C.$8i("watchExpressionsExist",!1,{type:"boolean",description:f.localize(11,null)}),e.$rG=new C.$8i("variablesFocused",!0,{type:"boolean",description:f.localize(12,null)}),e.$sG=new C.$8i("expressionSelected",!1,{type:"boolean",description:f.localize(13,null)}),e.$tG=new C.$8i("breakpointInputFocused",!1,{type:"boolean",description:f.localize(14,null)}),e.$uG=new C.$8i("callStackItemType",void 0,{type:"string",description:f.localize(15,null)}),e.$vG=new C.$8i("callStackSessionIsAttach",!1,{type:"boolean",description:f.localize(16,null)}),e.$wG=new C.$8i("callStackItemStopped",!1,{type:"boolean",description:f.localize(17,null)}),e.$xG=new C.$8i("callStackSessionHasOneThread",!1,{type:"boolean",description:f.localize(18,null)}),e.$yG=new C.$8i("watchItemType",void 0,{type:"string",description:f.localize(19,null)}),e.$zG=new C.$8i("canViewMemory",void 0,{type:"boolean",description:f.localize(20,null)}),e.$AG=new C.$8i("breakpointItemType",void 0,{type:"string",description:f.localize(21,null)}),e.$BG=new C.$8i("breakpointSupportsCondition",!1,{type:"boolean",description:f.localize(22,null)}),e.$CG=new C.$8i("loadedScriptsSupported",!1,{type:"boolean",description:f.localize(23,null)}),e.$DG=new C.$8i("loadedScriptsItemType",void 0,{type:"string",description:f.localize(24,null)}),e.$EG=new C.$8i("focusedSessionIsAttach",!1,{type:"boolean",description:f.localize(25,null)}),e.$FG=new C.$8i("stepBackSupported",!1,{type:"boolean",description:f.localize(26,null)}),e.$GG=new C.$8i("restartFrameSupported",!1,{type:"boolean",description:f.localize(27,null)}),e.$HG=new C.$8i("stackFrameSupportsRestart",!1,{type:"boolean",description:f.localize(28,null)}),e.$IG=new C.$8i("jumpToCursorSupported",!1,{type:"boolean",description:f.localize(29,null)}),e.$JG=new C.$8i("stepIntoTargetsSupported",!1,{type:"boolean",description:f.localize(30,null)}),e.$KG=new C.$8i("breakpointsExist",!1,{type:"boolean",description:f.localize(31,null)}),e.$LG=new C.$8i("debuggersAvailable",!1,{type:"boolean",description:f.localize(32,null)}),e.$MG=new C.$8i("debugExtensionAvailable",!0,{type:"boolean",description:f.localize(33,null)}),e.$NG=new C.$8i("debugProtocolVariableMenuContext",void 0,{type:"string",description:f.localize(34,null)}),e.$OG=new C.$8i("debugSetVariableSupported",!1,{type:"boolean",description:f.localize(35,null)}),e.$PG=new C.$8i("debugSetExpressionSupported",!1,{type:"boolean",description:f.localize(36,null)}),e.$QG=new C.$8i("breakWhenValueChangesSupported",!1,{type:"boolean",description:f.localize(37,null)}),e.$RG=new C.$8i("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:f.localize(38,null)}),e.$SG=new C.$8i("breakWhenValueIsReadSupported",!1,{type:"boolean",description:f.localize(39,null)}),e.$TG=new C.$8i("terminateDebuggeeSupported",!1,{type:"boolean",description:f.localize(40,null)}),e.$UG=new C.$8i("suspendDebuggeeSupported",!1,{type:"boolean",description:f.localize(41,null)}),e.$VG=new C.$8i("variableEvaluateNamePresent",!1,{type:"boolean",description:f.localize(42,null)}),e.$WG=new C.$8i("variableIsReadonly",!1,{type:"boolean",description:f.localize(43,null)}),e.$XG=new C.$8i("exceptionWidgetVisible",!1,{type:"boolean",description:f.localize(44,null)}),e.$YG=new C.$8i("multiSessionRepl",!1,{type:"boolean",description:f.localize(45,null)}),e.$ZG=new C.$8i("multiSessionDebug",!1,{type:"boolean",description:f.localize(46,null)}),e.$1G=new C.$8i("disassembleRequestSupported",!1,{type:"boolean",description:f.localize(47,null)}),e.$2G=new C.$8i("disassemblyViewFocus",!1,{type:"boolean",description:f.localize(48,null)}),e.$3G=new C.$8i("languageSupportsDisassembleRequest",!1,{type:"boolean",description:f.localize(49,null)}),e.$4G=new C.$8i("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:f.localize(50,null)});const O=u=>f.localize(51,null,u);e.$5G=O,e.$6G="editor.contrib.debug",e.$7G="editor.contrib.breakpoint",e.$8G="debug",e.$9G={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:f.localize(52,null)};var A;(function(u){u[u.Inactive=0]="Inactive",u[u.Initializing=1]="Initializing",u[u.Stopped=2]="Stopped",u[u.Running=3]="Running"})(A||(e.State=A={}));function c(u){switch(u){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.$0G=c;var E;(function(u){u[u.Valid=0]="Valid",u[u.Unreadable=1]="Unreadable",u[u.Error=2]="Error"})(E||(e.MemoryRangeType=E={})),e.$$G="vscode-debug-memory";var d;(function(u){u[u.Initial=1]="Initial",u[u.Dynamic=2]="Dynamic"})(d||(e.DebugConfigurationProviderTriggerKind=d={}));var R;(function(u){u.UnverifiedBreakpoints="unverifiedBreakpoints"})(R||(e.DebuggerString=R={})),e.$_G=(0,I.$Qh)("debugService");var S;(function(u){u[u.CONDITION=0]="CONDITION",u[u.HIT_COUNT=1]="HIT_COUNT",u[u.LOG_MESSAGE=2]="LOG_MESSAGE"})(S||(e.BreakpointWidgetContext=S={}))}),define(Ae[197],Re([1,0,16,2,20,25,13,41,19,18]),function(ee,e,f,C,I,O,A,c,E,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IF=e.$HF=e.$GF=e.$FF=e.$EF=e.$DF=e.$CF=e.$BF=e.$AF=e.$zF=e.$yF=e.$xF=e.$wF=void 0;const R=/{([^}]+)}/g;function S(P,h,w){return P.replace(R,function(y,M){return h&&M.length>0&&M[0]!=="_"?y:w&&w.hasOwnProperty(M)?w[M]:y})}e.$wF=S;function u(P){const h={};for(const w of Object.keys(P))w.startsWith("!")||(h[w]=P[w]);return h}e.$xF=u;function b(P){return P.configuration.request==="attach"&&!p(P)&&(!P.parentSession||b(P.parentSession))}e.$yF=b;function p(P){let h=P.configuration.type;if(h)return h==="vslsShare"&&(h=P.configuration.adapterProxy.configuration.type),(0,f.$3e)(h,"extensionhost")||(0,f.$3e)(h,"pwa-extensionhost")?P:P.parentSession?p(P.parentSession):void 0}e.$zF=p;function g(P){return P.type&&(P.label||P.program||P.runtime)}e.$AF=g;function t(P,h,w){let y,M=0;const V=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let B=null;for(;B=V.exec(P);){const z=B.index+1,T=z+B[0].length;if(z<=h&&T>=w){y=B[0],M=z;break}}if(y){const z=/\w+/g;let T=null;for(;(T=z.exec(y))&&!(T.index+1+M+T[0].length>=w););T&&(y=y.substring(0,z.lastIndex))}return y?{start:M,end:M+y.length-1}:{start:0,end:0}}e.$BF=t;async function i(P,h,w,y){if(P.evaluatableExpressionProvider.has(h)){const M=P.evaluatableExpressionProvider.ordered(h),V=(0,d.$Hb)(await Promise.all(M.map(async B=>{try{return await B.provideEvaluatableExpression(h,w,y??E.CancellationToken.None)}catch{return}})));if(V.length>0){let B=V[0].expression;const z=V[0].range;return B||(B=h.getLineContent(w.lineNumber).substring(z.startColumn-1,z.endColumn-1)),{range:z,matchingExpression:B}}}else{const M=h.getLineContent(w.lineNumber),{start:V,end:B}=t(M,w.column,w.column),z=M.substring(V-1,B);return{matchingExpression:z,range:new c.$ys(w.lineNumber,V,w.lineNumber,V+z.length)}}return null}e.$CF=i;const l=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function v(P){return!!(P&&P.match(l))}e.$DF=v;function D(P){if(typeof P.path=="string"&&!(typeof P.sourceReference=="number"&&P.sourceReference>0)){if(v(P.path))return C.URI.parse(P.path);if((0,I.$ic)(P.path))return C.URI.file(P.path)}return P.path}function m(P){if(typeof P.path=="object"){const h=C.URI.revive(P.path);if(h)return h.scheme===A.Schemas.file?h.fsPath:h.toString()}return P.path}function n(P,h){const w=h?D:m,y=(0,O.$9m)(P);return s(y,(M,V)=>{M&&V&&(V.path=w(V))}),y}e.$EF=n;function r(P,h){const w=h?D:m,y=(0,O.$9m)(P);return s(y,(M,V)=>{!M&&V&&(V.path=w(V))}),y}e.$FF=r;function s(P,h){switch(P.type){case"event":{const w=P;switch(w.event){case"output":h(!1,w.body.source);break;case"loadedSource":h(!1,w.body.source);break;case"breakpoint":h(!1,w.body.breakpoint.source);break;default:break}break}case"request":{const w=P;switch(w.command){case"setBreakpoints":h(!0,w.arguments.source);break;case"breakpointLocations":h(!0,w.arguments.source);break;case"source":h(!0,w.arguments.source);break;case"gotoTargets":h(!0,w.arguments.source);break;case"launchVSCode":w.arguments.args.forEach(y=>h(!1,y));break;default:break}break}case"response":{const w=P;if(w.success&&w.body)switch(w.command){case"stackTrace":w.body.stackFrames.forEach(y=>h(!1,y.source));break;case"loadedSources":w.body.sources.forEach(y=>h(!1,y));break;case"scopes":w.body.scopes.forEach(y=>h(!1,y.source));break;case"setFunctionBreakpoints":w.body.breakpoints.forEach(y=>h(!1,y.source));break;case"setBreakpoints":w.body.breakpoints.forEach(y=>h(!1,y.source));break;case"disassemble":w.body?.instructions.forEach(M=>h(!1,M.location));break;default:break}break}}}function o(P){return P.filter(h=>!h.presentation?.hidden).sort((h,w)=>h.presentation?w.presentation?h.presentation.group?w.presentation.group?h.presentation.group!==w.presentation.group?h.presentation.group.localeCompare(w.presentation.group):$(h.presentation.order,w.presentation.order):-1:w.presentation.group?1:$(h.presentation.order,w.presentation.order):-1:w.presentation?1:0)}e.$GF=o;function $(P,h){return typeof P!="number"?typeof h!="number"?0:1:typeof h!="number"?-1:P-h}async function a(P,h){const w=P.getValue("debug.saveBeforeStart",{overrideIdentifier:h.activeTextEditorLanguageId});if(w!=="none"&&(await h.saveAll(),w==="allEditorsInActiveGroup")){const y=h.activeEditorPane;y&&y.input.resource?.scheme===A.Schemas.untitled&&await h.save({editor:y.input,groupId:y.group.id})}await P.reloadConfiguration()}e.$HF=a;const k=(P,h)=>!P||!h?P===h:P.name===h.name&&P.path===h.path&&P.sourceReference===h.sourceReference;e.$IF=k}),define(Ae[75],Re([1,0,26,36,68,66,13,20,23,32]),function(ee,e,f,C,I,O,A,c,E,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BI=e.$AI=e.$zI=e.$yI=e.CellStatusbarAlignment=e.$xI=e.$wI=e.$vI=e.NotebookEditorPriority=e.$uI=e.$tI=e.$sI=e.$rI=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$qI=e.$pI=e.$oI=e.$nI=e.CellKind=e.$mI=e.$lI=e.$kI=void 0,e.$kI="workbench.editor.notebook",e.$lI="workbench.editor.notebookTextDiffEditor",e.$mI="workbench.editor.interactive";var R;(function(j){j[j.Markup=1]="Markup",j[j.Code=2]="Code"})(R||(e.CellKind=R={})),e.$nI=["application/json","application/javascript","text/html","image/svg+xml",O.$Ur.latex,O.$Ur.markdown,"image/png","image/jpeg",O.$Ur.text],e.$oI=[O.$Ur.latex,O.$Ur.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",O.$Ur.text],e.$pI=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$qI="_notAvailable";var S;(function(j){j[j.Running=1]="Running",j[j.Idle=2]="Idle"})(S||(e.NotebookRunState=S={}));var u;(function(j){j[j.Unconfirmed=1]="Unconfirmed",j[j.Pending=2]="Pending",j[j.Executing=3]="Executing"})(u||(e.NotebookCellExecutionState=u={}));var b;(function(j){j[j.Unconfirmed=1]="Unconfirmed",j[j.Pending=2]="Pending",j[j.Executing=3]="Executing"})(b||(e.NotebookExecutionState=b={}));var p;(function(j){j[j.WithHardKernelDependency=0]="WithHardKernelDependency",j[j.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",j[j.Pure=2]="Pure",j[j.Never=3]="Never"})(p||(e.NotebookRendererMatch=p={}));var g;(function(j){j.Always="always",j.Never="never",j.Optional="optional"})(g||(e.RendererMessagingSpec=g={}));var t;(function(j){j[j.ModelChange=1]="ModelChange",j[j.Move=2]="Move",j[j.ChangeCellLanguage=5]="ChangeCellLanguage",j[j.Initialize=6]="Initialize",j[j.ChangeCellMetadata=7]="ChangeCellMetadata",j[j.Output=8]="Output",j[j.OutputItem=9]="OutputItem",j[j.ChangeCellContent=10]="ChangeCellContent",j[j.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",j[j.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",j[j.ChangeCellMime=13]="ChangeCellMime",j[j.Unknown=100]="Unknown"})(t||(e.NotebookCellsChangeType=t={}));var i;(function(j){j[j.Handle=0]="Handle",j[j.Index=1]="Index"})(i||(e.SelectionStateType=i={}));var l;(function(j){j[j.Replace=1]="Replace",j[j.Output=2]="Output",j[j.Metadata=3]="Metadata",j[j.CellLanguage=4]="CellLanguage",j[j.DocumentMetadata=5]="DocumentMetadata",j[j.Move=6]="Move",j[j.OutputItems=7]="OutputItems",j[j.PartialMetadata=8]="PartialMetadata",j[j.PartialInternalMetadata=9]="PartialInternalMetadata"})(l||(e.CellEditType=l={}));var v;(function(j){j.scheme=A.Schemas.vscodeNotebookCell;const q=["W","X","Y","Z","a","b","c","d","e","f"],W=new RegExp(`^[${q.join("")}]+`),we=7;function ke(ye,De){const Q=De.toString(we),J=`${Q.length<q.length?q[Q.length-1]:"z"}${Q}s${(0,f.$we)(f.$ce.fromString(ye.scheme),!0,!0)}`;return ye.with({scheme:j.scheme,fragment:J})}j.generate=ke;function Se(ye){if(ye.scheme!==j.scheme)return;const De=ye.fragment.indexOf("s");if(De<0)return;const Q=parseInt(ye.fragment.substring(0,De).replace(W,""),we),ue=(0,f.$ve)(ye.fragment.substring(De+1)).toString();if(!isNaN(Q))return{handle:Q,notebook:ye.with({scheme:ue,fragment:null})}}j.parse=Se;function ve(ye,De){return ye.with({scheme:A.Schemas.vscodeNotebookCellOutput,fragment:`op${De??""},${ye.scheme!==A.Schemas.file?ye.scheme:""}`})}j.generateCellOutputUri=ve;function ge(ye){if(ye.scheme!==A.Schemas.vscodeNotebookCellOutput)return;const De=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(ye.fragment);if(!De)return;const Q=De[1]&&De[1]!==""?De[1]:void 0,ue=De[2];return{outputId:Q,notebook:ye.with({scheme:ue||A.Schemas.file,fragment:null})}}j.parseCellOutputUri=ge;function re(ye,De,Q){return j.generate(ye,De).with({scheme:Q})}j.generateCellPropertyUri=re;function oe(ye,De){if(ye.scheme===De)return j.parse(ye.with({scheme:j.scheme}))}j.parseCellPropertyUri=oe})(v||(e.CellUri=v={}));const D=j=>E.$d?j.replace(/\//g,"\\"):j;class m{constructor(q=[],W=e.$nI){this.e=W,this.d=[...new Set(q)].map(we=>({pattern:we,matches:C.$xj(D(we))}))}sort(q){const W=new Map(I.Iterable.map(q,ke=>[ke,D(ke)]));let we=[];for(const{matches:ke}of this.d)for(const[Se,ve]of W)if(ke(ve)){we.push(Se),W.delete(Se);break}return W.size&&(we=we.concat([...W.keys()].sort((ke,Se)=>this.e.indexOf(ke)-this.e.indexOf(Se)))),we}prioritize(q,W){const we=this.f(q);if(we===-1){this.d.unshift({pattern:q,matches:C.$xj(D(q))});return}const ke=new Set(W.map(ve=>this.f(ve,we)));ke.delete(-1);const Se=Array.from(ke).sort();this.d.splice(we+1,0,...Se.map(ve=>this.d[ve]));for(let ve=Se.length-1;ve>=0;ve--)this.d.splice(Se[ve],1)}toArray(){return this.d.map(q=>q.pattern)}f(q,W=this.d.length){const we=D(q);for(let ke=0;ke<W;ke++)if(this.d[ke].matches(we))return ke;return-1}}e.$rI=m;function n(j,q,W,we=(ke,Se)=>ke===Se){const ke=[];function Se(re,oe,ye){if(oe===0&&ye.length===0)return;const De=ke[ke.length-1];De&&De.start+De.deleteCount===re?(De.deleteCount+=oe,De.toInsert.push(...ye)):ke.push({start:re,deleteCount:oe,toInsert:ye})}let ve=0,ge=0;for(;;){if(ve===j.length){Se(ve,0,q.slice(ge));break}if(ge===q.length){Se(ve,j.length-ve,[]);break}const re=j[ve],oe=q[ge];if(we(re,oe)){ve+=1,ge+=1;continue}W(oe)?(Se(ve,1,[]),ve+=1):(Se(ve,0,[oe]),ge+=1)}return ke}e.$sI=n,e.$tI=new d.$8i("notebookEditorCursorAtBoundary","none"),e.$uI=new d.$8i("notebookEditorCursorAtLineBoundary","none");var r;(function(j){j.default="default",j.option="option"})(r||(e.NotebookEditorPriority=r={}));function s(j){const q=j;return!!((typeof q.include=="string"||C.$yj(q.include))&&(typeof q.exclude=="string"||C.$yj(q.exclude)))}e.$vI=s;function o(j,q,W){if(Array.isArray(j.viewType)&&j.viewType.indexOf(q)>=0||j.viewType===q)return!0;if(j.filenamePattern){const we=s(j.filenamePattern)?j.filenamePattern.include:j.filenamePattern,ke=s(j.filenamePattern)?j.filenamePattern.exclude:void 0;if(C.$wj(we,(0,c.$nc)(W.fsPath).toLowerCase()))return!(ke&&C.$wj(ke,(0,c.$nc)(W.fsPath).toLowerCase()))}return!1}e.$wI=o,e.$xI={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScroll:"notebook.stickyScroll.enabled",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",formatOnSave:"notebook.formatOnSave.enabled",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",anchorToFocusedCell:"notebook.scrolling.experimental.anchorToFocusedCell"};var $;(function(j){j[j.Left=1]="Left",j[j.Right=2]="Right"})($||(e.CellStatusbarAlignment=$={}));class a{static create(q){return`${a.d}${q}`}static parse(q){if(q.startsWith(a.d))return q.substring(a.d.length)}}e.$yI=a,a.d="notebook/";function k(j){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(j)}e.$zI=k;const P=new TextDecoder;function h(j){const q=[];let W=!1;for(const ve of j)(q.length===0||W)&&(q.push(ve),W=!0);let we=M(q);const ke=f.$ce.concat(q.map(ve=>f.$ce.wrap(ve))),Se=F(ke);return we=we||Se.byteLength!==ke.byteLength,{data:Se,didCompression:we}}e.$AI=h,e.$BI=`${String.fromCharCode(27)}[A`;const w=e.$BI.split("").map(j=>j.charCodeAt(0)),y=10;function M(j){let q=!1;return j.forEach((W,we)=>{if(we===0||W.length<e.$BI.length)return;const ke=j[we-1],Se=W.subarray(0,e.$BI.length);if(Se[0]===w[0]&&Se[1]===w[1]&&Se[2]===w[2]){const ve=ke.lastIndexOf(y);if(ve===-1)return;q=!0,j[we-1]=ke.subarray(0,ve),j[we]=W.subarray(e.$BI.length)}}),q}function V(j){let q=j;do j=q,q=j.replace(/[^\n]\x08/gm,"");while(q.length<j.length);return j}function B(j){for(j=j.replace(/\r+\n/gm,`
`);j.search(/\r[^$]/g)>-1;){const q=j.match(/^(.*)\r+/m)[1];let W=j.match(/\r+(.*)$/m)[1];W=W+q.slice(W.length,q.length),j=j.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,W)}return j}const z="\b".charCodeAt(0),T="\r".charCodeAt(0);function F(j){return!j.buffer.includes(z)&&!j.buffer.includes(T)?j:f.$ce.fromString(B(V(P.decode(j.buffer))))}});var Xe=this&&this.__classPrivateFieldSet||function(ee,e,f,C,I){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!I:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?I.call(ee,f):I?I.value=f:e.set(ee,f),f},Ne=this&&this.__classPrivateFieldGet||function(ee,e,f,C){if(f==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!C:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return f==="m"?C:f==="a"?C.call(ee):C?C.value:e.get(ee)};define(Ae[7],Re([1,0,18,11,51,28,66,16,15,2,37,21,39,97,75]),function(ee,e,f,C,I,O,A,c,E,d,R,S,u,b,p){"use strict";var g,t,i,l,v,D,m,n,r,s,o,$,a,k,P,h,w,y,M,V,B,z,T,F,j,q;Object.defineProperty(e,"__esModule",{value:!0}),e.SpeechToTextStatus=e.RelatedInformationType=e.ChatAgentResultFeedbackKind=e.$gM=e.ChatVariableLevel=e.ChatMessageRole=e.InteractiveEditorResponseFeedbackKind=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.$fM=e.$eM=e.$dM=e.$cM=e.$bM=e.$aM=e.$_L=e.$$L=e.$0L=e.$9L=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$8L=e.$7L=e.$6L=e.$5L=e.$4L=e.$3L=e.$2L=e.$1L=e.TestRunProfileKind=e.TestResultState=e.$ZL=e.$YL=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$XL=e.$WL=e.$VL=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$UL=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$TL=e.$SL=e.$RL=e.$QL=e.$PL=e.ColorThemeKind=e.$OL=e.$NL=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$ML=e.DebugConsoleMode=e.$LL=e.$KL=e.$JL=e.$IL=e.$HL=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$GL=e.$FL=e.FileChangeType=e.$EL=e.$DL=e.$CL=e.$BL=e.InlineCompletionTriggerKind=e.$AL=e.$zL=e.$yL=e.$xL=e.$wL=e.$vL=e.$uL=e.$tL=e.$sL=e.$rL=e.$qL=e.$pL=e.$oL=e.ConfigurationTarget=e.$nL=e.$mL=e.$lL=e.$kL=e.$jL=e.$iL=e.$hL=e.$gL=e.$fL=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$eL=e.ViewBadge=e.ProgressLocation=e.$dL=e.$cL=e.TaskScope=e.ShellQuoting=e.$bL=e.$aL=e.$_K=e.TaskPanelKind=e.TaskRevealKind=e.$$K=e.TerminalLocation=e.$0K=e.$9K=e.$8K=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$7K=e.$6K=e.$5K=e.$4K=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.$3K=e.StatusBarAlignment=e.ViewColumn=e.$2K=e.$1K=e.$ZK=e.$YK=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$XK=e.$WK=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$VK=e.$UK=e.$TK=e.$SK=e.$RK=e.LanguageStatusSeverity=e.$QK=e.$PK=e.$OK=e.$NK=e.$MK=e.$LK=e.CodeActionTriggerKind=e.$KK=e.$JK=e.SymbolTag=e.SymbolKind=e.$IK=e.DocumentHighlightKind=e.$HK=e.$GK=e.$FK=e.$EK=e.DiagnosticSeverity=e.DiagnosticTag=e.$DK=e.$CK=e.FileEditType=e.$BK=e.$AK=e.$zK=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$yK=e.$xK=e.$wK=e.$vK=e.$uK=e.$tK=e.$sK=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function W(U){return Object.assign(U,{apply:function(...ae){if(ae.length===0)return Reflect.construct(U,[]);{const Ie=ae.length===1?[]:ae[1];return Reflect.construct(U,Ie,ae[0].constructor)}},call:function(...ae){if(ae.length===0)return Reflect.construct(U,[]);{const[Ie,...Qe]=ae;return Reflect.construct(U,Qe,Ie.constructor)}}})}var we;(function(U){U[U.Top=0]="Top",U[U.Bottom=1]="Bottom"})(we||(e.TerminalOutputAnchor=we={}));var ke;(function(U){U[U.TerminalCommand=0]="TerminalCommand",U[U.Opener=1]="Opener",U[U.Command=3]="Command"})(ke||(e.TerminalQuickFixType=ke={}));let Se=r=class{static from(...N){let ae=N;return new r(function(){if(ae){for(const Ie of ae)Ie&&typeof Ie.dispose=="function"&&Ie.dispose();ae=void 0}})}constructor(N){g.set(this,void 0),Xe(this,g,N,"f")}dispose(){typeof Ne(this,g,"f")=="function"&&(Ne(this,g,"f").call(this),Xe(this,g,void 0,"f"))}};e.$sK=Se,g=new WeakMap,e.$sK=Se=r=Ge([W],Se);let ve=s=class{static Min(...N){if(N.length===0)throw new TypeError;let ae=N[0];for(let Ie=1;Ie<N.length;Ie++){const Qe=N[Ie];Qe.isBefore(ae)&&(ae=Qe)}return ae}static Max(...N){if(N.length===0)throw new TypeError;let ae=N[0];for(let Ie=1;Ie<N.length;Ie++){const Qe=N[Ie];Qe.isAfter(ae)&&(ae=Qe)}return ae}static isPosition(N){if(!N)return!1;if(N instanceof s)return!0;const{line:ae,character:Ie}=N;return typeof ae=="number"&&typeof Ie=="number"}static of(N){if(N instanceof s)return N;if(this.isPosition(N))return new s(N.line,N.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(N,ae){if(N<0)throw(0,C.$7)("line must be non-negative");if(ae<0)throw(0,C.$7)("character must be non-negative");this.c=N,this.e=ae}isBefore(N){return this.c<N.c?!0:N.c<this.c?!1:this.e<N.e}isBeforeOrEqual(N){return this.c<N.c?!0:N.c<this.c?!1:this.e<=N.e}isAfter(N){return!this.isBeforeOrEqual(N)}isAfterOrEqual(N){return!this.isBefore(N)}isEqual(N){return this.c===N.c&&this.e===N.e}compareTo(N){return this.c<N.c?-1:this.c>N.line?1:this.e<N.e?-1:this.e>N.e?1:0}translate(N,ae=0){if(N===null||ae===null)throw(0,C.$7)();let Ie;return typeof N>"u"?Ie=0:typeof N=="number"?Ie=N:(Ie=typeof N.lineDelta=="number"?N.lineDelta:0,ae=typeof N.characterDelta=="number"?N.characterDelta:0),Ie===0&&ae===0?this:new s(this.line+Ie,this.character+ae)}with(N,ae=this.character){if(N===null||ae===null)throw(0,C.$7)();let Ie;return typeof N>"u"?Ie=this.line:typeof N=="number"?Ie=N:(Ie=typeof N.line=="number"?N.line:this.line,ae=typeof N.character=="number"?N.character:this.character),Ie===this.line&&ae===this.character?this:new s(Ie,ae)}toJSON(){return{line:this.line,character:this.character}}};e.$tK=ve,e.$tK=ve=s=Ge([W],ve);let ge=o=class{static isRange(N){return N instanceof o?!0:N?ve.isPosition(N.start)&&ve.isPosition(N.end):!1}static of(N){if(N instanceof o)return N;if(this.isRange(N))return new o(N.start,N.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(N,ae,Ie,Qe){let _e,at;if(typeof N=="number"&&typeof ae=="number"&&typeof Ie=="number"&&typeof Qe=="number"?(_e=new ve(N,ae),at=new ve(Ie,Qe)):ve.isPosition(N)&&ve.isPosition(ae)&&(_e=ve.of(N),at=ve.of(ae)),!_e||!at)throw new Error("Invalid arguments");_e.isBefore(at)?(this.c=_e,this.e=at):(this.c=at,this.e=_e)}contains(N){return o.isRange(N)?this.contains(N.start)&&this.contains(N.end):ve.isPosition(N)?!(ve.of(N).isBefore(this.c)||this.e.isBefore(N)):!1}isEqual(N){return this.c.isEqual(N.c)&&this.e.isEqual(N.e)}intersection(N){const ae=ve.Max(N.start,this.c),Ie=ve.Min(N.end,this.e);if(!ae.isAfter(Ie))return new o(ae,Ie)}union(N){if(this.contains(N))return this;if(N.contains(this))return N;const ae=ve.Min(N.start,this.c),Ie=ve.Max(N.end,this.end);return new o(ae,Ie)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(N,ae=this.end){if(N===null||ae===null)throw(0,C.$7)();let Ie;return N?ve.isPosition(N)?Ie=N:(Ie=N.start||this.start,ae=N.end||this.end):Ie=this.start,Ie.isEqual(this.c)&&ae.isEqual(this.end)?this:new o(Ie,ae)}toJSON(){return[this.start,this.end]}};e.$uK=ge,e.$uK=ge=o=Ge([W],ge);let re=$=class extends ge{static isSelection(N){return N instanceof $?!0:N?ge.isRange(N)&&ve.isPosition(N.anchor)&&ve.isPosition(N.active)&&typeof N.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(N,ae,Ie,Qe){let _e,at;if(typeof N=="number"&&typeof ae=="number"&&typeof Ie=="number"&&typeof Qe=="number"?(_e=new ve(N,ae),at=new ve(Ie,Qe)):ve.isPosition(N)&&ve.isPosition(ae)&&(_e=ve.of(N),at=ve.of(ae)),!_e||!at)throw new Error("Invalid arguments");super(_e,at),this.f=_e,this.g=at}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$vK=re,e.$vK=re=$=Ge([W],re);const oe=U=>{if(typeof U!="string"||U.length===0||!/^[0-9A-Za-z_\-]+$/.test(U))throw(0,C.$7)("connectionToken")};class ye{static isResolvedAuthority(N){return N&&typeof N=="object"&&typeof N.host=="string"&&typeof N.port=="number"&&(N.connectionToken===void 0||typeof N.connectionToken=="string")}constructor(N,ae,Ie){if(typeof N!="string"||N.length===0)throw(0,C.$7)("host");if(typeof ae!="number"||ae===0||Math.round(ae)!==ae)throw(0,C.$7)("port");typeof Ie<"u"&&oe(Ie),this.host=N,this.port=Math.round(ae),this.connectionToken=Ie}}e.$wK=ye;class De{static isManagedResolvedAuthority(N){return N&&typeof N=="object"&&typeof N.makeConnection=="function"&&(N.connectionToken===void 0||typeof N.connectionToken=="string")}constructor(N,ae){this.makeConnection=N,this.connectionToken=ae,typeof ae<"u"&&oe(ae)}}e.$xK=De;class Q extends Error{static NotAvailable(N,ae){return new Q(N,b.RemoteAuthorityResolverErrorCode.NotAvailable,ae)}static TemporarilyNotAvailable(N){return new Q(N,b.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(N,ae=b.RemoteAuthorityResolverErrorCode.Unknown,Ie){super(N),this._message=N,this._code=ae,this._detail=Ie,Object.setPrototypeOf(this,Q.prototype)}}e.$yK=Q;var ue;(function(U){U[U.LF=1]="LF",U[U.CRLF=2]="CRLF"})(ue||(e.EndOfLine=ue={}));var J;(function(U){U[U.Replace=1]="Replace",U[U.Append=2]="Append",U[U.Prepend=3]="Prepend"})(J||(e.EnvironmentVariableMutatorType=J={}));let he=a=class{static isTextEdit(N){return N instanceof a?!0:N?ge.isRange(N)&&typeof N.newText=="string":!1}static replace(N,ae){return new a(N,ae)}static insert(N,ae){return a.replace(new ge(N,N),ae)}static delete(N){return a.replace(N,"")}static setEndOfLine(N){const ae=new a(new ge(new ve(0,0),new ve(0,0)),"");return ae.newEol=N,ae}get range(){return this.c}set range(N){if(N&&!ge.isRange(N))throw(0,C.$7)("range");this.c=N}get newText(){return this.e||""}set newText(N){if(N&&typeof N!="string")throw(0,C.$7)("newText");this.e=N}get newEol(){return this.f}set newEol(N){if(N&&typeof N!="number")throw(0,C.$7)("newEol");this.f=N}constructor(N,ae){this.c=N,this.e=ae}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$zK=he,e.$zK=he=a=Ge([W],he);let de=k=class{static isNotebookCellEdit(N){return N instanceof k?!0:N?Xt.isNotebookRange(N)&&Array.isArray(N.newCells):!1}static replaceCells(N,ae){return new k(N,ae)}static insertCells(N,ae){return new k(new Xt(N,N),ae)}static deleteCells(N){return new k(N,[])}static updateCellMetadata(N,ae){const Ie=new k(new Xt(N,N),[]);return Ie.newCellMetadata=ae,Ie}static updateNotebookMetadata(N){const ae=new k(new Xt(0,0),[]);return ae.newNotebookMetadata=N,ae}constructor(N,ae){this.range=N,this.newCells=ae}};e.$AK=de,e.$AK=de=k=Ge([W],de);class le{static isSnippetTextEdit(N){return N instanceof le?!0:N?ge.isRange(N.range)&&fe.isSnippetString(N.snippet):!1}static replace(N,ae){return new le(N,ae)}static insert(N,ae){return le.replace(new ge(N,N),ae)}constructor(N,ae){this.range=N,this.snippet=ae}}e.$BK=le;var be;(function(U){U[U.File=1]="File",U[U.Text=2]="Text",U[U.Cell=3]="Cell",U[U.CellReplace=5]="CellReplace",U[U.Snippet=6]="Snippet"})(be||(e.FileEditType=be={}));let ie=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(N,ae,Ie,Qe){this.c.push({_type:1,from:N,to:ae,options:Ie,metadata:Qe})}createFile(N,ae,Ie){this.c.push({_type:1,from:void 0,to:N,options:ae,metadata:Ie})}deleteFile(N,ae,Ie){this.c.push({_type:1,from:N,to:void 0,options:ae,metadata:Ie})}e(N,ae,Ie){this.c.push({_type:3,metadata:Ie,uri:N,edit:{editType:5,metadata:ae},notebookMetadata:ae})}f(N,ae,Ie,Qe){const _e=ae.start,at=ae.end;(_e!==at||Ie.length>0)&&this.c.push({_type:5,uri:N,index:_e,count:at-_e,cells:Ie,metadata:Qe})}g(N,ae,Ie,Qe){this.c.push({_type:3,metadata:Qe,uri:N,edit:{editType:3,index:ae,metadata:Ie}})}replace(N,ae,Ie,Qe){this.c.push({_type:2,uri:N,edit:new he(ae,Ie),metadata:Qe})}insert(N,ae,Ie,Qe){this.replace(N,new ge(ae,ae),Ie,Qe)}delete(N,ae,Ie){this.replace(N,ae,"",Ie)}has(N){return this.c.some(ae=>ae._type===2&&ae.uri.toString()===N.toString())}set(N,ae){if(ae)for(const Ie of ae){if(!Ie)continue;let Qe,_e;Array.isArray(Ie)?(Qe=Ie[0],_e=Ie[1]):Qe=Ie,de.isNotebookCellEdit(Qe)?Qe.newCellMetadata?this.g(N,Qe.range.start,Qe.newCellMetadata,_e):Qe.newNotebookMetadata?this.e(N,Qe.newNotebookMetadata,_e):this.f(N,Qe.range,Qe.newCells,_e):le.isSnippetTextEdit(Qe)?this.c.push({_type:6,uri:N,range:Qe.range,edit:Qe.snippet,metadata:_e}):this.c.push({_type:2,uri:N,edit:Qe,metadata:_e})}else{for(let Ie=0;Ie<this.c.length;Ie++){const Qe=this.c[Ie];switch(Qe._type){case 2:case 6:case 3:case 5:Qe.uri.toString()===N.toString()&&(this.c[Ie]=void 0);break}}(0,f.$Ib)(this.c)}}get(N){const ae=[];for(const Ie of this.c)Ie._type===2&&Ie.uri.toString()===N.toString()&&ae.push(Ie.edit);return ae}entries(){const N=new O.$Ac;for(const ae of this.c)if(ae._type===2){let Ie=N.get(ae.uri);Ie||(Ie=[ae.uri,[]],N.set(ae.uri,Ie)),Ie[1].push(ae.edit)}return[...N.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$CK=ie,e.$CK=ie=Ge([W],ie);let fe=P=class{static isSnippetString(N){return N instanceof P?!0:N?typeof N.value=="string":!1}static c(N){return N.replace(/\$|}|\\/g,"\\$&")}constructor(N){this.e=1,this.value=N||""}appendText(N){return this.value+=P.c(N),this}appendTabstop(N=this.e++){return this.value+="$",this.value+=N,this}appendPlaceholder(N,ae=this.e++){if(typeof N=="function"){const Ie=new P;Ie.e=this.e,N(Ie),this.e=Ie.e,N=Ie.value}else N=P.c(N);return this.value+="${",this.value+=ae,this.value+=":",this.value+=N,this.value+="}",this}appendChoice(N,ae=this.e++){const Ie=N.map(Qe=>Qe.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ae,this.value+="|",this.value+=Ie,this.value+="|}",this}appendVariable(N,ae){if(typeof ae=="function"){const Ie=new P;Ie.e=this.e,ae(Ie),this.e=Ie.e,ae=Ie.value}else typeof ae=="string"&&(ae=ae.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=N,ae&&(this.value+=":",this.value+=ae),this.value+="}",this}};e.$DK=fe,e.$DK=fe=P=Ge([W],fe);var ne;(function(U){U[U.Unnecessary=1]="Unnecessary",U[U.Deprecated=2]="Deprecated"})(ne||(e.DiagnosticTag=ne={}));var ce;(function(U){U[U.Hint=3]="Hint",U[U.Information=2]="Information",U[U.Warning=1]="Warning",U[U.Error=0]="Error"})(ce||(e.DiagnosticSeverity=ce={}));let pe=h=class{static isLocation(N){return N instanceof h?!0:N?ge.isRange(N.range)&&d.URI.isUri(N.uri):!1}constructor(N,ae){if(this.uri=N,ae)if(ge.isRange(ae))this.range=ge.of(ae);else if(ve.isPosition(ae))this.range=new ge(ae,ae);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$EK=pe,e.$EK=pe=h=Ge([W],pe);let Ce=class{static is(N){return N?typeof N.message=="string"&&N.location&&ge.isRange(N.location.range)&&d.URI.isUri(N.location.uri):!1}constructor(N,ae){this.location=N,this.message=ae}static isEqual(N,ae){return N===ae?!0:!N||!ae?!1:N.message===ae.message&&N.location.range.isEqual(ae.location.range)&&N.location.uri.toString()===ae.location.uri.toString()}};e.$FK=Ce,e.$FK=Ce=Ge([W],Ce);let L=class{constructor(N,ae,Ie=ce.Error){if(!ge.isRange(N))throw new TypeError("range must be set");if(!ae)throw new TypeError("message must be set");this.range=N,this.message=ae,this.severity=Ie}toJSON(){return{severity:ce[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(N,ae){return N===ae?!0:!N||!ae?!1:N.message===ae.message&&N.severity===ae.severity&&N.code===ae.code&&N.severity===ae.severity&&N.source===ae.source&&N.range.isEqual(ae.range)&&(0,f.$ub)(N.tags,ae.tags)&&(0,f.$ub)(N.relatedInformation,ae.relatedInformation,Ce.isEqual)}};e.$GK=L,e.$GK=L=Ge([W],L);let K=class{constructor(N,ae){if(!N)throw new Error("Illegal argument, contents must be defined");Array.isArray(N)?this.contents=N:this.contents=[N],this.range=ae}};e.$HK=K,e.$HK=K=Ge([W],K);var Y;(function(U){U[U.Text=0]="Text",U[U.Read=1]="Read",U[U.Write=2]="Write"})(Y||(e.DocumentHighlightKind=Y={}));let X=class{constructor(N,ae=Y.Text){this.range=N,this.kind=ae}toJSON(){return{range:this.range,kind:Y[this.kind]}}};e.$IK=X,e.$IK=X=Ge([W],X);var H;(function(U){U[U.File=0]="File",U[U.Module=1]="Module",U[U.Namespace=2]="Namespace",U[U.Package=3]="Package",U[U.Class=4]="Class",U[U.Method=5]="Method",U[U.Property=6]="Property",U[U.Field=7]="Field",U[U.Constructor=8]="Constructor",U[U.Enum=9]="Enum",U[U.Interface=10]="Interface",U[U.Function=11]="Function",U[U.Variable=12]="Variable",U[U.Constant=13]="Constant",U[U.String=14]="String",U[U.Number=15]="Number",U[U.Boolean=16]="Boolean",U[U.Array=17]="Array",U[U.Object=18]="Object",U[U.Key=19]="Key",U[U.Null=20]="Null",U[U.EnumMember=21]="EnumMember",U[U.Struct=22]="Struct",U[U.Event=23]="Event",U[U.Operator=24]="Operator",U[U.TypeParameter=25]="TypeParameter"})(H||(e.SymbolKind=H={}));var x;(function(U){U[U.Deprecated=1]="Deprecated"})(x||(e.SymbolTag=x={}));let se=w=class{static validate(N){if(!N.name)throw new Error("name must not be falsy")}constructor(N,ae,Ie,Qe,_e){this.name=N,this.kind=ae,this.containerName=_e,typeof Ie=="string"&&(this.containerName=Ie),Qe instanceof pe?this.location=Qe:Ie instanceof ge&&(this.location=new pe(Qe,Ie)),w.validate(this)}toJSON(){return{name:this.name,kind:H[this.kind],location:this.location,containerName:this.containerName}}};e.$JK=se,e.$JK=se=w=Ge([W],se);let Le=y=class{static validate(N){if(!N.name)throw new Error("name must not be falsy");if(!N.range.contains(N.selectionRange))throw new Error("selectionRange must be contained in fullRange");N.children?.forEach(y.validate)}constructor(N,ae,Ie,Qe,_e){this.name=N,this.detail=ae,this.kind=Ie,this.range=Qe,this.selectionRange=_e,this.children=[],y.validate(this)}};e.$KK=Le,e.$KK=Le=y=Ge([W],Le);var je;(function(U){U[U.Invoke=1]="Invoke",U[U.Automatic=2]="Automatic"})(je||(e.CodeActionTriggerKind=je={}));let Ye=class{constructor(N,ae){this.title=N,this.kind=ae}};e.$LK=Ye,e.$LK=Ye=Ge([W],Ye);let Ke=M=class{constructor(N){this.value=N}append(N){return new M(this.value?this.value+M.c+N:N)}intersects(N){return this.contains(N)||N.contains(this)}contains(N){return this.value===N.value||N.value.startsWith(this.value+M.c)}};e.$MK=Ke,Ke.c=".",e.$MK=Ke=M=Ge([W],Ke),Ke.Empty=new Ke(""),Ke.QuickFix=Ke.Empty.append("quickfix"),Ke.Refactor=Ke.Empty.append("refactor"),Ke.RefactorExtract=Ke.Refactor.append("extract"),Ke.RefactorInline=Ke.Refactor.append("inline"),Ke.RefactorMove=Ke.Refactor.append("move"),Ke.RefactorRewrite=Ke.Refactor.append("rewrite"),Ke.Source=Ke.Empty.append("source"),Ke.SourceOrganizeImports=Ke.Source.append("organizeImports"),Ke.SourceFixAll=Ke.Source.append("fixAll"),Ke.Notebook=Ke.Empty.append("notebook");let tt=class{constructor(N,ae){if(this.range=N,this.parent=ae,ae&&!ae.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$NK=tt,e.$NK=tt=Ge([W],tt);class xe{constructor(N,ae,Ie,Qe,_e,at){this.kind=N,this.name=ae,this.detail=Ie,this.uri=Qe,this.range=_e,this.selectionRange=at}}e.$OK=xe;class et{constructor(N,ae){this.fromRanges=ae,this.from=N}}e.$PK=et;class rt{constructor(N,ae){this.fromRanges=ae,this.to=N}}e.$QK=rt;var nt;(function(U){U[U.Information=0]="Information",U[U.Warning=1]="Warning",U[U.Error=2]="Error"})(nt||(e.LanguageStatusSeverity=nt={}));let Ue=class{constructor(N,ae){this.range=N,this.command=ae}get isResolved(){return!!this.command}};e.$RK=Ue,e.$RK=Ue=Ge([W],Ue);let lt=V=class{static isMarkdownString(N){return N instanceof V?!0:N&&N.appendCodeblock&&N.appendMarkdown&&N.appendText&&N.value!==void 0}constructor(N,ae=!1){t.set(this,void 0),Xe(this,t,new I.$4j(N,{supportThemeIcons:ae}),"f")}get value(){return Ne(this,t,"f").value}set value(N){Ne(this,t,"f").value=N}get isTrusted(){return Ne(this,t,"f").isTrusted}set isTrusted(N){Ne(this,t,"f").isTrusted=N}get supportThemeIcons(){return Ne(this,t,"f").supportThemeIcons}set supportThemeIcons(N){Ne(this,t,"f").supportThemeIcons=N}get supportHtml(){return Ne(this,t,"f").supportHtml}set supportHtml(N){Ne(this,t,"f").supportHtml=N}get baseUri(){return Ne(this,t,"f").baseUri}set baseUri(N){Ne(this,t,"f").baseUri=N}appendText(N){return Ne(this,t,"f").appendText(N),this}appendMarkdown(N){return Ne(this,t,"f").appendMarkdown(N),this}appendCodeblock(N,ae){return Ne(this,t,"f").appendCodeblock(ae??"",N),this}};e.$SK=lt,t=new WeakMap,e.$SK=lt=V=Ge([W],lt);let _=class{constructor(N,ae){this.label=N,this.documentation=ae}};e.$TK=_,e.$TK=_=Ge([W],_);let Z=class{constructor(N,ae){this.label=N,this.documentation=ae,this.parameters=[]}};e.$UK=Z,e.$UK=Z=Ge([W],Z);let Ee=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$VK=Ee,e.$VK=Ee=Ge([W],Ee);var We;(function(U){U[U.Invoke=1]="Invoke",U[U.TriggerCharacter=2]="TriggerCharacter",U[U.ContentChange=3]="ContentChange"})(We||(e.SignatureHelpTriggerKind=We={}));var ze;(function(U){U[U.Type=1]="Type",U[U.Parameter=2]="Parameter"})(ze||(e.InlayHintKind=ze={}));let Ze=class{constructor(N){this.value=N}};e.$WK=Ze,e.$WK=Ze=Ge([W],Ze);let st=class{constructor(N,ae,Ie){this.position=N,this.label=ae,this.kind=Ie}};e.$XK=st,e.$XK=st=Ge([W],st);var vt;(function(U){U[U.Invoke=0]="Invoke",U[U.TriggerCharacter=1]="TriggerCharacter",U[U.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(vt||(e.CompletionTriggerKind=vt={}));var yt;(function(U){U[U.Text=0]="Text",U[U.Method=1]="Method",U[U.Function=2]="Function",U[U.Constructor=3]="Constructor",U[U.Field=4]="Field",U[U.Variable=5]="Variable",U[U.Class=6]="Class",U[U.Interface=7]="Interface",U[U.Module=8]="Module",U[U.Property=9]="Property",U[U.Unit=10]="Unit",U[U.Value=11]="Value",U[U.Enum=12]="Enum",U[U.Keyword=13]="Keyword",U[U.Snippet=14]="Snippet",U[U.Color=15]="Color",U[U.File=16]="File",U[U.Reference=17]="Reference",U[U.Folder=18]="Folder",U[U.EnumMember=19]="EnumMember",U[U.Constant=20]="Constant",U[U.Struct=21]="Struct",U[U.Event=22]="Event",U[U.Operator=23]="Operator",U[U.TypeParameter=24]="TypeParameter",U[U.User=25]="User",U[U.Issue=26]="Issue"})(yt||(e.CompletionItemKind=yt={}));var Mt;(function(U){U[U.Deprecated=1]="Deprecated"})(Mt||(e.CompletionItemTag=Mt={}));let Vt=class{constructor(N,ae){this.label=N,this.kind=ae}toJSON(){return{label:this.label,kind:this.kind&&yt[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$YK=Vt,e.$YK=Vt=Ge([W],Vt);let qt=class{constructor(N=[],ae=!1){this.items=N,this.isIncomplete=ae}};e.$ZK=qt,e.$ZK=qt=Ge([W],qt);let Et=class{constructor(N,ae,Ie){this.insertText=N,this.range=ae,this.command=Ie}};e.$1K=Et,e.$1K=Et=Ge([W],Et);let Lt=class{constructor(N){this.commands=void 0,this.suppressSuggestions=void 0,this.items=N}};e.$2K=Lt,e.$2K=Lt=Ge([W],Lt);var Ot;(function(U){U[U.Active=-1]="Active",U[U.Beside=-2]="Beside",U[U.One=1]="One",U[U.Two=2]="Two",U[U.Three=3]="Three",U[U.Four=4]="Four",U[U.Five=5]="Five",U[U.Six=6]="Six",U[U.Seven=7]="Seven",U[U.Eight=8]="Eight",U[U.Nine=9]="Nine"})(Ot||(e.ViewColumn=Ot={}));var xt;(function(U){U[U.Left=1]="Left",U[U.Right=2]="Right"})(xt||(e.StatusBarAlignment=xt={}));function Yt(U,N){return`${S.$8l.toKey(U)}.${N}`}e.$3K=Yt;var It;(function(U){U[U.Off=0]="Off",U[U.On=1]="On",U[U.Relative=2]="Relative"})(It||(e.TextEditorLineNumbersStyle=It={}));var Nt;(function(U){U[U.Manual=1]="Manual",U[U.AfterDelay=2]="AfterDelay",U[U.FocusOut=3]="FocusOut"})(Nt||(e.TextDocumentSaveReason=Nt={}));var Qt;(function(U){U[U.Default=0]="Default",U[U.InCenter=1]="InCenter",U[U.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",U[U.AtTop=3]="AtTop"})(Qt||(e.TextEditorRevealType=Qt={}));var zt;(function(U){U[U.Keyboard=1]="Keyboard",U[U.Mouse=2]="Mouse",U[U.Command=3]="Command"})(zt||(e.TextEditorSelectionChangeKind=zt={}));var Kt;(function(U){U[U.Undo=1]="Undo",U[U.Redo=2]="Redo"})(Kt||(e.TextDocumentChangeReason=Kt={}));var Ht;(function(U){U[U.OpenOpen=0]="OpenOpen",U[U.ClosedClosed=1]="ClosedClosed",U[U.OpenClosed=2]="OpenClosed",U[U.ClosedOpen=3]="ClosedOpen"})(Ht||(e.DecorationRangeBehavior=Ht={})),function(U){function N(ae){switch(ae){case"keyboard":return U.Keyboard;case"mouse":return U.Mouse;case"api":return U.Command}}U.fromValue=N}(zt||(e.TextEditorSelectionChangeKind=zt={}));var Ct;(function(U){U[U.Other=0]="Other",U[U.Comment=1]="Comment",U[U.String=2]="String",U[U.RegEx=3]="RegEx"})(Ct||(e.SyntaxTokenType=Ct={})),function(U){function N(ae){switch(ae){case U.Other:return"other";case U.Comment:return"comment";case U.String:return"string";case U.RegEx:return"regex"}return"other"}U.toString=N}(Ct||(e.SyntaxTokenType=Ct={}));let ct=class{constructor(N,ae){if(ae&&!d.URI.isUri(ae))throw(0,C.$7)("target");if(!ge.isRange(N)||N.isEmpty)throw(0,C.$7)("range");this.range=N,this.target=ae}};e.$4K=ct,e.$4K=ct=Ge([W],ct);let ht=class{constructor(N,ae,Ie,Qe){this.red=N,this.green=ae,this.blue=Ie,this.alpha=Qe}};e.$5K=ht,e.$5K=ht=Ge([W],ht);let Pt=class{constructor(N,ae){if(ae&&!(ae instanceof ht))throw(0,C.$7)("color");if(!ge.isRange(N)||N.isEmpty)throw(0,C.$7)("range");this.range=N,this.color=ae}};e.$6K=Pt,e.$6K=Pt=Ge([W],Pt);let Tt=class{constructor(N){if(!N||typeof N!="string")throw(0,C.$7)("label");this.label=N}};e.$7K=Tt,e.$7K=Tt=Ge([W],Tt);var Ft;(function(U){U[U.RGB=0]="RGB",U[U.HEX=1]="HEX",U[U.HSL=2]="HSL"})(Ft||(e.ColorFormat=Ft={}));var ut;(function(U){U[U.Error=0]="Error",U[U.Warning=1]="Warning",U[U.Information=2]="Information"})(ut||(e.SourceControlInputBoxValidationType=ut={}));var Dt;(function(U){U[U.Unknown=0]="Unknown",U[U.Shutdown=1]="Shutdown",U[U.Process=2]="Process",U[U.User=3]="User",U[U.Extension=4]="Extension"})(Dt||(e.TerminalExitReason=Dt={}));class Ut{constructor(N,ae,Ie){if(this.startIndex=N,this.length=ae,this.tooltip=Ie,typeof N!="number"||N<0)throw(0,C.$7)("startIndex");if(typeof ae!="number"||ae<1)throw(0,C.$7)("length");if(Ie!==void 0&&typeof Ie!="string")throw(0,C.$7)("tooltip")}}e.$8K=Ut;class jt{constructor(N){this.uri=N}}e.$9K=jt;class Ve{constructor(N){this.terminalCommand=N}}e.$0K=Ve;var Jt;(function(U){U[U.Panel=1]="Panel",U[U.Editor=2]="Editor"})(Jt||(e.TerminalLocation=Jt={}));class Pe{constructor(N){if(this.options=N,typeof N!="object")throw(0,C.$7)("options")}}e.$$K=Pe;var Fe;(function(U){U[U.Always=1]="Always",U[U.Silent=2]="Silent",U[U.Never=3]="Never"})(Fe||(e.TaskRevealKind=Fe={}));var $e;(function(U){U[U.Shared=1]="Shared",U[U.Dedicated=2]="Dedicated",U[U.New=3]="New"})($e||(e.TaskPanelKind=$e={}));let G=B=class{static from(N){switch(N){case"clean":return B.Clean;case"build":return B.Build;case"rebuild":return B.Rebuild;case"test":return B.Test;default:return}}constructor(N,ae){if(this.label=ae,typeof N!="string"||typeof ae!="string")throw(0,C.$7)("name");this.c=N}get id(){return this.c}};e.$_K=G,G.Clean=new B("clean","Clean"),G.Build=new B("build","Build"),G.Rebuild=new B("rebuild","Rebuild"),G.Test=new B("test","Test"),e.$_K=G=B=Ge([W],G);function Me(U){let N="";for(let ae=0;ae<U.length;ae++)N+=U[ae].replace(/,/g,",,")+",";return N}let Be=class{constructor(N,ae,Ie){if(typeof N!="string")throw(0,C.$7)("process");this.e=[],this.c=N,ae!==void 0&&(Array.isArray(ae)?(this.e=ae,this.f=Ie):this.f=ae)}get process(){return this.c}set process(N){if(typeof N!="string")throw(0,C.$7)("process");this.c=N}get args(){return this.e}set args(N){Array.isArray(N)||(N=[]),this.e=N}get options(){return this.f}set options(N){this.f=N}computeId(){const N=[];if(N.push("process"),this.c!==void 0&&N.push(this.c),this.e&&this.e.length>0)for(const ae of this.e)N.push(ae);return Me(N)}};e.$aL=Be,e.$aL=Be=Ge([W],Be);let Je=class{constructor(N,ae,Ie){if(this.f=[],Array.isArray(ae)){if(!N)throw(0,C.$7)("command can't be undefined or null");if(typeof N!="string"&&typeof N.value!="string")throw(0,C.$7)("command");this.e=N,this.f=ae,this.g=Ie}else{if(typeof N!="string")throw(0,C.$7)("commandLine");this.c=N,this.g=ae}}get commandLine(){return this.c}set commandLine(N){if(typeof N!="string")throw(0,C.$7)("commandLine");this.c=N}get command(){return this.e?this.e:""}set command(N){if(typeof N!="string"&&typeof N.value!="string")throw(0,C.$7)("command");this.e=N}get args(){return this.f}set args(N){this.f=N||[]}get options(){return this.g}set options(N){this.g=N}computeId(){const N=[];if(N.push("shell"),this.c!==void 0&&N.push(this.c),this.e!==void 0&&N.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const ae of this.f)N.push(typeof ae=="string"?ae:ae.value);return Me(N)}};e.$bL=Je,e.$bL=Je=Ge([W],Je);var He;(function(U){U[U.Escape=1]="Escape",U[U.Strong=2]="Strong",U[U.Weak=3]="Weak"})(He||(e.ShellQuoting=He={}));var it;(function(U){U[U.Global=1]="Global",U[U.Workspace=2]="Workspace"})(it||(e.TaskScope=it={}));class St{constructor(N){this.c=N}computeId(){return"customExecution"+(0,R.$fg)()}set callback(N){this.c=N}get callback(){return this.c}}e.$cL=St;let bt=z=class{constructor(N,ae,Ie,Qe,_e,at){this.j=!1,this.k=this.definition=N;let ft;typeof ae=="string"?(this.m=this.name=ae,this.t=this.source=Ie,this.execution=Qe,ft=_e,this.j=!0):ae===it.Global||ae===it.Workspace?(this.target=ae,this.m=this.name=Ie,this.t=this.source=Qe,this.execution=_e,ft=at):(this.target=ae,this.m=this.name=Ie,this.t=this.source=Qe,this.execution=_e,ft=at),typeof ft=="string"?(this.o=[ft],this.q=!0):Array.isArray(ft)?(this.o=ft,this.q=!0):(this.o=[],this.q=!1),this.r=!1,this.w=Object.create(null),this.x=Object.create(null)}get _id(){return this.h}set _id(N){this.h=N}get _deprecated(){return this.j}z(){this.h!==void 0&&(this.h=void 0,this.l=void 0,this.A())}A(){this.n instanceof Be?this.k={type:z.e,id:this.n.computeId()}:this.n instanceof Je?this.k={type:z.f,id:this.n.computeId()}:this.n instanceof St?this.k={type:z.c,id:this.n.computeId()}:this.k={type:z.g,id:(0,R.$fg)()}}get definition(){return this.k}set definition(N){if(N==null)throw(0,C.$7)("Kind can't be undefined or null");this.z(),this.k=N}get scope(){return this.l}set target(N){this.z(),this.l=N}get name(){return this.m}set name(N){if(typeof N!="string")throw(0,C.$7)("name");this.z(),this.m=N}get execution(){return this.n}set execution(N){N===null&&(N=void 0),this.z(),this.n=N;const ae=this.k.type;(z.g===ae||z.e===ae||z.f===ae||z.c===ae)&&this.A()}get problemMatchers(){return this.o}set problemMatchers(N){if(Array.isArray(N))this.z(),this.o=N,this.q=!0;else{this.z(),this.o=[],this.q=!1;return}}get hasDefinedMatchers(){return this.q}get isBackground(){return this.r}set isBackground(N){N!==!0&&N!==!1&&(N=!1),this.z(),this.r=N}get source(){return this.t}set source(N){if(typeof N!="string"||N.length===0)throw(0,C.$7)("source must be a string of length > 0");this.z(),this.t=N}get group(){return this.u}set group(N){N===null&&(N=void 0),this.z(),this.u=N}get detail(){return this.y}set detail(N){N===null&&(N=void 0),this.y=N}get presentationOptions(){return this.w}set presentationOptions(N){N==null&&(N=Object.create(null)),this.z(),this.w=N}get runOptions(){return this.x}set runOptions(N){N==null&&(N=Object.create(null)),this.z(),this.x=N}};e.$dL=bt,bt.c="customExecution",bt.e="process",bt.f="shell",bt.g="$empty",e.$dL=bt=z=Ge([W],bt);var $t;(function(U){U[U.SourceControl=1]="SourceControl",U[U.Window=10]="Window",U[U.Notification=15]="Notification"})($t||(e.ProgressLocation=$t={}));var gt;(function(U){function N(ae){const Ie=ae;return(0,E.$Df)(Ie.value)?Ie.tooltip&&!(0,E.$zf)(Ie.tooltip)?(console.log("INVALID view badge, invalid tooltip",Ie.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Ie.value),!1)}U.isViewBadge=N})(gt||(e.ViewBadge=gt={}));let mt=T=class{static isTreeItem(N,ae){const Ie=N;if(Ie.checkboxState!==void 0){const Qe=(0,E.$Df)(Ie.checkboxState)?Ie.checkboxState:(0,E.$Bf)(Ie.checkboxState)&&(0,E.$Df)(Ie.checkboxState.state)?Ie.checkboxState.state:void 0,_e=!(0,E.$Df)(Ie.checkboxState)&&(0,E.$Bf)(Ie.checkboxState)?Ie.checkboxState.tooltip:void 0;if(Qe===void 0||Qe!==Gt.Checked&&Qe!==Gt.Unchecked||_e!==void 0&&!(0,E.$zf)(_e))return console.log("INVALID tree item, invalid checkboxState",Ie.checkboxState),!1}if(N instanceof T)return!0;if(Ie.label!==void 0&&!(0,E.$zf)(Ie.label)&&!Ie.label?.label)return console.log("INVALID tree item, invalid label",Ie.label),!1;if(Ie.id!==void 0&&!(0,E.$zf)(Ie.id))return console.log("INVALID tree item, invalid id",Ie.id),!1;if(Ie.iconPath!==void 0&&!(0,E.$zf)(Ie.iconPath)&&!d.URI.isUri(Ie.iconPath)&&(!Ie.iconPath||!(0,E.$zf)(Ie.iconPath.id))){const Qe=Ie.iconPath;if(!Qe||!(0,E.$zf)(Qe.light)&&!d.URI.isUri(Qe.light)&&!(0,E.$zf)(Qe.dark)&&!d.URI.isUri(Qe.dark))return console.log("INVALID tree item, invalid iconPath",Ie.iconPath),!1}return Ie.description!==void 0&&!(0,E.$zf)(Ie.description)&&typeof Ie.description!="boolean"?(console.log("INVALID tree item, invalid description",Ie.description),!1):Ie.resourceUri!==void 0&&!d.URI.isUri(Ie.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Ie.resourceUri),!1):Ie.tooltip!==void 0&&!(0,E.$zf)(Ie.tooltip)&&!(Ie.tooltip instanceof lt)?(console.log("INVALID tree item, invalid tooltip",Ie.tooltip),!1):Ie.command!==void 0&&!Ie.command.command?(console.log("INVALID tree item, invalid command",Ie.command),!1):Ie.collapsibleState!==void 0&&Ie.collapsibleState<ci.None&&Ie.collapsibleState>ci.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Ie.collapsibleState),!1):Ie.contextValue!==void 0&&!(0,E.$zf)(Ie.contextValue)?(console.log("INVALID tree item, invalid contextValue",Ie.contextValue),!1):Ie.accessibilityInformation!==void 0&&!Ie.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Ie.accessibilityInformation),!1):!0}constructor(N,ae=ci.None){this.collapsibleState=ae,d.URI.isUri(N)?this.resourceUri=N:this.label=N}};e.$eL=mt,e.$eL=mt=T=Ge([W],mt);var ci;(function(U){U[U.None=0]="None",U[U.Collapsed=1]="Collapsed",U[U.Expanded=2]="Expanded"})(ci||(e.TreeItemCollapsibleState=ci={}));var Gt;(function(U){U[U.Unchecked=0]="Unchecked",U[U.Checked=1]="Checked"})(Gt||(e.TreeItemCheckboxState=Gt={}));let wi=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(N){this.value=N}};e.$fL=wi,e.$fL=wi=Ge([W],wi);class hi extends wi{}e.$gL=hi;class Ji extends hi{constructor(N){super(""),i.set(this,void 0),Xe(this,i,N,"f")}asFile(){return Ne(this,i,"f")}}e.$hL=Ji,i=new WeakMap;class At{constructor(N,ae,Ie,Qe){this.name=N,this.uri=ae,this._itemId=Ie,this.c=Qe}data(){return this.c()}}e.$iL=At;let Pi=class{constructor(N){l.add(this),v.set(this,new Map);for(const[ae,Ie]of N??[]){const Qe=Ne(this,v,"f").get(Ne(this,l,"m",D).call(this,ae));Qe?Qe.push(Ie):Ne(this,v,"f").set(Ne(this,l,"m",D).call(this,ae),[Ie])}}get(N){return Ne(this,v,"f").get(Ne(this,l,"m",D).call(this,N))?.[0]}set(N,ae){Ne(this,v,"f").set(Ne(this,l,"m",D).call(this,N),[ae])}forEach(N,ae){for(const[Ie,Qe]of Ne(this,v,"f"))for(const _e of Qe)N.call(ae,_e,Ie,this)}*[(v=new WeakMap,l=new WeakSet,Symbol.iterator)](){for(const[N,ae]of Ne(this,v,"f"))for(const Ie of ae)yield[N,Ie]}};e.$jL=Pi,D=function(N){return N.toLowerCase()},e.$jL=Pi=Ge([W],Pi);let Ai=class{constructor(N){this.insertText=N}};e.$kL=Ai,e.$kL=Ai=Ge([W],Ai);let kt=class{constructor(N,ae){this.label=ae,this.insertText=N}};e.$lL=kt,e.$lL=kt=Ge([W],kt);let Zt=class{constructor(N,ae){this.id=N,this.color=ae}static isThemeIcon(N){return typeof N.id!="string"?(console.log("INVALID ThemeIcon, invalid id",N.id),!1):!0}};e.$mL=Zt,e.$mL=Zt=Ge([W],Zt),Zt.File=new Zt("file"),Zt.Folder=new Zt("folder");let bi=class{constructor(N){this.id=N}};e.$nL=bi,e.$nL=bi=Ge([W],bi);var fi;(function(U){U[U.Global=1]="Global",U[U.Workspace=2]="Workspace",U[U.WorkspaceFolder=3]="WorkspaceFolder"})(fi||(e.ConfigurationTarget=fi={}));let Ri=class{get base(){return this.c}set base(N){this.c=N,this.e=d.URI.file(N)}get baseUri(){return this.e}set baseUri(N){this.e=N,this.c=N.fsPath}constructor(N,ae){if(typeof N!="string"&&(!N||!d.URI.isUri(N)&&!d.URI.isUri(N.uri)))throw(0,C.$7)("base");if(typeof ae!="string")throw(0,C.$7)("pattern");typeof N=="string"?this.baseUri=d.URI.file(N):d.URI.isUri(N)?this.baseUri=N:this.baseUri=N.uri,this.pattern=ae}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$oL=Ri,e.$oL=Ri=Ge([W],Ri);const Yi=new WeakMap;function Bt(U,N){Yi.set(U,N)}e.$pL=Bt;let ri=class{constructor(N,ae,Ie,Qe){this.enabled=typeof N=="boolean"?N:!0,typeof ae=="string"&&(this.condition=ae),typeof Ie=="string"&&(this.hitCondition=Ie),typeof Qe=="string"&&(this.logMessage=Qe)}get id(){return this.c||(this.c=Yi.get(this)??(0,R.$fg)()),this.c}};e.$qL=ri,e.$qL=ri=Ge([W],ri);let Mi=class extends ri{constructor(N,ae,Ie,Qe,_e){if(super(ae,Ie,Qe,_e),N===null)throw(0,C.$7)("location");this.location=N}};e.$rL=Mi,e.$rL=Mi=Ge([W],Mi);let ui=class extends ri{constructor(N,ae,Ie,Qe,_e){super(ae,Ie,Qe,_e),this.functionName=N}};e.$sL=ui,e.$sL=ui=Ge([W],ui);let li=class extends ri{constructor(N,ae,Ie,Qe,_e,at,ft){if(super(Qe,_e,at,ft),!ae)throw(0,C.$7)("dataId");this.label=N,this.dataId=ae,this.canPersist=Ie}};e.$tL=li,e.$tL=li=Ge([W],li);let dt=class{constructor(N,ae,Ie){this.command=N,this.args=ae||[],this.options=Ie}};e.$uL=dt,e.$uL=dt=Ge([W],dt);let Fi=class{constructor(N,ae){this.port=N,this.host=ae}};e.$vL=Fi,e.$vL=Fi=Ge([W],Fi);let ei=class{constructor(N){this.path=N}};e.$wL=ei,e.$wL=ei=Ge([W],ei);let si=class{constructor(N){this.implementation=N}};e.$xL=si,e.$xL=si=Ge([W],si);let yi=class{constructor(N,ae,Ie){this.session=N,this.threadId=ae,this.frameId=Ie}};e.$yL=yi,e.$yL=yi=Ge([W],yi);let Ti=class{constructor(N,ae){this.session=N,this.threadId=ae}};e.$zL=Ti,e.$zL=Ti=Ge([W],Ti);let Li=class{constructor(N,ae){this.range=N,this.expression=ae}};e.$AL=Li,e.$AL=Li=Ge([W],Li);var Zi;(function(U){U[U.Invoke=0]="Invoke",U[U.Automatic=1]="Automatic"})(Zi||(e.InlineCompletionTriggerKind=Zi={}));let Ei=class{constructor(N,ae){this.range=N,this.text=ae}};e.$BL=Ei,e.$BL=Ei=Ge([W],Ei);let Oi=class{constructor(N,ae,Ie=!0){this.range=N,this.variableName=ae,this.caseSensitiveLookup=Ie}};e.$CL=Oi,e.$CL=Oi=Ge([W],Oi);let Di=class{constructor(N,ae){this.range=N,this.expression=ae}};e.$DL=Di,e.$DL=Di=Ge([W],Di);let oi=class{constructor(N,ae){this.frameId=N,this.stoppedLocation=ae}};e.$EL=oi,e.$EL=oi=Ge([W],oi);var Xi;(function(U){U[U.Changed=1]="Changed",U[U.Created=2]="Created",U[U.Deleted=3]="Deleted"})(Xi||(e.FileChangeType=Xi={}));let gi=F=class extends Error{static FileExists(N){return new F(N,u.FileSystemProviderErrorCode.FileExists,F.FileExists)}static FileNotFound(N){return new F(N,u.FileSystemProviderErrorCode.FileNotFound,F.FileNotFound)}static FileNotADirectory(N){return new F(N,u.FileSystemProviderErrorCode.FileNotADirectory,F.FileNotADirectory)}static FileIsADirectory(N){return new F(N,u.FileSystemProviderErrorCode.FileIsADirectory,F.FileIsADirectory)}static NoPermissions(N){return new F(N,u.FileSystemProviderErrorCode.NoPermissions,F.NoPermissions)}static Unavailable(N){return new F(N,u.FileSystemProviderErrorCode.Unavailable,F.Unavailable)}constructor(N,ae=u.FileSystemProviderErrorCode.Unknown,Ie){super(d.URI.isUri(N)?N.toString(!0):N),this.code=Ie?.name??"Unknown",(0,u.$ok)(this,ae),Object.setPrototypeOf(this,F.prototype),typeof Error.captureStackTrace=="function"&&typeof Ie=="function"&&Error.captureStackTrace(this,Ie)}};e.$FL=gi,e.$FL=gi=F=Ge([W],gi);let mi=class{constructor(N,ae,Ie){this.start=N,this.end=ae,this.kind=Ie}};e.$GL=mi,e.$GL=mi=Ge([W],mi);var _i;(function(U){U[U.Comment=1]="Comment",U[U.Imports=2]="Imports",U[U.Region=3]="Region"})(_i||(e.FoldingRangeKind=_i={}));var xi;(function(U){U[U.Collapsed=0]="Collapsed",U[U.Expanded=1]="Expanded"})(xi||(e.CommentThreadCollapsibleState=xi={}));var di;(function(U){U[U.Editing=0]="Editing",U[U.Preview=1]="Preview"})(di||(e.CommentMode=di={}));var en;(function(U){U[U.Published=0]="Published",U[U.Draft=1]="Draft"})(en||(e.CommentState=en={}));var tn;(function(U){U[U.Unresolved=0]="Unresolved",U[U.Resolved=1]="Resolved"})(tn||(e.CommentThreadState=tn={}));class fn{constructor(N,ae=[]){this.tokenTypes=N,this.tokenModifiers=ae}}e.$HL=fn;function ki(U){return typeof U>"u"||(0,E.$Af)(U)}class Ni{constructor(N){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.h=0,this.j=new Map,this.k=new Map,this.l=!1,N){this.l=!0;for(let ae=0,Ie=N.tokenTypes.length;ae<Ie;ae++)this.j.set(N.tokenTypes[ae],ae);for(let ae=0,Ie=N.tokenModifiers.length;ae<Ie;ae++)this.k.set(N.tokenModifiers[ae],ae)}}push(N,ae,Ie,Qe,_e){if(typeof N=="number"&&typeof ae=="number"&&typeof Ie=="number"&&typeof Qe=="number"&&(typeof _e=="number"||typeof _e>"u"))return typeof _e>"u"&&(_e=0),this.n(N,ae,Ie,Qe,_e);if(ge.isRange(N)&&typeof ae=="string"&&ki(Ie))return this.m(N,ae,Ie);throw(0,C.$7)()}m(N,ae,Ie){if(!this.l)throw new Error("Legend must be provided in constructor");if(N.start.line!==N.end.line)throw new Error("`range` cannot span multiple lines");if(!this.j.has(ae))throw new Error("`tokenType` is not in the provided legend");const Qe=N.start.line,_e=N.start.character,at=N.end.character-N.start.character,ft=this.j.get(ae);let Wt=0;if(Ie)for(const _t of Ie){if(!this.k.has(_t))throw new Error("`tokenModifier` is not in the provided legend");const ii=this.k.get(_t);Wt|=1<<ii>>>0}this.n(Qe,_e,at,ft,Wt)}n(N,ae,Ie,Qe,_e){if(this.f&&(N<this.c||N===this.c&&ae<this.e)){this.f=!1;const Wt=this.g.length/5|0;let _t=0,ii=0;for(let ni=0;ni<Wt;ni++){let ai=this.g[5*ni],Gi=this.g[5*ni+1];ai===0?(ai=_t,Gi+=ii):ai+=_t,this.g[5*ni]=ai,this.g[5*ni+1]=Gi,_t=ai,ii=Gi}}let at=N,ft=ae;this.f&&this.h>0&&(at-=this.c,at===0&&(ft-=this.e)),this.g[this.h++]=at,this.g[this.h++]=ft,this.g[this.h++]=Ie,this.g[this.h++]=Qe,this.g[this.h++]=_e,this.c=N,this.e=ae}static o(N){const ae=[],Ie=N.length/5|0;for(let ft=0;ft<Ie;ft++)ae[ft]=ft;ae.sort((ft,Wt)=>{const _t=N[5*ft],ii=N[5*Wt];if(_t===ii){const ni=N[5*ft+1],ai=N[5*Wt+1];return ni-ai}return _t-ii});const Qe=new Uint32Array(N.length);let _e=0,at=0;for(let ft=0;ft<Ie;ft++){const Wt=5*ae[ft],_t=N[Wt+0],ii=N[Wt+1],ni=N[Wt+2],ai=N[Wt+3],Gi=N[Wt+4],Mn=_t-_e,qn=Mn===0?ii-at:ii,Qi=5*ft;Qe[Qi+0]=Mn,Qe[Qi+1]=qn,Qe[Qi+2]=ni,Qe[Qi+3]=ai,Qe[Qi+4]=Gi,_e=_t,at=ii}return Qe}build(N){return this.f?new zi(new Uint32Array(this.g),N):new zi(Ni.o(this.g),N)}}e.$IL=Ni;class zi{constructor(N,ae){this.resultId=ae,this.data=N}}e.$JL=zi;class gn{constructor(N,ae,Ie){this.start=N,this.deleteCount=ae,this.data=Ie}}e.$KL=gn;class Si{constructor(N,ae){this.resultId=ae,this.edits=N}}e.$LL=Si;var Ui;(function(U){U[U.Separate=0]="Separate",U[U.MergeWithParent=1]="MergeWithParent"})(Ui||(e.DebugConsoleMode=Ui={}));let Ii=class{constructor(){}};e.$ML=Ii,Ii.Back={iconPath:new Zt("arrow-left")},e.$ML=Ii=Ge([W],Ii);var ji;(function(U){U[U.Separator=-1]="Separator",U[U.Default=0]="Default"})(ji||(e.QuickPickItemKind=ji={}));var Bi;(function(U){U[U.Info=1]="Info",U[U.Warning=2]="Warning",U[U.Error=3]="Error"})(Bi||(e.InputBoxValidationSeverity=Bi={}));var nn;(function(U){U[U.UI=1]="UI",U[U.Workspace=2]="Workspace"})(nn||(e.ExtensionKind=nn={}));class mn{static validate(N){if(typeof N.badge=="string"){let ae=(0,c.$af)(N.badge,0);if(ae<N.badge.length&&(ae+=(0,c.$af)(N.badge,ae)),N.badge.length>ae)throw new Error("The 'badge'-property must be undefined or a short character")}else if(N.badge&&!Zt.isThemeIcon(N.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!N.color&&!N.badge&&!N.tooltip)throw new Error("The decoration is empty");return!0}constructor(N,ae,Ie){this.badge=N,this.tooltip=ae,this.color=Ie}}e.$NL=mn;let Wi=class{constructor(N){this.kind=N}};e.$OL=Wi,e.$OL=Wi=Ge([W],Wi);var rn;(function(U){U[U.Light=1]="Light",U[U.Dark=2]="Dark",U[U.HighContrast=3]="HighContrast",U[U.HighContrastLight=4]="HighContrastLight"})(rn||(e.ColorThemeKind=rn={}));class Xt{static isNotebookRange(N){return N instanceof Xt?!0:N?typeof N.start=="number"&&typeof N.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(N,ae){if(N<0)throw(0,C.$7)("start must be positive");if(ae<0)throw(0,C.$7)("end must be positive");N<=ae?(this.c=N,this.e=ae):(this.c=ae,this.e=N)}with(N){let ae=this.c,Ie=this.e;return N.start!==void 0&&(ae=N.start),N.end!==void 0&&(Ie=N.end),ae===this.c&&Ie===this.e?this:new Xt(ae,Ie)}}e.$PL=Xt;class $i{static validate(N){if(typeof N.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof N.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof N.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(N){return Array.isArray(N)&&N.every(ae=>$i.isNotebookCellData(ae))}static isNotebookCellData(N){return!0}constructor(N,ae,Ie,Qe,_e,at,ft){this.kind=N,this.value=ae,this.languageId=Ie,this.mime=Qe,this.outputs=_e??[],this.metadata=at,this.executionSummary=ft,$i.validate(this)}}e.$QL=$i;class Oe{constructor(N){this.cells=N}}e.$RL=Oe;class ti{static isNotebookCellOutputItem(N){return N instanceof m?!0:N?typeof N.mime=="string"&&N.data instanceof Uint8Array:!1}static error(N){const ae={name:N.name,message:N.message,stack:N.stack};return m.json(ae,"application/vnd.code.notebook.error")}static stdout(N){return m.text(N,"application/vnd.code.notebook.stdout")}static stderr(N){return m.text(N,"application/vnd.code.notebook.stderr")}static bytes(N,ae="application/octet-stream"){return new m(N,ae)}static text(N,ae=A.$Ur.text){const Ie=Ne(m,m,"f",n).encode(String(N));return new m(Ie,ae)}static json(N,ae="text/x-json"){const Ie=JSON.stringify(N,void 0,"	");return m.text(Ie,ae)}constructor(N,ae){this.data=N,this.mime=ae;const Ie=(0,A.$Yr)(ae,!0);if(!Ie)throw new Error(`INVALID mime type: ${ae}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Ie}}e.$SL=ti,m=ti,n={value:new TextEncoder};class pi{static isNotebookCellOutput(N){return N instanceof pi?!0:!N||typeof N!="object"?!1:typeof N.id=="string"&&Array.isArray(N.items)}static ensureUniqueMimeTypes(N,ae=!1){const Ie=new Set,Qe=new Set;for(let _e=0;_e<N.length;_e++){const at=N[_e],ft=(0,A.$Yr)(at.mime);if(!Ie.has(ft)||(0,p.$zI)(ft)){Ie.add(ft);continue}Qe.add(_e),ae&&console.warn(`DUPLICATED mime type '${at.mime}' will be dropped`)}return Qe.size===0?N:N.filter((_e,at)=>!Qe.has(at))}constructor(N,ae,Ie){this.items=pi.ensureUniqueMimeTypes(N,!0),typeof ae=="string"?(this.id=ae,this.metadata=Ie):(this.id=(0,R.$fg)(),this.metadata=ae??Ie)}}e.$TL=pi;var pt;(function(U){U[U.Markup=1]="Markup",U[U.Code=2]="Code"})(pt||(e.NotebookCellKind=pt={}));var sn;(function(U){U[U.Idle=1]="Idle",U[U.Pending=2]="Pending",U[U.Executing=3]="Executing"})(sn||(e.NotebookCellExecutionState=sn={}));var on;(function(U){U[U.Left=1]="Left",U[U.Right=2]="Right"})(on||(e.NotebookCellStatusBarAlignment=on={}));var Vi;(function(U){U[U.Default=0]="Default",U[U.InCenter=1]="InCenter",U[U.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",U[U.AtTop=3]="AtTop"})(Vi||(e.NotebookEditorRevealType=Vi={}));class $n{constructor(N,ae){this.text=N,this.alignment=ae}}e.$UL=$n;var vi;(function(U){U[U.Default=1]="Default",U[U.Preferred=2]="Preferred"})(vi||(e.NotebookControllerAffinity=vi={}));var an;(function(U){U[U.Default=1]="Default",U[U.Preferred=2]="Preferred",U[U.Hidden=-1]="Hidden"})(an||(e.NotebookControllerAffinity2=an={}));class pn{constructor(N,ae=[]){this.uri=N,this.provides=(0,f.$3b)(ae)}}e.$VL=pn;class vn{constructor(N){this.label=N}}e.$WL=vn;let Ci=class{constructor(N,ae){this.label=N,this.timestamp=ae}};e.$XL=Ci,e.$XL=Ci=Ge([W],Ci);var cn;(function(U){U[U.Production=1]="Production",U[U.Development=2]="Development",U[U.Test=3]="Test"})(cn||(e.ExtensionMode=cn={}));var un;(function(U){U[U.Node=1]="Node",U[U.Webworker=2]="Webworker"})(un||(e.ExtensionRuntime=un={}));var ln;(function(U){U[U.Other=0]="Other",U[U.Comment=1]="Comment",U[U.String=2]="String",U[U.RegEx=3]="RegEx"})(ln||(e.StandardTokenType=ln={}));class wn{constructor(N,ae){this.ranges=N,this.wordPattern=ae}}e.$YL=wn;class bn{constructor(N){this.c=N}get autoForwardAction(){return this.c}}e.$ZL=bn;var dn;(function(U){U[U.Queued=1]="Queued",U[U.Running=2]="Running",U[U.Passed=3]="Passed",U[U.Failed=4]="Failed",U[U.Skipped=5]="Skipped",U[U.Errored=6]="Errored"})(dn||(e.TestResultState=dn={}));var hn;(function(U){U[U.Run=1]="Run",U[U.Debug=2]="Debug",U[U.Coverage=3]="Coverage"})(hn||(e.TestRunProfileKind=hn={}));let qi=class{constructor(N=void 0,ae=void 0,Ie=void 0,Qe=!1){this.include=N,this.exclude=ae,this.profile=Ie,this.continuous=Qe}};e.$1L=qi,e.$1L=qi=Ge([W],qi);let Ki=j=class{static diff(N,ae,Ie){const Qe=new j(N);return Qe.expectedOutput=ae,Qe.actualOutput=Ie,Qe}constructor(N){this.message=N}};e.$2L=Ki,e.$2L=Ki=j=Ge([W],Ki);let Hi=class{constructor(N){this.id=N}};e.$3L=Hi,e.$3L=Hi=Ge([W],Hi);let te=class{constructor(N,ae){this.covered=N,this.total=ae}};e.$4L=te,e.$4L=te=Ge([W],te);let me=q=class{static fromDetails(N,ae){const Ie=new te(0,0),Qe=new te(0,0),_e=new te(0,0);for(const ft of ae)if("branches"in ft){Ie.total+=1,Ie.covered+=ft.executionCount>0?1:0;for(const Wt of ft.branches)Qe.total+=1,Qe.covered+=Wt.executionCount>0?1:0}else _e.total+=1,_e.covered+=ft.executionCount>0?1:0;const at=new q(N,Ie,Qe.total>0?Qe:void 0,_e.total>0?_e:void 0);return at.detailedCoverage=ae,at}constructor(N,ae,Ie,Qe){this.uri=N,this.statementCoverage=ae,this.branchCoverage=Ie,this.functionCoverage=Qe}};e.$5L=me,e.$5L=me=q=Ge([W],me);let Te=class{constructor(N,ae,Ie=[]){this.executionCount=N,this.location=ae,this.branches=Ie}};e.$6L=Te,e.$6L=Te=Ge([W],Te);let ot=class{constructor(N,ae){this.executionCount=N,this.location=ae}};e.$7L=ot,e.$7L=ot=Ge([W],ot);let wt=class{constructor(N,ae){this.executionCount=N,this.location=ae}};e.$8L=wt,e.$8L=wt=Ge([W],wt);var Rt;(function(U){U[U.None=0]="None",U[U.Option=1]="Option",U[U.Default=2]="Default",U[U.Preferred=3]="Preferred"})(Rt||(e.ExternalUriOpenerPriority=Rt={}));var yn;(function(U){U[U.Untrusted=0]="Untrusted",U[U.Trusted=1]="Trusted",U[U.Unspecified=2]="Unspecified"})(yn||(e.WorkspaceTrustState=yn={}));var En;(function(U){U[U.Notify=1]="Notify",U[U.OpenBrowser=2]="OpenBrowser",U[U.OpenPreview=3]="OpenPreview",U[U.Silent=4]="Silent",U[U.Ignore=5]="Ignore",U[U.OpenBrowserOnce=6]="OpenBrowserOnce"})(En||(e.PortAutoForwardAction=En={}));class Fn{constructor(N,ae,Ie,Qe,_e,at){this.kind=N,this.name=ae,this.detail=Ie,this.uri=Qe,this.range=_e,this.selectionRange=at}}e.$9L=Fn;class Tn{constructor(N){this.uri=N}}e.$0L=Tn;class Ln{constructor(N,ae){this.original=N,this.modified=ae}}e.$$L=Ln;class On{constructor(N,ae,Ie,Qe){this.base=N,this.input1=ae,this.input2=Ie,this.result=Qe}}e.$_L=On;class Nn{constructor(N,ae){this.uri=N,this.viewType=ae}}e.$aM=Nn;class zn{constructor(N){this.viewType=N}}e.$bM=zn;class Un{constructor(N,ae){this.uri=N,this.notebookType=ae}}e.$cM=Un;class jn{constructor(N,ae,Ie){this.original=N,this.modified=ae,this.notebookType=Ie}}e.$dM=jn;class Bn{constructor(){}}e.$eM=Bn;class Wn{constructor(N,ae){this.uri=N,this.inputBoxUri=ae}}e.$fM=Wn;var Dn;(function(U){U[U.Down=0]="Down",U[U.Up=1]="Up"})(Dn||(e.InteractiveSessionVoteDirection=Dn={}));var kn;(function(U){U[U.Action=1]="Action",U[U.Toolbar=2]="Toolbar"})(kn||(e.InteractiveSessionCopyKind=kn={}));var Sn;(function(U){U[U.Unhelpful=0]="Unhelpful",U[U.Helpful=1]="Helpful",U[U.Undone=2]="Undone",U[U.Accepted=3]="Accepted"})(Sn||(e.InteractiveEditorResponseFeedbackKind=Sn={}));var In;(function(U){U[U.System=0]="System",U[U.User=1]="User",U[U.Assistant=2]="Assistant",U[U.Function=3]="Function"})(In||(e.ChatMessageRole=In={}));var Cn;(function(U){U[U.Short=1]="Short",U[U.Medium=2]="Medium",U[U.Full=3]="Full"})(Cn||(e.ChatVariableLevel=Cn={}));class Vn{constructor(N,ae){this.role=N,this.content=ae}}e.$gM=Vn;var Pn;(function(U){U[U.Unhelpful=0]="Unhelpful",U[U.Helpful=1]="Helpful"})(Pn||(e.ChatAgentResultFeedbackKind=Pn={}));var An;(function(U){U[U.SymbolInformation=1]="SymbolInformation",U[U.CommandInformation=2]="CommandInformation",U[U.SearchInformation=3]="SearchInformation",U[U.SettingInformation=4]="SettingInformation"})(An||(e.RelatedInformationType=An={}));var Rn;(function(U){U[U.Started=1]="Started",U[U.Recognizing=2]="Recognizing",U[U.Recognized=3]="Recognized",U[U.Stopped=4]="Stopped"})(Rn||(e.SpeechToTextStatus=Rn={}))}),define(Ae[100],Re([1,0,53,13,16,281,136,7,18]),function(ee,e,f,C,I,O,A,c,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vM=e.$uM=e.$tM=void 0;const d=new Map;function R(p,g){g?d.set(p,g):d.delete(p)}e.$tM=R;function S(p){return d.get(p)}class u extends O.$1u{constructor(g,t,i,l,v,D,m,n){super(t,i,l,v),this.c=g,this.m=D,this.q=m,this.notebook=n,this.b=!1}dispose(){(0,f.ok)(!this.b),this.b=!0,this.q=!1}equalLines(g){return(0,E.$ub)(this.f,g)}get document(){if(!this.a){const g=this;this.a={get uri(){return g.d},get fileName(){return g.d.fsPath},get isUntitled(){return g.d.scheme===C.Schemas.untitled},get languageId(){return g.m},get version(){return g.h},get isClosed(){return g.b},get isDirty(){return g.q},save(){return g.r()},getText(t){return t?g.s(t):g.getText()},get eol(){return g.g===`
`?c.EndOfLine.LF:c.EndOfLine.CRLF},get lineCount(){return g.f.length},lineAt(t){return g.t(t)},offsetAt(t){return g.u(t)},positionAt(t){return g.v(t)},validateRange(t){return g.w(t)},validatePosition(t){return g.x(t)},getWordRangeAtPosition(t,i){return g.y(t,i)}}}return Object.freeze(this.a)}_acceptLanguageId(g){(0,f.ok)(!this.b),this.m=g}_acceptIsDirty(g){(0,f.ok)(!this.b),this.q=g}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(g){const t=this.w(g);if(t.isEmpty)return"";if(t.isSingleLine)return this.f[t.start.line].substring(t.start.character,t.end.character);const i=this.g,l=t.start.line,v=t.end.line,D=[];D.push(this.f[l].substring(t.start.character));for(let m=l+1;m<v;m++)D.push(this.f[m]);return D.push(this.f[v].substring(0,t.end.character)),D.join(i)}t(g){let t;if(g instanceof c.$tK?t=g.line:typeof g=="number"&&(t=g),typeof t!="number"||t<0||t>=this.f.length||Math.floor(t)!==t)throw new Error("Illegal value for `line`");return new b(t,this.f[t],t===this.f.length-1)}u(g){return g=this.x(g),this.l(),this.j.getPrefixSum(g.line-1)+g.character}v(g){g=Math.floor(g),g=Math.max(0,g),this.l();const t=this.j.getIndexOf(g),i=this.f[t.index].length;return new c.$tK(t.index,Math.min(t.remainder,i))}w(g){if(!(g instanceof c.$uK))throw new Error("Invalid argument");const t=this.x(g.start),i=this.x(g.end);return t===g.start&&i===g.end?g:new c.$uK(t.line,t.character,i.line,i.character)}x(g){if(!(g instanceof c.$tK))throw new Error("Invalid argument");if(this.f.length===0)return g.with(0,0);let{line:t,character:i}=g,l=!1;if(t<0)t=0,i=0,l=!0;else if(t>=this.f.length)t=this.f.length-1,i=this.f[t].length,l=!0;else{const v=this.f[t].length;i<0?(i=0,l=!0):i>v&&(i=v,l=!0)}return l?new c.$tK(t,i):g}y(g,t){const i=this.x(g);if(!t)t=S(this.m);else if((0,I.$Pe)(t))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${t.source}' because it matches the empty string.`);const l=(0,A.$as)(i.character+1,(0,A.$$r)(t),this.f[i.line],0);if(l)return new c.$uK(i.line,l.startColumn-1,i.line,l.endColumn-1)}}e.$uM=u;class b{constructor(g,t,i){this.a=g,this.b=t,this.c=i}get lineNumber(){return this.a}get text(){return this.b}get range(){return new c.$uK(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new c.$uK(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$vM=b}),define(Ae[198],Re([1,0,7,17,5]),function(ee,e,f,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dec=void 0;let O=class{constructor(c){this.a=new f.$OL(f.ColorThemeKind.Dark),this.b=new I.$Od}get activeColorTheme(){return this.a}$onColorThemeChange(c){let E;switch(c){case"light":E=f.ColorThemeKind.Light;break;case"hcDark":E=f.ColorThemeKind.HighContrast;break;case"hcLight":E=f.ColorThemeKind.HighContrastLight;break;default:E=f.ColorThemeKind.Dark}this.a=new f.$OL(E),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$dec=O,e.$dec=O=Ge([qe(0,C.$rM)],O)}),define(Ae[199],Re([1,0,4]),function(ee,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DI=e.CellExecutionUpdateType=void 0;var C;(function(I){I[I.Output=1]="Output",I[I.OutputItems=2]="OutputItems",I[I.ExecutionState=3]="ExecutionState"})(C||(e.CellExecutionUpdateType=C={})),e.$DI=(0,f.$Qh)("INotebookExecutionService")}),define(Ae[46],Re([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jJ=e.TestPosition=e.TestIdPathParts=void 0;var f;(function(O){O.Delimiter="\0"})(f||(e.TestIdPathParts=f={}));var C;(function(O){O[O.IsSame=0]="IsSame",O[O.Disconnected=1]="Disconnected",O[O.IsChild=2]="IsChild",O[O.IsParent=3]="IsParent"})(C||(e.TestPosition=C={}));class I{static fromExtHostTestItem(A,c,E=A.parent){if(A._isRoot)return new I([c]);const d=[A.id];for(let R=E;R&&R.id!==c;R=R.parent)d.push(R.id);return d.push(c),new I(d.reverse())}static isRoot(A){return!A.includes("\0")}static root(A){const c=A.indexOf("\0");return c===-1?A:A.slice(0,c)}static fromString(A){return new I(A.split("\0"))}static join(A,c){return new I([...A.path,c])}static joinToString(A,c){return A.toString()+"\0"+c}static parentId(A){const c=A.lastIndexOf("\0");return c===-1?void 0:A.slice(0,c)}static localId(A){const c=A.lastIndexOf("\0");return c===-1?A:A.slice(c+1)}static isChild(A,c){return c.startsWith(A)&&c[A.length]==="\0"}static compare(A,c){return A===c?0:I.isChild(A,c)?2:I.isChild(c,A)?3:1}constructor(A,c=A.length){if(this.path=A,this.d=c,A.length===0||c<1)throw new Error("cannot create test with empty path")}get rootId(){return new I(this.path,1)}get parentId(){return this.d>1?new I(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let A=1;A<=this.d;A++)yield new I(this.path,A)}*idsToRoot(){for(let A=this.d;A>0;A--)yield new I(this.path,A)}compare(A){if(typeof A=="string")return I.compare(this.toString(),A);for(let c=0;c<A.d&&c<this.d;c++)if(A.path[c]!==this.path[c])return 1;return A.d>this.d?2:A.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let A=1;A<this.d;A++)this.c+="\0",this.c+=this.path[A]}return this.c}}e.$jJ=I}),define(Ae[58],Re([1,0,2,41,46]),function(ee,e,f,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qJ=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.$pJ=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$oJ=e.$nJ=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$mJ=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$lJ=e.$kJ=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.TestResultState=void 0;var O;(function(P){P[P.Unset=0]="Unset",P[P.Queued=1]="Queued",P[P.Running=2]="Running",P[P.Passed=3]="Passed",P[P.Failed=4]="Failed",P[P.Skipped=5]="Skipped",P[P.Errored=6]="Errored"})(O||(e.TestResultState=O={}));var A;(function(P){P[P.Run=1]="Run",P[P.Debug=2]="Debug",P[P.Coverage=3]="Coverage"})(A||(e.ExtTestRunProfileKind=A={}));var c;(function(P){P[P.Run=2]="Run",P[P.Debug=4]="Debug",P[P.Coverage=8]="Coverage",P[P.HasNonDefaultProfile=16]="HasNonDefaultProfile",P[P.HasConfigurable=32]="HasConfigurable",P[P.SupportsContinuousRun=64]="SupportsContinuousRun"})(c||(e.TestRunProfileBitset=c={})),e.$kJ=[2,4,8,16,32,64];const E=P=>"runId"in P;e.$lJ=E;var d;(function(P){P.serialize=h=>({range:h.range.toJSON(),uri:h.uri.toJSON()}),P.deserialize=h=>({range:C.$ys.lift(h.range),uri:f.URI.revive(h.uri)})})(d||(e.IRichLocation=d={}));var R;(function(P){P[P.Error=0]="Error",P[P.Output=1]="Output"})(R||(e.TestMessageType=R={}));var S;(function(P){P.serialize=h=>({message:h.message,type:0,expected:h.expected,actual:h.actual,contextValue:h.contextValue,location:h.location&&d.serialize(h.location)}),P.deserialize=h=>({message:h.message,type:0,expected:h.expected,actual:h.actual,contextValue:h.contextValue,location:h.location&&d.deserialize(h.location)})})(S||(e.ITestErrorMessage=S={}));const u=(P,h)=>`${h?"s":"e"}${P}`;e.$mJ=u;var b;(function(P){P.serialize=h=>({message:h.message,type:1,offset:h.offset,length:h.length,location:h.location&&d.serialize(h.location)}),P.deserialize=h=>({message:h.message,type:1,offset:h.offset,length:h.length,location:h.location&&d.deserialize(h.location)})})(b||(e.ITestOutputMessage=b={}));var p;(function(P){P.serialize=h=>h.type===0?S.serialize(h):b.serialize(h),P.deserialize=h=>h.type===0?S.deserialize(h):b.deserialize(h)})(p||(e.ITestMessage=p={}));var g;(function(P){P.serializeWithoutMessages=h=>({state:h.state,duration:h.duration,messages:[]}),P.serialize=h=>({state:h.state,duration:h.duration,messages:h.messages.map(p.serialize)}),P.deserialize=h=>({state:h.state,duration:h.duration,messages:h.messages.map(p.deserialize)})})(g||(e.ITestTaskState=g={}));const t="\0",i=(P,h)=>P+t+h;e.$nJ=i;const l=P=>{const h=P.indexOf(t);return{ctrlId:P.slice(0,h),tagId:P.slice(h+1)}};e.$oJ=l;var v;(function(P){P.serialize=h=>({extId:h.extId,label:h.label,tags:h.tags,busy:h.busy,children:void 0,uri:h.uri?.toJSON(),range:h.range?.toJSON()||null,description:h.description,error:h.error,sortText:h.sortText}),P.deserialize=h=>({extId:h.extId,label:h.label,tags:h.tags,busy:h.busy,children:void 0,uri:h.uri?f.URI.revive(h.uri):void 0,range:h.range?C.$ys.lift(h.range):null,description:h.description,error:h.error,sortText:h.sortText})})(v||(e.ITestItem=v={}));var D;(function(P){P[P.NotExpandable=0]="NotExpandable",P[P.Expandable=1]="Expandable",P[P.BusyExpanding=2]="BusyExpanding",P[P.Expanded=3]="Expanded"})(D||(e.TestItemExpandState=D={}));var m;(function(P){P.serialize=h=>({expand:h.expand,item:v.serialize(h.item)}),P.deserialize=h=>({controllerId:I.$jJ.root(h.item.extId),expand:h.expand,item:v.deserialize(h.item)})})(m||(e.InternalTestItem=m={}));var n;(function(P){P.serialize=h=>{let w;return h.item&&(w={},h.item.label!==void 0&&(w.label=h.item.label),h.item.tags!==void 0&&(w.tags=h.item.tags),h.item.busy!==void 0&&(w.busy=h.item.busy),h.item.uri!==void 0&&(w.uri=h.item.uri?.toJSON()),h.item.range!==void 0&&(w.range=h.item.range?.toJSON()),h.item.description!==void 0&&(w.description=h.item.description),h.item.error!==void 0&&(w.error=h.item.error),h.item.sortText!==void 0&&(w.sortText=h.item.sortText)),{extId:h.extId,expand:h.expand,item:w}},P.deserialize=h=>{let w;return h.item&&(w={},h.item.label!==void 0&&(w.label=h.item.label),h.item.tags!==void 0&&(w.tags=h.item.tags),h.item.busy!==void 0&&(w.busy=h.item.busy),h.item.range!==void 0&&(w.range=h.item.range?C.$ys.lift(h.item.range):null),h.item.description!==void 0&&(w.description=h.item.description),h.item.error!==void 0&&(w.error=h.item.error),h.item.sortText!==void 0&&(w.sortText=h.item.sortText)),{extId:h.extId,expand:h.expand,item:w}}})(n||(e.ITestItemUpdate=n={}));const r=(P,h)=>{h.expand!==void 0&&(P.expand=h.expand),h.item!==void 0&&(P.item=P.item?Object.assign(P.item,h.item):h.item)};e.$pJ=r;var s;(function(P){P.serializeWithoutMessages=h=>({...m.serialize(h),ownComputedState:h.ownComputedState,computedState:h.computedState,tasks:h.tasks.map(g.serializeWithoutMessages)}),P.serialize=h=>({...m.serialize(h),ownComputedState:h.ownComputedState,computedState:h.computedState,tasks:h.tasks.map(g.serialize)}),P.deserialize=h=>({...m.deserialize(h),ownComputedState:h.ownComputedState,computedState:h.computedState,tasks:h.tasks.map(g.deserialize),retired:!0})})(s||(e.TestResultItem=s={}));var o;(function(P){P[P.Function=0]="Function",P[P.Statement=1]="Statement"})(o||(e.DetailType=o={}));var $;(function(P){P[P.Add=0]="Add",P[P.Update=1]="Update",P[P.DocumentSynced=2]="DocumentSynced",P[P.Remove=3]="Remove",P[P.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",P[P.Retire=5]="Retire",P[P.AddTag=6]="AddTag",P[P.RemoveTag=7]="RemoveTag"})($||(e.TestDiffOpType=$={}));var a;(function(P){P.deserialize=h=>h.op===0?{op:h.op,item:m.deserialize(h.item)}:h.op===1?{op:h.op,item:n.deserialize(h.item)}:h.op===2?{op:h.op,uri:f.URI.revive(h.uri),docv:h.docv}:h,P.serialize=h=>h.op===0?{op:h.op,item:m.serialize(h.item)}:h.op===1?{op:h.op,item:n.serialize(h.item)}:h})(a||(e.TestsDiffOp=a={}));class k{constructor(){this.c=new Map,this.d=new Map,this.f=new Set,this.g=0,this.h=0,this.tags=this.c}apply(h){const w=this.o();for(const y of h)switch(y.op){case 0:this.j(m.deserialize(y.item),w);break;case 1:this.k(n.deserialize(y.item),w);break;case 3:this.l(y.itemId,w);break;case 5:this.m(y.itemId);break;case 4:this.updatePendingRoots(y.amount);break;case 6:this.c.set(y.tag.id,y.tag);break;case 7:this.c.delete(y.id);break}w.complete?.()}j(h,w){const y=I.$jJ.parentId(h.item.extId)?.toString();let M;if(!y)M=this.p(h),this.f.add(M),this.d.set(h.item.extId,M);else if(this.d.has(y)){const V=this.d.get(y);V.children.add(h.item.extId),M=this.p(h,V),this.d.set(h.item.extId,M)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(h)}`);return}return w.add?.(M),h.expand===2&&this.g++,M}k(h,w){const y=this.d.get(h.extId);if(y)return h.expand!==void 0&&(y.expand===2&&this.g--,h.expand===2&&this.g++),(0,e.$pJ)(y,h),w.update?.(y),y}l(h,w){const y=this.d.get(h);if(!y)return;const M=I.$jJ.parentId(y.item.extId)?.toString();M?this.d.get(M).children.delete(y.item.extId):this.f.delete(y);const V=[[h]];for(;V.length;)for(const B of V.pop()){const z=this.d.get(B);z&&(V.push(z.children),this.d.delete(B),w.remove?.(z,z!==y),z.expand===2&&this.g--)}}m(h){}updatePendingRoots(h){this.h+=h}o(){return{}}}e.$qJ=k}),define(Ae[76],Re([1,0,12,5,6,53,58,46]),function(ee,e,f,C,I,O,A,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lM=e.$kM=e.$jM=e.$iM=e.$hM=e.TestItemEventOp=void 0;var E;(function(l){l[l.Upsert=0]="Upsert",l[l.SetTags=1]="SetTags",l[l.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",l[l.RemoveChild=3]="RemoveChild",l[l.SetProp=4]="SetProp",l[l.Bulk=5]="Bulk",l[l.DocumentSynced=6]="DocumentSynced"})(E||(e.TestItemEventOp=E={}));const d=(l,v)=>l===v,S=Object.entries({range:(l,v)=>l===v?!0:!l||!v?!1:l.equalsRange(v),busy:d,label:d,description:d,error:d,sortText:d,tags:(l,v)=>!(l.length!==v.length||l.some(D=>!v.includes(D)))}),u=(l,v)=>{let D;for(const[m,n]of S)n(l[m],v[m])||(D?D[m]=v[m]:D={[m]:v[m]});return D};class b extends I.$Sc{get root(){return this.s.root}constructor(v){super(),this.s=v,this.f=this.B(new f.$7g(()=>this.flushDiff(),200)),this.g=this.B(new C.$Od),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.y(this.root,void 0)}set resolveHandler(v){this.h=v;for(const D of this.tree.values())this.I(D)}get resolveHandler(){return this.h}collectDiff(){const v=this.m;return this.m=[],v}pushDiff(v){switch(v.op){case 2:{for(const D of this.m)if(D.op===2&&D.uri===v.uri){D.docv=v.docv;return}break}case 1:{const D=this.m[this.m.length-1];if(D){if(D.op===1&&D.item.extId===v.item.extId){(0,A.$pJ)(D.item,v.item);return}if(D.op===0&&D.item.item.extId===v.item.extId){(0,A.$pJ)(D.item,v.item);return}}break}}this.m.push(v),this.f.isScheduled()||this.f.schedule()}expand(v,D){const m=this.tree.get(v);if(m){if((m.expandLevels===void 0||D>m.expandLevels)&&(m.expandLevels=D),m.expand===1){const n=this.L(m);return n.isOpen()?this.J(m,D-1):n.wait().then(()=>this.J(m,D-1))}else if(m.expand===3)return m.resolveBarrier?.isOpen()===!1?m.resolveBarrier.wait().then(()=>this.J(m,D-1)):this.J(m,D-1)}}dispose(){for(const v of this.tree.values())this.s.getApiFor(v.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}u(v,D){switch(D.op){case 3:this.N(c.$jJ.joinToString(v.fullId,D.id));break;case 0:this.y(D.item,v);break;case 5:for(const m of D.ops)this.u(v,m);break;case 1:this.z(D.new,D.old,v.fullId.toString());break;case 2:this.I(v);break;case 4:this.pushDiff({op:1,item:{extId:v.fullId.toString(),item:D.update}});break;case 6:this.w(v.actual.uri);break;default:(0,O.$4c)(D)}}w(v){v&&this.pushDiff({op:2,uri:v,docv:this.s.getDocumentVersion(v)})}y(v,D){const m=c.$jJ.fromExtHostTestItem(v,this.root.id,D?.actual),n=this.s.getApiFor(v);n.parent&&n.parent!==D?.actual&&this.s.getChildren(n.parent).delete(v.id);let r=this.tree.get(m.toString());if(!r){r={fullId:m,actual:v,expandLevels:D?.expandLevels?D.expandLevels-1:void 0,expand:0},v.tags.forEach(this.C,this),this.tree.set(r.fullId.toString(),r),this.F(v,D),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:r.expand,item:this.s.toITestItem(v)}}),this.H(v,r,D);return}if(r.actual===v){this.G(v,r,D);return}if(r.actual.uri?.toString()!==v.uri?.toString())return this.N(m.toString()),this.y(v,D);const s=this.s.getChildren(r.actual),o=r.actual,$=u(this.s.toITestItem(o),this.s.toITestItem(v));this.s.getApiFor(o).listener=void 0,r.actual=v,r.expand=0,$&&($.hasOwnProperty("tags")&&(this.z(v.tags,o.tags,m.toString()),delete $.tags),this.u(r,{op:4,update:$})),this.H(v,r,D);for(const[a,k]of s)this.s.getChildren(v).get(k.id)||this.N(c.$jJ.joinToString(m,k.id));this.w(r.actual.uri)}z(v,D,m){const n=new Set(D.map(r=>r.id));for(const r of v)n.delete(r.id)||this.C(r);this.pushDiff({op:1,item:{extId:m,item:{tags:v.map(r=>(0,A.$nJ)(this.s.controllerId,r.id))}}}),n.forEach(this.D,this)}C(v){const D=this.j.get(v.id);D?D.refCount++:(this.j.set(v.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,A.$nJ)(this.s.controllerId,v.id)}}))}D(v){const D=this.j.get(v);D&&!--D.refCount&&(this.j.delete(v),this.pushDiff({op:7,id:(0,A.$nJ)(this.s.controllerId,v)}))}F(v,D){this.s.getApiFor(v).parent=D&&D.actual!==this.root?D.actual:void 0}G(v,D,m){this.F(v,m);const n=this.s.getApiFor(v);n.parent=m?.actual,n.listener=r=>this.u(D,r),this.I(D)}H(v,D,m){this.G(v,D,m);for(const[n,r]of this.s.getChildren(v))this.y(r,D)}I(v){let D;this.h?v.resolveBarrier?D=v.resolveBarrier.isOpen()?3:2:D=v.actual.canResolveChildren?1:0:D=0,D!==v.expand&&(v.expand=D,this.pushDiff({op:1,item:{extId:v.fullId.toString(),expand:D}}),D===1&&v.expandLevels!==void 0&&this.L(v))}J(v,D){if(D<0)return;const m=[];for(const[n,r]of this.s.getChildren(v.actual)){const s=this.expand(c.$jJ.joinToString(v.fullId,r.id),D);(0,f.$Hg)(s)&&m.push(s)}if(m.length)return Promise.all(m).then(()=>{})}L(v){if(v.resolveBarrier)return v.resolveBarrier;if(!this.h){const r=new f.$Tg;return r.open(),r}v.expand=2,this.M(v);const D=v.resolveBarrier=new f.$Tg,m=r=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,r)};let n;try{n=this.h(v.actual===this.root?void 0:v.actual)}catch(r){m(r)}return(0,f.$Hg)(n)?n.catch(m).then(()=>{D.open(),this.I(v)}):(D.open(),this.I(v)),v.resolveBarrier}M(v){this.pushDiff({op:1,item:{extId:v.fullId.toString(),expand:v.expand}})}N(v){const D=this.tree.get(v);if(!D)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:v});const m=[D];for(;m.length;){const n=m.pop();if(n){this.s.getApiFor(n.actual).listener=void 0;for(const r of n.actual.tags)this.D(r.id);this.tree.delete(n.fullId.toString());for(const[r,s]of this.s.getChildren(n.actual))m.push(this.tree.get(c.$jJ.joinToString(n.fullId,s.id)))}}}flushDiff(){const v=this.collectDiff();v.length&&this.g.fire(v)}}e.$hM=b;class p extends Error{constructor(v){super(`Attempted to insert a duplicate test item ID ${v}`)}}e.$iM=p;class g extends Error{constructor(v){super(`TestItem with ID "${v}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$jM=g;class t extends Error{constructor(v,D,m){super(`TestItem with ID "${v}" is from controller "${D}" and cannot be added as a child of an item from controller "${m}".`)}}e.$kM=t;const i=(l,v,D)=>{let m=new Map;return{get size(){return m.size},forEach(n,r){for(const s of m.values())n.call(r,s,this)},[Symbol.iterator](){return m.entries()},replace(n){const r=new Map,s=new Set(m.keys()),o={op:5,ops:[]};for(const $ of n){if(!($ instanceof D))throw new g($.id);const a=v($).controllerId;if(a!==l.controllerId)throw new t($.id,a,l.controllerId);if(r.has($.id))throw new p($.id);r.set($.id,$),s.delete($.id),o.ops.push({op:0,item:$})}for(const $ of s.keys())o.ops.push({op:3,id:$});l.listener?.(o),m=r},add(n){if(!(n instanceof D))throw new g(n.id);m.set(n.id,n),l.listener?.({op:0,item:n})},delete(n){m.delete(n)&&l.listener?.({op:3,id:n})},get(n){return m.get(n)},toJSON(){return Array.from(m.values())}}};e.$lM=i}),define(Ae[101],Re([1,0,76]),function(ee,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nM=e.$mM=void 0;const C=new WeakMap,I=(A,c)=>{const E={controllerId:c};return C.set(A,E),E};e.$mM=I;const O=A=>{const c=C.get(A);if(!c)throw new f.$jM(A?.id||"<unknown>");return c};e.$nM=O}),define(Ae[77],Re([1,0,13,2]),function(ee,e,f,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tpb=e.$spb=e.$rpb=e.$qpb=e.$ppb=void 0,e.$ppb="vscode-cdn.net",e.$qpb=`vscode-resource.${e.$ppb}`,e.$rpb=`'self' https://*.${e.$ppb}`;function I(c,E){return c.scheme===f.Schemas.http||c.scheme===f.Schemas.https?c:(E&&E.authority&&E.isRemote&&c.scheme===f.Schemas.file&&(c=C.URI.from({scheme:f.Schemas.vscodeRemote,authority:E.authority,path:c.path})),C.URI.from({scheme:f.Schemas.https,authority:`${c.scheme}+${O(c.authority)}.${e.$qpb}`,path:c.path,fragment:c.fragment,query:c.query}))}e.$spb=I;function O(c){return c.replace(/./g,E=>{const d=E.charCodeAt(0);return d>=97&&d<=122||d>=65&&d<=90||d>=48&&d<=57?E:"-"+d.toString(16).padStart(4,"0")})}function A(c){return c.replace(/-([0-9a-f]{4})/g,(E,d)=>String.fromCharCode(parseInt(d,16)))}e.$tpb=A}),define(Ae[200],Re([1,0,5,6,77]),function(ee,e,f,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ndc=void 0;class O{constructor(c,E,d){this.d=c,this.e=E,this.f=d,this.a=0,this.b=new C.$Rc,this.c=new Map,this.b.add(E.onDidChangeVisibleTextEditors(()=>{const R=E.getVisibleTextEditors();for(const S of this.c.values())R.indexOf(S.editor)<0&&S.inset.dispose()}))}dispose(){this.c.forEach(c=>c.inset.dispose()),this.b.dispose()}createWebviewEditorInset(c,E,d,R,S){let u;for(const v of this.e.getVisibleTextEditors(!0))if(v.value===c){u=v;break}if(!u)throw new Error("not a visible editor");const b=this,p=this.a++,g=new f.$Od,t=new f.$Od,i=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(v){return(0,I.$spb)(v,b.f)}get cspSource(){return I.$rpb}set options(v){this.b=v,b.d.$setOptions(p,v)}get options(){return this.b}set html(v){this.a=v,b.d.$setHtml(p,v)}get html(){return this.a}get onDidReceiveMessage(){return g.event}postMessage(v){return b.d.$postMessage(p,v)}},l=new class{constructor(){this.editor=c,this.line=E,this.height=d,this.webview=i,this.onDidDispose=t.event}dispose(){b.c.has(p)&&(b.c.delete(p),b.d.$disposeEditorInset(p),t.fire(),t.dispose(),g.dispose())}};return this.d.$createEditorInset(p,u.id,u.value.document.uri,E+1,d,R||{},S.identifier,S.extensionLocation),this.c.set(p,{editor:c,inset:l,onDidReceiveMessage:g}),l}$onDidDispose(c){const E=this.c.get(c);E&&E.inset.dispose()}$onDidReceiveMessage(c,E){this.c.get(c)?.onDidReceiveMessage.fire(E)}}e.$Ndc=O}),define(Ae[201],Re([1,0,4]),function(ee,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eN=e.VariableKind=e.$dN=void 0,e.$dN=(0,f.$Qh)("configurationResolverService");var C;(function(O){O.Unknown="unknown",O.Env="env",O.Config="config",O.Command="command",O.Input="input",O.ExtensionInstallFolder="extensionInstallFolder",O.WorkspaceFolder="workspaceFolder",O.Cwd="cwd",O.WorkspaceFolderBasename="workspaceFolderBasename",O.UserHome="userHome",O.LineNumber="lineNumber",O.SelectedText="selectedText",O.File="file",O.FileWorkspaceFolder="fileWorkspaceFolder",O.RelativeFile="relativeFile",O.RelativeFileDirname="relativeFileDirname",O.FileDirname="fileDirname",O.FileExtname="fileExtname",O.FileBasename="fileBasename",O.FileBasenameNoExtension="fileBasenameNoExtension",O.FileDirnameBasename="fileDirnameBasename",O.ExecPath="execPath",O.ExecInstallFolder="execInstallFolder",O.PathSeparator="pathSeparator"})(C||(e.VariableKind=C={}));class I extends Error{constructor(A,c){super(c),this.variable=A}}e.$eN=I}),define(Ae[202],Re([1,0,20,73,15,25,23,90,166,201,16]),function(ee,e,f,C,I,O,A,c,E,d,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sN=void 0;class S{constructor(b,p,g,t){this.h=new Map,this.a=b,this.b=p,this.g=g,t&&(this.c=t.then(i=>this.i(i)))}i(b){if(A.$d){const p=Object.create(null);return Object.keys(b).forEach(g=>{p[g.toLowerCase()]=b[g]}),p}return b}resolveWithEnvironment(b,p,g){return this.l({env:this.i(b),userHome:void 0},p?p.uri:void 0,g)}async resolveAsync(b,p){const g={env:await this.c,userHome:await this.g};return this.l(g,b?b.uri:void 0,p)}async j(b,p,g,t){const i=O.$9m(p);A.$d&&i.windows?Object.keys(i.windows).forEach(v=>i[v]=i.windows[v]):A.$e&&i.osx?Object.keys(i.osx).forEach(v=>i[v]=i.osx[v]):A.$f&&i.linux&&Object.keys(i.linux).forEach(v=>i[v]=i.linux[v]),delete i.windows,delete i.osx,delete i.linux;const l={env:await this.c,userHome:await this.g};return this.l(l,b?b.uri:void 0,i,g,t)}async resolveAnyAsync(b,p,g){return this.j(b,p,g)}async resolveAnyMap(b,p,g){const t=new Map;return{newConfig:await this.j(b,p,g,t),resolvedVariables:t}}resolveWithInteractionReplace(b,p,g,t){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(b,p,g,t){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(b,p){if(this.h.has(b))throw new Error("Variable "+b+" is contributed twice.");this.h.set(b,p)}async l(b,p,g,t,i){if(I.$zf(g))return this.m(b,p,g,t,i);if(Array.isArray(g))return Promise.all(g.map(l=>this.l(b,p,l,t,i)));if(I.$Bf(g)){const l=Object.create(null),v=await Promise.all(Object.keys(g).map(async D=>[await this.m(b,p,D,t,i),await this.l(b,p,g[D],t,i)]));for(const[D,m]of v)l[D]=m;return l}return g}m(b,p,g,t,i){return(0,R.$Ue)(g,S.VARIABLE_REGEXP,async(l,v)=>{if(v.includes(S.VARIABLE_LHS))return l;let D=await this.o(b,l,v,p,t);return i?.set(v,D),D!==l&&I.$zf(D)&&D.match(S.VARIABLE_REGEXP)&&(D=await this.m(b,p,D,t,i)),D})}n(b){return this.b?this.b.getUriLabel(b,{noPrefix:!0}):b.fsPath}async o(b,p,g,t,i){let l;const v=g.split(":");v.length>1&&(g=v[0],l=v[1]);const D=r=>{const s=this.a.getFilePath();if(s)return(0,c.$xv)(s);throw new d.$eN(r,(0,E.localize)(0,null,p))},m=r=>{const s=D(r);if(this.a.getWorkspaceFolderPathForFile){const o=this.a.getWorkspaceFolderPathForFile();if(o)return(0,c.$xv)(o)}throw new d.$eN(r,(0,E.localize)(1,null,p,f.$nc(s)))},n=r=>{if(l){const s=this.a.getFolderUri(l);if(s)return s;throw new d.$eN(r,(0,E.localize)(2,null,p,l))}if(t)return t;throw this.a.getWorkspaceFolderCount()>1?new d.$eN(r,(0,E.localize)(3,null,p)):new d.$eN(r,(0,E.localize)(4,null,p))};switch(g){case"env":if(l){if(b.env){const r=b.env[A.$d?l.toLowerCase():l];if(I.$zf(r))return r}return""}throw new d.$eN(d.VariableKind.Env,(0,E.localize)(5,null,p));case"config":if(l){const r=this.a.getConfigurationValue(t,l);if(I.$If(r))throw new d.$eN(d.VariableKind.Config,(0,E.localize)(6,null,p,l));if(I.$Bf(r))throw new d.$eN(d.VariableKind.Config,(0,E.localize)(7,null,p,l));return r}throw new d.$eN(d.VariableKind.Config,(0,E.localize)(8,null,p));case"command":return this.p(d.VariableKind.Command,p,l,i,"command");case"input":return this.p(d.VariableKind.Input,p,l,i,"input");case"extensionInstallFolder":if(l){const r=await this.a.getExtension(l);if(!r)throw new d.$eN(d.VariableKind.ExtensionInstallFolder,(0,E.localize)(9,null,p,l));return this.n(r.extensionLocation)}throw new d.$eN(d.VariableKind.ExtensionInstallFolder,(0,E.localize)(10,null,p));default:switch(g){case"workspaceRoot":case"workspaceFolder":return(0,c.$xv)(this.n(n(d.VariableKind.WorkspaceFolder)));case"cwd":return t||l?(0,c.$xv)(this.n(n(d.VariableKind.Cwd))):C.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,c.$xv)(f.$nc(this.n(n(d.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(b.userHome)return b.userHome;throw new d.$eN(d.VariableKind.UserHome,(0,E.localize)(11,null,p))}case"lineNumber":{const r=this.a.getLineNumber();if(r)return r;throw new d.$eN(d.VariableKind.LineNumber,(0,E.localize)(12,null,p))}case"selectedText":{const r=this.a.getSelectedText();if(r)return r;throw new d.$eN(d.VariableKind.SelectedText,(0,E.localize)(13,null,p))}case"file":return D(d.VariableKind.File);case"fileWorkspaceFolder":return m(d.VariableKind.FileWorkspaceFolder);case"relativeFile":return t||l?f.$lc(this.n(n(d.VariableKind.RelativeFile)),D(d.VariableKind.RelativeFile)):D(d.VariableKind.RelativeFile);case"relativeFileDirname":{const r=f.$mc(D(d.VariableKind.RelativeFileDirname));if(t||l){const s=f.$lc(this.n(n(d.VariableKind.RelativeFileDirname)),r);return s.length===0?".":s}return r}case"fileDirname":return f.$mc(D(d.VariableKind.FileDirname));case"fileExtname":return f.$oc(D(d.VariableKind.FileExtname));case"fileBasename":return f.$nc(D(d.VariableKind.FileBasename));case"fileBasenameNoExtension":{const r=f.$nc(D(d.VariableKind.FileBasenameNoExtension));return r.slice(0,r.length-f.$oc(r).length)}case"fileDirnameBasename":return f.$nc(f.$mc(D(d.VariableKind.FileDirnameBasename)));case"execPath":{const r=this.a.getExecPath();return r||p}case"execInstallFolder":{const r=this.a.getAppRoot();return r||p}case"pathSeparator":return f.sep;default:try{const r=l?`${g}:${l}`:g;return this.p(d.VariableKind.Unknown,p,r,i,void 0)}catch{return p}}}}p(b,p,g,t,i){if(g&&t){const l=i===void 0?t[g]:t[i+":"+g];if(typeof l=="string")return l;throw new d.$eN(b,(0,E.localize)(14,null,p))}return p}}e.$sN=S,S.VARIABLE_LHS="${",S.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(Ae[102],Re([1,0,4,99]),function(ee,e,f,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vC=e.$uC=e.OpenEditorContext=e.GroupsOrder=e.$tC=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$sC=void 0,e.$sC=(0,f.$Qh)("editorGroupsService");var I;(function(p){p[p.UP=0]="UP",p[p.DOWN=1]="DOWN",p[p.LEFT=2]="LEFT",p[p.RIGHT=3]="RIGHT"})(I||(e.GroupDirection=I={}));var O;(function(p){p[p.HORIZONTAL=0]="HORIZONTAL",p[p.VERTICAL=1]="VERTICAL"})(O||(e.GroupOrientation=O={}));var A;(function(p){p[p.FIRST=0]="FIRST",p[p.LAST=1]="LAST",p[p.NEXT=2]="NEXT",p[p.PREVIOUS=3]="PREVIOUS"})(A||(e.GroupLocation=A={}));var c;(function(p){p[p.MAXIMIZE=0]="MAXIMIZE",p[p.EXPAND=1]="EXPAND",p[p.EVEN=2]="EVEN"})(c||(e.GroupsArrangement=c={}));var E;(function(p){p[p.COPY_EDITORS=0]="COPY_EDITORS",p[p.MOVE_EDITORS=1]="MOVE_EDITORS"})(E||(e.MergeGroupMode=E={}));function d(p){const g=p;return(0,C.$aE)(g?.editor)&&(0,C.$aE)(g?.replacement)}e.$tC=d;var R;(function(p){p[p.CREATION_TIME=0]="CREATION_TIME",p[p.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",p[p.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(R||(e.GroupsOrder=R={}));var S;(function(p){p[p.NEW_EDITOR=1]="NEW_EDITOR",p[p.MOVE_EDITOR=2]="MOVE_EDITOR",p[p.COPY_EDITOR=3]="COPY_EDITOR"})(S||(e.OpenEditorContext=S={}));function u(p){const g=p;return!!g&&typeof g.id=="number"&&Array.isArray(g.editors)}e.$uC=u;function b(p){return p.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.$vC=b}),define(Ae[203],Re([1,0,4,102]),function(ee,e,f,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zC=e.$yC=e.$xC=e.$wC=void 0,e.$wC=(0,f.$Qh)("editorService"),e.$xC=-1,e.$yC=-2;function I(O){const A=O;return typeof O=="number"||(0,C.$uC)(A)}e.$zC=I}),define(Ae[204],Re([1,0,4,172]),function(ee,e,f,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NJ=void 0,e.$NJ=(0,f.$Rh)(C.$Xh)}),define(Ae[103],Re([1,0,21,5,20,6]),function(ee,e,f,C,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Z4b=e.$Y4b=e.$X4b=e.$W4b=e.$V4b=e.$U4b=void 0;class A{constructor(i,l){this.versionId=i,this.removedDueToLooping=l}}e.$U4b=A;class c{static isHostExtension(i,l,v){if(l.getExtensionDescription(i))return!1;const D=v.getExtensionDescription(i);return D?!!((D.main||D.browser)&&D.api==="none"):!1}constructor(i,l){this.j=i,this.c=new C.$Od,this.onDidChange=this.c.event,this.d=0,this.e=l,this.k()}k(){this.e.sort(p),this.f=new f.$0l,this.g=[],this.h=new Map;for(const i of this.e){if(this.f.has(i.identifier)){console.error("Extension `"+i.identifier.value+"` is already registered");continue}this.f.set(i.identifier,i),this.g.push(i);const l=this.j.readActivationEvents(i);if(Array.isArray(l))for(let v of l)v==="onUri"&&(v=`onUri:${f.$8l.toKey(i.identifier)}`),this.h.has(v)||this.h.set(v,[]),this.h.get(v).push(i)}}set(i){return this.e=i,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(i,l){this.e=g(this.e,l),this.e=this.e.concat(i);const v=c.l(this.e);return this.e=g(this.e,v.map(D=>D.identifier)),this.k(),this.d++,this.c.fire(void 0),new A(this.d,v)}static l(i){const l=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(r){this.d.has(r)||(this.d.add(r),this.e.push(r))}addArc(r,s){this.addNode(r),this.addNode(s),this.c.has(r)?this.c.get(r).push(s):this.c.set(r,[s])}getArcs(r){return this.c.has(r)?this.c.get(r):[]}hasOnlyGoodArcs(r,s){const o=l.getArcs(r);for(let $=0;$<o.length;$++)if(!s.has(o[$]))return!1;return!0}getNodes(){return this.e}},v=new f.$0l;for(const r of i)if(v.set(r.identifier,r),r.extensionDependencies)for(const s of r.extensionDependencies)l.addArc(f.$8l.toKey(r.identifier),f.$8l.toKey(s));const D=new Set;l.getNodes().filter(r=>l.getArcs(r).length===0).forEach(r=>D.add(r));const m=l.getNodes().filter(r=>!D.has(r));let n;do{n=!1;for(let r=0;r<m.length;r++){const s=m[r];l.hasOnlyGoodArcs(s,D)&&(m.splice(r,1),r--,D.add(s),n=!0)}}while(n);return m.map(r=>v.get(r))}containsActivationEvent(i){return this.h.has(i)}containsExtension(i){return this.f.has(i)}getExtensionDescriptionsForActivationEvent(i){const l=this.h.get(i);return l?l.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new E(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(i){const l=this.f.get(i);return l||void 0}getExtensionDescriptionByUUID(i){for(const l of this.g)if(l.uuid===i)return l}getExtensionDescriptionByIdOrUUID(i,l){return this.getExtensionDescription(i)??(l?this.getExtensionDescriptionByUUID(l):void 0)}}e.$V4b=c;class E{constructor(i,l){this.versionId=i,this.extensions=l}}e.$W4b=E,e.$X4b={readActivationEvents:t=>t.activationEvents};class d{constructor(i){this.d=new u,this.c=new c(i,[])}async acquireLock(i){const l=await this.d.acquire(i);return new R(this,l)}deltaExtensions(i,l,v){if(!i.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(l,v)}containsActivationEvent(i){return this.c.containsActivationEvent(i)}containsExtension(i){return this.c.containsExtension(i)}getExtensionDescriptionsForActivationEvent(i){return this.c.getExtensionDescriptionsForActivationEvent(i)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(i){return this.c.getExtensionDescription(i)}getExtensionDescriptionByUUID(i){return this.c.getExtensionDescriptionByUUID(i)}getExtensionDescriptionByIdOrUUID(i,l){return this.c.getExtensionDescriptionByIdOrUUID(i,l)}}e.$Y4b=d;class R extends O.$Sc{constructor(i,l){super(),this.f=i,this.c=!1,this.B(l)}isAcquiredFor(i){return!this.c&&this.f===i}}e.$Z4b=R;class S{constructor(i){this.name=i,this.promise=new Promise((l,v)=>{this.c=l})}resolve(i){this.c(i)}}class u{constructor(){this.c=[],this.d=!1}async acquire(i){const l=new S(i);return this.c.push(l),this.e(),l.promise}e(){if(this.d||this.c.length===0)return;const i=this.c.shift();this.d=!0;let l=!0;const v=setTimeout(()=>{l&&console.warn(`The customer named ${i.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),D=()=>{l&&(clearTimeout(v),l=!1,this.d=!1,this.e())};i.resolve((0,O.$Qc)(D))}}var b;(function(t){t[t.Builtin=0]="Builtin",t[t.User=1]="User",t[t.Dev=2]="Dev"})(b||(b={}));function p(t,i){const l=t.isBuiltin?0:t.isUnderDevelopment?2:1,v=i.isBuiltin?0:i.isUnderDevelopment?2:1;if(l!==v)return l-v;const D=I.$gc.basename(t.extensionLocation.path),m=I.$gc.basename(i.extensionLocation.path);return D<m?-1:D>m?1:0}function g(t,i){const l=new f.$9l(i);return t.filter(v=>!l.has(v.identifier))}}),define(Ae[78],Re([1,0,26]),function(ee,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.$em=e.$dm=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var C;(function(d){d[d.Desktop=1]="Desktop",d[d.Web=2]="Web"})(C||(e.UIKind=C={}));var I;(function(d){d[d.VersionMismatch=55]="VersionMismatch",d[d.UnexpectedError=81]="UnexpectedError"})(I||(e.ExtensionHostExitCode=I={}));var O;(function(d){d[d.Initialized=0]="Initialized",d[d.Ready=1]="Ready",d[d.Terminate=2]="Terminate"})(O||(e.MessageType=O={}));function A(d){const R=f.$ce.alloc(1);switch(d){case 0:R.writeUInt8(1,0);break;case 1:R.writeUInt8(2,0);break;case 2:R.writeUInt8(3,0);break}return R}e.$dm=A;function c(d,R){if(d.byteLength!==1)return!1;switch(d.readUInt8(0)){case 1:return R===0;case 2:return R===1;case 3:return R===2;default:return!1}}e.$em=c;var E;(function(d){d.Start="START_NATIVE_LOG",d.End="END_NATIVE_LOG"})(E||(e.NativeLogMarkers=E={}))}),define(Ae[59],Re([1,0,4,5,14,27,78,54,55,25,2,6,155]),function(ee,e,f,C,I,O,A,c,E,d,R,S,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LM=e.$KM=e.$JM=e.$IM=void 0;let b=class extends S.$Sc{constructor(i,l){super(),this.s=i,this.t=l,this.a=this.B(new C.$Od),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new C.$Od),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=R.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=l.createLogger(this.m,{id:E.$to,name:(0,u.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(l.onDidChangeLogLevel(v=>{(0,I.$aj)(v)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===I.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(i,l,v){const D=this.getTelemetryDetails(),m=new p(l,v,i,this.n,this.j,this.getBuiltInCommonProperties(i),{isUsageEnabled:D.isUsageEnabled,isErrorsEnabled:D.isErrorsEnabled}),n=this.r.get(i.identifier.value)??[];return this.r.set(i.identifier.value,[...n,m]),m.apiTelemetryLogger}$initializeTelemetryLevel(i,l,v){this.f=i,this.g=l,this.c=v??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(i){const l=Object.create(null);switch(l["common.extname"]=`${i.publisher}.${i.name}`,l["common.extversion"]=i.version,l["common.vscodemachineid"]=this.s.telemetryInfo.machineId,l["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,l["common.vscodeversion"]=this.s.version,l["common.isnewappinstall"]=g(this.s.telemetryInfo.firstSessionDate),l["common.product"]=this.s.environment.appHost,this.s.uiKind){case A.UIKind.Web:l["common.uikind"]="web";break;case A.UIKind.Desktop:l["common.uikind"]="desktop";break;default:l["common.uikind"]="unknown"}return l["common.remotename"]=(0,c.$Wk)((0,E.$Ao)(this.s.remote.authority)),l}$onDidChangeTelemetryLevel(i){this.h=this.getTelemetryConfiguration(),this.f=i;const l=this.getTelemetryDetails();this.r.forEach((v,D)=>{const m=v.filter(n=>!n.isDisposed);m.length===0?this.r.delete(D):this.r.set(D,m)}),this.r.forEach(v=>{for(const D of v)D.updateTelemetryEnablements(l.isUsageEnabled,l.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(i,l){const D=this.r.get(i.value)?.filter(n=>!n.isDisposed);if(!D)return this.r.delete(i.value),!1;let m=!1;for(const n of D)n.ignoreUnhandledExtHostErrors||(n.logError(l),m=!0);return m}};e.$IM=b,e.$IM=b=Ge([qe(0,O.$HM),qe(1,I.$_i)],b);class p{static validateSender(i){if(typeof i!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof i.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof i.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof i.flush<"u"&&typeof i.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(i,l,v,D,m,n,r){this.g=v,this.h=D,this.i=m,this.j=n,this.a=new C.$Od,this.ignoreUnhandledExtHostErrors=l?.ignoreUnhandledErrors??!1,this.b=l?.ignoreBuiltInCommonProperties??!1,this.c=l?.additionalCommonProperties,this.f=i,this.d={isUsageEnabled:r.isUsageEnabled,isErrorsEnabled:r.isErrorsEnabled}}updateTelemetryEnablements(i,l){this.e&&(this.d={isUsageEnabled:i,isErrorsEnabled:l},this.a.fire(this.e))}mixInCommonPropsAndCleanData(i){let l="properties"in i?i.properties??{}:i;return l=(0,E.$Do)(l,[]),this.c&&(l=(0,d.$_m)(l,this.c)),this.b||(l=(0,d.$_m)(l,this.j)),"properties"in i?i.properties=l:i=l,i}k(i,l){this.f&&(this.g.publisher==="vscode"?i=this.g.name+"/"+i:i=this.g.identifier.value+"/"+i,l=this.mixInCommonPropsAndCleanData(l||{}),this.i||this.f?.sendEventData(i,l),this.h.trace(i,l))}logUsage(i,l){this.d.isUsageEnabled&&this.k(i,l)}logError(i,l){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof i=="string")this.k(i,l);else{const v={name:i.name,message:i.message,stack:i.stack,cause:i.cause},D=(0,E.$Do)(v,[]),m=new Error(D.message,{cause:D.cause});m.stack=D.stack,m.name=D.name,l=this.mixInCommonPropsAndCleanData(l||{}),this.i||this.f.sendErrorData(m,l),this.h.trace("exception",l)}}get apiTelemetryLogger(){if(!this.e){const i=this,l={logUsage:i.logUsage.bind(i),get isUsageEnabled(){return i.d.isUsageEnabled},get isErrorsEnabled(){return i.d.isErrorsEnabled},logError:i.logError.bind(i),dispose:i.dispose.bind(i),onDidChangeEnableStates:i.a.event.bind(i)};this.e=Object.freeze(l)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let i=this.f;this.f=void 0,Promise.resolve(i.flush()).then(i=void 0),this.e=void 0}else this.f=void 0}}e.$JM=p;function g(t){const i=Date.now()-new Date(t).getTime();return isNaN(i)?!1:i<1e3*60*60*24}e.$KM=g,e.$LM=(0,f.$Qh)("IExtHostTelemetry")}),define(Ae[22],Re([1,0,5,2,181,98,21,4]),function(ee,e,f,C,I,O,A,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rF=e.$qF=e.$pF=e.ActivationKind=e.$oF=e.$nF=e.$mF=e.$lF=e.$kF=e.ExtensionHostStartup=e.$jF=e.$iF=e.$hF=e.$gF=void 0,e.$gF=Object.freeze({identifier:new A.$8l("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:C.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$hF="extensions.webWorker",e.$iF=(0,c.$Qh)("extensionService");class E{constructor(m){this.dependency=m}}e.$jF=E;var d;(function(D){D[D.EagerAutoStart=1]="EagerAutoStart",D[D.EagerManualStart=2]="EagerManualStart",D[D.Lazy=3]="Lazy"})(d||(e.ExtensionHostStartup=d={}));class R{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(m,n,r){this.c=m,this.d=n.slice(0),this.e=r.slice(0)}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:O.$4E.createActivationEventsMap(this.d)}}set(m,n,r){if(this.c>m)throw new Error(`ExtensionHostExtensions: invalid versionId ${m} (current: ${this.c})`);const s=[],o=[],$=[],a=[],k=S(this.d),P=S(n),h=(B,z)=>B.extensionLocation.toString()===z.extensionLocation.toString()||B.isBuiltin===z.isBuiltin||B.isUserBuiltin===z.isUserBuiltin||B.isUnderDevelopment===z.isUnderDevelopment;for(const B of this.d){const z=P.get(B.identifier);if(!z){s.push(B.identifier),k.delete(B.identifier);continue}if(!h(B,z)){s.push(B.identifier),k.delete(B.identifier);continue}}for(const B of n){const z=k.get(B.identifier);if(!z){o.push(B);continue}if(!h(z,B)){s.push(z.identifier),k.delete(z.identifier);continue}}const w=new A.$9l(this.e),y=new A.$9l(r);for(const B of this.e)y.has(B)||$.push(B);for(const B of r)w.has(B)||a.push(B);const M=O.$4E.createActivationEventsMap(o),V={versionId:m,toRemove:s,toAdd:o,addActivationEvents:M,myToRemove:$,myToAdd:a};return this.delta(V),V}delta(m){if(this.c>=m.versionId)return null;const{toRemove:n,toAdd:r,myToRemove:s,myToAdd:o}=m,$=new A.$9l(n),a=new A.$9l(s);for(let k=0;k<this.d.length;k++)$.has(this.d[k].identifier)&&(this.d.splice(k,1),k--);for(let k=0;k<this.e.length;k++)a.has(this.e[k])&&(this.e.splice(k,1),k--);for(const k of r)this.d.push(k);for(const k of o)this.e.push(k);return m}containsExtension(m){for(const n of this.e)if(A.$8l.equals(n,m))return!0;return!1}}e.$kF=R;function S(D){const m=new A.$0l;for(const n of D)m.set(n.identifier,n);return m}function u(D,m){return!0}e.$lF=u;function b(D,m){if(!u(D,m))throw new Error(`Extension '${D.identifier.value}' CANNOT use API proposal: ${m}.
Its package.json#enabledApiProposals-property declares: ${D.enabledApiProposals?.join(", ")??"[]"} but NOT ${m}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${D.identifier.value}`)}e.$mF=b;class p{constructor(m,n,r,s){this.codeLoadingTime=m,this.activateCallTime=n,this.activateResolvedTime=r,this.activationReason=s}}e.$nF=p;class g{constructor(m,n){this.description=m,this.value=n}}e.$oF=g;var t;(function(D){D[D.Normal=0]="Normal",D[D.Immediate=1]="Immediate"})(t||(e.ActivationKind=t={}));function i(D){return{type:D.isBuiltin?0:1,isBuiltin:D.isBuiltin||D.isUserBuiltin,identifier:{id:(0,I.$Jo)(D.publisher,D.name),uuid:D.uuid},manifest:D,location:D.extensionLocation,targetPlatform:D.targetPlatform,validations:[],isValid:!0}}e.$pF=i;function l(D,m){return{identifier:new A.$8l((0,I.$Ho)(D.manifest.publisher,D.manifest.name)),isBuiltin:D.type===0,isUserBuiltin:D.type===1&&D.isBuiltin,isUnderDevelopment:!!m,extensionLocation:D.location,...D.manifest,uuid:D.identifier.uuid,targetPlatform:D.targetPlatform}}e.$qF=l;class v{constructor(){this.onDidRegisterExtensions=f.Event.None,this.onDidChangeExtensionsStatus=f.Event.None,this.onDidChangeExtensions=f.Event.None,this.onWillActivateByEvent=f.Event.None,this.onDidChangeResponsiveChange=f.Event.None,this.onWillStop=f.Event.None,this.extensions=[]}activateByEvent(m){return Promise.resolve(void 0)}activationEventIsDone(m){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(m){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(m,n){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(m){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$rF=v}),define(Ae[205],Re([1,0,11,103,21,22,14,12]),function(ee,e,f,C,I,O,A,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5cc=e.$4cc=e.$3cc=e.$2cc=e.$1cc=e.$Zcc=void 0;class E{constructor(i,l,v,D){this.startup=i,this.codeLoadingTime=l,this.activateCallTime=v,this.activateResolvedTime=D}}e.$Zcc=E,E.NONE=new E(!1,-1,-1,-1);class d{constructor(i){this.a=i,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(i,l){return i===-1||l===-1?-1:l-i}build(){return new E(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$1cc=d;class R{constructor(i,l,v,D,m,n){this.activationFailed=i,this.activationFailedError=l,this.activationTimes=v,this.module=D,this.exports=m,this.subscriptions=n}}e.$2cc=R;class S extends R{constructor(i){super(!1,null,i,{activate:void 0,deactivate:void 0},void 0,[])}}e.$3cc=S;class u extends R{constructor(){super(!1,null,E.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$4cc=u;class b extends R{constructor(i){super(!0,i,E.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let p=class{constructor(i,l,v,D){this.g=D,this.a=i,this.b=l,this.c=v,this.d=new I.$0l,this.f=Object.create(null)}dispose(){for(const[i,l]of this.d)l.dispose()}async waitForActivatingExtensions(){const i=[];for(const[l,v]of this.d)i.push(v.wait());await Promise.all(i)}isActivated(i){const l=this.d.get(i);return!!(l&&l.value)}getActivatedExtension(i){const l=this.d.get(i);if(!l||!l.value)throw new Error(`Extension '${i.value}' is not known or not activated`);return l.value}async activateByEvent(i,l){if(this.f[i])return;const v=this.a.getExtensionDescriptionsForActivationEvent(i);await this.h(v.map(D=>({id:D.identifier,reason:{startup:l,extensionId:D.identifier,activationEvent:i}}))),this.f[i]=!0}activateById(i,l){const v=this.a.getExtensionDescription(i);if(!v)throw new Error(`Extension '${i}' is not known`);return this.h([{id:v.identifier,reason:l}])}async h(i){const l=i.filter(v=>!this.isActivated(v.id)).map(v=>this.j(v));await Promise.all(l.map(v=>v.wait()))}j(i){if(this.d.has(i.id))return this.d.get(i.id);if(this.l(i.id))return this.k(i,null,[],null);const l=this.a.getExtensionDescription(i.id);if(!l){const m=new Error(`Cannot activate unknown extension '${i.id.value}'`),n=this.k(i,null,[],new b(m));return this.c.onExtensionActivationError(i.id,m,new O.$jF(i.id.value)),n}const v=[],D=typeof l.extensionDependencies>"u"?[]:l.extensionDependencies;for(const m of D){if(this.m(m))continue;const n=this.d.get(m);if(n){v.push(n);continue}if(this.l(m)){v.push(this.j({id:this.b.getExtensionDescription(m).identifier,reason:i.reason}));continue}const r=this.a.getExtensionDescription(m);if(r){if(!r.main&&!r.browser)continue;v.push(this.j({id:r.identifier,reason:i.reason}));continue}const s=l.displayName||l.identifier.value,o=new Error(`Cannot activate the '${s}' extension because it depends on unknown extension '${m}'`),$=this.k(i,l.displayName,[],new b(o));return this.c.onExtensionActivationError(l.identifier,o,new O.$jF(m)),$}return this.k(i,l.displayName,v,null)}k(i,l,v,D){const m=new g(i.id,l,i.reason,v,D,this.c,this.g);return this.d.set(i.id,m),m}l(i){return C.$V4b.isHostExtension(i,this.a,this.b)}m(i){const l=this.b.getExtensionDescription(i);return l?!l.main&&!l.browser:!1}};e.$5cc=p,e.$5cc=p=Ge([qe(3,A.$$i)],p);let g=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(i,l,v,D,m,n,r){this.c=i,this.d=l,this.f=v,this.g=D,this.h=m,this.j=n,this.k=r,this.a=new c.$Tg,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let i=0;i<this.g.length;i++){const l=this.g[i];if(l.value&&!l.value.activationFailed){this.g.splice(i,1),i--;continue}if(l.value&&l.value.activationFailed){const v=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${l.friendlyName}' failed to activate`);v.detail=l.value.activationFailedError,this.h=new b(v),this.j.onExtensionActivationError(this.c,v,null);return}}this.g.length>0&&await Promise.race(this.g.map(i=>i.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(i){const l=new Error;if(i&&i.name&&(l.name=i.name),i&&i.message?l.message=`Activating extension '${this.c.value}' failed: ${i.message}.`:l.message=`Activating extension '${this.c.value}' failed: ${i}.`,i&&i.stack&&(l.stack=i.stack),this.h=new b(l),this.b&&f.$4(i))return;this.j.onExtensionActivationError(this.c,l,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(i)}}};g=Ge([qe(6,A.$$i)],g)}),define(Ae[8],Re([1,0,18,26,124,206,51,28,116,67,66,25,15,2,41,79,94,101,99,75,46,58,203,7,22]),function(ee,e,f,C,I,O,A,c,E,d,R,S,u,b,p,g,t,i,l,v,D,m,n,r,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalQuickFix=e.ChatResponseProgress=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.ChatMessageRole=e.ChatMessage=e.ChatFollowup=e.ChatReplyFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.$qM=e.$pM=e.MarkdownString=e.$oM=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var o;(function(Pe){function Fe(G){const{selectionStartLineNumber:Me,selectionStartColumn:Be,positionLineNumber:Je,positionColumn:He}=G,it=new r.$tK(Me-1,Be-1),St=new r.$tK(Je-1,He-1);return new r.$vK(it,St)}Pe.to=Fe;function $e(G){const{anchor:Me,active:Be}=G;return{selectionStartLineNumber:Me.line+1,selectionStartColumn:Me.character+1,positionLineNumber:Be.line+1,positionColumn:Be.character+1}}Pe.from=$e})(o||(e.Selection=o={}));var $;(function(Pe){function Fe(G){if(!G)return;const{start:Me,end:Be}=G;return{startLineNumber:Me.line+1,startColumn:Me.character+1,endLineNumber:Be.line+1,endColumn:Be.character+1}}Pe.from=Fe;function $e(G){if(!G)return;const{startLineNumber:Me,startColumn:Be,endLineNumber:Je,endColumn:He}=G;return new r.$uK(Me-1,Be-1,Je-1,He-1)}Pe.to=$e})($||(e.Range=$={}));var a;(function(Pe){function Fe($e){switch($e){case 1:return r.StandardTokenType.Comment;case 0:return r.StandardTokenType.Other;case 3:return r.StandardTokenType.RegEx;case 2:return r.StandardTokenType.String}}Pe.to=Fe})(a||(e.TokenType=a={}));var k;(function(Pe){function Fe(G){return new r.$tK(G.lineNumber-1,G.column-1)}Pe.to=Fe;function $e(G){return{lineNumber:G.line+1,column:G.character+1}}Pe.from=$e})(k||(e.Position=k={}));var P;(function(Pe){function Fe(Me,Be,Je){return(0,f.$Hb)((0,f.$3b)(Me).map(He=>$e(He,Be,Je)))}Pe.from=Fe;function $e(Me,Be,Je){if(typeof Me=="string")return{$serialized:!0,language:Me,isBuiltin:Je?.isBuiltin};if(Me)return{$serialized:!0,language:Me.language,scheme:G(Me.scheme,Be),pattern:_.from(Me.pattern)??void 0,exclusive:Me.exclusive,notebookType:Me.notebookType,isBuiltin:Je?.isBuiltin}}function G(Me,Be){return Be&&typeof Me=="string"?Be.transformOutgoingScheme(Me):Me}})(P||(e.DocumentSelector=P={}));var h;(function(Pe){function Fe(G){switch(G){case r.DiagnosticTag.Unnecessary:return 1;case r.DiagnosticTag.Deprecated:return 2}}Pe.from=Fe;function $e(G){switch(G){case 1:return r.DiagnosticTag.Unnecessary;case 2:return r.DiagnosticTag.Deprecated;default:return}}Pe.to=$e})(h||(e.DiagnosticTag=h={}));var w;(function(Pe){function Fe(G){let Me;return G.code&&((0,u.$zf)(G.code)||(0,u.$Df)(G.code)?Me=String(G.code):Me={value:String(G.code.value),target:G.code.target}),{...$.from(G.range),message:G.message,source:G.source,code:Me,severity:M.from(G.severity),relatedInformation:G.relatedInformation&&G.relatedInformation.map(y.from),tags:Array.isArray(G.tags)?(0,f.$Hb)(G.tags.map(h.from)):void 0}}Pe.from=Fe;function $e(G){const Me=new r.$GK($.to(G),G.message,M.to(G.severity));return Me.source=G.source,Me.code=(0,u.$zf)(G.code)?G.code:G.code?.value,Me.relatedInformation=G.relatedInformation&&G.relatedInformation.map(y.to),Me.tags=G.tags&&(0,f.$Hb)(G.tags.map(h.to)),Me}Pe.to=$e})(w||(e.Diagnostic=w={}));var y;(function(Pe){function Fe(G){return{...$.from(G.location.range),message:G.message,resource:G.location.uri}}Pe.from=Fe;function $e(G){return new r.$FK(new r.$EK(G.resource,$.to(G)),G.message)}Pe.to=$e})(y||(e.DiagnosticRelatedInformation=y={}));var M;(function(Pe){function Fe(G){switch(G){case r.DiagnosticSeverity.Error:return t.MarkerSeverity.Error;case r.DiagnosticSeverity.Warning:return t.MarkerSeverity.Warning;case r.DiagnosticSeverity.Information:return t.MarkerSeverity.Info;case r.DiagnosticSeverity.Hint:return t.MarkerSeverity.Hint}return t.MarkerSeverity.Error}Pe.from=Fe;function $e(G){switch(G){case t.MarkerSeverity.Info:return r.DiagnosticSeverity.Information;case t.MarkerSeverity.Warning:return r.DiagnosticSeverity.Warning;case t.MarkerSeverity.Error:return r.DiagnosticSeverity.Error;case t.MarkerSeverity.Hint:return r.DiagnosticSeverity.Hint;default:return r.DiagnosticSeverity.Error}}Pe.to=$e})(M||(e.DiagnosticSeverity=M={}));var V;(function(Pe){function Fe(G){return typeof G=="number"&&G>=r.ViewColumn.One?G-1:G===r.ViewColumn.Beside?n.$yC:n.$xC}Pe.from=Fe;function $e(G){if(typeof G=="number"&&G>=0)return G+1;throw new Error("invalid 'EditorGroupColumn'")}Pe.to=$e})(V||(e.ViewColumn=V={}));function B(Pe){return typeof Pe.range<"u"}function z(Pe){return Pe.length===0?!0:!!B(Pe[0])}e.$oM=z;var T;(function(Pe){function Fe(He){return He.map(Pe.from)}Pe.fromMany=Fe;function $e(He){return He&&typeof He=="object"&&typeof He.language=="string"&&typeof He.value=="string"}function G(He){let it;if($e(He)){const{language:gt,value:mt}=He;it={value:"```"+gt+`
`+mt+"\n```\n"}}else r.$SK.isMarkdownString(He)?it={value:He.value,isTrusted:He.isTrusted,supportThemeIcons:He.supportThemeIcons,supportHtml:He.supportHtml,baseUri:He.baseUri}:typeof He=="string"?it={value:He}:it={value:""};const St=Object.create(null);it.uris=St;const bt=gt=>{try{let mt=b.URI.parse(gt,!0);mt=mt.with({query:Me(mt.query,St)}),St[gt]=mt}catch{}return""},$t=new E.marked.Renderer;return $t.link=bt,$t.image=gt=>typeof gt=="string"?bt(A.$$j(gt).href):"",(0,E.marked)(it.value,{renderer:$t}),it}Pe.from=G;function Me(He,it){if(!He)return He;let St;try{St=(0,d.$mh)(He)}catch{}if(!St)return He;let bt=!1;return St=(0,S.$$m)(St,$t=>{if(b.URI.isUri($t)){const gt=`__uri_${Math.random().toString(16).slice(2,8)}`;return it[gt]=$t,bt=!0,gt}else return}),bt?JSON.stringify(St):He}function Be(He){const it=new r.$SK(He.value,He.supportThemeIcons);return it.isTrusted=He.isTrusted,it.supportHtml=He.supportHtml,it.baseUri=He.baseUri?b.URI.from(He.baseUri):void 0,it}Pe.to=Be;function Je(He){if(He)return typeof He=="string"?He:Pe.from(He)}Pe.fromStrict=Je})(T||(e.MarkdownString=T={}));function F(Pe){return z(Pe)?Pe.map(Fe=>({range:$.from(Fe.range),hoverMessage:Array.isArray(Fe.hoverMessage)?T.fromMany(Fe.hoverMessage):Fe.hoverMessage?T.from(Fe.hoverMessage):void 0,renderOptions:Fe.renderOptions})):Pe.map(Fe=>({range:$.from(Fe)}))}e.$pM=F;function j(Pe){return typeof Pe>"u"?Pe:typeof Pe=="string"?b.URI.file(Pe):Pe}e.$qM=j;var q;(function(Pe){function Fe($e){return typeof $e>"u"?$e:{contentText:$e.contentText,contentIconPath:$e.contentIconPath?j($e.contentIconPath):void 0,border:$e.border,borderColor:$e.borderColor,fontStyle:$e.fontStyle,fontWeight:$e.fontWeight,textDecoration:$e.textDecoration,color:$e.color,backgroundColor:$e.backgroundColor,margin:$e.margin,width:$e.width,height:$e.height}}Pe.from=Fe})(q||(e.ThemableDecorationAttachmentRenderOptions=q={}));var W;(function(Pe){function Fe($e){return typeof $e>"u"?$e:{backgroundColor:$e.backgroundColor,outline:$e.outline,outlineColor:$e.outlineColor,outlineStyle:$e.outlineStyle,outlineWidth:$e.outlineWidth,border:$e.border,borderColor:$e.borderColor,borderRadius:$e.borderRadius,borderSpacing:$e.borderSpacing,borderStyle:$e.borderStyle,borderWidth:$e.borderWidth,fontStyle:$e.fontStyle,fontWeight:$e.fontWeight,textDecoration:$e.textDecoration,cursor:$e.cursor,color:$e.color,opacity:$e.opacity,letterSpacing:$e.letterSpacing,gutterIconPath:$e.gutterIconPath?j($e.gutterIconPath):void 0,gutterIconSize:$e.gutterIconSize,overviewRulerColor:$e.overviewRulerColor,before:$e.before?q.from($e.before):void 0,after:$e.after?q.from($e.after):void 0}}Pe.from=Fe})(W||(e.ThemableDecorationRenderOptions=W={}));var we;(function(Pe){function Fe($e){if(typeof $e>"u")return $e;switch($e){case r.DecorationRangeBehavior.OpenOpen:return 0;case r.DecorationRangeBehavior.ClosedClosed:return 1;case r.DecorationRangeBehavior.OpenClosed:return 2;case r.DecorationRangeBehavior.ClosedOpen:return 3}}Pe.from=Fe})(we||(e.DecorationRangeBehavior=we={}));var ke;(function(Pe){function Fe($e){return{isWholeLine:$e.isWholeLine,rangeBehavior:$e.rangeBehavior?we.from($e.rangeBehavior):void 0,overviewRulerLane:$e.overviewRulerLane,light:$e.light?W.from($e.light):void 0,dark:$e.dark?W.from($e.dark):void 0,backgroundColor:$e.backgroundColor,outline:$e.outline,outlineColor:$e.outlineColor,outlineStyle:$e.outlineStyle,outlineWidth:$e.outlineWidth,border:$e.border,borderColor:$e.borderColor,borderRadius:$e.borderRadius,borderSpacing:$e.borderSpacing,borderStyle:$e.borderStyle,borderWidth:$e.borderWidth,fontStyle:$e.fontStyle,fontWeight:$e.fontWeight,textDecoration:$e.textDecoration,cursor:$e.cursor,color:$e.color,opacity:$e.opacity,letterSpacing:$e.letterSpacing,gutterIconPath:$e.gutterIconPath?j($e.gutterIconPath):void 0,gutterIconSize:$e.gutterIconSize,overviewRulerColor:$e.overviewRulerColor,before:$e.before?q.from($e.before):void 0,after:$e.after?q.from($e.after):void 0}}Pe.from=Fe})(ke||(e.DecorationRenderOptions=ke={}));var Se;(function(Pe){function Fe(G){return{text:G.newText,eol:G.newEol&&et.from(G.newEol),range:$.from(G.range)}}Pe.from=Fe;function $e(G){const Me=new r.$zK($.to(G.range),G.text);return Me.newEol=typeof G.eol>"u"?void 0:et.to(G.eol),Me}Pe.to=$e})(Se||(e.TextEdit=Se={}));var ve;(function(Pe){function Fe(G,Me){const Be={edits:[]};if(G instanceof r.$CK){const Je=new c.$Bc;for(const He of G._allEntries())He._type===1&&b.URI.isUri(He.to)&&He.from===void 0&&Je.add(He.to);for(const He of G._allEntries())if(He._type===1){let it;He.options?.contents&&(ArrayBuffer.isView(He.options.contents)?it={type:"base64",value:(0,C.$we)(C.$ce.wrap(He.options.contents))}:it={type:"dataTransferItem",id:He.options.contents._itemId}),Be.edits.push({oldResource:He.from,newResource:He.to,options:{...He.options,contents:it},metadata:He.metadata})}else He._type===2?Be.edits.push({resource:He.uri,textEdit:Se.from(He.edit),versionId:Je.has(He.uri)?void 0:Me?.getTextDocumentVersion(He.uri),metadata:He.metadata}):He._type===6?Be.edits.push({resource:He.uri,textEdit:{range:$.from(He.range),text:He.edit.value,insertAsSnippet:!0},versionId:Je.has(He.uri)?void 0:Me?.getTextDocumentVersion(He.uri),metadata:He.metadata}):He._type===3?Be.edits.push({metadata:He.metadata,resource:He.uri,cellEdit:He.edit,notebookMetadata:He.notebookMetadata,notebookVersionId:Me?.getNotebookDocumentVersion(He.uri)}):He._type===5&&Be.edits.push({metadata:He.metadata,resource:He.uri,notebookVersionId:Me?.getNotebookDocumentVersion(He.uri),cellEdit:{editType:1,index:He.index,count:He.count,cells:He.cells.map(yt.from)}})}return Be}Pe.from=Fe;function $e(G){const Me=new r.$CK,Be=new c.$Ac;for(const Je of G.edits)if(Je.textEdit){const He=Je,it=b.URI.revive(He.resource),St=$.to(He.textEdit.range),bt=He.textEdit.text,$t=He.textEdit.insertAsSnippet;let gt;$t?gt=r.$BK.replace(St,new r.$DK(bt)):gt=r.$zK.replace(St,bt);const mt=Be.get(it);mt?mt.push(gt):Be.set(it,[gt])}else Me.renameFile(b.URI.revive(Je.oldResource),b.URI.revive(Je.newResource),Je.options);for(const[Je,He]of Be)Me.set(Je,He);return Me}Pe.to=$e})(ve||(e.WorkspaceEdit=ve={}));var ge;(function(Pe){const Fe=Object.create(null);Fe[r.SymbolKind.File]=0,Fe[r.SymbolKind.Module]=1,Fe[r.SymbolKind.Namespace]=2,Fe[r.SymbolKind.Package]=3,Fe[r.SymbolKind.Class]=4,Fe[r.SymbolKind.Method]=5,Fe[r.SymbolKind.Property]=6,Fe[r.SymbolKind.Field]=7,Fe[r.SymbolKind.Constructor]=8,Fe[r.SymbolKind.Enum]=9,Fe[r.SymbolKind.Interface]=10,Fe[r.SymbolKind.Function]=11,Fe[r.SymbolKind.Variable]=12,Fe[r.SymbolKind.Constant]=13,Fe[r.SymbolKind.String]=14,Fe[r.SymbolKind.Number]=15,Fe[r.SymbolKind.Boolean]=16,Fe[r.SymbolKind.Array]=17,Fe[r.SymbolKind.Object]=18,Fe[r.SymbolKind.Key]=19,Fe[r.SymbolKind.Null]=20,Fe[r.SymbolKind.EnumMember]=21,Fe[r.SymbolKind.Struct]=22,Fe[r.SymbolKind.Event]=23,Fe[r.SymbolKind.Operator]=24,Fe[r.SymbolKind.TypeParameter]=25;function $e(Me){return typeof Fe[Me]=="number"?Fe[Me]:6}Pe.from=$e;function G(Me){for(const Be in Fe)if(Fe[Be]===Me)return Number(Be);return r.SymbolKind.Property}Pe.to=G})(ge||(e.SymbolKind=ge={}));var re;(function(Pe){function Fe(G){switch(G){case r.SymbolTag.Deprecated:return 1}}Pe.from=Fe;function $e(G){switch(G){case 1:return r.SymbolTag.Deprecated}}Pe.to=$e})(re||(e.SymbolTag=re={}));var oe;(function(Pe){function Fe(G){return{name:G.name,kind:ge.from(G.kind),tags:G.tags&&G.tags.map(re.from),containerName:G.containerName,location:J.from(G.location)}}Pe.from=Fe;function $e(G){const Me=new r.$JK(G.name,ge.to(G.kind),G.containerName,J.to(G.location));return Me.tags=G.tags&&G.tags.map(re.to),Me}Pe.to=$e})(oe||(e.WorkspaceSymbol=oe={}));var ye;(function(Pe){function Fe(G){const Me={name:G.name||"!!MISSING: name!!",detail:G.detail,range:$.from(G.range),selectionRange:$.from(G.selectionRange),kind:ge.from(G.kind),tags:G.tags?.map(re.from)??[]};return G.children&&(Me.children=G.children.map(Fe)),Me}Pe.from=Fe;function $e(G){const Me=new r.$KK(G.name,G.detail,ge.to(G.kind),$.to(G.range),$.to(G.selectionRange));return(0,f.$Lb)(G.tags)&&(Me.tags=G.tags.map(re.to)),G.children&&(Me.children=G.children.map($e)),Me}Pe.to=$e})(ye||(e.DocumentSymbol=ye={}));var De;(function(Pe){function Fe(G){const Me=new r.$OK(ge.to(G.kind),G.name,G.detail||"",b.URI.revive(G.uri),$.to(G.range),$.to(G.selectionRange));return Me._sessionId=G._sessionId,Me._itemId=G._itemId,Me}Pe.to=Fe;function $e(G,Me,Be){if(Me=Me??G._sessionId,Be=Be??G._itemId,Me===void 0||Be===void 0)throw new Error("invalid item");return{_sessionId:Me,_itemId:Be,name:G.name,detail:G.detail,kind:ge.from(G.kind),uri:G.uri,range:$.from(G.range),selectionRange:$.from(G.selectionRange),tags:G.tags?.map(re.from)}}Pe.from=$e})(De||(e.CallHierarchyItem=De={}));var Q;(function(Pe){function Fe($e){return new r.$PK(De.to($e.from),$e.fromRanges.map(G=>$.to(G)))}Pe.to=Fe})(Q||(e.CallHierarchyIncomingCall=Q={}));var ue;(function(Pe){function Fe($e){return new r.$QK(De.to($e.to),$e.fromRanges.map(G=>$.to(G)))}Pe.to=Fe})(ue||(e.CallHierarchyOutgoingCall=ue={}));var J;(function(Pe){function Fe(G){return{range:G.range&&$.from(G.range),uri:G.uri}}Pe.from=Fe;function $e(G){return new r.$EK(b.URI.revive(G.uri),$.to(G.range))}Pe.to=$e})(J||(e.location=J={}));var he;(function(Pe){function Fe(G){const Me=G,Be=G;return{originSelectionRange:Me.originSelectionRange?$.from(Me.originSelectionRange):void 0,uri:Me.targetUri?Me.targetUri:Be.uri,range:$.from(Me.targetRange?Me.targetRange:Be.range),targetSelectionRange:Me.targetSelectionRange?$.from(Me.targetSelectionRange):void 0}}Pe.from=Fe;function $e(G){return{targetUri:b.URI.revive(G.uri),targetRange:$.to(G.range),targetSelectionRange:G.targetSelectionRange?$.to(G.targetSelectionRange):void 0,originSelectionRange:G.originSelectionRange?$.to(G.originSelectionRange):void 0}}Pe.to=$e})(he||(e.DefinitionLink=he={}));var de;(function(Pe){function Fe(G){return{range:$.from(G.range),contents:T.fromMany(G.contents)}}Pe.from=Fe;function $e(G){return new r.$HK(G.contents.map(T.to),$.to(G.range))}Pe.to=$e})(de||(e.Hover=de={}));var le;(function(Pe){function Fe(G){return{range:$.from(G.range),expression:G.expression}}Pe.from=Fe;function $e(G){return new r.$AL($.to(G.range),G.expression)}Pe.to=$e})(le||(e.EvaluatableExpression=le={}));var be;(function(Pe){function Fe(G){if(G instanceof r.$BL)return{type:"text",range:$.from(G.range),text:G.text};if(G instanceof r.$CL)return{type:"variable",range:$.from(G.range),variableName:G.variableName,caseSensitiveLookup:G.caseSensitiveLookup};if(G instanceof r.$DL)return{type:"expression",range:$.from(G.range),expression:G.expression};throw new Error("Unknown 'InlineValue' type")}Pe.from=Fe;function $e(G){switch(G.type){case"text":return{range:$.to(G.range),text:G.text};case"variable":return{range:$.to(G.range),variableName:G.variableName,caseSensitiveLookup:G.caseSensitiveLookup};case"expression":return{range:$.to(G.range),expression:G.expression}}}Pe.to=$e})(be||(e.InlineValue=be={}));var ie;(function(Pe){function Fe(G){return{frameId:G.frameId,stoppedLocation:$.from(G.stoppedLocation)}}Pe.from=Fe;function $e(G){return new r.$EL(G.frameId,$.to(G.stoppedLocation))}Pe.to=$e})(ie||(e.InlineValueContext=ie={}));var fe;(function(Pe){function Fe(G){return{range:$.from(G.range),kind:G.kind}}Pe.from=Fe;function $e(G){return new r.$IK($.to(G.range),G.kind)}Pe.to=$e})(fe||(e.DocumentHighlight=fe={}));var ne;(function(Pe){function Fe($e){switch($e){case 1:return r.CompletionTriggerKind.TriggerCharacter;case 2:return r.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return r.CompletionTriggerKind.Invoke}}Pe.to=Fe})(ne||(e.CompletionTriggerKind=ne={}));var ce;(function(Pe){function Fe($e){return{triggerKind:ne.to($e.triggerKind),triggerCharacter:$e.triggerCharacter}}Pe.to=Fe})(ce||(e.CompletionContext=ce={}));var pe;(function(Pe){function Fe(G){switch(G){case r.CompletionItemTag.Deprecated:return 1}}Pe.from=Fe;function $e(G){switch(G){case 1:return r.CompletionItemTag.Deprecated}}Pe.to=$e})(pe||(e.CompletionItemTag=pe={}));var Ce;(function(Pe){const Fe=new Map([[r.CompletionItemKind.Method,0],[r.CompletionItemKind.Function,1],[r.CompletionItemKind.Constructor,2],[r.CompletionItemKind.Field,3],[r.CompletionItemKind.Variable,4],[r.CompletionItemKind.Class,5],[r.CompletionItemKind.Interface,7],[r.CompletionItemKind.Struct,6],[r.CompletionItemKind.Module,8],[r.CompletionItemKind.Property,9],[r.CompletionItemKind.Unit,12],[r.CompletionItemKind.Value,13],[r.CompletionItemKind.Constant,14],[r.CompletionItemKind.Enum,15],[r.CompletionItemKind.EnumMember,16],[r.CompletionItemKind.Keyword,17],[r.CompletionItemKind.Snippet,27],[r.CompletionItemKind.Text,18],[r.CompletionItemKind.Color,19],[r.CompletionItemKind.File,20],[r.CompletionItemKind.Reference,21],[r.CompletionItemKind.Folder,23],[r.CompletionItemKind.Event,10],[r.CompletionItemKind.Operator,11],[r.CompletionItemKind.TypeParameter,24],[r.CompletionItemKind.Issue,26],[r.CompletionItemKind.User,25]]);function $e(Be){return Fe.get(Be)??9}Pe.from=$e;const G=new Map([[0,r.CompletionItemKind.Method],[1,r.CompletionItemKind.Function],[2,r.CompletionItemKind.Constructor],[3,r.CompletionItemKind.Field],[4,r.CompletionItemKind.Variable],[5,r.CompletionItemKind.Class],[7,r.CompletionItemKind.Interface],[6,r.CompletionItemKind.Struct],[8,r.CompletionItemKind.Module],[9,r.CompletionItemKind.Property],[12,r.CompletionItemKind.Unit],[13,r.CompletionItemKind.Value],[14,r.CompletionItemKind.Constant],[15,r.CompletionItemKind.Enum],[16,r.CompletionItemKind.EnumMember],[17,r.CompletionItemKind.Keyword],[27,r.CompletionItemKind.Snippet],[18,r.CompletionItemKind.Text],[19,r.CompletionItemKind.Color],[20,r.CompletionItemKind.File],[21,r.CompletionItemKind.Reference],[23,r.CompletionItemKind.Folder],[10,r.CompletionItemKind.Event],[11,r.CompletionItemKind.Operator],[24,r.CompletionItemKind.TypeParameter],[25,r.CompletionItemKind.User],[26,r.CompletionItemKind.Issue]]);function Me(Be){return G.get(Be)??r.CompletionItemKind.Property}Pe.to=Me})(Ce||(e.CompletionItemKind=Ce={}));var L;(function(Pe){function Fe($e,G){const Me=new r.$YK($e.label);return Me.insertText=$e.insertText,Me.kind=Ce.to($e.kind),Me.tags=$e.tags?.map(pe.to),Me.detail=$e.detail,Me.documentation=A.$6j($e.documentation)?T.to($e.documentation):$e.documentation,Me.sortText=$e.sortText,Me.filterText=$e.filterText,Me.preselect=$e.preselect,Me.commitCharacters=$e.commitCharacters,p.$ys.isIRange($e.range)?Me.range=$.to($e.range):typeof $e.range=="object"&&(Me.range={inserting:$.to($e.range.insert),replacing:$.to($e.range.replace)}),Me.keepWhitespace=typeof $e.insertTextRules>"u"?!1:!!($e.insertTextRules&1),typeof $e.insertTextRules<"u"&&$e.insertTextRules&4?Me.insertText=new r.$DK($e.insertText):(Me.insertText=$e.insertText,Me.textEdit=Me.range instanceof r.$uK?new r.$zK(Me.range,Me.insertText):void 0),$e.additionalTextEdits&&$e.additionalTextEdits.length>0&&(Me.additionalTextEdits=$e.additionalTextEdits.map(Be=>Se.to(Be))),Me.command=G&&$e.command?G.fromInternal($e.command):void 0,Me}Pe.to=Fe})(L||(e.CompletionItem=L={}));var K;(function(Pe){function Fe(G){if(typeof G.label!="string"&&!Array.isArray(G.label))throw new TypeError("Invalid label");return{label:G.label,documentation:T.fromStrict(G.documentation)}}Pe.from=Fe;function $e(G){return{label:G.label,documentation:A.$6j(G.documentation)?T.to(G.documentation):G.documentation}}Pe.to=$e})(K||(e.ParameterInformation=K={}));var Y;(function(Pe){function Fe(G){return{label:G.label,documentation:T.fromStrict(G.documentation),parameters:Array.isArray(G.parameters)?G.parameters.map(K.from):[],activeParameter:G.activeParameter}}Pe.from=Fe;function $e(G){return{label:G.label,documentation:A.$6j(G.documentation)?T.to(G.documentation):G.documentation,parameters:Array.isArray(G.parameters)?G.parameters.map(K.to):[],activeParameter:G.activeParameter}}Pe.to=$e})(Y||(e.SignatureInformation=Y={}));var X;(function(Pe){function Fe(G){return{activeSignature:G.activeSignature,activeParameter:G.activeParameter,signatures:Array.isArray(G.signatures)?G.signatures.map(Y.from):[]}}Pe.from=Fe;function $e(G){return{activeSignature:G.activeSignature,activeParameter:G.activeParameter,signatures:Array.isArray(G.signatures)?G.signatures.map(Y.to):[]}}Pe.to=$e})(X||(e.SignatureHelp=X={}));var H;(function(Pe){function Fe($e,G){const Me=new r.$XK(k.to(G.position),typeof G.label=="string"?G.label:G.label.map(x.to.bind(void 0,$e)),G.kind&&se.to(G.kind));return Me.textEdits=G.textEdits&&G.textEdits.map(Se.to),Me.tooltip=A.$6j(G.tooltip)?T.to(G.tooltip):G.tooltip,Me.paddingLeft=G.paddingLeft,Me.paddingRight=G.paddingRight,Me}Pe.to=Fe})(H||(e.InlayHint=H={}));var x;(function(Pe){function Fe($e,G){const Me=new r.$WK(G.label);return Me.tooltip=A.$6j(G.tooltip)?T.to(G.tooltip):G.tooltip,g.Command.is(G.command)&&(Me.command=$e.fromInternal(G.command)),G.location&&(Me.location=J.to(G.location)),Me}Pe.to=Fe})(x||(e.InlayHintLabelPart=x={}));var se;(function(Pe){function Fe(G){return G}Pe.from=Fe;function $e(G){return G}Pe.to=$e})(se||(e.InlayHintKind=se={}));var Le;(function(Pe){function Fe(G){return{range:$.from(G.range),url:G.target,tooltip:G.tooltip}}Pe.from=Fe;function $e(G){let Me;if(G.url)try{Me=typeof G.url=="string"?b.URI.parse(G.url,!0):b.URI.revive(G.url)}catch{}return new r.$4K($.to(G.range),Me)}Pe.to=$e})(Le||(e.DocumentLink=Le={}));var je;(function(Pe){function Fe(G){const Me=new r.$7K(G.label);return G.textEdit&&(Me.textEdit=Se.to(G.textEdit)),G.additionalTextEdits&&(Me.additionalTextEdits=G.additionalTextEdits.map(Be=>Se.to(Be))),Me}Pe.to=Fe;function $e(G){return{label:G.label,textEdit:G.textEdit?Se.from(G.textEdit):void 0,additionalTextEdits:G.additionalTextEdits?G.additionalTextEdits.map(Me=>Se.from(Me)):void 0}}Pe.from=$e})(je||(e.ColorPresentation=je={}));var Ye;(function(Pe){function Fe(G){return new r.$5K(G[0],G[1],G[2],G[3])}Pe.to=Fe;function $e(G){return[G.red,G.green,G.blue,G.alpha]}Pe.from=$e})(Ye||(e.Color=Ye={}));var Ke;(function(Pe){function Fe(G){return{range:$.from(G.range)}}Pe.from=Fe;function $e(G){return new r.$NK($.to(G.range))}Pe.to=$e})(Ke||(e.SelectionRange=Ke={}));var tt;(function(Pe){function Fe($e){switch($e){case 2:return r.TextDocumentSaveReason.AfterDelay;case 1:return r.TextDocumentSaveReason.Manual;case 3:case 4:return r.TextDocumentSaveReason.FocusOut}}Pe.to=Fe})(tt||(e.TextDocumentSaveReason=tt={}));var xe;(function(Pe){function Fe(G){switch(G){case r.TextEditorLineNumbersStyle.Off:return 0;case r.TextEditorLineNumbersStyle.Relative:return 2;case r.TextEditorLineNumbersStyle.On:default:return 1}}Pe.from=Fe;function $e(G){switch(G){case 0:return r.TextEditorLineNumbersStyle.Off;case 2:return r.TextEditorLineNumbersStyle.Relative;case 1:default:return r.TextEditorLineNumbersStyle.On}}Pe.to=$e})(xe||(e.TextEditorLineNumbersStyle=xe={}));var et;(function(Pe){function Fe(G){if(G===r.EndOfLine.CRLF)return 1;if(G===r.EndOfLine.LF)return 0}Pe.from=Fe;function $e(G){if(G===1)return r.EndOfLine.CRLF;if(G===0)return r.EndOfLine.LF}Pe.to=$e})(et||(e.EndOfLine=et={}));var rt;(function(Pe){function Fe($e){if(typeof $e=="object")return $e.viewId;switch($e){case r.ProgressLocation.SourceControl:return 3;case r.ProgressLocation.Window:return 10;case r.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Pe.from=Fe})(rt||(e.ProgressLocation=rt={}));var nt;(function(Pe){function Fe(G){const Me={start:G.start+1,end:G.end+1};return G.kind&&(Me.kind=Ue.from(G.kind)),Me}Pe.from=Fe;function $e(G){const Me={start:G.start-1,end:G.end-1};return G.kind&&(Me.kind=Ue.to(G.kind)),Me}Pe.to=$e})(nt||(e.FoldingRange=nt={}));var Ue;(function(Pe){function Fe(G){if(G)switch(G){case r.FoldingRangeKind.Comment:return g.$nt.Comment;case r.FoldingRangeKind.Imports:return g.$nt.Imports;case r.FoldingRangeKind.Region:return g.$nt.Region}}Pe.from=Fe;function $e(G){if(G)switch(G.value){case g.$nt.Comment.value:return r.FoldingRangeKind.Comment;case g.$nt.Imports.value:return r.FoldingRangeKind.Imports;case g.$nt.Region.value:return r.FoldingRangeKind.Region}}Pe.to=$e})(Ue||(e.FoldingRangeKind=Ue={}));var lt;(function(Pe){function Fe($e){if($e)return{pinned:typeof $e.preview=="boolean"?!$e.preview:void 0,inactive:$e.background,preserveFocus:$e.preserveFocus,selection:typeof $e.selection=="object"?$.from($e.selection):void 0,override:typeof $e.override=="boolean"?l.$ZD.id:void 0}}Pe.from=Fe})(lt||(e.TextEditorOpenOptions=lt={}));var _;(function(Pe){function Fe(Be){return Be instanceof r.$oL?Be.toJSON():typeof Be=="string"?Be:$e(Be)||G(Be)?new r.$oL(Be.baseUri??Be.base,Be.pattern).toJSON():Be}Pe.from=Fe;function $e(Be){const Je=Be;return Je?b.URI.isUri(Je.baseUri)&&typeof Je.pattern=="string":!1}function G(Be){const Je=Be;return Je?typeof Je.base=="string"&&typeof Je.pattern=="string":!1}function Me(Be){return typeof Be=="string"?Be:new r.$oL(b.URI.revive(Be.baseUri),Be.pattern)}Pe.to=Me})(_||(e.GlobPattern=_={}));var Z;(function(Pe){function Fe($e){if($e){if(Array.isArray($e))return $e.map(Fe);if(typeof $e=="string")return $e;{const G=$e;return{language:G.language,scheme:G.scheme,pattern:_.from(G.pattern),exclusive:G.exclusive,notebookType:G.notebookType}}}else return}Pe.from=Fe})(Z||(e.LanguageSelector=Z={}));var Ee;(function(Pe){function Fe(G){return!!G&&typeof G=="object"&&"documents"in G&&Array.isArray(G.documents)&&G.documents.every(Me=>Array.isArray(Me)&&Me.every(Be=>Be&&typeof Be=="object"&&"uri"in Be&&b.URI.isUri(Be.uri)&&"version"in Be&&typeof Be.version=="number"&&"ranges"in Be&&Array.isArray(Be.ranges)&&Be.ranges.every(Je=>Je instanceof r.$uK)))}Pe.is=Fe;function $e(G){return{documents:G.documents.map(Me=>Me.map(Be=>({uri:b.URI.from(Be.uri),version:Be.version,ranges:Be.ranges.map(Je=>$.from(Je))})))}}Pe.from=$e})(Ee||(e.MappedEditsContext=Ee={}));var We;(function(Pe){function Fe(G){return{start:G.start,end:G.end}}Pe.from=Fe;function $e(G){return new r.$PL(G.start,G.end)}Pe.to=$e})(We||(e.NotebookRange=We={}));var ze;(function(Pe){function Fe(G){return{timing:typeof G.runStartTime=="number"&&typeof G.runEndTime=="number"?{startTime:G.runStartTime,endTime:G.runEndTime}:void 0,executionOrder:G.executionOrder,success:G.lastRunSuccess}}Pe.to=Fe;function $e(G){return{lastRunSuccess:G.success,runStartTime:G.timing?.startTime,runEndTime:G.timing?.endTime,executionOrder:G.executionOrder}}Pe.from=$e})(ze||(e.NotebookCellExecutionSummary=ze={}));var Ze;(function(Pe){function Fe($e){if($e===v.NotebookCellExecutionState.Unconfirmed)return r.NotebookCellExecutionState.Pending;if($e===v.NotebookCellExecutionState.Pending)return;if($e===v.NotebookCellExecutionState.Executing)return r.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${$e}`)}Pe.to=Fe})(Ze||(e.NotebookCellExecutionState=Ze={}));var st;(function(Pe){function Fe(G){switch(G){case r.NotebookCellKind.Markup:return v.CellKind.Markup;case r.NotebookCellKind.Code:default:return v.CellKind.Code}}Pe.from=Fe;function $e(G){switch(G){case v.CellKind.Markup:return r.NotebookCellKind.Markup;case v.CellKind.Code:default:return r.NotebookCellKind.Code}}Pe.to=$e})(st||(e.NotebookCellKind=st={}));var vt;(function(Pe){function Fe(G){const Me={metadata:G.metadata??Object.create(null),cells:[]};for(const Be of G.cells)r.$QL.validate(Be),Me.cells.push(yt.from(Be));return Me}Pe.from=Fe;function $e(G){const Me=new r.$RL(G.cells.map(yt.to));return(0,u.$Mf)(G.metadata)||(Me.metadata=G.metadata),Me}Pe.to=$e})(vt||(e.NotebookData=vt={}));var yt;(function(Pe){function Fe(G){return{cellKind:st.from(G.kind),language:G.languageId,mime:G.mime,source:G.value,metadata:G.metadata,internalMetadata:ze.from(G.executionSummary??{}),outputs:G.outputs?G.outputs.map(Vt.from):[]}}Pe.from=Fe;function $e(G){return new r.$QL(st.to(G.cellKind),G.source,G.language,G.mime,G.outputs?G.outputs.map(Vt.to):void 0,G.metadata,G.internalMetadata?ze.to(G.internalMetadata):void 0)}Pe.to=$e})(yt||(e.NotebookCellData=yt={}));var Mt;(function(Pe){function Fe(G){return{mime:G.mime,valueBytes:C.$ce.wrap(G.data)}}Pe.from=Fe;function $e(G){return new r.$SL(G.valueBytes.buffer,G.mime)}Pe.to=$e})(Mt||(e.NotebookCellOutputItem=Mt={}));var Vt;(function(Pe){function Fe(G){return{outputId:G.id,items:G.items.map(Mt.from),metadata:G.metadata}}Pe.from=Fe;function $e(G){const Me=G.items.map(Mt.to);return new r.$TL(Me,G.outputId,G.metadata)}Pe.to=$e})(Vt||(e.NotebookCellOutput=Vt={}));var qt;(function(Pe){function Fe(Me){return G(Me)?{include:_.from(Me.include)??void 0,exclude:_.from(Me.exclude)??void 0}:_.from(Me)??void 0}Pe.from=Fe;function $e(Me){return G(Me)?{include:_.to(Me.include),exclude:_.to(Me.exclude)}:_.to(Me)}Pe.to=$e;function G(Me){const Be=Me;return Be?!(0,u.$If)(Be.include)&&!(0,u.$If)(Be.exclude):!1}})(qt||(e.NotebookExclusiveDocumentPattern=qt={}));var Et;(function(Pe){function Fe($e,G,Me){const Be=typeof $e.command=="string"?{title:"",command:$e.command}:$e.command;return{alignment:$e.alignment===r.NotebookCellStatusBarAlignment.Left?1:2,command:G.toInternal(Be,Me),text:$e.text,tooltip:$e.tooltip,accessibilityInformation:$e.accessibilityInformation,priority:$e.priority}}Pe.from=Fe})(Et||(e.NotebookStatusBarItem=Et={}));var Lt;(function(Pe){function Fe($e,G,Me){const Be=typeof $e.command=="string"?{title:"",command:$e.command}:$e.command;return{command:G.toInternal(Be,Me),label:$e.label,description:$e.description,detail:$e.detail,documentation:$e.documentation}}Pe.from=Fe})(Lt||(e.NotebookKernelSourceAction=Lt={}));var Ot;(function(Pe){function Fe($e){return{transientOutputs:$e?.transientOutputs??!1,transientCellMetadata:$e?.transientCellMetadata??{},transientDocumentMetadata:$e?.transientDocumentMetadata??{},cellContentMetadata:$e?.cellContentMetadata??{}}}Pe.from=Fe})(Ot||(e.NotebookDocumentContentOptions=Ot={}));var xt;(function(Pe){function Fe(G){return{uri:G.uri,provides:G.provides}}Pe.from=Fe;function $e(G){return new r.$VL(b.URI.revive(G.uri),G.provides)}Pe.to=$e})(xt||(e.NotebookRendererScript=xt={}));var Yt;(function(Pe){function Fe(G){return{message:T.fromStrict(G.message)||"",type:0,expected:G.expectedOutput,actual:G.actualOutput,contextValue:G.contextValue,location:G.location&&{range:$.from(G.location.range),uri:G.location.uri}}}Pe.from=Fe;function $e(G){const Me=new r.$2L(typeof G.message=="string"?G.message:T.to(G.message));return Me.actualOutput=G.actual,Me.expectedOutput=G.expected,Me.contextValue=G.contextValue,Me.location=G.location?J.to(G.location):void 0,Me}Pe.to=$e})(Yt||(e.TestMessage=Yt={}));var It;(function(Pe){Pe.namespace=m.$nJ,Pe.denamespace=m.$oJ})(It||(e.TestTag=It={}));var Nt;(function(Pe){function Fe(G){const Me=(0,i.$nM)(G).controllerId;return{extId:D.$jJ.fromExtHostTestItem(G,Me).toString(),label:G.label,uri:b.URI.revive(G.uri),busy:G.busy,tags:G.tags.map(Be=>It.namespace(Me,Be.id)),range:p.$ys.lift($.from(G.range)),description:G.description||null,sortText:G.sortText||null,error:G.error&&T.fromStrict(G.error)||null}}Pe.from=Fe;function $e(G){return{parent:void 0,error:void 0,id:D.$jJ.fromString(G.extId).localId,label:G.label,uri:b.URI.revive(G.uri),tags:(G.tags||[]).map(Me=>{const{tagId:Be}=It.denamespace(Me);return new r.$3L(Be)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:$.to(G.range||void 0),canResolveChildren:!1,busy:G.busy,description:G.description||void 0,sortText:G.sortText||void 0}}Pe.toPlain=$e})(Nt||(e.TestItem=Nt={})),function(Pe){function Fe(G){return{id:G.id}}Pe.from=Fe;function $e(G){return new r.$3L(G.id)}Pe.to=$e}(It||(e.TestTag=It={}));var Qt;(function(Pe){const Fe=(G,Me)=>{const Be=[];for(const[He,it]of Me)D.$jJ.compare(it.item.extId,He)===2&&(Me.delete(He),Be.push(it));const Je={...Nt.toPlain(G.item),parent:void 0,taskStates:G.tasks.map(He=>({state:He.state,duration:He.duration,messages:He.messages.filter(it=>it.type===0).map(Yt.to)})),children:Be.map(He=>Fe(He,Me))};for(const He of Je.children)He.parent=Je;return Je};function $e(G){const Me=[],Be=new Map;for(const Je of G.items){Be.set(Je.item.extId,Je);const He=D.$jJ.root(Je.item.extId);G.request.targets.some(it=>it.controllerId===He&&it.testIds.includes(Je.item.extId))&&Me.push(Je)}return{completedAt:G.completedAt,results:Me.map(Je=>Fe(Je,Be))}}Pe.to=$e})(Qt||(e.TestResults=Qt={}));var zt;(function(Pe){function Fe(Be){return{covered:Be.covered,total:Be.covered}}function $e(Be){return"line"in Be?k.from(Be):$.from(Be)}function G(Be){return"branches"in Be?{count:Be.executionCount,location:$e(Be.location),type:1,branches:Be.branches.length?Be.branches.map(Je=>({count:Je.executionCount,location:Je.location&&$e(Je.location)})):void 0}:{type:0,count:Be.executionCount,location:$e(Be.location)}}Pe.fromDetailed=G;function Me(Be){return{uri:Be.uri,statement:Fe(Be.statementCoverage),branch:Be.branchCoverage&&Fe(Be.branchCoverage),function:Be.functionCoverage&&Fe(Be.functionCoverage),details:Be.detailedCoverage?.map(G)}}Pe.fromFile=Me})(zt||(e.TestCoverage=zt={}));var Kt;(function(Pe){function Fe($e){switch($e){case 1:return r.CodeActionTriggerKind.Invoke;case 2:return r.CodeActionTriggerKind.Automatic}}Pe.to=Fe})(Kt||(e.CodeActionTriggerKind=Kt={}));var Ht;(function(Pe){function Fe(G){const Me=new r.$9L(ge.to(G.kind),G.name,G.detail||"",b.URI.revive(G.uri),$.to(G.range),$.to(G.selectionRange));return Me._sessionId=G._sessionId,Me._itemId=G._itemId,Me}Pe.to=Fe;function $e(G,Me,Be){if(Me=Me??G._sessionId,Be=Be??G._itemId,Me===void 0||Be===void 0)throw new Error("invalid item");return{_sessionId:Me,_itemId:Be,kind:ge.from(G.kind),name:G.name,detail:G.detail??"",uri:G.uri,range:$.from(G.range),selectionRange:$.from(G.selectionRange),tags:G.tags?.map(re.from)}}Pe.from=$e})(Ht||(e.TypeHierarchyItem=Ht={}));var Ct;(function(Pe){function Fe($e){if($e)return{value:$e.value,tooltip:$e.tooltip}}Pe.from=Fe})(Ct||(e.ViewBadge=Ct={}));var ct;(function(Pe){function Fe(Be,Je,He){const it=Je.fileData;return it?new r.$hL(new r.$iL(it.name,b.URI.revive(it.uri),it.id,(0,O.$db)(()=>He(it.id)))):Be===R.$Ur.uriList&&Je.uriListData?new r.$gL(Me(Je.uriListData)):new r.$gL(Je.asString)}Pe.to=Fe;async function $e(Be,Je){const He=await Je.asString();if(Be===R.$Ur.uriList)return{asString:He,fileData:void 0,uriListData:G(He)};const it=Je.asFile();return{asString:He,fileData:it?{name:it.name,uri:it.uri,id:it._itemId??it.id}:void 0}}Pe.from=$e;function G(Be){return I.$8s.split(Be).map(Je=>{if(Je.startsWith("#"))return Je;try{return b.URI.parse(Je)}catch{}return Je})}function Me(Be){return I.$8s.create(Be.map(Je=>typeof Je=="string"?Je:b.URI.revive(Je)))}})(ct||(e.DataTransferItem=ct={}));var ht;(function(Pe){function Fe(G,Me){const Be=G.items.map(([Je,He])=>[Je,ct.to(Je,He,Me)]);return new r.$jL(Be)}Pe.toDataTransfer=Fe;async function $e(G){const Me={items:[]},Be=[];for(const[Je,He]of G)Be.push((async()=>{Me.items.push([Je,await ct.from(Je,He)])})());return await Promise.all(Be),Me}Pe.from=$e})(ht||(e.DataTransfer=ht={}));var Pt;(function(Pe){function Fe(G){return{message:G.message,metadata:G.metadata,title:G.title,tooltip:G.tooltip}}Pe.to=Fe;function $e(G){return{kind:"reply",message:G.message,metadata:G.metadata,title:G.title,tooltip:G.tooltip}}Pe.from=$e})(Pt||(e.ChatReplyFollowup=Pt={}));var Tt;(function(Pe){function Fe($e){return typeof $e=="string"?{title:$e,message:$e,kind:"reply"}:"commandId"in $e?{kind:"command",title:$e.title??"",commandId:$e.commandId??"",when:$e.when??"",args:$e.args}:Pt.from($e)}Pe.from=Fe})(Tt||(e.ChatFollowup=Tt={}));var Ft;(function(Pe){function Fe(G){const Me=new r.$gM(ut.to(G.role),G.content);return Me.name=G.name,Me}Pe.to=Fe;function $e(G){return{role:ut.from(G.role),content:G.content,name:G.name}}Pe.from=$e})(Ft||(e.ChatMessage=Ft={}));var ut;(function(Pe){function Fe(G){switch(G){case 0:return r.ChatMessageRole.System;case 1:return r.ChatMessageRole.User;case 2:return r.ChatMessageRole.Assistant;case 3:return r.ChatMessageRole.Function}}Pe.to=Fe;function $e(G){switch(G){case r.ChatMessageRole.System:return 0;case r.ChatMessageRole.Assistant:return 2;case r.ChatMessageRole.Function:return 3;case r.ChatMessageRole.User:default:return 1}}Pe.from=$e})(ut||(e.ChatMessageRole=ut={}));var Dt;(function(Pe){function Fe(Me){const Be={};for(const Je of Object.keys(Me))Be[Je]=Me[Je].map(Pe.to);return Be}Pe.objectTo=Fe;function $e(Me){return{level:Ut.to(Me.level),value:Me.value,description:Me.description}}Pe.to=$e;function G(Me){return{level:Ut.from(Me.level),value:Me.value,description:Me.description}}Pe.from=G})(Dt||(e.ChatVariable=Dt={}));var Ut;(function(Pe){function Fe(G){switch(G){case"short":return r.ChatVariableLevel.Short;case"medium":return r.ChatVariableLevel.Medium;case"full":default:return r.ChatVariableLevel.Full}}Pe.to=Fe;function $e(G){switch(G){case r.ChatVariableLevel.Short:return"short";case r.ChatVariableLevel.Medium:return"medium";case r.ChatVariableLevel.Full:default:return"full"}}Pe.from=$e})(Ut||(e.ChatVariableLevel=Ut={}));var jt;(function(Pe){function Fe($e){switch($e){case 1:return r.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return r.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return r.InteractiveEditorResponseFeedbackKind.Undone;case 3:return r.InteractiveEditorResponseFeedbackKind.Accepted}}Pe.to=Fe})(jt||(e.InteractiveEditorResponseFeedbackKind=jt={}));var Ve;(function(Pe){function Fe($e,G){return"placeholder"in G&&"resolvedContent"in G?{placeholder:G.placeholder}:"responseId"in G?{requestId:G.responseId}:"markdownContent"in G?((0,s.$mF)($e,"chatAgents2Additions"),{content:T.from(G.markdownContent)}):"content"in G?typeof G.content=="string"?G:((0,s.$mF)($e,"chatAgents2Additions"),{content:T.from(G.content)}):"documents"in G?{documents:G.documents.map(Me=>({uri:Me.uri,version:Me.version,ranges:Me.ranges.map(Be=>$.from(Be))}))}:"reference"in G?{reference:"uri"in G.reference?{uri:G.reference.uri,range:$.from(G.reference.range)}:G.reference}:"inlineReference"in G?{inlineReference:"uri"in G.inlineReference?{uri:G.inlineReference.uri,range:$.from(G.inlineReference.range)}:G.inlineReference,title:G.title}:("agentName"in G&&(0,s.$mF)($e,"chatAgents2Additions"),G)}Pe.from=Fe})(Ve||(e.ChatResponseProgress=Ve={}));var Jt;(function(Pe){function Fe($e,G,Me){return"terminalCommand"in $e?{terminalCommand:$e.terminalCommand}:"uri"in $e?{uri:$e.uri}:G.toInternal($e,Me)}Pe.from=Fe})(Jt||(e.TerminalQuickFix=Jt={}))}),define(Ae[207],Re([1,0,2,11,7,8,174]),function(ee,e,f,C,I,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ycc=void 0;class c{constructor(d,R,S,u={timeout:1500,errors:3}){this.c=d,this.d=R,this.f=S,this.g=u,this.a=new A.$2c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(d){return(R,S,u)=>{const p={dispose:this.a.push([R,S,d])};return Array.isArray(u)&&u.push(p),p}}async $participateInSave(d,R){const S=f.URI.revive(d);let u=!1;const b=setTimeout(()=>u=!0,this.g.timeout),p=[];try{for(const g of[...this.a]){if(u)break;const t=this.d.getDocument(S),i=await this.h(g,{document:t,reason:O.TextDocumentSaveReason.to(R)});p.push(i)}}finally{clearTimeout(b)}return p}h([d,R,S],u){const b=this.b.get(d);return typeof b=="number"&&b>this.g.errors?Promise.resolve(!1):this.i(S,d,R,u).then(()=>!0,p=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${S.identifier.value}' threw ERROR`),this.c.error(p),!(p instanceof Error)||p.message!=="concurrent_edits"){const g=this.b.get(d);this.b.set(d,g?g+1:1),typeof g=="number"&&g>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${S.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(d,R,S,u){const b=[],p=Date.now(),{document:g,reason:t}=u,{version:i}=g,l=Object.freeze({document:g,reason:t,waitUntil(v){if(Object.isFrozen(b))throw(0,C.$8)("waitUntil can not be called async");b.push(Promise.resolve(v))}});try{R.apply(S,[l])}catch(v){return Promise.reject(v)}return Object.freeze(b),new Promise((v,D)=>{const m=setTimeout(()=>D(new Error("timeout")),this.g.timeout);return Promise.all(b).then(n=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${d.identifier.value}' finished after ${Date.now()-p}ms`),clearTimeout(m),v(n)}).catch(n=>{clearTimeout(m),D(n)})}).then(v=>{const D={edits:[]};for(const m of v)if(Array.isArray(m)&&m.every(n=>n instanceof I.$zK))for(const{newText:n,newEol:r,range:s}of m)D.edits.push({resource:g.uri,versionId:void 0,textEdit:{range:s&&O.Range.from(s),text:n,eol:r&&O.EndOfLine.from(r)}});if(D.edits.length!==0)return i===g.version?this.f.$tryApplyWorkspaceEdit(D):Promise.reject(new Error("concurrent_edits"))})}}e.$Ycc=c}),define(Ae[208],Re([1,0,13,2,8,7,75]),function(ee,e,f,C,I,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aec=e.$_dc=void 0;class c{constructor(S,u,b,p){this.start=S,this.deletedCount=u,this.deletedItems=b,this.items=p}asApiEvent(){return{range:new O.$PL(this.start,this.start+this.deletedCount),addedCells:this.items.map(S=>S.apiCell),removedCells:this.deletedItems}}}class E{static asModelAddData(S,u){return{EOL:u.eol,lines:u.source,languageId:u.language,uri:u.uri,isDirty:!1,versionId:1,notebook:S}}constructor(S,u,b){this.notebook=S,this.h=u,this.j=b,this.handle=b.handle,this.uri=C.URI.revive(b.uri),this.cellKind=b.cellKind,this.a=b.outputs.map(I.NotebookCellOutput.to),this.e=b.internalMetadata??{},this.b=Object.freeze(b.metadata??{}),this.d=Object.freeze(I.NotebookCellExecutionSummary.to(b.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const S=this,u=this.h.getDocument(this.uri);if(!u)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const b={get index(){return S.notebook.getCellIndex(S)},notebook:S.notebook.apiNotebook,kind:I.NotebookCellKind.to(this.j.cellKind),document:u.document,get mime(){return S.g},set mime(p){S.g=p},get outputs(){return S.a.slice(0)},get metadata(){return S.b},get executionSummary(){return S.d}};this.f=Object.freeze(b)}return this.f}setOutputs(S){this.a=S.map(I.NotebookCellOutput.to)}setOutputItems(S,u,b){const p=b.map(I.NotebookCellOutputItem.to),g=this.a.find(t=>t.id===S);if(g&&(u||(g.items.length=0),g.items.push(...p),g.items.length>1&&g.items.every(t=>A.$zI(t.mime)))){const t=new Map,i=[];g.items.forEach(l=>{let v;t.has(l.mime)?v=t.get(l.mime):(v=[],t.set(l.mime,v),i.push(l.mime)),v.push(l.data)}),g.items.length=0,i.forEach(l=>{const v=A.$AI(t.get(l));g.items.push({mime:l,data:v.data.buffer})})}}setMetadata(S){this.b=Object.freeze(S)}setInternalMetadata(S){this.e=S,this.d=Object.freeze(I.NotebookCellExecutionSummary.to(S))}setMime(S){}}e.$_dc=E;class d{constructor(S,u,b,p,g){this.k=S,this.l=u,this.m=b,this.uri=p,this.handle=d.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=g.viewType,this.f=Object.freeze(g.metadata??Object.create(null)),this.r([[0,0,g.cells]],!0,void 0),this.g=g.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const S=this,u={get uri(){return S.uri},get version(){return S.g},get notebookType(){return S.d},get isDirty(){return S.h},get isUntitled(){return S.uri.scheme===f.Schemas.untitled},get isClosed(){return S.j},get metadata(){return S.f},get cellCount(){return S.b.length},cellAt(b){return b=S.n(b),S.b[b].apiCell},getCells(b){return(b?S.p(b):S.b).map(g=>g.apiCell)},save(){return S.q()}};this.e=Object.freeze(u)}return this.e}acceptDocumentPropertiesChanged(S){S.metadata&&(this.f=Object.freeze({...this.f,...S.metadata}))}acceptDirty(S){this.h=S}acceptModelChanged(S,u,b){this.g=S.versionId,this.h=u,this.acceptDocumentPropertiesChanged({metadata:b});const p={notebook:this.apiNotebook,metadata:b,cellChanges:[],contentChanges:[]},g=[];for(const i of S.rawEvents)i.kind===A.NotebookCellsChangeType.ModelChange?this.r(i.changes,!1,p.contentChanges):i.kind===A.NotebookCellsChangeType.Move?this.s(i.index,i.length,i.newIdx,p.contentChanges):i.kind===A.NotebookCellsChangeType.Output?(this.t(i.index,i.outputs),g.push({cell:this.b[i.index].apiCell,outputs:this.b[i.index].apiCell.outputs})):i.kind===A.NotebookCellsChangeType.OutputItem?(this.u(i.index,i.outputId,i.append,i.outputItems),g.push({cell:this.b[i.index].apiCell,outputs:this.b[i.index].apiCell.outputs})):i.kind===A.NotebookCellsChangeType.ChangeCellLanguage?(this.v(i.index,i.language),g.push({cell:this.b[i.index].apiCell,document:this.b[i.index].apiCell.document})):i.kind===A.NotebookCellsChangeType.ChangeCellContent?g.push({cell:this.b[i.index].apiCell,document:this.b[i.index].apiCell.document}):i.kind===A.NotebookCellsChangeType.ChangeCellMime?this.w(i.index,i.mime):i.kind===A.NotebookCellsChangeType.ChangeCellMetadata?(this.x(i.index,i.metadata),g.push({cell:this.b[i.index].apiCell,metadata:this.b[i.index].apiCell.metadata})):i.kind===A.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(i.index,i.internalMetadata),g.push({cell:this.b[i.index].apiCell,executionSummary:this.b[i.index].apiCell.executionSummary}));const t=new Map;for(let i=0;i<g.length;i++){const l=g[i],v=t.get(l.cell);if(v===void 0){const D=p.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...l});t.set(l.cell,D-1)}else p.cellChanges[v]={...p.cellChanges[v],...l}}return Object.freeze(p),Object.freeze(p.cellChanges),Object.freeze(p.contentChanges),p}n(S){return S=S|0,S<0?0:S>=this.b.length?this.b.length-1:S}o(S){let u=S.start|0,b=S.end|0;return u<0&&(u=0),b>this.b.length&&(b=this.b.length),S.with({start:u,end:b})}p(S){S=this.o(S);const u=[];for(let b=S.start;b<S.end;b++)u.push(this.b[b]);return u}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(S,u,b){if(this.j)return;const p=[],g=[],t=[];if(S.reverse().forEach(i=>{const v=i[2].map(n=>{const r=new E(this,this.l,n);return u||g.push(E.asModelAddData(this.apiNotebook,n)),r}),D=new c(i[0],i[1],[],v),m=this.b.splice(i[0],i[1],...v);for(const n of m)t.push(n.uri),D.deletedItems.push(n.apiCell);p.push(D)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:g,removedDocuments:t}),b)for(const i of p)b.push(i.asApiEvent())}s(S,u,b,p){const g=this.b.splice(S,u);this.b.splice(b,0,...g);const t=[new c(S,u,g.map(i=>i.apiCell),[]),new c(b,0,[],g)];for(const i of t)p.push(i.asApiEvent())}t(S,u){this.b[S].setOutputs(u)}u(S,u,b,p){this.b[S].setOutputItems(u,b,p)}v(S,u){const b=this.b[S];b.apiCell.document.languageId!==u&&this.m.$acceptModelLanguageChanged(b.uri,u)}w(S,u){const b=this.b[S];b.apiCell.mime=u}x(S,u){this.b[S].setMetadata(u)}y(S,u){this.b[S].setInternalMetadata(u)}getCellFromApiCell(S){return this.b.find(u=>u.apiCell===S)}getCellFromIndex(S){return this.b[S]}getCell(S){return this.b.find(u=>u.handle===S)}getCellIndex(S){return this.b.indexOf(S)}}e.$aec=d,d.a=0}),define(Ae[209],Re([1,0,5,2,8,7]),function(ee,e,f,C,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aec=void 0;class A{constructor(E,d,R,S={timeout:1500,errors:3}){this.b=E,this.c=d,this.d=R,this.f=S,this.a=new f.$Qd}dispose(){}getOnWillSaveNotebookDocumentEvent(E){return(d,R,S)=>{const u=function(p){d.call(R,p)};return u.extension=E,this.a.event(u,void 0,S)}}async $participateInSave(E,d,R){const S=C.URI.revive(E),u=this.c.getNotebookDocument(S);if(!u)throw new Error("Unable to resolve notebook document");const b=[];if(await this.a.fireAsync({notebook:u.apiNotebook,reason:I.TextDocumentSaveReason.to(d)},R,async(g,t)=>{const i=Date.now(),l=await await Promise.resolve(g);Date.now()-i>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",t.extension.identifier),!R.isCancellationRequested&&l&&(l instanceof O.$CK?b.push(l):this.b.warn("onWillSaveNotebookDocument-listener from extension",t.extension.identifier,"ignored due to invalid data"))}),R.isCancellationRequested)return!1;if(b.length===0)return!0;const p={edits:[]};for(const g of b){const{edits:t}=I.WorkspaceEdit.from(g);p.edits=p.edits.concat(t)}return this.d.$tryApplyWorkspaceEdit(p)}}e.$Aec=A}),define(Ae[104],Re([1,0,11,8,7]),function(ee,e,f,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bec=void 0;class O{constructor(c,E,d,R,S,u){this.id=c,this.f=E,this.notebookData=d,this.a=[],this.b=[],this.d=!1,this.a=S,this.b=R,this.c=u}get apiEditor(){if(!this.e){const c=this;this.e={get notebook(){return c.notebookData.apiNotebook},get selection(){return c.a[0]},set selection(E){this.selections=[E]},get selections(){return c.a},set selections(E){if(!Array.isArray(E)||!E.every(I.$PL.isNotebookRange))throw(0,f.$7)("selections");c.a=E,c.g(E)},get visibleRanges(){return c.b},revealRange(E,d){c.f.$tryRevealRange(c.id,C.NotebookRange.from(E),d??I.NotebookEditorRevealType.Default)},get viewColumn(){return c.c}},O.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(c){this.d=c}_acceptVisibleRanges(c){this.b=c}_acceptSelections(c){this.a=c}g(c){this.f.$trySetSelections(this.id,c.map(C.NotebookRange.from))}_acceptViewColumn(c){this.c=c}}e.$bec=O,O.apiEditorsToExtHost=new WeakMap}),define(Ae[210],Re([1,0,11,5,14,8]),function(ee,e,f,C,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tec=void 0;let A=class{constructor(E,d){this.c=E,this.d=d,this.a=new C.$Od({onListenerError:f.$2}),this.b=new C.$Od({onListenerError:f.$2}),this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(E,d){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",E,d);const R=this.d.getEditorById(E);d.visibleRanges&&R._acceptVisibleRanges(d.visibleRanges.ranges.map(O.NotebookRange.to)),d.selections&&R._acceptSelections(d.selections.selections.map(O.NotebookRange.to)),d.visibleRanges&&this.b.fire({notebookEditor:R.apiEditor,visibleRanges:R.apiEditor.visibleRanges}),d.selections&&this.a.fire(Object.freeze({notebookEditor:R.apiEditor,selections:R.apiEditor.selections}))}$acceptEditorViewColumns(E){for(const d in E)this.d.getEditorById(d)._acceptViewColumn(O.ViewColumn.to(E[d]))}};e.$tec=A,e.$tec=A=Ge([qe(0,I.$$i)],A)}),define(Ae[211],Re([1,0,8,52,153,19,65,11]),function(ee,e,f,C,I,O,A,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xdc=void 0;class E{constructor(u){this.b=0,this.c=new Map,this.a=u}async withProgress(u,b,p){const g=this.b++,{title:t,location:i,cancellable:l}=b,v={label:(0,I.localize)(0,null,u.displayName||u.name),id:u.identifier.value};return this.a.$startProgress(g,{location:f.ProgressLocation.from(i),title:t,source:v,cancellable:l},u.isUnderDevelopment?void 0:u.identifier.value).catch(c.$2),this.d(g,p,!!l)}d(u,b,p){let g;p&&(g=new O.$Yd,this.c.set(u,g));const t=l=>{this.a.$progressEnd(l),this.c.delete(l),g?.dispose()};let i;try{i=b(new R(this.a,u),p&&g?g.token:O.CancellationToken.None)}catch(l){throw t(u),l}return i.then(l=>t(u),l=>t(u)),i}$acceptProgressCanceled(u){const b=this.c.get(u);b&&(b.cancel(),this.c.delete(u))}}e.$xdc=E;function d(S,u){return S.message=u.message,typeof u.increment=="number"&&(typeof S.increment=="number"?S.increment+=u.increment:S.increment=u.increment),S}class R extends C.$0u{constructor(u,b){super(p=>this.throttledReport(p)),this.c=u,this.d=b}throttledReport(u){this.c.$progressReport(this.d,u)}}Ge([(0,A.$kh)(100,(S,u)=>d(S,u),()=>Object.create(null))],R.prototype,"throttledReport",null)}),define(Ae[105],Re([1,0,41,101,46,76,58,8,2]),function(ee,e,f,C,I,O,A,c,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GM=e.$FM=e.$EM=e.$DM=void 0;const d=(v,D,m,n)=>{let r=D;return{enumerable:!0,configurable:!1,get(){return r},set(s){if(!m(r,s)){const o=r;r=s,v.listener?.(n(s,o))}}}},R=(v,D)=>v===D,S={range:(v,D)=>v===D?!0:!v||!D?!1:v.isEqual(D),label:R,description:R,sortText:R,busy:R,error:R,canResolveChildren:R,tags:(v,D)=>!(v.length!==D.length||v.some(m=>!D.find(n=>m.id===n.id)))},u=v=>D=>({op:4,update:v(D)}),b=(v,D)=>({range:(()=>{let m;const n=u(r=>({range:f.$ys.lift(c.Range.from(r))}));return{enumerable:!0,configurable:!1,get(){return m},set(r){v.listener?.({op:6}),S.range(m,r)||(m=r,v.listener?.(n(r)))}}})(),label:d(v,D,S.label,u(m=>({label:m}))),description:d(v,void 0,S.description,u(m=>({description:m}))),sortText:d(v,void 0,S.sortText,u(m=>({sortText:m}))),canResolveChildren:d(v,!1,S.canResolveChildren,m=>({op:2,state:m})),busy:d(v,!1,S.busy,u(m=>({busy:m}))),error:d(v,void 0,S.error,u(m=>({error:c.MarkdownString.fromStrict(m)||null}))),tags:d(v,[],S.tags,(m,n)=>({op:1,new:m.map(c.TestTag.from),old:n.map(c.TestTag.from)}))}),p=v=>{const D=I.$jJ.fromString(v.extId),m=new t(D.controllerId,D.localId,v.label,E.URI.revive(v.uri)||void 0);return m.range=c.Range.to(v.range||void 0),m.description=v.description||void 0,m.sortText=v.sortText||void 0,m.tags=v.tags.map(n=>c.TestTag.to({id:(0,A.$oJ)(n).tagId})),m},g=v=>{let D;for(const m of v.tests){const n=p(m.item);(0,C.$nM)(n).parent=D,D=n}return D};e.$DM=g;class t{constructor(D,m,n,r){if(m.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(m)} symbol`);const s=(0,C.$mM)(this,D);Object.defineProperties(this,{id:{value:m,enumerable:!0,writable:!1},uri:{value:r,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return s.parent instanceof i?void 0:s.parent}},children:{value:(0,O.$lM)(s,C.$nM,t),enumerable:!0,writable:!1},...b(s,n)})}}e.$EM=t;class i extends t{constructor(D,m){super(D,D,m,void 0),this._isRoot=!0}}e.$FM=i;class l extends O.$hM{constructor(D,m,n){super({controllerId:D,getDocumentVersion:r=>r&&n.getDocument(r)?.version,getApiFor:C.$nM,getChildren:r=>r.children,root:new i(D,m),toITestItem:c.TestItem.from})}}e.$GM=l}),define(Ae[106],Re([1,0,53,11,88,8,7]),function(ee,e,f,C,I,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AM=e.$zM=e.$yM=void 0;class c{constructor(u,b,p){const g=c.c.nextId();u.$registerTextEditorDecorationType(b.identifier,g,O.DecorationRenderOptions.from(p)),this.value=Object.freeze({key:g,dispose(){u.$removeTextEditorDecorationType(g)}})}}e.$yM=c,c.c=new I.$wM("TextEditorDecorationType");class E{constructor(u,b){this.g=[],this.h=void 0,this.j=!1,this.c=u,this.d=u.version,this.e=b.undoStopBefore,this.f=b.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(u,b){this.k();let p=null;if(u instanceof A.$tK)p=new A.$uK(u,u);else if(u instanceof A.$uK)p=u;else throw new Error("Unrecognized location");this.l(p,b,!1)}insert(u,b){this.k(),this.l(new A.$uK(u,u),b,!0)}delete(u){this.k();let b=null;if(u instanceof A.$uK)b=u;else throw new Error("Unrecognized location");this.l(b,null,!0)}l(u,b,p){const g=this.c.validateRange(u);this.g.push({range:g,text:b,forceMoveMarkers:p})}setEndOfLine(u){if(this.k(),u!==A.EndOfLine.LF&&u!==A.EndOfLine.CRLF)throw(0,C.$7)("endOfLine");this.h=u}}class d{constructor(u,b,p,g){this.c=u,this.d=b,this._accept(p),this.e=g;const t=this;this.value={get tabSize(){return t.f},set tabSize(i){t.m(i)},get indentSize(){return t.g},set indentSize(i){t.o(i)},get insertSpaces(){return t.h},set insertSpaces(i){t.q(i)},get cursorStyle(){return t.j},set cursorStyle(i){t.s(i)},get lineNumbers(){return t.k},set lineNumbers(i){t.t(i)}}}_accept(u){this.f=u.tabSize,this.g=u.indentSize,this.h=u.insertSpaces,this.j=u.cursorStyle,this.k=O.TextEditorLineNumbersStyle.to(u.lineNumbers)}l(u){if(u==="auto")return"auto";if(typeof u=="number"){const b=Math.floor(u);return b>0?b:null}if(typeof u=="string"){const b=parseInt(u,10);return isNaN(b)?null:b>0?b:null}return null}m(u){const b=this.l(u);if(b!==null){if(typeof b=="number"){if(this.f===b)return;this.f=b}this.u("setTabSize",this.c.$trySetOptions(this.d,{tabSize:b}))}}n(u){if(u==="tabSize")return"tabSize";if(typeof u=="number"){const b=Math.floor(u);return b>0?b:null}if(typeof u=="string"){const b=parseInt(u,10);return isNaN(b)?null:b>0?b:null}return null}o(u){const b=this.n(u);if(b!==null){if(typeof b=="number"){if(this.g===b)return;this.g=b}this.u("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:b}))}}p(u){return u==="auto"?"auto":u==="false"?!1:!!u}q(u){const b=this.p(u);if(typeof b=="boolean"){if(this.h===b)return;this.h=b}this.u("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:b}))}s(u){this.j!==u&&(this.j=u,this.u("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:u})))}t(u){this.k!==u&&(this.k=u,this.u("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:O.TextEditorLineNumbersStyle.from(u)})))}assign(u){const b={};let p=!1;if(typeof u.tabSize<"u"){const g=this.l(u.tabSize);g==="auto"?(p=!0,b.tabSize=g):typeof g=="number"&&this.f!==g&&(this.f=g,p=!0,b.tabSize=g)}if(typeof u.indentSize<"u"){const g=this.n(u.indentSize);g==="tabSize"?(p=!0,b.indentSize=g):typeof g=="number"&&this.g!==g&&(this.g=g,p=!0,b.indentSize=g)}if(typeof u.insertSpaces<"u"){const g=this.p(u.insertSpaces);g==="auto"?(p=!0,b.insertSpaces=g):this.h!==g&&(this.h=g,p=!0,b.insertSpaces=g)}typeof u.cursorStyle<"u"&&this.j!==u.cursorStyle&&(this.j=u.cursorStyle,p=!0,b.cursorStyle=u.cursorStyle),typeof u.lineNumbers<"u"&&this.k!==u.lineNumbers&&(this.k=u.lineNumbers,p=!0,b.lineNumbers=O.TextEditorLineNumbersStyle.from(u.lineNumbers)),p&&this.u("setOptions",this.c.$trySetOptions(this.d,b))}u(u,b){b.catch(p=>{this.e.warn(`ExtHostTextEditorOptions '${u}' failed:'`),this.e.warn(p)})}}e.$zM=d;class R{constructor(u,b,p,g,t,i,l,v){this.id=u,this.j=b,this.k=p,this.g=!1,this.h=new Set,this.c=t,this.d=new d(this.j,this.id,i,p),this.e=l,this.f=v;const D=this;this.value=Object.freeze({get document(){return g.value},set document(m){throw new C.$9("document")},get selection(){return D.c&&D.c[0]},set selection(m){if(!(m instanceof A.$vK))throw(0,C.$7)("selection");D.c=[m],D.l()},get selections(){return D.c},set selections(m){if(!Array.isArray(m)||m.some(n=>!(n instanceof A.$vK)))throw(0,C.$7)("selections");D.c=m,D.l()},get visibleRanges(){return D.e},set visibleRanges(m){throw new C.$9("visibleRanges")},get options(){return D.d.value},set options(m){D.g||D.d.assign(m)},get viewColumn(){return D.f},set viewColumn(m){throw new C.$9("viewColumn")},edit(m,n={undoStopBefore:!0,undoStopAfter:!0}){if(D.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const r=new E(g.value,n);return m(r),D.m(r)},insertSnippet(m,n,r={undoStopBefore:!0,undoStopAfter:!0}){if(D.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let s;if(!n||Array.isArray(n)&&n.length===0)s=D.c.map(o=>O.Range.from(o));else if(n instanceof A.$tK){const{lineNumber:o,column:$}=O.Position.from(n);s=[{startLineNumber:o,startColumn:$,endLineNumber:o,endColumn:$}]}else if(n instanceof A.$uK)s=[O.Range.from(n)];else{s=[];for(const o of n)if(o instanceof A.$uK)s.push(O.Range.from(o));else{const{lineNumber:$,column:a}=O.Position.from(o);s.push({startLineNumber:$,startColumn:a,endLineNumber:$,endColumn:a})}}return b.$tryInsertSnippet(u,g.value.version,m.value,s,r)},setDecorations(m,n){const r=n.length===0;r&&!D.h.has(m.key)||(r?D.h.delete(m.key):D.h.add(m.key),D.n(()=>{if(O.$oM(n))return b.$trySetDecorations(u,m.key,O.$pM(n));{const s=new Array(4*n.length);for(let o=0,$=n.length;o<$;o++){const a=n[o];s[4*o]=a.start.line+1,s[4*o+1]=a.start.character+1,s[4*o+2]=a.end.line+1,s[4*o+3]=a.end.character+1}return b.$trySetDecorationsFast(u,m.key,s)}}))},revealRange(m,n){D.n(()=>b.$tryRevealRange(u,O.Range.from(m),n||A.TextEditorRevealType.Default))},show(m){b.$tryShowEditor(u,O.ViewColumn.from(m))},hide(){b.$tryHideEditor(u)}})}dispose(){(0,f.ok)(!this.g),this.g=!0}_acceptOptions(u){(0,f.ok)(!this.g),this.d._accept(u)}_acceptVisibleRanges(u){(0,f.ok)(!this.g),this.e=u}_acceptViewColumn(u){(0,f.ok)(!this.g),this.f=u}_acceptSelections(u){(0,f.ok)(!this.g),this.c=u}async l(){const u=this.c.map(O.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,u)),this.value}m(u){const b=u.finalize();if(b.edits.length===0&&!b.setEndOfLine)return Promise.resolve(!0);const p=b.edits.map(t=>t.range);p.sort((t,i)=>t.end.line===i.end.line?t.end.character===i.end.character?t.start.line===i.start.line?t.start.character-i.start.character:t.start.line-i.start.line:t.end.character-i.end.character:t.end.line-i.end.line);for(let t=0,i=p.length-1;t<i;t++){const l=p[t].end;if(p[t+1].start.isBefore(l))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const g=b.edits.map(t=>({range:O.Range.from(t.range),text:t.text,forceMoveMarkers:t.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,b.documentVersionId,g,{setEndOfLine:typeof b.setEndOfLine=="number"?O.EndOfLine.from(b.setEndOfLine):void 0,undoStopBefore:b.undoStopBefore,undoStopAfter:b.undoStopAfter})}n(u){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):u().then(()=>this,b=>(b instanceof Error&&b.name==="DISPOSED"||this.k.warn(b),null))}}e.$AM=R}),define(Ae[212],Re([1,0,157,24,2,5,6,193,12,7,15,18,8,51,19,128,22]),function(ee,e,f,C,I,O,A,c,E,d,R,S,u,b,p,g,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Edc=void 0;function i(D,m){if((0,R.$zf)(D))return{label:D};if(D&&typeof D=="object"&&typeof D.label=="string"){let n;return Array.isArray(D.highlights)&&(n=D.highlights.filter(r=>r.length===2&&typeof r[0]=="number"&&typeof r[1]=="number"),n=n.length?n:void 0),{label:D.label,highlights:n}}}class l extends A.$Sc{constructor(m,n,r){super(),this.f=m,this.g=n,this.h=r,this.a=new Map,this.b=new g.$57;function s(o){return o&&o.$treeViewId&&(o.$treeItemHandle||o.$selectedTreeItems||o.$focusedTreeItem)}n.registerArgumentProcessor({processArgument:o=>s(o)?this.r(o):Array.isArray(o)&&o.length>0?o.map($=>s($)?this.r($):$):o})}registerTreeDataProvider(m,n,r){const s=this.createTreeView(m,{treeDataProvider:n},r);return{dispose:()=>s.dispose()}}createTreeView(m,n,r){if(!n||!n.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const s=n.dragAndDropController?.dropMimeTypes??[],o=n.dragAndDropController?.dragMimeTypes??[],$=!!n.dragAndDropController?.handleDrag,a=!!n.dragAndDropController?.handleDrop,k=this.m(m,n,r),P={showCollapseAll:!!n.showCollapseAll,canSelectMany:!!n.canSelectMany,dropMimeTypes:s,dragMimeTypes:o,hasHandleDrag:$,hasHandleDrop:a,manuallyManageCheckboxes:!!n.manageCheckboxStateManually},h=this.f.$registerTreeViewDataProvider(m,P),w={get onDidCollapseElement(){return k.onDidCollapseElement},get onDidExpandElement(){return k.onDidExpandElement},get selection(){return k.selectedElements},get onDidChangeSelection(){return k.onDidChangeSelection},get activeItem(){return(0,t.$mF)(r,"treeViewActiveItem"),k.focusedElement},get onDidChangeActiveItem(){return(0,t.$mF)(r,"treeViewActiveItem"),k.onDidChangeActiveItem},get visible(){return k.visible},get onDidChangeVisibility(){return k.onDidChangeVisibility},get onDidChangeCheckboxState(){return k.onDidChangeCheckboxState},get message(){return k.message},set message(y){(0,b.$6j)(y)&&(0,t.$mF)(r,"treeViewMarkdownMessage"),k.message=y},get title(){return k.title},set title(y){k.title=y},get description(){return k.description},set description(y){k.description=y},get badge(){return k.badge},set badge(y){y!==void 0&&d.ViewBadge.isViewBadge(y)?k.badge={value:Math.floor(Math.abs(y.value)),tooltip:y.tooltip}:y===void 0&&(k.badge=void 0)},reveal:(y,M)=>k.reveal(y,M),dispose:async()=>{await h,this.a.delete(m),k.dispose()}};return this.B(w),w}$getChildren(m,n){const r=this.a.get(m);return r?r.getChildren(n):Promise.reject(new c.$xE(m))}async $handleDrop(m,n,r,s,o,$,a,k){const P=this.a.get(m);if(!P)return Promise.reject(new c.$xE(m));const h=u.DataTransfer.toDataTransfer(r,async w=>(await this.f.$resolveDropFileData(m,n,w)).buffer);return a===m&&k&&await this.j(h,P,k,o,$),P.onDrop(h,s,o)}async j(m,n,r,s,o){const $=this.b.removeDragOperationTransfer(o);if($)(await $)?.forEach((a,k)=>{a&&m.set(k,a)});else if(o&&n.handleDrag){const a=n.handleDrag(r,m,s);this.b.addDragOperationTransfer(o,a),await a}return m}async $handleDrag(m,n,r,s){const o=this.a.get(m);if(!o)return Promise.reject(new c.$xE(m));const $=await this.j(new d.$jL,o,n,s,r);if(!(!$||s.isCancellationRequested))return u.DataTransfer.from($)}async $hasResolve(m){const n=this.a.get(m);if(!n)throw new c.$xE(m);return n.hasResolve}$resolve(m,n,r){const s=this.a.get(m);if(!s)throw new c.$xE(m);return s.resolveTreeItem(n,r)}$setExpanded(m,n,r){const s=this.a.get(m);if(!s)throw new c.$xE(m);s.setExpanded(n,r)}$setSelectionAndFocus(m,n,r){const s=this.a.get(m);if(!s)throw new c.$xE(m);s.setSelectionAndFocus(n,r)}$setVisible(m,n){const r=this.a.get(m);if(!r){if(!n)return;throw new c.$xE(m)}r.setVisible(n)}$changeCheckboxState(m,n){const r=this.a.get(m);if(!r)throw new c.$xE(m);r.setCheckboxState(n)}m(m,n,r){const s=this.B(new v(m,n,this.f,this.g.converter,this.h,r));return this.a.set(m,s),s}r(m){const n=this.a.get(m.$treeViewId);return n&&"$treeItemHandle"in m?n.getExtensionElement(m.$treeItemHandle):n&&"$focusedTreeItem"in m&&m.$focusedTreeItem?n.focusedElement:null}}e.$Edc=l;class v extends A.$Sc{get visible(){return this.r}get selectedElements(){return this.s.map(m=>this.getExtensionElement(m)).filter(m=>!(0,R.$If)(m))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(m,n,r,s,o,$){if(super(),this.I=m,this.J=r,this.L=s,this.M=o,this.N=$,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new O.$Od),this.onDidExpandElement=this.u.event,this.w=this.B(new O.$Od),this.onDidCollapseElement=this.w.event,this.y=this.B(new O.$Od),this.onDidChangeSelection=this.y.event,this.z=this.B(new O.$Od),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new O.$Od),this.onDidChangeVisibility=this.C.event,this.D=this.B(new O.$Od),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new O.$Od),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new p.$Yd,$.contributes&&$.contributes.views)for(const h in $.contributes.views)for(const w of $.contributes.views[h])w.id===m&&(this.P=w.name);this.f=n.treeDataProvider,this.g=n.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(h=>this.F.fire({message:!1,element:h})));let a,k;const P=O.Event.debounce(this.F.event,(h,w)=>(h||(h={message:!1,elements:[]}),w.element!==!1&&(a||(a=new Promise(y=>k=y),this.G=this.G.then(()=>a)),Array.isArray(w.element)?h.elements.push(...w.element):h.elements.push(w.element)),w.message&&(h.message=!0),h),200,!0);this.B(P(({message:h,elements:w})=>{w.length&&(this.H=this.H.then(()=>{const y=k;return a=null,this.$(w).then(()=>y())})),h&&this.J.$setMessage(this.I,u.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(m){const n=m?this.getExtensionElement(m):void 0;if(m&&!n)return this.M.error(`No tree item with id '${m}' found.`),Promise.resolve([]);let r=this.X(m);return r||(r=await this.Y(n)),r?r.map(s=>s.item):void 0}getExtensionElement(m){return this.j.get(m)}reveal(m,n){n=n||{select:!0,focus:!1};const r=(0,R.$If)(n.select)?!0:n.select,s=(0,R.$If)(n.focus)?!1:n.focus,o=(0,R.$If)(n.expand)?!1:n.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):m?this.G.then(()=>this.S(m)).then($=>this.W(m,$[$.length-1]).then(a=>this.J.$reveal(this.I,{item:a.item,parentChain:$.map(k=>k.item)},{select:r,focus:s,expand:o})),$=>this.M.error($)):this.J.$reveal(this.I,void 0,{select:r,focus:s,expand:o})}get message(){return this.O}set message(m){this.O=m,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(m){this.P=m,this.J.$setTitle(this.I,m,this.Q)}get description(){return this.Q}set description(m){this.Q=m,this.J.$setTitle(this.I,this.P,m)}get badge(){return this.R}set badge(m){this.R?.value===m?.value&&this.R?.tooltip===m?.tooltip||(this.R=u.ViewBadge.from(m),this.J.$setBadge(this.I,m))}setExpanded(m,n){const r=this.getExtensionElement(m);r&&(n?this.u.fire(Object.freeze({element:r})):this.w.fire(Object.freeze({element:r})))}setSelectionAndFocus(m,n){const r=!(0,S.$ub)(this.s,m);this.s=m;const s=this.t!==n;this.t=n,r&&this.y.fire(Object.freeze({selection:this.selectedElements})),s&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(m){m!==this.r&&(this.r=m,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(m){const n=(await Promise.all(m.map(async r=>{const s=this.getExtensionElement(r.treeItemHandle);return s?{extensionItem:s,treeItem:await this.f.getTreeItem(s),newState:r.newState?d.TreeItemCheckboxState.Checked:d.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(r=>r!==void 0);n.forEach(r=>{r.treeItem.checkboxState=r.newState?d.TreeItemCheckboxState.Checked:d.TreeItemCheckboxState.Unchecked}),this.D.fire({items:n.map(r=>[r.extensionItem,r.newState])})}async handleDrag(m,n,r){const s=[];for(const o of m){const $=this.getExtensionElement(o);$&&s.push($)}if(!(!this.g?.handleDrag||s.length===0))return await this.g.handleDrag(s,n,r),n}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(m,n,r){const s=n?this.getExtensionElement(n):void 0;if(!(!s&&n||!this.g?.handleDrop))return(0,E.$Ng)(()=>this.g?.handleDrop?this.g.handleDrop(s,m,r):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(m,n){if(!this.f.resolveTreeItem)return;const r=this.j.get(m);if(r){const s=this.m.get(r);if(s){const o=await this.f.resolveTreeItem(s.extensionItem,r,n)??s.extensionItem;return this.hb(o),s.item.tooltip=this.eb(o.tooltip),s.item.command=this.fb(s.disposableStore,o.command),s.item}}}S(m){return this.U(m).then(n=>n?this.S(n).then(r=>this.W(n,r[r.length-1]).then(s=>(r.push(s),r))):Promise.resolve([]))}U(m){const n=this.m.get(m);return n?Promise.resolve(n.parent?this.j.get(n.parent.item.handle):void 0):(0,E.$Ng)(()=>this.f.getParent(m))}W(m,n){const r=this.m.get(m);return r?Promise.resolve(r):(0,E.$Ng)(()=>this.f.getTreeItem(m)).then(s=>this.kb(m,s,n,!0)).then(s=>this.getChildren(n?n.item.handle:void 0).then(()=>{const o=this.getExtensionElement(s);if(o){const $=this.m.get(o);if($)return Promise.resolve($)}throw new Error(`Cannot resolve tree item for element ${s} from extension ${this.N.identifier.value}`)}))}X(m){if(m){let n;if(typeof m=="string"){const r=this.getExtensionElement(m);n=r?this.m.get(r):void 0}else n=m;return n&&n.children||void 0}return this.h}async Y(m){this.rb(m);const n=new p.$Yd(this.Z.token);try{const r=m?this.m.get(m):void 0,s=await this.f.getChildren(m);if(n.token.isCancellationRequested)return;const o=await Promise.all((0,S.$Hb)(s||[]).map(async $=>{const a=await this.f.getTreeItem($);return a&&!n.token.isCancellationRequested?this.db($,a,r):null}));return n.token.isCancellationRequested?void 0:(0,S.$Hb)(o)}finally{n.dispose()}}$(m){if(m.some(r=>!r))return this.Z.dispose(!0),this.Z=new p.$Yd,this.tb(),this.J.$refresh(this.I);{const r=this.ab(m);if(r.length)return this.bb(r)}return Promise.resolve(void 0)}ab(m){const n=new Set,r=m.map(o=>this.m.get(o));for(const o of r)if(o&&!n.has(o.item.handle)){let $=o;for(;$&&$.parent&&r.findIndex(a=>$&&$.parent&&a&&a.item.handle===$.parent.item.handle)===-1;){const a=this.j.get($.parent.item.handle);$=a?this.m.get(a):void 0}$&&!$.parent&&n.add(o.item.handle)}const s=[];return n.forEach(o=>{const $=this.j.get(o);if($){const a=this.m.get($);a&&(!a.parent||!n.has(a.parent.item.handle))&&s.push(o)}}),s}bb(m){const n={};return Promise.all(m.map(r=>this.cb(r).then(s=>{s&&(n[r]=s.item)}))).then(()=>Object.keys(n).length?this.J.$refresh(this.I,n):void 0)}cb(m){const n=this.getExtensionElement(m);if(n){const r=this.m.get(n);if(r)return this.rb(n),(0,E.$Ng)(()=>this.f.getTreeItem(n)).then(s=>{if(s){const o=this.ib(n,s,r.parent);return this.pb(n,o,r,r.parent),r.dispose(),o}return null})}return Promise.resolve(null)}db(m,n,r){const s=this.ib(m,n,r);if(n.id&&this.j.has(s.item.handle))throw new Error((0,f.localize)(0,null,n.id));return this.ob(m,s),this.qb(s,r),s}eb(m){return d.$SK.isMarkdownString(m)?u.MarkdownString.from(m):m}fb(m,n){return n?{...this.L.toInternal(n,m),originalId:n.command}:void 0}gb(m){if(m.checkboxState===void 0)return;let n,r,s;return typeof m.checkboxState=="number"?n=m.checkboxState:(n=m.checkboxState.state,r=m.checkboxState.tooltip,s=m.checkboxState.accessibilityInformation),{isChecked:n===d.TreeItemCheckboxState.Checked,tooltip:r,accessibilityInformation:s}}hb(m){if(!d.$eL.isTreeItem(m,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(m,n,r){this.hb(n);const s=this.B(new A.$Rc),o=this.kb(m,n,r),$=this.lb(n);return{item:{handle:o,parentHandle:r?r.item.handle:void 0,label:i(n.label,this.N),description:n.description,resourceUri:n.resourceUri,tooltip:this.eb(n.tooltip),command:this.fb(s,n.command),contextValue:n.contextValue,icon:$,iconDark:this.mb(n)||$,themeIcon:this.jb(n),collapsibleState:(0,R.$If)(n.collapsibleState)?d.TreeItemCollapsibleState.None:n.collapsibleState,accessibilityInformation:n.accessibilityInformation,checkbox:this.gb(n)},extensionItem:n,parent:r,children:void 0,disposableStore:s,dispose(){s.dispose()}}}jb(m){return m.iconPath instanceof d.$mL?m.iconPath:void 0}kb(m,{id:n,label:r,resourceUri:s},o,$){if(n)return`${v.b}/${n}`;const a=i(r,this.N),k=o?o.item.handle:v.a;let P=a?a.label:s?(0,C.$tg)(s):"";P=P.indexOf("/")!==-1?P.replace("/","//"):P;const h=this.m.has(m)?this.m.get(m).item.handle:void 0,w=this.X(o)||[];let y,M=0;do{if(y=`${k}/${M}:${P}`,$||!this.j.has(y)||h===y)break;M++}while(M<=w.length);return y}lb(m){if(m.iconPath&&!(m.iconPath instanceof d.$mL))return typeof m.iconPath=="string"||I.URI.isUri(m.iconPath)?this.nb(m.iconPath):this.nb(m.iconPath.light)}mb(m){if(m.iconPath&&!(m.iconPath instanceof d.$mL)&&m.iconPath.dark)return this.nb(m.iconPath.dark)}nb(m){return I.URI.isUri(m)?m:I.URI.file(m)}ob(m,n){this.j.set(n.item.handle,m),this.m.set(m,n)}pb(m,n,r,s){this.j.delete(n.item.handle),this.m.delete(m),n.item.handle!==r.item.handle&&this.j.delete(r.item.handle),this.ob(m,n);const o=this.X(s)||[],$=o.filter(a=>a.item.handle===r.item.handle)[0];$&&o.splice(o.indexOf($),1,n)}qb(m,n){n?(n.children||(n.children=[]),n.children.push(m)):(this.h||(this.h=[]),this.h.push(m))}rb(m){if(m){const n=this.m.get(m);if(n){if(n.children)for(const r of n.children){const s=this.j.get(r.item.handle);s&&this.sb(s)}n.children=void 0}}else this.tb()}sb(m){const n=this.m.get(m);if(n){if(n.children)for(const r of n.children){const s=this.j.get(r.item.handle);s&&this.sb(s)}this.m.delete(m),this.j.delete(n.item.handle),n.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(m=>m.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}v.a="0",v.b="1"}),define(Ae[213],Re([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chat:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chat.d.ts",chatAgents:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents.d.ts",chatAgents2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents2.d.ts",chatAgents2Additions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents2Additions.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatRequestAccess:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatRequestAccess.d.ts",chatVariables:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariables.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",defaultChatAgent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatAgent.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",dropMetadata:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dropMetadata.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",handleIssueUri:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.handleIssueUri.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveUserActions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveUserActions.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",readonlyMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.readonlyMessage.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",saveEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.saveEditor.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmInputBoxActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmInputBoxActionButton.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Ae[214],Re([1,0,167,11,29,92,72,30,21,213,177,98]),function(ee,e,f,C,I,O,A,c,E,d,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fF=e.$eF=e.$dF=e.$cF=e.$bF=e.$aF=void 0;const u=c.$ln.as(A.$mn.JSONContribution);class b{constructor(m,n,r){this.a=m,this.b=n,this.c=r}d(m,n){this.a({type:m,message:n,extensionId:this.b.identifier,extensionPointId:this.c})}error(m){this.d(I.default.Error,m)}warn(m){this.d(I.default.Warning,m)}info(m){this.d(I.default.Info,m)}}e.$aF=b;class p{static a(m){const n=new E.$9l;for(let r=0,s=m.length;r<s;r++)n.add(m[r].description.identifier);return n}static compute(m,n){if(!m||!m.length)return new p(n,[]);if(!n||!n.length)return new p([],m);const r=this.a(m),s=this.a(n),o=n.filter(a=>!r.has(a.description.identifier)),$=m.filter(a=>!s.has(a.description.identifier));return new p(o,$)}constructor(m,n){this.added=m,this.removed=n}}e.$bF=p;class g{constructor(m,n){this.name=m,this.defaultExtensionKind=n,this.a=null,this.b=null,this.c=null}setHandler(m){if(this.a!==null)throw new Error("Handler already set!");this.a=m,this.d()}acceptUsers(m){this.c=p.compute(this.b,m),this.b=m,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(m){(0,C.$1)(m)}}}e.$cF=g;const t={type:"string",enum:["ui","workspace"],enumDescriptions:[f.localize(0,null),f.localize(1,null)]},i="vscode://schemas/vscode-extensions";e.$dF={properties:{engines:{type:"object",description:f.localize(2,null),properties:{vscode:{type:"string",description:f.localize(3,null),default:"^1.22.0"}}},publisher:{description:f.localize(4,null),type:"string"},displayName:{description:f.localize(5,null),type:"string"},categories:{description:f.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:E.$7l},{type:"string",const:"Languages",deprecationMessage:f.localize(7,null)}]}},galleryBanner:{type:"object",description:f.localize(8,null),properties:{color:{description:f.localize(9,null),type:"string"},theme:{description:f.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:f.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:f.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:f.localize(13,null)},enabledApiProposals:{markdownDescription:f.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(d.allApiProposals),markdownEnumDescriptions:Object.values(d.allApiProposals)}},api:{markdownDescription:f.localize(15,null),type:"string",enum:["none"],enumDescriptions:[f.localize(16,null)]},activationEvents:{description:f.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:f.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:f.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:f.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:f.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:f.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:f.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:f.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:f.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:f.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:f.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:f.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:f.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:f.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:f.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:f.localize(32,null)},{label:"onUri",body:"onUri",description:f.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:f.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:f.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:f.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:f.localize(37,null)},{label:"onRenderer",description:f.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:f.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:f.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:f.localize(41,null)},{label:"*",description:f.localize(42,null),body:"*"}]}},badges:{type:"array",description:f.localize(43,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:f.localize(44,null)},href:{type:"string",description:f.localize(45,null)},description:{type:"string",description:f.localize(46,null)}}}},markdown:{type:"string",description:f.localize(47,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:f.localize(48,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:f.localize(49,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:O.$3n}},extensionPack:{description:f.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:O.$3n}},extensionKind:{description:f.localize(51,null),type:"array",items:t,default:["workspace"],defaultSnippets:[{body:["ui"],description:f.localize(52,null)},{body:["workspace"],description:f.localize(53,null)},{body:["ui","workspace"],description:f.localize(54,null)},{body:["workspace","ui"],description:f.localize(55,null)},{body:[],description:f.localize(56,null)}]},capabilities:{description:f.localize(57,null),type:"object",properties:{virtualWorkspaces:{description:f.localize(58,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:f.localize(59,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[f.localize(60,null),f.localize(61,null),f.localize(62,null)]},description:{type:"string",markdownDescription:f.localize(63,null)}}},untrustedWorkspaces:{description:f.localize(64,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:f.localize(65,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[f.localize(66,null),f.localize(67,null),f.localize(68,null)]},restrictedConfigurations:{description:f.localize(69,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:f.localize(70,null)}}}}},sponsor:{description:f.localize(71,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:f.localize(72,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:f.localize(73,null),type:"string"},"vscode:uninstall":{description:f.localize(74,null),type:"string"}}},icon:{type:"string",description:f.localize(75,null)},l10n:{type:"string",description:f.localize(76,null)},pricing:{type:"string",markdownDescription:f.localize(77,null),enum:["Free","Trial"],default:"Free"}}};class l{constructor(){this.a=new Map}registerExtensionPoint(m){if(this.a.has(m.extensionPoint))throw new Error("Duplicate extension point: "+m.extensionPoint);const n=new g(m.extensionPoint,m.defaultExtensionKind);return this.a.set(m.extensionPoint,n),m.activationEventsGenerator&&S.$4E.register(m.extensionPoint,m.activationEventsGenerator),e.$dF.properties.contributes.properties[m.extensionPoint]=m.jsonSchema,u.registerSchema(i,e.$dF),n}getExtensionPoints(){return Array.from(this.a.values())}}e.$eF=l;const v={ExtensionsRegistry:"ExtensionsRegistry"};c.$ln.add(v.ExtensionsRegistry,new l),e.$fF=c.$ln.as(v.ExtensionsRegistry),u.registerSchema(i,e.$dF),u.registerSchema(R.$rj,{properties:{extensionEnabledApiProposals:{description:f.localize(78,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(d.allApiProposals),markdownEnumDescriptions:Object.values(d.allApiProposals)}}]}}}})}),define(Ae[215],Re([1,0,164,15,25,214,32,5]),function(ee,e,f,C,I,O,A,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WF=void 0;const E={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:f.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:f.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:f.localize(2,null),default:""}}};var d;(function(u){function b(p,g,t){if(!p)return;const i=C.$zf(p.type)?p.type:void 0;if(!i||i.length===0){t.error(f.localize(3,null));return}const l=[];if(Array.isArray(p.required))for(const v of p.required)C.$zf(v)&&l.push(v);return{extensionId:g.value,taskType:i,required:l,properties:p.properties?I.$9m(p.properties):{},when:p.when?A.$Oi.deserialize(p.when):void 0}}u.from=b})(d||(d={}));const R=O.$fF.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(u,b)=>{for(const p of u)p.type&&b.push(`onTaskType:${p.type}`)},jsonSchema:{description:f.localize(4,null),type:"array",items:E}});class S{constructor(){this.d=new c.$Od,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((b,p)=>{R.setHandler((g,t)=>{this.c=void 0;try{for(const i of t.removed){const l=i.value;for(const v of l)this.a&&v.type&&this.a[v.type]&&delete this.a[v.type]}for(const i of t.added){const l=i.value;for(const v of l){const D=d.from(v,i.description.identifier,i.collector);D&&(this.a[D.taskType]=D)}}(t.removed.length>0||t.added.length>0)&&this.d.fire()}catch{}b(void 0)})})}onReady(){return this.b}get(b){return this.a[b]}all(){return Object.keys(this.a).map(b=>this.a[b])}getJsonSchema(){if(this.c===void 0){const b=[];for(const p of this.all()){const g={type:"object",additionalProperties:!1};p.required.length>0&&(g.required=p.required.slice(0)),p.properties!==void 0?g.properties=I.$9m(p.properties):g.properties=Object.create(null),g.properties.type={type:"string",enum:[p.taskType]},b.push(g)}this.c={oneOf:b}}return this.c}}e.$WF=new S}),define(Ae[216],Re([1,0,165,15,24,25,32,215]),function(ee,e,f,C,I,O,A,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$7F=e.JsonSchemaVersion=e.ExecutionEngine=e.$6F=e.$5F=e.$4F=e.$3F=e.$2F=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$1F=e.ShellQuoting=e.$ZF=e.$YF=e.$XF=void 0,e.$XF="settings",e.$YF=new A.$8i("taskRunning",!1,f.localize(0,null)),e.$ZF={value:f.localize(1,null),original:"Tasks"};var E;(function(F){F[F.Escape=1]="Escape",F[F.Strong=2]="Strong",F[F.Weak=3]="Weak"})(E||(e.ShellQuoting=E={})),e.$1F="$customized",function(F){function j(q){if(!q)return F.Strong;switch(q.toLowerCase()){case"escape":return F.Escape;case"strong":return F.Strong;case"weak":return F.Weak;default:return F.Strong}}F.from=j}(E||(e.ShellQuoting=E={}));var d;(function(F){F.defaults={cwd:"${workspaceFolder}"}})(d||(e.CommandOptions=d={}));var R;(function(F){F[F.Always=1]="Always",F[F.Silent=2]="Silent",F[F.Never=3]="Never"})(R||(e.RevealKind=R={})),function(F){function j(q){switch(q.toLowerCase()){case"always":return F.Always;case"silent":return F.Silent;case"never":return F.Never;default:return F.Always}}F.fromString=j}(R||(e.RevealKind=R={}));var S;(function(F){F[F.Never=1]="Never",F[F.OnProblem=2]="OnProblem",F[F.Always=3]="Always"})(S||(e.RevealProblemKind=S={})),function(F){function j(q){switch(q.toLowerCase()){case"always":return F.Always;case"never":return F.Never;case"onproblem":return F.OnProblem;default:return F.OnProblem}}F.fromString=j}(S||(e.RevealProblemKind=S={}));var u;(function(F){F[F.Shared=1]="Shared",F[F.Dedicated=2]="Dedicated",F[F.New=3]="New"})(u||(e.PanelKind=u={})),function(F){function j(q){switch(q.toLowerCase()){case"shared":return F.Shared;case"dedicated":return F.Dedicated;case"new":return F.New;default:return F.Shared}}F.fromString=j}(u||(e.PanelKind=u={}));var b;(function(F){F.defaults={echo:!0,reveal:R.Always,revealProblems:S.Never,focus:!1,panel:u.Shared,showReuseMessage:!0,clear:!1}})(b||(e.PresentationOptions=b={}));var p;(function(F){F[F.Shell=1]="Shell",F[F.Process=2]="Process",F[F.CustomExecution=3]="CustomExecution"})(p||(e.RuntimeType=p={})),function(F){function j(W){switch(W.toLowerCase()){case"shell":return F.Shell;case"process":return F.Process;case"customExecution":return F.CustomExecution;default:return F.Process}}F.fromString=j;function q(W){switch(W){case F.Shell:return"shell";case F.Process:return"process";case F.CustomExecution:return"customExecution";default:return"process"}}F.toString=q}(p||(e.RuntimeType=p={}));var g;(function(F){function j(q){return C.$zf(q)?q:q.value}F.value=j})(g||(e.CommandString=g={}));var t;(function(F){F.Clean={_id:"clean",isDefault:!1},F.Build={_id:"build",isDefault:!1},F.Rebuild={_id:"rebuild",isDefault:!1},F.Test={_id:"test",isDefault:!1};function j(W){return W===F.Clean._id||W===F.Build._id||W===F.Rebuild._id||W===F.Test._id}F.is=j;function q(W){if(W!==void 0)return C.$zf(W)?j(W)?{_id:W,isDefault:!1}:void 0:W}F.from=q})(t||(e.TaskGroup=t={}));var i;(function(F){F[F.Global=1]="Global",F[F.Workspace=2]="Workspace",F[F.Folder=3]="Folder"})(i||(e.TaskScope=i={}));var l;(function(F){F.Workspace="workspace",F.Extension="extension",F.InMemory="inMemory",F.WorkspaceFile="workspaceFile",F.User="user";function j(q){switch(q){case F.User:return 2;case F.WorkspaceFile:return 5;default:return 6}}F.toConfigurationTarget=j})(l||(e.TaskSourceKind=l={}));var v;(function(F){F.parallel="parallel",F.sequence="sequence"})(v||(e.DependsOrder=v={}));var D;(function(F){F[F.default=1]="default",F[F.folderOpen=2]="folderOpen"})(D||(e.RunOnOptions=D={}));var m;(function(F){F.defaults={reevaluateOnRerun:!0,runOn:D.default,instanceLimit:1}})(m||(e.RunOptions=m={}));class n{constructor(j,q,W,we,ke,Se){this._label="",this._id=j,q&&(this._label=q),W&&(this.type=W),this.runOptions=we,this.configurationProperties=ke,this._source=Se}getDefinition(j){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const j={folder:this.d(),id:this._id};return JSON.stringify(j)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(j,q=!1){if(j===void 0)return!1;if(C.$zf(j))return j===this._label||j===this.configurationProperties.identifier||q&&j===this._id;const W=this.getDefinition(!0);return W!==void 0&&W._key===j._key}getQualifiedLabel(){const j=this.getWorkspaceFolder();return j?`${this._label} (${j.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(j){this.c===void 0&&(this.c=[]),j&&(this.c=this.c.concat(j))}get taskLoadMessages(){return this.c}}e.$2F=n;class r extends n{constructor(j,q,W,we,ke,Se,ve,ge){super(j,W,void 0,ve,ge,q),this.command={},this._source=q,this.hasDefinedMatchers=Se,ke&&(this.command=ke)}clone(){return new r(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(j=!1){if(j&&this._source.customizes!==void 0)return this._source.customizes;{let q;switch(this.command?this.command.runtime:void 0){case p.Shell:q="shell";break;case p.Process:q="process";break;case p.CustomExecution:q="customExecution";break;case void 0:q="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:q,_key:this._id,id:this._id}}}static is(j){return j instanceof r}getMapKey(){const j=this._source.config.workspaceFolder;return j?`${j.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===l.User?e.$XF:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const j=this.d();if(!j)return;let q=this.configurationProperties.identifier;this._source.kind!==l.Workspace&&(q+=this._source.kind);const W={type:e.$1F,folder:j,id:q};return JSON.stringify(W)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?I.$tg(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(j){return new r(j._id,j._source,j._label,j.type,j.command,j.hasDefinedMatchers,j.runOptions,j.configurationProperties)}}e.$3F=r;class s extends n{constructor(j,q,W,we,ke,Se,ve){super(j,W,we,Se,ve,q),this._source=q,this.configures=ke}static is(j){return j instanceof s}f(j){return j}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?I.$tg(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===l.User?e.$XF:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const j=this.d();if(!j)return;let q=this.configurationProperties.identifier;this._source.kind!==l.Workspace&&(q+=this._source.kind);const W={type:e.$1F,folder:j,id:q};return JSON.stringify(W)}}e.$4F=s;class o extends n{constructor(j,q,W,we,ke,Se,ve,ge,re){super(j,W,we,ge,re,q),this.defines=ke,this.hasDefinedMatchers=ve,this.command=Se,this.icon=re.icon,this.hide=re.hide}clone(){return new o(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(j){return j instanceof o}getMapKey(){const j=this._source.workspaceFolder;return j?`${this._source.scope.toString()}|${j.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const j={type:"contributed",scope:this._source.scope,id:this._id};return j.folder=this.d(),JSON.stringify(j)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(j){return new o(j._id,j._source,j._label,j.type,j.defines,j.command,j.hasDefinedMatchers,j.runOptions,j.configurationProperties)}}e.$5F=o;class $ extends n{constructor(j,q,W,we,ke,Se){super(j,W,we,ke,Se,q),this._source=q}clone(){return new $(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(j){return j instanceof $}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(j){return new $(j._id,j._source,j._label,j.type,j.runOptions,j.configurationProperties)}}e.$6F=$;var a;(function(F){F[F.Process=1]="Process",F[F.Terminal=2]="Terminal"})(a||(e.ExecutionEngine=a={})),function(F){F._default=F.Terminal}(a||(e.ExecutionEngine=a={}));var k;(function(F){F[F.V0_1_0=1]="V0_1_0",F[F.V2_0_0=2]="V2_0_0"})(k||(e.JsonSchemaVersion=k={}));class P{constructor(j){this.c=new Map;for(let q=0;q<j.length;q++)this.c.set(j[q].uri.toString(),q)}compare(j,q){const W=j.getWorkspaceFolder(),we=q.getWorkspaceFolder();if(W&&we){let ke=this.c.get(W.uri.toString());ke=ke===void 0?0:ke+1;let Se=this.c.get(we.uri.toString());return Se=Se===void 0?0:Se+1,ke===Se?j._label.localeCompare(q._label):ke-Se}else return!W&&we?-1:W&&!we?1:0}}e.$7F=P;var h;(function(F){F.DependsOnStarted="dependsOnStarted",F.AcquiredInput="acquiredInput",F.Start="start",F.ProcessStarted="processStarted",F.Active="active",F.Inactive="inactive",F.Changed="changed",F.Terminated="terminated",F.ProcessEnded="processEnded",F.End="end"})(h||(e.TaskEventKind=h={}));var w;(function(F){F.SingleRun="singleRun",F.Background="background"})(w||(e.TaskRunType=w={}));var y;(function(F){F[F.System=0]="System",F[F.User=1]="User",F[F.FolderOpen=2]="FolderOpen",F[F.ConfigurationChange=3]="ConfigurationChange",F[F.Reconnect=4]="Reconnect"})(y||(e.TaskRunSource=y={}));var M;(function(F){function j(ge){return{taskId:ge._id,taskName:ge.configurationProperties.name,runType:ge.configurationProperties.isBackground?"background":"singleRun",group:ge.configurationProperties.group,__task:ge}}function q(ge,re,oe){return{...j(ge),kind:"start",terminalId:re,resolvedVariables:oe}}F.start=q;function W(ge,re,oe){return{...j(ge),kind:"processStarted",terminalId:re,processId:oe}}F.processStarted=W;function we(ge,re,oe){return{...j(ge),kind:"processEnded",terminalId:re,exitCode:oe}}F.processEnded=we;function ke(ge,re,oe){return{...j(ge),kind:"terminated",exitReason:oe,terminalId:re}}F.terminated=ke;function Se(ge,re,oe){return{...j(re),kind:ge,terminalId:oe}}F.general=Se;function ve(){return{kind:"changed"}}F.changed=ve})(M||(e.TaskEvent=M={}));var V;(function(F){function j(W){const we=Object.keys(W).sort();let ke="";for(const Se of we){let ve=W[Se];ve instanceof Object?ve=j(ve):typeof ve=="string"&&(ve=ve.replace(/,/g,",,")),ke+=Se+","+ve+","}return ke}function q(W){const ke={_key:j(W),type:W.taskType};return Object.assign(ke,W),ke}F.create=q})(V||(e.KeyedTaskIdentifier=V={}));var B;(function(F){F.AutoDetect="task.autoDetect",F.SaveBeforeRun="task.saveBeforeRun",F.ShowDecorations="task.showDecorations",F.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",F.SlowProviderWarning="task.slowProviderWarning",F.QuickOpenHistory="task.quickOpen.history",F.QuickOpenDetail="task.quickOpen.detail",F.QuickOpenSkip="task.quickOpen.skip",F.QuickOpenShowAll="task.quickOpen.showAll",F.AllowAutomaticTasks="task.allowAutomaticTasks",F.Reconnection="task.reconnection"})(B||(e.TaskSettingId=B={}));var z;(function(F){F.Tasks="tasks",F.SuppressTaskName="tasks.suppressTaskName",F.Windows="tasks.windows",F.Osx="tasks.osx",F.Linux="tasks.linux",F.ShowOutput="tasks.showOutput",F.IsShellCommand="tasks.isShellCommand",F.ServiceTestSetting="tasks.service.testSetting"})(z||(e.TasksSchemaProperties=z={}));var T;(function(F){function j(q,W){const we=c.$WF.get(q.type);if(we===void 0){const ge=O.$9m(q);return delete ge._key,V.create(ge)}const ke=Object.create(null);ke.type=we.taskType;const Se=new Set;we.required.forEach(ge=>Se.add(ge));const ve=we.properties;for(const ge of Object.keys(ve)){const re=q[ge];if(re!=null)ke[ge]=re;else if(Se.has(ge)){const oe=ve[ge];if(oe.default!==void 0)ke[ge]=O.$9m(oe.default);else switch(oe.type){case"boolean":ke[ge]=!1;break;case"number":case"integer":ke[ge]=0;break;case"string":ke[ge]="";break;default:W.error(f.localize(2,null,JSON.stringify(q,void 0,0),ge));return}}}return V.create(ke)}F.createTaskIdentifier=j})(T||(e.TaskDefinition=T={}))}),define(Ae[217],Re([1,0,11]),function(ee,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$24b=e.$14b=void 0;class C{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((A,c)=>{this.b=A,this.d=c,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(A){this.f||this.h||(this.f=!0,this.g=A,this.a&&this.b(A))}resolveErr(A){this.f||this.h||(this.h=!0,this.i=A,this.a?this.d(A):(0,f.$1)(A))}then(A,c){return this.j().then(A,c)}catch(A){return this.j().then(void 0,A)}finally(A){return this.j().finally(A)}}e.$14b=C;class I extends C{constructor(){super(),this.h=!0,this.i=new f.$5}}e.$24b=I}),define(Ae[47],Re([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vv=e.$uv=e.$tv=e.$sv=void 0;class f{constructor(E){this._proxyIdentifierBrand=void 0,this.sid=E,this.nid=++f.count}}e.$sv=f,f.count=0;const C=[];function I(c){const E=new f(c);return C[E.nid]=E,E}e.$tv=I;function O(c){return C[c].sid}e.$uv=O;class A{constructor(E){this.value=E}}e.$vv=A}),define(Ae[3],Re([1,0,47]),function(ee,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rK=e.$qK=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$pK=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var C;(function(g){g[g.Default=0]="Default",g[g.InCenter=1]="InCenter",g[g.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",g[g.AtTop=3]="AtTop"})(C||(e.TextEditorRevealType=C={}));var I;(function(g){g[g.UnknownInput=0]="UnknownInput",g[g.TextInput=1]="TextInput",g[g.TextDiffInput=2]="TextDiffInput",g[g.TextMergeInput=3]="TextMergeInput",g[g.NotebookInput=4]="NotebookInput",g[g.NotebookDiffInput=5]="NotebookDiffInput",g[g.CustomEditorInput=6]="CustomEditorInput",g[g.WebviewEditorInput=7]="WebviewEditorInput",g[g.TerminalEditorInput=8]="TerminalEditorInput",g[g.InteractiveEditorInput=9]="InteractiveEditorInput"})(I||(e.TabInputKind=I={}));var O;(function(g){g[g.TAB_OPEN=0]="TAB_OPEN",g[g.TAB_CLOSE=1]="TAB_CLOSE",g[g.TAB_UPDATE=2]="TAB_UPDATE",g[g.TAB_MOVE=3]="TAB_MOVE"})(O||(e.TabModelOperationKind=O={}));var A;(function(g){g[g.Editable=0]="Editable",g[g.SupportsHotExit=1]="SupportsHotExit"})(A||(e.WebviewEditorCapabilities=A={}));var c;(function(g){g[g.Int8Array=1]="Int8Array",g[g.Uint8Array=2]="Uint8Array",g[g.Uint8ClampedArray=3]="Uint8ClampedArray",g[g.Int16Array=4]="Int16Array",g[g.Uint16Array=5]="Uint16Array",g[g.Int32Array=6]="Int32Array",g[g.Uint32Array=7]="Uint32Array",g[g.Float32Array=8]="Float32Array",g[g.Float64Array=9]="Float64Array",g[g.BigInt64Array=10]="BigInt64Array",g[g.BigUint64Array=11]="BigUint64Array"})(c||(e.WebviewMessageArrayBufferViewType=c={}));var E;(function(g){g[g.Text=1]="Text",g[g.Error=2]="Error",g[g.Rich=3]="Rich"})(E||(e.CellOutputKind=E={}));var d;(function(g){g[g.Default=0]="Default",g[g.InCenter=1]="InCenter",g[g.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",g[g.AtTop=3]="AtTop"})(d||(e.NotebookEditorRevealType=d={}));var R;(function(g){g[g.None=0]="None",g[g.Process=1]="Process",g[g.Output=2]="Output"})(R||(e.CandidatePortSource=R={}));class S{static mixin(t){return t._id=S.a++,t}}e.$pK=S,S.a=0;var u;(function(g){g.label="a",g.kind="b",g.detail="c",g.documentation="d",g.sortText="e",g.filterText="f",g.preselect="g",g.insertText="h",g.insertTextRules="i",g.range="j",g.commitCharacters="k",g.additionalTextEdits="l",g.kindModifier="m",g.commandIdent="n",g.commandId="o",g.commandArguments="p"})(u||(e.ISuggestDataDtoField=u={}));var b;(function(g){g.defaultRanges="a",g.completions="b",g.isIncomplete="c",g.duration="d"})(b||(e.ISuggestResultDtoField=b={}));var p;(function(g){g[g.Workspace=0]="Workspace",g[g.TextDocument=1]="TextDocument"})(p||(e.ExtHostTestingResource=p={})),e.$qK={MainThreadAuthentication:(0,f.$tv)("MainThreadAuthentication"),MainThreadBulkEdits:(0,f.$tv)("MainThreadBulkEdits"),MainThreadChatProvider:(0,f.$tv)("MainThreadChatProvider"),MainThreadChatAgents:(0,f.$tv)("MainThreadChatAgents"),MainThreadChatAgents2:(0,f.$tv)("MainThreadChatAgents2"),MainThreadChatVariables:(0,f.$tv)("MainThreadChatVariables"),MainThreadClipboard:(0,f.$tv)("MainThreadClipboard"),MainThreadCommands:(0,f.$tv)("MainThreadCommands"),MainThreadComments:(0,f.$tv)("MainThreadComments"),MainThreadConfiguration:(0,f.$tv)("MainThreadConfiguration"),MainThreadConsole:(0,f.$tv)("MainThreadConsole"),MainThreadDebugService:(0,f.$tv)("MainThreadDebugService"),MainThreadDecorations:(0,f.$tv)("MainThreadDecorations"),MainThreadDiagnostics:(0,f.$tv)("MainThreadDiagnostics"),MainThreadDialogs:(0,f.$tv)("MainThreadDiaglogs"),MainThreadDocuments:(0,f.$tv)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,f.$tv)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,f.$tv)("MainThreadTextEditors"),MainThreadEditorInsets:(0,f.$tv)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,f.$tv)("MainThreadEditorTabs"),MainThreadErrors:(0,f.$tv)("MainThreadErrors"),MainThreadTreeViews:(0,f.$tv)("MainThreadTreeViews"),MainThreadDownloadService:(0,f.$tv)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,f.$tv)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,f.$tv)("MainThreadLanguages"),MainThreadLogger:(0,f.$tv)("MainThreadLogger"),MainThreadMessageService:(0,f.$tv)("MainThreadMessageService"),MainThreadOutputService:(0,f.$tv)("MainThreadOutputService"),MainThreadProgress:(0,f.$tv)("MainThreadProgress"),MainThreadQuickDiff:(0,f.$tv)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,f.$tv)("MainThreadQuickOpen"),MainThreadStatusBar:(0,f.$tv)("MainThreadStatusBar"),MainThreadSecretState:(0,f.$tv)("MainThreadSecretState"),MainThreadStorage:(0,f.$tv)("MainThreadStorage"),MainThreadSpeech:(0,f.$tv)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,f.$tv)("MainThreadTelemetry"),MainThreadTerminalService:(0,f.$tv)("MainThreadTerminalService"),MainThreadWebviews:(0,f.$tv)("MainThreadWebviews"),MainThreadWebviewPanels:(0,f.$tv)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,f.$tv)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,f.$tv)("MainThreadCustomEditors"),MainThreadUrls:(0,f.$tv)("MainThreadUrls"),MainThreadUriOpeners:(0,f.$tv)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,f.$tv)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,f.$tv)("MainThreadWorkspace"),MainThreadFileSystem:(0,f.$tv)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,f.$tv)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,f.$tv)("MainThreadExtensionService"),MainThreadSCM:(0,f.$tv)("MainThreadSCM"),MainThreadSearch:(0,f.$tv)("MainThreadSearch"),MainThreadShare:(0,f.$tv)("MainThreadShare"),MainThreadTask:(0,f.$tv)("MainThreadTask"),MainThreadWindow:(0,f.$tv)("MainThreadWindow"),MainThreadLabelService:(0,f.$tv)("MainThreadLabelService"),MainThreadNotebook:(0,f.$tv)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,f.$tv)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,f.$tv)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,f.$tv)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,f.$tv)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,f.$tv)("MainThreadInteractive"),MainThreadChat:(0,f.$tv)("MainThreadChat"),MainThreadInlineChat:(0,f.$tv)("MainThreadInlineChatShape"),MainThreadTheming:(0,f.$tv)("MainThreadTheming"),MainThreadTunnelService:(0,f.$tv)("MainThreadTunnelService"),MainThreadManagedSockets:(0,f.$tv)("MainThreadManagedSockets"),MainThreadTimeline:(0,f.$tv)("MainThreadTimeline"),MainThreadTesting:(0,f.$tv)("MainThreadTesting"),MainThreadLocalization:(0,f.$tv)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,f.$tv)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,f.$tv)("MainThreadAiEmbeddingVector"),MainThreadIssueReporter:(0,f.$tv)("MainThreadIssueReporter")},e.$rK={ExtHostCommands:(0,f.$tv)("ExtHostCommands"),ExtHostConfiguration:(0,f.$tv)("ExtHostConfiguration"),ExtHostDiagnostics:(0,f.$tv)("ExtHostDiagnostics"),ExtHostDebugService:(0,f.$tv)("ExtHostDebugService"),ExtHostDecorations:(0,f.$tv)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,f.$tv)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,f.$tv)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,f.$tv)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,f.$tv)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,f.$tv)("ExtHostEditors"),ExtHostTreeViews:(0,f.$tv)("ExtHostTreeViews"),ExtHostFileSystem:(0,f.$tv)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,f.$tv)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,f.$tv)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,f.$tv)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,f.$tv)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,f.$tv)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,f.$tv)("ExtHostQuickDiff"),ExtHostStatusBar:(0,f.$tv)("ExtHostStatusBar"),ExtHostShare:(0,f.$tv)("ExtHostShare"),ExtHostExtensionService:(0,f.$tv)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,f.$tv)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,f.$tv)("ExtHostTerminalService"),ExtHostSCM:(0,f.$tv)("ExtHostSCM"),ExtHostSearch:(0,f.$tv)("ExtHostSearch"),ExtHostTask:(0,f.$tv)("ExtHostTask"),ExtHostWorkspace:(0,f.$tv)("ExtHostWorkspace"),ExtHostWindow:(0,f.$tv)("ExtHostWindow"),ExtHostWebviews:(0,f.$tv)("ExtHostWebviews"),ExtHostWebviewPanels:(0,f.$tv)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,f.$tv)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,f.$tv)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,f.$tv)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,f.$tv)("ExtHostEditorTabs"),ExtHostProgress:(0,f.$tv)("ExtHostProgress"),ExtHostComments:(0,f.$tv)("ExtHostComments"),ExtHostSecretState:(0,f.$tv)("ExtHostSecretState"),ExtHostStorage:(0,f.$tv)("ExtHostStorage"),ExtHostUrls:(0,f.$tv)("ExtHostUrls"),ExtHostUriOpeners:(0,f.$tv)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,f.$tv)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,f.$tv)("ExtHostOutputService"),ExtHosLabelService:(0,f.$tv)("ExtHostLabelService"),ExtHostNotebook:(0,f.$tv)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,f.$tv)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,f.$tv)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,f.$tv)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,f.$tv)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,f.$tv)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,f.$tv)("ExtHostInteractive"),ExtHostInlineChat:(0,f.$tv)("ExtHostInlineChatShape"),ExtHostChat:(0,f.$tv)("ExtHostChat"),ExtHostChatAgents:(0,f.$tv)("ExtHostChatAgents"),ExtHostChatAgents2:(0,f.$tv)("ExtHostChatAgents"),ExtHostChatVariables:(0,f.$tv)("ExtHostChatVariables"),ExtHostChatProvider:(0,f.$tv)("ExtHostChatProvider"),ExtHostSpeech:(0,f.$tv)("ExtHostSpeech"),ExtHostAiRelatedInformation:(0,f.$tv)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,f.$tv)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,f.$tv)("ExtHostTheming"),ExtHostTunnelService:(0,f.$tv)("ExtHostTunnelService"),ExtHostManagedSockets:(0,f.$tv)("ExtHostManagedSockets"),ExtHostAuthentication:(0,f.$tv)("ExtHostAuthentication"),ExtHostTimeline:(0,f.$tv)("ExtHostTimeline"),ExtHostTesting:(0,f.$tv)("ExtHostTesting"),ExtHostTelemetry:(0,f.$tv)("ExtHostTelemetry"),ExtHostLocalization:(0,f.$tv)("ExtHostLocalization"),ExtHostIssueReporter:(0,f.$tv)("ExtHostIssueReporter")}}),define(Ae[218],Re([1,0,3,7]),function(ee,e,f,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gec=void 0;class I{constructor(A){this.a=new Map,this.b=0,this.c=A.getProxy(f.$qK.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(A,c,E){if(this.a.size===0)throw new Error("No related information providers registered");const d=this.a.get(A);if(!d)throw new Error("related information provider not found");return await d.provideRelatedInformation(c,E)??[]}getRelatedInformation(A,c,E){return this.c.$getAiRelatedInformation(c,E)}registerRelatedInformationProvider(A,c,E){const d=this.b;return this.b++,this.a.set(d,E),this.c.$registerAiRelatedInformationProvider(d,c),new C.$sK(()=>{this.c.$unregisterAiRelatedInformationProvider(d),this.a.delete(d)})}}e.$Gec=I}),define(Ae[80],Re([1,0,4,14,3,17]),function(ee,e,f,C,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kcc=e.$Jcc=e.$Icc=void 0,e.$Icc=(0,f.$Qh)("IExtHostApiDeprecationService");let A=class{constructor(E,d){this.c=d,this.a=new Set,this.b=E.getProxy(I.$qK.MainThreadTelemetry)}report(E,d,R){const S=this.d(E,d);this.a.has(S)||(this.a.add(S),d.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${E}' is deprecated. ${R}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:d.identifier.value,apiId:E}))}d(E,d){return`${E}-${d.identifier.value}`}};e.$Jcc=A,e.$Jcc=A=Ge([qe(0,O.$rM),qe(1,C.$$i)],A),e.$Kcc=Object.freeze(new class{report(c,E,d){}})}),define(Ae[219],Re([1,0,5,3,7,21]),function(ee,e,f,C,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eec=void 0;class A{constructor(d){this.b=new Map,this.c=[],this.d=new f.$Od,this.onDidChangeSessions=this.d.event,this.f=new c,this.g=new c,this.a=d.getProxy(C.$qK.MainThreadAuthentication)}$setProviders(d){return this.c=d,Promise.resolve()}async getSession(d,R,S,u={}){const b=O.$8l.toKey(d.identifier),p=[...S].sort().join(" ");return await this.f.getOrCreate(`${b} ${R} ${p}`,async()=>{await this.a.$ensureProvider(R);const g=d.displayName||d.name;return this.a.$getSession(R,S,b,g,u)})}async getSessions(d,R,S){const u=O.$8l.toKey(d.identifier),b=[...S].sort().join(" ");return await this.g.getOrCreate(`${u} ${b}`,async()=>{await this.a.$ensureProvider(R);const p=d.displayName||d.name;return this.a.$getSessions(R,S,u,p)})}async removeSession(d,R){const S=this.b.get(d);return S?S.provider.removeSession(R):this.a.$removeSession(d,R)}registerAuthenticationProvider(d,R,S,u){if(this.b.get(d))throw new Error(`An authentication provider with id '${d}' is already registered.`);this.b.set(d,{label:R,provider:S,options:u??{supportsMultipleAccounts:!1}}),this.c.find(p=>p.id===d)||this.c.push({id:d,label:R});const b=S.onDidChangeSessions(p=>{this.a.$sendDidChangeSessions(d,{added:p.added??[],changed:p.changed??[],removed:p.removed??[]})});return this.a.$registerAuthenticationProvider(d,R,u?.supportsMultipleAccounts??!1),new I.$sK(()=>{b.dispose(),this.b.delete(d);const p=this.c.findIndex(g=>g.id===d);p>-1&&this.c.splice(p),this.a.$unregisterAuthenticationProvider(d)})}$createSession(d,R,S){const u=this.b.get(d);if(u)return Promise.resolve(u.provider.createSession(R,S));throw new Error(`Unable to find authentication provider with handle: ${d}`)}$removeSession(d,R){const S=this.b.get(d);if(S)return Promise.resolve(S.provider.removeSession(R));throw new Error(`Unable to find authentication provider with handle: ${d}`)}$getSessions(d,R){const S=this.b.get(d);if(S)return Promise.resolve(S.provider.getSessions(R));throw new Error(`Unable to find authentication provider with handle: ${d}`)}$onDidChangeAuthenticationSessions(d,R){return this.d.fire({provider:{id:d,label:R}}),Promise.resolve()}}e.$eec=A;class c{constructor(){this.a=new Map}getOrCreate(d,R){const S=this.a.get(d);if(S)return S;const u=R().finally(()=>this.a.delete(d));return this.a.set(d,u),u}}}),define(Ae[220],Re([1,0,3,17,8]),function(ee,e,f,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kec=void 0;let O=class{constructor(c,E){this.a=c.getProxy(f.$qK.MainThreadBulkEdits),this.b={getTextDocumentVersion:d=>E.getDocument(d)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(c,E,d){const R=I.WorkspaceEdit.from(c,this.b);return this.a.$tryApplyWorkspaceEdit(R,void 0,d?.isRefactoring??!1)}};e.$kec=O,e.$kec=O=Ge([qe(0,C.$rM)],O)}),define(Ae[221],Re([1,0,12,5,68,6,48,146,3,8]),function(ee,e,f,C,I,O,A,c,E,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yec=void 0;class R{constructor(b,p){this.extension=b,this.provider=p,this.handle=R.a++}}R.a=0;class S{constructor(b,p){this.h=p,this.b=new Map,this.d=new Map,this.e=new C.$Od,this.onDidPerformUserAction=this.e.event,this.g=b.getProxy(E.$qK.MainThreadChat)}registerChatProvider(b,p,g){const t=new R(b,g);return this.b.set(t.handle,t),this.g.$registerChatProvider(t.handle,p),(0,O.$Qc)(()=>{this.g.$unregisterChatProvider(t.handle),this.b.delete(t.handle)})}transferChatSession(b,p){const g=I.Iterable.find(this.d.keys(),t=>this.d.get(t)===b)??0;typeof g=="number"&&this.g.$transferChatSession(g,p)}sendInteractiveRequestToProvider(b,p){this.g.$sendRequestToProvider(b,p)}async $prepareChat(b,p,g){const t=this.b.get(b);if(!t)return;const i=await t.provider.prepareSession(p,g);if(!i)return;const l=S.a++;return this.d.set(l,i),{id:l,requesterUsername:i.requester?.name,requesterAvatarIconUri:i.requester?.icon,responderUsername:i.responder?.name,responderAvatarIconUri:i.responder?.icon,inputPlaceholder:i.inputPlaceholder}}async $provideWelcomeMessage(b,p){const g=this.b.get(b);if(!g||!g.provider.provideWelcomeMessage)return;const t=await g.provider.provideWelcomeMessage(p);if(t)return t.map(i=>typeof i=="string"?i:Array.isArray(i)?i.map(l=>d.ChatReplyFollowup.from(l)):d.MarkdownString.from(i))}async $provideFollowups(b,p,g){const t=this.b.get(b);if(!t)return;const i=this.d.get(p);return!i||!t.provider.provideFollowups?void 0:(await t.provider.provideFollowups(i,g))?.map(v=>d.ChatFollowup.from(v))}async $provideSampleQuestions(b,p){const g=this.b.get(b);if(!g||!g.provider.provideSampleQuestions)return;const t=await g.provider.provideSampleQuestions(p);if(t)return t?.map(i=>d.ChatReplyFollowup.from(i))}$removeRequest(b,p,g){const t=this.b.get(b);if(!t)return;const i=this.d.get(p);i&&t.provider.removeRequest&&t.provider.removeRequest(i,g)}async $provideReply(b,p,g,t){const i=this.b.get(b);if(!i)return;const l=this.d.get(p);if(!l)return;const v={session:l,message:g.message,variables:{}};if(g.variables)for(const o of Object.keys(g.variables))v.variables[o]=g.variables[o].map(d.ChatVariable.to);const D=A.$Kd.create(!1);let m;const n={report:o=>{if(t.isCancellationRequested)return;typeof m>"u"&&(m=D.elapsed());const $=d.ChatResponseProgress.from(i.extension,o);if("placeholder"in o&&"resolvedContent"in o){const a=Promise.all([this.g.$acceptResponseProgress(b,p,$),o.resolvedContent]);(0,f.$Jg)(a,t).then(k=>{if(!k)return;const[P,h]=k;this.g.$acceptResponseProgress(b,p,h,P??void 0)})}else this.g.$acceptResponseProgress(b,p,$)}};let r;try{r=await i.provider.provideResponseWithProgress(v,n,t),r||(r={errorDetails:{message:(0,c.localize)(0,null)}})}catch(o){r={errorDetails:{message:(0,c.localize)(1,null,o.message),responseIsIncomplete:!0}},this.h.error(o)}try{if(l.saveState&&this.d.has(p)){const o=l.saveState();this.g.$acceptChatState(p,o)}}catch(o){this.h.warn(o)}const s={firstProgress:m??0,totalElapsed:D.elapsed()};return{errorDetails:r.errorDetails,timings:s}}async $provideSlashCommands(b,p,g){const t=this.b.get(b);if(!t)return;const i=this.d.get(p);return!i||!t.provider.provideSlashCommands?void 0:(await t.provider.provideSlashCommands(i,g))?.map(v=>({...v,kind:d.CompletionItemKind.from(v.kind)}))}$releaseSession(b){this.d.delete(b)}async $onDidPerformUserAction(b){this.e.fire(b)}}e.$yec=S,S.a=0}),define(Ae[222],Re([1,0,12,6,52,3,8,7]),function(ee,e,f,C,I,O,A,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Iec=void 0;class E{constructor(S,u,b){this.d=u,this.e=b,this.b=new Map,this.c=S.getProxy(O.$qK.MainThreadChatAgents)}registerAgent(S,u,b,p){const g=E.a++;return this.b.set(g,{extension:S,agent:b}),this.c.$registerAgent(g,u,p),(0,C.$Qc)(()=>{this.c.$unregisterAgent(g),this.b.delete(g)})}async $invokeAgent(S,u,b,p,g){const t=this.b.get(S);if(!t){this.e.warn(`[CHAT](${S}) CANNOT invoke agent because the agent is not registered`);return}let i=!1;function l(){if(i)throw new Error("Only valid while executing the command")}const v=new f.$dh;g.onCancellationRequested(()=>v.complete()),setTimeout(()=>v.complete(),10*1e3),this.d.allowListExtensionWhile(t.extension,v.p);const D=t.agent({role:c.ChatMessageRole.User,content:b},{history:p.history.map(A.ChatMessage.to)},new I.$0u(m=>{l(),this.c.$handleProgressChunk(u,{content:d(m.message)?m.message:m.message.value})}),g);try{return await(0,f.$Jg)(Promise.resolve(D).then(m=>{if(m&&"followUp"in m)return{followUp:m?.followUp?.map(r=>A.ChatFollowup.from(r))}}),g)}finally{i=!0,v.complete()}}}e.$Iec=E,E.a=0;function d(R){return!!R&&typeof R=="object"&&"treeData"in R}}),define(Ae[223],Re([1,0,12,19,38,5,48,15,2,147,52,3,8,7,194,22]),function(ee,e,f,C,I,O,A,c,E,d,R,S,u,b,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jec=void 0;class t{constructor(v,D,m){this.i=D,this.j=m,this.b=new Map,this.g=new Map,this.h=new Map,this.d=v.getProxy(S.$qK.MainThreadChatAgents2)}createChatAgent(v,D,m){const n=t.a++,r=new i(v,D,this.d,n,m);return this.b.set(n,r),this.d.$registerAgent(n,D,{}),r.apiAgent}async $invokeAgent(v,D,m,n,r,s){this.g.delete(D);const o=this.b.get(v);if(!o)throw new Error(`[CHAT](${v}) CANNOT invoke agent because the agent is not registered`);let $=!1;function a(){if($)throw new Error("Only valid while executing the command")}const k=new f.$dh;s.onCancellationRequested(()=>k.complete()),setTimeout(()=>k.complete(),10*1e3),this.i.allowListExtensionWhile(o.extension.identifier,k.p);const P=n.command?await o.validateSlashCommand(n.command):void 0,h=A.$Kd.create(!1);let w;try{const y=o.invoke({prompt:n.message,variables:u.ChatVariable.objectTo(n.variables),slashCommand:P},{history:r.history.map(u.ChatMessage.to)},new R.$0u(M=>{a(),typeof w>"u"&&"content"in M&&(w=h.elapsed());const V=u.ChatResponseProgress.from(o.extension,M);if("placeholder"in M&&"resolvedContent"in M){const B=Promise.all([this.d.$handleProgressChunk(m,V),M.resolvedContent]);(0,f.$Jg)(B,s).then(z=>{if(!z)return;const[T,F]=z;this.d.$handleProgressChunk(m,F,T??void 0)})}else this.d.$handleProgressChunk(m,V)}),s);return await(0,f.$Jg)(Promise.resolve(y).then(M=>{if(M){this.g.set(D,M);let V=this.h.get(D);V||(V=new Map,this.h.set(D,V)),V.set(m,M);const B={firstProgress:w,totalElapsed:h.elapsed()};return{errorDetails:M.errorDetails,timings:B}}else this.g.delete(D)}),s)}catch(y){return this.j.error(y,o.extension),{errorDetails:{message:(0,d.localize)(0,null,(0,I.$Bi)(y)),responseIsIncomplete:!0}}}finally{$=!0,k.complete()}}$releaseSession(v){this.g.delete(v),this.h.delete(v)}async $provideSlashCommands(v,D){const m=this.b.get(v);return m?m.provideSlashCommand(D):[]}$provideFollowups(v,D,m){const n=this.b.get(v);if(!n)return Promise.resolve([]);const r=this.g.get(D);return r?n.provideFollowups(r,m):Promise.resolve([])}$acceptFeedback(v,D,m,n){const r=this.b.get(v);if(!r)return;const s=this.h.get(D)?.get(m);if(!s)return;let o;switch(n){case p.InteractiveSessionVoteDirection.Down:o=b.ChatAgentResultFeedbackKind.Unhelpful;break;case p.InteractiveSessionVoteDirection.Up:o=b.ChatAgentResultFeedbackKind.Helpful;break}r.acceptFeedback(Object.freeze({result:s,kind:o}))}$acceptAction(v,D,m,n){const r=this.b.get(v);if(!r)return;const s=this.h.get(D)?.get(m);s&&n.action.kind!=="vote"&&r.acceptAction(Object.freeze({action:n.action,result:s}))}}e.$Jec=t,t.a=0;class i{constructor(v,D,m,n,r){this.extension=v,this.n=D,this.o=m,this.q=n,this.r=r,this.l=new O.$Od,this.m=new O.$Od}acceptFeedback(v){this.l.fire(v)}acceptAction(v){this.m.fire(v)}async validateSlashCommand(v){this.b||(await this.provideSlashCommand(C.CancellationToken.None),(0,c.$Jf)(this.b));const D=this.b.find(m=>m.name===v);if(!D)throw new Error(`Unknown slashCommand: ${v}`);return D}async provideSlashCommand(v){if(!this.a)return[];const D=await this.a.provideSlashCommands(v);return D?(this.b=D,D.map(m=>({name:m.name,description:m.description,followupPlaceholder:m.followupPlaceholder,shouldRepopulate:m.shouldRepopulate}))):[]}async provideFollowups(v,D){if(!this.d)return[];const m=await this.d.provideFollowups(v,D);return m?m.map(n=>u.ChatFollowup.from(n)):[]}get apiAgent(){let v=!1,D=!1;const m=()=>{v||D||(D=!0,queueMicrotask(()=>{this.o.$updateAgent(this.q,{description:this.g??"",fullName:this.h,icon:this.i?this.i instanceof E.URI?this.i:"light"in this.i?this.i.light:void 0:void 0,iconDark:this.i&&"dark"in this.i?this.i.dark:void 0,themeIcon:this.i instanceof b.$mL?this.i:void 0,hasSlashCommands:this.a!==void 0,hasFollowup:this.d!==void 0,isDefault:this.j,isSecondary:this.k}),D=!1}))},n=this;return{get name(){return n.n},get description(){return n.g??""},set description(r){n.g=r,m()},get fullName(){return n.h??n.extension.displayName??n.extension.name},set fullName(r){n.h=r,m()},get iconPath(){return n.i},set iconPath(r){n.i=r,m()},get slashCommandProvider(){return n.a},set slashCommandProvider(r){n.a=r,m()},get followupProvider(){return n.d},set followupProvider(r){n.d=r,m()},get isDefault(){return(0,g.$mF)(n.extension,"defaultChatAgent"),n.j},set isDefault(r){(0,g.$mF)(n.extension,"defaultChatAgent"),n.j=r,m()},get isSecondary(){return(0,g.$mF)(n.extension,"defaultChatAgent"),n.k},set isSecondary(r){(0,g.$mF)(n.extension,"defaultChatAgent"),n.k=r,m()},get onDidReceiveFeedback(){return n.l.event},onDidPerformAction:(0,g.$lF)(this.extension,"chatAgents2Additions")?this.m.event:void 0,dispose(){v=!0,n.a=void 0,n.d=void 0,n.l.dispose(),n.o.$unregisterAgent(n.q)}}}invoke(v,D,m,n){return this.r(v,D,m,n)}}}),define(Ae[224],Re([1,0,19,6,3,8,52,21,12,5]),function(ee,e,f,C,I,O,A,c,E,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dec=void 0;class R{constructor(p,g){this.stream=new E.$hh,this.stream=g??new E.$hh;const t=this;this.apiObj={option:p,response:t.stream.asyncIterable}}}class S{constructor(p,g){this.a=new d.$Od,this.b=new Map,this.c=new E.$hh,this.d=!1;const t=this;this.apiObject={result:p,response:t.c.asyncIterable,onDidStartResponseStream:t.a.event,cancel(){g.cancel()}},p.finally(()=>{if(this.d=!0,this.b.size>0)for(const[,i]of this.b)i.stream.resolve();else this.c.resolve()})}handleFragment(p){if(this.d)return;let g=this.b.get(p.index);g||(this.b.size===0?g=new R(p.index,this.c):g=new R(p.index),this.b.set(p.index,g),this.a.fire(g.apiObj)),g.stream.emitOne(p.part)}}class u{constructor(p,g){this.d=g,this.c=new Map,this.e=new Map,this.f=new c.$0l,this.b=p.getProxy(I.$qK.MainThreadChatProvider)}registerProvider(p,g,t,i){const l=u.a++;return this.c.set(l,{extension:p,provider:t}),this.b.$registerProvider(l,g,{extension:p,displayName:i.name??p.value}),(0,C.$Qc)(()=>{this.b.$unregisterProvider(l),this.c.delete(l)})}async $provideChatResponse(p,g,t,i,l){const v=this.c.get(p);if(!v)return;const D=new A.$0u(async m=>{if(l.isCancellationRequested){this.d.warn(`[CHAT](${v.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}this.b.$handleProgressChunk(g,{index:m.index,part:m.part})});return v.provider.provideChatResponse(t.map(O.ChatMessage.to),i,D,l)}allowListExtensionWhile(p,g){this.f.set(p,g),g.finally(()=>this.f.delete(p))}async requestChatResponseProvider(p,g){if(!this.f.has(p))throw new Error("Extension is NOT allowed to make chat requests");const t=this;return{get isRevoked(){return!t.f.has(p)},makeRequest(i,l,v){if(!t.f.has(p))throw new Error("Access to chat has been revoked");const D=new f.$Yd(v),m=Math.random()*1e6|0,n=t.b.$fetchResponse(p,g,m,i.map(O.ChatMessage.from),l??{},D.token),r=new S(n,D);return t.e.set(m,{res:r}),n.finally(()=>{t.e.delete(m)}),r.apiObject}}}async $handleResponseFragment(p,g){const t=this.e.get(p);t&&t.res.handleFragment(g)}}e.$Dec=u,u.a=1}),define(Ae[225],Re([1,0,6,3,11,8]),function(ee,e,f,C,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fec=void 0;class A{constructor(E){this.b=new Map,this.c=E.getProxy(C.$qK.MainThreadChatVariables)}async $resolveVariable(E,d,R){const S=this.b.get(E);if(S)try{const u=await S.resolver.resolve(S.data.name,{message:d},R);if(u)return u.map(O.ChatVariable.from)}catch(u){(0,I.$2)(u)}}registerVariableResolver(E,d,R,S){const u=A.a++;return this.b.set(u,{extension:E.identifier,data:{name:d,description:R},resolver:S}),this.c.$registerVariable(u,{name:d,description:R}),(0,f.$Qc)(()=>{this.b.delete(u),this.c.$unregisterVariable(u)})}}e.$Fec=A,A.a=0}),define(Ae[226],Re([1,0,3]),function(ee,e,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ncc=void 0;class C{constructor(O){const A=O.getProxy(f.$qK.MainThreadClipboard);this.value=Object.freeze({readText(){return A.$readText()},writeText(c){return A.$writeText(c)}})}}e.$Ncc=C});var Xe=this&&this.__classPrivateFieldSet||function(ee,e,f,C,I){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!I:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?I.call(ee,f):I?I.value=f:e.set(ee,f),f},Ne=this&&this.__classPrivateFieldGet||function(ee,e,f,C){if(f==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!C:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return f==="m"?C:f==="a"?C.call(ee):C?C.value:e.get(ee)};define(Ae[31],Re([1,0,15,7,8,25,3,18,14,67,41,282,2,6,4,17,105,26,47,38,48,55,59]),function(ee,e,f,C,I,O,A,c,E,d,R,S,u,b,p,g,t,i,l,v,D,m,n){"use strict";var r,s,o;Object.defineProperty(e,"__esModule",{value:!0}),e.$RM=e.$QM=e.$PM=e.$OM=e.$NM=e.$MM=void 0;let $=class{constructor(y,M,V){r.set(this,void 0),this.b=new Map,this.c=new Map,s.set(this,void 0),o.set(this,void 0),Xe(this,r,y.getProxy(A.$qK.MainThreadCommands),"f"),this.d=M,Xe(this,o,V,"f"),Xe(this,s,y.getProxy(A.$qK.MainThreadTelemetry),"f"),this.converter=new a(this,B=>{const z=this.c.get(B);return z?.result===P.Void?z:void 0},M),this.f=[{processArgument(B){return(0,d.$nh)(B)}},{processArgument(B){return(0,O.$$m)(B,function(z){if(R.$ys.isIRange(z))return I.Range.to(z);if(S.$xs.isIPosition(z))return I.Position.to(z);if(R.$ys.isIRange(z.range)&&u.URI.isUri(z.uri))return I.location.to(z);if(z instanceof i.$ce)return z.buffer.buffer;if(!Array.isArray(z))return z})}}]}registerArgumentProcessor(y){this.f.push(y)}registerApiCommand(y){const M=this.registerCommand(!1,y.id,async(...V)=>{const B=y.args.map((T,F)=>{if(!T.validate(V[F]))throw new Error(`Invalid argument '${T.name}' when running '${y.id}', received: ${typeof V[F]=="object"?JSON.stringify(V[F],null,"	"):V[F]} `);return T.convert(V[F])}),z=await this.executeCommand(y.internalId,...B);return y.result.convert(z,V,this.converter)},void 0,{description:y.description,args:y.args,returns:y.result.description});return this.c.set(y.id,y),new C.$sK(()=>{M.dispose(),this.c.delete(y.id)})}registerCommand(y,M,V,B,z,T){if(this.d.trace("ExtHostCommands#registerCommand",M),!M.trim().length)throw new Error("invalid id");if(this.b.has(M))throw new Error(`command '${M}' already exists`);return this.b.set(M,{callback:V,thisArg:B,metadata:z,extension:T}),y&&Ne(this,r,"f").$registerCommand(M),new C.$sK(()=>{this.b.delete(M)&&y&&Ne(this,r,"f").$unregisterCommand(M)})}executeCommand(y,...M){return this.d.trace("ExtHostCommands#executeCommand",y),this.g(y,M,!0)}async g(y,M,V){if(this.b.has(y))return Ne(this,r,"f").$fireCommandActivationEvent(y),this.h(y,M,!1);{let B=!1;const z=(0,O.$$m)(M,function(T){if(T instanceof C.$tK)return I.Position.from(T);if(T instanceof C.$uK)return I.Range.from(T);if(T instanceof C.$EK)return I.location.from(T);if(C.$PL.isNotebookRange(T))return I.NotebookRange.from(T);if(T instanceof ArrayBuffer)return B=!0,i.$ce.wrap(new Uint8Array(T));if(T instanceof Uint8Array)return B=!0,i.$ce.wrap(T);if(T instanceof i.$ce)return B=!0,T;if(!Array.isArray(T))return T});try{const T=await Ne(this,r,"f").$executeCommand(y,B?new l.$vv(z):z,V);return(0,d.$nh)(T)}catch(T){if(T instanceof Error&&T.message==="$executeCommand:retry")return this.g(y,M,!1);throw T}}}async h(y,M,V){const B=this.b.get(y);if(!B)throw new Error("Unknown command");const{callback:z,thisArg:T,metadata:F}=B;if(F?.args)for(let q=0;q<F.args.length;q++)try{(0,f.$Qf)(M[q],F.args[q].constraint)}catch{throw new Error(`Running the contributed command: '${y}' failed. Illegal argument '${F.args[q].name}' - ${F.args[q].description}`)}const j=D.$Kd.create();try{return await z.apply(T,M)}catch(q){if(y===this.converter.delegatingCommandId){const W=this.converter.getActualCommand(...M);W&&(y=W.command)}if(this.d.error(q,y,B.extension?.identifier),!V)throw q;if(B.extension?.identifier){const W=Ne(this,o,"f").onExtensionError(B.extension.identifier,q);this.d.trace("forwarded error to extension?",W,B.extension?.identifier)}throw new class extends Error{constructor(){super((0,v.$Bi)(q)),this.id=y,this.source=B.extension?.displayName??B.extension?.name}}}finally{this.j(B,y,j.elapsed())}}j(y,M,V){y.extension&&Ne(this,s,"f").$publicLog2("Extension:ActionExecuted",{extensionId:y.extension.identifier.value,id:new m.$oo(M),duration:V})}$executeContributedCommand(y,...M){this.d.trace("ExtHostCommands#$executeContributedCommand",y);const V=this.b.get(y);return V?(M=M.map(B=>this.f.reduce((z,T)=>T.processArgument(z,V.extension?.identifier),B)),this.h(y,M,!0)):Promise.reject(new Error(`Contributed command '${y}' does not exist.`))}getCommands(y=!1){return this.d.trace("ExtHostCommands#getCommands",y),Ne(this,r,"f").$getCommands().then(M=>(y&&(M=M.filter(V=>V[0]!=="_")),M))}$getContributedCommandMetadata(){const y=Object.create(null);for(const[M,V]of this.b){const{metadata:B}=V;B&&(y[M]=B)}return Promise.resolve(y)}};e.$MM=$,r=new WeakMap,s=new WeakMap,o=new WeakMap,e.$MM=$=Ge([qe(0,g.$rM),qe(1,E.$$i),qe(2,n.$LM)],$),e.$NM=(0,p.$Qh)("IExtHostCommands");class a{constructor(y,M,V){this.d=y,this.f=M,this.g=V,this.delegatingCommandId=`__vsc${Date.now().toString(36)} `,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(y,M){if(!y)return;const V={$ident:void 0,id:y.command,title:y.title,tooltip:y.tooltip};if(!y.command)return V;const B=this.f(y.command);if(B)V.id=B.internalId,V.arguments=B.args.map((z,T)=>z.convert(y.arguments&&y.arguments[T]));else if((0,c.$Lb)(y.arguments)){const z=`${y.command} /${++this.c}`;this.b.set(z,y),M.add((0,b.$Qc)(()=>{this.b.delete(z),this.g.trace("CommandsConverter#DISPOSE",z)})),V.$ident=z,V.id=this.delegatingCommandId,V.arguments=[z],this.g.trace("CommandsConverter#CREATE",y.command,z)}return V}fromInternal(y){return typeof y.$ident=="string"?this.b.get(y.$ident):{command:y.id,title:y.title,arguments:y.arguments}}getActualCommand(...y){return this.b.get(y[0])}h(...y){const M=this.getActualCommand(...y);return this.g.trace("CommandsConverter#EXECUTE",y[0],M?M.command:"MISSING"),M?this.d.executeCommand(M.command,...M.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${y[0]}`)}}e.$OM=a;class k{static Arr(y){return new k(`${y.name}_array`,`Array of ${y.name}, ${y.description}`,M=>Array.isArray(M)&&M.every(V=>y.validate(V)),M=>M.map(V=>y.convert(V)))}constructor(y,M,V,B){this.name=y,this.description=M,this.validate=V,this.convert=B}optional(){return new k(this.name,`(optional) ${this.description}`,y=>y==null||this.validate(y),y=>y===void 0?void 0:y===null?null:this.convert(y))}with(y,M){return new k(y??this.name,M??this.description,this.validate,this.convert)}}e.$PM=k,k.Uri=new k("uri","Uri of a text document",w=>u.URI.isUri(w),w=>w),k.Position=new k("position","A position in a text document",w=>C.$tK.isPosition(w),I.Position.from),k.Range=new k("range","A range in a text document",w=>C.$uK.isRange(w),I.Range.from),k.Selection=new k("selection","A selection in a text document",w=>C.$vK.isSelection(w),I.Selection.from),k.Number=new k("number","",w=>typeof w=="number",w=>w),k.String=new k("string","",w=>typeof w=="string",w=>w),k.StringArray=k.Arr(k.String),k.CallHierarchyItem=new k("item","A call hierarchy item",w=>w instanceof C.$OK,I.CallHierarchyItem.from),k.TypeHierarchyItem=new k("item","A type hierarchy item",w=>w instanceof C.$9L,I.TypeHierarchyItem.from),k.TestItem=new k("testItem","A VS Code TestItem",w=>w instanceof t.$EM,I.TestItem.from);class P{constructor(y,M){this.description=y,this.convert=M}}e.$QM=P,P.Void=new P("no result",w=>w);class h{constructor(y,M,V,B,z){this.id=y,this.internalId=M,this.description=V,this.args=B,this.result=z}}e.$RM=h}),define(Ae[227],Re([1,0,18,13,2,79,91,32,95,31,8,7]),function(ee,e,f,C,I,O,A,c,E,d,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mcc=void 0;const u=[new d.$RM("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[d.$PM.Uri,d.$PM.Position],new d.$QM("A promise that resolves to an array of DocumentHighlight-instances.",p(R.DocumentHighlight.to))),new d.$RM("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[d.$PM.Uri],new d.$QM("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(t,i)=>{if((0,f.$Kb)(t))return;class l extends S.$JK{static to(D){const m=new l(D.name,R.SymbolKind.to(D.kind),D.containerName||"",new S.$EK(i[0],R.Range.to(D.range)));return m.detail=D.detail,m.range=m.location.range,m.selectionRange=R.Range.to(D.selectionRange),m.children=D.children?D.children.map(l.to):[],m}}return t.map(l.to)})),new d.$RM("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[d.$PM.Uri,new d.$PM("options","Formatting options",t=>!0,t=>t)],new d.$QM("A promise that resolves to an array of TextEdits.",p(R.TextEdit.to))),new d.$RM("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[d.$PM.Uri,d.$PM.Range,new d.$PM("options","Formatting options",t=>!0,t=>t)],new d.$QM("A promise that resolves to an array of TextEdits.",p(R.TextEdit.to))),new d.$RM("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[d.$PM.Uri,d.$PM.Position,new d.$PM("ch","Trigger character",t=>typeof t=="string",t=>t),new d.$PM("options","Formatting options",t=>!0,t=>t)],new d.$QM("A promise that resolves to an array of TextEdits.",p(R.TextEdit.to))),new d.$RM("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[d.$PM.Uri,d.$PM.Position],new d.$QM("A promise that resolves to an array of Location or LocationLink instances.",g)),new d.$RM("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[d.$PM.Uri,d.$PM.Position],new d.$QM("A promise that resolves to an array of Location or LocationLink instances.",g)),new d.$RM("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[d.$PM.Uri,d.$PM.Position],new d.$QM("A promise that resolves to an array of Location or LocationLink instances.",g)),new d.$RM("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[d.$PM.Uri,d.$PM.Position],new d.$QM("A promise that resolves to an array of Location or LocationLink instances.",g)),new d.$RM("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[d.$PM.Uri,d.$PM.Position],new d.$QM("A promise that resolves to an array of Location-instances.",p(R.location.to))),new d.$RM("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[d.$PM.Uri,d.$PM.Position],new d.$QM("A promise that resolves to an array of Hover-instances.",p(R.Hover.to))),new d.$RM("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[d.$PM.Uri,new d.$PM("position","A position in a text document",t=>Array.isArray(t)&&t.every(i=>S.$tK.isPosition(i)),t=>t.map(R.Position.from))],new d.$QM("A promise that resolves to an array of ranges.",t=>t.map(i=>{let l;for(const v of i.reverse())l=new S.$NK(R.Range.to(v),l);return l}))),new d.$RM("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[d.$PM.String.with("query","Search string")],new d.$QM("A promise that resolves to an array of SymbolInformation-instances.",t=>t.map(R.WorkspaceSymbol.to))),new d.$RM("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[d.$PM.Uri,d.$PM.Position],new d.$QM("A promise that resolves to an array of CallHierarchyItem-instances",t=>t.map(R.CallHierarchyItem.to))),new d.$RM("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[d.$PM.CallHierarchyItem],new d.$QM("A promise that resolves to an array of CallHierarchyIncomingCall-instances",t=>t.map(R.CallHierarchyIncomingCall.to))),new d.$RM("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[d.$PM.CallHierarchyItem],new d.$QM("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",t=>t.map(R.CallHierarchyOutgoingCall.to))),new d.$RM("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[d.$PM.Uri,d.$PM.Position],new d.$QM("A promise that resolves to a range and placeholder text.",t=>{if(t)return{range:R.Range.to(t.range),placeholder:t.text}})),new d.$RM("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[d.$PM.Uri,d.$PM.Position,d.$PM.String.with("newName","The new symbol name")],new d.$QM("A promise that resolves to a WorkspaceEdit.",t=>{if(t){if(t.rejectReason)throw new Error(t.rejectReason);return R.WorkspaceEdit.to(t)}})),new d.$RM("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[d.$PM.Uri,d.$PM.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new d.$QM("A promise that resolves to an array of DocumentLink-instances.",t=>t.map(R.DocumentLink.to))),new d.$RM("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[d.$PM.Uri],new d.$QM("A promise that resolves to SemanticTokensLegend.",t=>{if(t)return new S.$HL(t.tokenTypes,t.tokenModifiers)})),new d.$RM("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[d.$PM.Uri],new d.$QM("A promise that resolves to SemanticTokens.",t=>{if(!t)return;const i=(0,A.$c$)(t);if(i.type==="full")return new S.$JL(i.data,void 0)})),new d.$RM("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[d.$PM.Uri,d.$PM.Range.optional()],new d.$QM("A promise that resolves to SemanticTokensLegend.",t=>{if(t)return new S.$HL(t.tokenTypes,t.tokenModifiers)})),new d.$RM("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[d.$PM.Uri,d.$PM.Range],new d.$QM("A promise that resolves to SemanticTokens.",t=>{if(!t)return;const i=(0,A.$c$)(t);if(i.type==="full")return new S.$JL(i.data,void 0)})),new d.$RM("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[d.$PM.Uri,d.$PM.Position,d.$PM.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),d.$PM.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new d.$QM("A promise that resolves to a CompletionList-instance.",(t,i,l)=>{if(!t)return new S.$ZK([]);const v=t.suggestions.map(D=>R.CompletionItem.to(D,l));return new S.$ZK(v,t.incomplete)})),new d.$RM("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[d.$PM.Uri,d.$PM.Position,d.$PM.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new d.$QM("A promise that resolves to SignatureHelp.",t=>{if(t)return R.SignatureHelp.to(t)})),new d.$RM("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[d.$PM.Uri,d.$PM.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new d.$QM("A promise that resolves to an array of CodeLens-instances.",(t,i,l)=>p(v=>new S.$RK(R.Range.to(v.range),v.command&&l.fromInternal(v.command)))(t))),new d.$RM("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[d.$PM.Uri,new d.$PM("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",t=>S.$uK.isRange(t),t=>S.$vK.isSelection(t)?R.Selection.from(t):R.Range.from(t)),d.$PM.String.with("kind","Code action kind to return code actions for").optional(),d.$PM.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new d.$QM("A promise that resolves to an array of Command-instances.",(t,i,l)=>p(v=>{if(v._isSynthetic){if(!v.command)throw new Error("Synthetic code actions must have a command");return l.fromInternal(v.command)}else{const D=new S.$LK(v.title,v.kind?new S.$MK(v.kind):void 0);return v.edit&&(D.edit=R.WorkspaceEdit.to(v.edit)),v.command&&(D.command=l.fromInternal(v.command)),D.isPreferred=v.isPreferred,D}})(t))),new d.$RM("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[d.$PM.Uri],new d.$QM("A promise that resolves to an array of ColorInformation objects.",t=>t?t.map(i=>new S.$6K(R.Range.to(i.range),R.Color.to(i.color))):[])),new d.$RM("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new d.$PM("color","The color to show and insert",t=>t instanceof S.$5K,R.Color.from),new d.$PM("context","Context object with uri and range",t=>!0,t=>({uri:t.uri,range:R.Range.from(t.range)}))],new d.$QM("A promise that resolves to an array of ColorPresentation objects.",t=>t?t.map(R.ColorPresentation.to):[])),new d.$RM("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[d.$PM.Uri,d.$PM.Range],new d.$QM("A promise that resolves to an array of Inlay objects",(t,i,l)=>t.map(R.InlayHint.to.bind(void 0,l)))),new d.$RM("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[d.$PM.Uri],new d.$QM("A promise that resolves to an array of FoldingRange objects",(t,i)=>{if(t)return t.map(R.FoldingRange.to)})),new d.$RM("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new d.$QM("A promise that resolves to an array of NotebookContentProvider static info objects.",p(t=>({viewType:t.viewType,displayName:t.displayName,options:{transientOutputs:t.options.transientOutputs,transientCellMetadata:t.options.transientCellMetadata,transientDocumentMetadata:t.options.transientDocumentMetadata},filenamePattern:t.filenamePattern.map(i=>R.NotebookExclusiveDocumentPattern.to(i))})))),new d.$RM("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[d.$PM.Uri,d.$PM.Range,new d.$PM("context","An InlineValueContext",t=>t&&typeof t.frameId=="number"&&t.stoppedLocation instanceof S.$uK,t=>R.InlineValueContext.from(t))],new d.$QM("A promise that resolves to an array of InlineValue objects",t=>t.map(R.InlineValue.to))),new d.$RM("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new d.$PM("uriOrString","Uri-instance or string (only http/https)",t=>I.URI.isUri(t)||typeof t=="string"&&(0,E.$xU)(t,C.Schemas.http,C.Schemas.https),t=>t),new d.$PM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="number"||typeof t=="object",t=>t&&(typeof t=="number"?[R.ViewColumn.from(t),void 0]:[R.ViewColumn.from(t.viewColumn),R.TextEditorOpenOptions.from(t)])).optional(),d.$PM.String.with("label","").optional()],d.$QM.Void),new d.$RM("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[d.$PM.Uri.with("resource","Resource to open"),d.$PM.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new d.$PM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="number"||typeof t=="object",t=>t&&(typeof t=="number"?[R.ViewColumn.from(t),void 0]:[R.ViewColumn.from(t.viewColumn),R.TextEditorOpenOptions.from(t)])).optional()],d.$QM.Void),new d.$RM("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[d.$PM.Uri.with("left","Left-hand side resource of the diff editor"),d.$PM.Uri.with("right","Right-hand side resource of the diff editor"),d.$PM.String.with("title","Human readable title for the diff editor").optional(),new d.$PM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="object",t=>t&&[R.ViewColumn.from(t.viewColumn),R.TextEditorOpenOptions.from(t)]).optional()],d.$QM.Void),new d.$RM("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[d.$PM.Uri,d.$PM.Position],new d.$QM("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(R.TypeHierarchyItem.to))),new d.$RM("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[d.$PM.TypeHierarchyItem],new d.$QM("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(R.TypeHierarchyItem.to))),new d.$RM("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[d.$PM.TypeHierarchyItem],new d.$QM("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(R.TypeHierarchyItem.to))),new d.$RM("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[d.$PM.TestItem],d.$QM.Void),new d.$RM("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[d.$PM.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],d.$QM.Void),new d.$RM("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[d.$PM.String.with("name","The context key name"),new d.$PM("value","The context key value",()=>!0,t=>t)],d.$QM.Void),new d.$RM("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[d.$PM.Uri,d.$PM.StringArray,new d.$PM("MappedEditsContext","Mapped Edits Context",t=>R.MappedEditsContext.is(t),t=>R.MappedEditsContext.from(t))],new d.$QM("A promise that resolves to a workspace edit or null",t=>t?R.WorkspaceEdit.to(t):null))];class b{static register(i){u.forEach(i.registerApiCommand,i),this.a(i)}static a(i){i.registerCommand(!1,"_validateWhenClauses",c.$Pi)}}e.$Mcc=b;function p(t){return i=>{if(Array.isArray(i))return i.map(t)}}function g(t){if(!Array.isArray(t))return;const i=[];for(const l of t)O.$jt(l)?i.push(R.DefinitionLink.to(l)):i.push(R.location.to(l));return i}}),define(Ae[228],Re([1,0,12,65,5,6,2,79,21,8,7,3,22]),function(ee,e,f,C,I,O,A,c,E,d,R,S,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Occ=void 0;function b(p,g,t){const i=p.getProxy(S.$qK.MainThreadComments);class l{constructor(){this.b=new Map,this.c=new E.$0l,g.registerArgumentProcessor({processArgument:a=>{if(a&&a.$mid===6){const k=this.b.get(a.handle);return k?k.value:a}else if(a&&a.$mid===7){const k=this.b.get(a.commentControlHandle);if(!k)return a;const P=k.getCommentThread(a.commentThreadHandle);return P?P.value:a}else if(a&&(a.$mid===9||a.$mid===8)){const k=this.b.get(a.thread.commentControlHandle);if(!k)return a;const P=k.getCommentThread(a.thread.commentThreadHandle);return P?a.$mid===8?P.value:{thread:P.value,text:a.text}:a}else if(a&&a.$mid===10){const k=this.b.get(a.thread.commentControlHandle);if(!k)return a;const P=k.getCommentThread(a.thread.commentThreadHandle);if(!P)return a;const h=a.commentUniqueId,w=P.getCommentByUniqueId(h);return w||a}else if(a&&a.$mid===11){const k=this.b.get(a.thread.commentControlHandle);if(!k)return a;const P=k.getCommentThread(a.thread.commentThreadHandle);if(!P)return a;const h=a.text,w=a.commentUniqueId,y=P.getCommentByUniqueId(w);return y?(typeof y.body=="string"?y.body=h:y.body=new R.$SK(h),y):a}return a}})}createCommentController(a,k,P){const h=l.a++,w=new D(a,h,k,P);this.b.set(w.handle,w);const y=this.c.get(a.identifier)||[];return y.push(w),this.c.set(a.identifier,y),w.value}async $createCommentThreadTemplate(a,k,P){const h=this.b.get(a);h&&h.$createCommentThreadTemplate(k,P)}async $updateCommentThreadTemplate(a,k,P){const h=this.b.get(a);h&&h.$updateCommentThreadTemplate(k,P)}$deleteCommentThread(a,k){this.b.get(a)?.$deleteCommentThread(k)}$provideCommentingRanges(a,k,P){const h=this.b.get(a);if(!h||!h.commentingRangeProvider)return Promise.resolve(void 0);const w=t.getDocument(A.URI.revive(k));return(0,f.$Ng)(async()=>{const y=await h.commentingRangeProvider.provideCommentingRanges(w,P);let M;return Array.isArray(y)?M={ranges:y,fileComments:!1}:y?M={ranges:y.ranges||[],fileComments:y.fileComments||!1}:M=y??void 0,M}).then(y=>{let M;return y&&(M={ranges:y.ranges.map(V=>d.Range.from(V)),fileComments:y.fileComments}),M})}$toggleReaction(a,k,P,h,w){const y=this.b.get(a);return!y||!y.reactionHandler?Promise.resolve(void 0):(0,f.$Ng)(()=>{const M=y.getCommentThread(k);if(M){const V=M.getCommentByUniqueId(h.uniqueIdInThread);if(y!==void 0&&V&&y.reactionHandler)return y.reactionHandler(V,r(w))}return Promise.resolve(void 0)})}}l.a=0;class v{set threadId(a){this.n=a}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(a){(a===void 0!=(this.p===void 0)||!a||!this.p||!a.isEqual(this.p))&&(this.p=a,this.b.range=a,this.c.fire())}get range(){return this.p}set canReply(a){this.d!==a&&(this.d=a,this.b.canReply=a,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(a){this.e=a,this.b.label=a,this.c.fire()}get contextValue(){return this.f}set contextValue(a){this.f=a,this.b.contextValue=a,this.c.fire()}get comments(){return this.q}set comments(a){this.q=a,this.b.comments=a,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(a){this.g=a,this.b.collapsibleState=a,this.c.fire()}get state(){return this.h}set state(a){this.h=a,this.b.state=a,this.c.fire()}get isDisposed(){return this.j}constructor(a,k,P,h,w,y,M,V){this.m=k,this.n=P,this.o=h,this.p=w,this.q=y,this.extensionDescription=M,this.r=V,this.handle=v.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new I.$Od,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new O.$Tc,this.l.value=new O.$Rc,this.n===void 0&&(this.n=`${a}.${this.handle}`),i.$createCommentThread(k,this.handle,this.n,this.o,d.Range.from(this.p),M.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=y,this.i.push({dispose:()=>{i.$deleteCommentThread(k,this.handle)}});const B=this;this.value={get uri(){return B.uri},get range(){return B.range},set range(z){B.range=z},get comments(){return B.comments},set comments(z){B.comments=z},get collapsibleState(){return B.collapsibleState},set collapsibleState(z){B.collapsibleState=z},get canReply(){return B.canReply},set canReply(z){B.canReply=z},get contextValue(){return B.contextValue},set contextValue(z){B.contextValue=z},get label(){return B.label},set label(z){B.label=z},get state(){return B.state},set state(z){B.state=z},dispose:()=>{B.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new O.$Rc);const a=P=>Object.prototype.hasOwnProperty.call(this.b,P),k={};a("range")&&(k.range=d.Range.from(this.p)),a("label")&&(k.label=this.label),a("contextValue")&&(k.contextValue=this.contextValue??null),a("comments")&&(k.comments=this.q.map(P=>m(this,P,this.k,this.extensionDescription))),a("collapsibleState")&&(k.collapseState=s(this.g)),a("canReply")&&(k.canReply=this.canReply),a("state")&&(k.state=o(this.h)),a("isTemplate")&&(k.isTemplate=this.r),this.b={},i.$updateCommentThread(this.m,this.handle,this.n,this.o,k)}getCommentByUniqueId(a){for(const k of this.k){const P=k[0],h=k[1];if(a===h)return P}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(a=>a.dispose())}}v.a=0,Ge([(0,C.$jh)(100)],v.prototype,"eventuallyUpdateCommentThread",null);class D{get id(){return this.h}get label(){return this.i}get handle(){return this.g}get commentingRangeProvider(){return this.b}set commentingRangeProvider(a){this.b=a,i.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(a){this.c=a,i.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!a})}get options(){return this.d}set options(a){this.d=a,i.$updateCommentControllerFeatures(this.handle,{options:this.d})}constructor(a,k,P,h){this.f=a,this.g=k,this.h=P,this.i=h,this.a=new Map,i.$registerCommentController(this.handle,P,h,this.f.identifier.value);const w=this;this.value=Object.freeze({id:w.id,label:w.label,get options(){return w.options},set options(y){w.options=y},get commentingRangeProvider(){return w.commentingRangeProvider},set commentingRangeProvider(y){w.commentingRangeProvider=y},get reactionHandler(){return w.reactionHandler},set reactionHandler(y){w.reactionHandler=y},createCommentThread(y,M,V){return w.createCommentThread(y,M,V).value},dispose:()=>{w.dispose()}}),this.e=[],this.e.push({dispose:()=>{i.$unregisterCommentController(this.handle)}})}createCommentThread(a,k,P){k===void 0&&(0,u.$mF)(this.f,"fileComments");const h=new v(this.id,this.handle,void 0,a,k,P,this.f,!1);return this.a.set(h.handle,h),h}$createCommentThreadTemplate(a,k){const P=new v(this.id,this.handle,void 0,A.URI.revive(a),d.Range.to(k),[],this.f,!0);return P.collapsibleState=c.CommentThreadCollapsibleState.Expanded,this.a.set(P.handle,P),P}$updateCommentThreadTemplate(a,k){const P=this.a.get(a);P&&(P.range=d.Range.to(k))}$deleteCommentThread(a){this.a.get(a)?.dispose(),this.a.delete(a)}getCommentThread(a){return this.a.get(a)}dispose(){this.a.forEach(a=>{a.dispose()}),this.e.forEach(a=>a.dispose())}}function m($,a,k,P){let h=k.get(a);return h||(h=++$.commentHandle,k.set(a,h)),a.state!==void 0&&(0,u.$mF)(P,"commentsDraftState"),{mode:a.mode,contextValue:a.contextValue,uniqueIdInThread:h,body:typeof a.body=="string"?a.body:d.MarkdownString.from(a.body),userName:a.author.name,userIconPath:a.author.iconPath,label:a.label,commentReactions:a.reactions?a.reactions.map(w=>n(w)):void 0,state:a.state,timestamp:a.timestamp?.toJSON()}}function n($){return{label:$.label,iconPath:$.iconPath?d.$qM($.iconPath):void 0,count:$.count,hasReacted:$.authorHasReacted}}function r($){return{label:$.label||"",count:$.count||0,iconPath:$.iconPath?A.URI.revive($.iconPath):"",authorHasReacted:$.hasReacted||!1}}function s($){if($!==void 0)switch($){case R.CommentThreadCollapsibleState.Expanded:return c.CommentThreadCollapsibleState.Expanded;case R.CommentThreadCollapsibleState.Collapsed:return c.CommentThreadCollapsibleState.Collapsed}return c.CommentThreadCollapsibleState.Collapsed}function o($){if($!==void 0)switch($){case R.CommentThreadState.Unresolved:return c.CommentThreadState.Unresolved;case R.CommentThreadState.Resolved:return c.CommentThreadState.Resolved}return c.CommentThreadState.Unresolved}return new l}e.$Occ=b}),define(Ae[229],Re([1,0,25,3,27,17]),function(ee,e,f,C,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mec=void 0;let A=class{constructor(R,S){this.a=R.getProxy(C.$qK.MainThreadConsole),this.b=S.consoleForward.includeStack,this.c=S.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("error","error")}d(R,S){const u=this,b=console[R];Object.defineProperty(console,R,{set:()=>{},get:()=>function(){u.e(R,S,b,arguments)}})}e(R,S,u,b){this.a.$logExtensionHostMessage({type:"__$console",severity:S,arguments:E(b,this.b)}),this.c&&this.f(R,u,b)}};e.$Mec=A,e.$Mec=A=Ge([qe(0,O.$rM),qe(1,I.$HM)],A);const c=1e5;function E(d,R){const S=[];if(d.length)for(let u=0;u<d.length;u++){let b=d[u];if(typeof b>"u")b="undefined";else if(b instanceof Error){const p=b;p.stack?b=p.stack:b=p.toString()}S.push(b)}if(R){const u=new Error().stack;u&&S.push({__$stack:u.split(`
`).slice(3).join(`
`)})}try{const u=(0,f.$bn)(S);return u.length>c?"Output omitted for a large object that exceeds the limits":u}catch(u){return`Output omitted for an object that cannot be inspected ('${u.toString()}')`}}}),define(Ae[107],Re([1,0,2,3,7,4,17,14,18,16,20,22]),function(ee,e,f,C,I,O,A,c,E,d,R,S){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.$Qdc=e.$Pdc=void 0;let b=u=class{constructor(g,t){this.h=t,this.f=new Map,this.g=g.getProxy(C.$qK.MainThreadDecorations)}registerFileDecorationProvider(g,t){const i=u.c++;this.f.set(i,{provider:g,extensionDescription:t}),this.g.$registerDecorationProvider(i,t.identifier.value);const l=g.onDidChangeFileDecorations&&g.onDidChangeFileDecorations(v=>{if(!v){this.g.$onDidChange(i,null);return}const D=(0,E.$3b)(v);if(D.length<=u.d){this.g.$onDidChange(i,D);return}this.h.warn("[Decorations] CAPPING events from decorations provider",t.identifier.value,D.length);const m=D.map(s=>({uri:s,rank:(0,d.$He)(s.path,"/")})),n=(0,E.$zb)(m,(s,o)=>s.rank-o.rank||(0,d.$Ve)(s.uri.path,o.uri.path)),r=[];e:for(const s of n){let o;for(const $ of s){const a=(0,R.$mc)($.uri.path);if(o!==a&&(o=a,r.push($.uri)>=u.d))break e}}this.g.$onDidChange(i,r)});return new I.$sK(()=>{l?.dispose(),this.g.$unregisterDecorationProvider(i),this.f.delete(i)})}async $provideDecorations(g,t,i){if(!this.f.has(g))return Object.create(null);const l=Object.create(null),{provider:v,extensionDescription:D}=this.f.get(g);return await Promise.all(t.map(async m=>{try{const{uri:n,id:r}=m,s=await Promise.resolve(v.provideFileDecoration(f.URI.revive(n),i));if(!s)return;try{I.$NL.validate(s),s.badge&&typeof s.badge!="string"&&(0,S.$mF)(D,"codiconDecoration"),l[r]=[s.propagate,s.tooltip,s.badge,s.color]}catch(o){this.h.warn(`INVALID decoration from extension '${D.identifier.value}': ${o}`)}}catch(n){this.h.error(n)}})),l}};e.$Pdc=b,b.c=0,b.d=250,e.$Pdc=b=u=Ge([qe(0,A.$rM),qe(1,c.$$i)],b),e.$Qdc=(0,O.$Qh)("IExtHostDecorations")});var Xe=this&&this.__classPrivateFieldSet||function(ee,e,f,C,I){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!I:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?I.call(ee,f):I?I.value=f:e.set(ee,f),f},Ne=this&&this.__classPrivateFieldGet||function(ee,e,f,C){if(f==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!C:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return f==="m"?C:f==="a"?C.call(ee):C?C.value:e.get(ee)};define(Ae[230],Re([1,0,148,94,2,3,7,8,5,14,28,40]),function(ee,e,f,C,I,O,A,c,E,d,R,S){"use strict";var u,b,p,g;Object.defineProperty(e,"__esModule",{value:!0}),e.$Hcc=e.$Gcc=void 0;class t{constructor(v,D,m,n,r,s,o,$){this.d=v,this.e=D,this.f=m,this.g=n,this.h=r,u.set(this,void 0),b.set(this,void 0),p.set(this,void 0),this.c=!1,this.f=Math.max(n,m),Xe(this,p,new R.$Ac(a=>s.getComparisonKey(a)),"f"),Xe(this,u,o,"f"),Xe(this,b,$,"f")}dispose(){this.c||(Ne(this,b,"f").fire([...Ne(this,p,"f").keys()]),Ne(this,u,"f")?.$clear(this.e),Ne(this,p,"f").clear(),this.c=!0)}get name(){return this.j(),this.d}set(v,D){if(!v){this.clear();return}this.j();let m=[];if(I.URI.isUri(v)){if(!D){this.delete(v);return}Ne(this,p,"f").set(v,D.slice()),m=[v]}else if(Array.isArray(v)){m=[];let s;v=[...v].sort(t.k);for(const o of v){const[$,a]=o;if((!s||$.toString()!==s.toString())&&(s&&Ne(this,p,"f").get(s).length===0&&Ne(this,p,"f").delete(s),s=$,m.push($),Ne(this,p,"f").set($,[])),a)Ne(this,p,"f").get($)?.push(...a);else{const k=Ne(this,p,"f").get($);k&&(k.length=0)}}}if(Ne(this,b,"f").fire(m),!Ne(this,u,"f"))return;const n=[];let r=0;for(const s of m){let o=[];const $=Ne(this,p,"f").get(s);if($)if($.length>this.g){o=[];const a=[A.DiagnosticSeverity.Error,A.DiagnosticSeverity.Warning,A.DiagnosticSeverity.Information,A.DiagnosticSeverity.Hint];e:for(let k=0;k<4;k++)for(const P of $)if(P.severity===a[k]&&o.push({...c.Diagnostic.from(P),modelVersionId:this.h(s)})===this.g)break e;o.push({severity:C.MarkerSeverity.Info,message:(0,f.localize)(0,null,$.length-this.g),startLineNumber:o[o.length-1].startLineNumber,startColumn:o[o.length-1].startColumn,endLineNumber:o[o.length-1].endLineNumber,endColumn:o[o.length-1].endColumn})}else o=$.map(a=>({...c.Diagnostic.from(a),modelVersionId:this.h(s)}));if(n.push([s,o]),r+=o.length,r>this.f)break}Ne(this,u,"f").$changeMany(this.e,n)}delete(v){this.j(),Ne(this,b,"f").fire([v]),Ne(this,p,"f").delete(v),Ne(this,u,"f")?.$changeMany(this.e,[[v,void 0]])}clear(){this.j(),Ne(this,b,"f").fire([...Ne(this,p,"f").keys()]),Ne(this,p,"f").clear(),Ne(this,u,"f")?.$clear(this.e)}forEach(v,D){this.j();for(const[m,n]of this)v.call(D,m,n,this)}*[(u=new WeakMap,b=new WeakMap,p=new WeakMap,Symbol.iterator)](){this.j();for(const v of Ne(this,p,"f").keys())yield[v,this.get(v)]}get(v){this.j();const D=Ne(this,p,"f").get(v);return Array.isArray(D)?Object.freeze(D.slice(0)):[]}has(v){return this.j(),Array.isArray(Ne(this,p,"f").get(v))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(v,D){return v[0].toString()<D[0].toString()?-1:v[0].toString()>D[0].toString()?1:0}}e.$Gcc=t;let i=g=class{static _mapper(v){const D=new R.$Ac;for(const m of v)D.set(m,m);return{uris:Object.freeze(Array.from(D.values()))}}constructor(v,D,m,n){this.j=D,this.k=m,this.l=n,this.g=new Map,this.h=new E.$Sd({merge:r=>r.flat(),delay:50}),this.onDidChangeDiagnostics=E.Event.map(this.h.event,g._mapper),this.f=v.getProxy(O.$qK.MainThreadDiagnostics)}createDiagnosticCollection(v,D){const{g:m,f:n,h:r,j:s,k:o,l:$}=this,a=new class{$changeMany(h,w){n.$changeMany(h,w),s.trace("[DiagnosticCollection] change many (extension, owner, uris)",v.value,h,w.length===0?"CLEARING":w)}$clear(h){n.$clear(h),s.trace("[DiagnosticCollection] remove all (extension, owner)",v.value,h)}dispose(){n.dispose()}};let k;if(!D)D="_generated_diagnostic_collection_name_#"+g.c++,k=D;else if(!m.has(D))k=D;else{this.j.warn(`DiagnosticCollection with name '${D}' does already exist.`);do k=D+g.c++;while(m.has(k))}return new class extends t{constructor(){super(D,k,g.e,g.d,h=>$.getDocument(h)?.version,o.extUri,a,r),m.set(k,this)}dispose(){super.dispose(),m.delete(k)}}}getDiagnostics(v){if(v)return this.m(v);{const D=new Map,m=[];for(const n of this.g.values())n.forEach((r,s)=>{let o=D.get(r.toString());typeof o>"u"&&(o=m.length,D.set(r.toString(),o),m.push([r,[]])),m[o][1]=m[o][1].concat(...s)});return m}}m(v){let D=[];for(const m of this.g.values())m.has(v)&&(D=D.concat(m.get(v)));return D}$acceptMarkersChange(v){if(!this.n){const D="_generated_mirror",m=new t(D,D,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,n=>{},this.k.extUri,void 0,this.h);this.g.set(D,m),this.n=m}for(const[D,m]of v)this.n.set(I.URI.revive(D),m.map(c.Diagnostic.to))}};e.$Hcc=i,i.c=0,i.d=1e3,i.e=1.1*g.d,e.$Hcc=i=g=Ge([qe(1,d.$$i),qe(2,S.$Fcc)],i)}),define(Ae[231],Re([1,0,2,3,22]),function(ee,e,f,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wcc=void 0;class O{constructor(c){this.a=c.getProxy(C.$qK.MainThreadDialogs)}showOpenDialog(c,E){return E?.allowUIResources&&(0,I.$mF)(c,"showLocal"),this.a.$showOpenDialog(E).then(d=>d?d.map(R=>f.URI.revive(R)):void 0)}showSaveDialog(c){return this.a.$showSaveDialog(c).then(E=>E?f.URI.revive(E):void 0)}}e.$Wcc=O}),define(Ae[232],Re([1,0,11,2,7,3,13,19,16]),function(ee,e,f,C,I,O,A,c,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xcc=void 0;class d{constructor(S,u,b){this.d=u,this.e=b,this.b=new Map,this.c=S.getProxy(O.$qK.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(S,u){if(Object.keys(A.Schemas).indexOf(S)>=0)throw new Error(`scheme '${S}' already registered`);const b=d.a++;this.b.set(b,u),this.c.$registerTextContentProvider(b,S);let p;return typeof u.onDidChange=="function"&&(p=u.onDidChange(g=>{if(g.scheme!==S){this.e.warn(`Provider for scheme '${S}' is firing event for schema '${g.scheme}' which will be IGNORED`);return}this.d.getDocument(g)&&this.$provideTextDocumentContent(b,g).then(t=>{if(!t&&typeof t!="string")return;const i=this.d.getDocument(g);if(!i)return;const l=(0,E.$Qe)(t);if(!i.equalLines(l))return this.c.$onVirtualDocumentChange(g,t)},f.$1)})),new I.$sK(()=>{this.b.delete(b)&&this.c.$unregisterTextContentProvider(b),p&&(p.dispose(),p=void 0)})}$provideTextDocumentContent(S,u){const b=this.b.get(S);return b?Promise.resolve(b.provideTextDocumentContent(C.URI.revive(u),c.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${u.scheme}`))}}e.$Xcc=d,d.a=0}),define(Ae[233],Re([1,0,5,6,2,3,100,8,15,25,7,11]),function(ee,e,f,C,I,O,A,c,E,d,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dcc=void 0;class u{constructor(p,g){this.a=new f.$Od({onListenerError:S.$2}),this.b=new f.$Od({onListenerError:S.$2}),this.c=new f.$Od({onListenerError:S.$2}),this.d=new f.$Od({onListenerError:S.$2}),this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new C.$Rc,this.h=new Map,this.f=p.getProxy(O.$qK.MainThreadDocuments),this.g=g,this.g.onDidRemoveDocuments(t=>{for(const i of t)this.b.fire(i.document)},void 0,this.e),this.g.onDidAddDocuments(t=>{for(const i of t)this.a.fire(i.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(p){if(!p)return;const g=this.g.getDocument(p);if(g)return g}getDocument(p){const g=this.getDocumentData(p);if(!g?.document)throw new Error(`Unable to retrieve document from URI '${p}'`);return g.document}ensureDocumentData(p){const g=this.g.getDocument(p);if(g)return Promise.resolve(g);let t=this.h.get(p.toString());return t||(t=this.f.$tryOpenDocument(p).then(i=>{this.h.delete(p.toString());const l=I.URI.revive(i);return(0,E.$Kf)(this.g.getDocument(l))},i=>(this.h.delete(p.toString()),Promise.reject(i))),this.h.set(p.toString(),t)),t}createDocumentData(p){return this.f.$tryCreateDocument(p).then(g=>I.URI.revive(g))}$acceptModelLanguageChanged(p,g){const t=I.URI.revive(p),i=this.g.getDocument(t);if(!i)throw new Error("unknown document");this.b.fire(i.document),i._acceptLanguageId(g),this.a.fire(i.document)}$acceptModelSaved(p){const g=I.URI.revive(p),t=this.g.getDocument(g);if(!t)throw new Error("unknown document");this.$acceptDirtyStateChanged(p,!1),this.d.fire(t.document)}$acceptDirtyStateChanged(p,g){const t=I.URI.revive(p),i=this.g.getDocument(t);if(!i)throw new Error("unknown document");i._acceptIsDirty(g),this.c.fire({document:i.document,contentChanges:[],reason:void 0})}$acceptModelChanged(p,g,t){const i=I.URI.revive(p),l=this.g.getDocument(i);if(!l)throw new Error("unknown document");l._acceptIsDirty(t),l.onEvents(g);let v;g.isUndoing?v=R.TextDocumentChangeReason.Undo:g.isRedoing&&(v=R.TextDocumentChangeReason.Redo),this.c.fire((0,d.$0m)({document:l.document,contentChanges:g.changes.map(D=>({range:c.Range.to(D.range),rangeOffset:D.rangeOffset,rangeLength:D.rangeLength,text:D.text})),reason:v}))}setWordDefinitionFor(p,g){(0,A.$tM)(p,g)}}e.$Dcc=u}),define(Ae[60],Re([1,0,53,5,6,2,4,3,100,17,106,8,14,28,13,68,42]),function(ee,e,f,C,I,O,A,c,E,d,R,S,u,b,p,g,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CM=e.$BM=void 0;class i{constructor(D){this.value=D,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let l=class{constructor(D,m){this.h=D,this.i=m,this.a=null,this.b=new Map,this.c=new b.$Ac,this.d=new C.$Od,this.e=new C.$Od,this.f=new C.$Od,this.g=new C.$Od,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(D){this.acceptDocumentsAndEditorsDelta(D)}acceptDocumentsAndEditorsDelta(D){const m=[],n=[],r=[];if(D.removedDocuments)for(const s of D.removedDocuments){const o=O.URI.revive(s),$=this.c.get(o);$?.unref()&&(this.c.delete(o),m.push($.value))}if(D.addedDocuments)for(const s of D.addedDocuments){const o=O.URI.revive(s.uri);let $=this.c.get(o);if($&&o.scheme!==p.Schemas.vscodeNotebookCell&&o.scheme!==p.Schemas.vscodeInteractiveInput)throw new Error(`document '${o} already exists!'`);$||($=new i(new E.$uM(this.h.getProxy(c.$qK.MainThreadDocuments),o,s.lines,s.EOL,s.versionId,s.languageId,s.isDirty,s.notebook)),this.c.set(o,$),n.push($.value)),$.ref()}if(D.removedEditors)for(const s of D.removedEditors){const o=this.b.get(s);this.b.delete(s),o&&r.push(o)}if(D.addedEditors)for(const s of D.addedEditors){const o=O.URI.revive(s.documentUri);f.ok(this.c.has(o),`document '${o}' does not exist`),f.ok(!this.b.has(s.id),`editor '${s.id}' already exists!`);const $=this.c.get(o).value,a=new R.$AM(s.id,this.h.getProxy(c.$qK.MainThreadTextEditors),this.i,new t.$V(()=>$.document),s.selections.map(S.Selection.to),s.options,s.visibleRanges.map(k=>S.Range.to(k)),typeof s.editorPosition=="number"?S.ViewColumn.to(s.editorPosition):void 0);this.b.set(s.id,a)}D.newActiveEditor!==void 0&&(f.ok(D.newActiveEditor===null||this.b.has(D.newActiveEditor),`active editor '${D.newActiveEditor}' does not exist`),this.a=D.newActiveEditor),(0,I.$Nc)(m),(0,I.$Nc)(r),D.removedDocuments&&this.e.fire(m),D.addedDocuments&&this.d.fire(n),(D.removedEditors||D.addedEditors)&&this.f.fire(this.allEditors().map(s=>s.value)),D.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(D){return this.c.get(D)?.value}allDocuments(){return g.Iterable.map(this.c.values(),D=>D.value)}getEditor(D){return this.b.get(D)}activeEditor(D){if(!this.a)return;const m=this.b.get(this.a);return D?m:m?.value}allEditors(){return[...this.b.values()]}};e.$BM=l,e.$BM=l=Ge([qe(0,d.$rM),qe(1,u.$$i)],l),e.$CM=(0,A.$Qh)("IExtHostDocumentsAndEditors")}),define(Ae[61],Re([1,0,8,3,2,5,4,7,17,15,234]),function(ee,e,f,C,I,O,A,c,E,d,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vdc=e.$Udc=void 0,e.$Udc=(0,A.$Qh)("IExtHostEditorTabs");class S{constructor(t,i,l){this.e=l,this.d=i,this.acceptDtoUpdate(t)}get apiObject(){if(!this.a){const t=this,i={get isActive(){return t.b.id===t.e()},get label(){return t.b.label},get input(){return t.c},get isDirty(){return t.b.isDirty},get isPinned(){return t.b.isPinned},get isPreview(){return t.b.isPreview},get group(){return t.d.apiObject}};this.a=Object.freeze(i)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(t){this.b=t,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new c.$0L(I.URI.revive(this.b.input.uri));case 2:return new c.$$L(I.URI.revive(this.b.input.original),I.URI.revive(this.b.input.modified));case 3:return new c.$_L(I.URI.revive(this.b.input.base),I.URI.revive(this.b.input.input1),I.URI.revive(this.b.input.input2),I.URI.revive(this.b.input.result));case 6:return new c.$aM(I.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new c.$bM(this.b.input.viewType);case 4:return new c.$cM(I.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new c.$dM(I.URI.revive(this.b.input.original),I.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new c.$eM;case 9:return new c.$fM(I.URI.revive(this.b.input.uri),I.URI.revive(this.b.input.inputBoxUri));default:return}}}class u{constructor(t,i){this.c=[],this.d="",this.b=t,this.e=i;for(const l of t.tabs)l.isActive&&(this.d=l.id),this.c.push(new S(l,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const t=this,i={get isActive(){return t.b.groupId===t.e()},get viewColumn(){return f.ViewColumn.to(t.b.viewColumn)},get activeTab(){return t.c.find(l=>l.tabId===t.d)?.apiObject},get tabs(){return Object.freeze(t.c.map(l=>l.apiObject))}};this.a=Object.freeze(i)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(t){this.b=t}acceptTabOperation(t){if(t.kind===0){const l=new S(t.tabDto,this,()=>this.activeTabId());return this.c.splice(t.index,0,l),t.tabDto.isActive&&(this.d=l.tabId),l}else if(t.kind===1){const l=this.c.splice(t.index,1)[0];if(!l)throw new Error(`Tab close updated received for index ${t.index} which does not exist`);return l.tabId===this.d&&(this.d=""),l}else if(t.kind===3){if(t.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const l=this.c.splice(t.oldIndex,1)[0];if(!l)throw new Error(`Tab move updated received for index ${t.oldIndex} which does not exist`);return this.c.splice(t.index,0,l),l}const i=this.c.find(l=>l.tabId===t.tabDto.id);if(!i)throw new Error("INVALID tab");return t.tabDto.isActive?this.d=t.tabDto.id:this.d===t.tabDto.id&&!t.tabDto.isActive&&(this.d=""),i.acceptDtoUpdate(t.tabDto),i}activeTabId(){return this.d}}let b=class{constructor(t){this.b=new O.$Od,this.c=new O.$Od,this.e=[],this.a=t.getProxy(C.$qK.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const t=this,i={onDidChangeTabGroups:t.c.event,onDidChangeTabs:t.b.event,get all(){return Object.freeze(t.e.map(l=>l.apiObject))},get activeTabGroup(){const l=t.d;return(0,d.$Kf)(t.e.find(D=>D.groupId===l)?.apiObject)},close:async(l,v)=>{const D=Array.isArray(l)?l:[l];return D.length?p(D[0])?this.j(D,v):this.i(D,v):!0}};this.f=Object.freeze(i)}return this.f}$acceptEditorTabModel(t){const i=new Set(this.e.map(s=>s.groupId)),l=new Set(t.map(s=>s.groupId)),v=(0,R.$E)(i,l),D=this.e.filter(s=>v.removed.includes(s.groupId)).map(s=>s.apiObject),m=[],n=[];this.e=t.map(s=>{const o=new u(s,()=>this.d);return v.added.includes(o.groupId)?m.push(o.apiObject):n.push(o.apiObject),o});const r=(0,d.$Kf)(t.find(s=>s.isActive===!0)?.groupId);r!==void 0&&this.d!==r&&(this.d=r),this.c.fire(Object.freeze({opened:m,closed:D,changed:n}))}$acceptTabGroupUpdate(t){const i=this.e.find(l=>l.groupId===t.groupId);if(!i)throw new Error("Update Group IPC call received before group creation.");i.acceptGroupDtoUpdate(t),t.isActive&&(this.d=t.groupId),this.c.fire(Object.freeze({changed:[i.apiObject],opened:[],closed:[]}))}$acceptTabOperation(t){const i=this.e.find(v=>v.groupId===t.groupId);if(!i)throw new Error("Update Tabs IPC call received before group creation.");const l=i.acceptTabOperation(t);switch(t.kind){case 0:this.b.fire(Object.freeze({opened:[l.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[l.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[l.apiObject]}));return}}g(t){for(const i of this.e)for(const l of i.tabs)if(l.apiObject===t)return l}h(t){return this.e.find(i=>i.apiObject===t)}async i(t,i){const l=[];for(const v of t){const D=this.g(v);if(!D)throw new Error("Tab close: Invalid tab not found!");l.push(D.tabId)}return this.a.$closeTab(l,i)}async j(t,i){const l=[];for(const v of t){const D=this.h(v);if(!D)throw new Error("Group close: Invalid group not found!");l.push(D.groupId)}return this.a.$closeGroup(l,i)}};e.$Vdc=b,e.$Vdc=b=Ge([qe(0,E.$rM)],b);function p(g){return g.tabs!==void 0}}),define(Ae[235],Re([1,0,3,7]),function(ee,e,f,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hec=void 0;class I{constructor(A){this.a=new Map,this.b=0,this.c=A.getProxy(f.$qK.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(A,c,E){if(this.a.size===0)throw new Error("No embedding vector providers registered");const d=this.a.get(A);if(!d)throw new Error("Embedding vector provider not found");const R=await d.provideEmbeddingVector(c,E);if(!R)throw new Error("Embedding vector provider returned undefined");return R}registerEmbeddingVectorProvider(A,c,E){const d=this.b;return this.b++,this.a.set(d,E),this.c.$registerAiEmbeddingVectorProvider(c,d),new C.$sK(()=>{this.c.$unregisterAiEmbeddingVectorProvider(d),this.a.delete(d)})}}e.$Hec=I}),define(Ae[236],Re([1,0,2,3,6,7,8,283,16,26,22,51]),function(ee,e,f,C,I,O,A,c,E,d,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rdc=void 0;class u{constructor(){this.a=[]}add(g){this.b=void 0,this.a.push(g)}delete(g){const t=this.a.indexOf(g);t>=0&&(this.a.splice(t,1),this.b=void 0)}c(){if(!this.b){const g=this.a.sort(),t=[];let i,l,v=14,D=14;for(const m of g){let n=i?(0,E.$5e)(i,m):0;for(n===0?l=1:l=D;n<m.length;n++)n+1===m.length?(v=D,D=9):D+=1,t.push([l,m.toUpperCase().charCodeAt(n),D]),t.push([l,m.toLowerCase().charCodeAt(n),D]),l=D;i=m,D=v}t.push([9,58,10]),t.push([10,47,12]),this.b=new c.$fZ(t)}}provideDocumentLinks(g){this.c();const t=[],i=c.$gZ.computeLinks({getLineContent(l){return g.lineAt(l-1).text},getLineCount(){return g.lineCount}},this.b);for(const l of i){const v=A.DocumentLink.to(l);v.target&&t.push(v)}return t}}class b{constructor(g,t){this.i=t,this.b=new u,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=g.getProxy(C.$qK.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(g,t,i,l={}){if(b.j(i),this.d.has(t))throw new Error(`a provider for the scheme '${t}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(g,"*",this.b));const v=this.h++;this.b.add(t),this.d.add(t),this.c.set(v,i);let D=2;l.isCaseSensitive&&(D+=1024),l.isReadonly&&(D+=2048),typeof i.copy=="function"&&(D+=8),typeof i.open=="function"&&typeof i.close=="function"&&typeof i.read=="function"&&typeof i.write=="function"&&((0,R.$mF)(g,"fsChunks"),D+=4);let m;l.isReadonly&&(0,S.$6j)(l.isReadonly)&&((0,R.$mF)(g,"readonlyMessage"),m={value:l.isReadonly.value,isTrusted:l.isReadonly.isTrusted,supportThemeIcons:l.isReadonly.supportThemeIcons,supportHtml:l.isReadonly.supportHtml,baseUri:l.isReadonly.baseUri,uris:l.isReadonly.uris}),this.a.$registerFileSystemProvider(v,t,D,m).catch(r=>{console.error(`FAILED to register filesystem provider of ${g.identifier.value}-extension for the scheme ${t}`),console.error(r)});const n=i.onDidChangeFile(r=>{const s=[];for(const o of r){const{uri:$,type:a}=o;if($.scheme!==t)continue;let k;switch(a){case O.FileChangeType.Changed:k=0;break;case O.FileChangeType.Created:k=1;break;case O.FileChangeType.Deleted:k=2;break;default:throw new Error("Unknown FileChangeType")}s.push({resource:$,type:k})}this.a.$onFileSystemChange(v,s)});return(0,I.$Qc)(()=>{n.dispose(),this.b.delete(t),this.d.delete(t),this.c.delete(v),this.a.$unregisterProvider(v)})}static j(g){if(!g)throw new Error("MISSING provider");if(typeof g.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof g.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof g.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof g.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof g.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof g.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof g.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof g.rename!="function")throw new Error("Provider does NOT implement rename")}static k(g){const{type:t,ctime:i,mtime:l,size:v,permissions:D}=g;return{type:t,ctime:i,mtime:l,size:v,permissions:D}}$stat(g,t){return Promise.resolve(this.l(g).stat(f.URI.revive(t))).then(i=>b.k(i))}$readdir(g,t){return Promise.resolve(this.l(g).readDirectory(f.URI.revive(t)))}$readFile(g,t){return Promise.resolve(this.l(g).readFile(f.URI.revive(t))).then(i=>d.$ce.wrap(i))}$writeFile(g,t,i,l){return Promise.resolve(this.l(g).writeFile(f.URI.revive(t),i.buffer,l))}$delete(g,t,i){return Promise.resolve(this.l(g).delete(f.URI.revive(t),i))}$rename(g,t,i,l){return Promise.resolve(this.l(g).rename(f.URI.revive(t),f.URI.revive(i),l))}$copy(g,t,i,l){const v=this.l(g);if(!v.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(v.copy(f.URI.revive(t),f.URI.revive(i),l))}$mkdir(g,t){return Promise.resolve(this.l(g).createDirectory(f.URI.revive(t)))}$watch(g,t,i,l){const v=this.l(g).watch(f.URI.revive(i),l);this.f.set(t,v)}$unwatch(g,t){const i=this.f.get(t);i&&(i.dispose(),this.f.delete(t))}$open(g,t,i){const l=this.l(g);if(!l.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(l.open(f.URI.revive(t),i))}$close(g,t){const i=this.l(g);if(!i.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(i.close(t))}$read(g,t,i,l){const v=this.l(g);if(!v.read)throw new Error('FileSystemProvider does not implement "read"');const D=d.$ce.alloc(l);return Promise.resolve(v.read(t,i,D.buffer,0,l)).then(m=>D.slice(0,m))}$write(g,t,i,l){const v=this.l(g);if(!v.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(v.write(t,i,l.buffer,0,l.byteLength))}l(g){const t=this.c.get(g);if(!t){const i=new Error;throw i.name="ENOPRO",i.message="no provider",i}return t}}e.$rdc=b}),define(Ae[62],Re([1,0,3,39,7,26,4,17,40,6,12,24,13]),function(ee,e,f,C,I,O,A,c,E,d,R,S,u){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.$$cc=e.$0cc=void 0;let p=b=class{constructor(t,i){this.b=new Map,this.c=new R.$4g,this.a=t.getProxy(f.$qK.MainThreadFileSystem);const l=this;this.value=Object.freeze({async stat(v){try{let D;const m=l.b.get(v.scheme);return m?(await l.a.$ensureActivation(v.scheme),D=await m.impl.stat(v)):D=await l.a.$stat(v),{type:D.type,ctime:D.ctime,mtime:D.mtime,size:D.size,permissions:D.permissions===C.FilePermission.Readonly?1:void 0}}catch(D){b.e(D)}},async readDirectory(v){try{const D=l.b.get(v.scheme);return D?(await l.a.$ensureActivation(v.scheme),(await D.impl.readDirectory(v)).slice()):await l.a.$readdir(v)}catch(D){return b.e(D)}},async createDirectory(v){try{const D=l.b.get(v.scheme);return D&&!D.isReadonly?(await l.a.$ensureActivation(v.scheme),await l.d(D.impl,D.extUri,v)):await l.a.$mkdir(v)}catch(D){return b.e(D)}},async readFile(v){try{const D=l.b.get(v.scheme);return D?(await l.a.$ensureActivation(v.scheme),(await D.impl.readFile(v)).slice()):(await l.a.$readFile(v)).buffer}catch(D){return b.e(D)}},async writeFile(v,D){try{const m=l.b.get(v.scheme);return m&&!m.isReadonly?(await l.a.$ensureActivation(v.scheme),await l.d(m.impl,m.extUri,m.extUri.dirname(v)),await l.c.queueFor(v).queue(()=>Promise.resolve(m.impl.writeFile(v,D,{create:!0,overwrite:!0})))):await l.a.$writeFile(v,O.$ce.wrap(D))}catch(m){return b.e(m)}},async delete(v,D){try{const m=l.b.get(v.scheme);return m&&!m.isReadonly?(await l.a.$ensureActivation(v.scheme),await m.impl.delete(v,{recursive:!1,...D})):await l.a.$delete(v,{recursive:!1,useTrash:!1,atomic:!1,...D})}catch(m){return b.e(m)}},async rename(v,D,m){try{return await l.a.$rename(v,D,{overwrite:!1,...m})}catch(n){return b.e(n)}},async copy(v,D,m){try{return await l.a.$copy(v,D,{overwrite:!1,...m})}catch(n){return b.e(n)}},isWritableFileSystem(v){const D=i.getCapabilities(v);if(typeof D=="number")return!(D&2048)}})}async d(t,i,l){const v=[];for(;!i.isEqual(l,i.dirname(l));)try{if(!((await t.stat(l)).type&C.FileType.Directory))throw I.$FL.FileExists(`Unable to create folder '${l.scheme===u.Schemas.file?l.fsPath:l.toString(!0)}' that already exists but is not a directory`);break}catch(D){if(C.$pk(D)!==C.FileSystemProviderErrorCode.FileNotFound)throw D;v.push(i.basename(l)),l=i.dirname(l)}for(let D=v.length-1;D>=0;D--){l=i.joinPath(l,v[D]);try{await t.createDirectory(l)}catch(m){if(C.$pk(m)!==C.FileSystemProviderErrorCode.FileExists)throw m}}}static e(t){if(t instanceof I.$FL)throw t;if(t instanceof C.$lk)switch(t.code){case C.FileSystemProviderErrorCode.FileExists:throw I.$FL.FileExists(t.message);case C.FileSystemProviderErrorCode.FileNotFound:throw I.$FL.FileNotFound(t.message);case C.FileSystemProviderErrorCode.FileNotADirectory:throw I.$FL.FileNotADirectory(t.message);case C.FileSystemProviderErrorCode.FileIsADirectory:throw I.$FL.FileIsADirectory(t.message);case C.FileSystemProviderErrorCode.NoPermissions:throw I.$FL.NoPermissions(t.message);case C.FileSystemProviderErrorCode.Unavailable:throw I.$FL.Unavailable(t.message);default:throw new I.$FL(t.message,t.name)}if(!(t instanceof Error))throw new I.$FL(String(t));if(t.name==="ENOPRO"||t.message.includes("ENOPRO"))throw I.$FL.Unavailable(t.message);switch(t.name){case C.FileSystemProviderErrorCode.FileExists:throw I.$FL.FileExists(t.message);case C.FileSystemProviderErrorCode.FileNotFound:throw I.$FL.FileNotFound(t.message);case C.FileSystemProviderErrorCode.FileNotADirectory:throw I.$FL.FileNotADirectory(t.message);case C.FileSystemProviderErrorCode.FileIsADirectory:throw I.$FL.FileIsADirectory(t.message);case C.FileSystemProviderErrorCode.NoPermissions:throw I.$FL.NoPermissions(t.message);case C.FileSystemProviderErrorCode.Unavailable:throw I.$FL.Unavailable(t.message);default:throw new I.$FL(t.message,t.name)}}addFileSystemProvider(t,i,l){return this.b.set(t,{impl:i,extUri:l?.isCaseSensitive?S.$mg:S.$og,isReadonly:!!l?.isReadonly}),(0,d.$Qc)(()=>this.b.delete(t))}getFileSystemProviderExtUri(t){return this.b.get(t)?.extUri??S.$mg}};e.$0cc=p,e.$0cc=p=b=Ge([qe(0,c.$rM),qe(1,E.$Fcc)],p),e.$$cc=(0,A.$Qh)("IExtHostConsumerFileSystem")}),define(Ae[237],Re([1,0,5,36,2,3,8,7,42]),function(ee,e,f,C,I,O,A,c,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sdc=void 0;class d{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(b,p,g,t,i,l){this.a=Math.random(),this.b=new f.$Od,this.c=new f.$Od,this.d=new f.$Od,this.h=0,l?.ignoreCreateEvents&&(this.h+=1),l?.ignoreChangeEvents&&(this.h+=2),l?.ignoreDeleteEvents&&(this.h+=4);const v=(0,C.$xj)(i),D=typeof i=="string",m=l?.correlate,n=t(r=>{if(!(typeof r.session=="number"&&r.session!==this.a)&&!(m&&typeof r.session>"u")){if(!l?.ignoreCreateEvents)for(const s of r.created){const o=I.URI.revive(s);v(o.fsPath)&&(!D||p.getWorkspaceFolder(o))&&this.b.fire(o)}if(!l?.ignoreChangeEvents)for(const s of r.changed){const o=I.URI.revive(s);v(o.fsPath)&&(!D||p.getWorkspaceFolder(o))&&this.c.fire(o)}if(!l?.ignoreDeleteEvents)for(const s of r.deleted){const o=I.URI.revive(s);v(o.fsPath)&&(!D||p.getWorkspaceFolder(o))&&this.d.fire(o)}}});this.g=c.$sK.from(this.i(b,g,i,l,l?.correlate),this.b,this.c,this.d,n)}i(b,p,g,t,i){const l=c.$sK.from();if(typeof g=="string")return l;const v=b.getProxy(O.$qK.MainThreadFileSystemEventService);let D=!1;return(g.pattern.includes(C.$tj)||g.pattern.includes(C.$uj))&&(D=!0),v.$watch(p.identifier.value,this.a,g.baseUri,{recursive:D,excludes:t?.excludes??[]},!!i),c.$sK.from({dispose:()=>v.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class R{constructor(b){this.a=b,this.session=this.a.session,this.b=new E.$V(()=>this.a.created.map(I.URI.revive)),this.c=new E.$V(()=>this.a.changed.map(I.URI.revive)),this.d=new E.$V(()=>this.a.deleted.map(I.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class S{constructor(b,p,g){this.j=b,this.k=p,this.l=g,this.a=new f.$Od,this.b=new f.$Od,this.c=new f.$Od,this.d=new f.$Od,this.g=new f.$Qd,this.h=new f.$Qd,this.i=new f.$Qd,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(b,p,g,t){return new d(this.j,b,p,this.a.event,A.GlobPattern.from(g),t)}$onFileEvent(b){this.a.fire(new R(b))}$onDidRunFileOperation(b,p){switch(b){case 2:this.b.fire(Object.freeze({files:p.map(g=>({oldUri:I.URI.revive(g.source),newUri:I.URI.revive(g.target)}))}));break;case 1:this.d.fire(Object.freeze({files:p.map(g=>I.URI.revive(g.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:p.map(g=>I.URI.revive(g.target))}));break;default:}}getOnWillRenameFileEvent(b){return this.m(b,this.g)}getOnWillCreateFileEvent(b){return this.m(b,this.h)}getOnWillDeleteFileEvent(b){return this.m(b,this.i)}m(b,p){return(g,t,i)=>{const l=function(D){g.call(t,D)};return l.extension=b,p.event(l,void 0,i)}}async $onWillRunFileOperation(b,p,g,t){switch(b){case 2:return await this.n(this.g,{files:p.map(i=>({oldUri:I.URI.revive(i.source),newUri:I.URI.revive(i.target)}))},g,t);case 1:return await this.n(this.i,{files:p.map(i=>I.URI.revive(i.target))},g,t);case 0:case 3:return await this.n(this.h,{files:p.map(i=>I.URI.revive(i.target))},g,t)}}async n(b,p,g,t){const i=new Set,l=[];if(await b.fireAsync(p,t,async(D,m)=>{const n=Date.now(),r=await Promise.resolve(D);r instanceof c.$CK&&(l.push([m.extension,r]),i.add(m.extension.displayName??m.extension.identifier.value)),Date.now()-n>g&&this.k.warn("SLOW file-participant",m.extension.identifier)}),t.isCancellationRequested||l.length===0)return;const v={edits:[]};for(const[,D]of l){const{edits:m}=A.WorkspaceEdit.from(D,{getTextDocumentVersion:n=>this.l.getDocument(n)?.version,getNotebookDocumentVersion:()=>{}});v.edits=v.edits.concat(m)}return{edit:v,extensionNames:Array.from(i)}}}e.$sdc=S}),define(Ae[238],Re([1,0,6,2,3,8,7,31,12]),function(ee,e,f,C,I,O,A,c,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zec=void 0;class d{constructor(b,p){this.extension=b,this.provider=p,this.handle=d.a++}}d.a=0;class R{constructor(b){this.session=b,this.responses=[]}}class S{constructor(b,p,g,t){this.f=g,this.g=t,this.b=new Map,this.d=new Map,this.e=b.getProxy(I.$qK.MainThreadInlineChat),p.registerApiCommand(new c.$RM("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new c.$PM("Run arguments","",i=>!0,i=>{if(i)return{initialRange:i.initialRange?O.Range.from(i.initialRange):void 0,initialSelection:i.initialSelection?O.Selection.from(i.initialSelection):void 0,message:i.message,autoSend:i.autoSend,position:i.position?O.Position.from(i.position):void 0}})],c.$QM.Void))}registerProvider(b,p,g){const t=new d(b,p);return this.b.set(t.handle,t),this.e.$registerInteractiveEditorProvider(t.handle,g.label,b.identifier.value,typeof p.handleInteractiveEditorResponseFeedback=="function"),(0,f.$Qc)(()=>{this.e.$unregisterInteractiveEditorProvider(t.handle),this.b.delete(t.handle)})}async $prepareSession(b,p,g,t){const i=this.b.get(b);if(!i){this.g.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const l=this.f.getDocument(C.URI.revive(p)),v=O.Selection.to(g),D=await i.provider.prepareInteractiveEditorSession({document:l,selection:v},t);if(!D)return;if(D.wholeRange&&!D.wholeRange.contains(v))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const m=S.a++;return this.d.set(m,new R(D)),{id:m,placeholder:D.placeholder,input:D.input,slashCommands:D.slashCommands?.map(n=>({command:n.command,detail:n.detail,refer:n.refer,executeImmediately:n.executeImmediately})),wholeRange:O.Range.from(D.wholeRange),message:D.message}}async $provideResponse(b,p,g,t){const i=this.b.get(b);if(!i)return;const l=this.d.get(p.id);if(!l)return;const v={prompt:g.prompt,selection:O.Selection.to(g.selection),wholeRange:O.Range.to(g.wholeRange),attempt:g.attempt,live:g.live};let D=!1;const m={report:async a=>{if(!g.live&&a.edits?.length)throw new Error("Progress reporting is only supported for live sessions");D||t.isCancellationRequested||await this.e.$handleProgressChunk(g.requestId,{message:a.message,edits:a.edits?.map(O.TextEdit.from),editsShouldBeInstant:a.editsShouldBeInstant,slashCommand:a.slashCommand?.command,markdownFragment:A.$SK.isMarkdownString(a.content)?a.content.value:a.content})}},n=Promise.resolve(i.provider.provideInteractiveEditorResponse(l.session,v,m,t));let r;try{r=await(0,E.$Jg)(n,t)}finally{D=!0}if(!r)return;const s=l.responses.push(r)-1,o={wholeRange:O.Range.from(r.wholeRange),placeholder:r.placeholder};if(S.h(r))return{...o,id:s,type:"message",message:O.MarkdownString.from(r.contents)};const{edits:$}=r;return $ instanceof A.$CK?{...o,id:s,type:"bulkEdit",edits:O.WorkspaceEdit.from($)}:{...o,id:s,type:"editorEdit",edits:$.map(O.TextEdit.from)}}$handleFeedback(b,p,g,t){const i=this.b.get(b),l=this.d.get(p),v=l?.responses[g];if(i&&v){const D=O.InteractiveEditorResponseFeedbackKind.to(t);i.provider.handleInteractiveEditorResponseFeedback?.(l.session,v,D)}}$releaseSession(b,p){}static h(b){return typeof b=="object"&&typeof b.contents=="object"}}e.$zec=S,S.a=0}),define(Ae[239],Re([1,0,2,31]),function(ee,e,f,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vec=void 0;class I{constructor(A,c,E,d,R){this.a=c,this.b=E,this.c=d;const S=new C.$RM("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new C.$PM("showOptions","Show Options",u=>!0,u=>u),new C.$PM("resource","Interactive resource Uri",u=>!0,u=>u),new C.$PM("controllerId","Notebook controller Id",u=>!0,u=>u),new C.$PM("title","Interactive editor title",u=>!0,u=>u)],new C.$QM("Notebook and input URI",u=>{if(R.debug("[ExtHostInteractive] open iw with notebook editor id",u.notebookEditorId),u.notebookEditorId!==void 0){const b=this.a.getEditorById(u.notebookEditorId);return R.debug("[ExtHostInteractive] notebook editor found",b.id),{notebookUri:f.URI.revive(u.notebookUri),inputUri:f.URI.revive(u.inputUri),notebookEditor:b.apiEditor}}return R.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",u.notebookUri,u.inputUri),{notebookUri:f.URI.revive(u.notebookUri),inputUri:f.URI.revive(u.inputUri)}}));this.c.registerApiCommand(S)}$willAddInteractiveDocument(A,c,E,d){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:c,lines:[""],languageId:E,uri:A,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument(f.URI.revive(d))?.apiNotebook}]})}$willRemoveInteractiveDocument(A,c){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[A]})}}e.$vec=I}),define(Ae[240],Re([1,0,3,7]),function(ee,e,f,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bec=void 0;class I{constructor(A){this.a=new Map,this.b=new Map,this.c=A.getProxy(f.$qK.MainThreadIssueReporter)}async $getIssueReporterUri(A,c){if(this.a.size===0)throw new Error("No issue request handlers registered");const E=this.a.get(A);if(!E)throw new Error("Issue request handler not found");const d=await E.handleIssueUrlRequest();if(!d)throw new Error("Issue request handler returned no result");return d}async $getIssueReporterData(A,c){if(this.b.size===0)throw new Error("No issue request handlers registered");const E=this.b.get(A);if(!E)throw new Error("Issue data provider not found");const d=await E.provideIssueData(c);if(!d)throw new Error("Issue data provider returned no result");return d}async $getIssueReporterTemplate(A,c){if(this.b.size===0)throw new Error("No issue request handlers registered");const E=this.b.get(A);if(!E)throw new Error("Issue data provider not found");const d=await E.provideIssueTemplate(c);if(!d)throw new Error("Issue template provider returned no result");return d}registerIssueUriRequestHandler(A,c){const E=A.identifier.value;return this.a.set(E,c),this.c.$registerIssueUriRequestHandler(E),new C.$sK(()=>{this.c.$unregisterIssueUriRequestHandler(E),this.a.delete(E)})}registerIssueDataProvider(A,c){const E=A.identifier.value;return this.b.set(E,c),this.c.$registerIssueDataProvider(E),new C.$sK(()=>{this.c.$unregisterIssueDataProvider(E),this.b.delete(E)})}}e.$Bec=I}),define(Ae[241],Re([1,0,6,3]),function(ee,e,f,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Odc=void 0;class I{constructor(A){this.b=0,this.a=A.getProxy(C.$qK.MainThreadLabelService)}$registerResourceLabelFormatter(A){const c=this.b++;return this.a.$registerResourceLabelFormatter(c,A),(0,f.$Qc)(()=>{this.a.$unregisterResourceLabelFormatter(c)})}}e.$Odc=I}),define(Ae[242],Re([1,0,2,25,8,7,79,3,16,41,18,15,284,19,21,6,91,88,74,48,11,12,22,150]),function(ee,e,f,C,I,O,A,c,E,d,R,S,u,b,p,g,t,i,l,v,D,m,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lcc=void 0;class s{constructor(L,K){this.d=L,this.e=K}async provideDocumentSymbols(L,K){const Y=this.d.getDocument(L),X=await this.e.provideDocumentSymbols(Y,K);if(!(0,R.$Kb)(X))return X[0]instanceof O.$KK?X.map(I.DocumentSymbol.from):s.f(X)}static f(L){L=L.slice(0).sort((X,H)=>{let x=X.location.range.start.compareTo(H.location.range.start);return x===0&&(x=H.location.range.end.compareTo(X.location.range.end)),x});const K=[],Y=[];for(const X of L){const H={name:X.name||"!!MISSING: name!!",kind:I.SymbolKind.from(X.kind),tags:X.tags?.map(I.SymbolTag.from)||[],detail:"",containerName:X.containerName,range:I.Range.from(X.location.range),selectionRange:I.Range.from(X.location.range),children:[]};for(;;){if(Y.length===0){Y.push(H),K.push(H);break}const x=Y[Y.length-1];if(d.$ys.containsRange(x.range,H.range)&&!d.$ys.equalsRange(x.range,H.range)){x.children?.push(H),Y.push(H);break}Y.pop()}}return K}}class o{constructor(L,K,Y){this.g=L,this.h=K,this.j=Y,this.e=new l.$Ccc("CodeLens"),this.f=new Map}async provideCodeLenses(L,K){const Y=this.g.getDocument(L),X=await this.j.provideCodeLenses(Y,K);if(!X||K.isCancellationRequested)return;const H=this.e.add(X),x=new g.$Rc;this.f.set(H,x);const se={cacheId:H,lenses:[]};for(let Le=0;Le<X.length;Le++)se.lenses.push({cacheId:[H,Le],range:I.Range.from(X[Le].range),command:this.h.toInternal(X[Le].command,x)});return se}async resolveCodeLens(L,K){const Y=L.cacheId&&this.e.get(...L.cacheId);if(!Y)return;let X;if(typeof this.j.resolveCodeLens!="function"||Y.isResolved?X=Y:X=await this.j.resolveCodeLens(Y,K),X||(X=Y),K.isCancellationRequested)return;const H=L.cacheId&&this.f.get(L.cacheId[0]);if(H)return L.command=this.h.toInternal(X.command??o.d,H),L}releaseCodeLenses(L){this.f.get(L)?.dispose(),this.f.delete(L),this.e.delete(L)}}o.d={command:"missing",title:"!!MISSING: command!!"};function $(Ce){return Array.isArray(Ce)?Ce.map(I.DefinitionLink.from):Ce?[I.DefinitionLink.from(Ce)]:[]}class a{constructor(L,K){this.d=L,this.e=K}async provideDefinition(L,K,Y){const X=this.d.getDocument(L),H=I.Position.to(K),x=await this.e.provideDefinition(X,H,Y);return $(x)}}class k{constructor(L,K){this.d=L,this.e=K}async provideDeclaration(L,K,Y){const X=this.d.getDocument(L),H=I.Position.to(K),x=await this.e.provideDeclaration(X,H,Y);return $(x)}}class P{constructor(L,K){this.d=L,this.e=K}async provideImplementation(L,K,Y){const X=this.d.getDocument(L),H=I.Position.to(K),x=await this.e.provideImplementation(X,H,Y);return $(x)}}class h{constructor(L,K){this.d=L,this.e=K}async provideTypeDefinition(L,K,Y){const X=this.d.getDocument(L),H=I.Position.to(K),x=await this.e.provideTypeDefinition(X,H,Y);return $(x)}}class w{constructor(L,K){this.d=L,this.e=K}async provideHover(L,K,Y){const X=this.d.getDocument(L),H=I.Position.to(K),x=await this.e.provideHover(X,H,Y);if(!(!x||(0,R.$Kb)(x.contents)))return x.range||(x.range=X.getWordRangeAtPosition(H)),x.range||(x.range=new O.$uK(H,H)),I.Hover.from(x)}}class y{constructor(L,K){this.d=L,this.e=K}async provideEvaluatableExpression(L,K,Y){const X=this.d.getDocument(L),H=I.Position.to(K),x=await this.e.provideEvaluatableExpression(X,H,Y);if(x)return I.EvaluatableExpression.from(x)}}class M{constructor(L,K){this.d=L,this.e=K}async provideInlineValues(L,K,Y,X){const H=this.d.getDocument(L),x=await this.e.provideInlineValues(H,I.Range.to(K),I.InlineValueContext.to(Y),X);if(Array.isArray(x))return x.map(se=>I.InlineValue.from(se))}}class V{constructor(L,K){this.d=L,this.e=K}async provideDocumentHighlights(L,K,Y){const X=this.d.getDocument(L),H=I.Position.to(K),x=await this.e.provideDocumentHighlights(X,H,Y);if(Array.isArray(x))return x.map(I.DocumentHighlight.from)}}class B{constructor(L,K){this.d=L,this.e=K}async provideLinkedEditingRanges(L,K,Y){const X=this.d.getDocument(L),H=I.Position.to(K),x=await this.e.provideLinkedEditingRanges(X,H,Y);if(x&&Array.isArray(x.ranges))return{ranges:(0,R.$Hb)(x.ranges.map(I.Range.from)),wordPattern:x.wordPattern}}}class z{constructor(L,K){this.d=L,this.e=K}async provideReferences(L,K,Y,X){const H=this.d.getDocument(L),x=I.Position.to(K),se=await this.e.provideReferences(H,x,Y,X);if(Array.isArray(se))return se.map(I.location.from)}}class T{constructor(L,K,Y,X,H,x,se){this.g=L,this.h=K,this.j=Y,this.k=X,this.l=H,this.m=x,this.n=se,this.e=new l.$Ccc("CodeAction"),this.f=new Map}async provideCodeActions(L,K,Y,X){const H=this.g.getDocument(L),x=u.$As.isISelection(K)?I.Selection.to(K):I.Range.to(K),se=[];for(const xe of this.j.getDiagnostics(L))if(x.intersection(xe.range)&&se.push(xe)>T.d)break;const Le={diagnostics:se,only:Y.only?new O.$MK(Y.only):void 0,triggerKind:I.CodeActionTriggerKind.to(Y.trigger)},je=await this.k.provideCodeActions(H,x,Le,X);if(!(0,R.$Lb)(je)||X.isCancellationRequested)return;const Ye=this.e.add(je),Ke=new g.$Rc;this.f.set(Ye,Ke);const tt=[];for(let xe=0;xe<je.length;xe++){const et=je[xe];et&&(T.o(et)?(this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),tt.push({_isSynthetic:!0,title:et.title,command:this.h.toInternal(et,Ke)})):(Le.only&&(et.kind?Le.only.contains(et.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Le.only.value} 'requested but returned code action is of kind '${et.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Le.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),tt.push({cacheId:[Ye,xe],title:et.title,command:et.command&&this.h.toInternal(et.command,Ke),diagnostics:et.diagnostics&&et.diagnostics.map(I.Diagnostic.from),edit:et.edit&&I.WorkspaceEdit.from(et.edit,void 0),kind:et.kind&&et.kind.value,isPreferred:et.isPreferred,isAI:(0,n.$lF)(this.m,"codeActionAI")?et.isAI:!1,disabled:et.disabled?.reason})))}return{cacheId:Ye,actions:tt}}async resolveCodeAction(L,K){const[Y,X]=L,H=this.e.get(Y,X);if(!H||T.o(H))return{};if(!this.k.resolveCodeAction)return{};const x=await this.k.resolveCodeAction(H,K)??H;let se;x.edit&&(se=I.WorkspaceEdit.from(x.edit,void 0));let Le;if(x.command){const je=this.f.get(Y);je&&(Le=this.h.toInternal(x.command,je))}return{edit:se,command:Le}}releaseCodeActions(L){this.f.get(L)?.dispose(),this.f.delete(L),this.e.delete(L)}static o(L){return typeof L.command=="string"&&typeof L.title=="string"}}T.d=1e3;class F{static toInternalProviderId(L,K){return L+"."+K}constructor(L,K,Y,X,H){this.d=L,this.e=K,this.f=Y,this.g=X,this.h=H}async prepareDocumentPaste(L,K,Y,X){if(!this.f.prepareDocumentPaste)return;const H=this.e.getDocument(L),x=K.map(je=>I.Range.to(je)),se=I.DataTransfer.toDataTransfer(Y,()=>{throw new D.$$});if(await this.f.prepareDocumentPaste(H,x,se,X),X.isCancellationRequested)return;const Le=Array.from(se).filter(([,je])=>!(je instanceof O.$gL));return I.DataTransfer.from(Le)}async providePasteEdits(L,K,Y,X,H){if(!this.f.provideDocumentPasteEdits)return;const x=this.e.getDocument(K),se=Y.map(Ye=>I.Range.to(Ye)),Le=I.DataTransfer.toDataTransfer(X,async Ye=>(await this.d.$resolvePasteFileData(this.g,L,Ye)).buffer),je=await this.f.provideDocumentPasteEdits(x,se,Le,H);if(je)return{label:je.label??(0,r.localize)(0,null,this.h.displayName||this.h.name),detail:this.h.displayName||this.h.name,yieldTo:je.yieldTo?.map(Ye=>"mimeType"in Ye?Ye:{providerId:F.toInternalProviderId(Ye.extensionId,Ye.providerId)}),insertText:typeof je.insertText=="string"?je.insertText:{snippet:je.insertText.value},additionalEdit:je.additionalEdit?I.WorkspaceEdit.from(je.additionalEdit,void 0):void 0}}}class j{constructor(L,K){this.d=L,this.e=K}async provideDocumentFormattingEdits(L,K,Y){const X=this.d.getDocument(L),H=await this.e.provideDocumentFormattingEdits(X,K,Y);if(Array.isArray(H))return H.map(I.TextEdit.from)}}class q{constructor(L,K){this.d=L,this.e=K}async provideDocumentRangeFormattingEdits(L,K,Y,X){const H=this.d.getDocument(L),x=I.Range.to(K),se=await this.e.provideDocumentRangeFormattingEdits(H,x,Y,X);if(Array.isArray(se))return se.map(I.TextEdit.from)}async provideDocumentRangesFormattingEdits(L,K,Y,X){(0,S.$Jf)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const H=this.d.getDocument(L),x=K.map(I.Range.to),se=await this.e.provideDocumentRangesFormattingEdits(H,x,Y,X);if(Array.isArray(se))return se.map(I.TextEdit.from)}}class W{constructor(L,K){this.d=L,this.e=K,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(L,K,Y,X,H){const x=this.d.getDocument(L),se=I.Position.to(K),Le=await this.e.provideOnTypeFormattingEdits(x,se,Y,X,H);if(Array.isArray(Le))return Le.map(I.TextEdit.from)}}class we{constructor(L,K){this.e=L,this.f=K,this.d=new l.$Ccc("WorkspaceSymbols")}async provideWorkspaceSymbols(L,K){const Y=await this.e.provideWorkspaceSymbols(L,K);if(!(0,R.$Lb)(Y))return{symbols:[]};const X=this.d.add(Y),H={cacheId:X,symbols:[]};for(let x=0;x<Y.length;x++){const se=Y[x];if(!se||!se.name){this.f.warn("INVALID SymbolInformation",se);continue}H.symbols.push({...I.WorkspaceSymbol.from(se),cacheId:[X,x]})}return H}async resolveWorkspaceSymbol(L,K){if(typeof this.e.resolveWorkspaceSymbol!="function"||!L.cacheId)return L;const Y=this.d.get(...L.cacheId);if(Y){const X=await this.e.resolveWorkspaceSymbol(Y,K);return X&&(0,C.$_m)(L,I.WorkspaceSymbol.from(X),!0)}}releaseWorkspaceSymbols(L){this.d.delete(L)}}class ke{static supportsResolving(L){return typeof L.prepareRename=="function"}constructor(L,K,Y){this.d=L,this.e=K,this.f=Y}async provideRenameEdits(L,K,Y,X){const H=this.d.getDocument(L),x=I.Position.to(K);try{const se=await this.e.provideRenameEdits(H,x,Y,X);return se?I.WorkspaceEdit.from(se):void 0}catch(se){const Le=ke.g(se);return Le?{rejectReason:Le,edits:void 0}:Promise.reject(se)}}async resolveRenameLocation(L,K,Y){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const X=this.d.getDocument(L),H=I.Position.to(K);try{const x=await this.e.prepareRename(X,H,Y);let se,Le;if(O.$uK.isRange(x)?(se=x,Le=X.getText(x)):(0,S.$Bf)(x)&&(se=x.range,Le=x.placeholder),!se||!Le)return;if(se.start.line>H.line||se.end.line<H.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:I.Range.from(se),text:Le}}catch(x){const se=ke.g(x);return se?{rejectReason:se,range:void 0,text:void 0}:Promise.reject(x)}}static g(L){return typeof L=="string"?L:L instanceof Error&&typeof L.message=="string"?L.message:void 0}}class Se{constructor(L,K){this.resultId=L,this.tokens=K}}class ve{constructor(L,K){this.f=L,this.g=K,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(L,K,Y){const X=this.f.getDocument(L),H=K!==0?this.d.get(K):null;let x=typeof H?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(X,H.resultId,Y):await this.g.provideDocumentSemanticTokens(X,Y);return H&&this.d.delete(K),x?(x=ve.h(x),this.o(ve.n(H,x),x)):null}async releaseDocumentSemanticColoring(L){this.d.delete(L)}static h(L){return ve.j(L)?ve.k(L)?L:new O.$JL(new Uint32Array(L.data),L.resultId):ve.l(L)?ve.m(L)?L:new O.$LL(L.edits.map(K=>new O.$KL(K.start,K.deleteCount,K.data?new Uint32Array(K.data):K.data)),L.resultId):L}static j(L){return L&&!!L.data}static k(L){return L.data instanceof Uint32Array}static l(L){return L&&Array.isArray(L.edits)}static m(L){for(const K of L.edits)if(!(K.data instanceof Uint32Array))return!1;return!0}static n(L,K){if(!ve.j(K)||!L||!L.tokens)return K;const Y=L.tokens,X=Y.length,H=K.data,x=H.length;let se=0;const Le=Math.min(X,x);for(;se<Le&&Y[se]===H[se];)se++;if(se===X&&se===x)return new O.$LL([],K.resultId);let je=0;const Ye=Le-se;for(;je<Ye&&Y[X-je-1]===H[x-je-1];)je++;return new O.$LL([{start:se,deleteCount:X-se-je,data:H.subarray(se,x-je)}],K.resultId)}o(L,K){if(ve.j(L)){const Y=this.e++;return this.d.set(Y,new Se(L.resultId,L.data)),(0,t.$b$)({id:Y,type:"full",data:L.data})}if(ve.l(L)){const Y=this.e++;return ve.j(K)?this.d.set(Y,new Se(K.resultId,K.data)):this.d.set(Y,new Se(L.resultId)),(0,t.$b$)({id:Y,type:"delta",deltas:(L.edits||[]).map(X=>({start:X.start,deleteCount:X.deleteCount,data:X.data}))})}return null}}class ge{constructor(L,K){this.d=L,this.e=K}async provideDocumentRangeSemanticTokens(L,K,Y){const X=this.d.getDocument(L),H=await this.e.provideDocumentRangeSemanticTokens(X,I.Range.to(K),Y);return H?this.f(H):null}f(L){return(0,t.$b$)({id:0,type:"full",data:L.data})}}class re{static supportsResolving(L){return typeof L.resolveCompletionItem=="function"}constructor(L,K,Y,X,H){this.f=L,this.g=K,this.h=Y,this.j=X,this.k=H,this.d=new l.$Ccc("CompletionItem"),this.e=new Map}async provideCompletionItems(L,K,Y,X){const H=this.f.getDocument(L),x=I.Position.to(K),se=H.getWordRangeAtPosition(x)||new O.$uK(x,x),Le=se.with({end:x}),je=new v.$Kd,Ye=await this.h.provideCompletionItems(H,x,X,I.CompletionContext.to(Y));if(!Ye||X.isCancellationRequested)return;const Ke=Array.isArray(Ye)?new O.$ZK(Ye):Ye,tt=re.supportsResolving(this.h)?this.d.add(Ke.items):this.d.add([]),xe=new g.$Rc;this.e.set(tt,xe);const et=[],rt={x:tt,b:et,a:{replace:I.Range.from(se),insert:I.Range.from(Le)},c:Ke.isIncomplete||void 0,d:je.elapsed()};for(let nt=0;nt<Ke.items.length;nt++){const Ue=Ke.items[nt],lt=this.l(Ue,[tt,nt],Le,se);et.push(lt)}return rt}async resolveCompletionItem(L,K){if(typeof this.h.resolveCompletionItem!="function")return;const Y=this.d.get(...L);if(!Y)return;const X=this.l(Y,L),H=await this.h.resolveCompletionItem(Y,K);if(!H)return;const x=this.l(H,L);return(X.h!==x.h||X.i!==x.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(X.n!==x.n||X.o!==x.o||!(0,C.$an)(X.p,x.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...X,d:x.d,c:x.c,l:x.l,h:x.h,i:x.i,n:x.n,o:x.o,p:x.p}}releaseCompletionItems(L){this.e.get(L)?.dispose(),this.e.delete(L),this.d.delete(L)}l(L,K,Y,X){const H=this.e.get(K[0]);if(!H)throw Error("DisposableStore is missing...");const x=this.g.toInternal(L.command,H),se={x:K,a:L.label,b:L.kind!==void 0?I.CompletionItemKind.from(L.kind):void 0,m:L.tags&&L.tags.map(I.CompletionItemTag.from),c:L.detail,d:typeof L.documentation>"u"?void 0:I.MarkdownString.fromStrict(L.documentation),e:L.sortText!==L.label?L.sortText:void 0,f:L.filterText!==L.label?L.filterText:void 0,g:L.preselect||void 0,i:L.keepWhitespace?1:0,k:L.commitCharacters?.join(""),l:L.additionalTextEdits&&L.additionalTextEdits.map(I.TextEdit.from),n:x?.$ident,o:x?.id,p:x?.$ident?void 0:x?.arguments};L.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),se.h=L.textEdit.newText):typeof L.insertText=="string"?se.h=L.insertText:L.insertText instanceof O.$DK&&(se.h=L.insertText.value,se.i|=4);let Le;return L.textEdit?Le=L.textEdit.range:L.range&&(Le=L.range),O.$uK.isRange(Le)?se.j=I.Range.from(Le):Le&&(!Y?.isEqual(Le.inserting)||!X?.isEqual(Le.replacing))&&(se.j={insert:I.Range.from(Le.inserting),replace:I.Range.from(Le.replacing)}),se}}class oe{async provideInlineCompletions(L,K,Y,X){}disposeCompletions(L){}handleDidShowCompletionItem(L,K,Y){}handlePartialAccept(L,K,Y){}}class ye extends oe{constructor(L,K,Y,X){super(),this.f=L,this.g=K,this.h=Y,this.j=X,this.d=new De,this.e=(0,n.$lF)(this.f,"inlineCompletionsAdditions"),this.k={[A.InlineCompletionTriggerKind.Automatic]:O.InlineCompletionTriggerKind.Automatic,[A.InlineCompletionTriggerKind.Explicit]:O.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,n.$lF)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(L,K,Y,X){const H=this.g.getDocument(L),x=I.Position.to(K),se=await this.h.provideInlineCompletionItems(H,x,{selectedCompletionInfo:Y.selectedSuggestionInfo?{range:I.Range.to(Y.selectedSuggestionInfo.range),text:Y.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[Y.triggerKind]},X);if(!se||X.isCancellationRequested)return;const Le=Array.isArray(se)?se:se.items,je=this.e?Array.isArray(se)?[]:se.commands||[]:[],Ye=this.e&&!Array.isArray(se)?se.enableForwardStability:void 0;let Ke;return{pid:this.d.createReferenceId({dispose(){Ke?.dispose()},items:Le}),items:Le.map((xe,et)=>{let rt;xe.command&&(Ke||(Ke=new g.$Rc),rt=this.j.toInternal(xe.command,Ke));const nt=xe.insertText;return{insertText:typeof nt=="string"?nt:{snippet:nt.value},filterText:xe.filterText,range:xe.range?I.Range.from(xe.range):void 0,command:rt,idx:et,completeBracketPairs:this.e?xe.completeBracketPairs:!1}}),commands:je.map(xe=>(Ke||(Ke=new g.$Rc),this.j.toInternal(xe,Ke))),suppressSuggestions:!1,enableForwardStability:Ye}}disposeCompletions(L){this.d.disposeReferenceId(L)?.dispose()}handleDidShowCompletionItem(L,K,Y){const X=this.d.get(L)?.items[K];X&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(X,Y)}handlePartialAccept(L,K,Y){const X=this.d.get(L)?.items[K];X&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&this.h.handleDidPartiallyAcceptCompletionItem(X,Y)}}class De{constructor(){this.d=new Map,this.e=1}createReferenceId(L){const K=this.e++;return this.d.set(K,L),K}disposeReferenceId(L){const K=this.d.get(L);return this.d.delete(L),K}get(L){return this.d.get(L)}}class Q{constructor(L,K){this.e=L,this.f=K,this.d=new l.$Ccc("SignatureHelp")}async provideSignatureHelp(L,K,Y,X){const H=this.e.getDocument(L),x=I.Position.to(K),se=this.g(Y),Le=await this.f.provideSignatureHelp(H,x,X,se);if(Le){const je=this.d.add([Le]);return{...I.SignatureHelp.from(Le),id:je}}}g(L){let K;if(L.activeSignatureHelp){const Y=I.SignatureHelp.to(L.activeSignatureHelp),X=this.d.get(L.activeSignatureHelp.id,0);X?(K=X,K.activeSignature=Y.activeSignature,K.activeParameter=Y.activeParameter):K=Y}return{...L,activeSignatureHelp:K}}releaseSignatureHelp(L){this.d.delete(L)}}class ue{constructor(L,K,Y,X,H){this.f=L,this.g=K,this.h=Y,this.j=X,this.k=H,this.d=new l.$Ccc("InlayHints"),this.e=new Map}async provideInlayHints(L,K,Y){const X=this.f.getDocument(L),H=I.Range.to(K),x=await this.h.provideInlayHints(X,H,Y);if(!Array.isArray(x)||x.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for ${K}`);return}if(Y.isCancellationRequested)return;const se=this.d.add(x);this.e.set(se,new g.$Rc);const Le={hints:[],cacheId:se};for(let je=0;je<x.length;je++)this.l(x[je],H)&&Le.hints.push(this.m(x[je],[se,je]));return this.j.trace(`[InlayHints] ${Le.hints.length} inlay hints from '${this.k.identifier.value}' for ${K}`),Le}async resolveInlayHint(L,K){if(typeof this.h.resolveInlayHint!="function")return;const Y=this.d.get(...L);if(!Y)return;const X=await this.h.resolveInlayHint(Y,K);if(X&&this.l(X))return this.m(X,L)}releaseHints(L){this.e.get(L)?.dispose(),this.e.delete(L),this.d.delete(L)}l(L,K){return L.label.length===0||Array.isArray(L.label)&&L.label.every(Y=>Y.value.length===0)?(console.log("INVALID inlay hint, empty label",L),!1):!(K&&!K.contains(L.position))}m(L,K){const Y=this.e.get(K[0]);if(!Y)throw Error("DisposableStore is missing...");const X={label:"",cacheId:K,tooltip:I.MarkdownString.fromStrict(L.tooltip),position:I.Position.from(L.position),textEdits:L.textEdits&&L.textEdits.map(I.TextEdit.from),kind:L.kind&&I.InlayHintKind.from(L.kind),paddingLeft:L.paddingLeft,paddingRight:L.paddingRight};return typeof L.label=="string"?X.label=L.label:X.label=L.label.map(H=>{const x={label:H.value};return x.tooltip=I.MarkdownString.fromStrict(H.tooltip),O.$EK.isLocation(H.location)&&(x.location=I.location.from(H.location)),H.command&&(x.command=this.g.toInternal(H.command,Y)),x}),X}}class J{constructor(L,K){this.e=L,this.f=K,this.d=new l.$Ccc("DocumentLink")}async provideLinks(L,K){const Y=this.e.getDocument(L),X=await this.f.provideDocumentLinks(Y,K);if(!(!Array.isArray(X)||X.length===0)&&!K.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:X.filter(J.g).map(I.DocumentLink.from)};{const H=this.d.add(X),x={links:[],cacheId:H};for(let se=0;se<X.length;se++){if(!J.g(X[se]))continue;const Le=I.DocumentLink.from(X[se]);Le.cacheId=[H,se],x.links.push(Le)}return x}}}static g(L){return L.target&&L.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(L,K){if(typeof this.f.resolveDocumentLink!="function")return;const Y=this.d.get(...L);if(!Y)return;const X=await this.f.resolveDocumentLink(Y,K);if(!(!X||!J.g(X)))return I.DocumentLink.from(X)}releaseLinks(L){this.d.delete(L)}}class he{constructor(L,K){this.d=L,this.e=K}async provideColors(L,K){const Y=this.d.getDocument(L),X=await this.e.provideDocumentColors(Y,K);return Array.isArray(X)?X.map(x=>({color:I.Color.from(x.color),range:I.Range.from(x.range)})):[]}async provideColorPresentations(L,K,Y){const X=this.d.getDocument(L),H=I.Range.to(K.range),x=I.Color.to(K.color),se=await this.e.provideColorPresentations(x,{document:X,range:H},Y);if(Array.isArray(se))return se.map(I.ColorPresentation.from)}}class de{constructor(L,K){this.d=L,this.e=K}async provideFoldingRanges(L,K,Y){const X=this.d.getDocument(L),H=await this.e.provideFoldingRanges(X,K,Y);if(Array.isArray(H))return H.map(I.FoldingRange.from)}}class le{constructor(L,K,Y){this.d=L,this.e=K,this.f=Y}async provideSelectionRanges(L,K,Y){const X=this.d.getDocument(L),H=K.map(I.Position.to),x=await this.e.provideSelectionRanges(X,H,Y);if(!(0,R.$Lb)(x))return[];if(x.length!==H.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const se=[];for(let Le=0;Le<H.length;Le++){const je=[];se.push(je);let Ye=H[Le],Ke=x[Le];for(;;){if(!Ke.range.contains(Ye))throw new Error("INVALID selection range, must contain the previous range");if(je.push(I.SelectionRange.from(Ke)),!Ke.parent)break;Ye=Ke.range,Ke=Ke.parent}}return se}}class be{constructor(L,K){this.f=L,this.g=K,this.d=new i.$wM(""),this.e=new Map}async prepareSession(L,K,Y){const X=this.f.getDocument(L),H=I.Position.to(K),x=await this.g.prepareCallHierarchy(X,H,Y);if(!x)return;const se=this.d.nextId();return this.e.set(se,new Map),Array.isArray(x)?x.map(Le=>this.h(se,Le)):[this.h(se,x)]}async provideCallsTo(L,K,Y){const X=this.j(L,K);if(!X)throw new Error("missing call hierarchy item");const H=await this.g.provideCallHierarchyIncomingCalls(X,Y);if(H)return H.map(x=>({from:this.h(L,x.from),fromRanges:x.fromRanges.map(se=>I.Range.from(se))}))}async provideCallsFrom(L,K,Y){const X=this.j(L,K);if(!X)throw new Error("missing call hierarchy item");const H=await this.g.provideCallHierarchyOutgoingCalls(X,Y);if(H)return H.map(x=>({to:this.h(L,x.to),fromRanges:x.fromRanges.map(se=>I.Range.from(se))}))}releaseSession(L){this.e.delete(L)}h(L,K){const Y=this.e.get(L),X=I.CallHierarchyItem.from(K,L,Y.size.toString(36));return Y.set(X._itemId,K),X}j(L,K){return this.e.get(L)?.get(K)}}class ie{constructor(L,K){this.f=L,this.g=K,this.d=new i.$wM(""),this.e=new Map}async prepareSession(L,K,Y){const X=this.f.getDocument(L),H=I.Position.to(K),x=await this.g.prepareTypeHierarchy(X,H,Y);if(!x)return;const se=this.d.nextId();return this.e.set(se,new Map),Array.isArray(x)?x.map(Le=>this.h(se,Le)):[this.h(se,x)]}async provideSupertypes(L,K,Y){const X=this.j(L,K);if(!X)throw new Error("missing type hierarchy item");const H=await this.g.provideTypeHierarchySupertypes(X,Y);if(H)return H.map(x=>this.h(L,x))}async provideSubtypes(L,K,Y){const X=this.j(L,K);if(!X)throw new Error("missing type hierarchy item");const H=await this.g.provideTypeHierarchySubtypes(X,Y);if(H)return H.map(x=>this.h(L,x))}releaseSession(L){this.e.delete(L)}h(L,K){const Y=this.e.get(L),X=I.TypeHierarchyItem.from(K,L,Y.size.toString(36));return Y.set(X._itemId,K),X}j(L,K){return this.e.get(L)?.get(K)}}class fe{static toInternalProviderId(L,K){return L+"."+K}constructor(L,K,Y,X,H){this.d=L,this.e=K,this.f=Y,this.g=X,this.h=H}async provideDocumentOnDropEdits(L,K,Y,X,H){const x=this.e.getDocument(K),se=I.Position.to(Y),Le=I.DataTransfer.toDataTransfer(X,async Ye=>(await this.d.$resolveDocumentOnDropFileData(this.g,L,Ye)).buffer),je=await this.f.provideDocumentDropEdits(x,se,Le,H);if(je)return{label:je.label??(0,r.localize)(1,null,this.h.displayName||this.h.name),yieldTo:je.yieldTo?.map(Ye=>"mimeType"in Ye?Ye:{providerId:fe.toInternalProviderId(Ye.extensionId,Ye.providerId)}),insertText:typeof je.insertText=="string"?je.insertText:{snippet:je.insertText.value},additionalEdit:je.additionalEdit?I.WorkspaceEdit.from(je.additionalEdit,void 0):void 0}}}class ne{constructor(L,K){this.d=L,this.e=K}async provideMappedEdits(L,K,Y,X){const H=f.URI.revive(L),x=this.d.getDocument(H),se=Y.documents.map(Ye=>Ye.map(Ke=>({uri:f.URI.revive(Ke.uri),version:Ke.version,ranges:Ke.ranges.map(tt=>I.Range.to(tt))}))),Le={documents:se,selections:se[0]?.[0]?.ranges??[]},je=await this.e.provideMappedEdits(x,K,Le,X);return je?I.WorkspaceEdit.from(je):null}}class ce{constructor(L,K){this.adapter=L,this.extension=K}}class pe{constructor(L,K,Y,X,H,x,se,Le){this.g=K,this.h=Y,this.j=X,this.k=H,this.l=x,this.m=se,this.n=Le,this.f=new Map,this.e=L.getProxy(c.$qK.MainThreadLanguageFeatures)}o(L,K){return I.DocumentSelector.from(L,this.g,K)}p(L){return new O.$sK(()=>{this.f.delete(L),this.e.$unregister(L)})}q(){return pe.d++}async s(L,K,Y,X,H,x=!1){const se=this.f.get(L);if(!se||!(se.adapter instanceof K))return X;const Le=Date.now();x||this.l.trace(`[${se.extension.identifier.value}] INVOKE provider '${Y.toString().replace(/[\r\n]/g,"")}'`);const je=Y(se.adapter,se.extension);return Promise.resolve(je).catch(Ye=>{(0,D.$4)(Ye)||(this.l.error(`[${se.extension.identifier.value}] provider FAILED`),this.l.error(Ye),this.n.onExtensionError(se.extension.identifier,Ye))}).finally(()=>{x||this.l.trace(`[${se.extension.identifier.value}] provider DONE after ${Date.now()-Le}ms`)}),b.CancellationToken.isCancellationToken(H)?(0,m.$Kg)(je,H):je}t(L,K){const Y=this.q();return this.f.set(Y,new ce(L,K)),Y}static u(L){return L.displayName||L.name}registerDocumentSymbolProvider(L,K,Y,X){const H=this.t(new s(this.h,Y),L),x=X&&X.label||pe.u(L);return this.e.$registerDocumentSymbolProvider(H,this.o(K,L),x),this.p(H)}$provideDocumentSymbols(L,K,Y){return this.s(L,s,X=>X.provideDocumentSymbols(f.URI.revive(K),Y),void 0,Y)}registerCodeLensProvider(L,K,Y){const X=this.q(),H=typeof Y.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(X,new ce(new o(this.h,this.j.converter,Y),L)),this.e.$registerCodeLensSupport(X,this.o(K,L),H);let x=this.p(X);if(H!==void 0){const se=Y.onDidChangeCodeLenses(Le=>this.e.$emitCodeLensEvent(H));x=O.$sK.from(x,se)}return x}$provideCodeLenses(L,K,Y){return this.s(L,o,X=>X.provideCodeLenses(f.URI.revive(K),Y),void 0,Y)}$resolveCodeLens(L,K,Y){return this.s(L,o,X=>X.resolveCodeLens(K,Y),void 0,void 0)}$releaseCodeLenses(L,K){this.s(L,o,Y=>Promise.resolve(Y.releaseCodeLenses(K)),void 0,void 0)}registerDefinitionProvider(L,K,Y){const X=this.t(new a(this.h,Y),L);return this.e.$registerDefinitionSupport(X,this.o(K,L)),this.p(X)}$provideDefinition(L,K,Y,X){return this.s(L,a,H=>H.provideDefinition(f.URI.revive(K),Y,X),[],X)}registerDeclarationProvider(L,K,Y){const X=this.t(new k(this.h,Y),L);return this.e.$registerDeclarationSupport(X,this.o(K,L)),this.p(X)}$provideDeclaration(L,K,Y,X){return this.s(L,k,H=>H.provideDeclaration(f.URI.revive(K),Y,X),[],X)}registerImplementationProvider(L,K,Y){const X=this.t(new P(this.h,Y),L);return this.e.$registerImplementationSupport(X,this.o(K,L)),this.p(X)}$provideImplementation(L,K,Y,X){return this.s(L,P,H=>H.provideImplementation(f.URI.revive(K),Y,X),[],X)}registerTypeDefinitionProvider(L,K,Y){const X=this.t(new h(this.h,Y),L);return this.e.$registerTypeDefinitionSupport(X,this.o(K,L)),this.p(X)}$provideTypeDefinition(L,K,Y,X){return this.s(L,h,H=>H.provideTypeDefinition(f.URI.revive(K),Y,X),[],X)}registerHoverProvider(L,K,Y,X){const H=this.t(new w(this.h,Y),L);return this.e.$registerHoverProvider(H,this.o(K,L)),this.p(H)}$provideHover(L,K,Y,X){return this.s(L,w,H=>H.provideHover(f.URI.revive(K),Y,X),void 0,X)}registerEvaluatableExpressionProvider(L,K,Y,X){const H=this.t(new y(this.h,Y),L);return this.e.$registerEvaluatableExpressionProvider(H,this.o(K,L)),this.p(H)}$provideEvaluatableExpression(L,K,Y,X){return this.s(L,y,H=>H.provideEvaluatableExpression(f.URI.revive(K),Y,X),void 0,X)}registerInlineValuesProvider(L,K,Y,X){const H=typeof Y.onDidChangeInlineValues=="function"?this.q():void 0,x=this.t(new M(this.h,Y),L);this.e.$registerInlineValuesProvider(x,this.o(K,L),H);let se=this.p(x);if(H!==void 0){const Le=Y.onDidChangeInlineValues(je=>this.e.$emitInlineValuesEvent(H));se=O.$sK.from(se,Le)}return se}$provideInlineValues(L,K,Y,X,H){return this.s(L,M,x=>x.provideInlineValues(f.URI.revive(K),Y,X,H),void 0,H)}registerDocumentHighlightProvider(L,K,Y){const X=this.t(new V(this.h,Y),L);return this.e.$registerDocumentHighlightProvider(X,this.o(K,L)),this.p(X)}$provideDocumentHighlights(L,K,Y,X){return this.s(L,V,H=>H.provideDocumentHighlights(f.URI.revive(K),Y,X),void 0,X)}registerLinkedEditingRangeProvider(L,K,Y){const X=this.t(new B(this.h,Y),L);return this.e.$registerLinkedEditingRangeProvider(X,this.o(K,L)),this.p(X)}$provideLinkedEditingRanges(L,K,Y,X){return this.s(L,B,async H=>{const x=await H.provideLinkedEditingRanges(f.URI.revive(K),Y,X);if(x)return{ranges:x.ranges,wordPattern:x.wordPattern?pe.w(x.wordPattern):void 0}},void 0,X)}registerReferenceProvider(L,K,Y){const X=this.t(new z(this.h,Y),L);return this.e.$registerReferenceSupport(X,this.o(K,L)),this.p(X)}$provideReferences(L,K,Y,X,H){return this.s(L,z,x=>x.provideReferences(f.URI.revive(K),Y,X,H),void 0,H)}registerCodeActionProvider(L,K,Y,X){const H=new g.$Rc,x=this.t(new T(this.h,this.j.converter,this.k,Y,this.l,L,this.m),L);return this.e.$registerQuickFixSupport(x,this.o(K,L),{providedKinds:X?.providedCodeActionKinds?.map(se=>se.value),documentation:X?.documentation?.map(se=>({kind:se.kind.value,command:this.j.converter.toInternal(se.command,H)}))},pe.u(L),!!Y.resolveCodeAction),H.add(this.p(x)),H}$provideCodeActions(L,K,Y,X,H){return this.s(L,T,x=>x.provideCodeActions(f.URI.revive(K),Y,X,H),void 0,H)}$resolveCodeAction(L,K,Y){return this.s(L,T,X=>X.resolveCodeAction(K,Y),{},void 0)}$releaseCodeActions(L,K){this.s(L,T,Y=>Promise.resolve(Y.releaseCodeActions(K)),void 0,void 0)}registerDocumentFormattingEditProvider(L,K,Y){const X=this.t(new j(this.h,Y),L);return this.e.$registerDocumentFormattingSupport(X,this.o(K,L),L.identifier,L.displayName||L.name),this.p(X)}$provideDocumentFormattingEdits(L,K,Y,X){return this.s(L,j,H=>H.provideDocumentFormattingEdits(f.URI.revive(K),Y,X),void 0,X)}registerDocumentRangeFormattingEditProvider(L,K,Y){const X=typeof Y.provideDocumentRangesFormattingEdits=="function",H=this.t(new q(this.h,Y),L);return this.e.$registerRangeFormattingSupport(H,this.o(K,L),L.identifier,L.displayName||L.name,X),this.p(H)}$provideDocumentRangeFormattingEdits(L,K,Y,X,H){return this.s(L,q,x=>x.provideDocumentRangeFormattingEdits(f.URI.revive(K),Y,X,H),void 0,H)}$provideDocumentRangesFormattingEdits(L,K,Y,X,H){return this.s(L,q,x=>x.provideDocumentRangesFormattingEdits(f.URI.revive(K),Y,X,H),void 0,H)}registerOnTypeFormattingEditProvider(L,K,Y,X){const H=this.t(new W(this.h,Y),L);return this.e.$registerOnTypeFormattingSupport(H,this.o(K,L),X,L.identifier),this.p(H)}$provideOnTypeFormattingEdits(L,K,Y,X,H,x){return this.s(L,W,se=>se.provideOnTypeFormattingEdits(f.URI.revive(K),Y,X,H,x),void 0,x)}registerWorkspaceSymbolProvider(L,K){const Y=this.t(new we(K,this.l),L);return this.e.$registerNavigateTypeSupport(Y,typeof K.resolveWorkspaceSymbol=="function"),this.p(Y)}$provideWorkspaceSymbols(L,K,Y){return this.s(L,we,X=>X.provideWorkspaceSymbols(K,Y),{symbols:[]},Y)}$resolveWorkspaceSymbol(L,K,Y){return this.s(L,we,X=>X.resolveWorkspaceSymbol(K,Y),void 0,void 0)}$releaseWorkspaceSymbols(L,K){this.s(L,we,Y=>Y.releaseWorkspaceSymbols(K),void 0,void 0)}registerRenameProvider(L,K,Y){const X=this.t(new ke(this.h,Y,this.l),L);return this.e.$registerRenameSupport(X,this.o(K,L),ke.supportsResolving(Y)),this.p(X)}$provideRenameEdits(L,K,Y,X,H){return this.s(L,ke,x=>x.provideRenameEdits(f.URI.revive(K),Y,X,H),void 0,H)}$resolveRenameLocation(L,K,Y,X){return this.s(L,ke,H=>H.resolveRenameLocation(f.URI.revive(K),Y,X),void 0,X)}registerDocumentSemanticTokensProvider(L,K,Y,X){const H=this.t(new ve(this.h,Y),L),x=typeof Y.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(H,this.o(K,L),X,x);let se=this.p(H);if(x){const Le=Y.onDidChangeSemanticTokens(je=>this.e.$emitDocumentSemanticTokensEvent(x));se=O.$sK.from(se,Le)}return se}$provideDocumentSemanticTokens(L,K,Y,X){return this.s(L,ve,H=>H.provideDocumentSemanticTokens(f.URI.revive(K),Y,X),null,X)}$releaseDocumentSemanticTokens(L,K){this.s(L,ve,Y=>Y.releaseDocumentSemanticColoring(K),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(L,K,Y,X){const H=this.t(new ge(this.h,Y),L);return this.e.$registerDocumentRangeSemanticTokensProvider(H,this.o(K,L),X),this.p(H)}$provideDocumentRangeSemanticTokens(L,K,Y,X){return this.s(L,ge,H=>H.provideDocumentRangeSemanticTokens(f.URI.revive(K),Y,X),null,X)}registerCompletionItemProvider(L,K,Y,X){const H=this.t(new re(this.h,this.j.converter,Y,this.m,L),L);return this.e.$registerCompletionsProvider(H,this.o(K,L),X,re.supportsResolving(Y),L.identifier),this.p(H)}$provideCompletionItems(L,K,Y,X,H){return this.s(L,re,x=>x.provideCompletionItems(f.URI.revive(K),Y,X,H),void 0,H)}$resolveCompletionItem(L,K,Y){return this.s(L,re,X=>X.resolveCompletionItem(K,Y),void 0,Y)}$releaseCompletionItems(L,K){this.s(L,re,Y=>Y.releaseCompletionItems(K),void 0,void 0)}registerInlineCompletionsProvider(L,K,Y,X){const H=new ye(L,this.h,Y,this.j.converter),x=this.t(H,L);return this.e.$registerInlineCompletionsSupport(x,this.o(K,L),H.supportsHandleEvents,p.$8l.toKey(L.identifier.value),X?.yieldTo?.map(se=>p.$8l.toKey(se))||[]),this.p(x)}$provideInlineCompletions(L,K,Y,X,H){return this.s(L,oe,x=>x.provideInlineCompletions(f.URI.revive(K),Y,X,H),void 0,H)}$handleInlineCompletionDidShow(L,K,Y,X){this.s(L,oe,async H=>{H.handleDidShowCompletionItem(K,Y,X)},void 0,void 0)}$handleInlineCompletionPartialAccept(L,K,Y,X){this.s(L,oe,async H=>{H.handlePartialAccept(K,Y,X)},void 0,void 0)}$freeInlineCompletionsList(L,K){this.s(L,oe,async Y=>{Y.disposeCompletions(K)},void 0,void 0)}registerSignatureHelpProvider(L,K,Y,X){const H=Array.isArray(X)?{triggerCharacters:X,retriggerCharacters:[]}:X,x=this.t(new Q(this.h,Y),L);return this.e.$registerSignatureHelpProvider(x,this.o(K,L),H),this.p(x)}$provideSignatureHelp(L,K,Y,X,H){return this.s(L,Q,x=>x.provideSignatureHelp(f.URI.revive(K),Y,X,H),void 0,H)}$releaseSignatureHelp(L,K){this.s(L,Q,Y=>Y.releaseSignatureHelp(K),void 0,void 0)}registerInlayHintsProvider(L,K,Y){const X=typeof Y.onDidChangeInlayHints=="function"?this.q():void 0,H=this.t(new ue(this.h,this.j.converter,Y,this.l,L),L);this.e.$registerInlayHintsProvider(H,this.o(K,L),typeof Y.resolveInlayHint=="function",X,pe.u(L));let x=this.p(H);if(X!==void 0){const se=Y.onDidChangeInlayHints(Le=>this.e.$emitInlayHintsEvent(X));x=O.$sK.from(x,se)}return x}$provideInlayHints(L,K,Y,X){return this.s(L,ue,H=>H.provideInlayHints(f.URI.revive(K),Y,X),void 0,X)}$resolveInlayHint(L,K,Y){return this.s(L,ue,X=>X.resolveInlayHint(K,Y),void 0,Y)}$releaseInlayHints(L,K){this.s(L,ue,Y=>Y.releaseHints(K),void 0,void 0)}registerDocumentLinkProvider(L,K,Y){const X=this.t(new J(this.h,Y),L);return this.e.$registerDocumentLinkProvider(X,this.o(K,L),typeof Y.resolveDocumentLink=="function"),this.p(X)}$provideDocumentLinks(L,K,Y){return this.s(L,J,X=>X.provideLinks(f.URI.revive(K),Y),void 0,Y,K.scheme==="output")}$resolveDocumentLink(L,K,Y){return this.s(L,J,X=>X.resolveLink(K,Y),void 0,void 0,!0)}$releaseDocumentLinks(L,K){this.s(L,J,Y=>Y.releaseLinks(K),void 0,void 0,!0)}registerColorProvider(L,K,Y){const X=this.t(new he(this.h,Y),L);return this.e.$registerDocumentColorProvider(X,this.o(K,L)),this.p(X)}$provideDocumentColors(L,K,Y){return this.s(L,he,X=>X.provideColors(f.URI.revive(K),Y),[],Y)}$provideColorPresentations(L,K,Y,X){return this.s(L,he,H=>H.provideColorPresentations(f.URI.revive(K),Y,X),void 0,X)}registerFoldingRangeProvider(L,K,Y){const X=this.q(),H=typeof Y.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(X,new ce(new de(this.h,Y),L)),this.e.$registerFoldingRangeProvider(X,this.o(K,L),L.identifier,H);let x=this.p(X);if(H!==void 0){const se=Y.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(H));x=O.$sK.from(x,se)}return x}$provideFoldingRanges(L,K,Y,X){return this.s(L,de,H=>H.provideFoldingRanges(f.URI.revive(K),Y,X),void 0,X)}registerSelectionRangeProvider(L,K,Y){const X=this.t(new le(this.h,Y,this.l),L);return this.e.$registerSelectionRangeProvider(X,this.o(K,L)),this.p(X)}$provideSelectionRanges(L,K,Y,X){return this.s(L,le,H=>H.provideSelectionRanges(f.URI.revive(K),Y,X),[],X)}registerCallHierarchyProvider(L,K,Y){const X=this.t(new be(this.h,Y),L);return this.e.$registerCallHierarchyProvider(X,this.o(K,L)),this.p(X)}$prepareCallHierarchy(L,K,Y,X){return this.s(L,be,H=>Promise.resolve(H.prepareSession(f.URI.revive(K),Y,X)),void 0,X)}$provideCallHierarchyIncomingCalls(L,K,Y,X){return this.s(L,be,H=>H.provideCallsTo(K,Y,X),void 0,X)}$provideCallHierarchyOutgoingCalls(L,K,Y,X){return this.s(L,be,H=>H.provideCallsFrom(K,Y,X),void 0,X)}$releaseCallHierarchy(L,K){this.s(L,be,Y=>Promise.resolve(Y.releaseSession(K)),void 0,void 0)}registerTypeHierarchyProvider(L,K,Y){const X=this.t(new ie(this.h,Y),L);return this.e.$registerTypeHierarchyProvider(X,this.o(K,L)),this.p(X)}$prepareTypeHierarchy(L,K,Y,X){return this.s(L,ie,H=>Promise.resolve(H.prepareSession(f.URI.revive(K),Y,X)),void 0,X)}$provideTypeHierarchySupertypes(L,K,Y,X){return this.s(L,ie,H=>H.provideSupertypes(K,Y,X),void 0,X)}$provideTypeHierarchySubtypes(L,K,Y,X){return this.s(L,ie,H=>H.provideSubtypes(K,Y,X),void 0,X)}$releaseTypeHierarchy(L,K){this.s(L,ie,Y=>Promise.resolve(Y.releaseSession(K)),void 0,void 0)}registerDocumentOnDropEditProvider(L,K,Y,X){const H=this.q();this.f.set(H,new ce(new fe(this.e,this.h,Y,H,L),L));const x=(0,n.$lF)(L,"dropMetadata")&&X?fe.toInternalProviderId(L.identifier.value,X.id):void 0;return this.e.$registerDocumentOnDropEditProvider(H,this.o(K,L),x,(0,n.$lF)(L,"dropMetadata")?X:void 0),this.p(H)}$provideDocumentOnDropEdits(L,K,Y,X,H,x){return this.s(L,fe,se=>Promise.resolve(se.provideDocumentOnDropEdits(K,f.URI.revive(Y),X,H,x)),void 0,void 0)}registerMappedEditsProvider(L,K,Y){const X=this.t(new ne(this.h,Y),L);return this.e.$registerMappedEditsProvider(X,this.o(K,L)),this.p(X)}$provideMappedEdits(L,K,Y,X,H){return this.s(L,ne,x=>Promise.resolve(x.provideMappedEdits(K,Y,X,H)),null,H)}registerDocumentPasteEditProvider(L,K,Y,X){const H=this.q();this.f.set(H,new ce(new F(this.e,this.h,Y,H,L),L));const x=F.toInternalProviderId(L.identifier.value,X.id);return this.e.$registerPasteEditProvider(H,this.o(K,L),x,{supportsCopy:!!Y.prepareDocumentPaste,supportsPaste:!!Y.provideDocumentPasteEdits,copyMimeTypes:X.copyMimeTypes,pasteMimeTypes:X.pasteMimeTypes}),this.p(H)}$prepareDocumentPaste(L,K,Y,X,H){return this.s(L,F,x=>x.prepareDocumentPaste(f.URI.revive(K),Y,X,H),void 0,H)}$providePasteEdits(L,K,Y,X,H,x){return this.s(L,F,se=>se.providePasteEdits(K,f.URI.revive(Y),X,H,x),void 0,x)}static w(L){return{pattern:L.source,flags:L.flags}}static y(L){return{decreaseIndentPattern:pe.w(L.decreaseIndentPattern),increaseIndentPattern:pe.w(L.increaseIndentPattern),indentNextLinePattern:L.indentNextLinePattern?pe.w(L.indentNextLinePattern):void 0,unIndentedLinePattern:L.unIndentedLinePattern?pe.w(L.unIndentedLinePattern):void 0}}static z(L){return{beforeText:pe.w(L.beforeText),afterText:L.afterText?pe.w(L.afterText):void 0,previousLineText:L.previousLineText?pe.w(L.previousLineText):void 0,action:L.action}}static B(L){return L.map(pe.z)}static C(L){return{open:L.open,close:L.close,notIn:L.notIn?L.notIn.map(K=>O.SyntaxTokenType.toString(K)):void 0}}static D(L){return L.map(pe.C)}setLanguageConfiguration(L,K,Y){const{wordPattern:X}=Y;if(X&&(0,E.$Pe)(X))throw new Error(`Invalid language configuration: wordPattern '${X}' is not allowed to match the empty string.`);X?this.h.setWordDefinitionFor(K,X):this.h.setWordDefinitionFor(K,void 0),Y.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",L,"Do not use."),Y.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",L,"Do not use.");const H=this.q(),x={comments:Y.comments,brackets:Y.brackets,wordPattern:Y.wordPattern?pe.w(Y.wordPattern):void 0,indentationRules:Y.indentationRules?pe.y(Y.indentationRules):void 0,onEnterRules:Y.onEnterRules?pe.B(Y.onEnterRules):void 0,__electricCharacterSupport:Y.__electricCharacterSupport,__characterPairSupport:Y.__characterPairSupport,autoClosingPairs:Y.autoClosingPairs?pe.D(Y.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(H,K,x),this.p(H)}$setWordDefinitions(L){for(const K of L)this.h.setWordDefinitionFor(K.languageId,new RegExp(K.regexSource,K.regexFlags))}}e.$Lcc=pe,pe.d=0}),define(Ae[243],Re([1,0,3,8,7,29,12,6,22]),function(ee,e,f,C,I,O,A,c,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tdc=void 0;class d{constructor(S,u,b,p){this.c=u,this.d=b,this.e=p,this.b=[],this.f=0,this.g=new Set,this.a=S.getProxy(f.$qK.MainThreadLanguages)}$acceptLanguageIds(S){this.b=S}async getLanguages(){return this.b.slice(0)}async changeLanguage(S,u){await this.a.$changeLanguage(S,u);const b=this.c.getDocumentData(S);if(!b)throw new Error(`document '${S.toString()}' NOT found`);return b.document}async tokenAtPosition(S,u){const b=S.version,p=C.Position.from(u),g=await this.a.$tokensAtPosition(S.uri,p),t={type:I.StandardTokenType.Other,range:S.getWordRangeAtPosition(u)??new I.$uK(u.line,u.character,u.line,u.character)};if(!g)return t;const i={range:C.Range.to(g.range),type:C.TokenType.to(g.type)};return!i.range.contains(u)||b!==S.version?t:i}createLanguageStatusItem(S,u,b){const p=this.f++,g=this.a,t=this.g,i=`${S.identifier.value}/${u}`;if(t.has(i))throw new Error(`LanguageStatusItem with id '${u}' ALREADY exists`);t.add(i);const l={selector:b,id:u,name:S.displayName??S.name,severity:I.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let v;const D=new c.$Rc,m=()=>{if(v?.dispose(),!t.has(i)){console.warn(`LanguageStatusItem (${u}) from ${S.identifier.value} has been disposed and CANNOT be updated anymore`);return}v=(0,A.$Wg)(()=>{D.clear(),this.a.$setLanguageStatus(p,{id:i,name:l.name??S.displayName??S.name,source:S.displayName??S.name,selector:C.DocumentSelector.from(l.selector,this.e),label:l.text,detail:l.detail??"",severity:l.severity===I.LanguageStatusSeverity.Error?O.default.Error:l.severity===I.LanguageStatusSeverity.Warning?O.default.Warning:O.default.Info,command:l.command&&this.d.toInternal(l.command,D),accessibilityInfo:l.accessibilityInformation,busy:l.busy})},0)},n={dispose(){D.dispose(),v?.dispose(),g.$removeLanguageStatus(p),t.delete(i)},get id(){return l.id},get name(){return l.name},set name(r){l.name=r,m()},get selector(){return l.selector},set selector(r){l.selector=r,m()},get text(){return l.text},set text(r){l.text=r,m()},set text2(r){(0,E.$mF)(S,"languageStatusText"),l.text=r,m()},get text2(){return(0,E.$mF)(S,"languageStatusText"),l.text},get detail(){return l.detail},set detail(r){l.detail=r,m()},get severity(){return l.severity},set severity(r){l.severity=r,m()},get accessibilityInformation(){return l.accessibilityInformation},set accessibilityInformation(r){l.accessibilityInformation=r,m()},get command(){return l.command},set command(r){l.command=r,m()},get busy(){return l.busy},set busy(r){l.busy=r,m()}};return m(),n}}e.$tdc=d}),define(Ae[81],Re([1,0,23,16,2,4,14,3,27,17]),function(ee,e,f,C,I,O,A,c,E,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jdc=e.$idc=void 0;let R=class{constructor(u,b,p){this.f=p,this.d=new Map,this.a=b.getProxy(c.$qK.MainThreadLocalization),this.b=u.environment.appLanguage,this.c=this.b===f.$a}getMessage(u,b){const{message:p,args:g,comment:t}=b;if(this.c)return(0,C.$Ee)(p,g??{});let i=p;t&&t.length>0&&(i+=`/${Array.isArray(t)?t.join(""):t}`);const l=this.d.get(u)?.contents[i];return l||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${i}`),(0,C.$Ee)(l??p,g??{})}getBundle(u){return this.d.get(u)?.contents}getBundleUri(u){return this.d.get(u)?.uri}async initializeLocalizedMessages(u){if(this.c||!u.l10n&&!u.isBuiltin||this.d.has(u.identifier.value))return;let b;const p=await this.g(u);if(!p){this.f.error(`No bundle location found for extension ${u.identifier.value}`);return}try{const g=await this.a.$fetchBundleContents(p),t=JSON.parse(g);b=u.isBuiltin?t.contents?.bundle:t}catch(g){this.f.error(`Failed to load translations for ${u.identifier.value} from ${p}: ${g.message}`);return}b&&this.d.set(u.identifier.value,{contents:b,uri:p})}async g(u){if(u.isBuiltin){const b=await this.a.$fetchBuiltInBundleUri(u.identifier.value,this.b);return I.URI.revive(b)}return u.l10n?I.URI.joinPath(u.extensionLocation,u.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$idc=R,e.$idc=R=Ge([qe(0,E.$HM),qe(1,d.$rM),qe(2,A.$$i)],R),e.$jdc=(0,O.$Qh)("IExtHostLocalizationService")}),define(Ae[244],Re([1,0,14,3,27,17,2,67]),function(ee,e,f,C,I,O,A,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lec=void 0;let E=class extends f.$jj{constructor(S,u){super(u.logLevel,u.logsLocation,u.loggers.map(b=>(0,c.$nh)(b))),this.r=S.getProxy(C.$qK.MainThreadLogger)}$setLogLevel(S,u){u?this.setLogLevel(A.URI.revive(u),S):this.setLogLevel(S)}setVisibility(S,u){super.setVisibility(S,u),this.r.$setVisibility(S,u)}s(S,u,b){return new d(this.r,S,u,b)}};e.$Lec=E,e.$Lec=E=Ge([qe(0,O.$rM),qe(1,I.$HM)],E);class d extends f.$ej{constructor(S,u,b,p){super(p?.logLevel==="always"),this.r=S,this.s=u,this.m=!1,this.n=[],this.setLevel(b),this.r.$createLogger(u,p).then(()=>{this.u(this.n),this.m=!0})}g(S,u){const b=[[S,u]];this.m?this.u(b):this.n.push(...b)}u(S){this.r.$log(this.s,S)}flush(){this.r.$flush(this.s)}}}),define(Ae[82],Re([1,0,3,4,6,17,26]),function(ee,e,f,C,I,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ldc=e.$kdc=void 0,e.$kdc=(0,C.$Qh)("IExtHostManagedSockets");let c=class{constructor(S){this.b=0,this.c=null,this.d=new Map,this.a=S.getProxy(f.$qK.MainThreadManagedSockets)}setFactory(S,u){for(const b of this.d.values())b.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new E(S,u),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(S){if(!this.c||this.c.socketFactoryId!==S)throw new Error(`No socket factory with id ${S}`);const u=++this.b,b=await this.c.makeConnection(),p=new I.$Rc;return this.d.set(u,new d(u,b,p)),p.add((0,I.$Qc)(()=>this.d.delete(u))),p.add(b.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(u),p.dispose()})),p.add(b.onDidClose(g=>{this.a.$onDidManagedSocketClose(u,g?.stack??g?.message),p.dispose()})),p.add(b.onDidReceiveMessage(g=>this.a.$onDidManagedSocketHaveData(u,A.$ce.wrap(g)))),u}$remoteSocketWrite(S,u){this.d.get(S)?.actual.send(u.buffer)}$remoteSocketEnd(S){const u=this.d.get(S);u&&(u.actual.end(),u.dispose())}async $remoteSocketDrain(S){await this.d.get(S)?.actual.drain?.()}};e.$ldc=c,e.$ldc=c=Ge([qe(0,O.$rM)],c);class E{constructor(S,u){this.socketFactoryId=S,this.makeConnection=u}}class d extends I.$Sc{constructor(S,u,b){super(),this.socketId=S,this.actual=u,this.B(b)}}}),define(Ae[245],Re([1,0,3,14,22]),function(ee,e,f,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$udc=void 0;function O(c){return c&&c.title}let A=class{constructor(E,d){this.b=d,this.a=E.getProxy(f.$qK.MainThreadMessageService)}showMessage(E,d,R,S,u){const b={source:{identifier:E.identifier,label:E.displayName||E.name}};let p;typeof S=="string"||O(S)?p=[S,...u]:(b.modal=S?.modal,b.useCustom=S?.useCustom,b.detail=S?.detail,p=u),b.useCustom&&(0,I.$mF)(E,"resolvers");const g=[];for(let t=0;t<p.length;t++){const i=p[t];if(typeof i=="string")g.push({title:i,handle:t,isCloseAffordance:!1});else if(typeof i=="object"){const{title:l,isCloseAffordance:v}=i;g.push({title:l,isCloseAffordance:!!v,handle:t})}else this.b.warn("Invalid message item:",i)}return this.a.$showMessage(d,R,b,g).then(t=>{if(typeof t=="number")return p[t]})}};e.$udc=A,e.$udc=A=Ge([qe(1,C.$$i)],A)}),define(Ae[246],Re([1,0,152,26,5,6,28,16,15,2,39,74,3,31,8,7,47,208,104,11,25,13]),function(ee,e,f,C,I,O,A,c,E,d,R,S,u,b,p,g,t,i,l,v,D,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cec=void 0;class n{get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(s=>s.apiEditor)}constructor(s,o,$,a,k){this.q=$,this.r=a,this.s=k,this.f=new Map,this.g=new A.$Ac,this.h=new Map,this.j=new I.$Od({onListenerError:v.$2}),this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new I.$Od({onListenerError:v.$2}),this.onDidOpenNotebookDocument=this.m.event,this.n=new I.$Od({onListenerError:v.$2}),this.onDidCloseNotebookDocument=this.n.event,this.o=new I.$Od({onListenerError:v.$2}),this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new S.$Ccc("NotebookCellStatusBarCache"),this.u=0,this.w=new Map,this.b=s.getProxy(u.$qK.MainThreadNotebook),this.c=s.getProxy(u.$qK.MainThreadNotebookDocuments),this.d=s.getProxy(u.$qK.MainThreadNotebookEditors),this.i=o.converter,o.registerArgumentProcessor({processArgument:P=>{if(P&&P.$mid===13){const h=P.notebookEditor?.notebookUri,w=P.cell.handle,M=this.g.get(h)?.getCell(w);if(M)return M.apiCell}if(P&&P.$mid===14){const h=P.uri,w=this.g.get(h);if(w)return w.apiNotebook}return P}}),n.A(o)}getEditorById(s){const o=this.h.get(s);if(!o)throw new Error(`unknown text editor: ${s}. known editors: ${[...this.h.keys()]} `);return o}getIdByEditor(s){for(const[o,$]of this.h)if($.apiEditor===s)return o}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(s,o){const $=this.g.get(s);if(!$&&!o)throw new Error(`NO notebook document for '${s}'`);return $}static t(s,o){if(!o)return;const $=o.filenamePattern.map(a=>p.NotebookExclusiveDocumentPattern.from(a)).filter(a=>a!==void 0);if(o.filenamePattern&&!$){console.warn(`Notebook content provider view options file name pattern is invalid ${o.filenamePattern}`);return}return{extension:s.identifier,providerDisplayName:s.displayName||s.name,displayName:o.displayName,filenamePattern:$,exclusive:o.exclusive||!1}}registerNotebookCellStatusBarItemProvider(s,o,$){const a=n.a++,k=typeof $.onDidChangeCellStatusBarItems=="function"?n.a++:void 0;this.f.set(a,$),this.b.$registerNotebookCellStatusBarItemProvider(a,k,o);let P;return k!==void 0&&(P=$.onDidChangeCellStatusBarItems(h=>this.b.$emitCellStatusBarEvent(k))),new g.$sK(()=>{this.f.delete(a),this.b.$unregisterNotebookCellStatusBarItemProvider(a,k),P?.dispose()})}async createNotebookDocument(s){const o=await this.c.$tryCreateNotebook({viewType:s.viewType,content:s.content&&p.NotebookData.from(s.content)});return d.URI.revive(o)}async openNotebookDocument(s){const o=this.g.get(s);if(o)return o.apiNotebook;const $=await this.c.$tryOpenNotebook(s),a=this.g.get(d.URI.revive($));return(0,E.$Kf)(a?.apiNotebook)}async showNotebookDocument(s,o){d.URI.isUri(s)&&(s=await this.openNotebookDocument(s));let $;typeof o=="object"?$={position:p.ViewColumn.from(o.viewColumn),preserveFocus:o.preserveFocus,selections:o.selections&&o.selections.map(p.NotebookRange.from),pinned:typeof o.preview=="boolean"?!o.preview:void 0}:$={preserveFocus:!1};const a=await this.d.$tryShowNotebookDocument(s.uri,s.notebookType,$),k=a&&this.h.get(a)?.apiEditor;if(k)return k;throw a?new Error(`Could NOT open editor for "${s.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${s.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(s,o,$,a){const k=this.f.get(s),P=d.URI.revive(o),h=this.g.get(P);if(!h||!k)return;const w=h.getCellFromIndex($);if(!w)return;const y=await k.provideCellStatusBarItems(w.apiCell,a);if(!y)return;const M=new O.$Rc,V=this.p.add([M]),z=(Array.isArray(y)?y:[y]).map(T=>p.NotebookStatusBarItem.from(T,this.i,M));return{cacheId:V,items:z}}$releaseNotebookCellStatusBarItems(s){this.p.delete(s)}registerNotebookSerializer(s,o,$,a,k){if((0,c.$Ce)(o))throw new Error("viewType cannot be empty or just whitespace");const P=this.u++;return this.w.set(P,{viewType:o,serializer:$,options:a}),this.b.$registerNotebookSerializer(P,{id:s.identifier,location:s.extensionLocation},o,p.NotebookDocumentContentOptions.from(a),n.t(s,k)),(0,O.$Qc)(()=>{this.b.$unregisterNotebookSerializer(P)})}async $dataToNotebook(s,o,$){const a=this.w.get(s);if(!a)throw new Error("NO serializer found");const k=await a.serializer.deserializeNotebook(o.buffer,$);return new t.$vv(p.NotebookData.from(k))}async $notebookToData(s,o,$){const a=this.w.get(s);if(!a)throw new Error("NO serializer found");const k=await a.serializer.serializeNotebook(p.NotebookData.to(o.value),$);return C.$ce.wrap(k)}async $saveNotebook(s,o,$,a,k){const P=d.URI.revive(o),h=this.w.get(s);if(!h)throw new Error("NO serializer found");const w=this.g.get(P);if(!w)throw new Error("Document NOT found");if(w.versionId!==$)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(P.scheme))throw new R.$uk((0,f.localize)(0,null,this.y(P)),6);await this.x(P,a);const y={metadata:(0,D.$en)(w.apiNotebook.metadata,T=>!(h.options?.transientDocumentMetadata??{})[T]),cells:[]};for(const T of w.apiNotebook.getCells()){const F=new g.$QL(T.kind,T.document.getText(),T.document.languageId,T.mime,h.options?.transientOutputs?[]:[...T.outputs],T.metadata,T.executionSummary);F.metadata=(0,D.$en)(T.metadata,j=>!(h.options?.transientCellMetadata??{})[j]),y.cells.push(F)}const M=await h.serializer.serializeNotebook(y,k);await this.s.value.writeFile(P,M);const V=this.s.getFileSystemProviderExtUri(P.scheme),B=await this.s.value.stat(P);return{name:V.basename(P),isFile:(B.type&R.FileType.File)!==0,isDirectory:(B.type&R.FileType.Directory)!==0,isSymbolicLink:(B.type&R.FileType.SymbolicLink)!==0,mtime:B.mtime,ctime:B.ctime,size:B.size,readonly:!!((B.permissions??0)&R.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(P.scheme),locked:!!((B.permissions??0)&R.FilePermission.Locked),etag:R.$Fk({mtime:B.mtime,size:B.size}),children:void 0}}async x(s,o){const $=await this.s.value.stat(s);if(typeof o?.mtime=="number"&&typeof o.etag=="string"&&o.etag!==R.$Ek&&typeof $.mtime=="number"&&typeof $.size=="number"&&o.mtime<$.mtime&&o.etag!==R.$Fk({mtime:o.mtime,size:$.size}))throw new R.$uk((0,f.localize)(1,null),3,o)}y(s){return s.scheme===m.Schemas.file?s.fsPath:s.toString()}z(s,o,$){if(this.h.has(o))throw new Error(`editor with id ALREADY EXSIST: ${o}`);const a=new l.$bec(o,this.d,s,$.visibleRanges.map(p.NotebookRange.to),$.selections.map(p.NotebookRange.to),typeof $.viewColumn=="number"?p.ViewColumn.to($.viewColumn):void 0);this.h.set(o,a)}$acceptDocumentAndEditorsDelta(s){if(s.value.removedDocuments)for(const $ of s.value.removedDocuments){const a=d.URI.revive($),k=this.g.get(a);k&&(k.dispose(),this.g.delete(a),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:k.apiNotebook.getCells().map(P=>P.document.uri)}),this.n.fire(k.apiNotebook));for(const P of this.h.values())P.notebookData.uri.toString()===a.toString()&&this.h.delete(P.id)}if(s.value.addedDocuments){const $=[];for(const a of s.value.addedDocuments){const k=d.URI.revive(a.uri);if(this.g.has(k))throw new Error(`adding EXISTING notebook ${k} `);const P=new i.$aec(this.c,this.q,this.r,k,a);$.push(...a.cells.map(h=>i.$_dc.asModelAddData(P.apiNotebook,h))),this.g.get(k)?.dispose(),this.g.set(k,P),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:$}),this.m.fire(P.apiNotebook)}}if(s.value.addedEditors)for(const $ of s.value.addedEditors){if(this.h.has($.id))return;const a=d.URI.revive($.documentUri),k=this.g.get(a);k&&this.z(k,$.id,$)}const o=[];if(s.value.removedEditors)for(const $ of s.value.removedEditors){const a=this.h.get($);a&&(this.h.delete($),this.k?.id===a.id&&(this.k=void 0),o.push(a))}if(s.value.visibleEditors){this.l=s.value.visibleEditors.map(a=>this.h.get(a)).filter(a=>!!a);const $=new Set;this.l.forEach(a=>$.add(a.id));for(const a of this.h.values()){const k=$.has(a.id);a._acceptVisibility(k)}this.l=[...this.h.values()].map(a=>a).filter(a=>a.visible),this.o.fire(this.visibleNotebookEditors)}s.value.newActiveEditor===null?this.k=void 0:s.value.newActiveEditor&&(this.h.get(s.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${s.value.newActiveEditor}`),this.k=this.h.get(s.value.newActiveEditor)),s.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static A(s){const o=b.$PM.String.with("notebookType","A notebook type"),$=new b.$RM("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[o,new b.$PM("data","Bytes to convert to data",k=>k instanceof Uint8Array,k=>C.$ce.wrap(k))],new b.$QM("Notebook Data",k=>p.NotebookData.to(k.value))),a=new b.$RM("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[o,new b.$PM("NotebookData","Notebook data to convert to bytes",k=>!0,k=>new t.$vv(p.NotebookData.from(k)))],new b.$QM("Bytes",k=>k.buffer));s.registerApiCommand($),s.registerApiCommand(a)}}e.$cec=n,n.a=0}),define(Ae[247],Re([1,0,18,12,19,5,6,28,2,21,14,3,31,8,7,77,199,22,47]),function(ee,e,f,C,I,O,A,c,E,d,R,S,u,b,p,g,t,i,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rec=e.$qec=void 0;let v=class{constructor(a,k,P,h,w){this.l=k,this.m=P,this.n=h,this.o=w,this.b=new c.$Ac,this.c=new c.$Ac,this.e=new Map,this.f=0,this.g=new Map,this.h=0,this.i=new Map,this.j=0,this.k=new O.$Od,this.onDidChangeNotebookCellExecutionState=this.k.event,this.a=a.getProxy(S.$qK.MainThreadNotebookKernels);const y=new u.$RM("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new u.$PM("options","Select kernel options",M=>!0,M=>{if(M&&"notebookEditor"in M&&"id"in M){const V=this.m.getIdByEditor(M.notebookEditor);return{id:M.id,extension:M.extension,notebookEditorId:V}}else if(M&&"notebookEditor"in M){const V=this.m.getIdByEditor(M.notebookEditor);if(V===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${M.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:V}}return M})],u.$QM.Void);this.n.registerApiCommand(y)}createNotebookController(a,k,P,h,w,y){for(const ge of this.i.values())if(ge.controller.id===k&&d.$8l.equals(a.identifier,ge.extensionId))throw new Error(`notebook controller with id '${k}' ALREADY exist`);const M=this.j++,V=this;this.o.trace(`NotebookController[${M}], CREATED by ${a.identifier.value}, ${k}`);const B=()=>console.warn(`NO execute handler from notebook controller '${j.id}' of extension: '${a.identifier}'`);let z=!1;const T=new O.$Od,F=new O.$Od,j={id:o(a.identifier,k),notebookType:P,extensionId:a.identifier,extensionLocation:a.extensionLocation,label:h||a.identifier.value,preloads:y?y.map(b.NotebookRendererScript.from):[]};let q=w??B,W;this.a.$addKernel(M,j).catch(ge=>{console.log(ge),z=!0});let we=0;const ke=()=>{if(z)return;const ge=++we;Promise.resolve().then(()=>{ge===we&&this.a.$updateKernel(M,j)})},Se=new c.$Ac,ve={get id(){return k},get notebookType(){return j.notebookType},onDidChangeSelectedNotebooks:T.event,get label(){return j.label},set label(ge){j.label=ge??a.displayName??a.name,ke()},get detail(){return j.detail??""},set detail(ge){j.detail=ge,ke()},get description(){return j.description??""},set description(ge){j.description=ge,ke()},get supportedLanguages(){return j.supportedLanguages},set supportedLanguages(ge){j.supportedLanguages=ge,ke()},get supportsExecutionOrder(){return j.supportsExecutionOrder??!1},set supportsExecutionOrder(ge){j.supportsExecutionOrder=ge,ke()},get rendererScripts(){return j.preloads?j.preloads.map(b.NotebookRendererScript.to):[]},get executeHandler(){return q},set executeHandler(ge){q=ge??B},get interruptHandler(){return W},set interruptHandler(ge){W=ge,j.supportsInterrupt=!!ge,ke()},createNotebookCellExecution(ge){if(z)throw new Error("notebook controller is DISPOSED");if(!Se.has(ge.notebook.uri))throw V.o.trace(`NotebookController[${M}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(Se.keys()).map(re=>re.toString())),new Error(`notebook controller is NOT associated to notebook: ${ge.notebook.uri.toString()}`);return V._createNotebookCellExecution(ge,o(a.identifier,this.id))},createNotebookExecution(ge){if((0,i.$mF)(a,"notebookExecution"),z)throw new Error("notebook controller is DISPOSED");if(!Se.has(ge.uri))throw V.o.trace(`NotebookController[${M}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(Se.keys()).map(re=>re.toString())),new Error(`notebook controller is NOT associated to notebook: ${ge.uri.toString()}`);return V._createNotebookExecution(ge,o(a.identifier,this.id))},dispose:()=>{z||(this.o.trace(`NotebookController[${M}], DISPOSED`),z=!0,this.i.delete(M),T.dispose(),F.dispose(),this.a.$removeKernel(M))},updateNotebookAffinity(ge,re){re===p.NotebookControllerAffinity2.Hidden&&(0,i.$mF)(a,"notebookControllerAffinityHidden"),V.a.$updateNotebookPriority(M,ge.uri,re)},onDidReceiveMessage:F.event,postMessage(ge,re){return(0,i.$mF)(a,"notebookMessaging"),V.a.$postMessage(M,re&&V.m.getIdByEditor(re),ge)},asWebviewUri(ge){return(0,i.$mF)(a,"notebookMessaging"),(0,g.$spb)(ge,V.l.remote)}};return this.i.set(M,{extensionId:a.identifier,controller:ve,onDidReceiveMessage:F,onDidChangeSelection:T,associatedNotebooks:Se}),ve}getIdByController(a){for(const[k,P]of this.i)if(P.controller===a)return o(P.extensionId,a.id);return null}createNotebookControllerDetectionTask(a,k){const P=this.f++,h=this;this.o.trace(`NotebookControllerDetectionTask[${P}], CREATED by ${a.identifier.value}`),this.a.$addKernelDetectionTask(P,k);const w={dispose:()=>{this.e.delete(P),h.a.$removeKernelDetectionTask(P)}};return this.e.set(P,w),w}registerKernelSourceActionProvider(a,k,P){const h=this.h++,w=typeof P.onDidChangeNotebookKernelSourceActions=="function"?h:void 0,y=this;this.g.set(h,P),this.o.trace(`NotebookKernelSourceActionProvider[${h}], CREATED by ${a.identifier.value}`),this.a.$addKernelSourceActionProvider(h,h,k);let M;return w!==void 0&&(M=P.onDidChangeNotebookKernelSourceActions(V=>this.a.$emitNotebookKernelSourceActionsChangeEvent(w))),{dispose:()=>{this.g.delete(h),y.a.$removeKernelSourceActionProvider(h,h),M?.dispose()}}}async $provideKernelSourceActions(a,k){const P=this.g.get(a);if(P){const h=new A.$Rc;return(await P.provideNotebookKernelSourceActions(k)??[]).map(y=>b.NotebookKernelSourceAction.from(y,this.n.converter,h))}return[]}$acceptNotebookAssociation(a,k,P){const h=this.i.get(a);if(h){const w=this.m.getNotebookDocument(E.URI.revive(k));P?h.associatedNotebooks.set(w.uri,!0):h.associatedNotebooks.delete(w.uri),this.o.trace(`NotebookController[${a}] ASSOCIATE notebook`,w.uri.toString(),P),h.onDidChangeSelection.fire({selected:P,notebook:w.apiNotebook})}}async $executeCells(a,k,P){const h=this.i.get(a);if(!h)return;const w=this.m.getNotebookDocument(E.URI.revive(k)),y=[];for(const M of P){const V=w.getCell(M);V&&y.push(V.apiCell)}try{this.o.trace(`NotebookController[${a}] EXECUTE cells`,w.uri.toString(),y.length),await h.controller.executeHandler.call(h.controller,y,w.apiNotebook,h.controller)}catch(M){this.o.error(`NotebookController[${a}] execute cells FAILED`,M),console.error(M)}}async $cancelCells(a,k,P){const h=this.i.get(a);if(!h)return;const w=this.m.getNotebookDocument(E.URI.revive(k));if(h.controller.interruptHandler)await h.controller.interruptHandler.call(h.controller,w.apiNotebook);else for(const y of P){const M=w.getCell(y);M&&this.b.get(M.uri)?.cancel()}if(h.controller.interruptHandler){const y=this.c.get(w.uri);P.length&&Array.isArray(y)&&y.length&&y.forEach(M=>M.dispose())}}$acceptKernelMessageFromRenderer(a,k,P){const h=this.i.get(a);if(!h)return;const w=this.m.getEditorById(k);h.onDidReceiveMessage.fire(Object.freeze({editor:w.apiEditor,message:P}))}$cellExecutionChanged(a,k,P){const w=this.m.getNotebookDocument(E.URI.revive(a)).getCell(k);if(w){const y=P?b.NotebookCellExecutionState.to(P):p.NotebookCellExecutionState.Idle;y!==void 0&&this.k.fire({cell:w.apiCell,state:y})}}_createNotebookCellExecution(a,k){if(a.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const h=this.m.getNotebookDocument(a.notebook.uri).getCellFromApiCell(a);if(!h)throw new Error("invalid cell");if(this.b.has(h.uri))throw new Error(`duplicate execution for ${h.uri}`);const w=new m(k,h,this.a);this.b.set(h.uri,w);const y=w.onDidChangeState(()=>{w.state===D.Resolved&&(w.dispose(),y.dispose(),this.b.delete(h.uri))});return w.asApiObject()}_createNotebookExecution(a,k){const P=this.m.getNotebookDocument(a.uri),h=a.getCells().find(M=>{const V=P.getCellFromApiCell(M);return V&&this.b.has(V.uri)});if(h)throw new Error(`duplicate cell execution for ${h.document.uri}`);if(this.c.has(P.uri))throw new Error(`duplicate notebook execution for ${P.uri}`);const w=new r(k,P,this.a),y=w.onDidChangeState(()=>{w.state===n.Resolved&&(w.dispose(),y.dispose(),this.c.delete(P.uri))});return this.c.set(P.uri,[w,y]),w.asApiObject()}};e.$qec=v,e.$qec=v=Ge([qe(4,R.$$i)],v);var D;(function($){$[$.Init=0]="Init",$[$.Started=1]="Started",$[$.Resolved=2]="Resolved"})(D||(D={}));class m extends A.$Sc{get state(){return this.f}constructor(a,k,P){super(),this.m=k,this.n=P,this.b=m.a++,this.c=new O.$Od,this.onDidChangeState=this.c.event,this.f=D.Init,this.g=this.B(new I.$Yd),this.h=new s(10,h=>this.s(h)),this.j=k.internalMetadata.executionOrder,this.n.$createExecution(this.b,a,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(a){await this.h.addItem(a)}async s(a){const k=Array.isArray(a)?a:[a];return this.n.$updateExecution(this.b,new l.$vv(k))}t(){if(this.f===D.Init)throw new Error("Must call start before modifying cell output");if(this.f===D.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(a){let k=this.m;if(a&&(k=this.m.notebook.getCellFromApiCell(a)),!k)throw new Error("INVALID cell");return k.handle}y(a){return a.map(k=>{const P=p.$TL.ensureUniqueMimeTypes(k.items,!0);return P===k.items?b.NotebookCellOutput.from(k):b.NotebookCellOutput.from({items:P,id:k.id,metadata:k.metadata})})}async z(a,k,P){const h=this.w(k),w=this.y((0,f.$3b)(a));return this.r({editType:t.CellExecutionUpdateType.Output,cellHandle:h,append:P,outputs:w})}async C(a,k,P){return a=p.$TL.ensureUniqueMimeTypes((0,f.$3b)(a),!0),this.r({editType:t.CellExecutionUpdateType.OutputItems,items:a.map(b.NotebookCellOutputItem.from),outputId:k.id,append:P})}asApiObject(){const a=this;return Object.freeze({get token(){return a.g.token},get cell(){return a.m.apiCell},get executionOrder(){return a.j},set executionOrder(P){a.j=P,a.s([{editType:t.CellExecutionUpdateType.ExecutionState,executionOrder:a.j}])},start(P){if(a.f===D.Resolved||a.f===D.Started)throw new Error("Cannot call start again");a.f=D.Started,a.c.fire(),a.s({editType:t.CellExecutionUpdateType.ExecutionState,runStartTime:P})},end(P,h){if(a.f===D.Resolved)throw new Error("Cannot call resolve twice");a.f=D.Resolved,a.c.fire(),a.h.flush(),a.n.$completeExecution(a.b,new l.$vv({runEndTime:h,lastRunSuccess:P}))},clearOutput(P){return a.t(),a.z([],P,!1)},appendOutput(P,h){return a.t(),a.z(P,h,!0)},replaceOutput(P,h){return a.t(),a.z(P,h,!1)},appendOutputItems(P,h){return a.t(),a.C(P,h,!0)},replaceOutputItems(P,h){return a.t(),a.C(P,h,!1)}})}}m.a=0;var n;(function($){$[$.Init=0]="Init",$[$.Started=1]="Started",$[$.Resolved=2]="Resolved"})(n||(n={}));class r extends A.$Sc{get state(){return this.f}constructor(a,k,P){super(),this.h=k,this.j=P,this.b=r.a++,this.c=new O.$Od,this.onDidChangeState=this.c.event,this.f=n.Init,this.g=this.B(new I.$Yd),this.j.$createNotebookExecution(this.b,a,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===n.Resolved||this.f===n.Started)throw new Error("Cannot call start again");this.f=n.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===n.Resolved)throw new Error("Cannot call resolve twice");this.f=n.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}r.a=0;class s{constructor(a,k){this.e=a,this.f=k,this.a=[],this.b=Date.now()}addItem(a){return this.a.push(a),this.c||(this.c=new C.$dh,this.b=Date.now(),(0,C.$Vg)(this.e).then(()=>this.flush())),Date.now()-this.b>this.e?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const a=this.c;this.c=void 0;const k=this.a;return this.a=[],this.f(k).finally(()=>a.complete())}}function o($,a){return`${$.value}/${a}`}e.$rec=o}),define(Ae[248],Re([1,0,5,3,104]),function(ee,e,f,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sec=void 0;class O{constructor(c,E){this.c=E,this.a=new Map,this.b=c.getProxy(C.$qK.MainThreadNotebookRenderers)}$postRendererMessage(c,E,d){const R=this.c.getEditorById(c);this.a.get(E)?.fire({editor:R.apiEditor,message:d})}createRendererMessaging(c,E){if(!c.contributes?.notebookRenderer?.some(R=>R.id===E))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${E})`);return{onDidReceiveMessage:(R,S,u)=>this.d(E).event(R,S,u),postMessage:(R,S)=>{I.$bec.apiEditorsToExtHost.has(R)&&([R,S]=[S,R]);const u=S&&I.$bec.apiEditorsToExtHost.get(S);return this.b.$postMessage(u?.id,E,R)}}}d(c){let E=this.a.get(c);return E||(E=new f.$Od({onDidRemoveLastListener:()=>{E?.dispose(),this.a.delete(c)}}),this.a.set(c,E),E)}}e.$sec=O}),define(Ae[249],Re([1,0,6,15,2,22,3]),function(ee,e,f,C,I,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wec=void 0;class c{constructor(d){this.b=new Map,this.a=d.getProxy(A.$qK.MainThreadProfileContentHandlers)}registrProfileContentHandler(d,R,S){if((0,O.$mF)(d,"profileContentHandlers"),this.b.has(R))throw new Error(`Handler with id '${R}' already registered`);return this.b.set(R,S),this.a.$registerProfileContentHandler(R,S.name,S.description,d.identifier.value),(0,f.$Qc)(()=>{this.b.delete(R),this.a.$unregisterProfileContentHandler(R)})}async $saveProfile(d,R,S,u){const b=this.b.get(d);if(!b)throw new Error(`Unknown handler with id: ${d}`);return b.saveProfile(R,S,u)}async $readProfile(d,R,S){const u=this.b.get(d);if(!u)throw new Error(`Unknown handler with id: ${d}`);return u.readProfile((0,C.$zf)(R)?R:I.URI.revive(R),S)}}e.$wec=c}),define(Ae[250],Re([1,0,2,3,12,8]),function(ee,e,f,C,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xec=void 0;class A{constructor(E,d){this.d=d,this.c=new Map,this.b=E.getProxy(C.$qK.MainThreadQuickDiff)}$provideOriginalResource(E,d,R){const S=f.URI.revive(d),u=this.c.get(E);return u?(0,I.$Ng)(()=>u.provideOriginalResource(S,R)).then(b=>b||null):Promise.resolve(null)}registerQuickDiffProvider(E,d,R,S){const u=A.a++;return this.c.set(u,d),this.b.$registerQuickDiffProvider(u,O.DocumentSelector.from(E,this.d),R,S),{dispose:()=>{this.b.$unregisterQuickDiffProvider(u),this.c.delete(u)}}}}e.$xec=A,A.a=0}),define(Ae[251],Re([1,0,19,5,6,3,2,7,11,18,29,44,22,8]),function(ee,e,f,C,I,O,A,c,E,d,R,S,u,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ydc=void 0;function p(g,t,i){const l=g.getProxy(O.$qK.MainThreadQuickOpen);class v{constructor(k,P){this.e=new Map,this.f=0,this.a=k,this.b=P}showQuickPick(k,P,h,w=f.CancellationToken.None){this.c=void 0;const y=Promise.resolve(P),M=++this.f,V=l.$show(M,{title:h?.title,placeHolder:h?.placeHolder,matchOnDescription:h?.matchOnDescription,matchOnDetail:h?.matchOnDetail,ignoreFocusLost:h?.ignoreFocusOut,canPickMany:h?.canPickMany},w),B={},z=V.then(()=>B);return Promise.race([z,y]).then(T=>{if(T===B)return;const F=(0,u.$lF)(k,"quickPickItemTooltip");return y.then(j=>{const q=[];for(let W=0;W<j.length;W++){const we=j[W];if(typeof we=="string")q.push({label:we,handle:W});else if(we.kind===c.QuickPickItemKind.Separator)q.push({type:"separator",label:we.label});else{we.tooltip&&!F&&console.warn(`Extension '${k.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${k.identifier.value}`);const ke=we.iconPath?s(we.iconPath):void 0;q.push({label:we.label,iconPath:ke?.iconPath,iconClass:ke?.iconClass,description:we.description,detail:we.detail,picked:we.picked,alwaysShow:we.alwaysShow,tooltip:F?b.MarkdownString.fromStrict(we.tooltip):void 0,handle:W})}}return h&&typeof h.onDidSelectItem=="function"&&(this.c=W=>{h.onDidSelectItem(j[W])}),l.$setItems(M,q),V.then(W=>{if(typeof W=="number")return j[W];if(Array.isArray(W))return W.map(we=>j[we])})})}).then(void 0,T=>{if(!(0,E.$4)(T))return l.$setError(M,T),Promise.reject(T)})}$onItemSelected(k){this.c?.(k)}showInput(k,P=f.CancellationToken.None){return this.d=k?.validateInput,l.$input(k,typeof this.d=="function",P).then(void 0,h=>{if(!(0,E.$4)(h))return Promise.reject(h)})}async $validateInput(k){if(!this.d)return;const P=await this.d(k);if(!P||typeof P=="string")return P;let h;switch(P.severity){case c.InputBoxValidationSeverity.Info:h=R.default.Info;break;case c.InputBoxValidationSeverity.Warning:h=R.default.Warning;break;case c.InputBoxValidationSeverity.Error:h=R.default.Error;break;default:h=P.message?R.default.Error:R.default.Ignore;break}return{content:P.message,severity:h}}async showWorkspaceFolderPick(k,P=f.CancellationToken.None){const h=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[k]);if(!h)return;const w=await this.a.getWorkspaceFolders2();if(w)return w.find(y=>y.uri.toString()===h.uri.toString())}createQuickPick(k){const P=new o(k,()=>this.e.delete(P._id));return this.e.set(P._id,P),P}createInputBox(k){const P=new $(k,()=>this.e.delete(P._id));return this.e.set(P._id,P),P}$onDidChangeValue(k,P){this.e.get(k)?._fireDidChangeValue(P)}$onDidAccept(k){this.e.get(k)?._fireDidAccept()}$onDidChangeActive(k,P){const h=this.e.get(k);h instanceof o&&h._fireDidChangeActive(P)}$onDidChangeSelection(k,P){const h=this.e.get(k);h instanceof o&&h._fireDidChangeSelection(P)}$onDidTriggerButton(k,P){this.e.get(k)?._fireDidTriggerButton(P)}$onDidTriggerItemButton(k,P,h){const w=this.e.get(k);w instanceof o&&w._fireDidTriggerItemButton(P,h)}$onDidHide(k){this.e.get(k)?._fireDidHide()}}class D{constructor(k,P){this.x=k,this.y=P,this._id=o.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new C.$Od,this.q=new C.$Od,this.r=new C.$Od,this.s=new C.$Od,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(k){this.b=k,this.z({title:k})}get step(){return this.c}set step(k){this.c=k,this.z({step:k})}get totalSteps(){return this.d}set totalSteps(k){this.d=k,this.z({totalSteps:k})}get enabled(){return this.g}set enabled(k){this.g=k,this.z({enabled:k})}get busy(){return this.j}set busy(k){this.j=k,this.z({busy:k})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(k){this.k=k,this.z({ignoreFocusOut:k})}get value(){return this.l}set value(k){this.l=k,this.z({value:k})}get placeholder(){return this.m}set placeholder(k){this.m=k,this.z({placeholder:k})}get buttons(){return this.n}set buttons(k){this.n=k.slice(),this.o.clear(),k.forEach((P,h)=>{const w=P===c.$ML.Back?-1:h;this.o.set(w,P)}),this.z({buttons:k.map((P,h)=>({...s(P.iconPath),tooltip:P.tooltip,handle:P===c.$ML.Back?-1:h}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(k){this.l=k,this.q.fire(k)}_fireDidTriggerButton(k){const P=this.o.get(k);P&&this.r.fire(P)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,I.$Nc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),l.$dispose(this._id))}z(k){if(!this.v){for(const P of Object.keys(k)){const h=k[P];this.u[P]=h===void 0?null:h}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){l.$createOrUpdate(this.u),this.u={id:this._id}}}D.a=1;function m(a){if(a instanceof c.$mL)return{id:a.id};const k=r(a),P=n(a);return{dark:typeof k=="string"?A.URI.file(k):k,light:typeof P=="string"?A.URI.file(P):P}}function n(a){return typeof a=="object"&&"light"in a?a.light:a}function r(a){return typeof a=="object"&&"dark"in a?a.dark:a}function s(a){const k=m(a);let P,h;return"id"in k?h=S.ThemeIcon.asClassName(k):P=k,{iconPath:P,iconClass:h}}class o extends D{constructor(k,P){super(k.identifier,P),this.O=k,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new C.$Od,this.L=[],this.M=new C.$Od,this.N=new C.$Od,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(k){this.B=k.slice(),this.C.clear(),this.D.clear(),k.forEach((w,y)=>{this.C.set(y,w),this.D.set(w,y)});const P=(0,u.$lF)(this.O,"quickPickItemTooltip"),h=[];for(let w=0;w<k.length;w++){const y=k[w];if(y.kind===c.QuickPickItemKind.Separator)h.push({type:"separator",label:y.label});else{y.tooltip&&!P&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const M=y.iconPath?s(y.iconPath):void 0;h.push({handle:w,label:y.label,iconPath:M?.iconPath,iconClass:M?.iconClass,description:y.description,detail:y.detail,picked:y.picked,alwaysShow:y.alwaysShow,tooltip:P?b.MarkdownString.fromStrict(y.tooltip):void 0,buttons:y.buttons?.map((V,B)=>({...s(V.iconPath),tooltip:V.tooltip,handle:B}))})}}this.z({items:h})}get canSelectMany(){return this.E}set canSelectMany(k){this.E=k,this.z({canSelectMany:k})}get matchOnDescription(){return this.F}set matchOnDescription(k){this.F=k,this.z({matchOnDescription:k})}get matchOnDetail(){return this.G}set matchOnDetail(k){this.G=k,this.z({matchOnDetail:k})}get sortByLabel(){return this.H}set sortByLabel(k){this.H=k,this.z({sortByLabel:k})}get keepScrollPosition(){return this.I}set keepScrollPosition(k){this.I=k,this.z({keepScrollPosition:k})}get activeItems(){return this.J}set activeItems(k){this.J=k.filter(P=>this.D.has(P)),this.z({activeItems:this.J.map(P=>this.D.get(P))})}get selectedItems(){return this.L}set selectedItems(k){this.L=k.filter(P=>this.D.has(P)),this.z({selectedItems:this.L.map(P=>this.D.get(P))})}_fireDidChangeActive(k){const P=(0,d.$Hb)(k.map(h=>this.C.get(h)));this.J=P,this.K.fire(P)}_fireDidChangeSelection(k){const P=(0,d.$Hb)(k.map(h=>this.C.get(h)));this.L=P,this.M.fire(P)}_fireDidTriggerItemButton(k,P){const h=this.C.get(k);if(!h||!h.buttons||!h.buttons.length)return;const w=h.buttons[P];w&&this.N.fire({button:w,item:h})}}class $ extends D{constructor(k,P){super(k.identifier,P),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(k){this.B=k,this.z({password:k})}get prompt(){return this.C}set prompt(k){this.C=k,this.z({prompt:k})}get valueSelection(){return this.D}set valueSelection(k){this.D=k,this.z({valueSelection:k})}get validationMessage(){return this.E}set validationMessage(k){this.E=k,k?typeof k=="string"?this.z({validationMessage:k,severity:R.default.Error}):this.z({validationMessage:k.message,severity:k.severity??R.default.Error}):this.z({validationMessage:void 0,severity:R.default.Ignore})}}return new v(t,i)}e.$ydc=p});var Ne=this&&this.__classPrivateFieldGet||function(ee,e,f,C){if(f==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!C:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return f==="m"?C:f==="a"?C.call(ee):C?C.value:e.get(ee)},Xe=this&&this.__classPrivateFieldSet||function(ee,e,f,C,I){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!I:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?I.call(ee,f):I?I.value=f:e.set(ee,f),f};define(Ae[252],Re([1,0,2,5,65,6,12,3,18,118,14,21,44,8,22,13]),function(ee,e,f,C,I,O,A,c,E,d,R,S,u,b,p,g){"use strict";var t,i,l,v;Object.defineProperty(e,"__esModule",{value:!0}),e.$Adc=e.$zdc=void 0;function D(B){if(B)return typeof B.iconPath=="string"?f.URI.file(B.iconPath):f.URI.isUri(B.iconPath)||u.ThemeIcon.isThemeIcon(B.iconPath)?B.iconPath:void 0}function m(B){if(B?.icon){if(f.URI.isUri(B.icon))return B.icon;if(u.ThemeIcon.isThemeIcon(B.icon))return B.icon;{const z=B.icon;return{light:z.light,dark:z.dark}}}else return}function n(B){if(B.icon){if(f.URI.isUri(B.icon))return B.icon;if(u.ThemeIcon.isThemeIcon(B.icon))return B.icon;{const z=B.icon;return{light:z.light,dark:z.dark}}}else return}function r(B,z){if(!B.iconPath&&!z.iconPath)return 0;if(B.iconPath){if(!z.iconPath)return 1}else return-1;const T=typeof B.iconPath=="string"?B.iconPath:f.URI.isUri(B.iconPath)?B.iconPath.fsPath:B.iconPath.id,F=typeof z.iconPath=="string"?z.iconPath:f.URI.isUri(z.iconPath)?z.iconPath.fsPath:z.iconPath.id;return(0,d.$wq)(T,F)}function s(B,z){let T=0;if(B.strikeThrough!==z.strikeThrough)return B.strikeThrough?1:-1;if(B.faded!==z.faded)return B.faded?1:-1;if(B.tooltip!==z.tooltip)return(B.tooltip||"").localeCompare(z.tooltip||"");if(T=r(B,z),T!==0)return T;if(B.light&&z.light)T=r(B.light,z.light);else{if(B.light)return 1;if(z.light)return-1}if(T!==0)return T;if(B.dark&&z.dark)T=r(B.dark,z.dark);else{if(B.dark)return 1;if(z.dark)return-1}return T}function o(B,z){if(B.command!==z.command)return B.command<z.command?-1:1;if(B.title!==z.title)return B.title<z.title?-1:1;if(B.tooltip!==z.tooltip){if(B.tooltip!==void 0&&z.tooltip!==void 0)return B.tooltip<z.tooltip?-1:1;if(B.tooltip!==void 0)return 1;if(z.tooltip!==void 0)return-1}if(B.arguments===z.arguments)return 0;if(B.arguments)if(z.arguments){if(B.arguments.length!==z.arguments.length)return B.arguments.length-z.arguments.length}else return 1;else return-1;for(let T=0;T<B.arguments.length;T++){const F=B.arguments[T],j=z.arguments[T];if(F!==j)return F<j?-1:1}return 0}function $(B,z){let T=(0,d.$wq)(B.resourceUri.fsPath,z.resourceUri.fsPath,!0);if(T!==0)return T;if(B.command&&z.command)T=o(B.command,z.command);else{if(B.command)return 1;if(z.command)return-1}if(T!==0)return T;if(B.decorations&&z.decorations)T=s(B.decorations,z.decorations);else{if(B.decorations)return 1;if(z.decorations)return-1}return T}function a(B,z){for(let T=0;T<B.length;T++)if(B[T]!==z[T])return!1;return!0}function k(B,z){return B.command===z.command&&B.title===z.title&&B.tooltip===z.tooltip&&(B.arguments&&z.arguments?a(B.arguments,z.arguments):B.arguments===z.arguments)}function P(B,z){return(0,E.$ub)(B,z,k)}function h(B,z){return B===z?!0:!B||!z?!1:B.id===z.id&&B.label===z.label&&B.upstream?.id===z.upstream?.id&&B.upstream?.label===z.upstream?.label}class w{get value(){return this.d}set value(z){z=z??"",Ne(this,t,"f").$setInputBoxValue(this.o,z),this.q(z)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(z){Ne(this,t,"f").$setInputBoxPlaceholder(this.o,z),this.f=z}get validateInput(){return(0,p.$mF)(this.m,"scmValidation"),this.g}set validateInput(z){if((0,p.$mF)(this.m,"scmValidation"),z&&typeof z!="function")throw new Error(`[${this.m.identifier.value}]: Invalid SCM input box validation function`);this.g=z,Ne(this,t,"f").$setValidationProviderIsEnabled(this.o,!!z)}get enabled(){return this.h}set enabled(z){z=!!z,this.h!==z&&(this.h=z,Ne(this,t,"f").$setInputBoxEnablement(this.o,z))}get visible(){return this.j}set visible(z){z=!!z,this.j!==z&&(this.j=z,Ne(this,t,"f").$setInputBoxVisibility(this.o,z))}get actionButton(){return(0,p.$mF)(this.m,"scmInputBoxActionButton"),this.k}set actionButton(z){(0,p.$mF)(this.m,"scmInputBoxActionButton"),this.l.value=new O.$Rc,this.k=z;const T=z!==void 0?{command:this.n.converter.toInternal(z.command,this.l.value),icon:m(z),enabled:z.enabled}:void 0;Ne(this,t,"f").$setInputBoxActionButton(this.o,T??null)}get document(){return(0,p.$mF)(this.m,"scmTextDocument"),Ne(this,i,"f").getDocument(this.p)}constructor(z,T,F,j,q,W){this.m=z,this.n=T,this.o=q,this.p=W,t.set(this,void 0),i.set(this,void 0),this.d="",this.e=new C.$Od,this.f="",this.h=!0,this.j=!0,this.l=new O.$Tc,Xe(this,i,F,"f"),Xe(this,t,j,"f")}showValidationMessage(z,T){(0,p.$mF)(this.m,"scmValidation"),Ne(this,t,"f").$showValidationMessage(this.o,z,T)}$onInputBoxValueChange(z){this.q(z)}q(z){this.d=z,this.e.fire(z)}}e.$zdc=w,t=new WeakMap,i=new WeakMap;class y{get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(z){this.v=z,this.q.$updateGroupLabel(this.t,this.handle,z)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(z){this.p=z,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(z){this.f=[...z],this.k.fire()}constructor(z,T,F,j,q){this.q=z,this.s=T,this.t=F,this.u=j,this.v=q,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new C.$Od,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new C.$Od,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=y.d++}getResourceState(z){return this.g.get(z)}$executeResourceCommand(z,T){const F=this.h.get(z);return F?(0,A.$Ng)(()=>this.s.executeCommand(F.command,...F.arguments||[],T)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const z=[...this.f].sort($),F=(0,E.$Db)(this.o,z,$).map(W=>{const we=W.toInsert.map(ke=>{const Se=this.e++;this.g.set(Se,ke);const ve=ke.resourceUri;let ge;if(ke.command)if(ke.command.command==="vscode.open"||ke.command.command==="vscode.diff"){const le=new O.$Rc;ge=this.s.converter.toInternal(ke.command,le),this.j.set(Se,le)}else this.h.set(Se,ke.command);const re=D(ke.decorations),oe=ke.decorations&&D(ke.decorations.light)||re,ye=ke.decorations&&D(ke.decorations.dark)||re,De=[oe,ye],Q=ke.decorations&&ke.decorations.tooltip||"",ue=ke.decorations&&!!ke.decorations.strikeThrough,J=ke.decorations&&!!ke.decorations.faded,he=ke.contextValue||"";return{rawResource:[Se,ve,De,Q,ue,J,he,ge],handle:Se}});return{start:W.start,deleteCount:W.deleteCount,toInsert:we}}),j=F.map(({start:W,deleteCount:we,toInsert:ke})=>[W,we,ke.map(Se=>Se.rawResource)]),q=F.reverse();for(const{start:W,deleteCount:we,toInsert:ke}of q){const Se=ke.map(ge=>ge.handle),ve=this.n.splice(W,we,...Se);for(const ge of ve)this.g.delete(ge),this.h.delete(ge),this.j.get(ge)?.dispose(),this.j.delete(ge)}return this.o=z,j}dispose(){this.l=!0,this.m.fire()}}y.d=0;class M{get id(){return this.A}get label(){return this.B}get rootUri(){return this.C}get inputBox(){return this.f}get count(){return this.g}set count(z){this.g!==z&&(this.g=z,Ne(this,l,"f").$updateSourceControl(this.x,{count:z}))}get quickDiffProvider(){return this.h}set quickDiffProvider(z){this.h=z;let T;(0,p.$lF)(this.y,"quickDiffProvider")&&(T=z?.label),Ne(this,l,"f").$updateSourceControl(this.x,{hasQuickDiffProvider:!!z,quickDiffLabel:T})}get historyProvider(){return(0,p.$mF)(this.y,"scmHistoryProvider"),this.j}set historyProvider(z){(0,p.$mF)(this.y,"scmHistoryProvider"),this.j=z,this.k.value=new O.$Rc,Ne(this,l,"f").$updateSourceControl(this.x,{hasHistoryProvider:!!z}),z&&(this.k.value.add(z.onDidChangeCurrentHistoryItemGroup(()=>{h(this.l,z?.currentHistoryItemGroup)||(this.l=z?.currentHistoryItemGroup,Ne(this,l,"f").$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.x,this.l))})),this.k.value.add(z.onDidChangeActionButton(()=>{(0,p.$mF)(this.y,"scmActionButton"),this.m.value=new O.$Rc;const T=z.actionButton!==void 0?{command:this.z.converter.toInternal(z.actionButton.command,this.m.value),description:z.actionButton.description,enabled:z.actionButton.enabled}:void 0;Ne(this,l,"f").$onDidChangeHistoryProviderActionButton(this.x,T??null)})))}get commitTemplate(){return this.n}set commitTemplate(z){z!==this.n&&(this.n=z,Ne(this,l,"f").$updateSourceControl(this.x,{commitTemplate:z}))}get acceptInputCommand(){return this.p}set acceptInputCommand(z){this.o.value=new O.$Rc,this.p=z;const T=this.z.converter.toInternal(z,this.o.value);Ne(this,l,"f").$updateSourceControl(this.x,{acceptInputCommand:T})}get actionButton(){return(0,p.$mF)(this.y,"scmActionButton"),this.s}set actionButton(z){(0,p.$mF)(this.y,"scmActionButton"),this.q.value=new O.$Rc,this.s=z;const T=z!==void 0?{command:this.z.converter.toInternal(z.command,this.q.value),secondaryCommands:z.secondaryCommands?.map(F=>F.map(j=>this.z.converter.toInternal(j,this.q.value))),description:z.description,enabled:z.enabled}:void 0;Ne(this,l,"f").$updateSourceControl(this.x,{actionButton:T??null})}get statusBarCommands(){return this.u}set statusBarCommands(z){if(this.u&&z&&P(this.u,z))return;this.t.value=new O.$Rc,this.u=z;const T=(z||[]).map(F=>this.z.converter.toInternal(F,this.t.value));Ne(this,l,"f").$updateSourceControl(this.x,{statusBarCommands:T})}get selected(){return this.v}constructor(z,T,F,j,q,W,we){this.y=z,this.z=j,this.A=q,this.B=W,this.C=we,l.set(this,void 0),this.e=new Map,this.g=void 0,this.h=void 0,this.k=new O.$Tc,this.m=new O.$Tc,this.n=void 0,this.o=new O.$Tc,this.p=void 0,this.q=new O.$Tc,this.t=new O.$Tc,this.u=void 0,this.v=!1,this.w=new C.$Od,this.onDidChangeSelection=this.w.event,this.x=M.d++,this.D=new Map,this.E=new Set,Xe(this,l,F,"f");const ke=f.URI.from({scheme:g.Schemas.vscodeSourceControl,path:`${q}/scm${this.x}/input`,query:we?`rootUri=${encodeURIComponent(we.toString())}`:void 0});this.f=new w(z,j,T,Ne(this,l,"f"),this.x,ke),Ne(this,l,"f").$registerSourceControl(this.x,q,W,we,ke)}createResourceGroup(z,T){const F=new y(Ne(this,l,"f"),this.z,this.x,z,T),j=C.Event.once(F.onDidDispose)(()=>this.D.delete(F));return this.D.set(F,j),this.eventuallyAddResourceGroups(),F}eventuallyAddResourceGroups(){const z=[],T=[];for(const[F,j]of this.D){j.dispose();const q=F.onDidUpdateResourceStates(()=>{this.E.add(F),this.eventuallyUpdateResourceStates()});C.Event.once(F.onDidDispose)(()=>{this.E.delete(F),q.dispose(),this.e.delete(F.handle),Ne(this,l,"f").$unregisterGroup(this.x,F.handle)}),z.push([F.handle,F.id,F.label,F.features]);const W=F._takeResourceStateSnapshot();W.length>0&&T.push([F.handle,W]),this.e.set(F.handle,F)}Ne(this,l,"f").$registerGroups(this.x,z,T),this.D.clear()}eventuallyUpdateResourceStates(){const z=[];this.E.forEach(T=>{const F=T._takeResourceStateSnapshot();F.length!==0&&z.push([T.handle,F])}),z.length>0&&Ne(this,l,"f").$spliceResourceStates(this.x,z),this.E.clear()}getResourceGroup(z){return this.e.get(z)}setSelectionState(z){this.v=z,this.w.fire(z)}dispose(){this.o.dispose(),this.q.dispose(),this.t.dispose(),this.e.forEach(z=>z.dispose()),Ne(this,l,"f").$unregisterSourceControl(this.x)}}l=new WeakMap,M.d=0,Ge([(0,I.$jh)(100)],M.prototype,"eventuallyAddResourceGroups",null),Ge([(0,I.$jh)(100)],M.prototype,"eventuallyUpdateResourceStates",null);let V=v=class{get onDidChangeActiveProvider(){return this.j.event}constructor(z,T,F,j){this.l=T,this.m=F,this.n=j,this.g=new Map,this.h=new S.$0l,this.j=new C.$Od,this.e=z.getProxy(c.$qK.MainThreadSCM),this.f=z.getProxy(c.$qK.MainThreadTelemetry),T.registerArgumentProcessor({processArgument:q=>{if(q&&q.$mid===3){const W=this.g.get(q.sourceControlHandle);if(!W)return q;const we=W.getResourceGroup(q.groupHandle);return we?we.getResourceState(q.handle):q}else if(q&&q.$mid===4){const W=this.g.get(q.sourceControlHandle);return W?W.getResourceGroup(q.groupHandle):q}else if(q&&q.$mid===5){const W=this.g.get(q.handle);return W||q}return q}})}createSourceControl(z,T,F,j){this.n.trace("ExtHostSCM#createSourceControl",z.identifier.value,T,F,j),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:z.identifier.value});const q=v.d++,W=new M(z,this.m,this.e,this.l,T,F,j);this.g.set(q,W);const we=this.h.get(z.identifier)||[];return we.push(W),this.h.set(z.identifier,we),W}getLastInputBox(z){this.n.trace("ExtHostSCM#getLastInputBox",z.identifier.value);const T=this.h.get(z.identifier),F=T&&T[T.length-1];return F&&F.inputBox}$provideOriginalResource(z,T,F){const j=f.URI.revive(T);this.n.trace("ExtHostSCM#$provideOriginalResource",z,j.toString());const q=this.g.get(z);return!q||!q.quickDiffProvider||!q.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,A.$Ng)(()=>q.quickDiffProvider.provideOriginalResource(j,F)).then(W=>W||null)}$onInputBoxValueChange(z,T){this.n.trace("ExtHostSCM#$onInputBoxValueChange",z);const F=this.g.get(z);return F&&F.inputBox.$onInputBoxValueChange(T),Promise.resolve(void 0)}$executeResourceCommand(z,T,F,j){this.n.trace("ExtHostSCM#$executeResourceCommand",z,T,F);const q=this.g.get(z);if(!q)return Promise.resolve(void 0);const W=q.getResourceGroup(T);return W?W.$executeResourceCommand(F,j):Promise.resolve(void 0)}$validateInput(z,T,F){this.n.trace("ExtHostSCM#$validateInput",z);const j=this.g.get(z);return!j||!j.inputBox.validateInput?Promise.resolve(void 0):(0,A.$Ng)(()=>j.inputBox.validateInput(T,F)).then(q=>{if(!q)return Promise.resolve(void 0);const W=b.MarkdownString.fromStrict(q.message);return W?Promise.resolve([W,q.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(z){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",z),z!==void 0&&this.g.get(z)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=z,Promise.resolve(void 0)}async $resolveHistoryItemGroupBase(z,T,F){return await this.g.get(z)?.historyProvider?.resolveHistoryItemGroupBase(T,F)??void 0}async $resolveHistoryItemGroupCommonAncestor(z,T,F,j){return await this.g.get(z)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(T,F,j)??void 0}async $provideHistoryItems(z,T,F,j){return(await this.g.get(z)?.historyProvider?.provideHistoryItems(T,F,j))?.map(we=>({id:we.id,parentIds:we.parentIds,label:we.label,description:we.description,icon:n(we),timestamp:we.timestamp}))??void 0}async $provideHistoryItemChanges(z,T,F){return await this.g.get(z)?.historyProvider?.provideHistoryItemChanges(T,F)??void 0}};e.$Adc=V,V.d=0,e.$Adc=V=v=Ge([qe(3,R.$$i)],V)}),define(Ae[83],Re([1,0,3,5,4]),function(ee,e,f,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gdc=e.$fdc=void 0;class O{constructor(c){this.b=new C.$Od,this.onDidChangePassword=this.b.event,this.a=c.getProxy(f.$qK.MainThreadSecretState)}async $onDidChangePassword(c){this.b.fire(c)}get(c,E){return this.a.$getPassword(c,E)}store(c,E,d){return this.a.$setPassword(c,E,d)}delete(c,E){return this.a.$deletePassword(c,E)}}e.$fdc=O,e.$gdc=(0,I.$Qh)("IExtHostSecretState")}),define(Ae[253],Re([1,0,3,8,2]),function(ee,e,f,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cec=void 0;class O{constructor(c,E){this.d=E,this.c=new Map,this.b=c.getProxy(f.$qK.MainThreadShare)}async $provideShare(c,E,d){return await this.c.get(c)?.provideShare({selection:C.Range.to(E.selection),resourceUri:I.URI.revive(E.resourceUri)},d)??void 0}registerShareProvider(c,E){const d=O.a++;return this.c.set(d,E),this.b.$registerShareProvider(d,C.DocumentSelector.from(c,this.d),E.id,E.label,E.priority),{dispose:()=>{this.b.$unregisterShareProvider(d),this.c.delete(d)}}}}e.$Cec=O,O.a=0}),define(Ae[254],Re([1,0,19,6,3]),function(ee,e,f,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eec=void 0;class O{constructor(c){this.c=new Map,this.d=new Map,this.b=c.getProxy(I.$qK.MainThreadSpeech)}async $createSpeechToTextSession(c,E){const d=this.c.get(c);if(!d)return;const R=new C.$Rc,S=new f.$Yd;this.d.set(E,S);const u=R.add(d.provideSpeechToTextSession(S.token));R.add(u.onDidChange(b=>{S.token.isCancellationRequested||this.b.$emitSpeechToTextEvent(E,b)})),R.add(S.token.onCancellationRequested(()=>R.dispose()))}async $cancelSpeechToTextSession(c){this.d.get(c)?.dispose(!0),this.d.delete(c)}registerProvider(c,E,d){const R=O.a++;return this.c.set(R,d),this.b.$registerProvider(R,E,{extension:c,displayName:c.value}),(0,C.$Qc)(()=>{this.b.$unregisterProvider(R),this.c.delete(R)})}}e.$Eec=O,O.a=1});var Xe=this&&this.__classPrivateFieldSet||function(ee,e,f,C,I){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!I:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?I.call(ee,f):I?I.value=f:e.set(ee,f),f},Ne=this&&this.__classPrivateFieldGet||function(ee,e,f,C){if(f==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!C:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return f==="m"?C:f==="a"?C.call(ee):C?C.value:e.get(ee)};define(Ae[255],Re([1,0,7,3,154,6,8,15]),function(ee,e,f,C,I,O,A,c){"use strict";var E,d;Object.defineProperty(e,"__esModule",{value:!0}),e.$Cdc=e.$Bdc=void 0;class R{constructor(p,g,t,i,l,v=f.StatusBarAlignment.Left,D){if(E.set(this,void 0),d.set(this,void 0),this.i=!1,this.k="",this.q=new O.$Rc,Xe(this,E,p,"f"),Xe(this,d,g,"f"),l&&i){this.c=(0,f.$3K)(i.identifier,l);const m=t.get(this.c);m&&(v=m.alignLeft?f.StatusBarAlignment.Left:f.StatusBarAlignment.Right,D=m.priority,this.j=!0,this.name=m.name,this.text=m.text,this.tooltip=m.tooltip,this.command=m.command,this.accessibilityInformation=m.accessibilityInformation)}else this.c=String(R.a++);this.e=i,this.f=l,this.g=v,this.h=this.u(D)}u(p){if((0,c.$Df)(p))return p===Number.POSITIVE_INFINITY?Number.MAX_VALUE:p===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:p}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(p){this.k=p,this.v()}set name(p){this.m=p,this.v()}set tooltip(p){this.l=p,this.v()}set color(p){this.n=p,this.v()}set backgroundColor(p){p&&!R.b.has(p.id)&&(p=void 0),this.o=p,this.v()}set command(p){this.r?.fromApi!==p&&(this.p&&this.q.add(this.p),this.p=new O.$Rc,typeof p=="string"?this.r={fromApi:p,internal:Ne(this,d,"f").toInternal({title:"",command:p},this.p)}:p?this.r={fromApi:p,internal:Ne(this,d,"f").toInternal(p,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(p){this.t=p,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,Ne(this,E,"f").$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let p;this.e?this.f?p=`${this.e.identifier.value}.${this.f}`:p=this.e.identifier.value:p=this.f;let g;this.m?g=this.m:g=(0,I.localize)(0,null,this.e.displayName||this.e.name);let t=this.n;this.o&&(t=R.b.get(this.o.id));const i=A.MarkdownString.fromStrict(this.l);Ne(this,E,"f").$setEntry(this.c,p,this.e?.identifier.value,g,this.k,i,this.r?.internal,t,this.o,this.g===f.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$Bdc=R,E=new WeakMap,d=new WeakMap,R.a=0,R.b=new Map([["statusBarItem.errorBackground",new f.$nL("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new f.$nL("statusBarItem.warningForeground")]]);class S{constructor(p){this.b=[],this.a=p.createStatusBarEntry(void 0,"status.extensionMessage",f.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,I.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(p){const g={message:p};return this.b.unshift(g),this.c(),new f.$sK(()=>{const t=this.b.indexOf(g);t>=0&&(this.b.splice(t,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class u{constructor(p,g){this.e=new Map,this.a=p.getProxy(C.$qK.MainThreadStatusBar),this.b=g,this.c=new S(this)}$acceptStaticEntries(p){for(const g of p)this.e.set(g.entryId,g)}createStatusBarEntry(p,g,t,i){return new R(this.a,this.b,this.e,p,g,t,i)}setStatusBarMessage(p,g){const t=this.c.setMessage(p);let i;return typeof g=="number"?i=setTimeout(()=>t.dispose(),g):typeof g<"u"&&g.then(()=>t.dispose(),()=>t.dispose()),new f.$sK(()=>{t.dispose(),clearTimeout(i)})}}e.$Cdc=u}),define(Ae[84],Re([1,0,3,5,4]),function(ee,e,f,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7cc=e.$6cc=void 0;class O{constructor(c,E){this.c=E,this.b=new C.$Od,this.onDidChangeStorage=this.b.event,this.a=c.getProxy(f.$qK.MainThreadStorage)}registerExtensionStorageKeysToSync(c,E){this.a.$registerExtensionStorageKeysToSync(c,E)}async initializeExtensionStorage(c,E,d){const R=await this.a.$initializeExtensionStorage(c,E);let S;return R&&(S=this.d(c,E,R)),S||d}setValue(c,E,d){return this.a.$setValue(c,E,d)}$acceptValue(c,E,d){const R=this.d(c,E,d);R&&this.b.fire({shared:c,key:E,value:R})}d(c,E,d){try{return JSON.parse(d)}catch(R){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${E}, global: ${c}): ${R}`)}}}e.$6cc=O,e.$7cc=(0,I.$Qh)("IExtHostStorage")}),define(Ae[85],Re([1,0,4,27,14,62,2]),function(ee,e,f,C,I,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$adc=e.$_cc=void 0,e.$_cc=(0,f.$Qh)("IExtensionStoragePaths");let c=class{constructor(d,R,S){this.d=R,this.f=S,this.a=d.workspace??void 0,this.b=d.environment,this.whenReady=this.h().then(u=>this.c=u)}async g(d){return A.URI.joinPath(this.b.workspaceStorageHome,d)}async h(){if(!this.a)return Promise.resolve(void 0);const d=this.a.id,R=await this.g(d);try{return await this.f.value.stat(R),this.d.trace("[ExtHostStorage] storage dir already exists",R),R}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",R),await this.f.value.createDirectory(R),await this.f.value.writeFile(A.URI.joinPath(R,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:A.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),R}catch(S){this.d.error("[ExtHostStorage]",S);return}}workspaceValue(d){if(this.c)return A.URI.joinPath(this.c,d.identifier.value)}globalValue(d){return A.URI.joinPath(this.b.globalStorageHome,d.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$adc=c,e.$adc=c=Ge([qe(0,C.$HM),qe(1,I.$$i),qe(2,O.$$cc)],c)}),define(Ae[63],Re([1,0,5,3,4,2,17,6,7,156,11,182,19,37,183,44,12,8,31]),function(ee,e,f,C,I,O,A,c,E,d,R,S,u,b,p,g,t,i,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$edc=e.$ddc=e.$cdc=e.$bdc=void 0,e.$bdc=(0,I.$Qh)("IExtHostTerminalService");class v{constructor(h,w,y,M){this.l=h,this._id=w,this.m=y,this.n=M,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.m=Object.freeze(this.m),this.b=new Promise(B=>this.f=B);const V=this;this.value={get name(){return V.n||""},get processId(){return V.b},get creationOptions(){return V.m},get exitStatus(){return V.h},get state(){return V.j},get selection(){return V.k},sendText(B,z=!0){V.q(),V.l.$sendText(V._id,B,z)},show(B){V.q(),V.l.$show(V._id,B)},hide(){V.q(),V.l.$hide(V._id)},dispose(){V.a||(V.a=!0,V.l.$dispose(V._id))},get dimensions(){if(!(V.d===void 0||V.g===void 0))return{columns:V.d,rows:V.g}}}}async create(h,w){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.l.$createTerminal(this._id,{name:h.name,shellPath:h.shellPath??void 0,shellArgs:h.shellArgs??void 0,cwd:h.cwd??void 0,env:h.env??void 0,icon:$(h.iconPath)??void 0,color:g.ThemeColor.isThemeColor(h.color)?h.color.id:void 0,initialText:h.message??void 0,strictEnv:h.strictEnv??void 0,hideFromUser:h.hideFromUser??void 0,isFeatureTerminal:w?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:w?.useShellEnvironment??void 0,location:w?.location||this.o(h.location,w?.resolvedExtHostIdentifier),isTransient:h.isTransient??void 0})}async createExtensionTerminal(h,w,y,M){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.l.$createTerminal(this._id,{name:this.n,isExtensionCustomPtyTerminal:!0,icon:y,color:g.ThemeColor.isThemeColor(M)?M.id:void 0,location:this.o(h,w),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}o(h,w){return typeof h=="object"?"parentTerminal"in h&&h.parentTerminal&&w?{parentTerminal:w}:"viewColumn"in h?{viewColumn:i.ViewColumn.from(h.viewColumn),preserveFocus:h.preserveFocus}:void 0:h}q(){if(this.a)throw new Error("Terminal has already been disposed")}set name(h){this.n=h}setExitStatus(h,w){this.h=Object.freeze({code:h,reason:w})}setDimensions(h,w){return h===this.d&&w===this.g||h===0||w===0?!1:(this.d=h,this.g=w,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}setSelection(h){this.k=h}_setProcessId(h){this.f?(this.f(h),this.f=void 0):this.b.then(w=>{w!==h&&(this.b=Promise.resolve(h))})}}e.$cdc=v;class D{get onProcessReady(){return this.b.event}constructor(h){this.g=h,this.id=0,this.shouldPersist=!1,this.a=new f.$Od,this.onProcessData=this.a.event,this.b=new f.$Od,this.d=new f.$Od,this.onDidChangeProperty=this.d.event,this.f=new f.$Od,this.onProcessExit=this.f.event}refreshProperty(h){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${h}`)}updateProperty(h,w){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${h}, value: ${w}`)}async start(){}shutdown(){this.g.close()}input(h){this.g.handleInput?.(h)}resize(h,w){this.g.setDimensions?.({columns:h,rows:w})}clearBuffer(){}async processBinary(h){}acknowledgeDataEvent(h){}async setUnicodeVersion(h){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(h){this.g.onDidWrite(w=>this.a.fire(w)),this.g.onDidClose?.((w=void 0)=>{this.f.fire(w===void 0?void 0:w)}),this.g.onDidOverrideDimensions?.(w=>{w&&this.d.fire({type:"overrideDimensions",value:{cols:w.columns,rows:w.rows}})}),this.g.onDidChangeName?.(w=>{this.d.fire({type:"title",value:w})}),this.g.open(h||void 0),h&&this.g.setDimensions?.(h),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let m=1,n=class extends c.$Sc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(h=>h.value)}constructor(h,w,y){super(),this.Q=w,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new c.$Tc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new f.$Od,this.onDidCloseTerminal=this.H.event,this.I=new f.$Od,this.onDidOpenTerminal=this.I.event,this.J=new f.$Od,this.onDidChangeActiveTerminal=this.J.event,this.L=new f.$Od,this.onDidChangeTerminalDimensions=this.L.event,this.M=new f.$Od,this.onDidChangeTerminalState=this.M.event,this.N=new f.$Od,this.onDidChangeShell=this.N.event,this.O=new f.$Od({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new f.$Od({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=y.getProxy(C.$qK.MainThreadTerminalService),this.y=new p.$clb(this.a.$sendProcessData),this.a.$registerProcessSupport(h),this.Q.registerArgumentProcessor({processArgument:M=>{const V=B=>{const z=B;return this.W(z.instanceId)?.value};switch(M?.$mid){case 15:return V(M);default:{if(Array.isArray(M))for(let B=0;B<M.length&&M[B].$mid===15;B++)M[B]=V(M[B]);return M}}}}),this.B({dispose:()=>{for(const[M,V]of this.g)V.shutdown(!0)}})}getDefaultShell(h){return(h?this.u:this.s)?.path||""}getDefaultShellArgs(h){return(h?this.u:this.s)?.args||[]}createExtensionTerminal(h,w){const y=new v(this.a,(0,b.$fg)(),h,h.name),M=new D(h.pty);return y.createExtensionTerminal(h.location,this.R(h,w).resolvedExtHostIdentifier,$(h.iconPath),a(h.color)).then(V=>{const B=this.S(V,M);this.h[V]=B}),this.f.push(y),y.value}R(h,w){if(w=w||{},h.location&&typeof h.location=="object"&&"parentTerminal"in h.location){const y=h.location.parentTerminal;if(y){const M=this.f.find(V=>V.value===y);M&&(w.resolvedExtHostIdentifier=M._id)}}else h.location&&typeof h.location!="object"?w.location=h.location:w.location&&typeof w.location=="object"&&"splitActiveTerminal"in w.location&&(w.location={splitActiveTerminal:!0});return w}attachPtyToTerminal(h,w){if(!this.W(h))throw new Error(`Cannot resolve terminal with id ${h} for virtual process`);const M=new D(w),V=this.S(h,M);this.h[h]=V}async $acceptActiveTerminalChanged(h){const w=this.b;if(h===null){this.b=void 0,w!==this.b&&this.J.fire(this.b);return}const y=this.W(h);y&&(this.b=y,w!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(h,w){const y=this.W(h);y&&this.O.fire({terminal:y.value,data:w})}async $acceptTerminalDimensions(h,w,y){const M=this.W(h);M&&M.setDimensions(w,y)&&this.L.fire({terminal:M.value,dimensions:M.value.dimensions})}async $acceptDidExecuteCommand(h,w){const y=this.W(h);y&&this.P.fire({terminal:y.value,...w})}async $acceptTerminalMaximumDimensions(h,w,y){this.g.get(h)?.resize(w,y)}async $acceptTerminalTitleChange(h,w){const y=this.W(h);y&&(y.name=w)}async $acceptTerminalClosed(h,w,y){const M=this.Y(this.f,h);if(M!==null){const V=this.f.splice(M,1)[0];V.setExitStatus(w,y),this.H.fire(V.value)}}$acceptTerminalOpened(h,w,y,M){if(w){const z=this.Y(this.f,w);if(z!==null){this.f[z]._id=h,this.I.fire(this.terminals[z]),this.f[z].isOpen=!0;return}}const V={name:M.name,shellPath:M.executable,shellArgs:M.args,cwd:typeof M.cwd=="string"?M.cwd:O.URI.revive(M.cwd),env:M.env,hideFromUser:M.hideFromUser},B=new v(this.a,h,V,y);this.f.push(B),this.I.fire(B.value),B.isOpen=!0}async $acceptTerminalProcessId(h,w){this.W(h)?._setProcessId(w)}async $startExtensionTerminal(h,w){const y=this.W(h);if(!y)return{message:(0,d.localize)(0,null,h)};y.isOpen||await new Promise(V=>{const B=this.onDidOpenTerminal(async z=>{z===y.value&&(B.dispose(),V())})});const M=this.g.get(h);M?M.startSendingEvents(w):this.j[h]={initialDimensions:w}}S(h,w){const y=new c.$Rc;y.add(w.onProcessReady(V=>this.a.$sendProcessReady(h,V.pid,V.cwd,V.windowsPty))),y.add(w.onDidChangeProperty(V=>this.a.$sendProcessProperty(h,V))),this.y.startBuffering(h,w.onProcessData),y.add(w.onProcessExit(V=>this.U(h,V))),this.g.set(h,w);const M=this.j[h];return M&&w instanceof D&&(w.startSendingEvents(M.initialDimensions),delete this.j[h]),y}$acceptProcessAckDataEvent(h,w){this.g.get(h)?.acknowledgeDataEvent(w)}$acceptProcessInput(h,w){this.g.get(h)?.input(w)}$acceptTerminalInteraction(h){const w=this.W(h);w?.setInteractedWith()&&this.M.fire(w.value)}$acceptTerminalSelection(h,w){this.W(h)?.setSelection(w)}$acceptProcessResize(h,w,y){try{this.g.get(h)?.resize(w,y)}catch(M){if(M.code!=="EPIPE"&&M.code!=="ERR_IPC_CHANNEL_CLOSED")throw M}}$acceptProcessShutdown(h,w){this.g.get(h)?.shutdown(w)}$acceptProcessRequestInitialCwd(h){this.g.get(h)?.getInitialCwd().then(w=>this.a.$sendProcessProperty(h,{type:"initialCwd",value:w}))}$acceptProcessRequestCwd(h){this.g.get(h)?.getCwd().then(w=>this.a.$sendProcessProperty(h,{type:"cwd",value:w}))}$acceptProcessRequestLatency(h){return Promise.resolve(h)}registerLinkProvider(h){return this.z.add(h),this.z.size===1&&this.a.$startLinkProvider(),new E.$sK(()=>{this.z.delete(h),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(h,w,y){if(this.C.has(w))throw new Error(`Terminal profile provider "${w}" already registered`);return this.C.set(w,y),this.a.$registerProfileProvider(w,h.identifier.value),new E.$sK(()=>{this.C.delete(w),this.a.$unregisterProfileProvider(w)})}registerTerminalQuickFixProvider(h,w,y){if(this.D.has(h))throw new Error(`Terminal quick fix provider "${h}" is already registered`);return this.D.set(h,y),this.a.$registerQuickFixProvider(h,w),new E.$sK(()=>{this.D.delete(h),this.a.$unregisterQuickFixProvider(h)})}async $provideTerminalQuickFixes(h,w){const y=new u.$Yd().token;if(y.isCancellationRequested)return;const M=this.D.get(h);if(!M)return;const V=await M.provideTerminalQuickFixes(w,y);if(V===null||Array.isArray(V)&&V.length===0)return;const B=new c.$Rc;if(this.w.value=B,!Array.isArray(V))return V?i.TerminalQuickFix.from(V,this.Q.converter,B):void 0;const z=[];for(const T of V){const F=i.TerminalQuickFix.from(T,this.Q.converter,B);F&&z.push(F)}return z}async $createContributedProfileTerminal(h,w){const y=new u.$Yd().token;let M=await this.C.get(h)?.provideTerminalProfile(y);if(!y.isCancellationRequested){if(M&&!("options"in M)&&(M={options:M}),!M||!("options"in M))throw new Error(`No terminal profile options provided for id "${h}"`);if("pty"in M.options){this.createExtensionTerminal(M.options,w);return}this.createTerminalFromOptions(M.options,w)}}async $provideLinks(h,w){const y=this.W(h);if(!y)return[];this.F.delete(h),this.G.get(h)?.dispose(!0);const V=new u.$Yd;this.G.set(h,V);const B=[],z={terminal:y.value,line:w},T=[];for(const q of this.z)T.push(t.Promises.withAsyncBody(async W=>{V.token.onCancellationRequested(()=>W({provider:q,links:[]}));const we=await q.provideTerminalLinks(z,V.token)||[];V.token.isCancellationRequested||W({provider:q,links:we})}));const F=await Promise.all(T);if(V.token.isCancellationRequested)return[];const j=new Map;for(const q of F)q&&q.links.length>0&&B.push(...q.links.map(W=>{const we={id:m++,startIndex:W.startIndex,length:W.length,label:W.tooltip};return j.set(we.id,{provider:q.provider,link:W}),we}));return this.F.set(h,j),B}$activateLink(h,w){const y=this.F.get(h)?.get(w);y&&y.provider.handleTerminalLink(y.link)}U(h,w){this.y.stopBuffering(h),this.g.delete(h),delete this.j[h];const y=this.h[h];y&&(y.dispose(),delete this.h[h]),this.a.$sendProcessExit(h,w)}W(h){return this.X(this.f,h)}X(h,w){const y=this.Y(h,w);return y!==null?h[y]:null}Y(h,w){const y=h.findIndex(M=>M._id===w);return y===-1?null:y}getEnvironmentVariableCollection(h){let w=this.n.get(h.identifier.value);return w||(w=new r,this.$(h.identifier.value,w)),w.getScopedEnvironmentVariableCollection(void 0)}Z(h,w){const y=(0,S.$pr)(w.map),M=(0,S.$qr)(w.descriptionMap);this.a.$setEnvironmentVariableCollection(h,w.persistent,y.length===0?void 0:y,M)}$initEnvironmentVariableCollections(h){h.forEach(w=>{const y=w[0],M=new r(w[1]);this.$(y,M)})}$acceptDefaultProfile(h,w){const y=this.s;this.s=h,this.u=w,y?.path!==h.path&&this.N.fire(h.path)}$(h,w){this.n.set(h,w),w.onDidChangeCollection(()=>{this.Z(h,w)})}};e.$ddc=n,e.$ddc=n=Ge([qe(1,l.$NM),qe(2,A.$rM)],n);class r{get persistent(){return this.b}set persistent(h){this.b=h,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor(h){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new f.$Od,this.map=new Map(h)}getScopedEnvironmentVariableCollection(h){const w=this.h(h);let y=this.a.get(w);return y||(y=new s(this,h),this.a.set(w,y),y.onDidChangeCollection(()=>this.d.fire())),y}replace(h,w,y,M){this.f(h,{value:w,type:E.EnvironmentVariableMutatorType.Replace,options:y??{applyAtProcessCreation:!0},scope:M})}append(h,w,y,M){this.f(h,{value:w,type:E.EnvironmentVariableMutatorType.Append,options:y??{applyAtProcessCreation:!0},scope:M})}prepend(h,w,y,M){this.f(h,{value:w,type:E.EnvironmentVariableMutatorType.Prepend,options:y??{applyAtProcessCreation:!0},scope:M})}f(h,w){if(w.options&&w.options.applyAtProcessCreation===!1&&!w.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const y=this.g(h,w.scope),M=this.map.get(y),V=w.options?{applyAtProcessCreation:w.options.applyAtProcessCreation??!1,applyAtShellIntegration:w.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!M||M.value!==w.value||M.type!==w.type||M.options?.applyAtProcessCreation!==V.applyAtProcessCreation||M.options?.applyAtShellIntegration!==V.applyAtShellIntegration||M.scope?.workspaceFolder?.index!==w.scope?.workspaceFolder?.index){const B=this.g(h,w.scope),z={variable:h,...w,options:V};this.map.set(B,z),this.d.fire()}}get(h,w){const y=this.g(h,w),M=this.map.get(y);return M?k(M):void 0}g(h,w){const y=this.h(w);return y.length?`${h}:::${y}`:h}h(h){return this.j(h?.workspaceFolder)??""}j(h){return h?h.uri.toString():void 0}getVariableMap(h){const w=new Map;for(const[y,M]of this.map)this.h(M.scope)===this.h(h)&&w.set(M.variable,k(M));return w}delete(h,w){const y=this.g(h,w);this.map.delete(y),this.d.fire()}clear(h){if(h?.workspaceFolder){for(const[w,y]of this.map)y.scope?.workspaceFolder?.index===h.workspaceFolder.index&&this.map.delete(w);this.k(h)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription(h,w){const y=this.h(w),M=this.descriptionMap.get(y);if(!M||M.description!==h){let V;typeof h=="string"?V=h:V=h?.value.split(`

`)[0];const B={description:V,scope:w};this.descriptionMap.set(y,B),this.d.fire()}}getDescription(h){const w=this.h(h);return this.descriptionMap.get(w)?.description}k(h){const w=this.h(h);this.descriptionMap.delete(w)}}class s{get persistent(){return this.b.persistent}set persistent(h){this.b.persistent=h}get onDidChangeCollection(){return this.a&&this.a.event}constructor(h,w){this.b=h,this.d=w,this.a=new f.$Od}getScoped(h){return this.b.getScopedEnvironmentVariableCollection(h)}replace(h,w,y){this.b.replace(h,w,y,this.d)}append(h,w,y){this.b.append(h,w,y,this.d)}prepend(h,w,y){this.b.prepend(h,w,y,this.d)}get(h){return this.b.get(h,this.d)}forEach(h,w){this.b.getVariableMap(this.d).forEach((y,M)=>h.call(w,M,y,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(h){this.b.delete(h,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(h){this.b.setDescription(h,this.d)}get description(){return this.b.getDescription(this.d)}}let o=class extends n{constructor(h,w){super(!1,h,w)}createTerminal(h,w,y){throw new R.$_}createTerminalFromOptions(h,w){throw new R.$_}};e.$edc=o,e.$edc=o=Ge([qe(0,l.$NM),qe(1,A.$rM)],o);function $(P){if(!(!P||typeof P=="string"))return"id"in P?{id:P.id,color:P.color}:P}function a(P){return g.ThemeColor.isThemeColor(P)?P:void 0}function k(P){const h={...P};return delete h.scope,h.options=h.options??void 0,delete h.variable,h}});var Ne=this&&this.__classPrivateFieldGet||function(ee,e,f,C){if(f==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!C:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return f==="m"?C:f==="a"?C.call(ee):C?C.value:e.get(ee)},Xe=this&&this.__classPrivateFieldSet||function(ee,e,f,C,I){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!I:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?I.call(ee,f):I?I.value=f:e.set(ee,f),f};define(Ae[256],Re([1,0,285,12,26,19,5,206,93,6,25,15,37,3,17,105,8,7,46,76,58]),function(ee,e,f,C,I,O,A,c,E,d,R,S,u,b,p,g,t,i,l,v,D){"use strict";var m,n;Object.defineProperty(e,"__esModule",{value:!0}),e.$oec=e.$nec=e.$mec=e.$lec=void 0;let r=class{constructor(T,F,j){this.j=j,this.c=new A.$Od,this.d=new Map,this.onResultsChanged=this.c.event,this.results=[],this.f=T.getProxy(b.$qK.MainThreadTesting),this.h=new M(this.f),this.g=new a(this.f),F.registerArgumentProcessor({processArgument:q=>{switch(q?.$mid){case 16:{const W=q,we=W.tests[W.tests.length-1].item.extId;return this.d.get(l.$jJ.root(we))?.collection.tree.get(we)?.actual??(0,g.$DM)(q)}case 18:{const{extId:W,message:we}=q;return{test:this.d.get(l.$jJ.root(W))?.collection.tree.get(W)?.actual,message:t.TestMessage.to(we)}}default:return q}}}),F.registerCommand(!1,"testing.getExplorerSelection",async()=>{const q=await F.executeCommand("_testing.getExplorerSelection"),W=we=>{const ke=this.d.get(l.$jJ.root(we));if(ke)return l.$jJ.isRoot(we)?ke.controller:ke.collection.tree.get(we)?.actual};return{include:q?.include.map(W).filter(S.$Hf)||[],exclude:q?.exclude.map(W).filter(S.$Hf)||[]}})}createTestController(T,F,j,q){if(this.d.has(F))throw new Error(`Attempt to insert a duplicate controller with ID "${F}"`);const W=new d.$Rc,we=W.add(new g.$GM(F,j,this.j));we.root.label=j;const ke=new Map,Se=this.f,ve={items:we.root.children,get label(){return j},set label(re){j=re,we.root.label=re,Se.$updateController(F,{label:j})},get refreshHandler(){return q},set refreshHandler(re){q=re,Se.$updateController(F,{canRefresh:!!re})},get id(){return F},createRunProfile:(re,oe,ye,De,Q,ue)=>{let J=(0,E.$Ei)(re);for(;ke.has(J);)J++;return new V(this.f,ke,F,J,re,oe,ye,De,Q,ue)},createTestItem(re,oe,ye){return new g.$EM(F,re,oe,ye)},createTestRun:(re,oe,ye=!0)=>this.g.createTestRun(T,F,we,re,oe,ye),invalidateTestResults:re=>{if(re===void 0)this.f.$markTestRetired(void 0);else{const oe=re instanceof Array?re:[re];this.f.$markTestRetired(oe.map(ye=>l.$jJ.fromExtHostTestItem(ye,F).toString()))}},set resolveHandler(re){we.resolveHandler=re},get resolveHandler(){return we.resolveHandler},dispose:()=>{W.dispose()}};Se.$registerTestController(F,j,!!q),W.add((0,d.$Qc)(()=>Se.$unregisterTestController(F)));const ge={controller:ve,collection:we,profiles:ke,extension:T};return this.d.set(F,ge),W.add((0,d.$Qc)(()=>this.d.delete(F))),W.add(we.onDidGenerateDiff(re=>Se.$publishDiff(F,re.map(D.TestsDiffOp.serialize)))),ve}createTestObserver(){return this.h.checkout()}async runTests(T,F=O.CancellationToken.None){const j=k(T);if(!j)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const q=this.d.get(j.controllerId);if(!q)throw new Error("Controller not found");await this.f.$runTests({isUiTriggered:!1,targets:[{testIds:T.include?.map(W=>l.$jJ.fromExtHostTestItem(W,q.collection.root.id).toString())??[q.collection.root.id],profileGroup:B[j.kind],profileId:j.profileId,controllerId:j.controllerId}],exclude:T.exclude?.map(W=>W.id)},F)}$syncTests(){for(const{collection:T}of this.d.values())T.flushDiff();return Promise.resolve()}$provideFileCoverage(T,F,j){return(0,f.$rb)(this.g.trackers,W=>W.id===T?W.getCoverage(F):void 0)?.provideFileCoverage(j)??Promise.resolve([])}$resolveFileCoverage(T,F,j,q){return(0,f.$rb)(this.g.trackers,we=>we.id===T?we.getCoverage(F):void 0)?.resolveFileCoverage(j,q)??Promise.resolve([])}$configureRunProfile(T,F){this.d.get(T)?.profiles.get(F)?.configureHandler?.()}async $refreshTests(T,F){await this.d.get(T)?.controller.refreshHandler?.(F)}$publishTestResults(T){this.results=Object.freeze(T.map(F=>(0,R.$0m)(t.TestResults.to(F))).concat(this.results).sort((F,j)=>j.completedAt-F.completedAt).slice(0,32)),this.c.fire()}async $expandTest(T,F){const j=this.d.get(l.$jJ.fromString(T).controllerId)?.collection;j&&(await j.expand(T,F<0?1/0:F),j.flushDiff())}$acceptDiff(T){this.h.applyDiff(T.map(D.TestsDiffOp.deserialize))}async $runControllerTests(T,F){return Promise.all(T.map(j=>this.k(j,!1,F)))}async $startContinuousRun(T,F){const j=new O.$Yd(F),q=await Promise.all(T.map(W=>this.k(W,!0,j.token)));return!F.isCancellationRequested&&!q.some(W=>W.error)&&await new Promise(W=>F.onCancellationRequested(W)),j.dispose(!0),q}async k(T,F,j){const q=this.d.get(T.controllerId);if(!q)return{};const{collection:W,profiles:we,extension:ke}=q,Se=we.get(T.profileId);if(!Se)return{};const ve=T.testIds.map(ye=>W.tree.get(ye)).filter(S.$Hf),ge=T.excludeExtIds.map(ye=>q.collection.tree.get(ye)).filter(S.$Hf).filter(ye=>ve.some(De=>De.fullId.compare(ye.fullId)===2));if(!ve.length)return{};const re=new i.$1L(ve.some(ye=>ye.actual instanceof g.$FM)?void 0:ve.map(ye=>ye.actual),ge.map(ye=>ye.actual),Se,F),oe=(0,D.$lJ)(T)&&this.g.prepareForMainThreadTestRun(re,P.fromInternal(T,q.collection),ke,j);try{return await Se.runHandler(re,j),{}}catch(ye){return{error:String(ye)}}finally{oe&&(oe.hasRunningTasks&&!j.isCancellationRequested&&await A.Event.toPromise(oe.onEnd),oe.dispose())}}$cancelExtensionTestRun(T){T===void 0?this.g.cancelAllRuns():this.g.cancelRunById(T)}};e.$lec=r,e.$lec=r=Ge([qe(0,p.$rM)],r);const s=1e4;var o;(function(z){z[z.Running=0]="Running",z[z.Cancelling=1]="Cancelling",z[z.Ended=2]="Ended"})(o||(o={}));class $ extends d.$Sc{get hasRunningTasks(){return this.f.size>0}get id(){return this.m.id}constructor(T,F,j){super(),this.m=T,this.s=F,this.c=0,this.f=new Map,this.g=new Set,this.j=this.B(new A.$Od),this.onEnd=this.j.event,this.h=this.B(new O.$Yd(j));const q=this.B(new C.$7g(()=>this.u(),s));this.B(this.h.token.onCancellationRequested(()=>q.schedule()))}cancel(){this.c===0?(this.h.cancel(),this.c=1):this.c===1&&this.u()}getCoverage(T){return this.f.get(T)?.coverage}createRun(T){const F=this.m.id,j=this.m.controllerId,q=(0,u.$fg)(),W=new h(this.s,F,q),we=ge=>(re,...oe)=>{if(Se){console.warn(`Setting the state of test "${re.id}" is a no-op after the run ends.`);return}this.m.isIncluded(re)&&(this.y(re),ge(re,...oe))},ke=(ge,re)=>{const oe=re instanceof Array?re.map(t.TestMessage.from):[t.TestMessage.from(re)];if(ge.uri&&ge.range){const ye={range:t.Range.from(ge.range),uri:ge.uri};for(const De of oe)De.location=De.location||ye}this.s.$appendTestMessagesInRun(F,q,l.$jJ.fromExtHostTestItem(ge,j).toString(),oe)};let Se=!1;const ve={isPersisted:this.m.isPersisted,token:this.h.token,name:T,get coverageProvider(){return W.coverageProvider},set coverageProvider(ge){W.coverageProvider=ge},enqueued:we(ge=>{this.s.$updateTestStateInRun(F,q,l.$jJ.fromExtHostTestItem(ge,j).toString(),1)}),skipped:we(ge=>{this.s.$updateTestStateInRun(F,q,l.$jJ.fromExtHostTestItem(ge,j).toString(),5)}),started:we(ge=>{this.s.$updateTestStateInRun(F,q,l.$jJ.fromExtHostTestItem(ge,j).toString(),2)}),errored:we((ge,re,oe)=>{ke(ge,re),this.s.$updateTestStateInRun(F,q,l.$jJ.fromExtHostTestItem(ge,j).toString(),6,oe)}),failed:we((ge,re,oe)=>{ke(ge,re),this.s.$updateTestStateInRun(F,q,l.$jJ.fromExtHostTestItem(ge,j).toString(),4,oe)}),passed:we((ge,re)=>{this.s.$updateTestStateInRun(F,q,l.$jJ.fromExtHostTestItem(ge,this.m.controllerId).toString(),3,re)}),appendOutput:(ge,re,oe)=>{Se||(oe&&(this.m.isIncluded(oe)?this.y(oe):oe=void 0),this.s.$appendOutputToRun(F,q,I.$ce.fromString(ge),re&&t.location.from(re),oe&&l.$jJ.fromExtHostTestItem(oe,j).toString()))},end:()=>{Se||(Se=!0,this.s.$finishedTestRunTask(F,q),this.f.delete(q),this.f.size||this.w())}};return this.f.set(q,{run:ve,coverage:W}),this.s.$startedTestRunTask(F,{id:q,name:T,running:!0}),ve}u(){for(const{run:T}of this.f.values())T.end()}w(){this.c!==2&&(this.c=2,this.j.fire())}y(T){if(!(T instanceof g.$EM))throw new v.$jM(T.id);if(this.g.has(l.$jJ.fromExtHostTestItem(T,this.m.controllerId).toString()))return;const F=[],j=this.m.colllection.root;for(;;){const q=t.TestItem.from(T);if(F.unshift(q),this.g.has(q.extId)||(this.g.add(q.extId),T===j))break;T=T.parent||j}this.s.$addTestsToRun(this.m.controllerId,this.m.id,F)}dispose(){this.w(),super.dispose()}}class a{get trackers(){return this.c.values()}constructor(T){this.d=T,this.c=new Map}prepareForMainThreadTestRun(T,F,j,q){return this.f(T,F,j,q)}cancelRunById(T){for(const F of this.c.values())if(F.id===T){F.cancel();return}}cancelAllRuns(){for(const T of this.c.values())T.cancel()}createTestRun(T,F,j,q,W,we){const ke=this.c.get(q);if(ke)return ke.createRun(W);const Se=P.fromPublic(F,j,q,we),ve=k(q);this.d.$startedExtensionTestRun({controllerId:F,continuous:!!q.continuous,profile:ve&&{group:B[ve.kind],id:ve.profileId},exclude:q.exclude?.map(re=>l.$jJ.fromExtHostTestItem(re,j.root.id).toString())??[],id:Se.id,include:q.include?.map(re=>l.$jJ.fromExtHostTestItem(re,j.root.id).toString())??[j.root.id],persist:we});const ge=this.f(q,Se,T);return A.Event.once(ge.onEnd)(()=>{this.d.$finishedExtensionTestRun(Se.id),ge.dispose()}),ge.createRun(W)}f(T,F,j,q){const W=new $(F,this.d,q);return this.c.set(T,W),A.Event.once(W.onEnd)(()=>this.c.delete(T)),W}}e.$mec=a;const k=z=>{if(z.profile){if(!(z.profile instanceof V))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return z.profile}};class P{static fromPublic(T,F,j,q){return new P(T,(0,u.$fg)(),j.include?.map(W=>l.$jJ.fromExtHostTestItem(W,T).toString())??[T],j.exclude?.map(W=>l.$jJ.fromExtHostTestItem(W,T).toString())??[],q,F)}static fromInternal(T,F){return new P(T.controllerId,T.runId,T.testIds,T.excludeExtIds,!0,F)}constructor(T,F,j,q,W,we){this.controllerId=T,this.id=F,this.isPersisted=W,this.colllection=we,this.c=j.map(ke=>ke+"\0"),this.d=q.map(ke=>ke+"\0")}isIncluded(T){const F=l.$jJ.fromExtHostTestItem(T,this.controllerId).toString()+"\0";for(const j of this.d)if(F===j||F.startsWith(j))return!1;for(const j of this.c)if(F===j||F.startsWith(j))return!0;return!1}}e.$nec=P;class h{set coverageProvider(T){if(this.c)throw new Error("The TestCoverageProvider cannot be replaced after being provided");T&&(this.c=T,this.f.$signalCoverageAvailable(this.g,this.h))}get coverageProvider(){return this.c}constructor(T,F,j){this.f=T,this.g=F,this.h=j}async provideFileCoverage(T){if(!this.c)return[];this.d||(this.d=(async()=>this.c.provideFileCoverage(T))());try{return(await this.d)?.map(t.TestCoverage.fromFile)??[]}catch(F){throw this.d=void 0,F}}async resolveFileCoverage(T,F){const j=await this.d;let q=j?.[T];return!this.c||!j||!q?[]:(q.detailedCoverage||(q=j[T]=await this.c.resolveFileCoverage?.(q,F)??q),q.detailedCoverage?.map(t.TestCoverage.fromDetailed)??[])}}class w{get isEmpty(){return this.c.size===0&&this.f.size===0&&this.d.size===0}constructor(T){this.h=T,this.c=new Set,this.d=new Set,this.f=new Set,this.g=new Set}add(T){this.c.add(T)}update(T){Object.assign(T.revived,t.TestItem.toPlain(T.item)),this.c.has(T)||this.d.add(T)}remove(T){if(this.c.has(T)){this.c.delete(T);return}this.d.delete(T);const F=l.$jJ.parentId(T.item.extId);if(F&&this.g.has(F.toString())){this.g.add(T.item.extId);return}this.f.add(T)}getChangeEvent(){const{c:T,d:F,f:j}=this;return{get added(){return[...T].map(q=>q.revived)},get updated(){return[...F].map(q=>q.revived)},get removed(){return[...j].map(q=>q.revived)}}}complete(){this.isEmpty||this.h.fire(this.getChangeEvent())}}class y extends D.$qJ{constructor(){super(...arguments),this.q=new A.$Od,this.onDidChangeTests=this.q.event}get rootTests(){return this.f}getMirroredTestDataById(T){return this.d.get(T)}getMirroredTestDataByReference(T){return this.d.get(T.id)}p(T,F){return{...T,revived:t.TestItem.toPlain(T.item),depth:F?F.depth+1:0,children:new Set}}o(){return new w(this.q)}}class M{constructor(T){this.d=T}checkout(){this.c||(this.c=this.f());const T=this.c;return T.observers++,{onDidChangeTest:T.tests.onDidChangeTests,get tests(){return[...T.tests.rootTests].map(F=>F.revived)},dispose:(0,c.$db)(()=>{--T.observers===0&&(this.d.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(T){return this.c?.tests.getMirroredTestDataByReference(T)}applyDiff(T){this.c?.tests.apply(T)}f(){const T=new y;return this.d.$subscribeToDiffs(),{observers:0,tests:T}}}class V{get label(){return this.d}set label(T){T!==this.d&&(this.d=T,Ne(this,m,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:T}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(T){T!==this.g&&(this.g=T,Ne(this,m,"f").$updateTestRunConfig(this.controllerId,this.profileId,{supportsContinuousRun:T}))}get isDefault(){return this.f}set isDefault(T){T!==this.f&&(this.f=T,Ne(this,m,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:T}))}get tag(){return this._tag}set tag(T){T?.id!==this._tag?.id&&(this._tag=T,Ne(this,m,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:T?t.TestTag.namespace(this.controllerId,T.id):null}))}get configureHandler(){return this.c}set configureHandler(T){T!==this.c&&(this.c=T,Ne(this,m,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!T}))}constructor(T,F,j,q,W,we,ke,Se=!1,ve=void 0,ge=!1){this.controllerId=j,this.profileId=q,this.d=W,this.kind=we,this.runHandler=ke,this.f=Se,this._tag=ve,this.g=ge,m.set(this,void 0),n.set(this,void 0),Xe(this,m,T,"f"),Xe(this,n,F,"f"),F.set(q,this);const re=B[we];if(typeof re!="number")throw new Error(`Unknown TestRunProfile.group ${we}`);Ne(this,m,"f").$publishTestRunProfile({profileId:q,controllerId:j,tag:ve?t.TestTag.namespace(this.controllerId,ve.id):null,label:W,group:re,isDefault:Se,hasConfigurationHandler:!1,supportsContinuousRun:ge})}dispose(){Ne(this,n,"f")?.delete(this.profileId)&&(Xe(this,n,void 0,"f"),Ne(this,m,"f").$removeTestProfile(this.controllerId,this.profileId))}}e.$oec=V,m=new WeakMap,n=new WeakMap;const B={[i.TestRunProfileKind.Coverage]:8,[i.TestRunProfileKind.Debug]:4,[i.TestRunProfileKind.Run]:2}}),define(Ae[257],Re([1,0,18,11,5,3,106,8,7]),function(ee,e,f,C,I,O,A,c,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ddc=void 0;class d{constructor(S,u){this.i=u,this.a=new I.$Od({onListenerError:C.$2}),this.b=new I.$Od({onListenerError:C.$2}),this.c=new I.$Od({onListenerError:C.$2}),this.d=new I.$Od({onListenerError:C.$2}),this.f=new I.$Od({onListenerError:C.$2}),this.g=new I.$Od({onListenerError:C.$2}),this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=S.getProxy(O.$qK.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(b=>this.g.fire(b)),this.i.onDidChangeActiveTextEditor(b=>this.f.fire(b))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(S){const u=this.i.allEditors();return S?u:u.map(b=>b.value)}async showTextDocument(S,u,b){let p;typeof u=="number"?p={position:c.ViewColumn.from(u),preserveFocus:b}:typeof u=="object"?p={position:c.ViewColumn.from(u.viewColumn),preserveFocus:u.preserveFocus,selection:typeof u.selection=="object"?c.Range.from(u.selection):void 0,pinned:typeof u.preview=="boolean"?!u.preview:void 0}:p={preserveFocus:!1};const g=await this.h.$tryShowTextDocument(S.uri,p),t=g&&this.i.getEditor(g);if(t)return t.value;throw g?new Error(`Could NOT open editor for "${S.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${S.uri.toString()}".`)}createTextEditorDecorationType(S,u){return new A.$yM(this.h,S,u).value}$acceptEditorPropertiesChanged(S,u){const b=this.i.getEditor(S);if(!b)throw new Error("unknown text editor");if(u.options&&b._acceptOptions(u.options),u.selections){const p=u.selections.selections.map(c.Selection.to);b._acceptSelections(p)}if(u.visibleRanges){const p=f.$Hb(u.visibleRanges.map(c.Range.to));b._acceptVisibleRanges(p)}if(u.options&&this.b.fire({textEditor:b.value,options:{...u.options,lineNumbers:c.TextEditorLineNumbersStyle.to(u.options.lineNumbers)}}),u.selections){const p=E.TextEditorSelectionChangeKind.fromValue(u.selections.source),g=u.selections.selections.map(c.Selection.to);this.a.fire({textEditor:b.value,selections:g,kind:p})}if(u.visibleRanges){const p=f.$Hb(u.visibleRanges.map(c.Range.to));this.c.fire({textEditor:b.value,visibleRanges:p})}}$acceptEditorPositionData(S){for(const u in S){const b=this.i.getEditor(u);if(!b)throw new Error("Unknown text editor");const p=c.ViewColumn.to(S[u]);b.value.viewColumn!==p&&(b._acceptViewColumn(p),this.d.fire({textEditor:b.value,viewColumn:p}))}}getDiffInformation(S){return Promise.resolve(this.h.$getDiffInformation(S))}}e.$Ddc=d}),define(Ae[258],Re([1,0,2,4,3,6,7,8,21,15]),function(ee,e,f,C,I,O,A,c,E,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gec=e.$fec=void 0,e.$fec=(0,C.$Qh)("IExtHostTimeline");class R{constructor(b,p){this.b=new Map,this.c=new Map,this.a=b.getProxy(I.$qK.MainThreadTimeline),p.registerArgumentProcessor({processArgument:(g,t)=>{if(g&&g.$mid===12)if(this.b.get(g.source)&&E.$8l.equals(t,this.b.get(g.source)?.extension)){const i=g.uri===void 0?void 0:f.URI.revive(g.uri);return this.c.get(g.source)?.get(S(i))?.get(g.handle)}else return;return g}})}async $getTimeline(b,p,g,t){return this.b.get(b)?.provider.provideTimeline(f.URI.revive(p),g,t)}registerTimelineProvider(b,p,g,t){const i=new O.$Rc,l=this.d(p.id,t,i).bind(this);let v;p.onDidChange&&(v=p.onDidChange(m=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...m,id:p.id}),this));const D=this.c;return this.f({...p,scheme:b,onDidChange:void 0,async provideTimeline(m,n,r){n?.resetCache&&(i.clear(),D.get(p.id)?.clear());const s=await p.provideTimeline(m,n,r);if(s==null)return;const o=l(m,n);return{...s,source:p.id,items:s.items.map(o)}},dispose(){for(const m of D.values())m.get(p.id)?.clear();v?.dispose(),i.dispose()}},g)}d(b,p,g){return(t,i)=>{let l;if(i?.cacheResults){let v=this.c.get(b);v===void 0&&(v=new Map,this.c.set(b,v));const D=S(t);l=v.get(D),l===void 0&&(l=new Map,v.set(D,l))}return v=>{const{iconPath:D,...m}=v,n=`${b}|${v.id??v.timestamp}`;l?.set(n,v);let r,s,o;v.iconPath&&(D instanceof A.$mL?o={id:D.id,color:D.color}:f.URI.isUri(D)?(r=D,s=D):{light:r,dark:s}=D);let $;return A.$SK.isMarkdownString(m.tooltip)?$=c.MarkdownString.from(m.tooltip):(0,d.$zf)(m.tooltip)?$=m.tooltip:A.$SK.isMarkdownString(m.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),$=c.MarkdownString.from(m.detail)):(0,d.$zf)(m.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),$=m.detail),{...m,id:m.id??void 0,handle:n,source:b,command:v.command?p.toInternal(v.command,g):void 0,icon:r,iconDark:s,themeIcon:o,tooltip:$,accessibilityInformation:v.accessibilityInformation}}}}f(b,p){if(this.b.get(b.id))throw new Error(`Timeline Provider ${b.id} already exists.`);return this.a.$registerTimelineProvider({id:b.id,label:b.label,scheme:b.scheme}),this.b.set(b.id,{provider:b,extension:p}),(0,O.$Qc)(()=>{for(const t of this.c.values())t.get(b.id)?.clear();this.b.delete(b.id),this.a.$unregisterTimelineProvider(b.id),b.dispose()})}}e.$gec=R;function S(u){return u?.toString()}}),define(Ae[86],Re([1,0,19,5,6,158,4,14,185,3,27,17,7]),function(ee,e,f,C,I,O,A,c,E,d,R,S,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vwb=e.$uwb=e.TunnelDtoConverter=void 0;class b extends E.$lv{}var p;(function(t){function i(v){return{remoteAddress:v.remoteAddress,localAddress:v.localAddress,public:!!v.public,privacy:v.privacy??(v.public?E.TunnelPrivacyId.Public:E.TunnelPrivacyId.Private),protocol:v.protocol}}t.fromApiTunnel=i;function l(v){return{remoteAddress:{host:v.tunnelRemoteHost,port:v.tunnelRemotePort},localAddress:v.localAddress,public:v.privacy!==E.TunnelPrivacyId.ConstantPrivate&&v.privacy!==E.TunnelPrivacyId.ConstantPrivate,privacy:v.privacy,protocol:v.protocol}}t.fromServiceTunnel=l})(p||(e.TunnelDtoConverter=p={})),e.$uwb=(0,A.$Qh)("IExtHostTunnelService");let g=class extends I.$Sc{constructor(i,l,v){super(),this.s=v,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new C.$Od,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=i.getProxy(d.$qK.MainThreadTunnelService)}async openTunnel(i,l){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${i.identifier.value} called openTunnel API for ${l.remoteAddress.host}:${l.remoteAddress.port}.`);const v=await this.a.$openTunnel(l,i.displayName);if(v){const D=new b(v.remoteAddress,v.localAddress,()=>this.a.$closeTunnel(v.remoteAddress));return this.B(D),D}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(i,l){const v=this.u();return this.r.set(v,{selector:i,provider:l}),this.a.$registerPortsAttributesProvider(i,v),new u.$sK(()=>{this.r.delete(v),this.a.$unregisterPortsAttributesProvider(v)})}async $providePortAttributes(i,l,v,D,m){const n=[];for(const s of i){const o=this.r.get(s);if(!o)return[];n.push(...await Promise.all(l.map(async $=>{let a;try{a=await o.provider.providePortAttributes({port:$,pid:v,commandLine:D},m)}catch{a=await o.provider.providePortAttributes($,v,D,m)}return{providedAttributes:a,port:$}})))}const r=n.filter(s=>!!s.providedAttributes);return r.length>0?r.map(s=>({autoForwardAction:s.providedAttributes.autoForwardAction,port:s.port})):[]}async $registerCandidateFinder(i){}registerTunnelProvider(i,l){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(D,m)=>await i.provideTunnel(D,m,new f.$Yd().token)??void 0;const v=l.tunnelFeatures?{elevation:!!l.tunnelFeatures?.elevation,privacyOptions:l.tunnelFeatures?.privacyOptions}:void 0;return this.a.$setTunnelProvider(v),Promise.resolve((0,I.$Qc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(i,l){if(i){i.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(i.candidatePortSource),i.showCandidatePort&&(this.f=i.showCandidatePort,this.a.$setCandidateFilter());const v=i.tunnelFactory??(l?this.w(l):void 0);if(v){this.b=v;let D=i.tunnelFeatures?.privacyOptions??[];i.tunnelFeatures?.public&&D.length===0&&(D=[{id:"private",label:O.localize(0,null),themeIcon:"lock"},{id:"public",label:O.localize(1,null),themeIcon:"eye"}]);const m=i.tunnelFeatures?{elevation:!!i.tunnelFeatures?.elevation,public:!!i.tunnelFeatures?.public,privacyOptions:D}:void 0;this.a.$setTunnelProvider(m)}}else this.b=void 0;return(0,I.$Qc)(()=>{this.b=void 0})}w(i){}async $closeTunnel(i,l){if(this.g.has(i.host)){const v=this.g.get(i.host);v.has(i.port)&&(l&&v.get(i.port).disposeListener.dispose(),await v.get(i.port).tunnel.dispose(),v.delete(i.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(i,l){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const v=this.b(i,l);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),v!==void 0){const D=await v;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),D===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(i.remoteAddress.host)||this.g.set(i.remoteAddress.host,new Map);const m=this.B(D.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(D.remoteAddress))));return this.g.get(i.remoteAddress.host).set(i.remoteAddress.port,{tunnel:D,disposeListener:m}),p.fromApiTunnel(D)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(v){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),v instanceof Error)return v.message}}async $applyCandidateFilter(i){const l=await Promise.all(i.map(D=>this.f(D.host,D.port,D.detail??""))),v=i.filter((D,m)=>l[m]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${i.map(D=>D.port).join(", ")} to ${v.map(D=>D.port).join(", ")}`),v}};e.$vwb=g,e.$vwb=g=Ge([qe(0,S.$rM),qe(1,R.$HM),qe(2,c.$$i)],g)}),define(Ae[259],Re([1,0,6,13,2,3]),function(ee,e,f,C,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pec=void 0;class A{constructor(E){this.c=new Map,this.b=E.getProxy(O.$qK.MainThreadUriOpeners)}registerExternalUriOpener(E,d,R,S){if(this.c.has(d))throw new Error(`Opener with id '${d}' already registered`);const u=S.schemes.find(b=>!A.a.has(b));if(u)throw new Error(`Scheme '${u}' is not supported. Only http and https are currently supported.`);return this.c.set(d,R),this.b.$registerUriOpener(d,S.schemes,E,S.label),(0,f.$Qc)(()=>{this.c.delete(d),this.b.$unregisterUriOpener(d)})}async $canOpenUri(E,d,R){const S=this.c.get(E);if(!S)throw new Error(`Unknown opener with id: ${E}`);const u=I.URI.revive(d);return S.canOpenExternalUri(u,R)}async $openUri(E,d,R){const S=this.c.get(E);if(!S)throw new Error(`Unknown opener id: '${E}'`);return S.openExternalUri(I.URI.revive(d.resolvedUri),{sourceUri:I.URI.revive(d.sourceUri)},R)}}e.$pec=A,A.a=new Set([C.Schemas.http,C.Schemas.https])}),define(Ae[260],Re([1,0,3,2,6,11,21]),function(ee,e,f,C,I,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fdc=void 0;class c{constructor(d){this.c=new A.$9l,this.d=new Map,this.b=d.getProxy(f.$qK.MainThreadUrls)}registerUriHandler(d,R){const S=d.identifier;if(this.c.has(S))throw new Error(`Protocol handler already registered for extension ${S}`);const u=c.a++;return this.c.add(S),this.d.set(u,R),this.b.$registerUriHandler(u,S,d.displayName||d.name),(0,I.$Qc)(()=>{this.c.delete(S),this.d.delete(u),this.b.$unregisterUriHandler(u)})}$handleExternalUri(d,R){const S=this.d.get(d);if(!S)return Promise.resolve(void 0);try{S.handleUri(C.URI.revive(R))}catch(u){(0,O.$1)(u)}return Promise.resolve(void 0)}async createAppUri(d){return C.URI.revive(await this.b.$createAppUri(d))}}e.$Fdc=c,c.a=0});var Xe=this&&this.__classPrivateFieldSet||function(ee,e,f,C,I){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!I:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?I.call(ee,f):I?I.value=f:e.set(ee,f),f},Ne=this&&this.__classPrivateFieldGet||function(ee,e,f,C){if(f==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!C:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return f==="m"?C:f==="a"?C.call(ee):C?C.value:e.get(ee)};define(Ae[64],Re([1,0,5,6,13,25,2,170,192,77,3]),function(ee,e,f,C,I,O,A,c,E,d,R){"use strict";var S,u,b,p,g,t,i,l,v,D,m,n,r;Object.defineProperty(e,"__esModule",{value:!0}),e.$Kdc=e.$Jdc=e.$Idc=e.$Hdc=e.$Gdc=void 0;class s{constructor(M,V,B,z,T,F,j){S.set(this,void 0),u.set(this,void 0),b.set(this,void 0),p.set(this,void 0),g.set(this,void 0),t.set(this,void 0),i.set(this,""),l.set(this,void 0),v.set(this,!1),D.set(this,!1),m.set(this,void 0),n.set(this,void 0),this._onMessageEmitter=new f.$Od,this.onDidReceiveMessage=this._onMessageEmitter.event,r.set(this,new f.$Od),this._onDidDispose=Ne(this,r,"f").event,Xe(this,S,M,"f"),Xe(this,u,V,"f"),Xe(this,l,B,"f"),Xe(this,p,z,"f"),Xe(this,g,T,"f"),Xe(this,t,F,"f"),Xe(this,m,o(F),"f"),Xe(this,n,$(F),"f"),Xe(this,b,j,"f")}dispose(){Xe(this,v,!0,"f"),Ne(this,r,"f").fire(),Ne(this,r,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(M){return Xe(this,D,!0,"f"),(0,d.$spb)(M,Ne(this,p,"f"))}get cspSource(){const M=Ne(this,t,"f").extensionLocation;if(M.scheme===I.Schemas.https||M.scheme===I.Schemas.http){let V=M.toString();return V.endsWith("/")||(V+="/"),V+" "+d.$rpb}return d.$rpb}get html(){return this.a(),Ne(this,i,"f")}set html(M){this.a(),Ne(this,i,"f")!==M&&(Xe(this,i,M,"f"),Ne(this,n,"f")&&!Ne(this,D,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(M)&&(Xe(this,D,!0,"f"),Ne(this,b,"f").report("Webview vscode-resource: uris",Ne(this,t,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Ne(this,u,"f").$setHtml(Ne(this,S,"f"),this.b(M)))}get options(){return this.a(),Ne(this,l,"f")}set options(M){this.a(),O.$an(Ne(this,l,"f"),M)||Ne(this,u,"f").$setOptions(Ne(this,S,"f"),P(Ne(this,t,"f"),Ne(this,g,"f"),M)),Xe(this,l,M,"f")}async postMessage(M){if(Ne(this,v,"f"))return!1;const V=(0,E.$Rcb)(M,{serializeBuffersForPostMessage:Ne(this,m,"f")});return Ne(this,u,"f").$postMessage(Ne(this,S,"f"),V.message,...V.buffers)}a(){if(Ne(this,v,"f"))throw new Error("Webview is disposed")}b(M){if(!Ne(this,n,"f"))return M;const V=Ne(this,t,"f").extensionLocation?.scheme===I.Schemas.vscodeRemote,B=Ne(this,t,"f").extensionLocation.scheme===I.Schemas.vscodeRemote?Ne(this,t,"f").extensionLocation.authority:void 0;return M.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(z,T,F,j,q,W)=>{const we=A.URI.from({scheme:j||"file",path:decodeURIComponent(q)}),ke=(0,d.$spb)(we,{isRemote:V,authority:B}).toString();return`${T}${ke}${W}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(z,T,F,j,q,W)=>{const we=A.URI.from({scheme:j||"file",path:decodeURIComponent(q)}),ke=(0,d.$spb)(we,{isRemote:V,authority:B}).toString();return`${T}${ke}${W}`})}}e.$Gdc=s,S=new WeakMap,u=new WeakMap,b=new WeakMap,p=new WeakMap,g=new WeakMap,t=new WeakMap,i=new WeakMap,l=new WeakMap,v=new WeakMap,D=new WeakMap,m=new WeakMap,n=new WeakMap,r=new WeakMap;function o(y){try{const M=(0,c.$So)((0,c.$Ro)(y.engines.vscode));return!!M&&M.majorBase>=1&&M.minorBase>=57}catch{return!1}}e.$Hdc=o;function $(y){try{const M=(0,c.$So)((0,c.$Ro)(y.engines.vscode));return M?M.majorBase<1||M.majorBase===1&&M.minorBase<60:!1}catch{return!1}}class a extends C.$Sc{constructor(M,V,B,z,T){super(),this.c=V,this.f=B,this.g=z,this.h=T,this.b=new Map,this.a=M.getProxy(R.$qK.MainThreadWebviews)}dispose(){super.dispose();for(const M of this.b.values())M.dispose();this.b.clear()}$onMessage(M,V,B){const z=this.j(M);if(z){const{message:T}=(0,E.$Scb)(V,B.value);z._onMessageEmitter.fire(T)}}$onMissingCsp(M,V){this.g.warn(`${V} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(M,V,B){const z=new s(M,this.a,h(V),this.c,this.f,B,this.h);this.b.set(M,z);const T=z._onDidDispose(()=>{T.dispose(),this.deleteWebview(M)});return z}deleteWebview(M){this.b.delete(M)}j(M){return this.b.get(M)}}e.$Idc=a;function k(y){return{id:y.identifier,location:y.extensionLocation}}e.$Jdc=k;function P(y,M,V){return{enableCommandUris:V.enableCommandUris,enableScripts:V.enableScripts,enableForms:V.enableForms,portMapping:V.portMapping,localResourceRoots:V.localResourceRoots||w(y,M)}}e.$Kdc=P;function h(y){return{enableCommandUris:y.enableCommandUris,enableScripts:y.enableScripts,enableForms:y.enableForms,portMapping:y.portMapping,localResourceRoots:y.localResourceRoots?.map(M=>A.URI.from(M))}}function w(y,M){return[...(M?.getWorkspaceFolders()||[]).map(V=>V.uri),y.extensionLocation]}}),define(Ae[261],Re([1,0,19,93,6,13,24,2,8,64,74,3,7]),function(ee,e,f,C,I,O,A,c,E,d,R,S,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jec=void 0;class b{constructor(r,s){this.document=r,this.b=s,this.a=1,this.c=new R.$Ccc("custom documents")}addEdit(r){return this.c.add([r])}async undo(r,s){await this.f(r).undo(),s||this.disposeBackup()}async redo(r,s){await this.f(r).redo(),s||this.disposeBackup()}disposeEdits(r){for(const s of r)this.c.delete(s)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const r=m(this.document.uri)+this.a++;return(0,A.$wg)(this.b,r)}updateBackup(r){this.d?.delete(),this.d=r}disposeBackup(){this.d?.delete(),this.d=void 0}f(r){const s=this.c.get(r,0);if(!s)throw new Error("No edit found");return s}}class p{constructor(){this.a=new Map}get(r,s){return this.a.get(this.b(r,s))}add(r,s,o){const $=this.b(r,s.uri);if(this.a.has($))throw new Error(`Document already exists for viewType:${r} resource:${s.uri}`);const a=new b(s,o);return this.a.set($,a),a}delete(r,s){const o=this.b(r,s.uri);this.a.delete(o)}b(r,s){return`${r}@@@${s}`}}var g;(function(n){n[n.Text=0]="Text",n[n.Custom=1]="Custom"})(g||(g={}));class t{constructor(){this.a=new Map}addTextProvider(r,s,o){return this.b(0,r,s,o)}addCustomProvider(r,s,o){return this.b(1,r,s,o)}get(r){return this.a.get(r)}b(r,s,o,$){if(this.a.has(s))throw new Error(`Provider for viewType:${s} already registered`);return this.a.set(s,{type:r,extension:o,provider:$}),new u.$sK(()=>this.a.delete(s))}}class i{constructor(r,s,o,$,a){this.d=s,this.f=o,this.g=$,this.h=a,this.b=new t,this.c=new p,this.a=r.getProxy(S.$qK.MainThreadCustomEditors)}registerCustomEditorProvider(r,s,o,$){const a=new I.$Rc;return v(o)?(a.add(this.b.addTextProvider(s,r,o)),this.a.$registerTextEditorProvider((0,d.$Jdc)(r),s,$.webviewOptions||{},{supportsMove:!!o.moveCustomTextEditor},(0,d.$Hdc)(r))):(a.add(this.b.addCustomProvider(s,r,o)),l(o)&&a.add(o.onDidChangeCustomDocument(k=>{const P=this.i(s,k.document.uri);if(D(k)){const h=P.addEdit(k);this.a.$onDidEdit(k.document.uri,s,h,k.label)}else this.a.$onContentChange(k.document.uri,s)})),this.a.$registerCustomEditorProvider((0,d.$Jdc)(r),s,$.webviewOptions||{},!!$.supportsMultipleEditorsPerDocument,(0,d.$Hdc)(r))),u.$sK.from(a,new u.$sK(()=>{this.a.$unregisterEditorProvider(s)}))}async $createCustomDocument(r,s,o,$,a){const k=this.b.get(s);if(!k)throw new Error(`No provider found for '${s}'`);if(k.type!==1)throw new Error(`Invalid provide type for '${s}'`);const P=c.URI.revive(r),h=await k.provider.openCustomDocument(P,{backupId:o,untitledDocumentData:$?.buffer},a);let w;return l(k.provider)&&this.f&&(w=this.f.workspaceValue(k.extension)??this.f.globalValue(k.extension)),this.c.add(s,h,w),{editable:l(k.provider)}}async $disposeCustomDocument(r,s){const o=this.b.get(s);if(!o)throw new Error(`No provider found for '${s}'`);if(o.type!==1)throw new Error(`Invalid provider type for '${s}'`);const $=c.URI.revive(r),{document:a}=this.i(s,$);this.c.delete(s,a),a.dispose()}async $resolveCustomEditor(r,s,o,$,a,k){const P=this.b.get(o);if(!P)throw new Error(`No provider found for '${o}'`);const h=E.ViewColumn.to(a),w=this.g.createNewWebview(s,$.contentOptions,P.extension),y=this.h.createNewWebviewPanel(s,o,$.title,h,$.options,w,$.active),M=c.URI.revive(r);switch(P.type){case 1:{const{document:V}=this.i(o,M);return P.provider.resolveCustomEditor(V,y,k)}case 0:{const V=this.d.getDocument(M);return P.provider.resolveCustomTextEditor(V,y,k)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(r,s,o){this.i(s,r).disposeEdits(o)}async $onMoveCustomEditor(r,s,o){const $=this.b.get(o);if(!$)throw new Error(`No provider found for '${o}'`);if(!$.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${o}'`);const a=this.h.getWebviewPanel(r);if(!a)throw new Error("No webview found");const k=c.URI.revive(s),P=this.d.getDocument(k);await $.provider.moveCustomTextEditor(P,a,f.CancellationToken.None)}async $undo(r,s,o,$){return this.i(s,r).undo(o,$)}async $redo(r,s,o,$){return this.i(s,r).redo(o,$)}async $revert(r,s,o){const $=this.i(s,r);await this.j(s).revertCustomDocument($.document,o),$.disposeBackup()}async $onSave(r,s,o){const $=this.i(s,r);await this.j(s).saveCustomDocument($.document,o),$.disposeBackup()}async $onSaveAs(r,s,o,$){const a=this.i(s,r);return this.j(s).saveCustomDocumentAs(a.document,c.URI.revive(o),$)}async $backup(r,s,o){const $=this.i(s,r),k=await this.j(s).backupCustomDocument($.document,{destination:$.getNewBackupUri()},o);return $.updateBackup(k),k.id}i(r,s){const o=this.c.get(r,c.URI.revive(s));if(!o)throw new Error("No custom document found");return o}j(r){const o=this.b.get(r)?.provider;if(!o||!l(o))throw new Error("Custom document is not editable");return o}}e.$jec=i;function l(n){return!!n.onDidChangeCustomDocument}function v(n){return typeof n.resolveCustomTextEditor=="function"}function D(n){return typeof n.undo=="function"&&typeof n.redo=="function"}function m(n){const r=n.scheme===O.Schemas.file||n.scheme===O.Schemas.untitled?n.fsPath:n.toString();return(0,C.$Ei)(r)+""}});var Xe=this&&this.__classPrivateFieldSet||function(ee,e,f,C,I){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!I:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?I.call(ee,f):I?I.value=f:e.set(ee,f),f},Ne=this&&this.__classPrivateFieldGet||function(ee,e,f,C){if(f==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!C:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return f==="m"?C:f==="a"?C.call(ee):C?C.value:e.get(ee)};define(Ae[262],Re([1,0,5,6,2,37,8,64,3,7]),function(ee,e,f,C,I,O,A,c,E,d){"use strict";var R,S,u,b,p,g,t,i,l,v,D,m,n;Object.defineProperty(e,"__esModule",{value:!0}),e.$iec=void 0;class r extends C.$Sc{constructor(a,k,P,h){super(),R.set(this,void 0),S.set(this,void 0),u.set(this,void 0),b.set(this,void 0),p.set(this,void 0),g.set(this,void 0),t.set(this,void 0),i.set(this,void 0),l.set(this,!0),v.set(this,void 0),D.set(this,!1),m.set(this,this.B(new f.$Od)),this.onDidDispose=Ne(this,m,"f").event,n.set(this,this.B(new f.$Od)),this.onDidChangeViewState=Ne(this,n,"f").event,Xe(this,R,a,"f"),Xe(this,S,k,"f"),Xe(this,b,P,"f"),Xe(this,u,h.viewType,"f"),Xe(this,p,h.panelOptions,"f"),Xe(this,i,h.viewColumn,"f"),Xe(this,g,h.title,"f"),Xe(this,v,h.active,"f")}dispose(){Ne(this,D,"f")||(Xe(this,D,!0,"f"),Ne(this,m,"f").fire(),Ne(this,S,"f").$disposeWebview(Ne(this,R,"f")),Ne(this,b,"f").dispose(),super.dispose())}get webview(){return this.c(),Ne(this,b,"f")}get viewType(){return this.c(),Ne(this,u,"f")}get title(){return this.c(),Ne(this,g,"f")}set title(a){this.c(),Ne(this,g,"f")!==a&&(Xe(this,g,a,"f"),Ne(this,S,"f").$setTitle(Ne(this,R,"f"),a))}get iconPath(){return this.c(),Ne(this,t,"f")}set iconPath(a){this.c(),Ne(this,t,"f")!==a&&(Xe(this,t,a,"f"),Ne(this,S,"f").$setIconPath(Ne(this,R,"f"),I.URI.isUri(a)?{light:a,dark:a}:a))}get options(){return Ne(this,p,"f")}get viewColumn(){if(this.c(),!(typeof Ne(this,i,"f")=="number"&&Ne(this,i,"f")<0))return Ne(this,i,"f")}get active(){return this.c(),Ne(this,v,"f")}get visible(){return this.c(),Ne(this,l,"f")}_updateViewState(a){Ne(this,D,"f")||(this.active!==a.active||this.visible!==a.visible||this.viewColumn!==a.viewColumn)&&(Xe(this,v,a.active,"f"),Xe(this,l,a.visible,"f"),Xe(this,i,a.viewColumn,"f"),Ne(this,n,"f").fire({webviewPanel:this}))}reveal(a,k){this.c(),Ne(this,S,"f").$reveal(Ne(this,R,"f"),{viewColumn:typeof a>"u"?void 0:A.ViewColumn.from(a),preserveFocus:!!k})}c(){if(Ne(this,D,"f"))throw new Error("Webview is disposed")}}R=new WeakMap,S=new WeakMap,u=new WeakMap,b=new WeakMap,p=new WeakMap,g=new WeakMap,t=new WeakMap,i=new WeakMap,l=new WeakMap,v=new WeakMap,D=new WeakMap,m=new WeakMap,n=new WeakMap;class s extends C.$Sc{static c(){return(0,O.$fg)()}constructor(a,k,P){super(),this.j=k,this.m=P,this.g=new Map,this.h=new Map,this.f=a.getProxy(E.$qK.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(a=>a.dispose()),this.g.clear()}createWebviewPanel(a,k,P,h,w={}){const y=typeof h=="object"?h.viewColumn:h,M={viewColumn:A.ViewColumn.from(y),preserveFocus:typeof h=="object"&&!!h.preserveFocus},V=(0,c.$Hdc)(a),B=s.c();this.f.$createWebviewPanel((0,c.$Jdc)(a),B,k,{title:P,panelOptions:o(w),webviewOptions:(0,c.$Kdc)(a,this.m,w),serializeBuffersForPostMessage:V},M);const z=this.j.createNewWebview(B,w,a);return this.createNewWebviewPanel(B,k,P,y,w,z,!0)}$onDidChangeWebviewPanelViewStates(a){const k=Object.keys(a);k.sort((P,h)=>{const w=a[P],y=a[h];return w.active?1:y.active?-1:+w.visible-+y.visible});for(const P of k){const h=this.getWebviewPanel(P);if(!h)continue;const w=a[P];h._updateViewState({active:w.active,visible:w.visible,viewColumn:A.ViewColumn.to(w.position)})}}async $onDidDisposeWebviewPanel(a){this.getWebviewPanel(a)?.dispose(),this.g.delete(a),this.j.deleteWebview(a)}registerWebviewPanelSerializer(a,k,P){if(this.h.has(k))throw new Error(`Serializer for '${k}' already registered`);return this.h.set(k,{serializer:P,extension:a}),this.f.$registerSerializer(k,{serializeBuffersForPostMessage:(0,c.$Hdc)(a)}),new d.$sK(()=>{this.h.delete(k),this.f.$unregisterSerializer(k)})}async $deserializeWebviewPanel(a,k,P,h){const w=this.h.get(k);if(!w)throw new Error(`No serializer found for '${k}'`);const{serializer:y,extension:M}=w,V=this.j.createNewWebview(a,P.webviewOptions,M),B=this.createNewWebviewPanel(a,k,P.title,h,P.panelOptions,V,P.active);await y.deserializeWebviewPanel(B,P.state)}createNewWebviewPanel(a,k,P,h,w,y,M){const V=new r(a,this.f,y,{viewType:k,title:P,viewColumn:h,panelOptions:w,active:M});return this.g.set(a,V),V}getWebviewPanel(a){return this.g.get(a)}}e.$iec=s;function o($){return{enableFindWidget:$.enableFindWidget,retainContextWhenHidden:$.retainContextWhenHidden}}});var Xe=this&&this.__classPrivateFieldSet||function(ee,e,f,C,I){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!I:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?I.call(ee,f):I?I.value=f:e.set(ee,f),f},Ne=this&&this.__classPrivateFieldGet||function(ee,e,f,C){if(f==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!C:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return f==="m"?C:f==="a"?C.call(ee):C?C.value:e.get(ee)};define(Ae[263],Re([1,0,5,6,64,8,3,7]),function(ee,e,f,C,I,O,A,c){"use strict";var E,d,R,S,u,b,p,g,t,i,l;Object.defineProperty(e,"__esModule",{value:!0}),e.$hec=void 0;class v extends C.$Sc{constructor(n,r,s,o,$,a){super(),E.set(this,void 0),d.set(this,void 0),R.set(this,void 0),S.set(this,void 0),u.set(this,!1),b.set(this,void 0),p.set(this,void 0),g.set(this,void 0),t.set(this,void 0),i.set(this,this.B(new f.$Od)),this.onDidChangeVisibility=Ne(this,i,"f").event,l.set(this,this.B(new f.$Od)),this.onDidDispose=Ne(this,l,"f").event,Xe(this,R,s,"f"),Xe(this,p,o,"f"),Xe(this,E,n,"f"),Xe(this,d,r,"f"),Xe(this,S,$,"f"),Xe(this,b,a,"f")}dispose(){Ne(this,u,"f")||(Xe(this,u,!0,"f"),Ne(this,l,"f").fire(),Ne(this,S,"f").dispose(),super.dispose())}get title(){return this.a(),Ne(this,p,"f")}set title(n){this.a(),Ne(this,p,"f")!==n&&(Xe(this,p,n,"f"),Ne(this,d,"f").$setWebviewViewTitle(Ne(this,E,"f"),n))}get description(){return this.a(),Ne(this,g,"f")}set description(n){this.a(),Ne(this,g,"f")!==n&&(Xe(this,g,n,"f"),Ne(this,d,"f").$setWebviewViewDescription(Ne(this,E,"f"),n))}get visible(){return Ne(this,b,"f")}get webview(){return Ne(this,S,"f")}get viewType(){return Ne(this,R,"f")}_setVisible(n){n===Ne(this,b,"f")||Ne(this,u,"f")||(Xe(this,b,n,"f"),Ne(this,i,"f").fire())}get badge(){return this.a(),Ne(this,t,"f")}set badge(n){this.a(),!(n?.value===Ne(this,t,"f")?.value&&n?.tooltip===Ne(this,t,"f")?.tooltip)&&(Xe(this,t,O.ViewBadge.from(n),"f"),Ne(this,d,"f").$setWebviewViewBadge(Ne(this,E,"f"),n))}show(n){this.a(),Ne(this,d,"f").$show(Ne(this,E,"f"),!!n)}a(){if(Ne(this,u,"f"))throw new Error("Webview is disposed")}}E=new WeakMap,d=new WeakMap,R=new WeakMap,S=new WeakMap,u=new WeakMap,b=new WeakMap,p=new WeakMap,g=new WeakMap,t=new WeakMap,i=new WeakMap,l=new WeakMap;class D{constructor(n,r){this.d=r,this.b=new Map,this.c=new Map,this.a=n.getProxy(A.$qK.MainThreadWebviewViews)}registerWebviewViewProvider(n,r,s,o){if(this.b.has(r))throw new Error(`View provider for '${r}' already registered`);return this.b.set(r,{provider:s,extension:n}),this.a.$registerWebviewViewProvider((0,I.$Jdc)(n),r,{retainContextWhenHidden:o?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,I.$Hdc)(n)}),new c.$sK(()=>{this.b.delete(r),this.a.$unregisterWebviewViewProvider(r)})}async $resolveWebviewView(n,r,s,o,$){const a=this.b.get(r);if(!a)throw new Error(`No view provider found for '${r}'`);const{provider:k,extension:P}=a,h=this.d.createNewWebview(n,{},P),w=new v(n,this.a,r,s,h,!0);this.c.set(n,w),await k.resolveWebviewView(w,{state:o},$)}async $onDidChangeWebviewViewVisibility(n,r){this.e(n)._setVisible(r)}async $disposeWebviewView(n){const r=this.e(n);this.c.delete(n),r.dispose(),this.d.deleteWebview(n)}e(n){const r=this.c.get(n);if(!r)throw new Error("No webview found");return r}}e.$hec=D}),define(Ae[108],Re([1,0,5,3,2,13,16,4,17,22]),function(ee,e,f,C,I,O,A,c,E,d){"use strict";var R;Object.defineProperty(e,"__esModule",{value:!0}),e.$Mdc=e.$Ldc=void 0;let S=R=class{getState(b){const p=this.d;return{get focused(){return p.focused},get active(){return(0,d.$mF)(b,"windowActivity"),p.active}}}constructor(b){this.c=new f.$Od,this.onDidChangeWindowState=this.c.event,this.d=R.a,this.b=b.getProxy(C.$qK.MainThreadWindow),this.b.$getInitialState().then(({isFocused:p,isActive:g})=>{this.onDidChangeWindowProperty("focused",p),this.onDidChangeWindowProperty("active",g)})}$onDidChangeWindowFocus(b){this.onDidChangeWindowProperty("focused",b)}$onDidChangeWindowActive(b){this.onDidChangeWindowProperty("active",b)}onDidChangeWindowProperty(b,p){p!==this.d[b]&&(this.d={...this.d,[b]:p},this.c.fire(this.d))}openUri(b,p){let g;if(typeof b=="string"){g=b;try{b=I.URI.parse(b)}catch{return Promise.reject(`Invalid uri - '${b}'`)}}return(0,A.$Ce)(b.scheme)?Promise.reject("Invalid scheme - cannot be empty"):b.scheme===O.Schemas.command?Promise.reject(`Invalid scheme '${b.scheme}'`):this.b.$openUri(b,g,p)}async asExternalUri(b,p){if((0,A.$Ce)(b.scheme))return Promise.reject("Invalid scheme - cannot be empty");const g=await this.b.$asExternalUri(b,p);return I.URI.from(g)}};e.$Ldc=S,S.a={focused:!0,active:!0},e.$Ldc=S=R=Ge([qe(0,E.$rM)],S),e.$Mdc=(0,c.$Qh)("IExtHostWindow")}),define(Ae[264],Re([1,0,229,27,17]),function(ee,e,f,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tgc=void 0;let O=class extends f.$Mec{constructor(c,E){super(c,E)}f(c,E,d){E.apply(console,d)}};e.$Tgc=O,e.$Tgc=O=Ge([qe(0,I.$rM),qe(1,C.$HM)],O)}),define(Ae[265],Re([1,0,12,26,19,11,5,6,123,217,47]),function(ee,e,f,C,I,O,A,c,E,d,R){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.$54b=e.ResponsiveState=e.RequestInitiator=e.$44b=e.$34b=void 0;function u(y,M){try{return JSON.stringify(y,M)}catch{return"null"}}const b="$$ref$$",p={[b]:-1};class g{constructor(M,V){this.jsonString=M,this.referencedBuffers=V}}function t(y,M=null,V=!1){const B=[];return{jsonString:(V?u:JSON.stringify)(y,(T,F)=>{if(typeof F>"u")return p;if(typeof F=="object"){if(F instanceof C.$ce){const j=B.push(F)-1;return{[b]:j}}if(M)return M(T,F)}return F}),referencedBuffers:B}}e.$34b=t;function i(y,M,V){return JSON.parse(y,(B,z)=>{if(z){const T=z[b];if(typeof T=="number")return M[T];if(V&&z.$mid===1)return V.transformIncoming(z)}return z})}e.$44b=i;function l(y,M){return JSON.stringify(y,M)}function v(y){return y?(M,V)=>V&&V.$mid===1?y.transformOutgoing(V):V:null}var D;(function(y){y[y.LocalSide=0]="LocalSide",y[y.OtherSide=1]="OtherSide"})(D||(e.RequestInitiator=D={}));var m;(function(y){y[y.Responsive=0]="Responsive",y[y.Unresponsive=1]="Unresponsive"})(m||(e.ResponsiveState=m={}));const n=()=>{},r=Symbol.for("rpcProtocol"),s=Symbol.for("rpcProxy");class o extends c.$Sc{constructor(M,V=null,B=null){super(),this[S]=!0,this.b=this.B(new A.$Od),this.onDidChangeResponsiveState=this.b.event,this.c=M,this.f=V,this.g=B,this.h=v(this.g),this.j=!1,this.m=[],this.s=[];for(let z=0,T=R.$sv.count;z<T;z++)this.m[z]=null,this.s[z]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=0,this.z=0,this.C=0,this.D=this.B(new f.$7g(()=>this.H(),1e3)),this.c.onMessage(z=>this.L(z))}dispose(){this.j=!0,Object.keys(this.w).forEach(M=>{const V=this.w[M];delete this.w[M],V.resolveErr(O.$6())})}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(M){this.z===0&&(this.C=Date.now()+o.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(M){this.C=Date.now()+o.a,this.z--,this.z===0&&this.D.cancel(),this.I(0)}H(){this.z!==0&&(Date.now()>this.C?this.I(1):this.D.schedule())}I(M){this.y!==M&&(this.y=M,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(M){return this.g?(0,E.$Qm)(M,this.g):M}getProxy(M){const{nid:V,sid:B}=M;return this.s[V]||(this.s[V]=this.J(V,B)),this.s[V]}J(M,V){const B={get:(z,T)=>(typeof T=="string"&&!z[T]&&T.charCodeAt(0)===36&&(z[T]=(...F)=>this.U(M,T,F)),T===s?V:z[T])};return new Proxy(Object.create(null),B)}set(M,V){return this.m[M.nid]=V,V}assertRegistered(M){for(let V=0,B=M.length;V<B;V++){const z=M[V];if(!this.m[z.nid])throw new Error(`Missing proxy instance ${z.sid}`)}}L(M){if(this.j)return;const V=M.byteLength,B=a.read(M,0),z=B.readUInt8(),T=B.readUInt32();switch(z){case 1:case 2:{let{rpcId:F,method:j,args:q}=P.deserializeRequestJSONArgs(B);this.g&&(q=(0,E.$Qm)(q,this.g)),this.M(V,T,F,j,q,z===2);break}case 3:case 4:{let{rpcId:F,method:j,args:q}=P.deserializeRequestMixedArgs(B);this.g&&(q=(0,E.$Qm)(q,this.g)),this.M(V,T,F,j,q,z===4);break}case 5:{this.f?.logIncoming(V,T,0,"ack"),this.G(T);break}case 6:{this.N(V,T);break}case 7:{this.O(V,T,void 0);break}case 9:{let F=P.deserializeReplyOKJSON(B);this.g&&(F=(0,E.$Qm)(F,this.g)),this.O(V,T,F);break}case 10:{const F=P.deserializeReplyOKJSONWithBuffers(B,this.g);this.O(V,T,F);break}case 8:{const F=P.deserializeReplyOKVSBuffer(B);this.O(V,T,F);break}case 11:{let F=P.deserializeReplyErrError(B);this.g&&(F=(0,E.$Qm)(F,this.g)),this.P(V,T,F);break}case 12:{this.P(V,T,void 0);break}default:console.error("received unexpected message"),console.error(M)}}M(M,V,B,z,T,F){this.f?.logIncoming(M,V,1,`receiveRequest ${(0,R.$uv)(B)}.${z}(`,T);const j=String(V);let q,W;if(F){const ke=new I.$Yd;T.push(ke.token),q=this.Q(B,z,T),W=()=>ke.cancel()}else q=this.Q(B,z,T),W=n;this.u[j]=W;const we=P.serializeAcknowledged(V);this.f?.logOutgoing(we.byteLength,V,1,"ack"),this.c.send(we),q.then(ke=>{delete this.u[j];const Se=P.serializeReplyOK(V,ke,this.h);this.f?.logOutgoing(Se.byteLength,V,1,"reply:",ke),this.c.send(Se)},ke=>{delete this.u[j];const Se=P.serializeReplyErr(V,ke);this.f?.logOutgoing(Se.byteLength,V,1,"replyErr:",ke),this.c.send(Se)})}N(M,V){this.f?.logIncoming(M,V,1,"receiveCancel");const B=String(V);this.u[B]?.()}O(M,V,B){this.f?.logIncoming(M,V,0,"receiveReply:",B);const z=String(V);if(!this.w.hasOwnProperty(z))return;const T=this.w[z];delete this.w[z],T.resolveOk(B)}P(M,V,B){this.f?.logIncoming(M,V,0,"receiveReplyErr:",B);const z=String(V);if(!this.w.hasOwnProperty(z))return;const T=this.w[z];delete this.w[z];let F;B&&(B.$isError?(F=new Error,F.name=B.name,F.message=B.message,F.stack=B.stack):F=B),T.resolveErr(F)}Q(M,V,B){try{return Promise.resolve(this.S(M,V,B))}catch(z){return Promise.reject(z)}}S(M,V,B){const z=this.m[M];if(!z)throw new Error("Unknown actor "+(0,R.$uv)(M));const T=z[V];if(typeof T!="function")throw new Error("Unknown method "+V+" on actor "+(0,R.$uv)(M));return T.apply(z,B)}U(M,V,B){if(this.j)return new d.$24b;let z=null;if(B.length>0&&I.CancellationToken.isCancellationToken(B[B.length-1])&&(z=B.pop()),z&&z.isCancellationRequested)return Promise.reject(O.$6());const T=P.serializeRequestArguments(B,this.h),F=++this.t,j=String(F),q=new d.$14b,W=new c.$Rc;z&&W.add(z.onCancellationRequested(()=>{const ke=P.serializeCancel(F);this.f?.logOutgoing(ke.byteLength,F,0,"cancel"),this.c.send(P.serializeCancel(F))})),this.w[j]=new $(q,W),this.F(F);const we=P.serializeRequest(F,M,V,T,!!z);return this.f?.logOutgoing(we.byteLength,F,0,`request: ${(0,R.$uv)(M)}.${V}(`,B),this.c.send(we),q}}e.$54b=o,S=r,o.a=3*1e3;class ${constructor(M,V){this.a=M,this.b=V}resolveOk(M){this.a.resolveOk(M),this.b.dispose()}resolveErr(M){this.a.resolveErr(M),this.b.dispose()}}class a{static alloc(M,V,B){const z=new a(C.$ce.alloc(B+1+4),0);return z.writeUInt8(M),z.writeUInt32(V),z}static read(M,V){return new a(M,V)}get buffer(){return this.a}constructor(M,V){this.a=M,this.b=V}static sizeUInt8(){return 1}writeUInt8(M){this.a.writeUInt8(M,this.b),this.b+=1}readUInt8(){const M=this.a.readUInt8(this.b);return this.b+=1,M}writeUInt32(M){this.a.writeUInt32BE(M,this.b),this.b+=4}readUInt32(){const M=this.a.readUInt32BE(this.b);return this.b+=4,M}static sizeShortString(M){return 1+M.byteLength}writeShortString(M){this.a.writeUInt8(M.byteLength,this.b),this.b+=1,this.a.set(M,this.b),this.b+=M.byteLength}readShortString(){const M=this.a.readUInt8(this.b);this.b+=1;const B=this.a.slice(this.b,this.b+M).toString();return this.b+=M,B}static sizeLongString(M){return 4+M.byteLength}writeLongString(M){this.a.writeUInt32BE(M.byteLength,this.b),this.b+=4,this.a.set(M,this.b),this.b+=M.byteLength}readLongString(){const M=this.a.readUInt32BE(this.b);this.b+=4;const B=this.a.slice(this.b,this.b+M).toString();return this.b+=M,B}writeBuffer(M){this.a.writeUInt32BE(M.byteLength,this.b),this.b+=4,this.a.set(M,this.b),this.b+=M.byteLength}static sizeVSBuffer(M){return 4+M.byteLength}writeVSBuffer(M){this.a.writeUInt32BE(M.byteLength,this.b),this.b+=4,this.a.set(M,this.b),this.b+=M.byteLength}readVSBuffer(){const M=this.a.readUInt32BE(this.b);this.b+=4;const V=this.a.slice(this.b,this.b+M);return this.b+=M,V}static sizeMixedArray(M){let V=0;V+=1;for(let B=0,z=M.length;B<z;B++){const T=M[B];switch(V+=1,T.type){case 1:V+=this.sizeLongString(T.value);break;case 2:V+=this.sizeVSBuffer(T.value);break;case 3:V+=this.sizeUInt32,V+=this.sizeLongString(T.value);for(let F=0;F<T.buffers.length;++F)V+=this.sizeVSBuffer(T.buffers[F]);break;case 4:break}}return V}writeMixedArray(M){this.a.writeUInt8(M.length,this.b),this.b+=1;for(let V=0,B=M.length;V<B;V++){const z=M[V];switch(z.type){case 1:this.writeUInt8(1),this.writeLongString(z.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(z.value);break;case 3:this.writeUInt8(3),this.writeUInt32(z.buffers.length),this.writeLongString(z.value);for(let T=0;T<z.buffers.length;++T)this.writeBuffer(z.buffers[T]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const M=this.a.readUInt8(this.b);this.b+=1;const V=new Array(M);for(let B=0;B<M;B++)switch(this.readUInt8()){case 1:V[B]=this.readLongString();break;case 2:V[B]=this.readVSBuffer();break;case 3:{const T=this.readUInt32(),F=this.readLongString(),j=[];for(let q=0;q<T;++q)j.push(this.readVSBuffer());V[B]=new R.$vv(i(F,j,null));break}case 4:V[B]=void 0;break}return V}}a.sizeUInt32=4;var k;(function(y){y[y.Simple=0]="Simple",y[y.Mixed=1]="Mixed"})(k||(k={}));class P{static a(M){for(let V=0,B=M.length;V<B;V++)if(M[V]instanceof C.$ce||M[V]instanceof R.$vv||typeof M[V]>"u")return!0;return!1}static serializeRequestArguments(M,V){if(this.a(M)){const B=[];for(let z=0,T=M.length;z<T;z++){const F=M[z];if(F instanceof C.$ce)B[z]={type:2,value:F};else if(typeof F>"u")B[z]={type:4};else if(F instanceof R.$vv){const{jsonString:j,referencedBuffers:q}=t(F.value,V);B[z]={type:3,value:C.$ce.fromString(j),buffers:q}}else B[z]={type:1,value:C.$ce.fromString(l(F,V))}}return{type:1,args:B}}return{type:0,args:l(M,V)}}static serializeRequest(M,V,B,z,T){switch(z.type){case 0:return this.b(M,V,B,z.args,T);case 1:return this.c(M,V,B,z.args,T)}}static b(M,V,B,z,T){const F=C.$ce.fromString(B),j=C.$ce.fromString(z);let q=0;q+=a.sizeUInt8(),q+=a.sizeShortString(F),q+=a.sizeLongString(j);const W=a.alloc(T?2:1,M,q);return W.writeUInt8(V),W.writeShortString(F),W.writeLongString(j),W.buffer}static deserializeRequestJSONArgs(M){const V=M.readUInt8(),B=M.readShortString(),z=M.readLongString();return{rpcId:V,method:B,args:JSON.parse(z)}}static c(M,V,B,z,T){const F=C.$ce.fromString(B);let j=0;j+=a.sizeUInt8(),j+=a.sizeShortString(F),j+=a.sizeMixedArray(z);const q=a.alloc(T?4:3,M,j);return q.writeUInt8(V),q.writeShortString(F),q.writeMixedArray(z),q.buffer}static deserializeRequestMixedArgs(M){const V=M.readUInt8(),B=M.readShortString(),z=M.readMixedArray(),T=new Array(z.length);for(let F=0,j=z.length;F<j;F++){const q=z[F];typeof q=="string"?T[F]=JSON.parse(q):T[F]=q}return{rpcId:V,method:B,args:T}}static serializeAcknowledged(M){return a.alloc(5,M,0).buffer}static serializeCancel(M){return a.alloc(6,M,0).buffer}static serializeReplyOK(M,V,B){if(typeof V>"u")return this.d(M);if(V instanceof C.$ce)return this.e(M,V);if(V instanceof R.$vv){const{jsonString:z,referencedBuffers:T}=t(V.value,B,!0);return this.g(M,z,T)}else return this.f(M,u(V,B))}static d(M){return a.alloc(7,M,0).buffer}static e(M,V){let B=0;B+=a.sizeVSBuffer(V);const z=a.alloc(8,M,B);return z.writeVSBuffer(V),z.buffer}static deserializeReplyOKVSBuffer(M){return M.readVSBuffer()}static f(M,V){const B=C.$ce.fromString(V);let z=0;z+=a.sizeLongString(B);const T=a.alloc(9,M,z);return T.writeLongString(B),T.buffer}static g(M,V,B){const z=C.$ce.fromString(V);let T=0;T+=a.sizeUInt32,T+=a.sizeLongString(z);for(const j of B)T+=a.sizeVSBuffer(j);const F=a.alloc(10,M,T);F.writeUInt32(B.length),F.writeLongString(z);for(const j of B)F.writeBuffer(j);return F.buffer}static deserializeReplyOKJSON(M){const V=M.readLongString();return JSON.parse(V)}static deserializeReplyOKJSONWithBuffers(M,V){const B=M.readUInt32(),z=M.readLongString(),T=[];for(let F=0;F<B;++F)T.push(M.readVSBuffer());return new R.$vv(i(z,T,V))}static serializeReplyErr(M,V){const B=V?u(O.$3(V),null):void 0;if(typeof B!="string")return this.h(M);const z=C.$ce.fromString(B);let T=0;T+=a.sizeLongString(z);const F=a.alloc(11,M,T);return F.writeLongString(z),F.buffer}static deserializeReplyErrError(M){const V=M.readLongString();return JSON.parse(V)}static h(M){return a.alloc(12,M,0).buffer}}var h;(function(y){y[y.RequestJSONArgs=1]="RequestJSONArgs",y[y.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",y[y.RequestMixedArgs=3]="RequestMixedArgs",y[y.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",y[y.Acknowledged=5]="Acknowledged",y[y.Cancel=6]="Cancel",y[y.ReplyOKEmpty=7]="ReplyOKEmpty",y[y.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",y[y.ReplyOKJSON=9]="ReplyOKJSON",y[y.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",y[y.ReplyErrError=11]="ReplyErrError",y[y.ReplyErrEmpty=12]="ReplyErrEmpty"})(h||(h={}));var w;(function(y){y[y.String=1]="String",y[y.VSBuffer=2]="VSBuffer",y[y.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",y[y.Undefined=4]="Undefined"})(w||(w={}))}),define(Ae[266],Re([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vgc=void 0;const f=function(O){const A=c=>{globalThis.removeEventListener("message",A);const E=c.data;Object.defineProperties(globalThis,{postMessage:{value(d,R){E.postMessage(d,R)}},onmessage:{get(){return E.onmessage},set(d){E.onmessage=d}}}),E.addEventListener("message",d=>{globalThis.dispatchEvent(new MessageEvent("message",{data:d.data,ports:d.ports?[...d.ports]:void 0}))}),E.start(),globalThis.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(O)};globalThis.addEventListener("message",A)}.toString();class C extends EventTarget{constructor(O,A,c){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const E=`((${f})('${A}'))`,d=new Blob([E],{type:"application/javascript"}),R=URL.createObjectURL(d),S=new MessageChannel,u=R,b={type:"_newWorker",id:u,port:S.port2,url:R,options:c};O(b,[S.port2]),this.postMessage=S.port1.postMessage.bind(S.port1),this.terminate=()=>{O({type:"_terminateWorker",id:u}),URL.revokeObjectURL(R),S.port1.close(),S.port2.close()},Object.defineProperties(this,{onmessage:{get(){return S.port1.onmessage},set(p){S.port1.onmessage=p}},onmessageerror:{get(){return S.port1.onmessageerror},set(p){S.port1.onmessageerror=p}}}),S.port1.addEventListener("messageerror",p=>{const g=new MessageEvent("messageerror",{data:p.data});this.dispatchEvent(g)}),S.port1.addEventListener("message",p=>{const g=new MessageEvent("message",{data:p.data});this.dispatchEvent(g)}),S.port1.start()}}e.$Vgc=C}),define(Ae[267],Re([1,0,5,30,32,4]),function(ee,e,f,C,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MJ=e.$LJ=e.OutputChannelUpdateMode=e.$KJ=e.$JJ=e.$IJ=e.$HJ=e.$GJ=e.$FJ=e.$EJ=e.$DJ=e.$CJ=e.$BJ=void 0,e.$BJ="text/x-code-output",e.$CJ="output",e.$DJ="Log",e.$EJ="text/x-code-log-output",e.$FJ="log",e.$GJ="workbench.panel.output",e.$HJ=new I.$8i("inOutput",!1),e.$IJ=new I.$8i("activeLogOutput",!1),e.$JJ=new I.$8i("outputView.scrollLock",!1),e.$KJ=(0,O.$Qh)("outputService");var A;(function(E){E[E.Append=1]="Append",E[E.Replace=2]="Replace",E[E.Clear=3]="Clear"})(A||(e.OutputChannelUpdateMode=A={})),e.$LJ={OutputChannels:"workbench.contributions.outputChannels"};class c{constructor(){this.a=new Map,this.b=new f.$Od,this.onDidRegisterChannel=this.b.event,this.c=new f.$Od,this.onDidRemoveChannel=this.c.event}registerChannel(d){this.a.has(d.id)||(this.a.set(d.id,d),this.b.fire(d.id))}getChannels(){const d=[];return this.a.forEach(R=>d.push(R)),d}getChannel(d){return this.a.get(d)}removeChannel(d){this.a.delete(d),this.c.fire(d)}}C.$ln.add(e.$LJ.OutputChannels,new c),e.$MJ=new I.$8i("activeOutputChannel","")}),define(Ae[109],Re([1,0,3,4,17,21,14,267,62,27,40,132,26,15,39,5,6]),function(ee,e,f,C,I,O,A,c,E,d,R,S,u,b,p,g,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wdc=e.$vdc=void 0;class i extends A.$ej{get disposed(){return this.n}constructor(m,n,r,s,o){super(),this.id=m,this.name=n,this.r=r,this.s=s,this.extension=o,this.m=0,this.n=!1,this.visible=!1,this.setLevel(r.getLevel()),this.B(r.onDidChangeLogLevel($=>this.setLevel($)))}get logLevel(){return this.getLevel()}appendLine(m){this.append(m+`
`)}append(m){this.info(m)}clear(){const m=this.m;this.r.flush(),this.s.$update(this.id,c.OutputChannelUpdateMode.Clear,m)}replace(m){const n=this.m;this.info(m),this.s.$update(this.id,c.OutputChannelUpdateMode.Replace,n),this.visible&&this.r.flush()}show(m,n){this.r.flush(),this.s.$reveal(this.id,!!(typeof m=="boolean"?m:n))}hide(){this.s.$close(this.id)}g(m,n){this.m+=u.$ce.fromString(n).byteLength,(0,A.log)(this.r,m,n),this.visible&&(this.r.flush(),this.s.$update(this.id,c.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class l extends i{appendLine(m){this.append(m)}}let v=class{constructor(m,n,r,s,o,$){this.i=n,this.j=r,this.k=s,this.l=o,this.m=$,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=m.getProxy(f.$qK.MainThreadOutputService),this.b=this.k.extUri.joinPath(n.logsLocation,`output_logging_${(0,S.$gm)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(m){this.h=m;for(const[n,r]of this.g)r.visible=n===this.h}createOutputChannel(m,n,r){if(m=m.trim(),!m)throw new Error("illegal argument `name`. must not be falsy");const s=typeof n=="object"&&n.log,o=(0,b.$zf)(n)?n:void 0;if((0,b.$zf)(o)&&!o.trim())throw new Error("illegal argument `languageId`. must not be empty");let $;const a=this.i.environment.extensionLogLevel?.find(([P])=>O.$8l.equals(r.identifier,P))?.[1];a&&($=(0,A.$oj)(a));const k=s?this.o(m,$,r):this.n(m,o,r);return k.then(P=>{this.g.set(P.id,P),P.visible=P.id===this.h}),s?this.r(m,$??this.m.getLevel(),k):this.q(m,k)}async n(m,n,r){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const s=await this.c,o=this.k.extUri.joinPath(s,`${this.f++}-${m.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),$=this.l.createLogger(o,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),a=await this.a.$register(m,o,n,r.identifier.value);return new i(a,m,$,this.a,r)}async o(m,n,r){const s=await this.p(r),o=m.replace(/[\\/:\*\?"<>\|]/g,""),$=this.k.extUri.joinPath(s,`${o}.log`),a=`${r.identifier.value}.${o}`,k=this.l.createLogger($,{id:a,name:m,logLevel:n,extensionId:r.identifier.value});return new l(a,m,k,this.a,r)}p(m){let n=this.d.get(m.identifier.value);if(!n){const r=this.k.extUri.joinPath(this.i.logsLocation,m.identifier.value);this.d.set(m.identifier.value,n=(async()=>{try{await this.j.value.createDirectory(r)}catch(s){if((0,p.$pk)(s)!==p.FileSystemProviderErrorCode.FileExists)throw s}return r})())}return n}q(m,n){let r=!1;const s=()=>{if(r)throw new Error("Channel has been closed")};return{get name(){return m},append(o){s(),n.then($=>$.append(o))},appendLine(o){s(),n.then($=>$.appendLine(o))},clear(){s(),n.then(o=>o.clear())},replace(o){s(),n.then($=>$.replace(o))},show(o,$){s(),n.then(a=>a.show(o,$))},hide(){s(),n.then(o=>o.hide())},dispose(){r=!0,n.then(o=>o.dispose())}}}r(m,n,r){const s=new t.$Rc,o=()=>{if(s.isDisposed)throw new Error("Channel has been closed")},$=s.add(new g.$Od);function a(k){n=k,$.fire(k)}return r.then(k=>{s.add(k),k.logLevel!==n&&a(k.logLevel),s.add(k.onDidChangeLogLevel(P=>a(P)))}),{...this.q(m,r),get logLevel(){return n},onDidChangeLogLevel:$.event,trace(k,...P){o(),r.then(h=>h.trace(k,...P))},debug(k,...P){o(),r.then(h=>h.debug(k,...P))},info(k,...P){o(),r.then(h=>h.info(k,...P))},warn(k,...P){o(),r.then(h=>h.warn(k,...P))},error(k,...P){o(),r.then(h=>h.error(k,...P))},dispose(){s.dispose()}}}};e.$vdc=v,e.$vdc=v=Ge([qe(0,I.$rM),qe(1,d.$HM),qe(2,E.$$cc),qe(3,R.$Fcc),qe(4,A.$_i),qe(5,A.$$i)],v),e.$wdc=(0,C.$Qh)("IExtHostOutputService")}),define(Ae[268],Re([1,0,4,12]),function(ee,e,f,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wm=e.$vm=void 0,e.$vm=(0,f.$Qh)("remoteAgentService"),e.$wm=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(I){let O=1/0;for(let c=0;c<this.maxSampleCount;c++){const E=await I.getRoundTripTime();if(E===void 0)return;O=Math.min(O,E/2),await(0,C.$Vg)(this.sampleDelay)}this.average.push(O),this.average.length>this.maxAverageCount&&this.average.shift();let A;return this.initial.length<this.maxInitialCount?this.initial.push(O):A=this.initial.reduce((c,E)=>c+E,0)/this.initial.length,this.lastMeasurement={initial:A,current:O,average:this.average.reduce((c,E)=>c+E,0)/this.average.length,high:(()=>typeof A>"u"?!1:O>this.highLatencyMaxThreshold||O>this.highLatencyMinThreshold&&O>A*this.highLatencyMultiple)()},this.lastMeasurement}}}),define(Ae[269],Re([1,0,43,13,20,23,24,2,4,187,56,204,268]),function(ee,e,f,C,I,O,A,c,E,d,R,S,u){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.$6J=e.$5J=void 0,e.$5J=(0,E.$Qh)("pathService");let p=b=class{constructor(t,i,l,v){this.d=t,this.e=i,this.f=l,this.g=v,this.a=(async()=>(await this.e.getEnvironment())?.os||O.OS)(),this.b=(async()=>{const D=await this.e.getEnvironment();return this.c=D?.userHome??t})()}hasValidBasename(t,i,l){return typeof i=="string"||typeof i>"u"?this.a.then(v=>this.h(t,v,i)):this.h(t,i,l)}h(t,i,l){return t.scheme===C.Schemas.file||t.scheme===C.Schemas.vscodeRemote?(0,f.$Wf)(l??(0,A.$tg)(t),i===1):!0}get defaultUriScheme(){return b.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(t,i){if(t.remoteAuthority)return C.Schemas.vscodeRemote;const l=(0,d.$2J)(i.getWorkspace());if(l)return l;const v=i.getWorkspace().folders[0];if(v)return v.uri.scheme;const D=i.getWorkspace().configuration;return D?D.scheme:C.Schemas.file}userHome(t){return t?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(t=>t===1?I.$fc:I.$gc)}async fileURI(t){let i="";if(await this.a===1&&(t=t.replace(/\\/g,"/")),t[0]==="/"&&t[1]==="/"){const v=t.indexOf("/",2);v===-1?(i=t.substring(2),t="/"):(i=t.substring(2,v),t=t.substring(v)||"/")}return c.URI.from({scheme:C.Schemas.file,authority:i,path:t,query:"",fragment:""})}};e.$6J=p,e.$6J=p=b=Ge([qe(1,u.$vm),qe(2,S.$NJ),qe(3,R.$Zh)],p)}),define(Ae[110],Re([1,0]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$LI=e.$KI=void 0;class f{constructor(A,c){this.line=A,this.character=c}isBefore(A){return!1}isBeforeOrEqual(A){return!1}isAfter(A){return!1}isAfterOrEqual(A){return!1}isEqual(A){return!1}compareTo(A){return 0}translate(A,c){return new f(0,0)}with(A){return new f(0,0)}}e.$KI=f;class C{constructor(A,c,E,d){this.isEmpty=!1,this.isSingleLine=!1,this.start=new f(A,c),this.end=new f(E,d)}contains(A){return!1}isEqual(A){return!1}intersection(A){}union(A){return new C(0,0,0,0)}with(A){return new C(0,0,0,0)}}e.$LI=C;var I;(function(O){O[O.Information=1]="Information",O[O.Warning=2]="Warning"})(I||(e.TextSearchCompleteMessageType=I={}))}),define(Ae[49],Re([1,0,18,36,25,43,16,4,20,11,110,12]),function(ee,e,f,C,I,O,A,c,E,d,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aJ=e.$_I=e.$$I=e.$0I=e.$9I=e.$8I=e.$7I=e.$6I=e.$5I=e.$4I=e.$3I=e.$2I=e.SearchErrorCode=e.$1I=e.$ZI=e.SearchSortOrder=e.ViewMode=e.$YI=e.$XI=e.$WI=e.$VI=e.SearchCompletionExitCode=e.$UI=e.$TI=e.$SI=e.QueryType=e.SearchProviderType=e.$RI=e.$QI=e.$PI=e.$OI=e.$NI=e.$MI=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return R.TextSearchCompleteMessageType}}),e.$MI="workbench.view.search",e.$NI="workbench.panel.search",e.$OI="workbench.view.search",e.$PI="search-result",e.$QI="search.exclude";const u="\u27EA ",b=" characters skipped \u27EB",p=(u.length+b.length+5)*2;e.$RI=(0,c.$Qh)("searchService");var g;(function(ve){ve[ve.file=0]="file",ve[ve.text=1]="text"})(g||(e.SearchProviderType=g={}));var t;(function(ve){ve[ve.File=1]="File",ve[ve.Text=2]="Text"})(t||(e.QueryType=t={}));function i(ve){return!!ve.preview}e.$SI=i;function l(ve){return!!ve.resource}e.$TI=l;function v(ve){return!!ve.message}e.$UI=v;var D;(function(ve){ve[ve.Normal=0]="Normal",ve[ve.NewSearchStarted=1]="NewSearchStarted"})(D||(e.SearchCompletionExitCode=D={}));class m{constructor(ge){this.resource=ge,this.results=[]}}e.$VI=m;class n{constructor(ge,re,oe,ye){this.ranges=re,this.webviewIndex=ye;const De=Array.isArray(re)?re:[re];if(oe&&oe.matchLines===1&&r(De)){ge=(0,A.$sf)(ge,oe.matchLines);let Q="",ue=0,J=0;const he=Math.floor(oe.charsPerLine/5),de=[];for(const le of De){const be=Math.max(le.startColumn-he,0),ie=le.startColumn+oe.charsPerLine;if(be>J+he+p){const fe=u+(be-J)+b;Q+=fe+ge.slice(be,ie),ue+=be-(J+fe.length)}else Q+=ge.slice(J,ie);de.push(new o(0,le.startColumn-ue,le.endColumn-ue)),J=ie}this.preview={text:Q,matches:Array.isArray(this.ranges)?de:de[0]}}else{const Q=Array.isArray(re)?re[0].startLineNumber:re.startLineNumber;this.preview={text:ge,matches:(0,f.$2b)(re,ue=>new s(ue.startLineNumber-Q,ue.startColumn,ue.endLineNumber-Q,ue.endColumn))}}}}e.$WI=n;function r(ve){const ge=ve[0].startLineNumber;for(const re of ve)if(re.startLineNumber!==ge||re.endLineNumber!==ge)return!1;return!0}class s{constructor(ge,re,oe,ye){this.startLineNumber=ge,this.startColumn=re,this.endLineNumber=oe,this.endColumn=ye}}e.$XI=s;class o extends s{constructor(ge,re,oe){super(ge,re,ge,oe)}}e.$YI=o;var $;(function(ve){ve.List="list",ve.Tree="tree"})($||(e.ViewMode=$={}));var a;(function(ve){ve.Default="default",ve.FileNames="fileNames",ve.Type="type",ve.Modified="modified",ve.CountDescending="countDescending",ve.CountAscending="countAscending"})(a||(e.SearchSortOrder=a={}));function k(ve,ge=!0){const re=ve&&ve.files&&ve.files.exclude,oe=ge&&ve&&ve.search&&ve.search.exclude;if(!re&&!oe)return;if(!re||!oe)return re||oe;let ye=Object.create(null);return ye=I.$_m(ye,I.$9m(re)),ye=I.$_m(ye,I.$9m(oe),!0),ye}e.$ZI=k;function P(ve,ge){return ve.excludePattern&&C.$wj(ve.excludePattern,ge)?!1:ve.includePattern||ve.usingSearchPaths?ve.includePattern&&C.$wj(ve.includePattern,ge)?!0:ve.usingSearchPaths?!!ve.folderQueries&&ve.folderQueries.some(re=>{const oe=re.folder.fsPath;if(O.$Yf(ge,oe)){const ye=E.$lc(oe,ge);return!re.includePattern||!!C.$wj(re.includePattern,ye)}else return!1}):!1:!0}e.$1I=P;var h;(function(ve){ve[ve.unknownEncoding=1]="unknownEncoding",ve[ve.regexParseError=2]="regexParseError",ve[ve.globParseError=3]="globParseError",ve[ve.invalidLiteral=4]="invalidLiteral",ve[ve.rgProcessError=5]="rgProcessError",ve[ve.other=6]="other",ve[ve.canceled=7]="canceled"})(h||(e.SearchErrorCode=h={}));class w extends Error{constructor(ge,re){super(ge),this.code=re}}e.$2I=w;function y(ve){const ge=ve.message;if((0,d.$4)(ve))return new w(ge,h.canceled);try{const re=JSON.parse(ge);return new w(re.message,re.code)}catch{return new w(ge,h.other)}}e.$3I=y;function M(ve){const ge={message:ve.message,code:ve.code};return new Error(JSON.stringify(ge))}e.$4I=M;function V(ve){return ve.type==="error"?!0:ve.type==="success"}e.$5I=V;function B(ve){return ve.type==="success"}e.$6I=B;function z(ve){return!!ve.path}e.$7I=z;function T(ve,ge){const re=ve.searchPath?ve.searchPath:ve.relativePath;return(0,A.$pf)(re,ge)}e.$8I=T;class F{constructor(ge){this.path=ge,this.results=[]}addMatch(ge){this.results.push(ge)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$9I=F;function j(ve,ge){const re={...ve||{},...ge||{}};return Object.keys(re).filter(oe=>{const ye=re[oe];return typeof ye=="boolean"&&ye})}e.$0I=j;class q{constructor(ge,re){this.c=null,this.a={...ge.excludePattern||{},...re.excludePattern||{}},this.b=C.$xj(this.a);let oe=ge.includePattern;re.includePattern&&(oe?oe={...oe,...re.includePattern}:oe=re.includePattern),oe&&(this.c=C.$xj(oe))}matchesExcludesSync(ge,re,oe){return!!(this.b&&this.b(ge,re,oe))}includedInQuerySync(ge,re,oe){return!(this.b&&this.b(ge,re,oe)||this.c&&!this.c(ge,re,oe))}includedInQuery(ge,re,oe){const ye=this.b(ge,re,oe),De=()=>this.c?!!this.c(ge,re,oe):!0;return(0,S.$Hg)(ye)?ye.then(Q=>Q?!1:De()):De()}hasSiblingExcludeClauses(){return W(this.a)}}e.$$I=q;function W(ve){for(const ge in ve)if(typeof ve[ge]!="boolean")return!0;return!1}function we(ve){if(!ve)return;let ge;return re=>(ge||(ge=(ve()||Promise.resolve([])).then(oe=>oe?Se(oe):{})),ge.then(oe=>!!oe[re]))}e.$_I=we;function ke(ve){if(!ve)return;let ge;return re=>{if(!ge){const oe=ve();ge=oe?Se(oe):{}}return!!ge[re]}}e.$aJ=ke;function Se(ve){const ge={};for(const re of ve)ge[re]=!0;return ge}}),define(Ae[33],Re([1,0,18,12,19,5,6,50,13,117,24,16,2,159,4,14,176,56,40,27,17,8,7,57,49,3]),function(ee,e,f,C,I,O,A,c,E,d,R,S,u,b,p,g,t,i,l,v,D,m,n,r,s,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Scc=e.$Rcc=void 0;function $(V,B,z){return new R.$lg(T=>h(T,z)).isEqual(V,B)}function a(V,B,z){return $(V.uri,B.uri,z)?0:(0,S.$Ve)(V.uri.toString(),B.uri.toString())}function k(V,B,z){return V.index!==B.index?V.index<B.index?-1:1:$(V.uri,B.uri,z)?(0,S.$Ve)(V.name,B.name):(0,S.$Ve)(V.uri.toString(),B.uri.toString())}function P(V,B,z,T){const F=V.slice(0).sort((q,W)=>z(q,W,T)),j=B.slice(0).sort((q,W)=>z(q,W,T));return(0,f.$Eb)(F,j,(q,W)=>z(q,W,T))}function h(V,B){const z=B.getCapabilities(V.scheme);return!(z&&z&1024)}class w extends i.$0h{static toExtHostWorkspace(B,z,T,F){if(!B)return{workspace:null,added:[],removed:[]};const{id:j,name:q,folders:W,configuration:we,transient:ke,isUntitled:Se}=B,ve=[],ge=z;z?W.forEach((De,Q)=>{const ue=u.URI.revive(De.uri),J=w.o(T||z,ue,F);J?(J.name=De.name,J.index=De.index,ve.push(J)):ve.push({uri:ue,name:De.name,index:Q})}):ve.push(...W.map(({uri:De,name:Q,index:ue})=>({uri:u.URI.revive(De),name:Q,index:ue}))),ve.sort((De,Q)=>De.index<Q.index?-1:1);const re=new w(j,q,ve,!!ke,we?u.URI.revive(we):null,!!Se,De=>h(De,F)),{added:oe,removed:ye}=P(ge?ge.workspaceFolders:[],re.workspaceFolders,a,F);return{workspace:re,added:oe,removed:ye}}static o(B,z,T){for(let F=0;F<B.folders.length;F++){const j=B.workspaceFolders[F];if($(j.uri,z,T))return j}}constructor(B,z,T,F,j,q,W){super(B,T.map(we=>new i.$$h(we)),F,j,W),this.t=z,this.u=q,this.q=[],this.s=c.$Wh.forUris(W),T.forEach(we=>{this.q.push(we),this.s.set(we.uri,we)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(B,z){return z&&this.s.get(B)&&(B=(0,R.$vg)(B)),this.s.findSubstr(B)}resolveWorkspaceFolder(B){return this.s.get(B)}}let y=class{constructor(B,z,T,F,j){this.c=new O.$Od,this.onDidChangeWorkspace=this.c.event,this.g=new O.$Od,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.z=0,this.A=new O.$Qd,this.B=new Map,this.h=F,this.s=T,this.t=j,this.j=new d.$Sl,this.k=new C.$Tg,this.o=B.getProxy(o.$qK.MainThreadWorkspace),this.q=B.getProxy(o.$qK.MainThreadMessageService);const q=z.workspace;this.l=q?new w(q.id,q.name,[],!!q.transient,q.configuration?u.URI.revive(q.configuration):null,!!q.isUntitled,W=>h(W,T)):void 0}$initializeWorkspace(B,z){this.v=z,this.$acceptWorkspaceData(B),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?u.URI.from({scheme:E.Schemas.untitled,path:(0,R.$tg)((0,R.$vg)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(B,z,T,...F){const j=[];if(Array.isArray(F)&&F.forEach(Se=>{u.URI.isUri(Se.uri)&&!j.some(ve=>$(ve.uri,Se.uri,this.s))&&j.push({uri:Se.uri,name:Se.name||(0,R.$sg)(Se.uri)})}),this.n||[z,T].some(Se=>typeof Se!="number"||Se<0)||T===0&&j.length===0)return!1;const q=this.x?this.x.workspaceFolders:[];if(z+T>q.length)return!1;const W=q.slice(0);W.splice(z,T,...j.map(Se=>({uri:Se.uri,name:Se.name||(0,R.$sg)(Se.uri),index:void 0})));for(let Se=0;Se<W.length;Se++){const ve=W[Se];if(W.some((ge,re)=>re!==Se&&$(ve.uri,ge.uri,this.s)))return!1}W.forEach((Se,ve)=>Se.index=ve);const{added:we,removed:ke}=P(q,W,k,this.s);if(we.length===0&&ke.length===0)return!1;if(this.o){const Se=B.displayName||B.name;this.o.$updateWorkspaceFolders(Se,z,T,j).then(void 0,ve=>{this.n=void 0;const ge={source:{identifier:B.identifier,label:B.displayName||B.name}};this.q.$showMessage(t.Severity.Error,(0,b.localize)(0,null,Se,ve.toString()),ge,[])})}return this.y(W),!0}getWorkspaceFolder(B,z){if(this.x)return this.x.getWorkspaceFolder(B,z)}async getWorkspaceFolder2(B,z){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(B,z)}async resolveWorkspaceFolder(B){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(B)}getPath(){if(!this.x)return;const{folders:B}=this.x;if(B.length!==0)return B[0].uri.fsPath}getRelativePath(B,z){let T,F="";if(typeof B=="string"?(T=u.URI.file(B),F=B):typeof B<"u"&&(T=B,F=B.fsPath),!T)return F;const j=this.getWorkspaceFolder(T,!0);if(!j)return F;typeof z>"u"&&this.x&&(z=this.x.folders.length>1);let q=(0,R.$yg)(j.uri,T);return z&&j.name&&(q=`${j.name}/${q}`),q}y(B){this.x&&(this.n=w.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:B,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(B){const{workspace:z,added:T,removed:F}=w.toExtHostWorkspace(B,this.l,this.n,this.s);this.l=z||void 0,this.n=void 0,this.c.fire(Object.freeze({added:T,removed:F}))}findFiles(B,z,T,F,j=I.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${F.value}, entryPoint: findFiles`);let q;if(z===null?q=!1:z&&(typeof z=="string"?q=z:q=z.pattern),j&&j.isCancellationRequested)return Promise.resolve([]);const{includePattern:W,folder:we}=M(m.GlobPattern.from(B));return this.o.$startFileSearch(W??null,we??null,q??null,T??null,j).then(ke=>Array.isArray(ke)?ke.map(Se=>u.URI.revive(Se)):[])}async findTextInFiles(B,z,T,F,j=I.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${F.value}, entryPoint: findTextInFiles`);const q=this.j.getNext(),W=typeof z.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:z.previewOptions,{includePattern:we,folder:ke}=M(m.GlobPattern.from(z.include)),Se=typeof z.exclude=="string"?z.exclude:z.exclude?z.exclude.pattern:void 0,ve={ignoreSymlinks:typeof z.followSymlinks=="boolean"?!z.followSymlinks:void 0,disregardIgnoreFiles:typeof z.useIgnoreFiles=="boolean"?!z.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof z.useGlobalIgnoreFiles=="boolean"?!z.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof z.useParentIgnoreFiles=="boolean"?!z.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof z.useDefaultExcludes=="boolean"?!z.useDefaultExcludes:!0,fileEncoding:z.encoding,maxResults:z.maxResults,previewOptions:W,afterContext:z.afterContext,beforeContext:z.beforeContext,includePattern:we,excludePattern:Se},ge=!1;if(this.u[q]=re=>{if(ge)return;const oe=u.URI.revive(re.resource);re.results.forEach(ye=>{(0,s.$SI)(ye)?T({uri:oe,preview:{text:ye.preview.text,matches:(0,f.$2b)(ye.preview.matches,De=>new n.$uK(De.startLineNumber,De.startColumn,De.endLineNumber,De.endColumn))},ranges:(0,f.$2b)(ye.ranges,De=>new n.$uK(De.startLineNumber,De.startColumn,De.endLineNumber,De.endColumn))}):T({uri:oe,text:ye.text,lineNumber:ye.lineNumber})})},j.isCancellationRequested)return{};try{const re=await this.o.$startTextSearch(B,ke??null,ve,q,j);return delete this.u[q],re||{}}catch(re){throw delete this.u[q],re}}$handleTextSearchResult(B,z){this.u[z]?.(B)}async save(B){const z=await this.o.$save(B,{saveAs:!1});return u.URI.revive(z)}async saveAs(B){const z=await this.o.$save(B,{saveAs:!0});return u.URI.revive(z)}saveAll(B){return this.o.$saveAll(B)}resolveProxy(B){return this.o.$resolveProxy(B)}get trusted(){return this.v}requestWorkspaceTrust(B){return this.o.$requestWorkspaceTrust(B)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(B,z){if(this.w.has(B))throw new Error(`A provider has already been registered for scheme ${B}`);this.w.set(B,z);const T=this.t.transformOutgoingScheme(B),F=this.z++;return this.o.$registerEditSessionIdentityProvider(F,T),(0,A.$Qc)(()=>{this.w.delete(B),this.o.$unregisterEditSessionIdentityProvider(F)})}async $getEditSessionIdentifier(B,z){this.h.info("Getting edit session identifier for workspaceFolder",B);const T=await this.resolveWorkspaceFolder(u.URI.revive(B));if(!T){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",T);const F=this.w.get(T.uri.scheme);if(this.h.info(`Provider for scheme ${T.uri.scheme} is defined: `,!!F),!F)return;const j=await F.provideEditSessionIdentity(T,z);if(this.h.info("Provider returned edit session identifier: ",j),!!j)return j}async $provideEditSessionIdentityMatch(B,z,T,F){this.h.info("Getting edit session identifier for workspaceFolder",B);const j=await this.resolveWorkspaceFolder(u.URI.revive(B));if(!j){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",j);const q=this.w.get(j.uri.scheme);if(this.h.info(`Provider for scheme ${j.uri.scheme} is defined: `,!!q),!q)return;const W=await q.provideEditSessionIdentityMatch?.(z,T,F);if(this.h.info("Provider returned edit session identifier match result: ",W),!!W)return W}getOnWillCreateEditSessionIdentityEvent(B){return(z,T,F)=>{const j=function(W){z.call(T,W)};return j.extension=B,this.A.event(j,void 0,F)}}async $onWillCreateEditSessionIdentity(B,z,T){const F=await this.resolveWorkspaceFolder(u.URI.revive(B));if(F===void 0)throw new Error("Unable to resolve workspace folder");await this.A.fireAsync({workspaceFolder:F},z,async(j,q)=>{const W=Date.now();await Promise.resolve(j),Date.now()-W>T&&this.h.warn("SLOW edit session create-participant",q.extension.identifier)}),z.isCancellationRequested}registerCanonicalUriProvider(B,z){if(this.B.has(B))throw new Error(`A provider has already been registered for scheme ${B}`);this.B.set(B,z);const T=this.t.transformOutgoingScheme(B),F=this.z++;return this.o.$registerCanonicalUriProvider(F,T),(0,A.$Qc)(()=>{this.B.delete(B),this.o.$unregisterCanonicalUriProvider(F)})}async provideCanonicalUri(B,z,T){const F=this.B.get(B.scheme);if(!F)return;const j=await F.provideCanonicalUri?.(u.URI.revive(B),z,T);if(j)return j}async $provideCanonicalUri(B,z,T){return this.provideCanonicalUri(u.URI.revive(B),{targetScheme:z},T)}};e.$Rcc=y,e.$Rcc=y=Ge([qe(0,D.$rM),qe(1,v.$HM),qe(2,l.$Fcc),qe(3,g.$$i),qe(4,r.$Pcc)],y),e.$Scc=(0,p.$Qh)("IExtHostWorkspace");function M(V){let B,z;return V&&(typeof V=="string"?B=V:(B=V.pattern,z=u.URI.revive(V.baseUri))),{includePattern:B,folder:z}}}),define(Ae[34],Re([1,0,25,5,33,3,7,178,96,15,12,4,17,14,2]),function(ee,e,f,C,I,O,A,c,E,d,R,S,u,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vcc=e.$Ucc=e.$Tcc=void 0;function g(r,s){if(s){const o=s.split(".");let $=r;for(let a=0;$&&a<o.length;a++)$=$[o[a]];return $}}function t(r){return r instanceof p.URI}function i(r){return r&&r.uri instanceof p.URI&&r.languageId&&typeof r.languageId=="string"}function l(r){return r&&!r.uri&&r.languageId&&typeof r.languageId=="string"}function v(r){return r&&r.uri instanceof p.URI&&(!r.name||typeof r.name=="string")&&(!r.index||typeof r.index=="number")}function D(r){if(t(r))return{resource:r};if(i(r))return{resource:r.uri,overrideIdentifier:r.languageId};if(l(r))return{overrideIdentifier:r.languageId};if(v(r))return{resource:r.uri};if(r===null)return{resource:null}}let m=class{constructor(s,o,$){this.a=s.getProxy(O.$qK.MainThreadConfiguration),this.c=o,this.b=$,this.d=new R.$Tg,this.e=null}getConfigProvider(){return this.d.wait().then(s=>this.e)}$initializeConfiguration(s){this.e=new n(this.a,this.c,s,this.b),this.d.open()}$acceptConfigurationChanged(s,o){this.getConfigProvider().then($=>$.$acceptConfigurationChanged(s,o))}};e.$Tcc=m,e.$Tcc=m=Ge([qe(0,u.$rM),qe(1,I.$Scc),qe(2,b.$$i)],m);class n{constructor(s,o,$,a){this.a=new C.$Od,this.b=s,this.f=a,this.c=o,this.e=c.$Jn.parse($),this.d=this.k($.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(s,o){const $={data:this.e.toData(),workspace:this.c.workspace};this.e=c.$Jn.parse(s),this.d=this.k(s.configurationScopes),this.a.fire(this.j(o,$))}getConfiguration(s,o,$){const a=D(o)||{},k=this.g(s?g(this.e.getValue(void 0,a,this.c.workspace),s):this.e.getValue(void 0,a,this.c.workspace));s&&this.h(s,a,$?.identifier);function P(w){if(w==null)return null;if(typeof w=="boolean")return w?2:5;switch(w){case A.ConfigurationTarget.Global:return 2;case A.ConfigurationTarget.Workspace:return 5;case A.ConfigurationTarget.WorkspaceFolder:return 6}}const h={has(w){return typeof g(k,w)<"u"},get:(w,y)=>{this.h(s?`${s}.${w}`:w,a,$?.identifier);let M=g(k,w);if(typeof M>"u")M=y;else{let V;const B=(z,T)=>{if((0,d.$Bf)(z)){let F;const j=()=>{V=V||(0,f.$9m)(k),F=F||g(V,T)};return new Proxy(z,{get:(q,W)=>{if(typeof W=="string"&&W.toLowerCase()==="tojson")return j(),()=>F;if(V)return F=F||g(V,T),F[W];const we=q[W];return typeof W=="string"?B(we,`${T}.${W}`):we},set:(q,W,we)=>(j(),F&&(F[W]=we),!0),deleteProperty:(q,W)=>(j(),F&&delete F[W],!0),defineProperty:(q,W,we)=>(j(),F&&Object.defineProperty(F,W,we),!0)})}return Array.isArray(z)?(0,f.$9m)(z):z};M=B(M,w)}return M},update:(w,y,M,V)=>{w=s?`${s}.${w}`:w;const B=P(M);return y!==void 0?this.b.$updateConfigurationOption(B,w,y,a,V):this.b.$removeConfigurationOption(B,w,a,V)},inspect:w=>{w=s?`${s}.${w}`:w;const y=this.e.inspect(w,a,this.c.workspace);if(y)return{key:w,defaultValue:(0,f.$9m)(y.policy?.value??y.default?.value),globalValue:(0,f.$9m)(y.user?.value??y.application?.value),workspaceValue:(0,f.$9m)(y.workspace?.value),workspaceFolderValue:(0,f.$9m)(y.workspaceFolder?.value),defaultLanguageValue:(0,f.$9m)(y.default?.override),globalLanguageValue:(0,f.$9m)(y.user?.override??y.application?.override),workspaceLanguageValue:(0,f.$9m)(y.workspace?.override),workspaceFolderLanguageValue:(0,f.$9m)(y.workspaceFolder?.override),languageIds:(0,f.$9m)(y.overrideIdentifiers)}}};return typeof k=="object"&&(0,f.$_m)(h,k,!1),Object.freeze(h)}g(s){const o=$=>(0,d.$Bf)($)?new Proxy($,{get:(a,k)=>o(a[k]),set:(a,k,P)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(k)}' of object`)},deleteProperty:(a,k)=>{throw new Error(`TypeError: Cannot delete read only property '${String(k)}' of object`)},defineProperty:(a,k)=>{throw new Error(`TypeError: Cannot define property '${String(k)}' for a readonly object`)},setPrototypeOf:a=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):$;return o(s)}h(s,o,$){const a=E.$An.test(s)?4:this.d.get(s),k=$?`[${$.value}] `:"";if(a===4){typeof o?.resource>"u"&&this.f.warn(`${k}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${s}', provide the URI of a resource or 'null' for any resource.`);return}if(a===3){o?.resource&&this.f.warn(`${k}Accessing a window scoped configuration for a resource is not expected. To associate '${s}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(s,o){const $=new c.$Ln(s,o,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(a,k)=>$.affectsConfiguration(a,D(k))})}k(s){return s.reduce((o,$)=>(o.set($[0],$[1]),o),new Map)}}e.$Ucc=n,e.$Vcc=(0,S.$Qh)("IExtHostConfiguration")});var Xe=this&&this.__classPrivateFieldSet||function(ee,e,f,C,I){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!I:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?I.call(ee,f):I?I.value=f:e.set(ee,f),f},Ne=this&&this.__classPrivateFieldGet||function(ee,e,f,C){if(f==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!C:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return f==="m"?C:f==="a"?C.call(ee):C?C.value:e.get(ee)};define(Ae[111],Re([1,0,2,12,5,3,7,33,60,34,19,63,17,27,4,13,23,14,80,216,11]),function(ee,e,f,C,I,O,A,c,E,d,R,S,u,b,p,g,t,i,l,v,D){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.$Tdc=e.$Sdc=e.$Rdc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var n;(function(z){function T(j){if(j!=null)return j}z.from=T;function F(j){if(j!=null)return j}z.to=F})(n||(n={}));var r;(function(z){function T(j){if(j!=null)return j}z.from=T;function F(j){if(j!=null)return j}z.to=F})(r||(r={}));var s;(function(z){function T(j){if(j!=null)return j}z.from=T;function F(j){if(j!=null)return j}z.to=F})(s||(s={}));var o;(function(z){function T(q){if(q){const W=q;return W&&!!W.process}else return!1}z.is=T;function F(q){if(q==null)return;const W={process:q.process,args:q.args};return q.options&&(W.options=s.from(q.options)),W}z.from=F;function j(q){if(q!=null)return new A.$aL(q.process,q.args,q.options)}z.to=j})(o||(o={}));var $;(function(z){function T(j){if(j!=null)return j}z.from=T;function F(j){if(j!=null)return j}z.to=F})($||($={}));var a;(function(z){function T(q){if(q){const W=q;return W&&(!!W.commandLine||!!W.command)}else return!1}z.is=T;function F(q){if(q==null)return;const W={};return q.commandLine!==void 0?W.commandLine=q.commandLine:(W.command=q.command,W.args=q.args),q.options&&(W.options=$.from(q.options)),W}z.from=F;function j(q){if(!(q==null||q.command===void 0&&q.commandLine===void 0))return q.commandLine?new A.$bL(q.commandLine,q.options):new A.$bL(q.command,q.args?q.args:[],q.options)}z.to=j})(a||(a={}));var k;(function(z){function T(q){if(q){const W=q;return W&&W.customExecution==="customExecution"}else return!1}z.is=T;function F(q){return{customExecution:"customExecution"}}z.from=F;function j(q,W){return W.get(q)}z.to=j})(k||(e.CustomExecutionDTO=k={}));var P;(function(z){function T(F,j){let q;return F.scope!==void 0&&typeof F.scope!="number"?q=F.scope.uri:F.scope!==void 0&&typeof F.scope=="number"&&(F.scope===A.TaskScope.Workspace&&j&&j.workspaceFile?q=j.workspaceFile:q=v.$XF),{id:F._id,workspaceFolder:q}}z.from=T})(P||(e.TaskHandleDTO=P={}));var h;(function(z){function T(F){if(F!=null)return{_id:F.id,isDefault:F.isDefault}}z.from=T})(h||(h={}));var w;(function(z){function T(q,W){if(q==null)return[];const we=[];for(const ke of q){const Se=F(ke,W);Se&&we.push(Se)}return we}z.fromMany=T;function F(q,W){if(q==null)return;let we;q.execution instanceof A.$aL?we=o.from(q.execution):q.execution instanceof A.$bL?we=a.from(q.execution):q.execution&&q.execution instanceof A.$cL&&(we=k.from(q.execution));const ke=n.from(q.definition);let Se;return q.scope?typeof q.scope=="number"?Se=q.scope:Se=q.scope.uri:Se=A.TaskScope.Workspace,!ke||!Se?void 0:{_id:q._id,definition:ke,name:q.name,source:{extensionId:W.identifier.value,label:q.source,scope:Se},execution:we,isBackground:q.isBackground,group:h.from(q.group),presentationOptions:r.from(q.presentationOptions),problemMatchers:q.problemMatchers,hasDefinedMatchers:q.hasDefinedMatchers,runOptions:q.runOptions?q.runOptions:{reevaluateOnRerun:!0},detail:q.detail}}z.from=F;async function j(q,W,we){if(q==null)return;let ke;o.is(q.execution)?ke=o.to(q.execution):a.is(q.execution)?ke=a.to(q.execution):k.is(q.execution)&&(ke=k.to(q._id,we));const Se=n.to(q.definition);let ve;if(q.source&&(q.source.scope!==void 0?typeof q.source.scope=="number"?ve=q.source.scope:ve=await W.resolveWorkspaceFolder(f.URI.revive(q.source.scope)):ve=A.TaskScope.Workspace),!Se||!ve)return;const ge=new A.$dL(Se,ve,q.name,q.source.label,ke,q.problemMatchers);return q.isBackground!==void 0&&(ge.isBackground=q.isBackground),q.group!==void 0&&(ge.group=A.$_K.from(q.group._id),ge.group&&q.group.isDefault&&(ge.group=new A.$_K(ge.group.id,ge.group.label),q.group.isDefault===!0&&(ge.group.isDefault=q.group.isDefault))),q.presentationOptions&&(ge.presentationOptions=r.to(q.presentationOptions)),q._id&&(ge._id=q._id),q.detail&&(ge.detail=q.detail),ge}z.to=j})(w||(e.TaskDTO=w={}));var y;(function(z){function T(j){return j}z.from=T;function F(j){if(j)return Object.assign(Object.create(null),j)}z.to=F})(y||(y={}));class M{constructor(T,F,j){this._id=F,this.a=j,m.set(this,void 0),Xe(this,m,T,"f")}get task(){return this.a}terminate(){Ne(this,m,"f").terminateTask(this)}fireDidStartProcess(T){}fireDidEndProcess(T){}}m=new WeakMap;let V=class{constructor(T,F,j,q,W,we,ke,Se){this.q=new I.$Od,this.r=new I.$Od,this.s=new I.$Od,this.t=new I.$Od,this.a=T.getProxy(O.$qK.MainThreadTask),this.b=j,this.c=q,this.d=W,this.e=we,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=ke,this.g=Se,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(T,F,j){if(!j)return new A.$sK(()=>{});const q=this.w();return this.j.set(q,{type:F,provider:j,extension:T}),this.a.$registerTaskProvider(q,F),new A.$sK(()=>{this.j.delete(q),this.a.$unregisterTaskProvider(q)})}registerTaskSystem(T,F){this.a.$registerTaskSystem(T,F)}fetchTasks(T){return this.a.$fetchTasks(y.from(T)).then(async F=>{const j=[];for(const q of F){const W=await w.to(q,this.b,this.m);W&&j.push(W)}return j})}get taskExecutions(){const T=[];return this.k.forEach(F=>T.push(F)),T}terminateTask(T){if(!(T instanceof M))throw new Error("No valid task execution provided");return this.a.$terminateTask(T._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(T,F,j){const q=this.m.get(T.id);q&&(this.o.set(T.id,q),this.e.attachPtyToTerminal(F,await q.callback(j))),this.p=T.id,this.q.fire({execution:await this.y(T)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(T){const F=await this.y(T);this.l.delete(T.id),this.k.delete(T.id),this.A(T),this.r.fire({execution:F})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(T){const F=await this.y(T.id);this.s.fire({execution:F,processId:T.processId})}get onDidEndTaskProcess(){return this.t.event}async $onDidEndTaskProcess(T){const F=await this.y(T.id);this.t.fire({execution:F,exitCode:T.exitCode})}$provideTasks(T,F){const j=this.j.get(T);if(!j)return Promise.reject(new Error("no handler found"));const q=[],W=(0,C.$Ng)(()=>j.provider.provideTasks(R.CancellationToken.None)).then(we=>this.u(F,q,j,we));return new Promise(we=>{W.then(ke=>{Promise.all(q).then(()=>{we(ke)})})})}async $resolveTask(T,F){const j=this.j.get(T);if(!j)return Promise.reject(new Error("no handler found"));if(F.definition.type!==j.type)throw new Error(`Unexpected: Task of type [${F.definition.type}] cannot be resolved by provider of type [${j.type}].`);const q=await w.to(F,this.b,this.m);if(!q)throw new Error("Unexpected: Task cannot be resolved.");const W=await j.provider.resolveTask(q,R.CancellationToken.None);if(!W)return;this.z(W,j);const we=w.from(W,j.extension);if(!we)throw new Error("Unexpected: Task cannot be resolved.");if(W.definition!==q.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return k.is(we.execution)&&await this.x(we,W,!0),await this.v(we)}w(){return this.h++}async x(T,F,j){const q=await this.a.$createTaskId(T);!j&&!this.m.has(q)&&(this.n.add(q),this.o.set(q,F.execution)),this.m.set(q,F.execution)}async y(T,F){if(typeof T=="string"){const W=this.l.get(T);if(!W)throw new D.$bb("Unexpected: The specified task is missing an execution");return W}const j=this.l.get(T.id);if(j)return j;const q=new Promise((W,we)=>{function ke(Se,ve,ge){ge?W(new M(Se,ve.id,ge)):we("Unexpected: Task does not exist.")}F?ke(this,T,F):w.to(T.task,this.b,this.m).then(Se=>ke(this,T,Se))});return this.l.set(T.id,q),q.then(W=>(this.k.set(T.id,W),W),W=>Promise.reject(W))}z(T,F){T._deprecated&&this.g.report("Task.constructor",F.extension,"Use the Task constructor that takes a `scope` instead.")}A(T){this.o.get(T.id)&&this.o.delete(T.id),this.n.has(T.id)&&this.p!==T.id&&(this.m.delete(T.id),this.n.delete(T.id));const j=this.n.values();let q=j.next();for(;!q.done;)!this.o.has(q.value)&&this.p!==q.value&&(this.m.delete(q.value),this.n.delete(q.value)),q=j.next()}};e.$Rdc=V,e.$Rdc=V=Ge([qe(0,u.$rM),qe(1,b.$HM),qe(2,c.$Scc),qe(3,E.$CM),qe(4,d.$Vcc),qe(5,S.$bdc),qe(6,i.$$i),qe(7,l.$Icc)],V);let B=class extends V{constructor(T,F,j,q,W,we,ke,Se){super(T,F,j,q,W,we,ke,Se),this.registerTaskSystem(g.Schemas.vscodeRemote,{scheme:g.Schemas.vscodeRemote,authority:"",platform:t.$c(0)})}async executeTask(T,F){if(!F.execution)throw new Error("Tasks to execute must include an execution");const j=w.from(F,T);if(j===void 0)throw new Error("Task is not valid");if(k.is(j.execution))await this.x(j,F,!1);else throw new D.$_;const q=await this.y(await this.a.$getTaskExecution(j),F);return this.a.$executeTask(j).catch(W=>{throw new Error(W)}),q}u(T,F,j,q){const W=[];if(q)for(const we of q){this.z(we,j),(!we.definition||!T[we.definition.type])&&this.f.warn(`The task [${we.source}, ${we.name}] uses an undefined task type. The task will be ignored in the future.`);const ke=w.from(we,j.extension);ke&&k.is(ke.execution)?(W.push(ke),F.push(this.x(ke,we,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:W,extension:j.extension}}async v(T){if(k.is(T.execution))return T;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(T,F){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(T,F,j){}};e.$Sdc=B,e.$Sdc=B=Ge([qe(0,u.$rM),qe(1,b.$HM),qe(2,c.$Scc),qe(3,E.$CM),qe(4,d.$Vcc),qe(5,S.$bdc),qe(6,i.$$i),qe(7,l.$Icc)],B),e.$Tdc=(0,p.$Qh)("IExtHostTask")}),define(Ae[270],Re([1,0,20,19,38,36,24,48,49]),function(ee,e,f,C,I,O,A,c,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4dc=void 0;class d{constructor(u,b,p){this.k=u,this.l=b,this.o=p,this.e=!1,this.f=0,this.g=!1,this.a=u.filePattern,this.b=u.includePattern&&O.$xj(u.includePattern),this.c=u.maxResults||void 0,this.d=u.exists,this.h=new Set,this.j=u.excludePattern&&O.$xj(u.excludePattern)}cancel(){this.g=!0,this.h.forEach(u=>u.cancel()),this.h=new Set}search(u){const b=this.k.folderQueries||[];return new Promise((p,g)=>{const t=i=>{this.f++,u(i)};if(this.g)return p({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(i=>{const l=i.toString(),v=f.$nc(l);this.j&&this.j(l,v)||this.v(t,{base:i,basename:v})}),Promise.all(b.map(i=>this.p(i,t))).then(i=>{p({limitHit:this.e,stats:i[0]||void 0})},i=>{g(new Error((0,I.$Bi)(i)))})})}async p(u,b){const p=new C.$Yd,g=this.q(u),t=this.r(),i=new E.$$I(this.k,u),l=!i.hasSiblingExcludeClauses();let v;try{this.h.add(p),v=c.$Kd.create();const D=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},g,p.token),m=v.elapsed(),n=c.$Kd.create();return this.g&&!this.e||(D&&D.forEach(r=>{const s=f.$gc.relative(u.folder.path,r.path);if(l){const o=f.$nc(r.path);this.v(b,{base:u.folder,relativePath:s,basename:o});return}this.s(t,u.folder,s,b)}),this.g&&!this.e)?null:(this.u(t,i,b),{providerTime:m,postProcessTime:n.elapsed()})}finally{p.dispose(),this.h.delete(p)}}q(u){const b=(0,E.$0I)(this.k.includePattern,u.includePattern),p=(0,E.$0I)(this.k.excludePattern,u.excludePattern);return{folder:u.folder,excludes:p,includes:b,useIgnoreFiles:!u.disregardIgnoreFiles,useGlobalIgnoreFiles:!u.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!u.disregardParentIgnoreFiles,followSymlinks:!u.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const u={rootEntries:[],pathToEntries:Object.create(null)};return u.pathToEntries["."]=u.rootEntries,u}s({pathToEntries:u},b,p,g){if(p===this.a){const i=f.$nc(this.a);this.v(g,{base:b,relativePath:this.a,basename:i})}function t(i){const l=f.$nc(i),v=f.$mc(i);let D=u[v];D||(D=u[v]=[],t(v)),D.push({base:b,relativePath:i,basename:l})}t(p)}u({rootEntries:u,pathToEntries:b},p,g){const t=this,i=this.a;function l(v){const D=(0,E.$aJ)(()=>v.map(m=>m.basename));for(let m=0,n=v.length;m<n;m++){const r=v[m],{relativePath:s,basename:o}=r;if(p.matchesExcludesSync(s,o,i!==o?D:void 0))continue;const $=b[s];if($)l($);else{if(s===i)continue;t.v(g,r)}if(t.e)break}}l(u)}v(u,b){(!this.b||b.relativePath&&this.b(b.relativePath,b.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||u(b))}}class R{constructor(){this.b=new Map}fileSearch(u,b,p,g){const t=this.c(u.cacheKey),i=new d(u,b,t&&t.token);let l=0;const v=D=>{l+=D.length,p(D.map(m=>this.d(m)))};return this.e(i,R.a,v,g).then(D=>({limitHit:D.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:l,detailStats:D.stats}}))}clearCache(u){this.c(u)?.cancel()}c(u){if(u)return this.b.has(u)||this.b.set(u,new C.$Yd),this.b.get(u)}d(u){return u.relativePath?{resource:A.$wg(u.base,u.relativePath)}:{resource:u.base}}e(u,b,p,g){const t=g.onCancellationRequested(()=>{u.cancel()}),i=v=>{v&&(l.push(v),b>0&&l.length>=b&&(p(l),l=[]))};let l=[];return u.search(i).then(v=>(l.length&&p(l),t.dispose(),v),v=>(l.length&&p(l),t.dispose(),Promise.reject(v)))}}e.$4dc=R,R.a=512}),define(Ae[271],Re([1,0,18,234,36,90,28,13,20,24,16,15,2,286,168,45,14,56,102,269,49]),function(ee,e,f,C,I,O,A,c,E,d,R,S,u,b,p,g,t,i,l,v,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8J=e.$7J=void 0;let m=class{constructor(w,y,M,V,B){this.a=w,this.b=y,this.c=M,this.d=V,this.e=B}text(w,y,M={}){w=this.f(w,M);const V=this.a.getValue(),B=y&&y.some(T=>!this.a.getValue({resource:T}).search.useRipgrep);return{...this.h(y?.map(i.$_h),M),type:2,contentPattern:w,previewOptions:M.previewOptions,maxFileSize:M.maxFileSize,usePCRE2:V.search.usePCRE2||B||!1,beforeContext:M.beforeContext,afterContext:M.afterContext,userDisabledExcludesAndIgnoreFiles:M.disregardExcludeSettings&&M.disregardIgnoreFiles}}f(w,y){const M=this.a.getValue();w.isRegExp&&(w.pattern=w.pattern.replace(/\r?\n/g,"\\n"));const V={...w,wordSeparators:M.editor.wordSeparators};return this.j(w,y)&&(V.isCaseSensitive=!0),this.k(w)&&(V.isMultiline=!0),y.notebookSearchConfig?.includeMarkupInput&&(V.notebookInfo||(V.notebookInfo={}),V.notebookInfo.isInNotebookMarkdownInput=y.notebookSearchConfig.includeMarkupInput),y.notebookSearchConfig?.includeMarkupPreview&&(V.notebookInfo||(V.notebookInfo={}),V.notebookInfo.isInNotebookMarkdownPreview=y.notebookSearchConfig.includeMarkupPreview),y.notebookSearchConfig?.includeCodeInput&&(V.notebookInfo||(V.notebookInfo={}),V.notebookInfo.isInNotebookCellInput=y.notebookSearchConfig.includeCodeInput),y.notebookSearchConfig?.includeOutput&&(V.notebookInfo||(V.notebookInfo={}),V.notebookInfo.isInNotebookCellOutput=y.notebookSearchConfig.includeOutput),V}file(w,y={}){return{...this.h(w,y),type:1,filePattern:y.filePattern?y.filePattern.trim():y.filePattern,exists:y.exists,sortByScore:y.sortByScore,cacheKey:y.cacheKey}}g(w,y){return w?(w=Array.isArray(w)?w.map($):$(w),y?this.parseSearchPaths(w):{pattern:r(...Array.isArray(w)?w:[w])}):{}}h(w=[],y={}){const M=this.g(y.includePattern,y.expandPatterns),V=this.g(y.excludePattern,y.expandPatterns),B=w.length>1,z=(M.searchPaths&&M.searchPaths.length?M.searchPaths.map(j=>this.q(j,y,V)):w.map(j=>this.r(j,y,V,B))).filter(j=>!!j),T={_reason:y._reason,folderQueries:z,usingSearchPaths:!!(M.searchPaths&&M.searchPaths.length),extraFileResources:y.extraFileResources,excludePattern:V.pattern,includePattern:M.pattern,onlyOpenEditors:y.onlyOpenEditors,maxResults:y.maxResults};if(y.onlyOpenEditors){const j=f.$Hb(f.$Rb(this.c.groups.map(we=>we.editors.map(ke=>ke.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(j));const q=j.filter(we=>(0,D.$1I)(T,we.fsPath)),W=this.i(q);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(W)),{...T,...W}}const F=y.extraFileResources&&y.extraFileResources.filter(j=>(0,D.$1I)(T,j.fsPath));return T.extraFileResources=F&&F.length?F:void 0,T}i(w){const y=[],M=new A.$Ac,V={};let B=!1;return w.forEach(z=>{if(z.scheme===c.Schemas.walkThrough)return;if((0,d.$Ag)(z)){const F=this.b.getWorkspaceFolder(z)?.uri??z.with({path:E.$mc(z.fsPath)});let j=M.get(F);j||(B=!0,j={folder:F,includePattern:{}},y.push(j),M.set(F,j));const q=E.$lc(F.fsPath,z.fsPath);(0,S.$Kf)(j.includePattern)[q.replace(/\\/g,"/")]=!0}else z.fsPath&&(B=!0,V[z.fsPath]=!0)}),{folderQueries:y,includePattern:V,usingSearchPaths:!0,excludePattern:B?void 0:{"**/*":!0}}}j(w,y){if(y.isSmartCase){if(w.isRegExp){if(R.$qf(w.pattern,!0))return!0}else if(R.$qf(w.pattern))return!0}return!!w.isCaseSensitive}k(w){return w.isMultiline||w.isRegExp&&(0,b.$AB)(w.pattern)||w.pattern.indexOf(`
`)>=0?!0:!!w.isMultiline}parseSearchPaths(w){const y=W=>E.$ic(W)||/^\.\.?([\/\\]|$)/.test(W),V=(Array.isArray(w)?w:s(w)).map(W=>{const we=this.e.resolvedUserHome;return we?(0,O.$zv)(W,we.scheme===c.Schemas.file?we.fsPath:we.path):W}),B=C.$D(V,W=>y(W)?"searchPaths":"exprSegments"),z=(B.exprSegments||[]).map(W=>R.$Le(W,"/")).map(W=>R.$Le(W,"\\")).map(W=>(W[0]==="."&&(W="*"+W),o(W))),T={},F=this.m(B.searchPaths||[]);F&&F.length&&(T.searchPaths=F);const j=f.$Rb(z),q=r(...j);return q&&(T.pattern=q),T}l(w,y){return y.disregardExcludeSettings?void 0:(0,D.$ZI)(w,!y.disregardSearchExcludeSettings)}m(w){if(!w||!w.length)return[];const y=w.flatMap(V=>{let{pathPortion:B,globPortion:z}=n(V);return z&&(z=a(z)),this.n(B).flatMap(F=>this.o(F,z))}),M=new Map;return y.forEach(V=>{const B=V.searchPath.toString(),z=M.get(B);z?V.pattern&&(z.pattern=z.pattern||{},z.pattern[V.pattern]=!0):M.set(B,{searchPath:V.searchPath,pattern:V.pattern?r(V.pattern):void 0})}),Array.from(M.values())}n(w){if(E.$ic(w)){const y=this.b.getWorkspace().folders;return y[0]&&y[0].uri.scheme!==c.Schemas.file?[{searchPath:y[0].uri.with({path:w})}]:[{searchPath:u.URI.file(E.$hc(w))}]}if(this.b.getWorkbenchState()===2){const y=this.b.getWorkspace().folders[0].uri;if(w=$(w),w.startsWith("../")||w===".."){const V=E.$gc.resolve(y.path,w);return[{searchPath:y.with({path:V})}]}const M=a(w);return[{searchPath:y,pattern:M}]}else{if(w==="./"||w===".\\")return[];{const y=w.replace(/^\.[\/\\]/,""),V=this.b.getWorkspace().folders.map(B=>{const z=y.match(new RegExp(`^${R.$Ge(B.name)}(?:/(.*)|$)`));return z?{match:z,folder:B}:null}).filter(S.$Hf);if(V.length)return V.map(B=>{const z=B.match[1];return{searchPath:B.folder.uri,pattern:z&&a(z)}});{const B=w.match(/\.[\/\\](.+)[\/\\]?/),z=B?B[1]:w,T=p.localize(0,null,z);throw new Error(T)}}}}o(w,y){const M=w.pattern&&y?`${w.pattern}/${y}`:w.pattern||y,V=[{searchPath:w.searchPath,pattern:M}];return M&&!M.endsWith("**")&&V.push({searchPath:w.searchPath,pattern:M+"/**"}),V}q(w,y,M){const V=this.r((0,i.$_h)(w.searchPath),y,M,!1);return V?{...V,includePattern:w.pattern}:null}r(w,y,M,V){let B;const z=u.URI.isUri(w)?w:w.uri;if(M.searchPaths){const W=M.searchPaths.filter(we=>(0,d.$pg)(we.searchPath,z))[0];if(W&&!W.pattern)return null;W&&(B=W.pattern)}const T=this.a.getValue({resource:z}),j={...this.l(T,y)||{},...B||{}},q=u.URI.isUri(w)?(0,d.$tg)(w):w.name;return{folder:z,folderName:V?q:void 0,excludePattern:Object.keys(j).length>0?j:void 0,fileEncoding:T.files&&T.files.encoding,disregardIgnoreFiles:typeof y.disregardIgnoreFiles=="boolean"?y.disregardIgnoreFiles:!T.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof y.disregardGlobalIgnoreFiles=="boolean"?y.disregardGlobalIgnoreFiles:!T.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof y.disregardParentIgnoreFiles=="boolean"?y.disregardParentIgnoreFiles:!T.search.useParentIgnoreFiles,ignoreSymlinks:typeof y.ignoreSymlinks=="boolean"?y.ignoreSymlinks:!T.search.followSymlinks}}};e.$7J=m,e.$7J=m=Ge([qe(0,g.$ki),qe(1,i.$Zh),qe(2,l.$sC),qe(3,t.$$i),qe(4,v.$5J)],m);function n(h){const w=h.match(/[\*\{\}\(\)\[\]\?]/);if(w){const y=w.index,M=h.substr(0,y).match(/[/|\\][^/\\]*$/);if(M){let V=h.substr(0,M.index);return V.match(/[/\\]/)||(V+="/"),{pathPortion:V,globPortion:h.substr((M.index||0)+1)}}}return{pathPortion:h}}function r(...h){return h.length?h.reduce((w,y)=>(w[y]=!0,w),Object.create(null)):void 0}function s(h){return I.$vj(h,",").map(w=>w.trim()).filter(w=>!!w.length)}function o(h){return[`**/${h}/**`,`**/${h}`].map(y=>y.replace(/\*\*\/\*\*/g,"**"))}function $(h){return h.replace(/\\/g,"/")}function a(h){return $(h).replace(/^\.\//,"").replace(/\/+$/g,"")}function k(h){return h.replace(/([?*[\]])/g,"[$1]")}function P(h,w){h=f.$Mb(h,V=>V.toString());const y=[],M=w.getWorkspace();return h&&h.forEach(V=>{let B;if(w.getWorkbenchState()===2)B=(0,d.$yg)(M.folders[0].uri,V),B&&B!=="."&&(B="./"+B);else{const z=w.getWorkspaceFolder(V);if(z){const T=z.name;if(M.folders.filter(j=>j.name===T).length===1){const j=(0,d.$yg)(z.uri,V);j===""?B=`./${z.name}`:B=`./${z.name}/${j}`}else B=V.fsPath}}B&&y.push(k(B))}),y}e.$8J=P}),define(Ae[272],Re([1,0,24,2,19,11,4,271,49,56]),function(ee,e,f,C,I,O,A,c,E,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vlb=e.$Ulb=void 0;const R=7e3;function S(g,t){const i=t.activationEvents;if(!i)return Promise.resolve(void 0);const l=[],v=[];for(const o of i)if(/^workspaceContains:/.test(o)){const $=o.substr(18);$.indexOf("*")>=0||$.indexOf("?")>=0||g.forceUsingSearch?v.push($):l.push($)}if(l.length===0&&v.length===0)return Promise.resolve(void 0);let D;const m=new Promise((o,$)=>{D=o}),n=o=>D({activationEvent:o}),r=Promise.all(l.map(o=>u(g,o,n))).then(()=>{}),s=b(g,t.identifier,v,n);return Promise.all([r,s]).then(()=>{D(void 0)}),m}e.$Ulb=S;async function u(g,t,i){for(const l of g.folders)if(await g.exists(f.$wg(C.URI.revive(l),t))){i(`workspaceContains:${t}`);return}}async function b(g,t,i,l){if(i.length===0)return Promise.resolve(void 0);const v=new I.$Yd,D=g.checkExists(g.folders,i,v.token),m=setTimeout(async()=>{v.cancel(),g.logService.info(`Not activating extension '${t.value}': Timed out while searching for 'workspaceContains' pattern ${i.join(",")}`)},R);let n=!1;try{n=await D}catch(r){O.$4(r)||O.$1(r)}v.dispose(),clearTimeout(m),n&&l(`workspaceContains:${i.join(",")}`)}function p(g,t,i,l){const v=g.get(A.$Ph),D=g.get(E.$RI),n=v.createInstance(c.$7J).file(t.map(r=>(0,d.$_h)(C.URI.revive(r))),{_reason:"checkExists",includePattern:i,exists:!0});return D.fileSearch(n,l).then(r=>!!r.limitHit,r=>O.$4(r)?!1:Promise.reject(r))}e.$Vlb=p});var Xe=this&&this.__classPrivateFieldSet||function(ee,e,f,C,I){if(C==="m")throw new TypeError("Private method is not writable");if(C==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!I:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return C==="a"?I.call(ee,f):I?I.value=f:e.set(ee,f),f},Ne=this&&this.__classPrivateFieldGet||function(ee,e,f,C){if(f==="a"&&!C)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!C:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return f==="m"?C:f==="a"?C.call(ee):C?C.value:e.get(ee)};define(Ae[35],Re([1,0,149,20,87,24,12,6,50,2,14,3,34,205,84,33,22,103,11,21,26,189,7,97,4,27,85,17,71,86,63,5,272,83,191,13,81,48,23,82]),function(ee,e,f,C,I,O,A,c,E,d,R,S,u,b,p,g,t,i,l,v,D,m,n,r,s,o,$,a,k,P,h,w,y,M,V,B,z,T,F,j){"use strict";var q,W,we,ke;Object.defineProperty(e,"__esModule",{value:!0}),e.$qdc=e.$pdc=e.$odc=e.$ndc=e.$mdc=void 0,e.$mdc=(0,s.$Qh)("IHostUtils");let Se=ke=class extends c.$Sc{constructor(J,he,de,le,be,ie,fe,ne,ce,pe,Ce,L){super(),this.X=L,this.a=this.B(new w.$Od),this.onDidChangeRemoteConnectionData=this.a.event,this.U=!1,this.c=he,this.g=de,this.f=fe,this.j=le,this.m=be,this.s=ie,this.t=ce,this.u=pe,this.w=Ce,this.y=this.g.getProxy(S.$qK.MainThreadWorkspace),this.z=this.g.getProxy(S.$qK.MainThreadTelemetry),this.C=this.g.getProxy(S.$qK.MainThreadExtensionService),this.D=new A.$Tg,this.F=new A.$Tg,this.G=new A.$Tg,this.H=new A.$Tg,this.I=new Q(this.f.extensions.activationEvents),this.L=new i.$V4b(this.I,this.f.extensions.allExtensions);const K=new v.$9l(this.f.extensions.myExtensions);this.J=new i.$V4b(this.I,ye(this.L,K)),F.$n&&(this.s.info(`Creating extension host with the following global extensions: ${re(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${re(this.J)}`)),this.M=new p.$6cc(this.g,this.s),this.N=new M.$fdc(this.g),this.O=ne,this.h=J.createChild(new k.$Oh([p.$7cc,this.M],[M.$gdc,this.N])),this.P=this.B(new b.$5cc(this.J,this.L,{onExtensionActivationError:(Y,X,H)=>{this.C.$onExtensionActivationError(Y,l.$3(X),H)},actualActivateExtension:async(Y,X)=>{if(i.$V4b.isHostExtension(Y,this.J,this.L))return await this.C.$activateExtension(Y,X),new b.$4cc;const H=this.J.getExtensionDescription(Y);return this.db(H,X)}},this.s)),this.Q=null,this.R=Object.create(null),this.S=!1,this.W=this.f.remote.connectionData}getRemoteConnectionData(){return this.W}async initialize(){try{await this.tb(),this.D.open(),await this.j.waitForInitializeCall(),I.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.rb()}catch(J){l.$1(J)}}async Y(){this.O.onWillDeactivateAll();let J=[];try{J=this.J.getAllExtensionDescriptions().map(be=>be.identifier).filter(be=>this.isActivated(be)).map(be=>this.cb(be))}catch{}await Promise.all(J)}terminate(J,he=0){if(this.U)return;this.U=!0,this.s.info(`Extension host terminating: ${J}`),this.s.flush(),this.u.dispose(),this.P.dispose(),l.setUnexpectedErrorHandler(le=>{this.s.error(le)}),this.g.dispose();const de=this.Y();Promise.race([(0,A.$Vg)(5e3),de]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${he}`):this.s.info(`Extension host exiting with code ${he}`),this.s.flush(),this.s.dispose(),this.c.exit(he)})}isActivated(J){return this.G.isOpen()?this.P.isActivated(J):!1}async getExtension(J){const he=await this.C.$getExtension(J);return he&&{...he,identifier:new v.$8l(he.identifier.value),extensionLocation:d.URI.revive(he.extensionLocation)}}Z(J,he){return this.P.activateByEvent(J,he)}$(J,he){return this.P.activateById(J,he)}activateByIdWithErrors(J,he){return this.$(J,he).then(()=>{const de=this.P.getActivatedExtension(J);if(de.activationFailed)return Promise.reject(de.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(J=>this.J)}getExtensionExports(J){if(this.G.isOpen())return this.P.getActivatedExtension(J).exports;try{return this.P.getActivatedExtension(J).exports}catch{return null}}async ab(J){if(J.scheme===B.Schemas.file&&this.c.fsRealpath){const he=await this.c.fsRealpath(J.fsPath);return d.URI.file(he)}return J}async getExtensionPathIndex(){return this.Q||(this.Q=this.bb(this.J.getAllExtensionDescriptions()).then(J=>new De(J))),this.Q}async bb(J){const he=E.$Wh.forUris(de=>O.$ng.ignorePathCasing(de));return await Promise.all(J.map(async de=>{if(this.ub(de)){const le=await this.ab(de.extensionLocation);he.set(le,de)}})),he}cb(J){let he=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(J))return he;const de=this.P.getActivatedExtension(J);if(!de)return he;try{typeof de.module.deactivate=="function"&&(he=Promise.resolve(de.module.deactivate()).then(void 0,le=>(this.s.error(le),Promise.resolve(void 0))))}catch(le){this.s.error(`An error occurred when deactivating the extension '${J.value}':`),this.s.error(le)}try{(0,c.$Nc)(de.subscriptions)}catch(le){this.s.error(`An error occurred when deactivating the subscriptions for extension '${J.value}':`),this.s.error(le)}return he}async db(J,he){return this.f.remote.isRemote?this.C.$onWillActivateExtension(J.identifier):await this.C.$onWillActivateExtension(J.identifier),this.fb(J,he).then(de=>{const le=de.activationTimes;return this.C.$onDidActivateExtension(J.identifier,le.codeLoadingTime,le.activateCallTime,le.activateResolvedTime,he),this.eb(J,he,"success",le),de},de=>{throw this.eb(J,he,"failure"),de})}eb(J,he,de,le){const be=ge(J,he);this.z.$publicLog2("extensionActivationTimes",{...be,...le||{},outcome:de})}fb(J,he){const de=ge(J,he);this.z.$publicLog2("activatePlugin",de);const le=this.ub(J);if(!le)return Promise.resolve(new b.$3cc(b.$Zcc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${J.identifier.value}, startup: ${he.startup}, activationEvent: '${he.activationEvent}'${J.identifier.value!==he.extensionId.value?`, root cause: ${he.extensionId.value}`:""}`),this.s.flush();const be=new b.$1cc(he.startup);return Promise.all([this.vb(J,(0,O.$wg)(J.extensionLocation,le),be),this.gb(J)]).then(ie=>(I.mark(`code/extHost/willActivateExtension/${J.identifier.value}`),ke.hb(this.s,J.identifier,ie[0],ie[1],be))).then(ie=>(I.mark(`code/extHost/didActivateExtension/${J.identifier.value}`),ie))}gb(J){const he=new m.$9cc(J,this.M),de=new m.$8cc(J.identifier.value,!1,this.M),le=new V.$hdc(J,this.N),be=J.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?n.ExtensionMode.Test:n.ExtensionMode.Development:n.ExtensionMode.Production,ie=this.f.remote.isRemote?n.ExtensionKind.Workspace:n.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${J.identifier.value}`),Promise.all([he.whenReady,de.whenReady,this.O.whenReady]).then(()=>{const fe=this;let ne,ce;const pe=(0,t.$lF)(J,"ipc")?this.f.messagePorts?.get(v.$8l.toKey(J.identifier)):void 0;return Object.freeze({globalState:he,workspaceState:de,secrets:le,subscriptions:[],get extensionUri(){return J.extensionLocation},get extensionPath(){return J.extensionLocation.fsPath},asAbsolutePath(Ce){return C.$jc(J.extensionLocation.fsPath,Ce)},get storagePath(){return fe.O.workspaceValue(J)?.fsPath},get globalStoragePath(){return fe.O.globalValue(J).fsPath},get logPath(){return C.$jc(fe.f.logsLocation.fsPath,J.identifier.value)},get logUri(){return d.URI.joinPath(fe.f.logsLocation,J.identifier.value)},get storageUri(){return fe.O.workspaceValue(J)},get globalStorageUri(){return fe.O.globalValue(J)},get extensionMode(){return be},get extension(){return ne===void 0&&(ne=new oe(fe,J.identifier,J,ie,!1)),ne},get extensionRuntime(){return(0,t.$mF)(J,"extensionRuntime"),fe.extensionRuntime},get environmentVariableCollection(){return fe.u.getEnvironmentVariableCollection(J)},get messagePassingProtocol(){if(!ce){if(!pe)return;const Ce=w.Event.buffer(w.Event.fromDOMEventEmitter(pe,"message",L=>L.data));pe.start(),ce={onDidReceiveMessage:Ce,postMessage:pe.postMessage.bind(pe)}}return ce}})})}static hb(J,he,de,le,be){return de=de||{activate:void 0,deactivate:void 0},this.ib(J,he,de,le,be).then(ie=>new b.$2cc(!1,null,be.build(),de,ie,le.subscriptions))}static ib(J,he,de,le,be){if(typeof de.activate=="function")try{be.activateCallStart(),J.trace(`ExtensionService#_callActivateOptional ${he.value}`);const ie=typeof global=="object"?global:self,fe=de.activate.apply(ie,[le]);return be.activateCallStop(),be.activateResolveStart(),Promise.resolve(fe).then(ne=>(be.activateResolveStop(),ne))}catch(ie){return Promise.reject(ie)}else return Promise.resolve(de)}jb(J,he){this.$(J.identifier,{startup:!1,extensionId:J.identifier,activationEvent:he}).then(void 0,de=>{this.s.error(de)})}kb(J,he=0){const le=Date.now();(0,F.$v)(()=>{for(let be=he;be<J.length;be+=1){const ie=J[be];for(const fe of ie.activationEvents??[])if(fe==="onStartupFinished")if(Date.now()-le>50){this.kb(J,be);break}else this.jb(ie,fe)}})}lb(){this.C.$setPerformanceMarks(I.getMarks()),this.m.getConfigProvider().then(J=>{const he=J.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),de=this.J.getAllExtensionDescriptions();if(he)this.kb(de);else for(const le of de)if(le.activationEvents)for(const be of le.activationEvents)be==="onStartupFinished"&&this.jb(le,be)})}mb(){const J=this.Z("*",!0).then(void 0,ie=>{this.s.error(ie)});this.B(this.j.onDidChangeWorkspace(ie=>this.nb(ie.added)));const he=this.j.workspace?this.j.workspace.folders:[],de=this.nb(he),le=this.pb(),be=Promise.all([le,J,de]).then(()=>{});return Promise.race([be,(0,A.$Vg)(1e4)]).then(()=>{this.lb()}),be}nb(J){return J.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(he=>this.ob(J,he))).then(()=>{})}async ob(J,he){if(this.isActivated(he.identifier))return;const de=!this.f.remote.isRemote&&!!this.f.remote.authority,le={logService:this.s,folders:J.map(ie=>ie.uri),forceUsingSearch:de||!this.c.fsExists,exists:ie=>this.c.fsExists(ie.fsPath),checkExists:(ie,fe,ne)=>this.y.$checkExists(ie,fe,ne)},be=await(0,y.$Ulb)(le,he);if(be)return this.$(he.identifier,{startup:!0,extensionId:he.identifier,activationEvent:be.activationEvent}).then(void 0,ie=>this.s.error(ie))}async pb(){if(this.f.remote.authority)return this.Z(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.qb()}catch(J){throw console.error(J),J}}async qb(){const{extensionDevelopmentLocationURI:J,extensionTestsLocationURI:he}=this.f.environment;if(!J||!he)throw new Error(f.localize(0,null));const de=await this.vb(null,he,new b.$1cc(!1));if(!de||typeof de.run!="function")throw new Error(f.localize(1,null,he.toString()));return new Promise((le,be)=>{const ie=(ce,pe)=>{ce?(F.$n&&this.s.error("Test runner called back with error",ce),be(ce)):(F.$n&&(pe?this.s.info(`Test runner called back with ${pe} failures.`):this.s.info("Test runner called back with successful outcome.")),le(typeof pe=="number"&&pe>0?1:0))},fe=(0,O.$kg)(he),ne=de.run(fe,ie);ne&&ne.then&&ne.then(()=>{F.$n&&this.s.info("Test runner finished successfully."),le(0)}).catch(ce=>{F.$n&&this.s.error("Test runner finished with error",ce),be(ce instanceof Error&&ce.stack?ce.stack:String(ce))})})}rb(){if(this.S)throw new Error("Extension host is already started!");return this.S=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,A.$Vg)(1e3)])).then(()=>this.mb()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(J,he){return this.R[J]=he,(0,c.$Qc)(()=>{delete this.R[J]})}async getRemoteExecServer(J){const{resolver:he}=await this.sb(J);return he?.resolveExecServer?.(J,{resolveAttempt:0})}async sb(J){const he=J.indexOf("+");if(he===-1)throw new n.$yK("Not an authority that can be resolved!",r.RemoteAuthorityResolverErrorCode.InvalidAuthority);const de=J.substr(0,he);return await this.D.wait(),await this.Z(`onResolveRemoteAuthority:${de}`,!1),{authorityPrefix:de,resolver:this.R[de]}}async $resolveAuthority(J,he){const de=T.$Kd.create(!1),le=()=>`[resolveAuthority(${(0,r.$Uk)(J)},${he})][${de.elapsed()}ms] `,be=se=>this.s.info(`${le()}${se}`),ie=se=>this.s.warn(`${le()}${se}`),fe=(se,Le=void 0)=>this.s.error(`${le()}${se}`,Le),ne=se=>{if(se instanceof n.$yK)return{type:"error",error:{code:se._code,message:se._message,detail:se._detail}};throw se},ce=async se=>{be(`activating resolver for ${se}...`);const{resolver:Le,authorityPrefix:je}=await this.sb(se);if(!Le)throw fe(`no resolver for ${je}`),new n.$yK(`No remote extension installed to resolve ${je}.`,r.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:Le,authorityPrefix:je,remoteAuthority:se}},pe=J.split(/@|%40/g).reverse();be(`activating remote resolvers ${pe.join(" -> ")}`);let Ce;try{Ce=await Promise.all(pe.map(ce)).catch(async se=>{if(!(se instanceof n.$yK)||se._code!==r.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw se;return ie(`resolving nested authorities failed: ${se.message}`),[await ce(J)]})}catch(se){return ne(se)}const L=new A.$6g;L.cancelAndSet(()=>be("waiting..."),1e3);let K,Y;for(const[se,{authorityPrefix:Le,resolver:je,remoteAuthority:Ye}]of Ce.entries())try{if(se===Ce.length-1)be("invoking final resolve()..."),I.mark(`code/extHost/willResolveAuthority/${Le}`),K=await je.resolve(Ye,{resolveAttempt:he,execServer:Y}),I.mark(`code/extHost/didResolveAuthorityOK/${Le}`),be("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(je,n.$xK.isManagedResolvedAuthority(K)?K:void 0));else{if(be(`invoking resolveExecServer() for ${Ye}`),I.mark(`code/extHost/willResolveExecServer/${Le}`),Y=await je.resolveExecServer?.(Ye,{resolveAttempt:he,execServer:Y}),!Y)throw new n.$yK(`Exec server was not available for ${Ye}`,r.RemoteAuthorityResolverErrorCode.NoResolverFound);I.mark(`code/extHost/didResolveExecServerOK/${Le}`)}}catch(Ke){return I.mark(`code/extHost/didResolveAuthorityError/${Le}`),fe("returned an error",Ke),L.dispose(),ne(Ke)}L.dispose();const X={environmentTunnels:K.environmentTunnels,features:K.tunnelFeatures},H={extensionHostEnv:K.extensionHostEnv,isTrusted:K.isTrusted,authenticationSession:K.authenticationSessionForInitializingExtensions?{id:K.authenticationSessionForInitializingExtensions.id,providerId:K.authenticationSessionForInitializingExtensions.providerId}:void 0};be(`returned ${n.$xK.isManagedResolvedAuthority(K)?"managed authority":`${K.host}:${K.port}`}`);let x;if(n.$xK.isManagedResolvedAuthority(K)){const se=he;this.X.setFactory(se,K.makeConnection),x={authority:J,connectTo:new r.$Rk(se),connectionToken:K.connectionToken}}else x={authority:J,connectTo:new r.$Sk(K.host,K.port),connectionToken:K.connectionToken};return{type:"ok",value:{authority:x,options:H,tunnelInformation:X}}}async $getCanonicalURI(J,he){this.s.info(`$getCanonicalURI invoked for authority (${(0,r.$Uk)(J)})`);const{resolver:de}=await this.sb(J);if(!de)return null;const le=d.URI.revive(he);if(typeof de.getCanonicalURI>"u")return le;const be=await(0,A.$Ng)(()=>de.getCanonicalURI(le));return be||le}$startExtensionHost(J){J.toAdd.forEach(le=>le.extensionLocation=d.URI.revive(le.extensionLocation));const{globalRegistry:he,myExtensions:de}=ve(this.I,this.L,this.J,J);return this.L.set(he.getAllExtensionDescriptions()),this.J.set(de),F.$n&&(this.s.info(`$startExtensionHost: global extensions: ${re(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${re(this.J)}`)),this.rb()}$activateByEvent(J,he){return he===1?this.D.wait().then(de=>this.Z(J,!1)):this.G.wait().then(de=>this.Z(J,!1))}async $activate(J,he){return await this.G.wait(),this.J.getExtensionDescription(J)?(await this.$(J,he),!0):!1}async $deltaExtensions(J){J.toAdd.forEach(ie=>ie.extensionLocation=d.URI.revive(ie.extensionLocation));const{globalRegistry:he,myExtensions:de}=ve(this.I,this.L,this.J,J),le=await this.bb(de);return(await this.getExtensionPathIndex()).setSearchTree(le),this.L.set(he.getAllExtensionDescriptions()),this.J.set(de),F.$n&&(this.s.info(`$deltaExtensions: global extensions: ${re(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${re(this.J)}`)),Promise.resolve(void 0)}async $test_latency(J){return J}async $test_up(J){return J.byteLength}async $test_down(J){const he=D.$ce.alloc(J),de=Math.random()%256;for(let le=0;le<J;le++)he.writeUInt8(de,le);return he}async $updateRemoteConnectionData(J){this.W=J,this.a.fire()}};e.$ndc=Se,e.$ndc=Se=ke=Ge([qe(0,s.$Ph),qe(1,e.$mdc),qe(2,a.$rM),qe(3,g.$Scc),qe(4,u.$Vcc),qe(5,R.$$i),qe(6,o.$HM),qe(7,$.$_cc),qe(8,P.$uwb),qe(9,h.$bdc),qe(10,z.$jdc),qe(11,j.$kdc)],Se);function ve(ue,J,he,de){ue.addActivationEvents(de.addActivationEvents);const le=new i.$V4b(ue,J.getAllExtensionDescriptions());le.deltaExtensions(de.toAdd,de.toRemove);const be=new v.$9l(he.getAllExtensionDescriptions().map(fe=>fe.identifier));for(const fe of de.myToRemove)be.delete(fe);for(const fe of de.myToAdd)be.add(fe);const ie=ye(le,be);return{globalRegistry:le,myExtensions:ie}}function ge(ue,J){return{id:ue.identifier.value,name:ue.name,extensionVersion:ue.version,publisherDisplayName:ue.publisher,activationEvents:ue.activationEvents?ue.activationEvents.join(","):null,isBuiltin:ue.isBuiltin,reason:J.activationEvent,reasonId:J.extensionId.value}}function re(ue){return ue.getAllExtensionDescriptions().map(J=>J.identifier.value).join(",")}e.$odc=(0,s.$Qh)("IExtHostExtensionService");class oe{constructor(J,he,de,le,be){q.set(this,void 0),W.set(this,void 0),we.set(this,void 0),Xe(this,q,J,"f"),Xe(this,W,he,"f"),Xe(this,we,de.identifier,"f"),this.id=de.identifier.value,this.extensionUri=de.extensionLocation,this.extensionPath=C.$hc((0,O.$kg)(de.extensionLocation)),this.packageJSON=de,this.extensionKind=le,this.isFromDifferentExtensionHost=be}get isActive(){return Ne(this,q,"f").isActivated(Ne(this,we,"f"))}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return Ne(this,q,"f").getExtensionExports(Ne(this,we,"f"))}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await Ne(this,q,"f").activateByIdWithErrors(Ne(this,we,"f"),{startup:!1,extensionId:Ne(this,W,"f"),activationEvent:"api"}),this.exports}}e.$pdc=oe,q=new WeakMap,W=new WeakMap,we=new WeakMap;function ye(ue,J){return ue.getAllExtensionDescriptions().filter(he=>J.has(he.identifier))}class De{constructor(J){this.a=J}setSearchTree(J){this.a=J}findSubstr(J){return this.a.findSubstr(J)}forEach(J){return this.a.forEach(J)}}e.$qdc=De;class Q{constructor(J){this.a=new v.$0l,this.addActivationEvents(J)}readActivationEvents(J){return this.a.get(J.identifier)}addActivationEvents(J){for(const he of Object.keys(J))this.a.set(he,J[he])}}}),define(Ae[273],Re([1,0,87,2,3,34,22,21,17,27,4,35,14,16]),function(ee,e,f,C,I,O,A,c,E,d,R,S,u,b){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.$Oec=void 0;let g=class{constructor(D,m,n,r,s,o,$){this.c=D,this.d=m,this.f=n,this.g=r,this.h=s,this.i=o,this.j=$,this.a=new Map,this.b=[]}async install(){this.k(),f.mark("code/extHost/willWaitForConfig");const D=await this.g.getConfigProvider();f.mark("code/extHost/didWaitForConfig");const m=await this.h.getExtensionPathIndex();this.register(new i(this.c,m,this.d,D,this.j)),this.register(this.f.createInstance(t)),this.i.remote.isRemote&&this.register(this.f.createInstance(l,m,this.i.environment.appUriScheme))}register(D){if("nodeModuleName"in D)if(Array.isArray(D.nodeModuleName))for(const m of D.nodeModuleName)this.a.set(m,D);else this.a.set(D.nodeModuleName,D);typeof D.alternativeModuleName=="function"&&this.b.push(m=>D.alternativeModuleName(m))}};e.$Oec=g,e.$Oec=g=Ge([qe(2,R.$Ph),qe(3,O.$Vcc),qe(4,S.$odc),qe(5,d.$HM),qe(6,u.$$i)],g);let t=p=class{constructor(D){if(D.environment.appRoot&&p.a.size){const m=(0,b.$Ge)(this.c(D.environment.appRoot.fsPath)),n="[a-z0-9_.-]",r=`@${n}+\\/${n}+|${n}+`,s="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${m}/${s}\\/)(${r})(.*)$`,"i")}}alternativeModuleName(D){if(!this.b)return;const m=this.b.exec(this.c(D));if(!m)return;const[,n,r,s]=m,o=p.a.get(r);if(o!==void 0)return console.warn(`${r} as been renamed to ${o}, please update your imports`),n+o+s}c(D){return D.replace(/\\/g,"/")}};t.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]]),t=p=Ge([qe(0,d.$HM)],t);class i{constructor(D,m,n,r,s){this.c=D,this.d=m,this.e=n,this.f=r,this.g=s,this.nodeModuleName="vscode",this.a=new c.$0l}load(D,m){const n=this.d.findSubstr(m);if(n){let r=this.a.get(n.identifier);return r||(r=this.c(n,this.e,this.f),this.a.set(n.identifier,r)),r}if(!this.b){let r="";this.d.forEach((s,o)=>r+=`	${o} -> ${s.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${m}. These are the extension path mappings: 
${r}`),this.b=this.c(A.$gF,this.e,this.f)}return this.b}}let l=class{constructor(D,m,n){this.e=D,this.f=m,this.nodeModuleName=["open","opn"],this.d=n.getProxy(I.$qK.MainThreadTelemetry);const r=n.getProxy(I.$qK.MainThreadWindow);this.c=(s,o)=>{const $=C.URI.parse(s);return o?this.g(s,o):$.scheme==="http"||$.scheme==="https"?r.$openUri($,s,{allowTunneling:!0}):$.scheme==="mailto"||$.scheme===this.f?r.$openUri($,s,{}):this.g(s,o)}}load(D,m,n){const r=this.e.findSubstr(m);return r&&(this.a=r.identifier.value,this.h()),this.b=n(D),this.c}g(D,m){return this.i(),this.b(D,m)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};l=Ge([qe(2,E.$rM)],l)}),define(Ae[112],Re([1,0,42,6,20,73,4,60,61,35,7,33,202,34]),function(ee,e,f,C,I,O,A,c,E,d,R,S,u,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xdc=e.$Wdc=void 0,e.$Wdc=(0,A.$Qh)("IExtHostVariableResolverProvider");class p extends u.$sN{constructor(i,l,v,D,m,n,r){function s(){if(v){const o=v.activeEditor();if(o)return o.document.uri;const $=D.tabGroups.all.find(a=>a.isActive)?.activeTab;if($!==void 0){if($.input instanceof R.$$L||$.input instanceof R.$dM)return $.input.modified;if($.input instanceof R.$0L||$.input instanceof R.$cM||$.input instanceof R.$aM)return $.input.uri}}}super({getFolderUri:o=>{const $=n.folders.filter(a=>a.name===o);if($&&$.length>0)return $[0].uri},getWorkspaceFolderCount:()=>n.folders.length,getConfigurationValue:(o,$)=>m.getConfiguration(void 0,o).get($),getAppRoot:()=>O.cwd(),getExecPath:()=>O.env.VSCODE_EXEC_PATH,getFilePath:()=>{const o=s();if(o)return I.$hc(o.fsPath)},getWorkspaceFolderPathForFile:()=>{if(l){const o=s();if(o){const $=l.getWorkspaceFolder(o);if($)return I.$hc($.uri.fsPath)}}},getSelectedText:()=>{if(v){const o=v.activeEditor();if(o&&!o.selection.isEmpty)return o.document.getText(o.selection)}},getLineNumber:()=>{if(v){const o=v.activeEditor();if(o)return String(o.selection.end.line+1)}},getExtension:o=>i.getExtension(o)},void 0,r?Promise.resolve(r):void 0,Promise.resolve(O.env))}}let g=class extends C.$Sc{constructor(i,l,v,D,m){super(),this.b=i,this.c=l,this.g=v,this.h=D,this.j=m,this.a=new f.$V(async()=>{const n=await this.h.getConfigProvider(),s={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async o=>{s.folders=await this.c.getWorkspaceFolders2()||[]})),new p(this.b,this.c,this.g,this.j,n,s,this.m())})}getResolver(){return this.a.value}m(){}};e.$Xdc=g,e.$Xdc=g=Ge([qe(0,d.$odc),qe(1,S.$Scc),qe(2,c.$CM),qe(3,b.$Vcc),qe(4,E.$Udc)],g)}),define(Ae[113],Re([1,0,12,5,2,4,3,61,35,17,7,33,195,197,34,112]),function(ee,e,f,C,I,O,A,c,E,d,R,S,u,b,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3dc=e.$2dc=e.$1dc=e.$Zdc=e.$Ydc=void 0,e.$Ydc=(0,O.$Qh)("IExtHostDebugService");let t=class{get onDidStartDebugSession(){return this.m.event}get onDidTerminateDebugSession(){return this.n.event}get onDidChangeActiveDebugSession(){return this.o.event}get activeDebugSession(){return this.q}get onDidReceiveDebugSessionCustomEvent(){return this.u.event}get activeDebugConsole(){return this.v.value}constructor(r,s,o,$,a,k){this.E=s,this.F=o,this.G=$,this.H=a,this.I=k,this.l=new Map,this.d=0,this.f=[],this.g=0,this.h=[],this.i=0,this.j=[],this.B=new Map,this.C=new Map,this.m=new C.$Od,this.n=new C.$Od,this.o=new C.$Od,this.u=new C.$Od,this.k=r.getProxy(A.$qK.MainThreadDebugService),this.y=new C.$Od,this.A=new C.$Od,this.v=new l(this.k),this.w=new Map,this.F.getExtensionRegistry().then(P=>{P.onDidChange(h=>{this.J(P)}),this.J(P)})}asDebugSourceUri(r,s){const o=r;if(typeof o.sourceReference=="number"&&o.sourceReference>0){let $=`debug:${encodeURIComponent(o.path||"")}`,a="?";return s&&($+=`${a}session=${encodeURIComponent(s.id)}`,a="&"),$+=`${a}ref=${o.sourceReference}`,I.URI.parse($)}else{if(o.path)return I.URI.file(o.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}J(r){const s=[];for(const o of r.getAllExtensionDescriptions())if(o.contributes){const $=o.contributes.debuggers;if($&&$.length>0)for(const a of $)(0,b.$AF)(a)&&s.push(a.type)}this.k.$registerDebugTypes(s)}get stackFrameFocus(){return this.z}get onDidChangeStackFrameFocus(){return this.A.event}get onDidChangeBreakpoints(){return this.y.event}get breakpoints(){const r=[];return this.w.forEach(s=>r.push(s)),r}addBreakpoints(r){const s=r.filter(a=>{const k=a.id;return this.w.has(k)?!1:(this.w.set(k,a),!0)});this.U(s,[],[]);const o=[],$=new Map;for(const a of s)if(a instanceof R.$rL){let k=$.get(a.location.uri.toString());k||(k={type:"sourceMulti",uri:a.location.uri,lines:[]},$.set(a.location.uri.toString(),k),o.push(k)),k.lines.push({id:a.id,enabled:a.enabled,condition:a.condition,hitCondition:a.hitCondition,logMessage:a.logMessage,line:a.location.range.start.line,character:a.location.range.start.character})}else a instanceof R.$sL&&o.push({type:"function",id:a.id,enabled:a.enabled,hitCondition:a.hitCondition,logMessage:a.logMessage,condition:a.condition,functionName:a.functionName});return this.k.$registerBreakpoints(o)}removeBreakpoints(r){const s=r.filter(k=>this.w.delete(k.id));this.U([],s,[]);const o=s.filter(k=>k instanceof R.$rL).map(k=>k.id),$=s.filter(k=>k instanceof R.$sL).map(k=>k.id),a=s.filter(k=>k instanceof R.$tL).map(k=>k.id);return this.k.$unregisterBreakpoints(o,$,a)}startDebugging(r,s,o){return this.k.$startDebugging(r?r.uri:void 0,s,{parentSessionID:o.parentSession?o.parentSession.id:void 0,lifecycleManagedByParent:o.lifecycleManagedByParent,repl:o.consoleMode===R.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:o.noDebug,compact:o.compact,suppressSaveBeforeStart:o.suppressSaveBeforeStart,suppressDebugStatusbar:o.suppressDebugStatusbar??o.debugUI?.simple,suppressDebugToolbar:o.suppressDebugToolbar??o.debugUI?.simple,suppressDebugView:o.suppressDebugView??o.debugUI?.simple})}stopDebugging(r){return this.k.$stopDebugging(r?r.id:void 0)}registerDebugConfigurationProvider(r,s,o){if(!s)return new R.$sK(()=>{});const $=this.d++;return this.f.push({type:r,handle:$,provider:s}),this.k.$registerDebugConfigurationProvider(r,o,!!s.provideDebugConfigurations,!!s.resolveDebugConfiguration,!!s.resolveDebugConfigurationWithSubstitutedVariables,$),new R.$sK(()=>{this.f=this.f.filter(a=>a.provider!==s),this.k.$unregisterDebugConfigurationProvider($)})}registerDebugAdapterDescriptorFactory(r,s,o){if(!o)return new R.$sK(()=>{});if(!this.Q(r,s))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${s}' debugger.`);if(this.N(s))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const $=this.g++;return this.h.push({type:s,handle:$,factory:o}),this.k.$registerDebugAdapterDescriptorFactory(s,$),new R.$sK(()=>{this.h=this.h.filter(a=>a.factory!==o),this.k.$unregisterDebugAdapterDescriptorFactory($)})}registerDebugAdapterTrackerFactory(r,s){if(!s)return new R.$sK(()=>{});const o=this.i++;return this.j.push({type:r,handle:o,factory:s}),new R.$sK(()=>{this.j=this.j.filter($=>$.factory!==s)})}async $runInTerminal(r,s){return Promise.resolve(void 0)}async $substituteVariables(r,s){let o;const $=await this.W(r);return $&&(o={uri:$.uri,name:$.name,index:$.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.I.getResolver()).resolveAnyAsync(o,s)}K(r,s){if(r.type==="implementation")return new D(r.implementation)}L(){}async $startDASession(r,s){const o=this,$=await this.V(s);return this.S(this.N($.type),$).then(a=>{if(!a)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${$.type}' (extension might have failed to activate)`);const k=this.M(a),P=this.K(k,$);if(!P)throw new Error(`Couldn't create a debug adapter for type '${$.type}'.`);const h=P;return this.B.set(r,h),this.R($).then(w=>(w&&this.C.set(r,w),h.onMessage(async y=>{if(y.type==="request"&&y.command==="handshake"){const M=y,V={type:"response",seq:0,command:M.command,request_seq:M.seq,success:!0};this.D||(this.D=this.L());try{if(this.D){const B=await this.D.sign(M.arguments.value);V.body={signature:B},h.sendResponse(V)}else throw new Error("no signer")}catch(B){V.success=!1,V.message=B.message,h.sendResponse(V)}}else w&&w.onDidSendMessage&&w.onDidSendMessage(y),y=(0,b.$FF)(y,!0),o.k.$acceptDAMessage(r,y)}),h.onError(y=>{w&&w.onError&&w.onError(y),this.k.$acceptDAError(r,y.name,y.message,y.stack)}),h.onExit(y=>{w&&w.onExit&&w.onExit(y??void 0,void 0),this.k.$acceptDAExit(r,y??void 0,void 0)}),w&&w.onWillStartSession&&w.onWillStartSession(),h.startSession()))})}$sendDAMessage(r,s){s=(0,b.$EF)(s,!1);const o=this.C.get(r);o&&o.onWillReceiveMessage&&o.onWillReceiveMessage(s),this.B.get(r)?.sendMessage(s)}$stopDASession(r){const s=this.C.get(r);this.C.delete(r),s&&s.onWillStopSession&&s.onWillStopSession();const o=this.B.get(r);return this.B.delete(r),o?o.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(r){const s=[],o=[],$=[];if(r.added)for(const a of r.added){const k=a.id;if(k&&!this.w.has(k)){let P;if(a.type==="function")P=new R.$sL(a.functionName,a.enabled,a.condition,a.hitCondition,a.logMessage);else if(a.type==="data")P=new R.$tL(a.label,a.dataId,a.canPersist,a.enabled,a.hitCondition,a.condition,a.logMessage);else{const h=I.URI.revive(a.uri);P=new R.$rL(new R.$EK(h,new R.$tK(a.line,a.character)),a.enabled,a.condition,a.hitCondition,a.logMessage)}(0,R.$pL)(P,k),this.w.set(k,P),s.push(P)}}if(r.removed)for(const a of r.removed){const k=this.w.get(a);k&&(this.w.delete(a),o.push(k))}if(r.changed){for(const a of r.changed)if(a.id){const k=this.w.get(a.id);if(k){if(k instanceof R.$sL&&a.type==="function"){const P=k;P.enabled=a.enabled,P.condition=a.condition,P.hitCondition=a.hitCondition,P.logMessage=a.logMessage,P.functionName=a.functionName}else if(k instanceof R.$rL&&a.type==="source"){const P=k;P.enabled=a.enabled,P.condition=a.condition,P.hitCondition=a.hitCondition,P.logMessage=a.logMessage,P.location=new R.$EK(I.URI.revive(a.uri),new R.$tK(a.line,a.character))}$.push(k)}}}this.U(s,o,$)}async $acceptStackFrameFocus(r){let s;const o=r.sessionId?await this.V(r.sessionId):void 0;if(!o)throw new Error("no DebugSession found for debug focus context");r.kind==="thread"?s=new R.$zL(o,r.threadId):s=new R.$yL(o,r.threadId,r.frameId),this.z=s,this.A.fire(this.z)}$provideDebugConfigurations(r,s,o){return(0,f.$Ng)(async()=>{const $=this.P(r);if(!$)throw new Error("no DebugConfigurationProvider found");if(!$.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const a=await this.W(s);return $.provideDebugConfigurations(a,o)}).then($=>{if(!$)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return $})}$resolveDebugConfiguration(r,s,o,$){return(0,f.$Ng)(async()=>{const a=this.P(r);if(!a)throw new Error("no DebugConfigurationProvider found");if(!a.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const k=await this.W(s);return a.resolveDebugConfiguration(k,o,$)})}$resolveDebugConfigurationWithSubstitutedVariables(r,s,o,$){return(0,f.$Ng)(async()=>{const a=this.P(r);if(!a)throw new Error("no DebugConfigurationProvider found");if(!a.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const k=await this.W(s);return a.resolveDebugConfigurationWithSubstitutedVariables(k,o,$)})}async $provideDebugAdapter(r,s){const o=this.O(r);if(!o)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const $=await this.V(s);return this.S(o,$).then(a=>{if(!a)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${$.type}'`);return this.M(a)})}async $acceptDebugSessionStarted(r){const s=await this.V(r);this.m.fire(s)}async $acceptDebugSessionTerminated(r){const s=await this.V(r);s&&(this.n.fire(s),this.l.delete(s.id))}async $acceptDebugSessionActiveChanged(r){this.q=r?await this.V(r):void 0,this.o.fire(this.q)}async $acceptDebugSessionNameChanged(r,s){(await this.V(r))?._acceptNameChanged(s)}async $acceptDebugSessionCustomEvent(r,s){const $={session:await this.V(r),event:s.event,body:s.body};this.u.fire($)}M(r){if(r instanceof R.$uL)return{type:"executable",command:r.command,args:r.args,options:r.options};if(r instanceof R.$vL)return{type:"server",port:r.port,host:r.host};if(r instanceof R.$wL)return{type:"pipeServer",path:r.path};if(r instanceof R.$xL)return{type:"implementation",implementation:r.implementation};throw new Error("convertToDto unexpected type")}N(r){const s=this.h.filter(o=>o.type===r);if(s.length>0)return s[0].factory}O(r){const s=this.h.filter(o=>o.handle===r);if(s.length>0)return s[0].factory}P(r){const s=this.f.filter(o=>o.handle===r);if(s.length>0)return s[0].provider}Q(r,s){if(r.contributes){const o=r.contributes.debuggers;if(o&&o.length>0){for(const $ of o)if($.label&&$.type&&$.type===s)return!0}}return!1}R(r){const o=r.configuration.type,$=this.j.filter(a=>a.type===o||a.type==="*").map(a=>(0,f.$Ng)(()=>a.factory.createDebugAdapterTracker(r)).then(k=>k,k=>null));return Promise.race([Promise.all($).then(a=>{const k=a.filter(P=>!!P);if(k.length>0)return new v(k)}),new Promise(a=>setTimeout(()=>a(void 0),1e3))]).catch(a=>{})}async S(r,s){const o=s.configuration.debugServer;if(typeof o=="number")return Promise.resolve(new R.$vL(o));if(r){const a=await this.F.getExtensionRegistry();return(0,f.$Ng)(()=>r.createDebugAdapterDescriptor(s,this.T(s,a))).then(k=>{if(k)return k})}const $=await this.F.getExtensionRegistry();return Promise.resolve(this.T(s,$))}T(r,s){}U(r,s,o){(r.length>0||s.length>0||o.length>0)&&this.y.fire(Object.freeze({added:r,removed:s,changed:o}))}async V(r){if(r)if(typeof r=="string"){const s=this.l.get(r);if(s)return s}else{let s=this.l.get(r.id);if(!s){const o=await this.W(r.folderUri),$=r.parent?this.l.get(r.parent):void 0;s=new i(this.k,r.id,r.type,r.name,o,r.configuration,$),this.l.set(s.id,s),this.k.$sessionCached(s.id)}return s}throw new Error("cannot find session")}W(r){if(r){const s=I.URI.revive(r);return this.E.resolveWorkspaceFolder(s)}return Promise.resolve(void 0)}};e.$Zdc=t,e.$Zdc=t=Ge([qe(0,d.$rM),qe(1,S.$Scc),qe(2,E.$odc),qe(3,p.$Vcc),qe(4,c.$Udc),qe(5,g.$Wdc)],t);class i{constructor(r,s,o,$,a,k,P){this.d=r,this.f=s,this.g=o,this.h=$,this.i=a,this.j=k,this.k=P}get id(){return this.f}get type(){return this.g}get name(){return this.h}set name(r){this.h=r,this.d.$setDebugSessionName(this.f,r)}get parentSession(){return this.k}_acceptNameChanged(r){this.h=r}get workspaceFolder(){return this.i}get configuration(){return this.j}customRequest(r,s){return this.d.$customDebugAdapterRequest(this.f,r,s)}getDebugProtocolBreakpoint(r){return this.d.$getDebugProtocolBreakpoint(this.f,r.id)}}e.$1dc=i;class l{constructor(r){this.value=Object.freeze({append(s){r.$appendDebugConsole(s)},appendLine(s){this.append(s+`
`)}})}}e.$2dc=l;class v{constructor(r){this.d=r}onWillStartSession(){this.d.forEach(r=>r.onWillStartSession?r.onWillStartSession():void 0)}onWillReceiveMessage(r){this.d.forEach(s=>s.onWillReceiveMessage?s.onWillReceiveMessage(r):void 0)}onDidSendMessage(r){this.d.forEach(s=>s.onDidSendMessage?s.onDidSendMessage(r):void 0)}onWillStopSession(){this.d.forEach(r=>r.onWillStopSession?r.onWillStopSession():void 0)}onError(r){this.d.forEach(s=>s.onError?s.onError(r):void 0)}onExit(r,s){this.d.forEach(o=>o.onExit?o.onExit(r,s):void 0)}}class D extends u.$ldb{constructor(r){super(),this.h=r,r.onDidSendMessage(s=>{this.acceptMessage(s)})}startSession(){return Promise.resolve(void 0)}sendMessage(r){this.h.handleMessage(r)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let m=class extends t{constructor(r,s,o,$,a,k){super(r,s,o,$,a,k)}};e.$3dc=m,e.$3dc=m=Ge([qe(0,d.$rM),qe(1,S.$Scc),qe(2,E.$odc),qe(3,p.$Vcc),qe(4,c.$Udc),qe(5,g.$Wdc)],m)}),define(Ae[274],Re([1,0,11,87,2,3,265,14,70,71,27,173,17,57,35,59]),function(ee,e,f,C,I,O,A,c,E,d,R,S,u,b,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qec=e.$Pec=void 0;class t{static async installEarlyHandler(v){Error.stackTraceLimit=100;const D=v.get(c.$$i),n=v.get(u.$rM).getProxy(O.$qK.MainThreadErrors);f.setUnexpectedErrorHandler(r=>{D.error(r);const s=f.$3(r);n.$onUnexpectedError(s)})}static async installFullHandler(v){const D=v.get(c.$$i),m=v.get(u.$rM),n=v.get(p.$odc),r=v.get(g.$LM),s=m.getProxy(O.$qK.MainThreadExtensionService),o=m.getProxy(O.$qK.MainThreadErrors),$=await n.getExtensionPathIndex(),a=new WeakMap;function k(w,y){if(a.has(w))return a.get(w).stack;let M="",V,B;for(const T of y)M+=`
	at ${T.toString()}`,B=T.getFileName(),!V&&B&&(V=$.findSubstr(I.URI.file(B)));const z=`${w.name||"Error"}: ${w.message||""}${M}`;return a.set(w,{extensionIdentifier:V?.identifier,stack:z}),z}const P=Symbol("prepareStackTrace wrapped");let h=k;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return h},set(w){if(w===k||!w||w[P]){h=w||k;return}h=function(y,M){return k(y,M),w.call(Error,y,M)},Object.assign(h,{[P]:!0})}}),f.setUnexpectedErrorHandler(w=>{D.error(w);const y=f.$3(w),M=a.get(w);if(!M?.extensionIdentifier){o.$onUnexpectedError(y);return}s.$onExtensionRuntimeError(M.extensionIdentifier,y);const V=r.onExtensionError(M.extensionIdentifier,w);D.trace("forwarded error to extension?",V,M)})}}e.$Pec=t;class i{constructor(v,D,m,n,r){this.a=m,this.b=new A.$54b(v,null,n),D=i.e(D,this.b);const s=new d.$Oh(...(0,E.$Cr)());s.set(R.$HM,{_serviceBrand:void 0,...D,messagePorts:r}),s.set(u.$rM,new u.$sM(this.b)),s.set(b.$Pcc,new b.$Qcc(n)),s.set(p.$mdc,m);const o=new S.$iq(s,!0);o.invokeFunction(t.installEarlyHandler),this.d=o.invokeFunction($=>$.get(c.$$i)),C.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",D),this.c=o.invokeFunction($=>$.get(p.$odc)),this.c.initialize(),o.invokeFunction(t.installFullHandler)}async asBrowserUri(v){const D=this.b.getProxy(O.$qK.MainThreadExtensionService);return I.URI.revive(await D.$asBrowserUri(v))}terminate(v){this.c.terminate(v)}static e(v,D){v.extensions.allExtensions.forEach(n=>{n.extensionLocation=I.URI.revive(D.transformIncomingURIs(n.extensionLocation))}),v.environment.appRoot=I.URI.revive(D.transformIncomingURIs(v.environment.appRoot));const m=v.environment.extensionDevelopmentLocationURI;return m&&(v.environment.extensionDevelopmentLocationURI=m.map(n=>I.URI.revive(D.transformIncomingURIs(n)))),v.environment.extensionTestsLocationURI=I.URI.revive(D.transformIncomingURIs(v.environment.extensionTestsLocationURI)),v.environment.globalStorageHome=I.URI.revive(D.transformIncomingURIs(v.environment.globalStorageHome)),v.environment.workspaceStorageHome=I.URI.revive(D.transformIncomingURIs(v.environment.workspaceStorageHome)),v.environment.extensionTelemetryLogResource=I.URI.revive(D.transformIncomingURIs(v.environment.extensionTelemetryLogResource)),v.nlsBaseUrl=I.URI.revive(D.transformIncomingURIs(v.nlsBaseUrl)),v.logsLocation=I.URI.revive(D.transformIncomingURIs(v.logsLocation)),v.workspace=D.transformIncomingURIs(v.workspace),v}}e.$Qec=i}),define(Ae[275],Re([1,0,18,12,19,38,13,20,24,2,49]),function(ee,e,f,C,I,O,A,c,E,d,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8dc=e.$7dc=e.$6dc=e.$5dc=void 0;class S{constructor(l,v,D,m){this.d=l,this.e=v,this.f=D,this.g=m,this.a=null,this.b=!1,this.c=0}search(l,v){const D=this.d.folderQueries||[],m=new I.$Yd(v);return new Promise((n,r)=>{this.a=new b(l);let s=!1;const o=($,a)=>{if(!s&&!this.b){const k=this.h($);g($)&&typeof this.d.maxResults=="number"&&this.c+k>this.d.maxResults&&(this.b=!0,s=!0,m.cancel(),$=this.j($,this.d.maxResults-this.c));const P=this.h($);this.c+=P,(P>0||!g($))&&this.a.add($,a)}};Promise.all(D.map(($,a)=>this.k($,k=>o(k,a),m.token))).then($=>{m.dispose(),this.a.flush();const a=$.some(k=>!!k&&!!k.limitHit);n({limitHit:this.b||a,messages:(0,f.$Rb)($.map(k=>k?.message?Array.isArray(k.message)?k.message:[k.message]:[])),stats:{type:this.g}})},$=>{m.dispose();const a=(0,O.$Bi)($);r(new Error(a))})})}h(l){return g(l)?Array.isArray(l.ranges)?l.ranges.length:1:0}j(l,v){const D=Array.isArray(l.ranges)?l.ranges:[l.ranges],m=Array.isArray(l.preview.matches)?l.preview.matches:[l.preview.matches];return{ranges:D.slice(0,v),preview:{matches:m.slice(0,v),text:l.preview.text},uri:l.uri}}async k(l,v,D){const m=new R.$$I(this.d,l),n=[],r={report:$=>{if(!this.l($))return;const a=l.folder.scheme===A.Schemas.file?(0,R.$_I)(()=>this.f.readdir(E.$vg($.uri))):void 0,k=E.$yg(l.folder,$.uri);if(k){const P=m.includedInQuery(k,c.$nc(k),a);(0,C.$Hg)(P)?n.push(P.then(h=>{h&&v($)})):P&&v($)}}},s=this.n(l),o=await this.e.provideTextSearchResults(u(this.d.contentPattern),s,r,D);return n.length&&await Promise.all(n),o}l(l){if(g(l)){if(Array.isArray(l.ranges)){if(!Array.isArray(l.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(l.preview.matches.length!==l.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(l.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(l){const v=(0,R.$0I)(this.d.includePattern,l.includePattern),D=(0,R.$0I)(this.d.excludePattern,l.excludePattern),m={folder:d.URI.from(l.folder),excludes:D,includes:v,useIgnoreFiles:!l.disregardIgnoreFiles,useGlobalIgnoreFiles:!l.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!l.disregardParentIgnoreFiles,followSymlinks:!l.ignoreSymlinks,encoding:l.fileEncoding&&this.f.toCanonicalName(l.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return m.usePCRE2=this.d.usePCRE2,m}}e.$5dc=S;function u(i){return{isCaseSensitive:i.isCaseSensitive||!1,isRegExp:i.isRegExp||!1,isWordMatch:i.isWordMatch||!1,isMultiline:i.isMultiline||!1,pattern:i.pattern}}class b{constructor(l){this.e=l,this.b=-1,this.d=null,this.a=new t(512,v=>this.g(v))}add(l,v){this.d&&(this.b!==v||!E.$pg(this.c,l.uri))&&(this.f(),this.d=null),this.d||(this.b=v,this.d={resource:l.uri,results:[]}),this.d.results.push(p(l))}f(){const l=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,l)}flush(){this.f(),this.a.flush()}g(l){this.e(l)}}e.$6dc=b;function p(i){return g(i)?{preview:{matches:(0,f.$2b)(i.preview.matches,l=>({startLineNumber:l.start.line,startColumn:l.start.character,endLineNumber:l.end.line,endColumn:l.end.character})),text:i.preview.text},ranges:(0,f.$2b)(i.ranges,l=>({startLineNumber:l.start.line,startColumn:l.start.character,endLineNumber:l.end.line,endColumn:l.end.character}))}:{text:i.text,lineNumber:i.lineNumber}}function g(i){return!!i.preview}e.$7dc=g;class t{constructor(l,v){this.g=l,this.h=v,this.c=0,this.d=[],this.e=0}addItem(l,v){l&&this.j(l,v)}addItems(l,v){l&&this.k(l,v)}j(l,v){this.d.push(l),this.e+=v,this.l()}k(l,v){this.d=this.d.concat(l),this.e+=v,this.l()}l(){this.c<t.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},t.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$8dc=t,t.a=4e3,t.b=50}),define(Ae[114],Re([1,0,6,3,4,270,17,57,14,2,275]),function(ee,e,f,C,I,O,A,c,E,d,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$dc=e.$0dc=e.$9dc=void 0,e.$9dc=(0,I.$Qh)("IExtHostSearch");let S=class{constructor(g,t,i){this.k=g,this.l=t,this.n=i,this.c=this.k.getProxy(C.$qK.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new O.$4dc}o(g){return this.l.transformOutgoingScheme(g)}registerTextSearchProvider(g,t){if(this.g.has(g))throw new Error(`a text search provider for the scheme '${g}' is already registered`);this.g.add(g);const i=this.d++;return this.e.set(i,t),this.c.$registerTextSearchProvider(i,this.o(g)),(0,f.$Qc)(()=>{this.g.delete(g),this.e.delete(i),this.c.$unregisterProvider(i)})}registerFileSearchProvider(g,t){if(this.i.has(g))throw new Error(`a file search provider for the scheme '${g}' is already registered`);this.i.add(g);const i=this.d++;return this.h.set(i,t),this.c.$registerFileSearchProvider(i,this.o(g)),(0,f.$Qc)(()=>{this.i.delete(g),this.h.delete(i),this.c.$unregisterProvider(i)})}$provideFileSearchResults(g,t,i,l){const v=u(i),D=this.h.get(g);if(D)return this.j.fileSearch(v,D,m=>{this.c.$handleFileMatch(g,t,m.map(n=>n.resource))},l);throw new Error("unknown provider: "+g)}$clearCache(g){return this.j.clearCache(g),Promise.resolve(void 0)}$provideTextSearchResults(g,t,i,l){const v=this.e.get(g);if(!v||!v.provideTextSearchResults)throw new Error(`Unknown provider ${g}`);const D=u(i);return this.q(D,v).search(n=>this.c.$handleTextMatch(g,t,n),l)}$enableExtensionHostSearch(){}q(g,t){return new R.$5dc(g,t,{readdir:i=>Promise.resolve([]),toCanonicalName:i=>i},"textSearchProvider")}};e.$0dc=S,e.$0dc=S=Ge([qe(0,A.$rM),qe(1,c.$Pcc),qe(2,E.$$i)],S);function u(p){return{...p,folderQueries:p.folderQueries&&p.folderQueries.map(b),extraFileResources:p.extraFileResources&&p.extraFileResources.map(g=>d.URI.revive(g))}}e.$$dc=u;function b(p){return{...p,folder:d.URI.revive(p.folder)}}}),define(Ae[276],Re([1,0,19,11,5,29,2,135,287,127,126,39,3,78,227,226,31,228,34,230,231,232,207,233,60,35,236,237,242,243,245,109,211,251,252,255,84,63,257,212,8,7,55,260,64,108,33,21,200,241,54,107,111,113,114,14,57,17,27,246,198,86,80,219,258,85,62,263,261,262,220,40,256,259,83,61,59,247,110,248,13,95,210,190,239,6,22,196,81,186,249,250,221,238,209,240,82,253,224,254,225,218,235,222,223]),function(ee,e,f,C,I,O,A,c,E,d,R,S,u,b,p,g,t,i,l,v,D,m,n,r,s,o,$,a,k,P,h,w,y,M,V,B,z,T,F,j,q,W,we,ke,Se,ve,ge,re,oe,ye,De,Q,ue,J,he,de,le,be,ie,fe,ne,ce,pe,Ce,L,K,Y,X,H,x,se,Le,je,Ye,Ke,tt,xe,et,rt,nt,Ue,lt,_,Z,Ee,We,ze,Ze,st,vt,yt,Mt,Vt,qt,Et,Lt,Ot,xt,Yt,It,Nt,Qt,zt,Kt,Ht){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kec=void 0;function Ct(ct){const ht=ct.get(ie.$HM),Pt=ct.get(Le.$Fcc),Tt=ct.get(Y.$$cc),Ft=ct.get(o.$odc),ut=ct.get(ge.$Scc),Dt=ct.get(xe.$LM),Ut=ct.get(l.$Vcc),jt=ct.get(le.$Pcc),Ve=ct.get(be.$rM),Jt=ct.get(z.$7cc),Pe=ct.get(K.$_cc),Fe=ct.get(de.$_i),$e=ct.get(de.$$i),G=ct.get(ce.$uwb),Me=ct.get(pe.$Icc),Be=ct.get(ve.$Mdc),Je=ct.get(Ke.$gdc),He=ct.get(tt.$Udc),it=ct.get(Ot.$kdc);Ve.set(u.$rK.ExtHostFileSystemInfo,Pt),Ve.set(u.$rK.ExtHostLogLevelServiceShape,Fe),Ve.set(u.$rK.ExtHostWorkspace,ut),Ve.set(u.$rK.ExtHostConfiguration,Ut),Ve.set(u.$rK.ExtHostExtensionService,Ft),Ve.set(u.$rK.ExtHostStorage,Jt),Ve.set(u.$rK.ExtHostTunnelService,G),Ve.set(u.$rK.ExtHostWindow,Be),Ve.set(u.$rK.ExtHostSecretState,Je),Ve.set(u.$rK.ExtHostTelemetry,Dt),Ve.set(u.$rK.ExtHostEditorTabs,He),Ve.set(u.$rK.ExtHostManagedSockets,it);const St=Ve.set(u.$rK.ExtHostDecorations,ct.get(Q.$Qdc)),bt=Ve.set(u.$rK.ExtHostDocumentsAndEditors,ct.get(s.$CM)),$t=Ve.set(u.$rK.ExtHostCommands,ct.get(t.$NM)),gt=Ve.set(u.$rK.ExtHostTerminalService,ct.get(T.$bdc)),mt=Ve.set(u.$rK.ExtHostDebugService,ct.get(J.$Ydc)),ci=Ve.set(u.$rK.ExtHostSearch,ct.get(he.$9dc)),Gt=Ve.set(u.$rK.ExtHostTask,ct.get(ue.$Tdc)),wi=Ve.set(u.$rK.ExtHostOutputService,ct.get(w.$wdc)),hi=Ve.set(u.$rK.ExtHostLocalization,ct.get(st.$jdc)),Ji=Ve.set(u.$rK.ExtHostUrls,new ke.$Fdc(Ve)),At=Ve.set(u.$rK.ExtHostDocuments,new r.$Dcc(Ve,bt)),Pi=Ve.set(u.$rK.ExtHostDocumentContentProviders,new m.$Xcc(Ve,bt,$e)),Ai=Ve.set(u.$rK.ExtHostDocumentSaveParticipant,new n.$Ycc($e,At,Ve.getProxy(u.$qK.MainThreadBulkEdits))),kt=Ve.set(u.$rK.ExtHostNotebook,new fe.$cec(Ve,$t,bt,At,Tt)),Zt=Ve.set(u.$rK.ExtHostNotebookDocuments,new Z.$uec(kt)),bi=Ve.set(u.$rK.ExtHostNotebookEditors,new _.$tec($e,kt)),fi=Ve.set(u.$rK.ExtHostNotebookKernels,new et.$qec(Ve,ht,kt,$t,$e)),Ri=Ve.set(u.$rK.ExtHostNotebookRenderers,new nt.$sec(Ve,kt)),Yi=Ve.set(u.$rK.ExtHostNotebookDocumentSaveParticipant,new Et.$Aec($e,kt,Ve.getProxy(u.$qK.MainThreadBulkEdits))),Bt=Ve.set(u.$rK.ExtHostEditors,new F.$Ddc(Ve,bt)),ri=Ve.set(u.$rK.ExtHostTreeViews,new j.$Edc(Ve.getProxy(u.$qK.MainThreadTreeViews),$t,$e)),Mi=Ve.set(u.$rK.ExtHostEditorInsets,new oe.$Ndc(Ve.getProxy(u.$qK.MainThreadEditorInsets),Bt,ht.remote)),ui=Ve.set(u.$rK.ExtHostDiagnostics,new v.$Hcc(Ve,$e,Pt,bt)),li=Ve.set(u.$rK.ExtHostLanguages,new P.$tdc(Ve,At,$t.converter,jt)),dt=Ve.set(u.$rK.ExtHostLanguageFeatures,new k.$Lcc(Ve,jt,At,$t,ui,$e,Me,Dt)),Fi=Ve.set(u.$rK.ExtHostFileSystem,new $.$rdc(Ve,dt)),ei=Ve.set(u.$rK.ExtHostFileSystemEventService,new a.$sdc(Ve,$e,bt)),si=Ve.set(u.$rK.ExtHostQuickOpen,(0,M.$ydc)(Ve,ut,$t)),yi=Ve.set(u.$rK.ExtHostSCM,new V.$Adc(Ve,$t,At,$e)),Ti=Ve.set(u.$rK.ExtHostQuickDiff,new Mt.$xec(Ve,jt)),Li=Ve.set(u.$rK.ExtHostShare,new xt.$Cec(Ve,jt)),Zi=Ve.set(u.$rK.ExtHostComments,(0,i.$Occ)(Ve,$t,At)),Ei=Ve.set(u.$rK.ExtHostProgress,new y.$xdc(Ve.getProxy(u.$qK.MainThreadProgress))),Oi=Ve.set(u.$rK.ExtHosLabelService,new ye.$Odc(Ve)),Di=Ve.set(u.$rK.ExtHostTheming,new ne.$dec(Ve)),oi=Ve.set(u.$rK.ExtHostAuthentication,new Ce.$eec(Ve)),Xi=Ve.set(u.$rK.ExtHostTimeline,new L.$gec(Ve,$t)),gi=Ve.set(u.$rK.ExtHostWebviews,new Se.$Idc(Ve,ht.remote,ut,$e,Me)),mi=Ve.set(u.$rK.ExtHostWebviewPanels,new x.$iec(Ve,gi,ut)),_i=Ve.set(u.$rK.ExtHostCustomEditors,new H.$jec(Ve,At,Pe,gi,mi)),xi=Ve.set(u.$rK.ExtHostWebviewViews,new X.$hec(Ve,gi)),di=Ve.set(u.$rK.ExtHostTesting,new je.$lec(Ve,$t,bt)),en=Ve.set(u.$rK.ExtHostUriOpeners,new Ye.$pec(Ve)),tn=Ve.set(u.$rK.ExtHostProfileContentHandlers,new yt.$wec(Ve));Ve.set(u.$rK.ExtHostInteractive,new Ee.$vec(Ve,kt,bt,$t,$e));const fn=Ve.set(u.$rK.ExtHostInlineChat,new qt.$zec(Ve,$t,At,$e)),ki=Ve.set(u.$rK.ExtHostChatProvider,new Yt.$Dec(Ve,$e)),Ni=Ve.set(u.$rK.ExtHostChatAgents,new Kt.$Iec(Ve,ki,$e)),zi=Ve.set(u.$rK.ExtHostChatAgents2,new Ht.$Jec(Ve,ki,$e)),gn=Ve.set(u.$rK.ExtHostChatVariables,new Nt.$Fec(Ve)),Si=Ve.set(u.$rK.ExtHostChat,new Vt.$yec(Ve,$e)),Ui=Ve.set(u.$rK.ExtHostAiRelatedInformation,new Qt.$Gec(Ve)),Ii=Ve.set(u.$rK.ExtHostAiEmbeddingVector,new zt.$Hec(Ve)),ji=Ve.set(u.$rK.ExtHostIssueReporter,new Lt.$Bec(Ve)),Bi=Ve.set(u.$rK.ExtHostStatusBar,new B.$Cdc(Ve,$t.converter)),nn=Ve.set(u.$rK.ExtHostSpeech,new It.$Eec(Ve)),mn=Object.values(u.$rK);Ve.assertRegistered(mn);const Wi=new se.$kec(Ve,bt),rn=new g.$Ncc(Ve),Xt=new h.$udc(Ve,$e),$i=new D.$Wcc(Ve);return p.$Mcc.register($t),function(Oe,ti,pi){const pt=function(){let te=!Oe.isUnderDevelopment;function me(){te||($e.info(`Extension '${Oe.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),te=!0)}return function Te(ot){if(Array.isArray(ot))ot.forEach(Te);else if(typeof ot=="string")me();else{const wt=ot;typeof wt.scheme>"u"&&me(),typeof wt.exclusive=="boolean"&&(0,ze.$mF)(Oe,"documentFiltersExclusive")}return ot}}(),sn={getSession(te,me,Te){return oi.getSession(Oe,te,me,Te)},getSessions(te,me){return(0,ze.$mF)(Oe,"authGetSessions"),oi.getSessions(Oe,te,me)},async hasSession(te,me){return(0,ze.$mF)(Oe,"authSession"),!!await oi.getSession(Oe,te,me,{silent:!0})},get onDidChangeSessions(){return oi.onDidChangeSessions},registerAuthenticationProvider(te,me,Te,ot){return oi.registerAuthenticationProvider(te,me,Te,ot)}},on={registerCommand(te,me,Te){return $t.registerCommand(!0,te,me,Te,void 0,Oe)},registerTextEditorCommand(te,me,Te){return $t.registerCommand(!0,te,(...ot)=>{const wt=Bt.getActiveTextEditor();if(!wt){$e.warn("Cannot execute "+te+" because there is no active text editor.");return}return wt.edit(Rt=>{me.apply(Te,[wt,Rt,...ot])}).then(Rt=>{Rt||$e.warn("Edits from command "+te+" were not applied.")},Rt=>{$e.warn("An error occurred while running command "+te,Rt)})},void 0,void 0,Oe)},registerDiffInformationCommand:(te,me,Te)=>((0,ze.$mF)(Oe,"diffCommand"),$t.registerCommand(!0,te,async(...ot)=>{const wt=bt.activeEditor(!0);if(!wt){$e.warn("Cannot execute "+te+" because there is no active text editor.");return}const Rt=await Bt.getDiffInformation(wt.id);me.apply(Te,[Rt,...ot])},void 0,void 0,Oe)),executeCommand(te,...me){return $t.executeCommand(te,...me)},getCommands(te=!1){return $t.getCommands(te)}},Vi={get machineId(){return ht.telemetryInfo.machineId},get sessionId(){return ht.telemetryInfo.sessionId},get language(){return ht.environment.appLanguage},get appName(){return ht.environment.appName},get appRoot(){return ht.environment.appRoot?.fsPath??""},get appHost(){return ht.environment.appHost},get uriScheme(){return ht.environment.appUriScheme},get clipboard(){return rn.value},get shell(){return gt.getDefaultShell(!1)},get onDidChangeShell(){return gt.onDidChangeShell},get isTelemetryEnabled(){return Dt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return Dt.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,ze.$mF)(Oe,"telemetry"),Dt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,ze.$mF)(Oe,"telemetry"),Dt.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,xe.$KM)(ht.telemetryInfo.firstSessionDate)},createTelemetryLogger(te,me){return xe.$JM.validateSender(te),Dt.instantiateLogger(Oe,te,me)},openExternal(te,me){return Be.openUri(te,{allowTunneling:!!ht.remote.authority,allowContributedOpeners:me?.allowContributedOpeners})},async asExternalUri(te){if(te.scheme===ht.environment.appUriScheme)return Ji.createAppUri(te);try{return await Be.asExternalUri(te,{allowTunneling:!!ht.remote.authority})}catch(me){if((0,lt.$wU)(te,Ue.Schemas.http)||(0,lt.$wU)(te,Ue.Schemas.https))return te;throw me}},get remoteName(){return(0,De.$Wk)(ht.remote.authority)},get remoteAuthority(){return(0,ze.$mF)(Oe,"resolvers"),ht.remote.authority},get uiKind(){return ht.uiKind},get logLevel(){return $e.getLevel()},get onDidChangeLogLevel(){return $e.onDidChangeLogLevel},registerIssueUriRequestHandler(te){return(0,ze.$mF)(Oe,"handleIssueUri"),ji.registerIssueUriRequestHandler(Oe,te)},registerIssueDataProvider(te){return(0,ze.$mF)(Oe,"handleIssueUri"),ji.registerIssueDataProvider(Oe,te)},get appQuality(){return(0,ze.$mF)(Oe,"resolvers"),ht.quality},get appCommit(){return(0,ze.$mF)(Oe,"resolvers"),ht.commit}};ht.environment.extensionTestsLocationURI||Object.freeze(Vi);const $n={createTestController(te,me,Te){return di.createTestController(Oe,te,me,Te)},createTestObserver(){return(0,ze.$mF)(Oe,"testObserver"),di.createTestObserver()},runTests(te){return(0,ze.$mF)(Oe,"testObserver"),di.runTests(te)},get onDidChangeTestResults(){return(0,ze.$mF)(Oe,"testObserver"),di.onResultsChanged},get testResults(){return(0,ze.$mF)(Oe,"testObserver"),di.results}},vi=ht.remote.isRemote?W.ExtensionKind.Workspace:W.ExtensionKind.UI,an={getExtension(te,me){(0,ze.$lF)(Oe,"extensionsAny")||(me=!1);const Te=ti.mine.getExtensionDescription(te);if(Te)return new o.$pdc(Ft,Oe.identifier,Te,vi,!1);if(me){const ot=ti.all.getExtensionDescription(te);if(ot)return new o.$pdc(Ft,Oe.identifier,ot,vi,!0)}},get all(){const te=[];for(const me of ti.mine.getAllExtensionDescriptions())te.push(new o.$pdc(Ft,Oe.identifier,me,vi,!1));return te},get allAcrossExtensionHosts(){(0,ze.$mF)(Oe,"extensionsAny");const te=new re.$9l(ti.mine.getAllExtensionDescriptions().map(Te=>Te.identifier)),me=[];for(const Te of ti.all.getAllExtensionDescriptions()){const ot=!te.has(Te.identifier);me.push(new o.$pdc(Ft,Oe.identifier,Te,vi,ot))}return me},get onDidChange(){return(0,ze.$lF)(Oe,"extensionsAny")?I.Event.any(ti.mine.onDidChange,ti.all.onDidChange):ti.mine.onDidChange}},pn={createDiagnosticCollection(te){return ui.createDiagnosticCollection(Oe.identifier,te)},get onDidChangeDiagnostics(){return ui.onDidChangeDiagnostics},getDiagnostics:te=>ui.getDiagnostics(te),getLanguages(){return li.getLanguages()},setTextDocumentLanguage(te,me){return li.changeLanguage(te.uri,me)},match(te,me){const Te=At.getDocumentData(me.uri)?.notebook;return(0,R.$yE)(q.LanguageSelector.from(te),me.uri,me.languageId,!0,Te?.uri,Te?.notebookType)},registerCodeActionsProvider(te,me,Te){return dt.registerCodeActionProvider(Oe,pt(te),me,Te)},registerDocumentPasteEditProvider(te,me,Te){return(0,ze.$mF)(Oe,"documentPaste"),dt.registerDocumentPasteEditProvider(Oe,pt(te),me,Te)},registerCodeLensProvider(te,me){return dt.registerCodeLensProvider(Oe,pt(te),me)},registerDefinitionProvider(te,me){return dt.registerDefinitionProvider(Oe,pt(te),me)},registerDeclarationProvider(te,me){return dt.registerDeclarationProvider(Oe,pt(te),me)},registerImplementationProvider(te,me){return dt.registerImplementationProvider(Oe,pt(te),me)},registerTypeDefinitionProvider(te,me){return dt.registerTypeDefinitionProvider(Oe,pt(te),me)},registerHoverProvider(te,me){return dt.registerHoverProvider(Oe,pt(te),me,Oe.identifier)},registerEvaluatableExpressionProvider(te,me){return dt.registerEvaluatableExpressionProvider(Oe,pt(te),me,Oe.identifier)},registerInlineValuesProvider(te,me){return dt.registerInlineValuesProvider(Oe,pt(te),me,Oe.identifier)},registerDocumentHighlightProvider(te,me){return dt.registerDocumentHighlightProvider(Oe,pt(te),me)},registerLinkedEditingRangeProvider(te,me){return dt.registerLinkedEditingRangeProvider(Oe,pt(te),me)},registerReferenceProvider(te,me){return dt.registerReferenceProvider(Oe,pt(te),me)},registerRenameProvider(te,me){return dt.registerRenameProvider(Oe,pt(te),me)},registerDocumentSymbolProvider(te,me,Te){return dt.registerDocumentSymbolProvider(Oe,pt(te),me,Te)},registerWorkspaceSymbolProvider(te){return dt.registerWorkspaceSymbolProvider(Oe,te)},registerDocumentFormattingEditProvider(te,me){return dt.registerDocumentFormattingEditProvider(Oe,pt(te),me)},registerDocumentRangeFormattingEditProvider(te,me){return dt.registerDocumentRangeFormattingEditProvider(Oe,pt(te),me)},registerOnTypeFormattingEditProvider(te,me,Te,...ot){return dt.registerOnTypeFormattingEditProvider(Oe,pt(te),me,[Te].concat(ot))},registerDocumentSemanticTokensProvider(te,me,Te){return dt.registerDocumentSemanticTokensProvider(Oe,pt(te),me,Te)},registerDocumentRangeSemanticTokensProvider(te,me,Te){return dt.registerDocumentRangeSemanticTokensProvider(Oe,pt(te),me,Te)},registerSignatureHelpProvider(te,me,Te,...ot){return typeof Te=="object"?dt.registerSignatureHelpProvider(Oe,pt(te),me,Te):dt.registerSignatureHelpProvider(Oe,pt(te),me,typeof Te>"u"?[]:[Te,...ot])},registerCompletionItemProvider(te,me,...Te){return dt.registerCompletionItemProvider(Oe,pt(te),me,Te)},registerInlineCompletionItemProvider(te,me,Te){return me.handleDidShowCompletionItem&&(0,ze.$mF)(Oe,"inlineCompletionsAdditions"),me.handleDidPartiallyAcceptCompletionItem&&(0,ze.$mF)(Oe,"inlineCompletionsAdditions"),Te&&(0,ze.$mF)(Oe,"inlineCompletionsAdditions"),dt.registerInlineCompletionsProvider(Oe,pt(te),me,Te)},registerDocumentLinkProvider(te,me){return dt.registerDocumentLinkProvider(Oe,pt(te),me)},registerColorProvider(te,me){return dt.registerColorProvider(Oe,pt(te),me)},registerFoldingRangeProvider(te,me){return dt.registerFoldingRangeProvider(Oe,pt(te),me)},registerSelectionRangeProvider(te,me){return dt.registerSelectionRangeProvider(Oe,te,me)},registerCallHierarchyProvider(te,me){return dt.registerCallHierarchyProvider(Oe,te,me)},registerTypeHierarchyProvider(te,me){return dt.registerTypeHierarchyProvider(Oe,te,me)},setLanguageConfiguration:(te,me)=>dt.setLanguageConfiguration(Oe,te,me),getTokenInformationAtPosition(te,me){return(0,ze.$mF)(Oe,"tokenInformation"),li.tokenAtPosition(te,me)},registerInlayHintsProvider(te,me){return dt.registerInlayHintsProvider(Oe,te,me)},createLanguageStatusItem(te,me){return li.createLanguageStatusItem(Oe,te,me)},registerDocumentDropEditProvider(te,me,Te){return dt.registerDocumentOnDropEditProvider(Oe,te,me,(0,ze.$lF)(Oe,"dropMetadata")?Te:void 0)}},vn={get activeTextEditor(){return Bt.getActiveTextEditor()},get visibleTextEditors(){return Bt.getVisibleTextEditors()},get activeTerminal(){return gt.activeTerminal},get terminals(){return gt.terminals},async showTextDocument(te,me,Te){const ot=await(A.URI.isUri(te)?Promise.resolve(Ci.openTextDocument(te)):Promise.resolve(te));return Bt.showTextDocument(ot,me,Te)},createTextEditorDecorationType(te){return Bt.createTextEditorDecorationType(Oe,te)},onDidChangeActiveTextEditor(te,me,Te){return Bt.onDidChangeActiveTextEditor(te,me,Te)},onDidChangeVisibleTextEditors(te,me,Te){return Bt.onDidChangeVisibleTextEditors(te,me,Te)},onDidChangeTextEditorSelection(te,me,Te){return Bt.onDidChangeTextEditorSelection(te,me,Te)},onDidChangeTextEditorOptions(te,me,Te){return Bt.onDidChangeTextEditorOptions(te,me,Te)},onDidChangeTextEditorVisibleRanges(te,me,Te){return Bt.onDidChangeTextEditorVisibleRanges(te,me,Te)},onDidChangeTextEditorViewColumn(te,me,Te){return Bt.onDidChangeTextEditorViewColumn(te,me,Te)},onDidCloseTerminal(te,me,Te){return gt.onDidCloseTerminal(te,me,Te)},onDidOpenTerminal(te,me,Te){return gt.onDidOpenTerminal(te,me,Te)},onDidChangeActiveTerminal(te,me,Te){return gt.onDidChangeActiveTerminal(te,me,Te)},onDidChangeTerminalDimensions(te,me,Te){return(0,ze.$mF)(Oe,"terminalDimensions"),gt.onDidChangeTerminalDimensions(te,me,Te)},onDidChangeTerminalState(te,me,Te){return gt.onDidChangeTerminalState(te,me,Te)},onDidWriteTerminalData(te,me,Te){return(0,ze.$mF)(Oe,"terminalDataWriteEvent"),gt.onDidWriteTerminalData(te,me,Te)},onDidExecuteTerminalCommand(te,me,Te){return(0,ze.$mF)(Oe,"terminalExecuteCommandEvent"),gt.onDidExecuteTerminalCommand(te,me,Te)},get state(){return Be.getState(Oe)},onDidChangeWindowState(te,me,Te){return Be.onDidChangeWindowState(te,me,Te)},showInformationMessage(te,...me){return Xt.showMessage(Oe,O.default.Info,te,me[0],me.slice(1))},showWarningMessage(te,...me){return Xt.showMessage(Oe,O.default.Warning,te,me[0],me.slice(1))},showErrorMessage(te,...me){return Xt.showMessage(Oe,O.default.Error,te,me[0],me.slice(1))},showQuickPick(te,me,Te){return si.showQuickPick(Oe,te,me,Te)},showWorkspaceFolderPick(te){return si.showWorkspaceFolderPick(te)},showInputBox(te,me){return si.showInput(te,me)},showOpenDialog(te){return $i.showOpenDialog(Oe,te)},showSaveDialog(te){return $i.showSaveDialog(te)},createStatusBarItem(te,me,Te){let ot,wt,Rt;return typeof te=="string"?(ot=te,wt=me,Rt=Te):(wt=te,Rt=me),Bi.createStatusBarEntry(Oe,ot,wt,Rt)},setStatusBarMessage(te,me){return Bi.setStatusBarMessage(te,me)},withScmProgress(te){return Me.report("window.withScmProgress",Oe,"Use 'withProgress' instead."),Ei.withProgress(Oe,{location:W.ProgressLocation.SourceControl},(me,Te)=>te({report(ot){}}))},withProgress(te,me){return Ei.withProgress(Oe,te,me)},createOutputChannel(te,me){return wi.createOutputChannel(te,me,Oe)},createWebviewPanel(te,me,Te,ot){return mi.createWebviewPanel(Oe,te,me,Te,ot)},createWebviewTextEditorInset(te,me,Te,ot){return(0,ze.$mF)(Oe,"editorInsets"),Mi.createWebviewEditorInset(te,me,Te,ot,Oe)},createTerminal(te,me,Te){return typeof te=="object"?"pty"in te?gt.createExtensionTerminal(te):gt.createTerminalFromOptions(te):gt.createTerminal(te,me,Te)},registerTerminalLinkProvider(te){return gt.registerLinkProvider(te)},registerTerminalProfileProvider(te,me){return gt.registerProfileProvider(Oe,te,me)},registerTerminalQuickFixProvider(te,me){return(0,ze.$mF)(Oe,"terminalQuickFixProvider"),gt.registerTerminalQuickFixProvider(te,Oe.identifier.value,me)},registerTreeDataProvider(te,me){return ri.registerTreeDataProvider(te,me,Oe)},createTreeView(te,me){return ri.createTreeView(te,me,Oe)},registerWebviewPanelSerializer:(te,me)=>mi.registerWebviewPanelSerializer(Oe,te,me),registerCustomEditorProvider:(te,me,Te={})=>_i.registerCustomEditorProvider(Oe,te,me,Te),registerFileDecorationProvider(te){return St.registerFileDecorationProvider(te,Oe)},registerUriHandler(te){return Ji.registerUriHandler(Oe,te)},createQuickPick(){return si.createQuickPick(Oe)},createInputBox(){return si.createInputBox(Oe)},get activeColorTheme(){return Di.activeColorTheme},onDidChangeActiveColorTheme(te,me,Te){return Di.onDidChangeActiveColorTheme(te,me,Te)},registerWebviewViewProvider(te,me,Te){return xi.registerWebviewViewProvider(Oe,te,me,Te?.webviewOptions)},get activeNotebookEditor(){return kt.activeNotebookEditor},onDidChangeActiveNotebookEditor(te,me,Te){return kt.onDidChangeActiveNotebookEditor(te,me,Te)},get visibleNotebookEditors(){return kt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return kt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(te,me,Te){return bi.onDidChangeNotebookEditorSelection(te,me,Te)},onDidChangeNotebookEditorVisibleRanges(te,me,Te){return bi.onDidChangeNotebookEditorVisibleRanges(te,me,Te)},showNotebookDocument(te,me){return kt.showNotebookDocument(te,me)},registerExternalUriOpener(te,me,Te){return(0,ze.$mF)(Oe,"externalUriOpener"),en.registerExternalUriOpener(Oe.identifier,te,me,Te)},registerProfileContentHandler(te,me){return(0,ze.$mF)(Oe,"profileContentHandlers"),tn.registrProfileContentHandler(Oe,te,me)},registerQuickDiffProvider(te,me,Te,ot){return(0,ze.$mF)(Oe,"quickDiffProvider"),Ti.registerQuickDiffProvider(pt(te),me,Te,ot)},get tabGroups(){return He.tabGroups},registerShareProvider(te,me){return(0,ze.$mF)(Oe,"shareProvider"),Li.registerShareProvider(pt(te),me)}},Ci={get rootPath(){return Me.report("workspace.rootPath",Oe,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ut.getPath()},set rootPath(te){throw new C.$9("rootPath")},getWorkspaceFolder(te){return ut.getWorkspaceFolder(te)},get workspaceFolders(){return ut.getWorkspaceFolders()},get name(){return ut.name},set name(te){throw new C.$9("name")},get workspaceFile(){return ut.workspaceFile},set workspaceFile(te){throw new C.$9("workspaceFile")},updateWorkspaceFolders:(te,me,...Te)=>ut.updateWorkspaceFolders(Oe,te,me||0,...Te),onDidChangeWorkspaceFolders:function(te,me,Te){return ut.onDidChangeWorkspace(te,me,Te)},asRelativePath:(te,me)=>ut.getRelativePath(te,me),findFiles:(te,me,Te,ot)=>ut.findFiles(te,me,Te,Oe.identifier,ot),findTextInFiles:(te,me,Te,ot)=>{(0,ze.$mF)(Oe,"findTextInFiles");let wt,Rt;return typeof me=="object"?(wt=me,Rt=Te):(wt={},Rt=me,ot=Te),ut.findTextInFiles(te,wt||{},Rt,Oe.identifier,ot)},save:te=>((0,ze.$mF)(Oe,"saveEditor"),ut.save(te)),saveAs:te=>((0,ze.$mF)(Oe,"saveEditor"),ut.saveAs(te)),saveAll:te=>ut.saveAll(te),applyEdit(te,me){return Wi.applyWorkspaceEdit(te,Oe,me)},createFileSystemWatcher:(te,me,Te,ot)=>{let wt;return typeof me=="boolean"?wt={ignoreCreateEvents:!!me,ignoreChangeEvents:!!Te,ignoreDeleteEvents:!!ot,correlate:!1}:me&&((0,ze.$mF)(Oe,"createFileSystemWatcher"),wt={...me,correlate:!0}),ei.createFileSystemWatcher(ut,Oe,te,wt)},get textDocuments(){return At.getAllDocumentData().map(te=>te.document)},set textDocuments(te){throw new C.$9("textDocuments")},openTextDocument(te){let me;const Te=te;if(typeof te=="string")me=Promise.resolve(A.URI.file(te));else if(A.URI.isUri(te))me=Promise.resolve(te);else if(!Te||typeof Te=="object")me=At.createDocumentData(Te);else throw new Error("illegal argument - uriOrFileNameOrOptions");return me.then(ot=>At.ensureDocumentData(ot).then(wt=>wt.document))},onDidOpenTextDocument:(te,me,Te)=>At.onDidAddDocument(te,me,Te),onDidCloseTextDocument:(te,me,Te)=>At.onDidRemoveDocument(te,me,Te),onDidChangeTextDocument:(te,me,Te)=>At.onDidChangeDocument(te,me,Te),onDidSaveTextDocument:(te,me,Te)=>At.onDidSaveDocument(te,me,Te),onWillSaveTextDocument:(te,me,Te)=>Ai.getOnWillSaveTextDocumentEvent(Oe)(te,me,Te),get notebookDocuments(){return kt.notebookDocuments.map(te=>te.apiNotebook)},async openNotebookDocument(te,me){let Te;if(A.URI.isUri(te))Te=te,await kt.openNotebookDocument(te);else if(typeof te=="string")Te=A.URI.revive(await kt.createNotebookDocument({viewType:te,content:me}));else throw new Error("Invalid arguments");return kt.getNotebookDocument(Te).apiNotebook},onDidSaveNotebookDocument(te,me,Te){return Zt.onDidSaveNotebookDocument(te,me,Te)},onDidChangeNotebookDocument(te,me,Te){return Zt.onDidChangeNotebookDocument(te,me,Te)},onWillSaveNotebookDocument(te,me,Te){return Yi.getOnWillSaveNotebookDocumentEvent(Oe)(te,me,Te)},get onDidOpenNotebookDocument(){return kt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return kt.onDidCloseNotebookDocument},registerNotebookSerializer(te,me,Te,ot){return kt.registerNotebookSerializer(Oe,te,me,Te,(0,ze.$lF)(Oe,"notebookLiveShare")?ot:void 0)},onDidChangeConfiguration:(te,me,Te)=>pi.onDidChangeConfiguration(te,me,Te),getConfiguration(te,me){return me=arguments.length===1?void 0:me,pi.getConfiguration(te,me,Oe)},registerTextDocumentContentProvider(te,me){return Pi.registerTextDocumentContentProvider(te,me)},registerTaskProvider:(te,me)=>(Me.report("window.registerTaskProvider",Oe,"Use the corresponding function on the 'tasks' namespace instead"),Gt.registerTaskProvider(Oe,te,me)),registerFileSystemProvider(te,me,Te){return(0,We.$Pc)(Fi.registerFileSystemProvider(Oe,te,me,Te),Tt.addFileSystemProvider(te,me,Te))},get fs(){return Tt.value},registerFileSearchProvider:(te,me)=>((0,ze.$mF)(Oe,"fileSearchProvider"),ci.registerFileSearchProvider(te,me)),registerTextSearchProvider:(te,me)=>((0,ze.$mF)(Oe,"textSearchProvider"),ci.registerTextSearchProvider(te,me)),registerRemoteAuthorityResolver:(te,me)=>((0,ze.$mF)(Oe,"resolvers"),Ft.registerRemoteAuthorityResolver(te,me)),registerResourceLabelFormatter:te=>((0,ze.$mF)(Oe,"resolvers"),Oi.$registerResourceLabelFormatter(te)),getRemoteExecServer:te=>((0,ze.$mF)(Oe,"resolvers"),Ft.getRemoteExecServer(te)),onDidCreateFiles:(te,me,Te)=>ei.onDidCreateFile(te,me,Te),onDidDeleteFiles:(te,me,Te)=>ei.onDidDeleteFile(te,me,Te),onDidRenameFiles:(te,me,Te)=>ei.onDidRenameFile(te,me,Te),onWillCreateFiles:(te,me,Te)=>ei.getOnWillCreateFileEvent(Oe)(te,me,Te),onWillDeleteFiles:(te,me,Te)=>ei.getOnWillDeleteFileEvent(Oe)(te,me,Te),onWillRenameFiles:(te,me,Te)=>ei.getOnWillRenameFileEvent(Oe)(te,me,Te),openTunnel:te=>((0,ze.$mF)(Oe,"tunnels"),G.openTunnel(Oe,te).then(me=>{if(!me)throw new Error("cannot open tunnel");return me})),get tunnels(){return(0,ze.$mF)(Oe,"tunnels"),G.getTunnels()},onDidChangeTunnels:(te,me,Te)=>((0,ze.$mF)(Oe,"tunnels"),G.onDidChangeTunnels(te,me,Te)),registerPortAttributesProvider:(te,me)=>((0,ze.$mF)(Oe,"portsAttributes"),G.registerPortsAttributesProvider(te,me)),registerTunnelProvider:(te,me)=>((0,ze.$mF)(Oe,"tunnelFactory"),G.registerTunnelProvider(te,me)),registerTimelineProvider:(te,me)=>((0,ze.$mF)(Oe,"timeline"),Xi.registerTimelineProvider(te,me,Oe.identifier,$t.converter)),get isTrusted(){return ut.trusted},requestWorkspaceTrust:te=>((0,ze.$mF)(Oe,"workspaceTrust"),ut.requestWorkspaceTrust(te)),onDidGrantWorkspaceTrust:(te,me,Te)=>ut.onDidGrantWorkspaceTrust(te,me,Te),registerEditSessionIdentityProvider:(te,me)=>((0,ze.$mF)(Oe,"editSessionIdentityProvider"),ut.registerEditSessionIdentityProvider(te,me)),onWillCreateEditSessionIdentity:(te,me,Te)=>((0,ze.$mF)(Oe,"editSessionIdentityProvider"),ut.getOnWillCreateEditSessionIdentityEvent(Oe)(te,me,Te)),registerCanonicalUriProvider:(te,me)=>((0,ze.$mF)(Oe,"canonicalUriProvider"),ut.registerCanonicalUriProvider(te,me)),getCanonicalUri:(te,me,Te)=>((0,ze.$mF)(Oe,"canonicalUriProvider"),ut.provideCanonicalUri(te,me,Te))},cn={get inputBox(){return Me.report("scm.inputBox",Oe,"Use 'SourceControl.inputBox' instead"),yi.getLastInputBox(Oe)},createSourceControl(te,me,Te){return yi.createSourceControl(Oe,te,me,Te)}},un={createCommentController(te,me){return Zi.createCommentController(Oe,te,me)}},ln={get activeDebugSession(){return mt.activeDebugSession},get activeDebugConsole(){return mt.activeDebugConsole},get breakpoints(){return mt.breakpoints},get stackFrameFocus(){return mt.stackFrameFocus},onDidStartDebugSession(te,me,Te){return mt.onDidStartDebugSession(te,me,Te)},onDidTerminateDebugSession(te,me,Te){return mt.onDidTerminateDebugSession(te,me,Te)},onDidChangeActiveDebugSession(te,me,Te){return mt.onDidChangeActiveDebugSession(te,me,Te)},onDidReceiveDebugSessionCustomEvent(te,me,Te){return mt.onDidReceiveDebugSessionCustomEvent(te,me,Te)},onDidChangeBreakpoints(te,me,Te){return mt.onDidChangeBreakpoints(te,me,Te)},onDidChangeStackFrameFocus(te,me,Te){return(0,ze.$mF)(Oe,"debugFocus"),mt.onDidChangeStackFrameFocus(te,me,Te)},registerDebugConfigurationProvider(te,me,Te){return mt.registerDebugConfigurationProvider(te,me,Te||Ze.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(te,me){return mt.registerDebugAdapterDescriptorFactory(Oe,te,me)},registerDebugAdapterTrackerFactory(te,me){return mt.registerDebugAdapterTrackerFactory(te,me)},startDebugging(te,me,Te){return!Te||typeof Te=="object"&&"configuration"in Te?mt.startDebugging(te,me,{parentSession:Te}):mt.startDebugging(te,me,Te||{})},stopDebugging(te){return mt.stopDebugging(te)},addBreakpoints(te){return mt.addBreakpoints(te)},removeBreakpoints(te){return mt.removeBreakpoints(te)},asDebugSourceUri(te,me){return mt.asDebugSourceUri(te,me)}},wn={registerTaskProvider:(te,me)=>Gt.registerTaskProvider(Oe,te,me),fetchTasks:te=>Gt.fetchTasks(te),executeTask:te=>Gt.executeTask(Oe,te),get taskExecutions(){return Gt.taskExecutions},onDidStartTask:(te,me,Te)=>Gt.onDidStartTask(te,me,Te),onDidEndTask:(te,me,Te)=>Gt.onDidEndTask(te,me,Te),onDidStartTaskProcess:(te,me,Te)=>Gt.onDidStartTaskProcess(te,me,Te),onDidEndTaskProcess:(te,me,Te)=>Gt.onDidEndTaskProcess(te,me,Te)},bn={createNotebookController(te,me,Te,ot,wt){return fi.createNotebookController(Oe,te,me,Te,ot,(0,ze.$lF)(Oe,"notebookMessaging")?wt:void 0)},registerNotebookCellStatusBarItemProvider:(te,me)=>kt.registerNotebookCellStatusBarItemProvider(Oe,te,me),createRendererMessaging(te){return Ri.createRendererMessaging(Oe,te)},createNotebookControllerDetectionTask(te){return(0,ze.$mF)(Oe,"notebookKernelSource"),fi.createNotebookControllerDetectionTask(Oe,te)},registerKernelSourceActionProvider(te,me){return(0,ze.$mF)(Oe,"notebookKernelSource"),fi.registerKernelSourceActionProvider(Oe,te,me)},onDidChangeNotebookCellExecutionState(te,me,Te){return(0,ze.$mF)(Oe,"notebookCellExecutionState"),fi.onDidChangeNotebookCellExecutionState(te,me,Te)}},dn={t(...te){if(typeof te[0]=="string"){const me=te.shift(),Te=!te||typeof te[0]!="object"?te:te[0];return hi.getMessage(Oe.identifier.value,{message:me,args:Te})}return hi.getMessage(Oe.identifier.value,te[0])},get bundle(){return hi.getBundle(Oe.identifier.value)},get uri(){return hi.getBundleUri(Oe.identifier.value)}},hn={_version:1,registerInteractiveEditorSessionProvider(te,me){return(0,ze.$mF)(Oe,"interactive"),fn.registerProvider(Oe,te,me={label:me?.label??Oe.displayName??Oe.name})},registerInteractiveSessionProvider(te,me){return(0,ze.$mF)(Oe,"interactive"),Si.registerChatProvider(Oe,te,me)},sendInteractiveRequestToProvider(te,me){return(0,ze.$mF)(Oe,"interactive"),Si.sendInteractiveRequestToProvider(te,me)},get onDidPerformUserAction(){return(0,ze.$mF)(Oe,"interactiveUserActions"),Si.onDidPerformUserAction},transferChatSession(te,me){return(0,ze.$mF)(Oe,"interactive"),Si.transferChatSession(te,me)}},qi={getRelatedInformation(te,me){return(0,ze.$mF)(Oe,"aiRelatedInformation"),Ui.getRelatedInformation(Oe,te,me)},registerRelatedInformationProvider(te,me){return(0,ze.$mF)(Oe,"aiRelatedInformation"),Ui.registerRelatedInformationProvider(Oe,te,me)},registerEmbeddingVectorProvider(te,me){return(0,ze.$mF)(Oe,"aiRelatedInformation"),Ii.registerEmbeddingVectorProvider(Oe,te,me)}},Ki={registerChatResponseProvider(te,me,Te){return(0,ze.$mF)(Oe,"chatProvider"),ki.registerProvider(Oe.identifier,te,me,Te)},requestChatAccess(te){return(0,ze.$mF)(Oe,"chatRequestAccess"),ki.requestChatResponseProvider(Oe.identifier,te)},registerVariable(te,me,Te){return(0,ze.$mF)(Oe,"chatVariables"),gn.registerVariableResolver(Oe,te,me,Te)},registerMappedEditsProvider(te,me){return(0,ze.$mF)(Oe,"mappedEditsProvider"),dt.registerMappedEditsProvider(Oe,te,me)},createChatAgent(te,me){return(0,ze.$mF)(Oe,"chatAgents2"),zi.createChatAgent(Oe,te,me)},registerAgent(te,me,Te){return(0,ze.$mF)(Oe,"chatAgents"),Ni.registerAgent(Oe.identifier,te,me,Te)}},Hi={registerSpeechProvider(te,me){return(0,ze.$mF)(Oe,"speech"),nn.registerProvider(Oe.identifier,te,me)}};return{version:ht.version,ai:qi,authentication:sn,commands:on,comments:un,chat:Ki,debug:ln,env:Vi,extensions:an,interactive:hn,l10n:dn,languages:pn,notebooks:bn,scm:cn,speech:Hi,tasks:wn,tests:$n,window:vn,workspace:Ci,Breakpoint:W.$qL,TerminalOutputAnchor:W.TerminalOutputAnchor,ChatAgentResultFeedbackKind:W.ChatAgentResultFeedbackKind,ChatMessage:W.$gM,ChatMessageRole:W.ChatMessageRole,ChatVariableLevel:W.ChatVariableLevel,CallHierarchyIncomingCall:W.$PK,CallHierarchyItem:W.$OK,CallHierarchyOutgoingCall:W.$QK,CancellationError:C.$5,CancellationTokenSource:f.$Yd,CandidatePortSource:u.CandidatePortSource,CodeAction:W.$LK,CodeActionKind:W.$MK,CodeActionTriggerKind:W.CodeActionTriggerKind,CodeLens:W.$RK,Color:W.$5K,ColorInformation:W.$6K,ColorPresentation:W.$7K,ColorThemeKind:W.ColorThemeKind,CommentMode:W.CommentMode,CommentState:W.CommentState,CommentThreadCollapsibleState:W.CommentThreadCollapsibleState,CommentThreadState:W.CommentThreadState,CompletionItem:W.$YK,CompletionItemKind:W.CompletionItemKind,CompletionItemTag:W.CompletionItemTag,CompletionList:W.$ZK,CompletionTriggerKind:W.CompletionTriggerKind,ConfigurationTarget:W.ConfigurationTarget,CustomExecution:W.$cL,DebugAdapterExecutable:W.$uL,DebugAdapterInlineImplementation:W.$xL,DebugAdapterNamedPipeServer:W.$wL,DebugAdapterServer:W.$vL,DebugConfigurationProviderTriggerKind:Ze.DebugConfigurationProviderTriggerKind,DebugConsoleMode:W.DebugConsoleMode,DecorationRangeBehavior:W.DecorationRangeBehavior,Diagnostic:W.$GK,DiagnosticRelatedInformation:W.$FK,DiagnosticSeverity:W.DiagnosticSeverity,DiagnosticTag:W.DiagnosticTag,Disposable:W.$sK,DocumentHighlight:W.$IK,DocumentHighlightKind:W.DocumentHighlightKind,DocumentLink:W.$4K,DocumentSymbol:W.$KK,EndOfLine:W.EndOfLine,EnvironmentVariableMutatorType:W.EnvironmentVariableMutatorType,EvaluatableExpression:W.$AL,InlineValueText:W.$BL,InlineValueVariableLookup:W.$CL,InlineValueEvaluatableExpression:W.$DL,InlineCompletionTriggerKind:W.InlineCompletionTriggerKind,EventEmitter:I.$Od,ExtensionKind:W.ExtensionKind,ExtensionMode:W.ExtensionMode,ExternalUriOpenerPriority:W.ExternalUriOpenerPriority,FileChangeType:W.FileChangeType,FileDecoration:W.$NL,FileDecoration2:W.$NL,FileSystemError:W.$FL,FileType:S.FileType,FilePermission:S.FilePermission,FoldingRange:W.$GL,FoldingRangeKind:W.FoldingRangeKind,FunctionBreakpoint:W.$sL,InlineCompletionItem:W.$1K,InlineCompletionList:W.$2K,Hover:W.$HK,IndentAction:d.IndentAction,Location:W.$EK,MarkdownString:W.$SK,OverviewRulerLane:E.OverviewRulerLane,ParameterInformation:W.$TK,PortAutoForwardAction:W.PortAutoForwardAction,Position:W.$tK,ProcessExecution:W.$aL,ProgressLocation:W.ProgressLocation,QuickInputButtons:W.$ML,Range:W.$uK,RelativePattern:W.$oL,Selection:W.$vK,SelectionRange:W.$NK,SemanticTokens:W.$JL,SemanticTokensBuilder:W.$IL,SemanticTokensEdit:W.$KL,SemanticTokensEdits:W.$LL,SemanticTokensLegend:W.$HL,ShellExecution:W.$bL,ShellQuoting:W.ShellQuoting,SignatureHelp:W.$VK,SignatureHelpTriggerKind:W.SignatureHelpTriggerKind,SignatureInformation:W.$UK,SnippetString:W.$DK,SourceBreakpoint:W.$rL,StandardTokenType:W.StandardTokenType,StatusBarAlignment:W.StatusBarAlignment,SymbolInformation:W.$JK,SymbolKind:W.SymbolKind,SymbolTag:W.SymbolTag,Task:W.$dL,TaskGroup:W.$_K,TaskPanelKind:W.TaskPanelKind,TaskRevealKind:W.TaskRevealKind,TaskScope:W.TaskScope,TerminalLink:W.$8K,TerminalQuickFixExecuteTerminalCommand:W.$0K,TerminalQuickFixOpener:W.$9K,TerminalLocation:W.TerminalLocation,TerminalProfile:W.$$K,TerminalExitReason:W.TerminalExitReason,TextDocumentSaveReason:W.TextDocumentSaveReason,TextEdit:W.$zK,SnippetTextEdit:W.$BK,TextEditorCursorStyle:c.TextEditorCursorStyle,TextEditorLineNumbersStyle:W.TextEditorLineNumbersStyle,TextEditorRevealType:W.TextEditorRevealType,TextEditorSelectionChangeKind:W.TextEditorSelectionChangeKind,SyntaxTokenType:W.SyntaxTokenType,TextDocumentChangeReason:W.TextDocumentChangeReason,ThemeColor:W.$nL,ThemeIcon:W.$mL,TreeItem:W.$eL,TreeItemCheckboxState:W.TreeItemCheckboxState,TreeItemCollapsibleState:W.TreeItemCollapsibleState,TypeHierarchyItem:W.$9L,UIKind:b.UIKind,Uri:A.URI,ViewColumn:W.ViewColumn,WorkspaceEdit:W.$CK,DocumentDropEdit:W.$kL,DocumentPasteEdit:W.$lL,InlayHint:W.$XK,InlayHintLabelPart:W.$WK,InlayHintKind:W.InlayHintKind,RemoteAuthorityResolverError:W.$yK,ResolvedAuthority:W.$wK,ManagedResolvedAuthority:W.$xK,SourceControlInputBoxValidationType:W.SourceControlInputBoxValidationType,ExtensionRuntime:W.ExtensionRuntime,TimelineItem:W.$XL,NotebookRange:W.$PL,NotebookCellKind:W.NotebookCellKind,NotebookCellExecutionState:W.NotebookCellExecutionState,NotebookCellData:W.$QL,NotebookData:W.$RL,NotebookRendererScript:W.$VL,NotebookCellStatusBarAlignment:W.NotebookCellStatusBarAlignment,NotebookEditorRevealType:W.NotebookEditorRevealType,NotebookCellOutput:W.$TL,NotebookCellOutputItem:W.$SL,NotebookCellStatusBarItem:W.$UL,NotebookControllerAffinity:W.NotebookControllerAffinity,NotebookControllerAffinity2:W.NotebookControllerAffinity2,NotebookEdit:W.$AK,NotebookKernelSourceAction:W.$WL,PortAttributes:W.$ZL,LinkedEditingRanges:W.$YL,TestResultState:W.TestResultState,TestRunRequest:W.$1L,TestMessage:W.$2L,TestMessage2:W.$2L,TestTag:W.$3L,TestRunProfileKind:W.TestRunProfileKind,TextSearchCompleteMessageType:rt.TextSearchCompleteMessageType,DataTransfer:W.$jL,DataTransferItem:W.$fL,CoveredCount:W.$4L,FileCoverage:W.$5L,StatementCoverage:W.$6L,BranchCoverage:W.$7L,FunctionCoverage:W.$8L,WorkspaceTrustState:W.WorkspaceTrustState,LanguageStatusSeverity:W.LanguageStatusSeverity,QuickPickItemKind:W.QuickPickItemKind,InputBoxValidationSeverity:W.InputBoxValidationSeverity,TabInputText:W.$0L,TabInputTextDiff:W.$$L,TabInputTextMerge:W.$_L,TabInputCustom:W.$aM,TabInputNotebook:W.$cM,TabInputNotebookDiff:W.$dM,TabInputWebview:W.$bM,TabInputTerminal:W.$eM,TabInputInteractiveWindow:W.$fM,TelemetryTrustedValue:we.$oo,LogLevel:de.LogLevel,EditSessionIdentityMatch:vt.EditSessionIdentityMatch,InteractiveSessionVoteDirection:W.InteractiveSessionVoteDirection,InteractiveSessionCopyKind:W.InteractiveSessionCopyKind,InteractiveEditorResponseFeedbackKind:W.InteractiveEditorResponseFeedbackKind,StackFrameFocus:W.$yL,ThreadFocus:W.$zL,RelatedInformationType:W.RelatedInformationType,SpeechToTextStatus:W.SpeechToTextStatus}}}e.$Kec=Ct}),define(Ae[277],Re([1,0,70,109,33,107,34,31,60,63,111,113,114,84,86,80,108,62,40,83,59,61,244,14,112,81,82]),function(ee,e,f,C,I,O,A,c,E,d,R,S,u,b,p,g,t,i,l,v,D,m,n,r,s,o,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,f.$Br)(o.$jdc,o.$idc,1),(0,f.$Br)(r.$_i,n.$Lec,1),(0,f.$Br)(g.$Icc,g.$Jcc,1),(0,f.$Br)(c.$NM,c.$MM,0),(0,f.$Br)(A.$Vcc,A.$Tcc,0),(0,f.$Br)(i.$$cc,i.$0cc,0),(0,f.$Br)(S.$Ydc,S.$3dc,0),(0,f.$Br)(O.$Qdc,O.$Pdc,0),(0,f.$Br)(E.$CM,E.$BM,0),(0,f.$Br)($.$kdc,$.$ldc,0),(0,f.$Br)(l.$Fcc,l.$Ecc,0),(0,f.$Br)(C.$wdc,C.$vdc,1),(0,f.$Br)(u.$9dc,u.$0dc,0),(0,f.$Br)(b.$7cc,b.$6cc,0),(0,f.$Br)(R.$Tdc,R.$Sdc,0),(0,f.$Br)(d.$bdc,d.$edc,0),(0,f.$Br)(p.$uwb,p.$vwb,0),(0,f.$Br)(t.$Mdc,t.$Ldc,0),(0,f.$Br)(I.$Scc,I.$Rcc,0),(0,f.$Br)(v.$gdc,v.$fdc,0),(0,f.$Br)(D.$LM,D.$IM,0),(0,f.$Br)(m.$Udc,m.$Vdc,0),(0,f.$Br)(s.$Wdc,s.$Xdc,0)}),define(Ae[278],Re([1,0,276,35,2,273,7,12,264]),function(ee,e,f,C,I,O,A,c,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ugc=void 0;class d extends O.$Oec{k(){}getModule(b,p){for(const g of this.b){const t=g(b);if(t){b=t;break}}if(this.a.has(b))return this.a.get(b).load(b,p,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class R extends C.$ndc{constructor(){super(...arguments),this.extensionRuntime=A.ExtensionRuntime.Webworker}async tb(){this.h.createInstance(E.$Tgc);const b=this.h.invokeFunction(f.$Kec);this.r=this.h.createInstance(d,b,{mine:this.J,all:this.L}),await this.r.install(),performance.mark("code/extHost/didInitAPI"),await this.zb()}ub(b){return b.browser}async vb(b,p,g){p=p.with({path:S(p.path,".js")});const t=b?.identifier.value;t&&performance.mark(`code/extHost/willFetchExtensionCode/${t}`);const i=I.URI.revive(await this.C.$asBrowserUri(p)),l=await fetch(i.toString(!0));if(t&&performance.mark(`code/extHost/didFetchExtensionCode/${t}`),l.status!==200)throw new Error(l.statusText);const v=await l.text(),D=`${p.toString(!0)}#vscode-extension`,m=`${v}
//# sourceURL=${D}`;let n;try{n=new Function("module","exports","require",m)}catch($){throw console.error(t?`Loading code for extension ${t} failed: ${$.message}`:`Loading code failed: ${$.message}`),console.error(`${p.toString(!0)}${typeof $.line=="number"?` line ${$.line}`:""}${typeof $.column=="number"?` column ${$.column}`:""}`),console.error($),$}b&&await this.w.initializeLocalizedMessages(b);const r={},s={exports:r},o=$=>{const a=this.r.getModule($,p);if(a===void 0)throw new Error(`Cannot load module '${$}'`);return a};try{return g.codeLoadingStart(),t&&performance.mark(`code/extHost/willLoadExtensionCode/${t}`),n(s,r,o),s.exports!==r?s.exports:r}finally{t&&performance.mark(`code/extHost/didLoadExtensionCode/${t}`),g.codeLoadingStop()}}async $setRemoteEnvironment(b){}async zb(b=5e3){if(!this.f.environment.isExtensionDevelopmentDebug)return;const p=Date.now()+b;for(;Date.now()<p&&!("__jsDebugIsReady"in globalThis);)await(0,c.$Vg)(10)}}e.$Ugc=R;function S(u,b){return u.endsWith(b)?u:u+b}}),define(Ae[279],Re([1,0,69,70,14,35,188,85,278]),function(ee,e,f,C,I,O,A,c,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,C.$Br)(I.$$i,new f.$Nh(A.$Nec,[!0],!0)),(0,C.$Br)(O.$odc,E.$Ugc,0),(0,C.$Br)(c.$_cc,c.$adc,0)}),define(Ae[288],Re([1,0,26,5,78,274,266,20,87,13,2,277,279]),function(ee,e,f,C,I,O,A,c,E,d,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const S=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const u=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function b(n){return/^(file|vscode-remote):/i.test(n)}const p=fetch.bind(self);function g(n){self.fetch=async function(r,s){return r instanceof Request||b(String(r))&&(r=(await n(R.URI.parse(String(r)))).toString(!0)),p(r,s)},self.XMLHttpRequest=class extends XMLHttpRequest{open(r,s,o,$,a){(async()=>(b(s.toString())&&(s=(await n(R.URI.parse(s.toString()))).toString(!0)),super.open(r,s,o??!0,$,a)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const n=self.Worker;Worker=function(r,s){if(/^file:/i.test(r.toString()))r=d.$dg.uriToBrowserUri(R.URI.parse(r.toString())).toString(!0);else if(/^vscode-remote:/i.test(r.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const $=`(${function(h){function w(V){return typeof V=="string"||V instanceof URL?String(V).replace(/^file:\/\//i,"vscode-file://vscode-app"):V}const y=fetch.bind(self);self.fetch=function(V,B){return V instanceof Request?y(V,B):y(w(V),B)},self.XMLHttpRequest=class extends XMLHttpRequest{open(V,B,z,T,F){return super.open(V,w(B),z??!0,T,F)}};const M=importScripts.bind(self);self.importScripts=(...V)=>{M(...V.map(w))},M(h)}.toString()}('${r}'))`;s=s||{},s.name=s.name||c.$nc(r.toString());const a=new Blob([$],{type:"application/javascript"}),k=URL.createObjectURL(a);return new n(k,s)}}else self.Worker=class extends A.$Vgc{constructor(n,r){super(u,n,{name:c.$nc(n.toString()),...r})}};const t=new class{constructor(){this.pid=void 0}exit(n){S()}};class i{constructor(){const r=new MessageChannel,s=new C.$Od;let o=!1;u(r.port2,[r.port2]),r.port1.onmessage=$=>{const{data:a}=$;if(!(a instanceof ArrayBuffer)){console.warn("UNKNOWN data received",a);return}const k=f.$ce.wrap(new Uint8Array(a,0,a.byteLength));if((0,I.$em)(k,2)){o=!0,v("received terminate message from renderer");return}s.fire(k)},this.protocol={onMessage:s.event,send:$=>{if(!o){const a=$.buffer.buffer.slice($.buffer.byteOffset,$.buffer.byteOffset+$.buffer.byteLength);r.port1.postMessage(a,[a])}}}}}function l(n){return new Promise(r=>{const s=n.onMessage(o=>{s.dispose();const $=JSON.parse(o.toString());n.send((0,I.$dm)(0)),r({protocol:n,initData:$})});n.send((0,I.$dm)(1))})}let v=n=>S();function D(n){return!!n&&typeof n=="object"&&n.type==="vscode.init"&&n.data instanceof Map}function m(){E.mark("code/extHost/willConnectToRenderer");const n=new i;return{onmessage(r){D(r)&&l(n.protocol).then(s=>{E.mark("code/extHost/didWaitForInitData");const o=new O.$Qec(s.protocol,s.initData,t,null,r.data);g($=>o.asBrowserUri($)),v=$=>o.terminate($)})}}}e.create=m})}).call(this);

//# sourceMappingURL=extensionHostWorker.js.map
